
(function (factory) {
  if (typeof module === 'object' && typeof module.exports !== "undefined") {
      module.exports = factory;
  } else {
      factory();
  }
}(function () {
"use strict";
(self["webpackChunkFusionCharts"] = self["webpackChunkFusionCharts"] || []).push([[10],{

/***/ 1465:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = _default;

var _lib = __webpack_require__(274);

var _discrete = _interopRequireDefault(__webpack_require__(630));

function _default(chart) {
  var legend,
      count = chart.config.showLegend ? 1 : 0;
  (0, _lib.componentFactory)(chart, _discrete.default, 'legend', count, [{}]);
  legend = chart.getChildren('legend');

  if (legend && legend[0] && !legend[0].getState('removed')) {
    chart.addToEnv('legend', legend[0]);
  } else {
    chart.deleteFromEnv('legend');
  }
}

/***/ }),

/***/ 1461:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _axisRefComponent = _interopRequireDefault(__webpack_require__(588));

var _polarUtil = __webpack_require__(1454);

var _lib = __webpack_require__(274);

var _dependencyManager = __webpack_require__(282);

var _axisRefPolar = _interopRequireDefault(__webpack_require__(1462));

var M = 'M',
    Z = 'Z',
    L = 'L',
    getRadius = function getRadius(axis, point) {
  var scale = axis.getScale(),
      range = axis.config.axisRange;
  return Math.abs(scale.getRangeValue(point) - scale.getRangeValue(range.min));
};

(0, _dependencyManager.addDep)({
  name: 'axisRefPolarAnimation',
  type: 'animationRule',
  extension: _axisRefPolar.default
});

var AxisRefPolarVisual = /*#__PURE__*/function (_AxisRefComponent) {
  (0, _inheritsLoose2.default)(AxisRefPolarVisual, _AxisRefComponent);

  function AxisRefPolarVisual() {
    return _AxisRefComponent.apply(this, arguments) || this;
  }

  var _proto = AxisRefPolarVisual.prototype;

  /**
   * Sets the type of the component
   * @return {string} type
   */
  _proto.getType = function getType() {
    return 'axisRefVisuals';
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */
  ;

  _proto.getName = function getName() {
    return 'axisRefVisualsPolar';
  }
  /**
   * Decides the type of line to draw
   *
   * @param {any} lineInfo
   * @param {any} axis
   * @memberof AxisRefPolarVisual
   */
  ;

  _proto.createLine = function createLine(lineInfo, axis) {
    var axisRef = this;

    if (axis.getName() === 'polarCategory') {
      return axisRef.createNormalLine(lineInfo, axis);
    } else if (axis.getName() === 'numeric') {
      return axisRef.createRadialLine(lineInfo, axis);
    }
  }
  /**
   * Creates radial line
   *
   * @param {any} lineInfo
   * @param {any} axis
   * @returns {any}
   * @memberof AxisRefPolarVisual
   */
  ;

  _proto.createRadialLine = function createRadialLine(lineInfo, axis) {
    var axisRef = this,
        xAxis = axisRef.getFromEnv('xAxis')[0],
        xAxisConfig = xAxis.config,
        category = xAxisConfig.tickValues.tickValue,
        yAxis = axis,
        axisRefConfig = axisRef.config,
        containersArr = axisRefConfig.containers,
        container = containersArr[lineInfo.layer],
        animationManager = axisRef.getFromEnv('animationManager'),
        toolTipController = axisRef.getFromEnv('toolTipController'),
        i,
        key,
        min,
        max,
        radius,
        lineAttr = lineInfo.attr,
        pathAr = [M],
        coordinate,
        compId = yAxis.getId(),
        eleId = lineInfo.id || lineInfo.from,
        lineEleId = compId + '_' + eleId,
        handlers = lineInfo.handlers,
        element = axisRef.getGraphicalElement(lineEleId);
    radius = getRadius(yAxis, lineInfo.from);
    min = 0;
    max = category ? category.length - 1 : 0;

    for (i = min; i <= max; i++) {
      coordinate = (0, _polarUtil.getCoordinates)({
        radius: radius,
        theta: i
      }, xAxis);
      pathAr.push(coordinate.x, coordinate.y, L);
    }

    pathAr.pop();
    pathAr.push(Z);
    lineAttr.path = pathAr;
    element = axisRef.addGraphicalElement(lineEleId, animationManager.setAnimation({
      container: container,
      el: element || 'path',
      attr: lineAttr,
      component: axisRef,
      label: 'path'
    }));

    if (lineInfo.toolText) {
      toolTipController.enableToolTip(element, lineInfo.toolText);
    } else {
      toolTipController.disableToolTip(element);
    }

    for (key in handlers) {
      if (handlers.hasOwnProperty(key)) {
        element.on(key, handlers[key].bind(axis));
      }
    }

    return [lineEleId];
  }
  /**
   * Draws normal line
   *
   * @param {any} lineInfo
   * @param {any} axis
   * @memberof AxisRefPolarVisual
   */
  ;

  _proto.createNormalLine = function createNormalLine(lineInfo, axis) {
    var axisRef = this,
        axisRefConfig = axisRef.config,
        axisConfig = axis.config,
        radius = (0, _lib.pluckNumber)(axisConfig.radius, 0),
        pathAr = [M],
        containersArr = axisRefConfig.containers,
        container = containersArr[lineInfo.layer],
        animationManager = axisRef.getFromEnv('animationManager'),
        toolTipController = axisRef.getFromEnv('toolTipController'),
        coordinate,
        key,
        centerX = axisConfig.axisDimention.centerX,
        centerY = axisConfig.axisDimention.centerY,
        compId = axis.getId(),
        eleId = lineInfo.id || lineInfo.from,
        lineEleId = compId + '_' + eleId,
        handlers = lineInfo.handlers,
        element = axisRef.getGraphicalElement(lineEleId);
    pathAr.push(centerX, centerY, L);
    coordinate = (0, _polarUtil.getCoordinates)({
      radius: radius,
      theta: lineInfo.from
    }, axis);
    pathAr.push(coordinate.x, coordinate.y);
    lineInfo.attr.path = pathAr;
    element = axisRef.addGraphicalElement(lineEleId, animationManager.setAnimation({
      container: container,
      el: element || 'path',
      attr: lineInfo.attr,
      component: axisRef,
      label: 'path'
    }));

    if (lineInfo.toolText) {
      toolTipController.enableToolTip(element, lineInfo.toolText);
    } else {
      toolTipController.disableToolTip(element);
    }

    for (key in handlers) {
      if (handlers.hasOwnProperty(key)) {
        element.on(key, handlers[key].bind(axis));
      }
    }

    return [lineEleId];
  } // eslint-disable-next-line
  ;

  _proto.createBand = function createBand() {
    // super.createBand(x, y);
    return [];
  };

  return AxisRefPolarVisual;
}(_axisRefComponent.default);

var _default = AxisRefPolarVisual;
exports["default"] = _default;

/***/ }),

/***/ 1462:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _polarAxis = _interopRequireDefault(__webpack_require__(1458));

var _default = {
  'initial.axis.axisRefVisualsPolar': function initialAxisAxisRefVisualsPolar() {
    return {
      'path.appearing': _polarAxis.default,
      'text.appearing': _polarAxis.default
    };
  }
};
exports["default"] = _default;

/***/ }),

/***/ 1350:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _componentInterface = __webpack_require__(290);

var _domEvent = _interopRequireDefault(__webpack_require__(276));

var _lib = __webpack_require__(274);

var ENTER_CODE = 13,
    ESCAPE_CODE = 27;
var linkedAxis;

function getCharCode(e) {
  return typeof e.which === 'number' ? e.which : e.keyCode;
}

function onMouseUp(e) {
  var ele = e.target;

  if (ele.justFocussed) {
    ele.justFocussed = false;

    if (!_lib.hasTouch) {
      ele.select();
    }
  }
}

function doAxisUpdate(value, oldvalue, isMax) {
  var success = false,
      axisParent = this.config.linkedAxis.getLinkedParent(); // do not update if value has not changed

  if (value === oldvalue + '') {
    return;
  }

  if (isMax) {
    success = axisParent.changeUpperLimits && axisParent.changeUpperLimits(Number(value));
  } else {
    success = axisParent.changeLowerLimits && axisParent.changeLowerLimits(Number(value));
  } // if (!success && showRangeError) {
  //   chart.showMessage('Sorry! Not enough range gap to modify axis limit to ' +
  //     (Number(value) || '0') +
  //     '.<br />Please modify the data values to be within range.<br />&nbsp;<br />' +
  //     '(click anywhere on the chart to close this message)', true);
  // }


  return success;
}

function onFocus(e) {
  var ele = e.target,
      styleObj = {
    opacity: 1,
    filter: 'alpha(opacity=100)',
    // IE opacity
    color: (0, _lib.rgbaToHex)(ele.axisLabel.attr('fill'))
  },
      item;

  for (item in styleObj) {
    ele.style[item] = styleObj[item];
  }

  ele.value = ele.dataValue;
  ele.justFocussed = true; // for IE

  ele.hasFocus = true;
  ele.axisLabel && ele.axisLabel.hide(); // if (!chart.graphics.hiddenAxisLabels) {
  //   chart.graphics.hiddenAxisLabels = [];
  // }
  // chart.graphics.hiddenAxisLabels.push(ele.axisLabel);
}

function onBlur(e) {
  var ele = e.target,
      newValue = ele.value,
      oldValue = ele.oldValue,
      isMaxLabel = ele.isMaxLabel; // success = doAxisUpdate(newValue, oldValue, isMaxLabel);

  doAxisUpdate.call(this, newValue, oldValue, isMaxLabel); // if (success !== true) {

  ele.style.opacity = 0;
  ele.style.filter = 'alpha(opacity=0)'; // IE opacity

  ele.axisLabel && ele.axisLabel.show(); // }

  if (_lib.isIE) {
    // To call the actual blur on the element in case of IE
    document.getElementsByTagName('body')[0].focus && document.getElementsByTagName('body')[0].focus();
  }

  ele.justFocussed = false;
  ele.hasFocus = false;
}

function onKeyUp(e) {
  var ele = e.target,
      keyCode = getCharCode(e.originalEvent),
      newValue = ele.value,
      oldValue = ele.oldValue,
      isMaxLabel = ele.isMaxLabel,
      success;

  if (keyCode === ENTER_CODE) {
    success = doAxisUpdate.call(this, newValue, oldValue, isMaxLabel);

    if (success === false) {
      ele.style.color = '#dd0000';
    } else {
      _domEvent.default.fire(ele, 'blur', e);
    }
  } else if (keyCode === ESCAPE_CODE) {
    ele.value = oldValue;

    _domEvent.default.fire(ele, 'blur', e);
  }
}

function defaultHandler(inputElement) {
  return function (e) {
    if (inputElement.parentNode) {
      _domEvent.default.fire(inputElement, 'blur', e);
    }
  };
}

function defaultIEHandler(inputElement) {
  return function (e) {
    if (e.target !== inputElement && inputElement.hasFocus) {
      _domEvent.default.fire(inputElement, 'blur', e);
    }
  };
}

function destroyHandler(inputElement, defaultAction) {
  _domEvent.default.unlisten(this.config.linkedAxis.getLinkedParent(), 'defaultprevented', defaultAction);

  inputElement.parentNode.removeChild(inputElement);
}

function destroyIEHandler(inputElement, defaultAction) {
  return function () {
    _domEvent.default.unlisten(linkedAxis.getLinkedParent().getLinkedItem('container'), 'mousedown', defaultAction);

    inputElement.parentNode.removeChild(inputElement);
  };
}

var LimitUpdater = /*#__PURE__*/function (_ComponentInterface) {
  (0, _inheritsLoose2.default)(LimitUpdater, _ComponentInterface);

  function LimitUpdater() {
    return _ComponentInterface.apply(this, arguments) || this;
  }

  var _proto = LimitUpdater.prototype;

  _proto.configureAttributes = function configureAttributes() {
    this.config.linkedAxis = this.getLinkedParent();
    linkedAxis = this.config.linkedAxis;
    this.config.onKeyUp = onKeyUp.bind(this);
    this.config.onBlur = onBlur.bind(this);
    this.config.onFocus = onFocus.bind(this);
    this.config.onMouseUp = onMouseUp.bind(this);
  }
  /**
   * Sets the type of the component
   * @return {string} type
   */
  ;

  _proto.getType = function getType() {
    return 'helper';
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */
  ;

  _proto.getName = function getName() {
    return 'limitUpdater';
  };

  _proto.draw = function draw() {
    // draw this component;
    var limitUpdater = this,
        chartConf = limitUpdater.getFromEnv('chartConfig'),
        axis = limitUpdater.config.linkedAxis,
        extremeLabels = axis.getAxisConfig('extremeLabels'),
        axisLimits = axis.getLimit(),
        chartContainer = limitUpdater.getFromEnv('chart-container'),
        chartCanvasStyle = limitUpdater.getFromEnv('style').inCanvasStyle,
        inputStyle = (0, _lib.extend2)({
      outline: 'none',
      // prevent chrome outlining
      '-webkit-appearance': 'none',
      // disable ios background
      filter: 'alpha(opacity=0)',
      // IE opacity
      position: 'absolute',
      background: 'transparent',
      border: '1px solid #cccccc',
      textAlign: 'right',
      top: 0,
      left: 0,
      width: 50,
      zIndex: 20,
      opacity: 0,
      borderRadius: 0,
      display: 'block'
    }, chartCanvasStyle),
        labelObj = {
      max: {
        element: extremeLabels.lastLabel.graphic,
        value: axisLimits.max
      },
      min: {
        element: extremeLabels.firstLabel.graphic,
        value: axisLimits.min
      }
    },
        inputElement,
        inputElementName,
        labelElement,
        key,
        styleKey,
        labelBox,
        isMaxLabel,
        labelValue,
        closedDefaultHandler,
        inputWidth,
        inputLeft,
        closedDefaultIEHandler;
    inputStyle.color = (0, _lib.hashify)(inputStyle.color);
    inputStyle.fontSize = inputStyle.fontSize + "px";

    for (key in labelObj) {
      if (labelObj.hasOwnProperty(key)) {
        labelElement = labelObj[key].element;
        labelBox = labelElement && labelElement.getBBox();
        labelValue = labelObj[key].value;
        isMaxLabel = key === 'max';
        inputElementName = key + "Input";
        inputElement = limitUpdater.getGraphicalElement(inputElementName);

        if (!(labelBox && labelElement)) {
          if (inputElement) {
            inputElement.style.display = 'none';
          }

          continue;
        }

        if (!inputElement) {
          inputElement = limitUpdater.addGraphicalElement(inputElementName, (0, _lib.createElement)('input', {
            type: 'text',
            value: labelValue,
            id: "fc-updater-" + key
          }, chartContainer));
        } // Add events to make the textboxes visible on focus and hide when not.


        _domEvent.default.listen(inputElement, ['focus', 'mouseup', 'blur', 'keyup'], [this.config.onFocus, this.config.onMouseUp, this.config.onBlur, this.config.onKeyUp]);

        if (_lib.hasSVG) {
          _domEvent.default.listen(chartContainer, 'defaultprevented', closedDefaultHandler = defaultHandler(inputElement)); // cleanup handlers


          _domEvent.default.listen(chartContainer, 'destroy', destroyHandler.bind(this, inputElement, closedDefaultHandler));
        } else {
          _domEvent.default.listen(chartContainer, 'mousedown', closedDefaultIEHandler = defaultIEHandler(inputElement)); // cleanup handlers


          _domEvent.default.listen(chartContainer, 'destroy', destroyIEHandler(inputElement, closedDefaultIEHandler));
        }

        inputWidth = labelBox.x + labelBox.width - chartConf.marginLeft;
        inputLeft = chartConf.marginLeft;
        inputStyle.top = labelBox.y + "px";
        inputStyle.left = inputLeft + "px";
        inputStyle.width = inputWidth + "px";

        for (styleKey in inputStyle) {
          if (inputStyle.hasOwnProperty(styleKey)) {
            inputElement.style[styleKey] = inputStyle[styleKey];
          }
        }

        inputElement.dataValue = labelValue;
        inputElement.value = labelValue;
        inputElement.oldValue = labelValue;
        inputElement.name = labelValue || '';
        inputElement.axisLabel = labelElement;
        inputElement.isMaxLabel = isMaxLabel;
      }
    }
  }
  /**
   * Generalised function for removing an entire instance of a component
   */
  ;

  _proto.removingDraw = function removingDraw() {
    var graphics = this.getGraphicalElement(),
        key,
        element;

    for (key in graphics) {
      if (graphics.hasOwnProperty(key)) {
        element = graphics[key];
        element && element.parentNode && element.parentNode.removeChild(element);
        delete graphics[key];
      }
    }
  };

  return LimitUpdater;
}(_componentInterface.ComponentInterface);

var _default = LimitUpdater;
exports["default"] = _default;

/***/ }),

/***/ 1316:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _log = _interopRequireDefault(__webpack_require__(866));

var _diff = _interopRequireDefault(__webpack_require__(569));

var _extent2 = _interopRequireDefault(__webpack_require__(538));

var _cartesian = _interopRequireDefault(__webpack_require__(566));

var _lib = __webpack_require__(274);

var _commonApi = __webpack_require__(572);

var validate = function validate(param) {
  if (param === null || param === _lib.UNDEF || param === '' || isNaN(param)) {
    // Variable is not specified - so return false.
    return false;
  } // Variable is specified - so return true.


  return true;
},
    queryOptions = {
  wrtVisible: true
},
    POSITION_START = _lib.preDefStr.POSITION_START,
    POSITION_TOP = _lib.preDefStr.POSITION_TOP,
    POSITION_BOTTOM = _lib.preDefStr.POSITION_BOTTOM,
    POSITION_END = _lib.preDefStr.POSITION_END,
    LABEL_ID = '_label',
    BLANKSTRING = '',
    EVENTARGS = 'eventArgs',
    NOSTRING = 'none',
    POINTER = 'pointer',
    logTicksMerge = function logTicksMerge(majorTickArr, minorTickArr) {
  if (majorTickArr === void 0) {
    majorTickArr = [];
  }

  if (minorTickArr === void 0) {
    minorTickArr = [];
  }

  if (majorTickArr.length === 0) return [];
  var majorArrlen = majorTickArr.length,
      minorArrLen = minorTickArr.length,
      k = majorArrlen - 1,
      l = minorArrLen - 1,
      mergedArr = [majorTickArr[k]];
  k--;

  while (k >= 0) {
    if (minorTickArr[l] > majorTickArr[k]) {
      mergedArr.push(minorTickArr[l]);
      l--;
    } else {
      mergedArr.push(majorTickArr[k]);
      k--;
    }
  }

  return mergedArr;
};

var LogAxis = /*#__PURE__*/function (_CartesianAxis) {
  (0, _inheritsLoose2.default)(LogAxis, _CartesianAxis);

  function LogAxis() {
    var _this;

    _this = _CartesianAxis.call(this) || this;
    _this.config.scale = new _log.default();
    _this.config.labelMap = [];
    return _this;
  }
  /**
   * Sets the default configuration of the axis
   */


  var _proto = LogAxis.prototype;

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    _CartesianAxis.prototype.__setDefaultConfig.call(this);

    var config = this.config;
    config.base = 10;
    config.showMinorDivLineValues = 1;
    config.numMinorDivLines = _lib.UNDEF;
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */
  ;

  _proto.getName = function getName() {
    return 'log';
  }
  /**
   * Prepare the axis attributes for use by the chart drawing. It applies some log specific
   * values to the axis' configuration.
   * @param  {Object}  rawAttr The raw attributes to be set
   */
  ;

  _proto.configureAttributes = function configureAttributes(rawAttr) {
    var axis = this,
        axisConfig = axis.config,
        numberFormatter = axis.getFromEnv('number-formatter'),
        colorM = axis.getFromEnv('color-manager'),
        axisAttr;

    _CartesianAxis.prototype.configureAttributes.call(this, rawAttr);

    axisAttr = axisConfig.rawAttr;
    axisConfig.minorDivlinecolor = (0, _lib.convertColor)((0, _lib.pluck)(axisAttr.minorDivlinecolor, colorM.getColor('divLineColor')), (0, _lib.pluckNumber)(axisAttr.minorDivLineAlpha, colorM.getColor('divLineAlpha') / 2));
    axisConfig.axisMinValue = numberFormatter.getCleanValue(axisAttr.axisMinValue);
    axisConfig.axisMaxValue = numberFormatter.getCleanValue(axisAttr.axisMaxValue);
    axisConfig.minorTicks = [];

    if (axisConfig.axisMinValue <= 0) {
      axisConfig.axisMinValue = _lib.UNDEF;
    }

    if (axisConfig.axisMaxValue <= 0) {
      axisConfig.axisMaxValue = _lib.UNDEF;
    }

    axis.getScale().setBase(axisConfig.base);
    axisConfig.minorDivLineThickness = (0, _lib.pluckNumber)(axisAttr.minorDivLineThickness, 1);
    axisConfig.band.isDraw = 0;
  };

  _proto.generateTicks = function generateTicks() {
    var ticks = this.getScale().ticks();
    this.config._allTicks = ticks.slice();
    return ticks;
  }
  /**
   * Generates minor ticks between every majot tick visible in the current visible range
   */
  ;

  _proto.generateMinorTicks = function generateMinorTicks() {
    return this.getScale().minorTicks(this.config.numMinorDivLines);
  };

  _proto._setAxisRange = function _setAxisRange(_ref) {
    var _ref$min = _ref.min,
        min = _ref$min === void 0 ? 0.1 : _ref$min,
        _ref$max = _ref.max,
        max = _ref$max === void 0 ? 1 : _ref$max;
    var scale = this.getScale().setDomain([min, max]).nice(),
        axisConfig = this.config,
        axisRange = axisConfig.axisRange;
    axisConfig.ticks = this.generateTicks();
    axisConfig.minorTicks = this.generateMinorTicks(); // eslint-disable-next-line

    var _scale$getDomain = scale.getDomain();

    min = _scale$getDomain[0];
    max = _scale$getDomain[1];
    axisRange.max = max;
    axisRange.min = min;
    this.setVisibleConfig(min, max);
  };

  _proto.setDataLimit = function setDataLimit(_max, _min) {
    var axis = this,
        max = _max,
        min = _min,
        axisConfig = axis.config,
        AxisMaxValue = axisConfig.axisMaxValue,
        AxisMinValue = axisConfig.axisMinValue,
        trendMin,
        trendMax;

    if (validate(AxisMinValue) && Number(AxisMinValue) <= min) {
      min = AxisMinValue;
    }

    if (validate(AxisMaxValue) && Number(AxisMaxValue) >= max) {
      max = AxisMaxValue;
    }

    if (min === 0) {
      min = 1;
    }

    if (max === 0) {
      max = axisConfig.base;
    }

    var _axis$getTrendLineLim = axis.getTrendLineLimits();

    trendMin = _axis$getTrendLineLim[0];
    trendMax = _axis$getTrendLineLim[1];

    var _extent = (0, _extent2.default)([trendMin, trendMax, min, max], function (a) {
      return Number(a);
    });

    min = _extent[0];
    max = _extent[1];

    this._setAxisRange({
      min: min,
      max: max
    });
  };

  _proto._parseLabel = function _parseLabel() {
    var axis = this,
        axisConfig = axis.config,
        chart = axis.getFromEnv('chart'),
        chartConfig = chart.config,
        axisRange = axisConfig.axisRange,
        isOpposit = axisConfig.isOpposit,
        increment,
        labels = axisConfig.labels,
        style = labels.style,
        i,
        isVertical = axisConfig.isVertical,
        max = axisRange.max,
        min = axisRange.min,
        canvasBottom = chartConfig.canvasBottom,
        canvasLeft = chartConfig.canvasLeft,
        canvasRight = chartConfig.canvasRight,
        canvasTop = chartConfig.canvasTop,
        axisPadding = axisConfig.labelPadding,
        numberFormatter = axis.getFromEnv('number-formatter'),
        axisValueMaxH = axisConfig.labelMaxH,
        axisValueMaxW = axisConfig.labelMaxW,
        axisStartPosition = axisConfig.axisStartPosition,
        text,
        getLimit,
        labelRotation,
        labelLineHeight,
        numberFormatterFn,
        addCategoryPadding,
        axisAttrObj,
        allTicks,
        ticksLen,
        tickVal,
        tickInPx,
        prevPos,
        labelMaxProp,
        labelArr,
        axisComp = axis.components,
        minorTicks = axisConfig.minorTicks,
        checkForLimit;

    if (style.lineHeight) {
      labelLineHeight = style.lineHeight;

      if (labelLineHeight.indexOf('px') !== -1) {
        labelLineHeight = labelLineHeight.replace('px', '');
        labelLineHeight = parseFloat(labelLineHeight);
      }
    } // checking if labels are to be drawn user can decide or can be decided by axis placeAxis function


    if (axisConfig.labels.isDraw) {
      checkForLimit = axis.getZoom() !== 1;
      labelArr = axisComp.labels; // initialize the increment by taking account the label step

      axisConfig.labels.step ? increment = axisRange.tickInterval * axisConfig.labels.step : increment = axisRange.tickInterval;
      labelRotation = axisConfig.labels.rotation; // intelligently calculate the loop max and loop min from the visual active dataset
      // get the visible configuration means the value between the dataset is visible

      getLimit = this.getVisibleConfig();
      axisComp.labelIndexArr = [];
      axisConfig.allTicks = allTicks = logTicksMerge(axisConfig.ticks, axisConfig.minorTicks);
      labelMaxProp = isVertical ? axisValueMaxH : axisValueMaxW;
      ticksLen = allTicks.length;

      for (i = 0; i < ticksLen; i++) {
        tickVal = allTicks[i];
        tickInPx = axis.getPixel(tickVal, queryOptions); // if minor div and minor value is set to display none

        if (minorTicks.indexOf(tickVal) >= 0 && !axisConfig.showMinorDivLineValues) {
          continue;
        } // check for overlap


        if (prevPos) {
          if (tickInPx > prevPos - labelMaxProp && tickInPx < prevPos + labelMaxProp) {
            continue;
          }
        } // if value is not between the visual limit increment it and continue


        if (checkForLimit && (tickVal < getLimit.minValue || tickVal > getLimit.maxValue)) {
          continue;
        } // if values are not limit value and label drawing is off other
        // than limit increment it and continue


        if (!axisConfig.labels.drawNormalVal && !(axisConfig.labels.drawLimitVal && (tickVal === min || tickVal === max))) {
          continue;
        }

        if (!axisConfig.labels.drawNormalVal && !(tickVal === min || tickVal === max)) {
          continue;
        } // if value are limit value but limit value are not mean to be drawn


        if (!axisConfig.labels.drawLimitVal && (tickVal === min || tickVal === max)) {
          continue;
        } // if value is zero and show zero plane is off


        if (axisConfig.showZeroPlaneValue === 0 && axisConfig.showZeroPlane === 0 && tickVal === 0) {
          continue;
        } // For overlapping of 0 and other value give priority to zero value


        if (axisConfig.showZeroPlane === 1 && axisConfig.showZeroPlaneValue === 1 && (tickVal < 0 && tickVal + increment > 0 || tickVal > 0 && tickVal - increment < 0)) {
          if (isVertical) {
            if (tickInPx + axisValueMaxH >= axis.getPixel(0, queryOptions) && axis.getPixel(0, queryOptions) >= tickInPx - axisValueMaxH) {
              continue;
            }
          } else {
            if (tickInPx + axisValueMaxW >= axis.getPixel(0, queryOptions) && axis.getPixel(0, queryOptions) >= tickInPx - axisValueMaxW) {
              continue;
            }
          }
        } // Common style attribute for both axis


        axisAttrObj = {
          fill: style.color,
          'font-size': style.fontSize,
          'cursor': style.labelLink ? POINTER : ''
        }; // make the attribute ready to use
        // y-axis

        if (isVertical) {
          if (axisConfig.numberFormatterFn) {
            numberFormatterFn = numberFormatter[axisConfig.numberFormatterFn];
          } else if (axisConfig.isPercent) {
            numberFormatterFn = numberFormatter.percentValue;
          } else {
            numberFormatterFn = numberFormatter.yAxis;
          }

          text = '' + numberFormatterFn.call(numberFormatter, tickVal); // @temp

          addCategoryPadding = axisConfig.hasCategory ? axisConfig.categories.category[i].labelPadding || 0 : 0;
          axisAttrObj['text-anchor'] = isOpposit ? POSITION_START : POSITION_END;
          axisAttrObj.text = text;
          axisAttrObj.x = isOpposit ? (axisStartPosition || canvasRight) + axisPadding : (axisStartPosition || canvasLeft) - axisPadding;
          axisAttrObj.y = addCategoryPadding ? tickInPx + addCategoryPadding : tickInPx;
          prevPos = axisAttrObj.y; // x-axis
        } else {
          if (axisConfig.numberFormatterFn) {
            numberFormatterFn = numberFormatter[axisConfig.numberFormatterFn];
          } else if (axisConfig.isPercent) {
            numberFormatterFn = numberFormatter.percentValue;
          } else {
            numberFormatterFn = numberFormatter.xAxis;
          }

          text = '' + numberFormatterFn.call(numberFormatter, tickVal); // @temp

          addCategoryPadding = axisConfig.hasCategory ? Number(axisConfig.categories.category[i].labelPadding) || 0 : 0;
          axisAttrObj.text = text;
          axisAttrObj.x = tickInPx;
          axisAttrObj.y = isOpposit ? (axisStartPosition || canvasTop) - axisPadding : (axisStartPosition || canvasBottom) + axisPadding;

          if (addCategoryPadding) {
            axisAttrObj.y += addCategoryPadding;
          }

          if (labelRotation) {
            axisAttrObj['text-anchor'] = isOpposit ? POSITION_START : POSITION_END;
            axisAttrObj['vertical-align'] = 'middle';
          } else {
            axisAttrObj['vertical-align'] = isOpposit ? POSITION_BOTTOM : POSITION_TOP;
          }

          prevPos = axisAttrObj.x;
        } // If labels shift is applicable (Specially for 3D) then apply the changes


        if (labels.shiftX) {
          axisAttrObj.x += labels.shiftX;
        }

        if (labels.shiftY) {
          axisAttrObj.y += labels.shiftY;
        }

        axisAttrObj.transform = (0, _lib.getSuggestiveRotation)(labelRotation, axisAttrObj.x, axisAttrObj.y); // check if extra label element is present don't draw it just use it by changing the attributes

        axisComp.labelIndexArr.push(i);
        labelArr[i] = labelArr[i] || {
          config: {
            props: {
              label: {}
            }
          }
        };

        if (typeof tickVal === 'undefined') {
          axisAttrObj['text-bound'] = [];
        } else {
          axisAttrObj['text-bound'] = [(0, _lib.pluck)(style.backgroundColor, BLANKSTRING), (0, _lib.pluck)(style.borderColor, BLANKSTRING), (0, _lib.pluck)(style.borderThickness, BLANKSTRING), (0, _lib.pluck)(style.borderPadding, 0), (0, _lib.pluck)(style.borderRadius, 0), (0, _lib.pluck)(style.borderDash, NOSTRING)];
        }

        labelArr[i].config.props.label.attr = axisAttrObj;
        labelArr[i].config.props.label.css = text.css;
        labelArr[i].config.value = tickVal;
      }
    }
  };

  _proto._drawLabel = function _drawLabel() {
    var axis = this,
        axisConfig = axis.config,
        animationManager = axis.getFromEnv('animationManager'),
        chart = axis.getFromEnv('chart'),
        labels = axisConfig.labels,
        style = labels.style,
        i,
        j,
        axisContainer = axisConfig.axisContainer,
        id,
        mapArr = [],
        removeElementsArr,
        removeElem,
        textElement,
        axisComp = axis.components,
        labelIndexArr = axisComp.labelIndexArr,
        css = {
      fontFamily: style.fontFamily,
      fontSize: style.fontSize,
      fontWeight: style.fontWeight,
      fontStyle: style.fontStyle,
      lineHeight: style.lineHeight
    },
        labelArrLen,
        ticksVal,
        labelArr,
        raiseEvent = function raiseEvent(event) {
      return function (data) {
        var ele = this;
        chart.plotEventHandler(ele, data, event);
      };
    },
        removeElements = function removeElements(arrOfId) {
      for (i = 0; i < arrOfId.length; ++i) {
        removeElem = axis.getGraphicalElement(arrOfId[i]);
        removeElem && axis.removeGraphicalElement(removeElem);
      }
    }; // checking if labels are to be drawn user can decide or can be decided by axis placeAxis function


    if (axisConfig.labels.isDraw) {
      labelArr = axisComp.labels;
      axisContainer.css(css);
      labelArrLen = labelIndexArr.length;

      for (j = 0; j < labelArrLen; j++) {
        i = labelIndexArr[j];
        ticksVal = labelArr[i].config.value;
        id = ticksVal + LABEL_ID;
        textElement = axis.getGraphicalElement(id);
        mapArr.push(id);
        textElement = this.addGraphicalElement(id, animationManager.setAnimation({
          container: axisContainer,
          el: textElement || 'text',
          attr: labelArr[i].config.props.label.attr,
          data: {
            value: ticksVal
          },
          component: this,
          label: 'text',
          css: labelArr[i].config.props.label.css
        }));
        textElement.on('fc-click', raiseEvent('dataLabelClick')).hover(raiseEvent('dataLabelRollOver'), raiseEvent('dataLabelRollOut'));
        textElement.data(EVENTARGS, {
          link: style.labelLink,
          text: labelArr[i].config.props.label.attr.text,
          index: i
        });
      }

      removeElementsArr = (0, _diff.default)(axisConfig.labelMap, mapArr);
    } else {
      removeElementsArr = axisConfig.labelMap;
    }

    axisConfig.labelMap = mapArr;
    removeElements(removeElementsArr);
  };

  _proto._getVMaxLabelDimention = function _getVMaxLabelDimention() {
    var axis = this,
        axisConfig = axis.config,
        chart = axis.getFromEnv('chart'),
        smartLabel = axis.getFromEnv('smartLabel'),
        numberFormatter = axis.getFromEnv('number-formatter'),
        labelStyle = axisConfig.labels.style,
        maxTextSize = 0,
        divArr,
        divArrLen,
        maxTextDim,
        i,
        text,
        dimention,
        numberFormatterFn,
        curDiv;
    smartLabel.useEllipsesOnOverflow(chart.config.useEllipsesWhenOverflow);
    smartLabel.setStyle({
      fontSize: labelStyle.fontSize,
      fontFamily: labelStyle.fontFamily,
      lineHeight: labelStyle.lineHeight,
      fontWeight: labelStyle.fontWeight
    });

    if (axisConfig.isPercent) {
      numberFormatterFn = numberFormatter.percentValue;
    } else {
      numberFormatterFn = numberFormatter.xAxis;
    }

    axisConfig.allTicks = divArr = logTicksMerge(axisConfig.ticks, axisConfig.minorTicks);
    divArrLen = divArr.length;

    for (i = 0; i < divArrLen; i++) {
      curDiv = divArr[i];
      text = '' + numberFormatterFn.call(numberFormatter, curDiv);
      dimention = smartLabel.getOriSize(text);
      axis.components.labels[i] = {
        config: {
          width: dimention.width,
          height: dimention.height,
          props: {
            label: {}
          }
        }
      };

      if (text.length > maxTextSize) {
        maxTextDim = dimention;
        maxTextSize = text.length;
      }
    }

    return maxTextDim;
  };

  _proto._getHMaxLabelDimention = function _getHMaxLabelDimention() {
    // since there is no difference between vertival and horizontal label dimentions api in log axis yet
    return this._getVMaxLabelDimention();
  };

  _proto.getCleanValue = function getCleanValue(_num) {
    var axis = this,
        num = _num,
        value = null;
    num = Math.abs(num);

    if (num > 0) {
      value = axis.getFromEnv('number-formatter').getCleanValue(num);
    }

    return value;
  };

  return LogAxis;
}(_cartesian.default);

LogAxis.prototype.getTrendLineLimits = _commonApi.getTrendLineLimits;
var _default = LogAxis;
exports["default"] = _default;

/***/ }),

/***/ 1457:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _polarAxis = _interopRequireDefault(__webpack_require__(1458));

var _default = {
  'initial.axis.polar': function initialAxisPolar() {
    return {
      'path.appearing': _polarAxis.default,
      'text.appearing': _polarAxis.default
    };
  }
};
exports["default"] = _default;

/***/ }),

/***/ 1456:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _axis = _interopRequireDefault(__webpack_require__(567));

var _lib = __webpack_require__(274);

var _polarUtil = __webpack_require__(1454);

var _diff = _interopRequireDefault(__webpack_require__(569));

var _range = _interopRequireDefault(__webpack_require__(563));

var _polar = _interopRequireDefault(__webpack_require__(1457));

var _dependencyManager = __webpack_require__(282);

var _category = _interopRequireDefault(__webpack_require__(586));

var _commonApi = __webpack_require__(572);

/* eslint require-jsdoc: 'error', valid-jsdoc: ["error", { "requireReturn": false }] */
var UNDEF,
    DASH_DEF = 'none',
    // PXSTRING = 'px',
POINTER = 'pointer',
    NORMALSTRING = 'normal',
    EVENTARGS = 'eventArgs',
    POSITION_MIDDLE = _lib.preDefStr.POSITION_MIDDLE,
    POSITION_START = _lib.preDefStr.POSITION_START,
    POSITION_TOP = _lib.preDefStr.POSITION_TOP,
    POSITION_BOTTOM = _lib.preDefStr.POSITION_BOTTOM,
    POSITION_END = _lib.preDefStr.POSITION_END,
    // M = 'M',
math = Math,
    mathMin = math.min,
    pi = math.PI,
    pi2 = 2 * pi; // pInt = function (s, mag) {
//   return parseInt(s, mag || 10);
// },
// labelFontBdrColor,

(0, _dependencyManager.addDep)({
  name: 'polarAnimation',
  type: 'animationRule',
  extension: _polar.default
});
/**
 * Creates the Polar axis class
 * @class
 */

var Polar = /*#__PURE__*/function (_Axis) {
  (0, _inheritsLoose2.default)(Polar, _Axis);

  /**
   * adding animation rules
   */
  function Polar() {
    var _this;

    _this = _Axis.call(this) || this;
    _this.config.scale = new _category.default();
    _this.config.referenceInfo = [];
    return _this;
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */


  var _proto = Polar.prototype;

  _proto.getName = function getName() {
    return 'polarCategory';
  }
  /**
   * Sets default config
   *
   * @memberof Polar
   */
  ;

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    _Axis.prototype.__setDefaultConfig.call(this);

    this.config.drawPlotBands = false;
    this.config.forceZeroTick = false;
  }
  /**
   * Prepare the axis attributes for use by the chart drawing. It applies default values to the
   * options that are undefined.
   * @param  {Object}  rawAttr The raw attributes to be set
   */
  ;

  _proto.configureAttributes = function configureAttributes(rawAttr) {
    var axis = this,
        axisConfig = axis.config,
        axisAttr = rawAttr,
        chart = axis.getFromEnv('chart'),
        jsonData = chart.getFromEnv('dataSource'),
        FCChartObj = jsonData.chart,
        colorM = axis.getFromEnv('color-manager');

    _Axis.prototype.configureAttributes.call(this, rawAttr);

    axisConfig.gridLineColor = (0, _lib.convertColor)((0, _lib.pluck)(axisAttr.radarSpikeColor, colorM.getColor('divLineColor')), (0, _lib.pluckNumber)(axisAttr.radarSpikeAlpha, axisAttr.radarInLineAlpha, colorM.getColor('divLineAlpha')));
    axisConfig.radarSpikeThickness = (0, _lib.pluckNumber)(FCChartObj.radarspikethickness, 1); // labelFontBdrColor = labelFontBdrColor ? convertColor(
    //   labelFontBdrColor, pluckNumber(FCChartObj.labelborderalpha,
    //     FCChartObj.labelalpha, 100)) : BLANKSTRING;
    // axisConfig.labels.style = {
    //   fontFamily: pluck(axisAttr.labelFont, axisAttr.outCanfontFamily),
    //   fontSize: pluckNumber(axisAttr.labelFontSize, pInt(axisAttr.outCanfontSize)) + PXSTRING,
    //   fontWeight: pluckNumber(axisAttr.labelFontBold) ? 'bold' :
    //     NORMALSTRING,
    //   fontStyle: pluckNumber(axisAttr.labelFontItalic) ? 'italic' :
    //     NORMALSTRING,
    //   color: convertColor(pluck(axisAttr.labelFontColor, axisAttr.outCancolor),
    //     pluckNumber(axisAttr.labelFontAlpha, 100)),
    //   labelLink: FCChartObj.labellink,
    //   border: labelFontBdrColor || FCChartObj.labelbgcolor ?
    //     (pluckNumber(FCChartObj.labelborderthickness, 1) + 'px solid') : '',
    //   borderColor: labelFontBdrColor,
    //   borderThickness: pluckNumber(FCChartObj.labelborderthickness, 1),
    //   borderPadding: pluckNumber(FCChartObj.labelborderpadding, 2),
    //   borderRadius: pluckNumber(FCChartObj.labelborderradius, 0),
    //   backgroundColor: FCChartObj.labelbgcolor ?
    //     convertColor(FCChartObj.labelbgcolor,
    //       pluckNumber(FCChartObj.labelbgalpha, FCChartObj.labelalpha,
    //         100)) : BLANKSTRING,
    //   borderDash: pluckNumber(FCChartObj.labelborderdashed, 0) ?
    //     getDashStyle(pluckNumber(FCChartObj.labelborderdashlen, 4),
    //       pluckNumber(FCChartObj.labelborderdashgap, 2)) : DASH_DEF
    // };
    // axisConfig.categoryNumDivLines = pluckNumber(axisConfig.numDivLines, 0);
  }
  /**
   * Function set the starting point for drawing the axis and the axis drawing width/height
   * @param {Object} data Contains the x, y, length and whether the axis is drawn on the opposite side
   */
  ;

  _proto.setAxisDimention = function setAxisDimention(data) {
    var axis = this,
        scale = axis.getScale(),
        axisConfig = axis.config,
        chart = axis.getFromEnv('chart'),
        chartConfig = chart.config,
        startAngle = axisConfig.startAngle || -pi / 2,
        totalAngle = axisConfig.totalAngle || -pi2,
        endAngle = startAngle + totalAngle,
        rangeArr,
        category = axisConfig.tickValues.tickValue || [],
        anglePerSlice = totalAngle / (category.length || 1),
        axisDimention = axisConfig.axisDimention || (axisConfig.axisDimention = {});
    axisDimention.opposite = (0, _lib.pluckNumber)(data.opposite, axisDimention.opposite);
    axisDimention.centerX = (0, _lib.pluckNumber)(data.x, axisDimention.x, chartConfig.canvasLeft);
    axisDimention.centerY = (0, _lib.pluckNumber)(data.y, axisDimention.y, chartConfig.canvasTop);
    axisDimention.axisLength = pi2;
    endAngle -= anglePerSlice;
    rangeArr = axisConfig.clockWise ? [endAngle, startAngle] : [startAngle, endAngle];
    scale.setRange(rangeArr);
  }
  /**
   * Parse category line attributes
   *
   * @memberof Polar
   */
  ;

  _proto._parseCategoryPlotLine = function _parseCategoryPlotLine() {
    var axis = this,
        axisConfig = axis.config,
        tickValue = axisConfig.tickValues.tickValue,
        plotLineColor = axisConfig.gridLineColor,
        plotLineWidth = axisConfig.radarSpikeThickness,
        axisAttrObj,
        referenceInfo = axisConfig.referenceInfo,
        i,
        value;
    axisAttrObj = {
      stroke: plotLineColor,
      'stroke-width': plotLineWidth // 'stroke-dasharray': plotLineDashStyle

    }; // checking for pure tickValue axis exclude bubble scatter

    if (tickValue[0] && (tickValue[0].x !== UNDEF || tickValue[0].y !== UNDEF)) {
      return;
    } // checking if lines are to be drawn user can decide


    if (axisConfig.lines.isDraw && axisConfig.numDivLines) {
      for (i = 0; i < tickValue.length; ++i) {
        value = i;
        referenceInfo.push({
          from: value,
          type: 'line',
          layer: 1,
          attr: axisAttrObj
        });
      }
    }
  }
  /**
   * Function called by the chart when there is requirement to calculate or recalculate the space
   * management this function must be called every time when chart dimension is changed
   * @param {number} width The maximum width that is available for space management
   * @param {number} height The maximum height that is available for space management
   * @return {Object} Left and right defining how much space is used in left and right
   */
  ;

  _proto.placeAxis = function placeAxis(width, height) {
    var axis = this,
        axisConfig = axis.config,
        chart = axis.getFromEnv('chart'),
        smartLabel = chart.getFromEnv('smartLabel'),
        labelStyle = axisConfig.labels.style,
        categories = chart.getFromEnv('dataSource').categories,
        axisValuePadding = axisConfig.labelPadding = (0, _lib.pluckNumber)(axisConfig.rawAttr.axisValuePadding, 10),
        useEllipsesWhenOverflow = axisConfig.useEllipsesWhenOverflow,
        top = 0,
        left = 0,
        right = 0,
        bottom = 0,
        avalTop = height / 2,
        avalBottom = height / 2,
        avalRight = width / 2,
        avalLeft = width / 2,
        i,
        // text,
    // allCategories = axisConfig.categories && axisConfig.categories.category,
    allCategories = axisConfig.tickValues && axisConfig.tickValues.tickValue,
        categoryLength,
        singleCategory,
        smartLabelText,
        categoriesStyle,
        categoryStyle,
        smartLabelStyle,
        smartLabelStyleLineHeight,
        lineHeight; // TODO : so space management for category

    axisConfig.labels.isDraw = 1;
    axisConfig.labels.drawNormalVal = 1;
    axisConfig.labels.drawLimitVal = 1;

    if (!axis.components) {
      axis.components = {};
    }

    axis.components.labels = []; // The style for the catergories

    if (axisConfig.showLabels) {
      if (categories) {
        var firstCategory = categories[0];
        categoriesStyle = {
          fontFamily: firstCategory.font,
          fontSize: firstCategory.fontsize,
          color: firstCategory.fontcolor
        };
      }

      for (i = 0, categoryLength = allCategories.length; i < categoryLength; i++) {
        singleCategory = allCategories[i]; // Style for the individuel category

        categoryStyle = {
          fontFamily: singleCategory.font,
          fontSize: singleCategory.fontsize,
          fontWeight: singleCategory.fontbold ? 'bold' : NORMALSTRING,
          fontStyle: singleCategory.fontitalic ? 'italic' : NORMALSTRING
        }; // the final style for smart label of that individual category label

        smartLabelStyle = {
          fontFamily: (0, _lib.pluck)(categoryStyle.fontFamily, categoriesStyle.fontFamily, labelStyle.fontFamily),
          fontSize: (0, _lib.pluck)(categoryStyle.fontSize, categoriesStyle.fontSize, this.computeFontSize(labelStyle.fontSizeWithUnit) + _lib.PXSTRING),
          fontWeight: (0, _lib.pluck)(categoryStyle.fontWeight, labelStyle.fontWeight),
          fontStyle: (0, _lib.pluck)(categoryStyle.fontStyle, labelStyle.fontStyle)
        };
        smartLabelStyleLineHeight = (0, _lib.setLineHeight)(smartLabelStyle);
        lineHeight = smartLabelStyleLineHeight.replace(/px/ig, '');
        smartLabel.useEllipsesOnOverflow(chart.config.useEllipsesWhenOverflow);
        smartLabel.setStyle(smartLabelStyle); // Make a copy of actual category label

        singleCategory.oriLabel === UNDEF && (singleCategory.oriLabel = singleCategory.label);

        if (i === 0) {
          smartLabelText = smartLabel.getSmartText(singleCategory.oriLabel, width, mathMin(lineHeight, avalTop), useEllipsesWhenOverflow);
          singleCategory.label = smartLabelText.text;
          singleCategory.tooltext = smartLabelText.tooltext;
          smartLabelText.width += smartLabelText.width ? axisValuePadding : 0;
          smartLabelText.height += smartLabelText.height ? axisValuePadding : 0;

          if (smartLabelText.height > top) {
            top = smartLabelText.height;
            bottom = top;
          }
        } else if (i === categoryLength / 2) {
          smartLabelText = smartLabel.getSmartText(singleCategory.oriLabel, width, mathMin(lineHeight, avalBottom), useEllipsesWhenOverflow);
          singleCategory.label = smartLabelText.text;
          singleCategory.tooltext = smartLabelText.tooltext;
          smartLabelText.width += smartLabelText.width ? axisValuePadding : 0;
          smartLabelText.height += smartLabelText.height ? axisValuePadding : 0;

          if (smartLabelText.height > bottom) {
            bottom = smartLabelText.height;
          }
        } else if (i < categoryLength / 2) {
          smartLabelText = smartLabel.getSmartText(singleCategory.oriLabel, avalLeft, smartLabelStyleLineHeight, useEllipsesWhenOverflow);
          singleCategory.label = smartLabelText.text;
          singleCategory.tooltext = smartLabelText.tooltext;
          smartLabelText.width += smartLabelText.width ? axisValuePadding : 0;
          smartLabelText.height += smartLabelText.height ? axisValuePadding : 0;

          if (smartLabelText.width > left) {
            left = smartLabelText.width;
          }
        } else {
          smartLabelText = smartLabel.getSmartText(singleCategory.oriLabel, avalRight, smartLabelStyleLineHeight, useEllipsesWhenOverflow);
          singleCategory.label = smartLabelText.text;
          singleCategory.tooltext = smartLabelText.tooltext;
          smartLabelText.width += smartLabelText.width ? axisValuePadding : 0;
          smartLabelText.height += smartLabelText.height ? axisValuePadding : 0;

          if (smartLabelText.width > right) {
            right = smartLabelText.width;
          }
        } // Store width and height of labels


        axis.components.labels.push({
          config: {
            width: smartLabelText.width,
            height: smartLabelText.height,
            props: {
              label: {
                attr: {}
              }
            }
          }
        });
      }
    } else {
      for (i = 0, categoryLength = allCategories.length; i < categoryLength; i++) {
        axis.components.labels.push({
          config: {
            width: 0,
            height: 0,
            props: {
              label: {
                attr: {}
              }
            }
          }
        });
      }
    }

    return {
      top: top,
      left: left,
      right: right,
      bottom: bottom
    };
  }
  /**
   * Calculates the parameters necessary to draw the components of the chart.
   * In addition, it also calculates and draws the axis labels and ticks
   */
  ;

  _proto._drawComponents = function _drawComponents() {
    var axis = this,
        axisConfig = axis.config;
    axisConfig.drawLabels && axisConfig.hasCategory && axis._drawCategory();
  }
  /**
   * Parses axis cosmetics and positions during post space management
   *
   * @memberof Polar
   */
  ;

  _proto.allocatePosition = function allocatePosition() {
    var axis = this,
        axisConfig = axis.config;
    axisConfig.drawLabels && axisConfig.hasCategory && axis._parseCategory();
  }
  /**
   * Parses the position and parsing of categories during post space management
   *
   * @memberof Polar
   */
  ;

  _proto._parseCategory = function _parseCategory() {
    var axis = this,
        axisConfig = axis.config,
        chart = axis.getFromEnv('chart'),
        isOpposit = axisConfig.isOpposit,
        labels = axisConfig.labels,
        style = labels.style,
        categoryLabel = axis.config.categoryLabel || (axis.config.categoryLabel = {}),
        categories = chart.getFromEnv('dataSource').categories,
        category = axisConfig.tickValues.tickValue,
        axisPadding = axisConfig.labelPadding,
        categoriesStyle = {},
        categoryStyle = {},
        centerX = axisConfig.axisDimention.centerX,
        centerY = axisConfig.axisDimention.centerY,
        i,
        max,
        min,
        curCategory,
        text,
        labelRotation,
        labelLineHeight,
        addCategoryPadding,
        css,
        axisAttrObj,
        fontColor,
        pos,
        curCategoryValue,
        posX,
        posY,
        radius,
        radiusXY,
        theta,
        axisScale = axis.getScale(),
        catStyle,
        id,
        textId;
    radius = (0, _lib.pluckNumber)(axisConfig.radius, 0);
    min = 0;
    max = category ? category.length - 1 : 0; // checking if labels are to be drawn user can decide or can be decided by axis placeAxis function

    if (axisConfig.labels.isDraw) {
      if (categories) {
        var cat0 = categories[0];
        categoriesStyle.fontFamily = cat0.font;
        categoriesStyle.fontSize = cat0.fontsize;
        categoriesStyle.color = cat0.fontcolor;
      } // recalculating font size in case of chart resize


      style.fontSize = this.computeFontSize(style.fontSizeWithUnit); // main loop where the drawing starts

      for (i = min; i <= max; i++) {
        curCategory = category[i]; // TODO : need to

        curCategoryValue = (0, _lib.pluckNumber)(curCategory.x, curCategory.y, i); // if values are not limit value and label drawing is off other
        // than limit increment it and continue

        if (!axisConfig.labels.drawNormalVal && !(axisConfig.labels.drawLimitVal && (i === min || curCategoryValue === max))) {
          continue;
        }

        if (!axisConfig.labels.drawNormalVal && !(curCategoryValue === min || curCategoryValue === max)) {
          continue;
        } // if value are limit value but limit value are not mean to be drawn


        if (!axisConfig.labels.drawLimitVal && (curCategoryValue === min || curCategoryValue === max)) {
          continue;
        }

        categoryStyle = {
          fontFamily: (0, _lib.pluck)(curCategory.font, curCategory.labelfont),
          fontSize: (0, _lib.pluck)(curCategory.fontsize, curCategory.labelfontsize),
          fontWeight: (0, _lib.pluckNumber)(curCategory.fontbold, curCategory.labelfontbold, 0) ? 'bold' : UNDEF,
          fontStyle: (0, _lib.pluckNumber)(curCategory.fontitalic, curCategory.labelfontitalic, 0) ? 'italic' : UNDEF
        };
        fontColor = (0, _lib.convertColor)((0, _lib.pluck)(curCategory.fontcolor, curCategory.labelfontcolor, categoriesStyle.color, style.color), (0, _lib.pluckNumber)(curCategory.labelalpha, axisConfig.rawAttr.labelFontAlpha, 100));
        css = {
          fontFamily: (0, _lib.pluck)(categoryStyle.fontFamily, categoriesStyle.fontFamily, style.fontFamily),
          fontSize: (0, _lib.pluck)(categoryStyle.fontSize, categoriesStyle.fontSize, style.fontSize),
          fontWeight: (0, _lib.pluck)(categoryStyle.fontWeight, style.fontWeight),
          fontStyle: (0, _lib.pluck)(categoryStyle.fontStyle, style.fontStyle)
        };
        css.lineHeight = (0, _lib.setLineHeight)(css);

        if (css.lineHeight) {
          labelLineHeight = css.lineHeight;

          if (labelLineHeight.indexOf('px') !== -1) {
            labelLineHeight = labelLineHeight.replace(/px/i, '');
            labelLineHeight = parseFloat(labelLineHeight);
          }
        } // make the attribute ready to use
        // y-axis


        theta = axisScale.getRangeValue(curCategoryValue);
        pos = (0, _polarUtil.polarToCartesian)(radius + axisPadding, theta);
        pos.x += centerX;
        pos.y += centerY;
        posX = pos.x;
        posY = pos.y;
        text = curCategory.label || '';

        if ((0, _lib.pluckNumber)(curCategory.showlabel, 1) === 0 || axisConfig.showLabels === 0) {
          text = '';
        }

        addCategoryPadding = curCategory.labelPadding || 0;
        axisAttrObj = {
          fill: fontColor,
          'line-height': labelLineHeight,
          'font-size': style.fontSize,
          'text': text,
          cursor: curCategory.link ? POINTER : 'default',
          'x': posX,
          'y': posY
        };

        if (addCategoryPadding) {
          axisAttrObj.y += addCategoryPadding;
        }

        if (labelRotation) {
          axisAttrObj['text-anchor'] = isOpposit ? POSITION_START : POSITION_END;
          axisAttrObj['vertical-align'] = POSITION_MIDDLE;
        } else {
          axisAttrObj['vertical-align'] = isOpposit ? POSITION_BOTTOM : POSITION_TOP;
        }

        if (i === 0) {
          axisAttrObj['text-anchor'] = POSITION_MIDDLE;
          axisAttrObj['vertical-align'] = POSITION_BOTTOM;
        } else if (i === (max + 1) / 2) {
          axisAttrObj['text-anchor'] = POSITION_MIDDLE;
          axisAttrObj['vertical-align'] = POSITION_TOP;
        } else if (i < (max + 1) / 2) {
          axisAttrObj['text-anchor'] = POSITION_END;
          axisAttrObj['vertical-align'] = POSITION_MIDDLE;
        } else {
          axisAttrObj['text-anchor'] = POSITION_START;
          axisAttrObj['vertical-align'] = POSITION_MIDDLE;
        }

        theta = axisScale.getRangeValue(curCategoryValue);
        radiusXY = (0, _polarUtil.polarToCartesian)(radius, theta);
        radiusXY.x += centerX;
        radiusXY.y += centerY; // If labels shift is applicable (Specially for 3D) then apply the changes

        if (labels.shiftX) {
          axisAttrObj.x += labels.shiftX;
        }

        if (labels.shiftY) {
          axisAttrObj.y += labels.shiftY;
        } // CategoryLabel is not present, create it.


        categoryLabel = axisConfig.categoryLabel = categoryLabel || {}; // Create/reuse category label

        textId = 'Label' + (id || i);
        categoryLabel[textId] = categoryLabel[textId] || {};
        categoryLabel[textId].config = categoryLabel[textId].config || {};
        categoryLabel[textId].config.labelBox = catStyle = {
          label: text,
          lineHeight: css.lineHeight,
          border: (0, _lib.pluckNumber)(curCategory.borderthickness, curCategory.labelborderthickness) ? (0, _lib.pluckNumber)(curCategory.borderthickness, curCategory.labelborderthickness, 1) + 'px solid' : '',
          borderColor: curCategory.bordercolor || curCategory.labelbordercolor ? (0, _lib.convertColor)(curCategory.bordercolor || curCategory.labelbordercolor, (0, _lib.pluckNumber)(curCategory.borderalpha, curCategory.labelborderalpha, curCategory.alpha, curCategory.labelalpha, 100)) : _lib.BLANKSTRING,
          borderThickness: (0, _lib.pluckNumber)(curCategory.borderthickness, curCategory.labelborderthickness),
          borderPadding: (0, _lib.pluckNumber)(curCategory.borderpadding, curCategory.labelborderpadding),
          borderRadius: (0, _lib.pluckNumber)(curCategory.borderradius, curCategory.labelborderradius),
          backgroundColor: curCategory.bgcolor || curCategory.labelbgcolor ? (0, _lib.convertColor)(curCategory.bgcolor || curCategory.labelbgcolor, (0, _lib.pluckNumber)(curCategory.bgalpha, curCategory.labelbgalpha, curCategory.alpha, curCategory.labelalpha, 100)) : _lib.BLANKSTRING,
          borderDash: (0, _lib.pluckNumber)(curCategory.borderdashed, curCategory.labelborderdashed, 0) ? (0, _lib.getDashStyle)((0, _lib.pluckNumber)(curCategory.borderdashlen, curCategory.labelborderdashlen, 4), (0, _lib.pluckNumber)(curCategory.borderdashgap, curCategory.labelborderdashgap, 2)) : (0, _lib.pluckNumber)(curCategory.borderdashed, curCategory.labelborderdashed) === 0 ? DASH_DEF : style.borderDash
        }; // Set the categorylabel text-bound cosmetics

        categoryLabel[textId].config.labelBox['text-bound'] = !text ? [] : [(0, _lib.pluck)(catStyle.backgroundColor, style.backgroundColor), (0, _lib.pluck)(catStyle.borderColor, style.borderColor), (0, _lib.pluck)(catStyle.borderThickness, style.borderThickness), (0, _lib.pluck)(catStyle.borderPadding, style.borderPadding), (0, _lib.pluck)(catStyle.borderRadius, style.borderRadius), (0, _lib.pluck)(catStyle.borderDash, style.borderDash)];
        axisAttrObj['text-bound'] = categoryLabel[textId].config.labelBox['text-bound'];
        axis.components.labels[i].config.props.label.css = css;
        axis.components.labels[i].config.props.label.attr = Object.assign(axis.components.labels[i].config.props.label.attr, axisAttrObj);
      }
    }
  }
  /**
   * Draws the category labels of the axis
   */
  ;

  _proto._drawCategory = function _drawCategory() {
    var axis = this,
        axisConfig = axis.config,
        chart = axis.getFromEnv('chart'),
        animationManager = chart.getFromEnv('animationManager'),
        labels = axisConfig.labels,
        style = labels.style,
        axisContainer = axisConfig.axisContainer,
        category = axisConfig.tickValues.tickValue,
        raiseEvent = function raiseEvent(event) {
      return function (data) {
        var ele = this;
        chart.plotEventHandler(ele, data, event);
      };
    },
        toolTipController = axis.getFromEnv('toolTipController'),
        counter = 0,
        i,
        max,
        min,
        curCategory,
        textElement,
        textElemCheck,
        css,
        axisAttrObj,
        curCategoryValue,
        removeElem,
        id,
        textId,
        mapArr = [],
        removeElementsArr,

    /**
     * Removes element which are required anymore.
     * @param {any} arrOfId array
     */
    removeElements = function removeElements(arrOfId) {
      for (i = 0; i < arrOfId.length; ++i) {
        removeElem = axis.getGraphicalElement(arrOfId[i]);
        removeElem && axis.removeGraphicalElement(removeElem);
      }
    };

    min = 0;
    max = category ? category.length - 1 : 0; // checking if labels are to be drawn user can decide or can be decided by axis placeAxis function

    if (axisConfig.labels.isDraw) {
      // main loop where the drawing starts
      for (i = min, counter = 0; i <= max; i++) {
        curCategory = category[i]; // TODO : need to

        curCategoryValue = (0, _lib.pluckNumber)(curCategory.x, curCategory.y, i); // if values are not limit value and label drawing is off other
        // than limit increment it and continue

        if (!axisConfig.labels.drawNormalVal && !(axisConfig.labels.drawLimitVal && (i === min || curCategoryValue === max))) {
          continue;
        }

        if (!axisConfig.labels.drawNormalVal && !(curCategoryValue === min || curCategoryValue === max)) {
          continue;
        } // if value are limit value but limit value are not mean to be drawn


        if (!axisConfig.labels.drawLimitVal && (curCategoryValue === min || curCategoryValue === max)) {
          continue;
        }

        textId = 'Label' + (id || i);
        mapArr.push(textId);
        axisAttrObj = axis.components.labels[i].config.props.label.attr;
        css = axis.components.labels[i].config.props.label.css;
        textElemCheck = axis.getGraphicalElement(textId);
        textElement = animationManager.setAnimation({
          css: css,
          el: textElemCheck || 'text',
          attr: axisAttrObj,
          container: axisContainer,
          component: axis,
          label: 'polarLabel'
        }); // Attach/remove tooltip

        if (axisConfig.showTooltip && curCategory.tooltext) {
          toolTipController.enableToolTip(textElement, curCategory.tooltext);
        } else {
          toolTipController.disableToolTip(textElement);
        }

        textElement.data(EVENTARGS, {
          link: curCategory.link || curCategory.labellink || style.labelLink,
          text: axisAttrObj.text,
          index: counter
        });

        if (!textElemCheck) {
          axis.addGraphicalElement(textId, textElement); // Attach event handler to category label

          textElement.on('fc-click', raiseEvent('datalabelclick')).hover(raiseEvent('dataLabelRollOver'), raiseEvent('dataLabelRollOut'));
        }

        counter += 1;
      }

      axisConfig.labelMap = axisConfig.labelMap || [];
      removeElementsArr = (0, _diff.default)(axisConfig.labelMap, mapArr);
    } else {
      removeElementsArr = mapArr;
    }

    axisConfig.labelMap = mapArr;
    removeElements(removeElementsArr);
  }
  /**
   * translation wil be for radar
   * @return {number} value 0
   */
  ;

  _proto.getTranslation = function getTranslation() {
    if (this) return 0;
  }
  /**
   * returns the reference info
   * @return {Array} array of object
  */
  ;

  _proto.getReferenceInfo = function getReferenceInfo() {
    return this.config.referenceInfo;
  }
  /**
   * Sets the visible range of the axis. Also sets axis's reference values and re-calculates PVR.
   * @param  {number} minValue The minimum value of the area to be visible
   * @param  {number} maxValue The maximum value of the area to be visible
   * @return {boolean} Whether the visible range of the axis was successfully set or not
   */
  ;

  _proto.setVisibleConfig = function setVisibleConfig(minValue, maxValue) {
    var axis = this,
        axisConfig = axis.config,
        scale = axis.getScale(),
        domain;

    if (minValue >= maxValue || minValue < axisConfig.axisRange.min || maxValue > axisConfig.axisRange.max) {
      return false;
    }

    domain = scale.setDomain([minValue, maxValue]).getDomain();
    axisConfig.visibleMin = domain[0];
    axisConfig.visibleMax = domain[1];
    axis.clearReferenceInfo();

    axis._parseReferenceVisuals();

    axis.fireEvent('visiblerangeset', {
      minValue: minValue,
      maxValue: maxValue
    });
    axis.asyncDraw();
    return true;
  }
  /**
   * will call api for parsing reference visuals
  */
  ;

  _proto._parseReferenceVisuals = function _parseReferenceVisuals() {
    this.config.drawPlotlines && this._parseCategoryPlotLine();
  }
  /**
   * will clear the reference visuals
  */
  ;

  _proto.clearReferenceInfo = function clearReferenceInfo() {
    var axisConfig = this.config;
    axisConfig.referenceInfo = [];
  };

  _proto._setAxisRange = function _setAxisRange(data) {
    var min = data.min,
        max = data.max,
        axisConfig = this.config,
        axisRange = axisConfig.axisRange,
        divGap = data.divGap,
        step;

    if (min > max) {
      return;
    }

    step = (max - min) / (axisConfig.categoryNumDivLines + 1);
    this.getScale().setDomain([min, max]);
    axisConfig.ticks = (0, _range.default)(min, max, step).concat(max);
    axisConfig._allTicks = axisConfig.ticks.slice();
    axisRange.min = min;
    axisRange.max = max;
    axisRange.tickInterval = divGap || step;
    this.setVisibleConfig(axisRange.min, axisRange.max);
  };

  return Polar;
}(_axis.default);

Polar.prototype.setTickValues = _commonApi.setTickValues;
Polar.prototype.shiftLabels = _commonApi.shiftLabels;
Polar.prototype._createContainer = _commonApi._createContainer;
Polar.prototype.setAxisPadding = _commonApi.setAxisPadding;
Polar.prototype.getPixel = _commonApi.getPixel;
Polar.prototype.getLabel = _commonApi.getLabel;
var _default = Polar;
exports["default"] = _default;

/***/ }),

/***/ 1385:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _componentInterface = __webpack_require__(290);

var _lib = __webpack_require__(274);

var _numeric = _interopRequireDefault(__webpack_require__(537));

var _checkbox = _interopRequireDefault(__webpack_require__(427));

var checkboxTopPadding = 4;

var removeInfo = function removeInfo(_existingAxes, _axisMapById) {
  var key, _info, i;

  for (i = _existingAxes.length - 1; i > -1; i--) {
    key = _existingAxes[i];
    _info = _axisMapById.get(key);
    _info.checkbox && _info.checkbox.remove();
    _info.axis && _info.axis.remove();

    _axisMapById['delete'](key);
  }
},
    swap = function swap(a, b, map) {
  var e1 = [a, map.get(a)],
      // eslint-disable-line good-practices/no-single-usage-variable
  e2 = [b, map.get(b)],
      // eslint-disable-line good-practices/no-single-usage-variable
  mapArray = Array.from(map.entries()),
      // eslint-disable-line good-practices/no-single-usage-variable
  newMapArray = mapArray.map(function (_ref) {
    var key = _ref[0],
        value = _ref[1];

    // eslint-disable-line good-practices/no-single-usage-variable
    if (key === a) {
      return e2;
    } else if (key === b) {
      return e1;
    }

    return [key, value];
  });
  return new Map(newMapArray);
},
    factoryAxis = function factoryAxis(parent) {
  var axesConf = parent.config.axesConf,
      axes,
      axisMapById,
      activeAxis,
      existingInfo,
      exsitingAxisMapById = parent.config.axisMapById,
      existingAxes = exsitingAxisMapById && Array.from(exsitingAxisMapById.keys()) || [],
      info,
      firstAxis = true,
      // eslint-disable-line good-practices/no-single-usage-variable
  canvas = parent.getFromEnv('chart').getChildren('canvas')[0],
      axisRefVisualCartesian = canvas.getChildren('axisRefVisualCartesian')[0],
      redraw = function redraw() {
    return axisRefVisualCartesian.asyncDraw();
  },
      // eslint-disable-line good-practices/no-single-usage-variable
  removeId = function removeId(id) {
    var index = existingAxes.indexOf(id);
    index !== -1 && existingAxes.splice(index, 1);
  };

  (0, _lib.componentFactory)(parent, _numeric.default, 'yAxis', axesConf.length, axesConf);
  axes = (parent.getChildren('yAxis') || []).slice(0);
  axisMapById = parent.config.axisMapById = new Map(); // eslint-disable-line good-practices/no-single-usage-variable

  (parent.config.side === 'l' ? axes.reverse() : axes).forEach(function (axis) {
    if (axis.getState('removed') || axis.config.showaxis === 0) {
      return;
    }

    var axisId = axis.getId();
    info = {};
    info.axis = axis;
    existingInfo = exsitingAxisMapById && exsitingAxisMapById.get(axisId);
    info.checkbox = existingInfo && existingInfo.checkbox;
    axisMapById.set(axisId, info);

    if (axis.config.showaxis === 0) {
      axis.hide();
    } else {
      axis.show();
    }

    canvas.attachAxis(axis, true);
    firstAxis && (parent.config.besideCanvas = axisId);
    firstAxis = false; // eslint-disable-line good-practices/no-single-usage-variable

    if (!axisCount) {
      activeAxis = axis;
    }

    axis.setLinkedItem('canvas', canvas);
    axisRefVisualCartesian.setLinkedItem(axis.getId(), axis);
    axisRefVisualCartesian.addExtEventListener('visiblerangeset', redraw, axis);
    axisCount++;
    removeId(axisId);
  });
  activeAxis && canvas.setPrimaryAxis('yAxis', activeAxis);
  removeInfo(existingAxes, exsitingAxisMapById);
},
    axisCount = 0;
/**
 * This module handles the customized UI for axis in multiaxis charts
 */


var AxisSelectorUI = /*#__PURE__*/function (_ComponentInterface) {
  (0, _inheritsLoose2.default)(AxisSelectorUI, _ComponentInterface);

  /**
   * constructor fn
   */
  function AxisSelectorUI() {
    var _this;

    _this = _ComponentInterface.call(this) || this;

    _this.registerFactory('axis', factoryAxis);

    return _this;
  }
  /**
   * reset axis count
   */


  AxisSelectorUI.resetAxisCount = function resetAxisCount() {
    axisCount = 0;
  }
  /**
   * function to configure this component by given configuration
   * @param {Object} conf configuration object
   */
  ;

  var _proto = AxisSelectorUI.prototype;

  _proto.configureAttributes = function configureAttributes(conf) {
    if (conf === void 0) {
      conf = {};
    }

    var config = this.config;
    config.axesConf = conf.axesConf || [];
    config.checkboxesConf = conf.checkboxesConf || [];
    config.side = conf.side;
  }
  /**
   * function to allocate and calculate total required space
   * @param {Number} avlWidth avialable width to allocated
   */
  ;

  _proto.placeAxis = function placeAxis(avlWidth) {
    var axisSelectorUI = this,
        availableWidth = avlWidth,
        side = axisSelectorUI.config.side,
        // eslint-disable-line good-practices/no-single-usage-variable
    axisMapById = axisSelectorUI.getAxesDetails(),
        // eslint-disable-line good-practices/no-single-usage-variable
    axesPadding = axisSelectorUI.getFromEnv('chartConfig').axesPadding,
        rightPadding = 0,
        // eslint-disable-line good-practices/no-single-usage-variable
    leftPadding = 0,
        // eslint-disable-line good-practices/no-single-usage-variable
    dim,
        dimension = {
      right: 0,
      left: 0
    };
    axisMapById.forEach(function (info) {
      var value = info.value || (info.value = {}),
          axis = info.axis;

      if (axis.getState('removed') || axis.config.showaxis === 0) {
        return;
      }

      dim = axis.placeAxis(availableWidth * 0.7);

      if (side === 'r') {
        availableWidth -= value.width = dim.right;
        dimension.right += dim.right;
        rightPadding += axesPadding;
      } else {
        availableWidth -= value.width = dim.left;
        dimension.left += dim.left;
        leftPadding += axesPadding;
      }
    });
    return {
      dimension: dimension,
      rightPadding: rightPadding,
      leftPadding: leftPadding
    };
  }
  /**
   * calculate post space management related calculation
   */
  ;

  _proto.setAxisDimention = function setAxisDimention() {
    var axisSelectorUI = this,
        conf = axisSelectorUI.config,
        axisMapById = axisSelectorUI.getAxesDetails(),
        // eslint-disable-line good-practices/no-single-usage-variable
    axesPadding = axisSelectorUI.getFromEnv('chartConfig').axesPadding,
        canvasConfig = axisSelectorUI.getFromEnv('chart').getChildren('canvas')[0].config,
        canvasBorderWidth = canvasConfig.canvasBorderWidth,
        canvasPaddingTop = canvasConfig.canvasPaddingTop,
        canvasPaddingBottom = canvasConfig.canvasPaddingBottom,
        // eslint-disable-line good-practices/no-single-usage-variable
    canvasLeft = canvasConfig.canvasLeft,
        canvasTop = canvasConfig.canvasTop,
        // eslint-disable-line good-practices/no-single-usage-variable
    canvasHeight = canvasConfig.canvasHeight,
        // eslint-disable-line good-practices/no-single-usage-variable
    canvasRight = canvasLeft + canvasConfig.canvasWidth,
        isRight = conf.side === 'r',
        // eslint-disable-line good-practices/no-single-usage-variable
    oppositePos = conf.side === 'r' ? canvasLeft - canvasBorderWidth : canvasRight + canvasBorderWidth,
        // eslint-disable-line good-practices/no-single-usage-variable
    padding = 0;
    axisMapById.forEach(function (info) {
      var value = info.value || (info.value = {}),
          axis = info.axis;

      if (axis.config.showaxis === 0 || axis.getState('removed')) {
        return;
      }

      if (isRight) {
        value.x = canvasRight + canvasBorderWidth + padding + axesPadding;
      } else {
        value.x = canvasLeft - canvasBorderWidth - padding - axesPadding;
      }

      value.y = canvasTop + canvasPaddingTop;
      value.height = canvasHeight - canvasPaddingTop - canvasPaddingBottom;
      value.opposite = oppositePos;
      padding += value.width + axesPadding;
      axis.setAxisDimention({
        x: value.x,
        y: value.y,
        opposite: value.opposite,
        axisLength: value.height
      });
    });
  }
  /**
   * function to draw hot elements of axes.
   * It helps to interact with axes
   */
  ;

  _proto.drawHotElements = function drawHotElements() {
    var axisSelectorUI = this,
        conf = axisSelectorUI.config,
        isRight = conf.side === 'r',
        // eslint-disable-line good-practices/no-single-usage-variable
    allowAxisShift = axisSelectorUI.getFromEnv('chartConfig').allowAxisShift,
        // eslint-disable-line good-practices/no-single-usage-variable
    chart = axisSelectorUI.getFromEnv('chart'),
        axisMapById = conf.axisMapById,
        // eslint-disable-line good-practices/no-single-usage-variable
    axisHotElements = axisSelectorUI.getGraphicalElement('axisHotElement') || [],
        k,
        length,
        counter = -1,
        attr = {
      cursor: 'col-resize',
      stroke: _lib.TRACKER_FILL,
      fill: _lib.TRACKER_FILL,
      visibility: true
    };

    if (allowAxisShift) {
      axisMapById.forEach(function (info, key) {
        var hotElement,
            value = info.value;
        attr.x = value.x + (isRight ? 0 : -value.width);
        attr.y = value.y;
        attr.width = value.width;
        attr.height = value.height; // Creating the hot element if not created

        if (!(hotElement = axisHotElements[++counter])) {
          hotElement = axisSelectorUI.addGraphicalElement('axisHotElement', axisSelectorUI.getFromEnv('paper').rect(chart.getChildContainer('trackerGroup')), true);
          hotElement.on('fc-click', axisSelectorUI._resuffelAxis);
        }

        hotElement.attr(attr).data('axisDetails', {
          axisSelectorUI: axisSelectorUI,
          canvas: chart.getChildren('canvas')[0],
          axisId: key
        });
      });
    }

    for (k = counter + 1, length = axisHotElements.length; k < length; k++) {
      // eslint-disable-line good-practices/no-single-usage-variable
      axisSelectorUI.removeGraphicalElement(axisHotElements[k]);
    }
  }
  /**
   * function to draw checkboxes
   */
  ;

  _proto.drawCheckBoxes = function drawCheckBoxes() {
    var axisSelectorUI = this,
        conf = axisSelectorUI.config,
        // chartId = axisSelectorUI.getFromEnv('chartInstance').id,
    chartConfig = axisSelectorUI.getFromEnv('chartConfig'),
        // chart = axisSelectorUI.getFromEnv('chart'),
    // checkBoxContainer = chart.getChildContainer('buttonGroup'),
    // toolBoxAPI = axisSelectorUI.getFromEnv('toolBoxAPI'),
    // tb = axisSelectorUI.getFromEnv('toolbox'),
    // CheckboxSymbol = toolBoxAPI.CheckboxSymbol,
    isRight = conf.side === 'r',
        // eslint-disable-line good-practices/no-single-usage-variable
    axisMapById = conf.axisMapById;

    if (chartConfig.allowSelection) {
      axisMapById.forEach(function (info, key) {
        var value = info.value,
            currCheckBox = info.checkbox,
            axisConfig = info.axis.config,
            checkboxClickHandler = function checkboxClickHandler() {
          var tool = this;
          tool.toggle();

          axisSelectorUI._dolegendInteraction.call(tool, key, tool.getFromEnv('chart'));

          axisConfig.checkBoxChecked = !axisConfig.checkBoxChecked;
        },
            // state = 'updating',
        padding = isRight ? info.axis.getAxisConfig('axisNamePadding') : -value.width; // eslint-disable-line good-practices/no-single-usage-variable


        if (!currCheckBox) {
          currCheckBox = info.checkbox = new _checkbox.default();
          axisSelectorUI.attachChild(currCheckBox, 'checkbox', true);
          currCheckBox.configure({
            isChecked: true,
            text: '',
            stroke: chartConfig.checkBoxColor,
            symbolStroke: chartConfig.checkBoxColor,
            strokeWidth: 1,
            symbolStrokeWidth: 1,
            containerInfo: {
              id: 'buttonGroup',
              label: 'group',
              isParent: true
            }
          });
          currCheckBox.addEventListener('fc-click', checkboxClickHandler);
        }

        currCheckBox.setDimension({
          x: value.x + padding,
          y: value.y + value.height + checkboxTopPadding
        });
      });
    } else {
      axisMapById.forEach(function (info, key) {
        info.checkbox && info.checkbox.remove();
        delete info.checkbox;
      });
    }
  };

  _proto._createLayers = function _createLayers() {
    var axisSelectorUI = this,
        parentLayer = axisSelectorUI.getFromEnv('chart').getChildContainer('selectorGroup');
    axisSelectorUI.createContainer('axisBottomGroup', {
      name: 'axis-bottom-group'
    }, parentLayer);
    axisSelectorUI.createContainer('axisTopGroup', {
      name: 'axis-top-group'
    }, parentLayer);
    axisSelectorUI.createContainer('buttonGroup', {
      name: 'buttons'
    }, parentLayer);
  };

  _proto.createContainer = function createContainer(containerName, attr, container) {
    return this.addChildContainer(containerName, this.getFromEnv('animationManager').setAnimation({
      container: container,
      attr: attr,
      el: this.getChildContainer(containerName) || 'group',
      component: this,
      label: 'group'
    }));
  }
  /**
   * function to handle draw job
   */
  ;

  _proto.draw = function draw() {
    this._createLayers();

    this.drawHotElements();
    this.drawCheckBoxes();
  }
  /**
   * Function to swap axis on click
   */
  ;

  _proto._resuffelAxis = function _resuffelAxis() {
    var data = this.data('axisDetails'),
        axisSelectorUI = data.axisSelectorUI,
        conf = axisSelectorUI.config,
        canvas = data.canvas,
        axisId = data.axisId,
        axesDetails = axisSelectorUI.getAxesDetails();

    if (conf.besideCanvas !== axisId) {
      axesDetails = axisSelectorUI.config.axisMapById = swap(conf.besideCanvas, axisId, axesDetails);
    }

    conf.besideCanvas = axisId;
    canvas.setPrimaryAxis('yAxis', axesDetails.get(axisId).axis);
    axisSelectorUI.setAxisDimention();
    axisSelectorUI.asyncDraw();
    canvas.getChildren('axisRefVisualCartesian')[0].asyncDraw();
  }
  /**
   * Function to manipulate legends on checkbox click
   * @param {number} axisIndex The index of the axis against which the checkbox is clicked
   * @param {Object} chart the chart object
   */
  ;

  _proto._dolegendInteraction = function _dolegendInteraction(axisId, chart) {
    var checkbox = this,
        datasets = [],
        // legend = iapi.getChildren('legend'),
    obj,
        dataset;
    chart.iterateComponents(function (child) {
      if (child.getType() === 'dataset') {
        datasets.push(child);
      }
    });

    for (obj in datasets) {
      if (datasets.hasOwnProperty(obj)) {
        dataset = datasets[obj];

        if (dataset.getFromEnv('yAxis').getId() === axisId) {
          if (!dataset.getState('visible') && checkbox.config.checked) {
            dataset.config.legendInteractivity = true;
            dataset.show();
          } else if (dataset.getState('visible') && !checkbox.config.checked) {
            dataset.config.legendInteractivity = true;
            dataset.hide();
          }
        }
      }
    } // legend.drawLegend();

  }
  /**
   * Function to change the state of the checkbox when legend is clicked
   * @param {Object} e The evet object
   */
  ;

  _proto.manipulateCheckBox = function manipulateCheckBox(e) {
    var data = e.data,
        clickedDS = data.dataset,
        axisId = clickedDS.getFromEnv('yAxis').getId(),
        // eslint-disable-line good-practices/no-single-usage-variable
    vCanvas = clickedDS.getLinkedParent(),
        // eslint-disable-line good-practices/no-single-usage-variable
    allDS = vCanvas.getChildren().dataset,
        checkboxUncheck = true,
        // eslint-disable-line good-practices/no-single-usage-variable
    i,
        len,
        dataset,
        info,
        axisMapById = this.getAxesDetails(); // eslint-disable-line good-practices/no-single-usage-variable

    if (!(info = axisMapById.get(axisId))) {
      return;
    }

    if (data.state === 'hide') {
      for (i = 0, len = allDS.length; i < len; i++) {
        dataset = allDS[i];

        if (dataset.getState('visible')) {
          checkboxUncheck = false;
        }
      }

      if (checkboxUncheck) {
        info.checkbox && info.checkbox.uncheck();
      }
    } else {
      info.checkbox && info.checkbox.check();
    }
  }
  /**
   * return axis components
   * @return {Object} axesMap
   */
  ;

  _proto.getAxesDetails = function getAxesDetails() {
    return this.config.axisMapById;
  }
  /**
   * return type of this component
   */
  ;

  _proto.getType = function getType() {
    return 'customAxisUI';
  }
  /**
   * return name of this component
   */
  ;

  _proto.getName = function getName() {
    return 'multiAxisSelectorUI';
  }
  /**
   * function to return axes attached to this comp.
   * This API is for external invocation whre the axes
   * is required from the outside components.
   * @return {Array} - axes
   */
  ;

  _proto.getAxes = function getAxes() {
    // eslint-disable-next-line good-practices/no-function-dependency
    return Array.from(this.config.axisMapById.values()).map(function (elem) {
      return elem.axis;
    });
  };

  return AxisSelectorUI;
}(_componentInterface.ComponentInterface);

var _default = AxisSelectorUI;
exports["default"] = _default;

/***/ }),

/***/ 1460:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _canvas = _interopRequireDefault(__webpack_require__(522));

var _polarUtil = __webpack_require__(1454);

var _lib = __webpack_require__(274);

var PolarCanvas = /*#__PURE__*/function (_Canvas) {
  (0, _inheritsLoose2.default)(PolarCanvas, _Canvas);

  function PolarCanvas() {
    return _Canvas.apply(this, arguments) || this;
  }

  var _proto = PolarCanvas.prototype;

  /**
   * Returns name of component
   *
   * @return {any}
   * @memberof polarCanvas
   */
  _proto.getName = function getName() {
    return 'polarCanvas';
  }
  /**
   * Returns type of component
   *
   * @return {any}
   * @memberof polarCanvas
   */
  ;

  _proto.getType = function getType() {
    return 'canvas';
  };

  _proto.configureAttributes = function configureAttributes() {
    _Canvas.prototype.configureAttributes.call(this);

    var canvas = this,
        canvasConfig = canvas.config,
        chart = canvas.getFromEnv('chart'),
        JSONData = chart.getFromEnv('dataSource'),
        FCChartObj = JSONData.chart,
        colorM = chart.getFromEnv('color-manager');
    canvasConfig.radarBorderColor = (0, _lib.convertColor)((0, _lib.pluck)(FCChartObj.radarbordercolor, colorM.getColor('divLineColor')), (0, _lib.pluckNumber)(FCChartObj.radarborderalpha, 100));
    canvasConfig.radarFillColor = (0, _lib.convertColor)((0, _lib.pluck)(FCChartObj.radarfillcolor, colorM.getColor('altHGridColor')), (0, _lib.pluckNumber)(FCChartObj.radarfillalpha, colorM.getColor('altHGridAlpha')));
    canvasConfig.radarBorderThickness = (0, _lib.pluckNumber)(FCChartObj.radarborderthickness, 2);
    canvasConfig.showRadarBorder = (0, _lib.pluckNumber)(FCChartObj.showradarborder, 1);
  }
  /**
   * Draws group and canvas
   *
   * @memberof polarCanvas
   */
  ;

  _proto.draw = function draw() {
    this.createGroup();
    this.drawCanvas();
  }
  /**
   * Draws the radar border and background
   *
   * @memberof polarCanvas
   */
  ;

  _proto.drawCanvas = function drawCanvas() {
    var canvas = this,
        canvasConfig = this.config,
        chart = canvas.getFromEnv('chart'),
        chartConfig = chart.config,
        axis = chart.getChildren('xAxis')[0],
        animationManager = chart.getFromEnv('animationManager'),
        radarBorderContainerDummy = canvas.getContainer('radarBorderContainer'),
        radarBorderContainer,
        canvasGroup = canvas.getContainer('canvasGroup'),
        axisConfig = axis.config,
        radarBorderAttrObj = {
      stroke: canvasConfig.radarBorderColor,
      fill: canvasConfig.radarFillColor,
      'stroke-width': canvasConfig.radarBorderThickness,
      path: []
    },
        i,
        category = axisConfig.tickValues.tickValue,
        min,
        max,
        theta,
        axisScale = axis.getScale(),
        radiusXY,
        radius,
        radBorderDummy = canvas.getGraphicalElement('radarBorder'),
        radarBorder,
        centerX = axisConfig.axisDimention.centerX,
        centerY = axisConfig.axisDimention.centerY;
    radius = (0, _lib.pluckNumber)(axisConfig.radius, 0);
    min = 0;
    max = category ? category.length - 1 : 0;
    canvasConfig.canvasLeft = canvasConfig.canvasLeft || chartConfig.canvasLeft;
    canvasConfig.canvasTop = canvasConfig.canvasTop || chartConfig.canvasTop;
    canvasConfig.canvasWidth = canvasConfig.canvasWidth || chartConfig.canvasWidth;
    canvasConfig.canvasHeight = canvasConfig.canvasHeight || chartConfig.canvasHeight;

    if (canvasConfig.showRadarBorder !== 0) {
      radarBorderAttrObj.path.push('M');

      for (i = min; i <= max; i++) {
        theta = axisScale.getRangeValue(i);
        radiusXY = (0, _polarUtil.polarToCartesian)(radius, theta);
        radiusXY.x += centerX;
        radiusXY.y += centerY;
        radarBorderAttrObj.path.push(radiusXY.x, radiusXY.y, 'L');
      }

      radarBorderAttrObj.path.pop();
      radarBorderAttrObj.path.push('Z');
    }

    radarBorderContainer = animationManager.setAnimation({
      el: radarBorderContainerDummy || 'group',
      attr: {
        name: 'radarBorderContainer'
      },
      container: canvasGroup,
      component: canvas,
      label: 'group'
    });

    if (!radarBorderContainerDummy) {
      canvas.addContainer('radarBorderContainer', radarBorderContainer);
    } // Create/Reuse rabBorder0


    radarBorder = animationManager.setAnimation({
      el: radBorderDummy || 'path',
      attr: radarBorderAttrObj,
      container: radarBorderContainer,
      component: axis,
      label: 'path'
    });

    if (!radBorderDummy) {
      canvas.addGraphicalElement('radarBorder', radarBorder);
    } // axis.config.radarBorder = radarBorder;

  };

  return PolarCanvas;
}(_canvas.default);

var _default = PolarCanvas;
exports["default"] = _default;

/***/ }),

/***/ 1352:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _assertThisInitialized2 = _interopRequireDefault(__webpack_require__(292));

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _componentInterface = __webpack_require__(290);

var _lib = __webpack_require__(274);

var dragstart = function dragstart(dragTracker) {
  return function (oriEvent) {
    var chart = dragTracker.getFromEnv('chart'),
        config = dragTracker.config,
        datasets = chart.config.datasetOrder || chart.getDatasets(),
        coordinate = (0, _lib.getMouseCoordinate)(chart.getFromEnv('chart-container'), oriEvent, chart),
        pointFound,
        hoveredInfo,
        i = datasets.length,
        dataset;

    while (i-- && !pointFound) {
      dataset = datasets[i];

      if (dataset && dataset.getState('visible')) {
        hoveredInfo = dataset._getHoveredPlot && dataset._getHoveredPlot(coordinate.chartX, coordinate.chartY);

        if (hoveredInfo && hoveredInfo.hovered) {
          pointFound = true;
          config.dragStart = true;
          config.hoveredInfo = hoveredInfo;
          config.hoveredDS = dataset;
          dataset.drag('dragstart', oriEvent, hoveredInfo.pointIndex, coordinate);
        }
      }
    }
  };
},
    dragmove = function dragmove(dragTracker) {
  return function (oriEvent) {
    var config = dragTracker.config;
    config.dragStart && config.hoveredDS.drag('dragmove', oriEvent, config.hoveredInfo.pointIndex);
  };
},
    dragend = function dragend(dragTracker) {
  return function (oriEvent) {
    var config = dragTracker.config;
    config.dragStart && config.hoveredDS.drag('dragend', oriEvent, config.hoveredInfo.pointIndex);
    config.dragStart = false;
  };
},
    eventList = ['fc-dragstart', 'fc-dragmove', 'fc-dragend'];
/**
 * This class manages the drag-interaction over draggable charts
 */


var DragTracker = /*#__PURE__*/function (_ComponentInterface) {
  (0, _inheritsLoose2.default)(DragTracker, _ComponentInterface);

  function DragTracker() {
    var _this;

    _this = _ComponentInterface.call(this) || this;
    _this.config.eventCb = {
      'fc-dragstart': dragstart((0, _assertThisInitialized2.default)(_this)),
      'fc-dragmove': dragmove((0, _assertThisInitialized2.default)(_this)),
      'fc-dragend': dragend((0, _assertThisInitialized2.default)(_this))
    };
    return _this;
  }
  /**
   * Function to add events on the canvas for drag
   */


  var _proto = DragTracker.prototype;

  _proto.addEvents = function addEvents() {
    var dragTracker = this,
        allCanvas = dragTracker.getFromEnv('chart').getChildren('canvas'); // eslint-disable-line good-practices/no-single-usage-variable

    dragTracker.removeEvents();
    allCanvas.forEach(function (canvas) {
      eventList.forEach(function (events) {
        canvas.addEventListener(events, dragTracker.config.eventCb[events]);
      });
    });
  }
  /**
   * Function to remove drag events on the canvas
   */
  ;

  _proto.removeEvents = function removeEvents() {
    var dragTracker = this,
        allCanvas = dragTracker.getFromEnv('chart').getChildren('canvas'); // eslint-disable-line good-practices/no-single-usage-variable

    allCanvas.forEach(function (canvas) {
      eventList.forEach(function (events) {
        canvas.removeEventListener(events, dragTracker.config.eventCb[events]);
      });
    });
  }
  /**
   * This method is used to remove all event listeners attached by MouseTracker to the chart.
   */
  ;

  _proto._dispose = function _dispose() {
    this.removeEvents();

    _ComponentInterface.prototype._dispose.call(this);
  };

  return DragTracker;
}(_componentInterface.ComponentInterface);

var _default = DragTracker;
exports["default"] = _default;

/***/ }),

/***/ 1343:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _lib = __webpack_require__(274);

var _safeMax = _interopRequireDefault(__webpack_require__(540));

var _safeMin = _interopRequireDefault(__webpack_require__(539));

var _schedular = __webpack_require__(286);

var _mscolumn2d = _interopRequireDefault(__webpack_require__(695));

var _fetchData = _interopRequireDefault(__webpack_require__(1344));

var _dependencyManager = __webpack_require__(282);

var _editableCharts = __webpack_require__(1345);

/* eslint require-jsdoc: 'error', valid-jsdoc: ["error", { "requireReturn": false }] */
var UNDEF,
    transcoders = (0, _dependencyManager.getDepsByType)('transcoder'),
    UNDERSCORE = _lib.preDefStr.UNDERSCORE,
    BLANK = _lib.BLANKSTRING,
    count = 0,
    updateDataLimit = function updateDataLimit(e) {
  var iapi = e.sender.apiInstance,
      canvas = iapi.getChildren('canvas')[0],
      // eslint-disable-line good-practices/no-single-usage-variable
  vCanvas = canvas.getChildren('vCanvas')[0],
      // eslint-disable-line good-practices/no-single-usage-variable
  iapiConf = iapi.config,
      dataLimit,
      data = e.data,
      endValue = data && data.endValue,
      startValue = data && data.startValue;

  if (endValue > iapiConf.yMax || endValue < iapiConf.yMin || startValue === iapiConf.yMin || startValue === iapiConf.yMax) {
    dataLimit = vCanvas.getDataLimits();
    iapiConf.yMax = dataLimit.max;
    iapiConf.yMin = dataLimit.min;
  }
},

/**
 * sanitise the format given by the user
 * @param {string} str value to be sanitised
 * @return {string} a string in lower case
 */
sanitiseFormatStr = function sanitiseFormatStr(str) {
  return str.toString().toLowerCase();
};
/**
 * API class of dragcolumn inheriting from column class
 */


var DragBase = /*#__PURE__*/function (_MSColumn2D) {
  (0, _inheritsLoose2.default)(DragBase, _MSColumn2D);

  /**
   * constructor to define the ei methods
   */
  function DragBase() {
    var _this;

    _this = _MSColumn2D.call(this) || this; // eslint-disable-next-line good-practices/no-function-dependency

    _this.eiMethods.getDataWithId = function () {
      var chartInstance = this,
          dataObj = chartInstance.apiInstance && chartInstance.apiInstance.getJSONData(),
          returnObj = [[BLANK]],
          datasets = dataObj.dataset,
          catArr = dataObj.categories && dataObj.categories[0] && dataObj.categories[0].category,
          i = datasets && datasets.length || 0,
          vLinePassed = 0,
          setArr,
          catName,
          catObj,
          set,
          DS,
          item,
          dsID,
          id,
          j,
          ln;

      while (i--) {
        DS = datasets[i];

        if (DS) {
          returnObj[0][i + 1] = DS.id || DS.seriesname;
          dsID = DS.id || i + 1;
          set = DS.data;
          ln = set && set.length || 0;

          for (j = 0; j < ln; j += 1) {
            item = j + 1;

            if (!returnObj[item]) {
              catObj = catArr && catArr[j + vLinePassed] || {};

              while (catObj.vline) {
                vLinePassed += 1;
                catObj = catArr[j + vLinePassed] || {};
              }

              catName = catObj.label || catObj.name || BLANK;
              returnObj[item] = [catName];
            }

            setArr = returnObj[item];
            id = set[j].id || item + UNDERSCORE + dsID;
            setArr[i + 1] = [id, Number(set[j].value)];
          }
        }
      }

      return returnObj;
    };
    /**
     * Data of the chart in format user wants or in a 2d array
     * @param {string} [format] in which the data will be returned
     * @return {string | Object} chart data
     */
    // eslint-disable-next-line good-practices/no-function-dependency


    _this.eiMethods.getData = function (format) {
      var chartInstance = this,
          jsonData = chartInstance.apiInstance && chartInstance.apiInstance.getJSONData(),
          returnData,
          datasets = jsonData.dataset,
          len = datasets && datasets.length || 0,
          // eslint-disable-line good-practices/no-single-usage-variable
      i = 0,
          transcoderObjSource,
          sanitisedFormat; // When a format is provided

      if (format) {
        sanitisedFormat = sanitiseFormatStr(format); // no transcoding needed for json

        if (/^json$/ig.test(sanitisedFormat)) {
          returnData = jsonData;
        } else {
          transcoderObjSource = transcoders[sanitisedFormat]();
          returnData = transcoderObjSource.fromJSON(jsonData, chartInstance).data;
        }
      } else {
        returnData = _fetchData.default.call(chartInstance.apiInstance);
        returnData.unshift([BLANK]);

        while (i < len) {
          returnData[0][i + 1] = datasets[i++].seriesname;
        }
      }

      return returnData;
    };
    /**
     * Function to set the upper limit of the chart
     * @param {number} limit new upper limit for the chart
     * @param {Function} callback is the function which gets the return value in its paramter if
     * @return {number} value of the returned function
     */
    // eslint-disable-next-line good-practices/no-function-dependency


    _this.eiMethods.setUpperLimit = function (limit, callback) {
      var iapi = this.apiInstance,
          output;

      if (callback) {
        iapi.addJob("setUpperLimitId" + count++, function () {
          output = iapi.changeUpperLimits(limit); // eslint-disable-line good-practices/no-single-usage-variable

          if (typeof callback === 'function') {
            callback(output);
          }
        }, _schedular.priorityList.postRender);
      } else {
        return iapi.changeUpperLimits(limit);
      }
    };
    /**
     * Function to set the lower limit of the chart
     * @param {number} limit new lower limit for the chart
     * @param {Function} callback is the function which gets the return value in its paramter if
     * @return {number} value of the returned function
     */
    // eslint-disable-next-line good-practices/no-function-dependency


    _this.eiMethods.setLowerLimit = function (limit, callback) {
      var iapi = this.apiInstance,
          output;

      if (callback) {
        iapi.addJob("setLowerLimitId" + count++, function () {
          output = iapi.changeLowerLimits(limit); // eslint-disable-line good-practices/no-single-usage-variable

          if (typeof callback === 'function') {
            callback(output);
          }
        }, _schedular.priorityList.postRender);
      } else {
        return iapi.changeLowerLimits(limit);
      }
    };
    /**
     * Function to get the lower limit of the chart
     * @param {Function} callback is the function which gets the return value in its paramter if
     * @return {number} lower limit value
     */
    // eslint-disable-next-line good-practices/no-function-dependency


    _this.eiMethods.getLowerLimit = function (callback) {
      var iapi = this.apiInstance,
          yAxis = iapi.getChildren('yAxis')[0];

      if (yAxis) {
        if (callback) {
          iapi.addJob("getLowerLimitId" + count++, function () {
            if (typeof callback === 'function') {
              callback(yAxis.config.axisRange.min);
            }
          }, _schedular.priorityList.postRender);
        } else {
          return yAxis.config.axisRange.min;
        }
      }
    };
    /**
     * Function to get the upper limit of the chart
     * @param {Function} callback is the function which gets the return value in its paramter if
     * @return {number} upper limit value
     */
    // eslint-disable-next-line good-practices/no-function-dependency


    _this.eiMethods.getUpperLimit = function (callback) {
      var iapi = this.apiInstance,
          yAxis = iapi.getChildren('yAxis')[0];

      if (yAxis) {
        if (callback) {
          iapi.addJob("getUpperLimitId" + count++, function () {
            if (typeof callback === 'function') {
              callback(yAxis.config.axisRange.max);
            }
          }, _schedular.priorityList.postRender);
        } else {
          return yAxis.config.axisRange.max;
        }
      }
    };

    return _this;
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */


  var _proto = DragBase.prototype;

  _proto.getName = function getName() {
    return 'DragBase';
  };

  _proto.configureAttributes = function configureAttributes(dataObj) {
    _MSColumn2D.prototype.configureAttributes.call(this, dataObj);

    this.getName() !== 'DragNode' && this.getFromEnv('chartInstance').addEventListener('dataplotdragend', updateDataLimit);
  };

  _proto.mouseoutHandler = function mouseoutHandler(e, _lastDatasetIndex, _lastPointIndex) {
    var chart = this,
        datasets = chart.config.datasetOrder || chart.getDatasets(),
        mouseTracker = chart.getChildren('mouseTracker')[0]; // check if the data plot exists. else hide all existing tooltips.

    if (datasets[_lastDatasetIndex] && datasets[_lastDatasetIndex].components.data[_lastPointIndex]) {
      datasets[_lastDatasetIndex]._firePlotEvent(_lib.MOUSEOUT, _lastPointIndex, e);
    } else {
      chart.getFromEnv('toolTipController').hideAll();
    } // delete stored last ds details


    delete mouseTracker._lastDatasetIndex;
    delete mouseTracker._lastPointIndex;
  }
  /**
   * Provides the name of the chart extension
   *
   * @static
   * @return {string} The name of the chart extension
   */
  ;

  DragBase.getName = function getName() {
    return 'DragBase';
  }
  /**
   * Function which determines on which particular data of a dataset the mouse pointer is hovered
   * @param {Object} e A wrapper over the original event
   * @param  {Object} data The Data Object
   */
  ;

  _proto._mouseEvtHandler = function _mouseEvtHandler(e, data) {
    var chart = this,
        mouseTracker = data.mouseTracker,
        datasets = chart.config.datasetOrder || chart.getDatasets(),
        coordinate = (0, _lib.getMouseCoordinate)(chart.getFromEnv('chart-container'), e.originalEvent, chart),
        dataset,
        hoveredInfo,
        pointFound = false,
        i = datasets.length,
        j,
        l,
        derivedEvensInfo,
        _lastDatasetIndex = mouseTracker._lastDatasetIndex,
        _lastPointIndex = mouseTracker._lastPointIndex,
        dragStart,
        eventType;
    _lastPointIndex !== UNDEF && datasets[_lastDatasetIndex] && datasets[_lastDatasetIndex].components.data[_lastPointIndex] && (dragStart = datasets[_lastDatasetIndex].components.data[_lastPointIndex].config.dragStart);

    if (!dragStart) {
      // @todo we have to implement this for charts with more than one canvas like candle stick
      while (i-- && !pointFound) {
        dataset = datasets[i];

        if (dataset && dataset.getState('visible')) {
          hoveredInfo = dataset._getHoveredPlot && dataset._getHoveredPlot(coordinate.chartX, coordinate.chartY);

          if (hoveredInfo && hoveredInfo.hovered) {
            pointFound = true;
            hoveredInfo.datasetIndex = i;
            derivedEvensInfo = mouseTracker.getMouseEvents(e, hoveredInfo.datasetIndex, hoveredInfo.pointIndex);
          }
        }
      }
    } // for drag event


    if (dragStart && _lastDatasetIndex !== UNDEF) {
      eventType = e.type === _lib.MOUSEOUT ? _lib.MOUSEMOVE : e.type;
      datasets[_lastDatasetIndex] && datasets[_lastDatasetIndex]._firePlotEvent && datasets[_lastDatasetIndex]._firePlotEvent(eventType, _lastPointIndex, e);
    } // @todo instead of sending event names, create a event object of that type and send it
    // fire out on last hovered plot


    if (!dragStart && (!pointFound || derivedEvensInfo && derivedEvensInfo.fireOut) && _lastDatasetIndex !== UNDEF) {
      if (datasets[_lastDatasetIndex] && datasets[_lastDatasetIndex]._firePlotEvent) {
        // when mouseout is fired and there aren't any events that need to be fired over the current plot,
        // call mouseouthamndler through settimeout.
        if (derivedEvensInfo && !derivedEvensInfo.events.length) {
          mouseTracker.mouseoutTimer = setTimeout(function () {
            chart.mouseoutHandler(e, _lastDatasetIndex, _lastPointIndex);
          }, 20);
        } else {
          chart.mouseoutHandler(e, _lastDatasetIndex, _lastPointIndex);
          clearTimeout(mouseTracker.mouseoutTimer);
        }
      }
    } // fire remaining events


    if (pointFound) {
      l = derivedEvensInfo.events && derivedEvensInfo.events.length; // Update only when events for current plot are present.
      // Reason: When cursor is present in territory of line/area plot but not directly over it, then
      // the fireOut of current plot was happening instead of the actual last plot.

      if (l) {
        // store the index of the hovered DS and plot
        mouseTracker._lastDatasetIndex = hoveredInfo.datasetIndex;
        _lastPointIndex = mouseTracker._lastPointIndex = hoveredInfo.pointIndex;
      }

      for (j = 0; j < l; j += 1) {
        dataset && dataset._firePlotEvent && dataset._firePlotEvent(derivedEvensInfo.events[j], _lastPointIndex, e);
      }
    }
  }
  /**
   * Configure function calls the parent configure function and adds eventListener to needed children
   * @param {Object} dataObj contains json data of the chart
   */
  ;

  _proto.parseChartAttr = function parseChartAttr(dataObj) {
    _MSColumn2D.prototype.parseChartAttr.call(this, dataObj);

    var chart = this,
        chartAttr = chart.getFromEnv('dataSource').chart,
        chartConfig;
    chartConfig = chart.config;
    chartConfig.formAction = (0, _lib.getValidValue)(chartAttr.formaction);

    if (chartAttr.submitdataasxml === _lib.ZEROSTRING && !chartAttr.formdataformat) {
      chartAttr.formdataformat = transcoders.csv().format;
    }

    chartConfig.formDataFormat = (0, _lib.pluck)(chartAttr.formdataformat, transcoders.xml().format);
    chartConfig.formTarget = (0, _lib.pluck)(chartAttr.formtarget, '_self');
    chartConfig.formMethod = (0, _lib.pluck)(chartAttr.formmethod, 'POST');
    chartConfig.submitFormAsAjax = (0, _lib.pluckNumber)(chartAttr.submitformusingajax, 1);
    chartConfig.restoreBtnTitle = (0, _lib.pluck)(chartAttr.restoretext,
    /**
     * @deprecated since 3.13.0.
     */
    // TODO: REMOVE restorebtntitle parsing after two releases from 3.13.0
    chartAttr.restorebtntitle, 'Restore');
    chartConfig.submitBtnTitle = (0, _lib.pluck)(chartAttr.submittext,
    /**
     * @deprecated since 3.13.0.
     */
    // TODO: REMOVE formbtntitle parsing after two releases from 3.13.0
    chartAttr.formbtntitle, 'Submit'); // Form Button

    chartConfig.showFormBtn = (0, _lib.pluckNumber)(chartAttr.enablesubmit,
    /**
     * @deprecated since 3.13.0.
     */
    // TODO: REMOVE showformbtn parsing after two releases from 3.13.0
    chartAttr.showformbtn, 1) && chartConfig.formAction;
    chartConfig.showRestoreBtn = (0, _lib.pluckNumber)(chartAttr.enablerestore,
    /**
     * @deprecated since 3.13.0.
     */
    // TODO: REMOVE showrestorebtn parsing after two releases from 3.13.0
    chartAttr.showrestorebtn, 1);
    chartConfig.formBtnTitle = (0, _lib.pluck)(chartAttr.formbtntitle, 'Submit');
    chartConfig.formBtnStyle = {
      fontSize: chartConfig.style.outCanfontSize,
      fontFamily: chartConfig.style.outCanfontFamily,
      fontWeight: 'bold'
    };
    chartConfig.restoreBtnWidth = (0, _lib.pluckNumber)(chartAttr.restorebtnwidth, 0);
    chartConfig.allowAxisChange = (0, _lib.pluckNumber)(chartAttr.allowaxischange, 1);

    if (chartAttr.toolbary || chartAttr.toolbarx) {
      chartConfig.spaceHardCoded = true;
    } else {
      delete chartConfig.spaceHardCoded;
    }

    chartConfig.drawTrendRegion = (0, _lib.pluckNumber)(chartAttr.drawcrossline, 0);
  }
  /**
   * Function to store the initial axis value
   * @param {Number} min is minimum data limit
   * @param {Number} max is maximum data limit
   */
  ;

  _proto._storeIntialLimit = function _storeIntialLimit(min, max) {
    this.config.axisInitialLimit = {
      min: min,
      max: max
    };
  }
  /**
   * Over-writing mscartesian createToolBoxMenu function
   */
  ;

  _proto.attachMenuButtons = function attachMenuButtons() {
    _MSColumn2D.prototype.attachMenuButtons.call(this);

    this.addConfigureOptions();
  }
  /**
   * Function for adding menu otions to be shown in the drop-down menu
   */
  ;

  _proto.addConfigureOptions = function addConfigureOptions() {
    var chart = this,
        toolbar = chart.getFromEnv('toolbar'),
        hamburgerMenu = toolbar.getChild("hamburgerMenu-" + toolbar.getId() + "-" + chart.getId() + "-0"),
        // eslint-disable-line good-practices/no-single-usage-variable
    chartConf = chart.config,
        restore,
        submit,
        configureTools = [{
      name: 'Increase Upper Limit',
      handler: function handler() {
        var axisRange = chart.getChildren('yAxis')[0].getLimit();
        chart.changeUpperLimits(axisRange.max + axisRange.tickInterval);
      },
      action: 'click'
    }, {
      name: 'Increase Lower Limit',
      handler: function handler() {
        var axisRange = chart.getChildren('yAxis')[0].getLimit();
        chart.changeLowerLimits(axisRange.min + axisRange.tickInterval);
      },
      action: 'click'
    }, {
      name: 'Decrease Upper Limit',
      handler: function handler() {
        var axisRange = chart.getChildren('yAxis')[0].getLimit();
        chart.changeUpperLimits(axisRange.max - axisRange.tickInterval);
      },
      action: 'click'
    }, {
      name: 'Decrease Lower Limit',
      handler: function handler() {
        var axisRange = chart.getChildren('yAxis')[0].getLimit();
        chart.changeLowerLimits(axisRange.min - axisRange.tickInterval);
      },
      action: 'click'
    }];

    if (chartConf.showFormBtn) {
      submit = {
        name: chartConf.submitBtnTitle,
        handler: function handler() {
          _editableCharts.submitData.call(chart);
        },
        action: 'click'
      };
      configureTools.push(submit);
    }

    if (chartConf.showRestoreBtn) {
      restore = {
        name: chartConf.restoreBtnTitle,
        handler: function handler() {
          chart.restoreData();
        },
        action: 'click'
      };
      configureTools.push(restore);
    }

    if (chartConf.allowAxisChange) {
      hamburgerMenu.appendInMenu(configureTools);
    }
  }
  /**
   * Function to restore all the data to the original json Data
   */
  ;

  _proto.restoreData = function restoreData() {
    var chart = this,
        yAxis = chart.getChildren('yAxis')[0],
        chartAttr = chart.getFromEnv('chart-attrib'),
        axisInitialLimit = chart.config.axisInitialLimit; // eslint-disable-next-line good-practices/no-function-dependency

    chart.iterateComponents(function (child) {
      var data; // eslint-disable-next-line good-practices/no-single-usage-variable

      if (data = child.getChildren('dataset')) {
        data.forEach(function (dataset) {
          dataset.restore();
        });
      }
    });
    yAxis.resetStoredLimits();
    yAxis.setAxisConfig({
      axisMaxValue: chartAttr.yaxismaxvalue,
      axisMinValue: chartAttr.yaxisminvalue
    });
    yAxis.setDataLimit(axisInitialLimit.max, axisInitialLimit.min);
    chart.fireChartInstanceEvent('dataRestored', {});

    chart._manageInteractiveSpace();
  }
  /**
   * Function to change the lowerLimit of the axis using the drop down menu item
   * @param {number} lowerLimit The limit to which lower limit of the axis has to be extended
   * @return {boolean} if axis limit is changed
   */
  ;

  _proto.changeLowerLimits = function changeLowerLimits(lowerLimit) {
    var chart = this,
        yAxis = chart.getChildren('yAxis')[0],
        axisRange = yAxis.getLimit(),
        min = axisRange.min,
        config = chart.config,
        minValue = (0, _safeMin.default)([config.yMin, yAxis.getTrendLineLimits()[0]]),
        // eslint-disable-line good-practices/no-single-usage-variable
    limitchanged = false,
        max = axisRange.max;
    chart.getFromEnv('animationManager').setAnimationState('update');

    if (lowerLimit !== UNDEF && lowerLimit < minValue && lowerLimit !== axisRange.min && config.allowAxisChange) {
      min = lowerLimit;
      limitchanged = true;
    }

    if (limitchanged) {
      yAxis.resetStoredLimits();
      yAxis.setAxisConfig({
        axisMaxValue: max,
        axisMinValue: min,
        showLowerLimit: true
      });
      yAxis.setDataLimit(max, min);

      chart._manageInteractiveSpace();
    }

    return limitchanged;
  }
  /**
   * Function to change the upperLimit of the axis using the drop down menu item
   * @param {number} upperLimit The limit to which upper limit of the axis has to be extended
   * @return {boolean} if axis limit is changed
   */
  ;

  _proto.changeUpperLimits = function changeUpperLimits(upperLimit) {
    var chart = this,
        // components = chart.components,
    yAxis = chart.getChildren('yAxis')[0],
        axisRange = yAxis.getLimit(),
        min = axisRange.min,
        config = chart.config,
        maxValue = (0, _safeMax.default)([config.yMax, yAxis.getTrendLineLimits()[1]]),
        // eslint-disable-line good-practices/no-single-usage-variable
    limitchanged = false,
        max;
    chart.getFromEnv('animationManager').setAnimationState('update');

    if (upperLimit !== UNDEF && upperLimit > maxValue && upperLimit !== axisRange.max && config.allowAxisChange) {
      max = upperLimit;
      limitchanged = true;
    }

    if (limitchanged) {
      yAxis.resetStoredLimits();
      yAxis.setAxisConfig({
        axisMaxValue: max,
        axisMinValue: min,
        showUpperLimit: true
      });
      yAxis.setDataLimit(max, min);

      chart._manageInteractiveSpace();
    }

    return limitchanged;
  }
  /**
   * Function to get the jsonData
   * @return {Object} the jsonData
   */
  ;

  _proto.getJSONData = function getJSONData() {
    var chart = this,
        canvas = chart.getChildren('canvas')[0],
        // eslint-disable-line good-practices/no-single-usage-variable
    vCanvas = canvas.getChildren('vCanvas')[0],
        // eslint-disable-line good-practices/no-single-usage-variable
    rawObj = chart.getFromEnv('dataSource'),
        // eslint-disable-line good-practices/no-single-usage-variable
    groupManager,
        datasetsArr = [],
        dataset,
        datasets,
        dataObj,
        i,
        len,
        jsonObj;
    vCanvas.iterateComponents(function (component) {
      if (component.getType() === 'group') {
        groupManager = component;
      }
    });

    if (groupManager) {
      datasetsArr = groupManager.getJSONData && groupManager.getJSONData();
    } else {
      datasets = chart.getDatasets();
      len = datasets.length;

      for (i = 0; i < len; i++) {
        dataset = datasets[i];
        dataObj = {
          'seriesname': dataset.config.seriesname,
          'data': dataset.getJSONData().data
        };
        datasetsArr.push(dataObj);
      }
    }

    jsonObj = (0, _lib.extend2)({}, rawObj);
    jsonObj.dataset = datasetsArr;
    return jsonObj;
  };

  return DragBase;
}(_mscolumn2d.default);

DragBase.prototype._manageInteractiveSpace = _lib._manageInteractiveSpace;
var _default = DragBase;
exports["default"] = _default;

/***/ }),

/***/ 1345:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports.submitData = submitData;

var _ajax = _interopRequireDefault(__webpack_require__(370));

var _dependencyManager = __webpack_require__(282);

var _lib = __webpack_require__(274);

var _trustedPolicy = _interopRequireDefault(__webpack_require__(299));

/* eslint require-jsdoc: 'error', valid-jsdoc: ["error", { "requireReturn": false }] */
// eslint-disable-next-line
var UNDEF,
    transcoders = (0, _dependencyManager.getDepsByType)('transcoder');
/**
 * Call back function when submit button is pressed.
 */

function submitData() {
  var chart = this,
      // iapi = chart.apiInstance,
  ajaxObj = new _ajax.default(),
      chartConf = chart.config,
      json = transcoders.json(),
      csv = transcoders.csv && transcoders.csv() || 'csv',
      xml = transcoders.xml(),
      url = chartConf.formAction,
      chartInstance = chart.getFromEnv('chartInstance'),
      requestType,
      data,
      paramObj,
      tempSpan,
      formEle;

  if (chartConf.formDataFormat === json.format) {
    requestType = json.format;

    if (chart.getJSONData) {
      data = JSON.stringify(chart.getJSONData());
    }

    if (chart.getCollatedData) {
      data = JSON.stringify(chart.getCollatedData());
    }
  } else if (chartConf.formDataFormat && chartConf.formDataFormat === csv.format) {
    requestType = csv.format;
    data = chart.getCSVString && chart.getCSVString();

    if (data === UNDEF || data === '') {
      if (chart.getJSONData) {
        data = csv.fromJSON(chart.getJSONData()).data;
      }

      if (chart.getCollatedData) {
        data = csv.fromJSON(chart.getCollatedData()).data;
      }
    }
  } else {
    requestType = xml.format;

    if (chart.getCollatedData) {
      data = xml.fromJSON(chart.getCollatedData()).data;
    }

    if (chart.getJSONData) {
      data = xml.fromJSON(chart.getJSONData()).data;
    }
  } // cancel data submit function added in event options

  /**
    * For interative charts like `Select Scatter`, `DragNode`, `Dragable Column2D ` and etc., data
    * points value can be selected for `Scatter Chart` and values can be changed for dragable charts by
    * clicking and dragging the data points whose data point values can be sent to an URL by ajax POST.
    * This is the first event raised when `Submit` button is clicked where the current chart data is
    * about to be sent to the set URL.
    *
    * @event FusionCharts#beforeDataSubmit
    * @group chart-powercharts
    *
    * @param {string} data - Contains the XML string with complete chart data at it's current state.
    *
    */


  chart.fireChartInstanceEvent('beforeDataSubmit', {
    data: data
  }, UNDEF, function () {
    // After the collation is done, we have to submit the data using
    // ajax or form submit method.
    if (!chartConf.submitFormAsAjax) {
      // Create a hidden form with data inside it.
      tempSpan = window.document.createElement('span');
      tempSpan.innerHTML = _trustedPolicy.default.createHTML('<form style="display:none" action="' + url + '" method="' + chartConf.formMethod + '" target="' + chartConf.formTarget + '"> <input type="hidden" name="strXML" value="' + (0, _lib.xssEncode)(data) + '"><input type="hidden" name="dataFormat" value="' + requestType.toUpperCase() + '" /></form>');
      formEle = tempSpan.removeChild(tempSpan.firstChild); // Append the form to body and then submit it.

      window.document.body.appendChild(formEle);
      formEle.submit && formEle.submit(); // cleanup

      formEle.parentNode.removeChild(formEle);
      tempSpan = formEle = null;
    } else {
      // eslint-disable-next-line
      ajaxObj.onError = function (response, wrapper, ajaxData, url) {
        /**
          * For interative charts like `Select Scatter`, `DragNode`, `Dragable Column2D ` and etc.,
          * data points value can be selected for `Scatter Chart` and values can be changed for
          * dragable charts by clicking and dragging the data points whose data point values can be
          * sent to an URL by ajax POST. This event is raised if there is an ajax error in sending
          * the chart XML data.
          *
          * @event FusionCharts#dataSubmitError
          * @group chart-powercharts
          *
          * @param {string} data - Contains the XML string with complete chart data.
          * @param {number} httpStatus - Tells the status code of the ajax POST request
          * @param {string} statusText - Contains the ajax error message.
          * @param {string} url - URL to which the data is sent as ajax POST request.
          * @param {object} xhrObject - XMLHttpRequest object which takes care of sending the XML
          * chart data. In case of error, this object won't be defined.
          */
        chart.fireChartInstanceEvent('dataSubmitError', {
          xhrObject: wrapper.xmlhttp,
          url: url,
          statusText: response,
          httpStatus: wrapper.xmlhttp && wrapper.xmlhttp.status ? wrapper.xmlhttp.status : -1,
          data: data
        }, [chartInstance.id, response, wrapper.xmlhttp && wrapper.xmlhttp.status]);
      }; // eslint-disable-next-line


      ajaxObj.onSuccess = function (response, wrapper, ajaxData, url) {
        /**
          * For interative charts like `Select Scatter`, `DragNode`, `Dragable Column2D ` and etc.,
          * data points value can be selected for `Scatter Chart` and values can be changed for
          * dragable charts by clicking and dragging the data points whose data point values can be
          * sent to an URL by ajax POST. This event is raised when the ajax POST request is
          * successfully completed.
          *
          * @event FusionCharts#dataSubmitted
          * @group chart-powercharts
          *
          * @param {string} data - Contains the XML string with complete chart data.
          * @param {string} reponse - Contains the reponse returned by the web server to which the
          * HTTP POST request was submitted.
          * @param {string} url - URL to which the data is sent as HTTP POST request.
          * @param {object} xhrObject - XMLHttpRequest object which takes care of sending the XML
          * chart data
          */
        chart.fireChartInstanceEvent('dataSubmitted', {
          xhrObject: ajaxObj,
          response: response,
          url: url,
          data: data
        }, [chartInstance.id, response]);
      };

      paramObj = {};
      paramObj['str' + requestType.toUpperCase()] = data;

      if (ajaxObj.open) {
        ajaxObj.abort();
      }

      ajaxObj.post(url, paramObj);
    }
  }, function () {
    /**
      * For interative charts like `Select Scatter`, `DragNode`, `Dragable Column2D ` and etc.,
      * data points value can be selected for `Scatter Chart` and values can be changed for
      * dragable charts by clicking and dragging the data points whose data point values can be
      * sent to an URL by ajax POST. This event is raised when `preventDefault()` method is called
      * from the `eventObject` of FusionCharts#beforeDataSubmit event.
      *
      * @event FusionCharts#dataSubmitCancelled
      * @group chart-powercharts
      *
      * @param {string} data - Contains the XML string with complete chart data.
      * @param {number} httpStatus - Tells the status code of the ajax POST request
      * @param {string} statusText - Contains the ajax error message.
      * @param {string} url - URL to which the data is sent as ajax POST request.
      * @param {object} xhrObject - XMLHttpRequest object which takes care of sending the XML
      * chart data. In case of error, this object won't be defined.
      * @example
      * FusionCharts.addEventListener('beforeDataSubmit', function(eventObject, parameterObject) {
      *  eventObject.preventDefault();
      * }
      */
    chart.fireChartInstanceEvent('dataSubmitCancelled', {
      data: data
    });
  });
}

/***/ }),

/***/ 1314:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _mscartesian = _interopRequireDefault(__webpack_require__(626));

var _logAxis = _interopRequireDefault(__webpack_require__(1315));

var _lib = __webpack_require__(274);

var _equal = _interopRequireDefault(__webpack_require__(421));

var MsLog = /*#__PURE__*/function (_MSCartesian) {
  (0, _inheritsLoose2.default)(MsLog, _MSCartesian);

  function MsLog() {
    var _this;

    _this = _MSCartesian.call(this) || this;

    _this.registerFactory('axis', _logAxis.default, ['canvas']);

    return _this;
  }
  /**
   * Provides the name of the chart extension
   *
   * @static
   * @return {string} The name of the chart extension
   */


  MsLog.getName = function getName() {
    return 'MsLog';
  };

  var _proto = MsLog.prototype;

  _proto._feedAxesRawData = function _feedAxesRawData() {
    var iapi = this,
        dataObj = iapi.getFromEnv('dataSource'),
        chartAttrs = iapi.getFromEnv('chart-attrib'),
        xAxisConf,
        yAxisConf;
    xAxisConf = iapi.getSpecificxAxisConf();
    yAxisConf = iapi.getSpecificyAxisConf();

    if (yAxisConf.base === '1') {
      yAxisConf.base = 10;
      yAxisConf.logBase = 10;
    }

    yAxisConf.minorDivlinecolor = (0, _lib.pluck)(chartAttrs.minordivlinecolor, yAxisConf.divLineColor);
    yAxisConf.minorDivLineThickness = (0, _lib.pluck)(chartAttrs.minordivlinethickness, 1);
    yAxisConf.minorDivLineAlpha = (0, _lib.pluck)(chartAttrs.minordivlinealpha, yAxisConf.divLineAlpha / 2);
    xAxisConf.vtrendlines = dataObj.vtrendlines;
    yAxisConf.trendlines = dataObj.trendlines;
    return {
      yAxisConf: [yAxisConf],
      xAxisConf: [xAxisConf]
    };
  }
  /**
   * Returns x-axis configuration for chart.
   * @return {Object} configurations of x-axis.
   */
  ;

  _proto.getSpecificxAxisConf = function getSpecificxAxisConf() {
    var iapi = this,
        chartAttrs = iapi.getFromEnv('chart-attrib'),
        xAxisConf = iapi.getBasexAxisConf();
    xAxisConf.showZeroPlane = chartAttrs.showvzeroplane;
    xAxisConf.zeroPlaneThickness = chartAttrs.vzeroplanethickness;
    xAxisConf.zeroPlaneAlpha = chartAttrs.vzeroplanealpha;
    xAxisConf.showAxisLine = (0, _lib.pluckNumber)(chartAttrs.showxaxisline, chartAttrs.showaxislines, chartAttrs.drawAxisLines, 0);
    xAxisConf.axisLineColor = (0, _lib.pluck)(chartAttrs.xaxislinecolor, chartAttrs.axislinecolor, '#000000');
    xAxisConf.isReverse = false;
    xAxisConf.showAlternateGridColor = (0, _lib.pluckNumber)(chartAttrs.showalternatevgridcolor, 0);
    xAxisConf.numDivLines = chartAttrs.numvdivlines;
    xAxisConf.maxLabelHeight = chartAttrs.maxlabelheight;
    xAxisConf.axisName = chartAttrs.xaxisname;
    xAxisConf.setAdaptiveMin = chartAttrs.setadaptivexmin;
    xAxisConf.showLimits = chartAttrs.showvlimits;
    xAxisConf.showDivLineValues = (0, _lib.pluckNumber)(chartAttrs.showvdivlinevalues, chartAttrs.showvdivlinevalues);
    return xAxisConf;
  }
  /**
   * Returns y-axis configuration for chart.
   * @return {Object} configurations of y-axis.
   */
  ;

  _proto.getSpecificyAxisConf = function getSpecificyAxisConf() {
    var iapi = this,
        chartAttrs = iapi.getFromEnv('chart-attrib'),
        palleteString = iapi.config.is3D ? _lib.chartPaletteStr.chart3D : _lib.chartPaletteStr.chart2D,
        invertYAxis = !!(0, _lib.pluckNumber)(chartAttrs.invertyaxis, 0),
        // eslint-disable-line good-practices/no-single-usage-variable
    colorM = iapi.getFromEnv('color-manager'),
        outCanfontSizeWithUnit = (0, _lib.pluckFontSizeMaintainUnit)(chartAttrs.outcnvbasefontsize, chartAttrs.basefontsize, 10);
    return {
      isVertical: true,
      isReverse: !invertYAxis,
      isOpposit: (0, _equal.default)(chartAttrs.yaxisposition, 'right'),
      outCanfontFamily: (0, _lib.pluck)(chartAttrs.outcnvbasefont, chartAttrs.basefont, 'Verdana,sans'),
      outCanfontSize: this.computeFontSize(outCanfontSizeWithUnit),
      outCanfontSizeWithUnit: outCanfontSizeWithUnit,
      outCancolor: (0, _lib.pluck)(chartAttrs.outcnvbasefontcolor, chartAttrs.basefontcolor, colorM.getColor(palleteString.baseFontColor)).replace(/^#? ([a-f0-9]+)/ig, '#$1'),
      axisNamePadding: chartAttrs.yaxisnamepadding,
      axisValuePadding: chartAttrs.yaxisvaluespadding,
      axisNameFont: chartAttrs.yaxisnamefont,
      axisNameFontSize: this.computeFontSize(chartAttrs.yaxisnamefontsize),
      axisNameFontSizeWithUnit: chartAttrs.yaxisnamefontsize,
      axisNameFontColor: chartAttrs.yaxisnamefontcolor,
      axisNameFontBold: chartAttrs.yaxisnamefontbold,
      axisNameFontItalic: chartAttrs.yaxisnamefontitalic,
      axisNameBgColor: chartAttrs.yaxisnamebgcolor,
      axisNameBorderColor: chartAttrs.yaxisnamebordercolor,
      axisNameAlpha: chartAttrs.yaxisnamealpha,
      axisNameFontAlpha: chartAttrs.yaxisnamefontalpha,
      axisNameBgAlpha: chartAttrs.yaxisnamebgalpha,
      axisNameBorderAlpha: chartAttrs.yaxisnameborderalpha,
      axisNameBorderPadding: chartAttrs.yaxisnameborderpadding,
      axisNameBorderRadius: chartAttrs.yaxisnameborderradius,
      axisNameBorderThickness: chartAttrs.yaxisnameborderthickness,
      axisNameBorderDashed: chartAttrs.yaxisnameborderdashed,
      axisNameBorderDashLen: chartAttrs.yaxisnameborderdashlen,
      axisNameBorderDashGap: chartAttrs.yaxisnameborderdashgap,
      axisNameWidth: chartAttrs.yaxisnamewidth,
      useEllipsesWhenOverflow: chartAttrs.useellipseswhenoverflow,
      rotateAxisName: (0, _lib.pluckNumber)(chartAttrs.rotateyaxisname, 1),
      axisName: chartAttrs.yaxisname,
      divLineColor: (0, _lib.pluck)(chartAttrs.divlinecolor, colorM.getColor(palleteString.divLineColor)),
      divLineAlpha: (0, _lib.pluck)(chartAttrs.divlinealpha, colorM.getColor('divLineAlpha')),
      divLineThickness: (0, _lib.pluckNumber)(chartAttrs.divlinethickness, 2),
      divLineIsDashed: Boolean((0, _lib.pluckNumber)(chartAttrs.divlinedashed, chartAttrs.divlineisdashed, 0)),
      divLineDashLen: (0, _lib.pluckNumber)(chartAttrs.divlinedashlen, 4),
      divLineDashGap: (0, _lib.pluckNumber)(chartAttrs.divlinedashgap, 2),
      showAlternateGridColor: (0, _lib.pluckNumber)(chartAttrs.showalternatehgridcolor, 1),
      alternateGridColor: (0, _lib.pluck)(chartAttrs.alternatehgridcolor, colorM.getColor('altHGridColor')),
      alternateGridAlpha: (0, _lib.pluck)(chartAttrs.alternatehgridalpha, colorM.getColor('altHGridAlpha')),
      numDivLines: chartAttrs.numdivlines,
      axisMinValue: chartAttrs.yaxisminvalue,
      axisMaxValue: chartAttrs.yaxismaxvalue,
      setAdaptiveMin: chartAttrs.setadaptiveymin,
      adjustDiv: chartAttrs.adjustdiv,
      labelStep: chartAttrs.yaxisvaluesstep,
      showAxisValues: (0, _lib.pluckNumber)(chartAttrs.showyaxisvalues, chartAttrs.showyaxisvalue),
      showLimits: (0, _lib.pluckNumber)(chartAttrs.showyaxislimits, chartAttrs.showlimits, iapi.showLimits),
      showDivLineValues: (0, _lib.pluckNumber)(chartAttrs.showdivlinevalues, chartAttrs.showdivlinevalue),
      showZeroPlane: chartAttrs.showzeroplane,
      zeroPlaneColor: chartAttrs.zeroplanecolor,
      zeroPlaneThickness: chartAttrs.zeroplanethickness,
      zeroPlaneAlpha: chartAttrs.zeroplanealpha,
      showZeroPlaneValue: chartAttrs.showzeroplanevalue,
      trendlineColor: chartAttrs.trendlinecolor,
      trendlineToolText: chartAttrs.trendlinetooltext,
      trendlineThickness: chartAttrs.trendlinethickness,
      trendlineAlpha: chartAttrs.trendlinealpha,
      showTrendlinesOnTop: chartAttrs.showtrendlinesontop,
      showAxisLine: (0, _lib.pluckNumber)(chartAttrs.showyaxisline, chartAttrs.showaxislines, chartAttrs.drawAxisLines, 0),
      axisLineThickness: (0, _lib.pluckNumber)(chartAttrs.yaxislinethickness, chartAttrs.axislinethickness, 1),
      axisLineAlpha: (0, _lib.pluckNumber)(chartAttrs.yaxislinealpha, chartAttrs.axislinealpha, 100),
      base: chartAttrs.base,
      logBase: chartAttrs.logbase,
      axisLineColor: (0, _lib.pluck)(chartAttrs.yaxislinecolor, chartAttrs.axislinecolor, '#000000'),
      showMinorDivLineValues: (0, _lib.pluckNumber)(chartAttrs.showminordivlinevalues, 0),
      numMinorDivLines: chartAttrs.numminordivlines,
      labelFont: chartAttrs.yaxisvaluefont,
      labelFontSize: this.computeFontSize(chartAttrs.yaxisvaluefontsize),
      labelFontSizeWithUnit: chartAttrs.yaxisvaluefontsize,
      labelFontColor: chartAttrs.yaxisvaluefontcolor,
      labelAlpha: chartAttrs.yaxisvaluealpha,
      labelFontBold: chartAttrs.yaxisvaluefontbold,
      labelFontItalic: chartAttrs.yaxisvaluefontitalic,
      labelBdrColor: chartAttrs.yaxisvaluebordercolor,
      labelBdrAlpha: chartAttrs.yaxisvalueborderalpha,
      labelBgAlpha: chartAttrs.yaxisvaluebgalpha,
      labelLink: chartAttrs.yaxisvaluelink,
      labelBgColor: chartAttrs.yaxisvaluebgcolor,
      labelBdrThickness: chartAttrs.yaxisvalueborderthickness,
      labelBdrPadding: chartAttrs.yaxisvalueborderpadding,
      labelBdrRadius: chartAttrs.yaxisvalueborderradius,
      labelBdrDashed: chartAttrs.yaxisvalueborderdashed,
      labelBdrDashLen: chartAttrs.yaxisvalueborderdashlen,
      labelBdrDashGap: chartAttrs.yaxisvalueborderdashgap
    };
  };

  return MsLog;
}(_mscartesian.default);

var _default = MsLog;
exports["default"] = _default;

/***/ }),

/***/ 1419:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _assertThisInitialized2 = _interopRequireDefault(__webpack_require__(292));

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _lib = __webpack_require__(274);

var _extent = _interopRequireDefault(__webpack_require__(538));

var _mscolumn2d = _interopRequireDefault(__webpack_require__(695));

var _scrollApis = __webpack_require__(690);

var _boxandwhisker = _interopRequireDefault(__webpack_require__(1420));

var _boxandwhiskerDataset = _interopRequireDefault(__webpack_require__(1424));

var _boxandwhiskerMultiseries = _interopRequireDefault(__webpack_require__(1426));

/* eslint require-jsdoc: 'error', valid-jsdoc: ["error", { "requireReturn": false }] */
_lib.setAttribDefs && (0, _lib.setAttribDefs)({
  whiskerslimitswidthratio: {
    type: _lib.attrTypeNum,
    pAttr: 'whiskerslimitswidthratio'
  },
  outliersupperrangeratio: {
    type: _lib.attrTypeNum,
    pAttr: 'outliersupperrangeratio'
  },
  outlierslowerrangeratio: {
    type: _lib.attrTypeNum,
    pAttr: 'outlierslowerrangeratio'
  },
  showalloutliers: {
    type: _lib.attrTypeNum,
    pAttr: 'showalloutliers'
  },
  showmean: {
    type: _lib.attrTypeNum,
    pAttr: 'showmean'
  },
  showsd: {
    type: _lib.attrTypeNum,
    pAttr: 'showsd'
  },
  showmd: {
    type: _lib.attrTypeNum,
    pAttr: 'showmd'
  },
  showqd: {
    type: _lib.attrTypeNum,
    pAttr: 'showqd'
  },
  showminvalues: {
    type: _lib.attrTypeNum,
    pAttr: 'showminvalues'
  },
  showmaxvalues: {
    type: _lib.attrTypeNum,
    pAttr: 'showmaxvalues'
  },
  showq1values: {
    type: _lib.attrTypeNum,
    pAttr: 'showq1values'
  },
  showq3values: {
    type: _lib.attrTypeNum,
    pAttr: 'showq3values'
  },
  showmedianvalues: {
    type: _lib.attrTypeNum,
    pAttr: 'showmedianvalues'
  }
});
var UNDEF,
    POLYGON = _lib.preDefStr.POLYGON,
    COLOR_000000 = _lib.preDefStr.colors.c000000,
    BOXANDWHISKER_2D = 'boxandwhisker2d',
    ABOVE = 'above',
    COLON_STR = ': ';
/**
 * class for Marimekko chartAPI
 */

var BoxAndWhisker2D = /*#__PURE__*/function (_MSColumn2D) {
  (0, _inheritsLoose2.default)(BoxAndWhisker2D, _MSColumn2D);

  /**
   * Provides the name of the chart extension
   *
   * @static
   * @return {string} The name of the chart extension
   */
  BoxAndWhisker2D.getName = function getName() {
    return 'BoxAndWhisker2D';
  }
  /**
   * Provides the name of the chart
   * @return {string} The name of the chart extension
   */
  ;

  var _proto = BoxAndWhisker2D.prototype;

  _proto.getName = function getName() {
    return 'BoxAndWhisker2D';
  }
  /**
   * Function to state if inputOptions are to be used for this charts
   * @return {Array} value
   */
  ;

  BoxAndWhisker2D.includeInputOptions = function includeInputOptions() {
    return ['SwipeGesture'];
  }
  /**
   * Constructor funtion for Marimekko chartAPI
   */
  ;

  function BoxAndWhisker2D() {
    var _this;

    _this = _MSColumn2D.call(this) || this;
    var iapi = (0, _assertThisInitialized2.default)(_this);
    iapi.maxColWidth = +Infinity;
    iapi.useErrorAnimation = 1;
    iapi.avoidCrispError = 0;
    iapi.plotSpacePercent = 20;
    iapi.useplotgradientcolor = 1;
    iapi.fireGroupEvent = true;
    iapi.hasScroll = true;
    iapi.eiMethods.scrollTo = _scrollApis.scrollTo;

    _this.registerFactory('dataset', _boxandwhiskerDataset.default, ['vCanvas']);

    return _this;
  }
  /**
   * Set default chart configuration
   */


  _proto.__setDefaultConfig = function __setDefaultConfig() {
    _MSColumn2D.prototype.__setDefaultConfig.call(this);

    var config = this.config;
    config.avgScrollPointWidth = 40;
    config.decimals = 2;
    config.defaultDatasetType = BOXANDWHISKER_2D;
    config.showplotborder = 1;
    config.plotborderdashlen = 5;
    config.plotborderdashgap = 4;
    config.plotfillalpha = _lib.HUNDREDSTRING;
    config.useroundedges = 0;
    config.plotborderthickness = 1;
    config.showvalues = 1;
    config.valuepadding = 2;
    config.decimals = 2;
    config.showtooltip = 1;
    config.maxcolwidth = 50;
    config.rotatevalues = 0;
    config.use3dlighting = 1;
    config.whiskerslimitswidthratio = 40;
    config.outliersupperrangeratio = 0;
    config.outlierslowerrangeratio = 0;
    config.showalloutliers = 0;
    config.showmean = 0;
    config.showsd = 0;
    config.showmd = 0;
    config.showqd = 0;
    config.showminvalues = 1;
    config.showmaxvalues = 1;
    config.showq1values = 0;
    config.showq3values = 0;
    config.showmedianvalues = 1;
    config.tooltipsepchar = COLON_STR; // default attributes of line

    config.anchorborderthickness = 1;
    config.anchorimageurl = UNDEF;
    config.anchorimagepadding = 1;
    config.anchorsides = 1;
    config.anchoralpha = UNDEF;
    config.anchorbgalpha = _lib.HUNDREDSTRING;
    config.anchorimagealpha = _lib.HUNDREDSTRING;
    config.anchorimagescale = 100;
    config.anchorstartangle = 90;
    config.anchorshadow = 0;
    config.anchorbgcolor = UNDEF;
    config.anchorbordercolor = UNDEF;
    config.anchorradius = 3;
    config.linedashlen = 5;
    config.linedashgap = 4;
    config.linedashed = UNDEF;
    config.linealpha = _lib.HUNDREDSTRING;
    config.linethickness = 2;
    config.drawfullareaborder = 1;
    config.connectnulldata = 0;
  }
  /**
   * function to create component and configure and also configure the chart
   * It creates components which are depend on data and configure them and also configure chart
   * It calls helper function namely, configure
   * @param  {Object} dataObj contains json data of the chart
   */
  ;

  _proto.configureAttributes = function configureAttributes(dataObj) {
    _MSColumn2D.prototype.configureAttributes.call(this, dataObj);

    _scrollApis.configurer.call(this, dataObj);
  }
  /**
   * Sets xAxis scale visible region
   */
  ;

  _proto._setAxisScale = function _setAxisScale() {
    _scrollApis.setAxisScale.call(this, BOXANDWHISKER_2D);
  }
  /**
   * Reset view port
   */
  ;

  _proto._resetViewPortConfig = function _resetViewPortConfig() {
    _scrollApis.resetViewPortConfig.call(this);
  }
  /**
   * Function to return the custom json data for the mean, meadian, etc (line dataset) of boxAndWhisker
   * @return {Object} The custom JSON Data
   */
  ;

  _proto._getLineJSONdata = function _getLineJSONdata() {
    var iapi = this,
        bwCalc = iapi.getChildren('BoxAndWhiskerStatisticalCalc')[0],
        jsonData = iapi.getFromEnv('dataSource'),
        chartAttrs = jsonData.chart,
        datasets = jsonData.dataset,
        len = datasets.length,
        // eslint-disable-line good-practices/no-single-usage-variable
    showMean,
        dataset,
        data,
        dataLen,
        setData,
        derivedDS = [],
        currDerivedDS,
        requiredSubDs = [],
        derivedDataValue = [],
        currDerivedDataVal,
        subDSLen,
        currSubDS,
        showSD,
        showQD,
        showMD,
        outliers,
        outliersArr,
        valueMin,
        valueMax,
        value,
        meanValue,
        sdValue,
        mdValue,
        qdValue,
        fn = function fn(val) {
      value = Number(val);

      var _ref = bwCalc.values ? (0, _extent.default)(bwCalc.values) : [setData.min, setData.max];

      valueMin = _ref[0];
      valueMax = _ref[1];
      (value < valueMin || value > valueMax) && outliersArr.push({
        showvalue: setData.showoutliervalue,
        valueposition: setData.outliervalueposition,
        value: value,
        index: j,
        anchorbgcolor: setData.outliericoncolor,
        anchorbordercolor: setData.outliericonbordercolor,
        anchorradius: setData.outliericonradius,
        anchoralpha: setData.outliericonalpha,
        anchorbgalpha: setData.outliericonalpha,
        anchorsides: setData.outliericonsides,
        dip: setData.outliericonshape
      });
    },
        j,
        k,
        i; // Deciding for which which all datasets we need which all sub-datasets


    for (i = 0; i < len; i++) {
      dataset = datasets[i];
      currSubDS = requiredSubDs[i] = {};
      currDerivedDataVal = derivedDataValue[i] = {
        showMean: {
          seriesname: 'Mean',
          valueposition: (0, _lib.pluck)(dataset.meanvalueposition, chartAttrs.meanvalueposition, ABOVE),
          showvalues: (0, _lib.pluckNumber)(dataset.showmeanvalues, chartAttrs.showmeanvalues, 0),
          anchorbgcolor: (0, _lib.pluck)(dataset.meaniconcolor, chartAttrs.meaniconcolor, COLOR_000000),
          anchorbordercolor: (0, _lib.pluck)(dataset.meaniconbordercolor, chartAttrs.meaniconbordercolor, COLOR_000000),
          anchorradius: (0, _lib.pluckNumber)(dataset.meaniconradius, chartAttrs.meaniconradius, 5),
          anchoralpha: (0, _lib.pluck)(dataset.alpha, dataset.meaniconalpha, chartAttrs.meaniconalpha),
          linethickness: (0, _lib.pluck)(dataset.linethickness, chartAttrs.linethickness, 1),
          anchorsides: (0, _lib.pluck)(dataset.meaniconsides, chartAttrs.meaniconsides, 3),
          showline: !(0, _lib.pluckNumber)(dataset.drawmeanconnector, chartAttrs.drawmeanconnector),
          dip: (0, _lib.pluck)(dataset.meaniconshape, chartAttrs.meaniconshape, POLYGON),
          color: (0, _lib.pluck)(dataset.meaniconcolor, chartAttrs.meaniconcolor, COLOR_000000),
          data: []
        },
        showSD: {
          seriesname: 'SD',
          valueposition: (0, _lib.pluck)(dataset.sdvalueposition, chartAttrs.sdvalueposition, ABOVE),
          showvalues: (0, _lib.pluckNumber)(dataset.showsdvalues, chartAttrs.showsdvalues, 0),
          anchorbgcolor: (0, _lib.pluck)(dataset.sdiconcolor, chartAttrs.sdiconcolor, COLOR_000000),
          anchorbordercolor: (0, _lib.pluck)(dataset.sdiconbordercolor, chartAttrs.sdiconbordercolor, COLOR_000000),
          anchorradius: (0, _lib.pluckNumber)(dataset.sdiconradius, chartAttrs.sdiconradius, 5),
          anchoralpha: (0, _lib.pluck)(dataset.alpha, dataset.sdiconalpha, chartAttrs.sdiconalpha),
          anchorbgalpha: (0, _lib.pluck)(dataset.sdiconalpha, chartAttrs.sdiconalpha, 100),
          linethickness: (0, _lib.pluck)(dataset.linethickness, chartAttrs.linethickness, 1),
          anchorsides: (0, _lib.pluck)(dataset.sdiconsides, chartAttrs.sdiconsides, 3),
          showline: !(0, _lib.pluckNumber)(dataset.drawsdconnector, chartAttrs.drawsdconnector),
          dip: (0, _lib.pluck)(dataset.sdiconshape, chartAttrs.sdiconshape, POLYGON),
          color: (0, _lib.pluck)(dataset.sdiconcolor, chartAttrs.sdiconcolor, COLOR_000000),
          data: []
        },
        showQD: {
          seriesname: 'QD',
          valueposition: (0, _lib.pluck)(dataset.qdvalueposition, chartAttrs.qdvalueposition, ABOVE),
          showvalues: (0, _lib.pluckNumber)(dataset.showqdvalues, chartAttrs.showqdvalues, 0),
          anchorbgcolor: (0, _lib.pluck)(dataset.qdiconcolor, chartAttrs.qdiconcolor, COLOR_000000),
          anchorbordercolor: (0, _lib.pluck)(dataset.qdiconbordercolor, chartAttrs.qdiconbordercolor, COLOR_000000),
          anchorradius: (0, _lib.pluckNumber)(dataset.qdiconradius, chartAttrs.qdiconradius, 5),
          anchoralpha: (0, _lib.pluck)(dataset.alpha, dataset.qdiconalpha, chartAttrs.qdiconalpha),
          anchorbgalpha: (0, _lib.pluck)(dataset.qdiconalpha, chartAttrs.qdiconalpha, 100),
          linethickness: (0, _lib.pluck)(dataset.linethickness, chartAttrs.linethickness, 1),
          anchorsides: (0, _lib.pluck)(dataset.qdiconsides, chartAttrs.qdiconsides, 3),
          showline: !(0, _lib.pluckNumber)(dataset.drawqdconnector, chartAttrs.drawqdconnector),
          dip: (0, _lib.pluck)(dataset.qdiconshape, chartAttrs.qdiconshape, POLYGON),
          color: (0, _lib.pluck)(dataset.qdiconcolor, chartAttrs.qdiconcolor, COLOR_000000),
          data: []
        },
        showMD: {
          seriesname: 'MD',
          valueposition: (0, _lib.pluck)(dataset.mdvalueposition, chartAttrs.mdvalueposition, ABOVE),
          showvalues: (0, _lib.pluckNumber)(dataset.showmdvalues, chartAttrs.showmdvalues, 0),
          anchorbgcolor: (0, _lib.pluck)(dataset.mdiconcolor, chartAttrs.mdiconcolor, COLOR_000000),
          anchorbordercolor: (0, _lib.pluck)(dataset.mdiconbordercolor, chartAttrs.mdiconbordercolor, COLOR_000000),
          anchorradius: (0, _lib.pluckNumber)(dataset.mdiconradius, chartAttrs.mdiconradius, 5),
          anchoralpha: (0, _lib.pluck)(dataset.alpha, dataset.mdiconalpha, chartAttrs.mdiconalpha),
          anchorbgalpha: (0, _lib.pluck)(dataset.mdiconalpha, chartAttrs.mdiconalpha, 100),
          linethickness: (0, _lib.pluck)(dataset.linethickness, chartAttrs.linethickness, 1),
          anchorsides: (0, _lib.pluck)(dataset.mdiconsides, chartAttrs.mdiconsides, 3),
          showline: !(0, _lib.pluckNumber)(dataset.drawmdconnector, chartAttrs.drawmdconnector),
          dip: (0, _lib.pluck)(dataset.mdiconshape, chartAttrs.mdiconshape, POLYGON),
          color: (0, _lib.pluck)(dataset.mdiconcolor, chartAttrs.mdiconcolor, COLOR_000000),
          data: []
        },
        outliers: {
          seriesname: 'Outliers',
          valueposition: (0, _lib.pluck)(dataset.outliervalueposition, chartAttrs.outliervalueposition, ABOVE),
          showvalues: (0, _lib.pluckNumber)(dataset.showoutliervalues, chartAttrs.showoutliervalues, 0),
          anchorbgcolor: (0, _lib.pluck)(dataset.outliericoncolor, chartAttrs.outliericoncolor, COLOR_000000),
          anchorbordercolor: (0, _lib.pluck)(dataset.outliericonbordercolor, chartAttrs.outliericonbordercolor, COLOR_000000),
          anchorradius: (0, _lib.pluckNumber)(dataset.outliericonradius, chartAttrs.outliericonradius, 5),
          anchoralpha: (0, _lib.pluck)(dataset.alpha, dataset.outliericonalpha, chartAttrs.outliericonalpha),
          includeinlegend: dataset.seriesname ? 1 : 0,
          anchorbgalpha: (0, _lib.pluck)(dataset.outliericonalpha, chartAttrs.outliericonalpha, 100),
          linethickness: (0, _lib.pluck)(dataset.linethickness, chartAttrs.linethickness, 1),
          anchorsides: (0, _lib.pluck)(dataset.outliericonsides, chartAttrs.outliericonsides, 3),
          showline: !(0, _lib.pluckNumber)(dataset.drawoutliersconnector, chartAttrs.drawoutliersconnector),
          color: (0, _lib.pluck)(dataset.outliericoncolor, chartAttrs.outliericoncolor, COLOR_000000),
          dip: (0, _lib.pluck)(dataset.outliericonshape, chartAttrs.outliericonshape, POLYGON),
          data: []
        }
      };
      showMean = (0, _lib.pluckNumber)(dataset.showmean, chartAttrs.showmean, 0);
      showSD = (0, _lib.pluckNumber)(dataset.showsd, chartAttrs.showsd, 0);
      showQD = (0, _lib.pluckNumber)(dataset.showqd, chartAttrs.showqd, 0);
      showMD = (0, _lib.pluckNumber)(dataset.showmd, chartAttrs.showmd, 0);
      data = dataset.data;
      dataLen = data && data.length || 0;

      for (j = 0; j < dataLen; j++) {
        setData = data[j];

        if (setData.min && setData.max && setData.q1 && setData.q3 && setData.median) {
          meanValue = setData.mean;
          sdValue = setData.sd;
          mdValue = setData.md;
          qdValue = setData.qd;
        } else {
          bwCalc.setArray(setData.value);
          bwCalc.getQuartiles();
          meanValue = bwCalc.getMean();
          sdValue = bwCalc.getSD();
          qdValue = bwCalc.getQD();
          mdValue = bwCalc.getMD();
        }

        outliers = setData.outliers; // Checking if at all mean, sd, etc datasets are required

        showMean = currSubDS.showMean = currSubDS.showMean || (0, _lib.pluckNumber)(setData.showmean, showMean);
        showSD = currSubDS.showSD = currSubDS.showSD || (0, _lib.pluckNumber)(setData.showsd, showSD);
        showQD = currSubDS.showQD = currSubDS.showQD || (0, _lib.pluckNumber)(setData.showqd, showQD);
        showMD = currSubDS.showMD = currSubDS.showMD || (0, _lib.pluckNumber)(setData.showmd, showMD); // Storing the value of mean, sd as the same key of the previous check for ease of use

        currDerivedDataVal.showMean.data.push({
          showvalue: setData.showmeanvalue,
          valueposition: setData.meanvalueposition,
          value: showMean && (meanValue || UNDEF),
          anchorbgcolor: setData.meaniconcolor,
          anchorbordercolor: setData.meaniconbordercolor,
          anchorradius: setData.meaniconradius,
          anchoralpha: setData.meaniconalpha,
          anchorbgalpha: setData.meaniconalpha,
          anchorsides: setData.meaniconsides,
          dip: setData.meaniconshape
        });
        currDerivedDataVal.showSD.data.push({
          showvalue: setData.showsdvalue,
          valueposition: setData.sdvalueposition,
          value: showSD && (sdValue || UNDEF),
          anchorbgcolor: setData.sdiconcolor,
          anchorbordercolor: setData.sdiconbordercolor,
          anchorradius: setData.sdiconradius,
          anchoralpha: setData.sdiconalpha,
          anchorbgalpha: setData.sdiconalpha,
          anchorsides: setData.sdiconsides,
          dip: setData.sdiconshape
        });
        currDerivedDataVal.showQD.data.push({
          showvalue: setData.showqdvalue,
          valueposition: setData.qdvalueposition,
          value: showQD && (qdValue || UNDEF),
          anchorbgcolor: setData.qdiconcolor,
          anchorbordercolor: setData.qdiconbordercolor,
          anchorradius: setData.qdiconradius,
          anchoralpha: setData.qdiconalpha,
          anchorbgalpha: setData.qdiconalpha,
          anchorsides: setData.qdiconsides,
          dip: setData.qdiconshape
        });
        currDerivedDataVal.showMD.data.push({
          showvalue: setData.showmdvalue,
          valueposition: setData.mdvalueposition,
          value: showMD && (mdValue || UNDEF),
          anchorbgcolor: setData.mdiconcolor,
          anchorbordercolor: setData.mdiconbordercolor,
          anchorradius: setData.mdiconradius,
          anchoralpha: setData.mdiconalpha,
          anchorbgalpha: setData.mdiconalpha,
          anchorsides: setData.mdiconsides,
          dip: setData.mdiconshape
        });

        if (outliers) {
          outliersArr = currDerivedDataVal.outliers.data;
          outliers.split(_lib.COMMA).forEach(fn);
          currSubDS.outliers = true;
        }
      }
    } // Creating the subDataset as per their requirements


    subDSLen = requiredSubDs.length; // eslint-disable-line good-practices/no-single-usage-variable

    for (k = 0; k < subDSLen; k++) {
      currSubDS = requiredSubDs[k];
      currDerivedDS = derivedDS[k] = [];

      for (i in currSubDS) {
        currSubDS[i] && currDerivedDS.push(derivedDataValue[k][i]);
      }
    }

    return derivedDS;
  }
  /**
   * This method return the dataset definations for this charts
   * @return {Object} return column dataset
   */
  ;

  _proto.getDSdef = function getDSdef() {
    return _boxandwhisker.default;
  }
  /**
   * This method return the dataset-group definations for this charts
   * @return {Object} Multiseries column group definition
   */
  ;

  _proto.getDSGroupdef = function getDSGroupdef() {
    return _boxandwhiskerMultiseries.default;
  };

  return BoxAndWhisker2D;
}(_mscolumn2d.default);

var _default = BoxAndWhisker2D;
exports["default"] = _default;

/***/ }),

/***/ 1406:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _lib = __webpack_require__(274);

var _mscartesian = _interopRequireDefault(__webpack_require__(626));

var _vcanvas = _interopRequireDefault(__webpack_require__(590));

var _candlestickDataset = _interopRequireDefault(__webpack_require__(1407));

var _candlestickAxis = _interopRequireDefault(__webpack_require__(1417));

var _candlestick = __webpack_require__(1408);

var _equal = _interopRequireDefault(__webpack_require__(421));

/* eslint require-jsdoc: 'error', valid-jsdoc: ["error", { "requireReturn": false }] */
var MOUSEOUT = 'fc-mouseout',
    CANDLESTICK = 'candlestick',
    padding = 6;

var altHGridColorStr = _lib.preDefStr.altHGridColorStr,
    altHGridAlphaStr = _lib.preDefStr.altHGridAlphaStr,
    math = Math,
    mathMax = math.max,
    mathRound = math.round,
    POSITION_BOTTOM = _lib.preDefStr.POSITION_BOTTOM,
    divLineAlpha3DStr = _lib.preDefStr.divLineAlpha3DStr,
    defaultFontStr = _lib.preDefStr.defaultFontStr,
    divLineAlphaStr = _lib.preDefStr.divLineAlphaStr,
    altVGridColorStr = _lib.preDefStr.altVGridColorStr,
    altVGridAlphaStr = _lib.preDefStr.altVGridAlphaStr,
    colorStrings = _lib.preDefStr.colors,
    COLOR_000000 = colorStrings.c000000,
    chartPaletteStr = {
  chart2D: {
    bgColor: 'bgColor',
    bgAlpha: 'bgAlpha',
    bgAngle: 'bgAngle',
    bgRatio: 'bgRatio',
    canvasBgColor: 'canvasBgColor',
    canvasBaseColor: 'canvasBaseColor',
    divLineColor: 'divLineColor',
    legendBgColor: 'legendBgColor',
    legendBorderColor: 'legendBorderColor',
    toolTipbgColor: 'toolTipbgColor',
    toolTipBorderColor: 'toolTipBorderColor',
    baseFontColor: 'baseFontColor',
    anchorBgColor: 'anchorBgColor'
  },
  chart3D: {
    bgColor: 'bgColor3D',
    bgAlpha: 'bgAlpha3D',
    bgAngle: 'bgAngle3D',
    bgRatio: 'bgRatio3D',
    canvasBgColor: 'canvasBgColor3D',
    canvasBaseColor: 'canvasBaseColor3D',
    divLineColor: 'divLineColor3D',
    divLineAlpha: divLineAlpha3DStr,
    legendBgColor: 'legendBgColor3D',
    legendBorderColor: 'legendBorderColor3D',
    toolTipbgColor: 'toolTipbgColor3D',
    toolTipBorderColor: 'toolTipBorderColor3D',
    baseFontColor: 'baseFontColor3D',
    anchorBgColor: 'anchorBgColor3D'
  }
},
    isVolumeChartRequired = function isVolumeChartRequired(dataObj) {
  if (!(dataObj && dataObj.dataset)) {
    return 0;
  }

  var data = dataObj.dataset[0].data; // eslint-disable-next-line good-practices/no-function-dependency

  return !!(Array.isArray(data) && data.filter(function (v) {
    return v.volume;
  }) || []).length;
};
/**
 * class definition for candlestick chart API
 */


var CandleStick = /*#__PURE__*/function (_MSCartesian) {
  (0, _inheritsLoose2.default)(CandleStick, _MSCartesian);

  /**
   * constructor function of this class
   */
  function CandleStick() {
    var _this;

    _this = _MSCartesian.call(this) || this;
    _this.isDual = true;
    _this.paletteIndex = 3;
    _this.hasInteractiveLegend = false;
    _this.numOfCanvas = 2;

    _this.registerFactory('vCanvas', _vcanvas.default, ['axis']);

    _this.registerFactory('axis', _candlestickAxis.default, ['canvas']);

    _this.registerFactory('dataset', _candlestickDataset.default, ['vCanvas']);

    return _this;
  }
  /**
   * Returns the name of the component
   *
   * @return {string} The name of the component
   */


  var _proto = CandleStick.prototype;

  _proto.getName = function getName() {
    return 'candlestick';
  }
  /**
   * Returns the name of the component
   *
   * @return {string} The name of the component
   */
  ;

  CandleStick.getName = function getName() {
    return 'candlestick';
  }
  /**
   * This method return the dataset definations for this charts
   * @param {string} name   name of the dataset that is required
   * @return {Object}       Required dataset class definition
   */
  ;

  _proto.getDSdef = function getDSdef(name) {
    return name === 'bar' ? _candlestick.CandleStickBarDataset : name === 'line' ? _candlestick.CandleStickLineDataset : _candlestick.CandleStickDataset;
  }
  /**
   * parse defualt configuration of the chart
   */
  ;

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    _MSCartesian.prototype.__setDefaultConfig.call(this);

    var config = this.config;
    config.hasLegend = true;
    config.defaultDatasetType = CANDLESTICK;
    config.drawanchors = 0;
    config.enablemousetracking = true;
    config.iscandlestick = true;
    config.canvasborderthickness = 1;
  }
  /**
   * function to create component and configure and also configure the chart
   * It creates components which are depend on data and configure them and also configure chart
   * It calls helper function namely, configure
   * @param  {Object} dataObj contains json data of the chart
   */
  ;

  _proto.configureAttributes = function configureAttributes(dataObj) {
    _MSCartesian.prototype.configureAttributes.call(this, dataObj);
  }
  /**
   * Parse the chart attributes and store in chart's config
   * @param {Object} dataObj User input json
   */
  ;

  _proto.parseChartAttr = function parseChartAttr(dataObj) {
    _MSCartesian.prototype.parseChartAttr.call(this, dataObj);

    var iapi = this,
        volumeHeightPercent,
        config = iapi.config,
        chartAttrs = iapi.getFromEnv('chart-attrib'),
        colorM = iapi.getFromEnv('color-manager');
    config.showVolumeChart = (0, _lib.pluckNumber)(chartAttrs.showvolumechart, isVolumeChartRequired(dataObj), 1);
    config.rollOverBandColor = (0, _lib.convertColor)((0, _lib.pluck)(chartAttrs.rolloverbandcolor, colorM.getColor(altHGridColorStr)), (0, _lib.pluck)(chartAttrs.rolloverbandalpha, colorM.getColor(altHGridAlphaStr)));
    config.crosslinecolor = (0, _lib.pluck)(chartAttrs.crosslinecolor, chartAttrs.rolloverbandcolor, colorM.getColor(altHGridColorStr));
    config.drawcrosslineontop = 0;
    config.crosslinealpha = (0, _lib.pluckNumber)(chartAttrs.crosslinealpha, chartAttrs.rolloverbandalpha, colorM.getColor(altHGridAlphaStr));
    config.drawcrossline = 1;
    config.skipClipping = true;
    chartAttrs = iapi.getFromEnv('chart-attrib');
    config.vplotbordercolor = (0, _lib.getFirstValue)(chartAttrs.vplotbordercolor, _lib.BLANKSTRING);
    config.vplotborderalpha = (0, _lib.getFirstValue)(chartAttrs.vplotborderalpha, _lib.BLANKSTRING);
    config.vplotborderthickness = (0, _lib.pluckNumber)(chartAttrs.vplotborderthickness, 1);
    config.showplotborder = (0, _lib.pluckNumber)(chartAttrs.showvplotborder, 1);
    volumeHeightPercent = (0, _lib.pluckNumber)(chartAttrs.volumeheightpercent, 40);
    config.volumeHeightPercent = volumeHeightPercent < 20 ? 20 : volumeHeightPercent > 80 ? 80 : volumeHeightPercent;
    config.canvasBorderWidth = (0, _lib.pluckNumber)(chartAttrs.canvasborderthickness, 1);
  }
  /**
   * calculate and allote space for various components
   * every components are get notified with maximum space and then components return
   * the available space.
   */
  ;

  _proto._spaceManager = function _spaceManager() {
    var spaceForActionBar,
        actionBarSpace,
        availableWidth,
        availableHeight,
        iapi = this,
        config = iapi.config,
        components = iapi.getChildren(),
        legendPosition = config.legendPosition ? config.legendPosition.split('-') : [],
        xAxis = components.xAxis && components.xAxis[0],
        yAxis = components.yAxis && components.yAxis[0],
        // eslint-disable-line good-practices/no-single-usage-variable
    yAxis2 = components.yAxis && components.yAxis[1],
        // eslint-disable-line good-practices/no-single-usage-variable
    legend = iapi.getFromEnv('legend'),
        // eslint-disable-line good-practices/no-single-usage-variable
    canvasHeight,
        xAxisDimensions,
        showVolumeChart = iapi.config.showVolumeChart,
        volumeHeightPercent = showVolumeChart ? config.volumeHeightPercent : 0,
        canvas = components.canvas[0],
        canvasConfig = canvas.config,
        volumeCanvas,
        volumeCanvasConfig,
        volumeCanvasY,
        yAxisDim,
        vYAxisDim,
        width = config.width,
        height = config.height,
        actualYDim = {},
        allottedSpace,
        chartBorderWidth = config.chartBorderWidth,
        canvasBorderWidth = canvasConfig.canvasBorderWidth,
        minCanvasHeight = config.minCanvasHeight,
        minCanvasWidth = config.minCanvasWidth,
        canvasMarginLeft = config.canvasMarginLeft,
        canvasMarginRight = config.canvasMarginRight,
        canvasMarginTop = config.canvasMarginTop,
        canvasMarginBottom = config.canvasMarginBottom,
        diff,
        currentCanvasHeight,
        currentCanvasWidth,
        heightAdjust,
        origCanvasTopMargin = config.origCanvasTopMargin,
        origCanvasBottomMargin = config.origCanvasBottomMargin,
        origCanvasLeftMargin = config.origCanvasLeftMargin,
        origCanvasRightMargin = config.origCanvasRightMargin,
        left,
        right,
        top,
        bottom,
        widthAdjust,
        sum; // Manage space

    iapi._allocateSpace({
      top: chartBorderWidth,
      bottom: chartBorderWidth,
      left: chartBorderWidth,
      right: chartBorderWidth
    }); // iapi._allocateSpace ( {
    //     left : config.canvasMarginLeft,
    //     right : config.canvasMarginRight
    // });


    spaceForActionBar = config.availableHeight * 0.225; // eslint-disable-line good-practices/no-single-usage-variable

    actionBarSpace = iapi._manageActionBarSpace && iapi._manageActionBarSpace(spaceForActionBar) || {}; // eslint-disable-line good-practices/no-single-usage-variable

    iapi._allocateSpace(actionBarSpace);

    if (legendPosition[0] === _lib.POSITION_LEFT || legendPosition[0] === _lib.POSITION_RIGHT) {
      allottedSpace = config.canvasWidth * 0.225;
    } else {
      allottedSpace = config.canvasHeight * 0.3;
    }

    config.hasLegend !== false && xAxis && config.showLegend && iapi._allocateSpace(legend._manageLegendPosition(allottedSpace));
    availableWidth = config.canvasWidth * 0.7;
    yAxisDim = yAxis.placeAxis(availableWidth);
    vYAxisDim = showVolumeChart ? yAxis2.placeAxis(availableWidth) : {};
    actualYDim.left = mathMax(yAxisDim.left, vYAxisDim.left || 0);
    actualYDim.right = mathMax(yAxisDim.right, vYAxisDim.right || 0);

    iapi._allocateSpace(actualYDim); // Check for minimun canvas width for applying canvas left and right margin.


    if (minCanvasWidth > width - canvasMarginLeft - canvasMarginRight) {
      widthAdjust = true;
      diff = config.canvasWidth - minCanvasWidth;
      sum = canvasMarginLeft + canvasMarginRight;
      canvasMarginLeft = config.canvasMarginLeft = diff * canvasMarginLeft / sum;
      canvasMarginRight = config.canvasMarginRight = diff * canvasMarginRight / sum;
    } // Calculating the left and right canvas margin.


    left = canvasMarginLeft > config.canvasLeft ? canvasMarginLeft - config.canvasLeft : 0;
    right = canvasMarginRight > width - config.canvasRight ? canvasMarginRight + config.canvasRight - width : 0;

    iapi._allocateSpace({
      left: left,
      right: right
    }); // Forcing canvas width to its minimum


    if (widthAdjust) {
      sum = origCanvasLeftMargin + origCanvasRightMargin;
      currentCanvasWidth = config.canvasWidth;

      if (currentCanvasWidth > minCanvasWidth) {
        diff = currentCanvasWidth - minCanvasWidth;
        left = diff * origCanvasLeftMargin / sum;
        right = diff * origCanvasRightMargin / sum;
      }

      iapi._allocateSpace({
        left: left,
        right: right
      });
    }

    availableHeight = config.canvasHeight * 0.225;
    availableHeight = legendPosition[0] === _lib.POSITION_TOP || legendPosition[0] === POSITION_BOTTOM ? config.canvasHeight * 0.6 : config.canvasWidth * 0.6; // a space manager that manages the space for the tools as well as the captions.

    iapi._manageChartMenuBar(availableHeight);

    iapi._allocateSpace({
      top: config.canvasMarginTop,
      bottom: config.canvasMarginBottom
    });

    availableHeight = config.canvasHeight * 0.3;
    xAxisDimensions = xAxis.placeAxis(availableHeight);
    xAxis && iapi._allocateSpace(xAxisDimensions);
    xAxisDimensions.bottom += padding;
    canvasConfig.intermediarySpace = xAxisDimensions.bottom; // enforcing the 10 pixel deduction in canvas height to set a padding between canvas and legend

    if (showVolumeChart) {
      iapi._allocateSpace({
        bottom: 10
      });
    }

    iapi._allocateSpace({
      top: canvasBorderWidth,
      bottom: canvasBorderWidth * 2,
      left: canvasBorderWidth,
      right: canvasBorderWidth
    }); // Check for minimum canvas height for applying top and bottom margin.


    if (minCanvasHeight > height - canvasMarginTop - canvasMarginBottom) {
      heightAdjust = true;
      diff = config.canvasHeight - minCanvasHeight;
      sum = canvasMarginTop + canvasMarginBottom;
      canvasMarginTop = config.canvasMarginTop = diff * canvasMarginTop / sum;
      canvasMarginBottom = config.canvasMarginBottom = diff * canvasMarginBottom / sum;
    } // Allocate space for canvas margin only if the margin is less than the margin entered by the user.


    top = canvasMarginTop > config.canvasTop ? canvasMarginTop - config.canvasTop : 0;
    bottom = canvasMarginBottom > height - config.canvasBottom ? canvasMarginBottom + config.canvasBottom - height : 0;

    iapi._allocateSpace({
      top: top,
      bottom: bottom
    }); // Forcing canvas height to its minimum


    if (heightAdjust) {
      sum = origCanvasTopMargin + origCanvasBottomMargin;
      currentCanvasHeight = config.canvasHeight;

      if (currentCanvasHeight > minCanvasHeight) {
        diff = currentCanvasHeight - minCanvasHeight;
        top = diff * origCanvasTopMargin / sum;
        bottom = diff * origCanvasBottomMargin / sum;
      }

      iapi._allocateSpace({
        top: top,
        bottom: bottom
      });
    }

    canvasHeight = config.canvasHeight;
    canvasConfig.canvasHeight = mathRound((100 - volumeHeightPercent) / 100 * canvasHeight);
    canvasConfig.canvasTop = config.canvasTop;
    canvasConfig.canvasLeft = config.canvasLeft;
    canvasConfig.canvasBottom = canvasConfig.canvasTop + canvasConfig.canvasHeight;
    canvasConfig.canvasWidth = config.canvasWidth;
    canvasConfig.canvasRight = config.canvasRight;
    canvasConfig.canvasY = config.canvasTop + canvasConfig.canvasHeight + canvasBorderWidth;
    canvas.setDimension({
      top: canvasConfig.canvasTop,
      left: canvasConfig.canvasLeft,
      width: canvasConfig.canvasWidth,
      height: canvasConfig.canvasHeight
    });

    if (showVolumeChart) {
      volumeCanvas = components.canvas[1];
      volumeCanvasConfig = volumeCanvas.config;
      volumeCanvasConfig.canvasHeight = volumeHeightPercent / 100 * canvasHeight;
      volumeCanvasConfig.canvasTop = canvasConfig.canvasBottom + xAxisDimensions.bottom + canvasBorderWidth * 2;
      volumeCanvasConfig.canvasLeft = config.canvasLeft;
      volumeCanvasConfig.canvasBottom = volumeCanvasConfig.canvasTop + volumeCanvasConfig.canvasHeight + canvasBorderWidth * 2;
      volumeCanvasConfig.canvasRight = config.canvasRight;
      volumeCanvasConfig.canvasWidth = config.canvasWidth;
      volumeCanvasY = config.canvasTop + canvasConfig.canvasHeight + xAxisDimensions.bottom + canvasBorderWidth * 2;
      volumeCanvasConfig.canvasY = volumeCanvasY;
      volumeCanvas.setDimension({
        top: volumeCanvasConfig.canvasTop,
        left: volumeCanvasConfig.canvasLeft,
        width: volumeCanvasConfig.canvasWidth,
        height: volumeCanvasConfig.canvasHeight
      });
    }
  }
  /**
   * function to calculate post space management calculations
   * calculations like axis dimenetion set, allocate space for xaxis labels,
   * canvas padding etc.
   */
  ;

  _proto._postSpaceManagement = function _postSpaceManagement() {
    _MSCartesian.prototype._postSpaceManagement.call(this);
  }
  /**
    * Sets dimension of Axis components
    */
  ;

  _proto.setAxisDimention = function setAxisDimention() {
    var iapi = this,
        components = iapi.getChildren(),
        xAxis = components.xAxis && components.xAxis[0],
        yAxis = components.yAxis && components.yAxis[0],
        vyAxis = components.yAxis && components.yAxis[1],
        canvasArr = components.canvas,
        canvasConfig = canvasArr[0].config,
        volumeCanvasConfig,
        canvasBorderWidth = canvasConfig.canvasBorderWidth,
        axisLeft = canvasConfig.canvasLeft - canvasBorderWidth;
    xAxis && xAxis.setAxisDimention({
      x: canvasConfig.canvasLeft,
      y: xAxis.config.isOpposit ? canvasConfig.canvasTop - canvasBorderWidth : canvasConfig.canvasY,
      opposite: xAxis.config.isOpposit ? canvasConfig.canvasY : canvasConfig.canvasTop - canvasBorderWidth,
      axisLength: canvasConfig.canvasWidth
    });
    yAxis && yAxis.setAxisDimention({
      x: yAxis.config.isOpposit ? canvasConfig.canvasRight + canvasBorderWidth : axisLeft,
      y: canvasConfig.canvasTop,
      opposite: yAxis.config.isOpposit ? axisLeft : canvasConfig.canvasRight + canvasBorderWidth,
      axisLength: canvasConfig.canvasHeight
    });
    xAxis.setCanvas(canvasConfig);
    yAxis.setCanvas(canvasConfig);

    if (iapi.config.showVolumeChart) {
      volumeCanvasConfig = canvasArr[1].config;
      vyAxis && vyAxis.setAxisDimention({
        x: yAxis.config.isOpposit ? volumeCanvasConfig.canvasRight + canvasBorderWidth : axisLeft,
        y: volumeCanvasConfig.canvasTop,
        opposite: yAxis.config.isOpposit ? axisLeft : volumeCanvasConfig.canvasRight + canvasBorderWidth,
        axisLength: volumeCanvasConfig.canvasHeight
      });
      vyAxis && vyAxis.setCanvas(volumeCanvasConfig);
    }
  }
  /**
   * function to parse JSON data for configurations of axis
   * @return { Object } contains axis configuration
   */
  ;

  _proto._feedAxesRawData = function _feedAxesRawData() {
    var iapi = this,
        colorM = iapi.getFromEnv('color-manager'),
        dataObj = iapi.getFromEnv('dataSource'),
        chartAttrs = iapi.getFromEnv('chart-attrib'),
        xAxisConf,
        yAxisConf,
        vYAxisConf,
        yAxisConfigure = [],
        xAxisConfigure = [],
        is3D = iapi.config.is3D,
        palleteString = is3D ? chartPaletteStr.chart3D : chartPaletteStr.chart2D,
        outCanfontSizeWithUnit = (0, _lib.pluckFontSizeMaintainUnit)(chartAttrs.outcnvbasefontsize, chartAttrs.basefontsize, 10);
    xAxisConf = {
      isVertical: false,
      isReverse: false,
      isOpposit: (0, _equal.default)(chartAttrs.xaxisposition, 'top'),
      drawTrendLabels: true,
      outCanfontFamily: (0, _lib.pluck)(chartAttrs.outcnvbasefont, chartAttrs.basefont, defaultFontStr),
      outCanfontSize: this.computeFontSize(outCanfontSizeWithUnit),
      outCanfontSizeWithUnit: outCanfontSizeWithUnit,
      outCancolor: (0, _lib.pluck)(chartAttrs.outcnvbasefontcolor, chartAttrs.basefontcolor, colorM.getColor(palleteString.baseFontColor)).replace(/^#?([a-f0-9]+)/ig, '#$1'),
      axisNamePadding: chartAttrs.xaxisnamepadding,
      axisValuePadding: chartAttrs.labelpadding,
      axisNameFont: chartAttrs.xaxisnamefont,
      axisNameFontSize: this.computeFontSize(chartAttrs.xaxisnamefontsize),
      axisNameFontSizeWithUnit: chartAttrs.xaxisnamefontsize,
      axisNameFontColor: chartAttrs.xaxisnamefontcolor,
      axisNameFontBold: chartAttrs.xaxisnamefontbold,
      axisNameFontItalic: chartAttrs.xaxisnamefontitalic,
      axisNameBgColor: chartAttrs.xaxisnamebgcolor,
      axisNameBorderColor: chartAttrs.xaxisnamebordercolor,
      axisNameAlpha: chartAttrs.xaxisnamealpha,
      axisNameFontAlpha: chartAttrs.xaxisnamefontalpha,
      axisNameBgAlpha: chartAttrs.xaxisnamebgalpha,
      axisNameBorderAlpha: chartAttrs.xaxisnameborderalpha,
      axisNameBorderPadding: chartAttrs.xaxisnameborderpadding,
      axisNameBorderRadius: chartAttrs.xaxisnameborderradius,
      axisNameBorderThickness: chartAttrs.xaxisnameborderthickness,
      axisNameBorderDashed: chartAttrs.xaxisnameborderdashed,
      axisNameBorderDashLen: chartAttrs.xaxisnameborderdashlen,
      axisNameBorderDashGap: chartAttrs.xaxisnameborderdashgap,
      useEllipsesWhenOverflow: chartAttrs.useellipseswhenoverflow,
      divLineColor: (0, _lib.pluck)(chartAttrs.vdivlinecolor, chartAttrs.divlinecolor, colorM.getColor(palleteString.divLineColor)),
      divLineAlpha: (0, _lib.pluck)(chartAttrs.vdivlinealpha, chartAttrs.divlinealpha, is3D ? colorM.getColor(divLineAlpha3DStr) : colorM.getColor(divLineAlphaStr)),
      divLineThickness: (0, _lib.pluckNumber)(chartAttrs.vdivlinethickness, chartAttrs.divlinethickness, 1),
      divLineIsDashed: Boolean((0, _lib.pluckNumber)(chartAttrs.vdivlinedashed, chartAttrs.vdivlineisdashed, chartAttrs.divlinedashed, chartAttrs.divlineisdashed, 0)),
      divLineDashLen: (0, _lib.pluckNumber)(chartAttrs.vdivlinedashlen, chartAttrs.divlinedashlen, 4),
      divLineDashGap: (0, _lib.pluckNumber)(chartAttrs.vdivlinedashgap, chartAttrs.divlinedashgap, 2),
      showAlternateGridColor: (0, _lib.pluckNumber)(chartAttrs.showalternatevgridcolor, 0),
      alternateGridColor: (0, _lib.pluck)(chartAttrs.alternatevgridcolor, colorM.getColor(altVGridColorStr)),
      alternateGridAlpha: (0, _lib.pluck)(chartAttrs.alternatevgridalpha, colorM.getColor(altVGridAlphaStr)),
      numDivLines: chartAttrs.numvdivlines,
      labelFont: chartAttrs.labelfont,
      labelFontSize: this.computeFontSize(chartAttrs.labelfontsize),
      labelFontSizeWithUnit: chartAttrs.labelfontsize,
      labelFontColor: chartAttrs.labelfontcolor,
      labelAlpha: chartAttrs.labelalpha,
      labelFontBold: chartAttrs.labelfontbold,
      labelFontItalic: chartAttrs.labelfontitalic,
      labelBdrColor: chartAttrs.labelbordercolor,
      labelBdrAlpha: chartAttrs.labelborderalpha,
      labelLink: chartAttrs.labellink,
      labelBgAlpha: chartAttrs.labelbgalpha,
      labelBgColor: chartAttrs.labelbgcolor,
      labelBdrThickness: chartAttrs.labelborderthickness,
      labelBdrPadding: chartAttrs.labelborderpadding,
      labelBdrRadius: chartAttrs.labelborderradius,
      labelBdrDashed: chartAttrs.labelborderdashed,
      labelBdrDashLen: chartAttrs.labelborderdashlen,
      labelBdrDashGap: chartAttrs.labelborderdashgap,
      axisName: chartAttrs.xaxisname,
      axisMinValue: chartAttrs.xaxisminvalue,
      axisMaxValue: chartAttrs.xaxismaxvalue,
      setAdaptiveMin: chartAttrs.setadaptivexmin,
      adjustDiv: chartAttrs.adjustvdiv,
      labelDisplay: chartAttrs.labeldisplay,
      showLabels: chartAttrs.showlabels,
      rotateLabels: chartAttrs.rotatelabels,
      slantLabel: (0, _lib.pluckNumber)(chartAttrs.slantlabels, chartAttrs.slantlabel),
      labelStep: (0, _lib.pluckNumber)(chartAttrs.labelstep, chartAttrs.xaxisvaluesstep),
      showAxisValues: (0, _lib.pluckNumber)(chartAttrs.showxaxisvalues, chartAttrs.showxaxisvalue),
      showLimits: chartAttrs.showvlimits,
      showDivLineValues: (0, _lib.pluckNumber)(chartAttrs.showvdivlinevalues, chartAttrs.showvdivlinevalues),
      showZeroPlane: chartAttrs.showvzeroplane,
      zeroPlaneColor: chartAttrs.vzeroplanecolor,
      zeroPlaneThickness: chartAttrs.vzeroplanethickness,
      zeroPlaneAlpha: chartAttrs.vzeroplanealpha,
      showZeroPlaneValue: chartAttrs.showvzeroplanevalue,
      trendlineColor: chartAttrs.trendlinecolor,
      trendlineToolText: chartAttrs.trendlinetooltext,
      trendlineThickness: chartAttrs.trendlinethickness,
      trendlineAlpha: chartAttrs.trendlinealpha,
      showTrendlinesOnTop: chartAttrs.showtrendlinesontop,
      showAxisLine: (0, _lib.pluckNumber)(chartAttrs.showxaxisline, chartAttrs.showaxislines, chartAttrs.drawAxisLines, 0),
      axisLineThickness: (0, _lib.pluckNumber)(chartAttrs.xaxislinethickness, chartAttrs.axislinethickness, 1),
      axisLineAlpha: (0, _lib.pluckNumber)(chartAttrs.xaxislinealpha, chartAttrs.axislinealpha, 100),
      axisLineColor: (0, _lib.pluck)(chartAttrs.xaxislinecolor, chartAttrs.axislinecolor, COLOR_000000),
      freezeLimit: true
    };
    xAxisConf.vtrendlines = dataObj.vtrendlines;
    xAxisConfigure.push(xAxisConf);
    yAxisConf = {
      isVertical: true,
      isReverse: true,
      isOpposit: (0, _equal.default)(chartAttrs.yaxisposition, 'left'),
      drawLabelsOpposit: 1,
      axisNameAlignCanvas: 1,
      outCanfontFamily: (0, _lib.pluck)(chartAttrs.outcnvbasefont, chartAttrs.basefont, defaultFontStr),
      outCanfontSize: this.computeFontSize(outCanfontSizeWithUnit),
      outCanfontSizeWithUnit: outCanfontSizeWithUnit,
      outCancolor: (0, _lib.pluck)(chartAttrs.outcnvbasefontcolor, chartAttrs.basefontcolor, colorM.getColor(palleteString.baseFontColor)).replace(/^#?([a-f0-9]+)/ig, '#$1'),
      axisNamePadding: chartAttrs.yaxisnamepadding,
      axisValuePadding: chartAttrs.yaxisvaluespadding,
      axisNameFont: chartAttrs.pyaxisnamefont,
      axisNameFontSize: chartAttrs.pyaxisnamefontsize,
      axisNameFontSizeWithUnit: chartAttrs.pyaxisnamefontsize,
      axisNameFontColor: chartAttrs.pyaxisnamefontcolor,
      axisNameFontBold: chartAttrs.pyaxisnamefontbold,
      axisNameFontItalic: chartAttrs.pyaxisnamefontitalic,
      axisNameBgColor: chartAttrs.pyaxisnamebgcolor,
      axisNameBorderColor: chartAttrs.pyaxisnamebordercolor,
      axisNameAlpha: chartAttrs.pyaxisnamealpha,
      axisNameFontAlpha: chartAttrs.pyaxisnamefontalpha,
      axisNameBgAlpha: chartAttrs.pyaxisnamebgalpha,
      axisNameBorderAlpha: chartAttrs.pyaxisnameborderalpha,
      axisNameBorderPadding: chartAttrs.pyaxisnameborderpadding,
      axisNameBorderRadius: chartAttrs.pyaxisnameborderradius,
      axisNameBorderThickness: chartAttrs.pyaxisnameborderthickness,
      axisNameBorderDashed: chartAttrs.pyaxisnameborderdashed,
      axisNameBorderDashLen: chartAttrs.pyaxisnameborderdashlen,
      axisNameBorderDashGap: chartAttrs.pyaxisnameborderdashgap,
      axisNameWidth: chartAttrs.yaxisnamewidth,
      useEllipsesWhenOverflow: chartAttrs.useellipseswhenoverflow,
      rotateAxisName: (0, _lib.pluckNumber)(chartAttrs.rotateyaxisname, 1),
      axisName: chartAttrs.pyaxisname,
      divLineColor: (0, _lib.pluck)(chartAttrs.divlinecolor, colorM.getColor(palleteString.divLineColor)),
      divLineAlpha: (0, _lib.pluck)(chartAttrs.divlinealpha, colorM.getColor(divLineAlphaStr)),
      divLineThickness: (0, _lib.pluckNumber)(chartAttrs.divlinethickness, 1),
      divLineIsDashed: Boolean((0, _lib.pluckNumber)(chartAttrs.divlinedashed, chartAttrs.divlineisdashed, 1)),
      divLineDashLen: (0, _lib.pluckNumber)(chartAttrs.divlinedashlen, 4),
      divLineDashGap: (0, _lib.pluckNumber)(chartAttrs.divlinedashgap, 2),
      showAlternateGridColor: (0, _lib.pluckNumber)(chartAttrs.showalternatehgridcolor, 1),
      alternateGridColor: (0, _lib.pluck)(chartAttrs.alternatehgridcolor, colorM.getColor(altHGridColorStr)),
      alternateGridAlpha: (0, _lib.pluck)(chartAttrs.alternatehgridalpha, colorM.getColor(altHGridAlphaStr)),
      numDivLines: (0, _lib.pluckNumber)(chartAttrs.numpdivlines, 5),
      axisMinValue: chartAttrs.pyaxisminvalue,
      axisMaxValue: chartAttrs.pyaxismaxvalue,
      setAdaptiveMin: (0, _lib.pluckNumber)(chartAttrs.setadaptiveymin, 1),
      adjustDiv: chartAttrs.adjustdiv,
      labelStep: chartAttrs.yaxisvaluesstep,
      showAxisValues: (0, _lib.pluckNumber)(chartAttrs.showyaxisvalues, chartAttrs.showyaxisvalue),
      showLimits: (0, _lib.pluckNumber)(chartAttrs.showyaxislimits, chartAttrs.showlimits, iapi.showLimits),
      showDivLineValues: (0, _lib.pluckNumber)(chartAttrs.showdivlinevalues, chartAttrs.showdivlinevalue),
      showZeroPlane: chartAttrs.showzeroplane,
      zeroPlaneColor: chartAttrs.zeroplanecolor,
      zeroPlaneThickness: chartAttrs.zeroplanethickness,
      zeroPlaneAlpha: chartAttrs.zeroplanealpha,
      showZeroPlaneValue: chartAttrs.showzeroplanevalue,
      trendlineColor: chartAttrs.trendlinecolor,
      trendlineToolText: chartAttrs.trendlinetooltext,
      trendlineThickness: chartAttrs.trendlinethickness,
      trendlineAlpha: chartAttrs.trendlinealpha,
      showTrendlinesOnTop: chartAttrs.showtrendlinesontop,
      showAxisLine: (0, _lib.pluckNumber)(chartAttrs.showyaxisline, chartAttrs.showaxislines, chartAttrs.drawAxisLines, 0),
      axisLineThickness: (0, _lib.pluckNumber)(chartAttrs.yaxislinethickness, chartAttrs.axislinethickness, 1),
      axisLineAlpha: (0, _lib.pluckNumber)(chartAttrs.yaxislinealpha, chartAttrs.axislinealpha, 100),
      axisLineColor: (0, _lib.pluck)(chartAttrs.yaxislinecolor, chartAttrs.axislinecolor, COLOR_000000),
      labelFont: chartAttrs.yaxisvaluefont,
      labelFontSize: this.computeFontSize(chartAttrs.yaxisvaluefontsize),
      labelFontSizeWithUnit: chartAttrs.yaxisvaluefontsize,
      labelFontColor: chartAttrs.yaxisvaluefontcolor,
      labelAlpha: chartAttrs.yaxisvaluealpha,
      labelFontBold: chartAttrs.yaxisvaluefontbold,
      labelFontItalic: chartAttrs.yaxisvaluefontitalic,
      labelBdrColor: chartAttrs.yaxisvaluebordercolor,
      labelBgAlpha: chartAttrs.yaxisvaluebgalpha,
      labelBdrAlpha: chartAttrs.yaxisvalueborderalpha,
      labelLink: chartAttrs.yaxisvaluelink,
      labelBgColor: chartAttrs.yaxisvaluebgcolor,
      labelBdrThickness: chartAttrs.yaxisvalueborderthickness,
      labelBdrPadding: chartAttrs.yaxisvalueborderpadding,
      labelBdrRadius: chartAttrs.yaxisvalueborderradius,
      labelBdrDashed: chartAttrs.yaxisvalueborderdashed,
      labelBdrDashLen: chartAttrs.yaxisvalueborderdashlen,
      labelBdrDashGap: chartAttrs.yaxisvalueborderdashgap
    };
    yAxisConf.trendlines = dataObj.trendlines;
    yAxisConfigure.push(yAxisConf);

    if (iapi.config.showVolumeChart) {
      vYAxisConf = {
        isVertical: true,
        isReverse: true,
        isOpposit: (0, _equal.default)(chartAttrs.yaxisposition, 'left'),
        axisIndex: 1,
        drawLabelsOpposit: 1,
        axisNameAlignCanvas: 1,
        uniqueClassName: 1,
        outCanfontFamily: (0, _lib.pluck)(chartAttrs.outcnvbasefont, chartAttrs.basefont, defaultFontStr),
        outCanfontSize: this.computeFontSize(outCanfontSizeWithUnit),
        outCanfontSizeWithUnit: outCanfontSizeWithUnit,
        outCancolor: (0, _lib.pluck)(chartAttrs.outcnvbasefontcolor, chartAttrs.basefontcolor, colorM.getColor(palleteString.baseFontColor)).replace(/^#?([a-f0-9]+)/ig, '#$1'),
        axisNamePadding: chartAttrs.yaxisnamepadding,
        axisValuePadding: chartAttrs.yaxisvaluespadding,
        axisNameFont: chartAttrs.vyaxisnamefont,
        axisNameFontSize: chartAttrs.vyaxisnamefontsize,
        axisNameFontSizeWithUnit: chartAttrs.vyaxisnamefontsize,
        axisNameFontColor: chartAttrs.vyaxisnamefontcolor,
        axisNameFontBold: chartAttrs.vyaxisnamefontbold,
        axisNameFontItalic: chartAttrs.vyaxisnamefontitalic,
        axisNameBgColor: chartAttrs.vyaxisnamebgcolor,
        axisNameBorderColor: chartAttrs.vyaxisnamebordercolor,
        axisNameAlpha: chartAttrs.vyaxisnamealpha,
        axisNameFontAlpha: chartAttrs.vyaxisnamefontalpha,
        axisNameBgAlpha: chartAttrs.vyaxisnamebgalpha,
        axisNameBorderAlpha: chartAttrs.vyaxisnameborderalpha,
        axisNameBorderPadding: chartAttrs.vyaxisnameborderpadding,
        axisNameBorderRadius: chartAttrs.vyaxisnameborderradius,
        axisNameBorderThickness: chartAttrs.vyaxisnameborderthickness,
        axisNameBorderDashed: chartAttrs.vyaxisnameborderdashed,
        axisNameBorderDashLen: chartAttrs.vyaxisnameborderdashlen,
        axisNameBorderDashGap: chartAttrs.vyaxisnameborderdashgap,
        axisNameWidth: chartAttrs.yaxisnamewidth,
        useEllipsesWhenOverflow: chartAttrs.useellipseswhenoverflow,
        rotateAxisName: (0, _lib.pluckNumber)(chartAttrs.rotateyaxisname, 1),
        axisName: chartAttrs.vyaxisname,
        divLineColor: (0, _lib.pluck)(chartAttrs.divlinecolor, colorM.getColor(palleteString.divLineColor)),
        divLineAlpha: (0, _lib.pluck)(chartAttrs.divlinealpha, colorM.getColor(divLineAlphaStr)),
        divLineThickness: (0, _lib.pluckNumber)(chartAttrs.divlinethickness, 1),
        divLineIsDashed: Boolean((0, _lib.pluckNumber)(chartAttrs.divlinedashed, chartAttrs.divlineisdashed, 1)),
        divLineDashLen: (0, _lib.pluckNumber)(chartAttrs.divlinedashlen, 4),
        divLineDashGap: (0, _lib.pluckNumber)(chartAttrs.divlinedashgap, 2),
        showAlternateGridColor: (0, _lib.pluckNumber)(chartAttrs.showalternatehgridcolor, 1),
        alternateGridColor: (0, _lib.pluck)(chartAttrs.alternatehgridcolor, colorM.getColor(altHGridColorStr)),
        alternateGridAlpha: (0, _lib.pluck)(chartAttrs.alternatehgridalpha, colorM.getColor(altHGridAlphaStr)),
        numDivLines: chartAttrs.numdivlines,
        // @todo have to change the y axis max and min value afterwards when percentage axis is ready
        axisMinValue: chartAttrs.vyaxisminvalue,
        axisMaxValue: chartAttrs.vyaxismaxvalue,
        setAdaptiveMin: chartAttrs.setadaptiveymin,
        adjustDiv: chartAttrs.adjustdiv,
        labelStep: chartAttrs.yaxisvaluesstep,
        showAxisValues: (0, _lib.pluckNumber)(chartAttrs.showyaxisvalues, chartAttrs.showyaxisvalue),
        showLimits: (0, _lib.pluckNumber)(chartAttrs.showsecondarylimits, chartAttrs.showlimits),
        showDivLineValues: (0, _lib.pluckNumber)(chartAttrs.showdivlinevalues, chartAttrs.showdivlinevalue),
        showZeroPlane: chartAttrs.showzeroplane,
        zeroPlaneColor: chartAttrs.zeroplanecolor,
        zeroPlaneThickness: chartAttrs.zeroplanethickness,
        zeroPlaneAlpha: chartAttrs.zeroplanealpha,
        showZeroPlaneValue: chartAttrs.showzeroplanevalue,
        trendlineColor: chartAttrs.trendlinecolor,
        trendlineToolText: chartAttrs.trendlinetooltext,
        trendlineThickness: chartAttrs.trendlinethickness,
        trendlineAlpha: chartAttrs.trendlinealpha,
        showTrendlinesOnTop: chartAttrs.showtrendlinesontop,
        showAxisLine: (0, _lib.pluckNumber)(chartAttrs.showyaxisline, chartAttrs.showaxislines, chartAttrs.drawAxisLines, 0),
        axisLineThickness: (0, _lib.pluckNumber)(chartAttrs.yaxislinethickness, chartAttrs.axislinethickness, 1),
        axisLineAlpha: (0, _lib.pluckNumber)(chartAttrs.yaxislinealpha, chartAttrs.axislinealpha, 100),
        axisLineColor: (0, _lib.pluck)(chartAttrs.yaxislinecolor, chartAttrs.axislinecolor, COLOR_000000),
        labelFont: chartAttrs.yaxisvaluefont,
        labelFontSize: this.computeFontSize(chartAttrs.yaxisvaluefontsize),
        labelFontSizeWithUnit: chartAttrs.yaxisvaluefontsize,
        labelFontColor: chartAttrs.yaxisvaluefontcolor,
        labelAlpha: chartAttrs.yaxisvaluealpha,
        labelFontBold: chartAttrs.yaxisvaluefontbold,
        labelFontItalic: chartAttrs.yaxisvaluefontitalic,
        labelBdrColor: chartAttrs.yaxisvaluebordercolor,
        labelBgAlpha: chartAttrs.yaxisvaluebgalpha,
        labelBdrAlpha: chartAttrs.yaxisvalueborderalpha,
        labelLink: chartAttrs.yaxisvaluelink,
        labelBgColor: chartAttrs.yaxisvaluebgcolor,
        labelBdrThickness: chartAttrs.yaxisvalueborderthickness,
        labelBdrPadding: chartAttrs.yaxisvalueborderpadding,
        labelBdrRadius: chartAttrs.yaxisvalueborderradius,
        labelBdrDashed: chartAttrs.yaxisvalueborderdashed,
        labelBdrDashLen: chartAttrs.yaxisvalueborderdashlen,
        labelBdrDashGap: chartAttrs.yaxisvalueborderdashgap
      };
      yAxisConfigure.push(vYAxisConf);
    }

    return {
      xAxisConfigure: xAxisConfigure,
      yAxisConfigure: yAxisConfigure
    };
  };

  _proto.mouseoutHandler = function mouseoutHandler(e, _lastDatasetIndex, _lastPointIndex) {
    var chart = this,
        datasets = chart.config.datasetOrder || chart.getDatasets(),
        mouseTracker = chart.getChildren('mouseTracker')[0]; // check if the data plot exists. else hide all existing tooltips.

    if (datasets[_lastDatasetIndex] && datasets[_lastDatasetIndex].components.data[_lastPointIndex]) {
      datasets[_lastDatasetIndex]._firePlotEvent(MOUSEOUT, _lastPointIndex, e);
    } else {
      chart.getFromEnv('toolTipController').hideAll();
    } // delete stored last ds details


    delete mouseTracker._lastDatasetIndex;
    delete mouseTracker._lastPointIndex;
  }
  /**
   * This method delegates the handling of  mouse event to the chart's event handler
   * @param  {Object} e The Event Object
   * @param  {Object} data The Data Object
   * @private
   */
  ;

  _proto._mouseEvtHandler = function _mouseEvtHandler(e, data) {
    var iapi = this,
        mouseTracker = data.mouseTracker,
        oriEvent = e.originalEvent,
        canvasLen = iapi.getChildren('canvas').length,
        // eslint-disable-line good-practices/no-single-usage-variable
    datasets,
        coordinate = oriEvent && (0, _lib.getMouseCoordinate)(iapi.getFromEnv('chart-container'), oriEvent, iapi),
        chartX = coordinate && coordinate.chartX || 0,
        // eslint-disable-line good-practices/no-single-usage-variable
    chartY = coordinate && coordinate.chartY || 0,
        // eslint-disable-line good-practices/no-single-usage-variable
    dataset,
        hoveredInfo,
        pointFound = false,
        i,
        j,
        l,
        derivedEvensInfo,
        _lastDatasetIndex = mouseTracker._lastDatasetIndex,
        _lastPointIndex = mouseTracker._lastPointIndex;

    for (i = 0; i < canvasLen; i++) {
      // todo make sure the datasets are as per their z-order
      datasets = iapi.getDatasets();
      j = datasets.length;

      while (j-- && !pointFound) {
        dataset = datasets[j];

        if (dataset && dataset.getState('visible')) {
          hoveredInfo = dataset._getHoveredPlot && dataset._getHoveredPlot(chartX, chartY);

          if (hoveredInfo && hoveredInfo.hovered) {
            pointFound = true;
            hoveredInfo.datasetIndex = j;
            derivedEvensInfo = mouseTracker.getMouseEvents(e, hoveredInfo.datasetIndex, hoveredInfo.pointIndex);
          }
        }
      }
    } // todo instead of sending event names, create a event object of that type and send it
    // fire out on last hovered plot


    if ((!pointFound || derivedEvensInfo && derivedEvensInfo.fireOut) && typeof _lastDatasetIndex !== 'undefined') {
      if (datasets[_lastDatasetIndex] && datasets[_lastDatasetIndex]._firePlotEvent) {
        // when mouseout is fired and there aren't any events that need to be fired over the current plot,
        // call mouseouthamndler through settimeout.
        if (derivedEvensInfo && !derivedEvensInfo.events.length) {
          mouseTracker.mouseoutTimer = setTimeout(function () {
            iapi.mouseoutHandler(e, _lastDatasetIndex, _lastPointIndex);
          }, 20);
        } else {
          iapi.mouseoutHandler(e, _lastDatasetIndex, _lastPointIndex);
          clearTimeout(mouseTracker.mouseoutTimer);
        }
      } // todo scope to have sticky tracked tooltip

    } // fire remaining events


    if (pointFound) {
      l = derivedEvensInfo.events && derivedEvensInfo.events.length; // Update only when events for current plot are present.

      if (l) {
        // store the index of the hovered DS and plot
        mouseTracker._lastDatasetIndex = hoveredInfo.datasetIndex;
        _lastPointIndex = mouseTracker._lastPointIndex = hoveredInfo.pointIndex;
      }

      for (j = 0; j < l; j += 1) {
        dataset && dataset._firePlotEvent && dataset._firePlotEvent(derivedEvensInfo.events[j], _lastPointIndex, e, hoveredInfo.datasetIndex);
      }
    }
  }
  /**
   * allocate space for canvas
   * @param  {Object} dimensions contains left, right, top, bottom co-ordinate (relative)
   */
  ;

  _proto._allocateSpace = function _allocateSpace(dimensions) {
    var iapi = this,
        canvas = iapi.getChildren('canvas'),
        canvasConfig = canvas && canvas[0].config,
        config = iapi.config,
        canvasHeight = config.canvasHeight,
        canvasWidth = config.canvasWidth,
        canvasTop,
        canvasLeft;
    canvasLeft = config.canvasLeft += dimensions.left || 0; // eslint-disable-line good-practices/no-single-usage-variable

    canvasTop = config.canvasTop += dimensions.top || 0; // eslint-disable-line good-practices/no-single-usage-variable

    canvasWidth = config.canvasWidth = mathMax(canvasWidth - ((dimensions.left || 0) + (dimensions.right || 0)), 0);
    canvasHeight = config.canvasHeight = mathMax(canvasHeight - ((dimensions.top || 0) + (dimensions.bottom || 0)), 0);
    config.availableHeight = mathMax(config.availableHeight - ((dimensions.top || 0) + (dimensions.bottom || 0)), 0);
    config.availableWidth = mathMax(config.availableWidth - ((dimensions.left || 0) + (dimensions.right || 0)), 0);
    config.canvasRight = canvasLeft + canvasWidth;
    config.canvasBottom = canvasTop + canvasHeight;

    if (canvasConfig) {
      canvasConfig.canvasPaddingLeft = mathMax(canvasConfig.canvasPaddingLeft, dimensions.paddingLeft || 0);
      canvasConfig.canvasPaddingRight = mathMax(canvasConfig.canvasPaddingRight, dimensions.paddingRight || 0);
      canvasConfig.canvasPaddingTop = mathMax(canvasConfig.canvasPaddingTop, dimensions.paddingTop || 0);
      canvasConfig.canvasPaddingBottom = mathMax(canvasConfig.canvasPaddingBottom, dimensions.paddingBottom || 0);
    }
  }
  /**
   * function to check if the chart specific data is proper is not
   * this fn is define for specific chart types
   * @return {boolean} if JSON data is valid or not
   */
  ;

  _proto._checkInvalidSpecificData = function _checkInvalidSpecificData() {
    var datasetsJSON = this.getFromEnv('dataSource').dataset,
        data = datasetsJSON && datasetsJSON[0] && datasetsJSON[0].data;

    if (!datasetsJSON || !data || !Array.isArray(data)) {
      return true;
    }
  };

  return CandleStick;
}(_mscartesian.default);

var _default = CandleStick;
exports["default"] = _default;

/***/ }),

/***/ 1464:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _assertThisInitialized2 = _interopRequireDefault(__webpack_require__(292));

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _commonchartapi = _interopRequireDefault(__webpack_require__(520));

var _arrayHasContent = _interopRequireDefault(__webpack_require__(446));

var _isObject = _interopRequireDefault(__webpack_require__(481));

var _chordLegend = _interopRequireDefault(__webpack_require__(1465));

var _nodeLinkManager = _interopRequireDefault(__webpack_require__(1466));

var _linear = _interopRequireDefault(__webpack_require__(541));

var _lib = __webpack_require__(274);

var _equal = _interopRequireDefault(__webpack_require__(421));

var _safeMax = _interopRequireDefault(__webpack_require__(540));

var _nodeLinkManager2 = _interopRequireDefault(__webpack_require__(1467));

var _legendSpacemanager = __webpack_require__(627);

/* eslint require-jsdoc: 'error', valid-jsdoc: ["error", { "requireReturn": false }] */
var CHART_STR = 'Chord',
    POST = 'post',
    PRE = 'pre',
    DEFAULT_PALETTE_COLOR = ['1E77B4', 'FF7F0E', '2BA02C', 'D62728', '9466BD', '8C564B', 'E376C2', '7F7F7F', 'BCBD22', '17BECF'],
    DEACTIVE_COLOR = '#c4c4c4',
    DEFAULT_BG_COLOR = 'FFFFFF,FFFFFF',
    TANGENTIAL = 'tangential',
    OUTSIDE = 'outside',
    INSIDE = 'inside',
    DEF_FONT_FAMILY = 'Verdana,sans',
    ITALIC = 'italic',
    NODE_LABEL_COLOR = '#5F5F5F',
    LABEL_POSITIONS = [TANGENTIAL, OUTSIDE, INSIDE],
    isValidLink = function isValidLink(obj) {
  return (0, _isObject.default)(obj) && (0, _lib.parseUnsafeString)(obj.from) && (0, _lib.parseUnsafeString)(obj.to);
},
    isValidNode = function isValidNode(obj, nodeMap) {
  return (0, _isObject.default)(obj) && (0, _lib.parseUnsafeString)(obj.label) && nodeMap[obj.label];
};
/**
 * Creates radar class
 * @class
 */


var Chord = /*#__PURE__*/function (_CommonAPI) {
  (0, _inheritsLoose2.default)(Chord, _CommonAPI);

  function Chord(id) {
    var _this;

    _this = _CommonAPI.call(this, id) || this;
    var chart = (0, _assertThisInitialized2.default)(_this);
    chart.deregisterFactory('canvas');
    chart.registerFactory('legend', _chordLegend.default);
    chart.registerFactory('nodelinkManager', _nodeLinkManager.default);
    chart.defaultPaletteOptions = {
      // Store colors now
      paletteColors: [DEFAULT_PALETTE_COLOR, DEFAULT_PALETTE_COLOR, DEFAULT_PALETTE_COLOR, DEFAULT_PALETTE_COLOR, DEFAULT_PALETTE_COLOR],
      bgColor: [DEFAULT_BG_COLOR, DEFAULT_BG_COLOR, DEFAULT_BG_COLOR, DEFAULT_BG_COLOR, DEFAULT_BG_COLOR]
    };
    return _this;
  }
  /**
   * Sets the default configuration
   */


  var _proto = Chord.prototype;

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    _CommonAPI.prototype.__setDefaultConfig.call(this);

    var config = this.config; // for skipping drawing of canvas

    config.skipCanvasDrawing = true;
    config.friendlyName = CHART_STR;
    config.nodes = {};
    config.mode = POST;
    config.isPost = true;
    config.nodeSpacing = 2;
    config.minNodeSize = 0.01;
    config.startingAngle = 0;
    config.links = {};
    config.linksOrder = [];
    config.nodesOrder = [];
    config.totalAngle = 360;
    config.clockwise = 1;
    config.nodeLabelGap = 10;
    config.nodeLabelPosition = 10;
    config.nodeThickness = 12; // config.total = 0;

    config.nodeLinkPadding = 3;
    config.linkAlpha = 70;
    config.linkBorderAlpha = 100;
    config.linkBorderThickness = 1;
    config.nodeHoverAlpha = 100;
    config.linkHoverAlpha = 100;
    config.nodeHoverColor = _lib.UNDEF;
    config.linkHoverColor = _lib.UNDEF;
    config.showNodeLabels = 1;
    config.showNodeBorder = 1;
    config.showLinkBorder = 1;
    config.nodeBorderColor = _lib.UNDEF;
    config.nodeBorderThickness = 1;
    config.nodeBorderDashed = 0;
    config.nodeBorderDashedLen = 2;
    config.nodeBorderDashedGap = 1;
    config.nodeBorderAlpha = 100;
    config.showLinkValueOnHover = 1;
    config.nodeAlpha = 70;
    config.nodeLabelPosition = TANGENTIAL;
    config.nodeLabelFont = DEF_FONT_FAMILY;
    config.nodeLabelFontSize = 12;
    config.nodeLabelFontBold = _lib.NORMAL;
    config.nodeLabelFontItalic = _lib.NORMAL;
    config.highlightEffect = 1;
    config.enableToggle = 1;
    config.chordradius = 100;
    config.nodeLabelColor = NODE_LABEL_COLOR;
    config.unfocussedAlpha = 35;
    config.deactiveNodeColor = DEACTIVE_COLOR;
    config.sortOrder = _lib.UNDEF;
    config.tooltipsepchar = _lib.BLANKSTRING;
    config.linkColorByDominance = 1;
    config.useEllipsesOnOverflow = 1;
  };

  _proto.configureAttributes = function configureAttributes(dataObj) {
    _CommonAPI.prototype.configureAttributes.call(this, dataObj);

    var chart = this,
        config = chart.config,
        nodes = config.nodes,
        links = config.links,
        nodesArr = config.nodesOrder,
        linksArr = config.linksOrder,
        connectors = config.connectors = dataObj.links,
        len = connectors.length,
        numberFormatter = chart.getFromEnv('number-formatter'),
        chartAttrs = dataObj.chart,
        colorM = chart.getFromEnv('color-manager'),
        i;
    config.mode = chartAttrs.mode === PRE ? PRE : POST;
    config.isPost = (0, _equal.default)(config.mode, POST); // Parse chart attributes

    config.minNodeSize = (0, _lib.pluckNumber)(chartAttrs.minnodesize, config.minNodeSize);
    config.startingAngle = (0, _lib.pluckNumber)(chartAttrs.startingangle, config.startingAngle);
    config.totalAngle = (0, _lib.pluckNumber)(chartAttrs.totalangle, config.totalAngle);
    config.nodeLabelGap = (0, _lib.pluckNumber)(chartAttrs.nodelabelpadding, config.nodeLabelGap);
    config.nodeThickness = (0, _lib.pluckNumber)(chartAttrs.nodethickness, config.nodeThickness);
    config.nodeSpacing = (0, _lib.pluckNumber)(chartAttrs.nodespacing, config.nodeSpacing);
    config.clockwise = (0, _lib.pluckNumber)(chartAttrs.clockwise, config.clockwise);
    config.nodeLinkPadding = (0, _lib.pluckNumber)(chartAttrs.nodelinkpadding, config.nodeLinkPadding);
    config.linkAlpha = (0, _lib.pluckNumber)(chartAttrs.linkalpha, config.linkAlpha);
    config.linkBorderAlpha = (0, _lib.pluckNumber)(chartAttrs.linkborderalpha, config.linkBorderAlpha);
    config.linkBorderThickness = (0, _lib.pluckNumber)(chartAttrs.linkborderthickness, config.linkBorderThickness);
    config.nodeHoverAlpha = (0, _lib.pluckNumber)(chartAttrs.nodehoveralpha, config.nodeHoverAlpha);
    config.linkHoverAlpha = (0, _lib.pluckNumber)(chartAttrs.linkhoveralpha, config.linkHoverAlpha);
    config.showLinkValueOnHover = (0, _lib.pluckNumber)(chartAttrs.showlinkvalueonhover, config.showLinkValueOnHover); // config.nodeHoverColor = pluck(chartAttrs.nodehovercolor, config.nodeHoverColor);
    // config.linkHoverColor = pluck(chartAttrs.linkhovercolor, config.linkHoverColor);

    config.showNodeLabels = (0, _lib.pluckNumber)(chartAttrs.shownodelabels, config.showNodeLabels);
    config.showNodeBorder = (0, _lib.pluckNumber)(chartAttrs.shownodeborder, config.showNodeBorder);
    config.showLinkBorder = (0, _lib.pluckNumber)(chartAttrs.showlinkborder, config.showLinkBorder);
    config.nodeBorderColor = (0, _lib.pluck)(chartAttrs.nodebordercolor, config.nodeBorderColor);
    config.nodeBorderThickness = (0, _lib.pluckNumber)(chartAttrs.nodeborderthickness, config.nodeBorderThickness);
    config.nodeBorderDashed = (0, _lib.pluckNumber)(chartAttrs.nodeborderdashed, config.nodeBorderDashed);
    config.nodeBorderDashedLen = (0, _lib.pluckNumber)(chartAttrs.nodeborderdashedlen, config.nodeBorderDashedLen);
    config.nodeBorderDashedGap = (0, _lib.pluckNumber)(chartAttrs.nodeborderdashedgap, config.nodeBorderDashedGap);
    config.nodeBorderAlpha = (0, _lib.pluckNumber)(chartAttrs.nodeborderalpha, config.nodeBorderAlpha);
    config.nodeAlpha = (0, _lib.pluckNumber)(chartAttrs.nodealpha, config.nodeAlpha);
    config.nodeLabelPosition = LABEL_POSITIONS.includes(chartAttrs.nodelabelposition) ? chartAttrs.nodelabelposition : config.nodeLabelPosition;
    config.nodeLabelFont = (0, _lib.pluck)(chartAttrs.nodelabelfont, chartAttrs.basefont, config.nodeLabelFont);
    config.nodeLabelFontSize = (0, _lib.pluckFontSize)(chartAttrs.nodelabelfontsize, this.computeFontSize(chartAttrs.basefontsize), config.nodeLabelFontSize);
    config.nodeLabelFontBold = (0, _lib.pluckNumber)(chartAttrs.nodelabelfontbold, 0) ? _lib.BOLD : _lib.NORMAL;
    config.nodeLabelColor = (0, _lib.pluck)(chartAttrs.nodelabelcolor, chartAttrs.basefontcolor, config.nodeLabelColor);
    config.nodeLabelFontItalic = (0, _lib.pluckNumber)(chartAttrs.nodelabelfontitalic, 0) ? ITALIC : _lib.NORMAL;
    config.highlightEffect = (0, _lib.pluckNumber)(chartAttrs.highlighteffect, config.highlightEffect);
    config.enableToggle = (0, _lib.pluckNumber)(chartAttrs.enabletoggle, config.enableToggle);
    config.chordradius = Math.max((0, _lib.pluckNumber)(chartAttrs.chordradius, config.chordradius), 0);
    config.unfocussedAlpha = (0, _lib.pluckNumber)(chartAttrs.unfocussedalpha, config.unfocussedAlpha);
    config.deactiveNodeColor = (0, _lib.pluck)(chartAttrs.deactivenodecolor, config.deactiveNodeColor);
    config.sortOrder = (0, _lib.pluck)(chartAttrs.sortorder, config.sortOrder);
    config.linkColorByDominance = (0, _lib.pluckNumber)(chartAttrs.linkcolorbydominance, config.linkColorByDominance);
    config.textOutline = (0, _lib.pluckNumber)(chartAttrs.textoutline, 0);
    config.useEllipsesOnOverflow = (0, _lib.pluckNumber)(chartAttrs.useellipsesonoverflow, config.useEllipsesOnOverflow);
    config.datalabelStyle = {
      'font-size': config.nodeLabelFontSize,
      'font-family': config.nodeLabelFont,
      'font-weight': config.nodeLabelFontBold,
      'font-style': config.nodeLabelFontItalic
    }; // when labels are kept inside the there is no node label gap

    if (config.nodeLabelPosition === INSIDE) {
      config.nodeLabelGap = 0;
    } // creating valid nodes link


    for (i = 0; i < len; ++i) {
      if (isValidLink(connectors[i])) {
        var connector = connectors[i],
            from = connector.from,
            to = connector.to,
            value = connector.value,
            tooltext = connector.tooltext,
            sanitisedValue = (0, _safeMax.default)([numberFormatter.getCleanValue(value), 0], Number),
            key = void 0,
            link = void 0;
        from = (0, _lib.parseUnsafeString)(from);
        to = (0, _lib.parseUnsafeString)(to);
        key = [from, to].sort().toString();

        if (!nodes[from]) {
          nodes[from] = {
            index: nodesArr.push(from) - 1,
            total: 0,
            adjustedTotal: 0,
            nodeCovered: 0,
            label: from,
            linkedLinks: [],
            scale: new _linear.default(),
            active: true,
            nodeLabelGap: config.nodeLabelGap,
            unfocussed: false,
            hovered: false,
            toolTipSepChar: config.tooltipsepchar,
            showToolTip: config.showToolTip
          };
        }

        if (!nodes[to]) {
          nodes[to] = {
            index: nodesArr.push(to) - 1,
            total: 0,
            adjustedTotal: 0,
            nodeCovered: 0,
            label: to,
            linkedLinks: [],
            scale: new _linear.default(),
            active: true,
            nodeLabelGap: config.nodeLabelGap,
            unfocussed: false,
            hovered: false,
            toolTipSepChar: config.tooltipsepchar,
            showToolTip: config.showToolTip
          };
        }

        if (!links[key]) {
          link = links[key] = {
            key: key,
            points: [],
            dominantNode: [],
            subservientNode: [],
            subservientFlowDataValue: [],
            dominantFlowDataValue: [],
            dominantNodeColor: [],
            subservientNodeColor: [],
            index: linksArr.push(key) - 1,
            linkedNodes: config.isPost ? [to, from] : [from, to],
            tooltip: {},
            visible: true,
            tooltext: tooltext,
            unfocussed: false,
            hovered: false,
            focussedState: {},
            unfocussedState: {},
            normalState: {},
            sanitisedValue: 0,
            toolTipSepChar: config.tooltipsepchar,
            showToolTip: config.showToolTip
          };
          nodes[from].linkedLinks.push(key);
          nodes[to].linkedLinks.push(key);
          link.alpha = (0, _lib.pluckNumber)(connector.alpha, config.linkAlpha);
          link.hoverAlpha = (0, _lib.pluckNumber)(connector.hoveralpha, config.linkHoverAlpha);
          link.borderAlpha = (0, _lib.pluckNumber)(connector.borderalpha, config.linkBorderAlpha);
          link.tooltext = (0, _lib.pluck)(connector.tooltext, config.linktooltext, _lib.UNDEF);
          link.showBorder = config.showLinkBorder;
          link.borderThickness = config.linkBorderThickness;
          link.unfocussedAlpha = (0, _lib.pluckNumber)(connector.unfocussedAlpha, config.unfocussedAlpha);
          link.style = config.datalabelStyle;
        } else {
          link = links[key];
        }

        nodes[config.isPost ? to : from].total += sanitisedValue; // config.total += sanitisedValue;

        link.tooltip[from + " to " + to] = {
          value: numberFormatter.dataLabels(sanitisedValue)
        };
        link.showLinkValueOnHover = config.showLinkValueOnHover;
        link[config.isPost ? to : from] = sanitisedValue;
        links[key].sanitisedValue += sanitisedValue;
      }
    }

    var _loop = function _loop(_key) {
      if (links.hasOwnProperty(_key) && links[_key].sanitisedValue === 0) {
        delete links[_key];
        config.linksOrder = linksArr = linksArr.filter(function (link) {
          return link !== _key;
        });

        _key.split(',').forEach(function (label) {
          nodes[label].linkedLinks = nodes[label].linkedLinks.filter(function (linkedLink) {
            return linkedLink !== _key;
          });
        });
      }
    };

    for (var _key in links) {
      _loop(_key);
    } // copying all the node level configurations in valid nodes


    if ((0, _arrayHasContent.default)(dataObj.nodes)) {
      dataObj.nodes.forEach(function (node) {
        if (isValidNode(node, nodes)) {
          var label = (0, _lib.parseUnsafeString)(node.label);
          nodes[label] = Object.assign({}, node, nodes[label]);
        }
      });
    } // require good name and value


    if (config.sortOrder === 'ascending') {
      nodesArr.sort(function (key1, key2) {
        return nodes[key1].total - nodes[key2].total;
      });
    } else if (config.sortOrder === 'descending') {
      nodesArr.sort(function (key1, key2) {
        return nodes[key2].total - nodes[key1].total;
      });
    } // Parse node cosmetics


    nodesArr.forEach(function (label, index) {
      var node = nodes[label],
          resolvedStrokeWidth = (config.showNodeBorder ? config.nodeBorderThickness : 0) || 0;
      node.index = index;
      node.label = (0, _lib.parseUnsafeString)(node.label);
      node.alpha = (0, _lib.pluckNumber)(node.alpha, config.nodeAlpha);
      node.borderAlpha = (0, _lib.pluckNumber)(node.borderalpha, config.nodeBorderAlpha);
      node.hoverAlpha = (0, _lib.pluckNumber)(node.hoveralpha, config.nodeHoverAlpha);
      node.borderDashedLen = (0, _lib.pluckNumber)(node.borderdashedlen, config.nodeBorderDashedLen);
      node.borderDashedGap = (0, _lib.pluckNumber)(node.borderdashedgap, config.nodeBorderDashedGap);
      node.borderDashed = (0, _lib.pluckNumber)(node.borderdashed, config.nodeBorderDashed) ? [node.borderDashedLen, node.borderDashedGap] : 'none';
      node.rawColor = (0, _lib.pluck)(node.color, colorM.getPlotColor(index));
      node.unfocussedAlpha = (0, _lib.pluckNumber)(node.unfocussedalpha, config.unfocussedAlpha);
      node.borderColor = (0, _lib.pluck)(node.bordercolor, config.nodeBorderColor, (0, _lib.getDarkColor)(node.rawColor, 80));
      node.tooltext = (0, _lib.pluck)(node.tooltext, chartAttrs.plottooltext, _lib.UNDEF);
      node.color = (0, _lib.hashify)(node.rawColor);
      node.labelPosition = (0, _lib.pluck)(node.labelposition, config.nodeLabelPosition);
      node.nodeLabelGap = config.nodeLabelGap; // Export error when textPaths are used

      if ((0, _lib.pluckNumber)(chartAttrs.exportenabled) && (node.labelPosition === OUTSIDE || node.labelPosition === INSIDE)) {
        node.showLabel = 0;
      } else {
        node.showLabel = (0, _lib.pluckNumber)(node.showlabel, config.showNodeLabels);
      }

      node.showBorder = config.showNodeBorder;
      node.labelColor = (0, _lib.pluck)(node.labelcolor, config.nodeLabelColor);
      node.style = config.datalabelStyle;
      node.focussedState = {
        fill: (0, _lib.convertColor)(node.rawColor, node.hoverAlpha),
        stroke: (0, _lib.convertColor)(node.borderColor, node.borderAlpha),
        'stroke-width': resolvedStrokeWidth,
        'stroke-dasharray': node.borderDashed
      };
      node.normalState = {
        fill: (0, _lib.convertColor)(node.rawColor, node.alpha),
        stroke: (0, _lib.convertColor)(node.borderColor, node.borderAlpha),
        'stroke-width': resolvedStrokeWidth,
        'stroke-dasharray': node.borderDashed
      };
      node.unfocussedState = {
        fill: (0, _lib.convertColor)(node.rawColor, node.unfocussedAlpha),
        stroke: (0, _lib.convertColor)(node.borderColor, node.unfocussedAlpha),
        'stroke-width': resolvedStrokeWidth,
        'stroke-dasharray': node.borderDashed
      };
      node.deactiveState = {
        fill: config.deactiveNodeColor,
        stroke: config.deactiveNodeColor,
        'stroke-width': resolvedStrokeWidth,
        'stroke-dasharray': node.borderDashed
      };
      node.linkedLinks.forEach(function (key) {
        var startsWithRegex = new RegExp("^" + node.label),
            tooltip = links[key].tooltip;

        for (var toolKey in tooltip) {
          if (tooltip.hasOwnProperty(toolKey) && startsWithRegex.test(toolKey)) {
            tooltip[toolKey].color = node.color;
          }
        }
      });
    });
    linksArr.forEach(function (key) {
      var link = links[key],
          _link$linkedNodes = link.linkedNodes,
          from = _link$linkedNodes[0],
          to = _link$linkedNodes[1];

      if (from === to) {
        link.dominantNode.push(from);
        link.subservientNode.push(from);
        link.subservientFlowDataValue.push(numberFormatter.dataLabels(link[from]));
        link.dominantFlowDataValue.push(numberFormatter.dataLabels(link[from]));
        link.dominantNodeColor.push(nodes[from].color);
        link.subservientNodeColor.push(nodes[from].color); // for equal contributing nodes
      }

      if (link[to] === link[from]) {
        link.dominantNode.push(from, to);
        link.subservientNode.push(to, from);
        link.subservientFlowDataValue.push(numberFormatter.dataLabels(link[to]));
        link.dominantFlowDataValue.push(numberFormatter.dataLabels(link[from]));
        link.dominantNodeColor.push(nodes[from].color, nodes[to].color);
        link.subservientNodeColor.push(nodes[to].color, nodes[from].color);
      } else {
        if (config.isPost) {
          if ((link[to] || 0) > (link[from] || 0)) {
            config.linkColorByDominance ? link.dominantNode.push(to) : link.dominantNode.push(from);
            config.linkColorByDominance ? link.subservientNode.push(from) : link.subservientNode.push(to);
            config.linkColorByDominance ? link.dominantFlowDataValue.push(numberFormatter.dataLabels(link[to])) : link.dominantFlowDataValue.push(numberFormatter.dataLabels(link[from]));
            config.linkColorByDominance ? link.subservientFlowDataValue.push(numberFormatter.dataLabels(link[from])) : link.subservientFlowDataValue.push(numberFormatter.dataLabels(link[to]));
            config.linkColorByDominance ? link.dominantNodeColor.push(nodes[to].color) : link.dominantNodeColor.push(nodes[from].color);
            config.linkColorByDominance ? link.subservientNodeColor.push(nodes[from].color) : link.subservientNodeColor.push(nodes[to].color);
          } else {
            config.linkColorByDominance ? link.dominantNode.push(from) : link.dominantNode.push(to);
            config.linkColorByDominance ? link.subservientNode.push(to) : link.subservientNode.push(from);
            config.linkColorByDominance ? link.dominantFlowDataValue.push(numberFormatter.dataLabels(link[from])) : link.dominantFlowDataValue.push(numberFormatter.dataLabels(link[to]));
            config.linkColorByDominance ? link.subservientFlowDataValue.push(numberFormatter.dataLabels(link[to])) : link.subservientFlowDataValue.push(numberFormatter.dataLabels(link[from]));
            config.linkColorByDominance ? link.dominantNodeColor.push(nodes[from].color) : link.dominantNodeColor.push(nodes[to].color);
            config.linkColorByDominance ? link.subservientNodeColor.push(nodes[to].color) : link.subservientNodeColor.push(nodes[from].color);
          }
        } else {
          if ((link[to] || 0) > (link[from] || 0)) {
            config.linkColorByDominance ? link.dominantNode.push(from) : link.dominantNode.push(to);
            config.linkColorByDominance ? link.subservientNode.push(to) : link.subservientNode.push(from);
            config.linkColorByDominance ? link.dominantFlowDataValue.push(numberFormatter.dataLabels(link[from])) : link.dominantFlowDataValue.push(numberFormatter.dataLabels(link[to]));
            config.linkColorByDominance ? link.subservientFlowDataValue.push(numberFormatter.dataLabels(link[to])) : link.subservientFlowDataValue.push(numberFormatter.dataLabels(link[from]));
            config.linkColorByDominance ? link.dominantNodeColor.push(nodes[from].color) : link.dominantNodeColor.push(nodes[to].color);
            config.linkColorByDominance ? link.subservientNodeColor.push(nodes[to].color) : link.subservientNodeColor.push(nodes[from].color);
          } else {
            config.linkColorByDominance ? link.dominantNode.push(to) : link.dominantNode.push(from);
            config.linkColorByDominance ? link.subservientNode.push(from) : link.subservientNode.push(to);
            config.linkColorByDominance ? link.dominantFlowDataValue.push(numberFormatter.dataLabels(link[to])) : link.dominantFlowDataValue.push(numberFormatter.dataLabels(link[from]));
            config.linkColorByDominance ? link.subservientFlowDataValue.push(numberFormatter.dataLabels(link[from])) : link.subservientFlowDataValue.push(numberFormatter.dataLabels(link[to]));
            config.linkColorByDominance ? link.dominantNodeColor.push(nodes[to].color) : link.dominantNodeColor.push(nodes[from].color);
            config.linkColorByDominance ? link.subservientNodeColor.push(nodes[from].color) : link.subservientNodeColor.push(nodes[to].color);
          }
        }
      }
    });
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */
  ;

  Chord.getName = function getName() {
    return 'Chord';
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */
  ;

  _proto.getName = function getName() {
    return 'Chord';
  }
  /**
   * This method return the dataset definations for this charts
   * @return {string} dataset defination
   */
  ;

  _proto.getDSdef = function getDSdef() {
    return _nodeLinkManager2.default;
  }
  /**
   * function to calculate and allote space for legend
   */
  ;

  _proto._manageLegendSpace = function _manageLegendSpace() {
    _legendSpacemanager._manageLegendSpace.call(this);
  };

  _proto._spaceManager = function _spaceManager() {
    var chart = this,
        config = chart.config,
        height,
        width,
        cx,
        cy,
        nodesLinkManager = chart.getChildren('node-link-manager')[0],
        maxNodeDim,
        maxRadius,
        minRadius,
        maxSpace;
    config.showLegend && chart._manageLegendSpace();

    chart._manageChartMenuBar(config.availableHeight * 0.6);

    chart.allocateDimensionOfChartMenuBar();
    chart.config.showLegend && chart.getChildren('legend') && chart.getChildren('legend')[0].postSpaceManager();
    height = config.canvasHeight;
    width = config.canvasWidth;
    cx = config.canvasLeft + width / 2;
    cy = config.canvasTop + height / 2;
    maxRadius = Math.min(height, width) / 2;
    minRadius = maxRadius * 0.3;
    maxSpace = maxRadius - minRadius - config.nodeLabelGap;
    maxNodeDim = nodesLinkManager._manageSpace({
      maxSpace: maxSpace
    });
    chart.config.cx = cx;
    chart.config.cy = cy;
    var nodeOuterRadius = Math.max((maxRadius - maxNodeDim.width - config.nodeLabelGap) * config.chordradius / 100, minRadius),
        nodeInnerRadius = nodeOuterRadius - config.nodeThickness,
        ribbonRadius = nodeInnerRadius - config.nodeLinkPadding;
    config.ribbonRadius = ribbonRadius;
    nodesLinkManager.setDimension({
      nodeOuterRadius: nodeOuterRadius,
      nodeInnerRadius: nodeInnerRadius,
      ribbonRadius: ribbonRadius
    });
    nodesLinkManager.setTranslation(cx, cy);
  }
  /**
   * Function to check if the chart has the proper data or not
   * @return {boolean} if JSON data is valid or not
   */
  ;

  _proto._checkInvalidData = function _checkInvalidData() {
    var chartInstance = this.getFromEnv('chartInstance'); // Checking if the chart has proper data

    if (!(0, _arrayHasContent.default)(this.getFromEnv('dataSource').links)) {
      chartInstance.__state.dataReady = false;
      chartInstance.jsVars.hasNativeMessage = true;
      chartInstance.jsVars.drawCount += 1;
      return true;
    }

    return !this;
  };

  _proto._checkInvalidSpecificData = function _checkInvalidSpecificData() {
    // temp code
    return !this;
  };

  return Chord;
}(_commonchartapi.default);

var _default = Chord;
exports["default"] = _default;

/***/ }),

/***/ 1470:
/***/ ((__unused_webpack_module, exports) => {



exports.__esModule = true;
exports.normaliseAngle = normaliseAngle;
exports.getArcLength = getArcLength;
exports.getTextRotationByQuadrant = getTextRotationByQuadrant;
exports.isAngleInLeftHemisphere = isAngleInLeftHemisphere;
exports.isAngleInTopHemisphere = isAngleInTopHemisphere;
exports.getCartesianDistance = getCartesianDistance;
exports.MEDIUMSQUARE = exports.SMALLSQUARE = exports.HALF_PI = exports.PI2 = exports.COS = exports.SIN = exports.PI = exports.C = exports.Z = exports.L = exports.A = exports.M = void 0;
var NOMRALIZE_CONSTANT = 90,
    M = 'M',
    A = 'A',
    L = 'L',
    Z = 'Z',
    C = 'C',
    PI = Math.PI,
    SIN = Math.sin,
    COS = Math.cos,
    PI2 = PI * 2,
    HALF_PI = PI / 2,
    SMALLSQUARE = '&#9632;',
    MEDIUMSQUARE = '&#9724;';
exports.MEDIUMSQUARE = MEDIUMSQUARE;
exports.SMALLSQUARE = SMALLSQUARE;
exports.HALF_PI = HALF_PI;
exports.PI2 = PI2;
exports.COS = COS;
exports.SIN = SIN;
exports.PI = PI;
exports.C = C;
exports.Z = Z;
exports.L = L;
exports.A = A;
exports.M = M;

function normaliseAngle(angle) {
  return angle - NOMRALIZE_CONSTANT;
}

function isAngleInLeftHemisphere(_rotationAngle) {
  return Math.abs(_rotationAngle) > 90 && Math.abs(_rotationAngle) < 270;
}

function isAngleInTopHemisphere(_angle) {
  return Math.abs(_angle) > 180 && Math.abs(_angle) < 360;
}

function getCartesianDistance(x1, y1, x2, y2) {
  return Math.sqrt((x2 - x1) * (x2 - x1) + (y2 - y1) * (y2 - y1));
}

function getArcLength(_radius, _startAngle, _endAngle) {
  return PI2 * _radius * Math.abs(_endAngle - _startAngle) / 360;
}
/**
 * Text is rotated according to which quadrant of the circle it is
 * currently placed in
 */


function getTextRotationByQuadrant(_angle) {
  var rotationAngle = _angle;

  if (isAngleInLeftHemisphere(rotationAngle)) {
    rotationAngle = rotationAngle - 180;
  }

  return rotationAngle;
}

/***/ }),

/***/ 1359:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _dragcolumn2d = _interopRequireDefault(__webpack_require__(1342));

var _dragarea = _interopRequireDefault(__webpack_require__(1356));

var _lib = __webpack_require__(274);

var _areabase = __webpack_require__(740);

/* eslint require-jsdoc: 'error', valid-jsdoc: ["error", { "requireReturn": false }] */

/**
 * API class of dragcolumn inheriting from area class
 */
var DragArea = /*#__PURE__*/function (_DragColumn) {
  (0, _inheritsLoose2.default)(DragArea, _DragColumn);

  function DragArea() {
    return _DragColumn.apply(this, arguments) || this;
  }

  var _proto = DragArea.prototype;

  /**
   * Sets the name of the component
   * @return {string} name
   */
  _proto.getName = function getName() {
    return 'DragArea';
  }
  /**
   * Provides the name of the chart extension
   *
   * @static
   * @return {string} The name of the chart extension
   */
  ;

  DragArea.getName = function getName() {
    return 'DragArea';
  } // eslint-disable-next-line
  ;

  _proto.getDSGroupdef = function getDSGroupdef() {}
  /**
   * Function to parse chart specific configurations. It first calls the __setDefaultConfig of areabase class.
   */
  ;

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    _DragColumn.prototype.__setDefaultConfig.call(this);

    var chart = this,
        config = chart.config;

    _areabase._setDefaultConfig.call(chart);

    config.isDrag = true;
    config.anchoralpha = _lib.HUNDREDSTRING;
    config.enablemousetracking = true;
    config.defaultcrosslinethickness = 1;
  }
  /**
   * Function to return the dataset liked with the current API
   * @return {Object} The DragAreaDataset class
   */
  ;

  _proto.getDSdef = function getDSdef() {
    return _dragarea.default;
  };

  return DragArea;
}(_dragcolumn2d.default);

var _default = DragArea;
exports["default"] = _default;

/***/ }),

/***/ 1342:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _dragbase = _interopRequireDefault(__webpack_require__(1343));

var _dragcolumn = _interopRequireDefault(__webpack_require__(1346));

var _dragcolumnMultiseries = _interopRequireDefault(__webpack_require__(1348));

var _limitUpdater = _interopRequireDefault(__webpack_require__(1349));

var _dragTracker = _interopRequireDefault(__webpack_require__(1351));

/* eslint require-jsdoc: 'error', valid-jsdoc: ["error", { "requireReturn": false }] */

/**
 * API class of dragcolumn inheriting from column class
 */
var DragColumn = /*#__PURE__*/function (_DragBase) {
  (0, _inheritsLoose2.default)(DragColumn, _DragBase);

  /**
   * constructor to register limit updater
   */
  function DragColumn() {
    var _this;

    _this = _DragBase.call(this) || this;

    _this.registerFactory('limitUpdater', _limitUpdater.default, ['axis']);

    _this.registerFactory('dragTracker', _dragTracker.default, ['canvas']);

    return _this;
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */


  var _proto = DragColumn.prototype;

  _proto.getName = function getName() {
    return 'DragColumn2D';
  }
  /**
   * Provides the name of the chart extension
   *
   * @static
   * @return {string} The name of the chart extension
   */
  ;

  DragColumn.getName = function getName() {
    return 'DragColumn2D';
  }
  /**
   * This method return the dataset-group definations for this charts
   * @return {Object}       Multiseries Dragcolumn group definition
   */
  ;

  _proto.getDSGroupdef = function getDSGroupdef() {
    return _dragcolumnMultiseries.default;
  }
  /**
   * Function to parse chart specific configurations.
   */
  ;

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    _DragBase.prototype.__setDefaultConfig.call(this);

    this.config.isDrag = true;
  }
  /**
   * Function to return the dataset liked with the current API
   * @return {Object} The DragColumnDataset class
   */
  ;

  _proto.getDSdef = function getDSdef() {
    return _dragcolumn.default;
  };

  return DragColumn;
}(_dragbase.default);

var _default = DragColumn;
exports["default"] = _default;

/***/ }),

/***/ 1354:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _dragline = _interopRequireDefault(__webpack_require__(1355));

var _dragarea = _interopRequireDefault(__webpack_require__(1359));

/* eslint require-jsdoc: 'error', valid-jsdoc: ["error", { "requireReturn": false }] */

/**
 * API class of dragcolumn inheriting from area class
 */
var DragLine = /*#__PURE__*/function (_DragArea) {
  (0, _inheritsLoose2.default)(DragLine, _DragArea);

  function DragLine() {
    var _this;

    _this = _DragArea.call(this) || this;
    _this.defaultPlotShadow = 1;
    return _this;
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */


  var _proto = DragLine.prototype;

  _proto.getName = function getName() {
    return 'DragLine';
  }
  /**
   * Provides the name of the chart extension
   *
   * @static
   * @return {string} The name of the chart extension
   */
  ;

  DragLine.getName = function getName() {
    return 'DragLine';
  }
  /**
   * Function to parse chart specific configurations. It first calls the __setDefaultConfig of areabase class.
   */
  ;

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    _DragArea.prototype.__setDefaultConfig.call(this);

    var config = this.config;
    config.isDrag = true;
    config.zeroplanethickness = 1;
    config.zeroplanealpha = 40;
    config.showzeroplaneontop = 0;
    config.enablemousetracking = true;
    config.defaultcrosslinethickness = 1;
  }
  /**
   * Function to return the dataset liked with the current API
   * @return {Object} The DragLineDataset class
   */
  ;

  _proto.getDSdef = function getDSdef() {
    return _dragline.default;
  };

  return DragLine;
}(_dragarea.default);

var _default = DragLine;
exports["default"] = _default;

/***/ }),

/***/ 1395:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports.configurer = exports["default"] = void 0;

var _assertThisInitialized2 = _interopRequireDefault(__webpack_require__(292));

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _dragbase = _interopRequireDefault(__webpack_require__(1343));

var _dragnode = __webpack_require__(1396);

var _lib = __webpack_require__(274);

var _dependencyManager = __webpack_require__(282);

var _dragnodeDataset = _interopRequireDefault(__webpack_require__(1404));

var _editableCharts = __webpack_require__(1345);

var _xyAxis = _interopRequireDefault(__webpack_require__(722));

var _baseChart = __webpack_require__(327);

/* eslint require-jsdoc: 'error', valid-jsdoc: ["error", { "requireReturn": false }] */
var DRAGNODE = 'dragnode';
var configurer, UNDEF;
/**
 * API class of dragcolumn inheriting from column class
 */

exports.configurer = configurer;

var DragNode = /*#__PURE__*/function (_DragBase) {
  (0, _inheritsLoose2.default)(DragNode, _DragBase);

  /**
   * Provides the name of the chart extension
   *
   * @static
   * @return {string} The name of the chart extension
   */
  DragNode.getName = function getName() {
    return 'DragNode';
  }
  /**
   * Constructor function of DragNode class
   */
  ;

  function DragNode() {
    var _this;

    _this = _DragBase.call(this) || this;
    var chart = (0, _assertThisInitialized2.default)(_this);
    chart.fireGroupEvent = true;
    chart.usesXYinCategory = true;
    chart.dontShowLegendByDefault = true;

    _this.registerFactory('dataset', _dragnodeDataset.default, ['vCanvas']);

    _this.registerFactory('axis', _xyAxis.default, ['canvas']);

    return _this;
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */


  var _proto = DragNode.prototype;

  _proto.getName = function getName() {
    return 'DragNode';
  }
  /**
   * function to check if the chart specific data is proper is not
   * this fn is define for specific chart types
   * @return {boolean} if JSON data is valid or not
   */
  ;

  _proto._checkInvalidSpecificData = function _checkInvalidSpecificData() {
    var datasetsJSON = this.getFromEnv('dataSource').dataset; // eslint-disable-line good-practices/no-single-usage-variable

    if (!datasetsJSON) {
      return true;
    }
  }
  /**
   * Decides event type and calls handler manager accordingly.
   *
   * @param {any} e e
   * @param {any} data data
   * @memberof DragNode
   */
  ;

  _proto._mouseEvtHandler = function _mouseEvtHandler(e, data) {
    (0, _baseChart._mouseEvtHandler)(this, e, data);
  }
  /**
   * Function to parse the common configurations at dataset level
   * @param {Object} dataObj contains json data of the chart
   */
  ;

  _proto.parseChartAttr = function parseChartAttr(dataObj) {
    var iapi = this,
        chartAttr = iapi.getFromEnv('dataSource').chart,
        config,
        transcoders = (0, _dependencyManager.getDepsByType)('transcoder');

    _DragBase.prototype.parseChartAttr.call(this, dataObj);

    config = iapi.config;
    config.formAction = (0, _lib.getValidValue)(chartAttr.formaction);
    config.showLegend = (0, _lib.pluckNumber)(chartAttr.showlegend, 0);

    if (chartAttr.submitdataasxml === _lib.ZEROSTRING && !chartAttr.formdataformat) {
      chartAttr.formdataformat = transcoders.csv().format;
    }

    config.formDataFormat = (0, _lib.pluck)(chartAttr.formdataformat, transcoders.xml().format);
    config.formTarget = (0, _lib.pluck)(chartAttr.formtarget, '_self');
    config.formMethod = (0, _lib.pluck)(chartAttr.formmethod, 'POST');
    config.submitFormAsAjax = (0, _lib.pluckNumber)(chartAttr.submitformusingajax, 1);
    config.viewMode = (0, _lib.pluckNumber)(chartAttr.viewmode, 0);
    config.drawTrendRegion = 0;
  }
  /**
   * Parsing the default configuration of the chart
   */
  ;

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    _DragBase.prototype.__setDefaultConfig.call(this);

    var chartConf = this.config;
    chartConf.hasLegend = true;
    chartConf.defaultDatasetType = DRAGNODE;
    chartConf.limitUpdaterEnabled = false;
    chartConf.skipClipping = true;
    chartConf.numVDivLines = 0;
    chartConf.numDivLines = 0;
    chartConf.setadaptivexmin = 1;
    chartConf.showLimits = 0;
    chartConf.showdivlinevalues = 0;
    chartConf.showzeroplane = 0;
    chartConf.showyaxisvalues = 0;
    chartConf.enablemousetracking = true;
    chartConf.showzeroplaneontop = 0;
  }
  /**
   * Function to add the menu options for the menu list
   */
  ;

  _proto.addConfigureOptions = function addConfigureOptions() {
    var chart = this,
        chartConf = chart.config,
        restore,
        submit,
        toolbar = chart.getFromEnv('toolbar'),
        hamburgerMenu = toolbar.getChild("hamburgerMenu-" + toolbar.getId() + "-" + chart.getId() + "-0"),
        // eslint-disable-line good-practices/no-single-usage-variable
    configureTools = [{
      name: 'Add Node',
      handler: function handler() {
        var manager = chart.getChildren('canvas')[0].getChildren('vCanvas')[0] // eslint-disable-line good-practices/no-single-usage-variable
        .getChildren('datasetGroup_dragNode')[0];
        manager.showNodeAddUI();
      },
      action: 'click'
    }, {
      name: 'Add Connector',
      handler: function handler() {
        var manager = chart.getChildren('canvas')[0].getChildren('vCanvas')[0] // eslint-disable-line good-practices/no-single-usage-variable
        .getChildren('datasetGroup_dragNode')[0];
        manager.showConnectorAddUI();
      },
      action: 'click'
    }, {
      name: 'Add Label',
      handler: function handler() {
        var manager = chart.getChildren('canvas')[0].getChildren('vCanvas')[0] // eslint-disable-line good-practices/no-single-usage-variable
        .getChildren('datasetGroup_dragNode')[0];
        manager.showLabelUpdateUI();
      },
      action: 'click'
    }];

    if (chartConf.showRestoreBtn) {
      restore = {
        name: chartConf.restoreBtnTitle,
        handler: function handler() {
          var manager = chart.getChildren('canvas')[0].getChildren('vCanvas')[0] // eslint-disable-line good-practices/no-single-usage-variable
          .getChildren('datasetGroup_dragNode')[0];
          manager.restoreData();
        },
        action: 'click'
      };
      configureTools.push(restore);
    }

    if (chartConf.showFormBtn) {
      submit = {
        name: chartConf.submitBtnTitle,
        handler: function handler() {
          _editableCharts.submitData.call(chart);
        },
        action: 'click'
      };
      configureTools.push(submit);
    } // setChartTools(configureTools);


    if (!chart.config.viewMode) {
      hamburgerMenu.appendInMenu(configureTools);
    }
  }
  /**
   * Function to map the dataset class to its type
   * @param {string} dsType the type of the dataset.
   * @return {Class} The corresponding dataset class.
   */
  ;

  _proto.getDSdef = function getDSdef(dsType) {
    switch (dsType) {
      case 'connector':
        return _dragnode.DragNodeConnector;

      case 'dragnode':
        return _dragnode.DragNodeDataset;

      case 'dragableLabels':
        return _dragnode.DragNodeLabels;
    }
  }
  /**
   * Function to determine the group manager associated with the current chartAPI
   * @return {Class} The group class
   */
  ;

  _proto.getDSGroupdef = function getDSGroupdef() {
    return _dragnode.DragNodeGroup;
  }
  /**
   * Fucntion to set the categories of X axes.
   */
  ;

  _proto._setCategories = function _setCategories() {
    var iapi = this,
        dataObj = iapi.getFromEnv('dataSource'),
        xAxis = iapi.getChildren('xAxis'),
        categories = dataObj.categories && dataObj.categories[0].category || [],
        catLen = categories.length,
        // eslint-disable-line good-practices/no-single-usage-variable
    catArr = [],
        i,
        catObj;

    for (i = 0; i < catLen; i++) {
      catObj = categories[i] || {};

      if (catObj.x !== UNDEF) {
        catArr.push(catObj);
      }
    }

    xAxis && xAxis[0].setTickValues(catArr);
  }
  /**
   * Function to get the jsonData
   * @return {Object} the jsonData
   */
  ;

  _proto.getJSONData = function getJSONData() {
    var chart = this,
        canvas = chart.getChildren('canvas')[0],
        // eslint-disable-line good-practices/no-single-usage-variable
    vCanvas = canvas.getChildren('vCanvas')[0],
        // eslint-disable-line good-practices/no-single-usage-variable
    groupManager = vCanvas.getChildren('datasetGroup_dragNode')[0],
        datasetsArr = {},
        jsonObj;

    if (groupManager) {
      datasetsArr = groupManager.getJSONData();
    }

    jsonObj = (0, _lib.extend2)({}, chart.getFromEnv('dataSource'));
    jsonObj.dataset = datasetsArr.dataset;
    jsonObj.connectors = datasetsArr.connectors;
    jsonObj.labels = datasetsArr.labels;
    return jsonObj;
  };

  return DragNode;
}(_dragbase.default);

exports.configurer = configurer = DragNode.prototype.configure;
var _default = DragNode;
exports["default"] = _default;

/***/ }),

/***/ 1322:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _mscartesian = _interopRequireDefault(__webpack_require__(626));

var _columnMultiseries = _interopRequireDefault(__webpack_require__(689));

var _errorbar2d = _interopRequireDefault(__webpack_require__(1323));

var ERRORBAR_2D = 'errorbar2d';

var ErrorBar2D = /*#__PURE__*/function (_MSCartesian) {
  (0, _inheritsLoose2.default)(ErrorBar2D, _MSCartesian);

  /**
   * Provides the name of the chart extension
   *
   * @static
   * @return {string} The name of the chart extension
   */
  ErrorBar2D.getName = function getName() {
    return 'ErrorBar2D';
  };

  function ErrorBar2D() {
    var _this;

    _this = _MSCartesian.call(this) || this;
    _this.showValues = 0;
    _this.isErrorChart = true; // this.fireGroupEvent = true;

    _this.eiMethods = {};
    return _this;
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */


  var _proto = ErrorBar2D.prototype;

  _proto.getName = function getName() {
    return 'ErrorBar2D';
  };

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    _MSCartesian.prototype.__setDefaultConfig.call(this);

    var config = this.config;
    config.hasLegend = true;
    config.defaultDatasetType = ERRORBAR_2D;
    config.enablemousetracking = true;
  };

  _proto.getDSGroupdef = function getDSGroupdef() {
    return _columnMultiseries.default;
  };

  _proto.getDSdef = function getDSdef() {
    return _errorbar2d.default;
  };

  return ErrorBar2D;
}(_mscartesian.default);

var _default = ErrorBar2D;
exports["default"] = _default;

/***/ }),

/***/ 1326:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _mscartesian = _interopRequireDefault(__webpack_require__(626));

var _areabase = __webpack_require__(740);

var _errorline = _interopRequireDefault(__webpack_require__(1327));

var ERRORLINE = 'errorline';

var ErrorLine = /*#__PURE__*/function (_MSCartesian) {
  (0, _inheritsLoose2.default)(ErrorLine, _MSCartesian);

  /**
   * Provides the name of the chart extension
   *
   * @static
   * @return {string} The name of the chart extension
   */
  ErrorLine.getName = function getName() {
    return 'ErrorLine';
  };

  function ErrorLine() {
    var _this;

    _this = _MSCartesian.call(this) || this;
    _this.useErrorGroup = true;
    _this.isErrorChart = true;
    _this.hasAnchor = true; // this.fireGroupEvent = true;

    _this.defaultPlotShadow = 1;
    _this.axisPaddingLeft = 0;
    _this.axisPaddingRight = 0;
    _this.canvasPaddingModifiers = ['anchor', 'errorbar'];
    return _this;
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */


  var _proto = ErrorLine.prototype;

  _proto.getName = function getName() {
    return 'ErrorLine';
  };

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    _MSCartesian.prototype.__setDefaultConfig.call(this);

    var config = this.config;
    config.defaultDatasetType = ERRORLINE;

    _areabase._setDefaultConfig.call(this);

    this.zeroplanethickness = 1;
    this.zeroplanealpha = 40;
    config.showzeroplaneontop = 0;
    config.defaultcrosslinethickness = 1;
    config.enablemousetracking = true;
  };

  _proto.getDSGroupdef = function getDSGroupdef() {// this fn overrides
  };

  _proto.getDSdef = function getDSdef() {
    return _errorline.default;
  };

  return ErrorLine;
}(_mscartesian.default);

var _default = ErrorLine;
exports["default"] = _default;

/***/ }),

/***/ 1331:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _scatterbase = _interopRequireDefault(__webpack_require__(719));

var _errorscatter = _interopRequireDefault(__webpack_require__(1332));

var ERRORSCATTER = 'errorscatter';

var ErrorScatter = /*#__PURE__*/function (_ScatterBase) {
  (0, _inheritsLoose2.default)(ErrorScatter, _ScatterBase);

  /**
   * Provides the name of the chart extension
   *
   * @static
   * @return {string} The name of the chart extension
   */
  ErrorScatter.getName = function getName() {
    return 'ErrorScatter';
  };

  function ErrorScatter() {
    var _this;

    _this = _ScatterBase.call(this) || this;
    _this.isXY = true;
    _this.defaultZeroPlaneHighlighted = false;
    _this.useErrorGroup = true;
    _this.isErrorChart = true;
    _this.hasAnchor = true; // this.fireGroupEvent = true;

    _this.initAnimation = true;
    return _this;
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */


  var _proto = ErrorScatter.prototype;

  _proto.getName = function getName() {
    return 'ErrorScatter';
  };

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    _ScatterBase.prototype.__setDefaultConfig.call(this);

    var config = this.config;
    config.defaultDatasetType = ERRORSCATTER;
    config.enablemousetracking = true;
  };

  _proto.getDSGroupdef = function getDSGroupdef() {// this fn overrides
  };

  _proto.getDSdef = function getDSdef() {
    return _errorscatter.default;
  };

  return ErrorScatter;
}(_scatterbase.default);

var _default = ErrorScatter;
exports["default"] = _default;

/***/ }),

/***/ 1439:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _mscartesian = _interopRequireDefault(__webpack_require__(626));

var _heatmap = _interopRequireDefault(__webpack_require__(1440));

var _heatmap2 = _interopRequireDefault(__webpack_require__(1442));

var _categoryAxis = _interopRequireDefault(__webpack_require__(1443));

var _multiseriesDataset = _interopRequireDefault(__webpack_require__(628));

var _colorrange = _interopRequireDefault(__webpack_require__(1444));

var _legendmanager = _interopRequireDefault(__webpack_require__(1448));

var _lib = __webpack_require__(274);

var _equal = _interopRequireDefault(__webpack_require__(421));

var defaultFontStr = _lib.preDefStr.defaultFontStr,
    divLineAlpha3DStr = _lib.preDefStr.divLineAlpha3DStr,
    divLineAlphaStr = _lib.preDefStr.divLineAlphaStr,
    altVGridColorStr = _lib.preDefStr.altVGridColorStr,
    altVGridAlphaStr = _lib.preDefStr.altVGridAlphaStr,
    altHGridColorStr = _lib.preDefStr.altHGridColorStr,
    altHGridAlphaStr = _lib.preDefStr.altHGridAlphaStr,
    colorStrings = _lib.preDefStr.colors,
    COLOR_000000 = colorStrings.c000000,
    EQUAL_STR = ' = ',
    HEATMAP = 'heatmap',
    UNDEF,
    checkValidId = function checkValidId(item) {
  return item.id !== UNDEF;
};

var HeatMap = /*#__PURE__*/function (_MSCartesian) {
  (0, _inheritsLoose2.default)(HeatMap, _MSCartesian);

  /**
   * Provides the name of the chart extension
   *
   * @static
   * @return {string} The name of the chart extension
   */
  HeatMap.getName = function getName() {
    return 'HeatMap';
  };

  function HeatMap() {
    var _this;

    _this = _MSCartesian.call(this) || this;
    _this.tooltipsepchar = EQUAL_STR;
    _this.hasGradientLegend = true;

    _this.registerFactory('axis', _categoryAxis.default, ['canvas']); // decide and create legend after creating canvas


    _this.registerFactory('legend', _legendmanager.default, ['canvas']); // create color manager after creating legend-decider


    _this.registerFactory('colormanager-decider', _colorrange.default, ['legend']); // create dataset after creating colormanager-decider and vCanvas


    _this.registerFactory('dataset', _multiseriesDataset.default, ['colormanager-decider', 'vCanvas']);

    return _this;
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */


  var _proto = HeatMap.prototype;

  _proto.getName = function getName() {
    return 'HeatMap';
  };

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    _MSCartesian.prototype.__setDefaultConfig.call(this);

    var config = this.config;
    config.isSingleSeries = true;
    config.hasLegend = true;
    config.defaultDatasetType = HEATMAP;
    config.enablemousetracking = true;
  }
  /**
   * function to check if the chart specific data is proper is not
   * this fn is define for specific chart types
   * @return {boolean} if JSON data is valid or not
   */
  ;

  _proto._checkInvalidSpecificData = function _checkInvalidSpecificData() {
    var jsonData = this.getFromEnv('dataSource'),
        dataset = jsonData.dataset,
        data,
        colorrange = jsonData.colorrange;

    if (dataset) {
      for (var i = 0; i < dataset.length; i++) {
        if (dataset[i].data) {
          data = dataset[i].data;
          break;
        }
      }
    }

    if (!dataset || !data || data.length === 0 || !colorrange || !colorrange.color && !Number(colorrange.gradient)) {
      return true;
    }
  }
  /**
   * Parse the chart attributes and store in chart's config
   * @param {Object} dataObj User input json
   */
  ;

  _proto.parseChartAttr = function parseChartAttr(dataObj) {
    _MSCartesian.prototype.parseChartAttr.call(this, dataObj);

    this.config.drawTrendRegion = 0;
  };

  _proto.configureAttributes = function configureAttributes(dataObj) {
    var iapi = this,
        chartConfig = iapi.config,
        dataSource = iapi.getFromEnv('dataSource'),
        skipConfigureIteration = iapi.config.skipConfigureIteration = {},
        // eslint-disable-line good-practices/no-single-usage-variable
    rows,
        columns,
        datasetArray = dataObj.dataset,
        unifiedDataset = [];
    rows = dataSource.rows && dataSource.rows.row.filter(checkValidId);
    columns = dataSource.columns && dataSource.columns.column.filter(checkValidId);

    if (!rows || !columns) {
      // create unified dataset
      for (var i = 0; i < datasetArray.length; i++) {
        for (var j = 0; j < datasetArray[i].data.length; j++) {
          unifiedDataset.push(datasetArray[i].data[j]);
        }
      }

      if (!rows) {
        // get unique rows by rowid property
        rows = unifiedDataset.map(function (item) {
          return (0, _lib.getFirstValue)(item.rowid);
        }).filter(function (value, index, self) {
          return self.indexOf(value) === index;
        });
      }

      if (!columns) {
        // get unique columns by columnid property
        columns = unifiedDataset.map(function (item) {
          return (0, _lib.getFirstValue)(item.columnid);
        }).filter(function (value, index, self) {
          return self.indexOf(value) === index;
        });
      }
    }

    iapi.parseChartAttr(dataObj);
    iapi.addToEnv('chartColorRange', dataObj.colorrange || {});
    iapi.createComponent(dataObj);

    iapi._feedAxesRawData();

    skipConfigureIteration.axis = true;
    iapi.addToEnv('totalRows', rows.length);
    iapi.addToEnv('totalColumns', columns.length);
    iapi.configureChildren(); // after configure chart calls its async draw

    iapi.asyncDraw();
    iapi.getFromEnv('toolTipController').setStyle({
      'backgroundColor': _lib.hasSVG ? (0, _lib.convertColor)(chartConfig.tooltipbgcolor || 'FFF', chartConfig.tooltipbgalpha || 100) : (chartConfig.tooltipbgcolor || 'FFF').replace(/\s+/g, '').replace(/^#?([a-f0-9]+)/ig, '#$1'),
      'color': (chartConfig.tooltipcolor || chartConfig.basefontcolor || '545454').replace(/^#?([a-f0-9]+)/ig, '#$1'),
      'borderColor': _lib.hasSVG ? (0, _lib.convertColor)(chartConfig.tooltipbordercolor || '666', chartConfig.tooltipborderalpha || 100) : (chartConfig.tooltipbordercolor || '666').replace(/\s+/g, '').replace(/^#?([a-f0-9]+)/ig, '#$1'),
      'borderWidth': (0, _lib.pluckNumber)(chartConfig.tooltipborderthickness, 1) + 'px',
      'showToolTipShadow': (0, _lib.pluckNumber)(chartConfig.showtooltipshadow || 0),
      'borderRadius': (0, _lib.pluckNumber)(chartConfig.tooltipborderradius, 0) + 'px',
      'fontSize': (0, _lib.pluckNumber)(chartConfig.basefontsize, 10) + 'px',
      'fontFamily': chartConfig.basefont || this.getFromEnv('style').inCanfontFamily,
      'padding': (0, _lib.pluckNumber)(chartConfig.tooltippadding || 3) + 'px'
    });
  };

  _proto._postSpaceManagement = function _postSpaceManagement() {
    var iapi = this,
        xAxis = iapi.getChildren('xAxis')[0],
        legend = iapi.getFromEnv('legend'),
        xDepth = iapi.config.xDepth; // eslint-disable-line good-practices/no-single-usage-variable

    iapi.setAxisDimention();
    xAxis && xAxis.shiftLabels(-xDepth, 0);
    legend && legend.postSpaceManager();
    iapi.allocateDimensionOfChartMenuBar();
  }
  /**
   * Sets dimension of Axis components
   */
  ;

  _proto.setAxisDimention = function setAxisDimention() {
    var iapi = this,
        xAxis = iapi.getChildren('xAxis') && iapi.getChildren('xAxis')[0],
        yAxis = iapi.getChildren('yAxis') && iapi.getChildren('yAxis')[0],
        chartConfig = iapi.getFromEnv('chartConfig'),
        canvas = iapi.getChildren('canvas')[0],
        canvasConfig = canvas.config,
        _canvas$getEffectiveD = canvas.getEffectiveDimensions(),
        left = _canvas$getEffectiveD.left,
        top = _canvas$getEffectiveD.top,
        width = _canvas$getEffectiveD.width,
        height = _canvas$getEffectiveD.height,
        paddingLeft = _canvas$getEffectiveD.paddingLeft,
        paddingRight = _canvas$getEffectiveD.paddingRight,
        canvasBorderWidth = canvasConfig && canvasConfig.canvasBorderWidth,
        canvasPadding = canvasConfig && canvasConfig.canvasPadding;

    xAxis && xAxis.setAxisConfig({
      'canvasPaddingLeft': Math.max(paddingLeft, canvasPadding),
      'canvasPaddingRight': Math.max(paddingRight, canvasPadding)
    });
    xAxis && xAxis.setAxisDimention({
      x: left,
      y: xAxis.config.isOpposit ? top + (chartConfig.shift || 0) - canvasBorderWidth : top + height + (chartConfig.shift || 0) + canvasBorderWidth,
      opposite: xAxis.config.isOpposit ? top + height + canvasBorderWidth : top - canvasBorderWidth,
      axisLength: width
    });
    yAxis && yAxis.setAxisDimention({
      x: yAxis.config.isOpposit ? left + width + canvasBorderWidth : left - canvasBorderWidth,
      y: top,
      opposite: yAxis.config.isOpposit ? left - canvasBorderWidth : left + width + canvasBorderWidth,
      axisLength: height
    });
  };

  _proto._feedAxesRawData = function _feedAxesRawData() {
    var iapi = this,
        colorM = iapi.getFromEnv('color-manager'),
        dataObj = iapi.getFromEnv('dataSource'),
        chartAttrs = dataObj.chart,
        xAxisConf,
        yAxisConf,
        is3D = iapi.config.is3D,
        palleteString = is3D ? _lib.chartPaletteStr.chart3D : _lib.chartPaletteStr.chart2D,
        xAxisPosition = (0, _lib.parseUnsafeString)(chartAttrs.xaxisposition).toLowerCase(),
        outCanfontSizeWithUnit = (0, _lib.pluckFontSizeMaintainUnit)(chartAttrs.outcnvbasefontsize, chartAttrs.basefontsize, 10);
    xAxisConf = {
      mapTickValuesById: true,
      isVertical: false,
      isReverse: false,
      isOpposit: (0, _lib.pluckNumber)(xAxisPosition === 'top' ? true : UNDEF, xAxisPosition === 'bottom' ? false : UNDEF, !!iapi.config.placeAxisLabelsOnTop),
      outCanfontFamily: (0, _lib.pluck)(chartAttrs.outcnvbasefont, chartAttrs.basefont, defaultFontStr),
      outCanfontSize: this.computeFontSize(outCanfontSizeWithUnit),
      outCanfontSizeWithUnit: outCanfontSizeWithUnit,
      outCancolor: (0, _lib.pluck)(chartAttrs.outcnvbasefontcolor, chartAttrs.basefontcolor, colorM.getColor(palleteString.baseFontColor)).replace(/^#?([a-f0-9]+)/ig, '#$1'),
      axisNamePadding: chartAttrs.xaxisnamepadding,
      axisValuePadding: (0, _lib.pluckNumber)(chartAttrs.labelxpadding, chartAttrs.labelpadding, 4),
      axisNameFont: chartAttrs.xaxisnamefont,
      axisNameFontSize: this.computeFontSize(chartAttrs.xaxisnamefontsize),
      axisNameFontSizeWithUnit: chartAttrs.xaxisnamefontsize,
      axisNameFontColor: chartAttrs.xaxisnamefontcolor,
      axisNameFontBold: chartAttrs.xaxisnamefontbold,
      axisNameFontItalic: chartAttrs.xaxisnamefontitalic,
      axisNameBgColor: chartAttrs.xaxisnamebgcolor,
      axisNameBorderColor: chartAttrs.xaxisnamebordercolor,
      axisNameAlpha: chartAttrs.xaxisnamealpha,
      axisNameFontAlpha: chartAttrs.xaxisnamefontalpha,
      axisNameBgAlpha: chartAttrs.xaxisnamebgalpha,
      axisNameBorderAlpha: chartAttrs.xaxisnameborderalpha,
      axisNameBorderPadding: chartAttrs.xaxisnameborderpadding,
      axisNameBorderRadius: chartAttrs.xaxisnameborderradius,
      axisNameBorderThickness: chartAttrs.xaxisnameborderthickness,
      axisNameBorderDashed: chartAttrs.xaxisnameborderdashed,
      axisNameBorderDashLen: chartAttrs.xaxisnameborderdashlen,
      axisNameBorderDashGap: chartAttrs.xaxisnameborderdashgap,
      useEllipsesWhenOverflow: chartAttrs.useellipseswhenoverflow,
      divLineColor: (0, _lib.pluck)(chartAttrs.vdivlinecolor, chartAttrs.divlinecolor, colorM.getColor(palleteString.divLineColor)),
      divLineAlpha: (0, _lib.pluck)(chartAttrs.vdivlinealpha, chartAttrs.divlinealpha, is3D ? colorM.getColor(divLineAlpha3DStr) : colorM.getColor(divLineAlphaStr)),
      divLineThickness: (0, _lib.pluckNumber)(chartAttrs.vdivlinethickness, chartAttrs.divlinethickness, 1),
      divLineIsDashed: Boolean((0, _lib.pluckNumber)(chartAttrs.vdivlinedashed, chartAttrs.vdivlineisdashed, chartAttrs.divlinedashed, chartAttrs.divlineisdashed, 0)),
      divLineDashLen: (0, _lib.pluckNumber)(chartAttrs.vdivlinedashlen, chartAttrs.divlinedashlen, 4),
      divLineDashGap: (0, _lib.pluckNumber)(chartAttrs.vdivlinedashgap, chartAttrs.divlinedashgap, 2),
      showAlternateGridColor: (0, _lib.pluckNumber)(chartAttrs.showalternatevgridcolor, 0),
      alternateGridColor: (0, _lib.pluck)(chartAttrs.alternatevgridcolor, colorM.getColor(altVGridColorStr)),
      alternateGridAlpha: (0, _lib.pluck)(chartAttrs.alternatevgridalpha, colorM.getColor(altVGridAlphaStr)),
      numDivLines: chartAttrs.numvdivlines,
      labelFont: chartAttrs.labelfont,
      labelFontSize: this.computeFontSize(chartAttrs.labelfontsize),
      labelFontSizeWithUnit: chartAttrs.labelfontsize,
      labelFontColor: chartAttrs.labelfontcolor,
      labelAlpha: chartAttrs.labelalpha,
      labelFontBold: chartAttrs.labelfontbold,
      labelFontItalic: chartAttrs.labelfontitalic,
      labelBdrColor: chartAttrs.labelbordercolor,
      labelBdrAlpha: chartAttrs.labelborderalpha,
      labelLink: chartAttrs.labellink,
      labelBgColor: chartAttrs.labelbgcolor,
      labelBgAlpha: chartAttrs.labelbgalpha,
      labelBdrThickness: chartAttrs.labelborderthickness,
      labelBdrPadding: chartAttrs.labelborderpadding,
      labelBdrRadius: chartAttrs.labelborderradius,
      labelBdrDashed: chartAttrs.labelborderdashed,
      labelBdrDashLen: chartAttrs.labelborderdashlen,
      labelBdrDashGap: chartAttrs.labelborderdashgap,
      axisName: chartAttrs.xaxisname,
      axisMinValue: chartAttrs.xaxisminvalue,
      axisMaxValue: chartAttrs.xaxismaxvalue,
      setAdaptiveMin: chartAttrs.setadaptivexmin,
      adjustDiv: chartAttrs.adjustvdiv,
      labelDisplay: chartAttrs.labeldisplay,
      showLabels: (0, _lib.pluckNumber)(chartAttrs.showxaxislabels, chartAttrs.showlabels),
      rotateLabels: chartAttrs.rotatexaxislabels,
      slantLabel: (0, _lib.pluckNumber)(chartAttrs.slantlabels, chartAttrs.slantlabel),
      labelStep: (0, _lib.pluckNumber)(chartAttrs.labelstep, chartAttrs.xaxisvaluesstep),
      showAxisValues: (0, _lib.pluckNumber)(chartAttrs.showxaxisvalues, chartAttrs.showxaxisvalue),
      maxLabelHeight: chartAttrs.maxlabelheight,
      showZeroPlane: chartAttrs.showvzeroplane,
      zeroPlaneColor: chartAttrs.vzeroplanecolor,
      zeroPlaneThickness: chartAttrs.vzeroplanethickness,
      zeroPlaneAlpha: chartAttrs.vzeroplanealpha,
      showZeroPlaneValue: chartAttrs.showvzeroplanevalue,
      trendlineColor: chartAttrs.trendlinecolor,
      trendlineToolText: chartAttrs.trendlinetooltext,
      trendlineThickness: chartAttrs.trendlinethickness,
      trendlineAlpha: chartAttrs.trendlinealpha,
      showTrendlinesOnTop: chartAttrs.showtrendlinesontop,
      showAxisLine: (0, _lib.pluckNumber)(chartAttrs.showxaxisline, chartAttrs.showaxislines, chartAttrs.drawAxisLines, 0),
      axisLineThickness: (0, _lib.pluckNumber)(chartAttrs.xaxislinethickness, chartAttrs.axislinethickness, 1),
      axisLineAlpha: (0, _lib.pluckNumber)(chartAttrs.xaxislinealpha, chartAttrs.axislinealpha, 100),
      axisLineColor: (0, _lib.pluck)(chartAttrs.xaxislinecolor, chartAttrs.axislinecolor, COLOR_000000)
    };
    yAxisConf = {
      mapTickValuesById: true,
      isVertical: true,
      isReverse: false,
      isOpposit: (0, _equal.default)(chartAttrs.yaxisposition, 'right'),
      outCanfontFamily: (0, _lib.pluck)(chartAttrs.outcnvbasefont, chartAttrs.basefont, defaultFontStr),
      outCanfontSize: this.computeFontSize(outCanfontSizeWithUnit),
      outCanfontSizeWithUnit: outCanfontSizeWithUnit,
      outCancolor: (0, _lib.pluck)(chartAttrs.outcnvbasefontcolor, chartAttrs.basefontcolor, colorM.getColor(palleteString.baseFontColor)).replace(/^#?([a-f0-9]+)/ig, '#$1'),
      axisNamePadding: chartAttrs.yaxisnamepadding,
      axisValuePadding: (0, _lib.pluckNumber)(chartAttrs.labelypadding, chartAttrs.yaxisvaluespadding, 4),
      axisNameFont: chartAttrs.yaxisnamefont,
      axisNameFontSize: this.computeFontSize(chartAttrs.yaxisnamefontsize),
      axisNameFontSizeWithUnit: chartAttrs.yaxisnamefontsize,
      axisNameFontColor: chartAttrs.yaxisnamefontcolor,
      axisNameFontBold: chartAttrs.yaxisnamefontbold,
      axisNameFontItalic: chartAttrs.yaxisnamefontitalic,
      axisNameBgColor: chartAttrs.yaxisnamebgcolor,
      axisNameBorderColor: chartAttrs.yaxisnamebordercolor,
      axisNameAlpha: chartAttrs.yaxisnamealpha,
      axisNameFontAlpha: chartAttrs.yaxisnamefontalpha,
      axisNameBgAlpha: chartAttrs.yaxisnamebgalpha,
      axisNameBorderAlpha: chartAttrs.yaxisnameborderalpha,
      axisNameBorderPadding: chartAttrs.yaxisnameborderpadding,
      axisNameBorderRadius: chartAttrs.yaxisnameborderradius,
      axisNameBorderThickness: chartAttrs.yaxisnameborderthickness,
      axisNameBorderDashed: chartAttrs.yaxisnameborderdashed,
      axisNameBorderDashLen: chartAttrs.yaxisnameborderdashlen,
      axisNameBorderDashGap: chartAttrs.yaxisnameborderdashgap,
      axisNameWidth: chartAttrs.yaxisnamewidth,
      useEllipsesWhenOverflow: chartAttrs.useellipseswhenoverflow,
      rotateAxisName: (0, _lib.pluckNumber)(chartAttrs.rotateyaxisname, 1),
      axisName: chartAttrs.yaxisname,
      showAlternateGridColor: (0, _lib.pluckNumber)(chartAttrs.showalternatehgridcolor, 1),
      alternateGridColor: (0, _lib.pluck)(chartAttrs.alternatehgridcolor, colorM.getColor(altHGridColorStr)),
      alternateGridAlpha: (0, _lib.pluck)(chartAttrs.alternatehgridalpha, colorM.getColor(altHGridAlphaStr)),
      numDivLines: chartAttrs.numdivlines,
      axisMinValue: chartAttrs.yaxisminvalue,
      axisMaxValue: chartAttrs.yaxismaxvalue,
      setAdaptiveMin: chartAttrs.setadaptiveymin,
      adjustDiv: chartAttrs.adjustdiv,
      labelStep: chartAttrs.yaxisvaluesstep,
      showLabels: (0, _lib.pluckNumber)(chartAttrs.showyaxislabels, chartAttrs.showlabels),
      maxLabelWidthPercent: chartAttrs.maxlabelwidthpercent,
      showAxisValues: (0, _lib.pluckNumber)(chartAttrs.showyaxisvalues, chartAttrs.showyaxisvalue),
      divLineColor: (0, _lib.pluck)(chartAttrs.hdivlinecolor, colorM.getColor(palleteString.divLineColor)),
      divLineAlpha: (0, _lib.pluck)(chartAttrs.hdivlinealpha, colorM.getColor(divLineAlphaStr)),
      divLineThickness: (0, _lib.pluckNumber)(chartAttrs.hdivlinethickness, 1),
      divLineIsDashed: Boolean((0, _lib.pluckNumber)(chartAttrs.hdivlinedashed, chartAttrs.hdivlineisdashed, 0)),
      divLineDashLen: (0, _lib.pluckNumber)(chartAttrs.hdivlinedashlen, 4),
      divLineDashGap: (0, _lib.pluckNumber)(chartAttrs.hdivlinedashgap, 2),
      // showLimits: chartAttrs.showlimits,
      // showDivLineValues: pluckNumber(chartAttrs.showdivlinevalues, chartAttrs.showdivlinevalue),
      showZeroPlane: chartAttrs.showzeroplane,
      zeroPlaneColor: chartAttrs.zeroplanecolor,
      zeroPlaneThickness: chartAttrs.zeroplanethickness,
      zeroPlaneAlpha: chartAttrs.zeroplanealpha,
      showZeroPlaneValue: chartAttrs.showzeroplanevalue,
      trendlineColor: chartAttrs.trendlinecolor,
      trendlineToolText: chartAttrs.trendlinetooltext,
      trendlineThickness: chartAttrs.trendlinethickness,
      trendlineAlpha: chartAttrs.trendlinealpha,
      showTrendlinesOnTop: chartAttrs.showtrendlinesontop,
      showAxisLine: (0, _lib.pluckNumber)(chartAttrs.showyaxisline, chartAttrs.showaxislines, chartAttrs.drawAxisLines, 0),
      axisLineThickness: (0, _lib.pluckNumber)(chartAttrs.yaxislinethickness, chartAttrs.axislinethickness, 1),
      axisLineAlpha: (0, _lib.pluckNumber)(chartAttrs.yaxislinealpha, chartAttrs.axislinealpha, 100),
      axisLineColor: (0, _lib.pluck)(chartAttrs.yaxislinecolor, chartAttrs.axislinecolor, COLOR_000000),
      labelFont: chartAttrs.labelfont,
      labelFontSize: this.computeFontSize(chartAttrs.labelfontsize),
      labelFontSizeWithUnit: chartAttrs.labelfontsize,
      labelFontColor: chartAttrs.labelfontcolor,
      labelAlpha: chartAttrs.labelalpha,
      labelFontBold: chartAttrs.labelfontbold,
      labelFontItalic: chartAttrs.labelfontitalic,
      labelBdrColor: chartAttrs.labelbordercolor,
      labelBdrAlpha: chartAttrs.labelborderalpha,
      labelLink: chartAttrs.labellink,
      labelBgColor: chartAttrs.labelbgcolor,
      labelBgAlpha: chartAttrs.labelbgalpha,
      labelBdrThickness: chartAttrs.labelborderthickness,
      labelBdrPadding: chartAttrs.labelborderpadding,
      labelBdrRadius: chartAttrs.labelborderradius,
      labelBdrDashed: chartAttrs.labelborderdashed,
      labelBdrDashLen: chartAttrs.labelborderdashlen,
      labelBdrDashGap: chartAttrs.labelborderdashgap
    };
    xAxisConf.vtrendlines = dataObj.vtrendlines;
    yAxisConf.trendlines = dataObj.trendlines;
    return {
      yAxisConf: [yAxisConf],
      xAxisConf: [xAxisConf]
    };
  };

  _proto._setCategories = function _setCategories() {
    var iapi = this,
        dataObj = iapi.getFromEnv('dataSource'),
        xAxis = iapi.getChildren('xAxis'),
        yAxis = iapi.getChildren('yAxis'),
        len,
        i,
        k,
        columnObj,
        rowObj,
        columns,
        rows,
        columnid,
        rowid,
        columnArr = [],
        rowArr = [],
        columnFlag,
        rowFlag,
        j;

    if (!dataObj.columns || !dataObj.rows) {
      dataObj.columns = {};
      dataObj.columns.column = columns = [];
      dataObj.rows = {};
      dataObj.rows.row = rows = [];

      for (k = 0; k < (dataObj.dataset && dataObj.dataset.length); k++) {
        len = dataObj.dataset && dataObj.dataset[k].data && dataObj.dataset[k].data.length;

        for (i = 0; i < len; i++) {
          columnid = (0, _lib.getFirstValue)(dataObj.dataset[k].data[i].columnid);
          rowid = (0, _lib.getFirstValue)(dataObj.dataset[k].data[i].rowid);
          columnFlag = true;
          rowFlag = true;

          for (j = 0; j < columns.length; j++) {
            if (columnid === columns[j].id) {
              columnFlag = false;
            }
          }

          if (columnFlag) {
            columnObj = {
              id: columnid,
              label: columnid
            };
            dataObj.columns.column.push(columnObj);
          }

          for (j = 0; j < rows.length; j++) {
            if (rowid === rows[j].id) {
              rowFlag = false;
            }
          }

          if (rowFlag) {
            rowObj = {
              id: rowid,
              label: rowid
            };
            dataObj.rows.row.push(rowObj);
          }
        }
      }
    }

    columns = dataObj.columns.column;
    rows = dataObj.rows.row;

    for (i = 0; i < (columns && columns.length); i++) {
      columns[i].label = (0, _lib.pluck)(columns[i].label, columns[i].name, columns[i].id);
      columnArr.push(columns[i]);
    }

    dataObj.columns.column = columnArr;

    for (i = 0; i < (rows && rows.length); i++) {
      rows[i].label = (0, _lib.pluck)(rows[i].label, rows[i].name, rows[i].id);
      rowArr.push(rows[i]);
    }

    dataObj.rows.row = rowArr; // dataObj.columns && xAxis[0].setAxisPadding(0.5, 0.5);

    dataObj.columns && xAxis[0].setTickValues(dataObj.columns.column); // dataObj.columns && yAxis[0].setAxisPadding(0.5, 0.5);

    dataObj.rows && yAxis[0].setTickValues(dataObj.rows.row);
    xAxis[0].setAxisConfig({
      categoryNumDivLines: iapi.getFromEnv('totalColumns') - 1,
      categoryDivLinesFromZero: 0,
      showAlternateGridColor: 0
    });
    yAxis[0].setAxisConfig({
      categoryNumDivLines: iapi.getFromEnv('totalRows') - 1,
      categoryDivLinesFromZero: 0,
      showAlternateGridColor: 0
    });
  };

  _proto.getDSdef = function getDSdef() {
    return _heatmap.default;
  };

  _proto.getDSGroupdef = function getDSGroupdef() {
    return _heatmap2.default;
  };

  return HeatMap;
}(_mscartesian.default);

var _default = HeatMap;
exports["default"] = _default;

/***/ }),

/***/ 1336:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _mscartesian = _interopRequireDefault(__webpack_require__(626));

var _area = _interopRequireDefault(__webpack_require__(617));

var _areabase = __webpack_require__(740);

var AREA = 'area';

var InverseMSArea = /*#__PURE__*/function (_MSCartesian) {
  (0, _inheritsLoose2.default)(InverseMSArea, _MSCartesian);

  function InverseMSArea() {
    return _MSCartesian.apply(this, arguments) || this;
  }

  /**
   * Provides the name of the chart extension
   *
   * @static
   * @return {string} The name of the chart extension
   */
  InverseMSArea.getName = function getName() {
    return 'InverseMSArea';
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */
  ;

  var _proto = InverseMSArea.prototype;

  _proto.getName = function getName() {
    return 'InverseMSArea';
  }
  /**
   * parse defualt configuration of the chart
   */
  ;

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    _MSCartesian.prototype.__setDefaultConfig.call(this);

    var config = this.config;
    config.defaultDatasetType = AREA;
    config.isInverse = true;
    config.zeroplanethickness = 2;
    config.zeroplanealpha = 80;
    config.showzeroplaneontop = 1;
    config.enablemousetracking = true;
    config.defaultcrosslinethickness = 1;

    _areabase._setDefaultConfig.call(this);
  };

  _proto.getDSdef = function getDSdef() {
    return _area.default;
  };

  _proto.getDSGroupdef = function getDSGroupdef() {// this fn overrides
  };

  return InverseMSArea;
}(_mscartesian.default);

var _default = InverseMSArea;
exports["default"] = _default;

/***/ }),

/***/ 1338:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _mscartesian = _interopRequireDefault(__webpack_require__(626));

var _column = _interopRequireDefault(__webpack_require__(595));

var _columnMultiseries = _interopRequireDefault(__webpack_require__(689));

var COLUMN = 'column';

var InverseMSColumn2d = /*#__PURE__*/function (_MSCartesian) {
  (0, _inheritsLoose2.default)(InverseMSColumn2d, _MSCartesian);

  function InverseMSColumn2d() {
    return _MSCartesian.apply(this, arguments) || this;
  }

  /**
   * Provides the name of the chart extension
   *
   * @static
   * @return {string} The name of the chart extension
   */
  InverseMSColumn2d.getName = function getName() {
    return 'InverseMSColumn2d';
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */
  ;

  var _proto = InverseMSColumn2d.prototype;

  _proto.getName = function getName() {
    return 'InverseMSColumn2d';
  }
  /**
   * parse defualt configuration of the chart
   */
  ;

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    _MSCartesian.prototype.__setDefaultConfig.call(this);

    var config = this.config;
    config.defaultDatasetType = COLUMN;
    config.isInverse = true;
    config.enablemousetracking = true;
  };

  _proto.getDSdef = function getDSdef() {
    return _column.default;
  };

  _proto.getDSGroupdef = function getDSGroupdef() {
    return _columnMultiseries.default;
  };

  return InverseMSColumn2d;
}(_mscartesian.default);

var _default = InverseMSColumn2d;
exports["default"] = _default;

/***/ }),

/***/ 1340:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _mscartesian = _interopRequireDefault(__webpack_require__(626));

var _line = _interopRequireDefault(__webpack_require__(616));

var _areabase = __webpack_require__(740);

var LINE = 'line';

var InverseMSLine = /*#__PURE__*/function (_MSCartesian) {
  (0, _inheritsLoose2.default)(InverseMSLine, _MSCartesian);

  /**
   * Provides the name of the chart extension
   *
   * @static
   * @return {string} The name of the chart extension
   */
  InverseMSLine.getName = function getName() {
    return 'InverseMSLine';
  };

  function InverseMSLine() {
    var _this;

    _this = _MSCartesian.call(this) || this;
    _this.defaultPlotShadow = 1;
    return _this;
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */


  var _proto = InverseMSLine.prototype;

  _proto.getName = function getName() {
    return 'InverseMSLine';
  }
  /**
   * parse defualt configuration of the chart
   */
  ;

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    _MSCartesian.prototype.__setDefaultConfig.call(this);

    var config = this.config;
    config.defaultDatasetType = LINE;
    config.isInverse = true;
    config.zeroplanethickness = 1;
    config.zeroplanealpha = 4;
    config.showzeroplaneontop = 0;
    config.enablemousetracking = true;
    config.defaultcrosslinethickness = 1;

    _areabase._setDefaultConfig.call(this);
  };

  _proto.getDSdef = function getDSdef() {
    return _line.default;
  };

  _proto.getDSGroupdef = function getDSGroupdef() {// this fn overrides
  };

  return InverseMSLine;
}(_mscartesian.default);

var _default = InverseMSLine;
exports["default"] = _default;

/***/ }),

/***/ 1361:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _waterfall2d = _interopRequireDefault(__webpack_require__(1362));

var _kagi = _interopRequireDefault(__webpack_require__(1365));

var _lib = __webpack_require__(274);

var UNDEF,
    HUNDREDSTRING = '100',
    SEVENTYSTRING = '70',
    KAGI = 'kagi';

var Kagi = /*#__PURE__*/function (_WaterFall2D) {
  (0, _inheritsLoose2.default)(Kagi, _WaterFall2D);

  function Kagi() {
    return _WaterFall2D.apply(this, arguments) || this;
  }

  /**
   * Provides the name of the chart extension
   *
   * @static
   * @return {string} The name of the chart extension
   */
  Kagi.getName = function getName() {
    return 'Kagi';
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */
  ;

  var _proto = Kagi.prototype;

  _proto.getName = function getName() {
    return 'Kagi';
  };

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    _WaterFall2D.prototype.__setDefaultConfig.call(this);

    var config = this.config;
    config.singleseries = true;
    config.hasLegend = false;
    config.defaultDatasetType = KAGI;
    config.setAdaptiveMin = true;
    config.anchorborderthickness = 1;
    config.anchorimageurl = UNDEF;
    config.anchorimagepadding = 1;
    config.anchorsides = 1;
    config.anchoralpha = UNDEF;
    config.anchorbgalpha = HUNDREDSTRING;
    config.anchorimagealpha = HUNDREDSTRING;
    config.anchorimagescale = 100;
    config.anchorstartangle = 90;
    config.anchorshadow = 0;
    config.anchorbgcolor = UNDEF;
    config.anchorbordercolor = UNDEF;
    config.anchorradius = 3;
    config.showvalues = 1;
    config.plotfillalpha = SEVENTYSTRING;
    config.linedashlen = 5;
    config.linedashgap = 4;
    config.linedashed = UNDEF;
    config.linealpha = HUNDREDSTRING;
    config.linethickness = 2;
    config.drawfullareaborder = 1;
    config.connectnulldata = 0;
    config.zeroplanethickness = 1;
    config.enablemousetracking = true;
    config.zeroplanealpha = 40;
    config.showzeroplaneontop = 0;
  };

  _proto._getDataset = function _getDataset() {
    var dataSetArr = [];
    this.iterateComponents(function (child) {
      if (child.getType && child.getType() === 'dataset') {
        dataSetArr.push(child);
      }
    });
    return dataSetArr;
  };

  _proto._postSpaceManagement = function _postSpaceManagement() {
    var iapi = this,
        config = iapi.config,
        xAxis = iapi.getChildren('xAxis')[0],
        yAxis = iapi.getChildren('yAxis')[0],
        canvas = iapi.getChildren('canvas')[0],
        canvasConfig = canvas.config,
        canvasBorderWidth = canvasConfig.canvasBorderWidth,
        canvasPadding = (0, _lib.pluckNumber)(canvasConfig.canvasPadding, 15),
        canvasPaddingTop = canvasConfig.canvasPaddingTop,
        canvasPaddingBottom = canvasConfig.canvasPaddingBottom,
        // eslint-disable-line good-practices/no-single-usage-variable
    canvasPaddingLeft = canvasConfig.canvasPaddingLeft,
        // eslint-disable-line good-practices/no-single-usage-variable
    canvasPaddingRight = canvasConfig.canvasPaddingRight,
        // eslint-disable-line good-practices/no-single-usage-variable
    chartAttrs = iapi.getFromEnv('dataSource').chart,
        // eslint-disable-line good-practices/no-single-usage-variable
    series = iapi._getDataset()[0].config,
        shiftCount = series && series.shiftCount,
        min = (0, _lib.pluckNumber)(xAxis.getAxisConfig('axisMinValue'), 0),
        // eslint-disable-line good-practices/no-single-usage-variable
    max = (0, _lib.pluckNumber)(xAxis.getAxisConfig('axisMaxValue'), shiftCount - 1),
        // plot area will not be less then 10 px
    // leftPixelPad = mathMin(pluckNumber(chartAttrs.canvaspadding, 0), (canvasWidth / 2) - 10),
    // rightPixelPad = leftPixelPad,
    // The maximum horizontal shift in percentage of the
    // available canvas width
    maxHShiftPercent = (0, _lib.pluckNumber)(chartAttrs.maxhshiftpercent, 10),
        effectiveCanvasWidth = iapi.config.canvasWidth - canvasPadding * 2,
        shift = config.shift || 0,
        xShiftLength;

    yAxis && yAxis.setAxisDimention({
      x: yAxis.config.isOpposit ? config.canvasRight + canvasBorderWidth : config.canvasLeft - canvasBorderWidth,
      y: config.canvasTop + canvasPaddingTop,
      opposite: yAxis.config.isOpposit ? config.canvasLeft - canvasBorderWidth : config.canvasRight + canvasBorderWidth,
      axisLength: config.canvasHeight - canvasPaddingTop - canvasPaddingBottom
    });

    iapi._setPosition();

    if (series) {
      // maxHShiftPercent can not be < 0
      maxHShiftPercent = maxHShiftPercent <= 0 ? 10 : maxHShiftPercent;
      xShiftLength = series.xShiftLength = Math.min(effectiveCanvasWidth / shiftCount, maxHShiftPercent * effectiveCanvasWidth / 100); // leftPixelPad = canvasPadding + xShiftLength / 2;
      // canvasWidth - ((xShiftLength *
      // // handling single value rendering issue in Kagi
      // mathMax((shiftCount - 1), 1)) + leftPixelPad);
      // Fix for Kagi chart single value rendering issue
      // If there is a single value, we use xAxis max value
      // as 1 not as 0

      max = Math.max(max, 1);
    } // function for adjusting value padding depending upon data and axis labels.


    canvas.setCanvasPadding();
    xAxis && xAxis.setAxisConfig({
      'canvasPaddingLeft': Math.max(canvasPaddingLeft, canvasPadding) + xShiftLength / 2,
      'canvasPaddingRight': Math.max(canvasPaddingRight, canvasPadding) + xShiftLength / 2
    });
    xAxis && xAxis.setAxisDimention({
      x: iapi.config.canvasLeft + canvasPadding + xShiftLength / 2,
      axisLength: xShiftLength * (max - min),
      y: xAxis.config.isOpposit ? config.canvasTop - canvasBorderWidth : config.canvasBottom + shift + canvasBorderWidth,
      opposite: xAxis.config.isOpposit ? config.canvasBottom + shift + canvasBorderWidth : config.canvasTop - canvasBorderWidth
    });
    iapi.allocateDimensionOfChartMenuBar();
  };

  _proto._setPosition = function _setPosition() {
    var i,
        point,
        yValue,
        isRally,
        lastHigh,
        lastLow,
        isRallyInitialised,
        lastPoint,
        iapi = this,
        dataObj = iapi.getFromEnv('dataSource'),
        dataSet = iapi._getDataset()[0],
        categories = dataObj.data || dataSet && dataSet[0] && dataSet[0].data,
        setDataArr = dataSet.components.data,
        dataSetLen = setDataArr && setDataArr.length,
        yAxis = iapi.getChildren('yAxis')[0],
        xValue = 0,
        plotX = xValue,
        // eslint-disable-line good-practices/no-single-usage-variable
    catArr = []; // create plot elements


    for (i = 0; i < dataSetLen; i++) {
      point = setDataArr[i].config;
      yValue = point.setValue;
      dataObj = setDataArr[i]; // Creating the data object if not created

      if (!dataObj) {
        dataObj = setDataArr[i] = {
          graphics: {}
        };
      }

      if (!point.isDefined) {
        yValue = point.plotValue;
      } // Getting appropiate value for the current plot point.


      yValue = (0, _lib.pluck)(point.plotValue, yValue); // Set the y position.

      point.plotY = (0, _lib.toPrecision)(yAxis.getPixel(point.setValue), 2); // Store value textbox y position.

      point.graphY = yValue && (0, _lib.toPrecision)(yAxis.getPixel(yValue), 2); // Abscissa of the point on the kagi line.

      point.plotX = plotX; // If there is a horizontal shift, then abscissa of the kagi
      // line and as such all points on it shifts to the right by a
      // slab more.

      if (point.isShift) {
        xValue += 1;
        plotX = xValue;
        categories && catArr.push(categories[i]);
      } else if (i === dataSetLen - 1) {
        categories && catArr.push(categories[i]);
      }

      if (i) {
        lastPoint = setDataArr[i - 1].config; // Getting the previously bundled up properties in local
        // variables.

        isRally = point && point.objParams && point.objParams.isRally;
        lastHigh = point && point.objParams && point.objParams.lastHigh;
        lastLow = point && point.objParams && point.objParams.lastLow;
        isRallyInitialised = point && point.objParams && point.objParams.isRallyInitialised; // To find if there is a change in trend towards the current
        // plot.

        if (lastPoint && isRallyInitialised && lastPoint.isRally !== point.isRally) {
          // Setting in this.data for the plot, to be used for.
          // Setting the color/thickness the graph segments.
          point.isChanged = true; // To get the pixel position of the transtion point and
          // storing in data point for the plot.

          point.ty = (0, _lib.toPrecision)(yAxis.getPixel(isRally ? lastHigh : lastLow), 2);
        } else {
          // Setting in this.data for the plot.
          point.isChanged = false;
        }
      }
    } // end of previous translation

  };

  _proto.getDSdef = function getDSdef() {
    return _kagi.default;
  };

  return Kagi;
}(_waterfall2d.default);

var _default = Kagi;
exports["default"] = _default;

/***/ }),

/***/ 1313:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _mslog = _interopRequireDefault(__webpack_require__(1314));

var _columnMultiseries = _interopRequireDefault(__webpack_require__(689));

var _column = _interopRequireDefault(__webpack_require__(595));

var COLUMN = 'column';

var LogMSColumn2d = /*#__PURE__*/function (_MSLog) {
  (0, _inheritsLoose2.default)(LogMSColumn2d, _MSLog);

  function LogMSColumn2d() {
    return _MSLog.apply(this, arguments) || this;
  }

  /**
   * Provides the name of the chart extension
   *
   * @static
   * @return {string} The name of the chart extension
   */
  LogMSColumn2d.getName = function getName() {
    return 'LogMSColumn2d';
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */
  ;

  var _proto = LogMSColumn2d.prototype;

  _proto.getName = function getName() {
    return 'LogMSColumn2d';
  };

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    _MSLog.prototype.__setDefaultConfig.call(this);

    var config = this.config;
    config.defaultDatasetType = COLUMN;
    config.enablemousetracking = true;
  };

  _proto.getDSGroupdef = function getDSGroupdef() {
    return _columnMultiseries.default;
  };

  _proto.getDSdef = function getDSdef() {
    return _column.default;
  };

  return LogMSColumn2d;
}(_mslog.default);

var _default = LogMSColumn2d;
exports["default"] = _default;

/***/ }),

/***/ 1318:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _mslog = _interopRequireDefault(__webpack_require__(1314));

var _line = _interopRequireDefault(__webpack_require__(616));

var _areabase = __webpack_require__(740);

var LINE = 'line';

var LogMSLine = /*#__PURE__*/function (_MSLog) {
  (0, _inheritsLoose2.default)(LogMSLine, _MSLog);

  /**
   * Provides the name of the chart extension
   *
   * @static
   * @return {string} The name of the chart extension
   */
  LogMSLine.getName = function getName() {
    return 'LogMSLine';
  };

  function LogMSLine() {
    var _this;

    _this = _MSLog.call(this) || this;
    _this.defaultPlotShadow = 1;
    return _this;
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */


  var _proto = LogMSLine.prototype;

  _proto.getName = function getName() {
    return 'LogMSLine';
  };

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    _MSLog.prototype.__setDefaultConfig.call(this);

    var config = this.config;
    config.defaultDatasetType = LINE;
    config.zeroplanethickness = 1;
    config.enablemousetracking = true;
    config.zeroplanealpha = 40;
    config.showzeroplaneontop = 0;
    config.enablemousetracking = true;
    config.defaultcrosslinethickness = 1;

    _areabase._setDefaultConfig.call(this);
  };

  _proto.getDSGroupdef = function getDSGroupdef() {// this fn overrides
  };

  _proto.getDSdef = function getDSdef() {
    return _line.default;
  };

  return LogMSLine;
}(_mslog.default);

var _default = LogMSLine;
exports["default"] = _default;

/***/ }),

/***/ 1320:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _logmscolumn2d = _interopRequireDefault(__webpack_require__(1313));

var _cartesianStack = _interopRequireDefault(__webpack_require__(698));

var LogStackedColumn2d = /*#__PURE__*/function (_LogMSColumn2d) {
  (0, _inheritsLoose2.default)(LogStackedColumn2d, _LogMSColumn2d);

  function LogStackedColumn2d() {
    return _LogMSColumn2d.apply(this, arguments) || this;
  }

  /**
   * Provides the name of the chart extension
   *
   * @static
   * @return {string} The name of the chart extension
   */
  LogStackedColumn2d.getName = function getName() {
    return 'LogStackedColumn2d';
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */
  ;

  var _proto = LogStackedColumn2d.prototype;

  _proto.getName = function getName() {
    return 'LogStackedColumn2d';
  };

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    _LogMSColumn2d.prototype.__setDefaultConfig.call(this);

    this.config.isstacked = true;
  };

  _proto.getDSGroupdef = function getDSGroupdef() {
    return _cartesianStack.default;
  };

  return LogStackedColumn2d;
}(_logmscolumn2d.default);

var _default = LogStackedColumn2d;
exports["default"] = _default;

/***/ }),

/***/ 1391:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _mscartesian = _interopRequireDefault(__webpack_require__(626));

var _areabase = __webpack_require__(740);

var _msstepline = _interopRequireDefault(__webpack_require__(1392));

var MSSTEPLINE = 'msstepline';

var MSStepLine = /*#__PURE__*/function (_MSCartesian) {
  (0, _inheritsLoose2.default)(MSStepLine, _MSCartesian);

  /**
   * Provides the name of the chart extension
   *
   * @static
   * @return {string} The name of the chart extension
   */
  MSStepLine.getName = function getName() {
    return 'MSStepLine';
  };

  function MSStepLine() {
    var _this;

    _this = _MSCartesian.call(this) || this;
    _this.defaultPlotShadow = 1;
    return _this;
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */


  var _proto = MSStepLine.prototype;

  _proto.getName = function getName() {
    return 'MSStepLine';
  };

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    _MSCartesian.prototype.__setDefaultConfig.call(this);

    var config = this.config;
    config.defaultDatasetType = MSSTEPLINE;
    config.drawverticaljoins = 1;
    config.useforwardsteps = 1;
    config.zeroplanethickness = 1;
    config.zeroplanealpha = 40;
    config.showzeroplaneontop = 0;
    config.enablemousetracking = true;
    config.defaultcrosslinethickness = 1;

    _areabase._setDefaultConfig.call(this);
  };

  _proto.getDSGroupdef = function getDSGroupdef() {// this fn overrides
  };

  _proto.getDSdef = function getDSdef() {
    return _msstepline.default;
  };

  return MSStepLine;
}(_mscartesian.default);

var _default = MSStepLine;
exports["default"] = _default;

/***/ }),

/***/ 1383:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _assertThisInitialized2 = _interopRequireDefault(__webpack_require__(292));

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _areabase = _interopRequireDefault(__webpack_require__(740));

var _multiaxisAxis = _interopRequireDefault(__webpack_require__(1384));

var _multiaxisVcanvas = _interopRequireDefault(__webpack_require__(1386));

var _multiaxisDataset = _interopRequireDefault(__webpack_require__(1387));

var _dependencyManager = __webpack_require__(282);

var _redraphaelShapes = _interopRequireDefault(__webpack_require__(442));

var _lib = __webpack_require__(274);

var _equal = _interopRequireDefault(__webpack_require__(421));

/* eslint require-jsdoc: 'error', valid-jsdoc: ["error", { "requireReturn": false }] */
var MULTIAXISLINE = 'multiaxisline';
var defaultFontStr = _lib.preDefStr.defaultFontStr,
    divLineAlphaStr = _lib.preDefStr.divLineAlphaStr,
    altVGridColorStr = _lib.preDefStr.altVGridColorStr,
    altVGridAlphaStr = _lib.preDefStr.altVGridAlphaStr,
    COLOR_000000 = _lib.preDefStr.colors.c000000,
    POSITION_BOTTOM = _lib.preDefStr.POSITION_BOTTOM,
    divLineAlpha3DStr = _lib.preDefStr.divLineAlpha3DStr,
    Raphael = (0, _dependencyManager.getDep)('redraphael', 'plugin'); // Resolve dependency to draw button shape

(0, _redraphaelShapes.default)(Raphael);
/**
 * Class for MultiAxisLine chartAPI
 */

var MultiAxisLine = /*#__PURE__*/function (_AreaBase) {
  (0, _inheritsLoose2.default)(MultiAxisLine, _AreaBase);

  /**
   * Provides the name of the chart extension
   *
   * @static
   * @return {string} The name of the chart extension
   */
  MultiAxisLine.getName = function getName() {
    return 'MultiAxisLine';
  }
  /**
   * Constructor function of MultiAxisLine chartAPI
   */
  ;

  function MultiAxisLine() {
    var _this;

    _this = _AreaBase.call(this) || this;
    var iapi = (0, _assertThisInitialized2.default)(_this);
    iapi.defaultPlotShadow = 1;
    iapi.axisPaddingLeft = 0;
    iapi.axisPaddingRight = 0;

    _this.registerFactory('axis', _multiaxisAxis.default, ['canvas']);

    _this.registerFactory('vCanvas', _multiaxisVcanvas.default, ['axis']);

    _this.registerFactory('dataset', _multiaxisDataset.default, ['vCanvas']);

    return _this;
  }
  /**
   * This sets default configuration
   * @memberof MultiAxisLine
   */


  var _proto = MultiAxisLine.prototype;

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    _AreaBase.prototype.__setDefaultConfig.call(this);

    var config = this.config;
    config.defaultDatasetType = MULTIAXISLINE;
    config.defaultcrosslinethickness = 1;
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */
  ;

  _proto.getName = function getName() {
    return 'MultiAxisLine';
  }
  /**
   * function to check if the chart specific data is proper is not
   * this fn is define for specific chart types
   * @return {boolean} if JSON data is valid or not
   */
  ;

  _proto._checkInvalidSpecificData = function _checkInvalidSpecificData() {
    var jsonData = this.getFromEnv('dataSource');

    if (!jsonData.axis || !jsonData.categories) {
      return true;
    }
  }
  /**
   * Function to configure the axis
   * @return {Object} configurations of axes
   */
  ;

  _proto._feedAxesRawData = function _feedAxesRawData() {
    var iapi = this,
        chartConfig = iapi.config,
        colorM = iapi.getFromEnv('color-manager'),
        numberFormatter = iapi.getFromEnv('number-formatter'),
        // eslint-disable-line good-practices/no-single-usage-variable
    dataObj = iapi.getFromEnv('dataSource'),
        chartAttrs = dataObj.chart,
        xAxisConf,
        yAxisConf,
        is3D = iapi.config.is3D,
        palleteString = is3D ? _lib.chartPaletteStr.chart3D : _lib.chartPaletteStr.chart2D,
        outCanfontSizeWithUnit = (0, _lib.pluckFontSizeMaintainUnit)(chartAttrs.outcnvbasefontsize, chartAttrs.basefontsize, 10),
        axes,
        i,
        len,
        isOpposit,
        axisJson,
        plotColor,
        leftAxes,
        rightAxes,
        axisHEXColor,
        gridLineWidth,
        tickWidth,
        axisLineThickness,
        yAxisConfigure = [],
        setAxisConfig = {},
        xAxisConfigure = [],
        j,
        jlen;
    xAxisConf = {
      // eslint-disable-line good-practices/no-single-usage-variable
      isVertical: false,
      isReverse: false,
      isOpposit: (0, _equal.default)(chartAttrs.xaxisposition, 'top'),
      outCanfontFamily: (0, _lib.pluck)(chartAttrs.outcnvbasefont, chartAttrs.basefont, defaultFontStr),
      outCanfontSize: this.computeFontSize(outCanfontSizeWithUnit),
      outCanfontSizeWithUnit: outCanfontSizeWithUnit,
      outCancolor: (0, _lib.pluck)(chartAttrs.outcnvbasefontcolor, chartAttrs.basefontcolor, colorM.getColor(palleteString.baseFontColor)).replace(/^#? ([a-f0-9]+)/ig, '#$1'),
      axisNamePadding: chartAttrs.xaxisnamepadding,
      axisValuePadding: chartAttrs.labelpadding,
      axisNameFont: chartAttrs.xaxisnamefont,
      axisNameFontSize: this.computeFontSize(chartAttrs.xaxisnamefontsize),
      axisNameFontSizeWithUnit: chartAttrs.xaxisnamefontsize,
      axisNameFontColor: chartAttrs.xaxisnamefontcolor,
      axisNameFontBold: chartAttrs.xaxisnamefontbold,
      axisNameFontItalic: chartAttrs.xaxisnamefontitalic,
      axisNameBgColor: chartAttrs.xaxisnamebgcolor,
      axisNameBorderColor: chartAttrs.xaxisnamebordercolor,
      axisNameAlpha: chartAttrs.xaxisnamealpha,
      axisNameFontAlpha: chartAttrs.xaxisnamefontalpha,
      axisNameBgAlpha: chartAttrs.xaxisnamebgalpha,
      axisNameBorderAlpha: chartAttrs.xaxisnameborderalpha,
      axisNameBorderPadding: chartAttrs.xaxisnameborderpadding,
      axisNameBorderRadius: chartAttrs.xaxisnameborderradius,
      axisNameBorderThickness: chartAttrs.xaxisnameborderthickness,
      axisNameBorderDashed: chartAttrs.xaxisnameborderdashed,
      axisNameBorderDashLen: chartAttrs.xaxisnameborderdashlen,
      axisNameBorderDashGap: chartAttrs.xaxisnameborderdashgap,
      useEllipsesWhenOverflow: chartAttrs.useellipseswhenoverflow,
      divLineColor: (0, _lib.pluck)(chartAttrs.vdivlinecolor, chartAttrs.divlinecolor, colorM.getColor(palleteString.divLineColor)),
      divLineAlpha: (0, _lib.pluck)(chartAttrs.vdivlinealpha, chartAttrs.divlinealpha, is3D ? colorM.getColor(divLineAlpha3DStr) : colorM.getColor(divLineAlphaStr)),
      divLineThickness: (0, _lib.pluckNumber)(chartAttrs.vdivlinethickness, chartAttrs.divlinethickness, 1),
      divLineIsDashed: Boolean((0, _lib.pluckNumber)(chartAttrs.vdivlinedashed, chartAttrs.vdivlineisdashed, chartAttrs.divlinedashed, chartAttrs.divlineisdashed, 0)),
      divLineDashLen: (0, _lib.pluckNumber)(chartAttrs.vdivlinedashlen, chartAttrs.divlinedashlen, 4),
      divLineDashGap: (0, _lib.pluckNumber)(chartAttrs.vdivlinedashgap, chartAttrs.divlinedashgap, 2),
      showAlternateGridColor: (0, _lib.pluckNumber)(chartAttrs.showalternatevgridcolor, 0),
      alternateGridColor: (0, _lib.pluck)(chartAttrs.alternatevgridcolor, colorM.getColor(altVGridColorStr)),
      alternateGridAlpha: (0, _lib.pluck)(chartAttrs.alternatevgridalpha, colorM.getColor(altVGridAlphaStr)),
      numDivLines: chartAttrs.numvdivlines,
      labelFont: chartAttrs.labelfont,
      labelFontSize: this.computeFontSize(chartAttrs.labelfontsize),
      labelFontSizeWithUnit: chartAttrs.labelfontsize,
      labelFontColor: chartAttrs.labelfontcolor,
      labelAlpha: chartAttrs.labelalpha,
      labelFontBold: chartAttrs.labelfontbold,
      labelFontItalic: chartAttrs.labelfontitalic,
      labelBdrColor: chartAttrs.labelbordercolor,
      labelBdrAlpha: chartAttrs.labelborderalpha,
      labelLink: chartAttrs.labellink,
      labelBgColor: chartAttrs.labelbgcolor,
      labelBgAlpha: chartAttrs.labelbgalpha,
      labelBdrThickness: chartAttrs.labelborderthickness,
      labelBdrPadding: chartAttrs.labelborderpadding,
      labelBdrRadius: chartAttrs.labelborderradius,
      labelBdrDashed: chartAttrs.labelborderdashed,
      labelBdrDashLen: chartAttrs.labelborderdashlen,
      labelBdrDashGap: chartAttrs.labelborderdashgap,
      maxLabelHeight: chartAttrs.maxlabelheight,
      axisName: chartAttrs.xaxisname,
      axisMinValue: chartAttrs.xaxisminvalue,
      axisMaxValue: chartAttrs.xaxismaxvalue,
      setAdaptiveMin: chartAttrs.setadaptivexmin,
      adjustDiv: chartAttrs.adjustvdiv,
      labelDisplay: chartAttrs.labeldisplay,
      showLabels: chartAttrs.showlabels,
      rotateLabels: chartAttrs.rotatelabels,
      slantLabel: (0, _lib.pluckNumber)(chartAttrs.slantlabels, chartAttrs.slantlabel),
      labelStep: (0, _lib.pluckNumber)(chartAttrs.labelstep, chartAttrs.xaxisvaluesstep),
      showAxisValues: (0, _lib.pluckNumber)(chartAttrs.showxaxisvalues, chartAttrs.showxaxisvalue),
      showLimits: chartAttrs.showvlimits,
      showDivLineValues: (0, _lib.pluckNumber)(chartAttrs.showvdivlinevalues, chartAttrs.showvdivlinevalues),
      showZeroPlane: chartAttrs.showvzeroplane,
      zeroPlaneColor: chartAttrs.vzeroplanecolor,
      zeroPlaneThickness: chartAttrs.vzeroplanethickness,
      zeroPlaneAlpha: chartAttrs.vzeroplanealpha,
      showZeroPlaneValue: chartAttrs.showvzeroplanevalue,
      trendlineColor: chartAttrs.trendlinecolor,
      trendlineToolText: chartAttrs.trendlinetooltext,
      trendlineThickness: chartAttrs.trendlinethickness,
      trendlineAlpha: chartAttrs.trendlinealpha,
      showTrendlinesOnTop: chartAttrs.showtrendlinesontop,
      showAxisLine: (0, _lib.pluckNumber)(chartAttrs.showxaxisline, chartAttrs.showaxislines, chartAttrs.drawAxisLines, 0),
      axisLineThickness: (0, _lib.pluckNumber)(chartAttrs.xaxislinethickness, chartAttrs.axislinethickness, 1),
      axisLineAlpha: (0, _lib.pluckNumber)(chartAttrs.xaxislinealpha, chartAttrs.axislinealpha, 100),
      axisLineColor: (0, _lib.pluck)(chartAttrs.xaxislinecolor, chartAttrs.axislinecolor, COLOR_000000)
    };
    xAxisConfigure.push(xAxisConf);
    yAxisConf = {
      outCanfontFamily: (0, _lib.pluck)(chartAttrs.outcnvbasefont, chartAttrs.basefont, defaultFontStr),
      outCanfontSize: this.computeFontSize(outCanfontSizeWithUnit),
      outCanfontSizeWithUnit: outCanfontSizeWithUnit,
      outCancolor: (0, _lib.pluck)(chartAttrs.outcnvbasefontcolor, chartAttrs.basefontcolor, colorM.getColor(palleteString.baseFontColor)).replace(/^#? ([a-f0-9]+)/ig, '#$1'),
      useEllipsesWhenOverflow: chartAttrs.useellipseswhenoverflow,
      showAlternateGridColor: 0,
      axisNameFont: chartAttrs.yaxisnamefont,
      axisNameFontSize: this.computeFontSize(chartAttrs.yaxisnamefontsize),
      axisNameFontSizeWithUnit: chartAttrs.yaxisnamefontsize,
      axisNameFontColor: chartAttrs.yaxisnamefontcolor,
      axisNameFontBold: chartAttrs.yaxisnamefontbold,
      axisNameFontItalic: chartAttrs.yaxisnamefontitalic,
      axisNameBgColor: chartAttrs.yaxisnamebgcolor,
      axisNameBorderColor: chartAttrs.yaxisnamebordercolor,
      axisNameAlpha: chartAttrs.yaxisnamealpha,
      axisNameFontAlpha: chartAttrs.yaxisnamefontalpha,
      axisNameBgAlpha: chartAttrs.yaxisnamebgalpha,
      axisNameBorderAlpha: chartAttrs.yaxisnameborderalpha,
      axisNameBorderPadding: chartAttrs.yaxisnameborderpadding,
      axisNameBorderRadius: chartAttrs.yaxisnameborderradius,
      axisNameBorderThickness: chartAttrs.yaxisnameborderthickness,
      axisNameBorderDashed: chartAttrs.yaxisnameborderdashed,
      axisNameBorderDashLen: chartAttrs.yaxisnameborderdashlen,
      axisNameBorderDashGap: chartAttrs.yaxisnameborderdashgap,
      labelFont: chartAttrs.yaxisvaluefont,
      labelFontSize: this.computeFontSize(chartAttrs.yaxisvaluefontsize),
      labelFontSizeWithUnit: chartAttrs.yaxisvaluefontsize,
      labelFontColor: chartAttrs.yaxisvaluefontcolor,
      labelAlpha: chartAttrs.yaxisvaluealpha,
      labelFontBold: chartAttrs.yaxisvaluefontbold,
      labelFontItalic: chartAttrs.yaxisvaluefontitalic,
      labelBdrColor: chartAttrs.yaxisvaluebordercolor,
      labelBdrAlpha: chartAttrs.yaxisvalueborderalpha,
      labelLink: chartAttrs.yaxisvaluelink,
      labelBgColor: chartAttrs.yaxisvaluebgcolor,
      labelBgAlpha: chartAttrs.yaxisvaluebgalpha,
      labelBdrThickness: chartAttrs.yaxisvalueborderthickness,
      labelBdrPadding: chartAttrs.yaxisvalueborderpadding,
      labelBdrRadius: chartAttrs.yaxisvalueborderradius,
      labelBdrDashed: chartAttrs.yaxisvalueborderdashed,
      labelBdrDashLen: chartAttrs.yaxisvalueborderdashlen,
      labelBdrDashGap: chartAttrs.yaxisvalueborderdashgap
    };
    leftAxes = {
      'side': 'l',
      axesConf: []
    };
    rightAxes = {
      'side': 'r',
      axesConf: []
    };
    axes = dataObj.axis || [];

    for (i = 0, len = axes.length; i < len; i++) {
      // eslint-disable-line good-practices/no-single-usage-variable
      setAxisConfig = {};
      axisJson = axes[i];
      setAxisConfig.checkBoxChecked = false;

      for (j = 0, jlen = axisJson.dataset ? axisJson.dataset.length : 0; j < jlen; j += 1) {
        if (Number(axisJson.dataset[j].visible) !== 0) {
          setAxisConfig.checkBoxChecked = true;
        }
      } // showAxis = pluckNumber(axisJson.showaxis, 1);


      plotColor = colorM.getPlotColor(i);
      axisHEXColor = (0, _lib.pluck)(axisJson.color, chartAttrs.axiscolor, plotColor);
      gridLineWidth = (0, _lib.pluckNumber)(axisJson.divlinethickness, chartAttrs.divlinethickness, 1);
      tickWidth = (0, _lib.pluckNumber)(axisJson.tickwidth, chartAttrs.axistickwidth, 2);
      axisLineThickness = (0, _lib.pluckNumber)(axisJson.axislinethickness, chartAttrs.axislinethickness, 2);
      isOpposit = !(0, _lib.pluckNumber)(axisJson.axisonleft, 1);
      yAxisConf.isVertical = true;
      yAxisConf.isReverse = true;
      yAxisConf.isOpposit = isOpposit; // add axis configuration

      yAxisConf.labelStep = (0, _lib.pluckNumber)(axisJson.yaxisvaluesstep, axisJson.yaxisvaluestep, chartAttrs.yaxisvaluesstep, chartAttrs.yaxisvaluestep);
      yAxisConf.axisMaxValue = axisJson.maxvalue; // yAxisConf.tickWidth = tickWidth;

      yAxisConf.axisMinValue = axisJson.minvalue;
      yAxisConf.setAdaptiveMin = (0, _lib.pluckNumber)(axisJson.setadaptiveymin, chartAttrs.setadaptiveymin);
      yAxisConf.numDivLines = (0, _lib.pluckNumber)(axisJson.numdivlines, chartAttrs.numdivlines, 4);
      yAxisConf.adjustDiv = (0, _lib.pluckNumber)(axisJson.adjustdiv, chartAttrs.adjustdiv);
      yAxisConf.showAxisValues = (0, _lib.pluckNumber)(axisJson.showyaxisvalues, axisJson.showyaxisvalue, chartAttrs.showyaxisvalues, chartAttrs.showyaxisvalue, 1);
      yAxisConf.showLimits = (0, _lib.pluckNumber)(axisJson.showlimits, chartAttrs.showyaxislimits, chartAttrs.showlimits, yAxisConf.showAxisValues);
      yAxisConf.showDivLineValues = (0, _lib.pluckNumber)(axisJson.showdivlinevalue, chartAttrs.showdivlinevalues, axisJson.showdivlinevalues, yAxisConf.showAxisValues);
      yAxisConf.showZeroPlane = (0, _lib.pluckNumber)(axisJson.showzeroplane, chartAttrs.showzeroplane);
      yAxisConf.showZeroPlaneValue = (0, _lib.pluckNumber)(axisJson.showzeroplanevalue, chartAttrs.showzeroplanevalue);
      yAxisConf.zeroPlaneColor = axisJson.zeroplanecolor;
      yAxisConf.zeroPlaneThickness = (0, _lib.pluckNumber)(axisJson.zeroplanethickness, axisJson.divlinethickness, chartConfig.zeroplanethickness, 2);
      yAxisConf.zeroPlaneAlpha = (0, _lib.pluckNumber)(axisJson.zeroplanealpha, axisJson.divlinealpha, chartConfig.zeroplanealpha);
      yAxisConf.showZeroPlaneOnTop = chartConfig.showzeroplaneontop;
      yAxisConf.divLineColor = (0, _lib.pluck)(axisJson.divlinecolor, axisHEXColor);
      yAxisConf.divLineAlpha = (0, _lib.pluckNumber)(axisJson.divlinealpha, chartAttrs.divlinealpha, colorM.getColor(divLineAlphaStr), 100);
      yAxisConf.divLineThickness = gridLineWidth;
      yAxisConf.divLineIsDashed = Boolean((0, _lib.pluckNumber)(axisJson.divlinedashed, axisJson.divlineisdashed, chartAttrs.divlinedashed, chartAttrs.divlineisdashed, 0));
      yAxisConf.divLineDashLen = (0, _lib.pluckNumber)(axisJson.divlinedashlen, chartAttrs.divlinedashlen, 4);
      yAxisConf.divLineDashGap = (0, _lib.pluckNumber)(axisJson.divlinedashgap, chartAttrs.divlinedashgap, 2);
      yAxisConf.showAxisLine = 1;
      yAxisConf.axisLineThickness = axisLineThickness;
      yAxisConf.axisLineAlpha = 100;
      yAxisConf.axisLineColor = axisHEXColor;
      yAxisConf.tickLength = tickWidth;
      yAxisConf.tickColor = axisHEXColor;
      yAxisConf.tickAlpha = 100;
      yAxisConf.tickWidth = axisLineThickness;
      yAxisConf.axisName = axisJson.title;
      yAxisConf.rotateAxisName = 1;
      yAxisConf.axisNameAlignCanvas = true;
      yAxisConf.drawAxisNameFromBottom = true;
      (0, _lib.extend2)(setAxisConfig, yAxisConf);
      numberFormatter.parseMLAxisConf(axisJson, i);

      if ((0, _lib.pluckNumber)(axisJson.showaxis) === 0) {
        (0, _lib.extend2)(setAxisConfig, {
          axisIndex: i,
          drawAxisLineWRTCanvas: false,
          drawLabels: false,
          drawPlotlines: false,
          drawAxisLine: false,
          drawPlotBands: false,
          drawAxisName: false,
          drawTrendLines: false,
          drawTrendLabels: false,
          drawTick: false,
          drawTickMinor: false,
          showAxis: 0
        });
      } else {
        (0, _lib.extend2)(setAxisConfig, {
          axisIndex: i,
          drawAxisLineWRTCanvas: false,
          drawLabels: true,
          drawPlotlines: true,
          drawAxisLine: true,
          drawPlotBands: true,
          drawAxisName: true,
          drawTrendLines: true,
          drawTrendLabels: true,
          drawTick: true,
          drawTickMinor: true,
          showAxis: 1
        });
      }

      if (isOpposit) {
        rightAxes.axesConf.push(setAxisConfig);
      } else {
        leftAxes.axesConf.push(setAxisConfig);
      }
    }

    leftAxes.axesConf.length && yAxisConfigure.push(leftAxes);
    rightAxes.axesConf.length && yAxisConfigure.push(rightAxes);
    return {
      xAxisConfigure: xAxisConfigure,
      yAxisConfigure: yAxisConfigure
    };
  }
  /**
   * Managing axis and legend space management after the actual space management
   */
  ;

  _proto._postSpaceManagement = function _postSpaceManagement() {
    var iapi = this,
        legend = iapi.getFromEnv('legend'),
        legendPos = legend && legend.config && legend.config.legendPos ? legend.config.legendPos.split('-') : []; // eslint-disable-line good-practices/no-single-usage-variable

    iapi.setAxisDimention(); // little space is required between legend and axis selector ui
    // when legend position is right-* or left-*

    if (legendPos[0] === _lib.POSITION_LEFT) {
      iapi._allocateSpace({
        left: 5
      });
    } else if (legendPos[0] === _lib.POSITION_RIGHT) {
      iapi._allocateSpace({
        right: 5
      });
    } // eslint-disable-next-line good-practices/no-function-dependency


    iapi.getChildren('yAxisSelectorUI').forEach(function (comp) {
      comp.setAxisDimention();
    }); // function for adjusting value padding depending upon data and axis labels.

    iapi.getChildren('canvas')[0].setCanvasPadding();
    iapi.setAxisDimention();
    iapi.config.showLegend && legend.postSpaceManager();
    iapi.allocateDimensionOfChartMenuBar();
  }
  /**
   * Sets dimension of Axis components
   */
  ;

  _proto.setAxisDimention = function setAxisDimention() {
    var iapi = this,
        config = iapi.config,
        xAxis = iapi.getChildren('xAxis')[0],
        xDepth = config.xDepth || 0,
        canvasConfig = iapi.getChildren('canvas')[0].config,
        canvasBorderWidth = canvasConfig.canvasBorderWidth,
        canvasPadding = canvasConfig.canvasPadding,
        canvasPaddingLeft = canvasConfig.canvasPaddingLeft,
        shift = config.shift || 0,
        canvasPaddingRight = canvasConfig.canvasPaddingRight; // eslint-disable-line good-practices/no-single-usage-variable

    xAxis && xAxis.setAxisDimention({
      x: config.canvasLeft + xDepth + Math.max(canvasPaddingLeft, canvasPadding),
      y: xAxis.config.isOpposit ? config.canvasTop - canvasBorderWidth : config.canvasBottom + shift + canvasBorderWidth,
      opposite: xAxis.config.isOpposit ? config.canvasBottom + shift + canvasBorderWidth : config.canvasTop - canvasBorderWidth,
      axisLength: config.canvasWidth - xDepth - Math.max(canvasPaddingLeft, canvasPadding) - Math.max(canvasPaddingRight, canvasPadding)
    });
  }
  /**
   * Managing the space of all the components of the chart including all the axiss
   */
  ;

  _proto._spaceManager = function _spaceManager() {
    // todo marge _allocateSpace and _spacemanager
    var spaceForActionBar,
        actionBarSpace,
        availableWidth,
        availableHeight,
        iapi = this,
        canvas = iapi.getChildren('canvas')[0],
        config = iapi.config,
        // axesArr = config.axesArr,
    // components = iapi.components,
    legendPosition = config.legendPosition ? config.legendPosition.split('-') : [],
        // axis = config.axisDataSetMap,
    xAxis = iapi.getChildren('xAxis'),
        // yAxis = iapi.getChildren('yAxis'),
    axisSelectorUI = iapi.getChildren('yAxisSelectorUI'),
        yDepth = config.yDepth,
        legend = iapi.getFromEnv('legend'),
        // eslint-disable-line good-practices/no-single-usage-variable
    // axesPadding = config.axesPadding,
    rightPadding = 0,
        leftPadding = 0,
        // length = yAxis.length,
    length = axisSelectorUI.length || 0,
        // eslint-disable-line good-practices/no-single-usage-variable
    // yAxisObj,
    i,
        yAxisSpaceUsed,
        // axesMap,
    // leftAxes,
    // rightAxes,
    allotedSpace,
        // mappedAxis,
    chartAttrs = iapi.getFromEnv('dataSource').chart,
        showBorder = (0, _lib.pluckNumber)(chartAttrs.showborder, iapi.config.is3D ? 0 : 1),
        // eslint-disable-line good-practices/no-single-usage-variable
    canvasBorderWidth = canvas.config.canvasBorderWidth,
        chartBorderWidth = config.borderWidth = showBorder ? (0, _lib.pluckNumber)(chartAttrs.borderthickness, 1) : 0,
        canvasMarginTop = config.canvasMarginTop,
        canvasMarginBottom = config.canvasMarginBottom,
        canvasMarginLeft = config.canvasMarginLeft,
        canvasMarginRight = config.canvasMarginRight,
        minCanvasHeight = config.minCanvasHeight,
        minCanvasWidth = config.minCanvasWidth,
        height = config.height,
        width = config.width,
        diff,
        heightAdjust = false,
        // eslint-disable-line good-practices/no-single-usage-variable
    widthAdjust = false,
        // eslint-disable-line good-practices/no-single-usage-variable
    top,
        bottom,
        left,
        right,
        currentCanvasHeight,
        currentCanvasWidth,
        origCanvasTopMargin = config.origCanvasTopMargin,
        origCanvasBottomMargin = config.origCanvasBottomMargin,
        origCanvasLeftMargin = config.origCanvasLeftMargin,
        origCanvasRightMargin = config.origCanvasRightMargin,
        sum; //* ***** Manage space

    iapi._allocateSpace({
      top: chartBorderWidth,
      bottom: chartBorderWidth,
      left: chartBorderWidth,
      right: chartBorderWidth
    });

    iapi._allocateSpace({
      left: config.canvasMarginLeft,
      right: config.canvasMarginRight
    }); //* ***** Manage space


    if (legendPosition[0] === 'left' || legendPosition[0] === 'right') {
      allotedSpace = config.canvasWidth * 0.3;
    } else {
      allotedSpace = config.canvasHeight * 0.3;
    } // No space is allocated for legend drawing in single series charts


    config.hasLegend !== false && xAxis && config.showLegend && iapi._allocateSpace(legend._manageLegendPosition(allotedSpace)); // @todo uncomment this code

    for (i = 0; i < length; i++) {
      yAxisSpaceUsed = axisSelectorUI[i].placeAxis(config.canvasWidth);
      rightPadding += yAxisSpaceUsed.rightPadding;
      leftPadding += yAxisSpaceUsed.leftPadding;

      iapi._allocateSpace(yAxisSpaceUsed.dimension);
    }

    spaceForActionBar = config.availableHeight * 0.225; // eslint-disable-line good-practices/no-single-usage-variable

    actionBarSpace = iapi._manageActionBarSpace && iapi._manageActionBarSpace(spaceForActionBar) || {}; // eslint-disable-line good-practices/no-single-usage-variable

    iapi._allocateSpace(actionBarSpace);

    availableHeight = legendPosition[0] === _lib.POSITION_TOP || legendPosition[0] === POSITION_BOTTOM ? config.canvasHeight * 0.6 : config.canvasWidth * 0.6;

    iapi._manageChartMenuBar(availableHeight);

    availableWidth = config.canvasWidth * 0.7; // eslint-disable-line good-practices/no-single-usage-variable

    if (availableWidth > rightPadding + leftPadding) {
      iapi._allocateSpace({
        'left': leftPadding,
        'right': rightPadding
      });
    }

    availableHeight = config.canvasHeight * 0.6;
    xAxis[0] && iapi._allocateSpace(xAxis[0].placeAxis(availableHeight)); // alocate the space for datasets

    availableHeight = config.canvasHeight * 0.325;
    iapi._getDSspace && iapi._allocateSpace(iapi._getDSspace(availableHeight));

    if (yDepth) {
      iapi._allocateSpace({
        bottom: yDepth
      }); // shift = xDepth + canvasBasePadding + canvasBaseDepth;

    }

    iapi._allocateSpace({
      top: canvasBorderWidth,
      bottom: canvasBorderWidth,
      left: canvasBorderWidth,
      right: canvasBorderWidth
    }); // Allocate space for canvas margin only if the margin is less than the margin entered by the user.


    top = canvasMarginTop > config.canvasTop ? canvasMarginTop - config.canvasTop : 0;
    bottom = canvasMarginBottom > height - config.canvasBottom ? canvasMarginBottom + config.canvasBottom - height : 0;
    left = canvasMarginLeft > config.canvasLeft ? canvasMarginLeft - config.canvasLeft : 0;
    right = canvasMarginRight > width - config.canvasRight ? canvasMarginRight + config.canvasRight - width : 0;

    iapi._allocateSpace({
      top: top,
      bottom: bottom,
      left: left,
      right: right
    }); // Forcing canvas height to its minimum


    if (heightAdjust) {
      sum = origCanvasTopMargin + origCanvasBottomMargin;
      currentCanvasHeight = config.canvasHeight;

      if (currentCanvasHeight > minCanvasHeight) {
        diff = currentCanvasHeight - minCanvasHeight;
        top = diff * origCanvasTopMargin / sum;
        bottom = diff * origCanvasBottomMargin / sum;
      }

      iapi._allocateSpace({
        top: top,
        bottom: bottom
      });
    } // Forcing canvas width to its minimum


    if (widthAdjust) {
      sum = origCanvasLeftMargin + origCanvasRightMargin;
      currentCanvasWidth = config.canvasWidth;

      if (currentCanvasWidth > minCanvasWidth) {
        diff = currentCanvasWidth - minCanvasWidth;
        left = diff * origCanvasLeftMargin / sum;
        right = diff * origCanvasRightMargin / sum;
      }

      iapi._allocateSpace({
        left: left,
        right: right
      });
    }

    config.actualCanvasMarginTop = top;
    config.actualCanvasMarginLeft = left;
    config.actualCanvasMarginRight = right;
    config.actualCanvasMarginBottom = bottom;
    canvas.setDimension({
      top: config.canvasTop,
      left: config.canvasLeft,
      width: config.canvasWidth,
      height: config.canvasHeight
    });
  }
  /**
   * Function to parse some additional parameters of the chart
   * @param  {Object} dataObj contains json data of the chart
   */
  ;

  _proto.configure = function configure(dataObj) {
    _AreaBase.prototype.configure.call(this, dataObj);

    var iapi = this,
        conf = iapi.config,
        chartAttr = iapi.getFromEnv('dataSource').chart;
    conf.axesPadding = 5;
    conf.allowAxisShift = (0, _lib.pluckNumber)(chartAttr.allowaxisshift, 1);
    conf.allowSelection = (0, _lib.pluckNumber)(chartAttr.allowselection, 1);
    conf.checkBoxColor = (0, _lib.pluck)(chartAttr.checkboxcolor, '#2196f3');
    conf.axisConfigured = true;
  };

  return MultiAxisLine;
}(_areabase.default);

var _default = MultiAxisLine;
exports["default"] = _default;

/***/ }),

/***/ 1373:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _commonchartapi = _interopRequireDefault(__webpack_require__(520));

var _mlpieDataset = _interopRequireDefault(__webpack_require__(1374));

var MULTILEVELPIE = 'multiLevelPie';

var MultilevelPie = /*#__PURE__*/function (_CommonAPI) {
  (0, _inheritsLoose2.default)(MultilevelPie, _CommonAPI);

  /**
   * Provides the name of the chart extension
   *
   * @static
   * @return {string} The name of the chart extension
   */
  MultilevelPie.getName = function getName() {
    return 'MultilevelPie';
  };

  function MultilevelPie() {
    var _this;

    _this = _CommonAPI.call(this) || this;
    _this.defaultPaletteOptions = null;

    _this.registerFactory('dataset', _mlpieDataset.default, ['canvas']);

    return _this;
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */


  var _proto = MultilevelPie.prototype;

  _proto.getName = function getName() {
    return 'MultilevelPie';
  }
  /**
   * parse defualt configuration of the chart
   */
  ;

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    _CommonAPI.prototype.__setDefaultConfig.call(this);

    var config = this.config;
    config.is3D = false;
    config.hasLegend = false;
    config.defaultDatasetType = MULTILEVELPIE;
    config.valuefontbold = 0;
    config.skipCanvasDrawing = true;
  }
  /**
   * function to check if the chart specific data is proper is not
   * this fn is define for specific chart types
   * @return {boolean} if JSON data is valid or not
   */
  ;

  _proto._checkInvalidSpecificData = function _checkInvalidSpecificData() {
    var categories = this.getFromEnv('dataSource').category;

    if (!(categories && categories[0]) || !Array.isArray(categories)) {
      return true;
    }
  };

  _proto._spaceManager = function _spaceManager() {
    var availableHeight,
        iapi = this,
        config = iapi.config; //* ***** Manage space

    iapi._allocateSpace(iapi._manageActionBarSpace && iapi._manageActionBarSpace(config.availableHeight * 0.225) || {});

    availableHeight = config.canvasHeight * 0.7; // eslint-disable-line good-practices/no-single-usage-variable
    // a space manager that manages the space for the tools as well as the captions.

    iapi._manageChartMenuBar(availableHeight);

    iapi.allocateDimensionOfChartMenuBar();
  };

  return MultilevelPie;
}(_commonchartapi.default);

var _default = MultilevelPie;
exports["default"] = _default;

/***/ }),

/***/ 1451:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _msarea = _interopRequireDefault(__webpack_require__(739));

var _radar = _interopRequireDefault(__webpack_require__(1452));

var _radarAxis = _interopRequireDefault(__webpack_require__(1455));

var _polarCanvas = _interopRequireDefault(__webpack_require__(1459));

var _lib = __webpack_require__(274);

/* eslint require-jsdoc: 'error', valid-jsdoc: ["error", { "requireReturn": false }] */
var POLAR = 'polar';
/**
 * Creates radar class
 * @class
 */

var Radar = /*#__PURE__*/function (_Area) {
  (0, _inheritsLoose2.default)(Radar, _Area);

  /**
   * constructor fn
   */
  function Radar() {
    var _this;

    _this = _Area.call(this) || this;

    _this.registerFactory('canvas', _polarCanvas.default);

    _this.registerFactory('axis', _radarAxis.default, ['canvas']);

    return _this;
  }

  var _proto = Radar.prototype;

  _proto.configureAttributes = function configureAttributes(obj) {
    // overriding the user given drawfullareaborder value since
    // it is not valid for radar
    this.config.drawfullareaborder = 1;
    this.config.radarRadius = (0, _lib.pluckNumber)(obj.chart.radarradius);

    _Area.prototype.configureAttributes.call(this, obj);

    this.config.alignLegendWithCanvas = 0; // as  no canvas is there as per behaviour of Radar chart
  }
  /**
   * Sets the default configuration
   */
  ;

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    _Area.prototype.__setDefaultConfig.call(this);

    var config = this.config;
    config.axisType = POLAR;
    config.axisValuePadding = 10;
    config.gridLineWidth = 1;
    config.showRadarBorder = 1;
    config.showvalues = 0;
    config.radarBorderThickness = 2;
    config.skipCanvasDrawing = true;
    config.useplotgradientcolor = 0;
    config.plotfillalpha = 50;
  }
  /**
   * Sets dimension of Axis components
   */
  ;

  _proto.setAxisDimention = function setAxisDimention() {
    this.getChildren('yAxis');
  }
  /**
   * function to parse JSON data for configurations of axis
   * @return {Object} configurations of axes
   */
  ;

  _proto._feedAxesRawData = function _feedAxesRawData() {
    var iapi = this,
        dataObj = iapi.getFromEnv('dataSource'),
        xAxisConf,
        yAxisConf;
    xAxisConf = iapi.getSpecificxAxisConf();
    yAxisConf = iapi.getSpecificyAxisConf();
    xAxisConf.vtrendlines = dataObj.vtrendlines;
    yAxisConf.trendlines = dataObj.trendlines;
    return {
      xAxisConf: [xAxisConf],
      yAxisConf: [yAxisConf]
    };
  }
  /**
   * Returns x-axis configuration for chart.
   * @return {Object} configurations of x-axis.
   */
  ;

  _proto.getSpecificxAxisConf = function getSpecificxAxisConf() {
    var iapi = this,
        chartAttrs = iapi.getFromEnv('chart-attrib'),
        xAxisConf = this.getBasexAxisConf();
    xAxisConf.isReverse = iapi.config.reverseXAxis;
    xAxisConf.axisLineColor = (0, _lib.pluck)(chartAttrs.xaxislinecolor, chartAttrs.axislinecolor, '#000000');
    xAxisConf.showAlternateGridColor = (0, _lib.pluckNumber)(chartAttrs.showalternatevgridcolor, 1);
    xAxisConf.numDivLines = chartAttrs.numvdivlines;
    xAxisConf.axisName = chartAttrs.xaxisname;
    xAxisConf.setAdaptiveMin = chartAttrs.setadaptivexmin;
    xAxisConf.showLimits = chartAttrs.showvlimits;
    xAxisConf.showDivLineValues = (0, _lib.pluckNumber)(chartAttrs.showvdivlinevalues, chartAttrs.showvdivlinevalues);
    xAxisConf.zeroPlaneThickness = chartAttrs.vzeroplanethickness;
    xAxisConf.zeroPlaneAlpha = chartAttrs.vzeroplanealpha;
    xAxisConf.showZeroPlaneValue = chartAttrs.showvzeroplanevalue;
    xAxisConf.showAxisLine = (0, _lib.pluckNumber)(chartAttrs.showxaxisline, chartAttrs.showaxislines, chartAttrs.drawAxisLines, 0);
    xAxisConf.showRadarBorder = chartAttrs.showradarborder;
    xAxisConf.radarBorderColor = chartAttrs.radarbordercolor;
    xAxisConf.radarBorderThickness = chartAttrs.radarborderthickness;
    xAxisConf.radarBorderAlpha = chartAttrs.radarborderalpha;
    xAxisConf.radarFillColor = chartAttrs.radarfillcolor;
    xAxisConf.radarFillAlpha = chartAttrs.radarfillalpha;
    xAxisConf.radarSpikeColor = chartAttrs.radarspikecolor;
    xAxisConf.radarSpikeThickness = chartAttrs.radarspikethickness;
    xAxisConf.radarSpikeAlpha = chartAttrs.radarspikealpha;
    xAxisConf.radarInLineAlpha = chartAttrs.radarinlinealpha;
    xAxisConf.showTooltip = (0, _lib.pluckNumber)(chartAttrs.showtooltip, 1);
    return xAxisConf;
  }
  /**
   * Returns y-axis configuration for chart.
   * @return {Object} configurations of y-axis.
   */
  ;

  _proto.getSpecificyAxisConf = function getSpecificyAxisConf() {
    var iapi = this,
        chartAttrs = iapi.getFromEnv('chart-attrib'),
        chartConfig = iapi.config,
        palleteString = chartConfig.is3D ? _lib.chartPaletteStr.chart3D : _lib.chartPaletteStr.chart2D,
        colorM = iapi.getFromEnv('color-manager'),
        outCanfontSizeWithUnit = (0, _lib.pluckFontSizeMaintainUnit)(chartAttrs.outcnvbasefontsize, chartAttrs.basefontsize, 10);
    return {
      isVertical: true,
      isReverse: !chartConfig.isInverse,
      isOpposit: false,
      outCanfontFamily: (0, _lib.pluck)(chartAttrs.outcnvbasefont, chartAttrs.basefont, 'Verdana,sans'),
      outCanfontSize: this.computeFontSize(outCanfontSizeWithUnit),
      outCanfontSizeWithUnit: outCanfontSizeWithUnit,
      outCancolor: (0, _lib.pluck)(chartAttrs.outcnvbasefontcolor, chartAttrs.basefontcolor, colorM.getColor(palleteString.baseFontColor)).replace(/^#? ([a-f0-9]+)/ig, '#$1'),
      axisNamePadding: chartAttrs.yaxisnamepadding,
      axisValuePadding: chartAttrs.yaxisvaluespadding,
      axisNameFont: chartAttrs.yaxisnamefont,
      axisNameFontSize: this.computeFontSize(chartAttrs.yaxisnamefontsize),
      axisNameFontSizeWithUnit: chartAttrs.yaxisnamefontsize,
      axisNameFontColor: chartAttrs.yaxisnamefontcolor,
      axisNameFontBold: chartAttrs.yaxisnamefontbold,
      axisNameFontItalic: chartAttrs.yaxisnamefontitalic,
      axisNameBgColor: chartAttrs.yaxisnamebgcolor,
      axisNameBorderColor: chartAttrs.yaxisnamebordercolor,
      axisNameAlpha: chartAttrs.yaxisnamealpha,
      axisNameFontAlpha: chartAttrs.yaxisnamefontalpha,
      axisNameBgAlpha: chartAttrs.yaxisnamebgalpha,
      axisNameBorderAlpha: chartAttrs.yaxisnameborderalpha,
      axisNameBorderPadding: chartAttrs.yaxisnameborderpadding,
      axisNameBorderRadius: chartAttrs.yaxisnameborderradius,
      axisNameBorderThickness: chartAttrs.yaxisnameborderthickness,
      axisNameBorderDashed: chartAttrs.yaxisnameborderdashed,
      axisNameBorderDashLen: chartAttrs.yaxisnameborderdashlen,
      axisNameBorderDashGap: chartAttrs.yaxisnameborderdashgap,
      axisNameWidth: chartAttrs.yaxisnamewidth,
      useEllipsesWhenOverflow: chartAttrs.useellipseswhenoverflow,
      rotateAxisName: (0, _lib.pluckNumber)(chartAttrs.rotateyaxisname, 1),
      divLineColor: (0, _lib.pluck)(chartAttrs.divlinecolor, colorM.getColor(palleteString.divLineColor)),
      divLineAlpha: (0, _lib.pluck)(chartAttrs.divlinealpha, colorM.getColor('divLineAlpha')),
      divLineThickness: (0, _lib.pluckNumber)(chartAttrs.divlinethickness, 1),
      divLineIsDashed: Boolean((0, _lib.pluckNumber)(chartAttrs.divlinedashed, chartAttrs.divlineisdashed, 0)),
      divLineDashLen: (0, _lib.pluckNumber)(chartAttrs.divlinedashlen, 4),
      divLineDashGap: (0, _lib.pluckNumber)(chartAttrs.divlinedashgap, 2),
      showAlternateGridColor: (0, _lib.pluckNumber)(chartAttrs.showalternatehgridcolor, 1),
      alternateGridColor: (0, _lib.pluck)(chartAttrs.alternatehgridcolor, colorM.getColor('altHGridColor')),
      alternateGridAlpha: (0, _lib.pluck)(chartAttrs.alternatehgridalpha, colorM.getColor('altHGridAlpha')),
      numDivLines: chartAttrs.numdivlines,
      axisMinValue: chartAttrs.yaxisminvalue,
      axisMaxValue: chartAttrs.yaxismaxvalue,
      setAdaptiveMin: chartAttrs.setadaptiveymin,
      adjustDiv: chartAttrs.adjustvdiv,
      labelStep: chartAttrs.yaxisvaluesstep,
      showAxisValues: (0, _lib.pluckNumber)(chartAttrs.showyaxisvalues, chartAttrs.showyaxisvalue),
      showLimits: (0, _lib.pluckNumber)(chartAttrs.showyaxislimits, chartAttrs.showlimits, iapi.showLimits),
      showDivLineValues: (0, _lib.pluckNumber)(chartAttrs.showdivlinevalues, chartAttrs.showdivlinevalue),
      // showZeroPlane: chartAttrs.showzeroplane,
      zeroPlaneColor: chartAttrs.zeroplanecolor,
      zeroPlaneThickness: (0, _lib.pluckNumber)(chartAttrs.zeroplanethickness, chartAttrs.divlinethickness, 2),
      zeroPlaneAlpha: chartAttrs.zeroplanealpha,
      showZeroPlaneValue: chartAttrs.showzeroplanevalue,
      trendlineColor: chartAttrs.trendlinecolor,
      trendlineToolText: chartAttrs.trendlinetooltext,
      trendlineThickness: chartAttrs.trendlinethickness,
      trendlineAlpha: chartAttrs.trendlinealpha,
      showTrendlinesOnTop: chartAttrs.showtrendlinesontop,
      axisLineThickness: (0, _lib.pluckNumber)(chartAttrs.yaxislinethickness, chartAttrs.axislinethickness, 1),
      axisLineAlpha: (0, _lib.pluckNumber)(chartAttrs.yaxislinealpha, chartAttrs.axislinealpha, 100),
      axisLineColor: (0, _lib.pluck)(chartAttrs.yaxislinecolor, chartAttrs.axislinecolor, '#000000'),
      showTooltip: (0, _lib.pluckNumber)(chartAttrs.showtooltip, 1)
    };
  }
  /**
   * space manager for radar
   */
  ;

  _proto._spaceManager = function _spaceManager() {
    // todo marge _allocateSpace and _spacemanager
    var spaceForActionBar,
        actionBarSpace,
        availableWidth,
        availableHeight,
        iapi = this,
        config = iapi.config,
        chartAttr = iapi.getFromEnv('chart-attrib'),
        // components = iapi.components,
    radarBorderThickness = config.radarBorderThickness,
        legendPosition = config.legendPosition ? config.legendposition.split('-') : [],
        xAxis = iapi.getChildren('xAxis') && iapi.getChildren('xAxis')[0],
        yAxisArr = iapi.getChildren('yAxis') && iapi.getChildren('yAxis') || [],
        // eslint-disable-line good-practices/no-single-usage-variable
    yAxis = yAxisArr[0],
        legend = iapi.getChildren('legend') && iapi.getChildren('legend')[0],
        // eslint-disable-line good-practices/no-single-usage-variable
    allottedSpace,
        decreaseCanvasBy,
        POSITION_BOTTOM = _lib.preDefStr.POSITION_BOTTOM,
        math = Math,
        mathMin = math.min,
        mathMax = math.max,
        mathAbs = math.abs,
        remainingSpace,
        radarRadius;
    config.radarRadius = (0, _lib.pluckNumber)(chartAttr.radarradius); // If Radar radius is user defined

    if (config.radarRadius !== _lib.UNDEF) {
      config.radarRadius = config.radarRadius > mathMin(config.canvasHeight, config.canvasWidth) / 2 ? mathMin(config.canvasHeight, config.canvasWidth) / 2 : config.radarRadius;
      config.availableHeight = availableHeight = config.canvasHeight - config.radarRadius * 2;
      config.availableWidth = availableWidth = config.canvasWidth - config.radarRadius * 2;
    } else {
      // Calculate the Radar radius
      config.availableHeight = availableHeight = config.canvasHeight * 0.7;
      config.availableWidth = availableWidth = config.canvasWidth * 0.7;
    } // Place legend


    allottedSpace = (legendPosition[0] === _lib.POSITION_TOP || legendPosition[0] === POSITION_BOTTOM ? availableHeight : availableWidth) * 0.3;
    allottedSpace = legendPosition[0] === _lib.POSITION_TOP || legendPosition[0] === POSITION_BOTTOM ? availableHeight : availableWidth; // No space is allocated for legend drawing in single series charts

    if (config.hasLegend !== false && xAxis && config.showLegend) {
      remainingSpace = legend._manageLegendPosition(allottedSpace);
      remainingSpace.bottom = mathMin(mathMax(remainingSpace.bottom, 0), allottedSpace);
      remainingSpace.right = mathMin(mathMax(remainingSpace.right, 0), allottedSpace);
      remainingSpace.top = mathMin(mathMax(remainingSpace.top, 0), allottedSpace);
      remainingSpace.left = mathMin(mathMax(remainingSpace.left, 0), allottedSpace);

      iapi._allocateSpace(remainingSpace);
    }

    if (xAxis) {
      remainingSpace = xAxis.placeAxis(config.availableWidth, config.availableHeight);

      iapi._allocateSpace(remainingSpace);
    }

    if (yAxis) {
      remainingSpace = yAxis.placeAxis(config.canvasWidth);
    } // A space manager that manages the space for the tools as well as the captions.


    remainingSpace = iapi._manageChartMenuBar(config.availableHeight);
    spaceForActionBar = config.availableHeight * 0.225; // eslint-disable-line good-practices/no-single-usage-variable

    actionBarSpace = iapi._manageActionBarSpace && (iapi._manageActionBarSpace(spaceForActionBar) || {}); // eslint-disable-line good-practices/no-single-usage-variable

    iapi._allocateSpace(actionBarSpace); // For rader make the canvas square with the minimum of width and height


    radarRadius = config.radarRadius > 0 ? config.radarRadius * 2 : mathMin(config.canvasHeight, config.canvasWidth);

    if (config.canvasHeight > radarRadius) {
      decreaseCanvasBy = mathAbs((config.canvasHeight - radarRadius) / 2);

      iapi._allocateSpace({
        top: decreaseCanvasBy,
        bottom: decreaseCanvasBy
      });
    }

    if (config.canvasWidth > radarRadius) {
      decreaseCanvasBy = mathAbs((config.canvasWidth - radarRadius) / 2);

      iapi._allocateSpace({
        left: decreaseCanvasBy,
        right: decreaseCanvasBy
      });
    }

    radarRadius = radarRadius / 2;
    yAxis.setAxisDimention({
      x: config.canvasLeft + config.canvasWidth / 2,
      y: config.canvasTop + config.canvasHeight / 2 - (radarRadius - radarBorderThickness / 2),
      axisLength: radarRadius - radarBorderThickness / 2
    });
    xAxis.setAxisConfig({
      radius: radarRadius - radarBorderThickness / 2
    });
    xAxis.setAxisDimention({
      x: config.canvasLeft + config.canvasWidth / 2,
      y: config.canvasTop + config.canvasHeight / 2
    });
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */
  ;

  Radar.getName = function getName() {
    return 'Radar';
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */
  ;

  _proto.getName = function getName() {
    return 'Radar';
  }
  /**
   * This method return the dataset definations for this charts
   * @return {string} dataset defination
   */
  ;

  _proto.getDSdef = function getDSdef() {
    return _radar.default;
  };

  return Radar;
}(_msarea.default);

var _default = Radar;
exports["default"] = _default;

/***/ }),

/***/ 1428:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _commonchartapi = _interopRequireDefault(__webpack_require__(520));

var _sankey = _interopRequireDefault(__webpack_require__(1429));

var _sankeyDatasetFactory = _interopRequireDefault(__webpack_require__(1437));

var _isArray = _interopRequireDefault(__webpack_require__(349));

var _lib = __webpack_require__(274);

var _legend = _interopRequireDefault(__webpack_require__(629));

var _sankeyhelper = __webpack_require__(1435);

var DEFAULT_NODE_WIDTH = 20,
    VERTICAL = 'vertical',
    HORIZONTAL = 'horizontal',
    RIGHT = 'right',
    INVALIDGRAPH = 'Self loops and circular links are not supported.',
    prepareData = function prepareData(dataSource) {
  var parsedNodes = [],
      parsedLinks = [],
      nodes = dataSource.nodes || [],
      links = dataSource.links || [],
      nodeId,
      nodeIds = {};
  nodes.forEach(function (node) {
    nodeId = (0, _lib.pluck)(node.id, node.label);
    if (!nodeId) return;
    nodeIds[nodeId.toString()] = node;
  });
  Object.keys(nodeIds).forEach(function (id, index) {
    parsedNodes.push(Object.assign({}, nodeIds[id], {
      props: {}
    }));
    parsedNodes[index].id = (0, _lib.parseUnsafeString)((parsedNodes[index].id || parsedNodes[index].label).toString());
    parsedNodes[index].label = (0, _lib.parseUnsafeString)((parsedNodes[index].label || parsedNodes[index].id).toString());
  });
  links.forEach(function (link) {
    if (!nodeIds[link.from] || !nodeIds[link.to]) return;
    parsedLinks.push(Object.assign({}, link, {
      props: {
        source: (0, _lib.parseUnsafeString)(link.from),
        target: (0, _lib.parseUnsafeString)(link.to)
      },
      value: (0, _lib.pluck)(link.value, '0')
    }));
  });
  return {
    nodes: parsedNodes,
    links: parsedLinks
  };
};

var Sankey = /*#__PURE__*/function (_CommonAPI) {
  (0, _inheritsLoose2.default)(Sankey, _CommonAPI);

  function Sankey() {
    var _this;

    _this = _CommonAPI.call(this) || this;

    _this.registerFactory('legend', _legend.default);

    _this.registerFactory('dataset', _sankeyDatasetFactory.default, ['legend']);

    return _this;
  }

  var _proto = Sankey.prototype;

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    _CommonAPI.prototype.__setDefaultConfig.call(this);

    var chartConfig = this.config;
    this.legendposition = RIGHT;
    chartConfig.legendPosition = _lib.preDefStr.POSITION_BOTTOM;
    chartConfig.orientation = HORIZONTAL;
    chartConfig.skipCanvasDrawing = true;
    chartConfig.alignCaptionWithCanvas = false;
    chartConfig.basefontsize = 11;
  };

  Sankey.getName = function getName() {
    return 'sankey';
  };

  _proto.getName = function getName() {
    return 'sankey';
  };

  _proto.getDSdef = function getDSdef() {
    return _sankey.default;
  };

  _proto._checkInvalidData = function _checkInvalidData() {
    var dataSource = this.getFromEnv('dataSource');

    if (!(0, _isArray.default)(dataSource.nodes) || !dataSource.nodes.length) {
      delete this.config.errorMessage;
      return true;
    }

    return false;
  } // eslint-disable-next-line
  ;

  _proto._checkInvalidSpecificData = function _checkInvalidSpecificData() {
    var chart = this,
        parsedData = prepareData(chart.getFromEnv('dataSource'));
    (0, _sankeyhelper.createNodeLinks)(parsedData);

    if (!(0, _sankeyhelper.traverseGraph)(parsedData)) {
      chart.config.errorMessage = INVALIDGRAPH;
      return true;
    }

    delete chart.config.errorMessage;
    chart.addToEnv('sankey-graph', parsedData);
    return false;
  };

  _proto.setChartMessage = function setChartMessage(message, chartObj, _container) {
    var errorMessage = this.config.errorMessage;

    _CommonAPI.prototype.setChartMessage.call(this, message || errorMessage, chartObj, _container);
  };

  _proto.configureAttributes = function configureAttributes(inputConfig) {
    if (inputConfig === void 0) {
      inputConfig = {};
    }

    _CommonAPI.prototype.configureAttributes.call(this, inputConfig);

    var chart = this,
        chartConfig = chart.config,
        chartAttr = inputConfig.chart || {},
        numberFormatter = chart.getFromEnv('number-formatter'),
        graph = chart.getFromEnv('sankey-graph'),
        nodes = graph.nodes,
        links = graph.links;

    if (typeof chartAttr.orientation !== 'undefined') {
      chartConfig.orientation = chartAttr.orientation.toString().toLowerCase();
      chartConfig.orientation = chartConfig.orientation === VERTICAL ? VERTICAL : HORIZONTAL;
    } else {
      chartConfig.orientation = HORIZONTAL;
    }

    if (typeof chartAttr.legendposition !== 'undefined') {
      chartConfig.legendPosition = ['top-left', 'top', 'top-right', 'right-top', 'right', 'right-bottom', 'bottom-right', 'bottom', 'bottom-left', 'left-bottom', 'left', 'left-top'].includes(chartAttr.legendposition.toString().toLowerCase()) ? chartAttr.legendposition.toString().toLowerCase() : _lib.preDefStr.POSITION_BOTTOM;
    } else {
      chartConfig.legendPosition = RIGHT;
    }

    chartConfig.legendposition = chartConfig.legendPosition;
    chart.addToEnv('orientation', chartConfig.orientation);
    chartConfig.nodeWidth = Math.max(0, numberFormatter.getCleanValue((0, _lib.pluck)(chartAttr.nodewidth, DEFAULT_NODE_WIDTH)));
    nodes.forEach(function (node) {
      node.nodeWidth = chartConfig.nodeWidth;
    });
    links.forEach(function (link) {
      link.value = Math.max(0, numberFormatter.getCleanValue((0, _lib.pluck)(link.value, 0)));
    });
    (0, _sankeyhelper.createNodeValues)(graph);
  };

  _proto._spaceManager = function _spaceManager() {
    var chart = this,
        chartConfig = chart.config,
        legendPosition = chartConfig.legendPosition,
        showLegend = chartConfig.showLegend,
        marginLeft = chartConfig.marginLeft,
        marginTop = chartConfig.marginTop,
        marginRight = chartConfig.marginRight,
        marginBottom = chartConfig.marginBottom,
        width = +chart.getFromEnv('chartWidth'),
        height = +chart.getFromEnv('chartHeight'),
        legend,
        allotedSpace,
        actionBarSpace,
        legendSpace;
    width -= marginLeft + marginRight;
    height -= marginTop + marginBottom;
    actionBarSpace = chart._manageActionBarSpace(0.225 * height);

    chart._allocateSpace(actionBarSpace);

    if (showLegend) {
      legendPosition = legendPosition || [];

      if (legendPosition.split('-')[0] === _lib.POSITION_TOP || legendPosition.split('-')[0] === _lib.preDefStr.POSITION_BOTTOM) {
        allotedSpace = height * 0.3;
      } else {
        allotedSpace = width * 0.3;

        if (legendPosition.split('-')[0] === _lib.POSITION_LEFT) {
          chart._allocateSpace({
            left: 11
          });
        } else if (legendPosition.split('-')[0] === _lib.POSITION_RIGHT) {
          chart._allocateSpace({
            right: 11
          });
        }
      }

      legend = chart.getChildren('legend')[0];
      legendSpace = legend._manageLegendPosition(allotedSpace);

      chart._allocateSpace(legendSpace);
    }

    chart._manageChartMenuBar(0.6 * chartConfig.availableHeight);
  };

  _proto._postSpaceManagement = function _postSpaceManagement() {
    var chart = this,
        showLegend = chart.config.showLegend,
        legends = chart.getChildren('legend');

    if (legends.length && showLegend) {
      legends.forEach(function (legend) {
        return legend.postSpaceManager();
      });
    }

    chart.allocateDimensionOfChartMenuBar();
  };

  return Sankey;
}(_commonchartapi.default);

var _default = Sankey;
exports["default"] = _default;

/***/ }),

/***/ 1369:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _lib = __webpack_require__(274);

var _scatterbase = _interopRequireDefault(__webpack_require__(719));

var _selectscatter = _interopRequireDefault(__webpack_require__(1370));

var _dependencyManager = __webpack_require__(282);

var _editableCharts = __webpack_require__(1345);

var _redraphaelShapes = _interopRequireDefault(__webpack_require__(442));

var Raphael = (0, _dependencyManager.getDep)('redraphael', 'plugin'),
    UNDEF,
    COMMA = ',',
    configStr = 'config',
    TRACKER_FILL = 'rgba(192,192,192,' + (_lib.isIE ? 0.002 : 0.000001) + ')',
    VISIBLE = 'visible',
    HIDDEN = 'hidden',
    ROUND = 'round',
    POINTER = 'pointer',
    SELECTSCATTER = 'selectScatter',
    resizeInnerSymbolColor = '#999999',
    resizeOuterSymbolColor = '#777777',
    NULLSTR = 'null',
    closeButtonRadius = 6,
    trackerRadius = 12,
    deg2rad = Math.PI / 180,
    checkObjectLength = function checkObjectLength(item) {
  return Object.keys(item).length;
},
    getArcPath = function getArcPath(endX, endY, rX, rY, isClockWise, isLargeArc) {
  return ['A', rX, rY, 0, isLargeArc, isClockWise, endX, endY];
},
    M = 'M',
    L = 'L',
    Z = 'Z',
    t = 't'; // Resolve dependency to draw button shape


(0, _redraphaelShapes.default)(Raphael);

function _createSelectionBox(event) {
  var chart = event.chart,
      paper = chart.getFromEnv('paper'),
      chartConfig = chart.config,
      yAxis = chart.getChildren('yAxis')[0],
      xAxis = chart.getChildren('xAxis')[0],
      x = event.selectionLeft,
      y = event.selectionTop,
      width = event.selectionWidth,
      height = event.selectionHeight,
      x2 = x + width,
      y2 = y + height,
      TRACKER_WIDTH = 12,
      TRACKER_HALF_WIDTH = TRACKER_WIDTH * 0.5,
      cornerSymbolRadius = 15,
      isSmall = width > cornerSymbolRadius && height > cornerSymbolRadius,
      selectEleObj = {
    resizeEleRadius: cornerSymbolRadius,
    canvasTop: chartConfig.canvasTop,
    canvasRight: chartConfig.canvasLeft + chartConfig.canvasWidth,
    canvasLeft: chartConfig.canvasLeft,
    canvasBottom: chartConfig.canvasTop + chartConfig.canvasHeight
  },
      selectEleArr = chartConfig._selectEleArr || (chartConfig._selectEleArr = []),
      selectBoxG; // var TRACKER_FILL = 'rgba(255,0,0,0.3)';

  selectEleObj.index = selectEleArr.length;
  selectEleObj.id = 'SELECT_' + selectEleObj.index;
  selectEleObj.selectBoxG = selectBoxG = paper.group('selection-box', chart.getChildContainer('trackerGroup')).toFront(); // Drawing the main box element

  selectEleObj.selectBoxTracker = paper.rect(x, y, width, height, selectBoxG).attr({
    'stroke-width': 1,
    stroke: (0, _lib.toRaphaelColor)(chartConfig.selectBorderColor),
    fill: chartConfig.selectFillColor
  }).css({
    cursor: 'move'
  });
  selectEleObj.selectBoxTracker.node._isTrackerElem = true;
  selectEleObj.selectBoxTracker.data(configStr, {
    position: 6,
    // MOVE
    selectEleObj: selectEleObj,
    chart: chart,
    xChange: true,
    yChange: true
  }); // Draw top tracker element

  selectEleObj.topTracker = paper.rect(x, y - TRACKER_HALF_WIDTH, width, TRACKER_WIDTH, selectBoxG).attr({
    'stroke-width': 0,
    fill: TRACKER_FILL
  }).css('cursor', _lib.hasSVG && 'ns-resize' || 'n-resize');
  selectEleObj.topTracker.node._isTrackerElem = true;
  selectEleObj.topTracker.data(configStr, {
    position: 1,
    // TOP
    selectEleObj: selectEleObj,
    yChange: true,
    chart: chart
  }); // Draw right tracker element

  selectEleObj.rightTracker = paper.rect(x + width - TRACKER_HALF_WIDTH, y, TRACKER_WIDTH, height, selectBoxG).attr({
    'stroke-width': 0,
    fill: TRACKER_FILL
  }).css('cursor', _lib.hasSVG && 'ew-resize' || 'w-resize');
  selectEleObj.rightTracker.node._isTrackerElem = true;
  selectEleObj.rightTracker.data(configStr, {
    position: 2,
    // RIGHT
    chart: chart,
    selectEleObj: selectEleObj,
    xChange: true
  }); // Draw bottom tracker element

  selectEleObj.bottomTracker = paper.rect(x, y + height - TRACKER_HALF_WIDTH, width, TRACKER_WIDTH, selectBoxG).attr({
    'stroke-width': 0,
    fill: TRACKER_FILL
  }).css('cursor', _lib.hasSVG && 'ns-resize' || 'n-resize');
  selectEleObj.bottomTracker.node._isTrackerElem = true;
  selectEleObj.bottomTracker.data(configStr, {
    position: 3,
    // BOTTOM
    chart: chart,
    selectEleObj: selectEleObj,
    yChange: true
  }); // Draw left tracker element

  selectEleObj.leftTracker = paper.rect(x - TRACKER_HALF_WIDTH, y, TRACKER_WIDTH, height, selectBoxG).attr({
    'stroke-width': 0,
    fill: TRACKER_FILL
  }).css('cursor', _lib.hasSVG && 'ew-resize' || 'e-resize');
  selectEleObj.leftTracker.node._isTrackerElem = true;
  selectEleObj.leftTracker.data(configStr, {
    position: 4,
    // LEFT
    chart: chart,
    selectEleObj: selectEleObj,
    xChange: true
  });
  selectEleObj.cornerInnerSymbol = paper.symbol('resizeIcon', 0, 0, cornerSymbolRadius, selectBoxG).attr({
    transform: t + x2 + COMMA + y2,
    'stroke-width': 1,
    visibility: isSmall ? VISIBLE : HIDDEN,
    stroke: resizeInnerSymbolColor
  });
  selectEleObj.cornerInnerSymbol.node._isTrackerElem = true;
  selectEleObj.cornerOuterSymbol = paper.symbol('resizeIcon', 0, 0, -cornerSymbolRadius * 0.8, selectBoxG).attr({
    transform: t + x2 + COMMA + y2,
    strokeWidth: 1,
    visibility: !isSmall ? VISIBLE : HIDDEN,
    stroke: resizeOuterSymbolColor
  });
  selectEleObj.cornerOuterSymbol.node._isTrackerElem = true;
  selectEleObj.resizeTracker = paper.circle(x2, y2, trackerRadius, selectBoxG).attr({
    'stroke-width': 1,
    stroke: TRACKER_FILL,
    fill: TRACKER_FILL
  }).css('cursor', _lib.hasSVG && 'nwse-resize' || 'nw-resize');
  selectEleObj.resizeTracker.node._isTrackerElem = true;
  selectEleObj.resizeTracker.data(configStr, {
    position: 5,
    // Corner
    chart: chart,
    selectEleObj: selectEleObj,
    yChange: true,
    xChange: true
  });
  selectEleObj.closeButton = paper.symbol('closeIcon', 0, 0, closeButtonRadius, selectBoxG).attr({
    transform: 't' + x2 + COMMA + y,
    'stroke-width': 2,
    stroke: chartConfig.selectionCancelButtonBorderColor,
    fill: chartConfig.selectionCancelButtonFillColor,
    'stroke-linecap': ROUND,
    'stroke-linejoin': ROUND
  }).css({
    cursor: POINTER,
    _cursor: 'hand'
  }).on('fc-click', function () {
    // Delete the selection
    chart.deleteSelection(this, chart);
  });
  selectEleObj.closeButton.node._isTrackerElem = true;
  selectEleObj.closeButton.data(configStr, {
    chart: chart,
    index: selectEleObj.index
  }); // Previously wrong calculations were done. Fixed it.

  selectEleObj.startX = xAxis.getValue(x);
  selectEleObj.startY = yAxis.getValue(y);
  selectEleObj.endX = xAxis.getValue(x2);
  selectEleObj.endY = yAxis.getValue(y2);
  selectEleObj.isVisible = true;
  selectEleArr.push(selectEleObj);
  chart.bindDragEvent(selectEleObj);
}

function _deleteSelection(ele, chart) {
  var index = ele.data(configStr).index,
      // eslint-disable-line good-practices/no-single-usage-variable
  selectEleArr = chart.config._selectEleArr,
      selectEleObj,
      selectEleItem,
      xAxis = chart.getChildren('xAxis')[0],
      yAxis = chart.getChildren('yAxis')[0],
      items,
      bBox,
      eventArgs;
  selectEleObj = selectEleArr.find(function (item) {
    return item.index === index;
  });
  bBox = selectEleObj.selectBoxTracker.getBBox();
  eventArgs = {
    // eslint-disable-line good-practices/no-single-usage-variable
    selectionLeft: bBox.x,
    selectionTop: bBox.y,
    selectionWidth: bBox.width,
    selectionHeight: bBox.height,
    startXValue: xAxis.getValue(bBox.x, 1),
    startYValue: yAxis.getValue(bBox.y, 1),
    endXValue: xAxis.getValue(bBox.x + bBox.width, 1),
    endYValue: yAxis.getValue(bBox.y + bBox.height, 1),
    data: chart.getCollatedData(),
    id: selectEleObj.id
  };

  for (items in selectEleObj) {
    if (selectEleObj.hasOwnProperty(items)) {
      selectEleItem = selectEleObj[items];
      selectEleItem.remove && selectEleItem.remove();
      delete selectEleObj[items];
    }
  } // splice out the last removed slection box


  selectEleArr = selectEleArr.filter(checkObjectLength);
  /**
   * This event is raised when the selection of a SelectScatter chart is removed. This happens when one
   * clicks the close button on a selection that one has made on the chart.
   *
   * @event FusionCharts#selectionRemoved
   * @group chart-powercharts:selectscatter
   *
   * @param {Object} data - This returns the subset of data that was selected.
   */

  chart.fireChartInstanceEvent('selectionRemoved', eventArgs);
}

Raphael.addSymbol({
  resizeIcon: function resizeIcon(xVal, yVal, rad) {
    var radius = rad,
        x = xVal,
        y = yVal,
        LINE_GAP = (0, _lib.pluckNumber)(radius, 15) / 3,
        LINE_DIS = 3,
        paths = [],
        i;

    if (LINE_GAP < 0) {
      LINE_GAP = -LINE_GAP;
      radius = -radius;
      x += radius - LINE_GAP / 2;
      y += radius - LINE_GAP / 2;
    }

    for (i = 3; i > 0; i -= 1) {
      paths.push(M, x - LINE_GAP * i, y - LINE_DIS, L, x - LINE_DIS, y - LINE_GAP * i);
    }

    return paths;
  },
  closeIcon: function closeIcon(x, y, r) {
    var icoX = x,
        icoY = y,
        rad = r * 1.3,
        startAngle = 43 * deg2rad,
        // to prevent cos and sin of start and end from becoming
    // equal on 360 arcs
    endAngle = 48 * deg2rad,
        startX = icoX + rad * Math.cos(startAngle),
        // eslint-disable-line good-practices/no-single-usage-variable
    startY = icoY + rad * Math.sin(startAngle),
        // eslint-disable-line good-practices/no-single-usage-variable
    endX = icoX + rad * Math.cos(endAngle),
        // eslint-disable-line good-practices/no-single-usage-variable
    endY = icoY + rad * Math.sin(endAngle),
        // eslint-disable-line good-practices/no-single-usage-variable
    paths,
        r1 = 0.71 * (r - 2),
        // (r - 2) * 0.5,
    r2 = 0.71 * (r - 2),
        // (r - 2) * 0.87,
    arcPath = getArcPath(endX, endY, rad, rad, 0, 1); // eslint-disable-line good-practices/no-single-usage-variable

    paths = [M, startX, startY];
    paths = paths.concat(arcPath);
    paths = paths.concat([M, x + r1, y - r2, L, x - r1, y + r2, M, x - r1, y - r2, L, x + r1, y + r2]);
    return paths;
  },
  configureIcon: function configureIcon(x, y, rVal) {
    var k = 0.5,
        r = rVal - 1,
        l = 0.25,
        r1 = r * 0.71,
        r2 = (r + 2) * 0.71,
        x1 = x - r,
        y1 = y - r,
        x2 = x + r,
        y2 = y + r,
        x3 = x + k,
        y3 = y + k,
        x4 = x - k,
        y4 = y - k,
        x5 = x1 - 2,
        y5 = y1 - 2,
        x6 = x2 + 2,
        y6 = y2 + 2,
        x7 = x + r1,
        y7 = y + r1,
        x8 = x - r1,
        y8 = y - r1,
        x9 = x + r2,
        y9 = y + r2,
        x10 = x - r2,
        y10 = y - r2,
        paths; // eslint-disable-next-line good-practices/no-single-usage-variable

    paths = [M, x1, y3, L, x5, y3, x5, y4, x1, y4, x8 - l, y8 + l, x10 - l, y10 + l, x10 + l, y10 - l, x8 + l, y8 - l, x4, y1, x4, y5, x3, y5, x3, y1, x7 - l, y8 - l, x9 - l, y10 - l, x9 + l, y10 + l, x7 + l, y8 + l, x2, y4, x6, y4, x6, y3, x2, y3, x7 + l, y7 - l, x9 + l, y9 - l, x9 - l, y9 + l, x7 - l, y7 + l, x3, y2, x3, y6, x4, y6, x4, y2, x8 + l, y7 + l, x10 + l, y9 + l, x10 - l, y9 - l, x8 - l, y7 - l, Z];
    return paths;
  },
  axisIcon: function axisIcon(x, y, rVal) {
    var r = rVal - 1,
        r1 = r * 0.33,
        r2 = r / 2,
        x1 = x - r,
        y1 = y - r,
        x2 = x + r2,
        y2 = y + r,
        x3 = x - r2,
        y3 = y + r1,
        y4 = y - r1,
        paths; // eslint-disable-next-line good-practices/no-single-usage-variable

    paths = [M, x1, y1, L, x2, y1, x2, y2, x1, y2, M, x3, y3, L, x2, y3, M, x3, y4, L, x2, y4];
    return paths;
  },
  loggerIcon: function loggerIcon(xVal, yVal, rVal) {
    var r = rVal - 1,
        y = yVal - r,
        x = xVal - r,
        r2 = r * 2,
        // eslint-disable-line good-practices/no-single-usage-variable
    x1 = x + r2,
        x2 = x + 2,
        x3 = x1 - 2,
        y1 = y + 2,
        y2 = y1 + r,
        y3 = y2 + 2,
        paths; // eslint-disable-next-line good-practices/no-single-usage-variable

    paths = [M, x, y, L, x1, y, x1, y1, x3, y1, x3, y2, x1, y2, x1, y3, x, y3, x, y2, x2, y2, x2, y1, x, y1, x, y];
    return paths;
  }
});

var SelectScatter = /*#__PURE__*/function (_ScatterBase) {
  (0, _inheritsLoose2.default)(SelectScatter, _ScatterBase);

  /**
   * Provides the name of the chart extension
   *
   * @static
   * @return {string} The name of the chart extension
   */
  SelectScatter.getName = function getName() {
    return 'SelectScatter';
  }
  /**
   * Parse the chart attributes and store in chart's config
   * @param {Object} dataObj User input json
   */
  ;

  var _proto = SelectScatter.prototype;

  _proto.parseChartAttr = function parseChartAttr(dataObj) {
    _ScatterBase.prototype.parseChartAttr.call(this, dataObj);

    this.config.formBtnTitle = (0, _lib.pluck)(dataObj.chart.submittext,
    /**
     * @deprecated since 3.13.0.
     */
    // TODO: REMOVE formbtntitle parsing after two releases from 3.13.0
    dataObj.chart.formbtntitle, 'Submit');
    this.config.restoreBtnTitle = (0, _lib.pluck)(dataObj.chart.restoretext,
    /**
     * @deprecated since 3.13.0.
     */
    // TODO: REMOVE restorebtntitle parsing after two releases from 3.13.0
    dataObj.chart.restorebtntitle, 'Restore');
  };

  function SelectScatter() {
    var _this;

    _this = _ScatterBase.call(this) || this;
    _this.isXY = true;
    _this.defaultZeroPlaneHighlighted = false;
    _this.eiMethods = {
      // eslint-disable-next-line good-practices/no-function-dependency
      getData: function getData(format) {
        var apiInstance = this.apiInstance;
        return apiInstance && apiInstance.getData(format);
      },
      // eslint-disable-next-line good-practices/no-function-dependency
      restoreData: function restoreData() {
        var apiInstance = this.apiInstance;
        return apiInstance && apiInstance.restoreData();
      },
      // eslint-disable-next-line good-practices/no-function-dependency
      submitData: function submitData() {
        var apiInstance = this.apiInstance;
        return apiInstance && apiInstance.submitData();
      }
    };
    return _this;
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */


  _proto.getName = function getName() {
    return 'SelectScatter';
  }
  /**
   * Configures and parses chart attributes.
   *
   * @param {any} dataObj json data
   * @memberof SelectScatter
   */
  ;

  _proto.configureAttributes = function configureAttributes(dataObj) {
    var iapi = this,
        chartConfig = iapi.getFromEnv('chart').config,
        chartAttr = iapi.getFromEnv('dataSource').chart || {};
    chartConfig.formAction = (0, _lib.getValidValue)(chartAttr.formaction);
    chartConfig.enableSubmit = (0, _lib.pluckNumber)(chartAttr.enablesubmit,
    /**
     * @deprecated since 3.13.0.
     */
    // TODO: REMOVE showformbtn parsing after two releases from 3.13.0
    chartAttr.showformbtn, 1) && chartConfig.formAction;
    chartConfig.enableRestore = (0, _lib.pluckNumber)(chartAttr.enablerestore,
    /**
     * @deprecated since 3.13.0.
     */
    // TODO: REMOVE showrestorebtn parsing after two releases from 3.13.0
    chartAttr.showrestorebtn, 1);

    _ScatterBase.prototype.configureAttributes.call(this, dataObj);
  };

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    _ScatterBase.prototype.__setDefaultConfig.call(this);

    var config = this.config;
    config.hasLegend = true;
    config.defaultDatasetType = SELECTSCATTER;
    config.allowreversexaxis = true;
    config.enablemousetracking = true;
  };

  _proto.attachMenuButtons = function attachMenuButtons() {
    _ScatterBase.prototype.attachMenuButtons.call(this);

    var iapi = this,
        chartConfig = iapi.getFromEnv('chartConfig'),
        toolbar = iapi.getFromEnv('toolbar'),
        hamburgerMenu = toolbar.getChild("hamburgerMenu-" + toolbar.getId() + "-" + iapi.getId() + "-0"),
        // eslint-disable-line good-practices/no-single-usage-variable
    list = [],
        tempObj;
    chartConfig.enableRestore && list.push({
      name: chartConfig.restoreBtnTitle,
      handler: function handler() {
        iapi.restoreData();
      },
      action: 'click'
    });

    if (chartConfig.enableSubmit) {
      tempObj = {
        name: chartConfig.formBtnTitle,
        handler: function handler() {
          _editableCharts.submitData.call(iapi);
        },
        action: 'click'
      };
      list.push(tempObj);
    }

    list.length > 0 && hamburgerMenu.appendInMenu(list);
  };

  _proto.getData = function getData(format) {
    // create a two dimensional array as given in the docs
    var iapi = this,
        dataObj = iapi.getCollatedData(),
        returnObj = [],
        datasets = dataObj.dataset,
        length = datasets && datasets.length || 0,
        // eslint-disable-line good-practices/no-single-usage-variable
    index = 0,
        dsInd = 0,
        setLen,
        set,
        j; // When a format is provided

    if (format) {
      // no transcoding needed for json
      if (/^json$/ig.test(format)) {
        returnObj = dataObj;
      } else if (/^csv$/ig.test(format)) {
        returnObj = iapi.getCSVString();
      } else {
        returnObj = __webpack_require__.g.core.transcodeData(dataObj, 'json', format);
      }
    } else {
      // if no format has been specified, return data as 2d array.
      // while (length--) {
      for (; index < length; index += 1) {
        set = datasets[index];

        if (set) {
          set = datasets[index] && datasets[index].data;
          j = setLen = set && set.length || 0;
          j && (returnObj[dsInd] || (returnObj[dsInd] = [(0, _lib.getValidValue)(datasets[index].id, NULLSTR)]));

          while (j--) {
            returnObj[dsInd][j + 1] = (0, _lib.getValidValue)(set[j].id, NULLSTR);
          }

          setLen && (dsInd += 1);
        }
      }
    }

    return returnObj;
  };

  _proto.getCSVString = function getCSVString() {
    var dataObj = this.getData(),
        i = dataObj.length;

    while (i--) {
      dataObj[i] = dataObj[i].join(COMMA);
    }

    return dataObj.join('|');
  }
  /**
   * Takes datasource and finds out all the points present in the selection box.
   * @returns {Object} origChartData - Final data
   * @memberof SelectScatter
   */
  ;

  _proto.getCollatedData = function getCollatedData(incomingJSON) {
    var api = this,
        dataset = this.getDatasets(),
        // eslint-disable-line good-practices/no-single-usage-variable
    selectedArr = api.config._selectEleArr,
        len = selectedArr && selectedArr.length || 0,
        jsonData = incomingJSON || api.getFromEnv('dataSource'),
        origChartData = (0, _lib.extend2)({}, jsonData),
        origDataSets = origChartData.dataset,
        xPos,
        yPos,
        oriDataArr,
        selectionBoxObj,
        lenDS = origDataSets && origDataSets.length,
        isSelected = false,
        // eslint-disable-line good-practices/no-single-usage-variable
    dataIndex,
        setObj,
        dataLen,
        startX,
        endX,
        startY,
        endY,
        selectedData = [];

    if (!len || !lenDS) {
      return jsonData;
    }

    while (len--) {
      selectionBoxObj = selectedArr[len];

      if (!selectionBoxObj) {
        continue;
      }

      startX = selectionBoxObj.startX;
      endX = selectionBoxObj.endX;
      startY = selectionBoxObj.startY;
      endY = selectionBoxObj.endY;
      dataIndex = lenDS;

      while (dataIndex--) {
        if (!dataset[dataIndex].getState('visible')) {
          continue;
        }

        selectedData[dataIndex] || (selectedData[dataIndex] = {
          data: []
        });
        oriDataArr = origDataSets[dataIndex].data;
        dataLen = oriDataArr && oriDataArr.length;

        while (dataLen--) {
          setObj = oriDataArr[dataLen];
          xPos = setObj.x;
          yPos = setObj.y;

          if (xPos > startX && xPos < endX && yPos < startY && yPos > endY) {
            selectedData[dataIndex].data[dataLen] = isSelected = true;
          }
        }
      }
    }

    while (lenDS--) {
      oriDataArr = origDataSets[lenDS].data;
      dataLen = oriDataArr && oriDataArr.length;

      while (dataLen--) {
        if (!(selectedData[lenDS] && selectedData[lenDS].data[dataLen])) {
          oriDataArr.splice(dataLen, 1);
        }
      }
    }

    return isSelected ? origChartData : jsonData;
  };

  _proto.createSelectionBox = function createSelectionBox(event) {
    _createSelectionBox.call(this, event);
  };

  _proto._deleteAllSelection = function _deleteAllSelection() {
    var chart = this,
        selectEleArr = chart.config._selectEleArr,
        selectEleObj,
        i,
        ii,
        selectEleItem,
        items1;

    if (selectEleArr) {
      for (i = 0, ii = selectEleArr.length; i < ii; i++) {
        selectEleObj = selectEleArr[i];

        for (items1 in selectEleObj) {
          if (selectEleObj.hasOwnProperty(items1)) {
            selectEleItem = selectEleObj[items1];
            selectEleItem.remove && selectEleItem.remove();
            delete selectEleObj[items1];
          }
        }
      }

      delete chart.config._selectEleArr;
    }
  };

  _proto.deleteSelection = function deleteSelection(ele, chart) {
    _deleteSelection.call(this, ele, chart);
  };

  _proto.bindDragEvent = function bindDragEvent(selectEleObj) {
    var chart = this,
        // logic = chart.logic,
    item;

    for (item in selectEleObj) {
      /Tracker/.test(item) && selectEleObj[item].drag(chart.move, chart.start, chart.up);
    }
  };

  _proto.start = function start() {
    var ele = this,
        data = ele.data(configStr),
        // eslint-disable-line good-practices/no-single-usage-variable
    selectEleObj = data.selectEleObj,
        topT = selectEleObj.topTracker,
        rightT = selectEleObj.rightTracker,
        bottomT = selectEleObj.bottomTracker,
        leftT = selectEleObj.leftTracker,
        resizeT = selectEleObj.resizeTracker,
        topTData = topT.data(configStr),
        rightTData = rightT.data(configStr),
        bottomTData = bottomT.data(configStr),
        leftTData = leftT.data(configStr),
        resizeTData = resizeT.data(configStr),
        selectTData = selectEleObj.selectBoxTracker.data(configStr),
        bBox = selectEleObj.selectBoxTracker.getBBox();
    topTData.ox = bBox.x;
    topTData.oy = bBox.y;
    rightTData.ox = bBox.x2;
    rightTData.oy = bBox.y;
    bottomTData.ox = bBox.x;
    bottomTData.oy = bBox.y2;
    leftTData.ox = bBox.x;
    leftTData.oy = bBox.y;
    topTData.ox = bBox.x;
    topTData.oy = bBox.y;
    resizeTData.ox = bBox.x2;
    resizeTData.oy = bBox.y2;
    selectTData.ox = bBox.x;
    selectTData.oy = bBox.y;
    selectTData.ow = bBox.width;
    selectTData.oh = bBox.height;
    selectTData.ox2 = bBox.x2;
    selectTData.oy2 = bBox.y2; // on click take the selection box on top.

    selectEleObj.selectBoxG.toFront();
    topT.hide();
    rightT.hide();
    bottomT.hide();
    leftT.hide();
    resizeT.hide();
    ele.show();
  };

  _proto.move = function move(evt) {
    var ele = this,
        data = ele.data(configStr),
        selectEleObj = data.selectEleObj,
        chart = data.chart,
        topT = selectEleObj.topTracker,
        // eslint-disable-line good-practices/no-single-usage-variable
    rightT = selectEleObj.rightTracker,
        // eslint-disable-line good-practices/no-single-usage-variable
    bottomT = selectEleObj.bottomTracker,
        // eslint-disable-line good-practices/no-single-usage-variable
    leftT = selectEleObj.leftTracker,
        // eslint-disable-line good-practices/no-single-usage-variable
    resizeT = selectEleObj.resizeTracker,
        // eslint-disable-line good-practices/no-single-usage-variable
    selectT = selectEleObj.selectBoxTracker,
        canvasLeft = selectEleObj.canvasLeft,
        // eslint-disable-line good-practices/no-single-usage-variable
    canvasRight = selectEleObj.canvasRight,
        // eslint-disable-line good-practices/no-single-usage-variable
    canvasTop = selectEleObj.canvasTop,
        // eslint-disable-line good-practices/no-single-usage-variable
    canvasBottom = selectEleObj.canvasBottom,
        // eslint-disable-line good-practices/no-single-usage-variable
    HALF_T_WID = -6,
        xAxis = chart.getChildren('xAxis')[0],
        yAxis = chart.getChildren('yAxis')[0],
        selectTData = selectT.data(configStr),
        attrib = {},
        bBox,
        dx = evt.data[0],
        dy = evt.data[1],
        eventArgs,
        x,
        y;
    dx = data.xChange ? dx : 0;
    dy = data.yChange ? dy : 0;
    x = dx + data.ox;
    y = dy + data.oy;
    x = Math.min(canvasRight - (data.ow || 0), Math.max(x, canvasLeft));
    y = Math.min(canvasBottom - (data.oh || 0), Math.max(y, canvasTop));

    switch (data.position) {
      case 1:
        // TOP
        attrib.y = Math.min(selectTData.oy2, y);
        attrib.height = Math.abs(selectTData.oy2 - y) || 1;
        topT.attr({
          y: y + HALF_T_WID
        });
        break;

      case 2:
        // Right
        attrib.x = Math.min(selectTData.ox, x);
        attrib.width = Math.abs(selectTData.ox - x) || 1;
        rightT.attr({
          x: x + HALF_T_WID
        });
        break;

      case 3:
        // Bottom
        attrib.y = Math.min(selectTData.oy, y);
        attrib.height = Math.abs(selectTData.oy - y) || 1;
        bottomT.attr({
          y: y + HALF_T_WID
        });
        break;

      case 4:
        // Left
        attrib.x = Math.min(selectTData.ox2, x);
        attrib.width = Math.abs(selectTData.ox2 - x) || 1;
        leftT.attr({
          x: x + HALF_T_WID
        });
        break;

      case 5:
        // Corner
        attrib.x = Math.min(selectTData.ox, x);
        attrib.width = Math.abs(selectTData.ox - x) || 1;
        attrib.y = Math.min(selectTData.oy, y);
        attrib.height = Math.abs(selectTData.oy - y) || 1;
        resizeT.attr({
          cx: x,
          cy: y
        });
        break;

      default:
        attrib.x = x;
        attrib.y = y;
        break;
    }

    if (!ele.data('dragStarted')) {
      bBox = selectT.getBBox();
      eventArgs = {
        selectionLeft: bBox.x,
        selectionTop: bBox.y,
        selectionWidth: bBox.width,
        selectionHeight: bBox.height,
        startXValue: xAxis.getValue(bBox.x),
        startYValue: yAxis.getValue(bBox.y),
        endXValue: xAxis.getValue(bBox.x + bBox.width),
        endYValue: yAxis.getValue(bBox.y + bBox.height),
        id: selectEleObj.id
      };
      chart.fireChartInstanceEvent('BeforeSelectionUpdate', eventArgs);
      ele.data('dragStarted', 1);
    }

    selectT.animate(attrib);

    if (selectEleObj.isVisible) {
      selectEleObj.closeButton.hide();
      selectEleObj.cornerInnerSymbol.hide();
      selectEleObj.cornerOuterSymbol.hide();
      selectEleObj.isVisible = false;
    }
  };

  _proto.up = function up() {
    var ele = this,
        data = ele.data(configStr),
        selectEleObj = data.selectEleObj,
        chart = data.chart,
        xAxis = chart.getChildren('xAxis')[0],
        yAxis = chart.getChildren('yAxis')[0],
        topT = selectEleObj.topTracker,
        rightT = selectEleObj.rightTracker,
        bottomT = selectEleObj.bottomTracker,
        leftT = selectEleObj.leftTracker,
        resizeT = selectEleObj.resizeTracker,
        selectT = selectEleObj.selectBoxTracker,
        // eslint-disable-line good-practices/no-single-usage-variable
    RESIZE_T_RADIUS = 15,
        HALF_T_WID = -6,
        bBox,
        eventArgs; // using setTimeout to fix for the issue #RED-476.

    setTimeout(function () {
      bBox = selectT.getBBox();
      selectEleObj.startX = xAxis.getValue(bBox.x);
      selectEleObj.startY = yAxis.getValue(bBox.y);
      selectEleObj.endX = xAxis.getValue(bBox.x2);
      selectEleObj.endY = yAxis.getValue(bBox.y2);
      topT.attr({
        x: bBox.x,
        y: bBox.y + HALF_T_WID,
        width: bBox.width
      });
      rightT.attr({
        x: bBox.x2 + HALF_T_WID,
        y: bBox.y,
        height: bBox.height
      });
      bottomT.attr({
        x: bBox.x,
        y: bBox.y2 + HALF_T_WID,
        width: bBox.width
      });
      leftT.attr({
        x: bBox.x + HALF_T_WID,
        y: bBox.y,
        height: bBox.height
      });
      resizeT.attr({
        cx: bBox.x2,
        cy: bBox.y2
      });
      selectEleObj.closeButton.transform(t + bBox.x2 + COMMA + bBox.y);
      selectEleObj.cornerInnerSymbol.transform(t + bBox.x2 + COMMA + bBox.y2);
      selectEleObj.cornerOuterSymbol.transform(t + bBox.x2 + COMMA + bBox.y2);
      selectEleObj.closeButton.show();

      if (bBox.width < RESIZE_T_RADIUS || bBox.height < RESIZE_T_RADIUS) {
        selectEleObj.cornerInnerSymbol.hide();
        selectEleObj.cornerOuterSymbol.show();
      } else {
        selectEleObj.cornerInnerSymbol.show();
        selectEleObj.cornerOuterSymbol.hide();
      }

      selectEleObj.isVisible = true;
      topT.show();
      rightT.show();
      bottomT.show();
      leftT.show();
      resizeT.show();

      if (ele.data('dragStarted')) {
        eventArgs = {
          selectionLeft: bBox.x,
          selectionTop: bBox.y,
          selectionWidth: bBox.width,
          selectionHeight: bBox.height,
          startXValue: xAxis.getValue(bBox.x),
          startYValue: yAxis.getValue(bBox.y),
          endXValue: xAxis.getValue(bBox.x + bBox.width),
          endYValue: yAxis.getValue(bBox.y + bBox.height),
          data: chart.getCollatedData(),
          id: selectEleObj.id
        };
        chart.fireChartInstanceEvent('SelectionUpdated', eventArgs);
        ele.data('dragStarted', 0);
      }
    }, 100);
  };

  _proto.restoreData = function restoreData() {
    var chart = this,
        datasets = [],
        i;
    chart.iterateComponents(function (child) {
      if (child.getType && child.getType() === 'dataset') {
        datasets.push(child);
      }
    });

    chart._deleteAllSelection();

    for (i = 0; i < datasets.length; i++) {
      datasets[i].asyncDraw();
    }

    chart.fireChartInstanceEvent('dataRestored', {});
    return true;
  };

  _proto._postSpaceManagement = function _postSpaceManagement() {
    _ScatterBase.prototype._postSpaceManagement.call(this);

    this._deleteAllSelection();
  };

  _proto.getDSdef = function getDSdef() {
    return _selectscatter.default;
  } // This method return the dataset-group definations for this charts
  ;

  _proto.getDSGroupdef = function getDSGroupdef() {
    return UNDEF;
  };

  return SelectScatter;
}(_scatterbase.default);

var _default = SelectScatter;
exports["default"] = _default;

/***/ }),

/***/ 1378:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _sunburstDataset = _interopRequireDefault(__webpack_require__(1379));

var _multilevelpie = _interopRequireDefault(__webpack_require__(1373));

var _lib = __webpack_require__(274);

var DEFAULT_PALETTE_COLOR = ['1E77B4', 'FF7F0E', '2BA02C', 'D62728', '9466BD', '8C564B', 'E376C2', '7F7F7F', 'BCBD22', '17BECF'],
    DEFAULT_BG_COLOR = 'FFFFFF,FFFFFF';

var Sunburst = /*#__PURE__*/function (_MultilevelPie) {
  (0, _inheritsLoose2.default)(Sunburst, _MultilevelPie);

  /**
   * Provides the name of the chart extension
   *
   * @static
   * @return {string} The name of the chart extension
   */
  Sunburst.getName = function getName() {
    return 'Sunburst';
  };

  function Sunburst() {
    var _this;

    _this = _MultilevelPie.call(this) || this;
    _this.defaultPaletteOptions = {
      // Store colors now
      paletteColors: [DEFAULT_PALETTE_COLOR, DEFAULT_PALETTE_COLOR, DEFAULT_PALETTE_COLOR, DEFAULT_PALETTE_COLOR, DEFAULT_PALETTE_COLOR],
      bgColor: [DEFAULT_BG_COLOR, DEFAULT_BG_COLOR, DEFAULT_BG_COLOR, DEFAULT_BG_COLOR, DEFAULT_BG_COLOR]
    };

    _this.registerFactory('dataset', _sunburstDataset.default, ['canvas']);

    return _this;
  }

  var _proto = Sunburst.prototype;

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    _MultilevelPie.prototype.__setDefaultConfig.call(this);

    this.config.allowdrilltonode = 1;
    this.config.showvaluesintooltip = 1;
  };

  _proto.configureAttributes = function configureAttributes(dataSource) {
    _MultilevelPie.prototype.configureAttributes.call(this, dataSource);

    var chart = this;
    chart.config.allowdrilltonode = (0, _lib.pluckNumber)(dataSource.chart.allowdrilltonode, 1);

    if (chart.config.allowdrilltonode) {
      chart.addToEnv('linkClickFN', function () {
        return null;
      });
    }
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */
  ;

  _proto.getName = function getName() {
    return 'Sunburst';
  }
  /**
   * function to check if the chart specific data is proper is not
   * this fn is define for specific chart types
   * @return {boolean} if JSON data is valid or not
   */
  ;

  _proto._checkInvalidSpecificData = function _checkInvalidSpecificData() {
    var parsedDS = this.parseAndSanitizeData();
    var i = 0;

    if (!parsedDS || !Array.isArray(parsedDS) || parsedDS.length === 0) {
      return true;
    }

    for (; i < parsedDS.length; i++) {
      if (parsedDS[i].category && parsedDS[i].category.length === 0 && !parsedDS[i].value) {
        return true;
      }
    }
  };

  _proto.parseAndSanitizeData = function parseAndSanitizeData() {
    var categories = [],
        flatInput = [],
        tempMap = {},
        chart = this,
        dataSource = (0, _lib.extend2)({}, chart.getFromEnv('dataSource'));

    if (dataSource && dataSource.data && Array.isArray(dataSource.data)) {
      flatInput = dataSource.data.map(function (item) {
        tempMap[item.id] = item;
        !item.parent && (item.isRootNode = true);
        !item.categories && (item.category = []);
        return item;
      }).filter(function (item) {
        if (item.id && (!item.value || !isNaN(+item.value))) {
          if (!item.parent || item.parent && tempMap[item.parent]) {
            return true;
          }
        }

        delete tempMap[item.id];
        return false;
      });

      for (var key in tempMap) {
        if (tempMap.hasOwnProperty(key)) {
          var item = tempMap[key];

          if (item.parent) {
            tempMap[item.parent].category.push(item);
          }

          if (item.isRootNode) {
            categories.push(item);
          }
        }
      }

      chart.addToEnv('parsedDataSource', categories);
    }

    return flatInput;
  };

  return Sunburst;
}(_multilevelpie.default);

var _default = Sunburst;
exports["default"] = _default;

/***/ }),

/***/ 1362:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _sscartesian = _interopRequireDefault(__webpack_require__(517));

var _waterfall2d = _interopRequireDefault(__webpack_require__(1363));

var _scrollApis = __webpack_require__(690);

var WATERFALL_2D = 'Waterfall2D';

var WaterFall2D = /*#__PURE__*/function (_SSCartesian) {
  (0, _inheritsLoose2.default)(WaterFall2D, _SSCartesian);

  function WaterFall2D() {
    return _SSCartesian.apply(this, arguments) || this;
  }

  /**
   * Provides the name of the chart extension
   *
   * @static
   * @return {string} The name of the chart extension
   */
  WaterFall2D.getName = function getName() {
    return 'WaterFall2D';
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */
  ;

  var _proto = WaterFall2D.prototype;

  _proto.getName = function getName() {
    return 'WaterFall2D';
  };

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    _SSCartesian.prototype.__setDefaultConfig.call(this);

    this.hasScroll = true;
    var config = this.config;
    config.singleseries = true;
    config.hasLegend = false;
    config.defaultDatasetType = WATERFALL_2D;
    config.enablemousetracking = true;
    config.avgScrollPointWidth = 75;
  }
  /**
   * Sets xAxis scale visible region
   */
  ;

  _proto._setAxisScale = function _setAxisScale() {
    _scrollApis.setAxisScale.call(this);
  };

  _proto.getDSdef = function getDSdef() {
    return _waterfall2d.default;
  };

  return WaterFall2D;
}(_sscartesian.default);

var _default = WaterFall2D;
exports["default"] = _default;

/***/ }),

/***/ 1425:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _componentInterface = __webpack_require__(290);

var _lib = __webpack_require__(274);

/**
 * class to make the mathematical calculations for boxAndWhisker
 */
var BoxAndWhiskerStatisticalCalc = /*#__PURE__*/function (_ComponentInterface) {
  (0, _inheritsLoose2.default)(BoxAndWhiskerStatisticalCalc, _ComponentInterface);

  function BoxAndWhiskerStatisticalCalc() {
    return _ComponentInterface.apply(this, arguments) || this;
  }

  var _proto = BoxAndWhiskerStatisticalCalc.prototype;

  /**
   * Function to set the data for the bw calculator
   * @param {string} val The comma separated string value
   */
  _proto.setArray = function setArray(val) {
    var nf = this.getFromEnv('number-formatter'),
        // eslint-disable-line good-practices/no-single-usage-variable
    sum = 0,
        // eslint-disable-line good-practices/no-single-usage-variable
    len,
        value = val,
        dataArr;
    !value && (value = _lib.BLANK); // First we make an arry form the comma-separated value.
    // and then we sort and store the data array in dataArr
    //  for further calculation.

    dataArr = value.replace(/\s/g, _lib.BLANK).split(_lib.COMMASTRING); // Parse the values using NumberFormatter getCleanValue

    len = this.dataLength = dataArr && dataArr.length;

    while (len--) {
      sum += dataArr[len] = nf.getCleanValue(dataArr[len]);
    } // Now sort the data in ascending order
    // eslint-disable-next-line good-practices/no-function-dependency


    dataArr && dataArr.sort(function (a, b) {
      return a - b;
    });
    this.values = dataArr; // Calculate and store the Mean

    this.mean = sum / this.dataLength;
    this.getFrequencies();
  }
  /**
   * Function to get the values of quartiles
   * @return {Object} The value of 1st and 3rd quartile
   */
  ;

  _proto.getQuartiles = function getQuartiles() {
    var values = this.values,
        len = this.dataLength,
        isOdd = len % 2,
        q1Pos,
        q1LowPos,
        q3Pos,
        q3LowPos,
        q1Val,
        q3Val,
        method = _lib.BLANKSTRING; // eslint-disable-line good-practices/no-single-usage-variable

    switch (method) {
      case 'tukey':
        if (isOdd) {
          // Q1 = n + 3 / 4 And Q3 = 3N + 1 / 4
          q1Pos = (len + 3) / 4;
          q3Pos = (len * 3 + 1) / 4;
        } else {
          // Q1 = n + 2 / 4 And Q3 = 3N + 2 / 4
          q1Pos = (len + 2) / 4;
          q3Pos = (len * 3 + 2) / 4;
        }

        break;

      case 'mooremccabe':
        if (isOdd) {
          // Q1 = n + 1 / 4 And Q3 = 3N + 3 / 4
          q1Pos = (len + 1) / 4;
          q3Pos = q1Pos * 3;
        } else {
          // Q1 = n + 2 / 4 And Q3 = 3N + 2 / 4
          q1Pos = (len + 2) / 4;
          q3Pos = (len * 3 + 2) / 4;
        }

        break;

      case 'freundperles':
        // Q1 = n + 3 / 4 And Q3 = 3N + 1 / 4
        q1Pos = (len + 3) / 4;
        q3Pos = (len * 3 + 1) / 4;
        break;

      case 'mendenhallsincich':
        // Q1 = [n + 1 / 4] And [Q3 = 3N + 3 / 4]
        q1Pos = Math.round((len + 1) / 4);
        q3Pos = Math.round(q1Pos * 3);
        break;

      default:
        // Q1 = n + 1 / 4 And Q3 = 3N + 3 / 4
        q1Pos = (len + 1) / 4;
        q3Pos = q1Pos * 3;
        break;
    }

    q1Pos -= 1;
    q3Pos -= 1;
    q1LowPos = Math.floor(q1Pos);
    q3LowPos = Math.floor(q3Pos);
    q1Val = q1Pos - q1LowPos ? values[q1LowPos] + // eslint-disable-line good-practices/no-single-usage-variable
    (values[Math.ceil(q1Pos)] - values[q1LowPos]) * (q1Pos - q1LowPos) : values[q1Pos];
    q3Val = q3Pos - q3LowPos ? values[q3LowPos] + // eslint-disable-line good-practices/no-single-usage-variable
    (values[Math.ceil(q3Pos)] - values[q3LowPos]) * (q3Pos - q3LowPos) : values[q3Pos];
    this.quartiles = {
      q1: q1Val,
      q3: q3Val
    };
    return this.quartiles;
  }
  /**
   * Return min and max values from the data array.
   * @return {Object} Contains the minimum and maximum of the entered data
   */
  ;

  _proto.getMinMax = function getMinMax() {
    var values = this.values;
    return {
      min: values[0],
      max: values[this.dataLength - 1]
    };
  }
  /**
   * calculate and returns the mean value
   * @return {number} mean value
   */
  ;

  _proto.getMean = function getMean() {
    return this.mean;
  }
  /**
   * calculate the MeanDeviation
   * @return {number} meanDevaition
   */
  ;

  _proto.getMD = function getMD() {
    var mean = this.mean,
        // eslint-disable-line good-practices/no-single-usage-variable
    freq = this.frequencies,
        freqLen = freq.length,
        freqObj,
        sum = 0; // eslint-disable-line good-practices/no-single-usage-variable

    while (freqLen--) {
      freqObj = freq[freqLen];
      sum += freqObj.frequency * Math.abs(freqObj.value - mean);
    }

    return sum / this.dataLength;
  }
  /**
   * calculate the standard deviation
   * @return {number} standard deviation
   */
  ;

  _proto.getSD = function getSD() {
    var mean = this.mean,
        // eslint-disable-line good-practices/no-single-usage-variable
    values = this.values,
        // eslint-disable-line good-practices/no-single-usage-variable
    i = this.dataLength,
        len = i,
        // eslint-disable-line good-practices/no-single-usage-variable
    sum = 0; // eslint-disable-line good-practices/no-single-usage-variable

    while (i--) {
      sum += Math.pow(values[i] - mean, 2);
    }

    return Math.sqrt(sum / (len - 1));
  }
  /**
   * calculate the quartile deviation
   * @return {number} quartile deviation
   */
  ;

  _proto.getQD = function getQD() {
    return (this.quartiles.q3 - this.quartiles.q1) * 0.5;
  }
  /**
   * calculate the frequencies and sum of the values
   */
  ;

  _proto.getFrequencies = function getFrequencies() {
    var frequenciesArr = [],
        len = this.dataLength,
        // eslint-disable-line good-practices/no-single-usage-variable
    values = this.values,
        // eslint-disable-line good-practices/no-single-usage-variable
    sum = 0,
        // eslint-disable-line good-practices/no-single-usage-variable
    value,
        freqObj,
        index;

    for (index = 0; index < len; index += 1) {
      sum += value = values[index];

      if ((0, _lib.defined)(frequenciesArr[index])) {
        frequenciesArr[index].frequency += 1;
      } else {
        freqObj = {};
        freqObj.value = value;
        freqObj.frequency = 1;
        frequenciesArr[index] = freqObj;
      }
    }

    this.sum = sum;
    this.frequencies = frequenciesArr;
  }
  /**
   * Function to get the median value
   * @return {number} median
   */
  ;

  _proto.getMedian = function getMedian() {
    var len = this.dataLength,
        midVal = len * 0.5,
        values = this.values;
    return len % 2 === 0 ? (values[midVal] + values[midVal - 1]) / 2 : values[Math.floor(midVal)];
  };

  return BoxAndWhiskerStatisticalCalc;
}(_componentInterface.ComponentInterface);

var _default = BoxAndWhiskerStatisticalCalc;
exports["default"] = _default;

/***/ }),

/***/ 1422:
/***/ ((__unused_webpack_module, exports) => {



exports.__esModule = true;
exports["default"] = void 0;
var _default = {
  'initial.dataset.boxandwhiskerline': function initialDatasetBoxandwhiskerline() {
    return {
      'line.appearing': [{
        initialAttr: {
          opacity: 0
        },
        finalAttr: {
          opacity: 1
        },
        slot: 'plot',
        startEnd: {
          start: 0.5,
          end: 1
        }
      }],
      'anchor.appearing': [{
        initialAttr: {
          opacity: 0
        },
        finalAttr: {
          opacity: 1
        },
        slot: 'plot',
        startEnd: {
          start: 0.5,
          end: 1
        }
      }]
    };
  }
};
exports["default"] = _default;

/***/ }),

/***/ 1421:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _line = _interopRequireDefault(__webpack_require__(616));

var _lib = __webpack_require__(274);

var _dependencyManager = __webpack_require__(282);

var _boxandwhiskerline = _interopRequireDefault(__webpack_require__(1422));

/* eslint require-jsdoc: 'error', valid-jsdoc: ["error", { "requireReturn": false }] */
var UNDEF,
    POLYGON = _lib.preDefStr.POLYGON,
    SPOKE = _lib.preDefStr.SPOKE,
    BOLDSTARTTAG = '<b>',
    BOLDENDTAG = '</b>',

/**
 * Helper function to create a RedRaphael group.
 * @param  {Object} attrs  List of attributes that are applied to the created group.
 * @param  {Element} parentContainer         The parent container in which the group will be appended.
 * @param {Object} dataset The concerned dataset
 * @return {Element}                         The group that was created.
 */
createGroup = function createGroup(attrs, parentContainer, dataset) {
  return dataset.getFromEnv('animationManager').setAnimation({
    el: 'group',
    attr: attrs,
    container: parentContainer,
    component: dataset,
    label: 'group'
  });
};

(0, _dependencyManager.addDep)({
  name: 'boxandwhiskerlineAnimation',
  type: 'animationRule',
  extension: _boxandwhiskerline.default
});
/**
 * Class for boxAndWhiskerLine dataset
 */

var BoxAndWhiskerLinedataset = /*#__PURE__*/function (_Linedataset) {
  (0, _inheritsLoose2.default)(BoxAndWhiskerLinedataset, _Linedataset);

  function BoxAndWhiskerLinedataset() {
    return _Linedataset.apply(this, arguments) || this;
  }

  var _proto = BoxAndWhiskerLinedataset.prototype;

  /**
   * Gets the name of the component
   * @return {string} name
   */
  _proto.getName = function getName() {
    return 'boxandwhiskerline';
  }
  /**
   * Create pixel coordinates for the plots
   */
  ;

  _proto.createCoordinates = function createCoordinates() {
    var dataset = this,
        dsData = dataset.components.data,
        // chart = dataset.getFromEnv('chart'),
    // isBar = chart.isBar,
    yAxis = dataset.getFromEnv('yAxis'),
        // eslint-disable-line good-practices/no-single-usage-variable
    xAxis = dataset.getFromEnv('xAxis'),
        // eslint-disable-line good-practices/no-single-usage-variable
    // yBase = yAxis.getAxisBase(),
    // yBasePos = yAxis.getPixel(yBase),
    dataObj,
        config,
        // previousY,
    i,
        Px,
        Py,
        len = dsData.length; // eslint-disable-line good-practices/no-single-usage-variable
    // !isBar && (xDepth = -xDepth);
    // isBar && (yDepth = -yDepth);

    for (i = 0; i < len; i++) {
      dataObj = dsData[i];
      config = dataObj && dataObj.config;

      if (dataObj === UNDEF) {
        continue;
      } // previousY = config._b;


      Px = xAxis.getPixel(config._x);
      Py = yAxis.getPixel(config._y); // Pb = (previousY ? yAxis.getPixel(previousY) : yBasePos) + yDepth;

      config._Px = Px + dataset.getFromEnv('columnXShift') + dataset.getFromEnv('columnWidth') / 2;
      config._Py = Py; // config._Pby = Pb;
      // config._Pbx = Px;
    }
  }
  /**
  * Returns all plots between the provided category indices
  * @param {Number} min Min category index
  * @param {Number} max Max category index
  * @return {Array} Plots between those indices
  */
  ;

  _proto.getAllPlots = function getAllPlots(min, max) {
    var data = this.components.data,
        allPlots = [],
        i,
        len;

    for (i = 0, len = data.length; i < len; i++) {
      // eslint-disable-line good-practices/no-single-usage-variable
      if (data[i].config._x >= min || data[i].config._x <= max) {
        allPlots.push(data[i]);
      }
    }

    return allPlots;
  }
  /**
   * calculate min and max position to scroll
   */
  ;

  _proto.calculateScrollRange = function calculateScrollRange() {
    var dataSet = this,
        conf = dataSet.config,
        data = dataSet.components.data; // eslint-disable-line good-practices/no-single-usage-variable

    conf.scrollMinVal = 0;
    conf.scrollMaxVal = data.length; // Since panning and data skipping are not applicable for scatter and bubble charts, the labels'
    // minimum and maximum index to be drawn is the same as the plots' minimum and maximum index.

    conf.scrollMinValForLabel = conf.scrollMinVal;
    conf.scrollMaxValForLabel = conf.scrollMaxVal;
  }
  /**
   * Function that return the nearest plot details
   * @param   {number} chartXVal x-axis position of the mouse cordinate
   * @param   {number} chartYVal y-axis position of the mouse cordinate
   * @return {Object} return an object with details of nearest plot and whether it is
   *                   hovered or not
   */
  ;

  _proto._getHoveredPlot = function _getHoveredPlot(chartXVal, chartYVal) {
    var dataset = this,
        chartX = chartXVal,
        chartY = chartYVal,
        xAxis = dataset.getFromEnv('xAxis'),
        dataStore = dataset.components.data,
        // eslint-disable-line good-practices/no-single-usage-variable
    pointObj,
        xMin,
        xMax,
        len = dataStore.length,
        // eslint-disable-line good-practices/no-single-usage-variable
    returnValue,
        conf = dataset.config,
        j,
        maxRadius = conf && conf.radius || 0,
        allPlots; // getting new chart XY accordint to Translation of axis

    chartX += xAxis.getTranslation();
    xMin = Math.floor(Math.max(xAxis.getValue(chartX - maxRadius), 0)); // eslint-disable-line good-practices/no-single-usage-variable

    xMax = Math.ceil(Math.min(xAxis.getValue(chartX + maxRadius), len - 1)); // eslint-disable-line good-practices/no-single-usage-variable

    allPlots = dataset.getAllPlots(xMin, xMax);

    for (j = allPlots.length; j >= 0; j--) {
      pointObj = allPlots[j];

      if (pointObj) {
        returnValue = dataset.isWithinShape(pointObj, j, chartX, chartY);

        if (returnValue) {
          break;
        }
      }
    }

    return returnValue;
  }
  /**
   * Function to add legend for LineDs only when the function is called from its parent ds
   * @param {boolean} callFromParentDS if call is from parent ds
   */
  ;

  _proto._addLegend = function _addLegend(callFromParentDS) {
    if (!callFromParentDS) {
      return;
    }

    var dataset = this,
        conf = dataset.config,
        legend = dataset.getFromEnv('chart').getChildren('legend')[0],
        legendItem,
        drawAnchors = (0, _lib.pluckNumber)(conf.drawanchors, 1),
        // eslint-disable-line good-practices/no-single-usage-variable
    config;

    if (conf.includeinlegend) {
      config = {
        anchorSide: drawAnchors ? conf.anchorsides : 0,
        label: (0, _lib.getFirstValue)(conf.JSONData.seriesname),
        customLegendIcon: false,
        spoke: conf.dip === 'spoke' ? 1 : 0,
        drawLine: !conf.showline,
        index: dataset.getJSONIndex()
      };
      legendItem = legend.getItem(dataset.config.legendItemId);

      if (!legendItem) {
        dataset.config.legendItemId = legend.createItem(dataset);
        legendItem = legend.getItem(dataset.config.legendItemId);
        dataset.addExtEventListener('fc-click', function () {
          legendItem.itemClickFn();
        }, legendItem);
      }

      legendItem.configure(config);
      legendItem.setStateCosmetics('default', {
        symbol: {
          fill: (0, _lib.toRaphaelColor)({
            color: conf.anchorbgcolor,
            alpha: conf.anchorbgalpha
          }),
          rawFillColor: conf.anchorbgcolor,
          stroke: (0, _lib.toRaphaelColor)({
            color: conf.anchorbordercolor,
            alpha: '100'
          })
        },
        background: {
          legendBackgroundColor: (0, _lib.toRaphaelColor)(dataset.getFromEnv('legendBackgroundColor')),
          alpha: 20
        }
      }); // check if dataset is initiallyhidden

      if (!dataset.getState('visible')) {
        legendItem.setLegendState('hidden');
      } else {
        // remove hidden state of legend item is dataset is not hidden
        legendItem.removeLegendState('hidden');
      }
    } else if (dataset.config.legendItemId) {
      legend.disposeItem(dataset.config.legendItemId);
    }
  }
  /**
    * Function for parsing all the attributes and value given by the user at chart,dataset and set level.
    * @param  {Object} datasetJSON JSON for dataset configurations
    */
  ;

  _proto.configureAttributes = function configureAttributes(datasetJSON) {
    _Linedataset.prototype.configureAttributes.call(this, datasetJSON);

    var dataset = this,
        JSONData = dataset.config.JSONData,
        conf = dataset.config;
    dataset.setState('visible', dataset.getLinkedParent().getState('visible')); // chartAttr = dataset.getFromEnv('chart-attrib');

    conf.skipCommonElements = JSONData.showline;
    conf.dip = JSONData.dip;
  }
  /**
   * function to create group for dataset
   */
  ;

  _proto.createContainer = function createContainer() {
    var dataset = this,
        parent = dataset.getLinkedParent().getLinkedParent(),
        group = dataset.groupName || dataset.dsGroup || dataset.getType(),
        parentContainer,
        parentShadowContainer;
    !parent.getChildContainer(group + 'VcanvasGroup') && (group = 'default');
    parentContainer = parent.getChildContainer('manager-defaultVcanvasGroup-lines');
    parentShadowContainer = parent.getChildContainer(group + 'ShadowVcanvasGroup'); // eslint-disable-line good-practices/no-single-usage-variable

    !dataset.getContainer('shadowGroup') && dataset.addContainer('shadowGroup', createGroup({
      name: 'shadow-group'
    }, parentShadowContainer, dataset));
    !dataset.getContainer('commonElemsGroup') && dataset.addContainer('commonElemsGroup', createGroup({
      name: 'common-elems-group'
    }, parentContainer, dataset));
    !dataset.getContainer('plotGroup') && dataset.addContainer('plotGroup', createGroup({
      name: 'common-elems-group'
    }, parentContainer, dataset));
    !dataset.getContainer('labelGroup') && dataset.addContainer('labelGroup', createGroup({
      name: 'label-group',
      class: 'fusioncharts-datalabels',
      opacity: 1
    }, parent.getChildContainer('vcanvasLabelGroup'), dataset));
  }
  /**
   * Configure data level
   * @param {Object} newDataset new dataset added
   * @param {Object} newIndex new added dataset index
   */
  ;

  _proto._setConfigure = function _setConfigure(newDataset, newIndex) {
    var dataSet = this,
        conf = dataSet.config,
        chartConfig = dataSet.getFromEnv('chartConfig'),
        // eslint-disable-line good-practices/no-single-usage-variable
    JSONData = dataSet.config.JSONData,
        setDataArr = newDataset || JSONData.data || [],
        setData,
        dataObj,
        catLen = dataSet.getFromEnv('xAxis').getTicksLen(),
        // eslint-disable-line good-practices/no-single-usage-variable
    newDataSetLen = newDataset && newDataset.data.length,
        len = JSONData.seriesname === 'Outliers' ? setDataArr.length : newDataSetLen || Math.min(catLen, setDataArr.length),
        dataStore,
        i,
        plotIndex,
        config,
        outlierIconShape,
        tempIndex;
    conf.imageCount = 0;
    dataStore = dataSet.components.data;

    if (!dataStore) {
      dataStore = dataSet.components.data = [];
    }

    conf.maxRadius = -Infinity;

    for (i = 0; i < len; i++) {
      if (newDataset) {
        setData = newDataset && newDataset.data[i] || {};

        if (newIndex !== UNDEF) {
          tempIndex = newIndex + i;
          dataObj = dataStore[tempIndex];
        } else {
          tempIndex = dataStore.length - len + i;
          dataObj = dataStore[tempIndex];
        }

        plotIndex = tempIndex;
      } else {
        dataObj = dataStore[i];
        setData = setDataArr && setDataArr[i] || {};
        plotIndex = i;
      }

      if (!dataObj) {
        dataObj = dataStore[plotIndex] = {};
      }

      if (!dataObj.config) {
        dataObj.config = {};
      }

      if (!dataObj.graphics) {
        dataObj.graphics = {};
      }

      dataSet._plotConfigure(plotIndex, setData, newDataSetLen);

      tempIndex && tempIndex++;
      config = dataObj && dataObj.config;
      outlierIconShape = (0, _lib.pluck)(setData.dip, JSONData.dip);
      config.dip = outlierIconShape === POLYGON ? 0 : outlierIconShape === SPOKE ? 1 : 0;
      config.toolText = config.finalTooltext = BOLDSTARTTAG + JSONData.seriesname + chartConfig.tooltipsepchar + BOLDENDTAG + config.displayValue;
    }
  };

  return BoxAndWhiskerLinedataset;
}(_line.default);

var _default = BoxAndWhiskerLinedataset;
exports["default"] = _default;

/***/ }),

/***/ 1423:
/***/ ((__unused_webpack_module, exports) => {



exports.__esModule = true;
exports["default"] = void 0;
var _default = {
  'initial.dataset.boxandwhisker2D': function initialDatasetBoxandwhisker2D() {
    return {
      'upperBox.appearing': function upperBoxAppearing(inputJSON) {
        return [{
          initialAttr: {
            x: inputJSON.attr.x,
            y: inputJSON.attr.y + inputJSON.attr.height,
            height: 0,
            width: inputJSON.attr.width
          },
          slot: 'plot',
          startEnd: {
            start: 0,
            end: 0.5
          }
        }];
      },
      'lowerBox.appearing': function lowerBoxAppearing(inputJSON) {
        return [{
          initialAttr: {
            x: inputJSON.attr.x,
            y: inputJSON.attr.y,
            height: 0,
            width: inputJSON.attr.width
          },
          slot: 'plot',
          startEnd: {
            start: 0,
            end: 0.5
          }
        }];
      },
      'path.appearing': [{
        initialAttr: {
          opacity: 0
        },
        finalAttr: {
          opacity: 1
        },
        slot: 'plot',
        startEnd: {
          start: 0.5,
          end: 1
        }
      }],
      'midline.appearing': [{
        initialAttr: {
          opacity: 0
        },
        finalAttr: {
          opacity: 1
        },
        slot: 'plot',
        startEnd: {
          start: 0,
          end: 0.2
        }
      }],
      'group.appearing': function groupAppearing(inputJSON) {
        if (inputJSON.attr.name === 'label-group') {
          return [{
            initialAttr: {
              opacity: 0
            },
            finalAttr: {
              opacity: 1
            },
            slot: 'final'
          }];
        }

        return [{
          initialAttr: {
            opacity: 1
          },
          finalAttr: {
            opacity: 1
          },
          slot: 'final'
        }];
      },
      '*': null
    };
  }
};
exports["default"] = _default;

/***/ }),

/***/ 1420:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _column = _interopRequireDefault(__webpack_require__(595));

var _boxandwhiskerline = _interopRequireDefault(__webpack_require__(1421));

var _lib = __webpack_require__(274);

var _dependencyManager = __webpack_require__(282);

var _index = _interopRequireDefault(__webpack_require__(1423));

/* eslint require-jsdoc: 'error', valid-jsdoc: ["error", { "requireReturn": false }] */
var PLOTBORDERCOLOR = 'plotBorderColor',
    PLOTGRADIENTCOLOR = 'plotGradientColor',
    SHOWSHADOW = 'showShadow',
    SETROLLOVERATTR = 'setRolloverAttr',
    SETROLLOUTATTR = 'setRolloutAttr',
    UNDEFINED,
    colorStrings = _lib.preDefStr.colors,
    COLOR_000000 = colorStrings.c000000,
    strokeColor = COLOR_000000,
    LABEL = _lib.preDefStr.LABEL,
    ROLLOVER = 'DataPlotRollOver',
    ROLLOUT = 'DataPlotRollOut',
    UNDERSCORE = _lib.preDefStr.UNDERSCORE,
    POINTER = _lib.preDefStr.POINTER,
    BLANK = _lib.preDefStr.BLANK,
    ROUND = _lib.preDefStr.ROUND,
    GROUPID = _lib.preDefStr.GROUPID,
    POSITION_START = _lib.preDefStr.POSITION_START,
    POSITION_BOTTOM = _lib.preDefStr.POSITION_BOTTOM,
    POSITION_TOP = _lib.preDefStr.POSITION_TOP,
    showHoverEffectStr = _lib.preDefStr.showHoverEffectStr,
    EVENTARGS = _lib.preDefStr.EVENTARGS,
    // dataLabelStr = preDefStr.dataLabelStr,
// shadowStr = preDefStr.shadowStr,
POSITION_END = _lib.preDefStr.POSITION_END,
    M = 'M',
    H = 'H',
    V = 'V',
    BOLDSTARTTAG = '<b>',
    BOLDENDTAG = '</b>',
    BREAKSTRING = '<br />',
    MAXIMUM_STR = 'Maximum',
    Q3_STR = 'Q3',
    MEDIAN_STR = 'Median',
    Q1_STR = 'Q1',
    MINIMUM_STR = 'Minimum',
    pStr = _lib.preDefStr.pStr,
    sStr = _lib.preDefStr.sStr,
    NONE = 'none',
    createChildIndices = function createChildIndices(index, len) {
  var indices = [],
      length = len;

  while (length) {
    indices.unshift(index + Number('.' + length));
    length--;
  }

  return indices;
},

/**
 * Helper function to create a RedRaphael group.
 * @param  {Object} attr  Attributes applied to the created group.
 * @param  {Element} parentContainer         The parent container in which the group will be appended.
 * @param {Object} dataset The concerned dataset
 * @return {Element}                         The group that was created.
 */
createGroup = function createGroup(attr, parentContainer, dataset) {
  return dataset.getFromEnv('animationManager').setAnimation({
    el: 'group',
    attr: attr,
    container: parentContainer,
    component: dataset,
    label: 'group'
  });
},
    _hide = function _hide() {
  // eslint-disable-next-line good-practices/no-function-dependency
  return function () {
    this.hide();
  };
};

(0, _dependencyManager.addDep)({
  name: 'boxandwhisker2dAnimation',
  type: 'animationRule',
  extension: _index.default
});
/**
 * Class for boxAndWhisker Dataset
 */

var BoxAndWhiskerDataset = /*#__PURE__*/function (_ColumnDataset) {
  (0, _inheritsLoose2.default)(BoxAndWhiskerDataset, _ColumnDataset);

  function BoxAndWhiskerDataset() {
    return _ColumnDataset.apply(this, arguments) || this;
  }

  var _proto = BoxAndWhiskerDataset.prototype;

  /**
   * function to create group for dataset
   */
  _proto.createContainer = function createContainer() {
    var dataset = this,
        parent = dataset.getLinkedParent(),
        group = dataset.groupName || dataset.dsGroup || dataset.type,
        parentContainer,
        parentShadowContainer;
    !parent.getChildContainer(group + 'VcanvasGroup') && (group = 'default');
    parentContainer = parent.getChildContainer(group + 'VcanvasGroup');
    parentShadowContainer = parent.getChildContainer(group + 'ShadowVcanvasGroup'); // eslint-disable-line good-practices/no-single-usage-variable

    !dataset.getContainer('shadowGroup') && dataset.addContainer('shadowGroup', createGroup({
      name: 'shadow-group'
    }, parentShadowContainer, dataset));
    !dataset.getContainer('commonElemsGroup') && dataset.addContainer('lowerBoxGroup', createGroup({
      name: 'lower-box-group'
    }, parentContainer, dataset));
    !dataset.getContainer('commonElemsGroup') && dataset.addContainer('upperBoxGroup', createGroup({
      name: 'upper-box-group'
    }, parentContainer, dataset));
    !dataset.getContainer('commonElemsGroup') && dataset.addContainer('upperWhiskerGroup', createGroup({
      name: 'upper-whisker-group'
    }, parentContainer, dataset));
    !dataset.getContainer('commonElemsGroup') && dataset.addContainer('lowerWhiskerGroup', createGroup({
      name: 'lower-whisker-group'
    }, parentContainer, dataset));
    !dataset.getContainer('commonElemsGroup') && dataset.addContainer('medianGroup', createGroup({
      name: 'median-group'
    }, parentContainer, dataset));
    !dataset.getContainer('labelGroup') && dataset.addContainer('labelGroup', createGroup({
      name: 'label-group',
      'class': 'fusioncharts-datalabels'
    }, parent.getChildContainer('vcanvasLabelGroup'), dataset));
  }
  /**
    * Function for parsing all the attributes and value given by the user at chart,dataset and set level.
    * @param  {Object} datasetJSON JSON for dataset configurations
    * @return {boolean} Indicates whether the configuration was successful or not
    */
  ;

  _proto.configureAttributes = function configureAttributes(datasetJSON) {
    if (!datasetJSON) {
      return false;
    }

    this.trimData(datasetJSON);
    this.config.JSONData = datasetJSON;
    var dataset = this,
        // chart = dataset.chart,
    conf = dataset.config,
        JSONData = dataset.config.JSONData,
        setDataArr = JSONData.data,
        setDataLen = setDataArr && setDataArr.length,
        // eslint-disable-line good-practices/no-single-usage-variable
    // categories = chart.config.categories,
    // singleSeries = chart.config.singleseries,
    chartConfig = dataset.getFromEnv('chartConfig'),
        xAxis = dataset.getFromEnv('xAxis'),
        catLen = xAxis.getTicksLen(),
        // eslint-disable-line good-practices/no-single-usage-variable
    len = Math.min(catLen, setDataLen),
        // eslint-disable-line good-practices/no-single-usage-variable
    chartAttr = dataset.getFromEnv('chart-attrib'),
        colorM = dataset.getFromEnv('color-manager'),
        index = conf.index,
        plotColor = conf.plotColor = colorM.getPlotColor(index),
        plotBorderDash = (0, _lib.pluckNumber)(JSONData.dashed, chartAttr.plotborderdashed),
        // eslint-disable-line good-practices/no-single-usage-variable
    tooltipSepChar = (0, _lib.parseUnsafeString)((0, _lib.pluck)(chartAttr.tooltipsepchar, ': ')),
        // parseTooltext = lib.parseTooltext,
    formatedVal,
        parserConfig,
        setTooltext,
        macroIndices,
        tempPlotfillAngle,
        toolText,
        plotDashLen,
        plotDashGap,
        plotBorderThickness,
        isRoundEdges,
        showHoverEffect,
        plotfillAngle,
        plotFillAlpha,
        // plotRadius,
    plotFillRatio,
        plotgradientcolor,
        plotBorderAlpha,
        plotBorderColor,
        // plotBorderDashStyle,
    initailPlotBorderDashStyle,
        setData,
        setValue,
        dataObj,
        config,
        label,
        // colorArr,
    upperBoxHoverColor,
        upperBoxHoverAlpha,
        upperBoxBorderHoverColor,
        upperBoxBorderHoverAlpha,
        upperBoxBorderHoverThickness,
        lowerBoxHoverColor,
        lowerBoxHoverAlpha,
        lowerBoxBorderHoverColor,
        lowerBoxBorderHoverAlpha,
        lowerBoxBorderHoverThickness,
        upperQuartileHoverColor,
        upperQuartileHoverAlpha,
        upperQuartileHoverThickness,
        lowerQuartileHoverColor,
        lowerQuartileHoverAlpha,
        lowerQuartileHoverThickness,
        medianHoverColor,
        medianHoverAlpha,
        medianHoverThickness,
        // getDashStyle = lib.getDashStyle,
    dataStore = dataset.components.data,
        numberFormatter = dataset.getFromEnv('number-formatter'),
        toolTipValue,
        setDisplayValue,
        // definedGroupPadding,
    // use3DLighting,
    parentYAxis,
        setDataDashed,
        setDataPlotDashLen,
        setDataPlotDashGap,
        i,
        maxValue = -Infinity,
        minValue = +Infinity,
        bwCalc = dataset.getFromEnv('BoxAndWhiskerStatisticalCalc'),
        quartile,
        q1,
        q3,
        limits,
        min,
        max,
        medianValue,
        mean,
        md,
        sd,
        qd,
        upperBoxColor,
        upperBoxAlpha,
        lowerBoxColor,
        lowerBoxAlpha,
        upperWhiskerAlpha,
        isMeanValueEnabledInData,
        isSDValueEnabledInData,
        isMDValueEnabledInData,
        isQDValueEnabledInData,
        isOutliersValueEnabledInData,
        difference,
        lowerWhiskerAlpha,
        upperQuartileRawColor,
        upperQuartileAlpha,
        upperBoxBorderRawColor,
        upperBoxBorderAlpha,
        lowerBoxBorderRawColor,
        lowerBoxBorderAlpha,
        lowerQuartileRawColor,
        lowerQuartileAlpha,
        isMDEnabled,
        isSDEnabled,
        isQDEnabled,
        isOutliersEnabled,
        isMeanEnabled,
        defaultValue,
        maxmin;
    dataset.setState('visible', !!((0, _lib.pluckNumber)(dataset.config.JSONData.visible, !Number(dataset.config.JSONData.initiallyhidden), 1) === 1));
    (0, _lib.parseConfiguration)(JSONData, conf, chartConfig, {
      data: true
    });
    conf.defaultPadding = {
      left: 0.5,
      right: 0.5
    };
    conf.seriesname = (0, _lib.parseUnsafeString)(JSONData.seriesname);
    conf.includeInLegend = (0, _lib.pluckNumber)(JSONData.includeinlegend, conf.seriesname ? 1 : 0);
    conf.legendSymbolColor = conf.plotColor;
    plotDashLen = conf.plotborderdashlen;
    plotDashGap = conf.plotborderdashgap;
    plotFillAlpha = conf.plotfillalpha;
    isRoundEdges = conf.useroundedges;
    plotFillRatio = conf.ratio; // eslint-disable-line good-practices/no-single-usage-variable

    plotBorderThickness = conf.plotborderthickness;
    conf.rotatevalues && (conf.rotatevalues = 270);
    conf.plotfillAngle = plotfillAngle = (0, _lib.pluckNumber)(360 - chartAttr.plotfillangle, 90);
    conf.plotColor = plotColor = (0, _lib.pluck)(JSONData.color, plotColor);
    conf.plotRadius = (0, _lib.pluckNumber)(chartAttr.useroundedges, isRoundEdges ? 1 : 0);
    conf.showTextOutline = (0, _lib.pluckNumber)(chartAttr.textoutline, 0);
    conf.plotgradientcolor = plotgradientcolor = (0, _lib.getDefinedColor)(chartAttr.plotgradientcolor, // eslint-disable-line good-practices/no-single-usage-variable
    colorM.getColor(PLOTGRADIENTCOLOR));
    !chartConfig.useplotgradientcolor && (plotgradientcolor = _lib.BLANKSTRING); // eslint-disable-line good-practices/no-single-usage-variable

    conf.plotBorderAlpha = plotBorderAlpha = conf.showplotborder ? (0, _lib.pluck)(chartAttr.plotborderalpha, plotFillAlpha, _lib.HUNDREDSTRING) : 0;
    conf.plotBorderColor = plotBorderColor = (0, _lib.pluck)(chartAttr.plotbordercolor, colorM.getColor(PLOTBORDERCOLOR));
    conf.plotBorderDashStyle = initailPlotBorderDashStyle = plotBorderDash // eslint-disable-line good-practices/no-single-usage-variable
    ? (0, _lib.getDashStyle)(plotDashLen, plotDashGap, plotBorderThickness) : NONE;
    conf.showShadow = isRoundEdges ? (0, _lib.pluckNumber)(chartAttr.showshadow, 1) : (0, _lib.pluckNumber)(chartAttr.showshadow, colorM.getColor(SHOWSHADOW));
    conf.showHoverEffect = showHoverEffect = (0, _lib.pluckNumber)(chartAttr.plothovereffect, chartAttr.showhovereffect, UNDEFINED); // conf.definedGroupPadding = definedGroupPadding = Math.max(pluckNumber(chartAttr.plotspacepercent), 0);
    // conf.plotSpacePercent = Math.max(pluckNumber(chartAttr.plotspacepercent, 20) % 100, 0);

    conf.parentYAxis = parentYAxis = (0, _lib.pluck)(JSONData.parentyaxis && JSONData.parentyaxis.toLowerCase(), // eslint-disable-line good-practices/no-single-usage-variable
    pStr) === sStr ? 1 : 0;
    conf.dataSeparator = _lib.COMMASTRING;
    conf.textDirection = chartAttr.hasrtltext === '1' ? 'rtl' : _lib.BLANKSTRING;
    conf.showMeanLegend = conf.showSDLegend = conf.showMDLegend = conf.showQDLegend = conf.showOutliersLegend = 0;
    !dataset.components.data && (dataset.components.data = []);
    dataStore = dataset.components.data;
    conf.upperBoxColor = upperBoxColor = (0, _lib.pluck)(JSONData.upperboxcolor, chartAttr.upperboxcolor, colorM.getPlotColor(index * 2));
    upperBoxAlpha = conf.upperBoxAlpha = (0, _lib.pluck)(JSONData.upperboxalpha, chartAttr.upperboxalpha, plotFillAlpha, _lib.HUNDREDSTRING);
    conf.lowerBoxColor = lowerBoxColor = (0, _lib.pluck)(JSONData.lowerboxcolor, chartAttr.lowerboxcolor, colorM.getPlotColor(index * 2 + 1));
    lowerBoxAlpha = conf.lowerBoxAlpha = (0, _lib.pluck)(JSONData.lowerboxalpha, chartAttr.lowerboxalpha, plotFillAlpha, _lib.HUNDREDSTRING); // Parsing the attributes and values at set level.

    for (i = 0; i < len; i++) {
      setData = setDataArr && setDataArr[i];
      dataObj = dataStore[i];
      config = dataObj && dataObj.config;

      if (!dataObj) {
        dataObj = dataStore[i] = {
          graphics: {}
        };
      }

      if (!dataObj.config) {
        config = dataStore[i].config = {};
      }

      if (setData.min && setData.max && setData.q1 && setData.q3 && setData.median) {
        quartile = {
          q1: setData.q1,
          q3: setData.q3
        };
        q1 = quartile.q1;
        q3 = quartile.q3;
        limits = {
          min: setData.min,
          max: setData.max
        };
        config.min = min = limits.min;
        config.max = max = limits.max;
        medianValue = setData.median;
        config.mean = mean = setData.mean;
        config.md = md = setData.md;
        config.sd = sd = setData.sd;
        config.qd = qd = setData.qd;
        config.outliers = setData.outliers;
        config.explicitData = true;
      } else if (setData.value) {
        config.outliers = setData.outliers;
        config.rawValue = setData.value;
        bwCalc.setArray(setData.value);
        quartile = bwCalc.getQuartiles();
        q1 = quartile.q1;
        q3 = quartile.q3;
        limits = bwCalc.getMinMax();
        config.min = min = limits.min;
        config.max = max = limits.max;
        medianValue = bwCalc.getMedian();
        config.mean = mean = bwCalc.getMean();
        config.md = md = bwCalc.getMD();
        config.sd = sd = bwCalc.getSD();
        config.qd = qd = bwCalc.getQD();
        config.explicitData = false; // get the valid value
        // highValue = itemValue = max;
      } else {
        config.setValue = UNDEFINED;
        config.explicitData = false;
        continue;
      } // if (setData.outliers) {
      //   config.outliers = setData.outliers.split(COMMA);
      //   maxNumberOfOutliers = Math.max(maxNumberOfOutliers, config.outliers.length);
      // }
      // config.showMean = showMean = pluckNumber(setData.showmean, conf.showmean);
      // config.showSD = showSD = pluckNumber(setData.showsd, conf.showsd);
      // config.showMD = showMD = pluckNumber(setData.showmd, conf.showmd);
      // config.showQD = showQD = pluckNumber(setData.showqd, conf.showqd);
      // setData.outliers && (conf.showOutliersLegend = 1);
      // showMean && (conf.showMeanLegend = 1);
      // showSD && (conf.showSDLegend = 1);
      // showMD && (conf.showMDLegend = 1);
      // showQD && (conf.showQDLegend = 1);


      upperQuartileRawColor = (0, _lib.pluck)(setData.upperquartilecolor, JSONData.upperquartilecolor, chartAttr.upperquartilecolor, chartAttr.plotbordercolor, colorM.getColor(PLOTBORDERCOLOR));
      upperQuartileAlpha = (0, _lib.pluckNumber)(setData.upperquartilealpha, JSONData.upperquartilealpha, chartAttr.upperquartilealpha, chartAttr.plotborderalpha, 100);
      config.upperQuartile = {
        value: q3,
        color: (0, _lib.convertColor)(upperQuartileRawColor, upperQuartileAlpha),
        rawColor: upperQuartileRawColor,
        alpha: upperQuartileAlpha,
        borderWidth: (0, _lib.pluckNumber)(setData.upperquartilethickness, JSONData.upperquartilethickness, chartAttr.upperquartilethickness, chartAttr.plotborderthickness, !isRoundEdges ? 1 : 0),
        displayValue: numberFormatter.dataLabels(q3)
      };
      lowerQuartileRawColor = (0, _lib.pluck)(setData.lowerquartilecolor, JSONData.lowerquartilecolor, chartAttr.lowerquartilecolor, chartAttr.plotbordercolor, colorM.getColor(PLOTBORDERCOLOR));
      lowerQuartileAlpha = (setData.lowerquartilealpha, JSONData.lowerquartilealpha, chartAttr.lowerquartilealpha, chartAttr.plotborderalpha, 100);
      config.lowerQuartile = {
        value: q1,
        color: (0, _lib.convertColor)(lowerQuartileRawColor, lowerQuartileAlpha),
        rawColor: lowerQuartileRawColor,
        alpha: lowerQuartileAlpha,
        borderWidth: (0, _lib.pluckNumber)(setData.lowerquartilethickness, JSONData.lowerquartilethickness, chartAttr.lowerquartilethickness, chartAttr.plotborderthickness, !isRoundEdges ? 1 : 0),
        displayValue: numberFormatter.dataLabels(q1)
      };
      config.valuePadding = (0, _lib.pluckNumber)(setData.valuepadding, conf.valuepadding);
      upperBoxBorderRawColor = (0, _lib.pluck)(setData.upperboxbordercolor, JSONData.upperboxbordercolor, chartAttr.upperboxbordercolor, chartAttr.plotbordercolor, colorM.getColor(PLOTBORDERCOLOR));
      upperBoxBorderAlpha = (0, _lib.pluckNumber)(setData.upperboxborderalpha, JSONData.upperboxborderalpha, chartAttr.upperboxborderalpha, chartAttr.plotborderalpha, 100);
      config.upperBoxBorder = {
        color: (0, _lib.convertColor)(upperBoxBorderRawColor, upperBoxBorderAlpha),
        rawColor: upperBoxBorderRawColor,
        alpha: upperBoxBorderAlpha,
        borderWidth: (0, _lib.pluckNumber)(setData.upperboxborderthickness, JSONData.upperboxborderthickness, chartAttr.upperboxborderthickness, !isRoundEdges && chartAttr.plotborderthickness, !isRoundEdges ? 1 : 0)
      };
      lowerBoxBorderRawColor = (0, _lib.pluck)(setData.lowerboxbordercolor, JSONData.lowerboxbordercolor, chartAttr.lowerboxbordercolor, chartAttr.plotbordercolor, colorM.getColor(PLOTBORDERCOLOR));
      lowerBoxBorderAlpha = (0, _lib.pluckNumber)(setData.lowerboxborderalpha, JSONData.lowerboxborderalpha, chartAttr.lowerboxborderalpha, chartAttr.plotborderalpha, 100);
      config.lowerBoxBorder = {
        color: (0, _lib.convertColor)(lowerBoxBorderRawColor, lowerBoxBorderAlpha),
        rawColor: lowerBoxBorderRawColor,
        alpha: lowerBoxBorderAlpha,
        borderWidth: (0, _lib.pluckNumber)(setData.lowerboxborderthickness, JSONData.lowerboxborderthickness, chartAttr.lowerboxborderthickness, !isRoundEdges && chartAttr.plotborderthickness, !isRoundEdges ? 1 : 0)
      };
      config.median = {
        value: medianValue,
        color: (0, _lib.convertColor)((0, _lib.pluck)(setData.mediancolor, JSONData.mediancolor, chartAttr.mediancolor, chartAttr.plotbordercolor, colorM.getColor(PLOTBORDERCOLOR)), (0, _lib.pluckNumber)(setData.medianalpha, JSONData.medianalpha, chartAttr.medianalpha, chartAttr.plotborderalpha, 100)),
        borderWidth: (0, _lib.pluckNumber)(setData.medianthickness, JSONData.medianthickness, chartAttr.medianthickness, chartAttr.plotborderthickness, 1),
        displayValue: numberFormatter.dataLabels(medianValue)
      };
      conf.upperBoxColor = upperBoxColor = (0, _lib.pluck)(setData.upperboxcolor, JSONData.upperboxcolor, chartAttr.upperboxcolor, colorM.getPlotColor(index * 2));
      upperBoxAlpha = conf.upperBoxAlpha = (0, _lib.pluck)(setData.upperboxalpha, JSONData.upperboxalpha, chartAttr.upperboxalpha, plotFillAlpha, _lib.HUNDREDSTRING);
      conf.lowerBoxColor = lowerBoxColor = (0, _lib.pluck)(setData.lowerboxcolor, JSONData.lowerboxcolor, chartAttr.lowerboxcolor, colorM.getPlotColor(index * 2 + 1));
      lowerBoxAlpha = conf.lowerBoxAlpha = (0, _lib.pluck)(setData.lowerboxalpha, JSONData.lowerboxalpha, chartAttr.lowerboxalpha, plotFillAlpha, _lib.HUNDREDSTRING);
      config.upperBoxColor = upperBoxColor;
      config.upperBoxAlpha = upperBoxAlpha;
      config.upperColorArr = (0, _lib.getColumnColor)(upperBoxColor, upperBoxAlpha, UNDEFINED, UNDEFINED, isRoundEdges, plotBorderColor, plotBorderAlpha.toString(), 0, false);
      config.lowerBoxColor = lowerBoxColor;
      config.lowerBoxAlpha = lowerBoxAlpha;
      config.lowerColorArr = (0, _lib.getColumnColor)(lowerBoxColor, lowerBoxAlpha, UNDEFINED, UNDEFINED, isRoundEdges, plotBorderColor, plotBorderAlpha.toString(), 0, false); // Priority:
      // showValue at data level > showvalues at dataset level > showvalues at chart level

      isMeanEnabled = (0, _lib.pluckNumber)(setData.showmean, JSONData.showmean, chartAttr.showmean);
      isMeanValueEnabledInData = isMeanEnabled && (0, _lib.pluckNumber)(setData.showmeanvalue, JSONData.showmeanvalues, chartAttr.showmeanvalues);
      isMDEnabled = (0, _lib.pluckNumber)(setData.showmd, JSONData.showmd, chartAttr.showmd);
      isMDValueEnabledInData = isMDEnabled && (0, _lib.pluckNumber)(setData.showmdvalue, JSONData.showmdvalues, chartAttr.showmdvalues);
      isSDEnabled = (0, _lib.pluckNumber)(setData.showsd, JSONData.showsd, chartAttr.showsd);
      isSDValueEnabledInData = isSDEnabled && (0, _lib.pluckNumber)(setData.showsdvalue, JSONData.showsdvalues, chartAttr.showsdvalues);
      isQDEnabled = (0, _lib.pluckNumber)(setData.showqd, JSONData.showqd, chartAttr.showqd);
      isQDValueEnabledInData = isQDEnabled && (0, _lib.pluckNumber)(setData.showqdvalue, JSONData.showqdvalues, chartAttr.showqdvalues);
      isOutliersEnabled = (0, _lib.pluckNumber)(setData.showoutlier, JSONData.showoutlier, chartAttr.showoutlier);
      isOutliersValueEnabledInData = isOutliersEnabled && (0, _lib.pluckNumber)(setData.showoutliervalue, JSONData.showoutliervalues, chartAttr.showoutliervalues);
      defaultValue = isMeanValueEnabledInData || isMDValueEnabledInData || isSDValueEnabledInData || isQDValueEnabledInData || isOutliersValueEnabledInData ? 0 : 1;
      config.showMinValues = (0, _lib.pluckNumber)(setData.showminvalue, setData.showvalue, JSONData.showminvalues, JSONData.showvalues, chartAttr.showminvalues, chartAttr.showvalues, defaultValue);
      config.showMaxValues = (0, _lib.pluckNumber)(setData.showmaxvalue, setData.showvalue, JSONData.showmaxvalues, JSONData.showvalues, chartAttr.showmaxvalues, chartAttr.showvalues, defaultValue);
      config.showMedianValues = (0, _lib.pluckNumber)(setData.showmedianvalue, setData.showvalue, JSONData.showmedianvalues, JSONData.showvalues, chartAttr.showmedianvalues, chartAttr.showvalues, defaultValue);
      config.showQ3Values = (0, _lib.pluckNumber)(setData.showq3value, JSONData.showq3values, chartAttr.showq3values, 0);
      config.showQ1Values = (0, _lib.pluckNumber)(setData.showq1value, JSONData.showq1values, chartAttr.showq1values, 0);
      config.upperWhiskerRawColor = (0, _lib.getFirstColor)((0, _lib.pluck)(setData.upperwhiskercolor, JSONData.upperwhiskercolor, chartAttr.upperwhiskercolor, chartAttr.plotbordercolor, colorM.getColor(PLOTBORDERCOLOR)));
      config.upperWhiskerColor = (0, _lib.convertColor)(config.upperWhiskerRawColor, upperWhiskerAlpha);
      config.upperWhiskerThickness = (0, _lib.pluckNumber)(setData.upperwhiskerthickness, JSONData.upperwhiskerthickness, chartAttr.upperwhiskerthickness, chartAttr.plotborderthickness, 1);
      config.upperWhiskerShadowOpacity = conf.showShadow ? upperWhiskerAlpha / 100 : 0;
      config.lowerWhiskerAlpha = lowerWhiskerAlpha = (0, _lib.getFirstAlpha)((0, _lib.pluck)(setData.lowerwhiskeralpha, JSONData.lowerwhiskeralpha, chartAttr.lowerwhiskeralpha, chartAttr.plotborderalpha, 100));
      config.lowerWhiskerRawColor = (0, _lib.getFirstColor)((0, _lib.pluck)(setData.lowerwhiskercolor, JSONData.lowerwhiskercolor, chartAttr.lowerwhiskercolor, chartAttr.plotbordercolor, colorM.getColor(PLOTBORDERCOLOR)));
      config.lowerWhiskerColor = (0, _lib.convertColor)(config.lowerWhiskerRawColor, lowerWhiskerAlpha);
      config.lowerWhiskerThickness = (0, _lib.pluckNumber)(setData.lowerwhiskerthickness, JSONData.lowerwhiskerthickness, chartAttr.lowerwhiskerthickness, chartAttr.plotborderthickness, 1);
      config.lowerWhiskerShadowOpacity = conf.showShadow ? lowerWhiskerAlpha / 100 : 0;
      config.setValue = setValue = numberFormatter.getCleanValue(setData.value);
      config.setLink = (0, _lib.pluck)(setData.link);
      config.toolTipValue = toolTipValue = numberFormatter.dataLabels(setValue, parentYAxis);
      config.setDisplayValue = setDisplayValue = (0, _lib.parseUnsafeString)(setData.displayvalue);
      config.displayValue = (0, _lib.pluck)(setDisplayValue, toolTipValue);
      setDataDashed = (0, _lib.pluckNumber)(setData.dashed);
      setDataPlotDashLen = (0, _lib.pluckNumber)(setData.dashlen, plotDashLen);
      setDataPlotDashGap = plotDashGap = (0, _lib.pluckNumber)(setData.dashgap, plotDashGap);
      maxValue = Math.max(maxValue, max);
      minValue = Math.min(minValue, min);
      config.dataLabelStyle = dataset._configureDataLabelStyle(setData); // if (showAllOutliers && setData.outliers) {
      //   for (j = 0; j < config.outliers.length; j++) {
      //     maxValue = Math.max(maxValue, config.outliers[j]);
      //     minValue = Math.min(minValue, config.outliers[j]);
      //   }
      // }

      config.plotBorderDashStyle = setDataDashed === 1 ? (0, _lib.getDashStyle)(setDataPlotDashLen, setDataPlotDashGap, plotBorderThickness) : setDataDashed === 0 ? NONE : initailPlotBorderDashStyle; // if (singleSeries) {
      //   plotColor = colorM.getPlotColor(i);
      //   plotColor = pluck(setData.color, plotColor);
      //   plotFillRatio = pluck(setData.ratio, conf.ratio);
      // }
      // else {

      plotColor = (0, _lib.pluck)(setData.color, conf.plotColor); // }

      plotFillAlpha = (0, _lib.pluck)(setData.alpha, conf.plotfillalpha); // Setting the angle for plot fill for negative data

      if (setValue < 0 && !isRoundEdges) {
        tempPlotfillAngle = plotfillAngle;
        plotfillAngle = 360 - plotfillAngle;
      } // Setting the color Array to be applied to the bar/column.


      config.colorArr = (0, _lib.getColumnColor)(plotColor + _lib.COMMA + plotgradientcolor, plotFillAlpha, plotFillRatio, plotfillAngle, isRoundEdges, plotBorderColor, plotBorderAlpha.toString(), 0, false);
      config.label = label = (0, _lib.getValidValue)((0, _lib.parseUnsafeString)(xAxis.getLabel((0, _lib.pluckNumber)(i)).label)); // Parsing the hover effects only if showhovereffect is not 0.

      if (showHoverEffect !== 0) {
        upperBoxHoverColor = (0, _lib.pluck)(setData.upperboxhovercolor, JSONData.upperboxhovercolor, chartAttr.upperboxhovercolor, upperBoxColor);
        upperBoxHoverAlpha = (0, _lib.pluck)(setData.upperboxhoveralpha, JSONData.upperboxhoveralpha, chartAttr.upperboxhoveralpha, upperBoxAlpha);
        upperBoxBorderHoverColor = (0, _lib.pluck)(setData.upperboxborderhovercolor, JSONData.upperboxborderhovercolor, chartAttr.upperboxborderhovercolor, setData.upperboxbordercolor, JSONData.upperboxbordercolor, chartAttr.upperboxbordercolor, chartAttr.plotbordercolor, colorM.getColor(PLOTBORDERCOLOR));
        upperBoxBorderHoverAlpha = (0, _lib.pluck)(setData.upperboxborderhoveralpha, JSONData.upperboxborderhoveralpha, chartAttr.upperboxborderhoveralpha, setData.upperboxborderalpha, JSONData.upperboxborderalpha, chartAttr.upperboxborderalpha, chartAttr.plotborderalpha, 100);
        upperBoxBorderHoverThickness = !isRoundEdges ? (0, _lib.pluck)(setData.upperboxborderhoverthickness, JSONData.upperboxborderhoverthickness, chartAttr.upperboxborderhoverthickness, config.upperBoxBorder.borderWidth) : 0;
        lowerBoxHoverColor = (0, _lib.pluck)(setData.lowerboxhovercolor, JSONData.lowerboxhovercolor, chartAttr.lowerboxhovercolor, lowerBoxColor);
        lowerBoxHoverAlpha = (0, _lib.pluck)(setData.lowerboxhoveralpha, JSONData.lowerboxhoveralpha, chartAttr.lowerboxhoveralpha, lowerBoxAlpha);
        lowerBoxBorderHoverColor = (0, _lib.pluck)(setData.lowerboxborderhovercolor, JSONData.lowerboxborderhovercolor, chartAttr.lowerboxborderhovercolor, setData.lowerboxbordercolor, JSONData.lowerboxbordercolor, chartAttr.lowerboxbordercolor, chartAttr.plotbordercolor, colorM.getColor(PLOTBORDERCOLOR));
        lowerBoxBorderHoverAlpha = (0, _lib.pluck)(setData.lowerboxborderhoveralpha, JSONData.lowerboxborderhoveralpha, chartAttr.lowerboxborderhoveralpha, setData.lowerboxborderalpha, JSONData.lowerboxborderalpha, chartAttr.lowerboxborderalpha, chartAttr.plotborderalpha, 100);
        lowerBoxBorderHoverThickness = !isRoundEdges ? (0, _lib.pluck)(setData.lowerboxborderhoverthickness, JSONData.lowerboxborderhoverthickness, chartAttr.lowerboxborderhoverthickness, config.lowerBoxBorder.borderWidth) : 0;
        upperQuartileHoverColor = (0, _lib.pluck)(setData.upperquartilehovercolor, JSONData.upperquartilehovercolor, chartAttr.upperquartilehovercolor, setData.upperquartilecolor, JSONData.upperquartilecolor, chartAttr.upperquartilecolor, chartAttr.plotbordercolor, colorM.getColor(PLOTBORDERCOLOR));
        upperQuartileHoverAlpha = (0, _lib.pluck)(setData.upperquartilehoveralpha, JSONData.upperquartilehoveralpha, chartAttr.upperquartilehoveralpha, setData.upperquartilealpha, JSONData.upperquartilealpha, chartAttr.upperquartilealpha, chartAttr.plotborderalpha, 100);
        upperQuartileHoverThickness = (0, _lib.pluck)(setData.upperquartilehoverthickness, JSONData.upperquartilehoverthickness, chartAttr.upperquartilehoverthickness, config.upperQuartile.borderWidth);
        lowerQuartileHoverColor = (0, _lib.pluck)(setData.lowerquartilehovercolor, JSONData.lowerquartilehovercolor, chartAttr.lowerquartilehovercolor, setData.lowerquartilecolor, JSONData.lowerquartilecolor, chartAttr.lowerquartilecolor, chartAttr.plotbordercolor, colorM.getColor(PLOTBORDERCOLOR));
        lowerQuartileHoverAlpha = (0, _lib.pluck)(setData.lowerquartilehoveralpha, JSONData.lowerquartilehoveralpha, chartAttr.lowerquartilehoveralpha, setData.lowerquartilealpha, JSONData.lowerquartilealpha, chartAttr.lowerquartilealpha, chartAttr.plotborderalpha, 100);
        lowerQuartileHoverThickness = (0, _lib.pluck)(setData.lowerquartilehoverthickness, JSONData.lowerquartilehoverthickness, chartAttr.lowerquartilehoverthickness, config.lowerQuartile.borderWidth);
        medianHoverColor = (0, _lib.pluck)(setData.medianhovercolor, JSONData.medianhovercolor, chartAttr.medianhovercolor, setData.mediancolor, JSONData.mediancolor, chartAttr.mediancolor, chartAttr.plotbordercolor, colorM.getColor(PLOTBORDERCOLOR));
        medianHoverAlpha = (0, _lib.pluck)(setData.medianhoveralpha, JSONData.medianhoveralpha, chartAttr.medianhoveralpha, setData.medianalpha, JSONData.medianalpha, chartAttr.medianalpha, chartAttr.plotborderalpha, 100);
        medianHoverThickness = (0, _lib.pluck)(setData.medianhoverthickness, JSONData.medianhoverthickness, chartAttr.medianhoverthickness, config.median.borderWidth);
        /* If no hover effects are explicitly defined and
         * showHoverEffect is not 0 then hoverColor is set.
         */

        if (showHoverEffect === 1) {
          upperBoxColor === upperBoxHoverColor && (upperBoxHoverColor = (0, _lib.getLightColor)(upperBoxHoverColor, 70));
          lowerBoxColor === lowerBoxHoverColor && (lowerBoxHoverColor = (0, _lib.getLightColor)(lowerBoxHoverColor, 70));
        }

        config.upperBoxHoverColorArr = (0, _lib.getColumnColor)(upperBoxHoverColor, upperBoxHoverAlpha, UNDEFINED, UNDEFINED, isRoundEdges, plotBorderColor, plotBorderAlpha.toString(), 0, false);
        config.lowerBoxHoverColorArr = (0, _lib.getColumnColor)(lowerBoxHoverColor, lowerBoxHoverAlpha, UNDEFINED, UNDEFINED, isRoundEdges, plotBorderColor, plotBorderAlpha.toString(), 0, false);
        config.setUpperBoxRolloutAttr = {
          fill: (0, _lib.toRaphaelColor)(config.upperColorArr[0])
        };
        config.setUpperBoxRolloverAttr = {
          fill: (0, _lib.toRaphaelColor)(config.upperBoxHoverColorArr[0])
        };
        config.setLowerBoxRolloutAttr = {
          fill: (0, _lib.toRaphaelColor)(config.lowerColorArr[0])
        };
        config.setLowerBoxRolloverAttr = {
          fill: (0, _lib.toRaphaelColor)(config.lowerBoxHoverColorArr[0])
        };
        config.setUpperBoxBorderRolloverAttr = {
          stroke: (0, _lib.convertColor)(upperBoxBorderHoverColor, upperBoxBorderHoverAlpha),
          'stroke-width': upperBoxBorderHoverThickness
        };
        config.setUpperBoxBorderRolloutAttr = {
          stroke: config.upperBoxBorder.color,
          'stroke-width': config.upperBoxBorder.borderWidth
        };
        config.setLowerBoxBorderRolloverAttr = {
          stroke: (0, _lib.convertColor)(lowerBoxBorderHoverColor, lowerBoxBorderHoverAlpha),
          'stroke-width': lowerBoxBorderHoverThickness
        };
        config.setLowerBoxBorderRolloutAttr = {
          stroke: config.lowerBoxBorder.color,
          'stroke-width': config.lowerBoxBorder.borderWidth
        };
        config.setUpperQuartileRolloverAttr = {
          stroke: (0, _lib.convertColor)(upperQuartileHoverColor, upperQuartileHoverAlpha),
          'stroke-width': upperQuartileHoverThickness
        };
        config.setUpperQuartileRolloutAttr = {
          stroke: config.upperQuartile.color,
          'stroke-width': config.upperQuartile.borderWidth
        };
        config.setLowerQuartileRolloverAttr = {
          stroke: (0, _lib.convertColor)(lowerQuartileHoverColor, lowerQuartileHoverAlpha),
          'stroke-width': lowerQuartileHoverThickness
        };
        config.setLowerQuartileRolloutAttr = {
          stroke: config.lowerQuartile.color,
          'stroke-width': config.lowerQuartile.borderWidth
        };
        config.setMedianRolloverAttr = {
          stroke: (0, _lib.convertColor)(medianHoverColor, medianHoverAlpha),
          'stroke-width': medianHoverThickness
        };
        config.setMedianRolloutAttr = {
          stroke: config.median.color,
          'stroke-width': config.median.borderWidth
        };
      }

      formatedVal = config.toolTipValue; // Parsing tooltext against various configurations provided by the user.

      setTooltext = (0, _lib.getValidValue)((0, _lib.parseUnsafeString)((0, _lib.pluck)(setData.tooltext, JSONData.plottooltext, chartAttr.plottooltext), false));

      if (!conf.showtooltip) {
        toolText = false;
      } else {
        if (formatedVal === null) {
          toolText = false;
        } else if (setTooltext !== UNDEFINED) {
          macroIndices = [1, 2, 3, 4, 5, 6, 62, 63, 64, 65, 66, 67, 68, 69, 70, 71, 72, 73, 74, 75, 76, 77, 78, 79, 80];
          parserConfig = {
            maxValue: max,
            maxDataValue: numberFormatter.dataLabels(max),
            minValue: min,
            minDataValue: numberFormatter.dataLabels(min),
            Q1: numberFormatter.dataLabels(q1),
            unformattedQ1: q1,
            Q3: numberFormatter.dataLabels(q3),
            unformattedQ3: q3,
            median: numberFormatter.dataLabels(medianValue),
            unformattedMedian: medianValue,
            SD: numberFormatter.dataLabels(sd),
            unformattedsd: sd,
            QD: numberFormatter.dataLabels(qd),
            unformattedQD: qd,
            MD: numberFormatter.dataLabels(md),
            unformattedMD: md,
            mean: numberFormatter.dataLabels(mean),
            unformattedMean: mean,
            label: label,
            yaxisName: chartConfig.yaxisname,
            xaxisName: chartConfig.xaxisname,
            formattedValue: formatedVal,
            value: label
          };
          toolText = (0, _lib.parseTooltext)(setTooltext, macroIndices, parserConfig, setData, chartAttr, JSONData);
        } else {
          toolText = BOLDSTARTTAG + MAXIMUM_STR + tooltipSepChar + BOLDENDTAG + numberFormatter.dataLabels(max) + BREAKSTRING + BOLDSTARTTAG + Q3_STR + tooltipSepChar + BOLDENDTAG + numberFormatter.dataLabels(q3) + BREAKSTRING + BOLDSTARTTAG + MEDIAN_STR + tooltipSepChar + BOLDENDTAG + numberFormatter.dataLabels(medianValue) + BREAKSTRING + BOLDSTARTTAG + Q1_STR + tooltipSepChar + BOLDENDTAG + numberFormatter.dataLabels(q1) + BREAKSTRING + BOLDSTARTTAG + MINIMUM_STR + tooltipSepChar + BOLDENDTAG + numberFormatter.dataLabels(min);
        }
      }

      config.toolText = toolText;
      config.setTooltext = toolText;
      tempPlotfillAngle && (plotfillAngle = tempPlotfillAngle);
    } // conf.maxNumberOfOutliers = maxNumberOfOutliers;


    if (conf.showalloutliers) {
      maxmin = dataset._getOutLiersLimit();
      maxValue = Math.max(maxValue, maxmin.max);
      minValue = Math.min(minValue, maxmin.min);
    } else {
      difference = maxValue - minValue;
      maxValue += conf.outliersupperrangeratio * difference;
      minValue -= conf.outlierslowerrangeratio * difference;
    }

    conf.maxValue = maxValue;
    conf.minValue = minValue;
    dataset.setState('dirty', true);

    dataset._createSubDS();

    chartConfig.showLegend && dataset._addLegend(); // (chart.config.hasLegend !== false) && dataset._addLegend();
    // dataset.subDS = 0;
    // (dataset.components.mean = dataset._createSubDS(0, MEAN_STR));
    // conf.showMeanLegend && (dataset._addLegendSubDS(dataset.components.mean));
    // conf.showMeanLegend && (dataset.subDS += 1);
    // (dataset.components.sd = dataset._createSubDS(1, SD_STR));
    // conf.showSDLegend && (dataset._addLegendSubDS(dataset.components.sd));
    // conf.showSDLegend && (dataset.subDS += 1);
    // (dataset.components.md = dataset._createSubDS(2, MD_STR));
    // conf.showMDLegend && (dataset._addLegendSubDS(dataset.components.md));
    // conf.showMDLegend && (dataset.subDS += 1);
    // (dataset.components.qd = dataset._createSubDS(3, QD_STR));
    // conf.showQDLegend && (dataset._addLegendSubDS(dataset.components.qd));
    // conf.showQDLegend && (dataset.subDS += 1);
    // !dataset.components.outliers && (dataset.components.outliers = []);
    // OutliersLength = dataset.config.maxNumberOfOutliers || dataset.components.outliers.length;
    // for (i = 0; i < OutliersLength; i++) {
    //   outlierDS = (dataset._createSubDS(4 + i, OUTLIERS_STR, i));
    //   dataset.components.outliers[i] = outlierDS;
    // }
    // conf.showOutliersLegend && (dataset._addLegendOutliers(dataset.components.outliers));
    // conf.showOutliersLegend && (dataset.subDS += 1);
  }
  /**
   * Function to create the derived sub-dataset
   */
  ;

  _proto._createSubDS = function _createSubDS() {
    var dataset = this,
        index = dataset.config.index,
        lineJSON = dataset.getFromEnv('lineJSON')[index],
        len = lineJSON.length;
    (0, _lib.datasetFactory)(dataset, _boxandwhiskerline.default, 'dataset', len, lineJSON, createChildIndices(index, len));

    if (!len) {
      dataset.iterateComponents(function (child) {
        if (child.getName() === 'line') {
          child.remove();
        }
      });
    }
  }
  /**
   * Function to get the maximum and minimum of the outliers
   * @return {Object} The max and min value of the outliers
   */
  ;

  _proto._getOutLiersLimit = function _getOutLiersLimit() {
    var dataset = this,
        lineJSON = dataset.getFromEnv('lineJSON')[dataset.config.index],
        len = lineJSON.length,
        // eslint-disable-line good-practices/no-single-usage-variable
    dataJSON,
        dataLen,
        j,
        data,
        max = -Infinity,
        min = +Infinity,
        i;

    for (i = 0; i < len; i++) {
      dataJSON = lineJSON[i];

      if (dataJSON.seriesname === 'Outliers') {
        data = dataJSON.data;
        dataLen = data.length;

        for (j = 0; j < dataLen; j++) {
          max = Math.max(data[j].value, max);
          min = Math.min(data[j].value, min);
        }

        return {
          max: max,
          min: min
        };
      }
    }

    return {
      max: max,
      min: min
    };
  }
  /**
   * Parses plot attributes and position during post space management
   *
   * @param {any} dataObj dataObj
   * @param {any} index index
   * @memberof BoxAndWhiskerDataset
   */
  ;

  _proto.parsePlotAttributes = function parsePlotAttributes(dataObj, index) {
    var dataset = this,
        conf = dataset.config,
        i = index,
        visible = dataset.getState('visible'),
        chartConfig = dataset.getFromEnv('chartConfig'),
        xAxis = dataset.getFromEnv('xAxis'),
        // eslint-disable-line good-practices/no-single-usage-variable
    yAxis = dataset.getFromEnv('yAxis'),
        xPos,
        columnWidth,
        dataStore = dataset.components.data,
        setLink,
        setValue,
        config,
        upperQuartile,
        yTop,
        yTopPos,
        lowerQuartile,
        yBottom,
        yBottomPos,
        median,
        yMed,
        yMedPos,
        upperBoxH,
        lowerBoxH,
        upperBoxBorder,
        lowerBoxBorder,
        crispX,
        crispX2,
        crispY,
        style = chartConfig.dataLabelStyle,
        hoverOutEffects,
        rotateValues = conf.rotatevalues,
        valuePadding,
        numberFormatter = dataset.getFromEnv('number-formatter'),
        textAlign = rotateValues ? _lib.POSITION_LEFT : _lib.POSITION_MIDDLE,
        smartLabel = dataset.getFromEnv('smartLabel'),
        errorStartPos,
        errorBarWidth,
        halfErrorBarW,
        errorValPos,
        crispyX,
        crispyY,
        errorPath,
        smartText,
        lineHeight,
        labelBottomY,
        labelTopY,
        lastDataSetHeight = +Infinity,
        plotDataLabelStyle,
        lastDataSetYpos,
        lowerBoxBorderEleAttr,
        lowerBoxElemAttr,
        lowerQuartileEleAttr,
        lowerWhiskerEleAttr,
        midLineElemAttr,
        upperBoxBorderEleAttr,
        upperBoxElemAttr,
        upperQuartileEleAttr,
        upperWhiskerEleAttr,
        upperQuartileMaxLabelAttr,
        upperQuartileMinLabelAttr,
        upperQuartileLabelAttr,
        lowerQuartileLabelAttr,
        medianLabelAttr,
        upperBoxStartPos,
        lowerBoxYPos,
        lowerBoxHeight,
        lowerBoxEndPos;
    columnWidth = dataset.getFromEnv('columnWidth');
    config = dataObj && dataObj.config;
    setValue = config && config.setValue; // If plot value is found "null", continue the loop to next iteration.

    if (!config.explicitData && (dataObj === UNDEFINED || setValue === UNDEFINED || setValue === null)) {
      return;
    } // isPositive = setValue >= 0;


    setLink = config.setLink; // Creating the data structure if not present for storing the graphics elements.

    if (!dataObj.graphics) {
      dataStore[i].graphics = {};
    }

    if (!dataObj.graphics.label) {
      dataStore[i].graphics.label = [];
    } // Getting the previous yposition of the plot and calculating the current yposition of the plot.
    // previousYPos = yAxis.getPixel(previousY || yBase);


    xPos = xAxis.getPixel(i) + dataset.getFromEnv('columnXShift');
    upperQuartile = config.upperQuartile || {};
    yTop = upperQuartile && upperQuartile.value;
    yTopPos = (yTop || yTop === 0) && yAxis.getPixel(yTop);
    lowerQuartile = config.lowerQuartile || {};
    yBottom = lowerQuartile && lowerQuartile.value;
    yBottomPos = (yBottom || yBottom === 0) && yAxis.getPixel(yBottom);
    median = config.median;
    yMed = median && median.value; // || yBottom;

    yMedPos = (yMed || yMed === 0) && yAxis.getPixel(yMed);
    upperBoxH = yMedPos - yTopPos;
    lowerBoxH = yBottomPos - yMedPos;
    upperBoxBorder = config.upperBoxBorder || {};
    lowerBoxBorder = config.lowerBoxBorder || {};
    valuePadding = config.valuePadding;
    config.eventArgs = {
      index: i,
      link: setLink,
      maximum: config.max,
      minimum: config.min,
      median: yMed,
      q3: upperQuartile.value,
      q1: lowerQuartile.value,
      maxDisplayValue: config.showMaxValues ? numberFormatter.dataLabels(config.max) : _lib.BLANKSTRING,
      minDisplayValue: config.showMinValues ? numberFormatter.dataLabels(config.min) : _lib.BLANKSTRING,
      medianDisplayValue: config.showMedianValues ? numberFormatter.dataLabels(yMed) : _lib.BLANKSTRING,
      q1DisplayValue: config.showQ1Values ? numberFormatter.dataLabels(lowerQuartile.value) : _lib.BLANKSTRING,
      q3DisplayValue: config.showQ3Values ? numberFormatter.dataLabels(upperQuartile.value) : _lib.BLANKSTRING,
      categoryLabel: config.label,
      toolText: config.toolText,
      datasetIndex: conf.index,
      datasetName: dataset.config.JSONData.seriesname,
      visible: visible,
      value: config.rawValue,
      showValue: config.showValue,
      upperBoxColor: config.upperBoxColor,
      upperBoxAlpha: config.upperBoxAlpha,
      lowerBoxColor: config.lowerBoxColor,
      lowerBoxAlpha: config.lowerBoxAlpha,
      upperQuartileColor: upperQuartile.rawColor,
      upperQuartileThickness: upperQuartile.borderWidth,
      upperQuartileAlpha: upperQuartile.alpha,
      lowerQuartileColor: lowerQuartile.rawColor,
      lowerQuartileThickness: lowerQuartile.borderWidth,
      lowerQuartileAlpha: lowerQuartile.alpha,
      upperBoxBorderColor: upperBoxBorder.rawColor,
      upperBoxBorderThickness: upperBoxBorder.borderWidth,
      upperBoxBorderAlpha: upperBoxBorder.alpha,
      lowerBoxBorderColor: lowerBoxBorder.rawColor,
      lowerBoxBorderThickness: lowerBoxBorder.borderWidth,
      lowerBoxBorderAlpha: lowerBoxBorder.alpha,
      upperWhiskerColor: config.upperWhiskerRawColor,
      upperWhiskerThickness: config.upperWhiskerThickness,
      lowerWhiskerThickness: config.lowerWhiskerThickness,
      lowerWhiskerColor: config.lowerWhiskerRawColor,
      upperWhiskerAlpha: config.upperWhiskerAlpha,
      lowerWhiskerAlpha: config.lowerWhiskerAlpha,
      outliers: config.outliers
    }; // upperBox

    crispX = Math.round(xPos) + upperBoxBorder.borderWidth % 2 * 0.5;
    crispX2 = Math.round(xPos + columnWidth) + upperBoxBorder.borderWidth % 2 * 0.5;
    crispY = Math.round(yTopPos) + upperQuartile.borderWidth % 2 * 0.5;
    columnWidth = crispX2 - crispX;
    hoverOutEffects = {
      upperBox: {
        fill: (0, _lib.toRaphaelColor)(config.upperColorArr[0]),
        // upperQuartile.color
        'stroke-width': 0,
        'stroke-dasharray': NONE,
        cursor: setLink ? POINTER : _lib.BLANKSTRING,
        visibility: visible
      },
      lowerBox: {
        fill: (0, _lib.toRaphaelColor)(config.lowerColorArr[0]),
        'stroke-width': 0,
        'stroke-dasharray': NONE,
        cursor: setLink ? POINTER : BLANK,
        visibility: visible
      },
      upperBoxBorder: {
        stroke: upperBoxBorder.color,
        'stroke-width': upperBoxBorder.borderWidth,
        'stroke-linecap': ROUND,
        dashstyle: upperBoxBorder.dashStyle,
        visibility: visible
      },
      lowerBoxBorder: {
        stroke: lowerBoxBorder.color,
        'stroke-width': lowerBoxBorder.borderWidth,
        dashstyle: lowerBoxBorder.dashStyle,
        'stroke-linecap': ROUND,
        visibility: visible
      },
      upperQuartile: {
        stroke: (0, _lib.toRaphaelColor)(upperQuartile.color),
        'stroke-width': upperQuartile.borderWidth,
        'stroke-dasharray': upperQuartile.dashSyle,
        'stroke-linecap': ROUND,
        cursor: setLink ? POINTER : BLANK,
        visibility: visible
      },
      lowerQuartile: {
        stroke: (0, _lib.toRaphaelColor)(lowerQuartile.color),
        'stroke-width': lowerQuartile.borderWidth,
        'stroke-dasharray': lowerQuartile.dashSyle,
        cursor: setLink ? POINTER : _lib.BLANKSTRING,
        'stroke-linecap': ROUND,
        visibility: visible
      },
      median: {
        stroke: (0, _lib.toRaphaelColor)(median.color),
        'stroke-width': median.borderWidth,
        'stroke-dasharray': median.dashSyle,
        cursor: setLink ? POINTER : _lib.BLANKSTRING,
        'stroke-linecap': ROUND,
        visibility: visible
      }
    };
    upperBoxStartPos = lastDataSetYpos || crispY; // draw upperbox element

    upperBoxElemAttr = Object.assign({
      // eslint-disable-line good-practices/no-single-usage-variable
      x: crispX,
      y: lastDataSetYpos || crispY,
      width: Math.max(columnWidth, 0),
      height: Math.max(Math.min(lastDataSetHeight, upperBoxH), 0),
      r: 0
    }, hoverOutEffects.upperBox); // upperBoxBorder element

    upperBoxBorderEleAttr = Object.assign({
      // eslint-disable-line good-practices/no-single-usage-variable
      path: [M, crispX, lastDataSetYpos || crispY, V, lastDataSetYpos || crispY + upperBoxH, M, crispX2, lastDataSetYpos || crispY, V, lastDataSetYpos || crispY + upperBoxH]
    }, hoverOutEffects.upperBoxBorder); // upperQuartileBorder element

    upperQuartileEleAttr = Object.assign({
      // eslint-disable-line good-practices/no-single-usage-variable
      path: [M, crispX, lastDataSetYpos || crispY, H, crispX + columnWidth]
    }, hoverOutEffects.upperQuartile);
    errorStartPos = crispY;
    errorBarWidth = columnWidth * (conf.whiskerslimitswidthratio / 100);
    halfErrorBarW = errorBarWidth / 2; // Vertical Error drawing

    errorValPos = yAxis.getPixel(config.max);
    crispyY = errorValPos;
    crispyX = crispX;
    crispyY = Math.round(errorValPos) + config.upperWhiskerThickness % 2 / 2;
    crispX = Math.round(crispX + columnWidth / 2) + config.upperWhiskerThickness % 2 / 2;
    errorPath = [M, crispX, lastDataSetYpos || errorStartPos, V, Math.min(lastDataSetYpos || crispyY, upperBoxStartPos), M, crispX - halfErrorBarW, Math.min(lastDataSetYpos || crispyY, upperBoxStartPos), H, crispX + halfErrorBarW];
    upperWhiskerEleAttr = {
      // eslint-disable-line good-practices/no-single-usage-variable
      path: errorPath,
      'stroke-width': config.upperWhiskerThickness,
      'cursor': setLink ? POINTER : _lib.BLANKSTRING,
      'stroke-linecap': ROUND,
      stroke: config.upperWhiskerColor,
      visibility: visible
    };
    plotDataLabelStyle = config.dataLabelStyle;
    smartLabel.useEllipsesOnOverflow(dataset.getFromEnv('chartConfig').useEllipsesWhenOverflow);
    smartLabel.setStyle(style);
    smartText = smartLabel.getOriSize(numberFormatter.dataLabels(config.max));
    lineHeight = rotateValues ? smartText.width : smartText.height;
    labelTopY = errorValPos - config.upperWhiskerThickness * 0.5 - valuePadding - lineHeight * (rotateValues ? 0.5 : 1);

    if (labelTopY - (rotateValues ? lineHeight / 2 : 0) < chartConfig.canvasTop) {
      labelTopY = chartConfig.canvasTop + (rotateValues ? lineHeight / 2 : 0);
    }

    upperQuartileMaxLabelAttr = {
      // eslint-disable-line good-practices/no-single-usage-variable
      text: numberFormatter.dataLabels(config.max),
      x: crispyX + columnWidth / 2,
      title: upperQuartile.originalText || _lib.BLANKSTRING,
      y: lastDataSetYpos || labelTopY,
      'text-anchor': rotateValues ? _lib.POSITION_MIDDLE : textAlign,
      'vertical-align': rotateValues ? _lib.POSITION_MIDDLE : POSITION_TOP,
      'visibility': _lib.visibleStr,
      direction: conf.textDirection,
      fill: plotDataLabelStyle.color,
      transform: (0, _lib.getSuggestiveRotation)(rotateValues, crispyX + columnWidth / 2, labelTopY),
      'text-bound': [plotDataLabelStyle.backgroundColor, plotDataLabelStyle.borderColor, style.borderThickness, style.borderPadding, style.borderRadius, style.borderDash]
    };
    crispX = Math.round(xPos) + lowerBoxBorder.borderWidth % 2 * 0.5;
    crispX2 = Math.round(xPos + columnWidth) + lowerBoxBorder.borderWidth % 2 * 0.5;
    crispY = Math.round(yMedPos + lowerBoxH) + lowerQuartile.borderWidth % 2 * 0.5;
    lowerBoxYPos = lastDataSetYpos || yMedPos;
    lowerBoxHeight = Math.max(Math.min(lastDataSetHeight, crispY - yMedPos), 0);
    lowerBoxEndPos = lowerBoxYPos + lowerBoxHeight; // draw lower element

    lowerBoxElemAttr = Object.assign({
      // eslint-disable-line good-practices/no-single-usage-variable
      x: crispX,
      y: lowerBoxYPos,
      width: Math.max(columnWidth, 0),
      height: lowerBoxHeight,
      r: 0
    }, hoverOutEffects.lowerBox); // lowerBoxBorder element

    lowerBoxBorderEleAttr = Object.assign({
      // eslint-disable-line good-practices/no-single-usage-variable
      path: [M, crispX, lastDataSetYpos || yMedPos, V, lastDataSetYpos || yMedPos + lowerBoxH, M, crispX2, lastDataSetYpos || yMedPos, V, lastDataSetYpos || yMedPos + lowerBoxH]
    }, hoverOutEffects.lowerBoxBorder); // lowerQuartileBorder element

    crispY = Math.round(yMedPos + lowerBoxH) + lowerQuartile.borderWidth % 2 * 0.5;
    lowerQuartileEleAttr = Object.assign({
      // eslint-disable-line good-practices/no-single-usage-variable
      path: [M, crispX, lastDataSetYpos || crispY, H, crispX + columnWidth]
    }, hoverOutEffects.lowerQuartile);
    errorStartPos = crispY;
    errorBarWidth = columnWidth * (conf.whiskerslimitswidthratio / 100);
    halfErrorBarW = errorBarWidth / 2; // Vertical Error drawing

    errorValPos = yAxis.getPixel(config.min);
    crispyY = errorValPos;
    crispyX = crispX;
    crispyY = Math.round(errorValPos) + config.lowerWhiskerThickness % 2 / 2;
    crispyX = Math.round(crispyX + columnWidth / 2) + config.lowerWhiskerThickness % 2 / 2;
    errorPath = [M, crispyX, lastDataSetYpos || errorStartPos, V, Math.max(lastDataSetYpos || crispyY, lowerBoxEndPos), M, crispyX - halfErrorBarW, Math.max(lastDataSetYpos || crispyY, lowerBoxEndPos), H, crispyX + halfErrorBarW];
    smartLabel.setStyle(style);
    smartText = smartLabel.getOriSize(numberFormatter.dataLabels(config.min));
    lineHeight = rotateValues ? smartText.width : smartText.height;
    labelBottomY = errorValPos + config.lowerWhiskerThickness * 0.5 + valuePadding;

    if (labelBottomY + lineHeight > chartConfig.canvasBottom) {
      labelBottomY = chartConfig.canvasBottom - lineHeight;
    }

    upperQuartileMinLabelAttr = {
      // eslint-disable-line good-practices/no-single-usage-variable
      text: numberFormatter.dataLabels(config.min),
      x: crispyX,
      title: upperQuartile.originalText || _lib.BLANKSTRING,
      y: lastDataSetYpos || labelBottomY,
      'text-anchor': rotateValues ? POSITION_END : textAlign,
      'vertical-align': rotateValues ? _lib.POSITION_MIDDLE : POSITION_TOP,
      'visibility': _lib.visibleStr,
      direction: conf.textDirection,
      fill: plotDataLabelStyle.color,
      transform: (0, _lib.getSuggestiveRotation)(rotateValues, crispyX, labelBottomY),
      'text-bound': [plotDataLabelStyle.backgroundColor, plotDataLabelStyle.borderColor, style.borderThickness, style.borderPadding, style.borderRadius, style.borderDash]
    };
    lowerWhiskerEleAttr = {
      // eslint-disable-line good-practices/no-single-usage-variable
      path: errorPath,
      'stroke-width': config.lowerWhiskerThickness,
      'cursor': setLink ? POINTER : _lib.BLANKSTRING,
      'stroke-linecap': ROUND,
      stroke: config.lowerWhiskerColor,
      visibility: visible
    }; // medianBorder

    crispY = Math.round(yMedPos) + median.borderWidth % 2 * 0.5;
    midLineElemAttr = Object.assign({
      // eslint-disable-line good-practices/no-single-usage-variable
      path: [M, crispX, lastDataSetYpos || crispY, H, crispX + columnWidth]
    }, hoverOutEffects.median);
    textAlign = rotateValues ? _lib.POSITION_LEFT : _lib.POSITION_MIDDLE;
    upperQuartileLabelAttr = {
      // eslint-disable-line good-practices/no-single-usage-variable
      text: upperQuartile.displayValue,
      x: xPos + columnWidth / 2,
      title: upperQuartile.originalText || _lib.BLANKSTRING,
      y: yTopPos - valuePadding,
      'text-anchor': rotateValues ? POSITION_START : textAlign,
      'vertical-align': rotateValues ? _lib.POSITION_MIDDLE : POSITION_BOTTOM,
      'visibility': _lib.visibleStr,
      direction: conf.textDirection,
      fill: plotDataLabelStyle.color,
      transform: (0, _lib.getSuggestiveRotation)(rotateValues, xPos + columnWidth / 2, yTopPos - valuePadding),
      'text-bound': [plotDataLabelStyle.backgroundColor, plotDataLabelStyle.borderColor, style.borderThickness, style.borderPadding, style.borderRadius, style.borderDash]
    };
    medianLabelAttr = {
      // eslint-disable-line good-practices/no-single-usage-variable
      text: median.displayValue,
      x: crispX + columnWidth / 2,
      y: yMedPos - valuePadding,
      title: median.originalText || _lib.BLANKSTRING,
      'text-anchor': rotateValues ? POSITION_START : textAlign,
      'vertical-align': rotateValues ? _lib.POSITION_MIDDLE : POSITION_BOTTOM,
      'visibility': _lib.visibleStr,
      direction: conf.textDirection,
      fill: plotDataLabelStyle.color,
      transform: (0, _lib.getSuggestiveRotation)(rotateValues, crispX + columnWidth / 2, yMedPos - valuePadding),
      'text-bound': [plotDataLabelStyle.backgroundColor, plotDataLabelStyle.borderColor, style.borderThickness, style.borderPadding, style.borderRadius, style.borderDash]
    };
    lowerQuartileLabelAttr = {
      // eslint-disable-line good-practices/no-single-usage-variable
      text: lowerQuartile.displayValue,
      x: xPos + columnWidth / 2,
      y: yBottomPos + valuePadding,
      title: lowerQuartile.originalText || _lib.BLANKSTRING,
      'text-anchor': rotateValues ? POSITION_START : textAlign,
      'vertical-align': rotateValues ? _lib.POSITION_MIDDLE : POSITION_TOP,
      'visibility': _lib.visibleStr,
      direction: conf.textDirection,
      fill: plotDataLabelStyle.color,
      transform: (0, _lib.getSuggestiveRotation)(rotateValues, xPos + columnWidth / 2, yBottomPos + valuePadding),
      'text-bound': [plotDataLabelStyle.backgroundColor, plotDataLabelStyle.borderColor, style.borderThickness, style.borderPadding, style.borderRadius, style.borderDash]
    };
    config.props = {
      lowerBoxBorderEle: {
        attr: lowerBoxBorderEleAttr
      },
      lowerBoxElem: {
        attr: lowerBoxElemAttr
      },
      lowerQuartileEle: {
        attr: lowerQuartileEleAttr
      },
      lowerWhiskerEle: {
        attr: lowerWhiskerEleAttr
      },
      midLineElem: {
        attr: midLineElemAttr
      },
      upperBoxElem: {
        attr: upperBoxElemAttr
      },
      upperBoxBorderEle: {
        attr: upperBoxBorderEleAttr
      },
      upperQuartileEle: {
        attr: upperQuartileEleAttr
      },
      upperWhiskerEle: {
        attr: upperWhiskerEleAttr
      },
      upperQuartileMaxLabel: {
        attr: upperQuartileMaxLabelAttr
      },
      upperQuartileMinLabel: {
        attr: upperQuartileMinLabelAttr
      },
      medianLabel: {
        attr: medianLabelAttr
      },
      upperQuartileLabel: {
        attr: upperQuartileLabelAttr
      },
      lowerQuartileLabel: {
        attr: lowerQuartileLabelAttr
      }
    };
  }
  /**
   * Parses attributes and allocates position during
   * post space management
   *
   * @memberof BoxAndWhiskerDataset
   */
  ;

  _proto.allocatePosition = function allocatePosition() {
    var dataset = this,
        setDataArr = dataset.config.JSONData.data,
        datasetLen = setDataArr && setDataArr.length,
        // eslint-disable-line good-practices/no-single-usage-variable
    catLen = dataset.getFromEnv('xAxis').getTicksLen(),
        // eslint-disable-line good-practices/no-single-usage-variable
    dataStore = dataset.components.data,
        // eslint-disable-line good-practices/no-single-usage-variable
    dataObj,
        i,
        len;
    len = Math.min(catLen, datasetLen); // eslint-disable-line good-practices/no-single-usage-variable

    dataset.setColumnPosition();

    for (i = 0; i < len; i++) {
      dataObj = dataStore[i];
      dataset.parsePlotAttributes(dataObj, i);
    }
  }
  /**
   * functioto draw and update the graphics elements of plots
   */
  ;

  _proto.drawPlots = function drawPlots() {
    var dataset = this,
        conf = dataset.config,
        setDataArr = dataset.config.JSONData.data,
        datasetLen = setDataArr && setDataArr.length,
        // eslint-disable-line good-practices/no-single-usage-variable
    len,
        i,
        chart = dataset.getFromEnv('chart'),
        catLen = dataset.getFromEnv('xAxis').getTicksLen(),
        // eslint-disable-line good-practices/no-single-usage-variable
    toolTipController = dataset.getFromEnv('toolTipController'),
        toolText,
        dataStore = dataset.components.data,
        dataObj,
        setValue,
        config,
        showShadow = conf.showShadow,
        upperBoxContainer = dataset.getContainer('upperBoxGroup').toBack(),
        lowerBoxContainer = dataset.getContainer('lowerBoxGroup'),
        medianContainer = dataset.getContainer('medianGroup'),
        upperWhiskerContainer = dataset.getContainer('upperWhiskerGroup'),
        lowerWhiskerContainer = dataset.getContainer('lowerWhiskerGroup'),
        dataLabelContainer = dataset.getContainer('labelGroup'),
        shadowContainer = dataset.getContainer('shadowGroup'),
        upperQuartile,
        applyShadow,
        lowerQuartile,
        median,
        upperBoxElem,
        upperBoxElemCheck,
        upperBoxBorderEle,
        upperBoxBorderEleCheck,
        upperQuartileEle,
        upperQuartileEleCheck,
        lowerBoxElem,
        lowerBoxElemCheck,
        lowerBoxBorderEle,
        lowerBoxBorderEleCheck,
        lowerQuartileEle,
        lowerQuartileEleCheck,
        midLineElem,
        midLineElemCheck,
        label,
        labelCheck,
        graphic,
        groupId,
        upperWhiskerEle,
        upperWhiskerEleCheck,
        lowerWhiskerEle,
        lowerWhiskerEleCheck,
        ele,
        graphics,
        removeDataArr = dataset.components.removeDataArr || [],
        // eslint-disable-line good-practices/no-single-usage-variable
    removeDataArrLen = removeDataArr.length,
        // eslint-disable-line good-practices/no-single-usage-variable
    newupperBoxElem,
        newlowerBoxElem,
        newupperBoxBorderEle,
        newlowerBoxBorderEle,
        newupperQuartileEle,
        newlowerQuartileEle,
        newmidLineElem,
        newupperWhiskerEle,
        newlowerWhiskerEle,
        hoverInAttr,
        hoverOutAttr,
        showHoverEffect = conf.showHoverEffect,
        k,
        subarr,
        arrlen,
        animationManager = dataset.getFromEnv('animationManager'),
        // Fired when clicked over the hot elements.
    clickFunc = function clickFunc(ele) {
      // eslint-disable-line
      return function (e) {
        chart.plotEventHandler(ele, e);
      };
    },
        // Fired on mouse-in over the hot elements.
    rolloverResponseSetter = function rolloverResponseSetter(obj, ele) {
      // eslint-disable-line
      return function (data) {
        var elem;

        if (ele.data(showHoverEffectStr) !== 0) {
          for (elem in obj) {
            if (elem !== LABEL) {
              animationManager.setAnimation({
                el: obj[elem],
                doNotRemove: true,
                attr: ele.data(SETROLLOVERATTR)[elem],
                component: dataset
              });
              chart.plotEventHandler(ele, data, ROLLOVER);
            }
          }
        }
      };
    },
        // Fired on mouse-out over the hot elements.
    rolloutResponseSetter = function rolloutResponseSetter(obj, ele) {
      // eslint-disable-line
      return function (data) {
        var elem;

        if (ele.data(showHoverEffectStr) !== 0) {
          for (elem in obj) {
            if (elem !== LABEL) {
              animationManager.setAnimation({
                el: obj[elem],
                doNotRemove: true,
                attr: ele.data(SETROLLOUTATTR)[elem],
                component: dataset
              });
              chart.plotEventHandler(ele, data, ROLLOUT);
            }
          }
        }
      };
    },
        animCallBack = function animCallBack() {
      if (dataset.getState('visible') === false && (dataset._conatinerHidden === false || dataset._conatinerHidden === UNDEFINED)) {
        upperBoxContainer.hide();
        lowerBoxContainer.hide();
        upperWhiskerContainer.hide();
        lowerWhiskerContainer.hide();
        medianContainer.hide();
        shadowContainer.hide();
        dataLabelContainer && dataLabelContainer.hide();
        dataset._conatinerHidden = true;
      }
    }; // eslint-disable-next-line good-practices/no-function-dependency


    applyShadow = function applyShadow(shadowProps) {
      return function () {
        this.show();
        this.shadow(shadowProps);
      };
    };

    dataset.setColumnPosition();

    if (!dataset.getState('visible')) {
      dataLabelContainer.hide();
      upperWhiskerContainer.hide();
      upperBoxContainer.hide();
      lowerWhiskerContainer.hide();
      lowerBoxContainer.hide();
      medianContainer.hide();
      shadowContainer.hide();
    } else {
      // Showing the groups when visible set to true
      upperBoxContainer.show();
      lowerBoxContainer.show();
      upperWhiskerContainer.show();
      lowerWhiskerContainer.show();
      medianContainer.show();
      shadowContainer.show();
      dataLabelContainer.show();
      dataset._conatinerHidden = false;
    }

    len = Math.min(catLen, datasetLen); // eslint-disable-line good-practices/no-single-usage-variable
    // Create plot elements.

    for (i = 0; i < len; i++) {
      // setData = setDataArr && setDataArr[i];
      dataObj = dataStore[i];
      config = dataObj && dataObj.config;
      setValue = config && config.setValue;
      newupperBoxElem = false;
      newlowerBoxElem = false;
      newupperBoxBorderEle = false;
      newlowerBoxBorderEle = false;
      newupperQuartileEle = false;
      newlowerQuartileEle = false;
      newmidLineElem = false;
      newupperWhiskerEle = false;
      newlowerWhiskerEle = false; // If plot value is found "null", continue the loop to next iteration.

      if (!config.explicitData && (dataObj === UNDEFINED || setValue === UNDEFINED || setValue === null)) {
        graphics = dataObj.graphics;

        for (ele in graphics) {
          if (graphics[ele] instanceof Array) {
            subarr = graphics[ele];

            for (k = 0, arrlen = subarr.length; k < arrlen; k++) {
              subarr[k] && subarr[k].hide();
            }
          } else {
            graphics[ele].hide();
          }
        }

        continue;
      }

      graphic = dataObj.graphics; // Creating the data structure if not present for storing the graphics elements.

      if (!dataObj.graphics) {
        dataStore[i].graphics = {};
      }

      if (!graphic.label) {
        dataStore[i].graphics.label = [];
      }

      upperQuartile = config.upperQuartile || {};
      lowerQuartile = config.lowerQuartile || {};
      median = config.median;
      toolText = config.toolText;
      groupId = conf.index + UNDERSCORE + i;
      upperBoxElemCheck = dataObj.graphics.upperBoxElem;
      upperBoxElem = animationManager.setAnimation({
        el: upperBoxElemCheck || 'rect',
        attr: config.props.upperBoxElem.attr,
        label: 'upperBox',
        container: upperBoxContainer,
        component: dataset
      });

      if (!upperBoxElemCheck) {
        dataObj.graphics.upperBoxElem = upperBoxElem;
        newupperBoxElem = true;
      }

      upperBoxElem.shadow({
        opacity: showShadow ? conf.upperBoxAlpha / 100 : 0
      }, shadowContainer);
      upperBoxBorderEleCheck = dataObj.graphics.upperBoxBorderEle;
      upperBoxBorderEle = animationManager.setAnimation({
        el: upperBoxBorderEleCheck || 'path',
        attr: config.props.upperBoxBorderEle.attr,
        container: upperBoxContainer,
        label: 'path',
        component: dataset
      });

      if (!upperBoxBorderEleCheck) {
        dataObj.graphics.upperBoxBorderEle = upperBoxBorderEle;
        newupperBoxBorderEle = true;
      }

      upperQuartileEleCheck = dataObj.graphics.upperQuartileEle;
      upperQuartileEle = animationManager.setAnimation({
        el: upperQuartileEleCheck || 'path',
        attr: config.props.upperQuartileEle.attr,
        label: 'path',
        container: upperBoxContainer,
        component: dataset
      });

      if (!upperQuartileEleCheck) {
        dataObj.graphics.upperQuartileEle = upperQuartileEle;
        newupperQuartileEle = true;
      }

      upperWhiskerEleCheck = dataObj.graphics.upperWhiskerEle;
      upperWhiskerEle = animationManager.setAnimation({
        el: upperWhiskerEleCheck || 'path',
        attr: config.props.upperWhiskerEle.attr,
        label: 'path',
        container: upperWhiskerContainer,
        component: dataset
      });
      applyShadow({
        opacity: config.upperWhiskerShadowOpacity
      }, shadowContainer);

      if (!upperWhiskerEleCheck) {
        dataObj.graphics.upperWhiskerEle = upperWhiskerEle;
        newupperWhiskerEle = true;
      }

      dataset.getFromEnv('smartLabel').useEllipsesOnOverflow(chart.config.useEllipsesWhenOverflow);

      if (config.showMaxValues) {
        labelCheck = graphic.label[3];
        labelCheck && labelCheck.show();
        label = animationManager.setAnimation({
          el: labelCheck || 'text',
          attr: config.props.upperQuartileMaxLabel.attr,
          component: dataset,
          label: 'text',
          container: dataLabelContainer
        });

        if (!labelCheck) {
          graphic.label[3] = label;
        }

        graphic.label[3].data(GROUPID, groupId);
      } else {
        graphic.label[3] && animationManager.setAnimation({
          el: graphic.label[3],
          component: dataset,
          attr: {
            'text-bound': []
          },
          callback: _hide.call(graphic.label[3])
        });
      }

      lowerBoxElemCheck = dataObj.graphics.lowerBoxElem;
      lowerBoxElem = animationManager.setAnimation({
        el: lowerBoxElemCheck || 'rect',
        attr: config.props.lowerBoxElem.attr,
        label: 'lowerBox',
        container: lowerBoxContainer,
        component: dataset
      });

      if (!lowerBoxElemCheck) {
        dataObj.graphics.lowerBoxElem = lowerBoxElem;
        newlowerBoxElem = true;
      }

      lowerBoxElem.shadow({
        opacity: showShadow ? conf.lowerBoxAlpha / 100 : 0
      }, shadowContainer);
      lowerBoxBorderEleCheck = dataObj.graphics.lowerBoxBorderEle;
      lowerBoxBorderEle = animationManager.setAnimation({
        el: lowerBoxBorderEleCheck || 'path',
        attr: config.props.lowerBoxBorderEle.attr,
        component: dataset,
        label: 'path',
        container: lowerBoxContainer
      });

      if (!lowerBoxBorderEleCheck) {
        dataObj.graphics.lowerBoxBorderEle = lowerBoxBorderEle;
        newlowerBoxBorderEle = true;
      }

      lowerQuartileEleCheck = dataObj.graphics.lowerQuartileEle;
      lowerQuartileEle = animationManager.setAnimation({
        el: lowerQuartileEleCheck || 'path',
        attr: config.props.lowerQuartileEle.attr,
        component: dataset,
        label: 'path',
        container: lowerBoxContainer
      });

      if (!lowerQuartileEleCheck) {
        dataObj.graphics.lowerQuartileEle = lowerQuartileEle;
        newlowerQuartileEle = true;
      }

      lowerWhiskerEle = dataObj.graphics.lowerWhiskerEle;

      if (config.showMinValues) {
        labelCheck = graphic.label[4];
        labelCheck && labelCheck.show();
        label = animationManager.setAnimation({
          el: labelCheck || 'text',
          attr: config.props.upperQuartileMinLabel.attr,
          label: 'text',
          container: dataLabelContainer,
          component: dataset
        });

        if (!labelCheck) {
          graphic.label[4] = label;
        }

        graphic.label[4].data(GROUPID, groupId);
      } else {
        graphic.label[4] && animationManager.setAnimation({
          el: graphic.label[4],
          component: dataset,
          attr: {
            'text-bound': []
          },
          callback: _hide.call(graphic.label[4])
        });
      }

      lowerWhiskerEleCheck = dataObj.graphics.lowerWhiskerEle;
      lowerWhiskerEle = animationManager.setAnimation({
        el: lowerWhiskerEleCheck || 'path',
        attr: config.props.lowerWhiskerEle.attr,
        label: 'path',
        container: lowerWhiskerContainer,
        component: dataset
      });
      applyShadow({
        opacity: config.lowerWhiskerShadowOpacity
      }, shadowContainer);

      if (!lowerWhiskerEleCheck) {
        dataObj.graphics.lowerWhiskerEle = lowerWhiskerEle;
        newlowerWhiskerEle = true;
      }

      midLineElemCheck = dataObj.graphics.midLineElem;
      midLineElem = animationManager.setAnimation({
        el: midLineElemCheck || 'path',
        component: dataset,
        label: 'midline',
        container: medianContainer,
        attr: config.props.midLineElem.attr
      });

      if (!midLineElemCheck) {
        dataObj.graphics.midLineElem = midLineElem;
        newmidLineElem = true;
      }

      hoverInAttr = {
        upperBoxElem: config.setUpperBoxRolloverAttr,
        lowerBoxElem: config.setLowerBoxRolloverAttr,
        upperBoxBorderEle: config.setUpperBoxBorderRolloverAttr,
        lowerBoxBorderEle: config.setLowerBoxBorderRolloverAttr,
        upperQuartileEle: config.setUpperQuartileRolloverAttr,
        lowerQuartileEle: config.setLowerQuartileRolloverAttr,
        midLineElem: config.setMedianRolloverAttr
      };
      hoverOutAttr = {
        upperBoxElem: config.setUpperBoxRolloutAttr,
        lowerBoxElem: config.setLowerBoxRolloutAttr,
        upperBoxBorderEle: config.setUpperBoxBorderRolloutAttr,
        lowerBoxBorderEle: config.setLowerBoxBorderRolloutAttr,
        upperQuartileEle: config.setUpperQuartileRolloutAttr,
        lowerQuartileEle: config.setLowerQuartileRolloutAttr,
        midLineElem: config.setMedianRolloutAttr
      };
      upperBoxElem.data(GROUPID, groupId).data(EVENTARGS, config.eventArgs).data(showHoverEffectStr, showHoverEffect).data(SETROLLOVERATTR, hoverInAttr).data(SETROLLOUTATTR, hoverOutAttr);

      if (newupperBoxElem) {
        upperBoxElem.on('fc-click', clickFunc(upperBoxElem));
        upperBoxElem.on('fc-mouseover', rolloverResponseSetter(dataObj.graphics, upperBoxElem));
        upperBoxElem.on('fc-mouseout', rolloutResponseSetter(dataObj.graphics, upperBoxElem));
      }

      lowerBoxElem.data(GROUPID, groupId).data(EVENTARGS, config.eventArgs).data(showHoverEffectStr, showHoverEffect).data(SETROLLOVERATTR, hoverInAttr).data(SETROLLOUTATTR, hoverOutAttr);

      if (newlowerBoxElem) {
        lowerBoxElem.on('fc-click', clickFunc(lowerBoxElem));
        lowerBoxElem.on('fc-mouseover', rolloverResponseSetter(dataObj.graphics, lowerBoxElem));
        lowerBoxElem.on('fc-mouseout', rolloutResponseSetter(dataObj.graphics, lowerBoxElem));
      }

      upperBoxBorderEle.data(GROUPID, groupId).data(EVENTARGS, config.eventArgs).data(showHoverEffectStr, showHoverEffect).data(SETROLLOVERATTR, hoverInAttr).data(SETROLLOUTATTR, hoverOutAttr);

      if (newupperBoxBorderEle) {
        upperBoxBorderEle.on('fc-click', clickFunc(upperBoxBorderEle));
        upperBoxBorderEle.on('fc-mouseover', rolloverResponseSetter(dataObj.graphics, upperBoxBorderEle));
        upperBoxBorderEle.on('fc-mouseout', rolloutResponseSetter(dataObj.graphics, upperBoxBorderEle));
      }

      lowerBoxBorderEle.data(GROUPID, groupId).data(EVENTARGS, config.eventArgs).data(showHoverEffectStr, showHoverEffect).data(SETROLLOVERATTR, hoverInAttr).data(SETROLLOUTATTR, hoverOutAttr);

      if (newlowerBoxBorderEle) {
        lowerBoxBorderEle.on('fc-click', clickFunc(lowerBoxBorderEle));
        lowerBoxBorderEle.on('fc-mouseover', rolloverResponseSetter(dataObj.graphics, lowerBoxBorderEle));
        lowerBoxBorderEle.on('fc-mouseout', rolloutResponseSetter(dataObj.graphics, lowerBoxBorderEle));
      }

      upperQuartileEle.data(GROUPID, groupId).data(EVENTARGS, config.eventArgs).data(showHoverEffectStr, showHoverEffect).data(SETROLLOVERATTR, hoverInAttr).data(SETROLLOUTATTR, hoverOutAttr);

      if (newupperQuartileEle) {
        upperQuartileEle.on('fc-click', clickFunc(upperQuartileEle));
        upperQuartileEle.on('fc-mouseover', rolloverResponseSetter(dataObj.graphics, upperQuartileEle));
        upperQuartileEle.on('fc-mouseout', rolloutResponseSetter(dataObj.graphics, upperQuartileEle));
      }

      lowerQuartileEle.data(GROUPID, groupId).data(EVENTARGS, config.eventArgs).data(showHoverEffectStr, showHoverEffect).data(SETROLLOVERATTR, hoverInAttr).data(SETROLLOUTATTR, hoverOutAttr);

      if (newlowerQuartileEle) {
        lowerQuartileEle.on('fc-click', clickFunc(lowerQuartileEle));
        lowerQuartileEle.on('fc-mouseover', rolloverResponseSetter(dataObj.graphics, lowerQuartileEle));
        lowerQuartileEle.on('fc-mouseout', rolloutResponseSetter(dataObj.graphics, lowerQuartileEle));
      }

      midLineElem.data(GROUPID, groupId).data(EVENTARGS, config.eventArgs).data(showHoverEffectStr, showHoverEffect).data(SETROLLOVERATTR, hoverInAttr).data(SETROLLOUTATTR, hoverOutAttr);

      if (newmidLineElem) {
        midLineElem.on('fc-click', clickFunc(midLineElem));
        midLineElem.on('fc-mouseover', rolloverResponseSetter(dataObj.graphics, midLineElem));
        midLineElem.on('fc-mouseout', rolloutResponseSetter(dataObj.graphics, midLineElem));
      }

      upperWhiskerEle.data(GROUPID, groupId).data(EVENTARGS, config.eventArgs).data(showHoverEffectStr, showHoverEffect).data(SETROLLOVERATTR, hoverInAttr).data(SETROLLOUTATTR, hoverOutAttr);

      if (newupperWhiskerEle) {
        upperWhiskerEle.on('fc-click', clickFunc(upperWhiskerEle));
        upperWhiskerEle.on('fc-mouseover', rolloverResponseSetter(dataObj.graphics, upperWhiskerEle));
        upperWhiskerEle.on('fc-mouseout', rolloutResponseSetter(dataObj.graphics, upperWhiskerEle));
      }

      lowerWhiskerEle.data(GROUPID, groupId).data(EVENTARGS, config.eventArgs).data(showHoverEffectStr, showHoverEffect).data(SETROLLOVERATTR, hoverInAttr).data(SETROLLOUTATTR, hoverOutAttr);

      if (newlowerWhiskerEle) {
        lowerWhiskerEle.on('fc-click', clickFunc(lowerWhiskerEle));
        lowerWhiskerEle.on('fc-mouseover', rolloverResponseSetter(dataObj.graphics, lowerWhiskerEle));
        lowerWhiskerEle.on('fc-mouseout', rolloutResponseSetter(dataObj.graphics, lowerWhiskerEle));
      }

      if ((0, _lib.defined)(upperQuartile.displayValue) && upperQuartile.displayValue !== BLANK && config.showQ3Values) {
        labelCheck = graphic.label[0];
        labelCheck && labelCheck.show();
        label = animationManager.setAnimation({
          el: labelCheck || 'text',
          attr: config.props.upperQuartileLabel.attr,
          component: dataset,
          label: 'text',
          container: dataLabelContainer
        });

        if (!labelCheck) {
          graphic.label[0] = label;
        }

        graphic.label[0].data(GROUPID, groupId);
      } else {
        graphic.label[0] && animationManager.setAnimation({
          el: graphic.label[0],
          component: dataset,
          attr: {
            'text-bound': []
          },
          callback: _hide.call(graphic.label[0])
        });
      }

      if ((0, _lib.defined)(median.displayValue) && median.displayValue !== BLANK && config.showMedianValues) {
        labelCheck = graphic.label[1];
        labelCheck && labelCheck.show();
        label = animationManager.setAnimation({
          el: labelCheck || 'text',
          attr: config.props.medianLabel.attr,
          component: dataset,
          label: 'text',
          container: dataLabelContainer
        });
        label.outlineText(conf.showTextOutline, config.props.medianLabel.attr.fill);

        if (!labelCheck) {
          graphic.label[1] = label;
        }

        graphic.label[1].data(GROUPID, groupId);
      } else {
        graphic.label[1] && animationManager.setAnimation({
          el: graphic.label[1],
          component: dataset,
          attr: {
            'text-bound': []
          },
          callback: _hide.call(graphic.label[1])
        });
      }

      if ((0, _lib.defined)(lowerQuartile.displayValue) && lowerQuartile.displayValue !== BLANK && config.showQ1Values) {
        labelCheck = graphic.label[2];
        label = animationManager.setAnimation({
          el: labelCheck || 'text',
          component: dataset,
          attr: config.props.lowerQuartileLabel.attr,
          container: dataLabelContainer
        });

        if (!labelCheck) {
          graphic.label[2] = label;
          label.show();
        }

        graphic.label[2].data(GROUPID, groupId);
      } else {
        graphic.label[2] && animationManager.setAnimation({
          el: graphic.label[2],
          component: dataset,
          attr: {
            'text-bound': []
          },
          callback: _hide.call(graphic.label[2])
        });
      }

      if (conf.showtooltip) {
        toolTipController.enableToolTip(upperBoxElem, toolText);
        toolTipController.enableToolTip(lowerBoxElem, toolText);
        toolTipController.enableToolTip(upperBoxBorderEle, toolText);
        toolTipController.enableToolTip(lowerBoxBorderEle, toolText);
        toolTipController.enableToolTip(upperQuartileEle, toolText);
        toolTipController.enableToolTip(lowerQuartileEle, toolText);
        toolTipController.enableToolTip(midLineElem, toolText);
        toolTipController.enableToolTip(upperWhiskerEle, toolText);
        toolTipController.enableToolTip(lowerWhiskerEle, toolText);
      } else {
        toolTipController.enableToolTip(upperBoxElem, false);
        toolTipController.enableToolTip(lowerBoxElem, false);
        toolTipController.enableToolTip(upperBoxBorderEle, false);
        toolTipController.enableToolTip(lowerBoxBorderEle, false);
        toolTipController.enableToolTip(upperQuartileEle, false);
        toolTipController.enableToolTip(lowerQuartileEle, false);
        toolTipController.enableToolTip(midLineElem, false);
        toolTipController.enableToolTip(upperWhiskerEle, false);
        toolTipController.enableToolTip(lowerWhiskerEle, false);
      }
    } // There has to be a provision such that the callback is called after the end of the slot animation


    animCallBack();
    removeDataArrLen && dataset.removePlots();
  }
  /**
   * Function to remove a data from a dataset
   */
  ;

  _proto.removePlots = function removePlots() {
    var dataSet = this,
        removeDataArr = dataSet.components.removeDataArr,
        animationManager = dataSet.getFromEnv('animationManager'),
        // eslint-disable-line good-practices/no-single-usage-variable
    len = removeDataArr.length,
        // eslint-disable-line good-practices/no-single-usage-variable
    removeData,
        ele,
        graphics,
        i,
        innerLen,
        j;

    for (i = 0; i < len; i++) {
      removeData = removeDataArr[0];
      removeDataArr.splice(0, 1); // In case of non existing data plot continue;

      if (!removeData || !removeData.graphics) {
        continue;
      }

      graphics = removeData.graphics;

      for (ele in graphics) {
        if (ele !== LABEL) {
          graphics[ele].shadow({
            opacity: 0
          });
          graphics[ele].hide();
        } else {
          innerLen = graphics[ele].length;

          for (j = 0; j < innerLen; j++) {
            if (graphics[ele][j]) {
              graphics[ele][j].shadow({
                opacity: 0
              });
              animationManager.setAnimation({
                el: graphics[ele][j],
                component: dataSet,
                attr: {
                  'text-bound': []
                },
                callback: _hide.call(graphics[ele][j])
              });
            }
          }
        }
      }
    }
  }
  /**
   * Function to remove a data with a given index.
   * @param {number}  indexVal     from which index data would be removed
   * @param {number}  stretchVal   delete count
   * @param {boolean} draw      whether draw or not
   */
  ;

  _proto.removeData = function removeData(indexVal, stretchVal, draw) {
    var dataSet = this,
        index = indexVal,
        stretch = stretchVal,
        components = dataSet.components,
        dataStore = components.data,
        removeDataArr = components.removeDataArr || (components.removeDataArr = []); // eslint-disable-line good-practices/no-single-usage-variable

    stretch = stretch || 1;
    index = index || 0; // Storing the direction of input data for the type of animation to be done during remove.

    if (index + stretch === dataStore.length) {
      dataSet.endPosition = true;
    } else if (index === 0 || index === UNDEFINED) {
      dataSet.endPosition = false;
    }

    components.removeDataArr = removeDataArr = removeDataArr.concat(dataStore.splice(index, stretch)); // eslint-disable-line good-practices/no-single-usage-variable

    draw && dataSet.asyncDraw();
  }
  /**
   * parse defualt configuration of the dataset
   */
  ;

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    _ColumnDataset.prototype.__setDefaultConfig.call(this);

    var config = this.config;
    config.showplotborder = UNDEFINED;
    config.plotborderdashlen = UNDEFINED;
    config.plotborderdashgap = UNDEFINED;
    config.plotfillalpha = UNDEFINED;
    config.useroundedges = UNDEFINED;
    config.ratio = UNDEFINED;
    config.plotborderthickness = UNDEFINED;
    config.showvalues = UNDEFINED;
    config.valuepadding = UNDEFINED;
    config.showtooltip = UNDEFINED;
    config.maxcolwidth = UNDEFINED;
    config.rotatevalues = UNDEFINED;
    config.use3dlighting = UNDEFINED;
    config.whiskerslimitswidthratio = UNDEFINED;
    config.outliersupperrangeratio = UNDEFINED;
    config.outlierslowerrangeratio = UNDEFINED;
    config.showalloutliers = UNDEFINED;
    config.showmean = UNDEFINED;
    config.showsd = UNDEFINED;
    config.showmd = UNDEFINED;
    config.showqd = UNDEFINED;
    config.showminvalues = UNDEFINED;
    config.showmaxvalues = UNDEFINED;
    config.showq1values = UNDEFINED;
    config.showq3values = UNDEFINED;
    config.showmedianvalues = UNDEFINED;
  }
  /**
   * Function to get the maximum and minimum from dataset
   * @return {Object}     contains max, min value
   */
  ;

  _proto.getDataLimits = function getDataLimits() {
    var dataset = this,
        conf = dataset.config,
        removed = dataset.getState('removed');
    return {
      max: removed ? -Infinity : conf.maxValue,
      min: removed ? +Infinity : conf.minValue
    };
  }
  /**
   * Function to register datasets in the internal data store of legend class.
   */
  ;

  _proto._addLegend = function _addLegend() {
    var dataset = this,
        // chart = dataset.chart,
    fillColor,
        config,
        conf = dataset.config,
        legendItem,
        legend = dataset.getFromEnv('legend'),
        chartAttr = dataset.getFromEnv('chart-attrib'),
        JSONData = conf.JSONData || {},
        upperBoxColor = conf.upperBoxColor,
        lowerBoxColor = conf.lowerBoxColor; // eslint-disable-line good-practices/no-single-usage-variable

    fillColor = {
      // eslint-disable-line good-practices/no-single-usage-variable
      FCcolor: {
        color: upperBoxColor + _lib.COMMA + lowerBoxColor,
        angle: 90,
        ratio: '50, 0',
        alpha: '100, 100'
      }
    };
    config = {
      // eslint-disable-line good-practices/no-single-usage-variable
      label: (0, _lib.getFirstValue)(dataset.config.JSONData.seriesname),
      index: dataset.getJSONIndex(),
      mainDS: true
    };

    if (conf.includeInLegend) {
      legendItem = legend.getItem(dataset.config.legendItemId);

      if (!legendItem) {
        dataset.config.legendItemId = legend.createItem(dataset);
        legendItem = legend.getItem(dataset.config.legendItemId);
        dataset.addExtEventListener('fc-click', function () {
          legendItem.itemClickFn();
        }, legendItem);
      }

      legendItem.configure(config);
      legendItem.setStateCosmetics('default', {
        symbol: {
          fill: (0, _lib.toRaphaelColor)(fillColor),
          bgAlpha: (0, _lib.pluckNumber)(JSONData.legendiconbgalpha, JSONData.legendiconalpha, chartAttr.legendiconbgalpha, chartAttr.legendiconalpha, conf.plotfillalpha),
          borderAlpha: (0, _lib.pluckNumber)(JSONData.legendiconborderalpha, JSONData.legendiconalpha, chartAttr.legendiconborderalpha, chartAttr.legendiconalpha, conf.plotfillalpha),
          rawFillColor: conf.upperBoxColor,
          stroke: (0, _lib.toRaphaelColor)(strokeColor)
        },
        background: {
          legendBackgroundColor: (0, _lib.toRaphaelColor)(upperBoxColor),
          alpha: 20
        }
      }); // check if dataset is initiallyhidden

      if (!dataset.getState('visible')) {
        legendItem.setLegendState('hidden');
      } else {
        // remove hidden state of legend item if dataset is not hidden
        legendItem.removeLegendState('hidden');
      }
    } else if (dataset.config.legendItemId) {
      legend.disposeItem(dataset.config.legendItemId);
    }

    dataset._mapChildren(function (child) {
      if (!child.getState('removed')) {
        child.addToEnv('legendBackgroundColor', upperBoxColor);
        child && child._addLegend(true);
      }
    });
  }
  /**
   * Fuction to be fired on legend click
   * @param  {Object} legendItem which legend is clicked
   */
  ;

  _proto.legendInteractivity = function legendInteractivity() {
    var dataset = this,
        childDS = dataset.getChildren('dataset'),
        state,
        i;
    state = dataset.getState('visible') ? 'hide' : 'show';

    for (i = 0; i < (childDS && childDS.length); i++) {
      childDS[i][state]();
    }

    dataset[state]();
  }
  /**
   * Over-writting drawLabel of column chart
   * @return {Object} the dataset object
   */
  ;

  _proto.drawLabel = function drawLabel() {
    return this;
  }
  /**
   * Gets the name of the component
   * @return {string} name
   */
  ;

  _proto.getName = function getName() {
    return 'boxandwhisker2D';
  }
  /**
   * Over-writting childChanged of column chart
   * @return {Object} the dataset object
   */
  ;

  _proto.childChanged = function childChanged() {
    return this;
  }
  /**
   * Function to show the dataset and raise an event
   */
  ;

  _proto.show = function show() {
    _ColumnDataset.prototype.show.call(this);
  }
  /**
   * Function to hide the dataset and raise an event
   */
  ;

  _proto.hide = function hide() {
    _ColumnDataset.prototype.hide.call(this);
  };

  return BoxAndWhiskerDataset;
}(_column.default);

var _default = BoxAndWhiskerDataset;
exports["default"] = _default;

/***/ }),

/***/ 1410:
/***/ ((__unused_webpack_module, exports) => {



exports.__esModule = true;
exports["default"] = void 0;
var _default = {
  'initial.dataset.candlestick': function initialDatasetCandlestick() {
    return {
      'rect.appearing': function rectAppearing(inputJSON) {
        return [{
          initialAttr: {
            y: inputJSON.attr.y + inputJSON.attr.height,
            height: 0
          },
          slot: 'plot'
        }];
      },
      'group.appearing': function groupAppearing(inputJSON) {
        if (inputJSON.attr.name === 'label-group') {
          return [{
            initialAttr: {
              opacity: 0
            },
            finalAttr: {
              opacity: 1
            },
            slot: 'final'
          }];
        }

        return [{
          initialAttr: {
            opacity: 1
          },
          finalAttr: {
            opacity: 1
          },
          slot: 'final'
        }];
      },
      '*': null
    };
  },
  'initial.dataset.volume': function initialDatasetVolume() {
    return {
      'rect.appearing': function rectAppearing(inputJSON) {
        return [{
          initialAttr: {
            y: inputJSON.attr.y + inputJSON.attr.height,
            height: 0
          },
          slot: 'plot'
        }];
      },
      '*': null
    };
  }
};
exports["default"] = _default;

/***/ }),

/***/ 1409:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports._parseToolText = exports._firePlotEvent = exports.getPlotIndices = exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _lib = __webpack_require__(274);

var _errorbar2d = _interopRequireDefault(__webpack_require__(1323));

var _dependencyManager = __webpack_require__(282);

var _candlestick = _interopRequireDefault(__webpack_require__(1410));

var _column = __webpack_require__(595);

/* eslint require-jsdoc: 'error', valid-jsdoc: ["error", { "requireReturn": false }] */
var colorStrings = _lib.preDefStr.colors,
    COLOR_B90000 = colorStrings.B90000,
    COLOR_FFFFFF = colorStrings.FFFFFF,
    BLANKSTRING = '',
    UNDEF,
    DASH_DEF = 'none',
    POINTER = 'pointer',
    DEFAULT_CURSOR = 'default',
    SHOWSHADOW = 'showShadow',
    ROLLOVER = 'DataPlotRollOver',
    ROLLOUT = 'DataPlotRollOut',
    LINE = 'line',
    BOLDSTARTTAG = '<b>',
    BOLDENDTAG = '</b>',
    BLANKSPACE = ' ',
    BREAKSTRING = '<br />',

/**
 * This method handles all mouse events of an dataset.
 * @param {string} eventType    name of the event
 * @param {number} plotIndex    index of the plot where this event has been occured
 * @param {Event}  e            reference of the original mouse event
 */
_firePlotEvent2 = function _firePlotEvent(eventType, plotIndex, e) {
  var dataset = this,
      chart = dataset.getFromEnv('chart'),
      dataStore = dataset.components.data,
      // eslint-disable-line good-practices/no-single-usage-variable
  data = dataStore[plotIndex],
      toolText,
      currentToolTip = dataset.config.currentToolTip,
      setElement = data.graphics.element,
      originalEvent = e.originalEvent,
      style = chart.getFromEnv('paper').canvas.style,
      toolTipController = dataset.getFromEnv('toolTipController'),
      config,
      setLink;

  if (setElement) {
    config = data.config;
    toolText = config.toolText;
    setLink = config.setLink;

    switch (eventType) {
      case 'fc-mouseover':
        if (toolText) {
          if (currentToolTip) {
            toolTipController.draw(originalEvent, toolText, currentToolTip);
          } else {
            currentToolTip = dataset.config.currentToolTip = toolTipController.draw(originalEvent, toolText);
          }
        }

        chart.plotEventHandler(setElement, e, ROLLOVER);
        setLink && (style.cursor = POINTER);
        break;

      case 'fc-mouseout':
        toolTipController.hide(currentToolTip);
        chart.plotEventHandler(setElement, e, ROLLOUT);
        setLink && (style.cursor = DEFAULT_CURSOR);
        break;

      case 'fc-click':
        chart.plotEventHandler(setElement, e);
        break;

      case 'fc-mousemove':
        if (toolText) {
          if (currentToolTip) {
            toolTipController.draw(originalEvent, toolText, currentToolTip);
          } else {
            currentToolTip = dataset.config.currentToolTip = toolTipController.draw(originalEvent, toolText);
          }
        }

    }
  }
},

/**
 * fetches data indices wrt. the x pos value
 * @param {number} x  x pos value
 * @return {Array}    contains indices
 */
_getPlotIndices = function getPlotIndices(x) {
  var dataset = this,
      i,
      minX = Math.floor(x),
      // eslint-disable-line good-practices/no-single-usage-variable
  maxX = Math.ceil(x),
      // eslint-disable-line good-practices/no-single-usage-variable
  data,
      returnIndices = [],
      sortedData = dataset.config.JSONData && dataset.config.JSONData.data;

  for (i = sortedData.length; i--;) {
    data = sortedData[i];

    if (data.x >= minX && data.x <= maxX) {
      returnIndices.push(i);
    }
  }

  return returnIndices;
},
    __parseToolText = function __parseToolText(i) {
  var dataset = this,
      conf = dataset.config,
      data = dataset.components.data,
      // eslint-disable-line good-practices/no-single-usage-variable
  chartAttr = dataset.getFromEnv('chart-attrib'),
      isLine = conf.plotType === LINE ? 1 : 0,
      toolText,
      BLANK = BLANKSTRING,
      setData = conf.JSONData.data[i],
      config = data[i].config,
      label = dataset.getFromEnv('xAxis').getLabel(config.x).label,
      // eslint-disable-line good-practices/no-single-usage-variable
  open = config.open,
      close = config.close,
      yAxis = dataset.getFromEnv('yAxis'),
      high = config.high,
      low = config.low,
      volume = config.volume,
      volumeToolText = volume !== UNDEF ? setData.volumetooltext : UNDEF; // eslint-disable-line good-practices/no-single-usage-variable
  // create the tooltext

  if (!conf.showTooltip) {
    toolText = BLANK;
  } else {
    toolText = (0, _lib.getValidValue)((0, _lib.parseUnsafeString)((0, _lib.pluck)(volumeToolText, setData.tooltext, conf.volumeToolText, conf.toolText), false));

    if (toolText !== UNDEF) {
      toolText = (0, _lib.parseTooltext)(toolText, [3, 5, 6, 10, 54, 55, 56, 57, 58, 59, 60, 61, 81, 82], {
        label: label,
        yaxisName: (0, _lib.parseUnsafeString)(chartAttr.yaxisname),
        xaxisName: (0, _lib.parseUnsafeString)(chartAttr.xaxisname),
        openValue: setData.open,
        openDataValue: yAxis.dataLabels(open),
        closeValue: setData.close,
        closeDataValue: yAxis.dataLabels(close),
        highValue: setData.high,
        highDataValue: yAxis.dataLabels(high),
        lowValue: setData.low,
        lowDataValue: yAxis.dataLabels(low),
        volumeValue: setData.volume,
        volumeDataValue: yAxis.dataLabels(volume)
      }, setData, chartAttr);
    } else {
      toolText = open !== null && !isLine ? BOLDSTARTTAG + 'Open:' + BOLDENDTAG + BLANKSPACE + yAxis.dataLabels(open) + BREAKSTRING : BLANK;
      toolText += close !== null ? BOLDSTARTTAG + 'Close:' + BOLDENDTAG + BLANKSPACE + yAxis.dataLabels(close) + BREAKSTRING : BLANK;
      toolText += high !== null && !isLine ? BOLDSTARTTAG + 'High:' + BOLDENDTAG + BLANKSPACE + yAxis.dataLabels(high) + BREAKSTRING : BLANK;
      toolText += low !== null && !isLine ? BOLDSTARTTAG + 'Low:' + BOLDENDTAG + BLANKSPACE + yAxis.dataLabels(low) + BREAKSTRING : BLANK;
      toolText += volume !== null ? BOLDSTARTTAG + 'Volume:' + BOLDENDTAG + BLANKSPACE + yAxis.dataLabels(volume) : BLANK;
    }
  }

  return toolText;
};

exports._parseToolText = __parseToolText;
exports.getPlotIndices = _getPlotIndices;
exports._firePlotEvent = _firePlotEvent2;
(0, _dependencyManager.addDep)({
  name: 'candlestickAnimation',
  type: 'animationRule',
  extension: _candlestick.default
});
/**
* Class def for bull stick chart API
* This dataset is reponsible for drawing stick depending on high and open value
*/

var CandleStickDataset = /*#__PURE__*/function (_ErrorBar2DDataset) {
  (0, _inheritsLoose2.default)(CandleStickDataset, _ErrorBar2DDataset);

  function CandleStickDataset() {
    return _ErrorBar2DDataset.apply(this, arguments) || this;
  }

  var _proto = CandleStickDataset.prototype;

  /**
   * function to Remove data plots if the number of current data plots/categories
   * is more than the existing ones.
   * @param  {Object} datasetJSON JSON for dataset configurations
   */
  _proto.trimData = function trimData(datasetJSON) {
    if (!this.components && this.components.data && this.components.data.length) {
      return;
    }

    var comps = this.components,
        prevData = comps && comps.data,
        prevDataLength = prevData && prevData.length,
        // eslint-disable-line good-practices/no-single-usage-variable
    data = datasetJSON.data,
        currDataLength = Array.isArray(data) && data.filter(function (v) {
      return v.high || v.open || v.close || v.low;
    }).length || 0,
        // eslint-disable-line good-practices/no-function-dependency
    dataDiff = prevDataLength - currDataLength; // Removing data plots if the number of current data plots
    // is less than the existing ones.

    if (dataDiff > 0) {
      this.removeData(currDataLength, dataDiff, false);
    }
  }
  /**
   * This Api is used to remove all the data objects which are not required anymore.
   * candleStick should use the removePlot of column dataset
   * @memberof CandleStickDataset
   */
  ;

  _proto.removePlots = function removePlots() {
    var dataset = this,
        components = dataset.components,
        removeDataArr = components && components.removeDataArr; // eslint-disable-line good-practices/no-single-usage-variable

    (0, _column._removePlots)(removeDataArr, dataset.__removeElem);
  }
  /**
    * Function for parsing all the attributes and value given by the user at chart,dataset and set level.
    * This function is called once from the init() function of the Column class.
    * @param  {Object} datasetJSON JSON for dataset configurations
    * @return {boolean} Indicates whether the configuration was successful or not
    */
  ;

  _proto.configureAttributes = function configureAttributes(datasetJSON) {
    if (!datasetJSON) {
      return false;
    }

    this.trimData(datasetJSON);
    this.config.JSONData = datasetJSON;
    var dataset = this,
        conf = dataset.config,
        chart = dataset.getFromEnv('chart'),
        JSONData = dataset.config.JSONData,
        dataArr = JSONData.data || [],
        chartAttr = chart.getFromEnv('dataSource').chart,
        dataLength = dataArr.length,
        // eslint-disable-line good-practices/no-single-usage-variable
    numberFormatter = dataset.getFromEnv('number-formatter'),
        colorM = dataset.getFromEnv('color-manager'),
        setColor,
        setBorderColor,
        setAlpha,
        // Candle stick properties.
    // Bear fill and border color - (Close lower than open)
    bearBorderColor = conf.bearBorderColor = // eslint-disable-line good-practices/no-single-usage-variable
    (0, _lib.getFirstColor)((0, _lib.pluck)(chartAttr.bearbordercolor, COLOR_B90000)),
        bearFillColor = conf.bearFillColor = // eslint-disable-line good-practices/no-single-usage-variable
    (0, _lib.getFirstColor)((0, _lib.pluck)(chartAttr.bearfillcolor, COLOR_B90000)),
        // Bull fill and border color - Close higher than open
    bullBorderColor = conf.bullBorderColor = // eslint-disable-line good-practices/no-single-usage-variable
    (0, _lib.getFirstColor)((0, _lib.pluck)(chartAttr.bullbordercolor, colorM.getColor('canvasBorderColor'))),
        bullFillColor = conf.bullFillColor = // eslint-disable-line good-practices/no-single-usage-variable
    (0, _lib.getFirstColor)((0, _lib.pluck)(chartAttr.bullfillcolor, COLOR_FFFFFF)),
        // Line Properties - Serves as line for bar & line and border for candle stick
    plotLineThickness = conf.linethickness = conf.plotBorderThickness = (0, _lib.pluckNumber)(chartAttr.plotlinethickness, 1),
        plotLineDashLen = conf.plotLineDashLen = (0, _lib.pluckNumber)(chartAttr.plotlinedashlen, 5),
        // eslint-disable-line good-practices/no-single-usage-variable
    plotLineDashGap = conf.plotLineDashGap = (0, _lib.pluckNumber)(chartAttr.plotlinedashgap, 4),
        // eslint-disable-line good-practices/no-single-usage-variable
    pointShadow,
        index,
        dataObj,
        open,
        close,
        high,
        low,
        volume,
        minValue,
        maxValue,
        x,
        closeVal,
        borderColor,
        yVal,
        dataStore,
        setData,
        config,
        isCandleStick = false,
        // eslint-disable-line good-practices/no-single-usage-variable
    plotSpacePercent,
        yMax = -Infinity,
        yMin = +Infinity,
        xMax = -Infinity,
        xMin = +Infinity,
        userMaxColWidth;
    dataset.setState('visible', (0, _lib.pluckNumber)(JSONData.visible, 1) === 1);
    dataset._conatinerHidden = !!dataset.getState('visible');
    conf.minAbsNonZeroValue = Infinity;
    conf.minAbsNonZeroData = {};
    conf.defaultPadding = {
      left: 0.5,
      right: 0.5
    };
    conf.parentYAxis = 0;
    conf.toolText = (0, _lib.getValidValue)((0, _lib.parseUnsafeString)((0, _lib.pluck)(JSONData.tooltext, chartAttr.plottooltext), false)); // Dataset seriesname

    conf.name = (0, _lib.getValidValue)(JSONData.seriesname);
    conf.showTooltip = (0, _lib.pluckNumber)(chartAttr.showtooltip, 1);
    conf.showShadow = (0, _lib.pluckNumber)(chartAttr.showshadow, colorM.getColor(SHOWSHADOW));
    conf.showErrorValue = true;
    conf.errorBarWidthPercent = 0;
    isCandleStick = true; // eslint-disable-line good-practices/no-single-usage-variable

    userMaxColWidth = (0, _lib.pluck)(chartAttr.maxcolwidth); // eslint-disable-line good-practices/no-single-usage-variable

    conf.maxColWidth = Math.abs((0, _lib.pluckNumber)(userMaxColWidth, 50)) || 1;
    plotSpacePercent = Math.max((0, _lib.pluckNumber)(chartAttr.plotspacepercent, 20) % 100, 0); // eslint-disable-line good-practices/no-single-usage-variable

    conf.plotSpacePercent = conf.groupPadding = plotSpacePercent / 200;
    dataStore = dataset.components.data = dataset.components.data || (dataset.components.data = []);
    conf.valuePadding = (0, _lib.pluckNumber)(JSONData.valuepadding, chartAttr.valuepadding, 2);
    conf.plotBorderThickness = plotLineThickness; // Iterate through all level data

    for (index = 0; index < dataLength; index += 1) {
      // Individual data obj
      // for further manipulation
      setData = dataArr[index];
      dataObj = dataStore[index];

      if (!dataObj) {
        dataObj = dataStore[index] = {};
      }

      !dataObj.config && (dataObj.config = {});
      !dataObj.graphics && (dataObj.graphics = {});
      config = dataObj.config;

      if (setData && !setData.vline) {
        config.setLink = (0, _lib.pluck)(setData.link);
        open = config.open = numberFormatter.getCleanValue(setData.open);
        close = config.close = numberFormatter.getCleanValue(setData.close);
        high = config.high = numberFormatter.getCleanValue(setData.high);
        low = config.low = numberFormatter.getCleanValue(setData.low);
        volume = config.volume = numberFormatter.getCleanValue(setData.volume, true);

        if (volume !== null) {
          chart.config.drawVolume = true;
        }

        x = config.x = numberFormatter.getCleanValue(setData.x); // openVal = config.openVal = isCandleStick ? Math.abs(close - open) : open;

        closeVal = config.closeVal = Math.min(open, close);
        yVal = config.yVal = Math.max(open, close);
        minValue = Math.min(open, close, high, low);
        maxValue = Math.max(open, close, high, low);
        config.valuePadding = (0, _lib.pluckNumber)(setData.valuepadding, conf.valuePadding); // valueText = parseUnsafeString(getValidValue(setData.valuetext, BLANK));

        setBorderColor = (0, _lib.getFirstColor)((0, _lib.pluck)(setData.bordercolor, close < open ? bearBorderColor : bullBorderColor));
        setAlpha = (0, _lib.pluckNumber)(setData.alpha, 100);
        setColor = (0, _lib.getFirstColor)((0, _lib.pluck)(setData.color, close < open ? bearFillColor : bullFillColor));
        config.dashed = (0, _lib.pluckNumber)(setData.dashed, 0);
        config.plotBorderDashStyle = (0, _lib.pluckNumber)(setData.dashed) ? (0, _lib.getDashStyle)(plotLineDashLen, plotLineDashGap) : DASH_DEF; // Set alpha of the shadow

        pointShadow = {
          opacity: conf.showShadow ? setAlpha / 100 : 0
        };
        config.color = isCandleStick ? setColor : setBorderColor;
        config.alpha = setAlpha;
        /*
        * Storing the set level color and set level alpha which is required in drawing of line
        * In line we are checking setColor and setAlpha of current line segment is same as the previous
        * line segment's setColor and setAlpha by accesing config.setColor and config.setAlpha
        */

        config.setColor = config.color;
        config.setAlpha = config.alpha;
        config.anchorImageUrl = (0, _lib.pluck)(setData.anchorimageurl, JSONData.anchorimageurl, chartAttr.anchorimageurl); // Finally add the data
        // we call getPointStub function that manage displayValue, toolText and link

        borderColor = config.borderColor = setBorderColor;
        config.borderAlpha = config.plotLineAlpha;
        config.colorArr = [{
          color: config.color,
          alpha: config.alpha
        }, {
          color: config.borderColor,
          alpha: config.borderAlpha
        }];
        config.showValue = 1;
        config.hoverEffects = {};
        config.y = Math.abs(close - open);
        config.previousY = closeVal;
        config.link = (0, _lib.pluck)(setData.link);
        config.errorValueArr = [];

        if (high - yVal > 0) {
          config.errorValue = true;
          config.errorValueArr.push({
            errorValue: yVal - high,
            errorStartValue: yVal,
            errorBarColor: borderColor,
            errorBarThickness: plotLineThickness,
            opacity: 1
          });
        }

        if (low - closeVal < 0) {
          config.errorValue = true;
          config.errorValueArr.push({
            errorValue: closeVal - low,
            errorStartValue: closeVal,
            errorBarColor: borderColor,
            errorBarThickness: plotLineThickness,
            opacity: 1
          });
        }

        config.setValue = yVal;

        if (yVal !== 0 && conf.minAbsNonZeroValue > Math.abs(yVal)) {
          conf.minAbsNonZeroValue = Math.abs(yVal);
          conf.minAbsNonZeroData = config;
        }

        config.dataLabelStyle = dataset._configureDataLabelStyle(setData);

        if (minValue !== null) {
          yMax = Math.max(yMax, minValue);
          yMin = Math.min(yMin, minValue);
        }

        if (maxValue !== null) {
          yMax = Math.max(yMax, maxValue);
          yMin = Math.min(yMin, maxValue);
        }

        if (x !== null) {
          xMax = Math.max(xMax, x);
          xMin = Math.min(xMin, x);
        }

        x = x !== null ? x : index + 1;
        config._x = x;
        config._y = yVal;
        config._b = closeVal;
        config.high = Math.max(open, close, high, low);
        config.low = Math.min(open, close, high, low);
        config.shadow = pointShadow;
        config.toolText = dataset._parseToolText(index);
        config.toolTipValue = BLANKSTRING;
        config.displayValue = (0, _lib.parseUnsafeString)((0, _lib.pluck)(setData.displayvalue, setData.valuetext, BLANKSTRING));
      }
    }

    conf.yMax = yMax;
    conf.yMin = yMin;
    conf.xMax = xMax;
    conf.xMin = xMin;
    dataset.setState('dirty', true);
  }
  /**
   * parse tooltext from the dataset json
   * @param {number} i index of data
   * @return {string} tooltext
   */
  ;

  _proto._parseToolText = function _parseToolText(i) {
    return __parseToolText.call(this, i);
  }
  /**
   * Adds dataset Specific event Arguments
   * @param {Object} _dataObj dataObject
   */
  // eslint-disable-next-line class-methods-use-this
  ;

  _proto.addDatasetSpecificEvtArgs = function addDatasetSpecificEvtArgs(_dataObj) {
    var dataObj = _dataObj,
        config = dataObj.config,
        trackerConfig = dataObj.trackerConfig,
        eventArgs = trackerConfig.eventArgs;
    Object.assign(eventArgs, {
      open: config.open,
      close: config.close,
      high: config.high,
      low: config.low,
      volume: config.volume,
      alpha: config.alpha,
      x: config.x,
      displayValue: config.displayValue,
      color: config.color,
      borderColor: config.borderColor,
      dashed: config.dashed
    });
  }
  /**
   * calculate min and max position to scroll
   */
  ;

  _proto.calculateScrollRange = function calculateScrollRange() {
    var dataset = this,
        conf = dataset.config,
        dataLen = dataset.components.data && dataset.components.data.length; // eslint-disable-line good-practices/no-single-usage-variable

    conf.scrollMinVal = conf.scrollMinValForLabel = 0;
    conf.scrollMaxVal = conf.scrollMaxValForLabel = dataLen;
  }
  /**
   * fetches data indices wrt. the x pos value
   * @param {number} x  x pos value
   * @return {Array}    contains indices
   */
  ;

  _proto.getPlotIndices = function getPlotIndices(x) {
    return _getPlotIndices.call(this, x);
  }
  /**
   * Function that retunr the nearest plot details
   * @param {number} chartX x-axis position of the mouse cordinate
   * @param {number} chartY x-axis position of the mouse cordinate
   * @return {Object} return an object with details of nearest polt and whether it is hovered or not
   */
  ;

  _proto._getHoveredPlot = function _getHoveredPlot(chartX, chartY) {
    var dataset = this,
        x,
        i,
        hoveredInfo,
        pXs,
        pX;
    x = dataset.getFromEnv('xAxis').getValue(chartX);
    pXs = dataset.getPlotIndices(x); // Checking for overlap between two cosecutive column plots along x-axis

    for (i = pXs.length - 1; i > -1; i--) {
      pX = pXs[i];
      hoveredInfo = pX - x > 0 ? dataset._checkPointerOverPlot(pX, chartX, chartY) || dataset._checkPointerOverPlot(pX - 1, chartX, chartY) : dataset._checkPointerOverPlot(pX + 1, chartX, chartY) || dataset._checkPointerOverPlot(pX, chartX, chartY);

      if (hoveredInfo) {
        break;
      }
    }

    return hoveredInfo;
  }
  /**
   * This method handles all mouse events of an dataset.
   * @param {string} eventType    name of the event
   * @param {number} plotIndex    index of the plot where this event has been occured
   * @param {Event}  e            reference of the original mouse event
   */
  ;

  _proto._firePlotEvent = function _firePlotEvent(eventType, plotIndex, e) {
    _firePlotEvent2.call(this, eventType, plotIndex, e);
  }
  /**
   * Function to get the maximum and minimum from dataset
   * @return {Object}     contains max, min value
   */
  ;

  _proto.getDataLimits = function getDataLimits() {
    var conf = this.config;
    return {
      max: conf.yMax,
      min: conf.yMin,
      xMax: conf.xMax,
      xMin: conf.xMin
    };
  }
  /**
   * Returns the name of the component
   *
   * @return {string} The name of the component
   */
  ;

  _proto.getName = function getName() {
    return 'candlestick';
  };

  return CandleStickDataset;
}(_errorbar2d.default);

var _default = CandleStickDataset;
exports["default"] = _default;

/***/ }),

/***/ 1412:
/***/ ((__unused_webpack_module, exports) => {



exports.__esModule = true;
exports["default"] = void 0;
var _default = {
  'initial.dataset.candlestickbar': function initialDatasetCandlestickbar() {
    return {
      'path.appearing': function pathAppearing() {
        return [{
          initialAttr: {
            opacity: 1,
            'stroke-width': 1
          },
          finalAttr: {
            opacity: 1
          }
        }];
      },
      '*': null
    };
  }
};
exports["default"] = _default;

/***/ }),

/***/ 1411:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _lib = __webpack_require__(274);

var _column = _interopRequireDefault(__webpack_require__(595));

var _errorbar2d = __webpack_require__(1323);

var _candlestick = __webpack_require__(1409);

var _dependencyManager = __webpack_require__(282);

var _candlestickbar = _interopRequireDefault(__webpack_require__(1412));

/* eslint require-jsdoc: 'error', valid-jsdoc: ["error", { "requireReturn": false }] */
var colorStrings = _lib.preDefStr.colors,
    COLOR_B90000 = colorStrings.B90000,
    COLOR_FFFFFF = colorStrings.FFFFFF,
    SHOWSHADOW = 'showShadow',
    ROUND = _lib.preDefStr.ROUND,
    visibleStr = _lib.preDefStr.visibleStr,
    DASH_DEF = 'none',
    POINTER = 'pointer',
    BLANKSTRING = '',
    M = 'M',
    L = 'L',
    applyShadow = function applyShadow(shadow) {
  return function () {
    this.shadow(shadow);
  };
};

(0, _dependencyManager.addDep)({
  name: 'candlestickbarAnimation',
  type: 'animationRule',
  extension: _candlestickbar.default
});
/**
 * Class def for bull stick chart API
 * This dataset is reponsible for drawing stick depending on high and open value
 */

var CandleStickBar = /*#__PURE__*/function (_Column) {
  (0, _inheritsLoose2.default)(CandleStickBar, _Column);

  function CandleStickBar() {
    return _Column.apply(this, arguments) || this;
  }

  var _proto = CandleStickBar.prototype;

  /**
   * function to Remove data plots if the number of current data plots/categories
   * is more than the existing ones.
   * @param  {Object} datasetJSON JSON for dataset configurations
   */
  _proto.trimData = function trimData(datasetJSON) {
    if (!this.components && this.components.data && this.components.data.length) {
      return;
    }

    var comps = this.components,
        prevData = comps && comps.data,
        prevDataLength = prevData && prevData.length,
        // eslint-disable-line good-practices/no-single-usage-variable
    data = datasetJSON.data,
        currDataLength = Array.isArray(data) && data.filter(function (v) {
      return v.high || v.open || v.close || v.low;
    }).length || 0,
        // eslint-disable-line good-practices/no-function-dependency
    dataDiff = prevDataLength - currDataLength; // Removing data plots if the number of current data plots
    // is less than the existing ones.

    if (dataDiff > 0) {
      this.removeData(currDataLength, dataDiff, false);
    }
  }
  /**
   * Adds dataset Specific event Arguments
   * @param {Object} _dataObj dataObject
   */
  // eslint-disable-next-line class-methods-use-this
  ;

  _proto.addDatasetSpecificEvtArgs = function addDatasetSpecificEvtArgs(_dataObj) {
    var dataObj = _dataObj,
        config = dataObj.config,
        trackerConfig = dataObj.trackerConfig,
        eventArgs = trackerConfig.eventArgs;
    Object.assign(eventArgs, {
      open: config.open,
      close: config.close,
      high: config.high,
      low: config.low,
      volume: config.volume,
      alpha: config.alpha,
      x: config.x,
      displayValue: config.displayValue,
      color: config.color,
      borderColor: config.borderColor,
      dashed: config.dashed
    });
  }
  /**
    * Function for parsing all the attributes and value given by the user at chart,dataset and set level.
    * This function is called once from the init() function of the Column class.
    * @param  {Object} datasetJSON JSON for dataset configurations
    * @return {boolean} Indicates whether the configuration was successful or not
    */
  ;

  _proto.configureAttributes = function configureAttributes(datasetJSON) {
    if (!datasetJSON) {
      return false;
    }

    this.trimData(datasetJSON);
    this.config.JSONData = datasetJSON;
    var dataset = this,
        conf = dataset.config,
        chart = dataset.getFromEnv('chart'),
        rawDataObj = chart.getFromEnv('dataSource'),
        // eslint-disable-line good-practices/no-single-usage-variable
    JSONData = dataset.config.JSONData,
        dataArr = JSONData.data || [],
        chartAttr = rawDataObj.chart,
        dataLength = dataArr.length,
        // eslint-disable-line good-practices/no-single-usage-variable
    numberFormatter = dataset.getFromEnv('number-formatter'),
        colorM = dataset.getFromEnv('color-manager'),
        setColor,
        setBorderColor,
        setAlpha,
        // Candle stick properties.
    // Bear fill and border color - (Close lower than open)
    bearBorderColor = conf.bearBorderColor = // eslint-disable-line good-practices/no-single-usage-variable
    (0, _lib.getFirstColor)((0, _lib.pluck)(chartAttr.bearbordercolor, COLOR_B90000)),
        bearFillColor = conf.bearFillColor = // eslint-disable-line good-practices/no-single-usage-variable
    (0, _lib.getFirstColor)((0, _lib.pluck)(chartAttr.bearfillcolor, COLOR_B90000)),
        // Bull fill and border color - Close higher than open
    bullBorderColor = conf.bullBorderColor = // eslint-disable-line good-practices/no-single-usage-variable
    (0, _lib.getFirstColor)((0, _lib.pluck)(chartAttr.bullbordercolor, colorM.getColor('canvasBorderColor'))),
        bullFillColor = conf.bullFillColor = // eslint-disable-line good-practices/no-single-usage-variable
    (0, _lib.getFirstColor)((0, _lib.pluck)(chartAttr.bullfillcolor, COLOR_FFFFFF)),
        index,
        dataObj,
        open,
        close,
        high,
        low,
        minValue,
        maxValue,
        x,
        dataStore,
        setData,
        config,
        isCandleStick = false,
        // eslint-disable-line good-practices/no-single-usage-variable
    yMax = -Infinity,
        yMin = +Infinity,
        xMax = -Infinity,
        xMin = +Infinity,
        userMaxColWidth;
    dataset.setState('visible', (0, _lib.pluckNumber)(JSONData.visible, 1) === 1);
    dataset._conatinerHidden = !!dataset.getState('visible');
    conf.defaultPadding = {
      left: 0.5,
      right: 0.5
    };
    conf.minAbsNonZeroValue = Infinity;
    conf.minAbsNonZeroData = {};
    conf.linethickness = (0, _lib.pluckNumber)(chartAttr.plotlinethickness, 2);
    conf.toolText = (0, _lib.getValidValue)((0, _lib.parseUnsafeString)((0, _lib.pluck)(JSONData.tooltext, chartAttr.plottooltext), false)); // Dataset seriesname

    conf.name = (0, _lib.getValidValue)(JSONData.seriesname);
    conf.showTooltip = (0, _lib.pluckNumber)(chartAttr.showtooltip, 1);
    conf.showErrorValue = true;
    conf.errorBarWidthPercent = 0;
    isCandleStick = true; // eslint-disable-line good-practices/no-single-usage-variable

    userMaxColWidth = (0, _lib.pluck)(chartAttr.maxcolwidth); // eslint-disable-line good-practices/no-single-usage-variable

    conf.maxColWidth = Math.abs((0, _lib.pluckNumber)(userMaxColWidth, 50)) || 1; // Animation related attributes configuration

    conf.enableAnimation = (0, _lib.pluckNumber)(chartAttr.animation, chartAttr.defaultanimation, 1);
    conf.animation = !conf.enableAnimation ? false : {
      duration: (0, _lib.pluckNumber)(chartAttr.animationduration, 1) * 1000
    };
    conf.plotLineDashLen = (0, _lib.pluckNumber)(chartAttr.plotlinedashlen, 5);
    conf.plotLineDashGap = (0, _lib.pluckNumber)(chartAttr.plotlinedashgap, 4);
    dataStore = dataset.components.data = dataset.components.data || (dataset.components.data = []);
    conf.valuePadding = (0, _lib.pluckNumber)(JSONData.valuepadding, chartAttr.valuepadding, 2);
    conf.showShadow = (0, _lib.pluckNumber)(chartAttr.showshadow, colorM.getColor(SHOWSHADOW)); // Iterate through all level data

    for (index = 0; index < dataLength; index++) {
      // Individual data obj
      // for further manipulation
      setData = dataArr[index];
      dataObj = dataStore[index];

      if (!dataObj) {
        dataObj = dataStore[index] = {};
      }

      !dataObj.config && (dataObj.config = {});
      !dataObj.graphics && (dataObj.graphics = {});
      config = dataObj.config;

      if (setData && !setData.vline) {
        config.setLink = (0, _lib.pluck)(setData.link);
        open = config.open = numberFormatter.getCleanValue(setData.open);
        close = config.close = numberFormatter.getCleanValue(setData.close);
        high = numberFormatter.getCleanValue(setData.high);
        low = numberFormatter.getCleanValue(setData.low);
        config.volume = numberFormatter.getCleanValue(setData.volume, true);
        x = config.x = numberFormatter.getCleanValue(setData.x);
        config.high = Math.max(open, close, high, low);
        config.low = Math.min(open, close, high, low);
        config.yVal = Math.max(open, close);
        minValue = Math.min(open, close, high, low);
        maxValue = Math.max(open, close, high, low);
        config.valuePadding = (0, _lib.pluckNumber)(setData.valuepadding, conf.valuePadding); // valueText = parseUnsafeString(getValidValue(setData.valuetext, BLANK));

        setBorderColor = (0, _lib.getFirstColor)((0, _lib.pluck)(setData.bordercolor, close < open ? bearBorderColor : bullBorderColor));
        setAlpha = (0, _lib.pluckNumber)(setData.alpha, 100);
        setColor = (0, _lib.getFirstColor)((0, _lib.pluck)(setData.color, close < open ? bearFillColor : bullFillColor));
        config.color = isCandleStick ? setColor : setBorderColor;
        config.alpha = setAlpha;
        /*
         * Storing the set level color and set level alpha which is required in drawing of line
         * In line we are checking setColor and setAlpha of current line segment is same as the previous
         * line segment's setColor and setAlpha by accesing config.setColor and config.setAlpha
         */

        config.setColor = config.color;
        config.setAlpha = config.alpha; // Finally add the data
        // we call getPointStub function that manage displayValue, toolText and link

        config.borderColor = setBorderColor;
        config.borderAlpha = config.plotLineAlpha;
        config.colorArr = [{
          color: config.color,
          alpha: config.alpha
        }, {
          color: config.borderColor,
          alpha: config.borderAlpha
        }];
        config.showValue = 1;
        config.hoverEffects = {};
        config.link = (0, _lib.pluck)(setData.link);
        config.setValue = config.y;

        if (config.setValue !== 0 && conf.minAbsNonZeroValue > Math.abs(config.setValue)) {
          conf.minAbsNonZeroValue = Math.abs(config.setValue);
          conf.minAbsNonZeroData = config;
        }

        config.dataLabelStyle = dataset._configureDataLabelStyle(setData);

        if (minValue !== null) {
          yMax = Math.max(yMax, minValue);
          yMin = Math.min(yMin, minValue);
        }

        if (maxValue !== null) {
          yMax = Math.max(yMax, maxValue);
          yMin = Math.min(yMin, maxValue);
        }

        if (x !== null) {
          xMax = Math.max(xMax, x);
          xMin = Math.min(xMin, x);
        }

        config.dashStyle = (0, _lib.pluckNumber)(setData.dashed) ? (0, _lib.getDashStyle)(conf.plotLineDashLen, conf.plotLineDashGap) : DASH_DEF;
        config.shadow = {
          opacity: conf.showShadow ? setAlpha / 100 : 0
        };
        x = x !== null ? x : index + 1;
        config.toolText = dataset._parseToolText(index);
        config.toolTipValue = BLANKSTRING;
        config._x = x;
        config.y = open;
        config.previousY = close;
        config.dashed = (0, _lib.pluckNumber)(conf.plotLineDashed, setData.dashed, 0);
      }
    }

    conf.yMax = yMax;
    conf.yMin = yMin;
    conf.xMax = xMax;
    conf.xMin = xMin;
    dataset.setState('dirty', true);
  }
  /**
   * functioto draw and update the graphics elements of plots
   * @param {Object} anim    - object reference of animation manager argument
   *                           consist of elements and their configuration
   */
  ;

  _proto.drawPlots = function drawPlots() {
    var dataset = this,
        config,
        animationManager = dataset.getFromEnv('animationManager'),
        conf = dataset.config,
        data = dataset.components.data,
        length = data.length,
        // eslint-disable-line good-practices/no-single-usage-variable
    xAxis = dataset.getFromEnv('xAxis'),
        // eslint-disable-line good-practices/no-single-usage-variable
    yAxis = dataset.getFromEnv('yAxis'),
        // key,
    i,
        set,
        setLink,
        x,
        y,
        previousY,
        xPos,
        yPos,
        previousYPos,
        setElem,
        bars,
        trackerTolerance = conf.linethickness > 5 ? conf.linethickness / 2 : 2.5,
        container = dataset.getContainer('plotGroup'),
        // hotElem,
    // targetGroup,
    highPos,
        lowPos,
        halfW,
        path,
        graphics;
    animationManager.setAnimation({
      el: container,
      attr: {
        opacity: dataset.getState('visible') ? 1 : 0
      },
      component: dataset
    });
    dataset.setColumnPosition(); // draw plots

    for (i = 0; i < length; i += 1) {
      set = data[i];
      config = set.config;
      graphics = set.graphics;
      y = config.y;
      setElem = null;

      if (y === null) {
        setElem = graphics.element;
      } else {
        // when valid value
        x = config._x;
        setLink = config.link;
        config.setLink = config.link; // fixedWidth = config._FCW * groupMaxWidth;

        xPos = xAxis.getPixel(x);
        previousY = config.previousY;
        previousYPos = yAxis.getPixel(previousY);
        yPos = yAxis.getPixel(y);
        highPos = yAxis.getPixel(config.high);
        lowPos = yAxis.getPixel(config.low);
        halfW = dataset.getFromEnv('columnXShift');
        set.errorBar = [];
        bars = set.errorBar;
        bars.push([{
          _xPos: xPos - trackerTolerance,
          _yPos: highPos,
          _height: Math.abs(highPos - lowPos),
          _width: 2 * trackerTolerance
        }, {
          _xPos: xPos + halfW,
          _yPos: yPos,
          _height: 2 * trackerTolerance,
          _width: Math.abs(halfW)
        }, {
          _xPos: xPos,
          _yPos: previousYPos,
          _height: 2 * trackerTolerance,
          _width: Math.abs(halfW)
        }]);
        path = [M, xPos, lowPos, L, xPos, highPos, M, xPos, yPos, L, xPos + halfW, yPos, M, xPos, previousYPos, L, xPos - halfW, previousYPos];
        setElem = graphics.element;
        setElem = animationManager.setAnimation({
          el: setElem || 'path',
          container: container,
          attr: {
            'path': path,
            'cursor': setLink ? POINTER : BLANKSTRING,
            fill: (0, _lib.toRaphaelColor)(config.color),
            stroke: (0, _lib.toRaphaelColor)(config.borderColor),
            'stroke-width': conf.linethickness,
            'stroke-dasharray': config.dashStyle,
            'stroke-linecap': ROUND,
            'stroke-linejoin': ROUND,
            'shape-rendering': 'crisp',
            'visibility': visibleStr
          },
          label: 'path',
          component: dataset,
          callback: applyShadow.call(setElem, config.shadow)
        });
        setElem.data('eventArgs', set.trackerConfig.eventArgs);
        graphics.element = setElem;
      }
    }
  }
  /**
   * parse tooltext from the dataset json
   * @param {number} i index of data
   * @return {string} tooltext
   */
  ;

  _proto._parseToolText = function _parseToolText(i) {
    return _candlestick._parseToolText.call(this, i);
  }
  /**
   * This method handles all mouse events of an dataset.
   * @param {string} eventType    name of the event
   * @param {number} plotIndex    index of the plot where this event has been occured
   * @param {Event}  e            reference of the original mouse event
   */
  ;

  _proto._firePlotEvent = function _firePlotEvent(eventType, plotIndex, e) {
    _candlestick._firePlotEvent.call(this, eventType, plotIndex, e);
  }
  /**
   * function to check if given x,y coordiante is over a column plot or not
   */
  // eslint-disable-next-line
  ;

  _proto._checkPointerOverColumn = function _checkPointerOverColumn() {}
  /**
   * Function that retunr the nearest plot details
   * @param {number} chartX x-axis position of the mouse cordinate
   * @param {number} chartY y-axis position of the mouse cordinate
   * @return {Object} return an object with details of nearest polt and whether it is hovered or not
   */
  ;

  _proto._getHoveredPlot = function _getHoveredPlot(chartX, chartY) {
    var dataset = this,
        x,
        i,
        hoveredInfo,
        pXs,
        pX;
    x = dataset.getFromEnv('xAxis').getValue(chartX);
    pXs = _candlestick.getPlotIndices.call(dataset, x); // Checking for overlap between two cosecutive column plots along x-axis

    for (i = pXs.length - 1; i > -1; i--) {
      pX = pXs[i];
      hoveredInfo = pX - x > 0 ? dataset._checkPointerOverPlot(pX, chartX, chartY) || dataset._checkPointerOverPlot(pX - 1, chartX, chartY) : dataset._checkPointerOverPlot(pX + 1, chartX, chartY) || dataset._checkPointerOverPlot(pX, chartX, chartY);

      if (hoveredInfo) {
        break;
      }
    }

    return hoveredInfo;
  }
  /**
   * Helper function of _getHoverPlot fn
   * @param {number} pX     x index value
   * @param {number} chartX x-axis position of the mouse cordinate
   * @param {number} chartY y-axis position of the mouse cordinate
   * @return {Object}       return hover information
   */
  ;

  _proto._checkPointerOverPlot = function _checkPointerOverPlot(pX, chartX, chartY) {
    return _errorbar2d._checkPointerOverPlot.call(this, pX, chartX, chartY);
  }
  /**
   * Helper function of _checkPointerOverPlot fn
   * @param {number} pX     x index value
   * @param {number} chartX x-axis position of the mouse cordinate
   * @param {number} chartY y-axis position of the mouse cordinate
   * @return {Object}       return hover information
   */
  ;

  _proto._checkPointerOverErrorBar = function _checkPointerOverErrorBar(pX, chartX, chartY) {
    return _errorbar2d._checkPointerOverErrorBar.call(this, pX, chartX, chartY);
  }
  /**
    * This function overrides drawlabel method
    * it prevents the label drawing
    */
  // eslint-disable-next-line
  ;

  _proto.drawLabel = function drawLabel() {}
  /**
   * Function to get the maximum and minimum from dataset
   * @return {Object}     contains max, min value
   */
  ;

  _proto.getDataLimits = function getDataLimits() {
    var conf = this.config;
    return {
      max: conf.yMax,
      min: conf.yMin,
      xMax: conf.xMax,
      xMin: conf.xMin
    };
  }
  /**
   * Returns the name of the component
   *
   * @return {string} The name of the component
   */
  ;

  _proto.getName = function getName() {
    return 'candlestickbar';
  };

  return CandleStickBar;
}(_column.default);

var _default = CandleStickBar;
exports["default"] = _default;

/***/ }),

/***/ 1413:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _lib = __webpack_require__(274);

var _line = _interopRequireDefault(__webpack_require__(616));

var _candlestick = __webpack_require__(1409);

/* eslint require-jsdoc: 'error', valid-jsdoc: ["error", { "requireReturn": false }] */
var colorStrings = _lib.preDefStr.colors,
    COLOR_B90000 = colorStrings.B90000,
    COLOR_FFFFFF = colorStrings.FFFFFF,
    UNDERSCORE = '_',
    BLANK = '',
    SHOWSHADOW = 'showShadow',
    LINE_STR = 'line',
    ZEROSTRING = '0',
    HUNDRED = '100';
/**
 * Class def for bull stick chart API
 * This dataset is reponsible for drawing stick depending on high and open value
 */

var CandleStickline = /*#__PURE__*/function (_Line) {
  (0, _inheritsLoose2.default)(CandleStickline, _Line);

  function CandleStickline() {
    return _Line.apply(this, arguments) || this;
  }

  var _proto = CandleStickline.prototype;

  /**
    * Function for parsing all the attributes and value given by the user at chart,dataset and set level.
    * This function is called once from the init() function of the Column class.
    * @param  {Object} datasetJSON JSON for dataset configurations
    * @return {boolean} Indicates whether the configuration was successful or not
    */
  _proto.configureAttributes = function configureAttributes(datasetJSON) {
    if (!datasetJSON) {
      return false;
    }

    this.trimData(datasetJSON);
    this.config.JSONData = datasetJSON;
    var dataset = this,
        conf = dataset.config,
        JSONData = dataset.config.JSONData,
        dataArr = JSONData.data || [],
        chartAttr = dataset.getFromEnv('chart-attrib'),
        dataLength = dataArr.length,
        // eslint-disable-line good-practices/no-single-usage-variable
    numberFormatter = dataset.getFromEnv('number-formatter'),
        colorM = dataset.getFromEnv('color-manager'),
        setColor,
        setBorderColor,
        setAlpha,
        dashStyle,
        // Candle stick properties.
    // Bear fill and border color - (Close lower than open)
    bearBorderColor = conf.bearBorderColor = // eslint-disable-line good-practices/no-single-usage-variable
    (0, _lib.getFirstColor)((0, _lib.pluck)(chartAttr.bearbordercolor, COLOR_B90000)),
        bearFillColor = conf.bearFillColor = // eslint-disable-line good-practices/no-single-usage-variable
    (0, _lib.getFirstColor)((0, _lib.pluck)(chartAttr.bearfillcolor, COLOR_B90000)),
        // Bull fill and border color - Close higher than open
    bullBorderColor = conf.bullBorderColor = (0, _lib.getFirstColor)((0, _lib.pluck)(chartAttr.bullbordercolor, colorM.getColor('canvasBorderColor'))),
        bullFillColor = conf.bullFillColor = // eslint-disable-line good-practices/no-single-usage-variable
    (0, _lib.getFirstColor)((0, _lib.pluck)(chartAttr.bullfillcolor, COLOR_FFFFFF)),
        // Line Properties - Serves as line for bar & line and border for candle stick
    plotLineThickness = conf.linethickness = conf.plotBorderThickness = // eslint-disable-line good-practices/no-single-usage-variable
    (0, _lib.pluckNumber)(chartAttr.plotlinethickness, 2),
        // Anchor cosmetics in data points
    // Getting anchor cosmetics for the data points or its default values
    // The default value is different from flash in order to render a
    // perfect circle when no anchorside is provided.
    drawAnchors = !!(0, _lib.pluckNumber)(chartAttr.drawanchors, 0),
        // eslint-disable-line good-practices/no-single-usage-variable
    setAnchorAngle = (0, _lib.pluckNumber)(chartAttr.anchorstartangle, 90),
        // eslint-disable-line good-practices/no-single-usage-variable
    setAnchorRadius = (0, _lib.pluckNumber)(chartAttr.anchorradius, // eslint-disable-line good-practices/no-single-usage-variable
    this.anchorRadius, 3),
        setAnchorBorderColor = (0, _lib.getFirstColor)((0, _lib.pluck)(chartAttr.anchorbordercolor, // eslint-disable-line good-practices/no-single-usage-variable
    bullBorderColor)),
        setAnchorBorderThickness = (0, _lib.pluckNumber)(chartAttr.anchorborderthickness, // eslint-disable-line good-practices/no-single-usage-variable
    this.anchorBorderThickness, 1),
        setAnchorBgColor = (0, _lib.getFirstColor)((0, _lib.pluck)(chartAttr.anchorbgcolor, // eslint-disable-line good-practices/no-single-usage-variable
    colorM.getColor('anchorBgColor'))),
        setAnchorAlpha = (0, _lib.pluck)(chartAttr.anchoralpha, ZEROSTRING),
        setAnchorBgAlpha = (0, _lib.pluck)(chartAttr.anchorbgalpha, setAnchorAlpha),
        // eslint-disable-line good-practices/no-single-usage-variable
    pointShadow,
        index,
        dataObj,
        open,
        close,
        high,
        low,
        minValue,
        maxValue,
        x,
        dataStore,
        setData,
        config,
        isCandleStick = false,
        // eslint-disable-line good-practices/no-single-usage-variable
    plotSpacePercent,
        yMax = -Infinity,
        yMin = +Infinity,
        xMax = -Infinity,
        xMin = +Infinity;
    dataset.setState('visible', (0, _lib.pluckNumber)(JSONData.visible, 1) === 1);
    conf.plotLineDashLen = (0, _lib.pluckNumber)(chartAttr.plotlinedashlen, 5);
    conf.plotLineDashGap = (0, _lib.pluckNumber)(chartAttr.plotlinedashgap, 4);
    dataset._conatinerHidden = !!dataset.getState('visible');
    conf.defaultPadding = {
      left: 0.5,
      right: 0.5
    };
    conf.plotType = LINE_STR;
    conf.parentYAxis = 0;
    conf.toolText = (0, _lib.getValidValue)((0, _lib.parseUnsafeString)((0, _lib.pluck)(JSONData.tooltext, chartAttr.plottooltext), false)); // Dataset seriesname

    conf.name = (0, _lib.getValidValue)(JSONData.seriesname);
    conf.showTooltip = (0, _lib.pluckNumber)(chartAttr.showtooltip, 1);
    conf.maxColWidth = Math.abs((0, _lib.pluckNumber)((0, _lib.pluck)(chartAttr.maxcolwidth), 50)) || 1; // Animation related attributes configuration

    conf.enableAnimation = (0, _lib.pluckNumber)(chartAttr.animation, chartAttr.defaultanimation, 1);
    conf.animation = !conf.enableAnimation ? false : {
      duration: (0, _lib.pluckNumber)(chartAttr.animationduration, 1) * 1000
    };
    conf.lineAlpha = (0, _lib.pluck)(chartAttr.plotlinealpha, HUNDRED);
    plotSpacePercent = Math.max((0, _lib.pluckNumber)(chartAttr.plotspacepercent, 20) % 100, 0); // eslint-disable-line good-practices/no-single-usage-variable

    conf.plotSpacePercent = conf.groupPadding = plotSpacePercent / 200;
    dataStore = dataset.components.data = dataset.components.data || (dataset.components.data = []);
    conf.valuePadding = (0, _lib.pluckNumber)(JSONData.valuepadding, chartAttr.valuepadding, 2);
    conf.plotBorderThickness = plotLineThickness;
    conf.showvalues = 1;
    conf.showShadow = (0, _lib.pluckNumber)(chartAttr.showshadow, colorM.getColor(SHOWSHADOW)); // Iterate through all level data

    for (index = 0; index < dataLength; index += 1) {
      // Individual data obj
      // for further manipulation
      setData = dataArr[index];
      dataObj = dataStore[index];

      if (!dataObj) {
        dataObj = dataStore[index] = {};
      }

      !dataObj.config && (dataObj.config = {});
      !dataObj.graphics && (dataObj.graphics = {});
      config = dataObj.config;

      if (setData && !setData.vline) {
        config.setLink = (0, _lib.pluck)(setData.link);
        open = config.open = numberFormatter.getCleanValue(setData.open);
        close = config.close = numberFormatter.getCleanValue(setData.close);
        high = config.high = numberFormatter.getCleanValue(setData.high);
        low = config.low = numberFormatter.getCleanValue(setData.low);
        config.volume = numberFormatter.getCleanValue(setData.volume, true);
        x = config.x = numberFormatter.getCleanValue(setData.x); // openVal = config.openVal = isCandleStick ? Math.abs(close - open) : open;

        config.closeVal = Math.min(open, close);
        config.yVal = Math.max(open, close);
        minValue = Math.min(open, close, high, low);
        maxValue = Math.max(open, close, high, low);
        config.valuePadding = (0, _lib.pluckNumber)(setData.valuepadding, conf.valuePadding); // valueText = parseUnsafeString(getValidValue(setData.valuetext, BLANK));

        setBorderColor = (0, _lib.getFirstColor)((0, _lib.pluck)(setData.bordercolor, close < open ? bearBorderColor : bullBorderColor));
        setAlpha = (0, _lib.pluck)(setData.alpha, conf.lineAlpha);
        setColor = (0, _lib.getFirstColor)((0, _lib.pluck)(setData.color, close < open ? bearFillColor : bullFillColor));
        dashStyle = (0, _lib.pluckNumber)(setData.dashed) ? (0, _lib.getDashStyle)(conf.plotLineDashLen, conf.plotLineDashGap) : 'none';
        config.dashStyle = dashStyle; // Set alpha of the shadow

        pointShadow = {
          opacity: conf.showShadow ? setAlpha / 100 : 0
        };
        config.rawDataColor = setColor;
        config.color = isCandleStick ? setColor : setBorderColor;
        config.alpha = setAlpha;
        config.dashed = (0, _lib.pluckNumber)(conf.plotLineDashed, setData.dashed, 0);
        /*
         * Storing the set level color and set level alpha which is required in drawing of line
         * In line we are checking setColor and setAlpha of current line segment is same as the previous
         * line segment's setColor and setAlpha by accesing config.setColor and config.setAlpha
         */

        config.setColor = config.color;
        config.setAlpha = config.alpha;
        config.anchorImageUrl = (0, _lib.pluck)(setData.anchorimageurl, JSONData.anchorimageurl, chartAttr.anchorimageurl); // Finally add the data
        // we call getPointStub function that manage displayValue, toolText and link

        config.borderColor = setBorderColor;
        config.borderAlpha = config.plotLineAlpha;
        config.colorArr = [{
          color: config.color,
          alpha: config.alpha
        }, {
          color: config.borderColor,
          alpha: config.borderAlpha
        }];
        config.dataLabelStyle = dataset._configureDataLabelStyle(setData);
        config.anchorSides = (0, _lib.pluckNumber)(setData.anchorsides, JSONData.anchorsides, chartAttr.anchorsides);
        config.symbol = (0, _lib.mapSymbolName)(config.anchorSides).split(UNDERSCORE);
        config.anchorProps = {
          enabled: drawAnchors,
          bgColor: setAnchorBgColor,
          symbol: config.symbol,
          bgAlpha: setAnchorBgAlpha * setAnchorAlpha / 100 + BLANK,
          borderColor: setAnchorBorderColor,
          borderAlpha: setAnchorAlpha,
          anchorAlpha: setAnchorAlpha,
          borderThickness: setAnchorBorderThickness,
          imageUrl: config.anchorImageUrl,
          radius: setAnchorRadius,
          imageScale: (0, _lib.pluckNumber)(setData.imagescale, JSONData.imagescale, chartAttr.imagescale, 100),
          imagePadding: (0, _lib.pluckNumber)(setData.anchorimagepadding, JSONData.anchorimagepadding, chartAttr.anchorimagepadding, 1),
          imageAlpha: (0, _lib.pluckNumber)(JSONData.anchorimagealpha, chartAttr.anchorimagealpha, 100),
          startAngle: setAnchorAngle
        };
        config.showValue = setData.displayvalue ? 1 : 0;
        config.hoverEffects = {};
        config.anchorSides = (0, _lib.pluckNumber)(setData.anchorsides, JSONData.anchorsides, chartAttr.anchorsides);
        config.symbol = (0, _lib.mapSymbolName)(config.anchorSides).split(UNDERSCORE);
        config.hoverEffects = {};
        config.y = close;
        config.link = (0, _lib.pluck)(setData.link);
        config.toolText = dataset._parseToolText(index);
        config.toolTipValue = _lib.BLANKSTRING;
        config.setValue = config._y = config.y;
        config.displayValue = (0, _lib.parseUnsafeString)((0, _lib.pluck)(setData.displayvalue, setData.valuetext, BLANK));

        if (minValue !== null) {
          yMax = Math.max(yMax, minValue);
          yMin = Math.min(yMin, minValue);
        }

        if (maxValue !== null) {
          yMax = Math.max(yMax, maxValue);
          yMin = Math.min(yMin, maxValue);
        }

        if (x !== null) {
          xMax = Math.max(xMax, x);
          xMin = Math.min(xMin, x);
        }

        x = x || index + 1;
        config._x = config.x = x;
        config.high = Math.max(open, close, high, low);
        config.low = Math.min(open, close, high, low);
        config.shadow = pointShadow;
      }
    }

    conf.yMax = yMax;
    conf.yMin = yMin;
    conf.xMax = xMax;
    conf.xMin = xMin;
    dataset.setState('dirty', true);
  }
  /**
   * Sets the default value of attributes
   */
  ;

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    _Line.prototype.__setDefaultConfig.call(this);

    this.config.drawLine = 1;
  }
  /**
   * Adds dataset Specific event Arguments
   * @param {Object} _dataObj dataObject
   */
  // eslint-disable-next-line class-methods-use-this
  ;

  _proto.addDatasetSpecificEvtArgs = function addDatasetSpecificEvtArgs(_dataObj) {
    var dataObj = _dataObj,
        config = dataObj.config,
        eventArgs = dataObj.config.eventArgs;
    Object.assign(eventArgs, {
      open: config.open,
      close: config.close,
      high: config.high,
      low: config.low,
      volume: config.volume,
      alpha: config.alpha,
      x: config.x,
      displayValue: config.displayValue,
      color: config.rawDataColor,
      borderColor: config.borderColor,
      dashed: config.dashed
    });
  }
  /**
   * function to Remove data plots if the number of current data plots/categories
   * is more than the existing ones.
   * @param  {Object} datasetJSON JSON for dataset configurations
   */
  ;

  _proto.trimData = function trimData(datasetJSON) {
    if (!this.components && this.components.data && this.components.data.length) {
      return;
    }

    var comps = this.components,
        prevData = comps && comps.data,
        prevDataLength = prevData && prevData.length,
        // eslint-disable-line good-practices/no-single-usage-variable
    data = datasetJSON.data,
        currDataLength = Array.isArray(data) && data.filter(function (v) {
      return v.high || v.open || v.close || v.low;
    }).length || 0,
        // eslint-disable-line good-practices/no-function-dependency
    dataDiff = prevDataLength - currDataLength; // Removing data plots if the number of current data plots
    // is less than the existing ones.

    if (dataDiff > 0) {
      this.removeData(currDataLength, dataDiff, false);
    }
  }
  /**
   * calculate min and max position to scroll
   */
  ;

  _proto.calculateScrollRange = function calculateScrollRange() {
    var dataset = this,
        conf = dataset.config,
        dataLen = dataset.components.data && dataset.components.data.length; // eslint-disable-line good-practices/no-single-usage-variable

    conf.scrollMinVal = conf.scrollMinValForLabel = 0;
    conf.scrollMaxVal = conf.scrollMaxValForLabel = dataLen;
  }
  /**
   * Function to get the maximum and minimum from dataset
   * @return {Object}     contains max, min value
   */
  ;

  _proto.getDataLimits = function getDataLimits() {
    var conf = this.config;
    return {
      max: conf.yMax,
      min: conf.yMin,
      xMax: conf.xMax,
      xMin: conf.xMin
    };
  }
  /**
   * fetches data indices wrt. the x pos value
   * @param {number} x  x pos value
   * @return {Array}    contains indices
   */
  ;

  _proto.getPlotIndices = function getPlotIndices(x) {
    var dataset = this,
        i,
        minX = Math.floor(x),
        // eslint-disable-line good-practices/no-single-usage-variable
    maxX = Math.ceil(x),
        // eslint-disable-line good-practices/no-single-usage-variable
    data,
        returnIndices = [],
        sortedData = dataset.config.JSONData && dataset.config.JSONData.data;

    for (i = sortedData.length; i--;) {
      data = sortedData[i];

      if (data.x >= minX && data.x <= maxX) {
        returnIndices.push(i);
      }
    }

    return returnIndices;
  }
  /**
   * parse tooltext from the dataset json
   * @param {number} i index of data
   * @return {string} tooltext
   */
  ;

  _proto._parseToolText = function _parseToolText(i) {
    return _candlestick._parseToolText.call(this, i);
  }
  /**
   * Function that return the nearest plot details
   * @param   {number} chartXVal x-axis position of the mouse cordinate
   * @param   {number} chartYVal y-axis position of the mouse cordinate
   * @return {Object} return an object with details of nearest plot and whether it is
   *                   hovered or not
   */
  ;

  _proto._getHoveredPlot = function _getHoveredPlot(chartXVal, chartYVal) {
    var dataset = this,
        chartX = chartXVal,
        chartY = chartYVal,
        xAxis = dataset.getFromEnv('xAxis'),
        dataStore = dataset.components.data,
        pointObj,
        pXs,
        xMin,
        xMax,
        returnValue,
        conf = dataset.config,
        i,
        maxRadius = conf && conf.radius || 0; // getting new chart XY accordint to Translation of axis

    chartX += xAxis.getTranslation();
    pXs = dataset.getPlotIndices(Math.floor(Math.max(xAxis.getValue(chartX - maxRadius), 0)));
    xMin = pXs[0];
    pXs = dataset.getPlotIndices(Math.ceil(Math.min(xAxis.getValue(chartX + maxRadius), dataStore.length - 1)));
    xMax = pXs[pXs.length - 1];

    var _ref = xMin > xMax ? [xMax, xMin] : [xMin, xMax];

    xMin = _ref[0];
    xMax = _ref[1];

    for (i = xMax; i >= xMin; i--) {
      pointObj = dataStore[i];

      if (pointObj) {
        returnValue = dataset.isWithinShape(pointObj, i, chartX, chartY);

        if (returnValue) {
          break;
        }
      }
    }

    return returnValue;
  }
  /**
   * Returns the name of the component
   *
   * @return {string} The name of the component
   */
  ;

  _proto.getName = function getName() {
    return 'candlestickline';
  };

  return CandleStickline;
}(_line.default);

var _default = CandleStickline;
exports["default"] = _default;

/***/ }),

/***/ 1408:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;

var _candlestick = _interopRequireDefault(__webpack_require__(1409));

exports.CandleStickDataset = _candlestick.default;

var _candlestickbar = _interopRequireDefault(__webpack_require__(1411));

exports.CandleStickBarDataset = _candlestickbar.default;

var _candlestickline = _interopRequireDefault(__webpack_require__(1413));

exports.CandleStickLineDataset = _candlestickline.default;

var _volume = _interopRequireDefault(__webpack_require__(1414));

exports.VolumeDataset = _volume.default;

var _trendset = _interopRequireDefault(__webpack_require__(1415));

exports.TrendSet = _trendset.default;

/***/ }),

/***/ 1416:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _index = _interopRequireDefault(__webpack_require__(619));

var _default = {
  'initial.trendset.trendset': _index.default['initial.dataset.line']
};
exports["default"] = _default;

/***/ }),

/***/ 1415:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _line = _interopRequireDefault(__webpack_require__(616));

var _lib = __webpack_require__(274);

var _dependencyManager = __webpack_require__(282);

var _trendset = _interopRequireDefault(__webpack_require__(1416));

/* eslint require-jsdoc: 'error', valid-jsdoc: ["error", { "requireReturn": false }] */
var HUNDRED = '100',
    // The default value for stroke-dash attribute
DASH_DEF = 'none';
(0, _dependencyManager.addDep)({
  name: 'trendsetAnimation',
  type: 'animationRule',
  extension: _trendset.default
});
/**
 * Class def for bull candles chart API
 * This dataset is reponsible for drawing candle depending on open and close value
 */

var Trendset = /*#__PURE__*/function (_Line) {
  (0, _inheritsLoose2.default)(Trendset, _Line);

  function Trendset() {
    return _Line.apply(this, arguments) || this;
  }

  var _proto = Trendset.prototype;

  /**
   * Sets the default value of drawLine to 1. This enables trendset component to draw the line.
   *
   * @memberof Trendset
   */
  _proto.__setDefaultConfig = function __setDefaultConfig() {
    _Line.prototype.__setDefaultConfig.call(this);

    this.config.drawLine = 1;
  }
  /**
    * Function for parsing all the attributes and value given by the user at chart,dataset and set level.
    * This function is called once from the init() function of the Column class.
    * @param  {Object} datasetJSON JSON for dataset configurations
    * @return {boolean} Indicates whether the configuration was successful or not
    */
  ;

  _proto.configureAttributes = function configureAttributes(datasetJSON) {
    if (!datasetJSON) {
      return false;
    }

    this.trimData(datasetJSON);
    this.config.JSONData = datasetJSON;
    var dataset = this,
        chartAttr = dataset.getFromEnv('chart-attrib'),
        trendset = dataset.config.JSONData,
        index = dataset.index,
        setDataArr = trendset.data || trendset.set || [],
        conf = dataset.config,
        dataObj,
        itemValue,
        dataStore = dataset.components.data,
        dataStoreObj,
        config,
        maxValue = -Infinity,
        minValue = +Infinity,
        x,
        length,
        xMax = -Infinity,
        xMin = +Infinity,
        NumberFormatter = dataset.getFromEnv('number-formatter'),
        // Trend-sets default properties
    trendSetColor = (0, _lib.getFirstColor)((0, _lib.pluck)(trendset.color, chartAttr.trendsetcolor, '666666')),
        // eslint-disable-line good-practices/no-single-usage-variable
    trendSetAlpha = (0, _lib.pluck)(trendset.alpha, chartAttr.trendsetalpha, HUNDRED),
        // eslint-disable-line good-practices/no-single-usage-variable
    trendSetThickness = (0, _lib.pluckNumber)(trendset.thickness, chartAttr.trendsetthickness, 2),
        // eslint-disable-line good-practices/no-single-usage-variable
    trendSetDashed = Boolean((0, _lib.pluckNumber)(trendset.dashed, chartAttr.trendsetdashed, 0)),
        // eslint-disable-line good-practices/no-single-usage-variable
    trendSetDashLen = (0, _lib.pluckNumber)(trendset.dashlen, chartAttr.trendsetdashlen, 4),
        // eslint-disable-line good-practices/no-single-usage-variable
    trendSetDashGap = (0, _lib.pluckNumber)(trendset.dashgap, chartAttr.trendsetdashgap, 4); // eslint-disable-line good-practices/no-single-usage-variable

    conf.includeInLegend = (0, _lib.pluckNumber)(trendset.includeinlegend, 1);
    conf.lineColor = trendSetColor;
    conf.lineAlpha = trendSetAlpha;
    conf.connectNullData = (0, _lib.pluckNumber)(chartAttr.connectnulldata, 0);
    conf.linethickness = trendSetThickness;
    conf.lineDashStyle = trendSetDashed ? (0, _lib.getDashStyle)(trendSetDashLen, trendSetDashGap) : DASH_DEF;
    conf.name = (0, _lib.getValidValue)(trendset.name);
    conf.includeInLegend = (0, _lib.pluckNumber)(trendset.includeinlegend, 1);
    conf.defaultPadding = {
      left: 0.5,
      right: 0.5
    };

    if (!dataStore) {
      dataStore = dataset.components.data = [];
    }

    for (index = 0, length = setDataArr.length; index < length; index += 1) {
      // eslint-disable-line good-practices/no-single-usage-variable
      dataObj = setDataArr[index];

      if (dataObj && !dataObj.vline) {
        dataStoreObj = dataStore[index] = dataStore[index] || (dataStore[index] = {});
        config = dataStoreObj.config = dataStoreObj.config || (dataStoreObj.config = {});
        itemValue = config._y = config.setValue = NumberFormatter.getCleanValue(dataObj.value);
        config.setColor = conf.lineColor;
        config.setAlpha = conf.lineAlpha;
        x = NumberFormatter.getCleanValue(dataObj.x);
        x = config._x = config.x = x !== null ? x : index + 1;
        maxValue = Math.max(maxValue, itemValue);
        minValue = Math.min(minValue, itemValue);
        xMin = Math.min(xMin, x);
        xMax = Math.max(xMax, x); // Parsing the anchor properties for set level

        config.anchorProps = this._parseAnchorProperties(index);
        config.hoverEffects = {};

        if (!dataStoreObj.graphics) {
          dataStoreObj.graphics = {};
        }
      }
    }

    conf.max = maxValue;
    conf.min = minValue;
    conf.xMax = xMax;
    conf.xMin = xMin;
    dataset.getFromEnv('chartConfig').showLegend && dataset._addLegend();
    dataset.setState('visible', true);
    dataset.setState('dirty', true);
  }
  /**
   * Function to register datasets in the internal data store of legend class.
   */
  ;

  _proto._addLegend = function _addLegend() {
    var dataset = this,
        conf = dataset.config,
        legendItem,
        legend = dataset.getFromEnv('legend');

    if (conf.includeinlegend) {
      legendItem = legend.getItem(dataset.config.legendItemId);

      if (!legendItem) {
        dataset.config.legendItemId = legend.createItem(dataset);
        legendItem = legend.getItem(dataset.config.legendItemId);
      } else {
        legendItem.configure({
          style: legend.config.itemStyle,
          hiddenStyle: legend.config.itemHiddenStyle,
          datasetVisible: legend.config.datasetVisible,
          hoverStyle: legend.config.itemHoverStyle
        });
      }

      legendItem.configure({
        enabled: conf.includeInLegend,
        interactiveLegend: false,
        type: dataset.type,
        drawLine: true,
        label: (0, _lib.getFirstValue)(dataset.config.JSONData.name)
      });
      legendItem.setStateCosmetics('default', {
        symbol: {
          stroke: (0, _lib.toRaphaelColor)({
            color: conf.lineColor,
            alpha: HUNDRED
          }),
          rawFillColor: conf.lineColor
        }
      });
    } else if (dataset.config.legendItemId) {
      legend.disposeItem(dataset.config.legendItemId);
    }
  }
  /**
   * Function to get the maximum and minimum from dataset
   * @return {Object}     contains max, min value
   */
  ;

  _proto.getDataLimits = function getDataLimits() {
    var conf = this.config;
    return {
      max: conf.max,
      min: conf.min,
      xMax: conf.xMax,
      xMin: conf.xMin
    };
  }
  /**
   * Sets the type of the component
   * @return {string} type
   */
  ;

  _proto.getType = function getType() {
    return 'trendset';
  }
  /**
    * This function overrides drawlabel method
    * it prevents the label drawing
    */
  // eslint-disable-next-line
  ;

  _proto.drawLabel = function drawLabel() {}
  /**
   * Sets the name of the component
   * @return {string} name
   */
  ;

  _proto.getName = function getName() {
    return 'trendset';
  };

  return Trendset;
}(_line.default);

var _default = Trendset;
exports["default"] = _default;

/***/ }),

/***/ 1414:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _column = _interopRequireDefault(__webpack_require__(595));

var _lib = __webpack_require__(274);

var _candlestick = __webpack_require__(1409);

/* eslint require-jsdoc: 'error', valid-jsdoc: ["error", { "requireReturn": false }] */
var colorStrings = _lib.preDefStr.colors,
    COLOR_B90000 = colorStrings.B90000,
    DASH_DEF = 'none',
    SHOWSHADOW = 'showShadow',
    COLOR_FFFFFF = colorStrings.FFFFFF;
/**
 * Class def for bull candles chart API
 * This dataset is reponsible for drawing candle depending on open and close value
 */

var Volume = /*#__PURE__*/function (_Column) {
  (0, _inheritsLoose2.default)(Volume, _Column);

  function Volume() {
    return _Column.apply(this, arguments) || this;
  }

  var _proto = Volume.prototype;

  /**
    * Function for parsing all the attributes and value given by the user at chart,dataset and set level.
    * This function is called once from the init() function of the Column class.
    * @param  {Object} datasetJSON JSON for dataset configurations
    * @return {boolean} Indicates whether the configuration was successful or not
    */
  _proto.configureAttributes = function configureAttributes(datasetJSON) {
    if (!datasetJSON) {
      return false;
    }

    this.trimData(datasetJSON);
    this.config.JSONData = datasetJSON;
    var dataset = this,
        conf = dataset.config,
        JSONData = dataset.config.JSONData,
        dataArr = JSONData.data || [],
        chartAttr = dataset.getFromEnv('chart-attrib'),
        chartConfig = dataset.getFromEnv('chartConfig'),
        dataLength = dataArr.length,
        // eslint-disable-line good-practices/no-single-usage-variable
    colorM = dataset.getFromEnv('color-manager'),
        setColor,
        setAlpha,
        pointShadow,
        index,
        dataObj,
        open,
        close,
        volume,
        x,
        borderAlpha,
        numberFormatterAttrs,
        plotLineDashLen,
        plotLineDashGap,
        // Candle stick properties.
    // Bear fill and border color - (Close lower than open)
    bearBorderColor = conf.bearBorderColor = // eslint-disable-line good-practices/no-single-usage-variable
    (0, _lib.getFirstColor)((0, _lib.pluck)(chartAttr.bearbordercolor, chartConfig.vplotbordercolor, COLOR_B90000)),
        bearFillColor = conf.bearFillColor = // eslint-disable-line good-practices/no-single-usage-variable
    (0, _lib.getFirstColor)((0, _lib.pluck)(chartAttr.bearfillcolor, COLOR_B90000)),
        // Bull fill and border color - Close higher than open
    bullBorderColor = conf.bullBorderColor = // eslint-disable-line good-practices/no-single-usage-variable
    (0, _lib.getFirstColor)((0, _lib.pluck)(chartAttr.bullbordercolor, chartConfig.vplotbordercolor, colorM.getColor('canvasBorderColor'))),
        bullFillColor = conf.bullFillColor = // eslint-disable-line good-practices/no-single-usage-variable
    (0, _lib.getFirstColor)((0, _lib.pluck)(chartAttr.bullfillcolor, COLOR_FFFFFF)),
        showVPlotBorder = (0, _lib.pluckNumber)(chartConfig.showplotborder, 1),
        // eslint-disable-line good-practices/no-single-usage-variable
    // VPlotBorder is border properties for the volume chart.
    vPlotBorderThickness = showVPlotBorder ? (0, _lib.pluckNumber)(chartAttr.vplotborderthickness, 1) : 0,
        dataStore,
        setData,
        config,
        plotSpacePercent,
        numberFormatter = dataset.getFromEnv('number-formatter'),
        yMax = -Infinity,
        yMin = +Infinity,
        xMax = -Infinity,
        xMin = +Infinity;
    dataset.setState('visible', (0, _lib.pluckNumber)(JSONData.visible, 1) === 1);

    if (dataset.getState('visible') === true) {
      dataset._conatinerHidden = false;
    } else {
      dataset._containerHidden = true;
    }

    conf.minAbsNonZeroValue = Infinity;
    conf.minAbsNonZeroData = {};
    conf.parentYAxis = 1;
    conf.volumeToolText = (0, _lib.getValidValue)((0, _lib.parseUnsafeString)((0, _lib.pluck)(JSONData.volumetooltext, chartAttr.volumetooltext, chartAttr.plottooltext), false)); // Dataset seriesname

    conf.name = (0, _lib.getValidValue)(JSONData.seriesname);
    conf.showTooltip = (0, _lib.pluckNumber)(chartAttr.showtooltip, 1);
    conf.showShadow = (0, _lib.pluckNumber)(chartAttr.showshadow, colorM.getColor(SHOWSHADOW));
    conf.maxColWidth = Math.abs((0, _lib.pluckNumber)((0, _lib.pluck)(chartAttr.maxcolwidth), 50)) || 1;
    plotSpacePercent = Math.max((0, _lib.pluckNumber)(chartAttr.plotspacepercent, 20) % 100, 0); // eslint-disable-line good-practices/no-single-usage-variable

    conf.plotSpacePercent = conf.groupPadding = plotSpacePercent / 200;
    conf.plotborderthickness = vPlotBorderThickness;
    dataStore = dataset.components.data = dataset.components.data || (dataset.components.data = []);
    numberFormatterAttrs = (0, _lib.extend2)((0, _lib.extend2)({}, chartAttr), {
      // eslint-disable-line good-practices/no-single-usage-variable
      sforcedecimals: (0, _lib.getFirstValue)(chartAttr.forcevdecimals, chartAttr.forcedecimals),
      sforceyaxisvaluedecimals: (0, _lib.getFirstValue)(chartAttr.forcevyaxisvaluedecimals, chartAttr.forceyaxisvaluedecimals),
      syaxisvaluedecimals: (0, _lib.getFirstValue)(chartAttr.vyaxisvaluedecimals, chartAttr.yaxisvaluedecimals),
      sformatnumber: (0, _lib.getFirstValue)(chartAttr.vformatnumber, chartAttr.formatnumber),
      sformatnumberscale: (0, _lib.getFirstValue)(chartAttr.vformatnumberscale, chartAttr.formatnumberscale, '1'),
      sdefaultnumberscale: (0, _lib.getFirstValue)(chartAttr.vdefaultnumberscale, chartAttr.defaultnumberscale),
      snumberscaleunit: (0, _lib.getFirstValue)(chartAttr.vnumberscaleunit, chartAttr.numberscaleunit),
      vnumberscalevalue: (0, _lib.getFirstValue)(chartAttr.vnumberscalevalue, chartAttr.numberscalevalue),
      sscalerecursively: (0, _lib.getFirstValue)(chartAttr.vscalerecursively, chartAttr.scalerecursively),
      smaxscalerecursion: (0, _lib.getFirstValue)(chartAttr.vmaxscalerecursion, chartAttr.maxscalerecursion),
      sscaleseparator: (0, _lib.getFirstValue)(chartAttr.vscaleseparator, chartAttr.scaleseparator),
      snumberprefix: (0, _lib.getFirstValue)(chartAttr.vnumberprefix, chartAttr.numberprefix),
      snumbersuffix: (0, _lib.getFirstValue)(chartAttr.vnumbersuffix, chartAttr.numbersuffix),
      sdecimals: (0, _lib.getFirstValue)(chartAttr.vdecimals, chartAttr.decimals)
    });
    plotLineDashLen = conf.plotLineDashLen = (0, _lib.pluckNumber)(chartAttr.plotlinedashlen, 5); // eslint-disable-line good-practices/no-single-usage-variable

    plotLineDashGap = conf.plotLineDashGap = (0, _lib.pluckNumber)(chartAttr.plotlinedashgap, 4); // eslint-disable-line good-practices/no-single-usage-variable

    dataset.getFromEnv('number-formatter').configure(numberFormatterAttrs); // Iterate through all level data

    for (index = 0; index < dataLength; index += 1) {
      // Individual data obj
      // for further manipulation
      setData = dataArr[index];
      dataObj = dataStore[index];

      if (!dataObj) {
        dataObj = dataStore[index] = {};
      }

      !dataObj.config && (dataObj.config = {});
      !dataObj.graphics && (dataObj.graphics = {});
      config = dataObj.config;

      if (setData && !setData.vline) {
        open = config.open = numberFormatter.getCleanValue(setData.open);
        close = config.close = numberFormatter.getCleanValue(setData.close);
        volume = config.volume = numberFormatter.getCleanValue(setData.volume, true);
        config.high = numberFormatter.getCleanValue(setData.high);
        config.low = numberFormatter.getCleanValue(setData.low);
        x = config.x = numberFormatter.getCleanValue(setData.x);
        yMax = Math.max(yMax, volume);
        yMin = Math.min(yMin, volume);
        xMax = Math.max(xMax, x);
        xMin = Math.min(xMin, x); // valueText = parseUnsafeString(getValidValue(setData.valuetext, BLANK));

        config.borderColor = (0, _lib.getFirstColor)((0, _lib.pluck)(setData.bordercolor, close < open ? bearBorderColor : bullBorderColor));
        setAlpha = (0, _lib.pluckNumber)(setData.alpha, 100);
        borderAlpha = (0, _lib.pluckNumber)(chartConfig.vplotborderalpha, setData.alpha, 100);
        setColor = (0, _lib.getFirstColor)((0, _lib.pluck)(setData.color, close < open ? bearFillColor : bullFillColor)); // Set alpha of the shadow

        pointShadow = {
          opacity: conf.showShadow ? setAlpha / 100 : 0
        };
        config.color = setColor;
        config.alpha = setAlpha;
        config.setLink = setData.link;
        config.borderWidth = vPlotBorderThickness;
        config.borderAlpha = borderAlpha;
        config.y = volume;
        config.colorArr = [{
          color: config.color,
          alpha: config.alpha
        }, {
          color: config.borderColor,
          alpha: config.borderAlpha
        }];
        config.toolText = dataset._parseToolText(index);
        config.toolTipValue = _lib.BLANKSTRING;
        config.setValue = config._y = config.y;

        if (volume !== 0 && conf.minAbsNonZeroValue > Math.abs(volume)) {
          conf.minAbsNonZeroValue = Math.abs(volume);
          conf.minAbsNonZeroData = config;
        }

        config.dashed = (0, _lib.pluckNumber)(conf.plotLineDashed, setData.dashed, 0);
        config.plotBorderDashStyle = (0, _lib.pluckNumber)(setData.dashed) ? (0, _lib.getDashStyle)(plotLineDashLen, plotLineDashGap) : DASH_DEF;
        x = x !== null ? x : index + 1;
        config._x = x;
        config.shadow = pointShadow;
      }
    }

    conf.defaultPadding = {
      left: 0,
      right: 0
    };
    conf.yMax = yMax;
    conf.yMin = yMin;
    conf.xMax = xMax;
    conf.xMin = xMin;
    dataset.setState('dirty', true);
  }
  /**
   * parse tooltext from the dataset json
   * @param {number} i index of data
   * @return {string} tooltext
   */
  ;

  _proto._parseToolText = function _parseToolText(i) {
    return _candlestick._parseToolText.call(this, i);
  }
  /**
   * fetches data indices wrt. the x pos value
   * @param {number} x  x pos value
   * @return {Array}    contains indices
   */
  ;

  _proto.getPlotIndices = function getPlotIndices(x) {
    var dataset = this,
        i,
        minX = Math.floor(x),
        // eslint-disable-line good-practices/no-single-usage-variable
    maxX = Math.ceil(x),
        // eslint-disable-line good-practices/no-single-usage-variable
    data,
        returnIndices = [],
        sortedData = dataset.config.JSONData && dataset.config.JSONData.data;

    for (i = sortedData.length; i--;) {
      data = sortedData[i];

      if (data.x >= minX && data.x <= maxX) {
        returnIndices.push(i);
      }
    }

    return returnIndices;
  }
  /**
   * Function that retunr the nearest plot details
   * @param {number} chartXVal x-axis position of the mouse cordinate
   * @param {number} chartYVal x-axis position of the mouse cordinate
   * @return {Object} return an object with details of nearest polt and whether it is hovered or not
   */
  ;

  _proto._getHoveredPlot = function _getHoveredPlot(chartXVal, chartYVal) {
    var dataset = this,
        chartX = chartXVal,
        chartY = chartYVal,
        xAxis = dataset.getFromEnv('xAxis'),
        x,
        i,
        hoveredInfo,
        pXs,
        pX;
    chartX += xAxis.getTranslation();
    x = xAxis.getValue(chartX);
    pXs = dataset.getPlotIndices(x); // Checking for overlap between two cosecutive column plots along x-axis

    for (i = pXs.length - 1; i > -1; i--) {
      pX = pXs[i];
      hoveredInfo = pX - x > 0 ? dataset._checkPointerOverColumn(pX, chartX, chartY) || dataset._checkPointerOverColumn(pX - 1, chartX, chartY) : dataset._checkPointerOverColumn(pX + 1, chartX, chartY) || dataset._checkPointerOverColumn(pX, chartX, chartY);

      if (hoveredInfo) {
        break;
      }
    }

    return hoveredInfo;
  }
  /**
   * Function to get the maximum and minimum from dataset
   * @return {Object}     contains max, min value
   */
  ;

  _proto.getDataLimits = function getDataLimits() {
    var conf = this.config;
    return {
      max: conf.yMax,
      min: conf.yMin,
      xMax: conf.xMax,
      xMin: conf.xMin
    };
  }
  /**
   * Adds dataset Specific event Arguments
   * @param {Object} _dataObj dataObject
   */
  // eslint-disable-next-line class-methods-use-this
  ;

  _proto.addDatasetSpecificEvtArgs = function addDatasetSpecificEvtArgs(_dataObj) {
    var dataObj = _dataObj,
        config = dataObj.config,
        trackerConfig = dataObj.trackerConfig,
        eventArgs = trackerConfig.eventArgs;
    Object.assign(eventArgs, {
      open: config.open,
      close: config.close,
      high: config.high,
      low: config.low,
      volume: config.volume,
      alpha: config.alpha,
      x: config.x,
      displayValue: config.displayValue,
      color: config.color,
      borderColor: config.borderColor,
      dashed: config.dashed
    });
  }
  /**
   * calculate min and max position to scroll
   */
  ;

  _proto.calculateScrollRange = function calculateScrollRange() {
    var dataset = this,
        conf = dataset.config;
    conf.scrollMinVal = 0;
    conf.scrollMaxVal = dataset.components.data && dataset.components.data.length; // Since panning and data skipping are not applicable for scatter and bubble charts, the labels'
    // minimum and maximum index to be drawn is the same as the plots' minimum and maximum index.

    conf.scrollMinValForLabel = conf.scrollMinVal;
    conf.scrollMaxValForLabel = conf.scrollMaxVal;
  }
  /**
    * This function overrides drawlabel method
    * it prevents the label drawing
    */
  // eslint-disable-next-line
  ;

  _proto.drawLabel = function drawLabel() {}
  /**
   * Returns the name of the component
   *
   * @return {string} The name of the component
   */
  ;

  _proto.getName = function getName() {
    return 'volume';
  };

  return Volume;
}(_column.default);

var _default = Volume;
exports["default"] = _default;

/***/ }),

/***/ 1467:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _defineProperty2 = _interopRequireDefault(__webpack_require__(273));

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _componentInterface = __webpack_require__(290);

var _chordNodeFactory = _interopRequireDefault(__webpack_require__(1468));

var _chordLinkFactory = _interopRequireDefault(__webpack_require__(1471));

var _lib = __webpack_require__(274);

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var comparator = function comparator(a, b) {
  return a - b;
};

var NodeLinkManager = /*#__PURE__*/function (_SmartRenderer) {
  (0, _inheritsLoose2.default)(NodeLinkManager, _SmartRenderer);

  function NodeLinkManager(id) {
    var _this;

    _this = _SmartRenderer.call(this, id) || this;

    _this.registerFactory('chord-node-factory', _chordNodeFactory.default);

    _this.registerFactory('chord-link-factory', _chordLinkFactory.default);

    return _this;
  }

  var _proto = NodeLinkManager.prototype;

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    _SmartRenderer.prototype.__setDefaultConfig.call(this);

    var config = this.config;
    config.total = 0;
    config.adjustedTotal = 0;
  };

  _proto.configureAttributes = function configureAttributes(dataObj) {
    _SmartRenderer.prototype.configureAttributes.call(this, dataObj);

    Object.assign(this.config, dataObj);
    var manager = this,
        config = manager.config,
        total,
        totalAngle = config.totalAngle,
        startingAngle = config.startingAngle,
        nodesOrder = config.nodesOrder,
        nodes = config.nodes,
        linksOrder = config.linksOrder,
        links = config.links;
    totalAngle -= config.nodeSpacing * nodesOrder.length;
    total = config.total = nodesOrder.reduce(function (acc, label) {
      return acc + nodes[label].total;
    }, 0);
    config.adjustedTotal = nodesOrder.reduce(function (acc, label) {
      var node = nodes[label];

      if (node.total / (total || 1) < config.minNodeSize) {
        node.adjustedTotal = (total || 1) * config.minNodeSize;
      } else {
        node.adjustedTotal = node.total;
      }

      return acc + node.adjustedTotal;
    }, 0);
    config.interactiveLegend = (0, _lib.pluckNumber)(manager.getFromEnv('chart-attrib').interactivelegend, 1);
    var angleRatio = totalAngle / config.adjustedTotal;
    nodesOrder.forEach(function (label) {
      var node = nodes[label];
      node.startingAngle = startingAngle;
      node.arcAngle = node.adjustedTotal * angleRatio;
      node.endingAngle = startingAngle + node.arcAngle;
      node.scale.setRange([node.startingAngle, node.endingAngle]).setDomain([0, node.adjustedTotal]);
      startingAngle = node.endingAngle + config.nodeSpacing;
    });
    linksOrder.forEach(function (key) {
      if (links[key].visible) {
        var link = links[key],
            from = config.isPost ? link.linkedNodes[1] : link.linkedNodes[0],
            to = config.isPost ? link.linkedNodes[0] : link.linkedNodes[1],
            firstNode = nodes[from],
            secondNode = nodes[to],
            firstScale = firstNode.scale,
            secondScale = secondNode.scale,
            p1 = firstScale.getRangeValue(firstNode.nodeCovered),
            p2 = firstScale.getRangeValue(firstNode.nodeCovered += link[from] || 0),
            p3,
            p4;

        if (link.points.length) {
          link.points.length = 0;
        }

        if (from === to) {
          p3 = p1;
          p4 = p2;
        } else {
          p3 = secondScale.getRangeValue(secondNode.nodeCovered);
          p4 = secondScale.getRangeValue(secondNode.nodeCovered += link[to] || 0);
        }

        link.points.push(p1, p2, p3, p4);
      }
    }); // Parse link cosmetics

    linksOrder.forEach(function (key) {
      var link = links[key],
          dominantNode = link.dominantNode;
      link.angles = link.points.slice(0).sort(comparator);

      if (dominantNode.length > 1 && nodes[dominantNode[0]].rawColor !== nodes[dominantNode[1]].rawColor) {
        var linkArray = nodes[dominantNode[0]].index > nodes[dominantNode[1]].index ? [nodes[dominantNode[1]], nodes[dominantNode[0]]] : [nodes[dominantNode[0]], nodes[dominantNode[1]]];
        link.rawColor = [linkArray[0].rawColor, linkArray[1].rawColor];
      } else {
        link.normalState.fill = (0, _lib.convertColor)(nodes[dominantNode[0]].rawColor, link.alpha);
        link.normalState.stroke = (0, _lib.convertColor)(nodes[dominantNode[0]].rawColor, link.borderAlpha);
        link.focussedState.fill = (0, _lib.convertColor)(nodes[dominantNode[0]].rawColor, link.hoverAlpha);
        link.focussedState.stroke = link.focussedState.fill;
        link.unfocussedState.fill = (0, _lib.convertColor)(nodes[dominantNode[0]].rawColor, link.unfocussedAlpha);
        link.unfocussedState.stroke = link.unfocussedState.fill;
      }
    });
  };

  _proto.setDimension = function setDimension(dim) {
    var manager = this,
        config = manager.config;
    Object.assign(config, dim);
    manager.getChildren('node') && manager.getChildren('node').forEach(function (node) {
      return !node.getState('removed') && node.setDimension({
        outerRadius: config.nodeOuterRadius,
        innerRadius: config.nodeInnerRadius
      });
    });
    manager.getChildren('ribbon') && manager.getChildren('ribbon').forEach(function (link) {
      return !link.getState('removed') && link.setDimension({
        radius: config.ribbonRadius
      });
    });
  };

  _proto._manageSpace = function _manageSpace(spaceArguments) {
    var manager = this,
        widths = manager.getChildren('node').map(function (node) {
      return node._manageSpace(spaceArguments);
    }),
        maxWidth = Math.max.apply(Math, widths);
    return {
      width: maxWidth,
      height: maxWidth
    };
  };

  _proto._createContainer = function _createContainer() {
    var manager = this,
        config = manager.config;
    manager.addGraphicalElement({
      el: 'group',
      container: {
        id: 'plotGroup',
        isParent: true
      },
      component: manager,
      label: 'link-container',
      id: 'link-container',
      attr: {
        name: 'link-container',
        transform: config.translate
      }
    });
    manager.addGraphicalElement({
      el: 'group',
      container: {
        id: 'plotGroup',
        isParent: true
      },
      component: manager,
      label: 'node-container',
      id: 'node-container',
      attr: _objectSpread({
        name: 'node-container',
        transform: config.translate
      }, config.datalabelStyle)
    });
  };

  _proto.draw = function draw() {
    this._createContainer();
  };

  _proto.getName = function getName() {
    return 'node-link-manager';
  };

  _proto.getType = function getType() {
    return 'node-link-manager';
  };

  _proto._addLegend = function _addLegend() {
    var manager = this,
        config = manager.config,
        nodes = config.nodes,
        nodesOrder = config.nodesOrder,
        legend = manager.getFromEnv('legend'),
        legendItem,
        legendItemId,
        legendItemMap = config.legendItemMap || (config.legendItemMap = {}),
        curLegendItems = new Set();
    Object.keys(legendItemMap).forEach(function (key) {
      return curLegendItems.add(legendItemMap[key]);
    });
    nodesOrder.forEach(function (label) {
      var node = nodes[label];
      legendItemId = legendItemMap[label];
      legendItem = legend.getItem(legendItemId);

      if (!legendItem) {
        legendItemId = legend.createItem();
        legendItem = legend.getItem(legendItemId);
        legendItemMap[label] = legendItemId;
        manager.addExtEventListener('fc-click', function () {
          if (manager.config.interactiveLegend) {
            var clickedNode = manager.config.nodes[label],
                item = legend.getItem(legendItemMap[label]);
            manager.nodeClicked(clickedNode.label, item);
          }
        }, legendItem);
        manager.addExtEventListener('fc-mouseover', function () {
          if (manager.config.interactiveLegend) {
            manager.nodeHoverIn(label);
          }
        }, legendItem);
        manager.addExtEventListener('fc-mouseout', function () {
          if (manager.config.interactiveLegend) {
            manager.nodeHoverOut(label);
          }
        }, legendItem);
      } else {
        legendItem.removeLegendState('hidden');
        curLegendItems['delete'](legendItemId);
      }

      legendItem.configure({
        enabled: true,
        label: label
      });
      legendItem.setStateCosmetics('default', {
        symbol: {
          rawFillColor: node.color,
          rawStrokeColor: node.color,
          fill: node.color,
          stroke: node.color
        }
      });
    });
    curLegendItems.forEach(function (item) {
      legend.disposeItem(item);
    });
  };

  _proto.nodeClicked = function nodeClicked(clickedNodeLabel, legendItem) {
    if (this.config.enableToggle) {
      var config = this.config,
          nodes = config.nodes,
          nodesOrder = config.nodesOrder,
          links = config.links,
          clickedNode = nodes[clickedNodeLabel],
          linkedLinks = clickedNode.linkedLinks,
          isActive = clickedNode.active;

      if (clickedNode.active) {
        legendItem && legendItem.setLegendState('hidden');
      } else {
        legendItem && legendItem.removeLegendState('hidden');
      }

      clickedNode.active = !isActive;
      linkedLinks.forEach(function (key) {
        var link = links[key],
            from = config.isPost ? link.linkedNodes[1] : link.linkedNodes[0],
            to = config.isPost ? link.linkedNodes[0] : link.linkedNodes[1],
            fromNode = nodes[from],
            toNode = nodes[to],
            isVisisble = link.visible;
        link.visible = fromNode.active && toNode.active;

        if (link.visible !== isVisisble) {
          if (link.visible) {
            fromNode.total = (0, _lib.toPrecision)(fromNode.total + (link[from] || 0), 4);

            if (to !== from) {
              toNode.total = (0, _lib.toPrecision)(toNode.total + (link[to] || 0), 4);
            }
          } else {
            fromNode.total = (0, _lib.toPrecision)(fromNode.total - (link[from] || 0), 4);

            if (to !== from) {
              toNode.total = (0, _lib.toPrecision)(toNode.total - (link[to] || 0), 4);
            }
          }
        }
      });
      nodesOrder.forEach(function (label) {
        return nodes[label].nodeCovered = 0;
      });

      if (isActive) {
        this.nodeHoverOut(clickedNodeLabel, false);
      } else {
        this.nodeHoverIn(clickedNodeLabel, false);
      }

      this.setData({}, true);
      this.setDimension();
    }
  };

  _proto.linkHoverIn = function linkHoverIn(linkKey, registerDraw) {
    if (registerDraw === void 0) {
      registerDraw = true;
    }

    if (this.config.highlightEffect) {
      var manager = this,
          config = manager.config,
          links = config.links,
          nodes = config.nodes,
          nodesOrder = config.nodesOrder,
          linksOrder = config.linksOrder,
          hoveredLink = links[linkKey],
          hoveredNodes = hoveredLink.linkedNodes;
      nodesOrder.forEach(function (label) {
        var node = nodes[label],
            child = manager.getChild(label);

        if (!child || child.getState('removed')) {
          return;
        }

        if (hoveredNodes.includes(label)) {
          node.hovered = true;
          node.unfocussed = false;
        } else {
          node.hovered = false;
          node.unfocussed = true;
        }

        registerDraw && child.setData({
          hovered: node.hovered,
          unfocussed: node.unfocussed
        }, true);
      });
      linksOrder.forEach(function (key) {
        var link = links[key],
            child = manager.getChild(key);

        if (!child || child.getState('removed')) {
          return;
        }

        if (key === linkKey) {
          link.hovered = true;
          link.unfocussed = false;
        } else {
          link.hovered = false;
          link.unfocussed = true;
        }

        registerDraw && child.setData({
          hovered: link.hovered,
          unfocussed: link.unfocussed
        }, true);
      });
      registerDraw && this.setDimension();
    }
  };

  _proto.resetEffect = function resetEffect(registerDraw) {
    if (registerDraw === void 0) {
      registerDraw = true;
    }

    var manager = this,
        config = manager.config,
        links = config.links,
        nodes = config.nodes,
        nodesOrder = config.nodesOrder,
        linksOrder = config.linksOrder;
    nodesOrder.forEach(function (label) {
      var node = nodes[label],
          child = manager.getChild(label);

      if (!child || child.getState('removed')) {
        return;
      }

      node.hovered = false;
      node.unfocussed = false;
      registerDraw && child.setData({
        hovered: node.hovered,
        unfocussed: node.unfocussed
      }, true);
    });
    linksOrder.forEach(function (key) {
      var link = links[key],
          child = manager.getChild(key);

      if (!child || child.getState('removed')) {
        return;
      }

      link.hovered = false;
      link.unfocussed = false;
      registerDraw && child.setData({
        hovered: link.hovered,
        unfocussed: link.unfocussed
      }, true);
    });
    this.setDimension();
  };

  _proto.linkHoverOut = function linkHoverOut(linkKey, registerDraw) {
    if (registerDraw === void 0) {
      registerDraw = true;
    }

    if (this.config.highlightEffect) {
      this.resetEffect(registerDraw);
    }
  };

  _proto.nodeHoverIn = function nodeHoverIn(labelKey, registerDraw) {
    if (registerDraw === void 0) {
      registerDraw = true;
    }

    if (this.config.highlightEffect) {
      var manager = this,
          config = manager.config,
          links = config.links,
          nodes = config.nodes,
          nodesOrder = config.nodesOrder,
          linksOrder = config.linksOrder,
          hoveredNode = nodes[labelKey],
          hoveredLinks = hoveredNode.linkedLinks,
          affectedNodes = hoveredLinks.map(function (key) {
        return links[key].linkedNodes[0] === labelKey ? links[key].linkedNodes[1] : links[key].linkedNodes[0];
      });
      affectedNodes.push(labelKey);
      nodesOrder.forEach(function (label) {
        var node = nodes[label],
            child = manager.getChild(label);

        if (!child || child.getState('removed')) {
          return;
        }

        if (affectedNodes.includes(label)) {
          node.hovered = true;
          node.unfocussed = false;
        } else {
          node.hovered = false;
          node.unfocussed = true;
        }

        registerDraw && hoveredNode.active && child.setData({
          hovered: node.hovered,
          unfocussed: node.unfocussed
        }, true);
      });
      linksOrder.forEach(function (key) {
        var link = links[key],
            child = manager.getChild(key);

        if (!child || child.getState('removed')) {
          return;
        }

        if (hoveredLinks.includes(key)) {
          link.hovered = true;
          link.unfocussed = false;
        } else {
          link.hovered = false;
          link.unfocussed = true;
        }

        registerDraw && hoveredNode.active && child.setData({
          hovered: link.hovered,
          unfocussed: link.unfocussed
        }, true);
      });
      registerDraw && hoveredNode.active && this.setDimension();
    }
  };

  _proto.nodeHoverOut = function nodeHoverOut(labelKey, registerDraw) {
    if (registerDraw === void 0) {
      registerDraw = true;
    }

    if (this.config.highlightEffect) {
      this.resetEffect(registerDraw);
    }
  };

  return NodeLinkManager;
}(_componentInterface.SmartRenderer);

var _default = NodeLinkManager;
exports["default"] = _default;

/***/ }),

/***/ 1469:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _componentInterface = __webpack_require__(290);

var _polarUtil = __webpack_require__(1454);

var _utils = __webpack_require__(1470);

var _lib = __webpack_require__(274);

var _pieLabelUtils = __webpack_require__(651);

var nodeGenerator = function nodeGenerator(_startAngle, _endAngle, arc, outerRadius, innerRadius) {
  var startAngle = (0, _utils.normaliseAngle)(_startAngle),
      endAngle = (0, _utils.normaliseAngle)(_endAngle),
      _polarToCartesian = (0, _polarUtil.polarToCartesian)(outerRadius, startAngle, false),
      x1 = _polarToCartesian.x,
      y1 = _polarToCartesian.y,
      _polarToCartesian2 = (0, _polarUtil.polarToCartesian)(outerRadius, endAngle, false),
      x2 = _polarToCartesian2.x,
      y2 = _polarToCartesian2.y,
      _polarToCartesian3 = (0, _polarUtil.polarToCartesian)(innerRadius, startAngle, false),
      x3 = _polarToCartesian3.x,
      y3 = _polarToCartesian3.y,
      _polarToCartesian4 = (0, _polarUtil.polarToCartesian)(innerRadius, endAngle, false),
      x4 = _polarToCartesian4.x,
      y4 = _polarToCartesian4.y;

  x1 = (0, _lib.toPrecision)(x1, 4);
  y1 = (0, _lib.toPrecision)(y1, 4);
  x2 = (0, _lib.toPrecision)(x2, 4);
  y2 = (0, _lib.toPrecision)(y2, 4);
  x3 = (0, _lib.toPrecision)(x3, 4);
  y3 = (0, _lib.toPrecision)(y3, 4);
  x4 = (0, _lib.toPrecision)(x4, 4);
  y4 = (0, _lib.toPrecision)(y4, 4);
  return [_utils.M, x1, y1, _utils.A, outerRadius, outerRadius, 0, arc > 180 ? 1 : 0, 1, x2, y2, _utils.L, x4, y4, _utils.A, innerRadius, innerRadius, 0, arc > 180 ? 1 : 0, 0, x3, y3, _utils.Z];
},
    labelPathGenerator = function labelPathGenerator(_startAngle, _endAngle, arc, radius) {
  var _polarToCartesian5 = (0, _polarUtil.polarToCartesian)(radius, (0, _utils.normaliseAngle)(_startAngle), false),
      x1 = _polarToCartesian5.x,
      y1 = _polarToCartesian5.y,
      _polarToCartesian6 = (0, _polarUtil.polarToCartesian)(radius, (0, _utils.normaliseAngle)(_endAngle), false),
      x2 = _polarToCartesian6.x,
      y2 = _polarToCartesian6.y;

  return "M " + x1 + " " + y1 + " A " + radius + " " + radius + " " + 0 + " " + (arc > 180 ? 1 : 0) + " " + (_startAngle > _endAngle ? 0 : 1) + " " + x2 + " " + y2;
},
    RED = '#ff0000',
    LABEL_POSITION_TANGENTIAL = 'tangential',
    LABEL_POSITION_OUTSIDE = 'outside',
    LABEL_POSITION_INSIDE = 'inside',
    START = 'start',
    PADDING = 4,
    clickFn = function clickFn(e) {
  var node = this,
      manager = node.getLinkedParent(),
      legend = node.getFromEnv('legend'),
      chart = node.getFromEnv('chart'),
      legendItem = legend ? legend.getItem(manager.config.legendItemMap[node.config.label]) : null;
  var eventArgs = {};
  setEventArgs(eventArgs, node);
  manager.nodeClicked(node.config.label, legendItem);
  chart.plotEventHandler(null, e, 'dataplotclick', eventArgs); // event args need to be passed
},
    END = 'end',
    mouseOverFn = function mouseOverFn(e) {
  var node = this,
      chart = node.getFromEnv('chart');
  this.getLinkedParent().nodeHoverIn(this.config.label);
  var eventArgs = {};
  setEventArgs(eventArgs, node);
  chart.plotEventHandler(null, e, 'DataPlotRollOver', eventArgs);
},
    mouseOutFn = function mouseOutFn(e) {
  var node = this,
      chart = node.getFromEnv('chart');
  this.getLinkedParent().nodeHoverOut(this.config.label);
  var eventArgs = {};
  setEventArgs(eventArgs, node);
  chart.plotEventHandler(null, e, 'DataPlotRollOut', eventArgs);
},
    setEventArgs = function setEventArgs(eventArgs, node) {
  // RED-8927: Support for plot click,label click and link click  events for Chord Diagram
  // sets the Arguments for mouse click/over/out events.
  var manager = node.getLinkedParent();
  eventArgs.label = node.config.label;
  eventArgs.color = node.config.color;
  eventArgs.alpha = node.config.alpha;
  eventArgs.links = {};
  eventArgs.value = node.config.total;
  eventArgs.displayValue = node.config.formattedValue;
  eventArgs.nodeValue = node.config.nodevalue;
  eventArgs.nodeDataValue = node.config.nodedatavalue;
  eventArgs.plotFillColor = node.config.plotfillcolor;
  eventArgs.toolText = node.config.tooltext;
  var i; // RED-8927: for loop is used to get link values for the current node.

  for (i = 0; i < node.config.linkedLinks.length; i++) {
    var j = node.config.linkedLinks[i],
        obj = manager.config.links[j],
        arrValues = [],
        currentnodelabel = eventArgs.label,
        currentnodevalue = {},
        linkednodelabel = void 0,
        linkednodevalue = {};
    currentnodevalue[currentnodelabel] = obj[currentnodelabel];
    linkednodelabel = j.replace(currentnodelabel, '').replace(',', '');
    linkednodevalue[linkednodelabel] = obj[linkednodelabel];
    arrValues.push(currentnodevalue);

    if (linkednodelabel !== currentnodelabel && !(obj[linkednodelabel] === _lib.UNDEF)) {
      arrValues.push(linkednodevalue);
    }

    eventArgs.links[j] = arrValues;
  }
},
    getClassName = function getClassName(baseName) {
  if (baseName === void 0) {
    baseName = '';
  }

  var randomString = Math.random().toString(36).substring(2);
  return baseName + "-" + randomString;
},
    getTooltext = function getTooltext(config, node, chartConfig) {
  var uniChar = _lib.isIpad ? _utils.SMALLSQUARE : _utils.MEDIUMSQUARE,
      macroIndices = [3, 133, 134, 143, 144, 145],
      basefontsize = node.computeFontSize(chartConfig.style.inCanfontSizeWithUnit),
      manager = node.getLinkedParent(),
      drawCustomLegendIcon = chartConfig && chartConfig.drawcustomlegendicon,
      legend = node.getFromEnv('legend'),
      chartNonce = (config == null ? void 0 : config.nonce) || '',
      pathArr,
      newPathArr = [],
      i,
      j,
      symbolBBox,
      legendItemSymbol,
      plotToolText,
      pathStart = [],
      finalPath,
      legendItem = drawCustomLegendIcon && legend && legend.config && legend.config.isActive ? legend.getItem(manager.config.legendItemMap[node.config.label]) : null,
      graphicalElement = legendItem && legendItem.getGraphicalElement(),
      parserConfig,
      toolText;
  finalPath = _lib.BLANKSTRING;

  if (legendItem) {
    legendItemSymbol = graphicalElement && graphicalElement.legendItemSymbol;
    pathArr = legendItemSymbol && legendItemSymbol.attrs.path.split(/(?=[LMCA])/);
    symbolBBox = legendItemSymbol && legendItemSymbol.node.getBBox();

    if (pathArr && pathArr.length) {
      for (i = 0; i < pathArr.length; i++) {
        pathStart.push(pathArr[i][0]);
        pathArr[i] = pathArr[i].substring(1, pathArr[i].length);

        if (i === pathArr.length - 1) {
          pathArr[i] = pathArr[i].substring(0, pathArr[i].length - 1);
        }

        newPathArr[i] = pathArr[i].split(',');
      }
    }

    if (newPathArr && newPathArr.length) {
      for (i = 0; i < newPathArr.length; i++) {
        if (newPathArr[i].length) {
          for (j = 0; j < newPathArr[i].length; j++) {
            newPathArr[i][j] = Number(newPathArr[i][j]);

            if (pathStart[i] !== 'A') {
              if (j === 0) {
                newPathArr[i][j] = newPathArr[i][j] - symbolBBox.x;
              } else if (j === 1) {
                newPathArr[i][j] = newPathArr[i][j] - symbolBBox.y;
              }
            } else if (pathStart[i] === 'A') {
              if (j === 5) {
                newPathArr[i][j] = newPathArr[i][j] - symbolBBox.x;
              } else if (j === 6) {
                newPathArr[i][j] = newPathArr[i][j] - symbolBBox.y;
              }
            }
          }
        }

        finalPath += pathStart[i] + newPathArr[i].toString();
      }
    }

    finalPath = finalPath + 'Z';
  }

  parserConfig = {
    label: config.label,
    value: config.total,
    nodeValue: config.total,
    nodeDataValue: config.formattedValue,
    plotFillColor: config.color,
    plotFillAlpha: config.alpha,
    plotIdentifier: legendItem ? "<svg height= " + symbolBBox.height + " width = " + symbolBBox.width + " overflow='visible' xmlns=\"http://www.w3.org/2000/svg\">\n      <path d= " + finalPath + " fill = " + graphicalElement.legendItemSymbol.node.getAttribute('fill') + " stroke = " + graphicalElement.legendItemSymbol.node.getAttribute('stroke') + "\n      stroke-opacity = " + graphicalElement.legendItemSymbol.node.getAttribute('stroke-opacity') + " fill-opacity = " + graphicalElement.legendItemSymbol.node.getAttribute('fill-opacity') + " \n      stroke-width = " + graphicalElement.legendItemSymbol.node.getAttribute('stroke-width') + " stroke-linecap = " + graphicalElement.legendItemSymbol.node.getAttribute('stroke-linecap') + "></path>\n    </svg>" : "<span style='color: " + config.color + ";'>" + uniChar + "&nbsp;</span>"
  };
  toolText = (0, _lib.parseTooltext)(config.tooltext, macroIndices, parserConfig, {
    label: config.label,
    value: config.formattedValue,
    nodeValue: config.total,
    nodeDataValue: config.formattedValue,
    plotFillColor: config.color,
    plotFillAlpha: config.alpha,
    plotIdentifier: legendItem ? "<svg height= " + symbolBBox.height + " width = " + symbolBBox.width + " overflow='visible' xmlns=\"http://www.w3.org/2000/svg\">\n        <path d= " + finalPath + " fill = " + graphicalElement.legendItemSymbol.node.getAttribute('fill') + " stroke = " + graphicalElement.legendItemSymbol.node.getAttribute('stroke') + "\n        stroke-opacity = " + graphicalElement.legendItemSymbol.node.getAttribute('stroke-opacity') + " fill-opacity = " + graphicalElement.legendItemSymbol.node.getAttribute('fill-opacity') + " \n        stroke-width = " + graphicalElement.legendItemSymbol.node.getAttribute('stroke-width') + " stroke-linecap = " + graphicalElement.legendItemSymbol.node.getAttribute('stroke-linecap') + "></path>\n      </svg>" : "<span style='color: " + config.color + ";'>" + uniChar + "&nbsp;</span>"
  });
  plotToolText = (0, _lib.parseTooltext)(config.tooltext, macroIndices, parserConfig, {
    label: config.label,
    value: config.formattedValue,
    nodeValue: config.total,
    nodeDataValue: config.formattedValue,
    plotFillColor: config.color,
    plotFillAlpha: config.alpha,
    plotIdentifier: legendItem ? "<svg height= " + symbolBBox.height + " width = " + symbolBBox.width + " overflow='visible' xmlns=\"http://www.w3.org/2000/svg\">\n        <path d= " + finalPath + " fill = " + graphicalElement.legendItemSymbol.node.getAttribute('fill') + " stroke = " + graphicalElement.legendItemSymbol.node.getAttribute('stroke') + "\n        stroke-opacity = " + graphicalElement.legendItemSymbol.node.getAttribute('stroke-opacity') + " fill-opacity = " + graphicalElement.legendItemSymbol.node.getAttribute('fill-opacity') + " \n        stroke-width = " + graphicalElement.legendItemSymbol.node.getAttribute('stroke-width') + " stroke-linecap = " + graphicalElement.legendItemSymbol.node.getAttribute('stroke-linecap') + "></path>\n      </svg>" : "<span style='color: " + config.color + ";'>" + uniChar + "&nbsp;</span>"
  });
  config.setToolText = toolText;
  config.setPlotTooltext = config.setToolText ? config.setToolText : plotToolText;
  var tooltipClass = getClassName('tooltip'),
      tooltipColorClass = getClassName('tooltip-color');

  if (!config.tooltext) {
    return "\n        <style nonce=\"" + chartNonce + "\">\n          ." + tooltipClass + " {\n            padding: 2px;\n            vertical-align: middle;\n            font-size: " + basefontsize + "px;\n          }\n\n          ." + tooltipColorClass + " {\n            color: " + config.color + ";\n          }\n        </style>\n        <div class=\"" + tooltipClass + "\">\n          <span class=\"" + tooltipColorClass + "\">\n              " + uniChar + "\n          </span>\n          " + (config.label + config.toolTipSepChar) + "\n          &nbsp;\n          " + config.formattedValue + "\n        </div>";
  }

  return "\n      <style nonce=\"" + chartNonce + "\">\n        ." + tooltipClass + " {\n          padding: 2px;\n          vertical-align: middle;\n          font-size: " + basefontsize + "px;\n        }\n\n        ." + tooltipColorClass + " {\n          color: " + config.color + ";\n        }\n      </style>\n      <div class=\"" + tooltipClass + "\">\n        <span class=\"" + tooltipColorClass + "\">\n            " + uniChar + "\n        </span>\n        " + config.setPlotTooltext + "\n      </div>";
};

var Node = /*#__PURE__*/function (_SmartRenderer) {
  (0, _inheritsLoose2.default)(Node, _SmartRenderer);

  function Node(id) {
    var _this;

    _this = _SmartRenderer.call(this, id) || this;

    _this.addEventListener('fc-click', clickFn); // this.addEventListener('fc-click', dataPlotClickfn);


    _this.addEventListener('fc-mouseover', mouseOverFn);

    _this.addEventListener('fc-mouseout', mouseOutFn);

    return _this;
  }

  var _proto = Node.prototype;

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    _SmartRenderer.prototype.__setDefaultConfig.call(this);

    var config = this.config;
    config.styles = {
      fill: RED,
      stroke: RED,
      'fill-alpha': 0.7
    };
  };

  _proto.configureAttributes = function configureAttributes(dataObj) {
    _SmartRenderer.prototype.configureAttributes.call(this, dataObj);

    Object.assign(this.config, dataObj);
    var node = this;
    node.config.formattedValue = node.getFromEnv('number-formatter').dataLabels(node.config.total);
    node.config.formattedNodeDataValue = node.getFromEnv('number-formatter').dataLabels(node.config.nodedatavalue);
  };

  _proto.setDimension = function setDimension(dim) {
    Object.assign(this.config, dim);
  };

  _proto.allocatePosition = function allocatePosition() {
    var node = this,
        config = node.config,
        label = config.label,
        _node$getFromEnv = node.getFromEnv('chartConfig'),
        canvasHeight = _node$getFromEnv.canvasHeight,
        canvasWidth = _node$getFromEnv.canvasWidth,
        cx = _node$getFromEnv.cx,
        cy = _node$getFromEnv.cy,
        style = _node$getFromEnv.style,
        slope,
        labelOrientation = config.labelPosition,
        applicableRadius = config.outerRadius + config.nodeLabelGap,
        smartLabel = node.getFromEnv('smartLabel'),
        startingAngle = (0, _utils.normaliseAngle)(config.startingAngle),
        endingAngle = (0, _utils.normaliseAngle)(config.endingAngle),
        labelAttrs = {},
        smartLabelOutput,
        fontSize,
        lineHeight,
        labelCatersianPosition; // Setting font size & line height for when the chart is resized


    config.style['font-size'] = fontSize = this.computeFontSize(style.inCanfontSizeWithUnit);
    lineHeight = (0, _lib.setLineHeight)({
      fontSize: fontSize
    }).replace(/px/ig, _lib.BLANKSTRING);
    smartLabel.setStyle(config.style);
    smartLabel.useEllipsesOnOverflow(node.getFromEnv('chartConfig').useEllipsesOnOverflow);
    /*
      * RED-8797
      * SVG cartesian system is not same as general cartesian system
      * But since slope is calculated down, it must be corrected as per
      * general cartesian system.
      * Followed by that if-else conditions are also matched with general
      * cartesian system.
      * Note: CASE 0, 1, 2, 3 still map to SVG cartesian system.
    */

    switch (labelOrientation) {
      case LABEL_POSITION_TANGENTIAL:
        {
          var labelAngleCenter = (startingAngle + endingAngle) / 2 % 360,
              x2,
              y2,
              spaceRemaining = 0;
          labelCatersianPosition = (0, _polarUtil.polarToCartesian)(applicableRadius, labelAngleCenter, false);
          var quadrant = (0, _pieLabelUtils.getQuadrant)((0, _polarUtil.deg2Rad)(labelAngleCenter));

          switch (quadrant) {
            case 0:
              x2 = canvasWidth / 2;
              y2 = canvasHeight / 2;
              slope = Math.tan((0, _polarUtil.deg2Rad)(360 - labelAngleCenter));

              if (Math.abs(x2 * slope) <= y2) {
                // intersects with right line
                spaceRemaining = (0, _utils.getCartesianDistance)(labelCatersianPosition.x + cx, labelCatersianPosition.y + cy, cx + x2, cy - x2 * slope);
              } else {
                // intersects with bottom line
                spaceRemaining = (0, _utils.getCartesianDistance)(labelCatersianPosition.x + cx, labelCatersianPosition.y + cy, cx - y2 / slope, cy + y2);
              }

              break;

            case 1:
              x2 = -1 * canvasWidth / 2;
              y2 = canvasHeight / 2;
              slope = Math.tan((0, _polarUtil.deg2Rad)(180 + labelAngleCenter));

              if (Math.abs(x2 * slope) <= Math.abs(y2)) {
                // intersects with left line
                spaceRemaining = (0, _utils.getCartesianDistance)(labelCatersianPosition.x + cx, labelCatersianPosition.y + cy, cx + x2, cy + x2 * slope);
              } else {
                // intersects with bottom line
                spaceRemaining = (0, _utils.getCartesianDistance)(labelCatersianPosition.x + cx, labelCatersianPosition.y + cy, cx + y2 / slope, cy + y2);
              }

              break;

            case 2:
              x2 = -1 * canvasWidth / 2;
              y2 = -1 * (canvasHeight / 2);
              slope = Math.tan((0, _polarUtil.deg2Rad)(360 - labelAngleCenter));

              if (Math.abs(x2 * slope) <= Math.abs(y2)) {
                // intersects with left line
                spaceRemaining = (0, _utils.getCartesianDistance)(labelCatersianPosition.x + cx, labelCatersianPosition.y + cy, cx + x2, cy - x2 * slope);
              } else {
                // intersects with top line
                spaceRemaining = (0, _utils.getCartesianDistance)(labelCatersianPosition.x + cx, labelCatersianPosition.y + cy, cx - y2 / slope, cy + y2);
              }

              break;

            case 3:
              x2 = canvasWidth / 2;
              y2 = -1 * (canvasHeight / 2);
              slope = Math.tan((0, _polarUtil.deg2Rad)(-1 * labelAngleCenter));

              if (Math.abs(x2 * slope) <= Math.abs(y2)) {
                // intersects with right line
                spaceRemaining = (0, _utils.getCartesianDistance)(labelCatersianPosition.x + cx, labelCatersianPosition.y + cy, cx + x2, cy - x2 * slope);
              } else {
                // intersects with top line
                spaceRemaining = (0, _utils.getCartesianDistance)(labelCatersianPosition.x + cx, labelCatersianPosition.y + cy, cx - y2 / slope, cy + y2);
              }

              break;

            default:
              ;
          }

          smartLabelOutput = smartLabel.getSmartText(label, spaceRemaining, lineHeight);
          labelAttrs.transform = (0, _lib.getSuggestiveRotation)((0, _utils.getTextRotationByQuadrant)(labelAngleCenter), labelCatersianPosition.x, labelCatersianPosition.y);

          if ((0, _utils.isAngleInLeftHemisphere)(labelAngleCenter)) {
            labelAttrs['text-anchor'] = END;
          }

          labelAttrs.x = labelCatersianPosition.x;
          labelAttrs.y = labelCatersianPosition.y;
          break;
        }

      case LABEL_POSITION_OUTSIDE:
        {
          var labelAngleCenterDeg = (startingAngle + endingAngle) / 2 % 360,
              labelAngleCenterRad = (0, _polarUtil.deg2Rad)(labelAngleCenterDeg),
              labelAngleCenterCleanRad = (0, _pieLabelUtils.getCleanAngle)(labelAngleCenterRad),
              labelAngleCenterCleanDeg = (0, _polarUtil.rad2Deg)(labelAngleCenterCleanRad),
              isLabelCenterInTopHemisphere = (0, _utils.isAngleInTopHemisphere)(labelAngleCenterCleanDeg),
              arcLength = (0, _utils.getArcLength)(applicableRadius, startingAngle, endingAngle),
              textPathStartAngle = isLabelCenterInTopHemisphere ? config.startingAngle : config.endingAngle,
              textPathEndAngle = isLabelCenterInTopHemisphere ? config.endingAngle : config.startingAngle;
          smartLabelOutput = smartLabel.getSmartText(label, arcLength - PADDING, lineHeight); // dy attribute of tspan not supported in IE, so path calculation changed

          if (_lib.isIE11) {
            if (!isLabelCenterInTopHemisphere) {
              applicableRadius += smartLabelOutput.height * 0.7;
            }
          }

          labelAttrs.textpath = {
            path: labelPathGenerator(textPathStartAngle, textPathEndAngle, config.arcAngle, applicableRadius),
            startOffset: '50%'
          };
          labelAttrs[_lib.TEXTANCHOR] = _lib.MIDDLESTR;
          labelAttrs['vertical-align'] = isLabelCenterInTopHemisphere ? 'top' : 'bottom';
          labelAttrs.transform = null;
          labelAttrs.x = 0;
          labelAttrs.y = 0;
          break;
        }

      case LABEL_POSITION_INSIDE:
      default:
        {
          var _labelAngleCenterDeg = (startingAngle + endingAngle) / 2 % 360,
              _labelAngleCenterRad = (0, _polarUtil.deg2Rad)(_labelAngleCenterDeg),
              _labelAngleCenterCleanRad = (0, _pieLabelUtils.getCleanAngle)(_labelAngleCenterRad),
              _labelAngleCenterCleanDeg = (0, _polarUtil.rad2Deg)(_labelAngleCenterCleanRad),
              _isLabelCenterInTopHemisphere = (0, _utils.isAngleInTopHemisphere)(_labelAngleCenterCleanDeg),
              middleRadius = (config.outerRadius + config.innerRadius) / 2,
              _arcLength = (0, _utils.getArcLength)(middleRadius, startingAngle, endingAngle),
              _textPathStartAngle = _isLabelCenterInTopHemisphere ? config.startingAngle : config.endingAngle,
              _textPathEndAngle = _isLabelCenterInTopHemisphere ? config.endingAngle : config.startingAngle;

          smartLabelOutput = smartLabel.getSmartText(label, _arcLength - PADDING, lineHeight); // IE doesn't support dy attribute of tspan, so path calculation changed

          if (_lib.isIE11) {
            if (_isLabelCenterInTopHemisphere) {
              middleRadius -= smartLabelOutput.height * 0.3;
            } else {
              middleRadius += smartLabelOutput.height * 0.3;
            }
          }

          labelAttrs.textpath = {
            path: labelPathGenerator(_textPathStartAngle, _textPathEndAngle, config.arcAngle, middleRadius),
            startOffset: '50%'
          };
          labelAttrs[_lib.TEXTANCHOR] = _lib.MIDDLESTR;
          labelAttrs['vertical-align'] = _lib.MIDDLESTR;
          labelAttrs.transform = null;
          labelAttrs.x = 0;
          labelAttrs.y = 0;
          break;
        }
    }

    labelAttrs.fill = (0, _lib.convertColor)(config.labelColor, 100);
    labelAttrs.text = smartLabelOutput.text;
    labelAttrs.cursor = _lib.POINTER;
    labelAttrs['text-anchor'] = labelAttrs['text-anchor'] || START;
    node.config.labelAttrs = labelAttrs;
    node.config.path = nodeGenerator(config.startingAngle, config.endingAngle, config.arcAngle, config.outerRadius, config.innerRadius);
    node.config.focussedState.path = node.config.path;
    node.config.normalState.path = node.config.path;
    node.config.unfocussedState.path = node.config.path;
    node.config.deactiveState.path = node.config.path;
  };

  _proto.draw = function draw() {
    var node = this,
        config = node.config,
        chartConfig = node.getFromEnv('chartConfig'),
        tooltext = config.showToolTip ? getTooltext(config, this, chartConfig) : _lib.BLANKSTRING;
    var nodeAttr;

    if (node.config.active) {
      nodeAttr = config.hovered ? config.focussedState : config.unfocussed ? config.unfocussedState : config.normalState;
    } else {
      nodeAttr = config.deactiveState;
    }

    nodeAttr.cursor = _lib.POINTER;
    node.addGraphicalElement({
      el: 'group',
      container: {
        id: 'node-container',
        isParent: true
      },
      tooltext: tooltext,
      component: node,
      label: 'text-path-container',
      id: 'text-path-container',
      attr: {
        name: 'text-path-container'
      }
    });
    node.addGraphicalElement({
      el: 'path',
      label: 'node',
      tooltext: tooltext,
      container: {
        id: 'text-path-container'
      },
      attr: nodeAttr,
      component: node
    }, true);

    if (config.showLabel) {
      node.addGraphicalElement({
        el: 'text',
        label: 'node-label',
        container: {
          id: 'text-path-container'
        },
        attr: config.labelAttrs,
        outlineText: !!chartConfig.textOutline,
        css: {},
        tooltext: tooltext,
        component: node
      }, true);
    }
  };

  _proto._manageSpace = function _manageSpace(spaceArguments) {
    var node = this,
        config = node.config,
        smartLabel = node.getFromEnv('smartLabel');
    var oriSize, smartText, spaceRequired;
    smartLabel.setStyle(config.style);
    oriSize = smartLabel.getOriSize(config.label);

    if (!config.showLabel) {
      return 0;
    }

    if (config.labelPosition === LABEL_POSITION_TANGENTIAL) {
      if (oriSize.width > spaceArguments.maxSpace) {
        smartText = smartLabel.getSmartText(config.label, spaceArguments.maxSpace, oriSize.height);
        spaceRequired = smartText.width;
      } else {
        spaceRequired = oriSize.width;
      }
    } else if (config.labelPosition === LABEL_POSITION_OUTSIDE) {
      spaceRequired = oriSize.height;
    } else {
      spaceRequired = 0;
    }

    return spaceRequired;
  };

  _proto.getName = function getName() {
    return 'node';
  };

  _proto.getType = function getType() {
    return 'dataset';
  };

  return Node;
}(_componentInterface.SmartRenderer);

var _default = Node;
exports["default"] = _default;

/***/ }),

/***/ 1472:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _componentInterface = __webpack_require__(290);

var _polarUtil = __webpack_require__(1454);

var _lib = __webpack_require__(274);

var _utils = __webpack_require__(1470);

var normalizeAngles = function normalizeAngles(radians) {
  return radians - _utils.HALF_PI;
},
    ribbonGenerator = function ribbonGenerator(points, radius, startAngle) {
  var corners = points.map(function (p, i) {
    var angle = (0, _polarUtil.deg2Rad)(p),
        _polarToCartesian = (0, _polarUtil.polarToCartesian)(radius, normalizeAngles((0, _polarUtil.deg2Rad)(startAngle)) + angle),
        x = _polarToCartesian.x,
        y = _polarToCartesian.y,
        curveFactor = 0.6,
        distance = Math.abs((0, _polarUtil.deg2Rad)(points[3 - i]) - angle),
        nextPointDist = Math.abs((0, _polarUtil.deg2Rad)(points[(i + 1) % 4]) - angle);

    if (distance > _utils.PI) {
      distance = _utils.PI2 - distance;
    }

    if (distance * radius < radius) {
      curveFactor *= distance;
    }

    x = (0, _lib.toPrecision)(x, 4);
    y = (0, _lib.toPrecision)(y, 4);
    return {
      x: x,
      y: y,
      cpX: (1 - curveFactor) * x,
      cpY: (1 - curveFactor) * y,
      arc: nextPointDist
    };
  });
  return [_utils.M, corners[0].x, corners[0].y, _utils.A, radius, radius, 0, corners[0].arc > _utils.PI ? 1 : 0, 1, corners[1].x, corners[1].y, _utils.C, corners[1].cpX, corners[1].cpY, corners[2].cpX, corners[2].cpY, corners[2].x, corners[2].y, _utils.A, radius, radius, 0, corners[2].arc > _utils.PI ? 1 : 0, 1, corners[3].x, corners[3].y, _utils.C, corners[3].cpX, corners[3].cpY, corners[0].cpX, corners[0].cpY, corners[0].x, corners[0].y].join(" ");
},
    mouseOverFn = function mouseOverFn() {
  var node = this,
      chart = node.getFromEnv('chart');
  this.getLinkedParent().linkHoverIn(this.config.key);
  var eventArgs = {};
  setEventArgs(eventArgs, node);
  chart.fireChartInstanceEvent('linkRollOver', eventArgs);
},
    mouseOutFn = function mouseOutFn() {
  var node = this,
      chart = node.getFromEnv('chart');
  this.getLinkedParent().linkHoverOut(this.config.key);
  var eventArgs = {};
  setEventArgs(eventArgs, node);
  chart.fireChartInstanceEvent('linkRollOut', eventArgs);
},
    mouseClickFn = function mouseClickFn() {
  var node = this,
      chart = node.getFromEnv('chart');
  var eventArgs = {};
  setEventArgs(eventArgs, node);
  chart.fireChartInstanceEvent('linkClick', eventArgs);
},
    setEventArgs = function setEventArgs(eventArgs, node) {
  // RED-8927: Support for plot click,label click and link click  events for Chord Diagram
  // sets the Arguments for mouse click/over/out events.
  eventArgs.dominantFlowValue = node.config[node.config.dominantNode[0]];
  var i; // RED-8927stores the index of subservient node.

  for (i = 0; i < node.config.linkedNodes.length; i++) {
    if (node.config.linkedNodes[i] !== node.config.dominantNode[0]) {
      break;
    }
  }

  eventArgs.subservientFlowValue = node.config[node.config.linkedNodes[i]];
  eventArgs.linkedNodes = node.config.linkedNodes;

  if (eventArgs.dominantFlowValue === eventArgs.subservientFlowValue) {
    eventArgs.color = node.config.rawColor || (0, _lib.rgbaToHex)(node.config.normalState.fill);
  } else {
    eventArgs.color = (0, _lib.rgbaToHex)(node.config.normalState.fill);
  }

  eventArgs.alpha = node.config.alpha;
},
    getUniqueNodes = function getUniqueNodes(nodeArr) {
  var resultingNodes = [];

  if (nodeArr.length === 0) {
    return [];
  } else if (nodeArr.length === 1) {
    return [nodeArr[0]];
  }

  resultingNodes = nodeArr.filter(function (c, index) {
    return nodeArr.indexOf(c) === index;
  });
  return resultingNodes;
},
    getDominantFlowValue = function getDominantFlowValue(_config, _nodeArr) {
  var i,
      config = _config,
      nodeArr = _nodeArr,
      resultValues = [];

  if (!nodeArr.length) {
    return [];
  }

  if (nodeArr.length === 1) {
    return config[nodeArr[0]];
  }

  for (i = 0; i < nodeArr.length; i++) {
    resultValues.push(config[nodeArr[i]]);
  }

  return resultValues;
},
    getPlotIdentifier = function getPlotIdentifier(colorArr, uniChar, legendItem, finalPath) {
  var body = _lib.BLANKSTRING,
      graphicalElement,
      symbolBBox,
      i;

  if (finalPath !== '' && legendItem && legendItem.length) {
    if (legendItem.length === 1) {
      graphicalElement = legendItem[0].getGraphicalElement();
      symbolBBox = graphicalElement.legendItemSymbol.node.getBBox();
      return "<svg height= " + symbolBBox.height + " width = " + symbolBBox.width + " overflow='visible' xmlns=\"http://www.w3.org/2000/svg\">\n        <path d= " + finalPath + " fill = " + graphicalElement.legendItemSymbol.node.getAttribute('fill') + " stroke = " + graphicalElement.legendItemSymbol.node.getAttribute('stroke') + "\n        stroke-opacity = " + graphicalElement.legendItemSymbol.node.getAttribute('stroke-opacity') + " fill-opacity = " + graphicalElement.legendItemSymbol.node.getAttribute('fill-opacity') + " \n        stroke-width = " + graphicalElement.legendItemSymbol.node.getAttribute('stroke-width') + " stroke-linecap = " + graphicalElement.legendItemSymbol.node.getAttribute('stroke-linecap') + "></path>\n      </svg>";
    }

    for (i = 0; i < legendItem.length; i++) {
      graphicalElement = legendItem[i].getGraphicalElement();
      symbolBBox = graphicalElement.legendItemSymbol.node.getBBox();
      body += "<svg height= " + symbolBBox.height + " width = " + symbolBBox.width + " overflow='visible' xmlns=\"http://www.w3.org/2000/svg\">\n          <path d= " + finalPath + " fill = " + graphicalElement.legendItemSymbol.node.getAttribute('fill') + " stroke = " + graphicalElement.legendItemSymbol.node.getAttribute('stroke') + "\n          stroke-opacity = " + graphicalElement.legendItemSymbol.node.getAttribute('stroke-opacity') + " fill-opacity = " + graphicalElement.legendItemSymbol.node.getAttribute('fill-opacity') + " \n          stroke-width = " + graphicalElement.legendItemSymbol.node.getAttribute('stroke-width') + " stroke-linecap = " + graphicalElement.legendItemSymbol.node.getAttribute('stroke-linecap') + "></path>\n        </svg>";
    }
  } else if (colorArr.length) {
    for (i = 0; i < colorArr.length; i++) {
      body += "\n            <span style='color: " + colorArr[i] + ";'>\n              " + uniChar + "\n            </span>";
    }
  }

  return body;
},
    getLegendItems = function getLegendItems(legend, manager, dominantNodes) {
  var legendItems = [],
      i;

  if (dominantNodes && dominantNodes.length) {
    if (dominantNodes.length === 1) {
      return [legend.getItem(manager.config.legendItemMap[dominantNodes[0]])];
    }

    for (i = 0; i < dominantNodes.length; i++) {
      legendItems.push(legend.getItem(manager.config.legendItemMap[dominantNodes[i]]));
    }
  }

  return legendItems;
},
    getClassName = function getClassName(baseName) {
  if (baseName === void 0) {
    baseName = '';
  }

  var randomString = Math.random().toString(36).substring(2);
  return baseName + "-" + randomString;
},
    getTooltext = function getTooltext(config, chartConfig, basefontsize, ribbon) {
  var uniChar = _lib.isIpad ? _utils.SMALLSQUARE : _utils.MEDIUMSQUARE,
      key,
      body = _lib.BLANKSTRING,
      drawCustomLegendIcon = chartConfig && chartConfig.drawcustomlegendicon,
      macroIndices = [135, 136, 137, 138, 139, 140, 146, 147],
      manager = ribbon.getLinkedParent(),
      legend = ribbon.getFromEnv('legend'),
      pathArr,
      newPathArr = [],
      chatNonce = (chartConfig == null ? void 0 : chartConfig.nonce) || '',
      graphicalElement,
      legendItemSymbol,
      i,
      j,
      symbolBBox,
      pathStart = [],
      finalPath,
      dominantLegendItem = drawCustomLegendIcon && legend && legend.config && legend.config.isActive ? getLegendItems(legend, manager, getUniqueNodes(config.dominantNode)) : null,
      subservientLegendItem = drawCustomLegendIcon && legend && legend.config && legend.config.isActive ? getLegendItems(legend, manager, getUniqueNodes(config.subservientNode)) : null,
      parserConfig,
      linkToolText;
  finalPath = _lib.BLANKSTRING;

  if (dominantLegendItem && dominantLegendItem.length) {
    graphicalElement = dominantLegendItem && dominantLegendItem[0] && dominantLegendItem[0].getGraphicalElement();
    legendItemSymbol = graphicalElement && graphicalElement.legendItemSymbol;
    pathArr = legendItemSymbol && legendItemSymbol.attrs.path.split(/(?=[LMCA])/);
    symbolBBox = legendItemSymbol && legendItemSymbol.node.getBBox();

    if (pathArr && pathArr.length) {
      for (i = 0; i < pathArr.length; i++) {
        pathStart.push(pathArr[i][0]);
        pathArr[i] = pathArr[i].substring(1, pathArr[i].length);

        if (i === pathArr.length - 1) {
          pathArr[i] = pathArr[i].substring(0, pathArr[i].length - 1);
        }

        newPathArr[i] = pathArr[i].split(',');
      }
    }

    if (newPathArr && newPathArr.length) {
      for (i = 0; i < newPathArr.length; i++) {
        if (newPathArr[i].length) {
          for (j = 0; j < newPathArr[i].length; j++) {
            newPathArr[i][j] = Number(newPathArr[i][j]);

            if (pathStart[i] !== 'A') {
              if (j === 0) {
                newPathArr[i][j] = newPathArr[i][j] - symbolBBox.x;
              } else if (j === 1) {
                newPathArr[i][j] = newPathArr[i][j] - symbolBBox.y;
              }
            } else if (pathStart[i] === 'A') {
              if (j === 5) {
                newPathArr[i][j] = newPathArr[i][j] - symbolBBox.x;
              } else if (j === 6) {
                newPathArr[i][j] = newPathArr[i][j] - symbolBBox.y;
              }
            }
          }
        }

        finalPath += pathStart[i] + newPathArr[i].toString();
      }
    }

    finalPath = finalPath + 'Z';
  }

  parserConfig = {
    toolText: config.tooltext,
    dominantNode: getUniqueNodes(config.dominantNode),
    subservientNode: getUniqueNodes(config.subservientNode),
    dominantFlowDataValue: getUniqueNodes(config.dominantFlowDataValue),
    subservientFlowDataValue: getUniqueNodes(config.subservientFlowDataValue)
  };
  ;
  parserConfig.dominantFlowValue = getDominantFlowValue(config, parserConfig.dominantNode);
  parserConfig.subservientFlowValue = getDominantFlowValue(config, parserConfig.subservientNode);
  parserConfig.dominantPlotIdentifier = getPlotIdentifier(getUniqueNodes(config.dominantNodeColor), uniChar, dominantLegendItem, finalPath);
  parserConfig.subservientPlotIdentifier = getPlotIdentifier(getUniqueNodes(config.subservientNodeColor), uniChar, subservientLegendItem, finalPath);
  linkToolText = (0, _lib.parseTooltext)(config.tooltext, macroIndices, parserConfig, config);
  config.setLinkToolText = linkToolText;

  for (key in config.tooltip) {
    var tooltipColorClass = getClassName('tooltip-color');

    if (config.tooltip.hasOwnProperty(key)) {
      body += "\n          <style nonce=\"" + chatNonce + "\">\n            ." + tooltipColorClass + " {\n              color: " + config.tooltip[key].color + ";\n            }\n          </style>\n          <span class=\"" + tooltipColorClass + "\">\n            " + uniChar + "\n          </span>\n          " + (key + config.toolTipSepChar) + "\n          " + (config.showLinkValueOnHover ? " &nbsp;" : '') + "\n          " + (config.showLinkValueOnHover ? config.tooltip[key].value : '') + "\n        <br>";
    }
  }

  var tooltipClass = getClassName('tooltip');

  if (!config.tooltext) {
    return "\n        <style nonce=\"" + chatNonce + "\">\n          ." + tooltipClass + " {\n            padding: 2px;\n            vertical-align: middle;\n            font-size: " + basefontsize + "px;\n          }\n        </style>\n        <div class=\"" + tooltipClass + "\">\n          " + body + "\n        </div>";
  }

  return "<div class=\"" + tooltipClass + "\">\n        " + config.setLinkToolText + "\n      </div>";
};

var Ribbon = /*#__PURE__*/function (_SmartRenderer) {
  (0, _inheritsLoose2.default)(Ribbon, _SmartRenderer);

  function Ribbon(id) {
    var _this;

    _this = _SmartRenderer.call(this, id) || this;

    _this.addEventListener('fc-mouseover', mouseOverFn);

    _this.addEventListener('fc-mouseout', mouseOutFn);

    _this.addEventListener('fc-click', mouseClickFn);

    return _this;
  }

  var _proto = Ribbon.prototype;

  _proto.configureAttributes = function configureAttributes(dataObj) {
    _SmartRenderer.prototype.configureAttributes.call(this, dataObj);

    Object.assign(this.config, dataObj);
  };

  _proto.setDimension = function setDimension(dim) {
    this.config.radius = dim.radius;
  };

  _proto.allocatePosition = function allocatePosition() {
    var config = this.config;
    config.path = ribbonGenerator(config.points, config.radius, 0);
    config.ribbonAttrs = config.hovered ? config.focussedState : config.unfocussed ? config.unfocussedState : config.normalState;
    config.ribbonAttrs.path = config.path;
    config.ribbonAttrs['stroke-width'] = (config.showBorder ? config.borderThickness : 0) || 0;
  };

  _proto.draw = function draw() {
    var ribbon = this,
        chartConfig = ribbon.getFromEnv('chart').config,
        height = chartConfig.canvasHeight,
        width = chartConfig.canvasWidth,
        cx = chartConfig.canvasLeft + width / 2,
        cy = chartConfig.canvasTop + height / 2,
        chartWidth = chartConfig.width,
        chartHeight = chartConfig.height,
        ribbonRadius = chartConfig.ribbonRadius,
        config = ribbon.config,
        angles = config.angles,
        tooltext = config.showToolTip ? getTooltext(config, chartConfig, chartConfig.style.baseFontSize, ribbon) : _lib.BLANKSTRING,
        _polarToCartesian2 = (0, _polarUtil.polarToCartesian)(ribbonRadius, normalizeAngles((0, _polarUtil.deg2Rad)(angles[0]))),
        x1 = _polarToCartesian2.x,
        y1 = _polarToCartesian2.y,
        _polarToCartesian3 = (0, _polarUtil.polarToCartesian)(ribbonRadius, normalizeAngles((0, _polarUtil.deg2Rad)(angles[3]))),
        x2 = _polarToCartesian3.x,
        y2 = _polarToCartesian3.y;

    if (config.dominantNode.length > 1 && config.rawColor) {
      config.ribbonAttrs.fill = (0, _lib.toRaphaelColor)({
        color: config.rawColor[0] + "," + config.rawColor[1],
        alpha: config.hovered ? config.hoverAlpha : config.unfocussed ? config.unfocussedAlpha : config.alpha,
        x1: (x1 + cx) / chartWidth,
        y1: (y1 + cy) / chartHeight,
        x2: (x2 + cx) / chartWidth,
        y2: (y2 + cy) / chartHeight
      });
      config.ribbonAttrs.stroke = (0, _lib.toRaphaelColor)({
        color: config.rawColor[0] + "," + config.rawColor[1],
        alpha: config.hovered ? config.hoveredAlpha : config.unfocussed ? config.unfocussedAlpha : config.borderAlpha,
        x1: (x1 + cx) / chartWidth,
        y1: (y1 + cy) / chartHeight,
        x2: (x2 + cx) / chartWidth,
        y2: (y2 + cy) / chartHeight
      });
    }

    ribbon.addGraphicalElement({
      el: 'path',
      label: 'ribbon',
      tooltext: tooltext,
      attr: config.ribbonAttrs,
      container: {
        id: 'link-container',
        isParent: true
      },
      component: ribbon
    });
  };

  _proto.getName = function getName() {
    return 'ribbon';
  };

  _proto.getType = function getType() {
    return 'dataset';
  };

  return Ribbon;
}(_componentInterface.SmartRenderer);

var _default = Ribbon;
exports["default"] = _default;

/***/ }),

/***/ 1357:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _index = _interopRequireDefault(__webpack_require__(618));

var _default = {
  '*.dataset.dragArea': _index.default['*.dataset.area']
};
exports["default"] = _default;

/***/ }),

/***/ 1356:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = exports._drag = exports._updateImage = exports.configurer = exports.__firePlotEvent = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _area = _interopRequireDefault(__webpack_require__(617));

var _lib = __webpack_require__(274);

var _dragcolumn = __webpack_require__(1346);

var _index = _interopRequireDefault(__webpack_require__(1357));

var _dependencyManager = __webpack_require__(282);

/* eslint require-jsdoc: 'error', valid-jsdoc: ["error", { "requireReturn": false }] */
var SETROLLOVERATTR = 'setRolloverAttr',
    SETROLLOUTATTR = 'setRolloutAttr',
    ROLLOUT = 'DataPlotRollOut',
    ROLLOVER = 'DataPlotRollOver',
    DRAGLINE = 'dragLine',
    DRAGAREA = 'dragArea',
    DATAPLOTCLICK = 'dataplotclick',
    DEFAULT = 'default',
    dragMouseAttr = _lib.hasSVG && 'ns-resize' || 'n-resize',
    mathMin = Math.min,
    mathMax = Math.max,
    isVML = false,
    _updateImage,
    _configure,
    __firePlotEvent,
    _drag,
    UNDEF;

exports._drag = _drag;
exports.__firePlotEvent = __firePlotEvent;
exports.configurer = _configure;
exports._updateImage = _updateImage;
(0, _dependencyManager.addDep)({
  name: 'dragAreaAnimation',
  type: 'animationRule',
  extension: _index.default
});
/**
 * dataset class of dragcolumn inheriting from column class
 */

var DragAreaDataset = /*#__PURE__*/function (_AreaDataset) {
  (0, _inheritsLoose2.default)(DragAreaDataset, _AreaDataset);

  function DragAreaDataset() {
    return _AreaDataset.apply(this, arguments) || this;
  }

  var _proto = DragAreaDataset.prototype;

  /**
   * Sets the type of the component
   * @return {string} type
   */
  _proto.getType = function getType() {
    return 'dataset';
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */
  ;

  _proto.getName = function getName() {
    return 'dragArea';
  }
  /**
  * Function for parsing all the attributes and value given by the user at chart,dataset and set level.
  * This function is called once from the init() function of the Column class.
  * @param  {Object} datasetJSON JSON for dataset configurations
  */
  ;

  _proto.configureAttributes = function configureAttributes(datasetJSON) {
    var dataset = this,
        conf = dataset.config,
        chartAttr = dataset.getFromEnv('chart-attrib'),
        JSONData = conf.JSONData;
    conf.allowDrag = (0, _lib.pluckNumber)(JSONData.allowdrag, 1);
    conf.allowNegDrag = (0, _lib.pluckNumber)(JSONData.allownegativedrag, 1);
    conf.allowAxisChange = (0, _lib.pluckNumber)(chartAttr.allowaxischange, 1);
    conf.snapToDivOnly = (0, _lib.pluckNumber)(chartAttr.snaptodivonly, 0);
    conf.doNotSnap = (0, _lib.pluckNumber)(chartAttr.donotsnap, 0);
    conf.snapToDiv = (0, _lib.pluckNumber)(chartAttr.snaptodiv, 1);
    conf.snapToDivRelaxation = (0, _lib.pluckNumber)(chartAttr.snaptodivrelaxation, 10);

    if (conf.doNotSnap) {
      conf.snapToDiv = conf.snapToDivOnly = 0;
    }

    _AreaDataset.prototype.configureAttributes.call(this, datasetJSON);
  }
  /**
   * method to configure a particular data plot object
   * @param {number} i index of the data object to be configured
   * @param {Object} setData particular plot information in of i'th index in input json
   */
  ;

  _proto._plotConfigure = function _plotConfigure(i, setData) {
    var conf = this.config,
        dataObj,
        config;

    _AreaDataset.prototype._plotConfigure.call(this, i, setData);

    dataObj = this.components.data[i]; // eslint-disable-line good-practices/no-single-usage-variable

    config = dataObj.config;
    config.allowDrag = (0, _lib.pluckNumber)(setData.allowdrag, conf.allowDrag);
    config.allowNegDrag = (0, _lib.pluckNumber)(setData.allownegativedrag, conf.allowNegDrag);
  }
  /**
   * Function to update image while dragging.
   * @param {Object} dataObj The object by which the dataset is to be updated.
   */
  ;

  DragAreaDataset.updateImage = function updateImage(dataObj) {
    var graphics = dataObj.graphics,
        image = graphics.image || graphics.element,
        config = dataObj.config,
        anchorProps = config.anchorProps,
        hoverEffects = config.hoverEffects,
        imgRef = image && image.data('imgRef'),
        scale = anchorProps.imageScale,
        imgH = imgRef.height * scale * 0.01,
        imgW = imgRef.width * scale * 0.01,
        x = dataObj._xPos,
        y = dataObj._yPos,
        hoverScale = hoverEffects.imageHoverScale,
        hotW = imgRef.width * hoverScale * 0.01,
        // eslint-disable-line good-practices/no-single-usage-variable
    hotH = imgRef.height * hoverScale * 0.01,
        // eslint-disable-line good-practices/no-single-usage-variable
    markerRadius = anchorProps.radius = anchorProps.isAnchorRadius // eslint-disable-line good-practices/no-single-usage-variable
    ? anchorProps.radius : mathMin(imgW, imgH) / 2,
        imagePadding = anchorProps.imagePadding,
        rolloutClipRadius = markerRadius - imagePadding - anchorProps.borderThickness * 0.5,
        rolloverClipRadius = hoverEffects.radius - imagePadding - hoverEffects.anchorBorderThickness * 0.5,
        symbol = anchorProps.symbol[1],
        imageRollOverPath = (0, _lib.polyPathToPath)([symbol || 2, x, y, // eslint-disable-line good-practices/no-single-usage-variable
    rolloverClipRadius > 0 ? rolloverClipRadius : 0, hoverEffects.startAngle, hoverEffects.dip]),
        setRolloverAttr,
        imageRolloutPath = (0, _lib.polyPathToPath)([symbol || 2, x, y, // eslint-disable-line good-practices/no-single-usage-variable
    rolloutClipRadius > 0 ? rolloutClipRadius : 0, anchorProps.startAngle, 0]),
        setRolloutAttr = {
      x: x - imgRef.width * scale * 0.005,
      y: y - imgRef.height * scale * 0.005,
      width: imgW,
      height: imgH,
      alpha: 100
    };

    if (!isVML) {
      setRolloutAttr['clip-path'] = imageRolloutPath;
    }

    setRolloverAttr = {
      x: x - imgRef.width * hoverScale * 0.005,
      y: y - imgRef.height * hoverScale * 0.005,
      width: hotW,
      height: hotH,
      alpha: 100
    };

    if (!isVML) {
      setRolloverAttr['clip-path'] = imageRollOverPath;
    }

    image.attr(setRolloutAttr);
    image.data(SETROLLOVERATTR, setRolloverAttr);
    image.data(SETROLLOUTATTR, setRolloutAttr);
  }
  /**
  * Function called when drag is triggered over the datasets
  * @param {String} action dragstart/dragmove/dragend action
  * @param {*} oriEvent The original mouse event
  * @param {*} index the index of the data over which drag is triggered
  * @param {*} coordinateData the mouse-coordinate wrt to the chart container
  */
  ;

  _proto.drag = function drag(action, oriEvent, index, coordinateData) {
    var dataset = this,
        coordinate = coordinateData,
        datasetConf = dataset.config,
        datasetIndex = datasetConf.index,
        chart = dataset.getFromEnv('chart'),
        chartConfig = chart.config,
        canvasTop = chartConfig.canvasTop,
        plotItem,
        element,
        config,
        dataStore = dataset.components.data,
        value,
        formattedVal,
        yPos,
        rolloverdata,
        lowerDragBoundary,
        chartY,
        canvas = dataset.getFromEnv('paper').canvas,
        // eslint-disable-line good-practices/no-single-usage-variable
    style = canvas.style,
        yAxis = dataset.getFromEnv('yAxis'),
        ticks = yAxis.getTicks(),
        snapToDivRelaxation = (0, _lib.mathAbs)(yAxis.getValue(yAxis.getPixel(0) - datasetConf.snapToDivRelaxation)),
        snapPixel = datasetConf.snapToDivOnly ? (0, _lib.mathAbs)(ticks[1] - ticks[0]) * 0.5 : snapToDivRelaxation,
        plotIndex,
        eventArgs,
        parserConfig = {
      xaxisName: chartConfig.xaxisname,
      yaxisName: chartConfig.yaxisname
    },
        anchorProps,
        datasetGraphics = dataset.getGraphicalElement(),
        // eslint-disable-line good-practices/no-single-usage-variable
    mainLineElement = datasetGraphics.lineElement,
        chartX,
        tolerance = chartConfig.dragTolerance + 1,
        setTooltext,
        toolText,
        allowDrag,
        xPos,
        rolloutdata,
        image,
        startIndex,
        endIndex,
        allowNegDrag,
        pathArr,
        anchorElement,
        anchorImageUrl,
        isHoverEnabled,
        hoverEffects,
        anchorStartAngle,
        eventArgsArr,
        hoverEnabled,
        datasetName = dataset.getName(),
        isDragLine = datasetName === DRAGLINE || datasetName === DRAGAREA,
        // eslint-disable-line good-practices/no-single-usage-variable
    pointerMouseAttr = DEFAULT,
        macroIndices = [1, 2, 3, 4, 5, 6, 7],
        // eslint-disable-line good-practices/no-single-usage-variable
    JSONData = datasetConf.JSONData,
        chartContainer = dataset.getFromEnv('chart-container');
    coordinate = coordinate || (0, _lib.getMouseCoordinate)(chartContainer, oriEvent, chart);

    switch (action) {
      case 'dragstart':
        plotItem = dataStore[index];
        config = plotItem.config;
        yPos = plotItem._yPos;
        xPos = plotItem._xPos;
        allowDrag = config.allowDrag;
        chartY = coordinate.chartY;
        chartX = coordinate.chartX;

        if (allowDrag && chartY >= yPos - tolerance && chartY <= yPos + tolerance && chartX <= xPos + tolerance && chartX >= xPos - tolerance) {
          config.dragStart = true;
          config._pointerDy = 0;
          config._dragStartY = chartY;
          config._dragBuffer = yPos - chartY;
          plotItem.dragged = true;
          plotItem.startValue = config.setValue;
          plotItem.name = datasetConf.seriesname;
          plotItem.datasetIndex = datasetConf.index;
          anchorProps = config.anchorProps;
          hoverEffects = config.hoverEffects;
          eventArgs = {
            index: plotIndex + 1,
            dataIndex: plotIndex + 1,
            datasetIndex: plotItem.datasetIndex,
            startValue: plotItem.startValue,
            datasetName: plotItem.name,
            color: config.color,
            alpha: config.alpha,
            anchorBgColor: anchorProps.bgColor,
            anchorBgAlpha: anchorProps.anchorBgAlpha,
            anchorAlpha: anchorProps.anchorAlpha,
            anchorBorderColor: anchorProps.borderColor,
            anchorBorderThickness: anchorProps.borderThickness,
            anchorRadius: anchorProps.radius,
            anchorSides: anchorProps.sides,
            anchorStartAngle: anchorProps.startAngle,
            anchorHoverColor: hoverEffects.anchorColor,
            anchorHoverAlpha: hoverEffects.anchorAlpha,
            anchorHoverSides: hoverEffects.anchorSides,
            dashed: config.dashed,
            valuePosition: config.valuePosition,
            id: config.id
          };
          config.dragStart = true;
        } else {
          config.dragStart = false;
        }

        break;

      case 'dragmove':
        plotItem = dataStore[index];
        config = plotItem.config;

        if (config.dragStart) {
          chartY = coordinate.chartY;
          config.allowDrag && (style.cursor = dragMouseAttr);
          element = plotItem.graphics.element;
          config._pointerDy++;
          image = plotItem.graphics.image;
          xPos = plotItem._xPos;
          anchorElement = element;
          chartY += config._dragBuffer;
          allowNegDrag = config.allowNegDrag;
          lowerDragBoundary = allowNegDrag ? chartConfig.canvasBottom : yAxis.yBasePos;
          anchorProps = config.anchorProps;
          anchorStartAngle = anchorProps.startAngle || 90;
          hoverEffects = config.hoverEffects;
          isHoverEnabled = config.hoverEffects && config.hoverEffects.enabled;
          anchorImageUrl = anchorProps.imageUrl;

          if (chartY < canvasTop) {
            chartY = canvasTop;
          } else if (chartY > lowerDragBoundary) {
            chartY = lowerDragBoundary;
          }

          plotItem._yPos = yPos = chartY;
          config._y = value = config.setValue = yAxis.getValue(yPos);
          config._Py = yAxis.getPixel(config._y);
          formattedVal = dataset.getFromEnv('number-formatter').dataLabels(value);
          config.toolTipValue = formattedVal;
          config.displayValue = formattedVal;
          dataset.parseLabelAttributes(plotItem, plotIndex);
          dataset.drawLabel(plotIndex, plotIndex + 1);
          plotItem.graphics.element = element;
          dataset.getFromEnv('toolTipController').hide(datasetConf.currentToolTip);

          if (isVML && anchorImageUrl) {
            image = anchorElement;
          } else {
            if (isHoverEnabled && (rolloverdata = anchorElement.data(SETROLLOVERATTR))) {
              rolloverdata.path = (0, _lib.polyPathToPath)([hoverEffects.anchorSides || 2, xPos, yPos, hoverEffects.anchorRadius, hoverEffects.startAngle, hoverEffects.dip]);
            }

            if (isHoverEnabled && (rolloutdata = anchorElement.data(SETROLLOUTATTR))) {
              rolloutdata.path = (0, _lib.polyPathToPath)([anchorProps.symbol[1] || 2, xPos, yPos, anchorProps.radius, anchorProps.startAngle, config.dip || 0]);
            }

            anchorElement && anchorElement.attr(rolloutdata || {
              path: (0, _lib.polyPathToPath)([anchorProps.symbol[1] || 2, xPos, yPos, anchorProps.radius, anchorStartAngle, 0])
            });
          }

          if (image) {
            DragAreaDataset.updateImage(plotItem);
          }

          if (isDragLine) {
            dataset.drawCommonElements();
          }

          if (mainLineElement) {
            datasetConf = dataset.config;
            startIndex = config.pathStartIndex;
            endIndex = config.pathEndIndex;
            pathArr = config.lastPath;
            pathArr = dataset.getLinePath(dataStore, {
              begin: startIndex,
              end: endIndex
            });
            mainLineElement.attr({
              path: pathArr.getPathArr()
            });
          }

          if (config._pointerDy === 1) {
            eventArgs = {
              index: index,
              dataIndex: index,
              datasetIndex: datasetIndex,
              startValue: plotItem.startValue,
              datasetName: plotItem.name,
              color: config.color,
              alpha: config.alpha,
              anchorBgColor: anchorProps.bgColor,
              anchorBgAlpha: anchorProps.anchorBgAlpha,
              anchorAlpha: anchorProps.anchorAlpha,
              anchorBorderColor: anchorProps.borderColor,
              anchorBorderThickness: anchorProps.borderThickness,
              anchorRadius: anchorProps.radius,
              anchorSides: anchorProps.sides,
              anchorStartAngle: anchorProps.startAngle,
              anchorHoverColor: hoverEffects.anchorColor,
              anchorHoverAlpha: hoverEffects.anchorAlpha,
              anchorHoverSides: hoverEffects.anchorSides,
              dashed: config.dashed,
              valuePosition: config.valuePosition,
              id: config.id
            };
            chart.fireChartInstanceEvent('dataplotDragStart', eventArgs);
          }
        }

        break;

      case 'dragend':
        plotItem = dataStore[index];
        config = plotItem.config;

        if (config.dragStart) {
          dataset.setMaxMin(plotItem);

          if (datasetConf.snapToDiv || datasetConf.snapToDivOnly) {
            element = plotItem.graphics.element;
            image = plotItem.graphics.image;
            xPos = plotItem._xPos;
            anchorElement = element;
            anchorProps = config.anchorProps;
            anchorStartAngle = anchorProps.startAngle || 90;
            hoverEffects = config.hoverEffects;
            isHoverEnabled = config.hoverEffects && config.hoverEffects.enabled;
            anchorImageUrl = anchorProps.imageUrl;
            config.setValue = (0, _lib.snapPoint)({
              snapPixel: snapPixel,
              datasetConf: datasetConf
            }, ticks, plotItem);
            chartY = yAxis.getPixel(config.setValue);
            plotItem._yPos = yPos = chartY;
            config._y = value = config.setValue;
            config._Py = yAxis.getPixel(config._y);
            formattedVal = dataset.getFromEnv('number-formatter').dataLabels(value);
            config.toolTipValue = formattedVal;
            config.displayValue = formattedVal;
            dataset.parseLabelAttributes(plotItem, plotIndex);
            dataset.drawLabel(plotIndex, plotIndex + 1);
            plotItem.graphics.element = element; // toolTipController.hide(datasetConf.currentToolTip);

            if (isVML && anchorImageUrl) {
              image = anchorElement;
            } else {
              if (isHoverEnabled && (rolloverdata = anchorElement.data(SETROLLOVERATTR))) {
                rolloverdata.path = (0, _lib.polyPathToPath)([hoverEffects.anchorSides || 2, xPos, yPos, hoverEffects.anchorRadius, hoverEffects.startAngle, hoverEffects.dip]);
              }

              if (isHoverEnabled && (rolloutdata = anchorElement.data(SETROLLOUTATTR))) {
                rolloutdata.path = (0, _lib.polyPathToPath)([anchorProps.symbol[1] || 2, xPos, yPos, anchorProps.radius, anchorProps.startAngle, config.dip || 0]);
              }

              anchorElement && anchorElement.attr(rolloutdata || {
                path: (0, _lib.polyPathToPath)([anchorProps.symbol[1] || 2, xPos, yPos, anchorProps.radius, anchorStartAngle, 0])
              });
            }

            if (image) {
              DragAreaDataset.updateImage(plotItem);
            }

            if (isDragLine) {
              dataset.drawCommonElements();
            }

            if (mainLineElement) {
              datasetConf = dataset.config;
              startIndex = config.pathStartIndex;
              endIndex = config.pathEndIndex;
              pathArr = config.lastPath;
              pathArr = dataset.getLinePath(dataStore, {
                begin: startIndex,
                end: endIndex
              });
              mainLineElement.attr({
                path: pathArr.getPathArr()
              });
            }
          }

          eventArgs = {
            index: index,
            dataIndex: index,
            datasetIndex: datasetIndex,
            startValue: plotItem.startValue,
            endValue: config.setValue,
            datasetName: plotItem.name,
            color: config.color,
            alpha: config.alpha,
            anchorBgColor: anchorProps.bgColor,
            anchorBgAlpha: anchorProps.anchorBgAlpha,
            anchorAlpha: anchorProps.anchorAlpha,
            anchorBorderColor: anchorProps.borderColor,
            anchorBorderThickness: anchorProps.borderThickness,
            anchorRadius: anchorProps.radius,
            anchorSides: anchorProps.sides,
            anchorStartAngle: anchorProps.startAngle,
            anchorHoverColor: hoverEffects.anchorColor,
            anchorHoverAlpha: hoverEffects.anchorAlpha,
            anchorHoverSides: hoverEffects.anchorSides,
            dashed: config.dashed,
            valuePosition: config.valuePosition,
            id: config.id
          };
          eventArgsArr = [chart.getFromEnv('chartInstance').id, eventArgs.dataIndex, eventArgs.datasetIndex, eventArgs.datasetName, eventArgs.startValue, eventArgs.endValue];
          element && _dragcolumn.updateDataValue.call(element, oriEvent, chart); // Update dataValue

          if (config._pointerDy) {
            hoverEnabled && dataset._hoverPlotAnchor(plotItem, ROLLOUT);
            chart.fireChartInstanceEvent('dataplotDragEnd', eventArgs); // Fire the ChartUpdated event

            chart.fireChartInstanceEvent('chartupdated', eventArgs, eventArgsArr);
          }

          setTooltext = (0, _lib.getValidValue)((0, _lib.parseUnsafeString)((0, _lib.pluck)(plotItem.tooltext, JSONData.plottooltext, dataset.getFromEnv('chart-attrib').plottooltext), false));

          if (setTooltext !== UNDEF) {
            parserConfig.formattedValue = config.toolTipValue;
            parserConfig.label = config.label;
            toolText = (0, _lib.parseTooltext)(setTooltext, macroIndices, parserConfig, {
              value: config.toolTipValue
            }, UNDEF, JSONData);
            config.setTooltext = toolText;
            setTooltext = toolText;
            config.toolText = toolText;
          }

          toolText = config.finalTooltext = config.toolText !== false ? setTooltext || config.toolText.substring(0, config.toolText.indexOf(config.formatedVal)) + config.toolTipValue : '';

          if (!(chartY >= yPos - tolerance && chartY <= yPos + tolerance && chartX <= xPos + tolerance && chartX >= xPos - tolerance)) {
            style.cursor = pointerMouseAttr;
          }

          config._dragBuffer = 0;
          config._pointerDy = 0;
          config.dragStart = false;
        }

        break;

      default:
        break;
    }
  }
  /**
   * This method handles all mouse events of an dataset.
   * @param {string} eventType name of the event
   * @param {number} plotIndex index of the plot where this event has been occured
   * @param {Event} e reference of the original mouse event
   */
  ;

  _proto._firePlotEvent = function _firePlotEvent(eventType, plotIndex, e) {
    var dataset = this,
        dataSetConf = dataset.config,
        chart = dataset.getFromEnv('chart'),
        chartConfig = dataset.getFromEnv('chartConfig'),
        drawTrendRegion = chartConfig.drawTrendRegion,
        // chartComp = chart.components,
    paper = dataset.getFromEnv('paper'),
        toolTipController = dataset.getFromEnv('toolTipController'),
        canvas = paper.canvas,
        style = canvas.style,
        datasetComp = dataset.components,
        plotItem = datasetComp.data[plotIndex],
        currentToolTip = dataSetConf.currentToolTip,
        originalEvent = e.originalEvent,
        pointerMouseAttr = DEFAULT,
        tolerance,
        coordinate,
        chartY,
        chartX,
        yPos,
        xPos,
        element,
        hoverEnabled,
        toolText,
        eventArgs,
        config,
        changedTouch,
        anchorProps;

    if (eventType === 'touchend') {
      changedTouch = originalEvent.changedTouches[0];
      originalEvent.pageX = changedTouch && changedTouch.pageX;
      originalEvent.pageY = changedTouch && changedTouch.pageY;
    }

    coordinate = (0, _lib.getMouseCoordinate)(chart.getFromEnv('chart-container'), originalEvent, chart);
    chartY = coordinate.chartY;
    chartX = coordinate.chartX;

    if (plotItem) {
      element = plotItem.graphics.element;
      config = plotItem.config;
      anchorProps = config.anchorProps;
      toolText = config.finalTooltext;
      hoverEnabled = config.hoverEffects.enabled;
      eventArgs = config.eventArgs;
      yPos = plotItem._yPos;
      xPos = plotItem._xPos;
      config.dragTolerance = config.dragTolerance < anchorProps.markerRadius ? anchorProps.markerRadius + 0.5 : config.dragTolerance;
      tolerance = mathMax(config.dragTolerance, config.hoverEffects.anchorRadius || 0) + 1;

      switch (eventType) {
        case 'fc-mouseover':
          if (config.allowDrag) {
            style.cursor = dragMouseAttr;
          }

          if (!config.dragStart && toolText && !config.dragStart && !drawTrendRegion) {
            if (currentToolTip) {
              toolTipController.draw(originalEvent, toolText, currentToolTip);
            } else {
              currentToolTip = dataSetConf.currentToolTip = toolTipController.draw(originalEvent, toolText);
            }
          }

          if (!config.dragStart) {
            hoverEnabled && dataset._hoverPlotAnchor(plotItem, ROLLOVER);
            element && chart.plotEventHandler(element, e, ROLLOVER, eventArgs);
          }

          break;

        case 'fc-mouseout':
          style.cursor = pointerMouseAttr;
          hoverEnabled && dataset._hoverPlotAnchor(plotItem, ROLLOUT);
          element && chart.plotEventHandler(element, e, ROLLOUT, eventArgs);
          toolTipController.hide(dataSetConf.currentToolTip);
          break;

        case 'fc-mousemove':
          if (!config.dragStart && toolText && chartY >= yPos - tolerance && chartY <= yPos + tolerance && chartX <= xPos + tolerance && chartX >= xPos - tolerance) {
            config.allowDrag && (style.cursor = dragMouseAttr);

            if (currentToolTip) {
              toolTipController.draw(originalEvent, toolText, currentToolTip);
            } else {
              currentToolTip = dataSetConf.currentToolTip = toolTipController.draw(originalEvent, toolText);
            }
          } else {
            toolTipController.hide(dataSetConf.currentToolTip);
          }

          break;

        case 'fc-click':
          element && chart.plotEventHandler(element, e, DATAPLOTCLICK, eventArgs);
          break;

        default:
          break;
      }
    }
  }
  /**
   * Function to restore the values of the dataset to its original
   */
  ;

  _proto.restore = function restore() {
    _dragcolumn._restore.call(this);
  }
  /**
   * Fucntion to get the updated values of data when they are dragged.
   * @return {Object} The corresponding data Array of the dataset containing the values of all the sets.
   */
  ;

  _proto.getJSONData = function getJSONData() {
    return _dragcolumn._getJSONData.call(this);
  };

  return DragAreaDataset;
}(_area.default);

exports._updateImage = _updateImage = DragAreaDataset.prototype.updateImage;
exports.__firePlotEvent = __firePlotEvent = DragAreaDataset.prototype._firePlotEvent;
exports.configurer = _configure = DragAreaDataset.prototype.configureAttributes;
exports._drag = _drag = DragAreaDataset.prototype.drag;
var _default = DragAreaDataset;
exports["default"] = _default;

/***/ }),

/***/ 1347:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _index = _interopRequireDefault(__webpack_require__(599));

var _default = {
  'initial.dataset.dragColumn': _index.default['initial.dataset.column']
};
exports["default"] = _default;

/***/ }),

/***/ 1346:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports.updateDataValue = exports._restore = exports._getJSONData = exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _column = _interopRequireDefault(__webpack_require__(595));

var _lib = __webpack_require__(274);

var _index = _interopRequireDefault(__webpack_require__(1347));

var _dependencyManager = __webpack_require__(282);

/* eslint require-jsdoc: 'error', valid-jsdoc: ["error", { "requireReturn": false }] */
var SETROLLOVERATTR = _lib.preDefStr.setRolloverAttrStr,
    SETROLLOUTATTR = _lib.preDefStr.setRolloutAttrStr,
    ROLLOUT = 'DataPlotRollOut',
    ROLLOVER = 'DataPlotRollOver',
    MOUSEOVER = 'mouseOver',
    MOUSEOUT = 'mouseOut',
    DEFAULT = 'default',
    DATAPLOTCLICK = _lib.preDefStr.DATAPLOTCLICK,
    dragMouseAttr = _lib.hasSVG && 'ns-resize' || 'n-resize',
    _getJSONData,
    _restore,
    UNDEF,
    updateDataValue = function updateDataValue(event, chart) {
  var element = this,
      yAxis = chart.getChildren('yAxis')[0],
      container = chart.getFromEnv('chart-container'),
      eventArgs = element.data('eventArgs'),
      mouseCoordinate;
  mouseCoordinate = (0, _lib.getMouseCoordinate)(container, event, chart);
  eventArgs.value = yAxis.getValue(mouseCoordinate.chartY);
  element.data('eventArgs', eventArgs);
};

exports.updateDataValue = updateDataValue;
exports._restore = _restore;
exports._getJSONData = _getJSONData;
(0, _dependencyManager.addDep)({
  name: 'dragColumnAnimation',
  type: 'animationRule',
  extension: _index.default
});
/**
 * dataset class of dragcolumn inheriting from column class
 */

var DragColumnDataset = /*#__PURE__*/function (_ColumnDataset) {
  (0, _inheritsLoose2.default)(DragColumnDataset, _ColumnDataset);

  function DragColumnDataset() {
    return _ColumnDataset.apply(this, arguments) || this;
  }

  var _proto = DragColumnDataset.prototype;

  /**
   * Sets the type of the component
   * @return {string} type
   */
  _proto.getType = function getType() {
    return 'dataset';
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */
  ;

  _proto.getName = function getName() {
    return 'dragColumn';
  }
  /**
    * Function for parsing all the attributes and value given by the user at chart,dataset and set level.
    * This function is called once from the init() function of the Column class.
    * @param  {Object} datasetJSON JSON for dataset configurations
    */
  ;

  _proto.configureAttributes = function configureAttributes(datasetJSON) {
    var dataset = this,
        conf = dataset.config,
        chartAttr = dataset.getFromEnv('chart-attrib'),
        JSONData = conf.JSONData;
    conf.allowDrag = (0, _lib.pluckNumber)(JSONData.allowdrag, 1);
    conf.allowNegDrag = (0, _lib.pluckNumber)(JSONData.allownegativedrag, 1);
    conf.allowAxisChange = (0, _lib.pluckNumber)(chartAttr.allowaxischange, 1);
    conf.snapToDivOnly = (0, _lib.pluckNumber)(chartAttr.snaptodivonly, 0);
    conf.snapToDiv = conf.snapToDivOnly ? 1 : (0, _lib.pluckNumber)(chartAttr.snaptodiv, 1);
    conf.doNotSnap = (0, _lib.pluckNumber)(chartAttr.donotsnap, 0);
    conf.snapToDivRelaxation = (0, _lib.pluckNumber)(chartAttr.snaptodivrelaxation, 10);

    if (conf.doNotSnap) {
      conf.snapToDiv = conf.snapToDivOnly = 0;
    }

    _ColumnDataset.prototype.configureAttributes.call(this, datasetJSON);
  }
  /**
   * method to configure a particular data plot object
   * @param {number} i index of the data object to be configured
   * @param {Object} setData particular plot information in of i'th index in input json
   */
  ;

  _proto._plotConfigure = function _plotConfigure(i, setData) {
    var conf = this.config,
        dataStore = this.components.data,
        dataObj,
        config;

    _ColumnDataset.prototype._plotConfigure.call(this, i, setData);

    dataObj = dataStore[i];
    config = dataObj.config;
    config.allowDrag = (0, _lib.pluckNumber)(setData.allowdrag, conf.allowDrag);
    config.allowNegDrag = (0, _lib.pluckNumber)(setData.allownegativedrag, conf.allowNegDrag);
  }
  /**
  * Function called when drag is triggered over the datasets
  * @param {String} action dragstart/dragmove/dragend action
  * @param {*} oriEvent The original mouse event
  * @param {*} index the index of the data over which drag is triggered
  * @param {*} coordinateData the mouse-coordinate wrt to the chart container
  */
  ;

  _proto.drag = function drag(action, oriEvent, index, coordinateData) {
    var dataset = this,
        coordinate = coordinateData,
        datasetConf = dataset.config,
        chart = dataset.getFromEnv('chart'),
        chartConfig = chart.config,
        canvasTop = chartConfig.canvasTop,
        canvasBottom = chartConfig.canvasBottom,
        setElement,
        config,
        toolTipController = dataset.getFromEnv('toolTipController'),
        NumberFormatter = dataset.getFromEnv('number-formatter'),
        dataStore = dataset.components.data,
        yActual,
        value,
        formattedVal,
        allowNegDrag,
        yPos,
        angle,
        height,
        rolloverdata,
        lowerDragBoundary,
        chartY,
        fill,
        rolloutedata,
        canvas = dataset.getFromEnv('paper').canvas,
        style = canvas.style,
        yAxis = dataset.getFromEnv('yAxis'),
        yBasePos = yAxis.yBasePos,
        plotIndex,
        eventArgs,
        eventArgsArr,
        yaxisName = chartConfig.yaxisname,
        xaxisName = chartConfig.xaxisname,
        parserConfig = {
      xaxisName: xaxisName,
      yaxisName: yaxisName
    },
        ticks = yAxis.getTicks(),
        data,
        tolerance = chartConfig.dragTolerance + 1,
        setTooltext,
        toolText,
        allowDrag,
        pointerMouseAttr = DEFAULT,
        macroIndices = [1, 2, 3, 4, 5, 6, 7],
        JSONData = datasetConf.JSONData,
        chartAttr = dataset.getFromEnv('chart-attrib'),
        useplotgradientcolor = chartConfig.useplotgradientcolor,
        useroundedges = chartConfig.useroundedges,
        chartContainer = dataset.getFromEnv('chart-container'),
        snapToDivRelaxation = (0, _lib.mathAbs)(yAxis.getValue(yAxis.getPixel(0) - datasetConf.snapToDivRelaxation)),
        snapPixel = datasetConf.snapToDivOnly ? (0, _lib.mathAbs)(ticks[1] - ticks[0]) * 0.5 : snapToDivRelaxation;
    coordinate = coordinate || (0, _lib.getMouseCoordinate)(chartContainer, oriEvent, chart);

    switch (action) {
      case 'dragstart':
        data = dataStore[index];
        config = data.config;
        setElement = data.graphics.element;
        yPos = data._yPos;
        height = data._height;
        yActual = config.setValue < 0 ? yPos + height : yPos;
        allowDrag = config.allowDrag;
        chartY = coordinate.chartY;

        if (allowDrag && chartY >= yActual - tolerance && chartY <= yActual + tolerance) {
          // set drag flag
          config.dragStart = true;
          config._pointerDy = 0;
          config._dragStartY = chartY; // difference on actualY and chartY

          config._dragBuffer = yActual - chartY;
          data.startValue = config.setValue;
          data.name = datasetConf.seriesname;
          data.datasetIndex = datasetConf.index;
          data.dragged = true;
        } else {
          config.dragStart = false;
        }

        break;

      case 'dragmove':
        data = dataStore[index];
        config = data.config;

        if (config.dragStart) {
          setElement = data.graphics.element;
          plotIndex = config.plotIndex;
          allowNegDrag = config.allowNegDrag;
          lowerDragBoundary = allowNegDrag ? canvasBottom : yBasePos;
          chartY = coordinate.chartY;
          config._rollOverResponseSetterFire = false;
          style.cursor = dragMouseAttr; // counter on drag move

          config._pointerDy++; // calculate chartY with _dragBuffer

          chartY += config._dragBuffer; // update chartY on canvas edge crossing

          if (chartY < canvasTop) {
            chartY = canvasTop;
          } else if (chartY > lowerDragBoundary) {
            chartY = lowerDragBoundary;
          } // calculate yPos


          yPos = yBasePos < chartY ? yBasePos : chartY; // calculate height

          height = (0, _lib.mathAbs)(yBasePos - chartY);
          data._yPos = yPos;
          data._height = height;
          yActual = yPos >= yBasePos ? yPos + height : yPos;
          config._y = value = config.setValue = yAxis.getValue(yActual);
          formattedVal = NumberFormatter.dataLabels(value);
          config.toolTipValue = formattedVal;
          config.displayValue = (0, _lib.pluck)(config.setDisplayValue, formattedVal);

          if (useplotgradientcolor && !useroundedges) {
            config.colorArr[0].FCcolor.angle = angle = yPos < yBasePos ? 90 : 270;
          }

          setElement.attr({
            y: data._yPos,
            height: data._height
          });
          dataset.parseLabelAttributes(data);
          dataset.drawLabel(plotIndex, plotIndex + 1);
          data.graphics.element = setElement;
          toolTipController.hide(datasetConf.currentToolTip); // fire dataplotDragStart event

          if (config._pointerDy === 1) {
            eventArgs = {
              index: index,
              dataIndex: index,
              datasetIndex: data.datasetIndex,
              startValue: data.startValue,
              datasetName: data.name,
              color: config.originalPlotColor,
              gradientColor: datasetConf.plotgradientcolor,
              alpha: config.plotFillAlpha,
              borderColor: datasetConf.plotbordercolor,
              borderAlpha: config.plotBorderAlpha,
              borderThickness: chartConfig.plotborderthickness,
              borderDashed: config.dashed,
              hoverColor: config.hoverColor,
              hoverAlpha: config.hoverAlpha,
              borderHoverColor: config.hoverBorderColor,
              borderHoverAlpha: config.hoverBorderAlpha
            };
            chart.fireChartInstanceEvent('dataplotDragStart', eventArgs);
          }
        }

        break;

      case 'dragend':
        var plotHeight;
        data = dataStore[index];
        config = data.config;
        plotHeight = data._height;

        if (config.dragStart) {
          yPos = data._yPos;
          setElement = data.graphics.element;
          setTooltext = (0, _lib.getValidValue)((0, _lib.parseUnsafeString)((0, _lib.pluck)(data.tooltext, JSONData.plottooltext, chartAttr.plottooltext), false));
          chartY = coordinate.chartY;
          dataset.setMaxMin(data); // chart._setDataLimits();

          if (config.givenPlotShowValue === 0) {
            config.showValue = 0;
          } else if (config.givenPlotShowValue === 1) {
            config.showValue = 1;
          } else if (config.givenPlotShowValue !== 1 && datasetConf.showValues) {
            if (Math.sqrt(plotHeight * plotHeight) < config.minplotheightforvalue) {
              config.showValue = 0;
            } else {
              config.showValue = 1;
            }
          }

          if (datasetConf.snapToDiv || datasetConf.snapToDivOnly) {
            config.setValue = (0, _lib.snapPoint)({
              snapPixel: snapPixel,
              datasetConf: datasetConf
            }, ticks, data);
            chartY = yAxis.getPixel(config.setValue);
            yPos = yBasePos < chartY ? yBasePos : chartY; // calculate height

            height = (0, _lib.mathAbs)(yBasePos - chartY);
            data._yPos = yPos;
            data._height = height;
            setElement.attr({
              y: yPos,
              height: height
            });
            formattedVal = NumberFormatter.dataLabels(config.setValue);
            config.toolTipValue = formattedVal;
            config.displayValue = (0, _lib.pluck)(config.setDisplayValue, formattedVal);
            dataset.parseLabelAttributes(data);
            dataset.drawLabel(plotIndex, plotIndex + 1);
          }

          eventArgs = {
            index: index,
            dataIndex: index,
            datasetIndex: data.datasetIndex,
            startValue: data.startValue,
            endValue: config.setValue,
            datasetName: data.name,
            color: config.originalPlotColor,
            gradientColor: datasetConf.plotgradientcolor,
            alpha: config.plotFillAlpha,
            borderColor: datasetConf.plotbordercolor,
            borderAlpha: config.plotBorderAlpha,
            borderThickness: chartConfig.plotborderthickness,
            borderDashed: config.dashed,
            hoverColor: config.hoverColor,
            hoverAlpha: config.hoverAlpha,
            borderHoverColor: config.hoverBorderColor,
            borderHoverAlpha: config.hoverBorderAlpha,
            id: config.id
          };
          eventArgsArr = [chart.getFromEnv('chartInstance').id, eventArgs.dataIndex, eventArgs.datasetIndex, eventArgs.datasetName, eventArgs.startValue, eventArgs.endValue]; // Update dataValue

          updateDataValue.call(setElement, oriEvent, chart);

          if (config._pointerDy) {
            chart.fireChartInstanceEvent('dataplotDragEnd', eventArgs); // Fire the ChartUpdated event

            chart.fireChartInstanceEvent('chartupdated', eventArgs, eventArgsArr);
          }

          if (useplotgradientcolor && !useroundedges) {
            angle = yPos >= yBasePos ? 90 : 270;

            if ((rolloverdata = setElement.data(SETROLLOVERATTR)) && rolloverdata.fill) {
              fill = rolloverdata.fill;
              fill = fill.split('-');
              fill[0] = angle;
              rolloverdata.fill = fill.join('-');
            }

            if ((rolloutedata = setElement.data(SETROLLOUTATTR)) && rolloutedata.fill) {
              fill = rolloutedata.fill;
              fill = fill.split('-');
              fill[0] = angle;
              rolloutedata.fill = fill.join('-');
            }
          } // difference on actualY and chartY


          config._dragBuffer = 0; // counter on drag move

          config._pointerDy = 0;

          if (setTooltext !== UNDEF) {
            parserConfig.formattedValue = config.toolTipValue;
            parserConfig.label = config.label;
            toolText = (0, _lib.parseTooltext)(setTooltext, macroIndices, parserConfig, {
              value: config.toolTipValue
            }, UNDEF, JSONData);
            config.setTooltext = toolText;
            setTooltext = toolText;
            config.toolText = toolText;
          }

          toolText = config.finalTooltext = config.toolText !== false ? config.toolText + (setTooltext ? '' : config.toolTipValue) : '';

          if (!(chartY >= yActual - tolerance && chartY <= yActual + tolerance)) {
            style.cursor = pointerMouseAttr;
          }

          config.dragStart = false;
        }

    }
  }
  /**
   * This method handles all mouse events of an dataset.
   * @param {string} eventType name of the event
   * @param {number} plotIndex index of the plot where this event has been occured
   * @param {Event} e reference of the original mouse event
   */
  ;

  _proto._firePlotEvent = function _firePlotEvent(eventType, plotIndex, e) {
    var dataset = this,
        chart = dataset.getFromEnv('chart'),
        datasetConf = dataset.config,
        currentToolTip = datasetConf.currentToolTip,
        chartConfig = dataset.getFromEnv('chartConfig'),
        drawTrendRegion = chartConfig.drawTrendRegion,
        // chartComp = chart.components,
    paper = dataset.getFromEnv('paper'),
        canvas = paper.canvas,
        style = canvas.style,
        toolTipController = dataset.getFromEnv('toolTipController'),
        data = dataset.components.data[plotIndex],
        config = data.config,
        setElement = data.graphics.element,
        toolText = config.finalTooltext || config.toolText,
        // tip = lib.toolTip,
    originalEvent = e.originalEvent,
        pointerMouseAttr = DEFAULT,
        tolerance,
        coordinate = (0, _lib.getMouseCoordinate)(dataset.getFromEnv('chart-container'), originalEvent, chart),
        chartY = coordinate.chartY,
        yPos = data._yPos,
        height = data._height,
        yAxis = dataset.getFromEnv('yAxis'),
        yBasePos = yAxis.yBasePos,
        allowDrag = config.allowDrag,
        yActual,
        colTop = yPos,
        colBottom = yPos + height;
    tolerance = chartConfig.dragTolerance + 1;
    yActual = yPos >= yBasePos ? yPos + height : yPos;

    if (setElement) {
      switch (eventType) {
        case 'fc-mouseover':
          if (chartY <= colBottom - tolerance && chartY >= colTop + tolerance && !drawTrendRegion && toolText) {
            if (currentToolTip) {
              toolTipController.draw(originalEvent, toolText, currentToolTip);
            } else {
              currentToolTip = datasetConf.currentToolTip = toolTipController.draw(originalEvent, toolText);
            }
          } // fire _rollOverResponseSetter if its not already fired and
          // cursor position is on column body


          if (!config._rollOverResponseSetterFire && chartY <= colBottom && chartY >= colTop) {
            DragColumnDataset._rolloverResponseSetter(chart, setElement, e, this); // set flag true as _rollOverResponseSetter is fired


            config._rollOverResponseSetterFire = true;
          }

          break;

        case 'fc-mouseout':
          style.cursor = pointerMouseAttr; // fire _rolloutResponseSetter if _rolloverResponseSetter is fired

          config._rollOverResponseSetterFire && DragColumnDataset._rolloutResponseSetter(chart, setElement, e, this); // set flag false as _rolloutResponseSetter is fired

          config._rollOverResponseSetterFire = false;
          toolTipController.hide(datasetConf.currentToolTip);
          break;

        case 'fc-click':
          chart.plotEventHandler(setElement, e, DATAPLOTCLICK);
          break;

        case 'fc-mousemove':
          if (!config.dragStart) {
            yActual = config.setValue < 0 ? yPos + height : yPos;

            if (allowDrag && chartY >= yActual - tolerance && chartY <= yActual + tolerance) {
              style.cursor = dragMouseAttr;
              toolTipController.hide(datasetConf.currentToolTip);
            } else {
              style.cursor = pointerMouseAttr;

              if (config._rollOverResponseSetterFire && !drawTrendRegion && toolText) {
                if (currentToolTip) {
                  toolTipController.draw(originalEvent, toolText, currentToolTip);
                } else {
                  currentToolTip = datasetConf.currentToolTip = toolTipController.draw(originalEvent, toolText);
                }
              }
            } // fire _rollOverResponseSetter if its not already fired and
            // cursor position is on column body


            if (!config._rollOverResponseSetterFire && chartY <= colBottom && chartY >= colTop) {
              DragColumnDataset._rolloverResponseSetter(chart, setElement, e);

              config._rollOverResponseSetterFire = true;
            } else if (config._rollOverResponseSetterFire && !(chartY <= colBottom && chartY >= colTop)) {
              toolTipController.hide(datasetConf.currentToolTip);
              config._rollOverResponseSetterFire = false;

              DragColumnDataset._rolloutResponseSetter(chart, setElement, e, this);
            }
          }

          break;
      }
    }
  }
  /**
   * Function called as a callback when mouse pointer hovers over a graphic element
   * @param {Object} chart The chart object
   * @param {Object} elem The graphic element for which the function is called
   * @param {Object} event The event against which the function is called.
   * @param {Component} dataset - dataset component
   */
  ;

  DragColumnDataset._rolloverResponseSetter = function _rolloverResponseSetter(chart, elem, event, dataset) {
    var elData = elem && elem.getData(),
        animationManager = chart.getFromEnv('animationManager'); // Check whether the plot is in dragged state or not if
    // drag then dont fire rolloverevent

    if (elem && elData.showHoverEffect !== 0 && elData.draged !== true && elem) {
      animationManager.setAnimationState(MOUSEOVER);
      animationManager.setAnimation({
        el: elem,
        label: 'rect',
        component: dataset,
        attr: elem.getData().setRolloverAttr
      });
      chart.plotEventHandler(elem, event, ROLLOVER);
    }
  }
  /**
   * Function called as a callback when mouse pointer hovers out a graphic element
   * @param {Object} chart The chart object
   * @param {Object} elem The graphic element for which the function is called
   * @param {Object} event The event against which the function is called.
   * @param {Component} dataset - dataset component
   */
  ;

  DragColumnDataset._rolloutResponseSetter = function _rolloutResponseSetter(chart, elem, event, dataset) {
    var elData = elem && elem.getData(),
        animationManager = chart.getFromEnv('animationManager'); // Check whether the plot is in draggedstate or not if drag then dont fire rolloutevent

    if (elem && elData.showHoverEffect !== 0 && elData.draged !== true) {
      animationManager.setAnimationState(MOUSEOUT);
      animationManager.setAnimation({
        el: elem,
        label: 'rect',
        component: dataset,
        attr: elem.getData().setRolloutAttr
      });
      chart.plotEventHandler(elem, event, ROLLOUT);
    }
  }
  /**
   * Fucntion to get the updated values of data when they are dragged.
   * @return {Object} The corresponding data Array of the dataset containing the values of all the sets.
   */
  ;

  _proto.getJSONData = function getJSONData() {
    var dataset = this,
        JSONData = dataset.config.JSONData.data,
        dataStore = dataset.components.data,
        dataArr = [],
        obj = {},
        updatedDataObj,
        dataObj,
        prop,
        len,
        i;

    for (i = 0, len = JSONData.length; i < len; i++) {
      dataObj = JSONData[i];
      updatedDataObj = dataStore[i];
      obj = {};

      for (prop in dataObj) {
        if (prop === 'value') {
          obj[prop] = updatedDataObj.config.setValue;
        } else {
          obj[prop] = dataObj[prop];
        }
      }

      dataArr.push(obj);
    }

    return {
      data: dataArr
    };
  }
  /**
   * Function to restore the values of the dataset to its original
   */
  ;

  _proto.restore = function restore() {
    var dataset = this;
    dataset.setData(dataset.config.JSONData, true);
  };

  return DragColumnDataset;
}(_column.default);

exports._getJSONData = _getJSONData = DragColumnDataset.prototype.getJSONData;
exports._restore = _restore = DragColumnDataset.prototype.restore;
var _default = DragColumnDataset;
exports["default"] = _default;

/***/ }),

/***/ 1358:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _index = _interopRequireDefault(__webpack_require__(619));

var _default = {
  '*.dataset.dragLine': _index.default['*.dataset.line']
};
exports["default"] = _default;

/***/ }),

/***/ 1355:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _line = _interopRequireDefault(__webpack_require__(616));

var _dragarea = __webpack_require__(1356);

var _lib = __webpack_require__(274);

var _dragcolumn = __webpack_require__(1346);

var _dependencyManager = __webpack_require__(282);

var _index = _interopRequireDefault(__webpack_require__(1358));

/* eslint require-jsdoc: 'error', valid-jsdoc: ["error", { "requireReturn": false }] */
(0, _dependencyManager.addDep)({
  name: 'dragLineAnimation',
  type: 'animationRule',
  extension: _index.default
});
/**
 * dataset class of dragcolumn inheriting from column class
 */

var DragLineDataset = /*#__PURE__*/function (_LineDataset) {
  (0, _inheritsLoose2.default)(DragLineDataset, _LineDataset);

  function DragLineDataset() {
    return _LineDataset.apply(this, arguments) || this;
  }

  var _proto = DragLineDataset.prototype;

  /**
   * Using fireplotevent of dragarea.
   */
  _proto._firePlotEvent = function _firePlotEvent() {
    _dragarea.__firePlotEvent.apply(this, arguments);
  }
  /**
   * Function to update image while dragging.
   * @param {Object} dataObj The object by which the dataset is to be updated.
   */
  ;

  _proto.updateImage = function updateImage(dataObj) {
    _dragarea._updateImage.call(this, dataObj);
  }
  /**
   * Function to manage drag over the datasets
   */
  ;

  _proto.drag = function drag() {
    _dragarea._drag.apply(this, arguments);
  }
  /**
   * Calling the configureAttributes of drag area.
   */
  ;

  _proto.configureAttributes = function configureAttributes() {
    _dragarea.configurer.apply(this, arguments);
  }
  /**
   * method to configure a particular data plot object
   * @param {number} i index of the data object to be configured
   * @param {Object} setData particular plot information in of i'th index in input json
   */
  ;

  _proto._plotConfigure = function _plotConfigure(i, setData) {
    var conf = this.config,
        dataStore = this.components.data,
        dataObj,
        config;

    _LineDataset.prototype._plotConfigure.call(this, i, setData);

    dataObj = dataStore[i];
    config = dataObj.config;
    config.allowDrag = (0, _lib.pluckNumber)(setData.allowdrag, conf.allowDrag);
    config.allowNegDrag = (0, _lib.pluckNumber)(setData.allownegativedrag, conf.allowNegDrag);
  }
  /**
   * Sets the type of the component
   * @return {string} type
   */
  ;

  _proto.getType = function getType() {
    return 'dataset';
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */
  ;

  _proto.getName = function getName() {
    return 'dragLine';
  }
  /**
   * Function to restore the values of the dataset to its original
   */
  ;

  _proto.restore = function restore() {
    _dragcolumn._restore.call(this);
  }
  /**
   * Fucntion to get the updated values of data when they are dragged.
   * @return {Object} The corresponding data Array of the dataset containing the values of all the sets.
   */
  ;

  _proto.getJSONData = function getJSONData() {
    return _dragcolumn._getJSONData.call(this);
  };

  return DragLineDataset;
}(_line.default);

var _default = DragLineDataset;
exports["default"] = _default;

/***/ }),

/***/ 1402:
/***/ ((__unused_webpack_module, exports) => {



exports.__esModule = true;
exports["default"] = void 0;
var _default = {
  'initial.dataset.dragNodeConnector': function initialDatasetDragNodeConnector() {
    return {
      'path.appearing': function pathAppearing() {
        return [{
          initialAttr: {
            opacity: 0
          },
          finalAttr: {
            opacity: 1
          },
          slot: 'plot'
        }];
      },
      'text.appearing': function textAppearing() {
        return [{
          initialAttr: {
            opacity: 0,
            'text-bound': 'none'
          },
          finalAttr: {
            opacity: 1
          },
          slot: 'final'
        }];
      },
      '*': null
    };
  }
};
exports["default"] = _default;

/***/ }),

/***/ 1401:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _dragnode = _interopRequireDefault(__webpack_require__(1397));

var _lib = __webpack_require__(274);

var _dependencyManager = __webpack_require__(282);

var _connectorAnimation = _interopRequireDefault(__webpack_require__(1402));

/* eslint require-jsdoc: 'error', valid-jsdoc: ["error", { "requireReturn": false }] */
var EVENTARGS = _lib.preDefStr.EVENTARGS,
    L = 'L',
    M = 'M',
    configStr = _lib.preDefStr.configStr,
    _getlinePath = function _getlinePath(connector) {
  var config = connector.config,
      fromPointObj = config.fromPointObj,
      toPointObj = config.toPointObj,
      fromX = config.fromX,
      fromY = config.fromY,
      toX = config.toX,
      toY = config.toY,
      path = [M, fromX, fromY],
      pointConfig;

  if (config.arrowAtStart) {
    pointConfig = fromPointObj.config;

    if (pointConfig.shapeType === _lib.SHAPE_RECT) {
      path = path.concat(DragNodeConnector._drawArrow(fromX, fromY, toX, toY, pointConfig.shapeArg.width, pointConfig.shapeArg.height));
    } else {
      path = path.concat(DragNodeConnector._drawArrow(fromX, fromY, toX, toY, pointConfig.shapeArg.radius));
    }
  } // Calculating path for connector Arrow


  if (config.arrowAtEnd) {
    pointConfig = toPointObj.config;

    if (pointConfig.shapeType === _lib.SHAPE_RECT) {
      path = path.concat(DragNodeConnector._drawArrow(toX, toY, fromX, fromY, pointConfig.shapeArg.width, pointConfig.shapeArg.height));
    } else {
      path = path.concat(DragNodeConnector._drawArrow(toX, toY, fromX, fromY, pointConfig.shapeArg.radius));
    }
  }

  path.push(L, toX, toY);
  return path;
},

/**
 * Helper function to create a RedRaphael group.
 * @param  {string} groupName                Name of the group to be created.
 * @param  {Element} parentContainer         The parent container in which the group will be appended.
 * @param {Object} dataset The concerned dataset
 * @return {Element}                         The group that was created.
 */
createGroup = function createGroup(groupName, parentContainer, dataset) {
  var animationManager = dataset.getFromEnv('animationManager');
  return animationManager.setAnimation({
    el: 'group',
    attr: {
      name: groupName
    },
    container: parentContainer,
    component: dataset,
    label: 'group'
  });
};

(0, _dependencyManager.addDep)({
  name: 'connectorAnimation',
  type: 'animationRule',
  extension: _connectorAnimation.default
});
/**
 * dataset class of dragcolumn inheriting from column class
 */

var DragNodeConnector = /*#__PURE__*/function (_DragNodeDataset) {
  (0, _inheritsLoose2.default)(DragNodeConnector, _DragNodeDataset);

  function DragNodeConnector() {
    return _DragNodeDataset.apply(this, arguments) || this;
  }

  var _proto = DragNodeConnector.prototype;

  /**
   * Sets the type of the component
   * @return {string} type
   */
  _proto.getType = function getType() {
    return 'dataset';
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */
  ;

  _proto.getName = function getName() {
    return 'dragNodeConnector';
  }
  /**
   * Function to set the index of the dataset from amongst the other datasets
   */
  ;

  _proto._setDatasetIndex = function _setDatasetIndex() {
    var dataset = this,
        chidrenArr = dataset.getLinkedParent().getChildren('connector');
    dataset.config.datasetIndex = chidrenArr.indexOf(dataset);
  }
  /**
    * Function for parsing all the attributes and value given by the user at chart and dataset level.
    * @param  {Object} datasetJSON JSON for dataset configurations
    * @return {boolean} if no datasetJSON is found
    */
  ;

  _proto.configureAttributes = function configureAttributes(datasetJSON) {
    if (datasetJSON) {
      this.trimData(datasetJSON);
      this.config.JSONData = datasetJSON;
    } else if (!datasetJSON && !this.config.JSONData) {
      return false;
    }

    var connectors = this,
        // chartObj = connectors.chart,
    // rawData = connectors.jsonData,
    chartAttr = connectors.getFromEnv('chart-attrib'),
        conf = connectors.config,
        // dataStore = connectors.components.data || (connectors.components.data = []),
    // dataStoreLen,
    connectorsObj = connectors.config.JSONData,
        connectorsArr = connectorsObj.connector,
        length = connectorsArr && connectorsArr.length,
        index,
        // seriesConnector,
    HUNDRED = _lib.HUNDREDSTRING;
    conf.connectorsTooltext = (0, _lib.getValidValue)((0, _lib.parseUnsafeString)((0, _lib.pluck)(connectorsObj.connectortooltext, chartAttr.connectortooltext), false)); // Extract attributes of this node.

    conf.stdThickness = (0, _lib.pluckNumber)(connectorsObj.stdthickness, 1);
    conf.conColor = (0, _lib.getFirstColor)((0, _lib.pluck)(connectorsObj.color, 'FF5904'));
    conf.conAlpha = (0, _lib.pluck)(connectorsObj.alpha, HUNDRED);
    conf.conDashGap = (0, _lib.pluckNumber)(connectorsObj.dashgap, 5);
    conf.conDashLen = (0, _lib.pluckNumber)(connectorsObj.dashlen, 5);
    conf.conDashed = Boolean((0, _lib.pluckNumber)(connectorsObj.dashed, 0));
    conf.arrowAtStart = Boolean((0, _lib.pluckNumber)(connectorsObj.arrowatstart, 1));
    conf.arrowAtEnd = Boolean((0, _lib.pluckNumber)(connectorsObj.arrowatend, 1));
    conf.conStrength = (0, _lib.pluckNumber)(connectorsObj.strength, 1);
    conf.toolTipSepChar = (0, _lib.pluck)(chartAttr.tooltipsepchar, ' - '); // seriesConnector = connectors.connector;

    conf.showTooltip = (0, _lib.pluckNumber)(chartAttr.showtooltip, 1);
    conf.showTextOutline = (0, _lib.pluckNumber)(chartAttr.textoutline, 0);
    conf.viewMode = (0, _lib.pluckNumber)(chartAttr.viewmode, 1); // dataStoreLen = dataStore.length;
    // if (dataStoreLen > length) {
    //     dataStore.splice(length, dataStoreLen - length);
    // }

    conf._refreshData = true;

    connectors._setDatasetIndex('connector'); // set the datasetIndex of the connectors


    for (index = 0; index < length; index += 1) {
      this._setConfigure(index, connectorsArr[index]);
    }

    conf._refreshData = true;
  }
  /**
   * Function for parsing all the attributes and value given by the user at set level.
   * @param {number} index The data index for which the configuration is to be parsed.
   * @param {Object} connectorObj It has the information of the data given by the user at the set level
   */
  ;

  _proto._setConfigure = function _setConfigure(index, connectorObj) {
    // connector label.
    var connector = this,
        connectorStore = connector.components.data || (connector.components.data = []),
        connObj = connectorStore[index] || (connectorStore[index] = connectorStore[index] = {}),
        conf = connector.config,
        // chartObj = connector.chart,
    connectorLabel = (0, _lib.parseUnsafeString)((0, _lib.pluck)(connectorObj.label, connectorObj.name)),
        setConAlpha = (0, _lib.pluck)(connectorObj.alpha, conf.conAlpha),
        smartLabel = connector.getFromEnv('smartLabel'),
        tooltipSepChar = conf.toolTipSepChar,
        defToolTextMacro = '$fromLabel' + tooltipSepChar + '$toLabel',
        setConColor = {
      FCcolor: {
        color: (0, _lib.getFirstColor)((0, _lib.pluck)(connectorObj.color, conf.conColor)),
        alpha: setConAlpha
      }
    },
        toolText,
        config,
        labelTextObj,
        connectorsTooltext = conf.connectorsTooltext,
        connectorToolText = (0, _lib.getValidValue)((0, _lib.parseUnsafeString)((0, _lib.pluck)(connectorObj.tooltext, connectorsTooltext), false)),
        boolCondition = Boolean((0, _lib.pluckNumber)(connectorObj.dashed, conf.conDashed));
    smartLabel.setStyle(connector.getFromEnv('dataLabelStyle'));
    smartLabel.useEllipsesOnOverflow(connector.getFromEnv('chartConfig').useEllipsesWhenOverflow);
    labelTextObj = smartLabel.getOriSize(connectorLabel);
    config = connObj.config = connObj.config || (connObj.config = {});
    !connObj.graphics && (connObj.graphics = {}); // create the tooltext

    if (!conf.showTooltip) {
      toolText = false;
    } else {
      // determine the tooltext then
      toolText = (0, _lib.pluck)(connectorToolText, connectorLabel ? '$label' : defToolTextMacro);
    }

    config = connObj.config = {
      _options: connectorObj,
      id: (0, _lib.pluck)(connectorObj.id, index).toString(),
      from: (0, _lib.pluck)(connectorObj.from, _lib.BLANK),
      to: (0, _lib.pluck)(connectorObj.to, _lib.BLANK),
      label: connectorLabel,
      toolText: toolText,
      customToolText: connectorToolText,
      color: setConColor,
      index: index,
      dashStyle: boolCondition ? (0, _lib.getDashStyle)((0, _lib.pluckNumber)(connectorObj.dashlen, conf.conDashLen), (0, _lib.pluckNumber)(connectorObj.dashgap, conf.conDashGap)) : _lib.DASH_DEF,
      dashed: connectorObj.dashed,
      dashlen: connectorObj.dashlen,
      dashgap: connectorObj.dashgap,
      arrowAtStart: Boolean((0, _lib.pluckNumber)(connectorObj.arrowatstart, conf.arrowAtStart)),
      arrowAtEnd: Boolean((0, _lib.pluckNumber)(connectorObj.arrowatend, conf.arrowAtEnd)),
      conStrength: (0, _lib.pluckNumber)(connectorObj.strength, conf.conStrength),
      link: connectorObj.link,
      stdThickness: conf.stdThickness,
      labelWidth: labelTextObj.widht,
      labelHeight: labelTextObj.height
    };
    config.datasetIndex = connector.config.datasetIndex;
    config.add = connectorObj.add;
    config.update = connectorObj.update;
    config.dataLabelStyle = connector._configureDataLabelStyle(connectorObj);

    if (conf._refreshData) {
      delete connObj.removed;
    }
  }
  /**
   * Function to create container at the dataset level
   */
  ;

  _proto.createContainer = function createContainer() {
    var dataset = this,
        parentContainer = dataset.getLinkedParent().getChildContainer();
    !dataset.getContainer('connectorGroup') && dataset.addContainer('connectorGroup', createGroup('connectorGroup', parentContainer.connectorGroup, dataset));
    !dataset.getContainer('connectorDataLabelGroup') && dataset.addContainer('connectorDataLabelGroup', createGroup('connectorDataLabelGroup', parentContainer.connectorGroup, dataset));
  }
  /**
   * Function ot draw the entire dataset
   */
  ;

  _proto.draw = function draw() {
    var connectors = this,
        // chart = connectors.chart,
    manager = connectors.getLinkedParent(),
        conf = connectors.config,
        // chartObj = connectors.chart,
    // chartComp = chartObj.components,
    // chartGraphics = chart.graphics,
    // nodes = manager.nodes,
    connectorStore = connectors.components.data,
        connector,
        fromId,
        toId,
        // paper = connectors.getFromEnv('paper'),
    // jobList = chart.getJobList(),
    // datasetGroup = chartGraphics.datasetGroup,
    fromPointObj,
        toPointObj,
        style = connectors.getFromEnv('dataLabelStyle'),
        // graphics,
    i,
        length = connectorStore.length,
        removeDataArr = connectors.components.removeDataArr || [],
        removeDataArrLen = removeDataArr.length,
        // connectorsGroup,
    config; // if (!connectorsGroup) {
    //     connectorsGroup = connectors.graphics.connectorGroup =
    //         connectors.graphics.connectorGroup || paper.group('connectorGroup').insertBefore(datasetGroup);
    // }

    connectors.createContainer(); // connectorsGroup = connectors.getContainer('connectorGroup');

    conf.cleared = false;
    connectors.getContainer('connectorDataLabelGroup').css(style);

    for (i = 0; i < length; i++) {
      connector = connectorStore[i];
      config = connector.config; // graphics = connector.graphics || (connector.graphics = {});

      fromId = config.from;
      toId = config.to;
      fromPointObj = manager.getNode(fromId);
      toPointObj = manager.getNode(toId);

      if (fromPointObj && toPointObj && config.deleted !== true) {
        connectors.drawConnector(connector, fromPointObj, toPointObj, i);
      }
    }

    connectors.config.drawn = true;

    for (i = 0; i < removeDataArrLen; i++) {
      connectors._removeDataVisuals(removeDataArr.shift());
    }
  }
  /**
   * Parsing and calculation of attributes takes place
   *
   * @param {any} connector connector
   * @param {any} fromPointObj from node
   * @param {any} toPointObj to node
   * @memberof DragNodeConnector
   */
  ;

  _proto.parsePlotAttributes = function parsePlotAttributes(connector, fromPointObj, toPointObj) {
    var dataset = this,
        fromX,
        toX,
        fromY,
        toY,
        strokeWidth,
        NumberFormatter = dataset.getFromEnv('number-formatter'),
        pathArr,
        startConnectors,
        endConnectors,
        config = connector.config,
        fromConf,
        toConf,
        eventArgs = config.eventArgs || (config.eventArgs = {}),
        color,
        id;
    config.fromPointObj = fromPointObj;
    config.toPointObj = toPointObj;
    fromConf = fromPointObj.config;
    toConf = toPointObj.config;
    config.fromX = fromX = fromConf._xPos;
    config.fromY = fromY = fromConf._yPos;
    config.toX = toX = toConf._xPos;
    config.toY = toY = toConf._yPos;
    config._labelX = (fromX + toX) / 2;
    config._labelY = (fromY + toY) / 2;
    config.strokeWidth = strokeWidth = config.conStrength * config.stdThickness;
    color = config.color;
    config.textBgColor = color && color.FCcolor && color.FCcolor.color;
    eventArgs.label = config.label;
    eventArgs.arrowAtStart = config.arrowAtStart;
    eventArgs.arrowAtEnd = config.arrowAtEnd;
    eventArgs.link = config.link;
    eventArgs.id = config.id;
    eventArgs.fromNodeId = fromConf.id;
    eventArgs.toNodeId = toConf.id;
    config.toolText = (0, _lib.parseTooltext)(config.toolText, [3, 83, 84, 85, 86, 87, 88, 89, 90, 91, 92], {
      label: config.label,
      fromXValue: NumberFormatter.dataLabels(fromPointObj.config.x),
      fromYValue: NumberFormatter.dataLabels(fromPointObj.config.y),
      fromXDataValue: fromPointObj.config.x,
      fromYDataValue: fromPointObj.config.y,
      fromLabel: (0, _lib.pluck)(fromPointObj.config.displayValue, fromPointObj.config.id),
      toXValue: NumberFormatter.dataLabels(toPointObj.config.x),
      toYValue: NumberFormatter.dataLabels(toPointObj.config.y),
      toXDataValue: toPointObj.config.x,
      toYDataValue: toPointObj.config.y,
      toLabel: (0, _lib.pluck)(toPointObj.config.displayValue, toPointObj.config.id)
    });
    fromConf = fromPointObj.config;
    toConf = toPointObj.config;
    startConnectors = fromConf.startConnectors || (fromConf.startConnectors = {});
    endConnectors = toConf.endConnectors || (toConf.endConnectors = {});
    id = connector.config.id + '-' + fromConf.id + '-' + toConf.id;
    startConnectors[id] = connector;
    endConnectors[id] = connector;
    pathArr = _getlinePath(connector);
    config.props = {
      element: {
        attr: {
          path: pathArr,
          'stroke-width': strokeWidth,
          'stroke-dasharray': config.dashStyle,
          cursor: config.link ? _lib.POINTER : _lib.BLANKSTRING,
          stroke: (0, _lib.toRaphaelColor)(color)
        }
      }
    };
  }
  /**
   * Parse attributes and calculates position during post space management
   *
   * @memberof DragNodeConnector
   */
  ;

  _proto.allocatePosition = function allocatePosition() {
    var connectors = this,
        i,
        connector,
        config,
        fromId,
        toId,
        fromPointObj,
        toPointObj,
        manager = connectors.getLinkedParent(),
        connectorStore = connectors.components.data,
        len = connectorStore.length;

    for (i = 0; i < len; i++) {
      connector = connectorStore[i];
      config = connector.config; // graphics = connector.graphics || (connector.graphics = {});

      fromId = config.from;
      toId = config.to;
      fromPointObj = manager.getNode(fromId);
      toPointObj = manager.getNode(toId);

      if (fromPointObj && toPointObj && config.deleted !== true) {
        connectors.parsePlotAttributes(connector, fromPointObj, toPointObj, i);
      }
    }
  }
  /**
   * Function to draw individual connectors
   * @param {Object} connector Object having information about the connector that is to be drawn
   * @param {Object} fromPointObj Object having the information about the node from which the connector is to be drawn
   * @param {Object} toPointObj Object having the information about the node to which the connector is to be drawn
   */
  ;

  _proto.drawConnector = function drawConnector(connector) {
    var dataset = this,
        toolTipController = dataset.getFromEnv('toolTipController'),
        animationManager = dataset.getFromEnv('animationManager'),
        graphics = connector.graphics,
        element,
        elementCheck,
        connectorsGroup = dataset.getContainer('connectorGroup'),
        config = connector.config,
        tooltext = config.toolText,
        eventArgs = config.eventArgs || (config.eventArgs = {}),
        conf = dataset.config,
        pool = dataset.components.pool || {};

    if (connector.removed) {
      return;
    }

    element = elementCheck = graphics.graphic;

    if (!graphics.graphic) {
      if (pool.graphic && pool.graphic.path && pool.graphic.path.length) {
        elementCheck = graphics.graphic = pool.graphic.path.shift();
      }
    } // draw the line


    element = animationManager.setAnimation({
      el: elementCheck || 'path',
      container: connectorsGroup,
      attr: config.props.element.attr,
      label: 'path',
      component: dataset
    });

    if (!elementCheck) {
      graphics.graphic = element;
      element.on('fc-mousedown', dataset.mouseDown).on('fc-mousemove', dataset.mousemove).on('fc-mouseup', dataset.mouseup).hover(dataset.hoverIn, dataset.hoverOut);
    }

    element.show().data(EVENTARGS, eventArgs).data('viewMode', conf.viewMode).data(configStr, config).data('dataset', dataset);
    conf.showTooltip ? toolTipController.enableToolTip(element, tooltext) : toolTipController.disableToolTip(element); // If this is not the first render then label is drawn instantly otherwise it is drawn in
    // another thread for performance optimization

    dataset.drawLabel(connector);
  }
  /**
   * Function to draw individual labels of the connector
   * @param {Object} connector Object having information about the connector whose label is to be drawn
   */
  ;

  _proto.drawLabel = function drawLabel(connector) {
    var dataset = this,
        toolTipController = dataset.getFromEnv('toolTipController'),
        // groupManager = dataset.groupManager,
    // nodes = groupManager.nodes,
    conf = dataset.config,
        animationManager = dataset.getFromEnv('animationManager'),
        // chart = dataset.chart,
    // animationObj = chart.get('config', 'animationObj'),
    connectorsGroup = dataset.getContainer('connectorDataLabelGroup'),
        // dummyAnimObj = animationObj.animObj,
    // dummyAnimElem = animationObj.dummyObj,
    // animType = animationObj.animType,
    // animationDuration = animationObj.duration,
    config,
        label,
        tooltext,
        labelAttrs,
        style = dataset.getFromEnv('dataLabelStyle'),
        labelStyle,
        labelElement,
        labelElementCheck,
        graphics,
        connectorObj,
        i,
        labelX,
        labelY,
        textBgColor,
        dataStore = dataset.components.data,
        pool = dataset.components.pool || {},
        len = dataStore.length,
        // fromPointObj,
    // toPointObj,
    // fromId,
    // toId,
    drawIndividualLabel = function drawIndividualLabel(labelConnector) {
      config = labelConnector.config;
      tooltext = config.toolText;
      graphics = labelConnector.graphics;
      label = config.label;
      labelX = config._labelX;
      labelY = config._labelY;
      labelStyle = config.dataLabelStyle || style; // fromId = config.from;
      // toId = config.to;
      // fromPointObj = nodes[fromId];
      // toPointObj = nodes[toId];

      textBgColor = config.textBgColor;

      if (label) {
        labelElementCheck = graphics.text = graphics.text || pool.element && pool.element.text && pool.element.text.shift();
        labelAttrs = {
          text: label,
          fill: labelStyle.color,
          direction: _lib.BLANKSTRING,
          cursor: config.link ? _lib.POINTER : _lib.BLANKSTRING,
          'text-bound': [(0, _lib.pluck)(labelStyle.backgroundColor, textBgColor), (0, _lib.pluck)(labelStyle.borderColor, textBgColor), 1, '2'],
          x: labelX,
          y: labelY
        }; // Drawing the connector Label

        labelElement = animationManager.setAnimation({
          el: labelElementCheck || 'text',
          attr: labelAttrs,
          container: connectorsGroup,
          label: 'text',
          component: dataset
        });
        labelElement.show();
        labelElement.outlineText(conf.showTextOutline, labelAttrs.fill);

        if (!labelElementCheck) {
          graphics.text = labelElement;
          labelElement.on('fc-mousedown', dataset.mouseDown).on('fc-mousemove', dataset.mousemove).on('fc-mouseup', dataset.mouseup).hover(dataset.hoverIn, dataset.hoverOut);
        }

        labelElement.data(EVENTARGS, config.eventArgs).data('viewMode', conf.viewMode).data(configStr, config).data('dataset', dataset);
        conf.showTooltip ? toolTipController.enableToolTip(labelElement, tooltext) : toolTipController.disableToolTip(labelElement);
      } else {
        graphics.text && graphics.text.hide();
      }
    };

    if (connector) {
      drawIndividualLabel(connector);
    } else {
      for (i = 0; i < len; i++) {
        connectorObj = dataStore[i];
        drawIndividualLabel(connectorObj);
      }
    }
  }
  /**
   * Callback function when mouse is pressed down over the connector
   */
  ;

  _proto.mouseDown = function mouseDown() {
    var ele = this,
        // config = ele.data(configStr),
    dataset = ele.data('dataset'),
        manager = dataset.getLinkedParent(); // chart = dataset.chart,
    // conf = dataset.config,
    // options = config || {};

    manager.clearLongPress(); // Whether to fire the click event ot not

    ele.data('fire_click_event', 1);
    manager.triggerConnectorUI(ele);
  }
  /**
   * Callback function when mouse is moved over a connector
   */
  ;

  _proto.mousemove = function mousemove() {
    var ele = this,
        dataset = ele.data('dataset'),
        manager = dataset.getLinkedParent(); // Whether to fire the click event ot not

    ele.data('fire_click_event', 0);
    manager.clearLongPress();
  }
  /**
   * Callback function mouse press is released from over a connector
   */
  ;

  _proto.mouseup = function mouseup() {
    var ele = this,
        dataset = ele.data('dataset'),
        manager = dataset.getLinkedParent();
    manager.clearLongPress(); // plotEventHandler.call(ele, chart, data, 'ConnectorClick');
  };

  _proto.hoverIn = function hoverIn(e) {
    var ele = this,
        dataset = ele.data('dataset'),
        chart = dataset.getFromEnv('chart');
    chart.plotEventHandler(ele, e, 'ConnectorRollover');
  };

  _proto.hoverOut = function hoverOut(e) {
    var ele = this,
        dataset = ele.data('dataset'),
        chart = dataset.getFromEnv('chart');
    chart.plotEventHandler(ele, e, 'ConnectorRollout');
  }
  /**
   * Function to draw arrow heads for the connectors
   * @param {number} X1 The required dimenions for drawing the arrow head
   * @param {number} Y1 The required dimenions for drawing the arrow head
   * @param {number} X2 The required dimenions for drawing the arrow head
   * @param {number} Y2 The required dimenions for drawing the arrow head
   * @param {number} R The required dimenions for drawing the arrow head
   * @param {number} H The required dimenions for drawing the arrow head
   * @return {Array} contains the path coordinates
   */
  ;

  DragNodeConnector._drawArrow = function _drawArrow(X1, Y1, X2, Y2, R, H) {
    var tanganent = (Y1 - Y2) / (X1 - X2),
        angle = Math.atan(tanganent),
        PX,
        PY,
        RHlf,
        HHlf,
        arr = []; // make all angle as positive

    if (angle < 0) {
      angle = 2 * Math.PI + angle;
    }

    if (Y2 > Y1) {
      // PI >angle > 0
      if (X2 >= X1 && angle > Math.PI || X2 < X1 && angle > Math.PI) {
        angle = angle - Math.PI;
      }
    } else {
      /// PI <= angle < 360 || angle == 0
      // angle may not be 360 in that case it will be 0 as atan work
      if (X2 >= X1 && angle < Math.PI && angle !== 0 || X2 < X1 && angle < Math.PI) {
        angle = angle + Math.PI;
      }
    }

    if (typeof H === 'undefined') {
      // arrow start point
      PX = X1 + R * Math.cos(angle);
      PY = Y1 + R * Math.sin(angle);
    } else {
      // rectangle
      RHlf = Math.abs(R) / 2;
      HHlf = Math.abs(H) / 2; // asume it will intersect a vertical side

      PX = X1 + (RHlf = X1 < X2 ? RHlf : -RHlf);
      PY = Y1 + RHlf * Math.tan(angle); // validate PY
      // if not validate then it will cross the horizontal axis

      if (Math.abs(Y1 - PY) > Math.abs(HHlf)) {
        PY = Y1 + (HHlf = Y1 < Y2 ? HHlf : -HHlf);
        PX = X1 + HHlf / Math.tan(angle);
      }
    }

    arr.push(L, PX, PY, // arrowone half
    PX + 10 * Math.cos(angle + 0.79), PY + 10 * Math.sin(angle + 0.79), // arrowone half
    M, PX + 10 * Math.cos(angle - 0.79), PY + 10 * Math.sin(angle - 0.79), // return to th eedege
    L, PX, PY);
    return arr;
  }
  /**
   * Function to remove data during update if number of data has reduced than the previous render
   * @param {number} indexVal The data index from which data has to be removed.
   * @param {number} stretch The index upto which data has to be removed
   */
  ;

  _proto.removeData = function removeData(indexVal, stretch) {
    var dataset = this,
        index = indexVal,
        components = dataset.components,
        dataStore = components.data;

    if (index < 0) {
      index = 0;
    }

    components.removeDataArr = dataStore.splice(index, stretch);
  }
  /**
   * function to Remove data plots if the number of current data plots/categories
   * is more than the existing ones.
   * @param  {Object} datasetJSON JSON for dataset configurations
   */
  ;

  _proto.trimData = function trimData(datasetJSON) {
    if (!this.config.JSONData) {
      return;
    }

    var dataSet = this,
        prevData = dataSet.components,
        prevDataLength = prevData.data && prevData.data.length,
        currDataLength = datasetJSON.connector && datasetJSON.connector.length || 0,
        dataDiff = prevDataLength - currDataLength; // Removing data plots if the number of current data plots/categories
    // is more than the existing ones.

    if (dataDiff > 0) {
      dataSet.removeData(currDataLength, dataDiff);
    }
  };

  return DragNodeConnector;
}(_dragnode.default);

var _default = DragNodeConnector;
exports["default"] = _default;

/***/ }),

/***/ 1399:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _dragnode = _interopRequireDefault(__webpack_require__(1397));

var _lib = __webpack_require__(274);

var _dependencyManager = __webpack_require__(282);

var _draggablelabelAnimation = _interopRequireDefault(__webpack_require__(1400));

/* eslint require-jsdoc: 'error', valid-jsdoc: ["error", { "requireReturn": false }] */
var PX = _lib.preDefStr.PX,
    EVENTARGS = 'eventArgs',
    LABELDRAGEND = 'labeldragend',
    TRACKER_FILL = 'rgba(192,192,192,' + (_lib.isIE ? 0.002 : 0.000001) + ')'; // invisible but clickable

/**
 * Dataset class for draggable labels
 */

var DragNodeLabels = /*#__PURE__*/function (_DragNodeDataset) {
  (0, _inheritsLoose2.default)(DragNodeLabels, _DragNodeDataset);

  /**
   * Creates an instance of DragNodeLabels.
   * @memberof DragNodeLabels
   */
  function DragNodeLabels() {
    var _this;

    _this = _DragNodeDataset.call(this) || this;
    (0, _dependencyManager.addDep)({
      name: 'draggablelabelAnimation',
      type: 'animationRule',
      extension: _draggablelabelAnimation.default
    });
    return _this;
  }
  /**
   * Sets the type of the component
   * @return {string} type
   */


  var _proto = DragNodeLabels.prototype;

  _proto.getType = function getType() {
    return 'dataset';
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */
  ;

  _proto.getName = function getName() {
    return 'dragNodeLabels';
  }
  /**
    * Function for parsing all the attributes and value given by the user at chart and dataset level.
    * @param  {Object} datasetJSON JSON for dataset configurations
    * @return {boolean} if no datasetJSON is found
    */
  ;

  _proto.configure = function configure(datasetJSON) {
    if (datasetJSON) {
      this.trimData(datasetJSON);
      this.config.JSONData = datasetJSON.label;
    } else if (!datasetJSON && !this.config.JSONData) {
      return false;
    }

    var dataset = this,
        // chart = dataset.chart,
    // jsonData = chart.jsonData,
    chartAttr = dataset.getFromEnv('chart-attrib'),
        conf = dataset.config,
        setDataArr = dataset.config.JSONData || [],
        len = setDataArr.length,
        // dataStoreLen,
    dataStore = dataset.components.data,
        i;
    conf.viewMode = (0, _lib.pluckNumber)(chartAttr.viewmode, 0);

    if (!dataStore) {
      dataStore = dataset.components.data = [];
    } // dataStoreLen = dataStore.length;


    for (i = 0; i < len; i++) {
      dataset._setConfigure(i);
    }
  }
  /**
   * Function for parsing all the attributes and value given by the user at set level.
   * @param {number} index The data index for which the configuration is to be parsed.
   * @param {Object} updateObj It has the information of the data given by the user at the set level
   */
  ;

  _proto._setConfigure = function _setConfigure(index, updateObj) {
    var dataset = this,
        setDataArr = dataset.config.JSONData,
        // chart = dataset.chart,
    setData = updateObj || setDataArr[index],
        dataStore = dataset.components.data,
        dataObj,
        text,
        // style = chart.config.style,
    inCanvasStyle = dataset.getFromEnv('style').inCanvasStyle,
        inCanFontSize = inCanvasStyle.fontSize,
        // labelColor,
    // labelBGColor,
    config,
        // labelBDColor,
    // alpha,
    labelFontSize;
    dataObj = dataStore[index];
    !dataObj && (dataObj = dataStore[index] = {});
    !dataObj.graphics && (dataObj.graphics = {});
    config = dataObj.config = dataObj.config || (dataObj.config = {});
    text = (0, _lib.parseUnsafeString)((0, _lib.pluck)(setData.text, setData.label));
    config._options = setData;
    config.add = setData.add;

    if (text) {
      config.text = text;
      config.x = setData.x || 0;
      config.y = setData.y || 0;
      config.labelFontSize = labelFontSize = (0, _lib.pluckNumber)(setData.fontsize, inCanFontSize);
      config.labelColor = (0, _lib.hashify)((0, _lib.pluck)(setData.color, inCanvasStyle.color));
      config.alpha = (0, _lib.pluckNumber)(setData.alpha, 100) / 100;
      config.allowDrag = (0, _lib.pluckNumber)(setData.allowdrag, 1);
      config.padding = (0, _lib.pluckNumber)(setData.padding, 5); // config.labelColor = labelColor = convertColor(pluck(setData.color, inCanvasStyle.color),
      //   pluckNumber(setData.alpha, 100));

      if (setData.fontsize) {
        config.labelCSS = {
          fontSize: labelFontSize + PX
        };
      } else {
        config.labelCSS = {};
      }

      config.labelBGColor = (0, _lib.pluck)(setData.bgcolor && setData.bgcolor.replace(_lib.dropHash, _lib.HASHSTRING));
      config.labelBDColor = (0, _lib.pluck)(setData.bordercolor && setData.bordercolor.replace(_lib.dropHash, _lib.HASHSTRING));
      config.link = setData.link;
      config.borderThickness = setData.borderthickness;
      config.dashLen = setData.dashlen;
      config.dashGap = setData.dashgap;
      config.dashed = setData.dashed;
      config.radius = setData.radius;
    }
  }
  /**
   * Get jsondata of dragable label dataset
   * @return {Object} The JSON data
   */
  ;

  _proto.getJSONData = function getJSONData() {
    var dataset = this,
        dataStore = dataset.components.data,
        len = dataStore.length,
        jsonData = [],
        dataObj,
        i;

    for (i = 0; i < len; i++) {
      dataObj = dataStore[i];

      if (!dataObj.removed) {
        if (dataObj.config._options) {
          jsonData.push(dataObj.config._options);
        }
      }
    }

    return jsonData;
  }
  /**
   * Function to create container at the dataset level
   */
  ;

  _proto.createContainer = function createContainer() {
    var dataset = this,
        animationManager = dataset.getFromEnv('animationManager'),
        parentContainer = dataset.getLinkedParent().getChildContainer();
    !dataset.getContainer('dragLabelGroup') && dataset.addContainer('dragLabelGroup', animationManager.setAnimation({
      el: 'group',
      attr: {
        name: 'dragLabelGroup'
      },
      label: 'group',
      component: dataset,
      container: parentContainer.defaultVcanvasGroup
    }));
  }
  /**
   * Parses and sets the attributes during post space management
   *
   * @memberof DragNodeLabels
   */
  ;

  _proto.allocatePosition = function allocatePosition() {
    this.parsePlotAttributes();
  }
  /**
   * Parsing of attributes
   *
   * @memberof DragNodeLabels
   */
  ;

  _proto.parsePlotAttributes = function parsePlotAttributes() {
    var dataset = this,
        dataStore = dataset.components.data,
        yAxis = dataset.getFromEnv('yAxis'),
        xAxis = dataset.getFromEnv('xAxis'),
        SmartLabel = dataset.getFromEnv('smartLabel'),
        style = dataset.getFromEnv('dataLabelStyle'),
        dashLen,
        dashGap,
        dashed,
        x,
        y,
        color,
        text,
        bgColor,
        borderColor,
        padding,
        config,
        attr,
        // alpha,
    dataObj,
        allowDrag,
        fontSize,
        radius,
        dim,
        borderThickness,
        len = dataStore && dataStore.length,
        lStyle,
        chartConfig = dataset.getFromEnv('chartConfig'),
        i,
        labelCSS;

    for (i = 0; i < len; i++) {
      dataObj = dataStore[i];

      if (dataObj.removed) {
        continue;
      }

      config = dataObj.config;
      !dataObj.graphics && (dataObj.graphics = {});
      config.index = i;
      x = xAxis.getPixel(config.x);
      y = yAxis.getPixel(config.y);
      text = config.text;
      bgColor = config.labelBGColor;
      borderColor = config.labelBDColor;
      padding = config.padding;
      allowDrag = config.allowDrag;
      fontSize = config.labelFontSize;
      color = config.labelColor;
      radius = config.radius;
      dashed = config.dashed;
      borderThickness = config.borderThickness;
      dashLen = config.dashLen;
      dashGap = config.dashGap;
      borderThickness = config.borderThickness;
      labelCSS = config.labelCSS;
      attr = {
        x: x,
        y: y,
        text: text,
        align: _lib.POSITION_CENTER,
        fill: color,
        'text-bound': [bgColor || _lib.BLANKSTRING, borderColor || _lib.BLANKSTRING, (0, _lib.pluckNumber)(borderThickness, 1), padding, (0, _lib.pluckNumber)(radius, 0), (0, _lib.pluckNumber)(dashed, 0) ? (0, _lib.getDashStyle)((0, _lib.pluckNumber)(dashLen, 5), (0, _lib.pluckNumber)(dashGap, 4)) : _lib.DASH_DEF],
        visibility: _lib.visibleStr
      };
      lStyle = {
        backgroundColor: bgColor,
        borderColor: borderColor,
        borderPadding: padding,
        fontSize: fontSize + _lib.PXSTRING,
        fontStyle: style.fontStyle,
        fontWeight: style.fontWeight,
        borderRadius: 0,
        borderDash: _lib.DASH_DEF,
        fontFamily: style.fontFamily
      };
      (0, _lib.setLineHeight)(lStyle);
      SmartLabel.useEllipsesOnOverflow(chartConfig.useEllipsesWhenOverflow);
      SmartLabel.setStyle(lStyle); // Explicitly added for IE8. If lineHeight is added for any text it gets updated to all the spans. So to avoid that line-height
      // is applied.

      labelCSS['line-height'] = lStyle.lineHeight;
      config.eventArgs = {
        link: config.link,
        text: text,
        x: x,
        y: y,
        allowdrag: allowDrag,
        sourceType: 'labelnode'
      };
      config.props = {
        element: {
          attr: attr
        }
      };
      config.labelCSSApplied = labelCSS;
      dim = SmartLabel.getOriSize(text);
      config.width = dim.width;
      config.height = dim.height;
      config.xPos = x;
      config.yPos = y;
    }
  }
  /**
   * Function ot draw the entire dataset
   */
  ;

  _proto.draw = function draw() {
    var dataset = this,
        dataStore = dataset.components.data,
        animationManager = dataset.getFromEnv('animationManager'),
        style = dataset.getFromEnv('dataLabelStyle'),
        config,
        dataObj,
        element,
        elementCheck,
        len = dataStore && dataStore.length,
        removeDataArr = dataset.components.removeDataArr || [],
        removeDataArrLen = removeDataArr.length,
        i,
        dataLabelContainer,
        labelCSS;
    dataset.createContainer();
    dataLabelContainer = dataset.getContainer('dragLabelGroup');
    dataLabelContainer.css({
      'font-weight': style.fontWeight,
      'font-style': style.fontStyle,
      'font-size': style.fontSize,
      'font-family': style.fontFamily
    });

    for (i = 0; i < len; i++) {
      dataObj = dataStore[i];

      if (dataObj.removed) {
        continue;
      }

      config = dataObj.config;
      elementCheck = dataObj.graphics.element;
      element = animationManager.setAnimation({
        el: elementCheck || 'text',
        container: dataLabelContainer,
        css: config.labelCSS,
        attr: config.props.element.attr,
        component: dataset
      });

      if (!elementCheck) {
        dataObj.graphics.element = element;
      } else {
        // If label css was applied on this element and now label css is not given then remove css
        if (config.labelCSSApplied && !labelCSS) {
          element.removeCSS();
        }

        element.show().css(config.labelCSS);
      }

      element.data('eventArgs', config.eventArgs);
    }

    dataset.drawTracker();

    for (i = 0; i < removeDataArrLen; i++) {
      dataset._removeDataVisuals(removeDataArr.shift());
    }
  }
  /**
   * Function ot draw the tracker over the lables for showing the tooltips and other mouse interactivity
   */
  ;

  _proto.drawTracker = function drawTracker() {
    var dataset = this,
        dataStore = dataset.components.data,
        animationManager = dataset.getFromEnv('animationManager'),
        chart = dataset.getFromEnv('chart'),
        manager = dataset.getLinkedParent(),
        conf = dataset.config,
        trackerGroup = dataset.getContainer('dragLabelGroup'),
        len = dataStore && dataStore.length,
        dataObj,
        config,
        padding,
        elemMouseDownFN = function elemMouseDownFN() {
      // Long press eve
      var ele = this,
          data = ele.data('drag-options'),
          dataSet = data.dataset,
          index = data.index,
          labelObj = dataSet.components.data[index];
      ele.data('fire_click_event', 1);
      manager.clearLongPress();
      manager.triggerLabelUI(ele, labelObj);
    },
        elemMouseMoveFN = function elemMouseMoveFN() {
      // Whether to fire the click event ot not
      var ele = this;

      if (ele.data('fire_click_event')) {
        ele.data('fire_click_event', 0);
        manager.clearLongPress();
      }
    },
        elemMouseUPFN = function elemMouseUPFN(data) {
      var ele = this,
          fireClick = ele.data('fire_click_event');
      manager.clearLongPress();

      if (fireClick) {
        /**
           *
           * > Applicable to `dragnode` chart only.
           *
           * @event FusionCharts#labelClick
           * @group chart-powercharts:dragnode
           *
           * @param {number} chartX - x-coordinate of the pointer relative to the chart.
           * @param {number} chartY - y-coordinate of the pointer relative to the chart.
           * @param {number} pageX - x-coordinate of the pointer relative to the page.
           * @param {number} pageY - y-coordinate of the pointer relative to the page.
           *
           * @param {number} x - The x-value of the label node scaled as per the axis of the chart.
           * @param {number} y - The y-value of the label node scaled as per the axis of the chart.
           *
           * @param {string} text - The text value of the label.
           */
        chart.plotEventHandler(ele, data, 'LabelClick');
      }
    },
        elemHoverFN = function elemHoverFN(data) {
      var ele = this;
      /**
       *
       * > Applicable to `dragnode` chart only.
       *
       * @event FusionCharts#labelRollOver
       * @group chart-powercharts:dragnode
       *
       * @param {number} chartX - x-coordinate of the pointer relative to the chart.
       * @param {number} chartY - y-coordinate of the pointer relative to the chart.
       * @param {number} pageX - x-coordinate of the pointer relative to the page.
       * @param {number} pageY - y-coordinate of the pointer relative to the page.
       *
       * @param {number} x - The x-value of the label node scaled as per the axis of the chart.
       * @param {number} y - The y-value of the label node scaled as per the axis of the chart.
       *
       * @param {string} text - The text value of the label.
       */

      chart.plotEventHandler(ele, data, 'LabelRollover');
    },
        elemOutFN = function elemOutFN(data) {
      var ele = this;
      /**
       *
       * > Applicable to `dragnode` chart only.
       *
       * @event FusionCharts#labelRollOut
       * @group chart-powercharts:dragnode
       *
       * @param {number} chartX - x-coordinate of the pointer relative to the chart.
       * @param {number} chartY - y-coordinate of the pointer relative to the chart.
       * @param {number} pageX - x-coordinate of the pointer relative to the page.
       * @param {number} pageY - y-coordinate of the pointer relative to the page.
       *
       * @param {number} x - The x-value of the label node scaled as per the axis of the chart.
       * @param {number} y - The y-value of the label node scaled as per the axis of the chart.
       *
       * @param {string} text - The text value of the label.
       */

      chart.plotEventHandler(ele, data, 'LabelRollout');
    },
        eventArgs,
        attr,
        allowDrag,
        text,
        trackerElement,
        trackerElementCheck,
        x,
        y,
        width,
        height,
        dragMove = function dragMove(event, data) {
      var ele = this;

      dataset._labelDragMove.call(ele, event, data, chart);
    },
        dragStart = function dragStart(event) {
      var ele = this;

      dataset._labelDragStart.call(ele, event, chart);
    },
        dragUp = function dragUp(event) {
      var ele = this;

      dataset._labelDragUp.call(ele, event);
    },
        i;

    for (i = 0; i < len; i++) {
      dataObj = dataStore[i];

      if (dataObj.removed) {
        continue;
      }

      config = dataObj.config;
      padding = config.padding || 0;
      width = config.width;
      height = config.height;
      x = config.xPos - width / 2;
      y = config.yPos - height / 2;
      allowDrag = config.allowDrag;
      text = config.text;
      trackerElementCheck = dataObj.graphics.trackerElement;
      attr = {
        x: x - padding,
        y: y - padding,
        width: width + padding * 2,
        height: height + padding * 2,
        cursor: config.allowDrag ? 'move' : _lib.BLANKSTRING,
        fill: TRACKER_FILL,
        stroke: TRACKER_FILL
      };
      eventArgs = {
        link: config.link,
        text: text,
        x: x,
        y: y,
        allowdrag: allowDrag,
        sourceType: 'labelnode'
      };
      trackerElement = animationManager.setAnimation({
        el: trackerElementCheck || 'rect',
        container: trackerGroup,
        attr: attr,
        component: dataset
      });

      if (!trackerElementCheck) {
        dataObj.graphics.trackerElement = trackerElement;
        trackerElement.on('fc-mousedown', elemMouseDownFN).on('fc-mousemove', elemMouseMoveFN).on('fc-mouseup', elemMouseUPFN).data('viewMode', conf.viewMode).data(_lib.preDefStr.EVENTARGS, eventArgs).hover(elemHoverFN, elemOutFN);
        config.allowDrag && trackerElement.drag(dragMove, dragStart, dragUp);
      }

      trackerElement.data('drag-options', {
        index: i,
        dataset: dataset
      });
    }
  }
  /**
   * Callback function when the dragging of the label starts
   */
  ;

  _proto._labelDragStart = function _labelDragStart() {
    var ele = this,
        bBox = ele.getBBox(),
        data = ele.data('drag-options'),
        dataset = data.dataset,
        manager = dataset.getLinkedParent(),
        index = data.index,
        labelObj = dataset.components.data[index],
        labelElement = labelObj.graphics.element,
        dragStart = labelObj.dragStart = labelObj.dragStart || (labelObj.dragStart = {});
    data.ox = labelElement.attr('x');
    data.oy = labelElement.attr('y');
    data.bBox = bBox;
    dragStart.xPos = labelObj.config.xPos;
    dragStart.yPos = labelObj.config.yPos;
    dragStart.bBox = bBox;
    ele.data('fire_click_event', 1);
    ele.data('fire_dragend', 0);
    manager.clearLongPress();
    manager.triggerLabelUI(ele, labelObj);
  }
  /**
   * Callback function when the labels are dragged around
   * @param {Event} event The actual mouse event
   * @param {Object} positionData Contains the coordinates of the label elements while they are dragged
   */
  ;

  _proto._labelDragMove = function _labelDragMove(event, positionData) {
    // eslint-disable-line no-unused-vars
    var ele = this,
        data = ele.data('drag-options'),
        index = data.index,
        dataset = data.dataset,
        chart = dataset.getFromEnv('chart'),
        chartConfig = dataset.getFromEnv('chartConfig'),
        canvasLeft = chartConfig.canvasLeft,
        canvasRight = chartConfig.canvasRight,
        canvasBottom = chartConfig.canvasBottom,
        canvasTop = chartConfig.canvasTop,
        manager = dataset.getLinkedParent(),
        labelObj = dataset.components.data[index],
        labelElement = labelObj.graphics.element,
        dragStart = labelObj.dragStart,
        bBox = dragStart.bBox,
        dx = positionData[0],
        dy = positionData[1],
        startX = dragStart.bBox.x + dx,
        endX = dragStart.bBox.x2 + dx,
        startY = dragStart.bBox.y + dy,
        endY = dragStart.bBox.y2 + dy,
        yAxis = dataset.getFromEnv('yAxis'),
        xAxis = dataset.getFromEnv('xAxis'),
        xPos,
        yPos; // Bound limits

    if (startX < canvasLeft) {
      dx += canvasLeft - startX;
    }

    if (endX > canvasRight) {
      dx -= endX - canvasRight;
    }

    if (startY < canvasTop) {
      dy += canvasTop - startY;
    }

    if (endY > canvasBottom) {
      dy -= endY - canvasBottom;
    }

    dragStart.draged = true;
    ele.attr({
      x: bBox.x + dx,
      y: bBox.y + dy
    });
    xPos = data.ox + dx;
    yPos = data.oy + dy;
    labelElement.attr({
      x: data.ox + dx,
      y: data.oy + dy
    });
    labelObj.config.x = xAxis.getValue(xPos);
    labelObj.config.y = yAxis.getValue(yPos);

    if (!ele.data('fire_dragend')) {
      /**
         *
         * > Applicable to `dragnode` chart only.
         *
         * @event FusionCharts#labelDragStart
         * @group chart-powercharts:dragnode
         *
         * @param {number} chartX - x-coordinate of the pointer relative to the chart.
         * @param {number} chartY - y-coordinate of the pointer relative to the chart.
         * @param {number} pageX - x-coordinate of the pointer relative to the page.
         * @param {number} pageY - y-coordinate of the pointer relative to the page.
         *
         * @param {number} x - The x-value of the label node scaled as per the axis of the chart.
         * @param {number} y - The y-value of the label node scaled as per the axis of the chart.
         *
         * @param {string} text - The text value of the label.
         */
      chart.plotEventHandler(ele, event, 'LabelDragStart');
      ele.data('fire_dragend', 1);
    }

    if (ele.data('fire_click_event')) {
      ele.data('fire_click_event', 0);
      manager.clearLongPress();
    }
  }
  /**
   * Callback function when dragging is stopped over a label
   * @param {Event} event The actual event object
   */
  ;

  _proto._labelDragUp = function _labelDragUp(event) {
    var ele = this,
        data = ele.data('drag-options'),
        index = data.index,
        dataset = data.dataset,
        chart = dataset.getFromEnv('chart'),
        xAxis = chart.getChildren('xAxis')[0],
        yAxis = chart.getChildren('yAxis')[0],
        manager = dataset.getLinkedParent(),
        sourceEvent = LABELDRAGEND,
        labelObj = dataset.components.data[index],
        dragStart = labelObj.dragStart,
        eventArgs = ele.data(EVENTARGS);
    eventArgs.x = xAxis.getValue(ele.attr('x'));
    eventArgs.y = yAxis.getValue(ele.attr('y'));
    dragStart.draged = false;

    if (ele.data('fire_dragend')) {
      // eventCord = getMouseCoordinate(chart.linkedItems.container, event);
      // eventCord.sourceEvent = sourceEvent;
      // Fire the ChartUpdated event
      chart.fireChartInstanceEvent('chartupdated', (0, _lib.extend2)({
        sourceEvent: sourceEvent
      }, eventArgs), event);
      chart.fireChartInstanceEvent('chartupdated', eventArgs, event);
      /**
       *
       * > Applicable to `dragnode` chart only.
       *
       * @event FusionCharts#labelDragEnd
       * @group chart-powercharts:dragnode
       *
       * @param {number} chartX - x-coordinate of the pointer relative to the chart.
       * @param {number} chartY - y-coordinate of the pointer relative to the chart.
       * @param {number} pageX - x-coordinate of the pointer relative to the page.
       * @param {number} pageY - y-coordinate of the pointer relative to the page.
       *
       * @param {number} x - The x-value of the label node scaled as per the axis of the chart.
       * @param {number} y - The y-value of the label node scaled as per the axis of the chart.
       *
       * @param {string} text - The text value of the label.
       */

      chart.plotEventHandler(ele, event, sourceEvent);
    }

    manager.clearLongPress();
  }
  /**
   * Function to remove data during update if number of data has reduced than the previous render
   * @param {number} index The data index from which data has to be removed.
   * @param {number} stretch The index upto which data has to be removed
   */
  ;

  _proto.removeData = function removeData(index, stretch) {
    var dataset = this,
        components = dataset.components,
        dataStore = components.data;
    components.removeDataArr = dataStore.splice(index, stretch);
  }
  /**
   * function to Remove data plots if the number of current data plots/categories
   * is more than the existing ones.
   * @param  {Object} datasetJSON JSON for dataset configurations
   */
  ;

  _proto.trimData = function trimData(datasetJSON) {
    if (!this.config.JSONData) {
      return;
    }

    var dataSet = this,
        prevData = dataSet.config.JSONData,
        prevDataLength = prevData && prevData.length,
        currDataLength = datasetJSON.label && datasetJSON.label.length || 0,
        dataDiff = prevDataLength - currDataLength; // Removing data plots if the number of current data plots/categories
    // is more than the existing ones.

    if (dataDiff > 0) {
      dataSet.removeData(currDataLength, dataDiff);
    }
  };

  return DragNodeLabels;
}(_dragnode.default);

var _default = DragNodeLabels;
exports["default"] = _default;

/***/ }),

/***/ 1400:
/***/ ((__unused_webpack_module, exports) => {



exports.__esModule = true;
exports["default"] = void 0;
var _default = {
  'initial.dataset.dragNodeLabels': function initialDatasetDragNodeLabels() {
    return {
      'group.appearing': function groupAppearing() {
        return [{
          initialAttr: {
            opacity: 0
          },
          finalAttr: {
            opacity: 1
          },
          slot: 'plot'
        }];
      }
    };
  }
};
exports["default"] = _default;

/***/ }),

/***/ 1398:
/***/ ((__unused_webpack_module, exports) => {



exports.__esModule = true;
exports["default"] = void 0;
var _default = {
  'initial.dataset.dragNode': function initialDatasetDragNode() {
    return {
      'node.appearing': function nodeAppearing() {
        return [{
          initialAttr: {
            opacity: 0
          },
          finalAttr: {
            opacity: 1
          },
          slot: 'axis'
        }];
      }
    };
  }
};
exports["default"] = _default;

/***/ }),

/***/ 1397:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _area = _interopRequireDefault(__webpack_require__(617));

var _lib = __webpack_require__(274);

var _dependencyManager = __webpack_require__(282);

var _dragnodeAnimation = _interopRequireDefault(__webpack_require__(1398));

var _redraphaelShapes = _interopRequireDefault(__webpack_require__(390));

var _kdtree = _interopRequireDefault(__webpack_require__(724));

/* eslint require-jsdoc: 'error', valid-jsdoc: ["error", { "requireReturn": false }] */
// import { triggerEvent } from '../../../core/events/event-api';
// import {_getJSONData, _restore} from './dragcolumn';
var PADDING = 1;

var Raphael = (0, _dependencyManager.getDep)('redraphael', 'plugin'),
    UNDEF,
    mathMax = Math.max,
    mathMin = Math.min,
    CIRCLE = _lib.preDefStr.CIRCLE,
    POLYGON = _lib.preDefStr.POLYGON,
    RECTANGLE = _lib.preDefStr.RECTANGLE,
    UNDERSCORE = _lib.preDefStr.UNDERSCORE,
    GROUPID = _lib.preDefStr.GROUPID,
    EVENTARGS = _lib.preDefStr.EVENTARGS,
    OBJECTBOUNDINGBOX = _lib.preDefStr.OBJECTBOUNDINGBOX,
    DATAPLOTCLICK = 'dataplotclick',
    DATAPLOTDRAGSTART = 'dataplotdragstart',
    DATAPLOTDRAGEND = 'dataplotdragend',
    DEFAULT_CURSOR = _lib.preDefStr.DEFAULT,
    COMMA = _lib.preDefStr.COMMA,
    FIFTY_PERCENT = '50%',
    PATH = 'path',
    POLY_4 = 'poly_4',
    ROLLOVER = 'DataPlotRollOver',
    ROLLOUT = 'DataPlotRollOut',
    POSITION_TOP = _lib.preDefStr.POSITION_TOP,
    isVML = !!_lib.hasSVG,
    hideFn = function hideFn() {
  this.hide();
},
    // CLEAR_TIME_1000 = 1000,
// stubEvent = {
//   pageX: 0,
//   pageY: 0
// },
// animType = 'linear',
defined = function defined(obj) {
  return obj !== UNDEF && obj !== null;
},

/**
 * Helper function of createContainer
 * @param {string} groupName The new group name
 * @param {Object} animationManager The renderer
 * @param {Object} parentContainer The container under which the new container has to be created
 * @param {Object} component The component for which the group is being created
 * @return {Object}  the newly created contaier
 */
createGroup = function createGroup(groupName, animationManager, parentContainer, component) {
  return animationManager.setAnimation({
    el: 'group',
    attr: {
      name: groupName
    },
    container: parentContainer,
    component: component
  });
},
    // Function that produce the point color
getPointColor = function getPointColor(colorVal, alphaVal, shapeType) {
  var color = colorVal,
      alpha = alphaVal,
      colorObj,
      innerColor,
      outerColor;
  color = (0, _lib.getFirstColor)(color);
  alpha = (0, _lib.getFirstAlpha)(alpha);
  innerColor = (0, _lib.getLightColor)(color, 80);
  outerColor = (0, _lib.getDarkColor)(color, 65);
  colorObj = {
    FCcolor: {
      gradientUnits: OBJECTBOUNDINGBOX,
      color: innerColor + COMMA + outerColor,
      alpha: alpha + COMMA + alpha,
      ratio: _lib.BGRATIOSTRING
    }
  };

  if (shapeType) {
    if (shapeType === 1) {
      colorObj.FCcolor.angle = 0;
    } else {
      colorObj.FCcolor.angle = 180;
    }
  } else {
    colorObj.FCcolor.cx = 0.4;
    colorObj.FCcolor.cy = 0.4;
    colorObj.FCcolor.r = FIFTY_PERCENT;
    colorObj.FCcolor.radialGradient = true;
  }

  return colorObj;
},
    _configureTooltext = function _configureTooltext(config, datasetConf, chartAttr) {
  var setTooltext = config.setTooltext,
      formatedVal = config.formatedVal,
      seriesname = datasetConf.seriesname,
      label = config.label,
      xValue = config.xValue,
      pointLabel = config.pointLabel,
      tooltipSepChar = datasetConf.tooltipSepChar,
      toolText;

  if (setTooltext !== UNDEF) {
    toolText = (0, _lib.parseTooltext)(setTooltext, [3, 4, 5, 6, 8, 9, 10, 11], {
      yaxisName: (0, _lib.parseUnsafeString)(chartAttr.yaxisname),
      xaxisName: (0, _lib.parseUnsafeString)(chartAttr.xaxisname),
      yDataValue: formatedVal,
      xDataValue: xValue,
      label: label
    }, config, chartAttr, datasetConf);
  } else if (pointLabel !== UNDEF) {
    toolText = label;
  } else {
    // determine the tooltext then
    if (formatedVal === null) {
      toolText = false;
    } else {
      if (datasetConf.seriesNameInToolTip) {
        seriesname = (0, _lib.getFirstValue)(datasetConf.seriesname);
      }

      toolText = seriesname ? seriesname + tooltipSepChar : _lib.BLANK;
      toolText += xValue ? xValue + tooltipSepChar : _lib.BLANK;
      toolText += formatedVal;
    }
  }

  return toolText;
};

(0, _dependencyManager.addDep)({
  name: 'dragNodeAnimation',
  type: 'animationRule',
  extension: _dragnodeAnimation.default
}); // Adding required shapes for chart.

(0, _redraphaelShapes.default)(Raphael);
/**
 * dataset class of dragcolumn inheriting from column class
 */

var DragNodeDataset = /*#__PURE__*/function (_Areadataset) {
  (0, _inheritsLoose2.default)(DragNodeDataset, _Areadataset);

  function DragNodeDataset() {
    return _Areadataset.apply(this, arguments) || this;
  }

  var _proto = DragNodeDataset.prototype;

  /**
   * Return the name of component
   * @return {string} name
   */
  _proto.getName = function getName() {
    return 'dragNode';
  }
  /**
   * Return the type of component
   * @return {string} type
   */
  ;

  _proto.getType = function getType() {
    return 'dataset';
  }
  /**
   * Function to hide the dataset on legend click
   */
  ;

  _proto.hide = function hide() {
    var dataSet = this,
        parent = dataSet.getLinkedParent(),
        changeInfo = {};
    changeInfo.hide = true;
    dataSet.setState('dirty', true);
    dataSet.setState('visible', false);
    parent.childChanged(changeInfo);
    dataSet.getFromEnv('chart').getChildren('legend')[0].getItem(dataSet.config.legendItemId).setLegendState('hidden');
    dataSet.asyncDraw();
  }
  /**
   * Function to show the dataset on legend click
   */
  ;

  _proto.show = function show() {
    var dataSet = this,
        parent = dataSet.getLinkedParent(),
        legendItem = dataSet.getFromEnv('legend').getItem(dataSet.config.legendItemId),
        changeInfo = {};
    changeInfo.show = true;
    dataSet.setState('visible', true);
    dataSet.setState('dirty', true);
    parent.childChanged(changeInfo);
    legendItem && legendItem.removeLegendState('hidden');
    dataSet.asyncDraw();
  }
  /**
   * Function to set the index of the dataset from amongst the other datasets
   */
  ;

  _proto._setDatasetIndex = function _setDatasetIndex() {
    var dataset = this,
        chidrenArr = dataset.getLinkedParent().getChildren('dataset');
    dataset.config.datasetIndex = chidrenArr.indexOf(dataset);
  } // Checks if a point lies in a shape
  ;

  _proto.pointInShape = function pointInShape(x, y, config) {
    var dataset = this,
        chart = dataset.getFromEnv('chart'),
        canvas = chart.getChildren('canvas')[0],
        canvasConfig = canvas.config,
        symbol = config.symbol,
        x2,
        y2,
        r2,
        xPos = config._xPos,
        yPos = config._yPos,
        width,
        height;

    if (x < canvasConfig.canvasLeft || x > canvasConfig.canvasLeft + canvasConfig.canvasWidth || y < canvasConfig.canvasTop || y > canvasConfig.canvasTop + canvasConfig.canvasHeight) {
      return false;
    }

    if (symbol === 'rectangle') {
      width = config._plotWidth;
      height = config._plotHeight;
      xPos -= width / 2;
      yPos -= height / 2;

      if (x >= xPos && y >= yPos && x <= xPos + width && y <= yPos + height) {
        return true;
      }

      return false;
    }

    x2 = (x - xPos) * (x - xPos);
    y2 = (y - yPos) * (y - yPos);
    r2 = Number(config.radius);
    r2 *= r2;

    if (x2 + y2 <= r2) {
      return true;
    }

    return false;
  }
  /**
   * This method handles all mouse events of an dataset.
   * @param {string} eventType name of the event
   * @param {number} plotIndex index of the plot where this event has been occured
   * @param {Event} e reference of the original mouse event
   * @param {number} datasetIndex index of the dataSet on which the mouse is hovered
   */
  ;

  _proto._firePlotEvent = function _firePlotEvent(eventType, plotIndex, e) {
    var dataset = this,
        chart = dataset.getFromEnv('chart'),
        components = dataset.components,
        toolTipController = dataset.getFromEnv('toolTipController'),
        dataStore = components.data,
        data = dataStore[plotIndex] || {},
        sharedAnchor = dataset.getGraphicalElement('sharedAnchor'),
        setElement = data.graphics && data.graphics.element || (data.config && data.config.setValue) !== UNDEF && sharedAnchor,
        toolTip = this.config.currentToolTip,
        // originalEvent = e.originalEvent,
    viewMode = dataset.config.viewMode,
        groupManager = dataset.getLinkedParent(),
        config,
        ele = data.graphics.element,
        eventArgs,
        setLink;

    if (setElement) {
      config = data.config;
      setLink = config.setLink;
      eventArgs = config.eventArgs;

      switch (eventType) {
        case 'fc-mouseover':
          dataset._decideTooltipType(plotIndex, e);

          dataset._rolloverResponseSetter(chart, data, e);

          setLink && (setElement.node.style.cursor = _lib.POINTER);
          break;

        case 'fc-mouseout':
          toolTipController.hide(toolTip);

          dataset._rolloutResponseSetter(chart, data, e);

          setLink && (setElement.node.style.cursor = DEFAULT_CURSOR);
          break;

        case 'fc-click':
          ele.data('fire_click_event') && chart.plotEventHandler(setElement, e, DATAPLOTCLICK, eventArgs);
          break;

        case 'fc-mousemove':
          groupManager.hideWaitElem();

          dataset._decideTooltipType(plotIndex, e);

          break;

        case 'fc-mousedown':
          clearTimeout(ele._longpressactive);
          ele.data('fire_click_event', 1);

          if (!viewMode) {
            groupManager.drawWaitingRing(data, dataset.config.datasetIndex);
          }

          break;

        case 'fc-mouseup':
          groupManager.hideWaitElem();
          groupManager.clearLongPress();
          break;
      }
    }
  }
  /**
   * Callback function when dragging of the node is stopped
   * @param {Object} event The actual event object
   */
  ;

  _proto.dragUp = function dragUp(event) {
    var ele = this,
        data = ele.data('drag-options'),
        dataset = data.dataset;

    dataset._dragUp.call(ele, event);
  }
  /**
   * Callback function when a node is being dragged
   * @param {Object} event The actual event object
   * @param {Object} customData Object containing the details related to drag coordinates
   */
  ;

  _proto.dragMove = function dragMove(event, customData) {
    // eslint-disable-line no-unused-vars
    var ele = this,
        data = ele.data('drag-options'),
        dataset = data.dataset,
        dx = customData[0],
        dy = customData[1],
        px = customData[2],
        py = customData[3];

    dataset._dragMove.call(ele, dx, dy, px, py);
  }
  /**
   * Callback function when dragging of a node is started
   * @param {Object} event The actual event object
   */
  ;

  _proto.dragStart = function dragStart(event) {
    var ele = this,
        data = ele.data('drag-options'),
        dataset = data.dataset;

    dataset._dragStart.call(ele, event);
  }
  /**
   * Helper function of dragStart()
   * @param {Object} e The actual event object
   */
  ;

  _proto._dragStart = function _dragStart() {
    var element = this,
        data = element.data('drag-options'),
        dataObj = data.dataObj,
        dataGraphics = dataObj.graphics,
        ele = dataGraphics.element,
        bBox = ele.getBBox(),
        config = dataObj.config,
        dataset = data.dataset,
        chart = dataset.getFromEnv('chart'),
        sourceEvent = DATAPLOTDRAGSTART,
        dragStart = config.dragStart || (config.dragStart = {}),
        cloneGraphic = dataObj.graphics.cloneGraphic,
        cloneGraphicGroup = dataset.getContainer('cloneGraphicGroup'),
        cloneText = dataObj.graphics.cloneText,
        image = dataObj.graphics.image,
        cloneImage = dataObj.graphics.cloneImage,
        label = dataObj.graphics.label,
        eventArgs; // Set dirty flag to 1 so that bbox is recalculated again

    if (isVML) {
      ele._.dirty = 1;
    }

    if (config.allowDrag) {
      if (!cloneGraphic && dataObj.graphics.element) {
        cloneGraphic = dataObj.graphics.cloneGraphic = dataObj.graphics.element.clone();
        cloneGraphicGroup.appendChild(cloneGraphic);
      }

      if (label && !cloneText) {
        cloneText = dataObj.graphics.cloneText = dataObj.graphics.label.clone();

        if (cloneText.followers[0] && cloneText.followers[0].el) {
          cloneGraphicGroup.appendChild(cloneText.followers[0].el);
        }

        cloneGraphicGroup.appendChild(cloneText);
      }

      if (image && !cloneImage) {
        cloneImage = dataObj.graphics.cloneImage = dataObj.graphics.image.clone();
        cloneGraphicGroup.appendChild(cloneImage);
      }

      cloneText && cloneText.show();
      cloneImage && cloneImage.show();
      cloneGraphic && cloneGraphic.show();
    }

    dragStart.xPos = config._xPos;
    dragStart.yPos = config._yPos;
    dragStart.x = config.x;
    dragStart.y = config.y;
    dragStart.bBox = bBox; // store original x, y positions

    dragStart.origX = dragStart.lastDx || (dragStart.lastDx = 0);
    dragStart.origY = dragStart.lastDy || (dragStart.lastDy = 0);
    eventArgs = ele.data(EVENTARGS); // Whether to fire the click event ot not

    chart.fireChartInstanceEvent(sourceEvent, eventArgs); // DragNode mouse progress cursor added.

    cloneGraphic && cloneGraphic.show();
    cloneText && cloneText.show();
    cloneImage && cloneImage.show();
  }
  /**
   * Helper function of dragMove()
   * @param {number} dxVal the drag coordinates
   * @param {number} dyVal the drag coordinates
   * @param {number} px the drag coordinates
   * @param {number} py the drag coordinates
   */
  ;

  _proto._dragMove = function _dragMove(dxVal, dyVal) {
    var element = this,
        dx = dxVal,
        dy = dyVal,
        data = element.data('drag-options'),
        dataObj = data.dataObj,
        ele = dataObj.graphics.element,
        cloneGraphic = dataObj.graphics.cloneGraphic,
        cloneImage = dataObj.graphics.cloneImage,
        cloneText = dataObj.graphics.cloneText,
        config = dataObj.config,
        dragStart = config.dragStart,
        startX = dragStart.bBox.x + dx,
        endX = dragStart.bBox.x2 + dx,
        startY = dragStart.bBox.y + dy,
        endY = dragStart.bBox.y2 + dy,
        dataset = data.dataset,
        animationManager = dataset.getFromEnv('animationManager'),
        parent = dataset.getLinkedParent(),
        // graphics = .getContainer('waitGroup'),
    chartConfig = dataset.getFromEnv('chartConfig'),
        canvasLeft = chartConfig.canvasLeft,
        canvasRight = chartConfig.canvasRight,
        transform,
        canvasTop = chartConfig.canvasTop,
        canvasBottom = chartConfig.canvasBottom; // Bound limits

    if (startX < canvasLeft) {
      dx += canvasLeft - startX;
    }

    if (endX > canvasRight) {
      dx -= endX - canvasRight;
    }

    if (startY < canvasTop) {
      dy += canvasTop - startY;
    }

    if (endY > canvasBottom) {
      dy -= endY - canvasBottom;
    }

    if (dx || dy) {
      // graphics.waitElement && graphics.waitElement.hide();
      // Whether to fire the click event or not
      ele.data('fire_click_event', 0);
      parent.hideWaitElem();
      parent.clearLongPress();
    }

    if (config.allowDrag) {
      dragStart.draged = true;
      dragStart.lastDx = dx;
      dragStart.lastDy = dy;
      transform = data._transformObj = {
        transform: 't' + (dragStart.origX + dx) + COMMA + (dragStart.origY + dy)
      };

      if (cloneGraphic) {
        animationManager.setAnimation({
          el: cloneGraphic,
          attr: transform,
          component: dataset
        });
      }

      if (cloneImage) {
        animationManager.setAnimation({
          el: cloneImage,
          attr: transform,
          component: dataset
        });
      }

      if (cloneText) {
        animationManager.setAnimation({
          el: cloneText,
          attr: {
            x: config._xPos + dx,
            y: config._yPos + dy
          },
          component: dataset
        });
      }
    }
  }
  /**
   * Function that return the nearest plot details
   * @param   {number} x x-axis position of the mouse cordinate
   * @param   {number} y y-axis position of the mouse cordinate
   * @return {Object} return an object with details of nearest plot and whether it is
   *                   hovered or not
   */
  ;

  _proto._getHoveredPlot = function _getHoveredPlot(x, y) {
    var res = this.config.tree.getNeighbour({
      x: x,
      y: y
    }, false); // searching neighbour from Kdtree with basic search flag on

    if (res) {
      return {
        pointIndex: res.index || res.i,
        hovered: true,
        pointObj: res.data
      };
    }
  }
  /**
   * handler called on mouseout
   *
   * @param {any} chart chart
   * @param {any} data dataObj on which event occured
   * @param {any} e event
   * @memberof DragNodeDataset
   */
  ;

  _proto._rolloutResponseSetter = function _rolloutResponseSetter(chart, data, e) {
    var dataset = this,
        animationManager = dataset.getFromEnv('animationManager'),
        config = data.config,
        element = data.graphics.element,
        dragStart = config.dragStart,
        unHoverAttr = element.data('unHoverAttr'),
        keysNo = dragStart && Object.keys(dragStart).length;

    if (!keysNo) {
      if (config.shapeType === 'poly' || config.shapeType === CIRCLE) {
        // For polygon and circle, convert path to polypath
        unHoverAttr.path = (0, _lib.polyPathToPath)([config.shapeArg.sides, config._xPos, config._yPos, unHoverAttr.r, config.startAngle, 0]);
      }

      config.rollOverProperties.enabled && animationManager.setAnimation({
        el: element,
        attr: unHoverAttr,
        component: dataset
      });
      chart && chart.plotEventHandler(element, e, ROLLOUT);
    }
  }
  /**
   * handler called on mouseover
   *
   * @param {any} chart chart
   * @param {any} data dataObj on which event occured
   * @param {any} e event
   * @memberof DragNodeDataset
   */
  ;

  _proto._rolloverResponseSetter = function _rolloverResponseSetter(chart, data, e) {
    var dataset = this,
        animationManager = dataset.getFromEnv('animationManager'),
        config = data.config,
        element = data.graphics.element,
        dragStart = config.dragStart,
        hoverAttr = element.data('hoverAttr'),
        keysNo = dragStart && Object.keys(dragStart).length;

    if (!keysNo) {
      if (config.shapeType === 'poly' || config.shapeType === CIRCLE) {
        // For polygon and circle, convert path to polypath
        hoverAttr.path = (0, _lib.polyPathToPath)([config.shapeArg.sides, config._xPos, config._yPos, hoverAttr.r, config.startAngle, 0]);
      }

      config.rollOverProperties.enabled && animationManager.setAnimation({
        el: element,
        attr: hoverAttr,
        component: dataset
      });
      chart && chart.plotEventHandler(element, e, ROLLOVER);
    }
  }
  /**
   * Helper function of dragUp()
   * @param {Object} event The actual event object
   */
  ;

  _proto._dragUp = function _dragUp(event) {
    var element = this,
        data = element.data('drag-options'),
        dataset = data.dataset,
        // chartConfig = dataset.getFromEnv('chartConfig'),
    chart = dataset.getFromEnv('chart'),
        dataStore = dataset.components.data,
        dataObj = data.dataObj,
        ele = dataObj.graphics.element,
        groupManager = dataset.getLinkedParent(),
        startConnectors,
        endConnectors,
        sourceEvent = DATAPLOTDRAGEND,
        config = dataObj.config,
        // canvasTop = chartConfig.canvasTop,
    // canvasLeft = chartConfig.canvasLeft,
    dragStart = dataObj.config.dragStart || {},
        yAxis = dataset.getFromEnv('yAxis'),
        i,
        setObj,
        len,
        eventCord,
        eventArgs,
        cloneText = dataObj.graphics.cloneText,
        // graphics = dataset.groupManager.graphics,
    xAxis = dataset.getFromEnv('xAxis'),
        updateObj = {},
        datasetIndex = dataset.config.datasetIndex,
        cloneGraphic = dataObj.graphics.cloneGraphic,
        cloneImage = dataObj.graphics.cloneImage;
    groupManager.hideWaitElem();
    groupManager.clearLongPress();

    if (dragStart.draged) {
      dragStart.origX += dragStart.lastDx;
      dragStart.origY += dragStart.lastDy;
      dataObj.config._xPos = dragStart.xPos + dragStart.lastDx;
      dataObj.config._yPos = dragStart.yPos + dragStart.lastDy;
      updateObj.x = xAxis.getValue(dataObj.config._xPos);
      updateObj.y = yAxis.getValue(dataObj.config._yPos);
      updateObj.update = true;

      for (i = 0, len = dataStore.length; i < len; i++) {
        setObj = dataStore[i];

        if (dataObj.config.id === setObj.config.id) {
          break;
        }
      }

      dataset.updatePointConfig(updateObj, i);
      eventArgs = ele.data(EVENTARGS);
      eventArgs.x = updateObj.x;
      eventArgs.y = updateObj.y;
      dataset.parsePlotAttributes(i);

      dataset._drawNode(i); // dataset.drawTracker(i, i + 1);


      startConnectors = dataObj.config.startConnectors;
      endConnectors = dataObj.config.endConnectors;
      groupManager.drawNodeConnectors(startConnectors, datasetIndex);
      groupManager.drawNodeConnectors(endConnectors, datasetIndex);
      eventCord = (0, _lib.getMouseCoordinate)(chart.getFromEnv('chart-container'), event, chart);
      eventCord.sourceEvent = sourceEvent; // Fire the ChartUpdated event

      chart.fireChartInstanceEvent('chartupdated', (0, _lib.extend2)({
        sourceEvent: sourceEvent
      }, eventArgs), event);
      chart.fireChartInstanceEvent(sourceEvent, eventArgs, event);
      dragStart.draged = false;

      dataset._setupKdTree();
    }

    cloneText && cloneText.hide();
    cloneGraphic && cloneGraphic.hide();
    cloneImage && cloneImage.hide();
    delete config.dragStart;
  }
  /**
   * Function to update a specific node at the end of dragging
   * @param {Object} updateConf Having values regarding the new position of the node
   * @param {number} index the index of the node that is to be updated
   */
  ;

  _proto.updatePointConfig = function updatePointConfig(updateConf, index) {
    var dataset = this,
        // chart = dataset.chart,
    dataStore = dataset.components.data,
        conf = dataset.config,
        dataObj = dataStore[index] || {},
        config = dataObj.config,
        numberFormatter = dataset.getFromEnv('number-formatter'),
        chartAttr = dataset.getFromEnv('chart-attrib'),
        // yMin = conf.yMin || +Infinity,
    // yMax = conf.yMax || -Infinity,
    // xMax = conf.xMax || -Infinity,
    // xMin = conf.xMin || +Infinity,
    xValue;

    if (config === UNDEF) {
      return;
    }

    config.y = numberFormatter.getCleanValue((0, _lib.pluck)(updateConf.y));
    config.x = numberFormatter.getCleanValue((0, _lib.pluck)(updateConf.x));
    config._options.x = config.x;
    config._options.y = config.y; // yMax = mathMax(yMax, config.y);
    // yMin = mathMin(yMin, config.y);
    // xMax = mathMax(xMax, config.x);
    // xMin = mathMin(xMin, config.x);

    xValue = numberFormatter.xAxis(config.x); // push the point object

    config.formatedVal = config.y === null ? config.y : numberFormatter.dataLabels(config.y);
    config.xValue = xValue;

    if (!conf.showTooltip) {
      config.toolText = false;
    } else {
      config.toolText = _configureTooltext(config, conf, chartAttr);
    }

    config.update = updateConf.update;
  }
  /**
   * Returns a node corresponding to the given id
   * @param {string} id The id of the enquired node
   * @return {Object} The object conatining the info about the node
   */
  ;

  _proto.getNode = function getNode(id) {
    return id ? this.components.nodes[id] : this.components.nodes;
  }
  /**
    * Function for parsing all the attributes and value given by the user at chart and dataset level.
    * This function is called once from the init() function of the Column class.
    * @param  {Object} datasetJSON JSON for dataset configurations
    * @return {boolean} if no datasetJSON is found
    */
  ;

  _proto.configureAttributes = function configureAttributes(datasetJSON) {
    if (datasetJSON) {
      this.trimData(datasetJSON);
      this.config.JSONData = datasetJSON;
    } else if (!datasetJSON && !this.config.JSONData) {
      return false;
    }

    var dataset = this,
        dIndex = dataset.config.datasetIndex,
        JSONData = dataset.config.JSONData,
        data = JSONData.data || [],
        chartAttr = dataset.getFromEnv('chart-attrib'),
        chartConfig = dataset.getFromEnv('chartConfig'),
        dataLength = data.length,
        conf = dataset.config,
        // showValues,
    ZERO = _lib.ZEROSTRING,
        colorM = dataset.getFromEnv('color-manager'),
        index,
        plotFillAlpha,
        showPlotBorder,
        plotBorderColor,
        plotBorderThickness,
        plotBorderAlpha,
        // datasetId,
    datasetPlotBorderThickness,
        // dataStore,
    // dataStoreLen,
    useRoundEdges,
        HUNDRED = _lib.HUNDREDSTRING;
    conf.context = {};
    dataset.components.nodes = {};
    conf.showValues = (0, _lib.pluckNumber)(JSONData.showvalues, chartAttr.showvalues, 1);
    useRoundEdges = conf.useRoundEdges = (0, _lib.pluckNumber)(chartAttr.useroundedges);
    conf.zIndex = 1;
    conf.name = (0, _lib.getValidValue)(JSONData.seriesname);
    conf.viewMode = (0, _lib.pluckNumber)(chartAttr.viewmode, 0);
    conf.id = (0, _lib.pluck)(JSONData.id, dataset.index);

    if ((0, _lib.pluckNumber)(JSONData.includeinlegend) === 0 || conf.name === UNDEF) {
      conf.showInLegend = false;
    }

    conf.seriesname = (0, _lib.parseUnsafeString)(JSONData.seriesname);
    conf.includeinlegend = (0, _lib.pluckNumber)(JSONData.includeinlegend, conf.seriesname ? 1 : 0);
    conf.showTooltip = (0, _lib.pluckNumber)(chartAttr.showtooltip, 1);
    conf.seriesNameInTooltip = (0, _lib.pluckNumber)(chartAttr.seriesnameintooltip, 1);
    conf.showTextOutline = (0, _lib.pluckNumber)(chartAttr.textoutline, 0);
    conf.tooltipSepChar = (0, _lib.pluck)(chartAttr.tooltipsepchar, ' - '); // Plot Properties

    plotFillAlpha = conf.plotFillAlpha = (0, _lib.pluck)(chartAttr.plotfillalpha, HUNDRED);
    showPlotBorder = conf.showPlotBorder = (0, _lib.pluckNumber)(chartAttr.showplotborder, 1);
    plotBorderColor = conf.plotBorderColor = (0, _lib.getFirstColor)((0, _lib.pluck)(chartAttr.plotbordercolor, '666666'));
    plotBorderThickness = conf.plotBorderThickness = (0, _lib.pluckNumber)(chartAttr.plotborderthickness, useRoundEdges ? 2 : 1);
    plotBorderAlpha = conf.plotBorderAlpha = (0, _lib.pluck)(chartAttr.plotborderalpha, chartAttr.plotfillalpha, useRoundEdges ? '35' : '95'); // Node Properties

    conf.use3DLighting = Boolean((0, _lib.pluckNumber)(chartAttr.use3dlighting, chartAttr.is3d, useRoundEdges ? 1 : 0)); // Store attributeshc

    conf.color = (0, _lib.getFirstColor)((0, _lib.pluck)(JSONData.color, colorM.getPlotColor(dIndex)));
    conf.alpha = (0, _lib.pluck)(JSONData.plotfillalpha, JSONData.nodeFillAlpha, JSONData.alpha, plotFillAlpha); // Data set plot properties

    conf.datasetShowPlotBorder = Boolean((0, _lib.pluckNumber)(JSONData.showplotborder, showPlotBorder));
    conf.datasetPlotBorderColor = (0, _lib.getFirstColor)((0, _lib.pluck)(JSONData.plotbordercolor, JSONData.nodebordercolor, plotBorderColor));
    conf.datasetPlotBorderThickness = (0, _lib.pluckNumber)(JSONData.plotborderthickness, JSONData.nodeborderthickness, plotBorderThickness);
    conf.datasetPlotBorderAlpha = conf.datasetShowPlotBorder ? (0, _lib.pluck)(JSONData.plotborderalpha, JSONData.nodeborderalpha, JSONData.alpha, plotBorderAlpha) : ZERO; // Drag Border properties

    conf.datasetAllowDrag = Boolean((0, _lib.pluckNumber)(JSONData.allowdrag, 1));
    conf.colorObj = {
      fillColor: (0, _lib.convertColor)(conf.color, conf.alpha),
      lineColor: {
        FCcolor: {
          color: conf.datasetPlotBorderColor,
          alpha: conf.datasetPlotBorderAlpha
        }
      }
    };
    conf.lineWidth = datasetPlotBorderThickness;
    conf.symbol = POLY_4; // dataStore = dataset.components.data =

    dataset.components.data || (dataset.components.data = []); // dataStoreLen = dataStore.length;
    // if (dataStoreLen > dataLength) {
    //   dataStore.splice(dataLength, dataStoreLen - dataLength);
    // }

    dataset.setState('visible', (0, _lib.pluckNumber)(JSONData.visible, !Number(JSONData.initiallyhidden), 1) === 1);
    conf.yMin = conf.yMax = conf.xMax = conf.xMin = 0; // This flag is true when data update is fired

    dataset._refreshData = true; // Iterate through all level data

    for (index = 0; index < dataLength; index += 1) {
      this._setConfigure(index);
    }

    dataset._refreshData = false;
    chartConfig.showLegend && dataset._addLegend();

    dataset._setDatasetIndex();

    dataset.setState('dirty', true);
  }
  /**
   * Function for parsing all the attributes and value given by the user at set level.
   * @param {number} index The data index for which the configuration is to be prsed.
   * @param {Object} updateObj It has the information of the data given by the user
   */
  ;

  _proto._setConfigure = function _setConfigure(index, updateObj) {
    var dataset = this,
        JSONData = dataset.config.JSONData,
        data = JSONData.data,
        setData = updateObj || data[index],
        dataStore = dataset.components.data,
        conf = dataset.config,
        dataObj = dataStore[index] = dataStore[index] || (dataStore[index] = {}),
        config = dataObj.config = dataObj.config || (dataObj.config = {}),
        datasetId = conf.id,
        shape,
        yMin = conf.yMin || +Infinity,
        yMax = conf.yMax || -Infinity,
        xMax = conf.xMax || -Infinity,
        xMin = conf.xMin || +Infinity,
        itemValueY,
        itemValueX,
        label,
        safeLabel,
        shapeType,
        use3DLighting = conf.use3DLighting,
        datasetPlotBorderThickness = conf.datasetPlotBorderThickness,
        datasetPlotBorderColor = conf.datasetPlotBorderColor,
        datasetPlotBorderAlpha = conf.datasetPlotBorderAlpha,
        // chart = dataset.chart,
    chartAttr = dataset.getFromEnv('chart-attrib'),
        datasetColor = conf.color,
        datasetAlpha = conf.alpha,
        // fillColor,
    datasetAllowDrag = conf.datasetAllowDrag,
        numberFormatter = dataset.getFromEnv('number-formatter');
    !dataObj.graphics && (dataObj.graphics = {});
    config._options = (0, _lib.extend2)({}, setData);

    if (setData || updateObj) {
      itemValueY = config.y = numberFormatter.getCleanValue((0, _lib.pluck)(setData.y));
      itemValueX = config.x = numberFormatter.getCleanValue((0, _lib.pluck)(setData.x));
      config.index = index;

      if (!config.dragStart) {
        config.dragStart = {};
      }

      yMax = mathMax(yMax, config.y);
      yMin = mathMin(yMin, config.y);
      xMax = mathMax(xMax, config.x);
      xMin = mathMin(xMin, config.x);

      if (itemValueY === null) {
        config.value = null;
      } else {
        label = numberFormatter.xAxis(itemValueX); // push the point object

        config.formatedVal = itemValueY === null ? itemValueY : numberFormatter.dataLabels(itemValueY);
        config.setTooltext = (0, _lib.getValidValue)((0, _lib.parseUnsafeString)((0, _lib.pluck)(setData.tooltext, JSONData.plottooltext, chartAttr.plottooltext), false));
        config.pointLabel = (0, _lib.pluck)(setData.label, setData.name);
        safeLabel = (0, _lib.parseUnsafeString)(config.pointLabel);
        config.label = safeLabel;
        config.name = safeLabel;
        config.displayValue = safeLabel;
        config.xValue = label;

        if (!updateObj) {
          config.startConnectors = {};
          config.endConnectors = {};
        } // create the tooltext


        if (!conf.showTooltip) {
          config.toolText = false;
        } else {
          config.toolText = _configureTooltext(config, conf, chartAttr);
        }

        config.link = setData.link; // Shape and cosmetics related attributes

        config.id = (0, _lib.pluck)(setData.id, datasetId + _lib.preDefStr.UNDERSCORE + index);
        config.allowDrag = Boolean((0, _lib.pluckNumber)(setData.allowdrag, datasetAllowDrag));
        shape = config.shape = (0, _lib.getValidValue)((0, _lib.pluck)(setData.shape), _lib.preDefStr.RECTANGLE).toLowerCase();
        config.height = (0, _lib.getValidValue)((0, _lib.pluck)(setData.height), 10);
        config.width = (0, _lib.getValidValue)((0, _lib.pluck)(setData.width), 10);
        config.radius = (0, _lib.getValidValue)((0, _lib.pluck)(setData.radius), 10);
        config.numSides = (0, _lib.getValidValue)((0, _lib.pluck)(setData.numsides), 4);
        config.color = (0, _lib.getFirstColor)((0, _lib.pluck)(setData.color, datasetColor));
        config.borderColor = (0, _lib.getFirstColor)((0, _lib.pluck)(setData.bordercolor, datasetPlotBorderColor));
        config.alpha = (0, _lib.pluck)(setData.alpha, datasetAlpha);
        config.imageURL = (0, _lib.getValidValue)(setData.imageurl);
        config.imageNode = Boolean((0, _lib.pluckNumber)(setData.imagenode));
        config.imageWidth = setData.imagewidth;
        config.imageHeight = setData.imageheight;
        config.imageAlign = (0, _lib.getValidValue)(setData.imagealign, _lib.BLANK).toLowerCase();
        config.labelAlign = (0, _lib.pluck)(setData.labelalign, config.imageNode && defined(config.imageURL) ? POSITION_TOP : _lib.preDefStr.POSITION_MIDDLE);
        config.hovercolor = (0, _lib.pluck)(setData.hovercolor, JSONData.hovercolor);
        config.borderhoveralpha = (0, _lib.pluck)(setData.borderhoveralpha, JSONData.borderhoveralpha);
        config.borderhovercolor = (0, _lib.pluck)(setData.borderhovercolor, JSONData.borderhovercolor);
        config.borderhoverthickness = (0, _lib.pluck)(setData.borderhoverthickness, JSONData.borderhoverthickness);
        config.hoveralpha = (0, _lib.pluck)(setData.hoveralpha, JSONData.hoveralpha);
        config.hoverheight = (0, _lib.pluck)(setData.hoverheight, JSONData.hoverheight);
        config.hoverradius = (0, _lib.pluck)(setData.hoverradius, JSONData.hoverradius);
        config.hoverwidth = (0, _lib.pluck)(setData.hoverwidth, JSONData.hoverwidth);
        config.dataLabelStyle = dataset._configureDataLabelStyle(setData); // If not required shape then set it to rectangle

        switch (config.shape) {
          case CIRCLE:
            shapeType = 0;
            break;

          case POLYGON:
            shapeType = 2;
            shape = (0, _lib.mapSymbolName)(config.numSides);
            break;

          default:
            shapeType = 1;
            break;
        }

        config.symbol = shape;

        if (use3DLighting) {
          config.fillColor = getPointColor(config.color, config.alpha, shapeType);
          config.cloneFillColor = getPointColor(config.color, 50, shapeType);
        } else {
          config.fillColor = {
            color: config.color,
            alpha: config.alpha
          };
          config.cloneFillColor = (0, _lib.convertColor)(config.color, 50);
        }

        config.colorArr = [{
          FCcolor: {
            color: config.color,
            alpha: config.alpha
          }
        }, {
          FCcolor: {
            color: config.borderColor,
            alpha: datasetPlotBorderAlpha
          }
        }];
        config.rollOverProperties = dataset.pointHoverOptions(dataObj, chartAttr, {
          shapeType: shapeType,
          use3D: use3DLighting,
          height: config.height,
          width: config.width,
          radius: config.radius,
          color: config.color,
          alpha: config.alpha,
          borderColor: config.borderColor,
          borderAlpha: datasetPlotBorderAlpha,
          borderThickness: datasetPlotBorderThickness
        });
      }

      !config.update && updateObj && (config.update = updateObj.update);
      !config.add && updateObj && (config.add = updateObj.add);

      if (dataset._refreshData === true) {
        delete dataObj.removed;
      }
    }

    dataObj.dataset = dataset;
    conf.xMax = xMax;
    conf.xMin = xMin;
    conf.yMin = yMin;
    conf.yMax = yMax;
  }
  /**
   * Function for parsing the hover effects
   * @param {Object} dataObj Containing the set level information used for creating the hover effect
   * @param {Object} chartAttr Containing the chart level information used for creating the hover effect
   * @param {Object} defaults Containing the default information used for creating the hover effect
   * @return {Object} Containg the final parsed hover properties
   */
  ;

  _proto.pointHoverOptions = function pointHoverOptions(dataObj, chartAttr, defaults) {
    var dataset = this,
        hoverEffect = (0, _lib.pluckNumber)(dataObj.config.showhovereffect, dataset.config.showhovereffect, chartAttr.plothovereffect, chartAttr.showhovereffect),
        rolloverProperties = {},
        hoverAttr = !!(0, _lib.pluck)(dataObj.config.hovercolor, dataset.config.hovercolor, chartAttr.plotfillhovercolor, dataObj.config.hoveralpha, dataset.config.hoveralpha, chartAttr.plotfillhoveralpha, dataObj.config.borderhovercolor, dataset.config.borderhovercolor, chartAttr.plotborderhovercolor, dataObj.config.borderhoveralpha, dataset.config.borderhoveralpha, chartAttr.plotborderhoveralpha, dataObj.config.borderhoverthickness, dataset.config.borderhoverthickness, chartAttr.plotborderhoverthickness, dataObj.config.hoverheight, dataset.config.hoverheight, chartAttr.plothoverheight, dataObj.config.hoverwidth, dataset.config.hoverwidth, chartAttr.plothoverwidth, dataObj.config.hoverradius, dataset.config.hoverradius, chartAttr.plothoverradius, hoverEffect),
        enabled = false,
        color,
        alpha,
        rawhoverBorderColor,
        rawhoverBorderAlpha,
        fillColor;

    if (hoverEffect === UNDEF && hoverAttr || hoverEffect) {
      enabled = true;
      color = (0, _lib.pluck)(dataObj.config.hovercolor, dataset.config.hovercolor, chartAttr.plotfillhovercolor, (0, _lib.getLightColor)(defaults.color, 70));
      alpha = (0, _lib.pluck)(dataObj.config.hoveralpha, dataset.config.hoveralpha, chartAttr.plotfillhoveralpha, defaults.alpha);
      rawhoverBorderColor = (0, _lib.pluck)(dataObj.config.borderhovercolor, dataset.config.borderhovercolor, chartAttr.plotborderhovercolor, defaults.borderColor);
      rawhoverBorderAlpha = (0, _lib.pluckNumber)(dataObj.config.borderhoveralpha, dataset.config.borderhoveralpha, chartAttr.plotborderhoveralpha, alpha, defaults.borderAlpha);
      rolloverProperties = {
        rawhoverAlpha: alpha,
        rawhoverColor: color,
        rawhoverBorderColor: rawhoverBorderColor,
        rawhoverBorderAlpha: rawhoverBorderAlpha,
        stroke: (0, _lib.convertColor)(rawhoverBorderColor, (0, _lib.pluckNumber)(dataObj.config.borderhoveralpha, dataset.config.borderhoveralpha, chartAttr.plotborderhoveralpha, alpha, defaults.borderAlpha)),
        'stroke-width': (0, _lib.pluckNumber)(dataObj.config.borderhoverthickness, dataset.config.borderhoverthickness, chartAttr.plotborderhoverthickness, defaults.borderThickness),
        height: (0, _lib.pluckNumber)(dataObj.config.hoverheight, dataset.config.hoverheight, chartAttr.plothoverheight, defaults.height),
        width: (0, _lib.pluckNumber)(dataObj.config.hoverwidth, dataset.config.hoverwidth, chartAttr.plothoverwidth, defaults.width),
        r: (0, _lib.pluckNumber)(dataObj.config.hoverradius, dataset.config.hoverradius, chartAttr.plothoverradius, defaults.radius)
      };

      if (defaults.use3D) {
        fillColor = getPointColor((0, _lib.getFirstColor)((0, _lib.pluck)(dataObj.config.hovercolor, dataset.config.hovercolor, chartAttr.plotfillhovercolor, (0, _lib.getLightColor)(defaults.color, 70))), (0, _lib.pluck)(dataObj.config.hoveralpha, dataset.config.hoveralpha, chartAttr.plotfillhoveralpha, defaults.alpha), defaults.shapeType);
      } else {
        fillColor = (0, _lib.convertColor)(color, alpha);
      }

      rolloverProperties.fill = (0, _lib.toRaphaelColor)(fillColor);
    }

    return {
      enabled: enabled,
      rollOverAttrs: rolloverProperties
    };
  }
  /**
   * Function for attaching a legend with a dataset
   */
  ;

  _proto._addLegend = function _addLegend() {
    var dataset = this,
        // chart = dataset.chart,
    conf = dataset.config,
        legendItem,
        legend = dataset.getFromEnv('legend'),
        config = {
      enabled: conf.includeInLegend,
      type: dataset.type,
      anchorSide: 4,
      label: (0, _lib.getFirstValue)(dataset.config.JSONData.seriesname)
    };

    if (conf.includeinlegend) {
      legendItem = legend.getItem(dataset.config.legendItemId);

      if (!legendItem) {
        dataset.config.legendItemId = legend.createItem(dataset);
        legendItem = legend.getItem(dataset.config.legendItemId);
        dataset.addExtEventListener('fc-click', function () {
          legendItem.itemClickFn();
        }, legendItem);
      } else {
        legendItem.configure({
          style: legend.config.itemStyle,
          hiddenStyle: legend.config.itemHiddenStyle,
          datasetVisible: legend.config.datasetVisible,
          hoverStyle: legend.config.itemHoverStyle
        });
      }

      legendItem.configure(config);
      legendItem.setStateCosmetics('default', {
        symbol: {
          fill: (0, _lib.toRaphaelColor)({
            color: conf.color,
            alpha: conf.alpha
          }),
          rawFillColor: conf.color,
          stroke: (0, _lib.toRaphaelColor)({
            color: conf.plotBorderColor,
            alpha: _lib.HUNDREDSTRING
          }),
          'stroke-width': conf.anchorBorderThickness
        }
      }); // check if dataset is initiallyhidden

      if (!dataset.getState('visible')) {
        legendItem.setLegendState('hidden');
      } else {
        // remove hidden state of legend item is dataset is not hidden
        legendItem.removeLegendState('hidden');
      }
    } else if (dataset.config.legendItemId) {
      legend.disposeItem(dataset.config.legendItemId);
    }
  }
  /**
   * Function to create graphical container for the specific dataset
   */
  ;

  _proto.createContainer = function createContainer() {
    var dataset = this,
        animationManager = dataset.getFromEnv('animationManager'),
        parentContainer = dataset.getLinkedParent().getChildContainer();
    !dataset.getContainer('nodesGroup') && dataset.addContainer('nodesGroup', createGroup('nodesGroup', animationManager, parentContainer.defaultVcanvasGroup, dataset));
    !dataset.getContainer('dataLabelsGroup') && dataset.addContainer('dataLabelsGroup', createGroup('dataLabelsGroup', animationManager, parentContainer.vcanvasLabelGroup, dataset));
    !dataset.getContainer('cloneGraphicGroup') && dataset.addContainer('cloneGraphicGroup', createGroup('cloneGraphicGroup', animationManager, parentContainer.defaultVcanvasGroup, dataset));
  }
  /**
   * Draw function of DragNodeDataset
   */
  ;

  _proto.draw = function draw() {
    var dataset = this,
        components = dataset.components,
        // parent = dataset.getLinkedParent(),
    // datasetGraphics = parent.getChildContainer(),
    // chart = dataset.chart,
    // jobList = chart.getJobList(),
    smartLabel = dataset.getFromEnv('smartLabel'),
        data = components.data,
        removeDataArr = dataset.components.removeDataArr || [],
        removeDataArrLen = removeDataArr.length,
        i,
        // paper = dataset.getFromEnv('paper'),
    ln,
        group,
        // config,
    style = dataset.getFromEnv('dataLabelStyle'),
        css = {
      fontFamily: style.fontFamily,
      fontSize: style.fontSize,
      lineHeight: style.lineHeight,
      fontWeight: style.fontWeight,
      fontStyle: style.fontStyle
    },
        // dragLabelGroup,
    removed; // layers = chart.graphics, // requird for series
    // gDataset = layers.datasetGroup;

    if (!dataset.getState('dirty') && !dataset._contextChanged()) {
      return;
    }

    dataset.createContainer();
    group = dataset.getContainer('nodesGroup'); // dragLabelGroup = dataset.getContainer('dataLabelsGroup');

    dataset.getFromEnv('animationManager').setAnimation({
      el: dataset.getContainer('cloneGraphicGroup'),
      attr: {
        opacity: 0.3
      },
      component: dataset
    });
    group.css(css);
    smartLabel.useEllipsesOnOverflow(dataset.getFromEnv('chartConfig').useEllipsesWhenOverflow); // smartLabel.setStyle(style);
    // group.css(css);
    // draw data

    for (i = 0, ln = data.length; i < ln; i += 1) {
      // config = data[i].config;
      removed = data[i].removed;
      !removed && this._drawNode(i);
    }

    dataset.config.drawn = true; // if (dataset.visible) {
    //   group.show();
    //   // dragLabelGroup.show();
    // }
    // Remove the extra elements

    for (i = 0; i < removeDataArrLen; i++) {
      dataset._removeDataVisuals(removeDataArr.shift());
    }

    dataset._setupKdTree();
  }
  /**
   * Sets up kdtree for finding out whether pointer is above any plot
   *
   * @memberof DragNodeDataset
   */
  ;

  _proto._setupKdTree = function _setupKdTree() {
    var dataset = this,
        conf = dataset.config,
        data = dataset.components.data,
        dataLen,
        i,
        config,
        attr,
        maxRadius = -Infinity,
        searchDataArr;
    searchDataArr = conf.searchDataArr = [];
    dataLen = data.length;

    for (i = 0; i < dataLen; i++) {
      config = data[i].config;

      if (!data[i].removed && config._yPos !== UNDEF && !isNaN(config._yPos)) {
        attr = config.props.element.attr;
        maxRadius = Math.max(maxRadius, (0, _lib.pluckNumber)(config.radius, 0));
        searchDataArr.push({
          x: (0, _lib.pluckNumber)(attr.x, config._xPos),
          y: (0, _lib.pluckNumber)(attr.y, config._yPos),
          index: i,
          data: data[i],
          shapeInfo: {
            type: config.shape,
            radius: (0, _lib.pluck)(config.radius, 0),
            width: (0, _lib.pluckNumber)(config.width),
            height: (0, _lib.pluckNumber)(config.height),
            sides: (0, _lib.pluckNumber)(config.numSides)
          }
        });
      }
    }

    conf.tree = new _kdtree.default(true).buildKdTree(searchDataArr);

    conf.tree._setSearchLimit(maxRadius, maxRadius);
  }
  /**
   * Draw the individual data labels for the nodes
   * @param {number} index The index of the datalabel that is to be drawn
   */
  ;

  _proto.drawLabel = function drawLabel(index) {
    var dataset = this,
        chart = dataset.getFromEnv('chart'),
        conf = dataset.config,
        datasetIndex = conf.datasetIndex,
        animationManager = dataset.getFromEnv('animationManager'),
        dataStore = dataset.components.data,
        i,
        len = dataStore.length,
        labelAttrs,
        labelElement,
        plotLabelStyle,
        group = dataset.getContainer('nodesGroup'),
        // style = chart.config.dataLabelStyle,
    // animationObj = chart.get('config', 'animationObj'),
    // dummyAnimElem = animationObj.dummyObj,
    // dummyAnimObj = animationObj.animObj,
    config,
        valueString,
        chartConfig = dataset.getFromEnv('chartConfig'),
        style = dataset.getFromEnv('dataLabelStyle'),
        cursor,
        smartTextObj,
        labelDisplacement,
        eventArgs,
        set,
        yAdjustment,
        // animType = animationObj.animType,
    xPos,
        labelY,
        groupId,
        cloneText,
        plotWidth,
        plotHeight,
        labelAlign,
        setGraphics,
        dragUp = dataset.dragUp,
        dragMove = dataset.dragMove,
        dragStart = dataset.dragStart,
        rollOverProperties,
        shapeType,
        yPos,
        smartLabel = dataset.getFromEnv('smartLabel'),
        setElement,
        visible = dataset.getState('visible');
    smartLabel.setStyle(style);

    if (index !== UNDEF) {
      i = index;
      len = i + 1;
    } else {
      i = 0;
    }

    for (; i < len; i++) {
      set = dataStore[i];
      config = set.config;
      plotWidth = config._plotWidth;
      plotHeight = config._plotHeight;
      valueString = config.displayValue;
      labelAlign = config.labelAlign;
      setGraphics = set.graphics;
      cloneText = setGraphics.cloneText;
      rollOverProperties = set.config.rollOverProperties;
      shapeType = config.shapeType;

      if (visible && defined(valueString) && valueString !== _lib.BLANK) {
        // Get the displayValue text according to the canvas width.
        smartLabel.useEllipsesOnOverflow(chartConfig.useEllipsesWhenOverflow); // padding for text from boundaries is taken care of

        smartTextObj = smartLabel.getSmartText(valueString, plotWidth - PADDING, plotHeight - PADDING); // label displacement for top or bottom

        labelDisplacement = plotHeight * 0.5 - smartTextObj.height * 0.5; // label at TOP

        switch (labelAlign) {
          case POSITION_TOP:
            labelDisplacement = -labelDisplacement;
            break;

          case _lib.POSITION_BOTTOM:
            break;

          default:
            labelDisplacement = 0;
            break;
        }

        xPos = config._xPos;
        yPos = config._yPos;
        set._yAdjustment = yAdjustment = labelDisplacement;
        labelY = yPos + yAdjustment;
        cursor = config.link ? _lib.POINTER : config.allowDrag ? 'move' : _lib.BLANKSTRING;
        plotLabelStyle = config.dataLabelStyle;
        labelAttrs = {
          text: smartTextObj.text,
          title: smartTextObj.tooltext || _lib.BLANKSTRING,
          fill: plotLabelStyle.color,
          'text-bound': [plotLabelStyle.backgroundColor, plotLabelStyle.borderColor, style.borderThickness, style.borderPadding, style.borderRadius, style.borderDash],
          x: xPos,
          y: labelY,
          cursor: cursor
        };
        labelElement = setGraphics.label;
        labelElement = animationManager.setAnimation({
          el: labelElement || 'text',
          attr: labelAttrs,
          container: group,
          component: dataset
        });
        labelElement.outlineText(conf.showTextOutline, labelAttrs.fill);

        if (!setGraphics.label) {
          labelElement = dataset.addGraphicalElement('plotLabel', labelElement, true);
          setGraphics.label = labelElement; // If dragging is allowed for that node then only we bind drag functions to the labelElement

          labelElement.drag(dragMove, dragStart, dragUp);
        } else {
          labelElement.show();
        }

        setElement = setGraphics && (setGraphics.image || setGraphics.element);

        if (cloneText) {
          animationManager.setAnimation({
            el: cloneText,
            attr: {
              transform: _lib.BLANKSTRING,
              x: xPos,
              y: labelY,
              text: smartTextObj.text,
              title: smartTextObj.tooltext || _lib.BLANKSTRING,
              fill: style.color,
              'text-bound': [style.backgroundColor, style.borderColor, style.borderThickness, style.borderPadding, style.borderRadius, style.borderDash]
            },
            component: dataset
          });
        }

        labelElement.data('drag-options', {
          dataObj: set,
          dataset: dataset,
          datasetIndex: datasetIndex,
          pointIndex: set.config.index,
          cursor: cursor,
          chart: chart,
          link: set.link
        });
        eventArgs = {
          index: i,
          link: config.link,
          y: config.y,
          x: config.x,
          shape: (0, _lib.pluck)(shapeType, 'rect'),
          width: config.width,
          height: config.height,
          radius: config.radius,
          sides: config.numSides,
          label: config.displayValue,
          toolText: config.toolText,
          id: config.id,
          datasetIndex: datasetIndex,
          datasetName: dataset.config.JSONData.seriesname,
          sourceType: 'dataplot',
          allowDrag: config.allowDrag,
          numSides: config.numSides,
          imageNode: config.imageNode,
          imageAlign: config.imageAlign,
          imageWidth: config.imageWidth,
          imageHeight: config.imageHeight,
          labelAlign: config.labelAlign,
          color: config.color,
          alpha: config.alpha,
          hoverColor: config.rollOverProperties.rollOverAttrs.rawhoverColor,
          hoverAlpha: config.rollOverProperties.rollOverAttrs.rawhoverAlpha,
          borderHoverColor: config.rollOverProperties.rollOverAttrs.rawhoverBorderColor,
          borderHoverAlpha: config.rollOverProperties.rollOverAttrs.rawhoverBorderAlpha,
          borderHoverThickness: config.rollOverProperties.rollOverAttrs['stroke-width'],
          hoverHeight: config.rollOverProperties.rollOverAttrs.height,
          hoverWidth: config.rollOverProperties.rollOverAttrs.width,
          hoverRadius: config.rollOverProperties.rollOverAttrs.r
        };
        groupId = datasetIndex + '_' + i;
        labelElement.data(GROUPID, groupId);
        labelElement.data(EVENTARGS, eventArgs);
        labelElement.data('hoverAttr', rollOverProperties && rollOverProperties.rollOverAttrs);
        labelElement.data('unHoverAttr', setElement.data('unHoverAttr'));
      } else {
        setGraphics.label && setGraphics.label.hide();
      }
    }
  }
  /**
   * Parses plot cosmetics and calculates position
   *
   * @param {any} i index
   * @memberof DragNodeDataset
   */
  ;

  _proto.parsePlotAttributes = function parsePlotAttributes(i) {
    var dataset = this,
        datasetIndex = dataset.config.datasetIndex,
        datasetComponents = dataset.components,
        nodes = datasetComponents.nodes,
        xAxis = dataset.getFromEnv('xAxis'),
        yAxis = dataset.getFromEnv('yAxis'),
        data = datasetComponents.data,
        set = data[i],
        config = set.config,
        conf = dataset.config,
        xPos,
        yPos,
        setGraphics = set.graphics || (set.graphics = {}),
        symbol = config.symbol,
        width,
        height,
        radius,
        id,
        imageNode,
        confShapeArg,
        imageURL,
        imageAlign,
        lineColor = conf.colorObj.lineColor,
        lineWidth = conf.datasetPlotBorderThickness,
        plotWidth,
        plotHeight,
        isRectangle,
        rollOverProperties = set.config.rollOverProperties,
        imageWidth,
        imageHeight,
        imageY,
        pointAttr,
        fill,
        shapeType = config.shape,
        cursor = config.link ? _lib.POINTER : config.allowDrag ? 'move' : _lib.BLANKSTRING,
        rollOverAttrs,
        polypath,
        cloneImage = setGraphics.cloneImage,
        attr,
        cloneImageAttr,
        imageElementAttr;
    config._yPos = yPos = yAxis.getPixel(config.y);
    config._xPos = xPos = xAxis.getPixel(config.x); // only draw the point if y is defined

    if (yPos !== UNDEF && !isNaN(yPos)) {
      config.shapeArg = {};
      confShapeArg = config.shapeArg;
      height = (0, _lib.pluckNumber)(config.height);
      width = (0, _lib.pluckNumber)(config.width);
      radius = (0, _lib.pluckNumber)(config.radius);
      isRectangle = symbol === RECTANGLE;
      id = config.id;
      imageNode = config.imageNode;
      imageURL = config.imageURL;
      imageAlign = config.imageAlign; // TOP, MIDDLE or BOTTOM

      plotWidth = isRectangle ? width : radius * 1.4;
      imageWidth = (0, _lib.pluckNumber)(config.imageWidth, plotWidth);
      plotHeight = isRectangle ? height : radius * 1.4;
      imageHeight = (0, _lib.pluckNumber)(config.imageHeight, plotHeight);
      fill = (0, _lib.toRaphaelColor)(config.fillColor);
      config._plotWidth = plotWidth;
      config._plotHeight = plotHeight;
      pointAttr = {
        fill: fill,
        'stroke-width': lineWidth,
        stroke: (0, _lib.toRaphaelColor)(lineColor)
      };
      symbol = confShapeArg.symbol = (0, _lib.pluck)(config.symbol, conf.symbol, _lib.BLANK);
      symbol = symbol.split(UNDERSCORE);
      polypath = [symbol[1], xPos, yPos, config.radius, config.startAngle, 0];

      if (symbol[0] === 'poly' || symbol[0] === CIRCLE) {
        config.shapeType = symbol[0];
        config.elemType = PATH; // convert polypath to path

        attr = {
          path: (0, _lib.polyPathToPath)(polypath)
        };
        confShapeArg.x = xPos;
        confShapeArg.y = yPos;
        confShapeArg.radius = config.radius;
        confShapeArg.sides = symbol[1];
        pointAttr.r = config.radius;
        delete pointAttr.width;
        delete pointAttr.x;
        delete pointAttr.y;
        delete pointAttr.height;

        if (rollOverProperties && rollOverProperties.enabled) {
          rollOverAttrs = rollOverProperties.rollOverAttrs;
          delete rollOverAttrs.x;
          delete rollOverAttrs.y;
          delete rollOverAttrs.width;
          delete rollOverAttrs.height;
        }
      } else {
        config.shapeType = _lib.SHAPE_RECT;
        config.elemType = _lib.SHAPE_RECT;
        confShapeArg.x = xPos - width / 2;
        confShapeArg.y = yPos - height / 2;
        confShapeArg.r = 0;
        confShapeArg.width = width;
        confShapeArg.height = height;
        attr = {
          x: confShapeArg.x,
          y: confShapeArg.y,
          width: width,
          height: height,
          r: 0
        };
        pointAttr.width = width;
        pointAttr.height = height;
        pointAttr.x = xPos - width / 2;
        pointAttr.y = yPos - height / 2; // Readjust x and y of the rectangle if hover width or height is
        // changed

        if (rollOverProperties && rollOverProperties.enabled) {
          rollOverAttrs = rollOverProperties.rollOverAttrs;
          rollOverAttrs.x = xPos - rollOverAttrs.width / 2;
          rollOverAttrs.y = yPos - rollOverAttrs.height / 2;
          delete rollOverAttrs.r;
        }
      }

      attr.fill = fill;
      attr['stroke-width'] = lineWidth;
      attr.stroke = (0, _lib.toRaphaelColor)(lineColor);
      config.eventArgs = {
        index: i,
        link: config.link,
        y: config.y,
        x: config.x,
        shape: (0, _lib.pluck)(shapeType, 'rect'),
        width: width,
        height: height,
        radius: radius,
        sides: config.numSides,
        label: config.displayValue,
        toolText: config.toolText,
        id: config.id,
        datasetIndex: datasetIndex,
        datasetName: dataset.config.JSONData.seriesname,
        sourceType: 'dataplot',
        allowDrag: config.allowDrag,
        numSides: config.numSides,
        imageNode: config.imageNode,
        imageAlign: config.imageAlign,
        imageWidth: config.imageWidth,
        imageHeight: config.imageHeight,
        labelAlign: config.labelAlign,
        color: config.color,
        alpha: config.alpha,
        hoverColor: config.rollOverProperties.rollOverAttrs.rawhoverColor,
        hoverAlpha: config.rollOverProperties.rollOverAttrs.rawhoverAlpha,
        borderHoverColor: config.rollOverProperties.rollOverAttrs.rawhoverBorderColor,
        borderHoverAlpha: config.rollOverProperties.rollOverAttrs.rawhoverBorderAlpha,
        borderHoverThickness: config.rollOverProperties.rollOverAttrs['stroke-width'],
        hoverHeight: config.rollOverProperties.rollOverAttrs.height,
        hoverWidth: config.rollOverProperties.rollOverAttrs.width,
        hoverRadius: config.rollOverProperties.rollOverAttrs.r
      }; // Draw the imageNode if available

      if (imageNode && imageURL) {
        if (imageHeight > plotHeight) {
          imageHeight = plotHeight;
        }

        if (imageWidth > plotWidth) {
          imageWidth = plotWidth;
        }

        switch (imageAlign) {
          case _lib.POSITION_MIDDLE:
            imageY = yPos - imageHeight / 2;
            break;

          case _lib.POSITION_BOTTOM:
            imageY = plotHeight > imageHeight ? yPos + plotHeight / 2 - imageHeight : yPos - imageHeight / 2;
            break;

          default:
            imageY = plotHeight > imageHeight ? yPos - plotHeight * 0.5 : yPos - imageHeight / 2;
            break;
        }

        config.imageX = xPos - imageWidth / 2;
        config.imageY = imageY;
        config.imageWidth = imageWidth;
        config.imageHeight = imageHeight;
        imageElementAttr = {
          src: imageURL,
          x: config.imageX,
          y: imageY,
          width: imageWidth,
          height: imageHeight,
          cursor: cursor
        };

        if (cloneImage) {
          cloneImageAttr = {
            transform: _lib.BLANKSTRING,
            src: imageURL,
            x: config.imageX,
            y: imageY,
            width: imageWidth,
            height: imageHeight
          };
        }
      }

      config.pointAttr = pointAttr;
      nodes[id] = set;
      config.props = {
        element: {
          attr: attr
        },
        imageElement: {
          attr: imageElementAttr
        },
        cloneImage: {
          attr: cloneImageAttr
        },
        cloneGraphic: {
          attr: attr
        }
      };
    }
  }
  /**
   * Allocates position and parses cosmetics during post space management
   * @param  {Number} index Specific node whose node that is to be updated.
   */
  ;

  _proto.allocatePosition = function allocatePosition(index) {
    var dataset = this,
        data = dataset.components.data,
        i,
        len;
    len = data.length;

    if (index !== UNDEF) {
      dataset.parsePlotAttributes(index);
    } else {
      for (i = 0; i < len; i++) {
        dataset.parsePlotAttributes(i);
      }
    }
  }
  /**
   * Draw the individual nodes of the dataset
   * @param {number} i The index of the node that is to be drawn
   */
  ;

  _proto._drawNode = function _drawNode(i) {
    var dataset = this,
        chart = dataset.getFromEnv('chart'),
        datasetIndex = dataset.config.datasetIndex,
        manager = dataset.getLinkedParent(),
        datasetComponents = dataset.components,
        animationManager = dataset.getFromEnv('animationManager'),
        data = datasetComponents.data,
        set = data[i],
        config = set.config,
        setGraphics = set.graphics || (set.graphics = {}),
        groupId,
        imageNode = config.imageNode,
        imageURL = config.imageURL,
        group = dataset.getContainer('nodesGroup'),
        rollOverProperties = set.config.rollOverProperties,
        dragUp = dataset.dragUp,
        dragMove = dataset.dragMove,
        dragStart = dataset.dragStart,
        cursor = config.link ? _lib.POINTER : config.allowDrag ? 'move' : _lib.BLANKSTRING,
        type,
        setElement = setGraphics.graphic,
        cloneText = setGraphics.cloneText,
        cloneGraphic = setGraphics.cloneGraphic,
        cloneImage = setGraphics.cloneImage,
        imageElement = setGraphics.image,
        labelElement = setGraphics.label,
        visible = dataset.getState('visible'); // only draw the point if y is defined

    if (config._yPos !== UNDEF && !isNaN(config._yPos)) {
      setElement = setGraphics.element;
      type = setElement && setElement.type;

      if (config.elemType.indexOf(type) === -1 && setElement) {
        setElement.remove();
        setElement = setGraphics.element = null;
        labelElement && labelElement.remove();
        imageElement && imageElement.remove();
        delete setGraphics.label;
        delete setGraphics.image;
        imageElement = null;
        labelElement = null;
      }

      setElement = animationManager.setAnimation({
        el: setElement || config.elemType,
        label: 'node',
        attr: config.props.element.attr,
        container: group,
        component: dataset
      }); // Create a new element

      if (!setGraphics.graphic) {
        // If dragging is allowed for that node then only we bind drag functions to the setElement
        setElement.drag(dragMove, dragStart, dragUp);
      }

      setGraphics.element = setElement;
      setElement.show();
      manager.animationDone = true;
      groupId = datasetIndex + '_' + i;

      if (cloneGraphic) {
        if (cloneGraphic.type === setElement.type) {
          animationManager.setAnimation({
            el: cloneGraphic,
            attr: config.props.element.attr,
            component: dataset
          }).transform(_lib.BLANKSTRING);
        } else {
          cloneGraphic.remove();
          delete set.graphics.cloneGraphic;

          if (cloneText) {
            cloneText.remove();
            delete set.graphics.cloneText;
          }
        }
      } // Draw the imageNode if available


      if (imageNode && imageURL) {
        imageElement = animationManager.setAnimation({
          el: setGraphics.image || 'image',
          attr: visible && config.props.imageElement.attr,
          doNotRemove: true,
          container: group,
          component: dataset,
          callback: !visible && hideFn
        });

        if (!setGraphics.image && imageElement) {
          // If dragging is allowed for that node then only
          // we bind drag functions to the imageElement
          imageElement.drag(dragMove, dragStart, dragUp);
        }

        setGraphics.image = imageElement;
        visible && imageElement.show();
        imageElement.data('drag-options', {
          dataObj: set,
          dataset: dataset,
          datasetIndex: dataset.index,
          pointIndex: set.config.index,
          cursor: cursor,
          link: set.link
        });
        imageElement.data(GROUPID, groupId);
        imageElement.data(EVENTARGS, config.eventArgs);
        imageElement.data('hoverAttr', rollOverProperties && rollOverProperties.rollOverAttrs);
        imageElement.data('unHoverAttr', config.pointAttr);

        if (cloneImage) {
          animationManager.setAnimation({
            el: cloneImage,
            attr: config.props.cloneImage.attr,
            component: dataset
          });
        }
      } else if (setGraphics.image) {
        setGraphics.image = animationManager.setAnimation({
          el: setGraphics.image,
          component: dataset
        });
      }

      dataset.drawLabel(i);
      animationManager.setAnimation({
        el: setElement,
        attr: {
          cursor: cursor
        },
        component: dataset
      });
      setElement.data('drag-options', {
        dataObj: set,
        dataset: dataset,
        datasetIndex: dataset.index,
        pointIndex: set.config.index,
        cursor: cursor,
        chart: chart,
        link: set.link
      });
      setElement.data(GROUPID, groupId);
      setElement.data(EVENTARGS, config.eventArgs);
      setElement.data('hoverAttr', rollOverProperties && rollOverProperties.rollOverAttrs);
      setElement.data('unHoverAttr', config.pointAttr);
      visible ? setElement.show() : setElement.hide();
    } else {
      setGraphics.element && (setGraphics.element = animationManager.setAnimation({
        el: setGraphics.element,
        component: dataset
      }));
      setGraphics.image && (setGraphics.image = animationManager.setAnimation({
        el: setGraphics.image,
        component: dataset
      }));
      setGraphics.label && (setGraphics.label = animationManager.setAnimation({
        el: setGraphics.label,
        component: dataset
      }));
    }
  }
  /**
   * function to Remove data plots if the number of current data plots/categories
   * is more than the existing ones.
   * @param  {Object} datasetJSON JSON for dataset configurations
   */
  ;

  _proto.trimData = function trimData(datasetJSON) {
    if (!this.config.JSONData) {
      return;
    }

    var dataSet = this,
        prevData = dataSet.components,
        prevDataLength = prevData.data && prevData.data.length,
        currDataLength = datasetJSON.data && datasetJSON.data.length || 0,
        dataDiff = prevDataLength - currDataLength; // Removing data plots if the number of current data plots/categories
    // is more than the existing ones.

    if (dataDiff > 0) {
      dataSet.removeData(currDataLength, dataDiff);
    }
  }
  /**
   * Function to remove data during update if number of data has reduced than the previous render
   * @param {number} indexVal The data index from which data has to be removed.
   * @param {number} stretchVal The index upto which data has to be removed
   */
  ;

  _proto.removeData = function removeData(indexVal, stretchVal) {
    var dataSet = this,
        index = indexVal,
        stretch = stretchVal,
        components = dataSet.components,
        manager = dataSet.getLinkedParent(),
        dataStore = components.data,
        removeDataArr = components.removeDataArr || (components.removeDataArr = []);
    stretch = stretch || 1;
    index = index || 0;

    if (index < 0) {
      index = 0;
    }

    components.removeDataArr = removeDataArr = removeDataArr.concat(dataStore.splice(index, stretch));

    manager._clearConnectors();
  }
  /**
   * Function to remove graphics during update if number of data has reduced than the previous render
   * @param {Object} dataObj The object corresponding to the data whose graphics has to be removed
   */
  ;

  _proto._removeDataVisuals = function _removeDataVisuals(dataObj) {
    var dataSet = this,
        ele,
        graphics,
        graphicsObj;

    if (!dataObj) {
      return;
    }

    graphics = dataObj.graphics;

    for (ele in graphics) {
      graphicsObj = graphics[ele];

      if (graphicsObj.hide && typeof graphicsObj.hide === 'function') {
        dataSet.getFromEnv('animationManager').setAnimation({
          el: graphicsObj,
          attr: {
            'text-bound': []
          },
          component: dataSet
        });
        graphicsObj.hide();
        graphicsObj.transform && graphicsObj.transform(_lib.BLANKSTRING);
      }
    }
  }
  /**
   * Get json data of dragnode dataset
   * @return {Object} jsonData
   */
  ;

  _proto.getJSONData = function getJSONData() {
    var dataset = this,
        dataStore = dataset.components.data,
        len = dataStore.length,
        jsonData = [],
        dataObj,
        i;

    for (i = 0; i < len; i++) {
      dataObj = dataStore[i];

      if (!dataObj.removed) {
        if (dataObj.config._options) {
          delete dataObj.config._options.update;
          delete dataObj.config._options.add;
          jsonData.push(dataObj.config._options);
        }
      }
    }

    return jsonData;
  };

  return DragNodeDataset;
}(_area.default);

var _default = DragNodeDataset;
exports["default"] = _default;

/***/ }),

/***/ 1396:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;

var _dragnode = _interopRequireDefault(__webpack_require__(1397));

exports.DragNodeDataset = _dragnode.default;

var _dragablelabels = _interopRequireDefault(__webpack_require__(1399));

exports.DragNodeLabels = _dragablelabels.default;

var _connector = _interopRequireDefault(__webpack_require__(1401));

exports.DragNodeConnector = _connector.default;

var _dragnode2 = _interopRequireDefault(__webpack_require__(1403));

exports.DragNodeGroup = _dragnode2.default;

/***/ }),

/***/ 1324:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _index = _interopRequireDefault(__webpack_require__(599));

var _default = {
  column: {
    'initial.dataset.errorBar2D': _index.default['initial.dataset.column']
  },
  error: {
    'initial.dataset.errorBar2D': function initialDatasetErrorBar2D() {
      return {
        'path.appearing': [{
          initialAttr: {
            opacity: 0
          },
          finalAttr: {
            opacity: 1
          },
          slot: 'final'
        }]
      };
    }
  }
};
exports["default"] = _default;

/***/ }),

/***/ 1323:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = exports._checkPointerOverPlot = exports._checkPointerOverErrorBar = exports._firePlotEvent = exports._rolloutResponseSetter = exports._rolloverResponseSetter = exports.removePlots = exports._getHoveredPlot = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _lib = __webpack_require__(274);

var _column = _interopRequireDefault(__webpack_require__(595));

var _dependencyManager = __webpack_require__(282);

var _index = _interopRequireDefault(__webpack_require__(1324));

var colorStrings = _lib.preDefStr.colors,
    COLOR_AAAAAA = colorStrings.AAAAAA,
    ROUND = _lib.preDefStr.ROUND,
    MOUSEOVER = 'mouseOver',
    MOUSEOUT = 'mouseOut',
    PERCENTAGESTRING = _lib.preDefStr.PERCENTAGESTRING,
    pStr = _lib.preDefStr.pStr,
    sStr = _lib.preDefStr.sStr,
    BLANKSTRING = '',
    UNDEF,
    removePlots,
    ROLLOVER = 'DataPlotRollOver',
    ROLLOUT = 'DataPlotRollOut',
    COMMASPACE = ', ',
    // showHoverEffectStr = preDefStr.showHoverEffectStr,
// SETROLLOVERATTR = preDefStr.setRolloverAttrStr,
// SETROLLOUTATTR = preDefStr.setRolloutAttrStr,
DEFAULT_CURSOR = 'default',
    POINTER = 'pointer',
    EVENTARGS = 'eventArgs',
    GROUPID = 'groupId',
    M = 'M',
    H = 'H',
    V = 'V',
    _getHoveredPlot,
    _firePlotEvent,
    _checkPointerOverPlot,
    _checkPointerOverErrorBar,
    _rolloverResponseSetter = function _rolloverResponseSetter(chart, data, event, dataset) {
  var dataGraphics = data.graphics,
      elem = dataGraphics && dataGraphics.element,
      animationManager = chart.getFromEnv('animationManager');

  if (!data.errorBarHovered && elem && elem.getData().showHoverEffect !== 0) {
    animationManager.setAnimationState(MOUSEOVER);
    animationManager.setAnimation({
      el: elem,
      label: 'rect',
      component: dataset,
      attr: elem.getData().setRolloverAttr,
      doNotRemove: true
    });
  }

  elem && chart.plotEventHandler(elem, event, ROLLOVER);
},
    _rolloutResponseSetter = function _rolloutResponseSetter(chart, data, event, dataset) {
  var dataGraphics = data.graphics,
      elem = dataGraphics && dataGraphics.element,
      animationManager = chart.getFromEnv('animationManager');

  if (!data.errorBarHovered && elem && elem.getData().showHoverEffect !== 0) {
    animationManager.setAnimationState(MOUSEOUT);
    animationManager.setAnimation({
      el: elem,
      label: 'rect',
      component: dataset,
      attr: elem.getData().setRolloutAttr,
      doNotRemove: true
    });
  }

  elem && chart.plotEventHandler(elem, event, ROLLOUT);
};

exports._rolloutResponseSetter = _rolloutResponseSetter;
exports._rolloverResponseSetter = _rolloverResponseSetter;
exports._checkPointerOverErrorBar = _checkPointerOverErrorBar;
exports._checkPointerOverPlot = _checkPointerOverPlot;
exports._firePlotEvent = _firePlotEvent;
exports._getHoveredPlot = _getHoveredPlot;
exports.removePlots = removePlots;
(0, _dependencyManager.addDep)({
  name: 'errorbar2DColumnAnimation',
  type: 'animationRule',
  extension: _index.default.column
});
(0, _dependencyManager.addDep)({
  name: 'errorbar2DErrorAnimation',
  type: 'animationRule',
  extension: _index.default.error
});

var ErrorBar2DDataset = /*#__PURE__*/function (_ColumnDataset) {
  (0, _inheritsLoose2.default)(ErrorBar2DDataset, _ColumnDataset);

  function ErrorBar2DDataset() {
    var _this;

    _this = _ColumnDataset.call(this) || this; // eslint-disable-next-line good-practices/no-function-dependency

    _this.drawCallBackFn = function (state) {
      return function () {
        if (state === 'disappearing') {
          this.hide();
        } else {
          this.show();
        }
      };
    };

    return _this;
  }
  /**
   * Sets the type of the component
   * @return {string} type
   */


  var _proto = ErrorBar2DDataset.prototype;

  _proto.getType = function getType() {
    return 'dataset';
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */
  ;

  _proto.getName = function getName() {
    return 'errorBar2D';
  }
  /*
   * Function for parsing all the attributes and value given by the user at chart,dataset and set level.
   * This function is called once from the init() function of the Column class.
   */
  ;

  _proto.ErrorValueConfigure = function ErrorValueConfigure() {
    var dataSet = this,
        conf = dataSet.config,
        // fcJSON = dataSet.fcJSON,
    JSONData = conf.JSONData,
        setDataArr = JSONData.data,
        chartAttr = dataSet.getFromEnv('chart-attrib'),
        setData,
        dataObj,
        config,
        dataStore = dataSet.components.data,
        toolText,
        seriesNameInTooltip = (0, _lib.pluckNumber)(chartAttr.seriesnameintooltip, 1),
        // eslint-disable-line good-practices/no-single-usage-variable
    seriesname,
        tooltipSepChar = (0, _lib.parseUnsafeString)((0, _lib.pluck)(chartAttr.tooltipsepchar, COMMASPACE)),
        numberFormatter = dataSet.getFromEnv('number-formatter'),
        errorInPercent,
        macroIndices,
        parserConfig,
        toolTipValue,
        errorBarAlpha,
        setErrorValue,
        setPositiveErrorValue,
        setNegativeErrorValue,
        formatedVal,
        setTooltext,
        errorBarShadow,
        maxValue = -Infinity,
        minValue = Infinity,
        parentYAxis,
        setValue,
        errorValue,
        maxErrorValue,
        catLen = dataSet.getFromEnv('xAxis').getTicksLen(),
        // eslint-disable-line good-practices/no-single-usage-variable
    len = Math.min(catLen, setDataArr && setDataArr.length),
        // eslint-disable-line good-practices/no-single-usage-variable
    minErrorValue,
        halfErrorBar,
        positiveErrorValue,
        negativeErrorValue,
        cumulativeValueOnErrorBar,
        positiveCumulativeErrorTooltext,
        negativeCumulativeErrorTooltext,
        getTooltext = function getTooltext(setToolText) {
      var tooltext;

      if (!conf.showTooltip) {
        tooltext = false;
      } else {
        if (formatedVal === null) {
          tooltext = false;
        } else if (setToolText !== UNDEF) {
          macroIndices = [1, 2, 3, 4, 5, 6, 7, 99, 100, 101, 102, 120, 121, 131, 132];
          parserConfig = {
            yaxisName: (0, _lib.parseUnsafeString)(chartAttr.yaxisname),
            xaxisName: (0, _lib.parseUnsafeString)(chartAttr.xaxisname),
            formattedValue: config.toolTipValue,
            errorValue: setErrorValue,
            errorDataValue: config.errorToolTipValue,
            errorPercentValue: config.errorPercentValue,
            errorPercentDataValue: config.errorPercentValue,
            positiveErrorValue: setPositiveErrorValue,
            negativeErrorValue: setNegativeErrorValue,
            positiveErrorDataValue: config.positiveErrorToolTipValue,
            negativeErrorDataValue: config.negativeErrorToolTipValue,
            label: config.label
          };
          tooltext = (0, _lib.parseTooltext)(setToolText, macroIndices, parserConfig, setData, chartAttr, JSONData);
        } else {
          if (seriesNameInTooltip) {
            seriesname = (0, _lib.getFirstValue)(JSONData && JSONData.seriesname);
          }

          tooltext = seriesname ? seriesname + tooltipSepChar : BLANKSTRING;
          tooltext += config.label ? config.label + tooltipSepChar : BLANKSTRING;
        }
      }

      return tooltext;
    },
        positiveErrorToolText,
        negativeErrorToolText,
        i;

    conf.showTooltip = (0, _lib.pluckNumber)(chartAttr.showtooltip, 1);
    conf.errorInPercent = errorInPercent = (0, _lib.pluckNumber)(JSONData.errorinpercent, chartAttr.errorinpercent); // eslint-disable-line good-practices/no-single-usage-variable

    conf.showValues = (0, _lib.pluckNumber)(JSONData.showvalues, chartAttr.showvalues, 0);
    conf.errorBarShadow = errorBarShadow = (0, _lib.pluckNumber)(chartAttr.errorbarshadow, chartAttr.showshadow, 1); // eslint-disable-line good-practices/no-single-usage-variable

    conf.ignoreEmptyDatasets = (0, _lib.pluckNumber)(JSONData.ignoreemptydatasets, 0);
    halfErrorBar = (0, _lib.pluckNumber)(chartAttr.halferrorbar, 1); // eslint-disable-line good-practices/no-single-usage-variable

    conf.notHalfErrorBar = !(0, _lib.pluckNumber)(chartAttr.halferrorbar, 1);
    errorBarAlpha = (0, _lib.getFirstAlpha)((0, _lib.pluck)(JSONData.errorbaralpha, chartAttr.errorbaralpha, conf.plotfillalpha));
    conf.errorBarWidthPercent = (0, _lib.pluckNumber)(JSONData.errorbarwidthpercent, chartAttr.errorbarwidthpercent, 70);
    conf.errorBarColor = (0, _lib.convertColor)((0, _lib.getFirstColor)((0, _lib.pluck)(JSONData.errorbarcolor, chartAttr.errorbarcolor, COLOR_AAAAAA)), errorBarAlpha);
    conf.errorBarThickness = (0, _lib.pluckNumber)(JSONData.errorbarthickness, chartAttr.errorbarthickness, 1);
    conf.shadowOpacity = errorBarShadow ? errorBarAlpha / 250 : 0;
    conf.parentYAxis = parentYAxis = (0, _lib.pluck)(JSONData.parentyaxis && JSONData.parentyaxis.toLowerCase(), pStr) === sStr ? 1 : 0;
    conf.cumulativeValueOnErrorBar = (0, _lib.pluckNumber)(JSONData.cumulativevalueonerrorbar, chartAttr.cumulativevalueonerrorbar, 1);

    for (i = 0; i < len; i++) {
      dataObj = dataStore[i];

      if (!dataObj) {
        continue;
      }

      setData = setDataArr && setDataArr[i];
      config = dataObj && dataObj.config;
      positiveErrorToolText = UNDEF;
      negativeErrorToolText = UNDEF;

      if ((0, _lib.pluckNumber)(setData.value) === UNDEF) {
        continue;
      }

      if (!dataObj) {
        dataObj = dataStore[i] = {
          graphics: {}
        };
      }

      if (!dataObj.config) {
        config = dataStore[i].config = {};
      }

      setValue = config.setValue;
      config.setErrorValue = setErrorValue = numberFormatter.getCleanValue(setData.errorvalue);
      config.errorInPercent = (0, _lib.pluckNumber)(setData.errorinpercent, errorInPercent, 0);
      setPositiveErrorValue = numberFormatter.getCleanValue((0, _lib.pluckNumber)(setData.positiveerrorvalue, setErrorValue));
      setNegativeErrorValue = numberFormatter.getCleanValue((0, _lib.pluckNumber)(setData.negativeerrorvalue, setErrorValue));
      config.errorInPercent && (config.setErrorValue = setErrorValue = (0, _lib.pluckNumber)((setErrorValue / 100 * setValue).toFixed(2)));
      config.cumulativeValueOnErrorBar = (0, _lib.pluckNumber)(setData.cumulativevalueonerrorbar, conf.cumulativeValueOnErrorBar, 1);
      config.positiveErrorValue = numberFormatter.getCleanValue((0, _lib.pluckNumber)(setData.positiveerrorvalue, setData.errorvalue));
      config.errorInPercent && config.positiveErrorValue && (config.positiveErrorValue = (0, _lib.pluckNumber)((config.positiveErrorValue / 100 * setValue).toFixed(2)));
      config.positiveCumulativeErrorValue = setValue + (0, _lib.pluckNumber)(config.positiveErrorValue, config.setErrorValue);
      config.negativeErrorValue = numberFormatter.getCleanValue((0, _lib.pluckNumber)(setData.negativeerrorvalue, setData.errorvalue));
      config.errorInPercent && config.negativeErrorValue && (config.negativeErrorValue = (0, _lib.pluckNumber)((config.negativeErrorValue / 100 * setValue).toFixed(2)));
      config.negativeCumulativeErrorValue = setValue - (0, _lib.pluckNumber)(config.negativeErrorValue, config.setErrorValue);
      config.errorToolTipValue = numberFormatter.dataLabels(setErrorValue, parentYAxis);
      config.negativeErrorToolTipValue = numberFormatter.dataLabels(config.negativeErrorValue, parentYAxis);
      config.negativeCumulativeErrorTooltipValue = numberFormatter.dataLabels(config.negativeCumulativeErrorValue, parentYAxis);
      config.positiveErrorToolTipValue = numberFormatter.dataLabels(config.positiveErrorValue, parentYAxis);
      config.positiveCumulativeErrorTooltipValue = numberFormatter.dataLabels(config.positiveCumulativeErrorValue, parentYAxis);
      config.errorPercentValue = Math.round(setErrorValue / setValue * _lib.HUNDREDSTRING * _lib.HUNDREDSTRING) / _lib.HUNDREDSTRING + PERCENTAGESTRING;
      cumulativeValueOnErrorBar = config.cumulativeValueOnErrorBar;
      config.notHalfErrorBar = conf.notHalfErrorBar;
      config.halfErrorBar = halfErrorBar;
      config.showValue = (0, _lib.pluckNumber)(setData.showvalue, conf.showValues);
      config.hasErrorValue = (0, _lib.pluckNumber)(setData.errorvalue) !== UNDEF ? 1 : 0;
      errorValue = config.errorValue = setErrorValue;
      toolTipValue = config.errorToolTipValue;
      formatedVal = toolTipValue;
      setTooltext = (0, _lib.getValidValue)((0, _lib.parseUnsafeString)((0, _lib.pluck)(setData.errorplottooltext, JSONData.errorplottooltext, chartAttr.errorplottooltext, formatedVal), false));
      toolText = getTooltext(setTooltext);
      positiveErrorToolText = negativeErrorToolText = UNDEF;
      setTooltext = (0, _lib.getValidValue)((0, _lib.parseUnsafeString)((0, _lib.pluck)(setData.errorplottooltext, JSONData.errorplottooltext, chartAttr.errorplottooltext, config.positiveErrorToolTipValue), false));
      setTooltext && config.positiveErrorToolTipValue && (positiveErrorToolText = getTooltext(setTooltext));
      setTooltext = (0, _lib.getValidValue)((0, _lib.parseUnsafeString)((0, _lib.pluck)(setData.errorplottooltext, JSONData.errorplottooltext, chartAttr.errorplottooltext, config.negativeErrorToolTipValue), false));
      setTooltext && config.negativeErrorToolTipValue && (negativeErrorToolText = getTooltext(setTooltext));

      if (cumulativeValueOnErrorBar) {
        setTooltext = (0, _lib.getValidValue)((0, _lib.parseUnsafeString)((0, _lib.pluck)(setData.errorplottooltext, JSONData.errorplottooltext, chartAttr.errorplottooltext, config.positiveCumulativeErrorTooltipValue), false));
        setTooltext && config.positiveCumulativeErrorTooltipValue && (positiveCumulativeErrorTooltext = getTooltext(setTooltext));
        setTooltext = (0, _lib.getValidValue)((0, _lib.parseUnsafeString)((0, _lib.pluck)(setData.errorplottooltext, JSONData.errorplottooltext, chartAttr.errorplottooltext, config.negativeCumulativeErrorTooltipValue), false));
        setTooltext && config.negativeCumulativeErrorTooltipValue && (negativeCumulativeErrorTooltext = getTooltext(setTooltext));
      }

      positiveErrorValue = config.positiveErrorValue;
      negativeErrorValue = config.negativeErrorValue;

      if (setData.positiveerrorvalue || setData.negativeerrorvalue) {
        config.halfErrorBar = 0;
        config.notHalfErrorBar = true;
      }

      maxErrorValue = setValue + (positiveErrorValue !== null ? positiveErrorValue : setErrorValue);
      minErrorValue = setValue - (config.halfErrorBar ? 0 : negativeErrorValue < 0 && setValue < 0 ? 0 : negativeErrorValue !== null ? negativeErrorValue : setErrorValue);
      maxValue = Math.max(maxValue, maxErrorValue, minErrorValue);
      minValue = Math.min(minValue, maxErrorValue, minErrorValue);
      config.errorValueArr = [];
      config.positiveErrorValue === null && (config.positiveErrorValue = UNDEF);
      errorValue = -config.positiveErrorValue;
      config.errorValueArr.push({
        errorValue: errorValue,
        tooltext: cumulativeValueOnErrorBar ? positiveCumulativeErrorTooltext : positiveErrorToolText || toolText,
        errorEdgeBar: true
      });
      config.errorValueArr.push({
        errorValue: errorValue,
        tooltext: positiveErrorToolText || toolText
      });

      if (config.notHalfErrorBar) {
        errorValue = config.negativeErrorValue;
        config.errorValueArr.push({
          errorValue: errorValue,
          tooltext: cumulativeValueOnErrorBar ? negativeCumulativeErrorTooltext : negativeErrorToolText || toolText,
          errorEdgeBar: true
        });
        config.errorValueArr.push({
          errorValue: errorValue,
          tooltext: negativeErrorToolText || toolText
        });
      }

      config.toolText = getTooltext(config.setTooltext);
    }

    conf.maxValue = maxValue;
    conf.minValue = minValue;
  };

  _proto.drawErrorValue = function drawErrorValue() {
    var dataSet = this,
        conf = dataSet.config,
        attr,
        i,
        k,
        visible = dataSet.getState('visible'),
        yAxis = dataSet.getFromEnv('yAxis'),
        errorBarThickness = conf.errorBarThickness,
        errorBarColor = conf.errorBarColor,
        setLink,
        xPos,
        yPos,
        dataObj,
        setValue,
        config,
        animState,
        scrollMaxVal = conf.scrollMaxVal,
        // eslint-disable-line good-practices/no-single-usage-variable
    crispY,
        crispX,
        errorPath,
        errorValPos,
        errorValuePosFactor,
        errorValueArr,
        errorValueObj,
        errorValue,
        errorStartPos,
        errorLen,
        errorBarWidth,
        halfErrorBarW,
        groupId,
        errorLineElem,
        isNegative,
        barXpos,
        barYpos,
        barWidth,
        barHeight,
        errorStartValue,
        trackerConfig,
        trackerTolerance,
        errorTrackerConfig,
        animationManager = dataSet.getFromEnv('animationManager'); // Loop through each data points

    for (i = conf.scrollMinVal; i < scrollMaxVal; i++) {
      dataObj = dataSet.components.data[i];

      if (!dataObj) {
        continue;
      }

      trackerConfig = dataObj.trackerConfig;
      errorTrackerConfig = dataObj.errorTrackerConfig = {};
      errorTrackerConfig.errorTrackerArr = [];
      config = dataObj && dataObj.config;
      setValue = config && config.setValue; // If plot value is found "null", continue the loop to next iteration.

      if (dataObj === UNDEF) {
        continue;
      } else if (dataObj && (setValue === UNDEF || setValue === null || config.errorValue === BLANKSTRING || config.errorValue === UNDEF || config.errorValue === null && config.positiveErrorValue === null && config.negativeErrorValue === null)) {
        // hide error bars
        errorLen = dataObj.graphics.error && dataObj.graphics.error.length;

        for (k = 0; k < errorLen; k++) {
          if (dataObj.graphics.error && dataObj.graphics.error[k]) {
            animationManager.setAnimation({
              el: dataObj.graphics.error[k],
              label: 'path',
              callback: dataSet.drawCallBackFn('disappearing')
            });
            dataObj.graphics.error[k].shadow({
              opacity: 0
            });
          }
        }

        continue;
      }

      dataObj.errorBar && delete dataObj.errorBar;
      errorValueArr = config.errorValueArr;
      errorTrackerConfig.errorLen = errorLen = errorValueArr.length;
      !dataObj.graphics.error && (dataObj.graphics.error = []);
      groupId = dataSet.getJSONIndex() + '_' + i;
      setLink = config.setLink;
      isNegative = setValue < 0;
      barXpos = dataObj._xPos;
      barYpos = dataObj._yPos;
      barWidth = dataObj._width;
      barHeight = dataObj._height;
      yPos = isNegative ? barYpos + barHeight : barYpos;
      xPos = barXpos + barWidth / 2;
      dataObj.errorBar || (dataObj.errorBar = []); // Loop through errorValue array

      while (errorLen--) {
        errorLineElem = null;
        errorTrackerConfig.errorTrackerArr[errorLen] = {};
        errorValueObj = errorValueArr[errorLen];
        errorTrackerConfig.errorTrackerArr[errorLen].tooltext = errorValueObj.tooltext;
        errorStartValue = errorValueObj.errorStartValue;
        errorStartPos = !isNaN(errorStartValue) ? yAxis.getPixel(errorStartValue) : yPos;
        errorValue = errorValueObj.errorValue;

        if (errorValue === null || isNaN(errorValue)) {
          if (dataObj.graphics.error && dataObj.graphics.error[errorLen]) {
            animationManager.setAnimation({
              el: dataObj.graphics.error[errorLen],
              label: 'path',
              doNotRemove: true,
              callback: dataSet.drawCallBackFn('disappearing')
            }).shadow({
              opacity: 0
            });
          }

          continue;
        }

        errorBarWidth = barWidth * (conf.errorBarWidthPercent / 100);
        halfErrorBarW = errorBarWidth / 2;
        errorValuePosFactor = visible ? -1 : 0; // Vertical Error drawing

        errorValPos = yAxis.getPixel(yAxis.getValue(!isNaN(errorStartValue) ? errorStartPos : barYpos) + errorValue * errorValuePosFactor, {
          wrtVisible: true
        });
        isNegative && (errorValPos = errorValPos + barHeight);
        crispY = errorValPos;
        crispX = xPos;
        errorBarThickness = (0, _lib.pluckNumber)(errorValueObj.errorBarThickness, errorBarThickness);
        trackerTolerance = errorBarThickness > 5 ? errorBarThickness / 2 : 2.5;
        crispY = Math.round(errorValPos) + errorBarThickness % 2 / 2;
        crispX = Math.round(xPos) + errorBarThickness % 2 / 2;
        dataObj.errorBar[errorLen] || (dataObj.errorBar[errorLen] = []);

        if (errorValueObj.errorEdgeBar) {
          errorPath = [M, crispX - halfErrorBarW, crispY, H, crispX + halfErrorBarW];
          dataObj.errorBar[errorLen][1] = {
            _xPos: crispX - halfErrorBarW - trackerTolerance,
            _yPos: crispY - trackerTolerance,
            _height: 2 * trackerTolerance,
            _width: 2 * (halfErrorBarW + trackerTolerance),
            _toolText: errorValueObj.tooltext
          };
        } else {
          errorPath = [M, crispX, errorStartPos, V, crispY];
          dataObj.errorBar[errorLen][0] = {
            _xPos: crispX - trackerTolerance,
            _yPos: crispY < errorStartPos ? crispY : errorStartPos,
            _height: Math.abs(errorStartPos - crispY),
            _width: 2 * trackerTolerance,
            _toolText: errorValueObj.tooltext
          };
        }

        errorBarColor = (0, _lib.pluck)(errorValueObj.errorBarColor, errorBarColor);
        attr = {
          path: errorPath,
          stroke: errorBarColor,
          'stroke-width': errorBarThickness,
          'cursor': setLink ? POINTER : BLANKSTRING,
          'stroke-linecap': ROUND
        };
        animState = !dataObj.graphics.error[errorLen] && visible ? 'appearing' : visible ? 'updating' : 'disappearing';
        errorLineElem = dataObj.graphics.error[errorLen] = animationManager.setAnimation({
          el: dataObj.graphics.error[errorLen] || 'path',
          container: dataSet.getContainer('errorPlotGroup'),
          component: dataSet,
          attr: attr,
          label: 'path',
          state: animState,
          callback: dataSet.drawCallBackFn(animState)
        }).shadow({
          opacity: conf.shadowOpacity
        }, dataSet.getContainer('errorShadowGroup'));
        dataSet.getFromEnv('chartConfig').enablemousetracking && errorLineElem.data(GROUPID, groupId).data(EVENTARGS, trackerConfig.eventArgs);
      }

      if (!config.notHalfErrorBar) {
        for (k = 2; k < 4; k++) {
          dataObj.graphics.error && dataObj.graphics.error[k] && animationManager.setAnimation({
            el: dataObj.graphics.error[k],
            label: 'path',
            doNotRemove: true,
            callback: dataSet.drawCallBackFn('disappearing')
          }).shadow({
            opacity: 0
          });
        }
      }
    }
  }
  /**
   * This method handles all mouse events of an dataset.
   * @param {String} eventType name of the event
   * @param {number} plotIndex index of the plot where this event has been occured
   * @param {Event} originalEvent reference of the original mouse event
   */
  ;

  _proto._firePlotEvent = function _firePlotEvent(eventType, plotIndex, e) {
    var dataset = this,
        chart = dataset.getFromEnv('chart'),
        data = dataset.components.data[plotIndex],
        setElement = data.graphics.element,
        labelElement = data.graphics.label,
        errorBarHovered = data.errorBarHovered,
        setLink = data.config.setLink;

    if (setElement) {
      switch (eventType) {
        case 'fc-mouseover':
          dataset._decideTooltipType(plotIndex, e);

          _rolloverResponseSetter(chart, data, e, this);

          if (setLink) {
            setElement.css({
              'cursor': POINTER
            }); // labelElement is undefined in dataset graphics so checking for labelElement added

            labelElement && labelElement.css({
              'cursor': POINTER
            });
          }

          break;

        case 'fc-mouseout':
          dataset.getFromEnv('toolTipController').hide(dataset.config.currentToolTip);

          _rolloutResponseSetter(chart, data, e, this);

          if (setLink) {
            setElement.css({
              'cursor': DEFAULT_CURSOR
            }); // labelElement is undefined in dataset graphics so checking for labelElement added

            labelElement && labelElement.css({
              'cursor': DEFAULT_CURSOR
            });
          }

          break;

        case 'fc-click':
          chart.plotEventHandler(setElement, e);
          break;

        case 'fc-mousemove':
          dataset._decideTooltipType(plotIndex, e);

          if (errorBarHovered && !data._isRollover) {
            setElement.showHoverEffect !== 0 && setElement.attr(setElement.getData().setRolloutAttr);
            data._isRollover = true;
            data._isRollout = false;
          } else if (!errorBarHovered && !data._isRollout) {
            setElement.showHoverEffect !== 0 && setElement.attr(setElement.getData().setRolloverAttr);
            data._isRollover = false;
            data._isRollout = true;
          }

      }
    }
  } // Helper function of _checkPointerOverPlot().
  ;

  _proto._checkPointerOverErrorBar = function _checkPointerOverErrorBar(pX, chartX, chartY) {
    var dataStore = this.components.data,
        pointObj = dataStore[pX],
        hovered,
        errorBarArr,
        errorBarCompArr,
        len,
        errorBarCompLen,
        toolText,
        xPos,
        yPos,
        height,
        width;

    if (!pointObj) {
      return;
    }

    errorBarArr = pointObj.errorBar;

    if (!errorBarArr) {
      return;
    }

    len = errorBarArr && errorBarArr.length;

    while (len--) {
      errorBarCompArr = errorBarArr[len];
      errorBarCompLen = errorBarCompArr && errorBarCompArr.length;

      while (errorBarCompLen--) {
        if (!(errorBarCompArr[errorBarCompLen] && errorBarCompArr[errorBarCompLen]._xPos)) {
          continue;
        }

        xPos = errorBarCompArr[errorBarCompLen]._xPos;
        yPos = errorBarCompArr[errorBarCompLen]._yPos;
        height = errorBarCompArr[errorBarCompLen]._height;
        width = errorBarCompArr[errorBarCompLen]._width;
        toolText = errorBarCompArr[errorBarCompLen]._toolText;
        hovered = chartX >= xPos && chartX <= xPos + width && chartY >= yPos && chartY <= yPos + height;

        if (hovered) {
          return {
            pointIndex: pX,
            hovered: hovered,
            pointObj: dataStore[pX],
            toolText: toolText
          };
        }
      }
    }
  } // Helper function of _getHoverPlot()
  ;

  _proto._checkPointerOverPlot = function _checkPointerOverPlot(pX, chartX, chartY) {
    var dataSet = this,
        data = dataSet.components.data[pX],
        config = data && data.config,
        tooltipValueAtEnd,
        hoverInfo;

    if (!data) {
      return;
    }

    tooltipValueAtEnd = !dataSet.config.JSONData.plottooltext && !dataSet.getFromEnv('chart-attrib').plottooltext ? config.toolTipValue : BLANKSTRING; // eslint-disable-line good-practices/no-single-usage-variable

    hoverInfo = dataSet._checkPointerOverErrorBar(pX, chartX, chartY);

    if (hoverInfo) {
      data.errorBarHovered = true;
      config.finalTooltext = hoverInfo.toolText;
    } else {
      hoverInfo = dataSet._checkPointerOverColumn(pX, chartX, chartY);
      data.errorBarHovered = false;
      hoverInfo && (config.finalTooltext = config.toolText !== false && config.toolText + tooltipValueAtEnd);
    }

    return hoverInfo;
  }
  /**
         * Function that retunr the nearest plot details
         * @param {number} x x-axis position of the mouse cordinate
         * @param {number} y y-axis position of the mouse cordinate
         * @return {object} return an object with details of nearest polt and whether it is hovered or not
         */
  ;

  _proto._getHoveredPlot = function _getHoveredPlot(chartX, chartY) {
    var dataset = this,
        x,
        pX;
    x = dataset.getFromEnv('xAxis').getValue(chartX);
    pX = Math.round(x); // Checking for overlap between two cosecutive column plots along x-axis

    return pX - x > 0 ? dataset._checkPointerOverPlot(pX, chartX, chartY) || dataset._checkPointerOverPlot(pX - 1, chartX, chartY) : dataset._checkPointerOverPlot(pX + 1, chartX, chartY) || dataset._checkPointerOverPlot(pX, chartX, chartY);
  } // Function to remove a data from a dataset during real time update.
  ;

  _proto.removePlots = function removePlots() {
    var dataSet = this,
        components = dataSet.components,
        removeDataArr = components.removeDataArr,
        pool = components.pool || (components.pool = {
      element: [],
      hotElement: [],
      label: []
    }),
        len = removeDataArr.length,
        // eslint-disable-line good-practices/no-single-usage-variable
    removeData,
        graphics,
        i,
        k;

    for (i = 0; i < len; i++) {
      removeData = removeDataArr[0];
      removeDataArr.splice(0, 1); // In case of non existing data plot continue;

      if (!removeData || !removeData.graphics) {
        continue;
      }

      graphics = removeData.graphics;
      graphics.element && graphics.element.hide() && graphics.element.shadow({
        opacity: 0
      });

      for (k = 0; k < 4; k++) {
        if (graphics.error && graphics.error[k]) {
          dataSet.getFromEnv('animationManager').setAnimation({
            el: graphics.error[k],
            label: 'path'
          });
        }
      } // Storing the graphic elements for reuse.


      removeData.graphics.element && (pool.element = pool.element.concat(removeData.graphics.element));
      removeData.graphics.hotElement && (pool.hotElement = pool.hotElement.concat(removeData.graphics.hotElement));
      removeData.graphics.label && (pool.label = pool.label.concat(removeData.graphics.label));
    }

    components.pool = pool;
  };

  return ErrorBar2DDataset;
}(_column.default);

exports.removePlots = removePlots = ErrorBar2DDataset.prototype.removePlots;
exports._getHoveredPlot = _getHoveredPlot = ErrorBar2DDataset.prototype._getHoveredPlot;
exports._firePlotEvent = _firePlotEvent = ErrorBar2DDataset.prototype._firePlotEvent;
exports._checkPointerOverPlot = _checkPointerOverPlot = ErrorBar2DDataset.prototype._checkPointerOverPlot;
exports._checkPointerOverErrorBar = _checkPointerOverErrorBar = ErrorBar2DDataset.prototype._checkPointerOverErrorBar;
var _default = ErrorBar2DDataset;
exports["default"] = _default;

/***/ }),

/***/ 1328:
/***/ ((__unused_webpack_module, exports) => {



exports.__esModule = true;
exports["default"] = void 0;
var _default = {
  'initial.dataset.errorLine': function initialDatasetErrorLine() {
    return {
      'path.appearing': function pathAppearing() {
        return [{
          initialAttr: {
            opacity: 0
          },
          finalAttr: {
            opacity: 1
          },
          startEnd: {
            start: 0.5,
            end: 1
          },
          slot: 'plot'
        }];
      },
      '*': null
    };
  }
};
exports["default"] = _default;

/***/ }),

/***/ 1327:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _lib = __webpack_require__(274);

var _errorbar2d = __webpack_require__(1323);

var _line = _interopRequireDefault(__webpack_require__(616));

var _dependencyManager = __webpack_require__(282);

var _error = _interopRequireDefault(__webpack_require__(1328));

var _line2 = _interopRequireDefault(__webpack_require__(1329));

var colorStrings = _lib.preDefStr.colors,
    COLOR_AAAAAA = colorStrings.AAAAAA,
    // errorBarStr = preDefStr.errorBarStr,
// errorShadowStr = preDefStr.errorShadowStr,
ROUND = _lib.preDefStr.ROUND,
    PERCENTAGESTRING = _lib.preDefStr.PERCENTAGESTRING,
    BLANKSTRING = '',
    UNDEF,
    COMMASPACE = ', ',
    POINTER = 'pointer',
    TRACKER_FILL = 'rgba(192,192,192,' + (_lib.isIE ? 0.002 : 0.000001) + ')',
    // invisible but clickable
M = 'M',
    H = 'H',
    V = 'V',
    math = Math,
    mathRound = math.round,
    mathMin = math.min,
    mathMax = math.max,
    mathAbs = math.abs,
    HTP = _lib.hasTouch ? _lib.TOUCH_THRESHOLD_PIXELS : _lib.CLICK_THRESHOLD_PIXELS;
(0, _dependencyManager.addDep)({
  name: 'errorlineErrorAnimation',
  type: 'animationRule',
  extension: _error.default
});
(0, _dependencyManager.addDep)({
  name: 'errorlineLineAnimation',
  type: 'animationRule',
  extension: _line2.default
});

var ErrorLineDataset = /*#__PURE__*/function (_LINEDataset) {
  (0, _inheritsLoose2.default)(ErrorLineDataset, _LINEDataset);

  function ErrorLineDataset() {
    var _this;

    _this = _LINEDataset.call(this) || this; // eslint-disable-next-line good-practices/no-function-dependency

    _this.drawCallbackFn = function (state) {
      return function () {
        if (state === 'disappearing') {
          this.hide();
        }
      };
    };

    return _this;
  }
  /**
   * Sets the type of the component
   * @return {string} type
   */


  var _proto = ErrorLineDataset.prototype;

  _proto.getType = function getType() {
    return 'dataset';
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */
  ;

  _proto.getName = function getName() {
    return 'errorLine';
  }
  /*
   * Parses all the attributes for dataset level and set level
   * Called from init function of area class and line class
   * Both line and area attributes configuration is done here
   */
  ;

  _proto.ErrorValueConfigure = function ErrorValueConfigure() {
    var dataSet = this,
        chart = dataSet.getFromEnv('chart'),
        conf = dataSet.config,
        parentYAxis = conf.parentYAxis,
        JSONData = conf.JSONData,
        setDataArr = JSONData.data,
        chartAttr = chart.getFromEnv('dataSource').chart,
        len = dataSet.getFromEnv('xAxis').getTicksLen(),
        // eslint-disable-line good-practices/no-single-usage-variable
    setData,
        dataObj,
        config,
        dataStore = dataSet.components.data,
        numberFormatter = dataSet.getFromEnv('number-formatter'),
        toolTipValue,
        errorBarAlpha,
        errorBarThickness,
        setErrorValue,
        formatedVal,
        setTooltext,
        setNegativeErrorValue,
        setPositiveErrorValue,
        positiveCumulativeErrorTooltext,
        negativeCumulativeErrorTooltext,
        positiveErrorToolText,
        negativeErrorToolText,
        errorBarShadow,
        lineThickness = conf.linethickness,
        maxValue = -Infinity,
        minValue = Infinity,
        maxErrorValue,
        minErrorValue,
        setValue,
        errorValue,
        cumulativeValueOnErrorBar,
        tooltipSepChar = (0, _lib.pluck)(chartAttr.tooltipsepchar, COMMASPACE),
        macroIndices,
        parserConfig,
        seriesname,
        errorInPercent,
        errorToolText,
        seriesNameInTooltip = (0, _lib.pluckNumber)(chartAttr.seriesnameintooltip, 1),
        // eslint-disable-line good-practices/no-single-usage-variable
    getTooltext = function getTooltext(setToolText) {
      var toolText;

      if (!chart.config.showtooltip) {
        toolText = false;
      } else {
        if (formatedVal === null) {
          toolText = false;
        } else if (setToolText !== UNDEF) {
          macroIndices = [1, 2, 3, 4, 5, 6, 7, 99, 100, 101, 102, 120, 121, 131, 132];
          parserConfig = {
            yaxisName: (0, _lib.parseUnsafeString)(chartAttr.yaxisname),
            xaxisName: (0, _lib.parseUnsafeString)(chartAttr.xaxisname),
            formattedValue: config.toolTipValue,
            errorValue: setErrorValue,
            errorDataValue: config.errorToolTipValue,
            errorPercentValue: config.errorPercentValue,
            errorPercentDataValue: config.errorPercentValue,
            positiveErrorValue: setPositiveErrorValue,
            negativeErrorValue: setNegativeErrorValue,
            positiveErrorDataValue: config.positiveErrorToolTipValue,
            negativeErrorDataValue: config.negativeErrorToolTipValue,
            label: config.label
          };
          toolText = (0, _lib.parseTooltext)(setToolText, macroIndices, parserConfig, setData, chartAttr, JSONData);
        } else {
          if (seriesNameInTooltip) {
            seriesname = (0, _lib.getFirstValue)(JSONData && JSONData.seriesname);
          }

          toolText = seriesname ? seriesname + tooltipSepChar : BLANKSTRING;
          toolText += config.label ? config.label + tooltipSepChar : BLANKSTRING;
        }
      }

      return toolText;
    },
        i;

    conf.errorBarShadow = errorBarShadow = (0, _lib.pluckNumber)(chartAttr.errorbarshadow, chartAttr.showshadow, 1); // eslint-disable-line good-practices/no-single-usage-variable

    conf.ignoreEmptyDatasets = (0, _lib.pluckNumber)(JSONData.ignoreemptydatasets, 0); // halfErrorBar = pluckNumber(chartAttr.halferrorbar, 1);

    conf.notHalfErrorBar = !(0, _lib.pluckNumber)(chartAttr.halferrorbar, 1);
    errorBarAlpha = (0, _lib.getFirstAlpha)((0, _lib.pluck)(JSONData.errorbaralpha, chartAttr.errorbaralpha, conf.alpha));
    conf.errorBarWidth = (0, _lib.pluckNumber)(JSONData.errorbarwidth, chartAttr.errorbarwidth, 5);
    conf.errorBarColor = (0, _lib.convertColor)((0, _lib.getFirstColor)((0, _lib.pluck)(JSONData.errorbarcolor, chartAttr.errorbarcolor, COLOR_AAAAAA)), errorBarAlpha);
    errorBarThickness = (0, _lib.pluckNumber)(JSONData.errorbarthickness, chartAttr.errorbarthickness, 1);
    conf.errorBarThickness = errorBarThickness > lineThickness ? lineThickness : errorBarThickness;
    conf.shadowOpacity = errorBarShadow ? errorBarAlpha / 250 : 0;
    conf.errorInPercent = errorInPercent = (0, _lib.pluckNumber)(JSONData.errorinpercent, chartAttr.errorinpercent); // eslint-disable-line good-practices/no-single-usage-variable

    conf.cumulativeValueOnErrorBar = (0, _lib.pluckNumber)(JSONData.cumulativevalueonerrorbar, chartAttr.cumulativevalueonerrorbar, 1);

    for (i = 0; i < len; i++) {
      setData = setDataArr && setDataArr[i];

      if (!setDataArr || !setData) {
        continue;
      }

      dataObj = dataStore[i];
      config = dataObj && dataObj.config;

      if (!dataObj) {
        dataObj = dataStore[i] = {
          graphics: {}
        };
      }

      if (!dataObj.config) {
        config = dataStore[i].config = {};
      }

      setValue = config.setValue;
      config.notHalfErrorBar = conf.notHalfErrorBar;
      setErrorValue = numberFormatter.getCleanValue(setData.errorvalue);
      config.errorToolTipValue = numberFormatter.dataLabels(setErrorValue, parentYAxis);
      setPositiveErrorValue = numberFormatter.getCleanValue((0, _lib.pluckNumber)(setData.positiveerrorvalue, setErrorValue));
      setNegativeErrorValue = numberFormatter.getCleanValue((0, _lib.pluckNumber)(setData.negativeerrorvalue, setErrorValue)); // errorPercentValue = (mathRound(((setErrorValue / setValue) * HUNDREDSTRING) * HUNDREDSTRING) /
      //               HUNDREDSTRING) + PERCENTAGESTRING;

      config.setErrorValue = config.errorValue = errorValue = setErrorValue;
      config.hasErrorValue = (0, _lib.pluckNumber)(setData.errorvalue) !== UNDEF ? 1 : 0;
      toolTipValue = config.errorToolTipValue;
      formatedVal = toolTipValue; // Parsing tooltext against various configurations provided by the user.

      setTooltext = (0, _lib.getValidValue)((0, _lib.parseUnsafeString)((0, _lib.pluck)(setData.errorplottooltext, JSONData.errorplottooltext, chartAttr.errorplottooltext, formatedVal), false));
      errorToolText = getTooltext(setTooltext);
      config.errorInPercent = (0, _lib.pluckNumber)(setData.errorinpercent, errorInPercent, 0);
      config.errorInPercent && (config.setErrorValue = setErrorValue = (0, _lib.pluckNumber)((setErrorValue / 100 * setValue).toFixed(2)));
      config.cumulativeValueOnErrorBar = cumulativeValueOnErrorBar = (0, _lib.pluckNumber)(setData.cumulativevalueonerrorbar, conf.cumulativeValueOnErrorBar, 1);
      config.positiveErrorValue = numberFormatter.getCleanValue((0, _lib.pluckNumber)(setData.positiveerrorvalue, setData.errorvalue));
      config.errorInPercent && config.positiveErrorValue && (config.positiveErrorValue = (0, _lib.pluckNumber)((config.positiveErrorValue / 100 * setValue).toFixed(2)));
      config.positiveCumulativeErrorValue = setValue + (0, _lib.pluckNumber)(config.positiveErrorValue, config.setErrorValue);
      config.negativeErrorValue = numberFormatter.getCleanValue((0, _lib.pluckNumber)(setData.negativeerrorvalue, setData.errorvalue));
      config.errorInPercent && config.negativeErrorValue && (config.negativeErrorValue = (0, _lib.pluckNumber)((config.negativeErrorValue / 100 * setValue).toFixed(2)));
      config.negativeCumulativeErrorValue = setValue - (0, _lib.pluckNumber)(config.negativeErrorValue, config.setErrorValue);
      config.errorToolTipValue = numberFormatter.dataLabels(setErrorValue, parentYAxis);
      config.negativeErrorToolTipValue = numberFormatter.dataLabels(config.negativeErrorValue, parentYAxis);
      config.negativeCumulativeErrorTooltipValue = numberFormatter.dataLabels(config.negativeCumulativeErrorValue, parentYAxis);
      config.positiveErrorToolTipValue = numberFormatter.dataLabels(config.positiveErrorValue, parentYAxis);
      config.positiveCumulativeErrorTooltipValue = numberFormatter.dataLabels(config.positiveCumulativeErrorValue, parentYAxis);
      config.errorPercentValue = mathRound(setErrorValue / setValue * _lib.HUNDREDSTRING * _lib.HUNDREDSTRING) / _lib.HUNDREDSTRING + PERCENTAGESTRING;
      positiveErrorToolText = negativeErrorToolText = UNDEF;
      setTooltext = (0, _lib.getValidValue)((0, _lib.parseUnsafeString)((0, _lib.pluck)(setData.errorplottooltext, JSONData.errorplottooltext, chartAttr.errorplottooltext, config.positiveErrorToolTipValue), false));
      setTooltext && config.positiveErrorToolTipValue && (positiveErrorToolText = getTooltext(setTooltext));
      setTooltext = (0, _lib.getValidValue)((0, _lib.parseUnsafeString)((0, _lib.pluck)(setData.errorplottooltext, JSONData.errorplottooltext, chartAttr.errorplottooltext, config.negativeErrorToolTipValue), false));
      setTooltext && config.negativeErrorToolTipValue && (negativeErrorToolText = getTooltext(setTooltext));

      if (setData.positiveerrorvalue || setData.negativeerrorvalue) {
        config.halfErrorBar = 0;
        config.notHalfErrorBar = true;
      }

      if (cumulativeValueOnErrorBar) {
        setTooltext = (0, _lib.getValidValue)((0, _lib.parseUnsafeString)((0, _lib.pluck)(setData.errorplottooltext, JSONData.errorplottooltext, chartAttr.errorplottooltext, config.positiveCumulativeErrorTooltipValue), false));
        setTooltext && config.positiveCumulativeErrorTooltipValue && (positiveCumulativeErrorTooltext = getTooltext(setTooltext));
        setTooltext = (0, _lib.getValidValue)((0, _lib.parseUnsafeString)((0, _lib.pluck)(setData.errorplottooltext, JSONData.errorplottooltext, chartAttr.errorplottooltext, config.negativeCumulativeErrorTooltipValue), false));
        setTooltext && config.negativeCumulativeErrorTooltipValue && (negativeCumulativeErrorTooltext = getTooltext(setTooltext));
      }

      maxErrorValue = setValue + (config.positiveErrorValue !== null ? config.positiveErrorValue : setErrorValue);
      minErrorValue = setValue - (config.halfErrorBar ? 0 : config.negativeErrorValue < 0 && setValue < 0 ? 0 : config.negativeErrorValue !== null ? config.negativeErrorValue : setErrorValue);
      maxValue = mathMax(maxValue, maxErrorValue, minErrorValue);
      minValue = mathMin(minValue, maxErrorValue, minErrorValue);

      if (setErrorValue === null) {
        setErrorValue = UNDEF;
      }

      config.errorValueArr = [];
      config.positiveErrorValue === null && (config.positiveErrorValue = UNDEF);
      errorValue = -config.positiveErrorValue;
      config.errorValueArr.push({
        errorValue: errorValue,
        tooltext: cumulativeValueOnErrorBar ? positiveCumulativeErrorTooltext : positiveErrorToolText || errorToolText,
        errorEdgeBar: true
      });
      config.errorValueArr.push({
        errorValue: errorValue,
        tooltext: positiveErrorToolText || errorToolText
      });

      if (config.notHalfErrorBar) {
        errorValue = config.negativeErrorValue;
        config.errorValueArr.push({
          errorValue: errorValue,
          tooltext: cumulativeValueOnErrorBar ? negativeCumulativeErrorTooltext : negativeErrorToolText || errorToolText,
          errorEdgeBar: true
        });
        config.errorValueArr.push({
          errorValue: errorValue,
          tooltext: negativeErrorToolText || errorToolText
        });
      }

      config.toolText = getTooltext(config.setTooltext); // toolText;
    }

    conf.maxValue = maxValue;
    conf.minValue = minValue;
  }
  /*
         * Initialization of line dataset
         * @param {Object} chart - chart object of fusioncharts
         * @param {number} datasetIndex - index of line dataset
         * @param {boolean} isLineSet - Whether it is a lineset or a dataset
         * Called from draw graph of line
         */

  /*
   * Makes a dataset visible when clicked on its respective legend
   * Fired every time a deactivated legend is clicked
   */
  ;

  _proto._show = function _show() {
    var dataSet = this,
        chart = dataSet.chart,
        container = dataSet.graphics && dataSet.graphics.container,
        dataLabelContainer = dataSet.graphics && dataSet.graphics.dataLabelContainer,
        // eslint-disable-line good-practices/no-single-usage-variable
    errorGroupContainer = dataSet.graphics && dataSet.graphics.errorGroupContainer,
        errorShadowContainer = dataSet.graphics && dataSet.graphics.errorShadowContainer;

    chart._chartAnimation();

    container.lineGroup.show();
    container.anchorGroup.show();
    container.anchorShadowGroup.show();
    container.lineShadowGroup.show();
    dataLabelContainer.show();
    dataSet.setState('visible', true);
    errorGroupContainer && errorGroupContainer.show();
    errorShadowContainer && errorShadowContainer.show();
    dataSet._conatinerHidden = false;

    chart._setAxisLimits();

    dataSet.yAxis.draw(); // Calling the draw function for redrawing the dataset

    chart._drawDataset();
  }
  /*
   * Hides when clicked on its respective legend
   * Fired every time an activated legend is clicked
   */
  ;

  _proto._hide = function _hide() {
    var dataSet = this,
        chart = dataSet.chart;

    chart._chartAnimation();

    dataSet.setState('visible', false);

    chart._setAxisLimits();

    dataSet.yAxis.draw();

    chart._drawDataset();
  };

  _proto.draw = function draw() {
    _LINEDataset.prototype.draw.call(this);

    this.drawErrorValue();
  };

  _proto.drawErrorValue = function drawErrorValue() {
    var dataSet = this,
        conf = dataSet.config,
        // parentContainer = chart.graphics.datasetGroup,
    len = dataSet.getFromEnv('xAxis').getTicksLen(),
        // eslint-disable-line good-practices/no-single-usage-variable
    attr,
        i,
        j,
        k,
        state,
        visible = dataSet.getState('visible'),
        yAxis = dataSet.getFromEnv('yAxis'),
        dataStore = dataSet.components.data,
        // eslint-disable-line good-practices/no-single-usage-variable
    // animObj = animationObj.animObj,
    // dummyObj = animationObj.dummyObj,
    // animationDuration = animationObj.duration,
    errorBarThickness = conf.errorBarThickness,
        setLink,
        xPos,
        yPos,
        dataObj,
        setValue,
        // groupId,
    config,
        // eventArgs,
    crispY,
        crispX,
        errorPath,
        errorValPos,
        errorValuePosFactor,
        errorValueArr,
        errorValueObj,
        errorValue,
        errorStartPos,
        errorLen,
        halfErrorBarW,
        errorLineElem,
        plotXpos,
        trackerTolerance = errorBarThickness > 5 ? errorBarThickness / 2 : 2.5,
        plotYpos,
        animationManager = dataSet.getFromEnv('animationManager'),
        errorTrackerConfig; // Loop through each data points

    for (i = 0; i < len; i++) {
      dataObj = dataStore[i];
      config = dataObj && dataObj.config;
      setValue = config && config.setValue; // If plot value is found "null", continue the loop to next iteration.

      if (dataObj === UNDEF || setValue === UNDEF || setValue === null) {
        if (dataObj && dataObj.graphics.error) {
          for (j = 0; j < dataObj.graphics.error.length; j++) {
            dataObj.graphics.error && dataObj.graphics.error[j] && animationManager.setAnimation({
              el: dataObj.graphics.error[j] || 'path',
              label: 'path',
              component: dataSet,
              doNotRemove: true,
              callback: dataSet.drawCallbackFn('disappearing')
            }).shadow({
              opacity: 0
            });
          }
        }

        continue;
      }

      errorTrackerConfig = dataObj.errorTrackerConfig = {};
      errorTrackerConfig.errorTrackerArr = [];
      errorValueArr = config.errorValueArr;
      errorTrackerConfig.errorLen = errorLen = errorValueArr.length;
      !dataObj.graphics.error && (dataObj.graphics.error = []);
      !dataObj.graphics.errorTracker && (dataObj.graphics.errorTracker = []);

      if (config.errorValue === BLANKSTRING || config.errorValue === UNDEF || config.errorValue === null && config.positiveErrorValue === null && config.negativeErrorValue === null) {
        for (k = 0; k < errorLen; k++) {
          dataObj.graphics.error && dataObj.graphics.error[k] && animationManager.setAnimation({
            el: dataObj.graphics.error[k] || 'path',
            label: 'path',
            component: dataSet,
            callback: dataSet.drawCallbackFn('disappearing')
          }).shadow({
            opacity: 0
          });
        }

        continue;
      }

      setLink = config.setLink;
      plotXpos = dataObj._xPos;
      plotYpos = dataObj._yPos;
      yPos = plotYpos;
      xPos = plotXpos;
      dataObj.errorBar && delete dataObj.errorBar;
      dataObj.errorBar = []; // Loop through errorValue array

      while (errorLen--) {
        errorLineElem = null;
        errorTrackerConfig.errorTrackerArr[errorLen] = {};
        errorValueObj = errorValueArr[errorLen];
        errorTrackerConfig.errorTrackerArr[errorLen].tooltext = errorValueObj.tooltext;
        errorStartPos = yPos;
        errorValue = errorValueObj.errorValue;

        if (errorValue === null || isNaN(errorValue)) {
          if (dataObj.graphics.error && dataObj.graphics.error[errorLen]) {
            dataObj.graphics.error[errorLen].hide();
            dataObj.graphics.error[errorLen].shadow({
              opacity: 0
            });
          }

          continue;
        }

        halfErrorBarW = conf.errorBarWidth / 2;
        errorValuePosFactor = !visible ? 0 : 1; // Vertical Error drawing

        errorValPos = plotYpos + (yAxis.getPixel(0) - yAxis.getPixel(1)) * errorValue * errorValuePosFactor;
        crispY = errorValPos;
        crispX = xPos;
        crispY = mathRound(errorValPos) + errorBarThickness % 2 / 2;
        crispX = mathRound(xPos) + errorBarThickness % 2 / 2;
        dataObj.errorBar[errorLen] || (dataObj.errorBar[errorLen] = []);

        if (!errorValueObj.errorEdgeBar) {
          errorPath = [M, crispX, errorStartPos, V, crispY];
          dataObj.errorBar[errorLen][0] = {
            _xPos: crispX - trackerTolerance,
            _yPos: crispY < errorStartPos ? crispY : errorStartPos,
            _height: mathAbs(errorStartPos - crispY),
            _width: 2 * trackerTolerance,
            _toolText: errorValueObj.tooltext
          };
        } else {
          errorPath = [M, crispX - halfErrorBarW, crispY, H, crispX + halfErrorBarW];
          dataObj.errorBar[errorLen][1] = {
            _xPos: crispX - halfErrorBarW - trackerTolerance,
            _yPos: crispY - trackerTolerance,
            _height: 2 * trackerTolerance,
            _width: 2 * (halfErrorBarW + trackerTolerance),
            _toolText: errorValueObj.tooltext
          };
        }

        attr = {
          path: errorPath,
          stroke: conf.errorBarColor,
          'stroke-width': errorBarThickness,
          'cursor': setLink ? POINTER : BLANKSTRING,
          'stroke-linecap': ROUND
        };
        state = !dataObj.graphics.error[errorLen] && visible ? 'appearing' : visible ? 'updating' : 'disappearing';
        errorLineElem = dataObj.graphics.error[errorLen] = animationManager.setAnimation({
          el: dataObj.graphics.error[errorLen] || 'path',
          state: state,
          attr: attr,
          label: 'path',
          component: dataSet,
          container: dataSet.getContainer('errorPlotGroup'),
          callback: dataSet.drawCallbackFn(state)
        });
        state !== 'disappearing' && errorLineElem.show();
        errorLineElem && errorLineElem.shadow({
          opacity: conf.shadowOpacity
        }, dataSet.getContainer('errorShadowGroup'));
        errorTrackerConfig.errorTrackerArr[errorLen].attr = {
          path: errorPath,
          stroke: TRACKER_FILL,
          'stroke-width': errorBarThickness < HTP ? HTP : errorBarThickness,
          'cursor': setLink ? POINTER : BLANKSTRING
        };
      }

      if (!config.notHalfErrorBar) {
        for (k = 2; k < 4; k++) {
          dataObj.graphics.error && dataObj.graphics.error[k] && animationManager.setAnimation({
            el: dataObj.graphics.error[k] || 'path',
            label: 'path',
            component: dataSet,
            doNotRemove: true,
            callback: dataSet.drawCallbackFn('disappearing')
          }).shadow({
            opacity: 0
          });
        }
      }
    }
  };

  _proto._firePlotEvent = function _firePlotEvent(eventType, plotIndex, e) {
    _errorbar2d._firePlotEvent.call(this, eventType, plotIndex, e);
  };

  _proto._checkPointerOverErrorBar = function _checkPointerOverErrorBar(pX, chartX, chartY) {
    return _errorbar2d._checkPointerOverErrorBar.call(this, pX, chartX, chartY);
  } // Helper function of _getHoverPlot()
  ;

  _proto._checkPointerOverPlot = function _checkPointerOverPlot(pX, chartX, chartY) {
    var dataSet = this,
        data = dataSet.components.data[pX],
        config = data && data.config,
        hoverInfo;

    if (!data) {
      return;
    }

    hoverInfo = dataSet.isWithinShape(data, pX, chartX, chartY);

    if (hoverInfo) {
      data.errorBarHovered = false;
      config.finalTooltext = config.toolText !== false && config.toolText;
    } else {
      hoverInfo = dataSet._checkPointerOverErrorBar(pX, chartX, chartY);

      if (hoverInfo) {
        data.errorBarHovered = true;
        config.finalTooltext = hoverInfo.toolText;
      }
    }

    return hoverInfo;
  };

  _proto._getHoveredPlot = function _getHoveredPlot(chartX, chartY) {
    return _errorbar2d._getHoveredPlot.call(this, chartX, chartY);
  }
  /*
   * This functions calculate the space required for a dataset and return that to the chart
   *
   */
  ;

  _proto.getCanvasPadding = function getCanvasPadding() {
    var dataset = this,
        halfErrorBarW = dataset.config.errorBarWidth * 0.5,
        chart = dataset.getFromEnv('chart'),
        dataLabelStyle = chart.config.dataLabelStyle,
        data = dataset.components && dataset.components.data || [],
        firstData = data[0],
        lastData = data[data.length - 1],
        dataConf,
        label,
        dataAnchorConf,
        labelDim = {},
        padding,
        labelSpace,
        showValue,
        SmartLabel = chart.getFromEnv('smartLabel'),
        retrunDimension = {
      paddingLeft: 0,
      paddingRight: 0
    }; // @todo also calculate the space for the labels

    if (firstData) {
      dataConf = firstData.config;
      showValue = dataConf.showValue;
      dataAnchorConf = dataConf && dataConf.anchorProps || {};

      if (showValue) {
        label = dataConf.displayValue;
        SmartLabel.useEllipsesOnOverflow(chart.config.useEllipsesWhenOverflow);
        SmartLabel.setStyle(dataLabelStyle);
        labelDim = SmartLabel.getOriSize(label);
      }

      if (dataConf.setValue) {
        padding = mathMax((0, _lib.pluckNumber)(dataAnchorConf.radius, 0), halfErrorBarW) + (0, _lib.pluckNumber)(dataAnchorConf.borderThickness, 0);
        labelSpace = (labelDim.width || 0) / 2;
      }

      retrunDimension.paddingLeft = mathMax(padding, labelSpace);
    }

    if (lastData) {
      dataConf = lastData.config;
      showValue = dataConf.showValue;
      dataAnchorConf = dataConf && dataConf.anchorProps || {};

      if (showValue) {
        label = dataConf.displayValue;
        SmartLabel.setStyle(dataLabelStyle);
        labelDim = SmartLabel.getOriSize(label);
      }

      if (dataConf.setValue) {
        padding = mathMax((0, _lib.pluckNumber)(dataAnchorConf.radius, 0), halfErrorBarW) + (0, _lib.pluckNumber)(dataAnchorConf.borderThickness, 0);
        labelSpace = (labelDim.width || 0) / 2;
      }

      retrunDimension.paddingRight = mathMax(padding, labelSpace);
    }

    return retrunDimension;
  }
  /**
  * method to remove data from the dataset during update
  */
  ;

  _proto.removePlots = function removePlots() {
    _errorbar2d.removePlots.call(this);
  };

  return ErrorLineDataset;
}(_line.default);

var _default = ErrorLineDataset;
exports["default"] = _default;

/***/ }),

/***/ 1329:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _index = _interopRequireDefault(__webpack_require__(619));

var _default = {
  '*.dataset.errorLine': _index.default['*.dataset.line']
};
exports["default"] = _default;

/***/ }),

/***/ 1334:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _line = _interopRequireDefault(__webpack_require__(1329));

var _default = {
  'initial.dataset.errorScatter': _line.default['initial.dataset.errorLine']
};
exports["default"] = _default;

/***/ }),

/***/ 1332:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _scatter = _interopRequireDefault(__webpack_require__(723));

var _lib = __webpack_require__(274);

var _kdtree = _interopRequireDefault(__webpack_require__(724));

var _dependencyManager = __webpack_require__(282);

var _line = _interopRequireDefault(__webpack_require__(1333));

var _error = _interopRequireDefault(__webpack_require__(1334));

var colorStrings = _lib.preDefStr.colors,
    COLOR_AAAAAA = colorStrings.AAAAAA,
    ROUND = _lib.preDefStr.ROUND,
    PERCENTAGESTRING = _lib.preDefStr.PERCENTAGESTRING,
    BLANK = '',
    UNDEF,
    COMMASPACE = ', ',
    POINTER = 'pointer',
    HORIZONTAL = 'horizontal',
    VERTICAL = 'vertical',
    OPTIONAL = 'optional',
    // TRACKER_FILL = 'rgba(192,192,192,' + (isIE ? 0.002 : 0.000001) + ')', // invisible but clickable
M = 'M',
    H = 'H',
    V = 'V';
var DISAPPEARING = 'disappearing',
    APPEARING = 'appearing',
    UPDATING = 'updating'; // HTP = hasTouch ? TOUCH_THRESHOLD_PIXELS : CLICK_THRESHOLD_PIXELS,

(0, _dependencyManager.addDep)({
  name: 'errorscatterAnimation',
  type: 'animationRule',
  extension: _line.default
});
(0, _dependencyManager.addDep)({
  name: 'errorscatterErrorAnimation',
  type: 'animationRule',
  extension: _error.default
});

var ErrorScatter = /*#__PURE__*/function (_ScatterDataset) {
  (0, _inheritsLoose2.default)(ErrorScatter, _ScatterDataset);

  function ErrorScatter() {
    var _this;

    _this = _ScatterDataset.call(this) || this; // eslint-disable-next-line good-practices/no-function-dependency

    _this.drawCallbackFn = function (state) {
      return function () {
        if (state === 'disappearing') {
          this.hide();
        }
      };
    }; // eslint-disable-next-line good-practices/no-function-dependency


    _this.removeCallbackFn = function () {
      this.hide();
      this.shadow({
        opacity: 0
      });
    };

    return _this;
  }
  /**
   * Sets the type of the component
   * @return {string} type
   */


  var _proto = ErrorScatter.prototype;

  _proto.getType = function getType() {
    return 'dataset';
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */
  ;

  _proto.getName = function getName() {
    return 'errorScatter';
  };

  _proto.ErrorValueConfigure = function ErrorValueConfigure() {
    var dataSet = this,
        conf = dataSet.config,
        JSONData = conf.JSONData,
        categories = dataSet.getFromEnv('dataSource').categories && dataSet.getFromEnv('dataSource').categories[0].category,
        chartAttr = dataSet.getFromEnv('chart-attrib'),
        setDataArr = JSONData.data,
        setDataLen = setDataArr && setDataArr.length || 0,
        // eslint-disable-line good-practices/no-single-usage-variable
    setData,
        dataObj,
        config,
        dataStore = dataSet.components.data,
        numberFormatter = dataSet.getFromEnv('number-formatter'),
        errorBarAlpha,
        errorBarThickness,
        errorBarShadow,
        errorBarWidth,
        errorBarColor,
        halfHorizontalErrorBar,
        halfVerticalErrorBar,
        horizontalErrorBarAlpha,
        verticalErrorBarAlpha,
        horizontalErrorBarColor,
        verticalErrorBarColor,
        horizontalErrorBarThickness,
        verticalErrorBarThickness,
        hErrorValue,
        vErrorValue,
        hErrorToolTipValue,
        vErrorToolTipValue,
        tooltipSepChar = (0, _lib.pluck)(chartAttr.tooltipsepchar, COMMASPACE),
        yAxisName = (0, _lib.parseUnsafeString)(chartAttr.yaxisname),
        xAxisName = (0, _lib.parseUnsafeString)(chartAttr.xaxisname),
        parentYAxis = conf.parentYAxis,
        setValue,
        formatedVal,
        toolText,
        horizontalErrorPercent,
        verticalErrorPercent,
        macroIndices,
        parserConfig,
        seriesname,
        infMin = -Infinity,
        infMax = +Infinity,
        maxErrorValue,
        minErrorValue,
        horizontal,
        vertical,
        vPositiveErrorValue,
        hNegativeErrorValue,
        hPositiveErrorValue,
        hPositiveSetTooltext,
        hPositiveErrorToolTipValue,
        hCPErrorToolText,
        hCPErrorToolTipValue,
        hNegativeErrorToolTipValue,
        hCNErrorToolTipValue,
        vPositiveErrorToolTipValue,
        hNegativeSetTooltext,
        vCPErrorToolTipValue,
        vNegativeErrorValue,
        vCNErrorToolText,
        vCNErrorToolTipValue,
        vPositiveSetTooltext,
        hCNErrorToolText,
        vCPErrorToolText,
        cumulativeValueOnErrorBar,
        vNegativeSetTooltext,
        vNegativeErrorToolTipValue,
        yMax = infMin,
        yMin = infMax,
        xMin = infMax,
        xMax = infMin,
        getTooltext = function getTooltext(setTooltext, errorValue) {
      var tooltext;

      if (!conf.showTooltip) {
        tooltext = false;
      } else {
        if (formatedVal === null) {
          tooltext = false;
        } else if (setTooltext !== UNDEF) {
          macroIndices = [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 99, 100, 101, 102, 103, 104, 105, 106, 107, 109, 120, 121, 123, 124, 125, 126, 127, 128, 129, 130];
          parserConfig = {
            yaxisName: yAxisName,
            xaxisName: xAxisName,
            yDataValue: formatedVal,
            xDataValue: config.label,
            formattedValue: config.toolTipValue,
            horizontalErrorValue: hErrorValue,
            horizontalErrorDataValue: hErrorToolTipValue,
            verticalErrorValue: vErrorValue,
            verticalErrorDataValue: vErrorToolTipValue,
            horizontalErrorPercentValue: horizontalErrorPercent,
            verticalErrorPercentValue: verticalErrorPercent,
            label: config.label,
            // positiveErrorValue: hPositiveErrorToolTipValue,
            // negativeErrorValue: hNegativeErrorToolTipValue,
            horizontalPositiveErrorValue: config.useHorizontalErrorBar ? hPositiveErrorValue : UNDEF,
            horizontalPositiveErrorDataValue: config.useHorizontalErrorBar ? hPositiveErrorToolTipValue : UNDEF,
            horizontalNegativeErrorValue: halfHorizontalErrorBar ? UNDEF : hNegativeErrorValue,
            horizontalNegativeErrorDataValue: halfHorizontalErrorBar ? UNDEF : hNegativeErrorToolTipValue,
            verticalPositiveErrorValue: config.useVerticalErrorBar ? vPositiveErrorValue : UNDEF,
            verticalPositiveErrorDataValue: config.useVerticalErrorBar ? vPositiveErrorToolTipValue : UNDEF,
            verticalNegativeErrorValue: halfVerticalErrorBar ? UNDEF : vNegativeErrorValue,
            verticalNegativeErrorDataValue: halfVerticalErrorBar ? UNDEF : vNegativeErrorToolTipValue,
            errorValue: errorValue,
            errorDataValue: errorValue,
            errorPercentValue: config.errorPercentValue,
            errorPercentDataValue: config.errorPercentValue
          };
          tooltext = (0, _lib.parseTooltext)(setTooltext, macroIndices, parserConfig, setData, chartAttr, JSONData);
        } else {
          if (formatedVal === null) {
            tooltext = false;
          } else {
            if (conf.seriesNameInTooltip) {
              seriesname = (0, _lib.getFirstValue)(JSONData && JSONData.seriesname);
            }

            tooltext = seriesname ? seriesname + tooltipSepChar : BLANK;
            tooltext += setValue.x ? numberFormatter.xAxis(setValue.x) + tooltipSepChar : BLANK;
            tooltext += config.toolTipValue;
          }
        }
      }

      return tooltext;
    },
        i;

    conf.errorBarShadow = errorBarShadow = (0, _lib.pluckNumber)(chartAttr.errorbarshadow, chartAttr.showshadow, 0);
    conf.ignoreEmptyDatasets = (0, _lib.pluckNumber)(JSONData.ignoreemptydatasets, 0);
    conf.notHalfErrorBar = !(0, _lib.pluckNumber)(chartAttr.halferrorbar, 1);
    conf.errorBarAlpha = (0, _lib.getFirstAlpha)((0, _lib.pluck)(JSONData.errorbaralpha, chartAttr.errorbaralpha));
    conf.errorBarWidth = errorBarWidth = (0, _lib.pluckNumber)(JSONData.errorbarwidth, chartAttr.errorbarwidth, 5);
    conf.errorBarColor = errorBarColor = (0, _lib.convertColor)((0, _lib.getFirstColor)((0, _lib.pluck)(JSONData.errorbarcolor, chartAttr.errorbarcolor, COLOR_AAAAAA)), errorBarAlpha);
    conf.errorBarThickness = errorBarThickness = (0, _lib.pluckNumber)(JSONData.errorbarthickness, chartAttr.errorbarthickness, 1);
    conf.shadowOpacity = errorBarShadow ? errorBarAlpha / 250 : 0;
    conf.halfHorizontalErrorBar = halfHorizontalErrorBar = (0, _lib.pluckNumber)(chartAttr.halfhorizontalerrorbar, 1); // eslint-disable-line good-practices/no-single-usage-variable

    conf.halfVerticalErrorBar = halfVerticalErrorBar = (0, _lib.pluckNumber)(chartAttr.halfverticalerrorbar, 1); // eslint-disable-line good-practices/no-single-usage-variable

    conf.initAnimation === UNDEF && (conf.initAnimation = dataSet.getFromEnv('chart').initAnimation);
    horizontalErrorBarAlpha = (0, _lib.pluck)(JSONData.horizontalerrorbaralpha, JSONData.errorbaralpha, chartAttr.horizontalerrorbaralpha, errorBarAlpha);
    verticalErrorBarAlpha = (0, _lib.pluckNumber)(JSONData.verticalerrorbaralpha, JSONData.errorbaralpha, chartAttr.verticalerrorbaralpha, errorBarAlpha);
    horizontalErrorBarColor = (0, _lib.convertColor)((0, _lib.pluck)(JSONData.horizontalerrorbarcolor, JSONData.errorbarcolor, chartAttr.horizontalerrorbarcolor, errorBarColor), horizontalErrorBarAlpha);
    verticalErrorBarColor = (0, _lib.convertColor)((0, _lib.pluck)(JSONData.verticalerrorbarcolor, JSONData.errorbarcolor, chartAttr.verticalerrorbarcolor, errorBarColor), verticalErrorBarAlpha);
    horizontalErrorBarThickness = (0, _lib.pluckNumber)(JSONData.horizontalerrorbarthickness, JSONData.errorbarthickness, chartAttr.horizontalerrorbarthickness, errorBarThickness);
    verticalErrorBarThickness = (0, _lib.pluckNumber)(JSONData.verticalerrorbarthickness, JSONData.errorbarthickness, chartAttr.verticalerrorbarthickness, errorBarThickness);
    conf.horizontalErrorBarWidth = (0, _lib.pluckNumber)(JSONData.horizontalerrorbarwidth, chartAttr.horizontalerrorbarwidth, errorBarWidth);
    conf.verticalErrorBarWidth = (0, _lib.pluckNumber)(JSONData.verticalerrorbarwidth, chartAttr.verticalerrorbarwidth, errorBarWidth);
    conf.cumulativeValueOnErrorBar = (0, _lib.pluckNumber)(JSONData.cumulativevalueonerrorbar, chartAttr.cumulativevalueonerrorbar, 1);

    for (i = 0; i < setDataLen; i++) {
      if (!setDataArr) {
        continue;
      }

      setData = setDataArr && setDataArr[i];
      dataObj = dataStore[i];
      config = dataObj && dataObj.config;

      if (!dataObj) {
        dataObj = dataStore[i] = {
          graphics: {}
        };
      }

      if (!dataObj.config) {
        config = dataStore[i].config = {};
      } // setErrorValue = numberFormatter.getCleanValue(setData.errorvalue);


      setValue = config.setValue;
      config.errorValue = setData.errorvalue;
      config.cumulativeValueOnErrorBar = cumulativeValueOnErrorBar = (0, _lib.pluckNumber)(setData.cumulativevalueonerrorbar, conf.cumulativeValueOnErrorBar, 1);
      config.hErrorValue = hErrorValue = numberFormatter.getCleanValue((0, _lib.pluck)(setData.horizontalerrorvalue, setData.errorvalue));
      hErrorToolTipValue = numberFormatter.xAxis(hErrorValue);
      config.vErrorValue = vErrorValue = numberFormatter.getCleanValue((0, _lib.pluck)(setData.verticalerrorvalue, setData.errorvalue));
      vErrorToolTipValue = numberFormatter.dataLabels(vErrorValue);
      config.hPositiveErrorValue = hPositiveErrorValue = numberFormatter.getCleanValue((0, _lib.pluck)(setData.horizontalpositiveerrorvalue, setData.positiveerrorvalue, hErrorValue));
      config.hNegativeErrorValue = hNegativeErrorValue = numberFormatter.getCleanValue((0, _lib.pluck)(setData.horizontalnegativeerrorvalue, setData.negativeerrorvalue, hErrorValue));
      config.vPositiveErrorValue = vPositiveErrorValue = numberFormatter.getCleanValue((0, _lib.pluck)(setData.verticalpositiveerrorvalue, setData.positiveerrorvalue, vErrorValue));
      config.vNegativeErrorValue = vNegativeErrorValue = numberFormatter.getCleanValue((0, _lib.pluck)(setData.verticalnegativeerrorvalue, setData.negativeerrorvalue, vErrorValue));
      horizontalErrorPercent = Math.round(hErrorValue / setValue.x * _lib.HUNDREDSTRING * _lib.HUNDREDSTRING) / _lib.HUNDREDSTRING + PERCENTAGESTRING;
      verticalErrorPercent = Math.round(vErrorValue / setValue.y * _lib.HUNDREDSTRING * _lib.HUNDREDSTRING) / _lib.HUNDREDSTRING + PERCENTAGESTRING;
      hPositiveErrorToolTipValue = numberFormatter.dataLabels(hPositiveErrorValue, parentYAxis);
      hPositiveSetTooltext = (0, _lib.getValidValue)((0, _lib.parseUnsafeString)((0, _lib.pluck)(setData.errorplottooltext, JSONData.errorplottooltext, chartAttr.errorplottooltext, hPositiveErrorToolTipValue), false));
      hNegativeErrorToolTipValue = numberFormatter.dataLabels(hNegativeErrorValue, parentYAxis);
      hNegativeSetTooltext = (0, _lib.getValidValue)((0, _lib.parseUnsafeString)((0, _lib.pluck)(setData.errorplottooltext, JSONData.errorplottooltext, chartAttr.errorplottooltext, hNegativeErrorToolTipValue), false));
      vPositiveErrorToolTipValue = numberFormatter.dataLabels(vPositiveErrorValue, parentYAxis);
      vPositiveSetTooltext = (0, _lib.getValidValue)((0, _lib.parseUnsafeString)((0, _lib.pluck)(setData.errorplottooltext, JSONData.errorplottooltext, chartAttr.errorplottooltext, vPositiveErrorToolTipValue), false));
      vNegativeErrorToolTipValue = numberFormatter.dataLabels(vNegativeErrorValue, parentYAxis);
      vNegativeSetTooltext = (0, _lib.getValidValue)((0, _lib.parseUnsafeString)((0, _lib.pluck)(setData.errorplottooltext, JSONData.errorplottooltext, chartAttr.errorplottooltext, vNegativeErrorToolTipValue), false));
      hCPErrorToolText = hCNErrorToolText = vCPErrorToolText = vCNErrorToolText = UNDEF;

      if (cumulativeValueOnErrorBar) {
        hCPErrorToolTipValue = numberFormatter.dataLabels(setValue.x + hPositiveErrorValue, parentYAxis);
        hCPErrorToolText = (0, _lib.getValidValue)((0, _lib.parseUnsafeString)((0, _lib.pluck)(setData.errorplottooltext, JSONData.errorplottooltext, chartAttr.errorplottooltext, hCPErrorToolTipValue), false));
        hCNErrorToolTipValue = numberFormatter.dataLabels(setValue.x - hNegativeErrorValue, parentYAxis);
        hCNErrorToolText = (0, _lib.getValidValue)((0, _lib.parseUnsafeString)((0, _lib.pluck)(setData.errorplottooltext, JSONData.errorplottooltext, chartAttr.errorplottooltext, hCNErrorToolTipValue), false));
        vCPErrorToolTipValue = numberFormatter.dataLabels(setValue.y + vPositiveErrorValue, parentYAxis);
        vCPErrorToolText = (0, _lib.getValidValue)((0, _lib.parseUnsafeString)((0, _lib.pluck)(setData.errorplottooltext, JSONData.errorplottooltext, chartAttr.errorplottooltext, vCPErrorToolTipValue), false));
        vCNErrorToolTipValue = numberFormatter.dataLabels(setValue.y - vNegativeErrorValue, parentYAxis);
        vCNErrorToolText = (0, _lib.getValidValue)((0, _lib.parseUnsafeString)((0, _lib.pluck)(setData.errorplottooltext, JSONData.errorplottooltext, chartAttr.errorplottooltext, vCNErrorToolTipValue), false));
      }

      categories && categories[i] && (config.label = (0, _lib.getValidValue)((0, _lib.parseUnsafeString)((0, _lib.pluck)(categories[i].tooltext, categories[i].label))));

      if (setData.horizontalpositiveerrorvalue || setData.positiveerrorvalue || setData.horizontalnegativeerrorvalue || setData.negativeerrorvalue) {
        config.halfHorizontalErrorBar = halfHorizontalErrorBar = 0;
      } else {
        config.halfHorizontalErrorBar = halfHorizontalErrorBar = conf.halfHorizontalErrorBar;
      }

      if (setData.verticalpositiveerrorvalue || setData.positiveerrorvalue || setData.verticalnegativeerrorvalue || setData.negativeerrorvalue) {
        config.halfVerticalErrorBar = halfVerticalErrorBar = 0;
      } else {
        config.halfVerticalErrorBar = halfVerticalErrorBar = conf.halfVerticalErrorBar;
      }

      if (setValue.x !== null) {
        maxErrorValue = setValue.x + Number(hPositiveErrorValue);
        minErrorValue = setValue.x - (halfHorizontalErrorBar ? 0 : Number(hNegativeErrorValue));
        xMax = Math.max(xMax, maxErrorValue, minErrorValue);
        xMin = Math.min(xMin, maxErrorValue, minErrorValue);
      }

      if (setValue.y !== null) {
        maxErrorValue = setValue.y + Number(vPositiveErrorValue);
        minErrorValue = setValue.y - (halfVerticalErrorBar ? 0 : Number(vNegativeErrorValue));
        yMax = Math.max(yMax, maxErrorValue, minErrorValue);
        yMin = Math.min(yMin, maxErrorValue, minErrorValue);
      }

      config.useHorizontalErrorBar = (0, _lib.pluckNumber)(setData.usehorizontalerrorbar, JSONData.usehorizontalerrorbar, chartAttr.usehorizontalerrorbar, 0);
      config.useVerticalErrorBar = (0, _lib.pluckNumber)(setData.useverticalerrorbar, JSONData.useverticalerrorbar, chartAttr.useverticalerrorbar, 1);
      config.errorValueConf = {}; // horizontal error bar related segments

      horizontal = config.errorValueConf.horizontal = {}; // this segments are mandatory as this part will show regardless show half error value is true or false

      horizontal.mandatory = {}; // marker is one of the segment of error bar which denotes the error value

      horizontal.mandatory.marker = {
        errorValue: -(hPositiveErrorValue === null ? UNDEF : hPositiveErrorValue),
        tooltext: getTooltext(hPositiveSetTooltext, hPositiveErrorToolTipValue),
        errorBarColor: horizontalErrorBarColor,
        isHorizontal: true,
        errorBarThickness: horizontalErrorBarThickness,
        shadowOpacity: errorBarShadow ? horizontalErrorBarAlpha / 250 : 0
      }; // limit denotes the error value or cummulative value of the error bar thats why we are calling it limit
      // as it conveys that the end of error bar

      horizontal.mandatory.limit = {
        errorValue: -(hPositiveErrorValue === null ? UNDEF : hPositiveErrorValue),
        tooltext: cumulativeValueOnErrorBar ? getTooltext(hCPErrorToolText, hCPErrorToolTipValue) : getTooltext(hPositiveSetTooltext, hPositiveErrorToolTipValue),
        errorBarColor: horizontalErrorBarColor,
        isHorizontal: true,
        errorBarThickness: horizontalErrorBarThickness,
        shadowOpacity: errorBarShadow ? horizontalErrorBarAlpha / 250 : 0,
        errorEdgeBar: true
      }; // this segments are option as this part will show only show half error value is true

      horizontal.optional = {}; // marker is one of the segment of error bar which denotes the error value

      horizontal.optional.marker = {
        errorValue: hNegativeErrorValue,
        tooltext: getTooltext(hNegativeSetTooltext, hNegativeErrorToolTipValue),
        errorBarColor: horizontalErrorBarColor,
        isHorizontal: true,
        errorBarThickness: horizontalErrorBarThickness,
        shadowOpacity: errorBarShadow ? horizontalErrorBarAlpha / 250 : 0
      }; // limit denotes the error value or cummulative value of the error bar thats why we are calling it limit
      // as it conveys that the end of error bar

      horizontal.optional.limit = {
        errorValue: hNegativeErrorValue,
        tooltext: cumulativeValueOnErrorBar ? getTooltext(hCNErrorToolText, hCNErrorToolTipValue) : getTooltext(hNegativeSetTooltext, hNegativeErrorToolTipValue),
        errorBarColor: horizontalErrorBarColor,
        isHorizontal: true,
        errorBarThickness: horizontalErrorBarThickness,
        shadowOpacity: errorBarShadow ? horizontalErrorBarAlpha / 250 : 0,
        errorEdgeBar: true
      }; // vertical error bar related segments

      vertical = config.errorValueConf.vertical = {}; // this segments are mandatory as this part will show regardless show half error value is true or false

      vertical.mandatory = {}; // marker is one of the segment of error bar which denotes the error value

      vertical.mandatory.marker = {
        errorValue: -(vPositiveErrorValue === null ? UNDEF : vPositiveErrorValue),
        tooltext: getTooltext(vPositiveSetTooltext, vPositiveErrorToolTipValue),
        errorBarColor: verticalErrorBarColor,
        errorBarThickness: verticalErrorBarThickness,
        shadowOpacity: errorBarShadow ? verticalErrorBarAlpha / 250 : 0
      }; // limit denotes the error value or cummulative value of the error bar thats why we are calling it limit
      // as it conveys that the end of error bar

      vertical.mandatory.limit = {
        errorValue: -(vPositiveErrorValue === null ? UNDEF : vPositiveErrorValue),
        tooltext: cumulativeValueOnErrorBar ? getTooltext(vCPErrorToolText, vCPErrorToolTipValue) : getTooltext(vPositiveSetTooltext, vPositiveErrorToolTipValue),
        errorBarColor: verticalErrorBarColor,
        errorBarThickness: verticalErrorBarThickness,
        shadowOpacity: errorBarShadow ? verticalErrorBarAlpha / 250 : 0,
        errorEdgeBar: true
      }; // this segments are option as this part will show only show half error value is true

      vertical.optional = {}; // marker is one of the segment of error bar which denotes the error value

      vertical.optional.marker = {
        errorValue: vNegativeErrorValue,
        tooltext: getTooltext(vNegativeSetTooltext, vNegativeErrorToolTipValue),
        errorBarColor: verticalErrorBarColor,
        errorBarThickness: verticalErrorBarThickness,
        shadowOpacity: errorBarShadow ? verticalErrorBarAlpha / 250 : 0
      }; // limit denotes the error value or cummulative value of the error bar thats why we are calling it limit
      // as it conveys that the end of error bar

      vertical.optional.limit = {
        errorValue: vNegativeErrorValue,
        tooltext: cumulativeValueOnErrorBar ? getTooltext(vCNErrorToolText, vCNErrorToolTipValue) : getTooltext(vNegativeSetTooltext, vNegativeErrorToolTipValue),
        errorBarColor: verticalErrorBarColor,
        errorBarThickness: verticalErrorBarThickness,
        shadowOpacity: errorBarShadow ? verticalErrorBarAlpha / 250 : 0,
        errorEdgeBar: true
      };
      setValue = config.setValue; // errorPercentValue = (Math.round(((setErrorValue / setValue) * HUNDREDSTRING) * HUNDREDSTRING) /
      //               HUNDREDSTRING) + PERCENTAGESTRING;

      formatedVal = config.formatedVal; // Initial tooltext parsing

      if (!conf.showTooltip) {
        toolText = false;
      } else if (config.setTooltext !== UNDEF) {
        macroIndices = [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 99, 100, 101, 102, 103, 104, 105, 106, 107, 109, 120, 121, 123, 124, 125, 126, 127, 128, 129, 130];
        parserConfig = {
          yaxisName: yAxisName,
          xaxisName: xAxisName,
          yDataValue: formatedVal,
          xDataValue: config.label,
          formattedValue: config.toolTipValue,
          horizontalErrorValue: hErrorValue,
          horizontalErrorDataValue: hErrorToolTipValue,
          verticalErrorValue: vErrorValue,
          verticalErrorDataValue: vErrorToolTipValue,
          horizontalErrorPercentValue: horizontalErrorPercent,
          verticalErrorPercentValue: verticalErrorPercent,
          label: config.label,
          // positiveErrorValue: hPositiveErrorToolTipValue,
          // negativeErrorValue: hNegativeErrorToolTipValue,
          horizontalPositiveErrorValue: config.useHorizontalErrorBar ? hPositiveErrorValue : UNDEF,
          horizontalPositiveErrorDataValue: config.useHorizontalErrorBar ? hPositiveErrorToolTipValue : UNDEF,
          horizontalNegativeErrorValue: halfHorizontalErrorBar ? UNDEF : hNegativeErrorValue,
          horizontalNegativeErrorDataValue: halfHorizontalErrorBar ? UNDEF : hNegativeErrorToolTipValue,
          verticalPositiveErrorValue: config.useVerticalErrorBar ? vPositiveErrorValue : UNDEF,
          verticalPositiveErrorDataValue: config.useVerticalErrorBar ? vPositiveErrorToolTipValue : UNDEF,
          verticalNegativeErrorValue: halfVerticalErrorBar ? UNDEF : vNegativeErrorValue,
          verticalNegativeErrorDataValue: halfVerticalErrorBar ? UNDEF : vNegativeErrorToolTipValue,
          errorValue: config.errorValue,
          errorDataValue: numberFormatter.dataLabels(config.errorValue, conf.parentYAxis)
        };
        toolText = (0, _lib.parseTooltext)(config.setTooltext, macroIndices, parserConfig, setData, chartAttr, JSONData);
      } else {
        // determine the default tooltext then.
        if (formatedVal === null) {
          toolText = false;
        } else {
          if (conf.seriesNameInTooltip) {
            seriesname = (0, _lib.getFirstValue)(JSONData && JSONData.seriesname);
          }

          toolText = seriesname ? seriesname + tooltipSepChar : BLANK;
          toolText += setValue.x ? numberFormatter.xAxis(setValue.x) + tooltipSepChar : BLANK;
          toolText += config.toolTipValue;
        }
      }

      config.toolText = toolText;
    }

    conf.xMax = xMax;
    conf.xMin = xMin;
    conf.yMin = yMin;
    conf.yMax = yMax;
  };

  _proto.drawErrorValue = function drawErrorValue() {
    var dataSet = this,
        conf = dataSet.config,
        setDataArr = dataSet.config.JSONData.data,
        dataSetLen = setDataArr && setDataArr.length,
        // eslint-disable-line good-practices/no-single-usage-variable
    attr,
        i,
        errorGraphicsString,
        visible = dataSet.getState('visible'),
        dataStore = dataSet.components.data,
        // eslint-disable-line good-practices/no-single-usage-variable
    graphics,
        // yAxisPVR = yAxis.getPVR(),
    // xAxisPVR = xAxis.getPVR(),
    isHorizontal,
        errorBarThickness,
        errorBarWidth,
        errorBarColor,
        setLink,
        xPos,
        yPos,
        useCrispErrorPath = 1,
        dataObj,
        setValue,
        animState,
        config,
        notRequiredHEB,
        notRequiredVEB,
        isHalfHorizontalErrorBar,
        isHalfVertictalErrorBar,
        crispY,
        crispX,
        errorPath,
        errorValPos,
        errorValuePosFactor,
        subType,
        errorBar,
        subErrorBar,
        segment,
        segmentType,
        currErrorTracker,
        errorValue,
        errorStartPos,
        halfErrorBarW,
        errorLineElem,
        plotXpos,
        plotYpos,
        errorBarSegmentLen,
        errorBarSegmentStartPos,
        l,
        k,
        errorValueConf,
        errorBarType,
        trackerTolerance,
        keys,
        animationManager = dataSet.getFromEnv('animationManager'),
        searchDataArr = [],
        errorTrackerConfig; // Loop through each data points

    for (i = 0; i < dataSetLen; i++) {
      dataObj = dataStore[i];
      errorTrackerConfig = dataObj.errorTrackerConfig = {};
      errorTrackerConfig.errorTrackerArr = [];
      config = dataObj && dataObj.config;
      setValue = config && config.setValue;
      errorValueConf = config.errorValueConf; // If plot value is found "null", continue the loop to next iteration.

      if (dataObj === UNDEF || setValue === UNDEF || setValue === null || !errorValueConf) {
        continue;
      }

      keys = Object.keys(graphics = dataObj.graphics);

      if (config.vErrorValue === null && config.vPositiveErrorValue === null && config.vNegativeErrorValue === null) {
        for (k = 0; k < keys.length; k++) {
          if (keys[k].match(/error-horizontal-/)) {
            animationManager.setAnimation({
              el: graphics[keys[k]],
              state: 'disappearing',
              callback: dataSet.drawCallbackFn('disappearing')
            });
            graphics[keys[k]].shadow({
              opacity: 0
            });
          }
        }
      }

      if (config.hErrorValue === null && config.hPositiveErrorValue === null && config.vPositiveErrorValue === null) {
        for (k = 0; k < keys.length; k++) {
          if (keys[k].match(/error-vertical-/)) {
            animationManager.setAnimation({
              el: graphics[keys[k]],
              state: 'disappearing',
              callback: dataSet.drawCallbackFn('disappearing')
            });
            graphics[keys[k]].shadow({
              opacity: 0
            });
          }
        }
      }

      if (config.hErrorValue === null && config.vErrorValue === null && config.hPositiveErrorValue && config.hNegativeErrorValue && config.vPositiveErrorValue && config.vNegativeErrorValue) {
        continue;
      }

      setLink = config.setLink;
      plotXpos = dataObj._xPos;
      plotYpos = dataObj._yPos;
      yPos = plotYpos;
      xPos = plotXpos; // errorBarType := horizontal / vertical

      for (errorBarType in errorValueConf) {
        if (!errorValueConf.hasOwnProperty(errorBarType)) {
          continue;
        }

        errorBar = errorValueConf[errorBarType]; // subType := mandatory / optional

        for (subType in errorBar) {
          if (!errorBar.hasOwnProperty(subType)) {
            continue;
          }

          subErrorBar = errorBar[subType]; // segmentType := marker / limit

          for (segmentType in subErrorBar) {
            if (!subErrorBar.hasOwnProperty(segmentType)) {
              continue;
            }

            animState = UNDEF;
            segment = subErrorBar[segmentType];
            attr = {};
            currErrorTracker = errorTrackerConfig.errorTrackerArr[0] = {};
            errorLineElem = null;
            currErrorTracker.tooltext = segment.tooltext;
            errorStartPos = yPos;
            errorValue = segment.errorValue;
            notRequiredHEB = !config.useHorizontalErrorBar && errorBarType === HORIZONTAL;
            notRequiredVEB = !config.useVerticalErrorBar && errorBarType === VERTICAL;
            isHalfHorizontalErrorBar = config.halfHorizontalErrorBar && errorBarType === HORIZONTAL && subType === OPTIONAL;
            isHalfVertictalErrorBar = config.halfVerticalErrorBar && errorBarType === VERTICAL && subType === OPTIONAL;

            if (notRequiredHEB || notRequiredVEB || isHalfHorizontalErrorBar || isHalfVertictalErrorBar) {
              animState = DISAPPEARING;
            } else if (errorValue === null || errorValue === UNDEF || isNaN(errorValue)) {
              animState = DISAPPEARING;
            } else {
              errorBarColor = segment.errorBarColor;
              isHorizontal = segment.isHorizontal;
              errorBarThickness = segment.errorBarThickness;
              errorBarWidth = isHorizontal ? conf.horizontalErrorBarWidth : conf.verticalErrorBarWidth;
              halfErrorBarW = !visible ? 0 : errorBarWidth / 2;
              errorValuePosFactor = !visible ? 0 : -1;
              trackerTolerance = errorBarThickness > 5 ? errorBarThickness / 2 + 0.5 : 5.5 / 2;

              if (isHorizontal) {
                errorValPos = dataSet.getFromEnv('xAxis').getPixel(dataObj.config._x + errorValue * errorValuePosFactor);
                crispY = errorValPos;
                crispX = xPos;

                if (useCrispErrorPath) {
                  crispY = Math.round(errorStartPos) + errorBarThickness % 2 / 2;
                  crispX = Math.round(errorValPos) + errorBarThickness % 2 / 2;
                }

                if (segment.errorEdgeBar) {
                  errorPath = [M, crispX, crispY - halfErrorBarW, V, crispY + halfErrorBarW];
                  errorBarSegmentLen = 2 * halfErrorBarW;
                  errorBarSegmentStartPos = crispY - halfErrorBarW;

                  for (l = trackerTolerance; l < errorBarSegmentLen; l += 2 * trackerTolerance) {
                    searchDataArr.push({
                      x: crispX,
                      y: errorBarSegmentStartPos + l,
                      r: trackerTolerance,
                      index: i,
                      data: dataObj,
                      toolText: segment.tooltext,
                      barType: 'h'
                    });
                  }
                } else {
                  errorPath = [M, xPos, crispY, H, crispX];
                  errorBarSegmentLen = Math.abs(xPos - crispX);
                  errorBarSegmentStartPos = xPos > crispX ? crispX : xPos;

                  for (l = trackerTolerance; l < errorBarSegmentLen; l += 2 * trackerTolerance) {
                    searchDataArr.push({
                      x: errorBarSegmentStartPos + l,
                      y: crispY,
                      r: trackerTolerance,
                      index: i,
                      data: dataObj,
                      toolText: segment.tooltext,
                      barType: 'h'
                    });
                  }
                }
              } else {
                // Vertical Error drawing
                errorValPos = dataSet.getFromEnv('yAxis').getPixel(dataObj.config._y + errorValue * errorValuePosFactor);
                crispY = errorValPos;
                crispX = xPos;

                if (useCrispErrorPath) {
                  crispY = Math.round(errorValPos) + errorBarThickness % 2 / 2;
                  crispX = Math.round(xPos) + errorBarThickness % 2 / 2;
                }

                if (segment.errorEdgeBar) {
                  errorPath = [M, crispX - halfErrorBarW, crispY, H, crispX + halfErrorBarW];
                  errorBarSegmentLen = 2 * halfErrorBarW;
                  errorBarSegmentStartPos = crispX - halfErrorBarW;

                  for (l = trackerTolerance; l <= errorBarSegmentLen; l += 2 * trackerTolerance) {
                    searchDataArr.push({
                      x: errorBarSegmentStartPos + l,
                      y: crispY,
                      r: trackerTolerance,
                      index: i,
                      data: dataObj,
                      toolText: segment.tooltext,
                      barType: 'v'
                    });
                  }
                } else {
                  errorPath = [M, crispX, errorStartPos, V, crispY];
                  errorBarSegmentLen = Math.abs(errorStartPos - crispY);
                  errorBarSegmentStartPos = errorStartPos > crispY ? crispY : errorStartPos;

                  for (l = trackerTolerance; l <= errorBarSegmentLen; l += 2 * trackerTolerance) {
                    searchDataArr.push({
                      x: crispX,
                      y: errorBarSegmentStartPos + l,
                      r: trackerTolerance,
                      index: i,
                      data: dataObj,
                      toolText: segment.tooltext,
                      barType: 'v'
                    });
                  }
                }
              }

              attr = {
                path: errorPath,
                'stroke-width': visible ? errorBarThickness : 0,
                stroke: errorBarColor,
                'cursor': setLink ? POINTER : BLANK,
                'stroke-linecap': ROUND
              };
            }

            errorGraphicsString = ['error', errorBarType, subType, segmentType].join('-');

            if (!animState) {
              if (graphics[errorGraphicsString]) {
                animState = UPDATING;
              } else {
                animState = APPEARING;
              }
            }

            if (!graphics[errorGraphicsString] && animState === 'disappearing') {
              continue;
            }

            errorLineElem = graphics[errorGraphicsString] = animationManager.setAnimation({
              el: graphics[errorGraphicsString] || 'path',
              container: dataSet.getContainer('errorPlotGroup'),
              component: dataSet,
              attr: attr,
              state: animState,
              label: 'path',
              callback: dataSet.drawCallbackFn(animState)
            });
            animState !== 'disappearing' && errorLineElem.show(); // @todo has to validate how it works
            // why we need to set opacity while it is follower to main element

            errorLineElem.shadow({
              opacity: animState === 'disappearing' ? 0 : conf.shadowOpacity
            }, dataSet.getContainer('errorShadowGroup'));
          }
        }
      }
    }

    searchDataArr.length && (this.config.dataTreeB = new _kdtree.default().buildKdTree(searchDataArr));
    conf.initAnimation = false;
  }
  /*
         * Using kdtree algo for searching
        */
  ;

  _proto._getHoveredPlot = function _getHoveredPlot(x, y) {
    var res, res1, tooltext, errorBarToolText, hoverEffects, element;
    res = this.config.dataTree.getNeighbour({
      x: x,
      y: y
    }, true); // searching neighbour from Kdtree with basic search flag on

    if (res) {
      tooltext = res.data.config.toolText;
      res.data.config.finalTooltext = tooltext;
      hoverEffects = res.data.config.hoverEffects;
      element = res.data.graphics.element;
      element.data('hoverEnabled', hoverEffects.enabled);
      hoverEffects.enabled && element.attr(element.getData().setRolloverAttr);
      return {
        pointIndex: res.index,
        hovered: true,
        pointObj: res.data
      };
    }

    res1 = this.config.dataTreeB && this.config.dataTreeB.getNeighbour({
      x: x,
      y: y
    }, true);

    if (res1) {
      if (res1.barType === 'h') {
        errorBarToolText = res1.toolText;
      } else if (res1.barType === 'v') {
        errorBarToolText = res1.toolText;
      }

      res1.data.config.finalTooltext = errorBarToolText;
      element = res1.data.graphics.element;
      element.data('hoverEnabled', false);
      element.attr(element.getData().setRolloutAttr);
      return {
        pointIndex: res1.index,
        hovered: true,
        pointObj: res1.data
      };
    }
  } // Function to remove a data from a dataset during real time update.
  ;

  _proto.removePlots = function removePlots() {
    var dataSet = this,
        components = dataSet.components,
        removeDataArr = components.removeDataArr,
        pool = components.pool || (components.pool = {
      element: [],
      hotElement: [],
      label: []
    }),
        len = removeDataArr.length,
        // eslint-disable-line good-practices/no-single-usage-variable
    removeData,
        graphics,
        i,
        key;

    for (i = 0; i < len; i++) {
      removeData = removeDataArr[0];
      removeDataArr.splice(0, 1); // In case of non existing data plot continue;

      if (!removeData || !removeData.graphics) {
        continue;
      }

      graphics = removeData.graphics;

      for (key in graphics) {
        if (graphics.hasOwnProperty(key)) {
          dataSet.getFromEnv('animationManager').setAnimation({
            el: graphics[key],
            component: dataSet,
            attr: {},
            state: 'disappering',
            callback: dataSet.removeCallbackFn
          });
        }
      } // Storing the graphic elements for reuse.


      removeData.graphics.element && (pool.element = pool.element.concat(removeData.graphics.element));
      removeData.graphics.label && (pool.label = pool.label.concat(removeData.graphics.label));
    }

    components.pool = pool;
  };

  return ErrorScatter;
}(_scatter.default);

var _default = ErrorScatter;
exports["default"] = _default;

/***/ }),

/***/ 1333:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _index = _interopRequireDefault(__webpack_require__(619));

var _default = {
  'initial.dataset.errorScatter': _index.default['initial.dataset.line']
};
exports["default"] = _default;

/***/ }),

/***/ 1426:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _columnMultiseries = _interopRequireDefault(__webpack_require__(689));

/* eslint require-jsdoc: 'error', valid-jsdoc: ["error", { "requireReturn": false }] */
var key = 'manager-defaultVcanvasGroup-lines',
    vcanvasGroup = 'defaultVcanvasGroup';
/**
 * class for marimekko group manager
 */

var BoxAndWhiskerMultiSeriesGroup = /*#__PURE__*/function (_ColumnMultiseriesGro) {
  (0, _inheritsLoose2.default)(BoxAndWhiskerMultiSeriesGroup, _ColumnMultiseriesGro);

  function BoxAndWhiskerMultiSeriesGroup() {
    return _ColumnMultiseriesGro.apply(this, arguments) || this;
  }

  var _proto = BoxAndWhiskerMultiSeriesGroup.prototype;

  /**
  * Create child containers
  */
  _proto.createContainer = function createContainer() {
    _ColumnMultiseriesGro.prototype.createContainer.call(this);

    var manager = this,
        pContainer = manager.getLinkedParent().getChildContainer(vcanvasGroup); // eslint-disable-line good-practices/no-single-usage-variable

    !manager.getChildContainer(key) && manager.addChildContainer(key, // create group
    manager.getFromEnv('animationManager').setAnimation({
      el: 'group',
      component: manager,
      attr: {
        name: key
      },
      container: pContainer
    }));
  };

  return BoxAndWhiskerMultiSeriesGroup;
}(_columnMultiseries.default);

var _default = BoxAndWhiskerMultiSeriesGroup;
exports["default"] = _default;

/***/ }),

/***/ 1348:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _columnMultiseries = _interopRequireDefault(__webpack_require__(689));

var _lib = __webpack_require__(274);

/* eslint require-jsdoc: 'error', valid-jsdoc: ["error", { "requireReturn": false }] */

/**
 * Group for drag column, area and line charts.
 */
var DragColumnMultiseriesGroup = /*#__PURE__*/function (_ColumnMultiSeriesgro) {
  (0, _inheritsLoose2.default)(DragColumnMultiseriesGroup, _ColumnMultiSeriesgro);

  function DragColumnMultiseriesGroup() {
    return _ColumnMultiSeriesgro.apply(this, arguments) || this;
  }

  var _proto = DragColumnMultiseriesGroup.prototype;

  /**
  * Function to get the jsonData from the datasets
  * @return {Object} data from the dataset
  */
  _proto.getJSONData = function getJSONData() {
    var manager = this,
        datasets = manager.getChildren('dataset'),
        jsonData = [],
        dataset,
        datasetObj,
        rawDataset,
        i,
        len = datasets.length; // eslint-disable-line good-practices/no-single-usage-variable

    for (i = 0; i < len; i++) {
      dataset = datasets[i];
      rawDataset = (0, _lib.extend2)({}, manager.getFromEnv('dataSource').dataset[i]); // Here the actual data is deleted and modified data is fetched from each datasets

      delete rawDataset.data;
      datasetObj = dataset.getJSONData();
      jsonData.push((0, _lib.extend2)(rawDataset, datasetObj));
    }

    return jsonData;
  };

  return DragColumnMultiseriesGroup;
}(_columnMultiseries.default);

var _default = DragColumnMultiseriesGroup;
exports["default"] = _default;

/***/ }),

/***/ 1403:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _assertThisInitialized2 = _interopRequireDefault(__webpack_require__(292));

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _componentInterface = __webpack_require__(290);

var _dragablelabels = _interopRequireDefault(__webpack_require__(1399));

var _lib = __webpack_require__(274);

var _trustedPolicy = _interopRequireDefault(__webpack_require__(299));

/* eslint require-jsdoc: 'error', valid-jsdoc: ["error", { "requireReturn": false }] */
// eslint-disable-next-line
var CLEAR_TIME_1000 = 1000,
    shapesInfo = {
  circle: 'circ',
  rectangle: 'rect',
  polygon: 'poly'
},
    UNDEF,
    INPUT = _lib.preDefStr.INPUT,
    BLANKSPACE = _lib.preDefStr.BLANKSPACE,
    BLANK = _lib.preDefStr.BLANK,
    COLOR_FFFFFF = 'ffffff',
    PX = _lib.preDefStr.PX,
    COLOR_000000 = '000000',
    OPTIONSTR = '<option>',
    OPTIONCLOSESTR = '</option>',
    LABEL = _lib.preDefStr.LABEL,
    DATASET = _lib.preDefStr.DATASET,
    COMMA = _lib.preDefStr.COMMA,
    DATASETSTATE = 'appearing',
    ONE_PX_BORDER = '1px solid #cccccc',
    DISABLED = 'disabled',
    LABEL_ADDED = 'labeladded',
    OPTION_VALUE = '<option value="',
    CLOSE_TAG = '">',
    OPTION_STR = '</option>',
    NODE_ADDED = 'nodeAdded',
    NODE_UPDATED = 'nodeupdated',
    NODE_DELETED = 'nodedeleted',
    CONNECTOR_ADDED = 'connectoradded',
    CONNECTOR_UPDATED = 'connectorupdated',
    CONNECTOR_DELETED = 'connectordeleted',
    TRANSPARENT = 'transparent',
    DIV_STR = 'div',
    COLOR_EFEFEF = 'efefef',
    SUBMIT_STR = 'Submit',
    DELETE_STR = 'Delete',
    CANCEL_STR = 'Cancel',
    UPDATE_STR = 'update',
    APPEARING_STR = 'appearing',
    LABEL_DELETED = 'labeldeleted',
    removeElems = function removeElems(graphics) {
  for (var i in graphics) {
    graphics[i].remove();
  }
},
    defined = function defined(obj) {
  return obj !== UNDEF && obj !== null;
},
    // configures eventArgs with values of dataObj based on shapeType of node
makeShapeSpecificModifications = function makeShapeSpecificModifications(eventArgs, dataObj) {
  switch (eventArgs.shape) {
    case _lib.preDefStr.CIRCLE:
      eventArgs.radius = dataObj.radius;
      break;

    case _lib.preDefStr.POLYGON:
      eventArgs.radius = dataObj.radius;
      eventArgs.sides = dataObj.numsides;
      break;

    default:
      eventArgs.width = dataObj.width;
      eventArgs.height = dataObj.height;
      break;
  }
},
    _showNodeUpdateUI = function () {
  // eslint-disable-next-line good-practices/no-function-dependency
  var manageShapeFields = function manageShapeFields() {
    var ui = this.getGraphicalElement('cacheUpdateUI'),
        ele = ui.fields.shape,
        // eslint-disable-line good-practices/no-single-usage-variable
    shapeFields = ['rectWidth', 'rectHeight', 'circPolyRadius', 'polySides'],
        i = shapeFields.length,
        key;

    while (i--) {
      key = shapeFields[i];

      if (/rect|poly|circ/ig.test(key)) {
        ui.labels[key].hide();
        ui.fields[key].hide();
      }

      if (new RegExp((0, _lib.pluck)(ele.val(), 'rect'), 'ig').test(key)) {
        ui.labels[key].show();
        ui.fields[key].show();
      }
    }
  },
      // eslint-disable-next-line good-practices/no-function-dependency
  showGivenColor = function showGivenColor() {
    var fields = this.getGraphicalElement('cacheUpdateUI').fields,
        color = (0, _lib.getValidColor)(fields.color.val());
    color && fields.colorOut.css({
      background: (0, _lib.parseColor)(color)
    });
  },
      // eslint-disable-next-line good-practices/no-function-dependency
  manageImageFields = function manageImageFields(animate) {
    var manager = this,
        ui = manager.getGraphicalElement('cacheUpdateUI'),
        animationManager = manager.getFromEnv('animationManager'),
        chartHeight = manager.getFromEnv('chartConfig').height,
        // eslint-disable-line good-practices/no-single-usage-variable
    padding = 5,
        isChecked = ui.fields.image.val(),
        imgKey = ['imgWidth', 'imgHeight', 'imgAlign', 'imgUrl'],
        dialogHeight,
        i,
        key;
    dialogHeight = isChecked ? 250 : 215;

    if (animate) {
      ui.ok.hide();
      ui.cancel.hide();
      ui.removeItem.hide();
      ui.error.hide();
    }

    i = imgKey.length; // eslint-disable-next-line no-unmodified-loop-condition

    while (!isChecked && i--) {
      key = imgKey[i];
      ui.labels[key].hide();
      ui.fields[key].hide();
    }

    animate && animationManager.setAnimationState('uichange');
    animationManager.setAnimation({
      el: ui.dialog,
      state: 'updating',
      attr: {
        top: (chartHeight - dialogHeight) / 2,
        height: dialogHeight
      },
      component: manager,
      label: 'uidialog',
      callback: function callback() {
        i = imgKey.length; // eslint-disable-next-line no-unmodified-loop-condition

        while (i-- && isChecked) {
          key = imgKey[i];
          ui.labels[key].show();
          ui.fields[key].show();
        }

        ui.ok.attr({
          y: dialogHeight - 23 - padding
        }).show();
        ui.cancel.attr({
          y: dialogHeight - 23 - padding
        }).show();
        ui.removeItem.attr({
          y: dialogHeight - 23 - padding
        });
        ui.error.attr({
          y: dialogHeight - 23 - padding + 4
        }).show();

        if (ui.edit) {
          ui.removeItem.show();
        } else {
          ui.removeItem.hide();
        }
      }
    });
  };

  return function (config, edit) {
    var manager = this,
        // graphics = manager.graphics,
    ui = manager.getGraphicalElement('cacheUpdateUI'),
        // nodes = manager.nodes,
    // conf = chart.config,
    paper = manager.getFromEnv('paper'),
        borderStyle = ONE_PX_BORDER,
        inputStyle = {
      width: 80 + PX,
      border: borderStyle,
      fontSize: 10 + PX,
      lineHeight: 15 + PX,
      padding: 2 + PX,
      fontFamily: (manager.getFromEnv('style').inCanvasStyle || {}).fontFamily
    },
        noUIfound,
        labelStyle = {
      // eslint-disable-line good-practices/no-single-usage-variable
      textAlign: 'right'
    },
        fields = ui && ui.fields,
        labels = ui && ui.labels,
        dialog,
        // node,
    // index,
    onSubmit = function onSubmit(event) {
      event.stopPropagation();
      var uiFields = ui && ui.fields,
          // eslint-disable-line good-practices/no-single-usage-variable
      uiEdit = ui.edit,
          idFound,
          id,
          submitObj;

      if (fields) {
        submitObj = {
          x: (0, _lib.getFirstValue)(fields.x.val(), manager.getFromEnv('xAxis').getLimit().min),
          y: (0, _lib.getFirstValue)(fields.y.val(), manager.getFromEnv('yAxis').getLimit().min),
          id: id = fields.id.val(),
          datasetId: fields.dataset.val(),
          name: fields.label.val(),
          tooltext: fields.tooltip.val(),
          color: fields.color.val(),
          alpha: fields.alpha.val(),
          labelalign: fields.labelalign.val(),
          allowdrag: fields.draggable.val(),
          imagenode: fields.image.val(),
          imagewidth: fields.imgWidth.val(),
          imageheight: fields.imgHeight.val(),
          imagealign: fields.imgAlign.val(),
          imageurl: fields.imgUrl.val(),
          link: fields.link.val()
        }; // Shape specific configurations.

        switch (uiFields.shape.val()) {
          case 'circ':
            submitObj.shape = _lib.preDefStr.CIRCLE;
            submitObj.radius = fields.circPolyRadius.val();
            break;

          case 'poly':
            submitObj.shape = _lib.preDefStr.POLYGON;
            submitObj.radius = fields.circPolyRadius.val();
            submitObj.numsides = fields.polySides.val();
            break;

          default:
            submitObj.shape = _lib.preDefStr.RECTANGLE;
            submitObj.width = fields.rectWidth.val();
            submitObj.height = fields.rectHeight.val();
            break;
        } // Check if node already exists


        if (manager.getNode(submitObj.id)) {
          idFound = true;
        } // If node already exists then we do not add a node and show an error


        if (!idFound || uiEdit !== UNDEF) {
          // node = nodes[submitObj.id] || {};
          id = submitObj.datasetId; // Dont add nodes when dataset id is not given

          if (id !== _lib.BLANKSTRING || uiEdit) {
            id = Number(id); // index = node.config && node.config.index;

            uiEdit ? manager.updateNode(submitObj) : manager.addNode(submitObj);
            ui.hide();
            ui.visible = false;
          }

          return;
        }

        ui.error.attr({
          text: 'ID already exist.'
        });
        fields.label.focus();
      } // Remobe disabled from attr


      ui.enableFields();
    },
        onCancel = function onCancel(event) {
      event.stopPropagation(); // Hide the UI

      ui.hide();
      ui.visible = false; // Remobe disabled from attr

      ui.enableFields(); // Hide error msg

      ui.error.attr({
        text: BLANK
      });
      ui.visible = false;
    },
        onDelete = function onDelete(event) {
      event.stopPropagation();
      manager.deleteNode(ui.fields.id.val());
      ui.hide();
      ui.visible = false;
    };

    manager.getFromEnv('animationManager').setAnimationState('uichange');

    if (!ui) {
      noUIfound = true;
    }

    ui = manager.addGraphicalElement('cacheUpdateUI', manager.createHtmlDialog(350, 215, onSubmit, onCancel, onDelete, ui));

    if (noUIfound) {
      // add fields.
      dialog = ui.dialog;
      labels = ui.labels = {};
      fields = ui.fields = {};
    }

    ui.config = config;
    ui.edit = edit;

    if (!ui.error) {
      ui.error = paper.html('span', {
        color: 'ff0000',
        x: 30,
        y: 228
      }, UNDEF, dialog);
    }

    if (!ui.enableFields) {
      ui.enableFields = function () {
        var key;

        for (key in config) {
          if (config[key] && config[key].disabled && fields[key]) {
            fields[key].element.removeAttribute('disabled');
          }
        }
      };
    }

    if (!ui.clearFields) {
      ui.clearFields = function () {
        var key;

        for (key in ui.fields) {
          if (!fields[key].element.disabled) {
            fields[key].element.value = _lib.BLANKSTRING;
          }
        }
      };
    }

    (0, _lib.fcEach)(this.nodeUpdateUIDefinition, function (def) {
      var field,
          key = def.key,
          attrs = {},
          confObj = config[key] || {},
          innerHTML,
          value;
      !labels[key] && (labels[key] = paper.html(LABEL, {
        x: def.x,
        y: def.y,
        width: def.labelWidth || 45,
        text: def.text
      }, labelStyle, dialog)); // No need to proceed of this label has no input box
      // associated with itself.

      if (def.noInput) {
        return;
      }

      field = fields[key];

      if (!field) {
        inputStyle.border = def.type === 'checkbox' ? BLANK : borderStyle;
        field = fields[key] = paper.html(def.inputType || 'input', {
          x: def.labelWidth && def.labelWidth + 5 || 50,
          y: -2 + (def.inputPaddingTop || 0),
          width: def.inputWidth || 50,
          name: key || _lib.BLANKSTRING
        }, inputStyle);

        if (def.inputType !== 'select') {
          field.attr({
            type: def.type || 'text'
          }).on('keyup', ui.handleKeyPress);
        }

        field.add(labels[key]);
      }

      if (defined(innerHTML = (0, _lib.getFirstValue)(confObj.innerHTML, def.innerHTML))) {
        // eslint-disable-line good-practices/no-single-usage-variable
        attrs.innerHTML = _trustedPolicy.default.createHTML(innerHTML);
      }

      if (confObj.disabled) {
        attrs.disabled = DISABLED;
      } else {
        field.element && (field.element.disabled = false);
      }

      field.attr(attrs);

      if (defined(value = (0, _lib.getFirstValue)(confObj.value, def.value))) {
        // eslint-disable-line good-practices/no-single-usage-variable
        field.val(value);
      } // eslint-disable-next-line good-practices/no-function-dependency


      key === 'shape' && field.on('change', function () {
        manageShapeFields.call(manager);
      }); // eslint-disable-next-line good-practices/no-function-dependency

      key === 'image' && field.on('fc-click', function () {
        manageImageFields.call(manager, true);
      }); // eslint-disable-next-line good-practices/no-function-dependency

      key === 'color' && field.on('keyup', function () {
        showGivenColor.call(manager);
      });
    });
    showGivenColor.call(this);
    manageImageFields.call(this);
    manageShapeFields.call(this);
    ui.visible = true;
    ui.fields[edit ? LABEL : 'id'].focus();
  };
}();
/**
 * Class for dragnodes's group
 */


var DragNodeGroup = /*#__PURE__*/function (_ComponentInterface) {
  (0, _inheritsLoose2.default)(DragNodeGroup, _ComponentInterface);

  /**
   * constructor function this class
   */
  function DragNodeGroup() {
    var _this;

    _this = _ComponentInterface.call(this) || this;
    var manager = (0, _assertThisInitialized2.default)(_this);
    manager.setState('visible', true);
    manager.connectorUpdateUIDefinition = [{
      key: 'fromid',
      text: 'Connect From',
      inputType: 'select',
      x: 10,
      y: 15,
      labelWidth: 80,
      inputWidth: 100
    }, {
      key: 'toid',
      text: 'Connect To',
      inputType: 'select',
      x: 10,
      y: 40,
      labelWidth: 80,
      inputWidth: 100
    }, {
      key: 'arratstart',
      text: 'Arrow At Start',
      x: 200,
      y: 15,
      type: 'checkbox',
      inputPaddingTop: 3,
      labelWidth: 80,
      inputWidth: 15
    }, {
      key: 'arratend',
      text: 'Arrow At End',
      x: 200,
      y: 40,
      type: 'checkbox',
      inputPaddingTop: 3,
      labelWidth: 80,
      inputWidth: 15
    }, {
      key: LABEL,
      text: 'Label',
      x: 10,
      y: 75,
      labelWidth: 40,
      inputWidth: 120
    }, {
      key: 'id',
      text: 'Node ID',
      x: 190,
      y: 75,
      inputWidth: 55
    }, {
      key: 'color',
      text: 'Color',
      x: 10,
      y: 100,
      labelWidth: 40,
      inputWidth: 35
    }, {
      key: 'alpha',
      text: 'Alpha',
      x: 110,
      y: 100,
      inputWidth: 25,
      labelWidth: 35
    }, {
      key: 'strength',
      text: 'Strength',
      x: 190,
      y: 100,
      inputWidth: 55,
      val: '0.1'
    }, {
      key: 'url',
      text: 'Link',
      x: 10,
      y: 125,
      labelWidth: 40,
      inputWidth: 120
    }, {
      key: 'tooltext',
      text: 'Tooltip',
      x: 190,
      y: 125,
      labelWidth: 40,
      inputWidth: 60
    }, {
      key: 'dashed',
      text: 'Dashed',
      x: 10,
      y: 150,
      type: 'checkbox',
      inputPaddingTop: 3,
      inputWidth: 15,
      labelWidth: 40
    }, {
      key: 'dashgap',
      text: 'Dash Gap',
      x: 85,
      y: 150,
      labelWidth: 60,
      inputWidth: 25
    }, {
      key: 'dashlen',
      text: 'Dash Length',
      x: 190,
      y: 150,
      labelWidth: 70,
      inputWidth: 30
    }];
    manager.nodeUpdateUIDefinition = [{
      key: 'id',
      text: 'Id',
      inputWidth: 60,
      x: 10,
      y: 15
    }, {
      key: DATASET,
      text: DATASET,
      inputType: 'select',
      inputWidth: 110,
      innerHTML: _trustedPolicy.default.createHTML(UNDEF),
      x: 170,
      y: 15
    }, {
      key: 'x',
      text: 'Value',
      x: 10,
      y: 40,
      inputWidth: 21
    }, {
      key: 'y',
      text: COMMA,
      x: 88,
      y: 40,
      inputWidth: 21,
      labelWidth: 5
    }, {
      text: '(x, y)',
      x: 125,
      y: 40,
      labelWidth: 33,
      noInput: true
    }, {
      key: 'tooltip',
      text: 'Tooltip',
      inputWidth: 105,
      x: 170,
      y: 40
    }, {
      key: LABEL,
      text: 'Label',
      inputWidth: 92,
      x: 10,
      y: 65
    }, {
      key: 'labelalign',
      text: 'Align',
      labelWidth: 70,
      inputWidth: 110,
      inputType: 'select',
      innerHTML: _trustedPolicy.default.createHTML('<option></option><option value="top">Top</option><option value="middle">Middle</option>' + '<option value="bottom">Bottom</option>'),
      x: 145,
      y: 63
    }, {
      key: 'color',
      text: 'Color',
      x: 10,
      y: 90,
      inputWidth: 60
    }, {
      key: 'colorOut',
      innerHTML: _trustedPolicy.default.createHTML('&nbsp;'),
      x: 85,
      y: 90,
      inputWidth: 15,
      inputType: 'span'
    }, {
      key: 'alpha',
      text: 'Alpha',
      x: 170,
      y: 90,
      inputWidth: 20
    }, {
      key: 'draggable',
      text: 'Allow Drag',
      value: true,
      inputWidth: 20,
      x: 250,
      y: 90,
      labelWidth: 58,
      inputPaddingTop: 3,
      type: 'checkbox'
    }, {
      key: 'shape',
      text: 'Shape',
      inputType: 'select',
      inputWidth: 97,
      innerHTML: _trustedPolicy.default.createHTML('<option value="rect">Rectangle</option><option value="circ">Circle</option><option ' + 'value="poly">Polygon</option>'),
      x: 10,
      y: 115
    }, {
      key: 'rectHeight',
      text: 'Height',
      x: 170,
      y: 115,
      inputWidth: 20
    }, {
      key: 'rectWidth',
      text: 'Width',
      x: 255,
      y: 115,
      inputWidth: 20
    }, {
      key: 'circPolyRadius',
      text: 'Radius',
      x: 170,
      y: 115,
      inputWidth: 20
    }, {
      key: 'polySides',
      text: 'Sides',
      x: 255,
      y: 115,
      inputWidth: 20
    }, {
      key: 'link',
      text: 'Link',
      x: 10,
      y: 140,
      inputWidth: 92
    }, {
      key: 'image',
      text: 'Image',
      type: 'checkbox',
      inputPaddingTop: 4,
      inputWidth: 20,
      x: 10,
      y: 170
    }, {
      key: 'imgUrl',
      text: 'URL',
      inputWidth: 105,
      x: 170,
      y: 170
    }, {
      key: 'imgWidth',
      text: 'Width',
      inputWidth: 20,
      x: 10,
      y: 195
    }, {
      key: 'imgHeight',
      text: 'Height',
      inputWidth: 20,
      x: 82,
      y: 195
    }, {
      key: 'imgAlign',
      text: 'Align',
      inputType: 'select',
      inputWidth: 75,
      innerHTML: _trustedPolicy.default.createHTML('<option value="top">Top</option><option value="middle">Middle</option><option ' + 'value="bottom">Bottom</option>'),
      x: 170,
      y: 195
    }];
    manager.labelUpdateUIDefinition = [{
      key: LABEL,
      text: 'Label*',
      x: 10,
      y: 15,
      inputWidth: 235
    }, {
      key: 'size',
      text: 'Size',
      x: 10,
      y: 40
    }, {
      key: 'padding',
      text: 'Padding',
      x: 10,
      y: 65
    }, {
      key: 'x',
      text: 'Position',
      x: 120,
      y: 65,
      labelWidth: 70,
      inputWidth: 25
    }, {
      key: 'y',
      text: COMMA,
      x: 225,
      y: 65,
      labelWidth: 10,
      inputWidth: 25
    }, {
      key: 'xy',
      text: '(x, y)',
      x: 260,
      y: 65,
      noInput: true
    }, {
      key: 'allowdrag',
      text: 'Allow Drag',
      x: 120,
      y: 40,
      inputType: 'checkbox',
      inputPaddingTop: 3,
      inputWidth: 15,
      labelWidth: 70,
      val: 1
    }, {
      key: 'color',
      text: 'Color',
      x: 10,
      y: 90
    }, {
      key: 'alpha',
      text: 'Alpha',
      x: 145,
      y: 90,
      inputWidth: 30,
      val: _lib.preDefStr.HUNDREDSTRING
    }, {
      key: 'bordercolor',
      text: 'Border Color',
      x: 10,
      y: 125,
      labelWidth: 100
    }, {
      key: 'bgcolor',
      text: 'Background Color',
      x: 10,
      y: 150,
      labelWidth: 100
    }];
    return _this;
  }
  /**
   * Function used to differentiate between update and resize
   */


  var _proto = DragNodeGroup.prototype;

  _proto.configure = function configure() {
    this.setState('configured', true);
  }
  /**
   * Sets the type of the component
   * @return {string} type
   */
  ;

  _proto.getType = function getType() {
    return 'group';
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */
  ;

  _proto.getName = function getName() {
    return 'dragNodeGroup';
  }
  /**
   * Funtion to create the UI box for adding new labels
   * @param {Object} options Any predefined options to be added to the UI box
   */
  ;

  _proto.showLabelUpdateUI = function showLabelUpdateUI(options) {
    if (options === void 0) {
      options = {};
    }

    var manager = this,
        paper = manager.getFromEnv('paper'),
        // conf = manager.getFromEnv('chartConfig'),
    ui = manager.getGraphicalElement('cacheLabelUpdateUI'),
        inputStyle = {
      // eslint-disable-line good-practices/no-single-usage-variable
      border: '1px solid #cccccc',
      fontSize: 10 + PX,
      lineHeight: 15 + PX,
      fontFamily: (manager.getFromEnv('style').inCanvasStyle || {}).fontFamily,
      padding: 2 + PX
    },
        labelStyle = {
      // eslint-disable-line good-practices/no-single-usage-variable
      textAlign: 'right'
    },
        noUIfound,
        fields = ui && ui.fields,
        labels = ui && ui.labels,
        field,
        value,
        dialog;
    manager.getFromEnv('animationManager').setAnimationState('uichange');

    if (!ui) {
      noUIfound = true;
    }

    ui = manager.addGraphicalElement('cacheLabelUpdateUI', manager.createHtmlDialog(315, 205, function () {
      var uiFields = ui && ui.fields,
          submitObj;

      if (uiFields) {
        // Prepare obbject for submission.
        submitObj = {
          text: uiFields.label.val(),
          x: uiFields.x.val(),
          y: uiFields.y.val(),
          color: uiFields.color.val(),
          alpha: uiFields.alpha.val(),
          bgcolor: uiFields.bgcolor.val(),
          bordercolor: uiFields.bordercolor.val(),
          fontsize: uiFields.size.val(),
          allowdrag: uiFields.allowdrag.val(),
          padding: uiFields.padding.val()
        };

        if (submitObj.text) {
          manager.addLabel && manager.addLabel(submitObj);
          ui.hide();
        } else {
          ui.error.attr({
            text: 'Label cannot be blank.'
          });
          fields.label.focus();
        }
      }
    }, function () {
      ui.error.attr({
        text: _lib.BLANKSTRING
      });
      ui.hide();
    }, UNDEF, ui));

    if (noUIfound) {
      dialog = ui.dialog;
      labels = ui.labels = {};
      fields = ui.fields = {};
    }

    (0, _lib.fcEach)(manager.labelUpdateUIDefinition, function (def) {
      var key = def.key;

      if (!labels[key]) {
        labels[key] = paper.html(LABEL, {
          x: def.x,
          y: def.y,
          width: def.labelWidth || 45,
          text: def.text
        }, labelStyle, dialog);
      } // No need to proceed of this label has no input box
      // associated with itself.


      if (def.noInput) {
        return;
      }

      if (!(field = fields[key])) {
        // eslint-disable-line good-practices/no-single-usage-variable
        field = fields[key] = paper.html(INPUT, {
          y: -2 + (def.inputPaddingTop || 0),
          x: def.labelWidth && def.labelWidth + 5 || 50,
          width: def.inputWidth || 50,
          type: def.inputType || 'text',
          name: key || _lib.BLANKSTRING
        }, inputStyle, labels[key]).on('keyup', ui.handleKeyPress);
      }

      if (defined(value = (0, _lib.getFirstValue)(options[key], def.val))) {
        // eslint-disable-line good-practices/no-single-usage-variable
        field.val(value);
      }
    });

    if (!ui.error) {
      ui.error = paper.html('span', {
        color: 'ff0000',
        x: 10,
        y: 180
      }, UNDEF, dialog);
    } // Focus on label textbox


    ui.fields.label.focus();
  }
  /**
   * Function to restore all the data of dragnode to its initial visual
   */
  ;

  _proto.restoreData = function restoreData() {
    var manager = this,
        // manager = chart.components['datasetGroup_' + chart.defaultDatasetType],
    datasets = manager.getChildren('dataset'),
        chart = manager.getFromEnv('chart'),
        showlegend = (0, _lib.pluckNumber)(chart.config.showlegend, 0),
        // eslint-disable-line good-practices/no-single-usage-variable
    connectors = manager.getChildren('connector'),
        jsonData = chart.getFromEnv('dataSource'),
        i,
        dataset,
        dataStore,
        dataObj,
        graphics,
        labelObj,
        len,
        labelSet = manager.getChildren('labels'),
        removeElements = function removeElements(datastore) {
      var j, ele;

      for (j = 0; j < (datastore && datastore.length); j++) {
        dataObj = datastore[j];
        delete dataObj.removed;

        if (dataObj.config.add) {
          graphics = datastore[j].graphics;

          for (ele in graphics) {
            graphics[ele].remove();
          }

          datastore.splice(j, 1);
          j--;
        }
      }
    },
        restoreDatasets = function restoreDatasets(k, dataSets, json) {
      dataset = dataSets[k];
      dataStore = dataset.components.data; // eslint-disable-line good-practices/no-single-usage-variable

      removeElements(dataStore);
      dataset.drawn = false;
      dataset.configure(json[k]);
    };

    for (i = 0, len = datasets && datasets.length; i < len; i++) {
      restoreDatasets(i, datasets, jsonData.dataset);
    }

    for (i = 0, len = connectors && connectors.length; i < len; i++) {
      restoreDatasets(i, connectors, jsonData.connectors);
    }

    if (labelSet && labelSet.length) {
      labelObj = labelSet[0];
      dataStore = labelObj.components.data;
      dataStore && removeElements(dataStore);
      labelObj.configure(jsonData.labels);
    }

    chart.fireChartInstanceEvent('dataRestored');
    manager.asyncDraw();
    showlegend && manager.getFromEnv('legend').asyncDraw();
  }
  /**
   * Function to add a draggable-label via UI
   * @param {Object} labelObj Conatins the information about the label that is to be added
   */
  ;

  _proto.addLabel = function addLabel(labelObj) {
    var manager = this,
        labelDS = manager.getChildren('labels'),
        sourceEvent = LABEL_ADDED,
        dataStore,
        eventArgs,
        chart = manager.getFromEnv('chart'),
        len;
    labelObj.add = true; // Creating an instance of the label class if not already present

    if (labelDS && labelDS[0]) {
      labelDS = labelDS[0];
    } else {
      (0, _lib.componentFactory)(manager, _dragablelabels.default, 'labels', 1, [{}]);
      labelDS = manager.getChildren('labels')[0];
    }

    dataStore = labelDS.components.data || (labelDS.components.data = []);
    len = dataStore.length;

    labelDS._setConfigure(len, labelObj); // }


    eventArgs = {
      text: labelObj.text,
      x: labelObj.x,
      y: labelObj.y,
      allowdrag: labelObj.allowdrag,
      sourceType: 'labelnode',
      link: labelObj.link
    };
    chart.fireChartInstanceEvent('chartupdated', (0, _lib.extend2)({
      sourceEvent: sourceEvent
    }, eventArgs));
    chart.fireChartInstanceEvent(sourceEvent, eventArgs);
    labelDS.asyncDraw();
  }
  /**
   * Funtion to create the options for the dialog box used for adding new nodes
   */
  ;

  _proto.showNodeAddUI = function showNodeAddUI() {
    var manager = this,
        // chart = manager.chart,
    datasets = manager.getChildren('dataset'),
        datasetDropDownStr = _lib.BLANKSTRING,
        // eslint-disable-line good-practices/no-single-usage-variable
    conf,
        dataset,
        type,
        i;

    for (i = 0; i < datasets.length; i++) {
      dataset = datasets[i] || {};
      conf = dataset.config;
      type = dataset.getName();

      if (type === 'dragNode') {
        datasetDropDownStr += OPTION_VALUE + dataset.config.datasetIndex + CLOSE_TAG + (conf.name !== BLANK && conf.name !== UNDEF && conf.name + _lib.COMMASTRING + BLANKSPACE || BLANK) + dataset.config.datasetIndex + OPTION_STR;
      }
    }

    manager.showNodeUpdateUI({
      dataset: {
        innerHTML: _trustedPolicy.default.createHTML(datasetDropDownStr)
      }
    });
  }
  /**
   * Funtion to create the options for the dialog box used for adding new connectors
   */
  ;

  _proto.showConnectorAddUI = function showConnectorAddUI() {
    var manager = this,
        // chart = manager.chart,
    nodes = manager.getNode(),
        nodeStr = _lib.BLANKSTRING,
        id,
        i,
        config,
        node;

    for (i in nodes) {
      node = nodes[i];
      config = node.config;
      id = config.id;
      nodeStr += OPTION_VALUE + id + CLOSE_TAG + id + OPTION_STR;
    }

    manager.showConnectorUpdateUI({
      fromid: {
        innerHTML: _trustedPolicy.default.createHTML(nodeStr)
      },
      toid: {
        innerHTML: _trustedPolicy.default.createHTML(nodeStr)
      }
    });
  }
  /**
   * Function to create the UI box for adding/updating the connectors
   * @param {Object} config Has the information about the concerned connector
   * @param {boolean} edit Flag for determining if a new connector has to be added or existing connector has to be
   * updated
   */
  ;

  _proto.showConnectorUpdateUI = function showConnectorUpdateUI(config, edit) {
    var manager = this,
        renderer = manager.getFromEnv('paper'),
        uiName = "cacheConnectorUpdateUI" + (edit ? 'edit' : 'new'),
        ui = manager.getGraphicalElement(uiName),
        inputStyle = {
      // eslint-disable-line good-practices/no-single-usage-variable
      border: '1px solid #cccccc',
      fontSize: 10 + PX,
      lineHeight: 15 + PX,
      fontFamily: (manager.getFromEnv('style').inCanvasStyle || {}).fontFamily,
      padding: 2 + PX
    },
        noUIfound,
        labelStyle = {
      // eslint-disable-line good-practices/no-single-usage-variable
      textAlign: 'right'
    },
        fields = ui && ui.fields,
        labels = ui && ui.labels,
        innerHTML,
        field,
        value,
        onDelete = function onDelete() {
      var uiFields = ui && ui.fields;
      manager.deleteConnector({
        from: uiFields.fromid.val(),
        to: uiFields.toid.val(),
        id: uiFields.id.val()
      });
      ui.hide();
    },
        dialog;

    manager.getFromEnv('animationManager').setAnimationState('uichange');

    if (!ui) {
      noUIfound = true;
    }

    ui = manager.addGraphicalElement(uiName, manager.createHtmlDialog(315, 215, function () {
      var uiFields = ui && ui.fields,
          submitObj;

      if (uiFields) {
        submitObj = {
          from: uiFields.fromid.val(),
          to: uiFields.toid.val(),
          id: uiFields.id.val(),
          label: uiFields.label.val(),
          color: uiFields.color.val(),
          alpha: uiFields.alpha.val(),
          link: uiFields.url.val(),
          tooltext: uiFields.tooltext.val(),
          strength: uiFields.strength.val(),
          arrowatstart: uiFields.arratstart.val(),
          arrowatend: uiFields.arratend.val(),
          dashed: uiFields.dashed.val(),
          dashlen: uiFields.dashlen.val(),
          dashgap: uiFields.dashgap.val()
        }; // Validate

        if (submitObj.from) {
          if (submitObj.to) {
            if (submitObj.from !== submitObj.to) {
              edit ? manager.editConnector(submitObj) : manager.addConnector(submitObj);
              ui.enableFields();
              ui.hide();
              ui.clearFields();
            } else {
              ui.error.attr({
                text: 'Connector cannot start and end at the same node!'
              });
              fields.fromid.focus();
            }
          } else {
            ui.error.attr({
              text: 'Please select a valid connector end.'
            });
            fields.toid.focus();
          }
        } else {
          ui.error.attr({
            text: 'Please select a valid connector start.'
          });
          fields.fromid.focus();
        }
      }
    }, // Cancel function
    function () {
      ui.error.attr({
        text: _lib.BLANKSTRING
      });
      ui.enableFields();
      ui.hide();
    }, // Delete function
    onDelete, ui));

    if (noUIfound) {
      dialog = ui.dialog;
      labels = ui.labels = {};
      fields = ui.fields = {};
    }

    ui.config = config;

    if (!ui.enableFields) {
      ui.enableFields = function () {
        var key;

        for (key in config) {
          if (config[key] && config[key].disabled && fields[key]) {
            fields[key].element.removeAttribute('disabled');
          }
        }
      };
    }

    if (!ui.clearFields) {
      ui.clearFields = function () {
        var key,
            uiFields = ui.fields;

        for (key in uiFields) {
          if (!uiFields[key].element.disabled) {
            uiFields[key].element.value = _lib.BLANKSTRING;
          }
        }
      };
    }

    (0, _lib.fcEach)(manager.connectorUpdateUIDefinition, function (def) {
      var key = def.key,
          attr = config[key] || {};

      if (!labels[key]) {
        labels[key] = renderer.html(LABEL, {
          x: def.x,
          y: def.y,
          width: def.labelWidth || 45,
          text: def.text
        }, labelStyle, dialog);
      } // No need to proceed of this label has no input box
      // associated with itself.


      if (def.noInput) {
        return;
      }

      if (!(field = fields[key])) {
        field = fields[key] = renderer.html(def.inputType || INPUT, {
          y: -2 + (def.inputPaddingTop || 0),
          x: def.labelWidth && def.labelWidth + 5 || 50,
          width: def.inputWidth || 50,
          name: key || _lib.BLANKSTRING
        }, inputStyle);

        if (def.inputType !== 'select') {
          field.attr({
            type: def.type || 'text'
          }).on('keyup', ui.handleKeyPress);
        }

        field.add(labels[key]);
      }

      if (innerHTML = (0, _lib.pluck)(attr.innerHTML, def.innerHTML)) {
        // eslint-disable-line good-practices/no-single-usage-variable
        field.attr({
          innerHTML: _trustedPolicy.default.createHTML(innerHTML)
        });
      }

      if ((value = (0, _lib.pluck)(attr.val, def.val)) !== UNDEF) {
        // eslint-disable-line good-practices/no-single-usage-variable
        field.val(value);
      }

      if (attr.disabled) {
        field.attr({
          disabled: 'disabled'
        });
      } else {
        field.element && (field.element.disabled = false);
      }
    }); // dash checking and ui modification
    // call to set default fro the first time

    ui.checkDash = function () {
      var showHideFn = fields.dashed && fields.dashed.val() ? 'show' : 'hide';
      labels.dashgap && labels.dashgap[showHideFn]();
      fields.dashgap && fields.dashgap[showHideFn]();
      labels.dashlen && labels.dashlen[showHideFn]();
      fields.dashlen && fields.dashlen[showHideFn]();
    };

    ui.checkDash();
    fields.dashed.on('fc-click', ui.checkDash);

    if (!ui.error) {
      ui.error = renderer.html('span', {
        color: 'ff0000',
        x: 10,
        y: 170
      }, UNDEF, dialog);
    }

    ui.removeItem[edit ? 'show' : 'hide']();
  }
  /**
   * Function to create the UI box for adding/updating the nodes
   * @return {Function} The actual function for updating/adding the nodes
   */
  ;

  _proto.showNodeUpdateUI = function showNodeUpdateUI() {
    return _showNodeUpdateUI.apply(this, arguments);
  }
  /**
   * Function for adding new nodes
   * @param {Object} dataObj Contains information about the node that is to be added
   */
  ;

  _proto.addNode = function addNode(dataObj) {
    var manager = this,
        datasets = manager.getChildren('dataset'),
        len = datasets.length,
        // eslint-disable-line good-practices/no-single-usage-variable
    dataset,
        index,
        idFound,
        id,
        i,
        eventArgs,
        sourceEvent = NODE_ADDED,
        chart = manager.getFromEnv('chart'),
        dataStore;

    for (i = 0; i < len; i++) {
      dataset = datasets[i] || {};
      id = dataset.config.datasetIndex;

      if (id !== UNDEF) {
        id = id.toString();
      }

      if (id === dataObj.datasetId) {
        idFound = true;
        break;
      }
    }

    if (dataset && idFound) {
      dataStore = dataset.components.data;
      dataObj.add = true; // This is the index of the new data

      index = dataStore.length;
      eventArgs = {
        index: index,
        // to be deprecated
        dataIndex: index,
        link: dataObj.link,
        y: dataObj.y,
        x: dataObj.x,
        shape: dataObj.shape,
        label: dataObj.name,
        toolText: dataObj.tooltext,
        id: dataObj.id,
        datasetIndex: dataset.config.datasetIndex,
        datasetName: dataset.config.seriesname,
        sourceType: 'dataplot'
      }; // configure the eventArgs based on the type of shape

      makeShapeSpecificModifications(eventArgs, dataObj);

      dataset._setConfigure(index, dataObj);

      dataset.parsePlotAttributes(index);

      dataset._drawNode(index);

      dataset.setState('dirty', true); // manager._redrawDragNode(eventArgs, sourceEvent);

      /**
       * In `DragNode` charts, data points are represented as nodes whose
       * properties like location(x,y), shape, dimensions and color can be added dynamically to
       * the chart. Chart can contain any number of datasets and an index number is assigned to
       * each dataset based upon order of dataset creation. This event is raised when a node is
       * added by clicking on the menu button located at the left side bottom of the chart by
       * default but can the menu button location can be changed.
       *
       * This event is only applicable to DragNode chart.
       *
       * @event FusionCharts#nodeAdded
       * @group chart-powercharts:dragnode
       *
       * @param {number} datasetIndex - Index of the dataset to which the newly added
       * node belongs to.
       * @param {string} datasetName - Name of the dataset to which the node was added. Name of
       * the dataset can be defined by the attribute `seriesName` for `dataset` tag in the chart
       * data.
       * @param {number} dataIndex - Index of the newly added node.
       *
       * @param {number} height - Height of the shape represented by the newly added node.
       * @param {string} id - ID of the newly added node which can be set using `id` attribute
       * for `set` tag.
       *
       * @param {string} label - Text displayed inside the shape of the newly added node.
       * @param {string} link - URL associated with the newly added node.
       * @param {number} radius - Radius of the circumcirle for the shape of the
       * newly added node.
       * @param {string} shape - Shape of the newly added node.
       * @param {number} sides - Depending on the shape of the node it is the
       * number of sides of the polygon. If it is a circle it will have 0 sides.
       * @param {string} toolText - Text that is displayed over the shape of the
       * newly added node.
       * @param {number} width - Width of the shape of the newly added node.
       * @param {number} x - X Co-ordinate of the newly added node in reference with
       * the canvas / axis.
       * @param {number} y - Y Co-ordinate of the newly added node in reference with
       * the canvas / axis.
       */

      chart.fireChartInstanceEvent('chartupdated', (0, _lib.extend2)({
        sourceEvent: sourceEvent
      }, eventArgs));
      chart.fireChartInstanceEvent(sourceEvent, eventArgs);

      dataset._setupKdTree();
    }
  }
  /**
   * Function for updating existing nodes
   * @param {Object} updateObj Contains information about the node that is to be updated
   */
  ;

  _proto.updateNode = function updateNode(updateObj) {
    var groupManager = this,
        datasets = groupManager.getChildren('dataset'),
        len = datasets.length,
        // eslint-disable-line good-practices/no-single-usage-variable
    dataLen,
        idFound,
        dataset,
        dataObj,
        i,
        dataStore,
        eventArgs,
        sourceEvent = NODE_UPDATED,
        chart = groupManager.getFromEnv('chart'),
        j;
    updateObj.update = true;

    for (i = 0; i < len; i++) {
      dataset = datasets[i];
      dataStore = dataset.components.data || [];
      dataLen = dataStore.length;

      for (j = 0; j < dataLen; j++) {
        dataObj = dataStore[j];

        if (dataObj.config.id === updateObj.id) {
          idFound = true;
          break;
        }
      }
    }

    if (dataset && idFound) {
      eventArgs = {
        index: j,
        // to be deprecated
        dataIndex: j,
        link: updateObj.link,
        y: updateObj.y,
        x: updateObj.x,
        shape: updateObj.shape,
        label: updateObj.name,
        toolText: updateObj.tooltext,
        id: updateObj.id,
        datasetIndex: dataset.config.datasetIndex,
        datasetName: dataset.config.seriesname,
        sourceType: 'dataplot'
      }; // configure the eventArgs based on the type of shape

      makeShapeSpecificModifications(eventArgs, updateObj);

      dataset._setConfigure(j, updateObj);

      dataset.parsePlotAttributes(j);

      dataset._drawNode(j);

      dataset.setState('dirty', true);
      chart.fireChartInstanceEvent('chartupdated', (0, _lib.extend2)({
        sourceEvent: sourceEvent
      }, eventArgs));
      chart.fireChartInstanceEvent(sourceEvent, eventArgs);

      dataset._setupKdTree();
    }
  }
  /**
   * Function for deleting a node
   * @param {Stirng} id The id of the node that is to be deleted
   */
  ;

  _proto.deleteNode = function deleteNode(id) {
    var manager = this,
        node = manager.getNode(id),
        // node = nodes[id],
    dataset,
        dataStore,
        startConnectors,
        endConnectors,
        i,
        graphics,
        connector,
        dataObj,
        prop,
        len,
        eventArgs,
        config,
        idFound,
        sourceEvent = NODE_DELETED,
        chart = manager.getFromEnv('chart');

    if (node) {
      dataset = node.dataset;
      dataStore = dataset.components.data;
      startConnectors = node.config.startConnectors;
      endConnectors = node.config.endConnectors;
      len = dataStore.length;

      for (i = 0; i < len; i++) {
        dataObj = dataStore[i];

        if (dataObj.config.id === id) {
          idFound = true;
          break;
        }
      }

      if (idFound === true) {
        graphics = dataObj.graphics;
        removeElems(graphics);

        for (prop in startConnectors) {
          connector = startConnectors[prop] || {};
          graphics = connector.graphics;
          removeElems(graphics);
          delete connector.graphics;
          connector.removed = true;
        }

        for (prop in endConnectors) {
          connector = endConnectors[prop] || {};
          graphics = connector.graphics;
          removeElems(graphics);
          delete connector.graphics;
          connector.removed = true;
        } // delete nodes[id];


        dataObj.removed = true;
        config = dataObj.config || {};
        eventArgs = {
          index: i,
          dataIndex: i,
          link: config.link,
          y: config.y,
          x: config.x,
          shape: config.shape,
          label: config.displayValue,
          toolText: config.toolText,
          id: config.id,
          datasetIndex: dataset.config.datasetIndex,
          datasetName: dataset.config.seriesname,
          sourceType: 'dataplot'
        }; // configure the eventArgs based on the type of shape

        makeShapeSpecificModifications(eventArgs, {
          width: config.width,
          height: config.height,
          radius: config.radius,
          numsides: config.numSides
        });
        chart.fireChartInstanceEvent('chartupdated', (0, _lib.extend2)({
          sourceEvent: sourceEvent
        }, eventArgs));
        chart.fireChartInstanceEvent(sourceEvent, eventArgs);

        dataset._setupKdTree();
      }
    }
  }
  /**
   * Function for adding new connectors
   * @param {Object} connectorObj Contains information about the connector that is to be added
   */
  ;

  _proto.addConnector = function addConnector(connectorObj) {
    var manager = this,
        // groupManager = chart.components['datasetGroup_' + chart.defaultDatasetType],
    connectors = manager.getChildren('connector')[0],
        // connectors = connectorSets[0].connectors,
    sourceEvent = CONNECTOR_ADDED,
        eventArgs,
        chart = manager.getFromEnv('chart');
    connectorObj.add = true;

    connectors._setConfigure(connectors.components.data.length, connectorObj);

    eventArgs = {
      arrowAtEnd: Boolean(connectorObj.arrowatend),
      arrowAtStart: Boolean(connectorObj.arrowatstart),
      fromNodeId: connectorObj.from,
      id: connectorObj.id,
      label: connectorObj.label,
      link: connectorObj.connectorLink,
      sourceType: 'connector',
      toNodeId: connectorObj.to
    };
    chart.fireChartInstanceEvent('chartupdated', (0, _lib.extend2)({
      sourceEvent: sourceEvent
    }, eventArgs));
    chart.fireChartInstanceEvent(sourceEvent, eventArgs);
    connectors.asyncDraw();
  }
  /**
   * Function for updating existing connectors
   * @param {Object} connectorObj Contains information about the connector that is to be updated
   */
  ;

  _proto.editConnector = function editConnector(connectorObj) {
    var manager = this,
        connectorSets = manager.getChildren('connector'),
        i,
        conLen,
        data,
        dataObj,
        fromId,
        toId,
        j,
        idFound,
        connectors,
        config,
        eventArgs,
        chart = manager.getFromEnv('chart'),
        sourceEvent = CONNECTOR_UPDATED,
        len = connectorSets.length; // eslint-disable-line good-practices/no-single-usage-variable

    for (i = 0; i < len; i++) {
      connectors = connectorSets[i];
      data = connectors && connectors.components.data || [];
      conLen = data.length;

      for (j = 0; j < conLen; j++) {
        dataObj = data[j];
        config = dataObj.config;
        fromId = config.from;
        toId = config.to;

        if (fromId === connectorObj.from && toId === connectorObj.to) {
          idFound = true;
          break;
        }
      }
    }

    connectorObj.update = true;

    if (idFound) {
      connectors._setConfigure(j, connectorObj);

      eventArgs = {
        arrowAtEnd: Boolean(connectorObj.arrowatend),
        arrowAtStart: Boolean(connectorObj.arrowatstart),
        fromNodeId: connectorObj.from,
        id: connectorObj.id,
        label: connectorObj.label,
        link: connectorObj.link,
        sourceType: 'connector',
        toNodeId: connectorObj.to
      };
      chart.fireChartInstanceEvent('chartupdated', (0, _lib.extend2)({
        sourceEvent: sourceEvent
      }, eventArgs));
      chart.fireChartInstanceEvent(sourceEvent, eventArgs);
      connectors.asyncDraw();
    }
  }
  /**
   * Function for deleting a connector
   * @param {Object} config Contains information about the connector that is to be deleted
   */
  ;

  _proto.deleteConnector = function deleteConnector(config) {
    var manager = this,
        connectorSets = manager.getChildren('connector'),
        i,
        j,
        dataObj,
        dataStore,
        dataLen,
        connFound = false,
        // eslint-disable-line good-practices/no-single-usage-variable
    connectors,
        eventArgs,
        connConfig,
        len = connectorSets.length,
        // eslint-disable-line good-practices/no-single-usage-variable
    sourceEvent = CONNECTOR_DELETED,
        chart = manager.getFromEnv('chart');

    for (i = 0; i < len; i++) {
      connectors = connectorSets[i];
      dataStore = connectors.components.data;
      dataLen = dataStore.length;

      for (j = 0; j < dataLen; j++) {
        dataObj = dataStore[j];

        if (dataObj.config.from === config.from && dataObj.config.to === config.to) {
          connFound = true;
          break;
        }
      }
    }

    if (connFound) {
      connConfig = dataObj.config || {};
      eventArgs = {
        arrowAtEnd: connConfig.arrowAtEnd,
        arrowAtStart: connConfig.arrowAtStart,
        fromNodeId: connConfig.from,
        id: connConfig.id,
        label: connConfig.label,
        link: connConfig.connectorLink,
        sourceType: 'connector',
        toNodeId: connConfig.to
      };
      removeElems(dataObj.graphics);
      delete dataObj.graphics; // Mark data object as removed

      dataObj.removed = true;
      chart.fireChartInstanceEvent('chartupdated', (0, _lib.extend2)({
        sourceEvent: sourceEvent
      }, eventArgs));
      chart.fireChartInstanceEvent(sourceEvent, eventArgs);
    }
  }
  /**
   * Generic function for creating a html UI box
   * @param {number} dialogWidth The width of the dialog box
   * @param {number} dialogHeight The height of the dialog box
   * @param {Function} onsubmit Callback functions
   * @param {Function} oncancel Callback functions
   * @param {Function} onremove Callback functions
   * @param {Object} cacheUI If the dialog box or its components are created then they are sent via this object so that
   * they are not re-created.
   * @return {HTMLElement} The final created html UI box
   */
  ;

  _proto.createHtmlDialog = function createHtmlDialog(dialogWidth, dialogHeight, onsubmit, oncancel, onremove, cacheUI) {
    var manager = this,
        // paper = manager.getFromEnv('paper'),
    conf = manager.getFromEnv('chartConfig'),
        inCanvasStyle = manager.getFromEnv('style').inCanvasStyle || {},
        chartWidth = Number(conf.width),
        chartHeight = Number(conf.height),
        animationManager = manager.getFromEnv('animationManager'),
        padding = 5,
        uiok,
        uicancel,
        uiremove,
        dialogAttrs,
        okAttrs,
        cancelAttrs,
        removeAttrs,
        buttonStyle = {
      color: (0, _lib.hashify)(inCanvasStyle.color),
      textAlign: 'center',
      paddingTop: 1 + PX,
      border: '1px solid #cccccc',
      borderRadius: 4 + PX,
      cursor: _lib.preDefStr.POINTER,
      '_cursor': 'hand',
      backgroundColor: _lib.HASHSTRING + COLOR_FFFFFF,
      zIndex: 21,
      '-webkit-border-radius': 4 + PX
    },
        ui = cacheUI,
        attrObj;
    attrObj = {
      width: chartWidth,
      height: chartHeight
    };

    if (!cacheUI) {
      attrObj.fill = TRANSPARENT;
      attrObj.type = DIV_STR;
    }

    ui = animationManager.setAnimation({
      el: cacheUI || 'html',
      attr: attrObj,
      component: manager,
      label: 'ui',
      state: DATASETSTATE,
      css: {
        fontSize: 10 + PX,
        lineHeight: 15 + PX,
        fontFamily: inCanvasStyle.fontFamily,
        display: 'block'
      },
      container: !cacheUI && manager.getFromEnv('chart-container')
    });
    attrObj = {
      width: chartWidth,
      height: chartHeight,
      opacity: 0.3
    };

    if (!ui.veil) {
      attrObj.fill = COLOR_000000;
      attrObj.type = DIV_STR;
    }

    ui.veil = animationManager.setAnimation({
      el: ui.veil || 'html',
      attr: attrObj,
      component: manager,
      state: DATASETSTATE,
      label: 'uiveil',
      container: !ui.veil && ui
    });
    dialogAttrs = {
      x: (chartWidth - dialogWidth) / 2,
      y: (chartHeight - dialogHeight) / 2,
      width: dialogWidth,
      height: dialogHeight
    };

    if (!ui.dialog) {
      dialogAttrs.fill = COLOR_EFEFEF;
      dialogAttrs.strokeWidth = 1;
      dialogAttrs.stroke = COLOR_000000;
      dialogAttrs.type = DIV_STR;
    }

    ui.dialog = animationManager.setAnimation({
      el: ui.dialog || 'html',
      attr: dialogAttrs,
      component: manager,
      state: DATASETSTATE,
      label: 'uidialog',
      container: !ui.dialog && ui,
      css: {
        borderRadius: 5 + PX,
        boxShadow: '1px 1px 3px #000000',
        '-webkit-border-radius': 5 + PX,
        '-webkit-box-shadow': '1px 1px 3px #000000',
        filter: 'progid:DXImageTransform.Microsoft.Shadow(Strength=4, Direction=135, Color="#000000")'
      }
    });
    okAttrs = {
      x: dialogWidth - 70 - padding,
      y: dialogHeight - 23 - padding,
      width: 65,
      height: 17
    };

    if (!ui.ok) {
      okAttrs.text = SUBMIT_STR;
      okAttrs.tabIndex = 1;
      okAttrs.type = DIV_STR;
    }

    uiok = animationManager.setAnimation({
      el: ui.ok || 'html',
      state: DATASETSTATE,
      attr: okAttrs,
      component: manager,
      label: 'uiok',
      css: buttonStyle,
      container: !ui.ok && ui.dialog
    });
    !ui.ok && (ui.ok = uiok) && uiok.on('fc-mousedown', onsubmit);
    cancelAttrs = {
      x: dialogWidth - 140 - padding,
      y: dialogHeight - 23 - padding,
      width: 65,
      height: 17
    };

    if (!ui.cancel) {
      cancelAttrs.text = CANCEL_STR;
      cancelAttrs.tabIndex = 2;
      cancelAttrs.type = DIV_STR;
    }

    uicancel = animationManager.setAnimation({
      el: ui.cancel || 'html',
      state: DATASETSTATE,
      attr: cancelAttrs,
      component: manager,
      label: 'uicancel',
      css: buttonStyle,
      container: !ui.cancel && ui.dialog
    });
    !ui.cancel && (ui.cancel = uicancel) && uicancel.on('fc-mousedown', oncancel);
    removeAttrs = {
      x: dialogWidth - 210 - padding,
      y: dialogHeight - 23 - padding,
      width: 65,
      height: 17
    };

    if (!ui.removeItem) {
      removeAttrs.text = DELETE_STR;
      removeAttrs.tabIndex = 3;
      removeAttrs.type = DIV_STR;
    }

    uiremove = animationManager.setAnimation({
      el: ui.removeItem || 'html',
      state: DATASETSTATE,
      attr: removeAttrs,
      component: manager,
      label: 'uiremove',
      css: buttonStyle,
      container: !ui.removeItem && ui.dialog
    });
    !ui.removeItem && (ui.removeItem = uiremove) && uiremove.on('fc-mousedown', onremove);

    if (!ui.handleKeyPress) {
      // Add an event that would handle enter and esc on input
      // elements
      ui.handleKeyPress = function (e) {
        if (e.keyCode === 13) {
          // fire the mousedown handler when enter is pressed
          ui.ok.element && onsubmit(e);
        } else if (e.keyCode === 27) {
          // fire the mousedown handler when escape is pressed
          ui.cancel.element && oncancel(e);
        }
      };
    } // Keep initially hidden.
    // ui.hide();


    return ui;
  }
  /**
   * Function to get a specific node after querying all the datasets
   * @param {string} nodeId The node's id whose corresponding data object is required
   * @return {Object} The specific node or all the nodes from all the datasets
   */
  ;

  _proto.getNode = function getNode(nodeId) {
    var node,
        nodes = {},
        datasets = this.getChildren('dataset');

    for (var i = 0, len = datasets.length; i < len; i++) {
      if (nodeId) {
        if (node = datasets[i].getNode(nodeId)) {
          return node;
        }
      } else {
        Object.assign(nodes, datasets[i].getNode());
      }
    }

    return !nodeId && nodes;
  }
  /**
   * Create child containers
   */
  ;

  _proto.createContainer = function createContainer() {
    var manager = this,
        animationManager = manager.getFromEnv('animationManager'),
        keys = ['connectorGroup', 'defaultVcanvasGroup', 'vcanvasLabelGroup', 'cloneGroup'],
        // eslint-disable-line good-practices/no-single-usage-variable
    parentChildContainers = manager.getLinkedParent().getChildContainer();
    keys.forEach(function (key) {
      !manager.getChildContainer(key) && manager.addChildContainer(key, animationManager.setAnimation({
        el: 'group',
        attr: {
          name: 'manager-' + key
        },
        component: manager,
        container: parentChildContainers[key] || parentChildContainers.defaultVcanvasGroup
      }));
    });
    !manager.getContainer('waitContainer') && manager.addContainer('waitContainer', animationManager.setAnimation({
      el: 'group',
      attr: {
        name: 'manager-waitContainer'
      },
      container: parentChildContainers.defaultVcanvasGroup,
      component: manager
    }));
  }
  /**
   * Function to draw all the containers and repoition the html dialog box on chart-redraw
   */
  ;

  _proto.draw = function draw() {
    var manager = this,
        graphicalMap = {
      cacheUpdateUI: [350, 215],
      cacheLabelDeleteUI: [250, 100],
      cacheLabelUpdateUI: [350, 205],
      cacheConnectorUpdateUIedit: [315, 215],
      cacheConnectorUpdateUInew: [315, 215]
    },
        graphics,
        elem;

    if (!manager.getState('configured')) {
      DATASETSTATE = UPDATE_STR;

      for (graphics in graphicalMap) {
        if ((elem = manager.getGraphicalElement(graphics)) && elem.isVisible()) {
          if (graphics === 'cacheUpdateUI') {
            var fields = elem.fields,
                ele = fields.image,
                isChecked = ele.val();
            graphicalMap[graphics][1] = isChecked ? 250 : 215;
          }

          manager.createHtmlDialog(graphicalMap[graphics][0], graphicalMap[graphics][1], UNDEF, UNDEF, UNDEF, elem);
        }
      }

      DATASETSTATE = APPEARING_STR;
    }

    manager.setState('configured', false);
    manager.createContainer();
  }
  /**
   * function to get data limits from its child datasets
   * return minimun and maximum value among the datasets limit
   * @return {Object} [min, max]
   */
  ;

  _proto.getDataLimits = function getDataLimits() {
    var datasets = this.getChildren('dataset'),
        i,
        yMin = +Infinity,
        yMax = -Infinity,
        xMax = -Infinity,
        xMin = +Infinity,
        conf;

    for (i = 0; i < datasets.length; i++) {
      conf = datasets[i].config;
      yMax = Math.max(yMax, conf.yMax);
      yMin = Math.min(yMin, conf.yMin);
      xMax = Math.max(xMax, conf.xMax);
      xMin = Math.min(xMin, conf.xMin);
    }

    return {
      max: yMax,
      min: yMin,
      xMax: xMax,
      xMin: xMin
    };
  }
  /**
   * it return the status of dataset visiblity
   * @return {boolean} returns the visiblity status of dataset
   */
  ;

  _proto.isVisible = function isVisible() {
    return !this.isNotVisible;
  }
  /**
   * Over writing the childChanged function of the parent, basically a dummy function.
   * @return {Object} instance of DragNodeGroup class
   */
  ;

  _proto.childChanged = function childChanged() {
    return this;
  }
  /**
   * Function to hide the circular ring element
   */
  ;

  _proto.hideWaitElem = function hideWaitElem() {
    this.getGraphicalElement('waitElement') && this.getGraphicalElement('waitElement').hide();
  }
  /**
   * Function to clear the setTimeout of that is set when a long press is triggered on the nodes, connectors and labels
   */
  ;

  _proto.clearLongPress = function clearLongPress() {
    var manager = this;
    clearTimeout(manager.config._longpressactive);
    delete manager.config._longpressactive;
  }
  /**
   * Function to set the timer after which the UI for deleting labels will open
   * @param {SVGElement} ele The element over which the click is done
   * @param {Object} labelObj Conatins the information about the label that is clicked
   */
  ;

  _proto.triggerLabelUI = function triggerLabelUI(ele, labelObj) {
    var manager = this;
    manager.config._longpressactive = setTimeout(function () {
      ele.data('fire_click_event', 0);

      if (!ele.data('viewMode')) {
        manager.showLabelDeleteUI(labelObj);
      }
    }, CLEAR_TIME_1000);
  }
  /**
   * Function to manage the UI box for editing connectors
   * @param {SVGElemet} ele The element on which the mousedown event is triggered
   */
  ;

  _proto.triggerConnectorUI = function triggerConnectorUI(ele) {
    var manager = this,
        dataset = ele.data('dataset'),
        config = ele.data(_lib.preDefStr.configStr),
        options = config || {};
    manager.config._longpressactive = setTimeout(function () {
      // Whether to fire the click event ot not
      ele.data('fire_click_event', 0);

      if (!ele.data('viewMode')) {
        // add a selection method for start and end
        // TODO This innerHTML we might need to use below innerHTML in below trusted Policy
        manager.showConnectorUpdateUI({
          fromid: {
            val: options.from,
            innerHTML: OPTIONSTR + options.from + OPTIONCLOSESTR,
            disabled: true
          },
          toid: {
            val: options.to,
            innerHTML: OPTIONSTR + options.to + OPTIONCLOSESTR,
            disabled: true
          },
          datasetIndex: dataset.config.datasetIndex,
          index: config.index,
          arratstart: {
            val: Boolean((0, _lib.pluckNumber)(options.arrowatstart, 1))
          },
          arratend: {
            val: Boolean((0, _lib.pluckNumber)(options.arrowatend, 1))
          },
          dashed: {
            val: (0, _lib.pluckNumber)(options.dashed)
          },
          dashgap: {
            val: options.dashgap
          },
          dashlen: {
            val: options.dashlen
          },
          label: {
            val: options.label
          },
          tooltext: {
            val: options.tooltext
          },
          id: {
            val: dataset.config.id,
            disabled: true
          },
          strength: {
            val: options.conStrength
          },
          alpha: {
            val: options.alpha
          },
          color: {
            val: options.color.FCcolor.color
          }
        }, true);
      }
    }, CLEAR_TIME_1000);
  }
  /**
   * Function to delete a label
   * @param {number} i The index of the label that is to be deleted
   */
  ;

  _proto.deleteLabel = function deleteLabel(i) {
    var manager = this,
        labels = manager.getChildren('labels')[0],
        index = (0, _lib.pluckNumber)(i, labels.config.lastTappedLabelIndex),
        // eslint-disable-line good-practices/no-single-usage-variable
    labelObj = labels.components.data[index],
        labelElement,
        trackerElement,
        chart = manager.getFromEnv('chart'),
        sourceEvent = LABEL_DELETED,
        eventArgs;
    labelElement = labelObj.graphics.element;
    trackerElement = labelObj.graphics.trackerElement;

    if (labelElement) {
      eventArgs = labelElement.data('eventArgs');
      labelElement.remove();
      trackerElement && trackerElement.remove();
      delete labelObj.graphics;
    }

    chart.fireChartInstanceEvent('chartupdated', (0, _lib.extend2)({
      sourceEvent: sourceEvent
    }, eventArgs));
    chart.fireChartInstanceEvent(sourceEvent, eventArgs);
    labelObj.removed = true;
  }
  /**
   * Function to show thw UI for deleting an existing label
   * @param {Object} label Conatains information about the label that is to be deleted
   */
  ;

  _proto.showLabelDeleteUI = function showLabelDeleteUI(label) {
    var manager = this,
        ui = manager.getGraphicalElement('cacheLabelDeleteUI'); // Store the index of the last tapped label.

    manager.getChildren('labels')[0].config.lastTappedLabelIndex = label.config.index;

    if (!ui) {
      ui = manager.addGraphicalElement('cacheLabelDeleteUI', manager.createHtmlDialog(250, 100, UNDEF, function () {
        ui.hide();
      }, function () {
        manager.deleteLabel();
        ui.hide();
      })); // create a location where to show the text message

      ui.message = manager.getFromEnv('paper').html('span', {
        x: 10,
        y: 10,
        width: 230,
        height: 80
      }).add(ui.dialog); // since submit button is not needed, hide it and move the
      // delete button to its place.

      ui.ok.hide();
      ui.removeItem.translate(175).show();
    } else {
      ui.show();
    } // Update the message with proper text.


    ui.message.attr({
      text: 'Would you really like to delete the label: \"' + label.config.text + '\"?'
    });
  }
  /**
   * Function to draw the circular ring and trigger the timer for opening the html box for editing the node
   * @param {Object} dataObj Conatins information about the node that is clicked
   * @param {number} datasetIndex The index of the dataset to which the node belongs
   */
  ;

  _proto.drawWaitingRing = function drawWaitingRing(dataObj, datasetIndex) {
    var manager = this,
        config = dataObj.config,
        conf = manager.getChildren('dataset')[datasetIndex].config,
        waitElement = manager.getGraphicalElement('waitElement');
    manager.clearLongPress();
    waitElement = manager.getFromEnv('animationManager').setAnimation({
      el: waitElement || 'ringpath',
      attr: {
        ringpath: [config._xPos, config._yPos, 8, 11, 0, 0],
        fill: (0, _lib.toRaphaelColor)({
          alpha: '100,100',
          angle: 120,
          color: 'CCCCCC,FFFFFF',
          ratio: '30,50'
        }),
        'stroke-width': 0
      },
      container: manager.getContainer('waitContainer'),
      component: manager
    });

    if (!manager.getGraphicalElement('waitElement')) {
      manager.addGraphicalElement('waitElement', waitElement);
    } // layerX += 11;
    // layerY -= 21;


    waitElement.show().animate({
      ringpath: [config._xPos, config._yPos, 8, 11, 0, 6.28]
    }, CLEAR_TIME_1000);
    manager.config._longpressactive = setTimeout(function () {
      var seriesName = conf.name !== BLANK && conf.name !== UNDEF ? conf.name + _lib.preDefStr.BLANKSPACE : BLANK,
          seriesId = conf.id !== UNDEF ? (seriesName ? _lib.COMMASTRING : seriesName) + conf.id : BLANK;
      waitElement && waitElement.hide(); // Whether to fire the click event ot not
      // ele.data('fire_click_event', 0);

      manager.showNodeUpdateUI({
        x: {
          value: config.x
        },
        y: {
          value: config.y
        },
        draggable: {
          value: (0, _lib.getFirstValue)(config.allowdrag, 1)
        },
        color: {
          value: config.color
        },
        alpha: {
          value: config.alpha
        },
        label: {
          value: (0, _lib.getFirstValue)(config.label, config.name)
        },
        tooltip: {
          value: config.toolText
        },
        shape: {
          value: shapesInfo[config.shape]
        },
        rectWidth: {
          value: config.width
        },
        rectHeight: {
          value: config.height
        },
        circPolyRadius: {
          value: config.radius
        },
        polySides: {
          value: config.numsides
        },
        image: {
          value: config.imageNode
        },
        imgWidth: {
          value: config.imageWidth
        },
        imgHeight: {
          value: config.imageHeight
        },
        imgAlign: {
          value: config.imageAlign
        },
        imgUrl: {
          value: config.imageURL
        },
        id: {
          value: config.id,
          disabled: true
        },
        link: {
          value: config.link
        },
        dataset: {
          innerHTML: _trustedPolicy.default.createHTML('<option value="' + seriesId + '">' + seriesName + seriesId + '</option>'),
          disabled: true
        },
        datasetIndex: datasetIndex
      }, true);
    }, CLEAR_TIME_1000);
  }
  /**
   * Function to draw connectors during dragging of the nodes
   * @param {Object} connectorsObj Contains information about connector object that is to be re-drawn
   */
  ;

  _proto.drawNodeConnectors = function drawNodeConnectors(connectorsObj) {
    var i, datasetIndex, connectorSet, connector, fromObj, toObj;

    if (!connectorsObj) {
      return;
    }

    for (i in connectorsObj) {
      connector = connectorsObj[i];

      if (connector) {
        datasetIndex = connector.config.datasetIndex;
        fromObj = connector.config.fromPointObj;
        toObj = connector.config.toPointObj;
        connectorSet = this.getChildren('connector')[datasetIndex];

        if (connectorSet) {
          connectorSet && connectorSet.parsePlotAttributes(connector, fromObj, toObj);
          connectorSet && connectorSet.drawConnector(connector, fromObj, toObj);
        }
      }
    }
  }
  /**
   * Function to clear all the connectors if chart is updated.
   */
  ;

  _proto._clearConnectors = function _clearConnectors() {
    var nodes = this.getNode(),
        id,
        startConnectors,
        endConnectors,
        graphics,
        j,
        node; // Deleting all connectors from nodes object

    for (id in nodes) {
      node = nodes[id];

      if (node) {
        startConnectors = node.config.startConnectors || {};
        endConnectors = node.config.endConnectors || {};

        for (j in startConnectors) {
          graphics = {
            graphics: startConnectors[j].graphics || {}
          };

          _lib.componentDispose.call(graphics);
        }

        for (j in endConnectors) {
          graphics = {
            graphics: endConnectors[j].graphics || {}
          };

          _lib.componentDispose.call(graphics);
        }
      }
    } // // Clearing nodes object
    // manager.nodes = {};

  }
  /**
   * Function to get the jsonData from the datasets
   * @return {Object} data from the dataset
   */
  ;

  _proto.getJSONData = function getJSONData() {
    var children = this.getChildren(),
        nodeSets = children.dataset,
        connectorSets = children.connector,
        labelSets = children.labels,
        jsonData = {},
        i,
        len,
        dataset;
    jsonData.dataset = [];
    jsonData.connectors = [];
    jsonData.labels = [];

    for (i = 0, len = nodeSets && nodeSets.length; i < len; i++) {
      dataset = nodeSets[i];

      if (!jsonData.dataset[i]) {
        jsonData.dataset[i] = (0, _lib.extend2)({}, dataset.JSONData);
      }

      jsonData.dataset[i].data = dataset.getJSONData();
    }

    for (i = 0, len = connectorSets && connectorSets.length; i < len; i++) {
      dataset = connectorSets[i];

      if (!jsonData.connectors[i]) {
        jsonData.connectors[i] = (0, _lib.extend2)({}, dataset.JSONData);
      }

      jsonData.connectors[i].connector = dataset.getJSONData();
    }

    for (i = 0, len = labelSets && labelSets.length; i < len; i++) {
      dataset = labelSets[i];

      if (!jsonData.labels[i]) {
        jsonData.labels[i] = {
          label: []
        };
      }

      jsonData.labels[i].label = dataset.getJSONData();
    }

    return jsonData;
  };

  return DragNodeGroup;
}(_componentInterface.ComponentInterface);

var _default = DragNodeGroup;
exports["default"] = _default;

/***/ }),

/***/ 1442:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _componentInterface = __webpack_require__(290);

var HeatMapGroup = /*#__PURE__*/function (_ComponentInterface) {
  (0, _inheritsLoose2.default)(HeatMapGroup, _ComponentInterface);

  /**
   * constructor function this class
   */
  function HeatMapGroup() {
    var _this;

    _this = _ComponentInterface.call(this) || this;

    _this.setState('visible', true);

    _this.getDataLimits = null;
    return _this;
  }
  /**
   * Sets the type of the component
   * @return {string} type
   */


  var _proto = HeatMapGroup.prototype;

  _proto.getType = function getType() {
    return 'group';
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */
  ;

  _proto.getName = function getName() {
    return 'heatMapGroup';
  }
  /**
   * Create child containers
   */
  ;

  _proto.createContainer = function createContainer() {
    var manager = this,
        key,
        parent = manager.getLinkedParent(),
        animationManager = manager.getFromEnv('animationManager'),
        pContainer,
        parentChildContainers = parent.getChildContainer();

    for (key in parentChildContainers) {
      pContainer = parentChildContainers[key];
      !manager.getChildContainer(key) && manager.addChildContainer(key, animationManager.setAnimation({
        el: 'group',
        attr: {
          name: 'manager-' + key
        },
        container: pContainer,
        component: manager,
        label: 'group'
      }));
    }
  };

  _proto.getLimits = function getLimits(allVisible) {
    var manager = this,
        min = +Infinity,
        max = -Infinity,
        maxminObj,
        numOfColumns = 0,
        getMaxMin = function getMaxMin(_maxminObj) {
      max = Math.max(max, _maxminObj.max);
      min = Math.min(min, _maxminObj.min);
    };

    manager._mapChildren(function (child) {
      if (child.getState('removed') || child.getState('visible') === false) {
        if (allVisible) {
          maxminObj = child.getDataLimits(allVisible);
          getMaxMin(maxminObj);
        }

        return;
      }

      numOfColumns++;
      maxminObj = child.getDataLimits(allVisible);
      getMaxMin(maxminObj);
    });

    if (!numOfColumns) {
      manager.setState('visible', false);
    } else {
      manager.setState('visible', true);
    }

    if (!this.config.range) {
      this.config.range = {};
      this.config.range.min = this.config.dataMin;
      this.config.range.max = this.config.dataMax;
    }

    return {
      max: max,
      min: min
    };
  }
  /**
   * function call sync draw of its children
   */
  ;

  _proto.draw = function draw() {
    var manager = this,
        range = manager.getLimits(true);
    manager.addToEnv('datasetMinValue', range.min);
    manager.addToEnv('datasetMaxValue', range.max);
    this.createContainer();
  };

  _proto.getAxisValuePadding = function getAxisValuePadding() {
    var paddingObj = {},
        axisPaddingLeft = -Infinity,
        axisPaddingRight = -Infinity,
        axisPaddingTop = -Infinity,
        axisPaddingBottom = -Infinity;

    this._mapChildren(function (child) {
      if (child.getState('removed')) {
        return;
      }

      paddingObj = child.getAxisValuePadding && child.getAxisValuePadding() || {};
      axisPaddingLeft = Math.max(axisPaddingLeft, paddingObj.left || -Infinity);
      axisPaddingRight = Math.max(axisPaddingRight, paddingObj.right || -Infinity);
      axisPaddingTop = Math.max(axisPaddingTop, paddingObj.top || -Infinity);
      axisPaddingBottom = Math.max(axisPaddingBottom, paddingObj.bottom || -Infinity);
    });

    if (axisPaddingLeft === -Infinity) {
      axisPaddingLeft = 0;
    }

    if (axisPaddingRight === -Infinity) {
      axisPaddingRight = 0;
    }

    if (axisPaddingTop === -Infinity) {
      axisPaddingTop = 0;
    }

    if (axisPaddingBottom === -Infinity) {
      axisPaddingBottom = 0;
    }

    if (!this.config.padding) {
      this.config.padding = {};
      this.config.padding.left = axisPaddingLeft;
      this.config.padding.right = axisPaddingRight;
      this.config.padding.top = axisPaddingTop;
      this.config.padding.bottom = axisPaddingBottom;
    }

    return {
      left: axisPaddingLeft,
      right: axisPaddingRight,
      top: axisPaddingTop,
      bottom: axisPaddingBottom
    };
  };

  return HeatMapGroup;
}(_componentInterface.ComponentInterface);

var _default = HeatMapGroup;
exports["default"] = _default;

/***/ }),

/***/ 1441:
/***/ ((__unused_webpack_module, exports) => {



exports.__esModule = true;
exports["default"] = void 0;
var _default = {
  'initial.dataset.heatMap': function initialDatasetHeatMap() {
    return {
      'rect.appearing': function rectAppearing() {
        return [{
          initialAttr: {
            opacity: 0
          },
          finalAttr: {
            opacity: 1
          },
          slot: 'plot'
        }];
      },
      'text.appearing': function textAppearing() {
        return [{
          initialAttr: {
            opacity: 0
          },
          finalAttr: {
            opacity: 1
          },
          slot: 'final'
        }];
      },
      '*': null
    };
  }
};
exports["default"] = _default;

/***/ }),

/***/ 1440:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _componentInterface = __webpack_require__(290);

var _lib = __webpack_require__(274);

var _dependencyManager = __webpack_require__(282);

var _index = _interopRequireDefault(__webpack_require__(1441));

var _schedular = __webpack_require__(286);

var HUNDREDSTRING = '100',
    PLOTGRADIENTCOLOR = 'plotGradientColor',
    PLOTBORDERCOLOR = 'plotBorderColor',
    COLOR_FFFFFF = 'FFFFFF',
    SHOWSHADOW = 'showShadow',
    UNDEF,
    MOUSEOVER = 'mouseOver',
    MOUSEOUT = 'mouseOut',
    NORMAL = 'normal',
    PXSTRING = 'px',
    pStr = _lib.preDefStr.pStr,
    sStr = _lib.preDefStr.sStr,
    COMMA = ',',
    BOLDSTARTTAG = '<b>',
    BOLDENDTAG = '</b>',
    BREAKSTRING = '<br />',
    visibleStr = 'visible',
    miterStr = _lib.preDefStr.miterStr,
    hiddenStr = _lib.preDefStr.hiddenStr,
    showHoverEffectStr = _lib.preDefStr.showHoverEffectStr,
    POSITION_START = _lib.preDefStr.POSITION_START,
    POSITION_TOP = _lib.preDefStr.POSITION_TOP,
    POSITION_END = _lib.preDefStr.POSITION_END,
    POSITION_BOTTOM = _lib.preDefStr.POSITION_BOTTOM,
    SETROLLOVERATTR = 'setRolloverAttr',
    SETROLLOUTATTR = 'setRolloutAttr',
    EVENTARGS = 'eventArgs',
    POINTER = 'pointer',
    tlLabelStr = 'tlLabel',
    blLabelStr = 'blLabel',
    trLabelStr = 'trLabel',
    brLabelStr = 'brLabel',
    ROLLOVER = 'DataPlotRollOver',
    ROLLOUT = 'DataPlotRollOut',
    DEFAULT_CURSOR = _lib.preDefStr.DEFAULT,
    MAX_PERCENT_SPACE = 0.9,
    POINT_FIVE = 0.5,
    GUTTER_4 = 4,
    defined = function defined(obj) {
  return obj !== UNDEF && obj !== null;
},

/**
 * Helper function to create a RedRaphael group.
 * @param  {Object} attr  Attributes to be applied to the group
 * @param  {Element} parentContainer         The parent container in which the group will be appended.
 * @param {Object} dataset The concerned dataset
 * @return {Element}                         The group that was created.
 */
createGroup = function createGroup(attr, parentContainer, dataset) {
  return dataset.getFromEnv('animationManager').setAnimation({
    el: 'group',
    attr: attr,
    container: parentContainer,
    component: dataset,
    label: 'group'
  });
},
    TRACKER_FILL = 'rgba(192,192,192,' + (_lib.isIE ? 0.002 : 0.000001) + ')',
    // invisible but clickable
HTP = _lib.hasTouch ? _lib.TOUCH_THRESHOLD_PIXELS : _lib.CLICK_THRESHOLD_PIXELS,
    pInt = function pInt(s, mag) {
  return parseInt(s, mag || 10);
},
    NONE = 'none',
    _rolloverResponseSetter = function _rolloverResponseSetter(chart, data, event, onlyHoverEffect, dataset) {
  var dataGraphics = data.graphics,
      animationManager = chart.getFromEnv('animationManager'),
      elem = dataGraphics && dataGraphics.element,
      elData = elem && elem.getData(); // Check whether the plot is in dragged state or not if
  // drag then dont fire rolloverevent

  if (elData.draged !== true) {
    animationManager.setAnimationState(MOUSEOVER);
    elem && elData.showHoverEffect !== 0 && animationManager.setAnimation({
      el: elem,
      attr: elem.getData().setRolloverAttr,
      component: dataset
    });
    !onlyHoverEffect && elem && chart.plotEventHandler(elem, event, ROLLOVER);
  }
},
    _rolloutResponseSetter = function _rolloutResponseSetter(chart, data, event, onlyHoverEffect, dataset) {
  var dataGraphics = data.graphics,
      animationManager = chart.getFromEnv('animationManager'),
      elem = dataGraphics && dataGraphics.element,
      elData = elem && elem.getData(); // Check whether the plot is in draggedstate or not if drag then dont fire rolloutevent

  if (elData.draged !== true) {
    animationManager.setAnimationState(MOUSEOUT);
    elem && elData.showHoverEffect !== 0 && animationManager.setAnimation({
      el: elem,
      attr: elem.getData().setRolloutAttr,
      component: dataset
    });
    !onlyHoverEffect && elem && chart.plotEventHandler(elem, event, ROLLOUT);
  }
},
    mathMax = Math.max,
    mathMin = Math.min,
    mathAbs = Math.abs;

(0, _dependencyManager.addDep)({
  name: 'heatmapAnimation',
  type: 'animationRule',
  extension: _index.default
});

var HeatMapDataset = /*#__PURE__*/function (_ComponentInterface) {
  (0, _inheritsLoose2.default)(HeatMapDataset, _ComponentInterface);

  function HeatMapDataset() {
    var _this;

    _this = _ComponentInterface.call(this) || this;
    _this.components = {};
    _this.graphics = {};
    _this.dataSetArray = []; // this.getDataLimits = null;

    return _this;
  }
  /**
   * Sets the type of the component
   * @return {string} type
   */


  var _proto = HeatMapDataset.prototype;

  _proto.getType = function getType() {
    return 'dataset';
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */
  ;

  _proto.getName = function getName() {
    return 'heatMap';
  }
  /**
   * Configures the cosmetic of dataset
   * Creates the empty plotGrid array
   * Calculates the dataset min and max value
   * @param {Object} datasetJSON data array containing data information
   */
  ;

  _proto.configureAttributes = function configureAttributes(datasetJSON) {
    if (!datasetJSON) {
      return false;
    }

    this.trimData(datasetJSON);
    this.config.JSONData = datasetJSON;
    var dataSet = this,
        chart = dataSet.getFromEnv('chart'),
        conf = dataSet.config,
        JSONData = conf.JSONData,
        setDataArr = JSONData.data,
        len = setDataArr && setDataArr.length,
        // eslint-disable-line good-practices/no-single-usage-variable
    chartAttr = dataSet.getFromEnv('chart-attrib'),
        colorM = dataSet.getFromEnv('color-manager'),
        plotBorderDash = (0, _lib.pluckNumber)(JSONData.dashed, chartAttr.plotborderdashed),
        // eslint-disable-line good-practices/no-single-usage-variable
    setData,
        setValue,
        dataObj,
        config,
        dataStore = dataSet.components.data,
        plotGrid = dataSet.components.plotGrid = [],
        isBar = chart.isBar,
        is3D = chart.config.is3D,
        enableAnimation,
        i,
        r,
        c,
        maxValue = -Infinity,
        minValue = +Infinity,
        totalRows = dataSet.getFromEnv('totalRows'),
        // eslint-disable-line good-practices/no-single-usage-variable
    totalColumns = dataSet.getFromEnv('totalColumns'); // eslint-disable-line good-practices/no-single-usage-variable

    for (r = 0; r < totalRows; r++) {
      plotGrid.push([]);

      for (c = 0; c < totalColumns; c++) {
        plotGrid[r].push([]);
      }
    }

    dataSet.setState('visible', (0, _lib.pluckNumber)(dataSet.getState('visible'), dataSet.config.JSONData.visible, !Number(dataSet.config.JSONData.initiallyhidden), 1) === 1);
    conf.showplotborder = (0, _lib.pluckNumber)(chartAttr.showplotborder, is3D ? 0 : 1);
    conf.plotDashLen = (0, _lib.pluckNumber)(chartAttr.plotborderdashlen, 5);
    conf.plotDashGap = (0, _lib.pluckNumber)(chartAttr.plotborderdashgap, 4);
    conf.showTextOutLine = (0, _lib.pluckNumber)(chartAttr.textoutline, 0);
    conf.plotfillAngle = (0, _lib.pluckNumber)(360 - chartAttr.plotfillangle, isBar ? 180 : 90);
    conf.plotFillAlpha = (0, _lib.pluck)(JSONData.alpha, chartAttr.plotfillalpha, HUNDREDSTRING);
    conf.plotColor = (0, _lib.pluck)(JSONData.color, colorM.getPlotColor(dataSet.index || dataSet.positionIndex));
    conf.isRoundEdges = (0, _lib.pluckNumber)(chartAttr.useroundedges, 0);
    conf.plotRadius = (0, _lib.pluckNumber)(chartAttr.useRoundEdges, conf.isRoundEdges ? 1 : 0);
    conf.plotFillRatio = (0, _lib.pluck)(JSONData.ratio, chartAttr.plotfillratio);
    conf.plotgradientcolor = (0, _lib.getDefinedColor)(chartAttr.plotgradientcolor, colorM.getColor(PLOTGRADIENTCOLOR)); // !usePlotGradientColor && (plotgradientcolor = BLANKSTRING);

    conf.plotBorderAlpha = conf.showplotborder ? (0, _lib.pluck)(chartAttr.plotborderalpha, conf.plotFillAlpha, HUNDREDSTRING) : 0;
    conf.plotBorderColor = (0, _lib.pluck)(chartAttr.plotbordercolor, is3D ? COLOR_FFFFFF : colorM.getColor(PLOTBORDERCOLOR));
    conf.plotBorderThickness = (0, _lib.pluckNumber)(chartAttr.plotborderthickness, 1);
    conf.plotBorderDashStyle = plotBorderDash ? (0, _lib.getDashStyle)(conf.plotDashLen, conf.plotDashGap) : NONE;
    conf.showValues = (0, _lib.pluckNumber)(JSONData.showvalues, chartAttr.showvalues, 1);
    conf.valuePadding = (0, _lib.pluckNumber)(chartAttr.valuepadding, 2);
    conf.enableAnimation = enableAnimation = (0, _lib.pluckNumber)(chartAttr.animation, chartAttr.defaultanimation, 1);
    conf.animation = !enableAnimation ? false : {
      duration: (0, _lib.pluckNumber)(chartAttr.animationduration, 1) * 1000
    };
    conf.transposeAnimation = (0, _lib.pluckNumber)(chartAttr.transposeanimation, enableAnimation);
    conf.transposeAnimDuration = (0, _lib.pluckNumber)(chartAttr.transposeanimduration, 0.2) * 1000;
    conf.showShadow = conf.isRoundEdges || is3D ? (0, _lib.pluckNumber)(chartAttr.showshadow, 1) : (0, _lib.pluckNumber)(chartAttr.showshadow, colorM.getColor(SHOWSHADOW));
    conf.showHoverEffect = (0, _lib.pluckNumber)(chartAttr.plothovereffect, chartAttr.showhovereffect, UNDEF);
    conf.showTooltip = (0, _lib.pluckNumber)(chartAttr.showtooltip, 1);
    conf.definedGroupPadding = Math.max((0, _lib.pluckNumber)(chartAttr.plotspacepercent), 0);
    conf.plotSpacePercent = Math.max((0, _lib.pluckNumber)(chartAttr.plotspacepercent, 20) % 100, 0);
    conf.maxColWidth = (0, _lib.pluckNumber)(isBar ? chartAttr.maxbarheight : chartAttr.maxcolwidth, 50);
    conf.plotPaddingPercent = (0, _lib.pluckNumber)(chartAttr.plotpaddingpercent);
    conf.rotateValues = (0, _lib.pluckNumber)(chartAttr.rotatevalues) ? 270 : 0;
    conf.placeValuesInside = (0, _lib.pluckNumber)(chartAttr.placevaluesinside, 0);
    conf.defaultPadding = {
      left: 0.5,
      right: 0.5,
      top: 0.5,
      bottom: 0.5
    };
    conf.use3DLighting = (0, _lib.pluckNumber)(chartAttr.use3dlighting, 1);
    conf.parentYAxis = (0, _lib.pluck)(JSONData.parentyaxis && JSONData.parentyaxis.toLowerCase(), pStr) === sStr ? 1 : 0;

    if (!dataStore) {
      dataStore = dataSet.components.data = [];
    } // Parsing the attributes and values at set level.


    for (i = 0; i < len; i++) {
      setData = setDataArr && setDataArr[i];
      dataObj = dataStore[i];
      config = dataObj && dataObj.config;

      if (!dataObj) {
        dataObj = dataStore[i] = {
          graphics: {}
        };
      }

      if (!dataObj.config) {
        config = dataStore[i].config = {};
      }

      config.setValue = setValue = dataSet.getFromEnv('number-formatter').getCleanValue(setData.value);
      maxValue = Math.max(maxValue, setValue);
      minValue = Math.min(minValue, setValue);
    }

    conf.maxValue = maxValue;
    conf.minValue = minValue;

    dataSet._setConfigure();

    dataSet.setState('dirty', true);
  }
  /**
   * Attaches legendUpdate event listener to dataset which decides whether to
   * show/hide particular data in dataset.
   * Sets the color configuration for each data objects present in dataset.
   */
  ;

  _proto._setConfigure = function _setConfigure() {
    var dataSet = this,
        chart = dataSet.getFromEnv('chart'),
        conf = dataSet.config,
        JSONData = dataSet.config.JSONData,
        setDataArr = JSONData.data,
        len = setDataArr && setDataArr.length,
        // eslint-disable-line good-practices/no-single-usage-variable
    chartConfig = dataSet.getFromEnv('chartConfig'),
        chartAttr = dataSet.getFromEnv('chart-attrib'),
        showplotborder = conf.showplotborder,
        plotColor = conf.plotColor = dataSet.getFromEnv('color-manager').getPlotColor(dataSet.index || dataSet.positionIndex),
        showTooltip = (0, _lib.pluckNumber)(chartAttr.showtooltip, 1),
        // eslint-disable-line good-practices/no-single-usage-variable
    tooltipSepChar = (0, _lib.parseUnsafeString)((0, _lib.pluck)(chartAttr.tooltipsepchar, ': ')),
        usePlotGradientColor = (0, _lib.pluckNumber)(chartAttr.useplotgradientcolor, 1),
        // eslint-disable-line good-practices/no-single-usage-variable
    formatedVal,
        parserConfig,
        setTooltext,
        macroIndices,
        toolText = _lib.BLANKSTRING,
        plotDashLen = conf.plotDashLen,
        plotDashGap = conf.plotDashGap,
        plotBorderThickness = conf.plotBorderThickness,
        isRoundEdges = conf.isRoundEdges,
        showHoverEffect = conf.showHoverEffect,
        plotfillAngle = conf.plotfillAngle,
        plotFillAlpha = conf.plotFillAlpha,
        plotFillRatio = conf.plotFillRatio,
        plotBorderAlpha = conf.plotBorderAlpha,
        plotBorderColor = conf.plotBorderColor,
        plotBorderDashStyle,
        setData,
        setValue,
        dataObj,
        config,
        colorRange = dataSet.getFromEnv('chartColorRange'),
        column,
        row,
        rowid,
        columnid,
        mapByPercent = conf.mapByPercent = (0, _lib.pluckNumber)(colorRange.mapbypercent, 0),
        mapByCategory = conf.mapByCategory = (0, _lib.pluckNumber)(chartAttr.mapbycategory, 0),
        useColorGradient = colorRange && (0, _lib.pluckNumber)(colorRange.gradient),
        // eslint-disable-line good-practices/no-single-usage-variable
    hoverColor,
        hoverAlpha,
        hoverGradientColor,
        hoverRatio,
        hoverAngle,
        hoverBorderColor,
        hoverBorderAlpha,
        hoverBorderThickness,
        hoverBorderDashed,
        hoverBorderDashGap,
        hoverBorderDashLen,
        hoverDashStyle,
        hoverColorArr,
        numberFormatter = dataSet.getFromEnv('number-formatter'),
        setDisplayValue,
        isBar = chart.isBar,
        is3D = chart.config.is3D,
        parentYAxis = conf.parentYAxis,
        i,
        maxValue = conf.maxValue,
        // eslint-disable-line good-practices/no-single-usage-variable
    minValue = conf.minValue,
        heatRange,
        colorObj,
        tlType = (0, _lib.getValidValue)(chartAttr.tltype, _lib.BLANK),
        trType = (0, _lib.getValidValue)(chartAttr.trtype, _lib.BLANK),
        blType = (0, _lib.getValidValue)(chartAttr.bltype, _lib.BLANK),
        brType = (0, _lib.getValidValue)(chartAttr.brtype, _lib.BLANK),
        tlLabel,
        trLabel,
        blLabel,
        brLabel,
        tlTypeToolText = _lib.BLANK,
        // eslint-disable-line good-practices/no-single-usage-variable
    trTypeToolText = _lib.BLANK,
        // eslint-disable-line good-practices/no-single-usage-variable
    blTypeToolText = _lib.BLANK,
        // eslint-disable-line good-practices/no-single-usage-variable
    brTypeToolText = _lib.BLANK,
        // eslint-disable-line good-practices/no-single-usage-variable
    percentValue,
        toolTextValue,
        value,
        minMaxArray,
        minMaxArrayLen,
        toolTipValue,
        setDataDashed,
        setDataPlotDashLen,
        setDataPlotDashGap,
        colorManager = chart.getFromEnv('colorManager'),
        font,
        fontColor,
        fontSize,
        fontWeight,
        fontStyle;
    font = chartConfig.style.inCanfontFamily;
    fontSize = pInt(chartConfig.style.inCanfontSize, 10);
    fontColor = chartConfig.style.inCancolor;
    fontWeight = NORMAL;
    fontStyle = NORMAL;
    heatRange = maxValue - minValue; // eslint-disable-line good-practices/no-single-usage-variable

    if (!conf.eventAttached) {
      // listen to event fired by legends and decide what to do
      dataSet.addExtEventListener('legendUpdate', function (e, d) {
        if (d.component === 'legend') {
          if (d.legendItem.hasState('hidden')) {
            dataSet.show(d.legendItem, e);
          } else {
            dataSet.hide(d.legendItem, e);
          }
        } else {
          minMaxArray = d.maxMinArray;
          minMaxArrayLen = minMaxArray.length;

          for (i = 0; i < minMaxArrayLen; i++) {
            dataSet.updatePlot(minMaxArray[i].min, minMaxArray[i].max);
          }
        }
      }, colorManager);
      conf.eventAttached = true;
    }

    if (!useColorGradient || mapByCategory) {
      conf.colorMap = [];

      if (colorRange.color) {
        for (i = 0; i < colorRange.color.length; i++) {
          conf.colorMap[i] = {
            config: colorRange.color[i],
            dataSet: dataSet
          };
          conf.colorMap[i].config.visible = true;
        }
      }
    }

    for (i = 0; i < len; i++) {
      setData = setDataArr && setDataArr[i];
      dataObj = dataSet.components.data[i];
      config = dataObj && dataObj.config;
      setValue = config.setValue;
      config.showValue = (0, _lib.pluckNumber)(setData.showvalue, conf.showValues);
      config.setLink = (0, _lib.pluck)(setData.link);
      config.toolTipValue = toolTipValue = numberFormatter.dataLabels(setValue, parentYAxis);
      config.setDisplayValue = setDisplayValue = (0, _lib.parseUnsafeString)(setData.displayvalue);
      config.displayValue = (0, _lib.pluck)(setDisplayValue, toolTipValue);
      setDataDashed = (0, _lib.pluckNumber)(setData.dashed);
      setDataPlotDashLen = (0, _lib.pluckNumber)(setData.dashlen, plotDashLen);
      setDataPlotDashGap = plotDashGap = (0, _lib.pluckNumber)(setData.dashgap, plotDashGap);
      config.plotBorderDashStyle = setDataDashed === 1 ? (0, _lib.getDashStyle)(setDataPlotDashLen, setDataPlotDashGap) : setDataDashed === 0 ? NONE : conf.plotBorderDashStyle;
      /* @TODO-
      * Heatmap percentage calculation is done for each dataset individually and shown for ease.
      * But ideally percentage calculation must be done considering all the datasets.
      * A heatmap group manager should query each dataset for their local min and max values and
      * calculate overall range. Then, the group must inform all the dataset the range and the dataset must
      * calculate the percentage values for each data and then draw itself.
      */

      if (mapByPercent) {
        config.percentValue = percentValue = setData.value && Math.round((setData.value - minValue) / heatRange * 10000) / 100;
      } else {
        config.percentValue = UNDEF;
      }

      config.dataLabelStyle = dataSet._configureDataLabelStyle(setData);
      config.value = value = mapByCategory
      /* || !useColorGradient */
      ? setData.colorrangelabel || setData.categoryid : mapByPercent ? percentValue : config.setValue;
      colorObj = colorManager.getColor(value);
      config.colorRangeLabel = setData.colorrangelabel || colorObj.label;
      dataObj.legendItemIndex = colorObj.seriesIndex;
      config.legendItemId = colorObj.legendItemId;
      colorObj && !colorObj.code && (colorObj.code = 'ffffff');
      colorObj && colorObj.outOfRange && (colorObj.code = 'ffffff'); // alpha at data label > alpha at color object > plotfillalpha

      config.plotFillAlpha = plotFillAlpha = (0, _lib.pluckNumber)(setData.alpha, colorObj && colorObj.oriAlpha, conf.plotFillAlpha);
      plotColor = (0, _lib.pluck)(setData.color, colorObj && colorObj.code);

      if (setValue < 0 && !isRoundEdges) {
        plotfillAngle = isBar ? 180 - plotfillAngle : 360 - plotfillAngle;
      }

      config.colorArr = (0, _lib.getColumnColor)(plotColor + COMMA + conf.plotgradientcolor, plotFillAlpha.toString(), plotFillRatio, plotfillAngle, isRoundEdges, plotBorderColor, plotBorderAlpha.toString(), isBar ? 1 : 0, !!is3D);
      config.visible = true;
      config.color = (0, _lib.convertColor)(plotColor, config.plotFillAlpha);
      config.rawPlotColor = plotColor; // Parsing the hover effects only if showhovereffect is not 0.

      if (showHoverEffect !== 0) {
        hoverColor = (0, _lib.pluck)(setData.hovercolor, JSONData.hovercolor, chartAttr.plotfillhovercolor, chartAttr.columnhovercolor, plotColor);
        hoverAlpha = (0, _lib.pluck)(setData.hoveralpha, JSONData.hoveralpha, chartAttr.plotfillhoveralpha, chartAttr.columnhoveralpha, '25');
        hoverGradientColor = (0, _lib.pluck)(setData.hovergradientcolor, JSONData.hovergradientcolor, chartAttr.plothovergradientcolor, !usePlotGradientColor && _lib.BLANKSTRING);
        !hoverGradientColor && (hoverGradientColor = _lib.BLANKSTRING);
        hoverRatio = (0, _lib.pluck)(setData.hoverratio, JSONData.hoverratio, chartAttr.plothoverratio, plotFillRatio);
        hoverAngle = (0, _lib.pluckNumber)(360 - setData.hoverangle, 360 - JSONData.hoverangle, 360 - chartAttr.plothoverangle, plotfillAngle);
        hoverBorderColor = (0, _lib.pluck)(setData.borderhovercolor, JSONData.borderhovercolor, chartAttr.plotborderhovercolor, plotBorderColor);
        hoverBorderAlpha = (0, _lib.pluck)(setData.borderhoveralpha, JSONData.borderhoveralpha, chartAttr.plotborderhoveralpha, plotBorderAlpha, plotFillAlpha);
        hoverBorderThickness = (0, _lib.pluckNumber)(setData.borderhoverthickness, JSONData.borderhoverthickness, chartAttr.plotborderhoverthickness, plotBorderThickness);
        hoverBorderDashed = (0, _lib.pluckNumber)(setData.borderhoverdashed, JSONData.borderhoverdashed, chartAttr.plotborderhoverdashed);
        hoverBorderDashGap = (0, _lib.pluckNumber)(setData.borderhoverdashgap, JSONData.borderhoverdashgap, chartAttr.plotborderhoverdashgap, plotDashLen);
        hoverBorderDashLen = (0, _lib.pluckNumber)(setData.borderhoverdashlen, JSONData.borderhoverdashlen, chartAttr.plotborderhoverdashlen, plotDashGap);
        hoverDashStyle = hoverBorderDashed ? (0, _lib.getDashStyle)(hoverBorderDashLen, hoverBorderDashGap) : conf.plotBorderDashStyle;
        /* If no hover effects are explicitly defined and
                     * showHoverEffect is not 0 then hoverColor is set.
                     */

        if (showHoverEffect === 1 && hoverColor === plotColor) {
          hoverColor = (0, _lib.getLightColor)(hoverColor, 70);
        } // setting the hover color array which is always applied except when showHoverEffect is not 0.


        hoverColorArr = (0, _lib.getColumnColor)(hoverColor, hoverAlpha, hoverRatio, hoverAngle, isRoundEdges, hoverBorderColor, hoverBorderAlpha.toString(), isBar ? 1 : 0, !!is3D);
        config.setRolloutAttr = {
          fill: (0, _lib.toRaphaelColor)(config.color),
          stroke: showplotborder && (0, _lib.toRaphaelColor)(config.colorArr[1]) || TRACKER_FILL,
          'stroke-width': plotBorderThickness,
          'stroke-dasharray': plotBorderDashStyle || []
        };
        config.setRolloverAttr = {
          fill: (0, _lib.toRaphaelColor)(hoverColorArr[0]),
          stroke: showplotborder && (0, _lib.toRaphaelColor)(hoverColorArr[1]) || TRACKER_FILL,
          'stroke-width': hoverBorderThickness,
          'stroke-dasharray': hoverDashStyle
        };
      }

      mapByPercent && (percentValue = numberFormatter.percentValue(percentValue));
      config.setValue = setValue = numberFormatter.getCleanValue(setData.value);
      config.toolTipValue = numberFormatter.dataLabels(setValue, parentYAxis);
      formatedVal = config.toolTipValue;
      setTooltext = (0, _lib.getValidValue)((0, _lib.parseUnsafeString)((0, _lib.pluck)(setData.tooltext, JSONData.plottooltext, chartAttr.plottooltext), false));
      config.tlLabel = tlLabel = (0, _lib.parseUnsafeString)((0, _lib.pluck)(setData.tllabel, setData.ltlabel));
      config.trLabel = trLabel = (0, _lib.parseUnsafeString)((0, _lib.pluck)(setData.trlabel, setData.rtlabel));
      config.blLabel = blLabel = (0, _lib.parseUnsafeString)((0, _lib.pluck)(setData.bllabel, setData.lblabel));
      config.brLabel = brLabel = (0, _lib.parseUnsafeString)((0, _lib.pluck)(setData.brlabel, setData.rblabel));
      config.tlLabelStyle = {
        fontFamily: (0, _lib.pluck)(colorObj.tlLabelFont, chartAttr.tlfont, font),
        fontSize: (0, _lib.pluckNumber)(colorObj.tlLabelFontSize, chartAttr.tlfontsize, fontSize) + PXSTRING,
        color: (0, _lib.convertColor)((0, _lib.pluck)(colorObj.tlLabelFontColor, chartAttr.tlfontcolor, fontColor), 100),
        fontWeight: fontWeight,
        fontStyle: fontStyle
      };
      (0, _lib.setLineHeight)(config.tlLabelStyle);
      config.trLabelStyle = {
        fontFamily: (0, _lib.pluck)(colorObj.trLabelFont, chartAttr.trfont, font),
        fontSize: (0, _lib.pluckNumber)(colorObj.trLabelFontSize, chartAttr.trfontsize, fontSize) + PXSTRING,
        color: (0, _lib.convertColor)((0, _lib.pluck)(colorObj.trLabelFontColor, chartAttr.trfontcolor, fontColor), 100),
        fontWeight: fontWeight,
        fontStyle: fontStyle
      };
      config.brLabelStyle = {
        fontFamily: (0, _lib.pluck)(colorObj.brLabelFont, chartAttr.brfont, font),
        fontSize: (0, _lib.pluckNumber)(colorObj.brLabelFontSize, chartAttr.brfontsize, fontSize) + PXSTRING,
        color: (0, _lib.convertColor)((0, _lib.pluck)(colorObj.brLabelFontColor, chartAttr.brfontcolor, fontColor), 100),
        fontWeight: fontWeight,
        fontStyle: fontStyle
      };
      config.blLabelStyle = {
        fontFamily: (0, _lib.pluck)(colorObj.blLabelFont, chartAttr.blfont, font),
        fontSize: (0, _lib.pluckNumber)(colorObj.blLabelFontSize, chartAttr.blfontsize, fontSize) + PXSTRING,
        color: (0, _lib.convertColor)((0, _lib.pluck)(colorObj.blLabelFontColor, chartAttr.blfontcolor, fontColor), 100),
        fontWeight: fontWeight,
        fontStyle: fontStyle
      };
      setDisplayValue = (0, _lib.getValidValue)((0, _lib.parseUnsafeString)(setData.displayvalue));
      toolTextValue = mapByCategory ? setDisplayValue : (0, _lib.pluck)(setData.displayvalue, formatedVal);
      config.displayValue = (0, _lib.pluck)(setDisplayValue, percentValue, config.toolTipValue);

      if (tlType !== _lib.BLANK) {
        tlTypeToolText = BOLDSTARTTAG + tlType + tooltipSepChar + BOLDENDTAG;
      }

      if (trType !== _lib.BLANK) {
        trTypeToolText = BOLDSTARTTAG + trType + tooltipSepChar + BOLDENDTAG;
      }

      if (blType !== _lib.BLANK) {
        blTypeToolText = BOLDSTARTTAG + blType + tooltipSepChar + BOLDENDTAG;
      }

      if (brType !== _lib.BLANK) {
        brTypeToolText = BOLDSTARTTAG + brType + tooltipSepChar + BOLDENDTAG;
      }

      columnid = (0, _lib.getFirstValue)(setDataArr[i].columnid);
      rowid = (0, _lib.getFirstValue)(setDataArr[i].rowid);
      column = dataSet.getFromEnv('xAxis').getCategoryFromId(columnid.toLowerCase());
      row = dataSet.getFromEnv('yAxis').getCategoryFromId(rowid.toLowerCase()); // create the tooltext

      if (showTooltip) {
        if (formatedVal === null) {
          toolText = false;
        } else if (setTooltext !== UNDEF) {
          macroIndices = [1, 2, 5, 6, 7, 14, 93, 94, 95, 96, 97, 98, 112, 113, 114, 115, 116, 117];
          parserConfig = {
            formattedValue: formatedVal,
            value: setData.value,
            yaxisName: (0, _lib.parseUnsafeString)(chartAttr.yaxisname),
            xaxisName: (0, _lib.parseUnsafeString)(chartAttr.xaxisname),
            displayValue: setDisplayValue,
            percentValue: mapByPercent ? percentValue : _lib.BLANK,
            tlLabel: tlLabel,
            trLabel: trLabel,
            blLabel: blLabel,
            brLabel: brLabel,
            rowLabel: row.tickObj && row.tickObj.label,
            columnLabel: column.tickObj && column.tickObj.label,
            percentDataValue: mapByPercent ? percentValue : _lib.BLANK,
            trtype: trType,
            tltype: tlType,
            brType: brType,
            blType: blType,
            colorRangeLabel: config.colorRangeLabel
          };
          toolText = (0, _lib.parseTooltext)(setTooltext, macroIndices, parserConfig, setData, chartAttr, parserConfig);
        } else {
          toolText = (mapByPercent ? BOLDSTARTTAG + 'Value' + tooltipSepChar + BOLDENDTAG + formatedVal + BREAKSTRING + BOLDSTARTTAG + 'Percentage' + tooltipSepChar + BOLDENDTAG + percentValue : toolTextValue) + ( // Now we add special labels in toolTip
          tlLabel !== _lib.BLANK ? BREAKSTRING + (tlTypeToolText + tlLabel) : _lib.BLANK) + (trLabel !== _lib.BLANK ? BREAKSTRING + trTypeToolText + trLabel : _lib.BLANK) + (blLabel !== _lib.BLANK ? BREAKSTRING + blTypeToolText + blLabel : _lib.BLANK) + (brLabel !== _lib.BLANK ? BREAKSTRING + brTypeToolText + brLabel : _lib.BLANK);
        }
      }

      config.toolText = toolText;
      config.setTooltext = toolText;
    }
  }
  /**
   * Hides the data objects according to the legend item
   * @param {Object} item - legend item
   */
  ;

  _proto.hide = function hide(item) {
    var dataset = this,
        entityComponents = dataset.components.data,
        colorRange = dataset.getFromEnv('chart').getChildren('colorRange')[0],
        // eslint-disable-line good-practices/no-single-usage-variable
    i,
        len,
        config,
        legendItemColor,
        colorCode;
    legendItemColor = item.config.datasetObj.code; // eslint-disable-line good-practices/no-single-usage-variable

    for (i = 0, len = entityComponents.length; i < len; i++) {
      // eslint-disable-line good-practices/no-single-usage-variable
      if (!Object.keys(entityComponents[i]).length) {
        continue;
      }

      colorCode = colorRange.getColorObj(entityComponents[i].config.value).code;
      config = entityComponents[i].config;

      if (legendItemColor === colorCode) {
        entityComponents[i].graphics.element && dataset.getFromEnv('animationManager').setAnimation({
          el: entityComponents[i].graphics.element,
          attr: {
            'fill-opacity': 0,
            'stroke-width': 0
          },
          component: dataset
        }); // animFlagHide = false;

        entityComponents[i].graphics.hotElement && entityComponents[i].graphics.hotElement.hide();
        config.visible = false;
        entityComponents[i].visible = false;
      }
    }

    item.setLegendState('hidden');
  }
  /**
   * Shows the data objects according to the legend item
   * @param {Object} item - legend item
   */
  ;

  _proto.show = function show(item) {
    var dataset = this,
        entityComponents = dataset.components.data,
        animationManager = dataset.getFromEnv('animationManager'),
        config,
        plotFillAlpha,
        colorObj,
        colorRange = dataset.getFromEnv('chart').getChildren('colorRange')[0],
        // eslint-disable-line good-practices/no-single-usage-variable
    i,
        len,
        legendItemColor,
        colorCode;
    legendItemColor = item.config.datasetObj.code; // eslint-disable-line good-practices/no-single-usage-variable

    for (i = 0, len = entityComponents.length; i < len; i++) {
      // eslint-disable-line good-practices/no-single-usage-variable
      if (!Object.keys(entityComponents[i]).length) {
        continue;
      }

      config = entityComponents[i].config;
      plotFillAlpha = config.plotFillAlpha / 100;
      colorObj = colorRange.getColorObj(entityComponents[i].config.value); //  do not set color for out of range values

      colorCode = !colorObj.outOfRange && colorObj.code;

      if (legendItemColor === colorCode) {
        entityComponents[i].graphics.element && animationManager.setAnimation({
          el: entityComponents[i].graphics.element,
          attr: {
            'visibility': visibleStr
          },
          component: dataset
        });
        entityComponents[i].graphics.element && animationManager.setAnimation({
          el: entityComponents[i].graphics.element,
          component: dataset,
          attr: {
            'fill-opacity': plotFillAlpha,
            'stroke-width': dataset.config.plotBorderThickness
          }
        }); // animFlagShow = false;

        entityComponents[i].graphics.hotElement && entityComponents[i].graphics.hotElement.show();
        entityComponents[i].graphics.valEle && entityComponents[i].graphics.valEle.show();
        entityComponents[i].graphics.tlLabel && entityComponents[i].graphics.tlLabel.show();
        entityComponents[i].graphics.trLabel && entityComponents[i].graphics.trLabel.show();
        entityComponents[i].graphics.blLabel && entityComponents[i].graphics.blLabel.show();
        entityComponents[i].graphics.brLabel && entityComponents[i].graphics.brLabel.show();
        config.visible = true;
        entityComponents[i].visible = true;
      }
    }

    item && item.removeLegendState('hidden');
  }
  /**
   * updates the plot range when gradient legend is moved
   */
  ;

  _proto.updatePlot = function updatePlot(minValue, maxValue) {
    var dataset = this,
        animationManager = dataset.getFromEnv('animationManager'),
        config,
        plotFillAlpha,
        entityComponents = dataset.components.data,
        i,
        len,
        value;

    for (i = 0, len = entityComponents.length; i < len; i++) {
      // eslint-disable-line good-practices/no-single-usage-variable
      if (!Object.keys(entityComponents[i]).length) {
        continue;
      }

      config = entityComponents[i].config;
      plotFillAlpha = config.plotFillAlpha / 100;
      value = entityComponents[i].config.value;

      if (value < minValue || value > maxValue) {
        if (config.visible) {
          entityComponents[i].graphics.element && animationManager.setAnimation({
            el: entityComponents[i].graphics.element,
            attr: {
              'fill-opacity': 0,
              'stroke-width': 0
            },
            component: dataset
          });
          entityComponents[i].graphics.hotElement && entityComponents[i].graphics.hotElement.hide();
          config.visible = false;
          entityComponents[i].visible = false;
        }
      } else {
        if (!config.visible) {
          // entityComponents[i].graphics.element && animationManager.registerAnimation([{
          //   animType: animType,
          //   data: [{
          //     el: entityComponents[i].graphics.element,
          //     attrs: {
          //       'fill-opacity': plotFillAlpha,
          //       'stroke-width': conf.plotBorderThickness
          //     }
          //   }]
          // }], 'plot');
          entityComponents[i].graphics.element && animationManager.setAnimation({
            el: entityComponents[i].graphics.element,
            attr: {
              'fill-opacity': plotFillAlpha,
              'stroke-width': dataset.config.plotBorderThickness
            },
            callback: function callback() {
              this.show();
            },
            component: dataset
          });
          entityComponents[i].graphics.hotElement && entityComponents[i].graphics.hotElement.show();
          entityComponents[i].graphics.valEle && entityComponents[i].graphics.valEle.show();
          entityComponents[i].graphics.tlLabel && entityComponents[i].graphics.tlLabel.show();
          entityComponents[i].graphics.trLabel && entityComponents[i].graphics.trLabel.show();
          entityComponents[i].graphics.blLabel && entityComponents[i].graphics.blLabel.show();
          entityComponents[i].graphics.brLabel && entityComponents[i].graphics.brLabel.show();
          config.visible = true;
          entityComponents[i].visible = true;
        }
      }
    }
  };

  _proto._checkPointObj = function _checkPointObj(pX, pY, chartX, chartY) {
    var dataset = this,
        plotGrid = dataset.components.plotGrid,
        pointObj,
        chartConfig = dataset.getFromEnv('chartConfig'),
        viewPortConfig = chartConfig.viewPortConfig,
        plotBorderThickness = chartConfig.plotborderthickness,
        halfPlotBorderThickness,
        dx,
        dy,
        hovered;
    pointObj = plotGrid[pY] && plotGrid[pY][pX];
    plotBorderThickness = chartConfig.showplotborder ? plotBorderThickness : 0;
    halfPlotBorderThickness = plotBorderThickness / 2;
    halfPlotBorderThickness = halfPlotBorderThickness % 2 === 0 ? halfPlotBorderThickness + 1 : Math.round(halfPlotBorderThickness);

    if (pointObj && pointObj.config && pointObj.config.visible) {
      dx = chartX - (pointObj._xPos - viewPortConfig.x * viewPortConfig.scaleX) + halfPlotBorderThickness;
      dy = chartY - pointObj._yPos + halfPlotBorderThickness;
      hovered = dx >= 0 && dx <= pointObj._width + plotBorderThickness && dy >= 0 && dy <= pointObj._height + plotBorderThickness;

      if (hovered) {
        return {
          pointIndex: pointObj._index,
          hovered: hovered,
          pointObj: pointObj
        };
      }
    }
  }
  /**
   *  function to return the hovered data object
   */
  ;

  _proto._getHoveredPlot = function _getHoveredPlot(chartXVal, chartYVal) {
    var dataset = this,
        chartX = chartXVal,
        chartY = chartYVal,
        xAxis = dataset.getFromEnv('xAxis'),
        yAxis = dataset.getFromEnv('yAxis'),
        height = dataset.getFromEnv('chartConfig').canvasHeight / dataset.getFromEnv('totalRows'),
        // eslint-disable-line good-practices/no-single-usage-variable
    x,
        y,
        pX,
        pY;
    chartX += xAxis.getTranslation();
    chartY += yAxis.getTranslation();
    y = yAxis.getValue(chartY + height / 2);
    pY = Math.floor(y);
    x = xAxis.getValue(chartX);
    pX = Math.round(x);

    if (pX - x > 0) {
      return y - pY > 0.5 ? dataset._checkPointObj(pX, pY, chartX, chartY) || dataset._checkPointObj(pX - 1, pY, chartX, chartY) : dataset._checkPointObj(pX, pY - 1, chartX, chartY) || dataset._checkPointObj(pX, pY, chartX, chartY);
    }

    return y - pY > 0.5 ? dataset._checkPointObj(pX + 1, pY, chartX, chartY) || dataset._checkPointObj(pX, pY, chartX, chartY) : dataset._checkPointObj(pX, pY - 1, chartX, chartY) || dataset._checkPointObj(pX + 1, pY, chartX, chartY) || dataset._checkPointObj(pX, pY, chartX, chartY);
  }
  /**
   * Parses the plot attributes
   *
   * @param {any} dataObj
   * @param {any} index
   * @returns {any}
   * @memberof HeatMapDataset
   */
  ;

  _proto.parsePlotAttributes = function parsePlotAttributes(dataObj, index) {
    var dataSet = this,
        conf = dataSet.config,
        setDataArr = dataSet.config.JSONData.data,
        attr,
        i = index,
        chart = dataSet.getFromEnv('chart'),
        xAxis = dataSet.getFromEnv('xAxis'),
        yAxis = dataSet.getFromEnv('yAxis'),
        xPos,
        yPos,
        chartConfig = dataSet.getFromEnv('chartConfig'),
        columnWidth,
        height,
        toolText,
        setLink,
        setValue,
        config,
        plotBorderThickness = conf.plotBorderThickness,
        plotRadius = conf.plotRadius,
        colorArr,
        plotBorderDashStyle,
        legendActive = chart.getFromEnv('legend') && chart.getFromEnv('legend').config.isActive,
        plotGrid = dataSet.components.plotGrid,
        // eslint-disable-line good-practices/no-single-usage-variable
    width,
        column,
        row,
        columnid,
        rowid,
        trackerConfig;
    yAxis.yBasePos = yAxis.getPixel(yAxis.getAxisBase());

    if (!dataObj || !Object.keys(dataObj).length) {
      return;
    }

    width = chartConfig.canvasWidth / dataSet.getFromEnv('totalColumns');
    height = chartConfig.canvasHeight / dataSet.getFromEnv('totalRows');
    trackerConfig = dataObj.trackerConfig = {};
    config = dataObj && dataObj.config;
    setValue = config.setValue;
    columnid = (0, _lib.getFirstValue)(setDataArr[i].columnid);
    rowid = (0, _lib.getFirstValue)(setDataArr[i].rowid);
    column = xAxis.getCategoryFromId(columnid.toLowerCase());
    row = yAxis.getCategoryFromId(rowid.toLowerCase());

    if (column.index !== 0 && !column.index || row.index !== 0 && !row.index) {
      return;
    }

    if (!conf.mapByCategory && setValue === null) {
      return;
    }

    setLink = config.setLink;
    colorArr = config.colorArr; // Creating the data structure if not present for storing the graphics elements.

    if (!dataObj.graphics) {
      dataSet.components.data[i].graphics = {};
    }

    xPos = xAxis.getPixel(column.index) - width / 2;
    yPos = yAxis.getPixel(row.index) - height / 2;
    columnWidth = width; // Setting the final tooltext.

    toolText = config.toolText; // Setting the event arguments.

    trackerConfig.eventArgs = {
      index: i,
      link: setLink,
      value: config.percentValue || setValue,
      displayValue: config.displayValue,
      columnId: column.tickObj.id,
      rowId: row.tickObj.id,
      tlLabel: config.tlLabel,
      trLabel: config.trLabel,
      blLabel: config.blLabel,
      brLabel: config.brLabel,
      colorRangeLabel: config.colorRangeLabel,
      color: config.rawPlotColor,
      alpha: config.plotFillAlpha,
      showValue: config.showValue,
      // categoryLabel: categories[i].label,
      toolText: !toolText ? '' : toolText,
      id: _lib.BLANKSTRING,
      datasetIndex: legendActive ? dataObj.datasetIndex : UNDEF,
      datasetName: legendActive ? dataObj.datasetName : UNDEF,
      visible: dataSet.getState('visible')
    }; // Setting the attributes for plot drawing.

    attr = {
      x: xPos,
      y: yPos,
      width: columnWidth,
      height: height || 1,
      r: plotRadius,
      fill: config.color,
      stroke: (0, _lib.toRaphaelColor)(colorArr[1]),
      'stroke-width': plotBorderThickness,
      'stroke-dasharray': plotBorderDashStyle,
      'fill-opacity': config.plotFillAlpha / 100,
      'stroke-linejoin': miterStr,
      'visibility': config.visible ? visibleStr : hiddenStr,
      cursor: setLink ? POINTER : _lib.BLANKSTRING
    }; // todo- remove _ to make it public

    dataObj._xPos = xPos;
    dataObj._yPos = yPos;
    dataObj._height = height;
    dataObj._width = columnWidth;
    dataObj._index = i;
    plotGrid[row.index][column.index] = dataObj;
    /*
    * If the data plots are not present then they are created, else only attributes are set for the
    * existing plots.
    */

    if (!dataObj.graphics.element) {
      attr['fill-opacity'] = config.plotFillAlpha / 100;
      attr['stroke-width'] = plotBorderThickness;
    } else {
      attr = {
        x: xPos,
        y: yPos,
        width: columnWidth,
        height: height || 1
      };
      attr.fill = config.color;
      attr.stroke = (0, _lib.toRaphaelColor)(colorArr[1]);
      attr['fill-opacity'] = config.visible ? config.plotFillAlpha / 100 : 0;
      attr['stroke-width'] = config.visible ? plotBorderThickness : 0;
      attr['stroke-dasharray'] = plotBorderDashStyle;
      attr['stroke-linejoin'] = miterStr;
      attr.visibility = config.visible ? visibleStr : hiddenStr;
      attr.cursor = setLink ? POINTER : _lib.BLANKSTRING;
    }

    if (setLink || chartConfig.showtooltip) {
      // Fix for touch devices.
      if (height < HTP) {
        yPos -= (HTP - height) / 2;
        height = HTP;
      } // Setting attributes for the tooltip.


      trackerConfig.attr = {
        x: xPos,
        y: yPos,
        width: columnWidth,
        height: height,
        r: plotRadius,
        cursor: setLink ? POINTER : _lib.BLANKSTRING,
        stroke: TRACKER_FILL,
        'stroke-width': plotBorderThickness,
        fill: TRACKER_FILL,
        'visibility': config.visible ? visibleStr : hiddenStr
      };
    }

    config.props = {
      element: {
        attr: attr
      }
    };
  }
  /**
   * Parses and allocate plot cosmetics and position
   *
   * @memberof HeatMapDataset
   */
  ;

  _proto.allocatePosition = function allocatePosition() {
    var dataSet = this,
        setDataArr = dataSet.config.JSONData.data,
        len,
        i,
        dataStore = dataSet.components.data,
        // eslint-disable-line good-practices/no-single-usage-variable
    dataObj;
    len = setDataArr && setDataArr.length; // eslint-disable-line good-practices/no-single-usage-variable

    for (i = 0; i < len; i++) {
      dataObj = dataStore[i];
      dataSet.parsePlotAttributes(dataObj, i); // dataSet.parseLabelAttributes(dataObj, i);
    }
  }
  /**
   * draws the plot according to the configuration
   */
  ;

  _proto.drawPlots = function drawPlots() {
    var dataSet = this,
        conf = dataSet.config,
        setDataArr = dataSet.config.JSONData.data,
        len,
        i,
        animationManager = dataSet.getFromEnv('animationManager'),
        crispBox,
        dataStore = dataSet.components.data,
        // eslint-disable-line good-practices/no-single-usage-variable
    dataObj,
        setElement,
        setValue,
        config,
        state,
        column,
        row,
        columnid,
        rowid,
        elemIdStore = [],
        // eslint-disable-line good-practices/no-single-usage-variable
    elemId,
        removeDataArrLen = (dataSet.components.removeDataArr || []).length,
        // eslint-disable-line good-practices/no-single-usage-variable
    trackerConfig;
    len = setDataArr && setDataArr.length; // eslint-disable-line good-practices/no-single-usage-variable
    // Create plot elements.

    for (i = 0; i < len; i++) {
      dataObj = dataStore[i];
      trackerConfig = dataObj.trackerConfig;
      config = dataObj && dataObj.config;

      if (!dataObj.graphics) {
        continue;
      }

      state = !dataObj.graphics.element ? 'appearing' : dataSet.getState('visible') ? 'updating' : 'hiding';
      setValue = config.setValue;
      columnid = (0, _lib.getFirstValue)(setDataArr[i].columnid);
      rowid = (0, _lib.getFirstValue)(setDataArr[i].rowid);
      column = dataSet.getFromEnv('xAxis').getCategoryFromId(columnid.toLowerCase());
      row = dataSet.getFromEnv('yAxis').getCategoryFromId(rowid.toLowerCase());

      if (column.index !== 0 && !column.index || row.index !== 0 && !row.index) {
        dataObj.graphics.element = dataObj.graphics.element && animationManager.setAnimation({
          el: dataObj.graphics.element,
          component: dataSet
        });
        continue;
      }

      if ((!column.tickObj || !row.tickObj || config.value === _lib.BLANKSTRING) && dataObj.graphics) {
        dataObj.graphics.element = dataObj.graphics.element && animationManager.setAnimation({
          el: dataObj.graphics.element,
          component: dataSet
        });
      }

      if (!conf.mapByCategory && setValue === null && dataObj.graphics) {
        dataObj.graphics.element && dataObj.graphics.element.hide();
        dataObj.graphics.hotElement && dataObj.graphics.hotElement.hide();
        continue;
      }

      elemId = column.index.toString() + row.index.toString();
      elemIdStore.push(elemId);
      /*
      * If the data plots are not present then they are created, else only attributes are set for the
      * existing plots.
      */

      if (!dataObj.graphics.element) {
        setElement = dataObj.graphics.element = animationManager.setAnimation({
          el: 'rect',
          component: dataSet,
          attr: config.props.element.attr,
          label: 'rect',
          container: dataSet.getContainer('plotGroup')
        });
        config.elemCreated = true;
      } else {
        setElement = dataObj.graphics.element;
        config.elemCreated = false;
        animationManager.setAnimation({
          el: setElement,
          state: state,
          attr: config.props.element.attr,
          component: dataSet
        });
      } // The shadow element is set for the dataplots.


      setElement.shadow({
        opacity: conf.showShadow
      }, dataSet.getContainer('shadowGroup')).data('BBox', crispBox);
      dataSet.getFromEnv('chartConfig').enablemousetracking && setElement.data(EVENTARGS, trackerConfig.eventArgs).data(showHoverEffectStr, conf.showHoverEffect).data(SETROLLOVERATTR, config.setRolloverAttr || {}).data(SETROLLOUTATTR, config.setRolloutAttr || {});
    }

    dataSet.drawn ? dataSet.drawLabel() : dataSet.addJob('labelJob', dataSet.drawLabel.bind(dataSet), _schedular.priorityList.label);
    dataSet.drawn = true;
    removeDataArrLen && dataSet.removeDataElems();
  }
  /**
   * Draws the data labels if any
   */
  ;

  _proto.drawLabel = function drawLabel() {
    var dataSet = this,
        chartConf = dataSet.getFromEnv('chartConfig'),
        smartLabel = dataSet.getFromEnv('smartLabel'),
        animationManager = dataSet.getFromEnv('animationManager'),
        style = chartConf.dataLabelStyle,
        conf = dataSet.config,
        len = (dataSet.config.JSONData.data || []).length,
        // eslint-disable-line good-practices/no-single-usage-variable
    dataStore = dataSet.components.data,
        // eslint-disable-line good-practices/no-single-usage-variable
    dataObj,
        i,
        displayValue,
        graphic,
        textY,
        textX,
        yPos,
        xPos,
        attr,
        dataLabelContainer = dataSet.getContainer('labelGroup'),
        tlLabelContainer = dataSet.graphics.tlLabelContainer,
        blLabelContainer = dataSet.graphics.blLabelContainer,
        trLabelContainer = dataSet.graphics.trLabelContainer,
        brLabelContainer = dataSet.graphics.brLabelContainer,
        plotLabelStyle,
        tlStyle,
        trStyle,
        blStyle,
        brStyle,
        graphicEle,
        pointW,
        pointH,
        pointX,
        pointY,
        smartTextObj,
        tlLabel,
        trLabel,
        blLabel,
        brLabel,
        isTLLabel,
        isTRLabel,
        isBLLabel,
        isBRLabel,
        maxWidth,
        maxHeight,
        config,
        setValue,
        tlLabelCss,
        trLabelCss,
        blLabelCss,
        brLabelCss;
    animationManager.setAnimation({
      el: dataLabelContainer,
      attr: {
        opacity: 1
      },
      component: dataSet,
      label: 'text'
    });

    if (!tlLabelContainer) {
      tlLabelContainer = dataSet.graphics.tlLabelContainer = createGroup({
        name: tlLabelStr
      }, dataLabelContainer, dataSet);
    }

    if (!blLabelContainer) {
      blLabelContainer = dataSet.graphics.blLabelContainer = createGroup({
        name: blLabelStr
      }, dataLabelContainer, dataSet);
    }

    if (!trLabelContainer) {
      trLabelContainer = dataSet.graphics.trLabelContainer = createGroup({
        name: trLabelStr
      }, dataLabelContainer, dataSet);
    }

    if (!brLabelContainer) {
      brLabelContainer = dataSet.graphics.brLabelContainer = createGroup({
        name: brLabelStr
      }, dataLabelContainer, dataSet);
    }

    smartLabel.useEllipsesOnOverflow(chartConf.useEllipsesWhenOverflow);
    smartLabel.setStyle(style);

    for (i = 0; i < len; i++) {
      dataObj = dataStore[i]; // Condition arises when user has removed data in real time update

      if (dataObj === UNDEF) {
        continue;
      }

      graphic = dataObj.graphics; // Condition arises when feedData enters less number of data in a dataset compared to the other.

      if (!graphic) {
        continue;
      }

      config = dataObj && dataObj.config;
      setValue = config.setValue;

      if (!conf.mapByCategory && setValue === null) {
        dataSet.removeLabels(dataObj);
        continue;
      }

      displayValue = config.displayValue;
      graphicEle = dataObj.graphics.element;
      pointW = dataObj._width;
      pointH = dataObj._height;
      pointX = dataObj._xPos;
      pointY = dataObj._yPos; // Setting style for smartLabel

      smartLabel.setStyle(style); // Get the displayValue text from smartlabel

      smartTextObj = smartLabel.getSmartText(displayValue, pointW, pointH, false);
      displayValue = smartTextObj.text;
      plotLabelStyle = config.dataLabelStyle; // Drawing of displayValue

      if (defined(displayValue) && displayValue !== _lib.BLANK && config.showValue) {
        textY = pointY + pointH * 0.5;
        textX = pointX + pointW * 0.5;
        attr = {
          text: displayValue,
          title: smartTextObj.tooltext || _lib.BLANKSTRING,
          visibility: config.visible ? visibleStr : hiddenStr,
          fill: plotLabelStyle.color,
          direction: config.textDirection,
          x: textX,
          y: textY,
          cursor: config.setLink ? POINTER : _lib.BLANKSTRING,
          'text-bound': [plotLabelStyle.backgroundColor, plotLabelStyle.borderColor, style.borderThickness, style.borderPadding, style.borderRadius, style.borderDash]
        };

        if (graphicEle) {
          dataObj.graphics.valEle = animationManager.setAnimation({
            el: dataObj.graphics.valEle || 'text',
            container: dataLabelContainer,
            component: dataSet,
            label: 'text',
            attr: attr
          });
          dataObj.graphics.valEle.outlineText(conf.showTextOutLine, attr.fill);
        } else {
          if (dataObj.graphics.valEle) {
            dataObj.graphics.valEle = animationManager.setAnimation({
              el: dataObj.graphics.valEle,
              component: dataSet
            });
          }
        }

        tlLabel = config.tlLabel;
        trLabel = config.trLabel;
        blLabel = config.blLabel;
        brLabel = config.brLabel;
        tlStyle = config.tlLabelStyle;
        trStyle = config.trLabelStyle;
        blStyle = config.blLabelStyle;
        brStyle = config.brLabelStyle;
        isTLLabel = defined(tlLabel) && tlLabel !== _lib.BLANK;
        isTRLabel = defined(trLabel) && trLabel !== _lib.BLANK;
        isBLLabel = defined(blLabel) && blLabel !== _lib.BLANK;
        isBRLabel = defined(brLabel) && brLabel !== _lib.BLANK;
        maxWidth = pointW * (isTLLabel && isTRLabel ? POINT_FIVE : MAX_PERCENT_SPACE);
        maxHeight = (pointH - (smartTextObj && smartTextObj.height || 0)) * 0.5; // For top labels

        yPos = pointY + GUTTER_4;

        if (isTLLabel) {
          // Setting style for smartLabel
          smartLabel.setStyle(tlStyle);
          smartTextObj = smartLabel.getSmartText(tlLabel, maxWidth, maxHeight, false);
          displayValue = smartTextObj.text; // Get the x and y position of the dataValue

          xPos = pointX;
          attr = {
            text: displayValue,
            title: smartTextObj.tooltext || _lib.BLANKSTRING,
            visibility: config.visible ? visibleStr : hiddenStr,
            fill: tlStyle.color,
            'font-family': tlStyle.fontFamily,
            'font-weight': tlStyle.fontWeight,
            'line-height': tlStyle.lineHeight,
            'font-size': tlStyle.fontSize,
            'text-anchor': POSITION_START,
            'vertical-align': POSITION_TOP,
            direction: config.textDirection,
            x: xPos + GUTTER_4,
            y: yPos,
            'text-bound': [tlStyle.backgroundColor, tlStyle.borderColor, tlStyle.borderThickness, tlStyle.borderPadding, tlStyle.borderRadius, tlStyle.borderDash]
          };
          tlLabelCss = Object.assign(attr, tlStyle);
          dataObj.graphics.tlLabel = animationManager.setAnimation({
            el: dataObj.graphics.tlLabel || 'text',
            component: dataSet,
            attr: tlLabelCss,
            container: tlLabelContainer
          });
          dataObj.graphics.tlLabel.outlineText(conf.showTextOutLine, tlLabelCss.fill);
        } else {
          if (dataObj.graphics.tlLabel) {
            dataObj.graphics.tlLabel = animationManager.setAnimation({
              el: dataObj.graphics.tlLabel,
              component: dataSet
            });
          }
        }

        if (isTRLabel) {
          // Setting style for smartRabel
          smartLabel.setStyle(trStyle);
          smartTextObj = smartLabel.getSmartText(trLabel, maxWidth, maxHeight, false);
          displayValue = smartTextObj.text; // Get the x and y position of the dataValue

          xPos = pointX + pointW;
          attr = {
            text: displayValue,
            title: smartTextObj.tooltext || _lib.BLANKSTRING,
            visibility: config.visible ? visibleStr : hiddenStr,
            fill: trStyle.color,
            'font-family': trStyle.fontFamily,
            'font-weight': trStyle.fontWeight,
            'line-height': trStyle.lineHeight,
            'font-size': trStyle.fontSize,
            'text-anchor': POSITION_END,
            'vertical-align': POSITION_TOP,
            direction: config.textDirection,
            x: xPos - GUTTER_4,
            y: yPos,
            'text-bound': [trStyle.backgroundColor, trStyle.borderColor, trStyle.borderThickness, trStyle.borderPadding, trStyle.borderRadius, trStyle.borderDash]
          };
          trLabelCss = Object.assign(attr, trStyle);
          dataObj.graphics.trLabel = animationManager.setAnimation({
            el: dataObj.graphics.trLabel || 'text',
            attr: trLabelCss,
            container: trLabelContainer,
            component: dataSet
          });
          dataObj.graphics.trLabel.outlineText(conf.showTextOutLine, trLabelCss.fill);
        } else {
          if (dataObj.graphics.trLabel) {
            dataObj.graphics.trLabel = animationManager.setAnimation({
              el: dataObj.graphics.trLabel,
              component: dataSet
            });
          }
        } // For top labels


        yPos = pointY + pointH - GUTTER_4;

        if (isBLLabel) {
          // Setting style for smartLabel
          smartLabel.setStyle(blStyle);
          smartTextObj = smartLabel.getSmartText(blLabel, maxWidth, maxHeight, false);
          displayValue = smartTextObj.text; // Get the x and y position of the dataValue

          xPos = pointX;
          attr = {
            text: displayValue,
            title: smartTextObj.tooltext || _lib.BLANKSTRING,
            visibility: config.visible ? visibleStr : hiddenStr,
            fill: blStyle.color,
            'font-family': blStyle.fontFamily,
            'font-weight': blStyle.fontWeight,
            'line-height': blStyle.lineHeight,
            'font-size': blStyle.fontSize,
            'text-anchor': POSITION_START,
            'vertical-align': POSITION_BOTTOM,
            direction: config.textDirection,
            x: xPos + GUTTER_4,
            y: yPos,
            'text-bound': [blStyle.backgroundColor, blStyle.borderColor, blStyle.borderThickness, blStyle.borderPadding, blStyle.borderRadius, blStyle.borderDash]
          };
          blLabelCss = Object.assign(attr, blStyle);
          dataObj.graphics.blLabel = animationManager.setAnimation({
            el: dataObj.graphics.blLabel || 'text',
            component: dataSet,
            container: blLabelContainer,
            attr: blLabelCss
          });
          dataObj.graphics.blLabel.outlineText(conf.showTextOutLine, blLabelCss.fill);
        } else {
          if (dataObj.graphics.blLabel) {
            dataObj.graphics.blLabel = animationManager.setAnimation({
              el: dataObj.graphics.blLabel,
              component: dataSet
            });
          }
        }

        if (isBRLabel) {
          // Setting style for smartRabel
          smartLabel.setStyle(blStyle);
          smartTextObj = smartLabel.getSmartText(brLabel, maxWidth, maxHeight, false);
          displayValue = smartTextObj.text; // Get the x and y position of the dataValue

          xPos = pointX + pointW - GUTTER_4;
          attr = {
            text: displayValue,
            title: smartTextObj.tooltext || _lib.BLANKSTRING,
            visibility: config.visible ? visibleStr : hiddenStr,
            fill: brStyle.color,
            'font-family': brStyle.fontFamily,
            'font-weight': brStyle.fontWeight,
            'line-height': brStyle.lineHeight,
            'font-size': brStyle.fontSize,
            'text-anchor': POSITION_END,
            'vertical-align': POSITION_BOTTOM,
            direction: config.textDirection,
            x: xPos,
            y: yPos,
            'text-bound': [brStyle.backgroundColor, brStyle.borderColor, brStyle.borderThickness, brStyle.borderPadding, brStyle.borderRadius, brStyle.borderDash]
          };
          brLabelCss = Object.assign(attr, brStyle);
          dataObj.graphics.brLabel = animationManager.setAnimation({
            el: dataObj.graphics.brLabel || 'text',
            attr: brLabelCss,
            container: brLabelContainer,
            component: dataSet
          });
          dataObj.graphics.brLabel.outlineText(conf.showTextOutLine, brLabelCss.fill);
        } else {
          if (dataObj.graphics.brLabel) {
            dataObj.graphics.brLabel = animationManager.setAnimation({
              el: dataObj.graphics.brLabel,
              component: dataSet
            });
          }
        }
      } else {
        dataSet.removeLabels(dataObj);
      }
    }

    dataSet.labelDrawn = true;
  };

  _proto.removeLabels = function removeLabels(dataObj) {
    var dataSet = this,
        animationManager = dataSet.getFromEnv('animationManager');

    if (dataObj.graphics.valEle) {
      dataObj.graphics.valEle = animationManager.setAnimation({
        el: dataObj.graphics.valEle,
        component: dataSet
      });
    }

    if (dataObj.graphics.tlLabel) {
      dataObj.graphics.tlLabel = animationManager.setAnimation({
        el: dataObj.graphics.tlLabel,
        component: dataSet
      });
    }

    if (dataObj.graphics.trLabel) {
      dataObj.graphics.trLabel = animationManager.setAnimation({
        el: dataObj.graphics.trLabel,
        component: dataSet
      });
    }

    if (dataObj.graphics.blLabel) {
      dataObj.graphics.blLabel = animationManager.setAnimation({
        el: dataObj.graphics.blLabel,
        component: dataSet
      });
    }

    if (dataObj.graphics.brLabel) {
      dataObj.graphics.brLabel = animationManager.setAnimation({
        el: dataObj.graphics.brLabel,
        component: dataSet
      });
    }
  }
  /**
   * Function to remove data elements
   */
  ;

  _proto.removeDataElems = function removeDataElems() {
    var dataSet = this,
        components = dataSet.components,
        removeDataArr = components.removeDataArr,
        pool = components.pool || (components.pool = {
      element: [],
      hotElement: [],
      label: []
    }),
        len = removeDataArr.length,
        // eslint-disable-line good-practices/no-single-usage-variable
    removeData,
        ele,
        graphics,
        i;

    for (i = 0; i < len; i++) {
      removeData = removeDataArr[0];
      removeDataArr.splice(0, 1); // In case of non existing data plot continue;

      if (!removeData || !removeData.graphics) {
        continue;
      }

      graphics = removeData.graphics;

      for (ele in graphics) {
        // Stopping any previous animation.
        if (graphics[ele]) {
          graphics[ele] = dataSet.getFromEnv('animationManager').setAnimation({
            el: graphics[ele],
            component: dataSet
          });
        }
      } // Storing the graphic elements for reuse.


      removeData.graphics.element && (pool.element = pool.element.concat(removeData.graphics.element));
      removeData.graphics.hotElement && (pool.hotElement = pool.hotElement.concat(removeData.graphics.hotElement));
      removeData.graphics.label && (pool.label = pool.label.concat(removeData.graphics.label));
    }

    components.pool = pool;
  }
  /**
   * @returns {number} axis value padding
   */
  ;

  _proto.getAxisValuePadding = function getAxisValuePadding() {
    return this.config.defaultPadding;
  }
  /**
   * Function to get the maximum and minimum from dataset
   * @return {Object}     contains max, min value
   */
  ;

  _proto.getDataLimits = function getDataLimits() {
    var dataSet = this,
        dataStore = dataSet.components.data,
        conf = dataSet.config,
        i,
        config,
        len = dataStore.length,
        // eslint-disable-line good-practices/no-single-usage-variable
    setValue,
        maxValue = -Infinity,
        minValue = +Infinity;

    for (i = 0; i < len; i++) {
      if (!dataStore[i] || !Object.keys(dataStore[i]).length) {
        continue;
      }

      config = dataStore[i].config;
      setValue = config.setValue;

      if (setValue !== UNDEF && setValue !== null) {
        maxValue = mathMax(maxValue, setValue);
        minValue = mathMin(minValue, setValue);
      }
    }

    conf.maxValue = maxValue;
    conf.minValue = minValue;
    return {
      max: conf.maxValue,
      min: conf.minValue
    };
  }
  /**
   * function to Remove data plots if the number of current data plots/categories
   * is more than the existing ones.
   * @param  {Object} datasetJSON JSON for dataset configurations
   */
  ;

  _proto.trimData = function trimData(datasetJSON) {
    if (!this.config.JSONData) {
      return;
    }

    var dataSet = this,
        config = dataSet.config,
        context = config && config.context,
        prevCatlen = context && context.prevCatlen,
        // eslint-disable-line good-practices/no-single-usage-variable
    currCatLen = dataSet.getFromEnv('xAxis').getTicksLen(),
        catDiff = prevCatlen - currCatLen,
        prevData = config.JSONData,
        prevDataLength = prevData.data && prevData.data.length,
        // eslint-disable-line good-practices/no-single-usage-variable
    currDataLength = datasetJSON.data && datasetJSON.data.length || 0,
        dataDiff = prevDataLength - currDataLength,
        diff,
        startIndex;

    if (catDiff > dataDiff) {
      diff = catDiff;
      startIndex = currCatLen;
    } else {
      diff = dataDiff;
      startIndex = currDataLength;
    } // Removing data plots if the number of current data plots/categories
    // is more than the existing ones.


    if (diff > 0) {
      this.removeData(startIndex, diff, false);
    }
  }
  /**
   * Function for drawing 2D columns.
   * This function is called every time for each dataset when they are initially drawn or shown/hidden from
   * the drawGraph() function.
   */
  ;

  _proto.draw = function draw() {
    var dataSet = this,
        xAxis = dataSet.getFromEnv('xAxis'),
        groupMaxWidth = dataSet.getFromEnv('groupMaxWidth');

    if (!groupMaxWidth) {
      groupMaxWidth = mathAbs(xAxis.getPixel(1) - xAxis.getPixel(0));
      dataSet.addToEnv('groupMaxWidth', groupMaxWidth);
    }

    !dataSet.config.drawn && dataSet.createContainer();

    if (!xAxis.getState('scrolling')) {
      dataSet.createCoordinates();
    } // Draw all the graphic elements


    dataSet.drawPlots(); // dataSet.updatePlot(conf.minValue, conf.maxValue);
  };

  _proto.createContainer = function createContainer() {
    var dataset = this,
        parent = dataset.getLinkedParent(),
        group = dataset.groupName || dataset.dsGroup || dataset.getType(),
        parentContainer,
        parentShadowContainer;
    !parent.getChildContainer(group + 'VcanvasGroup') && (group = 'default');
    parentContainer = parent.getChildContainer(group + 'VcanvasGroup');
    parentShadowContainer = parent.getChildContainer(group + 'ShadowVcanvasGroup');
    !dataset.getContainer('shadowGroup') && dataset.addContainer('shadowGroup', createGroup({
      name: 'shadow-group'
    }, parentShadowContainer, dataset));
    !dataset.getContainer('errorShadowGroup') && dataset.addContainer('errorShadowGroup', createGroup({
      name: 'error-shadow-group'
    }, parentShadowContainer, dataset));
    !dataset.getContainer('commonElemsGroup') && dataset.addContainer('commonElemsGroup', createGroup({
      name: 'common-elems-group'
    }, parentContainer, dataset));
    !dataset.getContainer('plotGroup') && dataset.addContainer('plotGroup', createGroup({
      name: 'plot-group'
    }, parentContainer, dataset));
    !dataset.getContainer('errorPlotGroup') && dataset.addContainer('errorPlotGroup', createGroup({
      name: 'error-plot-group'
    }, parentContainer, dataset));
    dataset.getFromEnv('chart').hasAnchor && dataset.getContainer('errorPlotGroup').insertBefore(dataset.getContainer('plotGroup'));
    !dataset.getContainer('labelGroup') && dataset.addContainer('labelGroup', createGroup({
      name: 'label-group',
      'class': 'fusioncharts-datalabels'
    }, parent.getChildContainer('vcanvasLabelGroup'), dataset));
  }
  /**
   * Create pixel coordinates for the plots
   */
  ;

  _proto.createCoordinates = function createCoordinates() {
    var dataSet = this,
        chart = dataSet.getFromEnv('chart'),
        isBar = chart.isBar,
        yAxis = dataSet.getFromEnv('yAxis'),
        xAxis = dataSet.getFromEnv('xAxis'),
        yBasePos = yAxis.getPixel(yAxis.getAxisBase()),
        // eslint-disable-line good-practices/no-single-usage-variable
    dataObj,
        config,
        previousY,
        i,
        Px,
        Py,
        Pb,
        xDepth = chart.config.xDepth || 0,
        yDepth = chart.config.yDepth || 0,
        len = dataSet.components.data.length,
        // eslint-disable-line good-practices/no-single-usage-variable
    groupManager = dataSet.getLinkedParent(),
        stackConf = groupManager.getstackConf && groupManager.getstackConf(),
        dataStore = dataSet.components.data; // eslint-disable-line good-practices/no-single-usage-variable

    !isBar && (xDepth = -xDepth);
    isBar && (yDepth = -yDepth);

    for (i = 0; i < len; i++) {
      dataObj = dataStore[i];
      config = dataObj && dataObj.config;

      if (dataObj === UNDEF) {
        continue;
      }

      previousY = config._b;
      Px = xAxis.getPixel(stackConf && stackConf[i].x || config._x) + xDepth;
      Py = yAxis.getPixel(config._y) + yDepth;
      Pb = (previousY ? yAxis.getPixel(previousY) : yBasePos) + yDepth;

      if (xAxis.config.isVertical) {
        config._Px = Py;
        config._Py = Px;
        config._Pby = Px;
        config._Pbx = Pb;
      } else {
        config._Px = Px;
        config._Py = Py;
        config._Pby = Pb;
        config._Pbx = Px;
      }

      if (dataSet.getLineShift) {
        config._Py += dataSet.getLineShift('y');
      }
    }
  }
  /**
   * Helper function of _firePlotEvent which decides single/consolidated tooltip
   * @param {number} plotIndex      plot index
   * @param {Object} e              reference of the original mouse event
   * @param {Object} datasets            column datasets
   */
  ;

  _proto._decideTooltipType = function _decideTooltipType(plotIndex, e) {
    var dataset = this,
        drawTrendRegion = dataset.getFromEnv('chartConfig').drawTrendRegion,
        toolTipController = dataset.getFromEnv('toolTipController'),
        data = dataset.components.data[plotIndex],
        toolText = data && (data.config.finalTooltext || data.config.toolText),
        element = data && (data.graphics.element || dataset.graphics.sharedAnchor.element),
        // eslint-disable-line good-practices/no-single-usage-variable
    currentToolTip = dataset.config.currentToolTip,
        originalEvent = e.originalEvent;

    if (drawTrendRegion && element) {
      dataset.config.currentToolTip = dataset.getLinkedParent()._drawTooltip(plotIndex, dataset.config.index, originalEvent, currentToolTip);
    } else if (toolText && !drawTrendRegion) {
      if (currentToolTip) {
        toolTipController.draw(originalEvent, toolText, currentToolTip);
      } else {
        currentToolTip = dataset.config.currentToolTip = toolTipController.draw(originalEvent, toolText);
      }
    }
  }
  /**
   * This method handles all mouse events of an dataset.
   * @param {string} eventType    name of the event
   * @param {number} plotIndex    index of the plot where this event has been occured
   * @param {Event}  e            reference of the original mouse event
   * @param {Event}  datasets     column dataset
   */
  ;

  _proto._firePlotEvent = function _firePlotEvent(eventType, plotIndex, e) {
    var dataset = this,
        chart = dataset.getFromEnv('chart'),
        data = dataset.components.data[plotIndex],
        setElement = data.graphics.element,
        labelElement = data.graphics.label,
        // originalEvent = e.originalEvent,
    config,
        setLink;

    if (setElement) {
      config = data.config;
      setLink = config.setLink;

      switch (eventType) {
        case 'fc-mouseover':
          dataset._decideTooltipType(plotIndex, e);

          _rolloverResponseSetter(chart, data, e, UNDEF, dataset);

          if (setLink) {
            setElement.css({
              'cursor': POINTER
            }); // labelElement is undefined in dataset graphics so checking for labelElement added

            labelElement && labelElement.css({
              'cursor': POINTER
            });
          }

          break;

        case 'fc-mouseout':
          dataset.getFromEnv('toolTipController').hide(dataset.config.currentToolTip);

          _rolloutResponseSetter(chart, data, e, UNDEF, dataset);

          if (setLink) {
            setElement.css({
              'cursor': DEFAULT_CURSOR
            }); // labelElement is undefined in dataset graphics so checking for labelElement added

            labelElement && labelElement.css({
              'cursor': DEFAULT_CURSOR
            });
          }

          break;

        case 'fc-click':
          chart.plotEventHandler(setElement, e);
          break;

        case 'fc-mousemove':
          dataset._decideTooltipType(plotIndex, e);

      }
    }
  }
  /**
   * Function to remove a data with a given index.
   * @param {number}  indexVal     from which index data would be removed
   * @param {number}  stretchVal   delete count
   * @param {boolean} draw      whether draw or not
   */
  ;

  _proto.removeData = function removeData(indexVal, stretchVal, draw) {
    var dataSet = this,
        index = indexVal,
        stretch = stretchVal,
        components = dataSet.components,
        dataStore = components.data,
        removeDataArr = components.removeDataArr || (components.removeDataArr = []),
        conf = dataSet.config,
        i,
        config,
        len,
        maxminFlag = dataSet.maxminFlag;
    stretch === UNDEF && (stretch = 1);
    index = index || 0; // Storing the direction of input data for the type of animation to be done during remove.

    if (index + stretch === dataStore.length || !dataSet.getFromEnv('chart').isRealTime) {
      dataSet.endPosition = true;
    } else if (index === 0 || index === UNDEF) {
      dataSet.endPosition = false;
    }

    components.removeDataArr = removeDataArr = removeDataArr.concat(dataStore.splice(index, stretch));
    len = removeDataArr.length;

    for (i = len - 1; i >= 0; i--) {
      if (!removeDataArr[i]) {
        removeDataArr.splice(i, 1);
        continue;
      }

      config = removeDataArr[i].config;

      if (config.setValue === conf.maxValue || config.setValue === conf.minValue) {
        maxminFlag = dataSet.maxminFlag = true;
      } // Update the x position for this removed elements outside of the canvas


      config._x -= stretch;

      if (maxminFlag) {
        break;
      }
    }

    dataSet.removeDataLen = len;
    dataSet.resetCatPos && dataSet.resetCatPos();
    maxminFlag && dataSet.getDataLimits && dataSet.getDataLimits();
    draw && dataSet.asyncDraw();
  };

  return HeatMapDataset;
}(_componentInterface.ComponentInterface);

HeatMapDataset.prototype._configureDataLabelStyle = _lib.configureDataLabelStyle;
var _default = HeatMapDataset;
exports["default"] = _default;

/***/ }),

/***/ 1366:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _index = _interopRequireDefault(__webpack_require__(619));

var _default = {
  '*.dataset.kagi': _index.default['*.dataset.line']
};
exports["default"] = _default;

/***/ }),

/***/ 1365:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _line = _interopRequireDefault(__webpack_require__(616));

var _lib = __webpack_require__(274);

var _dependencyManager = __webpack_require__(282);

var _index = _interopRequireDefault(__webpack_require__(1366));

var POSITION_TOP = 'top',
    POSITION_BOTTOM = 'bottom',
    POSITION_MIDDLE = 'middle',
    POSITION_RIGHT = 'right',
    ROUND = 'round',
    UNDEF,
    EVENTARGS = 'eventArgs',
    SETROLLOVERATTR = 'setRolloverAttr',
    SETROLLOUTATTR = 'setRolloutAttr',
    defined = function defined(obj) {
  return obj !== UNDEF && obj !== null;
},
    M = 'M',
    H = 'H',
    V = 'V',
    GUTTER_4 = 4,
    GUTTER_2 = 2,
    CENTER = 'center',
    HTP = _lib.hasTouch ? _lib.TOUCH_THRESHOLD_PIXELS : _lib.CLICK_THRESHOLD_PIXELS,
    NONE = 'none';

(0, _dependencyManager.addDep)({
  name: 'kagiAnimation',
  type: 'animationRule',
  extension: _index.default
});

var KagiDataset = /*#__PURE__*/function (_LineDataset) {
  (0, _inheritsLoose2.default)(KagiDataset, _LineDataset);

  function KagiDataset() {
    var _this;

    _this = _LineDataset.call(this) || this;
    _this.manageSpace = _lib.stubFN;
    _this.drawCommonElements = _lib.stubFN;
    return _this;
  }
  /**
   * Sets the type of the component
   * @return {string} type
   */


  var _proto = KagiDataset.prototype;

  _proto.getType = function getType() {
    return 'dataset';
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */
  ;

  _proto.getName = function getName() {
    return 'kagi';
  };

  _proto._parseShadowOptions = function _parseShadowOptions() {
    var dataSet = this,
        chartAttr = dataSet.getFromEnv('chart').getFromEnv('dataSource').chart; // eslint-disable-line good-practices/no-single-usage-variable

    return {
      opacity: (0, _lib.pluckNumber)(chartAttr.showshadow, 1) ? dataSet.config.alpha / 100 : 0
    };
  };

  _proto.configureAttributes = function configureAttributes(datasetJSON) {
    _LineDataset.prototype.configureAttributes.call(this, datasetJSON);

    var dataSetComponents,
        datasetObj = this,
        removeDataArr,
        chart = datasetObj.getFromEnv('chart'),
        // eslint-disable-line good-practices/no-single-usage-variable
    temp = 0,
        data,
        catArr = [],
        series,
        JSONData,
        FCChartObj,
        isRallyInitialised,
        shiftCounter,
        reversalValue,
        reversalPercentage,
        rallyDashLen,
        rallyDashGap,
        declineDashLen,
        declineDashGap,
        lastPlotValue,
        setShowLabel,
        length,
        index,
        fcIndex,
        fcDataObj,
        lastShift,
        prevDataObj,
        plotValue,
        dataObj,
        nextDataValue,
        valueDifference,
        dataValue,
        isRally,
        lastLow,
        lastHigh,
        isMovingUp,
        isShift,
        checkValue,
        t,
        count = 0,
        vAlign,
        // canvasPadding,
    align;
    dataSetComponents = datasetObj.components;
    data = dataSetComponents.data;
    series = datasetObj.config;
    JSONData = datasetObj.config.JSONData.data;
    FCChartObj = chart.getFromEnv('dataSource').chart;
    removeDataArr = dataSetComponents.removeDataArr || (dataSetComponents.removeDataArr = []); // eslint-disable-line good-practices/no-single-usage-variable
    // First vertical point for shift is yet to be obtained

    isRallyInitialised = false; // Initialised to one to avoid zero dividing the width of the canvas
    // (as the case may be) to get the xShiftLength

    shiftCounter = 0; // eslint-disable-line good-practices/no-single-usage-variable
    // The value which determines whether to make a horizontal shift
    // to deal with the next point

    reversalValue = (0, _lib.pluckNumber)(FCChartObj.reversalvalue, -1); // The percentage of the range of values, which determines whether
    // to make a horizontal shift to deal with the next point

    reversalPercentage = (0, _lib.pluckNumber)(FCChartObj.reversalpercentage, 5); // eslint-disable-line good-practices/no-single-usage-variable

    for (index = 0; index < data.length; index += 1) {
      data[index].config.__nullCount = count;

      if (data[index].config.setValue === null) {
        removeDataArr.push(data.splice(index, 1)[0]);
        count++;
        index -= 1;
      }
    }

    if (data.length) {
      // Color of line denoting rally
      series.rallyColor = (0, _lib.pluck)(FCChartObj.rallycolor, 'FF0000');
      series.rallyAlpha = (0, _lib.pluckNumber)(FCChartObj.rallyalpha, FCChartObj.linealpha, 100); // color of line denoting decline

      series.declineColor = (0, _lib.pluck)(FCChartObj.declinecolor, '0000FF');
      series.declineAlpha = (0, _lib.pluckNumber)(FCChartObj.declinealpha, FCChartObj.linealpha, 100); // Default canvasPadding is 15.

      series.canvasPadding = (0, _lib.pluckNumber)(FCChartObj.canvaspadding, 15); // The maximum horizontal shift in percentage of the
      // available canvas width

      series.maxHShiftPercent = (0, _lib.pluckNumber)(FCChartObj.maxhshiftpercent, 10); // effectiveCanvasWidth = canvasWidth - canvasPadding * 2;
      // Thickness of line denoting rally

      series.rallyThickness = (0, _lib.pluckNumber)(FCChartObj.rallythickness, FCChartObj.linethickness, 2); // length of the dash

      rallyDashLen = (0, _lib.pluckNumber)(FCChartObj.rallydashlen, FCChartObj.linedashlen, 5); // distance between dash

      rallyDashGap = (0, _lib.pluckNumber)(FCChartObj.rallydashgap, FCChartObj.linedashgap, 4); // Thickness of line denoting decline

      series.declineThickness = (0, _lib.pluckNumber)(FCChartObj.declinethickness, FCChartObj.linethickness, 2); // length of the dash

      declineDashLen = (0, _lib.pluckNumber)(FCChartObj.declinedashlen, FCChartObj.linedashlen, 5); // distance between dash

      declineDashGap = (0, _lib.pluckNumber)(FCChartObj.declinedashgap, FCChartObj.linedashgap, 4);
      series.lineDashed = {
        'true': (0, _lib.pluckNumber)(FCChartObj.rallydashed, FCChartObj.linedashed, 0),
        'false': (0, _lib.pluckNumber)(FCChartObj.declinedashed, FCChartObj.linedashed, 0)
      }; // Storing dashStyle in series to be use while drawing graph and

      series.rallyDashed = (0, _lib.pluckNumber)(FCChartObj.rallydashed, FCChartObj.linedashed, 0) ? (0, _lib.getDashStyle)(rallyDashLen, rallyDashGap) : NONE;
      series.declineDashed = (0, _lib.pluckNumber)(FCChartObj.declinedashed, FCChartObj.linedashed, 0) ? (0, _lib.getDashStyle)(declineDashLen, declineDashGap) : NONE; // canvasPadding to be use by Kagi chart Drawing

      series.canvasPadding = (0, _lib.pluckNumber)(FCChartObj.canvaspadding, this.canvasPadding, 15); // setting the reversal value

      reversalValue = reversalValue > 0 ? reversalValue : reversalPercentage * (series.maxValue - series.minValue) / 100; // Initialised by the first data value

      lastPlotValue = data[0].config.setValue; // Local function to set anchor and value visibility of
      // unwanted points, after the first point is found to draw
      // vertical kagi line

      setShowLabel = function setShowLabel(id, _isRally) {
        // Initial data value
        var dataXValue,
            r = 1,
            data1Value = data[0].config.setValue; // Looping to check for unwanted points

        while (r < id) {
          // Value of point under check
          dataXValue = data[r].config.setValue; // If current trend is rally

          if (_isRally) {
            if (dataXValue <= data1Value) {
              data[r].config.isDefined = false;
            } // Else current trend is decline

          } else {
            if (dataXValue >= data1Value) {
              data[r].config.isDefined = false;
            }
          }

          r += 1;
        } // Setting alignment of value for the first data


        data[0].config.vAlign = _isRally ? POSITION_BOTTOM : POSITION_TOP;
        data[0].config.align = CENTER;
      };

      length = JSONData.length; // iterating to set values of properties in data for each respective
      // point (main algorithm of KagiChart)
      // loop counter starts from 2 since data for plot 1 is unique

      for (index = 0, fcIndex = 0; fcIndex < length; fcIndex += 1, index += 1) {
        fcDataObj = JSONData[fcIndex]; // Calculation of vLine based on hShift.

        if (fcDataObj && fcDataObj.vline) {
          continue;
        }

        dataObj = data[index] && data[index].config; // lastFcDataObj = JSONData[fcIndex];
        // Special handling for vLines

        if (lastShift) {
          lastShift = false; // vLinePosition += 0.5;
        }

        dataObj && (dataObj.isDefined = true);

        if (index && dataObj) {
          dataObj.isShift = UNDEF;
          prevDataObj = data[index - 1].config;
          dataObj.vAlign = POSITION_MIDDLE;
          dataObj.align = POSITION_RIGHT;
          dataObj.showLabel = false; // initialised to null each time

          plotValue = null; // data value of plot under current loop

          dataValue = dataObj.setValue; // data value of previous plot
          // lastDataValue = data[i-1].y;
          // data value of next plot

          nextDataValue = data[index + 1] && data[index + 1].config.setValue;
          valueDifference = Math.abs(lastPlotValue - dataValue); // if current plot is yet render the trend,then care is taken
          // to make few initial assumptions as algorithm starts with it

          if (!isRallyInitialised) {
            // if current plot is higher than the last plotted one
            // (first data) by significant amount
            if (dataValue > lastPlotValue && valueDifference > reversalValue) {
              // is assumed to be true
              isRally = true; // value of last low point of swing (assumed)

              lastLow = lastPlotValue; // none assumed

              lastHigh = null; // kagi rising

              isMovingUp = true; // first vertical point for shift is obtained

              isRallyInitialised = true; // call of local function to set visibility false for
              // anchors and values of unwanted points

              setShowLabel(index, isRally); // if current plot is lower than the last plotted one
              // (first data) by significant amount
            } else if (dataValue < lastPlotValue && valueDifference > reversalValue) {
              // is assumed to be false
              isRally = false; // none assumed

              lastLow = null; // value of last high point of swing (assumed)

              lastHigh = lastPlotValue; // kagi falling

              isMovingUp = false; // first vertical point for shift is obtained

              isRallyInitialised = true; // call of local function to set visibility false for
              // anchors and values of unwanted points

              setShowLabel(index, isRally); // else, point under loop is not significant to
              // draw the first vertical kagi line to
            } else {
              // is set to null
              isRally = null; // vertical shifting direction is set to null

              isMovingUp = null; // first vertical point for shift is yet to be obtained

              isRallyInitialised = false;
            } // trend property for plot 1 is set


            if (defined(prevDataObj)) {
              prevDataObj.isRally = isRally;
            }

            if (isRally !== null) {
              // to get the initial horizontal line in trend color
              // (in case data[1].value = data[2].value=... so on or not)
              data[0].config.isRally = isRally;
            } // else, for plot 3 and above, only trend is evaluated

          } else {
            // setting trends by concept of Kagi Chart
            if (dataValue < lastLow && isRally) {
              isRally = false;
            } else if (dataValue > lastHigh && !isRally) {
              isRally = true;
            } // else isRally remains unchanged

          } // Setting in data for the plot


          dataObj.isRally = isRally; // To check for having horizontal shift or not,
          // we need to use the pertinent value

          if (isMovingUp && dataValue < lastPlotValue || !isMovingUp && dataValue > lastPlotValue) {
            plotValue = lastPlotValue;
          } // To find if there is a horizontal shift associated
          // with this plot


          checkValue = plotValue || dataValue;
          valueDifference = Math.abs(checkValue - nextDataValue); // if the line is static till now

          if (isMovingUp === null) {
            isShift = null; // if the line is rising
          } else if (isMovingUp) {
            isShift = checkValue > nextDataValue && valueDifference >= reversalValue; // else if the line is falling
          } else {
            isShift = checkValue < nextDataValue && valueDifference >= reversalValue;
          } // To get the last extremes preceding the current point
          // and setting the vertical/horizontal
          // alignment of the value to be shown for it.


          if (prevDataObj && prevDataObj.isShift) {
            if (isMovingUp) {
              lastLow = lastPlotValue;
              vAlign = POSITION_BOTTOM;
            } else if (!isMovingUp) {
              lastHigh = lastPlotValue;
              vAlign = POSITION_TOP;
            }

            align = CENTER; // looping to get the actual plot corresponding to the
            // maxima/minima and setting label properties for the same

            for (t = index; t > 1; t -= 1) {
              if (data[t].y === lastPlotValue) {
                data[t].vAlign = vAlign;
                data[t].align = align;
                data[t].showLabel = true; // extreme obtained and thus stop looping

                break;
              }
            }
          } // if there is a horizontal shift, then


          if (isShift) {
            // updating counter to have to total number of horizontal
            // shifts in the total plot.This is vital for calculation
            // of the length of each horizontal shifts.
            shiftCounter += 1; // vLinePosition += 0.5;

            lastShift = true; // updating the flag by reversing the boolean
            // value of the flag itself

            isMovingUp = !isMovingUp; // setting in data for the plot, to be used for
            // drawing the graph

            dataObj.isShift = true; // updating last plotting value

            lastPlotValue = checkValue;
            catArr.push(JSONData[index + dataObj.__nullCount]);
            temp = datasetObj._appendCategory(temp, index, catArr, 0);
          } else if (isMovingUp && dataValue > lastPlotValue || !isMovingUp && dataValue < lastPlotValue) {
            // updating last plotting value
            lastPlotValue = dataValue; // if cuurent data value is to be skipped for plotting
          } else {
            // setting the value to be plotted
            // (virtually drawing pen stays still due to this)
            plotValue = lastPlotValue;
          } // plotValue assigned is either defined or set to null


          dataObj.plotValue = plotValue; // few local variables are bundled together in an object to be
          // used later-on to work around a Catch-22 problem

          dataObj.objParams = {
            isRally: isRally,
            lastHigh: lastHigh,
            lastLow: lastLow,
            isRallyInitialised: isRallyInitialised
          };
        }
      } // insert if any remaining categories to be appended.


      datasetObj._appendCategory(temp, index, catArr, 1); // insert the categories before setting the final category.


      catArr.push(fcDataObj);
      datasetObj.getFromEnv('xAxis').setTickValues(catArr);
      series.shiftCount = shiftCounter + 1;
    }
  };

  _proto._appendCategory = function _appendCategory(tempData, index, catArr, lineposition) {
    var i,
        catObj,
        temp = tempData,
        catData,
        refIndex,
        catOnlyData = this.config.JSONData.catData;

    if (temp < catOnlyData.length) {
      for (i = temp; i < catOnlyData.length; i += 1, temp = i) {
        catObj = catOnlyData[i];
        catData = catObj.data;
        refIndex = catObj.index - (i + 1);

        if (refIndex < index) {
          catData.lineposition = (0, _lib.pluckNumber)(catData.lineposition, lineposition);
        } else if (refIndex > index) {
          break;
        }

        catArr.push(catData);
      }
    }

    return temp;
  };

  _proto._getHoveredPlot = function _getHoveredPlot(chartXVal, chartYVal) {
    var dataset = this,
        chartX = chartXVal,
        chartY = chartYVal,
        xAxis = dataset.getFromEnv('xAxis'),
        conf = dataset.config,
        trackIndex = conf.trackIndex,
        // eslint-disable-line good-practices/no-single-usage-variable
    dataStore = dataset.components.data,
        len = dataStore.length,
        i,
        j,
        index,
        returnValue,
        xMin,
        xMax,
        pointObjs; // getting new chart XY accordint to Translation of axis

    chartX += xAxis.getTranslation();
    xMin = Math.floor(Math.max(xAxis.getValue(chartX - conf.maxRadius), 0)); // eslint-disable-line good-practices/no-single-usage-variable

    xMax = Math.ceil(Math.min(xAxis.getValue(chartX + conf.maxRadius), len - 1)); // eslint-disable-line good-practices/no-single-usage-variable

    for (j = xMax; j >= xMin; j--) {
      pointObjs = trackIndex[j];
      len = pointObjs && pointObjs.length; // search point objects under current value

      for (i = len; i >= 0; i--) {
        index = pointObjs[i];
        returnValue = dataset.isWithinShape(dataStore[index], index, chartX, chartY);

        if (returnValue) {
          return returnValue;
        }
      }
    }
  }
  /**
   * Returns the clip path for kagi
   *
   * @param {any} type type of clip-rect
   * @memberof KagiDataset
   */
  ;

  _proto.getClip = function getClip(type) {
    var canvasConfig = this.getFromEnv('chart').getChildren('canvas')[0].config,
        clipRect = [canvasConfig.canvasLeft, canvasConfig.canvasTop, 0, canvasConfig.canvasTop + canvasConfig.canvasHeight];
    clipRect[2] += type === 'init' ? 0 : canvasConfig.canvasLeft + canvasConfig.canvasWidth;
    return clipRect;
  }
  /**
   * Parses the plot attributes
   *
   * @param {any} pointData
   * @param {any} index
   * @memberof KagiDataset
   */
  ;

  _proto.parsePlotAttributes = function parsePlotAttributes(pointData, index) {
    var i = index,
        point = pointData,
        trackerConfig,
        dataSet = this,
        xPos,
        yPos,
        eventArgs,
        dataObj,
        setRolloutAttr,
        setRolloverAttr,
        anchorRadius,
        hoverEffects,
        anchorProps = {},
        symbol,
        config,
        visible = dataSet.getState('visible'),
        attr;
    point = point.config;
    dataObj = dataSet.components.data[i];
    config = dataObj.config;
    trackerConfig = point.trackerConfig = {}; // eslint-disable-line good-practices/no-single-usage-variable

    hoverEffects = config.hoverEffects;
    xPos = dataObj._xPos = dataSet.getFromEnv('xAxis').getPixel(point.plotX);
    yPos = dataObj._yPos = point.plotY;
    dataObj._index = point.plotX;
    anchorProps = config.anchorProps;
    symbol = anchorProps.symbol; // eslint-disable-line good-practices/no-single-usage-variable

    point.finalTooltext = point.toolText;

    if (yPos !== UNDEF && !isNaN(yPos) && point.isDefined) {
      // Storing the event arguments
      eventArgs = point.eventArgs = point.eventArgs || {}; // Storing the event arguments

      Object.assign(eventArgs, {
        index: i,
        link: config.setLink,
        value: config.setValue,
        displayValue: config.displayValue,
        categoryLabel: config.label,
        toolText: point.finalTooltext,
        id: dataSet.config.userID,
        datasetIndex: 0,
        datasetName: dataSet.config.JSONData.seriesname,
        visible: visible,
        color: config.color,
        alpha: config.alpha,
        anchorBgColor: anchorProps.bgColor,
        anchorBgAlpha: anchorProps.anchorBgAlpha,
        anchorAlpha: anchorProps.anchorAlpha,
        anchorBorderColor: anchorProps.borderColor,
        anchorBorderThickness: anchorProps.borderThickness,
        anchorRadius: anchorProps.radius,
        anchorSides: anchorProps.sides,
        anchorStartAngle: anchorProps.startAngle,
        anchorHoverColor: hoverEffects.anchorColor,
        anchorHoverAlpha: hoverEffects.anchorAlpha,
        anchorHoverSides: hoverEffects.anchorSides,
        dashed: config.dashed,
        valuePosition: config.valuePosition
      }); // Hover consmetics

      setRolloutAttr = setRolloverAttr = {};

      if (anchorProps.imageUrl) {
        config.anchorImageLoaded = false;
      }

      attr = {
        path: (0, _lib.polyPathToPath)([symbol[1] || 2, xPos, yPos, anchorProps.radius, anchorProps.startAngle, 0]),
        fill: (0, _lib.toRaphaelColor)({
          color: anchorProps.bgColor,
          alpha: anchorProps.bgAlpha
        }),
        stroke: (0, _lib.toRaphaelColor)({
          color: anchorProps.borderColor,
          alpha: anchorProps.borderAlpha
        }),
        'stroke-width': anchorProps.borderThickness,
        visibility: !anchorProps.radius ? 'hidden' : visible
      };
      anchorRadius = Math.max(anchorProps.radius, hoverEffects && hoverEffects.anchorRadius || 0, HTP) + anchorProps.borderThickness / 2;
      trackerConfig.trackerRadius = anchorRadius; // Parsing cosmectics to be applied when element is hovered on.

      if (hoverEffects.enabled) {
        setRolloverAttr = {
          path: (0, _lib.polyPathToPath)([hoverEffects.anchorSides || 2, xPos, yPos, hoverEffects.anchorRadius, hoverEffects.startAngle, hoverEffects.dip]),
          fill: (0, _lib.toRaphaelColor)({
            color: hoverEffects.anchorColor,
            alpha: hoverEffects.anchorBgAlpha
          }),
          stroke: (0, _lib.toRaphaelColor)({
            color: hoverEffects.anchorBorderColor,
            alpha: hoverEffects.anchorBorderAlpha
          }),
          'stroke-width': hoverEffects.anchorBorderThickness
        };
        setRolloutAttr = {
          path: (0, _lib.polyPathToPath)([anchorProps.sides, xPos, yPos, anchorProps.radius, anchorProps.startAngle, 0]),
          fill: (0, _lib.toRaphaelColor)({
            color: anchorProps.bgColor,
            alpha: anchorProps.bgAlpha
          }),
          stroke: (0, _lib.toRaphaelColor)({
            color: anchorProps.borderColor,
            alpha: anchorProps.borderAlpha
          }),
          'stroke-width': anchorProps.borderThickness
        }; // set hover effect on each data set

        hoverEffects.attrs = {
          'hoverEnabled': hoverEffects.enabled,
          'anchorRadius': anchorProps.radius,
          'anchorHoverRadius': hoverEffects.anchorRadius
        };
        hoverEffects.attrs[SETROLLOVERATTR] = setRolloverAttr;
        hoverEffects.attrs[SETROLLOUTATTR] = setRolloutAttr;
        anchorProps.isAnchorHoverRadius = hoverEffects.attrs.anchorRadius;
      }
    }

    point.props = {
      element: {
        attr: attr
      }
    };
  }
  /**
   * Parses label attributes and position
   *
   * @param {any} dataObj
   * @param {any} index
   * @memberof KagiDataset
   */
  ;

  _proto.parseLabelAttributes = function parseLabelAttributes(dataObj, index) {
    var dataSet = this,
        chart = dataSet.getFromEnv('chart'),
        chartConfig = chart.config,
        style = chart.config.dataLabelStyle,
        displayValue = _lib.BLANKSTRING,
        rotateValues = chartConfig.rotatevalues ? 270 : 0,
        canvasTop = chartConfig.canvasTop,
        canvasHeight = chartConfig.canvasHeight,
        // eslint-disable-line good-practices/no-single-usage-variable
    canvasBottom = canvasTop + canvasHeight,
        valuePadding,
        bBoxObj,
        graphic,
        textHeight,
        origTextHeight,
        textY,
        textX,
        yAdjust,
        nextPoint = {},
        // eslint-disable-line good-practices/no-single-usage-variable
    prevPoint = {},
        config,
        decidingDimention,
        xPos,
        yPos,
        value,
        anchorRadius,
        i = index,
        plotLabelStyle,
        len = dataSet.components.data.length,
        // eslint-disable-line good-practices/no-single-usage-variable
    setValue,
        attr;
    config = dataObj && dataObj.config;
    setValue = config && config.setValue;

    if (dataObj === UNDEF || setValue === UNDEF || setValue === null || config.labelSkip === true) {
      config && delete config.labelSkip;
      return;
    }

    if (index > 0) {
      prevPoint = {
        x: dataSet.components.data[i - 1]._xPos,
        y: dataSet.components.data[i - 1]._yPos
      };
    }

    if (index < len - 1) {
      nextPoint = {
        x: dataSet.components.data[i + 1]._xPos,
        y: dataSet.components.data[i + 1]._yPos
      };
    }

    graphic = dataObj.graphics;
    yPos = dataObj._yPos || dataObj.config._Py;
    xPos = dataObj._xPos || dataObj.config._Px; // eslint-disable-line good-practices/no-single-usage-variable

    anchorRadius = graphic.element ? graphic.image && // eslint-disable-line good-practices/no-single-usage-variable
    graphic.element.attr('height') * 0.5 || config.anchorProps.radius - 3 : 0;
    valuePadding = config.valuePadding + GUTTER_2 + anchorRadius;
    displayValue = config.displayValue; // Drawing label only if displayvalue is defined and not blank and setValue is not null

    if (defined(displayValue) && displayValue !== '' && value !== null && config.showValue) {
      plotLabelStyle = config.dataLabelStyle;
      attr = {
        text: displayValue,
        fill: plotLabelStyle.color,
        'text-bound': [plotLabelStyle.backgroundColor, plotLabelStyle.borderColor, style.borderThickness, style.borderPadding, style.borderRadius, style.borderDash]
      };
      bBoxObj = dataSet.getFromEnv('smartLabel').getOriSize(displayValue);

      if (rotateValues) {
        // If rotated values we use the width of
        // the text as height
        config._state = {
          // If label is already rotated then we take the width as labelWidth
          labelWidth: bBoxObj.height,
          labelHeight: bBoxObj.width
        };
        config._rotated = true;
      } else {
        config._state = {
          // If label is already rotated then we take the height as labelWidth
          labelWidth: bBoxObj.width,
          labelHeight: bBoxObj.height
        };
        config._rotated = false;
      } // Calculating the total text height


      textHeight = origTextHeight = rotateValues ? bBoxObj.width : bBoxObj.height;
      textHeight += valuePadding;
      yAdjust = origTextHeight * 0.5 + valuePadding;
      textY = yPos;
      textX = xPos;
      textHeight = textHeight + GUTTER_4;
      decidingDimention = Number(rotateValues) >= 1 ? bBoxObj.height : bBoxObj.width;
      config._valueBelowPoint = 0; // Positioning of data labels

      if (nextPoint.y > textY) {
        // nextPoint is below than current point
        if (prevPoint.y < textY) {
          // place aside anchor if not enough space is available in bottom
          textX -= valuePadding + 3 + decidingDimention * 0.5;
        } else {
          // previous point is below current point
          if (yPos - textHeight < canvasTop) {
            // place aside anchor if not enough space is available on top
            textX -= valuePadding + 3 + decidingDimention * 0.5;
            textY = canvasTop + textHeight / 2;
          } else {
            // else place vertically above anchor
            textY -= yAdjust;
          }
        }
      } else {
        // nextpoint is above the current point
        if (prevPoint.y > textY) {
          // place aside anchor if not enough space is available in bottom
          textX -= valuePadding + 3 + decidingDimention * 0.5;
        } else {
          // previous point is above current point
          if (yPos + textHeight > canvasBottom) {
            // place aside anchor if not enough space is available in bottom
            textX -= valuePadding + 3 + decidingDimention * 0.5;
            textY = canvasBottom - textHeight / 2;
          } else {
            // else place vertically below anchor
            textY += yAdjust + GUTTER_2;
            config._valueBelowPoint = 1;
          }
        }
      }

      attr.x = textX;
      attr.y = textY;
    }

    config.props = config.props || {};
    config.props.label = {
      attr: attr
    };
  }
  /**
   * Parses anchor position and cosmetics during post space management
   *
   * @returns {any}
   * @memberof KagiDataset
   */
  ;

  _proto.allocatePosition = function allocatePosition() {
    var i,
        dataSet = this,
        conf = dataSet.config,
        setDataArr = dataSet.components.data,
        dataSetLen = setDataArr && setDataArr.length,
        // eslint-disable-line good-practices/no-single-usage-variable
    xAxis = dataSet.getFromEnv('xAxis'),
        setValue,
        dataStore = dataSet.components.data,
        dataObj,
        xAxisZeroPos = xAxis.getPixel(0),
        xAxisFirstPos = xAxis.getPixel(1),
        // eslint-disable-line good-practices/no-single-usage-variable
    pointDistance = xAxisFirstPos - xAxisZeroPos,
        thickness = {
      'true': conf.rallyThickness,
      'false': conf.declineThickness
    },
        rallyPath,
        declinePath,
        xValue = 0,
        // eslint-disable-line good-practices/no-single-usage-variable
    plotX = xAxis.getPixel(xValue),
        isRally = setDataArr[0] && !!setDataArr[0].isRally,
        nextPointIsRally,
        startX = xAxisZeroPos - pointDistance / 2,
        plotY,
        crispY,
        nextPoint,
        path;
    conf.imagesLoaded = 0;

    if (!setDataArr.length) {
      return;
    }

    rallyPath = conf.rallyPath = [];
    declinePath = conf.declinePath = []; // Set components.data to blank array if dataStore is not present

    dataStore = dataSet.components.data = dataStore || []; // Special situation for first null data.

    if (!setDataArr[0].config.setValue) {
      for (i = 1; i < dataSetLen; i += 1) {
        setValue = setDataArr[i].config.setValue;

        if (setValue) {
          // Get the first valid value.
          plotY = setDataArr[i].config.plotY;
          break;
        }
      }
    } else {
      plotY = setDataArr[0].config.plotY;
    }

    isRally = !!setDataArr[0].config.isRally; // drawing starts with an initial half horizontal-shift

    crispY = Math.round(plotY) + thickness[isRally] % 2 / 2;

    if (isRally) {
      rallyPath.push(M, startX, crispY, H, plotX);
    } else {
      declinePath.push(M, startX, crispY, H, plotX);
    }

    (0, _lib.fcEach)(setDataArr, function (pointData, ii) {
      var point = pointData;
      point = point.config;
      dataObj = dataStore[ii];
      setValue = dataObj.config.setValue; // looping to draw the plots

      nextPoint = setDataArr[ii + 1] && setDataArr[ii + 1].config || {};

      if (nextPoint) {
        path = [M, plotX, plotY];
        isRally = point.isRally; // if there is a shift corresponding to this point

        if (point.isShift) {
          plotX += pointDistance;
          plotY = point.graphY;
          path.push(H, plotX);
          path[2] = Math.round(path[2]) + thickness[isRally] % 2 / 2;
          path = path.toString(); // draw the path

          if (isRally) {
            rallyPath.push(path);
          } else {
            declinePath.push(path);
          }

          path = [M, plotX, plotY];
        } // if there is a change in trend between the current and
        // the next points


        if (nextPoint.isChanged) {
          plotY = nextPoint.ty;
          path.push(V, plotY);
          path[1] = Math.round(path[1]) + thickness[!!isRally] % 2 / 2;
          path = path.toString();

          if (isRally) {
            rallyPath.push(path);
          } else {
            declinePath.push(path);
          }

          path = [M, plotX, plotY];
        }

        nextPointIsRally = nextPoint.isRally; // TODO: If path contains move to and line to at the same point line is not visible in
        //       native VML brewers need to remove this code when this issue in fixed in core.

        if (nextPoint.graphY !== path[2] && nextPoint.graphY !== UNDEF) {
          path.push(V, nextPoint.graphY);
          path[1] = Math.round(path[1]) + thickness[!!nextPointIsRally] % 2 / 2;
          path = path.toString();

          if (nextPointIsRally) {
            rallyPath.push(path);
          } else {
            declinePath.push(path);
          }
        } // updating value


        nextPoint.graphY && (plotY = nextPoint.graphY);
      }

      dataSet.parsePlotAttributes(dataObj, ii);
    });

    for (i = 0; i < setDataArr.length; i++) {
      dataSet.parseLabelAttributes(dataStore[i], i);
    }
  }
  /**
   * Draw the plots of kagi chart
   *
   * @memberof KagiDataset
   */
  ;

  _proto.drawPlots = function drawPlots() {
    var graphics,
        dataSet = this,
        datasetGraphics = dataSet.getGraphicalElement(),
        animationManager = dataSet.getFromEnv('animationManager'),
        conf = dataSet.config,
        // temp hardcoded.
    trackIndex = conf.trackIndex = {},
        setDataArr = dataSet.components.data,
        yPos,
        setElement,
        dataStore = dataSet.components.data,
        // eslint-disable-line good-practices/no-single-usage-variable
    dataObj,
        hoverEffects,
        shadow = conf.shadow,
        anchorProps = {},
        config,
        rallyThickness = conf.rallyThickness,
        declineThickness = conf.declineThickness,
        rallyAttr = {
      stroke: (0, _lib.toRaphaelColor)({
        color: conf.rallyColor,
        alpha: conf.rallyAlpha
      }),
      'stroke-linecap': ROUND,
      'stroke-linejoin': ROUND,
      'stroke-width': rallyThickness,
      'stroke-dasharray': conf.rallyDashed
    },
        declineAttr = {
      stroke: (0, _lib.toRaphaelColor)({
        color: conf.declineColor,
        alpha: conf.declineAlpha
      }),
      'stroke-linecap': ROUND,
      'stroke-linejoin': ROUND,
      'stroke-width': declineThickness,
      'stroke-dasharray': conf.declineDashed
    },
        rallyElemDummy = datasetGraphics.rallyElem,
        rallyElem,
        declineElemDummy = datasetGraphics.declineElem,
        declineElem,
        attr,
        commonElemGroup = dataSet.getContainer('commonElemsGroup'),
        plotGroup = dataSet.getContainer('plotGroup'),
        // eslint-disable-line good-practices/no-single-usage-variable
    shadowGroup = dataSet.getContainer('shadowGroup'),
        imageElement; // save the world if no valid data is there.

    if (!setDataArr.length) {
      rallyElem && rallyElem.hide();
      declineElem && declineElem.hide();
      return;
    }

    rallyElem && rallyElem.show();
    declineElem && declineElem.show();
    (0, _lib.fcEach)(setDataArr, function (pointData, i) {
      var point = pointData;
      point = point.config;
      dataObj = dataStore[i];
      config = dataObj.config;
      graphics = dataObj.graphics;
      imageElement = graphics.image;
      hoverEffects = config.hoverEffects;
      yPos = dataObj._yPos;

      if (!trackIndex[point.plotX]) {
        trackIndex[point.plotX] = [];
      }

      trackIndex[point.plotX].push(i);
      dataObj._index = point.plotX;
      anchorProps = config.anchorProps;

      if (yPos !== UNDEF && !isNaN(yPos) && point.isDefined) {
        if (anchorProps.imageUrl) {
          dataSet.drawAnchorImage(dataObj);
        } else {
          imageElement && imageElement.hide();
          setElement = graphics.element;
          attr = point.props.element.attr; // create/reuse setElement

          setElement = graphics.element = animationManager.setAnimation({
            el: setElement || 'path',
            attr: attr,
            container: plotGroup,
            component: dataSet,
            label: 'anchor'
          }); // Set properties to the data of element

          setElement.show().shadow(anchorProps.shadow, shadowGroup).data('anchorRadius', anchorProps.radius).data('anchorHoverRadius', hoverEffects.anchorRadius).data('hoverEnabled', hoverEffects.enabled).data(EVENTARGS, point.eventArgs);
        } // Parsing cosmectics to be applied when element is hovered on.


        if (hoverEffects.enabled) {
          setElement && setElement.data('anchorRadius', anchorProps.radius).data('anchorHoverRadius', hoverEffects.anchorRadius).data('hoverEnabled', hoverEffects.enabled).data(SETROLLOVERATTR, hoverEffects.attrs[SETROLLOVERATTR]).data(SETROLLOUTATTR, hoverEffects.attrs[SETROLLOUTATTR]).data(EVENTARGS, point.eventArgs);
        }
      } else {
        graphics.element && graphics.element.hide();
        imageElement && imageElement.hide();
      }
    }); // Create/reuse rally element

    rallyAttr.path = conf.rallyPath;
    rallyElem = animationManager.setAnimation({
      el: rallyElemDummy || 'path',
      attr: rallyAttr,
      container: commonElemGroup,
      component: dataSet,
      label: 'line'
    });
    rallyElem.shadow(rallyThickness && shadow, shadowGroup);

    if (!rallyElemDummy) {
      dataSet.addGraphicalElement('rallyElem', rallyElem);
    } // create/reuse decline element


    declineAttr.path = conf.declinePath;
    declineElem = animationManager.setAnimation({
      el: declineElemDummy || 'path',
      attr: declineAttr,
      container: commonElemGroup,
      component: dataSet,
      label: 'line'
    });
    declineElem.shadow(declineThickness && shadow, shadowGroup);

    if (!declineElemDummy) {
      dataSet.addGraphicalElement('declineElem', declineElem);
    }
  };

  return KagiDataset;
}(_line.default);

var _default = KagiDataset;
exports["default"] = _default;

/***/ }),

/***/ 1393:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _index = _interopRequireDefault(__webpack_require__(619));

var _default = {
  '*.dataset.stepLine': _index.default['*.dataset.line']
};
exports["default"] = _default;

/***/ }),

/***/ 1392:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _lib = __webpack_require__(274);

var _line = _interopRequireDefault(__webpack_require__(616));

var _dependencyManager = __webpack_require__(282);

var _index = _interopRequireDefault(__webpack_require__(1393));

var LINE = 'line',
    H = 'H',
    V = 'V',
    M = 'M',
    UNDEF;
(0, _dependencyManager.addDep)({
  name: 'stepLineAnimation',
  type: 'animationRule',
  extension: _index.default
});

var MSStepLineDataset = /*#__PURE__*/function (_LineDataset) {
  (0, _inheritsLoose2.default)(MSStepLineDataset, _LineDataset);

  function MSStepLineDataset() {
    var _this;

    _this = _LineDataset.call(this) || this; // eslint-disable-next-line good-practices/no-function-dependency

    _this.getPathArr = function () {
      var pathObj = this,
          pathArr = pathObj.pathArr,
          path2Arr = pathObj.path2Arr;

      if (pathArr.length || path2Arr.length) {
        return pathArr.concat(path2Arr);
      }

      return [];
    };

    return _this;
  }
  /**
   * Sets the type of the component
   * @return {string} type
   */


  var _proto = MSStepLineDataset.prototype;

  _proto.getType = function getType() {
    return 'dataset';
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */
  ;

  _proto.getName = function getName() {
    return 'stepLine';
  };

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    _LineDataset.prototype.__setDefaultConfig.call(this);

    var config = this.config;
    config.drawverticaljoins = UNDEF;
    config.useforwardsteps = UNDEF;
  };

  _proto._addLegend = function _addLegend() {
    var dataset = this,
        conf = dataset.config,
        legend = dataset.getFromEnv('legend'),
        chartAttr = dataset.getFromEnv('chart-attrib'),
        drawAnchors = (0, _lib.pluckNumber)(conf.drawanchors, 1),
        // eslint-disable-line good-practices/no-single-usage-variable
    legendItem,
        JSONData = dataset.config.JSONData || {},
        config = {
      // eslint-disable-line good-practices/no-single-usage-variable
      enabled: conf.includeinlegend,
      type: LINE,

      /* In case of scatter (a child chartAPI of line),
      line is drawn in legend only when drawLine is set
      to true. */
      drawLine: (0, _lib.pluck)(conf.drawLine, true),
      anchorSide: drawAnchors ? conf.anchorsides : 0,
      label: (0, _lib.getFirstValue)(dataset.config.JSONData.seriesname),
      legendIconAlpha: (0, _lib.pluckNumber)(JSONData.legendiconalpha)
    };

    if (conf.includeinlegend) {
      legendItem = legend.getItem(dataset.config.legendItemId);

      if (!legendItem) {
        dataset.config.legendItemId = legend.createItem(dataset);
        legendItem = legend.getItem(dataset.config.legendItemId);
        dataset.addExtEventListener('fc-click', function () {
          legendItem.itemClickFn();
        }, legendItem);
      }

      legendItem.configure(config);
      legendItem.setStateCosmetics('default', {
        symbol: {
          fill: (0, _lib.toRaphaelColor)({
            color: conf.anchorbgcolor,
            alpha: conf.anchorbgalpha
          }),
          bgAlpha: (0, _lib.pluckNumber)(JSONData.legendiconbgalpha, JSONData.legendiconalpha, chartAttr.legendiconbgalpha, chartAttr.legendiconalpha, conf.anchorbgalpha),
          borderAlpha: (0, _lib.pluckNumber)(JSONData.legendiconborderalpha, JSONData.legendiconalpha, chartAttr.legendiconborderalpha, chartAttr.legendiconalpha, '100'),
          rawFillColor: conf.anchorbgcolor,
          rawStrokeColor: conf.anchorbordercolor,
          stroke: (0, _lib.toRaphaelColor)({
            color: conf.anchorbordercolor,
            alpha: '100'
          }),
          'stroke-width': conf.anchorborderthickness
        }
      }); // check if dataset is initiallyhidden

      if (!dataset.getState('visible')) {
        legendItem.setLegendState('hidden');
      } else {
        // remove hidden state of legend item is dataset is not hidden
        legendItem.removeLegendState('hidden');
      }
    } else if (dataset.config.legendItemId) {
      legend.disposeItem(dataset.config.legendItemId);
    }
  };

  _proto.getLinePath = function getLinePath(data, positions) {
    var dataset = this,
        conf = dataset.config,
        chartConfig = dataset.getFromEnv('chartConfig'),
        connectNullData = (0, _lib.pluckNumber)(chartConfig.connectnulldata),
        // eslint-disable-line good-practices/no-single-usage-variable
    obj = {},
        drawVerticalJoins = (0, _lib.pluckNumber)(conf.drawverticaljoins),
        halfStep = (0, _lib.pluckNumber)(chartConfig.stepatmiddle) ? dataset.getFromEnv('xAxis').getPVR() * 0.5 : 0,
        // Used for determining whether the last value was valid
    // Initially it is false
    lastValidValue = obj.lastValidValue || false,
        temp = obj.temp || [],
        temp2 = obj.temp2 || [],
        // eslint-disable-line good-practices/no-single-usage-variable
    pathArr = obj.pathArr || [],
        path2Arr = obj.path2Arr || [],
        // eslint-disable-line good-practices/no-single-usage-variable
    lastXPos,
        i,
        config,
        xPos,
        yPos,
        pointsJoined = obj.pointsJoined || 0,
        dataObj,
        setValue,
        startPos = positions && positions.begin || 0,
        // eslint-disable-line good-practices/no-single-usage-variable
    endPos = positions && positions.end || data.length,
        // eslint-disable-line good-practices/no-single-usage-variable
    step = chartConfig.viewPortConfig.step || 1,
        // eslint-disable-line good-practices/no-single-usage-variable
    dataWithRemovedPaths = []; // Added current dataStore to arr

    dataWithRemovedPaths = dataWithRemovedPaths.concat(data);

    for (i = startPos; i < endPos; i += step) {
      dataObj = dataWithRemovedPaths[i];

      if (!dataObj) {
        continue;
      }

      config = dataObj.config;
      setValue = config.setValue; // skip the data plot if isSkipped flag is set to false

      if (setValue === UNDEF || config && config.isSkipped === true) {
        config && delete config.isSkipped;
        continue;
      }

      xPos = config._Px;
      yPos = config._Py; // create the path array
      // If the last value is valid

      if (setValue === null || setValue.isNull) {
        // If null data points are also to be connected
        if (!connectNullData) {
          temp = [];
          temp2 = [];
          lastValidValue = false;
        }
      } else {
        if (lastValidValue) {
          if (temp.length) {
            pathArr = pathArr.concat(temp);
            temp = [];
            pointsJoined++;
          }

          if ((0, _lib.pluckNumber)(conf.useforwardsteps)) {
            pathArr.push([H, xPos - halfStep]);

            if (drawVerticalJoins) {
              pathArr.push([V, yPos]);
            } else {
              pathArr.push([M, xPos - halfStep, yPos]);
            }

            if (halfStep) {
              pathArr.push([H, xPos]);
            }
          } else {
            if (drawVerticalJoins) {
              pathArr.push([V, yPos]);
            } else {
              pathArr.push([M, lastXPos, yPos]);
            }

            pathArr.push([H, xPos]);
            lastXPos = xPos;
          } // Push the upper x and y position to pathArr
          // pathArr.push([L, xPos, yPos]);

        } else {
          // Push the upper x and y positions of area plot to temp
          temp.push([M, xPos, yPos]);
          lastXPos = xPos; // No points are joined when starting a new path

          pointsJoined = 0;
          lastValidValue = true;
        }
      }
    }

    return {
      pathArr: pathArr,
      path2Arr: path2Arr,
      lastValidValue: lastValidValue,
      pointsJoined: pointsJoined,
      temp: temp,
      temp2: temp2,
      getPathArr: dataset.getPathArr
    };
  };

  return MSStepLineDataset;
}(_line.default);

var _default = MSStepLineDataset;
exports["default"] = _default;

/***/ }),

/***/ 1389:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _index = _interopRequireDefault(__webpack_require__(619));

var _default = {
  '*.dataset.multiaxisline': _index.default['*.dataset.line']
};
exports["default"] = _default;

/***/ }),

/***/ 1388:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _line = _interopRequireDefault(__webpack_require__(616));

var _lib = __webpack_require__(274);

var _dependencyManager = __webpack_require__(282);

var _index = _interopRequireDefault(__webpack_require__(1389));

/* eslint require-jsdoc: 'error', valid-jsdoc: ["error", { "requireReturn": false }] */
(0, _dependencyManager.addDep)({
  name: 'multiAxislineAnimation',
  type: 'animationRule',
  extension: _index.default
});
/**
 * Class for MultiAxisLine chartAPI
 */

var MultiAxisDataset = /*#__PURE__*/function (_Line) {
  (0, _inheritsLoose2.default)(MultiAxisDataset, _Line);

  function MultiAxisDataset() {
    return _Line.apply(this, arguments) || this;
  }

  var _proto = MultiAxisDataset.prototype;

  /**
   * Sets the type of the component
   * @return {string} type
   */
  _proto.getType = function getType() {
    return 'dataset';
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */
  ;

  _proto.getName = function getName() {
    return 'multiaxisline';
  }
  /**
   * Function to configure the data given by the user at the dataset level
   * @param {Object} datasetJSON JSON for dataset configurations
   * @return {boolean} False if no datasetJSON is present
   */
  ;

  _proto.configure = function configure(datasetJSON) {
    if (!datasetJSON) {
      return false;
    }

    this.trimData(datasetJSON);
    this.config.JSONData = datasetJSON;

    _Line.prototype.configure.call(this, datasetJSON);
  }
  /**
   * Function to parse the data given by the user at the dataset level
   */
  ;

  _proto.parseAttributes = function parseAttributes() {
    var dataSet = this,
        jsonData = dataSet.config.JSONData,
        dataSetConfig = dataSet.config,
        chartAttr = dataSet.getFromEnv('chart-attrib'),
        axis = dataSet.getFromEnv('axisData'),
        lineDashStyle,
        lineDashed;

    _Line.prototype.parseAttributes.call(this);

    dataSetConfig.linethickness = (0, _lib.pluckNumber)(jsonData.linethickness, axis.linethickness, chartAttr.linethickness, 2);
    dataSetConfig.lineDashLen = (0, _lib.pluckNumber)(jsonData.linedashlen, axis.linedashlen, chartAttr.linedashlen, 5);
    dataSetConfig.lineDashGap = (0, _lib.pluckNumber)(jsonData.linedashgap, axis.linedashgap, chartAttr.linedashgap, 4);
    dataSetConfig.alpha = (0, _lib.pluckNumber)(jsonData.alpha, axis.linealpha, chartAttr.linealpha, _lib.HUNDREDSTRING);
    dataSetConfig.linecolor = (0, _lib.pluck)(jsonData.color, axis.linecolor, axis.color, chartAttr.linecolor, dataSetConfig.plotColor);
    dataSetConfig.legendSymbolColor = dataSet.getName() === 'line' ? dataSetConfig.lineColor : dataSetConfig.plotFillColor;
    lineDashed = (0, _lib.pluckNumber)(jsonData.dashed, axis.linedashed, chartAttr.linedashed); // eslint-disable-line good-practices/no-single-usage-variable

    lineDashStyle = (0, _lib.getDashStyle)(dataSetConfig.lineDashLen, dataSetConfig.lineDashGap); // eslint-disable-line good-practices/no-single-usage-variable

    dataSetConfig.anchorbordercolor = (0, _lib.pluck)(jsonData.anchorbordercolor, jsonData.color, axis.color, chartAttr.anchorbordercolor, dataSetConfig.lineColor, dataSetConfig.plotColor);
    dataSetConfig.lineDashStyle = lineDashed ? lineDashStyle : 'none';
  };

  return MultiAxisDataset;
}(_line.default);

var _default = MultiAxisDataset;
exports["default"] = _default;

/***/ }),

/***/ 1376:
/***/ ((__unused_webpack_module, exports) => {



exports.__esModule = true;
exports["default"] = void 0;
var _default = {
  'initial.dataset.multiLevelPie': function initialDatasetMultiLevelPie() {
    var datasetConf = this.config,
        ringpath;
    return {
      'ringpath.appearing': function ringpathAppearing(inputJSON) {
        ringpath = inputJSON.attr.ringpath;
        return [{
          initialAttr: {
            ringpath: [ringpath[0], ringpath[1], ringpath[2], ringpath[3], datasetConf.initialAngle, datasetConf.initialAngle]
          },
          slot: 'plot'
        }];
      },
      'text.appearing': function textAppearing() {
        return [{
          initialAttr: {
            opacity: 0
          },
          finalAttr: {
            opacity: 1
          },
          slot: 'final'
        }];
      }
    };
  }
};
exports["default"] = _default;

/***/ }),

/***/ 1375:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _pie2d = _interopRequireDefault(__webpack_require__(649));

var _column = __webpack_require__(595);

var _lib = __webpack_require__(274);

var _dependencyManager = __webpack_require__(282);

var _index = _interopRequireDefault(__webpack_require__(1376));

var _schedular = __webpack_require__(286);

var _redraphaelShapes = _interopRequireDefault(__webpack_require__(390));

var Raphael = (0, _dependencyManager.getDep)('redraphael', 'plugin'),
    BLANK = '',
    NORMALSTRING = 'normal',
    COLOR_FFFFFF = 'FFFFFF',
    COLOR_000000 = '000000',
    HUNDRED_PERCENT = '100%',
    ZERO_STR = '0',
    pInt = function pInt(s, mag) {
  return parseInt(s, mag || 10);
},
    DASH_DEF = 'none',
    UNDEF,
    ROLLOVER = 'DataPlotRollOver',
    ROLLOUT = 'DataPlotRollOut',
    POINTER = 'pointer',
    EVENTARGS = 'eventArgs',
    PX = 'px',
    INNERRADIUS = /^[0-9]+\%?$|^([0-9]+[.][0-9]+)\%?$/,
    calculateInnerRadius = function calculateInnerRadius(innerRadius, pieRadius) {
  var innerRadiusLength = innerRadius && innerRadius.length,
      // eslint-disable-line good-practices/no-single-usage-variable
  calculatedInnerRadius;

  if (!innerRadius) {
    return 0;
  }

  if (innerRadius.charAt(innerRadiusLength - 1) === '%') {
    // execute when innerRadius is given as percentage
    calculatedInnerRadius = (0, _lib.pluckNumber)(pieRadius) * ((0, _lib.pluckNumber)(innerRadius.split('%')[0]) / 100);
  } else {
    // execute when innerRadius is given in pixels.
    calculatedInnerRadius = (0, _lib.pluckNumber)(innerRadius);
  }

  if (calculatedInnerRadius < pieRadius) {
    return calculatedInnerRadius;
  }

  return 0;
};

(0, _dependencyManager.addDep)({
  name: 'multilevelpieAnimation',
  type: 'animationRule',
  extension: _index.default
}); // Adding required shapes for chart.

(0, _redraphaelShapes.default)(Raphael);

var MultiLevelPieDataset = /*#__PURE__*/function (_Pie2DDataset) {
  (0, _inheritsLoose2.default)(MultiLevelPieDataset, _Pie2DDataset);

  function MultiLevelPieDataset() {
    var _this;

    _this = _Pie2DDataset.call(this) || this;
    _this.components = {
      data: []
    };
    _this.graphics = {};
    return _this;
  }
  /**
   * Sets the type of the component
   * @return {string} type
   */


  var _proto = MultiLevelPieDataset.prototype;

  _proto.getType = function getType() {
    return 'dataset';
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */
  ;

  _proto.getName = function getName() {
    return 'multiLevelPie';
  };

  _proto.configureAttributes = function configureAttributes(datasetJSON) {
    if (!datasetJSON) {
      return false;
    }

    this.config.JSONData = datasetJSON;

    var fontBdrColor,
        dataSet = this,
        chart = dataSet.getFromEnv('chart'),
        chartConfig = chart.config,
        dataSetConfig = dataSet.config || (dataSet.config = {}),
        dataLabels = dataSetConfig.dataLabelOptions || (dataSetConfig.dataLabelOptions = {}),
        piePlotOptions = dataSetConfig.piePlotOptions,
        style = chart.config.style,
        chartAttrs = chart.getFromEnv('dataSource').chart,
        centerAngle = (0, _lib.pluckNumber)(-chartAttrs.centerangle, 180),
        totalAngle = (0, _lib.pluckNumber)(chartAttrs.totalangle, 360),
        tranverseToRoot = function tranverseToRoot(dataInstance, evtType) {
      var dataObj = dataInstance;

      while (dataObj.graphics.element) {
        dataObj.graphics.element.attr({
          fill: evtType === 'mouseover' ? dataSetConfig.hoverFillColor : (dataObj.config || this.data('plotItem')).color
        });
        dataObj = dataObj.config.parent;
      }
    },
        traverseAllChildren = function traverseAllChildren(dataObj, evtType) {
      var k;
      dataObj.graphics.element.attr({
        fill: evtType === 'mouseover' ? dataSetConfig.hoverFillColor : (dataObj.config || this.data('plotItem')).color
      });

      for (k = 0; k < (dataObj.components.data && dataObj.components.data.length); k++) {
        traverseAllChildren.call(this, dataObj.components.data[k], evtType);
      }
    },
        mouseEvtHandler = function mouseEvtHandler(evtType) {
      if (!dataSetConfig.useHoverColor) {
        return;
      }

      var point = this.data('plotItem'),
          selfRef = point.selfRef;

      if (!dataSetConfig.highlightParentPieSlices && !dataSetConfig.highlightChildPieSlices) {
        selfRef.graphics.element.attr({
          fill: evtType === 'mouseover' ? dataSetConfig.hoverFillColor : (selfRef.config || point).color
        });
      } else if (!dataSetConfig.highlightParentPieSlices && dataSetConfig.highlightChildPieSlices) {
        traverseAllChildren.call(this, selfRef, evtType);
      } else if (dataSetConfig.highlightParentPieSlices && !dataSetConfig.highlightChildPieSlices) {
        tranverseToRoot.call(this, selfRef, evtType);
      } else if (dataSetConfig.highlightParentPieSlices && dataSetConfig.highlightChildPieSlices) {
        tranverseToRoot.call(this, selfRef, evtType);
        traverseAllChildren.call(this, selfRef, evtType);
      }
    };

    dataSetConfig.usePattern = (0, _lib.pluckNumber)(chartConfig.usePattern, 0);
    dataSetConfig.patternType = _column.PATTERN_TYPES.includes(datasetJSON.patterntype) ? datasetJSON.patterntype : chartConfig.patternType;
    dataSetConfig.patternDensity = (0, _lib.pluckNumber)(datasetJSON.patterndensity, chartConfig.patternDensity);
    dataSetConfig.patternAlpha = (0, _lib.pluckNumber)(datasetJSON.patternalpha, chartConfig.patternAlpha);
    dataSetConfig.patternBgColor = (0, _lib.pluck)(datasetJSON.patternbgcolor, dataSetConfig.patternBgColor);
    dataSetConfig.enableAnimation = (0, _lib.pluckNumber)(chartAttrs.animation, chartAttrs.defaultanimation, 1);
    dataSetConfig.animation = !dataSetConfig.enableAnimation ? false : {
      duration: (0, _lib.pluckNumber)(chartAttrs.animationduration, chartAttrs.moveduration, 1) * 1000
    };
    dataSetConfig.showShadow = (0, _lib.pluckNumber)(chartAttrs.showshadow, 0);
    dataSetConfig.useHoverColor = Boolean((0, _lib.pluckNumber)(chartAttrs.usehovercolor, 1));

    if (dataSetConfig.usePattern) {
      dataSetConfig.useHoverColor = 0;
    }

    dataSetConfig.showTextOutline = Boolean((0, _lib.pluckNumber)(chartAttrs.textoutline, 0));
    dataSetConfig.hoverFillColor = (0, _lib.convertColor)((0, _lib.pluck)(chartAttrs.hoverfillcolor, 'FF5904'), (0, _lib.pluckNumber)(chartAttrs.hoverfillalpha, 100));
    fontBdrColor = (0, _lib.getFirstValue)(chartAttrs.valuebordercolor, BLANK);
    fontBdrColor = fontBdrColor ? (0, _lib.convertColor)(fontBdrColor, (0, _lib.pluckNumber)(chartAttrs.valueborderalpha, chartAttrs.valuebgalpha, chartAttrs.valuealpha, 100)) : BLANK; // create the style object if required.
    // fix for multilevel pie datavalue cosmetics issue RED-1594

    !dataLabels.style && (dataLabels.style = {
      fontFamily: (0, _lib.pluck)(chartAttrs.valuefont, style.fontFamily),
      fontSize: (0, _lib.pluckNumber)(this.computeFontSize(chartAttrs.valuefontsize), pInt(style.fontSize, 10)) + PX,
      color: (0, _lib.convertColor)((0, _lib.pluck)(chartAttrs.valuefontcolor, style.color), (0, _lib.pluckNumber)(chartAttrs.valuefontalpha, chartAttrs.valuealpha, 100)),
      fontWeight: (0, _lib.pluckNumber)(chartAttrs.valuefontbold) ? 'bold' : NORMALSTRING,
      fontStyle: (0, _lib.pluckNumber)(chartAttrs.valuefontitalic) ? 'italic' : NORMALSTRING,
      backgroundColor: chartAttrs.valuebgcolor ? (0, _lib.convertColor)(chartAttrs.valuebgcolor, (0, _lib.pluckNumber)(chartAttrs.valuebgalpha, chartAttrs.valuealpha, 100)) : BLANK,
      border: fontBdrColor || chartAttrs.valuebgcolor ? (0, _lib.pluckNumber)(chartAttrs.valueborderthickness, 1) + 'px solid' : BLANK,
      borderPadding: (0, _lib.pluckNumber)(chartAttrs.valueborderpadding, 2),
      borderThickness: (0, _lib.pluckNumber)(chartAttrs.valueborderthickness, style.borderThickness, 1),
      borderRadius: (0, _lib.pluckNumber)(chartAttrs.valueborderradius, style.borderRadius, 0),
      borderColor: fontBdrColor,
      borderDash: (0, _lib.pluckNumber)(chartAttrs.valueborderdashed, 0) ? (0, _lib.getDashStyle)((0, _lib.pluckNumber)(chartAttrs.valueborderdashlen, 4), (0, _lib.pluckNumber)(chartAttrs.valueborderdashgap, 2)) : DASH_DEF
    }); // stop point slicing

    !piePlotOptions && (piePlotOptions = dataSetConfig.piePlotOptions = {});
    piePlotOptions.allowPointSelect = false;
    dataSetConfig.borderAlpha = (0, _lib.pluck)(chartAttrs.plotborderalpha, chartAttrs.pieborderalpha, 100);
    dataSetConfig.borderColor = (0, _lib.convertColor)((0, _lib.pluck)(chartAttrs.plotbordercolor, chartAttrs.piebordercolor, COLOR_FFFFFF), chartAttrs.showplotborder !== _lib.ZEROSTRING ? (0, _lib.pluck)(chartAttrs.plotborderalpha, chartAttrs.pieborderalpha, 100) : 0);
    dataSetConfig.rawborderColor = (0, _lib.pluck)(chartAttrs.plotbordercolor, chartAttrs.piebordercolor, COLOR_FFFFFF);
    dataSetConfig.showplotborder = (0, _lib.pluckNumber)(chartAttrs.showplotborder, 1);
    dataSetConfig.showTooltip = (0, _lib.pluckNumber)(chartAttrs.showtooltip, 1);
    dataSetConfig.borderWidth = (0, _lib.pluckNumber)(chartAttrs.pieborderthickness, chartAttrs.plotborderthickness, 1);
    piePlotOptions.startingAngle = 0; // set the chart's startingAngle as 0 [alwase]

    piePlotOptions.size = HUNDRED_PERCENT;
    dataSetConfig.highlightParentPieSlices = (0, _lib.pluckNumber)(chartAttrs.highlightparentpieslices, chartAttrs.highlightparentpienodes, 1);
    dataSetConfig.highlightChildPieSlices = (0, _lib.pluckNumber)(chartAttrs.highlightchildpieslices, chartAttrs.highlightchildpienodes, 0);
    dataSetConfig.showLabels = (0, _lib.pluckNumber)(chartAttrs.showlabels, 1);
    dataSetConfig.showValues = (0, _lib.pluckNumber)(chartAttrs.showvalues, 0);
    dataSetConfig.showValuesInTooltip = (0, _lib.pluckNumber)(chartAttrs.showvaluesintooltip, chartAttrs.showvalues, 0);
    dataSetConfig.showPercentValues = (0, _lib.pluckNumber)(chartAttrs.showpercentvalues, chartAttrs.showpercentagevalues, 0);
    dataSetConfig.showPercentInTooltip = (0, _lib.pluckNumber)(chartAttrs.showpercentintooltip, 0);
    dataSetConfig.toolTipSepChar = (0, _lib.pluck)(chartAttrs.tooltipsepchar, chartAttrs.hovercapsepchar, _lib.COMMASPACE);
    dataSetConfig.labelSepChar = (0, _lib.parseUnsafeString)((0, _lib.pluck)(chartAttrs.labelsepchar, dataSetConfig.toolTipSepChar));
    dataSetConfig.tooltext = chartAttrs.plottooltext;
    dataSetConfig.alpha = (0, _lib.pluck)(chartAttrs.plotfillalpha, chartAttrs.piefillalpha, 100);
    dataSetConfig.startAngle = (centerAngle - totalAngle / 2) * (Math.PI / 180);
    dataSetConfig.endtAngle = (centerAngle + totalAngle / 2) * (Math.PI / 180);
    dataSetConfig.initialAngle = dataSetConfig.endtAngle;
    dataSetConfig.originX = (0, _lib.pluckNumber)(chartAttrs.originx);
    dataSetConfig.originY = (0, _lib.pluckNumber)(chartAttrs.originy);
    dataSetConfig.events = {
      mouseOver: function mouseOver() {
        mouseEvtHandler.call(this, 'mouseover');
      },
      mouseOut: function mouseOut() {
        mouseEvtHandler.call(this, 'mouseout');
      }
    }; // remove the plotboder

    chartConfig.plotBorderWidth = 0; // get the label rotation, overlap and ellipses attributes if present

    dataSetConfig.autoRotateLabels = chartConfig.autorotatelabels ? (0, _lib.pluckNumber)(chartConfig.autorotatelabels) : 0;
    dataSetConfig.useEllipsesWhenOverflow = chartConfig.useellipseswhenoverflow ? (0, _lib.pluckNumber)(chartConfig.useellipseswhenoverflow) : 1;
    dataSetConfig.skipOverlapLabels = chartConfig.skipoverlaplabels ? (0, _lib.pluckNumber)(chartConfig.skipoverlaplabels) : 0; // remove the plotboder

    chartConfig.plotBorderWidth = 0;
    dataSetConfig.maxLevel = dataSet.addMSPieCat(dataSet.config.JSONData, 1, dataSet, dataSetConfig.startAngle, dataSetConfig.endtAngle);
    dataSetConfig.pieRadius = parseInt(chartAttrs.pieradius, 10); // dataSetConfig.innerRadius = pluckNumber(Number(pluck(chartAttrs.innerradius, '0%').split('%')[0]), 0);

    dataSetConfig.innerRadius = ZERO_STR;
    INNERRADIUS.test(chartAttrs.innerradius) && (dataSetConfig.innerRadius = (0, _lib.pluck)(chartAttrs.innerradius));
    dataLabels.distance = 0;
    dataLabels.placeLabelsInside = true;
  } // doHide is a Boolean Flag to hide the element or not.
  // All the graphical elements in excess are pushed to the graphics pool. They are hidden only after the
  // entire draw is complete.
  ;

  _proto.removalFn = function removalFn(ele, prop) {
    var dataSet = this,
        // eslint-disable-next-line good-practices/no-function-dependency
    hideFN = function hideFN() {
      this.remove();
    };

    dataSet.getFromEnv('animationManager').setAnimation({
      el: ele,
      label: prop === 'element' ? 'ringpath' : 'label',
      component: dataSet,
      callback: hideFN
    });
  };

  _proto.removeGraphics = function removeGraphics(obj) {
    var i,
        prop,
        dataSet = this,
        childData = obj.components && obj.components.data,
        len,
        graphics = obj.graphics;

    if (childData) {
      len = childData.length;

      for (i = 0; i < len; i += 1) {
        dataSet.removeGraphics(childData[i]);
      }
    }

    if (obj.graphics) {
      for (prop in graphics) {
        if (graphics.hasOwnProperty(prop)) {
          dataSet.removalFn(obj.graphics[prop], prop);
        }
      }
    }
  };

  _proto.removeChild = function removeChild(removalStore, doHide, type) {
    var i,
        elemObj,
        dataSet = this;

    if (removalStore.length) {
      for (i = 0; i < removalStore.length; i += 1) {
        elemObj = removalStore[i];

        if (type) {
          dataSet.removalFn(elemObj, doHide, type);
        } else {
          dataSet.removeGraphics(elemObj, doHide);
        }
      }
    } else {
      // if the removalStore is in the Object structure.
      for (i in removalStore) {
        dataSet.removeChild(removalStore[i], doHide, i);
      }
    }
  };

  _proto.addMSPieCat = function addMSPieCat(catArr, level, parentObj, startAngle, endAngle) {
    var dataObj,
        dataObjLen,
        cat = (0, _lib.extend2)([], catArr),
        catObjLen,
        catLen = cat.length,
        dataSet = this,
        data = parentObj.components.data,
        dataSetConfig = dataSet.config,
        numberFormatter = dataSet.getFromEnv('number-formatter'),
        sharePercent,
        totalValue = 0,
        catObj,
        catVal,
        i,
        label,
        labelSepChar = dataSetConfig.labelSepChar,
        fillalpha,
        valueStr,
        pValueStr,
        toolText,
        displayValue,
        rawColor,
        showLabel,
        patternType,
        patternAngle,
        patternDensity,
        patternSize,
        patternAlpha,
        patternBgColor,
        showPlotBorder,
        maxLevel = level,
        dataLength = data.length,
        // eslint-disable-line good-practices/no-single-usage-variable
    removalFn = function removalFn() {
      dataSet.removeChild.apply(dataSet, arguments);
    },
        catLength = cat.length,
        totAngle = endAngle - startAngle,
        // eslint-disable-line good-practices/no-single-usage-variable
    tempAngle,
        cumilative = 0,
        // eslint-disable-line good-practices/no-single-usage-variable
    preDataOldEndAngle;

    for (i = 0; i < catLen; i += 1) {
      // store for letter use
      catObj = cat[i];
      catObj._userValue = numberFormatter.getCleanValue(catObj.value, true);
      catObj._value = (0, _lib.pluckNumber)(catObj._userValue, 1);
      totalValue += catObj._value;
    } // Total value can't be zero, since its used in denominator to find ratio.


    totalValue = totalValue || 1; // add the category

    sharePercent = totAngle / totalValue; // eslint-disable-line good-practices/no-single-usage-variable

    for (i = catLen - 1; i >= 0; i -= 1) {
      catObj = cat[i];
      catVal = sharePercent * catObj._value;
      label = (0, _lib.parseUnsafeString)((0, _lib.pluck)(catObj.label, catObj.name));
      valueStr = catObj._userValue !== null ? numberFormatter.dataLabels(catObj._userValue) : BLANK;
      pValueStr = numberFormatter.percentValue(catObj._value / totalValue * 100); // pointIndex = sLevel.length - 1;

      fillalpha = (0, _lib.pluckNumber)(catObj.alpha, dataSetConfig.alpha);
      showLabel = (0, _lib.pluckNumber)(catObj.showlabel, dataSetConfig.showLabels);
      showPlotBorder = (0, _lib.pluckNumber)(dataSetConfig.showplotborder, 1);
      displayValue = showLabel === 1 ? label : BLANK;

      if ((0, _lib.pluckNumber)(catObj.showvalue, dataSetConfig.showValues) === 1) {
        if (dataSetConfig.showPercentValues) {
          displayValue += displayValue !== BLANK ? labelSepChar + pValueStr : pValueStr;
        } else if (valueStr !== UNDEF && valueStr !== BLANK) {
          displayValue += displayValue !== BLANK ? labelSepChar + valueStr : valueStr;
        }
      }

      toolText = dataSetConfig.showTooltip ? (0, _lib.parseUnsafeString)((0, _lib.pluck)(catObj.tooltext, catObj.hovertext, dataSetConfig.tooltext), false) : UNDEF;

      if (toolText === BLANK) {
        toolText = label;

        if (dataSetConfig.showValuesInTooltip) {
          if (dataSetConfig.showPercentInTooltip) {
            toolText += toolText !== BLANK ? labelSepChar + pValueStr : pValueStr;
          } else if (valueStr !== UNDEF && valueStr !== BLANK) {
            toolText += toolText !== BLANK ? labelSepChar + valueStr : valueStr;
          }
        }
      } else {
        toolText = (0, _lib.parseTooltext)(toolText, [1, 2, 3, 14], {
          percentValue: pValueStr,
          label: label,
          formattedValue: valueStr
        }, catObj);
      }

      dataObj = data[i];
      tempAngle = startAngle + cumilative;
      cumilative += catVal;

      if (!dataObj) {
        dataObj = data[i] = {
          components: {
            data: []
          },
          config: {},
          graphics: {}
        };
      } // store old end angle for newly added element's aimation position


      if (dataObj.graphics.element) {
        preDataOldEndAngle = dataObj.config.startAngle + dataObj.config.angleStrech;
      }

      patternType = _column.PATTERN_TYPES.includes(catObj.patterntype) ? catObj.patterntype : dataSetConfig.patternType;
      patternAngle = (0, _lib.pluckNumber)(catObj.patternangle, dataSet.getFromEnv('chart-attrib').patternangle, patternType === _column.PATTERN_TYPES[0] ? 40 : 0);
      patternDensity = (0, _lib.pluckNumber)(catObj.patterndensity, dataSetConfig.patternDensity);
      patternSize = (0, _lib.pluckNumber)(catObj.patternsize, patternType === _column.PATTERN_TYPES[0] ? 2 : 4);
      patternAlpha = (0, _lib.pluckNumber)(catObj.patternalpha, dataSetConfig.patternAlpha);
      patternBgColor = (0, _lib.pluck)(catObj.patternbgcolor, dataSetConfig.patternBgColor);
      rawColor = catObj.color || dataSet.getFromEnv('color-manager').getPlotColor();
      dataObj.config = {
        patternType: patternType,
        patternAngle: patternAngle,
        patternDensity: patternDensity,
        patternSize: patternSize,
        patternAlpha: patternAlpha,
        patternBgColor: patternBgColor,
        initialAngle: preDataOldEndAngle || (parentObj.config || parentObj.config).initialAngle,
        startAngle: tempAngle,
        alpha: fillalpha,
        angleStrech: catVal,
        level: level,
        displayValue: displayValue,
        showLabel: showLabel,
        showPlotBorder: showPlotBorder,
        toolText: toolText,
        link: (0, _lib.getValidValue)(catObj.link),
        rawColor: rawColor,
        doNotSlice: true,
        // added to stop slicing
        color: (0, _lib.convertColor)(rawColor, fillalpha),
        borderAlpha: (0, _lib.pluck)(catObj.plotborderalpha, dataSetConfig.borderAlpha),
        borderWidth: (0, _lib.pluckNumber)(catObj.borderwidth, dataSetConfig.borderWidth),
        borderColor: (0, _lib.pluck)(catObj.bordercolor, dataSetConfig.borderColor),
        rawborderColor: (0, _lib.pluck)(catObj.bordercolor, dataSetConfig.rawborderColor),
        dashStyle: (0, _lib.pluckNumber)(catObj.valueborderdashed, 0) ? (0, _lib.getDashStyle)((0, _lib.pluckNumber)(catObj.borderdashlen, 4), (0, _lib.pluckNumber)(catObj.borderdashgap, 2)) : DASH_DEF,
        shadow: {
          opacity: Math.round(fillalpha > 50 ? fillalpha * fillalpha * fillalpha * 0.0001 : fillalpha * fillalpha * 0.01) * 0.01
        },
        isSingleTon: !(catLen > 1)
      };

      if (dataSetConfig.usePattern) {
        dataObj.config.borderColor = dataObj.config.color;
        dataObj.config.rawborderColor = (0, _lib.hashify)(rawColor);
      }

      dataObj.config.parent = parentObj;
      dataObj.config.dataLabelStyle = dataSet._configureDataLabelStyle(catObj);

      if (catObj.category) {
        maxLevel = Math.max(maxLevel, dataSet.addMSPieCat(catObj.category, level + 1, dataObj, tempAngle, catVal + tempAngle));

        if ((dataObjLen = dataObj.components.data.length) > (catObjLen = catObj.category.length)) {
          removalFn(dataObj.components.data.splice(dataObjLen - 1, catObjLen));
        }
      } else {
        dataObjLen = dataObj.components.data.length;

        if (dataObjLen) {
          // no child category, recursively remove existing childs (dataObj.components.data)
          removalFn(dataObj.components.data.splice(0, dataObjLen));
        }
      }
    } // remove estra data


    if (dataLength > catLength) {
      // recursively remove elements with child
      removalFn(data.splice(catLength));
    }

    return maxLevel;
  };

  _proto.parsePlotAttributes = function parsePlotAttributes(parentInstance) {
    var angle,
        parentObj = parentInstance,
        _textAttrs,
        centerDistance,
        level,
        dataSet = this,
        dataSetConfig = dataSet.config || {},
        chart = dataSet.getFromEnv('chart'),
        chartConfig = chart.config,
        len = dataSet.components.data.length,
        // eslint-disable-line good-practices/no-single-usage-variable
    seriesDataLabelsStyle = chartConfig.dataLabelStyle,
        setDataLabelStyle,
        canvasWidth = chartConfig.canvasWidth,
        canvasHeight = chartConfig.canvasHeight,
        cx = (0, _lib.pluckNumber)(dataSetConfig.originX, chartConfig.canvasLeft + canvasWidth * 0.5),
        cy = (0, _lib.pluckNumber)(dataSetConfig.originY, chartConfig.canvasTop + canvasHeight * 0.5),
        r,
        r2,
        color,
        val,
        displayValue,
        setLink,
        angle1,
        angle2,
        i,
        setGraphics,
        setConfig,
        element,
        pieSize = (0, _lib.pluckNumber)(dataSetConfig.pieRadius * 2, Math.min(canvasWidth, canvasHeight)),
        // innerRadius in diameter of inner circle
    innerRadius = calculateInnerRadius(dataSetConfig.innerRadius, pieSize / 2),
        pool = dataSet.config.pool || (dataSet.config.pool = {}),
        // either the user-specified size is chosen or the minimum aspect dimension is choosen
    // pieSize is diameter of full pie
    seriesHalfWidth = (pieSize - 2 * innerRadius) / (2 * dataSetConfig.maxLevel);

    dataSetConfig.innerSize = innerRadius * 2;

    if (!parentObj) {
      parentObj = dataSet;
    }

    len = parentObj.components.data.length; // eslint-disable-line good-practices/no-single-usage-variable

    for (i = 0; i < len; i += 1) {
      dataSet.parsePlotAttributes(parentObj.components.data[i]);
    }

    setConfig = parentObj.config;
    level = setConfig.level;

    if (level) {
      r = level * seriesHalfWidth + innerRadius;
      r2 = (level - 1) * seriesHalfWidth + innerRadius; // Save the radius value for later thickness calculation

      setConfig.outerRadius = r;
      setConfig.innerRadius = r2;
      setGraphics = parentObj.graphics;
      val = setConfig.angleStrech;
      displayValue = setConfig.displayValue; // toolText = setConfig.toolText;

      setLink = !!setConfig.link;
      color = setConfig.color;
      angle1 = setConfig.startAngle;
      angle2 = angle1 + setConfig.angleStrech;
      element = setGraphics.element;

      if (pool.element && pool.element.length) {
        element = setGraphics.element = element || pool.element.shift();
      }

      setConfig.plotItem = {
        chart: chart,
        link: setConfig.link,
        value: val,
        color: color,
        labelText: displayValue,
        graphics: {
          element: element
        },
        selfRef: parentObj
      };
      setConfig.eventArgs = {
        alpha: setConfig.alpha,
        borderAlpha: setConfig.borderAlpha,
        link: setConfig.link,
        label: setConfig.displayValue,
        showLabel: setConfig.showLabel,
        toolText: setConfig.toolText,
        color: setConfig.rawColor,
        borderColor: setConfig.rawborderColor,
        borderThickness: setConfig.borderWidth,
        showPlotBorder: setConfig.showPlotBorder
      };

      if (dataSetConfig.usePattern) {
        setConfig.eventArgs.pattern = {
          patternType: setConfig.patternType,
          patternColor: setConfig.rawColor,
          patternBgColor: setConfig.patternBgColor === _lib.TRACKER_FILL ? UNDEF : setConfig.patternBgColor
        };
        delete setConfig.eventArgs.color;
      }

      setConfig.props = {
        element: {
          attr: {
            ringpath: [cx, cy, r, r2, angle1, angle2],
            'stroke-width': setConfig.borderWidth,
            'stroke': setConfig.borderColor,
            fill: (0, _lib.toRaphaelColor)(setConfig.color),
            'stroke-dasharray': setConfig.dashStyle,
            cursor: setLink ? POINTER : _lib.BLANKSTRING
          }
        }
      };
      setConfig.props.element.patternAttr = {
        patternType: setConfig.patternType,
        patternAngle: setConfig.patternAngle,
        patternDensity: setConfig.patternDensity,
        patternSize: setConfig.patternSize,
        color: setConfig.color,
        patternAlpha: setConfig.patternAlpha,
        patternBgColor: setConfig.patternBgColor,
        alpha: setConfig.alpha,
        x: cx,
        y: cy
      };

      if (displayValue !== UNDEF && displayValue !== _lib.BLANKSTRING) {
        angle = (angle1 + angle2) / 2; // for the innermost Concentric circle the center distance is presumed to be zero

        centerDistance = r2 === 0 && setConfig.isSingleTon ? 0 : r2 + (r - r2) / 2;

        if (!(_textAttrs = setConfig._textAttrs)) {
          _textAttrs = setConfig._textAttrs = {};
        }

        setDataLabelStyle = setConfig.dataLabelStyle;
        _textAttrs.text = displayValue;
        _textAttrs.fill = setDataLabelStyle.color || COLOR_000000;
        _textAttrs.direction = chartConfig.textDirection;
        _textAttrs.cursor = setLink ? POINTER : _lib.BLANKSTRING;
        _textAttrs.x = cx + centerDistance * Math.cos(angle);
        _textAttrs.y = cy + centerDistance * Math.sin(angle);
        _textAttrs['line-height'] = seriesDataLabelsStyle.lineHeight;
        _textAttrs['text-bound'] = [setDataLabelStyle.backgroundColor, setDataLabelStyle.borderColor, seriesDataLabelsStyle.borderThickness, seriesDataLabelsStyle.borderPadding, seriesDataLabelsStyle.borderRadius, seriesDataLabelsStyle.borderDash];
      }
    }
  }
  /**
   * Parses label attributes and position during post space management
   *
   * @param {any} parentObj
   * @memberof MultiLevelPieDataset
   */
  ;

  _proto.parseLabelAttributes = function parseLabelAttributes(parentInstance) {
    var dataSet = this,
        parentObj = parentInstance,
        len = dataSet.components.data.length,
        // eslint-disable-line good-practices/no-single-usage-variable
    displayValue,
        i,
        setConfig; // dataLabelsLayer.show();

    !parentObj && (parentObj = dataSet);
    len = parentObj.components.data.length; // eslint-disable-line good-practices/no-single-usage-variable

    for (i = 0; i < len; i += 1) {
      dataSet.parseLabelAttributes(parentObj.components.data[i]);
    }

    setConfig = parentObj.config; // plotItem = setConfig.plotItem;

    displayValue = setConfig.displayValue;

    if (setConfig.level) {
      if (displayValue !== UNDEF && displayValue !== _lib.BLANKSTRING) {
        setConfig.props.label = {
          attr: setConfig._textAttrs
        };
      }
    }
  };

  _proto.draw = function draw(parentInstance) {
    var dataSet = this,
        parentObj = parentInstance,
        dataSetConfig = dataSet.config,
        chart = dataSet.getFromEnv('chart'),
        dataSetComponents = dataSet.components,
        len = dataSetComponents.data.length,
        // eslint-disable-line good-practices/no-single-usage-variable
    i,
        setGraphics,
        setConfig,
        element,
        dataLabelsLayer = chart.getChildContainer('datalabelsGroup'),
        events = dataSetConfig.events || {},
        plotHoverFN = function plotHoverFN(e) {
      var o = this,
          mouseOver = events.mouseOver,
          plotItem = o.plotItem || o.data('plotItem'),
          dataset = plotItem.chart.getDatasets()[0]; // eslint-disable-line good-practices/no-single-usage-variable

      chart.plotEventHandler(o, e, ROLLOVER);
      mouseOver && mouseOver.call(o);
      dataset.fireEvent('datasetrollover', {
        pValue: plotItem.pValue,
        value: plotItem.value,
        displayValue: setConfig.displayValue
      });
    },
        plotMouseOut = function plotMouseOut(e) {
      var o = this,
          mouseOut = events.mouseOut,
          plotItem = o.plotItem || o.data('plotItem'),
          chartAPI = plotItem.chart,
          dataset = chartAPI.getDatasets()[0]; // eslint-disable-line good-practices/no-single-usage-variable

      chartAPI.plotEventHandler(o, e, ROLLOUT);
      mouseOut && mouseOut.call(o);
      dataset.fireEvent('datasetrollout', {
        pValue: plotItem.pValue,
        value: plotItem.value,
        displayValue: setConfig.displayValue
      });
    },
        // Fired when clicked over the hot elements.
    clickFunc = function clickFunc(setDataArr) {
      var ele = this; // eslint-disable-line good-practices/no-single-usage-variable

      chart.plotEventHandler(ele, setDataArr);
    },
        pool = dataSet.config.pool || (dataSet.config.pool = {}),
        removeDataArr = dataSetComponents.removeDataArr; // dataSetConfig.innerSize = innerRadius * 2;


    removeDataArr && removeDataArr.length && dataSet.removeElement();

    if (!parentObj) {
      parentObj = dataSet;
      dataLabelsLayer.css(chart.config.dataLabelStyle);
    }

    len = parentObj.components.data.length; // eslint-disable-line good-practices/no-single-usage-variable

    for (i = 0; i < len; i += 1) {
      dataSet.draw(parentObj.components.data[i]);
    }

    setConfig = parentObj.config;

    if (setConfig.level) {
      setGraphics = parentObj.graphics;
      element = setGraphics.element;

      if (pool.element && pool.element.length) {
        element = setGraphics.element = element || pool.element.shift();
      } // Create/reuse element


      element = setGraphics.element = dataSet.getFromEnv('animationManager').setAnimation({
        el: setGraphics.element || 'ringpath',
        attr: setConfig.props.element.attr,
        container: chart.getChildContainer('plotGroup'),
        component: dataSet,
        state: 'appearing',
        label: 'ringpath'
      });
      element.addPattern(setConfig.props.element.patternAttr, dataSetConfig.usePattern);
      element.shadow(dataSetConfig.showShadow && !!setConfig.shadow).data('plotItem', setConfig.plotItem).data(EVENTARGS, setConfig.eventArgs).on('fc-mouseover', plotHoverFN).on('fc-mouseout', plotMouseOut).on('fc-click', clickFunc);
      dataSet.getFromEnv('toolTipController').enableToolTip(element, setConfig.toolText);

      if (!i && !dataSetConfig._drawn) {
        dataSetConfig._drawn = true;
        dataLabelsLayer.show();
        dataSet.addJob('labelJob', dataSet.drawLabel.bind(dataSet), _schedular.priorityList.label);
      }
    } else {
      // If the chart is already drawn, then instead of sheduling the label drawing, directly draw the
      // labels.
      dataSetConfig._drawn && dataSet.drawLabel(); // at the end of all the tree structure, hide all the pool elements.

      dataSet.removeChild(dataSet.config.pool, true);
    }
  };

  _proto.drawLabel = function drawLabel(parentInstance) {
    var dataSet = this,
        config = dataSet.config,
        parentObj = parentInstance,
        chart = dataSet.getFromEnv('chart'),
        smartLabel = dataSet.getFromEnv('smartLabel'),
        labelSmartObj,
        angle,
        angleStretch,
        animationManager = dataSet.getFromEnv('animationManager'),
        chartConfig = chart.config,
        labelAttrs,
        len = dataSet.components.data.length,
        // eslint-disable-line good-practices/no-single-usage-variable
    tooltipOptions = chartConfig.tooltip || {},
        isTooltip = tooltipOptions && tooltipOptions.enabled !== false,
        // eslint-disable-line good-practices/no-single-usage-variable
    toolText,
        displayValue,
        tempLabel,
        i,
        setGraphics,
        setConfig,
        label,
        events = (config || {}).events || {},
        labelHoverFN = function labelHoverFN(e) {
      var o = this,
          mouseOver = events.mouseOver;
      chart.plotEventHandler(o, e, ROLLOVER);
      mouseOver && mouseOver.call(o);
    },
        labelOutFN = function labelOutFN(e) {
      var o = this,
          mouseOut = events.mouseOut;
      chart.plotEventHandler(o, e, ROLLOUT);
      mouseOut && mouseOut.call(o);
    },
        // Fired when clicked over the hot elements.
    clickFunc = function clickFunc(setDataArr) {
      var ele = this; // eslint-disable-line good-practices/no-single-usage-variable

      chart.plotEventHandler(ele, setDataArr);
    },
        pool = config.pool || (config.pool = {}),
        dataLabelsLayer = chart.getChildContainer('datalabelsGroup');

    dataLabelsLayer.show();
    !parentObj && (parentObj = dataSet);
    len = parentObj.components.data.length; // eslint-disable-line good-practices/no-single-usage-variable

    for (i = 0; i < len; i += 1) {
      dataSet.drawLabel(parentObj.components.data[i]);
    }

    setConfig = parentObj.config;
    displayValue = setConfig.displayValue;

    if (setConfig.level) {
      setGraphics = parentObj.graphics;
      tempLabel = setGraphics.label;
      angleStretch = setConfig.angleStrech; // Condition to check if skipOverlapLabels is set to true

      if (displayValue !== UNDEF && displayValue !== _lib.BLANKSTRING && (!config.skipOverlapLabels || config.skipOverlapLabels && angleStretch > 0.1)) {
        label = setGraphics.label;

        if (pool.label && pool.label.length) {
          label = setGraphics.label = label || pool.label.shift();
        }

        labelAttrs = setConfig.props.label.attr;

        if (config.autoRotateLabels) {
          // Angle calculation for label rotation
          angle = (setConfig.startAngle + angleStretch / 2) * 180 / Math.PI;

          if (Math.abs(angle) > 90 && Math.abs(angle) < 180) {
            angle = -(180 - angle);
          }

          if (Math.floor(angleStretch * 180 / Math.PI) === 360) {
            angle = 0;
          } // Use smart label when autoRotateLabels is set to true


          smartLabel.useEllipsesOnOverflow(config.useEllipsesWhenOverflow);
          smartLabel.setStyle(chartConfig.dataLabelStyle);
          labelSmartObj = smartLabel.getSmartText(displayValue, setConfig.outerRadius - setConfig.innerRadius - 10, smartLabel._lineHeight);
          labelAttrs.text = labelSmartObj.text;
          labelAttrs.transform = (0, _lib.getSuggestiveRotation)(parseFloat(angle), labelAttrs.x, labelAttrs.y);
        } else {
          labelAttrs.transform = (0, _lib.getSuggestiveRotation)(0, labelAttrs.x, labelAttrs.y);
        } // Create/Reuse label


        label = setGraphics.label = animationManager.setAnimation({
          el: tempLabel || 'text',
          attr: labelAttrs,
          container: dataLabelsLayer,
          component: dataSet,
          state: 'appearing',
          label: 'text'
        });
        label.outlineText(config.showTextOutline, labelAttrs.fill);

        if (!tempLabel) {
          label.on('fc-click', clickFunc).on('fc-mouseout', labelOutFN).on('fc-mouseover', labelHoverFN);
        }

        label.data('plotItem', setConfig.plotItem).data(EVENTARGS, setConfig.eventArgs);
        isTooltip && dataSet.getFromEnv('toolTipController').enableToolTip(label, toolText);
      } else {
        // In case of extra labels, hide them
        tempLabel && animationManager.setAnimation({
          el: tempLabel,
          component: dataSet,
          label: 'text'
        });
        delete setGraphics.label;
      }
    } else {
      // at the end of all the tree structure, hide all the pool elements.
      dataSet.removeChild(dataSet.config.pool, true);
    }
  };

  return MultiLevelPieDataset;
}(_pie2d.default);

var _default = MultiLevelPieDataset;
exports["default"] = _default;

/***/ }),

/***/ 1453:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



exports.__esModule = true;
exports["default"] = void 0;

var _polarUtil = __webpack_require__(1454);

var _default = {
  'initial.dataset.radar': function initialDatasetRadar() {
    return {
      'anchor.appearing': function anchorAppearing() {
        return [{
          initialAttr: {
            opacity: 0
          },
          finalAttr: {
            opacity: 1
          },
          startEnd: {
            start: 0.5,
            end: 1
          },
          slot: 'plot'
        }];
      },
      'anchor.updating': function anchorUpdating() {
        return [{
          initialAttr: {
            opacity: 0
          },
          finalAttr: {
            opacity: 1
          },
          slot: 'final'
        }];
      },
      'anchor.disappearing': function anchorDisappearing() {
        return [{
          finalAttr: {
            opacity: 0,
            'fill-opacity': 0,
            'stroke-opacity': 0
          },
          slot: 'final'
        }];
      },
      'line.appearing': function lineAppearing(inputJSON) {
        var dataset = inputJSON.component,
            xAxis = dataset.getFromEnv('xAxis'),
            yAxis = dataset.getFromEnv('yAxis'),
            catLen = xAxis.getTicksLen(),
            chartConfig = dataset.getFromEnv('chartConfig'),
            finalAttr = inputJSON.attr,
            value = chartConfig.canvasTop + chartConfig.canvasHeight / 2,
            initialPath = [],
            i;

        for (i = 0; i < catLen; i++) {
          initialPath.push(i ? 'L' : 'M');
          initialPath.push((0, _polarUtil.getCoordinates)({
            radius: value,
            theta: 0
          }, xAxis).x);
          initialPath.push(yAxis.getPixel(0));
        }

        initialPath.push('Z');
        return [{
          initialAttr: {
            opacity: 0,
            path: initialPath
          },
          finalAttr: {
            opacity: 1,
            path: finalAttr.path
          },
          startEnd: {
            start: 0,
            end: 0.5
          },
          slot: 'middle'
        }];
      },
      'label.appearing': [{
        initialAttr: {
          opacity: 0
        },
        finalAttr: {
          opacity: 1
        },
        slot: 'final'
      }],
      '*': null
    };
  }
};
exports["default"] = _default;

/***/ }),

/***/ 1452:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _area = _interopRequireDefault(__webpack_require__(617));

var _index = _interopRequireDefault(__webpack_require__(1453));

var _dependencyManager = __webpack_require__(282);

var _polarUtil = __webpack_require__(1454);

var _lib = __webpack_require__(274);

/* eslint require-jsdoc: 'error', valid-jsdoc: ["error", { "requireReturn": false }] */
var COMMASTRING = ',',
    UNDEF,
    M = 'M',
    L = 'L',
    Z = 'Z',
    dropHash = _lib.regex.dropHash;
(0, _dependencyManager.addDep)({
  name: 'radarAnimation',
  type: 'animationRule',
  extension: _index.default
});
/**
 * Creates the Radar Dataset
 * @class
 */

var RadarDataset = /*#__PURE__*/function (_AreaDataset) {
  (0, _inheritsLoose2.default)(RadarDataset, _AreaDataset);

  function RadarDataset() {
    var _this;

    _this = _AreaDataset.call(this) || this; // eslint-disable-next-line good-practices/no-function-dependency

    _this.getPathArr = function () {
      var pathObj = this,
          pathArr = pathObj.pathArr,
          path2Arr = pathObj.path2Arr;

      if (pathArr.length || path2Arr.length) {
        return pathArr.concat(path2Arr);
      }

      return [];
    };

    return _this;
  }
  /**
   * return name
   * @return {string} - component name
   */


  var _proto = RadarDataset.prototype;

  _proto.getName = function getName() {
    return 'radar';
  }
  /**
   * Create pixel coordinates for the plots
   */
  ;

  _proto.createCoordinates = function createCoordinates() {
    var dataSet = this,
        chartConfig = dataSet.getFromEnv('chartConfig'),
        dataObj,
        config,
        previousY,
        i,
        Px,
        Py,
        len = dataSet.components.data.length,
        // eslint-disable-line good-practices/no-single-usage-variable
    dataStore = dataSet.components.data,
        // eslint-disable-line good-practices/no-single-usage-variable
    xPos,
        yPos,
        setValue;

    for (i = 0; i < len; i++) {
      dataObj = dataStore[i];
      config = dataObj && dataObj.config;
      setValue = config.setValue;

      if (dataObj === UNDEF) {
        continue;
      }

      yPos = dataSet.getFromEnv('yAxis').getPixel(setValue + (previousY || 0));
      xPos = (0, _polarUtil.getCoordinates)({
        radius: chartConfig.canvasTop + chartConfig.canvasHeight / 2 - yPos,
        theta: i
      }, dataSet.getFromEnv('xAxis')); // xPos = xAxis.getPixel(i, (chartConfig.canvasTop + chartConfig.canvasHeight / 2) - yPos);

      Py = xPos.y;
      Px = xPos.x;
      config._Px = Px;
      config._Py = Py;
      config._Pbx = Px;
      config._Pby = Py;
    }
  }
  /**
   * Gets the path for the line plot.
   * @param {Object} data data object
   * @param {Object} positions position object
   * @param {boolean} type represents whether it is of type 'base'
   * @return {Object} path details
   */
  ;

  _proto.getLinePath = function getLinePath(data, positions, type) {
    var dataset = this,
        chartConfig = dataset.getFromEnv('chartConfig'),
        // eslint-disable-line good-practices/no-single-usage-variable
    obj = {},
        // Used for determining whether the last value was valid
    // Initially it is false
    lastValidValue = obj.lastValidValue || false,
        temp = obj.temp || [],
        temp2 = obj.temp2 || [],
        // eslint-disable-line good-practices/no-single-usage-variable
    pathArr = obj.pathArr || [],
        i,
        config,
        xPos,
        yPos,
        pointsJoined = obj.pointsJoined || 0,
        dataObj,
        setValue,
        startPos = positions && positions.begin || 0,
        // eslint-disable-line good-practices/no-single-usage-variable
    endPos = positions && positions.end || data.length,
        // eslint-disable-line good-practices/no-single-usage-variable
    step = chartConfig.viewPortConfig.step || 1,
        // eslint-disable-line good-practices/no-single-usage-variable
    yAxis = dataset.getFromEnv('yAxis'),
        xAxis = dataset.getFromEnv('xAxis'),
        baseZero = yAxis.getPixel(0),
        // eslint-disable-line good-practices/no-single-usage-variable
    removeDataLen = dataset.removeDataLen || 0,
        // eslint-disable-line good-practices/no-single-usage-variable
    dataWithRemovedPaths = []; // Added current dataStore to arr

    dataWithRemovedPaths = dataWithRemovedPaths.concat(data);

    for (i = startPos; i < endPos + removeDataLen; i += step) {
      dataObj = dataWithRemovedPaths[i];

      if (!dataObj) {
        continue;
      }

      config = dataObj.config;
      setValue = config.setValue;

      if (setValue === null || config && config.isSkipped === true) {
        // xPos = xAxis.getPixel(xAxis.getLimit().min).x;
        xPos = (0, _polarUtil.getCoordinates)({
          theta: xAxis.getLimit().min
        }, xAxis).x;
        yPos = yAxis.getPixel(yAxis.config.axisRange.min);
      } else {
        xPos = config._Px;
        yPos = config._Py;
      } // take base or zero y value for animation


      if (type === 'zero') {
        yPos = baseZero;
      } else if (type === 'base') {
        yPos = config._Pby;
      }

      if (lastValidValue) {
        if (temp.length) {
          pathArr = pathArr.concat(temp);
          temp = [];
          pointsJoined++;
        } // Push the upper x and y position to pathArr


        pathArr.push([L, xPos, yPos]);
      } else {
        // Push the upper x and y positions of area plot to temp
        temp.push([M, xPos, yPos]); // No points are joined when starting a new path

        pointsJoined = 0;
        lastValidValue = true;
      }
    } // If path is not closed and any points are joined then close the path


    if (pathArr[pathArr.length - 1] !== Z && pointsJoined > 0) {
      pathArr.push(Z);
    }

    return {
      pathArr: pathArr,
      path2Arr: [],
      lastValidValue: lastValidValue,
      pointsJoined: pointsJoined,
      temp: temp,
      temp2: temp2,
      getPathArr: dataset.getPathArr
    };
  }
  /**
   * Parses all the attributes for dataset level and set level
   * Called from init function of area class and line class
   * Both line and area attributes configuration is done here
   * @param {Object} datasetJSON the data provided by user
   * @return {boolean} false if datasetJSON is undefined
   */
  ;

  _proto.configureAttributes = function configureAttributes(datasetJSON) {
    if (!datasetJSON) {
      return false;
    }

    this.trimData(datasetJSON);
    this.JSONData = datasetJSON;
    var dataset = this,
        conf = dataset.config,
        chart = dataset.getFromEnv('chart'),
        // eslint-disable-line good-practices/no-single-usage-variable
    chartAttr = chart.getFromEnv('dataSource').chart,
        JSONData = dataset.JSONData,
        plotColor = dataset.getFromEnv('color-manager').getPlotColor(dataset.index);

    _AreaDataset.prototype.configureAttributes.call(this, datasetJSON);

    conf.defaultPadding = {
      left: 0,
      right: 0
    };
    conf.plotfillcolor = (0, _lib.pluck)(JSONData.color, chartAttr.plotfillcolor, plotColor);
    conf.plotbordercolor = (0, _lib.pluck)(JSONData.plotbordercolor, chartAttr.plotbordercolor, chartAttr.areabordercolor, plotColor).split(COMMASTRING)[0];
    conf.plotborderColorObject = {
      color: conf.plotbordercolor,
      alpha: conf.plotborderalpha,
      angle: conf.plotfillangle
    };
    conf.fillColor = {
      color: conf.plotfillcolor + (conf.plotgradientcolor ? COMMASTRING + conf.plotgradientcolor : _lib.BLANKSTRING),
      alpha: conf.plotfillalpha,
      angle: conf.plotfillangle
    };
    conf.legendSymbolColor = conf.plotfillcolor;
  }
  /**
   * Function that return the nearest plot details
   * @param   {number} chartX x-axis position of the mouse cordinate
   * @param   {number} chartY y-axis position of the mouse cordinate
   * @return {Object} return an object with details of nearest plot and whether it is
   *                   hovered or not
   */
  ;

  _proto._getHoveredPlot = function _getHoveredPlot(chartX, chartY) {
    var dataset = this,
        xAxis = dataset.getFromEnv('xAxis'),
        dataStore = dataset.components.data,
        pointObj,
        xMin,
        xMax,
        len = dataStore.length,
        returnValue,
        conf = dataset.config,
        divAngle = 360 / len,
        i;
    xMin = Math.floor(Math.max((0, _polarUtil.getPlotFromPixel)({
      // eslint-disable-line good-practices/no-single-usage-variable
      x: chartX - conf.maxRadius,
      y: chartY
    }, xAxis) / divAngle - 1, 0));
    xMax = Math.floor(Math.max((0, _polarUtil.getPlotFromPixel)({
      // eslint-disable-line good-practices/no-single-usage-variable
      x: chartX + conf.maxRadius,
      y: chartY
    }, xAxis) / divAngle, len - 1));

    for (i = xMax; i >= xMin; i--) {
      pointObj = dataStore[i];

      if (pointObj) {
        returnValue = dataset.isWithinShape(pointObj, i, chartX, chartY);

        if (returnValue) {
          break;
        }
      }
    }

    return returnValue;
  }
  /**
   * function to check if the context of dataset is chanegd or not
   * if changed then it will return staus true. It is for further infomormation to redraw a dataset
   *
   * @returns {boolean} status of context change
   * @memberof RadarDataset
   */
  ;

  _proto._contextChanged = function _contextChanged() {
    if (!this.config.context) {
      this.config.context = {};
    }

    var dataset = this,
        status,
        context = dataset.config.context,
        oldAxisCenterX = context.axisCenterX,
        // eslint-disable-line good-practices/no-single-usage-variable
    newAxisCenterX; // Find new center of polar category axis.

    newAxisCenterX = dataset.getFromEnv('xAxis').config.axisDimention.centerX; // If new center of polar category axis is different from old center, redraw is needed.

    status = !(newAxisCenterX === oldAxisCenterX); // eslint-disable-line good-practices/no-single-usage-variable

    context.axisCenterX = newAxisCenterX;
    return status || _AreaDataset.prototype._contextChanged.call(this);
  }
  /**
   * Returns the details of the plot in the category band that the givennt x and y co-ordinates
   * are in.
   *
   * @param {number} [chartX=0] x-axis position of the mouse cordinate
   * @param {number} [chartY=0] y-axis position of the mouse cordinate
   *
   * @return {Object} Return an object with details of nearest plot in the category band.
   */
  ;

  _proto.getPlotInCategoryAt = function getPlotInCategoryAt(chartX, chartY) {
    var plots = this.components.data,
        // eslint-disable-line good-practices/no-single-usage-variable
    categoryAxis = this.getFromEnv('xAxis'),
        isDatasetVisible = this.getState('visible'),
        hoveredCategoryIndex = Math.round((0, _polarUtil.getPlotFromPixel)({
      x: chartX,
      y: chartY
    }, categoryAxis)),
        foundPlot = plots.find(function (plot, idx, plotArr) {
      var plotCategoryIndex, nextPlotCategoryIndex, prevPlotCategoryIndex, halfCategoryDiff, nextPlot, prevPlot;

      if (idx === 0) {
        nextPlot = plotArr[idx + 1]; // For the first plot, the previous plot will be the last plot in the array of plots

        prevPlot = plotArr[plotArr.length - 1];
      } else if (idx === plotArr.length - 1) {
        // For the last plot, the next plot will be the first plot in the array of plots
        nextPlot = plotArr[0];
        prevPlot = plotArr[plotArr.length - 2];
      } else {
        // For any other plot just select the plot immediately before and after the current plot
        nextPlot = plotArr[idx + 1];
        prevPlot = plotArr[idx - 1];
      } // plotCategoryIndex = categoryAxis.getAngle(plot.config._Px, plot.config._Py);


      plotCategoryIndex = (0, _polarUtil.getPlotFromPixel)({
        // eslint-disable-line good-practices/no-single-usage-variable
        x: plot.config._Px,
        y: plot.config._Py
      }, categoryAxis); // For the last plot, the category band will end at 360 degrees

      nextPlotCategoryIndex = idx === plotArr.length - 1 ? 360 // categoryAxis.getAngle(nextPlot.config._Px, nextPlot.config._Py);
      : (0, _polarUtil.getPlotFromPixel)({
        x: nextPlot.config._Px,
        y: nextPlot.config._Py
      }, categoryAxis); // prevPlotCategoryIndex = categoryAxis.getAngle(prevPlot.config._Px, prevPlot.config._Py);

      prevPlotCategoryIndex = (0, _polarUtil.getPlotFromPixel)({
        // eslint-disable-line good-practices/no-single-usage-variable
        x: prevPlot.config._Px,
        y: prevPlot.config._Py
      }, categoryAxis); // The angle at which the category ends and the next category starts

      halfCategoryDiff = (nextPlotCategoryIndex - plotCategoryIndex) / 2;

      if (hoveredCategoryIndex <= 0 + halfCategoryDiff) {
        // If the mouse is over an angle less than where the first category ends
        return hoveredCategoryIndex >= 0 && hoveredCategoryIndex <= 0 + halfCategoryDiff;
      } else if (hoveredCategoryIndex > 360 - halfCategoryDiff) {
        // If the mouse is over an angle greater than where the last category band ends
        return hoveredCategoryIndex >= 360 - halfCategoryDiff && hoveredCategoryIndex <= 360;
      }

      return hoveredCategoryIndex >= prevPlotCategoryIndex + halfCategoryDiff && hoveredCategoryIndex <= nextPlotCategoryIndex - halfCategoryDiff;
    }),
        hoveredPlotInfo = this._getHoveredPlot(chartX, chartY);

    if (isDatasetVisible && hoveredPlotInfo) {
      // If dataset is visible and the mouse is exactly over a plot
      return hoveredPlotInfo;
    } else if (isDatasetVisible && foundPlot) {
      // If dataset is visible and the mouse is over a category band
      return {
        pointIndex: foundPlot._index,
        hovered: false,
        pointObj: foundPlot
      };
    } // If dataset is not visible and no relevant plot was found


    return false;
  }
  /**
   * Function to register datasets in the internal data store of legend class.
   */
  ;

  _proto._addLegend = function _addLegend() {
    var dataset = this,
        strokeColor,
        fillColor,
        conf = dataset.config,
        chartAttr = dataset.getFromEnv('chart-attrib'),
        legendItem,
        legend = dataset.getFromEnv('legend'),
        color = conf.legendSymbolColor,
        lightColor,
        use3DLighting = (0, _lib.pluckNumber)(chartAttr.use3dlighting, chartAttr.useplotgradientcolor, 1); // eslint-disable-line good-practices/no-single-usage-variable

    strokeColor = (0, _lib.getLightColor)(color, 60).replace(dropHash, _lib.HASHSTRING); // eslint-disable-line good-practices/no-single-usage-variable

    if (use3DLighting) {
      lightColor = (0, _lib.getLightColor)(color, 40);
      fillColor = {
        FCcolor: {
          color: color + ',' + color + ',' + lightColor + ',' + color + ',' + color,
          ratio: '0,70,30',
          angle: 270,
          alpha: '100,100,100,100,100'
        }
      };
    } else {
      fillColor = {
        FCcolor: {
          color: color,
          angle: 0,
          ratio: '0',
          alpha: '100'
        }
      };
    }

    if (conf.includeinlegend) {
      legendItem = legend.getItem(dataset.config.legendItemId);

      if (!legendItem) {
        dataset.config.legendItemId = legend.createItem(dataset);
        legendItem = legend.getItem(dataset.config.legendItemId);
        dataset.addExtEventListener('fc-click', function () {
          legendItem.itemClickFn();
        }, legendItem);
      }

      legendItem.configure({
        enabled: conf.includeInLegend,
        type: dataset.type,
        label: (0, _lib.getFirstValue)(dataset.JSONData.seriesname),
        legendIconAlpha: (0, _lib.pluckNumber)(dataset.JSONData.legendiconalpha),
        usePattern: conf.usePattern,
        patternAttr: {
          patternType: conf.patternType,
          patternAngle: conf.patternAngle,
          patternDensity: conf.patternDensity,
          patternSize: conf.patternSize,
          color: conf.plotColor,
          patternAlpha: conf.patternAlpha,
          patternBgColor: conf.patternBgColor,
          alpha: conf.plotfillalpha
        }
      });
      legendItem.setStateCosmetics('default', {
        symbol: {
          fill: (0, _lib.toRaphaelColor)(fillColor),
          bgAlpha: (0, _lib.pluckNumber)(dataset.JSONData.legendiconbgalpha, dataset.JSONData.legendiconalpha, chartAttr.legendiconbgalpha, chartAttr.legendiconalpha, conf.plotfillalpha),
          borderAlpha: (0, _lib.pluckNumber)(dataset.JSONData.legendiconborderalpha, dataset.JSONData.legendiconalpha, chartAttr.legendiconborderalpha, chartAttr.legendiconalpha, '100'),
          rawFillColor: color,
          stroke: (0, _lib.toRaphaelColor)(strokeColor)
        }
      }); // check if dataset is initiallyhidden

      if (!dataset.getState('visible')) {
        legendItem.setLegendState('hidden');
      } else {
        // remove hidden state of legend item is dataset is not hidden
        legendItem.removeLegendState('hidden');
      }
    } else if (dataset.config.legendItemId) {
      legend.disposeItem(dataset.config.legendItemId);
    }
  }
  /**
   * Calculate current pos w.r.t prev for an array
   * @param   {Object}  pathVal   current path
   * @param   {Object}  lim    x,y axis limits
   * @return {Array}          Old path
   */
  ;

  _proto.getOldPath = function getOldPath(pathVal, lim) {
    var dataSet = this,
        path = pathVal,
        xLim = lim.x,
        yLim = lim.y,
        oldLim = dataSet.config && dataSet.config.prevLim,
        oldLimX = oldLim.x,
        oldLimY = oldLim.y,
        i = 0,
        ii = path.pathArr.length,
        // eslint-disable-line good-practices/no-single-usage-variable
    item,
        getOldValX = function getOldValX(value) {
      // getting ratio by pixels
      var val = value;
      val = (val - oldLimX.minPixel.x) / (oldLimX.maxPixel.x - oldLimX.minPixel.x); // ratio to value

      val = val * (oldLimX.max - oldLimX.min) + oldLimX.min; // value in old ratio

      val = (val - xLim.min) / (xLim.max - xLim.min); // return position in previous

      return val * (xLim.maxPixel.x - xLim.minPixel.x) + xLim.minPixel.x + 1;
    },
        getOldValY = function getOldValY(value) {
      var val = value;

      if (val < oldLimY.base && val > yLim.base || val > oldLimY.base && val < yLim.base) {
        val = yLim.base;
      }

      return val - 1;
    },
        getOldValYBase = function getOldValYBase(val) {
      if (val === oldLimY.base) {
        return yLim.base;
      }

      return getOldValY(val);
    };

    if (oldLimY.min === yLim.min && oldLimX.min === xLim.min && oldLimY.max === yLim.max && oldLimX.max === xLim.max) {
      return path;
    }

    path = (0, _lib.extend2)({}, path);

    if (!oldLim) {
      return [];
    } // generating new copy of array


    path.pathArr = path.pathArr.slice(0);
    path.path2Arr = path.path2Arr.slice(0);

    for (i = ii; i--;) {
      item = path.pathArr[i].slice(0); // check if array

      if (!item[1] || !item.join) {
        continue;
      }

      item[1] = getOldValX(item[1]);
      item[2] = getOldValYBase(item[2]);
      path.pathArr[i] = item;
    }

    for (i = path.path2Arr.length; i--;) {
      item = path.path2Arr[i].slice(0); // check if array

      if (!item[1] || !item.join) {
        continue;
      }

      item[1] = getOldValX(item[1]);
      item[2] = getOldValYBase(item[2]);
      path.path2Arr[i] = item;
    }

    return path;
  }
  /**
   * Configure data level
   */
  ;

  _proto._setConfigure = function _setConfigure() {
    var dataSet = this,
        conf = dataSet.config,
        setDataArr = dataSet.config.JSONData.data || [],
        setData,
        dataObj,
        len = dataSet.getFromEnv('xAxis').getTicksLen(),
        // eslint-disable-line good-practices/no-single-usage-variable
    dataStore,
        i;
    conf.imageCount = 0;
    dataStore = dataSet.components.data;

    if (!dataStore) {
      dataStore = dataSet.components.data = [];
    }

    conf.maxRadius = -Infinity;

    for (i = 0; i < len; i++) {
      dataObj = dataStore[i];
      setData = setDataArr && setDataArr[i] || {};

      if (!dataObj) {
        dataObj = dataStore[i] = {};
      }

      if (!dataObj.config) {
        dataStore[i].config = {};
      }

      if (!dataObj.graphics) {
        dataObj.graphics = {};
      }

      dataSet._plotConfigure(i, setData);
    }
  };

  return RadarDataset;
}(_area.default);

var _default = RadarDataset;
exports["default"] = _default;

/***/ }),

/***/ 1436:
/***/ ((__unused_webpack_module, exports) => {



exports.__esModule = true;
exports["default"] = void 0;
var _default = {
  '*.dataset.sankey': function datasetSankey() {
    var dataset = this,
        clipCanvas = dataset.getClip('canvas'),
        clipCanvasInit = dataset.getClip('init');
    return {
      'linkGroup.appearing': function linkGroupAppearing() {
        return [{
          initialAttr: {
            'clip-rect': clipCanvasInit
          },
          finalAttr: {
            'clip-rect': clipCanvas
          },
          slot: 'plot'
        }];
      },
      'nodeGroup.appearing': function nodeGroupAppearing() {
        return [{
          initialAttr: {
            opacity: 0
          },
          finalAttr: {
            opacity: 1
          },
          slot: 'axis'
        }];
      },
      'nodeLabelGroup.appearing': function nodeLabelGroupAppearing() {
        return [{
          initialAttr: {
            opacity: 0
          },
          finalAttr: {
            opacity: 1
          },
          slot: 'final'
        }];
      }
    };
  }
};
exports["default"] = _default;

/***/ }),

/***/ 1429:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _defineProperty2 = _interopRequireDefault(__webpack_require__(273));

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _componentInterface = __webpack_require__(290);

var _sankeyNodeFactory = _interopRequireDefault(__webpack_require__(1430));

var _sankeyLinkFactory = _interopRequireDefault(__webpack_require__(1432));

var _sankeyhelper = __webpack_require__(1435);

var _dependencyManager = __webpack_require__(282);

var _index = _interopRequireDefault(__webpack_require__(1436));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var GUTTER5 = 5,
    START = 'start',
    INSIDE = 'inside',
    END = 'end',
    BLANK = '',
    HORIZONTAL = 'horizontal',
    NODEROLLOVER = 'dataPlotRollOver',
    NODEROLLOUT = 'dataPlotRollOut',
    NODECLICK = 'dataPlotClick',
    LINKROLLOVER = 'linkRollOver',
    LINKROLLOUT = 'linkRollOut',
    LINKCLICK = 'linkClick';
(0, _dependencyManager.addDep)({
  name: 'sankeyLinkAnimation',
  type: 'animationRule',
  extension: _index.default
});

var Sankey = /*#__PURE__*/function (_SmartRenderer) {
  (0, _inheritsLoose2.default)(Sankey, _SmartRenderer);

  function Sankey() {
    var _this;

    _this = _SmartRenderer.call(this) || this;

    _this.registerFactory('node', _sankeyNodeFactory.default);

    _this.registerFactory('link', _sankeyLinkFactory.default, ['node']);

    return _this;
  }

  Sankey.getName = function getName() {
    return 'sankey';
  };

  var _proto = Sankey.prototype;

  _proto.getName = function getName() {
    return 'sankey';
  };

  _proto.getType = function getType() {
    return 'dataset';
  };

  _proto.configureAttributes = function configureAttributes(inputConfig) {
    if (inputConfig === void 0) {
      inputConfig = {};
    }

    Object.assign(this.config, inputConfig);
  };

  _proto._addLegend = function _addLegend() {
    var dataset = this,
        dsConfig = dataset.config,
        nodes = dataset.getChildren('nodes'),
        legend = dataset.getFromEnv('legend'),
        nodeStyle,
        nodeConfig,
        legendItem,
        legendItemId,
        legendItemMap = dsConfig.legendItemMap = dsConfig.legendItemMap || {},
        curLegendItems = new Set();
    Object.keys(legendItemMap).forEach(function (key) {
      return curLegendItems.add(legendItemMap[key]);
    });
    nodes.forEach(function (node) {
      legendItemId = legendItemMap[node.getId()];
      legendItem = legend.getItem(legendItemId);

      if (!legendItem) {
        legendItemId = legend.createItem(dataset);
        legendItem = legend.getItem(legendItemId);
        legendItemMap[node.getId()] = legendItemId;
      } else {
        // eslint-disable-next-line
        curLegendItems.delete(legendItemId);
      }

      legendItem.configure({
        enabled: true,
        label: node.config.label
      });
      node.setData({
        legendItemId: legendItemId
      });
      nodeConfig = node.config;
      nodeStyle = nodeConfig.style;
      legendItem.setStateCosmetics('default', {
        symbol: {
          fill: nodeStyle.node.normal.fill,
          rawFillColor: nodeConfig.rawCosmetics.fill,
          stroke: nodeStyle.node.normal.stroke,
          cursor: 'default'
        },
        text: {
          cursor: 'default'
        }
      });
    });
    curLegendItems.forEach(function (item) {
      legend.disposeItem(item);
    });
  };

  _proto.allocatePosition = function allocatePosition() {
    var dataset = this,
        bounds,
        chartConfig = dataset.getFromEnv('chartConfig'),
        sankeyGraph = dataset.getFromEnv('sankey-graph'),
        orientation = dataset.getFromEnv('orientation'),
        canvasLeft = chartConfig.canvasLeft,
        canvasTop = chartConfig.canvasTop,
        canvasHeight = chartConfig.canvasHeight,
        canvasWidth = chartConfig.canvasWidth,
        columnWidth = 0,
        columnHeight = 0,
        columns = 0,
        _dataset$config = dataset.config,
        nodeWidth = _dataset$config.nodeWidth,
        nodeSpacing = _dataset$config.nodeSpacing,
        nodeRelaxation = _dataset$config.nodeRelaxation,
        style = _dataset$config.style,
        nodeLabelStyle = style.node.label;
    bounds = {
      left: canvasLeft,
      top: canvasTop,
      right: canvasLeft + canvasWidth,
      bottom: canvasTop + canvasHeight
    };
    dataset.config.nodeLabelCosmetics = {
      'font-size': this.computeFontSize(nodeLabelStyle.fontSize),
      'font-family': nodeLabelStyle.fontFamily,
      'font-weight': nodeLabelStyle.fontWeight,
      'font-style': nodeLabelStyle.fontStyle
    };

    if (orientation === HORIZONTAL) {
      dataset._accomodateBoundaryHLabels(bounds);

      (0, _sankeyhelper.createNodeDimensions)(sankeyGraph, {
        width: [bounds.left, bounds.right],
        height: [bounds.top, bounds.bottom],
        nodeGutter: nodeSpacing,
        orientation: orientation,
        nodeRelaxation: nodeRelaxation
      });
      sankeyGraph.nodes.forEach(function (node) {
        columns = Math.max(columns, node.props.depth);
      });
      columnWidth = dataset.config.columnGap = Math.max((bounds.right - bounds.left - nodeWidth * columns) / Math.max(columns, 1), 0);

      dataset._accomodateInternalHLabels(columnWidth);
    } else {
      dataset._accomodateBoundaryVLabels(bounds);

      (0, _sankeyhelper.createNodeDimensions)(sankeyGraph, {
        width: [bounds.left, bounds.right],
        height: [bounds.top, bounds.bottom],
        nodeGutter: nodeSpacing,
        orientation: orientation,
        nodeRelaxation: nodeRelaxation
      });
      sankeyGraph.nodes.forEach(function (node) {
        columns = Math.max(columns, node.props.depth);
      });
      columnHeight = dataset.config.columnGap = Math.max((bounds.bottom - bounds.top - nodeWidth * columns) / Math.max(columns, 1), 0);

      dataset._accomodateInternalVLabels(columnHeight, bounds.bottom - bounds.top);
    }
  };

  _proto._accomodateBoundaryHLabels = function _accomodateBoundaryHLabels(bounds) {
    var dataset = this,
        dsConfig = dataset.config,
        labelSepChar = dsConfig.labelSepChar,
        nodes = dataset.getChildren('nodes'),
        sl = dataset.getFromEnv('smartLabel'),
        canvasWidth = bounds.right - bounds.left,
        labelSl,
        valueSl,
        space,
        spaceFactor,
        availableWidth,
        divFactor,
        formattedValueSl,
        maxLeftSpaceReq = 0,
        maxRightSpaceReq = 0;
    nodes.forEach(function (node) {
      var _node$config = node.config,
          showValue = _node$config.showValue,
          showLabel = _node$config.showLabel,
          label = _node$config.label,
          props = _node$config.props,
          labelPosition = _node$config.labelPosition,
          value = _node$config.value,
          rotateLabel = _node$config.rotateLabel,
          labelPadding = _node$config.labelPadding,
          sourceLinks = props.sourceLinks,
          targetLinks = props.targetLinks;
      sl.setStyle(dataset.config.nodeLabelCosmetics);
      valueSl = sl.getSize(showValue ? value : BLANK);
      formattedValueSl = sl.getSize(showValue ? labelSepChar + ' ' + value : BLANK);
      availableWidth = Math.max(0, canvasWidth - formattedValueSl.width);

      if (sourceLinks.length && !targetLinks.length) {
        if (labelPosition === END) return;
        spaceFactor = labelPosition === START ? 0.1 : 0.2;
        divFactor = spaceFactor * 10;
        labelSl = sl.getSmartText(showLabel ? label : BLANK, spaceFactor * availableWidth, sl._lineHeight);

        if (rotateLabel) {
          space = labelPosition === INSIDE ? 0 : Math.max(labelSl.height / divFactor, valueSl.height / divFactor);
          maxLeftSpaceReq = Math.max(maxLeftSpaceReq, space + (space && labelPosition === START ? labelPadding : 0));
        } else {
          space = (labelSl.width + (labelSl.width ? formattedValueSl.width : valueSl.width)) / divFactor;
          maxLeftSpaceReq = Math.max(maxLeftSpaceReq, space + (space && labelPosition === START ? labelPadding : 0));
        }

        node.setData({
          formattedLabel: labelSl
        });
      } else if (!sourceLinks.length && targetLinks.length) {
        if (labelPosition === START) return;
        spaceFactor = labelPosition === END ? 0.1 : 0.2;
        divFactor = spaceFactor * 10;
        labelSl = sl.getSmartText(showLabel ? label : BLANK, spaceFactor * availableWidth, sl._lineHeight);

        if (rotateLabel) {
          space = labelPosition === INSIDE ? 0 : Math.max(labelSl.height / divFactor, valueSl.height / divFactor);
          maxRightSpaceReq = Math.max(maxRightSpaceReq, space + (space && labelPosition === END ? labelPadding : 0));
        } else {
          space = (labelSl.width + (labelSl.width ? formattedValueSl.width : valueSl.width)) / divFactor;
          maxRightSpaceReq = Math.max(maxRightSpaceReq, space + (space && labelPosition === END ? labelPadding : 0));
        }

        node.setData({
          formattedLabel: labelSl
        });
      }
    });
    bounds.left += maxLeftSpaceReq + (maxLeftSpaceReq ? GUTTER5 : 0);
    bounds.right -= maxRightSpaceReq + (maxRightSpaceReq ? GUTTER5 : 0);
    return bounds;
  };

  _proto._accomodateInternalHLabels = function _accomodateInternalHLabels(maxColumnWidth) {
    var dataset = this,
        nodes = dataset.getChildren('nodes'),
        sl = dataset.getFromEnv('smartLabel'),
        availableWidth,
        labelSepChar = dataset.config.labelSepChar,
        formattedValueSl,
        labelSl;
    nodes.forEach(function (node) {
      var _node$config2 = node.config,
          showValue = _node$config2.showValue,
          showLabel = _node$config2.showLabel,
          label = _node$config2.label,
          value = _node$config2.value,
          props = _node$config2.props,
          rotateLabel = _node$config2.rotateLabel,
          labelPosition = _node$config2.labelPosition,
          labelPadding = _node$config2.labelPadding,
          sourceLinks = props.sourceLinks,
          targetLinks = props.targetLinks,
          nodeHeight = Math.max(0, props.y1 - props.y0);
      label = showLabel ? label : BLANK;
      value = showValue ? value : BLANK;
      sl.setStyle(dataset.config.nodeLabelCosmetics);
      formattedValueSl = sl.getSize(showValue ? labelSepChar + ' ' + value : BLANK);
      availableWidth = Math.max(0, maxColumnWidth * 0.75 - labelPadding - formattedValueSl.width);

      if (rotateLabel) {
        labelSl = sl.getSmartText(label, nodeHeight - formattedValueSl.width, sl._lineHeight);
        node.setData({
          formattedLabel: labelSl
        });
        return;
      }

      if (sourceLinks.length && !targetLinks.length && labelPosition === END || !sourceLinks.length && targetLinks.length && labelPosition === START || sourceLinks.length && targetLinks.length || !sourceLinks.length && !targetLinks.length) {
        labelSl = sl.getSmartText(label, availableWidth, sl._lineHeight);
        node.setData({
          formattedLabel: labelSl
        });
      }
    });
  };

  _proto._accomodateBoundaryVLabels = function _accomodateBoundaryVLabels(bounds) {
    var dataset = this,
        nodes = dataset.getChildren('nodes'),
        sl = dataset.getFromEnv('smartLabel'),
        labelSepChar = dataset.config.labelSepChar,
        canvasHeight = bounds.bottom - bounds.top,
        valueSl,
        labelSl,
        spaceFactor,
        space,
        availableHeight,
        divFactor,
        formattedValueSl,
        maxTopSpaceReq = 0,
        maxBottomSpaceReq = 0;
    nodes.forEach(function (node) {
      var _node$config3 = node.config,
          props = _node$config3.props,
          labelPosition = _node$config3.labelPosition,
          rotateLabel = _node$config3.rotateLabel,
          showValue = _node$config3.showValue,
          showLabel = _node$config3.showLabel,
          value = _node$config3.value,
          label = _node$config3.label,
          labelPadding = _node$config3.labelPadding,
          sourceLinks = props.sourceLinks,
          targetLinks = props.targetLinks;
      value = showValue ? value : BLANK;
      label = showLabel ? label : BLANK;
      sl.setStyle(dataset.config.nodeLabelCosmetics);
      valueSl = sl.getSize(value);
      formattedValueSl = sl.getSize(showValue ? labelSepChar + ' ' + value : BLANK);
      availableHeight = Math.max(0, canvasHeight - formattedValueSl.width);

      if (sourceLinks.length && !targetLinks.length) {
        if (labelPosition === END) return;
        spaceFactor = labelPosition === START ? 0.1 : 0.2;
        divFactor = spaceFactor * 10;
        labelSl = sl.getSmartText(label, spaceFactor * availableHeight, sl._lineHeight);

        if (rotateLabel) {
          space = (labelSl.width + (labelSl.width ? formattedValueSl.width : valueSl.width)) / divFactor;
          maxTopSpaceReq = Math.max(maxTopSpaceReq, space + (space && labelPosition === START ? labelPadding : 0));
        } else {
          space = labelPosition === INSIDE ? 0 : Math.max(labelSl.height / divFactor, valueSl.height / divFactor);
          maxTopSpaceReq = Math.max(maxTopSpaceReq, space + (space && labelPosition === START ? labelPadding : 0));
        }

        node.setData({
          formattedLabel: labelSl
        });
      } else if (!sourceLinks.length && targetLinks.length) {
        if (labelPosition === START) return;
        spaceFactor = labelPosition === END ? 0.1 : 0.2;
        divFactor = spaceFactor * 10;
        labelSl = sl.getSmartText(label, spaceFactor * availableHeight, sl._lineHeight);

        if (rotateLabel) {
          space = (labelSl.width + (labelSl.width ? formattedValueSl.width : valueSl.width)) / divFactor;
          maxBottomSpaceReq = Math.max(maxBottomSpaceReq, space + (space && labelPosition === END ? labelPadding : 0));
        } else {
          space = labelPosition === INSIDE ? 0 : Math.max(labelSl.height / divFactor, valueSl.height / divFactor);
          maxBottomSpaceReq = Math.max(maxBottomSpaceReq, space + (space && labelPosition === END ? labelPadding : 0));
        }

        node.setData({
          formattedLabel: labelSl
        });
      }
    });
    bounds.top += maxTopSpaceReq + (maxTopSpaceReq ? GUTTER5 : 0);
    bounds.bottom -= maxBottomSpaceReq + (maxBottomSpaceReq ? GUTTER5 : 0);
    return bounds;
  };

  _proto._accomodateInternalVLabels = function _accomodateInternalVLabels(maxColumnWidth) {
    var dataset = this,
        nodes = dataset.getChildren('nodes'),
        sl = dataset.getFromEnv('smartLabel'),
        labelSepChar = dataset.config.labelSepChar,
        availableHeight,
        labelSl,
        nodeWidth,
        formattedValueSl;
    nodes.forEach(function (node) {
      var _node$config4 = node.config,
          showValue = _node$config4.showValue,
          props = _node$config4.props,
          label = _node$config4.label,
          value = _node$config4.value,
          showLabel = _node$config4.showLabel,
          rotateLabel = _node$config4.rotateLabel,
          labelPosition = _node$config4.labelPosition,
          labelPadding = _node$config4.labelPadding,
          sourceLinks = props.sourceLinks,
          targetLinks = props.targetLinks;
      sl.setStyle(dataset.config.nodeLabelCosmetics);
      label = showLabel ? label : BLANK;
      value = showValue ? value : BLANK;
      formattedValueSl = sl.getSize(showValue ? labelSepChar + ' ' + value : BLANK);
      availableHeight = Math.max(0, maxColumnWidth * 0.75 - labelPadding - formattedValueSl.width);
      nodeWidth = props.x1 - props.x0;

      if (!rotateLabel) {
        labelSl = sl.getSmartText(label, nodeWidth - formattedValueSl.width, sl._lineHeight);
        node.setData({
          formattedLabel: labelSl
        });
        return;
      }

      if (sourceLinks.length && !targetLinks.length && labelPosition === END || !sourceLinks.length && targetLinks.length && labelPosition === START || sourceLinks.length && targetLinks.length || !sourceLinks.length && !targetLinks.length) {
        labelSl = sl.getSmartText(label, availableHeight, sl._lineHeight);
        node.setData({
          formattedLabel: labelSl
        });
      }
    });
  };

  _proto.attachListeners = function attachListeners() {
    var dataset = this,
        nodes = dataset.getChildren('nodes'),
        links = dataset.getChildren('links');
    nodes.forEach(function (node) {
      node.onFocusCallback = node.onFocusCallback || dataset.interactionCallback(node, 'focus');
      node.onFocusOutCallback = node.onFocusOutCallback || dataset.interactionCallback(node, 'normal');
      node.onClickCallback = node.onClickCallback || dataset.interactionCallback(node, 'click');
      node.dragStartCallback = node.dragStartCallback || dataset.dragCallback(node, 'start');
      node.dragMoveCallback = node.dragMoveCallback || dataset.dragCallback(node, 'move');
      node.dragEndCallback = node.dragEndCallback || dataset.dragCallback(node, 'end');
      node.addEventListener('fc-mouseover', node.onFocusCallback);
      node.addEventListener('fc-mouseout', node.onFocusOutCallback);
      node.addEventListener('fc-click', node.onClickCallback);
      node.addEventListener('fc-dragstart', node.dragStartCallback);
      node.addEventListener('fc-dragmove', node.dragMoveCallback);
      node.addEventListener('fc-dragend', node.dragEndCallback);
    });
    links && links.forEach(function (link) {
      link.onFocusCallback = link.onFocusCallback || dataset.interactionCallback(link, 'focus');
      link.onFocusOutCallback = link.onFocusOutCallback || dataset.interactionCallback(link, 'normal');
      link.onClickCallback = link.onClickCallback || dataset.interactionCallback(link, 'click');
      link.addEventListener('fc-mouseover', link.onFocusCallback);
      link.addEventListener('fc-mouseout', link.onFocusOutCallback);
      link.addEventListener('fc-click', link.onClickCallback);
    });
  };

  _proto.interactionCallback = function interactionCallback(component, mode) {
    var dataset = this,
        dsConfig = dataset.config,
        chart = dataset.getLinkedParent(),
        type = component.getType();

    if (type === 'node') {
      return function () {
        var nodes = dataset.getChildren('nodes'),
            links = dataset.getChildren('links') || [],
            eventArgs = Object.assign({}, component.config.eventArgs),
            componentId = component.getId();
        if (component.config.isDragged) return;

        if (mode === 'click') {
          chart.fireChartInstanceEvent(NODECLICK, eventArgs);
        } else if (mode === 'normal') {
          chart.fireChartInstanceEvent(NODEROLLOUT, eventArgs);
          if (!dsConfig.highlightEffect) return;
          nodes.forEach(function (node) {
            return node.setData({
              mode: 'normal'
            });
          });
          links.forEach(function (link) {
            return link.setData({
              mode: 'normal'
            });
          });
        } else {
          var focusNodes = new Set(),
              _component$config$pro = component.config.props,
              sourceLinks = _component$config$pro.sourceLinks,
              targetLinks = _component$config$pro.targetLinks;
          chart.fireChartInstanceEvent(NODEROLLOVER, eventArgs);
          if (!dsConfig.highlightEffect) return;
          focusNodes.add(componentId);
          sourceLinks.forEach(function (link) {
            focusNodes.add(link.to);
          });
          targetLinks.forEach(function (link) {
            focusNodes.add(link.from);
          });
          nodes.forEach(function (node) {
            if (focusNodes.has(node.getId())) {
              node.setData({
                mode: 'focus'
              });
            } else {
              node.setData({
                mode: 'focusOut'
              });
            }
          });
          links.forEach(function (link) {
            var _link$config$props = link.config.props,
                source = _link$config$props.source,
                target = _link$config$props.target;

            if (componentId === source.id || componentId === target.id) {
              link.setData({
                mode: 'focus'
              });
            } else {
              link.setData({
                mode: 'focusOut'
              });
            }
          });
        }
      };
    }

    return function () {
      var nodes = dataset.getChildren('nodes'),
          links = dataset.getChildren('links') || [],
          eventArgs = Object.assign({}, component.config.eventArgs);
      if (component.config.isDragged) return;

      if (mode === 'click') {
        chart.fireChartInstanceEvent(LINKCLICK, eventArgs);
      } else if (mode === 'normal') {
        chart.fireChartInstanceEvent(LINKROLLOUT, eventArgs);
        if (!dsConfig.highlightEffect) return;
        nodes.forEach(function (node) {
          return node.setData({
            mode: 'normal'
          });
        });
        links.forEach(function (link) {
          return link.setData({
            mode: 'normal'
          });
        });
      } else {
        var focusNodes = new Set(),
            _component$config$pro2 = component.config.props,
            source = _component$config$pro2.source,
            target = _component$config$pro2.target;
        chart.fireChartInstanceEvent(LINKROLLOVER, eventArgs);
        if (!dsConfig.highlightEffect) return;
        focusNodes.add(source.id);
        focusNodes.add(target.id);
        nodes.forEach(function (node) {
          if (focusNodes.has(node.getId())) {
            node.setData({
              mode: 'focus'
            });
          } else {
            node.setData({
              mode: 'focusOut'
            });
          }
        });
        links.forEach(function (link) {
          return link.setData({
            mode: 'focusOut'
          });
        });
        component.setData({
          mode: 'focus'
        });
      }
    };
  };

  _proto.dragCallback = function dragCallback(component, mode) {
    var dataset = this,
        dsConfig = dataset.config;

    if (mode === 'start') {
      return function () {
        var props = component.config.props,
            linkComponent,
            linkProps;
        if (!dsConfig.enableDrag) return;
        component.onFocusOutCallback();
        component.setData({
          isDragged: true,
          curPos: {
            x0: props.x0,
            x1: props.x1,
            y0: props.y0,
            y1: props.y1
          }
        });
        props.sourceLinks.forEach(function (link) {
          linkComponent = dataset.getChild(link.props.index, 'links');
          linkProps = linkComponent.config.props;
          linkComponent.setData({
            isDragged: true,
            curPos: {
              x0: linkProps.x0,
              x1: linkProps.x1,
              y0: linkProps.y0,
              y1: linkProps.y1
            }
          });
        });
        props.targetLinks.forEach(function (link) {
          linkComponent = dataset.getChild(link.props.index, 'links');
          linkProps = linkComponent.config.props;
          linkComponent.setData({
            isDragged: true,
            curPos: {
              x0: linkProps.x0,
              x1: linkProps.x1,
              y0: linkProps.y0,
              y1: linkProps.y1
            }
          });
        });
      };
    } else if (mode === 'end') {
      return function () {
        var props = component.config.props,
            linkComponent;
        if (!dsConfig.enableDrag) return;
        component.setData({
          isDragged: false
        });
        props.sourceLinks.forEach(function (link) {
          linkComponent = dataset.getChild(link.props.index, 'links');
          linkComponent.setData({
            isDragged: false
          });
        });
        props.targetLinks.forEach(function (link) {
          linkComponent = dataset.getChild(link.props.index, 'links');
          linkComponent.setData({
            isDragged: false
          });
        });
      };
    }

    return function (evt) {
      var data = evt.originalEvent.data,
          dx = data[0],
          dy = data[1],
          linkComponent,
          linkProps,
          linkCurPos,
          orientation = dataset.getFromEnv('orientation'),
          _dataset$getFromEnv = dataset.getFromEnv('chartConfig'),
          canvasLeft = _dataset$getFromEnv.canvasLeft,
          canvasRight = _dataset$getFromEnv.canvasRight,
          canvasTop = _dataset$getFromEnv.canvasTop,
          canvasBottom = _dataset$getFromEnv.canvasBottom,
          _component$config = component.config,
          curPos = _component$config.curPos,
          props = _component$config.props;

      if (!dsConfig.enableDrag) return;

      if (orientation === HORIZONTAL) {
        if (curPos.y0 + dy < canvasTop || curPos.y1 + dy > canvasBottom) return;
        props.y0 = curPos.y0 + dy;
        props.y1 = curPos.y1 + dy;
        props.sourceLinks.forEach(function (link) {
          linkComponent = dataset.getChild(link.props.index, 'links');
          linkProps = linkComponent.config.props;
          linkCurPos = linkComponent.config.curPos;
          linkProps.y0 = linkCurPos.y0 + dy;
          linkComponent.setData({});
        });
        props.targetLinks.forEach(function (link) {
          linkComponent = dataset.getChild(link.props.index, 'links');
          linkProps = linkComponent.config.props;
          linkCurPos = linkComponent.config.curPos;
          linkProps.y1 = linkCurPos.y1 + dy;
          linkComponent.setData({});
        });
      } else {
        if (curPos.x0 + dx < canvasLeft || curPos.x1 + dx > canvasRight) return;
        props.x0 = curPos.x0 + dx;
        props.x1 = curPos.x1 + dx;
        props.sourceLinks.forEach(function (link) {
          linkComponent = dataset.getChild(link.props.index, 'links');
          linkProps = linkComponent.config.props;
          linkCurPos = linkComponent.config.curPos;
          linkProps.x0 = linkCurPos.x0 + dx;
          linkComponent.setData({});
        });
        props.targetLinks.forEach(function (link) {
          linkComponent = dataset.getChild(link.props.index, 'links');
          linkProps = linkComponent.config.props;
          linkCurPos = linkComponent.config.curPos;
          linkProps.x1 = linkCurPos.x1 + dx;
          linkComponent.setData({});
        });
      }

      component.setData({});
    };
  };

  _proto.getClip = function getClip(mode) {
    var dataset = this,
        orientation = dataset.getFromEnv('orientation'),
        clipAr = [],
        _dataset$getFromEnv2 = dataset.getFromEnv('chartConfig'),
        canvasTop = _dataset$getFromEnv2.canvasTop,
        canvasLeft = _dataset$getFromEnv2.canvasLeft,
        canvasWidth = _dataset$getFromEnv2.canvasWidth,
        canvasHeight = _dataset$getFromEnv2.canvasHeight;

    if (orientation === HORIZONTAL) {
      clipAr.push(canvasLeft);
      clipAr.push(canvasTop);

      if (mode === 'init') {
        clipAr.push(0);
      } else {
        clipAr.push(canvasWidth);
      }

      clipAr.push(canvasHeight);
    } else {
      clipAr.push(canvasLeft);
      clipAr.push(canvasTop);
      clipAr.push(canvasWidth);

      if (mode === 'init') {
        clipAr.push(0);
      } else {
        clipAr.push(canvasHeight);
      }
    }

    return clipAr;
  };

  _proto.draw = function draw() {
    var dataset = this;
    dataset.addGraphicalElement({
      el: 'group',
      attr: {
        name: 'sankey-link-group',
        'clip-rect': dataset.getClip('canvas')
      },
      id: 'sankey-link-group',
      component: dataset,
      container: {
        id: 'plotGroup',
        isParent: true
      },
      label: 'linkGroup'
    });
    dataset.addGraphicalElement({
      el: 'group',
      attr: {
        name: 'sankey-node-group'
      },
      id: 'sankey-node-group',
      component: dataset,
      container: {
        id: 'plotGroup',
        isParent: true
      },
      label: 'nodeGroup'
    });
    dataset.addGraphicalElement({
      el: 'group',
      attr: _objectSpread({
        name: 'sankey-node-label-group'
      }, dataset.config.nodeLabelCosmetics),
      id: 'sankey-node-label-group',
      component: dataset,
      container: {
        id: 'datalabelsGroup',
        isParent: true
      },
      label: 'nodeLabelGroup'
    });
  };

  return Sankey;
}(_componentInterface.SmartRenderer);

var _default = Sankey;
exports["default"] = _default;

/***/ }),

/***/ 1433:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _defineProperty2 = _interopRequireDefault(__webpack_require__(273));

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _componentInterface = __webpack_require__(290);

var _sankeyRibbon = __webpack_require__(1434);

var _lib = __webpack_require__(274);

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var CUSTOM = 'custom',
    UNIFORM = 'uniform',
    BLANKSTRING = '',
    SMALLSQUARE = '&#9632;',
    MEDIUMSQUARE = '&#x25FC;',
    getClassName = function getClassName(baseName) {
  if (baseName === void 0) {
    baseName = '';
  }

  var randomString = Math.random().toString(36).substring(2);
  return baseName + "-" + randomString;
},
    getTooltext = function getTooltext(config, link, chartConfig) {
  var uniChar = _lib.isIpad ? SMALLSQUARE : MEDIUMSQUARE,
      macroIndices = [148, 149, 142, 150, 151, 152, 153],
      manager = link.getLinkedParent(),
      legend = link.getFromEnv('legend'),
      pathArr,
      drawCustomLegendIcon = chartConfig && chartConfig.drawcustomlegendicon,
      newPathArr = [],
      i,
      j,
      symbolBBox,
      legendItemSymbol,
      pathStart = [],
      chartNonce = (chartConfig == null ? void 0 : chartConfig.nonce) || '',
      finalPath,
      fromLegendItem = drawCustomLegendIcon && legend && legend.config && legend.config.isActive ? legend.getItem(manager.config.legendItemMap[link.config.from]) : null,
      fromgraphicalElement = fromLegendItem && fromLegendItem.getGraphicalElement(),
      toLegendItem = drawCustomLegendIcon && legend && legend.config && legend.config.isActive ? legend.getItem(manager.config.legendItemMap[link.config.to]) : null,
      tographicalElement = toLegendItem && toLegendItem.getGraphicalElement(),
      parserConfig,
      linkToolText;
  finalPath = BLANKSTRING;

  if (fromLegendItem) {
    if (fromgraphicalElement) {
      legendItemSymbol = fromgraphicalElement && fromgraphicalElement.legendItemSymbol;
      pathArr = legendItemSymbol && legendItemSymbol.attrs.path.split(/(?=[LMCA])/);
      symbolBBox = legendItemSymbol && legendItemSymbol.node.getBBox();

      if (pathArr && pathArr.length) {
        for (i = 0; i < pathArr.length; i++) {
          pathStart.push(pathArr[i][0]);
          pathArr[i] = pathArr[i].substring(1, pathArr[i].length);

          if (i === pathArr.length - 1) {
            pathArr[i] = pathArr[i].substring(0, pathArr[i].length - 1);
          }

          newPathArr[i] = pathArr[i].split(',');
        }
      }

      if (newPathArr && newPathArr.length) {
        for (i = 0; i < newPathArr.length; i++) {
          if (newPathArr[i].length) {
            for (j = 0; j < newPathArr[i].length; j++) {
              newPathArr[i][j] = Number(newPathArr[i][j]);

              if (pathStart[i] !== 'A') {
                if (j === 0) {
                  newPathArr[i][j] = newPathArr[i][j] - symbolBBox.x;
                } else if (j === 1) {
                  newPathArr[i][j] = newPathArr[i][j] - symbolBBox.y;
                }
              } else if (pathStart[i] === 'A') {
                if (j === 5) {
                  newPathArr[i][j] = newPathArr[i][j] - symbolBBox.x;
                } else if (j === 6) {
                  newPathArr[i][j] = newPathArr[i][j] - symbolBBox.y;
                }
              }
            }
          }

          finalPath += pathStart[i] + newPathArr[i].toString();
        }
      }

      finalPath = finalPath + 'Z';
    }
  }

  parserConfig = {
    linkDataValue: config.value,
    fromPlotIdentifier: fromLegendItem ? "<svg height= " + symbolBBox.height + " width = " + symbolBBox.width + " overflow='visible' xmlns=\"http://www.w3.org/2000/svg\">\n      <path d= " + finalPath + " fill = " + fromgraphicalElement.legendItemSymbol.node.getAttribute('fill') + " stroke = " + fromgraphicalElement.legendItemSymbol.node.getAttribute('stroke') + "\n      stroke-opacity = " + fromgraphicalElement.legendItemSymbol.node.getAttribute('stroke-opacity') + " fill-opacity = " + fromgraphicalElement.legendItemSymbol.node.getAttribute('fill-opacity') + " \n      stroke-width = " + fromgraphicalElement.legendItemSymbol.node.getAttribute('stroke-width') + " stroke-linecap = " + fromgraphicalElement.legendItemSymbol.node.getAttribute('stroke-linecap') + "></path>\n    </svg>" : "<span style='color: " + (0, _lib.parseColor)(config.sourceFill) + ";'>" + uniChar + "&nbsp;</span>",
    toPlotIdentifier: toLegendItem ? "<svg height= " + symbolBBox.height + " width = " + symbolBBox.width + " overflow= 'visible' xmlns=\"http://www.w3.org/2000/svg\">\n      <path d= " + finalPath + " fill = " + tographicalElement.legendItemSymbol.node.getAttribute('fill') + " stroke = " + tographicalElement.legendItemSymbol.node.getAttribute('stroke') + "\n      stroke-opacity = " + tographicalElement.legendItemSymbol.node.getAttribute('stroke-opacity') + " fill-opacity = " + tographicalElement.legendItemSymbol.node.getAttribute('fill-opacity') + " \n      stroke-width = " + tographicalElement.legendItemSymbol.node.getAttribute('stroke-width') + " stroke-linecap = " + tographicalElement.legendItemSymbol.node.getAttribute('stroke-linecap') + "></path>\n    </svg>" : "<span style='color: " + (0, _lib.parseColor)(config.targetFill) + ";'>" + uniChar + "&nbsp;</span>",
    flowDirection: "&rarr;"
  };
  linkToolText = (0, _lib.parseTooltext)(config.toolText, macroIndices, config, parserConfig);
  config.setLinkTooltext = linkToolText;
  var tooltipClass = getClassName('tooltip'),
      tooltipColorSourceFill = getClassName('tooltip-source-color'),
      tooltipColorTargetFill = getClassName('tooltip-target-color');

  if (!config.toolText) {
    return "\n        <style nonce=\"" + chartNonce + "\">\n          ." + tooltipClass + " {\n            padding: 2px;\n            vertical-align: middle;\n          }\n\n          ." + tooltipColorSourceFill + " {\n            color: " + (0, _lib.parseColor)(config.sourceFill) + ";\n          }\n\n          ." + tooltipColorTargetFill + " {\n            color: " + (0, _lib.parseColor)(config.targetFill) + ";\n          }\n        </style>\n        <div class=\"" + tooltipClass + "\">\n        <span class=\"" + tooltipColorSourceFill + "\">" + uniChar + "&nbsp;</span>" + config.props.source.label + "\n        &rarr;\n        <span class=\"" + tooltipColorTargetFill + "\">" + uniChar + "&nbsp;</span>" + config.props.target.label + "\n        &nbsp;\n        " + config.value + "\n      </div>";
  }

  return "\n      <style nonce=\"" + chartNonce + "\">\n        ." + tooltipClass + " {\n          padding: 2px;\n          vertical-align: middle;\n        }\n      </style>\n      <div class=\"" + tooltipClass + "\">\n        " + config.setLinkTooltext + "\n      </div>";
};

var SankeyLink = /*#__PURE__*/function (_SmartRenderer) {
  (0, _inheritsLoose2.default)(SankeyLink, _SmartRenderer);

  function SankeyLink() {
    return _SmartRenderer.apply(this, arguments) || this;
  }

  var _proto = SankeyLink.prototype;

  _proto.getType = function getType() {
    return 'link';
  };

  _proto.getName = function getName() {
    return 'sankey-link';
  };

  _proto.configureAttributes = function configureAttributes(inputConfig) {
    if (inputConfig === void 0) {
      inputConfig = {};
    }

    Object.assign(this.config, inputConfig);
  };

  _proto.allocatePosition = function allocatePosition() {
    var link = this,
        linkConfig = link.config,
        mode = linkConfig.mode,
        style = linkConfig.style,
        props = linkConfig.props,
        linkPadding = linkConfig.linkPadding,
        linkType = linkConfig.linkType,
        curvature = linkConfig.curvature,
        _link$getFromEnv = link.getFromEnv('chartConfig'),
        orientation = _link$getFromEnv.orientation,
        linkCosmetics = style.link[mode],
        pathStr,
        sourcePoint = {
      x: props.x0,
      y: props.y0,
      width: props.linkWidth
    },
        source = props.source,
        target = props.target,
        sourceNodeLayer = source.props.layer,
        targetNodeLayer = target.props.layer,
        sourceNodeLen,
        targetNodeLen,
        targetPoint = {
      x: props.x1,
      y: props.y1,
      width: props.linkWidth > 1 ? props.linkWidth : 2
    },
        columnGap = link.getLinkedParent().config.columnGap;

    sourceNodeLen = Math.max(orientation === 'vertical' ? source.props.x1 - source.props.x0 : source.props.y1 - source.props.y0, 0);
    targetNodeLen = Math.max(orientation === 'vertical' ? source.props.x1 - source.props.x0 : source.props.y1 - source.props.y0, 0);

    if (linkType !== CUSTOM && linkType !== UNIFORM) {
      if (props.linkWidth > columnGap * Math.abs(targetNodeLayer - sourceNodeLayer) / 3 || sourcePoint.width > 0.7 * sourceNodeLen || targetPoint.width > 0.7 * targetNodeLen) {
        linkType = CUSTOM;
      } else {
        linkType = UNIFORM;
      }
    }

    pathStr = (0, _sankeyRibbon.sankeyRibbon)(sourcePoint, targetPoint, {
      orientation: orientation,
      padding: linkPadding,
      curvature: curvature,
      linkType: linkType
    });
    linkConfig.linkAttr = _objectSpread({
      path: pathStr,
      'stroke-width': linkType === UNIFORM ? props.linkWidth > 1 ? props.linkWidth : 2 : 'none'
    }, linkCosmetics);

    if (linkType === CUSTOM) {
      linkConfig.linkAttr.fill = linkConfig.linkAttr.stroke;
      linkConfig.linkAttr.stroke = 'none';
    }
  };

  _proto.draw = function draw() {
    var link = this,
        linkConfig = link.config,
        chartConfig = link.getFromEnv('chartConfig'),
        id = linkConfig.id,
        linkAttr = linkConfig.linkAttr;
    link.addGraphicalElement({
      el: 'path',
      attr: linkAttr,
      container: {
        id: 'sankey-link-group',
        label: 'linkGroup',
        isParent: true
      },
      tooltext: getTooltext(link.config, link, chartConfig),
      component: link,
      id: id,
      label: 'sankey-link'
    });
  };

  return SankeyLink;
}(_componentInterface.SmartRenderer);

var _default = SankeyLink;
exports["default"] = _default;

/***/ }),

/***/ 1431:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _defineProperty2 = _interopRequireDefault(__webpack_require__(273));

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _componentInterface = __webpack_require__(290);

var _lib = __webpack_require__(274);

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var START = 'start',
    END = 'end',
    INSIDE = 'inside',
    MIDDLE = 'middle',
    defaultTransform = 't0,0',
    // CENTER = 'center',
SMALLSQUARE = '&#9632;',
    MEDIUMSQUARE = '&#x25FC;',
    getClassName = function getClassName(baseName) {
  if (baseName === void 0) {
    baseName = '';
  }

  var randomString = Math.random().toString(36).substring(2);
  return baseName + "-" + randomString;
},
    getTooltext = function getTooltext(config, node, chartConfig) {
  var uniChar = _lib.isIpad ? SMALLSQUARE : MEDIUMSQUARE,
      macroIndices = [3, 133, 134, 143, 144, 145],
      manager = node.getLinkedParent(),
      legend = node.getFromEnv('legend'),
      pathArr,
      drawCustomLegendIcon = chartConfig && chartConfig.drawcustomlegendicon,
      newPathArr = [],
      i,
      j,
      symbolBBox,
      plotToolText,
      legendItemSymbol,
      pathStart = [],
      chartNonce = (chartConfig == null ? void 0 : chartConfig.nonce) || '',
      finalPath,
      legendItem = drawCustomLegendIcon && legend && legend.config && legend.config.isActive ? legend.getItem(manager.config.legendItemMap[node.config.label]) : null,
      graphicalElement = legendItem && legendItem.getGraphicalElement(),
      parserConfig,
      toolText;
  finalPath = _lib.BLANKSTRING;

  if (legendItem) {
    legendItemSymbol = graphicalElement && graphicalElement.legendItemSymbol;
    pathArr = legendItemSymbol && legendItemSymbol.attrs.path.split(/(?=[LMCA])/);
    symbolBBox = legendItemSymbol && legendItemSymbol.node.getBBox();

    if (pathArr && pathArr.length) {
      for (i = 0; i < pathArr.length; i++) {
        pathStart.push(pathArr[i][0]);
        pathArr[i] = pathArr[i].substring(1, pathArr[i].length);

        if (i === pathArr.length - 1) {
          pathArr[i] = pathArr[i].substring(0, pathArr[i].length - 1);
        }

        newPathArr[i] = pathArr[i].split(',');
      }
    }

    if (newPathArr && newPathArr.length) {
      for (i = 0; i < newPathArr.length; i++) {
        if (newPathArr[i].length) {
          for (j = 0; j < newPathArr[i].length; j++) {
            newPathArr[i][j] = Number(newPathArr[i][j]);

            if (pathStart[i] !== 'A') {
              if (j === 0) {
                newPathArr[i][j] = newPathArr[i][j] - symbolBBox.x;
              } else if (j === 1) {
                newPathArr[i][j] = newPathArr[i][j] - symbolBBox.y;
              }
            } else if (pathStart[i] === 'A') {
              if (j === 5) {
                newPathArr[i][j] = newPathArr[i][j] - symbolBBox.x;
              } else if (j === 6) {
                newPathArr[i][j] = newPathArr[i][j] - symbolBBox.y;
              }
            }
          }
        }

        finalPath += pathStart[i] + newPathArr[i].toString();
      }
    }

    finalPath = finalPath + 'Z';
  }

  parserConfig = {
    label: config.label,
    value: config.value,
    nodeValue: config.props.value,
    nodeDataValue: config.value,
    plotFillColor: config.rawCosmetics && '#' + config.rawCosmetics.fill,
    plotFillAlpha: config.rawCosmetics && config.rawCosmetics.alpha,
    plotIdentifier: legendItem ? "<svg height= " + symbolBBox.height + " width = " + symbolBBox.width + " overflow='visible' xmlns=\"http://www.w3.org/2000/svg\">\n      <path d= " + finalPath + " fill = " + graphicalElement.legendItemSymbol.node.getAttribute('fill') + " stroke = " + graphicalElement.legendItemSymbol.node.getAttribute('stroke') + "\n      stroke-opacity = " + graphicalElement.legendItemSymbol.node.getAttribute('stroke-opacity') + " fill-opacity = " + graphicalElement.legendItemSymbol.node.getAttribute('fill-opacity') + " \n      stroke-width = " + graphicalElement.legendItemSymbol.node.getAttribute('stroke-width') + " stroke-linecap = " + graphicalElement.legendItemSymbol.node.getAttribute('stroke-linecap') + "></path>\n    </svg>" : "<span style='color: " + (0, _lib.parseColor)(config.rawCosmetics.fill) + ";'>" + uniChar + "&nbsp;</span>"
  };
  toolText = (0, _lib.parseTooltext)(config.toolText, macroIndices, parserConfig, {
    value: config.value,
    nodeValue: config.props.value,
    nodeDataValue: config.value,
    plotFillColor: config.rawCosmetics && '#' + config.rawCosmetics.fill,
    plotFillAlpha: config.rawCosmetics && config.rawCosmetics.alpha,
    plotIdentifier: legendItem ? "<svg height= " + symbolBBox.height + " width = " + symbolBBox.width + " overflow='visible' xmlns=\"http://www.w3.org/2000/svg\">\n        <path d= " + finalPath + " fill = " + graphicalElement.legendItemSymbol.node.getAttribute('fill') + " stroke = " + graphicalElement.legendItemSymbol.node.getAttribute('stroke') + "\n        stroke-opacity = " + graphicalElement.legendItemSymbol.node.getAttribute('stroke-opacity') + " fill-opacity = " + graphicalElement.legendItemSymbol.node.getAttribute('fill-opacity') + " \n        stroke-width = " + graphicalElement.legendItemSymbol.node.getAttribute('stroke-width') + " stroke-linecap = " + graphicalElement.legendItemSymbol.node.getAttribute('stroke-linecap') + "></path>\n      </svg>" : "<span style='color: " + (0, _lib.parseColor)(config.rawCosmetics.fill) + ";'>" + uniChar + "&nbsp;</span>"
  });
  plotToolText = (0, _lib.parseTooltext)(config.plotToolText, macroIndices, parserConfig, {
    value: config.value,
    nodeValue: config.props.value,
    nodeDataValue: config.value,
    plotFillColor: config.rawCosmetics && '#' + config.rawCosmetics.fill,
    plotFillAlpha: config.rawCosmetics && config.rawCosmetics.alpha,
    plotIdentifier: legendItem ? "<svg height= " + symbolBBox.height + " width = " + symbolBBox.width + " overflow='visible' xmlns=\"http://www.w3.org/2000/svg\">\n        <path d= " + finalPath + " fill = " + graphicalElement.legendItemSymbol.node.getAttribute('fill') + " stroke = " + graphicalElement.legendItemSymbol.node.getAttribute('stroke') + "\n        stroke-opacity = " + graphicalElement.legendItemSymbol.node.getAttribute('stroke-opacity') + " fill-opacity = " + graphicalElement.legendItemSymbol.node.getAttribute('fill-opacity') + " \n        stroke-width = " + graphicalElement.legendItemSymbol.node.getAttribute('stroke-width') + " stroke-linecap = " + graphicalElement.legendItemSymbol.node.getAttribute('stroke-linecap') + "></path>\n      </svg>" : "<span style='color: " + (0, _lib.parseColor)(config.rawCosmetics.fill) + ";'>" + uniChar + "&nbsp;</span>"
  });
  config.setToolText = toolText;
  config.setPlotTooltext = config.setToolText ? config.setToolText : plotToolText;
  var tooltipClass = getClassName('tooltip'),
      tooltipColorClass = getClassName('tooltip-color');

  if (!config.plotToolText) {
    return "\n        <style nonce=\"" + chartNonce + "\">\n          ." + tooltipClass + " {\n            padding: 2px;\n            vertical-align: middle;\n          }\n\n          ." + tooltipColorClass + " {\n            color: " + (0, _lib.parseColor)(config.rawCosmetics.fill) + ";\n          }\n        </style>\n        <div class=\"" + tooltipClass + "\">\n          <span class=\"" + tooltipColorClass + "\">" + uniChar + "&nbsp;</span>" + config.label + "\n          &nbsp;\n          &nbsp;\n          " + config.value + "\n        </div>";
  }

  return "\n      <style nonce=\"" + chartNonce + "\">\n        ." + tooltipClass + " {\n          padding: 2px;\n          vertical-align: middle;\n        }\n\n        ." + tooltipColorClass + " {\n          color: " + (0, _lib.parseColor)(config.rawCosmetics.fill) + ";\n        }\n      </style>\n      <div class=\"" + tooltipClass + "\">\n        <span class=\"" + tooltipColorClass + "\";'>" + uniChar + "&nbsp;</span>\n        " + config.setPlotTooltext + "\n      </div>";
},
    // GUTTER5 = 5,
BLANK = '',
    SPACE = ' ';

var SankeyNode = /*#__PURE__*/function (_SmartRenderer) {
  (0, _inheritsLoose2.default)(SankeyNode, _SmartRenderer);

  function SankeyNode() {
    return _SmartRenderer.apply(this, arguments) || this;
  }

  var _proto = SankeyNode.prototype;

  _proto.getType = function getType() {
    return 'node';
  };

  _proto.getName = function getName() {
    return 'sankey-node';
  };

  _proto.configureAttributes = function configureAttributes(inputConfig) {
    if (inputConfig === void 0) {
      inputConfig = {};
    }

    var nodeConfig = this.config;
    Object.assign(nodeConfig, inputConfig);
  };

  _proto.allocatePosition = function allocatePosition() {
    var node = this,
        _node$config = node.config,
        props = _node$config.props,
        style = _node$config.style,
        mode = _node$config.mode,
        labelPosition = _node$config.labelPosition,
        showLabel = _node$config.showLabel,
        formattedLabel = _node$config.formattedLabel,
        showValue = _node$config.showValue,
        value = _node$config.value,
        rotateLabel = _node$config.rotateLabel,
        labelPadding = _node$config.labelPadding,
        nodeCosmetics = style.node[mode],
        labelCosmetics = style.label[mode],
        orientation = node.getFromEnv('orientation'),
        sl = node.getFromEnv('smartLabel'),
        labelXPos,
        labelYPos,
        anchor,
        labelSepChar = node.getLinkedParent().config.labelSepChar,
        text = formattedLabel.text + (showValue ? labelSepChar + SPACE + value : BLANK);

    if (!showLabel || !formattedLabel.text) {
      text = showValue ? value : BLANK;
      sl.setStyle(style.label.normal);
      formattedLabel = sl.getSmartText(text);
    }

    node.config.nodeAttr = _objectSpread({
      x: props.x0,
      y: props.y0,
      width: Math.max(0, props.x1 - props.x0),
      height: Math.max(0, props.y1 - props.y0)
    }, nodeCosmetics);

    if (orientation === 'horizontal') {
      if (!rotateLabel) {
        if (labelPosition === START) {
          labelXPos = props.x0 - labelPadding;
          anchor = END;
        } else if (labelPosition === INSIDE) {
          labelXPos = Math.abs(props.x0 + props.x1) / 2;
          anchor = MIDDLE;
        } else {
          labelXPos = props.x1 + labelPadding;
          anchor = START;
        }

        labelYPos = Math.abs(props.y1 + props.y0) / 2;
        node.config.labelAttr = _objectSpread({
          x: labelXPos,
          y: labelYPos,
          text: text,
          transform: defaultTransform,
          'text-anchor': anchor
        }, labelCosmetics);
      } else {
        if (labelPosition === START) {
          labelXPos = props.x0 - labelPadding - formattedLabel.height / 2;
        } else if (labelPosition === INSIDE) {
          labelXPos = Math.abs(props.x0 + props.x1) / 2;
        } else {
          labelXPos = props.x1 + labelPadding + formattedLabel.height / 2;
        }

        labelYPos = Math.abs(props.y1 + props.y0) / 2;
        node.config.labelAttr = _objectSpread({
          x: labelXPos,
          y: labelYPos,
          text: text,
          'text-anchor': MIDDLE,
          transform: (0, _lib.getSuggestiveRotation)(-90, labelXPos, labelYPos)
        }, labelCosmetics);
      }
    } else {
      if (!rotateLabel) {
        if (labelPosition === START) {
          labelYPos = props.y0 - labelPadding - formattedLabel.height / 2;
        } else if (labelPosition === INSIDE) {
          labelYPos = Math.abs(props.y0 + props.y1) / 2;
        } else {
          labelYPos = props.y1 + labelPadding + formattedLabel.height / 2;
        }

        anchor = MIDDLE;
        labelXPos = (props.x0 + props.x1) / 2;
        node.config.labelAttr = _objectSpread({
          x: labelXPos,
          y: labelYPos,
          text: text,
          transform: defaultTransform,
          'text-anchor': anchor
        }, labelCosmetics);
      } else {
        if (labelPosition === START) {
          labelYPos = props.y0 - labelPadding;
          anchor = START;
        } else if (labelPosition === INSIDE) {
          labelYPos = Math.abs(props.y0 + props.y1) / 2;
          anchor = MIDDLE;
        } else {
          labelYPos = props.y1 + labelPadding;
          anchor = END;
        }

        labelXPos = Math.abs(props.x1 + props.x0) / 2;
        node.config.labelAttr = _objectSpread({
          x: labelXPos,
          y: labelYPos,
          text: text,
          'text-anchor': anchor,
          transform: (0, _lib.getSuggestiveRotation)(-90, labelXPos, labelYPos)
        }, labelCosmetics);
      }
    }
  };

  _proto.draw = function draw() {
    var node = this,
        chartConfig = node.getFromEnv('chartConfig'),
        _node$config2 = node.config,
        id = _node$config2.id,
        labelAttr = _node$config2.labelAttr,
        nodeAttr = _node$config2.nodeAttr,
        textOutline = _node$config2.textOutline,
        tooltext = getTooltext(node.config, node, chartConfig);
    nodeAttr.height = nodeAttr.height > 1 ? nodeAttr.height : 1;
    node.addGraphicalElement({
      el: 'rect',
      attr: nodeAttr,
      container: {
        id: 'sankey-node-group',
        label: 'nodeGroup',
        isParent: true
      },
      tooltext: tooltext,
      component: node,
      id: id,
      label: 'node-rect'
    });
    labelAttr.text && node.addGraphicalElement({
      el: 'text',
      attr: labelAttr,
      container: {
        id: 'sankey-node-label-group',
        label: 'nodeLabelGroup',
        isParent: true
      },
      tooltext: tooltext,
      component: node,
      id: id,
      css: {},
      outlineText: textOutline,
      label: 'node-label'
    });
  };

  return SankeyNode;
}(_componentInterface.SmartRenderer);

var _default = SankeyNode;
exports["default"] = _default;

/***/ }),

/***/ 1434:
/***/ ((__unused_webpack_module, exports) => {



exports.__esModule = true;
exports.sankeyRibbon = void 0;

var M = 'M',
    C = 'C',
    L = 'L',
    DEFAULT_CURVATURE = 0.5,
    STATIC_LENGTH = 10,
    HORIZONTAL = 'horizontal',
    UNIFORM = 'uniform',
    horizontalRibbon = function horizontalRibbon(source, target, curvature, type) {
  if (curvature === void 0) {
    curvature = DEFAULT_CURVATURE;
  }

  if (type === void 0) {
    type = UNIFORM;
  }

  var x0,
      y0,
      x1,
      y1,
      sourceWidth = source.width,
      targetWidth = target.width,
      linePath,
      sy0,
      sy1,
      ty0,
      ty1,
      cx1,
      cy1,
      cx2,
      cy2;

  if (Math.abs(source.y - target.y) < 0.0001) {
    target.y += 0.0001;
  }

  x0 = source.x + STATIC_LENGTH;
  y0 = source.y;
  sy0 = y0 - sourceWidth / 2;
  sy1 = y0 + sourceWidth / 2;
  x1 = target.x - STATIC_LENGTH;
  y1 = target.y;
  ty0 = y1 - targetWidth / 2;
  ty1 = y1 + targetWidth / 2;

  if (x1 <= x0 || type !== UNIFORM) {
    x0 -= STATIC_LENGTH;
    x1 += STATIC_LENGTH;
  }

  cx1 = curvature * Math.abs(x1 - x0) + x0;
  cy1 = y0;
  cx2 = (1 - curvature) * Math.abs(x1 - x0) + x0;
  cy2 = y1;

  if (type === UNIFORM) {
    linePath = M + source.x + ',' + y0 + ' ' + L + x0 + ',' + y0 + ' ' + C + cx1 + ',' + cy1 + ' ' + cx2 + ',' + cy2 + ' ' + x1 + ',' + y1 + ' ' + L + target.x + ',' + y1;
  } else {
    linePath = M + x0 + ',' + sy0 + ' ' + L + x0 + ',' + sy0 + ' ' + C + cx1 + ',' + sy0 + ' ' + cx2 + ',' + ty0 + ' ' + x1 + ',' + ty0 + ' ' + L + x1 + ',' + ty1 + ' ' + C + cx2 + ',' + ty1 + ' ' + cx1 + ',' + sy1 + ' ' + x0 + ',' + sy1 + ' ' + L + x0 + ',' + sy0;
  }

  return linePath;
},
    verticalRibbon = function verticalRibbon(source, target, curvature, type) {
  if (curvature === void 0) {
    curvature = DEFAULT_CURVATURE;
  }

  if (type === void 0) {
    type = UNIFORM;
  }

  var x0,
      y0,
      x1,
      y1,
      linePath,
      sourceWidth = source.width,
      targetWidth = target.width,
      sx0,
      sx1,
      tx0,
      tx1,
      cx1,
      cy1,
      cx2,
      cy2;

  if (Math.abs(source.x - target.x) < 0.0001) {
    target.x += 0.0001;
  }

  x0 = source.x;
  sx0 = x0 - sourceWidth / 2;
  sx1 = x0 + sourceWidth / 2;
  y0 = source.y + STATIC_LENGTH;
  x1 = target.x;
  tx0 = x1 - targetWidth / 2;
  tx1 = x1 + targetWidth / 2;
  y1 = target.y - STATIC_LENGTH;

  if (y1 <= y0 || type !== UNIFORM) {
    y0 -= STATIC_LENGTH;
    y1 += STATIC_LENGTH;
  }

  cx1 = x0;
  cy1 = curvature * Math.abs(y1 - y0) + y0;
  cx2 = x1;
  cy2 = (1 - curvature) * Math.abs(y1 - y0) + y0;

  if (type === UNIFORM) {
    linePath = M + x0 + ',' + source.y + ' ' + L + x0 + ',' + y0 + ' ' + C + cx1 + ',' + cy1 + ' ' + cx2 + ',' + cy2 + ' ' + x1 + ',' + y1 + ' ' + L + x1 + ',' + target.y;
  } else {
    linePath = M + sx0 + ',' + y0 + ' ' + L + sx0 + ',' + y0 + ' ' + C + sx0 + ',' + cy1 + ' ' + tx0 + ',' + cy2 + ' ' + tx0 + ',' + y1 + ' ' + L + tx1 + ',' + y1 + ' ' + C + tx1 + ',' + cy2 + ' ' + sx1 + ',' + cy1 + ' ' + sx1 + ',' + y0 + ' ' + L + sx0 + ',' + y0;
  }

  return linePath;
},
    sankeyRibbon = function sankeyRibbon(source, target, config) {
  var curvature = config.curvature,
      orientation = config.orientation,
      padding = config.padding,
      linkType = config.linkType;
  orientation = orientation || HORIZONTAL;

  if (orientation === HORIZONTAL) {
    source.x = Math.floor(source.x + padding);
    target.x = Math.ceil(target.x - padding);
    return horizontalRibbon(source, target, curvature, linkType);
  }

  source.y = Math.floor(source.y + padding);
  target.y = Math.ceil(target.y - padding);
  return verticalRibbon(source, target, curvature, linkType);
};

exports.sankeyRibbon = sankeyRibbon;

/***/ }),

/***/ 1435:
/***/ ((__unused_webpack_module, exports) => {



exports.__esModule = true;
exports.createGraph = createGraph;
exports.createNodeLinks = createNodeLinks;
exports.createNodeValues = createNodeValues;
exports.traverseGraph = traverseGraph;
exports.createNodeDimensions = createNodeDimensions;

function _createForOfIteratorHelperLoose(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (it) return (it = it.call(o)).next.bind(it); if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; return function () { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

var MAX = Math.max,
    MIN = Math.min,
    VERYSMALLNUMBER = 1e-6,
    VERTICAL = 'vertical';

function findNodeById(_nodes, _node) {
  // Need to change this function to take in actual id
  var nodes = _nodes,
      node = _node;
  return nodes.find(function (d) {
    return d.id === node || d.label === node;
  });
}

function createNodeLinks(_ref) {
  var nodes = _ref.nodes,
      links = _ref.links;
  // Creating the Source - Target links of each node
  nodes.forEach(function (_node) {
    var node = _node;
    node.props.sourceLinks = []; // create empty arrays of source and target links

    node.props.targetLinks = [];
  });
  /** Populate the source and target Links array of each node */

  links.forEach(function (_link, index) {
    var link = _link,
        _link$props = link.props,
        source = _link$props.source,
        target = _link$props.target;
    if (typeof source !== 'object') source = link.props.source = findNodeById(nodes, source); // find the source node

    if (typeof target !== 'object') target = link.props.target = findNodeById(nodes, target); // find the target node

    source.props.sourceLinks.push(link);
    target.props.targetLinks.push(link);
    link.props.index = index;
  });
}

function ascendingHeight(a, b) {
  return a.props.target.props.y0 - b.props.target.props.y0;
}

function ascendingWidth(a, b) {
  return a.props.target.props.x0 - b.props.target.props.x0;
}

function sortLinks(_links, orientation) {
  var links = _links;

  if (orientation === VERTICAL) {
    links.sort(ascendingWidth);
  } else {
    links.sort(ascendingHeight);
  }

  return links;
}

function createLinkDimensions(_ref2, props) {
  var nodes = _ref2.nodes;
  var orientation = props && props.orientation;

  for (var _iterator = _createForOfIteratorHelperLoose(nodes), _step; !(_step = _iterator()).done;) {
    var node = _step.value;

    if (orientation === VERTICAL) {
      var x0 = node.props.x0,
          x1 = x0,
          sortedSourceLinks = sortLinks(node.props.sourceLinks, orientation);

      for (var _iterator2 = _createForOfIteratorHelperLoose(sortedSourceLinks), _step2; !(_step2 = _iterator2()).done;) {
        var link = _step2.value;
        link.props.x0 = x0 + link.props.linkWidth / 2;
        link.props.y0 = link.props.source.props.y1;
        x0 += link.props.linkWidth;
      }

      for (var _iterator3 = _createForOfIteratorHelperLoose(node.props.targetLinks), _step3; !(_step3 = _iterator3()).done;) {
        var _link2 = _step3.value;
        _link2.props.x1 = x1 + _link2.props.linkWidth / 2;
        _link2.props.y1 = _link2.props.target.props.y0;
        x1 += _link2.props.linkWidth;
      }
    } else {
      var y0 = node.props.y0,
          y1 = y0,
          _sortedSourceLinks = sortLinks(node.props.sourceLinks);

      for (var _iterator4 = _createForOfIteratorHelperLoose(_sortedSourceLinks), _step4; !(_step4 = _iterator4()).done;) {
        var _link3 = _step4.value;
        _link3.props.y0 = y0 + _link3.props.linkWidth / 2;
        _link3.props.x0 = _link3.props.source.props.x1;
        y0 += _link3.props.linkWidth;
      }

      for (var _iterator5 = _createForOfIteratorHelperLoose(node.props.targetLinks), _step5; !(_step5 = _iterator5()).done;) {
        var _link4 = _step5.value;
        _link4.props.y1 = y1 + _link4.props.linkWidth / 2;
        _link4.props.x1 = _link4.props.target.props.x0;
        y1 += _link4.props.linkWidth;
      }
    }
  }
}

function createNodeValues(_ref3) {
  var nodes = _ref3.nodes;
  nodes && nodes.forEach(function (_node) {
    var totalSourceValue = 0,
        totalTargetValue = 0,
        node = _node;

    for (var _iterator6 = _createForOfIteratorHelperLoose(node.props.sourceLinks), _step6; !(_step6 = _iterator6()).done;) {
      var value = _step6.value.value;
      totalSourceValue += Number(value);
    }

    for (var _iterator7 = _createForOfIteratorHelperLoose(node.props.targetLinks), _step7; !(_step7 = _iterator7()).done;) {
      var _value = _step7.value.value;
      totalTargetValue += Number(_value);
    }

    node.props.value = MAX(totalSourceValue, totalTargetValue); // Assign value to each node based on the maximun of source and target Link values
  });
}

function createGraph(graph) {
  createNodeLinks(graph);
  createNodeValues(graph);
  return graph;
}

function traverseGraph(_ref4) {
  var nodes = _ref4.nodes;
  var currentSet = new Set(nodes),
      // Create initial set of unique nodes
  nextSet = new Set(),
      // Creates empty set of next nodes
  depth = 0;
  /* Traverse the graph using BFS and calculate the depth of each node */

  while (currentSet.size) {
    // eslint-disable-next-line no-loop-func
    currentSet.forEach(function (_node) {
      var node = _node;
      node.props.depth = depth;

      for (var _iterator8 = _createForOfIteratorHelperLoose(node.props.sourceLinks), _step8; !(_step8 = _iterator8()).done;) {
        var link = _step8.value;
        nextSet.add(link.props.target);
      }
    });

    if (++depth > nodes.length) {
      return false;
    }

    ;
    currentSet = nextSet;
    nextSet = new Set();
  }

  return true;
}

function createNodeDimensions(graphs, _props) {
  var props = _props,
      iterations = 6,
      nodes = graphs.nodes,
      maxDepth = MAX.apply(null, nodes.map(function (node) {
    return node.props.depth;
  })) + 1; // Find maximum depth of the graph

  var columns = new Array(maxDepth);

  for (var _iterator9 = _createForOfIteratorHelperLoose(nodes), _step9; !(_step9 = _iterator9()).done;) {
    var node = _step9.value;
    var layer = MAX(0, MIN(maxDepth - 1, node.props.depth));
    node.props.layer = layer;
    if (columns[layer]) columns[layer].push(node);else columns[layer] = [node];
  }

  setnodeXY(columns, maxDepth, props);

  if (props.nodeRelaxation) {
    for (var i = 0; i < iterations; ++i) {
      // number of iterations = 6
      var convergence = Math.pow(0.99, i),
          divergence = Math.max(1 - convergence, (i + 1) / 6); // Convergence and divergence factors are calculated based on the difference of iterative values from 1

      relaxSources(columns, convergence, divergence, props);
      relaxTargets(columns, convergence, divergence, props);
    }
  }

  createLinkDimensions(graphs, props);
}

function setnodeXY(_columns, _maxDepth, _props) {
  var columns = _columns,
      props = _props,
      maxDepth = _maxDepth,
      maxNodeWidth,
      minNodesLength,
      nodeGutter,
      nodeValueFactor,
      columngapFactor,
      orientation = props.orientation;
  maxNodeWidth = MAX.apply(null, columns[maxDepth - 1].map(function (node) {
    return node.nodeWidth;
  }));
  columngapFactor = orientation === VERTICAL ? (props.height[1] - props.height[0] - maxNodeWidth) / (maxDepth - 1) : (props.width[1] - props.width[0] - maxNodeWidth) / (maxDepth - 1);
  nodeGutter = props.nodeGutter;
  minNodesLength = MAX.apply(null, columns.map(function (nodes) {
    return nodes.length;
  }));

  if (orientation === VERTICAL) {
    if ((minNodesLength - 1) * nodeGutter >= props.width[1] - props.width[0] || (minNodesLength - 1) * nodeGutter < 0) nodeGutter = props.nodeGutter = 10;
  } else {
    if ((minNodesLength - 1) * nodeGutter >= props.height[1] - props.height[0] || (minNodesLength - 1) * nodeGutter < 0) nodeGutter = props.nodeGutter = 10;
  }

  nodeValueFactor = MIN.apply(null, columns.map(function (nodes) {
    var totalValue = 0;

    for (var _iterator10 = _createForOfIteratorHelperLoose(nodes), _step10; !(_step10 = _iterator10()).done;) {
      var node = _step10.value;
      totalValue += node.props.value;
    }

    return orientation === VERTICAL ? (props.width[1] - props.width[0] - (nodes.length - 1) * nodeGutter) / totalValue : (props.height[1] - props.height[0] - (nodes.length - 1) * nodeGutter) / totalValue;
  }));
  if (!columngapFactor || columngapFactor === Infinity || columngapFactor === -Infinity) columngapFactor = 0;
  if (!nodeValueFactor || nodeValueFactor === Infinity || nodeValueFactor === -Infinity) nodeValueFactor = 0;

  for (var _iterator11 = _createForOfIteratorHelperLoose(columns), _step11; !(_step11 = _iterator11()).done;) {
    var nodes = _step11.value;

    if (orientation === VERTICAL) {
      var startX = props.width[0];

      for (var _iterator12 = _createForOfIteratorHelperLoose(nodes), _step12; !(_step12 = _iterator12()).done;) {
        var node = _step12.value;

        for (var _iterator13 = _createForOfIteratorHelperLoose(node.props.sourceLinks), _step13; !(_step13 = _iterator13()).done;) {
          var link = _step13.value;
          // Calculate the width of links of each sourcenode
          link.props.linkWidth = link.value * nodeValueFactor;
        }

        node.props.y0 = props.height[0] + node.props.layer * columngapFactor;
        node.props.y1 = node.props.y0 + node.nodeWidth;
        node.props.x0 = startX;
        node.props.x1 = node.props.x0 + nodeValueFactor * node.props.value;
        startX = node.props.x1 + nodeGutter;
      }
    } else {
      var startY = props.height[0];

      for (var _iterator14 = _createForOfIteratorHelperLoose(nodes), _step14; !(_step14 = _iterator14()).done;) {
        var _node2 = _step14.value;

        for (var _iterator15 = _createForOfIteratorHelperLoose(_node2.props.sourceLinks), _step15; !(_step15 = _iterator15()).done;) {
          var _link5 = _step15.value;
          // Calculate the width of links of each sourcenode
          _link5.props.linkWidth = _link5.value * nodeValueFactor;
        }

        _node2.props.x0 = props.width[0] + _node2.props.layer * columngapFactor;
        _node2.props.x1 = _node2.props.x0 + _node2.nodeWidth;
        _node2.props.y0 = startY;
        _node2.props.y1 = _node2.props.y0 + nodeValueFactor * _node2.props.value;
        startY = _node2.props.y1 + nodeGutter;
      }
    }
  }
} // Reposition each node based on its incoming (target) links.


function relaxTargets(columns, alpha, beta, props) {
  var orientation = props && props.orientation;

  for (var i = 1, n = columns.length; i < n; ++i) {
    var targetShiftFactor = void 0;
    var column = columns[i];

    for (var _iterator16 = _createForOfIteratorHelperLoose(column), _step16; !(_step16 = _iterator16()).done;) {
      var target = _step16.value;
      var y = 0,
          w = 0;

      for (var _iterator17 = _createForOfIteratorHelperLoose(target.props.targetLinks), _step17; !(_step17 = _iterator17()).done;) {
        var link = _step17.value;
        var valueFactor = link.value * (target.props.layer - link.props.source.props.layer);
        y += targetTop(link.props.source, target, props) * valueFactor;
        w += valueFactor;
      }

      if (!(w > 0)) continue;

      if (orientation === VERTICAL) {
        targetShiftFactor = (y / w - target.props.x0) * alpha;
        target.props.x0 += targetShiftFactor;
        target.props.x1 += targetShiftFactor;
      } else {
        targetShiftFactor = (y / w - target.props.y0) * alpha;
        target.props.y0 += targetShiftFactor;
        target.props.y1 += targetShiftFactor;
      }
    }

    resolveCollisions(column, beta, props);
  }
} // Reposition each node based on its outgoing (source) links.


function relaxSources(columns, alpha, beta, props) {
  var orientation = props && props.orientation;

  for (var n = columns.length, i = n - 2; i >= 0; --i) {
    var sourceShiftFactor = void 0;
    var column = columns[i];

    for (var _iterator18 = _createForOfIteratorHelperLoose(column), _step18; !(_step18 = _iterator18()).done;) {
      var source = _step18.value;
      var y = 0,
          w = 0;

      for (var _iterator19 = _createForOfIteratorHelperLoose(source.props.sourceLinks), _step19; !(_step19 = _iterator19()).done;) {
        var link = _step19.value;
        var target = link.props.target;
        var valueFactor = link.value * (target.props.layer - source.props.layer);
        y += sourceTop(source, target, props) * valueFactor;
        w += valueFactor;
      }

      if (!(w > 0)) continue;

      if (orientation === VERTICAL) {
        sourceShiftFactor = (y / w - source.props.x0) * alpha;
        source.props.x0 += sourceShiftFactor;
        source.props.x1 += sourceShiftFactor;
      } else {
        sourceShiftFactor = (y / w - source.props.y0) * alpha;
        source.props.y0 += sourceShiftFactor;
        source.props.y1 += sourceShiftFactor;
      }
    }

    resolveCollisions(column, beta, props);
  }
}

function resolveCollisions(nodes, beta, props) {
  var i = nodes.length >> 1,
      subject = nodes[i];
  var orientation = props && props.orientation;

  if (orientation === VERTICAL) {
    resolveCollisionsBottomToTop(nodes, subject.props.x0 - props.nodeGutter, i - 1, beta, props);
    resolveCollisionsTopToBottom(nodes, subject.props.x1 + props.nodeGutter, i + 1, beta, props);
    resolveCollisionsBottomToTop(nodes, props.width[1], nodes.length - 1, beta, props);
    resolveCollisionsTopToBottom(nodes, props.width[0], 0, beta, props);
  } else {
    resolveCollisionsBottomToTop(nodes, subject.props.y0 - props.nodeGutter, i - 1, beta, props);
    resolveCollisionsTopToBottom(nodes, subject.props.y1 + props.nodeGutter, i + 1, beta, props);
    resolveCollisionsBottomToTop(nodes, props.height[1], nodes.length - 1, beta, props);
    resolveCollisionsTopToBottom(nodes, props.height[0], 0, beta, props);
  }
} // Push any overlapping nodes down.


function resolveCollisionsTopToBottom(nodes, _y, _i, beta, props) {
  var i = _i,
      y = _y,
      orientation = props && props.orientation;

  for (; i < nodes.length; ++i) {
    var node = nodes[i],
        dy = (y - (orientation === VERTICAL ? node.props.x0 : node.props.y0)) * beta;

    if (orientation === VERTICAL) {
      if (dy > VERYSMALLNUMBER) {
        node.props.x0 += dy;
        node.props.x1 += dy;
      }

      y = node.props.x1 + props.nodeGutter;
    } else {
      if (dy > VERYSMALLNUMBER) {
        node.props.y0 += dy;
        node.props.y1 += dy;
      }

      y = node.props.y1 + props.nodeGutter;
    }
  }
} // Push any overlapping nodes up.


function resolveCollisionsBottomToTop(nodes, _y, _i, beta, props) {
  var i = _i,
      y = _y,
      orientation = props && props.orientation;

  for (; i >= 0; --i) {
    var node = nodes[i],
        dy = ((orientation === VERTICAL ? node.props.x1 : node.props.y1) - y) * beta;

    if (orientation === VERTICAL) {
      if (dy > VERYSMALLNUMBER) {
        node.props.x0 -= dy;
        node.props.x1 -= dy;
      }

      y = node.props.x0 - props.nodeGutter;
    } else {
      if (dy > VERYSMALLNUMBER) {
        node.props.y0 -= dy;
        node.props.y1 -= dy;
      }

      y = node.props.y0 - props.nodeGutter;
    }
  }
} // Returns the target.y0 that would produce an ideal link from source to target.


function targetTop(source, target, props) {
  var orientation = props && props.orientation,
      shiftStart = (orientation === VERTICAL ? source.props.x0 : source.props.y0) - (source.props.sourceLinks.length - 1) * props.nodeGutter / 2;

  for (var _iterator20 = _createForOfIteratorHelperLoose(source.props.sourceLinks), _step20; !(_step20 = _iterator20()).done;) {
    var link = _step20.value;
    var node = link.props.target,
        linkWidth = link.props.linkWidth;
    if (node === target) break;
    shiftStart += linkWidth + props.nodeGutter;
  }

  for (var _iterator21 = _createForOfIteratorHelperLoose(target.props.targetLinks), _step21; !(_step21 = _iterator21()).done;) {
    var _link6 = _step21.value;
    var _node3 = _link6.props.source,
        _linkWidth = _link6.props.linkWidth;
    if (_node3 === source) break;
    shiftStart -= _linkWidth;
  }

  return shiftStart;
} // Returns the source.y0 that would produce an ideal link from source to target.


function sourceTop(source, target, props) {
  var orientation = props && props.orientation,
      shiftStart = (orientation === VERTICAL ? target.props.x0 : target.props.y0) - (target.props.targetLinks.length - 1) * props.nodeGutter / 2;

  for (var _iterator22 = _createForOfIteratorHelperLoose(target.props.targetLinks), _step22; !(_step22 = _iterator22()).done;) {
    var link = _step22.value;
    var node = link.props.source,
        linkWidth = link.props.linkWidth;
    if (node === source) break;
    shiftStart += linkWidth + props.nodeGutter;
  }

  for (var _iterator23 = _createForOfIteratorHelperLoose(source.props.sourceLinks), _step23; !(_step23 = _iterator23()).done;) {
    var _link7 = _step23.value;
    var _node4 = _link7.props.target,
        _linkWidth2 = _link7.props.linkWidth;
    if (_node4 === target) break;
    shiftStart -= _linkWidth2;
  }

  return shiftStart;
}

/***/ }),

/***/ 1371:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _index = _interopRequireDefault(__webpack_require__(619));

var _default = {
  '*.dataset.selectScatter': _index.default['*.dataset.line']
};
exports["default"] = _default;

/***/ }),

/***/ 1370:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _scatter = _interopRequireDefault(__webpack_require__(723));

var _lib = __webpack_require__(274);

var _dependencyManager = __webpack_require__(282);

var _index = _interopRequireDefault(__webpack_require__(1371));

/* eslint require-jsdoc: 'error', valid-jsdoc: ["error", { "requireReturn": false }] */
var COLOR_FFFFFF = 'FFFFFF',
    XY_STR = 'xy',
    altHGridColorStr = _lib.preDefStr.altHGridColorStr,
    altHGridAlphaStr = _lib.preDefStr.altHGridAlphaStr;
(0, _dependencyManager.addDep)({
  name: 'selectScatterAnimation',
  type: 'animationRule',
  extension: _index.default
});
/**
 * Creates dataset class of Select scatter
 */

var SelectScatterDataset = /*#__PURE__*/function (_ScatterDataset) {
  (0, _inheritsLoose2.default)(SelectScatterDataset, _ScatterDataset);

  function SelectScatterDataset() {
    return _ScatterDataset.apply(this, arguments) || this;
  }

  var _proto = SelectScatterDataset.prototype;

  /**
   * Sets the type of the component
   * @return {string} type
   */
  _proto.getType = function getType() {
    return 'dataset';
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */
  ;

  _proto.getName = function getName() {
    return 'selectScatter';
  }
  /**
   * Configure default settings for datasets
   * @param {Object} datasetJSON dataset json
   */
  ;

  _proto.configure = function configure(datasetJSON) {
    _ScatterDataset.prototype.configure.call(this, datasetJSON);

    var dataSet = this,
        chart = dataSet.getFromEnv('chart'),
        chartConfig = chart.config,
        chartAttr = chart.getFromEnv('dataSource').chart,
        colorM = dataSet.getFromEnv('color-manager'),
        borderColor = (0, _lib.pluck)(chartAttr.selectbordercolor, colorM.getColor('canvasBorderColor')),
        borderAlpha = (0, _lib.pluckNumber)(chartAttr.selectborderalpha, colorM.getColor('canvasBorderAlpha'));
    chartConfig.selectBorderColor = // convertColor(borderColor, borderAlpha);
    {
      FCcolor: {
        color: borderColor,
        alpha: borderAlpha
      }
    };
    chartConfig.selectFillColor = (0, _lib.convertColor)((0, _lib.pluck)(chartAttr.selectfillcolor, colorM.getColor(altHGridColorStr)), (0, _lib.pluckNumber)(chartAttr.selectfillalpha, colorM.getColor(altHGridAlphaStr)));
    chartConfig.selectionCancelButtonBorderColor = (0, _lib.convertColor)((0, _lib.pluck)(chartAttr.selectioncancelbuttonbordercolor, borderColor), (0, _lib.pluckNumber)(chartAttr.selectioncancelbuttonborderalpha, borderAlpha));
    chartConfig.selectionCancelButtonFillColor = (0, _lib.convertColor)((0, _lib.pluck)(chartAttr.selectioncancelbuttonfillcolor, COLOR_FFFFFF), (0, _lib.pluckNumber)(chartAttr.selectioncancelbuttonfillalpha, 100));
    chartConfig.connativeZoom = false;
    chartConfig.zoomType = XY_STR;

    if (chartAttr.submitdataasxml === _lib.ZEROSTRING && !chartAttr.formdataformat) {
      chartAttr.formdataformat = (0, _dependencyManager.getDepsByType)('transcoder').csv && 'csv';
    } // @ temp will work after transcoder fix
    // chartConfig.formDataFormat = pluck(chartAttr.formdataformat,
    //             global.dataFormats.XML);


    chartConfig.formDataFormat = (0, _lib.pluck)(chartAttr.formdataformat);
    chartConfig.formTarget = (0, _lib.pluck)(chartAttr.formtarget, '_self');
    chartConfig.formMethod = (0, _lib.pluck)(chartAttr.formmethod, 'POST');
    chartConfig.submitFormAsAjax = (0, _lib.pluckNumber)(chartAttr.submitformusingajax, 1);
  }
  /**
   * Draws plot graphics
   */
  ;

  _proto.draw = function draw() {
    _ScatterDataset.prototype.draw.call(this);

    var dataSet = this,
        chart = dataSet.getFromEnv('chart'),
        container = chart.getFromEnv('chart-container'),
        xAxis = dataSet.getFromEnv('xAxis'),
        yAxis = dataSet.getFromEnv('yAxis');
    (0, _lib.bindSelectionEvent)(chart, {
      selectionStart: function selectionStart(data) {
        var pos = (0, _lib.getMouseCoordinate)(container, data.originalEvent, chart),
            // eslint-disable-line good-practices/no-single-usage-variable
        eventArgs = (0, _lib.extend2)({
          // eslint-disable-line good-practices/no-single-usage-variable
          selectionLeft: data.selectionLeft,
          selectionTop: data.selectionTop,
          selectionWidth: data.selectionWidth,
          selectionHeight: data.selectionHeight,
          startXValue: xAxis.getValue(data.selectionLeft, 1),
          startYValue: yAxis.getValue(data.selectionTop, 1)
        }, pos);
        /**
         * Raised when user starts to draw a selection box on a `selectScatter` chart.
         * @event FusionCharts#selectionStart
         *
         * @param {number} chartX - The x-coordinate of the mouse with respect to the chart.
         * @param {number} chartY - The y-coordinate of the mouse with respect to the chart.
         * @param {number} pageX - The x-coordinate of the mouse with respect to the page.
         * @param {number} pageY - The y-coordinate of the mouse with respect to the page.
         * @param {number} startXValue - The value on the canvas x-axis where the selection started.
         * @param {number} startYValue - The value on the canvas y-axis where the selection started.
         */

        data.chart.fireChartInstanceEvent('selectionStart', eventArgs);
      },
      selectionEnd: function selectionEnd(data) {
        var pos = (0, _lib.getMouseCoordinate)(container, data.originalEvent, chart),
            // eslint-disable-line good-practices/no-single-usage-variable
        eventArgs = (0, _lib.extend2)({
          // eslint-disable-line good-practices/no-single-usage-variable
          selectionLeft: data.selectionLeft,
          selectionTop: data.selectionTop,
          selectionWidth: data.selectionWidth,
          selectionHeight: data.selectionHeight,
          startXValue: xAxis.getValue(data.selectionLeft, 1),
          startYValue: yAxis.getValue(data.selectionTop, 1),
          endXValue: xAxis.getValue(data.selectionLeft + data.selectionWidth, 1),
          endYValue: yAxis.getValue(data.selectionTop + data.selectionHeight, 1)
        }, pos);
        /**
         * Raised when user completes a selection box on a `selectScatter` chart.
         * @event FusionCharts#selectionEnd
         *
         * @param {number} chartX - The x-coordinate of the mouse with respect to the chart.
         * @param {number} chartY - The y-coordinate of the mouse with respect to the chart.
         * @param {number} pageX - The x-coordinate of the mouse with respect to the page.
         * @param {number} pageY - The y-coordinate of the mouse with respect to the page.
         * @param {number} startXValue - The value on the canvas x-axis where the selection started.
         * @param {number} startYValue - The value on the canvas y-axis where the selection started.
         * @param {number} endXValue - The value on the canvas x-axis where the selection ended.
         * @param {number} endYValue - The value on the canvas y-axis where the selection ended.
         * @param {number} selectionLeft - The x-coordinate from where selection started with
         * respect to the chart.
         * @param {number} selectionTop - The y-coordinate from where selection started with
         * respect to the chart.
         * @param {number} selectionWidth - The width of the selection in pixels.
         * @param {number} selectionHeight - The height of the selection box in pixels.
         */

        data.chart.fireChartInstanceEvent('selectionEnd', eventArgs);
        data.chart.createSelectionBox(data);
      }
    });
  };

  return SelectScatterDataset;
}(_scatter.default);

var _default = SelectScatterDataset;
exports["default"] = _default;

/***/ }),

/***/ 1381:
/***/ ((__unused_webpack_module, exports) => {



exports.__esModule = true;
exports["default"] = void 0;
var _default = {
  'initial.dataset.multiLevelPie': function initialDatasetMultiLevelPie() {
    var datasetConf = this.config,
        ringpath;
    return {
      'ringpath.appearing': function ringpathAppearing(inputJSON) {
        ringpath = inputJSON.attr.ringpath;
        return [{
          initialAttr: {
            ringpath: [ringpath[0], ringpath[1], ringpath[2], ringpath[3], datasetConf.initialAngle, datasetConf.initialAngle]
          },
          slot: 'plot'
        }];
      },
      'text.appearing': function textAppearing() {
        return [{
          initialAttr: {
            opacity: 0
          },
          finalAttr: {
            opacity: 1
          },
          slot: 'final'
        }];
      }
    };
  }
};
exports["default"] = _default;

/***/ }),

/***/ 1380:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _assertThisInitialized2 = _interopRequireDefault(__webpack_require__(292));

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _lib = __webpack_require__(274);

var _dependencyManager = __webpack_require__(282);

var _index = _interopRequireDefault(__webpack_require__(1381));

var _schedular = __webpack_require__(286);

var _redraphaelShapes = _interopRequireDefault(__webpack_require__(390));

var _multilevelpie = _interopRequireDefault(__webpack_require__(1375));

var Raphael = (0, _dependencyManager.getDep)('redraphael', 'plugin'),
    BLANK = '',
    NORMALSTRING = 'normal',
    COLOR_FFFFFF = 'FFFFFF',
    COLOR_000000 = '000000',
    HUNDRED_PERCENT = '100%',
    ZERO_STR = '0',
    FOREST_INNER_RADIUS = '30',
    pInt = function pInt(s, mag) {
  return parseInt(s, mag || 10);
},
    DASH_DEF = 'none',
    UNDEF,
    ROLLOVER = 'DataPlotRollOver',
    ROLLOUT = 'DataPlotRollOut',
    POINTER = 'pointer',
    EVENTARGS = 'eventArgs',
    PX = 'px',
    INNERRADIUS = /^[0-9]+\%?$|^([0-9]+[.][0-9]+)\%?$/,
    calculateInnerRadius = function calculateInnerRadius(innerRadius, pieRadius) {
  var innerRadiusLength = innerRadius && innerRadius.length,
      // eslint-disable-line good-practices/no-single-usage-variable
  calculatedInnerRadius;

  if (!innerRadius) {
    return 0;
  }

  if (innerRadius.charAt(innerRadiusLength - 1) === '%') {
    // execute when innerRadius is given as percentage
    calculatedInnerRadius = (0, _lib.pluckNumber)(pieRadius) * ((0, _lib.pluckNumber)(innerRadius.split('%')[0]) / 100);
  } else {
    // execute when innerRadius is given in pixels.
    calculatedInnerRadius = (0, _lib.pluckNumber)(innerRadius);
  }

  if (calculatedInnerRadius < pieRadius) {
    return calculatedInnerRadius;
  }

  return 0;
};

(0, _dependencyManager.addDep)({
  name: 'sunburstAnimation',
  type: 'animationRule',
  extension: _index.default
}); // Adding required shapes for chart.

(0, _redraphaelShapes.default)(Raphael);

var SunburstDataset = /*#__PURE__*/function (_MultiLevelPieDataset) {
  (0, _inheritsLoose2.default)(SunburstDataset, _MultiLevelPieDataset);

  function SunburstDataset() {
    var _this;

    _this = _MultiLevelPieDataset.call(this) || this;
    var dataset = (0, _assertThisInitialized2.default)(_this);
    dataset.components = {
      data: []
    };
    dataset.graphics = {};

    dataset.elementClickedFn = function (e) {
      var ele = this,
          chart = dataset.getFromEnv('chart'),
          eventArgs = ele.data(EVENTARGS);
      chart.plotEventHandler(ele, e);

      if (chart.config.allowdrilltonode) {
        dataset.chartDrillDown(eventArgs.nodeId, eventArgs.nodeParentId, eventArgs.childrenCount);
      }
    };

    dataset.drillDownToId = UNDEF;
    dataset.nodeColorMap = {};
    return _this;
  }
  /**
   * Sets the type of the component
   * @return {string} type
   */


  var _proto = SunburstDataset.prototype;

  _proto.getType = function getType() {
    return 'dataset';
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */
  ;

  _proto.getName = function getName() {
    return 'multiLevelPie';
  };

  _proto.configureAttributes = function configureAttributes(datasetJSON) {
    if (!datasetJSON) {
      return false;
    }

    this.config.JSONData = datasetJSON;
    this.config.inputTree = datasetJSON.inputTree || [];
    this.config.isDrilledDown = datasetJSON.isDrilledDown;

    var fontBdrColor,
        dataSet = this,
        chart = dataSet.getFromEnv('chart'),
        chartConfig = chart.config,
        dataSetConfig = dataSet.config || (dataSet.config = {}),
        dataLabels = dataSetConfig.dataLabelOptions || (dataSetConfig.dataLabelOptions = {}),
        piePlotOptions = dataSetConfig.piePlotOptions,
        style = chart.config.style,
        chartAttrs = chart.getFromEnv('dataSource').chart,
        centerAngle = (0, _lib.pluckNumber)(-chartAttrs.centerangle, 180),
        totalAngle = (0, _lib.pluckNumber)(chartAttrs.totalangle, 360),
        tranverseToRoot = function tranverseToRoot(dataInstance, evtType) {
      var dataObj = dataInstance;
      travserseAllElements(dataSet, evtType);

      while (dataObj.graphics.element) {
        dataObj.graphics.element.attr({
          fill: evtType === 'mouseover' && dataSetConfig.hoverFillColor ? (0, _lib.convertColor)(dataSetConfig.hoverFillColor) : (dataObj.config || this.data('plotItem')).color,
          'fill-opacity': evtType === 'mouseover' ? dataSetConfig.hoverFillAlpha : (dataObj.config || this.data('plotItem')).alpha
        });
        dataObj = dataObj.config.parent;
      }
    },
        travserseAllElements = function travserseAllElements(ds, evtType) {
      var dsArr = ds.components.data;

      if (dsArr) {
        for (var i = 0; i < dsArr.length; i++) {
          if (dsArr[i].graphics && dsArr[i].graphics.element) {
            dsArr[i].graphics.element.attr({
              fill: (dsArr[i].config || this.data('plotItem')).color,
              'fill-opacity': evtType === 'mouseover' ? dataSetConfig.unFocussedAlpha : (dsArr[i].config || this.data('plotItem')).alpha
            });
          }
        }
      }

      if (ds.components && dsArr) {
        for (var _i = 0; _i < dsArr.length; _i++) {
          travserseAllElements(dsArr[_i], evtType);
        }
      }
    },
        traverseAllChildren = function traverseAllChildren(dataObj, evtType) {
      var k;
      dataObj.graphics.element.attr({
        fill: evtType === 'mouseover' ? dataSetConfig.hoverFillColor : (dataObj.config || this.data('plotItem')).color
      });

      for (k = 0; k < (dataObj.components.data && dataObj.components.data.length); k++) {
        traverseAllChildren.call(this, dataObj.components.data[k], evtType);
      }
    },
        mouseEvtHandler = function mouseEvtHandler(evtType) {
      if (!dataSetConfig.useHoverColor) {
        return;
      }

      var point = this.data('plotItem'),
          selfRef = point.selfRef;

      if (!dataSetConfig.highlightParentPieSlices && !dataSetConfig.highlightChildPieSlices) {
        selfRef.graphics.element.attr({
          fill: evtType === 'mouseover' ? dataSetConfig.hoverFillColor : (selfRef.config || point).color
        });
      } else if (!dataSetConfig.highlightParentPieSlices && dataSetConfig.highlightChildPieSlices) {
        traverseAllChildren.call(this, selfRef, evtType);
      } else if (dataSetConfig.highlightParentPieSlices && !dataSetConfig.highlightChildPieSlices) {
        tranverseToRoot.call(this, selfRef, evtType);
      } else if (dataSetConfig.highlightParentPieSlices && dataSetConfig.highlightChildPieSlices) {
        tranverseToRoot.call(this, selfRef, evtType);
        traverseAllChildren.call(this, selfRef, evtType);
      }
    };

    dataSetConfig.isSingleRootNode = dataSetConfig.inputTree.length === 1;
    dataSetConfig.enableAnimation = (0, _lib.pluckNumber)(chartAttrs.animation, chartAttrs.defaultanimation, 1);
    dataSetConfig.animation = !dataSetConfig.enableAnimation ? false : {
      duration: (0, _lib.pluckNumber)(chartAttrs.animationduration, chartAttrs.moveduration, 1) * 1000
    };
    dataSetConfig.showShadow = (0, _lib.pluckNumber)(chartAttrs.showshadow, 0);
    dataSetConfig.useHoverColor = Boolean((0, _lib.pluckNumber)(chartAttrs.usehovercolor, 1));
    dataSetConfig.showTextOutline = Boolean((0, _lib.pluckNumber)(chartAttrs.textoutline, 0));
    dataSetConfig.hoverFillAlpha = (0, _lib.pluckNumber)(chartAttrs.hoverfillalpha, 80);
    dataSetConfig.hoverFillColor = chartAttrs.hoverfillcolor;
    dataSetConfig.unFocussedAlpha = (0, _lib.pluck)(chartAttrs.unfocussedalpha, '0.35');
    fontBdrColor = (0, _lib.getFirstValue)(chartAttrs.valuebordercolor, BLANK);
    fontBdrColor = fontBdrColor ? (0, _lib.convertColor)(fontBdrColor, (0, _lib.pluckNumber)(chartAttrs.valueborderalpha, chartAttrs.valuebgalpha, chartAttrs.valuealpha, 100)) : BLANK; // create the style object if required.
    // fix for multilevel pie datavalue cosmetics issue RED-1594

    !dataLabels.style && (dataLabels.style = {
      fontFamily: (0, _lib.pluck)(chartAttrs.valuefont, style.fontFamily),
      fontSize: (0, _lib.pluckNumber)(this.computeFontSize(chartAttrs.valuefontsize), pInt(style.fontSize, 10)) + PX,
      color: (0, _lib.convertColor)((0, _lib.pluck)(chartAttrs.valuefontcolor, style.color), (0, _lib.pluckNumber)(chartAttrs.valuefontalpha, chartAttrs.valuealpha, 100)),
      fontWeight: (0, _lib.pluckNumber)(chartAttrs.valuefontbold) ? 'bold' : NORMALSTRING,
      fontStyle: (0, _lib.pluckNumber)(chartAttrs.valuefontitalic) ? 'italic' : NORMALSTRING,
      backgroundColor: chartAttrs.valuebgcolor ? (0, _lib.convertColor)(chartAttrs.valuebgcolor, (0, _lib.pluckNumber)(chartAttrs.valuebgalpha, chartAttrs.valuealpha, 100)) : BLANK,
      border: fontBdrColor || chartAttrs.valuebgcolor ? (0, _lib.pluckNumber)(chartAttrs.valueborderthickness, 1) + 'px solid' : BLANK,
      borderPadding: (0, _lib.pluckNumber)(chartAttrs.valueborderpadding, 2),
      borderThickness: (0, _lib.pluckNumber)(chartAttrs.valueborderthickness, style.borderThickness, 1),
      borderRadius: (0, _lib.pluckNumber)(chartAttrs.valueborderradius, style.borderRadius, 0),
      borderColor: fontBdrColor,
      borderDash: (0, _lib.pluckNumber)(chartAttrs.valueborderdashed, 0) ? (0, _lib.getDashStyle)((0, _lib.pluckNumber)(chartAttrs.valueborderdashlen, 4), (0, _lib.pluckNumber)(chartAttrs.valueborderdashgap, 2)) : DASH_DEF
    }); // stop point slicing

    !piePlotOptions && (piePlotOptions = dataSetConfig.piePlotOptions = {});
    piePlotOptions.allowPointSelect = false;
    dataSetConfig.borderAlpha = (0, _lib.pluck)(chartAttrs.plotborderalpha, chartAttrs.pieborderalpha, 100);
    dataSetConfig.borderColor = (0, _lib.convertColor)((0, _lib.pluck)(chartAttrs.plotbordercolor, chartAttrs.piebordercolor, COLOR_FFFFFF), +chartAttrs.showplotborder !== 0 ? (0, _lib.pluck)(chartAttrs.plotborderalpha, chartAttrs.pieborderalpha, 100) : 0);
    dataSetConfig.rawborderColor = (0, _lib.pluck)(chartAttrs.plotbordercolor, chartAttrs.piebordercolor, COLOR_FFFFFF);
    dataSetConfig.showplotborder = (0, _lib.pluckNumber)(chartAttrs.showplotborder, 1);
    dataSetConfig.showTooltip = (0, _lib.pluckNumber)(chartAttrs.showtooltip, 1);
    dataSetConfig.borderWidth = (0, _lib.pluckNumber)(chartAttrs.pieborderthickness, chartAttrs.plotborderthickness, 1);
    piePlotOptions.startingAngle = 0; // set the chart's startingAngle as 0 [alwase]

    piePlotOptions.size = HUNDRED_PERCENT;
    dataSetConfig.highlightParentPieSlices = (0, _lib.pluckNumber)(chartAttrs.highlightparentpieslices, chartAttrs.highlightparentpienodes, 1);
    dataSetConfig.highlightChildPieSlices = (0, _lib.pluckNumber)(chartAttrs.highlightchildpieslices, chartAttrs.highlightchildpienodes, 0);
    dataSetConfig.showLabels = (0, _lib.pluckNumber)(chartAttrs.showlabels, 1);
    dataSetConfig.showValues = (0, _lib.pluckNumber)(chartAttrs.showvalues, 0);
    dataSetConfig.showValuesInTooltip = (0, _lib.pluckNumber)(chartConfig.showvaluesintooltip, chartAttrs.showvaluesintooltip, chartAttrs.showvalues, 0);
    dataSetConfig.showPercentValues = (0, _lib.pluckNumber)(chartAttrs.showpercentvalues, chartAttrs.showpercentagevalues, 0);
    dataSetConfig.showPercentInTooltip = (0, _lib.pluckNumber)(chartAttrs.showpercentintooltip, 0);
    dataSetConfig.toolTipSepChar = (0, _lib.pluck)(chartAttrs.tooltipsepchar, chartAttrs.hovercapsepchar, _lib.COMMASPACE);
    dataSetConfig.labelSepChar = (0, _lib.parseUnsafeString)((0, _lib.pluck)(chartAttrs.labelsepchar, dataSetConfig.toolTipSepChar));
    dataSetConfig.tooltext = chartAttrs.plottooltext;
    dataSetConfig.alpha = (0, _lib.pluck)(chartAttrs.plotfillalpha, chartAttrs.piefillalpha, 100);
    dataSetConfig.startAngle = (centerAngle - totalAngle / 2) * (Math.PI / 180);
    dataSetConfig.endtAngle = (centerAngle + totalAngle / 2) * (Math.PI / 180);
    dataSetConfig.initialAngle = dataSetConfig.endtAngle;
    dataSetConfig.originX = (0, _lib.pluckNumber)(chartAttrs.originx);
    dataSetConfig.originY = (0, _lib.pluckNumber)(chartAttrs.originy);
    dataSetConfig.events = {
      mouseOver: function mouseOver() {
        mouseEvtHandler.call(this, 'mouseover');
      },
      mouseOut: function mouseOut() {
        mouseEvtHandler.call(this, 'mouseout');
      }
    }; // remove the plotboder

    chartConfig.plotBorderWidth = 0; // remove the plotboder

    chartConfig.plotBorderWidth = 0;
    dataSetConfig.maxLevel = dataSet.addMSPieCat(dataSet.config.inputTree, 1, dataSet, dataSetConfig.startAngle, dataSetConfig.endtAngle);
    dataSetConfig.pieRadius = parseInt(chartAttrs.pieradius, 10); // dataSetConfig.innerRadius = pluckNumber(Number(pluck(chartAttrs.innerradius, '0%').split('%')[0]), 0);

    dataSetConfig.innerRadius = dataSetConfig.isSingleRootNode ? ZERO_STR : FOREST_INNER_RADIUS;
    INNERRADIUS.test(chartAttrs.innerradius) && (!dataSetConfig.isSingleRootNode ? +dataSetConfig.innerRadius < +chartAttrs.innerradius && (dataSetConfig.innerRadius = (0, _lib.pluck)(chartAttrs.innerradius)) : dataSetConfig.innerRadius = (0, _lib.pluck)(chartAttrs.innerradius));
    dataLabels.distance = 0;
    dataLabels.placeLabelsInside = true;
  } // doHide is a Boolean Flag to hide the element or not.
  // All the graphical elements in excess are pushed to the graphics pool. They are hidden only after the
  // entire draw is complete.
  ;

  _proto.removalFn = function removalFn(ele, prop) {
    var dataSet = this,
        // eslint-disable-next-line good-practices/no-function-dependency
    hideFN = function hideFN() {
      this.remove();
    };

    dataSet.getFromEnv('animationManager').setAnimation({
      el: ele,
      label: prop === 'element' ? 'ringpath' : 'label',
      component: dataSet,
      callback: hideFN
    });
  };

  _proto.removeGraphics = function removeGraphics(obj) {
    var i,
        prop,
        dataSet = this,
        childData = obj.components && obj.components.data,
        len,
        graphics = obj.graphics;

    if (childData) {
      len = childData.length;

      for (i = 0; i < len; i += 1) {
        dataSet.removeGraphics(childData[i]);
      }
    }

    if (obj.graphics) {
      for (prop in graphics) {
        if (graphics.hasOwnProperty(prop)) {
          dataSet.removalFn(obj.graphics[prop], prop);
        }
      }
    }
  };

  _proto.removeChild = function removeChild(removalStore, doHide, type) {
    var i,
        elemObj,
        dataSet = this;

    if (removalStore.length) {
      for (i = 0; i < removalStore.length; i += 1) {
        elemObj = removalStore[i];

        if (type) {
          dataSet.removalFn(elemObj, doHide, type);
        } else {
          dataSet.removeGraphics(elemObj, doHide);
        }
      }
    } else {
      // if the removalStore is in the Object structure.
      // eslint-disable-next-line guard-for-in
      for (i in removalStore) {
        dataSet.removeChild(removalStore[i], doHide, i);
      }
    }
  };

  _proto.addMSPieCat = function addMSPieCat(catArr, level, parentObj, startAngle, endAngle, totalValueParam) {
    if (totalValueParam === void 0) {
      totalValueParam = null;
    }

    var dataObj,
        dataObjLen,
        cat = (0, _lib.extend2)([], catArr),
        catObjLen,
        catLen = cat.length,
        dataSet = this,
        data = parentObj.components.data,
        dataSetConfig = dataSet.config,
        numberFormatter = dataSet.getFromEnv('number-formatter'),
        sharePercent,
        currentLevelValue = 0,
        totalValue,
        catObj,
        catVal,
        i,
        label,
        labelSepChar = dataSetConfig.labelSepChar,
        fillalpha,
        valueStr,
        pValueStr,
        toolText,
        displayValue,
        showLabelValue,
        rawColor,
        showLabel,
        showPlotBorder,
        maxLevel = level,
        dataLength = data.length,
        // eslint-disable-line good-practices/no-single-usage-variable
    removalFn = function removalFn() {
      dataSet.removeChild.apply(dataSet, arguments);
    },
        catLength = cat.length,
        totAngle = endAngle - startAngle,
        // eslint-disable-line good-practices/no-single-usage-variable
    tempAngle,
        cumilative = 0,
        // eslint-disable-line good-practices/no-single-usage-variable
    preDataOldEndAngle;

    for (i = 0; i < catLen; i += 1) {
      // store for later use
      catObj = cat[i];
      catObj._userValue = numberFormatter.getCleanValue(catObj.value, true);
      catObj._value = (0, _lib.pluckNumber)(catObj._userValue, 1);
      currentLevelValue += catObj._value;
    } // Total value can't be zero, since its used in denominator to find ratio.


    totalValue = totalValueParam || currentLevelValue || 1; // add the category

    sharePercent = totAngle / totalValue; // eslint-disable-line good-practices/no-single-usage-variable

    for (i = catLen - 1; i >= 0; i -= 1) {
      catObj = cat[i];
      catVal = sharePercent * catObj._value;
      label = (0, _lib.parseUnsafeString)((0, _lib.pluck)(catObj.label, catObj.name));
      valueStr = catObj._userValue !== null ? numberFormatter.dataLabels(catObj._userValue) : BLANK;
      pValueStr = numberFormatter.percentValue(catObj._value / totalValue * 100); // pointIndex = sLevel.length - 1;

      fillalpha = (0, _lib.pluckNumber)(catObj.alpha, dataSetConfig.alpha);
      showLabel = (0, _lib.pluckNumber)(catObj.showlabel, dataSetConfig.showLabels);
      showPlotBorder = (0, _lib.pluckNumber)(dataSetConfig.showplotborder, 1);
      displayValue = showLabel === 1 ? label : BLANK;
      showLabelValue = (0, _lib.pluckNumber)(catObj.showlabelvalue, '');

      if ((0, _lib.pluckNumber)(catObj.showvalue, dataSetConfig.showValues) === 1) {
        if (dataSetConfig.showPercentValues) {
          displayValue += displayValue !== BLANK ? labelSepChar + pValueStr : pValueStr;
        } else if (valueStr !== UNDEF && valueStr !== BLANK) {
          displayValue += displayValue !== BLANK ? labelSepChar + valueStr : valueStr;
        }
      }

      toolText = dataSetConfig.showTooltip ? (0, _lib.parseUnsafeString)((0, _lib.pluck)(catObj.tooltext, catObj.hovertext, dataSetConfig.tooltext), false) : UNDEF;

      if (toolText === BLANK) {
        toolText = label;

        if (dataSetConfig.showValuesInTooltip) {
          if (dataSetConfig.showPercentInTooltip) {
            toolText += toolText !== BLANK ? labelSepChar + pValueStr : pValueStr;
          } else if (valueStr !== UNDEF && valueStr !== BLANK) {
            toolText += toolText !== BLANK ? labelSepChar + valueStr : valueStr;
          }
        }
      } else {
        toolText = (0, _lib.parseTooltext)(toolText, [1, 2, 3, 14], {
          percentValue: pValueStr,
          label: label,
          formattedValue: valueStr
        }, catObj);
      }

      dataObj = data[i];
      tempAngle = startAngle + cumilative;
      cumilative += catVal;

      if (!dataObj) {
        dataObj = data[i] = {
          components: {
            data: []
          },
          config: {},
          graphics: {}
        };
      } // store old end angle for newly added element's aimation position


      if (dataObj.graphics.element) {
        preDataOldEndAngle = dataObj.config.startAngle + dataObj.config.angleStrech;
      }

      rawColor = catObj.color ? catObj.color : level > (dataSetConfig.isSingleRootNode ? 2 : 1) ? parentObj.config.rawColor : dataSet.config.isDrilledDown && dataSet.nodeColorMap[catObj.id] ? dataSet.nodeColorMap[catObj.id] : dataSet.getFromEnv('color-manager').getPlotColor();
      dataSet.nodeColorMap[catObj.id] = rawColor;
      dataObj.config = {
        initialAngle: preDataOldEndAngle || (parentObj.config || parentObj.config).initialAngle,
        startAngle: tempAngle,
        alpha: fillalpha,
        angleStrech: catVal,
        level: level,
        displayValue: displayValue,
        showLabel: showLabel,
        showPlotBorder: showPlotBorder,
        toolText: toolText,
        link: (0, _lib.getValidValue)(catObj.link),
        drillDownToId: catObj.id,
        drillDownParent: catObj.parent,
        childrenCount: catObj.category ? catObj.category.length : 0,
        rawColor: rawColor,
        doNotSlice: true,
        // added to stop slicing
        color: (0, _lib.convertColor)(rawColor, fillalpha),
        borderAlpha: (0, _lib.pluck)(catObj.plotborderalpha, dataSetConfig.borderAlpha),
        borderWidth: (0, _lib.pluckNumber)(catObj.borderwidth, dataSetConfig.borderWidth),
        borderColor: (0, _lib.pluck)(catObj.bordercolor, dataSetConfig.borderColor),
        rawborderColor: (0, _lib.pluck)(catObj.bordercolor, dataSetConfig.rawborderColor),
        dashStyle: (0, _lib.pluckNumber)(catObj.valueborderdashed, 0) ? (0, _lib.getDashStyle)((0, _lib.pluckNumber)(catObj.borderdashlen, 4), (0, _lib.pluckNumber)(catObj.borderdashgap, 2)) : DASH_DEF,
        shadow: {
          opacity: Math.round(fillalpha > 50 ? fillalpha * fillalpha * fillalpha * 0.0001 : fillalpha * fillalpha * 0.01) * 0.01
        },
        isSingleTon: !(catLen > 1),
        showLabelValue: showLabelValue
      };
      dataObj.config.parent = parentObj;
      dataObj.config.dataLabelStyle = dataSet._configureDataLabelStyle(catObj);

      if (catObj.category && catObj.category.length > 0) {
        maxLevel = Math.max(maxLevel, dataSet.addMSPieCat(catObj.category, level + 1, dataObj, tempAngle, catVal + tempAngle, catObj._value));

        if ((dataObjLen = dataObj.components.data.length) > (catObjLen = catObj.category.length)) {
          removalFn(dataObj.components.data.splice(dataObjLen - 1, catObjLen));
        }
      } else {
        dataObjLen = dataObj.components.data.length;

        if (dataObjLen) {
          // no child category, recursively remove existing childs (dataObj.components.data)
          removalFn(dataObj.components.data.splice(0, dataObjLen));
        }
      }
    } // remove extra data


    if (dataLength > catLength) {
      // recursively remove elements with child
      removalFn(data.splice(catLength));
    }

    return maxLevel;
  };

  _proto.chartDrillDown = function chartDrillDown(drillDownToId, parentId, childrenCount) {
    var dataset = this,
        chart = dataset.getFromEnv('chart'),
        tree = chart.getFromEnv('parsedDataSource'),
        stack = [].concat(tree),
        toolTipController = dataset.getFromEnv('toolTipController');
    var idToSearch = dataset.drillDownToId === drillDownToId ? parentId : drillDownToId,
        searchedItem = null;

    if (childrenCount > 0) {
      if (idToSearch) {
        while (stack.length > 0) {
          var top = stack.pop();

          if (top.id !== idToSearch) {
            stack.push.apply(stack, top.category);
          } else {
            searchedItem = top;
          }
        }
      } else {
        dataset.setData({
          isDrilledDown: true,
          inputTree: tree
        }, true);
        dataset.drillDownToId = UNDEF;
        toolTipController.hideAll();
        return;
      }

      if (searchedItem.length > 0 || searchedItem.category.length > 0) {
        dataset.drillDownToId = idToSearch;
        dataset.setData({
          isDrilledDown: true,
          inputTree: [searchedItem]
        }, true);
        toolTipController.hideAll();
      }
    }
  };

  _proto.parsePlotAttributes = function parsePlotAttributes(parentInstance) {
    var angle,
        parentObj = parentInstance,
        _textAttrs,
        centerDistance,
        level,
        dataSet = this,
        dataSetConfig = dataSet.config || {},
        chart = dataSet.getFromEnv('chart'),
        chartConfig = chart.config,
        len = dataSet.components.data.length,
        // eslint-disable-line good-practices/no-single-usage-variable
    seriesDataLabelsStyle = chartConfig.dataLabelStyle,
        setDataLabelStyle,
        canvasWidth = chartConfig.canvasWidth,
        canvasHeight = chartConfig.canvasHeight,
        cx = (0, _lib.pluckNumber)(dataSetConfig.originX, chartConfig.canvasLeft + canvasWidth * 0.5),
        cy = (0, _lib.pluckNumber)(dataSetConfig.originY, chartConfig.canvasTop + canvasHeight * 0.5),
        r,
        r2,
        color,
        val,
        displayValue,
        clickablePath,
        angle1,
        angle2,
        i,
        setGraphics,
        setConfig,
        element,
        pieSize = (0, _lib.pluckNumber)(dataSetConfig.pieRadius * 2, Math.min(canvasWidth, canvasHeight)),
        // innerRadius in diameter of inner circle
    innerRadius = calculateInnerRadius(dataSetConfig.innerRadius, pieSize / 2),
        pool = dataSet.config.pool || (dataSet.config.pool = {}),
        // either the user-specified size is chosen or the minimum aspect dimension is choosen
    // pieSize is diameter of full pie
    seriesHalfWidth = (pieSize - 2 * innerRadius) / (2 * dataSetConfig.maxLevel);

    dataSetConfig.innerSize = innerRadius * 2;

    if (!parentObj) {
      parentObj = dataSet;
    }

    len = parentObj.components.data.length; // eslint-disable-line good-practices/no-single-usage-variable

    for (i = 0; i < len; i += 1) {
      dataSet.parsePlotAttributes(parentObj.components.data[i]);
    }

    setConfig = parentObj.config;
    level = setConfig.level;

    if (level) {
      r = level * seriesHalfWidth + innerRadius;
      r2 = (level - 1) * seriesHalfWidth + innerRadius;
      setConfig.outerRadius = r;
      setConfig.innerRadius = r2;
      setGraphics = parentObj.graphics;
      val = setConfig.angleStrech;
      displayValue = setConfig.displayValue; // toolText = setConfig.toolText;

      clickablePath = !!chart.config.allowdrilltonode && setConfig.childrenCount > 0 || !!setConfig.link;
      color = setConfig.color;
      angle1 = setConfig.startAngle;
      angle2 = angle1 + setConfig.angleStrech;
      element = setGraphics.element;

      if (pool.element && pool.element.length) {
        element = setGraphics.element = element || pool.element.shift();
      }

      setConfig.plotItem = {
        chart: chart,
        link: setConfig.link,
        value: val,
        color: color,
        labelText: displayValue,
        graphics: {
          element: element
        },
        selfRef: parentObj
      };
      setConfig.eventArgs = {
        alpha: setConfig.alpha,
        borderAlpha: setConfig.borderAlpha,
        link: setConfig.link,
        label: setConfig.displayValue,
        showLabel: setConfig.showLabel,
        toolText: setConfig.toolText,
        color: setConfig.rawColor,
        borderColor: setConfig.rawborderColor,
        borderThickness: setConfig.borderWidth,
        showPlotBorder: setConfig.showPlotBorder,
        nodeId: setConfig.drillDownToId,
        nodeParentId: setConfig.drillDownParent,
        childrenCount: setConfig.childrenCount
      };
      setConfig.props = {
        element: {
          attr: {
            ringpath: [cx, cy, r, r2, angle1, angle2],
            'stroke-width': setConfig.borderWidth,
            'stroke': setConfig.borderColor,
            fill: (0, _lib.toRaphaelColor)(setConfig.color),
            'stroke-dasharray': setConfig.dashStyle,
            cursor: clickablePath ? POINTER : 'initial'
          }
        }
      };

      if (displayValue !== UNDEF && displayValue !== _lib.BLANKSTRING) {
        angle = (angle1 + angle2) / 2; // for the innermost Concentric circle the center distance is presumed to be zero

        centerDistance = r2 === 0 && setConfig.isSingleTon ? 0 : r2 + (r - r2) / 2;

        if (!(_textAttrs = setConfig._textAttrs)) {
          _textAttrs = setConfig._textAttrs = {};
        }

        setDataLabelStyle = setConfig.dataLabelStyle;
        _textAttrs.text = displayValue;
        _textAttrs.fill = setDataLabelStyle.color || COLOR_000000;
        _textAttrs.direction = chartConfig.textDirection;
        _textAttrs.cursor = clickablePath ? POINTER : 'initial';
        _textAttrs.x = cx + centerDistance * Math.cos(angle);
        _textAttrs.y = cy + centerDistance * Math.sin(angle);
        _textAttrs['line-height'] = seriesDataLabelsStyle.lineHeight;
        _textAttrs['text-bound'] = [setDataLabelStyle.backgroundColor, setDataLabelStyle.borderColor, seriesDataLabelsStyle.borderThickness, seriesDataLabelsStyle.borderPadding, seriesDataLabelsStyle.borderRadius, seriesDataLabelsStyle.borderDash];
      }
    }
  }
  /**
   * Parses label attributes and position during post space management
   *
   * @param {any} parentObj
   * @memberof SunburstDataset
   */
  ;

  _proto.parseLabelAttributes = function parseLabelAttributes(parentInstance) {
    var dataSet = this,
        parentObj = parentInstance,
        len = dataSet.components.data.length,
        // eslint-disable-line good-practices/no-single-usage-variable
    displayValue,
        i,
        setConfig; // dataLabelsLayer.show();

    !parentObj && (parentObj = dataSet);
    len = parentObj.components.data.length; // eslint-disable-line good-practices/no-single-usage-variable

    for (i = 0; i < len; i += 1) {
      dataSet.parseLabelAttributes(parentObj.components.data[i]);
    }

    setConfig = parentObj.config; // plotItem = setConfig.plotItem;

    displayValue = setConfig.displayValue;

    if (setConfig.level) {
      if (displayValue !== UNDEF && displayValue !== _lib.BLANKSTRING) {
        setConfig.props.label = {
          attr: setConfig._textAttrs
        };
      }
    }
  };

  _proto.draw = function draw(parentInstance) {
    var dataSet = this,
        parentObj = parentInstance,
        dataSetConfig = dataSet.config || {},
        chart = dataSet.getFromEnv('chart'),
        dataSetComponents = dataSet.components,
        len = dataSetComponents.data.length,
        // eslint-disable-line good-practices/no-single-usage-variable
    i,
        setGraphics,
        setConfig,
        element,
        elementCheck,
        dataLabelsLayer = chart.getChildContainer('datalabelsGroup'),
        events = dataSetConfig.events || {},
        plotHoverFN = function plotHoverFN(e) {
      var o = this,
          mouseOver = events.mouseOver,
          plotItem = o.plotItem || o.data('plotItem'),
          dataset = plotItem.chart.getDatasets()[0]; // eslint-disable-line good-practices/no-single-usage-variable

      chart.plotEventHandler(o, e, ROLLOVER);
      mouseOver && mouseOver.call(o);
      dataset.fireEvent('datasetrollover', {
        pValue: plotItem.pValue,
        value: plotItem.value,
        displayValue: setConfig.displayValue
      });
    },
        plotMouseOut = function plotMouseOut(e) {
      var o = this,
          mouseOut = events.mouseOut,
          plotItem = o.plotItem || o.data('plotItem'),
          chartAPI = plotItem.chart,
          dataset = chartAPI.getDatasets()[0]; // eslint-disable-line good-practices/no-single-usage-variable

      chartAPI.plotEventHandler(o, e, ROLLOUT);
      mouseOut && mouseOut.call(o);
      dataset.fireEvent('datasetrollout', {
        pValue: plotItem.pValue,
        value: plotItem.value,
        displayValue: setConfig.displayValue
      });
    },
        removeDataArr = dataSetComponents.removeDataArr; // dataSetConfig.innerSize = innerRadius * 2;


    removeDataArr && removeDataArr.length && dataSet.removeElement();

    if (!parentObj) {
      parentObj = dataSet;
      dataLabelsLayer.css(chart.config.dataLabelStyle);
    }

    len = parentObj.components.data.length; // eslint-disable-line good-practices/no-single-usage-variable

    for (i = 0; i < len; i += 1) {
      dataSet.draw(parentObj.components.data[i]);
    }

    setConfig = parentObj.config;

    if (setConfig.level) {
      setGraphics = parentObj.graphics;
      elementCheck = setGraphics.element; // Create/reuse element

      element = setGraphics.element = dataSet.getFromEnv('animationManager').setAnimation({
        el: elementCheck || 'ringpath',
        attr: setConfig.props.element.attr,
        container: chart.getChildContainer('plotGroup'),
        component: dataSet,
        state: 'appearing',
        label: 'ringpath'
      });

      if (!elementCheck) {
        element.on('fc-mouseover', plotHoverFN).on('fc-mouseout', plotMouseOut);
      }

      element.shadow(dataSetConfig.showShadow && !!setConfig.shadow).data('plotItem', setConfig.plotItem).data(EVENTARGS, setConfig.eventArgs); // On click, the chart is drilled down and drawn again
      // The event handler callback is attached n number of times
      // Thus removing old handlers

      element.off('fc-click', dataSet.elementClickedFn);
      element.on('fc-click', dataSet.elementClickedFn);
      dataSet.getFromEnv('toolTipController').enableToolTip(element, setConfig.toolText);

      if (!i && !dataSetConfig._drawn) {
        dataSetConfig._drawn = true;
        dataLabelsLayer.show();
        dataSet.addJob('labelJob', dataSet.drawLabel.bind(dataSet), _schedular.priorityList.label);
      }
    } else {
      // If the chart is already drawn, then instead of sheduling the label drawing, directly draw the
      // labels.
      dataSetConfig._drawn && dataSet.drawLabel();
    }
  };

  _proto.drawLabel = function drawLabel(parentInstance) {
    var dataSet = this,
        angle,
        angleStretch,
        config = dataSet.config,
        parentObj = parentInstance,
        chart = dataSet.getFromEnv('chart'),
        animationManager = dataSet.getFromEnv('animationManager'),
        smartLabel = dataSet.getFromEnv('smartLabel'),
        labelSmartObj,
        chartConfig = chart.config,
        labelAttrs,
        len = dataSet.components.data.length,
        // eslint-disable-line good-practices/no-single-usage-variable
    tooltipOptions = chartConfig.tooltip || {},
        isTooltip = tooltipOptions && tooltipOptions.enabled !== false,
        // eslint-disable-line good-practices/no-single-usage-variable
    toolText,
        displayValue,
        tempLabel,
        i,
        setGraphics,
        setConfig,
        label,
        events = (config || {}).events || {},
        labelHoverFN = function labelHoverFN(e) {
      var o = this,
          mouseOver = events.mouseOver;
      chart.plotEventHandler(o, e, ROLLOVER);
      mouseOver && mouseOver.call(o);
    },
        labelOutFN = function labelOutFN(e) {
      var o = this,
          mouseOut = events.mouseOut;
      chart.plotEventHandler(o, e, ROLLOUT);
      mouseOut && mouseOut.call(o);
    },
        dataLabelsLayer = chart.getChildContainer('datalabelsGroup');

    dataLabelsLayer.show();
    !parentObj && (parentObj = dataSet);
    len = parentObj.components.data.length; // eslint-disable-line good-practices/no-single-usage-variable

    for (i = 0; i < len; i += 1) {
      dataSet.drawLabel(parentObj.components.data[i]);
    }

    setConfig = parentObj.config;
    angleStretch = setConfig.angleStrech;
    angle = (setConfig.startAngle + angleStretch / 2) * 180 / Math.PI;

    if (Math.abs(angle) > 90 && Math.abs(angle) < 270) {
      angle = -(180 - angle);
    }

    if (Math.floor(angleStretch * 180 / Math.PI) === 360) {
      angle = 0;
    }

    displayValue = setConfig.displayValue;
    smartLabel.useEllipsesOnOverflow(true);
    smartLabel.setStyle(chartConfig.dataLabelStyle);
    labelSmartObj = smartLabel.getSmartText(displayValue, setConfig.outerRadius - setConfig.innerRadius - 10, smartLabel._lineHeight);

    if (setConfig.level) {
      setGraphics = parentObj.graphics;
      tempLabel = setGraphics.label;

      if (displayValue !== UNDEF && displayValue !== _lib.BLANKSTRING && (angleStretch > 0.1 || setConfig.showLabelValue === 1) && setConfig.showLabelValue !== 0) {
        label = setGraphics.label;
        labelAttrs = setConfig.props.label.attr;
        labelAttrs.text = labelSmartObj.text;
        labelAttrs.transform = (0, _lib.getSuggestiveRotation)(parseFloat(angle), labelAttrs.x, labelAttrs.y); // Create/Reuse label

        label = setGraphics.label = animationManager.setAnimation({
          el: tempLabel || 'text',
          attr: labelAttrs,
          container: dataLabelsLayer,
          component: dataSet,
          state: 'appearing',
          label: 'text'
        });
        label.outlineText(config.showTextOutline, labelAttrs.fill);

        if (!tempLabel) {
          label.on('fc-mouseout', labelOutFN).on('fc-mouseover', labelHoverFN); // On click, the chart is drilled down and drawn again
          // The event handler callback is attached n number of times
          // Thus removing old handlers

          label.off('fc-click', dataSet.elementClickedFn);
          label.on('fc-click', dataSet.elementClickedFn);
        }

        label.data('plotItem', setConfig.plotItem).data(EVENTARGS, setConfig.eventArgs);
        isTooltip && dataSet.getFromEnv('toolTipController').enableToolTip(label, toolText);
      } else {
        // In case of extra labels, hide them
        tempLabel && animationManager.setAnimation({
          el: tempLabel,
          component: dataSet,
          label: 'text'
        });
        delete setGraphics.label;
      }
    }
  };

  return SunburstDataset;
}(_multilevelpie.default);

var _default = SunburstDataset;
exports["default"] = _default;

/***/ }),

/***/ 1364:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _index = _interopRequireDefault(__webpack_require__(599));

var _default = {
  'initial.dataset.waterFall2D': _index.default['initial.dataset.column']
};
exports["default"] = _default;

/***/ }),

/***/ 1363:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _lib = __webpack_require__(274);

var _column = _interopRequireWildcard(__webpack_require__(595));

var _dependencyManager = __webpack_require__(282);

var _index = _interopRequireDefault(__webpack_require__(1364));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var HUNDREDSTRING = '100',
    PLOTBORDERCOLOR = 'plotBorderColor',
    PLOTGRADIENTCOLOR = 'plotGradientColor',
    COMMA = ',',
    BLANK = '',
    SHOWSHADOW = 'showShadow',
    NONE = 'none',
    MAX_MITER_LINEJOIN = 2,
    M = 'M',
    H = 'H',
    UNDEF;
(0, _dependencyManager.addDep)({
  name: 'waterFall2DAnimation',
  type: 'animationRule',
  extension: _index.default
});

var WaterFall2DDataset = /*#__PURE__*/function (_ColumnDataset) {
  (0, _inheritsLoose2.default)(WaterFall2DDataset, _ColumnDataset);

  function WaterFall2DDataset() {
    return _ColumnDataset.apply(this, arguments) || this;
  }

  var _proto = WaterFall2DDataset.prototype;

  /**
   * Sets the type of the component
   * @return {string} type
   */
  _proto.getType = function getType() {
    return 'dataset';
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */
  ;

  _proto.getName = function getName() {
    return 'waterFall2D';
  };

  _proto.configure = function configure(datasetJSON) {
    if (!datasetJSON) {
      return false;
    }

    this.trimData(datasetJSON);
    this.config.JSONData = datasetJSON;
    var catData,
        catObj,
        dataSet = this,
        chart = dataSet.getFromEnv('chart'),
        // logic = chart.logic,
    conf = dataSet.config,
        // fcJSON = dataSet.fcJSON,
    JSONData = dataSet.config.JSONData,
        setDataArr = JSONData.data,
        setDataLen = setDataArr && setDataArr.length,
        // eslint-disable-line good-practices/no-single-usage-variable
    catLen = dataSet.getFromEnv('xAxis').getTicksLen(),
        // eslint-disable-line good-practices/no-single-usage-variable
    len = Math.min(catLen, setDataLen),
        chartAttr = chart.getFromEnv('dataSource').chart,
        colorM = dataSet.getFromEnv('color-manager'),
        showplotborder,
        plotColor = colorM.getPlotColor(dataSet.index || dataSet.positionIndex),
        plotBorderDash = (0, _lib.pluckNumber)(JSONData.dashed, chartAttr.plotborderdashed, 0),
        chartConfig = chart.config,
        usePlotGradientColor = chartConfig.useplotgradientcolor,
        // eslint-disable-line good-practices/no-single-usage-variable
    showTooltip = (0, _lib.pluckNumber)(chartAttr.showtooltip, 1),
        // eslint-disable-line good-practices/no-single-usage-variable
    tooltipSepChar = (0, _lib.parseUnsafeString)((0, _lib.pluck)(chartAttr.tooltipsepchar, ', ')),
        // eslint-disable-line good-practices/no-single-usage-variable
    formatedVal,
        parserConfig,
        setTooltext,
        // seriesname,
    macroIndices,
        // tempPlotfillAngle,
    toolText,
        plotDashLen,
        plotDashGap,
        plotBorderThickness,
        isRoundEdges,
        showHoverEffect,
        plotfillAngle,
        plotFillAlpha,
        plotFillRatio,
        plotgradientcolor,
        plotBorderAlpha,
        plotBorderColor,
        plotBorderDashStyle,
        initailPlotBorderDashStyle,
        setData,
        setValue,
        dataObj,
        config,
        // label,
    colorArr,
        hoverColor,
        hoverAlpha,
        hoverGradientColor,
        hoverRatio,
        hoverAngle,
        hoverBorderColor,
        hoverBorderAlpha,
        hoverBorderThickness,
        hoverBorderDashed,
        hoverBorderDashGap,
        hoverBorderDashLen,
        hoverDashStyle,
        hoverColorArr,
        dataStore = dataSet.components.data,
        numberFormatter = dataSet.getFromEnv('number-formatter'),
        toolTipValue,
        setDisplayValue,
        // isBar = chart.isBar,
    // is3D = chart.config.is3D,
    // isStacked = chart.isStacked,
    isBar = false,
        is3D = false,
        isStacked = false,
        stack100Percent,
        enableAnimation,
        parentYAxis,
        setDataDashed,
        setDataPlotDashLen,
        setDataPlotDashGap,
        i,
        reflowData =
    /* logic.chartInstance.jsVars._reflowData */
    {},
        reflowDataObj = reflowData.dataObj || (reflowData.dataObj = {}),
        reflowChartObj = reflowDataObj.chart || (reflowDataObj.chart = {}),
        // fcJSON = dataSet.fcJSON,
    // isSingleSeries = chart.config.singleseries,
    lineThickness = (0, _lib.pluck)(chartAttr.connectorthickness, 1),
        // eslint-disable-line good-practices/no-single-usage-variable
    showSum,
        dataLabel,
        showLabel,
        itemValue,
        maxValue = -Infinity,
        minValue = Infinity,
        seriesSum = 0,
        total = 0,
        lastComTotal = 0,
        issum,
        zLine,
        setColor,
        cumulative,
        sumObj,
        countPoint,
        plotfillangle;
    conf.minAbsNonZeroValue = Infinity;
    conf.minAbsNonZeroData = {};
    dataSet.setState('visible', (0, _lib.pluckNumber)(JSONData.visible, !Number(JSONData.initiallyhidden), 1) === 1); // dataplot border width. Managing for 3D too

    showplotborder = conf.showplotborder = (0, _lib.pluckNumber)(chartAttr.showplotborder, is3D ? 0 : 1); // waterfall2D chart doesn't show the plotborder by default until we set showplotborder true

    conf.plotBorderThickness = plotBorderThickness = showplotborder ? is3D ? 1 : (0, _lib.pluckNumber)(chartAttr.plotborderthickness, 1) : 0; // whether to use round edges or not in the waterfall2D

    conf.isRoundEdges = isRoundEdges = (0, _lib.pluckNumber)(chartAttr.useroundedges, 0); // dataplot border alpha

    conf.plotBorderAlpha = plotBorderAlpha = showplotborder ? (0, _lib.pluck)(chartAttr.plotborderalpha, plotFillAlpha, HUNDREDSTRING) : 0; // dataplot border color

    conf.plotbordercolor = plotBorderColor = (0, _lib.pluck)(chartAttr.plotbordercolor, is3D ? '#ffffff' : colorM.getColor(PLOTBORDERCOLOR).split(COMMA)[0]); // GradientColor of the plot fill

    conf.plotgradientcolor = plotgradientcolor = usePlotGradientColor ? (0, _lib.getDefinedColor)(chartAttr.plotgradientcolor, colorM.getColor(PLOTGRADIENTCOLOR)) : BLANK;
    conf.plotDashLen = plotDashLen = (0, _lib.pluckNumber)(chartAttr.plotborderdashlen, 6);
    conf.showTextOutline = (0, _lib.pluckNumber)(chartAttr.textoutline, 0);
    conf.plotDashGap = plotDashGap = (0, _lib.pluckNumber)(chartAttr.plotborderdashgap, 3); // use3DLighting to show gredient color effect in waterfall2D charts

    conf.use3DLighting = (0, _lib.pluckNumber)(chartAttr.use3dlighting, 1);
    conf.showSum = showSum = (0, _lib.pluckNumber)(chartAttr.showsumatend, 1);
    conf.plotColor = plotColor = (0, _lib.pluck)(JSONData.color, plotColor); // defaultAngle depend upon item value

    conf.plotfillAngle = plotfillAngle = (0, _lib.pluckNumber)(360 - chartAttr.plotfillangle, 90);
    conf.showShadow = isRoundEdges || is3D ? (0, _lib.pluckNumber)(chartAttr.showshadow, 1) : (0, _lib.pluckNumber)(chartAttr.showshadow, colorM.getColor(SHOWSHADOW));
    conf.usePattern = (0, _lib.pluckNumber)(chartConfig.usePattern, 0);
    conf.patternType = _column.PATTERN_TYPES.includes(JSONData.patterntype) ? JSONData.patterntype : chartConfig.patternType;
    conf.patternDensity = (0, _lib.pluckNumber)(JSONData.patterndensity, chartConfig.patternDensity);
    conf.patternAlpha = (0, _lib.pluckNumber)(JSONData.patternalpha, chartConfig.patternAlpha);
    conf.patternBgColor = (0, _lib.pluck)(JSONData.patternbgcolor, conf.patternBgColor);
    conf.showHoverEffect = showHoverEffect = (0, _lib.pluckNumber)(chartAttr.plothovereffect, chartAttr.showhovereffect, UNDEF);
    conf.usePattern && (conf.showHoverEffect = showHoverEffect = 0); // todo start - **Needs to remove them if not required in waterfall2D*****************

    conf.plotFillAlpha = plotFillAlpha = (0, _lib.pluck)(JSONData.alpha, chartAttr.plotfillalpha, HUNDREDSTRING);
    conf.plotRadius = (0, _lib.pluckNumber)(chartAttr.useRoundEdges, conf.isRoundEdges ? 1 : 0);
    conf.plotFillRatio = plotFillRatio = (0, _lib.pluck)(JSONData.ratio, chartAttr.plotfillratio);
    conf.dashed = plotBorderDash;
    conf.plotBorderDashStyle = initailPlotBorderDashStyle = plotBorderDash // eslint-disable-line good-practices/no-single-usage-variable
    ? (0, _lib.getDashStyle)(plotDashLen, plotDashGap) : 'none';
    conf.showValues = (0, _lib.pluckNumber)(JSONData.showvalues, chartAttr.showvalues, 1);
    conf.valuePadding = (0, _lib.pluckNumber)(chartAttr.valuepadding, 2);
    conf.enableAnimation = enableAnimation = (0, _lib.pluckNumber)(chartAttr.animation, chartAttr.defaultanimation, 1);
    conf.animation = !enableAnimation ? false : {
      duration: (0, _lib.pluckNumber)(chartAttr.animationduration, 1) * 1000
    };
    reflowChartObj.transposeAnimation = conf.transposeAnimation = (0, _lib.pluckNumber)(chartAttr.transposeanimation, reflowChartObj.transposeAnimation, enableAnimation);
    conf.transposeAnimDuration = (0, _lib.pluckNumber)(chartAttr.transposeanimduration, 0.2) * 1000;
    conf.showTooltip = (0, _lib.pluckNumber)(chartAttr.showtooltip, 1);
    conf.stack100Percent = stack100Percent = (0, _lib.pluckNumber)(chart.stack100percent, chartAttr.stack100percent, 0);
    conf.definedGroupPadding = Math.max((0, _lib.pluckNumber)(chartAttr.plotspacepercent), 0);
    conf.plotSpacePercent = Math.max((0, _lib.pluckNumber)(chartAttr.plotspacepercent, 20) % 100, 0);
    conf.maxColWidth = (0, _lib.pluckNumber)(isBar ? chartAttr.maxbarheight : chartAttr.maxcolwidth, 50);
    conf.showPercentValues = (0, _lib.pluckNumber)(chartAttr.showpercentvalues, isStacked && stack100Percent ? 1 : 0);
    conf.showPercentInToolTip = (0, _lib.pluckNumber)(chartAttr.showpercentintooltip, isStacked && stack100Percent ? 1 : 0);
    conf.plotPaddingPercent = (0, _lib.pluckNumber)(chartAttr.plotpaddingpercent);
    conf.rotateValues = (0, _lib.pluckNumber)(chartAttr.rotatevalues) ? 270 : 0;
    conf.placeValuesInside = (0, _lib.pluckNumber)(chartAttr.placevaluesinside, 0);
    /* conf.zeroPlaneColor = chart.options.chart.zeroPlaneColor;
    conf.zeroPlaneBorderColor = chart.options.chart.zeroPlaneBorderColor;
    conf.zeroPlaneShowBorder = chart.options.chart.zeroPlaneShowBorder; */

    conf.parentYAxis = parentYAxis = (0, _lib.pluck)(JSONData.parentyaxis && JSONData.parentyaxis.toLowerCase(), // eslint-disable-line good-practices/no-single-usage-variable
    'p') === 's' ? 1 : 0; // todo end ***************

    conf.defaultPadding = {
      left: 0.5,
      right: 0.5
    };
    dataSet.setState('dirty', true);

    if (!dataStore) {
      dataStore = dataSet.components.data = [];
    } // storing the configurations for z-line.


    conf.zLine = zLine = {
      step: true,
      data: [],
      dashStyle: chartAttr.connectordashed === '1' ? (0, _lib.getDashStyle)((0, _lib.pluckNumber)(chartAttr.connectordashlen, 2), (0, _lib.pluckNumber)(chartAttr.connectordashgap, 2)) : NONE,
      useForwardSteps: true,
      color: (0, _lib.convertColor)((0, _lib.pluck)(chartAttr.connectorcolor, '000000'), (0, _lib.pluck)(chartAttr.connectoralpha, 100)),
      lineWidth: lineThickness
    }; // calculate sum

    for (i = 0; i < len; i += 1) {
      // individual set level data
      setData = setDataArr[i];
      itemValue = numberFormatter.getCleanValue(setData.value);
      issum = (0, _lib.pluckNumber)(setData.issum, 0); // If its vline then don't calculate

      if (setData.vline || issum) {
        delete setData._value;
        continue;
      }

      seriesSum += itemValue;
      setData._value = itemValue;
    } // Is we have to show sum at end then create a dummy set for total


    if (showSum) {
      // converts the truty value of showSum to Boolean TRUE flag.
      showSum = true;
      len += 1;
      sumObj = {
        label: (0, _lib.getFirstValue)(chartAttr.sumlabel, 'Total'),
        // todo remove _value if not required.
        _value: seriesSum,
        value: seriesSum,
        issum: 1,
        cumulative: 1
      };
    } // Iterate through all level data
    // Managing the data value labels and other cosmetics inside this loop


    for (i = 0, countPoint = 0; i < len; i += 1) {
      // individual data obj
      setData = setDataArr[i];
      dataObj = dataStore[i];
      config = dataObj && dataObj.config;

      if (!dataObj) {
        dataObj = dataStore[i] = {
          graphics: {}
        };
      }

      if (!dataObj.config) {
        config = dataStore[i].config = {};
      }

      if (!setData && showSum) {
        setData = setDataArr[i] = sumObj;
      }

      plotColor = (0, _lib.pluck)(setData.color, colorM.getPlotColor(i)); // Managing vLines in between <set> elements
      // If its vline
      // we call the grid manager addVline function, that creates vline
      // and we stop execution here and continue the loop to next data

      if (dataObj.vline) {
        // todo need to validate with axis module and add vline.
        continue;
      } // get the valid value
      // parsePointValue check the its a value value of not and return
      // the valid value


      itemValue = setData._value;
      delete setData._value;
      config.issum = issum = (0, _lib.pluckNumber)(setData.issum, 0);
      cumulative = config.isCumulative = (0, _lib.pluckNumber)(setData.cumulative, 1);

      if (issum) {
        itemValue = cumulative ? total : total === lastComTotal ? total : total - lastComTotal;
        config.lastComTotal = lastComTotal;
        lastComTotal = total;
        zLine.data.push({
          y: null,
          x: countPoint - 0.5
        });
      } else {
        total += itemValue;
      }

      config.valuePadding = (0, _lib.pluckNumber)(setData.valuepadding, conf.valuePadding);
      maxValue = Math.max(maxValue, total);
      minValue = Math.min(minValue, total);

      if (itemValue !== 0 && conf.minAbsNonZeroValue > Math.abs(itemValue)) {
        conf.minAbsNonZeroValue = Math.abs(itemValue);
        conf.minAbsNonZeroData = config;
      } // store the cumulative total


      config.total = total; // we check showLabel in individual data
      // if its set to 0 than we do not show the particular label

      showLabel = config.showLabel = (0, _lib.pluckNumber)(setData.showlabel, chartAttr.showlabels, 1); // Label of the data
      // getFirstValue returns the first defined value in arguments
      // we check if showLabel is not set to 0 in data
      // then we take the label given in data, it can be given using label as well as name too
      // we give priority to label if label is not there, we check the name attribute

      dataLabel = config.dataLabel = (0, _lib.parseUnsafeString)(!showLabel ? BLANK : (0, _lib.getFirstValue)(setData.label, setData.name)); // <set> cosmetics
      // Color of the particular data

      if (itemValue > 0) {
        setColor = (0, _lib.pluck)(setData.color, chartAttr.positivecolor, plotColor);

        if (showHoverEffect !== 0) {
          hoverColor = (0, _lib.pluck)(setData.positivehovercolor, chartAttr.positivehovercolor, chartAttr.plotfillhovercolor, chartAttr.columnhovercolor, setColor);
        }
      } else {
        setColor = (0, _lib.pluck)(setData.color, chartAttr.negativecolor, plotColor);

        if (showHoverEffect !== 0) {
          hoverColor = (0, _lib.pluck)(setData.negativehovercolor, chartAttr.negativehovercolor, chartAttr.plotfillhovercolor, chartAttr.columnhovercolor, setColor);
        }
      } // Setting the angle for plot fill for negative data


      if (itemValue < 0) {
        plotfillangle = 360 - plotfillAngle;
      } else {
        plotfillangle = plotfillAngle;
      }

      plotFillAlpha = (0, _lib.pluck)(setData.alpha, conf.plotFillAlpha);
      config.dashed = setDataDashed = (0, _lib.pluckNumber)(setData.dashed, conf.dashed);
      setDataPlotDashLen = (0, _lib.pluckNumber)(setData.dashlen, plotDashLen);
      setDataPlotDashGap = plotDashGap = (0, _lib.pluckNumber)(setData.dashgap, plotDashGap);
      config.plotFillAlpha = plotFillAlpha;
      config.plotBorderAlpha = plotBorderAlpha;
      config.showValue = (0, _lib.pluckNumber)(setData.showvalue, conf.showValues); // todo clean the variables

      config.setValue = setValue = itemValue;
      config.setLink = (0, _lib.pluck)(setData.link);
      config.toolTipValue = toolTipValue = numberFormatter.dataLabels(setValue, parentYAxis);
      config.setDisplayValue = setDisplayValue = (0, _lib.getValidValue)((0, _lib.parseUnsafeString)(setData.displayvalue));
      config.displayValue = (0, _lib.pluck)(setDisplayValue, toolTipValue);
      config.plotBorderDashStyle = plotBorderDashStyle = setDataDashed === 1 ? (0, _lib.getDashStyle)(setDataPlotDashLen, setDataPlotDashGap) : setDataDashed === 0 ? 'none' : initailPlotBorderDashStyle;
      config.shadow = {
        opacity: conf.showShadow ? plotFillAlpha / 100 : 0
      };
      config.dataLabelStyle = dataSet._configureDataLabelStyle(setData);
      config.patternType = _column.PATTERN_TYPES.includes(setData.patterntype) ? setData.patterntype : conf.patternType;
      config.patternAngle = (0, _lib.pluckNumber)(setData.patternangle, JSONData.patternangle, chartAttr.patternangle, config.patternType === _column.PATTERN_TYPES[0] ? 40 : 0);
      config.patternDensity = (0, _lib.pluckNumber)(setData.patterndensity, conf.patternDensity);
      config.patternSize = (0, _lib.pluckNumber)(setData.patternsize, JSONData.patternsize, config.patternType === _column.PATTERN_TYPES[0] ? 2 : 4);
      config.patternAlpha = (0, _lib.pluckNumber)(setData.patternalpha, conf.patternAlpha);
      config.patternBgColor = (0, _lib.pluck)(setData.patternbgcolor, conf.patternBgColor); // Setting the color Array to be applied to the bar/column.

      config.colorArr = colorArr = (0, _lib.getColumnColor)(setColor + COMMA + plotgradientcolor.replace(/,+?$/, ''), plotFillAlpha, plotFillRatio, plotfillangle, isRoundEdges, plotBorderColor, // todo remove the toString() by plucking string only.
      plotBorderAlpha.toString(), // todo remove this dirty checks and set the flag value as required.
      isBar ? 1 : 0, !!is3D); // Parsing the hover effects only if showhovereffect is not 0.

      if (showHoverEffect !== 0) {
        // Alpha of the data
        hoverAlpha = (0, _lib.pluck)(setData.alpha, setData.hoveralpha, JSONData.hoveralpha, chartAttr.plotfillhoveralpha, chartAttr.columnhoveralpha, plotFillAlpha);
        hoverGradientColor = (0, _lib.pluck)(setData.hovergradientcolor, JSONData.hovergradientcolor, chartAttr.plothovergradientcolor, plotgradientcolor);
        !hoverGradientColor && (hoverGradientColor = ''); // Fill ratio of the data

        hoverRatio = (0, _lib.pluck)(setData.hoverratio, JSONData.hoverratio, setData.ratio, chartAttr.plothoverratio, plotFillRatio);
        hoverAngle = (0, _lib.pluckNumber)(360 - setData.hoverangle, 360 - JSONData.hoverangle, 360 - chartAttr.plothoverangle, plotfillangle);
        hoverBorderColor = (0, _lib.pluck)(setData.borderhovercolor, JSONData.borderhovercolor, chartAttr.plotborderhovercolor, plotBorderColor);
        hoverBorderAlpha = (0, _lib.pluck)(setData.borderhoveralpha, JSONData.borderhoveralpha, chartAttr.plotborderhoveralpha, plotBorderAlpha, plotFillAlpha);
        hoverBorderThickness = (0, _lib.pluckNumber)(setData.borderhoverthickness, JSONData.borderhoverthickness, chartAttr.plotborderhoverthickness, plotBorderThickness);
        hoverBorderDashed = (0, _lib.pluckNumber)(setData.borderhoverdashed, JSONData.borderhoverdashed, chartAttr.plotborderhoverdashed);
        hoverBorderDashGap = (0, _lib.pluckNumber)(setData.borderhoverdashgap, JSONData.borderhoverdashgap, chartAttr.plotborderhoverdashgap, plotDashLen);
        hoverBorderDashLen = (0, _lib.pluckNumber)(setData.borderhoverdashlen, JSONData.borderhoverdashlen, chartAttr.plotborderhoverdashlen, plotDashGap);
        hoverDashStyle = hoverBorderDashed ? (0, _lib.getDashStyle)(hoverBorderDashLen, hoverBorderDashGap) : plotBorderDashStyle;
        /* If no hover effects are explicitly defined and
                     * showHoverEffect is not 0 then hoverColor is set.
                     */

        if (showHoverEffect === 1 && hoverColor === plotColor) {
          hoverColor = (0, _lib.getLightColor)(hoverColor, 70);
        }

        config.hoverColor = hoverColor;
        config.hoverAlpha = hoverAlpha;
        config.hoverBorderColor = hoverBorderColor;
        config.hoverBorderAlpha = hoverBorderAlpha; // setting the hover color array which is always applied except when showHoverEffect is not 0.

        hoverColorArr = (0, _lib.getColumnColor)(hoverColor + ',' + hoverGradientColor, hoverAlpha, hoverRatio, hoverAngle, isRoundEdges, hoverBorderColor, hoverBorderAlpha.toString(), isBar ? 1 : 0, !!is3D);
        config.setRolloutAttr = {
          fill: !is3D ? (0, _lib.toRaphaelColor)(colorArr[0]) : [(0, _lib.toRaphaelColor)(colorArr[0]), !conf.use3DLighting],
          stroke: showplotborder && (0, _lib.toRaphaelColor)(colorArr[1]),
          'stroke-width': plotBorderThickness,
          'stroke-dasharray': plotBorderDashStyle
        };
        config.setRolloverAttr = {
          fill: !is3D ? (0, _lib.toRaphaelColor)(hoverColorArr[0]) : [(0, _lib.toRaphaelColor)(hoverColorArr[0]), !conf.use3DLighting],
          stroke: showplotborder && (0, _lib.toRaphaelColor)(hoverColorArr[1]),
          'stroke-width': hoverBorderThickness,
          'stroke-dasharray': hoverDashStyle
        };
      }
      /*
                todo: Was in the old architechture and need to be validated and included in the new architechture.
                // Used to set alpha of the shadow
                    pointShadow = {
                        opacity: setAlpha / 100,
                        inverted: isBar
                    };
                // get per-point dash-style
                    pointDashStyle = setBorderDashed ?
                        getDashStyle(setBorderDashLen, setBorderDashGap, setBorderWidth) :
                        DASH_DEF;
                */
      // todo removing this category tooltext. Needs a validation.
      // label = getValidValue(parseUnsafeString(pluck (categories[i].tooltext, categories[i].label)));


      formatedVal = config.toolTipValue; // Parsing tooltext against various configurations provided by the user.

      config.origToolText = setTooltext = (0, _lib.getValidValue)((0, _lib.parseUnsafeString)((0, _lib.pluck)(setData.tooltext, JSONData.plottooltext, chartAttr.plottooltext), false)); // create the tooltext

      if (!showTooltip) {
        toolText = false;
      } else if (setTooltext !== UNDEF) {
        macroIndices = [1, 2, 3, 5, 6, 7, 20, 21, 24, 25];
        parserConfig = {
          formattedValue: formatedVal,
          label: dataLabel,
          yaxisName: (0, _lib.parseUnsafeString)(chartAttr.yaxisname),
          xaxisName: (0, _lib.parseUnsafeString)(chartAttr.xaxisname),
          cumulativeValue: total,
          cumulativeDataValue: numberFormatter.dataLabels(total),
          sum: numberFormatter.dataLabels(seriesSum),
          unformattedSum: seriesSum
        };
        toolText = (0, _lib.parseTooltext)(setTooltext, macroIndices, parserConfig, setData, chartAttr, JSONData);
      } else {
        // determine the dispalay value then
        toolText = formatedVal === null ? false : dataLabel !== BLANK ? dataLabel + tooltipSepChar : '';
      } // create the displayvalue
      // if (!config.showValue) {
      //   displayValue = BLANK;
      // } else if (setDisplayValue !== UNDEF) {
      //   displayValue = setDisplayValue;
      // } else { // determine the dispalay value then
      //   displayValue = formatedVal;
      // }


      zLine.data.push({
        y: itemValue === null ? null : total,
        x: countPoint
      });
      countPoint += 1;
      config.originalPlotColor = (0, _lib.hashify)(plotColor);
      config.toolText = toolText;
      config.setTooltext = toolText;
      config._x = i;
      config._y = setValue; // if (!config.issum) {
      //   config._y = dataStore[i - 1] && dataStore[i - 1].config.total;
      // } else if (!config.isCumulative) {
      //   config._y = config.lastComTotal;
      // }
    }

    conf.maxValue = maxValue;
    conf.minValue = minValue;
    conf.connectNullData = (0, _lib.pluckNumber)(chartAttr.connectnulldata, 0);
    conf.showConnectors = (0, _lib.pluckNumber)(chartAttr.showconnectors, 1); // reconfiguring the category object for the axis module

    catData = JSONData.catData;

    for (i = 0; i < catData.length; i += 1) {
      catObj = catData[i];
      setDataArr.splice(catObj.index, 0, catObj.data);
    }

    dataSet.getFromEnv('xAxis').setTickValues(setDataArr); // No real time max min calculations are required during resize.

    dataSet.config.maxminFlag = false;
  } // Create pixel coordinates for the plots
  ;

  _proto.createCoordinates = function createCoordinates() {
    var dataSet = this,
        isBar = dataSet.getFromEnv('chart').isBar,
        yAxis = dataSet.getFromEnv('yAxis'),
        xAxis = dataSet.getFromEnv('xAxis'),
        yBase = yAxis.getAxisBase(),
        // eslint-disable-line good-practices/no-single-usage-variable
    yBasePos = yAxis.getPixel(yBase),
        // eslint-disable-line good-practices/no-single-usage-variable
    dataObj,
        config,
        previousY,
        i,
        Px,
        Py,
        Pb,
        yVal,
        chartConfig = dataSet.getFromEnv('chartConfig'),
        xDepth = chartConfig.xDepth || 0,
        yDepth = chartConfig.yDepth || 0,
        len = dataSet.components.data.length,
        // eslint-disable-line good-practices/no-single-usage-variable
    groupManager = dataSet.groupManager,
        stackConf = groupManager && groupManager.stackConf,
        dataStore = dataSet.components.data;
    !isBar && (xDepth = -xDepth);
    isBar && (yDepth = -yDepth);

    for (i = 0; i < len; i++) {
      dataObj = dataStore[i];
      config = dataObj && dataObj.config;

      if (dataObj === UNDEF) {
        continue;
      }

      yVal = config._y;

      if (!config.issum) {
        previousY = dataStore[i - 1] && dataStore[i - 1].config.total;
        previousY && (yVal += previousY);
      } else if (!config.isCumulative) {
        previousY = config.lastComTotal;
        yVal += config.lastComTotal;
      } else {
        previousY = null;
      }

      Px = xAxis.getPixel(stackConf && stackConf[i].x || config._x) + xDepth;
      Py = yAxis.getPixel(yVal) + yDepth;
      Pb = (previousY ? yAxis.getPixel(previousY) : yBasePos) + yDepth;

      if (xAxis.config.isVertical) {
        config._Px = Py;
        config._Py = Px;
        config._Pby = Px;
        config._Pbx = Pb;
      } else {
        config._Px = Px;
        config._Py = Py;
        config._Pby = Pb;
        config._Pbx = Px;
      }
    }
  };

  _proto.getDataLimits = function getDataLimits() {
    var dataSet = this,
        dataStore = dataSet.components.data,
        conf = dataSet.config,
        i,
        config,
        len = dataStore.length,
        // eslint-disable-line good-practices/no-single-usage-variable
    setValue,
        maxValue = -Infinity,
        minValue = +Infinity;

    for (i = 0; i < len; i++) {
      if (!dataStore[i]) {
        continue;
      }

      config = dataStore[i].config;
      setValue = config.total;

      if (setValue !== UNDEF) {
        maxValue = Math.max(maxValue, setValue);
        minValue = Math.min(minValue, setValue);
      }
    }

    conf.maxValue = maxValue;
    conf.minValue = minValue;
    return {
      max: conf.maxValue,
      min: conf.minValue
    };
  };

  _proto.drawPlots = function drawPlots(anim) {
    var dataSet = this;

    _ColumnDataset.prototype.drawPlots.call(this, anim);

    if (dataSet.config.showConnectors) {
      dataSet.drawLine();
    } else {
      dataSet.getContainer('commonElemsGroup').hide();
    }
  };

  _proto.drawLine = function drawLine() {
    var dataSet = this,
        conf = dataSet.config,
        i,
        yPos,
        xPos,
        yAxis = dataSet.getFromEnv('yAxis'),
        yBase = yAxis.getAxisBase(),
        // eslint-disable-line good-practices/no-single-usage-variable
    yBasePos = yAxis.getPixel(yBase),
        // eslint-disable-line good-practices/no-single-usage-variable
    lineContainer = dataSet.getContainer('commonElemsGroup'),
        groupNetHalfWidth = dataSet.getFromEnv('columnWidth') / 2,
        zLineConf = conf.zLine,
        data = zLineConf.data,
        set,
        y,
        x,
        ln = data.length,
        // eslint-disable-line good-practices/no-single-usage-variable
    seriesLineWidth = zLineConf.lineWidth,
        lastXPos,
        zLineDummy = dataSet._graphics.zLine,
        zLine,
        lastYPos = null,
        linePath = [],
        lastMoveCommand = [];
    yAxis.yBasePos = yBasePos;
    lineContainer.toFront().show();

    for (i = 0; i < ln; i += 1) {
      set = data[i];
      y = set.y;

      if (y === null) {
        lastMoveCommand.length = 0;

        if (conf.connectNullData === 0) {
          lastYPos = null;
        }
      } else {
        x = (0, _lib.pluckNumber)(set.x, i); // Multi series related management.

        yPos = yAxis.getPixel(y);
        xPos = dataSet.getFromEnv('xAxis').getPixel(x); // crisp line positions

        xPos = (0, _lib.getCrispValue)(xPos, seriesLineWidth, seriesLineWidth).position;
        yPos = (0, _lib.getCrispValue)(yPos, seriesLineWidth, seriesLineWidth).position;

        if (lastYPos !== null) {
          if (lastMoveCommand.length) {
            linePath = linePath.concat(lastMoveCommand);
            lastMoveCommand.length = 0;
          }

          linePath.push(M, lastXPos, lastYPos, 'm', -groupNetHalfWidth, 0, H, xPos, 'h', groupNetHalfWidth, 'm', 0, yPos - lastYPos);
        } else {
          lastMoveCommand.push(M, xPos, yPos);
        }

        lastXPos = xPos;
        lastYPos = yPos;
      }
    } // If zLine is not present, create it


    zLine = dataSet.getFromEnv('animationManager').setAnimation({
      // eslint-disable-line good-practices/no-single-usage-variable
      el: zLineDummy || 'path',
      attr: {
        path: linePath,
        'stroke-linecap': 'round',
        'stroke-opacity': 1,
        'stroke-dasharray': zLineConf.dashStyle,
        'stroke': zLineConf.color,
        'stroke-linejoin': seriesLineWidth >= MAX_MITER_LINEJOIN ? 'round' : 'miter',
        'stroke-width': seriesLineWidth
      },
      container: lineContainer,
      component: dataSet,
      label: 'path'
    }); // If zline is not present previously, add to _graphics of dataset

    if (!zLineDummy) {
      dataSet.addGraphicalElement('zLine', zLine);
    }
  };

  return WaterFall2DDataset;
}(_column.default);

var _default = WaterFall2DDataset;
exports["default"] = _default;

/***/ }),

/***/ 1424:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = _default;

var _lib = __webpack_require__(274);

var _boxAndWhiskerStatisticalCalc = _interopRequireDefault(__webpack_require__(1425));

/**
 * function to  create dataset
 * sort data wrt. x value
 * assign dataset to its parents
 **/
function _default(chart) {
  var datasetsJSON = chart.getFromEnv('dataSource').dataset,
      canvas = chart.getChildren('canvas')[0],
      // eslint-disable-line good-practices/no-single-usage-variable
  vCanvas,
      datasetParent = vCanvas = canvas.getChildren('vCanvas')[0],
      dsType = chart.config.defaultDatasetType || '',
      groupManager;

  if (!datasetsJSON) {
    chart.setChartMessage();
  }

  (0, _lib.componentFactory)(vCanvas, chart.getDSGroupdef(), 'datasetGroup_' + dsType);
  groupManager = vCanvas.getChildren('datasetGroup_' + dsType);
  groupManager && (datasetParent = groupManager[0]);
  (0, _lib.componentFactory)(chart, _boxAndWhiskerStatisticalCalc.default, 'BoxAndWhiskerStatisticalCalc');
  vCanvas.getChildren('datasetGroup_' + dsType)[0].addToEnv('BoxAndWhiskerStatisticalCalc', chart.getChildren('BoxAndWhiskerStatisticalCalc')[0]); // Adding the JSON data of line dataset to the parent of boxandwhisker ds

  datasetParent.addToEnv('lineJSON', chart._getLineJSONdata());
  (0, _lib.datasetFactory)(datasetParent, chart.getDSdef(), 'dataset', datasetsJSON.length, datasetsJSON);
}

/***/ }),

/***/ 1417:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = _default;

var _lib = __webpack_require__(274);

var _numeric = _interopRequireDefault(__webpack_require__(537));

/**
 * function to instatiate axis and get attached to canvas
 * @param {Object} chart chart API
 */
function _default(chart) {
  var canvasArr = chart.getChildren('canvas'),
      canvas = canvasArr[0],
      canvasVolume = canvasArr[1],
      showVolumeChart = chart.config.showVolumeChart,
      zoomObj = {
    zoomable: true,
    pannable: true
  },
      conf,
      axisRefVisualCartesian = canvas.getChildren('axisRefVisualCartesian')[0],
      axisRefVisualCartesianVol,
      vYAxis,
      yAxis,
      xAxis,
      redraw = function redraw() {
    return axisRefVisualCartesian.asyncDraw();
  },
      redrawVol = function redrawVol() {
    return axisRefVisualCartesianVol.asyncDraw();
  };

  conf = chart._feedAxesRawData();
  (0, _lib.componentFactory)(chart, _numeric.default, 'yAxis', showVolumeChart ? 2 : 1, conf.yAxisConfigure);
  (0, _lib.componentFactory)(chart, _numeric.default, 'xAxis', 1, conf.xAxisConfigure);
  yAxis = chart.getChildren('yAxis')[0];
  vYAxis = chart.getChildren('yAxis')[1];
  yAxis.setAxisConfig({
    relativeAxis: vYAxis
  });
  vYAxis && vYAxis.setAxisConfig({
    relativeAxis: yAxis
  });
  xAxis = chart.getChildren('xAxis')[0];
  yAxis.setLinkedItem('canvas', canvas);
  xAxis.setLinkedItem('canvas', canvas);
  axisRefVisualCartesian.setLinkedItem(yAxis.getId(), yAxis);
  axisRefVisualCartesian.setLinkedItem(xAxis.getId(), xAxis);
  axisRefVisualCartesian.addExtEventListener('visiblerangeset', redraw, yAxis);
  axisRefVisualCartesian.addExtEventListener('visiblerangeset', redraw, xAxis);
  canvas.attachAxis(xAxis, false, chart.zoomX ? zoomObj : {});
  canvas.attachAxis(yAxis, true, chart.zoomY ? zoomObj : {});

  if (showVolumeChart) {
    axisRefVisualCartesianVol = canvasVolume.getChildren('axisRefVisualCartesian')[0];
    canvasVolume.attachAxis(xAxis, false, chart.zoomX ? zoomObj : {});
    vYAxis.setLinkedItem('canvas', canvasVolume);
    axisRefVisualCartesianVol.setLinkedItem(vYAxis.getId(), vYAxis);
    axisRefVisualCartesianVol.setLinkedItem(xAxis.getId(), xAxis);
    axisRefVisualCartesianVol.addExtEventListener('visiblerangeset', redrawVol, vYAxis);
    axisRefVisualCartesianVol.addExtEventListener('visiblerangeset', redrawVol, xAxis);
    canvasVolume.attachAxis(vYAxis, true, chart.zoomY ? zoomObj : {});
  }

  chart._setCategories();
}

/***/ }),

/***/ 1407:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



exports.__esModule = true;
exports["default"] = _default;

var _lib = __webpack_require__(274);

var _candlestick = __webpack_require__(1408);

/**
 * splice a given array with the given value
 * @param  {Array} array   on which splice opration will be executed
 * @param  {generic} value criteria to splice the array
 */
var arraySpliceByValue = function arraySpliceByValue(array, value) {
  var indexOf = array.indexOf(value);

  if (indexOf !== -1) {
    array.splice(indexOf, 1);
  }
},

/**
 * function to remove component if name is matched with value in set
 * @param  {Object} component from where it would iterate
 * @param  {Array} set        criteria; if matched then remove
 */
removeComponents = function removeComponents(component, set) {
  var i;
  component && component.iterateComponents(function (child) {
    for (i = 0; i < set.length; i++) {
      if (child.getName() === set[i]) {
        child.remove();
      }
    }
  });
};
/**
 * function to  create dataset
 * sort data wrt. x value
 * assign dataset to its parents
 **/


function _default(chart) {
  var jsonData = chart.getFromEnv('dataSource'),
      datasetsJSON = jsonData.dataset,
      trendSet = jsonData.trendset,
      showVolumeChart = chart.getFromEnv('chartConfig').showVolumeChart,
      // eslint-disable-line good-practices/no-single-usage-variable
  dsType = (0, _lib.pluck)((0, _lib.parseUnsafeString)(chart.getFromEnv('chart-attrib').plotpriceas).toLowerCase(), 'candlestick'),
      canvas = chart.getChildren('canvas')[0],
      // eslint-disable-line good-practices/no-single-usage-variable
  datasetParent = canvas.getChildren('vCanvas')[0],
      volumeCanvas,
      volumeDatasetParent,
      sortedDatasetsJSON,
      set = ['candlestick', 'candlestickbar', 'candlestickline', 'trendset'];

  if (!datasetsJSON) {
    chart.setChartMessage();
    return;
  }

  sortedDatasetsJSON = datasetsJSON.slice(0);
  sortedDatasetsJSON[0] && sortedDatasetsJSON[0].data && sortedDatasetsJSON[0].data.sort(function (a, b) {
    // eslint-disable-line good-practices/no-function-dependency
    return a.x - b.x;
  });
  (0, _lib.datasetFactory)(datasetParent, chart.getDSdef(dsType), 'dataset_' + dsType, datasetsJSON.length, sortedDatasetsJSON);

  if (dsType === 'bar') {
    arraySpliceByValue(set, 'candlestickbar');
  } else if (dsType === 'line') {
    arraySpliceByValue(set, 'candlestickline');
  } else {
    arraySpliceByValue(set, 'candlestick');
  }

  if (showVolumeChart) {
    volumeCanvas = chart.getChildren('canvas')[1];
    volumeDatasetParent = volumeCanvas.getChildren('vCanvas')[0];
    (0, _lib.datasetFactory)(volumeDatasetParent, _candlestick.VolumeDataset, 'dataset_volume', datasetsJSON.length, datasetsJSON);
  }

  if (trendSet) {
    (0, _lib.datasetFactory)(datasetParent, _candlestick.TrendSet, 'dataset_trendset', trendSet.length, trendSet);
    arraySpliceByValue(set, 'trendset');
  }

  removeComponents(datasetParent, set);
}

/***/ }),

/***/ 1443:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = _default;

var _lib = __webpack_require__(274);

var _category = _interopRequireDefault(__webpack_require__(585));

/**
 * function to instatiate axis and get attached to canvas
 * @param {Object} chart chart API
 */
function _default(chart) {
  var canvas = chart.getChildren('canvas')[0],
      axisRefVisualCartesian = canvas.getChildren('axisRefVisualCartesian')[0],
      zoomObj = {
    zoomable: true,
    pannable: true
  },
      config = chart._feedAxesRawData(),
      yAxis,
      xAxis,
      redraw = function redraw() {
    return axisRefVisualCartesian.asyncDraw();
  };

  (0, _lib.componentFactory)(chart, _category.default, 'yAxis', 1, config.yAxisConf);
  (0, _lib.componentFactory)(chart, _category.default, 'xAxis', 1, config.xAxisConf);
  yAxis = chart.getChildren('yAxis')[0];
  xAxis = chart.getChildren('xAxis')[0];
  yAxis.setLinkedItem('canvas', canvas);
  xAxis.setLinkedItem('canvas', canvas);
  axisRefVisualCartesian.setLinkedItem(yAxis.getId(), yAxis);
  axisRefVisualCartesian.setLinkedItem(xAxis.getId(), xAxis);
  axisRefVisualCartesian.addExtEventListener('visiblerangeset', redraw, xAxis);
  axisRefVisualCartesian.addExtEventListener('visiblerangeset', redraw, yAxis);
  canvas.attachAxis(xAxis, false, chart.zoomX ? zoomObj : {});
  canvas.attachAxis(yAxis, true, chart.zoomY ? zoomObj : {});

  chart._setCategories();
}

/***/ }),

/***/ 1471:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = _default;

var _ribbon = _interopRequireDefault(__webpack_require__(1472));

/**
 * function to instatiate ribbon and get attached to manager
 * @param {Object} manager manager API
 */
function _default(manager) {
  var links = manager.config.links;

  for (var key in links) {
    if (links.hasOwnProperty(key)) {
      if (links[key].visible) {
        manager.attachChild(_ribbon.default, 'ribbon', key).configure(links[key]);
      }
    }
  }
}

/***/ }),

/***/ 1468:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = _default;

var _node = _interopRequireDefault(__webpack_require__(1469));

/**
 * function to instatiate node and get attached to manager
 * @param {Object} manager manager API
 */
function _default(manager) {
  var config = manager.config;
  config.nodesOrder.forEach(function (label) {
    manager.attachChild(_node.default, 'node', label).configure(config.nodes[label]);
  });
}

/***/ }),

/***/ 1351:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = _default;

var _dragTracker = _interopRequireDefault(__webpack_require__(1352));

var _lib = __webpack_require__(274);

function _default(chart) {
  (0, _lib.componentFactory)(chart, _dragTracker.default, 'dragTracker');
  chart.getChildren('dragTracker')[0].addEvents();
}

/***/ }),

/***/ 1404:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



exports.__esModule = true;
exports["default"] = _default;

var _lib = __webpack_require__(274);

var removeSets = function removeSets(parent, set) {
  var children = parent.getChildren(),
      // eslint-disable-line good-practices/no-single-usage-variable
  childArr,
      j,
      i;

  if (set && set.length) {
    for (i = set.length - 1; i > -1; i--) {
      childArr = children[set[i]];

      for (j = childArr && childArr.length - 1; j > -1; childArr[j].remove(), j--) {
        ;
      }
    }
  }
};
/**
 * function to  create dataset, groupmaneger.
 * assign dataset to group manager.
 **/


function _default(chart) {
  var jsonData = chart.getFromEnv('dataSource'),
      datasetsJSON = jsonData.dataset,
      connectorsJSON = jsonData.connectors,
      labels = jsonData.labels,
      canvas = chart.getChildren('canvas')[0],
      // eslint-disable-line good-practices/no-single-usage-variable
  vCanvas,
      datasetParent = vCanvas = canvas.getChildren('vCanvas')[0],
      setType = [],
      groupManager;
  labels && (labels = [labels]);

  if (!datasetsJSON && !connectorsJSON && !labels) {
    chart.setChartMessage();
    return;
  }

  (0, _lib.componentFactory)(vCanvas, chart.getDSGroupdef(), 'datasetGroup_dragNode');
  groupManager = vCanvas.getChildren('datasetGroup_dragNode');
  groupManager && (datasetParent = groupManager[0]);

  if (datasetsJSON && datasetsJSON.length) {
    (0, _lib.componentFactory)(datasetParent, chart.getDSdef('dragnode'), 'dataset', datasetsJSON.length, datasetsJSON);
  } else {
    setType.push('dataset');
  }

  if (connectorsJSON && connectorsJSON.length) {
    (0, _lib.componentFactory)(datasetParent, chart.getDSdef('connector'), 'connector', connectorsJSON.length, connectorsJSON);
  } else {
    setType.push('connector');
  }

  if (labels && labels.length) {
    (0, _lib.componentFactory)(datasetParent, chart.getDSdef('dragableLabels'), 'labels', labels.length, labels);
  } else {
    setType.push('labels');
  }

  setType.length && removeSets(datasetParent, setType);
}

/***/ }),

/***/ 1349:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = _default;

var _lib = __webpack_require__(274);

var _limitUpdater = _interopRequireDefault(__webpack_require__(1350));

function _default(chart) {
  var numericAxis = chart.getChildren('yAxis')[0],
      limitUpdaterArr,
      limitUpdater;
  (0, _lib.componentFactory)(numericAxis, _limitUpdater.default, 'limitUpdater', chart.config.allowAxisChange ? 1 : 0);
  limitUpdaterArr = numericAxis.getChildren('limitUpdater');
  limitUpdater = limitUpdaterArr && limitUpdaterArr[0];
  limitUpdater && limitUpdater.configure();
}

/***/ }),

/***/ 1315:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = _default;

var _lib = __webpack_require__(274);

var _log = _interopRequireDefault(__webpack_require__(1316));

var _category = _interopRequireDefault(__webpack_require__(585));

// import CartesianAxis from '../axis/cartesian';

/**
 * function to instatiate axis and get attached to canvas
 * @param {Object} chart chart API
 */
function _default(chart) {
  var canvas = chart.getChildren('canvas')[0],
      axisRefVisualCartesian = canvas.getChildren('axisRefVisualCartesian')[0],
      zoomObj = {
    zoomable: true,
    pannable: true
  },
      config = chart._feedAxesRawData(),
      yAxis,
      xAxis,
      redraw = function redraw() {
    return axisRefVisualCartesian.asyncDraw();
  };

  (0, _lib.componentFactory)(chart, _log.default, 'yAxis', 1, config.yAxisConf);
  (0, _lib.componentFactory)(chart, _category.default, 'xAxis', 1, config.xAxisConf);
  yAxis = chart.getChildren('yAxis')[0];
  xAxis = chart.getChildren('xAxis')[0];
  yAxis.setLinkedItem('canvas', canvas);
  xAxis.setLinkedItem('canvas', canvas);
  axisRefVisualCartesian.setLinkedItem(yAxis.getId(), yAxis);
  axisRefVisualCartesian.setLinkedItem(xAxis.getId(), xAxis);
  axisRefVisualCartesian.addExtEventListener('visiblerangeset', redraw, xAxis);
  axisRefVisualCartesian.addExtEventListener('visiblerangeset', redraw, yAxis);
  canvas.attachAxis(xAxis, false, chart.zoomX ? zoomObj : {});
  canvas.attachAxis(yAxis, true, chart.zoomY ? zoomObj : {});

  chart._setCategories();
}

/***/ }),

/***/ 1374:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = _default;

var _lib = __webpack_require__(274);

var _multilevelpie = _interopRequireDefault(__webpack_require__(1375));

/**
 * function to  create dataset, groupmaneger.
 * assign dataset to group manager.
 **/
function _default(chart) {
  var categories,
      catLength,
      length,
      datasetJSON = {}; // eslint-disable-line good-practices/no-single-usage-variable

  categories = chart.config.categories = chart.getFromEnv('dataSource').category || [];
  catLength = categories.length;

  if (!length && catLength) {
    datasetJSON = categories;
    length = catLength;
  } // if the data has no categories in them.


  if (!catLength) {
    chart.setChartMessage();
    return;
  }

  (0, _lib.datasetFactory)(chart, _multilevelpie.default, 'dataset', length, [datasetJSON]);
}

/***/ }),

/***/ 1384:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = _default;

var _lib = __webpack_require__(274);

var _category = _interopRequireDefault(__webpack_require__(585));

var _axisSelectorUi = _interopRequireDefault(__webpack_require__(1385));

/**
 * function to instatiate axis and get attached to canvas
 * @param {Object} chart chart API
 */
function _default(chart) {
  var canvas = chart.getChildren('canvas')[0],
      axisRefVisualCartesian = canvas.getChildren('axisRefVisualCartesian')[0],
      configure,
      xAxis,
      redraw = function redraw() {
    return axisRefVisualCartesian.asyncDraw();
  }; // eslint-disable-line good-practices/no-single-usage-variable


  configure = chart._feedAxesRawData();

  _axisSelectorUi.default.resetAxisCount();

  (0, _lib.componentFactory)(chart, _axisSelectorUi.default, 'yAxisSelectorUI', configure.yAxisConfigure && configure.yAxisConfigure.length, configure.yAxisConfigure);
  (0, _lib.componentFactory)(chart, _category.default, 'xAxis', 1, configure.xAxisConfigure);
  xAxis = chart.getChildren('xAxis')[0];
  xAxis.setLinkedItem('canvas', canvas);
  axisRefVisualCartesian.setLinkedItem(xAxis.getId(), xAxis);
  axisRefVisualCartesian.addExtEventListener('visiblerangeset', redraw, xAxis);
  canvas.attachAxis(xAxis, false);
  canvas.setPrimaryAxis('xAxis', xAxis);

  chart._setCategories();
}

/***/ }),

/***/ 1387:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = _default;

var _lib = __webpack_require__(274);

var _multiaxisline = _interopRequireDefault(__webpack_require__(1388));

/**
 * Function to create the datasets
 */
function _default(chart) {
  var datasetsJSON,
      length,
      indices,
      vC,
      children = chart.getChildren(),
      yAxisSelectorUI = children.yAxisSelectorUI,
      // eslint-disable-line good-practices/no-single-usage-variable
  canvas = children.canvas[0],
      // eslint-disable-line good-practices/no-single-usage-variable
  numLen = (length + '').length,
      vCanvas = canvas.getChildren('vCanvas'),
      visibilityChangedHandler = function visibilityChangedHandler(e) {
    yAxisSelectorUI.forEach(function (comp) {
      comp.manipulateCheckBox(e);
    });
  },
      addDatasetVisibilityChangedEventListener = function addDatasetVisibilityChangedEventListener(dataset) {
    dataset.addEventListener('datasetVisibilityChanged', visibilityChangedHandler);
  };

  for (var i = 0, len = vCanvas.length; i < len; i++) {
    vC = vCanvas[i];

    if (vC.getState('removed')) {
      continue;
    }

    datasetsJSON = vC.getFromEnv('axisData').dataset; // vC.addToEnv('axisData', axis);

    if (datasetsJSON) {
      length = datasetsJSON.length; // for each dataset its datasetindex is a fractional number where the whole part is the index of its parent axis
      // and the fractional part is its index in that axis

      indices = Array(length).fill(vC.getFromEnv('yAxis').config.axisIndex).map(function (n, j) {
        // eslint-disable-line
        return n + (j + 1) * (1 / Math.pow(10, numLen));
      });
      (0, _lib.datasetFactory)(vC, _multiaxisline.default, 'dataset', length, datasetsJSON, indices);
      children = vC.getChildren('dataset'); // Adding event listeners to each dataset

      children.forEach(addDatasetVisibilityChangedEventListener);
    }
  }
}

/***/ }),

/***/ 1386:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = _default;

var _vcanvas = _interopRequireDefault(__webpack_require__(591));

var _lib = __webpack_require__(274);

/**
 * Function to create virtual canvas, additionally axis data is added to the env of virtual canvas
 */
function _default(chart) {
  var canvas = chart.getChildren('canvas')[0],
      axisSelectorUI = chart.getChildren('yAxisSelectorUI'),
      // eslint-disable-line good-practices/no-single-usage-variable
  axisY = chart.getFromEnv('dataSource').axis,
      // eslint-disable-line good-practices/no-single-usage-variable
  vCanvas,
      axes,
      xAxis = [],
      yAxis = [],
      vC,
      i,
      k,
      j;
  axes = chart.getChildren('xAxis');

  for (k = 0; k < (axes && axes.length); k++) {
    if (!axes[k].getState('removed')) {
      xAxis.push(axes[k]);
    }
  }

  axisSelectorUI.forEach(function (comp) {
    axes = comp.getChildren('yAxis');

    for (k = 0; k < (axes && axes.length); k++) {
      if (!axes[k].getState('removed')) {
        yAxis.push(axes[k]);
      }
    }
  });
  (0, _lib.componentFactory)(canvas, _vcanvas.default, 'vCanvas', xAxis.length * yAxis.length);
  vCanvas = canvas.getChildren('vCanvas');

  for (i = 0, k = 0; i < (xAxis && xAxis.length); i++) {
    for (j = 0; j < (yAxis && yAxis.length); j++, k++) {
      vC = vCanvas[k];
      vC.configure();
      vC.xAxis(xAxis[i]).yAxis(yAxis[j]).canvas(canvas);
      vC.addToEnv('axisData', axisY[k]);
      vC.addToEnv('vCanvas', vCanvas[k]);
    }
  }
}

/***/ }),

/***/ 1466:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = _default;

var _index = __webpack_require__(274);

var _nodeLinkManager = _interopRequireDefault(__webpack_require__(1467));

function _default(chart) {
  var config = chart.config;
  (0, _index.componentFactory)(chart, _nodeLinkManager.default, 'node-link-manager', 1, [{
    nodes: config.nodes,
    links: config.links,
    nodesOrder: config.nodesOrder,
    linksOrder: config.linksOrder,
    nodeLabelGap: config.nodeLabelGap,
    nodeLinkPadding: config.nodeLinkPadding,
    showLegend: config.showLegend,
    totalAngle: config.totalAngle,
    nodeSpacing: config.nodeSpacing,
    isPost: config.isPost,
    matrix: config.matrix,
    startingAngle: config.startingAngle,
    minNodeSize: config.minNodeSize,
    highlightEffect: config.highlightEffect,
    enableToggle: config.enableToggle,
    datalabelStyle: config.datalabelStyle // total: config.total

  }]);
  config.showLegend && chart.getChildren('node-link-manager')[0]._addLegend();
}

/***/ }),

/***/ 1459:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = _default;

var _polarCanvas = _interopRequireDefault(__webpack_require__(1460));

var _axisRefPolarComponent = _interopRequireDefault(__webpack_require__(1461));

var _lib = __webpack_require__(274);

// import axisRefVisual from '../components/axis-ref-visuals-polar';

/**
 * polarCanvas factory creates polarCanvas for radar chart
 *
 * @export
 * @param {any} chart chartAPI
 */
function _default(chart) {
  var pCanvas;
  (0, _lib.componentFactory)(chart, _polarCanvas.default, 'canvas', chart.config.showVolumeChart ? 2 : 1);
  pCanvas = chart.getChildren('canvas');

  for (var i = 0, len = pCanvas.length; i < len; i++) {
    pCanvas[i].configure();
    (0, _lib.componentFactory)(pCanvas[i], _axisRefPolarComponent.default, 'axisRefVisualPolar');
  }
}

/***/ }),

/***/ 1455:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = _default;

var _numeric = _interopRequireDefault(__webpack_require__(537));

var _polar = _interopRequireDefault(__webpack_require__(1456));

var _lib = __webpack_require__(274);

/**
 * function to instatiate axis and get attached to canvas
 * @param {Object} chart chart API
 */
function _default(chart) {
  var canvas = chart.getChildren('canvas')[0],
      config = chart._feedAxesRawData(),
      axisRefVisual = canvas.getChildren('axisRefVisualPolar')[0],
      yAxis,
      xAxis,
      redraw = function redraw() {
    return axisRefVisual.asyncDraw();
  };

  (0, _lib.componentFactory)(chart, _numeric.default, 'yAxis', 1, config.yAxisConf);
  (0, _lib.componentFactory)(chart, _polar.default, 'xAxis', 1, config.xAxisConf);
  yAxis = chart.getChildren('yAxis')[0];
  xAxis = chart.getChildren('xAxis')[0];
  yAxis.setLinkedItem('canvas', canvas);
  axisRefVisual.setLinkedItem(yAxis.getId(), yAxis);
  axisRefVisual.setLinkedItem(xAxis.getId(), xAxis);
  axisRefVisual.addExtEventListener('visiblerangeset', redraw, xAxis);
  axisRefVisual.addExtEventListener('visiblerangeset', redraw, yAxis);
  canvas.attachAxis(xAxis, false, {});
  canvas.attachAxis(yAxis, true, {});

  chart._setCategories();
}

/***/ }),

/***/ 1437:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



exports.__esModule = true;
exports["default"] = _default;

var _lib = __webpack_require__(274);

var BOLD = 'bold',
    NORMAL = 'normal',
    ITALIC = 'italic';

function _default(chart) {
  var dsDef = chart.getDSdef(),
      chartAttr = chart.getFromEnv('dataSource').chart || {},
      ds,
      nodeLabelFontBold,
      nodeLabelFontItalic,
      nodeLabelBorderThickness,
      nodeLabelBorderPadding,
      nodeLabelBorderRadius,
      nodeLabelBorderDash,
      showNodes,
      dataLabelStyle = chart.config.dataLabelStyle,
      _chart$getFromEnv = chart.getFromEnv('sankey-graph'),
      nodes = _chart$getFromEnv.nodes,
      links = _chart$getFromEnv.links;

  nodeLabelFontBold = (0, _lib.pluckNumber)(chartAttr.nodelabelfontbold, chartAttr.labelfontbold, 0) ? BOLD : NORMAL;
  nodeLabelFontItalic = (0, _lib.pluckNumber)(chartAttr.nodelabelfontitalic, chartAttr.labelfontitalic, 0) ? ITALIC : NORMAL;
  nodeLabelBorderThickness = (0, _lib.pluckNumber)(chartAttr.nodelabelborderthickness, chartAttr.labelborderthickness, 1);
  nodeLabelBorderPadding = (0, _lib.pluckNumber)(chartAttr.nodelabelborderpadding, chartAttr.labelborderpadding, 2);
  nodeLabelBorderRadius = (0, _lib.pluckNumber)(chartAttr.nodelabelborderradius, chartAttr.labelborderradius, 0);
  nodeLabelBorderDash = (0, _lib.pluckNumber)(chartAttr.nodelabelborderdashed, chartAttr.labelborderdashed, 0) ? (0, _lib.getDashStyle)((0, _lib.pluckNumber)(chartAttr.nodelabelborderdashlen, chartAttr.labelborderdashlen, 4), (0, _lib.pluckNumber)(chartAttr.nodelabelborderdashgap, chartAttr.labelborderdashgap, 2)) : _lib.DASH_DEF;
  showNodes = (0, _lib.pluckNumber)(chartAttr.shownodes, 1);
  (0, _lib.componentFactory)(chart, dsDef, 'dataset', 1);
  ds = chart.getDatasets()[0];
  ds.configure({
    showNodes: showNodes,
    nodeWidth: chart.config.nodeWidth,
    nodeRelaxation: (0, _lib.pluckNumber)(chartAttr.noderelaxation, 1),
    nodeSpacing: (0, _lib.pluckNumber)(chartAttr.nodespacing, 10),
    labelSepChar: (0, _lib.parseUnsafeString)((0, _lib.pluck)(chartAttr.labelSepChar, ',')),
    enableDrag: (0, _lib.pluckNumber)(chartAttr.enabledrag, true),
    highlightEffect: (0, _lib.pluckNumber)(chartAttr.highlighteffect, true),
    style: {
      node: {
        label: {
          fontFamily: (0, _lib.pluck)(chartAttr.nodelabelfont, chartAttr.labelfont, dataLabelStyle.fontFamily),
          fontSize: (0, _lib.pluck)(chartAttr.nodelabelfontsize, chartAttr.labelfontsize, chartAttr.basefontsize, 11 + _lib.PXSTRING),
          fontWeight: nodeLabelFontBold,
          fontStyle: nodeLabelFontItalic,
          borderThickness: nodeLabelBorderThickness,
          borderPadding: nodeLabelBorderPadding,
          borderRadius: nodeLabelBorderRadius,
          borderDash: nodeLabelBorderDash
        }
      },
      link: {}
    },
    nodes: nodes,
    links: links
  });
}

;

/***/ }),

/***/ 1432:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = _default;

var _lib = __webpack_require__(274);

var _sankeyLink = _interopRequireDefault(__webpack_require__(1433));

var SOURCE = 'source',
    TARGET = 'target',
    BLEND = 'blend',
    BUTT = 'butt',
    HORIZONTAL = 'horizontal';

function _default(dataset) {
  var dsConfig = dataset.config,
      links = dsConfig.links,
      orientation = dataset.getFromEnv('orientation'),
      numberFormatter = dataset.getFromEnv('number-formatter'),
      linkComponent,
      gradientAngle,
      chartAttr = dataset.getFromEnv('dataSource').chart,
      linkPadding = (0, _lib.pluckNumber)(chartAttr.nodelinkpadding, 0),
      linkColor,
      linkCss,
      linkFocusCss,
      linkFocusOutCss,
      rawCosmetics,
      sourceFill,
      targetFill,
      fromNode,
      toNode,
      from,
      fromValue,
      toValue,
      to,
      toolText,
      id;
  links.forEach(function (link) {
    link.props.index += _lib.BLANK;
    id = link.props.index;
    from = (0, _lib.parseUnsafeString)((0, _lib.pluck)(link.from));
    to = (0, _lib.parseUnsafeString)((0, _lib.pluck)(link.to));
    fromNode = dataset.getChild(from, 'nodes');
    toNode = dataset.getChild(to, 'nodes');
    toolText = (0, _lib.parseUnsafeString)((0, _lib.pluck)(link.tooltext, chartAttr.linktooltext, _lib.UNDEF));
    fromValue = fromNode.config.value;
    toValue = toNode.config.value;
    linkColor = (0, _lib.pluck)(link.color, chartAttr.linkcolor, SOURCE);
    sourceFill = fromNode.config.rawCosmetics.fill;
    targetFill = toNode.config.rawCosmetics.fill; // eslint-disable-next-line

    switch (linkColor.toLowerCase()) {
      case SOURCE:
        linkColor = sourceFill;
        break;

      case TARGET:
        linkColor = targetFill;
        break;

      case BLEND:
        linkColor = sourceFill + ',' + targetFill;
        break;
    }

    rawCosmetics = {
      fill: linkColor,
      alpha: (0, _lib.pluckNumber)(link.alpha, chartAttr.linkalpha, 20),
      focusAlpha: (0, _lib.pluckNumber)(link.hoveralpha, chartAttr.linkhoveralpha, 75),
      focusOutAlpha: 10
    };
    gradientAngle = orientation === HORIZONTAL ? 0 : 90;
    linkCss = {
      stroke: (0, _lib.toRaphaelColor)({
        color: rawCosmetics.fill,
        alpha: rawCosmetics.alpha,
        angle: gradientAngle
      }),
      'stroke-linecap': BUTT,
      fill: 'none'
    };
    linkFocusCss = ({}, linkCss, {
      stroke: (0, _lib.toRaphaelColor)({
        color: rawCosmetics.fill,
        alpha: rawCosmetics.focusAlpha,
        angle: gradientAngle
      })
    });
    linkFocusOutCss = ({}, linkCss, {
      stroke: (0, _lib.toRaphaelColor)({
        color: rawCosmetics.fill,
        alpha: rawCosmetics.focusOutAlpha,
        angle: gradientAngle
      })
    });
    linkComponent = dataset.attachChild(_sankeyLink.default, 'links', id);
    linkComponent.setData({
      from: from,
      to: to,
      mode: 'normal',
      linkValue: (0, _lib.pluckNumber)(link.value),
      value: numberFormatter.dataLabels((0, _lib.pluckNumber)(link.value)),
      fromValue: fromValue,
      toValue: toValue,
      toolText: toolText,
      color: rawCosmetics.linkColor,
      alpha: rawCosmetics.alpha,
      curvature: (0, _lib.clampNumber)((0, _lib.pluckNumber)(link.curvature, chartAttr.linkcurvature, 0.5), 0, 1),
      linkType: (0, _lib.pluck)(link.type, chartAttr.linktype),
      linkPadding: linkPadding,
      sourceFill: sourceFill,
      targetFill: targetFill,
      props: link.props,
      rawCosmetics: rawCosmetics,
      eventArgs: {
        color: rawCosmetics.fill,
        alpha: rawCosmetics.alpha,
        value: link.value,
        from: link.props.source.label,
        to: link.props.target.label
      },
      style: {
        link: {
          normal: linkCss,
          focus: linkFocusCss,
          focusOut: linkFocusOutCss
        }
      }
    });
  });
  dataset.attachListeners();
}

;

/***/ }),

/***/ 1430:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = _default;

var _lib = __webpack_require__(274);

var _sankeyNode = _interopRequireDefault(__webpack_require__(1431));

var NONE = 'none',
    validPosition = ['start', 'inside', 'end'];

function _default(dataset) {
  var dsConfig = dataset.config,
      nodes = dsConfig.nodes,
      enableDrag = dsConfig.enableDrag,
      style = dsConfig.style,
      nodeComponent,
      labelCss,
      nodeCss,
      nodeFocusCss,
      nodeFocusOutCss,
      rawCosmetics,
      rawLabelCosmetics,
      labelBgColor,
      labelBorderColor,
      labelPosition,
      cursor,
      chartAttr = dataset.getFromEnv('dataSource').chart,
      nodeLabelStyle = style.node.label,
      nodeLabelAlpha,
      inheritFromPlot = (0, _lib.pluckNumber)(chartAttr.inheritlabelcolorfromnode, 1),
      colorM = dataset.getFromEnv('color-manager'),
      numberFormatter = dataset.getFromEnv('number-formatter'),
      _dataset$getFromEnv = dataset.getFromEnv('chartConfig'),
      dataLabelStyle = _dataset$getFromEnv.dataLabelStyle,
      showLegend = _dataset$getFromEnv.showLegend,
      id;

  nodes.forEach(function (node, index) {
    id = (0, _lib.pluck)(node.id, node.label);
    rawCosmetics = {
      fill: (0, _lib.pluck)(node.color, chartAttr.nodecolor, colorM.getPlotColor(index)),
      alpha: (0, _lib.pluckNumber)(node.alpha, chartAttr.nodealpha, 100),
      focusAlpha: (0, _lib.pluckNumber)(node.hoveralpha, chartAttr.nodehoveralpha, 100),
      focusOutAlpha: 40,
      stroke: NONE
    };
    nodeLabelAlpha = (0, _lib.pluck)(node.labelalpha, chartAttr.nodelabelalpha, chartAttr.labelalpha, inheritFromPlot ? rawCosmetics.alpha : 100);
    labelBgColor = (0, _lib.pluck)(node.labelbgcolor, chartAttr.nodelabelbgcolor, chartAttr.labelbgcolor);
    labelBgColor = labelBgColor ? (0, _lib.convertColor)(labelBgColor, nodeLabelAlpha) : _lib.BLANK;
    labelBorderColor = (0, _lib.pluck)(node.labelbordercolor, chartAttr.nodelabelbordercolor, chartAttr.labelbordercolor);
    labelBorderColor = labelBorderColor ? (0, _lib.convertColor)(labelBorderColor, nodeLabelAlpha) : _lib.BLANK;
    rawLabelCosmetics = Object.assign({}, dataLabelStyle, {
      labelFill: (0, _lib.pluck)(node.labelfontcolor, chartAttr.nodelabelfontcolor, chartAttr.labelfontcolor, chartAttr.basefontcolor, inheritFromPlot ? rawCosmetics.fill : '#5f5f5f'),
      labelAlpha: nodeLabelAlpha,
      focusAlpha: rawCosmetics.focusAlpha,
      focusOutAlpha: rawCosmetics.focusOutAlpha,
      border: labelBgColor ? nodeLabelStyle.borderThickness + 'px solid' : _lib.BLANK,
      borderColor: labelBorderColor,
      backgroundColor: labelBgColor
    });
    cursor = enableDrag ? 'move' : 'default';
    labelCss = {
      cursor: cursor,
      'text-bound': [labelBgColor, labelBorderColor, nodeLabelStyle.borderThickness, nodeLabelStyle.borderPadding, nodeLabelStyle.borderRadius, nodeLabelStyle.borderDash],
      fill: (0, _lib.convertColor)(rawLabelCosmetics.labelFill, rawLabelCosmetics.labelAlpha)
    };
    labelPosition = (0, _lib.pluck)(node.labelposition, chartAttr.nodelabelposition, _lib.preDefStr.POSITION_END).toLowerCase();

    if (validPosition.indexOf(labelPosition) < 0) {
      labelPosition = _lib.preDefStr.POSITION_END;
    }

    nodeCss = {
      fill: (0, _lib.convertColor)(rawCosmetics.fill, rawCosmetics.alpha),
      cursor: cursor,
      stroke: rawCosmetics.stroke
    };
    nodeFocusCss = {
      fill: (0, _lib.convertColor)(rawCosmetics.fill, rawCosmetics.focusAlpha)
    };
    nodeFocusOutCss = {
      fill: (0, _lib.convertColor)(rawCosmetics.fill, rawCosmetics.focusOutAlpha)
    };
    nodeComponent = dataset.attachChild(_sankeyNode.default, 'nodes', id);
    nodeComponent.setData({
      id: id,
      index: index,
      mode: 'normal',
      label: (0, _lib.pluck)(node.label, node.id),
      value: numberFormatter.dataLabels(node.props.value),
      labelPadding: numberFormatter.getCleanValue((0, _lib.pluck)(node.labelpadding, chartAttr.nodelabelpadding, 5)),
      visible: (0, _lib.pluckNumber)(node.visible, chartAttr.shownodes, 1),
      showLabel: (0, _lib.pluckNumber)(node.showlabel, chartAttr.shownodelabels, 1),
      showValue: (0, _lib.pluckNumber)(node.showvalue, chartAttr.shownodevalues, 0),
      rotateLabel: (0, _lib.pluckNumber)(node.rotatelabel, chartAttr.rotatenodelabels, 0),
      labelPosition: labelPosition,
      valuePosition: (0, _lib.pluck)(node.labelposition, chartAttr.nodelabelposition, _lib.preDefStr.POSITION_MIDDLE),
      plotToolText: (0, _lib.getValidValue)((0, _lib.parseUnsafeString)((0, _lib.pluck)(node.tooltext, chartAttr.plottooltext))),
      toolText: (0, _lib.getValidValue)((0, _lib.parseUnsafeString)((0, _lib.pluck)(node.tooltext, node.tooltext))),
      nodeValue: (0, _lib.pluckNumber)(node.nodevalue, chartAttr.nodevalue, 0),
      nodeDataValue: numberFormatter.dataLabels(node.nodedatavalue),
      // linkPadding: pluckNumber(node.linkpadding, chartAttr.nodelinkpadding, 0),
      textOutline: (0, _lib.pluckNumber)(node.textoutline, chartAttr.textoutline, 0),
      rawCosmetics: rawCosmetics,
      rawLabelCosmetics: rawLabelCosmetics,
      props: node.props,
      eventArgs: {
        color: rawCosmetics.fill,
        alpha: rawCosmetics.alpha,
        labelFill: rawLabelCosmetics.labelFill,
        labelAlpha: rawLabelCosmetics.labelAlpha,
        value: node.props.value,
        label: node.label,
        sourceLinks: node.props.sourceLinks.map(function (link) {
          return link.to;
        }),
        targetLinks: node.props.targetLinks.map(function (link) {
          return link.from;
        })
      },
      style: {
        node: {
          normal: nodeCss,
          focus: nodeFocusCss,
          focusOut: nodeFocusOutCss
        },
        label: {
          normal: labelCss,
          focus: Object.assign({}, labelCss, {
            fill: (0, _lib.convertColor)(rawLabelCosmetics.labelFill, rawLabelCosmetics.focusAlpha)
          }),
          focusOut: Object.assign({}, labelCss, {
            fill: (0, _lib.convertColor)(rawLabelCosmetics.labelFill, rawLabelCosmetics.focusOutAlpha)
          })
        } // value: {
        //   normal: valueCss,
        //   focus: valueCss,
        //   focusOut: Object.assign({}, valueCss, {
        //     fill: convertColor(rawLabelCosmetics.valueFill, rawLabelCosmetics.focusOutAlpha)
        //   })
        // }

      }
    });
  });
  showLegend && dataset._addLegend();
}

;

/***/ }),

/***/ 1379:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _lib = __webpack_require__(274);

var _sunburst = _interopRequireDefault(__webpack_require__(1380));

var depthFirstVisit = function depthFirstVisit(arr) {
  var sumOfVisit = 0;
  arr.forEach(function (c) {
    var givenValue = c.value ? +c.value : 0,
        applicableValue = c.category.length > 0 ? depthFirstVisit(c.category) : givenValue;

    if (applicableValue > givenValue) {
      c.value = applicableValue;
    } else {
      c.value = givenValue;
      applicableValue = givenValue;
    }

    sumOfVisit += applicableValue;
  });
  return sumOfVisit;
};
/**
 * function to  create dataset, group manager.
 * assign dataset to group manager.
 **/


var _default = function _default(chart) {
  var categories = chart.getFromEnv('parsedDataSource') || [],
      length;
  categories.forEach(function depthFirstVisitRunner(e) {
    var sum = depthFirstVisit(e.category);
    !e.value && (e.value = 0);

    if (sum > +e.value) {
      e.value = sum;
    }
  });
  chart.config.categories = categories;
  length = categories.length; // if the data has no categories in them.

  if (!length) {
    chart.setChartMessage();
    return;
  }

  (0, _lib.datasetFactory)(chart, _sunburst.default, 'dataset', length, [{
    inputTree: categories
  }]);
};

exports["default"] = _default;

/***/ }),

/***/ 1475:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _multicanvasCrosslineManager = _interopRequireDefault(__webpack_require__(466));

var _default = _multicanvasCrosslineManager.default;
exports["default"] = _default;

/***/ }),

/***/ 1311:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _spline = _interopRequireDefault(__webpack_require__(786));

exports.Spline = _spline.default;

var _logmscolumn2d = _interopRequireDefault(__webpack_require__(1312));

exports.Logmscolumn2d = _logmscolumn2d.default;

var _logmsline = _interopRequireDefault(__webpack_require__(1317));

exports.Logmsline = _logmsline.default;

var _logstackedcolumn2d = _interopRequireDefault(__webpack_require__(1319));

exports.LogStackedColumn2d = _logstackedcolumn2d.default;

var _splinearea = _interopRequireDefault(__webpack_require__(789));

exports.Splinearea = _splinearea.default;

var _msspline = _interopRequireDefault(__webpack_require__(791));

exports.Msspline = _msspline.default;

var _mssplinedy = _interopRequireDefault(__webpack_require__(794));

exports.MSSplineDy = _mssplinedy.default;

var _mssplinearea = _interopRequireDefault(__webpack_require__(796));

exports.Mssplinearea = _mssplinearea.default;

var _errorbar2d = _interopRequireDefault(__webpack_require__(1321));

exports.Errorbar2d = _errorbar2d.default;

var _errorline = _interopRequireDefault(__webpack_require__(1325));

exports.Errorline = _errorline.default;

var _errorscatter = _interopRequireDefault(__webpack_require__(1330));

exports.Errorscatter = _errorscatter.default;

var _inversemsarea = _interopRequireDefault(__webpack_require__(1335));

exports.Inversemsarea = _inversemsarea.default;

var _inversemscolumn2d = _interopRequireDefault(__webpack_require__(1337));

exports.Inversemscolumn2d = _inversemscolumn2d.default;

var _inversemsline = _interopRequireDefault(__webpack_require__(1339));

exports.Inversemsline = _inversemsline.default;

var _dragcolumn2d = _interopRequireDefault(__webpack_require__(1341));

exports.Dragcolumn2d = _dragcolumn2d.default;

var _dragline = _interopRequireDefault(__webpack_require__(1353));

exports.Dragline = _dragline.default;

var _kagi = _interopRequireDefault(__webpack_require__(1360));

exports.Kagi = _kagi.default;

var _waterfall2d = _interopRequireDefault(__webpack_require__(1367));

exports.WaterFall2D = _waterfall2d.default;

var _selectscatter = _interopRequireDefault(__webpack_require__(1368));

exports.SelectScatter = _selectscatter.default;

var _multilevelpie = _interopRequireDefault(__webpack_require__(1372));

exports.MultilevelPie = _multilevelpie.default;

var _sunburst = _interopRequireDefault(__webpack_require__(1377));

exports.Sunburst = _sunburst.default;

var _multiaxisline = _interopRequireDefault(__webpack_require__(1382));

exports.MultiAxisLine = _multiaxisline.default;

var _msstepline = _interopRequireDefault(__webpack_require__(1390));

exports.MSStepLine = _msstepline.default;

var _dragnode = _interopRequireDefault(__webpack_require__(1394));

exports.DragNode = _dragnode.default;

var _candlestick = _interopRequireDefault(__webpack_require__(1405));

exports.CandleStick = _candlestick.default;

var _boxandwhisker2d = _interopRequireDefault(__webpack_require__(1418));

exports.BoxAndWhisker2D = _boxandwhisker2d.default;

var _sankey = _interopRequireDefault(__webpack_require__(1427));

exports.Sankey = _sankey.default;

var _heatmap = _interopRequireDefault(__webpack_require__(1438));

exports.HeatMap = _heatmap.default;

var _radar = _interopRequireDefault(__webpack_require__(1450));

exports.Radar = _radar.default;

var _chord = _interopRequireDefault(__webpack_require__(1463));

exports.Chord = _chord.default;

var _dragarea = _interopRequireDefault(__webpack_require__(1473));

exports.DragArea = _dragarea.default;

var _crossline = _interopRequireDefault(__webpack_require__(1474));

var _multicanvasCrosslineManager = _interopRequireDefault(__webpack_require__(1475));

// import TreeMap from '../viz/treemap';
var _default = {
  name: 'powercharts',
  type: 'package',
  requiresFusionCharts: true,
  extension: function extension(FusionCharts) {
    FusionCharts.addDep(_crossline.default);
    FusionCharts.addDep(_multicanvasCrosslineManager.default);
    FusionCharts.addDep(_spline.default);
    FusionCharts.addDep(_logmscolumn2d.default);
    FusionCharts.addDep(_logstackedcolumn2d.default);
    FusionCharts.addDep(_logmsline.default);
    FusionCharts.addDep(_splinearea.default);
    FusionCharts.addDep(_mssplinedy.default);
    FusionCharts.addDep(_msspline.default);
    FusionCharts.addDep(_mssplinearea.default);
    FusionCharts.addDep(_errorbar2d.default);
    FusionCharts.addDep(_errorline.default);
    FusionCharts.addDep(_errorscatter.default);
    FusionCharts.addDep(_inversemsarea.default);
    FusionCharts.addDep(_inversemscolumn2d.default);
    FusionCharts.addDep(_inversemsline.default);
    FusionCharts.addDep(_dragcolumn2d.default);
    FusionCharts.addDep(_dragline.default);
    FusionCharts.addDep(_kagi.default);
    FusionCharts.addDep(_waterfall2d.default);
    FusionCharts.addDep(_selectscatter.default);
    FusionCharts.addDep(_multilevelpie.default);
    FusionCharts.addDep(_sunburst.default);
    FusionCharts.addDep(_multiaxisline.default);
    FusionCharts.addDep(_msstepline.default);
    FusionCharts.addDep(_dragnode.default);
    FusionCharts.addDep(_candlestick.default);
    FusionCharts.addDep(_boxandwhisker2d.default);
    FusionCharts.addDep(_sankey.default);
    FusionCharts.addDep(_heatmap.default);
    FusionCharts.addDep(_radar.default);
    FusionCharts.addDep(_chord.default); // FusionCharts.addDep(TreeMap);

    FusionCharts.addDep(_dragarea.default);
  }
};
exports["default"] = _default;

/***/ }),

/***/ 1418:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _boxandwhisker2d = _interopRequireDefault(__webpack_require__(1419));

var _default = _boxandwhisker2d.default;
exports["default"] = _default;

/***/ }),

/***/ 1405:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _candlestick = _interopRequireDefault(__webpack_require__(1406));

var _default = _candlestick.default;
exports["default"] = _default;

/***/ }),

/***/ 1463:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _chord = _interopRequireDefault(__webpack_require__(1464));

var _default = _chord.default;
exports["default"] = _default;

/***/ }),

/***/ 1473:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _dragarea = _interopRequireDefault(__webpack_require__(1359));

var _default = _dragarea.default;
exports["default"] = _default;

/***/ }),

/***/ 1341:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _dragcolumn2d = _interopRequireDefault(__webpack_require__(1342));

var _default = _dragcolumn2d.default;
exports["default"] = _default;

/***/ }),

/***/ 1353:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _dragline = _interopRequireDefault(__webpack_require__(1354));

var _default = _dragline.default;
exports["default"] = _default;

/***/ }),

/***/ 1394:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _dragnode = _interopRequireDefault(__webpack_require__(1395));

var _default = _dragnode.default;
exports["default"] = _default;

/***/ }),

/***/ 1321:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _errorbar2d = _interopRequireDefault(__webpack_require__(1322));

var _default = _errorbar2d.default;
exports["default"] = _default;

/***/ }),

/***/ 1325:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _errorline = _interopRequireDefault(__webpack_require__(1326));

var _default = _errorline.default;
exports["default"] = _default;

/***/ }),

/***/ 1330:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _errorscatter = _interopRequireDefault(__webpack_require__(1331));

var _default = _errorscatter.default;
exports["default"] = _default;

/***/ }),

/***/ 1438:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _heatmap = _interopRequireDefault(__webpack_require__(1439));

var _default = _heatmap.default;
exports["default"] = _default;

/***/ }),

/***/ 1335:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inversemsarea = _interopRequireDefault(__webpack_require__(1336));

var _default = _inversemsarea.default;
exports["default"] = _default;

/***/ }),

/***/ 1337:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inversemscolumn2d = _interopRequireDefault(__webpack_require__(1338));

var _default = _inversemscolumn2d.default;
exports["default"] = _default;

/***/ }),

/***/ 1339:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inversemsline = _interopRequireDefault(__webpack_require__(1340));

var _default = _inversemsline.default;
exports["default"] = _default;

/***/ }),

/***/ 1360:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _kagi = _interopRequireDefault(__webpack_require__(1361));

var _default = _kagi.default;
exports["default"] = _default;

/***/ }),

/***/ 1312:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _logmscolumn2d = _interopRequireDefault(__webpack_require__(1313));

var _default = _logmscolumn2d.default;
exports["default"] = _default;

/***/ }),

/***/ 1317:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _logmsline = _interopRequireDefault(__webpack_require__(1318));

var _default = _logmsline.default;
exports["default"] = _default;

/***/ }),

/***/ 1319:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _logstackedcolumn2d = _interopRequireDefault(__webpack_require__(1320));

var _default = _logstackedcolumn2d.default;
exports["default"] = _default;

/***/ }),

/***/ 1390:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _msstepline = _interopRequireDefault(__webpack_require__(1391));

var _default = _msstepline.default;
exports["default"] = _default;

/***/ }),

/***/ 1382:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _multiaxisline = _interopRequireDefault(__webpack_require__(1383));

var _default = _multiaxisline.default;
exports["default"] = _default;

/***/ }),

/***/ 1372:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _multilevelpie = _interopRequireDefault(__webpack_require__(1373));

var _default = _multilevelpie.default;
exports["default"] = _default;

/***/ }),

/***/ 1450:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _radar = _interopRequireDefault(__webpack_require__(1451));

var _default = _radar.default;
exports["default"] = _default;

/***/ }),

/***/ 1427:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _sankey = _interopRequireDefault(__webpack_require__(1428));

var _default = _sankey.default;
exports["default"] = _default;

/***/ }),

/***/ 1368:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _selectscatter = _interopRequireDefault(__webpack_require__(1369));

var _default = _selectscatter.default;
exports["default"] = _default;

/***/ }),

/***/ 1377:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _sunburst = _interopRequireDefault(__webpack_require__(1378));

var _default = _sunburst.default;
exports["default"] = _default;

/***/ }),

/***/ 1367:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _waterfall2d = _interopRequireDefault(__webpack_require__(1362));

var _default = _waterfall2d.default;
exports["default"] = _default;

/***/ })

}]);
}));

//# sourceMappingURL=http://localhost:3052/4.1.0-beta.9/map/eval/fusioncharts.powercharts.js.map