
(function (factory) {
  if (typeof module === 'object' && typeof module.exports !== "undefined") {
      module.exports = factory;
  } else {
      factory();
  }
}(function () {
"use strict";
(self["webpackChunkFusionCharts"] = self["webpackChunkFusionCharts"] || []).push([[11],{

/***/ 901:
/***/ ((__unused_webpack_module, exports) => {



exports.__esModule = true;
exports.isWithinMinRange = exports.clampWithinContextRange = void 0;

var clampWithinContextRange = function clampWithinContextRange(curRange, focusScale, contextScale) {
  var maxZoomRange = contextScale.getDomain().map(function (val) {
    return focusScale.getRangeValue(val);
  });
  curRange[0] = Math.max(curRange[0], maxZoomRange[0]);
  curRange[1] = Math.min(curRange[1], maxZoomRange[1]);
  return curRange;
},
    isWithinMinRange = function isWithinMinRange(curRange, focusScale) {
  var binMin = focusScale.getBinMin(),
      minZoomDomain = 3 * binMin[2],
      minZoomRangeLen = focusScale.getRangeValue(minZoomDomain) - focusScale.getRangeValue(0);

  if (curRange[1] - curRange[0] >= minZoomRangeLen) {
    return true;
  }

  return false;
};

exports.isWithinMinRange = isWithinMinRange;
exports.clampWithinContextRange = clampWithinContextRange;

/***/ }),

/***/ 884:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _defineProperty2 = _interopRequireDefault(__webpack_require__(273));

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _lib = __webpack_require__(274);

var _safeMax = _interopRequireDefault(__webpack_require__(540));

var _linear = _interopRequireDefault(__webpack_require__(541));

var _componentInterface = __webpack_require__(290);

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var identity = function identity(x) {
  return x;
},
    isNil = function isNil(x) {
  return x === null || typeof x === 'undefined';
},
    // HEIGHT = 'height',
// WIDTH = 'width',
MAX_ALLOWED_SPACE = 5,
    TICKMAJOR = 'tick-mark-major',
    TICKMINOR = 'tick-mark-minor',
    LABELMAJOR = 'label-major',
    LABELMINOR = 'label-minor',
    LABELCONTEXT = 'label-context',
    START = 'start',
    END = 'end',
    MIDDLE = 'middle',
    TOP = 'top',
    RIGHT = 'right',
    BOTTOM = 'bottom',
    LEFT = 'left',
    X = 'x',
    Y = 'y',
    MAJOR = 'major',
    MINOR = 'minor',
    CONTEXT = 'context',
    DEFAULT_TICK_SIZE = 12,
    DEFAULT_TICK_PADDING = 1,
    DEFAULT_ROTATION = 90,
    DEFAULT_TRANSFORM = 't0,0',
    DEFAULT_LABEL_PADDING = 5,
    LABEL_NAME_WIDTH_BUFFER = 10,
    GUTTER_2 = 2,
    // MIN_VERTICAL_LABEL_GAP = 5,
floor = Math.floor,
    mathMax = Math.max,
    BLANK = '',

/**
 * Creates translation string with y set to 0
 *
 * @param {number} x x value
 */
translateX = function translateX(x) {
  return "t" + x + ",0";
},

/**
 * Creates translation string with x set to 0
 *
 * @param {number} y y value
 */
translateY = function translateY(y) {
  return "t0," + y;
},
    number = function number(scale) {
  return function (d) {
    return +scale.getRangeValue(d);
  };
},
    center = function center(scale) {
  return function (d) {
    return +scale.getRangeValue(d) + scale.getBandwidth() / 2;
  };
},

/**
 * Returns the time formatter based on tick type
 *
 * @param {Array} timeFormat list of formatters
 * @param {Array} tickType list of ticks
 * @param {Number} index index for which tick is to be calculated
 * @returns {Instance} formatter
 */
getFormatter = function getFormatter(timeFormat, tickType, index) {
  if (timeFormat && tickType) {
    return timeFormat[tickType[index]];
  }
},

/**
 * checks if two boxes overlaps
 *
 * @param {Object} bbox1 first dimension
 * @param {Object} bbox2 second dimension
 * @returns {boolean} true if two bbox overlaps, else false
 */
overlaps = function overlaps(bbox1, bbox2) {
  if (bbox1.x > bbox2.x + bbox2.width || bbox2.x > bbox1.x + bbox1.width) {
    return false;
  }

  if (bbox1.y > bbox2.y + bbox2.height || bbox2.y > bbox1.y + bbox1.height) {
    return false;
  }

  return true;
},

/**
 * sets tick label to blank string and width and height of ticks to 0
 *
 * @param {Object} tick tick object
 */
resetTickInfo = function resetTickInfo(tick) {
  tick.text = BLANK;
  tick.dim.width = 0;
  tick.dim.height = 0;
},

/**
 * decide text anchor to be applied on labels
 *
 * @param {String} orient orientation of axis
 */
getTextAnchor = function getTextAnchor(orient) {
  var anchor;

  switch (orient) {
    case LEFT:
      anchor = END;
      break;

    case RIGHT:
      anchor = START;
      break;

    default:
      anchor = MIDDLE;
  }

  return anchor;
},

/**
 * Method to check whether the label lies within its parent's Dimensions
 * @param {Object} smartText smart text
 * @param {String} textAnchor text anchor of the label
 * @param {Object} labelDim dimension of the label
 * @param {Object} parentDim parent's dimension
 */
isWithinDomain = function isWithinDomain(smartText, textAnchor, labelDim, parentDim) {
  var startX;

  if (textAnchor === START) {
    startX = labelDim.x;
  } else if (textAnchor === END) {
    startX = labelDim.x - smartText.width;
  } else {
    startX = labelDim.x - smartText.width / 2;
  }

  if (startX >= 0 && startX + smartText.width <= parentDim.width) {
    return true;
  }

  return false;
},
    isWithinVisibleRange = function isWithinVisibleRange(value, limits) {
  return value >= limits.start && value <= limits.end;
};
/**
 * @todo
 * 1. try to merge cleanseMajorTicks and cleanseMinorTicks
 * 2. Reduce arrays in axis label space management
 */


var Axis = /*#__PURE__*/function (_SmartRenderer) {
  (0, _inheritsLoose2.default)(Axis, _SmartRenderer);

  function Axis() {
    return _SmartRenderer.apply(this, arguments) || this;
  }

  var _proto = Axis.prototype;

  _proto.getType = function getType() {
    return 'axis';
  };

  _proto.getName = function getName() {
    return 'axis';
  };

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    var _axisConfig$style;

    _SmartRenderer.prototype.__setDefaultConfig.call(this);

    var axisConfig = this.config;
    this.setScale(new _linear.default());
    this.setAlignment(LEFT);
    this.setTickArguments();
    this.setTickValues();
    this.setReverse(false);
    this.setTickSize(DEFAULT_TICK_SIZE);
    this.setTickPadding(DEFAULT_TICK_PADDING);
    this.setDomainLine(true);
    this.setTicksDraw(true);
    this.setLabelOffset();
    this.setDayInMajor(false);
    this.setStickyContextLabel(true);
    this.setTickVisibilityLimit({
      start: -Infinity,
      end: Infinity
    });
    axisConfig.alignDiff = 0;
    axisConfig.maxLabelSpace = 0;
    axisConfig.axisDimension = {}; // Default styles to be used when user didn't provide any values

    axisConfig.defaultStyle = axisConfig.style = (_axisConfig$style = {}, _axisConfig$style[TICKMINOR] = {
      stroke: '#d3d3d3',
      'stroke-width': '1px'
    }, _axisConfig$style[TICKMAJOR] = {
      stroke: '#AAAAAA',
      'stroke-width': '1px'
    }, _axisConfig$style[LABELMAJOR] = {
      fill: '#858585',
      'font-size': '12px',
      'font-weight': 'normal',
      'font-style': 'normal'
    }, _axisConfig$style[LABELMINOR] = {
      fill: '#9A9A9A',
      'font-size': '11px',
      'font-weight': 'normal',
      'font-style': 'normal'
    }, _axisConfig$style[LABELCONTEXT] = {
      fill: '#858585',
      'font-size': '12px',
      'font-weight': 'normal',
      'font-style': 'normal'
    }, _axisConfig$style._ticks = {
      minor: {
        stroke: '#d3d3d3'
      },
      major: {
        stroke: '#AAAAAA'
      },
      context: {}
    }, _axisConfig$style._text = {
      major: {
        fill: '#858585',
        'font-size': '12px',
        'font-weight': 'normal',
        'font-style': 'normal'
      },
      minor: {
        fill: '#9A9A9A',
        'font-size': '11px',
        'font-weight': 'normal',
        'font-style': 'normal'
      },
      context: {
        fill: '#858585',
        'font-size': '12px',
        'font-weight': 'normal',
        'font-style': 'normal'
      }
    }, _axisConfig$style.line = {
      fill: '#D6D6D6'
    }, _axisConfig$style.title = {
      fill: '#5F5F5F',
      'font-size': '12px',
      'font-weight': 'normal',
      'font-style': 'normal'
    }, _axisConfig$style);
    if (!this.config.prevTicks) this.config.prevTicks = [];
  }
  /**
   * configures different properties of axis
   *
   * @param {any} inputCfg configurations object
   * @memberof Axis
   */
  ;

  _proto.configureAttributes = function configureAttributes(inputCfg) {
    _SmartRenderer.prototype.configureAttributes.call(this, inputCfg);

    var axis = this;
    inputCfg.scale && axis.setScale(inputCfg.scale);
    inputCfg.align && axis.setAlignment(inputCfg.align, inputCfg.overlap);
    inputCfg.reverse && axis.setReverse(inputCfg.reverse);
    inputCfg.tickarguments && axis.setTickArguments.apply(axis, inputCfg.tickarguments);
    inputCfg.title && axis.setAxisName((0, _lib.parseUnsafeString)(inputCfg.title));
    inputCfg.skipinfo && axis.setSkipInfo(inputCfg.skipinfo);
    inputCfg.offset && axis.setLabelOffset(inputCfg.offset);
    inputCfg.dayinmajor && axis.setDayInMajor(inputCfg.dayinmajor);
    inputCfg.scalemode && axis.setScaleMode(inputCfg.scalemode);
    inputCfg.minspace && axis.setminSpace(inputCfg.minspace);
    typeof inputCfg.stickycontextlabel !== 'undefined' && axis.setStickyContextLabel(inputCfg.stickycontextlabel);
    !isNil(inputCfg.ticksize) && axis.setTickSize(inputCfg.ticksize);
    !isNil(inputCfg.tickpadding) && axis.setTickPadding(inputCfg.tickpadding);
    axis.setDomainLine(inputCfg.domainline);
    axis.setTicksDraw(inputCfg.drawticks);
    !isNil(inputCfg.formatterFn) && axis.setTickFormat(inputCfg);
    inputCfg.outputtimeformat && axis.setTimeFormat(inputCfg.outputtimeformat);
    inputCfg.tickvisibilitylimit && axis.setTickVisibilityLimit(inputCfg.tickvisibilitylimit); // parse user provided styles

    inputCfg.style && axis.parseStyle(inputCfg.style);
    axis.config.validateLabelDimensions = (0, _lib.pluckNumber)(inputCfg.validateLabelDimensions, 0);
  }
  /**
   * merges the style provided by the user with the default style
   *
   * @param {any} [style={}] style provided by the user
   * @memberof Axis
   */
  ;

  _proto.parseStyle = function parseStyle(style) {
    var _axisConfig$style2;

    if (style === void 0) {
      style = {};
    }

    var axis = this,
        axisConfig = axis.config,
        defaultStyle = axisConfig.defaultStyle,
        getStyleDef = axis.getFromEnv('getStyleDef'),
        baseTextStyle = axis.getFromEnv('baseTextStyle'),
        genericLabelStyle = getStyleDef(style.label),
        genericTickStyle = getStyleDef(style['tick-mark']),
        majorTickStyle,
        minorTickStyle,
        majorLabelStyle,
        minorLabelStyle,
        contextLabelStyle;
    majorTickStyle = Object.assign({}, defaultStyle['tick-mark-major'], genericTickStyle, getStyleDef(style['tick-mark-major']));
    minorTickStyle = Object.assign({}, defaultStyle['tick-mark-minor'], genericTickStyle, getStyleDef(style['tick-mark-minor']));
    majorLabelStyle = Object.assign({}, defaultStyle['label-major'], baseTextStyle, genericLabelStyle, getStyleDef(style['label-major']));
    minorLabelStyle = Object.assign({}, defaultStyle['label-minor'], baseTextStyle, genericLabelStyle, getStyleDef(style['label-minor']));
    contextLabelStyle = Object.assign({}, defaultStyle['label-context'], baseTextStyle, genericLabelStyle, getStyleDef(style['label-context']));
    axisConfig.style = (_axisConfig$style2 = {}, _axisConfig$style2[TICKMAJOR] = majorTickStyle, _axisConfig$style2[TICKMINOR] = minorTickStyle, _axisConfig$style2[LABELMAJOR] = majorLabelStyle, _axisConfig$style2[LABELMINOR] = minorLabelStyle, _axisConfig$style2[LABELCONTEXT] = contextLabelStyle, _axisConfig$style2.title = Object.assign({}, defaultStyle.title, baseTextStyle, getStyleDef(style.title)), _axisConfig$style2.line = Object.assign({}, defaultStyle.line, getStyleDef(style.line)), _axisConfig$style2);
  }
  /**
   * Calculates the total space required by axis
   *
   * @returns {Object} space required by the axis
   * @memberof Axis
   */
  ;

  _proto.placeAxis = function placeAxis() {
    var _axisConfig$axisDimen;

    var axis = this,
        axisConfig = axis.config,
        isVertical = axisConfig.isVertical,
        minSpace = (0, _lib.pluckNumber)(axisConfig.minspace, -1),
        scale = axis.getScale(),
        skipInfo = axis.getSkipInfo() || {},
        tickArguments,
        values,
        format,
        padding = axis.getTickPadding(),
        smartLabel = axis.getFromEnv('smartLabel'),
        processedValues = [],
        i,
        len,
        maxLen = 0,
        maxLabelLen = 0,
        tickLen,
        labelDim,
        nameDim,
        axisName = axis.getAxisName(),
        axisNameDim,
        formatter,
        value,
        text,
        fSize,
        tickType,
        tickLabelDimension,
        labelDimAr = [],
        labelHeight,
        contextStyle,
        fontSize,
        overlapBuffer,
        dataSource = axis.getFromEnv('dataSource');
    tickArguments = (axis.getTickArguments() || []).slice(0);
    tickArguments.push(skipInfo);
    tickArguments.push(axisConfig.dayInMajor); // creates ticks

    values = isNil(axis.getTickValues()) ? scale.ticks ? scale.ticks.apply(scale, tickArguments) : scale.getDomain() : axis.getTickValues(); // get formatter

    format = isNil(axis.getTickFormat()) ? scale.tickFormat ? scale.tickFormat.apply(scale, axis.getTickArguments()) : identity : axis.getTickFormat();
    contextStyle = axisConfig.style[LABELCONTEXT];
    smartLabel.setStyle(Object.assign({}, contextStyle));
    fontSize = contextStyle['font-size'] || contextStyle.fontSize;
    axisConfig.labelHeight = parseFloat(fontSize, 10) * 1.2; // If axis name is provided, calculate its space required as well

    if (axisName) {
      smartLabel.setStyle(Object.assign({}, axisConfig.style.title));
      axisNameDim = axisConfig.axisNameDim = smartLabel.getOriSize(axisName, false);
      nameDim = axisNameDim.height;
      maxLen += nameDim;
    }

    tickType = scale._tickType || []; // Space calculations of tick labels

    for (i = 0, len = values.length; i < len; i++) {
      var _processedValues$push;

      value = values[i];
      formatter = getFormatter(scale._timeFormat, tickType, i);
      smartLabel.setStyle(Object.assign({}, axisConfig.style['label-' + (tickType[i] || MAJOR)]));
      text = axisConfig.isVertical ? format.formatFn({
        value: value,
        prefix: format.prefix,
        suffix: format.suffix,
        type: 'axis'
      }, formatter) : format(value, formatter, tickType[i]);
      var timeFormatOnSlider = dataSource.navigator && dataSource.navigator.hourtimeformat ? dataSource.navigator.hourtimeformat : 0;

      if (timeFormatOnSlider === 24 && !axisConfig.timeFormat) {
        var date = new Date(value),
            hours = date.getHours().toString().length === 1 ? '0' + date.getHours().toString() : date.getHours().toString(),
            minutes = date.getMinutes().toString().length === 1 ? '0' + date.getMinutes().toString() : date.getMinutes().toString();
        text = formatter === 'hour' ? hours + ':' + minutes : formatter === 'minute' ? hours + ':' + minutes : text;
      }

      text = (0, _lib.parseUnsafeString)(text); // Find the length of the longest label

      maxLabelLen = mathMax(text.length, maxLabelLen);
      tickLabelDimension = smartLabel.getOriSize(text, false);
      isVertical && (tickLabelDimension.width = axisConfig.vLabelWidth); // tickLabelDimension = isVertical ? smartLabel.getSmartText(bufferText) : smartLabel.getSmartText(text);

      tickLen = axis.getTickSize(tickType[i]);
      processedValues.push((_processedValues$push = {
        text: text,
        value: value,
        dim: tickLabelDimension,
        tickLen: tickLen
      }, _processedValues$push[axisConfig.x] = padding + tickLen, _processedValues$push));
      tickType[i] !== CONTEXT && labelDimAr.push((isVertical ? tickLabelDimension.width : tickLabelDimension.height) + tickLen);
    }

    if (isVertical && isNil(axisConfig.vLabelWidth)) {
      // only executed once during initial render and for y-axus
      axisConfig.vLabelWidth = 0;
      labelDimAr = [];

      for (i = 0, len = values.length; i < len; i++) {
        smartLabel.setStyle(Object.assign({}, axisConfig.style['label-' + (tickType[i] || MAJOR)]));
        fSize = axisConfig.style['label-' + (tickType[i] || MAJOR)]['font-size'];
        fSize = +fSize.toString().split('px')[0]; // get a buffer text based on the longest label and store its width

        tickLabelDimension = smartLabel.getOriSize(text, false);
        tickLabelDimension.width = mathMax(tickLabelDimension.width + LABEL_NAME_WIDTH_BUFFER, minSpace - maxLen);
        processedValues[i].dim = tickLabelDimension;
        axisConfig.vLabelWidth = mathMax(tickLabelDimension.width, axisConfig.vLabelWidth);
        tickType[i] !== CONTEXT && labelDimAr.push((isVertical ? tickLabelDimension.width : tickLabelDimension.height) + tickLen);
      }
    }

    axisConfig.values = processedValues; // Get space required when minor and major label overlaps

    overlapBuffer = axis.getLabelOverlapBuffer(); // Find the max space taken by the labels and the ticks

    labelDim = axisConfig.prevMaxLen = (0, _lib.pluckNumber)((0, _safeMax.default)(labelDimAr), axisConfig.prevMaxLen, 0);
    maxLen += labelDim; // Take space for context tick labels

    labelHeight = isVertical ? 0 : axisConfig.labelHeight;
    axisConfig.maxLabelSpace = maxLen + padding + overlapBuffer + labelHeight; // find the space when tick labels will be placed

    for (i = 0, len = values.length; i < len; i++) {
      value = processedValues[i];

      if (axisConfig.orientation === TOP || axisConfig.orientation === LEFT) {
        value[axisConfig.x] = axisConfig.maxLabelSpace - padding - overlapBuffer - value.tickLen;
      } else {
        value[axisConfig.x] = padding + value.tickLen;
      }
    }

    axisConfig.axisDimension = (_axisConfig$axisDimen = {}, _axisConfig$axisDimen[axisConfig.align] = axisConfig.maxLabelSpace, _axisConfig$axisDimen);
    return axisConfig.axisDimension;
  }
  /**
   * Finds the pixels by which major labels should be shifted so that there is
   * no overlapping between minor and major tick labels
   *
   * @returns {number} pixel by which label will be shifted
   * @memberof Axis
   */
  ;

  _proto.getLabelOverlapBuffer = function getLabelOverlapBuffer() {
    var axis = this,
        axisConfig = axis.config,
        values = axisConfig.values,
        scale = axis.getScale(),
        tickType = scale._tickType || [],
        majorTick,
        minorTick,
        i,
        len,
        overlap = 0,
        dim; // Find a minor and major tick from the list of ticks

    for (i = 0, len = values.length; i < len; i++) {
      if (tickType[i] === MAJOR || !tickType[i]) {
        majorTick = values[i];
      } else if (tickType[i] === MINOR) {
        minorTick = values[i];
      } // when both major and minor tick is found, break


      if (majorTick && minorTick) {
        break;
      }

      ;
    } // If minor tick is available, check for overlap


    if (minorTick) {
      dim = {
        x: minorTick.dim.width,
        y: minorTick.dim.height
      };

      switch (axisConfig.k) {
        case 1:
          overlap = mathMax(minorTick[axisConfig.x] + dim[axisConfig.x] - majorTick[axisConfig.x], 0);
          break;

        case -1:
          overlap = mathMax(majorTick[axisConfig.x] - (minorTick[axisConfig.x] + dim[axisConfig.x]), 0);
          break;
      }
    }

    return axisConfig.overlapBuffer = axisConfig.k * overlap / 3;
  }
  /**
   * makes bbox of label from the configuration of smartlabel and axis range
   *
   * @param {Object} tick tick for which bbox is to be created
   * @returns {Object} bbox of tick label
   * @memberof Axis
   */
  ;

  _proto.makeBBox = function makeBBox(tick, buffer) {
    var _ref;

    if (buffer === void 0) {
      buffer = DEFAULT_LABEL_PADDING;
    }

    var axisConfig = this.config,
        scale = this.getScale(),
        dim = {
      x: tick.dim.width,
      y: tick.dim.height
    };
    return _ref = {}, _ref[axisConfig.x] = tick[axisConfig.x] - buffer - dim[axisConfig.x] / 2, _ref[axisConfig.xInverse] = scale.getRangeValue(tick.value) - buffer - dim[axisConfig.xInverse] / 2, _ref.width = tick.dim.width + buffer, _ref.height = tick.dim.height + buffer, _ref;
  }
  /**
   * Finds the number of minor labels to be skipped
   *
   * @memberof Axis
   */
  ;

  _proto.setMinorSkipIndex = function setMinorSkipIndex() {
    var axis = this,
        axisConfig = axis.config,
        scale = axis.getScale(),
        ticks = axisConfig.values,
        tickType = scale._tickType || [],
        minorTicks = [],
        i,
        j,
        len = ticks.length,
        midPoint,
        startMajorTick,
        endMajorTick,
        startTickBBox,
        endTickBBox,
        curTickBBox,
        midTickBBox,
        start,
        leftSkip = 1,
        rightSkip = 1,
        found = false,
        doesNotOverlap = false; // Take out the minor ticks between the first two major ticks

    for (i = 0; i < len; i++) {
      if (tickType[i] === MAJOR || typeof tickType[i] === _lib.UNDEF) {
        for (j = i + 1; j < len; j++) {
          if (tickType[j] === MAJOR || typeof tickType[j] === _lib.UNDEF) {
            startMajorTick = ticks[i];
            endMajorTick = ticks[j];
            minorTicks = ticks.slice(i + 1, j);
            found = true;
            break;
          }
        }
      }

      if (found) {
        break;
      }
    } // minor ticks are optional, cannot be present in many axis


    if (!minorTicks.length) {
      return;
    }

    len = minorTicks.length;
    start = i; // find midpoint of the minor ticks

    midPoint = floor(len / 2); // major tick on left

    startTickBBox = axis.makeBBox(startMajorTick); // major tick on right

    endTickBBox = axis.makeBBox(endMajorTick); // minor tick in the middle

    midTickBBox = axis.makeBBox(minorTicks[midPoint]); // if the middle minor tick label overlaps with either left or right major tick label, no minor tick
    // labels can be drawn, hence return

    if (overlaps(midTickBBox, startTickBBox) || overlaps(midTickBBox, endTickBBox)) {
      axisConfig.minorSkip = len;
      return;
    } // traverse left. find the first minor tick label which do not overlaps with middle minor tick label
    // leftSkip stores the gap between the middle minor tick label and first minor tick label on the left
    // which do not overlaps


    for (i = midPoint - 1; i >= 0; i--) {
      curTickBBox = axis.makeBBox(minorTicks[i]);

      if (overlaps(curTickBBox, midTickBBox)) {
        continue;
      }

      leftSkip = midPoint - i;
      break;
    } // traverse right. find the first minor tick label which do not overlaps with middle minor tick label
    // leftSkip stores the gap between the middle minor tick label and first minor tick label on the right
    // which do not overlaps


    for (i = midPoint + 1; i < len + start; i++) {
      curTickBBox = axis.makeBBox(minorTicks[i]);

      if (overlaps(curTickBBox, midTickBBox)) {
        continue;
      }

      rightSkip = i - midPoint;
      break;
    }

    len = minorTicks.length; // check for overlap for the rest of the labels

    while (!doesNotOverlap) {
      doesNotOverlap = true;

      for (i = midPoint + rightSkip; i < len; i += rightSkip) {
        if (overlaps(axis.makeBBox(minorTicks[i]), axis.makeBBox(minorTicks[i - rightSkip]))) {
          rightSkip++;
          doesNotOverlap = false;
          break;
        }
      }

      for (i = midPoint - leftSkip; i >= 0; i -= leftSkip) {
        if (overlaps(axis.makeBBox(minorTicks[i]), axis.makeBBox(minorTicks[i + leftSkip]))) {
          leftSkip++;
          doesNotOverlap = false;
          break;
        }
      }
    } // take max of the gaps on the left and right and skip based on it. This ensures symmetrical skipping
    // on both sides


    axisConfig.minorSkip = mathMax(leftSkip, rightSkip);
  }
  /**
   * Clear the minor ticks information whose labels are not to be shown
   *
   * @memberof Axis
   */
  ;

  _proto.cleanseMinorTicks = function cleanseMinorTicks() {
    var _ref2, _ref3;

    var axis = this,
        axisConfig = axis.config,
        scale = axis.getScale(),
        tickType = scale._tickType || [],
        i,
        j,
        len,
        majorTickIndex = [],
        minorTicks,
        minorTicksAr = [],
        midPoint,
        leftPointBBox,
        rightPointBBox,
        curTickBBox,
        ticks = axisConfig.values,
        // equalOverlap,
    leftMax = -1,
        rightMin,
        dim = axisConfig.isVertical ? (_ref2 = {}, _ref2[axisConfig.xInverse] = 'height', _ref2[axisConfig.x] = 'width', _ref2) : (_ref3 = {}, _ref3[axisConfig.xInverse] = 'width', _ref3[axisConfig.x] = 'height', _ref3); // find the major tick indices

    for (i = 0, len = ticks.length; i < len; i++) {
      if (tickType[i] === MAJOR || !tickType[i]) {
        majorTickIndex.push(i);
      }
    }

    for (i = 0, len = majorTickIndex.length; i < len - 1; i++) {
      // for two consecutive major ticks, find the minor ticks in between
      minorTicks = ticks.slice(majorTickIndex[i] + 1, majorTickIndex[i + 1]);
      minorTicksAr.push(minorTicks); // rightMin store the index of the maximum tick label index that can be shown on the right

      rightMin = minorTicks.length; // leftMax store the index of the maximum tick label index that can be shown on the left

      leftMax = -1;

      if (!minorTicks.length) {
        continue;
      } // middle minor tick


      midPoint = floor(minorTicks.length / 2); // major tick on left

      leftPointBBox = axis.makeBBox(ticks[majorTickIndex[i]], 0); // major tick on right

      rightPointBBox = axis.makeBBox(ticks[majorTickIndex[i + 1]], 0);

      for (j = midPoint; j >= 0; j -= 1) {
        curTickBBox = axis.makeBBox(minorTicks[j], 1); // if the minor tick label overlaps with the left major tick, the label and all the labels
        // to its left should not be drawn.

        if (axisConfig.isVertical) {
          if (leftPointBBox[axisConfig.xInverse] <= curTickBBox[axisConfig.xInverse] + curTickBBox[dim[axisConfig.xInverse]]) {
            leftMax = mathMax(leftMax, j);
            break;
          }
        } else {
          if (curTickBBox[axisConfig.xInverse] <= leftPointBBox[axisConfig.xInverse] + leftPointBBox[dim[axisConfig.xInverse]]) {
            leftMax = mathMax(leftMax, j);
            break;
          }
        }
      }

      for (j = midPoint; j < minorTicks.length; j += 1) {
        curTickBBox = axis.makeBBox(minorTicks[j], 1); // if the minor tick label overlaps with the right major tick, the label and all the labels
        // to its right should not be drawn.

        if (axisConfig.isVertical) {
          if (rightPointBBox[axisConfig.xInverse] + rightPointBBox[dim[axisConfig.xInverse]] >= curTickBBox[axisConfig.xInverse]) {
            rightMin = Math.min(rightMin, j);
            break;
          }
        } else {
          if (curTickBBox[axisConfig.xInverse] + curTickBBox[dim[axisConfig.xInverse]] >= rightPointBBox[axisConfig.xInverse]) {
            rightMin = Math.min(rightMin, j);
            break;
          }
        }
      } // equalOverlap = mathMax(leftMax + 1, minorTicks.length - rightMin);
      // leftMax = -1 + equalOverlap;
      // rightMin = minorTicks.length - equalOverlap;
      // reset minor ticks information based on the following criteria:
      // 1. minor tick label overlaps with the major ticks
      // 2. minor tick label overlaps with the adjacent labels


      for (j = 0; j < minorTicks.length; j++) {
        if (j <= leftMax || j >= rightMin || Math.abs(midPoint - j) % axisConfig.minorSkip) {
          resetTickInfo(minorTicks[j]);
        }
      }
    }
  }
  /**
   * Clear the major ticks information whose labels are not to be shown
   *
   * @memberof Axis
   */
  ;

  _proto.cleanseMajorTicks = function cleanseMajorTicks() {
    var axis = this,
        axisConfig = axis.config,
        scale = axis.getScale(),
        values = axisConfig.values,
        majorTickAr = [],
        majorTickIndexAr = [],
        contextTickAr = [],
        contextTickIndexAr = [],
        tickType = scale._tickType || [],
        startIndex = 0,
        leftSkip = 1,
        rightSkip = 1,
        curTickBBox,
        majorSkip,
        i,
        len,
        doesNotOverlap = false;
    len = values.length;

    if (!len) {
      return;
    } // find all the major ticks from the ticks array


    for (i = 0; i < len; i++) {
      if (tickType[i] === MAJOR || !tickType[i]) {
        majorTickAr.push(values[i]);
        majorTickIndexAr.push(i);
      } else if (tickType[i] === CONTEXT) {
        contextTickAr.push(values[i]);
        contextTickIndexAr.push(i);
      }
    }
    /**
     * startIndex will be used to iterate the majorticks. Two cases can arise:
     * 1. When context tick is present: On any condition this tick label has to be shown(unless the font size is garbage)
     * 2. When context tick is not present: start from the 0 index and look for overlaps.
     *
     * startIndex stores the index of context label when context tick is present, else 0
     */


    if (contextTickIndexAr.length) {
      for (i = 0, len = majorTickAr.length; i < len; i++) {
        if (+contextTickAr[0].value === +majorTickAr[i].value) {
          startIndex = i;
        }
      }
    } else {
      startIndex = 0;
    } // Take the tick label at the startIndex of majorTickAr to calculate rest.
    // Lets call it context tick label


    curTickBBox = axis.makeBBox(majorTickAr[0]); // traverse right. look for the first major label on the right which do not overlap with context tick label

    for (i = startIndex + 1, len = majorTickAr.length; i < len; i++) {
      if (!overlaps(axis.makeBBox(majorTickAr[i]), curTickBBox)) {
        rightSkip = i - startIndex;
        break;
      }
    } // traverse left. look for the first major label on the left which do not overlap with context tick label


    for (i = startIndex - 1; i >= 0; i--) {
      if (!overlaps(axis.makeBBox(majorTickAr[i]), curTickBBox)) {
        leftSkip = startIndex - i;
        break;
      }
    }

    while (!doesNotOverlap) {
      doesNotOverlap = true;

      for (i = startIndex + rightSkip; i < len; i += rightSkip) {
        if (overlaps(axis.makeBBox(majorTickAr[i]), axis.makeBBox(majorTickAr[i - rightSkip]))) {
          rightSkip++;
          doesNotOverlap = false;
          break;
        }
      }

      for (i = startIndex - leftSkip; i >= 0; i -= rightSkip) {
        if (overlaps(axis.makeBBox(majorTickAr[i]), axis.makeBBox(majorTickAr[i + leftSkip]))) {
          leftSkip++;
          doesNotOverlap = false;
          break;
        }
      }
    } // take the maximum gap between the labels on left and right, to decide number of labels to be skipped.


    axisConfig.majorSkip = majorSkip = mathMax(leftSkip, rightSkip); // reset information of all the ticks which are to be skipped.

    for (i = 0, len = majorTickAr.length; i < len; i++) {
      if (Math.abs(i - startIndex) % majorSkip) {
        resetTickInfo(majorTickAr[i]);
      }
    }
  }
  /**
   * Drawing of ticks and labels
   *
   * @memberof Axis
   */
  ;

  _proto.draw = function draw() {
    var axis = this,
        axisConfig = axis.config,
        chartConfig = axis.getFromEnv('chart').config,
        scale = axis.getScale(),
        parent = axis.getLinkedParent(),
        tickType = scale._tickType || [],
        position = (scale.getBandwidth ? center : number)(scale),
        range = scale.getRange(),
        domain = scale.getDomain(),
        range0 = Number(range[0]),
        range1 = Number(range[range.length - 1]),
        orientation = axis.getOrientation(),
        smartLabel = axis.getFromEnv('smartLabel'),
        values = axisConfig.values,
        lineOffset = orientation === LEFT || orientation === TOP ? axisConfig.maxLabelSpace + GUTTER_2 : 0,
        isVertical = axisConfig.isVertical,
        orient = axisConfig.orientation,
        xInverse = axisConfig.xInverse,
        x = axisConfig.x,
        k = axisConfig.k,
        style = axisConfig.style; // Container group for the axis

    axis.addGraphicalElement({
      el: 'group',
      attr: {
        name: "meso-axis",
        transform: axisConfig.groupTranslation
      },
      container: {
        id: 'meso',
        label: 'group',
        isParent: true
      },
      id: 'meso-axis',
      component: axis,
      label: 'group'
    }); // Group that will contain the ticks and labels

    axis.addGraphicalElement({
      el: 'group',
      attr: {
        name: "axis-" + orient
      },
      container: {
        id: 'meso-axis',
        label: 'group'
      },
      id: 'axisGroup',
      component: axis,
      label: 'group'
    });
    var tickValue,
        type,
        axisName,
        axisNameDim,
        xpos,
        ypos,
        index,
        len,
        value,
        majorTickIndex = [],
        majorTickIndexIterator,
        lMajor,
        rMajor,
        contextTickCount = 0,
        visibilityLimit = axis.getTickVisibilityLimit(),
        firstMajorTick,
        textAnchor,
        fontSize,
        linePath,
        tickPath,
        labelDim; // Skipping of minor ticks

    axis.setMinorSkipIndex();
    axis.cleanseMinorTicks(); // skipping of major ticks

    axis.cleanseMajorTicks();

    if (linePath = axis.getDomainLine()) {
      // draws the axis line
      axis.addGraphicalElement({
        el: 'path',
        attr: {
          path: linePath,
          stroke: '#d6d6d6',
          fill: 'none',
          'stroke-width': 2
        },
        container: {
          id: 'axisGroup',
          label: 'group',
          isParent: false
        },
        css: style.line,
        component: axis,
        label: 'path'
      });
    } // draw axis name


    if (axisName = axis.getAxisName()) {
      // find the lineHeight @todo remove after creating an API for this in smartlabel
      fontSize = parseFloat(axisConfig.style.title['font-size'] || axisConfig.style.title.fontSize, 10);
      smartLabel.setStyle(Object.assign({}, axisConfig.style.title));
      axisNameDim = smartLabel.getSmartText(axisName, Math.abs(range0 - range1), fontSize * 1.2); // calculation for vertical and horizontal axis

      if (isVertical) {
        xpos = orientation === LEFT ? 0 + axisNameDim.height / 2 : axisConfig.maxLabelSpace - axisNameDim.height / 2;
        ypos = (range0 - range1) / 2;
      } else {
        xpos = (range1 - range0) / 2;
        ypos = orientation === TOP ? 0 + axisNameDim.height / 2 : axisConfig.maxLabelSpace - axisNameDim.height / 2;
      }

      axis.addGraphicalElement({
        el: 'text',
        attr: {
          text: axisNameDim.text,
          x: xpos,
          y: ypos,
          opacity: style.title.opacity,
          'text-anchor': 'middle',
          transform: isVertical ? (0, _lib.getSuggestiveRotation)(k * DEFAULT_ROTATION, xpos, ypos) : DEFAULT_TRANSFORM
        },
        container: {
          id: 'axisGroup',
          label: 'group',
          isParent: false
        },
        tooltext: chartConfig.showTooltip ? axisNameDim.tooltext : _lib.UNDEF,
        css: style.title,
        component: axis,
        id: 'axis-name',
        label: 'name'
      });
    } // Drawing of axis ticks and axis labels


    if (axis.getTicksDraw()) {
      // find number of context ticks
      contextTickCount = tickType.length - tickType.indexOf(CONTEXT); // find the first major tick

      firstMajorTick = axisConfig.values.find(function (tick, pos) {
        return tick.value >= domain[0] && tick.value <= domain[1] && tickType[pos] === MAJOR;
      }); // fetch all the major ticks of time axis

      for (index = 0, len = values.length; index < len; index++) {
        if (tickType[index] === MAJOR) {
          if (values[index].value >= domain[0] && values[index].value <= domain[1]) {
            values[index][xInverse] = position(values[index].value);
          }

          majorTickIndex.push(index);
        }
      }

      lMajor = majorTickIndex[0];
      rMajor = majorTickIndex[1];
      majorTickIndexIterator = 2;

      for (index = 0, len = axisConfig.values.length; index < len; index++) {
        var _labelDim;

        value = axisConfig.values[index];
        type = tickType[index] || MAJOR; // if tick is without label then no need to draw it in x axis

        if (!isVertical && value.text.length === 0) {
          continue;
        } // for all non-context ticks, if ticks are outside visible domain, skip it


        if (type !== CONTEXT && (value.value < domain[0] || value.value > domain[1])) {
          continue;
        } // for context ticks, two conditions are possible
        // 1. when only one context tick is present, draw it.
        // 2. If more than 1 context ticks are present, show context labels present in visible domain


        if (type === CONTEXT && contextTickCount > 1 && (value.value < domain[0] || value.value > domain[1])) {
          continue;
        } // limit the context ticks to the left most point of the x-axis when stickyContextLabel is enabled,
        // Else, context label will be placed with the first major tick


        if (type === CONTEXT && contextTickCount === 1) {
          value[xInverse] = axis.getStickyContextLabel() || typeof firstMajorTick === 'undefined' ? mathMax(position(value.value), value.dim.width / 2) : position(firstMajorTick.value);
        } else {
          value[xInverse] = value[xInverse] || position(value.value);
        }

        if (index >= rMajor) {
          lMajor = rMajor;
          rMajor = majorTickIndex[majorTickIndexIterator];
          majorTickIndexIterator++;
        } // @todo: bring up tick skipping logic here from scale.
        // only for x axis


        if (type === MINOR && !isVertical && (value[xInverse] - values[lMajor][xInverse] < MAX_ALLOWED_SPACE || values[rMajor][xInverse] - value[xInverse] < MAX_ALLOWED_SPACE)) {
          continue;
        } // value[xInverse] = (type === CONTEXT && (axis.getStickyContextLabel() || firstMajorTick === -1)) ? mathMax(position(value.value), 0) : position(firstMajorTick.value);
        // alignDiff is the difference between the actual width and alloted width.


        value[x] += axisConfig.alignDiff;
        tickValue = value.value; // Create the group

        axis.addGraphicalElement({
          container: {
            id: 'axisGroup',
            label: 'group',
            isParent: false
          },
          attr: {
            name: 'tick',
            transform: axisConfig.translate(value[xInverse])
          },
          data: {
            value: tickValue
          },
          el: 'group',
          id: 'tick-group-' + index,
          component: this,
          label: 'group'
        }); // Create ticks for minor and major intervals

        if (type !== CONTEXT) {
          tickPath = isVertical ? "M " + lineOffset + " 0 H " + (lineOffset + k * axis.getTickSize(tickType[index])) : "M 0 " + lineOffset + " V " + (lineOffset + k * axis.getTickSize(tickType[index]));
          axis.addGraphicalElement({
            el: 'path',
            attr: {
              path: tickPath
            },
            container: {
              id: 'tick-group-' + index,
              label: 'group',
              isParent: false
            },
            id: 'tick-' + index,
            css: style['tick-mark-' + (type || MAJOR)],
            component: axis,
            label: 'path'
          });
        }

        textAnchor = style['label-' + (type || MAJOR)]['text-anchor'] || getTextAnchor(orientation);
        labelDim = (_labelDim = {}, _labelDim[xInverse] = value[xInverse] + axisConfig[xInverse + 'Offset'], _labelDim[x] = value[x] + axisConfig[x + 'Offset'] + (type !== MINOR ? axisConfig.overlapBuffer : 0), _labelDim);

        if (!axisConfig.validateLabelDimensions || isWithinDomain(value.dim, textAnchor, labelDim, parent.getDimension())) {
          var _attr;

          if (!isWithinVisibleRange(value.value, visibilityLimit) && type !== CONTEXT) {
            continue;
          }

          if (type === CONTEXT && typeof visibilityLimit.start === 'undefined') {
            continue;
          } // Create tick labels


          axis.addGraphicalElement({
            el: 'text',
            attr: (_attr = {
              text: value.text + ''
            }, _attr[xInverse] = 0 + axisConfig[xInverse + 'Offset'], _attr[x] = value[x] + axisConfig[x + 'Offset'] + (type !== MINOR ? axisConfig.overlapBuffer : 0), _attr['text-anchor'] = textAnchor, _attr['vertical-align'] = orient === TOP ? 'bottom' : orient === BOTTOM ? 'top' : 'middle', _attr.opacity = style['label-' + (type || MAJOR)].opacity, _attr),
            container: {
              id: 'tick-group-' + index,
              label: 'group',
              isParent: false
            },
            component: axis,
            id: 'tick-label-' + index,
            css: style['label-' + (type || MAJOR)],
            label: 'text'
          });
        }
      }
    }
  }
  /**
   * Updates the max space taken by the axis. This is feature is required to sync
   * the horizontal positioning of y-axis names in multivariate
   *
   * @param {Number} newDim new space to be alloted. Always greater than or equal to the actual space.
   * @returns {Object} object containing alignment and dimension
   * @memberof Axis
   */
  ;

  _proto.updateMaxLabelSpace = function updateMaxLabelSpace(newDim) {
    var axis = this,
        axisConfig = axis.config,
        align = axis.getAlignment(); // calculate the diff between the new dimension and actual dimension. This is diff is used to place
    // ticks and label in proper place

    axisConfig.alignDiff = newDim - axisConfig.maxLabelSpace; // update the maxLabelSpace(total space taken by the axis)

    axisConfig.maxLabelSpace = axisConfig.axisDimension[align] = newDim;
    return axisConfig.axisDimension;
  };

  _proto.setDayInMajor = function setDayInMajor(dayInMajor) {
    this.config.dayInMajor = dayInMajor;
  }
  /**
   * setter method for skipInfo. skipInfo contains information about the type of ticks that
   * are to be skipped
   *
   * @param {any} [info={}] Object containing the skipping information
   * @memberof Axis
   */
  ;

  _proto.setSkipInfo = function setSkipInfo(info) {
    if (info === void 0) {
      info = {};
    }

    this.config.tickInfo = info;
  }
  /**
   * getter method for skipInfo
   *
   * @returns {Object} returns skipInfo
   * @memberof Axis
   */
  ;

  _proto.getSkipInfo = function getSkipInfo() {
    return this.config.tickInfo;
  }
  /**
   * setter method for stickyContextLabel attribute
   *
   * @param {boolean} [flag=true] value of the attribute
   * @memberof Axis
   */
  ;

  _proto.setStickyContextLabel = function setStickyContextLabel(flag) {
    if (flag === void 0) {
      flag = true;
    }

    this.config.stickyContextLabel = flag;
  }
  /**
   * getter method for stickyContextLabel attribute
   *
   * @returns {boolean} value of stickyContextLabel attribute
   * @memberof Axis
   */
  ;

  _proto.getStickyContextLabel = function getStickyContextLabel() {
    return this.config.stickyContextLabel;
  }
  /**
   * setter method for labelnamespace attribute
   *
   */
  ;

  _proto.setminSpace = function setminSpace(minspace) {
    this.config.minspace = minspace;
  }
  /**
   Getter Method for labelnamespace
   */
  ;

  _proto.getminSpace = function getminSpace() {
    return this.config.minspace;
  }
  /**
   * An offset to labels can be provided to shift the labels as and when required
   *
   * @param {any} [offset={}] Object containing the xOffset and yOffset values
   * @memberof Axis
   */
  ;

  _proto.setLabelOffset = function setLabelOffset(offset) {
    if (offset === void 0) {
      offset = {};
    }

    var axisConfig = this.config;
    axisConfig.xOffset = (0, _lib.pluckNumber)(offset.x, 0);
    axisConfig.yOffset = (0, _lib.pluckNumber)(offset.y, 0);
  }
  /**
   * getter method for label offset
   *
   * @returns {Object} object containing the x and y offset
   * @memberof Axis
   */
  ;

  _proto.getLabelOffset = function getLabelOffset() {
    return {
      x: this.config.xOffset,
      y: this.config.yOffset
    };
  }
  /**
   * returns name of axis
   *
   * @returns {string} name of axis
   * @memberof Axis
   */
  ;

  _proto.getAxisName = function getAxisName() {
    return this.config.axisName;
  }
  /**
   * sets name of axis
   *
   * @param {string} [name=''] name of the axis
   * @memberof Axis
   */
  ;

  _proto.setAxisName = function setAxisName(title) {
    if (title === void 0) {
      title = '';
    }

    this.config.axisName = title;
  }
  /**
   * getter method of axis alignment
   *
   * @returns {any} axis alignment
   * @memberof Axis
   */
  ;

  _proto.getAlignment = function getAlignment() {
    return this.config.align;
  }
  /**
   * sets alignment of axis
   *
   * @param {any} align alignment
   * @memberof Axis
   */
  ;

  _proto.setAlignment = function setAlignment(align, overlap) {
    if (overlap === void 0) {
      overlap = false;
    }

    var axis = this,
        axisConfig = axis.config,
        orientation,
        isVertical; // calculate orientation based on the value of align and overlap

    switch (align) {
      case LEFT:
        orientation = overlap ? RIGHT : LEFT;
        break;

      case RIGHT:
        orientation = overlap ? LEFT : RIGHT;
        break;

      case TOP:
        orientation = overlap ? BOTTOM : TOP;
        break;

      case BOTTOM:
        orientation = overlap ? TOP : BOTTOM;
        break;
    }

    axisConfig.align = align;
    axisConfig.orientation = orientation;
    axisConfig.isVertical = isVertical = align === LEFT || align === RIGHT;
    axisConfig.k = orientation === LEFT || orientation === TOP ? -1 : 1;
    axisConfig.x = isVertical ? X : Y;
    axisConfig.xInverse = isVertical ? Y : X;
    axisConfig.translate = isVertical ? translateY : translateX;
    axisConfig.translateInverse = isVertical ? translateX : translateY;
  }
  /**
   * getter method for orientation
   *
   * @returns {string} orientation
   * @memberof Axis
   */
  ;

  _proto.getOrientation = function getOrientation() {
    return this.config.orientation;
  }
  /**
   * sets the translation of axis
   *
   * @param {number} [x=0] x position
   * @param {number} [y=0] y position
   * @memberof Axis
   */
  ;

  _proto.setTranslation = function setTranslation(x, y) {
    if (x === void 0) {
      x = 0;
    }

    if (y === void 0) {
      y = 0;
    }

    this.config._translatedX = x;
    this.config._translatedY = y;
    this.config.groupTranslation = "t" + x + ", " + y;
  }
  /**
   * getter method for translation
   *
   * @returns {Object} translation
   * @memberof Axis
   */
  ;

  _proto.getTranslation = function getTranslation() {
    return {
      x: this.config._translatedX,
      y: this.config._translatedY
    };
  }
  /**
   * setter method for domainline
   *
   * @param {boolean} [flag=true] whether domainline will be shown
   * @returns {Object} instance of this class
   * @memberof Axis
   */
  ;

  _proto.setDomainLine = function setDomainLine(flag) {
    if (flag === void 0) {
      flag = true;
    }

    this.config.drawDomainLine = flag;
    return this;
  }
  /**
   * calculates the path for axis line and returns it
   *
   * @returns {string} path string of axis line
   * @memberof Axis
   */
  ;

  _proto.getDomainLine = function getDomainLine() {
    var axis = this,
        axisConfig = axis.config,
        scale = axis.getScale(),
        range = scale.getRange(),
        isVertical = axisConfig.isVertical,
        orientation = axisConfig.orientation,
        maxLabelSpace = axisConfig.maxLabelSpace,
        lineOffset,
        start = +range[0],
        end = +range[1],
        path;

    if (axisConfig.drawDomainLine) {
      lineOffset = orientation === LEFT || orientation === TOP ? maxLabelSpace + GUTTER_2 : 0;

      if (isVertical) {
        path = "M " + lineOffset + " " + start + " V " + end;
      } else {
        path = "M " + start + " " + lineOffset + " H " + end;
      }
    }

    return path;
  };

  _proto.setTicksDraw = function setTicksDraw(flag) {
    if (flag === void 0) {
      flag = true;
    }

    this.config.drawTicks = flag;
    return this;
  };

  _proto.getTicksDraw = function getTicksDraw() {
    return this.config.drawTicks;
  };

  _proto.setScale = function setScale(scale) {
    this.config.scale = scale;
  };

  _proto.getScale = function getScale() {
    return this.config.scale;
  };

  _proto.setReverse = function setReverse(isReverse) {
    this.config.isReverse = isReverse;
  };

  _proto.getReverse = function getReverse() {
    return this.config.isReverse;
  };

  _proto.setTickArguments = function setTickArguments() {
    for (var _len = arguments.length, tickArgs = new Array(_len), _key = 0; _key < _len; _key++) {
      tickArgs[_key] = arguments[_key];
    }

    this.config.tickArguments = tickArgs;
    return this;
  };

  _proto.getTickArguments = function getTickArguments() {
    return this.config.tickArguments.slice();
  };

  _proto.setTickSize = function setTickSize(size) {
    this.config.tickSizeOuter = Number(size);
    this.config.tickSizeInner = this.config.tickSizeOuter * (2 / 3);
    return this;
  }
  /**
   * Returns the tick size corresponding to the tick type
   *
   * @param {any} [type=MAJOR] type of tick
   * @returns {number} tick size
   * @memberof Axis
   */
  ;

  _proto.getTickSize = function getTickSize(type) {
    if (type === void 0) {
      type = MAJOR;
    }

    var axisConfig = this.config;

    switch (type) {
      case CONTEXT:
        return axisConfig.tickSizeOuter + axisConfig.labelHeight;

      case MINOR:
        return axisConfig.tickSizeInner;

      case MAJOR:
        return axisConfig.tickSizeOuter;
    }
  };

  _proto.setTickPadding = function setTickPadding(padding) {
    this.config.tickPadding = Number(padding);
    return this;
  };

  _proto.getTickPadding = function getTickPadding() {
    return this.config.tickPadding;
  };

  _proto.setTickValues = function setTickValues(tickValues) {
    this.config.tickValues = isNil(tickValues) ? null : tickValues.slice();
    return this;
  };

  _proto.getTickValues = function getTickValues() {
    return this.config.tickValues && this.config.tickValues.slice();
  };

  _proto.setTickFormat = function setTickFormat(inputObj) {
    this.config.tickFormat = {
      formatFn: inputObj.formatterFn,
      prefix: inputObj.formatLabelPrefix,
      suffix: inputObj.formatLabelSuffix
    };
    return this;
  };

  _proto.getTickFormat = function getTickFormat() {
    return this.config.tickFormat;
  };

  _proto.getAxisEndLabelDisplaySpace = function getAxisEndLabelDisplaySpace() {
    var chartTop = 0,
        chartLeft = 0,
        chartRight = +this.getFromEnv('chartWidth'),
        chartBottom = +this.getFromEnv('chartHeight'),
        values = this.config.values,
        isReverse = this.getReverse(),
        isVertical = this.config.isVertical,
        space = {};
    var valueLeft, valueRight, valueTop, valueBottom;

    if (isVertical) {
      valueTop = isReverse ? values[values.length - 1] : values[0];
      valueBottom = isReverse ? values[0] : values[values.length - 1];
      space.top = chartTop - Math.min(chartTop, valueTop.y - valueTop.dim.height);
      space.bottom = mathMax(valueBottom.y + valueBottom.dim.height, chartBottom) - chartBottom;
    } else {
      valueLeft = isReverse ? values[values.length - 1] : values[0];
      valueRight = isReverse ? values[0] : values[values.length - 1];
      space.left = chartLeft - Math.min(chartLeft, valueLeft.x - valueLeft.dim.width);
      space.right = mathMax(valueRight.x + valueRight.dim.width, chartRight) - chartRight;
    }

    return space;
  };

  _proto.getDimension = function getDimension() {
    return this.config.axisDimension;
  };

  _proto.setDimension = function setDimension(dim) {
    return this.placeAxis(dim);
  }
  /**
   * setter method for scale mode
   *
   * @param {any} mode mode in which ticks will be calculated
   * @memberof Axis
   */
  ;

  _proto.setScaleMode = function setScaleMode(mode) {
    this.config.scale.setMode(mode);
  }
  /**
   * getter method for scale mode
   *
   * @returns {String} mode
   * @memberof Axis
   */
  ;

  _proto.getScaleMode = function getScaleMode() {
    return this.config.scale.getMode();
  }
  /**
   * setter API for time format in time scale
   *
   * @param {Object} format
   * @memberof Axis
   */
  ;

  _proto.setTimeFormat = function setTimeFormat(format) {
    var axisConfig = this.config,
        scale = axisConfig.scale;
    axisConfig.timeFormat = format;
    scale.setTimeFormat && scale.setTimeFormat(format);
  }
  /**
   * getter API for time format
   *
   * @memberof Axis
   */
  ;

  _proto.getTimeFormat = function getTimeFormat() {
    return this.config.timeFormat;
  };

  _proto.setTickVisibilityLimit = function setTickVisibilityLimit(limit) {
    this.config.tickVisibilityLimit = _objectSpread({}, limit);
  };

  _proto.getTickVisibilityLimit = function getTickVisibilityLimit() {
    return this.config.tickVisibilityLimit;
  };

  return Axis;
}(_componentInterface.SmartRenderer);

var _default = Axis;
exports["default"] = _default;

/***/ }),

/***/ 958:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _componentInterface = __webpack_require__(290);

var Background = /*#__PURE__*/function (_SmartRenderer) {
  (0, _inheritsLoose2.default)(Background, _SmartRenderer);

  function Background() {
    return _SmartRenderer.apply(this, arguments) || this;
  }

  var _proto = Background.prototype;

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    this.config.backgroundCss = {
      fill: '#ffffff'
    };
  }
  /**
   * configures the caption component
   *
   * @param {any} [options={}] options used to configure
   * @memberof Caption
   */
  ;

  _proto.configureAttributes = function configureAttributes(options) {
    if (options === void 0) {
      options = {};
    }

    _SmartRenderer.prototype.configureAttributes.call(this, options);

    var background = this,
        config = background.config,
        chartAttr = background.getFromEnv('chart-attrib'),
        backgroundStyle = chartAttr.style && chartAttr.style.background;
    Object.keys(options).forEach(function (key) {
      return config[key] = options[key];
    });
    config.backgroundCss = Object.assign(config.backgroundCss, background.getFromEnv('getStyleDef')(backgroundStyle));
  };

  _proto.setDimension = function setDimension(dim) {
    if (dim === void 0) {
      dim = {};
    }

    Object.assign(this.config, dim);
  };

  _proto.draw = function draw() {
    var background = this,
        config = background.config;
    background.addGraphicalElement({
      el: 'rect',
      attr: {
        x: 0,
        y: 0,
        height: config.height,
        width: config.width,
        transform: config.translate,
        opacity: config.backgroundCss.opacity
      },
      container: {
        id: 'tropo',
        label: 'group',
        isParent: true
      },
      css: config.backgroundCss,
      component: background,
      id: 'background',
      label: 'rect'
    });
  };

  return Background;
}(_componentInterface.SmartRenderer);

var _default = Background;
exports["default"] = _default;

/***/ }),

/***/ 965:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _componentInterface = __webpack_require__(290);

var _lib = __webpack_require__(274);

var SCALE = 'scale',
    DRAGSTART = 'timeNavBrushStart',
    DRAGEND = 'timeNavBrushEnd',
    DRAG = 'timeNavBrush',
    UP = 'up',
    DOWN = 'down',
    LABELFORMAT = '%b %d, %Y';

var Handle = /*#__PURE__*/function (_SmartRenderer) {
  (0, _inheritsLoose2.default)(Handle, _SmartRenderer);

  function Handle() {
    var _this;

    _this = _SmartRenderer.call(this) || this;
    _this._dimensions = {};
    return _this;
  }

  var _proto = Handle.prototype;

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    _SmartRenderer.prototype.__setDefaultConfig.call(this);

    var config = this.config;
    config._defaultHandleStyle = {
      fill: '#dfdfdf',
      stroke: 'none',
      cursor: 'ew-resize'
    };
    config._defaultHandleGripStyle = {
      cursor: 'ew-resize',
      stroke: '#808080',
      'stroke-width': 1,
      'stroke-linecap': 'round'
    };
  };

  _proto.configureAttributes = function configureAttributes(obj) {
    if (obj === void 0) {
      obj = {};
    }

    _SmartRenderer.prototype.configureAttributes.call(this, obj);

    var handle = this,
        handleConfig = handle.config;
    handleConfig.style = {
      handle: Object.assign({}, handleConfig._defaultHandleStyle, obj.style.handle),
      'handle-grip': Object.assign({}, handleConfig._defaultHandleGripStyle, obj.style['handle-grip'])
    };
    handleConfig.orientation = obj.orientation;
    handleConfig.type = obj.type;
  }
  /**
   * Method that sets the dimension of handle.
   * @param {Object} dim dimension
   */
  ;

  _proto.setDimension = function setDimension(dim) {
    this._dimensions = dim;
  }
  /**
   * Method to get the dimension of handle.
   * @return {Object} dimension
   */
  ;

  _proto.getDimension = function getDimension() {
    return this._dimensions;
  }
  /**
   * Method that attaches respective handlers on brush component.
   */
  ;

  _proto.attachHandlers = function attachHandlers() {
    var handle = this,
        brush = handle.getLinkedParent(),
        timeNav = brush.getFromEnv('timeNavigator'),
        timeNavConfig = timeNav.config,
        chart = handle.getFromEnv('chart'),
        currFocusLimit,
        brushDim,
        lastX,
        clampDirection,
        startX,
        // startY,
    offsetX,
        startPx,
        endPx,
        options = {
      timeFormatter: timeNavConfig.formatter
    },
        forceFireOptions = Object.assign({
      forceFire: true
    }, options),
        eventArgs = {
      formatter: LABELFORMAT,
      action: SCALE
    }; // offsetY;
    // attach dragstart event.

    handle.addEventListener('fc-dragstart', handle.dragstartHandler || (handle.dragstartHandler = function (e) {
      startX = (0, _lib.getTouchEvent)(e).clientX;
      lastX = 0;
      brushDim = brush.getCurrentBrushDimensions();
      currFocusLimit = chart.getFocusLimit();
      chart.getFromEnv('fireChartEvents')(DRAGSTART, [+currFocusLimit[0], +currFocusLimit[1]], eventArgs, forceFireOptions);
    })); // attach dragmove event

    handle.addEventListener('fc-dragmove', handle.dragmoveHandler || (handle.dragmoveHandler = function (e) {
      offsetX = (0, _lib.getTouchEvent)(e).clientX - startX;
      clampDirection = offsetX >= lastX ? UP : DOWN;
      lastX = offsetX; // offsetY = e.originalEvent.clientY - startY;
      // perform operations based on the type of handle.

      if (handle.config.type === 'leftHandle') {
        startPx = brushDim.x + offsetX;
        endPx = brushDim.x + brushDim.width;
      } else {
        startPx = brushDim.x;
        endPx = brushDim.x + brushDim.width + offsetX;
      }

      handle.getFromEnv('animationManager').setAnimationState('timenavSqueeze');
      timeNav.validateDomain([startPx, endPx], [clampDirection, clampDirection], {
        eventName: DRAG,
        eventArgs: eventArgs,
        options: options
      });
    })); // attach dragend event.

    handle.addEventListener('fc-dragend', handle.dragendHandler || (handle.dragendHandler = function (e) {
      currFocusLimit = chart.getFocusLimit();
      chart.getFromEnv('fireChartEvents')(DRAGEND, [+currFocusLimit[0], +currFocusLimit[1]], eventArgs, forceFireOptions);
    }));
  };

  _proto.draw = function draw() {
    var handle = this,
        handleConfig = handle.config,
        handleStyle = handleConfig.style.handle,
        handleGripStyle = handleConfig.style['handle-grip'],
        handleDimensions = handle.getDimension(),
        startX = handleDimensions.x,
        startY = handleDimensions.y,
        width = handleDimensions.width,
        height = handleDimensions.height; // @todo- mind the orientation
    // handle button

    handle.addGraphicalElement({
      el: 'rect',
      attr: {
        x: startX,
        y: startY,
        width: width,
        height: height,
        opacity: handleStyle.opacity
      },
      css: handleStyle,
      label: 'handleButton',
      component: handle,
      container: {
        id: 'brushGroup',
        label: 'brushGroup',
        isParent: true
      }
    }); // handle path

    handle.addGraphicalElement({
      el: 'path',
      attr: {
        path: "M " + (startX + 3.5) + "," + (startY + 6) + " v " + (height - 12) + "\n               M " + (startX + 6.5) + "," + (startY + 6) + " v " + (height - 12)
      },
      label: 'handlePath',
      component: handle,
      css: handleGripStyle,
      container: {
        id: 'brushGroup',
        label: 'brushGroup',
        isParent: true
      }
    });
  };

  return Handle;
}(_componentInterface.SmartRenderer);

var _default = Handle;
exports["default"] = _default;

/***/ }),

/***/ 964:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _componentInterface = __webpack_require__(290);

var _handle = _interopRequireDefault(__webpack_require__(965));

var _label = _interopRequireDefault(__webpack_require__(966));

var _selection = _interopRequireDefault(__webpack_require__(967));

var Brush = /*#__PURE__*/function (_SmartRenderer) {
  (0, _inheritsLoose2.default)(Brush, _SmartRenderer);

  function Brush() {
    var _this;

    _this = _SmartRenderer.call(this) || this;
    _this._maxDimensions = {};
    _this._currDimensions = {};
    return _this;
  }

  var _proto = Brush.prototype;

  _proto.__setDefaultConfig = function __setDefaultConfig(obj) {
    if (obj === void 0) {
      obj = {};
    }

    _SmartRenderer.prototype.__setDefaultConfig.call(this, obj);

    var config = this.config; // set default dimensions of itself and its child.

    config.handleWidth = 12;
    config.handleHeight = 20;
  };

  _proto.configureAttributes = function configureAttributes(obj) {
    if (obj === void 0) {
      obj = {};
    }

    _SmartRenderer.prototype.configureAttributes.call(this, obj);

    var brush = this;
    brush.config.style = obj.style;
    brush.createChildComponents();
  }
  /**
   * Method that sets dimensions of its child components
   */
  ;

  _proto.setChildDimension = function setChildDimension() {
    var brush = this,
        selfConfig = brush.config,
        selection = brush.getChildren('selection')[0],
        leftHandle = brush.getChildren('leftHandle')[0],
        rightHandle = brush.getChildren('rightHandle')[0],
        leftLabel = brush.getChildren('leftLabel')[0],
        rightLabel = brush.getChildren('rightLabel')[0],
        currDimension = brush.getCurrentBrushDimensions(),
        startPx = currDimension.x,
        endPx = currDimension.x + currDimension.width; // set dimension of selection

    selection.setDimension({
      x: startPx,
      y: currDimension.y,
      width: currDimension.width,
      height: currDimension.height
    }); // set dimension of left handle

    leftHandle.setDimension({
      x: startPx - selfConfig.handleWidth,
      y: currDimension.y + currDimension.height / 2 - selfConfig.handleHeight / 2,
      width: selfConfig.handleWidth,
      height: selfConfig.handleHeight
    }); // set dimension of right handle

    rightHandle.setDimension({
      x: endPx,
      y: currDimension.y + currDimension.height / 2 - selfConfig.handleHeight / 2,
      width: selfConfig.handleWidth,
      height: selfConfig.handleHeight
    }); // set dimension of left label

    leftLabel.setDimension({
      x: startPx,
      y: currDimension.y
    }); // set dimension of right label

    rightLabel.setDimension({
      x: endPx,
      y: currDimension.y
    });
  }
  /**
   * Method that returns the maximum space taken by the labels.
   * @return {Number} maximum space taken by labels.
   */
  ;

  _proto.getLabelSpace = function getLabelSpace() {
    var brush = this,
        leftLabel = brush.getChildren('leftLabel')[0],
        rightLabel = brush.getChildren('rightLabel')[0]; // return the maximum height taken by the labels

    return Math.max(leftLabel.getLabelDimension().height, rightLabel.getLabelDimension().height);
  };

  _proto.draw = function draw() {
    var brush = this; // parent brush group.

    brush.addGraphicalElement({
      el: 'group',
      attr: {
        name: 'brush-group'
      },
      id: 'brushGroup',
      label: 'brushGroup',
      component: brush,
      container: {
        id: 'exo',
        label: 'group',
        isParent: true
      }
    });
  }
  /**
   * API that hides both the dragable labels.
   */
  ;

  _proto.hideAllLabels = function hideAllLabels() {
    var brush = this,
        leftLabel = brush.getChildren('leftLabel')[0],
        rightLabel = brush.getChildren('rightLabel')[0]; // hide only when the mouse pointer is outside time navigator.

    if (!brush.config.pointerReleasedOnParent) {
      leftLabel.config.showLabel = rightLabel.config.showLabel = false;
      leftLabel.asyncDraw();
      rightLabel.asyncDraw();
    }
  };

  _proto.setBrushValue = function setBrushValue(value) {
    var brush = this,
        leftLabel = brush.getChildren('leftLabel')[0],
        rightLabel = brush.getChildren('rightLabel')[0];
    leftLabel.setValue(value[0]);
    rightLabel.setValue(value[1]);
  }
  /**
   * Method that creates all the child components of brush.
   */
  ;

  _proto.createChildComponents = function createChildComponents() {
    var brush = this,
        brushConfig = brush.config,
        getStyleDef = brush.getFromEnv('getStyleDef'),
        leftHandle,
        rightHandle,
        leftLabel,
        rightLabel,
        selection; // selection box

    selection = brush.attachChild(_selection.default, 'selection');
    selection.attachHandlers();
    selection.configure({
      orientation: 'horizontal',
      style: {
        mask: getStyleDef(brushConfig.style.mask)
      }
    }); // left handle

    leftHandle = brush.attachChild(_handle.default, 'leftHandle');
    leftHandle.attachHandlers();
    leftHandle.configure({
      orientation: 'horizontal',
      type: 'leftHandle',
      style: {
        handle: getStyleDef(brushConfig.style.handle),
        'handle-grip': getStyleDef(brushConfig.style['handle-grip'])
      }
    }); // right handle

    rightHandle = brush.attachChild(_handle.default, 'rightHandle');
    rightHandle.attachHandlers();
    rightHandle.configure({
      orientation: 'horizontal',
      type: 'rightHandle',
      style: {
        handle: getStyleDef(brushConfig.style.handle),
        'handle-grip': getStyleDef(brushConfig.style['handle-grip'])
      }
    }); // left label

    leftLabel = brush.attachChild(_label.default, 'leftLabel');
    leftLabel.attachHandlers();
    leftLabel.configure({
      orientation: 'horizontal',
      type: 'leftLabel',
      style: {
        label: getStyleDef(brushConfig.style.label),
        labelBg: getStyleDef(brushConfig.style['label-background'])
      }
    }); // right label

    rightLabel = brush.attachChild(_label.default, 'rightLabel');
    rightLabel.attachHandlers();
    rightLabel.configure({
      orientation: 'horizontal',
      type: 'rightLabel',
      style: {
        label: getStyleDef(brushConfig.style.label),
        labelBg: getStyleDef(brushConfig.style['label-background'])
      }
    });
  }
  /**
   * Method that sets the maximum play dimension of brush component as a whole
   * @param {Object} dim maximum dimension
   */
  ;

  _proto.setMaxBrushDimensions = function setMaxBrushDimensions(dim) {
    this._maxDimensions = dim;
  }
  /**
   * Method to get the maximum brush play dimension.
   * @return {Object} maximum dimension.
   */
  ;

  _proto.getMaxBrushDimensions = function getMaxBrushDimensions() {
    return this._maxDimensions;
  }
  /**
   * Method that sets the current brush dimension of brush component.
   * @param {Object} dim current dimension
   */
  ;

  _proto.setCurrentBrushDimensions = function setCurrentBrushDimensions(dim) {
    this._currDimensions = dim; // now set the dimensions of its childs.

    this.setChildDimension();
  }
  /**
   * Method to get the current brush dimension.
   * @return {Object} current dimension
   */
  ;

  _proto.getCurrentBrushDimensions = function getCurrentBrushDimensions() {
    return this._currDimensions;
  };

  return Brush;
}(_componentInterface.SmartRenderer);

var _default = Brush;
exports["default"] = _default;

/***/ }),

/***/ 966:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _componentInterface = __webpack_require__(290);

var _lib = __webpack_require__(274);

var START = 'start',
    END = 'end',
    SCALE = 'scale',
    DRAGSTART = 'timeNavBrushStart',
    DRAGEND = 'timeNavBrushEnd',
    DRAG = 'timeNavBrush',
    UP = 'up',
    DOWN = 'down',
    LABELFORMAT = '%b %d, %Y';

var Label = /*#__PURE__*/function (_SmartRenderer) {
  (0, _inheritsLoose2.default)(Label, _SmartRenderer);

  function Label() {
    var _this;

    _this = _SmartRenderer.call(this) || this;
    _this._dimensions = {};
    return _this;
  }

  var _proto = Label.prototype;

  _proto.configureAttributes = function configureAttributes(obj) {
    if (obj === void 0) {
      obj = {};
    }

    _SmartRenderer.prototype.configureAttributes.call(this, obj);

    var labelConfig = this.config,
        baseTextStyle = this.getFromEnv('baseTextStyle');

    for (var key in obj) {
      if (obj.hasOwnProperty(key)) {
        labelConfig[key] = obj[key];
      }
    }

    labelConfig.style = {
      label: Object.assign({}, labelConfig._defaultLabelStyle, baseTextStyle, labelConfig.style.label),
      labelBg: Object.assign({}, labelConfig._defaultLabelBgStyle, labelConfig.style.labelBg)
    };
  };

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    _SmartRenderer.prototype.__setDefaultConfig.call(this);

    var labelConfig = this.config;
    labelConfig.showLabel = false; // default text style of dragable labels

    labelConfig._defaultLabelStyle = {
      'fill': '#f3f3f3',
      'font-size': '11px',
      'font-weight': 600,
      'vertical-align': 'middle',
      cursor: 'move'
    };
    labelConfig._defaultLabelBgStyle = {
      fill: '#5f5f5f',
      cursor: 'move'
    };
    labelConfig['border-horizontal-padding'] = 5;
    labelConfig['border-vertical-padding'] = 3;
  }
  /**
   * Method that sets the dimension of handle
   * @param {Object} dim dimensions
   */
  ;

  _proto.setDimension = function setDimension(dim) {
    this._dimensions = dim;
  }
  /**
   * Method to get the dimension of handle
   * @return {Object} dimensions
   */
  ;

  _proto.getDimension = function getDimension() {
    return this._dimensions;
  }
  /**
   * Method that attaches respective handlers on brush component
   */
  ;

  _proto.attachHandlers = function attachHandlers() {
    var label = this,
        animationManager = label.getFromEnv('animationManager'),
        brush = label.getLinkedParent(),
        timeNav = brush.getFromEnv('timeNavigator'),
        timeNavConfig = timeNav.config,
        chart = timeNav.getFromEnv('chart'),
        currFocusLimit,
        brushDim,
        dragLabelElem,
        clampDirection,
        startX,
        lastX,
        // startY,
    offsetX,
        startPx,
        endPx,
        options = {
      timeFormatter: timeNavConfig.formatter
    },
        forceFireOptions = Object.assign({
      forceFire: true
    }, options),
        eventArgs = {
      formatter: LABELFORMAT,
      action: SCALE
    }; // offsetY;
    // attach dragstart event.

    label.addEventListener('fc-dragstart', label.dragstartHandler || (label.dragstartHandler = function (e) {
      startX = (0, _lib.getTouchEvent)(e).clientX;
      lastX = 0;
      brushDim = brush.getCurrentBrushDimensions(); // inform time navigator that a label is getting dragged.

      timeNav.config.labelsGettingDragged = true; // store the dragable label element.

      dragLabelElem = e.originalEvent.target;
      brush.config.pointerReleasedOnParent = false;
      currFocusLimit = chart.getFocusLimit();
      chart.getFromEnv('fireChartEvents')(DRAGSTART, [+currFocusLimit[0], +currFocusLimit[1]], eventArgs, forceFireOptions);
    })); // attach dragmove event

    label.addEventListener('fc-dragmove', label.dragmoveHandler || (label.dragmoveHandler = function (e) {
      animationManager.setAnimationState('timenavSqueeze');
      offsetX = (0, _lib.getTouchEvent)(e).clientX - startX;
      clampDirection = offsetX >= lastX ? UP : DOWN;
      lastX = offsetX; // offsetY = e.originalEvent.clientY - startY;
      // perform operations based on the type of handle.

      if (label.config.type === 'leftLabel') {
        startPx = brushDim.x + offsetX;
        endPx = brushDim.x + brushDim.width;
      } else {
        startPx = brushDim.x;
        endPx = brushDim.x + brushDim.width + offsetX;
      }

      timeNav.validateDomain([startPx, endPx], [clampDirection, clampDirection], {
        eventName: DRAG,
        eventArgs: eventArgs,
        options: options
      });
    })); // attach dragend event.

    label.addEventListener('fc-dragend', label.dragendHandler || (label.dragendHandler = function (e) {
      animationManager.setAnimationState('timenavSqueeze');
      timeNav.config.labelsGettingDragged = false; // if current target is not the dragable label then inform its parent to hide both of its labels.

      if (dragLabelElem !== e.originalEvent.target) {
        brush.hideAllLabels();
      }

      currFocusLimit = chart.getFocusLimit();
      chart.getFromEnv('fireChartEvents')(DRAGEND, [+currFocusLimit[0], +currFocusLimit[1]], eventArgs, forceFireOptions);
    }));
  };

  _proto.setValue = function setValue(value) {
    this.config.value = value;
  };

  _proto.getValue = function getValue() {
    return this.config.value;
  }
  /**
   * space taken by this label
   *
   * @returns {Object} Object containing width and height of the label
   * @memberof Label
   */
  ;

  _proto.getLabelDimension = function getLabelDimension() {
    var label = this,
        labelConfig = label.config,
        smartLabel = label.getFromEnv('smartLabel'),
        formatter = label.getFromEnv('timeNavigatorConfig').formatter;
    smartLabel.setStyle(labelConfig.style.label);
    return smartLabel.getOriSize(formatter.format(labelConfig.value));
  };

  _proto.draw = function draw() {
    var label = this,
        config = label.config,
        labelStyle = config.style.label,
        labelBgStyle = config.style.labelBg,
        brush = label.getLinkedParent(),
        timeNavConfig = label.getFromEnv('timeNavigatorConfig'),
        smartLabel = label.getFromEnv('smartLabel'),
        brushMaxDim = brush.getMaxBrushDimensions(),
        labelDimensions = label.getDimension(),
        startX = labelDimensions.x,
        inverter,
        // decides whether the padding will be added or subtracted
    textAnchor,
        formatter = timeNavConfig.formatter,
        smartText,
        timeStamp = label.getValue(),
        text = formatter.format(timeStamp),
        startY = labelDimensions.y,
        labelStartX,
        labelStartY,
        labelWidth,
        labelHeight,
        labelBgWidth,
        labelBgHeight;
    smartLabel.setStyle(labelStyle);
    smartText = smartLabel.getOriSize(text);

    if (config.type === 'leftLabel') {
      // check if the label is within brush dimensions
      if (startX - smartText.width >= brushMaxDim.x) {
        textAnchor = END;
        inverter = 1;
      } else {
        textAnchor = START;
        inverter = -1;
      }
    } else {
      // check if the label is within brush dimensions
      if (startX + smartText.width <= brushMaxDim.x + brushMaxDim.width) {
        textAnchor = START;
        inverter = -1;
      } else {
        textAnchor = END;
        inverter = 1;
      }
    }

    labelStyle['text-anchor'] = textAnchor;

    if (config.showLabel) {
      labelWidth = smartText.width;
      labelHeight = smartText.height;
      labelBgWidth = labelWidth + 2 * config['border-horizontal-padding'];
      labelBgHeight = labelHeight + 2 * config['border-vertical-padding'];
      labelStartX = startX - inverter * config['border-horizontal-padding'];
      labelStartY = startY - (labelHeight + 2 * config['border-vertical-padding']) / 2; // @todo- mind the orientation
      // label background

      label.addGraphicalElement({
        el: 'rect',
        attr: {
          x: textAnchor === START ? startX : startX - labelBgWidth,
          y: startY - labelBgHeight,
          width: labelBgWidth,
          height: labelBgHeight
        },
        css: labelBgStyle,
        shadow: [true, 1],
        label: 'dragableLabelBackground',
        id: config.type + 'dragableLabelBackground',
        component: label,
        container: {
          id: 'brushGroup',
          label: 'brushGroup',
          isParent: true
        }
      }); // label element

      label.addGraphicalElement({
        el: 'text',
        attr: {
          x: labelStartX,
          y: labelStartY,
          text: text
        },
        css: labelStyle,
        id: config.type + 'dragableLabel',
        label: 'dragableLabel',
        component: label,
        container: {
          id: 'brushGroup',
          label: 'brushGroup',
          isParent: true
        }
      });
    }
  };

  return Label;
}(_componentInterface.SmartRenderer);

var _default = Label;
exports["default"] = _default;

/***/ }),

/***/ 967:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _componentInterface = __webpack_require__(290);

var _lib = __webpack_require__(274);

var COLOR_FDFDFD = '#fdfdfd',
    COLOR_F7FFFE = '#f7fffe',
    COLOR_E3E3E3 = '#e3e3e3',
    UP = 'up',
    DOWN = 'down',
    M = 'M',
    v = 'v',
    h = 'h',
    NONE = 'none',
    DRAGSTART = 'timeNavBrushStart',
    DRAGEND = 'timeNavBrushEnd',
    DRAG = 'timeNavBrush',
    LABELFORMAT = '%b %d, %Y',
    TRANSLATE = 'translate',
    STROKE_ATTR_LIST = ['stroke', 'stroke-width', 'stroke-dasharray', 'stroke-dashoffset', 'stroke-linecap', 'stroke-linejoin', 'stroke-miterlimit', 'stroke-opacity', 'stroke-color'];

var Selection = /*#__PURE__*/function (_SmartRenderer) {
  (0, _inheritsLoose2.default)(Selection, _SmartRenderer);

  function Selection() {
    var _this;

    _this = _SmartRenderer.call(this) || this;
    _this._dimensions = {};
    return _this;
  }

  var _proto = Selection.prototype;

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    _SmartRenderer.prototype.__setDefaultConfig.call(this);

    this.config.defaultStyle = {
      'fill': (0, _lib.toRaphaelColor)({
        FCcolor: {
          color: COLOR_FDFDFD + ',' + COLOR_F7FFFE,
          ratio: '0,100',
          angle: 90,
          alpha: '50,50'
        }
      }),
      'stroke': COLOR_E3E3E3,
      'stroke-width': 1,
      'opacity': 1,
      'fill-opacity': 0.5,
      'cursor': 'move'
    };
  };

  _proto.configureAttributes = function configureAttributes(obj) {
    if (obj === void 0) {
      obj = {};
    }

    _SmartRenderer.prototype.configureAttributes.call(this, obj);

    var selection = this,
        selectionConfig = selection.config,
        defaultStyle = selectionConfig.defaultStyle;
    selectionConfig.style = Object.assign({}, defaultStyle, obj.style.mask);
    selectionConfig.orientation = obj.orientation;
  }
  /**
   * Method that sets the dimension of selection component
   * @param {Object} dim dimension
   */
  ;

  _proto.setDimension = function setDimension(dim) {
    this._dimensions = dim;
  }
  /**
   * Method to get the current dimension of selection component
   * @return {Object} dimension
   */
  ;

  _proto.getDimension = function getDimension() {
    return this._dimensions;
  }
  /**
   * Method that attaches respective handlers on selction component
   */
  ;

  _proto.attachHandlers = function attachHandlers() {
    var selection = this,
        animationManager = selection.getFromEnv('animationManager'),
        brush = selection.getLinkedParent(),
        timeNav = brush.getFromEnv('timeNavigator'),
        timeNavConfig = timeNav.config,
        scale = timeNavConfig.contextScale,
        chart = selection.getFromEnv('chart'),
        currFocusLimit,
        brushDim,
        startX,
        curPx,
        clampDirection,
        offsetX,
        startPx,
        endPx,
        options = {
      timeFormatter: timeNavConfig.formatter
    },
        forceFireOptions = Object.assign({
      forceFire: true
    }, options),
        eventArgs = {
      formatter: LABELFORMAT,
      action: TRANSLATE
    }; // attach dragstart event.

    selection.addEventListener('fc-dragstart', selection.dragstartHandler || (selection.dragstartHandler = function (e) {
      startX = (0, _lib.getTouchEvent)(e).clientX;
      curPx = 0;
      brushDim = brush.getCurrentBrushDimensions();
      currFocusLimit = chart.getFocusLimit();
      chart.getFromEnv('fireChartEvents')(DRAGSTART, [+currFocusLimit[0], +currFocusLimit[1]], eventArgs, forceFireOptions);
    })); // attach dragmove event.

    selection.addEventListener('fc-dragmove', selection.dragmoveHandler || (selection.dragmoveHandler = function (e) {
      animationManager.setAnimationState('timenavScroll');
      offsetX = (0, _lib.getTouchEvent)(e).clientX - startX;
      clampDirection = curPx >= offsetX ? DOWN : UP;
      curPx = offsetX;
      startPx = brushDim.x + offsetX;
      endPx = startPx + brushDim.width;
      chart.setPixelLimit([startPx, endPx], scale, [clampDirection, clampDirection], {
        name: DRAG,
        eventArgs: eventArgs,
        options: options
      });
    })); // attach dragend event.

    selection.addEventListener('fc-dragend', selection.dragendHandler || (selection.dragendHandler = function (e) {
      currFocusLimit = chart.getFocusLimit();
      chart.getFromEnv('fireChartEvents')(DRAGEND, [+currFocusLimit[0], +currFocusLimit[1]], eventArgs, forceFireOptions);
    }));
  };

  _proto.draw = function draw() {
    var selection = this,
        selfConfig = selection.config,
        selectionStyle = Object.assign({}, selfConfig.style),
        selectionBorderStyle = Object.assign({}, selfConfig.style),
        i,
        len = STROKE_ATTR_LIST.length,
        selectionDimensions = selection.getDimension(); // @todo- mind the orientation
    // remove all stroke related attributes from css of rect

    for (i = 0; i < len; i++) {
      delete selectionStyle[STROKE_ATTR_LIST[i]];
    } // selection element rect.


    selection.addGraphicalElement({
      el: 'rect',
      attr: {
        x: selectionDimensions.x,
        y: selectionDimensions.y,
        width: Math.max(selectionDimensions.width, 0),
        height: Math.max(selectionDimensions.height, 0),
        opacity: selectionStyle.opacity,
        stroke: 'none'
      },
      css: selectionStyle,
      id: 'selectionBox',
      label: 'selectionBox',
      component: selection,
      container: {
        id: 'brushGroup',
        label: 'brushGroup',
        isParent: true
      }
    }); // border of selection border should not have any fill

    selectionBorderStyle.fill = NONE; // selection element border.

    selection.addGraphicalElement({
      el: 'path',
      attr: {
        path: [M, selectionDimensions.x, selectionDimensions.y, v, selectionDimensions.height, h, selectionDimensions.width, v, -selectionDimensions.height],
        opacity: selectionBorderStyle.opacity
      },
      id: 'selectionBoxBorder',
      label: 'selectionBoxBorder',
      css: selectionBorderStyle,
      component: selection,
      container: {
        id: 'brushGroup',
        label: 'brushGroup',
        isParent: true
      }
    });
  };

  return Selection;
}(_componentInterface.SmartRenderer);

var _default = Selection;
exports["default"] = _default;

/***/ }),

/***/ 885:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _smartRenderer = _interopRequireDefault(__webpack_require__(294));

var _libGraphics = __webpack_require__(278);

var _lib = __webpack_require__(274);

var _timeMarkerFactory = _interopRequireDefault(__webpack_require__(886));

var _referenceLineFactory = _interopRequireDefault(__webpack_require__(890));

var _referenceZoneFactory = _interopRequireDefault(__webpack_require__(892));

var _gridLineFactory = _interopRequireDefault(__webpack_require__(894));

var _mouseTrackerFactory = _interopRequireDefault(__webpack_require__(896));

var _tooltipAndHoverFactory = _interopRequireDefault(__webpack_require__(898));

var _wheelFactory = _interopRequireDefault(__webpack_require__(900));

var _dbTapFactory = _interopRequireDefault(__webpack_require__(902));

var _swipeFactory = _interopRequireDefault(__webpack_require__(903));

var _pinchZoomFactory = _interopRequireDefault(__webpack_require__(904));

var _datasetFactory = _interopRequireDefault(__webpack_require__(905));

var _verticalCrosslineFactory = _interopRequireDefault(__webpack_require__(941));

var _horizontalCrosslineFactory = _interopRequireDefault(__webpack_require__(943));

var _gridBandFactory = _interopRequireDefault(__webpack_require__(944));

var M = 'M',
    H = 'H',
    V = 'V',
    HORIZONTAL = 'horizontal',
    DEFAULT_BORDER_WIDTH = 2,
    BIN_SKIP_LINE_GAP = 2,
    BIN_SKIP_LINE_TRANSX = 4,
    BIN_SKIP_LINE_TRANSY = 6;

var createBinSkipLine = function createBinSkipLine(xPos, yPos) {
  var firstLineX = xPos - BIN_SKIP_LINE_GAP,
      secondLineX = xPos + BIN_SKIP_LINE_GAP,
      transX = BIN_SKIP_LINE_TRANSX,
      transY = BIN_SKIP_LINE_TRANSY;
  return ["\n    M " + (firstLineX + transX) + ", " + (yPos - transY) + " L " + (firstLineX - transX) + ", " + (yPos + transY) + "\n    M " + (secondLineX + transX) + ", " + (yPos - transY) + " L " + (secondLineX - transX) + ", " + (yPos + transY) + "\n    ", "\n    M " + (xPos + transX) + ", " + (yPos - transY) + " L " + (xPos - transX) + ", " + (yPos + transY) + "\n    "];
};
/**
 * This class creates the canvas for time-series
 */


var Canvas = /*#__PURE__*/function (_SmartRenderer) {
  (0, _inheritsLoose2.default)(Canvas, _SmartRenderer);

  function Canvas() {
    var _this;

    _this = _SmartRenderer.call(this) || this;

    _this.registerFactory('dataset', _datasetFactory.default); // register grid line factory


    _this.registerFactory('gridLine', _gridLineFactory.default); // register grid band factory


    _this.registerFactory('gridBand', _gridBandFactory.default); // register time marker factory


    _this.registerFactory('timeMarker', _timeMarkerFactory.default); // register reference line factory


    _this.registerFactory('referenceLine', _referenceLineFactory.default);

    _this.registerFactory('referenceZone', _referenceZoneFactory.default, ['mouseTracker']);

    _this.registerFactory('mouseTracker', _mouseTrackerFactory.default);

    _this.registerFactory('tooltip', _tooltipAndHoverFactory.default, ['mouseTracker']);

    _this.registerFactory('wheel', _wheelFactory.default);

    _this.registerFactory('dbTap', _dbTapFactory.default);

    _this.registerFactory('swipe', _swipeFactory.default);

    _this.registerFactory('pinchZoom', _pinchZoomFactory.default); // vertical crossline


    _this.registerFactory('verticalCrossline', _verticalCrosslineFactory.default, ['dataset']);

    _this.registerFactory('horizontalCrossline', _horizontalCrosslineFactory.default, ['dataset']);

    return _this;
  }

  var _proto = Canvas.prototype;

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    _SmartRenderer.prototype.__setDefaultConfig.call(this);

    var config = this.config;
    config.padding = {
      left: 0,
      right: 0,
      top: 0,
      bottom: 0
    }; // to keep the mapping of datasets when stacked

    config.multiSeriesDatasetMap = {};
    config.enableMouseTracking = 1;
    config.enableMarkers = 1;
    config.enableTimeMarkers = 1;
    config.enableReferenceLine = 1;
    config.enableReferenceZone = 1;
    config.enableInteraction = 0;
    config.includeLegend = 1;
    config.gridLineDirection = HORIZONTAL;
    config.styleGridLines = 1;
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */
  ;

  _proto.getName = function getName() {
    return 'canvas';
  };

  _proto.highlightDataPoints = function highlightDataPoints(hovered, refZoneScale, refZoneRange) {
    var canvas = this,
        allDataSets = canvas.getChildren('dataset'),
        highlightIndices,
        mouseTrackerComp = canvas.getChildren('mouseTracker')[0],
        filteredDatasets = allDataSets.filter(function (dataset) {
      return dataset.getFromEnv('yScale') === refZoneScale;
    });
    filteredDatasets.forEach(function (dataset) {
      highlightIndices = dataset.getHighlightedIndices(refZoneRange);

      if (highlightIndices.length) {
        if (hovered) {
          mouseTrackerComp.deactivate();
          dataset.setHoverInEffect(highlightIndices);
        } else {
          mouseTrackerComp.activate();
          dataset.setHoverOutEffect(highlightIndices);
        }
      }
    });
  }
  /**
   * Sets the type of the component
   * @return {string} type
   */
  ;

  _proto.getType = function getType() {
    return 'canvas';
  }
  /**
   * Function to configure the canvas
   * @param {Object} overrideConfig - Configuration object for canvas
   */
  ;

  _proto.configureAttributes = function configureAttributes(overrideConfig) {
    if (overrideConfig === void 0) {
      overrideConfig = {};
    }

    var config = this.config,
        borderConfig = config.borderConfig || (config.borderConfig = {});
    Object.assign(config, overrideConfig);
    var canvasStyle = config.canvasStyle; // Setting the canvas border thickness

    ['leftBorder', 'topBorder', 'rightBorder', 'bottomBorder'].forEach(function (border) {
      // Parsing canvasBorder thickness only if provided by the chart
      borderConfig[border] = overrideConfig[border] ? (0, _lib.pluckNumber)(canvasStyle['stroke-width'], DEFAULT_BORDER_WIDTH) : borderConfig[border] || 0;
    });
    config.canvasBorderColor = (0, _libGraphics.convertColor)((0, _lib.pluck)(canvasStyle.stroke, 'D6D6D6'), (0, _lib.pluckNumber)(canvasStyle['stroke-opacity'] * 100, 100));
    config.canvasBGColor = (0, _libGraphics.convertColor)((0, _lib.pluck)(canvasStyle.fill, 'ffffff'), (0, _lib.pluckNumber)(canvasStyle['fill-opacity'] * 100, 100));
    config.opacity = canvasStyle.opacity;
    config.showGridBand = config.gridBandSupported && (0, _lib.pluckNumber)(config.yConfigs[0].showgridband, 0);
    config.gridBandStyle = config.yConfigs[0].style ? config.yConfigs[0].style['grid-band'] : {};
  }
  /**
   * Function to set the canvas dimensions
   * @param {Object} dim - Canvas dimensions set by the chart
   */
  ;

  _proto.setDimension = function setDimension(dim) {
    if (dim === void 0) {
      dim = {};
    }

    var canvas = this,
        config = canvas.config,
        borderConfig = config.borderConfig,
        chartConfig = canvas.getFromEnv('chartConfig');
    config.canvasTop = dim.top || 0;
    config.canvasLeft = dim.left || 0;
    config.canvasWidth = dim.width || chartConfig.origRenderWidth;
    config.canvasHeight = dim.height || chartConfig.origRenderHeight; // Background dimensions

    config.canvasBGTop = config.canvasTop + borderConfig.topBorder;
    config.canvasBGLeft = config.canvasLeft + borderConfig.leftBorder;
    config.canvasBGWidth = Math.max(0, config.canvasWidth - borderConfig.rightBorder - borderConfig.leftBorder);
    config.canvasBGHeight = Math.max(0, config.canvasHeight - borderConfig.bottomBorder);
  };

  _proto.getDimension = function getDimension() {
    var config = this.config;
    return {
      top: config.canvasTop,
      left: config.canvasLeft,
      width: config.canvasWidth,
      height: config.canvasHeight
    };
  }
  /**
   * function to check the given cordinate is with in canvas or not
   * @param {number} x - x coordinate
   * @param {number} y - y coordinate
   * @return {boolean} whether the coordinate is with in canvas or not
   */
  ;

  _proto.isWithinCanvas = function isWithinCanvas(xArg, yArg) {
    var canvas = this,
        x = xArg,
        y = yArg,
        config = canvas.config,
        left = config && config.canvasBGLeft,
        right = Math.floor(left + config && config.canvasBGWidth),
        top = config && config.canvasBGTop,
        padding = config && config.padding,
        bottom = Math.floor(top + config && config.canvasBGHeight),
        translationObj = canvas.getTranslation();
    x = x - (translationObj.x || 0) + (padding && padding.left || 0);
    y = y - (translationObj.y || 0) + (padding && padding.top || 0);
    return x > left && x < right && y > top && y < bottom;
  };

  _proto.draw = function draw() {
    var canvas = this;

    canvas._createGroup();

    canvas._drawCanvas();

    !canvas.config.isContext && canvas._setTooltipBounding();
  };

  _proto._setTooltipBounding = function _setTooltipBounding() {
    var canvas = this,
        config = canvas.config,
        translate = canvas.getTranslation(),
        tooltipController = canvas.getFromEnv('toolTipController'),
        left = config.canvasLeft + (translate.x || 0),
        top = config.canvasTop + (translate.y || 0);

    tooltipController._setRelativePosition({
      left: left,
      right: left + config.canvasWidth,
      top: top,
      bottom: top + config.canvasHeight,
      canvas: this
    });
  }
  /**
   * Fucntion to draw the canavs
   */
  ;

  _proto._drawCanvas = function _drawCanvas() {
    var canvas = this,
        config = canvas.config,
        borderConfig = config.borderConfig,
        canvasTop = config.canvasTop + borderConfig.topBorder / 2,
        canvasLeft = config.canvasLeft + borderConfig.leftBorder / 2,
        canvasWidth = config.canvasWidth - (borderConfig.rightBorder / 2 + borderConfig.leftBorder / 2),
        canvasHeight = config.canvasHeight - (borderConfig.bottomBorder / 2 + borderConfig.topBorder / 2),
        canvasPaths = {
      leftBorder: [M, canvasLeft, canvasTop, V, canvasTop + canvasHeight],
      rightBorder: [M, canvasLeft + canvasWidth, canvasTop, V, canvasTop + canvasHeight],
      topBorder: [M, canvasLeft, canvasTop, H, canvasLeft + canvasWidth],
      bottomBorder: [M, canvasLeft, canvasTop + canvasHeight, H, canvasLeft + canvasWidth]
    },
        border,
        bottomBorderPaths; // Creating the canvas background

    canvas.addGraphicalElement({
      el: 'rect',
      component: canvas,
      label: 'canvas',
      container: {
        id: 'tropo',
        label: 'group',
        isParent: false
      },
      attr: {
        y: config.canvasBGTop,
        x: config.canvasBGLeft,
        width: config.canvasBGWidth,
        height: config.canvasBGHeight,
        fill: config.canvasBGColor,
        'stroke-width': 0,
        'stroke': 'none',
        'opacity': config.opacity
      },
      id: 'background'
    }, true); // Creating individual canvas borders

    for (border in borderConfig) {
      if (border === 'bottomBorder') {
        bottomBorderPaths = this.getBottomBorderPaths();
        bottomBorderPaths.normalLine.length && canvas.addGraphicalElement({
          el: 'path',
          component: canvas,
          label: 'canvas',
          container: {
            id: 'tropo',
            label: 'group',
            isParent: false
          },
          attr: {
            path: bottomBorderPaths.normalLine.join(''),
            stroke: config.canvasBorderColor,
            'stroke-width': borderConfig[border],
            'opacity': config.opacity
          },
          id: border + '-normal'
        }, true);
        bottomBorderPaths.dashedLine.length && canvas.addGraphicalElement({
          el: 'path',
          component: canvas,
          label: 'canvas',
          container: {
            id: 'tropo',
            label: 'group',
            isParent: false
          },
          attr: {
            path: bottomBorderPaths.dashedLine.join(''),
            stroke: config.canvasBorderColor,
            'stroke-width': borderConfig[border],
            'opacity': config.opacity,
            'stroke-dasharray': [3, 4]
          },
          id: border + '-dashed'
        }, true);

        if (bottomBorderPaths.clippedLine.length) {
          canvas.addGraphicalElement({
            el: 'path',
            component: canvas,
            label: 'canvas',
            container: {
              id: 'tropo',
              label: 'group',
              isParent: false
            },
            attr: {
              path: bottomBorderPaths.clippedLine.join(''),
              stroke: config.canvasBorderColor,
              'stroke-width': borderConfig[border],
              'opacity': config.opacity
            },
            id: border + '-clipped'
          }, true);
          canvas.addGraphicalElement({
            el: 'path',
            component: canvas,
            label: 'canvas',
            container: {
              id: 'tropo',
              label: 'group',
              isParent: false
            },
            attr: {
              path: bottomBorderPaths.clippedLineMid.join(''),
              stroke: '#ffffff',
              'stroke-width': borderConfig[border],
              'opacity': config.opacity
            },
            id: border + '-clipped'
          }, true);
        }
      } else {
        canvas.addGraphicalElement({
          el: 'path',
          component: canvas,
          label: 'canvas',
          container: {
            id: 'tropo',
            label: 'group',
            isParent: false
          },
          attr: {
            path: canvasPaths[border],
            stroke: config.canvasBorderColor,
            'stroke-width': borderConfig[border],
            'opacity': config.opacity
          },
          id: border
        }, true);
      }
    }
  };

  _proto.getBottomBorderPaths = function getBottomBorderPaths() {
    var xScale = this.getFromEnv('focusScalesX')[0],
        config = this.config,
        borderConfig = config.borderConfig,
        bins = xScale.bins,
        domain = xScale.getDomain(),
        range = xScale.getRange(),
        showClippingCue = (0, _lib.pluckNumber)(config.xConfigs[0].showclippingcue, 1),
        canvasTop = config.canvasTop + borderConfig.topBorder / 2,
        canvasHeight = config.canvasHeight - (borderConfig.bottomBorder / 2 + borderConfig.topBorder / 2),
        j,
        len = bins.length,
        lastNonClippedBinIndex,
        lastClippedBin,
        xPos,
        yVal = canvasTop + canvasHeight,
        pathStr,
        binSkipLines,
        normalLine = [],
        dashedLine = [],
        clippedLine = [],
        clippedLineMid = [];

    for (j = 0, len = bins.length; j < len; j++) {
      if (bins[j].end > +domain[0] && bins[j].start < +domain[1]) {
        pathStr = "M " + xScale.getRangeValue(Math.max(+domain[0], +bins[j].start)) + ", " + yVal + " \n          L " + xScale.getRangeValue(Math.min(+bins[j].end, +domain[1])) + ", " + yVal;

        if (!bins[j].clipType || !showClippingCue) {
          normalLine.push(pathStr);
          lastNonClippedBinIndex = j;
        } else if (bins[j].clipType === 1) {
          dashedLine.push(pathStr);
          lastNonClippedBinIndex = j;
        }
      }

      if (bins[j].clipType === 2 && showClippingCue) {
        if (lastClippedBin === j - 1) {
          lastClippedBin = j;
          continue;
        }

        if (lastNonClippedBinIndex) {
          xPos = (xScale.getRangeValue(bins[lastNonClippedBinIndex].start) + xScale.getRangeValue(bins[j].end)) / 2;
        } else {
          xPos = xScale.getRangeValue(bins[j].end);
        }

        if (xPos < range[0] + BIN_SKIP_LINE_GAP || xPos > range[1] - BIN_SKIP_LINE_GAP) {
          continue;
        }

        binSkipLines = createBinSkipLine(xPos, yVal);
        clippedLine.push(binSkipLines[0]);
        clippedLineMid.push(binSkipLines[1]);
        lastClippedBin = j;
      }
    }

    return {
      normalLine: normalLine,
      dashedLine: dashedLine,
      clippedLine: clippedLine,
      clippedLineMid: clippedLineMid
    };
  }
  /**
   * Function to create group for its child components
   */
  ;

  _proto._createGroup = function _createGroup() {
    var canvas = this,
        config = canvas.config,
        padding = config.padding,
        // Taking the padding into consideration as the clip-rect is shifed based on the translation applied
    // on the group
    canvasLeft = config.canvasBGLeft - padding.left,
        canvasTop = config.canvasBGTop - padding.top,
        canvasWidth = config.canvasBGWidth,
        canvasHeight = config.canvasBGHeight,
        clipPath = ["M" + canvasLeft + "," + canvasTop, "L" + (canvasLeft + canvasWidth) + "," + canvasTop, "L" + (canvasLeft + canvasWidth) + "," + (canvasTop + canvasHeight), "L" + canvasLeft + "," + (canvasTop + canvasHeight) + "Z"]; // create group for canvas

    canvas.addGraphicalElement({
      el: 'group',
      container: {
        id: 'tropo',
        label: 'group',
        isParent: true
      },
      component: canvas,
      label: 'group',
      attr: {
        name: 'canvas-tropo',
        transform: config.canvasTranslation
      },
      id: 'tropo'
    });
    canvas.addGraphicalElement({
      el: 'group',
      container: {
        id: 'strato',
        label: 'group',
        isParent: true
      },
      component: canvas,
      label: 'strato',
      attr: {
        name: 'canvas-strato',
        transform: config.translate
      },
      id: 'strato'
    });
    canvas.addGraphicalElement({
      el: 'group',
      container: {
        id: 'meso',
        label: 'group',
        isParent: true
      },
      component: canvas,
      label: 'meso',
      attr: {
        name: 'canvas-meso',
        transform: config.translate,
        'clip-path': clipPath
      },
      id: 'meso'
    });
    canvas.addGraphicalElement({
      el: 'group',
      container: {
        id: 'thermo',
        label: 'group',
        isParent: true
      },
      component: canvas,
      label: 'thermo',
      attr: {
        name: 'canvas-thermo',
        transform: config.translate
      },
      id: 'thermo'
    });
    canvas.addGraphicalElement({
      el: 'group',
      container: {
        id: 'exo',
        label: 'group',
        isParent: true
      },
      component: canvas,
      label: 'exo',
      attr: {
        name: 'canvas-exo',
        transform: config.translate
      },
      id: 'exo'
    });
    canvas.addToEnv('dsGroupclipPath', clipPath);
  }
  /**
   * This function calculates the amount of translation that is to be applied on the groups of the canvas
   * The canavs border width is taken into consideration for final x,y translation
   * @param {Number} x Given translation in x
   * @param {Number} y Given translation in y
   */
  ;

  _proto.setTranslation = function setTranslation(x, y) {
    var config = this.config,
        borderConfig = config.borderConfig,
        padding = config.padding;
    config._translateX = x + borderConfig.leftBorder;
    config._translateY = y + borderConfig.topBorder;
    config.canvasTranslation = 't' + config._translateX + ',' + config._translateY;
    config._translateX += padding.left;
    config._translateY += padding.top;
    config.translate = 't' + config._translateX + ',' + config._translateY;
  };

  _proto.getCanvasBorder = function getCanvasBorder() {
    return this.config.borderConfig;
  };

  _proto.setPadding = function setPadding(padding) {
    if (padding === void 0) {
      padding = {};
    }

    Object.assign(this.config.padding, padding);
  };

  return Canvas;
}(_smartRenderer.default);

var _default = Canvas;
exports["default"] = _default;

/***/ }),

/***/ 948:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _componentInterface = __webpack_require__(290);

var _lib = __webpack_require__(274);

var _DEFAULT_CAPTION_CSS, _DEFAULT_SUBCAPTION_C;

var LEFT = 'left',
    RIGHT = 'right',
    MIDDLE = 'middle',
    START = 'start',
    END = 'end',
    TOP = 'top',
    DEFAULT_CAPTION_PADDING = 10,
    CAPTION_SUBCAPTION_GAP_RATIO = 0.02,
    CAPTION_HEIGHT_RATIO = 0.7,
    SUBCAPTION_HEIGHT_RATIO = 0.3,
    FONTSTYLE = 'font-style',
    FONTSIZE = 'font-size',
    FONTWEIGHT = 'font-weight',
    TEXT_ANCHOR = 'text-anchor',
    VERTICAL_ALIGN = 'vertical-align',
    FILL = 'fill',
    DEFAULT_CAPTION_CSS = (_DEFAULT_CAPTION_CSS = {}, _DEFAULT_CAPTION_CSS[FONTSIZE] = '16px', _DEFAULT_CAPTION_CSS[FONTSTYLE] = 'normal', _DEFAULT_CAPTION_CSS[FONTWEIGHT] = 'bold', _DEFAULT_CAPTION_CSS[FILL] = '#5F5F5F', _DEFAULT_CAPTION_CSS),
    DEFAULT_SUBCAPTION_CSS = (_DEFAULT_SUBCAPTION_C = {}, _DEFAULT_SUBCAPTION_C[FONTSIZE] = '12px', _DEFAULT_SUBCAPTION_C[FONTSTYLE] = 'normal', _DEFAULT_SUBCAPTION_C[FONTWEIGHT] = 'normal', _DEFAULT_SUBCAPTION_C[FILL] = '#B1B1B1', _DEFAULT_SUBCAPTION_C);

var Caption = /*#__PURE__*/function (_SmartRenderer) {
  (0, _inheritsLoose2.default)(Caption, _SmartRenderer);

  function Caption() {
    return _SmartRenderer.apply(this, arguments) || this;
  }

  var _proto = Caption.prototype;

  /**
   * Sets default configurations of caption component
   *
   * @memberof Caption
   */
  _proto.__setDefaultConfig = function __setDefaultConfig() {
    _SmartRenderer.prototype.__setDefaultConfig.call(this);

    var caption = this,
        captionConfig = caption.config;
    captionConfig.captionCss = DEFAULT_CAPTION_CSS;
    captionConfig.subCaptionCss = DEFAULT_SUBCAPTION_CSS;
    captionConfig.alignment = LEFT;
    captionConfig.gap = 0;
  }
  /**
   * configures the caption component
   *
   * @param {any} [options={}] options used to configure
   * @memberof Caption
   */
  ;

  _proto.configureAttributes = function configureAttributes(options) {
    if (options === void 0) {
      options = {};
    }

    _SmartRenderer.prototype.configureAttributes.call(this, options);

    var caption = this,
        captionConfig = caption.config,
        baseTextStyle = caption.getFromEnv('baseTextStyle');
    Object.keys(options).forEach(function (key) {
      return captionConfig[key] = options[key];
    });
    captionConfig.captionCss = Object.assign({}, DEFAULT_CAPTION_CSS, baseTextStyle, captionConfig.captionCss || {});
    captionConfig.subCaptionCss = Object.assign({}, DEFAULT_SUBCAPTION_CSS, baseTextStyle, captionConfig.subCaptionCss || {});
  }
  /**
   * Calculation of amount of space required by caption and subcaption.
   *
   * Caption and subCaption takes up the whole width but can take less than or equal to
   * the max-height provided
   *
   * @param {Object} dim {width , height} maximum width and height provided by chart
   * @returns {Object} height and width taken by caption
   * @memberof Caption
   */
  ;

  _proto.setDimension = function setDimension(dim) {
    var caption = this,
        captionConfig = caption.config,
        smartLabel = caption.getFromEnv('smartLabel'),
        maxHeight = dim.height - DEFAULT_CAPTION_PADDING,
        maxWidth = dim.width,
        availableHeight,
        maxCaptionHeight = 0,
        maxSubCaptionHeight = 0,
        captionDim,
        subCaptionDim,
        gap;

    if (captionConfig.subCaption) {
      // If subCaption is present, allocate 70% of the total height to caption and
      // 30% to subcaption
      gap = captionConfig.gap = maxHeight * CAPTION_SUBCAPTION_GAP_RATIO;
      availableHeight = maxHeight - gap;
      maxCaptionHeight = availableHeight * CAPTION_HEIGHT_RATIO; // If caption is not present, subcaption takes full height

      maxSubCaptionHeight = captionConfig.caption ? availableHeight * SUBCAPTION_HEIGHT_RATIO : maxHeight;
    } else {
      // Caption takes up whole space when subcaption is not present
      availableHeight = maxCaptionHeight = maxHeight;
    } // Caption and subcaption should have ellipse when truncated


    smartLabel.useEllipsesOnOverflow(true);
    smartLabel.setStyle(captionConfig.captionCss); // Get the caption text, height and width for caption text

    captionDim = captionConfig.captionDim = smartLabel.getSmartText(captionConfig.caption, maxWidth, maxCaptionHeight);
    smartLabel.setStyle(captionConfig.subCaptionCss); // Get the caption text, height and width for subcaption text

    subCaptionDim = captionConfig.subCaptionDim = smartLabel.getSmartText(captionConfig.subCaption, maxWidth, maxSubCaptionHeight); // Allow a gap of 2% of max-height between caption and subCaption

    maxHeight = captionDim.height + (captionConfig.subCaption ? gap : 0) + subCaptionDim.height; // Add a padding at the end

    maxHeight += maxHeight === 0 ? 0 : DEFAULT_CAPTION_PADDING; // store the total space take by caption

    captionConfig.spaceTaken = {
      width: maxWidth,
      height: maxHeight
    };
    return {
      height: maxHeight,
      width: maxWidth
    };
  }
  /**
   * Drawing of caption and subcaption
   *
   * @memberof Caption
   */
  ;

  _proto.draw = function draw() {
    var caption = this,
        captionConfig = caption.config,
        chartConfig = caption.getFromEnv('chart').config,
        captionDim = captionConfig.captionDim,
        subCaptionDim = captionConfig.subCaptionDim,
        xCaptionPos,
        xSubCaptionPos,
        captionTextAnchor,
        subCaptionTextAnchor,
        spaceTaken = captionConfig.spaceTaken,
        captionAttr = {
      text: captionDim.text
    },
        subCaptionAttr = {
      text: subCaptionDim.text
    }; // get the caption alignment and calculate x-position based on it

    switch (captionConfig.captionAlignment) {
      case RIGHT:
        // take width as xCaptionPos and 'end' as 'text-anchor' when aligned right
        xCaptionPos = spaceTaken.width;
        captionTextAnchor = END;
        break;

      case MIDDLE:
        // take width as xCaptionPos and 'middle' as 'text-anchor' when aligned middle/center
        xCaptionPos = spaceTaken.width / 2;
        captionTextAnchor = MIDDLE;
        break;

      case LEFT:
      default:
        // take width as xCaptionPos and 'left' as 'text-anchor' when aligned left. This is default behaviour
        xCaptionPos = 0;
        captionTextAnchor = START;
    } // get the sub-caption alignment and calculate x-position based on it


    switch (captionConfig.subCaptionAlignment) {
      case RIGHT:
        // take width as xSubCaptionPos and 'end' as 'text-anchor' when aligned right
        xSubCaptionPos = spaceTaken.width;
        subCaptionTextAnchor = END;
        break;

      case MIDDLE:
        // take width as xSubCaptionPos and 'middle' as 'text-anchor' when aligned middle/center
        xSubCaptionPos = spaceTaken.width / 2;
        subCaptionTextAnchor = MIDDLE;
        break;

      case LEFT:
      default:
        // take width as xSubCaptionPos and 'left' as 'text-anchor' when aligned left. This is default behaviour
        xSubCaptionPos = 0;
        subCaptionTextAnchor = START;
    }

    captionAttr.x = xCaptionPos;
    subCaptionAttr.x = xSubCaptionPos;
    captionAttr[TEXT_ANCHOR] = captionTextAnchor;
    subCaptionAttr[TEXT_ANCHOR] = subCaptionTextAnchor;
    captionAttr[VERTICAL_ALIGN] = subCaptionAttr[VERTICAL_ALIGN] = TOP; // caption text should be placed at ypos 0.(relative to its containing group. group is translated)

    captionAttr.y = 0;
    subCaptionAttr.y = captionConfig.gap + captionDim.height; // create the strato group

    caption.addGraphicalElement({
      el: 'group',
      container: {
        id: 'strato',
        label: 'group',
        isParent: true
      },
      component: caption,
      label: 'group',
      attr: {
        name: 'caption-strato',
        transform: captionConfig.translate
      },
      id: 'strato'
    }); // create caption text if text is present

    captionConfig.caption && caption.addGraphicalElement({
      el: 'text',
      attr: {
        x: captionAttr.x,
        y: captionAttr.y,
        text: captionAttr.text,
        'vertical-align': captionAttr[VERTICAL_ALIGN],
        opacity: captionConfig.captionCss.opacity,
        'text-anchor': captionAttr[TEXT_ANCHOR]
      },
      css: captionConfig.captionCss,
      container: {
        id: 'strato',
        label: 'group',
        isParent: false
      },
      tooltext: chartConfig.showTooltip ? captionDim.tooltext : _lib.UNDEF,
      component: caption,
      id: 'caption',
      label: 'text'
    }); // create subcaption text if text is present

    captionConfig.subCaption && caption.addGraphicalElement({
      el: 'text',
      attr: {
        x: subCaptionAttr.x,
        y: subCaptionAttr.y,
        text: subCaptionAttr.text,
        'vertical-align': subCaptionAttr[VERTICAL_ALIGN],
        opacity: captionConfig.subCaptionCss.opacity,
        'text-anchor': subCaptionAttr[TEXT_ANCHOR]
      },
      css: captionConfig.subCaptionCss,
      container: {
        id: 'strato',
        label: 'group',
        isParent: false
      },
      tooltext: chartConfig.showTooltip ? subCaptionDim.tooltext : _lib.UNDEF,
      component: caption,
      id: 'subCaption',
      label: 'text'
    });
  };

  return Caption;
}(_componentInterface.SmartRenderer);

var _default = Caption;
exports["default"] = _default;

/***/ }),

/***/ 942:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _componentInterface = __webpack_require__(290);

var _lib = __webpack_require__(274);

var _isValidNumber = _interopRequireDefault(__webpack_require__(856));

var VERTICAL = 'vertical',
    END = 'end',
    MIDDLE = 'middle',
    START = 'start',
    GUTTER_5 = 5,
    M = 'M',
    L = 'L',
    l = 'l',
    h = 'h',
    v = 'v',
    z = 'z';

var Crossline = /*#__PURE__*/function (_SmartRenderer) {
  (0, _inheritsLoose2.default)(Crossline, _SmartRenderer);

  function Crossline() {
    return _SmartRenderer.apply(this, arguments) || this;
  }

  var _proto = Crossline.prototype;

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    _SmartRenderer.prototype.__setDefaultConfig.call(this);

    var crosslineConfig = this.config;
    crosslineConfig.type = VERTICAL;
    crosslineConfig.values = [];
    crosslineConfig._defaultLineStyle = {
      stroke: '#9a9a9a',
      'stroke-width': 1,
      'stroke-opacity': 1
    };
    crosslineConfig._defaultTextStyle = {
      fill: '#ffffff',
      'font-size': '10px',
      'font-weight': 'normal',
      'font-style': 'normal',
      'text-anchor': 'middle'
    };
    crosslineConfig._defaultTagStyle = {
      fill: '#5f5f5f'
    };
    crosslineConfig._defaultPadding = 2;
  };

  _proto.configureAttributes = function configureAttributes(obj) {
    _SmartRenderer.prototype.configureAttributes.call(this, obj);

    var config = this.config,
        type,
        inputStyle,
        baseTextStyle = this.getFromEnv('baseTextStyle'),
        getStyleDef = this.getFromEnv('getStyleDef');

    for (var key in obj) {
      if (obj.hasOwnProperty(key)) {
        config[key] = obj[key];
      }
    }

    type = config.type;
    inputStyle = config.inputStyle;
    /**
     * Styling precedence for line and tag
     * -> default style < JSON.crossline.style.line < JSON.crossline.style.vertical-line (horizontal-line for horizontal crossline)
     * -> default style < JSON.crossline.style.tag < JSON.crossline.style.vertical-tag (horizontal-tag for horizontal crossline)
     *
     * Styling precedence for label
     * -> default style < baseTextStyle < JSON.crossline.style.label < JSON.crossline.style.vertical-label (horizontal-label for horizontal crossline)
     */

    config._lineStyle = Object.assign({}, config._defaultLineStyle, getStyleDef(inputStyle.line), getStyleDef(inputStyle[type + '-line']));
    config._textStyle = Object.assign({}, config._defaultTextStyle, baseTextStyle, getStyleDef(inputStyle.label), getStyleDef(inputStyle[type + '-label']));
    config._tagStyle = Object.assign({}, config._defaultTagStyle, getStyleDef(inputStyle.tag), getStyleDef(inputStyle[type + '-tag']));
  }
  /**
   * Method to get the path of crossline
   * @return {Array} pathArr array of paths.
   */
  ;

  _proto.getPathArrs = function getPathArrs() {
    var crossline = this,
        selfConfig = crossline.config,
        isVertical = selfConfig.type === VERTICAL,
        scale = selfConfig.scale,
        values = selfConfig.values,
        pathArrays = [],
        pathArr,
        canvasConfig = crossline.getLinkedParent().config,
        canvasPadding = canvasConfig.padding,
        canvasLeft = canvasConfig.canvasLeft - canvasPadding.left,
        canvasTop = canvasConfig.canvasTop - canvasPadding.top,
        canvasWidth = canvasConfig.canvasWidth,
        canvasHeight = canvasConfig.canvasHeight;
    values.forEach(function (value) {
      var rangeVal = scale.getRangeValue(value);

      if (rangeVal) {
        if (isVertical) {
          pathArr = [M, rangeVal, canvasTop, v, canvasHeight];
        } else {
          pathArr = [M, canvasLeft, rangeVal, h, canvasWidth];
        }

        pathArrays.push(pathArr);
      }
    });
    return pathArrays;
  }
  /**
   * Method to draw vertical crossline text and anchor
   */
  ;

  _proto.drawVerticalCrosslineText = function drawVerticalCrosslineText() {
    var crossline = this,
        selfConfig = crossline.config,
        dateRange = selfConfig.dateRange,
        text = selfConfig.timeFormatterFn({
      dateRange: dateRange,
      type: 'crossline'
    }),
        values = selfConfig.values,
        scale = selfConfig.scale,
        padding = (0, _lib.pluckNumber)(selfConfig.padding, selfConfig._defaultPadding),
        canvasConfig = crossline.getLinkedParent().config,
        canvasPadding = canvasConfig.padding,
        canvasLeft = canvasConfig.canvasLeft - canvasPadding.left,
        canvasTop = canvasConfig.canvasTop - canvasPadding.top,
        canvasWidth = canvasConfig.canvasWidth,
        canvasHeight = canvasConfig.canvasHeight,
        canvasBottom = canvasTop + canvasHeight,
        canvasRight = canvasLeft + canvasWidth,
        smartLabel = crossline.getFromEnv('smartLabel'),
        markerPath,
        textOffset = 0,
        rangeValue,
        smartText,
        crosslineId; // draw only if value is valid

    values.forEach(function (value, index) {
      if ((0, _isValidNumber.default)(value)) {
        smartLabel.setStyle(selfConfig._textStyle);
        smartText = smartLabel.getOriSize(text);
        rangeValue = scale.getRangeValue(value);
        crosslineId = "crossline-" + index; // create group for vertical cross line.

        crossline.addGraphicalElement({
          el: 'group',
          container: {
            id: 'thermo',
            label: 'thermo',
            isParent: true
          },
          component: crossline,
          label: crosslineId,
          attr: {
            name: 'veritcal-crossline-marker-group'
          },
          id: crosslineId
        }); // crossline path crosses the right edge of the canvas

        if (rangeValue + smartText.width / 2 + 2 * padding > canvasRight) {
          markerPath = [M, rangeValue, canvasBottom, L, rangeValue, canvasBottom + padding, v, smartText.height + 2 * padding, h, -(smartText.width + 4 * padding), v, -(smartText.height + 2 * padding), L, rangeValue - padding, canvasBottom + padding, z];
          selfConfig._textStyle['text-anchor'] = END;
          textOffset = -2 * padding;
        } else if (rangeValue - smartText.width / 2 - 2 * padding < canvasLeft) {
          // crossline path crosses the left edge of the canvas
          markerPath = [M, rangeValue, canvasBottom, L, rangeValue, canvasBottom + padding, v, smartText.height + 2 * padding, h, smartText.width + 4 * padding, v, -(smartText.height + 2 * padding), L, rangeValue + padding, canvasBottom + padding, z];
          selfConfig._textStyle['text-anchor'] = START;
          textOffset = 2 * padding;
        } else {
          markerPath = [M, rangeValue, canvasBottom, L, rangeValue - padding, canvasBottom + padding, L, rangeValue - smartText.width / 2 - 2 * padding, canvasBottom + padding, v, smartText.height + 2 * padding, h, smartText.width + 4 * padding, v, -(smartText.height + 2 * padding), L, rangeValue + padding, canvasBottom + padding, z];
          selfConfig._textStyle['text-anchor'] = MIDDLE;
        }

        crossline.addGraphicalElement({
          el: 'path',
          attr: {
            path: markerPath
          },
          css: selfConfig._tagStyle,
          id: 'vertical-crossline-marker-' + index,
          container: {
            label: crosslineId
          }
        }); // text

        crossline.addGraphicalElement({
          el: 'text',
          attr: {
            text: text,
            x: rangeValue + textOffset,
            y: canvasBottom + 2 * padding + smartText.height / 2
          },
          css: selfConfig._textStyle,
          id: 'vertical-crossline-text-' + index,
          container: {
            label: crosslineId
          }
        });
        smartLabel.setStyle(selfConfig._textStyle);
        smartText = smartLabel.getOriSize(text);
        rangeValue = scale.getRangeValue(value);
      }
    });
  }
  /**
   * Method to draw horizontal crossline text and anchor
   */
  ;

  _proto.drawHorizontalCrosslineText = function drawHorizontalCrosslineText() {
    var _this = this;

    var crossline = this,
        selfConfig = crossline.config,
        values = selfConfig.values,
        text,
        crosslineId,
        markerProp; // draw only if value is valid

    values.forEach(function (value, index) {
      if ((0, _isValidNumber.default)(value)) {
        text = selfConfig.formatterFn({
          value: selfConfig.texts[index],
          type: 'crossline',
          prefix: selfConfig.prefix,
          suffix: selfConfig.suffix
        });
        markerProp = _this.getHorizontalMarkerProps(value, index);
        crosslineId = "crossline-" + index; // marker
        // create group for horizontal crossline

        crossline.addGraphicalElement({
          el: 'group',
          container: {
            id: 'thermo',
            label: 'thermo',
            isParent: true
          },
          component: crossline,
          label: crosslineId,
          attr: {
            name: 'horizontal-crossline-marker-group'
          },
          id: crosslineId
        });
        selfConfig._tagStyle.fill = (0, _lib.pluck)(selfConfig.markerFill, selfConfig._tagStyle.fill);
        selfConfig._tagStyle.stroke = (0, _lib.pluck)(selfConfig._tagStyle.stroke, selfConfig.markerFill);
        crossline.addGraphicalElement({
          el: 'path',
          attr: {
            path: markerProp.markerPath
          },
          css: selfConfig._tagStyle,
          id: 'horizontal-crossline-marker-' + index,
          container: {
            label: crosslineId
          }
        }); // text

        crossline.addGraphicalElement({
          el: 'text',
          attr: {
            text: text,
            x: markerProp.markerText.x,
            y: markerProp.markerText.y
          },
          css: selfConfig._textStyle,
          id: 'horizontal-crossline-text-' + index,
          outlineText: selfConfig.showTextOutline,
          container: {
            label: crosslineId
          }
        });
      }
    });
  };

  _proto.getHorizontalMarkerProps = function getHorizontalMarkerProps(value, index) {
    var crossline = this,
        selfConfig = crossline.config,
        scale = selfConfig.scale,
        yAxisAlignment = selfConfig.yAxisAlignment,
        padding = (0, _lib.pluckNumber)(selfConfig.padding, selfConfig._defaultPadding),
        canvasConfig = crossline.getLinkedParent().config,
        text = selfConfig.formatterFn({
      value: selfConfig.texts[index],
      type: 'crossline',
      prefix: selfConfig.prefix,
      suffix: selfConfig.suffix
    }),
        borderConfig = canvasConfig.borderConfig,
        canvasPadding = canvasConfig.padding,
        canvasLeft = canvasConfig.canvasLeft + borderConfig.leftBorder - canvasPadding.left,
        canvasWidth = canvasConfig.canvasWidth - borderConfig.rightBorder + canvasPadding.left,
        canvasRight = canvasLeft + canvasWidth,
        smartLabel = crossline.getFromEnv('smartLabel'),
        rangeValue,
        smartText,
        markerPath,
        markerText = {},
        markerProp = {};
    smartLabel.setStyle(selfConfig._textStyle);
    smartText = smartLabel.getSmartText(text);
    rangeValue = scale.getRangeValue(value);

    switch (yAxisAlignment) {
      case 'left':
        markerPath = [M, canvasLeft, rangeValue, h, -GUTTER_5, l, -GUTTER_5, -(smartText.height / 2) - 2 * padding, h, -(smartText.width + 2 * padding), v, smartText.height + 4 * padding, h, smartText.width + 2 * padding, l, GUTTER_5, -smartText.height / 2 - 2 * padding];
        markerText.x = canvasLeft - 2 * GUTTER_5 - (smartText.width + 2 * padding) / 2;
        markerText.y = rangeValue;
        break;

      case 'right':
        markerPath = [M, canvasRight, rangeValue, h, GUTTER_5, l, 2 * GUTTER_5, -(smartText.height / 2) - 2 * padding, h, smartText.width + 2 * padding, v, smartText.height + 4 * padding, h, -(smartText.width + 2 * padding), l, -(2 * GUTTER_5), -smartText.height / 2 - 2 * padding];
        markerText.x = canvasRight + 2 * GUTTER_5 + (smartText.width + 2 * padding) / 2;
        markerText.y = rangeValue;
        break;
    }

    markerProp.markerPath = markerPath;
    markerProp.markerText = markerText;
    return markerProp;
  };

  _proto.draw = function draw() {
    var crossline = this,
        config = crossline.config;
    crossline.getPathArrs().forEach(function (pathArr, index) {
      // create group for vertical cross line.
      crossline.addGraphicalElement({
        el: 'group',
        container: {
          id: 'strato',
          label: 'strato',
          isParent: true
        },
        component: crossline,
        label: 'verticalcrossline-' + index,
        attr: {
          name: 'vertical-crossline-group'
        },
        id: 'crossline-' + index
      }); // create group for horizontal cross line.

      crossline.addGraphicalElement({
        el: 'group',
        container: {
          id: 'strato',
          label: 'strato',
          isParent: true
        },
        component: crossline,
        label: 'horizontalcrossline-' + index,
        attr: {
          name: 'horizontal-crossline-group'
        },
        id: 'crossline-' + index
      });

      if (pathArr.length) {
        crossline.addGraphicalElement({
          el: 'path',
          attr: {
            path: pathArr
          },
          css: config._lineStyle,
          container: {
            label: config.type + 'crossline-' + index
          },
          id: config.type + '-crossline-path-' + index,
          component: crossline
        });
      }

      if (config.showMarker) {
        config.type === VERTICAL ? crossline.drawVerticalCrosslineText() : crossline.drawHorizontalCrosslineText();
      }
    });
  };

  return Crossline;
}(_componentInterface.SmartRenderer);

var _default = Crossline;
exports["default"] = _default;

/***/ }),

/***/ 975:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _defineProperty2 = _interopRequireDefault(__webpack_require__(273));

var _assertThisInitialized2 = _interopRequireDefault(__webpack_require__(292));

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _componentInterface = __webpack_require__(290);

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

// const DEFAULT_BUTTON_PADDING = 10;
var APPLY = 'Apply';

var Button = /*#__PURE__*/function (_SmartRenderer) {
  (0, _inheritsLoose2.default)(Button, _SmartRenderer);

  /**
   * Creates an instance of Button.
   * @param {any} id id
   * @memberof Button
   */
  function Button(id) {
    var _this;

    _this = _SmartRenderer.call(this, id) || this;
    var button = (0, _assertThisInitialized2.default)(_this),
        config = button.config;

    config.clickHandler = function () {
      button.getLinkedParent().submitData(config.type);
    }; // mouse over handler


    config.mouseoverHandler = function () {
      button.setData({
        buttonStyle: config['button:hover']
      }, true);
    }; // mouse out handler


    config.mouseoutHandler = function () {
      button.config && button.setData({
        buttonStyle: config['button:hoverout']
      }, true);
    };

    button.addEventListener('fc-click', config.clickHandler);
    button.addEventListener('fc-mouseover', config.mouseoverHandler);
    button.addEventListener('fc-mouseout', config.mouseoutHandler);
    return _this;
  }
  /**
   * sets default configuration
   *
   * @memberof Button
   */


  var _proto = Button.prototype;

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    var buttonConfig = this.config;
    buttonConfig.height = 10;
    buttonConfig.width = 20;
    buttonConfig.label = APPLY;
    buttonConfig._buttonStyle = {
      '-webkit-border-radius': '2px',
      backgroundColor: '#5648D4',
      border: '1px solid #5648D4',
      borderRadius: '2px',
      color: '#60634E',
      cursor: 'pointer',
      paddingTop: '1px',
      textAlign: 'center',
      zIndex: 21,
      display: 'flex',
      width: 66,
      height: 22,
      'line-height': '9px',
      'justify-content': 'center',
      'align-items': 'center',
      'font-size': '11px'
    };

    buttonConfig.clickHandler = function () {
      this.getLinkedParent().submitData();
    };
  }
  /**
   * configures the button
   *
   * @param {any} [inputConfig={}] configuration provided
   * @memberof Button
   */
  ;

  _proto.configureAttributes = function configureAttributes(inputConfig) {
    if (inputConfig === void 0) {
      inputConfig = {};
    }

    var button = this,
        buttonConfig = button.config,
        styleDef = button.getFromEnv('getStyleDef');
    Object.assign(buttonConfig, inputConfig);
    buttonConfig._finalStyle = Object.assign({}, buttonConfig._buttonStyle, button.getFromEnv('baseTextStyle'), styleDef(buttonConfig.customStyle), styleDef(buttonConfig.buttonStyle));
  }
  /**
   * calculates width and height of the buttons
   *
   * @returns {Object} width and height taken by the button
   * @memberof Button
   */
  ;

  _proto.getDimension = function getDimension() {
    var button = this,
        buttonConfig = button.config,
        fontSize = buttonConfig._finalStyle['font-size'],
        fontParser = button.getFromEnv('fontParser');
    buttonConfig.width = Math.max(+buttonConfig._finalStyle.width || 0, fontParser(fontSize) * 6);
    buttonConfig.height = Math.max(+buttonConfig._finalStyle.height || 0, fontParser(fontSize) * 2);
    return {
      width: buttonConfig.width,
      height: buttonConfig.height
    };
  }
  /**
   * sets the position
   *
   * @param {any} x position x
   * @param {any} y position y
   * @memberof Button
   */
  ;

  _proto.setTranslation = function setTranslation(x, y) {
    this.config.position = {
      x: x,
      y: y
    };
  }
  /**
   * Draws the button
   *
   * @memberof Button
   */
  ;

  _proto.draw = function draw() {
    var button = this,
        buttonConfig = button.config,
        position = buttonConfig.position,
        css = _objectSpread({}, buttonConfig._finalStyle);

    css['margin-bottom'] = window.innerWidth < 576 ? '15px' : '0px';
    button.addGraphicalElement({
      el: 'html',
      attr: {
        text: buttonConfig.label,
        type: 'div',
        width: buttonConfig.width,
        height: buttonConfig.height,
        x: position.x,
        y: position.y
      },
      component: button,
      container: {
        id: 'box-container',
        label: 'box-container',
        isParent: true
      },
      css: css,
      label: 'button',
      id: 'button'
    });
  };

  return Button;
}(_componentInterface.SmartRenderer);

var _default = Button;
exports["default"] = _default;

/***/ }),

/***/ 976:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _componentInterface = __webpack_require__(290);

var _lib = __webpack_require__(274);

var HIDDEN = 'hidden',
    MOBILE = 'mobile',
    DESKTOP = 'desktop',
    BODY = document.body,
    HTML = document.documentElement;

var Cover = /*#__PURE__*/function (_SmartRenderer) {
  (0, _inheritsLoose2.default)(Cover, _SmartRenderer);

  function Cover() {
    return _SmartRenderer.apply(this, arguments) || this;
  }

  var _proto = Cover.prototype;

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    _SmartRenderer.prototype.__setDefaultConfig.call(this);

    this.config.visibility = HIDDEN;
  };

  _proto.configureAttributes = function configureAttributes(inputConfig) {
    if (inputConfig === void 0) {
      inputConfig = {};
    }

    Object.assign(this.config, inputConfig);
  };

  _proto.draw = function draw() {
    var cover = this,
        height = +cover.getFromEnv('chartHeight'),
        width = +cover.getFromEnv('chartWidth'),
        mode = window.innerWidth < 576 ? MOBILE : DESKTOP,
        visibility = cover.config.visibility,
        maxHeight = Math.max(BODY.scrollHeight, BODY.offsetHeight, HTML.clientHeight, HTML.scrollHeight, HTML.offsetHeight),
        attr,
        css;

    if (mode === MOBILE) {
      attr = {
        x: 0,
        y: 0,
        width: window.innerWidth,
        height: maxHeight,
        visibility: visibility,
        type: 'div'
      };
      css = {
        position: 'fixed',
        opacity: 0.6,
        'background-color': '#cdcdcd'
      };
    } else {
      attr = {
        x: 0,
        y: 0,
        width: width,
        height: height,
        visibility: visibility,
        type: 'div'
      };
      css = {
        opacity: 1,
        'background-color': _lib.TRACKER_FILL
      };
    }

    cover.addGraphicalElement({
      el: 'html',
      attr: attr,
      css: css,
      component: cover,
      id: 'cover',
      label: 'cover'
    });
  };

  return Cover;
}(_componentInterface.SmartRenderer);

var _default = Cover;
exports["default"] = _default;

/***/ }),

/***/ 973:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _assertThisInitialized2 = _interopRequireDefault(__webpack_require__(292));

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _componentInterface = __webpack_require__(290);

var _lib = __webpack_require__(274);

var validDateLen = [2, 2, 4],

/**
 * appends a 0 in front of a number if the number is less than 10
 *
 * @param {Number} x number to checked
 */
formatDate = function formatDate(x) {
  return (x < 10 ? '0' + x : x) + '';
};

function blur(event) {
  var manager = this.getLinkedParent(),
      text = event.originalEvent.target.value + '',
      givenDate = text.split('/'),
      i,
      len = givenDate.length;

  if (len === 3) {
    for (i = 0; i < len; i++) {
      if (isNaN(givenDate[i]) || givenDate[i].length !== validDateLen[i]) {
        return;
      }
    }

    manager.updateCalendar({
      day: +givenDate[0],
      month: +givenDate[1],
      year: +givenDate[2]
    }, this.config.id);
  }
}

var DateBox = /*#__PURE__*/function (_SmartRenderer) {
  (0, _inheritsLoose2.default)(DateBox, _SmartRenderer);

  /**
   * Creates an instance of DateBox.
   * @param {any} id id
   * @memberof DateBox
   */
  function DateBox(id) {
    var _this;

    _this = _SmartRenderer.call(this, id) || this;
    var dateBox = (0, _assertThisInitialized2.default)(_this);

    _this.addEventListener('blur', blur.bind((0, _assertThisInitialized2.default)(_this)));

    _this.addEventListener('keyup', function (e) {
      dateBox.setData({
        tempDate: e.originalEvent.target.value
      });
    });

    return _this;
  }
  /**
   * sets default configurations
   *
   * @memberof DateBox
   */


  var _proto = DateBox.prototype;

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    _SmartRenderer.prototype.__setDefaultConfig.call(this);

    var dateBoxConfig = this.config;
    dateBoxConfig.enabled = true;
    dateBoxConfig.inputBoxWidth = 65;
    dateBoxConfig.tempDate = false; // dateBoxConfig.label = 'From: ';

    dateBoxConfig._labelStyle = {
      'font-size': '12px',
      'font-weight': 'normal',
      'font-style': 'normal',
      color: '#5F5F5F'
    };
    dateBoxConfig._inputStyle = {
      'font-size': '12px',
      border: '1px solid #efefef',
      'background-color': '#fcfcfc',
      color: '#5F5F5F',
      width: dateBoxConfig.inputBoxWidth + _lib.PXSTRING,
      padding: '2px'
    };
    dateBoxConfig.date = {
      day: 8,
      month: 10,
      year: 2018
    };
  }
  /**
   * configures the components
   *
   * @param {Object} [inputConfig={}] configuration provided by user
   * @memberof DateBox
   */
  ;

  _proto.configureAttributes = function configureAttributes(inputConfig) {
    if (inputConfig === void 0) {
      inputConfig = {};
    }

    _SmartRenderer.prototype.configureAttributes.call(this, inputConfig);

    var dateBox = this,
        config = dateBox.config,
        curDate,
        styleDef = dateBox.getFromEnv('getStyleDef'),
        baseTextStyle = dateBox.getFromEnv('baseTextStyle');
    Object.assign(config, inputConfig);
    curDate = config.date;
    config.value = formatDate(curDate.day) + "/" + formatDate(curDate.month) + "/" + formatDate(curDate.year);
    config._finalLabelStyle = Object.assign({}, config._labelStyle, baseTextStyle, styleDef(config.labelStyle));
    config._finalInputStyle = Object.assign({}, config._inputStyle, baseTextStyle, styleDef(config.inputStyle)); // for html element line-height should not be applied through css as it distorts the height of the elements

    delete config._finalInputStyle['line-height'];
  }
  /**
   * calculates the space taken by this component
   *
   * @returns {Object} width and height
   * @memberof DateBox
   */
  ;

  _proto.getDimension = function getDimension() {
    var dateBox = this,
        dateBoxConfig = dateBox.config,
        labelDim,
        smartLabel = dateBox.getFromEnv('smartLabel'),
        fontParser = dateBox.getFromEnv('fontParser'),
        fSize = fontParser(dateBoxConfig._finalInputStyle['font-size']);
    smartLabel.setStyle(Object.assign({}, dateBoxConfig._finalLabelStyle));
    dateBoxConfig.labelDim = labelDim = smartLabel.getOriSize(dateBoxConfig.label);
    smartLabel.setStyle(Object.assign({}, dateBoxConfig._finalInputStyle)); // add extra 10px space in the input box to make it look good

    dateBoxConfig.inputBoxWidth = smartLabel.getOriSize(dateBoxConfig.value).width + 10;
    dateBoxConfig._finalInputStyle.width = Math.max(65, dateBoxConfig.inputBoxWidth) + _lib.PXSTRING;
    return {
      width: labelDim.width + dateBoxConfig.inputBoxWidth,
      height: Math.max(smartLabel._lineHeight, fSize * 1.5)
    };
  }
  /**
   * setter method, takes position where the component is to be placed
   *
   * @param {Number} x pos x
   * @param {Number} y pos y
   * @memberof DateBox
   */
  ;

  _proto.setTranslation = function setTranslation(x, y) {
    this.config.position = {
      x: x,
      y: y
    };
  }
  /**
   * draws the elements
   *
   * @memberof DateBox
   */
  ;

  _proto.draw = function draw() {
    var dateBox = this,
        dateBoxConfig = dateBox.config,
        position = dateBoxConfig.position,
        labelDim = dateBoxConfig.labelDim,
        curDate = dateBoxConfig.date || {},
        value = formatDate(curDate.day) + "/" + formatDate(curDate.month) + "/" + formatDate(curDate.year); // create the label

    dateBox.addGraphicalElement({
      el: 'html',
      attr: {
        x: position.x,
        y: position.y,
        type: 'div',
        text: dateBoxConfig.label
      },
      component: dateBox,
      css: dateBoxConfig._finalLabelStyle,
      container: {
        id: 'box-container',
        label: 'box-container',
        isParent: true
      },
      label: 'label',
      id: 'label'
    });
    dateBoxConfig._finalInputStyle.width = dateBoxConfig.inputBoxWidth + _lib.PXSTRING; // create the input box

    dateBox.addGraphicalElement({
      el: 'html',
      attr: {
        x: position.x + labelDim.width,
        y: position.y - labelDim.height / 3,
        type: 'input',
        name: dateBoxConfig.label,
        value: dateBoxConfig.tempDate || value
      },
      component: dateBox,
      css: dateBoxConfig._finalInputStyle,
      container: {
        id: 'box-container',
        label: 'box-container',
        isParent: true
      },
      label: 'box',
      id: 'box'
    });
  };

  return DateBox;
}(_componentInterface.SmartRenderer);

var _default = DateBox;
exports["default"] = _default;

/***/ }),

/***/ 969:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _componentInterface = __webpack_require__(290);

var _selectorTool = _interopRequireDefault(__webpack_require__(970));

var CustomRangeSelector = /*#__PURE__*/function (_SmartRenderer) {
  (0, _inheritsLoose2.default)(CustomRangeSelector, _SmartRenderer);

  function CustomRangeSelector() {
    return _SmartRenderer.apply(this, arguments) || this;
  }

  var _proto = CustomRangeSelector.prototype;

  /**
   * configures the component
   *
   * @param {any} [inputConfig={}] configuration
   * @memberof CustomRangeSelector
   */
  _proto.configureAttributes = function configureAttributes(inputConfig) {
    if (inputConfig === void 0) {
      inputConfig = {};
    }

    Object.assign(this.config, inputConfig);
  }
  /**
   * Called when the event 'focusLimitChanged' is triggered
   *
   * @memberof CustomRangeSelector
   */
  ;

  _proto.updateOnLimitChange = function updateOnLimitChange() {
    this.setData({
      domain: this.getFromEnv('chart').getFocusLimit(),
      limitChanged: true
    }, true);
  }
  /**
   * returns the tool requirements of this components
   *
   * @returns {Object} requirements
   * @memberof CustomRangeSelector
   */
  ;

  _proto.getToolInfo = function getToolInfo() {
    var styleObj = Object.assign({}, this.config.style);
    styleObj['title:hoverout'] = {
      title: styleObj['title-text'],
      icon: styleObj['title-icon']
    };
    return {
      'selector-0': {
        type: 'tool',
        def: _selectorTool.default,
        configuration: {
          domain: this.config.domain,
          hAlign: 'right',
          scale: 1,
          marginTop: 2,
          marginBottom: 2,
          marginLeft: 2,
          marginRight: 2,
          extStyle: styleObj,
          limitChanged: this.config.limitChanged
        }
      }
    };
  };

  return CustomRangeSelector;
}(_componentInterface.SmartRenderer);

var _default = CustomRangeSelector;
exports["default"] = _default;

/***/ }),

/***/ 971:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = exports.formatDate = void 0;

var _assertThisInitialized2 = _interopRequireDefault(__webpack_require__(292));

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _componentInterface = __webpack_require__(290);

var _fcCalendar = _interopRequireDefault(__webpack_require__(972));

var _lib = __webpack_require__(274);

var _dateBox = _interopRequireDefault(__webpack_require__(973));

var _timeBox = _interopRequireDefault(__webpack_require__(974));

var _button = _interopRequireDefault(__webpack_require__(975));

var _isObject = _interopRequireDefault(__webpack_require__(481));

var _language_maps = __webpack_require__(534);

var DEFAULT_CALENDAR_GAP = 25,
    DEFAULT_VERTICAL_PADDING = 8,
    DEFAULT_HORIZONTAL_PADDING = 5,
    DEFAULT_WIDGET_FONT_SIZE = 11,
    CALENDAR_KEY = 'cal-',
    CALENDAR_KEY_LEN = CALENDAR_KEY.length,
    MOBILE = 'mobile',
    DESKTOP = 'desktop',
    ENGLISH = 'english',
    LANGUAGE = 'language',
    getCssObj = function getCssObj(obj, getStyleDef) {
  var output = {};

  if ((0, _isObject.default)(obj)) {
    for (var key in obj) {
      if (obj.hasOwnProperty(key) && key.startsWith(CALENDAR_KEY)) {
        output[key.substring(CALENDAR_KEY_LEN)] = getStyleDef(obj[key]);
      }
    }
  }

  return output;
},

/**
 * appends a 0 in front of a number if the number is less than 10
 *
 * @param {Number} x number to checked
 */
formatDate = function formatDate(x) {
  return (x < 10 ? '0' + x : x) + '';
},

/**
 * checks if a given date is with two date ranges
 *
 * @param {Object} date date
 * @param {Object} start start date
 * @param {Object} end end date
 * @returns {boolean} whether the date lies between start and end
 */
isWithinDate = function isWithinDate(date, start, end) {
  var startDate = new Date(start.year, start.month, start.day),
      endDate = new Date(end.year, end.month, end.day),
      curDate = new Date(date.year, date.month, date.day);

  if (+curDate >= +startDate && +curDate <= +endDate) {
    return true;
  }

  return false;
};

exports.formatDate = formatDate;

var CustomRangeManager = /*#__PURE__*/function (_SmartRenderer) {
  (0, _inheritsLoose2.default)(CustomRangeManager, _SmartRenderer);

  function CustomRangeManager(id) {
    var _this;

    _this = _SmartRenderer.call(this, id) || this;
    var manager = (0, _assertThisInitialized2.default)(_this);
    manager.addToEnv('fontParser', function (fontsizeArg) {
      var fontsize = parseFloat(fontsizeArg);
      return isNaN(fontsize) ? DEFAULT_WIDGET_FONT_SIZE : fontsize;
    });
    return _this;
  }
  /**
   * sets default configuration
   *
   * @memberof CustomRangeManager
   */


  var _proto = CustomRangeManager.prototype;

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    var managerConfig = this.config;
    managerConfig.paddingLeft = 10;
    managerConfig.paddingRight = 10;
    managerConfig.paddingTop = 15;
    managerConfig.paddingBottom = 15;
    managerConfig.prevVisibility = 'hidden'; // default fallback values

    managerConfig.contextStart = {
      year: 1970,
      month: 1,
      day: 1
    };
    managerConfig.contextEnd = {
      year: 2070,
      month: 1,
      day: 1
    };
    managerConfig.calendarDim = {
      height: 191,
      width: 163
    };
    this._calendars = {};
    managerConfig._backgroundStyle = {
      'font-size': DEFAULT_WIDGET_FONT_SIZE + _lib.PXSTRING,
      'font-family': 'Verdana,sans-serif',
      border: '1px solid #cdcdcd',
      position: 'absolute',
      'border-radius': '0px',
      'overflow-y': 'visible',
      'background-color': '#ffffff'
    };
    managerConfig._mobileBgStyle = Object.assign({}, managerConfig._backgroundStyle, {
      position: 'fixed',
      'overflow-y': 'scroll',
      'border-radius': '10px'
    });
    managerConfig._pointerStyle = {
      'font-size': DEFAULT_WIDGET_FONT_SIZE + _lib.PXSTRING,
      'font-family': 'Verdana,sans-serif',
      'border-left': '1px solid #cdcdcd',
      'border-right': '0px solid #cdcdcd',
      'border-top': '1px solid #cdcdcd',
      'border-bottom': '0px solid #cdcdcd',
      transform: 'rotate(45deg)',
      'background-color': '#ffffff'
    };
  }
  /**
   * configures the components
   *
   * @param {any} [inputConfig={}] configurations
   * @memberof CustomRangeManager
   */
  ;

  _proto.configureAttributes = function configureAttributes(inputConfig) {
    var _this$getFromEnv;

    if (inputConfig === void 0) {
      inputConfig = {};
    }

    var manager = this,
        managerConfig = manager.config,
        calendars = manager.getCalendars(),
        extStyle,
        styleDef = manager.getFromEnv('getStyleDef'),
        baseTextStyle = manager.getFromEnv('baseTextStyle'),
        lang = (_this$getFromEnv = this.getFromEnv(LANGUAGE)) != null ? _this$getFromEnv : ENGLISH,
        leftDateBoxLabel = _language_maps.dateBoxLabelMap[lang].From,
        rightDateBoxLabel = _language_maps.dateBoxLabelMap[lang].To,
        submitButtonLabel = _language_maps.crsButtonLabelsMap[lang].apply,
        cancelButtonLabel = _language_maps.crsButtonLabelsMap[lang].cancel,
        tempDate,
        leftDateConfig,
        rightDateConfig,
        applyButtonStyle,
        cancelButtonStyle;
    Object.assign(managerConfig, inputConfig);
    extStyle = managerConfig.extStyle;

    if (managerConfig.visibility !== managerConfig.prevVisibility) {
      /**
       * date-selection input box should take the focus limit when the widget is opened
       * by interacting with the crs tool. In other cases, the date input box should always
       * show the temporary date that is typed in it, hence the flag tempDate.
       * */
      tempDate = false;
      managerConfig.blockUpdate = false;
    } else {
      managerConfig.blockUpdate = true;
    }

    managerConfig.prevVisibility = managerConfig.visibility; // no need to configure the calendar widget components when it is not displayed

    if (managerConfig.visibility !== 'visible') {
      // remove the calendars if present
      if (calendars.left) {
        calendars.left.dispose();
        delete calendars.left;
      } // remove the calendars if present


      if (calendars.right) {
        calendars.right.dispose();
        delete calendars.right;
      }

      return;
    }

    leftDateConfig = {
      label: leftDateBoxLabel,
      date: managerConfig.leftCalSelectedDate,
      id: 'left',
      labelStyle: extStyle.label,
      inputStyle: extStyle.input
    };
    rightDateConfig = {
      label: rightDateBoxLabel,
      date: managerConfig.rightCalSelectedDate,
      id: 'right',
      labelStyle: extStyle.label,
      inputStyle: extStyle.input
    };

    if (typeof tempDate !== 'undefined') {
      leftDateConfig.tempDate = rightDateConfig.tempDate = tempDate;
    }

    manager.attachChild(_dateBox.default, 'left-date', 'left-date').configure(leftDateConfig);
    manager.attachChild(_dateBox.default, 'right-date', 'right-date').configure(rightDateConfig); // only create time box when either major and/or minor intervals are in time

    if (managerConfig.showTime) {
      manager.attachChild(_timeBox.default, 'left-time', 'left-time').configure({
        time: managerConfig.leftCalSelectedDate,
        labelStyle: extStyle.label,
        selectStyle: extStyle.select
      });
      manager.attachChild(_timeBox.default, 'right-time', 'right-time').configure({
        time: managerConfig.rightCalSelectedDate,
        labelStyle: extStyle.label,
        selectStyle: extStyle.select
      });
    }

    if (extStyle['button-apply']) {
      applyButtonStyle = Object.assign({}, baseTextStyle, extStyle['button-apply']);
    } else {
      applyButtonStyle = Object.assign({
        color: '#ffffff',
        'font-size': DEFAULT_WIDGET_FONT_SIZE + _lib.PXSTRING
      }, baseTextStyle);
    }

    manager.attachChild(_button.default, 'apply', 'apply').configure({
      label: submitButtonLabel,
      type: 'submit',
      customStyle: applyButtonStyle,
      buttonStyle: applyButtonStyle,
      'button:hoverout': applyButtonStyle,
      'button:hover': extStyle['button-apply:hover'] || {}
    });

    if (extStyle['button-cancel']) {
      cancelButtonStyle = Object.assign({}, baseTextStyle, extStyle['button-cancel']);
    } else {
      cancelButtonStyle = Object.assign({
        backgroundColor: '#ffffff',
        color: '#7A7A7A',
        border: '0px',
        'font-size': DEFAULT_WIDGET_FONT_SIZE + _lib.PXSTRING
      }, baseTextStyle);
    }

    manager.attachChild(_button.default, 'cancel', 'cancel').configure({
      label: cancelButtonLabel,
      type: 'cancel',
      customStyle: cancelButtonStyle,
      buttonStyle: cancelButtonStyle,
      'button:hoverout': cancelButtonStyle,
      'button:hover': extStyle['button-cancel:hover'] || {}
    });
    managerConfig._finalBackgroundStyle = Object.assign({}, managerConfig._backgroundStyle, styleDef(extStyle.container));
    managerConfig._finalMobileBgStyle = Object.assign({}, managerConfig._mobileBgStyle, styleDef(extStyle.container));
    managerConfig._finalPointerStyle = Object.assign({}, managerConfig._pointerStyle, styleDef(extStyle.container));

    if (managerConfig._finalPointerStyle.border) {
      managerConfig._finalPointerStyle['border-left'] = managerConfig._finalPointerStyle['border-top'] = managerConfig._finalPointerStyle.border;
    }

    managerConfig._finalPointerStyle['border-right'] = managerConfig._finalPointerStyle['border-bottom'] = '0px';
    delete managerConfig._finalPointerStyle.border;
    managerConfig.calStyle = getCssObj(managerConfig.extStyle, manager.getFromEnv('getStyleDef'));
  };

  _proto.manageSpace = function manageSpace(mode) {
    if (mode === void 0) {
      mode = DESKTOP;
    }

    if (mode === DESKTOP) {
      this.manageSpaceLG();
    } else {
      this.manageSpaceSM();
    }
  };

  _proto.manageSpaceSM = function manageSpaceSM() {
    var manager = this,
        managerConfig = manager.config,
        clientHeight = document.documentElement.clientHeight,
        clientWidth = document.documentElement.clientWidth,
        maxAllowedHeight = 0.8 * clientHeight,
        fromDate,
        toDate,
        fromTime,
        toTime,
        fromTimeDim = {
      height: 0,
      width: 0
    },
        toTimeDim = {
      height: 0,
      width: 0
    },
        fromLabelBoxDim,
        toLabelBoxDim,
        apply,
        cancel,
        xPos,
        availableWidth,
        paddingLeft = 50,
        paddingRight = 50,
        curYPos = managerConfig.paddingTop,
        calendarDim = managerConfig.calendarDim,
        applyDim,
        cancelDim; // no need to configure the calendar widget components when it is not displayed

    if (managerConfig.visibility !== 'visible') {
      return;
    }

    fromDate = manager.getChildren('left-date')[0];
    toDate = manager.getChildren('right-date')[0];
    fromTime = manager.getChildren('left-time');
    toTime = manager.getChildren('right-time');
    apply = manager.getChildren('apply')[0];
    cancel = manager.getChildren('cancel')[0]; // consider spaces for time selector box when time is to be shown

    if (fromTime) {
      fromTime = fromTime[0];
      fromTimeDim = fromTime.getDimension();
    }

    if (toTime) {
      toTime = toTime[0];
      toTimeDim = toTime.getDimension();
    }

    fromLabelBoxDim = fromDate.getDimension();
    toLabelBoxDim = toDate.getDimension();
    applyDim = apply.getDimension();
    cancelDim = cancel.getDimension();
    availableWidth = Math.max(calendarDim.width, fromLabelBoxDim.width, toLabelBoxDim.width, fromTimeDim.width, toTimeDim.width, applyDim.width + cancelDim.width + DEFAULT_VERTICAL_PADDING);
    fromDate.setTranslation(paddingLeft, curYPos);
    xPos = paddingLeft + availableWidth / 2 - calendarDim.width / 2;
    curYPos += fromLabelBoxDim.height + DEFAULT_VERTICAL_PADDING;
    managerConfig.leftCalendarPosition = {
      x: xPos,
      y: curYPos
    };
    curYPos += calendarDim.height + DEFAULT_VERTICAL_PADDING;
    fromTime && fromTime.setTranslation(paddingLeft, curYPos);
    curYPos += fromTimeDim.height + 2 * DEFAULT_VERTICAL_PADDING;
    toDate.setTranslation(paddingLeft, curYPos);
    xPos = paddingLeft + availableWidth / 2 - calendarDim.width / 2;
    curYPos += toLabelBoxDim.height + DEFAULT_VERTICAL_PADDING;
    managerConfig.rightCalendarPosition = {
      x: xPos,
      y: curYPos
    };
    curYPos += calendarDim.height + DEFAULT_VERTICAL_PADDING;
    toTime && toTime.setTranslation(paddingLeft, curYPos);
    curYPos += toTimeDim.height + DEFAULT_VERTICAL_PADDING;
    apply.setTranslation(paddingLeft, curYPos);
    cancel.setTranslation(paddingLeft + applyDim.width + DEFAULT_VERTICAL_PADDING, curYPos);

    if (maxAllowedHeight > curYPos + applyDim.height + managerConfig.paddingBottom) {
      managerConfig.height = curYPos + applyDim.height + managerConfig.paddingBottom;
      managerConfig.y = clientHeight / 2 - managerConfig.height / 2;
    } else {
      managerConfig.height = maxAllowedHeight;
      managerConfig.y = 0.1 * clientHeight;
    }

    managerConfig.width = calendarDim.width + paddingLeft + paddingRight;
    managerConfig.x = clientWidth / 2 - managerConfig.width / 2;
  }
  /**
   * Space management and positioning of all the internal component within this container
   *
   * @memberof CustomRangeManager
   */
  ;

  _proto.manageSpaceLG = function manageSpaceLG() {
    var manager = this,
        managerConfig = manager.config,
        fromLabelBoxDim,
        toLabelBoxDim,
        timeBoxPaddingFactor = 4,
        fromDate,
        toDate,
        fromTime,
        toTime,
        apply,
        cancel,
        maxSpaceTakenOnLeft = 0,
        maxSpaceTakenOnRight = 0,
        fromTimeDim = {
      height: 0,
      width: 0
    },
        toTimeDim = {
      height: 0,
      width: 0
    },
        applyDim,
        cancelDim,
        calendarDim = managerConfig.calendarDim,
        tool = manager.getLinkedParent(),
        position = tool.config.containerPos; // no need to configure the calendar widget components when it is not displayed

    if (managerConfig.visibility !== 'visible') {
      return;
    }

    fromDate = manager.getChildren('left-date')[0];
    toDate = manager.getChildren('right-date')[0];
    fromTime = manager.getChildren('left-time');
    toTime = manager.getChildren('right-time');
    apply = manager.getChildren('apply')[0];
    cancel = manager.getChildren('cancel')[0]; // consider spaces for time selector box when time is to be shown

    if (fromTime) {
      fromTime = fromTime[0];
      fromTimeDim = fromTime.getDimension();
    }

    if (toTime) {
      toTime = toTime[0];
      toTimeDim = toTime.getDimension();
    }

    !fromTimeDim.height && (timeBoxPaddingFactor = 2);
    fromLabelBoxDim = fromDate.getDimension();
    toLabelBoxDim = toDate.getDimension();
    applyDim = apply.getDimension();
    cancelDim = cancel.getDimension();
    maxSpaceTakenOnLeft = Math.max(fromTimeDim.width, fromLabelBoxDim.width, calendarDim.width);
    managerConfig.leftCalendarPosition = {
      x: managerConfig.paddingLeft,
      y: managerConfig.paddingTop + fromLabelBoxDim.height + DEFAULT_VERTICAL_PADDING
    };
    managerConfig.rightCalendarPosition = {
      x: managerConfig.paddingLeft + maxSpaceTakenOnLeft + DEFAULT_CALENDAR_GAP,
      y: managerConfig.paddingTop + toLabelBoxDim.height + DEFAULT_VERTICAL_PADDING
    };
    fromDate.setTranslation(managerConfig.paddingLeft, managerConfig.paddingTop);
    toDate.setTranslation(managerConfig.paddingLeft + maxSpaceTakenOnLeft + DEFAULT_CALENDAR_GAP, managerConfig.paddingTop);
    fromTime && fromTime.setTranslation(managerConfig.paddingLeft, managerConfig.leftCalendarPosition.y + calendarDim.height + 2 * DEFAULT_VERTICAL_PADDING);
    toTime && toTime.setTranslation(managerConfig.paddingLeft + maxSpaceTakenOnLeft + DEFAULT_CALENDAR_GAP, managerConfig.rightCalendarPosition.y + calendarDim.height + 2 * DEFAULT_VERTICAL_PADDING);
    apply.setTranslation(managerConfig.paddingLeft, managerConfig.leftCalendarPosition.y + calendarDim.height + timeBoxPaddingFactor * DEFAULT_VERTICAL_PADDING + fromTimeDim.height);
    cancel.setTranslation(managerConfig.paddingLeft + applyDim.width + DEFAULT_HORIZONTAL_PADDING, managerConfig.leftCalendarPosition.y + calendarDim.height + timeBoxPaddingFactor * DEFAULT_VERTICAL_PADDING + fromTimeDim.height);
    maxSpaceTakenOnRight = Math.max(managerConfig.paddingLeft + applyDim.width + DEFAULT_HORIZONTAL_PADDING + cancelDim.width, managerConfig.rightCalendarPosition.x + calendarDim.width, managerConfig.paddingLeft + maxSpaceTakenOnLeft + DEFAULT_CALENDAR_GAP + toTimeDim.width, managerConfig.paddingLeft + maxSpaceTakenOnLeft + DEFAULT_CALENDAR_GAP + toLabelBoxDim.width);
    managerConfig.width = maxSpaceTakenOnRight + managerConfig.paddingRight;
    managerConfig.height = managerConfig.leftCalendarPosition.y + calendarDim.height + applyDim.height + timeBoxPaddingFactor * DEFAULT_VERTICAL_PADDING + fromTimeDim.height + managerConfig.paddingBottom;
    managerConfig.x = position.x - managerConfig.width / 2;
    managerConfig.y = position.y + DEFAULT_VERTICAL_PADDING / 2;
  };

  _proto.isWithinWidget = function isWithinWidget(x, y) {
    var config = this.config,
        left = config.x,
        top = config.y,
        bottom = top + config.height,
        right = left + config.width;
    return x > left && x < right && y > top && y < bottom;
  }
  /**
   * draws the container
   *
   * @memberof CustomRangeManager
   */
  ;

  _proto.draw = function draw() {
    var _this$getFromEnv2;

    var manager = this,
        managerConfig = manager.config,
        _finalMobileBgStyle = managerConfig._finalMobileBgStyle,
        _finalBackgroundStyle = managerConfig._finalBackgroundStyle,
        mode = managerConfig.visualMode = window.innerWidth < 576 ? MOBILE : DESKTOP,
        bgStyle = mode === MOBILE ? _finalMobileBgStyle : _finalBackgroundStyle;
    managerConfig.language = (_this$getFromEnv2 = this.getFromEnv('language')) != null ? _this$getFromEnv2 : ENGLISH;
    if (managerConfig.visibility === 'hidden') return;

    if (mode === MOBILE) {
      bgStyle['overflow-y'] = 'scroll';
    }

    manager.manageSpace(mode); // main container

    manager.addGraphicalElement({
      el: 'html',
      attr: {
        x: managerConfig.x,
        y: managerConfig.y,
        width: managerConfig.width,
        height: managerConfig.height,
        type: 'div',
        fill: 'ffffff',
        display: 'block',
        class: 'fc-crs-widget',
        visibility: managerConfig.visibility
      },
      css: bgStyle,
      component: manager,
      label: 'box-container',
      id: 'box-container'
    });
    mode !== MOBILE && manager.addGraphicalElement({
      el: 'html',
      attr: {
        x: managerConfig.width / 2 - 10,
        y: -9,
        width: 15,
        height: 15,
        type: 'div',
        display: 'block',
        visibility: managerConfig.visibility
      },
      css: managerConfig._finalPointerStyle,
      container: {
        label: 'box-container',
        id: 'box-container'
      },
      component: manager,
      label: 'box-pointer',
      id: 'box-pointer'
    });
    managerConfig.drawCalendars && manager.drawCalendars();
    managerConfig.mode = mode;
  }
  /**
   * getter method for calendars
   *
   * @returns {Object} object containing the two calendars
   * @memberof CustomRangeManager
   */
  ;

  _proto.getCalendars = function getCalendars() {
    return this._calendars;
  }
  /**
   * configures and updates the visuals of the calendars
   *
   * @memberof CustomRangeManager
   */
  ;

  _proto.drawCalendars = function drawCalendars() {
    var manager = this,
        config = manager.config,
        calendars = manager.getCalendars(),
        leftCalendarPosition = config.leftCalendarPosition,
        rightCalendarPosition = config.rightCalendarPosition,
        container = manager.getGraphicalElement('box-container', 'box-container').element,
        mode = window.innerWidth < 576 ? MOBILE : DESKTOP,
        curCalendarDim,
        calStyle = config.calStyle,
        language = config.language;

    if (config.mode === mode && config.blockUpdate && calendars.left && calendars.right) {
      return;
    }

    if (!calendars.left) {
      calendars.left = new _fcCalendar.default({
        weekLabel: _language_maps.weekLabelMap[language],
        monthLabel: _language_maps.monthsMap[language],
        selectedDate: config.leftCalSelectedDate,
        posX: leftCalendarPosition.x,
        posY: leftCalendarPosition.y,
        container: container,
        id: 'left',
        rangeStart: config.contextStart,
        rangeEnd: config.contextEnd,
        showInactiveMonths: true,
        customCssClass: calStyle,
        language: language,
        events: {
          onDateChange: function onDateChange(date) {
            manager.updateDate(date, 'left');
          },
          onMonthChange: function onMonthChange(date) {
            manager.updateDate(date, 'left');
          },
          onYearChange: function onYearChange(date) {
            manager.updateDate(date, 'left');
          }
        },
        'font-family': _lib.DEFAULT_FT_FONT + ' !important'
      });
    } else {
      calendars.left.configure({
        weekLabel: _language_maps.weekLabelMap[language],
        monthLabel: _language_maps.monthsMap[language],
        selectedDate: config.leftCalSelectedDate,
        posX: leftCalendarPosition.x,
        posY: leftCalendarPosition.y,
        rangeStart: config.contextStart,
        rangeEnd: config.contextEnd,
        customCssClass: calStyle,
        showInactiveMonths: true,
        container: container,
        language: language
      });
    }

    if (!calendars.right) {
      calendars.right = new _fcCalendar.default({
        weekLabel: _language_maps.weekLabelMap[language],
        monthLabel: _language_maps.monthsMap[language],
        selectedDate: config.rightCalSelectedDate,
        posX: rightCalendarPosition.x,
        posY: rightCalendarPosition.y,
        rangeStart: config.contextStart,
        rangeEnd: config.contextEnd,
        showInactiveMonths: true,
        customCssClass: calStyle,
        language: language,
        container: container,
        id: 'right',
        events: {
          onDateChange: function onDateChange(date) {
            manager.updateDate(date, 'right');
          },
          onMonthChange: function onMonthChange(date) {
            manager.updateDate(date, 'right');
          },
          onYearChange: function onYearChange(date) {
            manager.updateDate(date, 'right');
          }
        },
        'font-family': _lib.DEFAULT_FT_FONT + ' !important'
      });
    } else {
      calendars.right.configure({
        weekLabel: _language_maps.weekLabelMap[language],
        monthLabel: _language_maps.monthsMap[language],
        selectedDate: config.rightCalSelectedDate,
        posX: rightCalendarPosition.x,
        posY: rightCalendarPosition.y,
        rangeStart: config.contextStart,
        rangeEnd: config.contextEnd,
        customCssClass: calStyle,
        showInactiveMonths: true,
        container: container,
        language: language
      });
    }

    curCalendarDim = calendars.left.getDimension(); // if calendar dimension is changed, redraw.

    if (curCalendarDim.width !== config.calendarDim.width || curCalendarDim.height !== config.calendarDim.height) {
      config.calendarDim = curCalendarDim;
      manager.asyncDraw();
    }
  }
  /**
   * update the date based on the date chosen in the calendar
   *
   * @param {any} date date
   * @param {any} id id of the calendar
   * @memberof CustomRangeManager
   */
  ;

  _proto.updateDate = function updateDate(date, id) {
    var manager = this,
        labelBox = manager.getChildren(id + '-date')[0],
        element = labelBox.getGraphicalElement('box', 'box');
    labelBox.setData({
      date: date,
      tempDate: false
    }, true);
    element.element.value = formatDate(date.day) + "/" + formatDate(date.month) + "/" + formatDate(date.year);
  }
  /**
   * update the calendar based on the date in the input box
   *
   * @param {any} date date
   * @param {any} id id of the calendar
   * @memberof CustomRangeManager
   */
  ;

  _proto.updateCalendar = function updateCalendar(date, id) {
    var manager = this,
        managerConfig = manager.config,
        calendars = manager.getCalendars(),
        selectedDate = managerConfig[id + 'CalSelectedDate']; // If date is within the given date, select it. Else ignore

    if (isWithinDate(date, managerConfig.contextStart, managerConfig.contextEnd)) {
      managerConfig[id + 'CalSelectedDate'] = date;
      selectedDate.day = date.day;
      selectedDate.month = date.month;
      selectedDate.year = date.year;
      calendars[id] && calendars[id].configure({
        selectedDate: date
      });
    } else {
      manager.getChildren(id + '-date')[0].setData({}, true);
    }
  }
  /**
   * When apply button is pressed, this api summons the domainValidator method of the chart
   * and updates the visuals
   *
   * @param {string} [type='cancel'] type of operation, can be 'apply' or 'cancel'
   * @memberof CustomRangeManager
   */
  ;

  _proto.submitData = function submitData(type) {
    var _this$getFromEnv3;

    if (type === void 0) {
      type = 'cancel';
    }

    var manager = this,
        rangeSelector = manager.getLinkedParent(),
        chart = rangeSelector.getFromEnv('chart'),
        scale = chart.getFromEnv('contextScalesX')[0],
        curDomain = [],
        calendars = manager.getCalendars(),
        isUTC = chart.getFromEnv('UTC'),
        leftDate = calendars.left.getDate(),
        rightDate = calendars.right.getDate(),
        fromTimeComp = manager.getChildren('left-time'),
        toTimeComp = manager.getChildren('right-time'),
        formattedDateTexts,
        showTimeInLabel,
        language = (_this$getFromEnv3 = this.getFromEnv('language')) != null ? _this$getFromEnv3 : ENGLISH,
        d1,
        d2,
        fromTime = {
      hours: 0,
      minutes: 0,
      seconds: 0
    },
        toTime = {
      hours: 0,
      minutes: 0,
      seconds: 0
    }; // update time if time box is present

    if (fromTimeComp) {
      fromTime = fromTimeComp[0].getTime();
    }

    if (toTimeComp) {
      toTime = toTimeComp[0].getTime();
    }

    rangeSelector.setData({}, true);

    if (type === 'submit') {
      d1 = isUTC ? Date.UTC(leftDate.year, leftDate.month - 1, leftDate.day, fromTime.hours, fromTime.minutes, fromTime.seconds) : new Date(leftDate.year, leftDate.month - 1, leftDate.day, fromTime.hours, fromTime.minutes, fromTime.seconds);
      d2 = isUTC ? Date.UTC(rightDate.year, rightDate.month - 1, rightDate.day, toTime.hours, toTime.minutes, toTime.seconds) : new Date(rightDate.year, rightDate.month - 1, rightDate.day, toTime.hours, toTime.minutes, toTime.seconds);
      curDomain.push(+d1);
      curDomain.push(+d2);
      chart.setFocusLimit(curDomain);
      showTimeInLabel = rangeSelector.decideTimeInLabel();
      formattedDateTexts = scale.getFormattedTime({
        dateRange: {
          startDate: d1,
          endDate: d2
        },
        type: 'CRS',
        showTimeInLabel: showTimeInLabel,
        language: language
      }).split(' - ');
      chart.fireChartInstanceEvent('customRangeSelect', {
        start: +d1,
        end: +d2,
        startText: formattedDateTexts[0],
        endText: formattedDateTexts[1],
        formatter: '%b %d, %Y' + (showTimeInLabel ? ', %H:%M:%S' : '') // static formatting of date in CRS

      });
    }

    rangeSelector.removeDocumentListener();
  };

  return CustomRangeManager;
}(_componentInterface.SmartRenderer);

var _default = CustomRangeManager;
exports["default"] = _default;

/***/ }),

/***/ 970:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _assertThisInitialized2 = _interopRequireDefault(__webpack_require__(292));

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _manager = _interopRequireDefault(__webpack_require__(971));

var _toolbox = __webpack_require__(418);

var _lib = __webpack_require__(274);

var _cover = _interopRequireDefault(__webpack_require__(976));

var _fusionEventWrapper = _interopRequireDefault(__webpack_require__(319));

// import { SmartRenderer } from '@fusioncharts/core/src/component-interface';
var TIME_INTERVALS = ['hour', 'minute', 'second', 'millisecond'],
    VISIBLE = 'visible',
    NORMAL = 'normal',
    CRS = 'CRS',
    SPACE_BETWEEN_ICON_AND_TEXT = 5,
    SCALING_STEP_VALUE = 0.0278,
    BLANK = '',
    LANGUAGE = 'language',
    CALENDAR_ICON_PATH = 'M15.604605,2.6231875 C15.3617479,2.39715625 15.0736134,2.284125 14.7409412,2.284125 L13.5126723,2.284125 L13.5126723,1.4275625 C13.5126723,1.0350625 13.3621849,0.69896875 13.0615126,0.41940625 C12.7606723,0.13984375 12.3993613,0 11.9769748,0 L11.3629244,0 C10.9405714,0 10.5791261,0.13984375 10.2784202,0.4194375 C9.97761345,0.69896875 9.8272605,1.03509375 9.8272605,1.42759375 L9.8272605,2.28415625 L6.14221849,2.28415625 L6.14221849,1.42759375 C6.14221849,1.03509375 5.99179832,0.699 5.69105882,0.4194375 C5.39038655,0.13984375 5.02890756,0 4.60655462,0 L3.99240336,0 C3.57015126,0 3.20863866,0.13984375 2.90789916,0.4194375 C2.60722689,0.69896875 2.45677311,1.03509375 2.45677311,1.42759375 L2.45677311,2.28415625 L1.22847059,2.28415625 C0.895697479,2.28415625 0.607831933,2.3971875 0.364705882,2.62321875 C0.121579832,2.84921875 0,3.11696875 0,3.42625 L0,14.8466563 C0,15.1557188 0.121579832,15.4234063 0.364705882,15.6495625 C0.607798319,15.8755312 0.895663866,15.9885937 1.22847059,15.9885937 L14.7407059,15.9885937 C15.0733782,15.9885937 15.3615462,15.8755625 15.6043697,15.6495625 C15.8475294,15.4235 15.9691429,15.1556875 15.9691429,14.8466563 L15.9691429,3.42621875 C15.9691092,3.11684375 15.8476303,2.84921875 15.604605,2.6231875 Z M11.0558319,1.4276875 C11.0558319,1.34434375 11.0843697,1.275875 11.1418824,1.22246875 C11.199395,1.169 11.2730084,1.14221875 11.3627227,1.14221875 L11.9767731,1.14221875 C12.066521,1.14221875 12.1398992,1.16890625 12.1976134,1.22246875 C12.2551597,1.27596875 12.2838992,1.3444375 12.2838992,1.4276875 L12.2838992,3.9971875 C12.2838992,4.0805 12.2551597,4.14884375 12.1976134,4.20240625 C12.1398655,4.2558125 12.066521,4.28265625 11.9767731,4.28265625 L11.3627227,4.28265625 C11.2730084,4.28265625 11.199395,4.2559375 11.1418824,4.20240625 C11.0843697,4.1488125 11.0558319,4.0805 11.0558319,3.9971875 L11.0558319,1.4276875 Z M3.68534454,1.4276875 C3.68534454,1.34434375 3.71408403,1.275875 3.77166387,1.22246875 C3.82927731,1.169 3.90278992,1.14221875 3.99240336,1.14221875 L4.60655462,1.14221875 C4.69620168,1.14221875 4.76984874,1.16890625 4.82729412,1.22246875 C4.88480672,1.27596875 4.91368067,1.3444375 4.91368067,1.4276875 L4.91368067,3.9971875 C4.91368067,4.0805 4.88494118,4.1489375 4.82729412,4.20240625 C4.76971429,4.2558125 4.69620168,4.28265625 4.60655462,4.28265625 L3.99240336,4.28265625 C3.90278992,4.28265625 3.82917647,4.2559375 3.77166387,4.20240625 C3.71421849,4.1488125 3.68534454,4.0805 3.68534454,3.9971875 L3.68534454,1.4276875 Z M14.7407059,14.8465 L1.22847059,14.8465 L1.22847059,5.71025 L14.7407059,5.71025 L14.7407059,14.8465 Z',

/**
 * Based on font-size of selector tool, the scaling value of calendar icon is calculcated,
 * the scaling value is directly applied on the path to make the size in sync with the
 * font-size.
 *
 * The value of scaling is 1 for font-size 12px. For a change in pixel value, the change in
 * scaling value if (+/-)0.0278. This value is derived by trying out experiments
 *
 * @param {String} fSize font-size
 * @returns
 */
getScalingParam = function getScalingParam(fSizeArg) {
  var fSize = parseFloat(fSizeArg);
  return (fSize - 12) * SCALING_STEP_VALUE + 1;
};

function mouseOver() {
  var style = this.config.extStyle;
  this.setData({
    interactionStyle: {
      text: style['title-text:hover'],
      icon: style['title-icon:hover']
    },
    hoverConfig: true
  }, true);
}

function mouseOut() {
  var selectorTool = this;
  !selectorTool.config.blockUpdate && selectorTool.setData({
    interactionStyle: this.config.extStyle['title:hoverout'],
    hoverConfig: true
  }, true);
}

;

function beforeMove(event) {
  var selectorTool = this;
  selectorTool.removeDocumentListener();
  event.detachHandler();
}

var CustomRangeSelectorTool = /*#__PURE__*/function (_Tool) {
  (0, _inheritsLoose2.default)(CustomRangeSelectorTool, _Tool);

  /**
   * Creates an instance of CustomRangeSelectorTool.
   * @param {any} id id
   * @memberof CustomRangeSelectorTool
   */
  function CustomRangeSelectorTool(id) {
    var _this;

    _this = _Tool.call(this, id) || this;
    var selectorTool = (0, _assertThisInitialized2.default)(_this),
        config = selectorTool.config;
    config.wrapper = new _fusionEventWrapper.default();

    config.documentClicked = function (e) {
      var _getMouseCoordinate = (0, _lib.getMouseCoordinate)(selectorTool.getFromEnv('chart-container'), e, selectorTool.getFromEnv('chart')),
          chartX = _getMouseCoordinate.chartX,
          chartY = _getMouseCoordinate.chartY,
          clientX = _getMouseCoordinate.clientX,
          clientY = _getMouseCoordinate.clientY,
          manager = selectorTool.getChildren('manager')[0],
          xPos,
          yPos,
          target = e.target;

      if (manager.config.visualMode === 'mobile') {
        xPos = clientX;
        yPos = clientY;
      } else {
        xPos = chartX;
        yPos = chartY;
      }

      if (!manager.isWithinWidget(xPos, yPos)) {
        var svgRectClassName = target instanceof SVGElement && target.className.baseVal; // different browsers have different behaviour in select option click
        // so this has been implemented to check that the element clicked is within the widget

        if (svgRectClassName !== 'fc__crs__str' && !(target.className === 'fc__select__time' || target.parentElement && target.parentElement.className === 'fc__select__time')) {
          config.wrapper.off(document, 'fc-click', config.documentClicked);
          selectorTool.setData({}, true);
        }
      }
    }; // When escape key is pressed, then hide the calender.


    selectorTool.keyDownHandler = function (evt) {
      var isEscape = false;

      if ('key' in evt) {
        isEscape = evt.key === 'Escape' || evt.key === 'Esc';
      } else {
        isEscape = evt.keyCode === 27;
      }

      if (isEscape) {
        _this.setData({}, true);
      }
    };

    selectorTool.clickHandler = function (e) {
      var component = selectorTool,
          totalDomain = config.domain,
          chart = component.getFromEnv('chart'),
          isUTC = chart.getFromEnv('UTC'),
          dateAPI = chart.getFromEnv('dateAPI'),
          contextScaleLimit = chart.getContextLimit(),
          contextStart = new Date(contextScaleLimit[0]),
          contextEnd = new Date(contextScaleLimit[1]),
          start = new Date(totalDomain[0]),
          end = new Date(totalDomain[1]),
          startDate,
          endDate; // set active state cosmetics

      component.setData({
        blockUpdate: true,
        interactionStyle: {
          text: config.extStyle['title-text:active'],
          icon: config.extStyle['title-icon:active']
        }
      }, true);
      component.getChildren('cover')[0].setData({
        visibility: 'visible'
      }, true);
      startDate = {
        year: dateAPI(start, 'FullYear', isUTC),
        month: dateAPI(start, 'Month', isUTC) + 1,
        day: dateAPI(start, 'Date', isUTC),
        hours: dateAPI(start, 'Hours', isUTC),
        minutes: dateAPI(start, 'Minutes', isUTC),
        seconds: dateAPI(start, 'Seconds', isUTC)
      };
      endDate = {
        year: dateAPI(end, 'FullYear', isUTC),
        month: dateAPI(end, 'Month', isUTC) + 1,
        day: dateAPI(end, 'Date', isUTC),
        hours: dateAPI(end, 'Hours', isUTC),
        minutes: dateAPI(end, 'Minutes', isUTC),
        seconds: dateAPI(end, 'Seconds', isUTC)
      };
      component.getChildren('manager')[0].setData({
        visibility: 'visible',
        position: component.config.containerPos,
        drawCalendars: true,
        startDate: startDate,
        endDate: endDate,
        leftCalSelectedDate: startDate,
        rightCalSelectedDate: endDate,
        contextStart: {
          year: dateAPI(contextStart, 'FullYear', isUTC),
          month: dateAPI(contextStart, 'Month', isUTC) + 1,
          day: dateAPI(contextStart, 'Date', isUTC)
        },
        contextEnd: {
          year: dateAPI(contextEnd, 'FullYear', isUTC),
          month: dateAPI(contextEnd, 'Month', isUTC) + 1,
          day: dateAPI(contextEnd, 'Date', isUTC)
        }
      }, true);
      config.wrapper.on(document, 'fc-click', selectorTool.config.documentClicked);
      config.wrapper.on(document, 'keydown', selectorTool.keyDownHandler);
    };

    selectorTool.addEventListener('fc-click', selectorTool.clickHandler); // set hover-in cosmetics

    selectorTool.addEventListener('fc-mouseover', mouseOver.bind((0, _assertThisInitialized2.default)(_this))); // set hover-out cosmetics

    selectorTool.addEventListener('fc-mouseout', mouseOut.bind((0, _assertThisInitialized2.default)(_this))); // Before this component is removed we need to make sure event listeners
    // add by it on document are removed

    selectorTool.addEventListener('beforeremove', beforeMove.bind((0, _assertThisInitialized2.default)(_this)));
    return _this;
  }
  /**
   * sets default configuration
   *
   * @memberof CustomRangeSelectorTool
   */


  var _proto = CustomRangeSelectorTool.prototype;

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    _Tool.prototype.__setDefaultConfig.call(this);

    var rangeSelectorConfig = this.config;
    rangeSelectorConfig.containerState = 0;
    rangeSelectorConfig.showDate = true;
    rangeSelectorConfig.calendarIconPath = CALENDAR_ICON_PATH;
    rangeSelectorConfig.calendarIconDim = {
      width: 16,
      height: 16
    };
    rangeSelectorConfig.containerPos = {
      x: 100,
      y: 100
    };
    rangeSelectorConfig.containerInfo = {
      id: 'group',
      label: 'group',
      isParent: true
    };
    rangeSelectorConfig.spaceNotHardCoded = true;
    rangeSelectorConfig.hoveredState = NORMAL;
    rangeSelectorConfig._iconStyle = {
      fill: '#5648D4',
      transform: "t0,0",
      opacity: 1
    };
    rangeSelectorConfig._textStyle = {
      'font-size': '12px',
      'font-style': 'normal',
      'font-weight': '600',
      'text-anchor': 'start',
      fill: '#5648D4',
      opacity: 1
    };
    rangeSelectorConfig.prevDim = {
      height: 0,
      width: 0
    };
  }
  /**
   * configures the component
   *
   * @param {any} [inputConfig={}] configuration
   * @memberof CustomRangeSelectorTool
   */
  ;

  _proto.configureAttributes = function configureAttributes(inputConfig) {
    if (inputConfig === void 0) {
      inputConfig = {};
    }

    var rangeSelector = this,
        config = rangeSelector.config,
        focusScales = rangeSelector.getFromEnv('focusScalesX'),
        showTime = false,
        extStyle = {},
        interactionStyle = {},
        styleDef = rangeSelector.getFromEnv('getStyleDef'),
        baseTextStyle = rangeSelector.getFromEnv('baseTextStyle');
    Object.assign(config, inputConfig); // delete unneccessary configs

    !inputConfig.blockUpdate && delete config.blockUpdate;
    !inputConfig.interactionStyle && delete config.interactionStyle;
    !inputConfig.limitChanged && delete config.limitChanged;
    extStyle = config.extStyle || {};
    interactionStyle = config.interactionStyle || {};
    rangeSelector.setState(VISIBLE, config.isHidden !== true);
    config.symbolName = config.name;
    focusScales.forEach(function (scale) {
      if (TIME_INTERVALS.includes(scale.getBinMin()[0].name())) {
        showTime = true;
      }
    }); // if limit is changed then render with old configuration
    // so that calendar does not close on limit change

    rangeSelector.attachChild(_cover.default, 'cover', 'cover').configure(config.limitChanged ? {} : {
      visibility: 'hidden'
    });
    rangeSelector.attachChild(_manager.default, 'manager', 'manager').configure(config.limitChanged ? {} : {
      visibility: 'hidden',
      position: config.containerPos,
      showTime: showTime,
      extStyle: extStyle,
      drawCalendars: false
    });
    config.showTime = showTime;
    config._finalIconStyle = Object.assign({}, config._iconStyle, styleDef(extStyle['title-icon']), styleDef(interactionStyle.icon));
    config._finalTextStyle = Object.assign({}, config._textStyle, baseTextStyle, styleDef(extStyle['title-text']), styleDef(interactionStyle.text)); // get the scaling parameter by which the calendar icon will increased/decreased.

    config.scalingParam = getScalingParam(config._finalTextStyle['font-size']);
    config._finalIconStyle.transform += " s" + config.scalingParam;
  }
  /**
   * returns the formatted label
   *
   * @returns {string} text
   * @memberof CustomRangeSelectorTool
   */
  ;

  _proto.getLabel = function getLabel() {
    var _this$getFromEnv;

    var rangeSelector = this,
        rangeSelectorConfig = rangeSelector.config,
        text = BLANK,
        ENGLISH = 'english',
        showTimeInLabel = rangeSelectorConfig.showTimeInLabel,
        chartWidth = +rangeSelector.getFromEnv('chartWidth'),
        toolbar = rangeSelector.getLinkedParent(),
        chart = rangeSelector.getFromEnv('chart'),
        scale = chart.getFromEnv('contextScalesX')[0],
        totalDomain = rangeSelectorConfig.domain || scale.getDomain(),
        smartLabel = rangeSelector.getFromEnv('smartLabel'),
        startDate = new Date(totalDomain[0]),
        endDate = new Date(totalDomain[1]),
        curDim,
        prevDim = Object.assign(rangeSelectorConfig.prevDim),
        dim = prevDim,
        language = (_this$getFromEnv = this.getFromEnv(LANGUAGE)) != null ? _this$getFromEnv : ENGLISH;
    smartLabel.setStyle(rangeSelectorConfig._finalTextStyle); // Show date when there is enough space

    text = scale.getFormattedTime({
      dateRange: {
        startDate: startDate,
        endDate: endDate
      },
      type: CRS,
      showTimeInLabel: showTimeInLabel,
      language: language
    });
    curDim = smartLabel.getOriSize(text); // If the length of the text is within 10px of the previous text length, no need to update

    if (Math.abs(curDim.width - prevDim.width) > 10) {
      dim = rangeSelectorConfig.prevDim = Object.assign(curDim);
    }

    if (chartWidth < 600) {
      if ((dim.width + rangeSelectorConfig.calendarIconDim.width) / toolbar.props.width > 0.4) {
        text = BLANK;
        dim.width = 0;
      }
    }

    rangeSelectorConfig.label = text;
    return {
      text: text,
      dim: dim
    };
  };

  _proto.decideTimeInLabel = function decideTimeInLabel() {
    var rangeSelector = this,
        rangeSelectorConfig = rangeSelector.config,
        showTimeInLabel,
        focusScales = rangeSelector.getFromEnv('focusScalesX');
    focusScales.forEach(function (scale) {
      if (TIME_INTERVALS.includes(scale.getBinMin()[0].name())) {
        rangeSelectorConfig.showTime = true;
      } // FTV3-1177 : timestamp should come in crs label when data binning is in time unit
      // Showing time in label by checking current binning


      if (TIME_INTERVALS.includes(rangeSelector.getFromEnv('focusBins')[0].getRangeThreshold()[0].name())) {
        showTimeInLabel = true;
      }
    });
    return showTimeInLabel;
  }
  /**
   * calculates the size taken by the component
   *
   * @returns {Object} width and height
   * @memberof CustomRangeSelectorTool
   */
  ;

  _proto.getLogicalSpace = function getLogicalSpace() {
    var rangeSelector = this,
        rangeSelectorConfig = rangeSelector.config,
        manager = rangeSelector.getChildren('manager')[0],
        width = rangeSelectorConfig.width,
        height = rangeSelectorConfig.height,
        marginTop = rangeSelectorConfig.marginTop,
        marginLeft = rangeSelectorConfig.marginLeft,
        marginRight = rangeSelectorConfig.marginRight,
        marginBottom = rangeSelectorConfig.marginBottom,
        dim;
    rangeSelectorConfig.showTimeInLabel = rangeSelector.decideTimeInLabel();
    manager.configure({
      showTime: rangeSelectorConfig.showTime
    }, true);
    dim = rangeSelector.getLabel().dim;
    width = dim.width;
    height = dim.height;

    if (rangeSelectorConfig.skipGraphics || rangeSelectorConfig.isHidden || rangeSelector.getState('removed')) {
      width = height = marginBottom = marginLeft = marginRight = marginTop = 0;
    }

    rangeSelectorConfig.width = dim.width;
    rangeSelectorConfig.height = dim.height;
    return {
      width: width,
      height: height,
      marginLeft: marginLeft,
      marginBottom: marginBottom,
      marginRight: marginRight,
      marginTop: marginTop
    };
  };

  _proto.draw = function draw() {
    var rangeSelector = this,
        rangeSelectorConfig = rangeSelector.config,
        toolbar = rangeSelector.getLinkedParent(),
        iconTranslateX,
        iconTranslateY,
        scalingParam = rangeSelectorConfig.scalingParam,
        calendarIconWidth,
        calendarIconHeight; // container

    rangeSelector.addGraphicalElement({
      el: 'group',
      attr: {
        name: 'range-selector-text',
        transform: "t" + rangeSelectorConfig.x + ", " + (rangeSelectorConfig.y + toolbar.props.height / 2)
      },
      container: rangeSelectorConfig.containerInfo,
      component: rangeSelector,
      id: 'group',
      label: 'group'
    }, true);
    calendarIconWidth = scalingParam * rangeSelectorConfig.calendarIconDim.width;
    calendarIconHeight = scalingParam * rangeSelectorConfig.calendarIconDim.height; // calculate translation for icon

    iconTranslateX = -1 * calendarIconWidth - SPACE_BETWEEN_ICON_AND_TEXT;
    iconTranslateY = -1 * (3 * calendarIconHeight / 4); // icon-container

    rangeSelector.addGraphicalElement({
      el: 'group',
      attr: {
        name: 'range-selector-icon-group',
        transform: "t" + iconTranslateX + ", " + iconTranslateY
      },
      container: {
        id: 'group',
        label: 'group'
      },
      component: rangeSelector,
      label: 'group',
      id: 'icon-group'
    }, true); // icon

    rangeSelector.addGraphicalElement({
      el: 'path',
      attr: {
        path: rangeSelectorConfig.calendarIconPath,
        stroke: 'none'
      },
      css: rangeSelectorConfig._finalIconStyle,
      container: {
        id: 'icon-group',
        label: 'group'
      },
      component: rangeSelector,
      label: 'path',
      id: 'icon'
    }, true); // text showing the current range

    rangeSelector.addGraphicalElement({
      el: 'text',
      attr: {
        text: rangeSelectorConfig.label,
        opacity: rangeSelectorConfig._finalTextStyle.opacity
      },
      css: rangeSelectorConfig._finalTextStyle,
      container: {
        id: 'group',
        label: 'group'
      },
      component: rangeSelector,
      label: 'text',
      id: 'display'
    }, true); // tracker

    rangeSelector.addGraphicalElement({
      el: 'rect',
      attr: {
        class: 'fc__crs__str',
        fill: _lib.TRACKER_FILL,
        x: iconTranslateX - SPACE_BETWEEN_ICON_AND_TEXT,
        y: -1 * toolbar.props.height / 2,
        width: calendarIconWidth + 2 * SPACE_BETWEEN_ICON_AND_TEXT + rangeSelectorConfig.width,
        height: toolbar.props.height,
        stroke: 'none'
      },
      component: rangeSelector,
      container: {
        label: 'group',
        id: 'group'
      },
      css: {
        cursor: 'pointer'
      },
      label: 'rect',
      id: 'rect'
    });
    rangeSelectorConfig.containerPos = {
      x: rangeSelectorConfig.x - calendarIconWidth / 2 - SPACE_BETWEEN_ICON_AND_TEXT * scalingParam,
      y: rangeSelectorConfig.y + toolbar.props.height / 2 + calendarIconHeight
    };
  };

  _proto.removeDocumentListener = function removeDocumentListener() {
    var selectorTool = this,
        config = selectorTool.config;
    config.wrapper.off(document, 'fc-click', config.documentClicked);
    config.wrapper.off(document, 'keydown', selectorTool.keyDownHandler);
  };

  return CustomRangeSelectorTool;
}(_toolbox.Tool);

var _default = CustomRangeSelectorTool;
exports["default"] = _default;

/***/ }),

/***/ 974:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _componentInterface = __webpack_require__(290);

var _lib = __webpack_require__(274);

var _trustedPolicy = _interopRequireDefault(__webpack_require__(299));

// eslint-disable-next-line
var SEMICOLON = ':',
    BLANK = '',
    TIMEBOX_CONFIG_LABEL = 'Time: ',
    DEFAULT_PADDING = 10,
    DEFAULT_INPUT_BOX_WIDTH = _lib.isIE11 ? 38 : 32,
    ARROW_SVG = '<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 4.95 10"><defs><style>.cls-2 {fill: #444;}</style></defs><polygon class="cls-2" points="1.41 4.67 2.48 3.18 3.54 4.67 1.41 4.67" /><polygon class="cls-2" points="3.54 5.33 2.48 6.82 1.41 5.33 3.54 5.33" /></svg>',
    SELECT_BG_IMAGE = 'url(data:image/svg+xml;base64,' + btoa(ARROW_SVG) + ') no-repeat 100% 100%',

/**
 * appends a 0 in front of a number if the number is less than 10
 *
 * @param {Number} x number to checked
 */
formatDate = function formatDate(x) {
  return (x < 10 ? '0' + x : x) + '';
},

/**
 * creates the options for select menu
 *
 * @param {Number} total number of options to be created
 * @param {Number} [selected=-1] the options which will be selected by default
 * @returns {string}
 */
getOptionsString = function getOptionsString(total, selected) {
  if (selected === void 0) {
    selected = -1;
  }

  var i,
      text = BLANK;

  for (i = 0; i <= total; i++) {
    if (i === selected) {
      text += "<option value=\"" + formatDate(i) + "\" selected>" + formatDate(i) + "</option>";
    } else {
      text += "<option value=\"" + formatDate(i) + "\">" + formatDate(i) + "</option>";
    }
  }

  return text;
},

/**
 * multiplier to calculate the select box size
 */
getMultiplier = function getMultiplier(fSize) {
  if (fSize < 21) {
    return 2;
  } else if (fSize < 31) {
    return 1.67;
  } else if (fSize < 51) {
    return 1.5;
  }

  return 1.25;
};

var TimeBox = /*#__PURE__*/function (_SmartRenderer) {
  (0, _inheritsLoose2.default)(TimeBox, _SmartRenderer);

  function TimeBox() {
    return _SmartRenderer.apply(this, arguments) || this;
  }

  var _proto = TimeBox.prototype;

  /**
   * sets default configurations
   *
   * @memberof TimeBox
   */
  _proto.__setDefaultConfig = function __setDefaultConfig() {
    var timeBoxConfig = this.config;
    timeBoxConfig.enabled = true;
    timeBoxConfig.label = TIMEBOX_CONFIG_LABEL;
    timeBoxConfig._labelStyle = {
      'font-size': '12px',
      'font-weight': 'normal',
      'font-style': 'normal',
      color: '#5f5f5f'
    };
    timeBoxConfig._selectStyle = {
      'font-size': '12px',
      border: '0',
      outline: '1px solid #efefef',
      'outline-offset': '-1px',
      color: '#5f5f5f',
      width: DEFAULT_INPUT_BOX_WIDTH + _lib.PXSTRING,
      'padding-left': _lib.isIE11 || _lib.isFirefox ? '0px' : '5px',
      'padding-right': _lib.isIE11 || _lib.isFirefox ? '0px' : '5px',
      'padding-top': '5px',
      'padding-bottom': '5px',
      background: SELECT_BG_IMAGE,
      'background-color': '#FFFFFF',
      '-webkit-appearance': 'none',
      '-moz-appearance': 'none',
      '-o-appearance': 'none',
      'border-radius': '0px',
      appearance: 'none'
    };

    if (_lib.isIE11) {
      delete timeBoxConfig._selectStyle.background;
    }
  }
  /**
   * configures the time box
   *
   * @param {any} [inputConfig={}] configurations
   * @memberof TimeBox
   */
  ;

  _proto.configureAttributes = function configureAttributes(inputConfig) {
    if (inputConfig === void 0) {
      inputConfig = {};
    }

    var timeBox = this,
        config = timeBox.config,
        styleDef = timeBox.getFromEnv('getStyleDef'),
        baseTextStyle = timeBox.getFromEnv('baseTextStyle');
    Object.assign(config, inputConfig);
    config._finalLabelStyle = Object.assign({}, config._labelStyle, baseTextStyle, styleDef(config.labelStyle));
    config._finalSelectStyle = Object.assign({}, config._selectStyle, baseTextStyle, styleDef(config.selectStyle)); // for html element line-height should not be applied through css as it distorts the height of the elements

    delete config._finalSelectStyle['line-height'];
  }
  /**
   * Calculates the space required for this component
   *
   * @returns {Object} width and height
   * @memberof TimeBox
   */
  ;

  _proto.getDimension = function getDimension() {
    var timeBox = this,
        timeBoxConfig = timeBox.config,
        labelDim,
        getCleanNumber = timeBox.getFromEnv('fontParser'),
        fSize = getCleanNumber(timeBoxConfig._finalSelectStyle['font-size']),
        smartLabel = timeBox.getFromEnv('smartLabel'),
        colonWidth,
        multiplier = getMultiplier(fSize);
    smartLabel.setStyle(timeBoxConfig._finalLabelStyle);
    labelDim = timeBoxConfig.labelDim = smartLabel.getOriSize(timeBoxConfig.label);
    colonWidth = smartLabel.getOriSize(':').width;
    timeBoxConfig.inputBoxWidth = Math.max(getCleanNumber(timeBoxConfig._finalSelectStyle.width), fSize * 2.6);
    timeBoxConfig.inputBoxHeight = fSize * multiplier;
    timeBoxConfig.spacingMultiplier = fSize > 30 ? 2 : 1;
    timeBoxConfig._finalSelectStyle.width = timeBoxConfig.inputBoxWidth + _lib.PXSTRING;
    return {
      width: labelDim.width + 3 * colonWidth + 3 * timeBoxConfig.inputBoxWidth + 2 * DEFAULT_PADDING,
      height: Math.max(labelDim.height, timeBoxConfig.inputBoxHeight)
    };
  }
  /**
   * setter method for position
   *
   * @param {any} x pos x
   * @param {any} y pos y
   * @memberof TimeBox
   */
  ;

  _proto.setTranslation = function setTranslation(x, y) {
    this.config.position = {
      x: x,
      y: y
    };
  }
  /**
   * returns the current selected time
   *
   * @returns {Object} Object containing hour, minute, second
   * @memberof TimeBox
   */
  ;

  _proto.getTime = function getTime() {
    var timeBox = this,
        hourElem,
        minuteElem,
        secondElem;
    hourElem = timeBox.getGraphicalElement('hour-box', 'hour-box');
    minuteElem = timeBox.getGraphicalElement('minute-box', 'minute-box');
    secondElem = timeBox.getGraphicalElement('second-box', 'second-box');
    return {
      hours: +hourElem.element.value,
      minutes: +minuteElem.element.value,
      seconds: +secondElem.element.value
    };
  }
  /**
   * draws the component
   *
   * @memberof TimeBox
   */
  ;

  _proto.draw = function draw() {
    var timeBox = this,
        timeBoxConfig = timeBox.config,
        position = timeBoxConfig.position,
        labelDim = timeBoxConfig.labelDim,
        curTime = timeBoxConfig.time || {},
        xPos = position.x,
        heightDiff = Math.abs(labelDim.height - timeBoxConfig.inputBoxHeight) / 2; // Label box

    timeBox.addGraphicalElement({
      el: 'html',
      attr: {
        x: xPos,
        y: position.y,
        type: 'label',
        text: timeBoxConfig.label
      },
      component: timeBox,
      css: timeBoxConfig._finalLabelStyle,
      container: {
        id: 'box-container',
        label: 'box-container',
        isParent: true
      },
      label: 'time-label',
      id: 'time-label'
    });
    xPos += labelDim.width + DEFAULT_PADDING / 2; // Hour selection box

    timeBox.addGraphicalElement({
      el: 'html',
      attr: {
        x: xPos,
        y: position.y - heightDiff,
        type: 'select',
        innerHTML: _trustedPolicy.default.createHTML(getOptionsString(23, curTime.hours)),
        class: 'fc__select__time'
      },
      component: timeBox,
      css: timeBoxConfig._finalSelectStyle,
      container: {
        id: 'box-container',
        label: 'box-container',
        isParent: true
      },
      label: 'hour-box',
      id: 'hour-box'
    });
    xPos += timeBoxConfig.inputBoxWidth; // colon before minute box

    timeBox.addGraphicalElement({
      el: 'html',
      attr: {
        x: xPos + 3,
        y: position.y,
        type: 'label',
        text: SEMICOLON
      },
      component: timeBox,
      css: timeBoxConfig._finalLabelStyle,
      container: {
        id: 'box-container',
        label: 'box-container',
        isParent: true
      },
      label: 'semicolon-minute',
      id: 'semicolon-minute'
    });
    xPos += timeBoxConfig.spacingMultiplier * DEFAULT_PADDING; // minute selection box

    timeBox.addGraphicalElement({
      el: 'html',
      attr: {
        x: xPos,
        y: position.y - heightDiff,
        type: 'select',
        innerHTML: _trustedPolicy.default.createHTML(getOptionsString(59, curTime.minutes)),
        class: 'fc__select__time'
      },
      component: timeBox,
      css: timeBoxConfig._finalSelectStyle,
      container: {
        id: 'box-container',
        label: 'box-container',
        isParent: true
      },
      label: 'minute-box',
      id: 'minute-box'
    });
    xPos += timeBoxConfig.inputBoxWidth; // semicolon before second box

    timeBox.addGraphicalElement({
      el: 'html',
      attr: {
        x: xPos + 3,
        y: position.y,
        type: 'label',
        text: SEMICOLON
      },
      component: timeBox,
      css: timeBoxConfig._finalLabelStyle,
      container: {
        id: 'box-container',
        label: 'box-container',
        isParent: true
      },
      label: 'semicolon-second',
      id: 'semicolon-second'
    });
    xPos += timeBoxConfig.spacingMultiplier * DEFAULT_PADDING; // second selection box

    timeBox.addGraphicalElement({
      el: 'html',
      attr: {
        x: xPos,
        y: position.y - heightDiff,
        type: 'select',
        innerHTML: _trustedPolicy.default.createHTML(getOptionsString(59, curTime.seconds)),
        class: 'fc__select__time'
      },
      component: timeBox,
      css: timeBoxConfig._finalSelectStyle,
      container: {
        id: 'box-container',
        label: 'box-container',
        isParent: true
      },
      label: 'second-box',
      id: 'second-box'
    });
  };

  return TimeBox;
}(_componentInterface.SmartRenderer);

var _default = TimeBox;
exports["default"] = _default;

/***/ }),

/***/ 924:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



exports.__esModule = true;
exports["default"] = void 0;

var _lib = __webpack_require__(274);

var appearing = function appearing(inputJSON) {
  return [{
    initialAttr: {
      opacity: 0
    },
    finalAttr: {
      opacity: (0, _lib.pluckNumber)(inputJSON.attr.opacity, 1)
    },
    slot: 'final'
  }];
},
    markerAnimation = function markerAnimation() {
  return {
    '*.appearing': appearing
  };
};

var _default = {
  'initial.dataMarker.dataMarker': markerAnimation
};
exports["default"] = _default;

/***/ }),

/***/ 925:
/***/ ((__unused_webpack_module, exports) => {



exports.__esModule = true;
exports["default"] = void 0;
var flagPathStr = 'M12.4444444,0 L1.55555556,0 C0.7,0 0,0.654545455 0,1.45454545 L0,10.8363636 C0,11.3454545 0.233333333,11.7817897 0.7,12.0727273 L7,16 L13.3,12.0727273 C13.6888889,11.7818182 14,11.3454545 14,10.8363636 L14,1.45454545 C14,0.654545455 13.3,0 12.4444444,0 Z';
/**
* Function to draw the FlagMarkers
*/

var _default = function _default(marker, index, markerDimensions) {
  var config = marker.config,
      markerDetails = config.markerInfo[index],
      data = config.dataInfo[index],
      markerStyle = marker.getStyleInformation(index),
      y,
      x,
      width,
      currMarker,
      stickX,
      id,
      identifier,
      attrObj,
      stickY,
      strokeWidth = 1,
      multipleMarkers,
      markerOpacity,
      textOpacity,
      flagHeight = markerDimensions.flagHeight,
      stickLength = markerDimensions.stickLength,
      flagWidth = markerDimensions.flagWidth;
  multipleMarkers = markerDetails.multipleMarkers;
  id = markerDetails.id;
  y = data.y;
  x = data.x;
  width = data.width || 0;
  stickX = x + width / 2;
  stickY = y - stickLength;
  currMarker = markerDetails.markers[0];
  markerOpacity = markerStyle.marker.opacity;
  textOpacity = markerStyle.text.opacity; // Creating the vertical line of the flag marker

  attrObj = {
    path: ['M', stickX, y, 'V', stickY],
    opacity: markerOpacity
  };
  marker.addGraphicalElement({
    el: 'path',
    container: {
      label: 'group'
    },
    id: id,
    component: marker,
    attr: attrObj,
    css: markerStyle.marker,
    label: 'flagStick'
  }, true); // Creating the remaining of the flag marker(the marker background)

  attrObj = {
    path: flagPathStr,
    transform: "t" + (stickX - flagWidth / 2 + strokeWidth) + "," + (stickY - flagHeight),
    opacity: markerOpacity
  };
  marker.addGraphicalElement({
    el: 'path',
    container: {
      label: 'group'
    },
    id: id,
    component: marker,
    attr: attrObj,
    css: markerStyle.marker,
    label: 'flagTriangle'
  }, true); // Drawing the text

  if (multipleMarkers || (identifier = currMarker.identifier)) {
    attrObj = {
      text: multipleMarkers ? markerDetails.markers.length : identifier.charAt(0),
      x: stickX,
      y: stickY - flagHeight / 2,
      opacity: textOpacity
    };
    marker.addGraphicalElement({
      el: 'text',
      container: {
        label: 'group'
      },
      id: id,
      component: marker,
      attr: attrObj,
      css: markerStyle.text,
      label: 'markerText'
    }, true);
  }
};

exports["default"] = _default;

/***/ }),

/***/ 923:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _smartRenderer = _interopRequireDefault(__webpack_require__(294));

var _timeConverter = _interopRequireDefault(__webpack_require__(350));

var _lib = __webpack_require__(274);

var _libGraphics = __webpack_require__(278);

var _timeBucket = __webpack_require__(874);

var _dependencyManager = __webpack_require__(282);

var _dataMarker = _interopRequireDefault(__webpack_require__(924));

var _isArray = _interopRequireDefault(__webpack_require__(349));

var _isObject = _interopRequireDefault(__webpack_require__(481));

var _flagMarkerDrawable = _interopRequireDefault(__webpack_require__(925));

var _pinMarkerDrawable = _interopRequireDefault(__webpack_require__(926));

var _equals = _interopRequireDefault(__webpack_require__(845));

var _isNumber = _interopRequireDefault(__webpack_require__(927));

var markerDimensions = {
  flagHeight: 16,
  flagWidth: 16,
  stickLength: 10,
  pinHeight: 23,
  pinWidth: 23,
  totalFlagHeight: 26
},
    DASH_STR = '—',
    VISIBLE = 'visible',
    DEFAULT_FONT_COLOR = '#ffffff',
    DEFAULT_STROKE_COLOR = '#8c8c8c',
    DEFAULT_TOOLTIP_BACKGROUND = '#f2eded',
    ROLLOVER = 'DataMarkerRollOver',
    ROLLOUT = 'DataMarkerRollOut',
    CLICK = 'dataMarkerClick',
    TYPE_PIN = 'pin',
    getSameProperty = function getSameProperty(arr) {
  if (arr === void 0) {
    arr = [];
  }

  if (!(0, _isArray.default)(arr)) return {};

  var output = {},
      key,
      j,
      obj1 = (0, _isObject.default)(arr[0]) ? arr[0] : {},
      len = arr.length,
      // eslint-disable-next-line
  filterFn = function filterFn(obj) {
    return (0, _isObject.default)(obj) && obj.hasOwnProperty(key) && obj[key] == obj1[key];
  };

  for (key in obj1) {
    if (obj1.hasOwnProperty(key)) {
      var addProp = true;

      for (j = 1; j < len; ++j) {
        if (!filterFn(arr[j])) {
          addProp = false;
          break;
        }
      }

      if (addProp) {
        output[key] = obj1[key];
      }
    }
  }

  return output;
},
    checkForValidCoordinated = function checkForValidCoordinated(coordiante) {
  var valid = true,
      key;

  for (key in coordiante) {
    if (coordiante.hasOwnProperty(key)) {
      valid = valid && !isNaN(coordiante[key]);
    }
  }

  return valid;
},
    _isMarkerInBounds = function _isMarkerInBounds(width, height, chartX, chartY, centerX, y) {
  return chartX >= centerX - width / 2 && chartX <= centerX + width / 2 && chartY <= y && chartY >= y - height;
};

(0, _dependencyManager.addDep)({
  name: 'dataMarkerAnimation',
  type: 'animationRule',
  extension: _dataMarker.default
});
/**
 * This class is used to manage and draw the flag markers of timeseries
 */

var DataMarker = /*#__PURE__*/function (_SmartRenderer) {
  (0, _inheritsLoose2.default)(DataMarker, _SmartRenderer);
  var _proto = DataMarker.prototype;

  _proto.configure = function configure(dataObj) {
    _SmartRenderer.prototype.configure.call(this, dataObj);

    var config = this.config,
        styleInfo = config.styleInfo,
        currStyle,
        styleObj;

    if ((0, _isArray.default)(dataObj.data)) {
      var oldData = config.unsortedData;
      config.unsortedData = dataObj.data.slice();

      if (!(0, _equals.default)(oldData, config.unsortedData)) {
        // data for tooltip will be sorted
        config.data = dataObj.data.slice();
        config.data.sort(function (a, b) {
          return _timeConverter.default.parser(a.timeformat).parse(a.time) - _timeConverter.default.parser(b.timeformat).parse(b.time);
        });
      }
    }

    config.isStock = (0, _lib.pluck)(dataObj.isStock, config.isStock);
    config.isRange = (0, _lib.pluck)(dataObj.isRange, config.isRange); // Stroring the information in style Object separately to be merged after grouping

    if (styleObj = dataObj.style) {
      currStyle = styleInfo[dataObj.index] || (styleInfo[dataObj.index] = {}); // Setting the given styles for the respective data markers

      for (var styles in styleObj) {
        if (styleObj.hasOwnProperty(styles)) {
          currStyle[styles] = styleObj[styles];
        }
      }
    }

    config.skipGrouping = dataObj.skipGrouping;
    (0, _lib.defined)(dataObj.visibility) && (config.visibility = dataObj.visibility);
  };

  function DataMarker() {
    var _this;

    _this = _SmartRenderer.call(this) || this;

    _this.getClassName = function (baseName) {
      if (baseName === void 0) {
        baseName = '';
      }

      var randomString = Math.random().toString(36).substring(2);
      return baseName + "-" + randomString;
    };

    _this.getCSPNonce = function () {
      var metaTag = document.querySelector("meta[http-equiv=\"Content-Security-Policy\"]");

      if (metaTag) {
        var content = metaTag.getAttribute('content');

        if (content) {
          var match = content.match(/'nonce-([^']+)'/);

          if (match) {
            return match[1];
          }
        }
      }

      return null;
    };

    _this.config.styleInfo = {};
    return _this;
  }
  /**
   * Function to set hover in effect
   * @param {number} index data index
   */


  _proto.setHoverInEffect = function setHoverInEffect(index) {
    var marker = this,
        markerConfig = marker.config,
        hoveredMarkers = markerConfig.markerInfo[index].markers,
        style = hoveredMarkers[0].style || {},
        markerHoverStyle = {},
        markerHoverStyles = {},
        textHoverStyle = {},
        textHoverStyles = {},
        styleDef = marker.getFromEnv('getStyleDef');

    if (hoveredMarkers.multipleMarkers) {
      markerHoverStyles = hoveredMarkers.markers.map(function (markerInfo) {
        return markerInfo.style && styleDef(markerInfo.style['marker:hover']) || {};
      });
      textHoverStyles = hoveredMarkers.markers.map(function (markerInfo) {
        return markerInfo.style && styleDef(markerInfo.style['text:hover']) || {};
      });
      Object.assign(markerHoverStyle, markerConfig.defaultHoverStyle, getSameProperty(markerHoverStyles));
      Object.assign(textHoverStyle, markerConfig.defaultHoverStyle, getSameProperty(textHoverStyles));
    } else {
      Object.assign(markerHoverStyle, markerConfig.defaultHoverStyle, styleDef(style['marker:hover']));
      Object.assign(textHoverStyle, markerConfig.defaultHoverStyle, styleDef(style['text:hover']));
    }

    marker.getFromEnv('animationManager').setAnimationState('mouseOver');
    marker.setData({
      style: {
        marker: markerHoverStyle,
        text: textHoverStyle
      },
      index: index,
      skipGrouping: true
    }, true);
  }
  /**
   * Function to set hover out effect
   * @param {number} index data index
   */
  ;

  _proto.setHoverOutEffect = function setHoverOutEffect(index) {
    var marker = this;
    marker.getFromEnv('animationManager').setAnimationState('mouseOut');
    marker.setData({
      style: {
        marker: {},
        text: {}
      },
      index: index,
      skipGrouping: true
    }, true);
  }
  /**
   * This method handles all mouse events of a data marker.
   * @param {string} eventType name of the event
   * @param {number} index  index of the data marker where this event has been occured
   * @param {Event}  e  reference of the original mouse event
   * @param {Event}  hoveredInfo the object containing the information about hovering
   */
  ;

  _proto._firePlotEvent = function _firePlotEvent(eventType, index, e, hoveredInfo) {
    var marker = this,
        markerConfig = marker.config,
        markerInfo = markerConfig.markerInfo,
        eventArgs = markerInfo[index] && markerInfo[index].eventArgs || {},
        chart = marker.getFromEnv('chart'),
        coordiante = (0, _lib.getMouseCoordinate)(chart.getFromEnv('chart-container'), e, chart),
        validCoordinates = checkForValidCoordinated(coordiante),
        args = (0, _lib.extend2)(coordiante, eventArgs);

    if (validCoordinates && index !== _lib.UNDEF) {
      switch (eventType) {
        case 'fc-mouseover':
          chart.fireChartInstanceEvent(ROLLOVER, args);
          break;

        case 'fc-mouseout':
          chart.fireChartInstanceEvent(ROLLOUT, args);
          break;

        case 'fc-click':
          chart.fireChartInstanceEvent(CLICK, args);
          break;

        default:
          break;
      }
    }
  };

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    var config = this.config;
    config.isStock = false;
    config.isRange = false;
    config['default-stroke-width'] = 1;
    config['default-fill-opacity'] = 0.5;
    config['default-stroke-opacity'] = 0.5;
    config['default-font-color'] = DEFAULT_FONT_COLOR;
    config['default-stroke-color-multiple'] = DEFAULT_STROKE_COLOR;
    config['default-tooltip-background'] = DEFAULT_TOOLTIP_BACKGROUND;
    config.defaultMarkerStyle = {
      'stroke-width': 1,
      'fill-opacity': 0.5,
      'stroke-opacity': 0.5
    };
    config.defaultTextStyle = {
      fill: '#ffffff',
      'font-size': '12px',
      'line-height': '14.4px',
      'fill-opacity': 1,
      'stroke-opacity': 1,
      'text-anchor': 'middle',
      'font-weight': 'normal',
      'font-style': 'normal'
    };
    config.defaultHoverStyle = {
      opacity: 1,
      'fill-opacity': 1,
      'stroke-opacity': 1
    };
  };

  _proto.draw = function draw() {
    if (this.config.visibility === VISIBLE) {
      this._createGroup();

      this._drawMarkers();
    }
  }
  /**
   * Sets the type of the component
   * @return {string} type
   */
  ;

  _proto.getType = function getType() {
    return 'dataMarker';
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */
  ;

  _proto.getName = function getName() {
    return 'dataMarker';
  }
  /**
   * function to check if given x,y coordiante is inside a dataMarker or not
   * @param  {number} pX     Approximate index on the xScale
   * @param  {number} chartX x co-ordinate
   * @param  {number} chartY y co-ordinate
   * @param  {number} catWidth the gap in pixel between two category
   * @return {Object}        hovered information
   */
  ;

  _proto._checkPointOverMarker = function _checkPointOverMarker(pX, chartX, chartY, catWidth) {
    var dataMarker = this,
        config = dataMarker.config,
        dataInfo = config.dataInfo,
        currData,
        currentMarker,
        x,
        y,
        dim = markerDimensions,
        halfWidth,
        centerX,
        returnObj,
        markerInfo = config.markerInfo,
        ceilPx = Math.ceil(pX),
        floorPx = Math.floor(pX),
        sum = catWidth,
        testWidth,
        testHeight,
        // managing overlapping
    indexRange = [ceilPx, floorPx]; // When the width of the marker covers more than 1 category

    while (sum < dim.flagWidth || sum < dim.pinWidth) {
      // Chance of the marker to be present on the right hand side of the given pX
      indexRange.unshift(++ceilPx); // Chance of the marker to be present on the left hand side of the given pX

      indexRange.push(--floorPx);
      sum += catWidth;
    } // Traversing over each dataset


    indexRange.forEach(function (index) {
      currentMarker = markerInfo[index];

      if (!returnObj && currentMarker) {
        currData = dataInfo[index];
        x = currData.x;
        y = currData.y;
        halfWidth = (currData.width || 0) / 2;
        centerX = x + halfWidth;

        if (currentMarker && currentMarker.markers && currentMarker.markers[0].type === TYPE_PIN) {
          testWidth = dim.pinWidth;
          testHeight = dim.pinHeight;
        } else {
          testWidth = dim.flagWidth;
          testHeight = dim.totalFlagHeight;
        } // Detection logic for data markers.


        if (_isMarkerInBounds(testWidth, testHeight, chartX, chartY, centerX, y)) {
          returnObj = {
            pointIndex: index,
            hovered: true,
            pointObj: currData,
            markerObj: currentMarker,
            component: dataMarker
          };
        }
      }
    });
    return returnObj;
  }
  /**
   * Generate the random class.
   * @param {String} baseName the static prefix for random class
   * @returns {String} new generated random classes.
   */
  ;

  /**
   * Getting the tooltext from the data-marker
   * @param {number} index The specific marker that ishovered
   */
  _proto._getTooltext = function _getTooltext(index) {
    var _this2 = this;

    var marker = this,
        config = marker.config,
        markerInfo = config.markerInfo,
        markerObj = markerInfo[index],
        markers = markerObj.markers,
        len = markers.length,
        formatter = marker.getFromEnv('yScale').tickFormat(4, '.2s'),
        multipleMarkers = markerObj.multipleMarkers,
        timeMap = {},
        header,
        body;
    var tooltipHeaderClass = this.getClassName('tooltip-header-class'),
        chartNonce = this.getCSPNonce();

    if (!markerObj.formatedTime) {
      markerObj.formatedTime = marker.getFromEnv('xScale').getFormattedTime({
        type: 'tooltip',
        dateRange: markerObj
      });
    }

    header = "\n    <style nonce=\"" + chartNonce + "\">\n      ." + tooltipHeaderClass + " {\n        margin-bottom: 6px;\n      }\n    </style>\n    <div class=\"" + tooltipHeaderClass + "\">" + markerObj.formatedTime + "</div>";

    if (config.isStock) {
      var tooltipIsStockBody1 = this.getClassName('tooltip-isStock-body1'),
          tooltipIsStockBody2 = this.getClassName('tooltip-isStock-body2'),
          tooltipIsStockOpen1 = this.getClassName('tooltip-isStock-open1'),
          tooltipIsStockOpen2 = this.getClassName('tooltip-isStock-open2'),
          tooltipIsStockHigh1 = this.getClassName('tooltip-isStock-high1'),
          tooltipIsStockHigh2 = this.getClassName('tooltip-isStock-high2'),
          tooltipIsStockLow1 = this.getClassName('tooltip-isStock-low1'),
          tooltipIsStockLow2 = this.getClassName('tooltip-isStock-low2'),
          tooltipIsStockClose = this.getClassName('tooltip-isStock-close');
      body = "\n      <style nonce=\"" + chartNonce + "\">\n        ." + tooltipIsStockBody1 + " {\n          display: grid; display: -ms-grid; grid-template-columns: auto auto auto auto 1fr; -ms-grid-columns: auto auto auto auto 1fr; grid-template-rows: auto auto; -ms-grid-rows: auto auto; margin-bottom:6px;\n        }\n\n        ." + tooltipIsStockBody2 + " {\n          grid-column-start: 1; -ms-grid-column: 1; grid-row-start: 1; -ms-grid-row: 1;\n        }\n      </style>\n      <div class=\"" + tooltipIsStockBody1 + "\">\n      <div class=\"" + tooltipIsStockBody2 + "\">\n      Open:\n      </div>\n      <style nonce=\"" + chartNonce + "\">\n        ." + tooltipIsStockOpen1 + " {\n          grid-column-start: 2; -ms-grid-column: 2; grid-row-start: 1; -ms-grid-row: 1; text-align: center;  margin-left: 6px;\n        }\n\n        ." + tooltipIsStockOpen2 + " {\n          grid-column-start: 3; -ms-grid-column: 3; grid-row-start: 1; -ms-grid-row: 1; margin-left: 12px;\n        }\n      </style>\n      <div class=\"" + tooltipIsStockOpen1 + "\">\n      " + ((0, _isNumber.default)(markerObj.openValue) ? (0, _lib.parseUnsafeString)(formatter(markerObj.openValue)) : DASH_STR) + "\n      </div>\n      <div class=\"" + tooltipIsStockOpen2 + "\">\n      High:\n      </div>\n      <style nonce=\"" + chartNonce + "\">\n        ." + tooltipIsStockHigh1 + " {\n          grid-column-start: 4; -ms-grid-column: 4; grid-row-start: 1; -ms-grid-row: 1; text-align: center; margin-left: 6px;\n        }\n\n        ." + tooltipIsStockHigh2 + " {\n          grid-column-start: 1; -ms-grid-column: 1; grid-row-start: 2; -ms-grid-row: 2;\n        }\n      </style>\n      <div class=\"" + tooltipIsStockHigh1 + "\">\n      " + ((0, _isNumber.default)(markerObj.highValue) ? (0, _lib.parseUnsafeString)(formatter(markerObj.highValue)) : DASH_STR) + "\n      </div>\n      <div class=\"" + tooltipIsStockHigh2 + "\">\n      Low:\n      </div>\n      <style nonce=\"" + chartNonce + "\">\n        ." + tooltipIsStockLow1 + " {\n          grid-column-start: 2; -ms-grid-column: 2; grid-row-start: 2; -ms-grid-row: 2; text-align: center; margin-left: 6px;\n        }\n\n        ." + tooltipIsStockLow2 + " {\n          grid-column-start: 3; -ms-grid-column: 3; grid-row-start: 2; -ms-grid-row: 2; margin-left: 12px;\n        }\n      </style>\n      <div class=\"" + tooltipIsStockLow1 + "\">\n      " + ((0, _isNumber.default)(markerObj.lowValue) ? (0, _lib.parseUnsafeString)(formatter(markerObj.lowValue)) : DASH_STR) + "\n      </div>\n      <div class=\"" + tooltipIsStockLow2 + "\">\n      Close:\n      </div>\n      <style nonce=\"" + chartNonce + "\">\n        ." + tooltipIsStockClose + " {\n          grid-column-start: 4; -ms-grid-column: 4; grid-row-start: 2; -ms-grid-row: 2; text-align: center; margin-left: 6px;\n        }\n      </style>\n      <div class=\"" + tooltipIsStockClose + "\">\n      " + ((0, _isNumber.default)(markerObj.closeValue) ? (0, _lib.parseUnsafeString)(formatter(markerObj.closeValue)) : DASH_STR) + "\n      </div>\n    </div>";
    } else if (config.isRange) {
      var tooltipIsRangeBody1 = this.getClassName('tooltip-isRange-body1'),
          tooltipIsRangeBody2 = this.getClassName('tooltip-isRange-body2'),
          tooltipIsRangeHigh1 = this.getClassName('tooltip-isRange-high1'),
          tooltipIsRangeHigh2 = this.getClassName('tooltip-isRange-high2'),
          tooltipIsRangeLow = this.getClassName('tooltip-isRange-low1');
      body = "\n      <style nonce=\"" + chartNonce + "\">\n        ." + tooltipIsRangeBody1 + " {\n          display: grid; display: -ms-grid; grid-template-columns: auto auto auto auto 1fr; -ms-grid-columns: auto auto auto auto 1fr; grid-template-rows: auto auto; -ms-grid-rows: auto auto; margin-bottom:6px;\n        }\n\n        ." + tooltipIsRangeBody2 + " {\n          grid-column-start: 1; -ms-grid-column: 1; grid-row-start: 1; -ms-grid-row: 1;\n        }\n      </style>\n      <div class=\"" + tooltipIsRangeBody1 + "\">\n      <div class=\"" + tooltipIsRangeBody2 + "\">\n      High:\n      </div>\n      <style nonce=\"" + chartNonce + "\">\n        ." + tooltipIsRangeHigh1 + " {\n          grid-column-start: 2; -ms-grid-column: 2; grid-row-start: 1; -ms-grid-row: 1; text-align: center;  margin-left: 6px;\n        }\n\n        ." + tooltipIsRangeHigh2 + " {\n          grid-column-start: 1; -ms-grid-column: 1; grid-row-start: 2; -ms-grid-row: 2;\n        }\n      </style>\n      <div class=\"" + tooltipIsRangeHigh1 + "\">\n      " + ((0, _isNumber.default)(markerObj.highValue) ? formatter(markerObj.highValue) : DASH_STR) + "\n      </div>\n      <div class=\"" + tooltipIsRangeHigh2 + "\">\n      Low:\n      </div>\n      <style nonce=\"" + chartNonce + "\">\n        ." + tooltipIsRangeLow + " {\n          grid-column-start: 2; -ms-grid-column: 2; grid-row-start: 2; -ms-grid-row: 2; text-align: center; margin-left: 6px;\n        }\n      </style>\n      <div class=\"" + tooltipIsRangeLow + "\">\n      " + ((0, _isNumber.default)(markerObj.lowValue) ? formatter(markerObj.lowValue) : DASH_STR) + "\n      </div>\n    </div>";
    } else {
      // Formatting the value to be shown on the tooltip
      if (!markerObj.tooltipValue) {
        markerObj.tooltipValue = formatter(markerObj.value);
      } // Value lying between -1 to 1 have issue in formatting.


      if (markerObj.value < 1 && markerObj.value > -1) {
        var tooltipIsMarkerObjBody1 = this.getClassName('tooltip-markerObj-body1'),
            tooltipIsMarkerObjBody2 = this.getClassName('tooltip-markerObj-body2'),
            tooltipIsMarkerObjBody3 = this.getClassName('tooltip-markerObj-body3');
        body = "\n        <style nonce=\"" + chartNonce + "\">\n          ." + tooltipIsMarkerObjBody1 + " {\n            margin-bottom:6px; height: 14px;\n          }\n\n          ." + tooltipIsMarkerObjBody2 + " {\n            float: left;\n          }\n\n          ." + tooltipIsMarkerObjBody3 + " {\n            padding-left: 8px;\n          }\n        </style>\n        <div class=\"" + tooltipIsMarkerObjBody1 + "\">\n        <div class=\"" + tooltipIsMarkerObjBody2 + "\">" + (0, _lib.parseUnsafeString)(markerObj.seriesname) + ":<span class=\"" + tooltipIsMarkerObjBody3 + "\">\n        " + markerObj.value + "</span></div>\n        </div>";
      } else {
        var _tooltipIsMarkerObjBody = this.getClassName('tooltip-markerObj-body1'),
            _tooltipIsMarkerObjBody2 = this.getClassName('tooltip-markerObj-body2'),
            _tooltipIsMarkerObjBody3 = this.getClassName('tooltip-markerObj-body3');

        body = "\n        <style nonce=\"" + chartNonce + "\">\n          ." + _tooltipIsMarkerObjBody + " {\n            margin-bottom:6px; height: 14px;\n          }\n\n          ." + _tooltipIsMarkerObjBody2 + " {\n            float: left;\n          }\n\n          ." + _tooltipIsMarkerObjBody3 + " {\n            padding-left: 8px;\n          }\n        </style>\n        <div class=\"" + _tooltipIsMarkerObjBody + "\">\n        <div class=\"" + _tooltipIsMarkerObjBody2 + "\">" + (0, _lib.parseUnsafeString)(markerObj.seriesname) + ":<span class=\"" + _tooltipIsMarkerObjBody3 + "\">\n        " + (0, _lib.parseUnsafeString)(markerObj.tooltipValue) + "</span></div>\n        </div>";
      }
    }

    markers.forEach(function (currMarker, i) {
      var margBottom = 6; // Setting individual date if multiple markers are present

      if (multipleMarkers && !timeMap[currMarker.time]) {
        var tooltipIsmultipleMarkersBody = _this2.getClassName('tooltip-multipleMarkers-body');

        timeMap[currMarker.time] = true;
        body += "\n        <style nonce=\"" + chartNonce + "\">\n          ." + tooltipIsmultipleMarkersBody + " {\n            clear: both; margin-bottom:2px; font-weight: 600;\n          }\n        </style>\n        <div clas=\"" + tooltipIsmultipleMarkersBody + "\">" + currMarker.time + "</div>";

        if (i + 1 < len && timeMap[markers[i + 1].time]) {
          margBottom = 2;
        }
      }

      var tooltipIscurrMarkersBody = _this2.getClassName('tooltip-currMarker-body');

      body += currMarker.tooltext ? "\n      <style nonce=\"" + chartNonce + "\">\n        ." + tooltipIscurrMarkersBody + " {\n          clear: both; " + (i < len - 1 ? 'margin-bottom: ' + margBottom + 'px' : '') + ";\n        }\n      </style>\n      <div class=\"" + tooltipIscurrMarkersBody + "\">" + (0, _lib.parseUnsafeString)(currMarker.tooltext, false) + "</div>" : '';
    });
    return {
      header: header,
      body: body
    };
  }
  /**
   * Function to induce the grouoing of the dataplots
   */
  ;

  _proto.allocatePosition = function allocatePosition() {
    !this.config.skipGrouping && this._groupMarkers();
  }
  /**
   * This function determines the grouping and positioning of the data markers
   */
  ;

  _proto._groupMarkers = function _groupMarkers() {
    var marker = this,
        parent = marker.getLinkedParent(),
        info = parent._getRelevantInfo(),
        dataInfo = info.dataInfo,
        config = marker.config,
        markerInfo = config.markerInfo = {},
        currMarkerObj,
        index,
        markerTime,
        timeGroupLevelDiff,
        binDecider = marker.getFromEnv('binDecider'),
        thresHold = binDecider.getRangeThreshold(),
        currentGrouping = thresHold[0].name(),
        firstTimeStamp = info.firstTimeStamp,
        xScale = marker.getFromEnv('xScale'),
        xScaleDomain = xScale.getDomain(),
        plotInfo,
        seriesInfo,
        seriesName,
        keys,
        data = config.data;

    config.dataInfo = dataInfo;
    data.forEach(function (currMarker, i) {
      markerTime = _timeConverter.default.parser(currMarker.timeformat).parse(currMarker.time); // Getting the differnce between the current aggregation level and the minimum time stamp entered in datamarker

      timeGroupLevelDiff = (0, _timeBucket.getPlaceHolderIndex)(currentGrouping) - (0, _timeBucket.getPlaceHolderIndex)((0, _timeBucket.getMinPlaceHolder)(currMarker.timeformat)); // Checking for the validity of the marker, if it is to be shown in the current aggregation level
      // FTV3-1147: Data marker is drawn at wrong position w.r.t. the specified date
      // Allowing data markers visibility upto two immediate time hierarchy levels

      if (markerTime && timeGroupLevelDiff >= 0 && timeGroupLevelDiff <= 2) {
        //  Getting index form dataInfo object
        markerTime = markerTime.getTime();

        if (markerTime >= firstTimeStamp && markerTime >= xScaleDomain[0] && markerTime <= xScaleDomain[1]) {
          // Storing a copy for the datamarker
          // Fetching the marker index from the DataInfo based on the index of data Array
          index = xScale.getBinIndex(markerTime, false); // Storing a copy for the datamarker

          if (plotInfo = dataInfo[index]) {
            seriesInfo = currMarker.series || {};
            seriesName = Object.keys(seriesInfo)[0];
            keys = (config.isRange || config.isStock) && ((0, _isObject.default)(currMarker.measures[0]) ? Object.keys(currMarker.measures[0]).toString() : currMarker.measures[0]);

            if (!markerInfo[index]) {
              markerInfo[index] = {
                markers: [],
                // Setting unique id of each marker
                id: (config.isStock || config.isRange ? keys : currMarker.seriesname) + currMarker.time,
                startDate: plotInfo.startDate,
                seriesname: currMarker.seriesname,
                endDate: dataInfo[index].endDate,
                eventArgs: {
                  timestamp: markerTime,
                  timeText: currMarker.time,
                  tooltipText: [currMarker.tooltext],
                  timeFormatter: currMarker.timeformat,
                  binStart: plotInfo.startDate,
                  binEnd: plotInfo.endDate,
                  binValue: plotInfo.eventArgs.binValue,
                  binValueFormatted: plotInfo.eventArgs.binValueFormatted,
                  measure: currMarker.value,
                  series: seriesName,
                  seriesName: seriesName && seriesInfo[seriesName],
                  identifier: currMarker.identifier
                }
              };
            }

            currMarkerObj = markerInfo[index];

            if (config.isStock) {
              currMarkerObj.openValue = plotInfo.openValue;
              currMarkerObj.highValue = plotInfo.highValue;
              currMarkerObj.lowValue = plotInfo.lowValue;
              currMarkerObj.closeValue = plotInfo.closeValue;
            } else if (config.isRange) {
              currMarkerObj.highValue = plotInfo.highValue;
              currMarkerObj.lowValue = plotInfo.lowValue;
            } else {
              currMarkerObj.value = plotInfo.value;
            }

            currMarkerObj.markers.push(currMarker);

            if (currMarkerObj.markers.length > 1) {
              currMarkerObj.multipleMarkers = true;
              currMarkerObj.eventArgs.tooltipText.push(currMarker.tooltext);
              currMarkerObj.eventArgs.identifier = currMarkerObj.markers.length;
            }
          }
        }
      }
    });
  }
  /**
   * Function to create the group for markers
   */
  ;

  _proto._createGroup = function _createGroup() {
    var marker = this;
    marker.addGraphicalElement({
      el: 'group',
      container: {
        label: 'group',
        id: 'thermo',
        isParent: true
      },
      component: marker,
      label: 'group',
      attr: {
        name: 'markerGroup-thermo'
      }
    });
    marker.addGraphicalElement({
      el: 'group',
      container: {
        label: 'group',
        id: 'thermo',
        isParent: true
      },
      component: marker,
      label: 'group-pin',
      attr: {
        name: 'markerGroup-thermo-pin'
      }
    });
  };

  _proto._drawMarkers = function _drawMarkers() {
    var marker = this,
        currMarkerObj,
        index,
        forceDrawFlag,
        allPin = true,
        markerInfo = marker.config.markerInfo,
        checkIfAllPins = function checkIfAllPins(m) {
      if (m.type !== TYPE_PIN) {
        allPin = false;
      }
    };

    for (index in markerInfo) {
      currMarkerObj = markerInfo[index];
      forceDrawFlag = false;
      allPin = true;

      if (currMarkerObj.multipleMarkers) {
        currMarkerObj.markers.forEach(checkIfAllPins);
        forceDrawFlag = !allPin;
      }

      if (currMarkerObj.markers[0].type === TYPE_PIN && !forceDrawFlag) {
        (0, _pinMarkerDrawable.default)(marker, index, markerDimensions);
      } else {
        (0, _flagMarkerDrawable.default)(marker, index, markerDimensions);
      }
    } // Deleting the information inside style object as drawing is complete


    marker.styleInfo = {};
  }
  /**
   * parsing of style information of data markers
   *
   * @param {any} index the data marker whose style information is to be parsed
   * @returns {Object} object containing the style of data marker text and background
   * @memberof FlagMarker
   */
  ;

  _proto.getStyleInformation = function getStyleInformation(index) {
    var marker = this,
        config = marker.config,
        styleInfo = config.styleInfo,
        currMarkerObj = config.markerInfo[index],
        getStyleDef = marker.getFromEnv('getStyleDef'),
        markerStyle,
        markerHoverStyle,
        textStyle,
        style,
        currMarker,
        defaultMarkerStyle = config.defaultMarkerStyle,
        defaultTextStyle = config.defaultTextStyle,
        info = marker.getLinkedParent()._getRelevantInfo(index),
        appliedMarkerStyle,
        appliedTextStyle,
        hoveredStyleInfo,
        baseTextStyle = marker.getFromEnv('baseTextStyle'),
        textStyles,
        markerStyles;

    appliedMarkerStyle = {};
    appliedTextStyle = {};
    hoveredStyleInfo = styleInfo[index] || {};
    markerHoverStyle = hoveredStyleInfo.marker || {};
    currMarker = currMarkerObj.markers[0];
    style = currMarker.style || {};
    markerStyle = getStyleDef(style.marker);
    textStyle = getStyleDef(style.text);

    if (currMarkerObj.multipleMarkers) {
      markerStyles = currMarkerObj.markers.map(function (markerInfo) {
        return markerInfo.style && getStyleDef(markerInfo.style.marker) || {};
      });
      textStyles = currMarkerObj.markers.map(function (markerInfo) {
        return markerInfo.style && getStyleDef(markerInfo.style.text) || {};
      });
      markerStyle = getSameProperty(markerStyles);
      textStyle = getSameProperty(textStyles);

      if (!markerStyle.fill) {
        markerStyle.fill = currMarkerObj.fill = config['default-stroke-color-multiple'];
      }

      if (!markerStyle.stroke) {
        markerStyle.stroke = config['default-stroke-color-multiple'];
      }
    } else {
      // special case for candlestick chart for default styles
      // since the default fill for bull of candle stick is white and defalut text
      // fill of data marker is white so text is not visible
      // if user has not given any fill for marker and text then the text fill
      // will be stroke of candle stick
      if (!markerStyle.fill && !textStyle.fill && config.isStock && info.text) {
        textStyle = Object.assign({}, textStyle, info.text);
      }

      markerStyle.fill = currMarkerObj.fill = (0, _libGraphics.convertColor)((0, _lib.pluck)(markerStyle.fill, info.fill), (0, _lib.pluck)(markerHoverStyle['fill-opacity'], markerStyle['fill-opacity'], defaultMarkerStyle['fill-opacity']) * 100);
      markerStyle.stroke = currMarkerObj.stroke = (0, _libGraphics.convertColor)((0, _lib.pluck)(markerStyle.stroke, info.stroke, info.fill), (0, _lib.pluck)(markerHoverStyle['stroke-opacity'], markerStyle['stroke-opacity'], defaultMarkerStyle['fill-opacity']) * 100);
    }

    Object.assign(appliedMarkerStyle, defaultMarkerStyle, markerStyle, hoveredStyleInfo.marker);
    Object.assign(appliedTextStyle, defaultTextStyle, baseTextStyle, textStyle, hoveredStyleInfo.text);
    return {
      marker: appliedMarkerStyle,
      text: appliedTextStyle
    };
  };

  return DataMarker;
}(_smartRenderer.default);

var _default = DataMarker;
exports["default"] = _default;

/***/ }),

/***/ 926:
/***/ ((__unused_webpack_module, exports) => {



exports.__esModule = true;
exports["default"] = void 0;
var pinPathStr = 'M12.0047766,4 L12.2491793,4.00380682 C16.5521622,4.13545713 20,7.66508574 20,12 C20,16.418278 16.418278,20 12,20 C7.581722,20 4,16.418278 4,12 C4,11.9105612 4.0014677,11.8214651 4.00438034,11.7327347 L4,4 L12,4 L12.0047766,4 Z';
/**
 * Function to draw the FlagMarkers
*/

var _default = function _default(marker, index, markerDimensions) {
  var config = marker.config,
      markerDetails = config.markerInfo[index],
      data = config.dataInfo[index],
      markerStyle = marker.getStyleInformation(index),
      pinY,
      pinX,
      currMarker,
      stroke,
      fill,
      id,
      attrObj,
      markerOpacity,
      textOpacity,
      multipleMarkers,
      pinHeight = markerDimensions.pinHeight,
      pinWidth = markerDimensions.pinWidth;
  multipleMarkers = markerDetails.multipleMarkers;
  id = markerDetails.id;
  pinY = data.y - (pinHeight + 2);
  pinX = data.x + (data.width || 0) / 2 - pinWidth / 2; // If multiple markers are in a single index then no style customization can be applied

  if (!multipleMarkers) {
    currMarker = markerDetails.markers[0];
  }

  markerOpacity = markerStyle.marker.opacity;
  textOpacity = markerStyle.text.opacity; // Creating the of the pin marker

  attrObj = {
    path: pinPathStr,
    transform: "t" + pinX + "," + pinY + "r225",
    opacity: markerOpacity
  }; // Applying the style only when it is provided

  stroke && (attrObj.stroke = stroke);
  fill && (attrObj.fill = fill);
  marker.addGraphicalElement({
    el: 'path',
    container: {
      label: 'group-pin'
    },
    id: id,
    attr: attrObj,
    css: markerStyle.marker,
    label: 'pinMarker'
  }, true); // Drawing the text if multiple markers are present

  if (multipleMarkers || currMarker.identifier) {
    attrObj = {
      text: multipleMarkers ? markerDetails.markers.length : currMarker.identifier.charAt(0),
      x: pinX + pinWidth / 2,
      y: pinY + pinHeight / 2 + 2,
      opacity: textOpacity
    };
    marker.addGraphicalElement({
      el: 'text',
      container: {
        label: 'group-pin'
      },
      id: id,
      attr: attrObj,
      css: markerStyle.text,
      label: 'markerText'
    }, true);
  }
};

exports["default"] = _default;

/***/ }),

/***/ 940:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _lib = __webpack_require__(274);

var _index = _interopRequireDefault(__webpack_require__(908));

var _dependencyManager = __webpack_require__(282);

var _libGraphics = __webpack_require__(278);

var _isValidNumber = _interopRequireDefault(__webpack_require__(856));

var _areaGenerator = _interopRequireDefault(__webpack_require__(914));

var _lineGenerator = _interopRequireDefault(__webpack_require__(917));

var _step = _interopRequireDefault(__webpack_require__(918));

var _linear = _interopRequireDefault(__webpack_require__(916));

var _monotone = _interopRequireDefault(__webpack_require__(919));

var _timeConverter = _interopRequireDefault(__webpack_require__(350));

var _line = _interopRequireDefault(__webpack_require__(928));

var _line2 = _interopRequireDefault(__webpack_require__(907));

var _rangedPlotUtils = __webpack_require__(939);

var PLOT_HOVERED_ANCHOR_RADIUS = 5.5,
    DEFAULT_LINE_LENGTH = 10,
    DEFAULT_GAP_LENGTH = 5,
    maxRadius = 5,
    VISIBLE = 'visible',
    CRISP_CONSTANT = 0.0625,
    DEFAULT_COLOR = '9194CC',
    calculateMid = function calculateMid(a, b) {
  return (a + b) / 2;
},

/**
 * If given a blank string, returns a valid path string by converting the
 * blank string to a M0,0 command. Otherwise, it assumes the the input path
 * string is valid and returns the input.
 *
 * @param {string} [pathString=''] The path string to be processed.
 *
 * @returns {string} The processed path string.
 */
unBlankify = function unBlankify(pathString) {
  if (pathString === void 0) {
    pathString = '';
  }

  return pathString === '' ? 'M0,0' : pathString;
},

/**
 * Attempts to 'crisp' the left and right edges of an input object with x, y,
 * width and height properties (i.e. a rectangle). Crisping is the act of
 * removing sub-pixel rendering artifacts by adjusting the edges by some
 * constant.
 *
 * @param {Object} rect The rectangle to be crisped.
 * @param {number} rect.x The co-ordinate of left edge of the rectangle.
 * @param {number} rect.y The co-ordinate of the top edge of the rectangle.
 * @param {number} rect.width The width of the rectangle.
 * @param {number} rect.height The height of the rectangle.
 *
 * @returns {Object} A crisped rectangle.
 */
crisper = function crisper(_ref) {
  var x = _ref.x,
      y = _ref.y,
      width = _ref.width,
      height = _ref.height;
  return {
    y: y,
    height: height,
    x: x - CRISP_CONSTANT,
    width: width + CRISP_CONSTANT * 2
  };
},

/**
 * Reduces a series of rectangle objects (i.e. objects with a x, y, width and
 * height) into a path string which visually correspond to exactly the same
 * series of rectangles.
 *
 * @param {string} acc The string into which the reducer will accumulate the
 * individual path strings
 * @param {Object} rect The rectangle to be reduced to its corresponding
 * path string
 * @param {number} rect.x The co-ordinate of left edge of the rectangle.
 * @param {number} rect.y The co-ordinate of the top edge of the rectangle.
 * @param {number} rect.width The width of the rectangle.
 * @param {number} rect.height The height of the rectangle.
 *
 * @returns {string} The input rectangle object, converted into a path string
 * and concatenated with the input accumulator.
 */
toPathRect = function toPathRect(acc, rect) {
  return acc + "M" + rect.x + "," + rect.y + "L" + (rect.x + rect.width) + "," + rect.y + "L" + (rect.x + rect.width) + "," + (rect.y + rect.height) + "L" + rect.x + "," + (rect.y + rect.height) + "Z";
};

var LINE = 'line',
    AREA = 'area',
    WHITE = '#ffffff'; // helper function to get the generator depending on the type of dataset

function getGenerator(type) {
  switch (type) {
    case 'area':
    case 'area-range':
    case 'smooth-area':
    case 'step-area':
      return _areaGenerator.default;

    case 'line':
    case 'smooth-line':
    case 'mean-line':
    case 'step-line':
    default:
      return _lineGenerator.default;
  }
} // helper function to get the curve generator class depending on the type of
// dataset


function getCurve(type) {
  switch (type) {
    case 'smooth-line':
    case 'smooth-area':
      return _monotone.default;

    case 'step-area':
    case 'step-line':
      return _step.default;

    case 'line':
    case 'area':
    case 'area-range':
    default:
      return _linear.default;
  }
}

function isArea(type) {
  return type === 'area' || type === 'smooth-area' || type === 'step-area' || 'area-range';
}

function isLine(type) {
  return type === 'line' || type === 'smooth-line' || type === 'step-line';
}

(0, _dependencyManager.addDep)({
  name: 'continuousAnimation',
  type: 'animationRule',
  extension: _line.default
});

var AreaRange = /*#__PURE__*/function (_Line) {
  (0, _inheritsLoose2.default)(AreaRange, _Line);

  function AreaRange() {
    return _Line.apply(this, arguments) || this;
  }

  var _proto = AreaRange.prototype;

  /**
   * Sets the name of the component
   * @return {string} name
   */
  _proto.getName = function getName() {
    return 'continuous-range';
  }
  /**
   * returns the data plot indices which falls within the range
   * @param {Object} range min and max value range
   * @returns {Array} array of data points
   */
  ;

  _proto.getHighlightedIndices = function getHighlightedIndices(range) {
    var dataset = this,
        config = dataset.config,
        dataInfo = config.dataInfo,
        hightlightedPoints = []; // FTV3-1175: Highlighting plots falling inside the reference zone in range charts
    // Adding a check for base value of datapoint inside reference zone

    dataInfo.forEach(function (data, index) {
      if (data.base <= range.minValue && data.y >= range.maxValue) {
        hightlightedPoints.push(index);
      }
    });
    return hightlightedPoints;
  };

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    _Line.prototype.__setDefaultConfig.call(this);

    var config = this.config;
    config['default-stroke'] = DEFAULT_COLOR;
    config['default-fill'] = DEFAULT_COLOR;
    config['default-anchor-stroke'] = (0, _libGraphics.convertColor)(WHITE);
    config.type = LINE;
    config.isRange = true;
    config.plotStyle = {};
    config.nullPlotStyle = {};
    config.linePlotStyle = {};
    config.nullLinePlotStyle = {};
    config.areaPlotStyle = {};
    config.nullAreaPlotStyle = {};
    config.anchorStyle = {};
    config.anchorHoverInStyle = {};
    config.anchorHoverOutStyle = {};
    config.anchorHighlightObj = {};
    config.defaultLineStyle = {
      'stroke-opacity': 1,
      'stroke-width': 2,
      'stroke-dasharray': 'none',
      fill: 'none'
    };
    config.defaultNullLineStyle = {
      'stroke-opacity': 1,
      'stroke-width': 2,
      'stroke-dasharray': [DEFAULT_LINE_LENGTH, DEFAULT_GAP_LENGTH],
      fill: 'none'
    };
    config.defaultLinePredictiveStyle = {
      'stroke-opacity': 1,
      'stroke-width': 1,
      'stroke-dasharray': 5,
      fill: 'none'
    };
    config.defaultAreaStyle = {
      'stroke-opacity': 1,
      'stroke-width': 0,
      'fill-opacity': 0.6
    };
    config.defaultNullAreaStyle = {
      'stroke-opacity': 1,
      'stroke-width': 0,
      'fill-opacity': 0.3
    };
    config.defaultAreaPredictiveStyle = {
      'stroke-opacity': 1,
      opacity: 0.5
    };
    config.defaultAnchorStyle = {
      'fill-opacity': 1,
      'stroke-width': 1
    };
    config.willInjectNulls = true;
  }
  /**
   * Function to allocation the position of the dataplots
   */
  ;

  _proto.allocatePosition = function allocatePosition() {
    var dataset = this,
        config = dataset.config,
        _config$indices = config.indices,
        xIdx = _config$indices[0],
        highIdx = _config$indices[1],
        lowIdx = _config$indices[2],
        seriesInfo = config.seriesInfo,
        dateColumn = dataset.getFromEnv('dateColumn'),
        isUTC = dataset.getFromEnv('UTC'),
        dsType = config.type,
        data = config.data,
        dataInfo = config.dataInfo,
        dataInfoNull = [],
        dataObj,
        binDecider = dataset.getFromEnv('binDecider'),
        xScale = dataset.getFromEnv('xScale'),
        yScale = dataset.getFromEnv('yScale'),
        xThresholdDuration = binDecider.getRangeThreshold()[2],
        nullClipAdjustment = Number.parseFloat(config.nullLinePlotStyle['stroke-width']),
        predictionClipAdjustment = Number.parseFloat(config.predictiveStyleAttributesLine['stroke-width']),
        clipAdjustment = Number.parseFloat(config.linePlotStyle['stroke-width']),
        pathGenerator,
        startDate,
        endDate,
        midDate,
        nextData,
        nextMidDate,
        yValue,
        highValue,
        lowValue,
        pX,
        base,
        y,
        i,
        len,
        bins = xScale.bins,
        yBaseValue,
        paddingInTimestamp,
        dataLen = data.length,
        _xScale$getDomain = xScale.getDomain(),
        startDomain = _xScale$getDomain[0],
        endDomain = _xScale$getDomain[1],
        xValue,
        duration,
        eventArgs,
        seriesName,
        format = dateColumn.format,
        formatter = isUTC ? _timeConverter.default.utcFormatter(format) : _timeConverter.default.formatter(format),
        isPlotOverTick = xScale.showPlotOverTick(); // Storing the 1st time stam


    config.firstTimeStamp = data && data[0] && data[0][xIdx] && data[0][xIdx].start;

    if (config.repositioningDone = dataset._isRepositioningNeeded()) {
      // skip drawing if dataset is not visible
      if (config.visibility !== 'visible') {
        return;
      }

      dataInfo = config.dataInfo = []; // Store data related operations

      config.timeStampGap = xThresholdDuration; // Storing info for dataMarker detection

      config.availableWidth = 0; // Storing info for dataMarker detection

      for (i = 0, len = bins.length; i < len; i++) {
        if (bins[i].clipType !== 2) {
          config.availableWidth = xScale.getRangeValue(bins[i].end) - xScale.getRangeValue(bins[i].start);
          break;
        }
      }

      paddingInTimestamp = +xScale.getDomainValue(PLOT_HOVERED_ANCHOR_RADIUS) - +xScale.getDomainValue(0); // Storing value for tooltip

      config.actualStartDomain = +startDomain - paddingInTimestamp; // Actual end domain is the scale domain minus the space taken up by the
      // plotspacepercent

      config.actualEndDomain = +endDomain + paddingInTimestamp; // Storing the x and y for plotting the data which is later used for
      // tooltip detection

      data.forEach(function (d, index, dataArr) {
        xValue = d[xIdx];
        highValue = Math.max(d[highIdx], d[lowIdx]);
        lowValue = Math.min(d[lowIdx], d[highIdx]);
        yValue = highValue;
        duration = xValue.config.duration;
        startDate = xValue.start;
        endDate = xValue.end;
        midDate = calculateMid(startDate, endDate);
        nextData = dataArr[index + 1];
        yBaseValue = lowValue;
        base = yScale.getRangeValue(yBaseValue || Math.max(yScale.getDomain()[0], 0));
        y = yScale.getRangeValue(yValue); // Storing the 1st time stamp

        if (!index) {
          config.firstTimeStamp = startDate;
        }

        if (dsType === AREA && !(0, _isValidNumber.default)(base)) {
          return;
        }

        if ((0, _isValidNumber.default)(yValue) && (0, _isValidNumber.default)(y)) {
          // Get the data index corresponding to the fetched timeStamp
          pX = xScale.getBinIndex(startDate);
          dataObj = {
            startDate: startDate,
            endDate: endDate,
            highValue: highValue,
            lowValue: lowValue,
            timeInstant: isPlotOverTick ? startDate : midDate,
            value: yValue,
            paddingInTimestamp: paddingInTimestamp,
            yBaseValue: dsType === AREA ? yBaseValue : _lib.UNDEF,
            x: xScale.getRangeValue(new Date(startDate), new Date(endDate)),
            endXPosition: xScale.getRangeValue(new Date(startDate), new Date(endDate)),
            y: y,
            base: base
          };
          eventArgs = {
            index: index,
            dataValue: yValue,
            highValue: highValue,
            lowValue: lowValue,
            start: startDate,
            startText: formatter.format(startDate),
            end: endDate,
            endText: formatter.format(endDate),
            binUnit: duration.Unit,
            binMultiplier: duration.number,
            plotType: config.type,
            timeFormatter: format,
            aggregation: config.aggregation,
            measure: config.measures[0],
            binValue: yValue,
            binValueFormatted: config.formatterFn && config.formatterFn({
              value: yValue,
              type: 'tooltip',
              prefix: config.prefix,
              suffix: config.suffix
            })
          };
          seriesName = null;

          if (seriesName) {
            eventArgs.series = seriesName;
            eventArgs.seriesValue = seriesInfo[seriesName];
          }

          dataObj.eventArgs = eventArgs;
          dataInfo[pX] = dataObj; // Storing metadata

          if (nextData) {
            var nextPX = xScale.getBinIndex(nextData[xIdx].start);
            dataInfoNull.push(dataObj);
            nextMidDate = calculateMid(nextData[xIdx].start, nextData[xIdx].end); // Pushing null if the gap between 2 consequtive data is more than
            // the threshold handling the uneven number of days in each month
            // with the 1.5 multiplier

            if (config.willInjectNulls && nextMidDate - midDate - (xScale.clips[nextPX] - xScale.clips[pX]) > xThresholdDuration * 1.5) {
              dataInfoNull.push(null);
            }
          } else if (dataLen - index === 1) {
            // For the last data
            dataInfoNull.push(dataObj);
          }
        } else if (config.willInjectNulls) {
          // when value is not present, insert null to show gaps in data
          dataInfoNull.push(null);
        }
      });
      pathGenerator = new _index.default(getGenerator(dsType)).setConnectUndefineds(config.connectNullData).setChunks({
        def: {
          clipAdjustment: clipAdjustment
        },
        undef: {
          clipAdjustment: nullClipAdjustment
        },
        predictive: {
          clipAdjustment: predictionClipAdjustment
        }
      }) // Uncomment to create a line instead of a smooth line
      .setCurve(getCurve(dsType)) // Below function determines what will happen incase of null data
      .setDefined(function (d) {
        return !!d;
      }).setChunkDecider(function (d) {
        return d.startDate >= config.prediction.dateMs ? 'predictive' : 'def';
      }) // Below function determines the x location of the plot
      .setXAccessor(function (d) {
        return d.x;
      }) // Below function determines the y location of the plot
      .setYAccessor(function (d) {
        return d.y;
      }); // applicable only for area charts.

      if (isArea(dsType)) {
        // Below function determines the y base location of the plot
        pathGenerator.setYBaseAccessor(function (d) {
          return d.base;
        });
      } // Below function generates the path


      config.chunks = pathGenerator.generate(dataInfoNull);
      config.path = unBlankify(config.chunks.def.path);
      config.clipPath = unBlankify(config.chunks.def.clipRects.map(crisper).reduce(toPathRect, ''));
      config.nullPath = unBlankify(config.chunks.undef.path);
      config.nullClipPath = unBlankify(config.chunks.undef.clipRects.map(crisper).reduce(toPathRect, ''));
      config.predictivePath = unBlankify(config.chunks.predictive.path);
      config.predictiveClipPath = unBlankify(config.chunks.predictive.clipRects.map(crisper).reduce(toPathRect, '')); // Below function generates only the top path

      config.topChunks = pathGenerator.getLineChunkerYTop().generate(dataInfoNull);
      config.topPath = unBlankify(config.topChunks.def.path);
      config.topClipPath = unBlankify(config.topChunks.def.clipRects.map(crisper).reduce(toPathRect, ''));
      config.topNullPath = unBlankify(config.topChunks.undef.path);
      config.topNullClipPath = unBlankify(config.topChunks.undef.clipRects.map(crisper).reduce(toPathRect, ''));
      config.topPredictivePath = unBlankify(config.topChunks.predictive.path);
      config.topPredictiveClipPath = unBlankify(config.topChunks.predictive.clipRects.map(crisper).reduce(toPathRect, '')); // Below function generates only the bottom path

      config.bottomChunks = pathGenerator.getLineChunkerYBase().generate(dataInfoNull);
      config.bottomPath = unBlankify(config.bottomChunks.def.path);
      config.bottomClipPath = unBlankify(config.bottomChunks.def.clipRects.map(crisper).reduce(toPathRect, ''));
      config.bottomNullPath = unBlankify(config.bottomChunks.undef.path);
      config.bottomNullClipPath = unBlankify(config.bottomChunks.undef.clipRects.map(crisper).reduce(toPathRect, ''));
      config.bottomPredictivePath = unBlankify(config.bottomChunks.predictive.path);
      config.bottomPredictiveClipPath = unBlankify(config.bottomChunks.predictive.clipRects.map(crisper).reduce(toPathRect, ''));
    }
  }
  /**
   * Function to draw the line plot
   */
  ;

  _proto._drawPlot = function _drawPlot() {
    var dataset = this,
        config = dataset.config,
        linePlotStyleObj = config.linePlotStyle,
        areaPlotStyleObj = config.areaPlotStyle,
        nullLinePlotStyleObj = config.nullLinePlotStyle,
        nullAreaPlotStyleObj = config.nullAreaPlotStyle,
        predictiveStyleAttributesLine = config.predictiveStyleAttributesLine,
        predictiveStyleAttributesArea = config.predictiveStyleAttributesArea,
        dataInfo = config.dataInfo,
        data; // dataset meso parent group

    dataset.addGraphicalElement({
      el: 'group',
      container: {
        id: 'meso',
        label: 'group'
      },
      component: dataset,
      label: 'group',
      id: 'meso-line',
      attr: {
        name: 'line-common-meso',
        visibility: config.visibility
      }
    }); // dataset thermo parent group

    dataset.addGraphicalElement({
      el: 'group',
      container: {
        id: 'thermo',
        label: 'group'
      },
      component: dataset,
      label: 'group',
      id: 'thermo-line',
      attr: {
        name: 'line-common-thermo',
        visibility: config.visibility
      }
    }); // Meso group for line path plot

    dataset.addGraphicalElement({
      el: 'group',
      container: {
        id: 'meso-line',
        label: 'group'
      },
      component: dataset,
      label: 'group',
      id: 'meso-plot',
      attr: {
        name: 'line-plot-meso',
        visibility: config.visibility
      }
    }, true); // Thermo group for line path plot

    dataset.addGraphicalElement({
      el: 'group',
      container: {
        id: 'thermo-line',
        label: 'group'
      },
      component: dataset,
      label: 'group',
      id: 'thermo-plot',
      attr: {
        name: 'line-plot-thermo',
        visibility: config.visibility
      }
    }, true); // Group for anchor (thermo)
    // As anchors should drawn on top of area path

    dataset.addGraphicalElement({
      el: 'group',
      container: {
        id: 'thermo-line',
        label: 'group'
      },
      component: dataset,
      label: 'group',
      id: 'thermo-anchor',
      attr: {
        name: 'line-anchor-thermo',
        visibility: config.visibility
      }
    }, true);

    if (config.connectNullData) {
      // drawing null area fill/line path in meso-plot group
      dataset.addGraphicalElement({
        el: 'path',
        container: {
          label: 'group',
          id: 'meso-plot'
        },
        attr: Object.assign({
          path: config.nullPath,
          'clip-path': config.nullClipPath
        }, isLine(config.type) ? nullLinePlotStyleObj : nullAreaPlotStyleObj),
        label: 'path',
        component: dataset
      }, true);
    } // drawing area fill/line path in meso-plot group


    dataset.addGraphicalElement({
      el: 'path',
      container: {
        label: 'group',
        id: 'meso-plot'
      },
      attr: Object.assign({
        path: config.path,
        'clip-path': config.clipPath
      }, isLine(config.type) ? linePlotStyleObj : areaPlotStyleObj),
      label: 'path',
      component: dataset
    }, true);

    if (config.prediction.enabled) {
      // drawing null area fill/line path in meso-plot group
      dataset.addGraphicalElement({
        el: 'path',
        container: {
          label: 'group',
          id: 'meso-plot'
        },
        attr: Object.assign({
          path: config.predictivePath,
          'clip-path': config.predictiveClipPath
        }, isLine(config.type) ? predictiveStyleAttributesLine : predictiveStyleAttributesArea),
        label: 'path',
        component: dataset
      }, true);
    } // draw the top path of dataset in thermo group.


    if (config.topPath) {
      if (config.connectNullData) {
        dataset.addGraphicalElement({
          el: 'path',
          container: {
            label: 'group',
            id: 'thermo-plot'
          },
          attr: Object.assign({
            path: config.topNullPath,
            'clip-path': config.topNullClipPath
          }, nullLinePlotStyleObj),
          label: 'topPath',
          component: dataset
        }, true);
      }

      dataset.addGraphicalElement({
        el: 'path',
        container: {
          label: 'group',
          id: 'thermo-plot'
        },
        attr: Object.assign({
          path: config.topPath,
          'clip-path': config.topClipPath
        }, linePlotStyleObj),
        label: 'topPath',
        component: dataset
      }, true);

      if (config.prediction.enabled) {
        // drawing predictive area fill/line path in meso-plot group
        dataset.addGraphicalElement({
          el: 'path',
          container: {
            label: 'group',
            id: 'meso-plot'
          },
          attr: Object.assign({
            path: config.topPredictivePath,
            'clip-path': config.topPredictiveClipPath
          }, predictiveStyleAttributesLine),
          label: 'path',
          component: dataset
        }, true);
      }
    } // draw the bottom path of dataset in thermo group.


    if (config.bottomPath) {
      if (config.connectNullData) {
        dataset.addGraphicalElement({
          el: 'path',
          container: {
            label: 'group',
            id: 'thermo-plot'
          },
          attr: Object.assign({
            path: config.bottomNullPath,
            'clip-path': config.bottomNullClipPath
          }, nullLinePlotStyleObj),
          label: 'topPath',
          component: dataset
        }, true);
      }

      dataset.addGraphicalElement({
        el: 'path',
        container: {
          label: 'group',
          id: 'thermo-plot'
        },
        attr: Object.assign({
          path: config.bottomPath,
          'clip-path': config.bottomClipPath
        }, linePlotStyleObj),
        label: 'bottomPath',
        component: dataset
      }, true);

      if (config.prediction.enabled) {
        // drawing predictive area fill/line path in meso-plot group
        dataset.addGraphicalElement({
          el: 'path',
          container: {
            label: 'group',
            id: 'meso-plot'
          },
          attr: Object.assign({
            path: config.bottomPredictivePath,
            'clip-path': config.bottomPredictiveClipPath
          }, predictiveStyleAttributesLine),
          label: 'path',
          component: dataset
        }, true);
      }
    }

    if (config.mode === 'show') {
      // Only draw the anchors whose showAnchor property are enabled
      // by default only the anchor on which mouse is hovered will be shown
      if (config.sharedAnchorIndices && config.sharedAnchorIndices.length) {
        config.sharedAnchorIndices.forEach(function (index) {
          data = dataInfo[index];
          config.lastShownIndices = config.sharedAnchorIndices;
          data && !isNaN(data.value) && dataset.addGraphicalElement({
            el: 'path',
            container: {
              label: 'group',
              id: 'thermo-anchor'
            },
            attr: Object.assign({
              path: (0, _lib.polyPathToPath)([2, data.x, data.y, config.radius, 0, 0]),
              visibility: 'show'
            }, config.isDsHovered ? config.anchorHoverInStyle : config.isOtherDsHovered ? config.anchorStyle : config.anchorHighlightObj),
            id: 'shared-anchor-' + index,
            label: config.dsType + '-anchor'
          });
          data && !isNaN(data.value) && dataset.addGraphicalElement({
            el: 'path',
            container: {
              label: 'group',
              id: 'thermo-anchor'
            },
            attr: Object.assign({
              path: (0, _lib.polyPathToPath)([2, data.x, data.base, config.radius, 0, 0]),
              visibility: 'show'
            }, config.isDsHovered ? config.anchorHoverInStyle : config.isOtherDsHovered ? config.anchorStyle : config.anchorHighlightObj),
            id: 'shared-anchor-' + index,
            label: config.dsType + '-anchor'
          });
        });
      }
    } else {
      // Hiding an anchor
      if (config.hideIndices && config.hideIndices.length) {
        config.hideIndices.forEach(function (index) {
          data = dataInfo[index];
          data && !isNaN(data.value) && dataset.addGraphicalElement({
            el: 'path',
            container: {
              label: 'group',
              id: 'meso-anchor'
            },
            attr: {
              visibility: 'hidden'
            },
            id: 'shared-anchor-' + index,
            label: config.dsType + '-anchor'
          });
        });
      }
    }
  }
  /**
   * Function that return the nearest plot details
   * @param   {number} chartX x-axis position of the mouse cordinate
   * @param   {number} chartY y-axis position of the mouse cordinate
   * @return {Object} return an object with details of nearest plot and whether
   * it is hovered or not
   */
  ;

  _proto._getHoveredPlot = function _getHoveredPlot(chartXArg, chartYArg) {
    var dataset = this,
        chartX = chartXArg,
        chartY = chartYArg,
        xScale = dataset.getFromEnv('xScale'),
        xScaleRange = xScale.getRange(),
        dataMarkers = [dataset.getChildren('dataMarker')],
        config = dataset.config,
        visible = config.visibility === VISIBLE,
        dataInfo = config.dataInfo,
        len = dataInfo.length,
        canvas = dataset.getLinkedParent(),
        translationObj = canvas.getTranslation(),
        translationX = translationObj.x,
        translationY = translationObj.y,
        pointObj,
        xMin,
        xMax,
        returnValue,
        j,
        pX; // Readjusting the chart as the canvas group is translated

    chartX -= translationX;
    chartY -= translationY; // if chartX is outside the range of scale, no plots will be hovered
    // as because tootlip expects a proper object or undefined component property is sent
    // if undefined it sent then it will freeze tooltip in its last position.

    if (chartX < xScaleRange[0] || chartX > xScaleRange[1]) {
      return {
        component: dataset
      };
    }

    pX = xScale.getBinIndex(xScale.getDomainValue(chartX)); // Finding the lower limit on the xscale of the search domain

    xMin = Math.floor(Math.max(pX, 0)); // Finding the upper limit on the xscale of the search domain

    xMax = Math.ceil(Math.min(pX, len - 1)); // Iteraring over the datamarkers to check if they are hovered

    dataMarkers.forEach(function (dataMarkerArg) {
      var dataMarker = dataMarkerArg;

      if (!returnValue && dataMarker && (dataMarker = dataMarker[0])) {
        returnValue = dataMarker._checkPointOverMarker(pX, chartX, chartY, config.availableWidth);
      }
    }); // If a datamarker is not hovered

    if (!returnValue) {
      for (j = xMax; j >= xMin; j--) {
        pointObj = dataInfo[j];
        returnValue = visible ? (0, _rangedPlotUtils.isWithinShape)(pointObj, j, chartX, chartY, dataset, maxRadius) : {};

        if (returnValue.hovered) {
          break;
        }
      }
    } // To avoid dirty checking at multiple instances later in the code


    !returnValue && (returnValue = {}); // if not hovered on any plot then get the nearest plot info.

    if (!returnValue.hovered) {
      // Storing info for crossline, x is calculated without considering the
      // radius
      returnValue.binIndexHovered = xScale.getBinIndex(xScale.getDomainValue(chartX));
      returnValue.pointObj = config.dataInfo[returnValue.binIndexHovered] || xScale.getBinBounds(pX);
      returnValue.component = dataset;
    } else {
      returnValue.binIndexHovered = returnValue.pointIndex;
    }

    config.binIndexHovered = returnValue.binIndexHovered;
    return returnValue;
  };

  _proto._calculateLimits = function _calculateLimits() {
    return (0, _rangedPlotUtils.calculateLimits)(this);
  };

  _proto._getTooltext = function _getTooltext(pointFound, datasetHovered, dataIndex) {
    return (0, _rangedPlotUtils.getTooltext)(this, pointFound, datasetHovered, dataIndex);
  };

  return AreaRange;
}(_line2.default);

var _default = AreaRange;
exports["default"] = _default;

/***/ }),

/***/ 930:
/***/ ((__unused_webpack_module, exports) => {



exports.__esModule = true;
exports["default"] = void 0;

/**
 * Returns a vertical path's starting x,y coordinates, and vertical lineto values
 * @param {string} path The path to parse
 */
function getVerticalPathValues(path) {
  var regExp = /M(.*)V(.*)/g,
      parsed = regExp.exec(path),
      MXY = parsed[1],
      VY = parsed[2],
      MX = parseFloat(MXY.split(',')[0]),
      MY = parseFloat(MXY.split(',')[1]);
  VY = parseFloat(VY);
  return {
    MX: MX,
    MY: MY,
    VY: VY
  };
}
/**
 * Returns a horizontal path's starting x,y coordinates, and horizontal lineto values
 * @param {string} path The path to parse
 */


function getHorizontalPathValues(path) {
  var regExp = /M(.*)H(.*)/g,
      parsed = regExp.exec(path),
      MXY = parsed[1],
      HX = parsed[2],
      MX = parseFloat(MXY.split(',')[0]),
      MY = parseFloat(MXY.split(',')[1]);
  HX = parseFloat(HX);
  return {
    MX: MX,
    MY: MY,
    HX: HX
  };
}

function getStartEndByIndex(index, total) {
  var start,
      timesegment = 0.00002,
      offset = timesegment * index;
  start = offset;
  return {
    start: start,
    end: 1
  };
}

var _default = {
  'initial.dataset.timeseriesCandlestick': function initialDatasetTimeseriesCandlestick() {
    var component = this,
        yScale = component.getFromEnv('yScale'),
        yBasePos = yScale.getRangeValue(0);

    var lastIndex = -1,
        lastValue = null,
        getStartEndByIndexCached = function getStartEndByIndexCached(index, total) {
      if (index === lastIndex) {
        return lastValue;
      }

      var val = getStartEndByIndex(index, total);
      lastIndex = index;
      lastValue = val;
      return val;
    };

    return {
      'rect.appearing': function rectAppearing(inputJSON) {
        var index = inputJSON.props.index,
            dataLength = inputJSON.props.dataLength;
        return [{
          initialAttr: {
            y: yBasePos
          },
          startEnd: function startEnd() {
            return getStartEndByIndexCached(index, dataLength);
          },
          effect: 'easeInOutQuart',
          slot: 'middle'
        }];
      },
      'line.appearing': function lineAppearing(inputJSON) {
        var path = inputJSON.attr.path,
            index = inputJSON.props.index,
            dataLength = inputJSON.props.dataLength,
            pathValues = getHorizontalPathValues(path);
        return [{
          initialAttr: {
            path: "M" + pathValues.MX + "," + yBasePos + "H" + pathValues.HX
          },
          finalAttr: {
            path: "M" + pathValues.MX + "," + pathValues.MY + "H" + pathValues.HX
          },
          startEnd: function startEnd() {
            return getStartEndByIndexCached(index, dataLength);
          },
          effect: 'easeInOutQuart',
          slot: 'middle'
        }];
      },
      'high.appearing': function highAppearing(inputJSON) {
        var path = inputJSON.attr.path,
            index = inputJSON.props.index,
            dataLength = inputJSON.props.dataLength,
            pathValues = getVerticalPathValues(path);
        return [{
          initialAttr: {
            path: "M" + pathValues.MX + "," + yBasePos + "V" + (pathValues.VY + (yBasePos - pathValues.MY))
          },
          finalAttr: {
            path: "M" + pathValues.MX + "," + pathValues.MY + "V" + pathValues.VY
          },
          startEnd: function startEnd() {
            return getStartEndByIndexCached(index, dataLength);
          },
          effect: 'easeInOutQuart',
          slot: 'middle'
        }];
      },
      'low.appearing': function lowAppearing(inputJSON) {
        var path = inputJSON.attr.path,
            index = inputJSON.props.index,
            dataLength = inputJSON.props.dataLength,
            pathValues = getVerticalPathValues(path);
        return [{
          initialAttr: {
            path: "M" + pathValues.MX + "," + yBasePos + "V" + (pathValues.VY + (yBasePos - pathValues.MY))
          },
          finalAttr: {
            path: "M" + pathValues.MX + "," + pathValues.MY + "V" + pathValues.VY
          },
          startEnd: function startEnd() {
            return getStartEndByIndexCached(index, dataLength);
          },
          effect: 'easeInOutQuart',
          slot: 'middle'
        }];
      }
    };
  }
};
exports["default"] = _default;

/***/ }),

/***/ 929:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _lib = __webpack_require__(274);

var _safeMax = _interopRequireDefault(__webpack_require__(540));

var _safeMin = _interopRequireDefault(__webpack_require__(539));

var _extent = _interopRequireDefault(__webpack_require__(538));

var _dependencyManager = __webpack_require__(282);

var _isValidNumber = _interopRequireDefault(__webpack_require__(856));

var _timeConverter = _interopRequireDefault(__webpack_require__(350));

var _column = _interopRequireDefault(__webpack_require__(920));

var _candlestick = _interopRequireDefault(__webpack_require__(930));

var STROKE_COLOR = '#464E56',
    BEAR = 'bear',
    BULL = 'bull',
    _reducerFn = function _reducerFn(s, t) {
  return Object.assign(s, t);
};

(0, _dependencyManager.addDep)({
  name: 'timeseriesCandlestickAnimation',
  type: 'animationRule',
  extension: _candlestick.default
});

var CandleStick = /*#__PURE__*/function (_Column) {
  (0, _inheritsLoose2.default)(CandleStick, _Column);

  function CandleStick() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _Column.call.apply(_Column, [this].concat(args)) || this;

    _this.getClassName = function (baseName) {
      if (baseName === void 0) {
        baseName = '';
      }

      var randomString = Math.random().toString(36).substring(2);
      return baseName + "-" + randomString;
    };

    return _this;
  }

  var _proto = CandleStick.prototype;

  /**
   * returns the style which is to be applied on the hovered plot
   *
   * @param {Object} hoverIndices index of hovered plots
   * @returns {Object} configuration
   * @memberof Column
   */
  _proto.getHoverInConfig = function getHoverInConfig(hoverIndices) {
    var dsConfig = this.config;
    return {
      bullStyle: dsConfig.bullHoverInStyle,
      bearStyle: dsConfig.bearHoverInStyle,
      hoverIndices: hoverIndices,
      hovered: true
    };
  };

  /**
   * returns the style which is to be applied on the highlighted plot
   *
   * @param {Object} hoverIndices index of highlighted plots
   * @returns {Object} configuration
   * @memberof Column
   */
  _proto.getHighlightConfig = function getHighlightConfig(hoverIndices) {
    var dsConfig = this.config;
    return {
      bullStyle: dsConfig.bullHighlightStyle,
      bearStyle: dsConfig.bearHighlightStyle,
      hoverIndices: hoverIndices,
      hovered: true
    };
  }
  /**
   * returns the style which is to be applied on the hovered out plot
   *
   * @param {Object} hoverIndices index of hovered out plots
   * @returns {Object} configuration
   * @memberof Column
   */
  ;

  _proto.getHoverOutConfig = function getHoverOutConfig(hoverIndices) {
    var dsConfig = this.config,
        bullStyle = Object.assign({}, dsConfig.bullHoverOutStyle),
        bearStyle = Object.assign({}, dsConfig.bearHoverOutStyle),
        key;

    for (key in bullStyle) {
      bullStyle[key] = null;
    }

    for (key in bearStyle) {
      bearStyle[key] = null;
    }

    return {
      bullStyle: bullStyle,
      bearStyle: bearStyle,
      hoverIndices: hoverIndices,
      hovered: false
    };
  };

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    var dataset = this,
        config = dataset.config;
    config.isStock = true;
    config.bullStyle = {};
    config.bullHoverInStyle = {};
    config.bullHighlightStyle = {};
    config.bullHoverOutStyle = {};
    config.bearStyle = {};
    config.bearHoverInStyle = {};
    config.bearHighlightStyle = {};
    config.bearHoverOutStyle = {};
    config.plotSpacePercent = 40;
    config.dataMarkerPadding = 0;
    config.visibility = _lib.VISIBLE;
    config.prevBoundaryInfo = {};
    config.defaultBullStyle = {
      'stroke-width': 1,
      'opacity': 1,
      'stroke': '000000',
      'fill': 'ffffff'
    };
    config.defaultBearStyle = {
      'stroke-width': 1,
      'opacity': 1,
      'stroke': '000000',
      'fill': '868AC8'
    };
    config.defaultBullHighlightStyle = {
      'stroke-width': 2
    };
    config.defaultBearHighlightStyle = {
      'stroke-width': 2
    };
    config.defaultBearHoverInStyle = {
      'stroke-width': 2
    };
    config.defaultBullHoverInStyle = {
      'stroke-width': 2
    };
    config.legendDefaultTextStyle = {
      'font-family': _lib.DEFAULT_FT_FONT,
      'font-weight': 'normal',
      'font-style': 'normal',
      'font-size': '12px',
      'fill': '#5F5F5F'
    };
    config.defaultBearPredictiveStyle = {
      fill: '#62B58F'
    };
    config.defaultBullPredictiveStyle = {
      fill: '#F76363'
    }; // used to decide the fill and stroke of legend item

    config.strokeColor = STROKE_COLOR;
    config.hoverInfo = [];
    config.prevPerBinYExtents = [];
    config.dataIndices = [1, 2, 3, 4];
  }
  /**
   * Function to configure the cosmemtics of the plots
   */
  ;

  _proto.configureAttributes = function configureAttributes(dataObj) {
    var dataset = this,
        prop,
        dataSource = dataset.getFromEnv('dataSource'),
        getStyleDef = dataset.getFromEnv('getStyleDef'),
        legendConf = dataSource.legend,
        legendStyle = getStyleDef(legendConf && legendConf.item && legendConf.item.style && legendConf.item.style.text),
        config = dataset.config;
    config.mergedLegendStyle = (0, _lib.extend2)((0, _lib.extend2)({}, config.legendDefaultTextStyle), legendStyle); // Setting the given configurations

    if (dataObj.hasOwnProperty('hoverIndices')) {
      config.hoverInfo.push(dataObj);
      config.hoverMode = true;
    } else {
      for (prop in dataObj) {
        if (prop === 'primaryColor') {
          var plotConfig = dataObj.plotCosmetics,
              genericConfig = dataObj.genericCosmetics,
              bullStyle = config.bullStyle,
              bearStyle = config.bearStyle,
              bullHoverInStyle = config.bullHoverInStyle,
              bearHoverInStyle = config.bearHoverInStyle,
              bullHighlightStyle = config.bullHighlightStyle,
              bearHighlightStyle = config.bearHighlightStyle,
              bullHoverOutStyle = config.bullHoverOutStyle,
              bearHoverOutStyle = config.bearHoverOutStyle,
              styles = void 0,
              applicableClassBearStyle = getStyleDef(plotConfig.style && plotConfig.style.bear),
              applicableClassBullStyle = getStyleDef(plotConfig.style && plotConfig.style.bull),
              applicableClassStyleGeneric = getStyleDef(genericConfig.style && genericConfig.style.plot),
              applicableClassStyleGenericHover = getStyleDef(genericConfig.style && genericConfig.style['plot:hover']),
              applicableClassStyleGenericHighlight = getStyleDef(genericConfig.style && genericConfig.style['plot:highlight']),
              applicableClassBullStyleGeneric = getStyleDef(genericConfig.style && genericConfig.style.bull),
              applicableClassBullStyleGenericHover = getStyleDef(genericConfig.style && genericConfig.style['bull:hover']),
              applicableClassBullStyleGenericHighlight = getStyleDef(genericConfig.style && genericConfig.style['bull:highlight']),
              applicableClassBearStyleGeneric = getStyleDef(genericConfig.style && genericConfig.style.bear),
              applicableClassBearStyleGenericHover = getStyleDef(genericConfig.style && genericConfig.style['bear:hover']),
              applicableClassBearStyleGenericHighlight = getStyleDef(genericConfig.style && genericConfig.style['bear:highlight']),
              applicableClassBearHoverStyle = getStyleDef(plotConfig.style && plotConfig.style['bear:hover']),
              applicableClassBearHighlightStyle = getStyleDef(plotConfig.style && plotConfig.style['bear:highlight']),
              applicableClassBullHoverStyle = getStyleDef(plotConfig.style && plotConfig.style['bull:hover']),
              applicableClassBullHighlightStyle = getStyleDef(plotConfig.style && plotConfig.style['bull:highlight']),
              applicableInlineBearStyle = getStyleDef(dataObj.styleConfig && dataObj.styleConfig.bear),
              applicableInlineBullStyle = getStyleDef(dataObj.styleConfig && dataObj.styleConfig.bull),
              applicableInlineBearHoverStyle = getStyleDef(dataObj.styleConfig && dataObj.styleConfig['bear:hover']),
              applicableInlineBearHighlightStyle = getStyleDef(dataObj.styleConfig && dataObj.styleConfig['bear:highlight']),
              applicableInlineBullHoverStyle = getStyleDef(dataObj.styleConfig && dataObj.styleConfig['bull:hover']),
              applicableInlineBullHighlightStyle = getStyleDef(dataObj.styleConfig && dataObj.styleConfig['bull:highlight']),
              applicableClassStylePlot = getStyleDef(plotConfig.style && plotConfig.style.plot),
              applicableInlineStylePlot = getStyleDef(dataObj.styleConfig && dataObj.styleConfig.plot),
              applicableClassStyleHoverPlot = getStyleDef(plotConfig.style && plotConfig.style['generic:hover']),
              applicableClassStyleHighlightPlot = getStyleDef(plotConfig.style && plotConfig.style['generic:highlight']),
              applicableInlineStyleHoverPlot = getStyleDef(dataObj.styleConfig && dataObj.styleConfig['plot:hover']),
              applicableInlineStyleHighlightPlot = getStyleDef(dataObj.styleConfig && dataObj.styleConfig['plot:highlight']); // Stroke and fill is applicable when applied from bull and bear configurations and not the general ones

          delete applicableClassStyleGeneric.fill;
          delete applicableClassStylePlot.fill;
          delete applicableInlineStylePlot.fill;

          if (dataset.getName() === 'timeseries-ohlc') {
            delete applicableInlineStylePlot.stroke;
            delete applicableClassStyleGeneric.stroke;
            delete applicableClassStylePlot.stroke;
          } // Parsing the plot styling properties with increasing preference


          [bullStyle, config.defaultBullStyle, applicableClassStyleGeneric, applicableClassStylePlot, applicableInlineStylePlot, applicableClassBullStyleGeneric, applicableClassBullStyle, applicableInlineBullStyle].reduce(_reducerFn);
          [bearStyle, config.defaultBearStyle, applicableClassStyleGeneric, applicableClassStylePlot, applicableInlineStylePlot, applicableClassBearStyleGeneric, applicableClassBearStyle, applicableInlineBearStyle].reduce(_reducerFn);
          [bullHoverInStyle, config.defaultBullHoverInStyle, applicableClassStyleGenericHover, applicableClassStyleHoverPlot, applicableInlineStyleHoverPlot, applicableClassBullStyleGenericHover, applicableClassBullHoverStyle, applicableInlineBullHoverStyle].reduce(_reducerFn);
          [bullHighlightStyle, config.defaultBullHighlightStyle, applicableClassStyleGenericHighlight, applicableClassStyleHighlightPlot, applicableInlineStyleHighlightPlot, applicableClassBullStyleGenericHighlight, applicableClassBullHighlightStyle, applicableInlineBullHighlightStyle].reduce(_reducerFn);
          [bearHoverInStyle, config.defaultBearHoverInStyle, applicableClassStyleGenericHover, applicableClassStyleHoverPlot, applicableInlineStyleHoverPlot, applicableClassBearStyleGenericHover, applicableClassBearHoverStyle, applicableInlineBearHoverStyle].reduce(_reducerFn);
          [bearHighlightStyle, config.defaultBearHighlightStyle, applicableClassStyleGenericHighlight, applicableClassStyleHighlightPlot, applicableInlineStyleHighlightPlot, applicableClassBearStyleGenericHighlight, applicableClassBearHighlightStyle, applicableInlineBearHighlightStyle].reduce(_reducerFn); // Parsing the plot colors for bull

          bullStyle.stroke = (0, _lib.convertColor)(bullStyle.stroke, (0, _lib.pluckNumber)(bullStyle['stroke-opacity'], 1) * 100);
          bullStyle.fill = (0, _lib.convertColor)(bullStyle.fill, (0, _lib.pluckNumber)(bullStyle['fill-opacity'], 1) * 100);
          bearStyle.stroke = (0, _lib.convertColor)(bearStyle.stroke, (0, _lib.pluckNumber)(bearStyle['fill-opacity'], 1) * 100);
          bearStyle.fill = (0, _lib.convertColor)(bearStyle.fill, (0, _lib.pluckNumber)(bearStyle['fill-opacity'], 1) * 100); // Formatting the hover in style style

          bullHoverInStyle.fill && (bullHoverInStyle.fill = (0, _lib.convertColor)(bullHoverInStyle.fill, (0, _lib.pluckNumber)(bullHoverInStyle['fill-opacity'], bullStyle['fill-opacity']) * 100));
          bullHoverInStyle.stroke && (bullHoverInStyle.stroke = (0, _lib.convertColor)(bullHoverInStyle.stroke, (0, _lib.pluckNumber)(bullHoverInStyle['stroke-opacity'], bullStyle['stroke-opacity']) * 100));
          bearHoverInStyle.fill && (bearHoverInStyle.fill = (0, _lib.convertColor)(bearHoverInStyle.fill, (0, _lib.pluckNumber)(bearHoverInStyle['fill-opacity'], bearStyle['fill-opacity']) * 100));
          bearHoverInStyle.stroke && (bearHoverInStyle.stroke = (0, _lib.convertColor)(bearHoverInStyle.stroke, (0, _lib.pluckNumber)(bearHoverInStyle['stroke-opacity'], bearStyle['stroke-opacity']) * 100)); // Formatting the highlight style

          bullHighlightStyle.fill && (bullHighlightStyle.fill = (0, _lib.convertColor)(bullHighlightStyle.fill, (0, _lib.pluckNumber)(bullHighlightStyle['fill-opacity'], bullStyle['fill-opacity']) * 100));
          bullHighlightStyle.stroke && (bullHighlightStyle.stroke = (0, _lib.convertColor)(bullHighlightStyle.stroke, (0, _lib.pluckNumber)(bullHighlightStyle['stroke-opacity'], bullStyle['stroke-opacity']) * 100));
          bearHoverInStyle.fill && (bearHoverInStyle.fill = (0, _lib.convertColor)(bearHoverInStyle.fill, (0, _lib.pluckNumber)(bearHoverInStyle['fill-opacity'], bearStyle['fill-opacity']) * 100));
          bearHoverInStyle.stroke && (bearHoverInStyle.stroke = (0, _lib.convertColor)(bearHoverInStyle.stroke, (0, _lib.pluckNumber)(bearHoverInStyle['stroke-opacity'], bearStyle['stroke-opacity']) * 100));
          config.plotBorderThickness = bearStyle['stroke-width'] = bullStyle['stroke-width'] = (0, _lib.pluckNumber)((0, _safeMin.default)([bearStyle['stroke-width'], bullStyle['stroke-width']], Number.parseFloat)); // Parsing the hoverOut styles from hover style and highlight style

          for (styles in Object.assign(Object.assign({}, bullHoverInStyle), bullHighlightStyle)) {
            bullHoverOutStyle[styles] = (0, _lib.pluck)(bullStyle[styles], '');
          } // Stroke dash-array behave differently when applied on element and group, hence removing it


          (0, _lib.defined)(bullHoverOutStyle['stroke-dasharray']) && (bullHoverOutStyle['stroke-dasharray'] = '');

          for (styles in Object.assign(Object.assign({}, bearHoverInStyle), bearHighlightStyle)) {
            bearHoverOutStyle[styles] = bearStyle[styles] || '';
          }

          (0, _lib.defined)(bearHoverOutStyle['stroke-dasharray']) && (bullHoverOutStyle['stroke-dasharray'] = ''); // Opacities are separately stored and is applied to each element as applying them on the group followed by the elememt (during hover in and out)
          // results into multiplied opacity

          config.bullOpacity = bullStyle.opacity;
          config['bull-fill-opacity'] = bullStyle['fill-opacity'];
          config['bull-stroke-opacity'] = bullStyle['stroke-opacity'];
          config.bearOpacity = bearStyle.opacity;
          config['bear-fill-opacity'] = bearStyle['fill-opacity'];
          config['bear-stroke-opacity'] = bearStyle['stroke-opacity'];
          delete bullStyle.opacity;
          delete bullStyle['fill-opacity'];
          delete bullStyle['stroke-opacity'];
          delete bearStyle.opacity;
          delete bearStyle['fill-opacity'];
          delete bearStyle['stroke-opacity'];
        } else {
          config[prop] = dataObj[prop];
        }
      }

      config.limit = dataset._calculateLimits();
      var chart = dataset.getFromEnv('chart');
      chart.setYScaleLimit(config.scaleY.getId(), dataset.getId(), config.limit.y, config.limit.baseRequired);
      chart.setXScaleLimit(config.scaleX.getId(), dataset.getId(), config.limit.x);
    }

    this.parsePrediction(dataObj);
  };

  _proto.parsePrediction = function parsePrediction(dataObject) {
    this.config.prediction = dataObject.prediction || this.config.prediction;
    this.parsePredictiveStyleAttributes();
  };

  _proto.parsePredictiveStyleAttributes = function parsePredictiveStyleAttributes() {
    var predictiveStyleAttributes = {},
        config = this.config;
    config.predictiveStyleAttributesBear = {};
    config.predictiveStyleAttributesBull = {};

    if (config.prediction.enabled) {
      // Now overriding properties with properties provided for candle stick
      Object.assign(predictiveStyleAttributes, config.prediction.style.plot);
      Object.assign(config.predictiveStyleAttributesBear, config.defaultBearPredictiveStyle, config.prediction.style.plot, config.prediction.style.bear);
      Object.assign(config.predictiveStyleAttributesBull, config.defaultBullPredictiveStyle, config.prediction.style.plot, config.prediction.style.bull);
    }

    config.predictiveStyleAttributes = predictiveStyleAttributes || {};
  };

  _proto._calculateLimits = function _calculateLimits() {
    var _this$config = this.config,
        indices = _this$config.indices,
        data = _this$config.data,
        scaleY = _this$config.scaleY,
        scaleX = _this$config.scaleX,
        calculateFromContext = _this$config.calculateFromContext,
        firstData = data[0],
        lastData = data[data.length - 1],
        showPlotOverTick = scaleX.showPlotOverTick(),
        isVisible = this.config.visibility === 'visible',
        isLog = scaleY.getType() === 'log',
        chart = this.getFromEnv('chart'),
        _ref = calculateFromContext ? chart.getContextLimit() : chart.getFocusLimit(),
        focusLimitStart = _ref[0],
        focusLimitEnd = _ref[1],
        returnObj = {},
        padding,
        sanitiseFn = function sanitiseFn(num) {
      if (isLog && num <= 0) {
        return null;
      }

      return num;
    },
        minFn = function minFn(datum) {
      // check if data is withing visible range or not
      if (!(datum[0].end < focusLimitStart) && !(datum[0].start > focusLimitEnd)) {
        return (0, _safeMin.default)([datum[indices[1]], datum[indices[2]], datum[indices[3]], datum[indices[4]]], sanitiseFn);
      }
    },
        maxFn = function maxFn(datum) {
      // check if data is withing visible range or not
      if (!(datum[0].end < focusLimitStart) && !(datum[0].start > focusLimitEnd)) {
        return (0, _safeMax.default)([datum[indices[1]], datum[indices[2]], datum[indices[3]], datum[indices[4]]], sanitiseFn);
      }
    };

    padding = this.getPadding();
    returnObj.x = [firstData && firstData[indices[0]].start - padding, lastData && lastData[indices[0]][showPlotOverTick ? 'start' : 'end'] + padding];
    returnObj.y = isVisible ? [(0, _safeMin.default)(data, minFn), (0, _safeMax.default)(data, maxFn)] : _lib.UNDEF;
    returnObj.baseRequired = false;
    return returnObj;
  }
  /**
   * Helper function of data markers
   * @return {Object} contains positioning info and the dataInfo
   */
  ;

  _proto._getRelevantInfo = function _getRelevantInfo(index) {
    var config = this.config,
        fill,
        text,
        stroke;

    if (index !== _lib.UNDEF) {
      var _ref2 = config.dataInfo[index].groupId === 'bull' ? config.bullStyle : config.bearStyle;

      fill = _ref2.fill;
      stroke = _ref2.stroke;

      if ((0, _lib.rgbaToHex)(fill) === '#ffffff') {
        text = {
          fill: stroke
        };
      }
    }

    return {
      firstTimeStamp: config.firstTimeStamp,
      timeStampGap: config.timeStampGap,
      dataInfo: config.dataInfo,
      fill: fill,
      stroke: stroke,
      text: text
    };
  }
  /**
   * Function to create the containers of the dataset with all the cosmetics applioed at group level
   * Two groups are created, one for the bull and the other for the bear
   */
  ;

  _proto._createContainer = function _createContainer() {
    _Column.prototype._createContainer.call(this);

    var dataset = this,
        config = dataset.config,
        bullStyle = config.bullStyle,
        bearStyle = config.bearStyle;
    dataset.addGraphicalElement({
      el: 'group',
      container: {
        id: 'meso',
        label: 'group',
        isParent: true
      },
      component: dataset,
      label: 'group',
      id: 'meso',
      attr: {
        name: 'candlestick-dataset-meso'
      }
    }); // Bull group

    dataset.addGraphicalElement({
      el: 'group',
      container: {
        id: 'meso',
        label: 'group'
      },
      component: dataset,
      label: 'group',
      id: 'meso-bull',
      attr: Object.assign({
        name: 'bullGroup-meso',
        visibility: config.visibility
      }, bullStyle)
    }); // Bear group

    dataset.addGraphicalElement({
      el: 'group',
      container: {
        id: 'meso',
        label: 'group'
      },
      component: dataset,
      label: 'group',
      id: 'meso-bear',
      attr: Object.assign({
        name: 'bearGroup-meso',
        visibility: config.visibility
      }, bearStyle)
    }); // Predictive Bull group

    dataset.addGraphicalElement({
      el: 'group',
      container: {
        id: 'meso',
        label: 'group'
      },
      component: dataset,
      label: 'group',
      id: 'meso-bull-predictive',
      attr: Object.assign({
        name: 'predictive-bullGroup-meso',
        visibility: config.visibility
      }, bullStyle, config.predictiveStyleAttributesBull)
    }); // Predictive Bear group

    dataset.addGraphicalElement({
      el: 'group',
      container: {
        id: 'meso',
        label: 'group'
      },
      component: dataset,
      label: 'group',
      id: 'meso-bear-predictive',
      attr: Object.assign({
        name: 'predictive-bearGroup-meso',
        visibility: config.visibility
      }, bearStyle, config.predictiveStyleAttributesBear)
    });
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */
  ;

  _proto.getName = function getName() {
    return 'timeseriesCandlestick';
  }
  /**
   * returns the data plot indices which falls within the range
   * @param {Object} range min and max value range
   * @returns {Array} array of data points
   */
  ;

  _proto.getHighlightedIndices = function getHighlightedIndices(range) {
    var dataset = this,
        config = dataset.config,
        dataInfo = config.dataInfo,
        hightlightedPoints = [];
    dataInfo.forEach(function (data, index) {
      if (data.closeValuePx <= range.minValue && data.closeValuePx >= range.maxValue) {
        hightlightedPoints.push(index);
      }
    });
    return hightlightedPoints;
  }
  /**
   * Function to allocation the position of the dataplots
   */
  ;

  _proto.allocatePosition = function allocatePosition() {
    var dataset = this,
        binDecider = dataset.getFromEnv('binDecider'),
        xScale = dataset.getFromEnv('xScale'),
        yScale = dataset.getFromEnv('yScale'),
        config = dataset.config,
        measures = config.measures[0],
        _config$indices = config.indices,
        xIdx = _config$indices[0],
        openIdx = _config$indices[1],
        highIdx = _config$indices[2],
        lowIdx = _config$indices[3],
        closeIdx = _config$indices[4],
        dateColumn = dataset.getFromEnv('dateColumn'),
        isUTC = dataset.getFromEnv('UTC'),
        height,
        width,
        date,
        x,
        y,
        midX,
        yPos,
        yBase,
        groupId,
        open,
        close,
        high,
        low,
        dataObj,
        pX,
        lowStickYEntend,
        highStickYExtend,
        dataInfo = config.dataInfo,
        availableWidth,
        hoverInfo,
        openPx,
        closePx,
        duration,
        format = dateColumn.format,
        formatter = isUTC ? _timeConverter.default.utcFormatter(format) : _timeConverter.default.formatter(format),
        startDate,
        endDate,
        i,
        len,
        bins = xScale.bins,
        rangeThreshold = binDecider.getRangeThreshold()[2],
        _xScale$getDomain = xScale.getDomain(),
        startDomain = _xScale$getDomain[0],
        endDomain = _xScale$getDomain[1],
        paddingInTimestamp,
        data = config.data,
        openValueFormatted,
        highValueFormatted,
        lowValueFormatted,
        closeValueFormatted;

    if (config.repositioningDone = dataset._isRepositioningNeeded()) {
      config.timeStampGap = rangeThreshold;
      config.availableWidth = availableWidth = 0; // Storing info for dataMarker detection

      for (i = 0, len = bins.length; i < len; i++) {
        if (bins[i].clipType !== 2) {
          config.availableWidth = availableWidth = xScale.getRangeValue(bins[i].end) - xScale.getRangeValue(bins[i].start);
          break;
        }
      }

      width = Math.max(availableWidth * (1 - config.plotSpacePercent / 100) - config.plotBorderThickness, 1);
      paddingInTimestamp = +xScale.getDomainValue(availableWidth * (config.plotSpacePercent / 200)) - +xScale.getDomainValue(0); // Storing value for tooltip

      config.actualStartDomain = +startDomain + paddingInTimestamp; // Actual end domain is the scale domain minus the space taken up by the plotspacepercent

      config.actualEndDomain = +endDomain - paddingInTimestamp; // Store data related operations

      dataInfo = config.dataInfo = [];
      data.forEach(function (datum, index) {
        // drawing the candle
        date = datum[xIdx];
        open = datum[openIdx];
        close = datum[closeIdx];
        high = datum[highIdx];
        low = datum[lowIdx];
        duration = date.config.duration;
        startDate = date.start;
        endDate = date.end;

        if (!index) {
          config.firstTimeStamp = date.start;
        }

        closePx = yScale.getRangeValue(close);
        openPx = yScale.getRangeValue(open);
        highStickYExtend = yScale.getRangeValue(high);
        lowStickYEntend = yScale.getRangeValue(low);

        if ((0, _isValidNumber.default)(openPx) || (0, _isValidNumber.default)(closePx) || (0, _isValidNumber.default)(highStickYExtend) || (0, _isValidNumber.default)(lowStickYEntend)) {
          // Find rectangle height and starting y, only if both open and close are present
          if ((0, _isValidNumber.default)(openPx) && (0, _isValidNumber.default)(closePx)) {
            if (open > close) {
              yBase = closePx;
              yPos = openPx;
              groupId = BEAR;
            } else {
              yPos = closePx;
              yBase = openPx;
              groupId = BULL;
            }

            height = Math.max(Math.abs(yBase - yPos), 1);
            y = yPos > yBase ? yBase : yPos;
          }

          midX = xScale.getRangeValue(new Date(date.start), new Date(date.end));
          x = midX - width / 2;
          dataObj = {
            startDate: startDate,
            endDate: endDate
          };
          dataObj.x = x;
          dataObj.endXPosition = x + width;
          dataObj.midX = midX;
          dataObj.colHeight = height || 0; // Either the calculated open or close as per bull or bear, when both open and close are present,
          // OR, open, if close absent, OR close, if open absent

          dataObj.colY = y || openPx || closePx;
          dataObj.highStickYExtend = highStickYExtend;
          dataObj.y = (0, _safeMin.default)([highStickYExtend, closePx, openPx, lowStickYEntend]);
          dataObj.closeValuePx = closePx;
          dataObj.width = width;
          dataObj.openValue = open;
          dataObj.closeValue = close;
          dataObj.highValue = high;
          dataObj.lowValue = low;
          dataObj.value = close;
          dataObj.lowStickYEntend = lowStickYEntend;
          openValueFormatted = config.formatterFn({
            value: open,
            type: 'tooltip',
            prefix: config.prefix,
            suffix: config.suffix
          });
          closeValueFormatted = config.formatterFn({
            value: close,
            type: 'tooltip',
            prefix: config.prefix,
            suffix: config.suffix
          });
          highValueFormatted = config.formatterFn({
            value: high,
            type: 'tooltip',
            prefix: config.prefix,
            suffix: config.suffix
          });
          lowValueFormatted = config.formatterFn({
            value: low,
            type: 'tooltip',
            prefix: config.prefix,
            suffix: config.suffix
          });
          dataObj.eventArgs = {
            index: index,
            start: startDate,
            startText: formatter.format(startDate),
            end: endDate,
            endText: formatter.format(endDate),
            binUnit: duration.Unit,
            binMultiplier: duration.number,
            plotType: config.type,
            timeFormatter: format,
            aggregation: config.aggregation,
            measure: measures.close,
            measureHigh: measures.high,
            measureLow: measures.low,
            measureOpen: measures.open,
            measuresClose: measures.close,
            binValue: close,
            binOpen: open,
            binHigh: high,
            binLow: low,
            binClose: close,
            binValueFomatted: closeValueFormatted,
            binOpenFormatted: openValueFormatted,
            binHighFormatted: highValueFormatted,
            binCloseFormatted: closeValueFormatted,
            binLowFormatted: lowValueFormatted
          }; // Either difference between low and high or 0 if either are missing

          var minmax = (0, _extent.default)([openPx, closePx, highStickYExtend, lowStickYEntend]);
          dataObj.height = Math.abs(minmax[0] - minmax[1]) || 0; // For missing open/close, always show plot as bull

          dataObj.groupId = groupId || 'bull';
          dataObj.groupConfig = groupId === 'bull' ? 'bullConfig' : 'bearConfig'; // Get the data index corresponding to the fetched timeStamp

          pX = xScale.getBinIndex(date.start);
          dataInfo[pX] = dataObj;
        }
      });
    } // If hovered, show hover effect of the particular plot


    if (hoverInfo = config.hoverInfo) {
      hoverInfo.forEach(function (hoveredData) {
        hoveredData.hoverIndices.forEach(function (index) {
          if (typeof dataInfo[index] === 'object') {
            dataInfo[index].style = (0, _lib.extend2)(dataInfo[index].style, hoveredData[dataInfo[index].groupId + 'Style']);
          }
        });
      });
    }
  }
  /**
   * Function to draw the candles and the sticks
   */
  ;

  _proto._drawPlot = function _drawPlot() {
    var dataset = this,
        config = dataset.config,
        attr,
        dataInfo = config.dataInfo,
        definedBullOpacity = (0, _lib.defined)(config.bullOpacity),
        definedBullFillOpacity = (0, _lib.defined)(config['bull-fill-opacity']),
        definedBullStrokeOpacity = (0, _lib.defined)(config['bull-stroke-opacity']),
        predictiveStyleAttributesBull = config.predictiveStyleAttributesBull,
        definedPredictiveBullOpacity = (0, _lib.defined)(predictiveStyleAttributesBull.opacity),
        definedPredictiveBullFillOpacity = (0, _lib.defined)(predictiveStyleAttributesBull['fill-opacity']),
        definedPredictiveBullStrokeOpacity = (0, _lib.defined)(predictiveStyleAttributesBull['stroke-opacity']),
        definedBearOpacity = (0, _lib.defined)(config.bearOpacity),
        definedBearFillOpacity = (0, _lib.defined)(config['bear-fill-opacity']),
        definedBearStrokeOpacity = (0, _lib.defined)(config['bear-stroke-opacity']),
        predictiveStyleAttributesBear = config.predictiveStyleAttributesBear,
        definedPredictiveBearOpacity = (0, _lib.defined)(predictiveStyleAttributesBear.opacity),
        definedPredictiveBearFillOpacity = (0, _lib.defined)(predictiveStyleAttributesBear['fill-opacity']),
        definedPredictiveBearStrokeOpacity = (0, _lib.defined)(predictiveStyleAttributesBear['stroke-opacity']),
        attrBaseBull = {},
        attrBaseBear = {},
        attrBase,
        derivedGroupId = _lib.BLANKSTRING,
        isDatumPredictive = false,
        mergePredictiveStylesInDatumGraphics = function mergePredictiveStylesInDatumGraphics(attrBear, attrBull) {
      definedPredictiveBearOpacity && (attrBear.opacity = predictiveStyleAttributesBear.opacity);
      definedPredictiveBearFillOpacity && (attrBear.opacity = predictiveStyleAttributesBear['fill-opacity']);
      definedPredictiveBearStrokeOpacity && (attrBear.opacity = predictiveStyleAttributesBear['stroke-opacity']);
      definedPredictiveBullOpacity && (attrBull.opacity = predictiveStyleAttributesBull.opacity);
      definedPredictiveBullFillOpacity && (attrBull.opacity = predictiveStyleAttributesBull['fill-opacity']);
      definedPredictiveBullStrokeOpacity && (attrBull.opacity = predictiveStyleAttributesBull['stroke-opacity']);
    };

    definedBullOpacity && (attrBaseBull.opacity = config.bullOpacity);
    definedBullFillOpacity && (attrBaseBull.opacity = config['bull-fill-opacity']);
    definedBullStrokeOpacity && (attrBaseBull.opacity = config['bull-stroke-opacity']);
    definedBearOpacity && (attrBaseBear.opacity = config.bearOpacity);
    definedBearFillOpacity && (attrBaseBear.opacity = config['bear-fill-opacity']);
    definedBearStrokeOpacity && (attrBaseBear.opacity = config['bear-stroke-opacity']);
    dataInfo.forEach(function (datum, index) {
      if (datum.groupConfig) {
        attrBase = datum.groupId === 'bull' ? attrBaseBull : attrBaseBear;
        isDatumPredictive = dataset.isPlotPredictive(datum);
        derivedGroupId = isDatumPredictive ? datum.groupId + '-predictive' : datum.groupId; // If open > close then column/rectangle will have a positive height

        if (datum.colHeight > 0) {
          // If height is a positive value, draw a rectangle
          // Drawing the open-close rect
          attr = Object.assign({
            x: datum.x,
            y: datum.colY,
            height: datum.colHeight,
            width: datum.width
          }, attrBase);
          datum.style && Object.assign(attr, datum.style);

          if (isDatumPredictive) {
            mergePredictiveStylesInDatumGraphics(attrBaseBear, attrBaseBull);
          }

          dataset.addGraphicalElement({
            el: 'rect',
            component: dataset,
            props: {
              index: index,
              dataLength: dataInfo.length
            },
            container: {
              label: 'group',
              id: 'meso-' + derivedGroupId
            },
            label: 'rect',
            attr: attr
          }, true); // If only either of open or close values are present, draw a horizontal path
        } else if (datum.openValue || datum.closeValue) {
          attr = Object.assign({
            path: "M" + datum.x + "," + datum.colY + ",H" + (datum.x + datum.width)
          }, attrBase);
          datum.style && Object.assign(attr, datum.style);

          if (isDatumPredictive) {
            mergePredictiveStylesInDatumGraphics(attrBaseBear, attrBaseBull);
          }

          dataset.addGraphicalElement({
            el: 'path',
            component: dataset,
            props: {
              index: index,
              dataLength: dataInfo.length
            },
            container: {
              label: 'group',
              id: 'meso-' + derivedGroupId
            },
            label: 'line',
            attr: attr
          }, true);
        }

        if (datum.highStickYExtend) {
          // drawing the high stick starting from -
          //  if open and/or close are present, high to start of column/horizontal path
          //  if open and close are absent, high with length difference between high and low
          attr = Object.assign({
            path: "M" + datum.midX + "," + datum.highStickYExtend + ",V" + (datum.colY || datum.highStickYExtend + datum.height),
            'stroke-linecap': 'round'
          }, attrBase);
          datum.style && Object.assign(attr, datum.style);
          dataset.addGraphicalElement({
            el: 'path',
            component: dataset,
            props: {
              index: index,
              dataLength: dataInfo.length
            },
            container: {
              label: 'group',
              id: 'meso-' + datum.groupId
            },
            label: 'high',
            attr: attr
          }, true);
        }

        if (datum.lowStickYEntend) {
          // drawing the low stick starting from -
          //  if open and/or close are present, low to end of column/horizontal path
          //  if open and close are absent, high with length difference between high and low
          attr = Object.assign({
            path: "M" + datum.midX + "," + datum.lowStickYEntend + ",V" + (datum.colY + datum.colHeight || datum.lowStickYEntend - datum.height),
            'stroke-linecap': 'round'
          }, attrBase);
          datum.style && Object.assign(attr, datum.style);
          dataset.addGraphicalElement({
            el: 'path',
            component: dataset,
            props: {
              index: index,
              dataLength: dataInfo.length
            },
            container: {
              label: 'group',
              id: 'meso-' + datum.groupId
            },
            label: 'low',
            attr: attr
          }, true);
        }
      }
    });
    config.hoverInfo = [];
  };

  /**
   * Function to form the tooltext
   * @param {Boolean} pointFound If any dataset's data is actually hovered
   * @param {Boolean} datasetHovered If the current dataset is hovered
   * @param {number} dataIndex The index of the data in the current dataset that is hovered
   */
  _proto._getTooltext = function _getTooltext(pointFound, datasetHovered, dataIndex) {
    var dataset = this,
        config = dataset.config,
        dataSource = dataset.getFromEnv('dataSource'),
        plots = dataset._linkedParent.getChildren('dataset'),
        tooltext = dataSource.tooltip ? dataSource.tooltip.tooltext : null,
        macroIndices,
        parserConfig,
        plotConfig,
        timeNavigator = dataset._linkedParent._linkedParent._components.timeNavigator[0],
        formatter = timeNavigator.config.formatter,
        binStart,
        binEnd,
        containsVolume,
        dataInfo = config.dataInfo,
        currData = dataInfo[dataIndex],
        isDataDefined,
        chartNonce = (config == null ? void 0 : config.nonce) || '',
        // Setting logic for opacity.
    // When the data of the currentdataset is hovered then all other tooltip's opacity is set to 0.5
    // Rest all the cases the opacity is 1
    opacity = pointFound ? datasetHovered ? 1 : 0.5 : 1,
        line1;

    if (dataset._isInvalidTooltext(currData)) {
      return '';
    }

    isDataDefined = (0, _lib.defined)(currData.groupConfig);

    if (tooltext) {
      containsVolume = dataSource.yaxis.find(function (item) {
        return item.plot.find(function (plotType) {
          return plotType.value === 'Volume';
        });
      }); // When volume is present, then no need to parse tooltext as it will be parsed in column plot for volume

      if (!containsVolume) {
        // Get the name for all the series
        parserConfig = {
          series: dataSource.yaxis.map(function (series) {
            return {
              name: series.title
            };
          })
        }; // Get individual plot configurations for tooltip macros

        plotConfig = {
          series: plots.map(function (index) {
            binStart = formatter.format(index.config.dataInfo[dataIndex].startDate);
            binEnd = formatter.format(index.config.dataInfo[dataIndex].endDate);
            return {
              bin: binStart + '-' + binEnd,
              binStart: binStart,
              binEnd: binEnd,
              openValue: index.config.dataInfo[dataIndex].eventArgs.binOpen,
              openDataValue: index.config.dataInfo[dataIndex].eventArgs.binOpenFormatted,
              highValue: index.config.dataInfo[dataIndex].eventArgs.binHigh,
              highDataValue: index.config.dataInfo[dataIndex].eventArgs.binHighFormatted,
              lowValue: index.config.dataInfo[dataIndex].eventArgs.binLow,
              lowDataValue: index.config.dataInfo[dataIndex].eventArgs.binLowFormatted,
              closeValue: index.config.dataInfo[dataIndex].eventArgs.binClose,
              closeDataValue: index.config.dataInfo[dataIndex].eventArgs.binCloseFormatted
            };
          })
        };
        macroIndices = [154, 155, 156, 157, 158, 159, 160, 161, 162, 163, 164, 165, 166, 167, 168, 169, 170, 171];
        tooltext = (0, _lib.parseTooltext)(tooltext, macroIndices, parserConfig, plotConfig);
        line1 = '<div>' + tooltext + '</div>';
      } else {
        line1 = "<div></div>";
      }
    } else {
      var tooltipMarginClass = this.getClassName('tooltip-margin');
      line1 = "\n      <style nonce=\"" + chartNonce + "\">\n        ." + tooltipMarginClass + " {\n          margin-bottom: 5px; \n          opacity: " + opacity + ";\n        }\n      </style>\n      <div class=\"" + tooltipMarginClass + "\">\n      <div>" + (0, _lib.parseUnsafeString)(config.series) + "</div>\n      </div>"; // Forming the open close high low tooltext

      if (isDataDefined) {
        var tooltipClass = this.getClassName('tooltip-class'),
            tooltipFloatRightClass = this.getClassName('tooltip-float-right-class'),
            tooltipFloatLeftClass = this.getClassName('tooltip-float-left-class');
        return (config.series ? line1 : '') + ['open', 'high', 'low', 'close'].reduce(function (accumulator, currentValue) {
          // Use `[open/high/low/close]TooltipValue` if present,
          // Else, current of OHLC has a value, then format it and update `[open/high/low/close]TooltipValue`
          var value = currData[currentValue + 'TooltipValue'] || (currData[currentValue + 'TooltipValue'] = currData[currentValue + 'Value'] && config.formatterFn({
            value: currData[currentValue + 'Value'],
            type: 'tooltip',
            prefix: config.prefix,
            suffix: config.suffix
          })); // Only add a line for O/H/L/C if it has a value calculated from above

          return accumulator + (value !== _lib.UNDEF ? "\n          <style nonce=\"" + chartNonce + "\">\n            ." + tooltipClass + " {\n              overflow: hidden; margin-top:4px;\n            }\n\n            ." + tooltipFloatLeftClass + " {\n              float: left;\n            }\n\n            ." + tooltipFloatRightClass + " {\n              float: right;\n            }\n          </style>\n          <div class=\"" + tooltipClass + "\">\n          <div class=\"" + tooltipFloatLeftClass + "\">" + currentValue + "</div>\n          <div class=\"" + tooltipFloatRightClass + "\">" + value + "</div>\n        </div>" : '');
        }, '');
      }
    }

    return line1;
  };

  return CandleStick;
}(_column.default);

var _default = CandleStick;
exports["default"] = _default;

/***/ }),

/***/ 938:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _dependencyManager = __webpack_require__(282);

var _column = _interopRequireDefault(__webpack_require__(920));

var _column2 = _interopRequireDefault(__webpack_require__(921));

var _timeConverter = _interopRequireDefault(__webpack_require__(350));

var _isValidNumber = _interopRequireDefault(__webpack_require__(856));

var _lib = __webpack_require__(274);

var _rangedPlotUtils = __webpack_require__(939);

(0, _dependencyManager.addDep)({
  name: 'timeseriesColumnAnimation',
  type: 'animationRule',
  extension: _column2.default
});
var VISIBLE = 'visible';

var ColumnRange = /*#__PURE__*/function (_Column) {
  (0, _inheritsLoose2.default)(ColumnRange, _Column);

  function ColumnRange() {
    return _Column.apply(this, arguments) || this;
  }

  var _proto = ColumnRange.prototype;

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    _Column.prototype.__setDefaultConfig.call(this);

    var config = this.config;
    config['default-plotSpacePercent'] = 30;
    config.visibility = VISIBLE;
    config.isRange = true;
    config.prevBoundaryInfo = {};
    config.dataMarkerPadding = 0;
    config.style = {};
    config.hoverInStyle = {};
    config.highlightStyle = {};
    config.hoverOutStyle = {};
    config.defaultStyle = {
      'stroke-width': 1,
      'fill-opacity': 1,
      'stroke-opacity': 1,
      'opacity': 1
    };
    config.defaultPredictedDataStyle = {
      'stroke-width': 1,
      'fill-opacity': 0.2,
      'stroke-opacity': 1,
      'stroke-dasharray': 5
    };
    config.defaultHoverInStyle = {
      'opacity': 0.8
    };
    config.defaultHighlightStyle = {
      'opacity': 0.8
    };
    config.dataInfo = [];
    config.prevPerBinYExtents = [];
    config.dataIndices = [1, 2];
  };

  _proto.allocatePosition = function allocatePosition() {
    var dataset = this,
        config = dataset.config,
        _config$indices = config.indices,
        xIdx = _config$indices[0],
        highIdx = _config$indices[1],
        lowIdx = _config$indices[2],
        binDecider = dataset.getFromEnv('binDecider'),
        xScale = dataset.getFromEnv('xScale'),
        yScale = dataset.getFromEnv('yScale'),
        dataInfo = config.dataInfo,
        seriesInfo = config.seriesInfo,
        dateColumn = dataset.getFromEnv('dateColumn'),
        isUTC = dataset.getFromEnv('UTC'),
        height,
        width,
        date,
        x,
        y,
        high,
        low,
        yBaseValue,
        yPos,
        yBase,
        hoverInfo,
        isNegative,
        pX,
        xShift,
        endXPosition,
        groupIndex = config.groupIndex || 0,
        groupWidth,
        totalGroups = config.totalGroups || 1,
        availableWidth,
        data = config.data,
        duration,
        eventArgs,
        seriesName,
        format = dateColumn.format,
        formatter = isUTC ? _timeConverter.default.utcFormatter(format) : _timeConverter.default.formatter(format),
        startDate,
        endDate,
        midGroup,
        gutter,
        i,
        len,
        bins = xScale.bins,
        plotBorderThickness = config.plotBorderThickness,
        considerPlotBorder = config.fillColor === config.strokeColor && plotBorderThickness > 0,
        paddingInTimestamp,
        rangeThreshold = binDecider.getRangeThreshold()[2],
        _xScale$getDomain = xScale.getDomain(),
        startDomain = _xScale$getDomain[0],
        endDomain = _xScale$getDomain[1],
        dataObj;

    config.firstTimeStamp = data && data[0] && data[0][xIdx] && data[0][xIdx].start;

    if (config.repositioningDone = dataset._isRepositioningNeeded()) {
      // skip drawing if dataset is not visible
      if (config.visibility !== 'visible') {
        return;
      } // Store data related operations


      dataInfo = config.dataInfo = []; // Getting the pixel width between two consecutive data

      config.availableWidth = availableWidth = 0; // Storing info for dataMarker detection

      for (i = 0, len = bins.length; i < len; i++) {
        if (bins[i].clipType !== 2) {
          config.availableWidth = availableWidth = xScale.getRangeValue(bins[i].end) - xScale.getRangeValue(bins[i].start);
          break;
        }
      }

      config.timeStampGap = rangeThreshold; // Avoid negative thickness when border thickness is more than the actual available width

      groupWidth = Math.max(availableWidth * (1 - config.plotSpacePercent / 100), 1); // Logic for multi-series

      width = groupWidth / totalGroups;
      midGroup = Math.round(totalGroups / 2);
      gutter = totalGroups % 2 === 0 ? 0 : 0.5;
      xShift = midGroup - groupIndex > 0 ? -width * (midGroup - groupIndex - gutter) : width * (groupIndex - midGroup + gutter);
      paddingInTimestamp = +xScale.getDomainValue(availableWidth * (config.plotSpacePercent / 200)) - +xScale.getDomainValue(0); // Storing value for tooltip

      config.actualStartDomain = +startDomain + paddingInTimestamp; // Actual end domain is the scale domain minus the space taken up by the plotspacepercent

      config.actualEndDomain = +endDomain - paddingInTimestamp; // Adjusting column width as per the column border

      considerPlotBorder && (width = Math.max(width - plotBorderThickness, 1));
      data.forEach(function (datum, index) {
        date = datum[xIdx];
        high = Math.max(datum[highIdx], datum[lowIdx]);
        low = Math.min(datum[lowIdx], datum[highIdx]);
        duration = date.config.duration;
        startDate = date.start;
        endDate = date.end; // Storing the 1st time stamp

        if (!index) {
          config.firstTimeStamp = date.start;
        }

        yBaseValue = low;
        yBase = yScale.getRangeValue(yBaseValue || Math.max(yScale.getDomain()[0], 0));
        yPos = yScale.getRangeValue(high);

        if ((0, _isValidNumber.default)(high) && (0, _isValidNumber.default)(low) && (0, _isValidNumber.default)(yBase) && (0, _isValidNumber.default)(yPos)) {
          // Find the position where the plot is to be placed
          x = xScale.getRangeValue(new Date(date.start), new Date(date.end)); // Adjusting column starting position as per the column border

          considerPlotBorder && (x += plotBorderThickness / 2);
          x += xShift;
          endXPosition = x + width; // Adding the base to manage the stacking

          height = Math.max(1, Math.abs(yBase - yPos));
          isNegative = yPos > yBase;
          y = isNegative ? yBase : yPos;
          dataObj = {
            startDate: startDate,
            endDate: endDate,
            high: high,
            low: low,
            highValue: high,
            lowValue: low,
            yBaseValue: yBaseValue,
            yBase: yBase,
            x: x,
            endXPosition: endXPosition,
            y: y,
            width: width,
            height: height,
            eventArgs: {
              index: index,
              high: high,
              low: low,
              highValue: high,
              lowValue: low
            }
          };
          eventArgs = {
            index: index,
            high: high,
            low: low,
            highValue: high,
            lowValue: low,
            start: startDate,
            startText: formatter.format(startDate),
            end: endDate,
            endText: formatter.format(endDate),
            binUnit: duration.Unit,
            binMultiplier: duration.number,
            plotType: config.type,
            timeFormatter: format,
            aggregation: config.aggregation,
            measure: config.measures[0] // binValue: value,
            // binValueFormatted:
            //   config.formatterFn &&
            //   config.formatterFn({
            //     value: value,
            //     type: 'tooltip',
            //     prefix: config.prefix,
            //     suffix: config.suffix
            //   })

          };
          seriesName =  false && 0;

          if (seriesName) {
            eventArgs.series = seriesName;
            eventArgs.seriesValue = seriesInfo[seriesName];
          }

          dataObj.eventArgs = eventArgs; // Get the data index corresponding to the fetched timeStamp

          pX = xScale.getBinIndex(date.start);
          dataInfo[pX] = dataObj;
        }
      });
    } // If hovered, show hover effect of the particular plot


    if (hoverInfo = config.hoverInfo) {
      hoverInfo.forEach(function (hoveredData) {
        hoveredData.hoverIndices.forEach(function (index) {
          if (typeof dataInfo[index] === 'object' && typeof hoveredData.style === 'object') {
            dataInfo[index].style = (0, _lib.extend2)(dataInfo[index].style, hoveredData.style);
          }
        });
      });
    }
  };

  _proto._calculateLimits = function _calculateLimits() {
    return (0, _rangedPlotUtils.calculateLimits)(this);
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */
  ;

  _proto.getName = function getName() {
    return 'column-range';
  };

  _proto._getTooltext = function _getTooltext(pointFound, datasetHovered, dataIndex) {
    return (0, _rangedPlotUtils.getTooltext)(this, pointFound, datasetHovered, dataIndex);
  };

  return ColumnRange;
}(_column.default);

var _default = ColumnRange;
exports["default"] = _default;

/***/ }),

/***/ 921:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



exports.__esModule = true;
exports["default"] = void 0;

var _lib = __webpack_require__(274);

var UNDEF;
var Y = 'y',
    HEIGHT = 'height';
/**
 * Get the initial state of the rect of the stacked column
 * @param {*} height Height of the element(rect) given by the user.
 * @param {*} y Y point given by the user.
 * @param {*} isNegative is the stacked column is in the negative axis?
 */

function getInitialAttr(height, y, isNegative) {
  return {
    y: !isNegative ? y + height : y,
    height: 0
  };
}
/**
 * Get the start timing and end timing divided across datasets.
 * @param {*} datasetIndex Index of the rect in the stacked column(dataset)
 * @param {*} totalDatasets Total number of datasets.
 */


function getStartEnd(datasetIndex, totalDatasets) {
  var timeblock = 1 / totalDatasets,
      offset = timeblock * datasetIndex;
  return {
    start: offset,
    end: offset + timeblock
  };
}
/**
 * Gets the animation for the stacked column
 * @param {*} component The dataset component for the rect.
 */


function getStackedAnimation(component) {
  var datasetIndex = component.config.datasetIndex,
      totalDatasets = component.config.seriesLength;
  return {
    'rect.appearing': function rectAppearing(inputJSON) {
      var index = inputJSON.index,
          dataInfo = component.config.dataInfo[index],
          isNegative = dataInfo.yBaseValue < 0;
      return [{
        initialAttr: getInitialAttr(inputJSON.attr.height, inputJSON.attr.y, isNegative),
        slot: 'middle',
        startEnd: getStartEnd(datasetIndex, totalDatasets),
        effect: 'linear'
      }];
    }
  };
}

;
var _default = {
  'initial.dataset.timeseriesColumn': function initialDatasetTimeseriesColumn() {
    var component = this,
        yAttrKey = Y,
        hAttrKey = HEIGHT,
        yScale = component.getFromEnv('yScale');
    var totalStackSum = component.config.indices[3] !== UNDEF;

    if (totalStackSum) {
      return getStackedAnimation(component, yScale);
    }

    return {
      'rect.appearing': function rectAppearing(inputJSON) {
        var index = inputJSON.props && inputJSON.props.originalIndex || inputJSON.index,
            dataObj = component.config.data[index],
            actualFinalAttr = inputJSON.attr,
            yAttrVal,
            hAttrVal,
            yBasePos,
            endPosWRT0,
            //  baseIndex = component.config.indices[2],
        zeroPos = yScale.getRangeValue(0); // yScale.getRangeValue((component.config.data.length > index) ? component.config.data[index][baseIndex] : component.config.data[index - 1][baseIndex]);
        // Store final y and h for later use

        yAttrVal = actualFinalAttr[yAttrKey];
        hAttrVal = actualFinalAttr[hAttrKey];
        endPosWRT0 = Math.sign(yAttrVal + hAttrVal / 2 - zeroPos); // If the plot is below zero plain, the base will be the y + h of the previous one
        // if it is stacked plot else y of the plot

        if (endPosWRT0 === 1) {
          yBasePos = yAttrVal;
        } else {
          // the base will be the y of the previous one if it is stacked plot else y+h of itself
          yBasePos = yAttrVal + hAttrVal;
        }

        dataObj && (dataObj._posWRT0 = endPosWRT0);
        return [{
          initialAttr: function initialAttr() {
            var initialAttr = {}; // Replace the y and h with initial positions

            initialAttr[yAttrKey] = yBasePos;
            initialAttr[hAttrKey] = 0;
            return initialAttr;
          },
          finalAttr: {},
          startEnd: function startEnd() {
            var startEnd = _lib.animHelperFN.animByWeight(inputJSON.index, inputJSON.props.dataLength, 0.6);

            return startEnd;
          },
          hookFn: function hookFn() {
            this.attr({
              opacity: 1
            });
          },
          effect: 'easeInOutQuart',
          slot: 'plot'
        }];
      },
      '*': null
    };
  }
};
exports["default"] = _default;

/***/ }),

/***/ 920:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _assertThisInitialized2 = _interopRequireDefault(__webpack_require__(292));

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _lib = __webpack_require__(274);

var _safeMin = _interopRequireDefault(__webpack_require__(539));

var _safeMax = _interopRequireDefault(__webpack_require__(540));

var _dependencyManager = __webpack_require__(282);

var _isValidNumber = _interopRequireDefault(__webpack_require__(856));

var _smartRenderer = _interopRequireDefault(__webpack_require__(294));

var _timeConverter = _interopRequireDefault(__webpack_require__(350));

var _column = _interopRequireDefault(__webpack_require__(921));

var _markerFactory = _interopRequireDefault(__webpack_require__(922));

var _extent = _interopRequireDefault(__webpack_require__(538));

var _hour = _interopRequireDefault(__webpack_require__(362));

var chartNonce = '';

var ROLLOVER = 'DataPlotRollOver',
    ROLLOUT = 'DataPlotRollOut',
    HIGHLIGHT = 'DataPlotHighlight',
    VISIBLE = 'visible',
    BLANK = '',
    _reducerFn = function _reducerFn(s, t) {
  return Object.assign(s, t);
},
    CLICK = 'DataPlotClick',

/**
 * Function to get the start and end position of plot.
 */
getDataPos = function getDataPos(num) {
  return [num.start, num.end];
},

/**
 * Function to check if data is invalid
 * Data is invalid if scale is log and value is less than zero
 * or data start or end is outside the focus limit.
 */
isDataInvalid = function isDataInvalid(isLog, num, dataPos, focusLimit) {
  return isLog && num <= 0 || dataPos[1] < focusLimit[0] || dataPos[0] > focusLimit[1];
},
    getGenericType = function getGenericType(type) {
  switch (type) {
    case 'line':
    case 'smooth-line':
    case 'step-line':
      return 'line';

    case 'area':
    case 'smooth-area':
    case 'step-area':
    case 'area-range':
      return 'area';

    default:
      break;
  }
},
    checkForValidCoordinated = function checkForValidCoordinated(coordiante) {
  var valid = true,
      key;

  for (key in coordiante) {
    if (coordiante.hasOwnProperty(key)) {
      valid = valid && !isNaN(coordiante[key]);
    }
  }

  return valid;
};

var HTP = _lib.hasTouch ? _lib.TOUCH_THRESHOLD_PIXELS : _lib.CLICK_THRESHOLD_PIXELS;
(0, _dependencyManager.addDep)({
  name: 'timeseriesColumnAnimation',
  type: 'animationRule',
  extension: _column.default
});
/**
 * This class is used to draw the column dataset of timeseries
 */

var Column = /*#__PURE__*/function (_SmartRenderer) {
  (0, _inheritsLoose2.default)(Column, _SmartRenderer);

  function Column() {
    var _this;

    _this = _SmartRenderer.call(this) || this;

    _this.getClassName = function (baseName) {
      if (baseName === void 0) {
        baseName = '';
      }

      var randomString = Math.random().toString(36).substring(2);
      return baseName + "-" + randomString;
    };

    var dataset = (0, _assertThisInitialized2.default)(_this),
        config = _this.config;

    _this.registerFactory('markerFactory', _markerFactory.default);
    /**
     * Function to get the 1st valid data
     */


    _this._getFirstValidData = function _getFirstValidDataFn(dataArr, validatorProp) {
      var i,
          ii = dataArr.length;

      for (i = 0; i < ii; i++) {
        if (dataArr[0] && dataArr[0][validatorProp] !== _lib.UNDEF) {
          return dataArr[0][validatorProp];
        }
      }

      return _lib.UNDEF;
    };

    config.hoverInfo = [];

    _this.addEventListener('beforeremove', function () {
      dataset.getFromEnv('chart').setXScaleLimit(config.scaleX.getId(), dataset.getId());
      dataset.getFromEnv('chart').setYScaleLimit(config.scaleY.getId(), dataset.getId());
    });

    return _this;
  }
  /**
   * returns the style which is to be applied on the hovered plot
   *
   * @param {Object} hoverIndices indices of hovered plots
   * @returns {Object} configuration
   * @memberof Column
   */


  var _proto = Column.prototype;

  _proto.getHoverInConfig = function getHoverInConfig(hoverIndices) {
    return {
      style: this.config.hoverInStyle,
      hoverIndices: hoverIndices,
      hovered: true
    };
  };

  /**
   * returns the style which is to be applied on the highlighted plot
   *
   * @param {Object} hoverIndices index of highlighted plots
   * @returns {Object} configuration
   * @memberof Column
   */
  _proto.getHighlightConfig = function getHighlightConfig(hoverIndices) {
    return {
      style: this.config.highlightStyle,
      hoverIndices: hoverIndices,
      hovered: false
    };
  }
  /**
   * returns the style which is to be applied on the hovered out plot
   *
   * @param {Object} hoverIndices index of hovered out plots
   * @returns {Object} configuration
   * @memberof Column
   */
  ;

  _proto.getHoverOutConfig = function getHoverOutConfig(hoverIndices) {
    return {
      style: this.config.hoverOutStyle,
      hoverIndices: hoverIndices,
      hovered: false
    };
  };

  /**
   * Sets the type of the component
   * @return {string} type
   */
  _proto.getType = function getType() {
    return 'dataset';
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */
  ;

  _proto.getName = function getName() {
    return 'timeseriesColumn';
  };

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    _SmartRenderer.prototype.__setDefaultConfig.call(this);

    var config = this.config;
    config['default-plotSpacePercent'] = 30;
    config.visibility = VISIBLE;
    config.prevBoundaryInfo = {};
    config.dataMarkerPadding = 0;
    config.style = {};
    config.hoverInStyle = {};
    config.highlightStyle = {};
    config.hoverOutStyle = {};
    config.defaultStyle = {
      'stroke-width': 1,
      'fill-opacity': 1,
      'stroke-opacity': 1,
      'opacity': 1
    };
    config.defaultPredictedDataStyle = {
      'stroke-width': 1,
      'fill-opacity': 0.2,
      'stroke-opacity': 1,
      'stroke-dasharray': 5
    };
    config.defaultHoverInStyle = {
      'opacity': 0.8
    };
    config.defaultHighlightStyle = {
      'opacity': 0.8
    };
    config.dataInfo = [];
    config.prevPerBinYExtents = [];
    config.dataIndices = [1, 2];
  }
  /**
   * Function to configure the cosmemtics of the plots
   */
  ;

  _proto.configureAttributes = function configureAttributes(dataObj) {
    var dataset = this,
        prop,
        chartAttr = dataset.getFromEnv('chart-attrib'),
        config = dataset.config; // Setting the given configurations

    if (dataObj.hasOwnProperty('hoverIndices')) {
      // If index is provided then, single plot has to be configured
      config.hoverInfo.push(dataObj);
      config.hoverMode = true;
    } else {
      for (prop in dataObj) {
        // Style parsing is done only when primaryColor is provided
        if (prop === 'primaryColor') {
          var plotConfig = dataObj.plotCosmetics,
              genericConfig = dataObj.genericCosmetics,
              primaryColor = dataObj[prop],
              styles = void 0,
              getStyleDef = dataset.getFromEnv('getStyleDef'),
              applicableClassStyleGeneric = getStyleDef(genericConfig.style && genericConfig.style.plot),
              applicableClassStyleGenericHover = getStyleDef(genericConfig.style && genericConfig.style['plot:hover']),
              applicableClassStyleGenericHighlight = getStyleDef(genericConfig.style && genericConfig.style['plot:highlight']),
              applicableClassStylePlot = getStyleDef(plotConfig.style && plotConfig.style.plot),
              applicableInlineStylePlot = getStyleDef(dataObj.styleConfig && dataObj.styleConfig.plot),
              applicableClassStyleColumn = getStyleDef(plotConfig.style && plotConfig.style.column),
              applicableInlineStyleColumn = getStyleDef(dataObj.styleConfig && dataObj.styleConfig.column),
              applicableHoverStylePlot = getStyleDef(plotConfig.style && plotConfig.style['plot:hover']),
              applicableHighlightStylePlot = getStyleDef(plotConfig.style && plotConfig.style['plot:highlight']),
              applicableHoverInlineStylePlot = getStyleDef(dataObj.styleConfig && dataObj.styleConfig['plot:hover']),
              applicableHighlightInlineStylePlot = getStyleDef(dataObj.styleConfig && dataObj.styleConfig['plot:highlight']),
              applicableHoverStyleColumn = getStyleDef(plotConfig.style && plotConfig.style['column:hover']),
              applicableHighlightStyleColumn = getStyleDef(plotConfig.style && plotConfig.style['column:highlight']),
              applicableHoverInlineStyleColumn = getStyleDef(dataObj.styleConfig && dataObj.styleConfig['column:hover']),
              applicableHighlightInlineStyleColumn = getStyleDef(dataObj.styleConfig && dataObj.styleConfig['column:highlight']),
              styleObj = config.style,
              hoverOutStyle = config.hoverOutStyle,
              hoverInStyle = config.hoverInStyle,
              highlightStyle = config.highlightStyle; // Parsing the plot styling properties with increasing preference

          [styleObj, config.defaultStyle, applicableClassStyleGeneric, applicableClassStylePlot, applicableInlineStylePlot, applicableClassStyleColumn, applicableInlineStyleColumn].reduce(_reducerFn);
          [hoverInStyle, config.defaultHoverInStyle, applicableClassStyleGenericHover, applicableHoverStylePlot, applicableHoverStyleColumn, applicableHoverInlineStylePlot, applicableHoverInlineStyleColumn].reduce(_reducerFn);
          [highlightStyle, config.defaultHighlightStyle, applicableClassStyleGenericHighlight, applicableHighlightStylePlot, applicableHighlightStyleColumn, applicableHighlightInlineStylePlot, applicableHighlightInlineStyleColumn].reduce(_reducerFn); // Forming the stroke color

          styleObj.stroke = (0, _lib.convertColor)((0, _lib.pluck)(styleObj.stroke, primaryColor, config['default-stroke']), (0, _lib.pluckNumber)(styleObj['stroke-opacity'], 1) * 100); // Fill is obtained only from palette colors

          styleObj.fill = (0, _lib.convertColor)((0, _lib.pluck)(primaryColor, styleObj.stroke, config['default-fill']), (0, _lib.pluckNumber)(styleObj['fill-opacity'], 1) * 100);
          hoverInStyle.fill && (hoverInStyle.fill = (0, _lib.convertColor)(hoverInStyle.fill, (0, _lib.pluckNumber)(hoverInStyle['fill-opacity'], styleObj['fill-opacity']) * 100));
          hoverInStyle.stroke && (hoverInStyle.stroke = (0, _lib.convertColor)(hoverInStyle.stroke, (0, _lib.pluckNumber)(hoverInStyle['stroke-opacity'], styleObj['stroke-opacity']) * 100));
          highlightStyle.fill && (highlightStyle.fill = (0, _lib.convertColor)(highlightStyle.fill, (0, _lib.pluckNumber)(highlightStyle['fill-opacity'], styleObj['fill-opacity']) * 100));
          highlightStyle.stroke && (highlightStyle.stroke = (0, _lib.convertColor)(highlightStyle.stroke, (0, _lib.pluckNumber)(highlightStyle['stroke-opacity'], styleObj['stroke-opacity']) * 100)); // Parsing the hoverOut styles from hover style and highlight style

          for (styles in Object.assign(Object.assign({}, hoverInStyle), highlightStyle)) {
            hoverOutStyle[styles] = (0, _lib.pluck)(styleObj[styles], '');
          } // Stroke dash-array behave differently when applied on element and group, hence removing it


          (0, _lib.defined)(hoverOutStyle['stroke-dasharray']) && (hoverOutStyle['stroke-dasharray'] = null);
          config.plotBorderThickness = styleObj['stroke-width']; // Opacities are separately stored and is applied to each element as applying them on the group followed by the elememt (during hover in and out)
          // results into multiplied opacity

          config.opacity = styleObj.opacity;
          config['fill-opacity'] = styleObj['fill-opacity'];
          config['stroke-opacity'] = styleObj['stroke-opacity'];
          delete styleObj.opacity;
          delete styleObj['fill-opacity'];
          delete styleObj['stroke-opacity'];
        } else {
          config[prop] = dataObj[prop];
        }
      }

      config.plotSpacePercent = (0, _lib.pluckNumber)(chartAttr.plotspacepercent, config['default-plotSpacePercent']);
      config.limit = dataset._calculateLimits();
      var chart = dataset.getFromEnv('chart');
      chart.setYScaleLimit(config.scaleY.getId(), dataset.getId(), config.limit.y, config.limit.baseRequired);
      chart.setXScaleLimit(config.scaleX.getId(), dataset.getId(), config.limit.x);
    }

    this.parsePrediction(dataObj);
  } // Method to get timestamp value for a given pixel
  ;

  _proto.getValueFromPx = function getValueFromPx(pxValue) {
    var binRange = this.getFromEnv('binDecider').getBinRange(),
        axisLength = binRange[1] - binRange[0],
        chart = this.getFromEnv('chart'),
        limit = this.config.calculateFromContext ? chart.getContextLimit() : chart.getFocusLimit(),
        diff = limit[1] - limit[0]; // The logic for this calculation is as follows:
    // Suppose your focus limit range is FR and you want to add X value of padding.
    // Then your new focus limit is now FR + X (considering both left and right padding).
    // If the axis length is AL pixel, and the pixel value for the timestamp X is known, then
    // apply unitary method to find the value of X.

    return pxValue * diff / (axisLength - pxValue);
  } // Method to get padding in data limits
  ;

  _proto.getPadding = function getPadding() {
    var dataset = this,
        config = dataset.config,
        scaleX = config.scaleX,
        curBin = this.getFromEnv('binDecider').getRangeThreshold(),
        scalePadding = 0,
        dataMarkerPadding = dataset.getValueFromPx(config.dataMarkerPadding);

    if (scaleX.showPlotOverTick()) {
      scalePadding = curBin[2] / 2;
    }

    return Math.ceil(Math.max(scalePadding, dataMarkerPadding));
  };

  _proto._calculateLimits = function _calculateLimits() {
    var _this$config = this.config,
        indices = _this$config.indices,
        data = _this$config.data,
        type = _this$config.type,
        scaleY = _this$config.scaleY,
        scaleX = _this$config.scaleX,
        calculateFromContext = _this$config.calculateFromContext,
        isContinuous = /continuous/.test(this.getName()),
        showPlotOverTick = scaleX.showPlotOverTick(),
        padding,
        returnObj = {},
        firstData = data[0],
        lastData = data[data.length - 1],
        isLog = scaleY.getType() === 'log',
        isVisible = this.config.visibility === 'visible',
        chart = this.getFromEnv('chart'),
        limit = calculateFromContext ? chart.getContextLimit() : chart.getFocusLimit(),
        minFn = function minFn(arr) {
      var num = (0, _lib.pluckNumber)(arr[indices[2]], arr[indices[1]]),
          dataPos = getDataPos(arr[0]),
          isInvalid = isDataInvalid(isLog, num, dataPos, limit);
      return isInvalid ? null : num;
    },
        maxFn = function maxFn(arr) {
      var num = arr[indices[1]],
          dataPos = getDataPos(arr[0]),
          isInvalid = isDataInvalid(isLog, num, dataPos, limit);
      return isInvalid ? null : num;
    };

    padding = this.getPadding();

    if (showPlotOverTick) {
      returnObj.x = [firstData && firstData[indices[0]].start - padding, lastData && lastData[indices[0]].start + padding];
    } else {
      if (isContinuous) {
        returnObj.x = [firstData && (firstData[indices[0]].start + firstData[indices[0]].end) / 2 - padding, lastData && (lastData[indices[0]].start + lastData[indices[0]].end) / 2 + padding];
      } else {
        returnObj.x = [firstData && firstData[indices[0]].start - padding, lastData && lastData[indices[0]].end - padding];
      }
    }

    returnObj.y = isVisible ? [(0, _safeMin.default)(data, minFn), (0, _safeMax.default)(data, maxFn)] : _lib.UNDEF;
    returnObj.baseRequired = !/line/.test(type);
    return returnObj;
  }
  /**
   * The main draw function
   */
  ;

  _proto.draw = function draw() {
    var dataset = this;

    dataset._createContainer();

    dataset._drawPlot(); // Resetting the hoverInfo after each draw cycle


    dataset.config.hoverInfo = [];
    dataset.config.hoverMode = false;
    dataset.config.repositioningDone = false;
  }
  /**
   * Function to create the containers of the dataset with all the cosmetics applioed at group level.
   * Also, create containers for its data-markers
   */
  ;

  _proto._createContainer = function _createContainer() {
    var dataset = this; // Group for plots

    dataset.addGraphicalElement({
      el: 'group',
      container: {
        id: 'meso',
        label: 'group',
        isParent: true
      },
      component: dataset,
      label: 'group',
      id: 'meso',
      attr: {
        name: 'dataset-meso'
      }
    }, true); // Group for plots

    dataset.addGraphicalElement({
      el: 'group',
      container: {
        id: 'thermo',
        label: 'group',
        isParent: true
      },
      component: dataset,
      label: 'group',
      id: 'thermo',
      attr: {
        name: 'dataset-thermo',
        'clip-path': dataset.getFromEnv('dsGroupclipPath')
      }
    }, true);
  }
  /**
   * Function that determines if drawing is required in the current data-cycle
   */
  ;

  _proto.isDrawingRequired = function isDrawingRequired() {
    var dataset = this,
        config = dataset.config;

    if (config.repositioningDone || config.hoverMode) {
      return true;
    }
  }
  /**
   * Function to draw the plots
   */
  ;

  _proto._drawPlot = function _drawPlot() {
    var dataset = this,
        config = dataset.config,
        styleObj = config.style,
        definedOpacity = (0, _lib.defined)(config.opacity),
        definedStrokeOpacity = (0, _lib.defined)(config['stroke-opacity']),
        definedFillOpacity = (0, _lib.defined)(config['fill-opacity']),
        attr,
        isDatumPredictive = false,
        predictiveStyleAttributes = dataset.config.predictiveStyleAttributes,
        definedPredictiveOpacity = (0, _lib.defined)(predictiveStyleAttributes.predictiveOpacity),
        definedPredictiveStrokeOpacity = (0, _lib.defined)(predictiveStyleAttributes.predictiveStrokeOpacity),
        definedPredictiveFillOpacity = (0, _lib.defined)(predictiveStyleAttributes.predictiveFillOpacity),
        dataInfo = config.dataInfo; // Group for plots

    dataset.addGraphicalElement({
      el: 'group',
      container: {
        id: 'meso',
        label: 'group'
      },
      component: dataset,
      label: 'group',
      id: 'meso-plot',
      attr: Object.assign({
        name: 'column-plot-meso',
        visibility: config.visibility
      }, styleObj)
    }, true); // Group for predictive plots

    dataset.addGraphicalElement({
      el: 'group',
      container: {
        id: 'meso',
        label: 'group'
      },
      component: dataset,
      label: 'group',
      id: 'meso-plot-predictive',
      attr: Object.assign({
        name: 'column-predictive-plot-meso',
        visibility: config.visibility
      }, styleObj, predictiveStyleAttributes)
    }, true); // Creating the plots

    dataInfo.forEach(function (datum, index) {
      if ((0, _isValidNumber.default)(datum.value) || (0, _isValidNumber.default)(datum.high) && (0, _isValidNumber.default)(datum.low)) {
        attr = {
          x: datum.x,
          y: datum.y,
          width: datum.width,
          height: datum.height
        };
        isDatumPredictive = dataset.isPlotPredictive(datum);
        definedOpacity && (attr.opacity = config.opacity);
        definedStrokeOpacity && (attr['stroke-opacity'] = config['stroke-opacity']);
        definedFillOpacity && (attr['fill-opacity'] = config['fill-opacity']); // Apply opacity only if it is applied

        datum.style && Object.assign(attr, datum.style);

        if (isDatumPredictive) {
          definedPredictiveOpacity && (attr.opacity = predictiveStyleAttributes.predictiveOpacity);
          definedPredictiveStrokeOpacity && (attr['stroke-opacity'] = predictiveStyleAttributes.predictiveStrokeOpacity);
          definedPredictiveFillOpacity && (attr['fill-opacity'] = predictiveStyleAttributes.predictiveFillOpacity);
        } // Invalid value checking


        dataset.addGraphicalElement({
          el: 'rect',
          container: {
            label: 'group',
            id: !isDatumPredictive ? 'meso-plot' : 'meso-plot-predictive'
          },
          props: {
            dataLength: dataInfo.length
          },
          label: 'rect',
          attr: attr,
          component: dataset,
          index: index
        }, true);
        datum.style = _lib.UNDEF;
      }
    });
    config.hoverInfo = [];
  }
  /**
   * Helper function to check if positioning is required based on the xScale's domain range
   */
  ;

  _proto._isRepositioningNeeded = function _isRepositioningNeeded() {
    var dataset = this,
        config = dataset.config,
        xScale = dataset.getFromEnv('xScale'),
        yScale = dataset.getFromEnv('yScale'),
        _xScale$getDomain = xScale.getDomain(),
        xDomainStart = _xScale$getDomain[0],
        xDomainEnd = _xScale$getDomain[1],
        _xScale$getRange = xScale.getRange(),
        xRangeStart = _xScale$getRange[0],
        xRangeEnd = _xScale$getRange[1],
        _yScale$getDomain = yScale.getDomain(),
        yDomainStart = _yScale$getDomain[0],
        yDomainEnd = _yScale$getDomain[1],
        _yScale$getRange = yScale.getRange(),
        yRangeStart = _yScale$getRange[0],
        yRangeEnd = _yScale$getRange[1],
        positioningReq,
        prevBoundaryInfo = config.prevBoundaryInfo,
        hasDataYExtentChangedInAnyBin = this.hasDataYExtentChangedInAnyBin();

    if (+xDomainStart !== +prevBoundaryInfo.xDomainStart || +xDomainEnd !== +prevBoundaryInfo.xDomainEnd || +yDomainStart !== +prevBoundaryInfo.yDomainStart || +yDomainEnd !== +prevBoundaryInfo.yDomainEnd || xRangeStart !== prevBoundaryInfo.xRangeStart || xRangeEnd !== +prevBoundaryInfo.xRangeEnd || yRangeStart !== prevBoundaryInfo.yRangeStart || yRangeEnd !== +prevBoundaryInfo.yRangeEnd || config.prevVisibility !== config.visibility || config.legendInteracted || hasDataYExtentChangedInAnyBin) {
      // once positioning is required the legend interaction must be set false otherwise it will always reamin
      // true and double drawing of dataset will occur during zooming
      config.legendInteracted = false;
      positioningReq = true;
      config.prevBoundaryInfo = {
        xDomainStart: xDomainStart,
        xDomainEnd: xDomainEnd,
        xRangeStart: xRangeStart,
        xRangeEnd: xRangeEnd,
        yDomainStart: yDomainStart,
        yDomainEnd: yDomainEnd,
        yRangeStart: yRangeStart,
        yRangeEnd: yRangeEnd
      };
      config.prevVisibility = config.visibility;
    }

    return positioningReq;
  };

  _proto.hasDataYExtentChangedInAnyBin = function hasDataYExtentChangedInAnyBin() {
    var config = this.config,
        data = config.data,
        prevPerBinYExtents = config.prevPerBinYExtents,
        indices = this.config.dataIndices,
        perBinYExtents = data.map(function (datum) {
      return (0, _extent.default)(indices.map(function (idx) {
        return datum[idx];
      }), Number);
    }); // If the number of bins in the last render and this render are equal,
    // iterate and compare the Y extents of every bin,

    if (perBinYExtents.length === prevPerBinYExtents.length) {
      var result = perBinYExtents.some(function (yExtent, idx) {
        var prevYExtent = prevPerBinYExtents[idx];
        return yExtent[0] !== prevYExtent[0] || yExtent[1] !== prevYExtent[1];
      });
      config.prevPerBinYExtents = perBinYExtents;
      return result;
    } // Else, no comparisons are required. The Y extents have definitely changed.
    //
    // Set the current perBinYExtents as the prevPerBinYExtents for the next
    // render cycle and return true to indicate that Y extents have changed in
    // some bins.


    config.prevPerBinYExtents = perBinYExtents;
    return true;
  }
  /**
   * Function to allocation the position of the dataplots
   */
  ;

  _proto.allocatePosition = function allocatePosition() {
    var dataset = this,
        config = dataset.config,
        _config$indices = config.indices,
        xIdx = _config$indices[0],
        yIdx = _config$indices[1],
        baseIdx = _config$indices[2],
        totalStackSum = _config$indices[3],
        binDecider = dataset.getFromEnv('binDecider'),
        xScale = dataset.getFromEnv('xScale'),
        yScale = dataset.getFromEnv('yScale'),
        dataInfo = config.dataInfo,
        seriesInfo = config.seriesInfo,
        dateColumn = dataset.getFromEnv('dateColumn'),
        isUTC = dataset.getFromEnv('UTC'),
        height,
        width,
        date,
        value,
        x,
        y,
        yBaseValue,
        yPos,
        yBase,
        hoverInfo,
        isNegative,
        pX,
        xShift,
        endXPosition,
        groupIndex = config.groupIndex || 0,
        groupWidth,
        totalGroups = config.totalGroups || 1,
        availableWidth,
        data = config.data,
        duration,
        eventArgs,
        seriesName,
        format = dateColumn.format,
        formatter = isUTC ? _timeConverter.default.utcFormatter(format) : _timeConverter.default.formatter(format),
        startDate,
        endDate,
        midGroup,
        gutter,
        i,
        len,
        bins = xScale.bins,
        plotBorderThickness = config.plotBorderThickness,
        considerPlotBorder = config.fillColor === config.strokeColor && plotBorderThickness > 0,
        paddingInTimestamp,
        rangeThreshold = binDecider.getRangeThreshold()[2],
        _xScale$getDomain2 = xScale.getDomain(),
        startDomain = _xScale$getDomain2[0],
        endDomain = _xScale$getDomain2[1],
        dataObj;

    config.firstTimeStamp = data && data[0] && data[0][xIdx] && data[0][xIdx].start;

    if (config.repositioningDone = dataset._isRepositioningNeeded()) {
      // skip drawing if dataset is not visible
      if (config.visibility !== 'visible') {
        return;
      } // Store data related operations


      dataInfo = config.dataInfo = []; // Getting the pixel width between two consecutive data

      config.availableWidth = availableWidth = 0; // Storing info for dataMarker detection

      for (i = 0, len = bins.length; i < len; i++) {
        if (bins[i].clipType !== 2) {
          config.availableWidth = availableWidth = xScale.getRangeValue(bins[i].end) - xScale.getRangeValue(bins[i].start);
          break;
        }
      }

      config.timeStampGap = rangeThreshold; // Avoid negative thickness when border thickness is more than the actual available width

      groupWidth = Math.max(availableWidth * (1 - config.plotSpacePercent / 100), 1); // Logic for multi-series

      width = groupWidth / totalGroups;
      midGroup = Math.round(totalGroups / 2);
      gutter = totalGroups % 2 === 0 ? 0 : 0.5;
      xShift = midGroup - groupIndex > 0 ? -width * (midGroup - groupIndex - gutter) : width * (groupIndex - midGroup + gutter);
      paddingInTimestamp = +xScale.getDomainValue(availableWidth * (config.plotSpacePercent / 200)) - +xScale.getDomainValue(0); // Storing value for tooltip

      config.actualStartDomain = +startDomain + paddingInTimestamp; // Actual end domain is the scale domain minus the space taken up by the plotspacepercent

      config.actualEndDomain = +endDomain - paddingInTimestamp; // Adjusting column width as per the column border

      considerPlotBorder && (width = Math.max(width - plotBorderThickness, 1));
      data.forEach(function (datum, index) {
        date = datum[xIdx];
        value = datum[yIdx];
        duration = date.config.duration;
        startDate = date.start;
        endDate = date.end;

        if (!isUTC) {
          var tempDate = new Date(startDate),
              winterOffset = new Date(tempDate.getFullYear(), 0).getTimezoneOffset(),
              summerOffset = new Date(tempDate.getFullYear(), 6).getTimezoneOffset(); // Incase of daylight savings, update the start date

          if (winterOffset > summerOffset) {
            startDate = _hour.default.offset(startDate, 1);
          }
        } // Storing the 1st time stamp


        if (!index) {
          config.firstTimeStamp = date.start;
        }

        yBaseValue = datum[baseIdx];
        yBase = yScale.getRangeValue(yBaseValue || Math.max(yScale.getDomain()[0], 0));
        yPos = yScale.getRangeValue(value);

        if ((0, _isValidNumber.default)(value) && (0, _isValidNumber.default)(yBase) && (0, _isValidNumber.default)(yPos)) {
          // Find the position where the plot is to be placed
          x = xScale.getRangeValue(new Date(date.start), new Date(date.end)); // Adjusting column starting position as per the column border

          considerPlotBorder && (x += plotBorderThickness / 2);
          x += xShift;
          endXPosition = x + width; // Adding the base to manage the stacking

          height = Math.abs(yBase - yPos);
          isNegative = yPos > yBase;
          y = isNegative ? yBase : yPos;
          dataObj = {
            startDate: startDate,
            endDate: endDate,
            value: value,
            yBaseValue: yBaseValue,
            yBase: yBase,
            x: x,
            endXPosition: endXPosition,
            y: y,
            width: width,
            height: height,
            totalStackSum: (0, _lib.defined)(datum[totalStackSum]) ? datum[totalStackSum] : _lib.UNDEF,
            eventArgs: {
              index: index,
              dataValue: value
            }
          };
          eventArgs = {
            index: index,
            dataValue: value,
            start: startDate,
            startText: formatter.format(startDate),
            end: endDate,
            endText: formatter.format(endDate),
            binUnit: duration.Unit,
            binMultiplier: duration.number,
            plotType: config.type,
            timeFormatter: format,
            aggregation: config.aggregation,
            measure: config.measures[0],
            binValue: value,
            binValueFormatted: config.formatterFn && config.formatterFn({
              value: value,
              type: 'tooltip',
              prefix: config.prefix,
              suffix: config.suffix
            })
          };
          seriesName = Object.keys(seriesInfo)[0];

          if (seriesName) {
            eventArgs.series = seriesName;
            eventArgs.seriesValue = seriesInfo[seriesName];
          }

          dataObj.eventArgs = eventArgs; // Get the data index corresponding to the fetched timeStamp

          pX = xScale.getBinIndex(date.start);
          dataInfo[pX] = dataObj;
        }
      });
    } // If hovered, show hover effect of the particular plot


    if (hoverInfo = config.hoverInfo) {
      hoverInfo.forEach(function (hoveredData) {
        hoveredData.hoverIndices.forEach(function (index) {
          if (typeof dataInfo[index] === 'object' && typeof hoveredData.style === 'object') {
            dataInfo[index].style = (0, _lib.extend2)(dataInfo[index].style, hoveredData.style);
          }
        });
      });
    }
  }
  /**
   * Helper function of data markers
   * @return {Object} contains positioning info and the dataInfo
   */
  ;

  _proto._getRelevantInfo = function _getRelevantInfo() {
    var config = this.config;
    return {
      firstTimeStamp: config.firstTimeStamp,
      timeStampGap: config.timeStampGap,
      dataInfo: config.dataInfo,
      fill: config.style.stroke
    };
  }
  /**
   * Function that retunr the nearest plot details
   * @param {number} chartX x-axis position of the mouse cordinate
   * @param {number} chartY x-axis position of the mouse cordinate
   * @return {Object} return an object with details of nearest polt and whether it is hovered or not
   */
  ;

  _proto._getHoveredPlot = function _getHoveredPlot(chartXArg, chartYArg) {
    var dataset = this,
        chartX = chartXArg,
        chartY = chartYArg,
        xScale = dataset.getFromEnv('xScale'),
        xScaleRange = xScale.getRange(),
        canvas = dataset.getLinkedParent(),
        config = dataset.config,
        visible = config.visibility === VISIBLE,
        dataMarkers = [dataset.getChildren('dataMarker')],
        dataMarker,
        output,
        returnObj,
        translationObj = canvas.getTranslation(),
        translationX = translationObj ? translationObj.x : 0,
        translationY = translationObj ? translationObj.y : 0,
        pX; // Readjusting the chart as the canvas group is translated

    chartX -= translationX;
    chartY -= translationY; // if chartX is outside the range of scale, no plots will be hovered
    // as because tootlip expects a proper object or undefined component property is sent
    // if undefined it sent then it will freeze tooltip in its last position.

    if (chartX < xScaleRange[0] || chartX > xScaleRange[1]) {
      return {
        component: dataset
      };
    } // Calculation the bin index corresponding to the fteched timeStamp


    pX = xScale.getBinIndex(xScale.getDomainValue(chartX)); // Special case  when timeStampGap = 1, the levelof aggregation is minimum

    config.timeStampGap <= 1 && pX === -1 && (pX = 0); // Iteraring over the datamarkers to check if they are hovered

    dataMarkers.forEach(function (dataMarkerArg) {
      if (!output && dataMarkerArg) {
        dataMarker = dataMarkerArg[0];
        output = dataMarker._checkPointOverMarker(pX, chartX, chartY, config.availableWidth);
      }
    }); // Checking for overlap amongst datamarker and two cosecutive column plots along x-axis

    returnObj = output;

    if (!returnObj) {
      if (visible) {
        returnObj = dataset._checkPointerOverColumn(pX, chartX, chartY);
      } else {
        returnObj = {};
      }
    } // if not hovered on any plot then get the nearest plot info.


    if (!returnObj.hovered) {
      // Storing info for crossline
      returnObj.binIndexHovered = xScale.getBinIndex(xScale.getDomainValue(chartX));
      returnObj.pointObj = config.dataInfo[returnObj.binIndexHovered] || xScale.getBinBounds(pX);
      returnObj.component = dataset;
    } else {
      returnObj.binIndexHovered = returnObj.pointIndex;
    }

    config.binIndexHovered = returnObj.binIndexHovered;
    return returnObj;
  }
  /**
   * Dummy helper function for tooltext to get the data index wrt the current dataset that is hovered
   */
  ;

  _proto._getHoveredBin = function _getHoveredBin() {
    return this.config.binIndexHovered;
  }
  /**
   * Generate the random class.
   * @param {String} baseName the static prefix for random class
   * @returns {String} new generated random classes.
   */
  ;

  /**
   * Function to form the tooltext
   * @param {Boolean} pointFound If any dataset's data is actually hovered
   * @param {Boolean} datasetHovered If the current dataset is hovered
   * @param {number} dataIndex The index of the data in the current dataset that is hovered
   */
  _proto._getTooltext = function _getTooltext(pointFound, datasetHovered, dataIndex) {
    var _dataSource$chart;

    var dataset = this,
        config = dataset.config,
        dataSource = dataset.getFromEnv('dataSource'),
        plots = dataset._linkedParent.getChildren('dataset'),
        tooltext = dataSource.tooltip ? dataSource.tooltip.tooltext : null,
        tooltextElement,
        macroIndices,
        parserConfig,
        plotConfig,
        outPutFormatter = config.scaleX.formatters,
        timeFormat = config.scaleX._timeFormat,
        bin,
        binStart,
        binEnd,
        dsName = dataset.getName(),
        dsType = getGenericType(config.type),
        bodyStyle = dataset.getFromEnv('tooltipStyle').body,
        containerLineHeight = dataset.getFromEnv('tooltipStyle').container['line-height'] || 1,
        colorBoxlen = containerLineHeight === 1 ? bodyStyle['font-size'] : containerLineHeight,
        dataInfo = config.dataInfo,
        currData = dataInfo[dataIndex],
        value,
        // Setting logic for opacity.
    // When the data of the currentdataset is hovered then all other tooltip's opacity is set to 0.5
    // Rest all the cases the opacity is 1
    opacity = pointFound ? datasetHovered ? 1 : 0.5 : 1,
        tooltipShapeFill = dsName === 'continuous' ? dsType === 'line' ? config.plotStyle.stroke : config.plotStyle.fill : config.style.fill,
        line2;

    chartNonce = (dataSource == null ? void 0 : (_dataSource$chart = dataSource.chart) == null ? void 0 : _dataSource$chart.nonce) || '';

    if (dataset._isInvalidTooltext(currData)) {
      return '';
    }

    if (!currData.tooltipValue) {
      // Substracting the base if it is provided
      // value = isValidNumber(currData.yBaseValue)
      // ? currData.yBaseValue >= 0 ? currData.value - currData.yBaseValue
      // : currData.yBaseValue - currData.value : currData.value;
      // FTV3-1076- correcting value in tooltip
      value = (0, _isValidNumber.default)(currData.yBaseValue) ? currData.value - currData.yBaseValue : currData.value;
      currData.tooltipValue = (0, _isValidNumber.default)(value) ? config.formatterFn({
        value: value,
        type: 'tooltip',
        prefix: config.prefix,
        suffix: config.suffix
      }) : '';
    }

    if (tooltext) {
      // get the name of all the series
      if (dataSource.yaxis.length > 1) {
        parserConfig = {
          series: dataSource.yaxis.map(function (series) {
            return {
              name: series.plot[0].value
            };
          })
        };
      } else {
        parserConfig = {
          series: dataSource.yaxis[0].plot.map(function (series) {
            return {
              name: series.value
            };
          })
        };
      } // get conigurations related to plots


      plotConfig = {
        series: plots.map(function (index) {
          var individualPlotConfig, isMajor, plotIdentifierElement; // If outputTimeFormat is provided, then update bin, binStart, binEnd

          if (dataSource.xaxis[0].outputtimeformat) {
            // Mock the time converter behaviour of time-axis
            isMajor = timeFormat.minor ? timeFormat.minor : timeFormat.major;
            binStart = outPutFormatter[isMajor].major.format(dataInfo[dataIndex].startDate);
            binEnd = outPutFormatter[isMajor].major.format(dataInfo[dataIndex].endDate);
          } else {
            bin = config.timeFormatterFn({
              type: 'tooltip',
              dateRange: index.config.dataInfo[dataIndex]
            });
            binStart = bin.split('-')[0];
            binEnd = bin.split('-')[1];
          }

          individualPlotConfig = index.config.dataInfo[dataIndex].eventArgs; // @todo - Function is not accessible

          var tooltipPlotIdentifierElement = this.getAmanName('tooltip-aman'); // Create plotIdentifier element dynamically for all plots

          plotIdentifierElement = "\n          <style nonce=\"" + chartNonce + "\">\n            ." + tooltipPlotIdentifierElement + " {\n              height: 10px;\n              width: 10px;\n              background-color: " + index.config.style.fill + ";\n            }\n          </style>\n          <div class=\"" + tooltipPlotIdentifierElement + "\"></div>";
          return {
            color: index.config.style ? index.config.style.fill : _lib.UNDEF,
            plotIdentifier: plotIdentifierElement,
            value: index.config.dataInfo[dataIndex].eventArgs.binValue,
            bin: bin,
            binStart: binStart,
            binEnd: binEnd,
            dataValue: index.config.dataInfo[dataIndex].eventArgs.binValueFormatted,
            volumeValue: dataInfo[dataIndex].eventArgs.binValue,
            volumeDataValue: dataInfo[dataIndex].eventArgs.binValueFormatted,
            openValue: individualPlotConfig.binOpen,
            openDataValue: individualPlotConfig.binOpenFormatted,
            highValue: individualPlotConfig.binHigh,
            highDataValue: individualPlotConfig.binHighFormatted,
            lowValue: individualPlotConfig.binLow,
            lowDataValue: individualPlotConfig.binLowFormatted,
            closeValue: individualPlotConfig.binClose,
            closeDataValue: individualPlotConfig.binCloseFormatted
          };
        })
      };
      macroIndices = [154, 155, 156, 157, 158, 159, 160, 161, 162, 163, 164, 165, 166, 167, 168, 169, 170, 171];
      tooltext = (0, _lib.parseTooltext)(tooltext, macroIndices, parserConfig, plotConfig);
      tooltextElement = '<div>' + tooltext + '</div>';
    } else {
      var toolTextElementClass = this.getClassName('tool-text-element'),
          colorBoxLenClass = this.getClassName('color-box-len'),
          tooltipShapeFillClass = this.getClassName('tooltip-shape-fill'),
          configSeriesClass = this.getClassName('config-series'),
          tooltipValueClass = this.getClassName('tooltip-value');
      tooltextElement = "\n      <style nonce=\"" + chartNonce + "\">\n        ." + toolTextElementClass + " {\n          margin-top: 6px;\n          overflow: hidden;\n          opacity: " + opacity + ";\n        }\n\n        ." + colorBoxLenClass + " {\n          float:left; \n          height: " + colorBoxlen + "; \n          width: " + colorBoxlen + "; \n          position:relative;\n          margin-right: 2px;\n        }\n\n        ." + tooltipShapeFillClass + " {\n          display:block;\n          height:64%;\n          width:64%;\n          position:absolute;\n          top:50%;\n          transform:translateY(-50%);\n          background-color:" + tooltipShapeFill + ";\n        }\n\n        ." + configSeriesClass + " {\n          float: left;\n        }\n\n        ." + tooltipValueClass + " {\n          float: right;\n        }\n      </style>\n      <div class=\"" + toolTextElementClass + "\">\n        <span class=\"" + colorBoxLenClass + "\">\n          <span class=\"" + tooltipShapeFillClass + "\"></span>\n        </span>\n        <div class=\"" + configSeriesClass + "\">" + (0, _lib.parseUnsafeString)(config.series) + "&nbsp</div>\n        <div class=\"" + tooltipValueClass + "\">&nbsp" + (currData.tooltipValue || '') + "</div>\n        </div>";
    }

    line2 = tooltextElement;
    return line2;
  }
  /**
   * Funtion that determines if tooltext is possible for the current data
   * @param {Object} currData contains info about the current hovered index
   */
  ;

  _proto._isInvalidTooltext = function _isInvalidTooltext(currData) {
    var dataset = this,
        config = dataset.config; // Checking the data's date range to be inside the range of the visbible axis

    if (!currData || currData.endDate < config.actualStartDomain || currData.startDate > config.actualEndDomain) {
      return true;
    }
  }
  /**
   * Function that sets the date for the tooltext along with the total styack sum if any
   */
  ;

  _proto._getDateForToolText = function _getDateForToolText(dataIndex) {
    var dataset = this,
        config = dataset.config,
        dataInfo = config.dataInfo,
        line1 = BLANK,
        line2 = BLANK,
        currData = dataInfo[dataIndex];

    if (dataset._isInvalidTooltext(currData)) {
      return {
        body: '',
        header: ''
      };
    }

    if (!currData.tooltextTime) {
      currData.tooltextTime = config.timeFormatterFn({
        type: 'tooltip',
        dateRange: currData
      });
    } // Parsing the total stack sum


    var condition = currData.eventArgs && currData.eventArgs.dataValue && currData.totalStackSum,
        toolTextTimeClass = this.getClassName('tooltext-time'),
        totalStackSumClass = this.getClassName('tooltip-stack');

    if (condition && currData.eventArgs.dataValue !== currData.totalStackSum) {
      currData.totalStackSum = currData.eventArgs.dataValue;
    }

    !currData.totalStackSumTooltip && (0, _isValidNumber.default)(currData.totalStackSum) && (currData.totalStackSumTooltip = config.formatterFn({
      value: currData.totalStackSum,
      type: 'tooltip',
      prefix: config.prefix,
      suffix: config.suffix
    }));
    line1 = "\n    <style nonce=\"" + chartNonce + "\">\n      ." + toolTextTimeClass + " {\n        margin-bottom: 8px;\n      }\n    </style>\n    <div class=\"" + toolTextTimeClass + "\">" + currData.tooltextTime + "</div>";
    currData.totalStackSumTooltip && (line2 = "\n        <style nonce=\"" + chartNonce + "\">\n          ." + totalStackSumClass + " {\n            margin-bottom: 2px;\n          }\n        </style>\n        <div class=\"" + totalStackSumClass + "\">Total: " + currData.totalStackSumTooltip + "</div>");
    return {
      header: line1,
      body: line2
    };
  }
  /**
   * function to check if given x,y coordiante is over a column plot or not
   * @param  {number} pX     index of column
   * @param  {number} chartX x co-ordinate
   * @param  {number} chartY y co-ordinate
   * @return {Object}        hovered information
   */
  ;

  _proto._checkPointerOverColumn = function _checkPointerOverColumn(pX, chartX, chartY) {
    var dataset = this,
        config = dataset.config,
        plotBorderThickness = config.plotBorderThickness,
        dataInfo = config.dataInfo,
        pointObj,
        dx,
        dy,
        width,
        height,
        hovered,
        halfPlotBorderThickness,
        yPos;
    pointObj = dataInfo[pX];

    if (!pointObj) {
      return {
        pointIndex: pX,
        hovered: false,
        component: dataset
      };
    } // Setting the tolerance incase of small height or width of column/bar


    height = pointObj.height < HTP ? HTP : pointObj.height;
    width = pointObj.width < HTP ? HTP : pointObj.width; // checking if height is less than thresold value then change the yPos of plot too

    yPos = pointObj.height < HTP ? pointObj.y - (HTP - pointObj.height) : pointObj.y;

    if (plotBorderThickness !== _lib.UNDEF) {
      halfPlotBorderThickness = plotBorderThickness / 2;
    } else {
      plotBorderThickness = halfPlotBorderThickness = 0;
    }

    dx = chartX - pointObj.x + halfPlotBorderThickness;
    dy = chartY - yPos + halfPlotBorderThickness;
    hovered = dx >= 0 && dx <= width + plotBorderThickness && dy >= 0 && dy <= height + plotBorderThickness;
    return {
      pointIndex: pX,
      hovered: hovered,
      pointObj: pointObj,
      component: dataset
    };
  }
  /**
   * This method handles all mouse events of an dataset.
   * @param {string} eventType    name of the event
   * @param {number} plotIndex    index of the plot where this event has been occured
   * @param {Event}  e            reference of the original mouse event
   */
  ;

  _proto._firePlotEvent = function _firePlotEvent(eventType, plotIndex, e) {
    var dataset = this,
        dataInfo = dataset.config.dataInfo,
        eventArgs = dataInfo[plotIndex] && dataInfo[plotIndex].eventArgs || {},
        chart = dataset.getFromEnv('chart'),
        coordiante = (0, _lib.getMouseCoordinate)(chart.getFromEnv('chart-container'), e, chart),
        validCoordinates = checkForValidCoordinated(coordiante),
        args = (0, _lib.extend2)(coordiante, eventArgs),
        env,
        linkClickFN,
        cancelHover = function cancelHover(c, a) {
      e.FusionChartsPreventEvent = true; // Hack for IE as the global event object gets overwritten
      // causing the FusionChartsPreventEvent to be UNDEF.
      // todo - rectify this commented code.

      /* if (isIE && a.toolText && lib.toolTip) {
        lib.toolTip.preventTooltip();
      } */
    };

    if (plotIndex !== _lib.UNDEF && validCoordinates) {
      switch (eventType) {
        case 'fc-mouseover':
          chart.fireChartInstanceEvent(ROLLOVER, args, _lib.UNDEF, _lib.UNDEF, cancelHover);
          break;

        case 'fc-mouseout':
          chart.fireChartInstanceEvent(ROLLOUT, args);
          break;

        case 'fc-click':
        case 'touchend':
        case 'mouseup':
          chart.fireChartInstanceEvent(CLICK, args); // when chart is getting disposed need to check if env is present

          env = chart.getFromEnv();
          linkClickFN = env && env.linkClickFN;
          args.link && linkClickFN && linkClickFN.call({
            link: args.link
          }, true);
          break;

        default:
          break;
      }
    }
  }
  /**
   * Function to set hover in effect
   * @param {number} indices data indices
   * @param {Boolean} isHovered boolean value representing whether dataset is hovered
   */
  ;

  _proto.setHoverInEffect = function setHoverInEffect(indices, isHovered) {
    var dataset = this,
        chart = dataset.getFromEnv('chart'),
        dataInfo = dataset.config.dataInfo,
        eventArgs;
    dataset.getFromEnv('animationManager').setAnimationState('mouseOver');

    if (!isHovered) {
      indices.forEach(function (index) {
        if (dataInfo[index]) {
          eventArgs = dataInfo[index].eventArgs;
          chart.fireChartInstanceEvent(HIGHLIGHT, eventArgs);
        }
      });
    }

    this.setData(isHovered ? this.getHoverInConfig(indices) : this.getHighlightConfig(indices), true);
  }
  /**
   * Function to set hover out effect
   * @param {number} indices data indices
   */
  ;

  _proto.setHoverOutEffect = function setHoverOutEffect(indices) {
    this.getFromEnv('animationManager').setAnimationState('mouseOut');
    this.setData(this.getHoverOutConfig(indices), true);
  }
  /**
   * returns the data plot indices which falls within the range
   * @param {Object} range min and max value range
   * @returns {Array} array of data points
   */
  ;

  _proto.getHighlightedIndices = function getHighlightedIndices(range) {
    var dataset = this,
        config = dataset.config,
        dataInfo = config.dataInfo,
        hightlightedPoints = []; // FTV3-1175: Highlighting plots falling inside the reference zone in range charts
    // Adding a check for ybase value of datapoint inside reference zone

    dataInfo.forEach(function (data, index) {
      if (data.yBase <= range.minValue && data.y >= range.maxValue) {
        hightlightedPoints.push(index);
      }
    });
    return hightlightedPoints;
  }
  /**
   * This function is used to make a dataset visible when clicked on its respective legend.
   */
  ;

  _proto.show = function show() {
    this.setData({
      'visibility': 'visible'
    }, true);
  }
  /**
   * This function is used to make a dataset hidden when clicked on its respective legend.
   */
  ;

  _proto.hide = function hide() {
    this.setData({
      'visibility': 'hidden'
    }, true);
  };

  _proto.isPlotPredictive = function isPlotPredictive(datum) {
    return datum.startDate >= this.config.prediction.dateMs;
  };

  _proto.parsePrediction = function parsePrediction(dataObject) {
    this.config.prediction = dataObject.prediction || this.config.prediction;
    this.parsePredictiveStyleAttributes();
  };

  _proto.parsePredictiveStyleAttributes = function parsePredictiveStyleAttributes() {
    var predictiveStyleAttributes = {},
        config = this.config;
    var predictiveStylePlot, predictiveStyleColumn;

    if (config.prediction.enabled) {
      predictiveStylePlot = config.prediction.style.plot;
      predictiveStyleColumn = config.prediction.style.column; // First copying all defaults

      Object.assign(predictiveStyleAttributes, config.defaultPredictedDataStyle); // Now overriding properties with properties provided in plot base

      Object.assign(predictiveStyleAttributes, predictiveStylePlot); // Now overriding properties with properties provided in column
      // A reason why column cannot be base class for all datasets

      Object.assign(predictiveStyleAttributes, predictiveStyleColumn);
    }

    predictiveStyleAttributes.predictiveOpacity = predictiveStyleAttributes.opacity;
    predictiveStyleAttributes.predictiveFillOpacity = predictiveStyleAttributes['fill-opacity'];
    predictiveStyleAttributes.predictiveStrokeOpacity = predictiveStyleAttributes['stroke-opacity'];
    delete predictiveStyleAttributes.opacity;
    delete predictiveStyleAttributes['fill-opacity'];
    delete predictiveStyleAttributes['stroke-opacity'];
    config.predictiveStyleAttributes = predictiveStyleAttributes || {};
  };

  return Column;
}(_smartRenderer.default);

var _default = Column;
exports["default"] = _default;

/***/ }),

/***/ 928:
/***/ ((__unused_webpack_module, exports) => {



exports.__esModule = true;
exports["default"] = void 0;

/**
 * Determines the clip path needs to be applied on basis of argument type
 * @param  {string} type   type of clip applied
 * @return {string}        the path to be used for clipping
 */
var getClip = function getClip(dataset, type) {
  var yScale = dataset.getFromEnv('yScale'),
      xScale = dataset.getFromEnv('xScale'),
      yAxisLimits = yScale.getDomain(),
      xAxisLimits = xScale.getDomain(),
      clipX = xScale.getRangeValue(xAxisLimits[0]),
      yMinPixel = yScale.getRangeValue(yAxisLimits[0]),
      yMaxPixel = yScale.getRangeValue(yAxisLimits[1]),
      height = yMinPixel - yMaxPixel,
      clipY = height < 0 ? yMinPixel : yMaxPixel,
      clipWidth = type === 'init' ? 0 : Math.abs(xScale.getRangeValue(xAxisLimits[1]) - clipX),
      clipHeight = Math.abs(height);
  return "M" + clipX + "," + clipY + "L" + (clipX + clipWidth) + "," + clipY + "L" + (clipX + clipWidth) + "," + (clipY + clipHeight) + "L" + clipX + "," + (clipY + clipHeight) + "Z";
};

var _default = {
  'initial.dataset.continuous': function initialDatasetContinuous() {
    var dataset = this;
    return {
      // Animating the group instead of the dataset paths in order to avoid
      // conflicts with the dataset's paths' clip-paths.
      'group.appearing': function groupAppearing() {
        return [{
          initialAttr: {
            'clip-path': getClip(dataset, 'init')
          },
          finalAttr: {
            'clip-path': getClip(dataset, 'canvas')
          },
          slot: 'middle'
        }];
      },
      '*': null
    };
  }
};
exports["default"] = _default;

/***/ }),

/***/ 907:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _defineProperty2 = _interopRequireDefault(__webpack_require__(273));

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _equals = _interopRequireDefault(__webpack_require__(845));

var _lib = __webpack_require__(274);

var _index = _interopRequireDefault(__webpack_require__(908));

var _dependencyManager = __webpack_require__(282);

var _libGraphics = __webpack_require__(278);

var _isValidNumber = _interopRequireDefault(__webpack_require__(856));

var _areaGenerator = _interopRequireDefault(__webpack_require__(914));

var _lineGenerator = _interopRequireDefault(__webpack_require__(917));

var _step = _interopRequireDefault(__webpack_require__(918));

var _linear = _interopRequireDefault(__webpack_require__(916));

var _monotone = _interopRequireDefault(__webpack_require__(919));

var _timeConverter = _interopRequireDefault(__webpack_require__(350));

var _column = _interopRequireDefault(__webpack_require__(920));

var _line = _interopRequireDefault(__webpack_require__(928));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var HOVERED_ANCHOR_RADIUS = 3.5,
    PLOT_HOVERED_ANCHOR_RADIUS = 5.5,
    DEFAULT_LINE_LENGTH = 10,
    DEFAULT_GAP_LENGTH = 5,
    CRISP_CONSTANT = 0.0625,
    NONE = 'none',
    DEFAULT_COLOR = '9194CC',
    VISIBLE = 'visible',
    SHOW = 'show',
    HIDE = 'hide',
    HIGHLIGHT = 'DataPlotHighlight',
    calculateMid = function calculateMid(a, b) {
  return (a + b) / 2;
},
    _reducerFn = function _reducerFn(s, t) {
  return Object.assign(s, t);
},

/**
 * If given a blank string, returns a valid path string by converting the
 * blank string to a M0,0 command. Otherwise, it assumes the the input path
 * string is valid and returns the input.
 *
 * @param {string} [pathString=''] The path string to be processed.
 *
 * @returns {string} The processed path string.
 */
unBlankify = function unBlankify(pathString) {
  if (pathString === void 0) {
    pathString = '';
  }

  return pathString === '' ? 'M0,0' : pathString;
},

/**
 * Attempts to 'crisp' the left and right edges of an input object with x, y,
 * width and height properties (i.e. a rectangle). Crisping is the act of
 * removing sub-pixel rendering artifacts by adjusting the edges by some
 * constant.
 *
 * @param {Object} rect The rectangle to be crisped.
 * @param {number} rect.x The co-ordinate of left edge of the rectangle.
 * @param {number} rect.y The co-ordinate of the top edge of the rectangle.
 * @param {number} rect.width The width of the rectangle.
 * @param {number} rect.height The height of the rectangle.
 *
 * @returns {Object} A crisped rectangle.
 */
crisper = function crisper(_ref) {
  var x = _ref.x,
      y = _ref.y,
      width = _ref.width,
      height = _ref.height;
  return {
    y: y,
    height: height,
    x: x - CRISP_CONSTANT,
    width: width + CRISP_CONSTANT * 2
  };
},

/**
 * Reduces a series of rectangle objects (i.e. objects with a x, y, width and
 * height) into a path string which visually correspond to exactly the same
 * series of rectangles.
 *
 * @param {string} acc The string into which the reducer will accumulate the
 * individual path strings
 * @param {Object} rect The rectangle to be reduced to its corresponding
 * path string
 * @param {number} rect.x The co-ordinate of left edge of the rectangle.
 * @param {number} rect.y The co-ordinate of the top edge of the rectangle.
 * @param {number} rect.width The width of the rectangle.
 * @param {number} rect.height The height of the rectangle.
 *
 * @returns {string} The input rectangle object, converted into a path string
 * and concatenated with the input accumulator.
 */
toPathRect = function toPathRect(acc, rect) {
  // FTV3-1076 Added padding to pathRect so that anchor points are rendered properly at the border
  var padding = 2;
  return acc + 'M' + rect.x + ',' + rect.y + 'L' + (rect.x + rect.width + padding) + ',' + rect.y + 'L' + (rect.x + rect.width + padding) + ',' + (rect.y + rect.height + padding) + 'L' + rect.x + ',' + (rect.y + rect.height + padding) + 'Z';
};

var maxRadius = 5,
    LINE = 'line',
    AREA = 'area',
    WHITE = '#ffffff',

/**
 * Function to check if the coordinate is inside the radius of the anchor
 * @param   {Object} pointObj The object containing the info about the data
 * point hovered
 * @param   {number} pX x-axis position of the mouse cordinate
 * @param   {number} x the chartX where hovered
 * @param   {number} y the chartY where hovered
 * @param   {String} component component hovered
 * @return {Object} return an object with details of nearest plot and whether
 * it is hovered or not
 */
isWithinShape = function isWithinShape(pointObj, pX, x, y, component) {
  var xPos, yPos, dx, dy, diff;

  if (!pointObj) {
    return {
      pointIndex: pX,
      hovered: false,
      component: component
    };
  }

  xPos = pointObj.x;
  yPos = pointObj.y;
  dx = x - xPos;
  dy = y - yPos; // Mathematical function to find a point inside a cirlce of given radius

  diff = Math.sqrt(Math.pow(dx, 2) + Math.pow(dy, 2));
  return {
    pointIndex: pX,
    hovered: diff <= maxRadius,
    pointObj: pointObj,
    component: component
  };
}; // helper function to get the generator depending on the type of dataset


function getGenerator(type) {
  switch (type) {
    case 'area':
    case 'smooth-area':
    case 'step-area':
      return _areaGenerator.default;

    case 'line':
    case 'smooth-line':
    case 'step-line':
    default:
      return _lineGenerator.default;
  }
} // helper function to get the curve generator class depending on the type of
// dataset


function getCurve(type) {
  switch (type) {
    case 'smooth-line':
    case 'smooth-area':
      return _monotone.default;

    case 'step-area':
    case 'step-line':
      return _step.default;

    case 'line':
    case 'area':
    default:
      return _linear.default;
  }
}

function isArea(type) {
  return type === 'area' || type === 'smooth-area' || type === 'step-area';
}

function isLine(type) {
  return type === 'line' || type === 'smooth-line' || type === 'step-line';
}

(0, _dependencyManager.addDep)({
  name: 'continuousAnimation',
  type: 'animationRule',
  extension: _line.default
});

var Line = /*#__PURE__*/function (_Column) {
  (0, _inheritsLoose2.default)(Line, _Column);

  function Line() {
    var _this;

    _this = _Column.call(this) || this;
    /**
     * returns the style which is to be applied on the hovered plot
     *
     * @param {Object} hoverIndices indices of hovered plots
     * @returns {Object} configuration
     * @memberof Column
     */

    _this.getHoverInConfig = function (hoverIndices, isDsHovered, isOtherDsHovered) {
      if (isOtherDsHovered === void 0) {
        isOtherDsHovered = false;
      }

      return {
        hoverIndices: hoverIndices,
        hovered: true,
        radius: isDsHovered ? PLOT_HOVERED_ANCHOR_RADIUS : HOVERED_ANCHOR_RADIUS,
        isDsHovered: isDsHovered,
        isOtherDsHovered: isOtherDsHovered
      };
    };
    /**
     * returns the style which is to be applied on the hovered out plot
     *
     * @param {Object} hoverIndices indices of hovered out plots
     * @returns {Object} configuration
     * @memberof Column
     */


    _this.getHoverOutConfig = function (hoverIndices) {
      return {
        hoverIndices: hoverIndices,
        hovered: false
      };
    };

    return _this;
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */


  var _proto = Line.prototype;

  _proto.getName = function getName() {
    return 'continuous';
  }
  /**
   * returns the data plot indices which falls within the range
   * @param {Object} range min and max value range
   * @returns {Array} array of data points
   */
  ;

  _proto.getHighlightedIndices = function getHighlightedIndices(range) {
    var dataset = this,
        config = dataset.config,
        dataInfo = config.dataInfo,
        hightlightedPoints = [];
    dataInfo.forEach(function (data, index) {
      if (data.y <= range.minValue && data.y >= range.maxValue) {
        hightlightedPoints.push(index);
      }
    });
    return hightlightedPoints;
  };

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    _Column.prototype.__setDefaultConfig.call(this);

    var config = this.config;
    config['default-stroke'] = DEFAULT_COLOR;
    config['default-fill'] = DEFAULT_COLOR;
    config['default-anchor-stroke'] = (0, _libGraphics.convertColor)(WHITE);
    config.type = LINE;
    config.plotStyle = {};
    config.nullPlotStyle = {};
    config.linePlotStyle = {};
    config.nullLinePlotStyle = {};
    config.areaPlotStyle = {};
    config.nullAreaPlotStyle = {};
    config.anchorStyle = {};
    config.anchorHoverInStyle = {};
    config.anchorHoverOutStyle = {};
    config.anchorHighlightObj = {};
    config.defaultLineStyle = {
      'stroke-opacity': 1,
      'stroke-width': 2,
      'stroke-dasharray': 'none',
      'fill': 'none'
    };
    config.defaultNullLineStyle = {
      'stroke-opacity': 1,
      'stroke-width': 2,
      'stroke-dasharray': [DEFAULT_LINE_LENGTH, DEFAULT_GAP_LENGTH],
      'fill': 'none'
    };
    config.defaultLinePredictiveStyle = {
      'stroke-opacity': 1,
      'stroke-width': 1,
      'stroke-dasharray': 5,
      'fill': 'none'
    };
    config.defaultAreaStyle = {
      'stroke-opacity': 1,
      'stroke-width': 0,
      'fill-opacity': 0.6
    };
    config.defaultNullAreaStyle = {
      'stroke-opacity': 1,
      'stroke-width': 0,
      'fill-opacity': 0.3
    };
    config.defaultAreaPredictiveStyle = {
      'stroke-opacity': 1,
      'opacity': 0.5
    };
    config.defaultAnchorStyle = {
      'fill-opacity': 1,
      'stroke-width': 1
    };
    config.willInjectNulls = true;
  }
  /**
   * Function to configure the cosmemtics of the plots
   */
  ;

  _proto.configureAttributes = function configureAttributes(dataObj) {
    var _this2 = this;

    var config = this.config,
        id = this.getId(),
        getStyleDef = this.getFromEnv('getStyleDef');
    var isNullAndNonNullStylesSame = true; // Setting the given configurations

    if (dataObj.hasOwnProperty('hoverIndices')) {
      // if a particular anchor is to be shown, enable it's showAnchor property
      if (dataObj.hovered) {
        config.mode = SHOW;
        config.sharedAnchorIndices = dataObj.hoverIndices;
      } else {
        config.mode = HIDE; // Storing infor for hiding the previously shown anchor

        config.hideIndices = config.lastShownIndices;
      }

      config.radius = dataObj.radius;
      config.isDsHovered = dataObj.isDsHovered;
      config.isOtherDsHovered = dataObj.isOtherDsHovered;
      config.hoverMode = true;
    } else {
      Object.entries(dataObj).forEach(function (_ref2) {
        var prop = _ref2[0],
            val = _ref2[1];

        if (prop === 'primaryColor') {
          _this2.parsePrediction(dataObj);

          var primaryColor = val,
              plotConfig = dataObj.plotCosmetics,
              genericConfig = dataObj.genericCosmetics,
              styleConfig = dataObj.styleConfig,
              dsType = dataObj.type,
              plotStyleObj = config.plotStyle,
              styleObj = config.style,
              predictivePlotStyleObj = config.predictiveStyleAttributes,
              nullPlotStyleObj = config.nullPlotStyle,
              linePlotStyleObj = config.linePlotStyle,
              predictiveStyleAttributesLine = config.predictiveStyleAttributesLine,
              predictiveStyleAttributesArea = config.predictiveStyleAttributesArea,
              nullLinePlotStyleObj = config.nullLinePlotStyle,
              areaPlotStyleObj = config.areaPlotStyle,
              nullAreaPlotStyleObj = config.nullAreaPlotStyle,
              anchorStyleObj = config.anchorStyle,
              anchorHoverInStyleObj = config.anchorHoverInStyle,
              anchorHighlightObj = config.anchorHighlightObj,
              applicableClassStyleGeneric = getStyleDef(genericConfig.style && genericConfig.style.plot),
              applicableClassStyleGenericNull = getStyleDef(genericConfig.style && genericConfig.style['plot.null']),
              applicableClassStyleGenericHover = getStyleDef(genericConfig.style && genericConfig.style['plot:hover']),
              applicableClassStyleGenericHighlight = getStyleDef(genericConfig.style && genericConfig.style['plot:highlight']),
              applicableClassStyleGenericLine = getStyleDef(genericConfig.style && genericConfig.style.line),
              applicableClassStyleGenericLineNull = getStyleDef(genericConfig.style && genericConfig.style['line.null']),
              applicableClassStyleGenericArea = getStyleDef(genericConfig.style && genericConfig.style.area),
              applicableClassStyleGenericAreaNull = getStyleDef(genericConfig.style && genericConfig.style['area.null']),
              applicableClassStyleGenericAnchor = getStyleDef(genericConfig.style && genericConfig.style.anchor),
              applicableClassStyleGenericAnchorHover = getStyleDef(genericConfig.style && genericConfig.style['anchor:hover']),
              applicableClassStyleGenericAnchorHighlight = getStyleDef(genericConfig.style && genericConfig.style['anchor:highlight']),
              applicableClassStyleSpecific = getStyleDef(plotConfig.style && plotConfig.style.plot),
              applicableClassStyleSpecificNull = getStyleDef(plotConfig.style && plotConfig.style['plot.null']),
              applicableClassStyleSpecificPredictive = getStyleDef(plotConfig.style && plotConfig.style['plot.predictive']),
              applicableClassStyleSpecificHover = getStyleDef(plotConfig.style && plotConfig.style['plot:hover']),
              applicableClassStyleSpecificHighlight = getStyleDef(plotConfig.style && plotConfig.style['plot:highlight']),
              applicableClassStyleSpecificLine = getStyleDef(plotConfig.style && plotConfig.style.line),
              applicableClassStyleSpecificLineNull = getStyleDef(plotConfig.style && plotConfig.style['line.null']),
              applicableClassStyleSpecificLinePredictive = getStyleDef(plotConfig.style && plotConfig.style['line.predictive']),
              applicableClassStyleSpecificArea = getStyleDef(plotConfig.style && plotConfig.style.area),
              applicableClassStyleSpecificAreaNull = getStyleDef(plotConfig.style && plotConfig.style['area.null']),
              applicableClassStyleSpecificAreaPredictive = getStyleDef(plotConfig.style && plotConfig.style['area.predictive']),
              applicableClassStyleSpecificAnchor = getStyleDef(plotConfig.style && plotConfig.style.anchor),
              applicableClassStyleSpecificAnchorHover = getStyleDef(plotConfig.style && plotConfig.style['anchor:hover']),
              applicableClassStyleSpecificAnchorHighlight = getStyleDef(plotConfig.style && plotConfig.style['anchor:highlight']),
              applicableInlineStyle = getStyleDef(styleConfig.plot),
              applicableInlineStyleNull = getStyleDef(styleConfig['plot.null']),
              applicableInlineStylePredictive = getStyleDef(styleConfig['plot.predictive']),
              applicableInlineStyleHover = getStyleDef(styleConfig['plot:hover']),
              applicableInlineStyleHighlight = getStyleDef(styleConfig['plot:highlight']),
              applicableInlineStyleLine = getStyleDef(styleConfig.line),
              applicableInlineStyleLineNull = getStyleDef(styleConfig['line.null']),
              applicableInlineStyleLinePredictive = getStyleDef(styleConfig['line.predictive']),
              applicableInlineStyleArea = getStyleDef(styleConfig.area),
              applicableInlineStyleAreaNull = getStyleDef(styleConfig['area.null']),
              applicableInlineStyleAreaPredictive = getStyleDef(styleConfig['area.predictive']),
              applicableInlineStyleAnchor = getStyleDef(styleConfig.anchor),
              applicableInlineStyleAnchorHover = getStyleDef(styleConfig['anchor:hover']),
              applicableInlineStyleAnchorHighlight = getStyleDef(styleConfig['anchor:highlight']); // config.defaultLineStyle['stroke-linecap'] = isArea(dsType)
          // ? 'round'
          // : 'round';

          config.defaultLineStyle['stroke-linecap'] = 'round';
          config.defaultNullLineStyle['stroke-linecap'] = isArea(dsType) ? 'butt' : 'round';
          config.defaultLinePredictiveStyle['stroke-linecap'] = isArea(dsType) ? 'butt' : 'round';
          [linePlotStyleObj, config.defaultLineStyle, applicableClassStyleGeneric, applicableClassStyleGenericLine, applicableInlineStyle, applicableClassStyleSpecific, applicableClassStyleSpecificLine, applicableInlineStyleLine].reduce(_reducerFn);
          [nullLinePlotStyleObj, config.defaultNullLineStyle, applicableClassStyleGenericNull, applicableClassStyleGenericLineNull, applicableInlineStyleNull, applicableClassStyleSpecificNull, applicableClassStyleSpecificLineNull, applicableInlineStyleLineNull].reduce(_reducerFn);
          [predictiveStyleAttributesLine, applicableInlineStylePredictive, applicableClassStyleSpecificPredictive, applicableClassStyleSpecificLinePredictive, applicableInlineStyleLinePredictive].reduce(_reducerFn);
          [areaPlotStyleObj, config.defaultAreaStyle, applicableClassStyleGeneric, applicableClassStyleGenericArea, applicableInlineStyle, applicableClassStyleSpecific, applicableClassStyleSpecificArea, applicableInlineStyleArea].reduce(_reducerFn);
          [nullAreaPlotStyleObj, config.defaultNullAreaStyle, applicableClassStyleGenericNull, applicableClassStyleGenericAreaNull, applicableInlineStyleNull, applicableClassStyleSpecificNull, applicableClassStyleSpecificAreaNull, applicableInlineStyleAreaNull].reduce(_reducerFn);
          [predictiveStyleAttributesArea, applicableInlineStylePredictive, applicableClassStyleSpecificPredictive, applicableClassStyleSpecificAreaPredictive, applicableInlineStyleAreaPredictive].reduce(_reducerFn);
          [anchorStyleObj, config.defaultAnchorStyle, applicableClassStyleGeneric, applicableClassStyleGenericAnchor, applicableInlineStyle, applicableClassStyleSpecific, applicableClassStyleSpecificAnchor, applicableInlineStyleAnchor].reduce(_reducerFn); // Applying primaryColor to stroke and fill
          // When area fill is taken only from primary color.
          // When line stroke is taken only from primary color

          plotStyleObj.fill = areaPlotStyleObj.fill = (0, _libGraphics.convertColor)((0, _lib.pluck)(primaryColor, config['default-fill']), areaPlotStyleObj['fill-opacity'] * 100);
          styleObj.fill = (0, _libGraphics.convertColor)((0, _lib.pluck)(primaryColor, config['default-stroke']), styleObj['fill-opacity'] * 100); // Same for null plots

          nullPlotStyleObj.fill = nullAreaPlotStyleObj.fill = (0, _libGraphics.convertColor)((0, _lib.pluck)(nullAreaPlotStyleObj.fill, primaryColor, config['default-fill']), nullAreaPlotStyleObj['fill-opacity'] * 100); // For predictive plots

          predictivePlotStyleObj.fill = predictiveStyleAttributesArea.fill = (0, _libGraphics.convertColor)((0, _lib.pluck)(predictiveStyleAttributesArea.fill, primaryColor, config['default-fill']), predictiveStyleAttributesArea['fill-opacity'] * 100); // line should not take fill even if user gives it, as it connects
          // terminal points and become a different shape.

          linePlotStyleObj.fill = NONE; // same for null plots

          nullLinePlotStyleObj.fill = NONE; // same for predictive plots

          predictiveStyleAttributesLine.fill = NONE;
          styleObj.stroke = (0, _libGraphics.convertColor)((0, _lib.pluck)(primaryColor, config['default-stroke']), styleObj['stroke-opacity'] * 100);
          areaPlotStyleObj.stroke = (0, _libGraphics.convertColor)((0, _lib.pluck)(primaryColor, config['default-stroke']), areaPlotStyleObj['stroke-opacity'] * 100);
          nullAreaPlotStyleObj.stroke = (0, _libGraphics.convertColor)((0, _lib.pluck)(nullAreaPlotStyleObj.stroke, primaryColor, config['default-stroke']), nullAreaPlotStyleObj['stroke-opacity'] * 100);
          predictiveStyleAttributesArea.stroke = (0, _libGraphics.convertColor)((0, _lib.pluck)(predictiveStyleAttributesArea.stroke, primaryColor, config['default-stroke']), predictiveStyleAttributesArea['stroke-opacity'] * 100);
          linePlotStyleObj.stroke = (0, _libGraphics.convertColor)((0, _lib.pluck)(primaryColor, config['default-stroke']), linePlotStyleObj['stroke-opacity'] * 100);
          nullLinePlotStyleObj.stroke = (0, _libGraphics.convertColor)((0, _lib.pluck)(nullLinePlotStyleObj.stroke, primaryColor, config['default-stroke']), nullLinePlotStyleObj['stroke-opacity'] * 100);
          predictiveStyleAttributesLine.stroke = (0, _libGraphics.convertColor)((0, _lib.pluck)(predictiveStyleAttributesLine.stroke, primaryColor, config['default-stroke']), predictiveStyleAttributesLine['stroke-opacity'] * 100);
          plotStyleObj.stroke = isArea(dsType) ? areaPlotStyleObj.stroke : linePlotStyleObj.stroke;
          nullPlotStyleObj.stroke = isArea(dsType) ? nullAreaPlotStyleObj.stroke : nullLinePlotStyleObj.stroke;
          predictivePlotStyleObj.stroke = isArea(dsType) ? predictiveStyleAttributesArea.stroke : predictiveStyleAttributesLine.stroke; // Applying primaryColor to stroke and fill

          anchorStyleObj.fill = (0, _libGraphics.convertColor)((0, _lib.pluck)(primaryColor, config['default-stroke']));
          anchorStyleObj.stroke = config['default-anchor-stroke'];
          [// styleObj,
          anchorHoverInStyleObj, anchorStyleObj, applicableClassStyleGenericHover, applicableClassStyleGenericAnchorHover, applicableClassStyleSpecificHover, applicableInlineStyleHover, applicableClassStyleSpecificAnchorHover, applicableInlineStyleAnchorHover].reduce(_reducerFn);
          [anchorHighlightObj, anchorStyleObj, applicableClassStyleGenericHighlight, applicableClassStyleGenericAnchorHighlight, applicableClassStyleSpecificHighlight, applicableInlineStyleHighlight, applicableClassStyleSpecificAnchorHighlight, applicableInlineStyleAnchorHighlight].reduce(_reducerFn); // Parsing the hoverOut styles from hover style and highlight style

          Object.keys(Object.assign(Object.assign({}, anchorHoverInStyleObj), anchorHighlightObj)).forEach(function (styles) {
            config.anchorHoverOutStyle[styles] = anchorStyleObj[styles] || '';
          }); // If no highlight style is given at any level then set highlight
          // styles to hover out styles.

          if (!Object.keys(anchorHighlightObj).length) {
            anchorHighlightObj = config.anchorHighlightObj = (0, _lib.extend2)({}, config.anchorHoverOutStyle);
          }

          config.connectNullData = (0, _lib.pluckNumber)(config.connectNullData, plotConfig.connectnulldata, genericConfig.connectnulldata, 0); // Applied individually in stroke and fill

          delete areaPlotStyleObj['fill-opacity'];
          delete nullAreaPlotStyleObj['fill-opacity'];
          delete areaPlotStyleObj['stroke-opacity'];
          delete nullAreaPlotStyleObj['stroke-opacity'];
          delete linePlotStyleObj['stroke-opacity'];
          delete nullLinePlotStyleObj['stroke-opacity'];
          delete config.predictiveStyleAttributesArea['fill-opacity'];
          delete config.predictiveStyleAttributesArea['stroke-opacity'];
          delete config.predictiveStyleAttributesLine['stroke-opacity'];
        } else {
          config[prop] = val;
        }
      }); // If we are not supposed to use different null styles (e.g. if the
      // dataset is being represented in the time navigator), make the null
      // and non-null styles the same

      if (!config.useNullStyles) {
        // Not deep copying here since the style objects are expected to be
        // at most one level deep. Instead, simply using Object.assign to break
        // the reference to the non-null styles
        config.nullAreaPlotStyle = Object.assign({}, config.areaPlotStyle);
        config.nullLinePlotStyle = Object.assign({}, config.linePlotStyle);
      } // Null and non null styles are same if BOTH the line's null and
      // non-null styles AND the area's null and non-null styles match


      isNullAndNonNullStylesSame = (0, _equals.default)(config.areaPlotStyle, config.nullAreaPlotStyle) && (0, _equals.default)(config.linePlotStyle, config.nullLinePlotStyle); // Even if null data is to be connected, nulls should NOT be injected if
      // the null and non-null styles are same.
      // Why? Because if the styles are the same and we still inject nulls,
      // a banding/striation effect appears on the rendered paths due to
      // sub-pixel aliasing effects on adjacent clip paths.

      if (config.connectNullData && isNullAndNonNullStylesSame) {
        config.willInjectNulls = false;
      } else {
        // If null data is to not be connected and the null and non null styles
        // are different, nulls should be injected into the data so that the
        // generated line paths appear 'broken'
        config.willInjectNulls = true;
      }

      var chart = this.getFromEnv('chart');
      config.limit = this._calculateLimits();
      chart.setYScaleLimit(config.scaleY.getId(), id, config.limit.y, config.limit.baseRequired);
      chart.setXScaleLimit(config.scaleX.getId(), id, config.limit.x);
    }
  };

  _proto.parsePrediction = function parsePrediction(dataObject) {
    this.config.prediction = dataObject.prediction || this.config.prediction;
    this.parsePredictiveStyleAttributes();
  };

  _proto.parsePredictiveStyleAttributes = function parsePredictiveStyleAttributes() {
    var predictiveStyleAttributes = {},
        config = this.config;
    config.predictiveStyleAttributesLine = {};
    config.predictiveStyleAttributesArea = {};

    if (config.prediction.enabled) {
      Object.assign(predictiveStyleAttributes, config.prediction.style.plot);
      Object.assign(config.predictiveStyleAttributesLine, config.defaultLinePredictiveStyle, config.prediction.style.plot, config.prediction.style.line);
      Object.assign(config.predictiveStyleAttributesArea, config.defaultAreaPredictiveStyle, config.prediction.style.plot, config.prediction.style.area);
    }

    config.predictiveStyleAttributes = predictiveStyleAttributes;
  } // Method to get padding in data limits
  ;

  _proto.getPadding = function getPadding() {
    var dataset = this,
        canvasConfig = dataset.getLinkedParent().config,
        config = dataset.config,
        anchorPadding,
        dataMarkerPadding;
    anchorPadding = dataset.getValueFromPx(PLOT_HOVERED_ANCHOR_RADIUS);
    dataMarkerPadding = canvasConfig.enableMarkers ? dataset.getValueFromPx(config.dataMarkerPadding) : 0;
    return Math.ceil(Math.max(anchorPadding, dataMarkerPadding));
  }
  /**
   * Helper function of data markers
   * @return {Object} contains positioning info and the dataInfo
   */
  ;

  _proto._getRelevantInfo = function _getRelevantInfo() {
    var config = this.config;
    return {
      firstTimeStamp: config.firstTimeStamp,
      timeStampGap: config.timeStampGap,
      dataInfo: config.dataInfo,
      fill: config.plotStyle.stroke
    };
  }
  /**
   * Function to allocation the position of the dataplots
   */
  ;

  _proto.allocatePosition = function allocatePosition() {
    var dataset = this,
        config = dataset.config,
        _config$indices = config.indices,
        xIdx = _config$indices[0],
        yIdx = _config$indices[1],
        baseIdx = _config$indices[2],
        totalStackSum = _config$indices[3],
        seriesInfo = config.seriesInfo,
        dateColumn = dataset.getFromEnv('dateColumn'),
        isUTC = dataset.getFromEnv('UTC'),
        dsType = config.type,
        data = config.data,
        dataInfo = config.dataInfo,
        dataInfoNull = [],
        dataObj,
        binDecider = dataset.getFromEnv('binDecider'),
        xScale = dataset.getFromEnv('xScale'),
        yScale = dataset.getFromEnv('yScale'),
        xThresholdDuration = binDecider.getRangeThreshold()[2],
        nullClipAdjustment = Number.parseFloat(config.nullLinePlotStyle['stroke-width']),
        predictionClipAdjustment = Number.parseFloat(config.predictiveStyleAttributesLine['stroke-width']),
        clipAdjustment = Number.parseFloat(config.linePlotStyle['stroke-width']),
        pathGenerator,
        startDate,
        endDate,
        midDate,
        nextData,
        nextMidDate,
        yValue,
        pX,
        base,
        y,
        yBaseValue,
        paddingInTimestamp,
        dataLen = data.length,
        _xScale$getDomain = xScale.getDomain(),
        startDomain = _xScale$getDomain[0],
        endDomain = _xScale$getDomain[1],
        bins = xScale.bins,
        i,
        len,
        xValue,
        duration,
        eventArgs,
        seriesName,
        format = dateColumn.format,
        formatter = isUTC ? _timeConverter.default.utcFormatter(format) : _timeConverter.default.formatter(format),
        isPlotOverTick = xScale.showPlotOverTick(); // Storing the 1st time stam


    config.firstTimeStamp = data && data[0] && data[0][xIdx] && data[0][xIdx].start;

    if (config.repositioningDone = dataset._isRepositioningNeeded()) {
      // skip drawing if dataset is not visible
      if (config.visibility !== 'visible') {
        return;
      }

      dataInfo = config.dataInfo = []; // Store data related operations

      config.timeStampGap = xThresholdDuration;
      config.availableWidth = 0; // Storing info for dataMarker detection

      for (i = 0, len = bins.length; i < len; i++) {
        if (bins[i].clipType !== 2) {
          config.availableWidth = xScale.getRangeValue(bins[i].end) - xScale.getRangeValue(bins[i].start);
          break;
        }
      }

      paddingInTimestamp = +xScale.getDomainValue(PLOT_HOVERED_ANCHOR_RADIUS) - +xScale.getDomainValue(0); // Storing value for tooltip

      config.actualStartDomain = +startDomain - paddingInTimestamp; // Actual end domain is the scale domain minus the space taken up by the
      // plotspacepercent

      config.actualEndDomain = +endDomain + paddingInTimestamp; // Storing the x and y for plotting the data which is later used for
      // tooltip detection

      data.forEach(function (d, index, dataArr) {
        xValue = d[xIdx];
        yValue = d[yIdx];
        duration = xValue.config.duration;
        startDate = xValue.start;
        endDate = xValue.end;

        if (!isUTC) {
          var tempDate = new Date(startDate),
              winterOffset = new Date(tempDate.getFullYear(), 0).getTimezoneOffset(),
              summerOffset = new Date(tempDate.getFullYear(), 6).getTimezoneOffset(); // In case of daylight-saving update the start date

          if (winterOffset > summerOffset) {//  startDate = timeHour.offset(startDate, 1);
          }
        }

        midDate = calculateMid(startDate, endDate);
        nextData = dataArr[index + 1];
        yBaseValue = d[baseIdx];

        if (Math.abs(yBaseValue) > Math.abs(yValue)) {
          // FTV3-1076 swapping values of yValue and yBaseValue.
          // generally yValue and yBaseValue should be present at indices yIdx and baseIdx respectively
          // but in certain cases they are present in baseIdx and yIdx respectively
          // this swap is to handle the above cases.
          yValue = d[baseIdx];
          yBaseValue = d[yIdx];
        }

        base = yScale.getRangeValue(yBaseValue || Math.max(yScale.getDomain()[0], 0));
        y = yScale.getRangeValue(yValue); // Storing the 1st time stamp

        if (!index) {
          config.firstTimeStamp = startDate;
        }

        if (dsType === AREA && !(0, _isValidNumber.default)(base)) {
          return;
        }

        if ((0, _isValidNumber.default)(yValue) && (0, _isValidNumber.default)(y)) {
          // Get the data index corresponding to the fetched timeStamp
          pX = xScale.getBinIndex(startDate);
          dataObj = {
            startDate: startDate,
            endDate: endDate,
            timeInstant: isPlotOverTick ? startDate : midDate,
            value: yValue,
            paddingInTimestamp: paddingInTimestamp,
            yBaseValue: dsType === AREA ? yBaseValue : _lib.UNDEF,
            x: xScale.getRangeValue(new Date(startDate), new Date(endDate)),
            endXPosition: xScale.getRangeValue(new Date(startDate), new Date(endDate)),
            totalStackSum: (0, _lib.defined)(d[totalStackSum]) ? d[totalStackSum] : _lib.UNDEF,
            y: y,
            base: base
          };
          eventArgs = {
            index: index,
            dataValue: yValue,
            start: startDate,
            startText: formatter.format(startDate),
            end: endDate,
            endText: formatter.format(endDate),
            binUnit: duration.Unit,
            binMultiplier: duration.number,
            plotType: config.type,
            timeFormatter: format,
            aggregation: config.aggregation,
            measure: config.measures[0],
            binValue: yValue,
            binValueFormatted: config.formatterFn && config.formatterFn({
              value: yValue,
              type: 'tooltip',
              prefix: config.prefix,
              suffix: config.suffix
            })
          };
          seriesName = Object.keys(seriesInfo)[0];

          if (seriesName) {
            eventArgs.series = seriesName;
            eventArgs.seriesValue = seriesInfo[seriesName];
          }

          dataObj.eventArgs = eventArgs;
          dataInfo[pX] = dataObj; // Storing metadata

          if (nextData) {
            var nextPX = xScale.getBinIndex(nextData[xIdx].start);
            dataInfoNull.push(dataObj);
            nextMidDate = calculateMid(nextData[xIdx].start, nextData[xIdx].end); // Pushing null if the gap between 2 consequtive data is more than
            // the threshold handling the uneven number of days in each month
            // with the 1.5 multiplier

            if (config.willInjectNulls && nextMidDate - midDate - (xScale.clips[nextPX] - xScale.clips[pX]) > xThresholdDuration * 1.5) {
              dataInfoNull.push(null);
            }
          } else if (dataLen - index === 1) {
            // For the last data
            dataInfoNull.push(dataObj);
          }
        } else if (config.willInjectNulls) {
          // when value is not present, insert null to show gaps in data
          dataInfoNull.push(null);
        }
      });
      pathGenerator = new _index.default(getGenerator(dsType)).setConnectUndefineds(config.connectNullData).setChunks({
        def: {
          clipAdjustment: clipAdjustment
        },
        undef: {
          clipAdjustment: nullClipAdjustment
        },
        predictive: {
          clipAdjustment: predictionClipAdjustment
        }
      }) // Uncomment to create a line instead of a smooth line
      .setCurve(getCurve(dsType)) // Below function determines what will happen incase of null data
      .setDefined(function (d) {
        return !!d;
      }).setChunkDecider(function (d) {
        return d.startDate >= config.prediction.dateMs ? 'predictive' : 'def';
      }) // Below function determines the x location of the plot
      .setXAccessor(function (d) {
        return d.x;
      }) // Below function determines the y location of the plot
      .setYAccessor(function (d) {
        return d.y;
      }); // applicable only for area charts.

      if (isArea(dsType)) {
        // Below function determines the y base location of the plot
        pathGenerator.setYBaseAccessor(function (d) {
          return d.base;
        });
      } // Below function generates the path


      config.chunks = pathGenerator.generate(dataInfoNull);
      config.path = unBlankify(config.chunks.def.path);
      config.clipPath = unBlankify(config.chunks.def.clipRects.map(crisper).reduce(toPathRect, ''));
      config.nullPath = unBlankify(config.chunks.undef.path);
      config.nullClipPath = unBlankify(config.chunks.undef.clipRects.map(crisper).reduce(toPathRect, ''));
      config.predictivePath = unBlankify(config.chunks.predictive.path);
      config.predictiveClipPath = unBlankify(config.chunks.predictive.clipRects.map(crisper).reduce(toPathRect, ''));

      if (isArea(dsType)) {
        // Below function generates only the top path
        config.topChunks = pathGenerator.getLineChunkerYTop().generate(dataInfoNull);
        config.topPath = unBlankify(config.topChunks.def.path);
        config.topClipPath = unBlankify(config.topChunks.def.clipRects.map(crisper).reduce(toPathRect, ''));
        config.topNullPath = unBlankify(config.topChunks.undef.path);
        config.topNullClipPath = unBlankify(config.topChunks.undef.clipRects.map(crisper).reduce(toPathRect, ''));
        config.topPredictivePath = unBlankify(config.topChunks.predictive.path);
        config.topPredictiveClipPath = unBlankify(config.topChunks.predictive.clipRects.map(crisper).reduce(toPathRect, ''));
      }
    }
  }
  /**
   * Funtion that determines if tooltext is possible for the current data
   * @param {Object} currData contains info about the current hovered index
   */
  ;

  _proto._isInvalidTooltext = function _isInvalidTooltext(currData) {
    var dataset = this,
        config = dataset.config; // Checking the data's mid date to be inside the range of the visbible axis

    if (!currData || currData.timeInstant < config.actualStartDomain || currData.timeInstant > config.actualEndDomain) {
      return true;
    }
  }
  /**
   * Function to draw the line plot
   */
  ;

  _proto._drawPlot = function _drawPlot() {
    var dataset = this,
        config = dataset.config,
        linePlotStyleObj = _objectSpread(_objectSpread({}, config.linePlotStyle), {}, {
      fill: 'none'
    }),
        areaPlotStyleObj = config.areaPlotStyle,
        nullLinePlotStyleObj = _objectSpread(_objectSpread({}, config.nullLinePlotStyle), {}, {
      fill: 'none'
    }),
        nullAreaPlotStyleObj = config.nullAreaPlotStyle,
        predictiveStyleAttributesLine = _objectSpread(_objectSpread({}, config.predictiveStyleAttributesLine), {}, {
      fill: 'none'
    }),
        predictiveStyleAttributesArea = config.predictiveStyleAttributesArea,
        dataInfo = config.dataInfo,
        data; // dataset meso parent group


    dataset.addGraphicalElement({
      el: 'group',
      container: {
        id: 'meso',
        label: 'group'
      },
      component: dataset,
      label: 'group',
      id: 'meso-line',
      attr: {
        name: 'line-common-meso',
        visibility: config.visibility
      }
    }); // dataset thermo parent group

    dataset.addGraphicalElement({
      el: 'group',
      container: {
        id: 'thermo',
        label: 'group'
      },
      component: dataset,
      label: 'group',
      id: 'thermo-line',
      attr: {
        name: 'line-common-thermo',
        visibility: config.visibility
      }
    }); // Meso group for line path plot

    dataset.addGraphicalElement({
      el: 'group',
      container: {
        id: 'meso-line',
        label: 'group'
      },
      component: dataset,
      label: 'group',
      id: 'meso-plot',
      attr: {
        name: 'line-plot-meso',
        visibility: config.visibility
      }
    }, true); // Thermo group for line path plot

    dataset.addGraphicalElement({
      el: 'group',
      container: {
        id: 'thermo-line',
        label: 'group'
      },
      component: dataset,
      label: 'group',
      id: 'thermo-plot',
      attr: {
        name: 'line-plot-thermo',
        visibility: config.visibility
      }
    }, true); // Group for anchor (thermo)
    // As anchors should drawn on top of area path

    dataset.addGraphicalElement({
      el: 'group',
      container: {
        id: 'thermo-line',
        label: 'group'
      },
      component: dataset,
      label: 'group',
      id: 'thermo-anchor',
      attr: {
        name: 'line-anchor-thermo',
        visibility: config.visibility
      }
    }, true);

    if (config.connectNullData) {
      // drawing null area fill/line path in meso-plot group
      dataset.addGraphicalElement({
        el: 'path',
        container: {
          label: 'group',
          id: 'meso-plot'
        },
        attr: Object.assign({
          path: config.nullPath,
          'clip-path': config.nullClipPath
        }, isLine(config.type) ? nullLinePlotStyleObj : nullAreaPlotStyleObj),
        label: 'path',
        component: dataset
      }, true);
    } // drawing area fill/line path in meso-plot group


    dataset.addGraphicalElement({
      el: 'path',
      container: {
        label: 'group',
        id: 'meso-plot'
      },
      attr: Object.assign({
        path: config.path,
        'clip-path': config.clipPath
      }, isLine(config.type) ? linePlotStyleObj : areaPlotStyleObj),
      label: 'path',
      component: dataset
    }, true);

    if (config.prediction.enabled) {
      // drawing null area fill/line path in meso-plot group
      dataset.addGraphicalElement({
        el: 'path',
        container: {
          label: 'group',
          id: 'meso-plot'
        },
        attr: Object.assign({
          path: config.predictivePath,
          'clip-path': config.predictiveClipPath
        }, isLine(config.type) ? predictiveStyleAttributesLine : predictiveStyleAttributesArea),
        label: 'path',
        component: dataset
      }, true);
    } // draw the top path of dataset in thermo group.


    if (config.topPath) {
      if (config.connectNullData) {
        dataset.addGraphicalElement({
          el: 'path',
          container: {
            label: 'group',
            id: 'thermo-plot'
          },
          attr: Object.assign({
            path: config.topNullPath,
            'clip-path': config.topNullClipPath
          }, nullLinePlotStyleObj),
          label: 'topPath',
          component: dataset
        }, true);
      }

      dataset.addGraphicalElement({
        el: 'path',
        container: {
          label: 'group',
          id: 'thermo-plot'
        },
        attr: Object.assign({
          path: config.topPath,
          'clip-path': config.topClipPath
        }, linePlotStyleObj),
        label: 'topPath',
        component: dataset
      }, true);

      if (config.prediction.enabled) {
        // drawing predictive area fill/line path in meso-plot group
        dataset.addGraphicalElement({
          el: 'path',
          container: {
            label: 'group',
            id: 'meso-plot'
          },
          attr: Object.assign({
            path: config.topPredictivePath,
            'clip-path': config.topPredictiveClipPath
          }, predictiveStyleAttributesLine),
          label: 'path',
          component: dataset
        }, true);
      }
    }

    if (config.mode === 'show') {
      // Only draw the anchors whose showAnchor property are enabled
      // by default only the anchor on which mouse is hovered will be shown
      if (config.sharedAnchorIndices && config.sharedAnchorIndices.length) {
        config.sharedAnchorIndices.forEach(function (index) {
          data = dataInfo[index];
          config.lastShownIndices = config.sharedAnchorIndices;
          data && !isNaN(data.value) && dataset.addGraphicalElement({
            el: 'path',
            container: {
              label: 'group',
              id: 'thermo-anchor'
            },
            attr: Object.assign({
              path: (0, _lib.polyPathToPath)([2, data.x, data.y, config.radius, 0, 0]),
              visibility: 'show'
            }, config.isDsHovered ? config.anchorHoverInStyle : config.isOtherDsHovered ? config.anchorStyle : config.anchorHighlightObj),
            id: 'shared-anchor-' + index,
            label: config.dsType + '-anchor'
          });
        });
      }
    } else {
      // Hiding an anchor
      if (config.hideIndices && config.hideIndices.length) {
        config.hideIndices.forEach(function (index) {
          data = dataInfo[index];
          data && !isNaN(data.value) && dataset.addGraphicalElement({
            el: 'path',
            container: {
              label: 'group',
              id: 'meso-anchor'
            },
            attr: {
              visibility: 'hidden'
            },
            id: 'shared-anchor-' + index,
            label: config.dsType + '-anchor'
          });
        });
      }
    }
  }
  /**
   * Function to set hover in effect
   * @param {number} indices data indices
   */
  ;

  _proto.setHoverInEffect = function setHoverInEffect(indices, isDsHovered, isOtherDsHovered) {
    var dataset = this,
        chart = dataset.getFromEnv('chart'),
        dataInfo = dataset.config.dataInfo,
        eventArgs;
    dataset.getFromEnv('animationManager').setAnimationState('mouseOver');

    if (!isDsHovered) {
      indices.forEach(function (index) {
        if (dataInfo[index]) {
          eventArgs = dataInfo[index].eventArgs;
          chart.fireChartInstanceEvent(HIGHLIGHT, eventArgs);
        }
      });
    }

    this.setData(this.getHoverInConfig(indices, isDsHovered, isOtherDsHovered), true);
  }
  /**
   * Function that return the nearest plot details
   * @param   {number} chartX x-axis position of the mouse cordinate
   * @param   {number} chartY y-axis position of the mouse cordinate
   * @return {Object} return an object with details of nearest plot and whether
   * it is hovered or not
   */
  ;

  _proto._getHoveredPlot = function _getHoveredPlot(chartXArg, chartYArg) {
    var dataset = this,
        chartX = chartXArg,
        chartY = chartYArg,
        xScale = dataset.getFromEnv('xScale'),
        xScaleRange = xScale.getRange(),
        dataMarkers = [dataset.getChildren('dataMarker')],
        config = dataset.config,
        visible = config.visibility === VISIBLE,
        dataInfo = config.dataInfo,
        len = dataInfo.length,
        canvas = dataset.getLinkedParent(),
        translationObj = canvas.getTranslation(),
        translationX = translationObj.x,
        translationY = translationObj.y,
        pointObj,
        xMin,
        xMax,
        returnValue,
        j,
        pX; // Readjusting the chart as the canvas group is translated

    chartX -= translationX;
    chartY -= translationY; // if chartX is outside the range of scale, no plots will be hovered
    // as because tootlip expects a proper object or undefined component property is sent
    // if undefined it sent then it will freeze tooltip in its last position.

    if (chartX < xScaleRange[0] || chartX > xScaleRange[1]) {
      return {
        component: dataset
      };
    }

    pX = xScale.getBinIndex(xScale.getDomainValue(chartX)); // Finding the lower limit on the xscale of the search domain

    xMin = Math.floor(Math.max(pX, 0)); // Finding the upper limit on the xscale of the search domain

    xMax = Math.ceil(Math.min(pX, len - 1)); // Iteraring over the datamarkers to check if they are hovered

    dataMarkers.forEach(function (dataMarkerArg) {
      var dataMarker = dataMarkerArg;

      if (!returnValue && dataMarker && (dataMarker = dataMarker[0])) {
        returnValue = dataMarker._checkPointOverMarker(pX, chartX, chartY, config.availableWidth);
      }
    }); // If a datamarker is not hovered

    if (!returnValue) {
      for (j = xMax; j >= xMin; j--) {
        pointObj = dataInfo[j];
        returnValue = visible ? isWithinShape(pointObj, j, chartX, chartY, dataset) : {};

        if (returnValue.hovered) {
          break;
        }
      }
    } // To avoid dirty checking at multiple instances later in the code


    !returnValue && (returnValue = {}); // if not hovered on any plot then get the nearest plot info.

    if (!returnValue.hovered) {
      // Storing info for crossline, x is calculated without considering the
      // radius
      returnValue.binIndexHovered = xScale.getBinIndex(xScale.getDomainValue(chartX));
      returnValue.pointObj = config.dataInfo[returnValue.binIndexHovered] || xScale.getBinBounds(pX);
      returnValue.component = dataset;
    } else {
      returnValue.binIndexHovered = returnValue.pointIndex;
    }

    config.binIndexHovered = returnValue.binIndexHovered;
    return returnValue;
  };

  return Line;
}(_column.default);

var _default = Line;
exports["default"] = _default;

/***/ }),

/***/ 932:
/***/ ((__unused_webpack_module, exports) => {



exports.__esModule = true;
exports["default"] = void 0;

function getPathValues(path, hPresent) {
  var regExp = /M(.*)V(.*)/g,
      parsed,
      MXY,
      VY,
      MX,
      MY,
      HX;
  hPresent && (regExp = /M(.*)H(.*)/g);
  parsed = regExp.exec(path);
  MXY = parsed[1];
  hPresent && (HX = parsed[2]) || (VY = parsed[2]);
  MX = parseFloat(MXY.split(',')[0]);
  MY = parseFloat(MXY.split(',')[1]);
  VY = parseFloat(VY);
  HX = parseFloat(HX);

  if (hPresent) {
    return {
      MX: MX,
      MY: MY,
      HX: HX
    };
  }

  ;
  return {
    MX: MX,
    MY: MY,
    VY: VY
  };
}

function getStartEndByIndex(index, total) {
  var start,
      timesegment = 0.00002,
      offset = timesegment * index;
  start = offset;
  return {
    start: start,
    end: 1
  };
}

var _default = {
  'initial.dataset.timeseries-ohlc': function initialDatasetTimeseriesOhlc() {
    var component = this,
        yScale = component.getFromEnv('yScale'),
        yBasePos = yScale.getRangeValue(0);

    var lastIndex = -1,
        lastValue = null,
        getStartEndByIndexCached = function getStartEndByIndexCached(index, total) {
      if (index === lastIndex) {
        return lastValue;
      }

      var val = getStartEndByIndex(index, total);
      lastIndex = index;
      lastValue = val;
      return val;
    };

    return {
      'highlow.appearing': function highlowAppearing(inputJSON) {
        var pathValues = getPathValues(inputJSON.attr.path),
            index = inputJSON.props.index,
            dataLength = inputJSON.props.dataLength;
        return [{
          initialAttr: {
            path: "M" + pathValues.MX + "," + yBasePos + "V" + (pathValues.VY + (yBasePos - pathValues.MY))
          },
          startEnd: getStartEndByIndexCached(index, dataLength),
          effect: 'easeInOutQuart'
        }];
      },
      'open.appearing': function openAppearing(inputJSON) {
        var pathValues = getPathValues(inputJSON.attr.path, true),
            index = inputJSON.props.index,
            dataLength = inputJSON.props.dataLength; // return null;

        return [{
          initialAttr: {
            path: "M" + pathValues.MX + "," + yBasePos + "H" + pathValues.HX
          },
          startEnd: getStartEndByIndexCached(index, dataLength),
          effect: 'easeInOutQuart'
        }];
      },
      'close.appearing': function closeAppearing(inputJSON) {
        var pathValues = getPathValues(inputJSON.attr.path, true),
            index = inputJSON.props.index,
            dataLength = inputJSON.props.dataLength; // return null;

        return [{
          initialAttr: {
            path: "M" + pathValues.MX + "," + yBasePos + "H" + pathValues.HX
          },
          startEnd: getStartEndByIndexCached(index, dataLength),
          effect: 'easeInOutQuart'
        }];
      }
    };
  }
};
exports["default"] = _default;

/***/ }),

/***/ 931:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _candlestick = _interopRequireDefault(__webpack_require__(929));

var _isValidNumber = _interopRequireDefault(__webpack_require__(856));

var _lib = __webpack_require__(274);

var _dependencyManager = __webpack_require__(282);

var _ohlc = _interopRequireDefault(__webpack_require__(932));

var _safeMin = _interopRequireDefault(__webpack_require__(539));

var _extent = _interopRequireDefault(__webpack_require__(538));

var _timeConverter = _interopRequireDefault(__webpack_require__(350));

(0, _dependencyManager.addDep)({
  name: 'ohlcAnimation',
  type: 'animationRule',
  extension: _ohlc.default
});
var UNDEF;
var tooltipYbuffer = 10,
    DEFAULT_BEAR_STROKE_COLOR = '868AC8';

var OHLC = /*#__PURE__*/function (_CandleStick) {
  (0, _inheritsLoose2.default)(OHLC, _CandleStick);

  function OHLC() {
    return _CandleStick.apply(this, arguments) || this;
  }

  var _proto = OHLC.prototype;

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    var config = this.config;

    _CandleStick.prototype.__setDefaultConfig.call(this);

    config.defaultBearStyle.stroke = DEFAULT_BEAR_STROKE_COLOR;
    config.defaultBearPredictiveStyle = {};
    config.defaultBullPredictiveStyle = {};
  }
  /**
   * Helper function of data markers
   * @return {Object} contains positioning info and the dataInfo
   */
  ;

  _proto._getRelevantInfo = function _getRelevantInfo(index) {
    var config = this.config;
    return {
      firstTimeStamp: config.firstTimeStamp,
      timeStampGap: config.timeStampGap,
      dataInfo: config.dataInfo,
      fill: index !== UNDEF && config.dataInfo[index].groupId === 'bull' ? config.bullStyle.stroke : config.bearStyle.stroke
    };
  }
  /**
   * Function to draw the candles and the sticks
   */
  ;

  _proto._drawPlot = function _drawPlot() {
    var dataset = this,
        config = dataset.config,
        attr,
        dataInfo = config.dataInfo,
        definedBullOpacity = (0, _lib.defined)(config.bullOpacity),
        definedBullFillOpacity = (0, _lib.defined)(config['bull-fill-opacity']),
        definedBullStrokeOpacity = (0, _lib.defined)(config['bull-stroke-opacity']),
        predictiveStyleAttributesBull = config.predictiveStyleAttributesBull,
        definedPredictiveBullOpacity = (0, _lib.defined)(predictiveStyleAttributesBull.opacity),
        definedPredictiveBullFillOpacity = (0, _lib.defined)(predictiveStyleAttributesBull['fill-opacity']),
        definedPredictiveBullStrokeOpacity = (0, _lib.defined)(predictiveStyleAttributesBull['stroke-opacity']),
        definedBearOpacity = (0, _lib.defined)(config.bearOpacity),
        definedBearFillOpacity = (0, _lib.defined)(config['bear-fill-opacity']),
        definedBearStrokeOpacity = (0, _lib.defined)(config['bear-stroke-opacity']),
        predictiveStyleAttributesBear = config.predictiveStyleAttributesBear,
        definedPredictiveBearOpacity = (0, _lib.defined)(predictiveStyleAttributesBear.opacity),
        definedPredictiveBearFillOpacity = (0, _lib.defined)(predictiveStyleAttributesBear['fill-opacity']),
        definedPredictiveBearStrokeOpacity = (0, _lib.defined)(predictiveStyleAttributesBear['stroke-opacity']),
        attrBaseBull = {},
        attrBaseBear = {},
        attrBase,
        derivedGroupId = '',
        isDatumPredictive = false,
        mergePredictiveStylesInDatumGraphics = function mergePredictiveStylesInDatumGraphics(attrBear, attrBull) {
      definedPredictiveBearOpacity && (attrBear.opacity = predictiveStyleAttributesBear.opacity);
      definedPredictiveBearFillOpacity && (attrBear.opacity = predictiveStyleAttributesBear['fill-opacity']);
      definedPredictiveBearStrokeOpacity && (attrBear.opacity = predictiveStyleAttributesBear['stroke-opacity']);
      definedPredictiveBullOpacity && (attrBull.opacity = predictiveStyleAttributesBull.opacity);
      definedPredictiveBullFillOpacity && (attrBull.opacity = predictiveStyleAttributesBull['fill-opacity']);
      definedPredictiveBullStrokeOpacity && (attrBull.opacity = predictiveStyleAttributesBull['stroke-opacity']);
    };

    definedBullOpacity && (attrBaseBull.opacity = config.bullOpacity);
    definedBullFillOpacity && (attrBaseBull.opacity = config['bull-fill-opacity']);
    definedBullStrokeOpacity && (attrBaseBull.opacity = config['bull-stroke-opacity']);
    definedBearOpacity && (attrBaseBear.opacity = config.bearOpacity);
    definedBearFillOpacity && (attrBaseBear.opacity = config['bear-fill-opacity']);
    definedBearStrokeOpacity && (attrBaseBear.opacity = config['bear-stroke-opacity']);
    dataInfo.forEach(function (datum, index) {
      if (datum.groupConfig) {
        isDatumPredictive = dataset.isPlotPredictive(datum);
        derivedGroupId = isDatumPredictive ? datum.groupId + '-predictive' : datum.groupId;

        if (isDatumPredictive) {
          mergePredictiveStylesInDatumGraphics(attrBaseBear, attrBaseBull);
        }

        attrBase = datum.groupId === 'bull' ? attrBaseBull : attrBaseBear; // Vertical line will be drawn if atleast 2 of OHLC are present,
        // Else, just a dot

        if (!!datum.lowStickYEntend + !!datum.highStickYExtend + !!datum.open + !!datum.close > 1) {
          if (datum.groupId === 'bull') {
            // Bull conditions - open > close OR one or both are missing
            // Hence, the vertical line can start from
            //  high to low
            //  high to close, if low missing (as close is lowest)
            //  high to open, if low and close missing (as open is lowest)
            //  open to low, if high missing (as open is highest)
            //  open to close, if low missing (as open is highest, close is lowest)
            //  NO CASE for open to open, (previous condition)
            //  close to low, if high and open missing (as close is highest, low is lowest)
            //  NO CASE for close to close, (previous condition)
            //  NO CASE for close to open, (previous condition)
            attr = Object.assign({
              path: "M" + datum.midX + "," + (datum.highStickYExtend || datum.open || datum.close) + ",V" + (datum.lowStickYEntend || datum.close || datum.open),
              'stroke-linecap': 'round'
            }, attrBase);
            datum.style && Object.assign(attr, datum.style);
            dataset.addGraphicalElement({
              el: 'path',
              component: dataset,
              container: {
                label: 'group',
                id: 'meso-' + derivedGroupId
              },
              props: {
                index: index,
                dataLength: dataInfo.length
              },
              label: 'highlow',
              attr: attr
            }, true);
          } else {
            // Bear conditions - open < close OR one or both are missing
            // Hence, the vertical line can start from
            //  high to low
            //  high to open, if low missing (as open is lowest)
            //  close to low, if high missing (as close is highest, low is lowest)
            //  close to open, if high and low missing (as close is highest, open is lowest)
            attr = Object.assign({
              path: "M" + datum.midX + "," + (datum.highStickYExtend || datum.close) + ",V" + (datum.lowStickYEntend || datum.open),
              'stroke-linecap': 'round'
            }, attrBase);
            datum.style && Object.assign(attr, datum.style);
            dataset.addGraphicalElement({
              el: 'path',
              component: dataset,
              container: {
                label: 'group',
                id: 'meso-' + derivedGroupId
              },
              props: {
                index: index,
                dataLength: dataInfo.length
              },
              label: 'highlow',
              attr: attr
            }, true);
          }
        } else if (datum.lowStickYEntend || datum.highStickYExtend) {
          attr = Object.assign({
            path: "M" + datum.midX + "," + (datum.lowStickYEntend || datum.highStickYExtend) + ",V" + (datum.lowStickYEntend || datum.highStickYExtend),
            'stroke-linecap': 'round'
          }, attrBase);
          datum.style && Object.assign(attr, datum.style);
          dataset.addGraphicalElement({
            el: 'path',
            component: dataset,
            container: {
              label: 'group',
              id: 'meso-' + datum.groupId
            },
            props: {
              index: index,
              dataLength: dataInfo.length
            },
            label: 'highlow',
            attr: attr
          }, true);
        }

        if (datum.open) {
          // Drawing the open stick
          attr = Object.assign({
            path: "M" + datum.midX + "," + datum.open + ",H" + datum.leftExtend
          }, attrBase);
          datum.style && Object.assign(attr, datum.style);
          dataset.addGraphicalElement({
            el: 'path',
            component: dataset,
            container: {
              label: 'group',
              id: 'meso-' + derivedGroupId
            },
            props: {
              index: index,
              dataLength: dataInfo.length
            },
            label: 'open',
            attr: attr
          }, true);
        }

        if (datum.close) {
          // Drawing the close stick
          attr = Object.assign({
            path: "M" + datum.midX + "," + datum.close + ",H" + datum.rightExtend
          }, attrBase);
          datum.style && Object.assign(attr, datum.style);
          dataset.addGraphicalElement({
            el: 'path',
            component: dataset,
            container: {
              label: 'group',
              id: 'meso-' + derivedGroupId
            },
            props: {
              index: index,
              dataLength: dataInfo.length
            },
            label: 'close',
            attr: attr
          }, true);
          datum.style = UNDEF;
        }
      }
    });
    config.hoverInfo = [];
  };

  _proto.allocatePosition = function allocatePosition() {
    var dataset = this,
        binDecider = dataset.getFromEnv('binDecider'),
        xScale = dataset.getFromEnv('xScale'),
        yScale = dataset.getFromEnv('yScale'),
        config = dataset.config,
        _config$indices = config.indices,
        xIdx = _config$indices[0],
        openIdx = _config$indices[1],
        highIdx = _config$indices[2],
        lowIdx = _config$indices[3],
        closeIdx = _config$indices[4],
        width,
        date,
        midX,
        open,
        close,
        high,
        low,
        pX,
        dataObj,
        dataInfo = config.dataInfo,
        dateColumn = dataset.getFromEnv('dateColumn'),
        isUTC = dataset.getFromEnv('UTC'),
        groupId,
        hoverInfo,
        lowStickYEntend,
        highStickYExtend,
        availableWidth,
        closePx,
        openPx,
        startDate,
        endDate,
        i,
        len,
        bins = xScale.bins,
        data = config.data,
        format = dateColumn.format,
        measures = config.measures[0],
        formatter = isUTC ? _timeConverter.default.utcFormatter(format) : _timeConverter.default.formatter(format),
        duration,
        openValueFormatted,
        highValueFormatted,
        lowValueFormatted,
        closeValueFormatted;

    if (config.repositioningDone = dataset._isRepositioningNeeded()) {
      config.timeStampGap = binDecider.getRangeThreshold()[2];
      config.availableWidth = availableWidth = 0; // Storing info for dataMarker detection

      for (i = 0, len = bins.length; i < len; i++) {
        if (bins[i].clipType !== 2) {
          config.availableWidth = availableWidth = xScale.getRangeValue(bins[i].end) - xScale.getRangeValue(bins[i].start);
          break;
        }
      }

      width = availableWidth * (1 - config.plotSpacePercent / 100);
      dataInfo = config.dataInfo = [];
      data.forEach(function (datum, index) {
        // drawing the candle
        date = datum[xIdx]; // value = datum[1];

        midX = xScale.getRangeValue(new Date(date.start), new Date(date.end));
        open = datum[openIdx];
        close = datum[closeIdx];
        high = datum[highIdx];
        low = datum[lowIdx];
        duration = date.config.duration;
        startDate = date.start;
        endDate = date.end;

        if (!index) {
          config.firstTimeStamp = date.start;
        }

        closePx = yScale.getRangeValue(close);
        openPx = yScale.getRangeValue(open);
        highStickYExtend = yScale.getRangeValue(high);
        lowStickYEntend = yScale.getRangeValue(low);

        if ((0, _isValidNumber.default)(openPx) || (0, _isValidNumber.default)(closePx) || (0, _isValidNumber.default)(highStickYExtend) || (0, _isValidNumber.default)(lowStickYEntend)) {
          // Calculate if bull or bear, if both open and close are present
          if ((0, _isValidNumber.default)(openPx) && (0, _isValidNumber.default)(closePx)) {
            groupId = open > close ? 'bear' : 'bull';
          } // Drawing the high and low stcik


          dataObj = {
            startDate: startDate,
            endDate: endDate
          };
          dataObj.rightExtend = midX + width / 2;
          dataObj.leftExtend = dataObj.x = midX - width / 2;
          dataObj.endXPosition = dataObj.x + width;
          dataObj.y = (0, _safeMin.default)([highStickYExtend, openPx, closePx, lowStickYEntend]);
          dataObj.closeValuePx = yScale.getRangeValue(close);
          dataObj.width = width;
          dataObj.close = closePx;
          dataObj.openValue = open;
          dataObj.closeValue = close;
          dataObj.highValue = high;
          dataObj.lowValue = low;
          dataObj.value = close;
          dataObj.open = openPx;
          dataObj.midX = midX; // For missing open/close, always show plot as bull

          dataObj.groupId = groupId || 'bull';
          dataObj.lowStickYEntend = lowStickYEntend;
          dataObj.highStickYExtend = highStickYExtend;
          openValueFormatted = config.formatterFn({
            value: open,
            type: 'tooltip',
            prefix: config.prefix,
            suffix: config.suffix
          });
          closeValueFormatted = config.formatterFn({
            value: close,
            type: 'tooltip',
            prefix: config.prefix,
            suffix: config.suffix
          });
          highValueFormatted = config.formatterFn({
            value: high,
            type: 'tooltip',
            prefix: config.prefix,
            suffix: config.suffix
          });
          lowValueFormatted = config.formatterFn({
            value: low,
            type: 'tooltip',
            prefix: config.prefix,
            suffix: config.suffix
          });
          dataObj.eventArgs = {
            index: index,
            start: startDate,
            startText: formatter.format(startDate),
            end: endDate,
            endText: formatter.format(endDate),
            binUnit: duration.Unit,
            binMultiplier: duration.number,
            plotType: config.type,
            timeFormatter: format,
            aggregation: config.aggregation,
            measure: measures.close,
            measureHigh: measures.high,
            measureLow: measures.low,
            measureOpen: measures.open,
            measuresClose: measures.close,
            binValue: close,
            binOpen: open,
            binHigh: high,
            binLow: low,
            binClose: close,
            binValueFomatted: closeValueFormatted,
            binOpenFormatted: openValueFormatted,
            binHighFormatted: highValueFormatted,
            binCloseFormatted: closeValueFormatted,
            binLowFormatted: lowValueFormatted
          }; // Either difference between low and high or 0 if either are missing

          var minmax = (0, _extent.default)([openPx, closePx, highStickYExtend, lowStickYEntend]);
          dataObj.height = Math.abs(minmax[0] - minmax[1]) || 0; // for tooltip plotting

          dataObj.colY = dataObj.height / 2 + highStickYExtend - tooltipYbuffer;
          dataObj['stroke-width'] = (0, _lib.pluckNumber)(config['default-stroke-width'], 1);
          dataObj.groupConfig = groupId === 'bull' ? 'bullConfig' : 'bearConfig'; // Get the data index corresponding to the fetched timeStamp

          pX = xScale.getBinIndex(date.start);
          dataInfo[pX] = dataObj;
        }
      });
    } // If hovered, show hover effect of the particular plot


    if (hoverInfo = config.hoverInfo) {
      hoverInfo.forEach(function (hoveredData) {
        hoveredData.hoverIndices.forEach(function (index) {
          if (typeof dataInfo[index] === 'object') {
            dataInfo[index].style = hoveredData[dataInfo[index].groupId + 'Style'];
          }
        });
      });
    }
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */
  ;

  _proto.getName = function getName() {
    return 'timeseries-ohlc';
  };

  return OHLC;
}(_candlestick.default);

var _default = OHLC;
exports["default"] = _default;

/***/ }),

/***/ 939:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports.isWithinShape = isWithinShape;
exports.calculateLimits = calculateLimits;
exports.getTooltext = getTooltext;

var _lib = __webpack_require__(274);

var _safeMin = _interopRequireDefault(__webpack_require__(539));

var _safeMax = _interopRequireDefault(__webpack_require__(540));

/**
 * Function to check if the coordinate is inside the radius of the anchor
 * @param   {Object} pointObj The object containing the info about the data
 * point hovered
 * @param   {number} pX x-axis position of the mouse cordinate
 * @param   {number} x the chartX where hovered
 * @param   {number} y the chartY where hovered
 * @param   {String} component component hovered
 * @param   {number} maxRadius maximum radius of the anchor
 * @return {Object} return an object with details of nearest plot and whether
 * it is hovered or not
 */
function isWithinShape(pointObj, pX, x, y, component, maxRadius) {
  var xPos1, yPos1, xPos2, yPos2, diff1, diff2;

  if (!pointObj) {
    return {
      pointIndex: pX,
      hovered: false,
      component: component
    };
  }

  xPos1 = pointObj.x;
  xPos2 = pointObj.x;
  yPos1 = pointObj.y;
  yPos2 = pointObj.base; // Mathematical function to find a point inside a cirlce of given radius

  diff1 = Math.sqrt(Math.pow(x - xPos1, 2) + Math.pow(y - yPos1, 2));
  diff2 = Math.sqrt(Math.pow(x - xPos2, 2) + Math.pow(y - yPos2, 2));
  return {
    pointIndex: pX,
    hovered: diff1 <= maxRadius || diff2 < maxRadius,
    pointObj: pointObj,
    component: component
  };
}

function calculateLimits(dataset) {
  var _dataset$config = dataset.config,
      indices = _dataset$config.indices,
      data = _dataset$config.data,
      type = _dataset$config.type,
      scaleY = _dataset$config.scaleY,
      scaleX = _dataset$config.scaleX,
      calculateFromContext = _dataset$config.calculateFromContext,
      isContinuous = /continuous/.test(dataset.getName()),
      showPlotOverTick = scaleX.showPlotOverTick(),
      padding,
      returnObj = {},
      firstData = data[0],
      lastData = data[data.length - 1],
      isLog = scaleY.getType() === 'log',
      isVisible = dataset.config.visibility === 'visible',
      chart = dataset.getFromEnv('chart'),
      _ref = calculateFromContext ? chart.getContextLimit() : chart.getFocusLimit(),
      focusLimitStart = _ref[0],
      focusLimitEnd = _ref[1],
      sanitiseFn = function sanitiseFn(num) {
    if (isLog && num <= 0) {
      return null;
    }

    return num;
  },
      minFn = function minFn(datum) {
    // check if data is withing visible range or not
    if (!(datum[0].end < focusLimitStart) && !(datum[0].start > focusLimitEnd)) {
      return (0, _safeMin.default)([datum[indices[1]], datum[indices[2]], datum[indices[3]], datum[indices[4]]], sanitiseFn);
    }

    return null;
  },
      maxFn = function maxFn(datum) {
    // check if data is withing visible range or not
    if (!(datum[0].end < focusLimitStart) && !(datum[0].start > focusLimitEnd)) {
      return (0, _safeMax.default)([datum[indices[1]], datum[indices[2]], datum[indices[3]], datum[indices[4]]], sanitiseFn);
    }

    return null;
  };

  padding = dataset.getPadding();

  if (showPlotOverTick) {
    returnObj.x = [firstData && firstData[indices[0]].start - padding, lastData && lastData[indices[0]].start + padding];
  } else {
    if (isContinuous) {
      returnObj.x = [firstData && (firstData[indices[0]].start + firstData[indices[0]].end) / 2 - padding, lastData && (lastData[indices[0]].start + lastData[indices[0]].end) / 2 + padding];
    } else {
      returnObj.x = [firstData && firstData[indices[0]].start - padding, lastData && lastData[indices[0]].end - padding];
    }
  }

  returnObj.y = isVisible ? [(0, _safeMin.default)(data, minFn), (0, _safeMax.default)(data, maxFn)] : _lib.UNDEF;
  returnObj.baseRequired = true;
  returnObj.type = type; // TODO: Remove this

  return returnObj;
}
/**
 * Generate the random class.
 * @param {String} baseName the static prefix for random class
 * @returns {String} new generated random classes.
 */


var getClassName = function getClassName(baseName) {
  if (baseName === void 0) {
    baseName = '';
  }

  var randomString = Math.random().toString(36).substring(2);
  return baseName + "-" + randomString;
},
    getCSPNonce = function getCSPNonce() {
  var metaTag = document.querySelector("meta[http-equiv=\"Content-Security-Policy\"]");

  if (metaTag) {
    var content = metaTag.getAttribute('content');

    if (content) {
      var match = content.match(/'nonce-([^']+)'/);

      if (match) {
        return match[1];
      }
    }
  }

  return null;
};
/**
  * Function to form the tooltext
  * @param {Object} dataset The dataset's context
  * @param {Boolean} pointFound If any dataset's data is actually hovered
  * @param {Boolean} datasetHovered If the current dataset is hovered
  * @param {number} dataIndex The index of the data in the current dataset that is hovered
*/


function getTooltext(dataset, pointFound, datasetHovered, dataIndex) {
  var config = dataset.config,
      dataInfo = config.dataInfo,
      currData = dataInfo[dataIndex],
      // Setting logic for opacity.
  // When the data of the currentdataset is hovered then all other tooltip's opacity is set to 0.5
  // Rest all the cases the opacity is 1
  opacity = pointFound ? datasetHovered ? 1 : 0.5 : 1,
      line2;
  var chartNonce = getCSPNonce();

  if (dataset._isInvalidTooltext(currData)) {
    return '';
  }

  line2 = ['high', 'low'].reduce(function (accumulator, currentValue) {
    var currentvalueOverflowClass = getClassName('current-value-overflow'),
        currentValueClass = getClassName('-tooltip-current-value'),
        tooltipValueClass = getClassName('tooltip-class-value');
    var value = currData[currentValue + 'TooltipValue'] || (currData[currentValue + 'TooltipValue'] = currData[currentValue + 'Value'] && config.formatterFn({
      value: currData[currentValue + 'Value'],
      type: 'tooltip',
      prefix: config.prefix,
      suffix: config.suffix
    })); // Only add a line for H/L if it has a value calculated from above

    return accumulator + (value !== _lib.UNDEF ? "\n      <style nonce=\"" + chartNonce + "\">\n        ." + currentvalueOverflowClass + " {\n          overflow: hidden;\n          margin-top: 4px;\n        }\n\n        ." + currentValueClass + " {\n          float: left;\n          padding-right: 5px;\n        }\n\n        ." + tooltipValueClass + " {\n          float: right;\n          padding-right: 5px;\n        }\n      </style>\n      <div class=\"" + currentvalueOverflowClass + "\">\n      <div class=\"" + currentValueClass + "\">" + currentValue + "</div>\n      <div class=\"" + tooltipValueClass + "\">" + value + "</div>\n     </div>" : '');
  }, '');
  var tooltipOpacityClass = getClassName('tooltip-opacity-class');
  line2 = "\n  <style nonce=\"" + chartNonce + "\">\n    ." + tooltipOpacityClass + " {\n      margin-top:6px;\n      overflow: hidden;\n      opacity:" + opacity + ";\n    }\n  </style>\n  <div class=\"" + tooltipOpacityClass + "\">\n              " + line2 + "\n            </div>";
  return line2;
}

/***/ }),

/***/ 945:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _componentInterface = __webpack_require__(290);

var _lib = __webpack_require__(274);

var HORIZONTAL = 'horizontal';

var GridBand = /*#__PURE__*/function (_SmartRenderer) {
  (0, _inheritsLoose2.default)(GridBand, _SmartRenderer);

  function GridBand() {
    return _SmartRenderer.apply(this, arguments) || this;
  }

  var _proto = GridBand.prototype;

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    _SmartRenderer.prototype.__setDefaultConfig.call(this);

    this.config.direction = HORIZONTAL;
    this.config.style = {};
    this.config.defaultStyle = {
      'stroke': '#EFEFEF',
      'stroke-width': '0',
      'fill': '#EFEFEF',
      'fill-opacity': '1'
    };
  };

  _proto.configureAttributes = function configureAttributes(obj) {
    if (obj === void 0) {
      obj = {};
    }

    _SmartRenderer.prototype.configureAttributes.call(this, obj);

    var selfConfig = this.config;

    for (var key in obj) {
      if (obj.hasOwnProperty(key)) {
        selfConfig[key] = obj[key];
      }
    }
  }
  /**
   * Method that creates all the gridline paths
   * @return {Array} array of paths
   */
  ;

  _proto.getBands = function getBands() {
    var _scale;

    var gridBand = this,
        canvasConfig = gridBand.getLinkedParent().config,
        bands = [],
        axisConfig,
        x,
        y,
        yScaleRangeFunction,
        width,
        height,
        scale,
        ticks,
        tickArguments = [],
        i,
        len; // grid-bands are drawn with respect to the primary y-axis
    // thus using the first yAxis config

    axisConfig = canvasConfig.yConfigs[0];
    scale = axisConfig.scale;
    x = canvasConfig.canvasBGLeft;
    yScaleRangeFunction = scale.getRangeValue.bind(scale);
    width = canvasConfig.canvasBGLeft + canvasConfig.canvasBGWidth; // If tickArguments is present, use it for calculation of ticks

    if (axisConfig.tickarguments) {
      tickArguments = axisConfig.tickarguments;
    } // If skipInfo is provided, use it to calculate ticks


    tickArguments.push(axisConfig.skipinfo || {});
    tickArguments.push(axisConfig.dayinmajor || false);
    ticks = (_scale = scale).ticks.apply(_scale, tickArguments);
    height = yScaleRangeFunction(ticks[0]) - yScaleRangeFunction(ticks[1]);

    for (i = 0, len = ticks.length; i < len; i += 2) {
      y = yScaleRangeFunction(ticks[i]) - height;
      bands.push({
        x: x,
        y: y,
        width: width,
        height: height
      });
    }

    return bands;
  };

  _proto.draw = function draw() {
    var gridBand = this,
        selfConfig = gridBand.config,
        mergedStyle,
        _gridBand$getLinkedPa = gridBand.getLinkedParent().config,
        canvasLeft = _gridBand$getLinkedPa.canvasLeft,
        canvasTop = _gridBand$getLinkedPa.canvasTop,
        canvasWidth = _gridBand$getLinkedPa.canvasWidth,
        canvasHeight = _gridBand$getLinkedPa.canvasHeight,
        padding = _gridBand$getLinkedPa.padding,
        clipPath = ["M" + canvasLeft + "," + (canvasTop - padding.top), "h" + canvasWidth, "v" + canvasHeight, "h" + -canvasWidth, "Z"]; // store style of gridbands

    selfConfig.style = gridBand.getFromEnv('getStyleDef')(selfConfig.style);
    mergedStyle = (0, _lib.extend2)((0, _lib.extend2)({}, selfConfig.defaultStyle), selfConfig.style); // We dont want bands to have strokes

    mergedStyle['stroke-width'] = 0; // create the grid line group

    gridBand.addGraphicalElement({
      el: 'group',
      container: {
        id: 'strato',
        label: 'group',
        isParent: true
      },
      component: gridBand,
      label: 'gridBand',
      attr: {
        name: 'grid-band-group',
        'clip-path': clipPath
      },
      id: 'gridBand'
    });
    gridBand.getBands().forEach(function (band, index) {
      band.opacity = mergedStyle.opacity;
      gridBand.addGraphicalElement({
        el: 'rect',
        attr: band,
        css: mergedStyle,
        container: {
          label: 'gridBand'
        },
        id: 'grid-band-' + index,
        component: gridBand,
        label: 'band'
      });
    });
  };

  return GridBand;
}(_componentInterface.SmartRenderer);

var _default = GridBand;
exports["default"] = _default;

/***/ }),

/***/ 895:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _componentInterface = __webpack_require__(290);

var _lib = __webpack_require__(274);

// import { extend2, pluck, pluckNumber } from '@fusioncharts/core/src/lib';
var HORIZONTAL = 'horizontal',
    VERTICAL = 'vertical',
    M = 'M',
    H = 'H',
    V = 'V',
    BLANKREGEX = /\S/,
    SPACE = ' ',
    STROKEDASH = 'stroke-dasharray',
    // function to check if a value falls within domain
iswithinDomain = function iswithinDomain(value, domainArr) {
  if (+value >= +domainArr[0] && +value <= +domainArr[1]) {
    return true;
  }

  return false;
};

var GridLine = /*#__PURE__*/function (_SmartRenderer) {
  (0, _inheritsLoose2.default)(GridLine, _SmartRenderer);

  function GridLine() {
    return _SmartRenderer.apply(this, arguments) || this;
  }

  var _proto = GridLine.prototype;

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    _SmartRenderer.prototype.__setDefaultConfig.call(this);

    this.config.direction = HORIZONTAL;
    this.config.showgridlines = 1;
    this.config.showboundarygridlines = 1;
    this.config.style = {};
    this.config.defaultStyle = {
      'stroke': '#EFEFEF',
      'stroke-width': '1',
      'stroke-opacity': '1'
    };
  };

  _proto.configureAttributes = function configureAttributes(obj) {
    if (obj === void 0) {
      obj = {};
    }

    _SmartRenderer.prototype.configureAttributes.call(this, obj);

    var selfConfig = this.config;

    for (var key in obj) {
      if (obj.hasOwnProperty(key) && typeof obj[key] !== 'undefined') {
        selfConfig[key] = obj[key];
      }
    }
  }
  /**
   * Method that creates all the gridline paths
   * @return {Array} array of paths
   */
  ;

  _proto.getPathArr = function getPathArr() {
    var _scale;

    var gridLine = this,
        selfConfig = gridLine.config,
        styleDef = gridLine.getFromEnv('getStyleDef'),
        axisStyle,
        canvasConfig = gridLine.getLinkedParent().config,
        direction = selfConfig.direction,
        pathArr = [],
        axisConfig,
        stretchFromX,
        stretchFromY,
        strechUpto,
        pathCommand,
        scale,
        scaleDomains,
        ticks,
        tickArguments = [],
        i,
        // FT 4: No grid line should appear in time navigator without a label
    timeNavAxis,
        len;

    if (direction !== VERTICAL) {
      axisConfig = canvasConfig.yConfigs[0];
      scale = axisConfig.scale;
      pathCommand = H;
      stretchFromX = canvasConfig.canvasBGLeft;
      stretchFromY = scale.getRangeValue;
      strechUpto = canvasConfig.canvasBGLeft + canvasConfig.canvasBGWidth;
    } else {
      // FT 4: No grid line should appear in time navigator without a label
      // Accessing  the axis of time navigator
      // Added null check and isArray check
      var timeNavigator = this.getLinkedParent().getLinkedParent();

      if (timeNavigator.getChildren('timeAxis') && Array.isArray(timeNavigator.getChildren('timeAxis'))) {
        timeNavAxis = timeNavigator.getChildren('timeAxis')[0];
      }

      axisConfig = canvasConfig.xConfigs[0];
      scale = axisConfig.scale;
      pathCommand = V;
      stretchFromX = scale.getRangeValue;
      stretchFromY = canvasConfig.canvasBGTop + canvasConfig.canvasBGHeight - canvasConfig.padding.top;
      strechUpto = canvasConfig.canvasBGTop - canvasConfig.padding.top;
    } // If tickArguments is present, use it for calculation of ticks


    if (axisConfig.tickarguments) {
      tickArguments = axisConfig.tickarguments;
    } // store style of gridlines


    axisStyle = axisConfig.style || {};
    selfConfig.style = styleDef(axisStyle['grid-line'] || {}); // If skipInfo is provided, use it to calculate ticks

    tickArguments.push(axisConfig.skipinfo || {});
    tickArguments.push(axisConfig.dayinmajor || false);
    ticks = (_scale = scale).ticks.apply(_scale, tickArguments);

    if (selfConfig.showgridlines) {
      scaleDomains = scale.getDomain();

      for (i = 0, len = ticks.length; i < len; i++) {
        if (!selfConfig.showboundarygridlines && (i === 0 || i === len - 1) || !iswithinDomain(ticks[i], scaleDomains)) {
          continue;
        } // FT 4: No grid line should appear in time navigator without a label
        // placing gridlines only for labels


        if (direction === VERTICAL && timeNavAxis.config.values[i].text.length === 0) {
          continue;
        }

        pathArr.push([M, typeof stretchFromX === 'function' ? stretchFromX.call(scale, ticks[i]) : stretchFromX, typeof stretchFromY === 'function' ? stretchFromY.call(scale, ticks[i]) : stretchFromY, pathCommand, strechUpto]);
      }
    }

    return pathArr;
  };

  _proto.draw = function draw() {
    var gridLine = this,
        selfConfig = gridLine.config,
        styleGridLines = selfConfig.styleGridLines,
        pathArr = gridLine.getPathArr(),
        mergedStyle = (0, _lib.extend2)((0, _lib.extend2)({}, selfConfig.defaultStyle), styleGridLines && selfConfig.style); // if stroke-dasharray is provided as string convert it to array

    if (mergedStyle[STROKEDASH]) {
      mergedStyle[STROKEDASH] = typeof mergedStyle[STROKEDASH] === 'string' ? mergedStyle[STROKEDASH].split(SPACE).filter(function (c) {
        return BLANKREGEX.test(c);
      }).map(function (c) {
        return +c;
      }) : mergedStyle[STROKEDASH];
    } // create the grid line group


    gridLine.addGraphicalElement({
      el: 'group',
      container: {
        id: 'strato',
        label: 'strato',
        isParent: true
      },
      component: gridLine,
      label: 'gridLine',
      attr: {
        name: 'grid-line-group'
      },
      id: 'gridLine'
    });
    pathArr.forEach(function (path, index) {
      gridLine.addGraphicalElement({
        el: 'path',
        attr: {
          'path': path
        },
        css: mergedStyle,
        container: {
          label: 'gridLine'
        },
        id: 'grid-line-' + index,
        component: gridLine,
        label: 'line'
      });
    });
  };

  return GridLine;
}(_componentInterface.SmartRenderer);

var _default = GridLine;
exports["default"] = _default;

/***/ }),

/***/ 897:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _assertThisInitialized2 = _interopRequireDefault(__webpack_require__(292));

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _mouseTracker = _interopRequireDefault(__webpack_require__(593));

var _lib = __webpack_require__(274);

// When ever chart is zoomed, canvasHovered is triggered to hide tooltip and crossline
var UNDEF,
    _helperFn = function _helperFn(mouseTracker) {
  return function () {
    // when chart is getting zoomed, no tooltip should be shown. hence, deactivate
    // the mouse-tracker so that it does not show tooltip on any event.
    mouseTracker.deactivate();
    mouseTracker.fireEvent('canvasHovered', {
      hoveredInfo: {},
      e: {}
    }); // clear the previously set timer on chart zooming.

    clearTimeout(mouseTracker.domainValidationTimer); // create a timer to re-activate the mouse-tracker, this is done because when chart is
    // getting zoomed through wheel, then mouseover could also get fired if you step over an
    // element. This may cause the tooltip to be drawn. Which is wrong because the wheel is
    // still in action. Hence, re-activate the mouse-tracker after a specific amount of time.
    // Note: The difference in ms between two consecutive wheel and mouseover event varied between
    // 30 to 65. On the basis of that, 100ms is chosen.

    mouseTracker.domainValidationTimer = setTimeout(function () {
      mouseTracker.activate();
    }, 100);
  };
};

var MouseTracker = /*#__PURE__*/function (_CoreMouseTracker) {
  (0, _inheritsLoose2.default)(MouseTracker, _CoreMouseTracker);

  function MouseTracker() {
    var _this2;

    _this2 = _CoreMouseTracker.call(this) || this; // Setting the handler function as UNDEF which was set in the super function

    _this2.handler = function (_this) {
      return function (e) {
        _this.mouseEvtHandler(e);
      };
    }((0, _assertThisInitialized2.default)(_this2)); // Including mouseout event by default to be listened over the canvas


    _this2.eventsList.push('fc-mouseout');

    _this2.active = true;
    return _this2;
  }
  /**
   * Callback function for the mouseTracker
   * @param {Object} e The mouse Event
   */


  var _proto = MouseTracker.prototype;

  _proto.mouseEvtHandler = function mouseEvtHandler(e) {
    if (!this.active) {
      return;
    }

    var mouseTracker = this,
        oriEvent = e.originalEvent,
        parent = mouseTracker.getLinkedParent(),
        datasets = parent.getChild(UNDEF, 'dataset') || [],
        timeInstanceMarker = parent.getChild(UNDEF, 'timeInstanceMarker')[0],
        timeSpanMinMarker = parent.getChild(UNDEF, 'timeSpanMinMarker')[0],
        timeSpanFullMarker = parent.getChild(UNDEF, 'timeSpanFullMarker')[0],
        coordinate,
        chartX,
        chartY,
        dataset,
        hoveredInfo,
        hoveredInfoMarker,
        hoveredInfoTemp,
        hoveredIndexTemp,
        i = datasets.length;

    if (!i) {
      return;
    }

    coordinate = (0, _lib.getMouseCoordinate)(mouseTracker.getFromEnv('chart-container'), oriEvent, mouseTracker.getFromEnv('chart'));
    chartX = coordinate.chartX;
    chartY = coordinate.chartY; // check if currently hovering in or out of time instance marker

    hoveredInfoMarker = timeInstanceMarker.getHoveredMarker(chartX, chartY);

    if (hoveredInfoMarker && hoveredInfoMarker.hovered) {
      mouseTracker.fireEvent('canvasHovered', {
        hoveredInfo: hoveredInfoMarker,
        e: e,
        i: i,
        chartX: chartX,
        chartY: chartY
      });
      return;
    } else if (hoveredInfoMarker && hoveredInfoMarker.previouslyHoveredIndex !== UNDEF) {
      mouseTracker.fireEvent('canvasHovered', {
        hoveredInfo: hoveredInfoMarker,
        e: e,
        i: i,
        chartX: chartX,
        chartY: chartY
      });
      timeInstanceMarker.config.previouslyHoveredIndex = UNDEF;
    } // check if currently hovering in or out of time span min marker


    hoveredInfoMarker = timeSpanMinMarker.getHoveredMarker(chartX, chartY);

    if (hoveredInfoMarker && hoveredInfoMarker.hovered) {
      mouseTracker.fireEvent('canvasHovered', {
        hoveredInfo: hoveredInfoMarker,
        e: e,
        i: i,
        chartX: chartX,
        chartY: chartY
      });
      return;
    } else if (hoveredInfoMarker && hoveredInfoMarker.previouslyHoveredIndex !== UNDEF) {
      mouseTracker.fireEvent('canvasHovered', {
        hoveredInfo: hoveredInfoMarker,
        e: e,
        i: i,
        chartX: chartX,
        chartY: chartY
      });
      timeSpanMinMarker.config.previouslyHoveredIndex = UNDEF;
    } // Traversing over the dataset to check if any of its plot is hovered and raising event accordingly
    // All the datasets are traversed as the binIndexHovered can be different for different dataset depending upon the data


    while (i--) {
      dataset = datasets[i];
      hoveredInfo = dataset._getHoveredPlot && dataset._getHoveredPlot(chartX, chartY);

      if (hoveredInfo && hoveredInfo.hovered) {
        hoveredInfoTemp = hoveredInfo;
        hoveredIndexTemp = i;
      }
    } // check hovering over time span full marker only if not hovered over dataset


    if (!hoveredInfoTemp) {
      hoveredInfoMarker = timeSpanFullMarker.getHoveredMarker(chartX, chartY);

      if (hoveredInfoMarker && hoveredInfoMarker.hovered) {
        mouseTracker.fireEvent('canvasHovered', {
          hoveredInfo: hoveredInfoMarker,
          e: e,
          i: i,
          chartX: chartX,
          chartY: chartY
        });
        return;
      } else if (hoveredInfoMarker && hoveredInfoMarker.previouslyHoveredIndex !== UNDEF) {
        mouseTracker.fireEvent('canvasHovered', {
          hoveredInfo: hoveredInfoMarker,
          e: e,
          i: i,
          chartX: chartX,
          chartY: chartY
        });
        timeSpanFullMarker.config.previouslyHoveredIndex = UNDEF;
      }
    } // Raising an event even when no plot of the dataset is hovered


    mouseTracker.fireEvent('canvasHovered', {
      hoveredInfo: hoveredInfoTemp || hoveredInfo,
      e: e,
      i: hoveredIndexTemp,
      chartX: chartX,
      chartY: chartY
    });
  }
  /**
   * This method simply removes previously added listeners and adds all events in its event list to
   * the chart
   */
  ;

  _proto.addEvents = function addEvents() {
    var mouseTracker = this,
        canvas = mouseTracker.getLinkedParent(),
        eventsList = mouseTracker.eventsList,
        eventIndex; // Remove old listners

    mouseTracker._removeListners(); // Attach all related mouse / touch events.


    for (eventIndex in eventsList) {
      canvas.addEventListener(eventsList[eventIndex], mouseTracker.handler);
    } // Store a reference to the handler function in order to be able to
    // clean-up the handler during MouseTracker's removal.


    this.config.onDomainValidated = _helperFn(mouseTracker);
    mouseTracker.addExtEventListener('focusLimitChanged', this.config.onDomainValidated, mouseTracker.getFromEnv('chart'));
  }
  /**
   * Removes all event listeners added to the chart, if any
   * @private
   */
  ;

  _proto._removeListners = function _removeListners() {
    var mouseTracker = this,
        canvas = mouseTracker.getLinkedParent(),
        eventsList = mouseTracker.eventsList,
        eventIndex; // remove all previously attached events

    for (eventIndex in eventsList) {
      canvas.removeEventListener(eventsList[eventIndex], mouseTracker.handler);
    }

    mouseTracker.removeExtEventListener('domainValidated', this.config.onDomainValidated, mouseTracker.getFromEnv('chart'));
  };

  _proto.remove = function remove() {
    var _CoreMouseTracker$pro;

    // Clean-up references to event handlers
    this._removeListners();

    for (var _len = arguments.length, params = new Array(_len), _key = 0; _key < _len; _key++) {
      params[_key] = arguments[_key];
    }

    (_CoreMouseTracker$pro = _CoreMouseTracker.prototype.remove).call.apply(_CoreMouseTracker$pro, [this].concat(params));
  }
  /**
   * Function to set the mouse-tracker in active state
   */
  ;

  _proto.activate = function activate() {
    this.active = true;
  }
  /**
   * Function to set the mouse-tracker in de-active state
   */
  ;

  _proto.deactivate = function deactivate() {
    this.active = false; // Fire blank canvasHovered to hide all the visual component equivalent to mouse-out

    _helperFn();
  };

  return MouseTracker;
}(_mouseTracker.default);

var _default = MouseTracker;
exports["default"] = _default;

/***/ }),

/***/ 983:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _assertThisInitialized2 = _interopRequireDefault(__webpack_require__(292));

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _componentInterface = __webpack_require__(290);

var _libGraphics = __webpack_require__(278);

var _lib = __webpack_require__(274);

var _isValidNumber = _interopRequireDefault(__webpack_require__(856));

var _tooltipAndHover = __webpack_require__(899);

function getFirstDefinedColor(colorArr) {
  var i, len;

  for (i = 0, len = colorArr.length; i < len; i++) {
    if (colorArr[i] !== UNDEF && colorArr[i] !== 'none') {
      return (0, _libGraphics.convertColor)(colorArr[i]);
    }
  }
}
/**
 * Checks if the dataset can be stacked
 *
 * @param {String} plotType type of dataset
 */


var BLANK = '',
    DEFAULT_FORMAT = '%A, %b %d, %Y',
    isPlotStackable = function isPlotStackable(plotType) {
  return plotType === 'column';
},
    xShift = 5;

var UNDEF,
    previousIndexIdMap = {};

var CrosslineManager = /*#__PURE__*/function (_SmartRenderer) {
  (0, _inheritsLoose2.default)(CrosslineManager, _SmartRenderer);

  function CrosslineManager() {
    var _this;

    _this = _SmartRenderer.call(this) || this;
    var crosslineManager = (0, _assertThisInitialized2.default)(_this),
        senderCanvas,
        toolTipController,
        verticalDate,
        dsConfig,
        isSenderCanvas,
        tooltext,
        translation,
        multiCanvasTooltip,
        scale,
        previousPointIndex,
        isWithinCanvas;
    crosslineManager.canvases = []; // handler for every canvas interaction

    crosslineManager._handler = function (e) {
      multiCanvasTooltip = crosslineManager.config.multiCanvasTooltip;
      senderCanvas = e.sender.getLinkedParent();
      scale = senderCanvas.config && senderCanvas.config.xConfigs[0].scale; // check whether pointer is within the interacting canvas

      isWithinCanvas = senderCanvas.isWithinCanvas(e.data.chartX, e.data.chartY);
      var hoveredInfo = e.data.hoveredInfo || {},
          verticalCrossline,
          horizontalCrossline,
          datasets,
          tooltipAndHover,
          tooltipAndHoverConfig,
          datasetHoveredIndex,
          startDate,
          endDate,
          values,
          pointIndex,
          pointObj,
          yScale,
          yAlign,
          domain,
          tooltipStyle = crosslineManager.getFromEnv('tooltipStyle'),
          dataSource = crosslineManager.getFromEnv('dataSource'),
          customeToolText = dataSource.tooltip ? dataSource.tooltip.tooltext : null; // manage vertical crosslines

      if (isWithinCanvas && hoveredInfo.pointObj) {
        // get the scale domains for validation.
        domain = crosslineManager.getFromEnv('chart').config.focusAxesX[0].scale.getDomain(); // get the mid point

        startDate = hoveredInfo.pointObj.startDate;
        endDate = hoveredInfo.pointObj.endDate; // get its time stamp

        verticalDate = scale.getDomainValue(scale.getRangeValue(startDate, endDate)); // validate if the vertical crossline timestamp is within current focus domain

        if (+verticalDate < +domain[0] || +verticalDate > +domain[1] || +startDate === +endDate) {
          verticalDate = UNDEF;
        }
      } else {
        verticalDate = UNDEF;
      }

      crosslineManager.canvases.forEach(function (canvas) {
        isSenderCanvas = canvas === senderCanvas;
        translation = canvas.getTranslation();
        pointObj = UNDEF; // configure all vertical crosslines with new data

        verticalCrossline = canvas.getChildren('verticalCrossLine')[0];
        verticalCrossline.setData({
          values: verticalDate ? [verticalDate] : [],
          showMarker: isSenderCanvas,
          dateRange: {
            startDate: startDate,
            endDate: endDate
          }
        }, true); // show hovered effect of dataset

        datasets = canvas.getChildren('dataset') || [];

        if (datasets.length && (!isPlotStackable(datasets[0].getName()) || datasets.length === 1) && hoveredInfo.component && (hoveredInfo.component.getType() === 'dataset' || hoveredInfo.component.getType() === 'dataMarker')) {
          datasets.forEach(function (ds) {
            // _getHoveredPlot called to set binIndexHovered
            ds._getHoveredPlot(e.data.chartX, e.data.chartY);

            pointIndex = isWithinCanvas && ds._getHoveredBin(); // Hovering out the previous plot

            previousPointIndex = previousIndexIdMap[ds.getId()];

            if ((0, _lib.defined)(previousPointIndex) && previousPointIndex !== pointIndex) {
              ds.setHoverOutEffect([previousPointIndex]);
            }

            previousIndexIdMap[ds.getId()] = pointIndex;

            if (hoveredInfo.hovered && isSenderCanvas) {
              if (hoveredInfo.component === ds) {
                // when a dataset is hovered and the hovered component is same as
                // the ds in the loop then hovereffect will be set
                ds.setHoverInEffect([pointIndex], true);
              } else {
                // if the component hovered is not same as the ds in the loop
                // then if its a line or area ds then the anchors will come without the highlight effect
                if (ds.getName() === 'continuous') {
                  // 2nd argument designates that this dataset is not getting hovered
                  // 3rd argument designates the other dataset is being hovered
                  ds.setHoverInEffect([pointIndex], false, true);
                } else {
                  ds.setHoverOutEffect([pointIndex]);
                }
              }
            } else {
              ds.setHoverInEffect([pointIndex], false);
            }
          });
        } else if (!isWithinCanvas) {
          // when not hovered, out of canvas
          datasets.forEach(function (ds) {
            ds.setHoverOutEffect([previousIndexIdMap[ds.getId()]]);
          });
        } // Showing tooltext of each dataset


        if (multiCanvasTooltip && !isSenderCanvas) {
          tooltipAndHover = canvas.getChildren('tooltipHover')[0];
          tooltipAndHoverConfig = tooltipAndHover.config;

          if (tooltipAndHoverConfig.showTooltip) {
            tooltext = BLANK;
            toolTipController = canvas.getFromEnv('toolTipController');

            if (isWithinCanvas && hoveredInfo.component && hoveredInfo.component.getType() === 'dataset') {
              datasets.forEach(function (ds, dsIndex) {
                pointIndex = ds._getHoveredBin(); // Checking if dataset is visible
                // Checking if data is present in the corresponding datasets

                if (ds.config.visibility === 'visible' && ds.config.dataInfo[pointIndex]) {
                  // Checking if data is present in the corresponding datasets
                  pointObj = ds.config.dataInfo[pointIndex];
                  tooltext += ds._getTooltext(false, false, pointIndex);
                  datasetHoveredIndex = dsIndex;
                }
              }); // If data found at the given index

              if (pointObj) {
                pointIndex = datasets[datasetHoveredIndex]._getHoveredBin();

                var _datasets$datasetHove = datasets[datasetHoveredIndex]._getDateForToolText(pointIndex),
                    header = _datasets$datasetHove.header,
                    body = _datasets$datasetHove.body,
                    xRange = hoveredInfo.component.getFromEnv('xScale').getRange();

                if (customeToolText) {
                  tooltext = (0, _tooltipAndHover.createDivString)('', body + tooltext);
                } else {
                  tooltext = (0, _tooltipAndHover.createDivString)(tooltipStyle.headerStyleString, header) + (0, _tooltipAndHover.createDivString)(tooltipStyle.bodyStyleString, body + tooltext);
                } // Drawing the tooltip at specific position


                tooltext !== '' && pointObj.endXPosition > xRange[0] && pointObj.x < xRange[1] ? tooltipAndHoverConfig.currentToolTip = // colY is applicable for candlestick
                toolTipController.drawAt(pointObj.x + (pointObj.width || 0) / 2 + xShift + translation.x, (pointObj.colY || pointObj.y) + translation.y, tooltext, tooltipAndHoverConfig.currentToolTip, canvas) : toolTipController.hide(tooltipAndHoverConfig.currentToolTip);
              } else {
                toolTipController.hide(tooltipAndHoverConfig.currentToolTip);
              }
            } else {
              toolTipController.hide(tooltipAndHoverConfig.currentToolTip);
            }
          }
        }
      }); // manage horizontal crossline

      horizontalCrossline = senderCanvas.getChildren('horizontalCrossLine') && senderCanvas.getChildren('horizontalCrossLine')[0];

      if (hoveredInfo.hovered && hoveredInfo.component.getType() === 'dataset' && isWithinCanvas) {
        if (hoveredInfo.pointObj.eventArgs.highValue && hoveredInfo.pointObj.eventArgs.lowValue) {
          values = [hoveredInfo.pointObj.eventArgs.highValue, hoveredInfo.pointObj.eventArgs.lowValue];
        } else {
          // FTV3-1076- correcting value in tooltip
          values = (0, _isValidNumber.default)(hoveredInfo.pointObj.yBaseValue) ? Math.abs(hoveredInfo.pointObj.yBaseValue) <= Math.abs(hoveredInfo.pointObj.value) ? [hoveredInfo.pointObj.value] : [hoveredInfo.pointObj.yBaseValue] : [hoveredInfo.pointObj.value];
        } // configure all horizontal cross-lines with new data


        dsConfig = hoveredInfo.component.config; // tells dataset that it is actually hovering over plot.
        // find the scale and alignment of the y-axis of the currently hovered dataset

        senderCanvas.config.yConfigs.forEach(function (yconfig) {
          if (yconfig.scale === hoveredInfo.component.config.scaleY) {
            yScale = yconfig.scale;
            yAlign = yconfig.align;
          }
        });
        dsConfig.visibility !== 'hidden' && horizontalCrossline.setData({
          values: values,
          scale: yScale,
          yAxisAlignment: yAlign,
          showMarker: true,
          texts: values,
          suffix: dsConfig.suffix,
          prefix: dsConfig.prefix,
          formatterFn: dsConfig.formatterFn,
          markerFill: getFirstDefinedColor([dsConfig.style && dsConfig.style.fill, dsConfig.plotStyle && dsConfig.plotStyle.fill, dsConfig.plotStyle && dsConfig.plotStyle.stroke])
        }, true);
      } else {
        // tells dataset that it is not hovered over plot.
        horizontalCrossline && horizontalCrossline.setData({
          values: []
        }, true);
      }
    };

    return _this;
  }

  var _proto = CrosslineManager.prototype;

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    _SmartRenderer.prototype.__setDefaultConfig.call(this);

    this.config.defaultFormat = DEFAULT_FORMAT;
    this.canvases = [];
  };

  _proto.configure = function configure() {
    _SmartRenderer.prototype.configure.call(this);

    var crosslineManager = this,
        chart = crosslineManager.getLinkedParent(),
        canvasLength = chart.config.focusPanels.length,
        mouseTracker,
        currentCanvas,
        i;
    crosslineManager.config.multiCanvasTooltip = (0, _lib.pluckNumber)(crosslineManager.getFromEnv('chart-attrib').multicanvastooltip, 1);

    for (i = 0; i < canvasLength; i++) {
      currentCanvas = chart.getChildren("canvas_" + i)[0];
      crosslineManager.canvases.push(currentCanvas);
      mouseTracker = currentCanvas.getFromEnv('mouseTracker'); // attach handler for showing and hiding crosslines.

      crosslineManager.addExtEventListener('canvasHovered', crosslineManager._handler, mouseTracker);
    }
  };

  return CrosslineManager;
}(_componentInterface.SmartRenderer);

var _default = CrosslineManager;
exports["default"] = _default;

/***/ }),

/***/ 891:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _assertThisInitialized2 = _interopRequireDefault(__webpack_require__(292));

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _componentInterface = __webpack_require__(290);

var _lib = __webpack_require__(274);

var _isValidNumber = _interopRequireDefault(__webpack_require__(856));

var anchorRadius = 3,
    GUTTER_5 = 5,
    M = 'M',
    L = 'L',
    h = 'h',
    v = 'v',
    z = 'z',
    COLOR_F3F3F3 = '#f3f3f3',
    COLOR_595959 = '#595959',
    RIGHT = 'right',
    MIDDLE = 'middle',
    ROLLOVER = 'referenceLineRollOver',
    ROLLOUT = 'referenceLineRollOut',
    CLICK = 'referenceLineClick',
    toString = function toString(x) {
  return x.toString();
};

var ReferenceLine = /*#__PURE__*/function (_SmartRenderer) {
  (0, _inheritsLoose2.default)(ReferenceLine, _SmartRenderer);

  /**
   * constructor fn
   */
  function ReferenceLine() {
    var _this;

    _this = _SmartRenderer.call(this) || this;
    var refLine = (0, _assertThisInitialized2.default)(_this),
        chart,
        config;

    refLine.hoverInHandler = function (e) {
      e.stopPropagation();
      refLine.setData({
        isHovered: true
      }, true);
      config = refLine.config;
      chart = refLine.getFromEnv('chart');
      chart.fireChartInstanceEvent(ROLLOVER, {
        label: config.label,
        value: config.value,
        valueFormatted: config.formattedMakerText
      });
    }; // eslint-disable-next-line


    refLine.moveHandler = function (e) {
      e.stopPropagation();
    };

    refLine.hoverOutHandler = function (e) {
      e.stopPropagation();
      refLine.setData({
        isHovered: false
      }, true);
      chart.fireChartInstanceEvent(ROLLOUT, {
        label: config.label,
        value: config.value,
        valueFormatted: config.formattedMakerText
      });
    };

    refLine.clickHandler = function (e) {
      e.stopPropagation();
      chart.fireChartInstanceEvent(CLICK, {
        label: config.label,
        value: config.value,
        valueFormatted: config.formattedMakerText
      });
    };

    return _this;
  }
  /**
   * Method that sets the default configuration of the component
   */


  var _proto = ReferenceLine.prototype;

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    _SmartRenderer.prototype.__setDefaultConfig.call(this);

    this.config.defaultStyle = {
      text: {
        fill: '#5F5F5F',
        'vertical-align': 'top',
        'opacity': '1',
        'fill-opacity': '1',
        'stroke-opacity': '1',
        'font-size': '11px',
        'font-style': 'normal'
      },
      marker: {
        fill: '#B70000',
        stroke: '#B70000',
        'fill-opacity': '1',
        'stroke-opacity': '1',
        'opacity': '1',
        borderthickness: 0,
        borderpadding: 2,
        borderradius: 0,
        borderdash: 'none',
        'stroke-width': '1'
      }
    };
    this.config.isHovered = false;
    this.config.formatterFn = toString;
    this.config.direction = RIGHT;
  }
  /**
   * Method that configures the component.
   * @param {Object} obj configuration object
   */
  ;

  _proto.configureAttributes = function configureAttributes(obj) {
    if (obj === void 0) {
      obj = {};
    }

    var refLine = this,
        selfConfig = refLine.config,
        getStyleDef = refLine.getFromEnv('getStyleDef');

    if (obj.referenceLine) {
      var refLineConfig = obj.referenceLine || {}; // parse and store configuration for label and marker

      if (refLineConfig.style) {
        selfConfig.markerStyle = getStyleDef(refLineConfig.style.marker || {});
        selfConfig.textStyle = getStyleDef(refLineConfig.style.text || {});
        selfConfig.alwaysVisible = refLineConfig.alwaysvisible || false;
      } else {
        selfConfig.markerStyle = {};
        selfConfig.textStyle = {};
      }

      selfConfig.label = (0, _lib.pluck)(refLineConfig.label, '');
      selfConfig.value = (0, _lib.pluckNumber)(refLineConfig.value, 0);
    }

    if (obj.yScale) selfConfig.yScale = obj.yScale;
    if (obj.formatterFn) selfConfig.formatterFn = obj.formatterFn;
    if (obj.prefix) selfConfig.prefix = obj.prefix;
    if (obj.suffix) selfConfig.suffix = obj.suffix;
    if (obj.direction) selfConfig.direction = obj.direction;
    if (obj.isHovered != null) selfConfig.isHovered = obj.isHovered;
    selfConfig.formattedValue = selfConfig.formatterFn({
      value: selfConfig.value,
      type: 'referenceline',
      prefix: selfConfig.prefix,
      suffix: selfConfig.suffix
    });
  }
  /**
   * Method to derive the path array based on the value and the direction
   * @return {Array} path array
   */
  ;

  _proto.getPathArr = function getPathArr() {
    var refLine = this,
        selfConfig = refLine.config,
        direction = selfConfig.direction,
        // the direction in which the line will be drawn
    canvasConfig = refLine.getLinkedParent().config,
        yScale = selfConfig.yScale,
        yScaleDomain = yScale.getDomain(),
        rangeValue,
        value = selfConfig.value,
        pathArr = []; // check if the provided domain falls within current domain.

    if ((0, _isValidNumber.default)(yScaleDomain[0]) && (0, _isValidNumber.default)(yScaleDomain[1]) && value >= yScaleDomain[0] && value <= yScaleDomain[1]) {
      // get the range value
      rangeValue = yScale.getRangeValue(value);

      switch (direction) {
        case 'left':
          pathArr = ['M', canvasConfig.canvasLeft + canvasConfig.canvasWidth - canvasConfig.borderConfig.rightBorder, rangeValue, 'h', -canvasConfig.canvasWidth];
          break;

        case 'top':
        case 'bottom':
          // vertical line
          pathArr = ['M', rangeValue, canvasConfig.canvasTop, 'v', canvasConfig.canvasHeight - canvasConfig.borderConfig.bottomBorder];
          break;

        case 'right':
        default:
          // horizontal line
          pathArr = ['M', canvasConfig.canvasLeft + canvasConfig.borderConfig.leftBorder, rangeValue, 'h', canvasConfig.canvasWidth];
      }
    }

    return pathArr;
  }
  /**
   * Method to derive the x and y position of the text and also its text anchor
   * based on the direction
   * @param {Array} pathArr path array
   * @return {Object} label properties
   */
  ;

  _proto.getLabelsProps = function getLabelsProps(pathArr, mergedMarkerStyle) {
    var refLineConfig = this.config,
        direction = refLineConfig.direction,
        // the direction in which the line will be drawn and bulb will be placed
    props = {
      isValidLabel: false
    };

    if (pathArr.length && refLineConfig.label) {
      props.isValidLabel = true; // label will be placed at the end of the line,
      // given the direction, calculate the end of the line along with some padding, so it doesn't overlap the anchor

      switch (direction) {
        case 'top':
          props.x = pathArr[1];
          props.y = pathArr[2];
          props.textAnchor = 'start';
          break;

        case 'bottom':
          props.x = pathArr[1];
          props.y = pathArr[4];
          props.textAnchor = 'start';
          break;

        case 'left':
          // Calculate x position using ref line path: start position x + horizontal lineto/length
          props.x = pathArr[1] + pathArr[4] + anchorRadius; // Some padding so it doesn't overlap the bulb

          props.y = pathArr[2] + mergedMarkerStyle.borderpadding;
          props.textAnchor = 'start';
          break;

        case 'right':
        default:
          // Calculate x position using ref line path: start position x + horizontal lineto/length
          props.x = pathArr[1] + pathArr[4] - mergedMarkerStyle.borderpadding - 1; // Some padding so it doesn't overlap the bulb

          props.y = pathArr[2] + mergedMarkerStyle.borderpadding;
          props.textAnchor = 'end';
      }
    }

    return props;
  }
  /**
   * Method to derive center point of bulb depending on the direction of reference line.
   * @param {Array} pathArr path Array
   */
  ;

  _proto.getBulbPoints = function getBulbPoints(pathArr) {
    var refLineConfig = this.config,
        direction = refLineConfig.direction,
        // the direction in which the line will be drawn and bulb will be placed
    bulbPoints = {};

    if (pathArr) {
      // given the direction, calculate end of the line to place the bulb
      switch (direction) {
        case 'left':
          // Calculate x position using ref line path: start position x + horizontal lineto/length
          bulbPoints.cx = pathArr[1] + pathArr[4] - anchorRadius; // Subtracting the bulb radius so it doesn't stick to edge of chart

          bulbPoints.cy = pathArr[2];
          break;

        case 'right':
        default:
          // Calculate x position using ref line path: start position x + horizontal lineto/length
          bulbPoints.cx = pathArr[1] + pathArr[4] + anchorRadius; // Adding the bulb radius so it doesn't stick to edge of chart

          bulbPoints.cy = pathArr[2];
      }
    }

    return bulbPoints;
  };

  _proto.getTagProps = function getTagProps(mergedMarkerStyle, flagStyle, textStyle) {
    var refLine = this,
        _this$config = this.config,
        value = _this$config.value,
        yScale = _this$config.yScale,
        direction = _this$config.direction,
        formattedValue = _this$config.formattedValue,
        smartLabel = refLine.getFromEnv('smartLabel'),
        smartText,
        _refLine$getLinkedPar = refLine.getLinkedParent().config,
        canvasLeft = _refLine$getLinkedPar.canvasLeft,
        canvasWidth = _refLine$getLinkedPar.canvasWidth,
        canvasLeftBorder = _refLine$getLinkedPar.borderConfig.leftBorder,
        canvasRight = canvasLeft + canvasWidth,
        rangeValue,
        tagWidth,
        tagPath,
        tagTextPosition = {},
        tagProps = {
      value: formattedValue
    };
    rangeValue = yScale.getRangeValue(value);
    smartLabel.setStyle({
      fontFamily: textStyle['font-family'],
      fontWeight: textStyle['font-weight'],
      fontSize: textStyle['font-size'],
      fontStyle: textStyle['font-style']
    });
    smartText = smartLabel.getSmartText(formattedValue);
    tagWidth = smartText.width + 2 * mergedMarkerStyle.borderpadding;

    switch (direction) {
      case 'left':
        tagPath = [M, canvasRight, rangeValue, L, canvasRight + GUTTER_5, rangeValue, L, canvasRight + 2 * GUTTER_5, rangeValue - smartText.height / 2 - 2 * flagStyle.marker.borderpadding, h, tagWidth, v, smartText.height + 4 * flagStyle.marker.borderpadding, h, -tagWidth, L, canvasRight + GUTTER_5, rangeValue, z];
        tagTextPosition.x = canvasRight + 2 * GUTTER_5 + tagWidth / 2;
        tagTextPosition.y = rangeValue;
        break;

      case 'right':
      default:
        tagPath = [M, canvasLeft + canvasLeftBorder, rangeValue, L, canvasLeft - GUTTER_5, rangeValue, L, canvasLeft - 2 * GUTTER_5, rangeValue - smartText.height / 2 - 2 * flagStyle.marker.borderpadding, h, -tagWidth, v, smartText.height + 4 * flagStyle.marker.borderpadding, h, tagWidth, L, canvasLeft - GUTTER_5, rangeValue, z];
        tagTextPosition.x = canvasLeft - 2 * GUTTER_5 - tagWidth / 2;
        tagTextPosition.y = rangeValue;
    }

    tagProps.value = formattedValue;
    tagProps.tagPath = tagPath;
    tagProps.tagTextPosition = tagTextPosition;
    return tagProps;
  };

  _proto.draw = function draw() {
    var refLine = this,
        selfConfig = refLine.config,
        mergedTextStyle,
        mergedMarkerStyle,
        selfDefaultStyle = selfConfig.defaultStyle,
        flagStyle,
        bulbStyle,
        flagStyleMarker,
        flagStyleText,
        textStyle = selfConfig.textStyle,
        markerStyle = selfConfig.markerStyle,
        label = selfConfig.label,
        value = selfConfig.value,
        pathArr,
        labelProps,
        bulbPoints,
        tagProps,
        tagPath,
        tagTextPosition,
        isHovered = selfConfig.isHovered,
        alwaysVisible = selfConfig.alwaysVisible,
        baseTextStyle = refLine.getFromEnv('baseTextStyle'); // create group for reference line

    refLine.addGraphicalElement({
      el: 'group',
      container: {
        id: 'thermo',
        label: 'group',
        isParent: true
      },
      component: refLine,
      label: 'refLine',
      attr: {
        name: 'reference-line-thermo'
      },
      id: 'thermo'
    }, true); // create two groups inside parent group first for path and circle element

    refLine.addGraphicalElement({
      el: 'group',
      container: {
        id: 'thermo',
        label: 'refLine'
      },
      component: refLine,
      label: 'refLine-thermo-hover-group',
      attr: {
        name: 'reference-line-hover-elem-group'
      },
      id: 'thermo'
    }, true); // second group is for hovered element like tags.

    refLine.addGraphicalElement({
      el: 'group',
      container: {
        id: 'thermo',
        label: 'refLine'
      },
      component: refLine,
      label: 'refLine-thermo-group',
      attr: {
        name: 'reference-line-group'
      },
      id: 'thermo'
    }, true);
    Object.assign(selfDefaultStyle.text, baseTextStyle); // merge chart default styles with refrence line styles

    mergedTextStyle = (0, _lib.extend2)((0, _lib.extend2)({}, selfDefaultStyle.text), textStyle);
    mergedMarkerStyle = (0, _lib.extend2)((0, _lib.extend2)({}, selfDefaultStyle.marker), markerStyle);
    bulbStyle = (0, _lib.extend2)({}, mergedMarkerStyle);
    pathArr = refLine.getPathArr();
    labelProps = refLine.getLabelsProps(pathArr, mergedMarkerStyle);
    bulbPoints = refLine.getBulbPoints(pathArr); // draw path only if it is valid.

    if (pathArr.length) {
      // reference line path
      refLine.addGraphicalElement({
        el: 'path',
        attr: {
          'path': pathArr,
          'stroke': mergedMarkerStyle.stroke || mergedMarkerStyle.fill,
          'fill-opacity': mergedMarkerStyle['fill-opacity'],
          'stroke-opacity': mergedMarkerStyle['stroke-opacity'],
          'stroke-width': mergedMarkerStyle['stroke-width'],
          'stroke-linecap': mergedMarkerStyle['stroke-linecap'],
          'opacity': mergedMarkerStyle.opacity * (isHovered || alwaysVisible ? 1 : 0.4),
          'stroke-dasharray': mergedMarkerStyle['stroke-dasharray'] || 'none'
        },
        container: {
          label: 'refLine-thermo-group'
        },
        component: refLine,
        label: 'line'
      }, true); // draw anchor

      bulbStyle['stroke-width'] = isHovered || alwaysVisible ? mergedMarkerStyle['stroke-width'] || 1 : 0;
      bulbStyle.stroke = markerStyle && markerStyle.stroke || COLOR_595959;
      refLine.addGraphicalElement({
        el: 'circle',
        attr: {
          cx: bulbPoints.cx,
          cy: bulbPoints.cy,
          r: anchorRadius
        },
        container: {
          label: 'refLine-thermo-group'
        },
        css: bulbStyle,
        component: refLine,
        label: 'anchor'
      });
      selfConfig.formattedMakerText = selfConfig.formatterFn({
        value: value,
        type: 'referenceline',
        prefix: selfConfig.prefix,
        suffix: selfConfig.suffix
      });

      if (isHovered || alwaysVisible) {
        // draw label only if it is valid and anchor is hovered.
        flagStyle = (0, _lib.extend2)((0, _lib.extend2)((0, _lib.extend2)({}, selfDefaultStyle), {
          text: {
            fill: COLOR_F3F3F3
          }
        }), {
          text: textStyle,
          marker: markerStyle
        });

        if (labelProps.isValidLabel) {
          // reference line text
          refLine.addGraphicalElement({
            el: 'text',
            attr: {
              'text': label,
              'x': labelProps.x,
              'y': labelProps.y - mergedMarkerStyle.borderpadding * (mergedTextStyle['vertical-align'] === 'top' ? -1 : 1),
              'opacity': mergedTextStyle.opacity,
              'text-anchor': labelProps.textAnchor,
              'text-bound': [mergedMarkerStyle.fill, mergedMarkerStyle.fill, mergedMarkerStyle.borderthickness, mergedMarkerStyle.borderpadding, mergedMarkerStyle.borderradius, mergedMarkerStyle.borderdash, 0.2]
            },
            css: mergedTextStyle,
            container: {
              label: 'refLine-thermo-hover-group'
            },
            component: refLine,
            label: 'label'
          }, true);
        } // draw tag


        tagProps = refLine.getTagProps(mergedMarkerStyle, flagStyle, mergedTextStyle);
        tagPath = tagProps.tagPath;
        tagTextPosition = tagProps.tagTextPosition;
        flagStyleMarker = (0, _lib.extend2)({}, flagStyle.marker);
        !flagStyleMarker.stroke && (flagStyleMarker.stroke = 'none');
        refLine.addGraphicalElement({
          el: 'path',
          attr: {
            path: tagPath
          },
          container: {
            label: 'refLine-thermo-hover-group'
          },
          css: flagStyleMarker,
          component: refLine,
          label: 'tag'
        }, true); // text

        flagStyleText = (0, _lib.extend2)({}, flagStyle.text);
        !flagStyleText['text-anchor'] && (flagStyleText['text-anchor'] = 'middle');
        flagStyleText['vertical-align'] = MIDDLE;
        refLine.addGraphicalElement({
          el: 'text',
          attr: {
            text: selfConfig.formattedValue,
            x: tagTextPosition.x,
            y: tagTextPosition.y
          },
          css: flagStyleText,
          container: {
            label: 'refLine-thermo-hover-group'
          },
          component: refLine,
          label: 'tag-text'
        }, true);
      }
    }
  };

  return ReferenceLine;
}(_componentInterface.SmartRenderer);

var _default = ReferenceLine;
exports["default"] = _default;

/***/ }),

/***/ 893:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _assertThisInitialized2 = _interopRequireDefault(__webpack_require__(292));

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _componentInterface = __webpack_require__(290);

var _lib = __webpack_require__(274);

var M = 'M',
    h = 'h',
    v = 'v',
    Z = 'Z',
    L = 'L',
    GUTTER = 1,
    GUTTER_5 = 5,
    GUTTER_1 = 1,
    COLOR_F3F3F3 = '#f3f3f3',
    anchorRadius = 3,
    BOTTOM = 'bottom',
    TOP = 'top',
    ROLLOVER = 'referenceZoneRollOver',
    ROLLOUT = 'referenceZoneRollOut',
    CLICK = 'referenceZoneClick',
    isWithinYRange = function isWithinYRange(value, range) {
  return value >= range[1] && value <= range[0];
},
    defaultStyle = {
  marker: {
    fill: '#f76260',
    stroke: '#f76260',
    'fill-opacity': '1',
    'stroke-opacity': '1',
    'opacity': '1',
    borderthickness: 0,
    borderpadding: 2,
    borderradius: 0,
    borderdash: 'none',
    'stroke-width': 1
  },
  'marker-zone': {
    'stroke': '#f76260',
    'fill-opacity': 0.2,
    'fill': '#f76260',
    'stroke-opacity': 1,
    'stroke-width': 0
  },
  'marker-zone:hover': {
    'stroke': '#f76260',
    'fill-opacity': 0.3,
    'fill': '#f76260',
    'stroke-opacity': 1,
    'stroke-width': 1
  },
  'marker-notch': {
    'stroke-width': 0,
    'stroke': '#f76260',
    'fill': '#f76260',
    'fill-opacity': 1
  },
  'marker-notch:hover': {
    'stroke-width': 1,
    'stroke': '#f76260',
    'fill': '#f76260',
    'fill-opacity': 0.5
  },
  'marker-tag': {
    fill: '#f76260',
    stroke: '#f76260',
    'fill-opacity': '1',
    'stroke-opacity': '1',
    'opacity': '1',
    borderthickness: 0,
    borderpadding: 2,
    borderradius: 0,
    borderdash: 'none',
    'stroke-width': 1
  },
  'marker-notch-connector': {
    fill: 'none',
    stroke: '#f76260',
    'fill-opacity': '1',
    'stroke-opacity': '1',
    'opacity': '1',
    'stroke-width': 1
  },
  text: {
    fill: '#5F5F5F',
    'vertical-align': 'top',
    'opacity': '1',
    'fill-opacity': '1',
    'stroke-opacity': '1',
    'font-size': '11px',
    'font-style': 'normal'
  },
  'marker-text': {
    fill: COLOR_F3F3F3,
    'vertical-align': 'middle',
    'text-anchor': 'middle',
    'opacity': '1',
    'fill-opacity': '1',
    'stroke-opacity': '1',
    'font-size': '11px',
    'font-style': 'normal'
  }
};

var ReferenceZone = /*#__PURE__*/function (_SmartRenderer) {
  (0, _inheritsLoose2.default)(ReferenceZone, _SmartRenderer);

  function ReferenceZone() {
    var _this;

    _this = _SmartRenderer.call(this) || this;
    var refzone = (0, _assertThisInitialized2.default)(_this),
        config = refzone.config,
        chart,
        scale,
        maxVaueFormatted,
        minValueFormatted;

    refzone.hoverInHandler = function (e) {
      e.stopPropagation();
      chart = refzone.getFromEnv('chart');
      scale = config.yScale;
      refzone.setState('hovered', true);
      refzone.asyncDraw();
      refzone.fireEvent('referenceZoneHovered', {
        hovered: true,
        scale: config.yScale,
        range: {
          minValue: scale.getRangeValue(config.minValue),
          maxValue: scale.getRangeValue(config.maxValue)
        }
      });
      maxVaueFormatted = config.formatterFn({
        value: config.maxValue,
        type: 'referenceline',
        prefix: config.prefix,
        suffix: config.suffix
      });
      minValueFormatted = config.formatterFn({
        value: config.minValue,
        type: 'referenceline',
        prefix: config.prefix,
        suffix: config.suffix
      });
      chart.fireChartInstanceEvent(ROLLOVER, {
        label: config.label,
        valueMax: config.maxValue,
        valueMin: config.minValue,
        valueMaxFormatted: maxVaueFormatted,
        valueMinFormatted: minValueFormatted
      });
    }; // eslint-disable-next-line


    refzone.moveHandler = function (e) {
      e.stopPropagation();
    };

    refzone.hoverOutHandler = function (e) {
      e.stopPropagation();
      refzone.setState('hovered', false);
      refzone.asyncDraw();
      refzone.fireEvent('referenceZoneHovered', {
        hovered: false,
        scale: config.yScale,
        range: {
          minValue: scale.getRangeValue(config.minValue),
          maxValue: scale.getRangeValue(config.maxValue)
        }
      });
      chart.fireChartInstanceEvent(ROLLOUT, {
        label: config.label,
        valueMax: config.maxValue,
        valueMin: config.minValue,
        valueMaxFormatted: maxVaueFormatted,
        valueMinFormatted: minValueFormatted
      });
    };

    refzone.clickHandler = function (e) {
      e.stopPropagation();
      chart.fireChartInstanceEvent(CLICK, {
        label: config.label,
        valueMax: config.maxValue,
        valueMin: config.minValue,
        valueMaxFormatted: maxVaueFormatted,
        valueMinFormatted: minValueFormatted
      });
    };

    refzone.referenceZoneHoveredHandler = function (e) {
      var eventData = e.data,
          canvas = refzone.getLinkedParent();
      canvas.highlightDataPoints(eventData.hovered, eventData.scale, eventData.range);
    };

    refzone.canvasHoveredHandler = function (e) {
      var canvas = refzone.getLinkedParent(),
          _refzone$config = refzone.config,
          yScale = _refzone$config.yScale,
          minValue = _refzone$config.minValue,
          maxValue = _refzone$config.maxValue;

      if (refzone.getState('hovered')) {
        refzone.setState('hovered', false);
        refzone.asyncDraw();
        canvas.highlightDataPoints(false, yScale, {
          minValue: yScale.getRangeValue(minValue),
          maxValue: yScale.getRangeValue(maxValue)
        });
      }
    };

    return _this;
  }

  var _proto = ReferenceZone.prototype;

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    _SmartRenderer.prototype.__setDefaultConfig.call(this);

    this.config.extStyle = {};
  }
  /**
   * Method that configures the component.
   * @param {Object} obj configuration object
   */
  ;

  _proto.configureAttributes = function configureAttributes(obj) {
    if (obj === void 0) {
      obj = {};
    }

    _SmartRenderer.prototype.configureAttributes.call(this, obj);

    var refZone = this,
        selfConfig = refZone.config,
        refZoneConfig = obj.referenceLine || {},
        minValue,
        maxValue;
    minValue = (0, _lib.pluckNumber)(refZoneConfig.valuemin, 0);
    maxValue = (0, _lib.pluckNumber)(refZoneConfig.valuemax, 0);
    selfConfig.label = (0, _lib.pluck)(refZoneConfig.label, ''); // swap values if min is greater than max value

    if (minValue > maxValue) {
      var _ref = [maxValue, minValue];
      minValue = _ref[0];
      maxValue = _ref[1];
    }

    selfConfig.minValue = minValue;
    selfConfig.maxValue = maxValue;

    for (var key in obj) {
      if (obj.hasOwnProperty(key)) {
        this.config[key] = obj[key];
      }
    }

    selfConfig.formattedMinValue = selfConfig.formatterFn({
      value: selfConfig.minValue,
      type: 'referenceline',
      prefix: selfConfig.prefix,
      suffix: selfConfig.suffix
    });
    selfConfig.formattedMaxValue = selfConfig.formatterFn({
      value: selfConfig.maxValue,
      type: 'referenceline',
      prefix: selfConfig.prefix,
      suffix: selfConfig.suffix
    });
    refZone.createStyleDefinition();
  };

  _proto.createStyleDefinition = function createStyleDefinition() {
    var refZone = this,
        config = refZone.config,
        extStyle = config.extStyle,
        getStyleDef = refZone.getFromEnv('getStyleDef'),
        baseTextStyle = refZone.getFromEnv('baseTextStyle'),
        extMarkerStyle = getStyleDef(extStyle.marker),
        extMarkerHoverStyle = getStyleDef(extStyle['marker:hover']),
        extMarkerZoneStyle = getStyleDef(extStyle['marker-zone']),
        extMarkerZoneHoverStyle = getStyleDef(extStyle['marker-zone:hover']),
        extMarkerTagStyle = getStyleDef(extStyle['marker-tag']),
        extTextStyle = getStyleDef(extStyle.text),
        extMarkerTextStyle = getStyleDef(extStyle['marker-text']),
        extMarkerNotchStyle = getStyleDef(extStyle['marker-notch']),
        extMarkerNotchHoverStyle = getStyleDef(extStyle['marker-notch:hover']),
        extMarkerNotchConnectorStyle = getStyleDef(extStyle['marker-notch-connector']),
        extMarkerNotchConnectorHoverStyle = getStyleDef(extStyle['marker-notch-connector:hover']);
    config.styleDefinition = {
      marker: Object.assign({}, defaultStyle.marker, extMarkerStyle),
      'marker:hover': Object.assign({}, defaultStyle.marker, extMarkerHoverStyle),
      'marker-zone': Object.assign({}, defaultStyle['marker-zone'], extMarkerStyle, extMarkerZoneStyle),
      'marker-zone:hover': Object.assign({}, extMarkerStyle, extMarkerZoneStyle, defaultStyle['marker-zone:hover'], extMarkerHoverStyle, extMarkerZoneHoverStyle),
      'marker-tag': Object.assign({}, defaultStyle['marker-tag'], extMarkerStyle, extMarkerTagStyle),
      text: Object.assign({}, baseTextStyle, defaultStyle.text, extTextStyle),
      'marker-text': Object.assign({}, baseTextStyle, defaultStyle['marker-text'], extTextStyle, extMarkerTextStyle),
      'marker-notch': Object.assign({}, defaultStyle['marker-notch'], extMarkerStyle, extMarkerNotchStyle),
      'marker-notch:hover': Object.assign({}, extMarkerStyle, extMarkerNotchStyle, defaultStyle['marker-notch:hover'], extMarkerHoverStyle, extMarkerNotchHoverStyle),
      'marker-notch-connector': Object.assign({}, defaultStyle['marker-notch-connector'], extMarkerStyle, extMarkerNotchConnectorStyle),
      'marker-notch-connector:hover': Object.assign({}, defaultStyle['marker-notch-connector'], extMarkerStyle, extMarkerNotchConnectorStyle, extMarkerHoverStyle, extMarkerNotchConnectorHoverStyle)
    };
  }
  /**
   * Method to derive the path array of zone and connector based on the range values and the direction
   * @return {Object} path array
   */
  ;

  _proto.getMarkerPath = function getMarkerPath() {
    var refLine = this,
        selfConfig = refLine.config,
        direction = selfConfig.direction,
        // the direction in which the line will be drawn
    canvasConfig = refLine.getLinkedParent().config,
        canvasLeft = canvasConfig.canvasLeft,
        canvasWidth = canvasConfig.canvasWidth,
        canvasTop = canvasConfig.canvasTop,
        canvasHeight = canvasConfig.canvasHeight,
        canvasRight = canvasLeft + canvasWidth,
        canvasBottom = canvasTop + canvasHeight,
        rightBorder = canvasConfig.borderConfig.rightBorder,
        leftBorder = canvasConfig.borderConfig.leftBorder,
        topBorder = canvasConfig.borderConfig.topBorder,
        bottomBorder = canvasConfig.borderConfig.bottomBorder,
        yScale = selfConfig.yScale,
        minRangeValue,
        maxRangeValue,
        minValue = selfConfig.minValue,
        maxValue = selfConfig.maxValue,
        rangeDiffPx,
        zonePathArr = [],
        connectorPathArr = []; // get the range value

    minRangeValue = yScale.getRangeValue(minValue);
    maxRangeValue = yScale.getRangeValue(maxValue);
    rangeDiffPx = minRangeValue - maxRangeValue;

    switch (direction) {
      case 'left':
        zonePathArr = [M, canvasRight - rightBorder, maxRangeValue, h, -canvasWidth, v, rangeDiffPx, h, canvasWidth, Z];
        connectorPathArr = [M, canvasRight - rightBorder - canvasWidth, maxRangeValue, v, rangeDiffPx];
        break;

      case 'right':
        zonePathArr = [M, canvasLeft + leftBorder, maxRangeValue, h, canvasWidth, v, rangeDiffPx, h, -canvasWidth, Z];
        connectorPathArr = [M, canvasLeft + leftBorder + canvasWidth, maxRangeValue, v, rangeDiffPx];
        break;

      case 'top':
        zonePathArr = [M, minRangeValue, canvasBottom - bottomBorder, v, -canvasHeight, h, rangeDiffPx, v, canvasHeight, Z];
        connectorPathArr = [M, minRangeValue, canvasBottom - bottomBorder - canvasHeight, h, rangeDiffPx];
        break;

      case 'bottom':
        zonePathArr = [M, minRangeValue, canvasTop + topBorder, v, canvasHeight, h, rangeDiffPx, v, -canvasHeight, Z];
        connectorPathArr = [M, minRangeValue, canvasTop + topBorder + canvasHeight, h, rangeDiffPx];
        break;
    }

    return {
      connectorPath: connectorPathArr,
      zonePath: zonePathArr
    };
  }
  /**
   * Method to derive the x and y position of the text and also its text anchor
   * based on the direction
   * @param {Array} pathArr path array
   * @return {Object} label properties
   */
  ;

  _proto.getLabelsProps = function getLabelsProps(pathArr, styleDefinition) {
    var refLine = this,
        mergedMarkerStyle = styleDefinition.marker,
        textStyle = styleDefinition.text,
        refLineConfig = refLine.config,
        canvasConfig = refLine.getLinkedParent().config,
        direction = refLineConfig.direction,
        // the direction in which the line will be drawn and bulb will be placed
    props = {
      isValidLabel: false
    };

    if (pathArr.length && refLineConfig.label) {
      props.isValidLabel = true; // label will be placed at the end of the line,
      // given the direction, calculate the end of the line along with some padding, so it doesn't overlap the anchor

      switch (direction) {
        case 'top':
          props.x = pathArr[1];
          props.y = pathArr[2] + pathArr[4];
          props.textAnchor = 'start';
          break;

        case 'bottom':
          props.x = pathArr[1];
          props.y = pathArr[2] + pathArr[4];
          props.textAnchor = 'start';
          break;

        case 'left':
          // Calculate x position using ref line path: start position x + horizontal lineto/length
          props.x = pathArr[1] + pathArr[4] + anchorRadius; // Some padding so it doesn't overlap the bulb

          props.y = pathArr[2] + pathArr[6] + mergedMarkerStyle.borderpadding;
          props.textAnchor = 'start';
          break;

        case 'right':
          // Calculate x position using ref line path: start position x + horizontal lineto/length
          props.x = pathArr[1] + pathArr[4] - mergedMarkerStyle.borderpadding - 1; // Some padding so it doesn't overlap the bulb

          props.y = pathArr[2] + pathArr[6] + mergedMarkerStyle.borderpadding;
          props.textAnchor = 'end';
      } // restricting positon of referencezone label when going outside canvas


      if (canvasConfig.canvasBGHeight < props.y) {
        props.y = canvasConfig.canvasBGHeight - 2 * mergedMarkerStyle.borderpadding;
        textStyle['vertical-align'] = BOTTOM;
      } else {
        textStyle['vertical-align'] = TOP;
      }
    }

    return props;
  }
  /**
   * Method to derive center point of bulb depending on the direction of reference line.
   * @param {Array} pathArr path Array
   */
  ;

  _proto.getBulbPoints = function getBulbPoints(pathArr) {
    var refLineConfig = this.config,
        direction = refLineConfig.direction,
        // the direction in which the line will be drawn and bulb will be placed
    scale = refLineConfig.yScale,
        scaleRange = scale.getRange(),
        bulbPoints = [];

    if (pathArr) {
      // given the direction, calculate end of the line to place the bulb
      switch (direction) {
        case 'left':
          // push the co-ordinates of the first bulb point
          isWithinYRange(pathArr[2], scaleRange) && bulbPoints.push({
            cx: pathArr[1] + pathArr[4],
            cy: pathArr[2]
          }); // push the co-ordinates of the second bulb point

          isWithinYRange(pathArr[2] + pathArr[6], scaleRange) && bulbPoints.push({
            cx: pathArr[1] + pathArr[4],
            cy: pathArr[2] + pathArr[6]
          });
          break;

        case 'right':
          // push the co-ordinates of the first bulb point
          isWithinYRange(pathArr[2], scaleRange) && bulbPoints.push({
            cx: pathArr[1] + pathArr[4],
            cy: pathArr[2]
          }); // push the co-ordinates of the second bulb point

          isWithinYRange(pathArr[2] + pathArr[6], scaleRange) && bulbPoints.push({
            cx: pathArr[1] + pathArr[4],
            cy: pathArr[2] + pathArr[6]
          });
      }
    }

    return bulbPoints;
  };

  _proto.getTagProps = function getTagProps(mergedMarkerStyle, flagStyle, textStyle) {
    var refLine = this,
        _this$config = this.config,
        yScale = _this$config.yScale,
        minValue = _this$config.minValue,
        maxValue = _this$config.maxValue,
        direction = _this$config.direction,
        formattedMinValue = _this$config.formattedMinValue,
        formattedMaxValue = _this$config.formattedMaxValue,
        scaleRange = yScale.getRange(),
        smartLabel = refLine.getFromEnv('smartLabel'),
        flagBorderPadding = 2 * flagStyle.borderpadding,
        tagPadding = 2 * (mergedMarkerStyle.borderpadding + GUTTER_1),
        minSmartText,
        maxSmartText,
        _refLine$getLinkedPar = refLine.getLinkedParent().config,
        canvasLeft = _refLine$getLinkedPar.canvasLeft,
        canvasWidth = _refLine$getLinkedPar.canvasWidth,
        canvasLeftBorder = _refLine$getLinkedPar.borderConfig.leftBorder,
        canvasRight = canvasLeft + canvasWidth,
        minRangeValue,
        maxRangeValue,
        tagWidth,
        tagProps = [];
    minRangeValue = yScale.getRangeValue(minValue);
    maxRangeValue = yScale.getRangeValue(maxValue);
    smartLabel.setStyle({
      fontFamily: textStyle['font-family'],
      fontWeight: textStyle['font-weight'],
      fontSize: textStyle['font-size'],
      fontStyle: textStyle['font-style']
    });

    switch (direction) {
      case 'left':
        minSmartText = smartLabel.getSmartText(formattedMinValue);
        maxSmartText = smartLabel.getSmartText(formattedMaxValue);
        tagWidth = Math.max(minSmartText.width, maxSmartText.width) + tagPadding; // push dimension of the min value tag

        isWithinYRange(minRangeValue, scaleRange) && tagProps.push({
          tagPath: [M, canvasRight, minRangeValue, L, canvasRight + GUTTER_5, minRangeValue, L, canvasRight + 2 * GUTTER_5, minRangeValue - minSmartText.height / 2 - flagBorderPadding, h, tagWidth, v, minSmartText.height + 4 * flagStyle.borderpadding, h, -tagWidth, L, canvasRight + GUTTER_5, minRangeValue, Z],
          tagTextProps: {
            x: canvasRight + 2 * GUTTER_5 + tagWidth / 2,
            y: minRangeValue,
            value: formattedMinValue
          }
        }); // push dimension of the max value tag

        isWithinYRange(maxRangeValue, scaleRange) && tagProps.push({
          tagPath: [M, canvasRight, maxRangeValue, L, canvasRight + GUTTER_5, maxRangeValue, L, canvasRight + 2 * GUTTER_5, maxRangeValue - maxSmartText.height / 2 - flagBorderPadding, h, tagWidth, v, maxSmartText.height + 4 * flagStyle.borderpadding, h, -tagWidth, L, canvasRight + GUTTER_5, maxRangeValue, Z],
          tagTextProps: {
            x: canvasRight + 2 * GUTTER_5 + tagWidth / 2,
            y: maxRangeValue,
            value: formattedMaxValue
          }
        });
        break;

      case 'right':
      default:
        minSmartText = smartLabel.getSmartText(formattedMinValue);
        maxSmartText = smartLabel.getSmartText(formattedMaxValue);
        tagWidth = Math.max(minSmartText.width, maxSmartText.width) + tagPadding; // push dimension of the min value tag

        isWithinYRange(minRangeValue, scaleRange) && tagProps.push({
          tagPath: [M, canvasLeft + canvasLeftBorder, minRangeValue, L, canvasLeft - GUTTER_5, minRangeValue, L, canvasLeft - 2 * GUTTER_5, minRangeValue - minSmartText.height / 2 - flagBorderPadding, h, -tagWidth, v, minSmartText.height + 4 * flagStyle.borderpadding, h, tagWidth, L, canvasLeft - GUTTER_5, minRangeValue, Z],
          tagTextProps: {
            x: canvasLeft - 2 * GUTTER_5 - tagWidth / 2,
            y: minRangeValue,
            value: formattedMinValue
          }
        }); // push dimension of the max value tag

        isWithinYRange(maxRangeValue, scaleRange) && tagProps.push({
          tagPath: [M, canvasLeft + canvasLeftBorder, maxRangeValue, L, canvasLeft - GUTTER_5, maxRangeValue, L, canvasLeft - 2 * GUTTER_5, maxRangeValue - maxSmartText.height / 2 - flagBorderPadding, h, -tagWidth, v, maxSmartText.height + 4 * flagStyle.borderpadding, h, tagWidth, L, canvasLeft - GUTTER_5, maxRangeValue, Z],
          tagTextProps: {
            x: canvasLeft - 2 * GUTTER_5 - tagWidth / 2,
            y: maxRangeValue,
            value: formattedMaxValue
          }
        });
    }

    return tagProps;
  };

  _proto.draw = function draw() {
    var refZone = this,
        selfConfig = refZone.config,
        styleDefinition = selfConfig.styleDefinition,
        label = selfConfig.label,
        markerPath,
        zonePath,
        labelProps,
        bulbPoints,
        tagProps,
        tagPath,
        tagTextProps,
        isHovered = refZone.getState('hovered'),
        canvasConfig = refZone.getLinkedParent().config,
        padding = canvasConfig.padding,
        connectorStyle = isHovered ? styleDefinition['marker-notch-connector:hover'] : styleDefinition['marker-notch-connector'],
        strokeWidth = Number.parseFloat(connectorStyle['stroke-width']) + GUTTER,
        // Taking the padding into consideration as the clip-rect is shifed based on the translation applied
    // on the group
    left = canvasConfig.canvasBGLeft - padding.left - anchorRadius - (selfConfig.direction === 'left' ? strokeWidth : 0),
        top = canvasConfig.canvasBGTop - padding.top - anchorRadius,
        width = canvasConfig.canvasBGWidth + 2 * anchorRadius + strokeWidth,
        height = canvasConfig.canvasBGHeight + 2 * anchorRadius,
        clipPath = ["M" + left + "," + top, "L" + (left + width) + "," + top, "L" + (left + width) + "," + (top + height), "L" + left + "," + (top + height) + "Z"]; // create group for reference zone

    refZone.addGraphicalElement({
      el: 'group',
      container: {
        id: 'exo',
        label: 'group',
        isParent: true
      },
      component: refZone,
      label: 'refZone',
      attr: {
        name: 'reference-zone-exo'
      },
      id: 'exo'
    }, true);
    refZone.addGraphicalElement({
      el: 'group',
      container: {
        id: 'exo',
        label: 'refZone'
      },
      component: refZone,
      label: 'refZone-exo-group',
      attr: {
        name: 'reference-zone-group',
        'clip-path': clipPath
      },
      id: 'exo'
    }, true);
    refZone.addGraphicalElement({
      el: 'group',
      container: {
        id: 'exo',
        label: 'refZone'
      },
      component: refZone,
      label: 'refZone-exo-hover-group',
      attr: {
        name: 'reference-zone-hover-elem-group'
      },
      id: 'exo'
    }, true);
    markerPath = refZone.getMarkerPath();
    zonePath = markerPath.zonePath;
    labelProps = refZone.getLabelsProps(zonePath, styleDefinition);
    bulbPoints = refZone.getBulbPoints(zonePath); // draw path only if it is valid.

    if (zonePath.length) {
      // reference zone path
      refZone.addGraphicalElement({
        el: 'path',
        attr: {
          'path': zonePath
        },
        container: {
          label: 'refZone-exo-group'
        },
        css: isHovered ? styleDefinition['marker-zone:hover'] : styleDefinition['marker-zone'],
        component: refZone,
        label: 'line'
      }, true); // draw anchor
      // create reference zone bulbs

      bulbPoints.forEach(function (bulbPoint) {
        refZone.addGraphicalElement({
          el: 'circle',
          attr: {
            cx: bulbPoint.cx,
            cy: bulbPoint.cy,
            r: anchorRadius
          },
          container: {
            label: 'refZone-exo-hover-group'
          },
          css: isHovered ? styleDefinition['marker-notch:hover'] : styleDefinition['marker-notch'],
          component: refZone,
          label: 'anchor'
        });
      }); // bulb connector path

      refZone.addGraphicalElement({
        el: 'path',
        attr: {
          path: markerPath.connectorPath
        },
        container: {
          label: 'refZone-exo-group'
        },
        css: connectorStyle,
        component: refZone,
        label: 'anchorConnector'
      });

      if (isHovered) {
        // draw label only if it is valid and anchor is hovered.
        if (labelProps.isValidLabel) {
          refZone.addGraphicalElement({
            el: 'text',
            attr: {
              'text': label,
              'x': labelProps.x,
              'y': labelProps.y - styleDefinition.marker.borderpadding * (styleDefinition.text['vertical-align'] === 'top' ? -1 : 1),
              'text-anchor': labelProps.textAnchor
            },
            css: styleDefinition.text,
            container: {
              label: 'refZone-exo-hover-group'
            },
            outlineText: selfConfig.showTextOutline,
            component: refZone,
            label: 'label'
          }, true);
        } // draw tag


        tagProps = refZone.getTagProps(styleDefinition.marker, styleDefinition['marker-tag'], styleDefinition.text);
        tagProps.forEach(function (tagProp) {
          tagPath = tagProp.tagPath;
          tagTextProps = tagProp.tagTextProps;
          refZone.addGraphicalElement({
            el: 'path',
            attr: {
              path: tagPath
            },
            container: {
              label: 'refZone-exo-hover-group'
            },
            css: styleDefinition['marker-tag'],
            component: refZone,
            label: 'tag'
          }, true); // text

          refZone.addGraphicalElement({
            el: 'text',
            attr: {
              text: tagTextProps.value,
              x: tagTextProps.x,
              y: tagTextProps.y
            },
            css: styleDefinition['marker-text'],
            container: {
              label: 'refZone-exo-hover-group'
            },
            component: refZone,
            label: 'tag-text'
          }, true);
        });
      }
    }
  };

  return ReferenceZone;
}(_componentInterface.SmartRenderer);

var _default = ReferenceZone;
exports["default"] = _default;

/***/ }),

/***/ 981:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _toolbox = __webpack_require__(418);

var _lib = __webpack_require__(274);

var SmartToolbar = /*#__PURE__*/function (_ToolBar) {
  (0, _inheritsLoose2.default)(SmartToolbar, _ToolBar);

  function SmartToolbar() {
    return _ToolBar.apply(this, arguments) || this;
  }

  var _proto = SmartToolbar.prototype;

  /**
   * configures the attributes
   *
   * @param {any} [options={}] options
   * @memberof SmartToolbar
   */
  _proto.configureAttributes = function configureAttributes(options) {
    if (options === void 0) {
      options = {};
    }

    var toolbar = this,
        conf = toolbar.config,
        chartConfig = toolbar.getFromEnv('chartConfig'),
        child,
        key,
        i,
        len,
        tool;
    this.props.width = (0, _lib.pluckNumber)(options.width, this.props.width, 0);
    this.props.height = (0, _lib.pluckNumber)(options.height, this.props.height, 0);
    conf.orientation = (0, _lib.pluck)(options.toolbarorientation, conf.orientation);
    conf.hPadding = (0, _lib.pluck)(options.toolbarhpadding, conf.hPadding);
    conf.vPadding = (0, _lib.pluck)(options.toolbarvpadding, conf.vPadding);
    conf.backgroundcolor = (0, _lib.pluck)(options.toolbarbackgroundcolor, conf.backgroundcolor);
    conf.backgroundalpha = (0, _lib.pluck)(options.toolbarbackgroundalpha, conf.backgroundalpha);
    conf.bordercolor = (0, _lib.pluck)(options.toolbarbordercolor, conf.bordercolor);
    conf.borderalpha = (0, _lib.pluck)(options.toolbarborderalpha, conf.borderalpha);
    conf.borderthickness = (0, _lib.pluck)(options.toolbarborderthickness, conf.borderthickness);
    conf.hDirection = (0, _lib.pluckNumber)(options.toolbarhdirection, chartConfig.toolbarHAlign === 'r' ? -1 : 1);
    conf.vDirection = (0, _lib.pluckNumber)(options.toolbarvdirection, chartConfig.toolbarBAlign === 'b' ? -1 : 1);
    conf.hAlign = (0, _lib.pluck)(options.hAlign, 'center').toLowerCase();
    conf.vAlign = (0, _lib.pluck)(options.vAlign, 'middle').toLowerCase();
    conf.marginTop = (0, _lib.pluckNumber)(options.marginTop, options.spacing, conf.marginTop);
    conf.marginLeft = (0, _lib.pluckNumber)(options.marginLeft, options.spacing, conf.marginLeft);
    conf.marginRight = (0, _lib.pluckNumber)(options.marginRight, options.spacing, conf.marginRight);
    conf.marginBottom = (0, _lib.pluckNumber)(options.marginBottom, options.spacing, conf.marginBottom);
    conf.child = options.child || conf.child;

    if (conf.child) {
      child = conf.child;
      key = Object.keys(conf.child);

      for (i = 0, len = key.length; i < len; i++) {
        tool = toolbar.attachChild(child[key[i]].def, child[key[i]].type, key[i]);
        tool.setData(child[key[i]].configuration, true);
        tool.setState('visible', true);
      }
    }
  };

  return SmartToolbar;
}(_toolbox.ToolBar);

var _default = SmartToolbar;
exports["default"] = _default;

/***/ }),

/***/ 986:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _assertThisInitialized2 = _interopRequireDefault(__webpack_require__(292));

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _tools = __webpack_require__(419);

var HOVER = 'hover',
    NORMAL = 'normal',
    VISIBLE = 'visible',
    PRESSED = 'pressed';

function mouseOver() {
  this.setData({
    hoveredState: HOVER
  }, true);
}

function mouseOut() {
  this.setData({
    hoveredState: NORMAL
  }, true);
}

var SRSTool = /*#__PURE__*/function (_Tool) {
  (0, _inheritsLoose2.default)(SRSTool, _Tool);

  /**
   * Creates an instance of SRSTool.
   * @param {any} id id
   * @memberof SRSTool
   */
  function SRSTool(id) {
    var _this;

    _this = _Tool.call(this, id) || this;

    _this.addEventListener('fc-mouseover', mouseOver.bind((0, _assertThisInitialized2.default)(_this)));

    _this.addEventListener('fc-mouseout', mouseOut.bind((0, _assertThisInitialized2.default)(_this)));

    return _this;
  }
  /**
   * sets default configuration
   *
   * @memberof SRSTool
   */


  var _proto = SRSTool.prototype;

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    _Tool.prototype.__setDefaultConfig.call(this);

    var toolConfig = this.config;
    toolConfig.containerInfo = {
      id: 'group',
      label: 'group',
      isParent: true
    };
    toolConfig.spaceNotHardCoded = true;
    toolConfig.hoveredState = NORMAL;
  }
  /**
   * configures attributes
   *
   * @param {any} [inputConfig={}] input configurations
   * @memberof SRSTool
   */
  ;

  _proto.configureAttributes = function configureAttributes(inputConfig) {
    if (inputConfig === void 0) {
      inputConfig = {};
    }

    var tool = this,
        toolConfig = tool.config,
        prop;

    for (prop in inputConfig) {
      toolConfig[prop] = inputConfig[prop];
    } // attach the event listeners


    for (prop in toolConfig.listener) {
      tool.addEventListener(prop, toolConfig.listener[prop]);
    }

    tool.setState(VISIBLE, toolConfig.isHidden !== true);
    toolConfig.symbolName = toolConfig.name;
  }
  /**
   * getter method for hoveredState
   *
   * @returns {string} hovered state
   * @memberof SRSTool
   */
  ;

  _proto.getHoveredState = function getHoveredState() {
    return this.config.hoveredState;
  }
  /**
   * draws the tool
   *
   * @memberof SRSTool
   */
  ;

  _proto.draw = function draw() {
    var tool = this,
        toolConfig = tool.config,
        x = toolConfig.x + toolConfig.width / 2,
        y = toolConfig.y + toolConfig.height / 2,
        width = toolConfig.width,
        height = toolConfig.height,
        css = toolConfig.css,
        state = tool.getCurrentState(),
        hoveredState = tool.getHoveredState(),
        textCss = css[state].config[hoveredState],
        backgroundCss = css[state].config[hoveredState + "Background"]; // if tool is not visible, dont draw

    if (!tool.getState(VISIBLE)) {
      return;
    } // draw the group


    tool.addGraphicalElement({
      el: 'group',
      attr: {
        name: 'srs-tool'
      },
      container: toolConfig.containerInfo,
      component: tool,
      id: 'group',
      label: 'group'
    }); // draw tracker

    tool.addGraphicalElement({
      el: 'rect',
      attr: {
        x: x - width / 2 - 2,
        y: y - height / 2 - 2,
        width: width + 4,
        height: height + 4,
        opacity: backgroundCss.opacity
      },
      css: backgroundCss,
      container: {
        id: 'group',
        label: 'group'
      },
      component: tool,
      id: 'rect',
      label: 'rect'
    }, true); // draw the text

    tool.addGraphicalElement({
      el: 'text',
      attr: {
        x: x,
        y: y,
        text: toolConfig.text,
        opacity: textCss.opacity
      },
      container: {
        id: 'group',
        label: 'group'
      },
      css: textCss,
      component: tool,
      id: 'text',
      label: 'text'
    }, true); // draw the path under the text only when tool is pressed

    state === PRESSED && tool.addGraphicalElement({
      el: 'path',
      attr: {
        path: "M" + (x - width / 2 - 1) + ", " + (y + height / 2 + 1.5) + " h " + (width + 1),
        opacity: textCss.opacity
      },
      container: {
        id: 'group',
        label: 'group'
      },
      css: {
        stroke: textCss.fill,
        'stroke-linecap': 'round',
        'stroke-opacity': textCss['fill-opacity']
      },
      component: tool,
      id: 'path',
      label: 'path'
    }, true);
  };

  return SRSTool;
}(_tools.Tool);

var _default = SRSTool;
exports["default"] = _default;

/***/ }),

/***/ 985:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _assertThisInitialized2 = _interopRequireDefault(__webpack_require__(292));

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _componentInterface = __webpack_require__(290);

var _srsTool = _interopRequireDefault(__webpack_require__(986));

var _tools = __webpack_require__(419);

var _lib = __webpack_require__(274);

var _utc = __webpack_require__(497);

var _timeIntervals = __webpack_require__(490);

var _smartToolbar = _interopRequireDefault(__webpack_require__(981));

var _clipUtils = __webpack_require__(864);

var _language_maps = __webpack_require__(534);

var R = _interopRequireWildcard(__webpack_require__(987));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var UNDEF,
    intervalMap = _language_maps.intervalMapEn;

var LABEL_FONT_SIZE = '12px',
    PRESSED = 'pressed',
    ACTIVATED = 'activated',
    DURATION_YEAR = 31536000000,
    DURATION_MONTH = 2678400000,
    DURATION_DAY = 86400000,
    DURATION_HOUR = 3600000,
    COLOR_9E9E9E = '#9e9e9e',
    COLOR_DFDFDF = '#dfdfdf',
    TOOL_PADDING = 3,
    DEFAULT_SEPARATOR_HEIGHT = 16,
    standardIntervals = [DURATION_YEAR * 10, DURATION_YEAR * 5, DURATION_YEAR * 3, DURATION_YEAR * 2, DURATION_YEAR, 6 * DURATION_MONTH, 3 * DURATION_MONTH, DURATION_MONTH, 15 * DURATION_DAY, 7 * DURATION_DAY, DURATION_DAY, 12 * DURATION_HOUR, 6 * DURATION_HOUR, 3 * DURATION_HOUR, DURATION_HOUR, DURATION_HOUR / 2],
    ENGLISH = 'english',
    GERMAN = 'german',
    FRENCH = 'french',
    SPANISH = 'spanish',
    PORTUGUESE = 'portuguese',
    ITALIAN = 'italian',
    LANGUAGE = 'language',
    ALL = 'All',
    getChartLang = function getChartLang(context) {
  return context.getFromEnv(LANGUAGE) ? context.getFromEnv(LANGUAGE).toLowerCase() : ENGLISH;
},
    isLeapYear = function isLeapYear(year) {
  return year % 4 === 0 && year % 100 !== 0 || year % 400 === 0;
},
    leapYearCount = function leapYearCount(start, end) {
  var startDate = new Date(start),
      endDate = new Date(end);
  var startYear = startDate.getFullYear(),
      endYear = endDate.getFullYear(),
      startMonth = startDate.getMonth(),
      endMonth = endDate.getMonth(),
      endDay = endDate.getDate(),
      count = 0,
      currYear;
  if (startMonth > 1) startYear++;
  if (endMonth === 0 || endMonth === 1 && endDay < 29) endYear--;
  currYear = startYear;

  while (currYear <= endYear) {
    if (isLeapYear(currYear)) count++;
    currYear++;
  }

  return count;
},
    // method to ckeck if current interval is valid as per current binning configurations
isValidInterVal = function isValidInterVal(index, rangeThreshold, minBin, isBusinessButton, endDomain) {
  if (isBusinessButton === void 0) {
    isBusinessButton = false;
  }

  var standardRangeSelector = this,
      lang = this.config.language,
      interval = getInterVal(intervalMap[index].unit, standardRangeSelector.getFromEnv('UTC'), lang),
      minBinDuration = minBin[2] * 3;
  intervalMap = getIntervalMap(lang);

  if (!isBusinessButton ? standardIntervals[index] >= rangeThreshold[2] && standardIntervals[index] >= minBinDuration : endDomain - interval.every(intervalMap[index].multiplier).floor(endDomain) >= minBinDuration) {
    return true;
  }

  return false;
},

/**
 * Function to get the time interval
 */
getInterVal = function getInterVal(unitF, isUTC, language) {
  if (language === void 0) {
    language = ENGLISH;
  }

  var unit = unitF,
      unitIndex;

  if (language in _language_maps.timeUnitsMap) {
    var _timeUnitsMap$english;

    unitIndex = _language_maps.timeUnitsMap[language].findIndex(function (u) {
      return u === unit;
    });
    unit = unitIndex !== -1 ? (_timeUnitsMap$english = _language_maps.timeUnitsMap == null ? void 0 : _language_maps.timeUnitsMap.english[unitIndex]) != null ? _timeUnitsMap$english : unit : unit;
  }

  switch (unit) {
    case 'year':
      return isUTC ? _utc.utcYear : _timeIntervals.timeYear;

    case 'quarter':
      return isUTC ? _utc.utcQuarter : _timeIntervals.timeQuarter;

    case 'month':
      return isUTC ? _utc.utcMonth : _timeIntervals.timeMonth;

    case 'week':
      return isUTC ? _utc.utcWeek : _timeIntervals.timeWeek;

    case 'day':
      return isUTC ? _utc.utcDay : _timeIntervals.timeDay;

    case 'hour':
      return isUTC ? _utc.utcHour : _timeIntervals.timeHour;

    case 'minute':
      return isUTC ? _utc.utcMinute : _timeIntervals.timeMinute;

    case 'second':
      return isUTC ? _utc.utcSecond : _timeIntervals.timeSecond;
  }
},

/**
 * method to find font size considering different states as
 * normal, hover and active as of now.
 * this will return max font size required by an state
 */
findRelaventFontSize = function findRelaventFontSize(style) {
  var normalFontSize = style.activated.config.normal['font-size'] || 0,
      hoverFontSize = style.activated.config.hover['font-size'] || 0,
      activeFontSize = style.pressed.config.normal['font-size'] || 0;
  return Math.max(parseFloat(normalFontSize), parseFloat(hoverFontSize), parseFloat(activeFontSize)) + 'px';
},

/**
* Function: getIntervalMap
* Description: Returns an interval map based on the specified language.
* @param {string} language - The language code (e.g., 'english', 'german').
* @returns {Object} - Object representing the interval mapping for the specified language.
*/
getIntervalMap = function getIntervalMap(language) {
  var tempIntervalMap = {};

  switch (language) {
    case ENGLISH:
      tempIntervalMap = _language_maps.intervalMapEn;
      break;

    case GERMAN:
      tempIntervalMap = _language_maps.intervalMapDe;
      break;

    case FRENCH:
      tempIntervalMap = _language_maps.intervalMapFr;
      break;

    case SPANISH:
      tempIntervalMap = _language_maps.intervalMapEs;
      break;

    case PORTUGUESE:
      tempIntervalMap = _language_maps.intervalMapPt;
      break;

    case ITALIAN:
      tempIntervalMap = _language_maps.intervalMapIt;
      break;

    default:
      // Default to English if the language is not specified or recognized
      tempIntervalMap = _language_maps.intervalMapEn;
  }

  return tempIntervalMap;
};

var StandardRangeSelector = /*#__PURE__*/function (_SmartRenderer) {
  (0, _inheritsLoose2.default)(StandardRangeSelector, _SmartRenderer);

  function StandardRangeSelector() {
    var _this;

    _this = _SmartRenderer.call(this) || this;
    var standardRangeSelector = (0, _assertThisInitialized2.default)(_this); // hanlder function for button click

    _this._handler = function () {
      var tool = this,
          chart = tool.getFromEnv('chart'),
          xScale = chart.getFromEnv('focusScalesX')[0],
          _xScale$applicableCli = xScale.applicableClippings,
          repeatClips = _xScale$applicableCli.repeatClips,
          singleClips = _xScale$applicableCli.singleClips,
          toolConfig = tool.config,
          multiplier = toolConfig.multiplier,
          isUTC = tool.getFromEnv('UTC'),
          unit = toolConfig.unit,
          fixedAtEnd = toolConfig.fixedAtEnd,
          fixedAtStart = toolConfig.fixedAtStart,
          text = toolConfig.text,
          interval,
          startDomain,
          endDomain,
          currentDomain = chart.getFocusLimit(),
          actualTotalDomain = chart.getContextLimit(),
          lang = getChartLang(this);
      standardRangeSelector.config.clickedButtonDetails = toolConfig;
      tool.getFromEnv('animationManager').setAnimationState('selectedRange'); // if fixed at end then set total domain's end value as end domain
      // else current domain's end value as endDomain

      if (fixedAtEnd) {
        endDomain = actualTotalDomain[1];
      } else {
        endDomain = currentDomain[1];
      } // if it is standard interval button or till date button


      if (unit && multiplier) {
        interval = getInterVal(unit, isUTC, lang); // if it is a standard interval button

        if (!fixedAtEnd) {
          startDomain = interval.offset(endDomain, -multiplier);
        } else {
          startDomain = interval.every(multiplier).floor(endDomain);
        }
      } else if (fixedAtStart) {
        // ALL button
        startDomain = actualTotalDomain[0];
      } // When time navigator is at extreme left and for larger time interval
      // end domain will be increased so that SRS shifts from right side


      if (+startDomain < actualTotalDomain[0]) {
        endDomain = interval.offset(actualTotalDomain[0], multiplier);
      } // store the clicked button details


      standardRangeSelector.config.lastSelectedButtonConfig = {
        fixedAtEnd: toolConfig.fixedAtEnd,
        fixedAtStart: toolConfig.fixedAtStart,
        unit: toolConfig.unit,
        multiplier: toolConfig.multiplier
      };
      standardRangeSelector.config.updatedThroughButton = true;
      startDomain = (0, _clipUtils.getUnclippedValue)(startDomain, repeatClips, singleClips, {
        clampDirection: 'up'
      });
      endDomain = (0, _clipUtils.getUnclippedValue)(endDomain, repeatClips, singleClips, {
        clampDirection: 'down'
      }); // inform chart to validate domains and draw all respective components.

      chart.setFocusLimit([startDomain, endDomain]);
      chart.fireChartInstanceEvent('standardRangeSelect', {
        unit: unit,
        multiplier: multiplier,
        text: text
      });
    };

    _this._toolbars = {};
    return _this;
  }

  var _proto = StandardRangeSelector.prototype;

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    _SmartRenderer.prototype.__setDefaultConfig.call(this);

    var config = this.config;
    config.lastSelectedButtonConfig = UNDEF;
    config.clickedButtonDetails = {};
    config.labelFontSize = LABEL_FONT_SIZE;
    config.takeMaxSize = false; // creating a state style object for buttons and background

    config.defaultStateStyle = {
      activated: {
        config: {
          normal: {
            fill: COLOR_9E9E9E,
            stroke: 'none',
            'stroke-width': 2,
            cursor: 'pointer',
            'stroke-opacity': 1,
            'fill-opacity': 1,
            'opacity': '1',
            'font-weight': 400,
            'font-size': '12',
            'line-height': 14.4,
            'text-anchor': 'middle'
          },
          hover: {
            fill: '#5648D4',
            stroke: 'none',
            'stroke-width': 2,
            cursor: 'pointer',
            'stroke-opacity': 1,
            'fill-opacity': 1,
            'opacity': '1',
            'font-weight': 400,
            'font-size': '12',
            'line-height': 14.4,
            'text-anchor': 'middle'
          },
          normalBackground: {
            fill: 'none',
            'fill-opacity': 1,
            stroke: 'none',
            cursor: 'pointer',
            r: '2px',
            'stroke-width': '1',
            'stroke-dasharray': 'none',
            'stroke-opacity': '1',
            opacity: 1
          },
          hoverBackground: {
            fill: 'none',
            'fill-opacity': 1,
            stroke: 'none',
            cursor: 'pointer',
            r: '2px',
            'stroke-width': '1',
            'stroke-dasharray': 'none',
            'stroke-opacity': '1',
            opacity: 1
          }
        }
      },
      pressed: {
        config: {
          normal: {
            fill: '#5648D4',
            'stroke-width': 2,
            stroke: 'none',
            'symbol-stroke': '#343434',
            cursor: 'pointer',
            'fill-opacity': 1,
            'stroke-opacity': 1,
            'opacity': '1',
            'font-weight': 400,
            'font-size': '12',
            'line-height': 14.4,
            'text-anchor': 'middle'
          },
          hover: {
            fill: '#5648D4',
            'stroke-width': 2,
            stroke: 'none',
            'symbol-stroke': '#5648D4',
            cursor: 'pointer',
            'fill-opacity': 1,
            'stroke-opacity': 1,
            'opacity': '1',
            'font-weight': 400,
            'font-size': '12',
            'line-height': 14.4,
            'text-anchor': 'middle'
          },
          normalBackground: {
            fill: 'none',
            'fill-opacity': 1,
            stroke: 'none',
            cursor: 'pointer',
            r: '2px',
            'stroke-width': '1',
            'stroke-dasharray': 'none',
            'stroke-opacity': '1',
            opacity: 1
          },
          hoverBackground: {
            fill: 'none',
            'fill-opacity': 1,
            stroke: 'none',
            cursor: 'pointer',
            r: '2px',
            'stroke-width': '1',
            'stroke-dasharray': 'none',
            'stroke-opacity': '1',
            opacity: 1
          }
        }
      }
    };
    config.stateStyle = {};
  };

  _proto.configureAttributes = function configureAttributes(obj) {
    _SmartRenderer.prototype.configureAttributes.call(this, obj);

    var srs = this,
        config = srs.config,
        getStyleDef = srs.getFromEnv('getStyleDef'),
        baseTextStyle = srs.getFromEnv('baseTextStyle'),
        textStyleNormal,
        textStyleHover,
        textStyleActive,
        backgroundStyleNormal,
        backgroundStyleHover,
        backgroundStyleActive,
        userStyle,
        userGivenStyle;
    config.contextRangeThreshold = srs.getFromEnv('contextBins')[0].getRangeThreshold();
    config.focusRangeThreshold = srs.getFromEnv('focusBins')[0].getRangeThreshold();
    config.contextMinBin = srs.getFromEnv('contextBins')[0].getBinMin();
    config.focusMinBin = srs.getFromEnv('focusBins')[0].getBinMin();
    config.language = getChartLang(this);
    Object.assign(config, obj);
    userStyle = config.style; // parse user provided styles
    // parse styles for button texts for different states as normal, hovered, active

    textStyleNormal = Object.assign({}, baseTextStyle, getStyleDef(userStyle['button-text']));
    textStyleHover = Object.assign({}, baseTextStyle, getStyleDef(userStyle['button-text:hover']));
    textStyleActive = Object.assign({}, baseTextStyle, getStyleDef(userStyle['button-text:active'])); // parse styles for button backgrounds(rects) for different states as normal, hovered, active

    backgroundStyleNormal = getStyleDef(userStyle['button-background']);
    backgroundStyleHover = getStyleDef(userStyle['button-background:hover']);
    backgroundStyleActive = getStyleDef(userStyle['button-background:active']);

    if (backgroundStyleNormal.fill || backgroundStyleNormal.stroke) {
      config.takeMaxSize = true;
    }

    userGivenStyle = {
      'activated': {
        config: {
          normal: textStyleNormal,
          hover: Object.assign({}, textStyleNormal, textStyleHover),
          normalBackground: backgroundStyleNormal,
          hoverBackground: Object.assign({}, backgroundStyleNormal, backgroundStyleHover)
        }
      },
      'pressed': {
        config: {
          normal: Object.assign({}, textStyleNormal, textStyleActive),
          hover: Object.assign({}, textStyleNormal, textStyleActive, textStyleHover),
          normalBackground: Object.assign({}, backgroundStyleNormal, backgroundStyleActive),
          hoverBackground: Object.assign({}, backgroundStyleNormal, backgroundStyleActive, backgroundStyleHover)
        }
      }
    }; // update the state style object based on user provided style

    config.stateStyle = (0, _lib.extend2)((0, _lib.extend2)({}, config.defaultStateStyle), userGivenStyle); // parse styles for separator line(path)

    config.stateStyle.separator = getStyleDef(userStyle.separator && userStyle.separator);
  }
  /**
   * Checks whether the till-date buttons are available based on the current
   * context domain. Till-date buttons are only available when the current
   * system date falls within the current domain.
   *
   * @returns {boolean} Whether the till-date buttons are available or not.
   */
  ;

  _proto.areTillDateButtonsPossible = function areTillDateButtonsPossible() {
    var isUTC = this.getFromEnv('UTC'),
        dateAPI = this.getFromEnv('dateAPI'),
        currentDate = new Date(),
        // current date
    endDomain = this.getFromEnv('chart').getContextLimit()[1],
        availableLastDate = new Date(endDomain); // last date in given data

    return dateAPI(availableLastDate, 'FullYear', isUTC) === dateAPI(currentDate, 'FullYear', isUTC) && dateAPI(availableLastDate, 'Month', isUTC) === dateAPI(currentDate, 'Month', isUTC) && dateAPI(availableLastDate, 'Date', isUTC) === dateAPI(currentDate, 'Date', isUTC);
  }
  /**
   * Function to get all till date buttons
   * @param {Number} duration Actual data total duration.
   * @param {Array} rangeThreshold context range threshold based on current binning.
   * @param {Array} minBin context range minBin based on current binning.
   * @return {Array} array of till date buttons
   */
  ;

  _proto.getTillDateButtons = function getTillDateButtons(duration, rangeThreshold, minBin) {
    var tillDateObjArr = [],
        tillDateObj,
        endDomain = this.getFromEnv('chart').getContextLimit()[1],
        i,
        len; // create business buttons only if data for current date is present

    if (this.areTillDateButtonsPossible()) {
      for (i = 0, len = standardIntervals.length; i < len; i++) {
        if (duration >= standardIntervals[i] && intervalMap[i].tilldateName && isValidInterVal.call(this, i, rangeThreshold, minBin, true, endDomain)) {
          tillDateObj = (0, _lib.extend2)({}, intervalMap[i]);
          tillDateObj.fixedAtEnd = true;
          tillDateObj.fixedAtStart = false;
          tillDateObjArr.push(tillDateObj);
        }
      }
    }

    return tillDateObjArr;
  }
  /**
   * API to higlight a button based on current domain's value and
   * whether the interaction was through button click or invoked by
   * any other component.
   * @return {Object} the highlighted button's configuration
   */
  ;

  _proto.getSelectionButtonConfig = function getSelectionButtonConfig() {
    var standardRangeSelector = this,
        selfConfig = standardRangeSelector.config,
        timeInterValMonth,
        timeInterValYear,
        timeInterValDay,
        isUTC = standardRangeSelector.getFromEnv('UTC'),
        currentDomain = selfConfig.currentDomain,
        returnObj = {},
        totalDomain = selfConfig.totalDomain,
        currentDomainDiff = +currentDomain[1] - +currentDomain[0];
    timeInterValYear = !isUTC ? _timeIntervals.timeYear : _utc.utcYear;
    timeInterValMonth = !isUTC ? _timeIntervals.timeMonth : _utc.utcMonth;
    timeInterValDay = !isUTC ? _timeIntervals.timeDay : _utc.utcDay; // if the interaction was through button click

    if (selfConfig.lastSelectedButtonConfig) {
      returnObj = {
        isTillDate: selfConfig.lastSelectedButtonConfig.fixedAtEnd && !selfConfig.lastSelectedButtonConfig.fixedAtStart,
        isAllButton: selfConfig.lastSelectedButtonConfig.fixedAtEnd && selfConfig.lastSelectedButtonConfig.fixedAtStart,
        isIntervalButton: !selfConfig.lastSelectedButtonConfig.fixedAtEnd && !selfConfig.lastSelectedButtonConfig.fixedAtStart,
        multiplier: selfConfig.lastSelectedButtonConfig.multiplier,
        unit: selfConfig.lastSelectedButtonConfig.unit
      };
      return returnObj;
    } // checking if the domain values satisfies for ALL button


    if (currentDomainDiff === +totalDomain[1] - +totalDomain[0]) {
      return {
        isAllButton: true
      };
    } // checking if the domain values satisfies for till date buttons
    // this only ever needs to be done if there are any till date buttons


    if (this.areTillDateButtonsPossible()) {
      // YTD
      if (currentDomainDiff === +currentDomain[1] - +timeInterValYear.floor(currentDomain[1])) {
        return {
          isTillDate: true,
          multiplier: '1',
          unit: 'year'
        };
      } // MTD


      if (currentDomainDiff === +currentDomain[1] - +timeInterValMonth.floor(currentDomain[1])) {
        return {
          isTillDate: true,
          multiplier: '1',
          unit: 'month'
        };
      } // QTD


      if (currentDomainDiff === +currentDomain[1] - +timeInterValMonth.every(3).floor(currentDomain[1])) {
        return {
          isTillDate: true,
          multiplier: '3',
          unit: 'month'
        };
      } // WTD


      if (currentDomainDiff === +currentDomain[1] - +timeInterValDay.every(7).floor(currentDomain[1])) {
        return {
          isTillDate: true,
          multiplier: '7',
          unit: 'day'
        };
      }
    } // standard interval button


    return standardRangeSelector.getHighlightedIntervalButton(currentDomainDiff);
  }
  /**
   * Function to get all stanadard interval buttons
   * @param {Number} currentDomainDuration current domain difference in milliseconds
   * @param {Number} totalDomainDuration total domain difference in milliseconds
   * @param {Array} rangeThreshold context range threshold based on current binning.
   * @param {Array} minBin context range minBin based on current binning.
   * @return {Array} array of button configurations
   */
  ;

  _proto.getIntervalButtons = function getIntervalButtons(currentDomainDuration, totalDomainDuration, rangeThreshold, minBin, numberOfLeapDays) {
    var standardLeapYearIntervals = [];
    var i,
        len = standardIntervals.length,
        intervalArr = [],
        additionDays = [];

    if (numberOfLeapDays > 0) {
      for (i = 0; i < 5; i++) {
        var res = Math.min(numberOfLeapDays, 1 + Math.floor(Number(intervalMap[i].multiplier) / 4));
        additionDays[i] = res;
        standardLeapYearIntervals.push(DURATION_YEAR * intervalMap[i].multiplier + additionDays[i] * DURATION_DAY);
      }
    }

    for (i = len - 1; i > 0; i--) {
      if (numberOfLeapDays > 0 && i < 5 && standardLeapYearIntervals[i] >= currentDomainDuration) {
        break;
      } else if (standardIntervals[i] >= currentDomainDuration) {
        break;
      }
    } // if valid duration is given


    if (currentDomainDuration) {
      // greater than or equal to one year
      if (i <= 0) {
        (numberOfLeapDays > 0 ? standardLeapYearIntervals[0] <= totalDomainDuration : standardIntervals[0] <= totalDomainDuration) && isValidInterVal.call(this, 0, rangeThreshold, minBin) && intervalArr.push(intervalMap[0]);
        (numberOfLeapDays > 1 ? standardLeapYearIntervals[1] <= totalDomainDuration : standardIntervals[1] <= totalDomainDuration) && isValidInterVal.call(this, 1, rangeThreshold, minBin) && intervalArr.push(intervalMap[1]);
      } else if (i === len - 1) {
        // create one level higher interval button if it is less than total range
        standardIntervals[i - 1] <= totalDomainDuration && isValidInterVal.call(this, i - 1, rangeThreshold, minBin) && intervalArr.push(intervalMap[i - 1]); // equal to 30 minutes
        // consider the least button only if its less than or equal to the total range.

        standardIntervals[i] <= totalDomainDuration && isValidInterVal.call(this, i, rangeThreshold, minBin) && intervalArr.push(intervalMap[i]);
      } else {
        // within one year and 30 minutes
        (numberOfLeapDays > 0 && i < 5 ? standardLeapYearIntervals[i - 1] <= totalDomainDuration : standardIntervals[i - 1] <= totalDomainDuration) && isValidInterVal.call(this, i - 1, rangeThreshold, minBin) && intervalArr.push(intervalMap[i - 1]); // add the rest of the two buttons

        (numberOfLeapDays > 0 && i < 5 ? standardLeapYearIntervals[i] <= totalDomainDuration : standardIntervals[i] <= totalDomainDuration) && isValidInterVal.call(this, i, rangeThreshold, minBin) && intervalArr.push(intervalMap[i]);
        standardIntervals[i + 1] <= totalDomainDuration && isValidInterVal.call(this, i + 1, rangeThreshold, minBin) && intervalArr.push(intervalMap[i + 1]);
      }
    }

    return intervalArr;
  }
  /**
   * Function to get the current highlighted standard button's configuration based on duration
   * @return {Obj} button configuration
   */
  ;

  _proto.getHighlightedIntervalButton = function getHighlightedIntervalButton(duration) {
    var srs = this,
        selfConfig = srs.config,
        lang = selfConfig.language,
        i,
        intervalButtons = selfConfig.intervalButtons,
        currentDomain = selfConfig.currentDomain,
        isUTC = srs.getFromEnv('UTC'),
        interval,
        len = intervalButtons.length,
        returnObj = {};

    for (i = len - 1; i >= 0; i--) {
      interval = getInterVal(intervalButtons[i].unit, isUTC, lang);

      if (+currentDomain[1] === +interval.offset(currentDomain[0], intervalButtons[i].multiplier)) {
        break;
      }
    }

    if (i !== -1) {
      returnObj = (0, _lib.extend2)({
        isIntervalButton: true
      }, intervalMap[i]);
      returnObj = {
        isIntervalButton: true,
        unit: intervalButtons[i].unit,
        multiplier: intervalButtons[i].multiplier
      };
      selfConfig.lastSelectedButtonConfig = returnObj;
    }

    return returnObj;
  }
  /**
   * returns the tool requirements of this component
   *
   * @returns {Object} requirements
   * @memberof StandardRangeSelector
   */
  ;

  _proto.getToolInfo = function getToolInfo() {
    var srs = this,
        srsConfig = srs.config,
        lang = srsConfig.language,
        chart = srs.getFromEnv('chart'),
        toolBar = srs.getFromEnv('selectorToolbar'),
        retObj = {},
        i,
        len,
        state,
        smartLabel = srs.getFromEnv('smartLabel'),
        allTextSize,
        stateStyleObj = srsConfig.stateStyle,
        labelFontSize = findRelaventFontSize(stateStyleObj) || srsConfig.labelFontSize,
        labelFontFamily = stateStyleObj.activated.config.normal['font-family'],
        labelFontWeight = stateStyleObj.activated.config.normal['font-weight'],
        currentDomain = srsConfig.currentDomain,
        totalDomain = chart.getContextLimit(),
        contextRangeThreshold = srsConfig.contextRangeThreshold,
        focusRangeThreshold = srsConfig.focusRangeThreshold,
        contextMinBin = srsConfig.contextMinBin,
        focusMinBin = srsConfig.focusMinBin,
        selectedButtonConfig,
        maxHeight = 0,
        maxWidth = 0,
        takeMaxSize = srsConfig.takeMaxSize,
        currentDomainDiff = +currentDomain[1] - +currentDomain[0],
        numberOfLeapDays = leapYearCount(+currentDomain[0], +currentDomain[1]),
        totalDomainDiff = +totalDomain[1] - +totalDomain[0],
        intervalToolbarId = "intervalToolBar-" + toolBar.getId() + "-" + chart.getId(),
        businessToolbarId = "businessToolBar-" + toolBar.getId() + "-" + chart.getId(),
        allToolbarId = "allToolBar-" + toolBar.getId() + "-" + chart.getId(),
        intervalButtons = srsConfig.intervalButtons = srs.getIntervalButtons(currentDomainDiff, totalDomainDiff, focusRangeThreshold, focusMinBin, numberOfLeapDays),
        tillDateButtons = srsConfig.tillDateButtons = srs.getTillDateButtons(totalDomainDiff, contextRangeThreshold, contextMinBin),
        allButtonText;
    smartLabel.setStyle({
      fontSize: labelFontSize,
      fontFamily: labelFontFamily,
      fontWeight: labelFontWeight
    });
    intervalButtons.forEach(function (info) {
      var _smartLabel$getOriSiz = smartLabel.getOriSize(info.intervalName, false),
          height = _smartLabel$getOriSiz.height,
          width = _smartLabel$getOriSiz.width;

      info.height = height;
      info.width = width;
      maxHeight = Math.max(height, maxHeight);
      maxWidth = Math.max(width, maxWidth);
    });
    tillDateButtons.forEach(function (info) {
      var _smartLabel$getOriSiz2 = smartLabel.getOriSize(info.tilldateName, false),
          height = _smartLabel$getOriSiz2.height,
          width = _smartLabel$getOriSiz2.width;

      info.height = height;
      info.width = width;
      maxHeight = Math.max(height, maxHeight);
      maxWidth = Math.max(width, maxWidth);
    });
    allButtonText = R.propOr(ALL, lang, _language_maps.allButtonMap);
    allTextSize = smartLabel.getOriSize(allButtonText, false);
    maxHeight = Math.max(allTextSize.height, maxHeight);
    maxWidth = Math.max(allTextSize.width, maxWidth);
    selectedButtonConfig = srs.getSelectionButtonConfig(); // create configurations of interval button toolbar

    retObj[intervalToolbarId] = {
      type: 'tool',
      def: _smartToolbar.default,
      configuration: {
        hAlign: 'left',
        toolbarhdirection: 1,
        child: {}
      }
    }; // create configurations of interval buttons

    for (i = 0, len = intervalButtons.length; i < len; i++) {
      if (selectedButtonConfig.isIntervalButton && selectedButtonConfig.unit === intervalButtons[i].unit && selectedButtonConfig.multiplier === intervalButtons[i].multiplier) {
        state = PRESSED;
      } else {
        state = ACTIVATED;
      }

      retObj[intervalToolbarId].configuration.child["intervalButton-" + toolBar.getId() + "-" + chart.getId() + "-" + i] = {
        type: 'tool',
        def: _srsTool.default,
        configuration: {
          text: intervalButtons[i].intervalName,
          name: 'interval',
          width: takeMaxSize ? maxWidth : intervalButtons[i].width,
          height: takeMaxSize ? maxHeight : intervalButtons[i].height,
          scale: 1,
          'marginLeft': i ? TOOL_PADDING : 0,
          'marginRight': i === len - 1 ? 0 : TOOL_PADDING,
          'hAlign': 'left',
          'symbolStrokeWidth': '2',
          'hoveredState': 'normal',
          state: state,
          'multiplier': intervalButtons[i].multiplier,
          'unit': intervalButtons[i].unit,
          'strokeWidth': 0,
          listener: {
            'fc-click': srs._handler
          },
          css: stateStyleObj
        }
      };
    } // first separator, create configurations only when interval buttons are created


    if (len) {
      retObj["separator-" + toolBar.getId() + "-" + chart.getId() + "-0"] = {
        type: 'tool',
        def: _tools.Separator,
        configuration: {
          marginLeft: 0,
          marginRight: 0,
          scale: 1,
          height: maxHeight < DEFAULT_SEPARATOR_HEIGHT ? DEFAULT_SEPARATOR_HEIGHT : maxHeight,
          // default height for separator as per design is 16px, so if size is less convert it to default value
          width: 8,
          hAlign: 'left',
          stroke: stateStyleObj.separator.stroke || COLOR_DFDFDF,
          css: stateStyleObj.separator
        }
      };
    }

    len = tillDateButtons.length;

    if (len) {
      // create configurations of business toolbar
      retObj[businessToolbarId] = {
        type: 'tool',
        def: _smartToolbar.default,
        configuration: {
          hAlign: 'left',
          toolbarhdirection: 1,
          child: {}
        }
      }; // create configurations of business tool buttons

      for (i = 0; i < len; i++) {
        // decide the state of button
        if (selectedButtonConfig.isTillDate && selectedButtonConfig.unit === tillDateButtons[i].unit && selectedButtonConfig.multiplier === tillDateButtons[i].multiplier && +currentDomain[1] === +totalDomain[1]) {
          // till date button is not in pressed state if active window end is not same as time nav end.
          state = PRESSED;
        } else {
          state = ACTIVATED;
        }

        retObj[businessToolbarId].configuration.child["tillDateButton-" + toolBar.getId() + "-" + chart.getId() + "-" + i] = {
          type: 'tool',
          def: _srsTool.default,
          configuration: {
            text: tillDateButtons[i].tilldateName,
            name: 'interval',
            scale: 1,
            width: takeMaxSize ? maxWidth : tillDateButtons[i].width,
            height: takeMaxSize ? maxHeight : tillDateButtons[i].height,
            state: state,
            'multiplier': tillDateButtons[i].multiplier,
            'unit': tillDateButtons[i].unit,
            'symbolStrokeWidth': '2',
            'hoveredState': 'normal',
            'fixedAtStart': tillDateButtons[i].fixedAtStart,
            'fixedAtEnd': tillDateButtons[i].fixedAtEnd,
            'marginLeft': i ? TOOL_PADDING : 0,
            'marginRight': i === len - 1 ? 0 : TOOL_PADDING,
            'hAlign': 'left',
            'strokeWidth': 0,
            listener: {
              'fc-click': srs._handler
            },
            css: stateStyleObj
          }
        };
      } // create second separator configurations only when business buttons are also shown


      retObj["separator-" + toolBar.getId() + "-" + chart.getId() + "-1"] = {
        type: 'tool',
        def: _tools.Separator,
        configuration: {
          'marginLeft': 0,
          'marginRight': 0,
          scale: 1,
          height: maxHeight < DEFAULT_SEPARATOR_HEIGHT ? DEFAULT_SEPARATOR_HEIGHT : maxHeight,
          // default height for separator as per design is 16px, so if size is less convert it to default value
          classIndex: 3,
          itemIndex: 0,
          width: 8,
          'hAlign': 'left',
          'stroke': stateStyleObj.separator.stroke || COLOR_DFDFDF,
          css: stateStyleObj.separator
        }
      };
    } // check for the state of all button


    if (selectedButtonConfig.isAllButton) {
      state = PRESSED;
    } else {
      state = ACTIVATED;
    } // create configurations all button toolbar


    retObj[allToolbarId] = {
      type: 'tool',
      def: _smartToolbar.default,
      configuration: {
        'hAlign': 'left',
        toolbarhdirection: 1,
        child: {}
      }
    }; // create 'all' button configuration

    retObj[allToolbarId].configuration.child["allButton-" + toolBar.getId() + "-" + chart.getId() + "-0"] = {
      type: 'tool',
      def: _srsTool.default,
      configuration: {
        state: state,
        width: takeMaxSize ? maxWidth : allTextSize.width,
        height: takeMaxSize ? maxHeight : allTextSize.height,
        scale: 1,
        text: allButtonText,
        name: 'interval',
        'marginLeft': 0,
        'marginRight': 0,
        'hAlign': 'left',
        'hoveredState': 'normal',
        'symbolStrokeWidth': '2',
        'strokeWidth': 0,
        'fixedAtStart': true,
        'fixedAtEnd': true,
        fill: '#00ff00',
        labelFill: '#00ff00',
        symbolFill: '#00ff00',
        listener: {
          'fc-click': srs._handler
        },
        css: stateStyleObj
      }
    };
    return retObj;
  }
  /**
   * Api is called when focusLimitChanged event is triggered
   *
   * @memberof StandardRangeSelector
   */
  ;

  _proto.updateOnLimitChange = function updateOnLimitChange() {
    var standardRangeSelector = this,
        config = standardRangeSelector.config,
        chart = standardRangeSelector.getFromEnv('chart'),
        currentDomain = chart.getFocusLimit() || [0, 1],
        currentDomainDiff = currentDomain[1] - currentDomain[0]; // if current range is not the same as the last selected range and the
    // update has not happened through button click then reset the last clicked
    // button details

    if (config.lastSelectedRange && config.lastSelectedRange !== currentDomainDiff && !config.updatedThroughButton) {
      config.lastSelectedButtonConfig = UNDEF;
    }

    config.lastSelectedRange = currentDomainDiff;
    config.updatedThroughButton = false; // register draw job

    standardRangeSelector.setData({
      currentDomain: currentDomain,
      totalDomain: chart.getContextLimit() || [0, 1]
    }, true);
  };

  return StandardRangeSelector;
}(_componentInterface.SmartRenderer);

var _default = StandardRangeSelector;
exports["default"] = _default;

/***/ }),

/***/ 889:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _componentInterface = __webpack_require__(290);

var _utc = __webpack_require__(497);

var _timeIntervals = __webpack_require__(490);

var _lib = __webpack_require__(274);

var _timeConverter = _interopRequireDefault(__webpack_require__(350));

var _clipUtils = __webpack_require__(864);

var UNDEF;
var GUTTER_5 = 5,
    GUTTER_8 = 8,
    GUTTER_14 = 14,
    M = 'M',
    v = 'v',
    DIV = '<div>',
    WHITE_HEX = '#ffffff',
    MINIMAL = 'minimal',
    RADIUS = '1.5',
    ROLLOVER = 'timeMarkerRollOver',
    ROLLOUT = 'timeMarkerRollOut',
    CLICK = 'timeMarkerClick'; // function to check if the given unit is valid

function isValidUnit(unit) {
  switch (unit) {
    case 'year':
    case 'quarter':
    case 'month':
    case 'week':
    case 'day':
    case 'hour':
    case 'minute':
    case 'second':
    case 'millisecond':
      return true;

    default:
      return false;
  }
} // function to get the time interval


function getInterVal(unit, isUTC) {
  switch (unit) {
    case 'year':
      return isUTC ? _utc.utcYear : _timeIntervals.timeYear;

    case 'quarter':
      return isUTC ? _utc.utcMonth : _timeIntervals.timeMonth;

    case 'month':
      return isUTC ? _utc.utcMonth : _timeIntervals.timeMonth;

    case 'week':
      return isUTC ? _utc.utcWeek : _timeIntervals.timeWeek;

    case 'day':
      return isUTC ? _utc.utcDay : _timeIntervals.timeDay;

    case 'hour':
      return isUTC ? _utc.utcHour : _timeIntervals.timeHour;

    case 'minute':
      return isUTC ? _utc.utcMinute : _timeIntervals.timeMinute;

    case 'second':
      return isUTC ? _utc.utcSecond : _timeIntervals.timeSecond;

    case 'millisecond':
      return isUTC ? _utc.utcMillisecond : _timeIntervals.timeMillisecond;
  }
}

function isWithinMarker(timeMarker, chartX, chartY, marker) {
  var hovered = false,
      dimensions = marker.markerDim,
      hoveredMarkerDim,
      i,
      len;

  for (i = 0, len = dimensions.length; i < len; i++) {
    if (chartX >= dimensions[i].x && chartX <= dimensions[i].x + dimensions[i].width && chartY >= dimensions[i].y && chartY <= dimensions[i].y + dimensions[i].height) {
      hovered = true;
      timeMarker.config.previouslyHoveredIndex = marker.index;
      hoveredMarkerDim = dimensions[i];
      break;
    }
  }

  return {
    pointIndex: marker.index,
    hovered: hovered,
    pointObj: {
      hoveredMarkerDim: hoveredMarkerDim,
      index: hovered && i
    },
    previouslyHoveredIndex: timeMarker.config.previouslyHoveredIndex,
    component: timeMarker
  };
}

var TimeInstanceMarker = /*#__PURE__*/function (_SmartRenderer) {
  (0, _inheritsLoose2.default)(TimeInstanceMarker, _SmartRenderer);

  function TimeInstanceMarker() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _SmartRenderer.call.apply(_SmartRenderer, [this].concat(args)) || this;

    _this.getClassName = function (baseName) {
      if (baseName === void 0) {
        baseName = '';
      }

      var randomString = Math.random().toString(36).substring(2);
      return baseName + "-" + randomString;
    };

    _this.getCSPNonce = function () {
      var metaTag = document.querySelector("meta[http-equiv=\"Content-Security-Policy\"]");

      if (metaTag) {
        var content = metaTag.getAttribute('content');

        if (content) {
          var match = content.match(/'nonce-([^']+)'/);

          if (match) {
            return match[1];
          }
        }
      }

      return null;
    };

    return _this;
  }

  var _proto = TimeInstanceMarker.prototype;

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    _SmartRenderer.prototype.__setDefaultConfig.call(this);

    this.config.defaultStyle = {
      text: {
        'fill': '#808080',
        'font-size': '11px',
        'font-weight': 'normal',
        'font-style': 'normal',
        'vertical-align': 'middle',
        'text-anchor': 'middle',
        'fill-opacity': '1',
        'stroke-opacity': '1',
        'opacity': 1
      },
      marker: {
        'fill': '#f8b8b7',
        'opacity': 1,
        'stroke': '#666666',
        'r': 2,
        'stroke-width': '1',
        'stroke-dasharray': 'none',
        'fill-opacity': '1',
        'stroke-opacity': '1'
      }
    };
    this.config.hoveredMarkerIndex = UNDEF;
    this.config.hoveredDomainIndex = UNDEF;
    this.config.lastHoveredMarkerIndex = UNDEF;
    this.config.lastHoveredDomainIndex = UNDEF;
    this.config.previouslyHoveredIndex = UNDEF;
    this.config.hoveredFromOutside = false;
    this.config.hoveredLabelFill = WHITE_HEX;
    this.config.hoveredMarkerRadius = RADIUS;
    this.config.valueArr = [];
    this.config.textArr = [];
    this.config.styleArr = [];
    this.config.domainArr = [];
    this.config.repeatationArr = [];
    this.config.markerDetails = [];
    this.config.type = MINIMAL;
  };

  _proto.getHoveredMarker = function getHoveredMarker(chartXArg, chartYArg) {
    var timeMarker = this,
        chartX = chartXArg,
        chartY = chartYArg,
        selfConfig = timeMarker.config,
        canvas = timeMarker.getLinkedParent(),
        translationObj = canvas.getTranslation(),
        hoverDetails,
        markerDetails = selfConfig.markerDetails,
        i;
    chartX -= translationObj.x;
    chartY -= translationObj.y;

    for (i = markerDetails.length - 1; i >= 0; i--) {
      hoverDetails = isWithinMarker(timeMarker, chartX, chartY, markerDetails[i]);

      if (hoverDetails.hovered) {
        break;
      }
    }

    return hoverDetails;
  };

  _proto.setHoverInEffect = function setHoverInEffect(hoveredMarkerIndex, hoveredDomainIndex, hoveredFromOutside) {
    var timeMarker = this,
        chart = timeMarker.getFromEnv('chart');
    timeMarker.setData({
      hoveredMarkerIndex: hoveredMarkerIndex,
      hoveredDomainIndex: hoveredDomainIndex,
      hoveredFromOutside: hoveredFromOutside
    }, true);
    chart.fireEvent('timeInstanceMarkerHovered', {
      senderTimeMarker: timeMarker,
      hoveredMarkerIndex: hoveredMarkerIndex,
      hoveredDomainIndex: hoveredDomainIndex,
      hoveredFromOutside: true
    });
  };

  _proto.setHoverOutEffect = function setHoverOutEffect() {
    var timeMarker = this,
        config = timeMarker.config,
        chart = timeMarker.getFromEnv('chart');
    timeMarker.setData({
      lastHoveredMarkerIndex: config.hoveredMarkerIndex,
      lastHoveredDomainIndex: config.hoveredDomainIndex,
      hoveredMarkerIndex: UNDEF,
      hoveredDomainIndex: UNDEF
    }, true);
    chart.fireEvent('timeInstanceMarkerHovered', {
      senderTimeMarker: timeMarker,
      hoveredMarkerIndex: UNDEF,
      hoveredDomainIndex: UNDEF,
      hoveredFromOutside: true
    });
  };

  _proto.fireMarkerEvents = function fireMarkerEvents(type, hoverMarkerIndex, hoverDomainIndex) {
    var timeMarker = this,
        config = timeMarker.config,
        valueArr = config.valueArr,
        domainArr = config.domainArr,
        repeatArr = config.repeatationArr,
        markerIndex,
        domainIndex,
        chart = timeMarker.getFromEnv('chart'),
        dateFormatter,
        startMS,
        isUTC = timeMarker.getFromEnv('UTC'),
        timeFormat,
        eventToBeFired;

    switch (type) {
      case 'fc-mouseover':
        eventToBeFired = ROLLOVER;
        markerIndex = hoverMarkerIndex;
        domainIndex = hoverDomainIndex;
        break;

      case 'fc-mouseout':
        markerIndex = config.lastHoveredMarkerIndex;
        domainIndex = config.lastHoveredDomainIndex; // for the first time when a time marker is hovered, its last hovered and
        // hoveredout index is not defined, so skip this firing

        if (markerIndex !== UNDEF && domainIndex !== UNDEF) {
          eventToBeFired = ROLLOUT;
        }

        break;

      case 'fc-click':
        eventToBeFired = CLICK;
        markerIndex = hoverMarkerIndex;
        domainIndex = hoverDomainIndex;
        break;
    }

    if (eventToBeFired) {
      timeFormat = valueArr[markerIndex].timeFormat;
      dateFormatter = isUTC ? _timeConverter.default.utcFormatter(timeFormat) : _timeConverter.default.formatter(timeFormat);
      startMS = +domainArr[markerIndex][domainIndex];
      chart.fireChartInstanceEvent(eventToBeFired, {
        start: startMS,
        startText: dateFormatter.format(startMS),
        end: UNDEF,
        endText: _lib.BLANKSTRING,
        formatter: timeFormat,
        type: valueArr[markerIndex].type,
        label: repeatArr[markerIndex][domainIndex].labels
      });
    }
  };

  _proto.getToolTextConfiguration = function getToolTextConfiguration(toolTextArr) {
    var timeMarker = this,
        _timeMarker$getFromEn = timeMarker.getFromEnv('tooltipStyle'),
        headerStyle = _timeMarker$getFromEn.header,
        bodyStyle = _timeMarker$getFromEn.body,
        totalWidth = 2 * GUTTER_5 + 2 * GUTTER_8 + GUTTER_14,
        totalHeight = 6 * GUTTER_5 + 2 * GUTTER_8,
        smartLabel = timeMarker.getFromEnv('smartLabel'),
        returnObj = {},
        i,
        len,
        smartText;

    smartLabel.setStyle({
      'font-size': headerStyle['font-size'],
      'font-family': headerStyle['font-family'],
      'font-weight': headerStyle['font-weight']
    });
    smartText = smartLabel.getOriSize(toolTextArr[0]);
    totalWidth += smartText.width;
    totalHeight += smartText.height;
    var toolTipTextArrClass = this.getClassName('tooltip-text-margin'),
        chartNonce = this.getCSPNonce();
    returnObj.header = "\n    <style nonce=\"" + chartNonce + "\">." + toolTipTextArrClass + " {margin: 5px;}</style><div class=\"" + toolTipTextArrClass + "\">\n    " + toolTextArr[0] + "</div>";
    returnObj.body = DIV;
    smartLabel.setStyle({
      'font-size': bodyStyle['font-size'],
      'font-family': bodyStyle['font-family'],
      'font-weight': bodyStyle['font-weight']
    });

    if (toolTextArr.length > 2) {
      returnObj.body += "</br>";

      for (i = 1, len = toolTextArr.length; i < len; i++) {
        if (toolTextArr[i]) {
          smartText = smartLabel.getOriSize(toolTextArr[i]);
          totalHeight += smartText.height;
          totalWidth = Math.max(totalWidth, smartText.width);
          returnObj.body += "<style nonce=\"" + chartNonce + "\">." + toolTipTextArrClass + " {margin: 5px;}</style>\n          <div class=" + toolTipTextArrClass + "'>" + i + ". " + toolTextArr[i] + "</div>";
        }
      }
    } else if (toolTextArr.length === 2) {
      if (toolTextArr[1]) {
        smartText = smartLabel.getOriSize(toolTextArr[1]);
        totalHeight += smartText.height;
        totalWidth = Math.max(totalWidth, smartText.width);
        returnObj.body += "<style nonce=\"" + chartNonce + "\">." + toolTipTextArrClass + " {margin: 5px;}</style><div class=\"" + toolTipTextArrClass + "\">" + toolTextArr[1] + "</div>";
      }
    }

    returnObj.body += "</div>";
    returnObj.dimensions = {
      width: totalWidth,
      height: totalHeight
    };
    return returnObj;
  } // Method that recalculates the dimensions of a time marker
  ;

  _proto.reCalculateDimension = function reCalculateDimension(i, j, lineHeight) {
    var timeMarker = this,
        selfConfig = timeMarker.config,
        value = selfConfig.domainArr[i][j],
        xScale = timeMarker.config.xScale,
        canvasConfig = timeMarker.getLinkedParent().config,
        canvasPadding = canvasConfig.padding,
        leftPadding = canvasPadding.left,
        rightPadding = canvasPadding.right,
        topPadding = canvasPadding.top,
        bottomPaddding = canvasPadding.bottom,
        startRangeValue = xScale.getRangeValue(value),
        markerDim = selfConfig.markerDetails[i].markerDim[j],
        x = startRangeValue - lineHeight / 2 - leftPadding + rightPadding,
        y = canvasConfig.canvasBGTop + canvasConfig.canvasBGHeight - lineHeight / 2 - topPadding + bottomPaddding,
        width = 2 * lineHeight / 2,
        height = 2 * lineHeight / 2;
    markerDim.x = x;
    markerDim.y = y;
    markerDim.width = width;
    markerDim.height = height;
    markerDim.thresholdX = x < canvasConfig.canvasBGLeft ? x - canvasConfig.canvasBGLeft : x + width > canvasConfig.canvasBGLeft + canvasConfig.canvasBGWidth ? x + width - (canvasConfig.canvasBGLeft + canvasConfig.canvasBGWidth) : 0;
    markerDim.thresholdY = lineHeight / 2;
  } // Method to get marker dimension
  ;

  _proto.getMarkerDimension = function getMarkerDimension(value, lineHeight) {
    var timeMarker = this,
        xScale = timeMarker.config.xScale,
        canvasConfig = timeMarker.getLinkedParent().config,
        canvasPadding = canvasConfig.padding,
        leftPadding = canvasPadding.left,
        rightPadding = canvasPadding.right,
        topPadding = canvasPadding.top,
        bottomPaddding = canvasPadding.bottom,
        startRangeValue = xScale.getRangeValue(value),
        x = startRangeValue - lineHeight / 2 - leftPadding + rightPadding,
        y = canvasConfig.canvasBGTop + canvasConfig.canvasBGHeight - lineHeight / 2 - topPadding + bottomPaddding,
        width = 2 * lineHeight / 2,
        height = 2 * lineHeight / 2; // calculate dimensions and thresholds based on its placement. If it crosses the canvas' edge then calculate
    // the offset and use it as threshold so that it could be detected properly by the mousetracker.

    return {
      x: x,
      y: y,
      width: width,
      height: height,
      thresholdX: x < canvasConfig.canvasBGLeft ? x - canvasConfig.canvasBGLeft : x + width > canvasConfig.canvasBGLeft + canvasConfig.canvasBGWidth ? x + width - (canvasConfig.canvasBGLeft + canvasConfig.canvasBGWidth) : 0,
      thresholdY: lineHeight / 2
    };
  }
  /**
       * Method to derive marker and text details
       * @param {Number} index data index
       * @return {Array} path array
       */
  ;

  _proto.getMarkerAndLabelConfiguration = function getMarkerAndLabelConfiguration(index, mergedStyle) {
    var timeMarker = this,
        selfConfig = timeMarker.config,
        xScale = timeMarker.config.xScale,
        _xScale$applicableCli = xScale.applicableClippings,
        repeatClips = _xScale$applicableCli.repeatClips,
        singleClips = _xScale$applicableCli.singleClips,
        xScaleDomain = xScale.getDomain(),
        value = selfConfig.valueArr[index],
        repeat = value.repeat,
        domainArr,
        lineHeight = parseFloat(mergedStyle.text['line-height']); // create the path array if given values are within total domain

    selfConfig.markerDetails[index].markerDim = [];
    selfConfig.markerDetails[index].index = index;
    selfConfig.domainArr[index] = []; // if marker is placed in a time that is clipped, do not draw it.

    if (isNaN(+value.start) || (0, _clipUtils.getUnclippedValue)(+value.start, repeatClips, singleClips) !== +value.start) return;

    if (!repeat && +value.start >= +xScaleDomain[0] && +value.start <= +xScaleDomain[1]) {
      selfConfig.domainArr[index].push(value.start); // calculate dimensions and thresholds based on its placement. If it crosses the canvas' edge then calculate
      // the offset and use it as threshold so that it could be detected properly by the mousetracker.

      selfConfig.markerDetails[index].markerDim.push(timeMarker.getMarkerDimension(value.start, lineHeight));
    } else if (repeat) {
      // get all valid repeated domains
      selfConfig.domainArr[index] = domainArr = timeMarker.getAllValidDomains(value.start, value.repeat);

      if (domainArr.length) {
        domainArr.forEach(function (domain) {
          selfConfig.markerDetails[index].markerDim.push(timeMarker.getMarkerDimension(domain, lineHeight));
        });
      }
    }
  }
  /**
       * API that calculates all the domains that can be drawn in current visible config
       * @param {Object} startValue start domain value.
       * @param {Object} repeatConfig repaeat configuration.
       */
  ;

  _proto.getAllValidDomains = function getAllValidDomains(startValueArg, repeatConfig) {
    var timeMarker = this,
        startValue = startValueArg,
        scale = timeMarker.config.xScale,
        totalDomain = scale.getDomain(),
        domainArr = []; // if start domain is less than current domain start value then start
    // from the repeated domain than comes immediately after it only if positive
    // multiplier is given

    if (+startValue < +totalDomain[0] && repeatConfig.multiplier > 0) {
      // convert to millisecond
      while (+startValue < +totalDomain[0]) {
        // shift both start and end domains by the provided unit and offset
        startValue = repeatConfig.interval.offset(startValue, repeatConfig.multiplier);
      }
    } // create all applicable domains


    while (+startValue <= +totalDomain[1]) {
      domainArr.push(startValue); // shift both start and end domains by the provided unit and offset

      startValue = repeatConfig.interval.offset(startValue, repeatConfig.multiplier);
    }

    return domainArr;
  }
  /**
   * Method that configures the component.
   * @param {Object} obj configuration object
   */
  ;

  _proto.configureAttributes = function configureAttributes(obj) {
    if (obj === void 0) {
      obj = {};
    }

    _SmartRenderer.prototype.configureAttributes.call(this, obj);

    var timeMarker = this,
        config = timeMarker.config,
        styleArr = [],
        textArr = [],
        isUTC = timeMarker.getFromEnv('UTC'),
        valueArr = [],
        valueObj,
        parser,
        startValue,
        unit,
        timeFormat,
        getStyleDef = timeMarker.getFromEnv('getStyleDef'),
        chartDefaultTextStyle = timeMarker.getFromEnv('textStyle'),
        baseTextStyle = timeMarker.getFromEnv('baseTextStyle'),
        timeMarkerConf = obj.timeMarker || [],
        i,
        len,
        marker,
        styles,
        textStyle,
        markerStyle,
        markerHoverStyle,
        markerBoxStyle,
        markerNotchStyle,
        markerLineStyle,
        userMarkerHoverStyle,
        defaultMergeTextStyle = Object.assign({}, chartDefaultTextStyle, config.defaultStyle.text, baseTextStyle); // parse and store configuration for labels and markers

    for (i = 0, len = timeMarkerConf.length; i < len; i++) {
      marker = timeMarkerConf[i]; // if no valid formatter or start value is given then continue

      if (!marker.start || marker.start === _lib.BLANKSTRING) {
        continue;
      }

      timeFormat = (0, _lib.pluck)(marker.timeformat, obj.defaultFormat); // decide the parser and set its specifier

      parser = isUTC ? _timeConverter.default.utcParser(timeFormat) : _timeConverter.default.parser(timeFormat); // parse the values

      startValue = parser.parse(marker.start);

      if (!startValue) {
        continue;
      }

      valueObj = {
        start: startValue,
        startString: marker.start,
        timeFormat: timeFormat,
        type: marker.type || config.type
      }; // check if valid repeat configuration is provided.

      if (marker.repeat && marker.repeat.unit && Math.floor(+marker.repeat.multiplier) !== 0 && isValidUnit(unit = marker.repeat.unit.toLowerCase())) {
        valueObj.repeat = {
          interval: getInterVal(unit, isUTC),
          // if unit is quarter then increase the multiplier by three times
          multiplier: (unit === 'quarter' ? 3 : 1) * (0, _lib.pluckNumber)(marker.repeat.multiplier, 1)
        };
      }

      styles = marker.style || {};
      valueArr.push(valueObj);
      textStyle = Object.assign({}, defaultMergeTextStyle, {}, getStyleDef(styles.text));
      markerStyle = Object.assign({}, config.defaultStyle.marker, getStyleDef(styles.marker));
      userMarkerHoverStyle = getStyleDef(styles['marker:hover']);
      markerHoverStyle = Object.assign({}, markerStyle, userMarkerHoverStyle);
      markerBoxStyle = Object.assign({}, markerStyle, getStyleDef(styles['marker-box']));
      markerNotchStyle = Object.assign({}, markerStyle, getStyleDef(styles['marker-notch']));
      markerLineStyle = Object.assign({}, markerStyle, getStyleDef(styles['marker-line']));
      styleArr.push({
        text: textStyle,
        'text:hover': Object.assign({}, textStyle, getStyleDef(styles['text:hover'])),
        marker: markerStyle,
        'marker:hover': markerHoverStyle,
        'marker-box': markerBoxStyle,
        'marker-box:hover': Object.assign({}, markerBoxStyle, userMarkerHoverStyle, getStyleDef(styles['marker-box:hover'])),
        'marker-notch': markerNotchStyle,
        'marker-notch:hover': Object.assign({}, markerNotchStyle, userMarkerHoverStyle, getStyleDef(styles['marker-notch:hover'])),
        'marker-line': markerLineStyle,
        'marker-line:hover': Object.assign({}, markerLineStyle, userMarkerHoverStyle, getStyleDef(styles['marker-line:hover']))
      });
      textArr.push((0, _lib.pluck)((0, _lib.parseUnsafeString)(marker.label, false), ''));
    }

    if (obj.xScale) config.xScale = obj.xScale;
    config.hoveredMarkerIndex = obj.hoveredMarkerIndex;
    config.hoveredDomainIndex = obj.hoveredDomainIndex;
    config.lastHoveredMarkerIndex = obj.lastHoveredMarkerIndex;
    config.lastHoveredDomainIndex = obj.lastHoveredDomainIndex;
    config.hoveredFromOutside = obj.hoveredFromOutside;

    if (obj.timeMarker) {
      config.valueArr = valueArr;
      config.styleArr = styleArr;
      config.textArr = textArr;
    }
  }
  /**
   * API to get properties of all labels that will be drawn
   * @param {Object} labelConfiguration label configuration
   */
  ;

  _proto.createToolipConfiguration = function createToolipConfiguration() {
    var timeMarker = this,
        selfConfig = timeMarker.config,
        //   smartLabel = timeMarker.getFromEnv('smartLabel'),
    markerDetails = selfConfig.markerDetails,
        totalDomain = selfConfig.domainArr,
        repeatationArr = selfConfig.repeatationArr,
        valueArr = selfConfig.valueArr,
        domainArr,
        timeFormat,
        //   smartText,
    isUTC = timeMarker.getFromEnv('UTC'),
        dateFormatter,
        dateLabel,
        //   labelArr = [],
    toolText = [],
        i,
        j;

    for (i = 0; i < totalDomain.length; i++) {
      domainArr = totalDomain[i];
      timeFormat = valueArr[i].timeFormat;
      dateFormatter = isUTC ? _timeConverter.default.utcFormatter(timeFormat) : _timeConverter.default.formatter(timeFormat);

      for (j = 0; j < domainArr.length; j++) {
        toolText = [];
        dateLabel = dateFormatter.format(domainArr[j]);
        toolText = toolText.concat([dateLabel], repeatationArr[i][j].labels);
        markerDetails[i].markerDim[j].toolTextArr = toolText;
      }
    }
  };

  _proto.getRepeatationArr = function getRepeatationArr() {
    var timeMarker = this,
        selfConfig = timeMarker.config,
        domainArr = selfConfig.domainArr,
        textArr = selfConfig.textArr,
        markerDetails = selfConfig.markerDetails,
        currIndex,
        sliceIndex,
        repeatationArr = [],
        convertedDomainArr,
        domainValues,
        value,
        i,
        j;

    for (i = 0; i < domainArr.length; i++) {
      domainValues = domainArr[i];
      repeatationArr[i] = [];

      for (j = 0; j < domainValues.length; j++) {
        currIndex = i;
        value = domainValues[j];
        repeatationArr[i][j] = {
          domainValue: value,
          labels: [],
          markerDimIndex: j
        };
        textArr[i] && repeatationArr[i][j].labels.push(textArr[i]);

        while (currIndex + 1 < domainArr.length) {
          convertedDomainArr = domainArr[currIndex + 1].map(function (domain) {
            return +domain;
          });

          if ((sliceIndex = convertedDomainArr.indexOf(+value)) !== -1) {
            textArr[currIndex + 1] && repeatationArr[i][j].labels.push(textArr[currIndex + 1]); // eslint-disable-next-line

            domainArr[currIndex + 1] = domainArr[currIndex + 1].filter(function (domainValue) {
              return +domainValue !== +value;
            }); // eslint-disable-next-line

            markerDetails[currIndex + 1].markerDim = markerDetails[currIndex + 1].markerDim.filter(function (domainValue, index) {
              return index !== sliceIndex;
            });
          }

          currIndex++;
        }
      }
    }

    return repeatationArr;
  };

  _proto.draw = function draw() {
    var timeMarker = this,
        selfConfig = timeMarker.config,
        values = selfConfig.valueArr,
        styleArr = selfConfig.styleArr,
        i,
        len; // create the time marker hover elements group

    timeMarker.addGraphicalElement({
      el: 'group',
      container: {
        id: 'thermo',
        label: 'thermo',
        isParent: true
      },
      component: timeMarker,
      label: 'timeMarkerHoverGroup',
      attr: {
        name: 'time-marker-hover-elem-group'
      },
      id: 'timeMarker'
    }); // create the time marker group

    timeMarker.addGraphicalElement({
      el: 'group',
      container: {
        id: 'thermo',
        label: 'thermo',
        isParent: true
      },
      component: timeMarker,
      label: 'timeMarker',
      attr: {
        name: 'time-marker-group'
      },
      id: 'timeMarker'
    });
    selfConfig.markerDetails = [];

    for (i = 0, len = values.length; i < len; i++) {
      selfConfig.markerDetails[i] = {};
      timeMarker.getMarkerAndLabelConfiguration(i, styleArr[i]);
    }

    selfConfig.repeatationArr = timeMarker.getRepeatationArr();
    timeMarker.createToolipConfiguration();
    timeMarker.drawTimeMarkers();
    timeMarker.drawTimeMarkerLabels();
  };

  _proto.drawTimeMarkers = function drawTimeMarkers() {
    var timeMarker = this,
        selfConfig = timeMarker.config,
        markerDetails = selfConfig.markerDetails,
        markerArr,
        markerDim,
        isHovered,
        type,
        parentConfig = timeMarker.getLinkedParent().config,
        padding = parentConfig.padding,
        styleArr = selfConfig.styleArr,
        lineHeight,
        style,
        i,
        j;

    for (i = 0; i < markerDetails.length; i++) {
      markerArr = markerDetails[i].markerDim;
      type = selfConfig.valueArr[i].type;

      for (j = 0; j < markerArr.length; j++) {
        isHovered = i === selfConfig.hoveredMarkerIndex && j === selfConfig.hoveredDomainIndex;
        style = styleArr[i]; // if not text is present inside the time marker but text style is given whose line height is
        // not equal to the default line height then recalculate its dimensions

        lineHeight = parseFloat(isHovered ? style['text:hover']['line-height'] : style.text['line-height'], 10);

        if (lineHeight !== parseFloat(style.text['line-height'], 10)) {
          timeMarker.reCalculateDimension(i, j, lineHeight);
        }

        markerDim = markerArr[j];

        if (isHovered || type === 'full') {
          timeMarker.addGraphicalElement({
            el: 'path',
            attr: {
              'path': [M, markerDim.x + markerDim.width / 2, markerDim.y + markerDim.height / 2, v, -parentConfig.canvasBGHeight],
              opacity: isHovered ? style['marker-line:hover'].opacity : style['marker-line'].opacity
            },
            container: {
              label: 'timeMarkerHoverGroup'
            },
            id: 'time-instance-marker-path-' + i + j,
            css: isHovered ? style['marker-line:hover'] : style['marker-line'],
            component: timeMarker,
            label: 'path'
          });
          timeMarker.addGraphicalElement({
            el: 'circle',
            attr: {
              'cx': markerDim.x + markerDim.width / 2,
              'cy': parentConfig.canvasTop + selfConfig.hoveredMarkerRadius + padding.bottom - padding.top,
              'r': selfConfig.hoveredMarkerRadius,
              'opacity': isHovered ? style['marker-notch:hover'].opacity : style['marker-notch'].opacity
            },
            container: {
              label: 'timeMarkerHoverGroup'
            },
            css: isHovered ? style['marker-notch:hover'] : style['marker-notch'],
            id: 'time-instance-marker-circle-' + i + j,
            component: timeMarker,
            label: 'path'
          });
        }

        timeMarker.addGraphicalElement({
          el: 'rect',
          attr: {
            'x': markerDim.x,
            'y': markerDim.y,
            'width': markerDim.width,
            'height': markerDim.height,
            'opacity': isHovered ? style['marker-box:hover'].opacity : style['marker-box'].opacity
          },
          container: {
            label: 'timeMarker'
          },
          css: isHovered ? style['marker-box:hover'] : style['marker-box'],
          id: 'time-instance-marker-rect-' + i + j,
          component: timeMarker,
          label: 'rect'
        });
      }
    }
  };

  _proto.drawTimeMarkerLabels = function drawTimeMarkerLabels() {
    var timeMarker = this,
        selfConfig = timeMarker.config,
        markerDetails = selfConfig.markerDetails,
        markerDim,
        repeatArr = selfConfig.repeatationArr,
        repeatConfig,
        isHovered,
        repeatDetails,
        labelLength,
        styleArr = selfConfig.styleArr,
        i,
        j;

    for (i = 0; i < repeatArr.length; i++) {
      repeatConfig = repeatArr[i];

      for (j = 0; j < repeatConfig.length; j++) {
        repeatDetails = repeatConfig[j];
        isHovered = i === selfConfig.hoveredMarkerIndex && j === selfConfig.hoveredDomainIndex;

        if ((labelLength = repeatDetails.labels.length) > 1) {
          markerDim = markerDetails[i].markerDim[repeatDetails.markerDimIndex];
          timeMarker.addGraphicalElement({
            el: 'text',
            attr: {
              'x': markerDim.x + markerDim.width / 2,
              'y': markerDim.y + markerDim.height / 2,
              'text': labelLength,
              'opacity': isHovered ? styleArr[i]['text:hover'].opacity : styleArr[i].text.opacity
            },
            container: {
              label: 'timeMarker'
            },
            css: isHovered ? styleArr[i]['text:hover'] : styleArr[i].text,
            id: 'time-instance-marker-text-' + i + j,
            component: timeMarker,
            label: 'text'
          }, true);
        }
      }
    }
  };

  _proto.getType = function getType() {
    return 'timeMarker';
  };

  _proto.getName = function getName() {
    return 'timeInstanceMarker';
  };

  return TimeInstanceMarker;
}(_componentInterface.SmartRenderer);

var _default = TimeInstanceMarker;
exports["default"] = _default;

/***/ }),

/***/ 960:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _componentInterface = __webpack_require__(290);

var _canvas = _interopRequireDefault(__webpack_require__(885));

var _line = _interopRequireDefault(__webpack_require__(907));

var _timeNavigatorAxis = _interopRequireDefault(__webpack_require__(961));

var _scrollbarFactory = _interopRequireDefault(__webpack_require__(962));

var _timeNavigatorBrushFactory = _interopRequireDefault(__webpack_require__(963));

var _timeConverter = _interopRequireDefault(__webpack_require__(350));

var _lib = __webpack_require__(274);

var DEFAULT_GRID_STYLE = {
  'stroke': '#F1F1F1',
  'stroke-width': '1',
  'stroke-opacity': '1'
},
    timeNavCanvas = function timeNavCanvas(timeNav) {
  var config = timeNav.config,
      styleDef = timeNav.getFromEnv('getStyleDef'),
      chartAttrs = timeNav.getFromEnv('chart-attrib'),
      // Time navigator always creates a single canvas. Hence, ignoring the
  // presence of other X Axis configurations and only using the 0th one to
  // fetch the style of the grid lines and pass it onto the canvas.
  //
  // Ideally, canvas itself should pick up the required grid line styles
  // withinduringduring its configuration. However, due to lack of time and
  // to avoid major last minute changes this is not being changed right now.
  //
  // TODO: Make canvas pick up the required grid line styles.
  xStyle = config.xConfigs[0].style ? config.xConfigs[0].style : {},
      // Merge user given grid line styles and default grid line styles
  gridLineStyle = Object.assign({}, DEFAULT_GRID_STYLE, styleDef(xStyle['grid-line'])); // @todo- mind the orientation

  timeNav.attachChild(_canvas.default, 'canvas').configure({
    xConfigs: config.xConfigs,
    yConfigs: config.yConfigs,
    plotConfigs: config.plotConfigs,
    tableMap: config.tableMap,
    enableGridLines: true,
    gridBandSupported: false,
    gridLineDirection: 'vertical',
    enableMarkers: false,
    enableReferenceLine: false,
    enableReferenceZone: false,
    leftBorder: config.border.left,
    bottomBorder: config.border.bottom,
    topBorder: config.border.top,
    rightBorder: config.border.right,
    enableTimeMarkers: false,
    styleGridLines: 0,
    includeLegend: 0,
    enableMouseTracking: 0,
    isContext: true,
    dataTable: config.dataTable,
    gridLineStyle: gridLineStyle,
    legendInteracted: config.legendInteracted,
    canvasStyle: styleDef(chartAttrs.style && chartAttrs.style.canvas)
  });
},
    extractScales = function extractScales(cfg) {
  return cfg.scale;
};

var TimeNavigator = /*#__PURE__*/function (_SmartRenderer) {
  (0, _inheritsLoose2.default)(TimeNavigator, _SmartRenderer);

  function TimeNavigator() {
    var _this;

    _this = _SmartRenderer.call(this) || this;
    _this._dimensions = {};
    _this._translation = {};
    _this._scrollbarConfig = {};

    _this.registerFactory('timeNavigatorAxis', _timeNavigatorAxis.default);

    _this.registerFactory('scrollbar', _scrollbarFactory.default);

    _this.registerFactory('brush', _timeNavigatorBrushFactory.default);

    _this.registerFactory('canvas', timeNavCanvas);

    return _this;
  }

  var _proto = TimeNavigator.prototype;

  _proto.__setDefaultConfig = function __setDefaultConfig(obj) {
    if (obj === void 0) {
      obj = {};
    }

    _SmartRenderer.prototype.__setDefaultConfig.call(this, obj);

    var config = this.config; // set default dimensions of itself and its child.

    config.startX = 0;
    config.startY = 0;
    config.scrollbarHeight = 18;
    config.scrollbarStart = -17.5;
    config.scrollbarButtonWidth = 17;
    config.yScalePadding = 20;
    config.formatter = _timeConverter.default.formatter('%b %d, %Y');
    config.border = {
      left: 1,
      right: 1,
      top: 1,
      bottom: 0
    };
    config.labels = {};
  }
  /**
   * Method to set the context scale for time navigator
   */
  ;

  _proto.setContextScaleLimit = function setContextScaleLimit() {
    var timeNav = this,
        contextBin = timeNav.getFromEnv('contextBins')[0];
    timeNav.config.contextScale.setBinMin(contextBin.getBinMin()).setRangeThreshold(contextBin.getRangeThreshold()).setDomain(timeNav.getFromEnv('chart').getContextLimit());
  }
  /**
   * Method to set its dimension.
   * @param {Object} dim dimensions
   */
  ;

  _proto.setDimension = function setDimension(dim) {
    var _this2 = this;

    if (dim === void 0) {
      dim = {};
    }

    var timeNav = this,
        config = timeNav.config,
        canvas = timeNav.getChildren('canvas')[0],
        brush = timeNav.getChildren('brush')[0],
        border = config.border;
    timeNav._dimensions.width = (0, _lib.pluckNumber)(dim.width, timeNav._dimensions.width);
    timeNav._dimensions.height = (0, _lib.pluckNumber)(dim.height, timeNav._dimensions.height); // @todo- mind the orientation

    config.xConfigs.map(extractScales).forEach(function (scale) {
      scale.setRange([border.left, _this2._dimensions.width - (border.left + border.right) / 2]);
    });
    config.contextScale.setRange(config.xConfigs[0].scale.getRange());
    brush.setBrushValue(timeNav.getFromEnv('chart').getFocusLimit());
    var labelSpace = brush.getLabelSpace(); // set canvas dimensions

    canvas.setDimension({
      left: config.startX,
      top: labelSpace,
      width: this._dimensions.width,
      height: Math.max(this._dimensions.height - labelSpace - config.scrollbarHeight, 0)
    });
    timeNav.getChildren('timeAxis').forEach(function (axis) {
      axis.setTranslation(0, labelSpace);
      axis.placeAxis();
    });
    config.yConfigs.map(extractScales).forEach(function (scale) {
      return scale.setRange([_this2._dimensions.height - config.scrollbarHeight - border.top - border.bottom, labelSpace]);
    });
    timeNav.setChildDimension();
  }
  /**
   * Method to get its translated position
   * @return {Object} translated position
   */
  ;

  _proto.getPosition = function getPosition() {
    return {
      x: this.config._translateX,
      y: this.config._translateY
    };
  }
  /**
   * Method to set the dimension of its child components
   */
  ;

  _proto.setChildDimension = function setChildDimension() {
    var timeNav = this,
        config = timeNav.config,
        brush = timeNav.getChildren('brush')[0],
        labelSpace = brush.getLabelSpace(),
        scrollbar = timeNav.getChildren('scrollbar')[0],
        contextScale = config.contextScale,
        contextRange = contextScale.getRange(),
        focusDomain = timeNav.getFromEnv('chart').getFocusLimit(),
        focusRange = focusDomain.map(function (val) {
      return contextScale.getRangeValue(val);
    }); // set max allowable dimensions of brush.

    brush.setMaxBrushDimensions({
      x: contextRange[0],
      y: labelSpace,
      width: contextRange[1] - contextRange[0],
      height: this._dimensions.height - labelSpace - config.scrollbarHeight
    }); // store the current play dimension of brush component as a whole.

    brush.setCurrentBrushDimensions({
      x: focusRange[0],
      y: labelSpace,
      width: focusRange[1] - focusRange[0],
      height: this._dimensions.height - labelSpace - config.scrollbarHeight
    }); // set scrollbar dimensions

    scrollbar.setDimension({
      x: config.scrollbarStart,
      y: this._dimensions.height - config.scrollbarHeight,
      height: config.scrollbarHeight,
      width: this._dimensions.width + 2 * config.scrollbarButtonWidth + 1 // 1px is for left and right padding of scrollbar

    });
    timeNav.setScrollbarConfig('width', this._dimensions.width + 2 * config.scrollbarButtonWidth + 1);
    scrollbar.config.scrollRatio = timeNav.getScrollRatio();
    timeNav.setScrollbarConfig('scrollRatio', scrollbar.config.scrollRatio);
    scrollbar.config.scrollPosition = timeNav.getScrollPosition();
    timeNav.setScrollbarConfig('scrollPosition', scrollbar.config.scrollPosition);
    timeNav.setScrollbarConfig('height', config.scrollbarHeight);
  }
  /**
   * Method to get its current dimensions
   */
  ;

  _proto.getDimension = function getDimension() {
    return this._dimensions;
  };

  _proto.configureAttributes = function configureAttributes(obj) {
    if (obj === void 0) {
      obj = {};
    }

    _SmartRenderer.prototype.configureAttributes.call(this, obj);

    var timeNav = this,
        timeNavConfig = timeNav.config;
    Object.assign(timeNavConfig, obj);
    timeNav.setContextScaleLimit();
    timeNav.addToEnv('timeNavigator', timeNav);
    timeNav.addToEnv('timeNavigatorConfig', timeNavConfig);
  }
  /**
   * Method that attaches handlers on this component
   */
  ;

  _proto.attachHandlers = function attachHandlers() {
    var timeNav = this,
        brush,
        leftLabel,
        rightLabel;
    timeNav.addEventListener('fc-mouseover', timeNav.mouseoverHandler || (timeNav.mouseoverHandler = function () {
      // clear the timer set on mouseout, every time a mouseover is encountered from time nav or its child components
      // through event bubbling.
      clearTimeout(timeNav.mouseoutTimer);
      brush = this.getChildren('brush')[0];
      leftLabel = brush.getChildren('leftLabel')[0];
      rightLabel = brush.getChildren('rightLabel')[0]; // draw labels only if previously not visible.

      if (!leftLabel.config.showLabel && !rightLabel.config.showLabel) {
        leftLabel.setData({
          showLabel: true
        }, true);
        rightLabel.setData({
          showLabel: true
        }, true);
      }
    }));
    timeNav.addEventListener('fc-mouseup', timeNav.mouseupHandler || (timeNav.mouseupHandler = function () {
      // inform brush that mouse is released within its boundaries and no need to hide the labels.
      brush.config.pointerReleasedOnParent = true;
    }));
    timeNav.addEventListener('fc-mouseout', timeNav.mouseoutHandler || (timeNav.mouseoutHandler = function () {
      // if currently a label is getting dragged then dont hide the labels.
      if (!timeNav.config.labelsGettingDragged) {
        // create a timer every time a mouseout is encountered from time nav or its child components
        // through event bubbling.
        timeNav.mouseoutTimer = setTimeout(function () {
          leftLabel.setData({
            showLabel: false
          }, true);
          rightLabel.setData({
            showLabel: false
          }, true);
        }, 20);
      }
    }));
  };

  _proto.draw = function draw() {
    var timeNav = this;
    timeNav.addGraphicalElement({
      el: 'group',
      container: {
        id: 'tropo',
        label: 'group',
        isParent: true
      },
      component: timeNav,
      label: 'group',
      attr: {
        name: 'timenav-tropo',
        transform: timeNav.config.translate
      },
      id: 'tropo'
    });
    timeNav.addGraphicalElement({
      el: 'group',
      container: {
        id: 'strato',
        label: 'group',
        isParent: true
      },
      component: timeNav,
      label: 'group',
      attr: {
        name: 'timenav-strato',
        transform: timeNav.config.translate
      },
      id: 'strato'
    });
    timeNav.addGraphicalElement({
      el: 'group',
      container: {
        id: 'meso',
        label: 'group',
        isParent: true
      },
      component: timeNav,
      label: 'group',
      attr: {
        name: 'timenav-meso',
        transform: timeNav.config.translate
      },
      id: 'meso'
    });
    timeNav.addGraphicalElement({
      el: 'group',
      container: {
        id: 'thermo',
        label: 'group',
        isParent: true
      },
      component: timeNav,
      label: 'group',
      attr: {
        name: 'timenav-thermo',
        transform: timeNav.config.translate
      },
      id: 'thermo'
    });
    timeNav.addGraphicalElement({
      el: 'group',
      container: {
        id: 'exo',
        label: 'group',
        isParent: true
      },
      component: timeNav,
      label: 'group',
      attr: {
        name: 'timenav-exo',
        transform: timeNav.config.translate
      },
      id: 'exo'
    }); // time axis group

    timeNav.addGraphicalElement({
      el: 'group',
      attr: {
        name: 'time-axis-group'
      },
      id: 'axisTopGroup',
      label: 'group',
      container: {
        id: 'strato',
        label: 'group'
      },
      component: timeNav
    }, true); // scrollbar group

    timeNav.addGraphicalElement({
      el: 'group',
      attr: {
        name: 'scrollbar-group'
      },
      id: 'scrollbarContainer',
      label: 'scrollbar',
      container: {
        id: 'thermo',
        label: 'group'
      },
      component: timeNav
    }, true);
  }
  /**
   * Method to store its child scrollbar config
   * @param {String} conf configuration name
   * @param {Number} value configuration value
   */
  ;

  _proto.setScrollbarConfig = function setScrollbarConfig(conf, value) {
    this._scrollbarConfig[conf] = value;
  }
  /**
   * Method to get its child scrollbar config
   * @param {String} conf configuration name
   */
  ;

  _proto.getScrollbarConfig = function getScrollbarConfig(conf) {
    return conf ? this._scrollbarConfig[conf] : this._scrollbarConfig;
  }
  /**
  * Method that informs chart to validate domains
  * @param {Array} values Domain values
  */
  ;

  _proto.validateDomain = function validateDomain(values, direction, obj) {
    var timeNav = this,
        startPx = values[0],
        endPx = values[1],
        scale = timeNav.config.contextScale,
        range = scale.getRange(),
        chart = timeNav.getFromEnv('chart');

    if (startPx > endPx) {
      var _ref = [endPx, startPx];
      startPx = _ref[0];
      endPx = _ref[1];
    }

    startPx = _lib.clampNumber.apply(void 0, [startPx].concat(range));
    endPx = _lib.clampNumber.apply(void 0, [endPx].concat(range));
    chart.setPixelLimit([startPx, endPx], scale, [].concat(direction), {
      name: obj.eventName,
      eventArgs: obj.eventArgs,
      options: obj.eventArgs
    });
  }
  /**
   * Method that smartly calculates the scroll ratio
   */
  ;

  _proto.getScrollRatio = function getScrollRatio() {
    var timeNav = this,
        scrollbarConf = timeNav.getChildren('scrollbar')[0].config,
        _timeNav$getChildren$ = timeNav.getChildren('canvas')[0].config,
        leftBorder = _timeNav$getChildren$.leftBorder,
        rightBorder = _timeNav$getChildren$.rightBorder,
        width = scrollbarConf.width,
        height = scrollbarConf.height,
        scrollButtonsTotalWidth = 2 * Math.min(height, width * 0.5),
        brush = timeNav.getChildren('brush')[0],
        borderToWidthRatio = (leftBorder + rightBorder) / width,
        selectionWidth = brush.getCurrentBrushDimensions().width; // scroll ration will turn to infinity if width - scrollButtonsTotalWidth is 0

    var scrollRatio = (selectionWidth + 1) / Math.max(0.001, width - scrollButtonsTotalWidth); // 1px is for left and right padding of scrollbar

    /**
     * borderToWidthRatio is the ratio of canvas left and right thickness by total timeNav width.
     * When scrollRatio is more than (1 - borderToWidthRatio), it means that scroll bar should take up full
     * space of the scroll track. Hence, the scrollRatio is set to 1.
     */

    if (scrollRatio >= 1 - borderToWidthRatio) {
      return 1;
    }

    return scrollRatio;
  }
  /**
   * Method that smartly calculates the scroll position
   */
  ;

  _proto.getScrollPosition = function getScrollPosition() {
    var timeNav = this,
        scrollbarConf = timeNav.getChildren('scrollbar')[0].config,
        width = scrollbarConf.width,
        height = scrollbarConf.height,
        scrollButtonsTotalWidth = 2 * Math.min(height, width * 0.5),
        brush = timeNav.getChildren('brush')[0],
        selectionStart = brush.getCurrentBrushDimensions().x,
        selectionWidth = brush.getCurrentBrushDimensions().width,
        scrollRatio = timeNav.getScrollbarConfig('scrollRatio'),
        anchorWidth = scrollRatio * (width - scrollButtonsTotalWidth),
        scrollPositionRange = width - (scrollButtonsTotalWidth + anchorWidth),
        rangeMinPx = scrollButtonsTotalWidth / 2 + anchorWidth / 2 - timeNav.config.scrollbarButtonWidth;
    return (selectionStart + selectionWidth / 2 - rangeMinPx) / scrollPositionRange;
  }
  /**
   * This method returns the dataset defination
   */
  ;

  _proto.getDSdef = function getDSdef() {
    return _line.default;
  };

  _proto.getName = function getName() {
    return 'TimeNavigator';
  };

  return TimeNavigator;
}(_componentInterface.SmartRenderer);

var _default = TimeNavigator;
exports["default"] = _default;

/***/ }),

/***/ 888:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _timeSpanMinMarker = _interopRequireDefault(__webpack_require__(887));

var UNDEF;

var TimeSpanFullMarker = /*#__PURE__*/function (_TimeSpanMinMarker) {
  (0, _inheritsLoose2.default)(TimeSpanFullMarker, _TimeSpanMinMarker);

  function TimeSpanFullMarker() {
    return _TimeSpanMinMarker.apply(this, arguments) || this;
  }

  var _proto = TimeSpanFullMarker.prototype;

  _proto.setHoverInEffect = function setHoverInEffect(index, domainIndex) {
    var timeMarker = this,
        chart = timeMarker.getFromEnv('chart');
    timeMarker.setData({
      hoveredIndex: index,
      hoveredDomainIndex: domainIndex
    }, true);
    chart.fireEvent('timeSpanFullMarkerHovered', {
      senderTimeMarker: timeMarker,
      hoveredIndex: index,
      hoveredFromOutside: true
    });
  };

  _proto.setHoverOutEffect = function setHoverOutEffect() {
    var timeMarker = this,
        config = timeMarker.config,
        chart = timeMarker.getFromEnv('chart');
    timeMarker.setData({
      hoveredIndex: UNDEF,
      lastHoveredMarkerIndex: config.hoveredIndex,
      lastHoveredDomainIndex: config.hoveredDomainIndex
    }, true);
    chart.fireEvent('timeSpanFullMarkerHovered', {
      senderTimeMarker: timeMarker,
      hoveredIndex: UNDEF,
      hoveredFromOutside: true
    });
  };

  _proto.createGroup = function createGroup() {
    var timeMarker = this,
        canvasConfig = timeMarker.getLinkedParent().config,
        padding = canvasConfig.padding,
        canvasLeft = canvasConfig.canvasBGLeft - padding.left,
        canvasTop = canvasConfig.canvasBGTop - padding.top,
        canvasWidth = canvasConfig.canvasBGWidth,
        canvasHeight = canvasConfig.canvasBGHeight,
        clipPath = ["M" + canvasLeft + "," + canvasTop, "L" + (canvasLeft + canvasWidth) + "," + canvasTop, "L" + (canvasLeft + canvasWidth) + "," + (canvasTop + canvasHeight), "L" + canvasLeft + "," + (canvasTop + canvasHeight) + "Z"];
    timeMarker.addGraphicalElement({
      el: 'group',
      container: {
        id: 'strato',
        label: 'group',
        isParent: true
      },
      component: timeMarker,
      label: 'timeMarker',
      attr: {
        name: 'time-marker-full-group',
        'clip-path': clipPath
      },
      id: 'timeMarker'
    });
  };

  _proto.getName = function getName() {
    return 'timeSpanFullMarker';
  };

  return TimeSpanFullMarker;
}(_timeSpanMinMarker.default);

var _default = TimeSpanFullMarker;
exports["default"] = _default;

/***/ }),

/***/ 887:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _componentInterface = __webpack_require__(290);

var _utc = __webpack_require__(497);

var _timeIntervals = __webpack_require__(490);

var _lib = __webpack_require__(274);

var _timeConverter = _interopRequireDefault(__webpack_require__(350));

var _clipUtils = __webpack_require__(864);

var UNDEF;
var GUTTER_2 = 2,
    GUTTER_5 = 5,
    GUTTER_8 = 8,
    GUTTER_14 = 14,
    MINIMAL = 'minimal',
    ROLLOVER = 'timeMarkerRollOver',
    ROLLOUT = 'timeMarkerRollOut',
    CLICK = 'timeMarkerClick'; // function to check if the given unit is valid

function isValidUnit(unit) {
  switch (unit) {
    case 'year':
    case 'quarter':
    case 'month':
    case 'week':
    case 'day':
    case 'hour':
    case 'minute':
    case 'second':
    case 'millisecond':
      return true;

    default:
      return false;
  }
} // function to get the time interval


function getInterVal(unit, isUTC) {
  switch (unit) {
    case 'year':
      return isUTC ? _utc.utcYear : _timeIntervals.timeYear;

    case 'quarter':
      return isUTC ? _utc.utcMonth : _timeIntervals.timeMonth;

    case 'month':
      return isUTC ? _utc.utcMonth : _timeIntervals.timeMonth;

    case 'week':
      return isUTC ? _utc.utcWeek : _timeIntervals.timeWeek;

    case 'day':
      return isUTC ? _utc.utcDay : _timeIntervals.timeDay;

    case 'hour':
      return isUTC ? _utc.utcHour : _timeIntervals.timeHour;

    case 'minute':
      return isUTC ? _utc.utcMinute : _timeIntervals.timeMinute;

    case 'second':
      return isUTC ? _utc.utcSecond : _timeIntervals.timeSecond;

    case 'millisecond':
      return isUTC ? _utc.utcMillisecond : _timeIntervals.timeMillisecond;
  }
}

function isWithinMarker(timeMarker, chartX, chartY, marker) {
  var hovered = false,
      dimensions = marker.markerDim,
      hoveredMarkerDim,
      i,
      len,
      canvasDim = timeMarker.getLinkedParent().getDimension(),
      showTimeSpanMarkerTooltipAt = timeMarker.config.showTimeSpanMarkerTooltipAt;

  for (i = 0, len = dimensions.length; i < len; i++) {
    var dimension = dimensions[i],
        widthInCanvas = Math.min(dimension.x + dimension.width, canvasDim.left + canvasDim.width) - Math.max(dimension.x, canvasDim.left);

    if (chartX >= dimension.x && chartX <= dimension.x + dimension.width && (showTimeSpanMarkerTooltipAt === 1 || widthInCanvas <= canvasDim.width * showTimeSpanMarkerTooltipAt) && chartY >= dimension.y && chartY <= dimension.y + dimension.height) {
      hovered = true;
      timeMarker.config.previouslyHoveredIndex = marker.index;
      hoveredMarkerDim = dimension;
      break;
    }
  }

  return {
    pointIndex: marker.index,
    hovered: hovered,
    pointObj: {
      hoveredMarkerDim: hoveredMarkerDim,
      index: hovered && i,
      type: marker.type
    },
    previouslyHoveredIndex: timeMarker.config.previouslyHoveredIndex,
    component: timeMarker
  };
} // function to determine whether a given marker dimension is valid


function isValidMarker(currDomainStart, currDomainEnd, totalDomainStart, totalDomainEnd) {
  if (currDomainStart >= totalDomainStart && currDomainStart <= totalDomainEnd || currDomainEnd <= totalDomainEnd && currDomainEnd >= totalDomainStart || totalDomainStart >= currDomainStart && totalDomainEnd <= currDomainEnd) {
    return true;
  }

  return false;
}

var TimeSpanMinMarker = /*#__PURE__*/function (_SmartRenderer) {
  (0, _inheritsLoose2.default)(TimeSpanMinMarker, _SmartRenderer);

  function TimeSpanMinMarker() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _SmartRenderer.call.apply(_SmartRenderer, [this].concat(args)) || this;

    _this.getClassName = function (baseName) {
      if (baseName === void 0) {
        baseName = '';
      }

      var randomString = Math.random().toString(36).substring(2);
      return baseName + "-" + randomString;
    };

    _this.getCSPNonce = function () {
      var metaTag = document.querySelector("meta[http-equiv=\"Content-Security-Policy\"]");

      if (metaTag) {
        var content = metaTag.getAttribute('content');

        if (content) {
          var match = content.match(/'nonce-([^']+)'/);

          if (match) {
            return match[1];
          }
        }
      }

      return null;
    };

    return _this;
  }

  var _proto = TimeSpanMinMarker.prototype;

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    _SmartRenderer.prototype.__setDefaultConfig.call(this);

    var config = this.config;
    config.defaultStyle = {
      text: {
        'fill': '#808080',
        'opacity': 1,
        'font-size': '10px',
        'font-weight': 'normal',
        'font-style': 'normal',
        'text-anchor': 'middle',
        'fill-opacity': 1,
        'stroke-opacity': 1
      },
      marker: {
        'fill': '#62b58f',
        'opacity': 0.2,
        'fill-opacity': 1,
        'stroke-opacity': 1,
        'border-thickness': 0,
        'border-padding': 1,
        'border-radius': 0,
        'border-dash': 'none',
        'stroke-width': 1,
        'stroke-dasharray': 'none',
        'stroke': 'none'
      }
    };
    this.config.lastHoveredMarkerIndex = UNDEF;
    this.config.lastHoveredDomainIndex = UNDEF;
    config.hoveredIndex = UNDEF;
    config.previouslyHoveredIndex = UNDEF;
    config.hoveredOpacity = 0.5;
    config.valueArr = [];
    config.textArr = [];
    config.styleArr = [];
    config.domainArr = [];
    config.markerDetails = [];
    config.type = MINIMAL;
    config.showTimeSpanMarkerTooltipAt = 1;
  };

  _proto.getHoveredMarker = function getHoveredMarker(chartXArg, chartYArg) {
    var timeMarker = this,
        chartX = chartXArg,
        chartY = chartYArg,
        selfConfig = timeMarker.config,
        canvas = timeMarker.getLinkedParent(),
        translationObj = canvas.getTranslation(),
        hoverDetails,
        markerDetails = selfConfig.markerDetails,
        i;
    chartX -= translationObj.x;
    chartY -= translationObj.y;

    for (i = markerDetails.length - 1; i >= 0; i--) {
      hoverDetails = isWithinMarker(timeMarker, chartX, chartY, markerDetails[i]);

      if (hoverDetails.hovered) {
        break;
      }
    }

    return hoverDetails;
  };

  _proto.setHoverInEffect = function setHoverInEffect(index, domainIndex) {
    var timeMarker = this,
        chart = timeMarker.getFromEnv('chart');
    timeMarker.setData({
      hoveredIndex: index,
      hoveredDomainIndex: domainIndex
    }, true);
    chart.fireEvent('timeSpanMinMarkerHovered', {
      senderTimeMarker: timeMarker,
      hoveredIndex: index,
      hoveredFromOutside: true
    });
  };

  _proto.setHoverOutEffect = function setHoverOutEffect() {
    var timeMarker = this,
        config = timeMarker.config,
        chart = timeMarker.getFromEnv('chart');
    timeMarker.setData({
      hoveredIndex: UNDEF,
      lastHoveredMarkerIndex: config.hoveredIndex,
      lastHoveredDomainIndex: config.hoveredDomainIndex
    }, true);
    chart.fireEvent('timeSpanMinMarkerHovered', {
      senderTimeMarker: timeMarker,
      hoveredIndex: UNDEF,
      hoveredFromOutside: true
    });
  };

  _proto.fireMarkerEvents = function fireMarkerEvents(type, hoverMarkerIndex, hoverDomainIndex) {
    var timeMarker = this,
        config = timeMarker.config,
        valueArr = config.valueArr,
        textArr = config.textArr,
        domainArr = config.domainArr,
        markerIndex,
        domainIndex,
        dateFormatter,
        startMS,
        endMS,
        isUTC = timeMarker.getFromEnv('UTC'),
        timeFormat,
        chart = timeMarker.getFromEnv('chart'),
        eventToBeFired;

    switch (type) {
      case 'fc-mouseover':
        eventToBeFired = ROLLOVER;
        markerIndex = hoverMarkerIndex;
        domainIndex = hoverDomainIndex;
        break;

      case 'fc-mouseout':
        markerIndex = config.lastHoveredMarkerIndex;
        domainIndex = config.lastHoveredDomainIndex; // for the first time when a time marker is hovered, its last hovered and
        // hoveredout index is not defined, so skip this firing

        if (markerIndex !== UNDEF && domainIndex !== UNDEF) {
          eventToBeFired = ROLLOUT;
        }

        break;

      case 'fc-click':
        eventToBeFired = CLICK;
        markerIndex = hoverMarkerIndex;
        domainIndex = hoverDomainIndex;
        break;
    }

    if (eventToBeFired) {
      timeFormat = valueArr[markerIndex].timeFormat;
      dateFormatter = isUTC ? _timeConverter.default.utcFormatter(timeFormat) : _timeConverter.default.formatter(timeFormat);
      startMS = +domainArr[markerIndex][domainIndex].start;
      endMS = +domainArr[markerIndex][domainIndex].end;
      chart.fireChartInstanceEvent(eventToBeFired, {
        start: startMS,
        startText: dateFormatter.format(startMS),
        end: endMS,
        endText: dateFormatter.format(endMS),
        formatter: timeFormat,
        type: valueArr[markerIndex].type,
        label: textArr[markerIndex]
      });
    }
  };

  /**
  * Method to get the tooltip configurations
  * @param {Array} toolTextArr Array of tooltexts
  * @param {String} type type of time marker
  */
  _proto.getToolTextConfiguration = function getToolTextConfiguration(toolTextArr, type) {
    var timeMarker = this,
        _timeMarker$getFromEn = timeMarker.getFromEnv('tooltipStyle'),
        headerStyle = _timeMarker$getFromEn.header,
        bodyStyle = _timeMarker$getFromEn.body,
        totalWidth = 2 * GUTTER_5 + 2 * GUTTER_8 + GUTTER_14,
        totalHeight = 2 * GUTTER_5 + 2 * GUTTER_8,
        smartLabel = timeMarker.getFromEnv('smartLabel'),
        smartText;

    smartLabel.setStyle({
      'font-size': headerStyle['font-size'],
      'font-family': headerStyle['font-family'],
      'font-weight': headerStyle['font-weight']
    });
    smartText = smartLabel.getOriSize(toolTextArr[0]);
    totalWidth += smartText.width;
    totalHeight += smartText.height;
    var toolTipTextArrMarginClass = this.getClassName('tooltip-text-margin'),
        toolTipTextArrPaddingClass = this.getClassName('tooltip-text-padding'),
        chartNonce = this.getCSPNonce();

    if (toolTextArr[1]) {
      smartLabel.setStyle({
        'font-size': bodyStyle['font-size'],
        'font-family': bodyStyle['font-family'],
        'font-weight': bodyStyle['font-weight']
      });
      smartText = smartLabel.getOriSize(toolTextArr[1]);
      totalHeight += smartText.height;
      totalWidth = Math.max(totalWidth, smartText.width);
      return {
        header: "<style nonce=\"" + chartNonce + "\">." + toolTipTextArrMarginClass + " {margin: 5px;}</style><div class=\"" + toolTipTextArrMarginClass + "\">" + toolTextArr[0] + "</div>",
        body: "<style nonce=\"" + chartNonce + "\">." + toolTipTextArrMarginClass + " {margin: 5px;}</style><div class=\"" + toolTipTextArrMarginClass + "\">" + toolTextArr[1] + "</div>",
        dimensions: {
          width: totalWidth,
          height: type !== 'full' ? totalHeight : 0
        }
      };
    }

    return {
      header: "<style nonce=\"" + chartNonce + "\">." + toolTipTextArrPaddingClass + " {padding: 5px;}</style><div class=\"" + toolTipTextArrPaddingClass + "\">" + toolTextArr[0] + "</div>",
      body: '',
      dimensions: {
        width: totalWidth,
        height: type !== 'full' ? totalHeight : 0
      }
    };
  }
  /**
       * Method to derive marker and text details
       * @param {Number} index data index
       * @param {Number} lineHeight line height of the text
       * @return {Array} path array
       */
  ;

  _proto.getMarkerAndLabelConfiguration = function getMarkerAndLabelConfiguration(index, lineHeight) {
    var timeMarker = this,
        selfConfig = timeMarker.config,
        canvasConfig = timeMarker.getLinkedParent().config,
        canvasPadding = canvasConfig.padding,
        leftPadding = canvasPadding.left,
        rightPadding = canvasPadding.right,
        topPadding = canvasPadding.top,
        bottomPaddding = canvasPadding.bottom,
        xScale = timeMarker.config.xScale,
        xScaleDomain = xScale.getDomain(),
        value = selfConfig.valueArr[index],
        repeat = value.repeat,
        startRangeValue,
        textX,
        textY,
        type,
        markerYPos,
        markerHeight,
        domainArr,
        startDomain,
        endDomain,
        endRangeValue; // get start and end range values

    startRangeValue = xScale.getRangeValue(value.start);
    endRangeValue = xScale.getRangeValue(value.end);
    type = value.type;
    textY = type === 'full' ? canvasConfig.canvasTop + GUTTER_2 + topPadding : canvasConfig.canvasTop + canvasConfig.canvasHeight - GUTTER_2 - topPadding + bottomPaddding;
    markerYPos = type === 'full' ? canvasConfig.canvasTop - canvasConfig.padding.top : canvasConfig.canvasTop + canvasConfig.canvasHeight - (lineHeight + 2 * GUTTER_2) - topPadding + bottomPaddding;
    markerHeight = type === 'full' ? canvasConfig.canvasHeight : lineHeight + 2 * GUTTER_2; // create the path array if given values are within total domain

    selfConfig.markerDetails[index].markerDim = [];
    selfConfig.domainArr[index] = [];
    selfConfig.markerDetails[index].index = index;

    if (!repeat && isValidMarker(+value.start, +value.end, +xScaleDomain[0], +xScaleDomain[1])) {
      selfConfig.domainArr[index].push({
        start: value.start,
        end: value.end
      });
      selfConfig.markerDetails[index].markerDim.push({
        x: startRangeValue - leftPadding + rightPadding,
        y: markerYPos,
        width: endRangeValue - startRangeValue,
        height: markerHeight
      });
      textX = startRangeValue - leftPadding + rightPadding;
      startDomain = value.start;
      endDomain = value.end;
    } else if (repeat) {
      // get all valid repeated domains
      selfConfig.domainArr[index] = domainArr = timeMarker.getAllValidDomains(value.start, value.end, value.repeat);

      if (domainArr.length) {
        // get the configuration of the starting domain.
        textX = xScale.getRangeValue(domainArr[0].start) - leftPadding + rightPadding;
        startDomain = domainArr[0].start;
        endDomain = domainArr[0].end;
        domainArr.forEach(function (domain) {
          // get start and end range values
          startRangeValue = xScale.getRangeValue(domain.start);
          endRangeValue = xScale.getRangeValue(domain.end);
          selfConfig.markerDetails[index].markerDim.push({
            x: startRangeValue - leftPadding + rightPadding,
            y: markerYPos,
            width: endRangeValue - startRangeValue,
            height: markerHeight
          }); // if negative multiplier is given then take the configuration of the least domain available

          if (repeat.multiplier < 0) {
            textX = startRangeValue - leftPadding + rightPadding;
            startDomain = domain.start;
            endDomain = domain.end;
          }
        });
      }
    }

    selfConfig.markerDetails[index].type = type;
    return {
      labelConfiguration: {
        x: textX,
        y: textY,
        width: endRangeValue - startRangeValue - 2 * GUTTER_2,
        startDomain: startDomain,
        endDomain: endDomain
      }
    };
  }
  /**
       * API that calculates all the domains that can be drawn in current visible config
       * @param {Object} startValue start domain value.
       * @param {Object} endValue end domain value.
       * @param {Object} repeatConfig repaeat configuration.
       */
  ;

  _proto.getAllValidDomains = function getAllValidDomains(startValueArg, endValueArg, repeatConfig) {
    var timeMarker = this,
        scale = timeMarker.config.xScale,
        totalDomain = scale.getDomain(),
        startValue = startValueArg,
        endValue = endValueArg,
        domainArr = [],
        timeDifference = Number(endValue) - Number(startValue); // if start domain is less than current domain start value then start
    // from the first valid marker only if it falls within current focus domain

    if (+startValue < +totalDomain[0] && repeatConfig.multiplier > 0) {
      // convert to millisecond
      while (!isValidMarker(+startValue, +endValue, +totalDomain[0], +totalDomain[1]) && +startValue <= +totalDomain[1]) {
        // shift both start and end domains by the provided unit and offset
        startValue = repeatConfig.interval.offset(startValue, repeatConfig.multiplier); // Calculating endvalue based on increment of timedifference to ensure uniformity of time span marker widths

        endValue = new Date(Number(startValue) + timeDifference);
      }
    } // create all applicable domains


    while (isValidMarker(+startValue, +endValue, +totalDomain[0], +totalDomain[1])) {
      domainArr.push({
        start: startValue,
        end: endValue
      }); // shift both start and end domains by the provided unit and offset

      startValue = repeatConfig.interval.offset(startValue, repeatConfig.multiplier);
      endValue = new Date(Number(startValue) + timeDifference);
    }

    return domainArr;
  }
  /**
   * Method that configures the component.
   * @param {Object} obj configuration object
   */
  ;

  _proto.configureAttributes = function configureAttributes(obj) {
    if (obj === void 0) {
      obj = {};
    }

    _SmartRenderer.prototype.configureAttributes.call(this, obj);

    var timeMarker = this,
        config = timeMarker.config,
        styleArr = [],
        textArr = [],
        isUTC = timeMarker.getFromEnv('UTC'),
        _timeMarker$getFromEn2 = timeMarker.getFromEnv('focusScalesX')[0].applicableClippings,
        repeatClips = _timeMarker$getFromEn2.repeatClips,
        singleClips = _timeMarker$getFromEn2.singleClips,
        valueArr = [],
        valueObj,
        parser,
        startValue,
        timeFormat,
        endValue,
        unit,
        getStyleDef = timeMarker.getFromEnv('getStyleDef'),
        chartDefaultTextStyle = timeMarker.getFromEnv('textStyle'),
        baseTextStyle = timeMarker.getFromEnv('baseTextStyle'),
        timeMarkerConf = obj.timeMarker || [],
        i,
        len,
        marker,
        markerStyle,
        textStyle,
        styles,
        defaultMergeTextStyle = Object.assign({}, chartDefaultTextStyle, config.defaultStyle.text, baseTextStyle); // sort the timeMarkerConf array initially according to start date

    timeMarkerConf.sort(function (a, b) {
      return +new Date(a.start) - +new Date(b.start);
    }); // parse and store configuration for labels and markers

    for (i = 0, len = timeMarkerConf.length; i < len; i++) {
      marker = timeMarkerConf[i]; // if no valid formatter or start value is given then continue

      if (!marker.start || marker.start === _lib.BLANKSTRING) {
        continue;
      }

      timeFormat = (0, _lib.pluck)(marker.timeformat, obj.defaultFormat); // decide the parser and set its specifier

      parser = isUTC ? _timeConverter.default.utcParser(timeFormat) : _timeConverter.default.parser(timeFormat); // parse the values

      startValue = parser.parse(marker.start);
      endValue = parser.parse(marker.end); // if start value is greater than end value then swap both values

      if (!startValue || !endValue) {
        continue;
      }

      if (+startValue > +endValue) {
        // convert to millisecond
        var _ref = [endValue, startValue];
        startValue = _ref[0];
        endValue = _ref[1];
      }

      startValue = (0, _clipUtils.getUnclippedValue)(+startValue, repeatClips, singleClips, {
        clampDirection: 'up'
      });
      endValue = (0, _clipUtils.getUnclippedValue)(+endValue, repeatClips, singleClips, {
        clampDirection: 'down'
      });

      if (startValue > endValue) {
        continue;
      }

      valueObj = {
        start: new Date(startValue),
        end: new Date(endValue),
        startString: marker.start,
        endString: marker.end,
        timeFormat: timeFormat,
        type: marker.type || config.type
      }; // check if valid repeat configuration is provided.

      if (marker.repeat && marker.repeat.unit && Math.floor(+marker.repeat.multiplier) !== 0 && isValidUnit(unit = marker.repeat.unit.toLowerCase())) {
        valueObj.repeat = {
          interval: getInterVal(unit, isUTC),
          // if unit is quarter then increase the multiplier by three times
          multiplier: (unit === 'quarter' ? 3 : 1) * (0, _lib.pluckNumber)(marker.repeat.multiplier, 1)
        };
      }

      styles = marker.style || {};
      textStyle = Object.assign({}, defaultMergeTextStyle, {
        'vertical-align': valueObj.type === 'full' ? 'top' : 'bottom'
      }, getStyleDef(styles.text));
      markerStyle = Object.assign({}, config.defaultStyle.marker, getStyleDef(styles.marker));
      valueArr.push(valueObj);
      styleArr.push({
        text: textStyle,
        'text:hover': Object.assign({}, textStyle, getStyleDef(styles['text:hover'])),
        marker: markerStyle,
        'marker:hover': Object.assign({}, markerStyle, getStyleDef(styles['marker:hover']))
      });
      textArr.push((0, _lib.pluck)(marker.label, ''));
    }

    if (obj.xScale) config.xScale = obj.xScale;
    config.hoveredIndex = obj.hoveredIndex;
    config.hoveredDomainIndex = obj.hoveredDomainIndex;
    config.lastHoveredMarkerIndex = obj.lastHoveredMarkerIndex;
    config.lastHoveredDomainIndex = obj.lastHoveredDomainIndex;

    if (obj.timeMarker) {
      config.valueArr = valueArr;
      config.styleArr = styleArr;
      config.textArr = textArr;
      config.showTimeSpanMarkerTooltipAt = obj.showTimeSpanMarkerTooltipAt;
    }
  }
  /**
   * API to get properties of all labels that will be drawn
   * @param {Number} index value index
   * @param {Object} labelConfiguration label configuration
   * @param {Object} mergedStyle merged time marker style.
   */
  ;

  _proto.getAllLabelsProps = function getAllLabelsProps(index, labelConfiguration) {
    var timeMarker = this,
        selfConfig = timeMarker.config,
        smartLabel = timeMarker.getFromEnv('smartLabel'),
        valueArr = selfConfig.valueArr,
        domains = selfConfig.domainArr[index],
        domain,
        timeFormat,
        markerDim,
        markerDetails = selfConfig.markerDetails[index],
        smartText,
        dateLabel,
        _this$getFromEnv$0$ap = this.getFromEnv('focusScalesX')[0].applicableClippings,
        repeatClips = _this$getFromEnv$0$ap.repeatClips,
        singleClips = _this$getFromEnv$0$ap.singleClips,
        unClippedStart = (0, _clipUtils.getUnclippedValue)(+labelConfiguration.startDomain, repeatClips, singleClips),
        unClippedEnd = (0, _clipUtils.getUnclippedValue)(+labelConfiguration.endDomain, repeatClips, singleClips),
        isUTC = timeMarker.getFromEnv('UTC'),
        dateFormatter,
        x = labelConfiguration.x,
        y = labelConfiguration.y,
        width = labelConfiguration.width,
        height = smartLabel._lineHeight,
        labelArr = [],
        toolText,
        i,
        len,
        label = selfConfig.textArr[index]; // if time is clipped, do not show labels

    if (unClippedEnd <= unClippedStart) {
      return [];
    } // marker label


    if (label) {
      smartText = smartLabel.getSmartText((0, _lib.parseUnsafeString)(label), width, height);
      labelArr.push({
        dim: {
          x: x + width / 2 + GUTTER_2,
          y: y - GUTTER_2
        },
        text: (0, _lib.parseUnsafeString)(smartText.text)
      });
    }

    timeFormat = valueArr[index].timeFormat;

    for (i = 0, len = domains.length; i < len; i++) {
      toolText = [];
      domain = domains[i];
      markerDim = markerDetails.markerDim[i];
      dateFormatter = isUTC ? _timeConverter.default.utcFormatter(timeFormat) : _timeConverter.default.formatter(timeFormat);
      dateLabel = dateFormatter.format(domain.start) + ' - ' + dateFormatter.format(domain.end);
      toolText.push(dateLabel);
      label && toolText.push(smartText.oriText);
      markerDim.toolTextArr = toolText;
    }

    return labelArr;
  };

  _proto.createGroup = function createGroup() {
    var timeMarker = this,
        canvasConfig = timeMarker.getLinkedParent().config,
        padding = canvasConfig.padding,
        canvasLeft = canvasConfig.canvasBGLeft - padding.left,
        canvasTop = canvasConfig.canvasBGTop - padding.top,
        canvasWidth = canvasConfig.canvasBGWidth,
        canvasHeight = canvasConfig.canvasBGHeight,
        clipPath = ["M" + canvasLeft + "," + canvasTop, "L" + (canvasLeft + canvasWidth) + "," + canvasTop, "L" + (canvasLeft + canvasWidth) + "," + (canvasTop + canvasHeight), "L" + canvasLeft + "," + (canvasTop + canvasHeight) + "Z"];
    timeMarker.addGraphicalElement({
      el: 'group',
      container: {
        id: 'thermo',
        label: 'group',
        isParent: true
      },
      component: timeMarker,
      label: 'timeMarker',
      attr: {
        name: 'time-marker-min-group',
        'clip-path': clipPath
      },
      id: 'timeMarker'
    });
  }
  /**
   * Method that draws all the labels
   * @param {Array} allLabelProps all label configurations
   * @param {Object} mergedStyle merged text style
   */
  ;

  _proto.drawAllLabels = function drawAllLabels(allLabelProps, style) {
    var timeMarker = this;
    allLabelProps.forEach(function (labelProp, index) {
      timeMarker.addGraphicalElement({
        el: 'text',
        attr: {
          text: labelProp.text,
          x: labelProp.dim.x,
          y: labelProp.dim.y,
          opacity: style.opacity
        },
        css: style,
        container: {
          label: 'timeMarker'
        },
        id: 'time-marker-label-' + index,
        component: timeMarker,
        label: 'label'
      }, true);
    });
  };

  _proto.draw = function draw() {
    var timeMarker = this,
        selfConfig = timeMarker.config,
        smartLabel = timeMarker.getFromEnv('smartLabel'),
        values = selfConfig.valueArr,
        styleArr = selfConfig.styleArr,
        allLabelProps,
        markerAndLabelConfiguartion,
        markerArr,
        labelConfiguration,
        i,
        j,
        isHovered,
        textStyle,
        markerStyle,
        len; // create the time marker group

    timeMarker.createGroup();
    selfConfig.markerDetails = [];

    for (i = 0, len = values.length; i < len; i++) {
      isHovered = i === selfConfig.hoveredIndex;
      selfConfig.markerDetails[i] = {};
      textStyle = isHovered ? styleArr[i]['text:hover'] : styleArr[i].text;
      markerStyle = isHovered ? styleArr[i]['marker:hover'] : styleArr[i].marker;
      smartLabel.setStyle({
        'font-size': textStyle['font-size'] || styleArr[i].text['font-size'],
        'font-family': textStyle['font-family'] || styleArr[i].text['font-family'],
        'font-weight': textStyle['font-weight'] || styleArr[i].text['font-weight']
      });
      smartLabel.getOriSize((0, _lib.parseUnsafeString)(selfConfig.textArr[i])); // if text is present then only it will depend upon the line height else it will have height of 13px

      markerAndLabelConfiguartion = timeMarker.getMarkerAndLabelConfiguration(i, selfConfig.textArr[i] ? smartLabel._lineHeight : 13);
      markerArr = selfConfig.markerDetails[i].markerDim;
      labelConfiguration = markerAndLabelConfiguartion.labelConfiguration;

      if (markerArr.length) {
        allLabelProps = timeMarker.getAllLabelsProps(i, labelConfiguration);

        for (j = 0; j < markerArr.length; j++) {
          // time marker rect
          timeMarker.addGraphicalElement({
            el: 'rect',
            attr: {
              x: markerArr[j].x,
              y: markerArr[j].y,
              width: markerArr[j].width,
              height: markerArr[j].height,
              opacity: markerStyle.opacity
            },
            container: {
              label: 'timeMarker'
            },
            css: markerStyle,
            id: 'time-span-marker-' + i + j,
            component: timeMarker,
            label: 'line'
          });
        } // draw all time marker texts


        timeMarker.drawAllLabels(allLabelProps, textStyle);
      }
    }
  };

  _proto.getType = function getType() {
    return 'timeMarker';
  };

  _proto.getName = function getName() {
    return 'timeSpanMinMarker';
  };

  return TimeSpanMinMarker;
}(_componentInterface.SmartRenderer);

var _default = TimeSpanMinMarker;
exports["default"] = _default;

/***/ }),

/***/ 978:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _assertThisInitialized2 = _interopRequireDefault(__webpack_require__(292));

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _componentInterface = __webpack_require__(290);

var ToolbarManager = /*#__PURE__*/function (_SmartRenderer) {
  (0, _inheritsLoose2.default)(ToolbarManager, _SmartRenderer);

  /**
   * Creates an instance of ToolbarManager.
   * @param {any} id id
   * @memberof ToolbarManager
   */
  function ToolbarManager(id) {
    var _this;

    _this = _SmartRenderer.call(this, id) || this;
    var manager = (0, _assertThisInitialized2.default)(_this);
    _this._registry = {};

    _this._limitChangeHandler = function (e) {
      var key,
          regdComponents = manager.getRegistry();

      for (key in regdComponents) {
        if (regdComponents.hasOwnProperty(key)) {
          regdComponents[key].updateOnLimitChange && regdComponents[key].updateOnLimitChange(e);
        }
      }

      manager.setData({}, true);
    };

    return _this;
  }
  /**
   * configures the component
   *
   * @param {any} [inputConfig={}] configuration
   * @memberof ToolbarManager
   */


  var _proto = ToolbarManager.prototype;

  _proto.configureAttributes = function configureAttributes(inputConfig) {
    if (inputConfig === void 0) {
      inputConfig = {};
    }

    var manager = this,
        registeredComponents = manager.getRegistry(),
        key,
        infoList = [{}];

    for (key in registeredComponents) {
      if (registeredComponents.hasOwnProperty(key)) {
        registeredComponents[key] && infoList.push(registeredComponents[key].getToolInfo());
      }
    }

    manager.getFromEnv('selectorToolbar').setData({
      child: Object.assign.apply(Object, infoList),
      toolbarhdirection: 1
    }, true);
    manager.addExtEventListener('focusLimitChanged', manager._limitChangeHandler, manager.getFromEnv('chart'));
    manager.addExtEventListener('contextLimitChanged', manager._limitChangeHandler, manager.getFromEnv('chart'));
  }
  /**
   * getter function to fetch all the registered components
   *
   * @returns {Object} registered components
   * @memberof ToolbarManager
   */
  ;

  _proto.getRegistry = function getRegistry() {
    return this._registry;
  }
  /**
   * register a component to this manager
   *
   * @param {any} id id
   * @param {any} instance instance of the component which will provide the tool requirements
   * @memberof ToolbarManager
   */
  ;

  _proto.register = function register(id, instance) {
    this._registry[id] = instance;
  }
  /**
   * deregisters a component
   *
   * @param {any} id id of the component to be deregistered
   * @memberof ToolbarManager
   */
  ;

  _proto.deRegister = function deRegister(id) {
    delete this._registry[id];
  };

  return ToolbarManager;
}(_componentInterface.SmartRenderer);

var _default = ToolbarManager;
exports["default"] = _default;

/***/ }),

/***/ 899:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports.createDivString = exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _smartRenderer = _interopRequireDefault(__webpack_require__(294));

var MOUSEOVER = 'fc-mouseover',
    MOUSEDOWN = 'fc-mousedown',
    MOUSEUP = 'fc-mouseup',
    MOUSEMOVE = 'fc-mousemove',
    MOUSEOUT = 'fc-mouseout',
    CLICK = 'fc-click',
    xShift = 5,
    BLANK = '',
    getCSPNonce = function getCSPNonce() {
  var metaTag = document.querySelector("meta[http-equiv=\"Content-Security-Policy\"]");

  if (metaTag) {
    var content = metaTag.getAttribute('content');

    if (content) {
      var match = content.match(/'nonce-([^']+)'/);

      if (match) {
        return match[1];
      }
    }
  }

  return null;
},
    createDivString = function createDivString(styleStr, string) {
  if (styleStr === void 0) {
    styleStr = '';
  }

  if (string === void 0) {
    string = '';
  }

  var styleString = styleStr.replaceAll('style', '').replaceAll('\'', '').replaceAll('=', ''),
      className = "styleStrClass-" + Math.random().toString(36).substring(2),
      chartNonce = getCSPNonce(),
      styles = "\n      <style nonce=\"" + chartNonce + "\">\n        ." + className + " {\n          " + styleString + "\n        }\n      </style>\n    ";
  return styles + "<div class=\"" + className + "\">" + string + "</div>";
};

exports.createDivString = createDivString;
var UNDEF;
/**
 * This class is responsible for the tooltip and hover effect of dataplots and datamarkers
 */

var MouseAction = /*#__PURE__*/function (_SmartRenderer) {
  (0, _inheritsLoose2.default)(MouseAction, _SmartRenderer);

  function MouseAction() {
    return _SmartRenderer.apply(this, arguments) || this;
  }

  var _proto = MouseAction.prototype;

  _proto.configure = function configure() {
    _SmartRenderer.prototype.configure.call(this);

    var mouseAction = this,
        config = mouseAction.config,
        chartConfig = mouseAction.getFromEnv('chartConfig'),
        mouseTracker = mouseAction.getFromEnv('mouseTracker');
    config.showTooltip = chartConfig.showTooltip; // Attaching external event listener on mouseTracker for showing tooltip

    !config.eventAdded && mouseAction.addExtEventListener('canvasHovered', function (_mouseAction) {
      config.eventAdded = true;
      return function () {
        switch (arguments[1].hoveredInfo && arguments[1].hoveredInfo.component && arguments[1].hoveredInfo.component.getType()) {
          case 'timeMarker':
            // if hovered on the time marker for the first time then
            // hoverout on the dataset first and then hover in on the
            // time marker
            if (arguments[1].e.type === MOUSEOVER) {
              // send empty data to hide highlighted/hovered plots
              _mouseAction._triggerMouseActions({
                data: {
                  hoveredInfo: {},
                  e: {}
                }
              });
            }

            _mouseAction._triggerMarkerMouseActions.apply(_mouseAction, arguments);

            break;

          default:
            _mouseAction._triggerMouseActions.apply(_mouseAction, arguments);

        }
      };
    }(mouseAction), mouseTracker);
  }
  /**
   * Function to manage the mouseout event
   * @param {Object} e The actual mouse event object
   * @param {Number} _lastDatasetIndex The last datasetIndex hovered
   * @param {Number} _lastPointIndex The last data of the datasetIndex hovered
   * @param {Object} hoveredInfo The object conataining the hovered information
   * @param {Object} dataset The dataset instance hovered
   */
  ;

  _proto.mouseoutHandler = function mouseoutHandler(e, _lastDatasetIndex, _lastPointIndex, lastComponentHovered) {
    var mouseAction = this,
        config = mouseAction.config; // Triggering hover effect
    // Checking if lastComponentHovered's config property is present dataset might be disposed inbetween
    // hover in and hover out via wheel gesture.

    if (lastComponentHovered && lastComponentHovered.config) {
      lastComponentHovered.setHoverOutEffect([_lastPointIndex]);
      lastComponentHovered._firePlotEvent && lastComponentHovered._firePlotEvent(MOUSEOUT, _lastPointIndex, e);
    } // Hiding the tooltip


    config.showTooltip && mouseAction.getFromEnv('toolTipController').hide(config.currentToolTip); // delete stored last component details

    delete config._lastDatasetIndex;
    delete config._lastPointIndex;
  }
  /**
   * Call back function of canvasHovered event responsible for hover effect and tooltip of time markers
   * @param {Object} customObj The event object of canvasHovered events
   */
  ;

  _proto._triggerMarkerMouseActions = function _triggerMarkerMouseActions(customObj) {
    var mouseAction = this,
        data = customObj.data,
        e = data.e,
        toolTipController = mouseAction.getFromEnv('toolTipController'),
        tooltipStyle = mouseAction.getFromEnv('tooltipStyle'),
        chartX = data.chartX,
        chartY = data.chartY,
        parent = mouseAction.getLinkedParent(),
        startX,
        startY,
        translation = parent.getTranslation(),
        hoveredInfo = data.hoveredInfo,
        hovered = hoveredInfo.hovered,
        derivedEvents,
        config = mouseAction.config,
        showToolip = config.showTooltip,
        timeMarker = hoveredInfo.component,
        hoveredMarkerDim = hoveredInfo.pointObj.hoveredMarkerDim || {},
        toolText = BLANK,
        tooltextConfig = hoveredInfo.hovered && timeMarker.getToolTextConfiguration(hoveredMarkerDim.toolTextArr, hoveredInfo.pointObj.type),
        isWithinCanvas = parent.isWithinCanvas(chartX - (hoveredMarkerDim.thresholdX || 0), chartY - (hoveredMarkerDim.thresholdY || 0)),
        i,
        l;

    if (hovered && isWithinCanvas) {
      var header = tooltextConfig.header,
          body = tooltextConfig.body;
      toolText = createDivString(tooltipStyle.headerStyleString, header) + createDivString(tooltipStyle.bodyStyleString, body);
      startX = chartX;
      startY = hoveredMarkerDim.y - tooltextConfig.dimensions.height + translation.y;
      showToolip && (config.currentToolTip = toolTipController.drawAt(startX, startY, toolText, config.currentToolTip, parent));
      timeMarker.setHoverInEffect(hoveredInfo.pointIndex, hoveredInfo.pointObj.index, false);
      derivedEvents = mouseAction.getMakerMouseEvents(e, hoveredInfo.pointIndex, hoveredInfo.pointObj.index);

      if (l = derivedEvents.length) {
        config._lastMarkerIndex = hoveredInfo.pointIndex;
        config._lastDomainIndex = hoveredInfo.pointObj.index;

        for (i = 0; i < l; i++) {
          timeMarker.fireMarkerEvents(derivedEvents[i], hoveredInfo.pointIndex, hoveredInfo.pointObj.index);
        }
      }
    } else {
      showToolip && toolTipController.hide(config.currentToolTip);
      timeMarker.setHoverOutEffect();

      if (config._lastMarkerIndex !== UNDEF && config._lastDomainIndex !== UNDEF) {
        timeMarker.fireMarkerEvents(MOUSEOUT, hoveredInfo.pointIndex, hoveredInfo.pointObj.index);
      }

      config._lastMarkerIndex = UNDEF;
      config._lastDomainIndex = UNDEF;
    }
  }
  /**
   * Call back function of canvasHovered event responsible for hover effect and tooltip
   * @param {Object} customObj The event object of canvasHovered events
   */
  ;

  _proto._triggerMouseActions = function _triggerMouseActions(customObj) {
    var mouseAction = this,
        data = customObj.data,
        toolTipController = mouseAction.getFromEnv('toolTipController'),
        tooltipStyle = mouseAction.getFromEnv('tooltipStyle'),
        dataSource = mouseAction.getFromEnv('dataSource'),
        customToolText = dataSource.tooltip ? dataSource.tooltip.tooltext : null,
        componentIndex = data.i,
        e = data.e,
        chartX = data.chartX,
        chartY = data.chartY,
        hoveredInfo = data.hoveredInfo,
        pointObj,
        pointFound = componentIndex >= 0,
        parent = mouseAction.getLinkedParent(),
        datasets = parent.getChild(UNDEF, 'dataset'),
        config = mouseAction.config,
        _lastDatasetIndex = config._lastDatasetIndex,
        _lastPointIndex = config._lastPointIndex,
        translation = parent.getTranslation(),
        l,
        j,
        header = BLANK,
        body = BLANK,
        tooltext = BLANK,
        currTooltext,
        validPointObj,
        xRange,
        currPointIndex = hoveredInfo && hoveredInfo.pointIndex,
        targetComponent,
        datasetToEnquire,
        currDsConfig,
        isWithinCanvas = parent.isWithinCanvas(chartX, chartY),
        derivedEvensInfo;

    if (!hoveredInfo) {
      // if hoveredInfo is undefined, no valid data point is found in the canvas. Hence,
      // no tooltips and hover effects are applicable.
      return;
    }

    if (pointFound) {
      hoveredInfo.datasetIndex = componentIndex;
      derivedEvensInfo = mouseAction.getMouseEvents(e, hoveredInfo.datasetIndex, currPointIndex, hoveredInfo.component.getName(), hoveredInfo.markerObj);
    } // fire out on last hovered plot
    // Always fire out hover out if point is not within canvas


    if (!isWithinCanvas || (!pointFound || derivedEvensInfo && derivedEvensInfo.fireOut) && typeof _lastDatasetIndex !== 'undefined') {
      // when mouseout is fired and there aren't any events that need to be fired over the current plot,
      // call mouseouthamndler through settimeout.
      // It handles situation where there is no actual element but mouseOver/mouseOut is triggered,
      // example line plot without anchors
      if (derivedEvensInfo && !derivedEvensInfo.events.length) {
        config.mouseoutTimer = setTimeout(function () {
          mouseAction.mouseoutHandler(e, _lastDatasetIndex, _lastPointIndex, config._lastComponentHovered);
        }, 20);
      } else {
        mouseAction.mouseoutHandler(e, _lastDatasetIndex, _lastPointIndex, config._lastComponentHovered);
        clearTimeout(config.mouseoutTimer);
      }
    } // Always show the tooltip if mouse pointer is inside the canvas


    if (isWithinCanvas && datasets.length && config.showTooltip) {
      xRange = hoveredInfo.component.getFromEnv('xScale').getRange(); // Iterarting over all the datasets to trigger tooltip

      datasets.forEach(function (dataset, index) {
        currDsConfig = dataset.config;

        if (currDsConfig.visibility === 'visible') {
          currTooltext = dataset._getTooltext(pointFound, componentIndex === index, dataset._getHoveredBin()); // If custom tooltext is provided then no need to append

          if (customToolText) {
            tooltext = currTooltext;
          } else {
            tooltext += currTooltext;
          } // Fetching a valid dataset from which date info can be obtained


          if (currDsConfig.dataInfo[dataset._getHoveredBin()] && currTooltext) {
            validPointObj = currDsConfig.dataInfo[dataset._getHoveredBin()];
            datasetToEnquire = dataset;
          }

          ;
        }
      }); // Date to be shown in the tooltip is fetched from the dataset having a valid data at the given point

      if (datasetToEnquire) {
        var _datasetToEnquire$_ge = datasetToEnquire._getDateForToolText(datasetToEnquire._getHoveredBin());

        header = _datasetToEnquire$_ge.header;
        body = _datasetToEnquire$_ge.body;
      }

      if (customToolText) {
        tooltext = createDivString('', body + tooltext);
      } else {
        tooltext = createDivString(tooltipStyle.headerStyleString, header) + createDivString(tooltipStyle.bodyStyleString, body + tooltext);
      } // If data is not actually hovered then we take the data from the hoveredBinIndex


      pointObj = pointFound ? hoveredInfo.pointObj : validPointObj;

      if (pointObj) {
        // Drawing the tooltip at specific position
        tooltext !== '' && pointObj.endXPosition > xRange[0] && pointObj.x < xRange[1] ? config.currentToolTip = // colY is applicable for candlestick
        toolTipController.drawAt(pointObj.x + (pointObj.width || 0) / 2 + xShift + translation.x, (pointObj.colY || pointObj.y) + translation.y, tooltext, config.currentToolTip, parent) : toolTipController.hide(config.currentToolTip);
      } else {
        toolTipController.hide(config.currentToolTip);
      }
    } // fire remaining events


    if (pointFound) {
      l = derivedEvensInfo.events && derivedEvensInfo.events.length; // Update only when events for current plot are present.
      // Reason: When cursor is present in territory of line/area plot but not directly over it, then
      // the fireOut of current plot was happening instead of the actual last plot.

      if (l) {
        // store the index of the hovered DS and plot
        config._lastDatasetIndex = hoveredInfo.datasetIndex;
        config._lastPointIndex = currPointIndex;
        targetComponent = config._lastComponentHovered = hoveredInfo.component;
        config._lastComponentHoveredName = targetComponent && targetComponent.getName(); // triggering the hover effect

        targetComponent.setHoverInEffect([currPointIndex]); // Triggering tooltip
        // If hovered over dataMarker then tooltip of a specific dataMarker is shown else
        // consolidated tooltip is shown

        if (config.showTooltip && targetComponent.getType() === 'dataMarker') {
          var _targetComponent$_get = targetComponent._getTooltext(currPointIndex);

          header = _targetComponent$_get.header;
          body = _targetComponent$_get.body;
          tooltext = createDivString(tooltipStyle.headerStyleString, header) + createDivString(tooltipStyle.bodyStyleString, body);
          config.currentToolTip = toolTipController.draw(e, tooltext, config.currentToolTip);
        } // Firing corresponding events related to the actual mousevents


        for (j = 0; j < l; j += 1) {
          if (targetComponent && targetComponent._firePlotEvent) {
            targetComponent && targetComponent._firePlotEvent && targetComponent._firePlotEvent(derivedEvensInfo.events[j], currPointIndex, e);
          }
        }
      }
    }
  }
  /**
   * Given the event object, the index of the dataset and the index of the plot in the dataset, this
   * method determines which event has occured on a dataset's plot
   * @param {Event} e original mouse event that is being trapped
   * @param {number} datasetIndex Index of the dataset that is being interacted
   * @param {number} plotIndex Index of the plot that is being interacted
   * @param {String} componentName The component's name that is hovered
   * @return {DerivedEvent} An object containg the details of the mouse events that need to be fired
   * @todo has scope to reduce no of line
   */
  ;

  _proto.getMouseEvents = function getMouseEvents(e, datasetIndex, plotIndex, componentName) {
    var mouseAction = this,
        config = mouseAction.config,
        lastDatasetIndex = config._lastDatasetIndex,
        lastPointIndex = config._lastPointIndex,
        lastComponentHovered = config._lastComponentHoveredName,
        eventType = e.type,
        derivedEvensInfo = {
      fireOut: false,
      events: []
    };

    switch (eventType) {
      case CLICK:
        derivedEvensInfo.events.push(CLICK);
        break;

      case MOUSEMOVE:
        if (lastComponentHovered === componentName && lastDatasetIndex === datasetIndex && lastPointIndex === plotIndex) {
          // clear mouseout timer(if any) if mousemove happens over the same plot
          clearTimeout(config.mouseoutTimer);
          derivedEvensInfo.events.push(MOUSEMOVE);
        } else {
          derivedEvensInfo.events.push(MOUSEOVER);
          derivedEvensInfo.fireOut = true;
        }

        break;

      case MOUSEDOWN:
        if (lastComponentHovered !== componentName || lastDatasetIndex !== datasetIndex || lastPointIndex !== plotIndex) {
          derivedEvensInfo.fireOut = true;
          derivedEvensInfo.events.push(MOUSEOVER);
        }

        derivedEvensInfo.events.push(MOUSEDOWN);
        break;

      case MOUSEOVER:
        if (lastComponentHovered === componentName && lastDatasetIndex === datasetIndex && lastPointIndex === plotIndex) {
          // clear mouseout timer(if any) if mouseover happens over the same plot
          clearTimeout(config.mouseoutTimer);
        } else {
          //  when hovering over an element that lies over the last hovered element the fireout the last hovered element
          derivedEvensInfo.fireOut = true;
          derivedEvensInfo.events.push(MOUSEOVER);
        }

        break;

      case MOUSEUP:
        derivedEvensInfo.events.push(MOUSEUP); // @todo: implement clcik from mouseend as well

        break;

      case MOUSEOUT:
        derivedEvensInfo.fireOut = true;
    }

    return derivedEvensInfo;
  }
  /**
   * Given the event object and the index of the time marker, this
   * method determines which event has occured on an event markers
   * @param {Event} e original mouse event that is being trapped
   * @param {number} markerIndex Index of the marker that is being interacted
   * @param {number} domainIndex Sub-Index of the marker
   * @return {DerivedEvents} An array containg the details of the mouse events that need to be fired
   */
  ;

  _proto.getMakerMouseEvents = function getMakerMouseEvents(e, markerIndex, domainIndex) {
    var mouseAction = this,
        config = mouseAction.config,
        lastMarkerIndex = config._lastMarkerIndex,
        lastDomainIndex = config._lastDomainIndex,
        eventType = e.type,
        derivedEvents = [];

    switch (eventType) {
      case CLICK:
        derivedEvents.push(CLICK);
        break;

      case MOUSEMOVE:
        if (lastMarkerIndex === markerIndex && lastDomainIndex === domainIndex) {
          derivedEvents.push(MOUSEMOVE);
        } else {
          derivedEvents.push(MOUSEOVER);
        }

        break;

      case MOUSEOVER:
        if (lastMarkerIndex !== markerIndex && lastDomainIndex !== domainIndex) {
          derivedEvents.push(MOUSEOVER);
        }

        break;
    }

    return derivedEvents;
  };

  return MouseAction;
}(_smartRenderer.default);

var _default = MouseAction;
exports["default"] = _default;

/***/ }),

/***/ 905:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _transpose = _interopRequireDefault(__webpack_require__(906));

var _line = _interopRequireDefault(__webpack_require__(907));

var _column = _interopRequireDefault(__webpack_require__(920));

var _candlestick = _interopRequireDefault(__webpack_require__(929));

var _ohlc = _interopRequireDefault(__webpack_require__(931));

var _stackGenerator = _interopRequireDefault(__webpack_require__(933));

var _diverge = _interopRequireDefault(__webpack_require__(936));

var _null = _interopRequireDefault(__webpack_require__(937));

var _lib = __webpack_require__(274);

var _columnRange = _interopRequireDefault(__webpack_require__(938));

var _areaRange = _interopRequireDefault(__webpack_require__(940));

var _fcTimeSeparator = _interopRequireDefault(__webpack_require__(504));

/* eslint-disable complexity */
var LINE = 'line',
    getDataset = function getDataset(plotType) {
  switch (plotType) {
    case 'column':
      return _column.default;

    case 'candlestick':
      return _candlestick.default;

    case 'column-range':
      return _columnRange.default;

    case 'area-range':
      return _areaRange.default;

    case 'ohlc':
      return _ohlc.default;

    default:
      return _line.default;
  }
},
    getSeriesName = function getSeriesName(str) {
  return str.split(_fcTimeSeparator.default)[0];
},
    getMeasureOpName = function getMeasureOpName(str) {
  return str.split(_fcTimeSeparator.default).slice(1).join(_fcTimeSeparator.default);
},
    getVisibility = function getVisibility(bool) {
  return bool ? 'visible' : 'hidden';
},
    isOHLC = function isOHLC(plotType) {
  return plotType === 'ohlc' || plotType === 'candlestick';
},
    isRangedPlot = function isRangedPlot(plotType) {
  return plotType === 'column-range' || plotType === 'area-range';
},
    isPlotStackable = function isPlotStackable(plotType) {
  return plotType === 'area' || plotType === 'smooth-area' || plotType === 'step-area' || plotType === 'column';
},
    getAggregationName = function getAggregationName(str) {
  if (str === 'avg') {
    return 'average';
  }

  return str;
},
    getAggregationType = function getAggregationType(input) {
  var aggObj = {},
      values;

  if (typeof input === 'string') {
    values = input.split(_fcTimeSeparator.default);
    return getAggregationName(values[values.length - 1]);
  }

  input.forEach(function (currInput) {
    if (currInput) {
      values = currInput.split(_fcTimeSeparator.default);
      aggObj[values[0].trim()] = getAggregationName(values[1].trim());
    }
  });
  return aggObj;
},
    selector = function selector(plot) {
  var _ref2;

  if (plot.stack || !plot.tableInfo.filterItem) {
    var _ref;

    return _ref = {}, _ref[plot.value[0]] = getSeriesName(plot.value[0]), _ref;
  }

  return _ref2 = {}, _ref2[plot.value[0]] = plot.tableInfo.filterItem, _ref2;
};

var _default = function _default(canvas) {
  var chart = canvas.getFromEnv('chart'),
      legendMap = canvas.getFromEnv('legendMap'),
      canvasConf = canvas.config,
      dataSource = canvas.getFromEnv('dataSource'),
      plotConfigurations = dataSource.plotconfig || {},
      ordinalScale = canvas.getFromEnv('ordinalScale'),
      isContext = canvasConf.isContext,
      msDsMap = canvasConf.multiSeriesDatasetMap,
      enableMarkers = canvasConf.enableMarkers,
      xConfigs = isContext ? chart.config.contextAxesX : chart.config.focusAxesX,
      yConfigs = isContext ? chart.config.contextAxesY : chart.config.focusAxesY,
      prediction = canvas.getFromEnv('prediction'),
      predictiveDate = prediction ? canvas.getFromEnv('baseTimeConverter').parse(prediction.date) : _lib.UNDEF;
  prediction.dateMs = prediction.enabled ? predictiveDate ? predictiveDate.getTime() : Date.now() : _lib.UNDEF;

  if (isContext) {
    canvasConf.plotConfigs.forEach(function (_ref3) {
      var plots = _ref3.plots;
      // when there are multiple columns in a single canvas then it will be rendered as overlapped area in
      // navigator
      var isArea = plots.filter(function (_ref4) {
        var plottype = _ref4.plottype;
        return plottype === 'column';
      }).length > 1 ? 'area' : null;
      plots.forEach(function (ob) {
        if (isRangedPlot(ob.plottype)) {
          // as of now when dataset factory is called for time navigator
          // it iterates on value. So there is a need to map ob.high to ob.value
          // such that no error is thrown.
          ob.value = ob.high;
          ob.isRange = true;
          ob.plottype = typeof ob.typeinnavigator === 'string' && ob.typeinnavigator || 'line';
        } else if (isOHLC(ob.plottype)) {
          // For plotting the navigator chart, use whichever is present in the below order
          ob.value = ob.close || ob.low || ob.high || ob.open || [];
          ob.plottype = typeof ob.typeinnavigator === 'string' && ob.typeinnavigator || 'line';
        } else if (ob.plottype === 'column') {
          ob.plottype = ob.typeinnavigator || isArea || (ob.value.length > 1 ? 'area' : 'line');
        }
      });
    });
  }

  canvasConf.plotConfigs.forEach(function (plotConfig, k) {
    var xConfig = xConfigs[plotConfig.x],
        yConfig = yConfigs[plotConfig.y],
        binDecider = xConfig.binDecider,
        scaleX = xConfig.scale,
        scaleY = yConfig.scale,
        plotGenericStyle = yConfig.plotstyle || {},
        // the total no of columns plot will be total group,
    columnPlotInfo = plotConfig.plots.filter(function (_ref5) {
      var plottype = _ref5.plottype;
      return plottype === 'column';
    }),
        totalColumnPlots = columnPlotInfo.length,
        // storing the names of the series for non stacking mode only, since in stacking mode
    // there is no indexing problem
    columnSeriesNames = columnPlotInfo.map(selector);
    var currentColumnIndex = 0;
    plotConfig.plots.forEach(function (plot, j) {
      var nodeInfo = plot.tableInfo,
          nodeTable = nodeInfo.table,
          filterItem = nodeInfo.filterItem,
          oriPlotInfo = yConfig.plot[plot.plotInAxisIndex],
          plotInlineStyle = oriPlotInfo.style || {},
          mergedInlineStyle,
          connectNullData = oriPlotInfo.connectnulldata,
          plotCosmetics,
          genericCosmetics,
          tableData = nodeTable.getData(),
          data = tableData.data,
          dataTable = nodeTable,
          timeFormatterFn = xConfig.timeFormatterFn,
          plotType,
          groupIndex,
          totalGroups,
          Dataset,
          isVisible,
          measures = [oriPlotInfo.value],
          seriesInfo = {}; // if a key is present then the info will be set

      oriPlotInfo.group && (seriesInfo[oriPlotInfo.group] = filterItem);
      mergedInlineStyle = (0, _lib.extend2)((0, _lib.extend2)({}, plotGenericStyle), plotInlineStyle);

      if (!isContext && (isOHLC(plot.plottype) || isRangedPlot(plot.plottype))) {
        var arr = plot.close || plot.open || plot.high || plot.low; // for stack or group in ohlc it will be represented as line

        if (arr.length > 1 || filterItem) {
          plot.plottype = LINE;
          plot.value = arr;
        }
      }

      plotType = plot.plottype;
      plotCosmetics = plotConfigurations[plotType] || {};
      genericCosmetics = plotConfigurations.generic || {};
      Dataset = getDataset(plotType);

      if (plotType === 'column') {
        // only for column plots the groupIndex and totalGroups will be provided
        groupIndex = currentColumnIndex++;
        totalGroups = totalColumnPlots;
      }

      if (isOHLC(plotType)) {
        var ohlcs = (0, _transpose.default)([plot.open || [plot.open], plot.high || [plot.high], plot.low || [plot.low], plot.close || [plot.close]].filter(function (s) {
          return !!s;
        })),
            open = oriPlotInfo.open,
            high = oriPlotInfo.high,
            low = oriPlotInfo.low,
            close = oriPlotInfo.close;

        if (open || high || low || close) {
          measures[0] = {
            open: open,
            high: high,
            low: low,
            close: close
          };
        }

        ohlcs.forEach(function (ohlc, i) {
          // created unique id for better resuse
          var dsInstance = canvas.attachChild(Dataset, 'dataset', '' + plot.value + plotType + i + j + k);
          dsInstance.addToEnv('binDecider', binDecider);
          dsInstance.addToEnv('xScale', scaleX);
          dsInstance.addToEnv('yScale', scaleY);
          dsInstance.configure({
            data: data,
            scaleX: scaleX,
            scaleY: scaleY,
            formatterFn: yConfig.formatterFn,
            timeFormatterFn: timeFormatterFn,
            yAxisAlign: (0, _lib.pluck)(yConfig.align, 'left'),
            styleConfig: mergedInlineStyle,
            plotCosmetics: plotCosmetics,
            genericCosmetics: genericCosmetics,
            aggregation: getAggregationType(ohlc),
            prefix: yConfig.formatLabelPrefix,
            suffix: yConfig.formatLabelSuffix,
            indices: [dataTable.indexOf(nodeInfo.position)].concat(ohlc.map(function (name) {
              return dataTable.indexOf(name);
            })),
            enableMarkers: enableMarkers,
            // primary color is send as boolean to indicate that DS should configure the color
            primaryColor: true,
            type: plotType,
            series: plot.value,
            measures: measures,
            calculateFromContext: isContext,
            prediction: prediction,
            useNullStyles: !isContext
          });
        });
      } else if (isRangedPlot(plotType)) {
        var ranges = (0, _transpose.default)([plot.high || [plot.high], plot.low || [plot.low]].filter(function (s) {
          return !!s;
        })),
            _high = oriPlotInfo.high,
            _low = oriPlotInfo.low;

        if (_high || _low) {
          measures[0] = {
            high: _high,
            low: _low
          };
        }

        if (plot.name) {
          isVisible = legendMap[plot.name] && legendMap[plot.name].visibility;
          isVisible === _lib.UNDEF && (isVisible = true);
        } else {
          isVisible = true;
        }

        ranges.forEach(function (range, i) {
          // created unique id for better resuse
          var dsInstance = canvas.attachChild(Dataset, 'dataset', '' + plot.value + plotType + i + j + k);
          dsInstance.addToEnv('binDecider', binDecider);
          dsInstance.addToEnv('xScale', scaleX);
          dsInstance.addToEnv('yScale', scaleY);
          dsInstance.configure({
            data: data,
            scaleX: scaleX,
            scaleY: scaleY,
            visibility: getVisibility(isVisible),
            formatterFn: yConfig.formatterFn,
            timeFormatterFn: timeFormatterFn,
            yAxisAlign: (0, _lib.pluck)(yConfig.align, 'left'),
            styleConfig: mergedInlineStyle,
            plotCosmetics: plotCosmetics,
            genericCosmetics: genericCosmetics,
            aggregation: getAggregationType(range),
            prefix: yConfig.formatLabelPrefix,
            suffix: yConfig.formatLabelSuffix,
            connectNullData: connectNullData,
            indices: [dataTable.indexOf(nodeInfo.position)].concat(range.map(function (name) {
              return dataTable.indexOf(name);
            })),
            enableMarkers: enableMarkers,
            // primary color is send as boolean to indicate that DS should configure the color
            primaryColor: plot.name ? ordinalScale.getRangeValue(plot.name) : ordinalScale.getRangeValue(plot.high[0] + _fcTimeSeparator.default + plot.low[0]),
            type: plotType,
            series: plot.value,
            measures: measures,
            calculateFromContext: isContext,
            prediction: prediction,
            useNullStyles: !isContext
          });
        });
      } else {
        if (plot.stack && isPlotStackable(plotType)) {
          var xIndex = dataTable.indexOf(nodeInfo.position),
              sumColumn = "" + getMeasureOpName(plot.value[0]) + _fcTimeSeparator.default + "sum",
              generator = new _stackGenerator.default().setValueAccessor(function (d, key) {
            if ((legendMap[getSeriesName(key)] || {}).visibility) {
              return d[dataTable.indexOf(key)];
            }

            return 0;
          }).setKeysAccessor(function () {
            return (// the keys will be set according to the column names present in the dataTable
              plot.value.filter(function (name) {
                return dataTable.indexOf(name) >= 0;
              })
            );
          }).setOffset(scaleY.getType() === 'log' ? _null.default : _diverge.default);
          dataTable.addColumns({
            name: sumColumn,
            type: 'number',
            calcFn: function calcFn(row, cols) {
              return plot.value.reduce(function (acc, val) {
                if ((legendMap[getSeriesName(val)] || {}).visibility) {
                  return acc + row[cols[val]];
                }

                return acc;
              }, 0);
            }
          }); // the data mapping for the each DS is created

          var series = generator.generate(dataTable.getData().data),
              seriesLength = series.length;
          series.forEach(function (serie, index) {
            // created unique id for better resuse
            var dsInstance = canvas.attachChild(Dataset, 'dataset', serie.key + plotType + index + j + k),
                seriesName = getSeriesName(serie.key),
                serieData = serie.map(function (s) {
              return [s.data[xIndex], s[0], s[1], s.data[dataTable.indexOf(sumColumn)]];
            });
            isVisible = legendMap[seriesName] && legendMap[seriesName].visibility;
            isVisible === _lib.UNDEF && (isVisible = true);
            oriPlotInfo.stack && (seriesInfo[oriPlotInfo.stack] = seriesName);
            dsInstance.addToEnv('binDecider', binDecider);
            dsInstance.addToEnv('xScale', scaleX);
            dsInstance.addToEnv('yScale', scaleY); // unique id for each dataset in canvas

            if (filterItem) {
              msDsMap["" + filterItem + _fcTimeSeparator.default + serie.key] = dsInstance;
            } else {
              msDsMap[serie.key] = dsInstance;
            }

            dsInstance.configure({
              data: serieData,
              datasetIndex: index,
              seriesLength: seriesLength,
              aggregation: getAggregationType(serie.key),
              visibility: getVisibility(isVisible),
              scaleX: scaleX,
              scaleY: scaleY,
              timeFormatterFn: timeFormatterFn,
              legendInteracted: canvasConf.legendInteracted,
              groupIndex: groupIndex,
              yAxisAlign: (0, _lib.pluck)(yConfig.align, 'left'),
              totalGroups: totalGroups,
              formatterFn: yConfig.formatterFn,
              prefix: yConfig.formatLabelPrefix,
              suffix: yConfig.formatLabelSuffix,
              styleConfig: mergedInlineStyle,
              plotCosmetics: plotCosmetics,
              genericCosmetics: genericCosmetics,
              connectNullData: connectNullData,
              indices: [0, 2, 1, 3],
              primaryColor: ordinalScale.getRangeValue(seriesName),
              type: plotType,
              series: seriesName,
              enableMarkers: enableMarkers,
              measures: measures,
              calculateFromContext: isContext,
              seriesInfo: Object.assign({}, seriesInfo),
              prediction: prediction,
              useNullStyles: !isContext
            });
          });
        } else {
          var meanColumn;

          if (plot.isRange) {
            var _ranges = (0, _transpose.default)([plot.high || [plot.high], plot.low || [plot.low]].filter(function (s) {
              return !!s;
            }));

            var indices;
            meanColumn = "" + getMeasureOpName(plot.high[0]) + _fcTimeSeparator.default + getMeasureOpName(plot.low[0]) + _fcTimeSeparator.default + "mean";

            _ranges.forEach(function (range) {
              indices = range.map(function (name) {
                return dataTable.indexOf(name);
              });
              dataTable.addColumns({
                type: 'number',
                'name': meanColumn,
                calcFn: function calcFn(row) {
                  return (row[indices[0]] + row[indices[1]]) / 2;
                }
              });
            });
          }

          plot.value.forEach(function (name, i) {
            var seriesName = plot.stack ? getSeriesName(name) : plot.isRange ? plot.name ? plot.name : plot.high[0] + _fcTimeSeparator.default + plot.low[0] : filterItem || getSeriesName(name),
                // created unique id for better resuse
            dsInstance = canvas.attachChild(Dataset, 'dataset', seriesName + plotType + i + j + k),
                status,
                currentGroupIndex,
                currentTotalGroups;
            isVisible = legendMap[seriesName] && legendMap[seriesName].visibility;
            isVisible === _lib.UNDEF && (isVisible = true);

            if (plotType === 'column') {
              // for column plots, we filter the status of with respect to visibility
              // the indexing will be with respect to new status
              status = columnSeriesNames.filter(function (obj) {
                return legendMap[Object.values(obj)[0]].visibility;
              });
              currentGroupIndex = status.findIndex(function (obj) {
                var key = Object.keys(obj)[0];

                if (filterItem) {
                  if (key === name && obj[key] === filterItem) {
                    return true;
                  }

                  return false;
                }

                return key === name;
              });

              if (currentGroupIndex !== -1) {
                currentTotalGroups = status.length;
              } else {
                currentGroupIndex = _lib.UNDEF;
              }
            }

            if (plot.stack) {
              seriesInfo[plot.stack] = seriesName;
            }

            dsInstance.addToEnv('binDecider', binDecider);
            dsInstance.addToEnv('xScale', scaleX);
            dsInstance.addToEnv('yScale', scaleY);
            dsInstance.configure({
              data: data,
              scaleX: scaleX,
              scaleY: scaleY,
              timeFormatterFn: timeFormatterFn,
              legendInteracted: canvasConf.legendInteracted,
              groupIndex: currentGroupIndex,
              totalGroups: currentTotalGroups,
              visibility: getVisibility(isVisible),
              yAxisAlign: (0, _lib.pluck)(yConfig.align, 'left'),
              formatterFn: yConfig.formatterFn,
              prefix: yConfig.formatLabelPrefix,
              suffix: yConfig.formatLabelSuffix,
              styleConfig: mergedInlineStyle,
              aggregation: getAggregationType(name),
              plotCosmetics: plotCosmetics,
              genericCosmetics: genericCosmetics,
              connectNullData: connectNullData,
              indices: [dataTable.indexOf(nodeInfo.position), plot.isRange ? dataTable.indexOf(meanColumn) : dataTable.indexOf(name)],
              primaryColor: ordinalScale.getRangeValue(seriesName),
              type: plotType,
              series: seriesName,
              enableMarkers: enableMarkers,
              measures: measures,
              calculateFromContext: isContext,
              seriesInfo: Object.assign({}, seriesInfo),
              prediction: prediction,
              useNullStyles: !isContext
            });
          });
        }
      }
    });
  });
};

exports["default"] = _default;

/***/ }),

/***/ 944:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _gridBands = _interopRequireDefault(__webpack_require__(945));

var _default = function _default(canvas) {
  var canvasConfig = canvas.config,
      gridBand;

  if (canvasConfig.gridBandSupported && canvasConfig.showGridBand) {
    gridBand = canvas.attachChild(_gridBands.default, 'gridBand');
    gridBand.configure({
      style: canvasConfig.gridBandStyle
    });
  }
};

exports["default"] = _default;

/***/ }),

/***/ 894:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _gridLines = _interopRequireDefault(__webpack_require__(895));

var _default = function _default(canvas) {
  if (canvas.config.enableGridLines) {
    var gridLine = canvas.attachChild(_gridLines.default, 'gridLine');
    gridLine.configure({
      direction: canvas.config.gridLineDirection,
      styleGridLines: canvas.config.styleGridLines,
      defaultStyle: canvas.config.gridLineStyle
    });
  }
};

exports["default"] = _default;

/***/ }),

/***/ 943:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _crossline = _interopRequireDefault(__webpack_require__(942));

var _lib = __webpack_require__(274);

var _default = function _default(canvas) {
  var dataSource = canvas.getFromEnv('dataSource'),
      chartAttr = canvas.getFromEnv('chart-attrib');
  canvas.attachChild(_crossline.default, 'horizontalCrossLine').configure({
    type: 'horizontal',
    inputStyle: dataSource.crossline && dataSource.crossline.style || {},
    showTextOutline: (0, _lib.pluckNumber)(chartAttr.textoutline, 0)
  });
};

exports["default"] = _default;

/***/ }),

/***/ 902:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



exports.__esModule = true;
exports["default"] = _default;

var _pixelValidatorUtils = __webpack_require__(901);

var UP = 'up',
    DOWN = 'down';

var dbTapHandler = function dbTapHandler(canvas) {
  return function (e) {
    var chart = canvas.getLinkedParent(),
        scale = canvas.config.xConfigs[0].scale,
        _scale$getRange = scale.getRange(),
        currStartRange = _scale$getRange[0],
        currEndRange = _scale$getRange[1],
        calculatedRange; // Changing the Range wrt to the wheel value such that the gap changes (zoom)


    currStartRange += offset;
    currEndRange -= offset;
    calculatedRange = (0, _pixelValidatorUtils.clampWithinContextRange)([currStartRange, currEndRange], scale, canvas.getFromEnv('contextScalesX')[0]);
    chart.setPixelLimit([].concat(calculatedRange), scale, [UP, DOWN], {
      name: 'canvasDblTap'
    });
  };
},
    // Flag to control the dbTap magnification
offset = 20;

function _default(canvas) {
  var config = canvas.config; // Adding wheel event only once for the main canvas

  if (config.enableInteraction && !config.dbTapEventAdded) {
    canvas.addEventListener('fc-dbclick', dbTapHandler(canvas));
    config.dbTapEventAdded = true;
  }
}

/***/ }),

/***/ 904:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



exports.__esModule = true;
exports["default"] = _default;

var _lib = __webpack_require__(274);

var _pixelValidatorUtils = __webpack_require__(901);

var pinchStart = function pinchStart(e) {
  startX = e.originalEvent.data.distanceX;
},
    pinchMove = function pinchMove(canvas) {
  return function (e) {
    var chart = canvas.getLinkedParent(),
        scale = canvas.config.xConfigs[0].scale,
        _scale$getRange = scale.getRange(),
        currStartRange = _scale$getRange[0],
        currEndRange = _scale$getRange[1],
        data = e.originalEvent.data,
        distanceX = data.distanceX,
        calculatedRange,
        diff = distanceX - startX,
        coordinate = (0, _lib.getMouseCoordinate)(canvas.getFromEnv('chart-container'), e.originalEvent, chart),
        translationObj = canvas.getTranslation(),
        translationX = translationObj ? translationObj.x : 0,
        chartX = coordinate.chartX - translationX,
        r1 = chartX - currStartRange,
        r2 = currEndRange - chartX,
        sum = r1 + r2; // Storing the current distance as the startX


    startX = distanceX; // If diff is positive then we are zooming in else zooming out

    currStartRange += 2 * diff * r1 / sum;
    currEndRange -= 2 * diff * r2 / sum;
    calculatedRange = (0, _pixelValidatorUtils.clampWithinContextRange)([currStartRange, currEndRange], scale, canvas.getFromEnv('contextScalesX')[0]);
    chart.setPixelLimit([].concat(calculatedRange), scale, ['down', 'up']);
  };
},
    // Flag to control the dbTap magnification
startX;

function _default(canvas) {
  var config = canvas.config; // Adding wheel event only once for the main canvas

  if (config.enableInteraction && !config.pinchEventAdded) {
    canvas.addEventListener('fc-pinchstart', pinchStart);
    canvas.addEventListener('fc-pinchmove', pinchMove(canvas));
    config.pinchEventAdded = true;
  }
}

/***/ }),

/***/ 903:
/***/ ((__unused_webpack_module, exports) => {



exports.__esModule = true;
exports["default"] = _default;
var UP = 'up',
    DOWN = 'down';

var dragStartHandler = function dragStartHandler(canvas) {
  return function () {
    var chart = canvas.getFromEnv('chart'),
        currDomain = chart.getFocusLimit();
    startX = 0;
    canvas.getChildren('mouseTracker')[0].deactivate();
    chart.fireChartInstanceEvent('canvasDragStart', {
      start: +currDomain[0],
      end: +currDomain[1]
    });
  };
},
    dragMoveHandler = function dragMoveHandler(canvas) {
  return function (e) {
    var chart = canvas.getLinkedParent(),
        scale = canvas.config.xConfigs[0].scale,
        _scale$getRange = scale.getRange(),
        currStartRange = _scale$getRange[0],
        currEndRange = _scale$getRange[1],
        data = e.originalEvent.data,
        offset = data[0] - startX,
        clampDirection;

    currEndRange -= offset;
    currStartRange -= offset;
    clampDirection = offset < 0 ? UP : DOWN;

    if (chart.setPixelLimit([currStartRange, currEndRange], scale, [clampDirection, clampDirection], {
      name: 'canvasDrag'
    })) {
      startX = data[0];
    }
  };
},
    dragEndHandler = function dragEndHandler(canvas) {
  return function () {
    var chart = canvas.getFromEnv('chart'),
        currDomain = chart.getFocusLimit();
    canvas.getChildren('mouseTracker')[0].activate();
    chart.fireChartInstanceEvent('canvasDragEnd', {
      start: +currDomain[0],
      end: +currDomain[1]
    });
  };
},
    startX;

function _default(canvas) {
  var config = canvas.config; // Adding wheel event only once for the main canvas

  if (config.enableInteraction && !config.swipeEventAdded) {
    canvas.addEventListener('fc-dragstart', dragStartHandler(canvas));
    canvas.addEventListener('fc-dragmove', dragMoveHandler(canvas));
    canvas.addEventListener('fc-dragend', dragEndHandler(canvas));
    config.swipeEventAdded = true;
  }
}

/***/ }),

/***/ 900:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



exports.__esModule = true;
exports["default"] = _default;

var _lib = __webpack_require__(274);

var _pixelValidatorUtils = __webpack_require__(901);

var VERTICAL = 'vertical',
    HORIZONTAL = 'horizontal',
    UP = 'up',
    DOWN = 'down',
    wheelZoomDeltaModeLinePixels = 17,
    wheelZoomDeltaModeScreenPixels = 53,
    getWheelEventDeltaYInPixels = function getWheelEventDeltaYInPixels(deltaMode, deltaVal) {
  // The WheelEvent.deltaMode read-only property returns the length unit of scroll amount.
  // When wheeling on a mouse,
  // - chrome by default uses deltaY = 53, deltaMode = 0 i.e. DOM_DELTA_PIXEL(pixel)
  // - firefox by default uses deltaY = 3, deltaMode = 1 i.e. DOM_DELTA_LINE(line)
  // - chrome and firefox on windows alternatively can also be set to scroll by page, and
  //   use deltaY = 1, deltaMode = 2 i.e. DOM_DELTA_PAGE(screen)
  // Note that when when wheeling on a touchpad, deltaY depends on how fast
  // you swipe, but the deltaMode is still different between the browsers.
  // Normalize everything so that zooming speed is approximately the same in all cases
  switch (deltaMode) {
    case WheelEvent.DOM_DELTA_LINE:
      // 1 (Delta values measured in lines)
      return deltaVal * wheelZoomDeltaModeLinePixels;

    case WheelEvent.DOM_DELTA_PAGE:
      // 2 (Delta values measured in pages or screens)
      return deltaVal * wheelZoomDeltaModeScreenPixels;

    default:
      // 0 (Delta values measured in pixels)
      return deltaVal;
  }
},
    wheelInteraction = function wheelInteraction(canvas) {
  return function (e) {
    var chart = canvas.getLinkedParent(),
        scale = canvas.config.xConfigs[0].scale,
        _scale$getRange = scale.getRange(),
        currStartRange = _scale$getRange[0],
        currEndRange = _scale$getRange[1],
        originalEvent = e.originalEvent,
        direction,
        leftClampDirection,
        rightClampDirection,
        offset,
        coordinate,
        translationObj,
        translationX,
        chartX,
        r1,
        r2,
        sum;

    if (Math.abs(originalEvent.deltaY) > Math.abs(originalEvent.deltaX)) {
      direction = VERTICAL;
      offset = getWheelEventDeltaYInPixels(originalEvent.originalEvent.deltaMode, originalEvent.deltaY);
    } else {
      direction = HORIZONTAL;
      offset = getWheelEventDeltaYInPixels(originalEvent.originalEvent.deltaMode, originalEvent.deltaX);
    }

    if (direction === VERTICAL) {
      coordinate = (0, _lib.getMouseCoordinate)(canvas.getFromEnv('chart-container'), e.originalEvent, chart);
      translationObj = canvas.getTranslation();
      translationX = translationObj ? translationObj.x : 0;
      chartX = coordinate.chartX - translationX; // Finding the ratio in which the zooming has to be done such that zooming is done keeping the
      // category hovered at the center

      r1 = chartX - currStartRange;
      r2 = currEndRange - chartX;
      sum = r1 + r2; // Changing the Range wrt to the wheel value such that the gap changes (zoom)

      currStartRange -= 2 * offset * r1 / sum;
      currEndRange += 2 * offset * r2 / sum;

      var _clampWithinContextRa = (0, _pixelValidatorUtils.clampWithinContextRange)([currStartRange, currEndRange], scale, canvas.getFromEnv('contextScalesX')[0]);

      currStartRange = _clampWithinContextRa[0];
      currEndRange = _clampWithinContextRa[1];
      leftClampDirection = offset < 0 ? UP : DOWN;
      rightClampDirection = offset >= 0 ? UP : DOWN;
      chart.setPixelLimit([currStartRange, currEndRange], scale, [leftClampDirection, rightClampDirection], {
        name: 'canvasWheel'
      });
    } else {
      currEndRange += offset;
      currStartRange += offset;
      leftClampDirection = offset >= 0 ? UP : DOWN;
      rightClampDirection = leftClampDirection;
      chart.setPixelLimit([currStartRange, currEndRange], scale, [leftClampDirection, rightClampDirection], {
        name: 'canvasWheel'
      });
    }
  };
};

function _default(canvas) {
  var config = canvas.config; // Adding wheel event only once for the main canvas

  if (config.enableInteraction && !config.wheelEventAdded) {
    canvas.addEventListener('fc-wheel', wheelInteraction(canvas));
    config.wheelEventAdded = true;
  }
}

/***/ }),

/***/ 979:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _discrete = _interopRequireDefault(__webpack_require__(630));

var _lib = __webpack_require__(274);

var COLOR_5F5F5F = '#5f5f5f',
    INHERIT = 'inherit';

var _default = function _default(chart) {
  var legend,
      showLegend = chart.config.showLegend,
      legendTextStyle = chart.config.mergedLegendStyle,
      legendFontColor = legendTextStyle.color = (0, _lib.pluck)(legendTextStyle.fill, COLOR_5F5F5F),
      legendTextOpacity = (0, _lib.pluckNumber)(legendTextStyle.opacity, 1),
      legendTextFillOpacity = (0, _lib.pluckNumber)(legendTextStyle['fill-opacity'], 1),
      styleObj = Object.assign({}, chart.getFromEnv('baseTextStyle'), legendTextStyle); // remove px from font-size since legend component of fc accepts font-size as a number

  styleObj['font-size'] = +(styleObj['font-size'] + '').replace(/px/, '');

  if (showLegend) {
    // create an instance of legend and attach it as a children of chart
    (0, _lib.componentFactory)(chart, _discrete.default, 'legend', 1, [{
      // static configuration for legend
      'drawcustomlegendicon': 1,
      'legendiconsides': 4,
      'alignlegendwithcanvas': 1,
      'legendborderthickness': 0,
      'legendiconscale': 1.3,
      'legendbgalpha': 0,
      legendFontColor: legendFontColor,
      style: {
        text: styleObj
      }
    }]);
    legend = chart.getChildren('legend')[0]; // add legend to the env of chart for other components to access

    chart.addToEnv('legend', legend); // set hover cosmetics for legend

    legend.setStateCosmetics('hover', function (cosmetics, legenditem) {
      // only applied the text hovered color only if text is not hidden.
      if (!legenditem.hasState('hidden')) {
        if (!cosmetics.text) {
          cosmetics.text = {};
        } // set the text color and cursor.


        cosmetics.text.fill = (0, _lib.convertColor)(legendFontColor, legendTextOpacity * legendTextFillOpacity * 100);
        cosmetics.text.cursor = INHERIT;
      }

      return cosmetics;
    });

    var createLegend = function createLegend(info) {
      if (info === void 0) {
        info = {};
      }

      for (var key in info) {
        if (info.hasOwnProperty(key)) {
          var itemInfo = info[key];

          if (itemInfo.hasOwnProperty('visibility')) {
            chart._addLegend(itemInfo);
          } else {
            createLegend(itemInfo);
          }
        }
      }
    };

    createLegend(chart.getFromEnv('legendMap'));
  } else if (legend = chart.getChildren('legend') && chart.getChildren('legend')[0]) {
    legend.remove();
  }
};

exports["default"] = _default;

/***/ }),

/***/ 922:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = _default;

var _dataMarker = _interopRequireDefault(__webpack_require__(923));

var _stringHasContent = _interopRequireDefault(__webpack_require__(857));

var _arrayHasContent = _interopRequireDefault(__webpack_require__(446));

var _equals = _interopRequireDefault(__webpack_require__(845));

var _isObject = _interopRequireDefault(__webpack_require__(481));

var _timeConverter = _interopRequireDefault(__webpack_require__(350));

var _clipUtils = __webpack_require__(864);

function _default(dataset) {
  var dataSource = dataset.getFromEnv('dataSource'),
      seriesname = dataset.config.series,
      dataMarker,
      _dataset$getFromEnv$ = dataset.getFromEnv('focusScalesX')[0].applicableClippings,
      repeatClips = _dataset$getFromEnv$.repeatClips,
      singleClips = _dataset$getFromEnv$.singleClips,
      _dataset$config = dataset.config,
      measures = _dataset$config.measures,
      _dataset$config$serie = _dataset$config.seriesInfo,
      seriesInfo = _dataset$config$serie === void 0 ? {} : _dataset$config$serie,
      enableMarkers = _dataset$config.enableMarkers,
      visibility = _dataset$config.visibility,
      isStock = _dataset$config.isStock,
      isRange = _dataset$config.isRange,
      dataMarkerInstance,
      markers = [];

  if (enableMarkers && (dataMarker = dataSource.datamarker)) {
    // Separating the flag and the pin datamarkers
    dataMarker.forEach(function (data) {
      var cloneData = Object.assign({}, data),
          value = cloneData.value,
          series = cloneData.series,
          isConditionsMet = true,
          parsedTime = _timeConverter.default.parser(data.timeformat).parse(data.time);

      if (isNaN(+parsedTime) || (0, _clipUtils.getUnclippedValue)(parsedTime, repeatClips, singleClips) !== +parsedTime) {
        return;
      }

      if (value) {
        if ((0, _stringHasContent.default)(value)) {
          value = [value];
        }

        if ((0, _arrayHasContent.default)(value)) {
          value = value.filter(_stringHasContent.default); // for stock charts all the measure names should match with values

          if ((isRange || isStock) && (0, _isObject.default)(measures[0])) {
            var measuresArr = Object.values(measures[0]);

            for (var i = 0; i < value.length && isConditionsMet; ++i) {
              isConditionsMet = measuresArr.includes(value[i]);
            }
          } else {
            isConditionsMet = (0, _equals.default)(value, measures);
          }
        }
      }

      if (Object.keys(seriesInfo).length && (0, _isObject.default)(series)) {
        var keys = Object.keys(series),
            _i = keys.length,
            key;

        while (isConditionsMet && _i--) {
          key = keys[_i];

          if ((0, _stringHasContent.default)(series[key])) {
            if (series[key] !== seriesInfo[key]) isConditionsMet = false;
          }
        }

        ;
      }

      if (isConditionsMet) {
        // series name will be same as the series in dataset, it will be used internally
        if (isStock || isRange) {
          cloneData.measures = measures;
        } else {
          cloneData.seriesname = seriesname;
        }

        markers.push(cloneData);
      }

      ;
    });

    if (markers.length !== 0) {
      dataMarkerInstance = dataset.attachChild(_dataMarker.default, 'dataMarker');
      dataMarkerInstance.configure({
        data: markers,
        isStock: isStock,
        isRange: isRange,
        visibility: visibility
      });
    }
  }
}

/***/ }),

/***/ 896:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = _default;

var _mouseTracker = _interopRequireDefault(__webpack_require__(897));

function _default(canvas) {
  var mouseTracker;

  if (canvas.config.enableMouseTracking) {
    mouseTracker = canvas.attachChild(_mouseTracker.default, 'mouseTracker');
    canvas.addToEnv('mouseTracker', mouseTracker); // if mouse tracker events are already added then do not add the events

    if (!mouseTracker.config.mouseTrackerEventAdded) {
      mouseTracker.addEvents();
      mouseTracker.config.mouseTrackerEventAdded = true;
    }
  }
}

/***/ }),

/***/ 982:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _multicanvasCrosslineManager = _interopRequireDefault(__webpack_require__(983));

var _lib = __webpack_require__(274);

var _default = function _default(chart) {
  var crosslineManager;
  (0, _lib.componentFactory)(chart, _multicanvasCrosslineManager.default, 'multicanvasCrosslineManager', 1);
  crosslineManager = chart.getChildren('multicanvasCrosslineManager')[0];
  crosslineManager.configure();
};

exports["default"] = _default;

/***/ }),

/***/ 890:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _referenceLine = _interopRequireDefault(__webpack_require__(891));

var _default = function _default(canvas) {
  canvas.config.yConfigs.forEach(function (yConfig) {
    var scale = yConfig.scale;

    if (canvas.config.enableReferenceLine && Array.isArray(yConfig.referenceline)) {
      yConfig.referenceline.forEach(function (referencelineConf) {
        var refLine = canvas.attachChild(_referenceLine.default, 'referenceLine');
        refLine.addEventListener('fc-mouseover', refLine.hoverInHandler);
        refLine.addEventListener('fc-mousemove', refLine.moveHandler);
        refLine.addEventListener('fc-mouseout', refLine.hoverOutHandler);
        refLine.addEventListener('fc-click', refLine.clickHandler);
        refLine.configure({
          yScale: scale,
          // direction represent which side the bulb will be on
          // hence, always opposite to the axis alignment
          direction: yConfig.align === 'left' ? 'right' : 'left',
          formatterFn: yConfig.formatterFn,
          prefix: yConfig.formatLabelPrefix,
          suffix: yConfig.formatLabelSuffix,
          referenceLine: referencelineConf
        });
      });
    }
  });
};

exports["default"] = _default;

/***/ }),

/***/ 892:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _referenceZone = _interopRequireDefault(__webpack_require__(893));

var _lib = __webpack_require__(274);

var UNDEF,
    isDefined = function isDefined(value) {
  return value === UNDEF ? UNDEF : 1;
};

var _default = function _default(canvas) {
  canvas.config.yConfigs.forEach(function (yConfig) {
    var scale = yConfig.scale,
        chartAttr = canvas.getFromEnv('chart-attrib');

    if (canvas.config.enableReferenceZone && Array.isArray(yConfig.referencezone)) {
      yConfig.referencezone.forEach(function (referencezoneConf) {
        if (isDefined(referencezoneConf.valuemin) && isDefined(referencezoneConf.valuemax)) {
          var refZone = canvas.attachChild(_referenceZone.default, 'referenceZone');
          refZone.addEventListener('fc-mouseover', refZone.hoverInHandler);
          refZone.addEventListener('fc-mousemove', refZone.moveHandler);
          refZone.addEventListener('fc-mouseout', refZone.hoverOutHandler);
          refZone.addEventListener('fc-click', refZone.clickHandler);
          refZone.configure({
            yScale: scale,
            // direction represent which side the bulbs will be on
            // hence, always opposite to the axis alignment
            direction: yConfig.align === 'left' ? 'right' : 'left',
            formatterFn: yConfig.formatterFn,
            prefix: yConfig.formatLabelPrefix,
            suffix: yConfig.formatLabelSuffix,
            referenceLine: referencezoneConf,
            extStyle: referencezoneConf.style || {},
            yAxisAlign: yConfig.align,
            showTextOutline: (0, _lib.pluckNumber)(chartAttr.textoutline, 0)
          });
          canvas.addExtEventListener('referenceZoneHovered', refZone.referenceZoneHoveredHandler, refZone);
          refZone.addExtEventListener('canvasHovered', refZone.canvasHoveredHandler, canvas.getFromEnv('mouseTracker'));
        }
      });
    }
  });
};

exports["default"] = _default;

/***/ }),

/***/ 962:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _scrollbar = _interopRequireDefault(__webpack_require__(420));

var _index = __webpack_require__(274);

var DRAGSTART = 'timeNavBrushStart',
    DRAGEND = 'timeNavBrushEnd',
    DRAG = 'timeNavBrush',
    UP = 'up',
    DOWN = 'down',
    LABELFORMAT = '%b %d, %Y',
    TRANSLATE = 'translate',
    buttonStyle = {
  fill: '#e3e3e3',
  stroke: 'none'
},
    trackStyle = {
  fill: '#f8f8f8',
  stroke: 'none'
},
    anchorStyle = {
  fill: '#e3e3e3',
  stroke: 'none'
},
    buttonPointerFill = "#" + (0, _index.getDarkColor)(buttonStyle.fill, 60),
    stripesStroke = "#" + (0, _index.getDarkColor)(anchorStyle.fill, 60);

var _default = function _default(timeNav) {
  var scrollbar = timeNav.attachChild(_scrollbar.default, 'scrollbar'),
      chart = timeNav.getFromEnv('chart'),
      currFocusLimit,
      lastScrollPosition,
      timeNavConfig = timeNav.config,
      scale = timeNavConfig.contextScale,
      dataSource = scrollbar.getFromEnv('dataSource'),
      getStyleDef = scrollbar.getFromEnv('getStyleDef'),
      inputStyle = dataSource.navigator && dataSource.navigator.scrollbar && dataSource.navigator.scrollbar.style || {},
      style,
      options = {
    timeFormatter: timeNavConfig.formatter
  },
      forceFireOptions = Object.assign({
    forceFire: true
  }, options),
      eventArgs = {
    formatter: LABELFORMAT,
    action: TRANSLATE
  };
  style = {
    button: Object.assign({
      stroke: buttonStyle.stroke,
      fill: buttonStyle.fill
    }, getStyleDef(inputStyle.button)),
    arrow: Object.assign({
      fill: buttonPointerFill
    }, getStyleDef(inputStyle.arrow)),
    scroller: Object.assign({
      stroke: anchorStyle.stroke,
      fill: anchorStyle.fill
    }, getStyleDef(inputStyle.scroller)),
    grip: Object.assign({
      stroke: stripesStroke
    }, getStyleDef(inputStyle.grip)),
    track: Object.assign({
      stroke: trackStyle.stroke,
      fill: trackStyle.fill
    }, getStyleDef(inputStyle.track))
  };
  scrollbar.configure({
    isHorizontal: true,
    displayFlat: true,
    width: timeNav.getScrollbarConfig('width'),
    height: timeNav.getScrollbarConfig('height'),
    style: style,
    drawStripes: 1,
    restrictScrollAnchor: 0,
    scrollRatio: timeNav.getScrollbarConfig('scrollRatio')
  });
  scrollbar.attachEventHandlers({
    scroll: function scroll(scrollPosition) {
      // calculate the dimensions of scroll anchor and use them to calculate the new domain of brush.
      // calculations are the same as used in scroll-anchor component.
      var scrollbarConf = timeNav.getChildren('scrollbar')[0].config,
          width = scrollbarConf.width,
          height = scrollbarConf.height,
          clampDirection,
          scrollRatio = timeNav.getScrollbarConfig('scrollRatio'),
          scrollButtonWidth = Math.min(height, width * 0.5),
          anchorWidth = (width - 2 * scrollButtonWidth) * scrollRatio - 1,
          // 1px is for left and right padding of scrollbar
      trackOffset = scrollbarConf.x + scrollButtonWidth + 0.5,
          trackLength = width - 2 * scrollButtonWidth - anchorWidth,
          anchorXPos = trackOffset + trackLength * scrollPosition;
      clampDirection = lastScrollPosition > scrollPosition ? DOWN : UP;
      chart.setPixelLimit([anchorXPos, anchorXPos + anchorWidth], scale, [clampDirection, clampDirection], {
        name: DRAG
      });
    },
    scrollStart: function scrollStart() {
      currFocusLimit = chart.getFocusLimit();
      chart.getFromEnv('fireChartEvents')(DRAGSTART, [+currFocusLimit[0], +currFocusLimit[1]], eventArgs, forceFireOptions);
    },
    scrollEnd: function scrollEnd() {
      currFocusLimit = chart.getFocusLimit();
      chart.getFromEnv('fireChartEvents')(DRAGEND, [+currFocusLimit[0], +currFocusLimit[1]], eventArgs, forceFireOptions);
    }
  });
};

exports["default"] = _default;

/***/ }),

/***/ 984:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _standardRangeSelector = _interopRequireDefault(__webpack_require__(985));

var _lib = __webpack_require__(274);

var _default = function _default(chart) {
  var standardRangeSelector,
      extensions = chart.getFromEnv('dataSource').extensions,
      enabled = (0, _lib.pluckNumber)(extensions && extensions.standardrangeselector && extensions.standardrangeselector.enabled, 1);

  if (enabled) {
    (0, _lib.componentFactory)(chart, _standardRangeSelector.default, 'standardRangeSelector', 1);
    standardRangeSelector = chart.getChildren('standardRangeSelector')[0];
    standardRangeSelector.configure({
      'currentDomain': chart.getFocusLimit(),
      'totalDomain': chart.getContextLimit(),
      'style': extensions && extensions.standardrangeselector && extensions.standardrangeselector.style || {}
    });
  } else {
    (0, _lib.componentFactory)(chart, _standardRangeSelector.default, 'standardRangeSelector', 0);
  }
};

exports["default"] = _default;

/***/ }),

/***/ 886:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _timeSpanMinMarker = _interopRequireDefault(__webpack_require__(887));

var _timeSpanFullMarker = _interopRequireDefault(__webpack_require__(888));

var _timeInstanceMarker = _interopRequireDefault(__webpack_require__(889));

var _pluckNumber = _interopRequireDefault(__webpack_require__(280));

var _default = function _default(canvas) {
  var canvasConfig = canvas.config,
      xConfigs = canvasConfig.xConfigs;

  if (canvas.config.enableTimeMarkers) {
    xConfigs.forEach(function (xConfig) {
      var timeMarkers = xConfig.timemarker || [],
          showTimeSpanMarkerTooltipAt = (0, _pluckNumber.default)(xConfig.showtimespanmarkertooltipat, 1),
          columnName = xConfig.plot[0].value,
          chartConfig = canvas.getFromEnv('chartConfig'),
          schema = chartConfig.dataTable.getSchema(),
          defaultFormat = schema.find(function (el) {
        return el.name === columnName;
      }).format,
          timeSpanMinMarkersConf = [],
          timeSpanFullMarkersConf = [],
          timeInstanceMarkersConf = [],
          chart = canvas.getFromEnv('chart'),
          scale = canvas.config.xConfigs[0].scale,
          timeSpanMinMarker,
          timeSpanFullMarker,
          timeInstanceMarker;
      timeMarkers.forEach(function (marker) {
        // time span marker
        if (marker.end) {
          if (marker.type === 'full') {
            timeSpanFullMarkersConf.push(marker);
          } else {
            timeSpanMinMarkersConf.push(marker);
          }
        } else {
          // time instance marker
          timeInstanceMarkersConf.push(marker);
        }
      });
      timeSpanMinMarker = canvas.attachChild(_timeSpanMinMarker.default, 'timeSpanMinMarker');
      timeSpanFullMarker = canvas.attachChild(_timeSpanFullMarker.default, 'timeSpanFullMarker');
      timeSpanMinMarker.configure({
        timeMarker: timeSpanMinMarkersConf,
        defaultFormat: defaultFormat,
        xScale: scale,
        showTimeSpanMarkerTooltipAt: showTimeSpanMarkerTooltipAt
      });
      timeSpanMinMarker.addExtEventListener('timeSpanMinMarkerHovered', function (e) {
        if (e.data.senderTimeMarker !== timeSpanMinMarker) {
          timeSpanMinMarker.setData({
            hoveredIndex: e.data.hoveredIndex,
            hoveredFromOutside: true
          }, true);
        }
      }, chart);
      timeSpanFullMarker.configure({
        timeMarker: timeSpanFullMarkersConf,
        defaultFormat: defaultFormat,
        xScale: scale,
        showTimeSpanMarkerTooltipAt: showTimeSpanMarkerTooltipAt
      });
      timeSpanFullMarker.addExtEventListener('timeSpanFullMarkerHovered', function (e) {
        if (e.data.senderTimeMarker !== timeSpanFullMarker) {
          timeSpanFullMarker.setData({
            hoveredIndex: e.data.hoveredIndex,
            hoveredFromOutside: true
          }, true);
        }
      }, chart);
      timeInstanceMarker = canvas.attachChild(_timeInstanceMarker.default, 'timeInstanceMarker');
      timeInstanceMarker.configure({
        timeMarker: timeInstanceMarkersConf,
        defaultFormat: defaultFormat,
        xScale: scale
      });
      timeInstanceMarker.addExtEventListener('timeInstanceMarkerHovered', function (e) {
        if (e.data.senderTimeMarker !== timeInstanceMarker) {
          timeInstanceMarker.setData({
            hoveredMarkerIndex: e.data.hoveredMarkerIndex,
            hoveredDomainIndex: e.data.hoveredDomainIndex,
            hoveredFromOutside: true
          }, true);
        }
      }, chart);
    });
  }
};

exports["default"] = _default;

/***/ }),

/***/ 961:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _axis = _interopRequireDefault(__webpack_require__(884));

var UNDEF;

var _default = function _default(timeNav) {
  var baseTextStyle = timeNav.getFromEnv('baseTextStyle');
  timeNav.attachChild(_axis.default, 'timeAxis');
  timeNav.getChildren('timeAxis').forEach(function (axis) {
    axis.configure({
      skipinfo: {
        minor: true
      },
      overlap: true,
      validateLabelDimensions: 1,
      offset: {
        x: 2,
        y: 2
      },
      style: {
        'label-major': Object.assign({
          fill: '#5f5f5f',
          'font-size': 11,
          'text-anchor': 'start'
        }, baseTextStyle),
        'label-minor': Object.assign({
          'text-anchor': 'start'
        }, baseTextStyle),
        'label-context': Object.assign({
          'text-anchor': 'start'
        }, baseTextStyle)
      },
      ticksize: 0,
      domainline: false,
      align: 'top',
      dayinmajor: true,
      stickycontextlabel: false,
      scalemode: 'random',
      scale: timeNav.config.xConfigs[0].scale,
      tickvisibilitylimit: {
        start: UNDEF,
        end: UNDEF
      }
    });
  });
};

exports["default"] = _default;

/***/ }),

/***/ 963:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _brush = _interopRequireDefault(__webpack_require__(964));

var _default = function _default(timeNav) {
  var brush = timeNav.attachChild(_brush.default, 'brush'),
      dataSource = timeNav.getFromEnv('dataSource');
  brush.configure({
    values: timeNav.config.values,
    style: dataSource.navigator && dataSource.navigator.window && dataSource.navigator.window.style || {}
  });
};

exports["default"] = _default;

/***/ }),

/***/ 980:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _lib = __webpack_require__(274);

var _smartToolbar = _interopRequireDefault(__webpack_require__(981));

var _default = function _default(chart) {
  var toolbar,
      chartAttrib = chart.getFromEnv('dataSource').chart; // create an instance of toolbar and attach it as a children of chart

  (0, _lib.componentFactory)(chart, _smartToolbar.default, 'selectorToolbar', 1, [Object.assign({
    toolbarhdirection: 1
  }, chartAttrib)]);
  toolbar = chart.getChildren('selectorToolbar')[0]; // add toolbar to the env of chart for other components to access

  chart.addToEnv('selectorToolbar', toolbar);
};

exports["default"] = _default;

/***/ }),

/***/ 898:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = _default;

var _tooltipAndHover = _interopRequireDefault(__webpack_require__(899));

function _default(canvas) {
  if (canvas.config.enableMouseTracking) {
    canvas.attachChild(_tooltipAndHover.default, 'tooltipHover').configure();
  }
}

;

/***/ }),

/***/ 941:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _crossline = _interopRequireDefault(__webpack_require__(942));

var _default = function _default(canvas) {
  var crossLine = canvas.attachChild(_crossline.default, 'verticalCrossLine'),
      dataSource = canvas.getFromEnv('dataSource');
  crossLine.configure({
    scale: canvas.config.xConfigs[0].scale,
    type: 'vertical',
    timeFormatterFn: canvas.config.xConfigs[0].timeFormatterFn,
    inputStyle: dataSource.crossline && dataSource.crossline.style || {}
  });
};

exports["default"] = _default;

/***/ }),

/***/ 804:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;

var _timeseries = _interopRequireDefault(__webpack_require__(805));

exports.TimeSeries = _timeseries.default;

/***/ }),

/***/ 972:
/***/ ((module) => {



(function webpackUniversalModuleDefinition(root, factory) {
  if (true) module.exports = factory();else { var i, a; }
})(window, function () {
  return (
    /******/
    function (modules) {
      // webpackBootstrap

      /******/
      // The module cache

      /******/
      var installedModules = {};
      /******/

      /******/
      // The require function

      /******/

      function __nested_webpack_require_643__(moduleId) {
        /******/

        /******/
        // Check if module is in cache

        /******/
        if (installedModules[moduleId]) {
          /******/
          return installedModules[moduleId].exports;
          /******/
        }
        /******/
        // Create a new module (and put it into the cache)

        /******/


        var module = installedModules[moduleId] = {
          /******/
          i: moduleId,

          /******/
          l: false,

          /******/
          exports: {}
          /******/

        };
        /******/

        /******/
        // Execute the module function

        /******/

        modules[moduleId].call(module.exports, module, module.exports, __nested_webpack_require_643__);
        /******/

        /******/
        // Flag the module as loaded

        /******/

        module.l = true;
        /******/

        /******/
        // Return the exports of the module

        /******/

        return module.exports;
        /******/
      }
      /******/

      /******/

      /******/
      // expose the modules object (__webpack_modules__)

      /******/


      __nested_webpack_require_643__.m = modules;
      /******/

      /******/
      // expose the module cache

      /******/

      __nested_webpack_require_643__.c = installedModules;
      /******/

      /******/
      // define getter function for harmony exports

      /******/

      __nested_webpack_require_643__.d = function (exports, name, getter) {
        /******/
        if (!__nested_webpack_require_643__.o(exports, name)) {
          /******/
          Object.defineProperty(exports, name, {
            enumerable: true,
            get: getter
          });
          /******/
        }
        /******/

      };
      /******/

      /******/
      // define __esModule on exports

      /******/


      __nested_webpack_require_643__.r = function (exports) {
        /******/
        if (typeof Symbol !== 'undefined' && Symbol.toStringTag) {
          /******/
          Object.defineProperty(exports, Symbol.toStringTag, {
            value: 'Module'
          });
          /******/
        }
        /******/


        Object.defineProperty(exports, '__esModule', {
          value: true
        });
        /******/
      };
      /******/

      /******/
      // create a fake namespace object

      /******/
      // mode & 1: value is a module id, require it

      /******/
      // mode & 2: merge all properties of value into the ns

      /******/
      // mode & 4: return value when already ns object

      /******/
      // mode & 8|1: behave like require

      /******/


      __nested_webpack_require_643__.t = function (value, mode) {
        /******/
        if (mode & 1) value = __nested_webpack_require_643__(value);
        /******/

        if (mode & 8) return value;
        /******/

        if (mode & 4 && typeof value === 'object' && value && value.__esModule) return value;
        /******/

        var ns = Object.create(null);
        /******/

        __nested_webpack_require_643__.r(ns);
        /******/


        Object.defineProperty(ns, 'default', {
          enumerable: true,
          value: value
        });
        /******/

        if (mode & 2 && typeof value != 'string') for (var key in value) {
          __nested_webpack_require_643__.d(ns, key, function (key) {
            return value[key];
          }.bind(null, key));
        }
        /******/

        return ns;
        /******/
      };
      /******/

      /******/
      // getDefaultExport function for compatibility with non-harmony modules

      /******/


      __nested_webpack_require_643__.n = function (module) {
        /******/
        var getter = module && module.__esModule ?
        /******/
        function getDefault() {
          return module['default'];
        } :
        /******/
        function getModuleExports() {
          return module;
        };
        /******/

        __nested_webpack_require_643__.d(getter, 'a', getter);
        /******/


        return getter;
        /******/
      };
      /******/

      /******/
      // Object.prototype.hasOwnProperty.call

      /******/


      __nested_webpack_require_643__.o = function (object, property) {
        return Object.prototype.hasOwnProperty.call(object, property);
      };
      /******/

      /******/
      // __webpack_public_path__

      /******/


      __nested_webpack_require_643__.p = "/dist/";
      /******/

      /******/

      /******/
      // Load entry module and return exports

      /******/

      return __nested_webpack_require_643__(__nested_webpack_require_643__.s = 0);
      /******/
    }(
    /************************************************************************/

    /******/
    [
    /* 0 */

    /***/
    function (module, __nested_webpack_exports__, __nested_webpack_require_5371__) {
      "use strict";

      __nested_webpack_require_5371__.r(__nested_webpack_exports__);
      /* harmony import */


      var core_js_features_string_starts_with_js__WEBPACK_IMPORTED_MODULE_0__ = __nested_webpack_require_5371__(1);
      /* harmony import */


      var core_js_features_string_starts_with_js__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__nested_webpack_require_5371__.n(core_js_features_string_starts_with_js__WEBPACK_IMPORTED_MODULE_0__);
      /* harmony import */


      var core_js_features_string_ends_with_js__WEBPACK_IMPORTED_MODULE_1__ = __nested_webpack_require_5371__(55);
      /* harmony import */


      var core_js_features_string_ends_with_js__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__nested_webpack_require_5371__.n(core_js_features_string_ends_with_js__WEBPACK_IMPORTED_MODULE_1__);
      /* harmony import */


      var core_js_features_object_assign_js__WEBPACK_IMPORTED_MODULE_2__ = __nested_webpack_require_5371__(58);
      /* harmony import */


      var core_js_features_object_assign_js__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__nested_webpack_require_5371__.n(core_js_features_object_assign_js__WEBPACK_IMPORTED_MODULE_2__);
      /* harmony import */


      var _css_fc_calendar_css__WEBPACK_IMPORTED_MODULE_3__ = __nested_webpack_require_5371__(64);
      /* harmony import */


      var _css_fc_calendar_css__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__nested_webpack_require_5371__.n(_css_fc_calendar_css__WEBPACK_IMPORTED_MODULE_3__);
      /* harmony import */


      var _fusioncharts_utils_src_trusted_policy__WEBPACK_IMPORTED_MODULE_4__ = __nested_webpack_require_5371__(69);
      /* harmony import */


      var _fusioncharts_utils_src_trusted_policy__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__nested_webpack_require_5371__.n(_fusioncharts_utils_src_trusted_policy__WEBPACK_IMPORTED_MODULE_4__);

      function _classCallCheck(instance, Constructor) {
        if (!(instance instanceof Constructor)) {
          throw new TypeError("Cannot call a class as a function");
        }
      }

      function _defineProperties(target, props) {
        for (var i = 0; i < props.length; i++) {
          var descriptor = props[i];
          descriptor.enumerable = descriptor.enumerable || false;
          descriptor.configurable = true;
          if ("value" in descriptor) descriptor.writable = true;
          Object.defineProperty(target, descriptor.key, descriptor);
        }
      }

      function _createClass(Constructor, protoProps, staticProps) {
        if (protoProps) _defineProperties(Constructor.prototype, protoProps);
        if (staticProps) _defineProperties(Constructor, staticProps);
        return Constructor;
      }

      function _typeof(obj) {
        if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
          _typeof = function _typeof(obj) {
            return typeof obj;
          };
        } else {
          _typeof = function _typeof(obj) {
            return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
          };
        }

        return _typeof(obj);
      }

      var idNo = 0;

      var UNDEFINED = undefined,
          cssMap = new Map(),
          isObject = function isObject(x) {
        return x !== null && _typeof(x) === 'object' && !Array.isArray(x);
      },
          // basic calendar configaration
      daysInMonth = [31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31],
          weekLabel = ['Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat'],
          monthLabel = ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December'],
          // classes in cssStyleSheet will be applied in the gievn order
      // so that styles get applied correctly
      CLASS_PRECEDENCE_SEQUENCE = ['container', 'container:hover', 'header-container', 'header-container:hover', 'header', 'header:hover', 'year', 'year:hover', 'headername', 'headername:hover', 'yearname', 'yearname:hover', 'nav', 'nav:hover', 'navprev', 'navprev:hover', 'navnext', 'navnext:hover', 'navinactive', 'navinactive:hover', 'navmonth', 'navmonth:hover', 'navyear', 'navyear:hover', 'subheader', 'subheader:hover', 'body', 'body:hover', 'days', 'days:hover', 'indexeddays', 'indexeddays:hover', 'dateLI', 'dateLI:hover', 'date', 'date:hover', 'daycol', 'daycol:hover', 'normaldatedefault', 'normaldatedefault:hover', 'activedate', 'activedate:hover', 'disableddatedefault', 'disableddatedefault:hover', 'disableddate', 'disableddate:hover', 'weekenddefault', 'weekenddefault:hover', 'weekend', 'weekend:hover', 'selecteddatedefault', 'selecteddatedefault:hover', 'selecteddate', 'selecteddate:hover', 'highlighteddatedefault', 'highlighteddatedefault:hover', 'highlighteddate', 'highlighteddate:hover'],
          defaultCss = {
        dateLI: {
          'box-sizing': 'border-box!important',
          'float': 'left!important',
          'list-style-type': 'none!important',
          'width': '14.28571%!important',
          'height': 'auto!important',
          'padding': '2px 0 2px !important',
          'margin': '0 !important',
          'background-color': '#fff !important'
        },
        navinactive: {
          opacity: 0,
          cursor: 'default !important'
        },
        weekenddefault: {
          'background-color': '#F7F6FF!important'
        },
        'normaldatedefault': {
          cursor: 'pointer!important'
        },
        'normaldatedefault:hover': {
          color: '#5F5F5F!important',
          'background-color': '#dcdcdc!important'
        },
        'selecteddatedefault': {
          'background-color': '#5648D4!important',
          color: '#F3F3F3!important'
        },
        'selecteddatedefault:hover': {
          'background-color': '#5648D4!important',
          color: '#F3F3F3!important'
        },
        disableddatedefault: {
          color: '#cacaca!important'
        }
      },
          defaultClassNames = {
        container: 'fc-cal-container',
        'header-container': 'fc-cal-header-container',
        header: 'fc-cal-month-header',
        year: 'fc-cal-year-header',
        headername: 'fc-cal-month',
        yearname: 'fc-cal-year',
        nav: 'fc-cal-nav',
        navprev: 'fc-cal-nav-prev',
        navnext: 'fc-cal-nav-next',
        navinactive: 'fc-cal-nav-inactive',
        navmonth: 'fc-cal-nav-month',
        navyear: 'fc-cal-nav-year',
        subheader: 'fc-cal-sub-header',
        body: 'fc-cal-body',
        days: 'fc-cal-day',
        indexeddays: 'fc-cal-day-',
        // Index will be added at the end
        dateLI: 'fc-cal-date-li',
        date: 'fc-cal-date',
        daycol: 'fc-cal-day-col',
        normaldatedefault: 'fc-cal-date-normal-default',
        activedate: 'fc-cal-date-normal',
        disableddatedefault: 'fc-cal-date-disabled-default',
        disableddate: 'fc-cal-date-disabled',
        weekenddefault: 'fc-cal-weekend-default',
        weekend: 'fc-cal-weekend',
        selecteddatedefault: 'fc-cal-date-selected-default',
        selecteddate: 'fc-cal-date-selected',
        highlighteddatedefault: 'fc-cal-date-highlight-default',
        highlighteddate: 'fc-cal-date-highlight'
      },
          inlineStyle = {
        container: 'box-sizing: border-box !important; -webkit-touch-callout: none !important; -webkit-user-select: none !important; -khtml-user-select: none !important; -moz-user-select: none !important; -ms-user-select: none !important; user-select: none !important; text-align: center !important; vertical-align: top !important; padding-bottom: 0 !important; margin: 0px 0px 0px 0px !important; float: left;' + 'font-size: 11px !important; max-width: 163px !important; background-color: #fff !important; border: 1px solid #a5a4a4;',
        header: 'box-sizing: border-box !important; overflow: hidden !important; height: 26px !important; line-height: 2.4 !important' + 'font-size: 12px !important; background-color: #5648D4 !important;',
        month: 'display: block !important; width: 100% !important; float: left !important; height: 100% !important;' + 'font-weight: bold !important; color: #F3F3F3 !important; font-size: 13px !important;',
        year: 'display: block !important; width: 35% !important; float: right !important;',
        monthname: 'display: inline-block !important; padding: 4px !important;',
        yearname: 'display: inline-block !important; padding-right: 5px !important; padding-left: 5px !important;',
        nav: 'display: inline-block !important; cursor: pointer !important; padding: 4px;',
        navprev: 'float: left !important; padding-left: 8px !important;',
        navnext: 'float: right !important; padding-right: 8px !important;',
        navinactive: 'cursor: default !important;',
        navmonth: '',
        navyear: '',
        subheader: 'text-transform: uppercase !important; overflow: hidden !important; color: #666 !important;',
        days: 'box-sizing: border-box !important; display: block !important; float: left !important; width: 14.28571% !important; line-height: 2.3 !important;',
        indexeddays: '',
        body: 'width: 100% !important;',
        date: 'box-sizing: border-box !important; text-align: center !important; display: block !important; margin: 0 auto !important;' + 'border: 0px solid transparent !important; width: 14.2857% !important; padding: 0px !important;',
        dateLI: 'box-sizing: border-box !important; float: left !important; list-style-type: none !important; width: 14.28571% !important; height: auto!important;',
        selecteddate: '',
        disableddate: '',
        normaldate: 'cursor: pointer !important;',
        highlightedDate: '',
        daycol: '',
        weekenddefault: 'background-color: #F7F6FF!important;',
        weekend: ''
      },
          ulPadZeroStyle = {
        padding: '0',
        margin: 0
      },
          minHeight = 300,
          minWidth = 300,
          PX = 'px',
          SP = ' ',
          BLANK = '',
          SPACE = '&nbsp;',
          DASH = '-',
          SLASH = '/',
          vAlignMultiplier = {
        top: 0,
        middle: -0.5,
        bottom: -1
      },
          hAlignMultiplier = {
        left: 0,
        center: -0.5,
        right: -1
      },
          // get id for container
      getuid = function getuid() {
        return "fc_calendar-".concat(idNo++);
      },
          // check if the year is leap year or not
      checkLeapYear = function checkLeapYear(year) {
        return year % 4 === 0 && year % 100 !== 0 || year % 400 === 0;
      },
          // apply custom style to the container
      setStyle = function setStyle(element, style) {
        if (style && element && element.style) {
          for (var key in style) {
            if (style.hasOwnProperty(key)) {
              element.style[key] = style[key];
            }
          }
        }
      },
          removeClassName = function removeClassName(className, element) {
        var classNameList = element && element.className;

        if (classNameList && className) {
          element.className = classNameList.replace(new RegExp('(?:^|\\s*)' + className.trim() + '(?:\\s*|$)'), ' ');
        }
      },
          removeClassInChilds = function removeClassInChilds(parent, className) {
        var children, i, j, l, classArr;

        if (parent && parent.getElementsByClassName) {
          classArr = className.trim().split(SP);

          for (j = 0, l = classArr.length; j < l; j += 1) {
            className = classArr[j];
            children = parent.getElementsByClassName(className);

            for (i = children.length - 1; i >= 0; i--) {
              removeClassName(className, children[i]);
            }
          }
        }
      },
          // this function will update the calendar
      // without re-drawing the elements
      displayMonth = function displayMonth(calendar) {
        var info = calendar.info,
            graphic = calendar.graphic,
            classNames = calendar.classNames,
            active = info.active,
            rangeStart = info.rangeStart,
            rangeEnd = info.rangeEnd,
            weekStartingDay = info.weekStartingDay,
            highlight = info.highlight,
            highlightClasses = info.highlightClasses,
            showInactiveMonths = info.showInactiveMonths,
            monthStr = graphic.monthStr,
            yearStr = graphic.yearStr,
            dateElements = graphic.dateElements,
            dateLiElements = graphic.dateLiElements,
            container = graphic.container,
            prevMonth = graphic.prevMonth,
            prevMonthPointer = graphic.prevMonthPointer,
            nextMonth = graphic.nextMonth,
            nextMonthPointer = graphic.nextMonthPointer,
            prevYear = graphic.prevYear,
            nextYear = graphic.nextYear,
            month = active.month,
            year = active.year,
            highlightMonth = highlight && highlight[year] && highlight[year][month],
            startingOfMonth = new Date("".concat(month, "/1/").concat(year)),
            monthStaringDay = startingOfMonth.getDay(),
            monthStaringWeekDay = info.startingPos = monthStaringDay - weekStartingDay + (weekStartingDay <= monthStaringDay ? 0 : 7),
            totalDays = daysInMonth[month - 1] + (checkLeapYear(year) && month === 2 ? 1 : 0),
            limit = totalDays + monthStaringWeekDay,
            startActive = validateActiveStart({
          day: 1,
          month: month,
          year: year
        }, rangeStart),
            endActive = validateActiveEnd({
          day: totalDays,
          month: month,
          year: year
        }, rangeEnd),
            startInactiveLimit = startActive ? 0 : rangeStart.month === month && rangeStart.year === year ? rangeStart.day - 1 : totalDays,
            endInactiveLimit = endActive ? totalDays + 1 : rangeEnd.month === month && rangeEnd.year === year ? rangeEnd.day + 1 : 1;
        var i,
            j,
            l,
            cur,
            highlightInfo,
            highLightClass,
            dateList,
            weekenddefault,
            weekend,
            element,
            disablePrevMonthLi = rangeStart && rangeStart.year === active.year && rangeStart.month === active.month,
            disableNextMonthLi = rangeEnd && rangeEnd.year === active.year && rangeEnd.month === active.month;
        info.curMonthInfo = {
          start: monthStaringDay,
          end: limit
        };
        dateList = graphic.calendarBody.children[0]; // remove previously applied Classes

        removeClassInChilds(container, classNames.normaldatedefault);
        removeClassInChilds(container, classNames.selecteddatedefault);
        removeClassInChilds(container, classNames.disableddatedefault);
        removeClassInChilds(container, classNames.activedate);
        removeClassInChilds(container, classNames.selecteddate);
        removeClassInChilds(container, classNames.disableddate);
        removeClassInChilds(container, classNames.navinactive); // make navigators inactive

        if (disableNextMonthLi) {
          nextMonthPointer.className += SP + classNames.navinactive;
        } else {
          removeClassName(classNames.navinactive, nextMonth);
        }

        if (disablePrevMonthLi) {
          prevMonthPointer.className += SP + classNames.navinactive;
        } else {
          removeClassName(classNames.navinactive, prevMonth);
        } // remobve all highlight classes


        while (highlightClasses.length) {
          highLightClass = highlightClasses.pop();
          removeClassInChilds(container, highLightClass);
        } // If not enough list items are present, create them


        if (dateList.childElementCount < 42) {
          while (dateList.childElementCount < 42) {
            i = dateList.childElementCount;
            weekenddefault = SP + (i % 7 === 5 || i % 7 === 6 ? classNames.weekenddefault : BLANK);
            weekend = SP + (i % 7 === 5 || i % 7 === 6 ? classNames.weekend : BLANK); // create date elements

            element = createElement('li', {
              appendTo: dateList,
              className: weekenddefault,
              events: {
                click: function click() {
                  var info = calendar.info,
                      events = calendar.events,
                      selectedDate = info.selectedDate,
                      active = info.active,
                      tempDate = {
                    day: i - info.startingPos + 1,
                    month: active.month,
                    year: active.year
                  };

                  if (tempDate.day >= 1 && tempDate.day <= info.curMonthInfo.end - info.startingPos && validateActiveStart(tempDate, info.rangeStart) && validateActiveEnd(tempDate, info.rangeEnd)) {
                    selectedDate.day = tempDate.day;
                    selectedDate.month = tempDate.month;
                    selectedDate.year = tempDate.year;
                    setSelectedDate(calendar);
                    events.onDateChange && events.onDateChange(selectedDate);
                  }
                }
              }
            });
            dateLiElements.push(element);
            element = createElement('span', {
              appendTo: element,
              className: classNames.date + SP + classNames.daycol + DASH + i % 7 + weekend,
              innerHTML: _fusioncharts_utils_src_trusted_policy__WEBPACK_IMPORTED_MODULE_4___default.a.createHTML(SPACE)
            });
            dateElements.push(element);
          }
        } // month and year changed


        monthStr.innerHTML = _fusioncharts_utils_src_trusted_policy__WEBPACK_IMPORTED_MODULE_4___default.a.createHTML(info.monthLabel[month - 1] + SP + year); // print dates

        for (i = 0, l = dateElements.length; i < l; i++) {
          if (i < monthStaringWeekDay) {
            // show days of previous month
            dateElements[i].innerHTML = _fusioncharts_utils_src_trusted_policy__WEBPACK_IMPORTED_MODULE_4___default.a.createHTML(new Date(year, month - 1, i - monthStaringWeekDay + 1).getDate());
            dateLiElements[i].className += SP + classNames.disableddatedefault;
            dateElements[i].className += SP + classNames.disableddate;
            dateLiElements[i].eventAttached && dateLiElements[i].removeEventListener('click', dateElements[i]._clickHandler);
            dateLiElements[i].eventAttached = false;
          } else if (i >= limit) {
            // show days of next month
            cur = new Date(year, month - 1, i - monthStaringWeekDay + 1).getDate();
            dateElements[i].innerHTML = _fusioncharts_utils_src_trusted_policy__WEBPACK_IMPORTED_MODULE_4___default.a.createHTML(cur < 10 ? '0' + cur : cur);
            dateLiElements[i].className += SP + classNames.disableddatedefault;
            dateElements[i].className += SP + classNames.disableddate;
            dateLiElements[i].eventAttached && dateLiElements[i].removeEventListener('click', dateElements[i]._clickHandler);
            dateLiElements[i].eventAttached = false;
          } else {
            j = i - monthStaringWeekDay + 1;
            dateElements[i].innerHTML = _fusioncharts_utils_src_trusted_policy__WEBPACK_IMPORTED_MODULE_4___default.a.createHTML(j < 10 ? '0' + j : j);
            highlightInfo = highlightMonth && highlightMonth[j];

            if (highlightInfo) {
              highLightClass = SP + classNames.highlightedDate;
              highlightInfo !== true && (highLightClass += SP + highlightInfo);
              highlightClasses.push(highLightClass);
            }

            !dateLiElements[i].eventAttached && dateLiElements[i].addEventListener('click', dateLiElements[i]._clickHandler);
            dateLiElements[i].eventAttached = true;
            dateElements[i].className += SP + (j <= startInactiveLimit || j >= endInactiveLimit ? classNames.disableddate : classNames.activedate) + (highlightInfo ? highLightClass : BLANK);
            dateLiElements[i].className += SP + (j <= startInactiveLimit || j >= endInactiveLimit ? classNames.disableddatedefault : classNames.normaldatedefault) + (highlightInfo ? highLightClass : BLANK);
          }
        } // if the selected date is on this month, heighlight it


        setSelectedDate(calendar);
      },
          // this function update the day labels
      disPlayDays = function disPlayDays(calendar) {
        var info = calendar.info,
            weekStartingDay = info.weekStartingDay,
            dayElements = calendar.graphic.dayElements;
        var j;

        for (j = 0; j < 7; j++) {
          dayElements[j].innerHTML = _fusioncharts_utils_src_trusted_policy__WEBPACK_IMPORTED_MODULE_4___default.a.createHTML(info.weekLabel[(j + weekStartingDay) % 7]);
        }
      },
          setSelectedDate = function setSelectedDate(calendar) {
        var classNames = calendar.classNames,
            _calendar$info = calendar.info,
            selectedDate = _calendar$info.selectedDate,
            active = _calendar$info.active,
            startingPos = _calendar$info.startingPos,
            _calendar$graphic = calendar.graphic,
            container = _calendar$graphic.container,
            dateLiElements = _calendar$graphic.dateLiElements,
            dateElements = _calendar$graphic.dateElements; // if the selected date is on this month, heighlight it

        if (selectedDate.month === active.month && selectedDate.year === active.year) {
          // remove the class form the old element
          removeClassInChilds(container, classNames.selecteddatedefault);
          removeClassInChilds(container, classNames.selecteddate);
          dateLiElements[selectedDate.day + startingPos - 1].className += SP + classNames.selecteddatedefault;
          dateElements[selectedDate.day + startingPos - 1].className += SP + classNames.selecteddate;
        }
      },
          // function to create dom elements
      createElement = function createElement(type, options) {
        var appendTo = options.appendTo,
            className = options.className,
            inline = options.inline,
            id = options.id,
            innerHTML = options.innerHTML,
            events = options.events,
            element = document.createElement(type); // set the class

        className && (element.className = className); // set inline style of the element

        inline && element.setAttribute('style', inline); // set the attributes

        id && (element.id = id); // add the innerHTML

        innerHTML && (element.innerHTML = innerHTML);

        if (events) {
          for (var event in events) {
            element.addEventListener(event, events[event]);

            if (event === 'click') {
              element['_' + event + 'Handler'] = events[event];
              element.eventAttached = true;
            }
          }
        } // append to it's parent


        appendTo && appendTo.appendChild(element);
        return element;
      },
          // initailise calendar for the first time
      init = function init(calendar, config) {
        var graphic = calendar.graphic,
            weekLabel = calendar.info.weekLabel,
            dateElements = graphic.dateElements,
            dayElements = graphic.dayElements,
            dateLiElements = graphic.dateLiElements,
            fontFamily = config['font-family'] && " font-family: ".concat(config['font-family'], ";") || '',
            classNames = calendar.classNames = Object.assign({}, defaultClassNames, calendar._customCssClass),
            container = graphic.container = createElement('div', {
          appendTo: graphic.parentElement,
          inline: inlineStyle.container + fontFamily,
          className: classNames.container,
          id: calendar.id
        }),
            calendarHeader = graphic.calendarHeader = createElement('div', {
          appendTo: container,
          inline: inlineStyle.header // className: classNames.header

        }),
            headerUl = graphic.headerUl = createElement('ul', {
          appendTo: calendarHeader,
          className: classNames['header-container'],
          inline: 'height: 100% !important;'
        }),
            headerMonthLi = graphic.headerMonthLi = createElement('li', {
          appendTo: headerUl,
          inline: inlineStyle.month
        }),
            headerMonthUl = graphic.headerMonthUl = createElement('ul', {
          appendTo: headerMonthLi,
          className: classNames.header,
          inline: 'height: 100% !important;'
        }),
            calendarSubHeader = graphic.calendarSubHeader = createElement('div', {
          appendTo: container,
          // className: classNames.subHeader,
          inline: inlineStyle.subheader
        }),
            weekDays = graphic.weekDays = createElement('ul', {
          appendTo: calendarSubHeader,
          className: classNames.subheader
        }),
            calendarBody = graphic.calendarBody = createElement('div', {
          appendTo: container,
          inline: inlineStyle.body
        }),
            days = graphic.days = graphic.dayCell = createElement('ul', {
          appendTo: calendarBody,
          inline: 'padding: 1px !important; margin: 0px !important;',
          className: classNames.body
        });
        var element, i, weekend, weekenddefault; // set the container style

        setStyle(container, calendar.style); // set the UL styles

        setStyle(headerUl, ulPadZeroStyle);
        setStyle(weekDays, ulPadZeroStyle);
        setStyle(days, ulPadZeroStyle);
        setStyle(headerMonthUl, ulPadZeroStyle); // li for previous month pointer

        graphic.prevMonth = createElement('li', {
          appendTo: headerMonthUl,
          inline: inlineStyle.nav + SP + inlineStyle.navprev + SP,
          events: {
            click: function click() {
              var info = calendar.info,
                  graphic = calendar.graphic,
                  nextMonth = (info.active && info.active.month) - 1,
                  year = info.active && info.active.year,
                  rangeStart = info.rangeStart;

              if (nextMonth < 1) {
                nextMonth = 12;
                year--;
              }

              if (!rangeStart || year > rangeStart.year) {
                removeClassName(classNames.navinactive, graphic.prevMonth);
                removeClassName(classNames.navinactive, graphic.nextMonth);
                calendar.configure({
                  active: {
                    month: nextMonth,
                    year: year
                  },
                  doNotUpdateStyle: true
                });
              } else if (year === rangeStart.year && nextMonth >= rangeStart.month) {
                removeClassName(classNames.navinactive, graphic.nextMonth);
                nextMonth === rangeStart.month && (graphic.prevMonth.className += SP + classNames.navinactive);
                calendar.configure({
                  active: {
                    month: nextMonth,
                    year: year
                  },
                  doNotUpdateStyle: true
                });
              }
            }
          }
        }); // span containing the left arrow

        graphic.prevMonthPointer = createElement('span', {
          appendTo: graphic.prevMonth,
          className: classNames.navprev,
          innerHTML: _fusioncharts_utils_src_trusted_policy__WEBPACK_IMPORTED_MODULE_4___default.a.createHTML('&#10094;')
        }); // li for month name

        graphic.monthStrLi = createElement('li', {
          appendTo: headerMonthUl,
          inline: inlineStyle.monthname
        }); // span containing the month name

        graphic.monthStr = createElement('span', {
          appendTo: graphic.monthStrLi,
          className: classNames.headername
        }); // li for next month pointer

        graphic.nextMonth = createElement('li', {
          appendTo: headerMonthUl,
          inline: inlineStyle.nav + SP + inlineStyle.navnext + SP,
          events: {
            click: function click() {
              var info = calendar.info,
                  graphic = calendar.graphic,
                  nextMonth = (info.active && info.active.month) + 1,
                  year = info.active && info.active.year,
                  rangeEnd = info.rangeEnd;

              if (nextMonth > 12) {
                nextMonth = 1;
                year++;
              }

              if (!rangeEnd || year < rangeEnd.year) {
                removeClassName(classNames.navinactive, graphic.prevMonth);
                removeClassName(classNames.navinactive, graphic.nextMonth);
                calendar.configure({
                  active: {
                    month: nextMonth,
                    year: year
                  },
                  doNotUpdateStyle: true
                });
              } else if (year === rangeEnd.year && nextMonth <= rangeEnd.month) {
                nextMonth === rangeEnd.month && (graphic.nextMonth.className += SP + classNames.navinactive);
                removeClassName(classNames.navinactive, graphic.prevMonth);
                calendar.configure({
                  active: {
                    month: nextMonth,
                    year: year
                  },
                  doNotUpdateStyle: true
                });
              }
            }
          }
        }); // span containing the right arrow

        graphic.nextMonthPointer = createElement('span', {
          appendTo: graphic.nextMonth,
          className: classNames.navnext,
          innerHTML: _fusioncharts_utils_src_trusted_policy__WEBPACK_IMPORTED_MODULE_4___default.a.createHTML('&#10095;')
        }); // Create the days of week list items

        for (i = 1; i < 8; i++) {
          weekend = SP + (i > 5 ? classNames.weekend : BLANK);
          weekenddefault = SP + (i > 5 ? classNames.weekenddefault : BLANK); // create week elements

          element = createElement('li', {
            appendTo: weekDays,
            inline: inlineStyle.days,
            className: weekenddefault
          });
          element = createElement('span', {
            appendTo: element,
            innerHTML: _fusioncharts_utils_src_trusted_policy__WEBPACK_IMPORTED_MODULE_4___default.a.createHTML(weekLabel[i % 7]),
            inline: 'display: block !important;',
            className: classNames.days + SP + classNames.indexeddays + i % 7 + weekend
          });
          dayElements.push(element);
        } // Create the days of month list items


        var _loop = function _loop(_i) {
          weekenddefault = SP + (_i % 7 === 5 || _i % 7 === 6 ? classNames.weekenddefault : BLANK);
          weekend = SP + (_i % 7 === 5 || _i % 7 === 6 ? classNames.weekend : BLANK); // create date elements

          element = createElement('li', {
            appendTo: days,
            inline: inlineStyle.date,
            className: classNames.dateLI + weekenddefault
          });
          dateLiElements.push(element);
          element = createElement('span', {
            appendTo: element,
            className: classNames.date + SP + classNames.daycol + DASH + _i % 7 + weekend,
            inline: 'display: block !important; padding: 4px 0px !important;',
            innerHTML: _fusioncharts_utils_src_trusted_policy__WEBPACK_IMPORTED_MODULE_4___default.a.createHTML(SPACE),
            events: {
              click: function click() {
                var info = calendar.info,
                    events = calendar.events,
                    selectedDate = info.selectedDate,
                    active = info.active,
                    tempDate = {
                  day: _i - info.startingPos + 1,
                  month: active.month,
                  year: active.year
                };

                if (tempDate.day >= 1 && tempDate.day <= info.curMonthInfo.end - info.startingPos && validateActiveStart(tempDate, info.rangeStart) && validateActiveEnd(tempDate, info.rangeEnd)) {
                  selectedDate.day = tempDate.day;
                  selectedDate.month = tempDate.month;
                  selectedDate.year = tempDate.year;
                  setSelectedDate(calendar);
                  events.onDateChange && events.onDateChange(selectedDate);
                }
              }
            }
          });
          dateElements.push(element);
        };

        for (var _i = 0; _i < 42; _i++) {
          _loop(_i);
        }
      },
          // validate active date
      validateActiveStart = function validateActiveStart(date, start) {
        var day = date.day,
            month = date.month,
            year = date.year;
        return !(start && (start.year > year || start.year === year && (start.month > month || start.month === month && start.day > day)));
      },
          // validate active date
      validateActiveEnd = function validateActiveEnd(date, end) {
        var day = date.day,
            month = date.month,
            year = date.year;
        return !(end && (end.year < year || end.year === year && (end.month < month || end.month === month && end.day < day)));
      },
          toCssString = function toCssString(key, obj) {
        var className = "fc-cal-user-".concat(key),
            css = '';

        for (key in obj) {
          if (obj.hasOwnProperty(key)) {
            css += "".concat(key, ": ").concat(obj[key], "; ");
          }
        }

        return {
          className: className,
          cssString: ".".concat(className, " { ").concat(css, "}")
        };
      },

      /**
       * the api help in segregating the css given in string format or
       * in object format
       */
      separateCssClass = function separateCssClass() {
        var styles = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        var classObj = {},
            styleEle = document.getElementById('fc__calendar__style'),
            sheet = styleEle && styleEle.sheet;

        if (!sheet) {
          return classObj;
        }

        CLASS_PRECEDENCE_SEQUENCE.forEach(function (key) {
          if (styles.hasOwnProperty(key) || defaultCss[key]) {
            var value = styles[key] || defaultCss[key]; // when string is given as the value it will act as class
            // and user is suppose to define the css of the class in his
            // stylesheet

            if (typeof value === 'string') {
              classObj[key] = value;
            } else if (isObject(value)) {
              // the user can pass an object as well
              var _toCssString = toCssString(key, value),
                  className = _toCssString.className,
                  cssString = _toCssString.cssString; // the css for hover does not get return as classname since
              // hover css class gets applied by bowser itself


              !key.endsWith(':hover') && (classObj[key] = className);

              if (!(cssMap.has(className) && cssMap.get(className).cssStr === cssString)) {
                // the css only gets applied if the class contains new configurations
                var rulePos = sheet.cssRules.length;

                if (cssMap.has(className)) {
                  // if the class is already present i the css sheet then that css needs to be
                  // deleted and the new css class with different config willl be added in the
                  // same position to maintain the order
                  rulePos = cssMap.get(className).index;
                  sheet.deleteRule(rulePos);
                }

                cssMap.set(className, {
                  cssStr: cssString,
                  index: rulePos
                });
                sheet.insertRule(cssString, rulePos);
              }
            }
          }
        });
        return classObj;
      }; // calendar constructor


      var Calendar = /*#__PURE__*/function () {
        function Calendar() {
          var config = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

          _classCallCheck(this, Calendar);

          var calendar = this,
              today = new Date(),
              currentDate = {
            day: today.getDate(),
            month: today.getMonth() + 1,
            year: today.getFullYear()
          };
          calendar._customCssClass = {};
          calendar.graphic = {
            parentElement: config.container || document.body,
            dateElements: [],
            dateLiElements: [],
            dayElements: []
          };
          calendar.style = {
            position: 'absolute',
            top: '0px',
            left: '0px',
            width: minWidth + PX,
            // height: minHeight + PX,
            overflow: 'hidden'
          };
          calendar.id = config.id || getuid();
          calendar.events = {};
          calendar.info = {
            selectedDate: currentDate,
            active: {
              month: currentDate.month,
              year: currentDate.year
            },
            weekLabel: [].concat(weekLabel),
            monthLabel: [].concat(monthLabel),
            weekStartingDay: 1,
            posX: 0,
            posY: 0,
            height: minHeight,
            width: minWidth,
            vAlignment: 'top',
            hAlignment: 'left',
            highlightClasses: []
          };
          calendar._customCssClass = separateCssClass(config.customCssClass); // create the elements for first time only

          init(calendar, config); // configure Calendar with initial config

          config.doNotUpdateStyle = true;
          calendar.configure(config, true);
        } // configure calendar


        _createClass(Calendar, [{
          key: "configure",
          value: function configure(config, doRepaint) {
            var calendar = this,
                graphic = calendar.graphic,
                events = calendar.events,
                info = calendar.info,
                style = calendar.style,
                userEvents = config && config.events;
            var parentElement,
                temp,
                positioningChanged = false;

            if (!config) {
              return;
            }

            if (!config.doNotUpdateStyle) {
              calendar._customCssClass = separateCssClass(config.customCssClass);
            }

            calendar.classNames = Object.assign({}, defaultClassNames, calendar._customCssClass); // set container

            if (config.container && (parentElement = document.getElementById(config.container))) {
              graphic.parentElement = parentElement;
              parentElement.appendChild(graphic.container);
            } else if (config.container instanceof Element) {
              graphic.parentElement = config.container;
            } // set User applied styles


            if (config.style && config.style.position) {
              style.position = config.style.position;
              setStyle(graphic.container, style);
            } // applying visual positioning configuraions to the container


            if (!isNaN(temp = Number(config.posX))) {
              info.posX = temp;
              positioningChanged = true;
            }

            if (!isNaN(temp = Number(config.posY))) {
              info.posY = temp;
              positioningChanged = true;
            } // if (!isNaN(temp = Number(config.height)) && temp > minHeight) {
            //   info.height = temp;
            //   style.height = temp + PX;
            //   positioningChanged = true;
            // }


            if (!isNaN(temp = Number(config.width)) && temp > minWidth) {
              info.width = temp;
              style.width = temp + PX;
              positioningChanged = true;
            }

            if (config.vAlignment && (temp = config.vAlignment.toLowerCase()) && vAlignMultiplier[temp] !== UNDEFINED) {
              info.vAlignment = temp;
              positioningChanged = true;
            }

            if (config.hAlignment && (temp = config.hAlignment.toLowerCase()) && hAlignMultiplier[temp] !== UNDEFINED) {
              info.hAlignment = temp;
              positioningChanged = true;
            } // set events on date, month and year change


            if (userEvents) {
              typeof userEvents.onDateChange === 'function' && (events.onDateChange = userEvents.onDateChange);
              typeof userEvents.onYearChange === 'function' && (events.onYearChange = userEvents.onYearChange);
              typeof userEvents.onMonthChange === 'function' && (events.onMonthChange = userEvents.onMonthChange);
            }

            if (config.highlight) {
              info.highlight = config.highlight;
              doRepaint = true;
            } else if (config.highlight === null) {
              delete info.highlight;
              doRepaint = true;
            } // set calendar date


            if ((temp = config.selectedDate) && !isNaN(Date.parse(temp.month + SLASH + temp.day + SLASH + temp.year))) {
              info.selectedDate = config.selectedDate; // update the active month as well

              info.active.month = info.selectedDate.month;
              info.active.year = info.selectedDate.year;
              doRepaint = true;
            }

            if (config.showInactiveMonths !== UNDEFINED) {
              info.showInactiveMonths = !!config.showInactiveMonths;
            } // set active month


            if (config.active) {
              temp = {
                month: config.active.month || info.active.month,
                year: config.active.year || info.active.year
              };

              if ((info.active.month !== temp.month || info.active.year !== temp.year) && (info.showInactiveMonths || validateActiveStart(temp, info.rangeStart) && validateActiveEnd(temp, info.rangeEnd))) {
                info.active.month = temp.month;
                info.active.year = temp.year;
                doRepaint = true;
              }
            } // set month names


            if (config.monthLabel && config.monthLabel.length === 12) {
              info.monthLabel = config.monthLabel;
              doRepaint = true;
            } // set day names


            if (config.weekLabel && config.weekLabel.length === 7) {
              info.weekLabel = config.weekLabel;
              disPlayDays(calendar);
            } // set Starting day of week


            if (config.weekStart !== UNDEFINED && info.weekStartingDay !== config.weekStart) {
              info.weekStartingDay = config.weekStart;
              disPlayDays(calendar);
            } // Set active range start


            if (config.rangeStart && validateActiveStart(info.selectedDate, config.rangeStart)) {
              info.rangeStart = config.rangeStart;
              doRepaint = true;
            } else if (config.rangeStart === null) {
              delete info.rangeStart;
              doRepaint = true;
            } // Set active range end


            if (config.rangeEnd && validateActiveEnd(info.selectedDate, config.rangeEnd)) {
              info.rangeEnd = config.rangeEnd;
              doRepaint = true; // Check whether the old active date is valid or not
            } else if (config.rangeEnd === null) {
              delete info.rangeEnd;
              doRepaint = true;
            } // set calendar to the desired date


            doRepaint && displayMonth(calendar);

            if (positioningChanged) {
              style.left = info.posX + info.width * (hAlignMultiplier[info.hAlignment] || 0) + PX;
              info.height = graphic.container && graphic.container.offsetHeight || minHeight;
              style.top = info.posY + info.height * (vAlignMultiplier[info.vAlignment] || 0) + PX;
              setStyle(graphic.container, style);
            }
          } // call show function show calendar

        }, {
          key: "show",
          value: function show() {
            var calendar = this,
                container = calendar.graphic.container;
            container.style.visibility = 'visible';
            container.style.opacity = '1';
          } // call hide function to hide calendar

        }, {
          key: "hide",
          value: function hide() {
            var calendar = this,
                container = calendar.graphic.container;
            container.style.visibility = 'hidden';
            container.style.opacity = '0';
          } // returns the current or selected date

        }, {
          key: "getDate",
          value: function getDate() {
            return this.info.selectedDate;
          } // add custom funcion on click

        }, {
          key: "addEventListner",
          value: function addEventListner(eventName, handler) {
            typeof handler === 'function' && this.events && (this.events[eventName] = handler);
          } // remove custom funcion on click

        }, {
          key: "removeEventListner",
          value: function removeEventListner(eventName) {
            if (this.events && this.events[eventName]) {
              delete this.events[eventName];
            }
          }
        }, {
          key: "getDimension",
          value: function getDimension() {
            var graphic = this.graphic;
            return {
              width: graphic.container.offsetWidth,
              height: graphic.container.offsetHeight
            };
          } // dispose the dom elements

        }, {
          key: "dispose",
          value: function dispose() {
            var graphic = this.graphic,
                parentElement = graphic.parentElement,
                container = graphic.container;
            parentElement.removeChild(container);
          }
        }]);

        return Calendar;
      }(); // attache to the window if availabel


      if (window) {
        window.FusionCalendar = Calendar;
      }
      /* harmony default export */


      __nested_webpack_exports__["default"] = Calendar;
      /***/
    },
    /* 1 */

    /***/
    function (module, exports, __nested_webpack_require_51517__) {
      module.exports = __nested_webpack_require_51517__(2);
      /***/
    },
    /* 2 */

    /***/
    function (module, exports, __nested_webpack_require_51660__) {
      __nested_webpack_require_51660__(3);

      var entryUnbind = __nested_webpack_require_51660__(52);

      module.exports = entryUnbind('String', 'startsWith');
      /***/
    },
    /* 3 */

    /***/
    function (module, exports, __nested_webpack_require_51897__) {
      "use strict";

      var $ = __nested_webpack_require_51897__(4);

      var toLength = __nested_webpack_require_51897__(41);

      var notARegExp = __nested_webpack_require_51897__(47);

      var requireObjectCoercible = __nested_webpack_require_51897__(15);

      var correctIsRegExpLogic = __nested_webpack_require_51897__(51);

      var nativeStartsWith = ''.startsWith;
      var min = Math.min; // `String.prototype.startsWith` method
      // https://tc39.github.io/ecma262/#sec-string.prototype.startswith

      $({
        target: 'String',
        proto: true,
        forced: !correctIsRegExpLogic('startsWith')
      }, {
        startsWith: function startsWith(searchString
        /* , position = 0 */
        ) {
          var that = String(requireObjectCoercible(this));
          notARegExp(searchString);
          var index = toLength(min(arguments.length > 1 ? arguments[1] : undefined, that.length));
          var search = String(searchString);
          return nativeStartsWith ? nativeStartsWith.call(that, search, index) : that.slice(index, index + search.length) === search;
        }
      });
      /***/
    },
    /* 4 */

    /***/
    function (module, exports, __nested_webpack_require_53060__) {
      var global = __nested_webpack_require_53060__(5);

      var getOwnPropertyDescriptor = __nested_webpack_require_53060__(7).f;

      var hide = __nested_webpack_require_53060__(21);

      var redefine = __nested_webpack_require_53060__(24);

      var setGlobal = __nested_webpack_require_53060__(26);

      var copyConstructorProperties = __nested_webpack_require_53060__(34);

      var isForced = __nested_webpack_require_53060__(46);
      /*
        options.target      - name of the target object
        options.global      - target is the global object
        options.stat        - export as static methods of target
        options.proto       - export as prototype methods of target
        options.real        - real prototype method for the `pure` version
        options.forced      - export even if the native feature is available
        options.bind        - bind methods to the target, required for the `pure` version
        options.wrap        - wrap constructors to preventing global pollution, required for the `pure` version
        options.unsafe      - use the simple assignment of property instead of delete + defineProperty
        options.sham        - add a flag to not completely full polyfills
        options.enumerable  - export as enumerable property
        options.noTargetGet - prevent calling a getter on target
      */


      module.exports = function (options, source) {
        var TARGET = options.target;
        var GLOBAL = options.global;
        var STATIC = options.stat;
        var FORCED, target, key, targetProperty, sourceProperty, descriptor;

        if (GLOBAL) {
          target = global;
        } else if (STATIC) {
          target = global[TARGET] || setGlobal(TARGET, {});
        } else {
          target = (global[TARGET] || {}).prototype;
        }

        if (target) for (key in source) {
          sourceProperty = source[key];

          if (options.noTargetGet) {
            descriptor = getOwnPropertyDescriptor(target, key);
            targetProperty = descriptor && descriptor.value;
          } else targetProperty = target[key];

          FORCED = isForced(GLOBAL ? key : TARGET + (STATIC ? '.' : '#') + key, options.forced); // contained in target

          if (!FORCED && targetProperty !== undefined) {
            if (typeof sourceProperty === typeof targetProperty) continue;
            copyConstructorProperties(sourceProperty, targetProperty);
          } // add a flag to not completely full polyfills


          if (options.sham || targetProperty && targetProperty.sham) {
            hide(sourceProperty, 'sham', true);
          } // extend global


          redefine(target, key, sourceProperty, options);
        }
      };
      /***/

    },
    /* 5 */

    /***/
    function (module, exports, __nested_webpack_require_55799__) {
      /* WEBPACK VAR INJECTION */
      (function (global) {
        var O = 'object';

        var check = function check(it) {
          return it && it.Math == Math && it;
        }; // https://github.com/zloirock/core-js/issues/86#issuecomment-115759028


        module.exports = // eslint-disable-next-line no-undef
        check(typeof globalThis == O && globalThis) || check(typeof window == O && window) || check(typeof self == O && self) || check(typeof global == O && global) || // eslint-disable-next-line no-new-func
        Function('return this')();
        /* WEBPACK VAR INJECTION */
      }).call(this, __nested_webpack_require_55799__(6));
      /***/
    },
    /* 6 */

    /***/
    function (module, exports) {
      var g; // This works in non-strict mode

      g = function () {
        return this;
      }();

      try {
        // This works if eval is allowed (see CSP)
        g = g || new Function("return this")();
      } catch (e) {
        // This works if the window reference is available
        if (typeof window === "object") g = window;
      } // g can still be undefined, but nothing to do about it...
      // We return undefined, instead of nothing here, so it's
      // easier to handle this case. if(!global) { ...}


      module.exports = g;
      /***/
    },
    /* 7 */

    /***/
    function (module, exports, __nested_webpack_require_57176__) {
      var DESCRIPTORS = __nested_webpack_require_57176__(8);

      var propertyIsEnumerableModule = __nested_webpack_require_57176__(10);

      var createPropertyDescriptor = __nested_webpack_require_57176__(11);

      var toIndexedObject = __nested_webpack_require_57176__(12);

      var toPrimitive = __nested_webpack_require_57176__(16);

      var has = __nested_webpack_require_57176__(18);

      var IE8_DOM_DEFINE = __nested_webpack_require_57176__(19);

      var nativeGetOwnPropertyDescriptor = Object.getOwnPropertyDescriptor; // `Object.getOwnPropertyDescriptor` method
      // https://tc39.github.io/ecma262/#sec-object.getownpropertydescriptor

      exports.f = DESCRIPTORS ? nativeGetOwnPropertyDescriptor : function getOwnPropertyDescriptor(O, P) {
        O = toIndexedObject(O);
        P = toPrimitive(P, true);
        if (IE8_DOM_DEFINE) try {
          return nativeGetOwnPropertyDescriptor(O, P);
        } catch (error) {
          /* empty */
        }
        if (has(O, P)) return createPropertyDescriptor(!propertyIsEnumerableModule.f.call(O, P), O[P]);
      };
      /***/
    },
    /* 8 */

    /***/
    function (module, exports, __nested_webpack_require_58279__) {
      var fails = __nested_webpack_require_58279__(9); // Thank's IE8 for his funny defineProperty


      module.exports = !fails(function () {
        return Object.defineProperty({}, 'a', {
          get: function get() {
            return 7;
          }
        }).a != 7;
      });
      /***/
    },
    /* 9 */

    /***/
    function (module, exports) {
      module.exports = function (exec) {
        try {
          return !!exec();
        } catch (error) {
          return true;
        }
      };
      /***/

    },
    /* 10 */

    /***/
    function (module, exports, __webpack_require__) {
      "use strict";

      var nativePropertyIsEnumerable = {}.propertyIsEnumerable;
      var getOwnPropertyDescriptor = Object.getOwnPropertyDescriptor; // Nashorn ~ JDK8 bug

      var NASHORN_BUG = getOwnPropertyDescriptor && !nativePropertyIsEnumerable.call({
        1: 2
      }, 1); // `Object.prototype.propertyIsEnumerable` method implementation
      // https://tc39.github.io/ecma262/#sec-object.prototype.propertyisenumerable

      exports.f = NASHORN_BUG ? function propertyIsEnumerable(V) {
        var descriptor = getOwnPropertyDescriptor(this, V);
        return !!descriptor && descriptor.enumerable;
      } : nativePropertyIsEnumerable;
      /***/
    },
    /* 11 */

    /***/
    function (module, exports) {
      module.exports = function (bitmap, value) {
        return {
          enumerable: !(bitmap & 1),
          configurable: !(bitmap & 2),
          writable: !(bitmap & 4),
          value: value
        };
      };
      /***/

    },
    /* 12 */

    /***/
    function (module, exports, __nested_webpack_require_59931__) {
      // toObject with fallback for non-array-like ES3 strings
      var IndexedObject = __nested_webpack_require_59931__(13);

      var requireObjectCoercible = __nested_webpack_require_59931__(15);

      module.exports = function (it) {
        return IndexedObject(requireObjectCoercible(it));
      };
      /***/

    },
    /* 13 */

    /***/
    function (module, exports, __nested_webpack_require_60311__) {
      var fails = __nested_webpack_require_60311__(9);

      var classof = __nested_webpack_require_60311__(14);

      var split = ''.split; // fallback for non-array-like ES3 and non-enumerable old V8 strings

      module.exports = fails(function () {
        // throws an error in rhino, see https://github.com/mozilla/rhino/issues/346
        // eslint-disable-next-line no-prototype-builtins
        return !Object('z').propertyIsEnumerable(0);
      }) ? function (it) {
        return classof(it) == 'String' ? split.call(it, '') : Object(it);
      } : Object;
      /***/
    },
    /* 14 */

    /***/
    function (module, exports) {
      var toString = {}.toString;

      module.exports = function (it) {
        return toString.call(it).slice(8, -1);
      };
      /***/

    },
    /* 15 */

    /***/
    function (module, exports) {
      // `RequireObjectCoercible` abstract operation
      // https://tc39.github.io/ecma262/#sec-requireobjectcoercible
      module.exports = function (it) {
        if (it == undefined) throw TypeError("Can't call method on " + it);
        return it;
      };
      /***/

    },
    /* 16 */

    /***/
    function (module, exports, __nested_webpack_require_61501__) {
      var isObject = __nested_webpack_require_61501__(17); // `ToPrimitive` abstract operation
      // https://tc39.github.io/ecma262/#sec-toprimitive
      // instead of the ES6 spec version, we didn't implement @@toPrimitive case
      // and the second argument - flag - preferred type is a string


      module.exports = function (input, PREFERRED_STRING) {
        if (!isObject(input)) return input;
        var fn, val;
        if (PREFERRED_STRING && typeof (fn = input.toString) == 'function' && !isObject(val = fn.call(input))) return val;
        if (typeof (fn = input.valueOf) == 'function' && !isObject(val = fn.call(input))) return val;
        if (!PREFERRED_STRING && typeof (fn = input.toString) == 'function' && !isObject(val = fn.call(input))) return val;
        throw TypeError("Can't convert object to primitive value");
      };
      /***/

    },
    /* 17 */

    /***/
    function (module, exports) {
      module.exports = function (it) {
        return typeof it === 'object' ? it !== null : typeof it === 'function';
      };
      /***/

    },
    /* 18 */

    /***/
    function (module, exports) {
      var hasOwnProperty = {}.hasOwnProperty;

      module.exports = function (it, key) {
        return hasOwnProperty.call(it, key);
      };
      /***/

    },
    /* 19 */

    /***/
    function (module, exports, __nested_webpack_require_62868__) {
      var DESCRIPTORS = __nested_webpack_require_62868__(8);

      var fails = __nested_webpack_require_62868__(9);

      var createElement = __nested_webpack_require_62868__(20); // Thank's IE8 for his funny defineProperty


      module.exports = !DESCRIPTORS && !fails(function () {
        return Object.defineProperty(createElement('div'), 'a', {
          get: function get() {
            return 7;
          }
        }).a != 7;
      });
      /***/
    },
    /* 20 */

    /***/
    function (module, exports, __nested_webpack_require_63375__) {
      var global = __nested_webpack_require_63375__(5);

      var isObject = __nested_webpack_require_63375__(17);

      var document = global.document; // typeof document.createElement is 'object' in old IE

      var EXISTS = isObject(document) && isObject(document.createElement);

      module.exports = function (it) {
        return EXISTS ? document.createElement(it) : {};
      };
      /***/

    },
    /* 21 */

    /***/
    function (module, exports, __nested_webpack_require_63839__) {
      var DESCRIPTORS = __nested_webpack_require_63839__(8);

      var definePropertyModule = __nested_webpack_require_63839__(22);

      var createPropertyDescriptor = __nested_webpack_require_63839__(11);

      module.exports = DESCRIPTORS ? function (object, key, value) {
        return definePropertyModule.f(object, key, createPropertyDescriptor(1, value));
      } : function (object, key, value) {
        object[key] = value;
        return object;
      };
      /***/
    },
    /* 22 */

    /***/
    function (module, exports, __nested_webpack_require_64367__) {
      var DESCRIPTORS = __nested_webpack_require_64367__(8);

      var IE8_DOM_DEFINE = __nested_webpack_require_64367__(19);

      var anObject = __nested_webpack_require_64367__(23);

      var toPrimitive = __nested_webpack_require_64367__(16);

      var nativeDefineProperty = Object.defineProperty; // `Object.defineProperty` method
      // https://tc39.github.io/ecma262/#sec-object.defineproperty

      exports.f = DESCRIPTORS ? nativeDefineProperty : function defineProperty(O, P, Attributes) {
        anObject(O);
        P = toPrimitive(P, true);
        anObject(Attributes);
        if (IE8_DOM_DEFINE) try {
          return nativeDefineProperty(O, P, Attributes);
        } catch (error) {
          /* empty */
        }
        if ('get' in Attributes || 'set' in Attributes) throw TypeError('Accessors not supported');
        if ('value' in Attributes) O[P] = Attributes.value;
        return O;
      };
      /***/
    },
    /* 23 */

    /***/
    function (module, exports, __nested_webpack_require_65341__) {
      var isObject = __nested_webpack_require_65341__(17);

      module.exports = function (it) {
        if (!isObject(it)) {
          throw TypeError(String(it) + ' is not an object');
        }

        return it;
      };
      /***/

    },
    /* 24 */

    /***/
    function (module, exports, __nested_webpack_require_65654__) {
      var global = __nested_webpack_require_65654__(5);

      var shared = __nested_webpack_require_65654__(25);

      var hide = __nested_webpack_require_65654__(21);

      var has = __nested_webpack_require_65654__(18);

      var setGlobal = __nested_webpack_require_65654__(26);

      var nativeFunctionToString = __nested_webpack_require_65654__(28);

      var InternalStateModule = __nested_webpack_require_65654__(29);

      var getInternalState = InternalStateModule.get;
      var enforceInternalState = InternalStateModule.enforce;
      var TEMPLATE = String(nativeFunctionToString).split('toString');
      shared('inspectSource', function (it) {
        return nativeFunctionToString.call(it);
      });
      (module.exports = function (O, key, value, options) {
        var unsafe = options ? !!options.unsafe : false;
        var simple = options ? !!options.enumerable : false;
        var noTargetGet = options ? !!options.noTargetGet : false;

        if (typeof value == 'function') {
          if (typeof key == 'string' && !has(value, 'name')) hide(value, 'name', key);
          enforceInternalState(value).source = TEMPLATE.join(typeof key == 'string' ? key : '');
        }

        if (O === global) {
          if (simple) O[key] = value;else setGlobal(key, value);
          return;
        } else if (!unsafe) {
          delete O[key];
        } else if (!noTargetGet && O[key]) {
          simple = true;
        }

        if (simple) O[key] = value;else hide(O, key, value); // add fake Function#toString for correct work wrapped methods / constructors with methods like LoDash isNative
      })(Function.prototype, 'toString', function toString() {
        return typeof this == 'function' && getInternalState(this).source || nativeFunctionToString.call(this);
      });
      /***/
    },
    /* 25 */

    /***/
    function (module, exports, __nested_webpack_require_67471__) {
      var global = __nested_webpack_require_67471__(5);

      var setGlobal = __nested_webpack_require_67471__(26);

      var IS_PURE = __nested_webpack_require_67471__(27);

      var SHARED = '__core-js_shared__';
      var store = global[SHARED] || setGlobal(SHARED, {});
      (module.exports = function (key, value) {
        return store[key] || (store[key] = value !== undefined ? value : {});
      })('versions', []).push({
        version: '3.1.3',
        mode: IS_PURE ? 'pure' : 'global',
        copyright: '© 2019 Denis Pushkarev (zloirock.ru)'
      });
      /***/
    },
    /* 26 */

    /***/
    function (module, exports, __nested_webpack_require_68101__) {
      var global = __nested_webpack_require_68101__(5);

      var hide = __nested_webpack_require_68101__(21);

      module.exports = function (key, value) {
        try {
          hide(global, key, value);
        } catch (error) {
          global[key] = value;
        }

        return value;
      };
      /***/

    },
    /* 27 */

    /***/
    function (module, exports) {
      module.exports = false;
      /***/
    },
    /* 28 */

    /***/
    function (module, exports, __nested_webpack_require_68588__) {
      var shared = __nested_webpack_require_68588__(25);

      module.exports = shared('native-function-to-string', Function.toString);
      /***/
    },
    /* 29 */

    /***/
    function (module, exports, __nested_webpack_require_68809__) {
      var NATIVE_WEAK_MAP = __nested_webpack_require_68809__(30);

      var global = __nested_webpack_require_68809__(5);

      var isObject = __nested_webpack_require_68809__(17);

      var hide = __nested_webpack_require_68809__(21);

      var objectHas = __nested_webpack_require_68809__(18);

      var sharedKey = __nested_webpack_require_68809__(31);

      var hiddenKeys = __nested_webpack_require_68809__(33);

      var WeakMap = global.WeakMap;
      var set, get, has;

      var enforce = function enforce(it) {
        return has(it) ? get(it) : set(it, {});
      };

      var getterFor = function getterFor(TYPE) {
        return function (it) {
          var state;

          if (!isObject(it) || (state = get(it)).type !== TYPE) {
            throw TypeError('Incompatible receiver, ' + TYPE + ' required');
          }

          return state;
        };
      };

      if (NATIVE_WEAK_MAP) {
        var store = new WeakMap();
        var wmget = store.get;
        var wmhas = store.has;
        var wmset = store.set;

        set = function set(it, metadata) {
          wmset.call(store, it, metadata);
          return metadata;
        };

        get = function get(it) {
          return wmget.call(store, it) || {};
        };

        has = function has(it) {
          return wmhas.call(store, it);
        };
      } else {
        var STATE = sharedKey('state');
        hiddenKeys[STATE] = true;

        set = function set(it, metadata) {
          hide(it, STATE, metadata);
          return metadata;
        };

        get = function get(it) {
          return objectHas(it, STATE) ? it[STATE] : {};
        };

        has = function has(it) {
          return objectHas(it, STATE);
        };
      }

      module.exports = {
        set: set,
        get: get,
        has: has,
        enforce: enforce,
        getterFor: getterFor
      };
      /***/
    },
    /* 30 */

    /***/
    function (module, exports, __nested_webpack_require_70708__) {
      var global = __nested_webpack_require_70708__(5);

      var nativeFunctionToString = __nested_webpack_require_70708__(28);

      var WeakMap = global.WeakMap;
      module.exports = typeof WeakMap === 'function' && /native code/.test(nativeFunctionToString.call(WeakMap));
      /***/
    },
    /* 31 */

    /***/
    function (module, exports, __nested_webpack_require_71060__) {
      var shared = __nested_webpack_require_71060__(25);

      var uid = __nested_webpack_require_71060__(32);

      var keys = shared('keys');

      module.exports = function (key) {
        return keys[key] || (keys[key] = uid(key));
      };
      /***/

    },
    /* 32 */

    /***/
    function (module, exports) {
      var id = 0;
      var postfix = Math.random();

      module.exports = function (key) {
        return 'Symbol(' + String(key === undefined ? '' : key) + ')_' + (++id + postfix).toString(36);
      };
      /***/

    },
    /* 33 */

    /***/
    function (module, exports) {
      module.exports = {};
      /***/
    },
    /* 34 */

    /***/
    function (module, exports, __nested_webpack_require_71767__) {
      var has = __nested_webpack_require_71767__(18);

      var ownKeys = __nested_webpack_require_71767__(35);

      var getOwnPropertyDescriptorModule = __nested_webpack_require_71767__(7);

      var definePropertyModule = __nested_webpack_require_71767__(22);

      module.exports = function (target, source) {
        var keys = ownKeys(source);
        var defineProperty = definePropertyModule.f;
        var getOwnPropertyDescriptor = getOwnPropertyDescriptorModule.f;

        for (var i = 0; i < keys.length; i++) {
          var key = keys[i];
          if (!has(target, key)) defineProperty(target, key, getOwnPropertyDescriptor(source, key));
        }
      };
      /***/

    },
    /* 35 */

    /***/
    function (module, exports, __nested_webpack_require_72491__) {
      var getBuiltIn = __nested_webpack_require_72491__(36);

      var getOwnPropertyNamesModule = __nested_webpack_require_72491__(38);

      var getOwnPropertySymbolsModule = __nested_webpack_require_72491__(45);

      var anObject = __nested_webpack_require_72491__(23); // all object keys, includes non-enumerable and symbols


      module.exports = getBuiltIn('Reflect', 'ownKeys') || function ownKeys(it) {
        var keys = getOwnPropertyNamesModule.f(anObject(it));
        var getOwnPropertySymbols = getOwnPropertySymbolsModule.f;
        return getOwnPropertySymbols ? keys.concat(getOwnPropertySymbols(it)) : keys;
      };
      /***/

    },
    /* 36 */

    /***/
    function (module, exports, __nested_webpack_require_73178__) {
      var path = __nested_webpack_require_73178__(37);

      var global = __nested_webpack_require_73178__(5);

      var aFunction = function aFunction(variable) {
        return typeof variable == 'function' ? variable : undefined;
      };

      module.exports = function (namespace, method) {
        return arguments.length < 2 ? aFunction(path[namespace]) || aFunction(global[namespace]) : path[namespace] && path[namespace][method] || global[namespace] && global[namespace][method];
      };
      /***/

    },
    /* 37 */

    /***/
    function (module, exports, __nested_webpack_require_73751__) {
      module.exports = __nested_webpack_require_73751__(5);
      /***/
    },
    /* 38 */

    /***/
    function (module, exports, __nested_webpack_require_73895__) {
      var internalObjectKeys = __nested_webpack_require_73895__(39);

      var enumBugKeys = __nested_webpack_require_73895__(44);

      var hiddenKeys = enumBugKeys.concat('length', 'prototype'); // `Object.getOwnPropertyNames` method
      // https://tc39.github.io/ecma262/#sec-object.getownpropertynames

      exports.f = Object.getOwnPropertyNames || function getOwnPropertyNames(O) {
        return internalObjectKeys(O, hiddenKeys);
      };
      /***/

    },
    /* 39 */

    /***/
    function (module, exports, __nested_webpack_require_74419__) {
      var has = __nested_webpack_require_74419__(18);

      var toIndexedObject = __nested_webpack_require_74419__(12);

      var indexOf = __nested_webpack_require_74419__(40).indexOf;

      var hiddenKeys = __nested_webpack_require_74419__(33);

      module.exports = function (object, names) {
        var O = toIndexedObject(object);
        var i = 0;
        var result = [];
        var key;

        for (key in O) {
          !has(hiddenKeys, key) && has(O, key) && result.push(key);
        } // Don't enum bug & hidden keys


        while (names.length > i) {
          if (has(O, key = names[i++])) {
            ~indexOf(result, key) || result.push(key);
          }
        }

        return result;
      };
      /***/

    },
    /* 40 */

    /***/
    function (module, exports, __nested_webpack_require_75193__) {
      var toIndexedObject = __nested_webpack_require_75193__(12);

      var toLength = __nested_webpack_require_75193__(41);

      var toAbsoluteIndex = __nested_webpack_require_75193__(43); // `Array.prototype.{ indexOf, includes }` methods implementation


      var createMethod = function createMethod(IS_INCLUDES) {
        return function ($this, el, fromIndex) {
          var O = toIndexedObject($this);
          var length = toLength(O.length);
          var index = toAbsoluteIndex(fromIndex, length);
          var value; // Array#includes uses SameValueZero equality algorithm
          // eslint-disable-next-line no-self-compare

          if (IS_INCLUDES && el != el) while (length > index) {
            value = O[index++]; // eslint-disable-next-line no-self-compare

            if (value != value) return true; // Array#indexOf ignores holes, Array#includes - not
          } else for (; length > index; index++) {
            if ((IS_INCLUDES || index in O) && O[index] === el) return IS_INCLUDES || index || 0;
          }
          return !IS_INCLUDES && -1;
        };
      };

      module.exports = {
        // `Array.prototype.includes` method
        // https://tc39.github.io/ecma262/#sec-array.prototype.includes
        includes: createMethod(true),
        // `Array.prototype.indexOf` method
        // https://tc39.github.io/ecma262/#sec-array.prototype.indexof
        indexOf: createMethod(false)
      };
      /***/
    },
    /* 41 */

    /***/
    function (module, exports, __nested_webpack_require_76697__) {
      var toInteger = __nested_webpack_require_76697__(42);

      var min = Math.min; // `ToLength` abstract operation
      // https://tc39.github.io/ecma262/#sec-tolength

      module.exports = function (argument) {
        return argument > 0 ? min(toInteger(argument), 0x1FFFFFFFFFFFFF) : 0; // 2 ** 53 - 1 == 9007199254740991
      };
      /***/

    },
    /* 42 */

    /***/
    function (module, exports) {
      var ceil = Math.ceil;
      var floor = Math.floor; // `ToInteger` abstract operation
      // https://tc39.github.io/ecma262/#sec-tointeger

      module.exports = function (argument) {
        return isNaN(argument = +argument) ? 0 : (argument > 0 ? floor : ceil)(argument);
      };
      /***/

    },
    /* 43 */

    /***/
    function (module, exports, __nested_webpack_require_77493__) {
      var toInteger = __nested_webpack_require_77493__(42);

      var max = Math.max;
      var min = Math.min; // Helper for a popular repeating case of the spec:
      // Let integer be ? ToInteger(index).
      // If integer < 0, let result be max((length + integer), 0); else let result be min(length, length).

      module.exports = function (index, length) {
        var integer = toInteger(index);
        return integer < 0 ? max(integer + length, 0) : min(integer, length);
      };
      /***/

    },
    /* 44 */

    /***/
    function (module, exports) {
      // IE8- don't enum bug keys
      module.exports = ['constructor', 'hasOwnProperty', 'isPrototypeOf', 'propertyIsEnumerable', 'toLocaleString', 'toString', 'valueOf'];
      /***/
    },
    /* 45 */

    /***/
    function (module, exports) {
      exports.f = Object.getOwnPropertySymbols;
      /***/
    },
    /* 46 */

    /***/
    function (module, exports, __nested_webpack_require_78446__) {
      var fails = __nested_webpack_require_78446__(9);

      var replacement = /#|\.prototype\./;

      var isForced = function isForced(feature, detection) {
        var value = data[normalize(feature)];
        return value == POLYFILL ? true : value == NATIVE ? false : typeof detection == 'function' ? fails(detection) : !!detection;
      };

      var normalize = isForced.normalize = function (string) {
        return String(string).replace(replacement, '.').toLowerCase();
      };

      var data = isForced.data = {};
      var NATIVE = isForced.NATIVE = 'N';
      var POLYFILL = isForced.POLYFILL = 'P';
      module.exports = isForced;
      /***/
    },
    /* 47 */

    /***/
    function (module, exports, __nested_webpack_require_79182__) {
      var isRegExp = __nested_webpack_require_79182__(48);

      module.exports = function (it) {
        if (isRegExp(it)) {
          throw TypeError("The method doesn't accept regular expressions");
        }

        return it;
      };
      /***/

    },
    /* 48 */

    /***/
    function (module, exports, __nested_webpack_require_79509__) {
      var isObject = __nested_webpack_require_79509__(17);

      var classof = __nested_webpack_require_79509__(14);

      var wellKnownSymbol = __nested_webpack_require_79509__(49);

      var MATCH = wellKnownSymbol('match'); // `IsRegExp` abstract operation
      // https://tc39.github.io/ecma262/#sec-isregexp

      module.exports = function (it) {
        var isRegExp;
        return isObject(it) && ((isRegExp = it[MATCH]) !== undefined ? !!isRegExp : classof(it) == 'RegExp');
      };
      /***/

    },
    /* 49 */

    /***/
    function (module, exports, __nested_webpack_require_80066__) {
      var global = __nested_webpack_require_80066__(5);

      var shared = __nested_webpack_require_80066__(25);

      var uid = __nested_webpack_require_80066__(32);

      var NATIVE_SYMBOL = __nested_webpack_require_80066__(50);

      var Symbol = global.Symbol;
      var store = shared('wks');

      module.exports = function (name) {
        return store[name] || (store[name] = NATIVE_SYMBOL && Symbol[name] || (NATIVE_SYMBOL ? Symbol : uid)('Symbol.' + name));
      };
      /***/

    },
    /* 50 */

    /***/
    function (module, exports, __nested_webpack_require_80594__) {
      var fails = __nested_webpack_require_80594__(9);

      module.exports = !!Object.getOwnPropertySymbols && !fails(function () {
        // Chrome 38 Symbol has incorrect toString conversion
        // eslint-disable-next-line no-undef
        return !String(Symbol());
      });
      /***/
    },
    /* 51 */

    /***/
    function (module, exports, __nested_webpack_require_80963__) {
      var wellKnownSymbol = __nested_webpack_require_80963__(49);

      var MATCH = wellKnownSymbol('match');

      module.exports = function (METHOD_NAME) {
        var regexp = /./;

        try {
          '/./'[METHOD_NAME](regexp);
        } catch (e) {
          try {
            regexp[MATCH] = false;
            return '/./'[METHOD_NAME](regexp);
          } catch (f) {
            /* empty */
          }
        }

        return false;
      };
      /***/

    },
    /* 52 */

    /***/
    function (module, exports, __nested_webpack_require_81509__) {
      var global = __nested_webpack_require_81509__(5);

      var bind = __nested_webpack_require_81509__(53);

      var call = Function.call;

      module.exports = function (CONSTRUCTOR, METHOD, length) {
        return bind(call, global[CONSTRUCTOR].prototype[METHOD], length);
      };
      /***/

    },
    /* 53 */

    /***/
    function (module, exports, __nested_webpack_require_81874__) {
      var aFunction = __nested_webpack_require_81874__(54); // optional / simple context binding


      module.exports = function (fn, that, length) {
        aFunction(fn);
        if (that === undefined) return fn;

        switch (length) {
          case 0:
            return function () {
              return fn.call(that);
            };

          case 1:
            return function (a) {
              return fn.call(that, a);
            };

          case 2:
            return function (a, b) {
              return fn.call(that, a, b);
            };

          case 3:
            return function (a, b, c) {
              return fn.call(that, a, b, c);
            };
        }

        return function ()
        /* ...args */
        {
          return fn.apply(that, arguments);
        };
      };
      /***/

    },
    /* 54 */

    /***/
    function (module, exports) {
      module.exports = function (it) {
        if (typeof it != 'function') {
          throw TypeError(String(it) + ' is not a function');
        }

        return it;
      };
      /***/

    },
    /* 55 */

    /***/
    function (module, exports, __nested_webpack_require_83035__) {
      module.exports = __nested_webpack_require_83035__(56);
      /***/
    },
    /* 56 */

    /***/
    function (module, exports, __nested_webpack_require_83180__) {
      __nested_webpack_require_83180__(57);

      var entryUnbind = __nested_webpack_require_83180__(52);

      module.exports = entryUnbind('String', 'endsWith');
      /***/
    },
    /* 57 */

    /***/
    function (module, exports, __nested_webpack_require_83417__) {
      "use strict";

      var $ = __nested_webpack_require_83417__(4);

      var toLength = __nested_webpack_require_83417__(41);

      var notARegExp = __nested_webpack_require_83417__(47);

      var requireObjectCoercible = __nested_webpack_require_83417__(15);

      var correctIsRegExpLogic = __nested_webpack_require_83417__(51);

      var nativeEndsWith = ''.endsWith;
      var min = Math.min; // `String.prototype.endsWith` method
      // https://tc39.github.io/ecma262/#sec-string.prototype.endswith

      $({
        target: 'String',
        proto: true,
        forced: !correctIsRegExpLogic('endsWith')
      }, {
        endsWith: function endsWith(searchString
        /* , endPosition = @length */
        ) {
          var that = String(requireObjectCoercible(this));
          notARegExp(searchString);
          var endPosition = arguments.length > 1 ? arguments[1] : undefined;
          var len = toLength(that.length);
          var end = endPosition === undefined ? len : min(toLength(endPosition), len);
          var search = String(searchString);
          return nativeEndsWith ? nativeEndsWith.call(that, search, end) : that.slice(end - search.length, end) === search;
        }
      });
      /***/
    },
    /* 58 */

    /***/
    function (module, exports, __nested_webpack_require_84674__) {
      module.exports = __nested_webpack_require_84674__(59);
      /***/
    },
    /* 59 */

    /***/
    function (module, exports, __nested_webpack_require_84819__) {
      __nested_webpack_require_84819__(60);

      var path = __nested_webpack_require_84819__(37);

      module.exports = path.Object.assign;
      /***/
    },
    /* 60 */

    /***/
    function (module, exports, __nested_webpack_require_85034__) {
      var $ = __nested_webpack_require_85034__(4);

      var assign = __nested_webpack_require_85034__(61); // `Object.assign` method
      // https://tc39.github.io/ecma262/#sec-object.assign


      $({
        target: 'Object',
        stat: true,
        forced: Object.assign !== assign
      }, {
        assign: assign
      });
      /***/
    },
    /* 61 */

    /***/
    function (module, exports, __nested_webpack_require_85442__) {
      "use strict";

      var DESCRIPTORS = __nested_webpack_require_85442__(8);

      var fails = __nested_webpack_require_85442__(9);

      var objectKeys = __nested_webpack_require_85442__(62);

      var getOwnPropertySymbolsModule = __nested_webpack_require_85442__(45);

      var propertyIsEnumerableModule = __nested_webpack_require_85442__(10);

      var toObject = __nested_webpack_require_85442__(63);

      var IndexedObject = __nested_webpack_require_85442__(13);

      var nativeAssign = Object.assign; // `Object.assign` method
      // https://tc39.github.io/ecma262/#sec-object.assign
      // should work with symbols and should have deterministic property order (V8 bug)

      module.exports = !nativeAssign || fails(function () {
        var A = {};
        var B = {}; // eslint-disable-next-line no-undef

        var symbol = Symbol();
        var alphabet = 'abcdefghijklmnopqrst';
        A[symbol] = 7;
        alphabet.split('').forEach(function (chr) {
          B[chr] = chr;
        });
        return nativeAssign({}, A)[symbol] != 7 || objectKeys(nativeAssign({}, B)).join('') != alphabet;
      }) ? function assign(target, source) {
        // eslint-disable-line no-unused-vars
        var T = toObject(target);
        var argumentsLength = arguments.length;
        var index = 1;
        var getOwnPropertySymbols = getOwnPropertySymbolsModule.f;
        var propertyIsEnumerable = propertyIsEnumerableModule.f;

        while (argumentsLength > index) {
          var S = IndexedObject(arguments[index++]);
          var keys = getOwnPropertySymbols ? objectKeys(S).concat(getOwnPropertySymbols(S)) : objectKeys(S);
          var length = keys.length;
          var j = 0;
          var key;

          while (length > j) {
            key = keys[j++];
            if (!DESCRIPTORS || propertyIsEnumerable.call(S, key)) T[key] = S[key];
          }
        }

        return T;
      } : nativeAssign;
      /***/
    },
    /* 62 */

    /***/
    function (module, exports, __nested_webpack_require_87396__) {
      var internalObjectKeys = __nested_webpack_require_87396__(39);

      var enumBugKeys = __nested_webpack_require_87396__(44); // `Object.keys` method
      // https://tc39.github.io/ecma262/#sec-object.keys


      module.exports = Object.keys || function keys(O) {
        return internalObjectKeys(O, enumBugKeys);
      };
      /***/

    },
    /* 63 */

    /***/
    function (module, exports, __nested_webpack_require_87800__) {
      var requireObjectCoercible = __nested_webpack_require_87800__(15); // `ToObject` abstract operation
      // https://tc39.github.io/ecma262/#sec-toobject


      module.exports = function (argument) {
        return Object(requireObjectCoercible(argument));
      };
      /***/

    },
    /* 64 */

    /***/
    function (module, exports, __nested_webpack_require_88158__) {
      var content = __nested_webpack_require_88158__(65);

      if (typeof content === 'string') content = [[module.i, content, '']];
      var transform;
      var insertInto;
      var options = {
        "attrs": {
          "id": "fc__calendar__style"
        },
        "hmr": true
      };
      options.transform = transform;
      options.insertInto = undefined;

      var update = __nested_webpack_require_88158__(67)(content, options);

      if (content.locals) module.exports = content.locals;

      if (false) {}
      /***/

    },
    /* 65 */

    /***/
    function (module, exports, __nested_webpack_require_88759__) {
      exports = module.exports = __nested_webpack_require_88759__(66)(false); // Module

      exports.push([module.i, "", ""]);
      /***/
    },
    /* 66 */

    /***/
    function (module, exports, __webpack_require__) {
      "use strict";
      /*
        MIT License http://www.opensource.org/licenses/mit-license.php
        Author Tobias Koppers @sokra
      */
      // css base code, injected by the css-loader
      // eslint-disable-next-line func-names

      module.exports = function (useSourceMap) {
        var list = []; // return the list of modules as css string

        list.toString = function toString() {
          return this.map(function (item) {
            var content = cssWithMappingToString(item, useSourceMap);

            if (item[2]) {
              return "@media ".concat(item[2], "{").concat(content, "}");
            }

            return content;
          }).join('');
        }; // import a list of modules into the list
        // eslint-disable-next-line func-names


        list.i = function (modules, mediaQuery) {
          if (typeof modules === 'string') {
            // eslint-disable-next-line no-param-reassign
            modules = [[null, modules, '']];
          }

          var alreadyImportedModules = {};

          for (var i = 0; i < this.length; i++) {
            // eslint-disable-next-line prefer-destructuring
            var id = this[i][0];

            if (id != null) {
              alreadyImportedModules[id] = true;
            }
          }

          for (var _i = 0; _i < modules.length; _i++) {
            var item = modules[_i]; // skip already imported module
            // this implementation is not 100% perfect for weird media query combinations
            // when a module is imported multiple times with different media queries.
            // I hope this will never occur (Hey this way we have smaller bundles)

            if (item[0] == null || !alreadyImportedModules[item[0]]) {
              if (mediaQuery && !item[2]) {
                item[2] = mediaQuery;
              } else if (mediaQuery) {
                item[2] = "(".concat(item[2], ") and (").concat(mediaQuery, ")");
              }

              list.push(item);
            }
          }
        };

        return list;
      };

      function cssWithMappingToString(item, useSourceMap) {
        var content = item[1] || ''; // eslint-disable-next-line prefer-destructuring

        var cssMapping = item[3];

        if (!cssMapping) {
          return content;
        }

        if (useSourceMap && typeof btoa === 'function') {
          var sourceMapping = toComment(cssMapping);
          var sourceURLs = cssMapping.sources.map(function (source) {
            return "/*# sourceURL=".concat(cssMapping.sourceRoot).concat(source, " */");
          });
          return [content].concat(sourceURLs).concat([sourceMapping]).join('\n');
        }

        return [content].join('\n');
      } // Adapted from convert-source-map (MIT)


      function toComment(sourceMap) {
        // eslint-disable-next-line no-undef
        var base64 = btoa(unescape(encodeURIComponent(JSON.stringify(sourceMap))));
        var data = "sourceMappingURL=data:application/json;charset=utf-8;base64,".concat(base64);
        return "/*# ".concat(data, " */");
      }
      /***/

    },
    /* 67 */

    /***/
    function (module, exports, __nested_webpack_require_92168__) {
      /*
      	MIT License http://www.opensource.org/licenses/mit-license.php
      	Author Tobias Koppers @sokra
      */
      var stylesInDom = {};

      var memoize = function memoize(fn) {
        var memo;
        return function () {
          if (typeof memo === "undefined") memo = fn.apply(this, arguments);
          return memo;
        };
      };

      var isOldIE = memoize(function () {
        // Test for IE <= 9 as proposed by Browserhacks
        // @see http://browserhacks.com/#hack-e71d8692f65334173fee715c222cb805
        // Tests for existence of standard globals is to allow style-loader
        // to operate correctly into non-standard environments
        // @see https://github.com/webpack-contrib/style-loader/issues/177
        return window && document && document.all && !window.atob;
      });

      var getTarget = function getTarget(target, parent) {
        if (parent) {
          return parent.querySelector(target);
        }

        return document.querySelector(target);
      };

      var getElement = function (fn) {
        var memo = {};
        return function (target, parent) {
          // If passing function in options, then use it for resolve "head" element.
          // Useful for Shadow Root style i.e
          // {
          //   insertInto: function () { return document.querySelector("#foo").shadowRoot }
          // }
          if (typeof target === 'function') {
            return target();
          }

          if (typeof memo[target] === "undefined") {
            var styleTarget = getTarget.call(this, target, parent); // Special case to return head of iframe instead of iframe itself

            if (window.HTMLIFrameElement && styleTarget instanceof window.HTMLIFrameElement) {
              try {
                // This will throw an exception if access to iframe is blocked
                // due to cross-origin restrictions
                styleTarget = styleTarget.contentDocument.head;
              } catch (e) {
                styleTarget = null;
              }
            }

            memo[target] = styleTarget;
          }

          return memo[target];
        };
      }();

      var singleton = null;
      var singletonCounter = 0;
      var stylesInsertedAtTop = [];

      var fixUrls = __nested_webpack_require_92168__(68);

      module.exports = function (list, options) {
        if (typeof DEBUG !== "undefined" && DEBUG) {
          if (typeof document !== "object") throw new Error("The style-loader cannot be used in a non-browser environment");
        }

        options = options || {};
        options.attrs = typeof options.attrs === "object" ? options.attrs : {}; // Force single-tag solution on IE6-9, which has a hard limit on the # of <style>
        // tags it will allow on a page

        if (!options.singleton && typeof options.singleton !== "boolean") options.singleton = isOldIE(); // By default, add <style> tags to the <head> element

        if (!options.insertInto) options.insertInto = "head"; // By default, add <style> tags to the bottom of the target

        if (!options.insertAt) options.insertAt = "bottom";
        var styles = listToStyles(list, options);
        addStylesToDom(styles, options);
        return function update(newList) {
          var mayRemove = [];

          for (var i = 0; i < styles.length; i++) {
            var item = styles[i];
            var domStyle = stylesInDom[item.id];
            domStyle.refs--;
            mayRemove.push(domStyle);
          }

          if (newList) {
            var newStyles = listToStyles(newList, options);
            addStylesToDom(newStyles, options);
          }

          for (var i = 0; i < mayRemove.length; i++) {
            var domStyle = mayRemove[i];

            if (domStyle.refs === 0) {
              for (var j = 0; j < domStyle.parts.length; j++) {
                domStyle.parts[j]();
              }

              delete stylesInDom[domStyle.id];
            }
          }
        };
      };

      function addStylesToDom(styles, options) {
        for (var i = 0; i < styles.length; i++) {
          var item = styles[i];
          var domStyle = stylesInDom[item.id];

          if (domStyle) {
            domStyle.refs++;

            for (var j = 0; j < domStyle.parts.length; j++) {
              domStyle.parts[j](item.parts[j]);
            }

            for (; j < item.parts.length; j++) {
              domStyle.parts.push(addStyle(item.parts[j], options));
            }
          } else {
            var parts = [];

            for (var j = 0; j < item.parts.length; j++) {
              parts.push(addStyle(item.parts[j], options));
            }

            stylesInDom[item.id] = {
              id: item.id,
              refs: 1,
              parts: parts
            };
          }
        }
      }

      function listToStyles(list, options) {
        var styles = [];
        var newStyles = {};

        for (var i = 0; i < list.length; i++) {
          var item = list[i];
          var id = options.base ? item[0] + options.base : item[0];
          var css = item[1];
          var media = item[2];
          var sourceMap = item[3];
          var part = {
            css: css,
            media: media,
            sourceMap: sourceMap
          };
          if (!newStyles[id]) styles.push(newStyles[id] = {
            id: id,
            parts: [part]
          });else newStyles[id].parts.push(part);
        }

        return styles;
      }

      function insertStyleElement(options, style) {
        var target = getElement(options.insertInto);

        if (!target) {
          throw new Error("Couldn't find a style target. This probably means that the value for the 'insertInto' parameter is invalid.");
        }

        var lastStyleElementInsertedAtTop = stylesInsertedAtTop[stylesInsertedAtTop.length - 1];

        if (options.insertAt === "top") {
          if (!lastStyleElementInsertedAtTop) {
            target.insertBefore(style, target.firstChild);
          } else if (lastStyleElementInsertedAtTop.nextSibling) {
            target.insertBefore(style, lastStyleElementInsertedAtTop.nextSibling);
          } else {
            target.appendChild(style);
          }

          stylesInsertedAtTop.push(style);
        } else if (options.insertAt === "bottom") {
          target.appendChild(style);
        } else if (typeof options.insertAt === "object" && options.insertAt.before) {
          var nextSibling = getElement(options.insertAt.before, target);
          target.insertBefore(style, nextSibling);
        } else {
          throw new Error("[Style Loader]\n\n Invalid value for parameter 'insertAt' ('options.insertAt') found.\n Must be 'top', 'bottom', or Object.\n (https://github.com/webpack-contrib/style-loader#insertat)\n");
        }
      }

      function removeStyleElement(style) {
        if (style.parentNode === null) return false;
        style.parentNode.removeChild(style);
        var idx = stylesInsertedAtTop.indexOf(style);

        if (idx >= 0) {
          stylesInsertedAtTop.splice(idx, 1);
        }
      }

      function createStyleElement(options) {
        var style = document.createElement("style");

        if (options.attrs.type === undefined) {
          options.attrs.type = "text/css";
        }

        if (options.attrs.nonce === undefined) {
          var nonce = getNonce();

          if (nonce) {
            options.attrs.nonce = nonce;
          }
        }

        addAttrs(style, options.attrs);
        insertStyleElement(options, style);
        return style;
      }

      function createLinkElement(options) {
        var link = document.createElement("link");

        if (options.attrs.type === undefined) {
          options.attrs.type = "text/css";
        }

        options.attrs.rel = "stylesheet";
        addAttrs(link, options.attrs);
        insertStyleElement(options, link);
        return link;
      }

      function addAttrs(el, attrs) {
        Object.keys(attrs).forEach(function (key) {
          el.setAttribute(key, attrs[key]);
        });
      }

      function getNonce() {
        if (false) {}

        return __nested_webpack_require_92168__.nc;
      }

      function addStyle(obj, options) {
        var style, update, remove, result; // If a transform function was defined, run it on the css

        if (options.transform && obj.css) {
          result = typeof options.transform === 'function' ? options.transform(obj.css) : options.transform.default(obj.css);

          if (result) {
            // If transform returns a value, use that instead of the original css.
            // This allows running runtime transformations on the css.
            obj.css = result;
          } else {
            // If the transform function returns a falsy value, don't add this css.
            // This allows conditional loading of css
            return function () {// noop
            };
          }
        }

        if (options.singleton) {
          var styleIndex = singletonCounter++;
          style = singleton || (singleton = createStyleElement(options));
          update = applyToSingletonTag.bind(null, style, styleIndex, false);
          remove = applyToSingletonTag.bind(null, style, styleIndex, true);
        } else if (obj.sourceMap && typeof URL === "function" && typeof URL.createObjectURL === "function" && typeof URL.revokeObjectURL === "function" && typeof Blob === "function" && typeof btoa === "function") {
          style = createLinkElement(options);
          update = updateLink.bind(null, style, options);

          remove = function remove() {
            removeStyleElement(style);
            if (style.href) URL.revokeObjectURL(style.href);
          };
        } else {
          style = createStyleElement(options);
          update = applyToTag.bind(null, style);

          remove = function remove() {
            removeStyleElement(style);
          };
        }

        update(obj);
        return function updateStyle(newObj) {
          if (newObj) {
            if (newObj.css === obj.css && newObj.media === obj.media && newObj.sourceMap === obj.sourceMap) {
              return;
            }

            update(obj = newObj);
          } else {
            remove();
          }
        };
      }

      var replaceText = function () {
        var textStore = [];
        return function (index, replacement) {
          textStore[index] = replacement;
          return textStore.filter(Boolean).join('\n');
        };
      }();

      function applyToSingletonTag(style, index, remove, obj) {
        var css = remove ? "" : obj.css;

        if (style.styleSheet) {
          style.styleSheet.cssText = replaceText(index, css);
        } else {
          var cssNode = document.createTextNode(css);
          var childNodes = style.childNodes;
          if (childNodes[index]) style.removeChild(childNodes[index]);

          if (childNodes.length) {
            style.insertBefore(cssNode, childNodes[index]);
          } else {
            style.appendChild(cssNode);
          }
        }
      }

      function applyToTag(style, obj) {
        var css = obj.css;
        var media = obj.media;

        if (media) {
          style.setAttribute("media", media);
        }

        if (style.styleSheet) {
          style.styleSheet.cssText = css;
        } else {
          while (style.firstChild) {
            style.removeChild(style.firstChild);
          }

          style.appendChild(document.createTextNode(css));
        }
      }

      function updateLink(link, options, obj) {
        var css = obj.css;
        var sourceMap = obj.sourceMap;
        /*
        	If convertToAbsoluteUrls isn't defined, but sourcemaps are enabled
        	and there is no publicPath defined then lets turn convertToAbsoluteUrls
        	on by default.  Otherwise default to the convertToAbsoluteUrls option
        	directly
        */

        var autoFixUrls = options.convertToAbsoluteUrls === undefined && sourceMap;

        if (options.convertToAbsoluteUrls || autoFixUrls) {
          css = fixUrls(css);
        }

        if (sourceMap) {
          // http://stackoverflow.com/a/26603875
          css += "\n/*# sourceMappingURL=data:application/json;base64," + btoa(unescape(encodeURIComponent(JSON.stringify(sourceMap)))) + " */";
        }

        var blob = new Blob([css], {
          type: "text/css"
        });
        var oldSrc = link.href;
        link.href = URL.createObjectURL(blob);
        if (oldSrc) URL.revokeObjectURL(oldSrc);
      }
      /***/

    },
    /* 68 */

    /***/
    function (module, exports) {
      /**
       * When source maps are enabled, `style-loader` uses a link element with a data-uri to
       * embed the css on the page. This breaks all relative urls because now they are relative to a
       * bundle instead of the current page.
       *
       * One solution is to only use full urls, but that may be impossible.
       *
       * Instead, this function "fixes" the relative urls to be absolute according to the current page location.
       *
       * A rudimentary test suite is located at `test/fixUrls.js` and can be run via the `npm test` command.
       *
       */
      module.exports = function (css) {
        // get current location
        var location = typeof window !== "undefined" && window.location;

        if (!location) {
          throw new Error("fixUrls requires window.location");
        } // blank or null?


        if (!css || typeof css !== "string") {
          return css;
        }

        var baseUrl = location.protocol + "//" + location.host;
        var currentDir = baseUrl + location.pathname.replace(/\/[^\/]*$/, "/"); // convert each url(...)

        /*
        This regular expression is just a way to recursively match brackets within
        a string.
        	 /url\s*\(  = Match on the word "url" with any whitespace after it and then a parens
           (  = Start a capturing group
             (?:  = Start a non-capturing group
                 [^)(]  = Match anything that isn't a parentheses
                 |  = OR
                 \(  = Match a start parentheses
                     (?:  = Start another non-capturing groups
                         [^)(]+  = Match anything that isn't a parentheses
                         |  = OR
                         \(  = Match a start parentheses
                             [^)(]*  = Match anything that isn't a parentheses
                         \)  = Match a end parentheses
                     )  = End Group
                     *\) = Match anything and then a close parens
                 )  = Close non-capturing group
                 *  = Match anything
              )  = Close capturing group
         \)  = Match a close parens
        	 /gi  = Get all matches, not the first.  Be case insensitive.
         */

        var fixedCss = css.replace(/url\s*\(((?:[^)(]|\((?:[^)(]+|\([^)(]*\))*\))*)\)/gi, function (fullMatch, origUrl) {
          // strip quotes (if they exist)
          var unquotedOrigUrl = origUrl.trim().replace(/^"(.*)"$/, function (o, $1) {
            return $1;
          }).replace(/^'(.*)'$/, function (o, $1) {
            return $1;
          }); // already a full url? no change

          if (/^(#|data:|http:\/\/|https:\/\/|file:\/\/\/|\s*$)/i.test(unquotedOrigUrl)) {
            return fullMatch;
          } // convert the url to a full url


          var newUrl;

          if (unquotedOrigUrl.indexOf("//") === 0) {
            //TODO: should we add protocol?
            newUrl = unquotedOrigUrl;
          } else if (unquotedOrigUrl.indexOf("/") === 0) {
            // path should be relative to the base url
            newUrl = baseUrl + unquotedOrigUrl; // already starts with '/'
          } else {
            // path should be relative to current directory
            newUrl = currentDir + unquotedOrigUrl.replace(/^\.\//, ""); // Strip leading './'
          } // send back the fixed url(...)


          return "url(" + JSON.stringify(newUrl) + ")";
        }); // send back the fixed css

        return fixedCss;
      };
      /***/

    },
    /* 69 */

    /***/
    function (module, exports, __webpack_require__) {
      "use strict";

      exports.__esModule = true;
      exports.default = void 0;
      var trustedPolicy;

      if (window.trustedTypes) {
        trustedPolicy = window.trustedTypes.createPolicy("fusionChartsPolicy", {
          createHTML: function createHTML(input) {
            return input;
          }
        });
      }

      var _default = exports.default = trustedPolicy || {
        createHTML: function createHTML(input) {
          return input;
        }
      };
      /***/

    }
    /******/
    ])
  );
});

/***/ }),

/***/ 859:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports.getFormatStore = exports.getAtomicity = void 0;

var _datetimeEnums = __webpack_require__(358);

var _validateBinsize = _interopRequireDefault(__webpack_require__(860));

var getFormatStore = function getFormatStore(specifier) {
  if (specifier === void 0) {
    specifier = '';
  }

  var timeUnits = [],
      store = {};
  /* else if (/%[_ -]?q/.test(specifier)) {
  dateTimeUnit = DatetimeUnits.Quarter;
  } */
  // else if (/%[_ -]?[aAUVW]/.test(specifier)) {
  //   dateTimeUnit = DatetimeUnits.Week;
  // }

  if (/%[_ -]?[cfLQ]/.test(specifier)) {
    timeUnits.push(_datetimeEnums.DatetimeUnits.Millisecond);
    store[_datetimeEnums.DatetimeUnits.Millisecond.name] = {};
  }

  if (/%[_ -]?[sSX]/.test(specifier)) {
    timeUnits.push(_datetimeEnums.DatetimeUnits.Second);
    store[_datetimeEnums.DatetimeUnits.Second.name] = {};
  }

  if (/%[_ -]?M/.test(specifier)) {
    timeUnits.push(_datetimeEnums.DatetimeUnits.Minute);
    store[_datetimeEnums.DatetimeUnits.Minute.name] = {};
  }

  if (/%[_ -]?[HI]/.test(specifier)) {
    timeUnits.push(_datetimeEnums.DatetimeUnits.Hour);
    store[_datetimeEnums.DatetimeUnits.Hour.name] = {};
  }

  if (/%[_ -]?[dejuwx]/.test(specifier)) {
    timeUnits.push(_datetimeEnums.DatetimeUnits.Day);
    store[_datetimeEnums.DatetimeUnits.Day.name] = {};
  }

  if (/%[_ -]?[dejuwxbBmyY]/.test(specifier)) {
    timeUnits.push(_datetimeEnums.DatetimeUnits.Week);
    store[_datetimeEnums.DatetimeUnits.Week.name] = {};
  }

  if (/%[_ -]?[bBm]/.test(specifier)) {
    timeUnits.push(_datetimeEnums.DatetimeUnits.Month);
    store[_datetimeEnums.DatetimeUnits.Month.name] = {};
  }

  if (/%[_ -]?[yY]/.test(specifier)) {
    timeUnits.push(_datetimeEnums.DatetimeUnits.Year);
    store[_datetimeEnums.DatetimeUnits.Year.name] = {};
  }

  return {
    timeUnits: timeUnits,
    store: store
  };
},
    getAtomicity = function getAtomicity(_ref) {
  var _ref$timeUnits = _ref.timeUnits,
      timeUnits = _ref$timeUnits === void 0 ? [] : _ref$timeUnits,
      _ref$store = _ref.store,
      store = _ref$store === void 0 ? {} : _ref$store,
      index = _ref.index,
      _ref$data = _ref.data,
      data = _ref$data === void 0 ? [] : _ref$data,
      bins = _ref.bins,
      intervalIndexMap = _ref.intervalIndexMap,
      ms = _ref.ms;
  var i,
      diff,
      prevDate,
      currentDate,
      bin,
      count,
      minInfo = {
    count: 0
  },
      multipliersCountMap,
      len = data.length;

  if (!timeUnits.length) {
    return [];
  }

  if (len === 1 || len === 0) {
    return [timeUnits[0].ms, 1, timeUnits[0].ms];
  }

  timeUnits.forEach(function (unit) {
    var unitName = unit.name,
        intervals = store[unitName];
    if (!intervals) return;
    Object.keys(intervals).forEach(function (interval) {
      var intervalCount = intervals[interval];

      if (minInfo.count <= intervalCount) {
        minInfo.count = intervalCount;
        Object.assign(minInfo, {
          multiplier: Number(interval),
          unit: {
            name: unitName,
            ms: bins[intervalIndexMap[unitName.toLowerCase()]][2]
          }
        });
      }
    });
  });

  for (i = 1; i < len; ++i) {
    prevDate = data[i - 1][index];
    currentDate = data[i][index];
    diff = ms.count(prevDate, currentDate);
    if (!Math.max(0, diff)) continue;
    bin = (0, _validateBinsize.default)(bins, intervalIndexMap, timeUnits, diff);
    multipliersCountMap = store[bin.unit.name];

    if (!multipliersCountMap[bin.multiplier]) {
      multipliersCountMap[bin.multiplier] = 0;
    }

    count = ++multipliersCountMap[bin.multiplier];

    if (minInfo.count < count || minInfo.count === count && minInfo.unit.ms * minInfo.multiplier > bin.unit.ms * bin.multiplier) {
      minInfo.count = count;
      Object.assign(minInfo, bin);
    }
  }

  return minInfo.count ? [minInfo.unit.ms, minInfo.multiplier, minInfo.multiplier * minInfo.unit.ms] : [timeUnits[0].ms, 1, timeUnits[0].ms];
};

exports.getAtomicity = getAtomicity;
exports.getFormatStore = getFormatStore;

/***/ }),

/***/ 949:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _index = _interopRequireDefault(__webpack_require__(337));

var _arrayHasContent = _interopRequireDefault(__webpack_require__(446));

var _isArray = _interopRequireDefault(__webpack_require__(349));

var _isObject = _interopRequireDefault(__webpack_require__(481));

var _isString = _interopRequireDefault(__webpack_require__(858));

var _stringHasContent = _interopRequireDefault(__webpack_require__(857));

var _uniq = _interopRequireDefault(__webpack_require__(838));

var _sanitiseAggregationWith = _interopRequireDefault(__webpack_require__(950));

var VALID_PLOT_TYPES = ['column', 'line', 'step-line', 'smooth-line', 'area', 'step-area', 'smooth-area', 'candlestick', 'ohlc', 'column-range', 'area-range'],
    VALID_CLIP_LEVEL = {
  'millisecond': true,
  'second': true,
  'minute': true,
  'hour': true,
  'day': true,
  'month': true,
  'year': true
},
    sanitiseAggregation = (0, _sanitiseAggregationWith.default)(_index.default),
    getValidClips = function getValidClips(clips) {
  return clips.map(function (clip) {
    if (!(0, _isString.default)(clip.to)) {
      clip.to = clip.from;
    }

    if (clip.hasOwnProperty('format') && !(0, _isString.default)(clip.format)) {
      delete clip.format;
    }

    if ((0, _isObject.default)(clip.repeat)) {
      if ((0, _isString.default)(clip.repeat.unit) && VALID_CLIP_LEVEL[clip.repeat.unit.toLowerCase()]) {
        clip.repeat.unit = clip.repeat.unit.toLowerCase();
        clip.repeat.multiplier = Number(clip.repeat.multiplier);

        if (!clip.repeat.multiplier) {
          clip.repeat.multiplier = 1;
        }
      } else {
        delete clip.repeat;
      }
    } else {
      delete clip.repeat;
    }

    return clip;
  }).filter(function (clip) {
    return (0, _isString.default)(clip.from) && (0, _isObject.default)(clip.repeat) && (0, _isString.default)(clip.repeat.unit);
  });
},
    DEFAULT_PLOT_TYPE = 'line';

var UNDEF,
    truthFn = function truthFn() {
  return true;
},
    isValidPlotType = function isValidPlotType(plotType) {
  return VALID_PLOT_TYPES.includes(plotType);
},
    plotExistsIn = function plotExistsIn(obj) {
  return (0, _stringHasContent.default)(obj.plot) || (0, _arrayHasContent.default)(obj.plot) || (0, _isObject.default)(obj.plot);
},
    clipExistsIn = function clipExistsIn(obj) {
  return (0, _arrayHasContent.default)(obj.clip);
},

/**
 * api to check of the object has configuartion to be parsed
 * @param {*} any
 * @return Boolean value
 */
objectHasContent = function objectHasContent(param) {
  return (0, _isObject.default)(param) && (plotExistsIn(param) || clipExistsIn(param));
},

/**
 * api to expand the string configuarion in required format
 * @param {*} any
 * @param {Function} stringValidator validates the string with datatable
 * @return array containing the parsed data
 */
stringExpando = function stringExpando(str, stringValidator, mergingInfo) {
  if (mergingInfo === void 0) {
    mergingInfo = {};
  }

  var outputArr = [];

  if ((0, _stringHasContent.default)(str) && stringValidator(str)) {
    var mergedPlot = (0, _isObject.default)(mergingInfo.plot) ? Object.assign({}, mergingInfo.plot) : {},
        plotType = mergedPlot.type || mergingInfo.plottype;
    mergedPlot.type = isValidPlotType(plotType) ? plotType : DEFAULT_PLOT_TYPE;
    mergedPlot.value = str;
    mergedPlot.aggregation = sanitiseAggregation(mergedPlot.aggregation || mergingInfo.aggregation);
    outputArr.push(Object.assign({}, mergingInfo, {
      plot: [mergedPlot]
    }));
  }

  return outputArr;
},

/**
 * api to sanitise the 'value' with the schema column names
 * @param {object} obj The object to be processed
 * @param {Function} validator Validates the object attributes like `value`
 * and `OHLC` datatable
 * @return an object with the type, value and OHLC if applicable
 */
sanitiseObj = function sanitiseObj(obj, validator) {
  var type = isValidPlotType(obj.type) ? obj.type : DEFAULT_PLOT_TYPE,
      isOHLC = type === 'candlestick' || type === 'ohlc',
      isRangedData = type === 'column-range' || type === 'area-range',
      sanitisedName = function sanitisedName(str) {
    return validator(str) ? str : UNDEF;
  };

  var value,
      validatedObj = {},
      open,
      close,
      high,
      low; // Process the `value` attr, as it is common for both below

  if ((0, _isObject.default)(obj.value)) {
    value = sanitisedName(obj.value.value);
  } else {
    value = sanitisedName(obj.value);
  }

  if (isOHLC) {
    // The accepted format being OHLC values will be inside `value` object
    if ((0, _isObject.default)(obj.value)) {
      open = sanitisedName(obj.value.open);
      close = sanitisedName(obj.value.close);
      high = sanitisedName(obj.value.high);
      low = sanitisedName(obj.value.low);
    } // if all OHLC values are present, use them and set value to null


    if (open && high && low && close) {
      validatedObj = Object.assign({}, obj, {
        type: type,
        high: high,
        low: low,
        open: open,
        close: close,
        // value will be overridden since it will not be used
        value: null
      }); // if none of the OHLC values are present, use value for all
    } else if (!open && !high && !low && !close) {
      validatedObj = Object.assign({}, obj, {
        type: type,
        high: value,
        low: value,
        open: value,
        close: value,
        value: value
      }); // if 3 or less of OHLC value are present, use as is
    } else {
      validatedObj = Object.assign({}, obj, {
        type: type,
        high: high,
        low: low,
        open: open,
        close: close,
        // value will be override since it will not be used
        value: null
      });
    }
  } else if (isRangedData) {
    // The accepted format being Range values will be inside `value` object
    if ((0, _isObject.default)(obj.value)) {
      high = sanitisedName(obj.value.high);
      low = sanitisedName(obj.value.low);
    } // if all range values are present, use them and set value to null


    if (high && low) {
      validatedObj = Object.assign({}, obj, {
        type: type,
        high: high,
        low: low,
        // value will be overridden since it will not be used
        value: null
      }); // if none of the range values are present, use value for all
    } else if (!high && !low) {
      validatedObj = Object.assign({}, obj, {
        type: type,
        high: value,
        low: value,
        value: value
      }); // if high or low value are present, use as is
    }
  } else {
    validatedObj = Object.assign({}, obj, {
      type: type,
      value: value
    });
  }

  validatedObj.typeinnavigator = isValidPlotType(validatedObj.typeinnavigator) ? validatedObj.typeinnavigator : UNDEF;

  if (isOHLC && (value || open || close || high || low) || value) {
    return validatedObj;
  } else if (isRangedData && high && low) {
    return validatedObj;
  }
},

/**
 * api to expand the object configuarion in required format
 * @param {*} any
 * @param {Function} stringValidator validates the string with datatable
 * @return array containing the parsed data
 */
objectExpando = function objectExpando(obj, stringValidator) {
  var outputArr = [],
      plot = obj.plot,
      isPlotObject = (0, _isObject.default)(plot),
      action = obj.hasOwnProperty('plot') && !(isPlotObject && !plot.hasOwnProperty('value')) && 'axis',
      isValidString = function isValidString(str) {
    return (0, _stringHasContent.default)(str) && stringValidator(str);
  };

  if (objectHasContent(obj)) {
    var array = [],
        validClips = (0, _arrayHasContent.default)(obj.clip) ? getValidClips(obj.clip) : [];
    outputArr.push(Object.assign({}, obj, obj.aggregation ? validClips.length ? {
      plot: array,
      aggregation: sanitiseAggregation(obj.aggregation),
      clip: validClips
    } : {
      plot: array,
      aggregation: sanitiseAggregation(obj.aggregation)
    } : (0, _isArray.default)(obj.clips) ? {
      plot: array,
      clip: validClips
    } : {
      plot: array
    }));

    if (isPlotObject || (0, _stringHasContent.default)(plot)) {
      plot = [plot];
    }

    if ((0, _arrayHasContent.default)(plot)) {
      var filteredInfo = plot.filter(function (ele) {
        return !!ele;
      });
      filteredInfo.forEach(function (ele) {
        var output;

        if ((0, _isObject.default)(ele)) {
          var type = ele.type || obj.plottype;
          output = sanitiseObj(Object.assign({}, ele, {
            aggregation: sanitiseAggregation(ele.aggregation || obj.aggregation),
            type: type
          }), isValidString);
        } else if (isValidString(ele)) {
          output = sanitiseObj({
            value: ele,
            type: obj.plottype,
            aggregation: sanitiseAggregation(obj.aggregation)
          }, isValidString);
        }

        output && array.push(output);
      });
    }
  }

  return outputArr[0] && outputArr[0].plot.length ? {
    output: outputArr,
    action: (0, _isArray.default)(plot) && plot.length > outputArr[0].plot.length ? 'plot' : false
  } : {
    output: [],
    action: action
  };
},

/**
 * api to expand the array configuarion in required format
 * @param {*} any
 * @param {Function} stringValidator validates the string with datatable
 * @return array containing the parsed data
 */
arrayExpando = function arrayExpando(arr, stringValidator, mergingInfo) {
  var output = [],
      info,
      actions = [];
  arr.forEach(function (ele) {
    if ((0, _isString.default)(ele)) {
      output = output.concat(stringExpando(ele, stringValidator, mergingInfo));
    } else if ((0, _isObject.default)(ele)) {
      info = objectExpando(ele, stringValidator);
      output = output.concat(info.output);
      info.action && actions.push(info.action);
    }
  });
  return {
    output: output,
    actions: actions
  };
},

/**
 * api to expand the any type of configuartions
 * @param {*} any
 * @param {Function} stringValidator validates the string with datatable
 * @return array containing the parsed data
 */
expander = function expander(config, stringValidator, mergingInfo) {
  var output = [],
      actions = [];

  if ((0, _isString.default)(config)) {
    output = stringExpando(config, stringValidator);
  } else if ((0, _isObject.default)(config)) {
    var action;

    var _objectExpando = objectExpando(config, stringValidator);

    output = _objectExpando.output;
    action = _objectExpando.action;
    action && actions.push(action);
  } else if ((0, _isArray.default)(config)) {
    var _arrayExpando = arrayExpando(config, stringValidator, mergingInfo);

    output = _arrayExpando.output;
    actions = _arrayExpando.actions;
  }

  return {
    output: output,
    actions: actions
  };
},

/**
 * api to expand the configuartion of axis
 * @param {Array} dataTableColumns is an array of strings containing the data
 * table columns name
 * @param {*} config axis data to be parsed
 * @return array containing the parsed data
 */
expando = function expando(dataTableColumns, config, isY) {
  if (dataTableColumns === void 0) {
    dataTableColumns = [];
  }

  if (isY === void 0) {
    isY = true;
  }

  var output = [],
      actions = [],
      outputLen = 0,
      isObjectConfig = (0, _isObject.default)(config),
      stringValidator = function stringValidator(str) {
    return dataTableColumns.indexOf(str) >= 0;
  };

  if (config) {
    var _expander = expander(config, stringValidator);

    output = _expander.output;
    actions = _expander.actions;
    outputLen = output.length;
    var containsAxisAction = actions.includes('axis');

    if (isObjectConfig) {
      containsAxisAction && (actions = ['fullaxis']);
    } else if ((0, _isArray.default)(config) && outputLen < config.length) {
      if (outputLen) {
        !containsAxisAction && actions.push('axis');
      } else {
        actions = ['fullaxis'];
      }
    }
  } // if the config does not contain the info to build the axis info then
  // all the info from datatable is parsed


  if (!output.length) {
    var _expander2 = expander(dataTableColumns, truthFn, isObjectConfig && config);

    output = _expander2.output;
  } // default title will only be created for y Axis


  isY && output.forEach(function (obj) {
    if (!(0, _isString.default)(obj.title)) {
      var nameArr = [];

      for (var i = 0; i < obj.plot.length; i++) {
        if (obj.plot[i].value) {
          nameArr.push(obj.plot[i].value);
        }
      }

      obj.title = nameArr.join(' - ');
    }
  });
  return {
    expandedAxis: output,
    actions: (0, _uniq.default)(actions)
  };
};

var _default = expando;
exports["default"] = _default;

/***/ }),

/***/ 952:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _mergeRight = _interopRequireDefault(__webpack_require__(882));

var _all = _interopRequireDefault(__webpack_require__(953));

var _isObject = _interopRequireDefault(__webpack_require__(481));

var _isArray = _interopRequireDefault(__webpack_require__(349));

var _isNumber = _interopRequireDefault(__webpack_require__(927));

/**
 * Verifies that a number is a valid index of the given array
 *
 * @param {array} arr The array against which the number will be checked
 * @param {number} idx The number to be checked
 *
 * @return {boolean}
 */
var isValidIndex = function isValidIndex(arr, idx) {
  return idx >= 0 && idx < arr.length;
},

/**
 * Verifies that an input is a number and a valid index of the given array
 *
 * @param {array} arr The array against which the number will be checked
 * @param {*} num The input to be checked
 *
 * @return {boolean}
 */
isValidNumber = function isValidNumber(arr, num) {
  return (0, _isNumber.default)(num) && isValidIndex(arr, num);
},

/**
 * Verifies that an input is an object and has an index property which is a
 * valid index of the given array
 *
 * @param {array} arr The array against which the object will be checked
 * @param {*} obj The input to be checked
 *
 * @reutrn {boolean}
 */
isValidObject = function isValidObject(arr, obj) {
  return (0, _isObject.default)(obj) && isValidNumber(arr, +obj.index);
},

/**
 * Verifies that the input panel axis configuration is valid
 *
 * @param {array} arr The array of axis configurations
 * @param {*} a The panel specific reference to an axis configuration
 *
 * @return {boolean}
 */
isValidAxis = function isValidAxis(arr, a) {
  return isValidNumber(arr, +a) || isValidObject(arr, a);
},

/**
 * Transforms the input to a minimally valid panel axis configuration while
 * not omitting any configuration otherwise specified
 *
 * @param {*} a The input to be converted to a configuration
 *
 * @return {object} A minimally valid panel axis configuration
 */
expand = function expand(a) {
  return (0, _isObject.default)(a) ? (0, _mergeRight.default)(a, {
    index: +a.index
  }) : {
    index: +a
  };
},

/**
 * Transforms the input to a minimally valid panel configuration while not
 * omitting any configuration otherwise specified
 *
 * @param {*} a The input to be converted to a configuration
 *
 * @return {object} A minimally valid panel configuration
 */
toPanelConfig = function toPanelConfig(a) {
  return (0, _mergeRight.default)(a, {
    x: (0, _isArray.default)(a.x) ? a.x.map(expand) : [expand(a.x)],
    y: (0, _isArray.default)(a.y) ? a.y.map(expand) : [expand(a.y)]
  });
},

/**
 * Verifies whether the given panel configuration is valid or not.
 *
 * @param {array} arr An array of axis configurations
 * @param {*} config The panel configuration
 *
 * @return {boolean}
 */
validate = function validate(arr, config) {
  return (0, _isArray.default)(config) ? (0, _all.default)(function (x) {
    return isValidAxis(arr, x);
  }, config) : isValidAxis(arr, config);
};
/**
 * Generates minimally valid panel configurations from the given x, y and panel
 * configurations; failing which it defaults to the provided function to
 * generate a valid canvas configuration
 *
 * @param {array} xs An array of x configurations
 * @param {array} ys An array of y configurations
 * @param {array} panels An array of panel configurations
 * @param {function} defaultCanvases A function, which when passed the x and y
 * configurations returns an array of panel configurations
 *
 * @return {array} The generated minimally valid panel configurations
 */


var _default = function _default(xs, ys, panels, defaultCanvases) {
  if (xs === void 0) {
    xs = [];
  }

  if (ys === void 0) {
    ys = [];
  }

  if (panels === void 0) {
    panels = [];
  }

  var isValidPanelObject = function isValidPanelObject(panel) {
    return (0, _isObject.default)(panel) && validate(xs, panel.x) && validate(ys, panel.y);
  },
      getValidPanels = function getValidPanels(configs) {
    if ((0, _isArray.default)(configs) && configs.length > 0) {
      return configs.filter(isValidPanelObject).map(toPanelConfig);
    } else if (isValidPanelObject(configs)) {
      return [toPanelConfig(configs)];
    }

    return [];
  },
      panelConfigs = getValidPanels(panels);

  return panelConfigs.length ? panelConfigs : defaultCanvases(xs, ys);
};

exports["default"] = _default;

/***/ }),

/***/ 950:
/***/ ((__unused_webpack_module, exports) => {



exports.__esModule = true;
exports["default"] = void 0;
var DEFAULT_AGGREGATION = 'avg';

var _default = function _default(aggStore) {
  return function (aggregation) {
    var agg = aggregation == null ? DEFAULT_AGGREGATION : aggregation,
        lowerAgg = agg.toLowerCase();

    if (aggStore.getDefaultAggregations()[lowerAgg]) {
      return lowerAgg;
    } else if (aggStore.getRegisteredAggregations()[agg]) {
      return agg;
    }

    return DEFAULT_AGGREGATION;
  };
};

exports["default"] = _default;

/***/ }),

/***/ 956:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _stringHasContent = _interopRequireDefault(__webpack_require__(857));

var _lib = __webpack_require__(274);

/**
 * api to add sanitised series string in the expanded json
 * @param {Array} dataTableColumns is an array of strings containing the data table columns name of type string
 * @param {Array} config expanded json of axis
 * @param {String} seriesType is the series string given in root level of user's json
 */
var _default = function _default(dataTableColumns, config, seriesType, stackType, groupType) {
  if (dataTableColumns === void 0) {
    dataTableColumns = [];
  }

  if (config === void 0) {
    config = [];
  }

  if (seriesType === void 0) {
    seriesType = '';
  }

  if (stackType === void 0) {
    stackType = '';
  }

  if (groupType === void 0) {
    groupType = '';
  }

  var getValidString = function getValidString(str) {
    return (0, _stringHasContent.default)(str) && dataTableColumns.indexOf(str) >= 0 ? str : _lib.UNDEF;
  },
      rootSeries = getValidString(seriesType),
      rootStack = getValidString(stackType),
      rootGroup = getValidString(groupType);

  return config.map(function (axis) {
    var series = getValidString(axis.series) || rootSeries,
        stack = getValidString(axis.stack) || rootStack,
        group = getValidString(axis.group) || rootGroup;
    axis.plot = axis.plot.map(function (plot) {
      var type = plot.type;

      if (type === 'column' || /area/.test(type)) {
        plot.stack = getValidString(plot.stack) || stack || series;
        plot.group = getValidString(plot.group) || group;
      } else {
        plot.stack = getValidString(plot.stack) || stack;
        plot.group = getValidString(plot.group) || group || series;
      }

      return plot;
    });
    return axis;
  });
};

exports["default"] = _default;

/***/ }),

/***/ 951:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports.validateFocusLimit = validateFocusLimit;
exports.filterStandarBinsToUserConfig = filterStandarBinsToUserConfig;
exports.setBinningRules = setBinningRules;
exports.validateUserBin = validateUserBin;
exports.calculateDomainForUserCustomBin = calculateDomainForUserCustomBin;

var _pluckNumber = _interopRequireDefault(__webpack_require__(280));

/**
 * @description This function validates time selection provided by the user, also adds functionality like
 * restricting them to available domain of the chart, swapping the values if startTime > endTime. Holds the previous
 * start or end value if incorrect data provided.
 * @param {Object} timeInterval Expectedd time selection to set
 * @param {Object} currentTimeSelection Current tiem selection of the chart
 * @param {Object} chart FT chart instance
 */
function validateFocusLimit(timeInterval, currentTimeSelection, chart) {
  var domain = chart.getFromEnv('contextBins')[0].getBinDomain(),
      maxDomain = domain[1].getTime(),
      minDomain = domain[0].getTime(),
      start = timeInterval.start,
      end = timeInterval.end;

  if (start == null && end == null) {
    return false;
  } else if (isNaN(start) && isNaN(end)) {
    return false;
  } else if (!isNaN(start) && (isNaN(end) || end === null)) {
    end = currentTimeSelection.end;
  } else if ((isNaN(start) || start === null) && !isNaN(end)) {
    start = currentTimeSelection.start;
  }

  if (start > end) {
    start = start + end;
    end = start - end;
    start = start - end;
  }

  start = Math.max(minDomain, start);
  end = Math.min(maxDomain, end);
  return [start, end];
}
/**
 * @description This function filters the standardbin's data which user requires
 * @param {Array} standardBins is an array of array which holds all all possible binning for charts at that moment
 * @returns {Object} binning in a better readable and filtered data which the user only requires
 */


function filterStandarBinsToUserConfig(standardBins) {
  var binObj = {};

  for (var index = 0; index < standardBins.length; index++) {
    var bin = standardBins[index],
        binUnit = bin[0].name();

    if (binObj[binUnit]) {
      binObj[binUnit].push(bin[1]);
    } else {
      binObj[binUnit] = [bin[1]];
    }
  }

  return binObj;
}
/**
 * @description Overrides the binning rules followed by the chart with the binning rules provided to this API.
 * If some time unit is missing from the input binning rules, then the default multipliers for that time unit will be used by the chart.
 * If any incorrect multipliers are provided to a unit, they will be ignored.
 * @param {Object} customBin An object containing:
 * millisecond<Number[]>: All the multipliers applicable for the millisecond unit.
 * second<Number[]>: All the multipliers applicable for the second unit.
 * minute<Number[]>: All the multipliers applicable for the minute unit.
 * hour<Number[]>: All the multipliers applicable for the hour unit.
 * day<Number[]>: All the multipliers applicable for the day unit.
 * month<Number[]>: All the multipliers applicable for the month unit.
 * year<Number[]>: All the multipliers applicable for the year unit.
 * @returns {Object} <FusionCharts>: The instance of FusionCharts upon which the method was invoked.
 */


function setBinningRules(customBin) {
  var FC = this,
      chartData = FC.getJSONData(); // if xaxis is not present in JSON config, setting blank object to xaxis

  if (chartData.xaxis == null) {
    chartData.xaxis = {};
  }

  chartData.xaxis.binning = customBin;
  FC.setJSONData(chartData);
  return FC;
}
/**
 * @description Verifies given bin unit and multiplier with the standardbins and sends it back else returns false.
 * @param {object} customBin customBinObj An object containing:unit<String>: The unit of time to be represented in each bin - millisecond, second, minute, hour, day, month or year.
 * multiplier<Number>: The multiplier for the unit to be represented in each bin.
 * @param {*} chart
 */


function validateUserBin(customBin, chart) {
  var unit = customBin.unit,
      multiplier = customBin.multiplier,
      contextBins = chart.getFromEnv('contextBins')[0],
      atomicity = contextBins.getBinMin()[2],
      standardBins = contextBins.getStandardBins(),
      intervalIndexMap = contextBins.intervalIndexMap;
  multiplier = (0, _pluckNumber.default)(multiplier, 1);
  unit = unit.toLowerCase(); // if unit is invalid return false, intervalIndexMap stores all valid bin unit and their starting position in standarbins

  if (intervalIndexMap[unit] == null) {
    return false;
  } // Iterarate from the particular index of bin-unit in standardbin to avoid unnecessary iterations and breaks
  // when other binunit appears (as standard bins are sorted in order)


  for (var index = intervalIndexMap[unit]; index < standardBins.length; index++) {
    var bin = standardBins[index]; // when other binunit appears break the loop (as standard bins are sorted in order) or break if it goes below atomicity

    if (bin[0].name() !== unit || bin[2] < atomicity) {
      break;
    } // rerturns the unit and multiplier


    if (bin[1] === multiplier) {
      return {
        unit: unit,
        multiplier: multiplier,
        duration: bin[2]
      };
    }
  } // after iteration no valid multipliers found, hence returning false


  return false;
}

function calculateDomainForUserCustomBin(customBin, chart) {
  var duration = customBin.duration,
      contextBins = chart.getFromEnv('contextBins')[0],
      maxDomainLimit = contextBins.getBinDomain(),
      range = contextBins.getBinRange(),
      currentTimeSelection = chart.getFocusLimit(),
      currentEndTime = currentTimeSelection[1],
      minTime = maxDomainLimit[0].getTime(),
      maxTime = maxDomainLimit[1].getTime(),
      leftTimeToGo = currentEndTime - duration * range[1] / contextBins.thresholdPixels,
      rightTimeToGo = currentEndTime + (minTime - leftTimeToGo); // when changing current left time interval fixing current end interval

  if (leftTimeToGo >= minTime) {
    return [leftTimeToGo, currentEndTime];
  } else if (rightTimeToGo <= maxTime) {
    // when changing current left time interval and current end interval also required
    return [minTime, rightTimeToGo];
  } // return the max possible time to expand when binning size given is too large compare to possible binning


  return [minTime, maxTime];
}

/***/ }),

/***/ 860:
/***/ ((__unused_webpack_module, exports) => {



exports.__esModule = true;
exports["default"] = void 0;

/* eslint-disable good-practices/no-single-usage-variable */
var _default = function _default(standardBins, intervalIndexMap, units, diffDuration) {
  var i,
      j,
      unit,
      unitsLen = units.length,
      currentBin,
      oneMonthinMS = 2592000000,
      sixMonthsandOneDayinMS = 15724800000,
      standardDaysForOneMonth = 30,
      exceptionThreshold = 0.067,
      duration = diffDuration;
  /**
   * Special case,
   * Only in case of month level data, user may enter in form of a string in stead proper value. For eg. Jan, Feb, Mar.
   * And their values vary from 28 days to 31 days.Hence In case of month level binning The time differnce varies.
   * eg. for 2 months binning Jan-Feb,2003 has 59 days, WhereAs Apr-May, 2003 has 61 days, July-August,2003 has 62days differene.
   * eg. for 3 months binning Jan-Mar,2003 has 89 days, WhereAs Apr-Jun, 2004 has 91 days, July-Sep,2004 has 92days differene.
   * As in standardbin we follow month as 30days standard, restricting month level data to 30days or its multiplier.
   * hence values raning between 30-32, 60-62 till 180-182 are restricted to 30, 60 till 180.
   */
  // As month level binning are valid from 1-6 months hence adding check of one to six months

  if (duration > oneMonthinMS && duration <= sixMonthsandOneDayinMS) {
    /**
     * check to findout whether the data is within 30 *(multiplier 1-6) + 2 days range
     * exceptionThreshold is calculated from 2/30 as the max diff we are considering to restrict the data is 30 multiplier + 2 days
     * 2 is considered as July and August both months has 31 days
     */
    if (duration / standardDaysForOneMonth % 1 < exceptionThreshold) {
      // Logic to restric them to 30 or its multiplier
      duration = oneMonthinMS * Math.floor(duration / oneMonthinMS);
    }
  }

  for (i = 0; i < unitsLen; i++) {
    unit = units[i];
    j = intervalIndexMap[unit.name.toLowerCase()];

    while (standardBins[j] && standardBins[j][0].name() === unit.name.toLowerCase()) {
      currentBin = standardBins[j]; // if the duration is less or an exact match with an interval, simply return the interval

      if (duration <= currentBin[2]) {
        return {
          unit: unit,
          multiplier: currentBin[1]
        };
      }

      j++;
    }
  } // if it was not resolved above, divide and round the duration by the last unit that was processed


  return {
    unit: units[i - 1],
    multiplier: Math.round(duration / units[i - 1].ms)
  };
};

exports["default"] = _default;

/***/ }),

/***/ 946:
/***/ ((__unused_webpack_module, exports) => {



exports.__esModule = true;
exports["default"] = void 0;

var _default = function _default(axesConfig, index) {
  var config = axesConfig[index];
  return Object.assign({}, config, {
    columnname: config.columnname
  });
};

exports["default"] = _default;

/***/ }),

/***/ 957:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _background = _interopRequireDefault(__webpack_require__(958));

var _lib = __webpack_require__(274);

var _default = function _default(chart) {
  (0, _lib.componentFactory)(chart, _background.default, 'background', 1, [{}]);
};

exports["default"] = _default;

/***/ }),

/***/ 947:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _lib = __webpack_require__(274);

var _caption = _interopRequireDefault(__webpack_require__(948));

var MIDDLE = 'middle',
    LEFT = 'left',
    validPositionsArr = ['left', 'center', 'right'];

var _default = function _default(chart) {
  var dataSource = chart.getFromEnv('dataSource'),
      caption = dataSource.caption || {},
      captionText,
      captionStyle,
      subCaption = dataSource.subcaption || {},
      subCaptionText,
      subCaptionStyle,
      captionPosition,
      subCaptionPosition,
      getStyleDef = chart.getFromEnv('getStyleDef');
  captionPosition = (caption.position || '').toLowerCase();

  if (validPositionsArr.indexOf(captionPosition) < 0) {
    captionPosition = LEFT;
  }

  if (captionPosition === 'center') {
    captionPosition = MIDDLE;
  }

  subCaptionPosition = (subCaption.position || '').toLowerCase();

  if (validPositionsArr.indexOf(subCaptionPosition) < 0) {
    subCaptionPosition = LEFT;
  }

  if (subCaptionPosition === 'center') {
    subCaptionPosition = MIDDLE;
  }

  captionText = (0, _lib.parseUnsafeString)(caption.text) || ''; // merge caption style with default text style

  captionStyle = getStyleDef(caption.style && caption.style.text);
  subCaptionText = subCaption.text && (0, _lib.parseUnsafeString)(subCaption.text); // merge caption style with default text style

  subCaptionStyle = getStyleDef(subCaption.style && subCaption.style.text);
  var CONFIGURATION = {
    caption: captionText,
    subCaption: subCaptionText,
    captionAlignment: captionPosition,
    subCaptionAlignment: subCaptionPosition,
    captionCss: captionStyle,
    subCaptionCss: subCaptionStyle
  };
  (0, _lib.componentFactory)(chart, _caption.default, 'caption', 1, [CONFIGURATION]);
};

exports["default"] = _default;

/***/ }),

/***/ 968:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _lib = __webpack_require__(274);

var _customRangeSelector = _interopRequireDefault(__webpack_require__(969));

var _default = function _default(chart) {
  var dataSource = chart.getFromEnv('dataSource'),
      extensions = dataSource.extensions || {},
      isEnabled = (0, _lib.pluckNumber)(extensions.customrangeselector && extensions.customrangeselector.enabled, 1);
  (0, _lib.componentFactory)(chart, _customRangeSelector.default, 'customRangeSelector', +isEnabled, [{
    domain: chart.getFocusLimit(),
    style: extensions.customrangeselector && extensions.customrangeselector.style || {}
  }]);
};

exports["default"] = _default;

/***/ }),

/***/ 959:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _mergeRight = _interopRequireDefault(__webpack_require__(882));

var _timeNavigator = _interopRequireDefault(__webpack_require__(960));

var _lib = __webpack_require__(274);

var _panelConfigurer = _interopRequireDefault(__webpack_require__(946));

var DEFAULT_AXIS_X = {
  orientation: 'bottom',
  align: 'bottom',
  visible: true,
  overlap: true,
  dayinmajor: true,
  stickycontextlabel: false,
  scalemode: 'random',
  skipinfo: {
    minor: true
  },
  offset: {
    x: 2,
    y: 2
  }
},
    DEFAULT_AXIS_Y = {
  orientation: 'left',
  align: 'left',
  visible: true,
  overlap: false
},
    hydrateX = (0, _mergeRight.default)(DEFAULT_AXIS_X),
    hydrateY = (0, _mergeRight.default)(DEFAULT_AXIS_Y);

var _default = function _default(chart) {
  var chartConfig = chart.config,
      contextAxesX = chartConfig.contextAxesX,
      contextAxesY = chartConfig.contextAxesY,
      contextPanels = chartConfig.contextPanels.map(function (panel) {
    return (0, _mergeRight.default)(panel, {
      x: panel.x.map(function (xCfg) {
        return (0, _mergeRight.default)(hydrateX(xCfg), (0, _panelConfigurer.default)(contextAxesX, xCfg.index));
      }),
      y: panel.y.map(function (yCfg) {
        return (0, _mergeRight.default)(hydrateY(yCfg), (0, _mergeRight.default)((0, _panelConfigurer.default)(contextAxesY, yCfg.index), {
          plottype: 'line'
        }));
      })
    });
  }),
      tableMap = chartConfig.contextTableMap;
  var mergedContextPanels, timeNavigator; // to make navigator component compatible with using old stored
  // information and make the info as better and explicitly definig
  // keys the x y and plots has been replaced with xConfigs
  // yConfigs and plotConfigs respctively

  mergedContextPanels = contextPanels.map(function (cfg, i) {
    var info = (0, _mergeRight.default)(cfg, {
      tableMap: tableMap
    });
    (0, _lib.componentFactory)(chart, _timeNavigator.default, 'timeNavigator', chartConfig.navigatorEnabled ? 1 : 0, [{
      contextScale: info.x[i].scale.copy(),
      xConfigs: info.x,
      yConfigs: info.y,
      plotConfigs: info.plots,
      dataTable: info.dataTable,
      tableMap: info.tableMap,
      focusScale: chart.getFromEnv('focusScalesX')[0]
    }]);
    return info;
  });
  chartConfig.contextPanels = mergedContextPanels;

  if (timeNavigator = chart.getChildren('timeNavigator') && chart.getChildren('timeNavigator')[0]) {
    if (!timeNavigator || timeNavigator.getState('removed')) return;
    timeNavigator.attachHandlers();
    timeNavigator.addExtEventListener('focusLimitChanged', function () {
      timeNavigator.asyncDraw();
    }, chart);
  }
};

exports["default"] = _default;

/***/ }),

/***/ 881:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _mergeRight = _interopRequireDefault(__webpack_require__(882));

var _lib = __webpack_require__(274);

var _axis = _interopRequireDefault(__webpack_require__(884));

var _canvas = _interopRequireDefault(__webpack_require__(885));

var _panelConfigurer = _interopRequireDefault(__webpack_require__(946));

var _enUS = _interopRequireDefault(__webpack_require__(546));

var _isValidNumber = _interopRequireDefault(__webpack_require__(856));

var _numberConverter = __webpack_require__(547);

var _formatSpecifier = _interopRequireDefault(__webpack_require__(551));

/* eslint-disable good-practices/no-function-dependency */
var BOTTOM = 'bottom',
    canvases = function canvases(key) {
  return key.match(/^canvas/);
},
    removeComponent = function removeComponent(component) {
  return component.remove();
},
    validateRound = function validateRound(round) {
  // If round is a string, attempt to parse it as a number
  if (typeof round === 'string') {
    var parsedRound = parseInt(round, 10);
    return Number.isNaN(parsedRound) ? null : parsedRound;
  } else if ((0, _isValidNumber.default)(round)) {
    return round;
  }

  return null;
},
    getSpecifier = function getSpecifier(_ref) {
  var value = _ref.value,
      type = _ref.type,
      subType = _ref.subType,
      _ref$defaultformat = _ref.defaultformat,
      defaultformat = _ref$defaultformat === void 0 ? true : _ref$defaultformat,
      round = _ref.round;
  var precision;

  if (round != null) {
    // If round is positive, the precision is set to be the same as round.
    if (round >= 0) {
      precision = round;
    } else {
      // If round is negative, we round the values to the closest power of
      // 10. For example, if the value is 234, a round of -2 would be 200,
      // a round of -1 would be 230 etc.
      precision = Math.max(1, Math.floor(value).toString().length + round + 1);
    }
  } // If the user has left the formatting of numbers upto us, we try to figure
  // out the most appropriate formatting


  if (defaultformat) {
    var absValue = Math.abs(value); // When the value is greater than 0 but less than 1 OR less than 0 but
    // greater than -1,
    // If the number of decimal places in the value is in [4, Infinity),
    // format the values with scientific notation.
    // Otherwise, when the number of decimal places in the value is in [1,3]
    // show the values as they are.

    if (absValue !== 0 && absValue < 0.0001) {
      switch (type) {
        case 'axis':
          if (round == null) {
            return '$e';
          } else if (round < 0) {
            // trim insignificant zeroes
            return "$." + precision + "~e";
          } // preserve insignificant zeroes


          return "$." + precision + "e";

        default:
          if (round == null) {
            return '$.2e';
          } else if (round < 0) {
            // trim insignificant zeroes
            return "$." + precision + "~e";
          } // preserve insignificant zeroes


          return "$." + precision + "e";
      }
    } else if (absValue >= 0.0001 && absValue < 1 || absValue === 0) {
      switch (type) {
        case 'axis':
          if (round == null) {
            return '$';
          } else if (round < 0) {
            // trim insignificant zeroes
            return "$." + precision + "~";
          } // preserve insignificant zeroes


          return "$." + precision;

        default:
          if (round == null) {
            return '$.2';
          } else if (round < 0) {
            // trim insignificant zeroes
            return "$." + precision + "~";
          } // preserve insignificant zeroes


          return "$." + precision;
      }
    } // If the values are greater than 1 or less than -1


    switch (type) {
      case 'axis':
        if (round == null) {
          return '$~s';
        } else if (round < 0) {
          // trim insignificant zeroes
          return "$." + precision + "~s";
        } // preserve insignificant zeroes


        return "$." + precision + "s";
      // for tooltip, crossline and ref line/zone

      default:
        if (round == null) {
          return '$.2~s';
        } else if (round < 0) {
          // trim insignificant zeroes
          return "$." + precision + "~s";
        } // preserve insignificant zeroes


        return "$." + precision + "s";
    }
  } else {
    // If the user has opted set defaultFormat to false and a value is not provided
    // to round, simply trim away insignificant zeroes and use decimal
    // formatting with up to 12 digits of precision. We could just perform no
    // formatting at all, but that would lead to unsightly values with IEEE
    // Floating Point precision errors.
    if (round == null) return '$.12~r'; // If a positive value is provided to round, use fixed point precision

    if (round >= 0) return "$." + precision + "f"; // If a negative value is provided to round, use decimal precision

    return "$." + precision + "~r";
  }
},
    createFormatter = function createFormatter(formatConfig, _ref2) {
  var subType = _ref2.type,
      converter = _ref2.converter;

  if (typeof formatConfig.formatter === 'function') {
    // Append blank string to guard against possibly nullish/falsy/object
    // values returnde by the formatter function (especially when it is
    // defined by the user)
    return function (obj) {
      return formatConfig.formatter(obj) + '';
    };
  }

  var round = validateRound(formatConfig.round);
  return function (obj) {
    var specifier = typeof formatConfig.formatter === 'string' ? formatConfig.formatter : getSpecifier(Object.assign({}, formatConfig, {
      subType: subType,
      value: obj.value,
      type: obj.type,
      round: round
    })),
        hasSIPrefix = new _formatSpecifier.default(specifier).type === 's'; // formatPrefix interprets precision as fixed point precision instead of
    // as decimal precision (significant digits).

    return hasSIPrefix && (round == null || round >= 0) ? converter.formatPrefix(specifier, obj.value).format(obj.value) : converter.formatter(specifier).format(obj.value);
  };
},
    visibleAxes = function visibleAxes(cfg) {
  return !!cfg.visible;
},
    isLeftAligned = function isLeftAligned(_ref3) {
  var align = _ref3.align;
  return align === 'left';
},
    isRightAligned = function isRightAligned(_ref4) {
  var align = _ref4.align;
  return align === 'right';
},
    isTopAligned = function isTopAligned(_ref5) {
  var align = _ref5.align;
  return align === 'top';
},
    isBottomAligned = function isBottomAligned(_ref6) {
  var align = _ref6.align;
  return align === 'bottom';
},
    isValidYOrientation = function isValidYOrientation(orientation) {
  return orientation === 'left' || orientation === 'right';
},

/**
 * Reads the X and Y configs of a panel's configuration and appropraiately
 * sets the top, right, bottom and left border configurations within it.
 *
 * @param {Object} panelCfg The configuration of the panel within which the
 * top, right, left and bottom borders have to be added
 *
 * @return {Object} The input panel configuration with the border
 * configurations added within it
 */
mergeBorderConfig = function mergeBorderConfig(panelCfg) {
  var borderCfg = {
    leftBorder: false,
    rightBorder: false,
    topBorder: false,
    bottomBorder: false
  },
      xConfigs = panelCfg.xConfigs,
      yConfigs = panelCfg.yConfigs;

  if (xConfigs.find(isLeftAligned) || yConfigs.find(isLeftAligned)) {
    borderCfg.leftBorder = true;
  }

  if (xConfigs.find(isRightAligned) || yConfigs.find(isRightAligned)) {
    borderCfg.rightBorder = true;
  }

  if (xConfigs.find(isTopAligned) || yConfigs.find(isTopAligned)) {
    borderCfg.topBorder = true;
  }

  if (xConfigs.find(isBottomAligned) || yConfigs.find(isBottomAligned)) {
    borderCfg.bottomBorder = true;
  }

  return (0, _mergeRight.default)(panelCfg, borderCfg);
};

var _default = function _default(chart) {
  var usedCanvasIds = [],
      unusedCanvasIds = [],
      canvasIds,
      baseTextStyle = chart.getFromEnv('baseTextStyle'),
      dataSource = chart.getFromEnv('dataSource'),
      DEFAULT_AXIS_X = {
    orientation: 'bottom',
    align: 'bottom',
    tickpadding: 2,
    visible: true,
    overlap: false,
    domainline: false,
    outputtimeformat: {},
    style: {
      'label-major': Object.assign({
        fill: '#818181'
      }, baseTextStyle),
      'label-context': Object.assign({
        fill: '#818181'
      }, baseTextStyle)
    }
  },
      DEFAULT_AXIS_Y = {
    tickarguments: [4, 's'],
    ticksize: 5,
    tickpadding: 7,
    visible: true,
    overlap: false,
    domainline: false,
    style: {
      'label-major': Object.assign({
        'font-size': '11px'
      }, baseTextStyle),
      'tick-mark-major': {
        stroke: '#efefef'
      }
    }
  };

  var hydrateX = (0, _mergeRight.default)(DEFAULT_AXIS_X),
      hydrateY = (0, _mergeRight.default)(DEFAULT_AXIS_Y),
      chartConfig = chart.config,
      canvasAxisMap = chartConfig.canvasAxisMap,
      focusAxesX = chartConfig.focusAxesX,
      focusAxesY = chartConfig.focusAxesY,
      chartAttrs = chart.getFromEnv('chart-attrib'),
      canvasStyle = chart.getFromEnv('getStyleDef')(chartAttrs.style && chartAttrs.style.canvas),
      focusPanels = chartConfig.focusPanels.map(function (panel) {
    return (0, _mergeRight.default)(panel, {
      x: panel.x.map(function (xCfg) {
        var focusAxisX = focusAxesX[xCfg.index],
            formatObj = (0, _lib.pluck)(focusAxesX[xCfg.index].format, {}); // parse any information given by user, if not provided, use default

        focusAxisX.timeFormatterFn = typeof formatObj.formatter === 'function' ? function (options) {
          return formatObj.formatter.call(focusAxisX.scale, options);
        } : function (formatterObj) {
          return focusAxisX.scale.getFormattedTime && focusAxisX.scale.getFormattedTime(formatterObj, dataSource.tooltip && dataSource.tooltip.outputtimeformat);
        };
        return (0, _mergeRight.default)(hydrateX(xCfg), (0, _panelConfigurer.default)(focusAxesX, xCfg.index));
      }),
      y: panel.y.map(function (yCfg) {
        var focusAxisY = focusAxesY[yCfg.index],
            formatObj = Object.assign({
          defaultformat: true
        }, (0, _lib.pluck)(focusAxesY[yCfg.index].format, {})),
            formatLocale;
        focusAxisY.formatLabelPrefix = formatObj.prefix || _lib.BLANKSTRING;
        focusAxisY.formatLabelSuffix = formatObj.suffix || _lib.BLANKSTRING;
        formatLocale = Object.assign({}, _enUS.default, {
          prefix: focusAxisY.formatLabelPrefix,
          suffix: focusAxisY.formatLabelSuffix
        });
        focusAxisY.scale.setLocale(formatLocale);
        focusAxisY.formatterFn = createFormatter(formatObj, {
          converter: new _numberConverter.NumberConverter(formatLocale),
          type: focusAxisY.type
        });
        return (0, _mergeRight.default)(hydrateY(yCfg), (0, _panelConfigurer.default)(focusAxesY, yCfg.index));
      })
    });
  }),
      createPanelComponents = function createPanelComponents(_ref7, i) {
    var axisConfigsX = _ref7.x,
        axisConfigsY = _ref7.y,
        plotConfigs = _ref7.plots;
    var canvasId = "canvas_" + i;
    var axisCount = {
      left: 0,
      right: 0
    };

    if (!canvasAxisMap[canvasId]) {
      canvasAxisMap[canvasId] = {
        x: [],
        y: []
      };
    }

    axisConfigsX.filter(visibleAxes).forEach(function (axisConfig, ai) {
      var axisId = "axesX_" + i + "_" + ai; // Set alignment for the X-axis

      axisConfig.align = axisConfig.align.toLowerCase();

      if (!['bottom', 'top'].includes(axisConfig.align)) {
        axisConfig.align = BOTTOM;
      }

      axisConfig.tickvisibilitylimit = {
        start: _lib.UNDEF,
        end: _lib.UNDEF
      };
      (0, _lib.componentFactory)(chart, _axis.default, axisId, 1, [axisConfig]);

      if (!canvasAxisMap[canvasId].x.includes(axisId)) {
        canvasAxisMap[canvasId].x.push(axisId);
      }
    });
    axisConfigsY.filter(visibleAxes).forEach(function (axisConfig, ai) {
      var axisId = "axesY_" + i + "_" + ai; // If orientation is provided correctly, change the align value to it.

      if (isValidYOrientation(axisConfig.orientation)) {
        axisConfig.align = axisConfig.orientation;
      } // Set orientation for the Y-axis as per the calculated align.


      axisConfig.orientation = axisConfig.align;
      axisConfig.domainline = axisCount[axisConfig.align] > 0;
      if (axisConfig.type === 'log') axisConfig.tickarguments = [4, '~s'];
      axisCount[axisConfig.align]++;
      axisConfig.tickvisibilitylimit = {
        start: _lib.UNDEF,
        end: _lib.UNDEF
      };
      (0, _lib.componentFactory)(chart, _axis.default, axisId, 1, [axisConfig]);

      if (!canvasAxisMap[canvasId].y.includes(axisId)) {
        canvasAxisMap[canvasId].y.push(axisId);
      }
    }); // Make a list of canvas IDs that are being used/re-used

    usedCanvasIds.push(canvasId);
    (0, _lib.componentFactory)(chart, _canvas.default, canvasId, 1, [mergeBorderConfig({
      plotConfigs: plotConfigs,
      tableMap: chartConfig.focusTableMap,
      xConfigs: axisConfigsX,
      yConfigs: axisConfigsY,
      enableGridLines: true,
      gridBandSupported: axisConfigsY[0].type !== 'log',
      enableMouseTracking: 1,
      enableMarkers: 1,
      enableInteraction: 1,
      canvasStyle: canvasStyle
    })]);
  };

  focusPanels.forEach(createPanelComponents); // Remove any unused canvases

  canvasIds = Object.keys(chart.getChildren()).filter(canvases);
  unusedCanvasIds = canvasIds.filter(function (oldId) {
    return !usedCanvasIds.includes(oldId);
  });
  unusedCanvasIds.forEach(function (unusedId) {
    chart.getChildren(unusedId).forEach(removeComponent);
  });
  chartConfig.focusPanels = focusPanels;
};

exports["default"] = _default;

/***/ }),

/***/ 977:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _lib = __webpack_require__(274);

var _toolbarManager = _interopRequireDefault(__webpack_require__(978));

var _default = function _default(chart) {
  var srs = chart.getChildren('standardRangeSelector'),
      crs = chart.getChildren('customRangeSelector'),
      manager;
  (0, _lib.componentFactory)(chart, _toolbarManager.default, 'toolbar-manager');
  manager = chart.getChildren('toolbar-manager')[0];
  srs && srs[0] && !srs[0].getState('removed') ? manager.register('srs', srs[0]) : manager.deRegister('srs');
  crs && crs[0] && !crs[0].getState('removed') ? manager.register('crs', crs[0]) : manager.deRegister('crs');
  manager.configure();
};

exports["default"] = _default;

/***/ }),

/***/ 863:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _defineProperty2 = _interopRequireDefault(__webpack_require__(273));

var _binDecider = _interopRequireWildcard(__webpack_require__(861));

var _index = __webpack_require__(274);

var _index2 = __webpack_require__(864);

var _timeIntervals2 = __webpack_require__(490);

var _utc = __webpack_require__(497);

var _ftLog = _interopRequireDefault(__webpack_require__(865));

var _extent = _interopRequireDefault(__webpack_require__(538));

var _linear = _interopRequireDefault(__webpack_require__(541));

var _isObject = _interopRequireDefault(__webpack_require__(481));

var _timeBin = _interopRequireDefault(__webpack_require__(868));

var _timeConverter = _interopRequireDefault(__webpack_require__(350));

var _utcBin = _interopRequireDefault(__webpack_require__(876));

var _capsFirst = _interopRequireDefault(__webpack_require__(862));

var _standardBins = __webpack_require__(877);

var _atomicity = __webpack_require__(859);

var _time = __webpack_require__(875);

var _operators = __webpack_require__(483);

var _timeBucket = __webpack_require__(874);

var _timeInterval = _interopRequireDefault(__webpack_require__(355));

var _time2 = _interopRequireDefault(__webpack_require__(878));

var _utc2 = _interopRequireDefault(__webpack_require__(879));

var _isArray = _interopRequireDefault(__webpack_require__(349));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var TYPES = {
  time: _timeBin.default,
  utctime: _utcBin.default,
  scaletime: _time2.default,
  scaleutctime: _utc2.default,
  numeric: _linear.default,
  log: _ftLog.default
},
    SHARE_RATIO = 0.8;

var _default = function _default(chart) {
  var _ref6;

  var config = chart.config,
      contextAxesX = config.contextAxesX,
      clipDatesObj = (0, _isArray.default)(contextAxesX[0].clip) ? contextAxesX[0].clip : [],
      focusAxesX = config.focusAxesX,
      focusAxesY = config.focusAxesY,
      dateColumnName = chart.getFromEnv('dateColumn').name,
      customBin = focusAxesX[0].binning,
      table = config.dataTable,
      _table$getData = table.getData(),
      data = _table$getData.data,
      schema = _table$getData.schema,
      isUTC = chart.getFromEnv('UTC'),
      autoClipNullData = contextAxesX[0].autoclipnulldata ? contextAxesX[0].autoclipnulldata.toLowerCase() : null,
      autoClipMultiplier = contextAxesX[0].autoclipmultiplier || 1,
      clipFormat = '%b %d %Y %H:%M:%S:%L',
      timeConstant,
      firstDate,
      timeIntervals = isUTC ? {
    Year: new _timeInterval.default(_utc.utcYearObj),
    Month: new _timeInterval.default(_utc.utcMonthObj),
    Week: new _timeInterval.default(_utc.utcWeekObj),
    Day: new _timeInterval.default(_utc.utcDayObj),
    Hour: new _timeInterval.default(_utc.utcHourObj),
    Minute: new _timeInterval.default(_utc.utcMinuteObj),
    Second: new _timeInterval.default(_timeIntervals2.secondObj),
    Millisecond: new _timeInterval.default(_timeIntervals2.millisecondObj)
  } : {
    Year: new _timeInterval.default(_timeIntervals2.yearObj),
    Month: new _timeInterval.default(_timeIntervals2.monthObj),
    Week: new _timeInterval.default(_timeIntervals2.weekObj),
    Day: new _timeInterval.default(_timeIntervals2.dayObj),
    Hour: new _timeInterval.default(_timeIntervals2.hourObj),
    Minute: new _timeInterval.default(_timeIntervals2.minuteObj),
    Second: new _timeInterval.default(_timeIntervals2.secondObj),
    Millisecond: new _timeInterval.default(_timeIntervals2.millisecondObj)
  },
      isWeekFormat = function isWeekFormat(format) {
    return /^(%w[^%y]*%y)$/i.test(format);
  },
      weekDefaultBining = {
    week: 0
  },
      unclippedTimeIntervals = isUTC ? {
    Day: _utc.utcDay,
    Hour: _utc.utcHour,
    Week: _utc.utcWeek,
    Year: _utc.utcYear,
    Month: _utc.utcMonth,
    Minute: _utc.utcMinute,
    Second: _utc.utcSecond,
    Millisecond: _utc.utcMillisecond
  } : {
    Day: _timeIntervals2.timeDay,
    Hour: _timeIntervals2.timeHour,
    Week: _timeIntervals2.timeWeek,
    Year: _timeIntervals2.timeYear,
    Month: _timeIntervals2.timeMonth,
    Minute: _timeIntervals2.timeMinute,
    Second: _timeIntervals2.timeSecond,
    Millisecond: _timeIntervals2.timeMillisecond
  },
      chartWidth = chart.getFromEnv('chartWidth'),
      range = [0, SHARE_RATIO * chartWidth / focusAxesX.length],
      parsedClipDates,
      repeatClips,
      singleClips,
      clippedRows,
      UNDEF,
      makeScale = function makeScale(_ref) {
    var _ref$type = _ref.type,
        type = _ref$type === void 0 ? 'time' : _ref$type;
    var Scale = (type === 'time' && isUTC ? TYPES['utc' + type] : TYPES[type]) || TYPES.time;
    return new Scale();
  },
      makeBin = function makeBin(_ref2, index) {
    var _schema$dateColumnInd;

    var _ref2$type = _ref2.type,
        type = _ref2$type === void 0 ? 'time' : _ref2$type,
        plot = _ref2.plot;
    var Scale = (type === 'time' && isUTC ? TYPES['scaleutc' + type] : TYPES['scale' + type]) || TYPES.scaletime,
        scale = new Scale(),
        dateColumnIndex = config == null ? void 0 : config.dateColumnIndex,
        format = dateColumnIndex !== UNDEF ? (_schema$dateColumnInd = schema[dateColumnIndex]) == null ? void 0 : _schema$dateColumnInd.format : null,
        bin;

    if (!customBin && format && isWeekFormat(format)) {
      customBin = weekDefaultBining;
    }

    if (customBin) {
      bin = new _binDecider.default((0, _standardBins.getCustomBins)(timeIntervals.Year, timeIntervals.Month, timeIntervals.Week, timeIntervals.Day, timeIntervals.Hour, timeIntervals.Minute, timeIntervals.Second, timeIntervals.Millisecond, customBin));
    } else {
      bin = new _binDecider.default((0, _standardBins.getDefaultBins)(timeIntervals.Year, timeIntervals.Month, timeIntervals.Week, timeIntervals.Day, timeIntervals.Hour, timeIntervals.Minute, timeIntervals.Second, timeIntervals.Millisecond));
    }

    bin.setScale(scale);
    bin.setBinRange(range);
    bin.setRangeThreshold(config.pixelMultiplier * _binDecider.DEFAULT_THRESHOLD_PIXELS);
    return bin;
  },
      makeScalesBins = function makeScalesBins(axesX) {
    var scales = [],
        bins = [],
        i,
        len = axesX.length;

    for (i = 0; i < len; i++) {
      scales[i] = makeScale(axesX[i]);
      scales[i].setTimeInterval(timeIntervals);
      scales[i].setUnclippedTimeIntervals(unclippedTimeIntervals);
      bins[i] = makeBin(axesX[i], i);
      if (parsedClipDates.length) scales[i].setClippings(parsedClipDates); // set the standard bins of the scales

      // set the standard bins of the scales
      scales[i].setThresholdIntervals((0, _standardBins.getDefaultBins)(timeIntervals.Year, timeIntervals.Month, timeIntervals.Week, timeIntervals.Day, timeIntervals.Hour, timeIntervals.Minute, timeIntervals.Second, timeIntervals.Millisecond));
    }

    return {
      scales: scales,
      bins: bins
    };
  },
      contextInfo,
      focusInfo,
      minMaxFn = function minMaxFn(_ref3) {
    var value = _ref3.value;
    return [table.min(value), table.max(value)];
  },
      calculateDomain = function calculateDomain(axis) {
    var _ref4;

    var arr = axis.plot.map(minMaxFn),
        context = (0, _extent.default)((_ref4 = []).concat.apply(_ref4, arr), Number),
        minBinDuration = contextInfo.bins[0].getBinMin()[2],
        value = axis.plot[0].value,
        format = axis.format || schema.find(function (_ref5) {
      var name = _ref5.name;
      return name === value;
    }).format,
        parser = isUTC ? _timeConverter.default.utcParser(format) : _timeConverter.default.parser(format),
        initialInterval = (0, _isObject.default)(axis.initialinterval) ? axis.initialinterval : {},
        setMin = function setMin(userMin, dataMin) {
      var min = parser.parse(userMin);

      if (min === null) {
        return dataMin;
      }

      return min < dataMin ? +min : dataMin;
    },
        setMax = function setMax(userMax, dataMax) {
      var max = parser.parse(userMax);

      if (max === null) {
        return dataMax;
      }

      return max > dataMax ? +max : dataMax;
    },
        focus; // keeping the raw data start


    // keeping the raw data start
    config.rawDataXStart = context[0];

    if (!data.length && (typeof context[0] === 'undefined' || typeof context[1] === 'undefined')) {
      context[0] = +_time.TIME_SPAN[0];
      context[1] = +_time.TIME_SPAN[1];
    } // if the spread is provided then
    // the lower limit will be based on spread


    // if the spread is provided then
    // the lower limit will be based on spread
    if (config.timeSpread && config.timeSpread.duration >= minBinDuration * 3) {
      context[0] = +timeIntervals[config.timeSpread.unit.name].offset(context[1], -config.timeSpread.multiplier);
    } else if (data.length < 3) {
      if (data.length === 0) {
        context[0] = +_time.TIME_SPAN[0];
        context[1] = context[0] + minBinDuration * 3;
      } else {
        context[0] = context[1] - minBinDuration * 2;
      }
    }

    focus = context.slice();
    focus[0] = setMax(initialInterval.from, focus[0]);
    focus[1] = setMin(initialInterval.to, focus[1]);
    focus = (0, _extent.default)(focus);
    return {
      focus: focus,
      context: context
    };
  },
      setClipObjects = function setClipObjects(_clipDates, _timeIntervals, rawDataXStart, rawDataXEnd) {
    var clipDates = _clipDates,
        timeInterval = _timeIntervals;
    timeInterval.Day.setClipDates(clipDates);
    timeInterval.Day.setTimeUniverse([rawDataXStart, rawDataXEnd]);
    timeInterval.Hour.setClipDates(clipDates);
    timeInterval.Hour.setTimeUniverse([rawDataXStart, rawDataXEnd]);
    timeInterval.Week.setClipDates(clipDates);
    timeInterval.Week.setTimeUniverse([rawDataXStart, rawDataXEnd]);
    timeInterval.Year.setClipDates(clipDates);
    timeInterval.Year.setTimeUniverse([rawDataXStart, rawDataXEnd]);
    timeInterval.Month.setClipDates(clipDates);
    timeInterval.Month.setTimeUniverse([rawDataXStart, rawDataXEnd]);
    timeInterval.Minute.setClipDates(clipDates);
    timeInterval.Minute.setTimeUniverse([rawDataXStart, rawDataXEnd]);
    timeInterval.Second.setClipDates(clipDates);
    timeInterval.Second.setTimeUniverse([rawDataXStart, rawDataXEnd]);
    timeInterval.Millisecond.setClipDates(clipDates);
    timeInterval.Millisecond.setTimeUniverse([rawDataXStart, rawDataXEnd]);
  },
      getFormattedDate = function getFormattedDate(timestamp) {
    var addedHours = 0,
        date,
        hour,
        min,
        sec,
        millisec;
    date = new Date(timestamp);
    hour = date.getHours() - addedHours;
    min = date.getMinutes();
    sec = date.getSeconds();
    millisec = date.getMilliseconds();
    return date.toDateString().slice(4) + ' ' + hour + ':' + min + ':' + sec + ':' + millisec;
  },
      updateTimeVars = function updateTimeVars() {
    switch (autoClipNullData) {
      case 'year':
        timeConstant = 31536000000;
        break;

      case 'month':
        timeConstant = 2678400000;
        break;

      case 'day':
        timeConstant = 86400000;
        break;

      case 'hour':
        timeConstant = 3600000;
        break;

      case 'minute':
        timeConstant = 60000;
        break;

      case 'second':
        timeConstant = 1000;
        break;

      case 'millisecond':
        timeConstant = 1;
        break;

      default:
        timeConstant = 0;
    }
  },
      selectIntervalRange = function selectIntervalRange() {
    var intervalRange = 60000,
        timeDelta = 1,
        formatString = schema[0].format;

    if (formatString.search(/%[-,_,0]?[L]/) !== -1) {
      intervalRange = 1;
    } else if (formatString.search(/%[-,_,0]?[s,S]/) !== -1) {
      intervalRange = 1000;
    } else if (formatString.search(/%[-,_,0]?[M]/) !== -1) {
      intervalRange = 60000;
    } else if (formatString.search(/%[-,_,0]?[H,I]/) !== -1) {
      intervalRange = 3600000;
    } else if (formatString.search(/%[-,_,0]?[d,a,A,j]/) !== -1) {
      intervalRange = 86400000;
    } else if (formatString.search(/%[-,_,0]?[b,B,m]/) !== -1) {
      intervalRange = 2678400000;
    } else if (formatString.search(/%[-,_,0]?[y,Y]/) !== -1) {
      intervalRange = 31536000000;
    }

    return {
      intervalRange: intervalRange,
      timeDelta: timeDelta
    };
  },
      setDateForDynamicInterval = function setDateForDynamicInterval(minDate) {
    if (autoClipNullData === 'year') {
      return minDate.setFullYear(minDate.getFullYear() + autoClipMultiplier) - 1;
    } else if (autoClipNullData === 'month') {
      return minDate.setMonth(minDate.getMonth() + autoClipMultiplier) - 1;
    }
  },
      addAutoClipping = function addAutoClipping(rangeInterval, timeDelta, valueIndex) {
    var chartIndex = 0,
        maxChartIndex = data.length,
        currentMax,
        currentIntervalMin = dataXStart,
        currentIntervalMax = currentMax = currentIntervalMin + timeConstant * autoClipMultiplier - timeDelta;

    if (rangeInterval === 2678400000 || rangeInterval === 31536000000) {
      setDateForDynamicInterval(new Date(currentIntervalMin));
    }

    while (currentIntervalMax <= dataXEnd) {
      if (chartIndex < maxChartIndex) {
        if (data[chartIndex][0] >= currentIntervalMin && data[chartIndex][0] <= currentIntervalMax && (data[chartIndex][valueIndex] === 0 || data[chartIndex][valueIndex])) {
          currentMax = currentIntervalMax;

          while (currentIntervalMin <= currentMax) {
            var dt = new Date(currentIntervalMin);

            if (rangeInterval === 2678400000) {
              currentIntervalMin = dt.setMonth(dt.getMonth() + 1);
              currentIntervalMax = setDateForDynamicInterval(new Date(currentIntervalMin));
            } else if (rangeInterval === 31536000000) {
              currentIntervalMin = dt.setFullYear(dt.getFullYear() + 1);
              currentIntervalMax = setDateForDynamicInterval(new Date(currentIntervalMin));
            } else {
              currentIntervalMin = currentIntervalMin + rangeInterval;
              currentIntervalMax = currentIntervalMax + rangeInterval;
            }

            while (data[chartIndex][0] < currentIntervalMin) {
              chartIndex++;

              if (chartIndex === maxChartIndex || !(data[chartIndex][valueIndex] === 0 || data[chartIndex][valueIndex])) {
                break;
              }
            }

            if (data[chartIndex][0] > currentIntervalMax || currentIntervalMin === dataXEnd || !(data[chartIndex][valueIndex] === 0 || data[chartIndex][valueIndex])) {
              currentMax = currentIntervalMax;
              break;
            }
          }
        } else {
          if (data[chartIndex][0] < currentIntervalMin || data[chartIndex][0] >= currentIntervalMin && data[chartIndex][0] <= currentIntervalMax) {
            chartIndex++;
          } else {
            // Future Scope(Support-2009): Based on flag, will need to check if no valid value is present for other data-series as well to perform auto-time clipping
            var obj = {
              format: clipFormat,
              from: getFormattedDate(currentIntervalMin),
              to: getFormattedDate(currentIntervalMax)
            };
            clipDatesObj.push(obj);
            currentIntervalMin = currentIntervalMax + timeDelta;

            if (rangeInterval === 2678400000 || rangeInterval === 31536000000) {
              currentIntervalMax = setDateForDynamicInterval(new Date(currentIntervalMin));
            } else {
              currentIntervalMax = currentIntervalMax + timeConstant * autoClipMultiplier;
            }

            currentMax = currentIntervalMax;
          }
        }
      }
    }
  },
      calculatedDomains,
      dataXStart,
      dataXEnd,
      context,
      arr,
      clips = {},
      ops = [];

  arr = contextAxesX[0].plot.map(minMaxFn);
  context = (0, _extent.default)((_ref6 = []).concat.apply(_ref6, arr), Number);
  dataXStart = context[0];
  dataXEnd = context[1]; // code to initiate auto time-axis clipping

  if (autoClipNullData) {
    updateTimeVars();

    if (timeConstant !== 0) {
      if (typeof autoClipMultiplier === 'number' && isFinite(autoClipMultiplier) && Math.floor(autoClipMultiplier) === autoClipMultiplier && autoClipMultiplier > 0) {
        var timeVars = selectIntervalRange(),
            yValueIndex;

        for (var yValues = 0; yValues < focusAxesY.length; yValues++) {
          // iterating through all the data series(y-values) for auto time clipping
          for (var posn = 0; posn < schema.length; posn++) {
            if (focusAxesY[yValues].plot[0].value === schema[posn].name) {
              yValueIndex = posn;
              addAutoClipping(timeVars.intervalRange, timeVars.timeDelta, yValueIndex);
              break;
            }
          }
        }
      }
    }
  }

  parsedClipDates = clipDatesObj.map(function (clip) {
    var parser = config.baseTimeConverter,
        parsedRepeat,
        parsedClipObj,
        level = _index.BLANKSTRING,
        timeInterval,
        from,
        to;

    if (clip.format) {
      parser = isUTC ? _timeConverter.default.utcParser(clip.format) : _timeConverter.default.parser(clip.format);
    }

    level = (0, _timeBucket.getMinPlaceHolder)(parser.toString());
    timeInterval = timeIntervals[(0, _capsFirst.default)(level)];

    if (clip.repeat) {
      parsedRepeat = _objectSpread({}, clip.repeat);
      parsedRepeat.multiplier = Math.abs(parseInt(parsedRepeat.multiplier, 10));
    }

    from = +parser.parse(clip.from);
    to = +parser.parse(clip.to);

    if (from > to) {
      var _ref7 = [to, from];
      from = _ref7[0];
      to = _ref7[1];
    }

    to = +timeInterval.offset(to);
    parsedClipObj = _objectSpread(_objectSpread({}, clip), {}, {
      format: parser.toString(),
      to: to,
      from: from,
      level: (0, _timeBucket.getMinPlaceHolder)(parser.toString())
    });

    if (parsedRepeat) {
      parsedClipObj.repeat = parsedRepeat;
    }

    return parsedClipObj;
  });
  clips = (0, _index2.segregateClips)(parsedClipDates);
  repeatClips = clips.repeatClips;
  singleClips = clips.singleClips;

  clippedRows = function clippedRows(row, col) {
    var t = row[col[dateColumnName]];
    return t !== (0, _index2.getUnclippedValue)(t, repeatClips, singleClips);
  };

  if (parsedClipDates.length) {
    ops = [(0, _operators.filter)(clippedRows)];
    setClipObjects(parsedClipDates, timeIntervals, dataXStart, dataXEnd);
    chart.cloneTable();
    table = config.dataTable; // since new DT is created

    var _table$getData2 = table.getData();

    data = _table$getData2.data;
    schema = _table$getData2.schema;
  }

  contextInfo = makeScalesBins(contextAxesX);
  focusInfo = makeScalesBins(focusAxesX);
  table.getDataStore().on('itemsAdded', chart._onDataUpdate);
  chart.addEventListener('beforeremove', chart._offDataUpdate);
  chart.addToEnv('timeIntervals', timeIntervals);
  chart.addToEnv('unclippedTimeIntervals', unclippedTimeIntervals);

  if (config.timeSpread && config.timeSpread.duration) {
    // In case timespread is provided and data is not present, take the start of
    // default time as first date.
    firstDate = data.length ? data[data.length - 1][config.dateColumnIndex] : +_time.TIME_SPAN[0];
    ops = ops.concat((0, _operators.less)(dateColumnName, // Take minimum time achieved by removing timespread duration vs 3
    // bins
    Math.min(config.timeSpread.interval.offset(firstDate, -config.timeSpread.multiplier), contextInfo.bins[0].getRangeThreshold()[0].offset(firstDate, -2))));
  }

  if (ops.length) {
    table.getDataStore().deleteRows(_operators.pipe.apply(void 0, ops), table.getID());
  }

  data = table.getData().data;

  if (!config.atomicity) {
    var info = config.atomicity = _objectSpread({}, (0, _atomicity.getFormatStore)(schema[config.dateColumnIndex].format));

    info.minBin = (0, _atomicity.getAtomicity)(_objectSpread(_objectSpread({}, info), {}, {
      index: config.dateColumnIndex,
      data: data,
      bins: contextInfo.bins[0].getStandardBins(),
      intervalIndexMap: contextInfo.bins[0].intervalIndexMap,
      ms: timeIntervals.Millisecond
    }));
  }

  focusInfo.bins[0].setBinMin(config.atomicity.minBin);
  focusInfo.scales[0].setBinMin(focusInfo.bins[0].getBinMin()).setRangeThreshold(focusInfo.bins[0].getRangeThreshold());
  contextInfo.bins[0].setBinMin(config.atomicity.minBin);
  contextInfo.scales[0].setBinMin(contextInfo.bins[0].getBinMin()).setRangeThreshold(contextInfo.bins[0].getRangeThreshold());
  calculatedDomains = calculateDomain(contextAxesX[0]);
  contextInfo.scales.forEach(function (scale) {
    scale.setFirstData(config.rawDataXStart);
  });
  focusInfo.scales.forEach(function (scale) {
    scale.setFirstData(config.rawDataXStart);
  });
  chart.addToEnv('contextScalesX', contextInfo.scales);
  chart.addToEnv('focusScalesX', focusInfo.scales);
  chart.addToEnv('contextBins', contextInfo.bins);
  chart.addToEnv('focusBins', focusInfo.bins);
  config.clipDates = parsedClipDates;
  chart.setContextLimit(calculatedDomains.context);
  chart.setFocusLimit(calculatedDomains.focus);
};

exports["default"] = _default;

/***/ }),

/***/ 880:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _timeBin = _interopRequireDefault(__webpack_require__(868));

var _linear = _interopRequireDefault(__webpack_require__(541));

var _ftLog = _interopRequireDefault(__webpack_require__(865));

var TYPES = {
  time: _timeBin.default,
  linear: _linear.default,
  log: _ftLog.default
};

var _default = function _default(chart) {
  var chartConf = chart.config,
      focusAxesY = chartConf.focusAxesY,
      contextAxesY = chartConf.contextAxesY || [],
      makeScales = function makeScales(_ref) {
    var type = _ref.type,
        base = _ref.base;
    var Scale = TYPES[type] || TYPES.linear;

    if (Scale === _ftLog.default && +base > 0) {
      return new Scale().setBase(base);
    }

    return new Scale();
  };

  chart.addToEnv('contextScalesY', contextAxesY.map(makeScales));
  chart.addToEnv('focusScalesY', focusAxesY.map(makeScales));
};

exports["default"] = _default;

/***/ }),

/***/ 805:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _assertThisInitialized2 = _interopRequireDefault(__webpack_require__(292));

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _defineProperty2 = _interopRequireDefault(__webpack_require__(273));

var _chain = _interopRequireDefault(__webpack_require__(806));

var _clone = _interopRequireDefault(__webpack_require__(834));

var _uniq = _interopRequireDefault(__webpack_require__(838));

var _xprod = _interopRequireDefault(__webpack_require__(852));

var _equals = _interopRequireDefault(__webpack_require__(845));

var _addIndex = _interopRequireDefault(__webpack_require__(853));

var _lib = __webpack_require__(274);

var _operators = __webpack_require__(483);

var _extent3 = _interopRequireDefault(__webpack_require__(538));

var _safeMax = _interopRequireDefault(__webpack_require__(540));

var _timeIntervals = __webpack_require__(490);

var _utc = __webpack_require__(497);

var _isObject = _interopRequireDefault(__webpack_require__(481));

var _ordinal = _interopRequireDefault(__webpack_require__(855));

var _isValidNumber = _interopRequireDefault(__webpack_require__(856));

var _arrayHasContent = _interopRequireDefault(__webpack_require__(446));

var _datetimeEnums = __webpack_require__(358);

var _stringHasContent = _interopRequireDefault(__webpack_require__(857));

var _commonchartapi = _interopRequireDefault(__webpack_require__(520));

var _colormanager = _interopRequireDefault(__webpack_require__(531));

var _atomicity = __webpack_require__(859);

var _binDecider = __webpack_require__(861);

var _diff = _interopRequireDefault(__webpack_require__(569));

var _capsFirst = _interopRequireDefault(__webpack_require__(862));

var _x = _interopRequireDefault(__webpack_require__(863));

var _y = _interopRequireDefault(__webpack_require__(880));

var _panel = _interopRequireDefault(__webpack_require__(881));

var _caption = _interopRequireDefault(__webpack_require__(947));

var _axis = _interopRequireDefault(__webpack_require__(949));

var _index = __webpack_require__(951);

var _panel2 = _interopRequireDefault(__webpack_require__(952));

var _series = _interopRequireDefault(__webpack_require__(956));

var _background = _interopRequireDefault(__webpack_require__(957));

var _line = _interopRequireDefault(__webpack_require__(907));

var _navigatorTime = _interopRequireDefault(__webpack_require__(959));

var _customRangeSelector = _interopRequireDefault(__webpack_require__(968));

var _toolbarManagerFactory = _interopRequireDefault(__webpack_require__(977));

var _legendFactory = _interopRequireDefault(__webpack_require__(979));

var _toolbarFactory = _interopRequireDefault(__webpack_require__(980));

var _multicanvasCrosslineManager = _interopRequireDefault(__webpack_require__(982));

var _standardRangeSelector = _interopRequireDefault(__webpack_require__(984));

var _isArray = _interopRequireDefault(__webpack_require__(349));

var _timeConverter = _interopRequireDefault(__webpack_require__(350));

var _clipUtils = __webpack_require__(864);

var _fcTimeSeparator = _interopRequireDefault(__webpack_require__(504));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var standardTimeIntervals = {
  day: _timeIntervals.timeDay,
  hour: _timeIntervals.timeHour,
  week: _timeIntervals.timeWeek,
  year: _timeIntervals.timeYear,
  month: _timeIntervals.timeMonth,
  minute: _timeIntervals.timeMinute,
  second: _timeIntervals.timeSecond,
  millisecond: _timeIntervals.timeMillisecond
},
    utcStandardTimeIntervals = {
  day: _utc.utcDay,
  hour: _utc.utcHour,
  week: _utc.utcWeek,
  year: _utc.utcYear,
  month: _utc.utcMonth,
  minute: _utc.utcMinute,
  second: _utc.utcSecond,
  millisecond: _utc.utcMillisecond
},
    DEFAULT_CANVAS_DISTANCE = 20,
    DEFAULT_TIMENAV_HEIGHT_RATIO = 0.3,
    DEFAULT_AXIS_HEIGHT_RATIO = 0.6,
    DEFAULT_CAPTION_HEIGHT_RATIO = 0.3,
    DEFAULT_LEGEND_RATIO = 0.1,
    CANVAS_TOP_PADDING = 6,
    LINE_HEIGHT_FACTOR = 1.2,
    STYLE_STR_ONE = "style='",
    STYLE_STR_TWO = "'",
    MONTH_MID = 14,
    dropHash = _lib.regex.dropHash,
    AGGREGATE = 'aggregate',
    LEGEND_ALIGNMENT = 6,
    date = function date(s) {
  if (s === void 0) {
    s = 0;
  }

  return new Date(s);
},
    toString = function toString(d) {
  if (d === void 0) {
    d = '';
  }

  return d.toString();
},
    // Determines if the input is a string which is not the string 'none'
isDashedString = function isDashedString(str) {
  return typeof str === 'string' && str !== 'none';
},
    columnsFilter = function columnsFilter(table, filterFn) {
  return table.getSchema().filter(filterFn).map(function (scheme) {
    return scheme.name;
  });
},
    permuteIndices = function permuteIndices(arr) {
  return arr.map(function (p) {
    return {
      x: p.x,
      y: p.y,
      plots: (0, _xprod.default)(p.x.map(function (x) {
        return x.index;
      }), p.y.map(function (y) {
        return y.index;
      })).map(function (prod) {
        return {
          x: prod[0],
          y: prod[1]
        };
      })
    };
  });
},
    reducersum = function reducersum(a, b) {
  return a + b;
},
    getValidProportions = function getValidProportions(_prop, length) {
  var finalProp = {},
      prop = _prop,
      proparray = []; // Default array with canvas proportions set to 1

  for (var i = 0; i < length; i++) {
    proparray.push(1);
  }

  finalProp.proportions = proparray;
  finalProp.totalProportions = length;

  if (typeof prop === 'string') {
    prop = prop.split(':');
  }

  if (Array.isArray(prop)) {
    prop = prop.filter(function (value) {
      return value && !isNaN(Number(value)) && Number(value) > 0;
    }); // If length of validated array equal to focuspanel length, assign the array proportions and the totalproportions

    if (prop.length === length) {
      prop = prop.map(function (value) {
        return Number(value);
      });
      finalProp.proportions = prop;
      finalProp.totalProportions = prop.reduce(reducersum, 0);
    }
  }

  return finalProp;
},
    filterInformation = function filterInformation(ob) {
  return Object.assign({}, ob, {
    filter: ob.plot.map(function (n) {
      return n.value;
    }),
    filterInfo: {}
  });
},
    getIndex = function getIndex(id) {
  return +id.split('_').pop();
},
    // asyncDraw = c => c.asyncDraw(),
toolbarPositionParser = function toolbarPositionParser(positionArg) {
  var position = positionArg;

  switch (position) {
    case 'tr':
    case 'rt':
    case 'top right':
    case 'right top':
      position = 'tr';
      break;

    case 'br':
    case 'rb':
    case 'bottom right':
    case 'right bottom':
      position = 'br';
      break;

    case 'tl':
    case 'lt':
    case 'top left':
    case 'left top':
      position = 'tl';
      break;

    case 'bl':
    case 'lb':
    case 'bottom left':
    case 'left bottom':
      position = 'bl';
      break;

    default:
      position = 'tr';
  }

  return position;
},
    isDateScheme = function isDateScheme(scheme) {
  return scheme.type === 'date';
},
    isIntervalScheme = function isIntervalScheme(scheme) {
  return scheme.type === 'interval';
},
    isTemporalScheme = function isTemporalScheme(scheme) {
  return isDateScheme(scheme) || isIntervalScheme(scheme);
},
    isNumericScheme = function isNumericScheme(scheme) {
  return scheme.type === 'number';
},
    isStringyScheme = function isStringyScheme(scheme) {
  return scheme.type === 'string';
},
    flatMap = (0, _addIndex.default)(_chain.default),
    updateSet = function updateSet(set, arr) {
  if (set === void 0) {
    set = new Set();
  }

  if (arr === void 0) {
    arr = [];
  }

  var oldItemArr = Array.from(set),
      removedItems = (0, _diff.default)(oldItemArr, arr);
  removedItems.forEach(function (item) {
    return set['delete'](item);
  });
  arr.forEach(function (item) {
    return set.add(item);
  });
},

/**
 * Returns an array of multiple canvases using x and y axes.
 */
defaultPanelsMulticanvas = function defaultPanelsMulticanvas(xs, ys) {
  return flatMap(function (fx, ix) {
    return ys.map(function (fy, iy, yArr) {
      return {
        x: [{
          index: ix,
          visible: iy === yArr.length - 1
        }],
        y: [{
          index: iy,
          align: 'left'
        }]
      };
    });
  }, xs);
},

/**
 * Returns an array of a single canvas using x and y axes.
 */
defaultPanelsSingleCanvas = function defaultPanelsSingleCanvas(xs, ys) {
  return flatMap(function (fx, ix) {
    return {
      x: [{
        index: ix,
        visible: true
      }],
      y: ys.map(function (fy, iy) {
        return {
          index: iy,
          align: iy % 2 === 0 ? 'left' : 'right'
        };
      })
    };
  }, xs);
},
    parsePaletteColor = function parsePaletteColor(paletteInfo) {
  if (paletteInfo === void 0) {
    paletteInfo = [];
  }

  var colorArr = [];

  if ((0, _arrayHasContent.default)(paletteInfo)) {
    colorArr = paletteInfo.slice();
  } else if ((0, _stringHasContent.default)(paletteInfo)) {
    colorArr = paletteInfo.split(/\s*,\s*/);
  }

  colorArr = colorArr.filter(function (color) {
    return !!color;
  });
  return colorArr.map(function (color) {
    return (0, _lib.hashify)(color);
  });
},
    setLineHeight = function setLineHeight(styleObj, baseFontSize) {
  if (typeof styleObj !== 'object') {
    return;
  } // Calculate line height if not explicitly provided by the user


  if (!styleObj['line-height']) {
    styleObj['line-height'] = (parseFloat(styleObj['font-size']) || baseFontSize || 10) * LINE_HEIGHT_FACTOR + _lib.PXSTRING;
  }
},
    filterer = function filterer(tree, info) {
  for (var filter in tree) {
    if (tree.hasOwnProperty(filter)) {
      if (!tree[filter]._fc_info.table) {
        tree[filter]._fc_info.table = tree[filter]._fc_info.filter ? info.table.query([tree[filter]._fc_info.filterInfo.query]) : info.table;
        tree[filter]._fc_info.filterInfo.table = tree[filter]._fc_info.table;
      }

      tableCreator(tree[filter]);
    }
  }
},
    grouping = function grouping(tree, info) {
  for (var groupOp in tree) {
    if (tree.hasOwnProperty(groupOp)) {
      tree[groupOp]._fc_info.table = info.table;
      tree[groupOp]._fc_info.group = groupOp;
      tableCreator(tree[groupOp]);
    }
  }
},
    pivoter = function pivoter(tree, info) {
  for (var pivotOp in tree) {
    if (tree.hasOwnProperty(pivotOp)) {
      tree[pivotOp]._fc_info.table = info.table;
      tree[pivotOp]._fc_info.groupItems = info.groupItems;
      tree[pivotOp]._fc_info.group = info.group;
      tableCreator(tree[pivotOp]);
    }
  }
},
    aggregator = function aggregator(operation) {
  var operands = operation.operands,
      keys = [];

  if (operation.filter) {
    for (var key in operands) {
      if (operands.hasOwnProperty(key)) {
        for (var opKey in operands[key]) {
          if (operands[key].hasOwnProperty(opKey) && (0, _isArray.default)(operands[key][opKey])) {
            keys.push(opKey);
            operands[key][opKey].length = 0;
          }
        }
      }
    }

    keys = (0, _uniq.default)(keys);
  } else {
    for (var _key in operands) {
      if (operands.hasOwnProperty(_key) && (0, _isArray.default)(operands[_key])) {
        keys.push(_key);
        operands[_key].length = 0;
      }
    }
  }

  return keys.map(function (operand) {
    return {
      column: operand,
      operation: operation.op
    };
  });
},
    seriesGenerator = function seriesGenerator(operands, uniqueItems, aggregations, op) {
  if (uniqueItems === void 0) {
    uniqueItems = [];
  }

  var seriesNames = [];

  var _loop = function _loop(operand) {
    if (operand !== 'plottype') {
      var filterFn = function filterFn(aggr) {
        return aggr.column === operand && aggr.operation === op;
      }; // If unique items were found, pivoting was possible, join up the
      // unique items. Else, join up the column names with their
      // aggregation operations


      if (uniqueItems.length > 0) {
        seriesNames = (0, _chain.default)(function (item) {
          return aggregations.filter(filterFn).map(function (aggr) {
            return [item, aggr.column, aggr.operation];
          });
        }, uniqueItems).map(function (arr) {
          return arr.join(_fcTimeSeparator.default);
        });
      } else {
        seriesNames = aggregations.filter(filterFn).map(function (aggr) {
          return [aggr.column, aggr.operation].join(_fcTimeSeparator.default);
        });
      }

      seriesNames.forEach(function (name) {
        return operands[operand].push(name);
      });
    }
  };

  for (var operand in operands) {
    _loop(operand);
  }
},
    binner = function binner(tree, info) {
  for (var bin in tree) {
    if (tree.hasOwnProperty(bin)) {
      (function () {
        var binInfo = tree[bin]._fc_info,
            binDecider = binInfo.binDecider,
            chart = binInfo.chart,
            thresholdX = binDecider.getRangeThreshold(),
            groupConfig = [{
          column: binInfo.bin,
          timeUnit: _datetimeEnums.DatetimeUnits[(0, _capsFirst.default)(thresholdX[0].name())],
          binSize: thresholdX[1],
          startValue: binInfo.totalStart,
          weekStartFrom: chart.config.startOfWeek
        }],
            filterColumn = info.group,
            filterItems = info.groupItems,
            pivotColumn = info.pivot,
            infoTable = info.table,
            agg = AGGREGATE;

        if (tree[bin][agg]) {
          var ops = tree[bin][agg]._fc_info,
              operations = [],
              aggregations = [],
              query,
              queriedTables = [],
              uniqueItemsList = [],
              uniqueItemsSet = [],
              uniqueItems = [],
              tableCreated = false;

          for (var op in ops) {
            if (ops.hasOwnProperty(op)) {
              operations.push({
                op: op,
                operands: ops[op],
                filter: filterColumn
              });
            }
          }

          aggregations = (0, _chain.default)(aggregator, operations);

          if (filterColumn) {
            var selectorFn = function selectorFn(item) {
              var table, parentTable;

              for (var i = 0; i < operations.length && !table; ++i) {
                if (operations[i].operands[item].table) {
                  table = operations[i].operands[item].table;
                  parentTable = table._parentTable;
                }
              }

              return {
                table: table,
                filterQuery: !table && (0, _operators.filter)(function (row, col) {
                  return row[col[filterColumn]] === item;
                }),
                parentTable: parentTable
              };
            },
                filterQueries = filterItems.map(selectorFn),
                filteredTables = filterQueries.map(function (_ref) {
              var table = _ref.table,
                  filterQuery = _ref.filterQuery,
                  parentTable = _ref.parentTable;
              return {
                newTable: !table,
                table: table || infoTable.query([filterQuery]),
                parentTable: parentTable
              };
            });

            if (pivotColumn) {
              query = (0, _operators.pivot)(groupConfig, pivotColumn, aggregations);
              filteredTables.forEach(function (_ref2) {
                var table = _ref2.table,
                    newTable = _ref2.newTable,
                    parentTable = _ref2.parentTable;
                var items;

                if (newTable) {
                  tableCreated = true;
                  items = table.unique(pivotColumn);
                  uniqueItemsSet.push(new Set(items));
                  uniqueItemsList.push(items);
                  queriedTables.push(table.query([query]));
                } else {
                  var oldItems = Array.from(table.__set);
                  updateSet(table.__set, parentTable.unique(pivotColumn));
                  items = Array.from(table.__set);
                  uniqueItemsList.push(items);

                  if (!(0, _equals.default)(items, oldItems)) {
                    if (!table.disposed) {
                      parentTable.disposeChildren();
                      chart.removeEventListener('focusLimitChanged', info.query);
                    }

                    queriedTables.push(parentTable.query([query]));
                    tableCreated = true;
                  } else {
                    queriedTables.push(table);
                  }
                }
              });
            } else {
              query = (0, _operators.groupBy)(groupConfig, aggregations);
              queriedTables = filteredTables.map(function (_ref3) {
                var table = _ref3.table,
                    newTable = _ref3.newTable;

                if (newTable) {
                  tableCreated = true;
                }

                return newTable ? table.query([query]) : table;
              });
            }
          } else {
            if (pivotColumn) {
              query = (0, _operators.pivot)(groupConfig, pivotColumn, aggregations);
              uniqueItems = infoTable.unique(pivotColumn);
            } else {
              query = (0, _operators.groupBy)(groupConfig, aggregations);
            }

            if (operations[0].operands.table) {
              var set = operations[0].operands.table.__set,
                  oldItems = Array.from(set);
              updateSet(set, uniqueItems);
              uniqueItems = Array.from(set);
              uniqueItemsSet.push(set);

              if ((0, _equals.default)(oldItems, uniqueItems) && !operations[0].operands.table.diposed) {
                queriedTables = [operations[0].operands.table];
              } else {
                operations[0].operands.table.dispose();
                queriedTables = [infoTable.query([query])];
                tableCreated = true;
              }
            } else {
              uniqueItemsSet.push(new Set(uniqueItems));
              queriedTables = [infoTable.query([query])];
              tableCreated = true;
            }
          } // eslint-disable-next-line


          tableCreated && chart.addEventListener('focusLimitChanged', info.query = function (e) {
            if (!queriedTables.filter(function (table) {
              return table && !table.disposed;
            }).length) {
              e.detachHandler();
              return;
            }

            thresholdX = binDecider.getRangeThreshold();
            groupConfig = [{
              column: binInfo.bin,
              timeUnit: _datetimeEnums.DatetimeUnits[(0, _capsFirst.default)(thresholdX[0].name())],
              binSize: thresholdX[1],
              startValue: binInfo.totalStart,
              weekStartFrom: chart.config.startOfWeek
            }];

            if (pivotColumn) {
              query._updateArgs(groupConfig, pivotColumn, aggregations);
            } else {
              groupConfig.startValue = binInfo.totalStart;

              query._updateArgs(groupConfig, aggregations);
            }
          });
          operations.forEach(function (operation) {
            var operands = operation.operands;

            if (filterColumn) {
              filterItems.forEach(function (filterItem, index) {
                var nodeInfo = operands[filterItem];
                nodeInfo.table = queriedTables[index];
                nodeInfo.position = binInfo.bin;
                nodeInfo.filterItem = filterItem;
                nodeInfo.table.__set = uniqueItemsSet[index];
                seriesGenerator(nodeInfo, uniqueItemsList[index], aggregations, operation.op);
              });
            } else {
              operands.table = queriedTables[0];
              operands.position = binInfo.bin;
              operands.table.__set = uniqueItemsSet[0];
              seriesGenerator(operands, uniqueItems, aggregations, operation.op);
            }
          });
        }
      })();
    }
  }
},
    tableCreator = function tableCreator(tableMap) {
  for (var op in tableMap) {
    if (tableMap.hasOwnProperty(op)) {
      var ops = tableMap[op];

      if (op === 'filter') {
        filterer(ops, tableMap._fc_info);
      } else if (op === 'group') {
        grouping(ops, tableMap._fc_info);
      } else if (op === 'pivot') {
        pivoter(ops, tableMap._fc_info);
      } else if (op === 'bin') {
        binner(ops, tableMap._fc_info);
      }
    }
  }
},
    mapper = function mapper(chart, isContext) {
  var panels,
      xs,
      ys,
      binDeciders,
      scalesX,
      scalesY,
      root,
      config = chart.config;

  if (isContext) {
    panels = config.contextPanels;
    xs = config.contextAxesX;
    ys = config.contextAxesY;
    binDeciders = chart.getFromEnv('contextBins');
    scalesX = chart.getFromEnv('contextScalesX');
    scalesY = chart.getFromEnv('contextScalesY');
    root = config.contextTableMap;
  } else {
    panels = config.focusPanels;
    xs = config.focusAxesX;
    ys = config.focusAxesY;
    binDeciders = chart.getFromEnv('focusBins');
    scalesX = chart.getFromEnv('focusScalesX');
    scalesY = chart.getFromEnv('focusScalesY');
    root = config.focusTableMap;
  }

  for (var i = 0, ii = panels.length; i < ii; i++) {
    var plots = panels[i].plots;

    var _loop2 = function _loop2(j, jj) {
      var plot = plots[j],
          x = xs[plot.x],
          y = ys[plot.y],
          binDecider = binDeciders[plot.x],
          threshold = binDecider.getRangeThreshold(),
          xDomain = binDecider.getBinDomain().map(Number),
          scaleX = scalesX[plot.x],
          scaleY = scalesY[plot.y];
      var node = root;
      plot.plots = [];
      x.binDecider = binDecider;
      x.scale = scaleX;
      y.scale = scaleY; // Filter

      if (x.filter) {
        if (!node.filter) node.filter = {};
        node = node.filter;

        if (!x.filterInfo.query) {
          x.filterInfo.query = (0, _operators.between)(x.filter[0], xDomain[0] - threshold[2] * 2, xDomain[1] + threshold[2] * 2);
        }

        if (!node["x__FC_OP_SEP__" + plot.x]) {
          node["x__FC_OP_SEP__" + plot.x] = {
            _fc_info: {
              filter: x.filter[0],
              filterInfo: x.filterInfo,
              start: xDomain[0],
              end: xDomain[1]
            }
          };
        }

        node = node["x__FC_OP_SEP__" + plot.x];
      }

      if (y.filter) {
        if (!node) node.filter = {};
        node = node.filter;

        if (!node["y__FC_OP_SEP__" + plot.y]) {
          node["y__FC_OP_SEP__" + plot.y] = {
            _fc_info: {
              filter: y.filter[0]
            }
          };
        }

        node = node["y__FC_OP_SEP__" + plot.y];
      }

      y.plot.forEach(function (eachPlot, index) {
        var parent = node,
            uniqueItems = [];

        if (eachPlot.group) {
          var group = eachPlot.group;
          if (!node.group) node.group = {};
          node = node.group;

          if (!node[group]) {
            node[group] = {
              _fc_info: {}
            };
          }

          uniqueItems = config.dataTable.unique(group);

          if (node[group]._fc_info.groupItemsSet) {
            var oldSet = node[group]._fc_info.groupItemsSet;
            updateSet(oldSet, uniqueItems);
            node[group]._fc_info.groupItems = uniqueItems = Array.from(oldSet);
          } else {
            node[group]._fc_info.groupItemsSet = new Set(uniqueItems);
            node[group]._fc_info.groupItems = uniqueItems;
          }

          node = node[group];
        }

        if (eachPlot.stack) {
          var stack = eachPlot.stack;
          if (!node.pivot) node.pivot = {};
          node = node.pivot;

          if (!node[stack]) {
            node[stack] = {
              _fc_info: {
                pivot: stack
              }
            };
          }

          node = node[stack];
        }

        if (x.bin) {
          if (!node.bin) node.bin = {};
          node = node.bin;

          if (!node["x__FC_OP_SEP__" + plot.x]) {
            node["x__FC_OP_SEP__" + plot.x] = {
              _fc_info: {
                chart: chart,
                bin: x.bin[0],
                binDecider: binDecider
              }
            };
          }

          node = node["x__FC_OP_SEP__" + plot.x];
          node._fc_info.totalStart = +_timeIntervals.timeYear.floor(config.rawDataXStart);
        }

        if (y.bin) {
          if (!node.bin) node.bin = {};
          node = node.bin;

          if (!node["y__FC_OP_SEP__" + plot.y]) {
            node["y__FC_OP_SEP__" + plot.y] = {
              _fc_info: {
                bin: y.bin[0]
              }
            };
          }

          node = node["y__FC_OP_SEP__" + plot.y];
        }

        if (!node.aggregate) node.aggregate = {
          _fc_info: {}
        };

        if (eachPlot.type === 'candlestick' || eachPlot.type === 'ohlc') {
          // if the group is given then the no of plots in th canvas
          // for each measure will be created
          // with resect to unique items of the filtered column
          var len = eachPlot.group ? uniqueItems.length : 1;

          for (var k = 0; k < len; ++k) {
            var ohlcObj = {
              plottype: eachPlot.type,
              typeinnavigator: eachPlot.typeinnavigator
            },
                uniqueItem = eachPlot.group ? uniqueItems[k] : _lib.UNDEF;

            if (eachPlot.open) {
              if (!node.aggregate._fc_info.first) {
                node.aggregate._fc_info.first = {};
              }

              var first = node.aggregate._fc_info.first;

              if (uniqueItem && !first[uniqueItem]) {
                first[uniqueItem] = {};
              }

              if (uniqueItem) {
                if (!first[uniqueItem][eachPlot.open]) {
                  first[uniqueItem][eachPlot.open] = [];
                }
              } else {
                if (!first[eachPlot.open]) {
                  first[eachPlot.open] = [];
                }
              }

              ohlcObj.open = uniqueItem ? first[uniqueItem][eachPlot.open] : first[eachPlot.open];
            }

            if (eachPlot.high) {
              if (!node.aggregate._fc_info.max) {
                node.aggregate._fc_info.max = {};
              }

              var max = node.aggregate._fc_info.max;

              if (uniqueItem && !max[uniqueItem]) {
                max[uniqueItem] = {};
              }

              if (uniqueItem) {
                if (!max[uniqueItem][eachPlot.high]) {
                  max[uniqueItem][eachPlot.high] = [];
                }
              } else {
                if (!max[eachPlot.high]) {
                  max[eachPlot.high] = [];
                }
              }

              ohlcObj.high = uniqueItem ? max[uniqueItem][eachPlot.high] : max[eachPlot.high];
            }

            if (eachPlot.low) {
              if (!node.aggregate._fc_info.min) {
                node.aggregate._fc_info.min = {};
              }

              var min = node.aggregate._fc_info.min;

              if (uniqueItem && !min[uniqueItem]) {
                min[uniqueItem] = {};
              }

              if (uniqueItem) {
                if (!min[uniqueItem][eachPlot.low]) {
                  min[uniqueItem][eachPlot.low] = [];
                }
              } else {
                if (!min[eachPlot.low]) {
                  min[eachPlot.low] = [];
                }
              }

              ohlcObj.low = uniqueItem ? min[uniqueItem][eachPlot.low] : min[eachPlot.low];
            }

            if (eachPlot.close) {
              if (!node.aggregate._fc_info.last) {
                node.aggregate._fc_info.last = {};
              }

              var last = node.aggregate._fc_info.last;

              if (uniqueItem && !last[uniqueItem]) {
                last[uniqueItem] = {};
              }

              if (uniqueItem) {
                if (!last[uniqueItem][eachPlot.close]) {
                  last[uniqueItem][eachPlot.close] = [];
                }
              } else {
                if (!last[eachPlot.close]) {
                  last[eachPlot.close] = [];
                }
              }

              ohlcObj.close = uniqueItem ? last[uniqueItem][eachPlot.close] : last[eachPlot.close];
            }

            var info = node.aggregate._fc_info;
            ohlcObj.tableInfo = (uniqueItem ? [info.first[uniqueItem], info.max[uniqueItem], info.min[uniqueItem], info.last[uniqueItem]] : [info.first, info.max, info.min, info.last]).filter(function (s) {
              return !!s;
            })[0]; // added value info for series name

            ohlcObj.value = eachPlot.value; // added the index of the plot from which the styles are to be taken

            ohlcObj.plotInAxisIndex = index;
            plot.plots.push(ohlcObj);
          }
        } else if (eachPlot.type === 'column-range' || eachPlot.type === 'area-range') {
          // if the group is given then the no of plots in th canvas
          // for each measure will be created
          // with resect to unique items of the filtered column
          var _len = eachPlot.group ? uniqueItems.length : 1;

          for (var _k = 0; _k < _len; ++_k) {
            var rangeObj = {
              plottype: eachPlot.type,
              typeinnavigator: eachPlot.typeinnavigator,
              name: eachPlot.name
            },
                _uniqueItem = eachPlot.group ? uniqueItems[_k] : _lib.UNDEF;

            if (eachPlot.high) {
              if (!node.aggregate._fc_info.max) {
                node.aggregate._fc_info.max = {};
              }

              var _max = node.aggregate._fc_info.max;

              if (_uniqueItem && !_max[_uniqueItem]) {
                _max[_uniqueItem] = {};
              }

              if (_uniqueItem) {
                if (!_max[_uniqueItem][eachPlot.high]) {
                  _max[_uniqueItem][eachPlot.high] = [];
                }
              } else {
                if (!_max[eachPlot.high]) {
                  _max[eachPlot.high] = [];
                }
              }

              rangeObj.high = _uniqueItem ? _max[_uniqueItem][eachPlot.high] : _max[eachPlot.high];
            }

            if (eachPlot.low) {
              if (!node.aggregate._fc_info.min) {
                node.aggregate._fc_info.min = {};
              }

              var _min = node.aggregate._fc_info.min;

              if (_uniqueItem && !_min[_uniqueItem]) {
                _min[_uniqueItem] = {};
              }

              if (_uniqueItem) {
                if (!_min[_uniqueItem][eachPlot.low]) {
                  _min[_uniqueItem][eachPlot.low] = [];
                }
              } else {
                if (!_min[eachPlot.low]) {
                  _min[eachPlot.low] = [];
                }
              }

              rangeObj.low = _uniqueItem ? _min[_uniqueItem][eachPlot.low] : _min[eachPlot.low];
            }

            var _info = node.aggregate._fc_info;
            rangeObj.tableInfo = (_uniqueItem ? [_info.max[_uniqueItem], _info.min[_uniqueItem]] : [_info.max, _info.min]).filter(function (s) {
              return !!s;
            })[0]; // added the index of the plot from which the styles are to be taken

            rangeObj.plotInAxisIndex = index;
            plot.plots.push(rangeObj);
          }
        } else {
          if (!node.aggregate._fc_info[eachPlot.aggregation]) {
            node.aggregate._fc_info[eachPlot.aggregation] = {};
          }

          var aggregationObj = node.aggregate._fc_info[eachPlot.aggregation];

          if (eachPlot.group) {
            for (var _k2 = 0; _k2 < uniqueItems.length; ++_k2) {
              var _uniqueItem2 = uniqueItems[_k2];

              if (!aggregationObj[_uniqueItem2]) {
                aggregationObj[_uniqueItem2] = {};
              }

              if (!aggregationObj[_uniqueItem2][eachPlot.value]) {
                aggregationObj[_uniqueItem2][eachPlot.value] = [];
              }

              plot.plots.push({
                plottype: eachPlot.type,
                typeinnavigator: eachPlot.typeinnavigator,
                tableInfo: aggregationObj[_uniqueItem2],
                value: aggregationObj[_uniqueItem2][eachPlot.value],
                stack: eachPlot.stack,
                plotInAxisIndex: index
              });
            }
          } else {
            if (!aggregationObj[eachPlot.value]) {
              aggregationObj[eachPlot.value] = [];
            }

            plot.plots.push({
              plottype: eachPlot.type,
              typeinnavigator: eachPlot.typeinnavigator,
              tableInfo: aggregationObj,
              value: aggregationObj[eachPlot.value],
              stack: eachPlot.stack,
              plotInAxisIndex: index
            });
          }
        }

        node = parent;
      });
    };

    for (var j = 0, jj = plots.length; j < jj; j++) {
      _loop2(j, jj);
    }
  }
},
    getSmartLinearMin = function getSmartLinearMin(min, isBaseRequired, minLim) {
  var reducedMin = min - Math.abs(min * 0.1);
  reducedMin = reducedMin < minLim ? minLim : reducedMin;
  return reducedMin > 0 && isBaseRequired ? 0 : reducedMin;
},
    getSmartLogMin = function getSmartLogMin(min, isBaseRequired) {
  var reducedMin = min * 0.9;
  return isBaseRequired ? Math.min(reducedMin, 1) : reducedMin;
},
    getLogMinMax = function getLogMinMax(dataMin, dataMax, userMin, userMax, baseArg, isBaseRequired) {
  var base = baseArg;
  if (!(0, _isValidNumber.default)(base) || base === 0) base = 10;
  var logMin = dataMin > 0 && isFinite(dataMin) ? getSmartLogMin(dataMin, isBaseRequired) : 1,
      enforcedMin = (0, _isValidNumber.default)(userMin) && userMin > 0 && userMin < dataMin ? userMin : logMin,
      logMax = dataMax > 0 && isFinite(dataMax) ? dataMax : logMin + +base,
      enforcedMax = (0, _isValidNumber.default)(userMax) && userMax > enforcedMin ? userMax : logMax * 1.2;
  return [enforcedMin, enforcedMax];
},
    getLinearMinMax = function getLinearMinMax(dataMinArg, dataMaxArg, userMinArg, userMaxArg, isBaseRequired) {
  var dataMax = dataMaxArg,
      dataMin = dataMinArg,
      userMin = userMinArg,
      userMax = userMaxArg,
      linearMax,
      minLim,
      maxLim;
  !isFinite(dataMin) && (dataMin = _lib.UNDEF);
  !isFinite(dataMax) && (dataMax = _lib.UNDEF);
  !isFinite(userMin) && (userMin = _lib.UNDEF);
  !isFinite(userMax) && (userMax = _lib.UNDEF);
  minLim = dataMin === dataMax ? dataMin - Math.abs(dataMin * 0.1) : dataMin - Math.abs((dataMax - dataMin) * 0.2);
  maxLim = dataMin === dataMax ? dataMax + Math.abs(dataMax * 0.2) : dataMax + Math.abs((dataMax - dataMin) * 0.2);
  var linearMin = userMin < dataMin ? userMin : dataMin !== _lib.UNDEF ? getSmartLinearMin(dataMin, isBaseRequired, minLim) : 0,
      isNegitive = linearMin < 0 && (userMax < 0 || dataMax < 0);

  if (userMax > dataMax) {
    linearMax = userMax;
  } else if (dataMax !== _lib.UNDEF) {
    if (isNegitive && isBaseRequired) {
      linearMax = 0;
    } else {
      linearMax = dataMax + Math.abs(dataMax * 0.2);
      linearMax = maxLim < linearMax ? maxLim : linearMax;
    }
  } else {
    linearMax = linearMin + 1;
  }

  return [linearMin, linearMax];
},
    parseStrokeDashArray = function parseStrokeDashArray(styleDef) {
  for (var property in styleDef) {
    if (styleDef.hasOwnProperty(property)) {
      var isStrokeDashArray = property === 'stroke-dasharray';

      if (typeof styleDef[property] === 'object') {
        parseStrokeDashArray(styleDef[property]);
      } else if (isStrokeDashArray && isDashedString(styleDef[property])) {
        // If stoke dasharray not 'none' and is provided as a string,
        // first trim the whitespaces then replace comma with space to
        // normalise the string and then split with space.
        styleDef[property] = styleDef[property].replace(/^\s+|\s+$/g, '').replace(/,/g, ' ').split(' ').map(function (c) {
          return +c;
        });
      }
    }
  }
},
    parseOpacity = function parseOpacity(styleDef) {
  for (var property in styleDef) {
    if (styleDef.hasOwnProperty(property)) {
      if (typeof styleDef[property] === 'object') {
        parseOpacity(styleDef[property]);
      } else if (property === 'opacity' || property === 'stroke-opacity' || property === 'fill-opacity') {
        // normalize the opacity between 0 to 1
        styleDef[property] = Math.max(0, Math.min(1, +styleDef[property]));
      }
    }
  }
},
    updateBinStart = function updateBinStart(startObj, totalStart) {
  var bin = startObj.bin;

  for (var i in bin) {
    if (bin.hasOwnProperty(i) && /x__FC_OP_SEP__/.test(i)) {
      var binInfo = bin[i]._fc_info;
      binInfo.totalStart = totalStart;
    }
  }
},
    updateGroupByStart = function updateGroupByStart(tableMap, timeStart) {
  var totalStart = +_timeIntervals.timeYear.floor(timeStart);

  if (tableMap.filter) {
    var startObj = tableMap.filter;

    for (var key in startObj) {
      if (startObj.hasOwnProperty(key) && /x__FC_OP_SEP__/.test(key)) {
        updateBinStart(startObj[key], totalStart);
      }
    }
  } else {
    updateBinStart(tableMap, totalStart);
  }
},
    disposeFn = function disposeFn(component) {
  component.dispose && component.dispose();
},
    useFirstTables = function useFirstTables(obj, rootTable, useTable) {
  if (obj === void 0) {
    obj = {};
  }

  if (useTable === void 0) {
    useTable = _lib.stubFN;
  }

  var keys = Object.keys(obj),
      len = keys.length,
      continueRecursion = true;

  for (var i = 0; i < len && continueRecursion; ++i) {
    var key = keys[i],
        el = obj[key];

    if (key === '_fc_info' || key === 'table') {
      var table = key === 'table' ? el : el.table;

      if (table && table !== rootTable) {
        useTable(table);
        continueRecursion = false;
      }
    } else if (key === AGGREGATE) {
      useFirstTables(el._fc_info, rootTable, useTable);
    } else if ((0, _isObject.default)(el)) {
      useFirstTables(el, rootTable, useTable);
    }
  }
},
    actionsReducer = function actionsReducer(action, type, chart) {
  switch (action) {
    case 'plot':
      chart.showWarning('02362480', 'param', ' Timeseries', ' Some plot configurations were ignored. Please provide valid values to the plot attribute within a ' + type + 'Axis configuration.');
      break;

    case 'axis':
      chart.showWarning('08927060', 'param', ' Timeseries', 'Some ' + type + 'Axis configurations were ignored. Please provide a valid value to the plot attribute within the ' + type + 'Axis configurations.');
      break;

    case 'fullaxis':
      chart.showWarning('08963401', 'param', ' Timeseries', 'All ' + type + 'Axis configurations were ignored. Please provide a valid value to the plot attribute within the ' + type + 'Axis configurations. Defaulting to showing all numeric columns in separate canvases.');
      break;

    default:
  }
},
    createStyleStr = function createStyleStr(styleObj) {
  if (styleObj === void 0) {
    styleObj = {};
  }

  var key,
      styleStr = STYLE_STR_ONE;

  for (key in styleObj) {
    if (styleObj.hasOwnProperty(key)) {
      styleStr += key + ': ' + styleObj[key] + '; ';
    }
  }

  styleStr += STYLE_STR_TWO;
  return styleStr;
},
    parsePrediction = function parsePrediction(dataSource, getStyleDef) {
  var prediction = {},
      styleKey = {};

  if (dataSource.extensions && (0, _isObject.default)(dataSource.extensions.prediction)) {
    prediction = dataSource.extensions.prediction;
    prediction.enabled = true;
  } else {
    prediction = {
      enabled: false
    };
  }

  if ((0, _isObject.default)(prediction.style)) {
    for (styleKey in prediction.style) {
      if (prediction.style.hasOwnProperty(styleKey)) {
        prediction.style[styleKey] = getStyleDef(prediction.style[styleKey]);
      }
    }
  } else {
    prediction.style = {};
  }

  return prediction;
};

function dateAPI(dateVal, param, utc) {
  return dateVal['get' + utc + param]();
}
/*
  The below function getBinIndex() was supposed to be a part of
  scales. But due to clipping introduced in timeseries. This function has changed
  but the newer function is not compatible with real time timeseries chart
  So, this is the older version of that function. And in future is expected
  to be removed from here, when realtime chart will support clipping
*/


function getBinIndex(scale, curTimeStamp, startTimeStamp) {
  var curBin = scale._getRangeThreshold(),
      showPlotOverTick = scale.showPlotOverTick(),
      squareOff = showPlotOverTick ? Math.round : Math.floor,
      yearsInBetween,
      startTime = new Date(startTimeStamp),
      curTime = new Date(curTimeStamp),
      startMonth,
      curMonth,
      startYear,
      curYear,
      index,
      binLength = curBin[2];

  if (curBin[0].name() === 'year') {
    return squareOff(curBin[0].count(startTimeStamp, curTimeStamp) / curBin[1]);
  } else if (curBin[0].name() === 'month') {
    startYear = dateAPI(startTime, 'FullYear', scale.getType());
    curYear = dateAPI(curTime, 'FullYear', scale.getType());
    startMonth = dateAPI(startTime, 'Month', scale.getType());
    curMonth = dateAPI(curTime, 'Month', scale.getType());
    yearsInBetween = Math.max(0, curYear - startYear - 1);

    if (startYear === curYear) {
      index = Math.floor(curMonth / curBin[1]) - Math.floor(startMonth / curBin[1]);
    } else {
      index = yearsInBetween * 12 / curBin[1];
      index += 12 / curBin[1] - Math.floor(startMonth / curBin[1]);
      index += Math.floor(curMonth / curBin[1]);
    } // If plots are placed at starting of bin and mouse pointer is has crossed the mid point
    // of the bin, return the next bin as the active bin


    if (showPlotOverTick && curTime.getDate() > MONTH_MID) {
      index++;
    }

    return index;
  }

  return squareOff((curTimeStamp - startTimeStamp) / binLength);
}

function _onDataUpdate(_ref4) {
  var _ref4$data = _ref4.data,
      _ref4$data$parsedRows = _ref4$data.parsedRows,
      parsedRows = _ref4$data$parsedRows === void 0 ? [] : _ref4$data$parsedRows,
      tableID = _ref4$data.tableID;

  var chart = this,
      config = chart.config,
      focusAxis = config.focusAxesX[0],
      clipDates = config.clipDates,
      _this$getFromEnv = this.getFromEnv('dateColumn'),
      dateColumnName = _this$getFromEnv.name,
      clippedRows = function clippedRows(row, col) {
    var t = row[col[dateColumnName]];
    return clipDates.some(function (_ref5) {
      var from = _ref5.from,
          to = _ref5.to;
      return t >= from && t <= to;
    });
  },
      contextBins = chart.getFromEnv('contextBins'),
      focusBins = chart.getFromEnv('focusBins'),
      focusScalesX = chart.getFromEnv('focusScalesX'),
      contextScalesX = chart.getFromEnv('contextScalesX'),
      data = config.dataTable.getData().data,
      newDataLimit = (0, _extent3.default)(parsedRows, function (row) {
    return (0, _arrayHasContent.default)(row) && row[config.dateColumnIndex];
  }),
      newContextLimit = [],
      lastContextLimit = this.getContextLimit(),
      binStartTime = _timeIntervals.timeYear.floor(lastContextLimit[0]),
      focusLimit = this.getFocusLimit(),
      newFocusLimit = focusLimit.slice(),
      lastFocusDuration = focusLimit[1] - focusLimit[0],
      newStartLimit = Math.min(data[0][config.dateColumnIndex], newDataLimit[0]),
      isNewBinAdded = false,
      getDeletionTime = function getDeletionTime() {
    var interval = contextBins[0].getRangeThreshold()[0];
    return +interval.offset(lastContextLimit[0], interval.count(lastContextLimit[1], newDataLimit[1]));
  },
      ops = [];

  if (config.dataTable.getID() === tableID) {
    if (clipDates.length) {
      ops = [(0, _operators.filter)(clippedRows)];
    }

    contextScalesX.some(function (scale) {
      var currentMaxIndex = getBinIndex(scale, lastContextLimit[1], binStartTime),
          newMaxIndex = getBinIndex(scale, newDataLimit[1], binStartTime),
          indexDiff = newMaxIndex - currentMaxIndex;

      if (indexDiff > 0) {
        newStartLimit = getDeletionTime();
        ops = ops.concat((0, _operators.less)(dateColumnName, newStartLimit - (contextBins[0].getRangeThreshold()[2] === 1 ? 0 : 1)));
        isNewBinAdded = true;
        return true;
      }

      return false;
    });

    if (ops.length) {
      config.dataTable.getDataStore().deleteRows(_operators.pipe.apply(void 0, ops), config.dataTable.getID());
      data = config.dataTable.getData().data;
      newStartLimit = Math.max(newStartLimit, Math.min(data[0][config.dateColumnIndex], newDataLimit[0]));
    }

    config.contextAxesX.forEach(function (_ref6) {
      var binDecider = _ref6.binDecider,
          scale = _ref6.scale;
      config.atomicity.minBin = (0, _atomicity.getAtomicity)(_objectSpread(_objectSpread({}, config.atomicity), {}, {
        index: config.dateColumnIndex,
        data: data.slice(-parsedRows.length - 1),
        bins: binDecider.getStandardBins(),
        intervalIndexMap: binDecider.intervalIndexMap,
        ms: scale.getTimeInterval().Millisecond
      }));
      binDecider.setBinMin(config.atomicity.minBin);
      scale.setRangeThreshold(binDecider.getRangeThreshold());
    });
    config.focusAxesX.forEach(function (_ref7) {
      var binDecider = _ref7.binDecider,
          scale = _ref7.scale;
      binDecider.setBinMin(config.atomicity.minBin);
      scale.setRangeThreshold(binDecider.getRangeThreshold());
    });

    if (isNewBinAdded || data.length - parsedRows.length === 0) {
      var minBin = contextBins[0].getBinMin(),
          curBin = contextBins[0].getRangeThreshold();

      if (config.timeSpread) {
        newContextLimit[1] = newDataLimit[1];
        newContextLimit[0] = Math.min(config.timeSpread.interval.offset(newDataLimit[1], -config.timeSpread.multiplier), curBin[0].offset(newDataLimit[1], -2));
      } else {
        if (isNewBinAdded) {
          newContextLimit[1] = newDataLimit[1];
          newContextLimit[0] = Math.min(newDataLimit[1] - (lastContextLimit[1] - lastContextLimit[0]), newDataLimit[1] - (newDataLimit[1] - newStartLimit), minBin[0].offset(newDataLimit[1], -3));
        } else if (data.length - parsedRows.length === 0) {
          newContextLimit[1] = newDataLimit[1];
          newContextLimit[0] = Math.min(newDataLimit[1] - (lastContextLimit[1] - lastContextLimit[0]), newDataLimit[1] - (newDataLimit[1] - newStartLimit), minBin[0].offset(newDataLimit[1], -3));
        } else {
          newContextLimit = (0, _extent3.default)([].concat(lastContextLimit, newDataLimit), Number);
        }
      }
    } else {
      if (config.timeSpread) {
        var lowerBound = Math.min(lastContextLimit[0], newDataLimit[0]),
            upperBound = Math.max(lastContextLimit[1], newDataLimit[1]),
            upperDiff = Math.max(0, newDataLimit[1] - lastContextLimit[1]);
        newContextLimit = [lowerBound + upperDiff, upperBound];
      } else {
        newContextLimit = (0, _extent3.default)([].concat(lastContextLimit, newDataLimit), Number);
      }
    }

    var startUpdated = config.rawDataXStart !== newStartLimit && !config.hasSeries;

    if (startUpdated) {
      updateGroupByStart(config.focusTableMap, newStartLimit);
      updateGroupByStart(config.contextTableMap, newStartLimit);
    }

    config.rawDataXStart = newStartLimit;
    chart.setContextLimit(newContextLimit);

    if (focusLimit[0] <= lastContextLimit[0]) {
      newFocusLimit[0] = newContextLimit[0];

      if (focusLimit[1] !== lastContextLimit[1]) {
        newFocusLimit[1] = newFocusLimit[0] + lastFocusDuration;
      }
    }

    if (focusLimit[1] >= lastContextLimit[1]) {
      newFocusLimit[1] = newContextLimit[1];

      if (focusLimit[0] !== lastContextLimit[0]) {
        newFocusLimit[0] = newFocusLimit[1] - lastFocusDuration;
      }
    } // clamping the limit


    if (newFocusLimit[0] < newContextLimit[0]) {
      newFocusLimit[0] = newContextLimit[0];
      newFocusLimit[1] = newFocusLimit[0] + lastFocusDuration;
    }

    if (newFocusLimit[1] > newContextLimit[1]) {
      newFocusLimit[1] = newContextLimit[1];
      newFocusLimit[0] = newFocusLimit[1] - lastFocusDuration;
    }

    if (config.hasSeries) {
      if (!(0, _equals.default)(newFocusLimit, focusLimit)) {
        focusBins[0].setBinDomain(newFocusLimit);
      }

      var threshold = focusBins[0].getRangeThreshold();
      focusScalesX[0].setRangeThreshold(threshold);

      if (focusAxis.filterInfo && focusAxis.filterInfo.query) {
        focusAxis.filterInfo.query._updateArgs(+threshold[0].offset(+newFocusLimit[0], -2 * threshold[1]), +threshold[0].offset(+newFocusLimit[1], 2 * threshold[1]));
      } // change the tree with respect to new data


      mapper(chart);
      mapper(chart, true);
      tableCreator(config.focusTableMap);
      tableCreator(config.contextTableMap);

      chart._createLegendMap(true);

      for (var i = 0; i < contextBins.length; ++i) {
        var pixels = config.pixelMultiplier * _binDecider.DEFAULT_THRESHOLD_PIXELS;
        contextBins[i].setRangeThreshold(pixels);
        focusBins[i].setRangeThreshold(pixels);
        contextScalesX[i].setRangeThreshold(contextBins[i].getRangeThreshold());
        focusScalesX[i].setRangeThreshold(focusBins[i].getRangeThreshold());
      }
    }

    if (!chart.setFocusLimit(newFocusLimit, false)) {
      // flushing the result is required to update the data
      config.focusAxesX[0].filterInfo.table.flushResults(); // If the data is fed in between the context limit, the groupby start should change
      // and the query needs to be updated.

      startUpdated && chart.fireEvent('focusLimitChanged');

      chart._updateAffectedVisuals({
        legendInteracted: null
      });
    }
  }
}

function _offDataUpdate() {
  var dataTable = this.config.dataTable;
  dataTable.getDataStore().off('itemsAdded', this._onDataUpdate);
}

var TimeSeries = /*#__PURE__*/function (_CommonAPI) {
  (0, _inheritsLoose2.default)(TimeSeries, _CommonAPI);

  function TimeSeries() {
    var _this;

    _this = _CommonAPI.call(this) || this;
    var chart = (0, _assertThisInitialized2.default)(_this);
    _this._onDataUpdate = _onDataUpdate.bind((0, _assertThisInitialized2.default)(_this));
    _this._offDataUpdate = _offDataUpdate.bind((0, _assertThisInitialized2.default)(_this));
    chart.eiMethods = {
      /**
       * getter function for yaxis property of chart data
       */
      getYAxis: function getYAxis() {
        return chart.getFromEnv('chartInstance').getJSONData().yaxis;
      },

      /**
       * setter function for yaxis property of chart data
       */
      setYAxis: function setYAxis() {
        var chartInstance = chart.getFromEnv('chartInstance');

        if (arguments.length) {
          var data = chartInstance.getJSONData();
          data.yaxis = arguments.length <= 0 ? undefined : arguments[0];
          chartInstance.setJSONData(data);
        }

        return chartInstance;
      },

      /**
       * @description Provides information about the binning applied in the chart when the method was invoked.
       * @returns {object} unit<String>: The unit of time being represented in each bin - millisecond, second, minute, hour, day, month or year.
       * multiplier<Number>: The multiplier for the unit being represented in each bin.
       */
      getCurrentBin: function getCurrentBin() {
        var binDecider = chart.getFromEnv('focusBins')[0],
            currentBin = binDecider.getRangeThreshold();
        return {
          'unit': currentBin[0].name(),
          'multiplier': currentBin[1]
        };
      },

      /**
       * @description Sets the provided unit and multiplier as the current binning in the chart by adjusting spread of time on the focus canvases.
       * @param {object} customBinObj An object containing:unit<String>: The unit of time to be represented in each bin - millisecond, second, minute, hour, day, month or year.
       * multiplier<Number>: The multiplier for the unit to be represented in each bin.
       * @returns {object} <FusionCharts>: The instance of FusionCharts upon which the method was invoked.
       */
      setCurrentBin: function setCurrentBin(customBinObj) {
        var customBin = (0, _index.validateUserBin)(customBinObj, chart);

        if (customBin) {
          chart.setFocusLimit((0, _index.calculateDomainForUserCustomBin)(customBin, chart));
        }

        return this;
      },

      /**
       * @description Provides start and end UNIX timestamps of the visible window of the time axis.
       * @returns {object} start<Number>: The UNIX timestamp corresponding to the start of the time selection visible on the focus canvases.
       * end<Number>: The UNIX timestamp corresponding to the end of the time selection visible on the focus canvases.
       */
      getTimeSelection: function getTimeSelection() {
        var _chart$getFocusLimit = chart.getFocusLimit(),
            start = _chart$getFocusLimit[0],
            end = _chart$getFocusLimit[1];

        return {
          start: start,
          end: end
        };
      },

      /**
       *
       * @param {object} timeInterval An object containing: start<Number>: The UNIX timestamp corresponding to the time at which to start the time selection visible on the focus canvases.
       * end<Number>: The UNIX timestamp corresponding to the time at which to end the time selection visible on the focus canvases.
       * @returns {object} <FusionCharts>: The instance of FusionCharts upon which the method was invoked.
       */
      setTimeSelection: function setTimeSelection(timeInterval) {
        var validatedTimeInterval = (0, _index.validateFocusLimit)(timeInterval, this.getTimeSelection(), chart);

        if (validatedTimeInterval) {
          chart.setFocusLimit(validatedTimeInterval);
        }

        return this;
      },

      /**
       * @description Provides binning rules that are being followed by the chart. If any custom binning rules are in effect,
       * the returned rules will take into account the modifications made by them as well.
       * @returns the binning rules that are being followed by the chart. If any custom binning rules are in effect,
       * the returned rules will take into account the modifications made by them as well.
       */
      getBinning: function getBinning() {
        return (0, _index.filterStandarBinsToUserConfig)(chart.getFromEnv('contextBins')[0].getStandardBins());
      },

      /**
       * @description Overrides the binning rules followed by the chart with the binning rules provided to this API.
       * If some time unit is missing from the input binning rules, then the default multipliers for that time unit will be used by the chart.
       * If any incorrect multipliers are provided to a unit, they will be ignored.
       * @param {Object} customBin An object containing:
       * millisecond<Number[]>: All the multipliers applicable for the millisecond unit.
       * second<Number[]>: All the multipliers applicable for the second unit.
       * minute<Number[]>: All the multipliers applicable for the minute unit.
       * hour<Number[]>: All the multipliers applicable for the hour unit.
       * day<Number[]>: All the multipliers applicable for the day unit.
       * month<Number[]>: All the multipliers applicable for the month unit.
       * year<Number[]>: All the multipliers applicable for the year unit.
       * @returns {Object} <FusionCharts>: The instance of FusionCharts upon which the method was invoked.
       */
      setBinning: _index.setBinningRules,
      feedData: function feedData(rows) {
        if ((0, _arrayHasContent.default)(rows)) {
          var config = chart.config,
              contextLimit = chart.getContextLimit(),
              baseTimeConverter = config.baseTimeConverter,
              dateColumnIndex = config.dateColumnIndex;

          if (chart.cloneTable()) {
            config.focusTableMap = {
              _fc_info: {
                table: config.dataTable
              }
            };
            config.contextTableMap = {
              _fc_info: {
                table: config.dataTable
              }
            };
            mapper(chart);
            mapper(chart, true);
            tableCreator(config.focusTableMap);
            tableCreator(config.contextTableMap);
            config.dataTable.getDataStore().on('itemsAdded', chart._onDataUpdate);
          }

          var filteredData = rows.filter(function (row) {
            return +baseTimeConverter.parse(row[dateColumnIndex]) >= contextLimit[0];
          });

          if (filteredData.length) {
            config.dataTable.getDataStore().appendRows(filteredData, config.dataTable.getID());
          }
        }

        return chart;
      }
    }; // API that returns the style definition by name

    chart.addToEnv('getStyleDef', function (styleDefArg) {
      if (styleDefArg === void 0) {
        styleDefArg = {};
      }

      var styleDef = styleDefArg,
          defaulTextStyle = chart.getFromEnv('textStyle'),
          mergedStyle;

      if (typeof styleDef === 'string') {
        var styleDefinition = chart.getFromEnv('dataSource').styledefinition;
        mergedStyle = {}; // more than one style definitions can be provided, so merge all the styles with the last mentioned style
        // having the highest priority.

        styleDefinition && styleDef.split(/\s+/g).forEach(function (style) {
          return (0, _lib.extend2)(mergedStyle, styleDefinition[style]);
        });
      } // if mergeStyle is defined that means styleDef is of string type, then assign styleDef to mergedStyle


      if (mergedStyle) {
        styleDef = mergedStyle;
      } // middleware for parsing stroke dasharray
      // support for string dash array


      parseStrokeDashArray(styleDef); // middleware for parsing opacity
      // support for opacity normalisation

      parseOpacity(styleDef);
      (styleDef['font-size'] || styleDef['font-size'] === 0) && setLineHeight(styleDef, defaulTextStyle['font-size']);
      return styleDef;
    });
    chart.deregisterFactory('canvas');
    chart.registerFactory('background', _background.default);
    chart.registerFactory('caption', _caption.default);
    chart.registerFactory('legend', _legendFactory.default);
    chart.registerFactory('panel', _panel.default);
    chart.registerFactory('selectorToolbar', _toolbarFactory.default, ['timeNavigator', 'canvas']);
    chart.registerFactory('timeNavigator', _navigatorTime.default);
    chart.registerFactory('standardRangeSelector', _standardRangeSelector.default, ['selectorToolbar']);
    chart.registerFactory('customRangeSelector', _customRangeSelector.default, ['selectorToolbar']);
    chart.registerFactory('multicanvasCrosslineManager', _multicanvasCrosslineManager.default, ['mouseTracker']);
    chart.registerFactory('toolbarManager', _toolbarManagerFactory.default, ['standardRangeSelector', 'customRangeSelector']);
    return _this;
  }

  TimeSeries.getName = function getName() {
    return 'timeseries';
  };

  var _proto = TimeSeries.prototype;

  _proto.getName = function getName() {
    return 'timeseries';
  };

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    var config = this.config;
    config.skipConfigureIteration = {};
    config.canvasAxisMap = {};
    config.scaleDsMap = {};
    config.palettecolors = ['#5D62B5', '#29C3BE', '#F2726F', '#FFC533', '#62B58F', '#BC95DF', '#67CDF2'];
    config.defaultLegendTextStyle = {
      'font-family': _lib.DEFAULT_FT_FONT,
      'font-weight': 'normal',
      'font-style': 'normal',
      'font-size': '12px',
      'fill': '#5F5F5F',
      'line-height': '14px',
      'opacity': '1',
      'fill-opacity': '1'
    };
    config.defaultTooltipStyle = {
      'background-color': (0, _lib.convertColor)('#ffffff', '90'),
      'color': '#5f5f5f',
      'border-color': '#e8e8e8',
      'border-width': '1px',
      'border-radius': '0px',
      'line-height': 1,
      'font-family': _lib.DEFAULT_FT_FONT,
      'padding': '3px',
      opacity: 0.9
    }; // set the default text style of chart

    this.addToEnv('textStyle', {
      'font-family': 'sans-serif',
      'font-size': '10',
      'fill': '#000000',
      'line-height': '12'
    });
    config.contextPanels = [];
    config.contextLimit = config.focusLimit = _lib.UNDEF;
    config.legendMap = {};
    config.isXMLUnsupported = true;
    config.uniqueItemsMap = {};
    config.isTableCloned = false;
    config.hasSeries = false;
    config.clipDates = _lib.UNDEF;
  };

  _proto.cloneTable = function cloneTable() {
    var chart = this,
        config = chart.config,
        _config$dataTable$get = config.dataTable.getData(),
        data = _config$dataTable$get.data,
        schema = _config$dataTable$get.schema;

    if (!config.isTableCloned) {
      var newDataTable = config.dataTable.getDataStore().createDataTable(data.map(function (row) {
        return row.map(function (cell, idx) {
          return isDateScheme(schema[idx]) ? config.baseTimeConverter.format(cell) : cell;
        });
      }), schema);
      useFirstTables(config.focusTableMap, config.dataTable, disposeFn);
      useFirstTables(config.contextTableMap, config.dataTable, disposeFn);
      config.dataTable = newDataTable;
      config.isTableCloned = true;
      return true;
    }

    return false;
  } // Method that sets style for tooltip
  ;

  _proto.setTooltipStyle = function setTooltipStyle() {
    var tooltipStyle = this.getFromEnv('tooltipStyle'),
        baseTextStyle = this.getFromEnv('baseTextStyle'),
        toolTipController = this.getFromEnv('toolTipController');
    tooltipStyle.container = Object.assign({}, this.config.defaultTooltipStyle, baseTextStyle, tooltipStyle.text, tooltipStyle.container);
    tooltipStyle.header = Object.assign({
      'font-size': (0, _lib.pluck)(tooltipStyle.container['font-size'], '12px'),
      'font-weight': (0, _lib.pluck)(tooltipStyle.container['font-weight'], 'bold'),
      'font-family': tooltipStyle.container['font-family'],
      'padding': '5px 5px 0',
      color: (0, _lib.getLightColor)('#5f5f5f', 76)
    }, tooltipStyle.header);
    tooltipStyle.body = Object.assign({
      'font-size': (0, _lib.pluck)(tooltipStyle.container['font-size'], '11px'),
      'font-weight': (0, _lib.pluck)(tooltipStyle.container['font-weight'], 'normal'),
      'font-family': tooltipStyle.container['font-family'],
      'padding': '0 5px 5px'
    }, tooltipStyle.body);
    toolTipController.setStyle(tooltipStyle.container); // tooltips should not exceed the canvas bottom as it will cause overlap with
    // the crossline label. Hence this restriction is applied.

    toolTipController.setRestrictionWithinCanvas({
      bottom: true
    });
    tooltipStyle.headerStyleString = createStyleStr(tooltipStyle.header);
    tooltipStyle.bodyStyleString = createStyleStr(tooltipStyle.body);
  };

  _proto.sanitizeData = function sanitizeData(attrs) {
    var _this2 = this;

    if (attrs.yaxis && attrs.yaxis.format) {
      if (attrs.yaxis.format.suffix) {
        attrs.yaxis.format.suffix = (0, _lib.parseUnsafeString)(attrs.yaxis.format.suffix);
      }

      if (attrs.yaxis.format.prefix) {
        attrs.yaxis.format.prefix = (0, _lib.parseUnsafeString)(attrs.yaxis.format.prefix);
      }
    }

    _CommonAPI.prototype.sanitizeData.call(this, attrs);

    var _expanderAxis = (0, _axis.default)(columnsFilter(attrs.data, isTemporalScheme), attrs.xaxis, false),
        xAxis = _expanderAxis.expandedAxis,
        xActions = _expanderAxis.actions,
        _expanderAxis2 = (0, _axis.default)(columnsFilter(attrs.data, isNumericScheme), attrs.yaxis),
        yAxis = _expanderAxis2.expandedAxis,
        yActions = _expanderAxis2.actions;

    attrs.xaxis = xAxis;
    attrs.yaxis = yAxis;
    xActions.forEach(function (action) {
      return actionsReducer(action, 'x', _this2);
    });
    yActions.forEach(function (action) {
      return actionsReducer(action, 'y', _this2);
    });
  } // This method return the dataset definations for this charts
  ;

  _proto.getDSdef = function getDSdef() {
    return _line.default;
  };

  _proto._updateVisuals = function _updateVisuals() {
    _CommonAPI.prototype._updateVisuals.call(this);

    this.getFromEnv('paper').config.noDefaultAttribs = true;
  };

  _proto.setPixelLimit = function setPixelLimit(pixelLimit, scale, direction, event) {
    if (direction === void 0) {
      direction = ['up', 'up'];
    }

    var startPx = pixelLimit[0],
        endPx = pixelLimit[1],
        applyEvent,
        _scale$applicableClip = scale.applicableClippings,
        repeatClips = _scale$applicableClip.repeatClips,
        singleClips = _scale$applicableClip.singleClips,
        startVal = (0, _clipUtils.getUnclippedValue)(scale.getDomainValue(startPx), repeatClips, singleClips, {
      clampDirection: direction[0]
    }),
        endVal = (0, _clipUtils.getUnclippedValue)(scale.getDomainValue(endPx), repeatClips, singleClips, {
      clampDirection: direction[1]
    });

    if ((applyEvent = this.setFocusLimit([startVal, endVal])) && event) {
      this.getFromEnv('fireChartEvents')(event.name, [startVal, endVal], event.eventArgs, event.options);
    }

    return applyEvent;
  } // API that validates current domain with respect to its total domain and previous domain.
  ;

  _proto.domainValidator = function domainValidator(currentDomain, totalDomain, prevDomain) {
    if (prevDomain === void 0) {
      prevDomain = [];
    }

    var chart = this,
        mode,
        rangeThreshold = chart.getFromEnv('contextBins')[0].getBinMin(),
        focusScale = chart.getFromEnv('focusScalesX')[0],
        currentDomainStartValue = currentDomain[0],
        currentDomainEndValue = currentDomain[1],
        totalDomainStartValue = totalDomain[0],
        validatedDomainDiff,
        totalDomainEndValue = totalDomain[1],
        currentDomainStartValuems = +currentDomain[0],
        currentDomainEndValuems = +currentDomain[1],
        totalDomainStartValuems = +totalDomain[0],
        totalDomainEndValuems = +totalDomain[1],
        febGutter = 0; // if previous domain is defined, then derive the mode of transformation.

    if (prevDomain.length) {
      mode = Math.abs(currentDomainEndValuems - currentDomainStartValuems - (+prevDomain[1] - +prevDomain[0])) > 1 ? 'squeeze' : 'drag';
    } // if current brush start domain value is less than total domain start value


    if (currentDomainStartValuems < totalDomainStartValuems) {
      currentDomainStartValue = totalDomainStartValue;
      currentDomainEndValue = mode === 'drag' ? new Date(currentDomainEndValuems + (totalDomainStartValuems - currentDomainStartValuems)) : currentDomainEndValue;
    } // if current brush end domain value is greater than total domain end value


    if (currentDomainEndValuems > totalDomainEndValuems) {
      currentDomainEndValue = totalDomainEndValue;
      currentDomainStartValue = mode === 'drag' ? new Date(currentDomainStartValuems - (currentDomainEndValuems - totalDomainEndValuems)) : currentDomainStartValue;
    } // if current brush end domain value is less than total domain start value. possible only if the
    // right handle is dragged across the left handle


    if (currentDomainEndValuems < totalDomainStartValuems) {
      currentDomainEndValue = totalDomainStartValue;
    } // if current brush start domain value is greater than total domain end value. possible only if the
    // left handle is dragged across the right handle


    if (currentDomainStartValuems > totalDomainEndValuems) {
      currentDomainStartValue = totalDomainEndValue;
    } // if current brush start domain value is greater than the current domain end value.


    if (currentDomainStartValuems > currentDomainEndValuems) {
      // swap the domains
      var _ref8 = [currentDomainEndValue, currentDomainStartValue];
      currentDomainStartValue = _ref8[0];
      currentDomainEndValue = _ref8[1];
    }

    if (Object.keys(focusScale.applicableClippings).length) {
      validatedDomainDiff = focusScale.distance(currentDomainStartValue, currentDomainEndValue);
    } else {
      validatedDomainDiff = currentDomainEndValue - currentDomainStartValue;
    }

    if (rangeThreshold[0].name() === 'month' && rangeThreshold[1] === 1) {
      febGutter = 86400000;
    } // Ensures that the chart, at most, zooms in so that three plots may be
    // visible if the data is at regular intervals


    if (validatedDomainDiff >= 3 * rangeThreshold[2] - febGutter) {
      // Raising event for domainvalidator which can be used by mouseTracker
      chart.fireEvent('domainValidated'); // limit should always be clamped within the context limit

      currentDomainStartValue = (0, _lib.clampNumber)(+currentDomainStartValue, totalDomainStartValuems, totalDomainEndValuems);
      currentDomainEndValue = (0, _lib.clampNumber)(+currentDomainEndValue, totalDomainStartValuems, totalDomainEndValuems); // return validated domain

      return [+currentDomainStartValue, +currentDomainEndValue];
    } // if maximum zoom has been acheived then return current focus limit.


    return chart.getFocusLimit() || chart.getContextLimit();
  };

  _proto.configureAttributes = function configureAttributes(attrs) {
    var chart = this,
        config = chart.config,
        colorManager = new _colormanager.default(chart),
        ordinalScale = new _ordinal.default(),
        chartAttrs = attrs.chart,
        colors = parsePaletteColor(chartAttrs.palettecolors),
        canvasHeightProportion = chartAttrs.canvasheightproportion,
        getStyleDef = chart.getFromEnv('getStyleDef'),
        legendConf = attrs.legend,
        baseTextStyle = getStyleDef(chartAttrs.style && chartAttrs.style.text),
        timeSpread = Object.assign({}, chartAttrs.timespread),
        unit = _datetimeEnums.DatetimeUnits[(0, _capsFirst.default)(String(timeSpread.unit))],
        dataSource = chart.getFromEnv('dataSource'),
        defaultTextStyle = (0, _lib.extend2)(chart.getFromEnv('textStyle'), baseTextStyle),
        tooltipConfig = (0, _isObject.default)(attrs.tooltip) ? attrs.tooltip : {},
        tooltipStyle = (0, _isObject.default)(tooltipConfig.style) ? tooltipConfig.style : {},
        // to make color dynamic
    dataObj = this.getFromEnv('dataSource'); // Setting the starting of the week from the chart attributes


    config.startOfWeek = parseInt(attrs.chart.startofweek, 10) === 0 ? _datetimeEnums.Weekdays.Sunday : _datetimeEnums.Weekdays.Monday;
    var legendStyle = getStyleDef(legendConf && legendConf.style && legendConf.style.text),
        interimXExpand = [],
        dateColumn,
        isUTC,
        formatter,
        parser;
    chart.addToEnv('baseTextStyle', Object.assign({
      'font-family': _lib.DEFAULT_FT_FONT,
      stroke: 'none'
    }, baseTextStyle));
    legendStyle = Object.assign({}, chart.getFromEnv('baseTextStyle'), legendStyle);
    config.mergedLegendStyle = (0, _lib.extend2)((0, _lib.extend2)({}, config.defaultLegendTextStyle), legendStyle);

    if (config.focusTableMap) {
      useFirstTables(config.focusTableMap, config.focusTableMap._fc_info.table, disposeFn);
      config.focusTableMap = _lib.UNDEF;
    }

    if (config.contextTableMap) {
      useFirstTables(config.contextTableMap, config.contextTableMap._fc_info.table, disposeFn);
      config.contextTableMap = _lib.UNDEF;
    }

    chart.addToEnv('chart-attrib', chartAttrs);
    colorManager.configure();
    chart.addToEnv('color-manager', colorManager);

    if (colors.length) {
      config.palettecolors = colors;
    } // eslint-disable-next-line


    var _dataObj$data$getData = dataObj.data.getData(),
        schema = _dataObj$data$getData.schema; // eslint-disable-next-line


    for (var key in schema) {
      if (schema.hasOwnProperty(key)) {
        var itemInfo = schema[key];

        if (typeof itemInfo.paletteColor === 'string' && itemInfo.paletteColor !== '') {
          config.palettecolors[key - 1] = itemInfo.paletteColor;
        }
      }
    } // end to make color dynamic


    ordinalScale.setRange(config.palettecolors);
    chart.addToEnv('ordinalScale', ordinalScale);
    config.dataTable = attrs.data;
    config.showLegend = (0, _lib.pluckNumber)(legendConf && legendConf.enabled, chartAttrs.showlegend, 1);
    config.navigatorEnabled = (0, _lib.pluckNumber)(dataSource.navigator && dataSource.navigator.enabled, chartAttrs.enablenavigator, 1);
    config.navigatorHeight = (0, _lib.pluckNumber)(dataSource.navigator && dataSource.navigator.height);
    config.showTooltip = (0, _lib.pluckNumber)(tooltipConfig.enabled, chartAttrs.showtooltip, 1);
    config.interCanvasSpace = (0, _lib.pluckNumber)(chartAttrs.intercanvasspace, DEFAULT_CANVAS_DISTANCE);
    config.multiCanvas = (0, _lib.pluckNumber)(chartAttrs.multicanvas, 1);
    config.applycsstransform = (0, _lib.pluckNumber)(chartAttrs.applycsstransform, 0);
    isUTC = (0, _lib.pluck)(chartAttrs.enableutc, false);
    chart.addToEnv('UTC', isUTC);
    chart.addToEnv('dateAPI', function (dt, param, utc) {
      return dt['get' + (utc ? 'UTC' : '') + param]();
    });
    interimXExpand = attrs.xaxis.slice(0, 1).map(function (ob) {
      return Object.assign({}, ob, {
        bin: ob.plot.map(function (n) {
          return n.value;
        })
      });
    });
    config.focusAxesX = interimXExpand.map(filterInformation);
    config.focusAxesY = (0, _series.default)(columnsFilter(config.dataTable, isStringyScheme), attrs.yaxis, attrs.series, attrs.stack, attrs.group);
    config.contextAxesX = (0, _clone.default)(interimXExpand);
    config.contextAxesY = (0, _clone.default)(config.focusAxesY);
    config.dateColumnIndex = config.dataTable.indexOf(config.contextAxesX[0].plot[0].value);
    dateColumn = config.dataTable.getSchema()[config.dateColumnIndex];
    parser = dateColumn.format ? isUTC ? _timeConverter.default.utcParser(dateColumn.format) : _timeConverter.default.parser(dateColumn.format) : {
      parse: date
    };
    formatter = dateColumn.format ? isUTC ? _timeConverter.default.utcFormatter(dateColumn.format) : _timeConverter.default.formatter(dateColumn.format) : {
      format: toString
    };
    config.baseTimeConverter = {
      toString: function toString() {
        return parser.toString();
      },
      parse: function parse(s) {
        return parser.parse(s);
      },
      format: function format(d) {
        return formatter.format(d);
      }
    };
    chart.addToEnv('baseTimeConverter', config.baseTimeConverter);
    chart.addToEnv('dateColumn', dateColumn); // if valid is unit i provided then only the spread will be considered

    if (unit) {
      timeSpread.unit = unit;
      timeSpread.multiplier = (0, _safeMax.default)([(0, _lib.pluckNumber)(timeSpread.multiplier - 1), 1], Number); // the multiplier will non-zero and positive number

      timeSpread.duration = timeSpread.unit.ms * timeSpread.multiplier;
      timeSpread.interval = isUTC ? utcStandardTimeIntervals[unit.name.toLowerCase()] : standardTimeIntervals[unit.name.toLowerCase()];
      config.timeSpread = timeSpread;
    }

    config.focusPanels = permuteIndices((0, _panel2.default)(config.focusAxesX, config.focusAxesY, attrs.canvas, config.multiCanvas ? defaultPanelsMulticanvas : defaultPanelsSingleCanvas)); // get valid proportions of height based on any given proportion...
    // by default it will return array of length equal to that of focuspanels with proportion set to 1

    config.canvasHeightProportion = getValidProportions(canvasHeightProportion, config.focusPanels.length);

    chart._createLegendMap(); // function that fires canvas interaction events after validating its limits


    chart.addToEnv('fireChartEvents', function (eventType, limit, args, options) {
      if (args === void 0) {
        args = {};
      }

      if (options === void 0) {
        options = {};
      }

      var currFocusLimit = chart.getFocusLimit(),
          contextLimit = chart.getContextLimit(),
          limitsAfterValidation = chart.domainValidator(limit, contextLimit, currFocusLimit),
          eventArguments,
          fmtr;
      eventArguments = {
        start: limitsAfterValidation[0],
        end: limitsAfterValidation[1]
      };

      if (fmtr = options.timeFormatter) {
        eventArguments.startText = fmtr.format(limitsAfterValidation[0]);
        eventArguments.endText = fmtr.format(limitsAfterValidation[1]);
      }

      (0, _lib.extend2)(eventArguments, args);
      chart.fireChartInstanceEvent(eventType, eventArguments);
    });
    (0, _x.default)(chart);
    (0, _y.default)(chart);
    config.focusTableMap = {
      _fc_info: {
        table: config.dataTable
      }
    };
    mapper(chart);
    config.contextPanels = permuteIndices((0, _panel2.default)(config.contextAxesX, config.contextAxesY, [], function (xs, ys) {
      return xs.map(function (cx, ix) {
        return {
          x: [{
            index: ix
          }],
          y: ys.map(function (cy, iy) {
            return {
              index: iy,
              visible: false
            };
          })
        };
      });
    }));
    config.contextTableMap = {
      _fc_info: {
        table: config.dataTable
      }
    };
    mapper(chart, true);
    tableCreator(config.focusTableMap);
    tableCreator(config.contextTableMap);
    config.printOption = {
      enabled: (0, _lib.pluckNumber)(chartAttrs.printshowbutton, chartAttrs.showprintmenuitem, 0)
    };
    config.toolbarPosition = toolbarPositionParser((0, _lib.pluck)(chartAttrs.toolbarposition, 'tr').toLowerCase());
    config.toolbarHAlign = ('' + chartAttrs.toolbarhalign).toLowerCase() === 'left' ? 'l' : config.toolbarPosition.charAt(1);
    config.toolbarVAlign = ('' + chartAttrs.toolbarvalign).toLowerCase() === 'bottom' ? 'b' : config.toolbarPosition.charAt(0); // add clickurl attribute to config of chart

    config.link = chartAttrs.clickurl; // add linkClickFN to env of chart

    chart.addToEnv('linkClickFN', (0, _lib.getLinkAction)(chart.getFromEnv('dataSource'), chart));
    chart.addToEnv('chartConfig', config); // merge user given font styles with default styles if user has provided any

    chart.addToEnv('tooltipStyle', {
      container: getStyleDef(tooltipStyle.container),
      text: getStyleDef(tooltipStyle.text),
      header: getStyleDef(tooltipStyle.header),
      body: getStyleDef(tooltipStyle.body)
    }); // add the default style to the environment of chart.this will be used inside legend.

    chart.addToEnv('style', {
      'outCancolor': defaultTextStyle.fill,
      'fontSize': defaultTextStyle['font-size'],
      'outCanfontFamily': defaultTextStyle['font-family']
    });
    chart.createBaseComponent();
    chart.getFromEnv('animationManager').setAnimationState(chart._firstConfigure ? 'initial' : 'update'); // Parsing prediction object which has metadata about representation of predicted data

    config.prediction = parsePrediction(dataSource, getStyleDef);
    chart.addToEnv('prediction', config.prediction);
    chart.configureChildren();
    chart.setTooltipStyle();
  };

  _proto._createLegendMap = function _createLegendMap(preserveVisibilityState) {
    if (preserveVisibilityState === void 0) {
      preserveVisibilityState = false;
    }

    var chart = this,
        config = chart.config,
        legendMap = config.legendMap = {},
        legendConf = chart.getFromEnv('dataSource').legend,
        uniqueItems = {},
        prevLegendMap = chart.getFromEnv('legendMap'),
        legend = chart.getChildren('legend') && chart.getChildren('legend')[0],
        createLegend = function createLegend(info) {
      if (info === void 0) {
        info = {};
      }

      for (var key in info) {
        if (info.hasOwnProperty(key)) {
          var itemInfo = info[key];

          if (itemInfo.hasOwnProperty('visibility')) {
            chart._addLegend(itemInfo);
          } else {
            createLegend(itemInfo);
          }
        }
      }
    }; // by default the multiplication of pixel threshold will be one and will
    // only be changed if there are multiple columns in same axis


    config.pixelMultiplier = 1; // a list of unique items for the legend needs to be created

    config.focusAxesY.forEach(function (_ref9) {
      var plot = _ref9.plot;
      var count = 0,
          colItemsArr;
      plot.forEach(function (_ref10) {
        var stack = _ref10.stack,
            group = _ref10.group,
            value = _ref10.value,
            type = _ref10.type,
            name = _ref10.name;
        var isColumn = type === 'column';

        if (isColumn) {
          // when group is present then the count will incremented by the number of unique items
          // of the group or else it will incremented by one
          colItemsArr = group ? config.dataTable.unique(group) : new Array(1);
          count += colItemsArr.length;
        }

        if (stack) {
          // if (uniqueItems[stack]) return;
          uniqueItems[stack] = config.dataTable.unique(stack);
          config.hasSeries = true;
        } else if (group) {
          // if (uniqueItems[group]) return;
          uniqueItems[group] = isColumn ? colItemsArr : config.dataTable.unique(group);
          config.hasSeries = true; // legend will not be created for ohlc charts
        } else if (type === 'column-range' || type === 'area-range') {
          if (name) {
            uniqueItems[name] = [name];
          }
        } else if (type !== 'ohlc' && type !== 'candlestick') {
          // if (uniqueItems[value]) return;
          uniqueItems[value] = [value];
        }
      });
      config.pixelMultiplier = Math.max(count, config.pixelMultiplier);
    });

    for (var key in uniqueItems) {
      if (uniqueItems.hasOwnProperty(key)) {
        // all the unique names will create a single legend item
        var uniqueArr = uniqueItems[key];
        uniqueArr.forEach(function (name) {
          if (!legendMap[name]) {
            var obj = config.showLegend && legendConf && legendConf.item && Array.isArray(legendConf.item) && legendConf.item.find(function (o) {
              return o.value === name;
            }),
                hidden = (0, _lib.pluckNumber)(obj && obj.initiallyhidden, 0);
            legendMap[name] = {
              visibility: !hidden,
              initiallyhidden: !!hidden,
              series: name
            };
          }
        });
      }
    }

    chart.addToEnv('legendMap', legendMap);

    if (prevLegendMap) {
      var newLegendMap = legendMap,
          reuseLegend = function reuseLegend(oldObj, newObj) {
        for (var _key2 in oldObj) {
          if (oldObj.hasOwnProperty(_key2)) {
            var newItem = newObj && newObj[_key2],
                oldItem = oldObj[_key2];

            if (oldItem.hasOwnProperty('visibility')) {
              if (newItem) {
                if (!preserveVisibilityState) {
                  if (!oldItem.visibility) {
                    legend && legend.getItem(oldItem.legendItemId).removeLegendState('hidden');
                    oldItem.visibility = true;
                  }

                  if (!newItem.initiallyhidden) {
                    legend && legend.getItem(oldItem.legendItemId).removeLegendState('hidden');
                    oldItem.visibility = true;
                    oldItem.initiallyhidden = false;
                  } else if (newItem.initiallyhidden) {
                    legend && legend.getItem(oldItem.legendItemId).setLegendState('hidden');
                    oldItem.visibility = false;
                    oldItem.initiallyhidden = true;
                  }
                }

                newObj[_key2] = oldItem;
              } else {
                legend && legend.disposeItem(oldItem.legendItemId);
              }
            } else {
              reuseLegend(oldItem, newItem);
            }
          }
        }
      };

      reuseLegend(prevLegendMap, newLegendMap);
    }

    if (legend) {
      createLegend(chart.getFromEnv('legendMap'));
      legend.asyncDraw();
    }
  };

  _proto._updateAffectedVisuals = function _updateAffectedVisuals(configs) {
    if (configs === void 0) {
      configs = {};
    }

    var chart = this,
        config = chart.config,
        childs = chart.getChildren();
    Object.keys(config.canvasAxisMap).forEach(function (key) {
      return childs[key].forEach(function (canvas) {
        return !canvas.getState('removed') && canvas.setData(configs, true);
      });
    });
    childs.timeNavigator && childs.timeNavigator.forEach(function (navi) {
      if (!navi.getState('removed')) {
        navi.setData(configs, true); // for placing and drawing of axis labels of navigator

        navi.setDimension();
      }
    });
    chart.manageSpace();
  };

  _proto._addLegend = function _addLegend(info) {
    var chart = this,
        fillColor,
        // lightColor,
    config,
        legendItem,
        chartConfig = chart.config,
        mergedLegendStyle = chartConfig.mergedLegendStyle,
        series = info.series,
        itemConfig,
        color = chart.getFromEnv('ordinalScale').getRangeValue(series),
        legend = chart.getFromEnv('legend'),
        strokeColor = (0, _lib.getLightColor)(color, 60).replace(dropHash, _lib.HASHSTRING);

    if (chartConfig.showLegend) {
      fillColor = {
        FCcolor: {
          color: color,
          angle: 0,
          ratio: '0',
          alpha: '100'
        }
      };
      legendItem = legend.getItem(info.legendItemId);
      config = {
        label: series,
        eventArguments: {
          datasetName: series,
          visible: info.visibility
        }
      };

      if (!legendItem) {
        info.legendItemId = legend.createItem();
        legendItem = legend.getItem(info.legendItemId);

        if (info.initiallyhidden) {
          info.visibility = false;
          legendItem.config.eventArguments.visible = false;
          legendItem.setLegendState('hidden');
        }

        chart.addExtEventListener('fc-click', function () {
          var visibility = info.visibility;
          itemConfig = legendItem.config;

          if (visibility) {
            info.visibility = false;
            itemConfig.eventArguments.visible = false;
            legendItem.setLegendState('hidden');
          } else {
            info.visibility = true;
            itemConfig.eventArguments.visible = true;
            legendItem.removeLegendState('hidden');
          }

          chart._updateAffectedVisuals({
            legendInteracted: true
          });
        }, legendItem);
      }

      legendItem.configure(config);
      legendItem.setStateCosmetics('default', {
        symbol: {
          fill: (0, _lib.toRaphaelColor)(fillColor),
          rawFillColor: color,
          stroke: (0, _lib.toRaphaelColor)(strokeColor)
        },
        text: Object.assign({}, mergedLegendStyle, {
          fill: (0, _lib.convertColor)(mergedLegendStyle.fill, mergedLegendStyle.opacity * mergedLegendStyle['fill-opacity'] * 100)
        })
      });
    }
  };

  _proto._createGroup = function _createGroup(attr, container) {
    if (attr === void 0) {
      attr = {};
    }

    var animationManager = this.getFromEnv('animationManager');
    return animationManager.setAnimation({
      attr: attr,
      container: container,
      el: 'group',
      component: this,
      label: 'group'
    });
  };

  _proto._createLayers = function _createLayers() {
    var animationManager = this.getFromEnv('animationManager');
    var parentGroup = this.getContainer('parentgroup'),
        exo;
    !parentGroup && (parentGroup = this.addContainer('parentgroup', animationManager.setAnimation({
      el: parentGroup || 'group',
      attr: {
        name: 'parentgroup'
      },
      component: this
    }))); // creating tropo group

    if (!this.getChildContainer('tropo')) {
      this.addChildContainer('tropo', this._createGroup({
        name: 'chart-tropo'
      }, parentGroup));
    }

    if (!this.getChildContainer('strato')) {
      this.addChildContainer('strato', this._createGroup({
        name: 'chart-strato'
      }, parentGroup));
    } // creating meso group


    if (!this.getChildContainer('meso')) {
      this.addChildContainer('meso', this._createGroup({
        name: 'chart-meso'
      }, parentGroup));
    } // creating thermo group


    if (!this.getChildContainer('thermo')) {
      this.addChildContainer('thermo', this._createGroup({
        name: 'chart-thermo'
      }, parentGroup));
    } // creating exo group


    if (!this.getChildContainer('exo')) {
      exo = this.addChildContainer('exo', this._createGroup({
        name: 'chart-exo'
      }, parentGroup));
    }

    if (!this.getChildContainer('toolbar-master')) {
      this.addChildContainer('toolbar-master', this._createGroup({
        name: 'toolbar-master'
      }, exo));
    } // Creating the group for legend


    if (!this.getChildContainer('legendGroup')) {
      this.addChildContainer('legendGroup', this._createGroup({
        name: 'legend-group'
      }, exo));
    }
  } // check if the legend position given by user is valid
  ;

  _proto.checkValidLegendPosition = function checkValidLegendPosition() {
    var chart = this,
        dataSource = chart.getFromEnv('dataSource'),
        legendConf = dataSource.legend,
        legendPosition = legendConf.position ? legendConf.position.toLowerCase() : '',
        legendAlignment = legendConf.alignment ? legendConf.alignment.toLowerCase() : '';

    if (!legendPosition) {
      if (legendAlignment === _lib.POSITION_START || legendAlignment === _lib.POSITION_MIDDLE || legendAlignment === _lib.POSITION_END) {
        return true;
      }
    } else if (legendPosition === _lib.POSITION_TOP || legendPosition === _lib.POSITION_BOTTOM || legendPosition === _lib.POSITION_LEFT || legendPosition === _lib.POSITION_RIGHT) {
      if (!legendAlignment) {
        return true;
      } else if (legendAlignment === _lib.POSITION_START || legendAlignment === _lib.POSITION_MIDDLE || legendAlignment === _lib.POSITION_END) {
        return true;
      }
    }

    return false;
  }
  /**
   * Space manager of time-series. All the child components are provided with
   * available width, available height and translation
   *
   * @returns {instance} chart instance
   * @memberof TimeSeries
   */
  ;

  _proto.manageSpace = function manageSpace() {
    var chart = this,
        config = chart.config,
        focusPanels = config.focusPanels,
        canvasAxisMap = config.canvasAxisMap,
        xScales = chart.getFromEnv('focusScalesX'),
        caption = chart.getChildren('caption'),
        selectorToolBar = chart.getFromEnv('selectorToolbar'),
        menubar = chart.getFromEnv('toolbar'),
        menuSpace = menubar.getLogicalSpace(),
        legend = chart.getChildren('legend') && chart.getChildren('legend')[0],
        background = chart.getChildren('background')[0],
        firstCanvas = chart.getChildren('canvas_0'),
        timeNavigators = chart.getChildren('timeNavigator'),
        dataSource = chart.getFromEnv('dataSource'),
        legendConf = dataSource.legend,
        totalWidth,
        totalHeight,
        availableHeight,
        userNavHeight = config.navigatorHeight,
        timeNavScrollbarAndLabelHeight,
        totalTimeNavHeight = 0,
        availableWidth,
        intermediateCanvasHeight,
        maxVAxisWidth = {
      left: 0,
      right: 0
    },
        left = 0,
        top = 0,
        right = totalWidth = +chart.getFromEnv('chartWidth'),
        bottom = totalHeight = +chart.getFromEnv('chartHeight'),
        captionDim,
        leftAxesMaxWidth = 0,
        rightAxesMaxWidth = 0,
        marginHorizontal = 0.03 * totalWidth,
        marginVertical = 16,
        axisHeight = 0,
        heightTaken,
        yAxesDimensions,
        xAxesDimensions,
        intermediateTimeNavSelectionHeight,
        actualTimeNavSelectionHeight,
        timeNavHeight,
        brush,
        legendHeight,
        legendWidth,
        mid,
        legendPosition = _lib.POSITION_BOTTOM,
        legendAlignment = _lib.POSITION_START,
        legendX,
        legendY,
        validLegendPosition,
        toolHeight,
        capHeight,
        canvasBorder = {
      topBorder: 0,
      bottomBorder: 0,
      leftBorder: 0,
      rightBorder: 0
    },
        captionWidth,
        heightProportion = config.canvasHeightProportion,
        interCanvasSpace = config.interCanvasSpace,
        watermarkSpace = marginVertical > 37 ? 0 : 37 - marginVertical; // Allocate space for the margins

    top += (0, _lib.pluckNumber)(config.marginTop, marginVertical);
    bottom -= (0, _lib.pluckNumber)(config.marginBottom, marginVertical + watermarkSpace);
    left += (0, _lib.pluckNumber)(config.marginLeft, marginHorizontal);
    right -= (0, _lib.pluckNumber)(config.marginRight, marginHorizontal);
    background.setDimension({
      height: totalHeight,
      width: totalWidth
    });
    background.setTranslation(0, 0); // Calculate the space taken by all the y-axes. Among them, determine the max space taken by axis aligned as left(maxLeftWidth)
    // and axis aligned as right(maxRightWidth).
    // For all left aligned axis, maxLeftWidth should be the width and for all right aligned axis maxRightWidth should be the width.
    // ^this is to align all the axis names in a single line during a multivariate scenario

    focusPanels.forEach(function (panelInfo, i) {
      var canvasInfo = canvasAxisMap["canvas_" + i],
          yIds = canvasInfo.y,
          yAxisWidth = DEFAULT_AXIS_HEIGHT_RATIO * (right - left) / (yIds.length || 1),
          setYAxisDim = function setYAxisDim(axisId) {
        var index = getIndex(axisId),
            dim = chart.getChildren(axisId)[0].setDimension({
          width: yAxisWidth
        });
        return panelInfo.y[index].overlap ? {} : dim;
      };

      yAxesDimensions = yIds.map(setYAxisDim);
      yAxesDimensions.forEach(function (dim) {
        if (typeof dim.left === 'number') {
          maxVAxisWidth.left = Math.max(maxVAxisWidth.left, dim.left);
        } else {
          maxVAxisWidth.right = Math.max(maxVAxisWidth.right, dim.right);
        }
      });
    }); // Re-assign the maxLabelSpace(which is basically the width taken by y-axis) with the max values

    focusPanels.forEach(function (panelInfo, i) {
      var canvasInfo = canvasAxisMap["canvas_" + i],
          yIds = canvasInfo.y,
          axesLeftWidth = 0,
          axesRightWidth = 0,
          axis,
          dim,
          align;
      yIds.forEach(function (axisId) {
        axis = chart.getChildren(axisId)[0];
        align = axis.getAlignment(); // update the max space required by the axis

        dim = axis.updateMaxLabelSpace(maxVAxisWidth[align]);
        axesLeftWidth += (0, _lib.pluckNumber)(dim.left, 0);
        axesRightWidth += (0, _lib.pluckNumber)(dim.right, 0);
      });
      leftAxesMaxWidth = (0, _safeMax.default)([leftAxesMaxWidth, axesLeftWidth]);
      rightAxesMaxWidth = (0, _safeMax.default)([rightAxesMaxWidth, axesRightWidth]);
    });
    focusPanels.forEach(function (panelInfo, i) {
      var canvasInfo = canvasAxisMap["canvas_" + i],
          xIds = canvasInfo.x,
          xAxisHeight = DEFAULT_AXIS_HEIGHT_RATIO * (bottom - top) / (xIds.length || 1),
          setXAxisDim = function setXAxisDim(axisId) {
        var index = getIndex(axisId),
            dim = chart.getChildren(axisId)[0].setDimension({
          height: xAxisHeight
        });
        return panelInfo.x[index].overlap ? {} : dim;
      };

      xAxesDimensions = xIds.map(setXAxisDim);
      xAxesDimensions.forEach(function (dim) {
        axisHeight += (0, _lib.pluckNumber)(dim.top, dim.bottom, 0);
      });
    });
    availableHeight = bottom - top; // initial calculation for available width

    availableWidth = Math.max(0, right - left); // check wether the values given by user are valid

    if (legendConf && (legendConf.position || legendConf.alignment)) {
      validLegendPosition = this.checkValidLegendPosition();
    } // if position entered by user are valid asign them


    if (validLegendPosition) {
      legendPosition = legendConf.position ? legendConf.position.toLowerCase() : _lib.POSITION_BOTTOM;
      legendAlignment = legendConf.alignment ? legendConf.alignment.toLowerCase() : _lib.POSITION_START;
    } // Calculate the X-axis value for legend if the position is left/right


    if (legend && (legendPosition === _lib.POSITION_LEFT || legendPosition === _lib.POSITION_RIGHT)) {
      // to make the legend use one column
      legend.config.numColumns = 1;
      legendWidth = Math.max(0, legend.setDimension({
        height: 'auto',
        width: availableWidth
      }).width);
      legendHeight = legend.config.height;

      if (legendPosition === _lib.POSITION_LEFT) {
        legendX = left; // check wether the y-axis is aligned towards left

        if (leftAxesMaxWidth > 0) {
          left += legendWidth;
        } else {
          left += legendWidth + (0, _lib.pluckNumber)(config.marginLeft, marginHorizontal);
        }
      } else if (legendPosition === _lib.POSITION_RIGHT) {
        // check wether the y-axis is aligned towards right
        if (rightAxesMaxWidth > 0) {
          right -= legendWidth;
          legendX = right;
        } else {
          right -= legendWidth + (0, _lib.pluckNumber)(config.marginRight, marginHorizontal);
          legendX = right + (0, _lib.pluckNumber)(config.marginRight, marginHorizontal);
        }
      }
    } // Allocate space for y-axis placed at left


    left += leftAxesMaxWidth; // Allocate space for y-axis placed at right

    right -= rightAxesMaxWidth;

    if (menuSpace.height) {
      menubar.setDimension({
        x: right - menuSpace.width,
        y: top
      });
      menubar.manageSpace();
    }

    if (caption[0].config.captionAlignment === 'right' || caption[0].config.subCaptionAlignment === 'right') {
      top += menuSpace.height;
      captionWidth = right - left;
    } else {
      captionWidth = right - left - menuSpace.width;
    } // Allocate space and position for caption subcaption


    if (caption && caption.length) {
      // Caption should take maximum 30% of chart height
      captionDim = caption[0].setDimension({
        width: captionWidth,
        height: DEFAULT_CAPTION_HEIGHT_RATIO * availableHeight
      }); // Provide position for caption

      caption[0].setTranslation(left, top); // Increment top to account for space taken by caption

      capHeight = Math.max(captionDim.height, menuSpace.height);
    } else {
      capHeight = menuSpace.height;
    }

    top += capHeight;
    availableWidth = Math.max(0, right - left); // store the top value where the legend has to be drawn for left-start/right-start/top

    if (legend && (legendPosition === _lib.POSITION_TOP || (legendPosition === _lib.POSITION_RIGHT || legendPosition === _lib.POSITION_LEFT) && legendAlignment === _lib.POSITION_START)) {
      legend.setDimension({
        height: 'auto',
        width: availableWidth
      });
      legendWidth = legend.config.width;
      legendHeight = legend.config.height;
      legendY = top; // increament the top to accomodate the space for legend

      if (legendPosition === _lib.POSITION_TOP) {
        top += legendHeight;
      }
    }

    if (legend && legendPosition === _lib.POSITION_BOTTOM) {
      legend.setDimension({
        height: availableHeight * DEFAULT_LEGEND_RATIO,
        width: availableWidth
      });
      legendWidth = legend.config.width;
      legendHeight = legend.config.height;
    }

    toolHeight = selectorToolBar.getLogicalSpace().height;
    selectorToolBar.setDimension({
      x: left,
      y: top,
      width: availableWidth
    });
    selectorToolBar.manageSpace();
    top += toolHeight;
    heightTaken = axisHeight + (focusPanels.length - 1) * interCanvasSpace;
    availableHeight = Math.max(0, bottom - top - heightTaken); // Legend Space Management

    if (legend) {
      // calculate legend dimensions if not calculated previously
      legendHeight = legendHeight || Math.max(0, legend.setDimension({
        height: availableHeight * DEFAULT_LEGEND_RATIO,
        width: availableWidth
      }).height);
      legendWidth = legendWidth || legend.config.width; // legend space Management for top

      if (legendPosition === _lib.POSITION_TOP) {
        if (legendAlignment === _lib.POSITION_END) {
          legend.setTranslation(right - legendWidth + LEGEND_ALIGNMENT, legendY);
        } else if (legendAlignment === _lib.POSITION_MIDDLE) {
          // calculate the middle position
          mid = (left + right - legendWidth) / 2;
          legend.setTranslation(mid, legendY);
        } else {
          legend.setTranslation(left - LEGEND_ALIGNMENT, legendY);
        }
      } else if (legendPosition === _lib.POSITION_RIGHT || legendPosition === _lib.POSITION_LEFT) {
        // legend space Management for left/right
        if (legendAlignment === _lib.POSITION_END) {
          // accomodate space for legend at the bottom
          bottom -= legendHeight;
          legend.setTranslation(legendX, bottom); // increament the bottom as the rest of the canvas should use the whole available height

          bottom += legendHeight;
        } else if (legendAlignment === _lib.POSITION_MIDDLE) {
          // calculate the middle position
          mid = (top + bottom - legendHeight) / 2;
          legend.setTranslation(legendX, mid);
        } else {
          legend.setTranslation(legendX, legendY);
        }
      } else {
        // reduce the bottom to accomodate legend
        bottom -= legendHeight;
        availableHeight -= legendHeight;

        if (legendAlignment === _lib.POSITION_END) {
          legend.setTranslation(right - legendWidth + LEGEND_ALIGNMENT, bottom);
        } else if (legendAlignment === _lib.POSITION_MIDDLE) {
          // calculate the middle position
          mid = (left + right - legendWidth) / 2;
          legend.setTranslation(mid, bottom);
        } else {
          // for invalid position(default) as well as bottom start
          legend.setTranslation(left - LEGEND_ALIGNMENT, bottom);
        }
      }
    }

    if (timeNavigators && timeNavigators.length) {
      // calculate the intermediate height of the canvas which is the height after deducting the intermediate
      // height of time navigator
      intermediateCanvasHeight = (1 - DEFAULT_TIMENAV_HEIGHT_RATIO) * availableHeight / (focusPanels.length || 1); // calculate the intermediate height of the selection box of time navigator considering its default height ratio.

      intermediateTimeNavSelectionHeight = DEFAULT_TIMENAV_HEIGHT_RATIO * availableHeight / (timeNavigators.length || 1); // Allocate space for time-navigator

      timeNavigators.forEach(function (timeNavigator, index) {
        timeNavigator.config.formatter = _timeConverter.default.formatter(dataSource.navigator && dataSource.navigator.outputtimeformat ? (0, _lib.pluck)(dataSource.navigator.outputtimeformat) : timeNavigator.config.formatter);
        if (timeNavigator.getState('removed')) return;
        brush = timeNavigator.getChildren('brush')[0]; // total height of time nav labels and time nav scrollbar

        timeNavScrollbarAndLabelHeight = brush.getLabelSpace() + timeNavigator.config.scrollbarHeight; // calculate actual time nav selection box height by taking the minimum of the calculated intermediate height and 80% of either canvas.
        // also considering the min and max height to be 48px and 60px respectively

        actualTimeNavSelectionHeight = userNavHeight ? Math.min(Math.max(userNavHeight, 44), 84) : Math.min(Math.max(Math.min(intermediateTimeNavSelectionHeight, 0.8 * intermediateCanvasHeight), 48), 60); // time navigator total height

        timeNavHeight = actualTimeNavSelectionHeight + timeNavScrollbarAndLabelHeight;
        timeNavigator.setDimension({
          width: availableWidth,
          height: timeNavHeight
        });
        timeNavigator.setTranslation(left, bottom - (timeNavigators.length - index) * timeNavHeight);
        totalTimeNavHeight += timeNavHeight;
      }); // If totalTimeNavHeight is greater than the available, do not allocate space to time navigator

      if (totalTimeNavHeight > availableHeight) {
        timeNavigators.forEach(function (nav) {
          return nav.setDimension({
            width: 0,
            height: 0
          });
        });
      } else {
        availableHeight -= totalTimeNavHeight;
      }
    }

    if (firstCanvas && firstCanvas[0]) {
      canvasBorder = firstCanvas[0].getCanvasBorder();
    }

    xScales.forEach(function (scale) {
      return scale.setRange([canvasBorder.leftBorder, availableWidth - (canvasBorder.leftBorder + canvasBorder.rightBorder) / 2]);
    });
    focusPanels.forEach(function (panelConfig, index) {
      var canvasId = "canvas_" + index,
          _canvasAxisMap$canvas = canvasAxisMap[canvasId],
          xIds = _canvasAxisMap$canvas.x,
          yIds = _canvasAxisMap$canvas.y,
          x = panelConfig.x,
          y = panelConfig.y,
          tempLeft = left,
          tempRight = left + availableWidth,
          canvas = chart.getChildren(canvasId)[0],
          tempTop = top + canvasBorder.topBorder,
          tempBottom = tempTop + availableHeight / heightProportion.totalProportions * heightProportion.proportions[index],
          overlappedXAxis = []; // Set range of y-scales

      y.forEach(function (yValue, i) {
        yValue.scale.setRange([availableHeight / heightProportion.totalProportions * heightProportion.proportions[index] - canvasBorder.bottomBorder - CANVAS_TOP_PADDING, canvasBorder.topBorder]);
      });
      if (canvas.getState('removed')) return;
      canvasBorder = canvas.getCanvasBorder();
      canvas.setPadding({
        top: CANVAS_TOP_PADDING
      });
      canvas.setDimension({
        width: availableWidth,
        height: availableHeight / heightProportion.totalProportions * heightProportion.proportions[index]
      });
      xIds.forEach(function (id) {
        var axisInfo = x[getIndex(id)],
            axis = chart.getChildren(id)[0],
            dim = axis.getDimension();

        if (axisInfo.overlap) {
          overlappedXAxis.push(id);
          return;
        }

        if (axisInfo.align === 'top') {
          axis.setTranslation(left + canvasBorder.leftBorder, tempTop);
          tempTop += dim.top;
        } else if (axisInfo.align === 'bottom') {
          axis.setTranslation(left + canvasBorder.leftBorder, tempBottom);
          tempBottom += dim.bottom;
        }
      });
      canvas.setTranslation(left, tempTop);
      overlappedXAxis.forEach(function (id) {
        var axisInfo = x[getIndex(id)],
            axis = chart.getChildren(id)[0],
            dim = axis.getDimension();

        if (axisInfo.align === 'top') {
          axis.setTranslation(left + canvasBorder.leftBorder, tempTop);
        } else if (axisInfo.align === 'bottom') {
          axis.setTranslation(left + canvasBorder.leftBorder, tempTop + availableHeight / heightProportion.totalProportions * heightProportion.proportions[index] - dim.bottom);
        }
      });
      yIds.forEach(function (id) {
        var axisTop = tempTop + CANVAS_TOP_PADDING;
        var axisInfo = y[getIndex(id)],
            axis = chart.getChildren(id)[0],
            dim = axis.getDimension();

        if (axisInfo.overlap) {
          if (axisInfo.align === 'left') {
            axis.setTranslation(left, axisTop);
          } else if (axisInfo.align === 'right') {
            axis.setTranslation(left + availableWidth - dim.right, axisTop);
          }
        } else {
          if (axisInfo.align === 'left') {
            tempLeft -= dim.left;
            axis.setTranslation(tempLeft, axisTop);
          } else if (axisInfo.align === 'right') {
            axis.setTranslation(tempRight, axisTop);
            tempRight += dim.right;
          }
        }
      });
      top = tempBottom + interCanvasSpace;
    });
  };

  _proto._setDataLabelStyle = function _setDataLabelStyle() {
    // no-op. Time-series does not have any data labels. Yet.
    return this;
  }
  /**
   * Function to check if the chart has the proper data or not
   * @return {boolean} if JSON data is valid or not
   */
  ;

  _proto._checkInvalidData = function _checkInvalidData() {
    var dataObj = this.getFromEnv('dataSource'),
        chartInstance = this.getFromEnv('chartInstance'); // Checking if the chart has proper data

    if (!dataObj.data) {
      chartInstance.__state.dataReady = false;
      chartInstance.jsVars.hasNativeMessage = true;
      chartInstance.jsVars.drawCount += 1;
      return true;
    }

    return false;
  };

  _proto._checkInvalidSpecificData = function _checkInvalidSpecificData() {
    var dataObj = this.getFromEnv('dataSource');

    if (dataObj.data && typeof dataObj.data.getData === 'function') {
      var _dataObj$data$getData2 = dataObj.data.getData(),
          schema = _dataObj$data$getData2.schema;

      if (!Array.isArray(schema) || !schema.filter(function (obj) {
        return obj.type === 'date';
      }).length || !schema.filter(function (obj) {
        return obj.type === 'number';
      }).length) {
        return true;
      }

      return false;
    }

    return true;
  };

  _proto.setYScaleLimit = function setYScaleLimit(scaleId, dsId, limit, baseRequired) {
    if (baseRequired === void 0) {
      baseRequired = true;
    }

    var chart = this,
        config = chart.config,
        scaleDsMap = config.scaleDsMap,
        scaleMap = scaleDsMap[scaleId],
        dsInfo,
        dataMin,
        dataMax,
        visibilityLimit = {
      start: _lib.UNDEF,
      end: _lib.UNDEF
    },
        isBaseRequired,
        findFn = function findFn(_ref11) {
      var scale = _ref11.scale;
      return scale && scale.getId() === scaleId;
    },
        focusY = config.focusAxesY.find(findFn),
        contextY = config.contextAxesY.find(findFn),
        y = focusY || contextY,
        scale = y && y.scale;

    if (!scale) return;

    if (!scaleMap) {
      scaleMap = scaleDsMap[scaleId] = {};
    }

    if (!(dsInfo = scaleMap[dsId])) {
      dsInfo = scaleMap[dsId] = {};
    }

    dsInfo.limit = limit;
    dsInfo.baseRequired = baseRequired;

    for (var key in scaleMap) {
      if (scaleMap.hasOwnProperty(key)) {
        var dsInf = scaleMap[key];

        var _extent = (0, _extent3.default)([dataMin, dataMax].concat(dsInf.limit));

        dataMin = _extent[0];
        dataMax = _extent[1];
        isBaseRequired = isBaseRequired || dsInf.baseRequired;
      }
    }

    if (scale.getType() === 'log') {
      scale.setDomain(getLogMinMax(dataMin, dataMax, y.min, y.max, y.base, isBaseRequired));
    } else {
      scale.setDomain(getLinearMinMax(dataMin, dataMax, y.min, y.max, isBaseRequired));
    }

    if ((0, _lib.defined)(dataMin)) {
      visibilityLimit.start = -Infinity;
      visibilityLimit.end = Infinity;
    }

    if (focusY) {
      config.focusPanels.forEach(function (panelInfo, i) {
        var canvasId = "canvas_" + i,
            yInf = config.canvasAxisMap[canvasId],
            yIds = yInf && yInf.y;
        if (!yIds) return;
        yIds.forEach(function (id) {
          var axes = chart.getChildren(id);
          axes.forEach(function (axis) {
            if (axis.getScale() === scale) {
              axis.setTickVisibilityLimit(visibilityLimit);
              axis.placeAxis();
              axis.asyncDraw();
            }
          });
        });
      });
    }
  };

  _proto.setXScaleLimit = function setXScaleLimit(scaleId, dsId, limit) {
    var chart = this,
        config = chart.config,
        scaleDsMap = config.scaleDsMap,
        scaleMap = scaleDsMap[scaleId],
        dsInfo,
        dataMin,
        dataMax,
        min,
        isUTC = chart.getFromEnv('UTC'),
        timeIntervals = isUTC ? utcStandardTimeIntervals : standardTimeIntervals,
        max,
        visibilityLimit = {
      start: config.rawDataXStart,
      end: Infinity
    },
        _chart$getContextLimi = chart.getContextLimit(),
        tMin = _chart$getContextLimi[0],
        tMax = _chart$getContextLimi[1],
        findFn = function findFn(_ref12) {
      var scale = _ref12.scale;
      return scale && scale.getId() === scaleId;
    },
        focusX = config.focusAxesX.find(findFn),
        contextX = config.contextAxesX.find(findFn),
        x = focusX || contextX,
        binDecider = this.getFromEnv('contextBins')[0],
        atomicity = binDecider.getBinMin()[2],
        rangeThreshold = binDecider.getRangeThreshold(),
        timeIntervalName = rangeThreshold[0]._name,
        scale = x && x.scale;

    if (!scale) return;

    if (!scaleMap) {
      scaleMap = scaleDsMap[scaleId] = {};
    }

    if (!(dsInfo = scaleMap[dsId])) {
      dsInfo = scaleMap[dsId] = {};
    }

    dsInfo.limit = limit;

    for (var key in scaleMap) {
      if (scaleMap.hasOwnProperty(key)) {
        var dsInf = scaleMap[key];

        var _extent2 = (0, _extent3.default)([dataMin, dataMax].concat(dsInf.limit));

        dataMin = _extent2[0];
        dataMax = _extent2[1];
      }
    }

    if ((0, _lib.defined)(dataMin)) {
      visibilityLimit.start = Math.min(dataMin, config.rawDataXStart);
      visibilityLimit.end = Infinity;
    }

    if (focusX) {
      var _chart$getFocusLimit2 = chart.getFocusLimit();

      min = _chart$getFocusLimit2[0];
      max = _chart$getFocusLimit2[1];

      if (+min === tMin && (0, _isValidNumber.default)(dataMin)) {
        min = Math.min(min, dataMin);
      }

      if (+max === tMax && (0, _isValidNumber.default)(dataMax)) {
        max = Math.max(max, dataMax);
      }

      if (Math.ceil((max - min) / rangeThreshold[2]) < 3 && atomicity === rangeThreshold[2]) {
        min = +timeIntervals[timeIntervalName].offset(max, -3 * rangeThreshold[1]);
      }

      scale.setDomain([min, max]);
      config.focusPanels.forEach(function (panelInfo, i) {
        var canvasId = "canvas_" + i,
            canvases = chart.getChildren(canvasId),
            canvas = canvases && canvases[0],
            xInf = config.canvasAxisMap[canvasId],
            xIds = xInf && xInf.x; // setXScaleLimit, amongst other times, is called during a chart's
        // dataset's disposal. By this time, the chart's axes and canvases are
        // already removed and there is no need to invoke their rendering.
        //
        // TODO: Investigate why the canvases are getting removed. Even if they
        // are disposed, they should still exist as components which are marked
        // as removed. But, here the component is completely non-existent!

        if (!xIds || !canvas) return;
        canvas.asyncDraw();
        xIds.forEach(function (id) {
          chart.getChildren(id).forEach(function (axis) {
            if (axis.getScale() === scale) {
              axis.setTickVisibilityLimit(visibilityLimit);
              axis.placeAxis();
              axis.asyncDraw();
            }
          });
        });
      });
    } else {
      // For a context X scale,
      // Choose the min/max between the data min/max and the context min/max.
      // If the data min/max is invalid, the context min/max is always chosen.
      //
      // When the user has explicitly specified the min/max values for the xAxis
      // in the data source, it is available in the context min/max. The
      // min/max of the provided data is available in data min/max. Comparing
      // these pairs of mins and maxes give us the correct limits for the domain
      // of the context scale.
      min = (0, _isValidNumber.default)(dataMin) ? Math.min(tMin, dataMin) : tMin;
      max = (0, _isValidNumber.default)(dataMax) ? Math.max(tMax, dataMax) : tMax;

      if (Math.ceil((max - min) / rangeThreshold[2]) < 3 && atomicity === rangeThreshold[2]) {
        min = +timeIntervals[timeIntervalName].offset(max, -3 * rangeThreshold[1]);
      }

      scale.setDomain([min, max]);
      chart.getChildren('timeNavigator') && chart.getChildren('timeNavigator').forEach(function (navi) {
        if (!navi.getState('removed')) {
          var axis = navi.getChildren('timeAxis') && navi.getChildren('timeAxis')[0];

          if (!axis.getState('removed')) {
            axis.setTickVisibilityLimit(visibilityLimit);
            axis.placeAxis();
            axis.asyncDraw();
          }
        }
      });
    }
  };

  _proto.setFocusLimit = function setFocusLimit(limit, validateDomain) {
    if (limit === void 0) {
      limit = [];
    }

    if (validateDomain === void 0) {
      validateDomain = true;
    }

    var chart = this,
        config = chart.config,
        dataLimit = validateDomain ? this.domainValidator(limit, this.getContextLimit(), config.focusLimit) : limit,
        focusAxis = config.focusAxesX[0],
        focusBin = this.getFromEnv('focusBins')[0],
        focusScale = this.getFromEnv('focusScalesX')[0],
        focusLimit = chart.getFocusLimit(),
        currentBin = focusBin.getRangeThreshold();
    config.focusLimit = dataLimit; // fire public event

    chart.fireChartInstanceEvent('selectionChange', {
      start: +dataLimit[0],
      end: +dataLimit[1],
      binUnit: currentBin[0].name(),
      binMuliplier: currentBin[1]
    }); // return if data limit is equal to focus limit

    if ((0, _equals.default)(dataLimit, focusLimit)) {
      return false;
    }

    focusBin.setBinDomain(dataLimit);
    var threshold = focusBin.getRangeThreshold();
    focusScale.setRangeThreshold(threshold);
    chart.fireEvent('focusLimitChanged');

    if (focusAxis.filterInfo && focusAxis.filterInfo.query) {
      focusAxis.filterInfo.query._updateArgs(+threshold[0].offset(+dataLimit[0], -2 * threshold[1]), +threshold[0].offset(+dataLimit[1], 2 * threshold[1])); // flushing the result is required to update the data


      focusAxis.filterInfo.table.flushResults();
      chart.updateVerticalAxesWidth();
    } // for initial drawing and chart update
    // components should be drawn as chart flow
    // this should be called after updating the query so that data will be
    // created


    if (focusLimit !== _lib.UNDEF) {
      chart._updateAffectedVisuals({
        legendInteracted: null
      });
    }

    return true;
  }
  /**
   * Sets the width of vertical axis to the maximum width taken by a axis of same
   * alignment.
   * If there are 2 axes of left alignment and widths 120px and 140px respectively,
   * then this api sets the width of both the axes to 140px.
   * @memberof TimeSeries
   */
  ;

  _proto.updateVerticalAxesWidth = function updateVerticalAxesWidth() {
    var chart = this,
        canvasAxisMap = chart.config.canvasAxisMap,
        canvasAxisMapAr = Object.keys(canvasAxisMap),
        canvas,
        maxVAxesWidth = {
      left: 0,
      right: 0
    },
        axisDim,
        axes; // find out the max width taken in both left and right aligned axes

    canvasAxisMapAr.forEach(function (canvasId) {
      canvas = canvasAxisMap[canvasId];
      canvas.y.forEach(function (yId) {
        axes = chart.getChildren(yId);
        axes.forEach(function (axis) {
          axisDim = axis.getDimension();

          if (typeof axisDim.left === 'number') {
            maxVAxesWidth.left = Math.max(maxVAxesWidth.left, axisDim.left);
          } else if (typeof axisDim.right === 'number') {
            maxVAxesWidth.right = Math.max(maxVAxesWidth.right, axisDim.right);
          }
        });
      });
    }); // update the width of all left aligned axes with the max width of left-aligned axis.
    // similar for right aligned axes.

    canvasAxisMapAr.forEach(function (canvasId) {
      canvas = canvasAxisMap[canvasId];
      canvas.y.forEach(function (yId) {
        axes = chart.getChildren(yId);
        axes.forEach(function (axis) {
          axis.updateMaxLabelSpace(maxVAxesWidth[axis.getAlignment()]);
        });
      });
    });
  };

  _proto.getFocusLimit = function getFocusLimit() {
    var focusLimit = this.config.focusLimit;
    return focusLimit && focusLimit.slice();
  };

  _proto.setContextLimit = function setContextLimit(limit) {
    if (limit === void 0) {
      limit = [];
    }

    var config = this.config,
        contextScalesX = this.getFromEnv('contextScalesX')[0];
    var contextBins = this.getFromEnv('contextBins');

    if ((0, _equals.default)(limit, this.getContextLimit())) {
      return;
    }

    config.contextLimit = limit.slice();
    contextBins[0].setBinDomain(limit);
    contextScalesX.setRangeThreshold(contextBins[0].getRangeThreshold()); // if time navigator is not enabled then context scale should be set here for
    // zooming and panning, else its get set in Timeseries#setXScaleLimit API

    !config.navigatorEnabled && contextScalesX.setDomain(config.contextLimit);
    this.fireEvent('contextLimitChanged');
  };

  _proto.getContextLimit = function getContextLimit() {
    return (this.config.contextLimit || []).slice();
  };

  return TimeSeries;
}(_commonchartapi.default);

var _default = TimeSeries;
exports["default"] = _default;

/***/ }),

/***/ 872:
/***/ ((__unused_webpack_module, exports) => {



exports.__esModule = true;
exports["default"] = void 0;

var ascending = function ascending(a, b) {
  var result = NaN;

  if (a < b) {
    result = -1;
  } else if (a > b) {
    result = 1;
  } else if (a >= b) {
    result = 0;
  }

  return result;
},
    ascendingComparator = function ascendingComparator(f) {
  return function (d, x) {
    return ascending(f(d), x);
  };
},
    bisector = function bisector(compareFn) {
  var compare = compareFn;

  if (compare.length === 1) {
    compare = ascendingComparator(compare);
  }

  return {
    left: function left(arr, x, lo, hi) {
      if (arr === void 0) {
        arr = [];
      }

      if (lo === void 0) {
        lo = 0;
      }

      if (hi === void 0) {
        hi = arr.length;
      }

      var low = lo,
          high = hi;

      while (low < high) {
        var mid = Math.abs(Math.floor((low + high) / 2));

        if (compare(arr[mid], x) < 0) {
          low = mid + 1;
        } else {
          high = mid;
        }
      }

      return low;
    },
    right: function right(arr, x, lo, hi) {
      if (arr === void 0) {
        arr = [];
      }

      if (lo === void 0) {
        lo = 0;
      }

      if (hi === void 0) {
        hi = arr.length;
      }

      var low = lo,
          high = hi;

      while (low < high) {
        var mid = Math.abs(Math.floor((low + high) / 2));

        if (compare(arr[mid], x) > 0) {
          high = mid;
        } else {
          low = mid + 1;
        }
      }

      return low;
    }
  };
};

var _default = bisector;
exports["default"] = _default;

/***/ }),

/***/ 861:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports.DEFAULT_THRESHOLD_PIXELS = exports._calculateIndexOfIntervals = exports["default"] = void 0;

var _equals = _interopRequireDefault(__webpack_require__(577));

var DEFAULT_THRESHOLD_PIXELS = 4,

/**
 * For a number, this method checks if it falls within the max and min.
 * For example, if number is greater than max, number is converted to max.
 *
 * @param {any} number number to be tested
 * @param {any} min lower limit
 * @param {any} max upper limit
 */
clamp = function clamp(number, min, max) {
  return Math.min(Math.max(number, min), max);
},
    date = function date(d) {
  return new Date(d);
},
    _getStandardBin = function _getStandardBin(arr, value) {
  var firstIndex = 0,
      lastIndex = arr.length - 1,
      lastLessThan = lastIndex,
      middleIndex = Math.floor((lastIndex + firstIndex) / 2),
      ms = value instanceof Array ? value[2] : value.unit.ms * value.multiplier;

  while (firstIndex < lastIndex) {
    if (ms < arr[middleIndex][2]) {
      lastLessThan = lastIndex = middleIndex - 1;
    } else if (ms > arr[middleIndex][2]) {
      firstIndex = middleIndex + 1;
    } else {
      lastLessThan = middleIndex;
      break;
    }

    middleIndex = Math.floor((lastIndex + firstIndex) / 2);
  }

  if (value instanceof Array) {
    return arr[lastLessThan];
  }

  if (arr[lastLessThan][2] === ms) {
    return arr[lastLessThan];
  }

  return [arr[lastLessThan - 1][0], value.multiplier, ms];
},

/**
 * Stores index of first appearance of major time intervals from thresholdIntervals
 */
_calculateIndexOfIntervals = function _calculateIndexOfIntervals(thresholdIntervals) {
  var intervalIndexMap = {},
      i,
      len = thresholdIntervals.length;

  for (i = len - 1; i >= 0; i--) {
    intervalIndexMap[thresholdIntervals[i][0].name()] = i;
  }

  return intervalIndexMap;
};

exports._calculateIndexOfIntervals = _calculateIndexOfIntervals;
exports.DEFAULT_THRESHOLD_PIXELS = DEFAULT_THRESHOLD_PIXELS;

var BinDecider = /*#__PURE__*/function () {
  function BinDecider(standardBins) {
    /**
     * Structure of interval: A array of the following format
     * [Interval, multiplier, length of that interval in milliseconds]
    */
    this.setStandardBins(standardBins);
    this.binRange = [0, 1];
    this.binDomain = [0, 1];
    this.thresholdPixels = DEFAULT_THRESHOLD_PIXELS; // calculate the first index of major time intervals(day, month etc)

    this.intervalIndexMap = _calculateIndexOfIntervals(this.getStandardBins());
    this.minBin = [];
  }

  var _proto = BinDecider.prototype;

  _proto.setStandardBins = function setStandardBins(standardBins) {
    this.standardBins = standardBins;
  };

  _proto.getStandardBins = function getStandardBins() {
    return this.standardBins;
  };

  _proto.setScale = function setScale(scales) {
    this.scale = scales;
  };

  _proto.getScale = function getScale() {
    return this.scale;
  };

  _proto._computeRangeThreshold = function _computeRangeThreshold(rangeThreshold) {
    var range = this.getBinRange(),
        r0 = range[0],
        r1 = range[1],
        tw = clamp(rangeThreshold, 1, Math.abs(r0 - r1)),
        d0 = +this.getScale().getDomainValue(0),
        d1 = +this.getScale().getDomainValue(tw),
        dWidth = Math.abs(d1 - d0),
        binMin = this.getBinMin(),
        binMax = this.getBinMax(),
        index = this.standardBins.findIndex(function (v) {
      return v[2] >= dWidth;
    }),
        idx = index === -1 ? this.standardBins.length - 1 : index;

    if (this.standardBins[idx][2] < binMin[2]) {
      this._threshold = binMin;
    } else if (binMax && this.standardBins[idx][2] > binMax[2] && binMax[2] >= binMin[2]) {
      this._threshold = binMax;
    } else {
      this._threshold = this.standardBins[idx];
    }
  };

  _proto.setBinRange = function setBinRange(range) {
    this.binRange = range.slice();
    this.getScale().setRange(this.binRange);
    this.getScale().setDomain(this.binDomain);

    this._computeRangeThreshold(this.thresholdPixels);

    return this;
  };

  _proto.getBinRange = function getBinRange() {
    return this.binRange;
  };

  _proto.setBinDomain = function setBinDomain(domain) {
    this.binDomain = domain.slice();
    this.getScale().setRange(this.binRange);
    this.getScale().setDomain(this.binDomain);

    this._computeRangeThreshold(this.thresholdPixels);

    return this;
  };

  _proto.getBinDomain = function getBinDomain() {
    return this.binDomain.slice().map(date);
  };

  _proto.setBinMin = function setBinMin(minBin) {
    var standardMinBin = _getStandardBin(this.standardBins, minBin);

    if (!(0, _equals.default)(standardMinBin, minBin)) {
      this.minBin = standardMinBin;

      this._computeRangeThreshold(this.thresholdPixels);
    }

    return this;
  };

  _proto.getBinMin = function getBinMin() {
    return this.minBin;
  };

  _proto.setBinMax = function setBinMax(maxBin) {
    this.maxBin = _getStandardBin(this.standardBins, maxBin);
  };

  _proto.getBinMax = function getBinMax() {
    return this.maxBin;
  };

  _proto.setRangeThreshold = function setRangeThreshold(rangeThreshold) {
    if (rangeThreshold === void 0) {
      rangeThreshold = DEFAULT_THRESHOLD_PIXELS;
    }

    if (rangeThreshold !== this.thresholdPixels) {
      this._computeRangeThreshold(this.thresholdPixels = rangeThreshold);
    }

    return this;
  };

  _proto.getRangeThreshold = function getRangeThreshold() {
    return this._threshold;
  };

  return BinDecider;
}();

var _default = BinDecider;
exports["default"] = _default;

/***/ }),

/***/ 877:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



exports.__esModule = true;
exports.getDefaultBins = getDefaultBins;
exports.getCustomBins = getCustomBins;

var _scaleUtils = __webpack_require__(873);

var durationMilliSecond = 1,
    durationSecond = _scaleUtils.MILLISECONDS_IN_SECOND * durationMilliSecond,
    durationMinute = durationSecond * _scaleUtils.SECONDS_IN_MINUTE,
    durationHour = durationMinute * _scaleUtils.MINUTES_IN_HOUR,
    durationDay = durationHour * _scaleUtils.HOURS_IN_DAY,
    durationWeek = durationDay * _scaleUtils.DAYS_IN_WEEK,
    durationMonth = durationDay * _scaleUtils.DAYS_IN_MONTH,
    durationYear = durationDay * _scaleUtils.DAYS_IN_YEAR;
/**
 * @description This function santizes given bin to valid integers, common multiplies of max unit given and sorts then in ascending order
 * @param {Integer} maxUnit holds thje max value which a bin unit consists of. eg. for sec it will be 60 as one minute consist of 60 secs
 * @param {*} slotArr Array of given bin units eg. second: [1, 2, 20]
 */

function santizeBin(maxUnit, slotArr) {
  var sanitizedArr = [];

  for (var index = 0; index < slotArr.length; index++) {
    var bin = slotArr[index]; // eslint-disable-next-line eqeqeq

    bin && parseInt(bin, 10) == bin && bin > 0 && bin <= maxUnit / 2 && maxUnit % bin === 0 && sanitizedArr.push(Number(bin));
  }

  return sanitizedArr.sort(function sorAsc(a, b) {
    return a - b;
  });
}

; // sanitization function for year as it does not have any maxunit

function santizeYear(slotArr) {
  var sanitizedArr = [];

  for (var index = 0; index < slotArr.length; index++) {
    var bin = slotArr[index]; // eslint-disable-next-line eqeqeq

    bin && parseInt(bin, 10) == bin && bin > 0 && sanitizedArr.push(Number(bin));
  }

  return sanitizedArr.sort(function sorAsc(a, b) {
    return a - b;
  });
}

; // common sanitization function for all bins

function sanitizeBins(customBin) {
  // returning blank array when custombin not provided
  if (!customBin) {
    return [];
  }

  var sanitizdeCustomBin = customBin,
      binMaxUnitObj = {
    millisecond: _scaleUtils.MILLISECONDS_IN_SECOND,
    second: _scaleUtils.SECONDS_IN_MINUTE,
    minute: _scaleUtils.MINUTES_IN_HOUR,
    hour: _scaleUtils.HOURS_IN_DAY,
    day: _scaleUtils.DAYS_IN_MONTH,
    month: _scaleUtils.MONTHS_IN_YEAR
  };

  for (var key in binMaxUnitObj) {
    if (binMaxUnitObj.hasOwnProperty(key)) {
      if (Array.isArray(customBin[key])) {
        sanitizdeCustomBin[key] = santizeBin(binMaxUnitObj[key], customBin[key]);
      } else {
        sanitizdeCustomBin[key] = false;
      }
    }
  }

  if (Array.isArray(customBin.year)) {
    sanitizdeCustomBin.year = santizeYear(customBin.year);
  } else {
    sanitizdeCustomBin.year = false;
  }

  return sanitizdeCustomBin;
}

;
/**
 * @description This function returns all standardbins in a form of object, This function is solely developed
 * considering to keep single source of standard bins. Chaning here will affect bins used everywhere.
 * @author Dip Bhattacharjee
 * @since 3.14.0
 * @param {Object} year holds year interval info
 * @param {Object} month holds month interval info
 * @param {Object} week holds week interval info
 * @param {Object} day holds day interval info
 * @param {Object} hour holds hour interval info
 * @param {Object} minute holds minute interval info
 * @param {Object} second holds second interval info
 * @param {Object} millisecond holds millisecond interval info
 * @param {Boolean} isWeekBin flag to add week bin or not
 * @returns {object} returns object containing all standard bin unit name as key and all possible combination in
 * an array
 */

function getAllStandardBins(year, month, week, day, hour, minute, second, millisecond, isWeekBin) {
  // eslint-disable-next-line good-practices/no-single-usage-variable
  var standardMiliseconds = [[millisecond, 1, durationMilliSecond], [millisecond, 2, 2 * durationMilliSecond], [millisecond, 4, 4 * durationMilliSecond], [millisecond, 5, 5 * durationMilliSecond], [millisecond, 10, 10 * durationMilliSecond], [millisecond, 20, 20 * durationMilliSecond], [millisecond, 25, 25 * durationMilliSecond], [millisecond, 40, 40 * durationMilliSecond], [millisecond, 50, 50 * durationMilliSecond], [millisecond, 100, 100 * durationMilliSecond], [millisecond, 200, 200 * durationMilliSecond], [millisecond, 250, 250 * durationMilliSecond], [millisecond, 500, 500 * durationMilliSecond]],
      // eslint-disable-next-line good-practices/no-single-usage-variable
  standardSeconds = [[second, 1, durationSecond, true], [second, 2, 2 * durationSecond], [second, 3, 3 * durationSecond], [second, 4, 4 * durationSecond], [second, 5, 5 * durationSecond], [second, 6, 6 * durationSecond], [second, 10, 10 * durationSecond], [second, 12, 12 * durationSecond], [second, 15, 15 * durationSecond], [second, 20, 20 * durationSecond], [second, 30, 30 * durationSecond]],
      // eslint-disable-next-line good-practices/no-single-usage-variable
  standardMinutes = [[minute, 1, durationMinute, true], [minute, 2, 2 * durationMinute], [minute, 3, 3 * durationMinute], [minute, 4, 4 * durationMinute], [minute, 5, 5 * durationMinute], [minute, 6, 6 * durationMinute], [minute, 10, 10 * durationMinute], [minute, 12, 12 * durationMinute], [minute, 15, 15 * durationMinute], [minute, 20, 20 * durationMinute], [minute, 30, 30 * durationMinute]],
      // eslint-disable-next-line good-practices/no-single-usage-variable
  standardHours = [[hour, 1, durationHour, true], [hour, 2, 2 * durationHour], [hour, 3, 3 * durationHour], [hour, 4, 4 * durationHour], [hour, 6, 6 * durationHour], [hour, 8, 8 * durationHour], [hour, 12, 12 * durationHour]],
      // eslint-disable-next-line good-practices/no-single-usage-variable
  standardDays = [[day, 1, durationDay, true], [day, 2, 2 * durationDay], [day, 3, 3 * durationDay], [day, 5, 5 * durationDay], [day, 6, 6 * durationDay], [day, 10, 10 * durationDay], [day, 15, 15 * durationDay]],
      standardWeeks = [[week, 1, durationWeek, true], [week, 2, 2 * durationWeek], [week, 3, 3 * durationWeek], [week, 4, 4 * durationWeek], [week, 5, 5 * durationWeek], [week, 6, 6 * durationWeek], [week, 8, 8 * durationWeek], [week, 10, 10 * durationWeek], [week, 12, 12 * durationWeek], [week, 15, 15 * durationWeek]],
      // eslint-disable-next-line good-practices/no-single-usage-variable
  standardMonths = [[month, 1, durationMonth], [month, 2, 2 * durationMonth], [month, 3, 3 * durationMonth], [month, 4, 4 * durationMonth], [month, 6, 6 * durationMonth]],
      // eslint-disable-next-line good-practices/no-single-usage-variable
  standardYears = [[year, 1, durationYear], [year, 2, 2 * durationYear], [year, 3, 3 * durationYear], [year, 5, 5 * durationYear]],
      standardBins = [{
    binUnitName: millisecond,
    duration: durationMilliSecond,
    standardBinVal: standardMiliseconds
  }, {
    binUnitName: second,
    duration: durationSecond,
    standardBinVal: standardSeconds
  }, {
    binUnitName: minute,
    duration: durationMinute,
    standardBinVal: standardMinutes
  }, {
    binUnitName: hour,
    duration: durationHour,
    standardBinVal: standardHours
  }, {
    binUnitName: day,
    duration: durationDay,
    standardBinVal: standardDays
  }, {
    binUnitName: month,
    duration: durationMonth,
    standardBinVal: standardMonths
  }, {
    binUnitName: year,
    duration: durationYear,
    standardBinVal: standardYears
  }];

  if (isWeekBin) {
    standardBins.push({
      binUnitName: week,
      duration: durationWeek,
      standardBinVal: standardWeeks
    });
  }

  return standardBins;
}
/**
 * @description This function generates custom bin in desired format
 * @author Dip Bhattacharjee
 * @since 3.14.0
 * @param {*} binUnit TimeInterval instance of an bin
 * @param {*} binArr Valid Array of custom bins
 * @param {*} duration duration of a bin unit
 */


function generateBins(binUnit, binArr, duration) {
  var updatedBins = [];

  for (var index = 0; index < binArr.length; index++) {
    var bin = binArr[index];
    updatedBins.push([binUnit, bin, bin * duration]);
  }

  return updatedBins;
}
/**
 * @description This function returns standardbins in an array of array format sorted in ascending order
 * from lower bin values to higher. If user has provided any custom bin configration, this function modfies
 * the standard bin such a way that bins get restricts to the custom format provided.
 * Desired format to provide custom bin is written below
 * xAxis:{
 *  binning:{
 *   "month": [1,2];
 *   "day": [1,2,3,5,6,10,15];
 *   "hour": [2,4,8]; // [1] is removed as minBin is 2hr
 *   "minute": []; // Empty array to specify minBin
 *   "millisecond": [] // Empty array to specify minBin
 *  }
 * }
 * custom values should be common multipliers of the bin unit.By Providing blank array user can specify that
 * no binning is required for the particular bin unit.
 * eg. If user has provided valid bins for month, dat and hour blank array(option to override) for the other
 *  bin options like millisecond, minute then the standard does not contain minute, millisecond. Though user
 * has not provided any configuration for year. Hence we will consider the default value for year.
 * This function aslo sanitizes the given input to valid integers and common multiplier of bin units, also
 * sorts them in ascending order.
 * @author Dip Bhattacharjee
 * @since 3.14.0
 *
 * @param {Object} year holds year interval info
 * @param {Object} month holds month interval info
 * @param {Object} week holds week interval info
 * @param {Object} day holds day interval info
 * @param {Object} hour holds hour interval info
 * @param {Object} minute holds minute interval info
 * @param {Object} second holds second interval info
 * @param {Object} millisecond holds millisecond interval info
 * @param {Object} customBin holds custombin config if user has given custom bin
 * @returns {Array} returns the standard bins in array of array format
 */


function getCustomBins(year, month, week, day, hour, minute, second, millisecond, customBin) {
  var sanitizdeCustomBin = customBin,
      isWeekBin = Object.keys(sanitizdeCustomBin).indexOf('week') > -1,
      binNameDurationArr = getAllStandardBins(year, month, week, day, hour, minute, second, millisecond, isWeekBin),
      updatedBins = []; // returning if custombin is not provided as it does not need further execution

  sanitizdeCustomBin = sanitizeBins(Object.assign({}, customBin));

  for (var index = 0; index < binNameDurationArr.length; index++) {
    var binUnit = binNameDurationArr[index];

    if (sanitizdeCustomBin[binUnit.binUnitName.name()]) {
      // case: when configuration provided and not a blank array
      if (sanitizdeCustomBin[binUnit.binUnitName.name()].length > 0) {
        updatedBins = updatedBins.concat(generateBins(binUnit.binUnitName, sanitizdeCustomBin[binUnit.binUnitName.name()], binUnit.duration));
      }
    } else {
      // default case when configuration not provided
      updatedBins = updatedBins.concat(binUnit.standardBinVal);
    }
  } // case when all binunit is provided blank array, falling back to default binning


  if (updatedBins.length === 0) {
    updatedBins = getDefaultBins(year, month, week, day, hour, minute, second, millisecond, isWeekBin);
  } // Sorting the bins in ascending order according to their duration


  updatedBins.sort(function (b1, b2) {
    return b1[2] - b2[2];
  }); // returning defaultbinning and custombinning

  return updatedBins;
}

;
/**
 * @description This function returns defaultbins in an array of array format sorted in ascending order
 * from lower bin values to higher. This defaultbins are specified to provide maximum possible smooth transition
 * while zooming in or out in timeseries chart visual.
 * @since 3.14.0
 *
 * @param {Object} year holds year interval info
 * @param {Object} month holds month interval info
 * @param {Object} week holds week interval info
 * @param {Object} day holds day interval info
 * @param {Object} hour holds hour interval info
 * @param {Object} minute holds minute interval info
 * @param {Object} second holds second interval info
 * @param {Object} millisecond holds millisecond interval info
 * @param {Boolean} isWeekBin flag to add week bin or not
 * @returns {Array} returns the default bins in array of array format
 */

function getDefaultBins(year, month, week, day, hour, minute, second, millisecond, isWeekBin) {
  var binNameDurationArr = getAllStandardBins(year, month, week, day, hour, minute, second, millisecond, isWeekBin),
      defaultStandardBin = [];

  for (var index = 0; index < binNameDurationArr.length; index++) {
    defaultStandardBin = defaultStandardBin.concat(binNameDurationArr[index].standardBinVal);
  } // Sorting the bins in ascending order according to their duration


  defaultStandardBin.sort(function (b1, b2) {
    return b1[2] - b2[2];
  });
  return defaultStandardBin;
}

;

/***/ }),

/***/ 908:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _chain = _interopRequireDefault(__webpack_require__(806));

var _mergeDeepRight = _interopRequireDefault(__webpack_require__(909));

var _extent6 = _interopRequireDefault(__webpack_require__(538));

var _safeMax = _interopRequireDefault(__webpack_require__(540));

var _safeMin = _interopRequireDefault(__webpack_require__(539));

var _constant = _interopRequireDefault(__webpack_require__(544));

var _pair = _interopRequireDefault(__webpack_require__(867));

var _areaGenerator = _interopRequireDefault(__webpack_require__(914));

var _lineGenerator = _interopRequireDefault(__webpack_require__(917));

var BLANK = '',
    // Determines if the first element in the input array is the string 'undef'
isDefinedChunk = function isDefinedChunk(_ref) {
  var chunkName = _ref[0];
  return chunkName !== 'undef';
},
    // Extracts the clipRect objects from a deeply nested array of objects
extractClipRects = (0, _chain.default)(function (_ref2) {
  var name = _ref2[0],
      clipRects = _ref2[1].clipRects;
  return clipRects;
}),
    byX = function byX(a, b) {
  return a.x - b.x;
},
    // Computes the rectangle between two input rectangles which do not have any
// horizontal overlap
clipRectBetween = function clipRectBetween(_ref3) {
  var l = _ref3[0],
      r = _ref3[1];
  return {
    x: l.x + l.width,
    y: (0, _safeMin.default)([l.y, r.y, l.y + l.height, r.y + r.height]),
    width: r.x - (l.x + l.width),
    height: (0, _safeMax.default)([l.y, r.y, l.y + l.height, r.y + r.height]) - (0, _safeMin.default)([l.y, r.y, l.y + l.height, r.y + r.height])
  };
},
    validRects = function validRects(rect) {
  return !(rect.width < 1 || rect.height < 1);
},
    // Removes zero width clip rect objects from a chunk
removeInvalidClipRects = function removeInvalidClipRects(_ref4) {
  var k = _ref4[0],
      v = _ref4[1];
  return [k, Object.assign(v, {
    clipRects: v.clipRects.filter(validRects)
  })];
},
    DEFAULT_CHUNK_DECIDER = (0, _constant.default)('def'),
    // Resolves which chunk an input data point should belong to
CHUNK_RESOLVER = function CHUNK_RESOLVER(chunkNameLeft, chunkNameRight, chunkNames) {
  return chunkNames.indexOf(chunkNameLeft) > chunkNames.indexOf(chunkNameRight) ? chunkNameLeft : chunkNameRight;
},
    DEFAULT_CHUNKS = {
  def: {},
  undef: {}
};
/**
 * A Chunker is able to accept an array of data points and chunk them into
 * separate buckets based on whether the data point is defined. It can also
 * chunk data points into arbitrary named buckets based on some user defined
 * conditions.
 */


var Chunker = /*#__PURE__*/function () {
  /**
   * @param {Function} Generator The generator which will be used to generate
   * path strings for the input data.
   */
  function Chunker(Generator) {
    if (Generator === void 0) {
      Generator = _areaGenerator.default;
    }

    this.generator = new Generator();
    this.defined = (0, _constant.default)(true);
    this.chunkDecider = DEFAULT_CHUNK_DECIDER;
    this.chunks = DEFAULT_CHUNKS;
    this.connectUndefineds = false;
  }
  /**
   * Generates named chunks from the input data points based on whether they are
   * defined and based on defined predicates.
   *
   * @param {any[]} data An array of data points which need to be processed.
   *
   * @returns {Object} Always contains atleast two named chunks, named 'def' and
   * 'undef'. Additional named chunks may be present based on user defined
   * conditions. Each named chunk contains two properties - a string called
   * 'path' and an array of objects containing x, y, width and height called
   * 'clipRects'.
   */


  var _proto = Chunker.prototype;

  _proto.generate = function generate(data) {
    var _this = this;

    var chunks = this._getChunks(),
        definedChunks = Object.entries(chunks).filter(isDefinedChunk),
        defined = this.getDefined(),
        filteredData = data.filter(defined),
        connectUndefineds = this.getConnectUndefineds(),
        definedSegments = this._computeDefinedSegments(connectUndefineds ? data : filteredData),
        x = this.getXAccessor(),
        y = this.getYAccessor(),
        yBase = this.getYBaseAccessor(),
        // Converts a series of data segments into rectangle objects based on
    // their x and y extents
    clipGenerator = function clipGenerator(segment, _ref5) {
      var _ref5$clipAdjustment = _ref5.clipAdjustment,
          clipAdjustment = _ref5$clipAdjustment === void 0 ? 0 : _ref5$clipAdjustment;

      var _extent = (0, _extent6.default)(segment, y),
          yMin = _extent[0],
          yMax = _extent[1],
          _extent2 = (0, _extent6.default)(segment, x),
          xMin = _extent2[0],
          xMax = _extent2[1],
          _extent3 = (0, _extent6.default)(segment, yBase),
          yBaseMin = _extent3[0],
          yBaseMax = _extent3[1],
          _extent4 = (0, _extent6.default)([xMin, xMax]),
          clipX1 = _extent4[0],
          clipX2 = _extent4[1],
          _extent5 = (0, _extent6.default)([yMin, yMax, yBaseMin, yBaseMax]),
          clipY1 = _extent5[0],
          clipY2 = _extent5[1],
          clipY = clipY1 - clipAdjustment;

      return {
        x: clipX1,
        y: clipY,
        // TODO: Probably unnecessary Math.abs. Verify and remove.
        width: Math.abs(clipX2 - clipX1),
        height: Math.abs(clipY2 + clipAdjustment - clipY)
      };
    };

    var path = BLANK,
        definedChunkSegments = [],
        undefinedChunkSegements = [];

    if (connectUndefineds) {
      // If undefined points need to be connected, generate the path after
      // filtering out the null data.
      path = this.generator.generate(filteredData);
    } else {
      // Otherwise, generate the path by setting the defined function and
      // generating the path from the unfiltered data.
      path = this.generator.setDefined(defined).generate(data);
    } // create paths and clip rects for all the defined segments


    definedChunkSegments = definedChunks.map(function (_ref6) {
      var chunkName = _ref6[0],
          chunkDefinition = _ref6[1];
      return [chunkName, {
        path: path,
        clipRects: _this._computeSegmentChunks(chunkName, definedSegments).map(function (segment) {
          return clipGenerator(segment, chunkDefinition);
        })
      }];
    });
    undefinedChunkSegements = connectUndefineds ? (0, _pair.default)(extractClipRects(definedChunkSegments).sort(byX)).map(clipRectBetween).filter(validRects) : []; // Create paths and clip rects for all the undefined segments and add them
    // to the other segment definitions

    return Object.fromEntries(definedChunkSegments.map(removeInvalidClipRects).concat([['undef', {
      path: connectUndefineds && undefinedChunkSegements.length > 0 ? path : '',
      clipRects: undefinedChunkSegements
    }]]));
  }
  /**
   * Sets the input accessor function as the x accessor. The x accessor is used
   * to determine how to compute x values when generating chunks.
   *
   * @param {function} accessor Defines how to compute x values when generating
   * chunks.
   *
   * @returns {object} An instance of the current Chunker
   */
  ;

  _proto.setXAccessor = function setXAccessor(accessor) {
    this.generator.setXAccessor(accessor);
    return this;
  }
  /**
   * @returns {function} The x accesssor of the chunker
   */
  ;

  _proto.getXAccessor = function getXAccessor() {
    return this.generator.getXAccessor();
  }
  /**
   * Sets the input accessor function as the y accessor. The y accessor is used
   * to determine how to compute y values when generating chunks.
   *
   * @param {function} accessor Defines how to compute y values when generating
   * chunks.
   *
   * @returns {object} An instance of the current Chunker
   */
  ;

  _proto.setYAccessor = function setYAccessor(accessor) {
    this.generator.setYAccessor(accessor);
    return this;
  }
  /**
   * @returns {function} The y accesssor of the chunker
   */
  ;

  _proto.getYAccessor = function getYAccessor() {
    return this.generator.getYAccessor();
  }
  /**
   * If the chunker is created using an AreaGenerator, sets the input accessor
   * function as the y accessor for the top line of an area chunk. The y
   * accessor is used to determine how to compute y values when generating
   * chunks.
   * If the chunker is created using a LineGenerator, this method sets the y
   * accessor of the chunker instead since a line does not have any notion of a
   * y top.
   *
   * @param {function} accessor Defines how to compute y values when generating
   * chunks.
   *
   * @returns {object} An instance of the current Chunker
   */
  ;

  _proto.setYTopAccessor = function setYTopAccessor(accessor) {
    this.generator.setYTopAccessor ? this.generator.setYTopAccessor(accessor) : this.generator.setYAccessor(accessor);
    return this;
  }
  /**
   * @returns {function} The y top accesssor of the chunker
   */
  ;

  _proto.getYTopAccessor = function getYTopAccessor() {
    return this.generator.getYTopAccessor ? this.generator.getYTopAccessor() : this.generator.getYAccessor();
  }
  /**
   * If the chunker is created using an AreaGenerator, sets the input accessor
   * function as the y accessor for the bottom line of an area chunk. The y
   * accessor is used to determine how to compute y values when generating
   * chunks.
   * If the chunker is created using a LineGenerator, this method sets the y
   * accessor of the chunker instead since a line does not have any notion of a
   * y top.
   *
   * @param {function} accessor Defines how to compute y values when generating
   * chunks.
   *
   * @returns {object} An instance of the current Chunker
   */
  ;

  _proto.setYBaseAccessor = function setYBaseAccessor(accessor) {
    this.generator.setYBaseAccessor ? this.generator.setYBaseAccessor(accessor) : this.generator.setYAccessor(accessor);
    return this;
  }
  /**
   * @returns {function} The y base accesssor of the chunker
   */
  ;

  _proto.getYBaseAccessor = function getYBaseAccessor() {
    return this.generator.getYBaseAccessor ? this.generator.getYBaseAccessor() : this.generator.getYAccessor();
  }
  /**
   * Sets the defined function for the chunked which determines whether the
   * chunker should consider a point to be undefined or not.
   *
   * @param {function} defined Dictates whether a data point should be
   * considered as a defined point.
   *
   * @returns An instance of the current Chunker
   */
  ;

  _proto.setDefined = function setDefined(defined) {
    if (defined === void 0) {
      defined = (0, _constant.default)(true);
    }

    this.defined = typeof defined === 'function' ? defined : (0, _constant.default)(!!defined);
    return this;
  }
  /**
   * @returns The defined function of the chunker
   */
  ;

  _proto.getDefined = function getDefined() {
    return this.defined;
  }
  /**
   * Sets the Curve factory which will be used to generate a path string.
   *
   * @param {function} Curve The Curve factory which will be used to generate a
   * path string
   *
   * @returns An instance of the current Chunker
   */
  ;

  _proto.setCurve = function setCurve(Curve) {
    this.generator.setCurve(Curve);
    return this;
  }
  /**
   * @returns The Curve factory of the chunker
   */
  ;

  _proto.getCurve = function getCurve() {
    return this.generator.getCurve();
  }
  /**
   * @returns A new Line Chunker with all the properties of the current chunker
   * which has its X accessor set to the chunker's X top accessor and its Y
   * accessor set to the chunker's Y top accessor.
   */
  ;

  _proto.getLineChunkerYTop = function getLineChunkerYTop() {
    return this._areaLineChunker().setXAccessor(this.getXAccessor()).setYAccessor(this.getYTopAccessor());
  }
  /**
   * @returns A new Line Chunker with all the properties of the current chunker
   * which has its X accessor set to the chunker's X top accessor and its Y
   * accessor set to the chunker's Y top accessor.
   */
  ;

  _proto.getLineChunkerYBase = function getLineChunkerYBase() {
    return this._areaLineChunker().setXAccessor(this.getXAccessor()).setYAccessor(this.getYBaseAccessor());
  }
  /**
   * Sets the function which decides the chunk name for a data point
   *
   * @param {function} decider When given a data point, the decider decides the
   * name of the chunk to which the data belongs. The returned name MUST
   * correspond to a name defined in the chunk definitions. If a name is not
   * found, it will be assumed to belong to the 'def' chunk.
   *
   * @returns An instance of the current Chunker
   */
  ;

  _proto.setChunkDecider = function setChunkDecider(decider) {
    if (decider === void 0) {
      decider = DEFAULT_CHUNK_DECIDER;
    }

    this.chunkDecider = decider;
    return this;
  }
  /**
   * @returns The chunk decider of the chunker.
   */
  ;

  _proto.getChunkDecider = function getChunkDecider() {
    return this.chunkDecider;
  }
  /**
   * Sets the chunk definitions of the Chunker. The chunk definitions are used
   * to validate the decisions of the chunk decides and to determine what chunks
   * to create.
   *
   * @param {object} chunks An object containing the names of the chunks as keys
   * and their configuration as the value.
   *
   * @returns An instance of the Chunker
   */
  ;

  _proto.setChunks = function setChunks(chunks) {
    if (chunks === void 0) {
      chunks = DEFAULT_CHUNKS;
    }

    this._userChunks = Object.assign({}, chunks);
    this.chunks = (0, _mergeDeepRight.default)(chunks, DEFAULT_CHUNKS);
    return this;
  }
  /**
   * @returns {object} The user defined chunk definitions of the Chunker.
   */
  ;

  _proto.getChunks = function getChunks() {
    return this._userChunks || this.chunks;
  }
  /**
   * @returns {object} The user defiend chunk definitions merged with the
   * default chunks of the Chunker.
   */
  ;

  _proto._getChunks = function _getChunks() {
    return this.chunks;
  }
  /**
   * Sets whether or not to connect two chunks when there is an undefined chunk
   * between them.
   *
   * @param {boolean} [connectUndefineds=false] Indicates whether the chunker
   * should create connected paths across undefined chunks or whether the paths
   * should be separated across undefined chunks.
   *
   * @returns An instance of the Chunker
   */
  ;

  _proto.setConnectUndefineds = function setConnectUndefineds(connectUndefineds) {
    if (connectUndefineds === void 0) {
      connectUndefineds = false;
    }

    this.connectUndefineds = connectUndefineds;
    return this;
  }
  /**
   * @returns {boolean} Whether the chunker connects chunks across undefined
   * chunks or not.
   */
  ;

  _proto.getConnectUndefineds = function getConnectUndefineds() {
    return this.connectUndefineds;
  }
  /**
   * Helper method to instantiate a chunker with a line generator which has all
   * the properties of the current chunker except the x and y accessors.
   */
  ;

  _proto._areaLineChunker = function _areaLineChunker() {
    return new Chunker(_lineGenerator.default).setChunkDecider(this.getChunkDecider()).setChunks(this.getChunks()).setConnectUndefineds(this.getConnectUndefineds()).setCurve(this.getCurve()).setDefined(this.getDefined());
  }
  /**
   * Given an array of data points, this method separates each continuous
   * section of the defined data points into individual chunks.
   *
   * @param {any[]} data The array of data points whose defined segments need to
   * be separated into chunks.
   *
   * @returns {any[]} An array which contains individual sections of continuous,
   * defined data points.
   *
   * @example
   * // Returns [[1, 2], [3, 4], [5]]
   * chunker._computeDefinedSegments([1, 2, null, 3, 4, null, 5]);
   */
  ;

  _proto._computeDefinedSegments = function _computeDefinedSegments(data) {
    var _this2 = this;

    var startNewSegment = true; // split into segments of continuous data

    return data.reduce(function (acc, d) {
      // skip if this point has no data
      if (!_this2.defined(d)) {
        startNewSegment = true;
        return acc;
      }

      if (startNewSegment) {
        // starting a new segment with this point
        acc.push([d]);
        startNewSegment = false;
      } else {
        // add to the last segment
        var lastSegment = acc[acc.length - 1];
        lastSegment.push(d);
      }

      return acc;
    }, []);
  }
  /**
   * Further splits the defined chunk into sub-chunks based on the available
   * chunk definitions and the available chunk decider function.
   *
   * @param {string} chunkName The name of the chunk to be computed
   * @param {any[]} segments An array containting chunks of data split based on
   * the chunk decider function.
   *
   * @returns {any[]} An array of sub-chunks
   *
   * @example
   * // Returns [[1, 3, 5], [7, 8, 9]]
   * chunker._computeSegmentChunks('morethan5', [1, 3, 5, 7, 8, 9])
   */
  ;

  _proto._computeSegmentChunks = function _computeSegmentChunks(chunkName, segments) {
    var _this3 = this;

    var chunkNames = Object.keys(this.chunks);
    return segments.reduce(function (segmentChunks, segment) {
      var startNewSegment = true;
      var chunks = segment.reduce(function (acc, d, i) {
        var dataChunkName = _this3.getChunkDecider()(d),
            dataPrev = segment[i - 1],
            dataNext = segment[i + 1];

        if (dataChunkName === chunkName) {
          if (startNewSegment) {
            // if we are starting a new segment, start it with this point
            acc.push([d]);
            startNewSegment = false;
          } else {
            // otherwise add to the last segment
            acc[acc.length - 1].push(d);
          }
        } else {
          // check if this point belongs in the previous chunk:
          var added = false; // doesn't match chunk name, but does it go in the segment? as the
          // end?

          if (dataPrev != null) {
            var segmentChunkName = CHUNK_RESOLVER(_this3.getChunkDecider()(dataPrev), dataChunkName, chunkNames); // if it is supposed to be in this chunk, add it in

            if (segmentChunkName === chunkName) {
              if (startNewSegment) {
                // if we are starting a new segment, start it with this point
                acc.push([d]);
                startNewSegment = false;
              } else {
                // otherwise add to the last segment
                acc[acc.length - 1].push(d);
              }

              added = true;
              startNewSegment = false;
            }
          } // doesn't belong in previous, so does it belong in next?


          if (!added && dataNext != null) {
            // check if this point belongs in the next chunk
            var nextSegmentChunkName = CHUNK_RESOLVER(dataChunkName, _this3.getChunkDecider()(dataNext), chunkNames); // if it's supposed to be in the next chunk, create it

            if (nextSegmentChunkName === chunkName) {
              acc.push([d]);
              added = true;
              startNewSegment = false;
            } else {
              startNewSegment = true;
            } // not previous or next

          } else if (!added) {
            startNewSegment = true;
          }
        }

        return acc;
      }, []);

      if (chunks && chunks.length) {
        return segmentChunks.concat(chunks);
      }

      return segmentChunks;
    }, []);
  };

  return Chunker;
}();

var _default = Chunker;
exports["default"] = _default;

/***/ }),

/***/ 864:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports.segregateClips = segregateClips;
exports.getUnclippedValue = getUnclippedValue;
exports.getClipType = getClipType;

var _timeInterval = _interopRequireDefault(__webpack_require__(355));

var _month = __webpack_require__(496);

var _year = __webpack_require__(363);

var REPEAT_RESOLVE_ITERATION = 5,
    TIME_UNIT_LENGTH = {
  millisecond: 1,
  second: 1000,
  minute: 60 * 1000,
  hour: 60 * 60 * 1000,
  day: 24 * 60 * 60 * 1000,
  month: 30 * 24 * 60 * 60 * 1000,
  year: 365 * 24 * 60 * 60 * 1000
},
    monthInterval = new _timeInterval.default(_month.monthObj),
    yearInterval = new _timeInterval.default(_year.yearObj);

function getRepeatClippingMultiplier(value, clipObj, unitExpander) {
  if (unitExpander === void 0) {
    unitExpander = TIME_UNIT_LENGTH;
  }

  var repeat = clipObj.repeat.multiplier * unitExpander[clipObj.repeat.unit.toLowerCase()],
      multiplier = Math.floor((value - clipObj.from) / repeat);

  if (+clipObj.repeat.duration < 0) {
    multiplier = Math.min(0, multiplier);
  } else {
    multiplier = Math.max(0, multiplier);
  }

  return [repeat, multiplier];
}

function getNearestClipRange(value, clipObj, unitExpander) {
  if (unitExpander === void 0) {
    unitExpander = TIME_UNIT_LENGTH;
  }

  var timeUnit = clipObj.repeat.unit.toLowerCase(),
      nextFrom,
      nearestFrom,
      nearestTo,
      interval,
      rawMultiplier = clipObj.repeat.multiplier || 1,
      _getRepeatClippingMul = getRepeatClippingMultiplier(value, clipObj, unitExpander),
      repeat = _getRepeatClippingMul[0],
      multiplier = _getRepeatClippingMul[1];

  if (timeUnit === 'month' || timeUnit === 'year') {
    multiplier = multiplier * rawMultiplier;
    interval = timeUnit === 'year' ? yearInterval : monthInterval;
    nearestFrom = +interval.offset(new Date(clipObj.from), multiplier);
    nearestTo = +interval.offset(new Date(clipObj.to), multiplier);

    if (multiplier >= 0) {
      if (+nearestFrom > value) {
        while (+nearestFrom > value) {
          nextFrom = interval.offset(nearestFrom, -1 * rawMultiplier);

          if (nextFrom <= value) {
            break;
          }

          nearestFrom = nextFrom;
          nearestTo = interval.offset(nearestTo, -1 * rawMultiplier);
        }
      } else {
        while (+nearestFrom < value) {
          nextFrom = interval.offset(nearestFrom, rawMultiplier);

          if (nextFrom > value) {
            break;
          }

          nearestFrom = nextFrom;
          nearestTo = interval.offset(nearestTo, rawMultiplier);
        }
      }
    } else {
      if (+nearestFrom < value) {
        nearestFrom = interval.offset(nearestFrom, -1 * rawMultiplier);
        nearestTo = interval.offset(nearestTo, -1 * rawMultiplier);
      }
    }

    return [+nearestFrom, +nearestTo];
  }

  return [+clipObj.from + repeat * multiplier, +clipObj.to + repeat * multiplier];
}

function clamp(value, clipObj, direction) {
  if (clipObj === void 0) {
    clipObj = {};
  }

  if (direction === void 0) {
    direction = 'up';
  }

  var nearestFrom = +clipObj.from,
      nearestTo = +clipObj.to;

  if (clipObj.repeat) {
    var _getNearestClipRange = getNearestClipRange(value, clipObj);

    nearestFrom = _getNearestClipRange[0];
    nearestTo = _getNearestClipRange[1];
  }

  if (value >= nearestFrom && value < nearestTo) {
    return direction === 'up' ? nearestTo : nearestFrom - 1;
  }

  return value;
}

function getUnclippedValue(value, repeatClips, singleClips, options) {
  if (repeatClips === void 0) {
    repeatClips = [];
  }

  if (singleClips === void 0) {
    singleClips = [];
  }

  if (options === void 0) {
    options = {};
  }

  if (isNaN(+value)) return value;
  var i,
      j,
      len,
      _options = options,
      upperLimit = _options.upperLimit,
      lowerLimit = _options.lowerLimit,
      clampDirection = _options.clampDirection,
      curValue = +value,
      maxModValue = curValue,
      modValue = curValue,
      lastCalculatedValue,
      convergeIteration = REPEAT_RESOLVE_ITERATION,
      maxIteration = singleClips.length || 1;

  while (maxIteration > 0 || convergeIteration > 0) {
    // check with all repeat-clip objects
    for (i = 0, len = repeatClips.length; i < len; i++) {
      for (j = 0; j < len; j++) {
        modValue = clamp(curValue, repeatClips[j], clampDirection);

        if (modValue !== curValue) {
          if (clampDirection === 'down') {
            maxModValue = Math.min(maxModValue, modValue);

            if (maxModValue <= lowerLimit) {
              return lowerLimit;
            }
          } else {
            maxModValue = Math.max(maxModValue, modValue);

            if (maxModValue >= upperLimit) {
              return upperLimit;
            }
          }
        }
      }

      if (maxModValue === curValue) break;
      curValue = maxModValue;
    }

    if (lastCalculatedValue === curValue) {
      break;
    } // check with all single-clip objects


    for (i = 0, len = singleClips.length; i < len; i++) {
      curValue = clamp(curValue, singleClips[i], clampDirection);

      if (curValue >= upperLimit) {
        return upperLimit;
      } else if (curValue <= lowerLimit) {
        return lowerLimit;
      }
    }

    for (i = 0; i < len; i++) {
      if (clampDirection === 'down') {
        if (curValue < singleClips[i].from) {
          maxIteration--;
        }
      } else {
        if (curValue >= singleClips[i].to) {
          maxIteration--;
        }
      }
    }

    if (maxModValue === curValue) {
      maxIteration = 0;
    }

    lastCalculatedValue = curValue;
    convergeIteration--;
  }

  return curValue;
}

function segregateClips(clipObjects) {
  if (clipObjects === void 0) {
    clipObjects = [];
  }

  var repeatClips = [],
      singleClips = [],
      clipObj,
      i,
      len = clipObjects.length;

  for (i = 0; i < len; i++) {
    clipObj = clipObjects[i];

    if (clipObj.repeat) {
      repeatClips.push(clipObj);
    } else {
      singleClips.push(clipObj);
    }
  }

  return {
    repeatClips: repeatClips,
    singleClips: singleClips
  };
}

function getClipType(bin, repeatClips, singleClips) {
  if (bin === void 0) {
    bin = [];
  }

  if (repeatClips === void 0) {
    repeatClips = [];
  }

  if (singleClips === void 0) {
    singleClips = [];
  }

  var i,
      len,
      binStart = +bin[0],
      binEnd = +bin[1],
      clipObj,
      nearestClipRange,
      binStartMultiplier,
      binEndMultiplier;

  if (getUnclippedValue(binStart, repeatClips, singleClips, {
    upperLimit: binEnd
  }) >= binEnd) {
    return 2;
  } // test out with all the non-repeat clip configurations


  for (i = 0, len = singleClips.length; i < len; i++) {
    clipObj = singleClips[i];

    if (binStart <= +clipObj.from && +clipObj.from < binEnd || binStart < +clipObj.to && +clipObj.to < binEnd) {
      return 1;
    }
  }

  for (i = 0, len = repeatClips.length; i < len; i++) {
    clipObj = repeatClips[i];
    binStartMultiplier = getRepeatClippingMultiplier(binStart, clipObj)[1];
    binEndMultiplier = getRepeatClippingMultiplier(binEnd - 1, clipObj)[1];

    if (binEndMultiplier - binStartMultiplier > 1) {
      return 1;
    }

    nearestClipRange = getNearestClipRange(binStart, clipObj);

    if (binStart <= nearestClipRange[0] && nearestClipRange[0] < binEnd || binStart < nearestClipRange[1] && nearestClipRange[1] < binEnd) {
      return 1;
    }

    nearestClipRange = getNearestClipRange(binEnd - 1, clipObj);

    if (binStart <= nearestClipRange[0] && nearestClipRange[0] < binEnd || binStart < nearestClipRange[1] && nearestClipRange[1] < binEnd) {
      return 1;
    }
  }

  return 0;
}

window.getUnclippedValue = getUnclippedValue;

/***/ }),

/***/ 875:
/***/ ((__unused_webpack_module, exports) => {



exports.__esModule = true;
exports.UTC_TIME_SPAN = exports.TIME_SPAN = void 0;
var TIME_SPAN = [new Date(2000, 0, 1), new Date(2000, 0, 2)],
    UTC_TIME_SPAN = [Date.UTC(2000, 0, 1), Date.UTC(2000, 0, 2)];
exports.UTC_TIME_SPAN = UTC_TIME_SPAN;
exports.TIME_SPAN = TIME_SPAN;

/***/ }),

/***/ 873:
/***/ ((__unused_webpack_module, exports) => {



exports.__esModule = true;
exports.getFloorOfDate = getFloorOfDate;
exports.modifyDate = modifyDate;
exports.DAYS_IN_YEAR = exports.DAYS_IN_MONTH = exports.HOURS_IN_DAY = exports.MONTHS_IN_YEAR = exports.DAYS_IN_WEEK = exports.MINUTES_IN_HOUR = exports.SECONDS_IN_MINUTE = exports.MILLISECONDS_IN_SECOND = void 0;
var MONTHS_IN_YEAR = 12,
    MILLISECOND = 'millisecond',
    SECOND = 'second',
    MINUTE = 'minute',
    HOUR = 'hour',
    DAY = 'day',
    WEEK = 'week',
    MONTH = 'month',
    YEAR = 'year',
    GET = 'get',
    SET = 'set',
    MILLISECONDS_IN_SECOND = 1000,
    SECONDS_IN_MINUTE = 60,
    MINUTES_IN_HOUR = 60,
    DAYS_IN_WEEK = 7,
    HOURS_IN_DAY = 24,
    DAYS_IN_MONTH = 30,
    DAYS_IN_YEAR = 365;
/**
 * For a given date it transform the date to the beginning of nearest formatted date.
 *
 * When format is day, it converts the date to the beginning of the day
 * For example, when format is 'day', 24th jan, 2018 08:05:11 is converted to 24th jan, 2018 00:00:00
 *
 * When interval is 2 and format is 'day', all the days of a month are divided in bins of size 2
 * and the date is converted to beginning of the bin in which it belongs.
 *
 * When interval is 2,
 * 24th jan, 2018 08:05:11 is converted to 24th jan, 2018 00:00:00
 * 25th jan, 2018, 08:05:11 is converted to 24th jan, 2018 00:00:00
 *
 * @param {Date} date date to be converted
 * @param {string} [format='day'] the time interval in which the given date should be formatted
 * @param {number} [_interval=1] size of bins for the given format
 * @returns {Date} converted date
 */

exports.DAYS_IN_YEAR = DAYS_IN_YEAR;
exports.DAYS_IN_MONTH = DAYS_IN_MONTH;
exports.HOURS_IN_DAY = HOURS_IN_DAY;
exports.DAYS_IN_WEEK = DAYS_IN_WEEK;
exports.MINUTES_IN_HOUR = MINUTES_IN_HOUR;
exports.SECONDS_IN_MINUTE = SECONDS_IN_MINUTE;
exports.MILLISECONDS_IN_SECOND = MILLISECONDS_IN_SECOND;
exports.MONTHS_IN_YEAR = MONTHS_IN_YEAR;

function getFloorOfDate(date, format, _interval, utc) {
  if (format === void 0) {
    format = 'day';
  }

  if (_interval === void 0) {
    _interval = 1;
  }

  if (utc === void 0) {
    utc = '';
  }

  var curDate = new Date(date.valueOf()),
      subTime,
      interval = _interval;

  switch (format) {
    case MILLISECOND:
      subTime = curDate[GET + utc + 'Milliseconds']();
      interval = Math.min(interval, MILLISECONDS_IN_SECOND);
      curDate[SET + utc + 'Milliseconds'](Math.floor(subTime / interval) * interval);
      break;

    case SECOND:
      subTime = curDate[GET + utc + 'Seconds']();
      interval = Math.min(interval, SECONDS_IN_MINUTE);
      curDate[SET + utc + 'Seconds'](Math.floor(subTime / interval) * interval, 0);
      break;

    case MINUTE:
      subTime = curDate[GET + utc + 'Minutes']();
      interval = Math.min(interval, MINUTES_IN_HOUR);
      curDate[SET + utc + 'Minutes'](Math.floor(subTime / interval) * interval, 0, 0);
      break;

    case HOUR:
      subTime = curDate[GET + utc + 'Hours']();
      interval = Math.min(interval, HOURS_IN_DAY);
      curDate[SET + utc + 'Hours'](Math.floor(subTime / interval) * interval, 0, 0, 0);
      break;

    case DAY:
      subTime = curDate[GET + utc + 'Date']();
      interval = Math.min(interval, DAYS_IN_MONTH + 1);
      curDate[SET + utc + 'Date'](Math.max(Math.floor(subTime / interval) * interval, 1));
      curDate[SET + utc + 'Hours'](0, 0, 0, 0);
      break;

    case WEEK:
      subTime = curDate[GET + utc + 'Date']();
      interval = Math.min(interval, DAYS_IN_WEEK);
      curDate[SET + utc + 'Date'](Math.max(Math.floor(subTime / interval) * interval, 1));
      curDate[SET + utc + 'Hours'](0, 0, 0, 0);
      break;

    case MONTH:
      subTime = curDate[GET + utc + 'Month']();
      interval = Math.min(interval, MONTHS_IN_YEAR);
      curDate[SET + utc + 'Month'](Math.floor(subTime / interval) * interval, 1);
      curDate[SET + utc + 'Hours'](0, 0, 0, 0);
      break;

    case YEAR:
      curDate[SET + utc + 'Month'](0, 1);
      curDate[SET + utc + 'Hours'](0, 0, 0, 0);
  }

  return curDate;
}
/**
 * Increases or decreases the date based on the format and interval.
 *
 * When the format in 'day' and interval is 2, the date is increased by 2 days.
 * For decreasing the date, interval should be negative, interval = -2 decreases the day by 2.
 *
 * When reset = 1, date is incremented and set to beginning of the format,
 * for example, when format = 'day', interval = 2, reset = 1,
 * 24th jan, 2018 08:05:11 is converted to 26th jan, 2018 00:00:00
 *
 * @param {Date} date date to be modified
 * @param {string} [format='day'] time interval based on which increment and decrement will be done
 * @param {number} [interval=1] increment/decrement value
 * @param {boolean} [reset=false] reset flag
 * @returns {Date} modified date
 */


function modifyDate(date, format, interval, reset, utc) {
  if (format === void 0) {
    format = 'day';
  }

  if (interval === void 0) {
    interval = 1;
  }

  if (reset === void 0) {
    reset = false;
  }

  if (utc === void 0) {
    utc = '';
  }

  var curDate = new Date(date.valueOf());

  switch (format) {
    case MILLISECOND:
      curDate[SET + utc + 'Milliseconds'](curDate[GET + utc + 'Milliseconds']() + interval);
      break;

    case SECOND:
      curDate[SET + utc + 'Seconds'](curDate[GET + utc + 'Seconds']() + interval);
      reset && curDate[SET + utc + 'Milliseconds'](0);
      break;

    case MINUTE:
      curDate[SET + utc + 'Minutes'](curDate[GET + utc + 'Minutes']() + interval);
      reset && curDate[SET + utc + 'Seconds'](0, 0);
      break;

    case HOUR:
      curDate[SET + utc + 'Hours'](curDate[GET + utc + 'Hours']() + interval);
      reset && curDate[SET + utc + 'Minutes'](0, 0, 0);
      break;

    case DAY:
      curDate[SET + utc + 'Date'](curDate[GET + utc + 'Date']() + interval);
      reset && curDate[SET + utc + 'Hours'](0, 0, 0, 0);
      break;

    case MONTH:
      curDate[SET + utc + 'Month'](curDate[GET + utc + 'Month']() + interval);
      reset && curDate[SET + utc + 'Date'](0, 0, 0, 0, 0);
      break;

    case YEAR:
      curDate[SET + utc + 'FullYear'](curDate[GET + utc + 'FullYear']() + interval);
      reset && curDate[SET + utc + 'Month'](0, 0, 0, 0, 0, 0);
  }

  return curDate;
}

;

/***/ }),

/***/ 869:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = exports.copyScaleBin = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _calendar = _interopRequireDefault(__webpack_require__(870));

var _scaleUtils = __webpack_require__(873);

exports.getFloorOfDate = _scaleUtils.getFloorOfDate;
exports.modifyDate = _scaleUtils.modifyDate;

var _pluckNumber = _interopRequireDefault(__webpack_require__(280));

var _timeBucket = __webpack_require__(874);

var _timeConverter = _interopRequireDefault(__webpack_require__(350));

var _year = _interopRequireDefault(__webpack_require__(363));

var _clipUtils = __webpack_require__(864);

var _capsFirst = _interopRequireDefault(__webpack_require__(862));

var _hour = _interopRequireDefault(__webpack_require__(362));

var _language_maps = __webpack_require__(534);

var UNDEF;

var DEFAULT_THRESHOLD_PIXELS = 4,
    MAJOR = 'major',
    MINOR = 'minor',
    CONTEXT = 'context',
    YEAR = 'year',
    BLANK = '',
    DAY_1 = 1000 * 60 * 60 * 24,
    DAY_30 = DAY_1 * 30,
    DAY_365 = DAY_1 * 365,
    // FTV3-1002: Uniform alignment of plot and tick w.r.t. bin for all time units.
// Adding Time units in CONTEXT_SEQ
CONTEXT_SEQ = ['millisecond', 'second', 'minute', 'hour', 'day', 'month', 'year'],
    // TIME_UNITS = ['millisecond', 'second', 'minute', 'hour', 'day', 'month', 'year'],
// dayCount = [31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31],
showMonthInDayTick = true,
    domainToMajorIntervalRatio = [{
  ratio: 4,
  index: 8
}, {
  ratio: 3,
  index: 7
}, {
  ratio: 2.5,
  index: 6
}, {
  ratio: 2,
  index: 5
}, {
  ratio: 1.5,
  index: 4
}, {
  ratio: 1,
  index: 3
}, {
  ratio: 0.67,
  index: 2
}, {
  ratio: 0.33,
  // 0.25
  index: 1
}, {
  ratio: 0,
  index: 0
}],

/**
  *returns a function which when given a value in domain returns the corresponding range
  * @param {Array} domain array containing the start and end value
  * @param {Array} range array containing the start and end value
  * @param {Function} deInterpolate function
  * @param {Function} reInterpolate function
  * @return {Function} takes in value and returns the mapped value
  */
bimap = function bimap(domain, range, deInterpolate, reInterpolate) {
  var deInterpolator, reInterpolator;

  if (domain[0] > domain[1]) {
    deInterpolator = deInterpolate(domain[1], domain[0]);
    reInterpolator = reInterpolate(range[1], range[0]);
  } else {
    deInterpolator = deInterpolate(domain[0], domain[1]);
    reInterpolator = reInterpolate(range[0], range[1]);
  }

  return function (value) {
    return reInterpolator(deInterpolator(value));
  };
},

/**
* copy the domain, range and interpolator of source to targe
* @param {Object} sourceScale instance of scale
* @param {Object} targetScale instance of scale
* @return {Object} the target scale
*/
copyScaleBin = function copyScaleBin(sourceScale, targetScale) {
  return targetScale.setInterpolate(sourceScale.getInterpolate()).setClamp(sourceScale.getClamp()).setRangeThreshold(sourceScale._threshold).setRange(sourceScale.getRange()).setThresholdIntervals(sourceScale.thresholdIntervals).setBinMin(sourceScale.getBinMin()).setClippings(sourceScale.clippings).setFirstData(sourceScale.getFirstData()).setDomain(sourceScale.getDomain());
},

/**
 * Validates if x is a valid number
 *
 * @param {any} x value to be tested
 * @returns {boolean}
 */
validate = function validate(x) {
  return x !== null && !isNaN(x);
},

/**
 * For a given number ratio of domainWidth and majorInterval width, this API
 * determines the number of minor ticks to be generated
 *
 * @param {Number} ratio of domainWidth and majorInterval width
 * @returns {Number} index of thresholdIntervals based on which minor ticks will be calculated
 */
niceMinorTickIndex = function niceMinorTickIndex(value) {
  var i,
      len = domainToMajorIntervalRatio.length,
      inverse = 1 / value;

  if (inverse > 4) {
    return Infinity;
  }

  for (i = 0; i < len; i++) {
    if (inverse > domainToMajorIntervalRatio[i].ratio) {
      return domainToMajorIntervalRatio[i].index;
    }
  }
},

/**
 * checks if the startDate and endDate have a major change of date in between
 * (for example, day change, month change, year change)
 *
 * @param {Date} startDate start date
 * @param {Date} endDate end date
 * @param {Number} index index in the array of time intervals
 * @param {Array} thresholdIntervals array of time intervals
 * @returns {any} Array containing the two different context if there is context change, else false
 */
contextChange = function contextChange(startDate, endDate, index, thresholdIntervals, utc) {
  var start = (0, _scaleUtils.getFloorOfDate)(new Date(startDate), thresholdIntervals[index][0].name(), thresholdIntervals[index][1], utc),
      end = (0, _scaleUtils.getFloorOfDate)(new Date(endDate), thresholdIntervals[index][0].name(), thresholdIntervals[index][1], utc);

  if (+start !== +end) {
    return [start, end];
  }

  return false;
},
    biSearch = function biSearch(ar, val) {
  var start = 0,
      end = ar.length - 1,
      mid;

  while (start <= end) {
    mid = start + Math.ceil((end - start) / 2);

    if (val >= ar[mid].start && val < ar[mid].end) {
      return mid;
    }

    if (ar[mid].end <= val) {
      start = mid + 1;
    } else {
      end = mid - 1;
    }
  }

  return -1;
},
    dateAPI = function dateAPI(date, param, utc) {
  return date['get' + utc + param]();
},

/**
 * appends a 0 in front of a number if the number is less than 10
 *
 * @param {Number} x number to checked
 */
formatDate = function formatDate(x) {
  return (x < 10 ? '0' + x : x) + '';
},

/**
 * checks if a year is leap year
 */
// isLeapYear = x => {
//   if (x % 4 === 0) {
//     if (x % 100 === 0) {
//       if (x % 400 === 0) {
//         return true;
//       } return false;
//     } return true;
//   } return false;
// },

/**
 * returns number of days in a month
 */
// getNumberOfDay = (year, month) => {
//   if (month === 1 && isLeapYear(year)) {
//     return 29;
//   }
//   return dayCount[month];
// },

/**
 * For a given date, this API formats and returns it
 *
 * @param {any} date date to be formatted
 */
getFullDate = function getFullDate(date, type, language) {
  return _language_maps.abbreviatedMonthsMap[language][dateAPI(date, 'Month', type)] + " " + formatDate(dateAPI(date, 'Date', type)) + ", " + dateAPI(date, 'FullYear', type);
},
    getFullTime = function getFullTime(date, type) {
  return formatDate(dateAPI(date, 'Hours', type)) + ":" + formatDate(dateAPI(date, 'Minutes', type)) + ":" + formatDate(dateAPI(date, 'Seconds', type));
},

/**
 * returns best possible interval between ticks depending on the current binning only if the binning is in years
 *
 * @param {Array} thresholdIntervals array of time intervals
 * @param {Number} curMajorIndex current major index
 * @param {Number} minDiff minimum difference depending on the binning provided
 * @returns {Number} index of thresholdIntervals
 */
getNiceYearlyMajorTicks = function getNiceYearlyMajorTicks(thresholdIntervals, curMajorIndex, minDiff) {
  var i;
  i = curMajorIndex;

  while (i - 1 >= 0 && thresholdIntervals[i - 1][0].name() === 'year' && thresholdIntervals[i - 1][2] >= minDiff) {
    i--;
  }

  return i;
};

exports.copyScaleBin = copyScaleBin;

var ScaleCalendarBin = /*#__PURE__*/function (_ScaleCalendar) {
  (0, _inheritsLoose2.default)(ScaleCalendarBin, _ScaleCalendar);

  function ScaleCalendarBin(year, month, week, day, hour, minute, second, millisecond) {
    var _this;

    _this = _ScaleCalendar.call(this, year, month, week, day, hour, minute, second, millisecond) || this;
    _this._type = BLANK;
    _this.bins = [];
    _this.clippings = [];
    _this.clipIndices = [];
    _this.clips = [];
    _this.clippedDomain = [0, 1];
    _this.applicableClippings = {};
    return _this;
  }

  var _proto = ScaleCalendarBin.prototype;

  _proto.getType = function getType() {
    return this._type;
  };

  _proto.setTimeInterval = function setTimeInterval(timeIntervals) {
    this.timeIntervals = timeIntervals;

    _ScaleCalendar.prototype.setTimeInterval.call(this, timeIntervals);
  };

  _proto.setUnclippedTimeIntervals = function setUnclippedTimeIntervals(unclippedTimeIntervals) {
    this.unclippedTimeIntervals = unclippedTimeIntervals;

    _ScaleCalendar.prototype.setUnclippedTimeIntervals.call(this, unclippedTimeIntervals);
  };

  _proto._rescale = function _rescale() {
    this.output = null;
    this.input = null;
    return this;
  };

  _proto.setClippings = function setClippings(clippings) {
    this.clippings = clippings;
    return this;
  };

  _proto.getClippings = function getClippings() {
    return this.clippings;
  }
  /**
   * decides whether plot is to be drawn over the ticks
   *
   * @returns {boolean} whether ticks to be drawn on the ticks or not
   * @memberof ScaleCalendarBin
   */
  ;

  _proto.showPlotOverTick = function showPlotOverTick() {
    var scale = this,
        curBin = scale._getRangeThreshold(),
        minBin = scale.getBinMin();

    if (minBin[0].name() === 'millisecond' || CONTEXT_SEQ.indexOf(curBin[0].name()) > -1) // condition removed for not checking time interval by 1 && (curBin[1] === 1)
      {
        return true;
      }

    return false;
  }
  /**
   * finds the starting and ending of a bin based on a initial timestamp
   *
   * @param {any} pixel pixel position
   * @param {number} [firstTimeStamp=0] initial timestamp
   * @returns {Object} start and end of the bin
   * @memberof ScaleCalendarBin
   */
  ;

  _proto.getBinBounds = function getBinBounds(idx) {
    var bin = this._getBinBounds(idx);

    return {
      startDate: +bin.start,
      endDate: +bin.end
    };
  }
  /**
   * For a starting timestamp and current timestamp, this API returns the index of the bin
   * in which the current timestamp falls
   *
   * @param {any} curTimeStamp current timestamp
   * @returns {Number} index of the bin
   * @memberof ScaleCalendarBin
   */
  // FTV3-1147 : Data marker is drawn at wrong position w.r.t. the specified date.
  // Implemented controlled roundoff to next binIndex by passing  enableRoundOff parameter
  ;

  _proto.getBinIndex = function getBinIndex(curTimeStamp, enableRoundOff) {
    if (enableRoundOff === void 0) {
      enableRoundOff = true;
    }

    var binIndex = this._getBinIndex(curTimeStamp),
        binBounds = this._getBinBounds(binIndex),
        binsArLength = this.bins.length,
        binMid = +binBounds.start + (binBounds.end - binBounds.start) / 2,
        showPlotOverTick = this.showPlotOverTick();

    if (enableRoundOff && showPlotOverTick && curTimeStamp >= binMid) {
      binIndex++;

      while (binIndex < binsArLength && this.bins[binIndex].clipType === 2) {
        binIndex++;
      }
    }

    return binIndex;
  };

  _proto.calculateRangeValue = function calculateRangeValue(value) {
    var domain = this.getDomain(),
        bins = this.bins,
        clippedDomainValue;
    clippedDomainValue = value < bins[0].start || value >= bins[bins.length - 1].end ? value : +domain[0] + this.distance(+domain[0], +value);

    if (!this.output) {
      this.output = bimap(this.clippedDomain, this.getRange(), this.deInterpolate, this.interpolate);
    }

    return this.output(Number(clippedDomainValue));
  }
  /**
   * returns the pixel value for a timestamp. When both start and end is provided,
   * return the middle point of both the pixels
   *
   * @param {any} startValue start timestamp
   * @param {any} endValue end timestamp
   * @returns {Number} pixel value
   * @memberof ScaleCalendarBin
   */
  ;

  _proto.getRangeValue = function getRangeValue(startValue, endValue) {
    if (typeof startValue === 'undefined' && typeof endValue === 'undefined') {
      return UNDEF;
    } else if (typeof endValue === 'undefined') {
      return this.calculateRangeValue(startValue);
    }

    if (this.showPlotOverTick()) {
      return this.calculateRangeValue(startValue);
    }

    return (this.calculateRangeValue(startValue) + this.calculateRangeValue(endValue)) / 2;
  };

  _proto.getDomainValue = function getDomainValue(value) {
    if (isNaN(value)) {
      return value;
    }

    var domain = this.getDomain(),
        compressedDomainValue,
        spreadedDomainValue;

    if (!this.input) {
      this.input = bimap(this.getRange(), this.clippedDomain, this.deInterpolate, this.interpolate);
    }

    compressedDomainValue = this.input(Number(value));
    spreadedDomainValue = this.offset(+domain[0], compressedDomainValue - domain[0]);
    return new Date(spreadedDomainValue);
  }
  /**
   * Stores index of first appearance of major time intervals from ScaleCalendarBin.thresholdIntervals
   *
   * @memberof ScaleCalendarBin
   */
  ;

  _proto.calculateIndexOfIntervals = function calculateIndexOfIntervals() {
    var scale = this,
        intervalIndexMap,
        thresholdIntervals = scale.thresholdIntervals,
        i,
        len = thresholdIntervals.length;
    scale.intervalIndexMap = intervalIndexMap = {};

    for (i = len - 1; i >= 0; i--) {
      intervalIndexMap[thresholdIntervals[i][0].name()] = i;
    }
  }
  /**
   * Return the index of thresholdIntervals based on which minor ticks will be calculated.
   * If valid index is not found, it returns -1
   *
   * @param {number} majorIndex index of thresholdIntervals based on which major ticks are calculated
   * @param {number} gap length of a major tick interval
   * @returns {number} valid index or -1
   * @memberof ScaleCalendarBin
   */
  ;

  _proto.getNiceMinorTickInterval = function getNiceMinorTickInterval(majorIndex, gap, domainLength) {
    if (majorIndex === 0) {
      return -1;
    }

    var scale = this,
        thresholdIntervals = scale.thresholdIntervals,
        i,
        rangeThreshold = scale._getRangeThreshold(),
        minDiff = rangeThreshold[2],
        density,
        curIntervalName = thresholdIntervals[majorIndex - 1][0].name(),
        len,
        minAllowedMinorBinIndex,
        divisible = []; // calculate the minimum allowed minor tick interval based on binning


    for (i = 0, len = thresholdIntervals.length; i < len; i++) {
      if (thresholdIntervals[i][2] >= minDiff) {
        minDiff = rangeThreshold[0].name() === 'week' ? thresholdIntervals[i][2] : minDiff;
        minAllowedMinorBinIndex = i;
        break;
      }
    } // For lower time division, push all the divisions to divisible array


    for (i = majorIndex - 1; i >= minAllowedMinorBinIndex; i--) {
      if (thresholdIntervals[i][0].name() !== curIntervalName) {
        break;
      }

      if (!(thresholdIntervals[i][2] % minDiff) && curIntervalName !== 'year') {
        divisible.push(i);
      }
    } // Decide based on the domain length, the accurate time interval


    density = Math.min(niceMinorTickIndex(domainLength / gap), divisible.length - 1);
    return (0, _pluckNumber.default)(divisible[density], -1);
  }
  /**
   * This API decides which index to choose for showing nice major ticks
   * (index of this.thresholdinterval)
   *
   * @param {number} curMajorIndex index to be tested
   * @returns {number}  index to create nice major ticks
   * @memberof ScaleCalendarBin
   */
  ;

  _proto.getNiceMajorTickInterval = function getNiceMajorTickInterval(curMajorIndex, dayInMajor) {
    if (dayInMajor === void 0) {
      dayInMajor = false;
    }

    var scale = this,
        thresholdIntervals = scale.thresholdIntervals,
        i,
        len = thresholdIntervals.length,
        curBin = scale._getRangeThreshold(),
        minDiff = curBin[2],
        scaleMode = scale.getMode();

    if (scaleMode === 'random') {
      if (!dayInMajor && thresholdIntervals[curMajorIndex][0].name() === 'day' && (thresholdIntervals[curMajorIndex][1] > 1 || thresholdIntervals[curMajorIndex][2] > minDiff)) {
        for (i = curMajorIndex; i < len; i++) {
          if (thresholdIntervals[i][0].name() !== 'day' && minDiff < thresholdIntervals[i][2]) {
            return i;
          }
        }
      } else {
        if (thresholdIntervals[curMajorIndex][0].name() === 'year') {
          return getNiceYearlyMajorTicks(thresholdIntervals, curMajorIndex, minDiff);
        }

        for (i = curMajorIndex; i < len; i++) {
          if (thresholdIntervals[i][2] > minDiff) {
            return i;
          }
        }
      }
    } else {
      if (thresholdIntervals[curMajorIndex][1] !== 1 || thresholdIntervals[curMajorIndex][2] <= minDiff) {
        if (thresholdIntervals[curMajorIndex][0].name() === 'year') {
          return getNiceYearlyMajorTicks(thresholdIntervals, curMajorIndex, minDiff);
        }

        for (i = curMajorIndex; i < len; i++) {
          if (thresholdIntervals[i][1] === 1 && thresholdIntervals[i][2] > minDiff) {
            return i;
          }
        }
      }
    }

    return curMajorIndex;
  }
  /**
   * Based on the major ticks context ticks will be generated
   *
   * @param {any} curMajorIndex index of thresholdIntervals based on which majorTick is calculated
   * @returns {Array} context ticks
   * @memberof ScaleCalendarBin
   */
  ;

  _proto.generateContextTicks = function generateContextTicks(curMajorIndex, coincideWithMajor) {
    if (coincideWithMajor === void 0) {
      coincideWithMajor = false;
    }

    var scale = this,
        thresholdIntervals = scale.thresholdIntervals,
        intervalIndexMap = scale.intervalIndexMap,
        domain = scale.getDomain(),
        start = domain[0],
        end = domain[1],
        majorIntervalName = thresholdIntervals[curMajorIndex][0].name(),
        desiredContextInterval = CONTEXT_SEQ[CONTEXT_SEQ.indexOf(majorIntervalName) + 1],
        j,
        len = thresholdIntervals.length,
        dayStartIndex = intervalIndexMap.day,
        contextOfStart,
        contextOfEnd,
        contextIndex = -1,
        context,
        contextTickAr = []; // Check if context labels can be created

    if (coincideWithMajor) {
      // if coincideWithMajor is enabled, context ticks will behave as major ticks
      contextIndex = curMajorIndex;
    } else {
      if (majorIntervalName === 'day' && showMonthInDayTick) {
        desiredContextInterval = YEAR;
      }

      for (j = Math.max(curMajorIndex, dayStartIndex); j < len; j++) {
        if (thresholdIntervals[j][0].name() === desiredContextInterval) {
          contextIndex = j;
          break;
        }
      }
    } // Find context labels


    if (contextIndex > -1) {
      contextOfStart = (0, _scaleUtils.getFloorOfDate)(new Date(start), thresholdIntervals[contextIndex][0].name(), thresholdIntervals[contextIndex][1], scale.getType()); // If there is a change of context in domain, context ticks will be drawn

      if (context = contextChange(new Date(start), new Date(end), contextIndex, thresholdIntervals, scale.getType())) {
        contextOfEnd = context[1]; // Arrange all the context ticks that are in the current domain

        context = contextOfEnd - thresholdIntervals[contextIndex][2];

        while (context >= +start) {
          contextTickAr.push(new Date(context));
          context -= thresholdIntervals[contextIndex][2];
        }

        +start !== +contextOfStart && contextTickAr.push(new Date(contextOfStart));
        contextTickAr.reverse();
        contextTickAr.push(new Date(contextOfEnd));
      } else {
        contextTickAr.push(contextOfStart);
      }

      scale._timeFormat.context = thresholdIntervals[contextIndex][0].name();
    }

    return contextTickAr;
  };

  _proto.getClippedMinorTicks = function getClippedMinorTicks(majorStart, majorEnd, minorIndex) {
    var bins = this.bins,
        i,
        len,
        binning = this._getRangeThreshold(),
        firstBin = bins[0],
        lastBin = bins[bins.length - 1],
        _this$applicableClipp = this.applicableClippings,
        repeatClips = _this$applicableClipp.repeatClips,
        singleClips = _this$applicableClipp.singleClips,
        threshold = this.thresholdIntervals[minorIndex],
        interval = this.unclippedTimeIntervals[(0, _capsFirst.default)(binning[0].name())] || this.unclippedTimeIntervals[binning[0].name()],
        extendedBins = [],
        unClippedBins = 0,
        ticksThatCanBeGenerated = threshold[0].range(majorStart, majorEnd, threshold[1]).length,
        binsBetweenTwoTicks,
        binsEncounteredTillNow = -1,
        minorTicksAr = [],
        clipType,
        binStart,
        binEnd;

    binStart = firstBin.start;
    binEnd = firstBin.end;

    while (binStart > majorStart) {
      binStart = interval.offset(binStart, -1 * binning[1]);
      binEnd = interval.offset(binEnd, -1 * binning[1]);
      clipType = (0, _clipUtils.getClipType)([binStart, binEnd], repeatClips, singleClips);
      extendedBins.push({
        start: binStart,
        end: binEnd,
        clipType: clipType
      });

      if (clipType !== 2) {
        unClippedBins++;
      }
    }

    extendedBins.reverse();

    for (i = 0, len = bins.length; i < len; i++) {
      if (bins[i].end < majorStart || bins[i].start > majorEnd) continue;
      extendedBins.push(bins[i]);

      if (bins[i].clipType !== 2) {
        unClippedBins++;
      }
    }

    binStart = lastBin.start;
    binEnd = lastBin.end;

    while (binEnd < majorEnd) {
      binStart = interval.offset(binStart, binning[1]);
      binEnd = interval.offset(binEnd, binning[1]);
      extendedBins.push({
        start: binStart,
        end: binEnd,
        clipType: (0, _clipUtils.getClipType)([binStart, binEnd], repeatClips, singleClips)
      });

      if (clipType !== 2) {
        unClippedBins++;
      }
    }

    ticksThatCanBeGenerated = Math.min(ticksThatCanBeGenerated, unClippedBins) + 1;
    binsBetweenTwoTicks = Math.floor(unClippedBins / ticksThatCanBeGenerated) || 1;

    for (i = 0, len = extendedBins.length; i < len; i++) {
      if (extendedBins[i].clipType !== 2) {
        binsEncounteredTillNow++;

        if (binsEncounteredTillNow && !(binsEncounteredTillNow % binsBetweenTwoTicks)) {
          minorTicksAr.push(extendedBins[i].start);
        }
      }
    }

    return minorTicksAr;
  }
  /**
   * Returns the gap between two major ticks
   *
   * @param {Number} index index in thresholdIntervals based on which major ticks are calculated
   * @param {Array} majorIndexAr major ticks
   * @returns {Number} major interval gap
   * @memberof ScaleCalendarBin
   */
  ;

  _proto.getMajorIntervalGap = function getMajorIntervalGap(lMajor, rMajor, majorIndex) {
    var ticks = this,
        thresholdIntervals = ticks.thresholdIntervals,
        clippings = this.getClippings();

    if (!clippings.length) {
      if (thresholdIntervals[majorIndex][0].name() === 'month') {
        return DAY_30;
      } else if (thresholdIntervals[majorIndex][0].name() === 'year') {
        return DAY_365;
      }

      return rMajor - lMajor;
    }

    return this.distance(lMajor, rMajor);
  }
  /**
   * Calculate the major, minor and context tick intervals
   *
   * @returns {Array} Array containing the ticks
   * @memberof ScaleCalendarBin
   */
  ;

  _proto.ticks = function ticks(skipInfo, dayInMajor) {
    if (skipInfo === void 0) {
      skipInfo = {};
    }

    var scale = this,
        i,
        j,
        len,
        thresholdIntervals = scale.thresholdIntervals,
        unclippedTimeIntervals = scale.getUnclippedTimeIntervals(),
        interval,
        _scale$applicableClip = scale.applicableClippings,
        repeatClips = _scale$applicableClip.repeatClips,
        singleClips = _scale$applicableClip.singleClips,
        domain = scale.getDomain(),
        curBin = this._getRangeThreshold(),
        majorIndex,
        majorIntervalName,
        minorIntervalName,
        minorIndex,
        majorTicksAr,
        minorTicksAr,
        minorTicksArLen,
        isMajortickInDomain = false,
        contextTickAr = [],
        tickValue,
        start = domain[0],
        end = domain[1],
        timeGap,
        tickAr = [],
        tickType = [],
        timeFormat,
        retTickAr = [],
        scaleType = scale.getType(); // If domain is not valid, return blank array(no ticks).


    if (!validate(start) || !validate(end)) {
      scale._tickType = [];
      return [];
    }

    scale._timeFormat = timeFormat = {}; // calculate domain length

    timeGap = this.distance(start, end); // Calculate major ticks

    for (i = len = thresholdIntervals.length - 1; i >= 0; i--) {
      if (Math.floor(timeGap / thresholdIntervals[i][2]) > 1) {
        majorIndex = scale.getNiceMajorTickInterval(i, dayInMajor);
        majorIntervalName = thresholdIntervals[majorIndex][0].name();
        interval = unclippedTimeIntervals[(0, _capsFirst.default)(majorIntervalName)] || unclippedTimeIntervals[majorIntervalName]; // Convert domain to the accurate upper and lower limit

        start = (0, _scaleUtils.getFloorOfDate)(new Date(start), majorIntervalName, thresholdIntervals[majorIndex][1], scaleType);
        end = (0, _scaleUtils.modifyDate)(new Date(end), majorIntervalName, thresholdIntervals[majorIndex][1], false, scaleType);
        end = (0, _scaleUtils.getFloorOfDate)(new Date(end), majorIntervalName, thresholdIntervals[majorIndex][1], scaleType); // Calculate major ticks

        majorTicksAr = interval.range(+start, +end + thresholdIntervals[majorIndex][2], thresholdIntervals[majorIndex][1]);
        timeFormat.major = majorIntervalName; // checks whether no major ticks is visible

        for (j = 0; j < majorTicksAr.length; j++) {
          if (+majorTicksAr[j] >= +domain[0] && +majorTicksAr[j] <= +domain[1]) {
            isMajortickInDomain = true;
          }
        } // Check if context labels can be created


        contextTickAr = scale.generateContextTicks(majorIndex, !isMajortickInDomain) || [];
        break;
      }
    }

    if (!majorTicksAr) {
      scale._tickType = [];
      return tickAr;
    } // Calculation of minor ticks


    for (i = 0, len = majorTicksAr.length; i < len - 1; i++) {
      // push all the generated major ticks irrespective of domain checking
      tickAr.push(majorTicksAr[i]);
      tickType.push(MAJOR); // get minor tick index

      if (thresholdIntervals[majorIndex][0].name() === 'year' && majorTicksAr.length > 10) {
        // do not generate minor ticks if major ticks are in year and number of year is greater than 8
        minorIndex = -1;
      } else {
        minorIndex = scale.getNiceMinorTickInterval(majorIndex, scale.getMajorIntervalGap(majorTicksAr[i], majorTicksAr[i + 1], majorIndex), timeGap);
      } // create minor ticks


      if (minorIndex > -1 && !skipInfo.minor) {
        minorIntervalName = thresholdIntervals[minorIndex][0].name();
        interval = unclippedTimeIntervals[(0, _capsFirst.default)(minorIntervalName)] || unclippedTimeIntervals[minorIntervalName];

        if (((repeatClips || []).length || (singleClips || []).length) && curBin[1] === 1 && curBin[0].name() === thresholdIntervals[minorIndex][0].name()) {
          minorTicksAr = this.getClippedMinorTicks(majorTicksAr[i], majorTicksAr[i + 1], minorIndex);
        } else {
          minorTicksAr = interval.range(+majorTicksAr[i], +majorTicksAr[i + 1] + 1, thresholdIntervals[minorIndex][1]);
        }

        timeFormat.minor = thresholdIntervals[minorIndex][0].name();

        for (j = 0, minorTicksArLen = minorTicksAr.length; j < minorTicksArLen; j++) {
          tickValue = +minorTicksAr[j];

          if (j === minorTicksArLen - 1 && minorTicksArLen > 1) {
            // If ratio of the gap between the last two minor ticks and gap between last minor tick and next
            // major tick is less than 50%, discard it. (use case: irregular days in a month)
            if (+this.distance(majorTicksAr[i + 1], tickValue) / this.distance(tickValue, +minorTicksAr[j - 1]) < 0.5) {
              continue;
            }
          } // push minor ticks which do not overlaps with the major ticks


          if (tickValue !== +majorTicksAr[i] && tickValue !== +majorTicksAr[i + 1]) {
            tickAr.push(minorTicksAr[j]);
            tickType.push(MINOR);
          }
        }
      }
    } // push the last major tick


    tickAr.push(majorTicksAr[len - 1]);
    tickType.push(MAJOR); // add context ticks to tick array

    if (contextTickAr.length && !skipInfo.context) {
      for (i = 0, len = contextTickAr.length; i < len; i++) {
        tickAr.push(contextTickAr[i]);
        tickType.push(CONTEXT);
      }
    }

    scale._tickType = [];

    for (i = 0, len = tickAr.length; i < len; i++) {
      if (tickType[i] !== MINOR) {
        tickAr[i] = (0, _clipUtils.getUnclippedValue)(tickAr[i], repeatClips, singleClips);
      }
    }

    for (i = 0, len = tickAr.length; i < len; i++) {
      if (tickType[i] === MAJOR) {
        if (tickAr[i] !== tickAr[i - 1]) {
          retTickAr.push(tickAr[i]);

          scale._tickType.push(tickType[i]);
        }
      } else {
        retTickAr.push(tickAr[i]);

        scale._tickType.push(tickType[i]);
      }
    }

    return retTickAr;
  }
  /**
   * Sets the domain of scale
   *
   * @param {array} [domain=[]] domain provided as array
   * @returns {instance} scale
   * @memberof ScaleCalendarBin
   */
  ;

  _proto.setDomain = function setDomain(domain) {
    var _ref;

    if (domain === void 0) {
      domain = [];
    }

    var curDomain = this.getDomain();
    domain[0] > domain[1] && (_ref = [domain[0], domain[1]], domain[1] = _ref[0], domain[0] = _ref[1], _ref);

    if (+curDomain[0] !== +domain[0] || +curDomain[1] !== +domain[1]) {
      _ScaleCalendar.prototype.setDomain.call(this, domain);

      this.calculateBins(domain);
    }

    return this;
  };

  _proto.calculateBins = function calculateBins(domain) {
    if (domain === void 0) {
      domain = [];
    }

    var domainStart = +domain[0],
        domainEnd = +domain[1],
        binStart,
        binEnd,
        flooredDomainStart,
        bin = this._getRangeThreshold(),
        unclippedTimeIntervals = this.getUnclippedTimeIntervals(),
        interval,
        binLength = bin && bin[2],
        newBinsAr = [],
        clipType,
        i,
        j,
        len,
        currentTimeUnit,
        firstData = this.getFirstData(),
        clippings = this.getClippings(),
        clipObj,
        applicableClippings = [],
        clipIndices = [],
        clips = [];

    if (binLength) {
      currentTimeUnit = bin[0].name();

      for (i = 0, len = clippings.length; i < len; i++) {
        clipObj = clippings[i];

        if (clipObj.to - clipObj.from >= binLength) {
          applicableClippings.push(clipObj);
        }
      }

      interval = unclippedTimeIntervals[(0, _capsFirst.default)(currentTimeUnit)] || unclippedTimeIntervals[currentTimeUnit];
      applicableClippings = this.applicableClippings = (0, _clipUtils.segregateClips)(applicableClippings);
      flooredDomainStart = binStart = +_year.default.floor((0, _pluckNumber.default)(firstData, domainStart));
      domainStart = interval.offset(new Date(domain[0]), -3 * bin[1]);
      domainEnd = interval.offset(new Date(domain[1]), 3 * bin[1]);

      if (interval.name() === 'year' || interval.name() === 'month') {
        if (binStart > domainStart) {
          while (binStart > domainStart) {
            binStart = interval.offset(binStart, -1 * bin[1]);
          }
        } else {
          while (interval.offset(binStart, bin[1]) < domainStart) {
            binStart = interval.offset(binStart, bin[1]);
          }
        }
      } else {
        binStart = new Date(Math.floor((domainStart - flooredDomainStart) / binLength) * binLength + flooredDomainStart);

        if (this.getType() !== 'UTC') {
          var winterOffset = new Date(binStart.getFullYear(), 0, 0).getTimezoneOffset(),
              summerOffset = new Date(binStart.getFullYear(), 6).getTimezoneOffset();

          if (winterOffset < summerOffset) {
            binStart = _hour.default.offset(binStart, 1);
          }
        }
      }

      binEnd = interval.offset(binStart, bin[1]);

      for (j = 0; binStart <= domainEnd; j++) {
        clipType = (0, _clipUtils.getClipType)([+binStart, +binEnd], applicableClippings.repeatClips, applicableClippings.singleClips);
        newBinsAr.push({
          clipType: clipType,
          start: binStart,
          end: binEnd
        });

        if (clipType === 2) {
          clipIndices.push(j);
        }

        clips[j] = (clips[j - 1] || 0) + (clipType === 2 ? binEnd - binStart : 0);
        binStart = interval.offset(binStart, bin[1]);
        binEnd = interval.offset(binEnd, bin[1]);
      }

      this.clips = clips;
      this.clipIndices = clipIndices;
      this.bins = newBinsAr;
      this.clippedDomain = [+domain[0], +domain[0] + this.distance(+domain[0], +domain[1])];
    }

    this.clips = clips;
    this.clipIndices = clipIndices;
    this.bins = newBinsAr;
    return this;
  };

  _proto._getBinIndex = function _getBinIndex(_value) {
    var value = +_value,
        bins = this.bins,
        clips = this.clips,
        found = false,
        binIndex,
        i;
    i = binIndex = biSearch(bins, value);

    if (bins[i] && bins[i].clipType === 2) {
      while (i < clips.length) {
        i++;

        if (clips[i] === clips[i - 1]) {
          found = true;
          break;
        }
      }

      if (!found) {
        i = binIndex;

        while (i >= 0) {
          i--;

          if (clips[i] === clips[i + 1]) {
            i += 1;
            found = true;
            break;
          }
        }
      }
    }

    return i;
  };

  _proto._getBinBounds = function _getBinBounds(index) {
    return this.bins[index] || {};
  };

  _proto.distance = function distance(_val1, _val2) {
    var val1 = Math.min(+_val1, +_val2),
        val2 = Math.max(+_val1, +_val2),
        val1Bin,
        val2Bin,
        bins = this.bins,
        leftExtendedBins = [],
        rightExtendedBins = [],
        applicableClippings = this.applicableClippings,
        curBin,
        firstBin,
        lastBin,
        interval,
        index,
        len,
        unclippedTimeIntervals = this.getUnclippedTimeIntervals(),
        binning = this._getRangeThreshold(),
        clips = this.clips,
        val1BinIndex = this._getBinIndex(val1),
        val2BinIndex = this._getBinIndex(val2),
        direction = _val1 > _val2 ? -1 : 1,
        curTime = [],
        distance = 0;

    firstBin = bins[0];
    lastBin = bins[bins.length - 1];

    if (!binning.length) {
      return direction * (val2 - val1);
    }

    if (val1BinIndex === -1 || val2BinIndex === -1) {
      interval = unclippedTimeIntervals[(0, _capsFirst.default)(binning[0].name())] || unclippedTimeIntervals[binning[0].name()];
      val1BinIndex === -1 && (val1 = (0, _clipUtils.getUnclippedValue)(+val1, applicableClippings.repeatClips, applicableClippings.singleClips));
      val2BinIndex === -1 && (val2 = (0, _clipUtils.getUnclippedValue)(+val2, applicableClippings.repeatClips, applicableClippings.singleClips));

      if (val1 < firstBin.start) {
        curBin = firstBin;

        while (val1 < curBin.start) {
          curBin = {
            start: interval.offset(curBin.start, -1 * binning[1]),
            end: curBin.start
          };
          curBin.clipType = (0, _clipUtils.getClipType)([+curBin.start, +curBin.end], applicableClippings.repeatClips, applicableClippings.singleClips);
          leftExtendedBins.push(curBin);
        }

        val1Bin = curBin;
        val1BinIndex = leftExtendedBins.length - 1;
      } else if (val1 >= lastBin.end) {
        curBin = lastBin;

        while (val2 >= curBin.end) {
          curBin = {
            end: interval.offset(curBin.end, binning[1]),
            start: curBin.end
          };
          curBin.clipType = (0, _clipUtils.getClipType)([+curBin.start, +curBin.end], applicableClippings.repeatClips, applicableClippings.singleClips);
          rightExtendedBins.push(curBin);
        }

        val1Bin = curBin;
        val1BinIndex = rightExtendedBins.length - 1;
      } else {
        val1Bin = this._getBinBounds(val1BinIndex);
      }

      index = -1;

      if (val2 < firstBin.start) {
        curBin = firstBin;

        while (val2 < curBin.start) {
          index++;

          if (!leftExtendedBins[index]) {
            curBin = {
              start: interval.offset(curBin.start, -1 * binning[1]),
              end: curBin.start
            };
            curBin.clipType = (0, _clipUtils.getClipType)([+curBin.start, +curBin.end], applicableClippings.repeatClips, applicableClippings.singleClips);
            leftExtendedBins.push(curBin);
          }

          curBin = leftExtendedBins[index];
        }

        val2Bin = curBin;
        val2BinIndex = index;
      } else if (val2 >= lastBin.end) {
        curBin = lastBin;

        while (val2 >= curBin.end) {
          index++;

          if (!rightExtendedBins[index]) {
            curBin = {
              start: curBin.end,
              end: interval.offset(curBin.end, binning[1])
            };
            curBin.clipType = (0, _clipUtils.getClipType)([+curBin.start, +curBin.end], applicableClippings.repeatClips, applicableClippings.singleClips);
            rightExtendedBins.push(curBin);
          }

          curBin = rightExtendedBins[index];
        }

        val2Bin = curBin;
        val2BinIndex = index;
      } else {
        val2Bin = this._getBinBounds(val2BinIndex);
      }

      leftExtendedBins.reverse();
      curTime = val1;

      for (index = 0, len = leftExtendedBins.length; index < len; index++) {
        curBin = leftExtendedBins[index];

        if (val1 >= curBin.start && val1 < curBin.end) {
          if (val2 < curBin.end) {
            distance += val2 - val1;
            curTime = curBin.end;
            break;
          } else {
            distance += curBin.end - val1;
          }
        } else if (val2 >= curBin.start && val2 < curBin.end) {
          distance += val2 - curBin.start;
          curTime = curBin.end;
          break;
        } else {
          distance += curBin.clipType === 2 ? 0 : curBin.end - curBin.start;
        }

        curTime = curBin.end;
      }

      if (curTime < val2 && curTime < lastBin.end) {
        for (index = 0, len = bins.length; index < len; index++) {
          curBin = bins[index];

          if (val1 >= curBin.start && val1 < curBin.end) {
            if (val2 < curBin.end) {
              distance += val2 - val1;
              curTime = curBin.end;
              break;
            } else {
              distance += curBin.end - val1;
            }
          } else if (val2 >= curBin.start && val2 < curBin.end) {
            distance += val2 - curBin.start;
            curTime = curBin.end;
            break;
          } else if (curBin.start >= val1) {
            distance += curBin.clipType === 2 ? 0 : curBin.end - curBin.start;
            curTime = curBin.end;
          }
        }
      }

      if (curTime < val2) {
        for (index = 0, len = rightExtendedBins.length; index < len; index++) {
          curBin = rightExtendedBins[index];

          if (val1 >= curBin.start && val1 < curBin.end) {
            if (val2 < curBin.end) {
              distance += val2 - val1;
              curTime = curBin.end;
              break;
            } else {
              distance += curBin.end - val1;
            }
          } else if (val2 >= curBin.start && val2 < curBin.end) {
            distance += val2 - curBin.start;
            curTime = curBin.end;
            break;
          } else if (curBin.start >= val1) {
            distance += curBin.clipType === 2 ? 0 : curBin.end - curBin.start;
            curTime = curBin.end;
          }
        }
      }
    } else {
      val1Bin = this._getBinBounds(val1BinIndex);
      val2Bin = this._getBinBounds(val2BinIndex);

      if (val1Bin.start > val1) {
        val1 = val1Bin.start;
      } else if (val1Bin.end < val1) {
        val1 = val1Bin.end;
      }

      if (val2Bin.start > val2) {
        val2 = val2Bin.start;
      } else if (val2Bin.end < val2) {
        val2 = val2Bin.end;
      }

      if (val2BinIndex - val1BinIndex <= 1) {
        return (val2 - val1) * direction;
      }

      distance += val1Bin.end - val1;
      distance += val2 - val2Bin.start;
      distance += val2Bin.start - val1Bin.end;
      distance -= clips[val2BinIndex] - clips[val1BinIndex];
    }

    return distance * direction;
  };

  _proto.offset = function offset(domainStart, distance) {
    var remainingMS = Math.abs(+distance),
        curTimeStamp = +domainStart,
        curBinIndex = this._getBinIndex(curTimeStamp),
        startBin = this._getBinBounds(curBinIndex),
        bins = this.bins,
        unclippedTimeIntervals = this.getUnclippedTimeIntervals(),
        applicableClippings = this.applicableClippings,
        interval,
        binStart,
        binEnd,
        binning = this._getRangeThreshold(),
        curBin,
        len = this.clipIndices.length;

    if (!len) {
      return Number(domainStart) + Number(distance);
    }

    if (distance >= 0) {
      if (+startBin.start > curTimeStamp) {
        curTimeStamp = +startBin.start;
      }

      if (curTimeStamp + remainingMS < startBin.end) {
        return curTimeStamp + remainingMS;
      }

      remainingMS -= +startBin.end - curTimeStamp;
      curTimeStamp = +startBin.end;
      curBinIndex++;

      for (; curBinIndex < bins.length; curBinIndex++) {
        curBin = bins[curBinIndex];

        if (curBin.clipType !== 2) {
          if (remainingMS >= curBin.end - curBin.start) {
            remainingMS -= curBin.end - curBin.start;
            curTimeStamp = +curBin.end;
          } else {
            curTimeStamp += remainingMS;
            remainingMS = 0;
            break;
          }
        } else {
          curTimeStamp = +curBin.end;
        }
      }
    } else {
      if (+startBin.end < curTimeStamp) {
        curTimeStamp = +startBin.end;
      }

      if (curTimeStamp - remainingMS >= startBin.start) {
        return curTimeStamp - remainingMS;
      }

      remainingMS -= curTimeStamp - startBin.start;
      curTimeStamp = startBin.start;
      interval = unclippedTimeIntervals[(0, _capsFirst.default)(binning[0].name())] || unclippedTimeIntervals[binning[0].name()];
      curBin = startBin;

      while (remainingMS) {
        binStart = interval.offset(curBin.start, -1 * binning[1]);
        binEnd = curBin.start;
        curBin = {
          start: binStart,
          end: binEnd,
          clipType: (0, _clipUtils.getClipType)([+binStart, +binEnd], applicableClippings.repeatClips, applicableClippings.singleClips)
        };

        if (curBin.clipType !== 2) {
          if (remainingMS >= curBin.end - curBin.start) {
            remainingMS -= curBin.end - curBin.start;
            curTimeStamp = +curBin.start;
          } else {
            curTimeStamp -= remainingMS;
            remainingMS = 0;
          }
        } else {
          curTimeStamp = +curBin.start;
        }
      }
    }

    return curTimeStamp;
  };

  _proto.nice = function nice(interval, count) {
    var scale = _ScaleCalendar.prototype.nice.call(this, interval, count);

    this._computeRangeThreshold(DEFAULT_THRESHOLD_PIXELS);

    return scale;
  }
  /**
   * formats the time based on bin size
   *
   * @param {Object} [dateInfo={}] Object containing start and end date information
   * @param {any} customFormat custom Formatting provided by user
   * @returns formatted string
   * @memberof ScaleCalendarBin
   */
  ;

  _proto.getFormattedTime = function getFormattedTime(dateInfo, customFormat) {
    if (dateInfo === void 0) {
      dateInfo = {};
    }

    var scale = this,
        thresHold = scale._getRangeThreshold(),
        currentGrouping,
        timeFormat1,
        timeFormat2,
        dateRange = dateInfo.dateRange,
        timeFormatter,
        type = dateInfo.type,
        d1,
        d2,
        d1Str,
        d2Str,
        isSameDay,
        isSameMonth,
        isSameYear,
        language = dateInfo.language,
        multiplier = thresHold[1],
        scaleType = scale.getType();

    if (type === 'crossline' || type === 'tooltip') {
      currentGrouping = thresHold[0].name();

      if (customFormat && customFormat[currentGrouping]) {
        // if custom formatting is present, use it
        timeFormat1 = timeFormat2 = customFormat[currentGrouping];
        timeFormatter = scaleType === 'UTC' ? _timeConverter.default.utcFormatter(timeFormat1) : _timeConverter.default.formatter(timeFormat1);
        d1Str = timeFormatter.format(new Date(dateRange.startDate));

        if (multiplier > 1) {
          // for multiplier > 1, a range needs to be shown
          timeFormatter = scaleType === 'UTC' ? _timeConverter.default.utcFormatter(timeFormat2) : _timeConverter.default.formatter(timeFormat1);
          d2Str = timeFormatter.format(new Date(dateRange.endDate));
          return d1Str + ' - ' + d2Str;
        }

        return d1Str;
      } // Applying logic for showing date upto the current minimum binning level


      timeFormat1 = timeFormat2 = (0, _timeBucket.getFilterdTimeFormat)('%b %d, %Y, %I:%M:%S.%L %p', currentGrouping);

      if (currentGrouping === 'hour') {
        timeFormat1 = timeFormat1.replace(/%M/, '');
        timeFormat2 = timeFormat2.replace(/%M/, '');
      }

      timeFormat1 = timeFormat1.replace(/[:|.]*[\s]/g, ' ');
      timeFormat2 = timeFormat2.replace(/[:|.]*[\s]/g, ' ');

      if (!timeFormat1.match(/%I/)) {
        dateRange.endDate -= 1;
        timeFormat1 = timeFormat1.replace(/%p/, '');
        timeFormat2 = timeFormat2.replace(/%p/, '');
      } // Formating the range date to be shown


      d1 = new Date(dateRange.startDate);
      d2 = new Date(dateRange.endDate);
      isSameDay = dateAPI(d1, 'Date', scaleType) === dateAPI(d2, 'Date', scaleType);
      isSameMonth = dateAPI(d1, 'Month', scaleType) === dateAPI(d2, 'Month', scaleType);
      isSameYear = dateAPI(d1, 'FullYear', scaleType) === dateAPI(d2, 'FullYear', scaleType);

      if (multiplier > 1) {
        if (isSameYear) {
          if (isSameMonth) {
            if (isSameDay) {
              if (!timeFormat1.match(/%I/)) {
                timeFormat1 = timeFormat1.replace(/%b/, '%B');
                timeFormat2 = BLANK;
              } else {
                timeFormat1 = timeFormat1.replace(/%p/, ''); // 30

                timeFormat2 = timeFormat2.replace(/%b/, '');
                timeFormat2 = timeFormat2.replace(/%d/, '');
                timeFormat2 = timeFormat2.replace(/%Y/, '');
              }
            } else {
              timeFormat1 = timeFormat1.replace(/%Y/, '');

              if (!timeFormat1.match(/%I/)) {
                timeFormat2 = timeFormat2.replace(/%b/, '');
                timeFormat1 = timeFormat1.replace(/%b/, '%B');
              }
            }
          } else {
            if (multiplier !== 1) {
              timeFormat1 = timeFormat1.replace(/%Y/, '');
            }
          }
        }
      } else {
        if (!timeFormat1.match(/%I/)) {
          timeFormat1 = timeFormat1.replace(/%b/, '%B');
        }
      }

      timeFormat1 = timeFormat1.trim();
      timeFormat2 = timeFormat2.trim(); // Making sure the time formatter does not ends with special character
      // Making sure the time formatter does not starts with special character

      timeFormat1 = timeFormat1.replace(/^[,|\s|:]*/, '').replace(/(\W+$)/, '').replace(/([,]+[\s]*[,]+)|([\s]+[,]+)/g, ',');
      timeFormat2 = timeFormat2.replace(/^[,|\s|:]*/, '').replace(/(\W+$)/, '').replace(/([,]+[\s]*[,]+)|([\s]+[,]+)/g, ',');

      if (!timeFormat2 || multiplier === 1) {
        timeFormatter = scaleType === 'UTC' ? _timeConverter.default.utcFormatter(timeFormat1) : _timeConverter.default.formatter(timeFormat1);
        d1Str = timeFormatter.format(new Date(dateRange.startDate));
        return d1Str.trim();
      }

      timeFormatter = scaleType === 'UTC' ? _timeConverter.default.utcFormatter(timeFormat1) : _timeConverter.default.formatter(timeFormat1);
      d1Str = timeFormatter.format(new Date(dateRange.startDate));
      timeFormatter = scaleType === 'UTC' ? _timeConverter.default.utcFormatter(timeFormat2) : _timeConverter.default.formatter(timeFormat2);
      d2Str = timeFormatter.format(new Date(dateRange.endDate));
      return (d1Str + ' - ' + d2Str).trim();
    } else if (type === 'CRS') {
      d1Str = "" + getFullDate(dateRange.startDate, scaleType, language) + (dateInfo.showTimeInLabel ? ", " + getFullTime(dateRange.startDate, scaleType) : '');
      d2Str = "" + getFullDate(dateRange.endDate, scaleType, language) + (dateInfo.showTimeInLabel ? ", " + getFullTime(dateRange.endDate, scaleType) : '');
      return (d1Str + ' - ' + d2Str).trim();
    }
  };

  _proto.setBinMin = function setBinMin(minBin) {
    this.minBin = minBin;
    return this;
  };

  _proto.getBinMin = function getBinMin() {
    return this.minBin;
  };

  _proto.setRangeThreshold = function setRangeThreshold(threshold) {
    this._threshold = threshold;
    return this;
  };

  _proto._getRangeThreshold = function _getRangeThreshold() {
    return this._threshold || [];
  }
  /**
   * setter method for scale mode
   *
   * @param {any} mode mode
   * @memberof ScaleCalendarBin
   */
  ;

  _proto.setMode = function setMode(mode) {
    this.mode = mode;
  }
  /**
   * getter method for scale mode
   *
   * @returns {String} mode
   * @memberof ScaleCalendarBin
   */
  ;

  _proto.getMode = function getMode() {
    return this.mode;
  }
  /**
   * setter method for custom threshold intervals
   *
   * @param {any} intervals intervals
   * @memberof ScaleCalendarBin
   */
  ;

  _proto.setThresholdIntervals = function setThresholdIntervals(intervals) {
    this.thresholdIntervals = intervals; // calculate the first index of major time intervals(day, month etc)

    this.calculateIndexOfIntervals();
    return this;
  };

  _proto.setFirstData = function setFirstData(val) {
    this.binStart = val;
    return this;
  };

  _proto.getFirstData = function getFirstData() {
    return this.binStart;
  };

  _proto.copy = function copy() {
    return copyScaleBin(this, new ScaleCalendarBin());
  };

  return ScaleCalendarBin;
}(_calendar.default);

var _default = ScaleCalendarBin;
exports["default"] = _default;

/***/ }),

/***/ 870:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _continuous = _interopRequireWildcard(__webpack_require__(542));

var _number = _interopRequireDefault(__webpack_require__(535));

var _ticks = _interopRequireWildcard(__webpack_require__(871));

var _enUS = _interopRequireDefault(__webpack_require__(367));

var _timeConverter = __webpack_require__(350);

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var durationSecond = 1000,
    durationMinute = durationSecond * 60,
    durationHour = durationMinute * 60,
    durationDay = durationHour * 24,
    durationWeek = durationDay * 7,
    durationMonth = durationDay * 30,
    durationYear = durationDay * 365,
    date = function date(d) {
  return new Date(d);
},
    number = function number(n) {
  return n instanceof Date ? +n : +new Date(+n);
},
    _nice = function nice(domain, interval) {
  var d = domain.slice();
  var firstDomainIdx = 0,
      lastDomainIdx = d.length - 1,
      firstDomainElem = d[firstDomainIdx],
      lastDomainElem = d[lastDomainIdx],
      temp;

  if (lastDomainElem < firstDomainElem) {
    temp = firstDomainIdx;
    firstDomainIdx = lastDomainIdx;
    lastDomainIdx = temp;
    temp = firstDomainElem;
    firstDomainElem = lastDomainElem;
    lastDomainElem = temp;
  }

  d[firstDomainIdx] = interval.floor(firstDomainElem);
  d[lastDomainIdx] = interval.ceil(lastDomainElem);
  return d;
};

var ScaleCalendar = /*#__PURE__*/function (_ScaleContinuous) {
  (0, _inheritsLoose2.default)(ScaleCalendar, _ScaleContinuous);

  function ScaleCalendar(year, month, week, day, hour, minute, second, millisecond) {
    var _this;

    _this = _ScaleContinuous.call(this, _continuous.deInterpolateLinear, _number.default) || this;
    _this.timeIntervals = {
      year: year,
      month: month,
      week: week,
      day: day,
      hour: hour,
      minute: minute,
      second: second,
      millisecond: millisecond
    };
    _this.unclippedTimeIntervals = {
      year: year,
      month: month,
      week: week,
      day: day,
      hour: hour,
      minute: minute,
      second: second,
      millisecond: millisecond
    };
    _this.tickIntervals = [[_this.timeIntervals.second, 1, durationSecond], [_this.timeIntervals.second, 5, 5 * durationSecond], [_this.timeIntervals.second, 15, 15 * durationSecond], [_this.timeIntervals.second, 30, 30 * durationSecond], [_this.timeIntervals.minute, 1, durationMinute], [_this.timeIntervals.minute, 5, 5 * durationMinute], [_this.timeIntervals.minute, 15, 15 * durationMinute], [_this.timeIntervals.minute, 30, 30 * durationMinute], [_this.timeIntervals.hour, 1, durationHour], [_this.timeIntervals.hour, 3, 3 * durationHour], [_this.timeIntervals.hour, 6, 6 * durationHour], [_this.timeIntervals.hour, 12, 12 * durationHour], [_this.timeIntervals.day, 1, durationDay], [_this.timeIntervals.day, 2, 2 * durationDay], [_this.timeIntervals.week, 1, durationWeek], [_this.timeIntervals.month, 1, durationMonth], [_this.timeIntervals.month, 3, 3 * durationMonth], [_this.timeIntervals.year, 1, durationYear]];
    _this.locale = _enUS.default;
    _this._localeConverter = new _timeConverter.TimeConverter(_enUS.default);
    return _this;
  }

  var _proto = ScaleCalendar.prototype;

  _proto.setDomain = function setDomain(domain) {
    return _ScaleContinuous.prototype.setDomain.call(this, domain.map(number));
  };

  _proto.setTimeInterval = function setTimeInterval(timeIntervals) {
    this.timeIntervals = timeIntervals;
  };

  _proto.setUnclippedTimeIntervals = function setUnclippedTimeIntervals(unclippedTimeIntervals) {
    this.unclippedTimeIntervals = unclippedTimeIntervals;
  };

  _proto.getDomain = function getDomain() {
    return _ScaleContinuous.prototype.getDomain.call(this).map(date);
  };

  _proto.ticks = function ticks(interval, count) {
    var domain = _ScaleContinuous.prototype.getDomain.call(this);

    return (0, _ticks.default)(domain[0], domain[domain.length - 1], interval, count, this.tickIntervals, this.timeIntervals);
  };

  _proto.nice = function nice(interval, count) {
    var d = _ScaleContinuous.prototype.getDomain.call(this),
        i = (0, _ticks.tickInterval)(d[0], d[d.length - 1], interval, count, this.tickIntervals, this.timeIntervals);

    return i ? _ScaleContinuous.prototype.setDomain.call(this, _nice(d, i)) : this;
  };

  _proto.getDomainValue = function getDomainValue(range) {
    return new Date(_ScaleContinuous.prototype.getDomainValue.call(this, range));
  };

  _proto.setLocale = function setLocale(locale) {
    if (locale === void 0) {
      locale = _enUS.default;
    }

    this.locale = locale;
    this._localeConverter = new _timeConverter.TimeConverter(this.locale);
    return this;
  };

  _proto.copy = function copy() {
    var _this$timeIntervals = this.timeIntervals,
        year = _this$timeIntervals.year,
        month = _this$timeIntervals.month,
        week = _this$timeIntervals.week,
        day = _this$timeIntervals.day,
        hour = _this$timeIntervals.hour,
        minute = _this$timeIntervals.minute,
        second = _this$timeIntervals.second,
        millisecond = _this$timeIntervals.millisecond;
    return (0, _continuous.copyScale)(this, new ScaleCalendar(year, month, week, day, hour, minute, second, millisecond));
  };

  return ScaleCalendar;
}(_continuous.default);

var _default = ScaleCalendar;
exports["default"] = _default;

/***/ }),

/***/ 865:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _log = _interopRequireDefault(__webpack_require__(866));

var _ticks = _interopRequireDefault(__webpack_require__(558));

var UNDEF;

var Log = /*#__PURE__*/function (_FcLog) {
  (0, _inheritsLoose2.default)(Log, _FcLog);

  function Log() {
    return _FcLog.apply(this, arguments) || this;
  }

  var _proto = Log.prototype;

  _proto.ticks = function ticks(noOfTicks) {
    var _this$getDomain = this.getDomain(),
        min = _this$getDomain[0],
        max = _this$getDomain[1],
        maxLogY,
        isReverse = 0,
        minLogY,
        iniValue,
        checkValue,
        divLines = [],
        _tickType = [],
        divLineValue,
        r,
        i,
        j,
        count = 0,
        slabInterval,
        subInterval,
        interimDivLineValue,
        lastDivLine,
        base = this.base,
        baseWithRespectTo10 = Math.log(base) / Math.log(10),
        d = base > 1 ? -1 : 1,
        numMinorTicks = baseWithRespectTo10 % 1 ? 4 : 8;

    if (min <= 0 || max <= 0) {
      return divLines;
    }

    if (min > max) {
      var _this$getDomain2 = this.getDomain();

      max = _this$getDomain2[0];
      min = _this$getDomain2[1];
      isReverse = 1;
    } // for base greater than one


    if (base > 1) {
      maxLogY = Math.ceil(Math.log(max) / Math.log(base));
      minLogY = Math.floor(Math.log(min) / Math.log(base));
      checkValue = maxLogY;
      iniValue = minLogY;
    } else if (base > 0 && base < 1) {
      maxLogY = Math.floor(Math.log(max) / Math.log(base));
      minLogY = Math.ceil(Math.log(min) / Math.log(base));
      checkValue = minLogY;
      iniValue = maxLogY;
    }

    r = minLogY;

    for (i = iniValue; i <= checkValue; ++i) {
      // Select the major divLines
      // Conditions for major div lines:
      // 1. If y-axis is inverted and div value is not the very first one
      //    (the lowest one coinciding with x-axis)
      // OR
      // 2. If y-axis is not inverted and div value is not the very last one
      //    (the lowest one coinciding with x-axis)
      // if ((invertYAxis && r != maxLogY) || !(invertYAxis || i == checkValue)) {
      // Get the numerical value of div line by getting power of base.
      divLineValue = this.pows(r); // Create the div line object
      // conditional to avoid plot of major divLines and their axis labels beyond plot area

      if (typeof lastDivLine !== 'undefined') {
        // for base greater than one
        if (base > 1) {
          maxLogY = Math.ceil(Math.log(divLineValue) / Math.log(base));
        } else if (base > 0 && base < 1) {
          maxLogY = Math.floor(Math.log(divLineValue) / Math.log(base));
        } // Multiplication factor
        // For base <1, powers go in negative -0.1 is 10^-1, 0.001 is 10 ^ -3 and so on.
        // Numeric interval between two succesive major divLines (variable)


        slabInterval = Math.pow(base, maxLogY) - Math.pow(base, maxLogY + d); // Numeric interval between two succesive minor divLines (variable) in between 2
        // successive major divLines

        subInterval = slabInterval / (numMinorTicks + 1);

        for (j = 1; j <= numMinorTicks; ++j) {
          // Get the numeric value for minor div line
          // By adding the sub-interval to power of base (of major div line)
          interimDivLineValue = Math.pow(base, maxLogY + d) + subInterval * j; // if (min <= interimDivLineValue && max >= interimDivLineValue) {

          divLines.push(interimDivLineValue);

          _tickType.push('minor'); // }


          if (min > interimDivLineValue || max < interimDivLineValue) {
            ++count;
          }
        }
      } // if (min <= divLineValue && max >= divLineValue) {


      divLines.push(divLineValue);

      _tickType.push('major'); // }


      if (min > divLineValue || max < divLineValue) {
        ++count;
      }

      lastDivLine = divLineValue; // Update counter corresponding to next major divLine w.r.t. base value

      if (base > 1) {
        r++;
      } else {
        r--;
      }
    }

    this._tickType = _tickType; // when ticks are not enough then linear ticks are generated.

    if (divLines.length - count <= 2) {
      divLines = (0, _ticks.default)(min, max, noOfTicks);
      this._tickType = UNDEF;
    }

    return this.majorTicks = isReverse ? divLines.reverse() : divLines;
  };

  return Log;
}(_log.default);

var _default = Log;
exports["default"] = _default;

/***/ }),

/***/ 855:
/***/ ((__unused_webpack_module, exports) => {



exports.__esModule = true;
exports["default"] = void 0;

/* eslint require-jsdoc: 'error', valid-jsdoc: 'error' */
var DEFAULT_UNKNOWN = 'implicit';
/**
 * Ordainal class which maps ordered items to the range
 */

var ScaleOrdinal = /*#__PURE__*/function () {
  /**
   * constructs the class with default value
   */
  function ScaleOrdinal() {
    this.unknown = DEFAULT_UNKNOWN;
    this.domain = [];
    this.ordinalRange = [];
    this.map = new Map();
  }
  /**
   * sets the domain with unique values and creates its mapping
   * @param {Array} inputArr is the input array contianig the domian
   * @return {Object} instance of scale
   */


  var _proto = ScaleOrdinal.prototype;

  _proto.setDomain = function setDomain(inputArr) {
    if (inputArr === void 0) {
      inputArr = [];
    }

    var i, domainVal, domainValStr;
    this.domain = [];
    this.map.clear();

    for (i = 0; i < inputArr.length; ++i) {
      domainVal = inputArr[i];
      domainValStr = domainVal.toString();

      if (!this.map.has(domainVal)) {
        this.map.set(domainValStr, this.domain.push(domainVal));
      }
    }

    return this;
  }
  /**
   * returns the currnet domain
   * @return {Array} domain array
   */
  ;

  _proto.getDomain = function getDomain() {
    return this.domain.slice();
  }
  /**
   * sets the range
   * @param {Array} inputArr is the input array contianig the range
   * @return {Object} instance of scale
   */
  ;

  _proto.setRange = function setRange(inputArr) {
    this.ordinalRange = inputArr.slice();
    return this;
  }
  /**
   * returns the currnet range
   * @return {Array} range array
   */
  ;

  _proto.getRange = function getRange() {
    return this.ordinalRange.slice();
  }
  /**
   * sets the output value of the scale for unknown input values
   * @param {any} unknown any value
   * @return {Object} instance of the class
   */
  ;

  _proto.setUnknown = function setUnknown(unknown) {
    this.unknown = unknown;
    return this;
  }
  /**
   * return the unknown value which is by default implicit,
   * thi implicit value enables implicit domain contruction
   * @return {any} unknown
   */
  ;

  _proto.getUnknown = function getUnknown() {
    return this.unknown;
  }
  /**
   * returns a new instance of the class with same domain, range and unkown value
   * @return {Object} new instance
   */
  ;

  _proto.copy = function copy() {
    return new ScaleOrdinal().setDomain(this.getDomain()).setRange(this.getRange()).setUnknown(this.geUnknownn());
  }
  /**
   * gives the range value corresponding to a domain
   * @param {any} domainKey a value
   * @return {any} corresponding range value
   */
  ;

  _proto.getRangeValue = function getRangeValue(domainKey) {
    var map = this.map,
        domainKeyStr = domainKey.toString(),
        range = this.getRange(),
        value = map.get(domainKeyStr);

    if (!value) {
      if (this.getUnknown() !== DEFAULT_UNKNOWN) {
        return this.getUnknown();
      }

      value = this.domain.push(domainKey);
      map.set(domainKeyStr, value);
    }

    return range[(value - 1) % range.length];
  };

  _proto.getType = function getType() {
    return 'ordinal';
  };

  return ScaleOrdinal;
}();

var _default = ScaleOrdinal;
exports["default"] = _default;

/***/ }),

/***/ 868:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _timeIntervals = __webpack_require__(490);

var _calendarBin = _interopRequireWildcard(__webpack_require__(869));

var _time = __webpack_require__(875);

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var ScaleTimeBin = /*#__PURE__*/function (_ScaleCalendarBin) {
  (0, _inheritsLoose2.default)(ScaleTimeBin, _ScaleCalendarBin);

  function ScaleTimeBin() {
    var _this;

    _this = _ScaleCalendarBin.call(this, _timeIntervals.timeYear, _timeIntervals.timeMonth, _timeIntervals.timeWeek, _timeIntervals.timeDay, _timeIntervals.timeHour, _timeIntervals.timeMinute, _timeIntervals.timeSecond, _timeIntervals.timeMillisecond) || this;

    _this.setTimeFormat();

    _this.setDomain([].concat(_time.TIME_SPAN));

    return _this;
  }

  var _proto = ScaleTimeBin.prototype;

  _proto.getType = function getType() {
    return '';
  }
  /**
   * sets the time formatter strings
   *
   * @param {*} [format={}] Object containing format string
   * @memberof ScaleTimeBin
   */
  ;

  _proto.setTimeFormat = function setTimeFormat(format) {
    if (format === void 0) {
      format = {};
    }

    var localeConverter = this._localeConverter,
        _format = format,
        millisecond = _format.millisecond,
        second = _format.second,
        minute = _format.minute,
        hour = _format.hour,
        day = _format.day,
        week = _format.week,
        month = _format.month,
        year = _format.year;
    this.formatters = {
      millisecond: {
        major: localeConverter.formatter(millisecond || '%I:%M:%S.%L %p'),
        minor: localeConverter.formatter(millisecond || '%L ms'),
        context: localeConverter.formatter(millisecond || '%b %d, %Y, %I:%M:%S.%L %p')
      },
      second: {
        major: localeConverter.formatter(second || '%I:%M:%S %p'),
        minor: localeConverter.formatter(second || '%S s'),
        context: localeConverter.formatter(second || '%b %d, %Y, %I:%M:%S %p')
      },
      minute: {
        major: localeConverter.formatter(minute || '%I:%M %p'),
        minor: localeConverter.formatter(minute || '%M m'),
        context: localeConverter.formatter(minute || '%b %d, %Y, %I:%M %p')
      },
      hour: {
        major: localeConverter.formatter(hour || '%I %p'),
        minor: localeConverter.formatter(hour || '%I %p'),
        context: localeConverter.formatter(hour || '%b %d, %Y, %I %p')
      },
      day: {
        major: localeConverter.formatter(day || '%b %d'),
        minor: localeConverter.formatter(day || '%d'),
        context: localeConverter.formatter(day || '%b %d, %Y')
      },
      week: {
        major: localeConverter.formatter(week || '%b %d'),
        minor: localeConverter.formatter(week || '%d'),
        context: localeConverter.formatter(week || '%b %d, %Y')
      },
      month: {
        major: localeConverter.formatter(month || '%b'),
        minor: localeConverter.formatter(month || '%b'),
        context: localeConverter.formatter(month || '%b %Y')
      },
      year: {
        major: localeConverter.formatter(year || '%Y'),
        minor: localeConverter.formatter(year || '%Y'),
        context: localeConverter.formatter(year || '%Y')
      }
    };
  };

  _proto.setTimeInterval = function setTimeInterval(timeIntervals) {
    this.timeIntervals = timeIntervals;

    _ScaleCalendarBin.prototype.setTimeInterval.call(this, timeIntervals);
  };

  _proto.setUnclippedTimeIntervals = function setUnclippedTimeIntervals(unclippedTimeIntervals) {
    this.unclippedTimeIntervals = unclippedTimeIntervals;

    _ScaleCalendarBin.prototype.setUnclippedTimeIntervals.call(this, unclippedTimeIntervals);
  };

  _proto.getTimeInterval = function getTimeInterval() {
    return this.timeIntervals;
  };

  _proto.getUnclippedTimeIntervals = function getUnclippedTimeIntervals() {
    return this.unclippedTimeIntervals;
  }
  /**
   * formats the date as per specified formatter strings
   *
   * @param {any} specifier specifier string
   * @returns {function} instance of timeConverter
   * @memberof ScaleTimeBin
   */
  ;

  _proto.tickFormat = function tickFormat(specifier) {
    var _this2 = this;

    return specifier ? function (d) {
      return _this2._localeConverter.formatter(specifier).format(d);
    } : function (d, type, tickType) {
      /**
       * if scale provides with a formatter string, use it to format the given date
       * else use from the default formatters.
       */
      if (_this2._timeFormat[type]) {
        return _this2._localeConverter.formatter(_this2._timeFormat[type]).format(d);
      }

      return _this2.formatters[type][tickType].format(d);
    };
  };

  _proto.copy = function copy() {
    return (0, _calendarBin.copyScaleBin)(this, new ScaleTimeBin());
  };

  return ScaleTimeBin;
}(_calendarBin.default);

var _default = ScaleTimeBin;
exports["default"] = _default;

/***/ }),

/***/ 878:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _continuous = __webpack_require__(542);

var _timeIntervals = __webpack_require__(490);

var _calendar = _interopRequireDefault(__webpack_require__(870));

var _ticks = __webpack_require__(871);

var ScaleTime = /*#__PURE__*/function (_ScaleCalendar) {
  (0, _inheritsLoose2.default)(ScaleTime, _ScaleCalendar);

  function ScaleTime() {
    var _this;

    _this = _ScaleCalendar.call(this, _timeIntervals.timeYear, _timeIntervals.timeMonth, _timeIntervals.timeWeek, _timeIntervals.timeDay, _timeIntervals.timeHour, _timeIntervals.timeMinute, _timeIntervals.timeSecond, _timeIntervals.timeMillisecond) || this;
    _this.formatters = {
      millisecond: _this._localeConverter.formatter('.%L'),
      second: _this._localeConverter.formatter(':%S'),
      minute: _this._localeConverter.formatter('%I:%M'),
      hour: _this._localeConverter.formatter('%I %p'),
      day: _this._localeConverter.formatter('%a %d'),
      week: _this._localeConverter.formatter('%b %d'),
      month: _this._localeConverter.formatter('%B'),
      year: _this._localeConverter.formatter('%Y')
    };

    _this.setDomain([new Date(2000, 0, 1), new Date(2000, 0, 2)]);

    return _this;
  }

  var _proto = ScaleTime.prototype;

  _proto.tickFormat = function tickFormat(specifier) {
    var _this2 = this;

    return specifier ? function (d) {
      return _this2._localeConverter.formatter(specifier).format(d);
    } : function (d) {
      return (0, _ticks.tickFormat)(_this2.timeIntervals, _this2.formatters, d);
    };
  };

  _proto.copy = function copy() {
    return (0, _continuous.copyScale)(this, new ScaleTime());
  };

  return ScaleTime;
}(_calendar.default);

var _default = ScaleTime;
exports["default"] = _default;

/***/ }),

/***/ 876:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _utc = __webpack_require__(497);

var _continuous = __webpack_require__(542);

var _calendarBin = _interopRequireDefault(__webpack_require__(869));

var _time = __webpack_require__(875);

// import { tickFormat } from '../time-intervals/ticks';
var ScaleUtcBin = /*#__PURE__*/function (_ScaleCalendarBin) {
  (0, _inheritsLoose2.default)(ScaleUtcBin, _ScaleCalendarBin);

  function ScaleUtcBin() {
    var _this;

    _this = _ScaleCalendarBin.call(this, _utc.utcYear, _utc.utcMonth, _utc.utcWeek, _utc.utcDay, _utc.utcHour, _utc.utcMinute, _utc.utcSecond, _utc.utcMillisecond) || this;

    _this.setTimeFormat();

    _this.setDomain([].concat(_time.UTC_TIME_SPAN));

    return _this;
  }

  var _proto = ScaleUtcBin.prototype;

  _proto.getType = function getType() {
    return 'UTC';
  };

  _proto.setTimeInterval = function setTimeInterval(timeIntervals) {
    this.timeIntervals = timeIntervals;

    _ScaleCalendarBin.prototype.setTimeInterval.call(this, timeIntervals);
  }
  /**
   * sets the time formatter strings
   *
   * @param {*} [format={}] Object containing format string
   * @memberof ScaleUtcBin
   */
  ;

  _proto.setTimeFormat = function setTimeFormat(format) {
    if (format === void 0) {
      format = {};
    }

    var localeConverter = this._localeConverter,
        _format = format,
        millisecond = _format.millisecond,
        second = _format.second,
        minute = _format.minute,
        hour = _format.hour,
        day = _format.day,
        week = _format.week,
        month = _format.month,
        year = _format.year;
    this.formatters = {
      millisecond: {
        major: localeConverter.utcFormatter(millisecond || '%I:%M:%S.%L %p'),
        minor: localeConverter.utcFormatter(millisecond || '%L ms'),
        context: localeConverter.utcFormatter(millisecond || '%b %d, %Y, %I:%M:%S.%L %p')
      },
      second: {
        major: localeConverter.utcFormatter(second || '%I:%M:%S %p'),
        minor: localeConverter.utcFormatter(second || '%S s'),
        context: localeConverter.utcFormatter(second || '%b %d, %Y, %I:%M:%S %p')
      },
      minute: {
        major: localeConverter.utcFormatter(minute || '%I:%M %p'),
        minor: localeConverter.utcFormatter(minute || '%M m'),
        context: localeConverter.utcFormatter(minute || '%b %d, %Y, %I:%M %p')
      },
      hour: {
        major: localeConverter.utcFormatter(hour || '%I %p'),
        minor: localeConverter.utcFormatter(hour || '%I %p'),
        context: localeConverter.utcFormatter(hour || '%b %d, %Y, %I %p')
      },
      day: {
        major: localeConverter.utcFormatter(day || '%b %d'),
        minor: localeConverter.utcFormatter(day || '%d'),
        context: localeConverter.utcFormatter(day || '%b %d, %Y')
      },
      week: {
        major: localeConverter.formatter(week || '%b %d'),
        minor: localeConverter.formatter(week || '%d'),
        context: localeConverter.formatter(week || '%b %d, %Y')
      },
      month: {
        major: localeConverter.utcFormatter(month || '%b'),
        minor: localeConverter.utcFormatter(month || '%b'),
        context: localeConverter.utcFormatter(month || '%b %Y')
      },
      year: {
        major: localeConverter.utcFormatter(year || '%Y'),
        minor: localeConverter.utcFormatter(year || '%Y'),
        context: localeConverter.utcFormatter(year || '%Y')
      }
    };
  }
  /**
   * formats the date as per specified formatter strings
   *
   * @param {any} specifier specifier string
   * @returns {function} instance of timeConverter
   * @memberof ScaleTimeBin
   */
  ;

  _proto.tickFormat = function tickFormat(specifier) {
    var _this2 = this;

    return specifier ? function (d) {
      return _this2._localeConverter.utcFormatter(specifier).format(d);
    } : function (d, type, tickType) {
      /**
       * if scale provides with a formatter string, use it to format the given date
       * else use from the default formatters.
       */
      if (_this2._timeFormat[type]) {
        return _this2._localeConverter.utcFormatter(_this2._timeFormat[type]).format(d);
      }

      return _this2.formatters[type][tickType].format(d);
    };
  };

  _proto.getUnclippedTimeIntervals = function getUnclippedTimeIntervals() {
    return this.unclippedTimeIntervals;
  };

  _proto.setUnclippedTimeIntervals = function setUnclippedTimeIntervals(unclippedTimeIntervals) {
    this.unclippedTimeIntervals = unclippedTimeIntervals;

    _ScaleCalendarBin.prototype.setUnclippedTimeIntervals.call(this, unclippedTimeIntervals);
  };

  _proto.copy = function copy() {
    return (0, _continuous.copyScale)(this, new ScaleUtcBin());
  };

  return ScaleUtcBin;
}(_calendarBin.default);

var _default = ScaleUtcBin;
exports["default"] = _default;

/***/ }),

/***/ 879:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _utc = __webpack_require__(497);

var _calendar = _interopRequireDefault(__webpack_require__(870));

var _continuous = __webpack_require__(542);

var _ticks = __webpack_require__(871);

var ScaleUtc = /*#__PURE__*/function (_ScaleCalendar) {
  (0, _inheritsLoose2.default)(ScaleUtc, _ScaleCalendar);

  function ScaleUtc() {
    var _this;

    _this = _ScaleCalendar.call(this, _utc.utcYear, _utc.utcMonth, _utc.utcWeek, _utc.utcDay, _utc.utcHour, _utc.utcMinute, _utc.utcSecond, _utc.utcMillisecond) || this;
    _this.formatters = {
      millisecond: _this._localeConverter.utcFormatter('.%L'),
      second: _this._localeConverter.utcFormatter(':%S'),
      minute: _this._localeConverter.utcFormatter('%I:%M'),
      hour: _this._localeConverter.utcFormatter('%I %p'),
      day: _this._localeConverter.utcFormatter('%a %d'),
      week: _this._localeConverter.utcFormatter('%b %d'),
      month: _this._localeConverter.utcFormatter('%B'),
      year: _this._localeConverter.utcFormatter('%Y')
    };

    _this.setDomain([[Date.UTC(2000, 0, 1), Date.UTC(2000, 0, 2)]]);

    return _this;
  }

  var _proto = ScaleUtc.prototype;

  _proto.tickFormat = function tickFormat(specifier) {
    var _this2 = this;

    return specifier ? function (d) {
      return _this2._localeConverter.utcFormatter(specifier).format(d);
    } : function (d) {
      return (0, _ticks.tickFormat)(_this2.timeIntervals, _this2.formatters, d);
    };
  };

  _proto.copy = function copy() {
    return (0, _continuous.copyScale)(this, new ScaleUtc());
  };

  return ScaleUtc;
}(_calendar.default);

var _default = ScaleUtc;
exports["default"] = _default;

/***/ }),

/***/ 914:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _path = _interopRequireDefault(__webpack_require__(915));

var _constant = _interopRequireDefault(__webpack_require__(544));

var _linear = _interopRequireDefault(__webpack_require__(916));

var _lineGenerator = _interopRequireDefault(__webpack_require__(917));

var AreaGenerator = /*#__PURE__*/function () {
  function AreaGenerator() {
    this.xTopAccessor = function (d) {
      return d[0];
    };

    this.xBaseAccessor = null;
    this.yTopAccessor = (0, _constant.default)(0);

    this.yBaseAccessor = function (d) {
      return d[1];
    };

    this.isDefined = (0, _constant.default)(true);
    this.Curve = _linear.default;
    this.ctx = null;
    this._output = null;
  }

  var _proto = AreaGenerator.prototype;

  _proto.generate = function generate(data) {
    if (data === void 0) {
      data = [];
    }

    var n = data.length,
        defined0 = false,
        xBases = new Array(n),
        yBases = new Array(n),
        i,
        j,
        k,
        d,
        buffer;

    if (this.ctx === null || typeof this.ctx === 'undefined') {
      buffer = new _path.default();
      this._output = new this.Curve(buffer);
    }

    for (i = 0; i <= n; ++i) {
      d = data[i];

      if (!(i < n && this.isDefined(d, i, data)) === defined0) {
        defined0 = !defined0;

        if (defined0) {
          j = i;

          this._output.areaStart();

          this._output.lineStart();
        } else {
          this._output.lineEnd();

          this._output.lineStart();

          for (k = i - 1; k >= j; --k) {
            this._output.point(xBases[k], yBases[k]);
          }

          this._output.lineEnd();

          this._output.areaEnd();
        }
      }

      if (defined0) {
        xBases[i] = +this.xTopAccessor(d, i, data);
        yBases[i] = +this.yTopAccessor(d, i, data);

        this._output.point(this.xBaseAccessor ? +this.xBaseAccessor(d, i, data) : xBases[i], this.yBaseAccessor ? +this.yBaseAccessor(d, i, data) : yBases[i]);
      }
    } // Reference: https://www.w3.org/TR/SVG/paths.html#PathDataBNF
    // Quote: "Note that the EBNF allows the path data string in the d property to be empty. This is not an error, instead it disables rendering of the path. Rendering is also disabled when the d property has the value none."
    // Going with the empty string option since "none" or null does not exactly match the given EBNF in the SVG spec (although "none" is a part of the written specification)


    if (buffer) {
      this._output = null;
      return buffer.toString();
    }
  };

  _proto.setXAccessor = function setXAccessor(accessor) {
    if (accessor === void 0) {
      accessor = function accessor(d) {
        return d[0];
      };
    }

    this.xTopAccessor = typeof accessor === 'function' ? accessor : (0, _constant.default)(+accessor);
    this.xBaseAccessor = null;
    return this;
  };

  _proto.getXAccessor = function getXAccessor() {
    return this.xTopAccessor;
  };

  _proto.setXTopAccessor = function setXTopAccessor(accessor) {
    if (accessor === void 0) {
      accessor = function accessor(d) {
        return d[0];
      };
    }

    this.xTopAccessor = typeof accessor === 'function' ? accessor : (0, _constant.default)(+accessor);
    return this;
  };

  _proto.getXTopAccessor = function getXTopAccessor() {
    return this.xTopAccessor;
  };

  _proto.setXBaseAccessor = function setXBaseAccessor(accessor) {
    if (accessor === null || typeof accessor === 'undefined') {
      this.xBaseAccessor = null;
    } else {
      this.xBaseAccessor = typeof accessor === 'function' ? accessor : (0, _constant.default)(+accessor);
    }

    return this;
  };

  _proto.getXBaseAccessor = function getXBaseAccessor() {
    return this.xBaseAccessor;
  };

  _proto.setYAccessor = function setYAccessor(accessor) {
    if (accessor === void 0) {
      accessor = function accessor(d) {
        return d[1];
      };
    }

    this.yTopAccessor = typeof accessor === 'function' ? accessor : (0, _constant.default)(+accessor);
    this.yBaseAccessor = null;
    return this;
  };

  _proto.getYAccessor = function getYAccessor() {
    return this.yTopAccessor;
  };

  _proto.setYTopAccessor = function setYTopAccessor(accessor) {
    if (accessor === void 0) {
      accessor = function accessor(d) {
        return d[1];
      };
    }

    this.yTopAccessor = typeof accessor === 'function' ? accessor : (0, _constant.default)(+accessor);
    return this;
  };

  _proto.getYTopAccessor = function getYTopAccessor() {
    return this.yTopAccessor;
  };

  _proto.setYBaseAccessor = function setYBaseAccessor(accessor) {
    if (accessor === null || typeof accessor === 'undefined') {
      this.yBaseAccessor = null;
    } else {
      this.yBaseAccessor = typeof accessor === 'function' ? accessor : (0, _constant.default)(+accessor);
    }

    return this;
  };

  _proto.getYBaseAccessor = function getYBaseAccessor() {
    return this.yBaseAccessor;
  };

  _proto.setDefined = function setDefined(isDefined) {
    if (isDefined === void 0) {
      isDefined = (0, _constant.default)(true);
    }

    this.isDefined = typeof isDefined === 'function' ? isDefined : (0, _constant.default)(!!isDefined);
    return this;
  };

  _proto.getDefined = function getDefined() {
    return this.isDefined;
  };

  _proto.setCurve = function setCurve(Curve) {
    if (Curve === void 0) {
      Curve = _linear.default;
    }

    this.Curve = Curve;

    if (this.ctx !== null && typeof this.ctx !== 'undefined') {
      this._output = new this.Curve(this.ctx);
    }

    return this;
  };

  _proto.getCurve = function getCurve() {
    return this.Curve;
  };

  _proto.setContext = function setContext(ctx) {
    if (ctx === null || typeof ctx === 'undefined') {
      this.ctx = null;
      this._output = this._ctx;
    } else {
      this.ctx = ctx;
      this._output = new this.Curve(this.ctx);
    }

    return this;
  };

  _proto.getContext = function getContext() {
    return this.ctx;
  };

  _proto._areaLine = function _areaLine() {
    return new _lineGenerator.default().setDefined(this.isDefined).setCurve(this.Curve).setContext(this.ctx);
  };

  _proto.getLineXBase = function getLineXBase() {
    return this._areaLine().setXAccessor(this.xTopAccessor).setYAccessor(this.yTopAccessor);
  };

  _proto.getLineYBase = function getLineYBase() {
    return this._areaLine().setXAccessor(this.xTopAccessor).setYAccessor(this.yTopAccessor);
  };

  _proto.getLineYTop = function getLineYTop() {
    return this._areaLine().setXAccessor(this.xTopAccessor).setYAccessor(this.yTopAccessor);
  };

  _proto.getLineXTop = function getLineXTop() {
    return this._areaLine().setXAccessor(this.xBaseAccessor).setYAccessor(this.yBaseAccessor);
  };

  return AreaGenerator;
}();

var _default = AreaGenerator;
exports["default"] = _default;

/***/ }),

/***/ 916:
/***/ ((__unused_webpack_module, exports) => {



exports.__esModule = true;
exports["default"] = void 0;

var CurveLinear = /*#__PURE__*/function () {
  function CurveLinear(ctx) {
    this._ctx = ctx;
  }

  var _proto = CurveLinear.prototype;

  _proto.areaStart = function areaStart() {
    this._line = 0;
  };

  _proto.areaEnd = function areaEnd() {
    this._line = NaN;
  };

  _proto.lineStart = function lineStart() {
    this._point = 0;
  };

  _proto.lineEnd = function lineEnd() {
    if (this._line || this._line !== 0 && this._point === 1) {
      this._ctx.closePath();
    }

    this._line = 1 - this._line;
  };

  _proto.point = function point(_x, _y) {
    var x = +_x,
        y = +_y;

    switch (this._point) {
      case 0:
        this._point = 1;
        this._line ? this._ctx.lineTo(x, y) : this._ctx.moveTo(x, y);
        break;

      case 1:
        this._point = 2;
      // falls through

      default:
        this._ctx.lineTo(x, y);

    }
  };

  return CurveLinear;
}();

var _default = CurveLinear;
exports["default"] = _default;

/***/ }),

/***/ 919:
/***/ ((__unused_webpack_module, exports) => {



exports.__esModule = true;
exports["default"] = void 0;

var getSign = function getSign(x) {
  return x < 0 ? -1 : 1;
};

var CurveMonotoneX = /*#__PURE__*/function () {
  function CurveMonotoneX(ctx) {
    this._ctx = ctx;
  }

  var _proto = CurveMonotoneX.prototype;

  _proto.areaStart = function areaStart() {
    this._line = 0;
  };

  _proto.areaEnd = function areaEnd() {
    this._line = NaN;
  };

  _proto.lineStart = function lineStart() {
    this._x0 = this._x1 = NaN;
    this._y0 = this._y1 = NaN; // Tangent of the knot

    this._t0 = NaN;
    this._point = 0;
  };

  _proto.lineEnd = function lineEnd() {
    switch (this._point) {
      case 2:
        this._ctx.lineTo(this._x1, this._y1);

        break;

      case 3:
        this._monotoneCurveTo(this._t0, this._slope2(this._t0));

        break;
    }

    if (this._line || this._line !== 0 && this._point === 1) this._ctx.closePath();
    this._line = 1 - this._line;
  };

  _proto.point = function point(_x, _y) {
    var t1 = NaN,
        x = +_x,
        y = +_y;
    if (x === this._x1 && y === this._y1) return; // Co-incident points are ignored

    switch (this._point) {
      case 0:
        this._point = 1;
        this._line ? this._ctx.lineTo(x, y) : this._ctx.moveTo(x, y);
        break;

      case 1:
        this._point = 2;
        break;

      case 2:
        this._point = 3;
        t1 = this._slope3(x, y);

        this._monotoneCurveTo(this._slope2(t1), t1);

        break;

      default:
        t1 = this._slope3(x, y);

        this._monotoneCurveTo(this._t0, t1);

    }

    this._x0 = this._x1;
    this._x1 = x;
    this._y0 = this._y1;
    this._y1 = y;
    this._t0 = t1;
  };

  _proto._monotoneCurveTo = function _monotoneCurveTo(t0, t1) {
    var x0 = this._x0,
        y0 = this._y0,
        x1 = this._x1,
        y1 = this._y1,
        dx = (x1 - x0) / 3; // Refer https://en.wikipedia.org/wiki/Cubic_Hermite_spline#Representations
    // Quote: "express cubic Hermite interpolation in terms of cubic BÃ©zier curves
    // with respect to four values p0, p0 + (m0 / 3), p1 - (m1 / 3), p1".

    this._ctx.bezierCurveTo(x0 + dx, y0 + dx * t0, x1 - dx, y1 - dx * t1, x1, y1);
  };

  _proto._slope2 = function _slope2(tangent) {
    // Calculate one-sided slope using the given tangent
    var h = this._x1 - this._x0;
    return h ? (3 * (this._y1 - this._y0) / h - tangent) / 2 : tangent;
  };

  _proto._slope3 = function _slope3(x2, y2) {
    // Calculate slopes of the tangents (Hermite-type interpolation) based on
    // the paper "Steffen, M. 1990. A Simple Method for Monotonic
    // Interpolation in One Dimension. Astronomy and Astrophysics, Vol. 239, NO.
    // NOV(II), P. 443, 1990"
    var h0 = this._x1 - this._x0,
        h1 = x2 - this._x1,
        s0 = (this._y1 - this._y0) / (h0 || h1 < 0 && -0),
        s1 = (y2 - this._y1) / (h1 || h0 < 0 && -0),
        p = (s0 * h1 + s1 * h0) / (h0 + h1);
    return (getSign(s0) + getSign(s1)) * Math.min(Math.abs(s0), Math.abs(s1), 0.5 * Math.abs(p)) || 0;
  };

  return CurveMonotoneX;
}();

var _default = CurveMonotoneX;
exports["default"] = _default;

/***/ }),

/***/ 918:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = exports.StepAfter = exports.StepBefore = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var Step = /*#__PURE__*/function () {
  function Step(ctx, factor) {
    if (factor === void 0) {
      factor = 0.5;
    }

    this._ctx = ctx;
    this._factor = factor;
  }

  var _proto = Step.prototype;

  _proto.areaStart = function areaStart() {
    this._line = 0;
  };

  _proto.areaEnd = function areaEnd() {
    this._line = NaN;
  };

  _proto.lineStart = function lineStart() {
    this._x = this._y = NaN;
    this._point = 0;
  };

  _proto.lineEnd = function lineEnd() {
    if (this._factor > 0 && this._factor < 1 && this._point === 2) {
      this._ctx.lineTo(this._x, this._y);
    }

    if (this._line || this._line !== 0 && this._point === 1) {
      this._ctx.closePath();
    }

    if (this._line >= 0) {
      this._factor = 1 - this._factor;
      this._line = 1 - this._line;
    }
  };

  _proto.point = function point(_x, _y) {
    var x = +_x,
        y = +_y;

    switch (this._point) {
      case 0:
        this._point = 1;

        if (this._line) {
          this._ctx.lineTo(x, y);
        } else {
          this._ctx.moveTo(x, y);
        }

        break;

      case 1:
        this._point = 2;
      // fallthrough

      default:
        if (this._factor <= 0) {
          this._ctx.lineTo(this._x, y);

          this._ctx.lineTo(x, y);
        } else {
          var x1 = this._x * (1 - this._factor) + x * this._factor;

          this._ctx.lineTo(x1, this._y);

          this._ctx.lineTo(x1, y);
        }

    }

    this._x = x;
    this._y = y;
  };

  return Step;
}();

var StepAfter = /*#__PURE__*/function (_Step) {
  (0, _inheritsLoose2.default)(StepAfter, _Step);

  function StepAfter(ctx) {
    return _Step.call(this, ctx, 1) || this;
  }

  return StepAfter;
}(Step);

exports.StepAfter = StepAfter;

var StepBefore = /*#__PURE__*/function (_Step2) {
  (0, _inheritsLoose2.default)(StepBefore, _Step2);

  function StepBefore(ctx) {
    return _Step2.call(this, ctx, 0) || this;
  }

  return StepBefore;
}(Step);

exports.StepBefore = StepBefore;
var _default = Step;
exports["default"] = _default;

/***/ }),

/***/ 917:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _path = _interopRequireDefault(__webpack_require__(915));

var _constant = _interopRequireDefault(__webpack_require__(544));

var _linear = _interopRequireDefault(__webpack_require__(916));

var LineGenerator = /*#__PURE__*/function () {
  function LineGenerator() {
    this.xAccessor = function (d) {
      return d[0];
    };

    this.yAccessor = function (d) {
      return d[1];
    };

    this.isDefined = (0, _constant.default)(true);
    this.Curve = _linear.default;
    this.ctx = null;
    this._output = null;
  }

  var _proto = LineGenerator.prototype;

  _proto.generate = function generate(data) {
    if (data === void 0) {
      data = [];
    }

    var i = 0,
        n = data.length,
        datum,
        lineStarted,
        buffer;

    if (this.ctx === null || typeof this.ctx === 'undefined') {
      buffer = new _path.default();
      this._output = new this.Curve(buffer);
    }

    for (i = 0; i <= n; ++i) {
      datum = data[i];

      if (!lineStarted) {
        if (i < n && this.isDefined(datum, i, data)) {
          lineStarted = true;

          this._output.lineStart();

          this._output.point(this.xAccessor(datum, i, data), this.yAccessor(datum, i, data));
        }
      } else if (i < n && this.isDefined(datum, i, data)) {
        this._output.point(this.xAccessor(datum, i, data), this.yAccessor(datum, i, data));
      } else {
        this._output.lineEnd();

        lineStarted = false;
      }
    } // Reference: https://www.w3.org/TR/SVG/paths.html#PathDataBNF
    // Quote: "Note that the EBNF allows the path data string in the d property to be empty. This is not an error, instead it disables rendering of the path. Rendering is also disabled when the d property has the value none."
    // Going with the empty string option since "none" or null does not exactly match the given EBNF in the SVG spec (although "none" is a part of the written specification)


    if (buffer) {
      this._output = null;
      return buffer.toString();
    }
  };

  _proto.setXAccessor = function setXAccessor(accessor) {
    if (accessor === void 0) {
      accessor = function accessor(d) {
        return d[0];
      };
    }

    this.xAccessor = typeof accessor === 'function' ? accessor : (0, _constant.default)(+accessor);
    return this;
  };

  _proto.getXAccessor = function getXAccessor() {
    return this.xAccessor;
  };

  _proto.setYAccessor = function setYAccessor(accessor) {
    if (accessor === void 0) {
      accessor = function accessor(d) {
        return d[1];
      };
    }

    this.yAccessor = typeof accessor === 'function' ? accessor : (0, _constant.default)(+accessor);
    return this;
  };

  _proto.getYAccessor = function getYAccessor() {
    return this.yAccessor;
  };

  _proto.setDefined = function setDefined(isDefined) {
    if (isDefined === void 0) {
      isDefined = (0, _constant.default)(true);
    }

    this.isDefined = typeof isDefined === 'function' ? isDefined : (0, _constant.default)(!!isDefined);
    return this;
  };

  _proto.getDefined = function getDefined() {
    return this.isDefined;
  };

  _proto.setCurve = function setCurve(Curve) {
    if (Curve === void 0) {
      Curve = _linear.default;
    }

    this.Curve = Curve;

    if (typeof this.ctx !== 'undefined' || this.ctx !== null) {
      this._output = new this.Curve(this.ctx);
    }

    return this;
  };

  _proto.getCurve = function getCurve() {
    return this.Curve;
  };

  _proto.setContext = function setContext(ctx) {
    if (ctx === null || typeof ctx === 'undefined') {
      this.ctx = null;
      this._output = this.ctx;
    } else {
      this.ctx = ctx;
      this._output = new this.Curve(this.ctx);
    }

    return this;
  };

  _proto.getContext = function getContext() {
    return this.ctx;
  };

  return LineGenerator;
}();

var _default = LineGenerator;
exports["default"] = _default;

/***/ }),

/***/ 915:
/***/ ((__unused_webpack_module, exports) => {



exports.__esModule = true;
exports["default"] = void 0;
var epsilon = 1e-6,
    pi = Math.PI,
    tau = 2 * pi,
    Z = 'Z',
    BLANK = '',
    tauEpsilon = tau - epsilon;

var Path = /*#__PURE__*/function () {
  function Path() {
    this._clear();
  }

  var _proto = Path.prototype;

  _proto.moveTo = function moveTo(x, y) {
    this._x0 = this._x1 = +x;
    this._y0 = this._y1 = +y;
    this.pathStr += "M" + this._x0 + "," + this._y0;
  };

  _proto.lineTo = function lineTo(x, y) {
    this._x1 = +x;
    this._y1 = +y;
    this.pathStr += "L" + this._x1 + "," + this._y1;
  };

  _proto.quadraticCurveTo = function quadraticCurveTo(_cpx, _cpy, x, y) {
    this._x1 = +x;
    this._y1 = +y;
    var cpx = +_cpx,
        cpy = +_cpy;
    this.pathStr += "Q" + cpx + "," + cpy + "," + this._x1 + "," + this._y1;
  };

  _proto.bezierCurveTo = function bezierCurveTo(_cp1x, _cp1y, _cp2x, _cp2y, x, y) {
    this._x1 = +x;
    this._y1 = +y;
    var cp1x = +_cp1x,
        cp1y = +_cp1y,
        cp2x = +_cp2x,
        cp2y = +_cp2y;
    this.pathStr += "C" + cp1x + "," + cp1y + "," + cp2x + "," + cp2y + "," + this._x1 + "," + this._y1;
  };

  _proto.rect = function rect(x, y, _w, _h) {
    var path = this,
        w = +_w,
        h = +_h;
    path._x0 = path._x1 = +x;
    path._y0 = path._y1 = +y;
    path.pathStr += "M" + path._x0 + "," + path._y0 + "h" + w + "v" + h + "h" + -w + "Z";
  };

  _proto.arcTo = function arcTo(_x1, _y1, _x2, _y2, _radius) {
    var path = this,
        dx20,
        dy20,
        dx21,
        dy21,
        dx01,
        dy01,
        xy012,
        xy01,
        xy202,
        xy212,
        xy21,
        t01,
        t21,
        xy,
        x0,
        y0,
        x1 = +_x1,
        x2 = +_x2,
        y1 = +_y1,
        y2 = +_y2,
        radius = +_radius;
    x0 = path._x1;
    y0 = path._y1;
    dx21 = x2 - x1;
    dy21 = y2 - y1;
    dx01 = x0 - x1;
    dy01 = y0 - y1;
    xy012 = dx01 * dx01 + dy01 * dy01; // Is the radius negative? Set it to zero.

    radius = Math.max(radius, 0);

    if (this._x1 === null) {
      // Is the path empty? Move to (x1, y1).
      this._x1 = x1;
      this._y1 = y1;
      this.pathStr += "M" + this._x1 + "," + this._y1;
    } else if (!(xy012 > epsilon)) {// Else, is (x1,y1) coincident with (x0,y0)? Do nothing.
    } else if (!(Math.abs(dy01 * dx21 - dy21 * dx01) > epsilon) || !radius) {
      // Else, are (x0,y0), (x1,y1) and (x2,y2) collinear?
      // And, equivalently, is (x1,y1) coincident with (x2,y2)?
      // Or, is the radius zero? Line to (x1,y1).
      this._x1 = x1;
      this._y1 = y1;
      this.pathStr += "L" + this._x1 + "," + this._y1;
    } else {
      // Otherwise draw an arc.
      dx20 = x2 - x0;
      dy20 = y2 - y0;
      xy212 = dx21 * dx21 + dy21 * dy21;
      xy202 = dx20 * dx20 + dy20 * dy20;
      xy21 = Math.sqrt(xy212);
      xy01 = Math.sqrt(xy012);
      xy = radius * Math.tan((pi - Math.acos((xy212 + xy012 - xy202) / (2 * xy21 * xy01))) / 2);
      t01 = xy / xy01;
      t21 = xy / xy21; // If the start tangent is not coincident with (x0,y0), draw a line.

      if (Math.abs(t01 - 1) > epsilon) {
        this.pathStr += "L" + (x1 + t01 * dx01) + "," + (y1 + t01 * dy01);
      }

      this._x1 = x1 + t21 * dx21;
      this._y1 = y1 + t21 * dy21;
      this.pathStr += "A" + radius + "," + radius + ",0,0," + +(dy01 * dx20 > dx01 * dy20) + "," + this._x1 + "," + this._y1;
    }
  };

  _proto.arc = function arc(_x, _y, _radius, _startAngle, _endAngle, _counterclockwise) {
    if (_counterclockwise === void 0) {
      _counterclockwise = false;
    }

    var x = +_x,
        y = +_y,
        radius = +_radius,
        startAngle = +_startAngle,
        endAngle = +_endAngle,
        counterclockwise = !!_counterclockwise,
        path = this,
        dx = radius * Math.cos(startAngle),
        dy = radius * Math.sin(startAngle),
        x0 = x + dx,
        y0 = y + dy,
        cw = Number(!counterclockwise),
        da = counterclockwise ? startAngle - endAngle : endAngle - startAngle; // Is the radius negative? Set it to zero.

    Math.max(radius, 0);

    if (path._x1 === null) {
      // Is this path empty? Move to (x0,y0).
      path.pathStr += "M" + x0 + "," + y0;
    } else if (Math.abs(path._x1 - x0) > epsilon || Math.abs(path._y1 - y0) > epsilon) {
      // Else, is (x0,y0) not coincident with the previous point? Line to (x0,y0).
      path.pathStr += "L" + x0 + "," + y0;
    } // Is this arc empty? Nothing to be done.


    if (!radius) return; // Does the angle go the wrong way? Flip the direction.

    if (da < 0) da = da % tau + tau;

    if (da > tauEpsilon) {
      // Is this a complete circle? Draw two arcs to complete the circle.
      path._x1 = x0;
      path._y1 = y0;
      path.pathStr += "A" + radius + "," + radius + ",0,1," + cw + "," + (x - dx) + "," + (y - dy);
      path.pathStr += "A" + radius + "," + radius + ",0,1," + cw + "," + path._x1 + "," + path._y1;
    } else if (da > epsilon) {
      // Is this arc non-empty? Finally, draw an arc.
      path._x1 = x + radius * Math.cos(endAngle);
      path._y1 = y + radius * Math.sin(endAngle);
      path.pathStr += "A" + radius + "," + radius + ",0," + +(da >= pi) + "," + cw + "," + path._x1 + "," + path._y1;
    }
  };

  _proto.closePath = function closePath() {
    if (this._x1 !== null) {
      this._x1 = this._x0;
      this._y1 = this._y0;
      this.pathStr += Z;
    }
  };

  _proto.toString = function toString() {
    return this.pathStr;
  };

  _proto._clear = function _clear() {
    this._x0 = this._y0 = this._x1 = this._y1 = null;
    this.pathStr = BLANK;
  };

  return Path;
}();

var _default = Path;
exports["default"] = _default;

/***/ }),

/***/ 933:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _isArray = _interopRequireDefault(__webpack_require__(349));

var _constant = _interopRequireDefault(__webpack_require__(544));

var _default2 = _interopRequireDefault(__webpack_require__(934));

var _default3 = _interopRequireDefault(__webpack_require__(935));

var stackValue = function stackValue(d, key) {
  return d[key];
};

var StackGenerator = /*#__PURE__*/function () {
  function StackGenerator() {
    this.keysAccessor = (0, _constant.default)([]);
    this.order = _default2.default;
    this.offset = _default3.default;
    this.valueAccessor = stackValue;
  }

  var _proto = StackGenerator.prototype;

  _proto.generate = function generate(data) {
    var keys = this.keysAccessor(data),
        i,
        jj = data.length,
        ii = keys.length,
        series = new Array(ii),
        orders;

    for (i = 0; i < ii; ++i) {
      var ki = keys[i],
          si = new Array(jj),
          sij = void 0,
          j = void 0;
      series[i] = si;

      for (j = 0; j < jj; ++j) {
        sij = [0, +this.valueAccessor(data[j], ki, j, data)];
        sij.data = data[j];
        si[j] = sij;
      }

      si.key = ki;
    }

    orders = this.order(series);

    for (i = 0; i < ii; ++i) {
      series[orders[i]].index = i;
    }

    this.offset(series, orders);
    return series;
  };

  _proto.setKeysAccessor = function setKeysAccessor(accessor) {
    if (accessor === void 0) {
      accessor = (0, _constant.default)([]);
    }

    this.keysAccessor = typeof accessor === 'function' ? accessor : (0, _constant.default)((0, _isArray.default)(accessor) ? accessor.slice() : []);
    return this;
  };

  _proto.getKeysAccessor = function getKeysAccessor() {
    return this.keysAccessor;
  };

  _proto.setValueAccessor = function setValueAccessor(accessor) {
    if (accessor === void 0) {
      accessor = stackValue;
    }

    this.valueAccessor = typeof accessor === 'function' ? accessor : (0, _constant.default)(+accessor);
    return this;
  };

  _proto.getValueAccessor = function getValueAccessor() {
    return this.valueAccessor;
  };

  _proto.setOrder = function setOrder(order) {
    if (order === void 0) {
      order = _default2.default;
    }

    this.order = typeof order === 'function' ? order : (0, _constant.default)((0, _isArray.default)(order) ? order.slice() : []);
    return this;
  };

  _proto.getOrder = function getOrder() {
    return this.order;
  };

  _proto.setOffset = function setOffset(offset) {
    if (offset === void 0) {
      offset = _default3.default;
    }

    this.offset = offset;
    return this;
  };

  _proto.getOffset = function getOffset() {
    return this.offset;
  };

  return StackGenerator;
}();

var _default = StackGenerator;
exports["default"] = _default;

/***/ }),

/***/ 935:
/***/ ((__unused_webpack_module, exports) => {



exports.__esModule = true;
exports["default"] = void 0;

var _default = function _default(series, order) {
  var ii = series.length;

  if (ii > 1) {
    var s1 = series[order[0]],
        jj = s1.length,
        s0,
        i,
        j;

    for (i = 1; i < ii; ++i) {
      s0 = s1;
      s1 = series[order[i]];

      for (j = 0; j < jj; ++j) {
        s1[j][0] = isNaN(s0[j][1]) ? s0[j][0] : s0[j][1];
        s1[j][1] += s1[j][0];
      }
    }
  }
};

exports["default"] = _default;

/***/ }),

/***/ 936:
/***/ ((__unused_webpack_module, exports) => {



exports.__esModule = true;
exports["default"] = void 0;

var _default = function _default(series, order) {
  var ii = series.length;

  if (ii > 1) {
    var jj = series[order[0]].length,
        i = 0,
        j = 0,
        data,
        diff,
        amtPositive,
        amtNegative;

    for (j = 0; j < jj; ++j) {
      amtNegative = 0;
      amtPositive = amtNegative;

      for (i = 0; i < ii; ++i) {
        data = series[order[i]][j];
        diff = data[1] - data[0];

        if (diff >= 0) {
          data[0] = amtPositive;
          amtPositive += diff;
          data[1] = amtPositive;
        } else if (diff < 0) {
          data[1] = amtNegative;
          amtNegative += diff;
          data[0] = amtNegative;
        } else {
          data[0] = amtPositive;
        }
      }
    }
  }
};

exports["default"] = _default;

/***/ }),

/***/ 937:
/***/ ((__unused_webpack_module, exports) => {



exports.__esModule = true;
exports["default"] = void 0;

var _default = function _default(series, order) {
  var ii = series.length;

  if (ii > 1) {
    var s1 = series[order[0]],
        jj = s1.length,
        s0,
        i,
        j;

    for (i = 0; i < s1.length; i++) {
      s1[i][0] = null;
    }

    for (i = 1; i < ii; ++i) {
      s0 = s1;
      s1 = series[order[i]];

      for (j = 0; j < jj; ++j) {
        s1[j][0] = isNaN(s0[j][1]) ? s0[j][0] : s0[j][1];
        s1[j][1] += s1[j][0];
      }
    }
  }
};

exports["default"] = _default;

/***/ }),

/***/ 934:
/***/ ((__unused_webpack_module, exports) => {



exports.__esModule = true;
exports["default"] = void 0;

var _default = function _default(series) {
  var n = series.length;
  var o = new Array(n);

  while (--n >= 0) {
    o[n] = n;
  }

  return o;
};

exports["default"] = _default;

/***/ }),

/***/ 862:
/***/ ((__unused_webpack_module, exports) => {



exports.__esModule = true;
exports["default"] = void 0;

var _default = function _default(str) {
  if (str === void 0) {
    str = '';
  }

  return str.charAt(0).toUpperCase() + str.slice(1);
};

exports["default"] = _default;

/***/ }),

/***/ 874:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports.getMinPlaceHolder = getMinPlaceHolder;
exports.getPlaceHolderIndex = getPlaceHolderIndex;
exports.getFilterdTimeFormat = getFilterdTimeFormat;

var _pads = _interopRequireDefault(__webpack_require__(352));

/**
 * This file helps in the bucketting of a given time into various slots
 */
var dashToLast = function dashToLast(a, b) {
  return a === '-' ? 1 : b === '-' ? -1 : 0;
},
    BLANK = '',
    VALID_PAD = "%[" + Object.keys(_pads.default).sort(dashToLast).join('') + "]?",

/**
 * Given a token string, creates a RegEx from it which matches all valid
 * time padding modifiers.
 * @param {String} token The time specifier token whcih needs to be converted
 *                       into a regular expression
 * @return A regular expression which matches any valid padded or non-padded
 *         time specifier token
 */
regexCreator = function regexCreator(token) {
  return new RegExp("" + VALID_PAD + token);
},

/**
 * Accepts an object and returns an object of a similar structure except that
 * the token strings within it are changed to RegExes.
 * @param {Object} obj An object mapping time interval names to applicable
 *                     time specifier tokens
 * @return {Object} An object mapping time interval names to applicable
 *                  time specifier tokens regular expressions
 */
regexify = function regexify(obj) {
  var regexedObj = {};
  var interval = BLANK;

  for (interval in obj) {
    if (obj.hasOwnProperty(interval)) {
      regexedObj[interval] = obj[interval].map(regexCreator);
    }
  }

  return regexedObj;
};

var timeOrderArr = ['millisecond', 'second', 'minute', 'hour', 'day', 'week', 'month', 'year'],
    timeOrderObj = {
  'millisecond': 0,
  'second': 1,
  'minute': 2,
  'hour': 3,
  'day': 4,
  'week': 5,
  'month': 5,
  'year': 6
},
    // Here hour and minute are given same preference because if aggregation is in
// minutes level then to show minute
// This makes sense 12:00
// And not 12
minimumPlaceHolderObj = {
  'millisecond': 0,
  'second': 1,
  'minute': 2,
  'hour': 2,
  'day': 4,
  'week': 4,
  'month': 5,
  'year': 6
},
    // Map a supported time interval name to all of its possible format specifier
// token regexes
placeHolderMap = regexify({
  millisecond: ['L', 'Q'],
  second: ['S', 's'],
  minute: ['M'],
  hour: ['H', 'I', 'p'],
  day: ['d', 'e', 'j', 'a', 'A'],
  week: ['d', 'e', 'j', 'a', 'A'],
  month: ['b', 'B', 'm'],
  year: ['y', 'Y']
}),
    len = timeOrderArr.length;
/**
 * Function to get the minimum timeStamp in a given string of time placeholders
 * @param {String} timeString Conatins time placeholders
 */

function getMinPlaceHolder(timeString) {
  if (timeString === void 0) {
    timeString = '';
  }

  var i, j, currentPlaceHolder, currentPlaceHolderLen; // Running loop from minimum timeplaceholder to maximum

  for (i = 0; i < len; i++) {
    currentPlaceHolder = placeHolderMap[timeOrderArr[i]];
    currentPlaceHolderLen = currentPlaceHolder.length;

    for (j = 0; j < currentPlaceHolderLen; j++) {
      if (timeString.match(currentPlaceHolder[j])) {
        return timeOrderArr[i];
      }
    }
  }
}
/**
 * Function to get the index of timeStamp in increasing order
 * @param {String} placeHolder conatains the timeStamp
 */


function getPlaceHolderIndex(placeHolder) {
  return timeOrderObj[placeHolder];
}
/**
 * Function to filter out the non applicable placeholder
 * (that is the placeholder larger than the minimumPlaceHolder)
 * from the given format
 * @param {String} _format conatins mix and match of placeHolders
 * @param {String} minimumPlaceHolder the minimum placeHolder
 */


function getFilterdTimeFormat(_format, minimumPlaceHolder) {
  if (_format === void 0) {
    _format = '';
  }

  var upto = minimumPlaceHolderObj[minimumPlaceHolder],
      currentPlaceHolder,
      format = _format,
      callBack = function callBack(element) {
    format = format.replace(element, '');
  },
      i; // Removing all the non needed timeformatters


  for (i = 0; i < upto; i++) {
    currentPlaceHolder = placeHolderMap[timeOrderArr[i]];
    currentPlaceHolder.forEach(callBack);
  } // Removing (:,) at the end of the string or (,) at the start of the string, if any


  return format.replace(/(\W+$)/, '').replace(/^,/, '');
}

/***/ }),

/***/ 871:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = exports.tickFormat = exports.tickInterval = void 0;

var _bisector = _interopRequireDefault(__webpack_require__(872));

var _ticks = __webpack_require__(559);

var DURATION_YEAR = 31536000000,
    // 1000 ms * 60 s * 60 m * 24 h * 365 d
tickInterval = function tickInterval(start, stop, interval, count, tickIntervals, timeIntervals) {
  if (interval === void 0) {
    interval = 10;
  }

  var i = interval,
      c = count,
      idx,
      target,
      tickNum; // If tick count is specified, use a reasonable tick interval
  // based on the domain's extent and an estimated tick size.
  // Else assume that the interval is already a time interval and use it.

  if (typeof i === 'number') {
    target = Math.abs(stop - start) / i;
    tickNum = (0, _bisector.default)(function (n) {
      return n[2];
    }).right(tickIntervals, target);

    if (tickNum === tickIntervals.length) {
      c = (0, _ticks.tickStep)(start / DURATION_YEAR, stop / DURATION_YEAR, i);
      i = timeIntervals.year;
    } else if (tickNum) {
      if (target / tickIntervals[tickNum - 1][2] < tickIntervals[tickNum][2] / target) {
        idx = tickNum - 1;
      } else {
        idx = tickNum;
      }

      tickNum = tickIntervals[idx];
      c = tickNum[1];
      i = tickNum[0];
    } else {
      c = Math.max((0, _ticks.tickStep)(start, stop, i), 1);
      i = timeIntervals.millisecond;
    }
  }

  return c === null || typeof c === 'undefined' ? i : i.every(c);
},
    timeTicks = function timeTicks(_start, _stop, interval, count, tickIntervals, timeIntervals) {
  var start = _start,
      stop = _stop,
      isReverse = stop < start,
      temp,
      ticks;

  if (isReverse) {
    temp = start;
    start = stop;
    stop = temp;
  }

  ticks = tickInterval(start, stop, interval, count, tickIntervals, timeIntervals);
  ticks = ticks ? ticks.range(start, stop + 1) : [];
  return isReverse ? ticks.reverse() : ticks;
},
    tickFormat = function tickFormat(intervals, formatters, date) {
  var formatter;

  if (intervals.second.floor(date) < date) {
    formatter = formatters.millisecond;
  } else if (intervals.minute.floor(date) < date) {
    formatter = formatters.second;
  } else if (intervals.hour.floor(date) < date) {
    formatter = formatters.minute;
  } else if (intervals.day.floor(date) < date) {
    formatter = formatters.hour;
  } else if (intervals.month.floor(date) < date) {
    if (intervals.week.floor(date) < date) {
      formatter = formatters.day;
    } else {
      formatter = formatters.week;
    }
  } else if (intervals.year.floor(date) < date) {
    formatter = formatters.month;
  } else {
    formatter = formatters.year;
  }

  return formatter.format(date);
};

exports.tickFormat = tickFormat;
exports.tickInterval = tickInterval;
var _default = timeTicks;
exports["default"] = _default;

/***/ }),

/***/ 927:
/***/ ((__unused_webpack_module, exports) => {



exports.__esModule = true;
exports["default"] = void 0;

/**
 * Returns true if the provided parameter is a number
 *
 * @param {*} x The parameter to be checked
 *
 * @return {Boolean}
 */
var _default = function _default(x) {
  return typeof x === 'number' && !isNaN(x);
};

exports["default"] = _default;

/***/ }),

/***/ 858:
/***/ ((__unused_webpack_module, exports) => {



exports.__esModule = true;
exports["default"] = void 0;

/**
 * Returns true if the provided parameter is a string
 *
 * @param {*} x The parameter to be checked
 *
 * @return {Boolean}
 */
var _default = function _default(x) {
  return typeof x === 'string';
};

exports["default"] = _default;

/***/ }),

/***/ 856:
/***/ ((__unused_webpack_module, exports) => {



exports.__esModule = true;
exports["default"] = void 0;

/**
 * Returns true if the provided parameter is a valid number
 *
 * @param {*} x The parameter to be checked
 *
 * @return {Boolean}
 */
var _default = function _default(x) {
  return x !== '' && typeof +x === 'number' && !isNaN(+x) && x !== Infinity && x !== -Infinity;
};

exports["default"] = _default;

/***/ }),

/***/ 857:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _isString = _interopRequireDefault(__webpack_require__(858));

/**
 * Returns true if the provided parameter is string and not blank
 *
 * @param {*} x The parameter to be checked
 *
 * @return {Boolean}
 */
var _default = function _default(param) {
  return (0, _isString.default)(param) && param.length;
};

exports["default"] = _default;

/***/ }),

/***/ 802:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _timeseries = _interopRequireDefault(__webpack_require__(803));

exports.TimeSeries = _timeseries.default;

var _index = _interopRequireDefault(__webpack_require__(271));

var _datastore = _interopRequireDefault(__webpack_require__(470));

var _operators = __webpack_require__(482);

var _index2 = __webpack_require__(508);

var _utils = __webpack_require__(509);

_index.default.DataStore = _datastore.default;
_index.default.DataStore.Operators = {
  between: _operators.between,
  equals: _operators.equals,
  less: _operators.less,
  lessEquals: _operators.lessEquals,
  greater: _operators.greater,
  greaterEquals: _operators.greaterEquals,
  filter: _operators.filter,
  select: _operators.select,
  groupBy: _operators.groupBy,
  pipe: _operators.pipe,
  sort: _operators.sort,
  pivot: _operators.pivot
};
_index.default.Utils = {
  duration: _utils.duration,
  before: _utils.before,
  after: _utils.after,
  parseDate: _utils.parseDate,
  formatDate: _utils.formatDate,
  DatetimeUnits: _utils.DatetimeUnits,
  Weekdays: _utils.Weekdays
};
_index.default.DataStore.Aggregators = {
  aggregatorStore: _index2.aggregatorStore
};
var _default = {
  name: 'timeseries',
  type: 'package',
  requiresFusionCharts: true,
  extension: function extension(FC) {
    return FC.addDep(_timeseries.default);
  }
};
exports["default"] = _default;

/***/ }),

/***/ 803:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



exports.__esModule = true;
exports["default"] = void 0;

var _src = __webpack_require__(804);

var _default = _src.TimeSeries;
exports["default"] = _default;

/***/ })

}]);
}));

//# sourceMappingURL=http://localhost:3052/4.1.0-beta.9/map/eval/fusioncharts.timeseries.js.map