
(function (factory) {
  if (typeof module === 'object' && typeof module.exports !== "undefined") {
      module.exports = factory;
  } else {
      factory();
  }
}(function () {
"use strict";
(self["webpackChunkFusionCharts"] = self["webpackChunkFusionCharts"] || []).push([[14],{

/***/ 1507:
/***/ ((__unused_webpack_module, exports) => {



exports.__esModule = true;
exports["default"] = _default;

function _default(R) {
  var math = Math,
      mathPow = math.pow,
      mathTan = math.tan,
      mathAcos = math.acos,
      mathMin = math.min,
      mathSqrt = math.sqrt,
      M = 'M',
      L = 'L',
      Z = 'Z',
      Q = 'Q',
      p2pdistance = R._cacher(function (x1, y1, x2, y2) {
    // Returns distance between two points
    return mathSqrt(mathPow(x2 - x1, 2) + mathPow(y2 - y1, 2));
  }),
      pointAtLength = R._cacher(function (x1, y1, x2, y2, d) {
    /* Returns the coordinates of the point at distance 'd' from point (x1, y1)
           * on the line between point (x1, y1) and point (x2, y2).
           */
    // Calculate vectors along path
    var vx = x2 - x1,
        vy = y2 - y1,
        l,
        px,
        py; // Calculate total length of the path

    l = p2pdistance(x1, y1, x2, y2); // Normalize the vectors

    vx /= l;
    vy /= l; // Calculate required point coordinates

    px = x1 + vx * d;
    py = y1 + vy * d;
    return {
      x: px,
      y: py
    };
  });

  R.define && R.define([{
    // Name of the component goes here.
    name: 'trianglepath',
    // Constructor of the component goes here. Must be same name as the name of the component.
    trianglepath: function trianglepath() {
      // args: [x1, y1, x2, y2, x3, y3, r1, r2, r3]
      var paper = this,
          args = arguments,
          group = R._lastArgIfGroup(args),
          face = paper.path(group);

      return face.attr('trianglepath', [args[0], args[1], args[2], args[3], args[4], args[5], args[6] || 0, args[7] || 0, args[8] || 0]);
    },
    fn: {
      sides: function sides() {
        // Use p2pdistance library function to compute sides of a triangle.
        var points = this._args;
        return [p2pdistance(points[0], points[1], points[2], points[3]), // p1, p2
        p2pdistance(points[2], points[3], points[4], points[5]), // p2, p3
        p2pdistance(points[4], points[5], points[0], points[1]) // p3, p1
        ];
      },
      enclosedAngles: function enclosedAngles() {
        // Returns the three angles of a triangle formed by the given sides
        var edges = this._sides;
        return [mathAcos((mathPow(edges[0], 2) + mathPow(edges[2], 2) - mathPow(edges[1], 2)) / (2 * edges[0] * edges[2])), mathAcos((mathPow(edges[0], 2) + mathPow(edges[1], 2) - mathPow(edges[2], 2)) / (2 * edges[0] * edges[1])), mathAcos((mathPow(edges[2], 2) + mathPow(edges[1], 2) - mathPow(edges[0], 2)) / (2 * edges[2] * edges[1]))];
      },
      semiperimeter: function semiperimeter() {
        // Returns the semiperimeter of triangle
        var sides = this._sides || this.sides();
        return (sides[0] + sides[1] + sides[2]) / 2;
      }
    },
    ca: {
      trianglepath: function trianglepath(x1, y1, x2, y2, x3, y3, r1, r2, r3) {
        /* Create the triangle path with the provided vertices.
                 * Make rounded triangle corners if radius is provided.
                 * r1, r2, r3 are the radii of respective vertices.
                 */
        if (r1 || r2 || r3) {
          // Store arguments in trianglepath element
          this._args = arguments; // Calculate length of all sides of the triangle

          this._sides = this.sides(); // Get all the angles of the triangle

          var angles = this.enclosedAngles(),
              curveDistance,
              curvePoints,
              inradius,
              s = this.semiperimeter(); // Calculate inradius of triangle

          inradius = mathSqrt(s * (s - this._sides[0]) * (s - this._sides[1]) * (s - this._sides[2])) / s; // Get distance of points of curves from corresponding vertices
          // Impose an upper limit on radius which is inradius of triangle

          curveDistance = [mathMin(r1, inradius) / mathTan(angles[0] / 2), mathMin(r2, inradius) / mathTan(angles[1] / 2), mathMin(r3, inradius) / mathTan(angles[2] / 2)]; // Get coordinates of the points of curve on the triangle

          curvePoints = [pointAtLength(x1, y1, x3, y3, curveDistance[0]), pointAtLength(x1, y1, x2, y2, curveDistance[0]), pointAtLength(x2, y2, x1, y1, curveDistance[1]), pointAtLength(x2, y2, x3, y3, curveDistance[1]), pointAtLength(x3, y3, x2, y2, curveDistance[2]), pointAtLength(x3, y3, x1, y1, curveDistance[2])]; // Draw the triangle path with rounded corners

          this.attr({
            path: [M, curvePoints[0].x, curvePoints[0].y, Q, x1, y1, curvePoints[1].x, curvePoints[1].y, L, curvePoints[2].x, curvePoints[2].y, Q, x2, y2, curvePoints[3].x, curvePoints[3].y, L, curvePoints[4].x, curvePoints[4].y, Q, x3, y3, curvePoints[5].x, curvePoints[5].y, L, curvePoints[0].x, curvePoints[0].y]
          });
        } else {
          this.attr({
            path: [M, x1, y1, L, x2, y2, x3, y3, Z]
          });
        }
      }
    }
  }]);
}

/***/ }),

/***/ 1491:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _axis = _interopRequireDefault(__webpack_require__(567));

var _lib = __webpack_require__(274);

var _commonApi = __webpack_require__(572);

var _domainUpdater = _interopRequireDefault(__webpack_require__(564));

var GaugePolarNumeric = /*#__PURE__*/function (_Axis) {
  (0, _inheritsLoose2.default)(GaugePolarNumeric, _Axis);

  function GaugePolarNumeric() {
    return _Axis.apply(this, arguments) || this;
  }

  var _proto = GaugePolarNumeric.prototype;

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    _Axis.prototype.__setDefaultConfig.call(this);

    var config = this.config;
    config.majorTMNumber = -1;
    config.adjustDiv = 1;
    config.majorTMHeight = 6;
    config.showTickMarks = 1;
    config.majorTMThickness = 1;
    config.minorTMNumber = 4;
    config.minorTMThickness = 1;
    config.tickMarkDistance = 3;
    config.placeTicksInside = 0;
    config.placeValuesInside = 0;
    config.forceZeroTick = false;
  }
  /**
   * Prepare the axis attributes for use by the chart drawing. It applies default values to the
   * options that are undefined.
   * @param  {Object}  rawAttr The raw attributes to be set
   */
  ;

  _proto.configureAttributes = function configureAttributes(rawAttr) {
    var axis = this,
        axisConfig = axis.config,
        colorM = axis.getFromEnv('color-manager'),
        axisAttr;

    _Axis.prototype.configureAttributes.call(this, rawAttr);

    axisAttr = axisConfig.rawAttr;
    axisConfig.majorTMColor = (0, _lib.convertColor)((0, _lib.pluck)(axisAttr.majorTMColor, colorM.getColor('tickColor')), (0, _lib.pluckNumber)(axisAttr.majorTMAlpha, 100));
    axisConfig.tickValueStep = (0, _lib.pluckNumber)(axisAttr.tickValueStep, 1);
    axisConfig.tickValueStep = Math.round(axisConfig.tickValueStep);

    if (axisConfig.tickValueStep <= 0) {
      axisConfig.tickValueStep = 1;
    }

    axisConfig.connectTickMarks = axisConfig.showTickMarks ? (0, _lib.pluckNumber)(axisAttr.connectTickMarks, 1) : 0;
    axisConfig.showTickValues = (0, _lib.pluckNumber)(axisAttr.showTickValues, axisConfig.showTickMarks);
    axisConfig.reverseScale = (0, _lib.pluckNumber)(axisAttr.reverseScale, 0) === 1;
    axisConfig.minorTMColor = (0, _lib.convertColor)((0, _lib.pluck)(axisAttr.minorTMColor, axisConfig.majorTMColor), (0, _lib.pluckNumber)(axisAttr.minorTMAlpha, axisConfig.majorTMAlpha, 100));
    axisConfig.minorTMHeight = axisConfig.showTickMarks ? (0, _lib.pluckNumber)(axisAttr.minorTMHeight, Math.round(axisConfig.majorTMHeight / 2)) : 0; // Padding between tick mark start position and gauge
    // Tick value distance

    axisConfig.tickValueDistance = (0, _lib.pluckNumber)(axisAttr.tickValueDistance, 0) + 2; // text gutter

    axisConfig.upperLimitDisplay = (0, _lib.parseUnsafeString)(axisAttr.upperLimitDisplay) || '';
    axisConfig.lowerLimitDisplay = (0, _lib.parseUnsafeString)(axisAttr.lowerLimitDisplay) || '';
    axisConfig.drawTickMarkConnector = axisAttr.drawTickMarkConnector || 0;
    axisConfig.numDivLines = axisConfig.majorTMNumber >= 0 ? axisConfig.majorTMNumber : axisConfig.numDivLines + 1;
  };

  _proto._createContainer = function _createContainer() {
    var axis = this,
        axisConfig = axis.config,
        chart = axis.getLinkedParent(),
        childContainers = chart.getChildContainer(),
        axisBottom = childContainers.axisBottomGroup,
        axisTop = childContainers.axisTopGroup,
        axisLineGroup,
        axisTrendGroupTop,
        axisLabelGroupTop,
        axisTrendGroupBottom; // creating the axis elements group unique throughout the charts
    // axisTrendGroupBottom hold trendContainer bottom of the dataset

    axisTrendGroupBottom = this.createContainer('axisTrendGroupBottom', {
      name: 'dataset-Trend-group-bottom'
    }, axisBottom); // axisLineGroup hold the axis line  element

    axisLineGroup = axis.createContainer('axisLineGroup', {
      name: 'axis-Line-group'
    }, axisTop); // axisTrendGroupTop hold trendContainer top of the dataset

    axisTrendGroupTop = axis.createContainer('axisTrendGroupTop', {
      name: 'dataset-Trend-group-top'
    }, axisTop); // axisLabelGroup hold the label container

    axisLabelGroupTop = axis.createContainer('axisLabelGroupTop', {
      name: 'dataset-Label-group'
    }, axisTop); // creating the container group for every axis there will be
    // note : if new container added add it to hide and show
    // contains all the axis labels
    // for gauges the polar numeric the lables can be drawn over the plots if it is placed inside

    axisConfig.axisLabelContainerTop = axisConfig.axisContainer = axis.createGroup('axisLabelContainerTop', {
      name: 'dataset-top-label'
    }, axisLabelGroupTop);
    axisConfig.axisAxisLineContainer = axis.createGroup('axisAxisLineContainer', {
      name: 'axis-line-tick'
    }, axisLineGroup);
    axisConfig.axisTrendContainerTop = axis.createGroup('axisTrendContainerTop', {
      name: 'dataset-axis-trend-top'
    }, axisTrendGroupTop);
    axisConfig.axisTrendContainerBottom = axis.createGroup('axisTrendContainerBottom', {
      name: 'dataset-axis-trend-bottom'
    }, axisTrendGroupBottom); // contain trend label elements

    axisConfig.axisTrendLabelContainer = axis.createGroup('axisTrendLabelContainer', {
      name: 'dataset-axis-trend-label'
    }, axisTrendGroupTop);
  };

  _proto.allocatePosition = function allocatePosition() {
    var axis = this,
        axisConfig = axis.config;
    axisConfig.drawLabels && axis._parseLabel();
  }
  /**
   * Sets the visible range of the axis. Also sets axis's reference values and re-calculates PVR.
   * @param  {number} minValue The minimum value of the area to be visible
   * @param  {number} maxValue The maximum value of the area to be visible
   * @return {boolean} Whether the visible range of the axis was successfully set or not
   */
  ;

  _proto.setVisibleConfig = function setVisibleConfig(minValue, maxValue) {
    var axis = this,
        axisConfig = axis.config,
        scale = axis.getScale(),
        domain;

    if (minValue >= maxValue || minValue < axisConfig.axisRange.min || maxValue > axisConfig.axisRange.max) {
      return false;
    }

    domain = scale.setDomain([minValue, maxValue]).getDomain();
    axisConfig.visibleMin = domain[0];
    axisConfig.visibleMax = domain[1];
    axis.fireEvent('visiblerangeset', {
      minValue: minValue,
      maxValue: maxValue
    });
    axis.asyncDraw();
    return true;
  };

  _proto._adjustNumberFormatter = function _adjustNumberFormatter() {
    if (this) return 0;
  };

  _proto.calculateTicksOnLabelMode = function calculateTicksOnLabelMode() {
    if (this) return 0;
  };

  _proto.generateMinorTicks = function generateMinorTicks() {
    var axis = this,
        axisConfig = this.config;
    return axis.getScale().minorTicks(axisConfig.minorTMNumber, axisConfig.ticks);
  }
  /**
   * Function to set the axis range from (used for axis drawing) out side.
   * @param {Object} data Axis range object the values to be changed
   */
  ;

  _proto._setAxisRange = function _setAxisRange(data) {
    var min = data.min,
        max = data.max,
        axisConfig = this.config,
        axisRange = axisConfig.axisRange;

    if (min > max) {
      return;
    }

    (0, _domainUpdater.default)(min, max, this.getScale(), axisConfig);
    axisConfig.minorTicks = this.generateMinorTicks();
    this.setVisibleConfig(axisRange.min, axisRange.max);
  };

  return GaugePolarNumeric;
}(_axis.default);

GaugePolarNumeric.prototype.setDataLimit = _commonApi.setDataLimit;
GaugePolarNumeric.prototype.getTrendLineLimits = _commonApi.getTrendLineLimits;
var _default = GaugePolarNumeric;
exports["default"] = _default;

/***/ }),

/***/ 1492:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



exports.__esModule = true;
exports["default"] = void 0;

var _cartesianAxis = __webpack_require__(568);

var _default = {
  'initial.axis.gaugeAxis': {
    'text.appearing': _cartesianAxis.appearingAxis,
    'path.appearing': _cartesianAxis.appearingAxis
  },
  'update.axis.gaugeAxis': {
    'text.appearing': _cartesianAxis.appearingFinal,
    'path.appearing': _cartesianAxis.appearingFinal
  }
};
exports["default"] = _default;

/***/ }),

/***/ 1490:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _gaugePolarNumeric = _interopRequireDefault(__webpack_require__(1491));

var _lib = __webpack_require__(274);

var _diff = _interopRequireDefault(__webpack_require__(569));

var _dependencyManager = __webpack_require__(282);

var _gauge = _interopRequireDefault(__webpack_require__(1492));

var _linear = _interopRequireDefault(__webpack_require__(541));

var _commonApi = __webpack_require__(572);

(0, _dependencyManager.addDep)({
  name: 'gaugeAnimation',
  type: 'animationRule',
  extension: _gauge.default
});

var GaugeAxis = /*#__PURE__*/function (_GaugePolarNumeric) {
  (0, _inheritsLoose2.default)(GaugeAxis, _GaugePolarNumeric);

  function GaugeAxis() {
    var _this;

    _this = _GaugePolarNumeric.call(this) || this;
    _this.config.scale = new _linear.default();
    _this.config.labelMap = [];
    _this.config.prevIntervalArr = [];
    _this.config.prevTicksMap = [];
    return _this;
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */


  var _proto = GaugeAxis.prototype;

  _proto.getName = function getName() {
    return 'gaugeAxis';
  };

  _proto.getLabelPos = function getLabelPos(value, opt) {
    var axis = this,
        axisConfig = axis.config,
        canvas = axisConfig.canvas,
        chart = axis.getFromEnv('chart'),
        chartConfig = chart.config,
        canvasTop = canvas.canvasTop || chartConfig.canvasTop,
        canvasBottom = canvas.canvasBottom || chartConfig.canvasBottom,
        canvasLeft = canvas.canvasLeft || chartConfig.canvasLeft,
        isVertical = axisConfig.isVertical,
        isOpposit = (0, _lib.pluckNumber)(axisConfig.isOpposit),
        // axisDimention = axisConfig.axisDimention || {},
    canvasRight = canvas.canvasRight || chartConfig.canvasRight,
        axisPadding = axisConfig.labelPadding,
        // axisStartPosition = isVertical ? axisDimention.x : axisDimention.y,
    posObj = {
      x: 0,
      y: 0
    },
        addCategoryPadding;

    if (isVertical) {
      posObj.x = isOpposit ? canvasRight + axisPadding : canvasLeft - axisPadding;
      posObj.y = addCategoryPadding ? axis.getPixel(value, opt) + addCategoryPadding : axis.getPixel(value, opt);
    } else {
      posObj.x = axis.getPixel(value, opt);
      posObj.y = isOpposit ? canvasTop - axisPadding : canvasBottom + axisPadding;

      if (addCategoryPadding) {
        posObj.y += addCategoryPadding;
      }
    }

    return posObj;
  };

  _proto._drawComponents = function _drawComponents() {
    var axis = this,
        axisConfig = axis.config;
    axisConfig.drawTick && axis._drawTick();
    axisConfig.drawLabels && axis._drawLabel(); // axisConfig.drawTrendLines && axis._drawTrendLine();
  };

  _proto._drawTick = function _drawTick() {
    var axis = this,
        axisConfig = axis.config,
        axisRange = axisConfig.axisRange,
        isVertical = axisConfig.isVertical,
        isOpposit = (0, _lib.pluckNumber)(axisConfig.isOpposit),
        drawTick = axisConfig.drawTick,
        drawTickMinor = axisConfig.drawTickMinor,
        placeTicksInside = (0, _lib.pluckNumber)(axisConfig.placeTicksInside),
        canvasDim = axis.getLinkedItem('canvas').getEffectiveDimensions(),
        canvasTop = canvasDim.top,
        canvasBottom = canvasTop + canvasDim.height,
        canvasLeft = canvasDim.left,
        canvasRight = canvasLeft + canvasDim.width,
        max = axisRange.max,
        min = axisRange.min,
        animationManager = axis.getFromEnv('animationManager'),
        ticks = axisConfig.ticks,
        ticksLen = ticks.length,
        axisAxisLineContainer = axisConfig.axisAxisLineContainer,
        map = [],
        present,
        path,
        minorTickValues = axisConfig.minorTicks,
        lineElement,
        tickElement,
        minorTickObj,
        majorTickObj,
        connectorObj,
        statPix,
        endPixMajor,
        endPixMinor,
        tickMarkConnecterPath,
        i,
        j,
        tickValue,
        minorTickValue,
        diff,
        removingElement,
        ln,
        getPath = function getPath(value, startPix, endPix) {
      var pxVal = axis.getPixel(value, {
        wrtVisible: true
      });
      return isVertical ? ['M', startPix, pxVal, 'L', endPix, pxVal] : ['M', pxVal, startPix, 'L', pxVal, endPix];
    };

    majorTickObj = {
      stroke: axisConfig.majorTMColor,
      'stroke-width': axisConfig.majorTMThickness,
      'stroke-linecap': 'round',
      opacity: 1
    };
    connectorObj = {
      stroke: axisConfig.majorTMColor,
      'stroke-width': axisConfig.majorTMThickness,
      'stroke-linecap': 'round'
    };
    minorTickObj = {
      stroke: axisConfig.minorTMColor,
      'stroke-width': axisConfig.minorTMThickness,
      'stroke-linecap': 'round',
      opacity: 1
    }; // checking if lines are to be drawn user can decide

    if (axisConfig.lines.isDraw && drawTick) {
      if (isVertical) {
        if (isOpposit) {
          if (!placeTicksInside) {
            statPix = canvasRight + axisConfig.tickMarkDistance;
            endPixMajor = statPix + axisConfig.majorTMHeight;
            endPixMinor = statPix + axisConfig.minorTMHeight;
          } else {
            statPix = canvasRight - axisConfig.tickMarkDistance;
            endPixMajor = statPix - axisConfig.majorTMHeight;
            endPixMinor = statPix - axisConfig.minorTMHeight;
          }
        } else {
          if (!placeTicksInside) {
            statPix = canvasLeft - axisConfig.tickMarkDistance;
            endPixMajor = statPix - axisConfig.majorTMHeight;
            endPixMinor = statPix - axisConfig.minorTMHeight;
          } else {
            statPix = canvasLeft + axisConfig.tickMarkDistance;
            endPixMajor = statPix + axisConfig.majorTMHeight;
            endPixMinor = statPix + axisConfig.minorTMHeight;
          }
        }
      } else {
        if (!isOpposit) {
          if (!placeTicksInside) {
            statPix = canvasBottom + axisConfig.tickMarkDistance;
            endPixMajor = statPix + axisConfig.majorTMHeight;
            endPixMinor = statPix + axisConfig.minorTMHeight;
          } else {
            statPix = canvasBottom - axisConfig.tickMarkDistance;
            endPixMajor = statPix - axisConfig.majorTMHeight;
            endPixMinor = statPix - axisConfig.minorTMHeight;
          }
        } else {
          if (!placeTicksInside) {
            statPix = canvasTop - axisConfig.tickMarkDistance;
            endPixMajor = statPix - axisConfig.majorTMHeight;
            endPixMinor = statPix - axisConfig.minorTMHeight;
          } else {
            statPix = canvasTop + axisConfig.tickMarkDistance;
            endPixMajor = statPix + axisConfig.majorTMHeight;
            endPixMinor = statPix + axisConfig.minorTMHeight;
          }
        }
      }

      if (axisConfig.drawTickMarkConnector) {
        if (isVertical) {
          tickMarkConnecterPath = ['M', statPix, axis.getPixel(min), 'L', statPix, axis.getPixel(max)];
        } else {
          tickMarkConnecterPath = ['M', axis.getPixel(min), statPix, 'L', axis.getPixel(max), statPix];
        }
      } else {
        tickMarkConnecterPath = ['M0,0'];
      }

      connectorObj.path = tickMarkConnecterPath; // Drawing of the tick-mark connector
      // reuse the elements if there

      lineElement = axis.getGraphicalElement('axisLinePath');
      present = !!lineElement;
      lineElement = animationManager.setAnimation({
        el: lineElement || 'path',
        attr: connectorObj,
        container: axisAxisLineContainer,
        component: axis,
        label: 'path'
      });
      map.push('axisLinePath');

      if (!present) {
        axis.addGraphicalElement('axisLinePath', lineElement);
      }

      for (i = 0; i < ticksLen; i += 1) {
        tickValue = ticks[i];
        path = getPath(tickValue, statPix, endPixMajor);
        majorTickObj.path = path.toString();
        map.push(tickValue);
        tickElement = axis.getGraphicalElement(tickValue);
        present = !!tickElement; // reuse the elements if there

        tickElement = animationManager.setAnimation({
          el: tickElement || 'path',
          data: {
            path: path.slice(),
            value: tickValue
          },
          attr: majorTickObj,
          container: axisAxisLineContainer,
          component: axis,
          label: 'path'
        });

        if (!present) {
          axis.addGraphicalElement(tickValue, tickElement);
        }
      }

      if (drawTickMinor) {
        for (j = 0; j < minorTickValues.length; j += 1) {
          minorTickValue = minorTickValues[j];
          path = getPath(minorTickValue, statPix, endPixMinor);
          minorTickObj.path = path.toString();
          map.push(minorTickValue);
          tickElement = axis.getGraphicalElement(minorTickValue);
          present = !!tickElement;
          tickElement = animationManager.setAnimation({
            el: tickElement || 'path',
            data: {
              path: path.slice(),
              value: minorTickValue
            },
            attr: minorTickObj,
            component: axis,
            container: axisAxisLineContainer,
            label: 'path'
          });

          if (!present) {
            axis.addGraphicalElement(minorTickValue, tickElement);
          }
        }
      }
    }

    diff = (0, _diff.default)(axisConfig.prevTicksMap, map);

    for (i = 0, ln = diff.length; i < ln; i++) {
      removingElement = axis.getGraphicalElement(diff[i]);
      removingElement && axis.removeGraphicalElement(removingElement);
    }

    axisConfig.prevTicksMap = map;
  };

  _proto.placeAxis = function placeAxis(_maxLimit) {
    var axis = this,
        chart = axis.getFromEnv('chart'),
        maxLimit = _maxLimit,
        scale = axis.getScale(),
        smartLabel = chart.getFromEnv('smartLabel'),
        axisConfig = axis.config,
        axisRange = axisConfig.axisRange,
        isVertical = axisConfig.isVertical,
        isOpposit = (0, _lib.pluckNumber)(axisConfig.isOpposit),
        labelStyle = axisConfig.labels.style,
        increment = axisRange.tickInterval,
        placeTicksInside = (0, _lib.pluckNumber)(axisConfig.placeTicksInside),
        placeValuesInside = (0, _lib.pluckNumber)(axisConfig.placeValuesInside),
        max = axisRange.max,
        min = axisRange.min,
        upperLimitDisplay,
        lowerLimitDisplay,
        maxTextSize = 0,
        maxTickLength = 0,
        maxText = '',
        ret,
        text,
        i,
        counter,
        leftLimit,
        avalW,
        avalH,
        numDimention,
        dimention,
        intervalWidth,
        tempText,
        maxNumericVal,
        minNumericVal,
        labelLineHeight = axisConfig.labels.style.lineHeight,
        labelObj,
        numberFormatterFn,
        numberFormatter = axis.getFromEnv('number-formatter'),
        upperLimitDisplayDimention,
        lowerLimitDisplayDimention;

    if (isVertical) {
      scale.setRange([chart.config.canvasTop, chart.config.canvasBottom]);
    } else {
      scale.setRange([chart.config.canvasLeft, chart.config.canvasRight]);
    }

    ret = {
      left: 0,
      right: 0,
      top: 0,
      bottom: 0
    };

    if (maxLimit <= 0) {
      return ret;
    }

    axisConfig.labels.isDraw = true;
    axisConfig.labels.drawNumericVal = true;
    axisConfig.labels.drawNormalVal = axisConfig.showTickValues;
    axisConfig.labels.drawLimitVal = axisConfig.showLimits;
    axisConfig.lines.isDraw = true;
    axisConfig.labels.step = axisConfig.tickValueStep;
    axisConfig.labelPadding = 0;
    smartLabel.useEllipsesOnOverflow(chart.config.useEllipsesWhenOverflow);
    smartLabel.setStyle({
      fontSize: labelStyle.fontSize,
      fontFamily: labelStyle.fontFamily,
      lineHeight: labelStyle.lineHeight,
      fontWeight: labelStyle.fontWeight
    });

    if (!axis.components) {
      axis.components = {};
      axis.components.labels = [];
    } // measuring the tick length


    if (axisConfig.drawTick && axisConfig.showTickMarks && axisConfig.lines.isDraw) {
      maxLimit -= axisConfig.tickMarkDistance;
      maxTickLength = Math.max(axisConfig.minorTMHeight, axisConfig.majorTMHeight);

      if (!placeTicksInside) {
        if (maxTickLength > maxLimit) {
          axisConfig.lines.isDraw = false;
          leftLimit = maxLimit + axisConfig.tickMarkDistance;
          leftLimit = maxLimit;
        } else {
          if (isVertical) {
            if (isOpposit) {
              ret.right += maxTickLength + axisConfig.tickMarkDistance;
            } else {
              ret.left += maxTickLength + axisConfig.tickMarkDistance;
            }
          } else {
            if (isOpposit) {
              ret.top += maxTickLength + axisConfig.tickMarkDistance;
            } else {
              ret.bottom += maxTickLength + axisConfig.tickMarkDistance;
            }
          }

          leftLimit = maxLimit - maxTickLength;

          if (!placeValuesInside) {
            axisConfig.labelPadding = axisConfig.tickMarkDistance + maxTickLength;
          }
        }
      } else {
        leftLimit = maxLimit + axisConfig.tickMarkDistance;

        if (placeValuesInside) {
          axisConfig.labelPadding = axisConfig.tickMarkDistance + maxTickLength;
        }
      }
    } else {
      axisConfig.lines.isDraw = false;
      leftLimit = maxLimit;
    }

    leftLimit -= axisConfig.tickValueDistance;

    if (axisConfig.drawLabels && (axisConfig.showTickValues || axisConfig.showLimits)) {
      intervalWidth = Math.abs(axis.getPixel(min) - axis.getPixel(min + increment)) / 2;
      axisConfig.labelPadding += axisConfig.tickValueDistance;
      leftLimit -= axisConfig.tickValueDistance; // measuring the label dimention

      numberFormatterFn = numberFormatter.scale; // calculating the label max width and height
      // TODO : smartly calculate the max width height

      for (i = min + increment, counter = 0; i < max; i += increment) {
        text = '' + numberFormatterFn.call(numberFormatter, (0, _lib.toPrecision)(i, 10));
        numDimention = smartLabel.getOriSize(text);
        axis.components.labels[counter] = {
          config: {
            width: numDimention.width,
            height: numDimention.height,
            props: {
              label: {
                attr: {
                  text: text
                }
              }
            }
          }
        };
        counter++;

        if (text.length > maxTextSize) {
          maxText = text;
          maxTextSize = text.length;
        }
      }

      numDimention = smartLabel.getOriSize(maxText);

      if (isVertical) {
        if (numDimention.width > leftLimit) {
          axisConfig.labels.drawNumericVal = false;
          !axisConfig.upperLimitDisplay && !axisConfig.lowerLimitDisplay && (axisConfig.labels.isDraw = false);
          maxText = '';
          numDimention = smartLabel.getOriSize(maxText);
        }
      } else {
        if (numDimention.height > leftLimit) {
          axisConfig.labels.drawNumericVal = false;
          !axisConfig.upperLimitDisplay && !axisConfig.lowerLimitDisplay && (axisConfig.labels.isDraw = false);
          maxText = '';
          numDimention = smartLabel.getOriSize(maxText);
        }
      }

      avalW = isVertical ? leftLimit : intervalWidth;
      avalH = isVertical ? intervalWidth : leftLimit;

      if (axisConfig.showLimits) {
        maxNumericVal = numberFormatterFn.call(numberFormatter, max);
        minNumericVal = numberFormatterFn.call(numberFormatter, min);
        upperLimitDisplay = axisConfig.upperLimitDisplay || '' + maxNumericVal;
        lowerLimitDisplay = axisConfig.lowerLimitDisplay || '' + minNumericVal;
        upperLimitDisplayDimention = smartLabel.getOriSize(upperLimitDisplay);

        if (upperLimitDisplayDimention.width > numDimention.width) {
          tempText = smartLabel.getSmartText(upperLimitDisplay, avalW, avalH);

          if (upperLimitDisplay === maxNumericVal && tempText.text === tempText.oriText || axisConfig.labels.drawNumericVal) {
            maxText = upperLimitDisplay;
            numDimention = upperLimitDisplayDimention;
          }
        }

        lowerLimitDisplayDimention = smartLabel.getOriSize(lowerLimitDisplay);

        if (lowerLimitDisplayDimention.width > numDimention.width) {
          tempText = smartLabel.getSmartText(lowerLimitDisplay, avalW, avalH);

          if (lowerLimitDisplay === minNumericVal && tempText.text === tempText.oriText || axisConfig.labels.drawNumericVal) {
            maxText = lowerLimitDisplay;
          }
        }

        if (maxText === '') {
          if (smartLabel.getOriSize(axisConfig.upperLimitDisplay).width > smartLabel.getOriSize(axisConfig.lowerLimitDisplay).width) {
            maxText = upperLimitDisplay;
          } else {
            maxText = lowerLimitDisplay;
          }

          numDimention = smartLabel.getOriSize(maxText);
        }
      } else {
        axisConfig.labels.drawLimitVal = false;
      }

      if (!isVertical) {
        for (i = min; i <= max; i += increment) {
          dimention = smartLabel.getSmartText(maxText, avalW, avalH);

          if (dimention.text === '') {
            avalW += intervalWidth;
          } else {
            break;
          }
        }
      } else {
        dimention = smartLabel.getSmartText(maxText, avalW, avalH);
      }

      dimention = smartLabel.getSmartText(maxText, avalW, avalH);
      axisConfig.labelMaxW = Math.max(dimention.width, numDimention.width);
      axisConfig.labelMaxH = Math.max(dimention.height, numDimention.height);

      if (!placeValuesInside && axisConfig.labels.isDraw) {
        if (isVertical) {
          axisConfig.labelMaxW = Math.min(axisConfig.labelMaxW, leftLimit);

          if (isOpposit) {
            ret.right += axisConfig.labelMaxW + axisConfig.tickValueDistance;
          } else {
            ret.left += axisConfig.labelMaxW + axisConfig.tickValueDistance;
          }
        } else {
          axisConfig.labelMaxH = Math.min(axisConfig.labelMaxH, leftLimit);

          if (isOpposit) {
            ret.top += axisConfig.labelMaxH + axisConfig.tickValueDistance;
          } else {
            ret.bottom += axisConfig.labelMaxH + axisConfig.tickValueDistance;
          }
        }
      } else {
        axisConfig.labelPadding = -axisConfig.labelPadding;
      }

      if (axisConfig.labels.drawLimitVal) {
        if (labelLineHeight) {
          if (labelLineHeight.indexOf('px') !== -1) {
            labelLineHeight = parseFloat(labelLineHeight.replace('px', ''));
          }
        }

        if (axisConfig.upperLimitDisplay) {
          numDimention = smartLabel.getSmartText(axisConfig.upperLimitDisplay, axisConfig.labelMaxW, axisConfig.labelMaxH + labelLineHeight / 2);
        } else {
          text = '' + numberFormatterFn.call(numberFormatter, (0, _lib.toPrecision)(max, 10));
          numDimention = smartLabel.getOriSize(text);
        }

        axis.components.labels[counter] = {
          config: {
            width: numDimention.width,
            height: numDimention.height,
            props: {
              label: {
                attr: {
                  text: numDimention.text
                }
              }
            }
          }
        };

        if (axisConfig.lowerLimitDisplay) {
          numDimention = smartLabel.getSmartText(axisConfig.lowerLimitDisplay, axisConfig.labelMaxW, axisConfig.labelMaxH + labelLineHeight / 2);
        } else {
          text = '' + numberFormatterFn.call(numberFormatter, (0, _lib.toPrecision)(min, 10));
          numDimention = smartLabel.getOriSize(text);
        }

        labelObj = {
          config: {
            width: numDimention.width,
            height: numDimention.height,
            props: {
              label: {
                attr: {
                  text: numDimention.text
                }
              }
            }
          }
        };
        axis.components.labels.unshift(labelObj);
      }
    } else {
      axisConfig.labels.isDraw = false;
    }

    axisConfig.spaceTaken = ret;
    return ret;
  }
  /**
   * Hides the axis components
   */
  ;

  _proto.hide = function hide() {
    var axis = this,
        axisConfig = axis.config;

    if (!axisConfig.axisContainer) {
      return;
    }

    axisConfig.axisLabelContainerTop.hide();
    axisConfig.axisContainer.hide();
    axisConfig.axisTrendLabelContainer.hide();
    axisConfig.axisAxisLineContainer.hide();
  }
  /**
   * Hides the axis components
   */
  ;

  _proto.show = function show() {
    var axis = this,
        axisConfig = axis.config;

    if (!axisConfig.axisContainer) {
      return;
    }

    axisConfig.axisLabelContainerTop.show();
    axisConfig.axisContainer.show();
    axisConfig.axisTrendLabelContainer.show();
    axisConfig.axisAxisLineContainer.show();
  };

  _proto._computeTranslation = function _computeTranslation() {
    if (this) return 0;
  };

  return GaugeAxis;
}(_gaugePolarNumeric.default);

GaugeAxis.prototype.setAxisDimention = _commonApi.setAxisDimention;
GaugeAxis.prototype.getPixel = _commonApi.getPixel;
GaugeAxis.prototype._parseLabel = _commonApi._parseLabel;
GaugeAxis.prototype._drawLabel = _commonApi._drawLabel;
var _default = GaugeAxis;
exports["default"] = _default;

/***/ }),

/***/ 1501:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _polarAxis = _interopRequireDefault(__webpack_require__(1458));

var _default = {
  'initial.axis.polarNumeric': function initialAxisPolarNumeric() {
    return {
      'path.appearing': _polarAxis.default,
      'text.appearing': _polarAxis.default,
      'polypath.appearing': _polarAxis.default,
      'ringpath.appearing': _polarAxis.default,
      '*': null
    };
  }
};
exports["default"] = _default;

/***/ }),

/***/ 1500:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _gaugePolarNumeric = _interopRequireDefault(__webpack_require__(1491));

var _lib = __webpack_require__(274);

var _polarUtil = __webpack_require__(1454);

var _diff = _interopRequireDefault(__webpack_require__(569));

var _dependencyManager = __webpack_require__(282);

var _polarNumeric = _interopRequireDefault(__webpack_require__(1501));

var _linear = _interopRequireDefault(__webpack_require__(541));

var UNDEF,
    POSITION_MIDDLE = _lib.preDefStr.POSITION_MIDDLE,
    POSITION_START = _lib.preDefStr.POSITION_START,
    POSITION_TOP = _lib.preDefStr.POSITION_TOP,
    POSITION_BOTTOM = _lib.preDefStr.POSITION_BOTTOM,
    POSITION_END = _lib.preDefStr.POSITION_END,
    BLANKSTRING = '',
    GUTTER_PADDING = 5,
    M = 'M',
    L = 'L',
    math = Math,
    pi = math.PI,
    pi2 = 2 * pi,
    TICK = '_tick',
    LABEL_ID = '_label',
    TRENDLINE_ID = '_trendLine',
    TRENDLABEL_ID = '_trendLabel',
    TRENDMARKER_ID = '_marker',
    trendTextPositions = [],
    overLappingPoints = {};
(0, _dependencyManager.addDep)({
  name: 'polarNumericAnimation',
  type: 'animationRule',
  extension: _polarNumeric.default
});

var PolarGaugeAxis = /*#__PURE__*/function (_GaugePolarNumeric) {
  (0, _inheritsLoose2.default)(PolarGaugeAxis, _GaugePolarNumeric);

  function PolarGaugeAxis() {
    var _this;

    _this = _GaugePolarNumeric.call(this) || this;
    _this.config.scale = new _linear.default();
    _this.config.prevTickMarks = [];
    _this.config.prevIntervalArrLabel = [];
    _this.config.prevIntervalArrTrendLine = [];
    return _this;
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */


  var _proto = PolarGaugeAxis.prototype;

  _proto.getName = function getName() {
    return 'polarNumeric';
  }
  /**
   * Function set the starting point for drawing the axis and the axis drawing width/height
   * @param {Object} data Contains the x, y, length and whether the axis is drawn on the opposite side
   */
  ;

  _proto.setAxisDimention = function setAxisDimention() {
    var axis = this,
        scale = axis.getScale(),
        axisConfig = axis.config,
        startAngle = axisConfig.startAngle || pi2 / 2,
        totalAngle = axisConfig.totalAngle || pi2 / 2,
        endAngle = startAngle + totalAngle,
        rangeArr,
        // category = axisConfig.tickValues.tickValue || [],
    // anglePerSlice = totalAngle / (category.length || 1),
    axisDimention = axisConfig.axisDimention || (axisConfig.axisDimention = {});
    axisDimention.centerX = axisConfig.centerX;
    axisDimention.centerY = axisConfig.centerY;
    axisDimention.axisLength = pi2; // endAngle -= anglePerSlice;

    rangeArr = [startAngle, endAngle];
    scale.setRange(rangeArr);
  };

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    _GaugePolarNumeric.prototype.__setDefaultConfig.call(this);

    var config = this.config;
    config.trendPoints = UNDEF;
    config.ticksBelowGauge = UNDEF;
    config.ticksBelowGraph = UNDEF;
    config.trendValueDistance = UNDEF;
  }
  /**
   * Prepare the axis attributes for use by the chart drawing. It applies default values to the
   * options that are undefined.
   * @param  {Object}  rawAttr The raw attributes to be set
   */
  ;

  _proto.configureAttributes = function configureAttributes(rawAttr) {
    var axis = this,
        axisConfig = axis.config,
        axisAttr;

    _GaugePolarNumeric.prototype.configureAttributes.call(this, rawAttr);

    axisAttr = axisConfig.rawAttr;
    axisConfig.upperLimitDisplay = axisAttr.upperLimitDisplay || '';
    axisConfig.lowerLimitDisplay = axisAttr.lowerLimitDisplay || '';
    axisConfig.polarPadding = 4;
  };

  _proto._drawComponents = function _drawComponents() {
    var axis = this,
        axisConfig = axis.config;
    axisConfig.drawTick && axis._drawTick();
    axisConfig.drawLabels && axis._drawLabel();
    axisConfig.drawTrendLines && axis._drawTrendLine();
  };

  _proto.getAngle = function getAngle(value) {
    var axis = this,
        angle,
        axisScale = axis.getScale();
    angle = axisScale.getRangeValue(value);
    return angle;
  };

  _proto.placeAxis = function placeAxis(maxLimit) {
    var axis = this,
        axisConfig = axis.config,
        chart = axis.getFromEnv('chart'),
        smartLabel = chart.getFromEnv('smartLabel'),
        axisRange = axisConfig.axisRange,
        labelStyle = axisConfig.labels.style,
        increment = axisRange.tickInterval || 1,
        upperLimitDisplay = axisConfig.upperLimitDisplay,
        lowerLimitDisplay = axisConfig.lowerLimitDisplay,
        max = axisRange.max,
        min = axisRange.min,
        maxTextSize = 0,
        maxText,
        i,
        counter,
        text,
        numberFormatterFn,
        textWidthBuffer,
        numberFormatter = chart.getFromEnv('number-formatter'),
        numDimention,
        ret,
        leftLimit;
    ret = {
      left: 0,
      right: 0,
      top: 0,
      bottom: 0
    };
    smartLabel.useEllipsesOnOverflow(chart.config.useEllipsesWhenOverflow);
    smartLabel.setStyle({
      fontSize: labelStyle.fontSize,
      fontFamily: labelStyle.fontFamily,
      lineHeight: labelStyle.lineHeight,
      fontWeight: labelStyle.fontWeight
    });

    if (!axis.components) {
      axis.components = {};
      axis.components.labels = [];
    }

    axisConfig.labels.isDraw = 1;
    axisConfig.labels.drawNormalVal = 1;
    axisConfig.labels.drawLimitVal = 1;
    axisConfig.lines.isDraw = 1;
    axisConfig.labels.step = axisConfig.tickValueStep;
    axisConfig.labelPadding = 0;
    leftLimit = maxLimit;

    if (axisConfig.drawLabels && axisConfig.showTickValues && leftLimit > 0) {
      axisConfig.labelPadding += axisConfig.tickValueDistance;
      leftLimit -= axisConfig.tickValueDistance; // measuring the label dimention

      numberFormatterFn = numberFormatter.scale; // calculating the label max width and height
      // TODO : smartly calculate the max width height

      for (i = min, counter = 0; i <= max; i += increment) {
        text = '' + numberFormatterFn.call(numberFormatter, (0, _lib.toPrecision)(i, 10));
        numDimention = smartLabel.getOriSize(text, true);
        axis.components.labels[counter] = {
          config: {
            width: numDimention.width,
            height: numDimention.height,
            props: {
              label: {
                attr: {}
              }
            }
          }
        };
        counter++;

        if (text.length > maxTextSize) {
          maxText = text;
          maxTextSize = text.length;
        }
      }

      numDimention = smartLabel.getOriSize(maxText, true);

      if (numDimention.width > maxLimit / 2) {
        axisConfig.labels.isDraw = false;
        return ret;
      }

      if (axisConfig.showLimits) {
        // update numDimension if any displayvalue is given and has bigger dimensions than maxlimit value.
        if (upperLimitDisplay || lowerLimitDisplay) {
          textWidthBuffer = smartLabel.getOriSize(upperLimitDisplay, true); // if the width of the upperlimitdisplay is greater then the width
          // of the maxText then set maxText as upperlimitdisplay and update numDimention

          if (textWidthBuffer.width > numDimention.width) {
            maxText = upperLimitDisplay;
            maxTextSize = textWidthBuffer.width;
            numDimention = textWidthBuffer;
          }

          textWidthBuffer = smartLabel.getOriSize(lowerLimitDisplay, true); // if the width of the lowerlimitdisplay is greater then the width
          // of the maxText then set maxText as lowerlimitdisplay and update numDimention

          if (textWidthBuffer.width > numDimention.width) {
            maxText = lowerLimitDisplay;
            maxTextSize = textWidthBuffer.width;
            numDimention = textWidthBuffer;
          }
        }
      } else {
        axisConfig.labels.drawLimitVal = false;
      }

      numDimention = smartLabel.getOriSize(maxText);
      axisConfig.labelMaxW = numDimention.width;

      if (axisConfig.labelMaxW > maxLimit / 2) {
        axisConfig.labelMaxW = maxLimit / 2;
      }

      axisConfig.labelMaxH = numDimention.height;

      if (!axisConfig.placeValuesInside) {
        ret.right += axisConfig.labelMaxW + axisConfig.tickValueDistance;
        ret.left += axisConfig.labelMaxW + axisConfig.tickValueDistance;
        ret.top += axisConfig.labelMaxH + axisConfig.tickValueDistance;
        ret.bottom += axisConfig.labelMaxH + axisConfig.tickValueDistance;
      } else {
        axisConfig.labelPadding = -axisConfig.labelPadding;
      }
    } else {
      axisConfig.labels.isDraw = false;
    }

    return ret;
  }
  /**
   * Parses the label attributes and calculates position
   *
   * @memberof PolarGaugeAxis
   */
  ;

  _proto._parseLabel = function _parseLabel() {
    var axis = this,
        axisConfig = axis.config,
        chart = axis.getFromEnv('chart'),
        axisRange = axisConfig.axisRange,
        axisScale = axis.getScale(),
        smartLabel = chart.getFromEnv('smartLabel'),
        labelStore,
        labelConf,
        labels = axisConfig.labels,
        style = labels.style,
        axisPadding = axisConfig.labelPadding || 0,
        radius = axisConfig.radius,
        gaugeOuterRadius = (0, _lib.pluckNumber)(axisConfig.gaugeOuterRadius, radius),
        gaugeInnerRadius = (0, _lib.pluckNumber)(axisConfig.gaugeInnerRadius, radius),
        centerX = axisConfig.centerX,
        centerY = axisConfig.centerY,
        placeValuesInside = axisConfig.placeValuesInside,
        axisValueMaxH = axisConfig.labelMaxH,
        axisValueMaxW = axisConfig.labelMaxW,
        i,
        tick,
        max = axisRange.max,
        min = axisRange.min,
        tempText,
        theta,
        text,
        increment,
        parsing,
        ticks = axisConfig.ticks,
        ticksLen = ticks.length,
        labelLineHeight,
        numberFormatterFn,
        numberFormatter = chart.getFromEnv('number-formatter'),
        axisAttrObj,
        getPos;

    if (style.lineHeight) {
      labelLineHeight = style.lineHeight;

      if (labelLineHeight.indexOf('px') !== -1) {
        labelLineHeight = labelLineHeight.replace('px', '');
        labelLineHeight = parseFloat(labelLineHeight);
      }
    }

    smartLabel.useEllipsesOnOverflow(chart.config.useEllipsesWhenOverflow);
    smartLabel.setStyle({
      fontSize: style.fontSize,
      fontFamily: style.fontFamily,
      lineHeight: style.lineHeight,
      fontWeight: style.fontWeight
    });

    if (axisConfig.labels.isDraw) {
      labelStore = axis.components.labels;
      increment = axisConfig.labels.step;

      parsing = function parsing(index) {
        tick = ticks[index];
        theta = axisScale.getRangeValue(tick); // if values are not limit value and label drawing is off other
        // than limit increment it and continue

        if (!axisConfig.labels.drawNormalVal && !(axisConfig.labels.drawLimitVal && (tick === min || tick === max))) {
          return;
        }

        if (!axisConfig.labels.drawNormalVal && !(tick === min || tick === max)) {
          return;
        } // if value are limit value but limit value are not mean to be drawn


        if (!axisConfig.labels.drawLimitVal && (tick === min || tick === max)) {
          return;
        } // if value is zero and show zero plane is off


        if (axisConfig.showZeroPlaneValue === 0 && axisConfig.showZeroPlane === 0 && tick === 0) {
          return;
        } // make the attribute ready to use
        // y-axis


        numberFormatterFn = numberFormatter.scale;

        if (tick === min && axisConfig.lowerLimitDisplay) {
          tempText = smartLabel.getSmartText(axisConfig.lowerLimitDisplay, axisValueMaxW, axisValueMaxH);
          text = tempText.text;
        } else if (tick === max && axisConfig.upperLimitDisplay) {
          tempText = smartLabel.getSmartText(axisConfig.upperLimitDisplay, axisValueMaxW, axisValueMaxH);
          text = tempText.text;
        } else {
          text = numberFormatterFn.call(numberFormatter, (0, _lib.toPrecision)(tick, 10));
        }

        if (placeValuesInside) {
          getPos = (0, _polarUtil.polarToCartesian)(gaugeInnerRadius + axisPadding - axisConfig.polarPadding, theta);
        } else {
          getPos = (0, _polarUtil.polarToCartesian)(gaugeOuterRadius + axisPadding + axisConfig.polarPadding, theta);
        }

        getPos.x += centerX;
        getPos.y += centerY;
        axisAttrObj = {
          fill: style.color,
          'line-height': labelLineHeight,
          'text': text,
          'x': getPos.x,
          'y': getPos.y
        };

        if (getPos.x > centerX - 10 && getPos.x < centerX + 10 && getPos.y < centerY) {
          axisAttrObj['text-anchor'] = POSITION_MIDDLE;
          axisAttrObj['text-valign'] = placeValuesInside ? POSITION_TOP : POSITION_BOTTOM;
        } else if (getPos.x > centerX - 10 && getPos.x < centerX + 10 && getPos.y < centerY) {
          axisAttrObj['text-anchor'] = POSITION_MIDDLE;
          axisAttrObj['text-valign'] = placeValuesInside ? POSITION_BOTTOM : POSITION_TOP;
        } else if (getPos.x < centerX) {
          axisAttrObj['text-anchor'] = placeValuesInside ? POSITION_START : POSITION_END;
          axisAttrObj['text-valign'] = 'center';
        } else {
          axisAttrObj['text-anchor'] = placeValuesInside ? POSITION_END : POSITION_START;
          axisAttrObj['text-valign'] = 'center';
        }

        labelConf = labelStore[index] = labelStore[index] || {
          config: {
            props: {
              label: {
                attr: {}
              }
            }
          }
        };
        labelConf.config.props.label.attr = Object.assign(labelConf.config.props.label.attr, axisAttrObj);
      };

      for (i = 0; i < ticksLen; i += increment) {
        parsing(i);
      }

      if ((ticksLen - 1) % increment !== 0) {
        parsing(ticksLen - 1);
      }
    }
  }
  /**
   * Draws the axis labels
   *
   * @memberof PolarGaugeAxis
   */
  ;

  _proto._drawLabel = function _drawLabel() {
    var axis = this,
        axisConfig = axis.config,
        chart = axis.getFromEnv('chart'),
        axisRange = axisConfig.axisRange,
        labels = axisConfig.labels,
        style = labels.style,
        i,
        tick,
        max = axisRange.max,
        min = axisRange.min,
        axisContainer = axisConfig.axisLabelContainerTop,
        textElement,
        animationManager = chart.getFromEnv('animationManager'),
        css = {
      fontFamily: style.fontFamily,
      fontSize: style.fontSize,
      fontWeight: style.fontWeight,
      fontStyle: style.fontStyle,
      lineHeight: style.lineHeight
    },
        axisAttrObj,
        ticks = axisConfig.ticks,
        ticksLen = ticks.length,
        tickMap = [],
        ln,
        diff,
        increment,
        drawing,
        removingElement,
        textElementCheck; // Set visibility of axisContainer and apply css.

    axisContainer.show();
    axisContainer.css(css); // checking if labels are to be drawn user can decide or can be decided by axis placeAxis function

    if (axisConfig.labels.isDraw) {
      increment = axisConfig.labels.step;

      drawing = function drawing(index) {
        tick = ticks[index]; // if values are not limit value and label drawing is off other
        // than limit increment it and continue

        if (!axisConfig.labels.drawNormalVal && !(axisConfig.labels.drawLimitVal && (tick === min || tick === max))) {
          return;
        }

        if (!axisConfig.labels.drawNormalVal && !(tick === min || tick === max)) {
          return;
        } // if value are limit value but limit value are not mean to be drawn


        if (!axisConfig.labels.drawLimitVal && (tick === min || tick === max)) {
          return;
        } // if value is zero and show zero plane is off


        if (axisConfig.showZeroPlaneValue === 0 && axisConfig.showZeroPlane === 0 && tick === 0) {
          return;
        }

        tickMap.push(tick); // check if extra label element is present don't draw it just use it by changing the attributes

        textElementCheck = axis.getGraphicalElement("" + tick + LABEL_ID);
        axisAttrObj = axis.components.labels[index].config.props.label.attr; // create/reuse text element

        textElement = animationManager.setAnimation({
          el: textElementCheck || 'text',
          attr: axisAttrObj,
          container: axisContainer,
          component: axis,
          label: 'text'
        }); // Add to _graphics of axis if not present previously

        if (!textElementCheck) {
          axis.addGraphicalElement("" + tick + LABEL_ID, textElement);
        }
      };

      for (i = 0; i < ticksLen; i += increment) {
        drawing(i);
      }

      if ((ticksLen - 1) % increment !== 0) {
        drawing(ticksLen - 1);
      }
    }

    diff = (0, _diff.default)(axisConfig.prevIntervalArrLabel, tickMap);

    for (tick = 0, ln = diff.length; tick < ln; tick++) {
      removingElement = axis.getGraphicalElement("" + diff[tick] + LABEL_ID);
      removingElement && axis.removeGraphicalElement(removingElement);
    }

    axisConfig.prevIntervalArrLabel = tickMap;
  };

  _proto._drawTick = function _drawTick() {
    var axis = this,
        axisConfig = axis.config,
        drawTick = axisConfig.drawTick,
        axisScale = axis.getScale(),
        thetaMajor,
        thetaMinor,
        drawTickMinor = axisConfig.drawTickMinor,
        chart = axis.getFromEnv('chart'),
        animationManager = chart.getFromEnv('animationManager'),
        radius = axisConfig.radius,
        centerX = axisConfig.centerX,
        centerY = axisConfig.centerY,
        gaugeOuterRadius = (0, _lib.pluckNumber)(axisConfig.gaugeOuterRadius, radius),
        gaugeInnerRadius = (0, _lib.pluckNumber)(axisConfig.gaugeInnerRadius, radius),
        lineElement,
        minorTickObj,
        majorTickObj,
        statPix,
        endPixMajor,
        endPixMinor,
        i,
        minorV,
        tickGroup,
        diff,
        tempObj,
        tickValue,
        ticks = axisConfig.ticks,
        minorTickValues = axisConfig.minorTicks,
        majorTickCheck,
        prevTickMap,
        minorTickCheck,
        removingElement,
        ln;
    tickGroup = axisConfig.axisAxisLineContainer;
    majorTickObj = {
      stroke: axisConfig.majorTMColor,
      'stroke-width': axisConfig.majorTMThickness,
      'stroke-linecap': 'round'
    };
    minorTickObj = {
      stroke: axisConfig.minorTMColor,
      'stroke-width': axisConfig.minorTMThickness,
      'stroke-linecap': 'round'
    }; // Set visibility of tickGroup

    tickGroup.show();
    prevTickMap = axisConfig.prevTickMarks; // when ticks are not drawn

    axisConfig.prevTickMarks = []; // checking if lines are to be drawn user can decide

    if (axisConfig.lines.isDraw && drawTick && axisConfig.showTickMarks) {
      axisConfig.prevTickMarks = ticks.slice();

      for (i = 0; i < ticks.length; i++) {
        tickValue = ticks[i];
        thetaMajor = axisScale.getRangeValue(tickValue);

        if (!axisConfig.placeTicksInside) {
          statPix = (0, _polarUtil.polarToCartesian)(gaugeOuterRadius, thetaMajor);
          endPixMajor = (0, _polarUtil.polarToCartesian)(gaugeOuterRadius - axisConfig.majorTMHeight, thetaMajor);
        } else {
          statPix = (0, _polarUtil.polarToCartesian)(gaugeInnerRadius, thetaMajor);
          endPixMajor = (0, _polarUtil.polarToCartesian)(gaugeInnerRadius + axisConfig.majorTMHeight, thetaMajor);
        }

        statPix.x += centerX;
        statPix.y += centerY;
        endPixMajor.x += centerX;
        endPixMajor.y += centerY;
        majorTickObj.path = 'M' + statPix.x + ' ' + statPix.y + 'L' + endPixMajor.x + ' ' + endPixMajor.y;
        tempObj = Object.assign({}, majorTickObj);
        majorTickCheck = axis.getGraphicalElement("" + ticks[i] + TICK);
        lineElement = animationManager.setAnimation({
          el: majorTickCheck || 'path',
          attr: tempObj,
          container: tickGroup,
          component: axis,
          label: 'path'
        });

        if (!majorTickCheck) {
          axis.addGraphicalElement("" + ticks[i] + TICK, lineElement);
        }
      }

      if (drawTickMinor) {
        axisConfig.prevTickMarks = axisConfig.prevTickMarks.concat(minorTickValues);

        for (i = 0; i < minorTickValues.length; i += 1) {
          minorV = minorTickValues[i];
          thetaMinor = axisScale.getRangeValue(minorV);

          if (!axisConfig.placeTicksInside) {
            statPix = (0, _polarUtil.polarToCartesian)(gaugeOuterRadius, thetaMinor);
            endPixMinor = (0, _polarUtil.polarToCartesian)(gaugeOuterRadius - axisConfig.minorTMHeight, thetaMinor);
          } else {
            statPix = (0, _polarUtil.polarToCartesian)(gaugeInnerRadius, thetaMinor);
            endPixMinor = (0, _polarUtil.polarToCartesian)(gaugeInnerRadius + axisConfig.minorTMHeight, thetaMinor);
          }

          statPix.x += centerX;
          statPix.y += centerY;
          endPixMinor.x += centerX;
          endPixMinor.y += centerY;
          minorTickObj.path = 'M' + statPix.x + ' ' + statPix.y + 'L' + endPixMinor.x + ' ' + endPixMinor.y;
          tempObj = Object.assign({}, minorTickObj); // reuse the elements if there

          minorTickCheck = axis.getGraphicalElement("" + minorTickValues[i] + TICK);
          lineElement = animationManager.setAnimation({
            el: minorTickCheck || 'path',
            attr: tempObj,
            container: tickGroup,
            component: axis,
            label: 'path'
          });

          if (!minorTickCheck) {
            axis.addGraphicalElement("" + minorTickValues[i] + TICK, lineElement);
          }
        }
      }
    }

    diff = (0, _diff.default)(prevTickMap, axisConfig.prevTickMarks);

    for (i = 0, ln = diff.length; i < ln; i++) {
      removingElement = axis.getGraphicalElement("" + diff[i] + TICK);
      removingElement && axis.removeGraphicalElement(removingElement);
    }
  };

  _proto._drawTrendLine = function _drawTrendLine() {
    var _ref;

    var axis = this,
        axisConfig = axis.config,
        axisRange = axisConfig.axisRange,
        toolTipController = axis.getFromEnv('toolTipController'),
        max = axisRange.max,
        markerLabelOffset,
        axisScale = axis.getScale(),
        theta,
        min = axisRange.min,
        canvas = axisConfig.canvas,
        chart = axis.getFromEnv('chart'),
        chartConfig = chart.config,
        smartLabel = chart.getFromEnv('smartLabel'),
        colorM = chart.getFromEnv('color-manager'),
        animationManager = chart.getFromEnv('animationManager'),
        scaleFactor = axisConfig.scaleFactor,
        centerX = axisConfig.centerX || 0,
        centerY = axisConfig.centerY || 0,
        canvasWidth = canvas.canvasWidth || chartConfig.canvasWidth,
        style = axisConfig.trend.trendStyle,
        axisTrendContainerTop = axisConfig.axisTrendContainerTop,
        axisTrendContainerBottom = axisConfig.axisTrendContainerBottom,
        axisTrendLabelContainer = axisConfig.axisTrendLabelContainer,
        css = {
      fontFamily: style.fontFamily,
      fontSize: style.fontSize,
      lineHeight: style.lineHeight,
      fontWeight: style.fontWeight,
      fontStyle: style.fontStyle
    },
        numberFormatter = chart.getFromEnv('number-formatter'),
        trendPoints = axisConfig.trendPoints,
        point = trendPoints && trendPoints.point,
        deg2rad = math.PI / 180,
        trendText = {},
        i,
        totalPoints = (_ref = point && point.length) != null ? _ref : 0,
        trendElement,
        trendElemenCheck,
        trendLabelElementCheck,
        trendLabelElement,
        isTrendZone,
        axisDrawingAttrObj = {},
        axisMarkerAttrObj = {},
        axisTextAttrObj = {},
        trendPointObj,
        startValue,
        endValue,
        overlappingArray,
        AttrList,
        sides,
        limitingValue,
        limitingNegValue,
        trendOuterRadius,
        trendInnerRadius,
        startPoints,
        startPoints1,
        startX,
        startY,
        startX1,
        startY1,
        trendEndAngle,
        trendStartAngle,
        textValue,
        cosTh,
        sinTh,
        trendTextWidth,
        textRadius,
        align,
        trendTextHeight,
        stHeight,
        trendMarkerElement,
        trendMarkerCheck,
        trendValues = [],
        idStart,
        diff,
        removingElement,
        removingElementLabel,
        removingElementMarker,
        ln; // if trendline object is present iterate through the object to draw

    smartLabel.useEllipsesOnOverflow(chartConfig.useEllipsesWhenOverflow);
    smartLabel.setStyle(css);

    for (i = 0; i < totalPoints; i += 1) {
      trendPointObj = trendPoints.point[i];
      trendValues.push(trendPointObj.startvalue + '_' + trendPointObj.endvalue + '_' + i);
    }

    diff = (0, _diff.default)(axisConfig.prevIntervalArrTrendLine, trendValues);

    for (i = 0, ln = diff.length; i < ln; i++) {
      removingElement = axis.getGraphicalElement("" + diff[i] + TRENDLINE_ID);
      removingElementLabel = axis.getGraphicalElement("" + diff[i] + TRENDLABEL_ID);
      removingElementMarker = axis.getGraphicalElement("" + diff[i] + TRENDMARKER_ID);
      removingElement && axis.removeGraphicalElement(removingElement);
      removingElementLabel && axis.removeGraphicalElement(removingElementLabel);
      removingElementMarker && axis.removeGraphicalElement(removingElementMarker);
    }

    axisConfig.prevIntervalArrTrendLine = trendValues.slice(); // Iterating through the trendPoints array to find overlapping points

    for (var k = 0; k < totalPoints; k++) {
      var currentTrendPoint = trendPoints.point[k];

      for (var j = k + 1; j < totalPoints; j++) {
        var nextTrendPoint = trendPoints.point[j],
            currStartValue = (0, _lib.pluckNumber)(currentTrendPoint.startvalue, currentTrendPoint.value),
            currEndValue = (0, _lib.pluckNumber)(currentTrendPoint.endvalue, currStartValue),
            nextStartValue = (0, _lib.pluckNumber)(nextTrendPoint.startvalue, nextTrendPoint.value),
            nextEndValue = (0, _lib.pluckNumber)(nextTrendPoint.endvalue, nextStartValue),
            key = currStartValue + "_" + currEndValue;
        overlappingArray = overLappingPoints[key];

        if (currStartValue === nextStartValue && currEndValue === nextEndValue) {
          if (!overlappingArray) {
            overLappingPoints[key] = [];
            overlappingArray = overLappingPoints[key];
          }

          this.addToOverlappingPoints(currentTrendPoint.displayvalue, key);
          this.addToOverlappingPoints(nextTrendPoint.displayvalue, key);
        }
      }
    }

    for (i = 0; i < totalPoints; i += 1) {
      var _trendPointObj;

      trendPointObj = trendPoints.point[i];
      markerLabelOffset = (0, _lib.pluckNumber)((_trendPointObj = trendPointObj) == null ? void 0 : _trendPointObj.markerlabeloffset, 0);
      idStart = trendPointObj.startvalue + '_' + trendPointObj.endvalue + '_' + i;
      startValue = (0, _lib.pluckNumber)(trendPointObj.startvalue, trendPointObj.value);
      endValue = (0, _lib.pluckNumber)(trendPointObj.endvalue, startValue);
      theta = axisScale.getRangeValue(startValue);
      isTrendZone = startValue !== endValue;
      overlappingArray = overLappingPoints[startValue + "_" + endValue];

      if (startValue <= max && startValue >= min && endValue <= max && endValue >= min) {
        AttrList = {
          startValue: startValue,
          endValue: endValue,
          tooltext: (0, _lib.getValidValue)((0, _lib.parseUnsafeString)(trendPointObj.markertooltext, false)),
          displayValue: (0, _lib.getValidValue)((0, _lib.parseUnsafeString)(trendPointObj.displayvalue), isTrendZone ? BLANKSTRING : numberFormatter.scale(startValue)),
          showOnTop: (0, _lib.pluckNumber)(trendPointObj.showontop, axisConfig.ticksBelowGauge, axisConfig.ticksBelowGraph, 1),
          color: (0, _lib.pluck)(trendPointObj.color, colorM.getColor('trendLightColor')),
          alpha: (0, _lib.pluckNumber)(trendPointObj.alpha, 99),
          thickness: (0, _lib.pluckNumber)(trendPointObj.thickness, 1),
          dashStyle: trendPointObj.dashed ? (0, _lib.getDashStyle)(trendPointObj.dashlen || 2, trendPointObj.dashgap || 2) : '',
          // Marker properties
          useMarker: (0, _lib.pluckNumber)(trendPointObj.usemarker, 0),
          markerColor: (0, _lib.convertColor)((0, _lib.pluck)(trendPointObj.markercolor, trendPointObj.color, colorM.getColor('trendLightColor')), 100),
          markerBorderColor: (0, _lib.convertColor)((0, _lib.pluck)(trendPointObj.markerbordercolor, trendPointObj.bordercolor, colorM.getColor('trendDarkColor')), 100),
          markerRadius: (0, _lib.pluckNumber)((0, _lib.pluckNumber)(trendPointObj.markerradius) * scaleFactor, 5),
          markerToolText: (0, _lib.getFirstValue)(trendPointObj.markertooltext),
          trendValueDistance: (0, _lib.pluckNumber)((0, _lib.pluckNumber)(trendPointObj.trendvaluedistance, axisConfig.trendValueDistance) * scaleFactor, axisConfig.tickValueDistance),
          // calcullated
          isTrendZone: isTrendZone,
          // extra for angular gauge
          valueInside: (0, _lib.pluckNumber)(trendPointObj.valueinside, axisConfig.placeValuesInside, 0),
          showBorder: (0, _lib.pluckNumber)(trendPointObj.showborder, 1),
          borderColor: (0, _lib.convertColor)((0, _lib.pluck)(trendPointObj.bordercolor, trendPointObj.color, colorM.getColor('trendDarkColor')), (0, _lib.pluckNumber)(trendPointObj.borderalpha, trendPointObj.alpha, 100)),
          radius: (0, _lib.pluckNumber)((0, _lib.pluckNumber)(trendPointObj.radius) * scaleFactor),
          innerRadius: (0, _lib.pluckNumber)((0, _lib.pluckNumber)(trendPointObj.innerradius) * scaleFactor)
        };
        sides = 3;
        limitingValue = Math.cos(89.99 * deg2rad);
        limitingNegValue = -limitingValue;
        trendOuterRadius = (0, _lib.pluckNumber)(AttrList.radius, axisConfig.gaugeOuterRadius);
        trendInnerRadius = (0, _lib.pluckNumber)(AttrList.innerRadius, isTrendZone ? Math.max(axisConfig.gaugeInnerRadius - 15, 0) : axisConfig.gaugeInnerRadius);
        startPoints = (0, _polarUtil.polarToCartesian)(trendOuterRadius, theta);
        startPoints1 = (0, _polarUtil.polarToCartesian)(trendInnerRadius, theta);
        startPoints.x += centerX;
        startPoints.y += centerY;
        startPoints1.x += centerX;
        startPoints1.y += centerY;
        startX = startPoints.x;
        startY = startPoints.y;
        startX1 = startPoints1.x;
        startY1 = startPoints1.y;
        trendEndAngle = axis.getAngle(endValue);
        trendStartAngle = axis.getAngle(startValue);

        if (isTrendZone) {
          // If start angle > end angle then swap the two for intended
          // behavior.
          if (trendStartAngle > trendEndAngle) {
            trendStartAngle += trendEndAngle;
            trendEndAngle = trendStartAngle - trendEndAngle;
            trendStartAngle = trendStartAngle - trendEndAngle;
          }

          axisDrawingAttrObj = {
            fill: (0, _lib.convertColor)(AttrList.color, AttrList.alpha),
            'stroke-width': AttrList.showBorder ? AttrList.thickness : 0,
            stroke: AttrList.borderColor,
            'stroke-dasharray': AttrList.dashStyle,
            ringpath: [centerX, centerY, trendOuterRadius, trendInnerRadius, trendStartAngle, trendEndAngle]
          };
        } else {
          axisDrawingAttrObj = {
            'stroke-width': AttrList.showBorder ? AttrList.thickness : 0,
            stroke: AttrList.borderColor,
            'stroke-linecap': 'round',
            'stroke-dasharray': AttrList.dashStyle,
            path: [M, startX, startY, L, startX1, startY1]
          };
        } // if it has marker then add it


        if (AttrList.useMarker) {
          axisMarkerAttrObj = {
            fill: AttrList.markerColor,
            'stroke-width': 1,
            stroke: AttrList.markerBorderColor,
            polypath: [sides, startX, startY, AttrList.markerRadius, (-trendStartAngle + Math.PI) / deg2rad, 0]
          };
        } else {
          axisMarkerAttrObj = {};
        } // draw the text if any


        if (AttrList.displayValue !== BLANKSTRING) {
          textValue = (AttrList.endValue + AttrList.startValue) / 2;
          trendEndAngle = axis.getAngle(textValue);
          cosTh = Math.cos(trendEndAngle);
          sinTh = Math.sin(trendEndAngle);
          trendTextWidth = smartLabel.getOriSize(AttrList.displayValue).width;

          if (AttrList.valueInside) {
            textRadius = trendInnerRadius - 2 - AttrList.trendValueDistance;
            align = cosTh > limitingValue ? POSITION_END : cosTh < limitingNegValue ? POSITION_START : POSITION_MIDDLE;
          } else {
            textRadius = trendOuterRadius + 2 + AttrList.trendValueDistance;
            align = cosTh > limitingValue ? POSITION_START : cosTh < limitingNegValue ? POSITION_END : POSITION_MIDDLE;
          }

          startX = centerX + textRadius * cosTh;
          startY = centerY + textRadius * sinTh;
          trendTextHeight = smartLabel.getOriSize(AttrList.displayValue).height;
          trendText = smartLabel.getSmartText(AttrList.displayValue, canvasWidth, trendTextHeight); // check whether the text goes out of canvas on basis of it's width and
          // draw text accordingly by re-calculating it's x-coordinate

          startX = canvasWidth < startX + trendTextWidth ? canvasWidth - trendTextWidth - GUTTER_PADDING : startX < trendTextWidth ? trendTextWidth + GUTTER_PADDING : startX; // check whether the startX goes out of canvas

          if (trendTextWidth > canvasWidth) {
            startX = canvasWidth / 2;
          }

          axisTextAttrObj = {
            fill: (0, _lib.convertColor)(trendPointObj.color, AttrList.alpha) || style.color,
            text: trendText.text,
            'text-anchor': align,
            'vertical-align': POSITION_TOP,
            'text-bound': [style.backgroundColor, style.borderColor, style.borderThickness, style.borderPadding, style.borderRadius, style.borderDash],
            x: startX,
            y: startY
          }; // adjust with the bbox

          stHeight = trendText.height; // set the text Y

          if (cosTh > limitingValue || cosTh < limitingNegValue) {
            startY += -(stHeight / 2) + stHeight * 0.4 * sinTh * (AttrList.valueInside ? -1 : 1);
          } else {
            if (AttrList.valueInside) {
              startY += -(sinTh < 0 ? 0 : stHeight);
            } else {
              startY += -(sinTh > 0 ? 0 : stHeight);
            }
          }

          var _this$adjustTextPosit = this.adjustTextPositionToAvoidOverlap(AttrList, startY, Math.round((max + min) / 2), startX, markerLabelOffset),
              adjustedStartY = _this$adjustTextPosit.adjustedStartY,
              adjustedStartX = _this$adjustTextPosit.adjustedStartX;

          axisTextAttrObj.y = adjustedStartY;
          axisTextAttrObj.x = adjustedStartX;
        } else {
          axisTextAttrObj = {
            text: BLANKSTRING
          };
        } // reuse the elements if there


        trendElemenCheck = axis.getGraphicalElement(idStart + TRENDLINE_ID);
        trendLabelElementCheck = axis.getGraphicalElement(idStart + TRENDLABEL_ID);
        trendMarkerCheck = axis.getGraphicalElement(idStart + TRENDMARKER_ID); // Create/Reuse trend element

        trendElement = isTrendZone ? animationManager.setAnimation({
          el: trendElemenCheck || 'ringpath',
          attr: axisDrawingAttrObj,
          container: axisTrendContainerBottom,
          component: axis,
          label: 'ringpath'
        }) : animationManager.setAnimation({
          el: trendElemenCheck || 'path',
          attr: axisDrawingAttrObj,
          container: axisTrendContainerTop,
          component: axis,
          label: 'path'
        });
        trendElement.show();
        trendElement.data('label', isTrendZone ? 'ringPath' : 'path'); // Create/reuse label

        trendLabelElement = animationManager.setAnimation({
          el: trendLabelElementCheck || 'text',
          attr: axisTextAttrObj,
          container: axisTrendLabelContainer,
          component: axis,
          label: 'text'
        });
        trendLabelElement.css(css);
        trendLabelElement.show(); // Create/Reuse marker element

        trendMarkerElement = animationManager.setAnimation({
          el: trendMarkerCheck || 'polypath',
          attr: axisMarkerAttrObj,
          container: axisTrendContainerTop,
          component: axis,
          label: 'polypath'
        });
        trendMarkerElement.show(); // Attach tooltip if applicable

        if (axisConfig.showTooltip) {
          if (trendText.oriText && !overLappingPoints[startValue + "_" + endValue]) {
            toolTipController.enableToolTip(trendLabelElement, trendText.oriText + ": " + startValue + " " + (endValue === startValue ? '' : '- ' + endValue));
          } else {
            toolTipController.disableToolTip(trendLabelElement);
          }

          if (AttrList.markerToolText) {
            toolTipController.enableToolTip(trendMarkerElement, AttrList.markerToolText);
          } else {
            toolTipController.disableToolTip(trendMarkerElement);
          }

          if (Array.isArray(overlappingArray) && overlappingArray.length > 1 && overlappingArray.includes(trendPointObj.displayvalue)) {
            var combinedToolTipText = this.getCombinedTooltip(overlappingArray, startValue, endValue);
            toolTipController.enableToolTip(trendLabelElement, combinedToolTipText);
          }
        }

        if (!trendElemenCheck) {
          axis.addGraphicalElement(idStart + TRENDLINE_ID, trendElement);
        }

        if (!trendElemenCheck) {
          axis.addGraphicalElement(idStart + TRENDLABEL_ID, trendLabelElement);
        }

        if (!trendMarkerCheck) {
          axis.addGraphicalElement(idStart + TRENDMARKER_ID, trendMarkerElement);
        }
      }
    }
  }
  /**
  * Adjusts the Y position of the current trend text to avoid overlap with adjacent trend texts.
  *
  * @param {Object} currentAttrList - The attribute list for the current trend text.
  * @param {number} currentStartY - The current Y position of the trend text.
  * @returns {Object} - An object containing information about the adjustment.
  *   - isOverlapping {boolean} - Indicates whether the text was adjusted to avoid overlap.
  *   - adjustedStartY {number} - The adjusted Y position of the trend text.
  */
  ;

  _proto.adjustTextPositionToAvoidOverlap = function adjustTextPositionToAvoidOverlap(currentAttrList, currentStartY, mid, currentStartX, markerLabelOffset) {
    var minimumSpaceBetween = 11,
        startValue = currentAttrList.startValue,
        endValue = currentAttrList.endValue,
        isLessThanMid = startValue < mid || endValue < mid ? -1 : 1,
        labelOffset = Number(markerLabelOffset),
        xOffSet = (0, _lib.pluckNumber)(labelOffset, 0),
        adjustedStartX = currentStartX + xOffSet * isLessThanMid,
        shouldSpaceBetween = 14; // The new difference between overlapping data points, This is customizable

    this.overLapped = false;
    this.startY = currentStartY;

    for (var j = 0; j < trendTextPositions.length; j += 1) {
      var adjacentStartY = trendTextPositions[j],
          isOverlapping = Math.abs(this.startY - adjacentStartY) < minimumSpaceBetween;

      if (isOverlapping) {
        this.startY += shouldSpaceBetween * isLessThanMid;
        this.overLapped = true;
      }
    } // Store the current Y position in the array


    trendTextPositions.push(this.startY);
    return {
      isOverlapping: this.overLapped,
      adjustedStartY: this.startY,
      adjustedStartX: adjustedStartX
    };
  }
  /**
   * Generates a combined tooltip string for displaying multiple values along with start and end values.
   * @param {Array} displayValues - Array of display values to be included in the tooltip.
   * @param {string|number} startValue - The starting value of the trend.
   * @param {string|number} endValue - The ending value of the trend.
   * @returns {string} - Combined tooltip string.
   */
  ;

  _proto.getCombinedTooltip = function getCombinedTooltip(displayValues, startValue, endValue) {
    var _displayValues$length;

    this.tipString = '';
    var i = (_displayValues$length = displayValues.length) != null ? _displayValues$length : 0;

    while (i-- > 0) {
      var stringToAdd = displayValues[i] + ": " + startValue + " " + (endValue === startValue ? '' : '- ' + endValue) + " ::";
      this.tipString = stringToAdd + this.tipString;
    }

    return this.tipString.split('::').filter(function (t) {
      return t !== '';
    }).join(',<br/>');
  };

  _proto.addToOverlappingPoints = function addToOverlappingPoints(value, key) {
    this.overlappingArray = overLappingPoints[key];

    if (this.overlappingArray && !this.overlappingArray.includes(value)) {
      this.overlappingArray.push(value);
    }
  };

  return PolarGaugeAxis;
}(_gaugePolarNumeric.default);

var _default = PolarGaugeAxis;
exports["default"] = _default;

/***/ }),

/***/ 1519:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _lib = __webpack_require__(274);

var _componentInterface = __webpack_require__(290);

var sortColorFN = (0, _lib.getComparatorFN)(true, 'minvalue'),
    UNDEF; // Class for managing gradient color range

var ColorGradient = /*#__PURE__*/function (_ComponentInterface) {
  (0, _inheritsLoose2.default)(ColorGradient, _ComponentInterface);

  function ColorGradient() {
    return _ComponentInterface.apply(this, arguments) || this;
  }

  var _proto = ColorGradient.prototype;

  /**
   * Sets the type of the component
   * @return {string} type
   */
  _proto.getType = function getType() {
    return 'colorComponent';
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */
  ;

  _proto.getName = function getName() {
    return 'colorGradient';
  };

  _proto.configure = function configure(options) {
    var cm = this,
        oldColorArr = cm.colorArr,
        colorManager = cm.getFromEnv('color-manager'),
        numberFormatter = cm.getFromEnv('number-formatter'),
        colorArr = options.colorRange && (0, _lib.extend2)({}, options.colorRange).color,
        defuPaletteOptions = colorManager.getColor('paletteColors'),
        defaultObj,
        colorObj,
        colorObjNext,
        i,
        l,
        temp,
        newColorRange,
        j,
        newMin,
        nextIndex; // removing due to defaultAsigned retaining false after update

    delete cm.defaultAsigned;

    if (!(defuPaletteOptions instanceof Array)) {
      defuPaletteOptions = colorManager.getPlotColor(0);
    }

    if (colorArr && colorArr.length > 0) {
      l = colorArr.length - 1; // validate all color object
      // remove invalid obj

      for (i = l; i >= 0; i -= 1) {
        colorObj = colorArr[i];

        if (colorObj) {
          colorObj.minvalue = numberFormatter.getCleanValue(colorObj.minvalue);
          colorObj.maxvalue = numberFormatter.getCleanValue(colorObj.maxvalue); // for not specified min/max value

          if (colorObj.minvalue === null) {
            if (colorObj.maxvalue !== null) {
              colorObj.minvalue = colorObj.maxvalue;
            } else if (i !== l) {
              // remove invalid color range
              colorArr.splice(i, 1);
            }
          }

          if (colorObj.label !== UNDEF) {
            colorObj.label = (0, _lib.parseUnsafeString)(colorObj.label);
          }

          if (colorObj.name !== UNDEF) {
            colorObj.name = (0, _lib.parseUnsafeString)(colorObj.name);
          }

          if (colorObj.maxvalue !== null) {
            if (colorObj.minvalue > colorObj.maxvalue) {
              // alter the value
              temp = colorObj.minvalue;
              colorObj.minvalue = colorObj.maxvalue;
              colorObj.maxvalue = temp;
            }
          }
        }
      } // now sort colors


      colorArr.sort(sortColorFN); // Put the default Color if color not given in color Obj

      if (!colorArr[0].code) {
        colorArr[0].code = defuPaletteOptions[0];
      } // Put the default Alpha if Alpha not given in color Obj


      if ((0, _lib.getValidValue)(colorArr[0].alpha) === UNDEF) {
        colorArr[0].alpha = _lib.HUNDREDSTRING;
      } // now devide overlaping color ranges


      for (i = 0, l = colorArr.length - 1; i < l; i += 1) {
        nextIndex = i + 1;
        colorObj = colorArr[i];
        colorObjNext = colorArr[nextIndex]; // Put the default Color if color not given in color Obj

        if (!colorObjNext.code) {
          colorObjNext.code = defuPaletteOptions[nextIndex];
        } // Put the default Alpha if Alpha not given in color Obj


        if ((0, _lib.getValidValue)(colorObjNext.alpha) === UNDEF) {
          colorObjNext.alpha = _lib.HUNDREDSTRING;
        } // if maxColor is null


        if (colorObj.maxvalue === null) {
          colorObj.maxvalue = colorObjNext.minvalue;
        }

        if (colorObj.maxvalue > colorObjNext.minvalue) {
          if (colorObj.maxvalue > colorObjNext.maxvalue) {
            newColorRange = (0, _lib.extend2)(colorObj);
            newColorRange.maxvalue = colorObj.maxvalue;
            newMin = newColorRange.minvalue = colorObjNext.maxvalue; // insert newColorRange into proper position

            j = i + 2;

            while (j < l && colorArr[j].minvalue < newMin) {
              j += 1;
            }

            colorArr.splice(j, 0, newColorRange);
            l += 1; // legth increased
          }

          colorObj.maxvalue = colorObjNext.minvalue;
        }
      } // if last color has null maxvalue


      colorObj = colorArr[i]; // if maxColor is null

      if (colorObj.maxvalue === null) {
        colorObj.maxvalue = colorObj.minvalue;
      }
    } // If no color array is present, use default color array


    if (!(colorArr && colorArr.length)) {
      if (!defaultObj) {
        defaultObj = {
          code: 'CCCCCC',
          alpha: '100',
          bordercolor: '000000',
          borderalpha: '100'
        };
      }

      colorArr = [defaultObj];
      cm.defaultAsigned = true;
    }

    cm.colorArr = colorArr || oldColorArr;
  };

  _proto.getColorObj = function getColorObj(value) {
    var colorArr = this.colorArr,
        i = 0,
        l = colorArr.length,
        colorObj,
        nextColorObj,
        returnedObj = {};

    for (; i < l; i += 1) {
      returnedObj.index = i;
      colorObj = colorArr[i];
      nextColorObj = colorArr[i + 1];

      if (value < colorObj.minvalue) {
        returnedObj.nextObj = colorObj;
        return returnedObj;
      }

      if (value >= colorObj.minvalue && value <= colorObj.maxvalue) {
        returnedObj.colorObj = colorObj;

        if (nextColorObj && value === nextColorObj.minvalue) {
          // at the border of two color point
          returnedObj.nextObj = nextColorObj;
          returnedObj.isOnMeetPoint = true;
        }

        return returnedObj;
      }

      returnedObj.prevObj = colorObj;
    }

    returnedObj.index = i - 1;
    return returnedObj;
  };

  _proto.getColorRangeArr = function getColorRangeArr(_minValue, _maxValue) {
    var temp,
        colorArr = this.colorArr,
        i,
        l,
        minColorObj,
        lastMaxValue,
        maxColorObj,
        returnArr = [],
        colorObj,
        lastColorObj,
        minValue = _minValue,
        maxValue = _maxValue;

    if (!this.defaultAsigned) {
      if (minValue > maxValue) {
        // Swap
        temp = minValue;
        minValue = maxValue;
        maxValue = temp;
      }

      if (minValue < maxValue) {
        minColorObj = this.getColorObj(minValue);
        maxColorObj = this.getColorObj(maxValue);

        if (minColorObj && maxColorObj) {
          lastMaxValue = minValue;
          i = minColorObj.index;
          l = maxColorObj.index;

          for (; i <= l; i += 1) {
            colorObj = (0, _lib.extend2)({}, colorArr[i]);

            if (colorObj.minvalue !== lastMaxValue) {
              colorObj.minvalue = lastMaxValue;
            }

            returnArr.push(colorObj);
            lastColorObj = colorObj;
            lastMaxValue = colorObj.maxvalue;
          }

          lastColorObj.maxvalue = maxValue;
        }
      }
    }

    return returnArr;
  };

  return ColorGradient;
}(_componentInterface.ComponentInterface);

var _default = ColorGradient;
exports["default"] = _default;

/***/ }),

/***/ 1498:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



exports.__esModule = true;
exports._getData = _getData;
exports._setData = _setData;
exports._getDataForId = _getDataForId;
exports._setDataForId = _setDataForId;

var _lib = __webpack_require__(274);

var _schedular = __webpack_require__(286);

var STREAM_PREFIX = 'value=';

function _getData(_index, callback) {
  var iapi = this,
      components = iapi.getChildren(),
      dataset = components.dataset,
      data,
      dataObj,
      index = _index,
      _helperFn = function _helperFn() {
    dataObj = dataset[0].components.data;

    if (dataObj && dataObj[--index]) {
      data = dataObj[index].config;
      return (0, _lib.pluckNumber)(data.setValue, data.itemValue);
    }

    return null;
  };

  if (dataset) {
    if (typeof callback === 'function') {
      iapi.addJob('eiMethods', function () {
        callback(_helperFn());
      }, _schedular.priorityList.postRender);
    } else {
      return _helperFn();
    }
  }
}

function _setData(dialIndex, value) {
  var stream = STREAM_PREFIX,
      i;

  if (dialIndex === _lib.UNDEF || dialIndex === null || value === _lib.UNDEF || value === null) {
    return;
  }

  for (i = 1; i < Number(dialIndex); i++) {
    stream += _lib.COMMASTRING;
  }

  if (value.toString) {
    stream += value.toString();
  }

  if (stream) {
    this.feedData(stream);
  }
}

function _getDataForId(id, callback) {
  var iapi = this,
      dataset = iapi.getChildren('dataset')[0],
      idMap = dataset.config.idMap;

  if (typeof callback === 'function') {
    iapi.addJob('eiMethods', function () {
      callback(idMap && idMap[id] && idMap[id].config.itemValue || null);
    }, _schedular.priorityList.postRender);
  } else {
    return idMap && idMap[id] && idMap[id].config.itemValue || null;
  }
}

function _setDataForId(id, value) {
  var iapi = this,
      dataset = iapi.getChildren('dataset')[0],
      idMap = dataset.config.idMap;
  return idMap && idMap[id] && iapi._setData(idMap[id].index + 1, value);
}

/***/ }),

/***/ 1511:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports.configureAttributes = configureAttributes;
exports._getData = _getData;

var _lib = __webpack_require__(274);

var _colorBucket = _interopRequireDefault(__webpack_require__(1446));

function configureAttributes() {
  var iapi = this,
      jsonData = iapi.getFromEnv('dataSource'),
      colorrange = jsonData.colorrange; // If color array is present and contains non-zero color elements

  if (colorrange && colorrange.color && colorrange.color.length) {
    (0, _lib.componentFactory)(iapi, _colorBucket.default, 'colorRange', 1, [{
      colorRange: colorrange,
      numberFormatter: iapi.getFromEnv('number-formatter')
    }]);
    iapi.addToEnv('colorRange', iapi.getChildren('colorRange') && iapi.getChildren('colorRange')[0]);
  } else {
    iapi.deleteFromEnv('colorRange');
  }
}

function _getData() {
  var iapi = this,
      dataset = iapi.getDatasets(),
      data,
      dataObj;

  if (dataset) {
    dataObj = dataset[0].components.data;

    if (dataObj && dataObj[0]) {
      data = dataObj[0].config;
      return (0, _lib.pluckNumber)(data.setValue, data.itemValue);
    }
  }
}

/***/ }),

/***/ 1481:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _assertThisInitialized2 = _interopRequireDefault(__webpack_require__(292));

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _ajax = _interopRequireDefault(__webpack_require__(370));

var _componentInterface = __webpack_require__(290);

var _lib = __webpack_require__(274);

/* eslint require-jsdoc: 'error', valid-jsdoc: ["error", { "requireReturn": false }] */
var MS_MULTIPLIER = 1000;

var UNDEF,
    THRESHOLD_MS = 10,

/**
 * Function to initialize the the DataStreamer class
 * @param {Object} chart The chart object
 */
initializeDataStreamer = function initializeDataStreamer(chart) {
  chart.registerFactory('dataStreamer', function () {
    var ds;

    if (DataStreamer && chart.config.realtimeEnabled) {
      (0, _lib.componentFactory)(chart, DataStreamer, 'dataStreamer', 1);
      ds = chart.getChildren('dataStreamer')[0];
      ds.configure();
      chart.addToEnv('dataStreamer', ds);
    }
  });
},
    dataStreamerExt = {},
    onFcInstantiated = function onFcInstantiated(event) {
  var component = event.sender;

  if (component.getType() === 'chartAPI') {
    initializeDataStreamer(component);
  }
};
/**
 * Class for DataStreamer
 */


var DataStreamer = /*#__PURE__*/function (_ComponentInterface) {
  (0, _inheritsLoose2.default)(DataStreamer, _ComponentInterface);

  /**
   * constructor fn
   */
  function DataStreamer() {
    var _this2;

    _this2 = _ComponentInterface.call(this) || this;

    _this2._handlerFn = function (_this) {
      return function () {
        var config = _this.config;

        if (config) {
          config.rtPreInit === UNDEF && (config.rtPreInit = false);
          config._rtPaused && delete config._rtPaused;

          if (!config.rtStateChanged) {
            config.rtStateChanged = true; // If the event happens to happen while rendering is inprogress, we need to force process.

            _this.processRealtimeStateChange(arguments);
          }
        }
      };
    }((0, _assertThisInitialized2.default)(_this2));

    _this2._handlerStop = function (_this) {
      return function () {
        _this._dispose();
      };
    }((0, _assertThisInitialized2.default)(_this2));

    return _this2;
  }
  /**
   * Sets the type of the component
   * @return {string} type
   */


  var _proto = DataStreamer.prototype;

  _proto.getType = function getType() {
    return 'dataStreamer';
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */
  ;

  _proto.getName = function getName() {
    return 'dataStreamer';
  }
  /**
   * This function is to compact the routine of clearing and re-applying a timeout
   *
   * @example
   * to = resetTimeout(theFunction, 500, to);
   *
   * @param {Function} fn funstion to executes on a timeout
   * @param {number} ms timeout in mili second
   * @param {number} id timeout ID
   * @return {number} timeout ID
   */
  ;

  DataStreamer.resetTimeout = function resetTimeout(fn, ms, id) {
    clearTimeout(id);
    return setTimeout(fn, ms);
  }
  /**
   * Function to configure the dataStreamer class instance
   * @param {Object} chartObj The chart instance
   */
  ;

  _proto.configure = function configure() {
    var ds = this,
        config = ds.config,
        refreshMs,
        updateMs,
        chartObj,
        chart = ds.getLinkedParent(),
        realTimeConfig,
        chartAttr = chart.getFromEnv('dataSource') && chart.getFromEnv('dataSource').chart;
    chartObj = chart.getFromEnv('chartInstance');
    realTimeConfig = chart.config.realTimeConfig;
    config.clearMs = realTimeConfig.clearInterval * MS_MULTIPLIER;
    config.updateMs = updateMs = realTimeConfig.updateInterval * MS_MULTIPLIER;
    config.refreshMs = refreshMs = realTimeConfig.refreshInterval * MS_MULTIPLIER;
    ds.addEvents();

    if (refreshMs < updateMs) {
      config.refreshMs = updateMs;
    }

    config.dataStamp = chartAttr.datastamp;
    ds.config.chartObj = chartObj;
    chartObj.jsVars && (chartObj.jsVars._rtLastUpdatedData = null); // remove data cache
    // clear all timeouts

    ds.updateIntervalHandler(0, true);
    ds.refreshVisualHandler(null, null, true);
    ds.initiateResetVisual(true);
    config._rtAjaxLatencyStart = null; // clear latency calculations

    config._rtAjaxLatency = null;
    ds.addToEnv('realtimeDrawingLatency', 0);
  }
  /**
   * Function to dispose the dataStreamer object
   */
  ;

  _proto._dispose = function _dispose() {
    var ds = this; // clear all timeouts

    ds.updateIntervalHandler(0, true);
    ds.refreshVisualHandler(null, null, true);
    ds.initiateResetVisual(true);

    _ComponentInterface.prototype._dispose.call(this);
  }
  /**
   * Function which manages the entire real time ajax calls and feeding data to chart
   */
  ;

  _proto.processRealtimeStateChange = function processRealtimeStateChange() {
    var ds = this,
        config = ds.config,
        chartObj = ds.config.chartObj,
        state = chartObj.__state,
        chart = ds.getLinkedParent(),
        chartConfig = chart.config,
        realtimeEnabled = chartConfig.realtimeEnabled,
        dataUrl = chartConfig.realTimeConfig.dataStreamURL,
        ajaxObj; // In case data was set during construction, both the state-change capture events can happen to be fired before
    // even them being registered. Hence, a special check is made here.

    if (state.dataSetDuringConstruction && !config.rtStateChanged && config.rtPreInit === UNDEF) {
      if (chartObj.dataReady()) {
        config.rtStateChanged = true;
        config.rtPreInit = true;
      } else {
        config.rtPreInit = false;
      }
    } // If the data has not changed then the realtime initialization should not be repeated.


    if (!config.rtStateChanged) {
      return;
    } // reset the state changed flag to indicate that drawcomplete will re-work upon next state change.


    config.rtStateChanged = false; // Initialize the realtime framework.
    // In case process happens before load

    if (!chart) {
      return;
    }

    ajaxObj = config._rtAjaxObj;

    if (realtimeEnabled) {
      if (config._rtPaused === UNDEF) {
        config._rtPaused = false;
      }

      config._rtDataUrl = dataUrl;
      ds.initiateResetVisual(); // eslint-disable-next-line new-cap

      ajaxObj = config._rtAjaxObj || (config._rtAjaxObj = new _ajax.default());
      ajaxObj.onSuccess || (ajaxObj.onSuccess = function () {
        if (!ds.getFromEnv('chartConfig').realTimeConfig.dataStreamURL) {
          return;
        }

        ds.setState('ajaxRequested', true);
        ds.responseTextHandler(arguments[0]); // Update latency timer

        config._rtAjaxLatencyStart && (config._rtAjaxLatency = new Date() - config._rtAjaxLatencyStart || 0); // refresh visual

        ds.refreshVisualHandler({
          data: config.responseText,
          source: 'XmlHttpRequest',
          url: config.url,
          networkLatency: config._rtAjaxLatency
        }, config._rtAjaxLatency + (config._firstUpdate ? new Date() - config._firstUpdate : 0), !ds.getFromEnv('chartConfig').realTimeConfig.dataStreamURL);
        config._firstUpdate = UNDEF;

        if (!config._rtPaused) {
          if (config._rtAjaxLatency >= config.updateMs) {
            config._rtAjaxLatency = config.updateMs - 1;
          }
        } // re-issue realtime update.


        ds.updateIntervalHandler(config._rtAjaxLatency, config._rtPaused);
      });
      ajaxObj.onError || (ajaxObj.onError = function () {
        var resp = arguments[0],
            wrapper = arguments[1],
            url = arguments[3]; // Update latency timer

        config._rtAjaxLatencyStart && (config._rtAjaxLatency = new Date() - config._rtAjaxLatencyStart);
        ds.setState('ajaxRequested', false);
        /**
         * This event is raised where there is an error in performing a real-time chart data update using
         * `dataStreamUrl` attribute.
         *
         * @event FusionCharts#realTimeUpdateError
         * @group chart-realtime
         *
         * @param {number} source - Nature of data load request. Presently its value is 'XmlHttprequest'.
         * @param {string} url - URL of the data source.
         * @param {object} xmlHttpReqestObject - The object which has fetched data.
         * @param {string} httpStatus - A number which denotes the HTTP status number when the error was raised.
         * For example, the status will be ``404`` for URL not found.
         */

        chart.fireChartInstanceEvent('realTimeUpdateError', {
          source: 'XmlHttpRequest',
          url: url,
          xmlHttpRequestObject: wrapper.xmlhttp,
          error: resp,
          httpStatus: wrapper.xmlhttp && wrapper.xmlhttp.status ? wrapper.xmlhttp.status : -1,
          networkLatency: config._rtAjaxLatency
        }); // Upon error, based on whether chart is alive and kicking, re-request the data or abandon realtime
        // calls.

        ds.updateIntervalHandler(0, !chartObj.isActive());
      }); // This is the first (initial) realtime update request to be sent.

      if (!config._rtPaused) {
        ds.updateIntervalHandler(0);
        config._firstUpdate = new Date();
      }
    }
  }
  /**
   * function to handle response text whether it is from API or ajax response
   * @param {string} responseText - response text
   */
  ;

  _proto.responseTextHandler = function responseTextHandler(responseText) {
    var ds = this,
        config = ds.config,
        chart = ds.getFromEnv('chart'),
        chartConf = ds.getFromEnv('chartConfig'),
        realtimeEnabled = chartConf.realtimeEnabled,
        feedData = chart.feedData,
        updateObj = chart._linearDataParser(responseText);

    config.responseText = responseText;

    if (ds.getFromEnv('chartInstance').isActive() && feedData && realtimeEnabled) {
      config.dataStamp = updateObj.dataStamp ? updateObj.dataStamp : null;
      chart.realTimeUpdate(updateObj);
    }
  }
  /**
   * function to initiate visual reset in certain time interval
   * @param {boolean} kill - to kill the preocess
   */
  ;

  _proto.initiateResetVisual = function initiateResetVisual(kill) {
    if (kill === void 0) {
      kill = false;
    }

    if (kill) {
      clearTimeout(this.config._toClearChart);
      return;
    }

    var ds = this,
        config = ds.config,
        chart = ds.getFromEnv('chart'),
        resetVisual = function resetVisual() {
      chart._clearChart && chart._clearChart();

      if (config.clearMs) {
        config._toClearChart = DataStreamer.resetTimeout(resetVisual, config.clearMs, config._toClearChart);
      } else {
        clearTimeout(config._toClearChart);
      }
    };

    if (!kill) {
      if (config.clearMs) {
        config._toClearChart = DataStreamer.resetTimeout(resetVisual, config.clearMs, config._toClearChart);
      }
    }
  }
  /**
   * function to handle data update related job
   * @param {number} latency    - latency for update data
   * @param {boolean} kill   - whether the update job will be killed or not
   * @param {boolean} clearJob  - whether previously registered will be cleared or not
   */
  ;

  _proto.updateIntervalHandler = function updateIntervalHandler(latency, kill) {
    if (latency === void 0) {
      latency = 0;
    }

    if (kill === void 0) {
      kill = false;
    }

    if (kill) {
      clearTimeout(this.config && this.config._toRealtimeUpdate);
      return;
    }

    var ds = this,
        config = ds.config,
        ajaxObj = config._rtAjaxObj,
        skew,
        updateMs = config.updateMs;
    ds.requestData || (ds.requestData = function () {
      var dataUrl = ds.getFromEnv('chartConfig').realTimeConfig.dataStreamURL,
          dataStamp = config.dataStamp,
          ajaxObject = config._rtAjaxObj,
          url = dataUrl; // append anti-cache querystring to url (a random number)

      url += (dataUrl.indexOf('?') === -1 ? '?num=' : '&num=') + Math.random(); // append data stamp to the url

      dataStamp && (url += '&dataStamp=' + dataStamp);
      config.url = url; // If xhr object is open, then abort it. Probably because previous request did not return on time.

      ajaxObject.open && ajaxObject.abort();
      !!dataUrl && ajaxObject.get(url); // fetch the URL.

      config._rtAjaxLatencyStart = new Date();
    });

    if (updateMs <= 0) {
      config._toRealtimeUpdate = clearTimeout(config._toRealtimeUpdate);
      ajaxObj && ajaxObj.abort();
      return;
    } else if (updateMs < THRESHOLD_MS) {
      // validate whether refreshinterval is less than threshold.
      updateMs = THRESHOLD_MS;
    }

    if (!kill) {
      skew = updateMs - latency;
      config._toRealtimeUpdate = DataStreamer.resetTimeout(ds.requestData, skew, config._toRealtimeUpdate);
    }
  }
  /**
   * function to handle visual refresh job
   * @param {Object} info       - information of source from where visual refreshing is initiated
   * @param {number} _latency    - latency for refresh visual
   * @param {boolean} kill   - whether the draw job will be reIssued or not
   */
  ;

  _proto.refreshVisualHandler = function refreshVisualHandler(info, _latency, kill) {
    if (_latency === void 0) {
      _latency = 0;
    }

    if (kill === void 0) {
      kill = false;
    }

    if (kill) {
      clearTimeout(this.config._toRealtimeDraw);

      this._clearCachedData();

      this.config.isAlive = false;
      return;
    }

    var ds = this,
        config = ds.config,
        refreshMs = config.refreshMs,
        chart = ds.getFromEnv('chart'),
        chartConf = ds.getFromEnv('chartConfig'),
        realtimeEnabled = chartConf.realtimeEnabled,
        isActive = ds.getFromEnv('chartInstance').isActive(),
        skew,
        now = new Date().getTime(),
        feedData = chart.feedData,
        latency = _latency;

    if (!ds.getState('ajaxRequested') || !config.lastRTDrawAt) {
      config.lastRTDrawAt = now;
    }

    ds.config.sourceInfo = info;
    ds._rtDraw || (ds._rtDraw = function () {
      config.isAlive = false;
      config.lastRTDrawAt = new Date().getTime();
      chart.realTimeDraw(ds.config.sourceInfo);
    });

    if (isActive && feedData && realtimeEnabled && !kill && !config.isAlive) {
      config.isAlive = true;
      latency += now - config.lastRTDrawAt + ds.getFromEnv('realtimeDrawingLatency');
      skew = refreshMs - latency > 0 ? refreshMs - latency : 0;
      config._toRealtimeDraw = DataStreamer.resetTimeout(ds._rtDraw, skew, config._toRealtimeDraw);
    }
  };

  _proto._clearCachedData = function _clearCachedData() {
    this.getFromEnv('chart').config.cachedArrivedJSON = {};
  }
  /**
   * Function to stop the realTime update
   */
  ;

  _proto._stopUpdate = function _stopUpdate() {
    var ds = this,
        config = ds.config; // clear all timeouts

    ds.updateIntervalHandler(0, true);
    ds.refreshVisualHandler(null, null, true);
    ds.initiateResetVisual(true);
    config._rtAjaxObj && config._rtAjaxObj.abort();
    config._rtPaused = true;
    ds.setState('ajaxRequested', false);
  }
  /**
   * Function to restart the realTime update
   */
  ;

  _proto._restartUpdate = function _restartUpdate() {
    var ds = this,
        config = ds.config;

    if (config._rtDataUrl && config._rtPaused) {
      config._rtPaused = false;
      config.rtStateChanged = true;
      ds.processRealtimeStateChange();
    }
  }
  /**
   * Function to determine whether rt-update is active or not
   * @return {boolean} true/false
   */
  ;

  _proto._isUpdateActive = function _isUpdateActive() {
    return !this.config._rtPaused;
  }
  /**
   * Function to add event listners
   */
  ;

  _proto.addEvents = function addEvents() {
    var ds = this,
        chart = ds.getLinkedParent(),
        config = ds.config;

    if (!config.eventsAdded) {
      ds.addExtEventListener('renderComplete', ds._handlerFn, chart.getFromEnv('chartInstance'));
      ds.addExtEventListener('nodatatodisplay', ds._handlerStop, chart.getFromEnv('chartInstance'));
    }

    config.eventsAdded = true;
  };

  return DataStreamer;
}(_componentInterface.ComponentInterface);
/**
 * Wrapper method to provide FusionCHarts to dataStreamer
 *
 * @param {any} FusionCharts The FusionCharts class
 */


function dataStreamer(FusionCharts) {
  // Adding event listner for realTime charts
  FusionCharts.addEventListener('instantiated', onFcInstantiated);
}

dataStreamerExt = {
  extension: dataStreamer,
  name: 'DataStreamer',
  type: 'extension',
  requiresFusionCharts: true
};
var _default = dataStreamerExt;
exports["default"] = _default;

/***/ }),

/***/ 1560:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _lib = __webpack_require__(274);

var _commonspacemanager = _interopRequireDefault(__webpack_require__(519));

var defaultPaletteOptions = _interopRequireWildcard(__webpack_require__(532));

var _singleseriesDataset = _interopRequireDefault(__webpack_require__(594));

var _legend = _interopRequireDefault(__webpack_require__(629));

var _legendSpacemanager = __webpack_require__(627);

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/* eslint require-jsdoc: 'error', valid-jsdoc: ["error", { "requireReturn": false }] */
var DS_TYPE = 'funnelpyramidbaseds';
/**
 * Class for Funnel pyramid chart
 * @class FunnelPyramidBase
 * @extends {GaugeBase}
 */

var FunnelPyramidBase = /*#__PURE__*/function (_CommonSpaceManager) {
  (0, _inheritsLoose2.default)(FunnelPyramidBase, _CommonSpaceManager);

  /**
   * Provides the name of the chart extension
   *
   * @static
   * @return {string} The name of the chart extension
   */
  FunnelPyramidBase.getName = function getName() {
    return 'FunnelPyramidBase';
  }
  /**
   * Creates an instance of FunnelPyramidBase.
   * @memberof FunnelPyramidBase
   */
  ;

  function FunnelPyramidBase() {
    var _this;

    _this = _CommonSpaceManager.call(this) || this;
    _this.showRTvalue = false;
    _this.canvasPadding = false;
    _this.sliceOnLegendClick = true;
    _this.defaultPlotShadow = 1;
    _this.subTitleFontSizeExtender = 0;
    _this.tooltippadding = 3;
    _this.defaultPaletteOptions = defaultPaletteOptions;
    _this.drawAnnotations = true;
    _this.isDataLabelBold = false;
    _this.dontShowLegendByDefault = true;
    _this.formatnumberscale = 1;
    _this.alignCaptionWithCanvas = 0;

    _this.registerFactory('dataset', _singleseriesDataset.default, ['vCanvas', 'legend']);

    _this.registerFactory('legend', _legend.default);

    return _this;
  }
  /**
   * Sets default configuration
   * @memberof FunnelPyramidBase
   */


  var _proto = FunnelPyramidBase.prototype;

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    _CommonSpaceManager.prototype.__setDefaultConfig.call(this);

    var config = this.config;
    config.showRTvalue = false;
    config.canvasPadding = false;
    config.sliceOnLegendClick = true;
    config.defaultPlotShadow = 1;
    config.subTitleFontSizeExtender = 0;
    config.tooltippadding = 3;
    config.defaultPaletteOptions = defaultPaletteOptions;
    config.drawAnnotations = true;
    config.isDataLabelBold = false;
    config.dontShowLegendByDefault = true;
    config.alignCaptionWithCanvas = 0;
    config.formatnumberscale = 1;
    config.isSingleSeries = true;
    config.hasLegend = true;
    config.decimals = 2;
    config.defaultDatasetType = DS_TYPE;
    config.skipCanvasDrawing = true;
  }
  /**
   * Parse the chart attributes and store in chart's config
   * @param {Object} dataObj User input json
   */
  ;

  _proto.parseChartAttr = function parseChartAttr(dataObj) {
    _CommonSpaceManager.prototype.parseChartAttr.call(this, dataObj);

    var iapi = this,
        chartAttrs = iapi.getFromEnv('chart-attrib');
    iapi.config.showLegend = (0, _lib.pluckNumber)(chartAttrs.showlegend, 0);

    if (iapi.config.usePattern) {
      iapi.config.is2d = 1;
    }
  }
  /**
   * Checks if valid data is given as input
   *
   * @returns {any} returns true if invalid data, else false
   * @memberof FunnelPyramidBase
   */
  ;

  _proto._checkInvalidSpecificData = function _checkInvalidSpecificData() {
    var chart = this,
        chartAttr = chart.getFromEnv('dataSource'),
        i,
        len,
        zeroSum = 0,
        nullSum = 0,
        data = chartAttr.data,
        value;
    /**
     * Case 1: If no data is present, return true
     * Case 2: If no valid data is present(ie, data has all zero and/or null values)
     */

    if (!data) {
      return true;
    }

    len = data.length;

    for (i = 0; i < len; i++) {
      value = Number(data[i].value);
      zeroSum += !isNaN(value) && value === 0 ? 1 : 0;
      nullSum += isNaN(value) ? 1 : 0;
    } // Number of zero values + number of null values >= total data present.


    if (zeroSum + nullSum >= len) {
      return true;
    }
  }
  /**
   * function to calculate and allote space for legend
   */
  ;

  _proto._manageLegendSpace = function _manageLegendSpace() {
    _legendSpacemanager._manageLegendSpace.call(this);
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */
  ;

  _proto.getName = function getName() {
    return 'FunnelPyramidBase';
  };

  return FunnelPyramidBase;
}(_commonspacemanager.default);

var _default = FunnelPyramidBase;
exports["default"] = _default;

/***/ }),

/***/ 1488:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _gaugewidget = _interopRequireDefault(__webpack_require__(1479));

var _messagelogger = _interopRequireDefault(__webpack_require__(342));

var _alertmanager = _interopRequireDefault(__webpack_require__(380));

var _constructor = _interopRequireDefault(__webpack_require__(272));

var _lib = __webpack_require__(274);

var _equal = _interopRequireDefault(__webpack_require__(421));

var UNDEF;

var Gauge = /*#__PURE__*/function (_GaugeWidget) {
  (0, _inheritsLoose2.default)(Gauge, _GaugeWidget);

  function Gauge() {
    var _this;

    _this = _GaugeWidget.call(this) || this;

    _constructor.default.addDep(_messagelogger.default);

    _constructor.default.addDep(_alertmanager.default); // this has been added directly to this because in all gauges this type of configurations has been kept in this
    // we have problem in parsing of attribues,correcting of these changes will be taken in that flow change


    var WATERMARK_SPACE = 37;
    _this.chartLeftMargin = 15;
    _this.chartRightMargin = 15;
    _this.chartTopMargin = 10;
    _this.chartBottomMargin = WATERMARK_SPACE;
    _this.minChartHeight = 10;
    _this.minCanvasWidth = 0;
    return _this;
  }

  var _proto = Gauge.prototype;

  _proto._feedAxesRawData = function _feedAxesRawData() {
    var iapi = this,
        config = iapi.config,
        colorM = iapi.getFromEnv('color-manager'),
        dataObj = iapi.getFromEnv('dataSource'),
        chartAttrs = dataObj.chart,
        scaleConf,
        palleteString = _lib.chartPaletteStr.chart2D,
        ticksBelowGauge = (0, _lib.pluckNumber)(chartAttrs.ticksbelowgauge),
        ticksonright = (0, _lib.pluckNumber)(chartAttrs.ticksonright),
        isAxisOpposite = (0, _lib.pluckNumber)((0, _equal.default)(chartAttrs.scaleposition, config.scalePosition) ? config.isAxisOpposite : (0, _equal.default)(chartAttrs.scaleposition, config.canBeScalePosition) ? !config.isAxisOpposite : UNDEF, ticksBelowGauge !== UNDEF ? !ticksBelowGauge : UNDEF, ticksonright !== UNDEF ? ticksonright : UNDEF, config.isAxisOpposite),
        isAxisReverse = (0, _lib.pluckNumber)(chartAttrs.reverseaxis, iapi.isAxisReverse),
        isScaleReverse = (0, _lib.pluckNumber)(chartAttrs.reversescale, 0),
        showTickMarks = (0, _lib.pluckNumber)(chartAttrs.showtickmarks, 1),
        numberFormatter = iapi.getFromEnv('number-formatter'),
        showTickValues = (0, _lib.pluckNumber)(chartAttrs.showtickvalues),
        outCanfontSizeWithUnit = (0, _lib.pluckFontSizeMaintainUnit)(chartAttrs.outcnvbasefontsize, chartAttrs.basefontsize, 10),
        showLimits;

    if (!showTickValues && showTickValues !== UNDEF) {
      showLimits = false;
    } else if (!showTickMarks && showTickValues === UNDEF) {
      showLimits = false;
    } else {
      showLimits = true;
    }

    scaleConf = {
      isVertical: !iapi.isHorizontal,
      isReverse: iapi.isHorizontal ? isScaleReverse : !isAxisReverse,
      isOpposit: isAxisOpposite,
      outCanfontFamily: (0, _lib.pluck)(chartAttrs.outcnvbasefont, chartAttrs.basefont, 'Verdana,sans'),
      outCanfontSize: this.computeFontSize(outCanfontSizeWithUnit),
      outCanfontSizeWithUnit: outCanfontSizeWithUnit,
      outCancolor: (0, _lib.pluck)(chartAttrs.outcnvbasefontcolor, chartAttrs.basefontcolor, colorM.getColor(palleteString.baseFontColor)).replace(/^#?([a-f0-9]+)/ig, '#$1'),
      useEllipsesWhenOverflow: chartAttrs.useellipseswhenoverflow,
      divLineColor: (0, _lib.pluck)(chartAttrs.vdivlinecolor, colorM.getColor(palleteString.divLineColor)),
      divLineAlpha: (0, _lib.pluck)(chartAttrs.vdivlinealpha, colorM.getColor('divLineAlpha')),
      divLineThickness: (0, _lib.pluckNumber)(chartAttrs.vdivlinethickness, 1),
      divLineIsDashed: Boolean((0, _lib.pluckNumber)(chartAttrs.vdivlinedashed, chartAttrs.vdivlineisdashed, 0)),
      divLineDashLen: (0, _lib.pluckNumber)(chartAttrs.vdivlinedashlen, 4),
      divLineDashGap: (0, _lib.pluckNumber)(chartAttrs.vdivlinedashgap, 2),
      showAlternateGridColor: (0, _lib.pluckNumber)(chartAttrs.showalternatevgridcolor, 0),
      alternateGridColor: (0, _lib.pluck)(chartAttrs.alternatevgridcolor, colorM.getColor('altVGridColor')),
      alternateGridAlpha: (0, _lib.pluck)(chartAttrs.alternatevgridalpha, colorM.getColor('altVGridAlpha')),
      numDivLines: chartAttrs.numvdivlines,
      labelFont: chartAttrs.labelfont,
      labelFontSize: this.computeFontSize(chartAttrs.labelfontsize),
      labelFontSizeWithUnit: chartAttrs.labelfontsize,
      labelFontColor: chartAttrs.labelfontcolor,
      labelAlpha: chartAttrs.labelalpha,
      labelFontBold: chartAttrs.labelfontbold,
      labelFontItalic: chartAttrs.labelfontitalic,
      axisName: chartAttrs.xaxisname,
      axisMinValue: numberFormatter.getCleanValue(chartAttrs.lowerlimit),
      axisMaxValue: numberFormatter.getCleanValue(chartAttrs.upperlimit),
      setAdaptiveMin: chartAttrs.setadaptivemin,
      // adjusttm will be internally parsed as adjustdiv
      adjustDiv: chartAttrs.adjusttm,
      labelDisplay: chartAttrs.labeldisplay,
      showLabels: chartAttrs.showlabels,
      rotateLabels: chartAttrs.rotatelabels,
      slantLabel: (0, _lib.pluckNumber)(chartAttrs.slantlabels, chartAttrs.slantlabel),
      labelStep: (0, _lib.pluckNumber)(chartAttrs.labelstep, chartAttrs.xaxisvaluesstep),
      showAxisValues: (0, _lib.pluckNumber)(chartAttrs.showxaxisvalues, chartAttrs.showxaxisvalue),
      showDivLineValues: (0, _lib.pluckNumber)(chartAttrs.showvdivlinevalues, chartAttrs.showvdivlinevalues),
      showZeroPlane: chartAttrs.showvzeroplane,
      zeroPlaneColor: chartAttrs.vzeroplanecolor,
      zeroPlaneThickness: chartAttrs.vzeroplanethickness,
      zeroPlaneAlpha: chartAttrs.vzeroplanealpha,
      showZeroPlaneValue: chartAttrs.showvzeroplanevalue,
      trendlineColor: chartAttrs.trendlinecolor,
      trendlineToolText: chartAttrs.trendlinetooltext,
      trendlineThickness: chartAttrs.trendlinethickness,
      trendlineAlpha: chartAttrs.trendlinealpha,
      showTrendlinesOnTop: chartAttrs.showtrendlinesontop,
      showAxisLine: (0, _lib.pluckNumber)(chartAttrs.showxaxisline, chartAttrs.showaxislines, chartAttrs.drawAxisLines, 0),
      axisLineThickness: (0, _lib.pluckNumber)(chartAttrs.xaxislinethickness, chartAttrs.axislinethickness, 1),
      axisLineAlpha: (0, _lib.pluckNumber)(chartAttrs.xaxislinealpha, chartAttrs.axislinealpha, 100),
      axisLineColor: (0, _lib.pluck)(chartAttrs.xaxislinecolor, chartAttrs.axislinecolor, '#000000'),
      // Tick properties
      majorTMNumber: chartAttrs.majortmnumber,
      majorTMColor: chartAttrs.majortmcolor,
      majorTMAlpha: chartAttrs.majortmalpha,
      majorTMHeight: chartAttrs.majortmheight,
      tickValueStep: chartAttrs.tickvaluestep,
      showTickMarks: chartAttrs.showtickmarks,
      connectTickMarks: chartAttrs.connecttickmarks,
      showTickValues: chartAttrs.showtickvalues,
      majorTMThickness: chartAttrs.majortmthickness,
      reverseScale: chartAttrs.reversescale,
      // Whether to display the Limits
      showLimits: chartAttrs.showlimits || showLimits,
      minorTMNumber: (0, _lib.pluckNumber)(chartAttrs.minortmnumber, iapi.minorTMNumber, 4),
      minorTMColor: chartAttrs.minortmcolor,
      minorTMAlpha: chartAttrs.minortmalpha,
      minorTMHeight: (0, _lib.pluckNumber)(chartAttrs.minortmheight, chartAttrs.minortmwidth),
      minorTMThickness: chartAttrs.minortmthickness,
      // Padding between tick mark start position and gauge
      tickMarkDistance: (0, _lib.pluckNumber)(chartAttrs.tickmarkdistance, chartAttrs.tickmarkgap),
      // Tick value distance
      tickValueDistance: (0, _lib.pluckNumber)(chartAttrs.tickvaluedistance, chartAttrs.displayvaluedistance),
      placeTicksInside: chartAttrs.placeticksinside,
      placeValuesInside: chartAttrs.placevaluesinside,
      upperLimitDisplay: chartAttrs.upperlimitdisplay,
      lowerLimitDisplay: chartAttrs.lowerlimitdisplay,
      drawTickMarkConnector: iapi.isHorizontal ? 1 : 0
    };
    scaleConf.vtrendlines = dataObj.trendpoints;
    return [scaleConf];
  };

  _proto._setAxisLimits = function _setAxisLimits() {
    var iapi = this,
        chartAttrs = iapi.getFromEnv('dataSource').chart,
        scale = iapi.getChildren('scale')[0],
        minMaxObj;
    minMaxObj = iapi.getChildren('dataset')[0].getDataLimits();
    minMaxObj.max === -Infinity && (minMaxObj.max = 0);
    minMaxObj.min === Infinity && (minMaxObj.min = 0);
    iapi.colorRange && scale.setAxisConfig({
      axisMinValue: (0, _lib.pluckNumber)(chartAttrs.lowerlimit, minMaxObj.forceMin ? minMaxObj.min : UNDEF),
      axisMaxValue: (0, _lib.pluckNumber)(chartAttrs.upperlimit, minMaxObj.forceMax ? minMaxObj.max : UNDEF)
    });
    scale.setDataLimit(minMaxObj.max, minMaxObj.min);
  };

  _proto._getDataJSON = function _getDataJSON() {
    var i = 0,
        len,
        dataObj,
        values = [],
        labels = [],
        toolTexts = [],
        data = this.getChildren('dataset')[0].components.data;

    if (!data || !data.length) {
      len = 0;
    } else {
      len = data.length;
    }

    for (; i < len; i += 1) {
      dataObj = data[i].config;
      values.push(dataObj.itemValue);
      labels.push(dataObj.formatedVal || _lib.BLANK);
      toolTexts.push(dataObj.toolText || _lib.BLANK);
    }

    return {
      values: values,
      labels: labels,
      toolTexts: toolTexts
    };
  };

  _proto._postSpaceManagement = function _postSpaceManagement() {
    var iapi = this,
        config = iapi.config,
        canvas = iapi.getChildren('canvas')[0],
        scale = iapi.getChildren('scale')[0],
        isHorizontal = iapi.isHorizontal,
        canvasConf = canvas.config;

    if (isHorizontal) {
      scale.setAxisDimention({
        axisLength: config.canvasWidth,
        y: canvasConf.canvasTop + (scale.config.isOpposit ? 0 : canvasConf.canvasHeight),
        x: canvasConf.canvasLeft
      });
    } else {
      scale.setAxisDimention({
        axisLength: config.canvasHeight,
        x: canvasConf.canvasLeft + (scale.config.isOpposit ? canvasConf.canvasWidth : 0),
        y: canvasConf.canvasTop
      });
    }

    iapi.allocateDimensionOfChartMenuBar();
  } // eslint-disable-next-line
  ;

  _proto._clearChart = function _clearChart() {// not applicable for gauges
  };

  return Gauge;
}(_gaugewidget.default);

var _default = Gauge;
exports["default"] = _default;

/***/ }),

/***/ 1479:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _realtime = __webpack_require__(1480);

var _schedular = __webpack_require__(286);

var _commonchartapi = _interopRequireDefault(__webpack_require__(520));

var _lib = __webpack_require__(274);

var _singleseriesDataset = _interopRequireDefault(__webpack_require__(594));

var _constructor = _interopRequireDefault(__webpack_require__(272));

var _datastreamer = _interopRequireDefault(__webpack_require__(1481));

var defaultGaugePaletteOptions = (0, _lib.extend2)({}, _lib.defaultGaugePaletteOptions),
    math = Math,
    mathMax = math.max,
    getDataset = function getDataset(component) {
  var datasets = [];
  component.iterateComponents(function (child) {
    if (child.getType() === 'dataset') {
      datasets.push(child);
    }
  });
  return datasets;
};

_constructor.default.addDep(_datastreamer.default);

var GaugeWidget = /*#__PURE__*/function (_CommonAPI) {
  (0, _inheritsLoose2.default)(GaugeWidget, _CommonAPI);

  /**
   * Provides the name of the chart extension
   *
   * @static
   * @return {string} The name of the chart extension
   */
  GaugeWidget.getName = function getName() {
    return 'GaugeBase';
  };

  function GaugeWidget() {
    var _this;

    _this = _CommonAPI.call(this) || this;
    _this.defaultPaletteOptions = defaultGaugePaletteOptions;
    _this.multiValueGauge = false;
    _this.drawAnnotations = true;
    _this.includeColorRangeInLimits = false;
    _this.isWidget = true;
    _this._feedAxesRawData = _this._feedAxesRawData || _lib.stubFN;
    _this._setCategories = _this._setCategories || _lib.stubFN;
    _this.eiMethods = _realtime.eiMethods;

    _this.registerFactory('dataset', _singleseriesDataset.default, ['vCanvas']);

    _this.registerFactory('axis', _lib.stubFN, ['vCanvas']);

    return _this;
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */


  var _proto = GaugeWidget.prototype;

  _proto.getName = function getName() {
    return 'GaugeBase';
  };

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    _CommonAPI.prototype.__setDefaultConfig.call(this);

    var config = this.config;
    config.valuefontbold = 1;
    config.useScaleRecursively = true;
    config.formatnumberscale = 0;
  }
  /**
   * Parse the chart attributes and store in chart's config
   * @param {Object} dataObj User input json
   */
  ;

  _proto.parseChartAttr = function parseChartAttr(dataObj) {
    _CommonAPI.prototype.parseChartAttr.call(this, dataObj);

    this.config.drawTrendRegion = 0;
  } // Only updates the internal data-structure without updating visuals.
  ;

  _proto.realTimeUpdate = function realTimeUpdate(dataObj) {
    var iapi = this,
        components = iapi.getChildren(),
        dataset = components.dataset,
        newDataset = dataObj.dataset,
        newCategory = dataObj.categories && dataObj.categories.category || [],
        realTimeConfig = iapi.config.realTimeConfig = iapi.config.realTimeConfig || (iapi.config.realTimeConfig = {}),
        data,
        length,
        i,
        curDataset;
    iapi.fireChartInstanceEvent('updateDataReceived', dataObj); // fired on data update. used by message logger for updating logm

    iapi.fireEvent('realtimeDataUpdate', dataObj);

    if (!iapi.config.cachedArrivedJSON) {
      iapi.config.cachedArrivedJSON = {};
    }

    iapi.config.cachedArrivedJSON = dataObj;

    if (dataset) {
      curDataset = newDataset[0];
      data = curDataset.data;

      for (i = 0, length = data.length; i < length; i++) {
        data[i].label = newCategory[i] && newCategory[i].label;
      } // curDataset.data[0].label = newCategory[0].label;
      // dataset[0].updateData(curDataset);


      dataset[0].maxminFlag && (realTimeConfig.maxminFlag = dataset[0].maxminFlag);
    }
  };

  _proto._setData = function _setData(value, label) {
    var stream = _lib.BLANKSTRING;

    if (value && value.toString || value === _lib.BLANKSTRING || value === 0) {
      stream = 'value=' + value.toString();
    }

    if (label && label.toString || label === _lib.BLANKSTRING) {
      stream = stream + '&label=' + label.toString();
    }

    if (stream) {
      this.feedData(stream);
    }
  };

  _proto._getData = function _getData() {
    var iapi = this,
        components = iapi.getChildren(),
        dataset = iapi.getDatasets(),
        xAxis = components.xAxis && components.xAxis[0] || components.scale,
        length,
        i,
        j,
        store = [],
        maxLength = 0,
        data,
        innerStore;

    if (dataset) {
      length = dataset.length; // Finding the dataset with maximum length

      for (i = 0; i < length; i++) {
        maxLength = mathMax(maxLength, dataset[i].components.data.length);
      }

      for (i = 0; i < maxLength; i++) {
        innerStore = store[i] = [];
        innerStore[0] = xAxis.getLabel(i).label;

        for (j = 1; j <= length; j++) {
          data = dataset[j - 1].components.data[i];
          innerStore[j] = data && data.config.setValue;
        }
      }

      return store;
    }
  }
  /**
   * function to check if the chart specific data is proper is not
   * this fn is define for specific chart types
   * @return {boolean} if JSON data is valid or not
   */
  // eslint-disable-next-line
  ;

  _proto._checkInvalidSpecificData = function _checkInvalidSpecificData() {// this fn will override
  }
  /**
   * Update visuals during real time draw.
   * @param  {boolean} ajaxCall       to decide if the data are fed through ajax or API
   * @param  {string}  stream         raw data that has to be fed to the chart
   * @param  {Object}  prevData       previuosly fed data
   * @param  {string}  url            url for ajax request
   * @param  {number}  ajaxCallLatency ajax call delay
   */
  ;

  _proto.realTimeDraw = function realTimeDraw(eventArgs) {
    if (eventArgs === void 0) {
      eventArgs = {};
    }

    if (!this.config.cachedArrivedJSON) {
      return;
    }

    var iapi = this,
        config = iapi.config,
        prevData = config.prevData,
        // scale = chartChildren.scale && chartChildren.scale[0],
    dataset = getDataset(iapi),
        // sync = realTimeConfig.sync,
    dataObj = config.cachedArrivedJSON,
        newDataset,
        realTimeConfig = config.realTimeConfig || (config.realTimeConfig = {}),
        curDataset,
        showRTValue = realTimeConfig.showRTValue,
        // maxminFlag = realTimeConfig.maxminFlag,
    drawLatency,
        i,
        inputData,
        pointerId = [],
        pointerIdLen,
        getValueArray = function getValueArray(data) {
      if (data === void 0) {
        data = [];
      }

      var len = data.length,
          newData = [],
          ii,
          dataObject;

      for (ii = 0; ii < len; ++ii) {
        dataObject = data[ii];
        newData.push(dataObject.value);
      }

      return [newData];
    };

    iapi.__rtDrawStartAt = new Date(); // set the state that the realtime update is going to happen

    iapi.getFromEnv('animationManager').setAnimationState('realTimeUpdate');

    if (dataset && dataset.length) {
      inputData = dataObj.dataset[0].data; // Store all the IDs present in dataById or idMap in angularGauge or hlinearGauge respectively

      pointerId = Object.keys(dataset[0].config.dataById || dataset[0].config.idMap || {});
      pointerIdLen = pointerId.length; // Iterate through all the keys of dataObj.
      // If any value is provided by ID, move it to data array of dataset.

      for (i = 0; i < pointerIdLen; i++) {
        if (dataObj.hasOwnProperty(pointerId[i])) {
          inputData.push({
            value: Number(dataObj[pointerId[i]]),
            id: pointerId[i]
          });
        }
      }

      config.prevData = getValueArray(inputData);
      newDataset = dataObj.dataset;
      curDataset = newDataset[0];
      curDataset.data[0] && (curDataset.data[0].label = dataObj.categories && dataObj.categories.category && dataObj.categories.category[0] && dataObj.categories.category[0].label);
      dataset[0].updateData(curDataset);
      dataset[0].maxminFlag && (realTimeConfig.maxminFlag = dataset[0].maxminFlag);
      dataset[0].asyncDraw();
      config.cachedArrivedJSON = _lib.UNDEF; // Function to manage during realTime

      iapi.rtManageSpace && iapi._RTmanageSpace();
      iapi.prepareAttributes && iapi.prepareAttributes();

      iapi._preDraw(); // maxminFlag && scale && scale.asyncDraw();


      if (showRTValue && iapi._drawRealTimeValue) {
        iapi.asyncRealTimeValueDraw();
      }
    }

    config._eventArgs = eventArgs;
    eventArgs.prevData = prevData;
    iapi.__realtimeUpdateComplete || (iapi.__realtimeUpdateComplete = function () {
      drawLatency = new Date() - iapi.__rtDrawStartAt;

      if (!realTimeConfig.clear) {
        config._eventArgs.latency = drawLatency;
        config._eventArgs.updateObject = realTimeConfig.legacyUpdateObj;
      }

      iapi.getChildren('dataStreamer')[0].addToEnv('realtimeDrawingLatency', drawLatency);
      iapi.fireChartInstanceEvent('realTimeUpdateComplete', config._eventArgs);
    });
    iapi.addJob('realtimeupdatecomplete', iapi.__realtimeUpdateComplete, _schedular.priorityList.postRender);
  };

  _proto._setRTmenu = function _setRTmenu(showRTmenuItem, useMessageLog) {
    _realtime._setRTmenu.call(this, showRTmenuItem, useMessageLog);
  }
  /**
   * Creates layer for gauges. Swaps the position of axisbottom and belowplot group
   *
   * @memberof GaugeBase
   */
  ;

  _proto._createLayers = function _createLayers() {
    var iapi = this,
        belowPlotGroup,
        axisBottomGroup;

    _CommonAPI.prototype._createLayers.call(this); // Swapping the belowPlotGroup and axisBottomGroup, as in gauges axisBottomGroup lays over
    // belowPlotGroup(contains lower-annotations)


    belowPlotGroup = iapi.getChildContainer('belowPlotGroup');
    axisBottomGroup = iapi.getChildContainer('axisBottomGroup');
    belowPlotGroup.insertBefore(axisBottomGroup);
  };

  _proto._realTimeConfigure = function _realTimeConfigure() {
    _realtime._realTimeConfigure.call(this);
  };

  _proto._stopUpdate = function _stopUpdate(source) {
    _realtime._stopUpdate.call(this, source);
  };

  _proto._restartUpdate = function _restartUpdate() {
    _realtime._restartUpdate.call(this);
  };

  _proto._isUpdateActive = function _isUpdateActive() {
    return _realtime._isUpdateActive.call(this);
  };

  _proto.feedData = function feedData(stream) {
    _realtime.feedData.call(this, stream);
  };

  _proto._linearDataParser = function _linearDataParser(responseText) {
    return _realtime._linearDataParser.call(this, responseText);
  };

  _proto._clearChart = function _clearChart(_source) {
    _realtime._clearChart.call(this, _source);
  };

  return GaugeWidget;
}(_commonchartapi.default);

var _default = GaugeWidget;
exports["default"] = _default;

/***/ }),

/***/ 1487:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _gauge = _interopRequireDefault(__webpack_require__(1488));

var _gaugeAxis = _interopRequireDefault(__webpack_require__(1489));

var _lib = __webpack_require__(274);

var LinearGauge = /*#__PURE__*/function (_Gauge) {
  (0, _inheritsLoose2.default)(LinearGauge, _Gauge);

  /**
   * constructor fn
   */
  function LinearGauge() {
    var _this;

    _this = _Gauge.call(this) || this;

    _this.registerFactory('axis', _gaugeAxis.default);

    return _this;
  }
  /**
   * Provides the name of the chart extension
   *
   * @static\
   * @return {string} The name of the chart extension
   */


  LinearGauge.getName = function getName() {
    return 'AxisGaugeBase';
  }
  /**
   * Function to parse chart specific configurations
   */
  ;

  var _proto = LinearGauge.prototype;

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    _Gauge.prototype.__setDefaultConfig.call(this);
  }
  /**
   * Calculates the position of the annotation macros before drawing
   *
   * @memberof LinearGauge
   */
  ;

  _proto.allocatePosition = function allocatePosition() {
    var iapi = this,
        chartConfig = iapi.config,
        width = chartConfig.canvasWidth,
        height = chartConfig.canvasHeight,
        captionStyle = iapi.getChildren('caption')[0].config.style,
        subCaptionStyle = iapi.getChildren('subCaption')[0].config.style,
        chartAttrs = iapi.getFromEnv('dataSource').chart,
        style = iapi.getFromEnv('style'); // Setting the font size every time the viewport is resized
    // and chart is consequently redrawn

    captionStyle.fontSize = (0, _lib.pluckNumber)(this.computeFontSize(chartAttrs.captionfontsize), this.computeFontSize(style.fontSizeWithUnit) + 3) + _lib.PXSTRING;
    (0, _lib.setLineHeight)(captionStyle);
    subCaptionStyle.fontSize = (0, _lib.pluckNumber)(this.computeFontSize(chartAttrs.subcaptionfontsize), (0, _lib.pluckNumber)(Math.max((0, _lib.pluckNumber)(this.computeFontSize(chartAttrs.captionfontsize)) - 3, -1), this.computeFontSize(style.fontSizeWithUnit)) + (0, _lib.pluckNumber)(iapi.subTitleFontSizeExtender, 1)) + _lib.PXSTRING;
    (0, _lib.setLineHeight)(subCaptionStyle); // Setting macros for annotation

    chartConfig.gaugeStartX = chartConfig.canvasLeft;
    chartConfig.gaugeEndX = chartConfig.canvasLeft + width;
    chartConfig.gaugeStartY = chartConfig.canvasTop;
    chartConfig.gaugeEndY = chartConfig.canvasTop + height;
    chartConfig.gaugeCenterX = chartConfig.canvasLeft + width / 2;
    chartConfig.gaugeCenterY = chartConfig.canvasTop + height / 2;
  };

  _proto._spaceManager = function _spaceManager() {
    var spaceForActionBar,
        actionBarSpace,
        iapi = this,
        config = iapi.config,
        dataset = iapi.getChildren('dataset')[0],
        scale = iapi.getChildren('scale')[0],
        is3D = iapi.config.is3D,
        canvas = iapi.getChildren('canvas')[0],
        chartAttrs = iapi.getFromEnv('dataSource').chart,
        showBorder = (0, _lib.pluckNumber)(chartAttrs.showborder, is3D ? 0 : 1),
        isHorizontal = iapi.isHorizontal,
        minChartWidth = config.minChartWidth,
        minChartHeight = config.minChartHeight,
        chartBorderWidth = config.borderWidth = showBorder ? (0, _lib.pluckNumber)(chartAttrs.borderthickness, 1) : 0,
        chartBorderVertical,
        chartBorderHorizontal;

    if (config.canvasWidth - 2 * chartBorderWidth < minChartWidth) {
      chartBorderVertical = (config.canvasWidth - minChartWidth) / 2;
    }

    if (config.canvasHeight - 2 * chartBorderWidth < minChartHeight) {
      chartBorderHorizontal = (config.canvasHeight - minChartHeight) / 2;
    }

    iapi._allocateSpace({
      top: chartBorderHorizontal || chartBorderWidth,
      bottom: chartBorderHorizontal || chartBorderWidth,
      left: chartBorderVertical || chartBorderWidth,
      right: chartBorderVertical || chartBorderWidth
    });

    spaceForActionBar = config.availableHeight * 0.225;
    actionBarSpace = iapi._manageActionBarSpace && iapi._manageActionBarSpace(spaceForActionBar) || {};

    iapi._allocateSpace(actionBarSpace);

    if (isHorizontal) {
      iapi._allocateSpace(scale.placeAxis(config.availableHeight));
    } else {
      iapi._allocateSpace(scale.placeAxis(config.availableWidth));
    } // iapi._allocateSpace(iapi._manageCaptionSpacing(config.availableHeight * 0.4));


    iapi._manageChartMenuBar(config.availableHeight * 0.4);

    dataset._manageSpace && iapi._allocateSpace(dataset._manageSpace(config.availableHeight));
    scale.setAxisConfig({
      drawPlotlines: iapi.drawPlotlines,
      drawPlotBands: iapi.drawPlotBands
    });
    canvas.setDimension({
      top: config.canvasTop,
      left: config.canvasLeft,
      width: config.canvasWidth,
      height: config.canvasHeight
    });
  };

  return LinearGauge;
}(_gauge.default);

var _default = LinearGauge;
exports["default"] = _default;

/***/ }),

/***/ 1480:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports._setRTmenu = exports._clearChart = exports._linearDataParser = exports.feedData = exports.realTimeDraw = exports._RTmanageSpace = exports.realTimeUpdate = exports._isUpdateActive = exports._restartUpdate = exports._stopUpdate = exports.eiMethods = exports._realTimeConfigure = void 0;

var _index = __webpack_require__(274);

var _index2 = __webpack_require__(286);

var _safeMax = _interopRequireDefault(__webpack_require__(540));

var NORMALSTRING = 'normal',
    math = Math,
    mathMax = math.max,
    UNDEF,
    dropHash = _index.regex.dropHash,
    PXSTRING = 'px',
    feedIndex = 0,
    count = 0,
    AMPERSAND = '&',
    EQUALS = '=',
    PIPE = '|',
    COMMA = ',',
    copyObject = function copyObject(d) {
  return Object.assign({}, d);
},
    spaceLeft = function spaceLeft(d) {
  return d.spaceTaken.left;
},
    spaceRight = function spaceRight(d) {
  return d.spaceTaken.right;
},
    getDataset = function getDataset(component) {
  var datasets = [];
  component.iterateComponents(function (child) {
    if (child.getType() === 'dataset') {
      datasets.push(child);
    }
  });
  return datasets;
},
    _realTimeConfigure = function _realTimeConfigure() {
  var iapi = this,
      config = iapi.config,
      realTimeConfig = config.realTimeConfig || (config.realTimeConfig = {}),
      refreshInterval,
      realtimeValueFontColor,
      realtimeValueFontSize,
      jsonData = iapi.getFromEnv('dataSource'),
      chartAttrs = jsonData.chart,
      useMessageLog = (0, _index.pluckNumber)(chartAttrs.usemessagelog, 0),
      messageGoesToLog = (0, _index.pluckNumber)(chartAttrs.messagegoestolog, 1),
      catLen = jsonData.categories && Array.isArray(jsonData.categories) && jsonData.categories[0] && jsonData.categories[0].category && jsonData.categories[0].category.length || 0; // Parsing the real time attributes

  realTimeConfig.showRTValue = (0, _index.pluckNumber)(chartAttrs.showrealtimevalue, 1);
  realTimeConfig.dataStreamURL = (0, _index.parseUnsafeString)(chartAttrs.datastreamurl, _index.BLANKSTRING);
  realTimeConfig.dataStamp = chartAttrs.datastamp;
  realTimeConfig.useMessageLog = useMessageLog && messageGoesToLog;
  realTimeConfig.clearInterval = (0, _index.pluckNumber)(chartAttrs.clearchartinterval, 0);
  realTimeConfig.realtimeValueSeparator = (0, _index.pluck)(chartAttrs.realtimevaluesep, _index.COMMASPACE);
  realTimeConfig.refreshInterval = refreshInterval = (0, _index.pluckNumber)(chartAttrs.refreshinterval, chartAttrs.updateinterval, 2);
  realTimeConfig.updateInterval = iapi.config.updateInterval = (0, _index.pluckNumber)(chartAttrs.updateinterval, refreshInterval);
  realTimeConfig.realtimeValuePadding = (0, _index.pluckNumber)(chartAttrs.realtimevaluepadding);
  realTimeConfig.realtimeValueFont = (0, _index.pluck)(chartAttrs.realtimevaluefont, _index.BLANKSTRING);
  realTimeConfig.realtimeValueFontBold = (0, _index.pluck)(chartAttrs.realtimevaluefontbold, 0);
  realTimeConfig.realtimeValueFontColor = realtimeValueFontColor = (0, _index.pluck)(chartAttrs.realtimevaluefontcolor, _index.BLANKSTRING);
  realTimeConfig.realtimeValueFontSize = realtimeValueFontSize = (0, _index.pluckNumber)(chartAttrs.realtimevaluefontsize, _index.BLANKSTRING);
  realTimeConfig.realTimeValuePadding = (0, _index.pluckNumber)(chartAttrs.realtimevaluepadding, 5);
  realTimeConfig.fontWeight = (0, _index.pluckNumber)(chartAttrs.realtimevaluefontbold, 0) ? 'bold' : NORMALSTRING;
  realTimeConfig.numDisplaySets = (0, _index.pluckNumber)(chartAttrs.numdisplaysets, mathMax(catLen, 15));
  realTimeConfig.refreshInstantly = (0, _index.pluckNumber)(chartAttrs.refreshinstantly, 0);
  realTimeConfig.showRTmenuItem = (0, _index.pluckNumber)(chartAttrs.showrtmenuitem, 0); // chartAnimation is forced to sync

  realTimeConfig.sync = (0, _index.pluckNumber)(chartAttrs.sync, refreshInterval > 0.6);

  if (realtimeValueFontColor) {
    realTimeConfig.realtimeValueFontColor = realtimeValueFontColor.replace(dropHash, _index.HASHSTRING);
  }

  if (realtimeValueFontSize) {
    realTimeConfig.realtimeValueFontSize = realtimeValueFontSize + PXSTRING;
  }

  refreshInterval *= 1000; // iapi._setRTmenu(showRTmenuItem, useMessageLog);
},

/**
* @group chart-realtime
* @see FusionCharts#startUpdate
* @see FusionCharts#restartUpdate
* @see FusionCharts#isUpdateActive
* @see FusionCharts#clearChart
*/
_stopUpdate = function _stopUpdate(source) {
  var iapi = this,
      realTimeConfig = iapi.config.realTimeConfig,
      loadData = iapi.config.timers && iapi.config.timers.setTimeout.loadData;

  iapi.getChildren('dataStreamer')[0]._stopUpdate(); // Clearing previously queqed updates of the chart if any ideally when update interval is less than
  // refresh interval.


  loadData && clearTimeout(loadData);
  realTimeConfig.clearIntervalFlag = false;
  /**
       * This event is raised when the real time update of the chart is stopped .
       *
       * @event Fusioncharts#realTimeUpdateStopped
       * @group chart-realtime
       */

  iapi.fireChartInstanceEvent('dataRestored', {
    source: source
  });
},

/**
* @group chart-realtime
* @see FusionCharts#startUpdate
* @see FusionCharts#stopUpdate
* @see FusionCharts#isUpdateActive
* @see FusionCharts#clearChart
*/
_restartUpdate = function _restartUpdate() {
  this.getChildren('dataStreamer')[0]._restartUpdate();
},

/**
* @group chart-realtime
* @see FusionCharts#startUpdate
* @see FusionCharts#stopUpdate
* @see FusionCharts#clearChart
* @see FusionCharts#restartUpdate
*/
_isUpdateActive = function _isUpdateActive() {
  return this.getChildren('dataStreamer')[0]._isUpdateActive();
},
    eiMethods = {
  feedData: function feedData() {
    var chartContainer = this,
        chart = chartContainer.apiInstance,
        callback = arguments[1],
        updateStr,
        output;

    if (callback) {
      updateStr = arguments[0];
      chart.addJob("feedDataId" + count++ + feedIndex++, function () {
        output = chart.feedData(updateStr);

        if (typeof callback === 'function') {
          callback(output);
        }
      }, _index2.priorityList.postRender);
    } else {
      return chart.feedData.apply(chart, arguments);
    }
  },
  setData: function setData() {
    var chart = this.apiInstance,
        value = arguments[0],
        label = arguments[1],
        id = arguments[2];
    chart.addJob("setDataId" + count++, function () {
      chart._setData(value, label, id);
    }, _index2.priorityList.postRender);
  },
  stopUpdate: function stopUpdate() {
    var chart = this.apiInstance;
    chart.addJob("stopUpdateId" + count++, function () {
      chart._stopUpdate();
    }, _index2.priorityList.postRender);
  },
  restartUpdate: function restartUpdate() {
    this.apiInstance._restartUpdate.apply(this.apiInstance, arguments);
  },
  isUpdateActive: function isUpdateActive() {
    return this.apiInstance._isUpdateActive.apply(this.apiInstance, arguments);
  },
  clearChart: function clearChart() {
    var chart = this.apiInstance;
    chart.addJob("clearChartId" + count++, function () {
      chart._clearChart();
    }, _index2.priorityList.postRender);
  },
  getData: function getData() {
    return this.apiInstance._getData.apply(this.apiInstance, arguments);
  },
  getDataForId: function getDataForId() {
    return this.apiInstance._getDataForId.apply(this.apiInstance, arguments);
  },
  setDataForId: function setDataForId() {
    return this.apiInstance._setDataForId.apply(this.apiInstance, arguments);
  },
  getDataJSON: function getDataJSON() {
    return this.apiInstance._getDataJSON.apply(this.apiInstance, arguments);
  }
},

/**
 * Only updates the internal data-structure without updating visuals.
 * @param  {Object} dataObj new data object to be added in dataset
 */
realTimeUpdate = function realTimeUpdate(dataObj) {
  var iapi = this,
      datasets = getDataset(iapi),
      i,
      cachedArrivedJSON = iapi.config.cachedArrivedJSON,
      currJSONDataset,
      cachedCategories = cachedArrivedJSON && cachedArrivedJSON.categories,
      newDataset = dataObj.dataset,
      newCategory = dataObj.categories && dataObj.categories.category || [];
  iapi.fireChartInstanceEvent('updateDataReceived', dataObj); // fired on data update. used by message logger for updating logm

  iapi.fireEvent('realtimeDataUpdate', dataObj);
  !iapi.config.cachedArrivedJSON && (cachedArrivedJSON = iapi.config.cachedArrivedJSON = {});
  cachedArrivedJSON.dataset = cachedArrivedJSON.dataset || [];
  cachedCategories = cachedArrivedJSON.categories || (cachedArrivedJSON.categories = {});
  cachedCategories.category = cachedCategories.category || [];

  for (i = 0; i < datasets.length; i++) {
    currJSONDataset = cachedArrivedJSON.dataset[i] || (cachedArrivedJSON.dataset[i] = {});
    currJSONDataset.data || (currJSONDataset.data = []);
    currJSONDataset.data.push.apply(currJSONDataset.data, newDataset[i].data);
  }

  cachedCategories.category.push.apply(cachedCategories.category, newCategory);
},

/**
 * Calculates space for components during realtime update
 */
_RTmanageSpace = function _RTmanageSpace() {
  var iapi = this,
      config = iapi.config,
      chartChildren = iapi.getChildren(),
      xAxis = chartChildren.xAxis[0],
      yAxis = chartChildren.yAxis[0],
      sYAxis = chartChildren.yAxis[1],
      bottom,
      canvas = chartChildren.canvas && chartChildren.canvas[0],
      canvasConfig = canvas.config,
      canvasBorderWidth = canvasConfig.canvasBorderWidth,
      canvasPaddingTop = canvasConfig.canvasPaddingTop,
      canvasPaddingBottom = canvasConfig.canvasPaddingBottom,
      canvasPadding = canvasConfig.canvasPadding || 0,
      canvasPaddingLeft = canvasConfig.canvasPaddingLeft,
      canvasPaddingRight = canvasConfig.canvasPaddingRight,
      xAxisSpaceAllocation,
      availableWidth,
      prevXAxisSpaceAllocation = config.xAxisSpaceAllocation,
      spaceTakenByYAxis = config.yAxisSpaceAllocation || [],
      prevSpaceTakenByYAxis = spaceTakenByYAxis.map(copyObject),
      pYAxisStartXPos,
      sYAxisStartXPos,
      pYAxisOppLength,
      sYAxisOppLength,
      tempVar,
      yAxisPrevDim = yAxis && JSON.stringify(yAxis.getAxisDimension()),
      sYAxisPrevDim = yAxis && JSON.stringify(yAxis.getAxisDimension()),
      yAxisDim,
      top,
      shift = config.shift || 0,
      sYAxisDim;
  xAxisSpaceAllocation = config.xAxisSpaceAllocation = xAxis.placeAxis(config.availableHeight + (xAxis.config.isOpposit ? prevXAxisSpaceAllocation.top : prevXAxisSpaceAllocation.bottom));
  bottom = xAxisSpaceAllocation.bottom - prevXAxisSpaceAllocation.bottom;
  top = xAxisSpaceAllocation.top - prevXAxisSpaceAllocation.top; // when xAxis not at previous position

  if (top !== 0 || bottom !== 0) {
    iapi._allocateSpace({
      bottom: bottom,
      top: top
    });

    availableWidth = config.availableWidth; // place primary axis

    spaceTakenByYAxis[0].spaceTaken = yAxis.placeAxis(availableWidth + prevSpaceTakenByYAxis[0].spaceTaken.left);

    if (sYAxis) {
      // place secondary axis
      spaceTakenByYAxis[1].spaceTaken = sYAxis.placeAxis(availableWidth + prevSpaceTakenByYAxis[1].spaceTaken.right);
    } // since in dy charts the one axis trenvalue overlaps with
    // the other axis, so here all axis is placed and then
    // based on maximum space on each side the space is allocated


    iapi._allocateSpace({
      left: (0, _safeMax.default)(spaceTakenByYAxis, spaceLeft) - (0, _safeMax.default)(prevSpaceTakenByYAxis, spaceLeft),
      right: (0, _safeMax.default)(spaceTakenByYAxis, spaceRight) - (0, _safeMax.default)(prevSpaceTakenByYAxis, spaceRight)
    });

    availableWidth = config.availableWidth;
    pYAxisStartXPos = config.canvasLeft - canvasBorderWidth;
    pYAxisOppLength = config.canvasRight + canvasBorderWidth;

    if (sYAxis) {
      sYAxisStartXPos = pYAxisOppLength;
      sYAxisOppLength = pYAxisStartXPos; // when primary axis is on right change the positions

      if (config.primaryAxisOnleft === 0) {
        tempVar = pYAxisStartXPos;
        pYAxisStartXPos = sYAxisStartXPos;
        sYAxisStartXPos = tempVar;
        tempVar = pYAxisOppLength;
        pYAxisOppLength = sYAxisOppLength;
        sYAxisOppLength = tempVar;
      }

      sYAxis.setAxisDimention({
        x: sYAxisStartXPos,
        y: config.canvasTop + canvasPaddingTop,
        opposite: sYAxisOppLength,
        axisLength: config.canvasHeight - canvasPaddingTop - canvasPaddingBottom
      });
    }

    xAxis && xAxis.setAxisDimention({
      x: config.canvasLeft + mathMax(canvasPaddingLeft, canvasPadding),
      y: xAxis.config.isOpposit ? config.canvasTop - canvasBorderWidth : config.canvasBottom + shift + canvasBorderWidth,
      opposite: xAxis.config.isOpposit ? config.canvasBottom + shift + canvasBorderWidth : config.canvasTop - canvasBorderWidth,
      axisLength: config.canvasWidth - mathMax(canvasPaddingLeft, canvasPadding) - mathMax(canvasPaddingRight, canvasPadding)
    });
    yAxis && yAxis.setAxisDimention({
      x: yAxis.config.isOpposit ? pYAxisOppLength : pYAxisStartXPos,
      y: config.canvasTop + canvasPaddingTop,
      opposite: yAxis.config.isOpposit ? pYAxisStartXPos : pYAxisOppLength,
      axisLength: config.canvasHeight - canvasPaddingTop - canvasPaddingBottom
    });
  }

  iapi.canvasPadding && canvas.setCanvasPadding();
  canvas.setDimension({
    top: config.canvasTop,
    left: config.canvasLeft,
    width: config.canvasWidth,
    height: config.canvasHeight
  });
  canvasBorderWidth = canvasConfig.canvasBorderWidth;
  canvasPaddingTop = canvasConfig.canvasPaddingTop;
  canvasPaddingBottom = canvasConfig.canvasPaddingBottom;
  canvasPadding = canvasConfig.canvasPadding || 0;
  canvasPaddingLeft = canvasConfig.canvasPaddingLeft;
  canvasPaddingRight = canvasConfig.canvasPaddingRight;
  sYAxis && sYAxis.setAxisDimention({
    x: config.canvasRight + canvasBorderWidth,
    y: config.canvasTop + canvasPaddingTop,
    opposite: sYAxisOppLength,
    axisLength: config.canvasHeight - canvasPaddingTop - canvasPaddingBottom
  });
  xAxis && xAxis.setAxisDimention({
    x: config.canvasLeft + mathMax(canvasPaddingLeft, canvasPadding),
    y: xAxis.config.isOpposit ? config.canvasTop - canvasBorderWidth : config.canvasBottom + shift + canvasBorderWidth,
    opposite: xAxis.config.isOpposit ? config.canvasBottom + shift + canvasBorderWidth : config.canvasTop - canvasBorderWidth,
    axisLength: config.canvasWidth - mathMax(canvasPaddingLeft, canvasPadding) - mathMax(canvasPaddingRight, canvasPadding)
  });
  yAxis && yAxis.setAxisDimention({
    x: yAxis.config.isOpposit ? config.canvasRight + canvasBorderWidth : config.canvasLeft - canvasBorderWidth,
    y: config.canvasTop + canvasPaddingTop,
    opposite: yAxis.config.isOpposit ? config.canvasLeft - canvasBorderWidth : config.canvasRight + canvasBorderWidth,
    axisLength: config.canvasHeight - canvasPaddingTop - canvasPaddingBottom
  });
  yAxisDim = yAxis && JSON.stringify(yAxis.getAxisDimension());
  sYAxisDim = yAxis && JSON.stringify(yAxis.getAxisDimension());
  config.drawYAxis = yAxisDim !== yAxisPrevDim;
  config.drawSyAxis = sYAxisDim !== sYAxisPrevDim;
},

/**
 * Update visuals during real time draw.
 * @param  {Object} eventArgs Conatins the key value for the event Args of realTimeUpdate event.
 */
realTimeDraw = function realTimeDraw(eventArgs) {
  if (eventArgs === void 0) {
    eventArgs = {};
  }

  var iapi = this,
      iapiConf = iapi.config,
      chartChildren = iapi.getChildren(),
      canvas = chartChildren.canvas && chartChildren.canvas[0],
      xAxis = chartChildren.xAxis && chartChildren.xAxis[0],
      yAxis = chartChildren.yAxis && chartChildren.yAxis[0],
      sYAxis = chartChildren.yAxis && chartChildren.yAxis[1],
      dataset = getDataset(iapi),
      dslen = dataset.length,
      len,
      dataObj = iapiConf.cachedArrivedJSON,
      newDataset = dataObj && dataObj.dataset,
      newCategory = dataObj && dataObj.categories && dataObj.categories.category || [],
      catLen = xAxis && xAxis.getTicksLen(),
      realTimeConfig = iapiConf.realTimeConfig = iapiConf.realTimeConfig || (iapiConf.realTimeConfig = {}),
      prevData = realTimeConfig.prevData,
      newCatLength = 0,
      curDataset,
      datasetParent,
      showRTValue = realTimeConfig.showRTValue,
      i,
      drawLatency,
      isClear = realTimeConfig.clear,
      getValueArray = function getValueArray(data) {
    if (data === void 0) {
      data = [];
    }

    var dataLen = data.length,
        newData = [],
        ii,
        dataObject;

    for (ii = 0; ii < dataLen; ++ii) {
      dataObject = data[ii];
      newData.push(dataObject.value);
    }

    return newData;
  };

  iapiConf._eventArgs = eventArgs;
  eventArgs.prevData = prevData;
  realTimeConfig.prevData = []; // set the state that the realtime update is going to happen

  iapi.getFromEnv('animationManager').setAnimationState('realTimeUpdate');
  iapi.__rtDrawStartAt = new Date();
  iapi.__realtimeUpdateComplete || (iapi.__realtimeUpdateComplete = function () {
    drawLatency = new Date() - iapi.__rtDrawStartAt;

    if (!isClear) {
      iapiConf._eventArgs.latency = drawLatency;
      iapiConf._eventArgs.updateObject = realTimeConfig.legacyUpdateObj;
    }

    iapi.getChildren('dataStreamer')[0].addToEnv('realtimeDrawingLatency', drawLatency);
    iapi.fireChartInstanceEvent('realTimeUpdateComplete', iapiConf._eventArgs);
  });
  iapi.addJob('realtimeupdatecomplete', iapi.__realtimeUpdateComplete, _index2.priorityList.postRender);

  if (dataset) {
    // Register a drawing job canvas and it's childs
    canvas.asyncDraw();

    if (dataObj) {
      if (xAxis) {
        // Set a drawing job for the xAxis.
        xAxis.asyncDraw();
        xAxis.categoryInsert(catLen, newCategory, true);

        for (i = 0, len = newCategory.length; i < len; i++) {
          if (!newCategory[i].vline) {
            newCatLength += 1;
          }
        }

        xAxis.categoryDelete(0, newCatLength, true);
        xAxis.categoryTranslate(newCatLength);
      }

      iapiConf._sumValuesUpdated = false;

      if (isClear) {
        for (i = 0; i < dslen; i++) {
          dataset[i]._realTimeConfigure(true);
        }

        realTimeConfig.clear = false;
      }

      for (i = 0; i < dslen; i++) {
        curDataset = newDataset[i];
        dataset[i].addData(curDataset);
        dataset[i].removeData(0, curDataset.data.length);
        dataset[i].resetCatPos();
        dataset[i].setMaxMin();
        datasetParent = dataset[i].getLinkedParent();
        datasetParent.childChanged();
        realTimeConfig.prevData.push(getValueArray(curDataset.data));
      }

      iapiConf.cachedArrivedJSON = UNDEF;
    } // Function to manage space during realTime


    iapi.rtManageSpace && iapi._RTmanageSpace();
    iapiConf.drawYAxis && yAxis && yAxis.asyncDraw();
    iapiConf.drawSyAxis && sYAxis && sYAxis.asyncDraw();

    iapi._preDraw();

    if (showRTValue && iapi._drawRealTimeValue) {
      iapi.asyncRealTimeValueDraw();
    }
  }
},

/**
 * Legacy function for real time update via feedData
 * @param  {string}  stream raw data that has to be fed to the chart
 * @return {boolean} whether data are fed or not
 */
feedData = function feedData(stream) {
  var iapi = this,
      dataStreamer = iapi.getFromEnv('dataStreamer');
  dataStreamer.responseTextHandler(stream);
  dataStreamer.refreshVisualHandler({
    source: 'feedData',
    data: stream
  });
},

/**
 * Parse server input text and converts to input data object for chart
 * @param {string} _responseText User input text as from server
 * @return {Object} parsed data from response text
 */
_linearDataParser = function _linearDataParser(_responseText) {
  /* Commands to handle:
   * label, value, toolText, showLabel, link, color, vLine and related params (?),
   * clear, stopUpdate, pointerId related updates,
   */
  var iapi = this,
      commands,
      command,
      params,
      valueVisibility,
      toolTexts,
      toolTextsTarget,
      colors,
      links,
      vlineLabels,
      vlineColors,
      vlineThickness,
      vlineDashed,
      showLabels,
      i,
      l,
      labels,
      vlines,
      values,
      id,
      target,
      dataStamp,
      pause,
      clear,
      len,
      data,
      j,
      responseText = _responseText,
      existingDatasets = getDataset(iapi),
      existingDatasetsLen = existingDatasets && existingDatasets.length,
      valuesLen,
      valuefontcolors,
      valuebgcolors,
      valuebordercolors,
      realTimeConfig = iapi.config.realTimeConfig,
      legacyUpdateObj = realTimeConfig.legacyUpdateObj = {},
      dataObjValues = legacyUpdateObj.values = [],
      dataObjIds = legacyUpdateObj.id = [],
      dataObjTarget = legacyUpdateObj.target = [],
      dataObjShowValues = legacyUpdateObj.valueVisibility = [],
      dataObjToolTexts = legacyUpdateObj.toolTexts = [],
      dataObjToolTextsTarget = legacyUpdateObj.toolTextsTarget = [],
      dataObjColors = legacyUpdateObj.colors = [],
      dataObjLinks = legacyUpdateObj.links = [],
      dataObjValueFontColors = legacyUpdateObj.valueFontColors = [],
      dataObjValueBgColors = legacyUpdateObj.valueBgColors = [],
      dataObjValueBorderColors = legacyUpdateObj.valueBorderColors = [],
      maxValueLen = 0,
      dataObj,
      updateObj = {
    categories: {
      category: []
    },
    dataset: []
  },
      labelsLen,
      category = updateObj.categories.category,
      dataset = updateObj.dataset,
      lowerCaseCommand,
      tempToolText = responseText,
      toolText; // clean value

  responseText = responseText && responseText.toString && responseText.toString() || ''; // replacing all the | with , for hlinear gauge and angular gauge.

  if (iapi.rtParserModify) {
    tempToolText = tempToolText.replace(/([^\\])(\|)/g, '$1,');
    responseText = responseText.replace(/\|/g, ',');
  } // split the commands.


  commands = responseText.split(AMPERSAND);

  for (i = 0, l = commands.length; i < l; i += 1) {
    // for every command, separate the command name and its values.
    command = commands[i].split(EQUALS);
    params = command[1];
    command = command[0]; // no need to process improper data strings as of now.

    if (command === _index.BLANKSTRING || command === UNDEF || params === UNDEF || params === _index.BLANKSTRING) {
      continue;
    } // desensitize case.


    lowerCaseCommand = command.toLowerCase();

    switch (lowerCaseCommand) {
      case 'label':
        legacyUpdateObj.labels = labels = params.split(COMMA);
        break;

      case 'vline':
        legacyUpdateObj.vlines = vlines = params.split(COMMA);
        break;

      case 'vlinelabel':
        legacyUpdateObj.vlineLabels = vlineLabels = params.split(COMMA);
        break;

      case 'vlinecolor':
        legacyUpdateObj.vlineColors = vlineColors = params.split(COMMA);
        break;

      case 'vlinethickness':
        legacyUpdateObj.vlineThickness = vlineThickness = params.split(COMMA);
        break;

      case 'vlinedashed':
        legacyUpdateObj.vlineDashed = vlineDashed = params.split(COMMA);
        break;

      case 'value':
        values = params.split(PIPE);
        break;

      case 'valuefontcolor':
        valuefontcolors = params.split(PIPE);
        break;

      case 'valuebgcolor':
        valuebgcolors = params.split(PIPE);
        break;

      case 'valuebordercolor':
        valuebordercolors = params.split(PIPE);
        break;

      case 'target':
        target = params.split(PIPE);
        break;

      case 'showlabel':
        legacyUpdateObj.showLabels = showLabels = params.split(COMMA);
        break;

      case 'showvalue':
        valueVisibility = params.split(PIPE);
        break;

      case 'tooltext':
        toolTexts = tempToolText.match(/tooltext=(.*?\\&)*.*?[^\\]&/i);
        toolTexts = // When tooltext is succeeded by other parameters like &value, &color, etc.
        // Eliminating 'tooltext=' text from tooltext.
        toolTexts ? toolTexts[0].substr(9, toolTexts[0].length - 10) // When tooltext is the last argument in the feedData string.
        : tempToolText.match(/(tooltext=)(.*)/i)[2]; // Replacing all '|' characters except '\|' characters.

        toolTexts = toolTexts && toolTexts.replace(/([^\\])(\|)/g, '$1_FC@@**');
        toolTexts = toolTexts.split('_FC@@**'); // @todo - The string has to split with '|' and not '\|' directly without using replace.
        // // When tooltext is succeeded by other parameters like &value, &color, etc.
        // if (toolTexts[1] && toolTexts[2]) {
        //     toolTexts = toolTexts[1] + toolTexts[2];
        //     toolTexts = toolTexts.split(/\|(?=\\)/);
        // }
        // // When tooltext is the last argument in the feedData string.
        // else {
        //     toolTexts = tempToolText.match(/(tooltext=)(.*)/i)[2];
        //     toolTexts = toolTexts && toolTexts.split(/\|(?=\|)/);
        // }

        break;

      case 'targettooltext':
        toolTextsTarget = params.split(PIPE);
        break;

      case 'link':
        links = params.split(PIPE);
        break;

      case 'color':
        colors = params.split(PIPE);
        break;

      case 'datastamp':
        legacyUpdateObj.dataStamp = dataStamp = params;
        break;

      case 'stopupdate':
        legacyUpdateObj.pause = pause = params === '1';
        break;

      case 'clear':
        legacyUpdateObj.clear = clear = params === '1';
        break;

      case 'id':
        id = params.split(PIPE);
        break;

      default:
        // directly add the information in the update object
        legacyUpdateObj[command] = updateObj[command] = params;
    }
  }

  valuesLen = values && values.length;

  for (i = 0; i < valuesLen; i++) {
    dataObjValues[i] = values[i].split(COMMA);
    dataObjTarget[i] = target && target[i] && target[i].split(COMMA);
    dataObjShowValues[i] = valueVisibility && valueVisibility[i] && valueVisibility[i].split(COMMA);
    dataObjToolTextsTarget[i] = toolTextsTarget && toolTextsTarget[i] && toolTextsTarget[i].split(COMMA);
    dataObjColors[i] = colors && colors[i] && colors[i].split(COMMA);
    dataObjLinks[i] = links && links[i] && links[i].split(COMMA);
    dataObjValueFontColors[i] = valuefontcolors && valuefontcolors[i] && valuefontcolors[i].split(COMMA);
    dataObjValueBgColors[i] = valuebgcolors && valuebgcolors[i] && valuebgcolors[i].split(COMMA);
    dataObjValueBorderColors[i] = valuebordercolors && valuebordercolors[i] && valuebordercolors[i].split(COMMA);
    dataObjIds[i] = id ? id[i].split(COMMA) : null;

    if (toolTexts) {
      toolText = toolTexts[i];

      if (toolText) {
        toolText = toolText.replace(/([^\\])(\,)/g, '$1_FC@@**');
        dataObjToolTexts[i] = toolText.split('_FC@@**');
      }
    } // Finding the dataset that has the maximum data entered through feedData.


    maxValueLen = mathMax(maxValueLen, dataObjValues[i].length);
  }

  labelsLen = labels && labels.length; // No of data that is to be added is the maximum of number of categories or the num of data entered.

  len = mathMax(labelsLen || 0, maxValueLen || 0);

  for (i = 0; i < len; i++) {
    category.push({
      label: labels && labels[i],
      color: vlineColors && vlineColors[i],
      showlabel: showLabels && showLabels[i]
    });
  }

  if (vlines) {
    category.push({
      label: vlineLabels && vlineLabels[0],
      vline: vlines && vlines[0],
      color: vlineColors && vlineColors[0],
      thickness: vlineThickness && vlineThickness[0],
      dashed: vlineDashed && vlineDashed[0],
      showlabel: showLabels && showLabels[0]
    });
  }

  for (i = 0; i < existingDatasetsLen; i++) {
    dataObj = {};
    data = dataObj.data = [];

    for (j = 0; j < len; j++) {
      data.push({
        value: dataObjValues[i] && dataObjValues[i][j],
        target: dataObjTarget[i] && dataObjTarget[i][j],
        showvalue: dataObjShowValues[i] && dataObjShowValues[i][j],
        tooltext: dataObjToolTexts[i] && dataObjToolTexts[i][j] && decodeURIComponent(dataObjToolTexts[i][j].replace(/\\/g, '')),
        tooltexttarget: dataObjToolTextsTarget[i] && dataObjToolTextsTarget[i][j],
        color: dataObjColors[i] && dataObjColors[i][j],
        link: dataObjLinks[i] && dataObjLinks[i][j] && decodeURIComponent(dataObjLinks[i][j]),
        valuefontcolor: dataObjValueFontColors[i] && dataObjValueFontColors[i][j],
        valuebgcolor: dataObjValueBgColors[i] && dataObjValueBgColors[i][j],
        valuebordercolor: dataObjValueBorderColors[i] && dataObjValueBorderColors[i][j],
        id: dataObjIds[i] && dataObjIds[i][j]
      });
    }

    dataset.push(dataObj);
  }

  if (pause) {
    iapi._stopUpdate();
  }

  if (clear) {
    iapi._clearChart();
  }

  if (dataStamp) {
    iapi.config.dataStamp = dataStamp;
  }

  return updateObj;
},

/**
 * Clears the entire chart plots
 * @param {string} _source The source of feeding data into chart for realtime
 */
_clearChart = function _clearChart(_source) {
  var iapi = this,
      chartChildren = iapi.getChildren(),
      xAxis = chartChildren.xAxis && chartChildren.xAxis[0],
      dataset = getDataset(iapi),
      catLen = xAxis.getTicksLen(),
      visibleRange = xAxis.getVisibleConfig(),
      maxValue = visibleRange.maxValue,
      minValue = visibleRange.minValue,
      stretch = catLen > maxValue ? maxValue - minValue : catLen,
      realTimeConfig = iapi.config.realTimeConfig || (iapi.config.realTimeConfig = {}),
      showRTValue = realTimeConfig.showRTValue,
      curDataset,
      i,
      len = dataset.length;
  realTimeConfig.clear = true;

  if (dataset) {
    if (xAxis) {
      xAxis.categoryDelete(0, stretch, true);
    }

    iapi.config._sumValuesUpdated = false;

    for (i = 0; i < len; i++) {
      curDataset = dataset[i];
      dataset[i].removeData(0, curDataset.components.data.length);
      dataset[i].resetCatPos();
    }

    iapi._setCategories();
  }

  if (showRTValue && iapi._drawRealTimeValue) {
    iapi.asyncRealTimeValueDraw();
  }

  iapi.fireChartInstanceEvent('ChartCleared', {
    source: _source
  }, [iapi.getId(), _source]);
},
    _setRTmenu = function _setRTmenu(showRTmenuItem, useMessageLog) {
  var iapi = this,
      hamburger = iapi.getFromEnv('hamburger'),
      stopState = true,
      list = [],
      toggle = function toggle() {
    if (stopState) {
      iapi._stopUpdate();

      hamburger.getChild('listContainer').getChild('rt').configure({
        id: 'rt',
        name: 'Restart Update',
        handler: function handler() {
          toggle();
        },
        action: 'click'
      });
      hamburger.getChild('listContainer').getChild('rt').asyncDraw();
      stopState = false;
    } else {
      iapi._restartUpdate();

      hamburger.getChild('listContainer').getChild('rt').configure({
        id: 'rt',
        name: 'Stop Update',
        handler: function handler() {
          toggle();
        },
        action: 'click'
      });
      hamburger.getChild('listContainer').getChild('rt').asyncDraw();
      stopState = true;
    }
  };

  showRTmenuItem && list.push({
    name: 'Clear Chart',
    'handler': function handler() {
      iapi._clearChart();
    },
    'action': 'click'
  });
  useMessageLog && list.push({
    name: 'Show Log',
    'handler': function handler() {
      iapi.getChildren('messageLogger')[0].show();
    },
    'action': 'click'
  });
  showRTmenuItem && list.push({
    id: 'rt',
    name: 'Stop Update',
    handler: function handler() {
      toggle();
    },
    action: 'click'
  });
  list.length && hamburger.appendInMenu(list);
};

exports._setRTmenu = _setRTmenu;
exports._clearChart = _clearChart;
exports._linearDataParser = _linearDataParser;
exports.feedData = feedData;
exports.realTimeDraw = realTimeDraw;
exports._RTmanageSpace = _RTmanageSpace;
exports.realTimeUpdate = realTimeUpdate;
exports.eiMethods = eiMethods;
exports._isUpdateActive = _isUpdateActive;
exports._restartUpdate = _restartUpdate;
exports._stopUpdate = _stopUpdate;
exports._realTimeConfigure = _realTimeConfigure;

/***/ }),

/***/ 1526:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _lib = __webpack_require__(274);

var _sscartesian = _interopRequireDefault(__webpack_require__(517));

/* eslint require-jsdoc: 'error', valid-jsdoc: ["error", { "requireReturn": false }] */
var UNDEF,
    math = Math,
    mathMin = math.min,
    mathMax = math.max,
    mathCeil = math.ceil,
    GUTTER_PADDING = 2,
    defaultGaugePaletteOptions = (0, _lib.extend2)({}, _lib.defaultGaugePaletteOptions);
/**
 * Creates SparkChartBase class for spark charts series
 */

var SparkChartBase = /*#__PURE__*/function (_SSCartesian) {
  (0, _inheritsLoose2.default)(SparkChartBase, _SSCartesian);

  /**
   * Provides the name of the chart extension
   *
   * @static
   * @return {string} The name of the chart extension
   */
  SparkChartBase.getName = function getName() {
    return 'SparkChartBase';
  }
  /**
   * Constructor class for SparkChartBase
   */
  ;

  function SparkChartBase() {
    var _this;

    _this = _SSCartesian.call(this) || this;
    _this.showBorder = 0;
    _this.chartTopMargin = 3;
    _this.chartRightMargin = 3;
    _this.chartBottomMargin = 3;
    _this.chartLeftMargin = 3;
    _this.canvasborderthickness = 0;
    _this.subTitleFontSizeExtender = 0;
    _this.subTitleFontWeight = 0;
    _this.defaultPaletteOptions = (0, _lib.extend2)((0, _lib.extend2)({}, defaultGaugePaletteOptions), {
      // Store colors now
      paletteColors: [['555555', 'A6A6A6', 'CCCCCC', 'E1E1E1', 'F0F0F0'], ['A7AA95', 'C4C6B7', 'DEDFD7', 'F2F2EE'], ['04C2E3', '66E7FD', '9CEFFE', 'CEF8FF'], ['FA9101', 'FEB654', 'FED7A0', 'FFEDD5'], ['FF2B60', 'FF6C92', 'FFB9CB', 'FFE8EE']],
      // Store other colors
      // ------------- For 2D Chart ---------------//
      // We're storing 5 combinations, as we've 5 defined palettes.
      bgColor: ['FFFFFF', 'CFD4BE,F3F5DD', 'C5DADD,EDFBFE', 'A86402,FDC16D', 'FF7CA0,FFD1DD'],
      bgAngle: [270, 270, 270, 270, 270],
      bgRatio: ['0,100', '0,100', '0,100', '0,100', '0,100'],
      bgAlpha: ['100', '60,50', '40,20', '20,10', '30,30'],
      canvasBgColor: ['FFFFFF', 'FFFFFF', 'FFFFFF', 'FFFFFF', 'FFFFFF'],
      canvasBgAngle: [0, 0, 0, 0, 0],
      canvasBgAlpha: ['100', '100', '100', '100', '100'],
      canvasBgRatio: [_lib.BLANKSTRING, _lib.BLANKSTRING, _lib.BLANKSTRING, _lib.BLANKSTRING, _lib.BLANKSTRING],
      canvasBorderColor: ['BCBCBC', 'BEC5A7', '93ADBF', 'C97901', 'FF97B1'],
      toolTipBgColor: ['FFFFFF', 'FFFFFF', 'FFFFFF', 'FFFFFF', 'FFFFFF'],
      toolTipBorderColor: ['545454', '545454', '415D6F', '845001', '68001B'],
      baseFontColor: ['333333', '60634E', '025B6A', 'A15E01', '68001B'],
      trendColor: ['666666', '60634E', '415D6F', '845001', '68001B'],
      plotFillColor: ['666666', 'A5AE84', '93ADBF', 'C97901', 'FF97B1'],
      borderColor: ['767575', '545454', '415D6F', '845001', '68001B'],
      borderAlpha: [50, 50, 50, 50, 50],
      periodColor: ['EEEEEE', 'ECEEE6', 'E6ECF0', 'FFF4E6', 'FFF2F5'],
      // Colors for win loss chart
      winColor: ['666666', '60634E', '025B6A', 'A15E01', 'FF97B1'],
      lossColor: ['CC0000', 'CC0000', 'CC0000', 'CC0000', 'CC0000'],
      drawColor: ['666666', 'A5AE84', '93ADBF', 'C97901', 'FF97B1'],
      scorelessColor: ['FF0000', 'FF0000', 'FF0000', 'FF0000', 'FF0000']
    }, false, true);
    return _this;
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */


  var _proto = SparkChartBase.prototype;

  _proto.getName = function getName() {
    return 'SparkChartBase';
  }
  /**
   * Returns the postion for the caption placement
   * @return {number} extra space needed for caption
   */
  ;

  _proto._fetchCaptionPos = function _fetchCaptionPos() {
    var extraSpace,
        iapi = this,
        caption = iapi.getChildren('caption')[0],
        captionConfig = caption.config; // check if even after placing the caption
    // space available on right.
    // left aligned.

    /** @todo need to optimize this logic */

    if (captionConfig.isOnLeft) {
      extraSpace = -1;
    } else {
      // right aligned
      extraSpace = -1;
    }

    return extraSpace;
  }
  /**
   * Parse the chart attributes and store in chart's config
   * @param {Object} dataObj User input json
   */
  ;

  _proto.parseChartAttr = function parseChartAttr(dataObj) {
    _SSCartesian.prototype.parseChartAttr.call(this, dataObj);

    var iapi = this,
        chartAttrs = iapi.getFromEnv('dataSource').chart,
        config = iapi.config;
    config.origCanvasLeftMargin = (0, _lib.pluckNumber)(chartAttrs.canvasleftmargin);
    config.origCanvasRightMargin = (0, _lib.pluckNumber)(chartAttrs.canvasrightmargin);
    config.origCanvasTopMargin = (0, _lib.pluckNumber)(chartAttrs.canvastopmargin);
    config.origCanvasBottomMargin = (0, _lib.pluckNumber)(chartAttrs.canvasbottommargin);
    config.showBorder = (0, _lib.pluckNumber)(chartAttrs.showborder, 0);
  }
  /**
   * Manages space for the chart
   */
  ;

  _proto._spaceManager = function _spaceManager() {
    var availableWidth,
        availableHeight,
        iapi = this,
        config = iapi.config,
        canvasBaseDepth = config.canvasBaseDepth,
        canvas = iapi.getChildren('canvas')[0],
        captionStyle = iapi.getChildren('caption')[0].config.style,
        subCaptionStyle = iapi.getChildren('subCaption')[0].config.style,
        chartAttrs = iapi.getFromEnv('dataSource').chart,
        style = iapi.getFromEnv('style'),
        canvasBorderWidth = canvas.config.canvasBorderWidth,
        chartBorderWidth = config.borderWidth,
        canvasMarginTop = config.canvasMarginTop,
        canvasMarginBottom = config.canvasMarginBottom,
        canvasMarginLeft = config.canvasMarginLeft,
        canvasMarginRight = config.canvasMarginRight,
        minCanvasHeight = config.minCanvasHeight,
        minCanvasWidth = config.minCanvasWidth,
        height = config.height,
        width = config.width,
        diff,
        heightAdjust = false,
        widthAdjust = false,
        top,
        bottom,
        left,
        right,
        currentCanvasHeight,
        currentCanvasWidth,
        origCanvasTopMargin = config.origCanvasTopMargin,
        origCanvasBottomMargin = config.origCanvasBottomMargin,
        origCanvasLeftMargin = config.origCanvasLeftMargin,
        origCanvasRightMargin = config.origCanvasRightMargin,
        sum; // Setting the font size every time the viewport is resized
    // and chart is consequently redrawn

    captionStyle.fontSize = (0, _lib.pluckNumber)(this.computeFontSize(chartAttrs.captionfontsize), this.computeFontSize(style.fontSizeWithUnit) + 3) + _lib.PXSTRING;
    (0, _lib.setLineHeight)(captionStyle);
    subCaptionStyle.fontSize = (0, _lib.pluckNumber)(this.computeFontSize(chartAttrs.subcaptionfontsize), (0, _lib.pluckNumber)(mathMax((0, _lib.pluckNumber)(this.computeFontSize(chartAttrs.captionfontsize)) - 3, -1), this.computeFontSize(style.fontSizeWithUnit)) + (0, _lib.pluckNumber)(iapi.subTitleFontSizeExtender, 1)) + _lib.PXSTRING;
    (0, _lib.setLineHeight)(subCaptionStyle);

    iapi._allocateSpace({
      top: chartBorderWidth,
      bottom: chartBorderWidth,
      left: chartBorderWidth,
      right: chartBorderWidth
    }); // alocate the space for datasets


    availableHeight = config.availableHeight * 0.325;
    iapi._getDSspace && iapi._allocateSpace(iapi._getDSspace(availableHeight));

    iapi._allocateSpace(iapi._manageActionBarSpace && iapi._manageActionBarSpace(config.availableHeight * 0.225) || {});

    config.availableWidth = config.width;
    availableWidth = config.availableWidth * 0.75;
    availableWidth = availableWidth - config.origMarginLeft - config.origMarginRight - config.borderWidth * 2;
    availableWidth = mathMax(config.availableWidth * 0.1, availableWidth); // a space manager that manages the space for the tools as well as the captions.

    iapi._manageChartMenuBar(availableWidth); // iapi._allocateSpace(iapi._manageCaptionSpacing(availableWidth));


    availableWidth = (config.availableWidth - config.borderWidth * 2) * 0.75; // Space management for SparkWinLoss and SparkLine charts

    iapi._placeOpenCloseValues && iapi._allocateSpace(iapi._placeOpenCloseValues(availableWidth));

    iapi._allocateSpace({
      top: canvasBorderWidth,
      bottom: canvasBorderWidth,
      left: canvasBorderWidth,
      right: canvasBorderWidth
    });

    iapi._allocateSpace({
      bottom: canvasBaseDepth
    }); // Check for minimum canvas width and height


    if (minCanvasHeight > height - canvasMarginTop - canvasMarginBottom) {
      heightAdjust = true;
      diff = config.canvasHeight - minCanvasHeight;
      sum = canvasMarginTop + canvasMarginBottom;
      canvasMarginTop = config.canvasMarginTop = diff * canvasMarginTop / sum;
      canvasMarginBottom = config.canvasMarginBottom = diff * canvasMarginBottom / sum;
    }

    if (minCanvasWidth > width - canvasMarginLeft - canvasMarginRight) {
      widthAdjust = true;
      diff = config.canvasWidth - minCanvasWidth;
      sum = canvasMarginLeft + canvasMarginRight;
      canvasMarginLeft = config.canvasMarginLeft = diff * canvasMarginLeft / sum;
      canvasMarginRight = config.canvasMarginRight = diff * canvasMarginRight / sum;
    } // Allocate space for canvas margin only if the margin is less than the margin entered by the user.


    top = canvasMarginTop > config.canvasTop ? canvasMarginTop - config.canvasTop : 0;
    bottom = canvasMarginBottom > height - config.canvasBottom ? canvasMarginBottom + config.canvasBottom - height : 0;
    left = canvasMarginLeft > config.canvasLeft ? canvasMarginLeft - config.canvasLeft : 0;
    right = canvasMarginRight > width - config.canvasRight ? canvasMarginRight + config.canvasRight - width : 0;

    iapi._allocateSpace({
      top: top,
      bottom: bottom,
      left: left,
      right: right
    }); // Forcing canvas height to its minimum


    if (heightAdjust) {
      sum = origCanvasTopMargin + origCanvasBottomMargin;
      currentCanvasHeight = config.canvasHeight;

      if (currentCanvasHeight > minCanvasHeight) {
        diff = currentCanvasHeight - minCanvasHeight;
        top = diff * origCanvasTopMargin / sum;
        bottom = diff * origCanvasBottomMargin / sum;
      }

      iapi._allocateSpace({
        top: top,
        bottom: bottom
      });
    } // Forcing canvas width to its minimum


    if (widthAdjust) {
      sum = origCanvasLeftMargin + origCanvasRightMargin;
      currentCanvasWidth = config.canvasWidth;

      if (currentCanvasWidth > minCanvasWidth) {
        diff = currentCanvasWidth - minCanvasWidth;
        left = diff * origCanvasLeftMargin / sum;
        right = diff * origCanvasRightMargin / sum;
      }

      iapi._allocateSpace({
        left: left,
        right: right
      });
    } // Manage canvasMargins
    // If there is user given canvasMargins apply those to the chart


    if (config.origCanvasLeftMargin !== UNDEF) {
      config.canvasWidth = mathMax(config.canvasWidth + config.canvasLeft - config.origCanvasLeftMargin, config.availableWidth * 0.2);
      config.canvasLeft = config.origCanvasLeftMargin;
    }

    canvas.setDimension({
      top: config.canvasTop,
      left: config.canvasLeft,
      width: config.canvasWidth,
      height: config.canvasHeight
    });
  }
  /**
   * Manages space for Caption placement
   * @param {number} availableWidth available width for caption
   * @return {Object} dimension object(width, height)
   */
  ;

  _proto._manageCaptionSpacing = function _manageCaptionSpacing(availableWidth) {
    var iapi = this,
        chartConfig = iapi.config,
        components = iapi.getChildren(),
        // chartGraphics = iapi.graphics,
    caption = components.caption && components.caption[0],
        subCaption = components.subCaption && components.subCaption[0],
        captionConfig = caption.config,
        subCaptionConfig = subCaption.config,
        captionComponents = caption.components,
        // subCaptionComponents = subCaption.components,
    chartAttrs = iapi.getFromEnv('dataSource').chart,
        SmartLabel = iapi.getFromEnv('smartLabel'),
        titleText = (0, _lib.parseUnsafeString)(chartAttrs.caption),
        subTitleText = (0, _lib.parseUnsafeString)(chartAttrs.subcaption),
        captionPadding = captionConfig.captionPadding = (0, _lib.pluckNumber)(chartAttrs.captionpadding, 2),
        chartMenuBar = components.chartMenuBar && components.chartMenuBar[0],
        chartMenuLogicalSpace = chartMenuBar && chartMenuBar.getLogicalSpace(),
        height = chartConfig.height - (chartMenuLogicalSpace && chartMenuLogicalSpace.height || 0),
        // width = chartConfig.width,
    captionLineHeight = 0,
        subCaptionLineHeight = 0,
        // topGutterWidth = 5,
    canvasBorderThickness = mathMax(components.canvas && components.canvas[0].config.canvasBorderThickness, 0),
        captionHeight = 0,
        allowedHeight = height * 0.7,
        allowedWidth = availableWidth,
        dimensions = {},
        maxCaptionWidth,
        captionObj,
        subCaptionObj,
        capStyle,
        subCapStyle; // text below 3px is not properly visible

    if (allowedHeight > 3) {
      if (captionPadding < canvasBorderThickness) {
        captionPadding = canvasBorderThickness + 2;
      }

      captionConfig.captionPadding = subCaptionConfig.captionPadding = captionPadding;

      if (titleText !== _lib.BLANKSTRING) {
        // calculatethe single line's height
        capStyle = captionConfig.style;
        captionLineHeight = captionConfig.captionLineHeight = mathCeil(parseFloat((0, _lib.pluck)(capStyle.fontHeight, capStyle.lineHeight), 10), 12); // captionFontSize = subCaptionConfig.captionLineHeight =
        //     pluckNumber(parseInt(capStyle.fontSize, 10), 10);
      }

      if (subTitleText !== _lib.BLANKSTRING) {
        subCapStyle = subCaptionConfig.style;
        subCaptionLineHeight = mathCeil(parseInt((0, _lib.pluck)(subCapStyle.lineHeight, subCapStyle.fontHeight), 10), 12); // subCaptionFontSize = pluckNumber(parseInt(subCapStyle.fontSize, 10), 10);
      }

      SmartLabel.useEllipsesOnOverflow(chartConfig.useEllipsesWhenOverflow);

      if (captionLineHeight > 0 || subCaptionLineHeight > 0) {
        SmartLabel.setStyle(capStyle);
        captionObj = SmartLabel.getSmartText(titleText, allowedWidth, height); // Forcefully increase width to give a gutter in caption and sub-caption

        if (captionObj.width > 0) {
          captionObj.width += GUTTER_PADDING;
          captionHeight = captionObj.height;
        }

        SmartLabel.setStyle(subCapStyle);
        subCaptionObj = SmartLabel.getSmartText(subTitleText, allowedWidth, height - captionHeight); // Force fully increase width to give a gutter in caption and subCaption

        if (subCaptionObj.width > 0) {
          subCaptionObj.width += GUTTER_PADDING;
        }

        captionConfig.captionSubCaptionGap = captionObj.height + 0 + subCaptionLineHeight * 0.2;
        maxCaptionWidth = Math.max(captionObj.width, subCaptionObj.width); // Replace the caption and subCaption text with the new wrapped text
        // captionComponents.text = captionObj.text;

        captionConfig.height = captionHeight = captionObj.height;
        captionConfig.width = captionObj.width;
        captionConfig.tooltext && (captionComponents.originalText = captionObj.tooltext); // subCaptionComponents.text = subCaptionObj.text;

        subCaptionConfig.height = captionHeight = subCaptionObj.height;
        subCaptionConfig.width = subCaptionObj.width;
        subCaptionConfig.tooltext && (captionComponents.originalText = subCaptionObj.tooltext);
        maxCaptionWidth = Math.max(captionObj.width, subCaptionObj.width);
        captionConfig.captionPadding = captionPadding = mathMin(availableWidth - maxCaptionWidth, captionPadding); // Add caption padding, if either caption or sub-caption is to be shown

        if (maxCaptionWidth > 0) {
          maxCaptionWidth = mathMin(availableWidth, maxCaptionWidth + captionPadding);
        }

        captionConfig.maxCaptionWidth = subCaptionConfig.maxCaptionWidth = maxCaptionWidth; // totalHeight = totalHeight || canvasBorderThickness;

        if (captionConfig.isOnLeft) {
          dimensions.left = maxCaptionWidth;
        } else {
          dimensions.right = maxCaptionWidth;
        }
      }
    }

    return dimensions;
  }
  /**
   * Calculates caption coordinates
   */
  ;

  _proto._manageCaptionPosition = function _manageCaptionPosition() {
    var iapi = this,
        chartConfig = iapi.config,
        caption = iapi.getChildren('caption')[0],
        subCaption = iapi.getChildren('subCaption')[0],
        captionConfig = caption.config,
        subCaptionConfig = subCaption.config,
        captionPosition = captionConfig.captionPosition,
        maxWidth = mathMax(captionConfig.width, subCaptionConfig.width),
        borderWidth = chartConfig.borderWidth || 0,
        height = chartConfig.height,
        sparkValues = chartConfig.sparkValues || {},
        openValueWidth = sparkValues.openValueWidth || 0,
        captionPadding = captionConfig.captionPadding,
        captionSubCaptionGap = captionConfig.captionSubCaptionGap;

    switch (captionPosition) {
      case _lib.POSITION_MIDDLE:
        captionConfig.y = (height - (captionConfig.height + subCaptionConfig.height)) / 2 + (captionConfig._offsetHeight || 0) * 0.5;
        break;

      case _lib.POSITION_BOTTOM:
        captionConfig.y = height - (captionConfig.height + subCaptionConfig.height) - chartConfig.marginBottom - borderWidth;
        break;

      default:
        // We put it on top by default
        captionConfig.y = chartConfig.marginTop + borderWidth + (captionConfig._offsetHeight || 0);
        break;
    }

    subCaptionConfig.y = captionConfig.y + captionSubCaptionGap;

    if (captionConfig.isOnLeft) {
      captionConfig.align = subCaptionConfig.align = _lib.POSITION_END;
      captionConfig.x = subCaptionConfig.x = chartConfig.canvasLeft - (borderWidth + openValueWidth + GUTTER_PADDING + captionPadding) + chartConfig.borderWidth;
    } else {
      captionConfig.align = subCaptionConfig.align = _lib.POSITION_START;
      captionConfig.x = subCaptionConfig.x = chartConfig.width - chartConfig.marginRight - maxWidth - borderWidth;
    }
  }
  /**
   * function to parse JSON data for configurations of axis
   * @return {Object} configurations of axes
   */
  ;

  _proto._feedAxesRawData = function _feedAxesRawData() {
    var output = _SSCartesian.prototype._feedAxesRawData.call(this),
        xAxisConf = output.xAxisConf[0],
        yAxisConf = output.yAxisConf[0],
        chartAttr = this.getFromEnv('chart-attrib'),
        colorM = this.getFromEnv('color-manager'),
        periodLength = (0, _lib.pluckNumber)(chartAttr.periodlength, 0),
        drawConfig = {
      isDraw: 0
    };

    xAxisConf.lines = yAxisConf.lines = xAxisConf.band = yAxisConf.band = drawConfig;

    if (periodLength) {
      xAxisConf.alternateGridColor = (0, _lib.pluck)(chartAttr.periodcolor, colorM.getColor('periodColor'));
      xAxisConf.alternateGridAlpha = (0, _lib.pluck)(chartAttr.periodalpha, 100);
      xAxisConf.showAlternateGridColor = true;
      xAxisConf.categoryDivLinesFromZero = 0;
      xAxisConf.periodLength = periodLength;
      xAxisConf.band = {
        isDraw: 1
      };
    }

    return output;
  }
  /**
   * function to check if the chart specific data is proper is not
   * this fn is define for specific chart types
   * @return {boolean} if JSON data is valid or not
   */
  ;

  _proto._checkInvalidSpecificData = function _checkInvalidSpecificData() {
    var jsonData = this.getFromEnv('dataSource'),
        dataset = jsonData.dataset;

    if (!dataset || !dataset.length || !(dataset[0].data && dataset[0].data.length)) {
      return true;
    }
  };

  return SparkChartBase;
}(_sscartesian.default);

var _default = SparkChartBase;
exports["default"] = _default;

/***/ }),

/***/ 1497:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _lib = __webpack_require__(274);

var _angularHlinearCommon = __webpack_require__(1498);

var _colorBucket = _interopRequireDefault(__webpack_require__(1446));

var _gauge = _interopRequireDefault(__webpack_require__(1488));

var _polarGaugeAxis = _interopRequireDefault(__webpack_require__(1499));

var _angularGaugeDataset = _interopRequireDefault(__webpack_require__(1502));

var UNDEF,
    BLANK = '',
    math = Math,
    mathMin = math.min,
    mathPI = math.PI,
    deg2rad = mathPI / 180,
    defined = function defined(obj) {
  return obj !== UNDEF && obj !== null;
},
    FRIENDLY_NAME = 'Angular Gauge',
    ANG_GAUGE = 'angulargauge',
    EASE_OUT = 'easeOut';

var AngularGauge = /*#__PURE__*/function (_Gauge) {
  (0, _inheritsLoose2.default)(AngularGauge, _Gauge);

  /**
   * Provides the name of the chart extension
   *
   * @static
   * @return {string} The name of the chart extension
   */
  AngularGauge.getName = function getName() {
    return 'AngularGauge';
  };

  function AngularGauge() {
    var _this;

    _this = _Gauge.call(this) || this;
    _this.isHorizontal = true;
    _this.isAxisOpposite = false;
    _this.isRealTime = true;
    _this.drawPlotlines = false;
    _this.drawPlotBands = false;
    _this.isAxisReverse = false;
    _this.colorRange = true;
    _this.defaultPaletteOptions = (0, _lib.extend2)((0, _lib.extend2)({}, _lib.defaultGaugePaletteOptions), {
      dialColor: ['999999,ffffff,999999', 'ADB68F,F3F5DD,ADB68F', 'A2C4C8,EDFBFE,A2C4C8', 'FDB548,FFF5E8,FDB548', 'FF7CA0,FFD1DD,FF7CA0'],
      dialBorderColor: ['999999', 'ADB68F', 'A2C4C8', 'FDB548', 'FF7CA0'],
      pivotColor: ['999999,ffffff,999999', 'ADB68F,F3F5DD,ADB68F', 'A2C4C8,EDFBFE,A2C4C8', 'FDB548,FFF5E8,FDB548', 'FF7CA0,FFD1DD,FF7CA0'],
      pivotBorderColor: ['999999', 'ADB68F', 'A2C4C8', 'FDB548', 'FF7CA0']
    }, false, true);
    _this.rtParserModify = true;

    _this._setCategories = function () {// Override fn
    };

    _this.registerFactory('dataset', _angularGaugeDataset.default, ['axis']);

    _this.registerFactory('axis', _polarGaugeAxis.default, ['canvas']);

    return _this;
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */


  var _proto = AngularGauge.prototype;

  _proto.getName = function getName() {
    return 'AngularGauge';
  };

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    _Gauge.prototype.__setDefaultConfig.call(this);

    var config = this.config;
    config.friendlyName = FRIENDLY_NAME;
    config.hasLegend = false;
    config.defaultDatasetType = ANG_GAUGE;
    config.animationeffect = EASE_OUT;
    config.skipCanvasDrawing = true;
  };

  _proto.configureAttributes = function configureAttributes(dataObj) {
    _Gauge.prototype.configureAttributes.call(this, dataObj);

    var iapi = this,
        jsonData = iapi.getFromEnv('dataSource'),
        colorrange = jsonData.colorrange; // If color array is present and contains non-zero color items

    if (colorrange && colorrange.color && colorrange.color.length) {
      // componentFactory(iapi, ColorGradient, 'colorRange', 1, [colorrange]);
      (0, _lib.componentFactory)(iapi, _colorBucket.default, 'colorRange', 1, [{
        colorRange: colorrange,
        numberFormatter: iapi.getFromEnv('number-formatter')
      }]);
      iapi.addToEnv('colorRange', iapi.getChildren('colorRange')[0]);
    } else {
      // If colorRange is not present delete colorRange from env
      iapi.deleteFromEnv('colorRange');
    }
  };

  _proto._spaceManager = function _spaceManager() {
    var iapi = this,
        availableWidth,
        availableHeight,
        config = iapi.config,
        dataSet = iapi.getChildren('dataset')[0],
        scale = iapi.getFromEnv('scale'),
        axisConfig = scale.config,
        dataObject = dataSet.components.data[0],
        chart = iapi,
        jsonData = chart.getFromEnv('dataSource'),
        chartAttrs = jsonData.chart,
        datasetConfig = dataSet.config,
        scaleFactor = datasetConfig.scaleFactor,
        yPosExtra = 0,
        yNegExtra = 0,
        radius = 0,
        centerX = 0,
        centerY = 0,
        compositPivotRadius = datasetConfig.pivotRadius,
        displayValueLineHeight = config.dataLabels.style.lineHeight,
        displayValueCount = config.displayValueCount,
        chartBorderWidth = config.borderWidth,
        minChartWidth = config.minChartWidth,
        minChartHeight = config.minChartHeight,
        radiusDeduce = 0,
        gaugeSpacingObj,
        innerRadiusFactor,
        pivotRadius,
        axisSpace,
        chartBorderHorizontal,
        chartBorderVertical; //* ***** Manage space

    if (config.canvasWidth - 2 * chartBorderWidth < minChartWidth) {
      chartBorderVertical = (config.canvasWidth - minChartWidth) / 2;
    }

    if (config.canvasHeight - 2 * chartBorderWidth < minChartHeight) {
      chartBorderHorizontal = (config.canvasHeight - minChartHeight) / 2;
    }

    iapi._allocateSpace({
      top: chartBorderHorizontal || chartBorderWidth,
      bottom: chartBorderHorizontal || chartBorderWidth,
      left: chartBorderVertical || chartBorderWidth,
      right: chartBorderVertical || chartBorderWidth
    }); // availableHeight = config.canvasHeight * 0.225;
    // iapi._allocateSpace(iapi._manageCaptionSpacing(availableHeight));


    if (config.autoScale) {
      config.scaleFactor = scaleFactor = AngularGauge._getScaleFactor(datasetConfig.origW, datasetConfig.origH, config.width, config.height);
    } else {
      config.scaleFactor = scaleFactor = 1;
    }

    displayValueLineHeight = displayValueLineHeight.replace(/px/i, BLANK);

    if (/^\d+\%$/.test(datasetConfig.gaugeinnerradius)) {
      innerRadiusFactor = parseInt(datasetConfig.gaugeinnerradius, 10) / 100;
    } else {
      innerRadiusFactor = 0.7;
    }

    pivotRadius = compositPivotRadius = (0, _lib.pluckNumber)((0, _lib.getValidValue)(chartAttrs.pivotradius) * scaleFactor, 5);
    datasetConfig.pivotRadius = pivotRadius;
    compositPivotRadius = Math.max(compositPivotRadius, datasetConfig.rearExtension * scaleFactor);

    if (dataObject && dataObject.config && dataObject.config.rearextension) {
      compositPivotRadius = Math.max(compositPivotRadius, dataObject.config.rearextension * scaleFactor);
    }

    datasetConfig.compositPivotRadius = compositPivotRadius;
    yPosExtra = displayValueCount * displayValueLineHeight + 2 + pivotRadius;

    if (!datasetConfig.valueBelowPivot) {
      yNegExtra = yPosExtra;
      yPosExtra = 0;
    }

    datasetConfig.gaugeOuterRadius = (0, _lib.pluckNumber)(Math.abs((0, _lib.getValidValue)(chartAttrs.gaugeouterradius) * scaleFactor)); // Asume gauge inner radius to be a default of 70% of gauge outer radius

    datasetConfig.gaugeInnerRadius = (0, _lib.pluckNumber)(Math.abs((0, _lib.getValidValue)(chartAttrs.gaugeinnerradius) * scaleFactor), datasetConfig.gaugeOuterRadius * innerRadiusFactor);
    availableWidth = config.canvasWidth * 0.7;
    availableHeight = config.canvasHeight * 0.7; // Polar axis's labels placement is affected only by the width of the chart and not its height

    axisSpace = scale.placeAxis(availableWidth);
    availableHeight = config.canvasHeight * 0.7;

    iapi._manageChartMenuBar(availableHeight);

    gaugeSpacingObj = AngularGauge._angularGaugeSpaceManager(datasetConfig.gaugeStartAngle, datasetConfig.gaugeEndAngle, config.canvasWidth, config.canvasHeight, datasetConfig.gaugeOuterRadius, (0, _lib.pluckNumber)((0, _lib.getValidValue)(chartAttrs.gaugeoriginx) * scaleFactor - config.canvasLeft), (0, _lib.pluckNumber)((0, _lib.getValidValue)(chartAttrs.gaugeoriginy) * scaleFactor - config.canvasTop), compositPivotRadius + axisConfig.polarPadding, yPosExtra, yNegExtra);
    radius = gaugeSpacingObj.radius = (0, _lib.pluckNumber)(gaugeSpacingObj.radius, gaugeSpacingObj.maxRadius);
    datasetConfig.gaugeOriginX = gaugeSpacingObj.centerX + config.canvasLeft;
    datasetConfig.gaugeOriginY = gaugeSpacingObj.centerY + config.canvasTop;
    centerX = gaugeSpacingObj.centerX;
    centerY = gaugeSpacingObj.centerY;
    /*
      When axis space on left is less than axis space on top then check
      if distance between center and axis space is greater than distance
      between radius and axis space left, then the radius must be deduced by
      axis space left else it must be deduced by axis space top.
    */

    if (axisSpace.left < axisSpace.top) {
      if (centerX - axisSpace.left >= radius - axisSpace.left && centerY - axisSpace.top >= radius - axisSpace.left) {
        radiusDeduce = axisSpace.left;
      } else {
        radiusDeduce = axisSpace.top;
      }
      /*
        When axis space on left is greater or equal to axis space on top then check
        if distance between center and axis space is greater than distance between
        radius and axis space top, then radius must be deduced by axis space top else
        it must be deduced by axis space left.
       */

    } else {
      if (centerX - axisSpace.left >= radius - axisSpace.top && centerY - axisSpace.top >= radius - axisSpace.top) {
        radiusDeduce = axisSpace.top;
      } else {
        radiusDeduce = axisSpace.left;
      }
    }

    radiusDeduce += 2 * scale.config.polarPadding; // reduce the outer radius

    !datasetConfig.gaugeOuterRadius && (datasetConfig.gaugeOuterRadius = gaugeSpacingObj.radius - radiusDeduce);

    if (datasetConfig.gaugeInnerRadius === UNDEF) {
      datasetConfig.gaugeInnerRadius = datasetConfig.gaugeOuterRadius * innerRadiusFactor;
    }

    scale.setAxisConfig({
      centerX: datasetConfig.gaugeOriginX,
      centerY: datasetConfig.gaugeOriginY,
      radius: gaugeSpacingObj.radius || datasetConfig.gaugeOuterRadius,
      gaugeOuterRadius: datasetConfig.gaugeOuterRadius,
      gaugeInnerRadius: datasetConfig.gaugeInnerRadius,
      scaleFactor: scaleFactor
    });
  }
  /**
   * Parses and stores macro values during post space management
   *
   * @memberof AngularGauge
   */
  ;

  _proto.allocatePosition = function allocatePosition() {
    var iapi = this,
        config = iapi.config,
        datasetConfig = iapi.getChildren('dataset')[0].config; // For annotations

    config.gaugeStartX = config.canvasLeft;
    config.gaugeStartY = config.canvasTop;
    config.gaugeEndX = config.canvasRight;
    config.gaugeEndY = config.canvasBottom;
    config.gaugeCenterX = datasetConfig.gaugeOriginX;
    config.gaugeCenterY = datasetConfig.gaugeOriginY;
    config.gaugeStartAngle = datasetConfig.gaugeStartAngle / deg2rad;
    config.gaugeEndAngle = datasetConfig.gaugeEndAngle / deg2rad;
  };

  _proto._feedAxesRawData = function _feedAxesRawData() {
    var iapi = this,
        colorM = iapi.getFromEnv('color-manager'),
        dataObj = iapi.getFromEnv('dataSource'),
        chartAttrs = dataObj.chart,
        scaleConf,
        numberFormatter = iapi.getFromEnv('number-formatter'),
        palleteString = _lib.chartPaletteStr.chart2D,
        isAxisOpposite = (0, _lib.pluckNumber)(chartAttrs.axisontop, chartAttrs.axisonleft, chartAttrs.ticksbelowgauge !== UNDEF ? !chartAttrs.ticksbelowgauge : UNDEF, iapi.isAxisOpposite),
        isAxisReverse = (0, _lib.pluckNumber)(chartAttrs.reverseaxis, iapi.isAxisReverse),
        outCanfontSizeWithUnit = (0, _lib.pluckFontSizeMaintainUnit)(chartAttrs.outcnvbasefontsize, chartAttrs.basefontsize, 10);
    scaleConf = {
      isVertical: !iapi.isHorizontal,
      isReverse: isAxisReverse,
      isOpposit: isAxisOpposite,
      outCanfontFamily: (0, _lib.pluck)(chartAttrs.outcnvbasefont, chartAttrs.basefont, 'Verdana,sans'),
      outCanfontSize: this.computeFontSize(outCanfontSizeWithUnit),
      outCanfontSizeWithUnit: outCanfontSizeWithUnit,
      outCancolor: (0, _lib.pluck)(chartAttrs.outcnvbasefontcolor, chartAttrs.basefontcolor, colorM.getColor(palleteString.baseFontColor)).replace(/^#?([a-f0-9]+)/ig, '#$1'),
      useEllipsesWhenOverflow: chartAttrs.useellipseswhenoverflow,
      divLineColor: (0, _lib.pluck)(chartAttrs.vdivlinecolor, colorM.getColor(palleteString.divLineColor)),
      divLineAlpha: (0, _lib.pluck)(chartAttrs.vdivlinealpha, colorM.getColor('divLineAlpha')),
      divLineThickness: (0, _lib.pluckNumber)(chartAttrs.vdivlinethickness, 1),
      divLineIsDashed: Boolean((0, _lib.pluckNumber)(chartAttrs.vdivlinedashed, chartAttrs.vdivlineisdashed, 0)),
      divLineDashLen: (0, _lib.pluckNumber)(chartAttrs.vdivlinedashlen, 4),
      divLineDashGap: (0, _lib.pluckNumber)(chartAttrs.vdivlinedashgap, 2),
      showAlternateGridColor: (0, _lib.pluckNumber)(chartAttrs.showalternatevgridcolor, 0),
      alternateGridColor: (0, _lib.pluck)(chartAttrs.alternatevgridcolor, colorM.getColor('altVGridColor')),
      alternateGridAlpha: (0, _lib.pluck)(chartAttrs.alternatevgridalpha, colorM.getColor('altVGridAlpha')),
      numDivLines: chartAttrs.numvdivlines,
      labelFont: chartAttrs.labelfont,
      labelFontSize: this.computeFontSize(chartAttrs.labelfontsize),
      labelFontSizeWithUnit: chartAttrs.labelfontsize,
      labelFontColor: chartAttrs.labelfontcolor,
      labelAlpha: chartAttrs.labelalpha,
      labelFontBold: chartAttrs.labelfontbold,
      labelFontItalic: chartAttrs.labelfontitalic,
      axisName: chartAttrs.xaxisname,
      axisMinValue: numberFormatter.getCleanValue(chartAttrs.lowerlimit),
      axisMaxValue: numberFormatter.getCleanValue(chartAttrs.upperlimit),
      setAdaptiveMin: chartAttrs.setadaptivemin,
      // adjusttm will be internally parsed as adjustdiv
      adjustDiv: chartAttrs.adjusttm,
      labelDisplay: chartAttrs.labeldisplay,
      showLabels: chartAttrs.showlabels,
      rotateLabels: chartAttrs.rotatelabels,
      slantLabel: (0, _lib.pluckNumber)(chartAttrs.slantlabels, chartAttrs.slantlabel),
      labelStep: (0, _lib.pluckNumber)(chartAttrs.labelstep, chartAttrs.xaxisvaluesstep),
      showAxisValues: (0, _lib.pluckNumber)(chartAttrs.showxaxisvalues, chartAttrs.showxaxisvalue),
      showDivLineValues: (0, _lib.pluckNumber)(chartAttrs.showvdivlinevalues, chartAttrs.showvdivlinevalues),
      showZeroPlane: chartAttrs.showvzeroplane,
      zeroPlaneColor: chartAttrs.vzeroplanecolor,
      zeroPlaneThickness: chartAttrs.vzeroplanethickness,
      zeroPlaneAlpha: chartAttrs.vzeroplanealpha,
      showZeroPlaneValue: chartAttrs.showvzeroplanevalue,
      trendlineColor: chartAttrs.trendlinecolor,
      trendlineToolText: chartAttrs.trendlinetooltext,
      trendlineThickness: chartAttrs.trendlinethickness,
      trendlineAlpha: chartAttrs.trendlinealpha,
      showTrendlinesOnTop: chartAttrs.showtrendlinesontop,
      showAxisLine: (0, _lib.pluckNumber)(chartAttrs.showxaxisline, chartAttrs.showaxislines, chartAttrs.drawAxisLines, 0),
      axisLineThickness: (0, _lib.pluckNumber)(chartAttrs.xaxislinethickness, chartAttrs.axislinethickness, 1),
      axisLineAlpha: (0, _lib.pluckNumber)(chartAttrs.xaxislinealpha, chartAttrs.axislinealpha, 100),
      axisLineColor: (0, _lib.pluck)(chartAttrs.xaxislinecolor, chartAttrs.axislinecolor, '#000000'),
      // Tick properties
      majorTMNumber: chartAttrs.majortmnumber,
      majorTMColor: chartAttrs.majortmcolor,
      majorTMAlpha: chartAttrs.majortmalpha,
      majorTMHeight: chartAttrs.majortmheight,
      tickValueStep: chartAttrs.tickvaluestep,
      showTickMarks: chartAttrs.showtickmarks,
      connectTickMarks: chartAttrs.connecttickmarks,
      showTickValues: chartAttrs.showtickvalues,
      majorTMThickness: chartAttrs.majortmthickness,
      reverseScale: chartAttrs.reversescale,
      // Whether to display the Limits
      showLimits: chartAttrs.showlimits,
      minorTMNumber: chartAttrs.minortmnumber,
      minorTMColor: chartAttrs.minortmcolor,
      minorTMAlpha: chartAttrs.minortmalpha,
      minorTMHeight: (0, _lib.pluckNumber)(chartAttrs.minortmheight, chartAttrs.minortmwidth),
      minorTMThickness: chartAttrs.minortmthickness,
      // Padding between tick mark start position and gauge
      tickMarkDistance: (0, _lib.pluckNumber)(chartAttrs.tickmarkdistance, chartAttrs.tickmarkgap),
      // Tick value distance
      tickValueDistance: (0, _lib.pluckNumber)(chartAttrs.tickvaluedistance, chartAttrs.displayvaluedistance),
      placeTicksInside: chartAttrs.placeticksinside,
      placeValuesInside: chartAttrs.placevaluesinside,
      upperLimitDisplay: chartAttrs.upperlimitdisplay,
      lowerLimitDisplay: chartAttrs.lowerlimitdisplay,
      ticksBelowGauge: chartAttrs.ticksbelowgauge,
      ticksBelowGraph: chartAttrs.ticksbelowgraph,
      trendValueDistance: chartAttrs.trendvaluedistance
    };
    scaleConf.trendPoints = dataObj.trendpoints;
    return [scaleConf];
  };

  AngularGauge._angularGaugeSpaceManager = function _angularGaugeSpaceManager(startAngle, endAngle, canvasW, canvasH, radius, _centerX, _centerY, compositPivotRadius, yPostionExtra, yNegativeExtra) {
    if (compositPivotRadius === void 0) {
      compositPivotRadius = 0;
    }

    var rediusDefined = defined(radius),
        centerX = _centerX,
        centerY = _centerY,
        centerXDefined = defined(centerX),
        centerYDefined = defined(centerY),
        PI2 = Math.PI * 2,
        PI = Math.PI,
        PIby2 = Math.PI / 2,
        PI3by2 = PI + PIby2,
        calculatedRadus,
        returnObj = {
      radius: radius,
      centerX: centerX,
      centerY: centerY
    },
        yPosExtra = yPostionExtra,
        yNegExtra = yNegativeExtra,
        leftX,
        topY,
        rightX,
        bottomY,
        pivotCalRequard = false,
        startX,
        startY,
        endX,
        endY,
        tempRadius,
        resultantEnd,
        range,
        positiveLength,
        negativeLength,
        scale,
        startAbs = startAngle % PI2;

    if (startAbs < 0) {
      startAbs += PI2;
    }

    if (compositPivotRadius && compositPivotRadius < canvasW / 2 && compositPivotRadius < canvasH / 2) {
      pivotCalRequard = true;
    }

    if (yPosExtra > canvasH / 2) {
      // max half height will be setteled
      yPosExtra = canvasH / 2;
    }

    if (yNegExtra > canvasH / 2) {
      // max half height will be setteled
      yNegExtra = canvasH / 2;
    }

    startX = Math.cos(startAngle);
    startY = Math.sin(startAngle);
    endX = Math.cos(endAngle);
    endY = Math.sin(endAngle);
    leftX = mathMin(startX, endX, 0);
    rightX = Math.max(startX, endX, 0);
    topY = mathMin(startY, endY, 0);
    bottomY = Math.max(startY, endY, 0);

    if (!rediusDefined || !centerXDefined || !centerYDefined) {
      scale = endAngle - startAngle;
      resultantEnd = startAbs + scale;

      if (resultantEnd > PI2 || resultantEnd < 0) {
        rightX = 1;
      }

      if (scale > 0) {
        if (startAbs < PIby2 && resultantEnd > PIby2 || resultantEnd > PI2 + PIby2) {
          bottomY = 1;
        }

        if (startAbs < PI && resultantEnd > PI || resultantEnd > PI2 + PI) {
          leftX = -1;
        }

        if (startAbs < PI3by2 && resultantEnd > PI3by2 || resultantEnd > PI2 + PI3by2) {
          topY = -1;
        }
      } else {
        if (startAbs > PIby2 && resultantEnd < PIby2 || resultantEnd < -PI3by2) {
          bottomY = 1;
        }

        if (startAbs > PI && resultantEnd < PI || resultantEnd < -PI) {
          leftX = -1;
        }

        if (startAbs > PI3by2 && resultantEnd < PI3by2 || resultantEnd < -PIby2) {
          topY = -1;
        }
      } // now decide the x, y and radius


      if (!centerXDefined) {
        range = rightX - leftX;
        tempRadius = canvasW / range;
        centerX = -tempRadius * leftX;
        calculatedRadus = tempRadius;

        if (pivotCalRequard) {
          if (canvasW - centerX < compositPivotRadius) {
            centerX = canvasW - compositPivotRadius;
            positiveLength = canvasW - centerX;
            negativeLength = -centerX;
            calculatedRadus = leftX ? mathMin(positiveLength / rightX, negativeLength / leftX) : positiveLength / rightX;
          } else if (centerX < compositPivotRadius) {
            centerX = compositPivotRadius;
            positiveLength = canvasW - centerX;
            negativeLength = -centerX;
            calculatedRadus = leftX ? mathMin(positiveLength / rightX, negativeLength / leftX) : positiveLength / rightX;
          }
        }

        returnObj.centerX = centerX;
      } else if (!rediusDefined) {
        positiveLength = canvasW - centerX;
        negativeLength = -centerX;
        calculatedRadus = leftX ? mathMin(positiveLength / rightX, negativeLength / leftX) : positiveLength / rightX;
      }

      if (!centerYDefined) {
        range = bottomY - topY;
        tempRadius = canvasH / range;
        centerY = -tempRadius * topY;

        if (pivotCalRequard) {
          if (canvasH - centerY < compositPivotRadius) {
            centerY = canvasH - compositPivotRadius;
            positiveLength = canvasH - centerY;
            negativeLength = -centerY;
            calculatedRadus = mathMin(calculatedRadus, topY ? mathMin(positiveLength / bottomY, negativeLength / topY) : positiveLength / bottomY);
          } else if (centerY < compositPivotRadius) {
            centerY = compositPivotRadius;
            positiveLength = canvasH - centerY;
            negativeLength = -centerY;
            calculatedRadus = mathMin(calculatedRadus, topY ? mathMin(positiveLength / bottomY, negativeLength / topY) : positiveLength / bottomY);
          }
        } // yAxisExtra


        if (canvasH - centerY < yPosExtra) {
          centerY = canvasH - yPosExtra;
          positiveLength = canvasH - centerY;
          negativeLength = -centerY;
          calculatedRadus = mathMin(calculatedRadus, topY ? mathMin(positiveLength / bottomY, negativeLength / topY) : positiveLength / bottomY);
        } else if (centerY < yNegExtra) {
          centerY = yNegExtra;
          positiveLength = canvasH - centerY;
          negativeLength = -centerY;
          calculatedRadus = mathMin(calculatedRadus, topY ? mathMin(positiveLength / bottomY, negativeLength / topY) : positiveLength / bottomY);
        }

        calculatedRadus = mathMin(calculatedRadus, tempRadius);
        returnObj.centerY = centerY;
      } else if (!rediusDefined) {
        positiveLength = canvasH - centerY;
        negativeLength = -centerY;
        calculatedRadus = mathMin(calculatedRadus, topY ? mathMin(positiveLength / bottomY, negativeLength / topY) : positiveLength / bottomY);
      }

      returnObj.maxRadius = calculatedRadus;

      if (returnObj.maxRadius <= 0) {
        returnObj.maxRadius = mathMin(canvasW / 2, canvasH / 2);
      }
    }

    return returnObj;
  };

  AngularGauge._getScaleFactor = function _getScaleFactor(_origW, _origH, canvasWidth, canvasHeight) {
    var scaleFactor,
        origH = (0, _lib.pluckNumber)(_origH, canvasHeight),
        origW = (0, _lib.pluckNumber)(_origW, canvasWidth);

    if (!origH || !origW) {
      scaleFactor = 1;
    } else if (origW / canvasWidth === origH / canvasHeight) {
      // Now, if the ratio of original width,height & stage width,height are same
      // In this case, the transformation value would be the same, as the ratio
      // of transformation of width and height is same.
      scaleFactor = canvasWidth / origW;
    } else {
      // If the transformation factors are different, we do a constrained scaling
      // We get the aspect whose delta is on the lower side.
      scaleFactor = mathMin(canvasWidth / origW, canvasHeight / origH);
    }

    return scaleFactor;
  };

  _proto._getData = function _getData(index, callback) {
    return _angularHlinearCommon._getData.call(this, index, callback);
  };

  _proto._setData = function _setData(dialIndex, value) {
    _angularHlinearCommon._setData.call(this, dialIndex, value);
  };

  _proto._getDataForId = function _getDataForId(id, callback) {
    return _angularHlinearCommon._getDataForId.call(this, id, callback);
  };

  _proto._setDataForId = function _setDataForId(id, value) {
    _angularHlinearCommon._setDataForId.call(this, id, value);
  };

  return AngularGauge;
}(_gauge.default);

var _default = AngularGauge;
exports["default"] = _default;

/***/ }),

/***/ 1478:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _gaugewidget = _interopRequireDefault(__webpack_require__(1479));

var _bulb = _interopRequireDefault(__webpack_require__(1482));

var _lib = __webpack_require__(274);

var _colorBucket = _interopRequireDefault(__webpack_require__(1446));

var _vledDataset = _interopRequireDefault(__webpack_require__(1484));

var UNDEF,
    BULB = 'bulb',
    FRIENDLY_NAME = 'Bulb Gauge';

var Bulb = /*#__PURE__*/function (_GaugeWidget) {
  (0, _inheritsLoose2.default)(Bulb, _GaugeWidget);

  /**
   * Provides the name of the chart extension
   *
   * @static
   * @return {string} The name of the chart extension
   */
  Bulb.getName = function getName() {
    return 'Bulb';
  };

  function Bulb() {
    var _this;

    _this = _GaugeWidget.call(this) || this;
    _this.isRealTime = true;

    _this._drawCanvas = function () {// Blank fn to Override it's parent method
    };

    _this.registerFactory('dataset', _vledDataset.default, ['vCanvas']);

    return _this;
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */


  var _proto = Bulb.prototype;

  _proto.getName = function getName() {
    return 'Bulb';
  } // eslint-disable-next-line
  ;

  _proto._clearChart = function _clearChart() {// not applicable for gauges
  }
  /**
   * Configures the colorRange provided as json data
   *
   * @param {any} dataObj - dataObj
   * @memberof Bulb
   */
  ;

  _proto.configureAttributes = function configureAttributes(dataObj) {
    _GaugeWidget.prototype.configureAttributes.call(this, dataObj);

    var iapi = this,
        jsonData = iapi.getFromEnv('dataSource'),
        colorrange = jsonData.colorrange; // componentFactory(iapi, ColorGradient, 'colorRange', 1, [colorrange]);

    (0, _lib.componentFactory)(iapi, _colorBucket.default, 'colorRange', 1, [{
      colorRange: colorrange,
      numberFormatter: iapi.getFromEnv('number-formatter')
    }]);
    iapi.addToEnv('colorRange', iapi.getChildren('colorRange')[0]);
  };

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    _GaugeWidget.prototype.__setDefaultConfig.call(this);

    var config = this.config;
    config.showRTvalue = false;
    config.canvasPadding = false;
    config.defaultSeriesType = BULB;
    config.defaultPlotShadow = 1;
    config.drawAnnotations = true;
    config.charttopmargin = 10;
    config.chartrightmargin = 10;
    config.chartbottommargin = 10;
    config.chartleftmargin = 10;
    config.realtimeEnabled = true;
    config.isRealTime = true;
    config.friendlyName = FRIENDLY_NAME;
    config.defaultDatasetType = BULB;
    config.placevaluesinside = 0;
    config.hasgaugeoriginx = UNDEF;
    config.gaugeoriginx = UNDEF;
    config.hasgaugeoriginy = UNDEF;
    config.gaugeoriginy = UNDEF;
    config.hasgaugeradius = UNDEF;
    config.gaugeradius = UNDEF;
    config.valuepadding = 2;
    config.showgaugeborder = 0;
    config.showhovereffect = UNDEF;
    config.autoscale = 1;
    config.skipCanvasDrawing = true;
  };

  _proto._spaceManager = function _spaceManager() {
    // todo marge _allocateSpace and _spacemanager
    var availableHeight,
        iapi = this,
        config = iapi.config,
        dataset = iapi.getChildren('dataset')[0],
        datasetConfig = dataset.config,
        is3D = iapi.config.is3D,
        chartAttrs = iapi.getFromEnv('dataSource').chart,
        showBorder = (0, _lib.pluckNumber)(chartAttrs.showborder, is3D ? 0 : 1),
        chartBorderHorizontal,
        chartBorderVertical,
        minChartWidth = config.minChartWidth,
        minChartHeight = config.minChartHeight,
        chartBorderWidth = config.borderWidth = showBorder ? (0, _lib.pluckNumber)(chartAttrs.borderthickness, 1) : 0;

    if (config.autoscale) {
      datasetConfig.scaleFactor = Bulb._getScaleFactor(datasetConfig.origW, datasetConfig.origH, config.width, config.height);
    } else {
      datasetConfig.scaleFactor = 1;
    }

    if (config.canvasWidth - 2 * chartBorderWidth < minChartWidth) {
      chartBorderVertical = (config.canvasWidth - minChartWidth) / 2;
    }

    if (config.canvasHeight - 2 * chartBorderWidth < minChartHeight) {
      chartBorderHorizontal = (config.canvasHeight - minChartHeight) / 2;
    }

    iapi._allocateSpace({
      top: chartBorderHorizontal || chartBorderWidth,
      bottom: chartBorderHorizontal || chartBorderWidth,
      left: chartBorderVertical || chartBorderWidth,
      right: chartBorderVertical || chartBorderWidth
    });

    iapi._allocateSpace(iapi._manageActionBarSpace && iapi._manageActionBarSpace(config.availableHeight * 0.225) || {}); //* ***** Manage space


    availableHeight = config.canvasHeight * 0.7; // (hasLegend !== false) &&
    //           iapi._allocateSpace(legend._manageLegendPosition(availableHeight));
    // a space manager that manages the space for the tools as well as the captions.

    iapi._manageChartMenuBar(availableHeight);

    dataset._manageSpace && iapi._allocateSpace(dataset._manageSpace(availableHeight));
  };

  _proto.allocatePosition = function allocatePosition() {
    var iapi = this,
        chartConfig = iapi.config,
        dataset = iapi.getDatasets()[0],
        conf = dataset.config,
        radius,
        canvasHeight = chartConfig.canvasHeight,
        canvasWidth = chartConfig.canvasWidth,
        canvasTop = chartConfig.canvasTop,
        canvasLeft = chartConfig.canvasLeft,
        gaugeOriginX = chartConfig.gaugeoriginx,
        gaugeOriginY = chartConfig.gaugeoriginy,
        gaugeRadius = chartConfig.gaugeradius,
        hasGaugeOriginX = chartConfig.hasgaugeoriginx,
        hasGaugeOriginY = chartConfig.hasgaugeoriginy,
        hasGaugeRadius = chartConfig.hasgaugeradius;
    gaugeOriginX = hasGaugeOriginX !== UNDEF ? gaugeOriginX * conf.scaleFactor : canvasLeft + canvasWidth / 2;
    gaugeOriginY = hasGaugeOriginY !== UNDEF ? gaugeOriginY * conf.scaleFactor : canvasTop + canvasHeight / 2;
    radius = hasGaugeRadius !== UNDEF ? gaugeRadius * conf.scaleFactor : Math.min(canvasWidth / 2, canvasHeight / 2); // Setting macros for annotation

    chartConfig.gaugeStartX = gaugeOriginX - radius;
    chartConfig.gaugeEndX = gaugeOriginX + radius;
    chartConfig.gaugeStartY = gaugeOriginY - radius;
    chartConfig.gaugeEndY = gaugeOriginY + radius;
    chartConfig.gaugeCenterX = gaugeOriginX;
    chartConfig.gaugeCenterY = gaugeOriginY;
    chartConfig.gaugeRadius = radius;
  };

  _proto._getData = function _getData() {
    var iapi = this,
        dataset = iapi.getChildren('dataset'),
        data,
        dataObj;

    if (dataset) {
      dataObj = dataset[0].components.data;

      if (dataObj && dataObj[0]) {
        data = dataObj[0].config;
        return (0, _lib.pluckNumber)(data.setValue, data.itemValue);
      }
    }
  }
  /**
   * function to calculate post space management calculations
   * calculations like axis dimenetion set, allocate space for xaxis labels,
   * canvas padding etc.
   */
  // eslint-disable-next-line
  ;

  _proto._postSpaceManagement = function _postSpaceManagement() {
    // overwrite this method and do nothing
    this.allocateDimensionOfChartMenuBar();
  };

  _proto.getDSdef = function getDSdef() {
    return _bulb.default;
  };

  Bulb._getScaleFactor = function _getScaleFactor(_origW, _origH, canvasWidth, canvasHeight) {
    var scaleFactor,
        origH = _origH,
        origW = _origW;
    origH = (0, _lib.pluckNumber)(origH, canvasHeight);
    origW = (0, _lib.pluckNumber)(origW, canvasWidth);

    if (!origH || !origW) {
      scaleFactor = 1;
    } else if (origW / canvasWidth === origH / canvasHeight) {
      // Now, if the ratio of original width,height & stage width,height are same
      // In this case, the transformation value would be the same, as the ratio
      // of transformation of width and height is same.
      scaleFactor = canvasWidth / origW;
    } else {
      // If the transformation factors are different, we do a constrained scaling
      // We get the aspect whose delta is on the lower side.
      scaleFactor = Math.min(canvasWidth / origW, canvasHeight / origH);
    }

    return scaleFactor;
  };

  return Bulb;
}(_gaugewidget.default);

var _default = Bulb;
exports["default"] = _default;

/***/ }),

/***/ 1486:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _lib = __webpack_require__(274);

var _lineargauge = _interopRequireDefault(__webpack_require__(1487));

var _cylinder = _interopRequireDefault(__webpack_require__(1493));

var _vledDataset = _interopRequireDefault(__webpack_require__(1484));

/* eslint require-jsdoc: 'error', valid-jsdoc: ["error", { "requireReturn": false }] */
var colorStrings = _lib.preDefStr.colors,
    COLOR_FFFFFF = colorStrings.FFFFFF,
    gaugeFillColorStr = _lib.preDefStr.gaugeFillColorStr,
    gaugeBorderColorStr = _lib.preDefStr.gaugeBorderColorStr,
    UNDEFINED,
    defined = function defined(obj) {
  return obj !== UNDEFINED && obj !== null;
},
    DS_TYPE = 'cylinder',
    RIGHT = 'right',
    LEFT = 'left';
/**
 * Class for cylinder chart
 * @class Cylinder
 * @extends {Thermometer}
 */


var Cylinder = /*#__PURE__*/function (_LinearGauge) {
  (0, _inheritsLoose2.default)(Cylinder, _LinearGauge);

  /**
   * Provides the name of the chart extension
   *
   * @static
   * @return {string} The name of the chart extension
   */
  Cylinder.getName = function getName() {
    return 'Cylinder';
  }
  /**
   * Creates an instance of Cylinder.
   * @memberof Cylinder
   */
  ;

  function Cylinder() {
    var _this;

    _this = _LinearGauge.call(this) || this;
    _this.defaultPaletteOptions = (0, _lib.extend2)((0, _lib.extend2)({}, _lib.defaultGaugePaletteOptions), {
      gaugeBorderColor: ['545454', '60634E', '415D6F', '845001', '68001B'],
      gaugeFillColor: ['CCCCCC', 'ADB68F', 'E1F5FF', 'FDB548', 'FF7CA0'],
      periodColor: ['EEEEEE', 'ECEEE6', 'E6ECF0', 'FFF4E6', 'FFF2F5']
    }, false, true);
    _this.glasscolor = COLOR_FFFFFF;
    _this.showRTvalue = false;
    _this.canvasPadding = false;
    _this.isHorizontal = false;
    _this.config.isAxisOpposite = true;
    _this.config.scalePosition = RIGHT;
    _this.config.canBeScalePosition = LEFT;
    _this.hasCanvas = true;
    _this.drawPlotlines = false;
    _this.drawPlotBands = false;
    _this.isAxisReverse = false;
    _this.isRealTime = true;

    _this.registerFactory('dataset', _vledDataset.default, ['vCanvas']);

    return _this;
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */


  var _proto = Cylinder.prototype;

  _proto.getName = function getName() {
    return 'Cylinder';
  }
  /**
   * Sets default configuration
   * @memberof Cylinder
   */
  ;

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    _LinearGauge.prototype.__setDefaultConfig.call(this);

    var config = this.config;
    config.alignCaptionWithCanvas = 1;
    config.defaultDatasetType = DS_TYPE;
    config.hasLegend = false;
    config.skipCanvasDrawing = true;
  }
  /**
   * To parse special configuration
   * @memberof Cylinder
   */
  ;

  _proto._parseSpecialConfig = function _parseSpecialConfig() {
    var iapi = this,
        chartConfig = iapi.config,
        dataObj = iapi.getFromEnv('dataSource'),
        chartOptions = dataObj.chart,
        numberFormatter = iapi.getFromEnv('number-formatter'),
        colorM = iapi.getFromEnv('color-manager'),
        gaugeBorderAlpha;
    chartConfig.use3DLighting = (0, _lib.pluckNumber)(chartOptions.use3dlighting, 1);
    chartConfig.gaugeOriginX = (0, _lib.pluckNumber)(chartOptions.thmoriginx, chartOptions.cyloriginx, chartOptions.gaugeoriginx);
    chartConfig.gaugeOriginY = (0, _lib.pluckNumber)(chartOptions.thmoriginy, chartOptions.cyloriginy, chartOptions.gaugeoriginy);
    chartConfig.gaugeRadius = (0, _lib.pluckNumber)(numberFormatter.getCleanValue((0, _lib.pluckNumber)(chartOptions.thmbulbradius, chartOptions.cylradius, chartOptions.gaugeradius), true));
    chartConfig.gaugeHeight = (0, _lib.pluckNumber)(numberFormatter.getCleanValue((0, _lib.pluckNumber)(chartOptions.thmheight, chartOptions.cylheight, chartOptions.gaugeheight), true));
    chartConfig.origW = (0, _lib.pluckNumber)(chartOptions.origw);
    chartConfig.origH = (0, _lib.pluckNumber)(chartOptions.origh); // set the falg whether the measurements are defined by user or not

    chartConfig.xDefined = defined(chartConfig.gaugeOriginX);
    chartConfig.yDefined = defined(chartConfig.gaugeOriginY);
    chartConfig.rDefined = defined(chartConfig.gaugeRadius);
    chartConfig.hDefined = defined(chartConfig.gaugeHeight);
    chartConfig.gaugeFillColor = (0, _lib.pluck)(chartOptions.gaugefillcolor, chartOptions.cylfillcolor, colorM.getColor(gaugeFillColorStr));
    chartConfig.gaugeFillAlpha = (0, _lib.pluckNumber)(chartOptions.gaugefillalpha, chartOptions.cylfillalpha, _lib.HUNDREDSTRING);
    chartConfig.gaugeYScale = (0, _lib.pluckNumber)(chartOptions.cylyscale, chartOptions.gaugeyscale, 30);

    if (chartConfig.gaugeYScale > 50 || chartConfig.gaugeYScale < 0) {
      chartConfig.gaugeYScale = 30;
    }

    chartConfig.gaugeYScale = chartConfig.gaugeYScale / 100; // Gauge Border properties

    chartConfig.showGaugeBorder = (0, _lib.pluckNumber)(chartOptions.showgaugeborder, 1);
    gaugeBorderAlpha = chartConfig.showGaugeBorder ? (0, _lib.pluckNumber)(chartOptions.gaugeborderalpha, 40) : 0; // We are using 40 for default alpha of cylender Gauge Border

    chartConfig.gaugeBorderColor = (0, _lib.convertColor)((0, _lib.pluck)(chartOptions.gaugebordercolor, colorM.getColor(gaugeBorderColorStr)), gaugeBorderAlpha);
    chartConfig.gaugeBorderThickness = (0, _lib.pluckNumber)(chartOptions.gaugeborderthickness, 1); // Thermometer Glass color

    chartConfig.gaugeContainerColor = (0, _lib.pluck)(chartOptions.cylglasscolor, (0, _lib.getLightColor)(chartConfig.gaugeFillColor, 30));
  }
  /**
   * Fucntion that returns dataset
   * @return {Object} dataset
   * @memberof Cylinder
   */
  ;

  _proto.getDSdef = function getDSdef() {
    return _cylinder.default;
  }
  /**
   * Method to fetch data
   * @return {Number} data value
   */
  ;

  _proto._getData = function _getData() {
    var iapi = this,
        dataset = iapi.getChildren('dataset');

    if (dataset && dataset[0]) {
      return dataset[0].config.value;
    }
  };

  return Cylinder;
}(_lineargauge.default);

var _default = Cylinder;
exports["default"] = _default;

/***/ }),

/***/ 1559:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _funnelpyramidbase = _interopRequireDefault(__webpack_require__(1560));

var _funnel = _interopRequireDefault(__webpack_require__(1561));

var _lib = __webpack_require__(274);

/* eslint require-jsdoc: 'error', valid-jsdoc: ["error", { "requireReturn": false }] */
var FRIENDLY_NAME = 'Funnel Chart',
    DS_TYPE = 'funnel';
/**
 * Class for Funnel chart
 * @class Funnel
 * @extends {FunnelPyramidBase}
 */

var Funnel = /*#__PURE__*/function (_FunnelPyramidBase) {
  (0, _inheritsLoose2.default)(Funnel, _FunnelPyramidBase);

  /**
   * Provides the name of the chart extension
   *
   * @static
   * @return {string} The name of the chart extension
   */
  Funnel.getName = function getName() {
    return 'Funnel';
  }
  /**
   * Creates an instance of Funnel.
   * @memberof Funnel
   */
  ;

  function Funnel() {
    var _this;

    _this = _FunnelPyramidBase.call(this) || this;
    _this.useSortedData = true;
    return _this;
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */


  var _proto = Funnel.prototype;

  _proto.getName = function getName() {
    return 'funnel';
  }
  /**
   * Sets default configuration
   * @memberof Funnel
   */
  ;

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    _FunnelPyramidBase.prototype.__setDefaultConfig.call(this);

    var config = this.config;
    config.friendlyName = FRIENDLY_NAME;
    config.defaultDatasetType = DS_TYPE;
    config.enablemousetracking = true;
  }
  /**
   * Configures Attributes of chart
   *
   * @memberof Funnel
   */
  ;

  _proto.configureAttributes = function configureAttributes() {
    _FunnelPyramidBase.prototype.configureAttributes.call(this);

    var chart = this,
        dataSource = chart.getFromEnv('dataSource'),
        streamLinedData = (0, _lib.pluckNumber)(dataSource.chart.streamlineddata, 1);
    chart.config.PLOT_COLOR_INDEX_START = streamLinedData ? -1 : 0;
    chart.config.alignLegendWithCanvas = 0;
  }
  /**
   * This method return the dataset definations for this chart
   * @return {Object} dataset
   * @memberof Funnel
   */
  ;

  _proto.getDSdef = function getDSdef() {
    return _funnel.default;
  };

  return Funnel;
}(_funnelpyramidbase.default);

var _default = Funnel;
exports["default"] = _default;

/***/ }),

/***/ 1555:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _lib = __webpack_require__(274);

var _lineargauge = _interopRequireDefault(__webpack_require__(1487));

var _bulletLedCommon = __webpack_require__(1511);

var _bullet = _interopRequireDefault(__webpack_require__(1513));

var _vledDataset = _interopRequireDefault(__webpack_require__(1484));

var _equal = _interopRequireDefault(__webpack_require__(421));

/* eslint require-jsdoc: 'error', valid-jsdoc: ["error", { "requireReturn": false }] */
var UNDEF,
    GUTTER_PADDING = 2,
    BLANKSTRING = _lib.BLANK,
    POSITION_START = _lib.preDefStr.POSITION_START,
    POSITION_END = _lib.preDefStr.POSITION_END,
    POSITION_BOTTOM = _lib.preDefStr.POSITION_BOTTOM,
    POSITION_MIDDLE = _lib.preDefStr.POSITION_MIDDLE,
    math = Math,
    mathCeil = math.ceil,
    mathMax = math.max,
    zeroCommaHundredStr = '0,100',
    HBULLET = 'hbullet',
    FRIENDLY_NAME = 'Horizontal Bullet Gauge',
    BULLET = 'bullet',
    TOP = 'top';
/**
 * Class for hbullet chart
 * @class Hbullet
 * @extends {Vbullet}
 */

var Hbullet = /*#__PURE__*/function (_LinearGauge) {
  (0, _inheritsLoose2.default)(Hbullet, _LinearGauge);

  /**
   * Provides the name of the chart extension
   *
   * @static
   * @return {string} The name of the chart extension
   */
  Hbullet.getName = function getName() {
    return 'Hbullet';
  }
  /**
   * Creates an instance of Hbullet.
   * @memberof Hbullet
   */
  ;

  function Hbullet() {
    var _this;

    _this = _LinearGauge.call(this) || this;
    _this.defaultSeriesType = HBULLET;
    _this.gaugeType = 1;
    _this.defaultCaptionPadding = 5;
    _this.rendererId = HBULLET;
    _this.isHorizontal = true;
    _this.config.isAxisOpposite = false;
    _this.config.scalePosition = POSITION_BOTTOM;
    _this.config.canBeScalePosition = TOP;
    _this.rtManageSpace = true;
    _this.ticksOnRight = 0;
    _this.hasCanvas = true;
    _this.isAxisReverse = false;
    _this.defaultPaletteOptions = {
      // Store colors now
      paletteColors: [['A6A6A6', 'CCCCCC', 'E1E1E1', 'F0F0F0'], ['A7AA95', 'C4C6B7', 'DEDFD7', 'F2F2EE'], ['04C2E3', '66E7FD', '9CEFFE', 'CEF8FF'], ['FA9101', 'FEB654', 'FED7A0', 'FFEDD5'], ['FF2B60', 'FF6C92', 'FFB9CB', 'FFE8EE']],
      // Store other colors
      // ------------- For 2D Chart ---------------//
      // We're storing 5 combinations, as we've 5 defined palettes.
      bgColor: ['FFFFFF', 'CFD4BE,F3F5DD', 'C5DADD,EDFBFE', 'A86402,FDC16D', 'FF7CA0,FFD1DD'],
      bgAngle: [270, 270, 270, 270, 270],
      bgRatio: [zeroCommaHundredStr, zeroCommaHundredStr, zeroCommaHundredStr, zeroCommaHundredStr, zeroCommaHundredStr],
      bgAlpha: ['100', '60,50', '40,20', '20,10', '30,30'],
      toolTipBgColor: ['FFFFFF', 'FFFFFF', 'FFFFFF', 'FFFFFF', 'FFFFFF'],
      toolTipBorderColor: ['545454', '545454', '415D6F', '845001', '68001B'],
      baseFontColor: ['333333', '60634E', '025B6A', 'A15E01', '68001B'],
      tickColor: ['333333', '60634E', '025B6A', 'A15E01', '68001B'],
      trendColor: ['545454', '60634E', '415D6F', '845001', '68001B'],
      plotFillColor: ['545454', '60634E', '415D6F', '845001', '68001B'],
      borderColor: ['767575', '545454', '415D6F', '845001', '68001B'],
      borderAlpha: [50, 50, 50, 50, 50]
    };
    _this.showRTvalue = false;
    _this.canvasPadding = false;
    _this.defaultPlotShadow = 1;
    _this.realtimeEnabled = true;
    _this.chartleftmargin = 15;
    _this.chartrightmargin = 15;
    _this.charttopmargin = 10;
    _this.chartbottommargin = 10;
    _this.showTooltip = 0;
    _this.connectTickMarks = 0;
    _this.drawPlotlines = false;
    _this.drawPlotBands = false;
    _this.isRealTime = true;
    _this.colorRange = true;

    _this.registerFactory('dataset', _vledDataset.default, ['vCanvas']);

    return _this;
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */


  var _proto = Hbullet.prototype;

  _proto.getName = function getName() {
    return 'Hbullet';
  }
  /**
   * Sets default configuration
   * @memberof Hbullet
   */
  ;

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    _LinearGauge.prototype.__setDefaultConfig.call(this);

    var config = this.config;
    config.friendlyName = FRIENDLY_NAME;
    config.defaultDatasetType = BULLET;
    config.singleseries = true;
    config.skipCanvasDrawing = true;
  }
  /**
   * Manage space during real time update
   * @memberof Hbullet
   */
  ;

  _proto._RTmanageSpace = function _RTmanageSpace() {
    var iapi = this,
        config = iapi.config,
        scale = iapi.getChildren('scale')[0],
        dataset = iapi.getChildren('dataset')[0],
        diff,
        currentLabelSpace;
    currentLabelSpace = dataset._manageSpaceHorizontal(config.oriCanvasWidth * 0.7);
    diff = currentLabelSpace.right - config.labelSpace.right;

    iapi._allocateSpace({
      right: diff
    });

    scale.setAxisDimention({
      axisLength: config.canvasWidth
    });
    config.labelSpace = currentLabelSpace;
  }
  /**
   * function to create component and configure and also configure the chart
   * It creates components which are depend on data and configure them and also configure chart
   * It calls helper function namely, configure
   * @param  {Object} dataObj contains json data of the chart
   */
  ;

  _proto.configureAttributes = function configureAttributes(dataObj) {
    _LinearGauge.prototype.configureAttributes.call(this, dataObj);

    _bulletLedCommon.configureAttributes.call(this);
  }
  /**
   * Method to fetch data
   * @return {Number} data value
   */
  ;

  _proto._getData = function _getData() {
    return _bulletLedCommon._getData.call(this);
  }
  /**
   * calculate and allote space for various components
   * every components are get notified with maximum space and then components return
   * the available space.
   * @memberof Hbullet
   */
  ;

  _proto._spaceManager = function _spaceManager() {
    var availableWidth,
        availableHeight,
        iapi = this,
        config = iapi.config,
        canvas = iapi.getChildren('canvas')[0],
        dataset = iapi.getChildren('dataset')[0],
        scale = iapi.getChildren('scale')[0],
        is3D = iapi.config.is3D,
        chartAttrs = iapi.getFromEnv('dataSource').chart,
        showBorder = (0, _lib.pluckNumber)(chartAttrs.showborder, is3D ? 0 : 1),
        captionSpace,
        chartBorderHorizontal,
        chartBorderVertical,
        minChartWidth = config.minChartWidth,
        minChartHeight = config.minChartHeight,
        chartBorderWidth = config.borderWidth = showBorder ? (0, _lib.pluckNumber)(chartAttrs.borderthickness, 1) : 0; //* ***** Manage space

    if (config.canvasWidth - 2 * chartBorderWidth < minChartWidth) {
      chartBorderVertical = (config.canvasWidth - minChartWidth) / 2;
    }

    if (config.canvasHeight - 2 * chartBorderWidth < minChartHeight) {
      chartBorderHorizontal = (config.canvasHeight - minChartHeight) / 2;
    }

    iapi._allocateSpace({
      top: chartBorderHorizontal || chartBorderWidth,
      bottom: chartBorderHorizontal || chartBorderWidth,
      left: chartBorderVertical || chartBorderWidth,
      right: chartBorderVertical || chartBorderWidth
    });

    availableWidth = config.canvasWidth * 0.7;

    iapi._allocateSpace(scale.placeAxis(config.availableHeight));

    iapi._allocateSpace(iapi._manageActionBarSpace && iapi._manageActionBarSpace(config.availableHeight * 0.225) || {});

    config.oriCanvasWidth = config.canvasWidth;
    availableHeight = config.canvasHeight * 0.225; // a space manager that manages the space for the tools as well as the captions.

    iapi._manageChartMenuBar(availableHeight); // get the space calculated by caption


    captionSpace = mathMax(iapi.getChildren('subCaption')[0].config.width || 0, iapi.getChildren('caption')[0].config.width || 0);
    config.labelSpace = dataset._manageSpaceHorizontal(availableWidth - captionSpace * 0.7);
    dataset._manageSpace && iapi._allocateSpace(config.labelSpace);
    config.oriCanvasWidth -= captionSpace;
    availableHeight = config.canvasHeight * 0.325;
    canvas.setDimension({
      top: config.canvasTop,
      left: config.canvasLeft,
      width: config.canvasWidth,
      height: config.canvasHeight
    });
  }
  /**
   * function to
   * @param  {number} availableHeight available hieght to alocate
   * @param  {number} availableWidth  available width to alocate
   * @return {Object} dimensions
   * @memberof Hbullet
   */
  ;

  _proto._manageCaptionSpacing = function _manageCaptionSpacing() {
    var iapi = this,
        chartConfig = iapi.config,
        caption = iapi.getChildren('caption')[0],
        subCaption = iapi.getChildren('subCaption')[0],
        captionConfig = caption.config,
        subCaptionConfig = subCaption.config,
        chartAttrs = iapi.getFromEnv('dataSource').chart,
        SmartLabel = iapi.getFromEnv('smartLabel'),
        titleText = (0, _lib.parseUnsafeString)(chartAttrs.caption),
        subTitleText = (0, _lib.parseUnsafeString)(chartAttrs.subcaption),
        captionPadding = (0, _lib.pluckNumber)(chartAttrs.captionpadding, 2),
        height = chartConfig.height,
        width = chartConfig.width,
        captionLineHeight = 0,
        subCaptionLineHeight = 0,
        captionHeight = 0,
        allowedHeight = height * 0.3,
        allowedWidth = width * 0.3,
        dimensions = {},
        maxCaptionWidth,
        captionObj,
        subCaptionObj,
        capStyle,
        subCapStyle; // text below 3px is not properly visible

    if (allowedHeight > 3) {
      captionConfig.captionPadding = subCaptionConfig.captionPadding = captionPadding;

      if (titleText !== BLANKSTRING) {
        // calculatethe single line's height
        capStyle = captionConfig.style;
        captionLineHeight = captionConfig.captionLineHeight = mathCeil(parseFloat((0, _lib.pluck)(capStyle.fontHeight, capStyle.lineHeight), 10), 12); // captionFontSize = subCaptionConfig.captionLineHeight =
        //     pluckNumber(parseInt(capStyle.fontSize, 10), 10);
      }

      if (subTitleText !== BLANKSTRING) {
        subCapStyle = subCaptionConfig.style;
        subCaptionLineHeight = mathCeil(parseInt((0, _lib.pluck)(subCapStyle.lineHeight, subCapStyle.fontHeight), 10), 12); // subCaptionFontSize = pluckNumber(parseInt(subCapStyle.fontSize, 10), 10);
      }

      if (captionLineHeight > 0 || subCaptionLineHeight > 0) {
        SmartLabel.useEllipsesOnOverflow(chartConfig.useEllipsesWhenOverflow);
        SmartLabel.setStyle(capStyle);
        captionObj = SmartLabel.getSmartText(titleText, allowedWidth, height); // Forcefully increase width to give a gutter in caption and sub-caption

        if (captionObj.width > 0) {
          captionObj.width += GUTTER_PADDING;
          captionHeight = captionObj.height;
        }

        SmartLabel.setStyle(subCapStyle);
        subCaptionObj = SmartLabel.getSmartText(subTitleText, allowedWidth, height - captionHeight); // Force fully increase width to give a gutter in caption and subCaption

        if (subCaptionObj.width > 0) {
          subCaptionObj.width += GUTTER_PADDING;
        }

        captionConfig.captionSubCaptionGap = captionObj.height + 0 + subCaptionLineHeight * 0.2;
        maxCaptionWidth = Math.max(captionObj.width, subCaptionObj.width); // Replace the caption and subCaption text with the new wrapped text

        captionConfig.text = captionObj.text;
        captionConfig.height = captionHeight = captionObj.height;
        captionConfig.width = captionObj.width;
        captionConfig.tooltext && (captionConfig.originalText = captionObj.tooltext);
        subCaptionConfig.text = subCaptionObj.text;
        subCaptionConfig.height = captionHeight = subCaptionObj.height;
        subCaptionConfig.width = subCaptionObj.width;
        subCaptionConfig.tooltext && (captionConfig.originalText = subCaptionObj.tooltext);
        maxCaptionWidth = Math.max(captionObj.width, subCaptionObj.width); // Add caption padding, if either caption or sub-caption is to be shown

        if (maxCaptionWidth > 0) {
          maxCaptionWidth = maxCaptionWidth + captionPadding;
        }

        captionConfig.maxCaptionWidth = subCaptionConfig.maxCaptionWidth = maxCaptionWidth; // totalHeight = totalHeight || canvasBorderThickness;

        if (captionConfig.isOnLeft) {
          dimensions.left = maxCaptionWidth;
        } else {
          dimensions.right = maxCaptionWidth;
        }
      }
    }

    if (captionConfig.isOnLeft) {
      captionConfig.align = subCaptionConfig.align = POSITION_END;
    } else {
      captionConfig.align = subCaptionConfig.align = POSITION_START;
    }

    return dimensions;
  }
  /**
   * function to calculate caption width and height
   * @memberof Hbullet
   */
  ;

  _proto._manageCaptionPosition = function _manageCaptionPosition() {
    var iapi = this,
        chartConfig = iapi.config,
        caption = iapi.getChildren('caption')[0],
        subCaption = iapi.getChildren('subCaption')[0],
        captionConfig = caption.config,
        subCaptionConfig = subCaption.config,
        captionPosition = captionConfig.captionPosition,
        maxWidth = mathMax(captionConfig.width, subCaptionConfig.width),
        borderWidth = chartConfig.borderWidth || 0,
        // height = chartConfig.height,
    captionSubCaptionGap = captionConfig.captionSubCaptionGap;

    switch (captionPosition) {
      case POSITION_MIDDLE:
        captionConfig.y = (chartConfig.canvasTop + chartConfig.canvasHeight) * 0.5;
        break;

      case POSITION_BOTTOM:
        captionConfig.y = chartConfig.canvasBottom - (captionConfig.height + subCaptionConfig.height);
        break;

      default:
        // We put it on top by default
        captionConfig.y = chartConfig.canvasTop;
        break;
    }

    subCaptionConfig.y = captionConfig.y + captionSubCaptionGap;

    if (captionConfig.isOnLeft) {
      // captionConfig.align = subCaptionConfig.align = POSITION_END;
      captionConfig.x = subCaptionConfig.x = chartConfig.marginLeft + maxWidth + borderWidth;
    } else {
      // captionConfig.align = subCaptionConfig.align = POSITION_START;
      captionConfig.x = subCaptionConfig.x = chartConfig.width - chartConfig.marginRight - maxWidth - borderWidth;
    }
  }
  /**
   * This method parse all the attributes which are associated with axis compoenents.
   * So that axis compoenents can be configured
   * @return {Object} contains axes config
   * @memberof Hbullet
   */
  ;

  _proto._feedAxesRawData = function _feedAxesRawData() {
    var iapi = this,
        config = iapi.config,
        colorM = iapi.getFromEnv('color-manager'),
        numberFormatter = iapi.getFromEnv('number-formatter'),
        dataObj = iapi.getFromEnv('dataSource'),
        chartAttrs = dataObj.chart,
        scaleConf,
        palleteString = _lib.chartPaletteStr.chart2D,
        ticksBelowGraph = (0, _lib.pluckNumber)(chartAttrs.ticksbelowgraph, !config.isAxisOpposite),
        isAxisOpposite = (0, _lib.pluckNumber)((0, _equal.default)(chartAttrs.scaleposition, config.scalePosition) ? config.isAxisOpposite : (0, _equal.default)(chartAttrs.scaleposition, config.canBeScalePosition) ? !config.isAxisOpposite : UNDEF, !ticksBelowGraph),
        outCanfontSizeWithUnit = (0, _lib.pluckFontSizeMaintainUnit)(chartAttrs.outcnvbasefontsize, chartAttrs.basefontsize, 10);
    scaleConf = {
      isVertical: !iapi.isHorizontal,
      isReverse: false,
      isOpposit: isAxisOpposite,
      outCanfontFamily: (0, _lib.pluck)(chartAttrs.outcnvbasefont, chartAttrs.basefont, 'Verdana,sans'),
      outCanfontSize: this.computeFontSize(outCanfontSizeWithUnit),
      outCanfontSizeWithUnit: outCanfontSizeWithUnit,
      outCancolor: (0, _lib.pluck)(chartAttrs.outcnvbasefontcolor, chartAttrs.basefontcolor, colorM.getColor(palleteString.baseFontColor)).replace(/^#?([a-f0-9]+)/ig, '#$1'),
      // axisNamePadding: chartAttrs.xaxisnamepadding,
      // axisValuePadding: chartAttrs.labelpadding,
      // axisNameFont: chartAttrs.xaxisnamefont,
      // axisNameFontSize: chartAttrs.xaxisnamefontsize,
      // axisNameFontColor: chartAttrs.xaxisnamefontcolor,
      // axisNameFontBold: chartAttrs.xaxisnamefontbold,
      // axisNameFontItalic: chartAttrs.xaxisnamefontitalic,
      // axisNameBgColor: chartAttrs.xaxisnamebgcolor,
      // axisNameBorderColor: chartAttrs.xaxisnamebordercolor,
      // axisNameAlpha: chartAttrs.xaxisnamealpha,
      // axisNameFontAlpha: chartAttrs.xaxisnamefontalpha,
      // axisNameBgAlpha: chartAttrs.xaxisnamebgalpha,
      // axisNameBorderAlpha: chartAttrs.xaxisnameborderalpha,
      // axisNameBorderPadding: chartAttrs.xaxisnameborderpadding,
      // axisNameBorderRadius: chartAttrs.xaxisnameborderradius,
      // axisNameBorderThickness: chartAttrs.xaxisnameborderthickness,
      // axisNameBorderDashed: chartAttrs.xaxisnameborderdashed,
      // axisNameBorderDashLen: chartAttrs.xaxisnameborderdashlen,
      // axisNameBorderDashGap: chartAttrs.xaxisnameborderdashgap,
      useEllipsesWhenOverflow: chartAttrs.useellipseswhenoverflow,
      divLineColor: (0, _lib.pluck)(chartAttrs.vdivlinecolor, colorM.getColor(palleteString.divLineColor)),
      divLineAlpha: (0, _lib.pluck)(chartAttrs.vdivlinealpha, colorM.getColor('divLineAlpha')),
      divLineThickness: (0, _lib.pluckNumber)(chartAttrs.vdivlinethickness, 1),
      divLineIsDashed: Boolean((0, _lib.pluckNumber)(chartAttrs.vdivlinedashed, chartAttrs.vdivlineisdashed, 0)),
      divLineDashLen: (0, _lib.pluckNumber)(chartAttrs.vdivlinedashlen, 4),
      divLineDashGap: (0, _lib.pluckNumber)(chartAttrs.vdivlinedashgap, 2),
      showAlternateGridColor: (0, _lib.pluckNumber)(chartAttrs.showalternatevgridcolor, 0),
      alternateGridColor: (0, _lib.pluck)(chartAttrs.alternatevgridcolor, colorM.getColor('altVGridColor')),
      alternateGridAlpha: (0, _lib.pluck)(chartAttrs.alternatevgridalpha, colorM.getColor('altVGridAlpha')),
      numDivLines: chartAttrs.numvdivlines,
      labelFont: chartAttrs.labelfont,
      labelFontSize: this.computeFontSize(chartAttrs.labelfontsize),
      labelFontSizeWithUnit: chartAttrs.labelfontsize,
      labelFontColor: chartAttrs.labelfontcolor,
      labelAlpha: chartAttrs.labelalpha,
      labelFontBold: chartAttrs.labelfontbold,
      labelFontItalic: chartAttrs.labelfontitalic,
      axisName: chartAttrs.xaxisname,
      axisMinValue: numberFormatter.getCleanValue(chartAttrs.lowerlimit),
      axisMaxValue: numberFormatter.getCleanValue(chartAttrs.upperlimit),
      setAdaptiveMin: chartAttrs.setadaptivexmin,
      // adjusttm will be internally parsed as adjustdiv
      adjustDiv: chartAttrs.adjusttm,
      labelDisplay: chartAttrs.labeldisplay,
      showLabels: chartAttrs.showlabels,
      rotateLabels: chartAttrs.rotatelabels,
      slantLabel: (0, _lib.pluckNumber)(chartAttrs.slantlabels, chartAttrs.slantlabel),
      labelStep: (0, _lib.pluckNumber)(chartAttrs.labelstep, chartAttrs.xaxisvaluesstep),
      showAxisValues: (0, _lib.pluckNumber)(chartAttrs.showxaxisvalues, chartAttrs.showxaxisvalue),
      showDivLineValues: (0, _lib.pluckNumber)(chartAttrs.showvdivlinevalues, chartAttrs.showvdivlinevalues),
      showZeroPlane: chartAttrs.showvzeroplane,
      zeroPlaneColor: chartAttrs.vzeroplanecolor,
      zeroPlaneThickness: chartAttrs.vzeroplanethickness,
      zeroPlaneAlpha: chartAttrs.vzeroplanealpha,
      showZeroPlaneValue: chartAttrs.showvzeroplanevalue,
      trendlineColor: chartAttrs.trendlinecolor,
      trendlineToolText: chartAttrs.trendlinetooltext,
      trendlineThickness: chartAttrs.trendlinethickness,
      trendlineAlpha: chartAttrs.trendlinealpha,
      showTrendlinesOnTop: chartAttrs.showtrendlinesontop,
      showAxisLine: (0, _lib.pluckNumber)(chartAttrs.showxaxisline, chartAttrs.showaxislines, chartAttrs.drawAxisLines, 0),
      axisLineThickness: (0, _lib.pluckNumber)(chartAttrs.xaxislinethickness, chartAttrs.axislinethickness, 1),
      axisLineAlpha: (0, _lib.pluckNumber)(chartAttrs.xaxislinealpha, chartAttrs.axislinealpha, 100),
      axisLineColor: (0, _lib.pluck)(chartAttrs.xaxislinecolor, chartAttrs.axislinecolor, '#000000'),
      // Tick properties
      majorTMNumber: chartAttrs.majortmnumber,
      majorTMColor: chartAttrs.majortmcolor,
      majorTMAlpha: chartAttrs.majortmalpha,
      majorTMHeight: chartAttrs.majortmheight,
      tickValueStep: chartAttrs.tickvaluestep,
      showTickMarks: chartAttrs.showtickmarks,
      connectTickMarks: chartAttrs.connecttickmarks,
      showTickValues: chartAttrs.showtickvalues,
      majorTMThickness: chartAttrs.majortmthickness,
      reverseScale: chartAttrs.reversescale,
      // Whether to display the Limits
      showLimits: (0, _lib.pluckNumber)(chartAttrs.showlimits, chartAttrs.showtickmarks),
      minorTMNumber: (0, _lib.pluckNumber)(chartAttrs.minortmnumber, 0),
      minorTMColor: chartAttrs.minortmcolor,
      minorTMAlpha: chartAttrs.minortmalpha,
      minorTMHeight: (0, _lib.pluckNumber)(chartAttrs.minortmheight, chartAttrs.minortmwidth),
      minorTMThickness: chartAttrs.minortmthickness,
      // Padding between tick mark start position and gauge
      tickMarkDistance: (0, _lib.pluckNumber)(chartAttrs.tickmarkdistance, chartAttrs.tickmarkgap),
      // Tick value distance
      tickValueDistance: (0, _lib.pluckNumber)(chartAttrs.tickvaluedistance, chartAttrs.displayvaluedistance),
      placeTicksInside: chartAttrs.placeticksinside,
      placeValuesInside: chartAttrs.placevaluesinside,
      upperLimitDisplay: chartAttrs.upperlimitdisplay,
      lowerLimitDisplay: chartAttrs.lowerlimitdisplay
    };
    return [scaleConf];
  }
  /**
   * get dataset defination
   * @return {Object} The dataset defination
   */
  ;

  _proto.getDSdef = function getDSdef() {
    return _bullet.default;
  }
  /**
   * Returns the postion for the caption placement.
   * @return {number} extraspace
   * @memberof Hbullet
   */
  ;

  _proto._fetchCaptionPos = function _fetchCaptionPos() {
    var extraSpace,
        iapi = this,
        caption = iapi.getChildren('caption')[0],
        captionConfig = caption.config; // check if even after placing the caption
    // space available on right.
    // left aligned.

    if (captionConfig.align === POSITION_END) {
      extraSpace = 0;
    } else {
      // right aligned
      extraSpace = -1;
    }

    return extraSpace;
  };

  return Hbullet;
}(_lineargauge.default);

var _default = Hbullet;
exports["default"] = _default;

/***/ }),

/***/ 1509:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _vled = _interopRequireDefault(__webpack_require__(1510));

/* eslint require-jsdoc: 'error', valid-jsdoc: ["error", { "requireReturn": false }] */
var SERIES_TYPE = 'led',
    FRIENDLY_NAME = 'Vertical LED Gauge',
    BOTTOM = 'bottom',
    TOP = 'top';
/**
 * Class for Hled chart
 * @class Hled
 * @extends {Vled}
 */

var Hled = /*#__PURE__*/function (_Vled) {
  (0, _inheritsLoose2.default)(Hled, _Vled);

  /**
   * Provides the name of the chart extension
   *
   * @static
   * @return {string} The name of the chart extension
   */
  Hled.getName = function getName() {
    return 'Hled';
  }
  /**
  * Creates an instance of Hled.
  * @memberof Hled
  */
  ;

  function Hled() {
    var _this;

    _this = _Vled.call(this) || this;
    _this.defaultSeriesType = SERIES_TYPE;
    _this.defaultPlotShadow = 1;
    _this.realtimeEnabled = true;
    _this.chartleftmargin = 15;
    _this.chartrightmargin = 15;
    _this.charttopmargin = 10;
    _this.chartbottommargin = 10;
    _this.showTooltip = 0;
    _this.connectTickMarks = 0;
    _this.isHorizontal = true;
    _this.config.isAxisOpposite = false;
    _this.config.scalePosition = BOTTOM;
    _this.config.canBeScalePosition = TOP;
    return _this;
  } // Disabling the ability to reverse the scale


  var _proto = Hled.prototype;

  _proto._feedAxesRawData = function _feedAxesRawData() {
    var scaleConf = _Vled.prototype._feedAxesRawData.call(this);

    scaleConf[0].isReverse = false;
    return scaleConf;
  }
  /**
   * Sets default configuration
   * @memberof Hled
   */
  ;

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    _Vled.prototype.__setDefaultConfig.call(this);

    this.config.friendlyName = FRIENDLY_NAME;
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */
  ;

  _proto.getName = function getName() {
    return 'Hled';
  };

  return Hled;
}(_vled.default);

var _default = Hled;
exports["default"] = _default;

/***/ }),

/***/ 1518:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _lib = __webpack_require__(274);

var _colorGradient = _interopRequireDefault(__webpack_require__(1519));

var _lineargauge = _interopRequireDefault(__webpack_require__(1487));

var _hlineargauge = _interopRequireDefault(__webpack_require__(1504));

var _angularHlinearCommon = __webpack_require__(1498);

var BLANKSTRING = _lib.BLANK,
    FRIENDLY_NAME = 'Horizontal Linear Gauge',
    DS_TYPE = 'hlineargauge',
    BOTTOM = 'bottom',
    TOP = 'top';

var Hlineargauge = /*#__PURE__*/function (_LinearGauge) {
  (0, _inheritsLoose2.default)(Hlineargauge, _LinearGauge);

  /**
   * Provides the name of the chart extension
   *
   * @static
   * @return {string} The name of the chart extension
   */
  Hlineargauge.getName = function getName() {
    return 'Hlineargauge';
  };

  function Hlineargauge() {
    var _this;

    _this = _LinearGauge.call(this) || this;
    _this.showRTvalue = false;
    _this.canvasPadding = false;
    _this.isHorizontal = true;
    _this.config.isAxisOpposite = false;
    _this.config.scalePosition = BOTTOM;
    _this.config.canBeScalePosition = TOP;
    _this.drawPlotlines = false;
    _this.drawPlotBands = false;
    _this.isAxisReverse = false;
    _this.minorTMNumber = 4;
    _this.isRealTime = true;
    _this.colorRange = true;
    _this.rtParserModify = true;

    _this.registerFactory('dataset', function (parent) {
      var dataObj = parent.getFromEnv('dataSource'),
          pointers = dataObj.pointers;
      (0, _lib.datasetFactory)(parent, _hlineargauge.default, 'dataset', 1, [pointers]);
    }, ['vCanvas']);

    return _this;
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */


  var _proto = Hlineargauge.prototype;

  _proto.getName = function getName() {
    return 'Hlineargauge';
  };

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    _LinearGauge.prototype.__setDefaultConfig.call(this);

    var config = this.config;
    config.friendlyName = FRIENDLY_NAME;
    config.hasLegend = false;
    config.defaultDatasetType = DS_TYPE;
    config.skipCanvasDrawing = true;
  };

  _proto.configure = function configure(dataObj) {
    _LinearGauge.prototype.configure.call(this, dataObj);

    var iapi = this,
        jsonData = iapi.getFromEnv('dataSource'),
        colorrange = jsonData.colorrange; // If color array is present and contains non-zero color elements

    if (colorrange && colorrange.color && colorrange.color.length) {
      (0, _lib.componentFactory)(iapi, _colorGradient.default, 'colorRange', 1, [{
        colorRange: colorrange,
        numberFormatter: iapi.getFromEnv('number-formatter')
      }]);
      iapi.addToEnv('colorRange', iapi.getChildren('colorRange')[0]);
    } else {
      iapi.deleteFromEnv('colorRange');
    }
  };

  _proto._configueTrendPoints = function _configueTrendPoints() {
    var iapi = this,
        jsonData = iapi.getFromEnv('dataSource'),
        config = iapi.config,
        style = config.style,
        trendArray = jsonData.trendpoints && jsonData.trendpoints.point,
        trendPointObj,
        i,
        scale = iapi.getFromEnv('scale'),
        scaleConfig = scale.config,
        axisRange = scaleConfig.axisRange,
        max = axisRange.max,
        min = axisRange.min,
        scaleFactor = scaleConfig.scaleFactor || 1,
        colorM = iapi.getFromEnv('color-manager'),
        startValue,
        endValue,
        isTrendZone,
        trendPointConfig = config.trendPointConfig = [],
        chartAttrs = jsonData.chart,
        length = trendArray.length;
    style.trendStyle = {
      fontFamily: style.outCanfontFamily,
      color: style.outCancolor,
      fontSize: style.outCanfontSize
    };

    for (i = 0; i < length; i++) {
      trendPointObj = trendArray[i];
      startValue = (0, _lib.pluckNumber)(trendPointObj.startvalue, trendPointObj.value);
      endValue = (0, _lib.pluckNumber)(trendPointObj.endvalue, startValue);
      isTrendZone = startValue !== endValue;

      if (startValue <= max && startValue >= min && endValue <= max && endValue >= min) {
        trendPointConfig.push({
          startValue: startValue,
          endValue: endValue,
          tooltext: (0, _lib.getValidValue)((0, _lib.parseUnsafeString)(trendPointObj.markertooltext, false)),
          displayValue: (0, _lib.getValidValue)((0, _lib.parseUnsafeString)(trendPointObj.displayvalue), isTrendZone ? BLANKSTRING : iapi.getFromEnv('number-formatter').scale(startValue)),
          showOnTop: (0, _lib.pluckNumber)(trendPointObj.showontop, chartAttrs.ticksbelowgauge, 1),
          color: (0, _lib.pluck)(trendPointObj.color, colorM.getColor('trendLightColor')),
          textColor: trendPointObj.color,
          alpha: (0, _lib.pluckNumber)(trendPointObj.alpha, 99),
          thickness: (0, _lib.pluckNumber)(trendPointObj.thickness, 1),
          dashStyle: Number(trendPointObj.dashed) ? (0, _lib.getDashStyle)(trendPointObj.dashlen || 2, trendPointObj.dashgap || 2) : _lib.BLANK,
          // Marker properties
          useMarker: (0, _lib.pluckNumber)(trendPointObj.usemarker, 0),
          markerColor: (0, _lib.convertColor)((0, _lib.pluck)(trendPointObj.markercolor, trendPointObj.color, colorM.getColor('trendLightColor')), 100),
          markerBorderColor: (0, _lib.convertColor)((0, _lib.pluck)(trendPointObj.markerbordercolor, trendPointObj.bordercolor, colorM.getColor('trendDarkColor')), 100),
          markerRadius: (0, _lib.pluckNumber)((0, _lib.pluckNumber)(trendPointObj.markerradius) * scaleFactor, 5),
          markerToolText: (0, _lib.getFirstValue)(trendPointObj.markertooltext),
          trendValueDistance: (0, _lib.pluckNumber)((0, _lib.pluckNumber)(trendPointObj.trendvaluedistance) * scaleFactor, axisRange.tickInterval),
          isTrendZone: isTrendZone
        });
      }
    } // Sorting the trend point array because the labels have to
    // be space managed in case of hlineargauge.


    _lib.stableSort && (0, _lib.stableSort)(config.trendPointConfig, function (a, b) {
      return a.startValue - b.startValue;
    });
  };

  _proto._getData = function _getData(index, callback) {
    return _angularHlinearCommon._getData.call(this, index, callback);
  };

  _proto._setData = function _setData(dialIndex, value) {
    _angularHlinearCommon._setData.call(this, dialIndex, value);
  };

  _proto._getDataForId = function _getDataForId(id, callback) {
    return _angularHlinearCommon._getDataForId.call(this, id, callback);
  };

  _proto._setDataForId = function _setDataForId(id, value) {
    _angularHlinearCommon._setDataForId.call(this, id, value);
  };

  return Hlineargauge;
}(_lineargauge.default);

var _default = Hlineargauge;
exports["default"] = _default;

/***/ }),

/***/ 1567:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _funnelpyramidbase = _interopRequireDefault(__webpack_require__(1560));

var _pyramid = _interopRequireDefault(__webpack_require__(1568));

/* eslint require-jsdoc: 'error', valid-jsdoc: ["error", { "requireReturn": false }] */
var DS_TYPE = 'pyramid',
    FRIENDLY_NAME = 'Funnel Chart';
/**
 * Class for Pyramid chart
 * @class Pyramid
 * @extends {FunnelPyramidBase}
 */

var Pyramid = /*#__PURE__*/function (_FunnelPyramidBase) {
  (0, _inheritsLoose2.default)(Pyramid, _FunnelPyramidBase);

  /**
   * Provides the name of the chart extension
   *
   * @static
   * @return {string} The name of the chart extension
   */
  Pyramid.getName = function getName() {
    return 'Pyramid';
  }
  /**
  * Creates an instance of Pyramid.
  * @memberof Pyramid
  */
  ;

  function Pyramid() {
    var _this;

    _this = _FunnelPyramidBase.call(this) || this;
    _this.useSortedData = false;
    return _this;
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */


  var _proto = Pyramid.prototype;

  _proto.getName = function getName() {
    return 'Pyramid';
  }
  /**
  * Sets default configuration
  * @memberof Pyramid
  */
  ;

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    _FunnelPyramidBase.prototype.__setDefaultConfig.call(this);

    var config = this.config;
    config.friendlyName = FRIENDLY_NAME;
    config.defaultDatasetType = DS_TYPE;
  }
  /**
   * Configures Attributes of chart
   *
   * @memberof Funnel
   */
  ;

  _proto.configureAttributes = function configureAttributes() {
    _FunnelPyramidBase.prototype.configureAttributes.call(this);

    this.config.PLOT_COLOR_INDEX_START = 0;
    this.alignLegendWithCanvas = 0;
  }
  /**
  * This method return the dataset definations for this chart
  * @return {Object} dataset
  * @memberof Pyramid
  */
  ;

  _proto.getDSdef = function getDSdef() {
    return _pyramid.default;
  };

  return Pyramid;
}(_funnelpyramidbase.default);

var _default = Pyramid;
exports["default"] = _default;

/***/ }),

/***/ 1571:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _commonchartapi = _interopRequireDefault(__webpack_require__(520));

var _legend9 = _interopRequireDefault(__webpack_require__(629));

var _legendSpacemanager = __webpack_require__(627);

var _radialtrack = _interopRequireDefault(__webpack_require__(1572));

var _radialbar = _interopRequireDefault(__webpack_require__(1573));

var _lib = __webpack_require__(274);

var _polarUtil = __webpack_require__(1454);

var _trustedPolicy = _interopRequireDefault(__webpack_require__(299));

var TICK_VALUE_GAP = 8,
    ICON_PADDING = 10;
/**
 * Creates the padding object for padding of labels
 * @param {String} paddingStr string with padding values
 * @returns {Object} Object with directional padding values
 */

function createLabelPadding(paddingStr) {
  var labelPaddingArr = paddingStr.split(' ').map(function (padding) {
    return parseInt(padding, 10);
  });

  if (labelPaddingArr.every(function (padding) {
    return isNaN(padding);
  })) {
    return {
      top: 6,
      right: 10,
      bottom: 6,
      left: 10
    };
  }

  if (labelPaddingArr.length === 1) {
    labelPaddingArr.push(labelPaddingArr[0]);
    labelPaddingArr.push(labelPaddingArr[0]);
    labelPaddingArr.push(labelPaddingArr[0]);
  } else if (labelPaddingArr.length === 2) {
    labelPaddingArr.push(labelPaddingArr[0]);
    labelPaddingArr.push(labelPaddingArr[1]);
  } else if (labelPaddingArr.length === 3) {
    labelPaddingArr.push(labelPaddingArr[1]);
  }

  labelPaddingArr.map(function (padding, index) {
    if (isNaN(padding)) {
      if (index === 0) {
        return 6;
      } else if (index === 1) {
        return labelPaddingArr[index - 1];
      } // eslint-disable-next-line no-else-return


      return labelPaddingArr[index - 2];
    }

    return padding;
  });
  return {
    top: labelPaddingArr[0],
    right: labelPaddingArr[1],
    bottom: labelPaddingArr[2],
    left: labelPaddingArr[3]
  };
}
/**
 * Populates radial bar dataset.
 */


function radialBarFactoryFn(chart) {
  var parent = chart,
      config = chart.config,
      bars = parent.getChildren(_radialbar.default.getType()),
      lenBars = bars ? bars.length : 0,
      dataSource = chart.getFromEnv('dataSource');

  if (Array.isArray(dataSource.data)) {
    // when no of tracks greater than existing
    if (dataSource.data.length > lenBars) {
      var children = parent.getChildren('plot');

      for (var child = 0; child < lenBars; child++) {
        children[child].configure({
          startangle: config.startangle,
          endangle: config.endangle,
          barstartradius: config.barstartradius,
          barendradius: config.barendradius,
          barborder: config.barborder,
          barbordercolor: config.barbordercolor,
          barborderalpha: config.barborderalpha,
          barborderthickness: config.barborderthickness,
          color: config.plots[child].color,
          baralpha: config.plots[child].baralpha,
          legenditemalpha: config.plots[child].baralpha,
          legenditemcolor: config.plots[child].color,
          legenditembordercolor: config.barbordercolor,
          value: config.plots[child].value,
          dataValue: config.plots[child].dataValue,
          label: config.plots[child].label,
          iconurl: config.plots[child].iconurl,
          contexttext: config.plots[child].contextlabeltext,
          tooltext: config.plots[child].tooltext,
          plotHidden: config.plots[child].initiallyhidden,
          plotIndex: child
        });
      }

      for (var _child = 0; _child < dataSource.data.length - lenBars; _child++) {
        var childInstance = new _radialbar.default(),
            childComp = parent.attachChild(childInstance, 'plot');
        childComp.configure({
          startangle: config.startangle,
          endangle: config.endangle,
          barstartradius: config.barstartradius,
          barendradius: config.barendradius,
          barborder: config.barborder,
          barbordercolor: config.barbordercolor,
          barborderalpha: config.barborderalpha,
          barborderthickness: config.barborderthickness,
          color: config.plots[_child].color,
          baralpha: config.plots[_child].baralpha,
          legenditemalpha: config.plots[_child].baralpha,
          legenditemcolor: config.plots[_child].color,
          legenditembordercolor: config.barbordercolor,
          value: config.plots[_child].value,
          dataValue: config.plots[_child].dataValue,
          label: config.plots[_child].label,
          iconurl: config.plots[_child].iconurl,
          contexttext: config.plots[_child].contextlabeltext,
          tooltext: config.plots[_child].tooltext,
          plotHidden: config.plots[_child].initiallyhidden,
          plotIndex: _child
        });
      }
    } else if (dataSource.data.length === lenBars) {
      var _children = parent.getChildren('plot');

      for (var index = 0; index < lenBars; index++) {
        _children[index].configure({
          startangle: config.startangle,
          endangle: config.endangle,
          barstartradius: config.barstartradius,
          barendradius: config.barendradius,
          barborder: config.barborder,
          barbordercolor: config.barbordercolor,
          barborderalpha: config.barborderalpha,
          barborderthickness: config.barborderthickness,
          color: config.plots[index].color,
          baralpha: config.plots[index].baralpha,
          legenditemalpha: config.plots[index].baralpha,
          legenditemcolor: config.plots[index].color,
          legenditembordercolor: config.barbordercolor,
          value: config.plots[index].value,
          dataValue: config.plots[index].dataValue,
          label: config.plots[index].label,
          iconurl: config.plots[index].iconurl,
          contexttext: config.plots[index].contextlabeltext,
          tooltext: config.plots[index].tooltext,
          plotHidden: config.plots[index].initiallyhidden,
          plotIndex: index
        });
      }

      ;
    } else {
      var _children2 = parent.getChildren('plot');

      for (var _index = 0; _index < dataSource.data.length; _index++) {
        _children2[_index].configure({
          startangle: config.startangle,
          endangle: config.endangle,
          barstartradius: config.barstartradius,
          barendradius: config.barendradius,
          barborder: config.barborder,
          barbordercolor: config.barbordercolor,
          barborderalpha: config.barborderalpha,
          barborderthickness: config.barborderthickness,
          color: config.plots[_index].color,
          baralpha: config.plots[_index].baralpha,
          legenditemalpha: config.plots[_index].baralpha,
          legenditemcolor: config.plots[_index].color,
          legenditembordercolor: config.barbordercolor,
          value: config.plots[_index].value,
          dataValue: config.plots[_index].dataValue,
          label: config.plots[_index].label,
          iconurl: config.plots[_index].iconurl,
          contexttext: config.plots[_index].contextlabeltext,
          tooltext: config.plots[_index].tooltext,
          plotHidden: config.plots[_index].initiallyhidden,
          plotIndex: _index
        });
      }

      for (var _child2 = dataSource.data.length; _child2 < lenBars; _child2++) {
        _children2[_child2].remove();
      }
    }
  } else {
    var _children3 = parent.getChildren('plot');

    for (var _index2 = 0; _index2 < lenBars; _index2++) {
      _children3[_index2].remove();
    }
  }
}

;
/**
 * Populates radial track dataset.
 */

function radialTrackFactoryFn(chart) {
  var parent = chart,
      config = chart.config,
      tracks = parent.getChildren(_radialtrack.default.getType()),
      lenTracks = tracks ? tracks.length : 0,
      dataSource = chart.getFromEnv('dataSource');

  if (Array.isArray(dataSource.data)) {
    // when no of tracks greater than existing
    if (dataSource.data.length > lenTracks) {
      var children = parent.getChildren('dataset');

      for (var child = 0; child < lenTracks; child++) {
        children[child].configure({
          startangle: config.startangle,
          endangle: config.endangle,
          trackpadding: config.trackpadding,
          trackmargin: config.trackmargin,
          trackstartradius: config.trackstartradius,
          trackendradius: config.trackendradius,
          trackfillcolor: config.tracks[child].trackfillcolor,
          trackalpha: config.tracks[child].trackalpha,
          trackborder: config.trackborder,
          trackbordercolor: config.trackbordercolor,
          trackborderalpha: config.trackborderalpha,
          trackborderthickness: config.trackborderthickness,
          numTicks: config.numticks,
          tickMarkLength: config.tickmarklength,
          tickvaluefontsizeWithUnit: config.tickvaluefontsizeWithUnit,
          showticks: config.showticks,
          showtickmarks: config.showtickmarks,
          showtickvalues: config.showtickvalues,
          tickmarkcolor: config.tickmarkcolor,
          tickmarkthickness: config.tickmarkthickness,
          tickalpha: config.tickalpha,
          tickvaluealpha: config.tickvaluealpha,
          tickvaluelabelfont: config.tickvaluelabelfont,
          tickvaluefontcolor: config.tickvaluefontcolor,
          baseFontColor: config.baseFontColor,
          tickvaluegap: TICK_VALUE_GAP,
          label: config.tracks[child].label,
          iconurl: config.tracks[child].iconurl,
          labelFontColor: config.tracks[child].labelFontColor,
          value: config.tracks[child].value
        });
      }

      for (var _child3 = 0; _child3 < dataSource.data.length - lenTracks; _child3++) {
        var childInstance = new _radialtrack.default(),
            childComp = parent.attachChild(childInstance, 'dataset');
        childComp.configure({
          startangle: config.startangle,
          endangle: config.endangle,
          trackpadding: config.trackpadding,
          trackmargin: config.trackmargin,
          trackstartradius: config.trackstartradius,
          trackendradius: config.trackendradius,
          trackfillcolor: config.tracks[_child3].trackfillcolor,
          trackalpha: config.tracks[_child3].trackalpha,
          trackborder: config.trackborder,
          trackbordercolor: config.trackbordercolor,
          trackborderalpha: config.trackborderalpha,
          trackborderthickness: config.trackborderthickness,
          numTicks: config.numticks,
          tickMarkLength: config.tickmarklength,
          tickvaluefontsizeWithUnit: config.tickvaluefontsizeWithUnit,
          showticks: config.showticks,
          showtickmarks: config.showtickmarks,
          showtickvalues: config.showtickvalues,
          tickmarkcolor: config.tickmarkcolor,
          tickmarkthickness: config.tickmarkthickness,
          tickalpha: config.tickalpha,
          tickvaluealpha: config.tickvaluealpha,
          tickvaluelabelfont: config.tickvaluelabelfont,
          tickvaluefontcolor: config.tickvaluefontcolor,
          baseFontColor: config.baseFontColor,
          tickvaluegap: TICK_VALUE_GAP,
          label: config.tracks[_child3].label,
          iconurl: config.tracks[_child3].iconurl,
          labelFontColor: config.tracks[_child3].labelFontColor,
          value: config.tracks[_child3].value
        });
      }
    } else if (dataSource.data.length === lenTracks) {
      var _children4 = parent.getChildren('dataset');

      for (var index = 0; index < lenTracks; index++) {
        _children4[index].configure({
          startangle: config.startangle,
          endangle: config.endangle,
          trackpadding: config.trackpadding,
          trackmargin: config.trackmargin,
          trackstartradius: config.trackstartradius,
          trackendradius: config.trackendradius,
          trackfillcolor: config.tracks[index].trackfillcolor,
          trackalpha: config.tracks[index].trackalpha,
          trackborder: config.trackborder,
          trackbordercolor: config.trackbordercolor,
          trackborderalpha: config.trackborderalpha,
          trackborderthickness: config.trackborderthickness,
          numTicks: config.numticks,
          tickMarkLength: config.tickmarklength,
          tickvaluefontsizeWithUnit: config.tickvaluefontsizeWithUnit,
          showticks: config.showticks,
          showtickmarks: config.showtickmarks,
          showtickvalues: config.showtickvalues,
          tickmarkcolor: config.tickmarkcolor,
          tickmarkthickness: config.tickmarkthickness,
          tickalpha: config.tickalpha,
          tickvaluealpha: config.tickvaluealpha,
          tickvaluelabelfont: config.tickvaluelabelfont,
          tickvaluefontcolor: config.tickvaluefontcolor,
          baseFontColor: config.baseFontColor,
          tickvaluegap: TICK_VALUE_GAP,
          label: config.tracks[index].label,
          iconurl: config.tracks[index].iconurl,
          labelFontColor: config.tracks[index].labelFontColor,
          value: config.tracks[index].value
        });
      }

      ;
    } else {
      var _children5 = parent.getChildren('dataset');

      for (var _child4 = dataSource.data.length; _child4 < lenTracks; _child4++) {
        _children5[_child4].remove();
      }
    }
  } else {
    if (lenTracks === 0) {
      var _childInstance = new _radialtrack.default();

      parent.attachChild(_childInstance, 'dataset');

      _childInstance.configure({
        startangle: config.startangle,
        endangle: config.endangle,
        trackpadding: config.trackpadding,
        trackmargin: config.trackmargin,
        trackstartradius: config.trackstartradius,
        trackendradius: config.trackendradius,
        trackfillcolor: config.tracks[0].trackfillcolor,
        trackalpha: config.tracks[0].trackalpha,
        trackborder: config.trackborder,
        trackbordercolor: config.trackbordercolor,
        trackborderalpha: config.trackborderalpha,
        trackborderthickness: config.trackborderthickness,
        numTicks: config.numticks,
        tickMarkLength: config.tickmarklength,
        tickvaluefontsizeWithUnit: config.tickvaluefontsizeWithUnit,
        showticks: config.showticks,
        showtickmarks: config.showtickmarks,
        showtickvalues: config.showtickvalues,
        tickmarkcolor: config.tickmarkcolor,
        tickmarkthickness: config.tickmarkthickness,
        tickalpha: config.tickalpha,
        tickvaluealpha: config.tickvaluealpha,
        tickvaluelabelfont: config.tickvaluelabelfont,
        tickvaluefontcolor: config.tickvaluefontcolor,
        baseFontColor: config.baseFontColor,
        tickvaluegap: TICK_VALUE_GAP,
        label: config.tracks[0].label,
        iconurl: config.tracks[0].iconurl,
        labelFontColor: config.tracks[0].labelFontColor,
        value: config.tracks[0].value
      });
    } else {
      var _child5 = parent.getChildren('dataset');

      for (var _index3 = 0; _index3 < lenTracks - 1; _index3++) {
        if (_index3 === 0) {
          tracks[_index3].configure({
            startangle: config.startangle,
            endangle: config.endangle,
            trackpadding: config.trackpadding,
            trackmargin: config.trackmargin,
            trackstartradius: config.trackstartradius,
            trackendradius: config.trackendradius,
            trackfillcolor: config.tracks[_index3].trackfillcolor,
            trackalpha: config.tracks[_index3].trackalpha,
            trackborder: config.trackborder,
            trackbordercolor: config.trackbordercolor,
            trackborderalpha: config.trackborderalpha,
            trackborderthickness: config.trackborderthickness,
            numTicks: config.numticks,
            tickMarkLength: config.tickmarklength,
            tickvaluefontsizeWithUnit: config.tickvaluefontsizeWithUnit,
            showticks: config.showticks,
            showtickmarks: config.showtickmarks,
            showtickvalues: config.showtickvalues,
            tickmarkcolor: config.tickmarkcolor,
            tickmarkthickness: config.tickmarkthickness,
            tickalpha: config.tickalpha,
            tickvaluealpha: config.tickvaluealpha,
            tickvaluelabelfont: config.tickvaluelabelfont,
            tickvaluefontcolor: config.tickvaluefontcolor,
            baseFontColor: config.baseFontColor,
            tickvaluegap: TICK_VALUE_GAP,
            label: config.tracks[_index3].label,
            iconurl: config.tracks[_index3].iconurl,
            labelFontColor: config.tracks[_index3].labelFontColor,
            value: config.tracks[_index3].value
          });
        } else {
          _child5[_index3].remove();
        }
      }
    }
  }
}

;

var RadialBar = /*#__PURE__*/function (_CommonAPI) {
  (0, _inheritsLoose2.default)(RadialBar, _CommonAPI);

  /**
   * Provides the name of the chart extension
   *
   * @static
   * @return {string} The name of the chart extension
   */
  RadialBar.getName = function getName() {
    return 'RadialBar';
  }
  /**
   * Sets the name of the component
   * @return {string} The name of the chart extension
   */
  ;

  var _proto = RadialBar.prototype;

  _proto.getName = function getName() {
    return 'RadialBar';
  }
  /**
   * Provides the type of the chart extension
   *
   * @static
   * @return {string} The type of the chart extension
   */
  ;

  RadialBar.getType = function getType() {
    return 'chartAPI';
  }
  /**
   * Provides the type of the chart extension
   *
   * @return {string} The type of the chart extension
   */
  ;

  _proto.getType = function getType() {
    return 'chartAPI';
  }
  /**
   * function to check if the chart has the proper data or not
   * @return {boolean} if JSON data is valid or not
   */
  // eslint-disable-next-line class-methods-use-this
  ;

  _proto._checkInvalidData = function _checkInvalidData() {
    return false;
  }
  /**
   * function to check if this Specific chart has the proper data or not
   * @return {boolean} if specific attribute in is valid or not
   */
  // eslint-disable-next-line class-methods-use-this
  ;

  _proto._checkInvalidSpecificData = function _checkInvalidSpecificData() {
    var jsonData = this.getFromEnv('dataSource'),
        datasetsJSON = jsonData.data;

    if (!datasetsJSON) {
      return true;
    }

    return false;
  }
  /**
    * Creates an instance of RadialProgress.
    * @memberof RadialBar
    */
  ;

  function RadialBar() {
    var _this;

    _this = _CommonAPI.call(this) || this; // Deregistering canvas component as this chart is not built on canvas
    // and commonchartapi constructor automatically registers it.

    _this.deregisterFactory('canvas'); // Registering dataset for track & bar component


    _this.registerFactory('RadialTrack', radialTrackFactoryFn);

    _this.registerFactory('RadialBarPlot', radialBarFactoryFn, ['legend']);

    _this.registerFactory('legend', _legend9.default);

    return _this;
  }
  /**
    * Sets the default values for parameters of the chart.
    * @memberof RadialBar
    */


  _proto.__setDefaultConfig = function __setDefaultConfig() {
    var chart = this,
        config = chart.config; // Chart configurations

    config.innerradius = 55;
    config.outerradius = 77;
    config.startangle = 90;
    config.endangle = 180; // Track configs

    config.trackpadding = 0;
    config.trackmargin = 6;
    config.trackstartradius = '100%';
    config.trackendradius = '100%';
    config.trackfillcolor = '#cdcdcd';
    config.trackborder = 'none';
    config.trackbordercolor = '#000000';
    config.trackborderalpha = '100%';
    config.trackborderthickness = 1; // Bar configs

    config.barstartradius = '100%';
    config.barendradius = '100%';
    config.barborder = 'none';
    config.barbordercolor = '#000000';
    config.barborderalpha = '100%';
    config.barborderthickness = 1; // Default config for plots & tracks

    config.plots = [{
      color: '#0000ff',
      baralpha: '100%',
      value: 0
    }];
    config.tracks = [{
      trackfillcolor: '#cdcdcd',
      trackalpha: '40%'
    }]; // Ticks configuration

    config.showticks = 1;
    config.numticks = 'auto';
    config.showtickvalues = 1;
    config.tickvaluelabelfont = 'Verdana,sans';
    config.tickvaluefontsize = '10' + _lib.PXSTRING;
    config.tickvaluefontcolor = '#000000';
    config.showtickmarks = 1;
    config.tickmarkcolor = '#000000';
    config.tickmarklength = 5;
    config.tickmarkthickness = 1;
    config.tickalpha = '100%'; // Context label configs

    config.showcontextlabel = 0;
    config.defaultcontextlabel = '';
    config.contextlabeltext = '';
    config.contextlabelfont = 'Verdana,sans';
    config.contextlabelfontsize = '10' + _lib.PXSTRING;
    config.contextlabelfontcolor = '#000000';
    config.contextlabelalpha = '100%'; // Label configs

    config.showlabels = 0;
    config.usedataplotcolorforlabels = 0;
    config.labeltext = '$label, $datavalue';
    config.placevaluesinside = 0;
    config.labelposition = 'start';
    config.labelpadding = '6px 10px 6px 10px';
    config.showlabelicon = 0;
    config.iconscale = '100%';
    config.iconposition = 'end'; // Legend config

    config.interactivelegend = 1; // Tooltip config

    config.showtooltip = 1;
    this.config.style = {
      inCanvasStyle: {}
    };
    this.config.dataLabelStyle = {};
  }
  /**
    * Configures the chart attributes.
    * @memberof RadialBar
    */
  ;

  _proto.configureAttributes = function configureAttributes(dataSource) {
    _CommonAPI.prototype.configureAttributes.call(this, dataSource);

    var config = this.config,
        chartAttr = dataSource.chart,
        numTicks; // RED-9092 check if global value available for trackfillcolor

    var chartAttrToolbarColorAvailable = chartAttr.trackfillcolor; // Chart attributes

    config.innerradius = (0, _lib.pluck)(chartAttr.innerradius, config.innerradius);
    config.outerradius = (0, _lib.pluck)(chartAttr.outerradius, config.outerradius); // Legend attributes

    config.interactivelegend = parseInt((0, _lib.pluck)(chartAttr.interactivelegend, config.interactivelegend, 1), 10);
    config.showLegend = parseInt(chartAttr.showlegend, 10);
    config.startangle = (0, _lib.pluckNumber)(chartAttr.startangle, config.startangle);
    config.endangle = (0, _lib.pluckNumber)(chartAttr.endangle, config.endangle);
    config.startangle = config.startangle >= 0 && config.startangle <= 360 ? config.startangle : 90;
    config.endangle = config.endangle >= 0 && config.endangle <= 360 ? config.endangle : 180; // Track attributes

    config.trackpadding = (0, _lib.pluck)(chartAttr.trackpadding, config.trackpadding);
    config.trackmargin = (0, _lib.pluck)(chartAttr.trackmargin, config.trackmargin);
    config.trackstartradius = (0, _lib.pluck)(chartAttr.trackstartradius, config.trackstartradius);
    config.trackendradius = (0, _lib.pluck)(chartAttr.trackendradius, config.trackendradius);
    config.trackfillcolor = (0, _lib.pluck)(chartAttr.trackfillcolor, config.trackfillcolor);
    config.trackborder = (0, _lib.pluck)(chartAttr.trackborder, config.trackborder);
    config.trackbordercolor = (0, _lib.pluck)(chartAttr.trackbordercolor, config.trackbordercolor);
    config.trackborderalpha = parseInt((0, _lib.pluck)(chartAttr.trackborderalpha, config.trackborderalpha), 10) / 100;
    config.trackborderthickness = (0, _lib.pluck)(chartAttr.trackborderthickness, config.trackborderthickness); // Plot attributes

    config.barstartradius = (0, _lib.pluck)(chartAttr.barstartradius, config.barstartradius);
    config.barendradius = (0, _lib.pluck)(chartAttr.barendradius, config.barendradius);
    config.barborder = (0, _lib.pluck)(chartAttr.barborder, config.barborder);
    config.barbordercolor = (0, _lib.pluck)(chartAttr.barbordercolor, config.barbordercolor);
    config.barborderalpha = parseInt((0, _lib.pluck)(chartAttr.barborderalpha, config.barborderalpha), 10) / 100;
    config.barborderthickness = (0, _lib.pluck)(chartAttr.barborderthickness, config.barborderthickness);

    if (config.style.inCancolor.indexOf('#') === -1) {
      config.style.inCancolor = '#' + config.style.inCancolor;
    }

    config.baseFontColor = (0, _lib.pluck)(chartAttr.baseFontColor, config.style.inCancolor); // Ticks attributes

    numTicks = (0, _lib.pluck)(chartAttr.numticks, config.numticks);
    config.numticks = isNaN(numTicks) ? 'auto' : numTicks;
    config.tickmarklength = parseInt((0, _lib.pluck)(chartAttr.tickmarklength, config.tickmarklength), 10);
    config.showticks = (0, _lib.pluck)(chartAttr.showticks, config.showticks);
    config.showtickmarks = (0, _lib.pluck)(chartAttr.showtickmarks, config.showtickmarks, config.showticks);
    config.showtickvalues = (0, _lib.pluck)(chartAttr.showtickvalues, config.showtickvalues, config.showticks);
    config.tickmarkcolor = (0, _lib.pluck)(chartAttr.tickmarkcolor, config.tickmarkcolor);
    config.tickmarkthickness = parseInt((0, _lib.pluck)(chartAttr.tickmarkthickness, config.tickmarkthickness), 10);
    config.tickalpha = parseInt((0, _lib.pluck)(chartAttr.tickalpha, config.tickalpha), 10) / 100;
    config.tickvaluealpha = parseInt((0, _lib.pluck)(chartAttr.tickvaluealpha, chartAttr.tickalpha, '100%'), 10) / 100;
    config.tickvaluelabelfont = (0, _lib.pluck)(chartAttr.tickvaluelabelfont, config.style.inCanfontFamily);
    config.tickvaluefontcolor = (0, _lib.pluck)(chartAttr.tickvaluefontcolor, config.baseFontColor);
    config.tickvaluefontsizeWithUnit = (0, _lib.pluckFontSizeMaintainUnit)(chartAttr.tickvaluefontsize, config.style.inCanfontSizeWithUnit);
    config.tickvaluefontsize = this.computeFontSize(config.tickvaluefontsizeWithUnit);
    config.palettecolors = (0, _lib.pluck)(chartAttr.palettecolors, config.palettecolors);

    if (config.palettecolors) {
      config.paletteColorsArray = config.palettecolors.trim().split(',');
      config.paletteColorsArray = config.paletteColorsArray.filter(function (color) {
        return color;
      });
    } // Context label attributes


    config.showcontextlabel = parseInt((0, _lib.pluck)(chartAttr.showcontextlabel, config.showcontextlabel), 10);
    config.defaultcontextlabel = (0, _lib.parseUnsafeString)((0, _lib.pluck)(chartAttr.defaultcontextlabel, config.defaultcontextlabel));
    config.contextlabeltext = (0, _lib.pluck)(chartAttr.contextlabeltext, config.contextlabeltext);
    config.contextlabelfont = (0, _lib.pluck)(chartAttr.contextlabelfont, config.style.inCanfontFamily);
    config.contextlabelfontsizewithunit = (0, _lib.pluckFontSizeMaintainUnit)(chartAttr.contextlabelfontsize, config.style.inCanfontSizeWithUnit);
    config.contextlabelfontsize = this.computeFontSize(config.contextlabelfontsizewithunit);
    config.contextlabelfontcolor = (0, _lib.pluck)(chartAttr.contextlabelfontcolor, config.baseFontColor);
    config.contextlabelalpha = parseInt((0, _lib.pluck)(chartAttr.contextlabelalpha, config.contextlabelalpha), 10) / 100;
    config.contexttext = chartAttr.contextlabeltext; // Label attributes

    config.showlabels = (0, _lib.pluckNumber)(chartAttr.showlabels, config.showlabels) || 0;
    config.usedataplotcolorforlabels = (0, _lib.pluckNumber)(chartAttr.usedataplotcolorforlabels, config.usedataplotcolorforlabels) || 0;
    config.labeltext = (0, _lib.pluck)(chartAttr.labeltext, config.labeltext);
    config.placevaluesinside = parseInt((0, _lib.pluckNumber)(chartAttr.placevaluesinside, config.placevaluesinside) || 0, 10);
    config.labelposition = (0, _lib.pluck)(chartAttr.labelposition, config.labelposition);
    config.labelpadding = "6px " + (config.placevaluesinside ? '10px' : '15px');
    config.labelpadding = createLabelPadding((0, _lib.pluck)(chartAttr.labelpadding, config.labelpadding));
    config.showlabelicon = (0, _lib.pluckNumber)(chartAttr.showlabelicon, config.showlabelicon) || 0;
    config.iconscale = (0, _lib.pluck)(chartAttr.iconscale, config.iconscale);
    config.iconposition = (0, _lib.pluck)(chartAttr.iconposition, config.iconposition);

    if (Array.isArray(dataSource.data)) {
      for (var i = 0; i < dataSource.data.length; i++) {
        // configuring track data
        config.tracks[i] = {}; // RED-9092 if global value available for track field alpha then get to global and not then set to default and local

        config.tracks[i].trackfillcolor = chartAttrToolbarColorAvailable && dataSource.data[i].trackfillcolor ? (0, _lib.pluck)(config.trackfillcolor, dataSource.data[i].trackfillcolor) : (0, _lib.pluck)(dataSource.data[i].trackfillcolor, config.trackfillcolor);
        config.tracks[i].trackalpha = parseInt((0, _lib.pluck)(dataSource.data[i].trackalpha, '40%'), 10) / 100;
        config.tracks[i].value = (0, _lib.pluckNumber)(dataSource.data[i].value, 0);
        config.tracks[i].label = (0, _lib.pluck)(dataSource.data[i].label, '');
        config.tracks[i].iconurl = (0, _lib.pluck)(dataSource.data[i].icon, '');
        config.tracks[i].labelFontColor = (0, _lib.pluck)(dataSource.data[i].color, '#0000ff'); // configuring plot data

        config.plots[i] = {};
        config.plots[i].color = (0, _lib.pluck)(dataSource.data[i].color, config.paletteColorsArray ? config.paletteColorsArray[i] : '#0000ff');
        config.plots[i].baralpha = parseInt((0, _lib.pluck)(dataSource.data[i].baralpha, '100'), 10) / 100;
        config.plots[i].value = (0, _lib.pluckNumber)(parseInt(dataSource.data[i].value, 10), 0);
        config.plots[i].iconurl = (0, _lib.pluck)(dataSource.data[i].icon, '');
        config.plots[i].label = (0, _lib.pluck)(dataSource.data[i].label, '');
        config.plots[i].contextlabeltext = (0, _lib.pluck)(dataSource.data[i].contextlabeltext, config.contextlabeltext);
        config.plots[i].tooltext = (0, _lib.pluck)(dataSource.data[i].tooltext, chartAttr.plottooltext);
        config.plots[i].initiallyhidden = config.interactivelegend ? (0, _lib.pluckNumber)(dataSource.data[i].initiallyhidden, 0) : 0;
        config.plots[i].dataValue = config.plots[i].value + '%';
      }
    } // The number of rings


    config.rings = Array.isArray(dataSource.data) && dataSource.data.length || 1;
    this.addToEnv('chartConfig', this.config);
    this.createBaseComponent();
  }
  /**
   * function to calculate and allot space for legend
   * @memberof RadialBar
   */
  ;

  _proto._manageLegendSpace = function _manageLegendSpace() {
    _legendSpacemanager._manageLegendSpace.call(this);
  }
  /**
   * Click event handler for legend item
   * @param {LegendItem} legendItem the legend item that has been clicked
   * @memberof RadialBar
   */
  ;

  _proto.legendInteractivity = function legendInteractivity(legendItem) {
    if (!legendItem.getFromEnv('chart-attrib').interactivelegend) {
      return;
    }

    var plots = this.getChildren('plot'),
        tracks = this.getChildren('dataset'),
        legendItemId = legendItem.getId(),
        plot,
        track;

    if (legendItem.hasState('highlight')) {
      legendItem.removeLegendState('highlight');
    }

    for (var i = 0; i < plots.length; i++) {
      plot = plots[i];
      track = tracks[i];

      if (plot.config.legendItemId === legendItemId) {
        if (!plot.config.plotHidden) {
          plot.config.realBarAlpha = plot.config.realBarAlpha || plot.config.baralpha;
          plot.config.realBarBorderAlpha = plot.config.realBarBorderAlpha || plot.config.barborderalpha;
          plot.setData({
            'baralpha': 0,
            'barborderalpha': 0
          }, true); // Remove the existing label

          if (plot.label) {
            this.removeGraphicalElement(plot.label);
          } // Remove the existing icon


          if (plot.iconImage) {
            this.removeGraphicalElement(plot.iconImage);
          } // Remove the existing plot identifier


          if (plot.plotIdentifier) {
            this.removeGraphicalElement(plot.plotIdentifier);
          } // Remove the existing label [if it was a div]


          if (plot.labelDiv) {
            this.getFromEnv('chart-container').removeChild(plot.labelDiv);
            delete plot.labelDiv;
          }

          legendItem.setLegendState('hidden', true);
          plot.config.plotHidden = true;
        } else {
          plot.setData({
            'baralpha': plot.config.realBarAlpha,
            'barborderalpha': plot.config.realBarBorderAlpha
          }, true);
          this.drawLabel(track, plot);
          legendItem.removeLegendState('hidden');
          plot.config.plotHidden = false;
        }

        legendItem.getFromEnv('chart-attrib').interactivelegend = 0;
      }
    }
  }
  /**
    * Performs calculation logic for space management for
    * the chart.
    * @memberof RadialBar
    */
  ;

  _proto._spaceManager = function _spaceManager() {
    var _this2 = this;

    var config = this.config,
        side,
        chartMaxDiameter,
        trackthickness,
        barthickness,
        data = this.getFromEnv('dataSource').data,
        box = _lib.UNDEF,
        counter = 0,
        captionSpace; // Managing space for legend

    this.config.showLegend && this._manageLegendSpace(); // Setting the values & calculating maximum chart diameter

    config.tickvaluefontsize = this.computeFontSize(config.tickvaluefontsizeWithUnit);
    config.availableHeight = this.getFromEnv('chartConfig').availableHeight;
    config.availableWidth = this.getFromEnv('chartConfig').availableWidth;
    side = config.availableHeight > config.availableWidth ? config.availableWidth : config.availableHeight;
    config.outerradius = (0, _lib.convertToPixels)(config.outerradius, side / 2);
    config.outerradius = config.outerradius < 0 ? 77 : config.outerradius;
    config.innerradius = (0, _lib.convertToPixels)(config.innerradius, side / 2);
    config.innerradius = config.innerradius < 0 ? 55 : config.innerradius;
    config.trackstartradius = (0, _lib.convertToPixels)(config.trackstartradius, side / 2);
    config.trackstartradius = config.trackstartradius > 100 ? 100 : config.trackstartradius;
    config.trackendradius = (0, _lib.convertToPixels)(config.trackendradius, side / 2);
    config.trackendradius = config.trackendradius > 100 ? 100 : config.trackendradius;
    config.barstartradius = (0, _lib.convertToPixels)(config.barstartradius, side / 2);
    config.barstartradius = config.barstartradius > 100 ? 100 : config.barstartradius;
    config.barendradius = (0, _lib.convertToPixels)(config.barendradius, side / 2);
    config.barendradius = config.barendradius > 100 ? 100 : config.barendradius;
    config.trackmargin = (0, _lib.convertToPixels)(config.trackmargin, side / 2);

    if (config.innerradius >= config.outerradius) {
      config.innerradius = 55;
      config.outerradius = 77;
    }

    chartMaxDiameter = (config.outerradius + (config.showticks ? config.tickmarklength : 0) + (config.showtickvalues ? TICK_VALUE_GAP + config.tickvaluefontsize : 0)) * 2; // Managing space for caption

    captionSpace = this._manageChartMenuBar(chartMaxDiameter < config.availableHeight ? config.availableHeight - chartMaxDiameter : config.availableHeight / 2);
    chartMaxDiameter -= (captionSpace.top || 0) + (captionSpace.bottom || 0); // Adjusting outer radius of the chart according to available space

    if (chartMaxDiameter > side) {
      config.outerradius = side / 2 - (config.showticks ? config.tickmarklength : 0) - (config.showtickvalues ? config.tickvaluefontsize : 0);
    } // Calculating the thickness of track and bar


    trackthickness = (config.outerradius - config.innerradius - (config.rings - 1) * config.trackmargin) / config.rings;

    if (trackthickness < 0) {
      config.trackmargin = 0;
      trackthickness = (config.outerradius - config.innerradius) / config.rings;
    }

    config.trackpadding = (0, _lib.convertToPixels)(config.trackpadding, trackthickness / 2);

    if (config.trackpadding > trackthickness / 2) {
      config.trackpadding = 0;
    }

    barthickness = trackthickness - config.trackpadding * 2;

    if (barthickness < 0) {
      barthickness = (config.outerradius - config.innerradius) / config.rings;
    } // Space management for tracks


    this.getChildren('dataset') && this.getChildren('dataset').forEach(function (el, index) {
      box = _lib.UNDEF;

      if (!data || Array.isArray(data) && data.length === 0) {
        box = side;
      } else {
        if (!config.tracks[counter].thickness) {
          config.tracks[counter].thickness = trackthickness;
        }

        box = (config.innerradius + (counter + 1) * trackthickness + counter * config.trackmargin) * 2;
      }

      el.setNodePath(box, trackthickness, config);
      counter += 1;
      counter %= config.rings;

      if (index === _this2.getChildren('dataset').length - 1) {
        el.config.isLast = true;
      }
    });
    counter = 0; // Space management for plots

    this.getChildren('plot') && this.getChildren('plot').forEach(function (el) {
      box = _lib.UNDEF;

      if (!data || Array.isArray(data) && data.length === 0) {
        box = side;
      } else {
        if (!config.plots[counter].thickness) {
          config.plots[counter].thickness = trackthickness;
        }

        box = (config.innerradius + (counter + 1) * trackthickness + counter * config.trackmargin) * 2 - 2 * config.trackpadding;
      }

      el.setNodePath(box, barthickness, config);
      counter += 1;
      counter %= config.rings;
    });
  };

  _proto._postSpaceManagement = function _postSpaceManagement() {
    this.allocateDimensionOfChartMenuBar();
    this.config.showLegend && this.getChildren('legend') && this.getChildren('legend')[0].postSpaceManager();
  }
  /**
    * Creates the node container group svg element and takes
    * care of registering the mouse events on the chart.
    *
    * @memberof RadialBar
    */
  ;

  _proto.draw = function draw() {
    _CommonAPI.prototype.draw.call(this);

    var node = this,
        animationManager = this.getFromEnv('animationManager'),
        element = this.getChildContainer('node-container'),
        ticksContainer = this.getChildContainer('ticks-container'); // Creating the 'node-container' element

    node.addChildContainer('node-container', animationManager.setAnimation({
      el: element || 'group',
      component: node,
      label: 'node-container',
      id: 'node-container',
      attr: {
        name: 'node-container'
      },
      container: this.getChildContainer('plotGroup')
    })); // Creating the 'ticks-container' for drawing ticks and tick values

    node.addChildContainer('ticks-container', animationManager.setAnimation({
      el: ticksContainer || 'group',
      component: node,
      label: 'ticks-container',
      id: 'ticks-container',
      attr: {
        name: 'ticks-container'
      },
      container: this.getChildContainer('node-container')
    })); // Adding event listeners for the data plots

    for (var i = 0; i < this.config.plots.length && i < this.config.tracks.length; i++) {
      var currentPlot = this.getChildren('plot')[i];
      this.addExtEventListener('fc-mouseover', currentPlot._mouseOverHandler, currentPlot);
      this.addExtEventListener('fc-mouseout', currentPlot._mouseOutHandler, currentPlot);
      this.addExtEventListener('fc-click', currentPlot._mouseClickHandler, currentPlot);
    } // Adding the context label text element


    if (!this.config.defaultcontextlabel) {
      this.config.defaultcontextlabel = '';
    }

    this.drawContextLabel(this.config.defaultcontextlabel);
  }
  /**
    * creates the chart labels
    * @param {RadialTrack} track the track instance for which label is being drawn
    * @param {RadialBarPlot} plot the plot instance for which label is being drawn
    * @memberof RadialBar
    */
  ;

  _proto.drawLabel = function drawLabel(track, plot) {
    var chartConfig = this.getFromEnv('chartConfig'),
        animationManager = this.getFromEnv('animationManager'),
        toolTipController = this.getFromEnv('toolTipController'),
        smartLabel = this.getFromEnv('smartLabel'),
        config = this.config,
        canvasLeft = chartConfig.canvasLeft,
        canvasTop = chartConfig.canvasTop,
        availableWidth = chartConfig.canvasWidth,
        availableHeight = chartConfig.canvasHeight,
        centerX = canvasLeft + availableWidth / 2,
        centerY = canvasTop + availableHeight / 2,
        startAngle = (0, _polarUtil.changeAngleBase)(track.config.startingAngle),
        endingAngle = (0, _polarUtil.changeAngleBase)(track.config.endingAngle),
        endAngle = startAngle === endingAngle ? endingAngle - 0.1 : endingAngle,
        labelFontSize = track.config.thickness - config.labelpadding.top - config.labelpadding.bottom,
        labelFontColor = config.usedataplotcolorforlabels ? plot.config.color : config.style.inCancolor,
        labelTextObj,
        theta,
        labelText = config.labeltext,
        iconSize,
        labelGraphicsAttr,
        plotIdentifierShow = labelText.toLowerCase().indexOf('$plotidentifier') > -1,
        plotIdSvgString,
        radius,
        showIcon = this.config.showlabelicon;
    plot.config.labelFontSize = labelFontSize = labelFontSize < 5 ? track.config.thickness : labelFontSize;
    iconSize = labelFontSize * parseInt(config.iconscale, 10) / 100; // adding iconSize validation

    if (iconSize >= Math.abs(config.innerradius - config.outerradius)) {
      iconSize = labelFontSize;
    }

    iconSize = iconSize < 0 ? labelFontSize : iconSize; // Remove the existing label

    if (plot.label) {
      this.removeGraphicalElement(plot.label);
    } // Remove the existing icon


    if (plot.iconImage) {
      this.removeGraphicalElement(plot.iconImage);
    } // Remove the existing plot identifier


    if (plot.plotIdentifier) {
      this.removeGraphicalElement(plot.plotIdentifier);
    } // Remove the existing label [if it was a div]


    if (plot.labelDiv) {
      this.getFromEnv('chart-container').removeChild(plot.labelDiv);
      delete plot.labelDiv;
    }

    if (config.placevaluesinside) {
      // This block is for when the labels are curved, inside the track.
      // If no labels are present the icon are by default at the start position
      if (!config.showlabels || labelText.length === 0) {
        config.iconposition = 'start';
      } // Getting the plotidentifier svg separately & removing it from labelText


      if (plotIdentifierShow) {
        labelText = labelText.toLowerCase().replace('$plotidentifier', '');
        plotIdSvgString = plot.getParsedText('$plotIdentifier', false, labelFontSize);
      } // Getting the parsed text


      labelText = plot.getParsedText(labelText, false, labelFontSize) || track.config.label;
      /** Below is the code for placement of the three components of the labels
       * namely - icon, plotIdentifier and the text.
       */
      // ===== PLACING THE ICON =====
      // We need to place the icon first for two conditions - [iconposition = end, labelposition = end]
      // and [iconposition = start, labelposition = start]. For other conditions we will place the icon
      // after the text is placed.

      if (config.showlabelicon && track.config.iconurl) {
        if (config.iconposition !== 'end') {
          var iconRotation, iconCoords, iconTransform;

          if (config.labelposition === 'end') {
            // iconposition = start, labelposition = end
            radius = track.config.innerRadius + (track.config.thickness - iconSize) / 2;
            iconRotation = (0, _polarUtil.normaliseAngle)(endAngle) - track.config.paddingAngle;
            iconCoords = (0, _polarUtil.pointOnCircleFromCenter)(centerX, centerY, radius, iconRotation);
            iconTransform = "R" + (iconRotation - 180) + ", " + iconCoords.x + ", " + iconCoords.y;
          } else {
            // iconposition = start, labelposition = start
            radius = track.config.outerRadius - (track.config.thickness - iconSize) / 2;
            iconRotation = (0, _polarUtil.normaliseAngle)(startAngle) + track.config.paddingAngle;
            iconCoords = (0, _polarUtil.pointOnCircleFromCenter)(centerX, centerY, radius, iconRotation);
            iconTransform = "R" + iconRotation + ", " + iconCoords.x + ", " + iconCoords.y;
          }

          plot.iconImage = animationManager.setAnimation({
            el: 'image',
            attr: {
              'src': track.config.iconurl,
              'x': iconCoords.x,
              'y': iconCoords.y,
              'width': iconSize,
              'height': iconSize,
              'transform': iconTransform
            },
            container: {
              id: 'node-container',
              isParent: true
            },
            component: this,
            label: 'image'
          });
          this.addGraphicalElement('iconImage', plot.iconImage, true);
        }
      } // ===== PLACING THE PLOT IDENTIFIER NEXT =====


      if (config.showlabels && plotIdentifierShow) {
        var el = document.createElement('div');
        el.innerHTML = _trustedPolicy.default.createHTML(plotIdSvgString);
        var pathElement = el.firstChild.firstElementChild || el.firstChild,
            pathAttributes = pathElement && pathElement.attributes,
            plotIdentifierAttr = {},
            path,
            legend = this.getFromEnv('legend'),
            legendItem = config.showLegend && legend.getItem(plot.config.legendItemId),
            graphicalElement = legendItem && legendItem.getGraphicalElement(),
            legendItemSymbol = graphicalElement && graphicalElement.legendItemSymbol,
            iconAngle = config.iconposition !== 'end' ? track.config.iconAngle : 0,
            symbolBBox = legendItemSymbol && legendItemSymbol.node.getBBox(),
            svgScale = 1,
            plotIdentifierCoords,
            plotIdentifierRotation;

        if (!symbolBBox) {
          symbolBBox = {
            width: labelFontSize
          };
        }

        if (labelFontSize && symbolBBox && labelFontSize < symbolBBox.height) {
          svgScale = labelFontSize / symbolBBox.height;
        }

        if (config.labelposition === 'end') {
          radius = track.config.innerRadius + (track.config.thickness - labelFontSize) / 2;
          plotIdentifierRotation = (0, _polarUtil.normaliseAngle)(endAngle) - track.config.paddingAngle - iconAngle;
          plotIdentifierCoords = (0, _polarUtil.pointOnCircleFromCenter)(centerX, centerY, radius, plotIdentifierRotation);
          plotIdentifierRotation -= 180;
        } else {
          radius = track.config.outerRadius - (track.config.thickness - labelFontSize) / 2;
          plotIdentifierRotation = (0, _polarUtil.normaliseAngle)(startAngle) + track.config.paddingAngle + iconAngle;
          plotIdentifierCoords = (0, _polarUtil.pointOnCircleFromCenter)(centerX, centerY, radius, plotIdentifierRotation);
        }

        if (pathElement.tagName === 'path') {
          for (var i = 0; i < pathAttributes.length; i++) {
            if (pathAttributes[i].name === 'd') {
              path = pathAttributes[i].nodeValue;
            } else {
              plotIdentifierAttr[pathAttributes[i].name] = pathAttributes[i].nodeValue;
            }
          }

          plotIdentifierAttr.path = path;
        } else {
          plotIdentifierAttr.path = "M0,0L" + labelFontSize + ",0," + labelFontSize + "," + labelFontSize + ",0," + labelFontSize + "Z";
          plotIdentifierAttr['stroke-width'] = 0.1;
          plotIdentifierAttr.fill = plot.config.realColor || plot.config.color;
        }

        plotIdentifierAttr.transform = "T" + plotIdentifierCoords.x + ", " + plotIdentifierCoords.y + " R" + plotIdentifierRotation + ", " + plotIdentifierCoords.x + ", " + plotIdentifierCoords.y + " S" + svgScale;
        plot.plotIdentifier = animationManager.setAnimation({
          el: 'path',
          attr: plotIdentifierAttr,
          container: {
            id: 'plot',
            isParent: true
          },
          label: 'plotIdentifier',
          component: this
        });
        this.addGraphicalElement('plotIdentifier', plot.plotIdentifier, true);
      } // ===== PLACING THE LABEL TEXT AFTER THAT =====


      if (config.showlabels && labelText.length > 0) {
        var trackArc = (0, _polarUtil.findArc)(startAngle, startAngle === endingAngle ? endingAngle - 0.1 : endingAngle),
            trackLength = 2 * Math.PI * track.config.innerRadius / 360 * trackArc; // update styles of smartLabel

        var labelStyle = {
          'font-family': config.style.inCanfontFamily,
          'font-size': labelFontSize,
          'line-height': labelFontSize * 1.2
        };
        smartLabel.setStyle(labelStyle);
        labelTextObj = smartLabel.getSmartText(labelText, trackLength - config.labelpadding.left - config.labelpadding.right - (config.showlabelicon ? iconSize + 15 : 0) - (plotIdentifierShow ? labelFontSize : 0), labelFontSize * 1.2, false);
        labelGraphicsAttr = {
          'text': labelTextObj.text,
          'x': track.config.path_d[1],
          'y': track.config.path_d[2],
          'fill': labelFontColor,
          'font-family': config.style.inCanfontFamily,
          'font-size': labelFontSize,
          'text-anchor': 'start',
          'textpath': {
            path: track.config.labelPath[config.labelposition][config.iconposition]
          }
        };
        plot.label = animationManager.setAnimation({
          el: 'text',
          attr: labelGraphicsAttr,
          container: {
            id: 'plot',
            isParent: true
          },
          label: 'label',
          component: this
        });
        this.addGraphicalElement('trackLabel', plot.label, true);
      } // ===== PLACING THE ICON =====
      // We need to place the icon after the text is placed for for these two conditions -
      // [iconposition = end, labelposition = start] and [iconposition = end, labelposition = end].
      // For other conditions we icon placement has been done above.


      if (config.showlabelicon && track.config.iconurl) {
        if (config.iconposition === 'end') {
          var _iconRotation,
              _iconCoords,
              _iconTransform,
              numberOfChars = plot.label.node.getNumberOfChars() - 1;

          if (config.labelposition === 'start') {
            // iconposition = end, labelposition = start
            radius = track.config.outerRadius - (track.config.thickness - iconSize) / 2;
            _iconRotation = plot.label.node.getRotationOfChar(numberOfChars) + track.config.iconAngle;
            _iconCoords = (0, _polarUtil.pointOnCircleFromCenter)(centerX, centerY, radius, _iconRotation);
            _iconTransform = "R" + _iconRotation + ", " + _iconCoords.x + ", " + _iconCoords.y;
          } else {
            // iconposition = end, labelposition = end
            radius = track.config.innerRadius + (track.config.thickness - iconSize) / 2;
            _iconRotation = plot.label.node.getRotationOfChar(numberOfChars) - 180 - track.config.iconAngle;
            _iconCoords = (0, _polarUtil.pointOnCircleFromCenter)(centerX, centerY, radius, _iconRotation);
            _iconTransform = "R" + (_iconRotation - 180) + ", " + _iconCoords.x + ", " + _iconCoords.y;
          }

          plot.iconImage = animationManager.setAnimation({
            el: 'image',
            attr: {
              'src': track.config.iconurl,
              'x': _iconCoords.x,
              'y': _iconCoords.y,
              'width': iconSize,
              'height': iconSize,
              'transform': _iconTransform
            },
            container: {
              id: 'node-container',
              isParent: true
            },
            component: this,
            label: 'image'
          });
          this.addGraphicalElement('iconImage', plot.iconImage, true);
        }
      }
    } else if (startAngle !== endingAngle) {
      // For labels outside
      var newRadius,
          iconAttr = {},
          labelTextAttr = {},
          _plotIdentifierAttr = {},
          distance = 0;

      if (config.labelposition === 'end') {
        if (endAngle >= 0 && endAngle < 180 || endAngle === 360) {
          if (config.iconposition === 'end') {
            // labelposition end angle 0-180
            // iconposition end => place plotIdentifier, place text, place icon
            distance = distance + config.labelpadding.left;

            if (plotIdentifierShow && config.showlabels) {
              var _el = document.createElement('div');

              _el.innerHTML = _trustedPolicy.default.createHTML(plot.getParsedText('$plotIdentifier'));

              var _pathElement = _el.firstChild.firstElementChild || _el.firstChild,
                  _pathAttributes = _pathElement && _pathElement.attributes,
                  _path,
                  _legend = this.getFromEnv('legend'),
                  _legendItem = config.showLegend && _legend.getItem(plot.config.legendItemId),
                  _graphicalElement = _legendItem && _legendItem.getGraphicalElement(),
                  _legendItemSymbol = _graphicalElement && _graphicalElement.legendItemSymbol,
                  _symbolBBox = _legendItemSymbol && _legendItemSymbol.node.getBBox(),
                  _svgScale = 1,
                  _plotIdentifierCoords;

              distance = distance + labelFontSize / 2;
              newRadius = Math.sqrt(Math.pow(track.config.outerRadius - track.config.thickness / 2, 2) + Math.pow(distance, 2));
              theta = Math.atan(distance / track.config.outerRadius) * (180 / Math.PI);
              _plotIdentifierCoords = (0, _polarUtil.pointOnCircleFromCenter)(centerX, centerY, newRadius, (0, _polarUtil.normaliseAngle)(endAngle) + theta);

              if (!_symbolBBox) {
                _symbolBBox = {
                  width: labelFontSize
                };
              }

              if (labelFontSize && _symbolBBox && labelFontSize < _symbolBBox.height) {
                _svgScale = labelFontSize / _symbolBBox.height;
              }

              if (_pathElement.tagName === 'path') {
                for (var _i = 0; _i < _pathAttributes.length; _i++) {
                  if (_pathAttributes[_i].name === 'd') {
                    _path = _pathAttributes[_i].nodeValue;
                  } else {
                    _plotIdentifierAttr[_pathAttributes[_i].name] = _pathAttributes[_i].nodeValue;
                  }
                }

                _plotIdentifierAttr.path = _path;
              } else {
                _plotIdentifierAttr.path = "M0,0L" + labelFontSize + ",0," + labelFontSize + "," + labelFontSize + ",0," + labelFontSize + "Z";
                _plotIdentifierAttr['stroke-width'] = 0.1;
                _plotIdentifierAttr.fill = plot.config.realColor || plot.config.color;
              }

              _plotIdentifierAttr.transform = "T" + (_plotIdentifierCoords.x - _symbolBBox.width * _svgScale / 2) + ", " + (_plotIdentifierCoords.y - _symbolBBox.height * _svgScale / 2) + " R" + (endAngle - 90) + ", " + _plotIdentifierCoords.x + ", " + _plotIdentifierCoords.y + " S" + _svgScale;
              this.addPlotIdentifier(_plotIdentifierAttr, plot); // Adding the space taken by the plot identifier to the distance for the next element

              distance = distance + labelFontSize + 1;
            }

            if (config.showlabels) {
              radius = track.config.outerRadius - (track.config.thickness - labelFontSize) / 2 - labelFontSize / 2;
              newRadius = Math.sqrt(Math.pow(radius, 2) + Math.pow(distance, 2));
              theta = Math.atan(distance / track.config.outerRadius) * (180 / Math.PI);
              labelText = plot.getParsedText(labelText.replace('$plotIdentifier', '').replace('$plotidentifier', ''));
              var labelCoords = (0, _polarUtil.pointOnCircleFromCenter)(centerX, centerY, newRadius, (0, _polarUtil.normaliseAngle)(endAngle) + theta),
                  labelLength; // update styles of smartLabel

              var _labelStyle = {
                'font-family': config.style.inCanfontFamily,
                'font-size': labelFontSize,
                'line-height': labelFontSize * 1.2
              };
              smartLabel.setStyle(_labelStyle);
              labelTextObj = smartLabel.getSmartText(labelText, config.outerradius, labelFontSize * 1.2, false);
              labelTextAttr.x = labelCoords.x;
              labelTextAttr.y = labelCoords.y;
              labelTextAttr.fill = labelFontColor;
              labelTextAttr['font-family'] = config.style.inCanfontFamily;
              labelTextAttr['font-size'] = labelFontSize;
              labelTextAttr['text-anchor'] = 'start';
              labelTextAttr.transform = "R" + (endAngle - 90) + ", " + labelTextAttr.x + ", " + labelTextAttr.y;
              labelTextAttr.text = labelTextObj.text;
              labelLength = this.addLabel(labelTextAttr, plot);
              distance = distance + labelLength;
            }

            if (showIcon && track.config.iconurl) {
              distance = distance + ICON_PADDING;
              newRadius = Math.sqrt(Math.pow(track.config.outerRadius + (track.config.thickness - labelFontSize) / 2, 2) + Math.pow(distance, 2));
              theta = Math.atan(distance / track.config.outerRadius) * (180 / Math.PI);
              iconAttr.iconCoords = (0, _polarUtil.pointOnCircleFromCenter)(centerX, centerY, newRadius, (0, _polarUtil.normaliseAngle)(endAngle) + theta);
              iconAttr.transform = "R" + (endAngle - 90) + ", " + iconAttr.iconCoords.x + ", " + iconAttr.iconCoords.y;
              iconAttr.iconSize = labelFontSize;
              this.addIcon(iconAttr, plot, track);
            }
          } else {
            // labelposition end angle 0-180
            // iconposition start => place icon, place plotIdentifier, place text
            distance = distance + config.labelpadding.left;

            if (showIcon) {
              if (track.config.iconurl) {
                newRadius = Math.sqrt(Math.pow(track.config.outerRadius + (track.config.thickness - labelFontSize) / 2, 2) + Math.pow(distance, 2));
                theta = Math.atan(distance / track.config.outerRadius) * (180 / Math.PI);
                iconAttr.iconCoords = (0, _polarUtil.pointOnCircleFromCenter)(centerX, centerY, newRadius, (0, _polarUtil.normaliseAngle)(endAngle) + theta);
                iconAttr.transform = "R" + (endAngle - 90) + ", " + iconAttr.iconCoords.x + ", " + iconAttr.iconCoords.y;
                iconAttr.iconSize = labelFontSize;
                this.addIcon(iconAttr, plot, track);
              }

              distance = distance + labelFontSize + ICON_PADDING;
            }

            if (plotIdentifierShow && config.showlabels) {
              distance = distance + labelFontSize / 2;

              var _el2 = document.createElement('div');

              _el2.innerHTML = _trustedPolicy.default.createHTML(plot.getParsedText('$plotIdentifier'));

              var _pathElement2 = _el2.firstChild.firstElementChild || _el2.firstChild,
                  _pathAttributes2 = _pathElement2 && _pathElement2.attributes,
                  _path2,
                  _legend2 = this.getFromEnv('legend'),
                  _legendItem2 = config.showLegend && _legend2.getItem(plot.config.legendItemId),
                  _graphicalElement2 = _legendItem2 && _legendItem2.getGraphicalElement(),
                  _legendItemSymbol2 = _graphicalElement2 && _graphicalElement2.legendItemSymbol,
                  _symbolBBox2 = _legendItemSymbol2 && _legendItemSymbol2.node.getBBox(),
                  _svgScale2 = 1,
                  _plotIdentifierCoords2;

              newRadius = Math.sqrt(Math.pow(track.config.outerRadius - track.config.thickness / 2, 2) + Math.pow(distance, 2));
              theta = Math.atan(distance / track.config.outerRadius) * (180 / Math.PI);
              _plotIdentifierCoords2 = (0, _polarUtil.pointOnCircleFromCenter)(centerX, centerY, newRadius, (0, _polarUtil.normaliseAngle)(endAngle) + theta);

              if (!_symbolBBox2) {
                _symbolBBox2 = {
                  width: labelFontSize
                };
              }

              if (labelFontSize && _symbolBBox2 && labelFontSize < _symbolBBox2.height) {
                _svgScale2 = labelFontSize / _symbolBBox2.height;
              }

              if (_pathElement2.tagName === 'path') {
                for (var _i2 = 0; _i2 < _pathAttributes2.length; _i2++) {
                  if (_pathAttributes2[_i2].name === 'd') {
                    _path2 = _pathAttributes2[_i2].nodeValue;
                  } else {
                    _plotIdentifierAttr[_pathAttributes2[_i2].name] = _pathAttributes2[_i2].nodeValue;
                  }
                }

                _plotIdentifierAttr.path = _path2;
              } else {
                _plotIdentifierAttr.path = "M0,0L" + labelFontSize + ",0," + labelFontSize + "," + labelFontSize + ",0," + labelFontSize + "Z";
                _plotIdentifierAttr['stroke-width'] = 0.1;
                _plotIdentifierAttr.fill = plot.config.realColor || plot.config.color;
              }

              _plotIdentifierAttr.transform = "T" + (_plotIdentifierCoords2.x - _symbolBBox2.width * _svgScale2 / 2) + ", " + (_plotIdentifierCoords2.y - _symbolBBox2.height * _svgScale2 / 2) + " R" + (endAngle - 90) + ", " + _plotIdentifierCoords2.x + ", " + _plotIdentifierCoords2.y + " S" + _svgScale2;
              this.addPlotIdentifier(_plotIdentifierAttr, plot); // Adding the space taken by the plot identifier to the distance for the next element

              distance = distance + labelFontSize;
            }

            if (config.showlabels) {
              radius = track.config.outerRadius - (track.config.thickness - labelFontSize) / 2 - labelFontSize / 2;
              newRadius = Math.sqrt(Math.pow(radius, 2) + Math.pow(distance, 2));
              theta = Math.atan(distance / radius) * (180 / Math.PI);
              labelText = plot.getParsedText(labelText.replace('$plotIdentifier', '').replace('$plotidentifier', ''));

              var _labelCoords = (0, _polarUtil.pointOnCircleFromCenter)(centerX, centerY, newRadius, (0, _polarUtil.normaliseAngle)(endAngle) + theta); // update styles of smartLabel


              var _labelStyle2 = {
                'font-family': config.style.inCanfontFamily,
                'font-size': labelFontSize,
                'line-height': labelFontSize * 1.2
              };
              smartLabel.setStyle(_labelStyle2);
              labelTextObj = smartLabel.getSmartText(labelText, config.outerradius, labelFontSize * 1.2, false);
              labelTextAttr.x = _labelCoords.x;
              labelTextAttr.y = _labelCoords.y;
              labelTextAttr.fill = labelFontColor;
              labelTextAttr['font-family'] = config.style.inCanfontFamily;
              labelTextAttr['font-size'] = labelFontSize;
              labelTextAttr['text-anchor'] = 'start';
              labelTextAttr.transform = "R" + (endAngle - 90) + ", " + labelTextAttr.x + ", " + labelTextAttr.y;
              labelTextAttr.text = labelTextObj.text;
              this.addLabel(labelTextAttr, plot);
            }
          }
        } else if (endAngle >= 180 && endAngle < 360) {
          if (config.iconposition === 'end') {
            // labelposition end angle 180-360
            // iconposition end => place icon, place plotIdentifier, place text
            distance = distance - config.labelpadding.right;

            if (showIcon) {
              distance = distance - labelFontSize;

              if (track.config.iconurl) {
                newRadius = Math.sqrt(Math.pow(track.config.innerRadius - (track.config.thickness - labelFontSize) / 2, 2) + Math.pow(distance, 2));
                theta = Math.atan(distance / track.config.innerRadius) * (180 / Math.PI);
                iconAttr.iconCoords = (0, _polarUtil.pointOnCircleFromCenter)(centerX, centerY, newRadius, (0, _polarUtil.normaliseAngle)(endAngle) - theta);
                iconAttr.transform = "R" + (endAngle + 90) + ", " + iconAttr.iconCoords.x + ", " + iconAttr.iconCoords.y;
                iconAttr.iconSize = labelFontSize;
                this.addIcon(iconAttr, plot, track);
              }

              distance = distance - ICON_PADDING;
            }

            if (config.showlabels) {
              radius = track.config.innerRadius + (track.config.thickness - labelFontSize) / 2 + labelFontSize / 2;
              newRadius = Math.sqrt(Math.pow(radius, 2) + Math.pow(distance, 2));
              theta = Math.atan(distance / radius) * (180 / Math.PI);
              labelText = plot.getParsedText(labelText.replace('$plotIdentifier', '').replace('$plotidentifier', ''));

              var _labelCoords2 = (0, _polarUtil.pointOnCircleFromCenter)(centerX, centerY, newRadius, (0, _polarUtil.normaliseAngle)(endAngle) - theta),
                  _labelLength; // update styles of smartLabel


              var _labelStyle3 = {
                'font-family': config.style.inCanfontFamily,
                'font-size': labelFontSize,
                'line-height': labelFontSize * 1.2
              };
              smartLabel.setStyle(_labelStyle3);
              labelTextObj = smartLabel.getSmartText(labelText, config.outerradius, labelFontSize * 1.2, false);
              labelTextAttr.x = _labelCoords2.x;
              labelTextAttr.y = _labelCoords2.y;
              labelTextAttr.fill = labelFontColor;
              labelTextAttr['font-family'] = config.style.inCanfontFamily;
              labelTextAttr['font-size'] = labelFontSize;
              labelTextAttr['text-anchor'] = 'end';
              labelTextAttr.transform = "R" + (endAngle + 90) + ", " + labelTextAttr.x + ", " + labelTextAttr.y;
              labelTextAttr.text = labelTextObj.text;
              _labelLength = this.addLabel(labelTextAttr, plot);
              distance = distance - _labelLength - labelFontSize;
            }

            if (plotIdentifierShow && config.showlabels) {
              var _el3 = document.createElement('div');

              _el3.innerHTML = _trustedPolicy.default.createHTML(plot.getParsedText('$plotIdentifier'));

              var _pathElement3 = _el3.firstChild.firstElementChild || _el3.firstChild,
                  _pathAttributes3 = _pathElement3 && _pathElement3.attributes,
                  _path3,
                  _legend3 = this.getFromEnv('legend'),
                  _legendItem3 = config.showLegend && _legend3.getItem(plot.config.legendItemId),
                  _graphicalElement3 = _legendItem3 && _legendItem3.getGraphicalElement(),
                  _legendItemSymbol3 = _graphicalElement3 && _graphicalElement3.legendItemSymbol,
                  _symbolBBox3 = _legendItemSymbol3 && _legendItemSymbol3.node.getBBox(),
                  _svgScale3 = 1,
                  _plotIdentifierCoords3;

              newRadius = Math.sqrt(Math.pow(track.config.innerRadius + track.config.thickness / 2, 2) + Math.pow(distance, 2));
              theta = Math.atan(distance / track.config.innerRadius) * (180 / Math.PI);
              _plotIdentifierCoords3 = (0, _polarUtil.pointOnCircleFromCenter)(centerX, centerY, newRadius, (0, _polarUtil.normaliseAngle)(endAngle) - theta);

              if (!_symbolBBox3) {
                _symbolBBox3 = {
                  width: labelFontSize
                };
              }

              if (labelFontSize && _symbolBBox3 && labelFontSize < _symbolBBox3.height) {
                _svgScale3 = labelFontSize / _symbolBBox3.height;
              }

              if (_pathElement3.tagName === 'path') {
                for (var _i3 = 0; _i3 < _pathAttributes3.length; _i3++) {
                  if (_pathAttributes3[_i3].name === 'd') {
                    _path3 = _pathAttributes3[_i3].nodeValue;
                  } else {
                    _plotIdentifierAttr[_pathAttributes3[_i3].name] = _pathAttributes3[_i3].nodeValue;
                  }
                }

                _plotIdentifierAttr.path = _path3;
              } else {
                _plotIdentifierAttr.path = "M0,0L" + labelFontSize + ",0," + labelFontSize + "," + labelFontSize + ",0," + labelFontSize + "Z";
                _plotIdentifierAttr['stroke-width'] = 0.1;
                _plotIdentifierAttr.fill = plot.config.realColor || plot.config.color;
              }

              _plotIdentifierAttr.transform = "T" + (_plotIdentifierCoords3.x - _symbolBBox3.width * _svgScale3 / 2) + ", " + (_plotIdentifierCoords3.y - _symbolBBox3.height * _svgScale3 / 2) + " R" + (endAngle + 90) + ", " + _plotIdentifierCoords3.x + ", " + _plotIdentifierCoords3.y + " S" + _svgScale3;
              this.addPlotIdentifier(_plotIdentifierAttr, plot);
            }
          } else {
            // labelposition end angle 180-360
            // iconposition start => place text, place plotIdentifier, place icon
            distance = distance - config.labelpadding.right;

            if (config.showlabels) {
              radius = track.config.innerRadius + (track.config.thickness - labelFontSize) / 2 + labelFontSize / 2;
              newRadius = Math.sqrt(Math.pow(radius, 2) + Math.pow(distance, 2));
              theta = Math.atan(distance / radius) * (180 / Math.PI);
              labelText = plot.getParsedText(labelText.replace('$plotIdentifier', '').replace('$plotidentifier', ''));

              var _labelCoords3 = (0, _polarUtil.pointOnCircleFromCenter)(centerX, centerY, newRadius, (0, _polarUtil.normaliseAngle)(endAngle) - theta),
                  _labelLength2; // update styles of smartLabel


              var _labelStyle4 = {
                'font-family': config.style.inCanfontFamily,
                'font-size': labelFontSize,
                'line-height': labelFontSize * 1.2
              };
              smartLabel.setStyle(_labelStyle4);
              labelTextObj = smartLabel.getSmartText(labelText, config.outerradius, labelFontSize * 1.2, false);
              labelTextAttr.x = _labelCoords3.x;
              labelTextAttr.y = _labelCoords3.y;
              labelTextAttr.fill = labelFontColor;
              labelTextAttr['font-family'] = config.style.inCanfontFamily;
              labelTextAttr['font-size'] = labelFontSize;
              labelTextAttr['text-anchor'] = 'end';
              labelTextAttr.transform = "R" + (endAngle + 90) + ", " + labelTextAttr.x + ", " + labelTextAttr.y;
              labelTextAttr.text = labelTextObj.text;
              _labelLength2 = this.addLabel(labelTextAttr, plot);
              distance = distance - _labelLength2 - labelFontSize;
            }

            if (plotIdentifierShow && config.showlabels) {
              var _el4 = document.createElement('div');

              _el4.innerHTML = _trustedPolicy.default.createHTML(plot.getParsedText('$plotIdentifier'));

              var _pathElement4 = _el4.firstChild.firstElementChild || _el4.firstChild,
                  _pathAttributes4 = _pathElement4 && _pathElement4.attributes,
                  _path4,
                  _legend4 = this.getFromEnv('legend'),
                  _legendItem4 = config.showLegend && _legend4.getItem(plot.config.legendItemId),
                  _graphicalElement4 = _legendItem4 && _legendItem4.getGraphicalElement(),
                  _legendItemSymbol4 = _graphicalElement4 && _graphicalElement4.legendItemSymbol,
                  _symbolBBox4 = _legendItemSymbol4 && _legendItemSymbol4.node.getBBox(),
                  _svgScale4 = 1,
                  _plotIdentifierCoords4;

              newRadius = Math.sqrt(Math.pow(track.config.innerRadius + track.config.thickness / 2, 2) + Math.pow(distance, 2));
              theta = Math.atan(distance / track.config.innerRadius) * (180 / Math.PI);
              _plotIdentifierCoords4 = (0, _polarUtil.pointOnCircleFromCenter)(centerX, centerY, newRadius, (0, _polarUtil.normaliseAngle)(endAngle) - theta);

              if (!_symbolBBox4) {
                _symbolBBox4 = {
                  width: labelFontSize
                };
              }

              if (labelFontSize && _symbolBBox4 && labelFontSize < _symbolBBox4.height) {
                _svgScale4 = labelFontSize / _symbolBBox4.height;
              }

              if (_pathElement4.tagName === 'path') {
                for (var _i4 = 0; _i4 < _pathAttributes4.length; _i4++) {
                  if (_pathAttributes4[_i4].name === 'd') {
                    _path4 = _pathAttributes4[_i4].nodeValue;
                  } else {
                    _plotIdentifierAttr[_pathAttributes4[_i4].name] = _pathAttributes4[_i4].nodeValue;
                  }
                }

                _plotIdentifierAttr.path = _path4;
              } else {
                _plotIdentifierAttr.path = "M0,0L" + labelFontSize + ",0," + labelFontSize + "," + labelFontSize + ",0," + labelFontSize + "Z";
                _plotIdentifierAttr['stroke-width'] = 0.1;
                _plotIdentifierAttr.fill = plot.config.realColor || plot.config.color;
              }

              _plotIdentifierAttr.transform = "T" + (_plotIdentifierCoords4.x - _symbolBBox4.width * _svgScale4 / 2) + ", " + (_plotIdentifierCoords4.y - _symbolBBox4.height * _svgScale4 / 2) + " R" + (endAngle + 90) + ", " + _plotIdentifierCoords4.x + ", " + _plotIdentifierCoords4.y + " S" + _svgScale4;
              this.addPlotIdentifier(_plotIdentifierAttr, plot);
              distance = distance - labelFontSize;
            }

            if (showIcon) {
              if (track.config.iconurl) {
                distance = distance - ICON_PADDING;
                newRadius = Math.sqrt(Math.pow(track.config.innerRadius - (track.config.thickness - labelFontSize) / 2, 2) + Math.pow(distance, 2));
                theta = Math.atan(distance / track.config.innerRadius) * (180 / Math.PI);
                iconAttr.iconCoords = (0, _polarUtil.pointOnCircleFromCenter)(centerX, centerY, newRadius, (0, _polarUtil.normaliseAngle)(endAngle) - theta);
                iconAttr.transform = "R" + (endAngle + 90) + ", " + iconAttr.iconCoords.x + ", " + iconAttr.iconCoords.y;
                iconAttr.iconSize = labelFontSize;
                this.addIcon(iconAttr, plot, track);
              }
            }
          }
        }
      } else {
        if (startAngle >= 0 && startAngle < 180 || startAngle === 360) {
          if (config.iconposition === 'end') {
            // labelposition start angle 0-180
            // iconposition end => place icon, place plotIdentifier, place text
            distance = distance + config.labelpadding.right;

            if (showIcon) {
              distance = distance + labelFontSize;

              if (track.config.iconurl) {
                newRadius = Math.sqrt(Math.pow(track.config.outerRadius - (track.config.thickness - labelFontSize) / 2, 2) + Math.pow(distance, 2));
                theta = Math.atan(distance / track.config.outerRadius) * (180 / Math.PI);
                iconAttr.iconCoords = (0, _polarUtil.pointOnCircleFromCenter)(centerX, centerY, newRadius, (0, _polarUtil.normaliseAngle)(startAngle) - theta);
                iconAttr.transform = "R" + (startAngle - 90) + ", " + iconAttr.iconCoords.x + ", " + iconAttr.iconCoords.y;
                iconAttr.iconSize = labelFontSize;
                this.addIcon(iconAttr, plot, track);
              }

              distance = distance + ICON_PADDING;
            }

            if (plotIdentifierShow && config.showlabels) {
              var _el5 = document.createElement('div');

              _el5.innerHTML = _trustedPolicy.default.createHTML(plot.getParsedText('$plotIdentifier'));

              var _pathElement5 = _el5.firstChild.firstElementChild || _el5.firstChild,
                  _pathAttributes5 = _pathElement5 && _pathElement5.attributes,
                  _path5,
                  _legend5 = this.getFromEnv('legend'),
                  _legendItem5 = config.showLegend && _legend5.getItem(plot.config.legendItemId),
                  _graphicalElement5 = _legendItem5 && _legendItem5.getGraphicalElement(),
                  _legendItemSymbol5 = _graphicalElement5 && _graphicalElement5.legendItemSymbol,
                  _symbolBBox5 = _legendItemSymbol5 && _legendItemSymbol5.node.getBBox(),
                  _svgScale5 = 1,
                  _plotIdentifierCoords5;

              newRadius = Math.sqrt(Math.pow(track.config.outerRadius - track.config.thickness / 2, 2) + Math.pow(distance, 2));
              theta = Math.atan(distance / track.config.outerRadius) * (180 / Math.PI);
              _plotIdentifierCoords5 = (0, _polarUtil.pointOnCircleFromCenter)(centerX, centerY, newRadius, (0, _polarUtil.normaliseAngle)(startAngle) - theta);

              if (!_symbolBBox5) {
                _symbolBBox5 = {
                  width: labelFontSize
                };
              }

              if (labelFontSize && _symbolBBox5 && labelFontSize < _symbolBBox5.height) {
                _svgScale5 = labelFontSize / _symbolBBox5.height;
              }

              if (_pathElement5.tagName === 'path') {
                for (var _i5 = 0; _i5 < _pathAttributes5.length; _i5++) {
                  if (_pathAttributes5[_i5].name === 'd') {
                    _path5 = _pathAttributes5[_i5].nodeValue;
                  } else {
                    _plotIdentifierAttr[_pathAttributes5[_i5].name] = _pathAttributes5[_i5].nodeValue;
                  }
                }

                _plotIdentifierAttr.path = _path5;
              } else {
                _plotIdentifierAttr.path = "M0,0L" + labelFontSize + ",0," + labelFontSize + "," + labelFontSize + ",0," + labelFontSize + "Z";
                _plotIdentifierAttr['stroke-width'] = 0.1;
                _plotIdentifierAttr.fill = plot.config.realColor || plot.config.color;
              }

              _plotIdentifierAttr.transform = "T" + (_plotIdentifierCoords5.x - _symbolBBox5.width * _svgScale5 / 2) + ", " + (_plotIdentifierCoords5.y - _symbolBBox5.height * _svgScale5 / 2) + " R" + (startAngle - 90) + ", " + _plotIdentifierCoords5.x + ", " + _plotIdentifierCoords5.y + " S" + _svgScale5;
              this.addPlotIdentifier(_plotIdentifierAttr, plot); // Adding the space taken by the plot identifier to the distance for the next element

              distance = distance + labelFontSize;
            }

            if (config.showlabels) {
              radius = track.config.outerRadius - (track.config.thickness - labelFontSize) / 2 - labelFontSize / 2;
              newRadius = Math.sqrt(Math.pow(radius, 2) + Math.pow(distance, 2));
              theta = Math.atan(distance / radius) * (180 / Math.PI);
              labelText = plot.getParsedText(labelText.replace('$plotIdentifier', '').replace('$plotidentifier', ''));

              var _labelCoords4 = (0, _polarUtil.pointOnCircleFromCenter)(centerX, centerY, newRadius, (0, _polarUtil.normaliseAngle)(startAngle) - theta); // update styles of smartLabel


              var _labelStyle5 = {
                'font-family': config.style.inCanfontFamily,
                'font-size': labelFontSize,
                'line-height': labelFontSize * 1.2
              };
              smartLabel.setStyle(_labelStyle5);
              labelTextObj = smartLabel.getSmartText(labelText, config.outerradius, labelFontSize * 1.2, false);
              labelTextAttr.x = _labelCoords4.x;
              labelTextAttr.y = _labelCoords4.y;
              labelTextAttr.fill = labelFontColor;
              labelTextAttr['font-family'] = config.style.inCanfontFamily;
              labelTextAttr['font-size'] = labelFontSize;
              labelTextAttr['text-anchor'] = 'end';
              labelTextAttr.transform = "R" + (startAngle - 90) + ", " + labelTextAttr.x + ", " + labelTextAttr.y;
              labelTextAttr.text = labelTextObj.text;
              this.addLabel(labelTextAttr, plot);
            }
          } else {
            // labelposition start angle 0-180
            // iconposition start => place text, place plotIdentifier, place icon
            if (config.showlabels) {
              distance = distance + config.labelpadding.right;
              radius = track.config.outerRadius - (track.config.thickness - labelFontSize) / 2 - labelFontSize / 2;
              newRadius = Math.sqrt(Math.pow(radius, 2) + Math.pow(distance, 2));
              theta = Math.atan(distance / radius) * (180 / Math.PI);
              labelText = plot.getParsedText(labelText.replace('$plotIdentifier', '').replace('$plotidentifier', ''));

              var _labelCoords5 = (0, _polarUtil.pointOnCircleFromCenter)(centerX, centerY, newRadius, (0, _polarUtil.normaliseAngle)(startAngle) - theta),
                  _labelLength3; // update styles of smartLabel


              var _labelStyle6 = {
                'font-family': config.style.inCanfontFamily,
                'font-size': labelFontSize,
                'line-height': labelFontSize * 1.2
              };
              smartLabel.setStyle(_labelStyle6);
              labelTextObj = smartLabel.getSmartText(labelText, config.outerradius, labelFontSize * 1.2, false);
              labelTextAttr.x = _labelCoords5.x;
              labelTextAttr.y = _labelCoords5.y;
              labelTextAttr.fill = labelFontColor;
              labelTextAttr['font-family'] = config.style.inCanfontFamily;
              labelTextAttr['font-size'] = labelFontSize;
              labelTextAttr['text-anchor'] = 'end';
              labelTextAttr.transform = "R" + (startAngle - 90) + ", " + labelTextAttr.x + ", " + labelTextAttr.y;
              labelTextAttr.text = labelTextObj.text;
              _labelLength3 = this.addLabel(labelTextAttr, plot);
              distance = distance + _labelLength3;
            }

            if (plotIdentifierShow && config.showlabels) {
              distance = distance + labelFontSize;

              var _el6 = document.createElement('div');

              _el6.innerHTML = _trustedPolicy.default.createHTML(plot.getParsedText('$plotIdentifier'));

              var _pathElement6 = _el6.firstChild.firstElementChild || _el6.firstChild,
                  _pathAttributes6 = _pathElement6 && _pathElement6.attributes,
                  _path6,
                  _legend6 = this.getFromEnv('legend'),
                  _legendItem6 = config.showLegend && _legend6.getItem(plot.config.legendItemId),
                  _graphicalElement6 = _legendItem6 && _legendItem6.getGraphicalElement(),
                  _legendItemSymbol6 = _graphicalElement6 && _graphicalElement6.legendItemSymbol,
                  _symbolBBox6 = _legendItemSymbol6 && _legendItemSymbol6.node.getBBox(),
                  _svgScale6 = 1,
                  _plotIdentifierCoords6;

              newRadius = Math.sqrt(Math.pow(track.config.outerRadius - track.config.thickness / 2, 2) + Math.pow(distance, 2));
              theta = Math.atan(distance / track.config.outerRadius) * (180 / Math.PI);
              _plotIdentifierCoords6 = (0, _polarUtil.pointOnCircleFromCenter)(centerX, centerY, newRadius, (0, _polarUtil.normaliseAngle)(startAngle) - theta);

              if (!_symbolBBox6) {
                _symbolBBox6 = {
                  width: labelFontSize
                };
              }

              if (labelFontSize && _symbolBBox6 && labelFontSize < _symbolBBox6.height) {
                _svgScale6 = labelFontSize / _symbolBBox6.height;
              }

              if (_pathElement6.tagName === 'path') {
                for (var _i6 = 0; _i6 < _pathAttributes6.length; _i6++) {
                  if (_pathAttributes6[_i6].name === 'd') {
                    _path6 = _pathAttributes6[_i6].nodeValue;
                  } else {
                    _plotIdentifierAttr[_pathAttributes6[_i6].name] = _pathAttributes6[_i6].nodeValue;
                  }
                }

                _plotIdentifierAttr.path = _path6;
              } else {
                _plotIdentifierAttr.path = "M0,0L" + labelFontSize + ",0," + labelFontSize + "," + labelFontSize + ",0," + labelFontSize + "Z";
                _plotIdentifierAttr['stroke-width'] = 0.1;
                _plotIdentifierAttr.fill = plot.config.realColor || plot.config.color;
              }

              _plotIdentifierAttr.transform = "T" + (_plotIdentifierCoords6.x - _symbolBBox6.width * _svgScale6 / 2) + ", " + (_plotIdentifierCoords6.y - _symbolBBox6.height * _svgScale6 / 2) + " R" + (startAngle - 90) + ", " + _plotIdentifierCoords6.x + ", " + _plotIdentifierCoords6.y + " S" + _svgScale6;
              this.addPlotIdentifier(_plotIdentifierAttr, plot);
              distance = distance + labelFontSize;
            }

            if (showIcon && track.config.iconurl) {
              distance = distance + labelFontSize + ICON_PADDING;
              newRadius = Math.sqrt(Math.pow(track.config.outerRadius - (track.config.thickness - labelFontSize) / 2, 2) + Math.pow(distance, 2));
              theta = Math.atan(distance / track.config.outerRadius) * (180 / Math.PI);
              iconAttr.iconCoords = (0, _polarUtil.pointOnCircleFromCenter)(centerX, centerY, newRadius, (0, _polarUtil.normaliseAngle)(startAngle) - theta);
              iconAttr.transform = "R" + (startAngle - 90) + ", " + iconAttr.iconCoords.x + ", " + iconAttr.iconCoords.y;
              iconAttr.iconSize = labelFontSize;
              this.addIcon(iconAttr, plot, track);
            }
          }
        } else if (startAngle >= 180 && startAngle < 360) {
          if (config.iconposition === 'end') {
            // labelposition start angle 180-360
            // iconposition end => place plotIdentifier, place text, place icon
            distance = distance - config.labelpadding.left;

            if (plotIdentifierShow && config.showlabels) {
              var _el7 = document.createElement('div');

              _el7.innerHTML = _trustedPolicy.default.createHTML(plot.getParsedText('$plotIdentifier'));

              var _pathElement7 = _el7.firstChild.firstElementChild || _el7.firstChild,
                  _pathAttributes7 = _pathElement7 && _pathElement7.attributes,
                  _path7,
                  _legend7 = this.getFromEnv('legend'),
                  _legendItem7 = config.showLegend && _legend7.getItem(plot.config.legendItemId),
                  _graphicalElement7 = _legendItem7 && _legendItem7.getGraphicalElement(),
                  _legendItemSymbol7 = _graphicalElement7 && _graphicalElement7.legendItemSymbol,
                  _symbolBBox7 = _legendItemSymbol7 && _legendItemSymbol7.node.getBBox(),
                  _svgScale7 = 1,
                  _plotIdentifierCoords7;

              newRadius = Math.sqrt(Math.pow(track.config.innerRadius + track.config.thickness / 2, 2) + Math.pow(distance, 2));
              theta = Math.atan(distance / track.config.innerRadius) * (180 / Math.PI);
              _plotIdentifierCoords7 = (0, _polarUtil.pointOnCircleFromCenter)(centerX, centerY, newRadius, (0, _polarUtil.normaliseAngle)(startAngle) + theta);

              if (!_symbolBBox7) {
                _symbolBBox7 = {
                  width: labelFontSize
                };
              }

              if (labelFontSize && _symbolBBox7 && labelFontSize < _symbolBBox7.height) {
                _svgScale7 = labelFontSize / _symbolBBox7.height;
              }

              if (_pathElement7.tagName === 'path') {
                for (var _i7 = 0; _i7 < _pathAttributes7.length; _i7++) {
                  if (_pathAttributes7[_i7].name === 'd') {
                    _path7 = _pathAttributes7[_i7].nodeValue;
                  } else {
                    _plotIdentifierAttr[_pathAttributes7[_i7].name] = _pathAttributes7[_i7].nodeValue;
                  }
                }

                _plotIdentifierAttr.path = _path7;
              } else {
                _plotIdentifierAttr.path = "M0,0L" + labelFontSize + ",0," + labelFontSize + "," + labelFontSize + ",0," + labelFontSize + "Z";
                _plotIdentifierAttr['stroke-width'] = 0.1;
                _plotIdentifierAttr.fill = plot.config.realColor || plot.config.color;
              }

              _plotIdentifierAttr.transform = "T" + (_plotIdentifierCoords7.x - _symbolBBox7.width * _svgScale7 / 2) + ", " + (_plotIdentifierCoords7.y - _symbolBBox7.height * _svgScale7 / 2) + " R" + (startAngle + 90) + ", " + _plotIdentifierCoords7.x + ", " + _plotIdentifierCoords7.y + " S" + _svgScale7;
              this.addPlotIdentifier(_plotIdentifierAttr, plot); // Adding the space taken by the plot identifier to the distance for the next element

              distance = distance - labelFontSize;
            }

            if (config.showlabels) {
              radius = track.config.innerRadius + (track.config.thickness - labelFontSize) / 2 + labelFontSize / 2;
              newRadius = Math.sqrt(Math.pow(radius, 2) + Math.pow(distance, 2));
              theta = Math.atan(distance / track.config.innerRadius) * (180 / Math.PI);
              labelText = plot.getParsedText(labelText.replace('$plotIdentifier', '').replace('$plotidentifier', ''));

              var _labelCoords6 = (0, _polarUtil.pointOnCircleFromCenter)(centerX, centerY, newRadius, (0, _polarUtil.normaliseAngle)(startAngle) + theta),
                  _labelLength4; // update styles of smartLabel


              var _labelStyle7 = {
                'font-family': config.style.inCanfontFamily,
                'font-size': labelFontSize,
                'line-height': labelFontSize * 1.2
              };
              smartLabel.setStyle(_labelStyle7);
              labelTextObj = smartLabel.getSmartText(labelText, config.outerradius, labelFontSize * 1.2, false);
              labelTextAttr.x = _labelCoords6.x;
              labelTextAttr.y = _labelCoords6.y;
              labelTextAttr.fill = labelFontColor;
              labelTextAttr['font-family'] = config.style.inCanfontFamily;
              labelTextAttr['font-size'] = labelFontSize;
              labelTextAttr['text-anchor'] = 'start';
              labelTextAttr.transform = "R" + (startAngle + 90) + ", " + labelTextAttr.x + ", " + labelTextAttr.y;
              labelTextAttr.text = labelTextObj.text;
              _labelLength4 = this.addLabel(labelTextAttr, plot);
              distance = distance - _labelLength4;
            }

            if (showIcon && track.config.iconurl) {
              distance = distance - ICON_PADDING;
              newRadius = Math.sqrt(Math.pow(track.config.innerRadius + (track.config.thickness - labelFontSize) / 2, 2) + Math.pow(distance, 2));
              theta = Math.atan(distance / track.config.innerRadius) * (180 / Math.PI);
              iconAttr.iconCoords = (0, _polarUtil.pointOnCircleFromCenter)(centerX, centerY, newRadius, (0, _polarUtil.normaliseAngle)(startAngle) + theta);
              iconAttr.transform = "R" + (startAngle + 90) + ", " + iconAttr.iconCoords.x + ", " + iconAttr.iconCoords.y;
              iconAttr.iconSize = labelFontSize;
              this.addIcon(iconAttr, plot, track);
            }
          } else {
            // labelposition start angle 180-360
            // iconposition start => place icon, place plotIdentifier, place text
            distance = distance - config.labelpadding.left;

            if (showIcon) {
              if (track.config.iconurl) {
                newRadius = Math.sqrt(Math.pow(track.config.innerRadius + (track.config.thickness - labelFontSize) / 2, 2) + Math.pow(distance, 2));
                theta = Math.atan(distance / track.config.innerRadius) * (180 / Math.PI);
                iconAttr.iconCoords = (0, _polarUtil.pointOnCircleFromCenter)(centerX, centerY, newRadius, (0, _polarUtil.normaliseAngle)(startAngle) + theta);
                iconAttr.transform = "R" + (startAngle + 90) + ", " + iconAttr.iconCoords.x + ", " + iconAttr.iconCoords.y;
                iconAttr.iconSize = labelFontSize;
                this.addIcon(iconAttr, plot, track);
              } // Adding the space taken by the icon to the distance for the next element (And 10px distance from icon)


              distance = distance - labelFontSize - ICON_PADDING;
            }

            if (plotIdentifierShow && config.showlabels) {
              var _el8 = document.createElement('div');

              _el8.innerHTML = _trustedPolicy.default.createHTML(plot.getParsedText('$plotIdentifier'));

              var _pathElement8 = _el8.firstChild.firstElementChild || _el8.firstChild,
                  _pathAttributes8 = _pathElement8 && _pathElement8.attributes,
                  _path8,
                  _legend8 = this.getFromEnv('legend'),
                  _legendItem8 = config.showLegend && _legend8.getItem(plot.config.legendItemId),
                  _graphicalElement8 = _legendItem8 && _legendItem8.getGraphicalElement(),
                  _legendItemSymbol8 = _graphicalElement8 && _graphicalElement8.legendItemSymbol,
                  _symbolBBox8 = _legendItemSymbol8 && _legendItemSymbol8.node.getBBox(),
                  _svgScale8 = 1,
                  _plotIdentifierCoords8;

              newRadius = Math.sqrt(Math.pow(track.config.innerRadius + track.config.thickness / 2, 2) + Math.pow(distance, 2));
              theta = Math.atan(distance / track.config.innerRadius) * (180 / Math.PI);
              _plotIdentifierCoords8 = (0, _polarUtil.pointOnCircleFromCenter)(centerX, centerY, newRadius, (0, _polarUtil.normaliseAngle)(startAngle) + theta);

              if (!_symbolBBox8) {
                _symbolBBox8 = {
                  width: labelFontSize
                };
              }

              if (labelFontSize && _symbolBBox8 && labelFontSize < _symbolBBox8.height) {
                _svgScale8 = labelFontSize / _symbolBBox8.height;
              }

              if (_pathElement8.tagName === 'path') {
                for (var _i8 = 0; _i8 < _pathAttributes8.length; _i8++) {
                  if (_pathAttributes8[_i8].name === 'd') {
                    _path8 = _pathAttributes8[_i8].nodeValue;
                  } else {
                    _plotIdentifierAttr[_pathAttributes8[_i8].name] = _pathAttributes8[_i8].nodeValue;
                  }
                }

                _plotIdentifierAttr.path = _path8;
              } else {
                _plotIdentifierAttr.path = "M0,0L" + labelFontSize + ",0," + labelFontSize + "," + labelFontSize + ",0," + labelFontSize + "Z";
                _plotIdentifierAttr['stroke-width'] = 0.1;
                _plotIdentifierAttr.fill = plot.config.realColor || plot.config.color;
              }

              _plotIdentifierAttr.transform = "T" + (_plotIdentifierCoords8.x - _symbolBBox8.width * _svgScale8 / 2) + ", " + (_plotIdentifierCoords8.y - _symbolBBox8.height * _svgScale8 / 2) + " R" + (startAngle + 90) + ", " + _plotIdentifierCoords8.x + ", " + _plotIdentifierCoords8.y + " S" + _svgScale8;
              this.addPlotIdentifier(_plotIdentifierAttr, plot); // Adding the space taken by the plot identifier to the distance for the next element

              distance = distance - labelFontSize - 1;
            }

            if (config.showlabels) {
              radius = track.config.innerRadius + (track.config.thickness - labelFontSize) / 2 + labelFontSize / 2;
              newRadius = Math.sqrt(Math.pow(radius, 2) + Math.pow(distance, 2));
              theta = Math.atan(distance / radius) * (180 / Math.PI);
              labelText = plot.getParsedText(labelText.replace('$plotIdentifier', '').replace('$plotidentifier', ''));

              var _labelCoords7 = (0, _polarUtil.pointOnCircleFromCenter)(centerX, centerY, newRadius, (0, _polarUtil.normaliseAngle)(startAngle) + theta); // update styles of smartLabel


              var _labelStyle8 = {
                'font-family': config.style.inCanfontFamily,
                'font-size': labelFontSize,
                'line-height': labelFontSize * 1.2
              };
              smartLabel.setStyle(_labelStyle8);
              labelTextObj = smartLabel.getSmartText(labelText, config.outerradius, labelFontSize * 1.2, false);
              labelTextAttr.x = _labelCoords7.x;
              labelTextAttr.y = _labelCoords7.y;
              labelTextAttr.fill = labelFontColor;
              labelTextAttr['font-family'] = config.style.inCanfontFamily;
              labelTextAttr['font-size'] = labelFontSize;
              labelTextAttr['text-anchor'] = 'start';
              labelTextAttr.transform = "R" + (startAngle + 90) + ", " + labelTextAttr.x + ", " + labelTextAttr.y;
              labelTextAttr.text = labelTextObj.text;
              this.addLabel(labelTextAttr, plot);
            }
          }
        }
      }
    }

    if (labelTextObj) {
      if (config.showToolTip && labelTextObj.oriText !== labelTextObj.text) {
        toolTipController.enableToolTip(plot.label, labelTextObj.oriText);
      } else {
        toolTipController.disableToolTip(plot.label);
      }
    }
  };

  _proto.addIcon = function addIcon(iconAttr, plot, track) {
    var animationManager = this.getFromEnv('animationManager');
    plot.iconImage = animationManager.setAnimation({
      el: 'image',
      attr: {
        'src': track.config.iconurl,
        'x': iconAttr.iconCoords.x,
        'y': iconAttr.iconCoords.y,
        'width': iconAttr.iconSize,
        'height': iconAttr.iconSize,
        'transform': iconAttr.transform
      },
      container: {
        id: 'node-container',
        isParent: true
      },
      component: this,
      label: 'image'
    });
    this.addGraphicalElement('iconImage', plot.iconImage, true);
  };

  _proto.addPlotIdentifier = function addPlotIdentifier(plotIdentifierAttr, plot) {
    var animationManager = this.getFromEnv('animationManager');
    plot.plotIdentifier = animationManager.setAnimation({
      el: 'path',
      attr: plotIdentifierAttr,
      container: {
        id: 'plot',
        isParent: true
      },
      label: 'plotIdentifier',
      component: this
    });
    this.addGraphicalElement('plotIdentifier', plot.plotIdentifier, true);
  };

  _proto.addLabel = function addLabel(labelTextAttr, plot) {
    var animationManager = this.getFromEnv('animationManager');
    plot.label = animationManager.setAnimation({
      el: 'text',
      attr: labelTextAttr,
      container: {
        id: 'plot',
        isParent: true
      },
      label: 'label',
      component: this
    });
    this.addGraphicalElement('trackLabel', plot.label, true);
    return plot.label.node.getBBox().width;
  }
  /**
    * Draws the center context label component on the chart
    * @param {String} labelText the text to be shown
    * @memberof RadialBar
    */
  ;

  _proto.drawContextLabel = function drawContextLabel(labelText, htmlObj) {
    if (!this.config.showcontextlabel) {
      return;
    }

    var chartConfig = this.getFromEnv('chartConfig'),
        smartLabel = this.getFromEnv('smartLabel'),
        animationManager = this.getFromEnv('animationManager'),
        config = this.config,
        canvasLeft = chartConfig.canvasLeft,
        canvasTop = chartConfig.canvasTop,
        availableWidth = chartConfig.canvasWidth,
        availableHeight = chartConfig.canvasHeight,
        centerX = canvasLeft + availableWidth / 2,
        centerY = canvasTop + availableHeight / 2,
        innerDiameter = config.innerradius * 2,
        fontSize = this.computeFontSize(config.contextlabelfontsizewithunit),
        contextLabelDivSide = Math.sqrt(2) * config.innerradius,
        containerDivStyle,
        spanStyle,
        labelTextObj,
        labelGraphicsAttr;

    if (config.contextlabelObject) {
      this.removeGraphicalElement(config.contextlabelObject);
    }

    if (htmlObj) {
      if (!config.div) {
        config.div = document.createElement('div');
        config.span = document.createElement('span');
        config.div.style = '';
        config.span.style = '';
      }

      containerDivStyle = config.div.style;
      spanStyle = config.span.style;
      containerDivStyle.color = config.contextlabelfontcolor;
      containerDivStyle.fontSize = fontSize + _lib.PXSTRING;
      containerDivStyle.overflow = 'hidden';
      containerDivStyle['text-overflow'] = 'ellipsis';
      containerDivStyle['word-break'] = 'break-all';
      containerDivStyle['text-align'] = 'center';
      containerDivStyle['font-family'] = config.contextlabelfont;
      containerDivStyle.opacity = config.contextlabelalpha;
      containerDivStyle.top = centerY - contextLabelDivSide / 2 + _lib.PXSTRING;
      containerDivStyle.left = centerX - contextLabelDivSide / 2 + _lib.PXSTRING;
      containerDivStyle.visibility = 'visible';
      containerDivStyle.position = 'absolute';
      containerDivStyle.width = contextLabelDivSide + _lib.PXSTRING;
      containerDivStyle.height = contextLabelDivSide + _lib.PXSTRING;
      spanStyle['margin-top'] = 'auto';
      spanStyle['margin-bottom'] = 'auto';
      spanStyle.display = 'flex';
      spanStyle['flex-direction'] = 'row';
      spanStyle['justify-content'] = 'center';
      spanStyle['flex-wrap'] = 'wrap';
      spanStyle['align-items'] = 'flex-start';
      config.div.id = 'contextlabeldiv';
      config.span.innerHTML = _trustedPolicy.default.createHTML(labelText);
      config.div.appendChild(config.span);
      this.getFromEnv('chart-container').appendChild(config.div);
    } else {
      if (this.getFromEnv('chart-container').querySelector('#contextlabeldiv')) {
        this.getFromEnv('chart-container').removeChild(config.div);
      } // update styles of smartLabel


      var labelStyle = {
        'font-family': config.style.inCanfontFamily,
        'font-size': fontSize,
        'line-height': fontSize * 1.2
      };
      smartLabel.setStyle(labelStyle);
      labelTextObj = smartLabel.getSmartText(labelText, innerDiameter - 10, innerDiameter - 10, false);
      labelGraphicsAttr = {
        'text': labelTextObj.text,
        'x': centerX,
        'y': centerY,
        'fill': config.contextlabelfontcolor,
        'font-family': config.contextlabelfont,
        'font-size': fontSize + _lib.PXSTRING,
        'fill-opacity': config.contextlabelalpha
      }; // Add the new label

      config.contextlabelObject = animationManager.setAnimation({
        el: 'text',
        attr: labelGraphicsAttr,
        container: {
          id: 'plot',
          isParent: true
        },
        label: 'label',
        component: this
      });
      this.addGraphicalElement('contentLabel', config.contextlabelObject, true);
    }
  };

  return RadialBar;
}(_commonchartapi.default);

var _default = RadialBar;
exports["default"] = _default;

/***/ }),

/***/ 1538:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _areabase = __webpack_require__(740);

var _realtimecolumn = _interopRequireDefault(__webpack_require__(1539));

var _realtimearea = _interopRequireDefault(__webpack_require__(1543));

var DS_TYPE = 'realtimearea';

var RealtimeArea = /*#__PURE__*/function (_RealtimeColumn) {
  (0, _inheritsLoose2.default)(RealtimeArea, _RealtimeColumn);

  /**
   * Provides the name of the chart extension
   *
   * @static
   * @return {string} The name of the chart extension
   */
  RealtimeArea.getName = function getName() {
    return 'RealtimeArea';
  };

  function RealtimeArea() {
    var _this;

    _this = _RealtimeColumn.call(this) || this;
    _this.axisPaddingLeft = 0;
    _this.axisPaddingRight = 0;
    return _this;
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */


  var _proto = RealtimeArea.prototype;

  _proto.getName = function getName() {
    return 'RealtimeArea';
  };

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    _RealtimeColumn.prototype.__setDefaultConfig.call(this);

    _areabase._setDefaultConfig.call(this);

    var config = this.config;
    config.defaultDatasetType = DS_TYPE;
    config.enablemousetracking = true;
  };

  _proto.getDSdef = function getDSdef() {
    return _realtimearea.default;
  }
  /**
   * This method return the dataset-group definations for this charts
   */
  ;

  _proto.getDSGroupdef = function getDSGroupdef() {// empty fn
  };

  return RealtimeArea;
}(_realtimecolumn.default);

var _default = RealtimeArea;
exports["default"] = _default;

/***/ }),

/***/ 1542:
/***/ ((__unused_webpack_module, exports) => {



exports.__esModule = true;
exports["default"] = void 0;
var _default = {
  'initial.chartAPI.RealtimeColumn': function initialChartAPIRealtimeColumn() {
    return {
      '*': null
    };
  }
};
exports["default"] = _default;

/***/ }),

/***/ 1539:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _assertThisInitialized2 = _interopRequireDefault(__webpack_require__(292));

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _mscartesian = _interopRequireDefault(__webpack_require__(626));

var _lib = __webpack_require__(274);

var _realtimecolumn = _interopRequireDefault(__webpack_require__(1540));

var _columnMultiseries = _interopRequireDefault(__webpack_require__(689));

var _messagelogger = _interopRequireDefault(__webpack_require__(342));

var _alertmanager = _interopRequireDefault(__webpack_require__(380));

var _constructor = _interopRequireDefault(__webpack_require__(272));

var _dependencyManager = __webpack_require__(282);

var _index = _interopRequireDefault(__webpack_require__(1542));

var _realtime = __webpack_require__(1480);

var _fetchData = _interopRequireDefault(__webpack_require__(1344));

var _schedular = __webpack_require__(286);

var _datastreamer = _interopRequireDefault(__webpack_require__(1481));

var UNDEF,
    visibleStr = _lib.preDefStr.visibleStr,
    DS_TYPE = 'realtimecolumn';

function _setData(value, label, id) {
  var stream = _lib.BLANKSTRING;

  if (value && value.toString || value === _lib.BLANKSTRING || value === 0) {
    stream = 'value=' + value.toString();
  }

  if (label && label.toString || label === _lib.BLANKSTRING) {
    stream = stream + '&label=' + label.toString();
  }

  if (id && id.toString || id === _lib.BLANKSTRING) {
    stream = stream + '&id=' + id.toString();
  }

  if (stream) {
    this.feedData(stream);
  }
}

(0, _dependencyManager.addDep)({
  name: 'realtimeColumnChartAnimation',
  type: 'animationRule',
  extension: _index.default
});

_constructor.default.addDep(_datastreamer.default);

var RealtimeColumn = /*#__PURE__*/function (_MSCartesian) {
  (0, _inheritsLoose2.default)(RealtimeColumn, _MSCartesian);

  /**
   * Provides the name of the chart extension
   *
   * @static
   * @return {string} The name of the chart extension
   */
  RealtimeColumn.getName = function getName() {
    return 'RealtimeColumn';
  };

  function RealtimeColumn() {
    var _this;

    _this = _MSCartesian.call(this) || this;
    var iapi = (0, _assertThisInitialized2.default)(_this);

    _constructor.default.addDep(_messagelogger.default);

    _constructor.default.addDep(_alertmanager.default);

    _this.showRTvalue = true;
    _this.canvasPadding = true;
    _this.isRealTime = true;
    _this.rtManageSpace = true;
    _this.transposeAxis = true;
    _this._setData = _setData;
    _this.eiMethods = _realtime.eiMethods;

    _this._drawRTValue = function () {
      iapi._drawRealTimeValue();
    };

    return _this;
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */


  var _proto = RealtimeColumn.prototype;

  _proto.getName = function getName() {
    return 'RealtimeColumn';
  };

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    _MSCartesian.prototype.__setDefaultConfig.call(this);

    var config = this.config;
    config.defaultDatasetType = DS_TYPE;
    config.enablemousetracking = true;
  };

  _proto.asyncRealTimeValueDraw = function asyncRealTimeValueDraw() {
    this.addJob('realtimevaluedraw', this._drawRTValue, _schedular.priorityList && _schedular.priorityList.draw);
  }
  /**
   * Parse the chart attributes and store in chart's config
   * @param {Object} dataObj User input json
   */
  ;

  _proto.parseChartAttr = function parseChartAttr(dataObj) {
    _MSCartesian.prototype.parseChartAttr.call(this, dataObj);

    this.config.drawTrendRegion = 0;
  };

  _proto._setCategories = function _setCategories() {
    // Setting the number of categories to be shown.
    var iapi = this,
        xAxis = iapi.getChildren('xAxis')[0],
        tempArr = [],
        tempCategories,
        realTimeConfig = iapi.config.realTimeConfig,
        clear = realTimeConfig && realTimeConfig.clear,
        categories = clear ? UNDEF : iapi.getFromEnv('dataSource').categories && iapi.getFromEnv('dataSource').categories[0] && iapi.getFromEnv('dataSource').categories[0].category,
        catLen = categories && Array.isArray(categories) && categories.filter(function (data) {
      return !data.vline;
    }).length || 0,
        numDisplaySets = realTimeConfig.numDisplaySets; // Setting category as per numDisplaySets

    if (catLen < numDisplaySets) {
      tempArr.length = numDisplaySets - catLen;
      tempCategories = categories ? tempArr.concat(categories) : tempArr;
    } else if (catLen > numDisplaySets && numDisplaySets >= 0) {
      tempCategories = numDisplaySets ? categories.slice(-numDisplaySets) : [];
    } else {
      tempCategories = categories.slice(0);
    }

    xAxis.setTickValues(tempCategories);
  } // Spacemanagement for real time value
  ;

  _proto._realTimeValuePositioning = function _realTimeValuePositioning(availableHeight) {
    var iapi = this,
        components = iapi.getChildren(),
        smartLabel = iapi.getFromEnv('smartLabel'),
        height,
        space,
        config = iapi.config,
        realTimeConfig = config.realTimeConfig || (config.realTimeConfig = {}),
        padding = realTimeConfig.realTimeValuePadding,
        axisConfig = components.xAxis[0].config,
        style = axisConfig.trend.trendStyle,
        attr = realTimeConfig.style = {
      color: (0, _lib.convertColor)((0, _lib.pluck)(realTimeConfig.realtimeValueFontColor, style.color), (0, _lib.pluck)(axisConfig.trendlineAlpha, 99)),
      fontFamily: (0, _lib.pluck)(realTimeConfig.realtimeValueFont, style.fontFamily),
      fontSize: (0, _lib.pluck)(realTimeConfig.realtimeValueFontSize, style.fontSize),
      fontWeight: (0, _lib.pluck)(realTimeConfig.fontWeight, style.fontWeight),
      lineHeight: (0, _lib.pluckNumber)(style.lineHeight)
    };
    smartLabel.useEllipsesOnOverflow(config.useEllipsesWhenOverflow);
    smartLabel.setStyle(attr); // Setting the height to be left for displaying the value.

    realTimeConfig.height = height = smartLabel.getOriSize(_lib.TESTSTR).height;
    realTimeConfig.canvasBottom = config.canvasBottom;
    space = height + padding;

    if (space > availableHeight) {
      space = availableHeight;
    }

    return {
      bottom: space
    };
  }
  /**
   * function to manage all draw draw related jobList
   * this function handle all the draw related jobs like space management,
   * post space management and draw
   */
  ;

  _proto.draw = function draw() {
    _MSCartesian.prototype.draw.call(this);

    if (this.showRTvalue && this.config.realTimeConfig.showRTValue) {
      this._drawRealTimeValue();
    }
  } // Drwaing the real time value.
  ;

  _proto._drawRealTimeValue = function _drawRealTimeValue() {
    var iapi = this,
        chart = iapi.getFromEnv('chart'),
        config = iapi.config,
        dataset = chart.getDatasets(),
        animationManager = chart.getFromEnv('animationManager'),
        smartLabel = iapi.getFromEnv('smartLabel'),
        realTimeConfig = config.realTimeConfig,
        realtimeValueSeparator = realTimeConfig.realtimeValueSeparator,
        len = dataset.length,
        displayValue = _lib.BLANKSTRING,
        canvasBottom = realTimeConfig.canvasBottom,
        height = realTimeConfig.height,
        canvasLeft = config.canvasLeft,
        canvasRight = config.canvasRight,
        style = realTimeConfig.style || {},
        positionX,
        positionY,
        realTimeValueGraphics,
        realTimeValueGraphicsCheck = iapi.getGraphicalElement('realTimeValue'),
        chartChildContainer = iapi.getChildContainer(),
        attr,
        parentLayer = chart.getContainer().parentGroup,
        realTimeValueGroup = chartChildContainer.realTimeValueGroup,
        datasetStore,
        drawn,
        prevData,
        dataDisplayValue,
        i;
    iapi.removeJob('realtimevaluedraw');

    if (realTimeConfig.clear && realTimeValueGraphics) {
      animationManager.setAnimation({
        el: realTimeValueGraphics,
        attr: {
          text: _lib.BLANKSTRING
        },
        component: iapi,
        label: 'label'
      });
    }

    if (!realTimeValueGroup) {
      realTimeValueGroup = chart.addChildContainer('realTimeValueGroup', animationManager.setAnimation({
        el: 'group',
        attr: {
          name: 'realTimeValue'
        },
        container: parentLayer,
        label: 'group',
        component: chart
      }).insertBefore(chartChildContainer.datalabelsGroup));
    } else {
      for (i = 0; i < len; i++) {
        datasetStore = dataset[i].components.data;
        prevData = datasetStore[datasetStore.length - 1];
        dataDisplayValue = prevData && prevData.config.displayValue;
        displayValue += dataDisplayValue ? dataDisplayValue === UNDEF ? _lib.BLANKSTRING : dataDisplayValue + realtimeValueSeparator : _lib.BLANKSTRING;
      }

      displayValue = displayValue.substring(0, displayValue.length - realtimeValueSeparator.length);
      smartLabel.useEllipsesOnOverflow(config.useEllipsesWhenOverflow);
      smartLabel.setStyle(style);
      positionX = (canvasLeft + canvasRight) / 2;
      positionY = canvasBottom - height / 2;
      attr = {
        x: positionX || 0,
        y: positionY || 0,
        'font-size': style.fontSize,
        'font-weight': style.fontWeight,
        'font-family': style.fontFamily,
        'line-height': style.lineHeight,
        text: displayValue,
        fill: style.color,
        visibility: visibleStr
      };
      realTimeValueGraphics = animationManager.setAnimation({
        el: realTimeValueGraphicsCheck || 'text',
        attr: attr,
        container: realTimeValueGroup,
        label: 'rtValue',
        component: chart
      });
      drawn = true;

      if (!realTimeValueGraphicsCheck) {
        iapi.addGraphicalElement('realTimeValue', realTimeValueGraphics);
      }

      realTimeValueGraphics && !drawn && realTimeValueGraphics.show();
    }
  };

  _proto._hideRealTimeValue = function _hideRealTimeValue() {
    var iapi = this,
        graphics = iapi.getGraphicalElement('realTimeValue');
    graphics && graphics.hide();
  };

  _proto._setRTmenu = function _setRTmenu(showRTmenuItem, useMessageLog) {
    _realtime._setRTmenu.call(this, showRTmenuItem, useMessageLog);
  };

  _proto._getDataJSON = function _getDataJSON() {
    return this.config.realTimeConfig.legacyUpdateObj || {
      values: []
    };
  }
  /**
   * function to check if the chart specific data is proper is not
   * this fn is define for specific chart types
   * @return {boolean} if JSON data is valid or not
   */
  ;

  _proto._checkInvalidSpecificData = function _checkInvalidSpecificData() {
    var jsonData = this.getFromEnv('dataSource'),
        datasetsJSON = jsonData.dataset,
        dataStreamer = this.getChildren('dataStreamer') && this.getChildren('dataStreamer')[0];

    if (!datasetsJSON) {
      dataStreamer && dataStreamer._stopUpdate();
      return true;
    }
  }
  /**
   * function to check if the chart has the proper data or not
   * @return {boolean} if JSON data is valid or not
   */
  ;

  _proto._checkInvalidData = function _checkInvalidData() {
    var iapi = this,
        dataObj = iapi.getFromEnv('dataSource'),
        dataStreamer = iapi.getChildren('dataStreamer') && this.getChildren('dataStreamer')[0]; // Checking if the chart has proper data

    if (dataObj === {}) {
      dataStreamer && dataStreamer._stopUpdate();
      return true;
    }
  }
  /**
   * to get multiseries group class defined
   */
  ;

  _proto.getDSGroupdef = function getDSGroupdef() {
    return _columnMultiseries.default;
  }
  /**
   * to get Dataset class defined
   */
  ;

  _proto.getDSdef = function getDSdef() {
    return _realtimecolumn.default;
  };

  _proto._realTimeConfigure = function _realTimeConfigure() {
    _realtime._realTimeConfigure.call(this);
  };

  _proto._stopUpdate = function _stopUpdate(source) {
    _realtime._stopUpdate.call(this, source);
  };

  _proto._restartUpdate = function _restartUpdate() {
    _realtime._restartUpdate.call(this);
  };

  _proto._isUpdateActive = function _isUpdateActive() {
    return _realtime._isUpdateActive.call(this);
  };

  _proto._getData = function _getData() {
    return _fetchData.default.call(this);
  };

  _proto.realTimeUpdate = function realTimeUpdate(dataObj) {
    _realtime.realTimeUpdate.call(this, dataObj);
  };

  _proto._RTmanageSpace = function _RTmanageSpace() {
    _realtime._RTmanageSpace.call(this);
  };

  _proto.realTimeDraw = function realTimeDraw(eventArgs) {
    if (eventArgs === void 0) {
      eventArgs = {};
    }

    _realtime.realTimeDraw.call(this, eventArgs);
  };

  _proto.feedData = function feedData(stream) {
    return _realtime.feedData.call(this, stream);
  };

  _proto._linearDataParser = function _linearDataParser(responseText) {
    return _realtime._linearDataParser.call(this, responseText);
  };

  _proto._clearChart = function _clearChart(_source) {
    _realtime._clearChart.call(this, _source);
  };

  return RealtimeColumn;
}(_mscartesian.default);

var _default = RealtimeColumn;
exports["default"] = _default;

/***/ }),

/***/ 1546:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _areabase = __webpack_require__(740);

var _realtimecolumn = _interopRequireDefault(__webpack_require__(1539));

var _realtimeline = _interopRequireDefault(__webpack_require__(1547));

var DS_TYPE = 'realtimeline';

var RealtimeLine = /*#__PURE__*/function (_RealtimeColumn) {
  (0, _inheritsLoose2.default)(RealtimeLine, _RealtimeColumn);

  /**
   * Provides the name of the chart extension
   *
   * @static
   * @return {string} The name of the chart extension
   */
  RealtimeLine.getName = function getName() {
    return 'RealtimeLine';
  };

  function RealtimeLine() {
    var _this;

    _this = _RealtimeColumn.call(this) || this;
    _this.axisPaddingLeft = 0;
    _this.axisPaddingRight = 0;
    return _this;
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */


  var _proto = RealtimeLine.prototype;

  _proto.getName = function getName() {
    return 'RealtimeLine';
  };

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    _RealtimeColumn.prototype.__setDefaultConfig.call(this);

    _areabase._setDefaultConfig.call(this);

    var config = this.config;
    config.defaultDatasetType = DS_TYPE;
    config.zeroplanethickness = 1;
    config.zeroplanealpha = 40;
    config.showzeroplaneontop = 0;
    config.enablemousetracking = true;
  };

  _proto.getDSdef = function getDSdef() {
    return _realtimeline.default;
  }
  /**
   * This method return the dataset-group definations for this charts
   */
  ;

  _proto.getDSGroupdef = function getDSGroupdef() {// empty fn
  };

  return RealtimeLine;
}(_realtimecolumn.default);

var _default = RealtimeLine;
exports["default"] = _default;

/***/ }),

/***/ 1553:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _areabase = __webpack_require__(740);

var _realtimecolumn = _interopRequireDefault(__webpack_require__(1539));

var _realtimeline = _interopRequireDefault(__webpack_require__(1547));

var _msdybasecartesian = __webpack_require__(668);

var _cartesianAxisDualY = _interopRequireDefault(__webpack_require__(669));

var _combiDualYDataset = _interopRequireDefault(__webpack_require__(670));

var DS_TYPE = 'RealtimeLine';

var RealtimeLineDy = /*#__PURE__*/function (_RealtimeColumn) {
  (0, _inheritsLoose2.default)(RealtimeLineDy, _RealtimeColumn);

  /**
   * Provides the name of the chart extension
   *
   * @static
   * @return {string} The name of the chart extension
   */
  RealtimeLineDy.getName = function getName() {
    return 'RealtimeLineDy';
  };

  function RealtimeLineDy() {
    var _this;

    _this = _RealtimeColumn.call(this) || this;
    _this.isRealTime = true;
    _this.axisPaddingLeft = 0;
    _this.isDual = true;
    _this.axisPaddingRight = 0;
    _this.getSpecificxAxisConf = _msdybasecartesian.getSpecificxAxisConf;
    _this.getSpecificyAxisConf = _msdybasecartesian.getSpecificyAxisConf;

    _this.registerFactory('axis', _cartesianAxisDualY.default, ['canvas']);

    _this.registerFactory('dataset', _combiDualYDataset.default, ['vCanvas']);

    return _this;
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */


  var _proto = RealtimeLineDy.prototype;

  _proto.getName = function getName() {
    return 'RealtimeLineDy';
  };

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    _RealtimeColumn.prototype.__setDefaultConfig.call(this);

    _areabase._setDefaultConfig.call(this);

    var config = this.config;
    config.defaultDatasetType = DS_TYPE;
    config.zeroplanethickness = 1;
    config.zeroplanealpha = 40;
    config.showzeroplaneontop = 0;
    config.enablemousetracking = true;
    config.isdual = true;
    config.syncaxislimits = 0;
  }
  /**
   * function to parse JSON data for configurations of axis
   * @return {Object} configurations of axes
   */
  ;

  _proto._feedAxesRawData = function _feedAxesRawData() {
    return _msdybasecartesian._feedAxesRawData.call(this);
  };

  _proto.getDSdef = function getDSdef() {
    return _realtimeline.default;
  }
  /**
   * function to return dataset type applicable for this chart
   * @return  {string}        dataset type applicable for this chart
   */
  ;

  _proto.getDSType = function getDSType() {
    return 'RealtimeLine';
  }
  /**
   * This method return the dataset-group definations for this charts
   */
  ;

  _proto.getDSGroupdef = function getDSGroupdef() {// empty fn
  };

  return RealtimeLineDy;
}(_realtimecolumn.default);

RealtimeLineDy.prototype.setAxisDimention = _msdybasecartesian.setAxisDimention;
var _default = RealtimeLineDy;
exports["default"] = _default;

/***/ }),

/***/ 1549:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _areabase = __webpack_require__(740);

var _realtimearea = _interopRequireDefault(__webpack_require__(1538));

var _realtimearea2 = _interopRequireDefault(__webpack_require__(1543));

var _cartesianStack = _interopRequireDefault(__webpack_require__(698));

var _lib = __webpack_require__(274);

var _pluckNumber = _interopRequireDefault(__webpack_require__(280));

var DS_TYPE = 'realtimearea';

var RealtimeStackedArea = /*#__PURE__*/function (_RealtimeArea) {
  (0, _inheritsLoose2.default)(RealtimeStackedArea, _RealtimeArea);

  function RealtimeStackedArea() {
    return _RealtimeArea.apply(this, arguments) || this;
  }

  /**
   * Provides the name of the chart extension
   *
   * @static
   * @return {string} The name of the chart extension
   */
  RealtimeStackedArea.getName = function getName() {
    return 'RealtimeStackedArea';
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */
  ;

  var _proto = RealtimeStackedArea.prototype;

  _proto.getName = function getName() {
    return 'RealtimeStackedArea';
  };

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    _RealtimeArea.prototype.__setDefaultConfig.call(this);

    _areabase._setDefaultConfig.call(this);

    var config = this.config;
    config.defaultDatasetType = DS_TYPE;
    config.isstacked = true;
    config.enablemousetracking = true; // for realtime stacked area and stacked area chart api the overlapping of sum labels
    // has been fixed and this has been used to reduce the affected subset

    this.addToEnv('useImprovedLabelPlacement', true); // The border is a line
    // Anchor must be at higher position than border

    this.addToEnv('useLinePlotGroupForAnchorPlacement', true);
  };

  _proto.configureAttributes = function configureAttributes(rawAttr) {
    _RealtimeArea.prototype.configureAttributes.call(this, rawAttr);

    var config = this.config,
        chartAttrs = this.getFromEnv('chart-attrib');
    config.showSum = (0, _pluckNumber.default)(chartAttrs.showsum, 0); // if show sum is on then default value position will be below for better visual

    if (config.showSum) {
      config.valueposition = (0, _lib.parseUnsafeString)((0, _lib.pluck)(chartAttrs.valueposition, 'below'));
    }
  }
  /**
   * This method return the dataset definations for this charts
   * @param  {string} name type of dataset class
   * @return {Object}      dataset class
   */
  ;

  _proto.getDSdef = function getDSdef() {
    return _realtimearea2.default;
  }
  /**
   * This method return the dataset-group definations for this charts
   * @return {Object} <dataset group class>     dataset group class
   */
  ;

  _proto.getDSGroupdef = function getDSGroupdef() {
    return _cartesianStack.default;
  };

  return RealtimeStackedArea;
}(_realtimearea.default);

var _default = RealtimeStackedArea;
exports["default"] = _default;

/***/ }),

/***/ 1551:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _realtimecolumn = _interopRequireDefault(__webpack_require__(1539));

var _cartesianStack = _interopRequireDefault(__webpack_require__(698));

var RealtimeStackedColumn = /*#__PURE__*/function (_RealtimeColumn) {
  (0, _inheritsLoose2.default)(RealtimeStackedColumn, _RealtimeColumn);

  function RealtimeStackedColumn() {
    return _RealtimeColumn.apply(this, arguments) || this;
  }

  /**
   * Provides the name of the chart extension
   *
   * @static
   * @return {string} The name of the chart extension
   */
  RealtimeStackedColumn.getName = function getName() {
    return 'RealtimeStackedColumn';
  };

  var _proto = RealtimeStackedColumn.prototype;

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    _RealtimeColumn.prototype.__setDefaultConfig.call(this);

    var config = this.config;
    config.isstacked = true;
    config.enablemousetracking = true;
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */
  ;

  _proto.getName = function getName() {
    return 'RealtimeStackedColumn';
  }
  /**
   * This method return the dataset-group definations for this charts
   * @return {Object} <dataset group class>     dataset group class
   */
  ;

  _proto.getDSGroupdef = function getDSGroupdef() {
    return _cartesianStack.default;
  };

  return RealtimeStackedColumn;
}(_realtimecolumn.default);

var _default = RealtimeStackedColumn;
exports["default"] = _default;

/***/ }),

/***/ 1533:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _lib = __webpack_require__(274);

var _sparkbase = _interopRequireDefault(__webpack_require__(1526));

var _sparkcolumn = _interopRequireDefault(__webpack_require__(1534));

/* eslint require-jsdoc: 'error', valid-jsdoc: ["error", { "requireReturn": false }] */
var math = Math,
    mathMax = math.max,
    DS_TYPE = 'sparkcolumn',
    FRIENDLY_NAME = 'sparkcolumn Chart';
/**
 * Creates SparkColumn class
 */

var SparkColumn = /*#__PURE__*/function (_SparkChartBase) {
  (0, _inheritsLoose2.default)(SparkColumn, _SparkChartBase);

  function SparkColumn() {
    return _SparkChartBase.apply(this, arguments) || this;
  }

  /**
   * Provides the name of the chart extension
   *
   * @static
   * @return {string} The name of the chart extension
   */
  SparkColumn.getName = function getName() {
    return 'SparkColumn';
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */
  ;

  var _proto = SparkColumn.prototype;

  _proto.getName = function getName() {
    return 'SparkColumn';
  }
  /**
   * Set default configurations for chart
   */
  ;

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    _SparkChartBase.prototype.__setDefaultConfig.call(this);

    var config = this.config;
    config.friendlyName = FRIENDLY_NAME;
    config.singleseries = false;
    config.defaultDatasetType = DS_TYPE;
    config.showplotborder = 0;
    config.enablemousetracking = true;
    config.canvasborderthickness = 1;
  }
  /**
   * Returns Class SparkColumnDataset
   * @return {Class} SparkColumnDataset class
   */
  ;

  _proto.getDSdef = function getDSdef() {
    return _sparkcolumn.default;
  }
  /**
   * Configure default canvas cosmetics
   * @return {Object} the canvas config that needs to be overridden
   */
  ;

  _proto._parseCanvasCosmetics = function _parseCanvasCosmetics() {
    var canvasBorderThickness,
        canBGAlpha,
        showCanvasBorder,
        shadow,
        iapi = this,
        canvasConfig = {},
        chartAttrs = iapi.getFromEnv('dataSource').chart,
        colorM = iapi.getFromEnv('color-manager'),
        is3D = iapi.config.is3D,
        oriCanvasBorderThickness,
        palleteString = is3D ? _lib.chartPaletteStr.chart3D : _lib.chartPaletteStr.chart2D,
        isRoundEdges = canvasConfig.isRoundEdges = (0, _lib.pluckNumber)(chartAttrs.useroundedges, 0),
        showAxisLine = (0, _lib.pluckNumber)(chartAttrs.showxaxisline, chartAttrs.showyaxisline, 0),
        hideAxisLine = showAxisLine ? 0 : 1;
    canvasConfig.canvasBorderRadius = (0, _lib.pluckNumber)(chartAttrs.plotborderradius, isRoundEdges ? 2 : 0);
    showCanvasBorder = canvasConfig.showCanvasBorder = Boolean((0, _lib.pluckNumber)(chartAttrs.showcanvasborder, hideAxisLine, canvasBorderThickness, isRoundEdges ? 0 : 1)); // Storing original canvasBorderThickness for future reference

    oriCanvasBorderThickness = canvasConfig.oriCanvasBorderThickness = mathMax((0, _lib.pluckNumber)(chartAttrs.canvasborderthickness, isRoundEdges ? 0 : (0, _lib.pluckNumber)(iapi.config.canvasborderthickness, 1), 0));
    canvasBorderThickness = canvasConfig.canvasBorderWidth = iapi.is3D ? 0 : showCanvasBorder ? oriCanvasBorderThickness : 0;
    canvasConfig.canvasBorderColor = (0, _lib.convertColor)((0, _lib.pluck)(chartAttrs.canvasbordercolor, colorM.getColor('canvasBorderColor')), (0, _lib.pluck)(chartAttrs.canvasborderalpha, colorM.getColor('canvasBorderAlpha')));
    canBGAlpha = canvasConfig.canBGAlpha = (0, _lib.pluck)(chartAttrs.canvasbgalpha, colorM.getColor('canvasBgAlpha'));
    canvasConfig.canBGColor = {
      FCcolor: {
        color: (0, _lib.pluck)(chartAttrs.canvasbgcolor, colorM.getColor(palleteString.canvasBgColor)),
        alpha: (0, _lib.pluck)(chartAttrs.canvasbgalpha, 100),
        angle: (0, _lib.pluck)(chartAttrs.canvasbgangle, 0),
        ratio: (0, _lib.pluck)(chartAttrs.canvasbgratio)
      }
    };
    shadow = canvasConfig.shadow = (0, _lib.pluckNumber)(chartAttrs.showshadow, isRoundEdges, 0) && isRoundEdges ? {
      enabled: true,
      opacity: canBGAlpha / 100
    } : 0;
    canvasConfig.shadowOnCanvasFill = shadow && shadow.enabled; // canvas padding

    canvasConfig.canvasPadding = (0, _lib.pluckNumber)(chartAttrs.canvaspadding, 0);
    canvasConfig.origCanvasTopPad = (0, _lib.pluckNumber)(chartAttrs.canvastoppadding, 0);
    canvasConfig.origCanvasBottomPad = (0, _lib.pluckNumber)(chartAttrs.canvasbottompadding, 0);
    canvasConfig.origCanvasLeftPad = (0, _lib.pluckNumber)(chartAttrs.canvasleftpadding, 0);
    canvasConfig.origCanvasRightPad = (0, _lib.pluckNumber)(chartAttrs.canvasrightpadding, 0);
    return canvasConfig;
  };

  return SparkColumn;
}(_sparkbase.default);

var _default = SparkColumn;
exports["default"] = _default;

/***/ }),

/***/ 1525:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _sparkbase = _interopRequireDefault(__webpack_require__(1526));

var _sparkline = _interopRequireDefault(__webpack_require__(1527));

var _sparkwinloss = __webpack_require__(1529);

/* eslint require-jsdoc: 'error', valid-jsdoc: ["error", { "requireReturn": false }] */
var FRIENDLY_NAME = 'SparkLine Chart',
    SPARKLINE = 'sparkline';
/**
 * Creates SparkChartBase class
 */

var SparkLine = /*#__PURE__*/function (_SparkChartBase) {
  (0, _inheritsLoose2.default)(SparkLine, _SparkChartBase);

  /**
   * Provides the name of the chart extension
   *
   * @static
   * @return {string} The name of the chart extension
   */
  SparkLine.getName = function getName() {
    return 'SparkLine';
  }
  /**
   * Constructor function of SparkChartBase class
   */
  ;

  function SparkLine() {
    var _this;

    _this = _SparkChartBase.call(this) || this;
    _this.showValues = 0;
    _this._parseCanvasCosmetics = _sparkwinloss._parseCanvasCosmetics;
    _this._placeOpenCloseValues = _sparkwinloss._placeOpenCloseValues;
    _this.defaultPlotShadow = 0;
    _this.axisPaddingLeft = 0;
    _this.axisPaddingRight = 0;
    return _this;
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */


  var _proto = SparkLine.prototype;

  _proto.getName = function getName() {
    return 'SparkLine';
  }
  /**
   * Set default configurations for chart
   */
  ;

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    _SparkChartBase.prototype.__setDefaultConfig.call(this);

    var config = this.config;
    config.friendlyName = FRIENDLY_NAME;
    config.singleseries = true;
    config.defaultDatasetType = SPARKLINE;
    config.showvalues = 0;
    config.anchorsides = 1;
    config.anchorstartangle = 90;
    config.enablemousetracking = true;
  }
  /**
   * Returns SparkLineDataset class
   * @return {Class} SparkLineDataset class
   */
  ;

  _proto.getDSdef = function getDSdef() {
    return _sparkline.default;
  };

  return SparkLine;
}(_sparkbase.default);

var _default = SparkLine;
exports["default"] = _default;

/***/ }),

/***/ 1529:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports._placeOpenCloseValues = _placeOpenCloseValues;
exports._parseCanvasCosmetics = _parseCanvasCosmetics;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _lib = __webpack_require__(274);

var _sparkbase = _interopRequireDefault(__webpack_require__(1526));

var _sparkwinloss = _interopRequireDefault(__webpack_require__(1530));

/* eslint require-jsdoc: 'error', valid-jsdoc: ["error", { "requireReturn": false }] */
var GUTTER_PADDING = 2,
    math = Math,
    mathMin = math.min,
    DS_TYPE = 'sparkwinloss',
    FRIENDLY_NAME = 'sparkwinloss Chart';
/**
 * Calculates space for values
 * @param {number} availableWidth available width for values
 * @return {Object} dimension taken by values(width, height)
 */

function _placeOpenCloseValues(availableWidth) {
  var iapi = this,
      config = iapi.config,
      smartLabel = iapi.getFromEnv('smartLabel'),
      style = config.dataLabelStyle,
      borderThickness = (0, _lib.pluckNumber)(style.borderThickness, 0),
      valuePadding = iapi.config.valuepadding + GUTTER_PADDING + borderThickness,
      openValueWidth = 0,
      closeValueWidth = 0,
      // height = chartConfig.height,
  // width = availableWidth,
  sparkValues = config.sparkValues || {},
      left,
      right;
  smartLabel.useEllipsesOnOverflow(config.useEllipsesWhenOverflow);
  smartLabel.setStyle(style);

  if (sparkValues.openValue && sparkValues.openValue.label) {
    sparkValues.openValue.smartObj = smartLabel.getSmartText(sparkValues.openValue.label);
    openValueWidth = sparkValues.openValue.smartObj.width + valuePadding;
  }

  if (sparkValues.closeValue && sparkValues.closeValue.label) {
    sparkValues.closeValue.smartObj = smartLabel.getSmartText(sparkValues.closeValue.label);
    closeValueWidth += sparkValues.closeValue.smartObj.width + valuePadding;
  }

  if (sparkValues.highValue && sparkValues.highValue.label) {
    sparkValues.highValue.smartObj = smartLabel.getSmartText(sparkValues.highValue.label);
  }

  if (sparkValues.lowValue && sparkValues.lowValue.label) {
    sparkValues.lowValue.smartObj = smartLabel.getSmartText(sparkValues.lowValue.label);
  }

  if (sparkValues.highLowValue && sparkValues.highLowValue.label) {
    sparkValues.highLowValue.smartObj = smartLabel.getSmartText(sparkValues.highLowValue.label);
    closeValueWidth += sparkValues.highLowValue.smartObj.width + valuePadding;
  } // Restrict the space to availableWidth


  left = sparkValues.openValueWidth = mathMin(openValueWidth, availableWidth);
  right = sparkValues.closeValueWidth = mathMin(closeValueWidth, availableWidth - left);
  return {
    left: left,
    right: right
  };
}
/**
 * Parse Canvas cosmetics
 * @return {Object} the canvas config that needs to be overridden
 */


function _parseCanvasCosmetics() {
  var canvasBorderThickness,
      showCanvasBorder,
      shadow,
      iapi = this,
      canvasConfig = {},
      chartAttrs = iapi.getFromEnv('dataSource').chart,
      colorM = iapi.getFromEnv('color-manager');
  canvasConfig.canvasBorderRadius = 0;
  canvasBorderThickness = canvasConfig.canvasBorderThickness = 0;
  showCanvasBorder = canvasConfig.showCanvasBorder = 0;
  canvasConfig.canvasBorderWidth = !showCanvasBorder ? 0 : canvasBorderThickness;
  canvasConfig.canvasBorderColor = (0, _lib.convertColor)((0, _lib.pluck)(chartAttrs.canvasbordercolor, colorM.getColor('canvasBorderColor'))); // Make canvas background transparent for sparkWinLoss and sparkLine charts.

  canvasConfig.canBGColor = {
    FCcolor: {
      color: 'ffffff',
      alpha: 0,
      angle: 0,
      ratio: _lib.UNDEF
    }
  };
  shadow = canvasConfig.shadow = 0;
  canvasConfig.shadowOnCanvasFill = shadow && shadow.enabled; // canvas padding

  canvasConfig.origCanvasTopPad = (0, _lib.pluckNumber)(chartAttrs.canvastoppadding, 0);
  canvasConfig.origCanvasBottomPad = (0, _lib.pluckNumber)(chartAttrs.canvasbottompadding, 0);
  canvasConfig.origCanvasLeftPad = (0, _lib.pluckNumber)(chartAttrs.canvasleftpadding, 0);
  canvasConfig.origCanvasRightPad = (0, _lib.pluckNumber)(chartAttrs.canvasrightpadding, 0);
  canvasConfig.canvasPadding = 0;
  return canvasConfig;
}
/**
 * Creates SparkWinLoss class
 */


var SparkWinLoss = /*#__PURE__*/function (_SparkChartBase) {
  (0, _inheritsLoose2.default)(SparkWinLoss, _SparkChartBase);

  /**
   * Provides the name of the chart extension
   *
   * @static
   * @return {string} The name of the chart extension
   */
  SparkWinLoss.getName = function getName() {
    return 'SparkWinLoss';
  }
  /**
   * Constructor function of class SparkWinLoss
   */
  ;

  function SparkWinLoss() {
    var _this;

    _this = _SparkChartBase.call(this) || this;
    _this._placeOpenCloseValues = _placeOpenCloseValues;
    _this._parseCanvasCosmetics = _parseCanvasCosmetics;
    return _this;
  }
  /**
   * Parse the chart attributes and store in chart's config
   * @param {Object} dataObj User input json
   */


  var _proto = SparkWinLoss.prototype;

  _proto.parseChartAttr = function parseChartAttr(dataObj) {
    _SparkChartBase.prototype.parseChartAttr.call(this, dataObj);

    this.config.drawTrendRegion = 0;
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */
  ;

  _proto.getName = function getName() {
    return 'SparkWinLoss';
  }
  /**
   * Set default configurations for chart
   */
  ;

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    _SparkChartBase.prototype.__setDefaultConfig.call(this);

    var config = this.config;
    config.friendlyName = FRIENDLY_NAME;
    config.singleseries = true;
    config.defaultDatasetType = DS_TYPE;
    config.enablemousetracking = true;
    config.yRangeMin = -1;
    config.yRangeMax = 1;
    config.canvasborderthickness = 0;
  }
  /**
   * Returns Dataset type for Spark Win Loss
   * @return {Class} SparkWinLossDataset class
   */
  ;

  _proto.getDSdef = function getDSdef() {
    return _sparkwinloss.default;
  };

  return SparkWinLoss;
}(_sparkbase.default);

var _default = SparkWinLoss;
exports["default"] = _default;

/***/ }),

/***/ 1521:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _lib = __webpack_require__(274);

var _thermometer = _interopRequireDefault(__webpack_require__(1522));

var _vledDataset = _interopRequireDefault(__webpack_require__(1484));

var _lineargauge = _interopRequireDefault(__webpack_require__(1487));

var UNDEF,
    gaugeFillColorStr = _lib.preDefStr.gaugeFillColorStr,
    gaugeBorderColorStr = _lib.preDefStr.gaugeBorderColorStr,
    defined = function defined(obj) {
  return obj !== UNDEF && obj !== null;
},
    FRIENDLY_NAME = 'Horizontal Linear Gauge',
    THERMOMETER = 'thermometer',
    EASE_OUT = 'easeOut',
    RIGHT = 'right',
    LEFT = 'left';

var Thermometer = /*#__PURE__*/function (_LinearGauge) {
  (0, _inheritsLoose2.default)(Thermometer, _LinearGauge);

  /**
   * Provides the name of the chart extension
   *
   * @static
   * @return {string} The name of the chart extension
   */
  Thermometer.getName = function getName() {
    return 'Thermometer';
  };

  function Thermometer() {
    var _this;

    _this = _LinearGauge.call(this) || this;
    _this.showRTvalue = false;
    _this.canvasPadding = false;
    _this.defaultPaletteOptions = (0, _lib.extend2)((0, _lib.extend2)({}, _lib.defaultGaugePaletteOptions), {
      gaugeBorderColor: ['545454', '60634E', '415D6F', '845001', '68001B'],
      gaugeFillColor: ['999999', 'ADB68F', 'A2C4C8', 'FDB548', 'FF7CA0'],
      periodColor: ['EEEEEE', 'ECEEE6', 'E6ECF0', 'FFF4E6', 'FFF2F5']
    }, false, true);
    _this.isHorizontal = false;
    _this.config.isAxisOpposite = true;
    _this.config.scalePosition = RIGHT;
    _this.config.canBeScalePosition = LEFT;
    _this.hasCanvas = true;
    _this.drawPlotlines = false;
    _this.drawPlotBands = false;
    _this.isAxisReverse = false;
    _this.isRealTime = true;

    _this.registerFactory('dataset', _vledDataset.default, ['vCanvas']);

    return _this;
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */


  var _proto = Thermometer.prototype;

  _proto.getName = function getName() {
    return 'Thermometer';
  };

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    _LinearGauge.prototype.__setDefaultConfig.call(this);

    var config = this.config;
    config.alignCaptionWithCanvas = 1;
    config.friendlyName = FRIENDLY_NAME;
    config.hasLegend = false;
    config.defaultDatasetType = THERMOMETER;
    config.animationeffect = EASE_OUT;
    config.skipCanvasDrawing = true;
  };

  _proto._getData = function _getData() {
    var iapi = this,
        dataset = iapi.getChildren('dataset');

    if (dataset && dataset[0]) {
      return dataset[0].config.value;
    }
  } // todo: this function need to be removed once the flow is proper
  ;

  _proto._parseSpecialConfig = function _parseSpecialConfig() {
    var iapi = this,
        chartConfig = iapi.config,
        dataObj = iapi.getFromEnv('dataSource'),
        chartOptions = dataObj.chart,
        numberFormatter = iapi.getFromEnv('number-formatter'),
        colorM = iapi.getFromEnv('color-manager'),
        gaugeBorderAlpha;
    chartConfig.use3DLighting = (0, _lib.pluckNumber)(chartOptions.use3dlighting, 1);
    chartConfig.thmOriginX = (0, _lib.pluckNumber)(chartOptions.thmoriginx, chartOptions.gaugeoriginx);
    chartConfig.thmOriginY = (0, _lib.pluckNumber)(chartOptions.thmoriginy, chartOptions.gaugeoriginy);
    chartConfig.thmBulbRadius = (0, _lib.pluckNumber)(numberFormatter.getCleanValue(chartOptions.thmbulbradius, true));
    chartConfig.thmHeight = (0, _lib.pluckNumber)(numberFormatter.getCleanValue((0, _lib.pluckNumber)(chartOptions.thmheight, chartOptions.gaugeheight), true));
    chartConfig.origW = (0, _lib.pluckNumber)(chartOptions.origw);
    chartConfig.origH = (0, _lib.pluckNumber)(chartOptions.origh); // set the falg whether the measurements are defined by user or not

    chartConfig.xDefined = defined(chartConfig.thmOriginX);
    chartConfig.yDefined = defined(chartConfig.thmOriginY);
    chartConfig.rDefined = defined(chartConfig.thmBulbRadius);
    chartConfig.hDefined = defined(chartConfig.thmHeight);
    chartConfig.gaugeFillColor = (0, _lib.pluck)(chartOptions.gaugefillcolor, chartOptions.thmfillcolor, colorM.getColor(gaugeFillColorStr));
    chartConfig.gaugeFillAlpha = (0, _lib.pluckNumber)(chartOptions.gaugefillalpha, chartOptions.thmfillalpha, _lib.HUNDREDSTRING); // Gauge Border properties

    chartConfig.showGaugeBorder = (0, _lib.pluckNumber)(chartOptions.showgaugeborder, 1);
    gaugeBorderAlpha = chartConfig.showGaugeBorder ? (0, _lib.pluckNumber)(chartOptions.gaugeborderalpha, 40) : 0; // We are using 40 for default alpha of Thermometer Gauge Border

    chartConfig.gaugeBorderColor = (0, _lib.convertColor)((0, _lib.pluck)(chartOptions.gaugebordercolor, colorM.getColor(gaugeBorderColorStr)), gaugeBorderAlpha);
    chartConfig.gaugeBorderThickness = (0, _lib.pluckNumber)(chartOptions.gaugeborderthickness, 1); // Thermometer Glass color

    chartConfig.gaugeContainerColor = (0, _lib.pluck)(chartOptions.thmglasscolor, (0, _lib.getLightColor)(chartConfig.gaugeFillColor, 30));
  };

  _proto.allocatePosition = function allocatePosition() {
    var iapi = this,
        chartConfig = iapi.config,
        canvasLeft = chartConfig.canvasLeft,
        canvasRight = chartConfig.canvasRight,
        canvasTop = chartConfig.canvasTop,
        canvasWidth = chartConfig.canvasWidth,
        canvasHeight = chartConfig.canvasHeight,
        canvasBottom = chartConfig.canvasBottom; // Setting macros for annotation

    chartConfig.gaugeStartX = canvasLeft;
    chartConfig.gaugeEndX = canvasRight;
    chartConfig.gaugeStartY = canvasTop;
    chartConfig.gaugeEndY = canvasBottom;
    chartConfig.gaugeCenterX = canvasLeft + canvasWidth * 0.5;
    chartConfig.gaugeCenterY = canvasTop + canvasHeight * 0.5;
    chartConfig.gaugeRadius = canvasWidth * 0.5;
  };

  _proto.getDSdef = function getDSdef() {
    return _thermometer.default;
  };

  return Thermometer;
}(_lineargauge.default);

var _default = Thermometer;
exports["default"] = _default;

/***/ }),

/***/ 1557:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _lib = __webpack_require__(274);

var _lineargauge = _interopRequireDefault(__webpack_require__(1487));

var _bulletLedCommon = __webpack_require__(1511);

var _bullet = _interopRequireDefault(__webpack_require__(1513));

var _vledDataset = _interopRequireDefault(__webpack_require__(1484));

var _equal = _interopRequireDefault(__webpack_require__(421));

var UNDEF,
    zeroCommaHundredStr = '0,100',
    BULLET = 'bullet',
    FRIENDLY_NAME = 'Vertical Bullet Gauge',
    RIGHT = 'right',
    LEFT = 'left';

var Vbullet = /*#__PURE__*/function (_LinearGauge) {
  (0, _inheritsLoose2.default)(Vbullet, _LinearGauge);

  /**
   * Provides the name of the chart extension
   *
   * @static
   * @return {string} The name of the chart extension
   */
  Vbullet.getName = function getName() {
    return 'Vbullet';
  };

  function Vbullet() {
    var _this;

    _this = _LinearGauge.call(this) || this;
    _this.defaultSeriesType = BULLET;
    _this.gaugeType = 4;
    _this.ticksOnRight = 0;
    _this.hasCanvas = true;
    _this.isHorizontal = false;
    _this.config.isAxisOpposite = false;
    _this.config.scalePosition = LEFT;
    _this.config.canBeScalePosition = RIGHT;
    _this.isAxisReverse = false;
    _this.defaultPaletteOptions = {
      // Store colors now
      paletteColors: [['A6A6A6', 'CCCCCC', 'E1E1E1', 'F0F0F0'], ['A7AA95', 'C4C6B7', 'DEDFD7', 'F2F2EE'], ['04C2E3', '66E7FD', '9CEFFE', 'CEF8FF'], ['FA9101', 'FEB654', 'FED7A0', 'FFEDD5'], ['FF2B60', 'FF6C92', 'FFB9CB', 'FFE8EE']],
      // Store other colors
      // ------------- For 2D Chart ---------------//
      // We're storing 5 combinations, as we've 5 defined palettes.
      bgColor: ['FFFFFF', 'CFD4BE,F3F5DD', 'C5DADD,EDFBFE', 'A86402,FDC16D', 'FF7CA0,FFD1DD'],
      bgAngle: [270, 270, 270, 270, 270],
      bgRatio: [zeroCommaHundredStr, zeroCommaHundredStr, zeroCommaHundredStr, zeroCommaHundredStr, zeroCommaHundredStr],
      bgAlpha: ['100', '60,50', '40,20', '20,10', '30,30'],
      toolTipBgColor: ['FFFFFF', 'FFFFFF', 'FFFFFF', 'FFFFFF', 'FFFFFF'],
      toolTipBorderColor: ['545454', '545454', '415D6F', '845001', '68001B'],
      baseFontColor: ['333333', '60634E', '025B6A', 'A15E01', '68001B'],
      tickColor: ['333333', '60634E', '025B6A', 'A15E01', '68001B'],
      trendColor: ['545454', '60634E', '415D6F', '845001', '68001B'],
      plotFillColor: ['545454', '60634E', '415D6F', '845001', '68001B'],
      borderColor: ['767575', '545454', '415D6F', '845001', '68001B'],
      borderAlpha: [50, 50, 50, 50, 50]
    };
    _this.showRTvalue = false;
    _this.canvasPadding = false;
    _this.defaultPlotShadow = 1;
    _this.realtimeEnabled = true;
    _this.chartleftmargin = 15;
    _this.chartrightmargin = 15;
    _this.charttopmargin = 10;
    _this.chartbottommargin = 10;
    _this.showTooltip = 0;
    _this.connectTickMarks = 0;
    _this.drawPlotlines = false;
    _this.drawPlotBands = false;
    _this.isRealTime = true;
    _this.colorRange = true;

    _this.registerFactory('dataset', _vledDataset.default, ['vCanvas']);

    return _this;
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */


  var _proto = Vbullet.prototype;

  _proto.getName = function getName() {
    return 'Vbullet';
  }
  /**
   * function to create component and configure and also configure the chart
   * It creates components which are depend on data and configure them and also configure chart
   * It calls helper function namely, configure
   * @param  {Object} dataObj contains json data of the chart
   */
  ;

  _proto.configureAttributes = function configureAttributes(dataObj) {
    _LinearGauge.prototype.configureAttributes.call(this, dataObj);

    _bulletLedCommon.configureAttributes.call(this);
  }
  /**
   * Method to fetch data
   * @return {Number} data value
   */
  ;

  _proto._getData = function _getData() {
    return _bulletLedCommon._getData.call(this);
  };

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    _LinearGauge.prototype.__setDefaultConfig.call(this);

    var config = this.config;
    config.friendlyName = FRIENDLY_NAME;
    config.defaultDatasetType = BULLET;
    config.singleseries = true;
    config.skipCanvasDrawing = true;
  };

  _proto.getDSdef = function getDSdef() {
    return _bullet.default;
  };

  _proto._feedAxesRawData = function _feedAxesRawData() {
    var iapi = this,
        config = iapi.config,
        colorM = iapi.getFromEnv('color-manager'),
        dataObj = iapi.getFromEnv('dataSource'),
        chartAttrs = dataObj.chart,
        numberFormatter = iapi.getFromEnv('number-formatter'),
        scaleConf,
        palleteString = _lib.chartPaletteStr.chart2D,
        ticksOnRight = (0, _lib.pluckNumber)(chartAttrs.ticksonright),
        isAxisOpposite = (0, _lib.pluckNumber)((0, _equal.default)(chartAttrs.scaleposition, config.scalePosition) ? config.isAxisOpposite : (0, _equal.default)(chartAttrs.scaleposition, config.canBeScalePosition) ? !config.isAxisOpposite : UNDEF, ticksOnRight !== UNDEF ? ticksOnRight : UNDEF, config.isAxisOpposite),
        outCanfontSizeWithUnit = (0, _lib.pluckFontSizeMaintainUnit)(chartAttrs.outcnvbasefontsize, chartAttrs.basefontsize, 10);
    scaleConf = {
      isVertical: !iapi.isHorizontal,
      isReverse: true,
      isOpposit: isAxisOpposite,
      outCanfontFamily: (0, _lib.pluck)(chartAttrs.outcnvbasefont, chartAttrs.basefont, 'Verdana,sans'),
      outCanfontSize: this.computeFontSize(outCanfontSizeWithUnit),
      outCanfontSizeWithUnit: outCanfontSizeWithUnit,
      outCancolor: (0, _lib.pluck)(chartAttrs.outcnvbasefontcolor, chartAttrs.basefontcolor, colorM.getColor(palleteString.baseFontColor)).replace(/^#?([a-f0-9]+)/ig, '#$1'),
      // axisNamePadding: chartAttrs.xaxisnamepadding,
      // axisValuePadding: chartAttrs.labelpadding,
      // axisNameFont: chartAttrs.xaxisnamefont,
      // axisNameFontSize: chartAttrs.xaxisnamefontsize,
      // axisNameFontColor: chartAttrs.xaxisnamefontcolor,
      // axisNameFontBold: chartAttrs.xaxisnamefontbold,
      // axisNameFontItalic: chartAttrs.xaxisnamefontitalic,
      // axisNameBgColor: chartAttrs.xaxisnamebgcolor,
      // axisNameBorderColor: chartAttrs.xaxisnamebordercolor,
      // axisNameAlpha: chartAttrs.xaxisnamealpha,
      // axisNameFontAlpha: chartAttrs.xaxisnamefontalpha,
      // axisNameBgAlpha: chartAttrs.xaxisnamebgalpha,
      // axisNameBorderAlpha: chartAttrs.xaxisnameborderalpha,
      // axisNameBorderPadding: chartAttrs.xaxisnameborderpadding,
      // axisNameBorderRadius: chartAttrs.xaxisnameborderradius,
      // axisNameBorderThickness: chartAttrs.xaxisnameborderthickness,
      // axisNameBorderDashed: chartAttrs.xaxisnameborderdashed,
      // axisNameBorderDashLen: chartAttrs.xaxisnameborderdashlen,
      // axisNameBorderDashGap: chartAttrs.xaxisnameborderdashgap,
      useEllipsesWhenOverflow: chartAttrs.useellipseswhenoverflow,
      divLineColor: (0, _lib.pluck)(chartAttrs.vdivlinecolor, colorM.getColor(palleteString.divLineColor)),
      divLineAlpha: (0, _lib.pluck)(chartAttrs.vdivlinealpha, colorM.getColor('divLineAlpha')),
      divLineThickness: (0, _lib.pluckNumber)(chartAttrs.vdivlinethickness, 1),
      divLineIsDashed: Boolean((0, _lib.pluckNumber)(chartAttrs.vdivlinedashed, chartAttrs.vdivlineisdashed, 0)),
      divLineDashLen: (0, _lib.pluckNumber)(chartAttrs.vdivlinedashlen, 4),
      divLineDashGap: (0, _lib.pluckNumber)(chartAttrs.vdivlinedashgap, 2),
      showAlternateGridColor: (0, _lib.pluckNumber)(chartAttrs.showalternatevgridcolor, 0),
      alternateGridColor: (0, _lib.pluck)(chartAttrs.alternatevgridcolor, colorM.getColor('altVGridColor')),
      alternateGridAlpha: (0, _lib.pluck)(chartAttrs.alternatevgridalpha, colorM.getColor('altVGridAlpha')),
      numDivLines: chartAttrs.numvdivlines,
      labelFont: chartAttrs.labelfont,
      labelFontSize: this.computeFontSize(chartAttrs.labelfontsize),
      labelFontSizeWithUnit: chartAttrs.labelfontsize,
      labelFontColor: chartAttrs.labelfontcolor,
      labelAlpha: chartAttrs.labelalpha,
      labelFontBold: chartAttrs.labelfontbold,
      labelFontItalic: chartAttrs.labelfontitalic,
      axisName: chartAttrs.xaxisname,
      axisMinValue: numberFormatter.getCleanValue(chartAttrs.lowerlimit),
      axisMaxValue: numberFormatter.getCleanValue(chartAttrs.upperlimit),
      setAdaptiveMin: chartAttrs.setadaptivexmin,
      // adjusttm will be internally parsed as adjustdiv
      adjustDiv: chartAttrs.adjusttm,
      labelDisplay: chartAttrs.labeldisplay,
      showLabels: chartAttrs.showlabels,
      rotateLabels: chartAttrs.rotatelabels,
      slantLabel: (0, _lib.pluckNumber)(chartAttrs.slantlabels, chartAttrs.slantlabel),
      labelStep: (0, _lib.pluckNumber)(chartAttrs.labelstep, chartAttrs.xaxisvaluesstep),
      showAxisValues: (0, _lib.pluckNumber)(chartAttrs.showxaxisvalues, chartAttrs.showxaxisvalue),
      showDivLineValues: (0, _lib.pluckNumber)(chartAttrs.showvdivlinevalues, chartAttrs.showvdivlinevalues),
      showZeroPlane: chartAttrs.showvzeroplane,
      zeroPlaneColor: chartAttrs.vzeroplanecolor,
      zeroPlaneThickness: chartAttrs.vzeroplanethickness,
      zeroPlaneAlpha: chartAttrs.vzeroplanealpha,
      showZeroPlaneValue: chartAttrs.showvzeroplanevalue,
      trendlineColor: chartAttrs.trendlinecolor,
      trendlineToolText: chartAttrs.trendlinetooltext,
      trendlineThickness: chartAttrs.trendlinethickness,
      trendlineAlpha: chartAttrs.trendlinealpha,
      showTrendlinesOnTop: chartAttrs.showtrendlinesontop,
      showAxisLine: (0, _lib.pluckNumber)(chartAttrs.showxaxisline, chartAttrs.showaxislines, chartAttrs.drawAxisLines, 0),
      axisLineThickness: (0, _lib.pluckNumber)(chartAttrs.xaxislinethickness, chartAttrs.axislinethickness, 1),
      axisLineAlpha: (0, _lib.pluckNumber)(chartAttrs.xaxislinealpha, chartAttrs.axislinealpha, 100),
      axisLineColor: (0, _lib.pluck)(chartAttrs.xaxislinecolor, chartAttrs.axislinecolor, '#000000'),
      // Tick properties
      majorTMNumber: chartAttrs.majortmnumber,
      majorTMColor: chartAttrs.majortmcolor,
      majorTMAlpha: chartAttrs.majortmalpha,
      majorTMHeight: chartAttrs.majortmheight,
      tickValueStep: chartAttrs.tickvaluestep,
      showTickMarks: chartAttrs.showtickmarks,
      connectTickMarks: chartAttrs.connecttickmarks,
      showTickValues: chartAttrs.showtickvalues,
      majorTMThickness: chartAttrs.majortmthickness,
      reverseScale: chartAttrs.reversescale,
      // Whether to display the Limits
      showLimits: (0, _lib.pluckNumber)(chartAttrs.showlimits, chartAttrs.showtickmarks),
      minorTMNumber: (0, _lib.pluckNumber)(chartAttrs.minortmnumber, 0),
      minorTMColor: chartAttrs.minortmcolor,
      minorTMAlpha: chartAttrs.minortmalpha,
      minorTMHeight: (0, _lib.pluckNumber)(chartAttrs.minortmheight, chartAttrs.minortmwidth),
      minorTMThickness: chartAttrs.minortmthickness,
      // Padding between tick mark start position and gauge
      tickMarkDistance: (0, _lib.pluckNumber)(chartAttrs.tickmarkdistance, chartAttrs.tickmarkgap),
      // Tick value distance
      tickValueDistance: (0, _lib.pluckNumber)(chartAttrs.tickvaluedistance, chartAttrs.displayvaluedistance),
      placeTicksInside: chartAttrs.placeticksinside,
      placeValuesInside: chartAttrs.placevaluesinside,
      upperLimitDisplay: chartAttrs.upperlimitdisplay,
      lowerLimitDisplay: chartAttrs.lowerlimitdisplay
    };
    return [scaleConf];
  } // _drawCanvas: stubFN
  ;

  return Vbullet;
}(_lineargauge.default);

var _default = Vbullet;
exports["default"] = _default;

/***/ }),

/***/ 1510:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _bulletLedCommon = __webpack_require__(1511);

var _lineargauge = _interopRequireDefault(__webpack_require__(1487));

var _led = _interopRequireDefault(__webpack_require__(1512));

var _vledDataset = _interopRequireDefault(__webpack_require__(1484));

var LED = 'led',
    FRIENDLY_NAME = 'Vertical LED Gauge',
    LEFT = 'left',
    RIGHT = 'right';

var Vled = /*#__PURE__*/function (_LinearGauge) {
  (0, _inheritsLoose2.default)(Vled, _LinearGauge);

  /**
   * Provides the name of the chart extension
   *
   * @static
   * @return {string} The name of the chart extension
   */
  Vled.getName = function getName() {
    return 'Vled';
  };

  function Vled() {
    var _this;

    _this = _LinearGauge.call(this) || this;
    _this.showRTvalue = false;
    _this.canvasPadding = false;
    _this.defaultSeriesType = LED;
    _this.defaultPlotShadow = 1;
    _this.realtimeEnabled = true;
    _this.chartleftmargin = 15;
    _this.chartrightmargin = 15;
    _this.charttopmargin = 10;
    _this.chartbottommargin = 10;
    _this.showTooltip = 0;
    _this.connectTickMarks = 0;
    _this.isHorizontal = false;
    _this.config.isAxisOpposite = true;
    _this.config.scalePosition = RIGHT;
    _this.config.canBeScalePosition = LEFT;
    _this.drawPlotlines = false;
    _this.drawPlotBands = false;
    _this.isAxisReverse = false;
    _this.isRealTime = true;
    _this.colorRange = true;

    _this.registerFactory('dataset', _vledDataset.default, ['vCanvas']);

    return _this;
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */


  var _proto = Vled.prototype;

  _proto.getName = function getName() {
    return 'Vled';
  };

  _proto.configureAttributes = function configureAttributes(dataObj) {
    _LinearGauge.prototype.configureAttributes.call(this, dataObj);

    _bulletLedCommon.configureAttributes.call(this);
  }
  /**
   * Method to fetch data
   * @return {Number} data value
   */
  ;

  _proto._getData = function _getData() {
    return _bulletLedCommon._getData.call(this);
  };

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    _LinearGauge.prototype.__setDefaultConfig.call(this);

    var config = this.config;
    config.friendlyName = FRIENDLY_NAME;
    config.hasLegend = false;
    config.defaultDatasetType = LED;
    config.skipCanvasDrawing = true;
    config.majorTMNumber = -1;
    config.majorTMHeight = 6;
    config.showTickMarks = 1;
    config.majorTMThickness = 1;
    config.minorTMNumber = 4;
    config.minorTMThickness = 1;
    config.tickMarkDistance = 3;
    config.placeTicksInside = 0;
    config.placeValuesInside = 0;
  };

  _proto.getDSdef = function getDSdef() {
    return _led.default;
  };

  return Vled;
}(_lineargauge.default);

var _default = Vled;
exports["default"] = _default;

/***/ }),

/***/ 1494:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _lib = __webpack_require__(274);

var _componentInterface = __webpack_require__(290);

/* eslint require-jsdoc: 'error', valid-jsdoc: ["error", { "requireReturn": false }] */
var UNDEF,
    BLANKSTRING = _lib.BLANK,
    AXISPOSITION_TOP = 1,
    AXISPOSITION_BOTTOM = 3,
    gaugeFillColorStr = _lib.preDefStr.gaugeFillColorStr,
    gaugeBorderColorStr = _lib.preDefStr.gaugeBorderColorStr,
    dummyStr = 'dummy',
    FILLMIXDARK10 = '{dark-10}';
/**
 * Base class of thermometer and cylinder dataset
 *
 * @class CylinderThermometerBase
 * @extends {ComponentInterface}
 */

var CylinderThermometerBase = /*#__PURE__*/function (_ComponentInterface) {
  (0, _inheritsLoose2.default)(CylinderThermometerBase, _ComponentInterface);

  function CylinderThermometerBase() {
    return _ComponentInterface.apply(this, arguments) || this;
  }

  var _proto = CylinderThermometerBase.prototype;

  /**
   * returns type
   *
   * @return {string} dataset
   * @memberof CylinderThermometerBase
   */
  _proto.getType = function getType() {
    return 'dataset';
  }
  /**
   * Returns name
   *
   * @return {string} name
   * @memberof CylinderThermometerBase
   */
  ;

  _proto.getName = function getName() {
    return 'cylinderThermometerBase';
  }
  /**
   * Function to update the value
   * @param {number} setData : value that will be added
   * @param {boolean} draw : whether to update the visuals also
   */
  ;

  _proto.setValue = function setValue(setData, draw) {
    if (!setData) {
      return;
    }

    var dataSet = this,
        datasetConfig = dataSet.config,
        chart = dataSet.getFromEnv('chart'),
        jsonChartObj = chart.getFromEnv('dataSource').chart,
        numberFormatter = dataSet.getFromEnv('number-formatter'),
        value = setData.value,
        color = setData.color,
        tooltext = setData.tooltext || jsonChartObj.plottooltext,
        formattedValue;
    datasetConfig.value = value = numberFormatter.getCleanValue(value);

    if (color) {
      datasetConfig.gaugeFillColor = color;
      datasetConfig.plotFillHoverColor = color;
    }

    if (value !== null) {
      formattedValue = datasetConfig.formattedValue = numberFormatter.dataLabels(datasetConfig.value);

      if (!datasetConfig.showValue) {
        datasetConfig.displayValue = BLANKSTRING;
      } else {
        // determine the dispalay value then
        datasetConfig.displayValue = setData.label || (0, _lib.getValidValue)(formattedValue, _lib.BLANK);
      }

      if (!datasetConfig.showTooltip) {
        datasetConfig.toolText = BLANKSTRING;
      } else if (tooltext !== UNDEF) {
        datasetConfig.toolText = (0, _lib.parseUnsafeString)((0, _lib.parseTooltext)((0, _lib.pluck)(setData.tooltext, tooltext), [1, 2], {
          formattedValue: formattedValue,
          value: value
        }, setData, jsonChartObj), false);
      } else {
        // determine the dispalay value then
        datasetConfig.toolText = (0, _lib.parseUnsafeString)((0, _lib.parseTooltext)((0, _lib.pluck)(setData.tooltext, formattedValue === null ? BLANKSTRING : formattedValue)), false);
      }
    } else {
      datasetConfig.displayValue = BLANKSTRING;
      datasetConfig.toolText = BLANKSTRING;
      datasetConfig.formattedValue = null;
    }

    if (draw) {
      dataSet.draw();
    }
  }
  /**
    * Function for parsing all the attributes and value given by the user at chart,dataset and set level
    * @param  {Object} dataSetJson JSON for dataset configurations
    * @return {boolean} Indicates whether the configuration was successful or not
    */
  ;

  _proto.configure = function configure(dataSetJson) {
    if (!dataSetJson) {
      return false;
    }

    this.setValue(dataSetJson && dataSetJson.data && dataSetJson.data[0]);
    var dataSet = this,
        chart = dataSet.getFromEnv('chart'),
        jsonData = chart.getFromEnv('dataSource'),
        chartAttrs = jsonData.chart,
        datasetConfig = dataSet.config || (dataSet.config = {}),
        colorM = dataSet.getFromEnv('color-manager'),
        chartConfig = chart.config,
        gaugeBorderAlpha,
        showHoverEffect = (0, _lib.pluckNumber)(chartAttrs.showhovereffect),
        plotFillHoverColor,
        gaugeFillAlpha,
        gaugeFillColor;
    datasetConfig.showValue = (0, _lib.pluckNumber)(chartAttrs.showvalue, chartAttrs.showvalues, 1);
    datasetConfig.showTooltip = (0, _lib.pluckNumber)(chartAttrs.showtooltip, 1);
    datasetConfig.valuePadding = (0, _lib.pluckNumber)(chartAttrs.valuepadding, 2);
    datasetConfig.tooltipSepChar = (0, _lib.pluck)(chartAttrs.tooltipsepchar, _lib.COMMASTRING);
    datasetConfig.pointerOnOpp = (0, _lib.pluckNumber)(chartAttrs.pointerontop, 0);
    datasetConfig.axisPosition = (0, _lib.pluckNumber)(chartAttrs.ticksbelowgauge, chartAttrs.ticksbelowgraph, this.ticksbelowgauge, 1) ? AXISPOSITION_BOTTOM : AXISPOSITION_TOP;
    datasetConfig.valueAbovePointer = (0, _lib.pluckNumber)(chartAttrs.valueabovepointer, 1);
    datasetConfig.labelStyle = chartConfig.dataLabelStyle;
    gaugeFillColor = datasetConfig.gaugeFillColor = (0, _lib.pluck)(chartAttrs.gaugefillcolor, chartAttrs.thmfillcolor, chartAttrs.cylfillcolor, colorM.getColor(gaugeFillColorStr));
    gaugeFillAlpha = datasetConfig.gaugeFillAlpha = (0, _lib.pluckNumber)(chartAttrs.gaugefillalpha, chartAttrs.cylfillalpha, chartAttrs.thmfillalpha, _lib.HUNDREDSTRING); // Gauge Border properties

    datasetConfig.showGaugeBorder = (0, _lib.pluckNumber)(chartAttrs.showgaugeborder, 1);
    gaugeBorderAlpha = datasetConfig.showGaugeBorder ? (0, _lib.pluckNumber)(chartAttrs.gaugeborderalpha, 40) : 0;
    datasetConfig.rawGaugeBorderColor = (0, _lib.pluck)(chartAttrs.gaugebordercolor, colorM.getColor(gaugeBorderColorStr));
    datasetConfig.gaugeBorderAlpha = gaugeBorderAlpha; // We are using 40 for default alpha of Thermometer Gauge Border

    datasetConfig.gaugeBorderColor = (0, _lib.convertColor)(datasetConfig.rawGaugeBorderColor, gaugeBorderAlpha);
    datasetConfig.gaugeBorderThickness = (0, _lib.pluckNumber)(chartAttrs.gaugeborderthickness, 1); // Thermometer Glass color

    datasetConfig.gaugeContainerColor = (0, _lib.pluck)(chartAttrs.thmglasscolor, chartAttrs.cylglasscolor, chart.glasscolor, (0, _lib.getLightColor)(gaugeFillColor, 30));

    if (showHoverEffect !== 0 && (showHoverEffect || chartAttrs.plotfillhovercolor || chartAttrs.plotfillhoveralpha || chartAttrs.plotfillhoveralpha === 0)) {
      datasetConfig.showHoverEffect = true;
      plotFillHoverColor = (0, _lib.pluck)(chartAttrs.plotfillhovercolor, chartAttrs.cylfillhovercolor, chartAttrs.thmfillhovercolor, FILLMIXDARK10);
      datasetConfig.plotFillHoverAlpha = (0, _lib.pluckNumber)(chartAttrs.plotfillhoveralpha, chartAttrs.cylfillhoveralpha, chartAttrs.thmfillhoveralpha, gaugeFillAlpha);
      datasetConfig.plotFillHoverColor = /\{/.test(plotFillHoverColor) ? colorM.parseColorMix(gaugeFillColor, plotFillHoverColor)[0] : plotFillHoverColor;
    }

    dataSet.setValue(jsonData);
    chart._parseSpecialConfig && chart._parseSpecialConfig();
  }
  /**
   * Fetch space taken by labels
   * @return {number} height taken by data label
   */
  ;

  _proto._getLabelSpace = function _getLabelSpace() {
    var dataSet = this,
        datasetConfig = dataSet.config,
        chart = dataSet.getFromEnv('chart'),
        smartLabel = dataSet.getFromEnv('smartLabel'),
        labelObj;
    smartLabel.useEllipsesOnOverflow(chart.config.useEllipsesWhenOverflow);
    smartLabel.setStyle(datasetConfig.labelStyle); // @todo map datalabel style

    labelObj = smartLabel.getOriSize(datasetConfig.displayValue !== _lib.BLANK ? datasetConfig.displayValue : dummyStr);
    return labelObj.height ? labelObj.height + datasetConfig.valuePadding : 0;
  }
  /**
   * Fetch data limits for scale
   * @return {Object} returns max, min of data limits
   */
  ;

  _proto.getDataLimits = function getDataLimits() {
    var dataSet = this,
        datasetConfig = dataSet.config,
        min,
        max;
    max = min = datasetConfig.value;
    datasetConfig.maxValue = max;
    datasetConfig.minValue = min;
    return {
      forceMin: true,
      forceMax: true,
      max: max,
      min: min
    };
  }
  /**
   * Updates data during realTime
   */
  ;

  _proto.updateData = function updateData() {
    var dataSet = this,
        dataObj = arguments[0],
        draw = arguments[2],
        conf = dataSet.config,
        prevMax = conf.maxValue,
        prevMin = conf.prevMin,
        value = conf.value,
        chart = dataSet.getFromEnv('chart'),
        drawManager = dataSet.groupManager || dataSet,
        scale = dataSet.getFromEnv('scale');
    dataSet.setValue(dataObj.data[0]);
    conf.maxValue = value;
    conf.minValue = value;

    if (conf.maxValue !== prevMax || conf.minValue !== prevMin) {
      dataSet.config.maxminFlag = true;
    }

    if (draw) {
      chart._setAxisLimits();

      scale.draw();
      drawManager.draw();
    }
  }
  /**
   * function to set index for the dataset component
   * @param {number} index    index according to the index JSON
   */
  ;

  _proto.setJSONIndex = function setJSONIndex(index) {
    this.config.index = index;
  }
  /**
   * function to return index for the dataset component
   * @return {number}    index according to the index JSON
   */
  ;

  _proto.getJSONIndex = function getJSONIndex() {
    return this.config.index || 0;
  };

  return CylinderThermometerBase;
}(_componentInterface.ComponentInterface);

var _default = CylinderThermometerBase;
exports["default"] = _default;

/***/ }),

/***/ 1564:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _funnelpyramidbasePoint = _interopRequireDefault(__webpack_require__(1565));

var _lib = __webpack_require__(274);

var UNDEF,
    POINTER = 'pointer',
    POSITION_START = _lib.preDefStr.POSITION_START,
    POSITION_END = _lib.preDefStr.POSITION_END,
    POSITION_MIDDLE = _lib.preDefStr.POSITION_MIDDLE,
    textHAlign = {
  right: POSITION_END,
  left: POSITION_START,
  middle: POSITION_MIDDLE,
  start: POSITION_START,
  end: POSITION_END,
  center: POSITION_MIDDLE,
  'undefined': _lib.BLANK,
  BLANK: _lib.BLANK
};

var FunnelPoint = /*#__PURE__*/function (_FunnelPyramidBasePoi) {
  (0, _inheritsLoose2.default)(FunnelPoint, _FunnelPyramidBasePoi);

  function FunnelPoint() {
    return _FunnelPyramidBasePoi.apply(this, arguments) || this;
  }

  var _proto = FunnelPoint.prototype;

  /**
   * Configures an instance of FunnelPoint.
   * @param {any} [options={}]
   * @memberof FunnelPoint
   */
  _proto.configure = function configure(options) {
    if (options === void 0) {
      options = {};
    }

    for (var key in options) {
      this[key] = options[key];
    }

    this.upperRadiusFactor = 1;
  }
  /**
   * Sets the type of the component
   * @return {string} type
   */
  ;

  _proto.getType = function getType() {
    return 'data';
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */
  ;

  _proto.getName = function getName() {
    return 'funnelpoint';
  }
  /**
   * Returns value after modifying
   *
   * @returns {any}
   * @memberof FunnelPoint
   */
  // eslint-disable-next-line
  ;

  _proto.getModifiedCurrentValue = function getModifiedCurrentValue() {
    return UNDEF;
  } // eslint-disable-next-line
  ;

  _proto.getRatioK = function getRatioK(context, currentValue, valueRadiusIncrementRatio, totalValue, maxValue) {
    var point = this,
        conf = context.config,
        // pointConfig = point.config,
    nonStreamlinedData = !conf.streamLinedData,
        useSameSlantAngle = conf.useSameSlantAngle;
    return nonStreamlinedData ? 0.2 + valueRadiusIncrementRatio * totalValue : point.y ? useSameSlantAngle ? point.y / maxValue : Math.sqrt(point.y / maxValue) : 1;
  };

  _proto.getLowestRadiusFactor = function getLowestRadiusFactor(context, maxValue) {
    var point = this,
        conf = context.config,
        // pointConfig = point.config,
    nonStreamlinedData = !conf.streamLinedData,
        useSameSlantAngle = conf.useSameSlantAngle;
    return nonStreamlinedData ? 0.2 : point.y ? useSameSlantAngle ? point.y / maxValue : Math.sqrt(point.y / maxValue) : 1;
  } // eslint-disable-next-line
  ;

  _proto.allocatePosition = function allocatePosition() {}
  /**
   * Draws individual plot graphics
   * @return {Object} individual pointItem object
   */
  ;

  _proto.drawPlots = function drawPlots() {
    var point = this,
        index = point.index,
        datasetStore = point.getLinkedParent(),
        toolTipController = datasetStore.getFromEnv('toolTipController'),
        conf = datasetStore.config,
        value = point.y,
        displayValue = point.displayValue,
        chartSliced = conf.isSliced,
        labelAlign = point.labelAline,
        css = point.appliedStyle,
        parentCSS = point.style,
        textDirection = _lib.BLANK,
        chart = datasetStore.getFromEnv('chart'),
        trackerGroup = chart.getChildContainer('trackerGroup'),
        sliced,
        plotItem = point.plot,
        translateXY,
        setLink = !!point.link,
        graphic,
        trackerObj,
        // attaching the hoverHandler made once in constructor of funnel-pyramid-base
    hoverHandler = this.hoverHandler,
        distanceAvailed = conf.distanceAvailed,
        // legend = datasetStore.getFromEnv('legend'),
    labelDrawingConfigArr = datasetStore.config.labelDrawingConfig,
        animationManager = datasetStore.getFromEnv('animationManager'),
        setRolloutAttr = point.setRolloutAttr,
        setRolloverAttr = point.setRolloverAttr,
        setRolloverProperties = point.rolloverProperties,
        sliceContext = {},
        pointFill,
        labelDrawingConfig,
        textDrawingArgs; // If all plots are sliced, then set flag to false, to make the first
    // slicing click on any of the plots will make it sliced.

    sliced = chartSliced ? 1 : point.isSliced;
    pointFill = css && css.color || parentCSS && parentCSS.color || datasetStore._chartLevelAttr.color;
    textDrawingArgs = {
      text: displayValue,
      direction: textDirection,
      cursor: setLink ? POINTER : _lib.BLANK,
      x: 0,
      y: 0,
      fill: pointFill,
      'text-anchor': textHAlign[labelAlign]
    };

    if (value === null || value === UNDEF || !point.shapeArgs) {
      labelDrawingConfigArr[index] = labelDrawingConfig = {
        args: textDrawingArgs,
        css: css,
        point: point
      };
      return;
    }

    graphic = point.getGraphicalElement('graphic');
    trackerObj = point.getGraphicalElement('trackerObj'); // Hover consmetics

    !setRolloutAttr && (point.setRolloutAttr = setRolloutAttr = {});
    !setRolloverAttr && (point.setRolloverAttr = setRolloverAttr = {});

    if (point.hoverEffects) {
      // hover-out cosmetics
      setRolloutAttr.color = point.rawColor;
      setRolloutAttr.opacity = point.rawAlpha;
      setRolloutAttr['stroke-width'] = point.borderWidth;
      setRolloutAttr.stroke = point.borderColor; // hover-in cosmetics

      setRolloverAttr.color = setRolloverProperties.color;
      setRolloverAttr.opacity = setRolloverProperties.alpha;
      setRolloverAttr['stroke-width'] = setRolloverProperties.borderWidth;
      setRolloverAttr.stroke = setRolloverProperties.borderColor;
      setRolloverAttr.rawBorderColor = setRolloverProperties.rawBorderColor;
      setRolloverAttr.borderAlpha = setRolloverProperties.borderAlpha;
    } else {
      // If hoverEffects is disabled, clear all cosmetics
      setRolloutAttr = point.setRolloutAttr = {};
      setRolloverAttr = point.setRolloverAttr = {};
    }

    if (!plotItem) {
      point.shapeArgs.graphics = plotItem;
      point.plot = plotItem = {};
      graphic = datasetStore.pyramidFunnelShape(point.shapeArgs).attr({
        fill: point.color,
        'stroke-width': point.borderWidth,
        stroke: point.borderColor
      });
      trackerObj = animationManager.setAnimation({
        el: 'path',
        container: trackerGroup,
        component: datasetStore
      }).on('fc-click', datasetStore.plotMouseUp, sliceContext).hover(hoverHandler, hoverHandler);
      point.addGraphicalElement('graphic', graphic);
      point.addGraphicalElement('trackerObj', trackerObj);
      labelDrawingConfigArr[index] = labelDrawingConfig = {
        args: textDrawingArgs,
        css: css,
        point: point
      };
    } else {
      point.shapeArgs.graphics = graphic;
      graphic = datasetStore.pyramidFunnelShape(point.shapeArgs);
      point.addGraphicalElement('graphic', graphic);
      graphic = animationManager.setAnimation({
        el: graphic,
        attr: {
          fill: point.color,
          'stroke-width': point.borderWidth,
          stroke: point.borderColor
        },
        component: datasetStore
      });
      point.addGraphicalElement('graphic', graphic);
      graphic.show();
      labelDrawingConfigArr[index] = labelDrawingConfig = {
        args: textDrawingArgs,
        css: css,
        point: point
      };
    }

    graphic.funnel2D && graphic.funnel2D.addPattern(point.patternAttr, conf.usePattern);

    if (conf.showTooltip) {
      toolTipController.enableToolTip(trackerObj, point.toolText);
    } else {
      toolTipController.disableToolTip(trackerObj);
    }

    plotItem.value = value;
    plotItem.displayValue = displayValue;
    plotItem.sliced = !!sliced;
    plotItem.cursor = setLink ? POINTER : _lib.BLANK;
    plotItem.x = point.x;
    plotItem.index = index;
    sliceContext.datasetStore = datasetStore;
    sliceContext.plotItem = plotItem;
    trackerObj.off('fc-click', datasetStore.slice);
    !point.doNotSlice && trackerObj.on('fc-click', datasetStore.slice, sliceContext);
    labelDrawingConfig.context = sliceContext;
    labelDrawingConfig.actions = {
      click: datasetStore.slice,
      hover: [hoverHandler, hoverHandler]
    };
    plotItem.dy = 0;

    if (conf.noOfGap) {
      if (distanceAvailed) {
        plotItem._startTranslateY = translateXY = 't0,' + distanceAvailed;
        plotItem.dy = plotItem.distanceAvailed = distanceAvailed;
      }

      if (conf.slicingGapPosition[point.x]) {
        conf.distanceAvailed -= conf.perGapDistance;
      }
    } else {
      plotItem._startTranslateY = translateXY = 't0,' + 0;
    }

    animationManager.setAnimation({
      el: graphic,
      attr: {
        transform: translateXY
      },
      component: datasetStore
    });
    labelDrawingConfig.transform = translateXY;
    return plotItem;
  };

  return FunnelPoint;
}(_funnelpyramidbasePoint.default);

var _default = FunnelPoint;
exports["default"] = _default;

/***/ }),

/***/ 1565:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _assertThisInitialized2 = _interopRequireDefault(__webpack_require__(292));

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _componentInterface = __webpack_require__(290);

var _lib = __webpack_require__(274);

var _pie2d = __webpack_require__(649);

var _column = __webpack_require__(595);

var _schedular = __webpack_require__(286);

var CRISP = 'crisp',
    M = 'M',
    L = 'L',
    POINTER = 'pointer',
    DEFAULT = 'default',
    win = window,
    userAgent = win.navigator.userAgent,
    isIE = /msie/i.test(userAgent) && !win.opera,
    noneStr = 'none',
    EVENTARGS = 'eventArgs',
    TRACKER_FILL = 'rgba(192,192,192,' + (isIE ? 0.002 : 0.000001) + ')',
    removeCSSProps = ['fontFamily', 'fontSize', 'fontWeight', 'fontStyle'],
    hideFn = function hideFn() {
  this.hide();
},
    ROLLOVER = 'DataPlotRollOver',
    ROLLOUT = 'DataPlotRollOut',
    MOUSEOVER = 'mouseover',

/**
 * Extract the text styles
 * @param {Object} dataObj input data
 * @return {Object} returns parsed style object
 */
extractTextStyle = function extractTextStyle(dataObj, chartAttr) {
  var keyMap = {
    'labelfont': 'fontFamily',
    'labelfontcolor': 'color',
    'labelfontsize': 'fontSize',
    'labelfontbold': 'fontWeight',
    'labelfontitalic': 'fontStyle',
    'labelalpha': 'alpha'
  },
      style,
      key;

  for (key in keyMap) {
    if (!(key in dataObj) && !(key in chartAttr)) {
      continue;
    }

    style = style || {};

    if (key === 'labelfontsize') {
      style[keyMap[key]] = (0, _lib.pluck)(dataObj[key], this.computeFontSize(chartAttr[key]));
      style.fontSizeWithUnit = (0, _lib.pluckFontSizeMaintainUnit)(dataObj.labelfontsize, chartAttr.labelfontsize);
    } else {
      style[keyMap[key]] = (0, _lib.pluck)(dataObj[key], chartAttr[key]);
    }
  }

  if (!style) {
    return style;
  }

  if (style.fontWeight) {
    style.fontWeight = (0, _lib.pluckNumber)(style.fontWeight) ? 'bold' : 'normal';
  }

  if (style.fontStyle) {
    style.fontStyle = (0, _lib.pluckNumber)(style.fontStyle) ? 'italic' : 'normal';
  } // Convert color to rgba. If color is not provided, black is assigned


  style.color = (0, _lib.convertColor)(style.color, style.alpha);
  return style;
};

var FunnelPyramidBasePoint = /*#__PURE__*/function (_ComponentInterface) {
  (0, _inheritsLoose2.default)(FunnelPyramidBasePoint, _ComponentInterface);

  /**
   * constructor to intantiate handler on the hover only once in lifetime of chart
  */
  function FunnelPyramidBasePoint() {
    var _this;

    _this = _ComponentInterface.call(this) || this;
    var point = (0, _assertThisInitialized2.default)(_this);
    /**
    * attaches the function of hover of actions of dataLabel
    * handler is defined in constructor and attached in funnel-point and pyramid-point
    */

    _this.hoverHandler = function (evt) {
      var graphic = point.getGraphicalElement('graphic'),
          chart = point.getLinkedParent().getFromEnv('chart'),
          ele = this;
      ele.data(EVENTARGS, Object.assign(ele.data(EVENTARGS), {
        isSliced: point.isSliced
      }));

      if (evt.type === MOUSEOVER) {
        graphic.attr(point.setRolloverAttr);
        chart.plotEventHandler(ele, evt, ROLLOVER);
      } else {
        graphic.attr(point.setRolloutAttr);
        chart.plotEventHandler(ele, evt, ROLLOUT);
      }
    };

    return _this;
  }
  /**
   * Parses the attributes and configures the point component.
   *
   * @param {any} dataObj dataObj
   * @param {any} res Contains calculations
   * @param {any} colorIndex colorIndex is used to depict the color to be used for the point component
   * @param {Number} index index of the plot
   * @memberof FunnelPyramidBasePoint
   */


  var _proto = FunnelPyramidBasePoint.prototype;

  _proto.parseAndConfigurePoint = function parseAndConfigurePoint(dataObj, res, colorIndex, index) {
    var point = this,
        datasetStore = point.getLinkedParent(),
        chart = datasetStore.getFromEnv('chart'),
        conf = datasetStore.config,
        numberFormatter = datasetStore.getFromEnv('number-formatter'),
        smartLabel = datasetStore.getFromEnv('smartLabel'),
        colorManager = datasetStore.getFromEnv('color-manager'),
        showValue,
        refreshedData,
        highestValue,
        patternType,
        patternAngle,
        patternDensity,
        patternSize,
        patternAlpha,
        patternBgColor,
        sumValue = 0,
        sum,
        dataValue,
        prevValue,
        name,
        smartTextObj,
        pointSliced,
        pValue,
        formatedVal,
        labelText,
        displayValueText,
        displayValue,
        toolText,
        ttValue,
        filteredDataObj,
        id,
        showPercentValues = conf.showPercentValues,
        labelSepChar = conf.labelSepChar,
        chartAttr = chart.getFromEnv('chart-attrib'),
        isSliced = conf.isSliced,
        plotColor,
        plotAlpha,
        plotBorderColor,
        plotBorderAlpha,
        pointShadow = {
      apply: conf.showShadow,
      opacity: 1
    },
        minplotheightforvalue = (0, _lib.pluckNumber)(dataObj.minplotheightforvalue, chartAttr.minplotheightforvalue, 0),
        tooltipOptions,
        hoverEffects,
        displayValueArgs,
        plotBorderWidth = conf.plotBorderThickness,
        defStyle = conf.style,
        legendItemId,
        colorApplied,
        labellink,
        legendColor,
        legendIconAlpha,
        legendIconBgAlpha;
    conf.showTextOutline = (0, _lib.pluckNumber)(chartAttr.textoutline, 0);
    refreshedData = res.refreshedData;
    sumValue = res.sumValue;
    sum = numberFormatter.dataLabels(sumValue);
    highestValue = res.highestValue;
    labellink = (0, _lib.pluck)(dataObj.labellink, chartAttr.labellink, dataObj.link, _lib.UNDEF);
    legendItemId = dataObj.legendItemId;
    dataValue = dataObj.cleanValue;
    prevValue = index ? refreshedData[index - 1].value : dataValue;
    name = (0, _lib.parseUnsafeString)((0, _lib.pluck)(dataObj.label, dataObj.name, _lib.BLANKSTRING)); // parsing the id property in config

    id = dataObj.id ? (0, _lib.parseUnsafeString)((0, _lib.pluck)(dataObj.id)) : name;
    smartLabel.setStyle(point.getFromEnv('dataLabelStyle'));
    smartTextObj = smartLabel.getOriSize(name);
    patternType = _column.PATTERN_TYPES.includes(dataObj.patterntype) ? dataObj.patterntype : conf.patternType;
    patternAngle = (0, _lib.pluckNumber)(dataObj.patternangle, chart.getFromEnv('chart-attrib').patternangle, patternType === _column.PATTERN_TYPES[0] ? 40 : 0);
    patternDensity = (0, _lib.pluckNumber)(dataObj.patterndensity, conf.patternDensity);
    patternSize = (0, _lib.pluckNumber)(dataObj.patternsize, patternType === _column.PATTERN_TYPES[0] ? 2 : 4);
    patternAlpha = (0, _lib.pluckNumber)(dataObj.patternalpha, conf.patternAlpha);
    patternBgColor = (0, _lib.pluck)(dataObj.patternbgcolor, conf.patternBgColor);
    plotAlpha = dataObj.alpha || conf.plotFillAlpha;
    colorApplied = (0, _lib.pluck)(dataObj.color, colorManager.getPlotColor(colorIndex));
    legendColor = (0, _lib.convertColor)(colorApplied);
    legendIconAlpha = dataObj.legendiconalpha;
    legendIconBgAlpha = dataObj.legendiconbgalpha;
    plotColor = (0, _lib.convertColor)(colorApplied, plotAlpha);
    plotBorderColor = (0, _lib.pluck)(dataObj.bordercolor, conf.plotBorderColor, conf.usePattern ? colorApplied : (0, _lib.getLightColor)(colorApplied, 25)).split(_lib.COMMASTRING)[0];
    plotBorderAlpha = !conf.showPlotBorder ? _lib.ZEROSTRING : (0, _lib.pluck)(dataObj.borderalpha, conf.plotBorderAlpha, conf.usePattern ? '100' : '80');
    pointShadow.opacity = Math.max(plotAlpha, plotBorderAlpha) / 100;
    pointSliced = (0, _lib.pluckNumber)(dataObj.issliced, isSliced);

    if (pointSliced) {
      conf.noOFSlicedElement += 1;
      conf.preSliced = pointSliced;
    }

    if (res.prevPerValReq) {
      sumValue = prevValue;
    }

    pValue = numberFormatter.percentValue(dataValue / sumValue * 100);

    if (!conf.datalabelDisabled) {
      formatedVal = numberFormatter.dataLabels(dataValue) || _lib.BLANKSTRING;
      labelText = conf.showLabels === 1 ? name : _lib.BLANKSTRING;
      showValue = (0, _lib.pluckNumber)(dataObj.showvalue, conf.showValues, 1);
      displayValueText = showValue === 1 ? showPercentValues === 1 ? pValue : formatedVal : _lib.BLANKSTRING;
      displayValue = (0, _lib.getValidValue)((0, _lib.parseUnsafeString)(dataObj.displayvalue));
      displayValueArgs = (0, _lib.pluck)(displayValue, name + labelSepChar + (showPercentValues ? pValue : formatedVal), _lib.BLANKSTRING);

      if (displayValue) {
        displayValueText = displayValue;
      } else {
        if (displayValueText !== _lib.BLANKSTRING && labelText !== _lib.BLANKSTRING) {
          displayValueText = labelText + labelSepChar + displayValueText;
        } else {
          displayValueText = (0, _lib.pluck)(labelText, displayValueText) || _lib.BLANKSTRING;
        }
      }
    }

    toolText = (0, _lib.getValidValue)((0, _lib.parseUnsafeString)((0, _lib.pluck)(dataObj.tooltext, conf.toolText), false));

    if (toolText !== _lib.UNDEF) {
      tooltipOptions = {
        formatedVal: formatedVal,
        name: name,
        pValue: pValue,
        sum: sum,
        sumValue: sum,
        dataValue: dataValue,
        prevValue: prevValue,
        highestValue: highestValue
      };
      toolText = (0, _lib.parseTooltext)(toolText, [1, 2, 3, 7, 14, 24, 25, 37], datasetStore.getTooltipMacroStub(tooltipOptions), dataObj, chartAttr);
    } else {
      ttValue = conf.showPercentInToolTip === 1 ? pValue : formatedVal;
      toolText = name !== _lib.BLANKSTRING ? name + conf.tooltipSepChar + ttValue : ttValue;
    }

    hoverEffects = datasetStore.pointHoverOptions(dataObj, {
      color: colorApplied,
      alpha: plotAlpha,
      borderColor: plotBorderColor,
      borderAlpha: plotBorderAlpha,
      borderWidth: plotBorderWidth
    });
    filteredDataObj = {
      displayValue: displayValueText,
      origValue: displayValueText,
      displayValueArgs: displayValueArgs,
      style: _lib.parsexAxisStyles.apply(this, [dataObj, {}, chartAttr, defStyle, plotColor]),
      appliedStyle: extractTextStyle.apply(this, [dataObj, chartAttr]),
      name: name,
      categoryLabel: name,
      rawColor: colorApplied,
      rawAlpha: plotAlpha,
      toolText: toolText,
      legendCosmetics: _lib.UNDEF,
      legendItemId: legendItemId || point && point.legendItemId,
      showInLegend: _lib.UNDEF,
      y: dataValue,
      shadow: pointShadow,
      smartTextObj: smartTextObj,
      legendColor: legendColor,
      color: plotColor,
      alpha: plotAlpha,
      legendiconalpha: legendIconAlpha,
      legendiconbgalpha: legendIconBgAlpha,
      borderColor: (0, _lib.convertColor)(plotBorderColor, plotBorderAlpha),
      plotBorderColor: plotBorderColor,
      plotBorderAlpha: plotBorderAlpha,
      borderWidth: plotBorderWidth,
      link: (0, _lib.getValidValue)(dataObj.link),
      isSliced: pointSliced,
      doNotSlice: !conf.enableSlicing,
      hoverEffects: hoverEffects.enabled && hoverEffects.options,
      labellink: labellink,
      rolloverProperties: hoverEffects.enabled && hoverEffects.rolloverOptions,
      minplotheightforvalue: minplotheightforvalue,
      showValue: showValue,
      id: id,
      patternAttr: {
        patternType: patternType,
        patternAngle: patternAngle,
        patternDensity: patternDensity,
        patternSize: patternSize,
        patternAlpha: patternAlpha,
        patternBgColor: patternBgColor,
        color: plotColor,
        alpha: plotAlpha,
        x: 0,
        y: 0
      }
    };
    point.configure(filteredDataObj);
  }
  /**
   * Draws individual data labels
   */
  ;

  _proto.drawLabel = function drawLabel() {
    var point = this,
        index = point.index,
        datasetStore = point.getLinkedParent(),
        chart = datasetStore.getFromEnv('chart'),
        animationManager = datasetStore.getFromEnv('animationManager'),
        toolTipController = datasetStore.getFromEnv('toolTipController'),
        conf = datasetStore.config,
        dataLabelsGroup = chart.getChildContainer('datalabelsGroup'),
        dataStore = datasetStore.getChildren('data'),
        displayValue = point.displayValue,
        plotItem = point.plot || {},
        dataLabel = point.getGraphicalElement('dataLabel'),
        connector = point.getGraphicalElement('connector'),
        isNewDataLabel = !dataLabel,
        labelY = point.labelY,
        labelX = point.labelX,
        style = point.style || {},
        fontSize = (0, _lib.pluckNumber)(parseInt(style.fontSize, 10), conf.baseFontSize),
        isFunnel = datasetStore.getName() === 'funnel',
        lineHeight = conf.lineHeight,
        value,
        connectorAttr,
        actions,
        drawConnector,
        labelDrawingConfig,
        yShift = fontSize * 0.3,
        yDisplacement = lineHeight * 0.3,
        connectorStartY,
        connectorEndY,
        lastConnectorEndY,
        showLabelsAtCenter = conf.showLabelsAtCenter,
        rolloverAttr = point.setRolloverAttr,
        eventArgs,
        connectorEndSwitchHistoryY = conf.connectorEndSwitchHistoryY,
        connectorEndX,
        connectorStartX,
        labelDistance = conf.labelDistance,
        blankSpace = conf.blankSpace,
        connectorPath,
        yD,
        streamLinedData = conf.streamLinedData,
        // shapeArgs might not exist for streamlined data when the point is the
    // top point.
    shapeArgs = point.shapeArgs,
        // If shapeArgs don't exist, labels can be drawn.
    // Otherwise, shapeArgs exist and labels can only be shown if the computed
    // point height is greater than the user defined minimum plot height to
    // show labels.
    canLabelBeShown = !shapeArgs || shapeArgs.h > point.minplotheightforvalue;

    if (!point.displayValue || isFunnel && !conf.streamLinedData && !index) {
      // in case displayvalue is blank or undefined, hide the existing label and connector
      // For funnel chart, when streamlineddata is disable, label of last plot should not be drawn
      dataLabel && animationManager.setAnimation({
        el: dataLabel,
        component: datasetStore,
        callback: hideFn,
        doNotRemove: true
      });
      connector && animationManager.setAnimation({
        el: connector,
        component: datasetStore,
        callback: hideFn,
        doNotRemove: true
      });
      return;
    }

    labelDrawingConfig = datasetStore.config.labelDrawingConfig[index];
    actions = labelDrawingConfig.actions;
    value = point.y;
    connectorAttr = {
      'stroke-width': conf.dataConnectorStyle.connectorWidth,
      stroke: conf.dataConnectorStyle.connectorColor,
      transform: labelDrawingConfig.transform
    };
    labelDrawingConfig.args.cursor = point.labellink ? 'pointer' : 'default'; // temporary fix till the time fill is inherited from the parent nodes in VML

    if (labelDrawingConfig.args && labelDrawingConfig.css) {
      labelDrawingConfig.args.fill = labelDrawingConfig.css.color || labelDrawingConfig.css.fill;
    }

    if (value === null || value === _lib.UNDEF || !shapeArgs) {
      if (dataLabel) {
        dataLabel.removeCSS(removeCSSProps);
        dataLabel && animationManager.setAnimation({
          el: dataLabel,
          attr: labelDrawingConfig.args,
          component: datasetStore
        });
        dataLabel && dataLabel.css(labelDrawingConfig.css);
      } else {
        dataLabel = animationManager.setAnimation({
          el: 'text',
          label: 'dataLabel',
          attr: labelDrawingConfig.args,
          css: labelDrawingConfig.css,
          container: dataLabelsGroup,
          component: datasetStore
        });
        point.addGraphicalElement('dataLabel', dataLabel);
      }

      dataLabel.outlineText(conf.showTextOutline, labelDrawingConfig.args.fill);
    } else {
      drawConnector = !(isFunnel && index === 0 && conf.streamLinedData);

      if (point.plot) {
        dataLabel && dataLabel.removeCSS(removeCSSProps); // Remove text css

        dataLabel = animationManager.setAnimation({
          el: dataLabel || 'text',
          label: 'dataLabel',
          attr: labelDrawingConfig.args,
          css: labelDrawingConfig.css,
          container: dataLabelsGroup,
          component: datasetStore
        });
        dataLabel.outlineText(conf.showTextOutline, labelDrawingConfig.args.fill);
        point.addGraphicalElement('dataLabel', dataLabel);
        connector = animationManager.setAnimation({
          el: connector || 'path',
          attr: drawConnector && connectorAttr,
          container: dataLabelsGroup,
          callback: function callback() {
            conf.showLabelsAtCenter && this.hide();
          },
          component: datasetStore,
          label: 'connector'
        });
        drawConnector && point.addGraphicalElement('connector', connector);
      }

      toolTipController.enableToolTip(dataLabel, point.originalText); // Previous click handlers are removed before attaching new ones when chart is updated or resized

      if (!isNewDataLabel) {
        // Applying dirty check as error arises in IE8
        point.labelClickFn && dataLabel.off('fc-click', point.labelClickFn);
        point.actionsClick && dataLabel.off('fc-click', point.actionsClick);
      }

      eventArgs = {
        index: point.index,
        link: point.link,
        value: point.y,
        displayValue: point.displayValueArgs,
        categoryLabel: point.categoryLabel,
        dataIndex: point.index || _lib.BLANK,
        toolText: point.toolText,
        label: point.categoryLabel,
        color: point.rawColor,
        alpha: point.rawAlpha,
        showValue: point.showValue,
        isSliced: point.isSliced,
        borderColor: point.plotBorderColor,
        borderAlpha: point.plotBorderAlpha,
        hoverColor: rolloverAttr.color,
        hoverAlpha: rolloverAttr.opacity,
        borderHoverColor: rolloverAttr.rawBorderColor,
        borderHoverAlpha: rolloverAttr.borderAlpha,
        borderHoverThickness: rolloverAttr['stroke-width'],
        id: point.id
      };
      dataLabel.data(EVENTARGS, eventArgs);
      point.labellink && dataLabel.on('fc-click', function (_dataLabel, labellink) {
        point.labelClickFn = function () {
          _pie2d.labelClickFn.call(_dataLabel, chart, labellink);
        };

        return point.labelClickFn;
      }(dataLabel, point.labellink));
      !point.doNotSlice && dataLabel.on('fc-click', function (context) {
        point.actionsClick = function () {
          actions.click.call(context);
        };

        return point.actionsClick;
      }(labelDrawingConfig.context)); // hover effect is attached only once

      isNewDataLabel && dataLabel.hover(actions.hover[0], actions.hover[1]);
    }

    if (!showLabelsAtCenter) {
      connectorStartY = labelY - yShift - point.distributionFactor * lineHeight;
      connectorEndY = labelY - yShift;
      lastConnectorEndY = connectorEndSwitchHistoryY[point.alignmentSwitch];

      if (conf.lastplotY !== _lib.UNDEF && lastConnectorEndY !== _lib.UNDEF && lastConnectorEndY - connectorEndY < lineHeight) {
        connectorEndY = lastConnectorEndY - lineHeight;
        labelY = connectorEndY;
      }

      point.displayValue && (connectorEndSwitchHistoryY[point.alignmentSwitch] = connectorEndY);
      conf.lastplotY = point.plotY;

      if (conf.labelAlignment === conf.alignmentType.alternate) {
        if (point.alignmentSwitch) {
          connectorEndX = labelX + blankSpace + point.virtualWidth;
          connectorStartX = connectorEndX + labelDistance + point.distributionFactor * conf.globalMinXShift;
        } else {
          connectorEndX = labelX - blankSpace;
          connectorStartX = connectorEndX - (labelDistance - (point.lOverflow || 0)) - point.distributionFactor * conf.globalMinXShift;
        }
      } else {
        connectorEndX = labelX - blankSpace;
        connectorStartX = connectorEndX - (labelDistance - (point.lOverflow || 0)) - point.distributionFactor * conf.globalMinXShift;
      } // Drawing the connector for labels
      // Check if the label is not blank and,
      // label is not the first label of Funnel Chart


      if (typeof displayValue !== 'undefined' && displayValue !== _lib.BLANKSTRING && !(isFunnel && index === 0 && streamLinedData)) {
        connectorPath = [M, connectorStartX, connectorStartY, L, connectorEndX, connectorEndY];
        animationManager.setAnimation({
          el: connector,
          state: 'transform',
          label: 'connector',
          attr: {
            path: connectorPath,
            'shape-rendering': connectorStartY === connectorEndY && connectorEndY < 1 ? CRISP : _lib.BLANK
          },
          component: datasetStore
        });
        connector.show();
      } else {
        connector && animationManager.setAnimation({
          el: connector,
          component: datasetStore
        });
      }

      if (index === 0 && streamLinedData) {
        yD = labelY + (dataStore[1].plot.dy || 0);
      } else {
        yD = connectorEndY + (plotItem.dy || 0);
      }

      if (displayValue !== _lib.BLANKSTRING) {
        animationManager.setAnimation({
          el: dataLabel,
          state: 'transform',
          attr: {
            transform: ['t', labelX, yD]
          },
          component: datasetStore,
          label: 'dataLabel'
        });
        dataLabel.show();
      } else {
        dataLabel && animationManager.setAnimation({
          el: dataLabel,
          component: datasetStore
        });
      }
    } else {
      if (index === 0 && streamLinedData) {
        // access to the first plot item
        yD = labelY - yDisplacement + (dataStore[1].plot.distanceAvailed || 0);
      } else {
        yD = labelY - yDisplacement + (plotItem.distanceAvailed || 0);
      }

      if (displayValue !== _lib.BLANKSTRING) {
        animationManager.setAnimation({
          el: dataLabel,
          attr: {
            transform: ['t', labelX, yD]
          },
          component: datasetStore
        });
        dataLabel.show();
      } else {
        dataLabel && animationManager.setAnimation({
          el: dataLabel,
          component: datasetStore
        });
      } // If labels can't be shown, hide the data labels if they exist.


      if (!canLabelBeShown && point.getGraphicalElement('dataLabel')) {
        point.getGraphicalElement('dataLabel').hide();
      }
    }

    dataLabel.attr({
      'text-bound': [style.backgroundColor, style.borderColor, style.borderThickness, style.borderPadding, style.borderRadius, style.borderDash]
    });
  }
  /**
   * Draws individual trackers
   * @param {Object} set point object
   */
  ;

  _proto.drawTracker = function drawTracker() {
    var point = this,
        datasetStore = point.getLinkedParent(),
        chart = datasetStore.getFromEnv('chart'),
        renderer = chart.getFromEnv('paper'),
        trackerGroup = chart.getChildContainer('trackerGroup'),
        shapeArgs,
        trackerObj,
        trackerLabel = +new Date(),
        graphic,
        rolloverAttr,
        eventArgs;

    if (!point) {
      return;
    }

    graphic = point.getGraphicalElement('graphic');
    trackerObj = point.getGraphicalElement('trackerObj');

    if (graphic) {
      shapeArgs = graphic.Shapeargs.silhuette;
      rolloverAttr = point.setRolloverAttr;
      eventArgs = {
        index: point.index,
        link: point.link,
        value: point.y,
        displayValue: point.displayValueArgs,
        categoryLabel: point.categoryLabel,
        dataIndex: point.index || _lib.BLANK,
        toolText: point.toolText,
        label: point.categoryLabel,
        color: point.rawColor,
        alpha: point.rawAlpha,
        showValue: point.showValue,
        isSliced: point.isSliced,
        borderColor: point.plotBorderColor,
        borderAlpha: point.plotBorderAlpha,
        hoverColor: rolloverAttr.color,
        hoverAlpha: rolloverAttr.opacity,
        borderHoverColor: rolloverAttr.rawBorderColor,
        borderHoverAlpha: rolloverAttr.borderAlpha,
        borderHoverThickness: rolloverAttr['stroke-width'],
        id: point.id
      };

      if (datasetStore.config.usePattern) {
        eventArgs.pattern = {
          patternType: point.patternAttr.patternType,
          patternColor: point.patternAttr.color,
          patternBgColor: point.patternAttr.patternBgColor === TRACKER_FILL ? _lib.UNDEF : point.patternAttr.patternBgColor
        };
        delete eventArgs.color;
      }

      point.datasetIndex = point.index;

      if (trackerObj) {
        trackerObj.attr({
          path: shapeArgs,
          isTracker: trackerLabel,
          fill: TRACKER_FILL,
          stroke: noneStr,
          transform: 't0,' + (point.plot._startTranslateY || 0),
          cursor: point.link ? POINTER : DEFAULT
        });
      } else {
        trackerObj = renderer.path(shapeArgs, trackerGroup).attr({
          isTracker: trackerLabel,
          fill: TRACKER_FILL,
          stroke: noneStr,
          transform: 't0,' + (point.plot._startTranslateY || 0),
          cursor: point.link ? POINTER : DEFAULT
        });
        point.addGraphicalElement('trackerObj', trackerObj);
      }

      trackerObj.data(EVENTARGS, eventArgs);
      trackerObj.show();
    }
  }
  /**
   * Method to call the drawing of a component synchronoously
   */
  ;

  _proto.syncDraw = function syncDraw() {
    var component = this; // fire the preDraw event

    component.fireEvent('predraw'); // If the component has an pending drawing JOB then remove that job

    component.removeJob('draw'); // Now call whether the drawing or removing draw of the component in sync manner

    component.getState('removed') ? component.removingDraw() : component.drawPlots && component.drawPlots();
    component.addExtEventListener('animationComplete', component.__remove, component.getFromEnv('animationManager'));
    component.childrenSyncDraw();
    component.setState('dirty', false);
    component.setState('parentChanged', false); // TODO: make the draw capable of async. i.e. incase of havey draw, we will split it into multiple thread and at the end will call a call back sent from here to fire the "drawn" event
    // fire the drawn event asynchronously

    component.addJob('draw-complete', function () {
      component.fireEvent('drawn');
    }, _schedular.priorityList.instant);
  };

  return FunnelPyramidBasePoint;
}(_componentInterface.ComponentInterface);

var _default = FunnelPyramidBasePoint;
exports["default"] = _default;

/***/ }),

/***/ 1569:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _funnelpyramidbasePoint = _interopRequireDefault(__webpack_require__(1565));

var _lib = __webpack_require__(274);

var UNDEF,
    POINTER = 'pointer',
    POSITION_START = _lib.preDefStr.POSITION_START,
    POSITION_END = _lib.preDefStr.POSITION_END,
    POSITION_MIDDLE = _lib.preDefStr.POSITION_MIDDLE,
    textHAlign = {
  right: POSITION_END,
  left: POSITION_START,
  middle: POSITION_MIDDLE,
  start: POSITION_START,
  end: POSITION_END,
  center: POSITION_MIDDLE,
  'undefined': _lib.BLANK,
  BLANK: _lib.BLANK
};

var PyramidPoint = /*#__PURE__*/function (_FunnelPyramidBasePoi) {
  (0, _inheritsLoose2.default)(PyramidPoint, _FunnelPyramidBasePoi);

  function PyramidPoint() {
    return _FunnelPyramidBasePoi.apply(this, arguments) || this;
  }

  var _proto = PyramidPoint.prototype;

  /**
   * Consfigures the point
   *
   * @param {any} [options={}]
   * @memberof PyramidPoint
   */
  _proto.configure = function configure(options) {
    if (options === void 0) {
      options = {};
    }

    for (var key in options) {
      this[key] = options[key];
    }

    this.upperRadiusFactor = 0;
  }
  /**
   * Sets the type of the component
   * @return {string} type
   */
  ;

  _proto.getType = function getType() {
    return 'data';
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */
  ;

  _proto.getName = function getName() {
    return 'pyramidpoint';
  };

  _proto.getModifiedCurrentValue = function getModifiedCurrentValue(totalValue) {
    return totalValue + this.y / 2;
  } // eslint-disable-next-line
  ;

  _proto.getRatioK = function getRatioK(context, currentValue) {
    var conf = context.config;
    return currentValue ? currentValue / conf.sumValue : 1;
  } // eslint-disable-next-line
  ;

  _proto.getLowestRadiusFactor = function getLowestRadiusFactor() {
    return 1;
  } // eslint-disable-next-line
  ;

  _proto.allocatePosition = function allocatePosition() {}
  /**
   * Draws individual data plots
   * @return {Object} plot item object
   */
  ;

  _proto.drawPlots = function drawPlots() {
    var point = this,
        index = point.index,
        datasetStore = point.getLinkedParent(),
        conf = datasetStore.config,
        toolTipController = datasetStore.getFromEnv('toolTipController'),
        // plotItems = datasetStore.graphics.plotItems,
    value = point.y,
        displayValue = point.displayValue,
        chartSliced = conf.isSliced,
        textDirection = _lib.BLANK,
        chart = datasetStore.getFromEnv('chart'),
        animationManager = datasetStore.getFromEnv('animationManager'),
        //  data = datasetStore.components.data,
    trackerGroup = chart.getChildContainer('trackerGroup'),
        dataLabelsGroup = chart.getChildContainer('datalabelsGroup'),
        graphicsGroup = chart.getChildContainer().plotGroup,
        sliced,
        plotItem = point.plot,
        translateXY,
        setLink = !!point.link,
        graphic,
        tempConfig,
        trackerObj,
        Point = conf.pointInContext,
        distanceAvailed = conf.distanceAvailed,
        labelAlign = point.labelAline,
        css = point.appliedStyle,
        // attaching the hoverHandler made once in constructor of funnel-pyramid-base
    hoverHandler = this.hoverHandler,
        parentCSS = point.style,
        setRolloutAttr = point.setRolloutAttr,
        setRolloverAttr = point.setRolloverAttr,
        setRolloverProperties = point.rolloverProperties,
        sliceContext = {},
        // legend = datasetStore.getFromEnv('legend'),
    textDrawingArgs,
        labelDrawingConfigArr = datasetStore.config.labelDrawingConfig,
        pointFill,
        labelDrawingConfig; // In case of streamlinedData = 0, the first plot is not configured

    if (!(point instanceof PyramidPoint)) {
      tempConfig = point;
      point = new Point();
      point.configure(tempConfig);
      datasetStore.components.data[index] = point;
    }

    if (conf.prevIs2d && conf.prevIs2d !== conf.is2d) {
      animationManager.setAnimation({
        el: graphicsGroup,
        attr: {
          opacity: 1
        },
        component: datasetStore
      });
      animationManager.setAnimation({
        el: dataLabelsGroup,
        attr: {
          opacity: 1
        },
        component: datasetStore
      });
    }

    pointFill = css && css.color || parentCSS && parentCSS.color || datasetStore._chartLevelAttr.color;
    sliced = chartSliced ? 1 : point.isSliced;
    textDrawingArgs = {
      text: displayValue,
      direction: textDirection,
      cursor: setLink ? POINTER : _lib.BLANK,
      x: 0,
      y: 0,
      fill: pointFill,
      'text-anchor': textHAlign[labelAlign]
    };

    if (value === null || value === UNDEF || !point.shapeArgs) {
      labelDrawingConfigArr[index] = labelDrawingConfig = {
        args: textDrawingArgs,
        css: css,
        point: point
      };
      return;
    }

    graphic = point.getGraphicalElement('graphic');
    trackerObj = point.getGraphicalElement('trackerObj'); // Hover consmetics

    !setRolloutAttr && (point.setRolloutAttr = setRolloutAttr = {});
    !setRolloverAttr && (point.setRolloverAttr = setRolloverAttr = {});

    if (point.hoverEffects) {
      // hover-out cosmetics
      setRolloutAttr.color = point.rawColor;
      setRolloutAttr.opacity = point.rawAlpha;
      setRolloutAttr['stroke-width'] = point.borderWidth;
      setRolloutAttr.stroke = point.borderColor; // hover-in cosmetics

      setRolloverAttr.color = setRolloverProperties.color;
      setRolloverAttr.opacity = setRolloverProperties.alpha;
      setRolloverAttr['stroke-width'] = setRolloverProperties.borderWidth;
      setRolloverAttr.stroke = setRolloverProperties.borderColor;
      setRolloverAttr.rawBorderColor = setRolloverProperties.rawBorderColor;
      setRolloverAttr.borderAlpha = setRolloverProperties.borderAlpha;
    } else {
      // If hoverEffects is disabled, clear all cosmetics
      setRolloutAttr = point.setRolloutAttr = {};
      setRolloverAttr = point.setRolloverAttr = {};
    }

    if (!plotItem) {
      point.shapeArgs.graphics = plotItem;
      point.plot = plotItem = {};
      graphic = datasetStore.pyramidFunnelShape(point.shapeArgs).attr({
        fill: point.color,
        'stroke-width': point.borderWidth,
        stroke: point.borderColor
      });
      trackerObj = animationManager.setAnimation({
        el: 'path',
        container: trackerGroup,
        component: datasetStore
      }).on('fc-click', datasetStore.plotMouseUp, sliceContext).hover(hoverHandler, hoverHandler);
      point.addGraphicalElement('graphic', graphic);
      point.addGraphicalElement('trackerObj', trackerObj);
      labelDrawingConfigArr[index] = labelDrawingConfig = {
        args: textDrawingArgs,
        css: css,
        point: point
      };
    } else {
      point.shapeArgs.graphics = graphic;
      graphic = datasetStore.pyramidFunnelShape(point.shapeArgs);
      point.addGraphicalElement('graphic', graphic);
      animationManager.setAnimation({
        el: graphic,
        attr: {
          fill: point.color,
          'stroke-width': point.borderWidth,
          stroke: point.borderColor
        },
        component: datasetStore
      });
      graphic.show();
      labelDrawingConfigArr[index] = labelDrawingConfig = {
        args: textDrawingArgs,
        css: css,
        point: point
      };
    }

    graphic.lighterHalf && graphic.lighterHalf.addPattern(point.patternAttr, conf.usePattern);
    graphic.darkerHalf && graphic.darkerHalf.addPattern(point.patternAttr, conf.usePattern);

    if (conf.showTooltip) {
      toolTipController.enableToolTip(trackerObj, point.toolText);
    } else {
      toolTipController.disableToolTip(trackerObj);
    }

    plotItem.value = value;
    plotItem.displayValue = displayValue;
    plotItem.sliced = !!sliced;
    plotItem.cursor = setLink ? POINTER : _lib.BLANK;
    plotItem.x = point.x;
    plotItem.index = index;
    sliceContext.datasetStore = datasetStore;
    sliceContext.plotItem = plotItem;
    trackerObj.off('fc-click', datasetStore.slice);
    !point.doNotSlice && trackerObj.on('fc-click', datasetStore.slice, sliceContext);
    labelDrawingConfig.context = sliceContext;
    labelDrawingConfig.actions = {
      click: datasetStore.slice,
      hover: [hoverHandler, hoverHandler]
    };
    plotItem.dy = 0;

    if (conf.noOfGap) {
      if (distanceAvailed) {
        plotItem._startTranslateY = translateXY = 't0,' + distanceAvailed;
        plotItem.dy = plotItem.distanceAvailed = distanceAvailed;
      }

      if (conf.slicingGapPosition[point.x]) {
        conf.distanceAvailed -= conf.perGapDistance;
      }
    } else {
      plotItem._startTranslateY = translateXY = 't0,' + 0;
    }

    animationManager.setAnimation({
      el: graphic,
      attr: {
        transform: translateXY
      },
      component: datasetStore
    });
    labelDrawingConfig.transform = translateXY;
    return plotItem;
  };

  return PyramidPoint;
}(_funnelpyramidbasePoint.default);

var _default = PyramidPoint;
exports["default"] = _default;

/***/ }),

/***/ 1563:
/***/ ((__unused_webpack_module, exports) => {



exports.__esModule = true;
exports["default"] = void 0;

var fadeIn = {
  initialAttr: {
    opacity: 0
  },
  finalAttr: {
    opacity: 1
  },
  slot: 'final'
},
    effect = function effect() {
  return {
    'connector.appearing': function connectorAppearing() {
      return [fadeIn];
    },
    'connector.transform': function connectorTransform(input) {
      return [{
        initialAttr: {
          path: input.attr.path
        },
        finalAttr: {
          path: input.attr.path
        }
      }];
    },
    'dataLabel.appearing': function dataLabelAppearing() {
      return [fadeIn];
    },
    'dataLabel.transform': function dataLabelTransform(input) {
      return [{
        initialAttr: {
          transform: input.attr.transform
        },
        finalAttr: {
          transform: input.attr.transform
        }
      }];
    },
    'path.appearing': function pathAppearing() {
      return [Object.assign({}, fadeIn, {
        slot: 'plot'
      })];
    }
  };
};

var _default = {
  'initial.dataset.funnel': effect,
  'initial.dataset.pyramid': effect
};
exports["default"] = _default;

/***/ }),

/***/ 1562:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _assertThisInitialized2 = _interopRequireDefault(__webpack_require__(292));

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _lib = __webpack_require__(274);

var _componentInterface = __webpack_require__(290);

var _pie2d = __webpack_require__(649);

var _funnelpyramidbase = _interopRequireDefault(__webpack_require__(1563));

var _dependencyManager = __webpack_require__(282);

/* eslint require-jsdoc: 'error', valid-jsdoc: ["error", { "requireReturn": false }] */
var PATTERN_TYPES = ['line', 'circle', 'square'];

var UNDEF,
    showHoverEffectStr = _lib.preDefStr.showHoverEffectStr,
    noneStr = 'none',
    PXSTRING = 'px',
    fillStr = 'fill',
    EASE_IN = 'easeIn',
    NORMALSTRING = 'normal',
    math = Math,
    mathRound = math.round,
    mathCeil = math.ceil,
    mathMax = math.max,
    mathMin = math.min,
    mathPow = math.pow,
    mathSqrt = math.sqrt,
    EMPTY_OBJ = {},
    colorStrings = _lib.preDefStr.colors,
    COLOR_000000 = colorStrings.c000000,
    // configStr = preDefStr.configStr,
// animationObjStr = preDefStr.animationObjStr,
POSITION_START = _lib.preDefStr.POSITION_START,
    POSITION_MIDDLE = _lib.preDefStr.POSITION_MIDDLE,
    pathStr = 'path',
    zeroCommaHundredStr = '0,100',
    EVENTARGS = 'eventArgs',
    win = window,
    userAgent = win.navigator.userAgent,
    isIE = /msie/i.test(userAgent) && !win.opera,
    HEXCODE = _lib.regex.hexcode,
    TRACKER_FILL = 'rgba(192,192,192,' + (isIE ? 0.002 : 0.000001) + ')',
    dropHash = _lib.regex.dropHash,
    isObject = function isObject(obj) {
  return typeof obj === 'object';
},
    isString = function isString(s) {
  return typeof s === 'string';
},
    defined = function defined(obj) {
  return obj !== UNDEF && obj !== null;
},
    _getTooltipMacroStub = function getTooltipMacroStub(options) {
  return {
    formattedValue: options.formatedVal,
    label: options.name,
    percentValue: options.pValue,
    sum: options.sum,
    unformattedSum: options.sumValue
  };
},
    M = 'M',
    A = 'A',
    L = 'L',
    Z = 'Z',
    startsRGBA = _lib.regex.startsRGBA,

/**
 * Handle color operations. The object methods are chainable.
 * @param {string} input The input color in either rbga or hex format
 * @return {Object} returns the member functions needed of class color
 * @private
 */
Color = function Color(input) {
  // declare variables
  var rgba = [],
      result;
  /**
  * Parse the input color to rgba array
  * @param {string} inp color string
  * @private
  */

  function init(inp) {
    // rgba
    result = /rgba\(\s*([0-9]{1,3})\s*,\s*([0-9]{1,3})\s*,\s*([0-9]{1,3})\s*,\s*([0-9]?(?:\.[0-9]+)?)\s*\)/.exec(inp);

    if (result) {
      rgba = [parseInt(result[1], 10), parseInt(result[2], 10), parseInt(result[3], 10), parseFloat(result[4])];
    } else {
      // hex
      result = /#([a-fA-F0-9]{2})([a-fA-F0-9]{2})([a-fA-F0-9]{2})/.exec(inp);

      if (result) {
        rgba = [parseInt(result[1], 16), parseInt(result[2], 16), parseInt(result[3], 16), 1];
      }
    }
  }
  /**
  * Return the color a specified format
  * @param {string} format color format, hex or rgba
  * @return {string} color string
  * @private
  */


  function get(format) {
    var ret; // it's NaN if gradient color on a column chart

    if (rgba && !isNaN(rgba[0])) {
      if (format === 'rgb') {
        ret = 'rgb(' + rgba[0] + ',' + rgba[1] + ',' + rgba[2] + ')';
        /** ^
                   * capability to return hex code
                   */
      } else if (format === 'hex') {
        ret = '#' + (COLOR_000000 + (rgba[0] << 16 | rgba[1] << 8 | rgba[2]).toString(16)).slice(-6);
      } else if (format === 'a') {
        /* EOP^ */
        ret = rgba[3];
      } else {
        ret = 'rgba(' + rgba.join(',') + ')';
      }
    } else {
      ret = input;
    }

    return ret;
  }
  /**
   * Brighten the color
   * @param {number} alpha alpha string
   * @return {Object} object instance
   * @private
   */


  function brighten(alpha) {
    if (!isNaN(alpha) && alpha !== 0) {
      var i;

      for (i = 0; i < 3; i++) {
        rgba[i] += parseInt(alpha * 255, 10);

        if (rgba[i] < 0) {
          rgba[i] = 0;
        }

        if (rgba[i] > 255) {
          rgba[i] = 255;
        }
      }
    }

    return this;
  }
  /**
   * Set the color's opacity to a given alpha value
   * @param {number} alpha alpha string
   * @return {Object} object instance
   * @private
   */


  function setOpacity(alpha) {
    rgba[3] = alpha;
    return this;
  } // initialize: parse the input


  init(input); // public methods

  return {
    get: get,
    brighten: brighten,
    setOpacity: setOpacity
  };
};

(0, _dependencyManager.addDep)({
  name: 'funnelPyramidBaseAnimation',
  type: 'animationRule',
  extension: _funnelpyramidbase.default
});
/**
 * Creates class FunnelPyramidBaseDataset
 */

var FunnelPyramidBaseDataset = /*#__PURE__*/function (_ComponentInterface) {
  (0, _inheritsLoose2.default)(FunnelPyramidBaseDataset, _ComponentInterface);
  var _proto = FunnelPyramidBaseDataset.prototype;

  /**
   * Sets the type of the component
   * @return {string} type
   */
  _proto.getType = function getType() {
    return 'dataset';
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */
  ;

  _proto.getName = function getName() {
    return 'funnelPyramidBase';
  }
  /**
   * Construction funtion for FunnelPyramidBaseDataset class
   */
  ;

  function FunnelPyramidBaseDataset() {
    var _this;

    _this = _ComponentInterface.call(this) || this;
    _this.components = {}; // Stub for saving all the computed configuration
    // this.removeData = function () {
    //   // Override parent fn
    // };

    _this.utils = function (_contextParam) {
      var _context = _contextParam;
      /**
       * Utility to create associative array with the facility to get non-undefined element in optimized way.
       * O(1) length retrieval
       */

      function ArrayableObj() {
        var _map = [],
            _eLength = 0; // Effective length. Only count of defined element
        // Set a value in associative array

        this.set = function (key, value) {
          _eLength++;
          _map[key] = value;
        }; // Get an value based on the key


        this.get = function (key) {
          return _map[key];
        }; // Get the complete array


        this.getAll = function () {
          return _map;
        }; // Merge with a given array and return a new one. However instance remains immutable.


        this.mergeWith = function (anotherArray) {
          var sArr,
              itemIndex,
              item,
              newArr = _map.slice(0);

          if (anotherArray instanceof Array) {
            sArr = anotherArray;
          } else if (anotherArray instanceof ArrayableObj) {
            sArr = anotherArray.getAll();
          } else {
            return;
          }

          for (itemIndex in sArr) {
            item = sArr[itemIndex];

            if (newArr[itemIndex]) {
              continue;
            }

            newArr[itemIndex] = item;
          }

          return newArr;
        };

        this.getEffectiveLength = function () {
          return _eLength;
        };
      }

      ArrayableObj.prototype.constructor = ArrayableObj;
      /**
       * Matrix that calculates the distribution of the labels.
       * If the distribution is not uniform it calculates a variable factor to make it uniform
       * It calculates the following cases :-
       * a) If the distribution is permitted for one given side, it suggestes chart.alignmentType['default']
       * b) If the distribution exceeds to a given limit it suggestes chart.alignmentType.alternate
       *
       * If the original distribution (non uniform) is like
       * ------------------------------------------------------
       *   4  |  2  |  0  |  0  |  0  |  0  |  0  | 1   |  0  |
       * ------------------------------------------------------
       * After make it uniform it would look like
       * ------------------------------------------------------
       *   1  |  1  |  1  |  1  |  1  |  1  |  0  | 1   |  0  |
       * ------------------------------------------------------
       *
       * If the original distribution array is not sufficient to hold all the elements one more array is
       * introduced.
       * @param {number} length Permitted limit of distribution
       */

      function DistributionMatrix(length) {
        // Allowed length of distribution
        this.distributionLength = length; // Represents the recalculated distribution for default side

        this.distributedMatrix = []; // Represents the recalculated distribution for alternate side

        this.altDistributedMatrix = []; // Represents the normal distribution

        this.nonDistributedMatrix = {}; // For focefully pushing elements which are need not be distributed, but required to be placed in
        // the final distribution matrix

        this.forcePushObj = {};
        this.flags = {
          exhaustion: false
        };
      }

      DistributionMatrix.prototype.constructor = DistributionMatrix;
      /**
       * Puts items in the matrix to calculate dependency.
       * @param {Object} item Item to be distributed
       * @param {number} rangeBottom distribution index
      */

      DistributionMatrix.prototype.push = function (item, rangeBottom) {
        // Original distribution before recalculation
        this.nonDistributedMatrix[rangeBottom] = this.nonDistributedMatrix[rangeBottom] || [];
        this.nonDistributedMatrix[rangeBottom].push(item);
      };
      /*
       * Forcefully pushes element in already distributed array. The system does not calculate the overall
       * distribution after the data being pushed.
       * @param item {{object}} - object to be forcefully distributed
       * @param index {{int}} - corrosponds to the index of the main array where the element to be placed
      */


      DistributionMatrix.prototype.forcePush = function (item, index) {
        this.forcePushObj[index] = item;
      };
      /*
       * Controls and spread distribution of non-uniform matrix to uniform matrix.
       * Gets called when result is prepared.
       */


      DistributionMatrix.prototype.distribute = function (legendSkip) {
        var datasetStore = _context,
            distributionItems,
            alternateSwitch = true,
            distributedMatrix = new ArrayableObj(),
            alternateDistributedMatrix = new ArrayableObj(),
            orphanMatrix = new ArrayableObj(),
            altOrphanMatrix = new ArrayableObj(),
            flags = this.flags,
            currentMatrix,
            distributionIndexAlt,
            distributionIndex,
            index,
            length,
            currentItem,
            absIndex = 0,
            dataLength = datasetStore.getDataLength(); // If there are too many labels even after placing them in alternate size, the system skips label.
        // This behaviour is observable especially with low height. On top of that if legend is positioned
        // at right side, system places labels only one side.
        // This is applied because two side space management
        // cannot be done in this scope.

        if (legendSkip) {
          // If legend is in right side place all the labels in one side
          if (dataLength - this.distributionLength > 0) {
            // willMatricsExhaust = true;
            // matricsExhaustionIndex = diff;
            for (distributionIndexAlt in this.nonDistributedMatrix) {
              distributionItems = this.nonDistributedMatrix[distributionIndexAlt];

              for (index = 1; index < distributionItems.length; index++) {
                // Keep only the first element in the block as
                // distribution will not be calculated since
                // labels are skipped.
                currentItem = distributionItems[index];
                currentItem.dontPlot = true;
                currentItem.displayValue = _lib.BLANK;
              }
            }
          }
        } else {
          // If legend is not in right side but possibility of canvas overflow
          if (dataLength - 2 * this.distributionLength > 0) {
            // willMatricsExhaust = true;
            // matricsExhaustionIndex = diff;
            for (distributionIndexAlt in this.nonDistributedMatrix) {
              distributionItems = this.nonDistributedMatrix[distributionIndexAlt];

              for (index = 1; index < distributionItems.length - 1; index++) {
                currentItem = distributionItems[index];
                currentItem.dontPlot = true;
                currentItem.displayValue = _lib.BLANK;
              }
            }
          }
        }
        /*
                   * If number of data to be distributed is greater than allowed length (in one side),
                   * alternate distribution happens.
                   * There are few concept here how the skipping is dealt with.
                   * The pyramid plot can have labels or can not. If the plot doesn't associate with a label we call
                   * it a orphan. While calculating the distribution orphans are not considered as their labels won't
                   * occupy any space. Hence these are kept in a separate matrix;
                   * Separately the orphans and non-orphans
                   * create one associative array. But when they are merged they create a complete array.
                   */


        if (dataLength > this.distributionLength && !legendSkip) {
          // If data exhausts two matrics, skip labels
          flags.exhaustion = true;

          for (distributionIndexAlt in this.nonDistributedMatrix) {
            distributionItems = this.nonDistributedMatrix[distributionIndexAlt]; // Alternatively place every item in two different arrays

            for (index = 0, length = distributionItems.length; index < length; index++) {
              currentItem = distributionItems[index];

              if (!currentItem.dontPlot) {
                alternateSwitch ? currentMatrix = distributedMatrix : currentMatrix = alternateDistributedMatrix;

                if (currentMatrix.getEffectiveLength() > parseInt(distributionIndexAlt, 10)) {
                  currentItem.distributionFactor = currentMatrix.getEffectiveLength() - 1 - distributionIndexAlt;
                } else {
                  // currentItem.distributionFactor = 0;
                  currentItem.distributionFactor = 0;
                }
              } else {
                alternateSwitch ? currentMatrix = orphanMatrix : currentMatrix = altOrphanMatrix;
              }

              currentMatrix.set(absIndex++, currentItem);
              alternateSwitch = !alternateSwitch;
            }
          } // Forms the complete array in both of the side


          this.distributedMatrix = distributedMatrix.mergeWith(orphanMatrix);
          this.altDistributedMatrix = alternateDistributedMatrix.mergeWith(altOrphanMatrix);
        } else {
          // Distribution happens in one side. Hence data can be accommodated in one side
          for (distributionIndex in this.nonDistributedMatrix) {
            distributionItems = this.nonDistributedMatrix[distributionIndex];

            for (index = 0, length = distributionItems.length; index < length; index++) {
              currentItem = distributionItems[index]; // Calculating distribution offset

              if (!currentItem.dontPlot) {
                currentMatrix = distributedMatrix;

                if (currentMatrix.getEffectiveLength() > parseInt(distributionIndex, 10)) {
                  currentItem.distributionFactor = currentMatrix.getEffectiveLength() - 1 - distributionIndex;
                } else {
                  currentItem.distributionFactor = 0;
                }
              } else {
                currentMatrix = orphanMatrix;
              }

              currentMatrix.set(absIndex++, currentItem);
            }
          }

          this.distributedMatrix = distributedMatrix.mergeWith(orphanMatrix);
        }
      };
      /*
               * Gets the distributed result.
               * @return {{object}} - {
               *   suggestion :
               *   matrix
               * }
               * Suggestion - suggests what kind of allignment to be taken
               * Matrix - Uniform distribution matrix
               */


      DistributionMatrix.prototype.getDistributedResult = function () {
        var datasetStore = _context,
            chart = datasetStore.getFromEnv('chart'),
            chartConfig = chart.config,
            legend = chart.getFromEnv('legend'),
            conf = datasetStore.config,
            alignmentType = conf.alignmentType,
            suggestion,
            matrix = [],
            isLegendRight = chart.isLegendRight,
            allowedRightX = chartConfig.width - conf.blankSpace;

        if (chartConfig.showLegend && legend.config.width) {
          isLegendRight && (allowedRightX -= legend.config.width + chartConfig.marginRight);
        } else {
          isLegendRight = 0;
        }

        chart.isLegendRight = isLegendRight;
        this.distribute(isLegendRight); // When legend is in right side the plot will be in one side with skipped labels.

        if (isLegendRight) {
          suggestion = alignmentType['default'];
          matrix.push(this.distributedMatrix);
        } else {
          suggestion = this.flags.exhaustion ? alignmentType.alternate : alignmentType['default'];
          this.flags.exhaustion ? [].push.call(matrix, this.distributedMatrix, this.altDistributedMatrix) : matrix.push(this.distributedMatrix);
        }

        return {
          'forceMatrix': this.forcePushObj,
          'suggestion': suggestion,
          'matrix': matrix
        };
      };

      return {
        DistributionMatrix: DistributionMatrix,
        setContext: function setContext(context) {
          _context = context;
        },
        invokeHookFns: function invokeHookFns() {
          var fn,
              params = [],
              ctx = _context;

          switch (arguments.length) {
            case 3:
              ctx = arguments[2];

            /* falls through */

            case 2:
              params = arguments[1];

            /* falls through */

            case 1:
              fn = arguments[0];
              break;

            default:
              return;
          }

          fn && typeof fn === 'function' && fn.apply(ctx, params);
        },
        copyProperties: function copyProperties(fromObject, toObject, mappingArray) {
          var index,
              length,
              confArr,
              fromName,
              toName,
              convertFunction,
              defaultValue,
              additionalFn,
              DEFAULT_FN = _lib.stubFN;
          /**
           * Calculates default value of key received
           * @param {number|string} key key value
           * @return {number|string} returns default value of key
           */

          function getDefaultValue(key) {
            var nKey;

            if (typeof key === 'string' && key.indexOf('$') === 0) {
              nKey = key.substring(1);
              return toObject[nKey];
            }

            if (typeof key === 'function') {
              return key.call(_context, toObject);
            }

            return key;
          }

          for (index = 0, length = mappingArray.length; index < length; index++) {
            confArr = mappingArray[index];
            fromName = confArr[0];
            toName = confArr[1];
            convertFunction = confArr[2];
            defaultValue = getDefaultValue(confArr[3]);
            additionalFn = confArr[4] || DEFAULT_FN;
            toObject[toName] = convertFunction(fromObject[fromName], defaultValue);
            additionalFn(toObject);
          }
        },
        sortObjArrByKey: function sortObjArrByKey(objArr, valueKey) {
          return objArr.sort(function (obj1, obj2) {
            return Math.abs(obj2[valueKey]) - Math.abs(obj1[valueKey]);
          });
        },
        getSumValueOfObjArrByKey: function getSumValueOfObjArrByKey(objArr, valueKey) {
          var index,
              length,
              total = 0;

          for (index = 0, length = objArr.length; index < length; index++) {
            total += parseFloat(objArr[index][valueKey], 10);
          }

          return total;
        }
      };
    };

    _this.hide = function (plotArr, currentDsLengthParam) {
      var index,
          animationManager = this.getFromEnv('animationManager'),
          callbackFn = function callbackFn() {
        this.hide();
      },
          plot,
          currentDsLength = currentDsLengthParam;

      if (!plotArr || plotArr.length === 0) {
        return;
      }

      currentDsLength = currentDsLength < 2 && this.getName() === 'funnel' ? 0 : currentDsLength;

      for (index = plotArr.length - 1; index >= currentDsLength; index--) {
        plot = plotArr[index].getGraphicalElement();

        if (plot.graphic) {
          plot.graphic.front && animationManager.setAnimation({
            el: plot.graphic.front,
            callback: callbackFn,
            component: this
          });
          plot.graphic.back && animationManager.setAnimation({
            el: plot.graphic.back,
            callback: callbackFn,
            component: this
          });
          plot.graphic.funnel2D && animationManager.setAnimation({
            el: plot.graphic.funnel2D,
            callback: callbackFn,
            component: this
          });
          plot.graphic.lighterHalf && animationManager.setAnimation({
            el: plot.graphic.lighterHalf,
            callback: callbackFn,
            component: this
          }); // plot.graphic.lighterHalf && !lighterHalf && plot.graphic.lighterHalf.hide();

          plot.graphic.darkerHalf && animationManager.setAnimation({
            el: plot.graphic.darkerHalf,
            callback: callbackFn,
            component: this
          }); // plot.graphic.darkerHalf && !darkerHalf && plot.graphic.darkerHalf.hide();

          plot.graphic.borderElement && animationManager.setAnimation({
            el: plot.graphic.borderElement,
            callback: callbackFn,
            component: this
          }); // plot.graphic.borderElement && !silhuettePath && plot.graphic.borderElement.hide();

          plot.graphic.centerLight && animationManager.setAnimation({
            el: plot.graphic.centerLight,
            callback: callbackFn,
            component: this
          }); // plot.graphic.centerLight && !centerLight && plot.graphic.centerLight.hide();

          plot.graphic.centerLight1 && animationManager.setAnimation({
            el: plot.graphic.centerLight1,
            callback: callbackFn,
            component: this
          }); // plot.graphic.centerLight1 && !centerLight1 && plot.graphic.centerLight1.hide();

          plot.graphic.toptop && animationManager.setAnimation({
            el: plot.graphic.toptop,
            callback: callbackFn,
            component: this
          }); // plot.graphic.toptop && !toptop && plot.graphic.toptop.hide();

          plot.graphic.topLight && animationManager.setAnimation({
            el: plot.graphic.topLight,
            callback: callbackFn,
            component: this
          }); // plot.graphic.topLight && !topLight && plot.graphic.topLight.hide();

          plot.graphic.topLight1 && animationManager.setAnimation({
            el: plot.graphic.topLight1,
            callback: callbackFn,
            component: this
          }); // plot.graphic.topLight1 && !topLight1 && plot.graphic.topLight1.hide();
        }

        plot.dataLabel && animationManager.setAnimation({
          el: plot.dataLabel,
          callback: callbackFn,
          component: this
        });
        plot.trackerObj && animationManager.setAnimation({
          el: plot.trackerObj,
          callback: callbackFn,
          component: this
        });
      }
    };

    _this.pyramidFunnelShape = function () {
      // @todo generic fn for pyramid and funnel
      // list of attr that will handled here
      var attrList = {
        y: true,
        R1: true,
        R2: true,
        h: true,
        r3dFactor: true,
        color: true,
        opacity: true,
        fill: true,
        stroke: true,
        strokeColor: true,
        strokeAlpha: true,
        'stroke-width': true
      },
          // FIX for #FWXT-600
      // for zero radius calcPoints return erroneous value
      minRadius = 0.01,
          getArcPath = function getArcPath(endX, endY, rX, rY, isClockWise, isLargeArc) {
        return [A, rX, rY, 0, isLargeArc, isClockWise, endX, endY];
      },

      /**
       * calcPoints method calculates and returns the
       * coordinates of four points of common tangency
       * between the upper and lower ellipses.
       * @param {number} a1          semi-major axis length of the upper ellipse
       * @param {number} b1          semi-minor axis length of the upper ellipse
       * @param {number} h1          height of upper ellipse center
       * @param {number} a2          semi-major axis length of the lower ellipse
       * @param {number} b2          semi-minor axis length of the lower ellipse
       * @param {number} h2          height of lower ellipse center
       * @return {Object}            object holding point instances corresponding
       *                       to the 4 points of tangencies.
      */
      calcPoints = function calcPoints(a1, b1, h1, a2, b2, h2) {
        // calcuating parameters of formula
        var alpha = mathPow(a2, 2) - mathPow(a1, 2),
            beta = -2 * (mathPow(a2, 2) * h1 - mathPow(a1, 2) * h2),
            gamma = mathPow(a1 * b2, 2) + mathPow(a2 * h1, 2) - mathPow(a2 * b1, 2) - mathPow(a1 * h2, 2),
            k = mathSqrt(mathPow(beta, 2) - 4 * alpha * gamma),
            // getting the 2 y-intercepts for there are 2 pairs of tangents
        c1 = (-beta + k) / (2 * alpha),
            c2 = (-beta - k) / (2 * alpha),
            oneHND = 100,
            objPoints,
            c,
            m1,
            m2,
            p1,
            p2,
            p3,
            p4,
            i; // but we need only one pair and hence one value of y-intercept

        if (c1 < h2 && c1 > h1) {
          c = c2;
        } else if (c2 < h2 && c2 > h1) {
          c = c1;
        } // getting the slopes of the 2 tangents of the selected pair


        m1 = mathSqrt((mathPow(c - h1, 2) - mathPow(b1, 2)) / mathPow(a1, 2));
        m2 = -m1; // getting the 4 points of tangency
        // right sided points
        // upper

        p1 = {
          x: mathRound(mathPow(a1, 2) * m1 / (c - h1) * oneHND) / oneHND,
          y: mathRound((mathPow(b1, 2) / (c - h1) + h1) * oneHND) / oneHND
        }; // lower

        p2 = {
          x: mathRound(mathPow(a2, 2) * m1 / (c - h2) * oneHND) / oneHND,
          y: mathRound((mathPow(b2, 2) / (c - h2) + h2) * oneHND) / oneHND
        }; // left sided points
        // upper

        p3 = {
          x: mathRound(mathPow(a1, 2) * m2 / (c - h1) * oneHND) / oneHND,
          y: mathRound((mathPow(b1, 2) / (c - h1) + h1) * oneHND) / oneHND
        }; // lower

        p4 = {
          x: mathRound(mathPow(a2, 2) * m2 / (c - h2) * oneHND) / oneHND,
          y: mathRound((mathPow(b2, 2) / (c - h2) + h2) * oneHND) / oneHND
        }; // storing in object to be passed as a collection

        objPoints = {
          topLeft: p3,
          bottomLeft: p4,
          topRight: p1,
          bottomRight: p2
        }; // checking for invalid situations

        for (i in objPoints) {
          if (isNaN(objPoints[i].x) || isNaN(objPoints[i].y)) {
            // The funnel is extremely thin and points of tangencies
            // coincide with ellipse ends
            if (i === 'topLeft' || i === 'bottomLeft') {
              objPoints[i].x = -a1;
            } else {
              objPoints[i].x = a1;
            }

            objPoints[i].y = i === 'bottomRight' || i === 'bottomLeft' ? h2 : h1;
          }
        } // object returned


        return objPoints;
      },
          getFunnel3DShapeArgs = function getFunnel3DShapeArgs(x, y, R1, R2, h, r3dFactor, isHollow) {
        var y2 = y + h,
            R3 = R1 * r3dFactor,
            R4 = R2 * r3dFactor,
            shapearge,
            objPoints = calcPoints(R1, R3, y, R2, R4, y2),
            topLeft = objPoints.topLeft,
            bottomLeft = objPoints.bottomLeft,
            topRight = objPoints.topRight,
            bottomRight = objPoints.bottomRight,
            X1 = x + topLeft.x,
            X2 = x + topRight.x,
            X3 = x + bottomLeft.x,
            X4 = x + bottomRight.x,
            y3 = topLeft.y,
            y4 = bottomLeft.y,
            arc1 = getArcPath(X2, y3, R1, R3, 0, 0),
            arc2 = getArcPath(X2, y3, R1, R3, 1, 1),
            arc3 = getArcPath(X3, y4, R2, R4, 1, 0),
            arc4 = getArcPath(X3, y4, R2, R4, 0, 1);
        shapearge = {
          front: [M, X1, y3].concat(arc1, [L, X4, y4], arc3, [Z]),
          back: [M, X1, y3].concat(arc2, [L, X4, y4], arc4, [Z]),
          silhuette: [M, X1, y3].concat(arc2, [L, X4, y4], arc3, [Z])
        };

        if (!isHollow) {
          shapearge.top = [M, X1, y3].concat(arc1, [L, X2, y3], getArcPath(X1, y3, R1, R3, 0, 1), [Z]);
        }

        return shapearge;
      },
          getPyramid3DShapeArgs = function getPyramid3DShapeArgs(xParam, yParam, R1Param, R2Param, hParam, r3dFactorParam, is2DParam, rendererParam, isFunnelParam, isHollowParam) {
        var x = xParam,
            y = yParam,
            R1 = R1Param,
            R2 = R2Param,
            h = hParam,
            r3dFactor = r3dFactorParam,
            is2D = is2DParam,
            renderer = rendererParam,
            isFunnel = isFunnelParam,
            isHollow = isHollowParam;

        if (isObject(x)) {
          y = x.y;
          R1 = x.R1;
          R2 = x.R2;
          h = x.h;
          r3dFactor = x.r3dFactor;
          is2D = x.is2D; // use3DLighting = x.use3DLighting;

          isHollow = x.isHollow;
          isFunnel = x.isFunnel;
          renderer = x.renderer;
          x = x.x;
        }

        var X1 = x - R1,
            X2 = x + R1,
            X3 = x - R2,
            X4 = x + R2,
            y2 = y + h,
            shapeArgs,
            R3,
            R4,
            lightLength,
            lightLengthH,
            lightLengthH1,
            lightWidth;

        if (is2D) {
          shapeArgs = {
            silhuette: [M, X1, y, L, X2, y, X4, y2, X3, y2, Z]
          };

          if (!isFunnel) {
            // Rounding the x value to remove the thin white gap between following two halfs due
            // to sub-pixel rendering.
            x = Math.round(x);
            shapeArgs.lighterHalf = [M, X1, y, L, x, y, x, y2, X3, y2, Z];
            shapeArgs.darkerHalf = [M, x, y, L, X2, y, X4, y2, x, y2, Z];
          }
        } else if (isFunnel) {
          shapeArgs = getFunnel3DShapeArgs(x, y, R1 || minRadius, R2 || minRadius, h, r3dFactor, isHollow, renderer);
        } else {
          R3 = R1 * r3dFactor;
          R4 = R2 * r3dFactor;
          lightLength = mathMin(5, R1);
          lightLengthH = mathMin(2, 2 * R3);
          lightLengthH1 = mathMin(2, lightLengthH);
          lightWidth = lightLengthH1 / r3dFactor;
          shapeArgs = {
            top: [M, X1, y, L, x, y + R3, X2, y, x, y - R3, Z],
            front: [M, X1, y, L, x, y + R3, X2, y, X4, y2, x, y2 + R4, X3, y2, Z],
            topLight: [M, X1, y + 0.5, L, x, y + R3 + 0.5, x, y + R3 - lightLengthH, X1 + lightWidth, y, Z],
            // x, y + R3 - lightLengthH, Z],
            topLight1: [M, X2, y + 0.5, L, x, y + R3 + 0.5, x, y + R3 - lightLengthH1, X2 - lightWidth, y, Z],
            // x, y + R3 - lightLengthH, Z],
            silhuette: [M, X1, y, L, x, y - R3, X2, y, X4, y2, x, y2 + R4, X3, y2, Z],
            centerLight: [M, x, y + R3, L, x, y2 + R4, x - 5, y2 + R4, x - lightLength, y + R3, Z],
            centerLight1: [M, x, y + R3, L, x, y2 + R4, x + 5, y2 + R4, x + lightLength, y + R3, Z]
          };
        }

        return shapeArgs;
      },
          attr = function attr(hashParam, val) {
        var key,
            value,
            element = this,
            color,
            alpha,
            colorObject,
            shapeChanged = false,
            colorChanged = false,
            lightColor,
            lightColor1,
            darkColor,
            attr3D = this._3dAttr,
            shapeArgs,
            colorDark,
            colorLight,
            zero100STR,
            lightAlphaSTR,
            lightShade,
            slantAngle,
            lightShadeStop,
            hash = hashParam; // single key-value pair

        if (isString(hash) && defined(val)) {
          key = hash;
          hash = {};
          hash[key] = val;
        } // used as a getter: first argument is a string, second is UNDEF


        if (isString(hash)) {
          // if belongs from the list then handle here
          if (attrList[hash]) {
            element = this._3dAttr[hash];
          } else {
            // else leve for the original attr
            element = this._attr(hash);
          } // setter

        } else {
          for (key in hash) {
            value = hash[key]; // if belongs from the list then handle here

            if (attrList[key]) {
              // store the att in attr3D for further use
              attr3D[key] = value; // if it is 'fill' or 'lighting3D' the redefine the colors for all the 3 elements

              if (key === fillStr) {
                if (value && value.linearGradient && value.stops && value.stops[0]) {
                  value = value.stops[0][1];
                }

                if (startsRGBA.test(value)) {
                  colorObject = new Color(value);
                  color = colorObject.get('hex');
                  alpha = colorObject.get('a') * 100;
                } else if (value && value.FCcolor) {
                  color = value.FCcolor.color.split(_lib.COMMASTRING)[0];
                  alpha = value.FCcolor.opacity.split(_lib.COMMASTRING)[0];
                } else if (HEXCODE.test(value)) {
                  color = value.replace(dropHash, _lib.HASHSTRING);
                  alpha = (0, _lib.pluckNumber)(attr3D.opacity, 100);
                }

                attr3D.color = color;
                attr3D.opacity = alpha;
                colorChanged = true;
              } else if (key === 'color' || key === 'opacity') {
                attr3D.fill = (0, _lib.toRaphaelColor)((0, _lib.convertColor)(attr3D.color, (0, _lib.pluckNumber)(attr3D.opacity, 100)));
                colorChanged = true;
              } else if (key === 'stroke' || key === 'strokeColor' || key === 'strokeAlpha') {
                if (attr3D.is2D) {
                  // stroke is only applicable on 2d shape
                  if (key === 'stroke') {
                    if (value && value.linearGradient && value.stops && value.stops[0]) {
                      value = value.stops[0][1];
                    }

                    if (startsRGBA.test(value)) {
                      colorObject = new Color(value);
                      color = colorObject.get('hex');
                      alpha = colorObject.get('a') * 100;
                    } else if (value && value.FCcolor) {
                      color = value.FCcolor.color.split(_lib.COMMASTRING)[0];
                      alpha = value.FCcolor.opacity.split(_lib.COMMASTRING)[0];
                    } else if (HEXCODE.test(value)) {
                      color = value.replace(dropHash, _lib.HASHSTRING);
                      alpha = (0, _lib.pluckNumber)(attr3D.opacity, 100);
                    }

                    attr3D.strokeColor = color;
                    attr3D.strokeAlpha = alpha;
                  } else {
                    attr3D.stroke = (0, _lib.convertColor)(attr3D.strokeColor, (0, _lib.pluckNumber)(attr3D.strokeAlpha, 100));
                  }

                  if (attr3D.isFunnel) {
                    this.funnel2D.attr('stroke', attr3D.stroke);
                  } else {
                    this.borderElement.attr('stroke', attr3D.stroke);
                  }
                }
              } else if (key === 'stroke-width') {
                if (attr3D.is2D) {
                  // stroke is only applicable on 2d shape
                  if (attr3D.isFunnel) {
                    this.funnel2D.attr(key, value);
                  } else {
                    this.borderElement.attr(key, value);
                  }
                }
              } else {
                shapeChanged = true;
              }
            } else {
              // else leave for the original attr
              this._attr(key, value);
            }
          }

          if (attr3D.is2D) {
            if (shapeChanged) {
              shapeArgs = getPyramid3DShapeArgs(attr3D.x, attr3D.y, attr3D.R1, attr3D.R2, attr3D.h, attr3D.r3dFactor, attr3D.is2D);
              element.shadowElement.attr({
                path: shapeArgs.silhuette
              });

              if (attr3D.isFunnel) {
                element.funnel2D.attr({
                  path: shapeArgs.silhuette
                });
              } else {
                element.lighterHalf.attr({
                  path: shapeArgs.lighterHalf
                });
                element.darkerHalf.attr({
                  path: shapeArgs.darkerHalf
                });
                element.borderElement.attr({
                  path: shapeArgs.silhuette
                });
              }
            } // if color change requared


            if (colorChanged) {
              if (attr3D.isFunnel) {
                element.funnel2D.attr(fillStr, (0, _lib.toRaphaelColor)((0, _lib.convertColor)(attr3D.color, (0, _lib.pluckNumber)(attr3D.opacity, 100))));
              } else {
                if (attr3D.use3DLighting === false) {
                  colorDark = colorLight = attr3D.color;
                } else {
                  colorDark = (0, _lib.getDarkColor)(attr3D.color, 80);
                  colorLight = (0, _lib.getLightColor)(attr3D.color, 80);
                }

                element.lighterHalf.attr(fillStr, (0, _lib.toRaphaelColor)((0, _lib.convertColor)(colorLight, (0, _lib.pluckNumber)(attr3D.opacity, 100))));
                element.darkerHalf.attr(fillStr, (0, _lib.toRaphaelColor)((0, _lib.convertColor)(colorDark, (0, _lib.pluckNumber)(attr3D.opacity, 100))));
              }
            }
          } else {
            // if shape changed requared
            if (shapeChanged) {
              shapeArgs = getPyramid3DShapeArgs(attr3D.x, attr3D.y, attr3D.R1, attr3D.R2, attr3D.h, attr3D.r3dFactor, attr3D.is2D);
              element.shadowElement.attr(pathStr, shapeArgs.silhuette);

              if (attr3D.isFunnel) {
                element.front.attr(pathStr, shapeArgs.front);
                element.back.attr(pathStr, shapeArgs.back);

                if (element.toptop && shapeArgs.top) {
                  element.toptop.attr(pathStr, shapeArgs.top);
                }
              } else {
                element.front.attr(pathStr, shapeArgs.front);
                element.toptop.attr(pathStr, shapeArgs.top);
                element.topLight.attr(pathStr, shapeArgs.topLight);
                element.topLight1.attr(pathStr, shapeArgs.topLight1);
                element.centerLight.attr(pathStr, shapeArgs.centerLight);
                element.centerLight1.attr(pathStr, shapeArgs.centerLight1);
              }
            } // if color change requared


            if (colorChanged) {
              color = attr3D.color;
              alpha = attr3D.opacity;

              if (attr3D.isFunnel) {
                lightColor = (0, _lib.getLightColor)(color, 60);
                darkColor = (0, _lib.getDarkColor)(color, 60);
                element.back.attr(fillStr, (0, _lib.toRaphaelColor)({
                  FCcolor: {
                    color: darkColor + _lib.COMMASTRING + lightColor + _lib.COMMASTRING + color,
                    alpha: alpha + _lib.COMMASTRING + alpha + _lib.COMMASTRING + alpha,
                    ratio: '0,60,40',
                    angle: 0
                  }
                }));
                element.front.attr(fillStr, (0, _lib.toRaphaelColor)({
                  FCcolor: {
                    color: color + _lib.COMMASTRING + lightColor + _lib.COMMASTRING + darkColor,
                    alpha: alpha + _lib.COMMASTRING + alpha + _lib.COMMASTRING + alpha,
                    ratio: '0,40,60',
                    angle: 0
                  }
                }));

                if (element.toptop) {
                  element.toptop.attr(fillStr, (0, _lib.toRaphaelColor)({
                    FCcolor: {
                      color: lightColor + _lib.COMMASTRING + darkColor,
                      alpha: alpha + _lib.COMMASTRING + alpha,
                      ratio: zeroCommaHundredStr,
                      angle: -65
                    }
                  }));
                }
              } else {
                lightColor = (0, _lib.getLightColor)(color, 80);
                lightColor1 = (0, _lib.getLightColor)(color, 70);
                darkColor = (0, _lib.getDarkColor)(color, 80);
                zero100STR = zeroCommaHundredStr;
                lightAlphaSTR = '0,' + alpha;
                lightShade = color + _lib.COMMASTRING + lightColor1;
                slantAngle = -45;
                lightShadeStop = 5 / (attr3D.R1 * attr3D.r3dFactor) * 100; // slantAngle = - math.atan(1 / attr3D.r3dFactor) / deg2rad

                element.centerLight.attr(fillStr, (0, _lib.toRaphaelColor)({
                  FCcolor: {
                    color: lightShade,
                    alpha: lightAlphaSTR,
                    ratio: zero100STR,
                    angle: 0
                  }
                }));
                element.centerLight1.attr(fillStr, (0, _lib.toRaphaelColor)({
                  FCcolor: {
                    color: lightShade,
                    alpha: lightAlphaSTR,
                    ratio: zero100STR,
                    angle: 180
                  }
                }));
                element.topLight.attr(fillStr, (0, _lib.toRaphaelColor)({
                  FCcolor: {
                    color: lightColor1 + _lib.COMMASTRING + lightColor1 + _lib.COMMASTRING + color + _lib.COMMASTRING + color,
                    alpha: alpha + _lib.COMMASTRING + alpha + _lib.COMMASTRING + 0 + _lib.COMMASTRING + 0,
                    ratio: '0,50,' + lightShadeStop + _lib.COMMASTRING + (50 - lightShadeStop),
                    angle: slantAngle
                  }
                }));
                element.topLight1.attr(fillStr, (0, _lib.toRaphaelColor)({
                  FCcolor: {
                    color: lightColor1 + _lib.COMMASTRING + color + _lib.COMMASTRING + darkColor,
                    alpha: alpha + _lib.COMMASTRING + alpha + _lib.COMMASTRING + alpha,
                    ratio: '0,50,50',
                    angle: 0
                  }
                }));
                element.front.attr(fillStr, (0, _lib.toRaphaelColor)({
                  FCcolor: {
                    color: color + _lib.COMMASTRING + color + _lib.COMMASTRING + darkColor + _lib.COMMASTRING + darkColor,
                    alpha: alpha + _lib.COMMASTRING + alpha + _lib.COMMASTRING + alpha + _lib.COMMASTRING + alpha,
                    ratio: '0,50,0,50',
                    angle: 0
                  }
                }));
                element.toptop.attr(fillStr, (0, _lib.toRaphaelColor)({
                  FCcolor: {
                    color: lightColor + _lib.COMMASTRING + color + _lib.COMMASTRING + darkColor + _lib.COMMASTRING + darkColor,
                    alpha: alpha + _lib.COMMASTRING + alpha + _lib.COMMASTRING + alpha + _lib.COMMASTRING + alpha,
                    ratio: '0,25,30,45',
                    angle: slantAngle
                  }
                }));
              }
            }
          }
        }

        return element;
      },
          shadow = function shadow() {
        var silhuette = this.shadowElement;

        if (shadow) {
          silhuette.shadow.apply(silhuette, arguments);
        }
      },
          normalizeShapes = function normalizeShapes(group, newAttrs) {
        var shapes = ['silhuette', 'lighterHalf', 'darkerHalf', 'centerLight', 'centerLight1', 'front', 'toptop', 'topLight', 'topLight1', 'shadowElement', 'funnel2D', 'borderElement', 'back'],
            shapeGElem,
            index,
            shapeName,
            oldAttrs,
            length;

        if (!group) {
          return;
        }

        oldAttrs = group._3dAttr;

        if (oldAttrs.isFunnel === newAttrs.isFunnel && oldAttrs.is2D === newAttrs.is2D && oldAttrs.isHollow === newAttrs.isHollow) {
          return group;
        }

        for (index = 0, length = shapes.length; index < length; index++) {
          shapeName = shapes[index];
          shapeGElem = group[shapeName];

          if (!shapeGElem) {
            continue;
          }

          delete group[shapeName];
          shapeGElem.remove();
        }

        return group;
      },
          animatePathIfPresent = function animatePathIfPresent(datasetStore, parentElem) {
        var chart = datasetStore.getFromEnv('chart');
        return function (elemType, pathArr, nonAnimAttr) {
          if (nonAnimAttr === void 0) {
            nonAnimAttr = EMPTY_OBJ;
          }

          var prevEle = parentElem[elemType];

          if (prevEle) {
            // return prevEle.animateWith(dummyAnimElem, dummyAnimObj, {
            //   path: pathArr
            // }, animDuration, animType, datasetStore.postPlotCallback);
            chart.getFromEnv('animationManager').setAnimation({
              el: prevEle,
              attr: {
                path: pathArr
              },
              component: datasetStore
            });
            return prevEle;
          }

          datasetStore.postPlotCallback();
          return chart.getFromEnv('animationManager').setAnimation({
            el: 'path',
            label: 'path',
            attr: Object.assign({
              path: pathArr
            }, nonAnimAttr),
            container: parentElem,
            component: datasetStore
          }); // renderer.path(pathArr, parentElem).attr(nonAnimAttr);
        };
      };

      return function (xParam, yParam, R1Param, R2Param, hParam, r3dFactorParam, gStrParam, is2DParam, rendererParam, isFunnelParam, isHollowParam, use3DLightingParam) {
        var datasetStore = this,
            chart = datasetStore.getFromEnv('chart'),
            graphicsGroup = chart.getChildContainer().plotGroup,
            _3dAttr,
            Shapeargs,
            Shapeargs2,
            oldLastData = datasetStore.config.oldLastData,
            rect3D,
            squeezedFormPathObj,
            squeezedShapeArgs,
            existingGElement,
            animationType = EASE_IN,
            animOrDraw,
            x = xParam,
            y = yParam,
            R1 = R1Param,
            R2 = R2Param,
            h = hParam,
            r3dFactor = r3dFactorParam,
            gStr = gStrParam,
            is2D = is2DParam,
            renderer = rendererParam,
            isFunnel = isFunnelParam,
            isHollow = isHollowParam,
            use3DLighting = use3DLightingParam;

        if (isObject(x)) {
          y = x.y;
          R1 = x.R1;
          R2 = x.R2;
          h = x.h;
          r3dFactor = x.r3dFactor;
          gStr = x.gStr;
          is2D = x.is2D;
          use3DLighting = x.use3DLighting;
          renderer = x.renderer;
          isHollow = x.isHollow;
          isFunnel = x.isFunnel;
          existingGElement = x.graphics;
          x = x.x;
        }

        r3dFactor = (0, _lib.pluckNumber)(r3dFactor, 0.15);
        _3dAttr = {
          x: x,
          y: y,
          R1: R1,
          R2: R2,
          h: h,
          r3dFactor: r3dFactor,
          is2D: is2D,
          use3DLighting: use3DLighting,
          isHollow: isHollow,
          isFunnel: isFunnel,
          renderer: renderer
        }; // Shapeargs = getPyramid3DShapeArgs(_3dAttr);

        rect3D = normalizeShapes(existingGElement, _3dAttr) || renderer.group(gStr, graphicsGroup);
        rect3D.toFront();

        if ((!rect3D.front && !is2D || !(rect3D.funnel2D || rect3D.lighterHalf) && is2D) && datasetStore.getState('notInitial') && datasetStore.config.prevIs2d === _3dAttr.is2D) {
          Shapeargs2 = getPyramid3DShapeArgs(_3dAttr);
          oldLastData.y = oldLastData.y + oldLastData.h;
          oldLastData.R1 = oldLastData.R2;
          oldLastData.h = 0;
          Shapeargs = getPyramid3DShapeArgs(oldLastData);
        } else {
          Shapeargs = getPyramid3DShapeArgs(_3dAttr);
          datasetStore.getState('notInitial', true);
        }

        squeezedShapeArgs = Object.assign({}, _3dAttr);
        squeezedShapeArgs.y = squeezedShapeArgs.y + squeezedShapeArgs.h;
        squeezedShapeArgs.R1 = squeezedShapeArgs.R2;
        squeezedShapeArgs.h = 0;
        squeezedFormPathObj = getPyramid3DShapeArgs(squeezedShapeArgs);
        rect3D.squeezedFormPathObj = squeezedFormPathObj;
        rect3D.Shapeargs = Shapeargs2 || Shapeargs;
        animOrDraw = animatePathIfPresent(datasetStore, rect3D, animationType);
        rect3D.shadowElement = animOrDraw('shadowElement', Shapeargs.silhuette, {
          fill: TRACKER_FILL,
          stroke: noneStr
        }); // modify the attr function of the group so that it can handle pyramid attrs
        // store the old function

        rect3D._attr = rect3D._attr || rect3D.attr;
        rect3D.attr = attr; // Replace the shadow function with a modified version.

        rect3D.shadow = shadow; // store the 3d attr(requared in new attr function to change any related
        //                  attr modiffiaction)

        rect3D._3dAttr = _3dAttr; // add the new attr function

        if (isFunnel) {
          // if the drawing is a 2d drawing
          if (is2D) {
            rect3D.funnel2D = animOrDraw('funnel2D', Shapeargs.silhuette);
            Shapeargs2 && (rect3D.funnel2D = animOrDraw('funnel2D', Shapeargs2.silhuette));
          } else {
            rect3D.back = animOrDraw('back', Shapeargs.back, {
              'stroke-width': 0,
              stroke: noneStr
            });
            rect3D.front = animOrDraw('front', Shapeargs.front, {
              'stroke-width': 0,
              stroke: noneStr
            });
            Shapeargs2 && (rect3D.back = animOrDraw('back', Shapeargs2.back, {
              'stroke-width': 0,
              stroke: noneStr
            }));
            Shapeargs2 && (rect3D.front = animOrDraw('front', Shapeargs2.front, {
              'stroke-width': 0,
              stroke: noneStr
            }));

            if (Shapeargs.top) {
              rect3D.toptop = animOrDraw('toptop', Shapeargs.top, {
                'stroke-width': 0,
                stroke: noneStr
              });
              Shapeargs2 && (rect3D.toptop = animOrDraw('toptop', Shapeargs2.top, {
                'stroke-width': 0,
                stroke: noneStr
              }));
            }
          }
        } else {
          // if the drawing is a 2d drawing
          if (is2D) {
            rect3D.lighterHalf = animOrDraw('lighterHalf', Shapeargs.lighterHalf, {
              'stroke-width': 0
            });
            Shapeargs2 && (rect3D.lighterHalf = animOrDraw('lighterHalf', Shapeargs2.lighterHalf, {
              'stroke-width': 0
            }));
            rect3D.darkerHalf = animOrDraw('darkerHalf', Shapeargs.darkerHalf, {
              'stroke-width': 0
            });
            Shapeargs2 && (rect3D.darkerHalf = animOrDraw('darkerHalf', Shapeargs2.darkerHalf, {
              'stroke-width': 0
            }));
            rect3D.borderElement = animOrDraw('borderElement', Shapeargs.silhuette, {
              fill: TRACKER_FILL,
              stroke: noneStr
            });
            Shapeargs2 && (rect3D.borderElement = animOrDraw('borderElement', Shapeargs2.silhuette, {
              fill: TRACKER_FILL,
              stroke: noneStr
            }));
          } else {
            // else it should be 3d
            rect3D.front = animOrDraw('front', Shapeargs.front, {
              'stroke-width': 0
            });
            Shapeargs2 && (rect3D.front = animOrDraw('front', Shapeargs2.front, {
              'stroke-width': 0
            }));
            rect3D.centerLight = animOrDraw('centerLight', Shapeargs.centerLight, {
              'stroke-width': 0
            });
            Shapeargs2 && (rect3D.centerLight = animOrDraw('centerLight', Shapeargs2.centerLight, {
              'stroke-width': 0
            }));
            rect3D.centerLight1 = animOrDraw('centerLight1', Shapeargs.centerLight1, {
              'stroke-width': 0
            });
            Shapeargs2 && (rect3D.centerLight1 = animOrDraw('centerLight1', Shapeargs2.centerLight1, {
              'stroke-width': 0
            }));
            rect3D.toptop = animOrDraw('toptop', Shapeargs.top, {
              'stroke-width': 0
            });
            Shapeargs2 && (rect3D.toptop = animOrDraw('toptop', Shapeargs2.top, {
              'stroke-width': 0
            }));
            rect3D.topLight = animOrDraw('topLight', Shapeargs.topLight, {
              'stroke-width': 0
            });
            Shapeargs2 && (rect3D.topLight = animOrDraw('topLight', Shapeargs2.topLight, {
              'stroke-width': 0
            }));
            rect3D.topLight1 = animOrDraw('topLight1', Shapeargs.topLight1, {
              'stroke-width': 0
            });
            Shapeargs2 && (rect3D.topLight1 = animOrDraw('topLight1', Shapeargs2.topLight1, {
              'stroke-width': 0
            }));
          }
        }

        return rect3D;
      };
    }();

    _this.config.legendItemIds = [];

    var utils = _this.utils((0, _assertThisInitialized2.default)(_this)),
        invokeHookFns = utils.invokeHookFns,
        postInitHookFn = _this.postInitHook;

    invokeHookFns(postInitHookFn);
    return _this;
  }
  /**
   * Trim extra old data compared to new data
   * @param {Object} datasetJSON input JSON data
   */


  _proto.trimData = function trimData(datasetJSON) {
    _pie2d.trimData.call(this, datasetJSON);
  }
  /**
   * Finds total number of data components not in removed state
   *
   * @returns {Number} total number of components not in removed state
   * @memberof FunnelPyramidBaseDataset
   */
  ;

  _proto.getDataLength = function getDataLength() {
    var dataset = this,
        i,
        data = dataset.getChildren('data'),
        dataLen = 0,
        len = data.length;

    for (i = 0; i < len; i++) {
      if (!data[i].getState('removed')) {
        dataLen++;
      }
    }

    return dataLen;
  }
  /**
   * Stores the data which are to be removed in removedDataArr during
   * configure
   *
   * @param {any} indexArg index
   * @param {any} stretchArg how many elements to be deleted
   * @param {any} draw whether to draw after removing
   * @memberof FunnelPyramidBaseDataset
   */
  ;

  _proto.removeData = function removeData(indexArg, stretchArg, draw) {
    if (draw === void 0) {
      draw = false;
    }

    var dataset = this,
        components = dataset.components,
        dataStore = dataset.getChildren('data'),
        removedDataArr,
        i,
        len,
        stretch = stretchArg,
        index = indexArg;
    stretch = (0, _lib.pluckNumber)(stretch, 1);
    index = (0, _lib.pluckNumber)(index, 0); // Store the elements which are no longer required

    removedDataArr = components.removedDataArr = dataStore.splice(index, stretch);
    len = removedDataArr.length;

    for (i = 0; i < len; i++) {
      if (!removedDataArr[i]) {
        removedDataArr.splice(i, 1);
      }
    }

    draw && dataset.asyncDraw();
  }
  /**
   * Removes extra plot elements when number of current data
   * is less than number of previous data
   */
  ;

  _proto.removePlots = function removePlots() {
    var dataset = this,
        components = dataset.components,
        removedDataArr = components.removedDataArr,
        i,
        elem,
        graphics,
        point;

    if (!removedDataArr) {
      return;
    }

    for (i = removedDataArr.length - 1; i >= 0; i--) {
      point = removedDataArr[i];
      graphics = point.getGraphicalElement();

      for (elem in graphics) {
        point.removeGraphicalElement(graphics[elem]);
      }

      removedDataArr.splice(i, 1);
    }
  }
  /**
   * Configure dataset
   */
  ;

  _proto._configure = function _configure() {
    var datasetStore = this,
        chart = datasetStore.getFromEnv('chart'),
        colorManager = datasetStore.getFromEnv('color-manager'),
        chartConfig = chart.config,
        globalStyle = chartConfig.style,
        datasetConf = datasetStore.config || {},
        jsonDataObj = datasetStore.config.JSONData,
        datasetDataArr = jsonDataObj.data || [],
        chartAttr = chart.getFromEnv('dataSource') ? chart.getFromEnv('dataSource').chart : {},
        utils = datasetStore.utils(datasetStore),
        invokeHookFns = utils.invokeHookFns,
        copyProperties = utils.copyProperties,
        BLANK_SPACE = 3,
        DEFAULT_LABEL_DISTANCE = 50,
        DEFAULT_BLANK_SPACE = 3,
        configureSpecificsFn = datasetStore.configureSpecifics,
        baseFontColor = colorManager.getColor('baseFontColor'); // Parse all the attributes common to pyramid and funnel

    copyProperties(chartAttr, datasetConf, [['showlabels', 'showLabels', _lib.pluckNumber, 1], ['showvalues', 'showValues', _lib.pluckNumber, 1], ['plottooltext', 'toolText', _lib.pluck, _lib.BLANK], ['enableslicing', 'enableSlicing', _lib.pluckNumber, 1], ['plotfillalpha', 'plotFillAlpha', _lib.pluckNumber, 100], ['showplotborder', 'showPlotBorder', _lib.pluckNumber, 0], ['plotborderalpha', 'plotBorderAlpha', _lib.pluckNumber, UNDEF], ['plotbordercolor', 'plotBorderColor', _lib.pluck, UNDEF], ['plotborderthickness', 'plotBorderThickness', _lib.pluckNumber, 1], ['showshadow', 'showShadow', _lib.pluckNumber, 1], ['showhovereffect', showHoverEffectStr, _lib.pluckNumber, 0], ['hovercapsepchar', 'hoverCapSepChar', _lib.pluck, _lib.COMMASPACE], ['tooltipsepchar', 'tooltipSepChar', _lib.pluck, '$hoverCapSepChar'], ['labelsepchar', 'labelSepChar', function () {
      return (0, _lib.parseUnsafeString)(_lib.pluck.apply(void 0, arguments));
    }, '$tooltipSepChar'], ['showpercentintooltip', 'showPercentInToolTip', _lib.pluckNumber, 1], ['showpercentvalues', 'showPercentValues', _lib.pluckNumber, 0], [_lib.BLANK, 'blankSpace', _lib.pluckNumber, BLANK_SPACE], ['labeldistance', 'labelDistance', _lib.pluckNumber, DEFAULT_LABEL_DISTANCE], ['issliced', 'isSliced', _lib.pluckNumber, 0], ['is2d', 'is2d', _lib.pluckNumber, 0], [_lib.BLANK, 'blankSpace', _lib.pluckNumber, DEFAULT_BLANK_SPACE], ['showlabelsatcenter', 'showLabelsAtCenter', _lib.pluckNumber, 0], ['smartlinethickness', 'connectorWidth', _lib.pluckNumber, 1], ['smartlinealpha', 'connectorAlpha', _lib.pluckNumber, 100], ['smartlinecolor', 'rawSmartLineColorCode', _lib.pluck, function () {
      return colorManager.getColor('baseFontColor');
    }], ['labelalpha', 'labelAlpha', _lib.pluckNumber, 100], ['basefont', 'baseFont', _lib.pluck, 'Verdana,sans'], ['basefontsize', 'baseFontSize', _lib.pluckNumber, 10], ['basefontcolor', 'baseFontColor', _lib.pluck, baseFontColor], ['labelfontcolor', 'labelFontColor', _lib.pluck, '$baseFontColor'], ['showtooltip', 'showTooltip', _lib.pluckNumber, 1], ['percentofprevious', 'percentOfPrevious', _lib.pluckNumber, 0], ['animationduration', 'animationDuration', _lib.pluckNumber, 1, function (datasetConfig) {
      datasetConfig.animationDuration *= 1000;
    }]]);
    datasetConf.usePattern = (0, _lib.pluckNumber)(chartConfig.usePattern, 0);
    datasetConf.patternType = PATTERN_TYPES.includes(jsonDataObj.patterntype) ? jsonDataObj.patterntype : chartConfig.patternType;
    datasetConf.patternDensity = (0, _lib.pluckNumber)(jsonDataObj.patterndensity, chartConfig.patternDensity);
    datasetConf.patternAlpha = (0, _lib.pluckNumber)(jsonDataObj.patternalpha, chartConfig.patternAlpha);
    datasetConf.patternBgColor = (0, _lib.pluck)(jsonDataObj.patternbgcolor, TRACKER_FILL); // when pattern is used all 3d effects is disabled

    if (datasetConf.usePattern) {
      datasetConf.is2d = 1;
      datasetConf.showPlotBorder = (0, _lib.pluck)(chartAttr.showplotorder, 1);
      datasetConf.showHoverEffect = 0;
    }

    datasetConf.connectorColor = (0, _lib.convertColor)(datasetConf.rawSmartLineColorCode, datasetConf.connectorAlpha); // Store original labelDistance. The labelDistance calculation should use the originalLabelDistance as initial value.

    datasetConf.origLabelDistance = datasetConf.labelDistance; // Calculate the line height with the style applied in chart level

    (0, _lib.setLineHeight)(globalStyle); // Get only the starting digits from the line height string. This is a temprary property.

    globalStyle.nLineHeight = globalStyle.lineHeight.match(/^\d+/)[0];
    copyProperties(globalStyle, datasetConf, [[_lib.BLANK, 'lineHeight', _lib.pluckNumber, datasetConf.baseFontSize]]); // Stores the state when isSliced is set to 1 at dataset level.
    // Used to keep the plot in clicked state.

    if (datasetConf.isSliced) {
      datasetConf.clicked = true;
    } // Detele the property as it was created for computation purpose only.


    delete globalStyle.nLineHeight; // Call function for specific configuration partucular to a chart.

    invokeHookFns(configureSpecificsFn);

    if (!datasetConf.showLabels && !datasetConf.showValues) {
      // If the labels and values both are disabled, refrain from plotting the datalabels.
      // This is a flag that let the drawing components know about the user choice.
      datasetConf.datalabelDisabled = true;
    } else {
      datasetConf.datalabelDisabled = false;
    } // Normalize the data set. This process handles all the parseInt, parseFloat like methods, computes
    // additional keys if necessary


    datasetStore.getNormalizeDataSet(datasetDataArr);
  }
  /**
   * Is called during post spacemanagement, it sets the slicing distance by using canvasHeight.
   * Also, does preDrawing calculations required when data is streamlined.
   *
   * @memberof FunnelPyramidBaseDataset
   */
  ;

  _proto._preDrawingHook = function _preDrawingHook() {
    var dataset = this,
        chart = dataset.getFromEnv('chart'),
        datasetConf = dataset.config,
        chartConf = chart.config,
        utils = dataset.utils(dataset),
        chartAttr = chart.getFromEnv('dataSource') ? chart.getFromEnv('dataSource').chart : {},
        heightAllotted = chartConf.canvasHeight,
        copyProperties = utils.copyProperties; // Set slicing distance. This parsing cannot be done in configure because
    // it needs canvasHeight, which is calculated after space management of chart

    copyProperties(chartAttr, datasetConf, [[_lib.BLANK, 'slicingDistance', _lib.pluckNumber, heightAllotted * 0.1], ['slicingdistance', 'slicingHeight', _lib.pluckNumber, '$slicingDistance', function () {
      if (datasetConf.slicingHeight > 2 * datasetConf.slicingDistance) {
        datasetConf.slicingDistance = 0;
      } else {
        datasetConf.slicingDistance = datasetConf.slicingHeight;
      }
    }]]);
  }
  /**
   * Checks whether input data is valid or not
   * @param {Object} data input data
   * @return {boolean} returns boolean value whether data is valid or not
   */
  ;

  _proto._checkValidData = function _checkValidData(data) {
    var datasetDefStore = this,
        chart = datasetDefStore.getFromEnv('chart');

    if (!(data && data.length)) {
      chart.setChartMessage();
      return false;
    }

    return true;
  }
  /**
   * Add legend items
   */
  ;

  _proto.addLegend = function addLegend() {
    var dataset = this,
        chart = dataset.getFromEnv('chart'),
        config,
        conf,
        tempId,
        legendItemIndex = 0,
        chartAttr = chart.getFromEnv('dataSource').chart,
        i,
        dataObj,
        data = dataset.getChildren('data') || dataset.config.JSONData.data,
        legend = chart.getFromEnv('legend'),
        legendItem = legend.getChildren('legendItem');

    for (i = 0; i < data.length; i++) {
      dataObj = data[i];
      conf = dataObj.config;

      if (dataObj.pseudoPoint || dataObj.getState('removed') || !dataObj.label && !dataObj.categoryLabel) {
        if (dataObj.pseudoPoint) {
          continue;
        }

        typeof (dataObj.categoryLabel !== 'undefined') && legendItemIndex++;

        if (conf.legendItemId) {
          legendItem = legend.getItem(conf.legendItemId);
          legendItem && legend.disposeItem(legendItem.getId());
          delete conf.legendItemId;
        }
      } else {
        config = {
          type: dataset.getName(),
          label: dataObj.label || dataObj.categoryLabel,
          index: legendItemIndex,
          enabled: (0, _lib.pluckNumber)(chartAttr.includeinlegend, 1),
          legendItemId: dataObj.legendItemId,
          usePattern: dataset.config.usePattern,
          legendIconAlpha: (0, _lib.pluckNumber)(data[i].legendiconalpha),
          patternAttr: dataObj.patternAttr
        };
        legendItem = legend.getItem(conf.legendItemId);

        if (!legendItem) {
          tempId = legend.createItem(dataset);
          dataObj.config.legendItemId = tempId;
          legendItem = legend.getItem(conf.legendItemId);
          legendItem.addEventListener('fc-click', legendItem.itemClickFn);
        }

        legendItem.configure(config); // count the number of legenditems

        legendItemIndex++;
        legendItem.setStateCosmetics('default', {
          symbol: {
            bgAlpha: (0, _lib.pluckNumber)(data[i].legendiconbgalpha, data[i].legendiconalpha, chartAttr.legendiconbgalpha, chartAttr.legendiconalpha, data[i].alpha),
            borderAlpha: (0, _lib.pluckNumber)(data[i].legendiconborderalpha, data[i].legendiconalpha, chartAttr.legendiconborderalpha, chartAttr.legendiconalpha, '100'),
            fill: data[i].legendColor,
            rawFillColor: data[i].rawColor,
            stroke: (0, _lib.getLightColor)(data[i].rawColor, 60).replace(dropHash, _lib.HASHSTRING)
          }
        });
      }
    }
  }
  /**
  *Handler for legend interaction
  * @param {Object} legendItem the clicked legend Item
  */
  ;

  _proto.legendInteractivity = function legendInteractivity(legendItem) {
    var plotItems = this.getChildren('data'),
        i,
        len,
        legendId = legendItem.getId();

    for (i = 0, len = plotItems.length; i < len; i++) {
      if (plotItems[i].config.legendItemId === legendId) {
        this.legendClick({
          datasetStore: this,
          plotItem: plotItems[i].plot
        }, true, false);
        break;
      }
    } // this.legendClick({datasetStore: this, plotItem: plotItem}, true, false);

  }
  /**
   * Normalize dataset
   * @param {Array} dataArr input data
   */
  ;

  _proto.getNormalizeDataSet = function getNormalizeDataSet(dataArr) {
    var datasetStore = this,
        dsStore = datasetStore.getChildren('data') || [],
        chart = datasetStore.getFromEnv('chart'),
        conf = datasetStore.config,
        smartLabel = datasetStore.getFromEnv('smartLabel'),
        Point = conf.pointInContext,
        index,
        dataObj,
        refreshedData,
        hasValidPoint,
        sumValue = 0,
        refreshedDataLength,
        chartAttr = chart.getFromEnv('dataSource').chart,
        defStyle,
        dataConnectorStyle = conf.dataConnectorStyle = {},
        colorIndexStart = chart.config.PLOT_COLOR_INDEX_START,
        res,
        counter = 0,
        point,
        notStreamlinedFunnel = 0;
    (0, _lib.extend2)(defStyle = conf.style = {}, chart.config.style);
    conf.noOFSlicedElement = 0;
    defStyle.borderDash = noneStr;
    defStyle.borderPadding = 2;
    defStyle.borderRadius = 0;
    defStyle.borderThickness = 1;
    defStyle.color = (0, _lib.convertColor)(conf.labelFontColor, conf.labelAlpha);
    defStyle.fontFamily = conf.baseFont;
    defStyle.fontSize = conf.baseFontSize + PXSTRING;
    defStyle.fontSizeWithUnit = conf.baseFontSize + PXSTRING;
    defStyle.fontStyle = NORMALSTRING;
    defStyle.fontWeight = NORMALSTRING;
    dataConnectorStyle.connectorWidth = conf.connectorWidth;
    dataConnectorStyle.connectorColor = conf.connectorColor;
    res = datasetStore.datasetCalculations(dataArr);
    hasValidPoint = res.hasValidPoint;
    refreshedData = res.refreshedData;
    sumValue = res.sumValue;
    notStreamlinedFunnel = +(!conf.streamLinedData && datasetStore.getName() === 'funnel');
    datasetStore._chartLevelAttr = _lib.parsexAxisStyles.apply(this, [{}, {}, chartAttr, defStyle]);

    if (hasValidPoint) {
      conf.sumValue = sumValue;
      refreshedDataLength = refreshedData.length;
      (0, _lib.componentFactory)(datasetStore, Point, 'data', refreshedDataLength + notStreamlinedFunnel);
      dsStore = datasetStore.getChildren('data');
      smartLabel.useEllipsesOnOverflow(chart.config.useEllipsesWhenOverflow);

      for (index = 0, counter = notStreamlinedFunnel; index < refreshedDataLength; index += 1, counter += 1) {
        dataObj = refreshedData[index];
        point = dsStore[counter];

        if (point.getState('removed')) {
          continue;
        }

        point.parseAndConfigurePoint(dataObj, res, colorIndexStart++, index);
      }
    }

    if (notStreamlinedFunnel && dsStore[0]) {
      dsStore[0].configure({
        displayValue: _lib.BLANK,
        y: conf.sumValue,
        index: 0
      });
    }
  }
  /**
   * Calculates data points and configures
   * @param {Array} dataArr input data
   * @return {Object} returns calculated object with configurations and data array
   */
  ;

  _proto.datasetCalculations = function datasetCalculations(dataArr) {
    var datasetStore = this,
        numberFormatter = datasetStore.getFromEnv('number-formatter'),
        index,
        length,
        dataObj,
        itemValue,
        res = {};
    res.refreshedData = [];
    res.sumValue = res.countPoint = 0;
    res.highestValue = Number.NEGATIVE_INFINITY;

    for (index = 0, length = dataArr.length; index < length; index++) {
      dataObj = dataArr[index];

      if (dataObj.vline) {
        // Funnel or pyramid does not use vline. Ignoring the same if user put it mistakenly.
        continue;
      }

      dataObj.cleanValue = itemValue = Math.abs(numberFormatter.getCleanValue(dataObj.value, true));

      if (itemValue !== null) {
        // If a valid value is provided in the configuration
        res.hasValidPoint = true;
        res.highestValue = res.highestValue || itemValue;
        res.refreshedData.push(dataObj);
        res.sumValue += itemValue;
        res.countPoint += 1;
        res.highestValue = Math.max(res.highestValue, res.itemValue);
      }
    }

    return res;
  }
  /**
   * Configure data point hover effects
   * @param {Object} dataObj data point object
   * @param {Object} pointCosmetics styles and cosmetics for particular data object
   * @return {Object} parsed styles and cosmetics
   */
  ;

  _proto.pointHoverOptions = function pointHoverOptions(dataObj, pointCosmetics) {
    var datasetStore = this,
        conf = datasetStore.config,
        chart = datasetStore.getFromEnv('chart'),
        hoverEffect = conf.usePattern ? 0 : (0, _lib.pluckNumber)(dataObj.showhovereffect, conf.showHoverEffect),
        hoverEffects = {
      enabled: hoverEffect
    },
        rolloverProperties = {},
        highlightColors,
        colorLen,
        index,
        chartAttr = chart.getFromEnv('dataSource') ? chart.getFromEnv('dataSource').chart : {}; // Detect whether any of the hover effect attributes are explicitly set or not
    // Enable hover effect when any of the hover attributes are explicitly set

    if (!hoverEffect && !conf.usePattern) {
      hoverEffect = hoverEffects.enabled = (0, _lib.pluck)(dataObj.hovercolor, chartAttr.plotfillhovercolor, dataObj.hoveralpha, chartAttr.plotfillhoveralpha, dataObj.borderhovercolor, chartAttr.plotborderhovercolor, dataObj.borderhoverthickness, chartAttr.plotborderhoverthickness, dataObj.borderhoveralpha, chartAttr.plotborderhoveralpha) !== UNDEF;
    }

    if (hoverEffect) {
      // Parse hover attributes
      hoverEffects.highlight = (0, _lib.pluckNumber)(dataObj.highlightonhover, chartAttr.highlightonhover);
      hoverEffects.color = (0, _lib.pluck)(dataObj.hovercolor, chartAttr.plotfillhovercolor);
      hoverEffects.alpha = (0, _lib.pluck)(dataObj.hoveralpha, chartAttr.plotfillhoveralpha, pointCosmetics.alpha);
      hoverEffects.borderColor = (0, _lib.pluck)(dataObj.borderhovercolor, chartAttr.plotborderhovercolor, pointCosmetics.borderColor);
      hoverEffects.borderThickness = (0, _lib.pluckNumber)(dataObj.borderhoverthickness, chartAttr.plotborderhoverthickness, pointCosmetics.borderWidth);
      hoverEffects.borderAlpha = (0, _lib.pluck)(dataObj.borderhoveralpha, chartAttr.plotborderhoveralpha, pointCosmetics.borderAlpha); // If hover effect is enabled but no hover color is provided, just highlight the default color

      if (hoverEffects.highlight !== 0 && hoverEffects.color === UNDEF) {
        hoverEffects.highlight = 1;
      }

      hoverEffects.color = (0, _lib.pluck)(hoverEffects.color, pointCosmetics.color).replace(/,+?$/, _lib.BLANK);

      if (hoverEffects.highlight === 1) {
        highlightColors = hoverEffects.color.split(/\s{0,},\s{0,}/);
        colorLen = highlightColors.length;

        for (index = 0; index < colorLen; index += 1) {
          highlightColors[index] = (0, _lib.getLightColor)(highlightColors[index], 70);
        }

        hoverEffects.color = highlightColors.join(',');
      }

      rolloverProperties = {
        color: hoverEffects.color,
        alpha: +hoverEffects.alpha,
        borderColor: (0, _lib.convertColor)(hoverEffects.borderColor, hoverEffects.borderAlpha),
        rawBorderColor: hoverEffects.borderColor,
        borderAlpha: hoverEffects.borderAlpha,
        borderWidth: hoverEffects.borderThickness
      };
    }

    return {
      enabled: hoverEffect,
      options: hoverEffects,
      rolloverOptions: rolloverProperties
    };
  }
  /**
   * Provides tooltip options
   * @param {Object} options congigurations of data points
   * @return {Object} returns tooltip options
   */
  ;

  _proto.getTooltipMacroStub = function getTooltipMacroStub(options) {
    return _getTooltipMacroStub.call(this, options);
  }
  /**
   * Called during post space management, does pre drawing calculations
  */
  ;

  _proto.allocatePosition = function allocatePosition() {
    var dataset = this,
        chart = dataset.getFromEnv('chart'),
        chartConfig = chart.config,
        dsConfig = dataset.config;
    chartConfig.style.fontSize = this.computeFontSize(chartConfig.style.fontSizeWithUnit);
    dsConfig.lineHeight = dsConfig.lineHeight === 0 ? 0 : parseInt(dataset._chartLevelAttr.lineHeight, 10);

    if (!dsConfig.showLabelsAtCenter && (dsConfig.labelSepChar === '<br>' || dsConfig.labelSepChar === '<br/>')) {
      dsConfig.lineHeight = dsConfig.lineHeight * 2;
    } // Checks and modify for streamLined data


    dataset._preDrawingHook();

    if (!dsConfig.sumValue) {
      return;
    }

    dsConfig.labelDrawingConfig = dsConfig.labelDrawingConfig || [];
    dsConfig.labelDrawingConfig.length = 0; // Store the marginTop and marginBottom before managing space

    dsConfig.psmMargin = {
      top: chartConfig.marginTop,
      bottom: chartConfig.marginBottom
    }; // Plot area management to decide the drawing area measurement

    dataset.preDrawingSpaceManagement();
  }
  /**
   * Calculates plot spaces before drawing
   */
  ;

  _proto.preDrawingSpaceManagement = function preDrawingSpaceManagement() {
    var datasetStore = this,
        chart = datasetStore.getFromEnv('chart'),
        chartConf = chart.config,
        caption = chart.getChildren('caption')[0],
        subCaption = chart.getChildren('subCaption')[0],
        capHeight = caption.config.height || 0,
        subCapHeight = subCaption.config.height || 0,
        conf = datasetStore.config,
        showTooltip = conf.showTooltip,
        slicingDistance = conf.slicingDistance,
        canvasHeight,
        canvasMaxWidth,
        chartWorkingHeight = chartConf.height - (chartConf.marginTop + chartConf.marginBottom),
        chartWorkingWidth = chartConf.width - (chartConf.marginRight + chartConf.marginLeft),
        dataArr = datasetStore.getChildren('data'),
        length,
        labelDistance,
        showLabelsAtCenter,
        blankSpace = conf.blankSpace,
        i = datasetStore.config.LABEL_PLACEMENT_ITERATOR_INDEX_START,
        upperRadiusFactor = datasetStore.getName() === 'funnel' ? 1 : 0,
        minWidthForChart,
        drawingWillExtend,
        maxWidthForLabel,
        labelMaxUsedWidth,
        hasPoint,
        maxValue,
        valueRadiusIncrementRatio,
        smartLabel = datasetStore.getFromEnv('smartLabel'),
        totalValue,
        point,
        lineHeight,
        smartTextObj,
        chartDrawingWidth,
        currentValue,
        ratioK,
        currentDiameter,
        labelMaxWidth,
        extraSpace,
        newDiameter = 0,
        lowestRadiusFactor,
        labelMaxW = 0,
        tempSnap,
        labelOverlappingW,
        utils = datasetStore.utils(datasetStore),
        gutter = 5,
        snapOffset,
        invokeHookFns = utils.invokeHookFns,
        labelStyle,
        prePointProcessingHookFn = datasetStore.prePointProcessingHookFn,
        legend = chart.getFromEnv('legend'),
        legendPos = chartConf.showLegend && legend && legend.config && legend.config.legendPos ? legend.config.legendPos.split('-') : [],
        legendWidth = 0;

    if (chartConf.showLegend && (legendPos[0] === 'right' || legendPos[0] === 'left')) {
      legendWidth = legend.config.width + 2 * gutter;
    }

    chartConf.oriCanvasLeft = chart.config.canvasLeft;
    chartConf.oriBottomSpace = chart.config.marginBottom;
    chartConf.oriTopSpace = chart.config.marginTop; // outCanvasSpace += chart.config.canvasRight;
    // For Anotation macros store temp conf

    tempSnap = conf._tempSnap = {
      top3DSpace: 0,
      bottom3DSpace: 0,
      topLabelSpace: 0,
      rightLabelSpace: 0
    };
    canvasHeight = chartWorkingHeight - slicingDistance;
    canvasMaxWidth = Math.min(2 * canvasHeight, chartWorkingWidth);
    chartConf.marginTop += slicingDistance / 2;
    chartConf.marginBottom += slicingDistance / 2; // Find the label maximun width

    length = datasetStore.getDataLength();
    labelDistance = conf.origLabelDistance + blankSpace;
    showLabelsAtCenter = conf.showLabelsAtCenter;
    minWidthForChart = Math.min(canvasMaxWidth, chartWorkingWidth * 0.3);
    drawingWillExtend = chartWorkingWidth - minWidthForChart;
    chartWorkingWidth -= legendWidth;
    maxWidthForLabel = chartWorkingWidth / 2 - minWidthForChart / 2 - labelDistance - chartConf.marginLeft;
    labelMaxUsedWidth = 0;
    hasPoint = dataArr[0];
    maxValue = hasPoint && dataArr[0].y ? dataArr[0].y : 1;
    valueRadiusIncrementRatio = 0.8 / maxValue; // conf.useSameSlantAngle = 1;

    invokeHookFns(prePointProcessingHookFn, [dataArr]);
    totalValue = conf.totalValue || 0;
    smartLabel.useEllipsesOnOverflow(chartConf.useEllipsesWhenOverflow);

    for (; i < length; i += 1) {
      point = dataArr[i];

      if (point.legendItemId) {
        legend.configureItems && legend.configureItems(point.legendItemId, {
          configuration: {
            fillColor: point.legendColor
          }
        });
      }

      labelStyle = point.style;
      (0, _lib.setLineHeight)(labelStyle);
      lineHeight = (0, _lib.pluckNumber)(mathCeil(parseFloat(labelStyle.lineHeight) + labelStyle.borderPadding + labelStyle.borderThickness + gutter), 10);
      smartLabel.setStyle(labelStyle);
      currentValue = point.y;

      if (showLabelsAtCenter) {
        smartTextObj = smartLabel.getSmartText(point.origValue, chartWorkingWidth, lineHeight);
      } else {
        currentValue = point.getModifiedCurrentValue && point.getModifiedCurrentValue(totalValue) || currentValue;
        ratioK = point.getRatioK(datasetStore, currentValue, valueRadiusIncrementRatio, totalValue, maxValue);
        currentDiameter = minWidthForChart * ratioK;
        labelMaxWidth = maxWidthForLabel + (minWidthForChart - currentDiameter) / 2;

        if (conf.labelSepChar === '<br>' || conf.labelSepChar === '<br/>') {
          lineHeight = lineHeight * 2;
        }

        smartTextObj = smartLabel.getSmartText(point.origValue, labelMaxWidth, lineHeight);
        point.displayValue = smartTextObj.text;
        showTooltip && smartTextObj.tooltext && (point.originalText = smartTextObj.tooltext);
        labelMaxUsedWidth = Math.max(labelMaxUsedWidth, smartTextObj.width);

        if (drawingWillExtend > 0) {
          if (smartTextObj.width > 0) {
            extraSpace = labelMaxWidth - smartTextObj.width;
          } else {
            extraSpace = labelMaxWidth + labelDistance;
          }

          newDiameter = 1 / (ratioK + 1) * (currentDiameter + 2 * extraSpace + minWidthForChart);
          drawingWillExtend = Math.min(drawingWillExtend, newDiameter - minWidthForChart);
        }

        totalValue += conf.offsetVal === UNDEF ? point.y : typeof conf.offsetVal === 'function' ? conf.offsetVal(i) : conf.offsetVal;
      }
    }

    if (chartConf.showLegend && (legendPos[0] === 'right' || legendPos[0] === 'left')) {
      chart.isLegendRight = true;
      chartConf.marginRight += legendWidth; // outCanvasSpace += legendWidth;
    } else {
      chart.isLegendRight = false;
    }

    if (point) {
      lowestRadiusFactor = point.getLowestRadiusFactor(datasetStore, maxValue);
    }

    chartDrawingWidth = minWidthForChart + drawingWillExtend;

    if (chartDrawingWidth > canvasMaxWidth) {
      chartDrawingWidth = canvasMaxWidth;
    }

    totalValue = conf.offsetVal === UNDEF ? 0 : typeof conf.offsetVal === 'function' ? conf.offsetVal() : conf.offsetVal; // Now we have the actual drawing width for the
    // funnel and pyramid reiterate through the data and find the
    // max label width

    if (!showLabelsAtCenter) {
      i = datasetStore.config.LABEL_PLACEMENT_ITERATOR_INDEX_START;

      for (length = datasetStore.getDataLength(); i < length; i += 1) {
        point = dataArr[i];
        currentValue = point.y;
        currentValue = point.getModifiedCurrentValue && point.getModifiedCurrentValue(totalValue) || currentValue;
        ratioK = point.getRatioK(datasetStore, currentValue, valueRadiusIncrementRatio, totalValue, maxValue);
        currentDiameter = chartDrawingWidth * ratioK;
        labelMaxWidth = maxWidthForLabel + (minWidthForChart - currentDiameter) / 2 - legendWidth;
        smartTextObj = smartLabel.getSmartText(point.displayValue, labelMaxWidth, lineHeight);
        labelMaxW = mathMax(labelMaxW, currentDiameter * 0.5 + smartTextObj.width + labelDistance);
        totalValue += conf.offsetVal === UNDEF ? point.y : typeof conf.offsetVal === 'function' ? conf.offsetVal() : conf.offsetVal;
      }
    }

    if (labelMaxUsedWidth > 0) {
      tempSnap.rightLabelSpace = chartWorkingWidth - chartDrawingWidth; // Keep the chart at center and find extra space required to place the label

      labelOverlappingW = labelMaxW - chartConf.canvasWidth * 0.5;

      if (labelOverlappingW > 0) {
        // Adjust the extra space required to place the label
        chartConf.marginRight += labelOverlappingW;
        chartConf.marginLeft -= labelOverlappingW;
      }

      chartConf.marginRight += tempSnap.rightLabelSpace * 0.5;
      chartConf.marginLeft += tempSnap.rightLabelSpace * 0.5;
    } else {
      labelDistance = 0;
    }

    conf.labelDistance = conf.connectorWidth = labelDistance;

    if ((showLabelsAtCenter || !labelMaxUsedWidth) && canvasMaxWidth < chartWorkingWidth) {
      chartConf.marginLeft += (chartWorkingWidth - canvasMaxWidth - labelDistance) * 0.5;
      chartConf.marginRight += (chartWorkingWidth - canvasMaxWidth - labelDistance) * 0.5;
    }

    if (!conf.is2d) {
      chartConf.marginTop += tempSnap.top3DSpace = chartDrawingWidth * conf.yScale * upperRadiusFactor / 2;
      chartConf.marginBottom += tempSnap.bottom3DSpace = chartDrawingWidth * conf.yScale * lowestRadiusFactor / 2;
    }

    datasetStore.calculatePositionOfPlots();
    snapOffset = capHeight + subCapHeight + gutter;

    if (datasetStore.getName() === 'funnel') {
      if (conf.streamLinedData && dataArr.length < 2) {
        chartConf.gaugeStartX = chartConf.marginLeft;
        chartConf.gaugeStartY = chartConf.marginTop + snapOffset;
        chartConf.gaugeEndX = chartDrawingWidth + chartConf.marginLeft;
        chartConf.gaugeEndY = chartConf.canvasHeight + chartConf.marginTop;
      } else {
        chartConf.gaugeStartX = dataArr[0].plotX - dataArr[1].shapeArgs.R1;
        chartConf.gaugeEndX = dataArr[0].plotX + dataArr[1].shapeArgs.R1;
        chartConf.gaugeStartY = dataArr[0].plotY;
        chartConf.gaugeEndY = dataArr[length - 1].plotY;
      }
    } else {
      chartConf.gaugeStartX = dataArr[length - 1].plotX - dataArr[length - 1].shapeArgs.R2;
      chartConf.gaugeEndX = dataArr[length - 1].plotX + dataArr[length - 1].shapeArgs.R2;
      chartConf.gaugeStartY = dataArr[0].shapeArgs.y;
      chartConf.gaugeEndY = dataArr[length - 1].shapeArgs.y + dataArr[length - 1].shapeArgs.h;
    }

    chartConf.gaugeCenterX = chartConf.canvasCenterX = (chartConf.gaugeStartX + chartConf.gaugeEndX) / 2;
    chartConf.gaugeCenterY = (chartConf.gaugeStartY + chartConf.gaugeEndY) / 2;
    chartConf.plotSemiWidth = (chartConf.canvasWidth - tempSnap.rightLabelSpace) / 2;
  }
  /**
   * Animate plot elements
   * @param {Array} elements plot elements
   * @param {string} subElem type of elements
   * @param {Array} subElemKeys type of elements
   * @param {Object} conditions element attributes to be set for preanimation and postanimation
   * @param {Function} callback animation callback function
   */
  ;

  _proto.animateElements = function animateElements(elements, subElem, subElemKeys, conditions
  /* , callback */
  ) {
    if (subElemKeys === void 0) {
      subElemKeys = [];
    }

    var datasetStore = this,
        // chart = datasetStore.getFromEnv('chart'),
    // animDuration = animationObj.duration,
    // dummyAnimElem = animationObj.dummyObj,
    // dummyAnimObj = animationObj.animObj,
    // isPromiseExecuted = false,
    target,
        index,
        length,
        ele,
        i,
        l;
    /**
     * Promise function
     * @return {undefined} return if already callback executed
     */
    // function promise () {
    //   if (isPromiseExecuted) {
    //     return;
    //   }
    //   callback();
    //   isPromiseExecuted = true;
    // }

    /**
     * Animate plots
     * @param {Object} _t plot element
     * @param {Object} point data object
     */

    function animate(_t, point) {
      var ialpha = (point || {}).alpha;
      ialpha = ialpha === UNDEF ? conditions.post : {
        opacity: ialpha
      };

      if (!_t) {
        return;
      } // _t.attr(conditions.pre);
      // _t.attr(ialpha);


      datasetStore.getFromEnv('animationManager').setAnimation({
        el: _t,
        attr: ialpha,
        component: datasetStore
      }); // _t.animateWith(dummyAnimElem, dummyAnimObj, ialpha, animDuration, animType, promise);
    } // callback = callback || stubFN;


    for (index = 0, length = elements.length; index < length; index++) {
      ele = elements[index];

      if (!ele) {
        continue;
      }

      if (!subElemKeys.length) {
        target = ele;
        animate(target[subElem], ele.point);
      } else {
        for (i = 0, l = subElemKeys.length; i < l; i++) {
          target = elements[index][subElem][subElemKeys[i]];
          animate(target, ele.point);
        }
      }
    }
  }
  /**
   * Draws all labels
   */
  ;

  _proto.drawAllLabels = function drawAllLabels() {
    var datasetStore = this,
        chart = datasetStore.getFromEnv('chart'),
        labelDrawingConfigArr = datasetStore.config.labelDrawingConfig,
        dataLabelsGroup = chart.getChildContainer('datalabelsGroup'),
        removeCSSProps = ['fontFamily', 'fontSize', 'fontWeight', 'fontStyle'],
        groupLabelCssProps = removeCSSProps,
        groupLabelCss = {},
        labelDrawingConfig,
        point,
        index,
        length,
        attr; // Extract the required css from the list of css (guard for IE)

    for (index = 0, length = groupLabelCssProps.length; index < length; index++) {
      attr = groupLabelCssProps[index];

      if (attr in datasetStore._chartLevelAttr) {
        groupLabelCss[attr] = datasetStore._chartLevelAttr[attr];
      }
    }

    dataLabelsGroup.css(groupLabelCss);

    for (index = labelDrawingConfigArr.length - 1; index > -1; index--) {
      labelDrawingConfig = labelDrawingConfigArr[index];

      if (labelDrawingConfig.css) {
        labelDrawingConfig.css.fontSize = this.computeFontSize(labelDrawingConfig.css.fontSizeWithUnit);
      }

      point = labelDrawingConfig.point;
      point.index = index;
      point.drawLabel();
    }
  }
  /**
   * Draws all trackers
   */
  ;

  _proto.drawAllTrackers = function drawAllTrackers() {
    var datasetStore = this,
        trackerArgs = datasetStore.config.trackerArgs,
        index,
        point,
        length;

    for (index = 0, length = trackerArgs.length; index < length; index++) {
      point = trackerArgs[index];
      point.drawTracker();
    }
  }
  /**
   * Calculates the data plot coordinates
   * @param {Array} dataArr data points
   * @param {boolean} placeOtherSide whether to put on left side or right side
   */
  ;

  _proto.calculatePositionCoordinate = function calculatePositionCoordinate(dataArr, placeOtherSide) {
    var datasetStore = this,
        conf = datasetStore.config,
        maxValue = conf.maxValue,
        is2d = conf.is2d,
        x = conf.x,
        chart = datasetStore.getFromEnv('chart'),
        chartConfig = chart.config,
        y = chartConfig.canvasTop,
        unitHeight = conf.unitHeight,
        drawingRadius = conf.drawingRadius,
        labelDistance = conf.labelDistance,
        showLabelsAtCenter = conf.showLabelsAtCenter,
        isHollow = conf.isHollow,
        fontSize = chartConfig.style.fontSize,
        yShift = fontSize * 0.3,
        yScale = conf.yScale,
        blankSpace = conf.blankSpace,
        lastRadius = conf.lastRadius,
        smartLabel = datasetStore.getFromEnv('smartLabel'),
        index,
        length,
        totalHeight = 0,
        point,
        sliceHeight,
        lastIndex = datasetStore.getDataLength() - 1,
        alignmentSwitchToggle = false,
        distributionOffset = 0,
        labelMeasurement,
        newRadius,
        negativeSpanningDataEnd,
        normalizedLabel,
        lineHeight = conf.lineHeight,
        widthHeightRatio = 0.8 / chartConfig.effCanvasHeight,
        chartWidth = chart.config.width - 2,
        streamlinedData = conf.streamLinedData,
        // Base of the  maximum trimmed label.
    trimmedInfo = {
      flag: false,
      point: UNDEF,
      sLabel: UNDEF,
      setAll: function setAll(flag, pt, sLabel) {
        this.flag = flag;
        this.point = pt;
        this.sLabel = sLabel;
      }
    },
        // Base of the maximum spanned labels
    largestLabel = {
      point: UNDEF,
      sLabel: UNDEF,
      set: function set(calcFn, predicate) {
        var _calcFn = calcFn,
            _predicate = predicate;
        return function (pt, sLabel) {
          var existingLabelSpan, currentLabelSpan;

          if (pt.dontPlot) {
            return;
          }

          if (!(this.point && this.sLabel)) {
            this.point = pt;
            this.sLabel = sLabel;
            return;
          }

          existingLabelSpan = _calcFn(this.point, this.sLabel);
          currentLabelSpan = _calcFn(pt, sLabel);

          if (_predicate(existingLabelSpan, currentLabelSpan)) {
            this.point = pt;
            this.sLabel = sLabel;
          }
        };
      }
    },
        leftTrimmedInfo = {},
        rightTrimmedInfo = {},
        lLargestLabel = {},
        rLargestLabel = {},
        extraConnectorSpace,
        xPos,
        slicingGapPosition = conf.slicingGapPosition = {};
    (0, _lib.extend2)(leftTrimmedInfo, trimmedInfo);
    (0, _lib.extend2)(rightTrimmedInfo, trimmedInfo);

    leftTrimmedInfo.setAll = function (flag, pt, sLabel) {
      var _point = this.point,
          _sLabel = this.sLabel,
          existingLabelSpan,
          currentLabelSpan;
      this.flag = flag;

      if (!(_point && _sLabel)) {
        this.point = pt;
        this.sLabel = sLabel;
        return;
      }

      existingLabelSpan = _point.labelX - (_sLabel.oriTextWidth - _sLabel.width);
      currentLabelSpan = pt.labelX - (sLabel.oriTextWidth - sLabel.width);

      if (existingLabelSpan > currentLabelSpan) {
        this.point = pt;
        this.sLabel = sLabel;
      }
    }; // Override the base class method for labels which are kept right


    rightTrimmedInfo.setAll = function (flag, pt, sLabel) {
      var _point = this.point,
          _sLabel = this.sLabel,
          existingLabelSpan,
          currentLabelSpan;
      this.flag = flag;

      if (!(_point && _sLabel)) {
        this.point = pt;
        this.sLabel = sLabel;
        return;
      }

      existingLabelSpan = _point.labelX + _sLabel.oriTextWidth;
      currentLabelSpan = pt.labelX + sLabel.oriTextWidth;

      if (existingLabelSpan < currentLabelSpan) {
        this.point = pt;
        this.sLabel = sLabel;
      }
    };

    (0, _lib.extend2)(lLargestLabel, largestLabel);
    (0, _lib.extend2)(rLargestLabel, largestLabel);

    lLargestLabel.set = function () {
      return largestLabel.set.apply(lLargestLabel, [function (pt) {
        return pt.labelX;
      }, function (existingLabelSpan, currentLabelSpan) {
        return existingLabelSpan > currentLabelSpan;
      }]);
    }();

    rLargestLabel.set = function () {
      return largestLabel.set.apply(rLargestLabel, [function (pt, sLabel) {
        return pt.labelX + sLabel.oriTextWidth;
      }, function (existingLabelSpan, currentLabelSpan) {
        return existingLabelSpan < currentLabelSpan;
      }]);
    }();

    conf.noOfGap = 0;
    smartLabel.useEllipsesOnOverflow(chartConfig.useEllipsesWhenOverflow);

    for (index = 0, length = dataArr.length; index < length; index++) {
      point = dataArr[index];

      if (!point) {
        continue;
      }

      point.x = index;

      if (point.plot) {
        // @todo correct the slicing here
        point.isSliced = !!point.isSliced || !!conf.isSliced;
      }

      point.isSliced = (0, _lib.pluckNumber)(point.isSliced, conf.isSliced);

      if (index) {
        placeOtherSide && (alignmentSwitchToggle = !alignmentSwitchToggle); // code for slicing drawing

        if (point.isSliced) {
          xPos = point.x;

          if (xPos > 1 && !slicingGapPosition[xPos]) {
            slicingGapPosition[xPos] = true;
            conf.noOfGap += 1;
          }

          if (xPos < lastIndex) {
            slicingGapPosition[xPos + 1] = true;
            conf.noOfGap += 1;
          }
        }

        if (!streamlinedData) {
          totalHeight += sliceHeight = unitHeight * dataArr[index].y;
          newRadius = drawingRadius * (1 - totalHeight * widthHeightRatio);
        } else {
          if (conf.useSameSlantAngle === 1) {
            newRadius = maxValue ? drawingRadius * point.y / maxValue : drawingRadius;
          } else {
            newRadius = maxValue ? drawingRadius * mathSqrt(point.y / maxValue) : drawingRadius;
          } // Default sliceHeight is set to one, in case its NaN.


          sliceHeight = unitHeight * (dataArr[index - 1].y - point.y) || 1;
        }

        point.shapeArgs = {
          x: x,
          y: y,
          R1: lastRadius,
          R2: newRadius,
          h: sliceHeight || 1,
          r3dFactor: yScale,
          isHollow: isHollow,
          gStr: 'point',
          is2D: is2d,
          renderer: chart.getFromEnv('paper'),
          isFunnel: true
        };
        smartLabel.setStyle(point.style);
        point.oriText = point.displayValue;
        labelMeasurement = labelMeasurement = smartLabel.getSmartText(point.displayValue, Number.POSITIVE_INFINITY, Number.POSITIVE_INFINITY);

        if (showLabelsAtCenter) {
          point.labelAline = POSITION_MIDDLE;
          point.labelX = x;
          point.labelY = (is2d ? y : y + yScale * lastRadius) + sliceHeight / 2 + yShift;

          if (point.shapeArgs.h < point.minplotheightforvalue) {
            point.showValue = 0;
          } else {
            point.showValue = 1;
          }
        } else {
          point.labelAline = POSITION_START;
          point.alignmentSwitch = alignmentSwitchToggle;
          point.distributionFactor = point.distributionFactor || 0;

          if (alignmentSwitchToggle) {
            point.labelX = x - (labelDistance + newRadius + blankSpace + labelMeasurement.width);
            point.labelX -= point.distributionFactor * conf.globalMinXShift;
            lLargestLabel.set(point, labelMeasurement);
          } else {
            point.labelX = x + labelDistance + newRadius + blankSpace;
            point.labelX += point.distributionFactor * conf.globalMinXShift;
            rLargestLabel.set(point, labelMeasurement);
          }

          distributionOffset = point.distributionFactor * lineHeight;
          point.labelY = y + yShift + sliceHeight + distributionOffset;
        } // Checking text overflow for alternate alignment


        if (placeOtherSide) {
          if (alignmentSwitchToggle && point.labelX < 0) {
            // Left and behind the margin
            negativeSpanningDataEnd = point.labelX + labelMeasurement.width;
            normalizedLabel = smartLabel.getSmartText(point.displayValue, negativeSpanningDataEnd, Number.POSITIVE_INFINITY, true);
            point.labelX = 2;
            point.isLabelTruncated = true;
            point.displayValue = normalizedLabel.text;
            point.virtualWidth = normalizedLabel.maxWidth;
            leftTrimmedInfo.setAll(true, point, normalizedLabel);
          } else if (!alignmentSwitchToggle && point.labelX + labelMeasurement.width > chartWidth) {
            // Right side and spanning the margin
            normalizedLabel = smartLabel.getSmartText(point.displayValue, chartWidth - point.labelX, Number.POSITIVE_INFINITY, true);
            point.isLabelTruncated = true;
            point.displayValue = normalizedLabel.text;
            point.virtualWidth = normalizedLabel.maxWidth;
            rightTrimmedInfo.setAll(true, point, normalizedLabel);
          }
        }

        point.pWidth = point.virtualWidth = labelMeasurement.width;
        y += sliceHeight;
        lastRadius = newRadius;
      } else {
        point.oriText = point.displayValue;

        if (conf.useSameSlantAngle === 1) {
          newRadius = maxValue ? drawingRadius * point.y / maxValue : drawingRadius;
        } else {
          newRadius = maxValue ? drawingRadius * mathSqrt(point.y / maxValue) : drawingRadius;
        }

        if (point.labelWidth > newRadius * 2 && !placeOtherSide) {
          point.labelAline = POSITION_START;
          point.labelX = conf.x - point.labelWidth / 2;
        } else {
          point.labelAline = POSITION_MIDDLE;
          point.labelX = x;
        }

        extraConnectorSpace = labelDistance * 2;
        point.displayValue = smartLabel.getSmartText(point.origValue, newRadius * 2 + extraConnectorSpace, Number.POSITIVE_INFINITY, true).text;
        point.labelY = (is2d ? y : y - yScale * lastRadius) - yShift - blankSpace;
      }

      point.plotX = x;
      point.plotY = y;
    } // Recalculate the space one more time. Ideally this should be given by space manager.
    // However in the current scope space manager cannot be called from here.


    datasetStore.findBestPosition(dataArr, {
      'lTrimmedInfo': leftTrimmedInfo,
      'rTrimmedInfo': rightTrimmedInfo,
      'lLargestLabel': lLargestLabel,
      'rLargestLabel': rLargestLabel
    });
  }
  /**
   * Calculates optimum position for labels
   * @param {Array} dataArr data array
   * @param {Object} config data point configuration
   */
  ;

  _proto.findBestPosition = function findBestPosition(dataArr, config) {
    var datasetStore = this,
        conf = datasetStore.config,
        chart = datasetStore.getFromEnv('chart'),
        chartConfig = chart.config,
        shift = 0,
        lTrimmedInfo = config.lTrimmedInfo,
        rTrimmedInfo = config.rTrimmedInfo,
        lLargestLabel = config.lLargestLabel,
        rLargestLabel = config.rLargestLabel,
        smartLabel = datasetStore.getFromEnv('smartLabel'),
        trimmedLength,
        sLabel,
        leftXSpace,
        rightXSpace,
        newLabel,
        data,
        index,
        length,
        unfoldWidth = 0,
        overflow,
        streamLinedData = conf.streamLinedData,
        allowedLeftX = conf.blankSpace,
        allowedRightX = chartConfig.width - conf.blankSpace;

    if (lTrimmedInfo.flag && rTrimmedInfo.flag) {
      // If labels are large in both of the sides. No need to shift the system
      return;
    }

    if (rTrimmedInfo.flag) {
      // Only right side labels are large. Shift left
      if (!lLargestLabel.point) {
        return;
      } // point = rTrimmedInfo.point;


      sLabel = rTrimmedInfo.sLabel;
      trimmedLength = sLabel.oriTextWidth - sLabel.width;
      leftXSpace = lLargestLabel.point.labelX - allowedLeftX;
      shift = -Math.ceil(Math.min(trimmedLength, leftXSpace));
    } else if (lTrimmedInfo.flag) {
      // Only left side labels are large. Shift right
      if (!rLargestLabel.point) {
        return;
      } // point = lTrimmedInfo.point;


      sLabel = lTrimmedInfo.sLabel;
      trimmedLength = sLabel.oriTextWidth - sLabel.width;
      rightXSpace = allowedRightX - (rLargestLabel.point.labelX + rLargestLabel.sLabel.width);
      shift = Math.ceil(Math.min(trimmedLength, rightXSpace));
    } // Apply shift to the whole system


    if (!shift) {
      smartLabel.useEllipsesOnOverflow(chartConfig.useEllipsesWhenOverflow);

      for (index = 0, length = dataArr.length; index < length; index++) {
        data = dataArr[index];

        if ((overflow = data.labelX + data.pWidth - allowedRightX) > 0) {
          data.lOverflow = overflow;
          data.labelX -= overflow;

          if (chart.isLegendRight) {
            data.displayValue = smartLabel.getSmartText(data.oriText, data.pWidth - overflow, Number.POSITIVE_INFINITY, true).text;
          } else {
            data.lOverflow = overflow;
            data.labelX -= overflow;
          }
        }
      }

      return;
    }

    for (index = 0, length = dataArr.length; index < length; index++) {
      data = dataArr[index];

      if (!index && streamLinedData) {
        data.labelX += shift;
        continue;
      }

      if (data.alignmentSwitch) {
        // left labels
        if (shift < 0) {
          newLabel = smartLabel.getSmartText(data.oriText, data.pWidth, Number.POSITIVE_INFINITY, true);
        } else {
          newLabel = smartLabel.getSmartText(data.oriText, data.pWidth + shift, Number.POSITIVE_INFINITY, true);
        }

        if (data.isLabelTruncated) {
          unfoldWidth = newLabel.width - data.pWidth;
        }

        data.virtualWidth = newLabel.width;
      } else {
        // Labels at right
        if (shift > 0) {
          newLabel = smartLabel.getSmartText(data.oriText, data.pWidth, Number.POSITIVE_INFINITY, true);
        } else {
          newLabel = smartLabel.getSmartText(data.oriText, data.pWidth - shift, Number.POSITIVE_INFINITY, true);
        }

        data.virtualWidth = newLabel.width;
      }

      data.displayValue = newLabel.text;
      data.labelX += shift - unfoldWidth;
      data.shapeArgs && (data.shapeArgs.x += shift);
      unfoldWidth = 0;
    }
  }
  /**
   * Returns data plot
   * @param {number} id data plot id
   * @return {Object} data plot
   */
  ;

  _proto.getPlotData = function getPlotData(id) {
    var datasetStore = this,
        data = datasetStore.getChildren('data')[id],
        userData = datasetStore.userData || (datasetStore.userData = []),
        props = ['y', 'name', 'color', 'alpha', 'borderColor', 'borderWidth', 'link', 'label', 'displayValue', 'datasetIndex', 'toolText'],
        plotData,
        i,
        prop;

    if (!userData[id]) {
      plotData = userData[id] = {};

      for (i = 0; i < props.length; i++) {
        plotData[prop = props[i]] = data[prop];
      }

      plotData.value = plotData.y;
      plotData.label = plotData.name;
      delete plotData.y;
      delete plotData.name;
    } else {
      plotData = userData[id];
    }

    return plotData;
  } // eslint-disable-next-line no-unused-vars

  /**
   * Slice data plots on interaction
   */
  ;

  _proto.slice = function slice() {
    var context = this,
        datasetStore = context.datasetStore,
        dataItem = context.plotItem,
        index = dataItem.index,
        data = datasetStore.getChildren('data'),
        point = data[index],
        graphicalElement = point.getGraphicalElement(),
        chart = datasetStore.getFromEnv('chart'),
        animationManager = datasetStore.getFromEnv('animationManager'),
        conf = datasetStore.config,
        sliced = arguments[3] || conf.clicked,
        slicingDistance = conf.slicingDistance,
        seriesOptionsHalf = slicingDistance / 2,
        i = 0,
        noOFPrevPoint = 0,
        length = data.length,
        transformObj,
        dataObj,
        reflowData = [],
        itemClicked,
        clickedItemId,
        dyPrev,
        dyNext,
        dyOld,
        dyNew,
        graphic,
        dataLabel,
        slicingEnd;

    if (conf.sliceLock) {
      return;
    } // Flag that informs whether slicing is on-going


    conf.sliceLock = 1;
    sliced = dataItem.sliced = defined(sliced) ? sliced : !dataItem.sliced;
    dyPrev = -seriesOptionsHalf;
    dyNext = seriesOptionsHalf;

    slicingEnd = function slicingEnd() {
      return function () {
        conf.sliceLock = 0;
        /**
                     * SlicingEnd event is usually associated with a pie chart.
                     * In pie charts, on click a certain entity of the pie, the clicked slice is shown distinctly.
                     * The slicing start event is triggered as soon as the particular entity
                     * is clicked when the slicing is finished,
                     * the slicingEnd event is triggered.
                     * @event FusionCharts#slicingEnd
                     * @param {boolean} slicedState Indicates whether the data is sliced or not.
                     * @param {string} data The plot data from the chart to slice.
                     */

        chart.fireChartInstanceEvent('SlicingEnd', {
          slicedState: sliced,
          data: datasetStore.getPlotData(clickedItemId)
        });
      };
    };

    for (i = 0; i < length; i += 1) {
      dataObj = data[i].plot;

      if (!dataObj || data[i].getState('removed')) {
        continue;
      }

      graphicalElement = data[i].getGraphicalElement();

      if (dataObj !== dataItem) {
        data[i].isSliced = 0;
        dataObj.sliced = false;
        reflowData[i] = {
          isSliced: false
        };
        itemClicked = false;
      } else {
        data[i].isSliced = +!data[i].isSliced;
        reflowData[i] = {
          isSliced: sliced
        };
        itemClicked = true;
        clickedItemId = i;
      }

      if (graphicalElement.graphic) {
        dyOld = dataObj.dy;
        dyNew = -dyOld;

        if (sliced) {
          if (dataObj.x < dataItem.x) {
            dyNew += dyPrev;
            noOFPrevPoint += 1;
          } else if (dataObj.x === dataItem.x) {
            if (!noOFPrevPoint) {
              dyNew += -seriesOptionsHalf * 0.5;
            } else if (i === length - 1) {
              dyNew += seriesOptionsHalf * 0.5;
            }
          } else {
            dyNew += dyNext;
          }
        } // The plot should be sent to ending y position, before invoking
        // next slicing movement, as in the case of rapid slicing interactions.


        graphicalElement.graphic.attr({
          transform: 't0,' + dataObj.dy
        });
        dataObj.dy += dyNew;
        transformObj = {
          transform: '...t0,' + dyNew
        }; // dataItem.distanceAvailed = dyNew;

        /**
                     * SlicingStart event is usually associated with a pie chart.
                     * In pie charts, on click a certain entity of the pie, the clicked slice is shown distinctly.
                     * The slicing start event is triggered as soon as the particular entity is clicked.
                     * @event FusionCharts#slicingStart
                     * @param {boolean} slicedState Indicates whether the data is sliced or not.
                     * @param {string} data The plot data from the chart to slice.
                     */

        itemClicked && chart.fireChartInstanceEvent('SlicingStart', {
          slicedState: !sliced,
          data: datasetStore.getPlotData(clickedItemId)
        }); // dataObj.graphic.animateWith(dummyAnimElem, dummyAnimObj, transformObj, animDuration, animType,
        //                 itemClicked && slicingEnd(sliced, clickedItemId));

        animationManager.setAnimation({
          el: graphicalElement.graphic,
          attr: transformObj,
          component: datasetStore,
          callback: itemClicked && slicingEnd(sliced, clickedItemId)
        }); // for labels at center translate the labels

        if (graphicalElement.dataLabel) {
          // dataObj.dataLabel.animateWith(dummyAnimElem, dummyAnimObj, transformObj, animDuration,
          //                   animType);
          animationManager.setAnimation({
            el: graphicalElement.dataLabel,
            attr: transformObj,
            component: datasetStore
          });
        }

        if (graphicalElement.connector) {
          // dataObj.connector.animateWith(dummyAnimElem, dummyAnimObj, transformObj, animDuration,
          //                   animType);
          animationManager.setAnimation({
            el: graphicalElement.connector,
            attr: transformObj,
            component: datasetStore
          });
        } // for tracker translate it


        if (graphicalElement.trackerObj) {
          // dataObj.trackerObj.animateWith(dummyAnimElem, dummyAnimObj, transformObj, animDuration,
          //                   animType);
          animationManager.setAnimation({
            el: graphicalElement.trackerObj,
            attr: transformObj,
            component: datasetStore
          });
        } // For Funnel streamlinedData, the top label should move with top funnel,
        // characterised by no graphic but with label for the plot. Topmost funnel
        // is not the topmost plot here.


        graphic = data[0].getGraphicalElement('graphic');
        dataLabel = data[0].getGraphicalElement('dataLabel');

        if (i === 1 && !graphic && dataLabel) {
          // data[0].dataLabel.animateWith(dummyAnimElem, dummyAnimObj, transformObj, animDuration,
          //                   animType);
          animationManager.setAnimation({
            el: dataLabel,
            attr: transformObj,
            component: datasetStore
          });
        }
      }
    } // After first click delete state


    delete conf.clicked;
  }
  /**
   * Handles legend interactivity
   * @param {Object} plotItem plot object
   */
  ;

  _proto.legendClick = function legendClick(plotItem) {
    this.slice.call(plotItem);
  }
  /**
   * Fetch event arguements of legendItems
   * @param {Object} legendItem legend item object of particular data
   * @return {Object} event arguements
   */
  ;

  _proto.getEventArgs = function getEventArgs(legendItem) {
    var dataset = this,
        dataStore = dataset.getChildren('data'),
        configuration = legendItem.config,
        index = configuration.index,
        dataObj = dataStore[index] || {},
        eventArgs;
    eventArgs = {
      alpha: dataObj.alpha,
      value: dataObj.y,
      color: dataObj.color,
      borderColor: dataObj.borderColor,
      borderWidth: dataObj.borderWidth,
      link: dataObj.link,
      displayValue: dataObj.displayValue,
      datasetIndex: dataObj.datasetIndex,
      toolText: dataObj.toolText,
      label: dataObj.categoryLabel
    };
    return eventArgs;
  }
  /**
   * Handler for plot click
   *
   * @param {any} data data
   * @memberof FunnelPyramidBaseDataset
   */
  ;

  _proto.plotMouseUp = function plotMouseUp(data) {
    var context = this,
        plotItem = context.plotItem,
        dataset = context.datasetStore,
        dataStore = dataset.getChildren('data'),
        funnelPoint = dataStore[plotItem.index],
        chart = dataset.getFromEnv('chart'),
        tracker = funnelPoint.getGraphicalElement('trackerObj');
    tracker.data(EVENTARGS, Object.assign(tracker.data(EVENTARGS), {
      isSliced: funnelPoint.isSliced
    }));
    chart.plotEventHandler(tracker, data, 'dataplotclick');
  };

  return FunnelPyramidBaseDataset;
}(_componentInterface.ComponentInterface);

var _default = FunnelPyramidBaseDataset;
exports["default"] = _default;

/***/ }),

/***/ 1506:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



exports.__esModule = true;
exports["default"] = void 0;

var _dependencyManager = __webpack_require__(282);

var _lib = __webpack_require__(274);

var fadeEffect = [{
  initialAttr: function initialAttr() {
    return {
      opacity: 0
    };
  },
  finalAttr: function finalAttr() {
    return {
      opacity: 1
    };
  }
}],
    COMMASTRING = ',';
var _default = {
  'initial.dataset.angularGauge': function initialDatasetAngularGauge() {
    var component = this,
        conf = component.config,
        R = (0, _dependencyManager.getDep)('redraphael', 'plugin'),
        deg2rad = Math.PI / 180,
        cx = R.vml ? -1.5 : 0,
        // correction of -1.5 has to be added for VML.
    cy = R.vml ? -1.5 : 0;
    return {
      'dialPath.appearing': function dialPathAppearing() {
        var attr,
            rotation,
            startAngle = conf.gaugeStartAngle;
        rotation = startAngle / deg2rad;
        attr = {
          transform: 'R' + rotation + COMMASTRING + cx + COMMASTRING + cy
        };
        return [{
          initialAttr: {
            opacity: 0
          },
          finalAttr: {
            opacity: 1
          },
          slot: 'initial'
        }, {
          initialAttr: attr,
          finalAttr: {
            opacity: 1
          },
          slot: 'middle'
        }];
      },
      'dialPath.updating': null,
      'text.appearing': function textAppearing() {
        fadeEffect[0].slot = _lib.FINALSTR;
        return fadeEffect;
      },
      'text.updating': null,
      'pivot.appearing': function pivotAppearing() {
        fadeEffect[0].slot = _lib.INITIALSTR;
        return fadeEffect;
      },
      'pivot.updating': null,
      'plotBackground.appearing': function plotBackgroundAppearing() {
        fadeEffect[0].slot = _lib.INITIALSTR;
        return fadeEffect;
      },
      'plotBackground.updating': null
    };
  }
};
exports["default"] = _default;

/***/ }),

/***/ 1503:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _lib = __webpack_require__(274);

var _hlineargauge = _interopRequireDefault(__webpack_require__(1504));

var _dependencyManager = __webpack_require__(282);

var _index = _interopRequireDefault(__webpack_require__(1506));

var _redraphaelShapes = _interopRequireDefault(__webpack_require__(390));

var _redraphaelShapes2 = _interopRequireDefault(__webpack_require__(1507));

/* eslint require-jsdoc: 'error', valid-jsdoc: ["error", { "requireReturn": false }] */
var R = (0, _dependencyManager.getDep)('redraphael', 'plugin'),
    math = Math,
    mathAbs = math.abs,
    mathATan2 = math.atan2,
    mathPI = math.PI,
    math2PI = 2 * mathPI,
    mathMax = math.max,
    BLANKSTRING = '',
    PXSTRING = 'px',
    NORMALSTRING = 'normal',
    deg2rad = mathPI / 180,
    UNDEF,
    FILLMIXDARK10 = '{dark-10}',
    M = 'M',
    L = 'L',
    Z = 'Z',
    GAUGE_FILTER_RATIO = ',6',
    ANGLE = 'angle',
    animationObjStr = 'animationObj',
    configStr = 'config',
    POINTER = 'pointer',
    EVENTARGS = 'eventArgs',
    doc = window.document,
    hasTouch = doc.documentElement.ontouchstart !== UNDEF,
    ANIM_EFFECT = 'linear',
    getTouchEvent = function getTouchEvent(event) {
  return hasTouch && event.sourceEvent && event.sourceEvent.touches && event.sourceEvent.touches[0] || event;
},
    isString = function isString(s) {
  return typeof s === 'string';
},
    defined = function defined(obj) {
  return obj !== UNDEF && obj !== null;
},
    getAttrFunction = function getAttrFunction() {
  var rotationStr = ANGLE;
  return function (_hash, val, animation) {
    var key,
        value,
        element = this,
        attr3D = this._Attr,
        cx = R.vml ? -1.5 : 0,
        // correction of -1.5 has to be added for VML.
    cy = R.vml ? -1.5 : 0,
        red,
        hash = _hash;

    if (!attr3D) {
      attr3D = element._Attr = {};
    } // single key-value pair


    if (isString(hash) && defined(val)) {
      key = hash;
      hash = {};
      hash[key] = val;
    } // used as a getter: first argument is a string, second is undefined
    // And also if first argument is undefined it should return the all attrs object.


    if (isString(hash) || hash === UNDEF) {
      // if belongs from the list then handle here
      if (hash === rotationStr) {
        element = element._Attr[hash];
      } else {
        // else leve for the original attr
        element = element._attr(hash);
      } // setter

    } else {
      for (key in hash) {
        value = hash[key]; // if belongs from the list then handle here

        if (key === rotationStr) {
          attr3D[key] = value;
          red = value * deg2rad;
          attr3D.tooltipPos[0] = attr3D.cx + attr3D.toolTipRadius * Math.cos(red);
          attr3D.tooltipPos[1] = attr3D.cy + attr3D.toolTipRadius * Math.sin(red);
          attr3D.prevValue = value;

          if (animation && animation.duration) {
            element.animate({
              transform: 'R' + value + _lib.COMMASTRING + cx + _lib.COMMASTRING + cy
            }, animation.duration, ANIM_EFFECT);
          } else {
            element.attr({
              transform: 'R' + value + _lib.COMMASTRING + cx + _lib.COMMASTRING + cy
            });
          }
        } else {
          // else leave for the original attr
          element._attr(key, value);
        }
      }
    }

    return element;
  };
};

(0, _dependencyManager.addDep)({
  name: 'angularAnimation',
  type: 'animationRule',
  extension: _index.default
}); // Adding required shapes for chart.

(0, _redraphaelShapes.default)(R);
(0, _redraphaelShapes2.default)(R);
/**
 * Creates dataset class for Angular Gauge
 */

var AngularGaugeDataset = /*#__PURE__*/function (_HlineargaugeDataset) {
  (0, _inheritsLoose2.default)(AngularGaugeDataset, _HlineargaugeDataset);

  /**
   * Constructor function to initialise attributes of AngularGaugeDataset object
   */
  function AngularGaugeDataset() {
    var _this;

    _this = _HlineargaugeDataset.call(this) || this;
    _this.components = _this.components || {};
    _this.config.idMap = {};
    return _this;
  }
  /**
   * Sets the type of the component
   * @return {string} type
   */


  var _proto = AngularGaugeDataset.prototype;

  _proto.getType = function getType() {
    return 'dataset';
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */
  ;

  _proto.getName = function getName() {
    return 'angularGauge';
  }
  /**
   * Configure dataset component and parse default values
   * @param  {Object} pointerArrArg JSON for dataset configurations
   * @return {boolean} Indicates whether the configuration was successful or not
   */
  ;

  _proto.configure = function configure(pointerArrArg) {
    if (!pointerArrArg) {
      return false;
    }

    this.trimData(pointerArrArg);
    this.config.pointerArr = pointerArrArg;
    var dataSet = this,
        chart = dataSet.getFromEnv('chart'),
        chartConfig = chart.config,
        jsonData = chart.getFromEnv('dataSource'),
        chartAttrs = jsonData.chart,
        pointer = jsonData.pointers || jsonData.dials,
        pointerArr = pointer.pointer || pointer.dial || [],
        data = dataSet.components.data || (dataSet.components.data = []),
        scale = dataSet.getFromEnv('scale'),
        colorM = dataSet.getFromEnv('color-manager'),
        datasetConfig = dataSet.config || (dataSet.config = {}),
        scaleAngle = (0, _lib.pluckNumber)(chartAttrs.gaugescaleangle, 180),
        startAngle = (0, _lib.pluckNumber)(chartAttrs.gaugestartangle),
        endAngle = (0, _lib.pluckNumber)(chartAttrs.gaugeendangle),
        startDefined = defined(startAngle),
        tempAngle,
        // arc on 360deg is not possable SVG limitation so reduce the scale
    circleHandler = _lib.hasSVG ? 0.001 : 0.01,
        endDefined = defined(endAngle),
        showGaugeBorder,
        pvColor,
        scaleOnResize,
        showValue,
        pointShowValue,
        valueY,
        dataLabelsStyle,
        fontBdrColor,
        i,
        config,
        ln;
    chartConfig.displayValueCount = 0;

    for (i = 0, ln = pointerArr.length; i < ln; i += 1) {
      data[i] = data[i] || (data[i] = {});
      config = data[i].config || (data[i].config = {});
      config.basewidth = pointerArr[i].basewidth;
      config.color = pointerArr[i].color;
      config.alpha = pointerArr[i].alpha;
      config.bgcolor = pointerArr[i].bgcolor;
      config.borderalpha = pointerArr[i].borderalpha;
      config.bordercolor = pointerArr[i].bordercolor;
      config.borderthickness = pointerArr[i].borderthickness;
      config.editmode = pointerArr[i].editmode;
      config.id = (0, _lib.pluck)(pointerArr[i].id, 'dial' + i);
      config.link = pointerArr[i].link;
      config.radius = pointerArr[i].radius;
      config.rearextension = pointerArr[i].rearextension;
      config.showvalue = pointerArr[i].showvalue;
      config.tooltext = pointerArr[i].tooltext;
      config.topwidth = pointerArr[i].topwidth;
      config.value = pointerArr[i].value;
      config.valuex = pointerArr[i].valuex;
      config.valuey = pointerArr[i].valuey;
      config.baseradius = pointerArr[i].baseradius;
      config.displayvalue = pointerArr[i].displayvalue;
      showValue = datasetConfig.showValue = (0, _lib.pluckNumber)(chartAttrs.showvalue, chartAttrs.showrealtimevalue, 0);
      pointShowValue = (0, _lib.pluckNumber)(config.showvalue, showValue);
      config.showPointerValue = pointShowValue;
      valueY = (0, _lib.pluckNumber)((0, _lib.getValidValue)(config.valuey));

      if (pointShowValue && !defined(valueY)) {
        chartConfig.displayValueCount += 1;
      }
    }
    /*
             *All angle should be in range of -360 to 360 of traditional methode
             *At the end convert them in computer graphics methode
             * relation among them is [scaleAngle = startAngle - endAngle;]
             */


    if (scaleAngle > 360 || scaleAngle < -360) {
      scaleAngle = scaleAngle > 0 ? 360 : -360;
    }

    if (endAngle > 360 || endAngle < -360) {
      endAngle = endAngle % 360;
    }

    if (startAngle > 360 || startAngle < -360) {
      startAngle = startAngle % 360;
    } // booth defined


    if (startDefined && endDefined) {
      // override the scale
      scaleAngle = startAngle - endAngle; // validate scale and EndAngle

      if (scaleAngle > 360 || scaleAngle < -360) {
        scaleAngle = scaleAngle % 360;
        endAngle = startAngle - scaleAngle;
      }
    } else if (startDefined) {
      // StartAngle Defined
      // derive endAngle
      endAngle = startAngle - scaleAngle; // if derived end angle cross the limit

      if (endAngle > 360 || endAngle < -360) {
        endAngle = endAngle % 360;
        startAngle += endAngle > 0 ? -360 : 360;
      }
    } else if (endDefined) {
      // endAngle Defined
      // derive StartAngle
      startAngle = endAngle + scaleAngle; // if derived start angle cross the limit

      if (startAngle > 360 || startAngle < -360) {
        startAngle = startAngle % 360;
        endAngle += startAngle > 0 ? -360 : 360;
      }
    } else {
      // booth will be derived
      if (scaleAngle === 360) {
        startAngle = 180;
        endAngle = -180;
      } else if (scaleAngle === -360) {
        startAngle = -180;
        endAngle = -180;
      } else {
        tempAngle = scaleAngle / 2;
        startAngle = 90 + tempAngle;
        endAngle = startAngle - scaleAngle;
      }
    } // Full 360 can't be drawn by arc[limitation]


    if (Math.abs(scaleAngle) === 360) {
      scaleAngle += scaleAngle > 0 ? -circleHandler : circleHandler;
      endAngle = startAngle - scaleAngle;
    } // convert all the angles into clockwise cordinate


    endAngle = 360 - endAngle;
    startAngle = 360 - startAngle;
    scaleAngle = -scaleAngle; // if start angle cross the limit

    if (startAngle > 360 || endAngle > 360) {
      startAngle -= 360;
      endAngle -= 360;
    } // convert into red


    datasetConfig.gaugeStartAngle = startAngle = startAngle * deg2rad;
    datasetConfig.gaugeEndAngle = endAngle = endAngle * deg2rad;
    datasetConfig.gaugeScaleAngle = scaleAngle = scaleAngle * deg2rad;
    datasetConfig.upperLimit = (0, _lib.pluckNumber)(chartAttrs.upperlimit);
    datasetConfig.lowerLimit = (0, _lib.pluckNumber)(chartAttrs.lowerlimit); // set axis configure

    scale.setAxisConfig({
      startAngle: startAngle,
      totalAngle: -scaleAngle
    });
    scaleOnResize = (0, _lib.pluckNumber)(chartAttrs.scaleonresize, 1);
    datasetConfig.origW = (0, _lib.pluckNumber)(chartAttrs.origw, scaleOnResize ? chart.config.origRenderWidth : chartConfig.width);
    datasetConfig.origH = (0, _lib.pluckNumber)(chartAttrs.origh, scaleOnResize ? chart.config.origRenderHeight : chartConfig.height);
    chartConfig.showtooltip = (0, _lib.pluckNumber)(chartAttrs.showtooltip, 1); // Whether to auto-scale itself with respect to previous size

    chartConfig.autoScale = (0, _lib.pluckNumber)(chartAttrs.autoscale, 1);
    datasetConfig.rearExtension = (0, _lib.pluckNumber)(pointer.rearextension, 0);
    datasetConfig.gaugeinnerradius = chartAttrs.gaugeinnerradius; // gaugeOuterRadius does not have any default value.

    datasetConfig.valueBelowPivot = (0, _lib.pluckNumber)(chartAttrs.valuebelowpivot, 0);
    datasetConfig.showShadow = (0, _lib.pluckNumber)(chartAttrs.showshadow, 1);
    showGaugeBorder = (0, _lib.pluckNumber)(chartAttrs.showgaugeborder, 1);
    datasetConfig.gaugeFillMix = (0, _lib.getFirstDefinedValue)(chartAttrs.colorrangefillmix, chartAttrs.gaugefillmix, chart.colorRangeFillMix, '{light-10},{light-70},{dark-10}');
    datasetConfig.gaugeFillRatio = (0, _lib.getFirstDefinedValue)(chartAttrs.colorrangefillratio, chartAttrs.gaugefillratio, chart.colorRangeFillRatio, chartAttrs.gaugefillratio);

    if (datasetConfig.gaugeFillRatio === UNDEF) {
      datasetConfig.gaugeFillRatio = GAUGE_FILTER_RATIO;
    } else if (datasetConfig.gaugeFillRatio !== _lib.BLANK) {
      // Append a comma before the ratio
      datasetConfig.gaugeFillRatio = _lib.COMMASTRING + datasetConfig.gaugeFillRatio;
    }

    datasetConfig.gaugeBorderColor = (0, _lib.pluck)(chartAttrs.gaugebordercolor, '{dark-20}');
    datasetConfig.gaugeBorderThickness = showGaugeBorder ? (0, _lib.pluckNumber)(chartAttrs.gaugeborderthickness, 1) : 0;
    datasetConfig.gaugeBorderAlpha = (0, _lib.pluckNumber)(chartAttrs.gaugeborderalpha, 100); // Gauge Border properties
    // Parse the color, alpha and ratio array for each color range arc.

    pvColor = colorM.parseColorMix((0, _lib.pluck)(chartAttrs.pivotfillcolor, chartAttrs.pivotcolor, chartAttrs.pivotbgcolor, colorM.getColor('pivotColor')), (0, _lib.pluck)(chartAttrs.pivotfillmix, '{light-10},{light-30},{dark-20}'));
    datasetConfig.pivotFillAlpha = colorM.parseAlphaList((0, _lib.pluck)(chartAttrs.pivotfillalpha, _lib.HUNDREDSTRING), pvColor.length);
    datasetConfig.pivotFillRatio = colorM.parseRatioList((0, _lib.pluck)(chartAttrs.pivotfillratio, _lib.ZEROSTRING), pvColor.length);
    datasetConfig.pivotFillColor = pvColor.join();
    datasetConfig.pivotFillAngle = (0, _lib.pluckNumber)(chartAttrs.pivotfillangle, 0);
    datasetConfig.isRadialGradient = (0, _lib.pluck)(chartAttrs.pivotfilltype, 'radial').toLowerCase() === 'radial'; // Pivot border properties

    datasetConfig.showPivotBorder = (0, _lib.pluckNumber)(chartAttrs.showpivotborder, 0);
    datasetConfig.pivotBorderThickness = (0, _lib.pluckNumber)(chartAttrs.pivotborderthickness, 1);
    datasetConfig.pivotBorderColor = (0, _lib.convertColor)((0, _lib.pluck)(chartAttrs.pivotbordercolor, colorM.getColor('pivotBorderColor')), datasetConfig.showPivotBorder === 1 ? (0, _lib.pluck)(chartAttrs.pivotborderalpha, _lib.HUNDREDSTRING) : _lib.ZEROSTRING);
    chartConfig.dataLabels = chartConfig.dataLabels || {};
    fontBdrColor = (0, _lib.getFirstValue)(chartAttrs.valuebordercolor, BLANKSTRING);
    fontBdrColor = fontBdrColor ? (0, _lib.convertColor)(fontBdrColor, (0, _lib.pluckNumber)(chartAttrs.valueborderalpha, chartAttrs.valuealpha, 100)) : BLANKSTRING;
    dataLabelsStyle = chartConfig.dataLabels.style = {
      fontFamily: (0, _lib.pluck)(chartAttrs.valuefont, chartConfig.style.inCanfontFamily),
      fontSize: (0, _lib.pluck)(this.computeFontSize(chartAttrs.valuefontsize), parseInt(chartConfig.style.inCanfontSize, 10)) + PXSTRING,
      fontSizeWithUnit: (0, _lib.pluckFontSizeMaintainUnit)(chartAttrs.valuefontsize, chartConfig.style.inCanfontSizeWithUnit),
      color: (0, _lib.convertColor)((0, _lib.pluck)(chartAttrs.valuefontcolor, chartConfig.style.inCancolor), (0, _lib.pluckNumber)(chartAttrs.valuefontalpha, chartAttrs.valuealpha, 100)),
      fontWeight: (0, _lib.pluckNumber)(chartAttrs.valuefontbold) ? 'bold' : NORMALSTRING,
      fontStyle: (0, _lib.pluckNumber)(chartAttrs.valuefontitalic) ? 'italic' : NORMALSTRING,
      border: fontBdrColor || chartAttrs.valuebgcolor ? (0, _lib.pluckNumber)(chartAttrs.valueborderthickness, 1) + 'px solid' : UNDEF,
      borderColor: fontBdrColor,
      borderThickness: (0, _lib.pluckNumber)(chartAttrs.valueborderthickness, 1),
      borderPadding: (0, _lib.pluckNumber)(chartAttrs.valueborderpadding, 2),
      borderRadius: (0, _lib.pluckNumber)(chartAttrs.valueborderradius, 0),
      backgroundColor: chartAttrs.valuebgcolor ? (0, _lib.convertColor)(chartAttrs.valuebgcolor, (0, _lib.pluckNumber)(chartAttrs.valuebgalpha, chartAttrs.valuealpha, 100)) : BLANKSTRING,
      borderDash: (0, _lib.pluckNumber)(chartAttrs.valueborderdashed, 0) ? (0, _lib.getDashStyle)((0, _lib.pluckNumber)(chartAttrs.valueborderdashlen, 4), (0, _lib.pluckNumber)(chartAttrs.valueborderdashgap, 2)) : _lib.BLANK
    };
    (0, _lib.setLineHeight)(dataLabelsStyle);
  }
  /**
   * Trim extra previous data on update
   * @param {Object} pointers JSON input data
   */
  ;

  _proto.trimData = function trimData(pointers) {
    var dataSet = this,
        prevPointers,
        currPointers;
    prevPointers = dataSet.components.data && dataSet.components.data.length;
    currPointers = pointers.dial && pointers.dial.length || 0;

    if (prevPointers > currPointers) {
      dataSet.removeData(prevPointers - currPointers);
    }
  }
  /**
   * Draws background graphics
   */
  ;

  _proto._drawBackground = function _drawBackground() {
    var dataSet = this,
        chart = dataSet.getFromEnv('chart'),
        canvas = chart.getChildren('canvas')[0],
        dsConfig = dataSet.config,
        scale = dataSet.getFromEnv('scale'),
        colorM = dataSet.getFromEnv('color-manager'),
        scaleRange = scale.config.axisRange,
        colorRangeGetter = dataSet.getFromEnv('colorRange'),
        plotContainer = chart.getChildContainer('plotGroup'),
        shadowContainer = chart.getChildContainer('defaultShadowGroup'),
        dataLabelContainer = chart.getChildContainer('datalabelsGroup'),
        animationManager = dataSet.getFromEnv('animationManager'),
        gaugeOuterRadius = dsConfig.gaugeOuterRadius,
        gaugeInnerRadius = dsConfig.gaugeInnerRadius,
        gaugeFillRatio = dsConfig.gaugeFillRatio,
        gaugeBorderColor = dsConfig.gaugeBorderColor,
        gaugeBorderThickness = dsConfig.gaugeBorderThickness,
        gaugeBorderAlpha = dsConfig.gaugeBorderAlpha,
        gaugeFillMix = dsConfig.gaugeFillMix,
        x = dsConfig.gaugeOriginX,
        y = dsConfig.gaugeOriginY,
        startAngle = dsConfig.gaugeStartAngle,
        showShadow = dsConfig.showShadow,
        minValue = scaleRange.min,
        maxValue = scaleRange.max,
        colorRange = colorRangeGetter ? colorRangeGetter.getColorRangeArr(minValue, maxValue) : [],
        i = 0,
        ln = colorRange.length,
        colorObj,
        currentEndAngle,
        lastAngle = startAngle,
        nextAngle,
        crColor,
        crAlpha,
        crRatio,
        shadowAlpha,
        borderColor,
        borderAlpha,
        fcColorObj,
        bandGroupDummy = dataSet.getContainer('bandGroup'),
        bandGroup,
        pointGroupDummy = dataSet.getContainer('pointGroup'),
        pointGroup,
        pivotElem,
        pivotElemDummy,
        bandElemDummy,
        bandElem,
        count = 0,
        hideFn = function hideFn() {
      this.hide();
    },
        showFn = function showFn() {
      this.show();
    }; // create/reuse bandgroup element


    bandGroup = animationManager.setAnimation({
      el: bandGroupDummy || 'group',
      attr: {
        name: 'bandGroup'
      },
      container: plotContainer,
      component: dataSet,
      label: 'group'
    });

    if (!bandGroupDummy) {
      bandGroup = dataSet.addContainer('bandGroup', bandGroup);
    } // create/reuse pointGroup element


    pointGroup = animationManager.setAnimation({
      el: pointGroupDummy || 'group',
      attr: {
        name: 'pointGroup',
        transform: 't' + x + _lib.COMMASTRING + y
      },
      container: dataLabelContainer,
      component: dataSet,
      label: 'group'
    });

    if (!pointGroupDummy) {
      dataSet.addContainer('pointGroup', pointGroup);
    } // draw all color Bands


    for (; i < ln; i += 1) {
      colorObj = colorRange[i];
      currentEndAngle = scale.getAngle(Math.min(colorObj.maxvalue, maxValue)); // Parse the color, alpha and ratio array for each color range arc.

      crColor = colorM.parseColorMix(colorObj.code, gaugeFillMix);
      crAlpha = colorM.parseAlphaList(colorObj.alpha, crColor.length);
      crRatio = colorM.parseRatioList(gaugeInnerRadius / gaugeOuterRadius * 100 + gaugeFillRatio, crColor.length);
      borderColor = colorObj.bordercolor;
      borderAlpha = (0, _lib.pluckNumber)(colorObj.borderAlpha, gaugeBorderAlpha); // Set border propeties
      // Which border color to use - between actual color and color mix specified?

      if (borderColor && borderColor.indexOf('{') === -1) {
        borderColor = (0, _lib.convertColor)(borderColor, borderAlpha);
      } else {
        borderColor = colorM.parseColorMix(colorObj.code, (0, _lib.pluck)(borderColor, gaugeBorderColor))[0];
      }

      borderColor = (0, _lib.convertColor)(borderColor, borderAlpha); // create the shadow element

      shadowAlpha = crAlpha.split(_lib.COMMASTRING);
      shadowAlpha = mathMax.apply(Math, shadowAlpha);
      shadowAlpha = showShadow ? mathMax(borderAlpha || 0, shadowAlpha) : 0; // If start angle > end angle then swap the two for intended
      // behavior.

      nextAngle = currentEndAngle;

      if (lastAngle > currentEndAngle) {
        lastAngle += currentEndAngle;
        currentEndAngle = lastAngle - currentEndAngle;
        lastAngle = lastAngle - currentEndAngle;
      }

      colorObj._startAngle = lastAngle;
      colorObj._endAngle = currentEndAngle;
      bandElemDummy = canvas.getGraphicalElement('bands') && canvas.getGraphicalElement('bands')[i]; // Create/reuse bandElements

      bandElem = animationManager.setAnimation({
        el: bandElemDummy || 'ringpath',
        attr: {
          ringpath: [x, y, gaugeOuterRadius, gaugeInnerRadius, lastAngle, currentEndAngle],
          fill: (0, _lib.toRaphaelColor)({
            FCcolor: {
              cx: x,
              cy: y,
              r: gaugeOuterRadius,
              gradientUnits: 'userSpaceOnUse',
              color: crColor.join(),
              alpha: crAlpha,
              ratio: crRatio,
              radialGradient: true
            }
          }),
          'stroke-width': gaugeBorderThickness,
          stroke: borderColor
        },
        container: bandGroup,
        callback: showFn,
        component: dataSet,
        label: 'plotBackground'
      });

      if (!bandElemDummy) {
        canvas.addGraphicalElement('bands', bandElem, true);
        bandElem.shadow({
          apply: showShadow,
          opacity: shadowAlpha / 100
        });
      }

      lastAngle = nextAngle;
      count += 1;
    }

    ln = canvas.getGraphicalElement('bands') && canvas.getGraphicalElement('bands').length; // Hide extra band elements

    for (i = count; i < ln; i++) {
      colorObj = colorRange[i] || dsConfig.oldColorArr[i];
      colorObj && animationManager.setAnimation({
        el: canvas.getGraphicalElement('bands')[i],
        attr: {
          ringpath: [x, y, gaugeOuterRadius, gaugeInnerRadius, colorObj._startAngle, colorObj._startAngle]
        },
        component: dataSet,
        callback: hideFn,
        label: 'plotBackground'
      });
    } // Store the old color array to be used for disappearing animation


    dsConfig.oldColorArr = colorRange;
    fcColorObj = dsConfig.isRadialGradient ? {
      color: dsConfig.pivotFillColor,
      alpha: dsConfig.pivotFillAlpha,
      ratio: dsConfig.pivotFillRatio,
      radialGradient: true,
      angle: dsConfig.pivotFillAngle,
      cx: 0.5,
      cy: 0.5,
      r: '50%'
    } : {
      color: dsConfig.pivotFillColor,
      alpha: dsConfig.pivotFillAlpha,
      ratio: dsConfig.pivotFillRatio,
      radialGradient: false,
      angle: dsConfig.pivotFillAngle
    };
    pivotElemDummy = dataSet.getGraphicalElement('pivot'); // Now draw the pivot

    pivotElem = animationManager.setAnimation({
      el: pivotElemDummy || 'circle',
      attr: {
        cx: x,
        cy: y,
        r: dsConfig.pivotRadius,
        fill: (0, _lib.toRaphaelColor)({
          FCcolor: fcColorObj
        }),
        'stroke-width': dsConfig.pivotBorderThickness,
        stroke: dsConfig.pivotBorderColor
      },
      container: dataLabelContainer,
      component: dataSet,
      label: 'pivot'
    });

    if (!pivotElemDummy) {
      pivotElem = dataSet.addGraphicalElement('pivot', pivotElem);
      pivotElem.shadow({
        apply: showShadow
      }, shadowContainer);
    }
  }
  /**
   * Alters the data of the dataset and stores the data to be removed in a different array
   * @param {number} numbers number of data to be removed
   */
  ;

  _proto.removeData = function removeData(numbers) {
    var dataSet = this,
        i,
        animationManager = dataSet.getFromEnv('animationManager'),
        callBackFn = function callBackFn() {
      this.remove();
    },
        data = dataSet.components.data;

    for (i = 0; i < numbers; i++) {
      data[i].graphics.pointersPath && animationManager.setAnimation({
        el: data[i].graphics.pointersPath,
        attr: {
          opacity: 0
        },
        callback: callBackFn,
        component: dataSet
      });
      data[i].graphics.pointersTpath && animationManager.setAnimation({
        el: data[i].graphics.pointersTpath,
        attr: {
          opacity: 0
        },
        callback: callBackFn,
        component: dataSet
      });
      data[i].graphics.dataLabel && animationManager.setAnimation({
        el: data[i].graphics.dataLabel,
        attr: {
          opacity: 0
        },
        callback: callBackFn,
        component: dataSet
      });
    }

    dataSet.removeDataArr || (dataSet.removeDataArr = []);
    dataSet.removeDataArr = dataSet.removeDataArr.concat(data.splice(0, numbers));
  }
  /**
   * Draw plot graphics
   * @param {boolean} animation determines whether to animate plot(dial) or not
   */
  ;

  _proto.draw = function draw(animation) {
    this._drawBackground();

    var dataSet = this,
        chart = dataSet.getFromEnv('chart'),
        toolTipController = dataSet.getFromEnv('toolTipController'),
        idMap = dataSet.config.idMap,
        chartConfig = chart.config,
        jsonData = chart.getFromEnv('dataSource'),
        chartAttrs = jsonData.chart,
        data = dataSet.components.data,
        datasetConfig = dataSet.config,
        renderer = datasetConfig,
        NumberFormatter = dataSet.getFromEnv('number-formatter'),
        colorM = dataSet.getFromEnv('color-manager'),
        scale = dataSet.getFromEnv('scale'),
        animationManager = dataSet.getFromEnv('animationManager'),
        x = Number(datasetConfig.gaugeOriginX),
        y = Number(datasetConfig.gaugeOriginY),
        startAngle = datasetConfig.gaugeStartAngle,
        endAngle = datasetConfig.gaugeEndAngle,
        shouldShowShadow = datasetConfig.showShadow,
        showTooltip = chartConfig.showtooltip,
        // (options.tooltip.enabled !== false),
    scaleRange = scale.config.axisRange,
        minValue = scaleRange.min,
        maxValue = scaleRange.max,
        pGroup = dataSet.getContainer('pointGroup'),
        dataLabelsGroup = dataSet.getLinkedParent().getChildContainer('datalabelsGroup'),
        valueRange = maxValue - minValue || 1,
        angleRange = endAngle - startAngle,
        angleValueFactor = valueRange / angleRange,
        editMode,
        plottooltext = chartAttrs.plottooltext,
        showHoverEffect = (0, _lib.pluckNumber)(chartAttrs.showhovereffect),
        showValue = dataSet.showValue = (0, _lib.pluckNumber)(chartAttrs.showvalue, chartAttrs.showrealtimevalue, 0),
        i = 0,
        style = chartConfig.dataLabels.style,
        css = {
      fontFamily: style.fontFamily,
      fontSize: this.computeFontSize(style.fontSizeWithUnit),
      lineHeight: style.lineHeight,
      fontWeight: style.fontWeight,
      fontStyle: style.fontStyle
    },
        scaleFactor = chartConfig.scaleFactor,
        lineHeight = (0, _lib.pluckNumber)(parseInt(style.lineHeight, 10), 12),
        isBelow = datasetConfig.valueBelowPivot,
        labelCounter = 0,
        hasHoverSizeChange,
        hoverFill,
        hoverAttr,
        outAttr,
        point,
        radius,
        baseWidth,
        topWidth,
        baseRadius,
        rearExtension,
        baseWidthHF,
        topWidthHF,
        ln = data && data.length,
        rotation,
        graphic,
        prevData,
        stubEvent = {
      pageX: 0,
      pageY: 0
    },
        attrFN = getAttrFunction(startAngle, endAngle),
        chartPosition,
        getClickArcTangent = function getClickArcTangent(xCoord, yCoord, center, ref) {
      return mathATan2(yCoord - center[1] - ref.top, xCoord - center[0] - ref.left);
    },
        dialDragStart = function dialDragStart(e) {
      var pt = data[this.pos],
          pointConfig = pt.config || {},
          startX = e.data[0],
          startY = e.data[1];

      if (!pointConfig.editMode) {
        return;
      } // For update previous value is retaining due to closure


      x = Number(datasetConfig.gaugeOriginX);
      y = Number(datasetConfig.gaugeOriginY);
      chartPosition = (0, _lib.getPosition)(chart.getFromEnv('chart-container')); // Record the angle of point of drag start with respect
      // to starting angle.

      chartConfig.rotationStartAngle = getClickArcTangent(startX, startY, [x, y], chartPosition);
      pointConfig.dragStartY = pointConfig.value;
      prevData = chart._getDataJSON();
    },
        dialDragEnd = function dialDragEnd() {
      var pt = data[this.pos],
          config = pt.config,
          chartObj = chart.getFromEnv('chartInstance'),
          jsVars;

      if (!pt.config.editMode) {
        return;
      }

      jsVars = chartObj && chartObj.jsVars;
      jsVars && (jsVars._rtLastUpdatedData = chart._getDataJSON());
      chart.fireChartInstanceEvent('RealTimeUpdateComplete', {
        data: '&value=' + config.updatedValStr,
        updateObject: {
          values: [config.updatedValStr]
        },
        prevData: prevData.values,
        source: 'editMode',
        url: null
      });

      try {
        window.FC_ChartUpdated && window.FC_ChartUpdated(chartObj.id);
      } catch (err) {
        setTimeout(function () {
          throw err;
        }, 1);
      }
    },
        dialDragHandler = function dialDragHandler(event) {
      var pt = data[this.pos],
          touchEvent = hasTouch && getTouchEvent(event) || stubEvent,
          newAngle,
          angleDelta,
          angleDelta2,
          newVal,
          newVal2,
          values,
          scaleRang = scale.config.axisRange,
          startX = event.data[2],
          startY = event.data[3],
          ii,
          tempValues,
          len;

      if (!pt.config.editMode) {
        return;
      } // set a flag to determine that drag is happened


      chartConfig.fromDrag = true; // For update previous value is retaining due to closure

      x = Number(datasetConfig.gaugeOriginX);
      y = Number(datasetConfig.gaugeOriginY);
      minValue = scaleRang.min;
      maxValue = scaleRang.max;
      startAngle = datasetConfig.gaugeStartAngle;
      endAngle = datasetConfig.gaugeEndAngle;
      valueRange = maxValue - minValue;
      angleRange = endAngle - startAngle;
      angleValueFactor = valueRange / angleRange;
      newAngle = getClickArcTangent(startX, startY, [x, y], chartPosition);
      angleDelta = chartConfig.rotationStartAngle - newAngle;
      angleDelta2 = angleDelta < 0 ? math2PI + angleDelta : angleDelta - math2PI;
      newVal = pt.config.dragStartY - angleDelta * angleValueFactor;
      newVal2 = pt.config.dragStartY - angleDelta2 * angleValueFactor;

      if ((newVal < minValue || newVal > maxValue) && newVal2 >= minValue && newVal2 <= maxValue) {
        newVal = newVal2;
      }

      if (newVal < minValue) {
        newVal = mathAbs(newVal2 - maxValue) < mathAbs(newVal - minValue) ? maxValue : minValue;
      } else if (newVal > maxValue) {
        newVal = mathAbs(newVal - maxValue) < mathAbs(newVal2 - minValue) ? maxValue : minValue;
      }

      pt.config.updatedValStr = newVal + _lib.BLANK;
      values = [];
      tempValues = [];
      ii = 0;
      len = pt.config.index;

      for (; ii < len; ii += 1) {
        values.push(_lib.BLANK);
        tempValues.push(_lib.BLANK);
      }

      values.push({
        value: newVal,
        animation: {
          duration: 0,
          transposeAnimDuration: 0,
          initAnimDuration: 0
        }
      });
      tempValues.push(newVal);

      if (pt.config.y !== newVal && dataSet.updateData({
        data: values
      })) {
        pt.config.updatedValStr = tempValues.join('|');
        pt.config.dragStartX = x || event.pageX || touchEvent.pageX;
      }
    },
        link,
        eventArgs,
        rolloverProperties,
        pathComand,
        hoverRadius,
        baseHoverWidth,
        baseHoverWidthHF,
        topHoverWidth,
        topHoverWidthHF,
        rearHoverExtension,
        clickHandler,
        angleValue,
        pointConfig,
        itemValue,
        formatedValue,
        displayValue,
        dataLabelObj,
        dataLabelTooltext,
        pointShowValue,
        valueY,
        setToolText,
        bgColor,
        bgAlpha,
        dialFill,
        borderColor,
        borderalpha,
        dialBorderColor,
        borderThickness,
        showDialHoverEffect,
        borderHoverColor,
        borderHoverAlpha,
        borderHoverThickness,
        hasBorderHoverMix,
        bgHoverColor,
        bgHoverAlpha,
        hasHoberFillMix,
        compositPivotRadius,
        pivotRadius,
        valueX,
        toolText,
        displayValueArgs,
        lastY,
        labelY,
        labelX,
        hoverRollOver,
        hoverRollOut,
        pointersTpathString,
        pointersPathString,
        dataGraphics,
        smartLabel = dataSet.getFromEnv('smartLabel'),
        cx = R.vml ? -1.5 : 0,
        // correction of -1.5 has to be added for VML.
    cy = R.vml ? -1.5 : 0,
        freshDraw;

    style.fontSize = this.computeFontSize(style.fontSizeWithUnit);
    (0, _lib.setLineHeight)(style);
    compositPivotRadius = pivotRadius = datasetConfig.pivotRadius;

    if (renderer.dataById === UNDEF) {
      renderer.dataById = {};
    }

    if (animation && animation.duration === 0) {
      chart.getFromEnv('animationManager').setAnimationState('dialDrag');
    }

    clickHandler = function clickHandler(dt) {
      var ele = this; // Checking if click is fired from drag or not

      if (chartConfig.fromDrag) {
        chartConfig.fromDrag = false;
        return;
      }

      chart.plotEventHandler(ele, dt);
    }; // fix for null or no data
    // gauge will show the dial at min value


    if (!ln) {
      ln = 0;
    }

    smartLabel.setStyle(css);

    if (showHoverEffect !== 0 && (showHoverEffect || chartAttrs.dialborderhovercolor || chartAttrs.dialborderhoveralpha || chartAttrs.dialborderhoveralpha === 0 || chartAttrs.dialborderhoverthickness || chartAttrs.dialborderhoverthickness === 0 || chartAttrs.dialbghovercolor || chartAttrs.plotfillhovercolor || chartAttrs.dialbghoveralpha || chartAttrs.plotfillhoveralpha || chartAttrs.dialbghoveralpha === 0)) {
      showHoverEffect = 1;
    } // rollOver handler


    hoverRollOver = function hoverRollOver(dat) {
      var ele = this,
          transStr,
          rolloverProps = ele.data('rolloverProperties');
      chart.plotEventHandler(ele, dat, 'DataPlotRollOver');

      if (rolloverProps.enabled) {
        transStr = ele.attr('transform');
        ele.attr('transform', _lib.BLANK);
        ele.attr(rolloverProps.hoverAttr);
        ele.attr('transform', transStr);
      }
    }; // rollOut Handler


    hoverRollOut = function hoverRollOut(dat) {
      var ele = this,
          transStr,
          rolloverProps = ele.data('rolloverProperties');
      chart.plotEventHandler(ele, dat, 'DataPlotRollOut');

      if (rolloverProps.enabled) {
        transStr = ele.attr('transform');
        ele.attr('transform', _lib.BLANK);
        ele.attr(rolloverProps.outAttr);
        ele.attr('transform', transStr);
      }
    };

    for (; i < ln; i += 1) {
      point = data[i];
      point.config = point.config || {};
      pointConfig = point.config;
      point.config.index = i;
      idMap[pointConfig.id] = {
        index: i,
        config: point.config
      };
      freshDraw = false;

      if (pointConfig.id !== UNDEF) {
        renderer.dataById[pointConfig.id] = {
          index: i,
          point: point
        };
      }

      dataGraphics = data[i].graphics || (data[i].graphics = {});
      itemValue = NumberFormatter.getCleanValue(pointConfig.value); // Set precision for handling decimal upto 10 place.

      itemValue = Number((0, _lib.toPrecision)(itemValue, 10));
      rearExtension = (0, _lib.pluckNumber)(pointConfig.rearextension, 0) * scaleFactor;
      compositPivotRadius = Math.max(compositPivotRadius, rearExtension * scaleFactor);
      formatedValue = NumberFormatter.dataLabels(itemValue);
      displayValue = (0, _lib.getValidValue)(pointConfig.displayvalue, formatedValue, BLANKSTRING);
      pointShowValue = (0, _lib.pluckNumber)(pointConfig.showvalue, showValue);
      valueY = (0, _lib.pluckNumber)((0, _lib.getValidValue)(pointConfig.valuey) * scaleFactor);
      valueX = (0, _lib.pluckNumber)((0, _lib.getValidValue)(pointConfig.valuex) * scaleFactor);
      pointConfig.itemValue = itemValue;
      pointConfig.formatedVal = formatedValue;
      setToolText = (0, _lib.getValidValue)((0, _lib.parseUnsafeString)((0, _lib.pluck)(pointConfig.tooltext, point.hovertext, plottooltext), false));

      if (setToolText) {
        setToolText = (0, _lib.parseTooltext)(setToolText, [1, 2], {
          formattedValue: formatedValue
        }, point.config, chartAttrs);
      } else {
        setToolText = displayValue;
      }

      bgColor = (0, _lib.pluck)(pointConfig.color, pointConfig.bgcolor, colorM.getColor('dialColor'));
      bgAlpha = (0, _lib.pluckNumber)(pointConfig.alpha, point.bgalpha, 100);
      dialFill = (0, _lib.toRaphaelColor)({
        FCcolor: {
          color: bgColor,
          alpha: bgAlpha,
          angle: 90
        }
      });
      borderColor = (0, _lib.pluck)(pointConfig.bordercolor, colorM.getColor('dialBorderColor'));
      borderalpha = (0, _lib.pluckNumber)(pointConfig.borderalpha, 100);
      dialBorderColor = (0, _lib.convertColor)(borderColor, borderalpha);
      borderThickness = (0, _lib.pluckNumber)(pointConfig.borderthickness, 1);
      radius = (0, _lib.pluckNumber)(pointConfig.radius) * scaleFactor;
      baseWidth = (0, _lib.pluckNumber)((0, _lib.pluckNumber)(pointConfig.basewidth * scaleFactor, pivotRadius * 1.6));
      topWidth = (0, _lib.pluckNumber)(pointConfig.topwidth, 0) * scaleFactor;
      baseRadius = (0, _lib.pluckNumber)(pointConfig.baseradius, 0);
      editMode = (0, _lib.pluckNumber)(pointConfig.editmode, chartAttrs.editmode, 0);
      link = (0, _lib.pluck)(pointConfig.link, BLANKSTRING);
      toolText = setToolText;
      pointConfig.toolText = toolText;
      displayValueArgs = (0, _lib.pluck)(displayValue, BLANKSTRING);
      displayValue = pointShowValue ? (0, _lib.pluck)(displayValue, _lib.BLANK) : BLANKSTRING;
      showDialHoverEffect = (0, _lib.pluckNumber)(point.showhovereffect, showHoverEffect);

      if (showDialHoverEffect !== 0 && (showDialHoverEffect || point.borderhovercolor || point.borderhoveralpha || point.borderhoveralpha === 0 || point.borderhoverthickness || point.borderhoverthickness === 0 || point.bghovercolor || point.bghoveralpha || point.bghoveralpha === 0)) {
        showDialHoverEffect = true;
        outAttr = {};
        hoverAttr = {};
        borderHoverColor = (0, _lib.pluck)(point.borderhovercolor, chartAttrs.dialborderhovercolor, FILLMIXDARK10);
        borderHoverAlpha = (0, _lib.pluckNumber)(point.borderhoveralpha, chartAttrs.dialborderhoveralpha, borderalpha);
        borderHoverThickness = (0, _lib.pluckNumber)(point.borderhoverthickness, chartAttrs.dialborderhoverthickness, borderThickness);

        if (borderHoverThickness) {
          outAttr.stroke = dialBorderColor;
          hasBorderHoverMix = /\{/.test(borderHoverColor);
          hoverAttr.stroke = (0, _lib.convertColor)(hasBorderHoverMix ? colorM.parseColorMix(borderColor, borderHoverColor)[0] : borderHoverColor, borderHoverAlpha);
        }

        if (borderHoverThickness !== borderThickness) {
          hoverAttr['stroke-width'] = borderHoverThickness;
          outAttr['stroke-width'] = borderThickness;
        }

        bgHoverColor = (0, _lib.pluck)(point.bghovercolor, chartAttrs.dialbghovercolor, chartAttrs.plotfillhovercolor, FILLMIXDARK10);
        bgHoverAlpha = (0, _lib.pluckNumber)(point.bghoveralpha, chartAttrs.dialbghoveralpha, chartAttrs.plotfillhoveralpha, bgAlpha);
        outAttr.fill = dialFill;
        hasHoberFillMix = /\{/.test(bgHoverColor);
        bgHoverColor = hasHoberFillMix ? colorM.parseColorMix(bgColor, bgHoverColor).join() : bgHoverColor;
        hoverFill = {
          FCcolor: {
            color: bgHoverColor,
            alpha: bgHoverAlpha,
            angle: 90
          }
        };
        hoverAttr.fill = (0, _lib.toRaphaelColor)(hoverFill);
      } // Parse data related attributed


      rolloverProperties = pointConfig.rolloverProperties = {
        enabled: showDialHoverEffect,
        hasHoverSizeChange: hasHoverSizeChange,
        hoverRadius: (0, _lib.pluckNumber)(hoverRadius * scaleFactor),
        baseHoverWidth: (0, _lib.pluckNumber)(baseHoverWidth * scaleFactor, pivotRadius * 1.6),
        topHoverWidth: (0, _lib.pluckNumber)(topHoverWidth * scaleFactor),
        rearHoverExtension: (0, _lib.pluckNumber)(rearHoverExtension * scaleFactor),
        hoverFill: hoverFill,
        hoverAttr: hoverAttr,
        outAttr: outAttr
      };
      radius = (0, _lib.pluckNumber)(radius, (Number(datasetConfig.gaugeOuterRadius) + Number(datasetConfig.gaugeInnerRadius)) / 2);
      baseWidthHF = baseWidth / 2;
      topWidthHF = topWidth / 2; // set the tooltip pos

      pointConfig.tooltipPos = [x, y];
      link = pointConfig.editMode ? UNDEF : pointConfig.link;
      pathComand = [M, radius, -topWidthHF, L, radius, topWidthHF, -rearExtension, baseWidthHF, -rearExtension, -baseWidthHF, Z];

      if (rolloverProperties.hasHoverSizeChange) {
        rolloverProperties.outAttr.path = pathComand;
        hoverRadius = (0, _lib.pluckNumber)(rolloverProperties.hoverRadius, radius);
        baseHoverWidth = rolloverProperties.baseHoverWidth;
        baseHoverWidthHF = baseHoverWidth / 2;
        topHoverWidth = rolloverProperties.topHoverWidth;
        topHoverWidthHF = topHoverWidth / 2;
        rearHoverExtension = rolloverProperties.rearHoverExtension;
        rolloverProperties.hoverAttr.path = [M, hoverRadius, -topHoverWidthHF, L, hoverRadius, topHoverWidthHF, -rearHoverExtension, baseHoverWidthHF, -rearHoverExtension, -baseHoverWidthHF, Z];
      }

      eventArgs = {
        link: pointConfig.link,
        value: itemValue,
        displayValue: displayValueArgs,
        toolText: toolText,
        baseWidth: pointConfig.basewidth,
        bgColor: pointConfig.bgcolor,
        borderAlpha: pointConfig.borderalpha,
        borderColor: pointConfig.bordercolor,
        borderThickness: pointConfig.borderthickness,
        editMode: pointConfig.editmode,
        id: pointConfig.id,
        radius: pointConfig.radius,
        rearExtension: pointConfig.rearextension,
        showValue: pointConfig.showPointerValue,
        topWidth: pointConfig.topwidth,
        valueX: pointConfig.valuex,
        valueY: pointConfig.valuey,
        baseRadius: pointConfig.baseradius
      };

      if (itemValue >= minValue && itemValue <= maxValue) {
        angleValue = (itemValue - minValue) / valueRange * angleRange;
        rotation = (startAngle + angleValue) / deg2rad;
      } // graphics.pointers[i].remove()


      if (!dataGraphics.pointersTpath) {
        if (topWidth) {
          pointersPathString = pathComand;
          pointersTpathString = [0, 0, 0, 0, 0, 0, 0, 0, 0];
        } else {
          // Render using trianglepath
          pointersPathString = ['M', 0, 0];
          pointersTpathString = [radius, topWidthHF, -rearExtension, baseWidthHF, -rearExtension, -baseWidthHF, 0, baseRadius, baseRadius];
        }

        dataGraphics.pointersPath = animationManager.setAnimation({
          el: 'path',
          attr: {
            path: pointersPathString,
            transform: 'R' + rotation + _lib.COMMASTRING + cx + _lib.COMMASTRING + cy
          },
          container: pGroup,
          component: dataSet,
          label: 'dialPath'
        });
        dataGraphics.pointersTpath = animationManager.setAnimation({
          el: 'trianglepath',
          attr: {
            trianglepath: pointersTpathString,
            transform: 'R' + rotation + _lib.COMMASTRING + cx + _lib.COMMASTRING + cy
          },
          container: pGroup,
          component: dataSet,
          label: 'dialPath'
        }); // Render using path if topWidth present

        if (topWidth) {
          graphic = dataGraphics.pointersPath;
        } else {
          graphic = dataGraphics.pointersTpath;
        }

        if (baseWidth || topWidth || borderThickness) {
          graphic.shadow({
            apply: shouldShowShadow
          });
        }

        freshDraw = true;
      } else {
        if (topWidth) {
          animationManager.setAnimation({
            el: dataGraphics.pointersPath,
            attr: {
              path: pathComand,
              transform: 'R' + rotation + _lib.COMMASTRING + cx + _lib.COMMASTRING + cy
            },
            component: dataSet,
            label: 'dialPath'
          });

          dataGraphics.pointersTpath._attr({
            trianglepath: [0, 0, 0, 0, 0, 0, 0, 0, 0]
          });
        } else {
          // Render using trianglepath
          animationManager.setAnimation({
            el: dataGraphics.pointersTpath,
            attr: {
              trianglepath: [radius, topWidthHF, -rearExtension, baseWidthHF, -rearExtension, -baseWidthHF, 0, baseRadius, baseRadius],
              transform: 'R' + rotation + _lib.COMMASTRING + cx + _lib.COMMASTRING + cy
            },
            component: dataSet,
            label: 'trianglepath'
          });

          dataGraphics.pointersPath._attr({
            path: 'M0,0'
          });
        }
      } // Render using path if topWidth present


      if (topWidth) {
        graphic = dataGraphics.pointersPath;
      } else {
        graphic = dataGraphics.pointersTpath;
      }

      if (!dataGraphics.pointersPath._attr) {
        dataGraphics.pointersPath._attr = dataGraphics.pointersPath.attr;
        dataGraphics.pointersPath.attr = attrFN;
      }

      if (!dataGraphics.pointersTpath._attr) {
        dataGraphics.pointersTpath._attr = dataGraphics.pointersTpath.attr;
        dataGraphics.pointersTpath.attr = attrFN;
      }

      graphic._attr({
        fill: dialFill,
        stroke: dialBorderColor,
        'stroke-width': borderThickness
      }).data(EVENTARGS, eventArgs).data('rolloverProperties', rolloverProperties);

      graphic._Attr = {
        tooltipPos: pointConfig.tooltipPos,
        cx: x,
        cy: y,
        toolTipRadius: radius - rearExtension,
        color: pointConfig.color
      };

      if (freshDraw) {
        rotation = startAngle / deg2rad;
        graphic.hover(hoverRollOver, hoverRollOut);
      }

      pointConfig.index = i;
      pointConfig.editMode = editMode;
      graphic.css({
        cursor: editMode || link ? POINTER : 'default',
        '_cursor': editMode ? 'hand' : 'default'
      });
      dataGraphics.pointersPath.pos = i;
      dataGraphics.pointersTpath.pos = i;

      if (freshDraw) {
        dataGraphics.pointersPath.on('fc-dragstart', dialDragStart);
        dataGraphics.pointersPath.on('fc-dragmove', dialDragHandler);
        dataGraphics.pointersPath.on('fc-dragend', dialDragEnd);
        dataGraphics.pointersTpath.on('fc-dragstart', dialDragStart);
        dataGraphics.pointersTpath.on('fc-dragmove', dialDragHandler);
        dataGraphics.pointersTpath.on('fc-dragend', dialDragEnd);
        dataGraphics.pointersPath.on('fc-click', clickHandler);
        dataGraphics.pointersTpath.on('fc-click', clickHandler);
      }

      pointConfig.y = itemValue;

      if (showTooltip && toolText !== _lib.BLANK) {
        toolTipController.enableToolTip(graphic, toolText);
      } else {
        toolTipController.disableToolTip(graphic);
      } // Draw widgets labels


      if (defined(displayValue) && displayValue !== _lib.BLANK) {
        lastY = y + (isBelow ? lineHeight / 2 + pivotRadius + 2 : -(lineHeight / 2) - pivotRadius - 2);
        labelY = valueY;
        labelX = (0, _lib.pluckNumber)(valueX, x);

        if (!defined(labelY)) {
          labelY = isBelow ? lastY + lineHeight * labelCounter : lastY - lineHeight * labelCounter;
        } // dataLabelObj = smartLabel.getSmartText(displayValue, datasetConfig.gaugeInnerRadius, datasetConfig.gaugeInnerRadius / 2);
        // TODO: Need to revisit the logic above why it was done like that.
        // Modifying the code in order to fix RED-8112 for now


        dataLabelObj = smartLabel.getSmartText(displayValue);
        displayValue = dataLabelObj.text;
        dataLabelTooltext = dataLabelObj.tooltext || BLANKSTRING;
        dataGraphics.dataLabel = animationManager.setAnimation({
          el: dataGraphics.dataLabel || 'text',
          attr: {
            x: labelX,
            y: labelY,
            direction: chartConfig.textDirection,
            text: displayValue,
            title: point.originalText || _lib.BLANK,
            fill: style.color,
            'text-bound': [style.backgroundColor, style.borderColor, style.borderThickness, style.borderPadding, style.borderRadius, style.borderDash]
          },
          css: css,
          container: dataLabelsGroup,
          component: dataSet,
          label: 'text'
        });
        dataGraphics.dataLabel.show();
        labelCounter += 1;

        if (showTooltip) {
          toolTipController.enableToolTip(dataGraphics.dataLabel, dataLabelTooltext);
        } else {
          toolTipController.disableToolTip(dataGraphics.dataLabel);
        }
      } else {
        dataGraphics.dataLabel && dataGraphics.dataLabel.hide();
        dataGraphics.dataLabel && toolTipController.disableToolTip(dataGraphics.dataLabel);
      }
    }
  }
  /**
   * Updates data with new JSON
   * @param {Object} _updateObj [description]
   * @return {boolean} determines whether on update draw is called or not
   */
  ;

  _proto.updateData = function updateData(_updateObj) {
    var dataSet,
        chart,
        data,
        config,
        label,
        toolText,
        dataArr,
        i,
        j,
        id,
        updateById,
        updateObjLength,
        updateData,
        updateDataMap = {},
        animation,
        value,
        updateObj = _updateObj;

    if (updateObj === this.config.lastUpdatedObj) {
      return false;
    }

    dataSet = this;
    chart = dataSet.getFromEnv('chart');
    data = dataSet.components.data;
    dataArr = dataSet.components.data;
    i = dataArr && dataArr.length || 0;
    updateObj = updateObj.data;
    updateObjLength = updateObj.length; // use the realtime animation value or the default animation value
    // Store the IDs and corresponding data in hashmap.

    for (j = 0; j < updateObjLength; j++) {
      id = updateObj[j].id;
      id && (updateDataMap[id] = updateObj[j]);
    }

    updateById = Object.keys(updateDataMap).length;

    if (i) {
      while (i--) {
        config = data[i].config;
        id = config.id;
        updateData = UNDEF; // Check if update is done by ID of pointer or sequentially.

        updateData = updateById ? updateDataMap[id] : updateObj[i];

        if (!updateData) {
          continue;
        }

        animation = updateData.animation || chart.get(configStr, animationObjStr);
        value = updateData.value;
        toolText = updateData.tooltext;
        label = updateData.label;
        config.value = (0, _lib.pluckNumber)(value, config.value, 0);
        config.tooltext = (0, _lib.pluck)(toolText, config.value);
        config.displayvalue = label;
      }

      this.config.lastUpdatedObj = updateObj; // Update the dial when editMode is enabled

      this.draw(animation);
      return true;
    }
  };

  return AngularGaugeDataset;
}(_hlineargauge.default);

var _default = AngularGaugeDataset;
exports["default"] = _default;

/***/ }),

/***/ 1483:
/***/ ((__unused_webpack_module, exports) => {



exports.__esModule = true;
exports["default"] = void 0;
var _default = {
  'initial.dataset.bulb': function initialDatasetBulb() {
    return {
      'circle.appearing': function circleAppearing(inputJSON) {
        return [{
          initialAttr: {
            cx: inputJSON.attr.cx,
            cy: inputJSON.attr.cy,
            r: 0
          },
          slot: 'plot'
        }];
      },
      'tracker.appearing': null,
      'circle.updating': function circleUpdating(inputJSON) {
        return [{
          initialAttr: {
            cx: inputJSON.attr.cx,
            cy: inputJSON.attr.cy,
            r: inputJSON.attr.r
          },
          slot: 'plot'
        }];
      },
      'labelGroup.appearing': function labelGroupAppearing() {
        return [{
          initialAttr: {
            opacity: 0
          },
          finalAttr: {
            opacity: 1
          },
          slot: 'final'
        }];
      },
      '*': null
    };
  }
};
exports["default"] = _default;

/***/ }),

/***/ 1482:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _lib = __webpack_require__(274);

var _componentInterface = __webpack_require__(290);

var _dependencyManager = __webpack_require__(282);

var _index = _interopRequireDefault(__webpack_require__(1483));

/* eslint require-jsdoc: 'error', valid-jsdoc: ["error", { "requireReturn": false }] */
var UNDEF,
    BLANKSTRING = _lib.BLANK,
    POSITION_TOP = _lib.preDefStr.POSITION_TOP,
    POSITION_MIDDLE = _lib.preDefStr.POSITION_MIDDLE,
    showHoverEffectStr = _lib.preDefStr.showHoverEffectStr,
    visibleStr = _lib.preDefStr.visibleStr,
    ROUND = _lib.preDefStr.ROUND,
    ROLLOVER = 'DataPlotRollOver',
    ROLLOUT = 'DataPlotRollOut',
    FILLMIXDARK10 = '{dark-10}',
    EVENTARGS = 'eventArgs',
    SETROLLOVERATTR = 'setRolloverAttr',
    SETROLLOUTATTR = 'setRolloutAttr',
    POINTER = 'pointer',
    EASE_OUT = 'easeOut',
    math = Math,
    mathMin = math.min,
    win = window,
    userAgent = win.navigator.userAgent,
    isIE = /msie/i.test(userAgent) && !win.opera,
    TRACKER_FILL = 'rgba(192,192,192,' + (isIE ? 0.002 : 0.000001) + ')',

/**
 * Helper function to create a RedRaphael group.
 * @param  {string} groupName                Name of the group to be created.
 * @param  {Element} parentContainer         The parent container in which the group will be appended.
 * @param {Object} dataset The concerned dataset
 * @return {Element}                         The group that was created.
 */
createGroup = function createGroup(groupName, parentContainer, dataset) {
  var animationManager = dataset.getFromEnv('animationManager');
  return animationManager.setAnimation({
    el: 'group',
    attr: {
      name: groupName
    },
    container: parentContainer,
    component: dataset,
    label: 'group'
  });
};

(0, _dependencyManager.addDep)({
  name: 'bulbAnimation',
  type: 'animationRule',
  extension: _index.default
});
/**
 * Creates dataset class for Bulb
 */

var BulbDataset = /*#__PURE__*/function (_ComponentInterface) {
  (0, _inheritsLoose2.default)(BulbDataset, _ComponentInterface);

  /**
   * Constructor function to initialise attributes of BulbDataset object
   */
  function BulbDataset() {
    var _this;

    _this = _ComponentInterface.call(this) || this;

    _this.addData = function () {// Blank fn to Override it's parent method
    };

    _this.removeData = function () {// Blank fn to Override it's parent method
    };

    _this.components = {};
    return _this;
  }
  /**
   * Returns the type of the component
   * @return {string} The type of the component, in this case a dataset.
   */


  var _proto = BulbDataset.prototype;

  _proto.getType = function getType() {
    return 'dataset';
  }
  /**
   * Returns the name of the component
   * @return {string} The name of the component.
   */
  ;

  _proto.getName = function getName() {
    return 'bulb';
  }
  /**
   * Calculates space management of bulb plot
   * @param {number} availableHeight maximum available height plot can take
   * @return {Object} height needed for bulb plot
   */
  ;

  _proto._manageSpace = function _manageSpace(availableHeight) {
    var dataSet = this,
        conf = dataSet.config,
        // JSONData = dataSet.JSONData,
    // setDataArr = JSONData.data,
    dataStore = dataSet.components.data,
        dataObj,
        chart = dataSet.getFromEnv('chart'),
        chartConfig = chart.config,
        smartLabel = dataSet.getFromEnv('smartLabel'),
        smartDataLabel,
        style = chartConfig.dataLabelStyle,
        lineHeight = (0, _lib.pluckNumber)(parseInt(style.lineHeight, 10), 12),
        maxAllowedHeight = availableHeight,
        valuePadding = chartConfig.valuepadding,
        heightUsed = 0,
        config; // setData = setDataArr[0];

    dataObj = dataStore[0];
    config = dataObj && dataObj.config;
    smartLabel.useEllipsesOnOverflow(chartConfig.useEllipsesWhenOverflow);
    smartLabel.setStyle(style);

    if (config && config.displayValue !== BLANKSTRING && !chartConfig.placevaluesinside) {
      if (conf.showValue) {
        smartDataLabel = smartLabel.getOriSize(config.displayValue); // special fix for space string

        /** @todo will be removed when smartLabel will be able to handle it */

        if (config.displayValue === _lib.BLANK) {
          smartDataLabel = {
            height: lineHeight
          };
        }

        if (smartDataLabel.height > 0) {
          heightUsed = smartDataLabel.height + valuePadding;
        }

        if (heightUsed > maxAllowedHeight) {
          heightUsed = maxAllowedHeight;
        }
      }
    }

    conf.heightUsed = heightUsed;
    return {
      top: 0,
      bottom: heightUsed
    };
  }
  /**
   * Configure dataset component and parse default values
   * @param  {Object} datasetJSON JSON for dataset configurations
   * @return {boolean} Indicates whether the configuration was successful or not
   */
  ;

  _proto.configureAttributes = function configureAttributes(datasetJSON) {
    if (!datasetJSON) {
      return false;
    }

    this.config.JSONData = datasetJSON;
    var dataSet = this,
        JSONData = dataSet.config.JSONData,
        userConfig = (0, _lib.extend2)({}, JSONData),
        chart = dataSet.getFromEnv('chart'),
        conf = dataSet.config,
        chartConfig = chart.config,
        chartAttr = chart.getFromEnv('dataSource').chart,
        enableAnimation;
    (0, _lib.parseConfiguration)(userConfig, conf, chart.config, {
      data: true
    }); // is3D = pluckNumber(chartAttr.is3D, 1);
    // conf.autoScale = pluckNumber(chartAttr.autoscale, 1);

    conf.origW = (0, _lib.pluckNumber)(chartAttr.origw, chartConfig.autoscale ? chart.config.origRenderWidth : chartConfig.width || chart.config.origRenderWidth);
    conf.origH = (0, _lib.pluckNumber)(chartAttr.origh, chartConfig.autoscale ? chart.config.origRenderHeight : chartConfig.height || chart.config.origRenderHeight); // showTooltip = pluckNumber(chartAttr.showtooltip, 1);

    conf.setToolText = (0, _lib.getValidValue)((0, _lib.parseUnsafeString)((0, _lib.pluck)(chartAttr.plottooltext, UNDEF), false));
    conf.useColorNameAsValue = (0, _lib.pluckNumber)(chartAttr.usecolornameasvalue, 0);
    conf.showTextOutline = (0, _lib.pluckNumber)(chartAttr.textoutline, 0);
    conf.enableAnimation = enableAnimation = (0, _lib.pluckNumber)(chartAttr.animation, chartAttr.defaultanimation, 1);
    conf.animation = !enableAnimation ? false : {
      duration: (0, _lib.pluckNumber)(chartAttr.animationduration, 1) * 1000
    };
    conf.showValue = (0, _lib.pluckNumber)(chartAttr.showvalue, 1);

    dataSet._setConfigure();
  }
  /**
   * Configure data level attributes
   * @param {Object} newDataset updated JSON data
   */
  ;

  _proto._setConfigure = function _setConfigure(newDataset) {
    var dataSet = this,
        chart = dataSet.getFromEnv('chart'),
        conf = dataSet.config,
        chartConfig = chart.config,
        JSONData = dataSet.config.JSONData,
        setDataArr = newDataset || JSONData.data,
        setDataLen = setDataArr && setDataArr.length,
        len = newDataset && newDataset.data.length || setDataLen,
        jsonData = chart.getFromEnv('dataSource'),
        chartAttr = jsonData.chart,
        colorM = dataSet.getFromEnv('color-manager'),
        showTooltip = (0, _lib.pluckNumber)(chartAttr.showtooltip, 1),
        // parseUnsafeString = lib.parseUnsafeString,
    tooltipSepChar = (0, _lib.parseUnsafeString)((0, _lib.pluck)(chartAttr.tooltipsepchar, _lib.COMMASPACE)),
        // parseTooltext = lib.parseTooltext,
    formatedVal,
        toolText,
        showHoverEffect = chartConfig.showhovereffect,
        dataStore = dataSet.components.data,
        setData,
        setValue,
        dataObj,
        config,
        label,
        setDisplayValue,
        is3D = (0, _lib.pluckNumber)(chartAttr.is3d, 1),
        i,
        numberFormatter = dataSet.getFromEnv('number-formatter'),
        colorRangeGetter,
        colorCodeObj,
        gaugeFillAlpha,
        colorName,
        gaugeBorderColorCode,
        gaugeBorderAlpha,
        hasGaugeBorderMix,
        fillColor,
        gaugeBorderColor,
        gaugeBorderThickness,
        gaugeFillHoverColor,
        gaugeFillHoverAlpha,
        showGaugeBorderOnHover,
        gaugeBorderHoverColor,
        gaugeBorderHoverAlpha,
        gaugeBorderHoverThickness,
        is3DOnHover,
        hasHoberFillMix,
        hasBorderHoverMix,
        displayValue,
        getPointColor = function getPointColor(color, alpha, isBulb3D) {
      if (!isBulb3D) {
        return (0, _lib.convertColor)(color, alpha);
      }

      return {
        FCcolor: {
          cx: 0.4,
          cy: 0.4,
          r: '80%',
          color: (0, _lib.getLightColor)(color, 65) + _lib.COMMASTRING + (0, _lib.getLightColor)(color, 75) + _lib.COMMASTRING + (0, _lib.getDarkColor)(color, 65),
          alpha: alpha + _lib.COMMASTRING + alpha + _lib.COMMASTRING + alpha,
          ratio: '0,30,70',
          // BGRATIOSTRING,
          radialGradient: true
        }
      };
    },
        hoverAttr,
        hoverAnimAttr,
        outAttr;

    if (!dataStore) {
      dataStore = dataSet.components.data = [];
    } // Parsing the attributes and values at set level.


    for (i = 0; i < len; i++) {
      if (newDataset) {
        setData = newDataset && newDataset.data[i];
      } else {
        setData = setDataArr[i];
      }

      dataObj = dataStore[i];
      config = dataObj && dataObj.config;

      if (!dataObj) {
        dataObj = dataStore[i] = {};
      }

      if (!dataObj.config) {
        config = dataStore[i].config = {};
      }

      config.setValue = setValue = numberFormatter.getCleanValue(setData.value) || 0;
      formatedVal = numberFormatter.dataLabels(setValue);
      setDisplayValue = (0, _lib.getValidValue)((0, _lib.parseUnsafeString)(setData.displayvalue)); // Get colorRange from the env of chart

      config.colorRangeGetter = colorRangeGetter = dataSet.getFromEnv('colorRange');
      colorCodeObj = colorRangeGetter.getColorObj(config.setValue);

      if (!colorRangeGetter.colorArr.length) {
        colorCodeObj = colorRangeGetter.config.defaultObj;
      } // colorCodeObj = colorCodeObj.colorObj || colorCodeObj.prevObj || colorCodeObj.nextObj;


      gaugeFillAlpha = (0, _lib.pluckNumber)(chartAttr.gaugefillalpha, colorCodeObj.alpha, 100);
      colorName = (0, _lib.parseUnsafeString)((0, _lib.pluck)(colorCodeObj.label, colorCodeObj.name));
      gaugeBorderColorCode = (0, _lib.pluck)(colorCodeObj.bordercolor, chartAttr.gaugebordercolor, (0, _lib.getDarkColor)(colorCodeObj.code, 70), '000000');
      gaugeBorderAlpha = (0, _lib.pluckNumber)(colorCodeObj.borderalpha, chartAttr.gaugeborderalpha, '90') * gaugeFillAlpha / 100;
      hasGaugeBorderMix = /\{/.test(gaugeBorderColorCode);
      gaugeBorderColorCode = hasGaugeBorderMix ? colorM.parseColorMix((0, _lib.pluck)(colorCodeObj.bordercolor, colorCodeObj.code), gaugeBorderColorCode)[0] : gaugeBorderColorCode;
      config.gaugeBorderColor = gaugeBorderColor = (0, _lib.convertColor)(gaugeBorderColorCode, gaugeBorderAlpha);
      config.gaugeBorderThickness = gaugeBorderThickness = chartConfig.showgaugeborder ? (0, _lib.pluckNumber)(chartAttr.gaugeborderthickness, 1) : 0;
      config.rawFillColor = colorCodeObj.code;
      config.fillColor = fillColor = getPointColor(colorCodeObj.code, gaugeFillAlpha, is3D);

      if (showHoverEffect !== 0 && (showHoverEffect || chartAttr.gaugefillhovercolor || chartAttr.plotfillhovercolor || chartAttr.gaugefillhoveralpha || chartAttr.plotfillhoveralpha || chartAttr.gaugefillhoveralpha === 0 || chartAttr.is3donhover || chartAttr.is3donhover === 0 || chartAttr.showgaugeborderonhover || chartAttr.showgaugeborderonhover === 0 || chartAttr.gaugeborderhovercolor || chartAttr.gaugeborderhoveralpha || chartAttr.gaugeborderhoveralpha === 0 || chartAttr.gaugeborderhoverthickness || chartAttr.gaugeborderhoverthickness === 0)) {
        showHoverEffect = true;
        gaugeFillHoverColor = (0, _lib.pluck)(chartAttr.gaugefillhovercolor, chartAttr.plotfillhovercolor, FILLMIXDARK10);
        gaugeFillHoverAlpha = (0, _lib.pluckNumber)(chartAttr.gaugefillhoveralpha, chartAttr.plotfillhoveralpha);
        showGaugeBorderOnHover = (0, _lib.pluckNumber)(chartAttr.showgaugeborderonhover);

        if (showGaugeBorderOnHover === UNDEF) {
          if (chartAttr.gaugeborderhovercolor || chartAttr.gaugeborderhoveralpha || chartAttr.gaugeborderhoveralpha === 0 || chartAttr.gaugeborderhoverthickness || chartAttr.gaugeborderhoverthickness === 0) {
            showGaugeBorderOnHover = 1;
          } else {
            showGaugeBorderOnHover = chartConfig.showgaugeborder;
          }
        }

        gaugeBorderHoverColor = (0, _lib.pluck)(chartAttr.gaugeborderhovercolor, FILLMIXDARK10);
        gaugeBorderHoverAlpha = (0, _lib.pluckNumber)(chartAttr.gaugeborderhoveralpha);
        gaugeBorderHoverThickness = showGaugeBorderOnHover ? (0, _lib.pluckNumber)(chartAttr.gaugeborderhoverthickness, gaugeBorderThickness || 1) : 0;
        is3DOnHover = !!(0, _lib.pluckNumber)(chartAttr.is3donhover, is3D);
        hoverAttr = {};
        outAttr = {};

        if (gaugeBorderThickness !== gaugeBorderHoverThickness) {
          hoverAttr['stroke-width'] = gaugeBorderHoverThickness;
          outAttr['stroke-width'] = gaugeBorderThickness;
        }

        outAttr.fill = (0, _lib.toRaphaelColor)(fillColor);
        hasHoberFillMix = /\{/.test(gaugeFillHoverColor);
        gaugeFillHoverColor = hasHoberFillMix ? colorM.parseColorMix(colorCodeObj.code, gaugeFillHoverColor)[0] : (0, _lib.pluck)(gaugeFillHoverColor, colorCodeObj.code);
        hoverAttr.fill = (0, _lib.toRaphaelColor)(getPointColor(gaugeFillHoverColor, (0, _lib.pluckNumber)(gaugeFillHoverAlpha, gaugeFillAlpha), is3DOnHover));

        if (gaugeBorderHoverThickness) {
          outAttr.stroke = gaugeBorderColor;
          hasBorderHoverMix = /\{/.test(gaugeBorderHoverColor);
          hoverAttr.stroke = (0, _lib.convertColor)(hasBorderHoverMix ? colorM.parseColorMix(hasGaugeBorderMix ? gaugeFillHoverColor : gaugeBorderColorCode, gaugeBorderHoverColor)[0] : gaugeBorderHoverColor, (0, _lib.pluckNumber)(gaugeBorderHoverAlpha, gaugeBorderAlpha));
        }
      }

      config.setTooltext = (0, _lib.getValidValue)((0, _lib.parseUnsafeString)((0, _lib.pluck)(setData.tooltext, JSONData.plottooltext, chartAttr.plottooltext), false));

      if (!showTooltip) {
        toolText = false;
      } else if (config.setTooltext !== UNDEF) {
        toolText = (0, _lib.parseTooltext)(config.setTooltext, [1, 2], {
          formattedValue: formatedVal
        }, setData, chartAttr);
      } else {
        // Determine the dispalay value then
        toolText = conf.useColorNameAsValue ? colorName : formatedVal === null ? false : label !== UNDEF ? label + tooltipSepChar + formatedVal : formatedVal;
      } // Create the displayvalue


      if (setDisplayValue !== UNDEF) {
        displayValue = setDisplayValue;
      } else {
        // Determine the dispalay value then
        displayValue = setData.label || (conf.useColorNameAsValue ? colorName : formatedVal);
      }

      config.toolText = toolText;
      config.displayValue = displayValue;
      config.rolloverProperties = {
        enabled: showHoverEffect,
        hoverAttr: hoverAttr,
        hoverAnimAttr: hoverAnimAttr,
        outAttr: outAttr
      }; // tempPlotfillAngle && (plotfillAngle = tempPlotfillAngle);
    }
  }
  /**
   * Update data with new JSON
   * @param {Object} dataObj updated parsd JSON
   * @param {number} index dataset index
   * @param {boolean} draw decides whether to draw datset instantly or not
   */
  ;

  _proto.updateData = function updateData(dataObj, index, draw) {
    var dataSet = this;

    dataSet._setConfigure(dataObj, index);

    if (draw) {
      dataSet.asynDraw();
    }
  }
  /**
   * Draw bulb plot
   */
  ;

  _proto.draw = function draw() {
    var dataSet = this,
        dataStore = dataSet.components.data,
        chart = dataSet.getFromEnv('chart'),
        toolTipController = dataSet.getFromEnv('toolTipController'),
        conf = dataSet.config,
        // animationObj = chart.get(configStr, animationObjStr),
    animType = EASE_OUT,
        // animObj = animationObj.animObj,
    // dummyObj = animationObj.dummyObj,
    // animationDuration = animationObj.duration,
    chartConfig = chart.config,
        canvasLeft = chartConfig.canvasLeft,
        canvasTop = chartConfig.canvasTop,
        canvasHeight = chartConfig.canvasHeight,
        canvasWidth = chartConfig.canvasWidth,
        parentContainer = chart.getChildContainer().plotGroup,
        container = dataSet.getContainer('container'),
        trackerContainer = dataSet.getContainer('trackerContainer'),
        // layers = chart.graphics,
    trackerLayer = chart.getChildContainer('trackerGroup'),
        setValue,
        attr,
        toolText,
        tooltipVal,
        dataLabelObj,
        xPos,
        yPos,
        radius,
        bulb,
        bulbCheck,
        dataObj = dataStore[0],
        graphic,
        label,
        labelCheck,
        config = dataObj && dataObj.config,
        gaugeOriginX = chartConfig.gaugeoriginx,
        gaugeOriginY = chartConfig.gaugeoriginy,
        gaugeRadius = chartConfig.gaugeradius,
        hasGaugeOriginX = chartConfig.hasgaugeoriginx,
        hasGaugeOriginY = chartConfig.hasgaugeoriginy,
        hasGaugeRadius = chartConfig.hasgaugeradius,
        labelY,
        vAlign,
        smartLabel = dataSet.getFromEnv('smartLabel'),
        animationManager = dataSet.getFromEnv('animationManager'),
        dataLabelContainer = dataSet.getContainer('dataLabelContainer'),
        style = chart.config.dataLabelStyle,
        dataLabelsLayer = chart.getChildContainer('datalabelsGroup'),
        // isNewElement = false,
    trackerConfig; // css = {
    //     fontFamily: style.fontFamily,
    //     fontSize: style.fontSize,
    //     lineHeight: style.lineHeight,
    //     fontWeight: style.fontWeight,
    //     fontStyle: style.fontStyle
    // };

    smartLabel.setStyle(style);

    if (!container) {
      container = dataSet.addContainer('container', createGroup('bulb', parentContainer, dataSet));
    }

    if (!trackerContainer) {
      trackerContainer = dataSet.addContainer('trackerContainer', createGroup('bulb-hot', trackerLayer, dataSet));
    } // Creating the datalabel container if not created


    if (!dataLabelContainer) {
      dataLabelContainer = dataSet.addContainer('dataLabelContainer', animationManager.setAnimation({
        el: 'group',
        attr: {
          name: 'datalabel'
        },
        label: 'labelGroup',
        component: dataSet
      }));
    } // Append the container to datalabelslayer


    if (dataLabelsLayer) {
      dataLabelsLayer.appendChild(dataLabelContainer);
    }

    trackerConfig = dataObj.trackerConfig = {};
    setValue = config.setValue;
    toolText = config.toolText;
    trackerConfig.eventArgs = {
      value: setValue,
      displayValue: config.displayValue,
      toolText: !toolText ? '' : toolText,
      color: config.rawFillColor
    };

    if (!dataObj.graphics) {
      dataObj.graphics = {};
    }

    gaugeOriginX = hasGaugeOriginX !== UNDEF ? gaugeOriginX * conf.scaleFactor : canvasLeft + canvasWidth / 2; // (hasGaugeOriginX !== UNDEF) && (gaugeOriginX *= conf.scaleFactor);

    gaugeOriginY = hasGaugeOriginY !== UNDEF ? gaugeOriginY * conf.scaleFactor : canvasTop + canvasHeight / 2; // (hasGaugeOriginY !== UNDEF) && (gaugeOriginY *= conf.scaleFactor);

    xPos = gaugeOriginX;
    yPos = gaugeOriginY;
    radius = hasGaugeRadius !== UNDEF ? gaugeRadius * conf.scaleFactor : mathMin(canvasWidth / 2, canvasHeight / 2); // (hasGaugeRadius !== UNDEF) && (radius *= conf.scaleFactor);

    attr = {
      cx: xPos,
      cy: yPos,
      r: radius,
      'stroke-linecap': ROUND,
      stroke: (0, _lib.toRaphaelColor)(config.gaugeBorderColor),
      'stroke-width': config.gaugeBorderThickness,
      fill: (0, _lib.toRaphaelColor)(config.fillColor)
    };
    bulbCheck = dataObj.graphics.element;
    bulb = animationManager.setAnimation({
      el: bulbCheck || 'circle',
      attr: attr,
      container: container,
      component: dataSet,
      animType: animType,
      label: 'circle'
    });

    if (!bulbCheck) {
      dataObj.graphics.element = bulb;
    }

    trackerConfig.attr = {
      cx: xPos,
      cy: yPos,
      r: radius,
      cursor: config.setLink ? POINTER : _lib.BLANK,
      stroke: TRACKER_FILL,
      'stroke-width': config.plotBorderThickness,
      fill: TRACKER_FILL,
      visibility: visibleStr
    };
    /*
             * If the tooltips are not present then they are created over the hot element,
             * else only attributes are set for the existing tooltips.
             */
    // hotElement = dataObj.graphics.hotElement;
    // if (!hotElement) {
    //     hotElement = dataObj.graphics.hotElement = paper.circle(attr, trackerContainer);
    //     isNewElement = true;
    // }
    // else {
    //     hotElement = dataObj.graphics.hotElement.attr(attr);
    // }
    // hotElement
    //     .data(EVENTARGS, eventArgs)
    //     .data(SETROLLOVERATTR, rolloverProperties.hoverAttr)
    //     .data(SETROLLOUTATTR, rolloverProperties.outAttr);
    // if (isNewElement) {
    //     hotElement
    //         .on('fc-click', clickFunc)
    //         .hover(
    //             rolloverResponseSetter(bulb),
    //             rolloutResponseSetter(bulb)
    //         );
    // }

    graphic = dataObj.graphics;
    labelCheck = graphic.label;

    if (!chartConfig.placevaluesinside) {
      labelY = yPos + radius + chartConfig.valuepadding;
      vAlign = POSITION_TOP;
    } else {
      labelY = yPos;
      vAlign = POSITION_MIDDLE;
    }

    if (config.setValue !== BLANKSTRING && conf.showValue) {
      dataLabelObj = smartLabel.getSmartText(config.displayValue, chartConfig.width - chartConfig.chartleftmargin - chartConfig.chartrightmargin, +chartConfig.height - labelY - chartConfig.chartbottommargin);
      tooltipVal = dataLabelObj.tooltext || BLANKSTRING;
      attr = {
        text: dataLabelObj.text,
        'text-anchor': POSITION_MIDDLE,
        x: gaugeOriginX,
        y: labelY,
        // title: (bulbProperties.originalText || BLANK),
        'vertical-align': vAlign,
        fill: style.color,
        direction: config.textDirection,
        'text-bound': [style.backgroundColor, style.borderColor, style.borderThickness, style.borderPadding, style.borderRadius, style.borderDash]
      };
      label = animationManager.setAnimation({
        el: labelCheck || 'text',
        animType: animType,
        attr: attr,
        label: 'text',
        container: dataLabelContainer,
        component: dataSet
      });
      label.outlineText(conf.showTextOutline, attr.fill);

      if (!labelCheck) {
        graphic.label = label;
      }

      if (chartConfig.showToolTip) {
        toolTipController.enableToolTip(label, tooltipVal);
      } else {
        toolTipController.disableToolTip(label);
      }
    }

    conf.showValue ? graphic.label && graphic.label.show() : graphic.label && graphic.label.hide();
    dataSet.drawTracker();
  }
  /**
   * Draw tracker of bulb plot
   */
  ;

  _proto.drawTracker = function drawTracker() {
    var dataSet = this,
        chart = dataSet.getFromEnv('chart'),
        animationManager = dataSet.getFromEnv('animationManager'),
        toolTipController = dataSet.getFromEnv('toolTipController'),
        components = dataSet.components,
        dataStore = components.data,
        chartConfig = chart.config,
        showHoverEffect = chartConfig.plothovereffect,
        trackerContainer = dataSet.getContainer('trackerContainer'),
        trackerConfig,
        config,
        dataObj,
        setElement,
        hotElemCreated = false,
        hotElement,
        hotElementCheck,
        attr,
        // Fired when clicked over the hot elements.
    clickFunc = function clickFunc(setDataArr) {
      var ele = this;
      chart.plotEventHandler(ele, setDataArr);
    },
        // Fired on mouse-in over the hot elements.
    rolloverResponseSetter = function rolloverResponseSetter(elem) {
      return function (data) {
        var ele = this,
            elData = ele.getData(),
            setRolloverAttr = elData.setRolloverAttr; // Check whether the plot is in dragged state or not if
        // drag then dont fire rolloverevent

        if (elData.showHoverEffect !== 0 && elData.draged !== true) {
          if (setRolloverAttr.fill) {
            animationManager.setAnimationState('mouseover');
            animationManager.setAnimation({
              el: elem,
              attr: setRolloverAttr,
              component: dataSet
            });
          }

          chart.plotEventHandler(ele, data, ROLLOVER);
        }
      };
    },
        // Fired on mouse-out over the hot elements.
    rolloutResponseSetter = function rolloutResponseSetter(elem) {
      return function (data) {
        var ele = this,
            elData = ele.getData(),
            setRolloutAttr = elData.setRolloutAttr; // Check whether the plot is in draggedstate or not if drag then dont fire rolloutevent

        if (elData.showHoverEffect !== 0 && elData.draged !== true) {
          if (setRolloutAttr.fill) {
            animationManager.setAnimationState('mouseout');
            animationManager.setAnimation({
              el: elem,
              attr: setRolloutAttr,
              component: dataSet
            });
          }

          chart.plotEventHandler(ele, data, ROLLOUT);
        }
      };
    }; // Create tracker elements.


    dataObj = dataStore[0];
    config = dataObj && dataObj.config;
    trackerConfig = dataObj.trackerConfig;
    setElement = dataObj.graphics.element;
    attr = trackerConfig.attr;
    hotElementCheck = dataObj.graphics.hotElement;

    if (attr) {
      /*
       * If the tooltips are not present then they are created over the hot element,
       * else only attributes are set for the existing tooltips.
       */
      hotElement = animationManager.setAnimation({
        el: hotElementCheck || 'circle',
        attr: attr,
        container: trackerContainer,
        component: dataSet,
        label: 'tracker'
      });

      if (!hotElementCheck) {
        dataObj.graphics.hotElement = hotElement;
        hotElemCreated = true;
      } // Hover effects and click function is binded to the hot element if present else the set element.


      (hotElement || setElement).data(EVENTARGS, trackerConfig.eventArgs).data(showHoverEffectStr, showHoverEffect).data(SETROLLOVERATTR, config.rolloverProperties.hoverAttr || {}).data(SETROLLOUTATTR, config.rolloverProperties.outAttr || {});
      toolTipController.enableToolTip(hotElement || setElement, trackerConfig.eventArgs.toolText);

      if (hotElemCreated || config.elemCreated) {
        (hotElement || setElement).on('fc-click', clickFunc).hover(rolloverResponseSetter(setElement), rolloutResponseSetter(setElement));
      }
    }
  };

  return BulbDataset;
}(_componentInterface.ComponentInterface);

var _default = BulbDataset;
exports["default"] = _default;

/***/ }),

/***/ 1514:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



exports.__esModule = true;
exports["default"] = void 0;

var _lib = __webpack_require__(274);

var fadeEffect = [{
  initialAttr: function initialAttr() {
    return {
      opacity: 0
    };
  },
  finalAttr: function finalAttr() {
    return {
      opacity: 1
    };
  }
}];
var _default = {
  'initial.dataset.bullet': function initialDatasetBullet() {
    var component = this,
        conf = component.config,
        chart = component.getFromEnv('chart'),
        scale = component.getFromEnv('scale'),
        yMax = scale.max,
        yMin = scale.min,
        isAllPositiveZero = yMax > 0 && yMin >= 0,
        isAllNegativeZero = yMax <= 0 && yMin < 0,
        yBase = isAllNegativeZero ? yMax : isAllPositiveZero ? yMin : 0,
        yBasePos = scale.yBasePos = scale.getPixel(yBase);
    return {
      'plotRect.appearing': function plotRectAppearing() {
        var isHorizontal = chart.isHorizontal,
            attr;

        if (!conf.plotAsDot) {
          yBasePos = scale.getPixel(conf.base);
        }

        if (isHorizontal) {
          attr = {
            width: 0
          };
        } else {
          attr = {
            height: 0,
            y: yBasePos
          };
        }

        return [{
          initialAttr: function initialAttr() {
            return attr;
          },
          slot: 'middle'
        }];
      },
      'plotRect.updating': null,
      'path.appearing': function pathAppearing() {
        fadeEffect[0].slot = _lib.MIDDLESTR;
        return fadeEffect;
      },
      'path.updating': null,
      'text.appearing': function textAppearing() {
        fadeEffect[0].slot = _lib.FINALSTR;
        return fadeEffect;
      },
      'text.updating': null,
      'labelGroup.appearing': function labelGroupAppearing() {
        fadeEffect[0].slot = _lib.FINALSTR;
        return fadeEffect;
      },
      'labelGroup.updating': null,
      'backgroundRect.appearing': function backgroundRectAppearing() {
        fadeEffect[0].slot = _lib.INITIALSTR;
        return fadeEffect;
      },
      'backgroundRect.updating': null
    };
  }
};
exports["default"] = _default;

/***/ }),

/***/ 1513:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _lib = __webpack_require__(274);

var _dependencyManager = __webpack_require__(282);

var _componentInterface = __webpack_require__(290);

var _index = _interopRequireDefault(__webpack_require__(1514));

/* eslint require-jsdoc: 'error', valid-jsdoc: ["error", { "requireReturn": false }] */
var Raphael = (0, _dependencyManager.getDep)('redraphael', 'plugin'),
    BLANKSTRING = _lib.BLANK,
    UNDEF,
    showHoverEffectStr = _lib.preDefStr.showHoverEffectStr,
    SETROLLOVERATTR = 'setRolloverAttr',
    ROUND = _lib.preDefStr.ROUND,
    miterStr = _lib.preDefStr.miterStr,
    BUTT = 'butt',
    PLOTBORDERCOLOR = 'plotBorderColor',
    PLOTGRADIENTCOLOR = 'plotGradientColor',
    colorStrings = _lib.preDefStr.colors,
    SHOWSHADOW = 'showShadow',
    math = Math,
    mathMax = math.max,
    mathMin = math.min,
    mathAbs = math.abs,
    COLOR_FFFFFF = colorStrings.FFFFFF,
    noneStr = 'none',
    FILLMIXDARK10 = '{dark-10}',
    ROLLOVER = 'DataPlotRollOver',
    SETROLLOUTATTR = 'setRolloutAttr',
    ROLLOUT = 'DataPlotRollOut',
    win = window,
    doc = win.document,
    hasTouch = doc.documentElement.ontouchstart !== UNDEF,
    M = 'M',
    L = 'L',
    DECIDE_CRISPENING = {
  'true': UNDEF,
  'false': 'crisp'
},
    EVENTARGS = 'eventArgs',
    GROUPID = 'groupId',
    POSITION_START = _lib.preDefStr.POSITION_START,
    POSITION_MIDDLE = _lib.preDefStr.POSITION_MIDDLE,
    PLOTFILLCOLOR_STR = _lib.preDefStr.PLOTFILLCOLOR_STR,
    HTP = hasTouch ? _lib.TOUCH_THRESHOLD_PIXELS : _lib.CLICK_THRESHOLD_PIXELS;
(0, _dependencyManager.addDep)({
  name: 'bulletAnimation',
  type: 'animationRule',
  extension: _index.default
});
/**
 * Creates dataset class for Bullet
 */

var BulletDataset = /*#__PURE__*/function (_ComponentInterface) {
  (0, _inheritsLoose2.default)(BulletDataset, _ComponentInterface);

  /**
   * Constructor function to initialise attributes of bullet dataset object
   */
  function BulletDataset() {
    var _this;

    _this = _ComponentInterface.call(this) || this;

    _this.addData = function () {// Blank fn to Override it's parent method
    };

    _this.removeData = function () {// Blank fn to Override it's parent method
    };

    _this.components = {};
    return _this;
  }
  /**
   * Sets the type of the component
   * @return {string} type
   */


  var _proto = BulletDataset.prototype;

  _proto.getType = function getType() {
    return 'dataset';
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */
  ;

  _proto.getName = function getName() {
    return 'bullet';
  }
  /**
   * Configure dataset component and parse default values
   * @param  {Object} datasetJSON JSON for dataset configurations
   * @return {boolean} Indicates whether the configuration was successful or not
   */
  ;

  _proto.configure = function configure(datasetJSON) {
    if (!datasetJSON) {
      return false;
    }

    this.config.JSONData = datasetJSON;
    var dataSet = this,
        chart = dataSet.getFromEnv('chart'),
        conf = dataSet.config,
        JSONData = dataSet.config.JSONData,
        chartAttr = chart.getFromEnv('dataSource').chart,
        colorM = dataSet.getFromEnv('color-manager'),
        showplotborder,
        plotColor = conf.plotColor = colorM.getColor(PLOTFILLCOLOR_STR),
        plotBorderDash = (0, _lib.pluckNumber)(JSONData.dashed, chartAttr.plotborderdashed),
        plotDashLen,
        plotDashGap,
        isRoundEdges,
        plotFillAlpha,
        dataStore = dataSet.components.data,
        isBar = chart.isBar,
        is3D = chart.config.is3D,
        isStacked = chart.isStacked,
        stack100Percent,
        targetalpha,
        plotAsDot,
        targetCapStyle; // Set visibilty of dataset

    dataSet.setState('visible', (0, _lib.pluckNumber)(JSONData.visible, 1) === 1);
    conf.targetCapStyle = targetCapStyle = (0, _lib.pluck)(chartAttr.targetcapstyle, ROUND).toLowerCase();

    if (targetCapStyle !== BUTT && targetCapStyle !== ROUND && targetCapStyle !== 'square' && targetCapStyle !== 'inherit') {
      conf.targetCapStyle = ROUND;
    }

    conf.upperLimit = (0, _lib.pluckNumber)(chartAttr.upperlimit);
    conf.lowerLimit = (0, _lib.pluckNumber)(chartAttr.lowerlimit);
    conf.initAnimation = true;
    showplotborder = conf.showplotborder = (0, _lib.pluckNumber)(chartAttr.showplotborder, 0);
    conf.plotDashLen = plotDashLen = (0, _lib.pluckNumber)(chartAttr.plotborderdashlen, 5);
    conf.plotDashGap = plotDashGap = (0, _lib.pluckNumber)(chartAttr.plotborderdashgap, 4);
    conf.plotfillAngle = (0, _lib.pluckNumber)(360 - chartAttr.plotfillangle, isBar ? 180 : 90);
    conf.plotFillAlpha = plotFillAlpha = (0, _lib.pluck)(JSONData.alpha, chartAttr.plotfillalpha, _lib.HUNDREDSTRING);
    conf.plotColor = plotColor = (0, _lib.pluck)(chartAttr.plotfillcolor, plotColor);
    conf.isRoundEdges = isRoundEdges = (0, _lib.pluckNumber)(chartAttr.useroundedges, 0);
    conf.plotRadius = (0, _lib.pluckNumber)(chartAttr.useRoundEdges, conf.isRoundEdges ? 1 : 0);
    conf.plotFillRatio = (0, _lib.pluck)(JSONData.ratio, chartAttr.plotfillratio);
    conf.plotgradientcolor = (0, _lib.getDefinedColor)(chartAttr.plotgradientcolor, colorM.getColor(PLOTGRADIENTCOLOR)); // !usePlotGradientColor && (plotgradientcolor = BLANK);

    conf.showPlotBorderOnHover = (0, _lib.pluckNumber)(chartAttr.showplotborderonhover, 0);
    conf.plotBorderAlpha = (0, _lib.pluck)(chartAttr.plotborderalpha, plotFillAlpha, _lib.HUNDREDSTRING);
    conf.plotBorderColor = (0, _lib.pluck)(chartAttr.plotbordercolor, is3D ? COLOR_FFFFFF : colorM.getColor(PLOTBORDERCOLOR));
    conf.plotBorderThickness = showplotborder ? (0, _lib.pluckNumber)(chartAttr.plotborderthickness, 0) : 0;
    conf.plotBorderDashStyle = plotBorderDash ? (0, _lib.getDashStyle)(plotDashLen, plotDashGap) : noneStr;
    conf.showValue = (0, _lib.pluckNumber)(JSONData.showvalue, chartAttr.showvalue, 1);
    conf.valuePadding = (0, _lib.pluckNumber)(chartAttr.valuepadding, 2);
    conf.showShadow = isRoundEdges || is3D ? (0, _lib.pluckNumber)(chartAttr.showshadow, 1) : (0, _lib.pluckNumber)(chartAttr.showshadow, colorM.getColor(SHOWSHADOW));
    conf.showHoverEffect = (0, _lib.pluckNumber)(chartAttr.plothovereffect, chartAttr.showhovereffect, 0);
    conf.showTooltip = (0, _lib.pluckNumber)(chartAttr.showtooltip, 1);
    conf.stack100Percent = stack100Percent = (0, _lib.pluckNumber)(chart.stack100percent, chartAttr.stack100percent, 0);
    conf.definedGroupPadding = mathMax((0, _lib.pluckNumber)(chartAttr.plotspacepercent), 0);
    conf.plotSpacePercent = mathMax((0, _lib.pluckNumber)(chartAttr.plotspacepercent, 20) % 100, 0);
    conf.maxColWidth = (0, _lib.pluckNumber)(isBar ? chartAttr.maxbarheight : chartAttr.maxcolwidth, 50);
    conf.showPercentValues = (0, _lib.pluckNumber)(chartAttr.showpercentvalues, isStacked && stack100Percent ? 1 : 0);
    conf.showPercentInToolTip = (0, _lib.pluckNumber)(chartAttr.showpercentintooltip, isStacked && stack100Percent ? 1 : 0);
    conf.plotPaddingPercent = (0, _lib.pluckNumber)(chartAttr.plotpaddingpercent);
    conf.rotateValues = (0, _lib.pluckNumber)(chartAttr.rotatevalues) ? 270 : 0;
    conf.placeValuesInside = (0, _lib.pluckNumber)(chartAttr.placevaluesinside, 0);
    conf.use3DLighting = (0, _lib.pluckNumber)(chartAttr.use3dlighting, 1);

    if (!dataStore) {
      dataStore = dataSet.components.data = [];
    }

    conf.plotAsDot = plotAsDot = (0, _lib.pluckNumber)(chartAttr.plotasdot, 0);
    conf.plotFillPercent = (0, _lib.pluckNumber)(chartAttr.plotfillpercent, plotAsDot ? 25 : 40);
    conf.targetFillPercent = (0, _lib.pluckNumber)(chartAttr.targetfillpercent, 60);
    conf.targetThickness = (0, _lib.pluckNumber)(chartAttr.targetthickness, 3);
    targetalpha = conf.targetalpha = (0, _lib.pluckNumber)(chartAttr.targetalpha, 100);
    conf.rawTargetColor = (0, _lib.pluck)(chartAttr.targetcolor, colorM.getColor(PLOTFILLCOLOR_STR));
    conf.targetColor = (0, _lib.convertColor)(conf.rawTargetColor, targetalpha);

    dataSet._setConfigure();
  }
  /**
   * Configure data level attributes
   * @param {Object} newDataset updated JSON data
   */
  ;

  _proto._setConfigure = function _setConfigure(newDataset) {
    var dataSet = this,
        chart = dataSet.getFromEnv('chart'),
        conf = dataSet.config,
        JSONData = dataSet.config.JSONData,
        setDataArr = newDataset || JSONData.data,
        setDataLen = setDataArr && setDataArr.length,
        len = newDataset && newDataset.data.length || setDataLen,
        chartAttr = chart.getFromEnv('dataSource').chart,
        colorM = dataSet.getFromEnv('color-manager'),
        showplotborder = conf.showplotborder,
        showPlotBorderOnHover = conf.showPlotBorderOnHover,
        plotColor = conf.plotColor,
        // showTooltip = pluckNumber(chartAttr.showtooltip, 1),
    tooltipSepChar = (0, _lib.parseUnsafeString)((0, _lib.pluck)(chartAttr.tooltipsepchar, _lib.COMMASPACE)),
        seriesNameInTooltip = (0, _lib.pluckNumber)(chartAttr.seriesnameintooltip, 1),
        formatedVal,
        parserConfig,
        setTooltext,
        seriesname,
        macroIndices,
        tempPlotfillAngle,
        // toolText,
    plotDashLen,
        plotDashGap,
        plotBorderThickness = conf.plotBorderThickness,
        isRoundEdges = conf.isRoundEdges,
        showHoverEffect = conf.showHoverEffect,
        plotfillAngle = conf.plotFillAngle,
        plotFillAlpha,
        // plotRadius,
    plotFillRatio,
        // plotgradientcolor,
    plotBorderAlpha = conf.plotBorderAlpha,
        plotBorderDashStyle,
        initailPlotBorderDashStyle = conf.plotBorderDashStyle,
        setData,
        setValue,
        dataObj,
        config,
        // label,
    colorArr,
        hoverColor,
        hoverAlpha,
        hoverGradientColor,
        hoverRatio,
        hoverAngle,
        hoverBorderColor,
        hoverBorderAlpha,
        hoverBorderThickness,
        hoverBorderDashed,
        hoverBorderDashGap,
        hoverBorderDashLen,
        hoverDashStyle,
        hoverColorArr,
        dataStore = dataSet.components.data,
        toolTipValue,
        setDisplayValue,
        isBar = chart.isBar,
        is3D = chart.config.is3D,
        setDataDashed,
        setDataPlotDashLen,
        setDataPlotDashGap,
        i,
        maxValue = -Infinity,
        minValue = Infinity,
        numberFormatter = dataSet.getFromEnv('number-formatter'),
        target,
        hoverAttr,
        outAttr,
        targetHoverThickness,
        targetHoverColor,
        targetHoverAlpha,
        hasTargetHoverMix,
        setTooltextTarget,
        getTooltext = function getTooltext(tooltext) {
      var toolText;

      if (!conf.showTooltip) {
        toolText = false;
      } else {
        if (formatedVal === null) {
          toolText = false;
        } else if (tooltext !== UNDEF) {
          macroIndices = [1, 2, 3, 4, 5, 6, 7, 26, 27];
          parserConfig = {
            formattedValue: formatedVal,
            targetValue: config.target,
            targetDataValue: config.toolTipValueTarget
          };
          toolText = (0, _lib.parseTooltext)(tooltext, macroIndices, parserConfig, setData, chartAttr, JSONData);
        } else {
          if (seriesNameInTooltip) {
            seriesname = (0, _lib.getFirstValue)(JSONData && JSONData.seriesname);
          }

          toolText = seriesname ? seriesname + tooltipSepChar : _lib.BLANK;
          toolText += config.toolTipValue ? config.toolTipValue : _lib.BLANK;
        }
      }

      return toolText;
    };

    if (!dataStore) {
      dataStore = dataSet.components.data = [];
    } // Parsing the attributes and values at set level.


    for (i = 0; i < len; i++) {
      if (newDataset) {
        setData = newDataset && newDataset.data[i];
      } else {
        setData = setDataArr[i];
      }

      dataObj = dataStore[i];
      config = dataObj && dataObj.config;

      if (!dataObj) {
        dataObj = dataStore[i] = {};
      }

      if (!dataObj.config) {
        config = dataStore[i].config = {};
      }

      config.showValue = (0, _lib.pluckNumber)(setData.showvalue, conf.showValues);
      config.valuePadding = (0, _lib.pluckNumber)(chartAttr.valuepadding, 2);
      config.setValue = setValue = numberFormatter.getCleanValue(setData.value);
      config.target = target = numberFormatter.getCleanValue(setData.target);
      config.setLink = (0, _lib.pluck)(setData.link);
      config.toolTipValue = toolTipValue = numberFormatter.dataLabels(setValue);
      config.toolTipValueTarget = numberFormatter.dataLabels(target);
      config.setDisplayValue = setDisplayValue = (0, _lib.parseUnsafeString)(setData.displayvalue);
      config.displayValue = (0, _lib.pluck)(setData.label, setDisplayValue, toolTipValue);
      setDataDashed = (0, _lib.pluckNumber)(setData.dashed);
      setDataPlotDashLen = (0, _lib.pluckNumber)(setData.dashlen, plotDashLen);
      setDataPlotDashGap = plotDashGap = (0, _lib.pluckNumber)(setData.dashgap, plotDashGap);
      maxValue = mathMax(maxValue, setValue, target);
      minValue = mathMin(minValue, setValue, target);
      config.plotBorderDashStyle = plotBorderDashStyle = setDataDashed === 1 ? (0, _lib.getDashStyle)(setDataPlotDashLen, setDataPlotDashGap) : setDataDashed === 0 ? noneStr : initailPlotBorderDashStyle;
      plotColor = (0, _lib.pluck)(setData.color, conf.plotColor);
      plotFillAlpha = (0, _lib.pluck)(setData.alpha, conf.plotFillAlpha); // Setting the angle for plot fill for negative data

      if (setValue < 0 && !isRoundEdges) {
        tempPlotfillAngle = plotfillAngle;
        plotfillAngle = isBar ? 180 - plotfillAngle : 360 - plotfillAngle;
      } // Setting the color Array to be applied to the bar/column.


      config.colorArr = colorArr = (0, _lib.getColumnColor)(plotColor, plotFillAlpha, plotFillRatio, plotfillAngle, isRoundEdges, conf.plotBorderColor, plotBorderAlpha.toString(), isBar ? 1 : 0, !!is3D); // label = 'getValidValue(parseUnsafeString(pluck (categories[i].tooltext, categories[i].label)))';
      // Parsing the hover effects only if showhovereffect is not 0.

      if (showHoverEffect !== 0) {
        hoverColor = (0, _lib.pluck)(setData.hovercolor, JSONData.hovercolor, chartAttr.plotfillhovercolor, chartAttr.columnhovercolor, plotColor);
        hoverAlpha = (0, _lib.pluck)(setData.hoveralpha, JSONData.hoveralpha, chartAttr.plotfillhoveralpha, chartAttr.columnhoveralpha, plotFillAlpha);
        hoverGradientColor = (0, _lib.pluck)(setData.hovergradientcolor, JSONData.hovergradientcolor, chartAttr.plothovergradientcolor, conf.plotgradientcolor);
        !hoverGradientColor && (hoverGradientColor = _lib.BLANK);
        hoverRatio = (0, _lib.pluck)(setData.hoverratio, JSONData.hoverratio, chartAttr.plothoverratio, plotFillRatio);
        hoverAngle = (0, _lib.pluckNumber)(360 - setData.hoverangle, 360 - JSONData.hoverangle, 360 - chartAttr.plothoverangle, plotfillAngle);
        hoverBorderColor = (0, _lib.pluck)(setData.borderhovercolor, JSONData.borderhovercolor, chartAttr.plotborderhovercolor, chartAttr.plotfillhovercolor, conf.plotBorderColor);
        hoverBorderAlpha = (0, _lib.pluck)(setData.borderhoveralpha, JSONData.borderhoveralpha, chartAttr.plotborderhoveralpha, plotBorderAlpha, plotFillAlpha);
        hoverBorderThickness = (0, _lib.pluckNumber)(setData.borderhoverthickness, JSONData.borderhoverthickness, chartAttr.plotborderhoverthickness, plotBorderThickness);
        hoverBorderDashed = (0, _lib.pluckNumber)(setData.borderhoverdashed, JSONData.borderhoverdashed, chartAttr.plotborderhoverdashed);
        hoverBorderDashGap = (0, _lib.pluckNumber)(setData.borderhoverdashgap, JSONData.borderhoverdashgap, chartAttr.plotborderhoverdashgap, plotDashLen);
        hoverBorderDashLen = (0, _lib.pluckNumber)(setData.borderhoverdashlen, JSONData.borderhoverdashlen, chartAttr.plotborderhoverdashlen, plotDashGap);
        hoverDashStyle = hoverBorderDashed ? (0, _lib.getDashStyle)(hoverBorderDashLen, hoverBorderDashGap) : plotBorderDashStyle;
        /* If no hover effects are explicitly defined and
                     * showHoverEffect is not 0 then hoverColor is set.
                     */

        if (showHoverEffect === 1 && hoverColor === plotColor) {
          hoverColor = (0, _lib.getDarkColor)(hoverColor, 90);
        } // setting the hover color array which is always applied except when showHoverEffect is not 0.


        hoverColorArr = (0, _lib.getColumnColor)(hoverColor, hoverAlpha, hoverRatio, hoverAngle, isRoundEdges, hoverBorderColor, hoverBorderAlpha.toString(), isBar ? 1 : 0, false);
        config.setPlotRolloutAttr = {
          fill: !is3D ? (0, _lib.toRaphaelColor)(colorArr[0]) : [(0, _lib.toRaphaelColor)(colorArr[0]), !conf.use3DLighting],
          stroke: showplotborder && (0, _lib.toRaphaelColor)(colorArr[1]),
          'stroke-width': plotBorderThickness,
          'stroke-dasharray': plotBorderDashStyle
        };
        config.setPlotRolloverAttr = {
          fill: !is3D ? (0, _lib.toRaphaelColor)(hoverColorArr[0]) : [(0, _lib.toRaphaelColor)(hoverColorArr[0]), !conf.use3DLighting],
          stroke: (0, _lib.toRaphaelColor)(hoverColorArr[1]),
          'stroke-width': showPlotBorderOnHover ? hoverBorderThickness || 1 : hoverBorderThickness,
          'stroke-dasharray': hoverDashStyle
        };
      }

      if (showHoverEffect !== 0 && (showHoverEffect || chartAttr.targethovercolor || chartAttr.targethoveralpha || chartAttr.targethoveralpha === 0 || chartAttr.targethoverthickness || chartAttr.targethoverthickness === 0)) {
        showHoverEffect = true;
        hoverAttr = {};
        outAttr = {};
        targetHoverThickness = (0, _lib.pluckNumber)(chartAttr.targethoverthickness, conf.targetThickness + 2);

        if (conf.targetThickness !== targetHoverThickness) {
          hoverAttr['stroke-width'] = targetHoverThickness;
          outAttr['stroke-width'] = conf.targetThickness;
        }

        targetHoverColor = (0, _lib.pluck)(chartAttr.targethovercolor, FILLMIXDARK10);
        targetHoverAlpha = (0, _lib.pluckNumber)(chartAttr.targethoveralpha, conf.targetalpha);

        if (targetHoverThickness) {
          outAttr.stroke = conf.targetColor;
          hasTargetHoverMix = /\{/.test(targetHoverColor);
          hoverAttr.stroke = (0, _lib.convertColor)(hasTargetHoverMix ? colorM.parseColorMix((0, _lib.pluck)(chartAttr.targetcolor, plotColor), targetHoverColor)[0] : targetHoverColor, targetHoverAlpha);
        } // showHoverAnimation = !!pluckNumber(chartAttr.showhoveranimation, 1);


        config.tagetHoverAttr = hoverAttr;
        config.targetOutAttr = outAttr;
      }

      formatedVal = config.toolTipValue; // Parsing tooltext against various configurations provided by the user.

      setTooltext = (0, _lib.getValidValue)((0, _lib.parseUnsafeString)((0, _lib.pluck)(setData.tooltext, JSONData.plottooltext, chartAttr.plottooltext), false)); // if (!showTooltip) {
      //     toolText = false;
      // }
      // else {
      //     if (formatedVal === null) {
      //         toolText = false;
      //     }
      //     else if (setTooltext !== UNDEF) {
      //         macroIndices = [1,2,3,4,5,6,7,26,27];
      //         parserConfig = {
      //             formattedValue : formatedVal,
      //             targetValue : config.target,
      //             targetDataValue : config.toolTipValueTarget
      //         };
      //         toolText = parseTooltext(setTooltext, macroIndices,
      //             parserConfig, setData, chartAttr, JSONData);
      //     }
      //     else {
      //         if (seriesNameInTooltip) {
      //             seriesname = getFirstValue(JSONData && JSONData.seriesname);
      //         }
      //         toolText = seriesname ? seriesname + tooltipSepChar : BLANK;
      //         toolText += label ? label + tooltipSepChar : BLANK;
      //     }
      // }

      config.toolText = getTooltext(setTooltext);
      config.setTooltext = config.toolText;
      tempPlotfillAngle && (plotfillAngle = tempPlotfillAngle);
      setTooltextTarget = (0, _lib.getValidValue)((0, _lib.parseUnsafeString)((0, _lib.pluck)(setData.tooltexttarget, JSONData.targettooltext, chartAttr.targettooltext), false));
      config.toolTextTarget = getTooltext(setTooltextTarget);
    }

    conf.maxValue = maxValue;
    conf.minValue = minValue;
  }
  /**
   * Calculates vertical space management of bullet plot
   * @param {number} availableHeight maximum available height plot can take
   * @return {Object} height needed for bullet plot
   */
  ;

  _proto._manageSpace = function _manageSpace(availableHeight) {
    var dataSet = this,
        conf = dataSet.config,
        dataStore = dataSet.components.data,
        dataObj,
        chart = dataSet.getFromEnv('chart'),
        // captionConfig = chart.getChildren('caption')[0].config,
    // components = dataSet.components,
    chartConfig = chart.config,
        // datasetConfig = dataSet.config,
    smartLabel = chart.getFromEnv('smartLabel'),
        // canvasWidth = chartConfig.canvasWidth,
    smartDataLabel,
        style = chartConfig.dataLabelStyle,
        lineHeight = (0, _lib.pluckNumber)(parseInt(style.lineHeight, 10), 12),
        maxAllowedHeight = availableHeight,
        valuePadding = conf.valuePadding,
        // valuePaddingWithRadius,
    heightUsed = 0,
        // heightReducedBottom = 0, heightReducedTop = 0,
    // tickDimension = 0,
    i = 0,
        len = 1,
        // pointerOnOpp = datasetConfig.pointerOnOpp,
    config; // setData = setDataArr[i];

    dataObj = dataStore[i];
    config = dataObj && dataObj.config;
    smartLabel.useEllipsesOnOverflow(chartConfig.useEllipsesWhenOverflow);
    smartLabel.setStyle(style);

    for (; i < len; i += 1) {
      if (conf.showValue) {
        smartDataLabel = smartLabel.getOriSize(config.toolTipValue); // special fix for space string

        /** @todo will be removed when smartLabel will be able to handle it */

        if (config.toolTipValue === _lib.BLANK) {
          smartDataLabel = {
            height: lineHeight
          };
        }

        if (smartDataLabel.height > 0) {
          heightUsed = smartDataLabel.height + valuePadding;
        }

        if (heightUsed > maxAllowedHeight) {
          // extraSpace = heightUsed - maxAllowedHeight;
          heightUsed = maxAllowedHeight;
        }
      }
    } // captionConfig.widgetValueHeight = heightUsed;


    conf.heightUsed = heightUsed;
    return {
      top: 0,
      bottom: heightUsed
    };
  }
  /**
   * Calculates horizontal space management of bullet plot
   * @param {number} availableWidth maximum available width plot can take
   * @return {Object} width needed for bullet plot
   */
  ;

  _proto._manageSpaceHorizontal = function _manageSpaceHorizontal(availableWidth) {
    var dataSet = this,
        conf = dataSet.config,
        // JSONData = dataSet.JSONData,
    // setDataArr = JSONData.data,
    dataStore = dataSet.components.data,
        dataObj,
        chart = dataSet.getFromEnv('chart'),
        // components = dataSet.components,
    chartConfig = chart.config,
        // datasetConfig = dataSet.config,
    smartLabel = chart.getFromEnv('smartLabel'),
        // canvasWidth = chartConfig.canvasWidth,
    smartDataLabel,
        style = chartConfig.dataLabelStyle,
        lineHeight = (0, _lib.pluckNumber)(parseInt(style.lineHeight, 10), 12),
        maxAllowedWidth = availableWidth,
        valuePadding = conf.valuePadding,
        // valuePaddingWithRadius,
    widthUsed = 0,
        i = 0,
        len = 1,
        config; // setData = setDataArr[i];

    dataObj = dataStore[i];
    config = dataObj && dataObj.config;
    smartLabel.useEllipsesOnOverflow(chartConfig.useEllipsesWhenOverflow);
    smartLabel.setStyle(style);

    for (; i < len; i += 1) {
      // config = components[i].config;
      if (config && config.displayValue !== BLANKSTRING && config.displayValue !== UNDEF) {
        if (conf.showValue) {
          smartDataLabel = smartLabel.getOriSize(config.displayValue); // special fix for space string

          /** @todo will be removed when smartLabel will be able to handle it */

          if (config.displayValue === _lib.BLANK) {
            smartDataLabel = {
              height: lineHeight
            };
          }

          if (smartDataLabel.height > 0) {
            widthUsed = smartDataLabel.width + valuePadding + 2;
          }

          if (widthUsed > maxAllowedWidth) {
            // extraSpace = widthUsed - maxAllowedWidth;
            widthUsed = maxAllowedWidth;
          }
        }
      }
    }

    conf.widthUsed = widthUsed;
    return {
      top: 0,
      right: widthUsed
    };
  }
  /**
   * Update data with new JSON
   * @param {Object} dataObj updated parsd JSON
   * @param {number} index dataset index
   * @param {boolean} draw decides whether to draw datset instantly or not
   */
  ;

  _proto.updateData = function updateData(dataObj, index, draw) {
    var dataSet = this,
        conf = dataSet.config,
        prevMax = conf.maxValue,
        prevMin = conf.prevMin,
        chart = dataSet.getFromEnv('chart'),
        drawManager = dataSet.groupManager || dataSet,
        scale = dataSet.getFromEnv('scale');

    dataSet._setConfigure(dataObj, index);

    dataSet.setMaxMin();

    if (conf.maxValue !== prevMax || conf.minValue !== prevMin) {
      dataSet.config.maxminFlag = true;
    }

    if (draw) {
      chart._setAxisLimits();

      scale.draw();
      drawManager.draw();
    }
  }
  /**
   * Get the max and min of data during real time update
   */
  ;

  _proto.setMaxMin = function setMaxMin() {
    var dataSet = this,
        dataStore = dataSet.components.data,
        conf = dataSet.config,
        i,
        config,
        len = dataStore.length,
        maxValue = -Infinity,
        minValue = +Infinity;

    for (i = 0; i < len; i++) {
      if (!dataStore[i]) {
        continue;
      }

      config = dataStore[i].config;
      maxValue = mathMax(maxValue, config.setValue, config.target);
      minValue = mathMin(minValue, config.setValue, config.target);
    }

    conf.maxValue = maxValue;
    conf.minValue = minValue;
  }
  /**
   * Draws bullet plot background
   */
  ;

  _proto.draw = function draw() {
    var dataSet = this,
        chart = dataSet.getFromEnv('chart'),
        chartAttr = chart.getFromEnv('dataSource').chart,
        chartConfig = chart.config,
        canvas = chart.getChildren('canvas')[0],
        config = canvas.config,
        colorRangeElems = dataSet.getGraphicalElement('backgroundRect') || [],
        canvasLeft = chartConfig.canvasLeft,
        canvasTop = chartConfig.canvasTop,
        canvasWidth = chartConfig.canvasWidth,
        canvasHeight = chartConfig.canvasHeight,
        parentContainer = canvas.getContainer('canvasGroup'),
        attr,
        scale = dataSet.getFromEnv('scale'),
        min = scale.getLimit().min,
        max = scale.getLimit().max,
        isHorizontal = chart.isHorizontal,
        getRectXY = function getRectXY(minValue, maxValue) {
      if (!isHorizontal) {
        return {
          x: canvasLeft,
          y: canvasTop + (canvasHeight - maxValue * canvasHeight / (max - min)),
          width: canvasWidth,
          height: (maxValue - minValue) * canvasHeight / (max - min)
        };
      } else if (isHorizontal) {
        return {
          x: canvasLeft + minValue * canvasWidth / (max - min),
          y: canvasTop,
          width: (maxValue - minValue) * canvasWidth / (max - min),
          height: canvasHeight
        };
      }
    },
        angle,
        gaugeFillMix,
        gaugeFillRatio,
        colorRangeGetter,
        colorArray,
        colorM = dataSet.getFromEnv('color-manager'),
        gaugeBorderColor,
        gaugeBorderAlpha,
        showShadow,
        showGaugeBorder,
        gaugeBorderThickness,
        colorObj,
        i,
        count,
        len,
        xyObj,
        color,
        borderColor,
        crColor,
        crAlpha,
        borderAlpha,
        shadowAlpha,
        animationManager = chart.getFromEnv('animationManager'),
        colorRangeElem;

    angle = isHorizontal ? 270 : 180;
    config.colorRangeFillMix = gaugeFillMix = (0, _lib.getFirstDefinedValue)(chartAttr.colorrangefillmix, chartAttr.gaugefillmix, chart.colorRangeFillMix, '{light-10},{dark-10},{light-10},{dark-10}');
    config.colorRangeFillRatio = gaugeFillRatio = (0, _lib.getFirstDefinedValue)(chartAttr.colorrangefillratio, chartAttr.gaugefillratio, chart.colorRangeFillRatio, chartAttr.gaugefillratio, '0,10,80,10'); // Fetch colorRange from env

    config.colorRangeGetter = colorRangeGetter = chart.getFromEnv('colorRange');
    config.colorArray = colorArray = colorRangeGetter && colorRangeGetter.getColorRangeArr(min, max);
    gaugeBorderColor = (0, _lib.pluck)(chartAttr.colorrangebordercolor, chartAttr.gaugebordercolor, '{dark-20}');
    gaugeBorderAlpha = (0, _lib.pluckNumber)(chartAttr.colorrangeborderalpha, chartAttr.gaugeborderalpha, 100);
    showShadow = (0, _lib.pluckNumber)(chartAttr.showshadow, 1);
    showGaugeBorder = (0, _lib.pluckNumber)(chartAttr.showgaugeborder, chartAttr.showcolorrangeborder, 0);
    config.colorRangeBorderThickness = gaugeBorderThickness = showGaugeBorder ? (0, _lib.pluckNumber)(chartAttr.colorrangeborderthickness, chartAttr.gaugeborderthickness, 2) : 0;
    len = chart.getFromEnv('dataSource').colorrange && colorArray && colorArray.length || 0;

    for (i = 0, count = 0; i < len; i += 1) {
      colorObj = colorArray[i];
      xyObj = getRectXY(colorObj.minvalue - min, colorObj.maxvalue - min);
      colorObj.x = xyObj.x;
      colorObj.y = xyObj.y;
      colorObj.width = xyObj.width;
      colorObj.height = xyObj.height;
      color = colorObj.code;
      borderColor = (0, _lib.convertColor)((0, _lib.getColorCodeString)((0, _lib.pluck)(colorObj.bordercolor, color), gaugeBorderColor), (0, _lib.pluckNumber)(colorObj.borderalpha, gaugeBorderAlpha)); // create the shadow element

      crColor = colorM.parseColorMix(colorObj.code, gaugeFillMix);
      crAlpha = colorM.parseAlphaList(colorObj.alpha, crColor.length);
      borderAlpha = (0, _lib.pluckNumber)(colorObj.borderAlpha, gaugeBorderAlpha);
      shadowAlpha = crAlpha.split(_lib.COMMASTRING);
      shadowAlpha = mathMax.apply(Math, shadowAlpha);
      shadowAlpha = mathMax(gaugeBorderThickness && borderAlpha || 0, shadowAlpha);
      attr = {
        x: xyObj.x,
        y: xyObj.y,
        width: xyObj.width,
        height: xyObj.height,
        r: 0,
        'stroke-width': gaugeBorderThickness,
        stroke: borderColor,
        'fill': (0, _lib.toRaphaelColor)({
          FCcolor: {
            color: crColor.toString(),
            ratio: gaugeFillRatio,
            alpha: crAlpha,
            angle: angle
          }
        })
      }; // Create/reuse colorRange elements

      colorRangeElem = animationManager.setAnimation({
        el: colorRangeElems[i] || 'rect',
        attr: attr,
        container: parentContainer,
        component: dataSet,
        doNotRemove: true,
        label: 'backgroundRect'
      });
      !colorRangeElems[i] && dataSet.addGraphicalElement('backgroundRect', colorRangeElem, true);
      colorRangeElem.show();
      colorRangeElem.shadow({
        apply: showShadow,
        opacity: shadowAlpha / 100
      });
      count++;
    } // hide the remaining color range elements


    len = colorRangeElems && colorRangeElems.length;

    while (len > count) {
      colorRangeElems && colorRangeElems[len - 1] && dataSet.removeGraphicalElement(colorRangeElems[len - 1]);
      len--;
    }

    dataSet.drawPlot();
  }
  /**
   * Draws bullet plot
   */
  ;

  _proto.drawPlot = function drawPlot() {
    var dataSet = this,
        conf = dataSet.config,
        attr,
        i,
        visible = dataSet.getState('visible'),
        chart = dataSet.getFromEnv('chart'),
        caption = chart.getChildren('caption')[0],
        subCaption = chart.getChildren('subCaption')[0],
        captionHeight = caption && caption.config.text && caption.config.height || 0,
        captionPadding = caption && caption.config.text && caption.config.captionPadding || 0,
        subCaptionHeight = subCaption && subCaption.config.text && subCaption.config.height || 0,
        toolTipController = dataSet.getFromEnv('toolTipController'),
        chartConfig = chart.config,
        canvasLeft = chartConfig.canvasLeft,
        canvasRight = chartConfig.canvasRight,
        canvasTop = chartConfig.canvasTop,
        canvasBottom = chartConfig.canvasBottom,
        canvasHeight = chartConfig.canvasHeight,
        canvasWidth = chartConfig.canvasWidth,
        smartLabel = dataSet.getFromEnv('smartLabel'),
        scale = dataSet.getFromEnv('scale'),
        eventArguments,
        parentContainer = chart.getChildContainer().plotGroup,
        xPos,
        yPos,
        crispBox,
        R = Raphael,
        showTooltip = conf.showTooltip,
        dataLabelTooltip,
        dataLabelObj,
        columnWidth,
        height,
        toolText,
        dataStore = dataSet.components.data,
        dataObj,
        setElement,
        setLink,
        setValue,
        displayValue,
        groupId,
        config,
        showShadow = conf.showShadow,
        plotBorderThickness = conf.plotBorderThickness,
        plotRadius = conf.plotRadius,
        containerDummy = dataSet.getContainer('container'),
        container,
        targetContainerDummy = dataSet.getContainer('targetContainer'),
        targetContainer,
        dataLabelContainerDummy = dataSet.getContainer('dataLabelContainer'),
        dataLabelContainer,
        shadowContainerDummy = dataSet.getContainer('shadowContainer'),
        shadowContainer,
        shadowTargetContainerDummy = dataSet.getContainer('shadowTargetContainer'),
        shadowTargetContainer,
        colorArr,
        plotBorderDashStyle,
        isNegative = false,
        targetPath,
        targetLength,
        startX,
        endX,
        startY,
        endY,
        initialColumnWidth,
        dataLabelsLayer = chart.getChildContainer('datalabelsGroup'),
        style = chart.config.dataLabelStyle,
        animationManager = chart.getFromEnv('animationManager'),
        heightUsed = conf.heightUsed,
        lineHeight,
        labelBBox,
        labelWidth,
        isNewTargetElem,
        lowerLimit = conf.lowerLimit,
        base,
        labelAttr,
        targetAttr,
        targetElement,
        showHoverEffect = conf.showHoverEffect,
        // Fired when clicked over the hot elements.
    clickFunc = function clickFunc(setDataArr) {
      var ele = this;
      chart.plotEventHandler(ele, setDataArr);
    },
        // Fired on mouse-in over the hot elements.
    rolloverResponseSetter = function rolloverResponseSetter(elem) {
      return function (data) {
        var ele = this;

        if (ele.data(showHoverEffectStr) !== 0) {
          elem.attr(ele.data(SETROLLOVERATTR));
        }

        chart.plotEventHandler(ele, data, ROLLOVER);
      };
    },
        // Fired on mouse-out over the hot elements.
    rolloutResponseSetter = function rolloutResponseSetter(elem) {
      return function (data) {
        var ele = this;

        if (ele.data(showHoverEffectStr) !== 0) {
          elem.attr(ele.data(SETROLLOUTATTR));
        }

        chart.plotEventHandler(ele, data, ROLLOUT);
      };
    },
        hideFn = function hideFn() {
      this.hide();
    };
    /*
    * Creating a container group for the graphic element of bar plots if
    * not present and attaching it to its parent group.
    */


    container = animationManager.setAnimation({
      el: containerDummy || 'group',
      attr: {
        name: 'bar'
      },
      component: dataSet,
      container: parentContainer,
      doNotRemove: true,
      label: 'group'
    });

    if (!containerDummy) {
      container = dataSet.addContainer('container', container);
    }

    dataLabelContainer = animationManager.setAnimation({
      el: dataLabelContainerDummy || 'group',
      attr: {
        name: 'datalabel'
      },
      component: dataSet,
      container: dataLabelsLayer,
      doNotRemove: true,
      label: 'labelGroup'
    });

    if (!dataLabelContainerDummy) {
      dataLabelContainer = dataSet.addContainer('dataLabelContainer', dataLabelContainer);
    }

    targetContainer = animationManager.setAnimation({
      el: targetContainerDummy || 'group',
      attr: {
        name: 'target'
      },
      container: parentContainer,
      doNotRemove: true,
      component: dataSet,
      label: 'group'
    });

    if (!targetContainerDummy) {
      targetContainer = dataSet.addContainer('targetContainer', targetContainer);
    }
    /*
    * Creating the shadow element container group for each plots if not present
    * and attaching it its parent group.
    */


    shadowContainer = animationManager.setAnimation({
      el: shadowContainerDummy || 'group',
      attr: {
        name: 'shadow'
      },
      component: dataSet,
      container: parentContainer,
      doNotRemove: true,
      label: 'group'
    });

    if (!shadowContainerDummy) {
      // Always sending the shadow group to the back of the plots group.
      shadowContainer = dataSet.addContainer('shadowContainer', shadowContainer.toBack());

      if (!visible) {
        shadowContainer.hide();
      }
    }

    shadowTargetContainer = animationManager.setAnimation({
      el: shadowTargetContainerDummy || 'group',
      attr: {
        name: 'shadow'
      },
      component: dataSet,
      container: parentContainer,
      doNotRemove: true,
      label: 'group'
    });

    if (!shadowTargetContainerDummy) {
      // Always sending the shadow group to the back of the plots group.
      shadowTargetContainer = dataSet.addContainer('shadowTargetContainer', shadowTargetContainer.toBack());

      if (!visible) {
        shadowTargetContainer.hide();
      }
    }

    smartLabel.setStyle(style); // Create plot elements.

    for (i = 0; i < 1; i++) {
      dataObj = dataStore[i];
      config = dataObj && dataObj.config;
      setValue = config.setValue;
      setValue < 0 && (isNegative = true);
      setLink = config.setLink;
      colorArr = config.colorArr; // isNewElem = false;

      isNewTargetElem = false; // Creating the data structure if not present for storing the graphics elements.

      if (!dataObj.graphics) {
        dataStore[i].graphics = {};
      }

      displayValue = config.displayValue;

      if (!chart.isHorizontal) {
        initialColumnWidth = conf.plotFillPercent / 100 * canvasWidth;
        xPos = mathAbs(canvasLeft + canvasRight) / 2 - initialColumnWidth / 2;

        if (conf.plotAsDot) {
          yPos = scale.getPixel(setValue) - initialColumnWidth / 2;
          height = initialColumnWidth;
        } else {
          conf.base = base = lowerLimit && lowerLimit <= setValue && scale.config.axisRange.min >= 0 ? lowerLimit : 0;
          yPos = isNegative ? scale.getPixel(0) : scale.getPixel(setValue);
          height = isNegative ? scale.getPixel(setValue) - scale.getPixel(0) : scale.getPixel(lowerLimit && lowerLimit <= setValue && scale.config.axisRange.min >= 0 ? lowerLimit : 0) - yPos;
        }

        crispBox = R.crispBound(xPos, yPos, initialColumnWidth, height, plotBorderThickness);
        xPos = crispBox.x;
        yPos = crispBox.y;
        columnWidth = crispBox.width;
        height = crispBox.height; // Setting the final tooltext.

        toolText = config.toolText === _lib.BLANK ? config.toolTipValue : config.toolText;
        plotBorderDashStyle = config.plotBorderDashStyle;
        /*
        * If animation is inactive then ybase position and heightBase of the plots is set to the final
        * values.
        */
        // Setting the attributes for plot drawing.

        attr = {
          x: xPos,
          y: yPos,
          width: columnWidth,
          height: height || 1,
          r: plotRadius,
          fill: (0, _lib.toRaphaelColor)(colorArr[0]),
          stroke: (0, _lib.toRaphaelColor)(colorArr[1]),
          'stroke-width': plotBorderThickness,
          'stroke-dasharray': plotBorderDashStyle,
          'stroke-linejoin': miterStr,
          'visibility': visible
        }; // todo- remove _ to make it public

        dataObj._xPos = xPos;
        dataObj._yPos = yPos + height;
        dataObj._height = height;
        dataObj._width = columnWidth;

        if (setValue !== null) {
          dataObj.graphics.element && dataObj.graphics.element.show();

          if (setLink || showTooltip) {
            // Fix for touch devices.
            if (height < HTP) {
              yPos -= (HTP - height) / 2;
              height = HTP;
            }
          }
        }
        /*
        * If the data plots are not present then they are
        * created, else only attributes are set for the
        * existing plots.
        */


        config.elemCreated = dataObj.graphics.element !== UNDEF;

        if (setValue) {
          setElement = dataObj.graphics.element = animationManager.setAnimation({
            el: dataObj.graphics.element || 'rect',
            attr: attr,
            container: container,
            component: dataSet,
            label: 'plotRect'
          });
        } else {
          dataObj.graphics.element && animationManager.setAnimation({
            el: dataObj.graphics.element,
            label: 'plotRect',
            doNotRemove: true,
            callback: hideFn,
            component: dataSet
          });
        }

        setElement && setElement.shadow({
          opacity: showShadow
        }, shadowContainer).data('BBox', crispBox); // Draw target element

        if (config.target) {
          toolText = config.toolTipValueTarget;
          targetLength = conf.targetFillPercent / 100 * canvasWidth;
          startX = (canvasLeft + canvasRight) / 2 - targetLength / 2;
          endX = startX + targetLength;
          startY = endY = scale.getPixel(config.target);
          targetPath = [M, startX, startY, L, endX, endY];
          targetAttr = {
            stroke: conf.targetColor,
            'stroke-width': conf.targetThickness,
            'stroke-linecap': conf.targetCapStyle,
            path: targetPath,
            'shape-rendering': DECIDE_CRISPENING[3 < 1]
          };
          dataObj.graphics.targetElement && dataObj.graphics.targetElement.show();
        }

        isNewTargetElem = dataObj.graphics.targetElement === UNDEF;
        targetElement = dataObj.graphics.targetElement = animationManager.setAnimation({
          el: dataObj.graphics.targetElement || 'path',
          attr: targetAttr,
          container: targetContainer,
          component: dataSet,
          doNotRemove: true,
          callback: config.target ? _lib.stubFN : hideFn,
          label: 'path'
        });
        lineHeight = parseInt(style.lineHeight, 10);
        yPos = lineHeight > heightUsed ? chartConfig.height - chartConfig.marginBottom - heightUsed + lineHeight / 2 : chartConfig.height - chartConfig.marginBottom - lineHeight / 2;
        yPos -= chartConfig.borderWidth;
        yPos -= (chart._manageActionBarSpace && chart._manageActionBarSpace(config.availableHeight * 0.225) || {}).bottom;

        if (caption.config.isOnTop === 0) {
          yPos -= captionHeight + subCaptionHeight + captionPadding;
        } // Draw Label


        if (displayValue !== BLANKSTRING && displayValue !== UNDEF && conf.showValue) {
          dataLabelObj = smartLabel.getSmartText(displayValue, chartConfig.width, heightUsed);
          displayValue = dataLabelObj.text;
          dataLabelTooltip = dataLabelObj.tooltext || BLANKSTRING;
          labelAttr = {
            text: displayValue,
            'text-anchor': POSITION_MIDDLE,
            x: canvasWidth / 2 + canvasLeft,
            y: yPos,
            'vertical-align': POSITION_MIDDLE,
            fill: style.color,
            direction: config.textDirection,
            'text-bound': [style.backgroundColor, style.borderColor, style.borderThickness, style.borderPadding, style.borderRadius, style.borderDash]
          };
          dataObj.graphics.label && dataObj.graphics.label.show();
        }

        dataObj.graphics.label = animationManager.setAnimation({
          el: dataObj.graphics.label || 'text',
          attr: labelAttr,
          component: dataSet,
          container: dataLabelContainer,
          doNotRemove: true,
          callback: !!displayValue && conf.showValue ? _lib.stubFN : hideFn,
          label: 'text'
        }); // Adjusting the chart label if goes out side the chart area
        // we try to keep the label inside viewport

        labelBBox = dataObj.graphics.label.getBBox();

        if (labelBBox.x + chartConfig.marginLeft < 0) {
          labelWidth = labelBBox.width - chartConfig.marginLeft;

          if (chartConfig.width < labelWidth) {
            labelWidth = chartConfig.width - chartConfig.marginLeft;
          }

          labelAttr.x = labelWidth / 2;
          animationManager.setAnimation({
            el: dataObj.graphics.label,
            attr: labelAttr,
            component: dataSet,
            doNotRemove: true,
            callback: !!displayValue && conf.showValue ? _lib.stubFN : hideFn,
            label: 'text'
          });
        }
      } else {
        height = conf.plotFillPercent / 100 * canvasHeight;
        yPos = mathAbs(canvasTop + canvasBottom) / 2 - height / 2;

        if (conf.plotAsDot) {
          xPos = scale.getPixel(setValue) - height / 2;
          initialColumnWidth = height;
        } else {
          base = lowerLimit && lowerLimit <= setValue && scale.config.axisRange.min >= 0 ? lowerLimit : 0;
          xPos = isNegative ? scale.getPixel(setValue) : scale.getPixel(base);
          initialColumnWidth = isNegative ? scale.getPixel(0) - scale.getPixel(setValue) : scale.getPixel(setValue) - scale.getPixel(base);
        }

        crispBox = R.crispBound(xPos, yPos, initialColumnWidth, height, plotBorderThickness);
        xPos = crispBox.x;
        yPos = crispBox.y;
        columnWidth = crispBox.width;
        height = crispBox.height; // Setting the final tooltext.

        toolText = config.toolText === _lib.BLANK ? config.toolTipValue : config.toolText;
        plotBorderDashStyle = config.plotBorderDashStyle; // Setting the attributes for plot drawing.

        attr = {
          x: xPos,
          y: yPos,
          width: columnWidth || 1,
          height: height,
          r: plotRadius,
          fill: (0, _lib.toRaphaelColor)(colorArr[0]),
          stroke: (0, _lib.toRaphaelColor)(colorArr[1]),
          'stroke-width': plotBorderThickness,
          'stroke-dasharray': plotBorderDashStyle,
          'stroke-linejoin': miterStr,
          'visibility': visible
        };

        if (setValue !== null) {
          dataObj.graphics.element && dataObj.graphics.element.show();

          if (setLink || showTooltip) {
            // Fix for touch devices.
            if (height < HTP) {
              yPos -= (HTP - height) / 2;
              height = HTP;
            }
          }
        }
        /*
        * If the data plots are not present then they are created,
        * else only attributes are set for the
        * existing plots.
        */


        config.elemCreated = dataObj.graphics.element !== UNDEF;

        if (setValue) {
          setElement = dataObj.graphics.element = animationManager.setAnimation({
            el: dataObj.graphics.element || 'rect',
            attr: attr,
            container: container,
            component: dataSet,
            label: 'plotRect'
          });
        } else {
          dataObj.graphics.element && animationManager.setAnimation({
            el: dataObj.graphics.element,
            component: dataSet,
            doNotRemove: true,
            callback: hideFn,
            label: 'plotRect'
          });
        }

        setElement && setElement.shadow({
          opacity: showShadow
        }, shadowContainer).data('BBox', crispBox); // Draw target element

        if (config.target) {
          toolText = config.toolTipValueTarget;
          targetLength = conf.targetFillPercent / 100 * canvasHeight;
          startX = endX = scale.getPixel(config.target);
          startY = (canvasTop + canvasBottom) / 2 - targetLength / 2;
          endY = startY + targetLength;
          targetPath = [M, startX, startY, L, endX, endY];
          targetAttr = {
            stroke: conf.targetColor,
            'stroke-width': conf.targetThickness,
            'stroke-linecap': conf.targetCapStyle,
            path: targetPath,
            'shape-rendering': DECIDE_CRISPENING[3 < 1]
          };
          dataObj.graphics.targetElement && dataObj.graphics.targetElement.show();
        }

        isNewTargetElem = dataObj.graphics.targetElement === UNDEF;
        targetElement = dataObj.graphics.targetElement = animationManager.setAnimation({
          el: dataObj.graphics.targetElement || 'path',
          attr: targetAttr,
          container: targetContainer,
          component: dataSet,
          doNotRemove: true,
          callback: config.target ? _lib.stubFN : hideFn,
          label: 'path'
        });
        config.target && (setElement = dataObj.graphics.targetElement);
        lineHeight = parseInt(style.lineHeight, 10);
        yPos = (canvasTop + canvasHeight) * 0.5; // Draw Label

        if (displayValue !== BLANKSTRING && displayValue !== UNDEF && conf.showValue) {
          dataLabelObj = smartLabel.getSmartText(displayValue, conf.widthUsed, chartConfig.height);
          displayValue = dataLabelObj.text;
          dataLabelTooltip = dataLabelObj.tooltext;
          labelAttr = {
            text: displayValue,
            'text-anchor': POSITION_START,
            x: canvasRight + conf.valuePadding + 2,
            y: yPos,
            'vertical-align': _lib.POSITION_TOP,
            fill: style.color,
            direction: config.textDirection,
            'text-bound': [style.backgroundColor, style.borderColor, style.borderThickness, style.borderPadding, style.borderRadius, style.borderDash]
          };
          dataObj.graphics.label && dataObj.graphics.label.show();
        }

        dataObj.graphics.label = animationManager.setAnimation({
          el: dataObj.graphics.label || 'text',
          attr: labelAttr,
          component: dataSet,
          container: dataLabelContainer,
          doNotRemove: true,
          callback: !!displayValue && conf.showValue ? _lib.stubFN : hideFn,
          label: 'text'
        }); // Adjusting the chart label if goes out side the chart area
        // we try to keep the label inside viewport

        labelBBox = dataObj.graphics.label.getBBox();

        if (labelBBox.x + chartConfig.marginLeft < 0) {
          labelWidth = labelBBox.width - chartConfig.marginLeft;

          if (chartConfig.width < labelWidth) {
            labelWidth = chartConfig.width - chartConfig.marginLeft;
          }

          labelAttr.x = labelWidth / 2;
          animationManager.setAnimation({
            el: dataObj.graphics.label,
            attr: labelAttr,
            component: dataSet,
            doNotRemove: true,
            callback: !!displayValue && conf.showValue ? _lib.stubFN : hideFn,
            label: 'text'
          });
        }
      }

      eventArguments = {
        showValue: conf.showValue,
        plotAsDot: conf.plotAsDot,
        plotFillPercent: conf.plotFillPercent,
        plotFillColor: conf.plotColor,
        plotFillAlpha: conf.plotFillAlpha,
        showPlotBorder: conf.showplotborder,
        plotBorderColor: conf.plotBorderColor,
        plotBorderThickness: conf.plotBorderThickness,
        plotBorderAlpha: conf.plotBorderAlpha,
        target: config.target,
        targetColor: conf.rawTargetColor,
        targetThickness: conf.targetThickness,
        targetFillPercent: conf.targetFillPercent,
        targetCapStyle: conf.targetCapStyle
      };

      if (dataObj.graphics.element) {
        dataObj.graphics.element.data(showHoverEffectStr, showHoverEffect).data(SETROLLOVERATTR, config.setPlotRolloverAttr || {}).data(SETROLLOUTATTR, config.setPlotRolloutAttr || {}).data(EVENTARGS, eventArguments);

        if (!config.elemCreated) {
          dataObj.graphics.element.on('fc-click', clickFunc).hover(rolloverResponseSetter(dataObj.graphics.element), rolloutResponseSetter(dataObj.graphics.element));
        }

        if (showTooltip) {
          toolTipController.enableToolTip(targetElement, toolText);
          toolTipController.enableToolTip(dataObj.graphics.element, config.toolText);
          toolTipController.enableToolTip(dataObj.graphics.label, dataLabelTooltip);
        } else {
          toolTipController.disableToolTip(targetElement);
          toolTipController.disableToolTip(dataObj.graphics.element);
          toolTipController.disableToolTip(dataObj.graphics.label);
        }
      } else if (showTooltip && (setValue === 0 || setValue === null)) {
        toolTipController.enableToolTip(targetElement, toolText);
        toolTipController.enableToolTip(dataObj.graphics.label, dataLabelTooltip);
      }

      if (isNewTargetElem) {
        targetElement.on('fc-click', clickFunc).hover(rolloverResponseSetter(targetElement), rolloutResponseSetter(targetElement));
      }

      targetElement.shadow({
        opacity: showShadow
      }, shadowContainer).data('BBox', crispBox).data(EVENTARGS, eventArguments).data(GROUPID, groupId).data(showHoverEffectStr, showHoverEffect).data(SETROLLOVERATTR, config.tagetHoverAttr).data(SETROLLOUTATTR, config.targetOutAttr);
    }
  }
  /**
   * Calculates data limit of dataset
   * @return {Object} maximum, minimum limit
   */
  ;

  _proto.getDataLimits = function getDataLimits() {
    var dataSet = this,
        config = dataSet.config,
        pointerArr = dataSet.pointerArr && dataSet.pointerArr.pointer,
        colorRange = dataSet.getFromEnv('chart').getFromEnv('dataSource').colorrange,
        colorArr = colorRange && colorRange.color,
        length = pointerArr && pointerArr.length,
        i,
        upperLimit = config.upperLimit,
        lowerLimit = config.lowerLimit,
        maxColorRangeVal,
        minColorRangeVal,
        max = config.maxValue,
        min = config.minValue;
    length = colorArr && colorArr.length; // finding max min amongst the color range value
    // but it has a lower priority than upperlimit and lowerlimit
    // set by the user.

    for (i = 0; i < length; i++) {
      maxColorRangeVal = Number(colorArr[i].maxvalue);
      minColorRangeVal = Number(colorArr[i].minvalue);
      upperLimit && maxColorRangeVal > upperLimit && (maxColorRangeVal = upperLimit);
      lowerLimit && minColorRangeVal < lowerLimit && (minColorRangeVal = lowerLimit);
      max = mathMax(max, maxColorRangeVal);
      min = mathMin(lowerLimit, minColorRangeVal);
    }

    return {
      forceMin: true,
      forceMax: true,
      max: max,
      min: min
    };
  };

  return BulletDataset;
}(_componentInterface.ComponentInterface);

var _default = BulletDataset;
exports["default"] = _default;

/***/ }),

/***/ 1495:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



exports.__esModule = true;
exports["default"] = void 0;

var _lib = __webpack_require__(274);

var fadeEffect = [{
  initialAttr: function initialAttr() {
    return {
      opacity: 0
    };
  },
  finalAttr: function finalAttr() {
    return {
      opacity: 1
    };
  }
}];
var _default = {
  'initial.dataset.cylinder': function initialDatasetCylinder() {
    var component = this,
        conf = component.config;
    return {
      'plotFluid.appearing': function plotFluidAppearing(input) {
        var pathArr = input.attr.path.slice(0);
        pathArr[13] = pathArr[21] = pathArr[2];
        return [{
          initialAttr: {
            opacity: 0
          },
          finalAttr: {
            opacity: 1
          },
          slot: 'initial'
        }, {
          initialAttr: {
            path: pathArr
          },
          finalAttr: {
            opacity: 1
          },
          slot: 'middle'
        }];
      },
      'plotFluid.updating': null,
      'plotFluidTop.appearing': function plotFluidTopAppearing(input) {
        var pathArr = input.attr.path.slice(0);
        pathArr[2] = pathArr[10] = pathArr[13] = pathArr[21] = conf.cylBase;
        return [{
          initialAttr: {
            opacity: 0
          },
          finalAttr: {
            opacity: 1
          },
          slot: 'initial'
        }, {
          initialAttr: {
            path: pathArr
          },
          finalAttr: {
            opacity: 1
          },
          slot: 'middle'
        }];
      },
      'plotFluidTop.updating': null,
      'text.appearing': function textAppearing() {
        fadeEffect[0].slot = _lib.FINALSTR;
        return fadeEffect;
      },
      'text.updating': null,
      'labelGroup.appearing': function labelGroupAppearing() {
        fadeEffect[0].slot = _lib.FINALSTR;
        return fadeEffect;
      },
      'labelGroup.updating': null,
      'path.appearing': function pathAppearing() {
        fadeEffect[0].slot = _lib.INITIALSTR;
        return fadeEffect;
      },
      'path.updating': null
    };
  }
};
exports["default"] = _default;

/***/ }),

/***/ 1493:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _lib = __webpack_require__(274);

var _cylinderthermometerbase = _interopRequireDefault(__webpack_require__(1494));

var _dependencyManager = __webpack_require__(282);

var _index = _interopRequireDefault(__webpack_require__(1495));

/* eslint require-jsdoc: 'error', valid-jsdoc: ["error", { "requireReturn": false }] */
var A = 'A',
    math = Math,
    mathMax = math.max,
    mathMin = math.min,
    ROLLOVER = 'DataPlotRollOver',
    ROLLOUT = 'DataPlotRollOut',
    win = window,
    userAgent = win.navigator.userAgent,
    isIE = /msie/i.test(userAgent) && !win.opera,
    Z = 'Z',
    HUNDREDPERCENT = '100%',
    zeroCommaHundredStr = '0,100',
    topLightGlowAlphaStr = '40,0',
    btnBorderLightAlphaStr = '50,50,50,50,50,70,50,50',
    btnBorderLightRatioStr = '0,15,0,12,0,15,43,15',
    backAlphaStr = '30,30,30,30,30,30,30,30',
    backRatioStr = '0,15,43,15,0,12,0,15',
    frontRatioStr = '0,15,0,12,0,15,43,15',
    TRACKER_FILL = 'rgba(192,192,192,' + (isIE ? 0.002 : 0.000001) + ')',
    M = 'M',
    L = 'L',
    EVENTARGS = 'eventArgs',
    POSITION_TOP = _lib.preDefStr.POSITION_TOP,
    POSITION_MIDDLE = _lib.preDefStr.POSITION_MIDDLE,
    getScaleFactor = function getScaleFactor(_origW, _origH, canvasWidth, canvasHeight) {
  var scaleFactor,
      origH = _origH,
      origW = _origW;
  origH = (0, _lib.pluckNumber)(origH, canvasHeight);
  origW = (0, _lib.pluckNumber)(origW, canvasWidth);

  if (!origH || !origW) {
    scaleFactor = 1;
  } else if (origW / canvasWidth === origH / canvasHeight) {
    // Now, if the ratio of original width,height & stage width,height are same
    // In this case, the transformation value would be the same, as the ratio
    // of transformation of width and height is same.
    scaleFactor = canvasWidth / origW;
  } else {
    // If the transformation factors are different, we do a constrained scaling
    // We get the aspect whose delta is on the lower side.
    scaleFactor = Math.min(canvasWidth / origW, canvasHeight / origH);
  }

  return scaleFactor;
};

(0, _dependencyManager.addDep)({
  name: 'cylinderAnimation',
  type: 'animationRule',
  extension: _index.default
});
/**
 * Creates dataset class for Cylinder
 */

var CylinderDataset = /*#__PURE__*/function (_CylinderThermometerB) {
  (0, _inheritsLoose2.default)(CylinderDataset, _CylinderThermometerB);

  function CylinderDataset() {
    return _CylinderThermometerB.apply(this, arguments) || this;
  }

  var _proto = CylinderDataset.prototype;

  /**
   * Sets the type of the component
   * @return {string} type
   */
  _proto.getType = function getType() {
    return 'dataset';
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */
  ;

  _proto.getName = function getName() {
    return 'cylinder';
  }
  /**
   * Calculates space management of cylinder plot
   * @return {Object} dimension(top, bottom, left, right) needed for cylinder plot
   */
  ;

  _proto._manageSpace = function _manageSpace() {
    var ds = this,
        dsConfig = ds.config,
        chart = ds.getFromEnv('chart'),
        chartConfig = chart.config,
        chartWidth = chartConfig.width,
        chartHwight = chartConfig.height,
        canvasWidth = chartConfig.canvasWidth,
        canvasHeight = chartConfig.canvasHeight,
        canvasLeft = chartConfig.canvasLeft,
        canvasTop = chartConfig.canvasTop,
        canvasRight = chartConfig.canvasRight,
        xDefined = chartConfig.xDefined,
        yDefined = chartConfig.yDefined,
        rDefined = chartConfig.rDefined,
        hDefined = chartConfig.hDefined,
        gaugeOriginX = chartConfig.gaugeOriginX,
        gaugeOriginY = chartConfig.gaugeOriginY,
        gaugeRadius = chartConfig.gaugeRadius,
        gaugeHeight = chartConfig.gaugeHeight,
        gaugeYScale = chartConfig.gaugeYScale,
        scaleFactor = getScaleFactor(chartConfig.origW, chartConfig.origH, chartWidth, chartHwight),
        top = 0,
        bottom = 0,
        left = 0,
        right = 0,
        gaugeRight,
        centerPos,
        gaugeDiameter,
        gaugeYfactor,
        measure,
        canvasLeftShift; // manage the space for the datalabels

    measure = ds._getLabelSpace();
    canvasHeight -= measure;
    bottom += measure; // lightX = r * 0.85,
    //  x5 = x - lightX,
    //  x6 = x + lightX,
    //  lightY = Math.sqrt((1 - ((lightX * lightX) / (r * r))) * r2 * r2),
    // manage the thermometer space

    /* First calculate the radius */
    // if Not defined the radius then calculate it.

    if (!rDefined) {
      gaugeRadius = mathMax(mathMin(canvasWidth, canvasHeight * 1.2) / 2, 5);
    } else {
      gaugeRadius = gaugeRadius * scaleFactor;
    } // store the effective radius


    chartConfig.effectiveR = gaugeRadius;
    gaugeDiameter = gaugeRadius * 2;
    gaugeYfactor = gaugeRadius * gaugeYScale;
    top += gaugeYfactor;
    canvasTop += gaugeYfactor;
    bottom += gaugeYfactor;
    canvasHeight -= 2 * gaugeYfactor;
    /* Calculate the x */
    // if x is user defined

    if (xDefined) {
      gaugeOriginX = gaugeOriginX * scaleFactor;
      canvasLeftShift = gaugeOriginX - gaugeRadius - canvasLeft;
    } else {
      // else, place the gauge at the center
      centerPos = (canvasRight - canvasLeft) / 2; // now as per the center position calculate the extra left gap

      canvasLeftShift = centerPos - gaugeRadius; // check whether we have space to put the gauge at center

      gaugeRight = canvasLeftShift + gaugeDiameter;

      if (gaugeRight > canvasWidth) {
        canvasLeftShift = canvasWidth - gaugeDiameter;
      }
    }

    left += canvasLeftShift;
    canvasLeft += canvasLeftShift;
    canvasWidth -= canvasLeftShift; // to make the canvas width same as gauge's cylinder width increase the right padding

    right += canvasWidth - gaugeDiameter;

    if (yDefined) {
      gaugeOriginY = gaugeOriginY * scaleFactor;
    }

    if (!hDefined) {
      // if height is not defined
      if (yDefined) {
        // if y is defined then adjust thermometer height is available space
        gaugeHeight = gaugeOriginY - canvasTop;
      } else {
        gaugeHeight = canvasHeight;
        gaugeOriginY = canvasTop + gaugeHeight;
      }
    } else {
      // height is defined
      gaugeHeight = gaugeHeight * scaleFactor;

      if (yDefined) {
        // if both are defined, adjust the top to accomodate this
        top += gaugeOriginY - gaugeHeight - canvasTop;
      } else {
        gaugeOriginY = canvasTop + gaugeHeight;
      }
    } // finally adjust the bottom to accomodate y and height


    bottom += canvasTop + canvasHeight - gaugeOriginY;
    dsConfig.gaugeOriginX = gaugeOriginX;
    dsConfig.gaugeOriginY = gaugeOriginY;
    dsConfig.gaugeRadius = gaugeRadius;
    dsConfig.gaugeHeight = gaugeHeight;
    dsConfig.gaugeYScale = gaugeYScale;
    return {
      top: top,
      bottom: bottom + 8,
      // space for thick border at the glass bottom
      left: left,
      right: right
    };
  }
  /**
   * Draws Cylinder plot
   */
  ;

  _proto.draw = function draw() {
    var dataSet = this,
        dsConfig = dataSet.config,
        smartLabel = dataSet.getFromEnv('smartLabel'),
        iapi = dataSet.getFromEnv('chart'),
        toolTipController = dataSet.getFromEnv('toolTipController'),
        trackerLayer = iapi.getChildContainer('trackerGroup'),
        parentContainer = iapi.getChildContainer().plotGroup,
        fluidTop = dataSet.getGraphicalElement('fluidTop'),
        fluid = dataSet.getGraphicalElement('fluid'),
        cylinterTop = dataSet.getGraphicalElement('cylinterTop'),
        frontLight1 = dataSet.getGraphicalElement('frontLight1'),
        frontLight = dataSet.getGraphicalElement('frontLight'),
        front = dataSet.getGraphicalElement('front'),
        back = dataSet.getGraphicalElement('back'),
        btnBorderLight = dataSet.getGraphicalElement('btnBorderLight'),
        btnBorder1 = dataSet.getGraphicalElement('btnBorder1'),
        btnBorder = dataSet.getGraphicalElement('btnBorder'),
        label = dataSet.getGraphicalElement('label'),
        dataLabelsLayer = iapi.getChildContainer('datalabelsGroup'),
        dataLabelContainerDummy = dataSet.getContainer('dataLabelContainer'),
        dataLabelContainer,
        trackerContainer = dataSet.getContainer('trackerContainer'),
        hotElement = dataSet.getGraphicalElement('hotElement'),
        scale = dataSet.getFromEnv('scale'),
        chartConfig = iapi.config,
        canvasLeft = chartConfig.canvasLeft,
        canvasTop = chartConfig.canvasTop,
        canvasHeight = chartConfig.canvasHeight,
        r = chartConfig.effectiveR || 40,
        value = (0, _lib.pluckNumber)(dsConfig.value, scale.getLimit().min),
        gaugePos = scale.getPixel(value),
        x = canvasLeft + r,
        y = canvasTop,
        h = canvasHeight,
        style = iapi.config.dataLabelStyle,
        fluidColor = dsConfig.gaugeFillColor,
        fluidDarkColor = (0, _lib.getDarkColor)(fluidColor, 70),
        fluidLightColor = (0, _lib.getLightColor)(fluidColor, 70),
        fluidEdgeColor = (0, _lib.getDarkColor)(fluidDarkColor, 90),
        fluidAlpha = chartConfig.gaugeFillAlpha,
        fluidStroke = 3,
        // Thermometer Glass color
    gaugeContainerColor = dsConfig.gaugeContainerColor,
        darkConColor = (0, _lib.getDarkColor)(gaugeContainerColor, 80),
        darkConColor1 = (0, _lib.getDarkColor)(gaugeContainerColor, 90),
        lightConColor = (0, _lib.getLightColor)(gaugeContainerColor, 80),
        r3dFactor = chartConfig.gaugeYScale,
        containerDummy = dataSet.getContainer('container'),
        animationManager = dataSet.getFromEnv('animationManager'),
        canvasHorizontalDiff = Math.abs(chartConfig.width - chartConfig.canvasRight - canvasLeft),
        container,
        ypos,
        r2 = r * r3dFactor,
        fluidStrHF = fluidStroke / 2,
        r3 = r - fluidStrHF,
        y2 = dsConfig.cylBase = y + h,
        y3 = gaugePos,
        x1 = x - r,
        x2 = x + r,
        x3 = x1 + fluidStrHF,
        x4 = x2 - fluidStrHF,
        xBt1 = x1 - 2,
        xBt2 = x2 + 2,
        rBt1 = r + 2,
        rBt2 = r2 + 2,
        yBt1 = y2 + 4,
        yBt2 = yBt1 + 0.001,
        lightX = r * 0.85,
        x5 = x - lightX,
        x6 = x + lightX,
        lightY = Math.sqrt((1 - lightX * lightX / (r * r)) * r2 * r2),
        y4 = y + lightY,
        y5 = y2 + lightY,
        y6 = y - 1,
        use3DLighting = chartConfig.use3DLighting,
        topColorStr,
        topStrokeStr,
        showHoverEffect = dsConfig.showHoverEffect,
        plotFillHoverAlpha = dsConfig.plotFillHoverAlpha,
        plotFillHoverColor = dsConfig.plotFillHoverColor,
        fluidHoverDarkColor,
        fluidHoverLightColor,
        fluidHoverEdgeColor,
        // todo: all attributes need to be parsed and ready during configuration
    eventArgs,
        dataLabelTooltip,
        dataLabelObj,
        fluidAttr = dsConfig.fluidAttr,
        backColor,
        frontColor,
        fluidFill,
        borderColor = (0, _lib.convertColor)(darkConColor, 50),
        btnBorderAttr = {
      'stroke-width': 4
    },
        btnBorder1Attr = {
      'stroke-width': 4
    },
        btnBorderLightAttr = {
      'stroke-width': 0
    },
        backAttr = {
      'stroke-width': 1
    },
        fluidTopAttr = {
      'stroke-width': 2
    },
        frontAttr = {
      'stroke-width': 1
    },
        frontLightAttr = {
      'stroke-width': 0
    },
        frontLight1Attr = {
      'stroke-width': 0
    },
        cylinterTopAttr = {
      'stroke-width': 2
    },
        hotElementAttr = {
      stroke: TRACKER_FILL,
      fill: TRACKER_FILL
    },
        dataLabelContainerAttr = {},
        labelAttr;

    if (!fluidAttr) {
      fluidAttr = dsConfig.fluidAttr = {};
    }

    fluidAttr['stroke-width'] = 0;
    eventArgs = {
      value: dsConfig.value,
      displayValue: dsConfig.displayValue,
      toolText: dsConfig.toolText,
      cylOriginX: dsConfig.gaugeOriginX,
      cylOriginY: dsConfig.gaugeOriginY,
      cylRadius: dsConfig.gaugeRadius,
      cylHeight: dsConfig.gaugeHeight,
      cylYScale: dsConfig.gaugeYScale,
      cylFillColor: dsConfig.gaugeFillColor,
      cylGlassColor: dsConfig.gaugeContainerColor
    }; // Set attributes for 3d lighting

    if (use3DLighting) {
      backColor = lightConColor + _lib.COMMASTRING + darkConColor + _lib.COMMASTRING + lightConColor + _lib.COMMASTRING + darkConColor + _lib.COMMASTRING + darkConColor1 + _lib.COMMASTRING + darkConColor1 + _lib.COMMASTRING + darkConColor + _lib.COMMASTRING + lightConColor;
      fluidFill = (0, _lib.toRaphaelColor)({
        FCcolor: {
          cx: 0.5,
          cy: 0,
          r: HUNDREDPERCENT,
          color: fluidLightColor + _lib.COMMASTRING + fluidDarkColor,
          alpha: fluidAlpha + _lib.COMMASTRING + fluidAlpha,
          ratio: zeroCommaHundredStr,
          radialGradient: true
        }
      });
      topColorStr = (0, _lib.toRaphaelColor)({
        FCcolor: {
          cx: 0.5,
          cy: 0.7,
          r: HUNDREDPERCENT,
          color: fluidLightColor + _lib.COMMASTRING + fluidDarkColor,
          alpha: fluidAlpha + _lib.COMMASTRING + fluidAlpha,
          ratio: zeroCommaHundredStr,
          radialGradient: true
        }
      });
      topStrokeStr = (0, _lib.convertColor)(fluidLightColor, fluidAlpha);
      frontColor = lightConColor + _lib.COMMASTRING + darkConColor + _lib.COMMASTRING + lightConColor + _lib.COMMASTRING + lightConColor + _lib.COMMASTRING + darkConColor + _lib.COMMASTRING + lightConColor + _lib.COMMASTRING + darkConColor + _lib.COMMASTRING + lightConColor; // Set attribute for front light left

      frontLightAttr.path = [M, x1, y2, A, r, r2, 1, 0, 0, x5, y5, L, x5, y4, A, r, r2, 0, 0, 1, x1, y, Z];
      frontLightAttr.fill = (0, _lib.toRaphaelColor)({
        FCcolor: {
          color: frontColor,
          alpha: topLightGlowAlphaStr,
          ratio: zeroCommaHundredStr,
          angle: 0
        }
      }); // Set attribute for front light right

      frontLight1Attr.path = [M, x6, y5, A, r, r2, 0, 0, 0, x2, y2, L, x2, y, A, r, r2, 1, 0, 0, x6, y4, Z];
      frontLight1Attr.fill = (0, _lib.toRaphaelColor)({
        FCcolor: {
          color: frontColor,
          alpha: topLightGlowAlphaStr,
          ratio: zeroCommaHundredStr,
          angle: 180
        }
      });
    } else {
      backColor = lightConColor + _lib.COMMASTRING + darkConColor + _lib.COMMASTRING + darkConColor + _lib.COMMASTRING + darkConColor + _lib.COMMASTRING + darkConColor + _lib.COMMASTRING + darkConColor + _lib.COMMASTRING + darkConColor + _lib.COMMASTRING + lightConColor;
      topColorStr = fluidFill = (0, _lib.convertColor)(fluidDarkColor, fluidAlpha);
      topStrokeStr = (0, _lib.convertColor)(fluidEdgeColor);
      frontColor = darkConColor + _lib.COMMASTRING + darkConColor + _lib.COMMASTRING + darkConColor + _lib.COMMASTRING + darkConColor + _lib.COMMASTRING + darkConColor + _lib.COMMASTRING + darkConColor + _lib.COMMASTRING + darkConColor + _lib.COMMASTRING + darkConColor;
    } // set attributes for fluid fill


    fluidAttr.bodyOut = {
      fill: fluidFill
    };
    fluidAttr.topOut = {
      stroke: topStrokeStr,
      fill: topColorStr
    }; // create hover attributes

    if (showHoverEffect) {
      fluidHoverDarkColor = (0, _lib.getDarkColor)(plotFillHoverColor, 70);
      fluidHoverLightColor = (0, _lib.getLightColor)(plotFillHoverColor, 70);
      fluidHoverEdgeColor = (0, _lib.getDarkColor)(fluidHoverDarkColor, 90);

      if (use3DLighting) {
        fluidAttr.bodyHover = {
          fill: (0, _lib.toRaphaelColor)({
            FCcolor: {
              cx: 0.5,
              cy: 0,
              r: HUNDREDPERCENT,
              color: fluidHoverLightColor + _lib.COMMASTRING + fluidHoverDarkColor,
              alpha: plotFillHoverAlpha + _lib.COMMASTRING + plotFillHoverAlpha,
              ratio: zeroCommaHundredStr,
              radialGradient: true
            }
          })
        };
        fluidAttr.topHover = {
          stroke: (0, _lib.convertColor)(fluidHoverLightColor, plotFillHoverAlpha),
          fill: (0, _lib.toRaphaelColor)({
            FCcolor: {
              cx: 0.5,
              cy: 0.7,
              r: HUNDREDPERCENT,
              color: fluidHoverLightColor + _lib.COMMASTRING + fluidHoverDarkColor,
              alpha: plotFillHoverAlpha + _lib.COMMASTRING + plotFillHoverAlpha,
              ratio: zeroCommaHundredStr,
              radialGradient: true
            }
          })
        };
      } else {
        fluidAttr.bodyHover = {
          fill: (0, _lib.convertColor)(fluidHoverDarkColor, plotFillHoverAlpha)
        };
        fluidAttr.topHover = {
          stroke: (0, _lib.convertColor)(fluidHoverEdgeColor),
          fill: (0, _lib.convertColor)(fluidHoverDarkColor, plotFillHoverAlpha)
        };
      }
    } // Set attrinbute of fluid


    fluidAttr.fill = fluidFill;
    fluidAttr.path = [M, x1, y2, A, r, mathMax(r2, 1), 0, 0, 0, x2, y2, L, x2, y3, A, r, mathMax(r2, 1), 0, 0, 1, x1, y3, Z]; // Set attribute of fluid top

    fluidTopAttr.fill = topColorStr;
    fluidTopAttr.stroke = topStrokeStr;
    fluidTopAttr.path = [M, x3, y3, A, r3, r2, 0, 0, 0, x4, y3, L, x4, y3, A, r3, r2, 0, 0, 0, x3, y3, Z]; // Set attribute for btnBorder

    btnBorderAttr.stroke = (0, _lib.convertColor)(darkConColor, 80);
    btnBorderAttr.path = [M, xBt1, yBt1, A, rBt1, rBt2, 0, 0, 0, xBt2, yBt1, L, xBt2, yBt2, A, rBt1, rBt2, 0, 0, 0, xBt1, yBt2, Z]; // Set attribute for btnBorder1

    btnBorder1Attr.stroke = borderColor;
    btnBorder1Attr.path = [M, x1, yBt1, A, r, r2, 0, 0, 0, x2, yBt1, L, x2, yBt2, A, r, r2, 0, 0, 0, x1, yBt2, Z]; // Set attribute for btnBorderLight

    btnBorderLightAttr.path = [M, x1, y2, A, r, r2, 0, 0, 0, x2, y2, A, r, r2, 0, 0, 0, x1, y2, Z];
    btnBorderLightAttr.fill = (0, _lib.toRaphaelColor)({
      FCcolor: {
        color: lightConColor + _lib.COMMASTRING + darkConColor + _lib.COMMASTRING + lightConColor + _lib.COMMASTRING + lightConColor + _lib.COMMASTRING + darkConColor + _lib.COMMASTRING + fluidDarkColor + _lib.COMMASTRING + darkConColor + _lib.COMMASTRING + lightConColor,
        alpha: btnBorderLightAlphaStr,
        ratio: btnBorderLightRatioStr,
        angle: 0
      }
    }); // Set attribute for back element

    backAttr.path = [M, x1, y2, A, r, r2, 0, 0, 0, x2, y2, L, x2, y, A, r, r2, 0, 0, 0, x1, y, Z];
    backAttr.stroke = borderColor;
    backAttr.fill = (0, _lib.toRaphaelColor)({
      FCcolor: {
        color: backColor,
        alpha: backAlphaStr,
        ratio: backRatioStr,
        angle: 0
      }
    }); // Set attribute for front element

    frontAttr.path = [M, x1, y2, A, r, r2, 0, 0, 0, x2, y2, L, x2, y, A, r, r2, 0, 0, 1, x1, y, Z];
    frontAttr.stroke = borderColor;
    frontAttr.fill = (0, _lib.toRaphaelColor)({
      FCcolor: {
        color: frontColor,
        alpha: backAlphaStr,
        ratio: frontRatioStr,
        angle: 0
      }
    }); // Set attribute for cylinder top

    cylinterTopAttr.stroke = (0, _lib.convertColor)(darkConColor, 40);
    cylinterTopAttr.path = [M, x1, y6, A, r, r2, 0, 0, 0, x2, y6, L, x2, y6, A, r, r2, 0, 0, 0, x1, y6, Z];
    hotElementAttr.path = [M, x1, y2, x1, yBt1 + 4, A, r, r2, 0, 0, 0, x2, yBt1 + 4, L, x2, y2, x2, y, A, r, r2, 0, 0, 0, x1, y, Z]; // Set the opacity of dataLabelContainer according to showValue value

    dataLabelContainerAttr.opacity = dsConfig.showValue ? 1 : 0;
    smartLabel.setStyle(style);
    ypos = y2 + r2 + (dsConfig.valuePadding || 0) + 8; // glass bottom extra thick border

    dataLabelObj = smartLabel.getSmartText(dsConfig.displayValue, chartConfig.width - chartConfig.marginLeft - chartConfig.marginRight - canvasHorizontalDiff / 2, +chartConfig.height - ypos - chartConfig.marginBottom);
    dataLabelTooltip = dataLabelObj.tooltext || _lib.BLANKSTRING; // Label Attributes

    labelAttr = {
      text: dataLabelObj.text,
      x: x,
      y: ypos,
      'text-anchor': POSITION_MIDDLE,
      'vertical-align': POSITION_TOP,
      fill: style.color,
      'text-bound': [style.backgroundColor, style.borderColor, style.borderThickness, style.borderPadding, style.borderRadius, style.borderDash]
    }; // Create/Reuse container

    container = animationManager.setAnimation({
      el: containerDummy || 'group',
      attr: {
        name: 'cylinder'
      },
      container: parentContainer,
      component: dataSet,
      label: 'group'
    }); // Create/Reuse btnBorder element

    btnBorder = animationManager.setAnimation({
      el: btnBorder || 'path',
      attr: btnBorderAttr,
      container: container,
      component: dataSet,
      label: 'path'
    }); // Create/Reuse btnBorder1 element

    btnBorder1 = animationManager.setAnimation({
      el: btnBorder1 || 'path',
      attr: btnBorder1Attr,
      container: container,
      component: dataSet,
      label: 'path'
    }); // Create/Reuse btnBorderLight element

    btnBorderLight = animationManager.setAnimation({
      el: btnBorderLight || 'path',
      attr: btnBorderLightAttr,
      container: container,
      component: dataSet,
      label: 'path'
    }); // Create/Reuse back element

    back = animationManager.setAnimation({
      el: back || 'path',
      attr: backAttr,
      container: container,
      component: dataSet,
      label: 'path'
    }); // Create/Reuse fluid element

    fluid = animationManager.setAnimation({
      el: fluid || 'path',
      attr: fluidAttr,
      container: container,
      component: dataSet,
      label: 'plotFluid'
    }); // Create/Reuse fluidTop element

    fluidTop = animationManager.setAnimation({
      el: fluidTop || 'path',
      attr: fluidTopAttr,
      container: container,
      component: dataSet,
      label: 'plotFluidTop'
    }); // Create/Reuse front element

    front = animationManager.setAnimation({
      el: front || 'path',
      attr: frontAttr,
      container: container,
      component: dataSet,
      label: 'path'
    }); // Create/Reuse frontLight element

    frontLight = animationManager.setAnimation({
      el: frontLight || 'path',
      attr: frontLightAttr,
      container: container,
      component: dataSet,
      label: 'path'
    }); // Create/Reuse frontLight1 element

    frontLight1 = animationManager.setAnimation({
      el: frontLight1 || 'path',
      attr: frontLight1Attr,
      container: container,
      component: dataSet,
      label: 'path'
    }); // Create/Reuse cylinderTop element

    cylinterTop = animationManager.setAnimation({
      el: cylinterTop || 'path',
      attr: cylinterTopAttr,
      container: container,
      component: dataSet,
      label: 'path'
    }); // Create/Reuse trackerContainer element

    trackerContainer = animationManager.setAnimation({
      el: trackerContainer || 'group',
      attr: {
        name: 'tracker-group'
      },
      container: trackerLayer,
      component: dataSet,
      label: 'group'
    }); // Create/Reuse dataLabelContainer

    dataLabelContainer = animationManager.setAnimation({
      el: dataLabelContainerDummy || 'group',
      attr: dataLabelContainerAttr,
      container: dataLabelsLayer,
      component: dataSet,
      label: 'labelGroup'
    }); // Create/Reuse label

    label = animationManager.setAnimation({
      el: label || 'text',
      attr: labelAttr,
      container: dataLabelContainer,
      component: dataSet,
      label: 'text'
    }); // Create/Reuse hotElement

    hotElement = animationManager.setAnimation({
      el: hotElement || 'path',
      attr: hotElementAttr,
      container: trackerContainer,
      component: dataSet,
      label: 'path'
    });

    if (dsConfig.showTooltip) {
      toolTipController.enableToolTip(label, dataLabelTooltip);
    } else {
      toolTipController.disableToolTip(label);
    } // Add to _graphics of dataset if container is not present


    if (!containerDummy) {
      // Attach event handlers
      hotElement.on('fc-click', function (setDataArr) {
        var ele = this;
        iapi.plotEventHandler(ele, setDataArr);
      }).hover(function (data) {
        var ele = this;

        if (dsConfig.showHoverEffect) {
          dataSet.getGraphicalElement('fluid') && dataSet.getGraphicalElement('fluid').attr(fluidAttr.bodyHover);
          dataSet.getGraphicalElement('fluidTop') && dataSet.getGraphicalElement('fluidTop').attr(fluidAttr.topHover);
        }

        iapi.plotEventHandler(ele, data, ROLLOVER);
      }, function (data) {
        var ele = this;

        if (dsConfig.showHoverEffect) {
          dataSet.getGraphicalElement('fluid') && dataSet.getGraphicalElement('fluid').attr(fluidAttr.bodyOut);
          dataSet.getGraphicalElement('fluidTop') && dataSet.getGraphicalElement('fluidTop').attr(fluidAttr.topOut);
        }

        iapi.plotEventHandler(ele, data, ROLLOUT);
      });
      dataSet.addContainer('container', container);
      dataSet.addGraphicalElement('btnBorder', btnBorder);
      dataSet.addGraphicalElement('btnBorder1', btnBorder1);
      dataSet.addGraphicalElement('btnBorderLight', btnBorderLight);
      dataSet.addGraphicalElement('back', back);
      dataSet.addGraphicalElement('fluid', fluid);
      dataSet.addGraphicalElement('fluidTop', fluidTop);
      dataSet.addGraphicalElement('front', front);
      dataSet.addGraphicalElement('frontLight', frontLight);
      dataSet.addGraphicalElement('frontLight1', frontLight1);
      dataSet.addGraphicalElement('cylinterTop', cylinterTop);
      dataSet.addContainer('trackerContainer', trackerContainer);
      dataSet.addGraphicalElement('hotElement', hotElement);
    } // If dataLabelContainer is not present previously, add to _containers of dataset


    if (!dataLabelContainerDummy) {
      dataSet.addContainer('dataLabelContainer', dataLabelContainer);
      dataSet.addGraphicalElement('label', label);
    } // add event args


    hotElement.data(EVENTARGS, eventArgs); // Add/Remove tooltip

    if (!dsConfig.toolText) {
      toolTipController.disableToolTip(hotElement);
    } else {
      toolTipController.enableToolTip(hotElement, dsConfig.toolText);
    }
  };

  return CylinderDataset;
}(_cylinderthermometerbase.default);

var _default = CylinderDataset;
exports["default"] = _default;

/***/ }),

/***/ 1561:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _lib = __webpack_require__(274);

var _funnelpyramidbase = _interopRequireDefault(__webpack_require__(1562));

var _schedular = __webpack_require__(286);

var _funnelPoint = _interopRequireDefault(__webpack_require__(1564));

/* eslint require-jsdoc: 'error', valid-jsdoc: ["error", { "requireReturn": false }] */
var UNDEF;
/**
 * Creates dataset class for Funnel
 */

var FunnelDataset = /*#__PURE__*/function (_FunnelPyramidBaseDat) {
  (0, _inheritsLoose2.default)(FunnelDataset, _FunnelPyramidBaseDat);

  /**
   * Constructor function to initialise attributes of Funnel dataset object
   */
  function FunnelDataset() {
    var _this;

    _this = _FunnelPyramidBaseDat.call(this) || this;
    _this.config.pointInContext = _funnelPoint.default;
    _this.config.LABEL_PLACEMENT_ITERATOR_INDEX_START = 1;
    return _this;
  }
  /**
   * Sets the type of the component
   * @return {string} type
   */


  var _proto = FunnelDataset.prototype;

  _proto.getType = function getType() {
    return 'dataset';
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */
  ;

  _proto.getName = function getName() {
    return 'funnel';
  }
  /**
   * Configure dataset component and parse default values
   * @param  {Object} datasetJSON JSON for dataset configurations
   * @return {boolean} Indicates whether the configuration was successful or not
   */
  ;

  _proto.configure = function configure(datasetJSON) {
    if (!datasetJSON) {
      return false;
    }

    this.config.JSONData = datasetJSON;
    var datasetDefStore = this,
        chart = datasetDefStore.getFromEnv('chart'),
        numberFormatter = datasetDefStore.getFromEnv('number-formatter'),
        utils = datasetDefStore.utils(datasetDefStore),
        sortObjArrByKey = utils.sortObjArrByKey,
        chartAttr = chart.getFromEnv('dataSource') ? chart.getFromEnv('dataSource').chart : {},
        data = datasetDefStore.config.JSONData.data,
        streamLinedData,
        index,
        dsItem,
        length;

    if (!datasetDefStore._checkValidData(data)) {
      return;
    }

    for (index = 0, length = data.length; index < length; index++) {
      dsItem = data[index];

      if (dsItem && dsItem.value !== UNDEF) {
        dsItem.value = numberFormatter.getCleanValue(dsItem.value, true);
      }
    }

    streamLinedData = datasetDefStore.config.streamLinedData = (0, _lib.pluckNumber)(chartAttr.streamlineddata, 1);
    datasetDefStore.config.JSONData.data = !streamLinedData ? data : sortObjArrByKey(data, 'value');
    /**
     * configure the data before calling addlegend so that the legenditems of
     * removed datas do not get drawn
     */

    datasetDefStore._configure();

    data = datasetDefStore.getChildren('data');
    streamLinedData && (data[0].pseudoPoint = true);
    chart.config.showLegend && datasetDefStore.addLegend();
  }
  /**
   * Configure specific attributes
   */
  ;

  _proto.configureSpecifics = function configureSpecifics() {
    var datasetStore = this,
        chart = datasetStore.getFromEnv('chart'),
        datasetConf = datasetStore.config,
        chartAttr = chart.getFromEnv('dataSource') ? chart.getFromEnv('dataSource').chart : {},
        utils = datasetStore.utils(datasetStore),
        copyProperties = utils.copyProperties; // Properties specific to the funnel only

    copyProperties(chartAttr, datasetConf, [['funnelyscale', 'yScale', _lib.pluckNumber, UNDEF, function (datasetConfig) {
      var ys = datasetConfig.yScale;
      datasetConfig.yScale = ys >= 0 && ys <= 40 ? ys / 200 : 0.2;
    }], ['usesameslantangle', 'useSameSlantAngle', _lib.pluckNumber, function (datasetConfig) {
      return datasetConfig.streamLinedData ? 0 : 1;
    }], ['ishollow', 'isHollow', _lib.pluckNumber, UNDEF, function (datasetConfig) {
      var isHollow = datasetConfig.isHollow;

      if (isHollow === UNDEF) {
        datasetConfig.isHollow = datasetConfig.streamLinedData ? 1 : 0;
      }
    }]]);
  }
  /**
   * Process data before drawing to calculate space management
   * @param {Array} pointsArr data points
   */
  ;

  _proto.prePointProcessingHookFn = function prePointProcessingHookFn(pointsArr) {
    var datasetStore = this,
        chart = datasetStore.getFromEnv('chart'),
        chartConf = chart.config,
        conf = datasetStore.config,
        chartWorkingWidth = chartConf.canvasWidth,
        smartLabel = chart.getFromEnv('smartLabel'),
        nonStreamLinedData = !conf.streamLinedData,
        point,
        lineHeight,
        smartTextObj,
        origHeight;
    point = pointsArr[0]; // Wrapping the first label to the whole drawing width

    point && (point.pseudoPoint = true);

    if (point && point.displayValue) {
      smartLabel.useEllipsesOnOverflow(chart.config.useEllipsesWhenOverflow);
      point.style.fontSize = this.computeFontSize(point.style.fontSizeWithUnit) + _lib.PXSTRING;
      smartLabel.setStyle(point.style);
      (0, _lib.setLineHeight)(point.style);
      lineHeight = parseFloat(point.style.lineHeight.match(/^\d+/)[0] || conf.lineHeight, 10);
      origHeight = smartLabel.getOriSize(point.displayValue).height;
      smartTextObj = smartLabel.getSmartText(point.displayValue, chartWorkingWidth, origHeight);
      point.displayValue = smartTextObj.text;
      smartTextObj.tooltext && (point.originalText = smartTextObj.tooltext);
      point.labelWidth = smartLabel.getOriSize(smartTextObj.text).width; // Reducing the chart height to place the top most label

      chartConf.marginTop += lineHeight + 4;
    }

    conf.totalValue = nonStreamLinedData ? pointsArr[0].y - pointsArr[1].y : 0;

    conf.offsetVal = function (i) {
      return nonStreamLinedData ? -(pointsArr[i + 1] && pointsArr[i + 1].y || 0) : point.y;
    };
  }
  /**
   * Process data array to normalise
   * @param {Array} dataArr data array
   * @return {Object} processed calculated dataobject
   */
  ;

  _proto.datasetCalculations = function datasetCalculations(dataArr) {
    var datasetStore = this,
        conf = datasetStore.config,
        numberFormatter = datasetStore.getFromEnv('number-formatter'),
        index,
        length,
        dataObj,
        itemValue,
        res = {},
        isStreamLinedData = conf.streamLinedData,
        percentOfPrevious = conf.percentOfPrevious;
    res.highestValue = Number.NEGATIVE_INFINITY;
    res.refreshedData = [];
    res.sumValue = res.countPoint = 0;

    for (index = 0, length = dataArr.length; index < length; index++) {
      dataObj = dataArr[index];

      if (dataObj.vline) {
        // Funnel or pyramid does not use vline. Ignoring the same if user put it mistakenly.
        continue;
      }

      dataObj.cleanValue = itemValue = Math.abs(numberFormatter.getCleanValue(dataObj.value, true));

      if (itemValue !== null) {
        // If a valid value is provided in the configuration
        res.hasValidPoint = true;
        res.highestValue = res.highestValue || itemValue;
        res.refreshedData.push(dataObj);
        res.sumValue += itemValue;
        res.countPoint += 1;
        res.highestValue = Math.max(res.highestValue, itemValue);
      }
    }

    if (isStreamLinedData) {
      res.sumValue = res.highestValue;
      percentOfPrevious && (res.prevPerValReq = true);
    }

    return res;
  }
  /**
   * Calculates plot values
   *
   * @memberof FunnelDataset
   */
  ;

  _proto.calculatePositionOfPlots = function calculatePositionOfPlots() {
    var datasetStore = this,
        chart = datasetStore.getFromEnv('chart'),
        chartConfig = chart.config,
        conf = datasetStore.config,
        utils = datasetStore.utils(datasetStore),
        getSumValueOfObjArrByKey = utils.getSumValueOfObjArrByKey,
        DistributionMatrix = utils.DistributionMatrix,
        calculatePositionCoordinate = datasetStore.calculatePositionCoordinate,
        psmMargin = conf.psmMargin,
        dataStore = datasetStore.getChildren('data'),
        index,
        length,
        plotObj,
        unitHeight,
        streamLinedData = conf.streamLinedData,
        heightAllotted,
        widthAllotted,
        drawingRadius,
        section = 2,
        dataStoreLength = datasetStore.getDataLength(),
        maxDataValue = conf.maxValue = dataStore[0].y,
        minDataValue = conf.minValue = dataStore[dataStoreLength - 1].y,
        mvMockNonStreamLine,
        alignmentType,
        uh,
        distributionKey,
        currentSliceHeight = 0,
        blockLabelLenFromOffset,
        blockLenFromOffset = 0,
        lineHeight = conf.lineHeight,
        mFloorFn = Math.floor,
        distributedResult,
        dMatrix,
        adMatrix,
        curr,
        ele,
        forceKeys,
        fKey,
        distributionMatrix;

    if (!conf.sumValue) {
      return;
    }

    datasetStore.postPlotCallback = _lib.stubFN;
    chartConfig.canvasTop += chartConfig.marginTop - psmMargin.top;
    chartConfig.effCanvasHeight = heightAllotted = chartConfig.canvasHeight - (chartConfig.marginTop + chartConfig.marginBottom) + (psmMargin.top + psmMargin.bottom);
    chartConfig.effCanvasWidth = widthAllotted = chartConfig.width - (chartConfig.marginLeft + chartConfig.marginRight);
    drawingRadius = conf.drawingRadius = widthAllotted / section; // Calculating the left position for drawing the chart

    conf.x = chartConfig.canvasLeft + (chartConfig.canvasRight - chartConfig.canvasLeft) / 2;

    if (streamLinedData && dataStoreLength < 2) {
      // datasetStore.hide(datasetStore.components.data, dataStoreLength);
      return;
    }

    if (!streamLinedData) {
      uh = unitHeight = maxDataValue ? heightAllotted / maxDataValue : heightAllotted;
    } else {
      unitHeight = heightAllotted / (maxDataValue - minDataValue);
      mvMockNonStreamLine = getSumValueOfObjArrByKey(dataStore, 'value');
      uh = mvMockNonStreamLine ? heightAllotted / mvMockNonStreamLine : heightAllotted;
    }

    conf.unitHeight = unitHeight;
    conf.lastRadius = drawingRadius; // For funnel no x shift calculation required since the shape of the funnel causes the labels to be
    // placed in non overlapping fashion

    conf.globalMinXShift = 0; // Defines how to align the labels of the chart.

    alignmentType = conf.alignmentType = {}; // Default alignment is labels placing in the right side of the pyramid, and chart is left aligned

    alignmentType['default'] = 1;
    alignmentType.alternate = 2; // Length of distribution matrix is how many labels ca be placed at one
    // side of the pyramid without overlapping

    distributionMatrix = new DistributionMatrix(mFloorFn(heightAllotted / lineHeight));

    for (index = 0, length = dataStoreLength; index < length; index++) {
      plotObj = dataStore[index];

      if (plotObj.getState('removed')) {
        continue;
      }

      if (!streamLinedData && index === 0 || !streamLinedData && index === length - 1) {
        // For non streamedlineData the first element contains the total hence continue
        distributionMatrix.forcePush(plotObj, index);
        continue;
      }

      currentSliceHeight = plotObj.y * uh; // Effective length of the current slice from the top of pyramid drawing

      blockLenFromOffset += plotObj.y * uh;
      blockLabelLenFromOffset = blockLenFromOffset - currentSliceHeight + currentSliceHeight / 2;
      distributionKey = mFloorFn(blockLabelLenFromOffset / lineHeight);
      distributionMatrix.push(plotObj, distributionKey);
    }

    distributedResult = distributionMatrix.getDistributedResult(); // Alternatively merge the data after distribution

    dataStore.length = 0;

    if (distributedResult.matrix[1] === UNDEF) {
      [].push.apply(dataStore, distributedResult.matrix[0]);
    } else {
      dMatrix = distributedResult.matrix[0];
      adMatrix = distributedResult.matrix[1];
      length = Math.max(dMatrix.length, adMatrix.length);

      for (index = 0; index < length; index++) {
        ele = dMatrix[index];
        curr = adMatrix[index];
        dataStore.push(ele || curr);
      }
    } // Placing the elements to be forced in distribution matrix


    forceKeys = Object.keys(distributedResult.forceMatrix);

    if (forceKeys.length > 0) {
      for (fKey in distributedResult.forceMatrix) {
        [].splice.apply(dataStore, [parseInt(fKey, 10), 0].concat(distributedResult.forceMatrix[fKey]));
      }
    }

    switch (distributedResult.suggestion) {
      case alignmentType['default']:
        calculatePositionCoordinate.call(datasetStore, dataStore, false);
        break;

      case alignmentType.alternate:
        conf.labelAlignment = alignmentType.alternate; // 1st section for left labels, 2nd sector for chart itself, 3rd section for right label

        section = 3;
        drawingRadius = widthAllotted / section;
        chartConfig.canvasLeft = chartConfig.canvasWidth / 2 - drawingRadius;
        conf.x = chartConfig.canvasLeft + drawingRadius; // lastRadius = drawingRadius;

        calculatePositionCoordinate.call(datasetStore, dataStore, true);
        break;
    }
  }
  /**
   * Draws funnel plot
   */
  ;

  _proto.draw = function draw() {
    var datasetStore = this,
        chart = datasetStore.getFromEnv('chart'),
        conf = datasetStore.config,
        trackerArgs = datasetStore.config.trackerArgs = [],
        dataStore = datasetStore.getChildren('data'),
        index,
        length,
        dlGroup = chart.getChildContainer('datalabelsGroup'),
        streamLinedData = conf.streamLinedData,
        dataStoreLength = dataStore.length,
        mMinFn = Math.min,
        slicingDistance,
        noOfGap,
        halfDistance,
        point,
        postPlotCallbackInitiated;
    datasetStore.config.labelDrawingConfig = datasetStore.config.labelDrawingConfig || [];
    datasetStore.config.labelDrawingConfig.length = 0;

    if (!conf.sumValue) {
      return;
    }

    datasetStore.animateFunction = function (group) {
      return function () {
        group.attr({
          opacity: 1
        });
      };
    };

    slicingDistance = conf.slicingDistance;
    halfDistance = slicingDistance / 2;

    if (streamLinedData && dataStoreLength < 2) {
      datasetStore.hide(datasetStore.getChildren('data'), dataStoreLength);
      return;
    }

    for (index = 0, length = dataStore.length; index < length; index++) {
      dataStore[index] && dataStore[index].shapeArgs && !dataStore[index].getState('removed') && (dataStore[index].shapeArgs.renderer = chart.getFromEnv('paper'));
    }

    noOfGap = conf.noOfGap;

    if (noOfGap) {
      conf.perGapDistance = mMinFn(halfDistance * 1.5, slicingDistance / noOfGap);
      conf.distanceAvailed = halfDistance;
    }

    index = dataStore.length;

    if (conf.alreadyPlotted) {
      datasetStore.postPlotCallback = function () {
        if (postPlotCallbackInitiated) {
          return;
        }

        postPlotCallbackInitiated = true;
        datasetStore.animateFunction(dlGroup)();
      };
    }

    while (index--) {
      point = dataStore[index];
      point.index = index;
      point.syncDraw();
    }

    conf.oldLastData = Object.assign({}, dataStore[dataStore.length - 1].shapeArgs);
    datasetStore.hide(datasetStore.getChildren('data'), dataStoreLength);
    conf.connectorEndSwitchHistoryY = {};
    index = dataStore.length;

    while (index--) {
      if (!dataStore[index].getState('removed')) {
        trackerArgs.push(dataStore[index]);
      }
    }

    datasetStore.addJob('labelDrawID', datasetStore.drawAllLabels.bind(datasetStore), _schedular.priorityList.label);
    datasetStore.addJob('trackerDrawID', datasetStore.drawAllTrackers.bind(datasetStore), _schedular.priorityList.tracker);
    datasetStore.removePlots();
    conf.alreadyPlotted = true;
    conf.prevIs2d = conf.is2d;
  }
  /**
   * Calculates parser configuration for tooltip
   * @param {Object} options configuration object
   * @return {Object} parserConfig for tooltip
   */
  ;

  _proto.getTooltipMacroStub = function getTooltipMacroStub(options) {
    var datasetStore = this,
        conf = datasetStore.config,
        numberFormatter = datasetStore.getFromEnv('number-formatter'),
        baseStub,
        percentOfPrevValue;

    if (conf.streamLinedData) {
      percentOfPrevValue = conf.percentOfPrevious ? options.pValue : numberFormatter.percentValue(options.dataValue / options.prevValue * 100);
    }

    baseStub = _FunnelPyramidBaseDat.prototype.getTooltipMacroStub.call(this, options);
    baseStub.percentValue = conf.percentOfPrevious ? numberFormatter.percentValue(options.dataValue / options.highestValue * 100) : options.pValue;
    baseStub.percentOfPrevValue = percentOfPrevValue;
    return baseStub;
  };

  return FunnelDataset;
}(_funnelpyramidbase.default);

var _default = FunnelDataset;
exports["default"] = _default;

/***/ }),

/***/ 1505:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



exports.__esModule = true;
exports["default"] = void 0;

var _lib = __webpack_require__(274);

var fadeEffect = [{
  initialAttr: function initialAttr() {
    return {
      opacity: 0
    };
  },
  finalAttr: function finalAttr() {
    return {
      opacity: 1
    };
  }
}];
var _default = {
  'initial.dataset.hlineargauge': function initialDatasetHlineargauge() {
    return {
      'parentgroup.initial': function parentgroupInitial(input) {
        return [{
          initialAttr: {
            transform: input.attr.transform
          },
          finalAttr: {
            transform: input.attr.transform
          },
          slot: 'initial'
        }];
      },
      'datalabel.initial': function datalabelInitial(input) {
        return [{
          initialAttr: {
            transform: input.attr.transform
          },
          finalAttr: {
            transform: input.attr.transform
          }
        }];
      },
      'background.appearing': function backgroundAppearing() {
        fadeEffect[0].slot = _lib.INITIALSTR;
        return fadeEffect;
      },
      'background.updating': null,
      'final.appearing': function finalAppearing() {
        fadeEffect[0].slot = _lib.FINALSTR;
        return fadeEffect;
      },
      'final.updating': null,
      'pointers.appearing': function pointersAppearing(input) {
        var dataset = input.component,
            isScaleReversed = dataset.config && dataset.config.isScaleReversed,
            polypathArr = input.attr.polypath.slice(0),
            canvasWidth = dataset.getFromEnv('chart') && dataset.getFromEnv('chart').config && dataset.getFromEnv('chart').config.canvasWidth;
        polypathArr[1] = isScaleReversed ? canvasWidth : 0;
        return [{
          initialAttr: {
            opacity: 0
          },
          finalAttr: {
            opacity: 1
          },
          slot: 'initial'
        }, {
          initialAttr: {
            polypath: polypathArr
          },
          finalAttr: {
            opacity: 1
          },
          slot: 'middle'
        }];
      },
      'pointers.updating': null,
      'pointerValues.appearing': function pointerValuesAppearing(input) {
        var dataset = input.component,
            isScaleReversed = dataset.config && dataset.config.isScaleReversed,
            canvasWidth = dataset.getFromEnv('chart') && dataset.getFromEnv('chart').config && dataset.getFromEnv('chart').config.canvasWidth;
        return [{
          initialAttr: {
            opacity: 0
          },
          finalAttr: {
            opacity: 1
          },
          slot: 'initial'
        }, {
          initialAttr: {
            x: isScaleReversed ? canvasWidth : 0
          },
          finalAttr: {
            opacity: 1
          },
          slot: 'middle'
        }];
      },
      'pointerValues.updating': null,
      '*': null
    };
  }
};
exports["default"] = _default;

/***/ }),

/***/ 1504:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _lib = __webpack_require__(274);

var _safeMax = _interopRequireDefault(__webpack_require__(540));

var _safeMin = _interopRequireDefault(__webpack_require__(539));

var _dependencyManager = __webpack_require__(282);

var _componentInterface = __webpack_require__(290);

var _index = _interopRequireDefault(__webpack_require__(1505));

/* eslint require-jsdoc: 'error', valid-jsdoc: ["error", { "requireReturn": false }] */
var UNDEF,
    BLANKSTRING = _lib.BLANK,
    AXISPOSITION_TOP = 1,
    AXISPOSITION_BOTTOM = 3,
    FILLMIXDARK10 = '{dark-10}',
    configStr = _lib.preDefStr.configStr,
    animationObjStr = _lib.preDefStr.animationObjStr,
    POSITION_TOP = _lib.preDefStr.POSITION_TOP,
    POSITION_BOTTOM = _lib.preDefStr.POSITION_BOTTOM,
    POSITION_MIDDLE = _lib.preDefStr.POSITION_MIDDLE,
    POSITION_START = _lib.preDefStr.POSITION_START,
    POSITION_END = _lib.preDefStr.POSITION_END,
    ROLLOVER = 'DataPlotRollOver',
    ROLLOUT = 'DataPlotRollOut',
    noneStr = 'none',
    M = 'M',
    L = 'L',
    NO_ANIM = 'noAnim',
    win = window,
    doc = win.document,
    hasTouch = doc.documentElement.ontouchstart !== UNDEF,
    math = Math,
    mathMax = math.max,
    mathMin = math.min,
    POINTER = 'pointer',
    EVENTARGS = 'eventArgs',
    ANIM_EFFECT = 'easeIn',
    textHAlign = {
  right: POSITION_END,
  left: POSITION_START,
  middle: POSITION_MIDDLE,
  start: POSITION_START,
  end: POSITION_END,
  center: POSITION_MIDDLE,
  'undefined': _lib.BLANK,
  BLANK: _lib.BLANK
},

/**
 * Returns the type of touch event
 * @param {Event} event the touch event fired
 * @return {Object} type of touch event raised
 */
getTouchEvent = function getTouchEvent(event) {
  return hasTouch && event.sourceEvent && event.sourceEvent.touches && event.sourceEvent.touches[0] || event;
};

(0, _dependencyManager.addDep)({
  name: 'hlineargaugeAnimation',
  type: 'animationRule',
  extension: _index.default
});
/**
 * Creates the HlineargaugeDataset class
 */

var HlineargaugeDataset = /*#__PURE__*/function (_ComponentInterface) {
  (0, _inheritsLoose2.default)(HlineargaugeDataset, _ComponentInterface);

  /**
   * Constructor function to initialise member variables of HlineargaugeDataset class
   */
  function HlineargaugeDataset() {
    var _this;

    _this = _ComponentInterface.call(this) || this;
    _this.config.idMap = {};
    return _this;
  }
  /**
   * Sets the type of the component
   * @return {string} type
   */


  var _proto = HlineargaugeDataset.prototype;

  _proto.getType = function getType() {
    return 'dataset';
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */
  ;

  _proto.getName = function getName() {
    return 'hlineargauge';
  }
  /**
   * Draws the color range of Hlinear Gauge plot as background
   */
  ;

  _proto._drawBackground = function _drawBackground() {
    var dataset = this,
        iapi = this.getFromEnv('chart'),
        envComponents = iapi.getFromEnv(),
        chartConfig = iapi.config,
        // For proper annotation drawing.
    canvasGroup = iapi.getChildContainer().plotGroup,
        toolTipController = iapi.getFromEnv('toolTipController'),
        width = chartConfig.canvasWidth,
        height = chartConfig.canvasHeight,
        canvasTop = chartConfig.canvasTop,
        canvasLeft = chartConfig.canvasLeft,
        scale = envComponents.scale,
        isScaleReversed = dataset.config.isScaleReversed,
        min = scale.config.axisRange.min,
        max = scale.config.axisRange.max,
        jsonData = iapi.getFromEnv('dataSource'),
        chartAttrs = jsonData.chart,
        trendArray = jsonData.trendpoints && jsonData.trendpoints.point,
        showGaugeBorder = (0, _lib.pluckNumber)(chartAttrs.showgaugeborder, 1),
        gaugeFillMix = (0, _lib.getFirstDefinedValue)(chartAttrs.colorrangefillmix, chartAttrs.gaugefillmix, '{light-10},{dark-20},{light-50},{light-85}'),
        gaugeFillRatio = (0, _lib.getFirstDefinedValue)(chartAttrs.colorrangefillratio, chartAttrs.gaugefillratio, chartAttrs.gaugefillratio, '0,8,84,8'),
        gaugeBorderColor = (0, _lib.pluck)(chartAttrs.colorrangebordercolor, chartAttrs.gaugebordercolor, '{dark-20}'),
        gaugeBorderAlpha = (0, _lib.pluckNumber)(chartAttrs.colorrangeborderalpha, chartAttrs.gaugeborderalpha, 100),
        gaugeBorderThickness = showGaugeBorder ? (0, _lib.pluckNumber)(chartAttrs.colorrangeborderthickness, chartAttrs.gaugeborderthickness, 1) : 0,
        gaugeType = 1,
        colorArray = jsonData.colorrange && envComponents.colorRange && envComponents.colorRange.getColorRangeArr(min, max),
        showShadow = (0, _lib.pluckNumber)(chartAttrs.showshadow, 1),
        // shadow,
    i,
        y,
        len,
        marker,
        orient,
        canvas = iapi.getChildren('canvas')[0],
        colorGrp = canvas.getGraphicalElement('linear'),
        outerRect = canvas.getGraphicalElement('outerRect'),
        getRectXY,
        angle,
        color,
        colorObj,
        borderColor,
        xyObj,
        trendPointConfig,
        trendZoneElem,
        trendZoneElems,
        trendObjElem,
        trendObjElems,
        trendObj,
        animationManager = envComponents.animationManager,
        colorM = envComponents['color-manager'],
        crColor,
        crAlpha,
        borderAlpha,
        shadowAlpha,
        startAngle,
        colorRangeElem,
        rangeWidth,
        // duration = animationObj.duration,
    // dummyObj = animationObj.dummyObj,
    // animObj = animationObj.animObj,
    pointOrientation = {
      top: 1,
      bottom: 3
    },
        attr,
        trendZoneElemsCount = 0,
        trendObjElemsCount = 0,
        markerCount = 0;
    animationManager.setAnimation({
      el: canvasGroup,
      state: 'initial',
      attr: {
        transform: ['T', canvasLeft, canvasTop]
      },
      component: dataset,
      container: iapi.getContainer('parentgroup'),
      label: 'parentgroup'
    });
    colorGrp = animationManager.setAnimation({
      el: colorGrp || 'group',
      attr: {
        name: 'colorrange'
      },
      component: dataset,
      container: canvasGroup,
      label: 'background'
    });
    outerRect = animationManager.setAnimation({
      el: outerRect || 'rect',
      attr: {
        x: 0,
        y: 0,
        width: width,
        height: height,
        stroke: noneStr,
        r: 0
      },
      component: dataset,
      container: canvasGroup
    });

    if (!canvas.getGraphicalElement('linear')) {
      colorGrp = canvas.addGraphicalElement('linear', colorGrp); // draw the outer rectangle

      canvas.addGraphicalElement('outerRect', outerRect);
    }

    if (gaugeType === 1) {
      // horizontal gauge; left to right;
      getRectXY = function getRectXY(minValue, maxValue) {
        rangeWidth = (maxValue - minValue) * width / (max - min); // If scale is reversed xPos of a color range will be shifted from canvas end

        return {
          x: isScaleReversed ? width - rangeWidth - minValue * width / (max - min) : minValue * width / (max - min),
          y: 0,
          width: rangeWidth,
          height: height
        };
      };

      angle = 270;
    } else if (gaugeType === 2) {
      // vertical gauge; top to bottom;
      getRectXY = function getRectXY(minValue, maxValue) {
        return {
          x: 0,
          y: minValue * height / (max - min),
          width: width,
          height: (maxValue - minValue) * height / (max - min)
        };
      };

      angle = 180;
    } else if (gaugeType === 3) {
      // horizontal linear gauge; right to left;
      getRectXY = function getRectXY(minValue, maxValue) {
        return {
          x: width - maxValue * width / (max - min),
          y: 0,
          width: (maxValue - minValue) * width / (max - min),
          height: height
        };
      };

      angle = 270;
    } else {
      // vertical linear gauge; bottom to top;
      getRectXY = function getRectXY(minValue, maxValue) {
        return {
          x: 0,
          y: height - maxValue * height / (max - min),
          width: width,
          height: (maxValue - minValue) * height / (max - min)
        };
      };

      angle = 180;
    } // if (!graphics.colorRangeElems) {
    //   graphics.colorRangeElems = [];
    // }


    for (i = 0, len = colorArray && colorArray.length; i < len; i += 1) {
      colorObj = isScaleReversed ? colorArray[len - 1 - i] : colorArray[i];
      xyObj = getRectXY(colorObj.minvalue - min, colorObj.maxvalue - min);
      colorObj.x = xyObj.x;
      colorObj.y = xyObj.y;
      colorObj.width = xyObj.width;
      colorObj.height = xyObj.height;
      color = colorObj.code;
      borderColor = (0, _lib.convertColor)((0, _lib.getColorCodeString)((0, _lib.pluck)(colorObj.bordercolor, color), gaugeBorderColor), (0, _lib.pluckNumber)(colorObj.borderalpha, gaugeBorderAlpha)); // shadow = showShadow ? (Math.max(colorObj.alpha, gaugeBorderAlpha) / 100) : null;
      // create the shadow element

      crColor = colorM.parseColorMix(colorObj.code, gaugeFillMix);
      crAlpha = colorM.parseAlphaList(colorObj.alpha, crColor.length);
      borderAlpha = (0, _lib.pluckNumber)(colorObj.borderAlpha, gaugeBorderAlpha);
      shadowAlpha = crAlpha.split(_lib.COMMASTRING);
      shadowAlpha = mathMax.apply(Math, shadowAlpha);
      shadowAlpha = mathMax(gaugeBorderThickness && borderAlpha || 0, shadowAlpha);
      attr = {
        x: xyObj.x,
        y: xyObj.y,
        width: xyObj.width,
        height: xyObj.height,
        r: 0,
        'stroke-width': gaugeBorderThickness,
        stroke: borderColor,
        'fill': (0, _lib.toRaphaelColor)({
          FCcolor: {
            color: crColor.toString(),
            ratio: gaugeFillRatio,
            alpha: crAlpha,
            angle: angle
          }
        })
      };
      colorRangeElem = canvas.getGraphicalElement('colorRangeElems') && canvas.getGraphicalElement('colorRangeElems')[i];
      colorRangeElem = animationManager.setAnimation({
        el: colorRangeElem || 'rect',
        attr: attr,
        component: dataset,
        container: colorGrp
      });

      if (!(canvas.getGraphicalElement('colorRangeElems') && canvas.getGraphicalElement('colorRangeElems')[i])) {
        colorRangeElem = canvas.addGraphicalElement('colorRangeElems', colorRangeElem, true, i);
        colorRangeElem.shadow({
          apply: showShadow,
          opacity: shadowAlpha / 100
        });
      }

      colorRangeElem.show();
    }

    if (!xyObj && canvas.getGraphicalElement('colorRangeElems') && canvas.getGraphicalElement('colorRangeElems').length > 0) {
      xyObj = canvas.getGraphicalElement('colorRangeElems')[canvas.getGraphicalElement('colorRangeElems').length - 1].attr();
    }

    if (canvas.getGraphicalElement('colorRangeElems')) {
      while (canvas.getGraphicalElement('colorRangeElems')[i]) {
        canvas.getGraphicalElement('colorRangeElems')[i].shadow(false);
        canvas.getGraphicalElement('colorRangeElems')[i].hide();
        i++;
      }
    }

    if (trendArray) {
      // iapi._configueTrendPoints ();
      trendPointConfig = chartConfig.trendPointConfig; // if (!graphics.trendObjElems) {
      //   graphics.trendObjElems = [];
      // }
      // if (!graphics.trendZoneElems) {
      //   graphics.trendZoneElems = [];
      // }
      // if (!graphics.marker) {
      //   graphics.marker = [];
      // }

      for (i = 0, len = trendPointConfig.length; i < len; i += 1) {
        trendObj = trendPointConfig[i];
        xyObj = getRectXY(trendObj.startValue - min, trendObj.endValue - min);

        if (trendObj.isTrendZone) {
          trendZoneElem = canvas.getGraphicalElement('trendZoneElems') && canvas.getGraphicalElement('trendZoneElems')[trendZoneElemsCount];
          trendZoneElem = animationManager.setAnimation({
            el: trendZoneElem || 'rect',
            attr: {
              x: xyObj.x,
              y: xyObj.y,
              width: xyObj.width > 0 ? xyObj.width : 0,
              height: xyObj.height > 0 ? xyObj.height : 0,
              r: 0,
              'stroke-width': 0,
              fill: (0, _lib.toRaphaelColor)({
                FCcolor: {
                  color: trendObj.color,
                  alpha: trendObj.alpha
                }
              })
            },
            component: dataset,
            container: colorGrp,
            label: 'final'
          });

          if (!(canvas.getGraphicalElement('trendZoneElems') && canvas.getGraphicalElement('trendZoneElems')[trendZoneElemsCount])) {
            trendZoneElem = canvas.addGraphicalElement('trendZoneElems', trendZoneElem, true, trendZoneElemsCount);
          }

          trendZoneElem.show();
          toolTipController.enableToolTip(trendZoneElem, trendObj.tooltext);
          trendZoneElemsCount++;
        } else {
          trendObjElem = canvas.getGraphicalElement('trendObjElems') && canvas.getGraphicalElement('trendObjElems')[trendObjElemsCount];
          trendZoneElem = animationManager.setAnimation({
            el: trendObjElem || 'path',
            attr: {
              stroke: (0, _lib.convertColor)(trendObj.color, trendObj.alpha),
              'stroke-dasharray': trendObj.dashStyle,
              'stroke-width': trendObj.thickness,
              path: [M, xyObj.x, xyObj.y, L, xyObj.x, xyObj.y + xyObj.height]
            },
            component: dataset,
            container: colorGrp,
            label: 'final'
          });

          if (!trendObjElem) {
            trendObjElem = canvas.addGraphicalElement('trendObjElems', trendZoneElem, true, trendObjElemsCount);
          }

          trendObjElem.show();
          toolTipController.enableToolTip(trendObjElem, trendObj.tooltext);
          trendObjElemsCount++;
        }

        if (trendObj.useMarker) {
          if (trendObj.showOnTop) {
            orient = POSITION_BOTTOM;
            y = 0;
          } else {
            orient = POSITION_TOP;
            y = height;
          }

          startAngle = pointOrientation[orient] * 90;
          marker = canvas.getGraphicalElement('marker') && canvas.getGraphicalElement('marker')[markerCount];
          marker = animationManager.setAnimation({
            el: marker || 'polypath',
            attr: {
              fill: trendObj.markerColor,
              stroke: trendObj.markerBorderColor,
              polypath: [3, xyObj.x, y, trendObj.markerRadius, startAngle, 0],
              'stroke-width': 1
            },
            component: dataset,
            container: colorGrp,
            label: 'final'
          });

          if (!(canvas.getGraphicalElement('marker') && canvas.getGraphicalElement('marker')[markerCount])) {
            marker = canvas.addGraphicalElement('marker', marker, true, markerCount);
            marker.shadow({
              apply: showShadow
            });
          }

          toolTipController.enableToolTip(marker, trendObj.tooltext);
          marker.show();
          markerCount++;
        }
      }
    } // Hiding the unused graphic trendpoint elements if it exists


    trendObjElems = canvas.getGraphicalElement('trendObjElems');

    if (trendObjElems) {
      while (trendObjElems[trendObjElemsCount]) {
        trendObjElems[trendObjElemsCount].hide();
        trendObjElemsCount++;
      }
    }

    trendZoneElems = canvas.getGraphicalElement('trendZoneElems');

    if (trendZoneElems) {
      while (trendZoneElems[trendZoneElemsCount]) {
        trendZoneElems[trendZoneElemsCount].hide();
        trendZoneElemsCount++;
      }
    }

    marker = canvas.getGraphicalElement('marker');

    if (marker) {
      while (marker[markerCount]) {
        marker[markerCount].hide();
        marker[markerCount].shadow(false);
        markerCount++;
      }
    }
  }
  /**
   * Configure thr dataset
   * @param {Object} pointerArrArg consists of pointers data
   */
  ;

  _proto.configureAttributes = function configureAttributes(pointerArrArg) {
    this.trimData(pointerArrArg);
    this.config.pointerArr = pointerArrArg;
    var dataSet = this,
        chart = dataSet.getFromEnv('chart'),
        jsonData = chart.getFromEnv('dataSource'),
        chartAttrs = jsonData.chart,
        numberFormatter = dataSet.getFromEnv('number-formatter'),
        colorM = dataSet.getFromEnv('color-manager'),
        scale = dataSet.getFromEnv('scale'),
        plottooltext = chartAttrs.plottooltext,
        datasetConfig = dataSet.config || (dataSet.config = {}),
        components = dataSet.components || (dataSet.components = {}),
        pointerArr = jsonData.pointers && jsonData.pointers.pointer,
        len = pointerArr && pointerArr.length || 0,
        dataObj,
        data,
        config,
        itemValue,
        i,
        setToolText,
        formatedVal,
        tooltipSepChar,
        setDisplayValue,
        sides,
        dataStore,
        pointOrientation = {
      top: 1,
      right: 0,
      left: 2,
      bottom: 3
    },
        gaugeType = 1,
        orient,
        pointerOnOpp,
        borderColor,
        borderAlpha,
        bgAlpha,
        valueAbovePointer,
        bgColor,
        baseStyle = chart.config.style,
        radius,
        pointerBorderColor,
        pointerBorderHoverAlpha,
        pointerBgHoverAlpha,
        pointerBgHoverColor,
        pointerBorderHoverColor,
        pointerBorderHoverThickness,
        pointerHoverRadius,
        borderWidth,
        showHoverEffect,
        hoverAttr,
        showBorderOnHover,
        showHoverAnimation,
        hasHoberFillMix,
        outAttr,
        hasBorderHoverMix,
        hoverAnimAttr,
        outAnimAttr,
        showBorder,
        fillColor,
        ticksBelowGauge,
        pointerSides,
        chartShowHoverEffect,
        pointerBorderThickness,
        showValue,
        label;
    datasetConfig.isScaleReversed = scale.config.isReverse;
    datasetConfig.valuePadding = (0, _lib.pluckNumber)(chartAttrs.valuepadding, 2);
    datasetConfig.tooltipSepChar = tooltipSepChar = (0, _lib.pluck)(chartAttrs.tooltipsepchar, _lib.COMMASTRING);
    ticksBelowGauge = (0, _lib.pluckNumber)(chartAttrs.ticksbelowgauge, chartAttrs.ticksbelowgraph, 1);
    datasetConfig.axisPosition = ticksBelowGauge ? AXISPOSITION_BOTTOM : AXISPOSITION_TOP;
    datasetConfig.pointerOnOpp = pointerOnOpp = Number(!(0, _lib.pluckNumber)(chartAttrs.pointerontop, ticksBelowGauge, 1));
    datasetConfig.valueabovepointer = valueAbovePointer = (0, _lib.pluckNumber)(chartAttrs.valueabovepointer, !pointerOnOpp, 1);
    datasetConfig.valueInsideGauge = valueAbovePointer === pointerOnOpp ? 1 : 0;
    datasetConfig.showPointerShadow = (0, _lib.pluckNumber)(chartAttrs.showpointershadow, chartAttrs.showshadow, 1);
    datasetConfig.showTooltip = (0, _lib.pluckNumber)(chartAttrs.showtooltip, 1);
    datasetConfig.textDirection = chartAttrs.hasrtltext === '1' ? 'rtl' : _lib.BLANK;
    datasetConfig.showGaugeLabels = (0, _lib.pluckNumber)(chartAttrs.showgaugelabels, 1);
    datasetConfig.colorRangeStyle = {
      fontFamily: baseStyle.inCanfontFamily,
      fontSize: baseStyle.inCanfontSize,
      lineHeight: baseStyle.inCanLineHeight,
      color: baseStyle.inCancolor.replace(/^#?/, '#')
    };
    datasetConfig.showTextOutline = (0, _lib.pluckNumber)(chartAttrs.textoutline, 0);
    datasetConfig.showValue = (0, _lib.pluckNumber)(chartAttrs.showvalue, 1);
    datasetConfig.editMode = (0, _lib.pluckNumber)(chartAttrs.editmode, 0);
    datasetConfig.pointerSides = pointerSides = (0, _lib.pluckNumber)(chartAttrs.pointersides, 3);
    datasetConfig.pointerBorderThickness = pointerBorderThickness = (0, _lib.pluckNumber)(chartAttrs.pointerborderthickness);
    datasetConfig.showHoverEffect = chartShowHoverEffect = (0, _lib.pluckNumber)(chartAttrs.showhovereffect, chartAttrs.plothovereffect);
    datasetConfig.upperLimit = (0, _lib.pluckNumber)(chartAttrs.upperlimit);
    datasetConfig.lowerLimit = (0, _lib.pluckNumber)(chartAttrs.lowerlimit);

    if (gaugeType === 1) {
      // horizontal gauge; left to right;
      orient = pointerOnOpp ? POSITION_TOP : POSITION_BOTTOM;
    } else if (gaugeType === 2) {
      // vertical gauge; top to bottom;
      orient = pointerOnOpp ? 'left' : 'right';
    } else if (gaugeType === 3) {
      // horizontal linear gauge; right to left;
      orient = pointerOnOpp ? POSITION_TOP : POSITION_BOTTOM;
    } else {
      // vertical linear gauge; bottom to top;
      orient = pointerOnOpp ? 'left' : 'right';
    }

    datasetConfig.startAngle = pointOrientation[orient] * 90;
    dataStore = components.data || (components.data = []);

    for (i = 0; i < len; i++) {
      data = dataStore[i] || (components.data[i] = {});
      config = data.config || (data.config = {});
      dataObj = pointerArr && pointerArr[i] || {};
      config.value = dataObj.value;
      config.itemValue = itemValue = numberFormatter.getCleanValue(dataObj.value);
      config.formatedVal = formatedVal = numberFormatter.dataLabels(itemValue);
      config.setDisplayValue = setDisplayValue = (0, _lib.getValidValue)((0, _lib.parseUnsafeString)(dataObj.displayvalue));
      config.setToolText = setToolText = (0, _lib.getValidValue)((0, _lib.parseUnsafeString)((0, _lib.pluck)(dataObj.tooltext, plottooltext), false));
      config.id = (0, _lib.pluck)(dataObj.id, 'pointer_' + i);
      config.showHoverEffect = showHoverEffect = (0, _lib.pluckNumber)(dataObj.showhovereffect, chartShowHoverEffect);
      config.showBorder = showBorder = (0, _lib.pluckNumber)(dataObj.showborder, chartAttrs.showplotborder, 1);
      config.borderWidth = borderWidth = showBorder ? (0, _lib.pluckNumber)(dataObj.borderthickness, pointerBorderThickness) : 0;
      config.showValue = showValue = (0, _lib.pluckNumber)(dataObj.showvalue, datasetConfig.showValue);
      config.dataLabelStyle = dataSet._configureDataLabelStyle(dataObj, jsonData.pointers); // create the displayvalue

      if (!showValue) {
        config.displayValue = BLANKSTRING;
      } else if (setDisplayValue !== UNDEF) {
        config.displayValue = setDisplayValue;
        config.isLabelString = true;
      } else {
        // determine the dispalay value then
        config.displayValue = (0, _lib.getValidValue)(formatedVal, _lib.BLANK);
      }

      config.sides = sides = (0, _lib.pluckNumber)(dataObj.sides, pointerSides);

      if (sides < 3) {
        config.sides = 3;
      }

      config.radius = radius = (0, _lib.pluckNumber)(dataObj.radius, chartAttrs.pointerradius, 10); // create the tooltext

      if (setToolText !== UNDEF) {
        config.toolText = (0, _lib.parseTooltext)(setToolText, [1, 2], {
          formattedValue: formatedVal
        }, dataObj, chartAttrs);
        config.isTooltextString = true;
      } else {
        // determine the dispalay value then
        config.toolText = formatedVal === null ? false : label !== UNDEF ? label + tooltipSepChar + formatedVal : formatedVal;
      } // Latter used in real time draw


      config.tempToolText = config.toolText;
      config.bgAlpha = bgAlpha = (0, _lib.pluckNumber)(dataObj.alpha, dataObj.bgalpha, chartAttrs.pointerbgalpha, 100);
      config.bgColor = bgColor = (0, _lib.pluck)(dataObj.color, dataObj.bgcolor, chartAttrs.pointerbgcolor, chartAttrs.pointercolor, colorM.getColor('pointerBgColor'));
      config.fillColor = fillColor = (0, _lib.convertColor)(bgColor, bgAlpha);
      config.showBorder = (0, _lib.pluckNumber)(dataObj.showborder, chartAttrs.showplotborder, 1);
      config.borderAlpha = borderAlpha = (0, _lib.pluckNumber)(dataObj.borderalpha, chartAttrs.pointerborderalpha, 100);
      config.borderColor = borderColor = (0, _lib.pluck)(dataObj.bordercolor, chartAttrs.pointerbordercolor, colorM.getColor('pointerBorderColor'));
      config.pointerBorderColor = pointerBorderColor = (0, _lib.convertColor)(borderColor, borderAlpha);
      config.dataLink = (0, _lib.getValidValue)(dataObj.link);
      config.editMode = (0, _lib.pluckNumber)(dataObj.editmode, datasetConfig.editMode);

      if (showHoverEffect !== 0 && (showHoverEffect || dataObj.bghovercolor || chartAttrs.pointerbghovercolor || chartAttrs.plotfillhovercolor || dataObj.bghoveralpha || chartAttrs.pointerbghoveralpha || chartAttrs.plotfillhoveralpha || dataObj.bghoveralpha === 0 || chartAttrs.pointerbghoveralpha === 0 || dataObj.showborderonhover || chartAttrs.showborderonhover || dataObj.showborderonhover === 0 || chartAttrs.showborderonhover === 0 || dataObj.borderhoverthickness || chartAttrs.pointerborderhoverthickness || dataObj.borderhoverthickness === 0 || chartAttrs.pointerborderhoverthickness === 0 || dataObj.borderhovercolor || chartAttrs.pointerborderhovercolor || dataObj.borderhoveralpha || chartAttrs.pointerborderhoveralpha || dataObj.borderhoveralpha === 0 || chartAttrs.pointerborderhoveralpha === 0 || dataObj.hoverradius || chartAttrs.pointerhoverradius || dataObj.hoverradius === 0 || chartAttrs.pointerhoverradius === 0)) {
        showHoverEffect = true;
        pointerBgHoverColor = (0, _lib.pluck)(dataObj.bghovercolor, chartAttrs.pointerbghovercolor, chartAttrs.plotfillhovercolor, FILLMIXDARK10);
        pointerBgHoverAlpha = (0, _lib.pluckNumber)(dataObj.bghoveralpha, chartAttrs.pointerbghoveralpha, chartAttrs.plotfillhoveralpha);
        showBorderOnHover = (0, _lib.pluckNumber)(dataObj.showborderonhover, chartAttrs.showborderonhover);

        if (showBorderOnHover === UNDEF) {
          if (dataObj.borderhoverthickness || dataObj.borderhoverthickness === 0 || dataObj.borderhovercolor || dataObj.borderhoveralpha || dataObj.borderhoveralpha === 0) {
            showBorderOnHover = 1;
          } else {
            showBorderOnHover = showBorder;
          }
        }

        pointerBorderHoverColor = (0, _lib.pluck)(dataObj.borderhovercolor, chartAttrs.pointerborderhovercolor, FILLMIXDARK10);
        pointerBorderHoverAlpha = (0, _lib.pluckNumber)(dataObj.borderhoveralpha, chartAttrs.pointerborderhoveralpha);
        pointerBorderHoverThickness = showBorderOnHover ? (0, _lib.pluckNumber)(dataObj.borderhoverthickness, chartAttrs.pointerborderhoverthickness, borderWidth || 1) : 0;
        pointerHoverRadius = (0, _lib.pluckNumber)(dataObj.hoverradius, chartAttrs.pointerhoverradius, radius + 2);
        showHoverAnimation = !!(0, _lib.pluckNumber)(dataObj.showhoveranimation, chartAttrs.showhoveranimation, 1);
        config.hoverAttr = hoverAttr = {};
        config.outAttr = outAttr = {};

        if (borderWidth !== pointerBorderHoverThickness) {
          hoverAttr['stroke-width'] = pointerBorderHoverThickness;
          outAttr['stroke-width'] = borderWidth;
        }

        outAttr.fill = fillColor;
        hasHoberFillMix = /\{/.test(pointerBgHoverColor);
        pointerBgHoverColor = hasHoberFillMix ? colorM.parseColorMix(bgColor, pointerBgHoverColor)[0] : pointerBgHoverColor;
        hoverAttr.fill = (0, _lib.convertColor)(pointerBgHoverColor, (0, _lib.pluckNumber)(pointerBgHoverAlpha, bgAlpha));

        if (pointerBorderHoverThickness) {
          outAttr.stroke = pointerBorderColor;
          hasBorderHoverMix = /\{/.test(pointerBorderHoverColor);
          hoverAttr.stroke = (0, _lib.convertColor)(hasBorderHoverMix ? colorM.parseColorMix(borderColor, pointerBorderHoverColor)[0] : pointerBorderHoverColor, (0, _lib.pluckNumber)(pointerBorderHoverAlpha, borderAlpha));
        }

        if (pointerHoverRadius) {
          if (showHoverAnimation) {
            hoverAnimAttr = {
              r: pointerHoverRadius
            };
            outAnimAttr = {
              r: radius
            };
          } else {
            hoverAttr.r = pointerHoverRadius;
            outAttr.r = radius;
          }
        }
      }

      config.rolloverProperties = {
        enabled: showHoverEffect,
        hoverAttr: hoverAttr,
        hoverAnimAttr: hoverAnimAttr,
        outAttr: outAttr,
        outAnimAttr: outAnimAttr
      };
    }
  }
  /**
   * Trim the extra data during update
   * @param {Object} pointers consists of new pointers data
   */
  ;

  _proto.trimData = function trimData(pointers) {
    var dataSet = this,
        prevPointers,
        currPointers;
    prevPointers = dataSet.config.pointerArr && dataSet.config.pointerArr.pointer && dataSet.config.pointerArr.pointer.length;
    currPointers = pointers && pointers.pointer && pointers.pointer.length || 0;

    if (prevPointers > currPointers) {
      dataSet.removeData(prevPointers - currPointers);
    }
  }
  /**
   * Manage space for pointer values
   * @param {number} availableHeight height which can be used
   * @return {Object} returns dimension used (top, bottom)
   */
  ;

  _proto._manageSpace = function _manageSpace(availableHeight) {
    var dataSet = this,
        chart = dataSet.getFromEnv('chart'),
        components = dataSet.components,
        chartConfig = chart.config,
        datasetConfig = dataSet.config,
        smartLabel = dataSet.getFromEnv('smartLabel'),
        canvasWidth = chartConfig.canvasWidth,
        smartDataLabel,
        extraSpace,
        style = chartConfig.dataLabelStyle,
        trendStyle = chartConfig.style.trendStyle,
        jsonData = chart.getFromEnv('dataSource'),
        trendArray = jsonData.trendpoints && jsonData.trendpoints.point,
        lineHeight = (0, _lib.pluckNumber)(parseInt(style.lineHeight, 10), 12),
        maxAllowedHeight = availableHeight,
        datasetValuePadding = datasetConfig.valuePadding,
        valueInsideGauge = datasetConfig.valueInsideGauge,
        valuePaddingWithRadius,
        heightUsed = 0,
        heightUsedBottom = 0,
        heightUsedTop = 0,
        valuePadding = 0,
        trendPadding = 0,
        heightReducedBottom = 0,
        heightReducedTop = 0,
        trendPointConfig,
        point,
        trendPaddingWithRadius,
        tickDimension = dataSet.getFromEnv('scale').config.spaceTaken,
        i = 0,
        len = dataSet.config.pointerArr && dataSet.config.pointerArr.pointer && dataSet.config.pointerArr.pointer.length,
        pointerOnOpp = datasetConfig.pointerOnOpp,
        config,
        data = components.data;
    trendArray && chart._configueTrendPoints();
    smartLabel.useEllipsesOnOverflow(chartConfig.useEllipsesWhenOverflow);
    smartLabel.setStyle(style);

    for (; i < len; i += 1) {
      config = data[i].config; // Add pointer radius in value-padding

      valuePaddingWithRadius = datasetValuePadding + config.radius * (config.sides <= 3 ? 0.5 : config.sides % 2 ? 1.1 - 1 / config.sides : 1);
      valuePadding = Math.max(valuePadding, valuePaddingWithRadius);

      if (config.showValue && config.displayValue !== BLANKSTRING) {
        if (config.isLabelString) {
          smartDataLabel = smartLabel.getSmartText(config.displayValue, canvasWidth, maxAllowedHeight - valuePadding);
          config.displayValue = smartDataLabel.text;
          smartDataLabel.tooltext && (config.originalText = smartDataLabel.tooltext);
        } else {
          smartDataLabel = smartLabel.getOriSize(config.displayValue);
        } // special fix for space string

        /** @todo will be removed when smartLabel will be able to handle it */


        if (config.displayValue === _lib.BLANK) {
          smartDataLabel = {
            height: lineHeight
          };
        }
      }

      if (smartDataLabel && smartDataLabel.height > 0 && !valueInsideGauge) {
        heightUsed = smartDataLabel.height + valuePaddingWithRadius;
      } else {
        heightUsed = valuePaddingWithRadius;
      }

      if (heightUsed > maxAllowedHeight) {
        extraSpace = heightUsed - maxAllowedHeight;
        valuePaddingWithRadius = extraSpace < valuePaddingWithRadius ? valuePaddingWithRadius - extraSpace : 0;
        heightUsed = maxAllowedHeight;
      }

      if (pointerOnOpp) {
        if (datasetConfig.axisPosition === AXISPOSITION_BOTTOM) {
          heightReducedBottom = Math.max(tickDimension.bottom, heightReducedBottom);
          heightUsed = Math.max(tickDimension.bottom, heightUsed);
        }

        heightUsedBottom = Math.max(heightUsedBottom, heightUsed);
      } else {
        if (datasetConfig.axisPosition === AXISPOSITION_TOP) {
          heightReducedTop = Math.max(tickDimension.top, heightReducedTop);
          heightUsed = Math.max(tickDimension.top, heightUsed);
        }

        heightUsedTop = Math.max(heightUsed, heightUsedTop);
      }

      datasetConfig.align = _lib.POSITION_CENTER;
    }

    datasetConfig.currentValuePadding = valuePadding;
    smartLabel.setStyle(trendStyle);

    if (trendArray) {
      trendPointConfig = chartConfig.trendPointConfig;

      for (i = 0, len = trendPointConfig.length; i < len; i += 1) {
        point = trendPointConfig[i];

        if (point && point.displayValue !== BLANKSTRING) {
          // Add pointer radius in value-padding
          trendPaddingWithRadius = datasetValuePadding + point.markerRadius * 0.5;
          trendPadding = Math.max(trendPaddingWithRadius, trendPadding);
          smartDataLabel = smartLabel.getOriSize(point.displayValue);

          if (smartDataLabel.height > 0) {
            heightUsed = smartDataLabel.height + trendPaddingWithRadius;
          }

          if (heightUsed > maxAllowedHeight) {
            extraSpace = heightUsed - maxAllowedHeight;
            trendPaddingWithRadius = extraSpace < trendPaddingWithRadius ? trendPaddingWithRadius - extraSpace : 0;
            heightUsed = maxAllowedHeight;
          }

          if (point.showOnTop) {
            if (datasetConfig.axisPosition === AXISPOSITION_TOP) {
              heightReducedTop = Math.max(tickDimension.top, heightReducedTop);
              heightUsed = Math.max(tickDimension.top, heightUsed);
            }

            heightUsedTop = Math.max(heightUsedTop, heightUsed);
          } else {
            if (datasetConfig.axisPosition === AXISPOSITION_BOTTOM) {
              heightReducedBottom = Math.max(tickDimension.bottom, heightReducedBottom);
              heightUsed = Math.max(tickDimension.bottom, heightUsed);
            }

            heightUsedBottom = Math.max(heightUsed, heightUsedBottom);
          }
        }
      }

      datasetConfig.currentTrendPadding = trendPadding;
    }

    return {
      top: heightUsedTop - heightReducedTop,
      bottom: heightUsedBottom - heightReducedBottom
    };
  }
  /**
   * Draws the pointer plots
   * @param {Object} animation animation object to check whether to animate
   * @param {boolean} isRTupdate check whether it is real time update or general update
   */
  ;

  _proto.draw = function draw(animation, isRTupdate) {
    var dataSet = this,
        idMap = dataSet.config.idMap,
        chart = dataSet.getFromEnv('chart'),
        chartConfig = chart.config,
        // chartGraphics = chart.graphics,
    dataLabelsGroup = chart.getChildContainer('datalabelsGroup'),
        toolTipController = dataSet.getFromEnv('toolTipController'),
        wGroup = dataSet.getGraphicalElement('tempGroup'),
        scale = dataSet.getFromEnv('scale'),
        animationManager = dataSet.getFromEnv('animationManager'),
        chartData = dataSet.config.pointerArr && dataSet.config.pointerArr.pointer,
        width = chartConfig.canvasWidth,
        // pointer = chartGraphics.pointer,
    height = chartConfig.canvasHeight,
        datasetConfig = dataSet.config,
        isScaleReversed = datasetConfig.isScaleReversed,
        NumberFormatter = dataSet.getFromEnv('number-formatter'),
        itemValue,
        pointerY = datasetConfig.pointerOnOpp ? height : 0,
        showPointerShadow = datasetConfig.showPointerShadow,
        showTooltip = datasetConfig.showTooltip,
        min = scale.config.axisRange.min,
        max = scale.config.axisRange.max,
        pxValueFactor = (max - min) / width,
        i = chartData && chartData.length || 0,
        config,
        prevData,
        shadowObj,
        startAngle,
        components = dataSet.components,
        data = components.data,
        // animObj = animationObj.animObj,
    // dummyObj = animationObj.dummyObj,
    // animationDuration = (animation || animationObj).duration,
    stubEvent = {
      pageX: 0,
      pageY: 0
    },
        pointerDragStart = function pointerDragStart(e) {
      var point = this,
          x = e.data[0];

      if (point.editMode === false) {
        return;
      }

      prevData = chart._getDataJSON();
      point.dragStartX = x;
    },
        pointerDragEnd = function pointerDragEnd() {
      var point = this,
          conf = point.config,
          jsVars,
          chartObj = chart.getFromEnv('chartInstance');

      if (point.config.editMode === false) {
        return;
      }

      jsVars = chartObj && chartObj.jsVars;
      jsVars && (jsVars._rtLastUpdatedData = chart._getDataJSON());
      chart.fireChartInstanceEvent('RealTimeUpdateComplete', {
        data: '&value=' + conf.updatedValStr,
        updateObject: {
          values: [conf.updatedValStr]
        },
        prevData: prevData.values,
        source: 'editMode',
        url: null
      });

      try {
        win.FC_ChartUpdated && win.FC_ChartUpdated(chartObj.id);
      } catch (err) {
        setTimeout(function () {
          throw err;
        }, 1);
      }

      if (datasetConfig.showTooltip) {
        toolTipController.enableToolTip(pointer, conf.toolText);
      } else {
        toolTipController.disableToolTip(pointer);
      }
    },
        pointerOnDrag = function pointerOnDrag(event) {
      var point = this,
          evtData = event.data,
          x = evtData[2],
          touchEvent = hasTouch && getTouchEvent(event) || stubEvent,
          scaleMinMax = scale.getLimit(),
          scaleMin = scaleMinMax.min,
          scaleMax = scaleMinMax.max,
          pointVal = (0, _lib.pluckNumber)(point.itemValue, scaleMin),
          diffX = isScaleReversed ? x - point.dragStartX : point.dragStartX - x,
          newVal = pointVal - diffX * pxValueFactor,
          ii = 0,
          values = [],
          tempValues = [];

      if (point.editMode === false) {
        return;
      } // Flag set for setting click link in edit mode.


      point.drag = true;

      if (newVal < scaleMin) {
        newVal = scaleMin;
      } else if (newVal > scaleMax) {
        newVal = scaleMax;
      }

      for (; ii < point.index; ii += 1) {
        values.push(_lib.BLANK);
        tempValues.push(_lib.BLANK);
      }

      values.push({
        value: newVal
      });
      tempValues.push(newVal);

      if (pointVal !== newVal && dataSet.updateData({
        data: values
      }, {
        duration: 0
      })) {
        point.updatedValStr = tempValues.join('|');
        point.dragStartX = x || event.pageX || touchEvent.pageX;
      }
    },
        pointer,
        graphics,
        link,
        rolloverProperties,
        eventArgs,
        clickHandler,
        hoverRollOver,
        hoverRollOut;

    if (animation && animation.duration === 0) {
      chart.state = NO_ANIM;
    }

    if (!wGroup) {
      wGroup = dataSet.addGraphicalElement('tempGroup', animationManager.setAnimation({
        el: 'group',
        state: chart.state,
        attr: {
          opacity: 1,
          name: 'tempGroup'
        },
        container: dataLabelsGroup,
        component: dataSet
      }));
    }

    clickHandler = function clickHandler(graphicData) {
      var ele = this,
          index = ele.data(EVENTARGS).index,
          conf = data[index].config;

      if (conf.drag === true) {
        conf.drag = false;
        return;
      }

      chart.plotEventHandler(ele, graphicData);
    };

    hoverRollOver = function hoverRollOver(dataParam) {
      var ele = this,
          rolloverProps = ele.data('rolloverProperties');

      if (rolloverProps.enabled) {
        ele.attr(rolloverProps.hoverAttr);

        if (rolloverProps.hoverAnimAttr) {
          ele.animate(rolloverProps.hoverAnimAttr, 100, ANIM_EFFECT);
        }
      }

      chart.plotEventHandler(ele, dataParam, ROLLOVER);
    };

    hoverRollOut = function hoverRollOut(dataParam) {
      var ele = this,
          rolloverProps = ele.data('rolloverProperties');

      if (rolloverProps.enabled) {
        ele.attr(rolloverProps.outAttr);

        if (rolloverProps.outAnimAttr) {
          ele.animate(rolloverProps.outAnimAttr, 100, ANIM_EFFECT);
        }
      }

      chart.plotEventHandler(ele, dataParam, ROLLOUT);
    };

    while (i--) {
      if (!data[i]) {
        continue;
      }

      config = data[i].config;
      itemValue = NumberFormatter.getCleanValue(config.value); // Set precision for handling decimal upto 10 place.

      itemValue = Number((0, _lib.toPrecision)(itemValue, 10));
      config.itemValue = itemValue;
      graphics = data[i].graphics || (data[i].graphics = {});
      rolloverProperties = config.rolloverProperties || {};
      startAngle = datasetConfig.startAngle;
      idMap[config.id] = {
        index: i,
        config: config
      };
      /**
       * @note
       * The slight increment in starting angle is done to avoid getting
       * angles in multiples of 90 degree (default starting angle is 270).
       * Issue is like, cos(270 deg) is not zero but in the range of e-16,
       * when VML silently fails to render.
       */

      startAngle += 0.2;
      shadowObj = showPointerShadow ? {
        opacity: Math.max(config.bgAlpha, config.borderAlpha) / 100
      } : false;
      link = config.dataLink;
      eventArgs = {
        index: i,
        link: link,
        value: config.itemValue,
        displayValue: config.displayValue,
        toolText: config.toolText,
        bgAlpha: config.bgAlpha,
        borderAlpha: config.borderAlpha,
        borderColor: config.borderColor,
        borderThickness: config.borderWidth,
        color: config.bgColor,
        editMode: config.editMode,
        id: config.id,
        radius: config.radius,
        showValue: config.showValue,
        sides: config.sides
      };
      pointer = graphics.pointer;
      pointer = animationManager.setAnimation({
        el: pointer || 'polypath',
        attr: {
          polypath: [config.sides, isScaleReversed // if scale is reversed pointer's xPos will be shifted from canvas end
          ? width - width * ((0, _lib.pluckNumber)(config.itemValue, min) - min) / (max - min) : width * ((0, _lib.pluckNumber)(config.itemValue, min) - min) / (max - min), pointerY || 0, config.radius, startAngle, 0],
          r: config.radius,
          fill: config.fillColor,
          stroke: config.pointerBorderColor,
          'stroke-width': config.borderWidth
        },
        css: link || config.editMode ? {
          cursor: POINTER,
          '_cursor': 'hand'
        } : {
          cursor: _lib.BLANK,
          '_cursor': _lib.BLANK
        },
        label: 'pointers',
        container: wGroup,
        component: dataSet
      }).show();

      if (!graphics.pointer) {
        graphics.pointer = pointer.on('fc-click', clickHandler).shadow(!!shadowObj, shadowObj && shadowObj.opacity).hover(hoverRollOver, hoverRollOut);
        pointer.show();
      }

      if (!isRTupdate) {
        pointer.data(EVENTARGS, eventArgs).data('rolloverProperties', rolloverProperties);
        config._startAngle = startAngle;

        if (config.editMode) {
          config.index = i;
          config.editMode = true;
        } else {
          config.editMode = false;
        }

        pointer.undrag();
        config.editMode && pointer.drag(pointerOnDrag, pointerDragStart, pointerDragEnd, config, config, data[i]);
      }

      if (showTooltip) {
        toolTipController.enableToolTip(pointer, config.toolText);
      } else {
        toolTipController.disableToolTip(pointer);
      }
    }

    dataSet._drawBackground();

    isRTupdate ? dataSet.drawPointerValues(animation) : dataSet._drawWidgetLabel(animation);
  }
  /**
   * Alters the data of the dataset and stores the data to be removed in a different array
   * @param {number} numbers number of data to be removed
   */
  ;

  _proto.removeData = function removeData(numbers) {
    var dataSet = this,
        data = dataSet.components.data,
        graphics,
        dataObj,
        callbackFN = function callbackFN() {
      this.hide();
    };

    dataSet.removeDataArr || (dataSet.removeDataArr = []);

    for (var i = 0; i < numbers; i++) {
      dataObj = data[i];

      if (!dataObj) {
        continue;
      }

      graphics = dataObj.graphics;
      graphics.pointer && dataSet.getFromEnv('animationManager').setAnimation({
        el: graphics.pointer,
        callback: callbackFN,
        component: dataSet
      });
      graphics.pointerValue && dataSet.getFromEnv('animationManager').setAnimation({
        el: graphics.pointerValue,
        callback: callbackFN,
        component: dataSet
      });
      graphics.pointerValueCont && dataSet.getFromEnv('animationManager').setAnimation({
        el: graphics.pointerValueCont,
        callback: callbackFN,
        component: dataSet
      });
    }

    dataSet.removeDataArr = dataSet.removeDataArr.concat(data.splice(0, numbers));
  }
  /**
   * draws Widget background(color range) values, trend point values and calls drawPointerValues
   * @param {Object} animation animation object to check whether to animate
   */
  ;

  _proto._drawWidgetLabel = function _drawWidgetLabel(animation) {
    var dataSet = this,
        chart = dataSet.getFromEnv('chart'),
        toolTipController = dataSet.getFromEnv('toolTipController'),
        chartConfig = chart.config,
        numberFormatter = dataSet.getFromEnv('number-formatter'),
        scale = dataSet.getFromEnv('scale'),
        animationManager = dataSet.getFromEnv('animationManager'),
        canvas = chart.getChildren('canvas')[0],
        dataLabelsGroup = chart.getChildContainer('datalabelsGroup'),
        dataLabelContainer = canvas.getGraphicalElement('dataLabelContainer'),
        min = scale.config.axisRange.min,
        max = scale.config.axisRange.max,
        datasetConfig = dataSet.config,
        textDirection = datasetConfig.textDirection,
        gaugeType = 1,
        // series.gaugeType,
    colorRange = dataSet.getFromEnv('colorRange'),
        jsonData = chart.getFromEnv('dataSource'),
        colorArr = jsonData.colorrange && colorRange && colorRange.getColorRangeArr(min, max),
        colorRangeStyle = datasetConfig.colorRangeStyle || {},
        showvalue = datasetConfig.showvalue,
        colorObj,
        trendArr = chart.getFromEnv('dataSource').trendpoints && chart.getFromEnv('dataSource').trendpoints.point,
        trendPointConfig = chartConfig.trendPointConfig,
        width = chartConfig.canvasWidth,
        height = chartConfig.canvasHeight,
        marginRight = chartConfig.marginRight,
        pointerOnOpp = datasetConfig.pointerOnOpp,
        valueInsideGauge = datasetConfig.valueInsideGauge,
        showGaugeLabels = datasetConfig.showGaugeLabels,
        isScaleReversed = datasetConfig.isScaleReversed,
        style = chartConfig.dataLabelStyle,
        rangeWidth,
        // animObj = animationObj.animObj,
    // dummyObj = animationObj.dummyObj,
    // animationDuration = animationObj.duration,
    colorArrLabel,
        maxWidth,
        truncatedWidth,
        i,
        length,
        getPointerLabelXY,
        getColorLabelXY,
        labelXY,
        nextPointer,
        nextOriText,
        nextSmartText,
        nextXY,
        labelGap,
        isSameLevel = false,
        j,
        labelX,
        labelY,
        smartLabel = dataSet.getFromEnv('smartLabel'),
        smartText,
        testStrObj,
        minWidth,
        // labelX, labelY,
    lineHeight = (0, _lib.pluckNumber)(parseInt(style.fontHeight, 10), parseInt(style.lineHeight, 10), 12),
        labelPadding = datasetConfig.currentValuePadding + lineHeight * 0.5,
        hPad = 4,
        innerLabelPadding = 4,
        oppTrendLabelPadding = datasetConfig.currentTrendPadding + lineHeight * 0.5,
        tempx,
        attr,
        trendObj,
        trendLabelPadding = datasetConfig.currentTrendPadding,
        css = {
      fontFamily: style.fontFamily,
      fontSize: style.fontSize,
      lineHeight: style.lineHeight,
      fontWeight: style.fontWeight,
      fontStyle: style.fontStyle
    },
        dataArr = dataSet.config.pointerArr && dataSet.config.pointerArr.pointer,
        config,
        components = dataSet.components,
        data = components.data,
        value,
        valueCont,
        trendTextElem;
    dataLabelContainer = animationManager.setAnimation({
      el: dataLabelContainer || 'group',
      attr: {
        name: 'label-container'
      },
      container: dataLabelsGroup,
      component: dataSet
    });
    dataLabelsGroup = animationManager.setAnimation({
      el: dataLabelsGroup || 'group',
      state: 'initial',
      attr: {
        transform: ['T', chartConfig.canvasLeft, chartConfig.canvasTop]
      },
      label: 'datalabel',
      component: dataSet
    });
    !canvas.getGraphicalElement('dataLabelContainer') && (dataLabelContainer = canvas.addGraphicalElement('dataLabelContainer', dataLabelContainer)); // tempLabelPadding = labelPadding - (lineHeight / 4);
    // if label is below the pointer then we need to add extra pdding to compensate for lineheight.

    labelPadding = valueInsideGauge === pointerOnOpp ? labelPadding - lineHeight / 4 : labelPadding + lineHeight / 4;
    smartLabel.useEllipsesOnOverflow(chartConfig.useEllipsesWhenOverflow);
    smartLabel.setStyle(css);
    testStrObj = smartLabel.getOriSize('W...');
    minWidth = testStrObj.width;
    colorRangeStyle.fontWeight = _lib.NORMAL;

    if (gaugeType === 1) {
      // horizontal gauge; left to right;
      getPointerLabelXY = dataSet.getPointerLabelXY = function (val, isInside, pointerOnOpposite, xsHeight, xsWidth) {
        var y;

        if (pointerOnOpposite) {
          y = isInside ? height - xsHeight - labelPadding : height + labelPadding;
        } else {
          y = isInside ? labelPadding : -(labelPadding + xsHeight);
        }

        tempx = (val - min) * width / (max - min);
        tempx + xsWidth > width + marginRight && (tempx = width - xsWidth + marginRight);
        return {
          x: tempx,
          y: y,
          align: POSITION_MIDDLE
        };
      };

      getColorLabelXY = function getColorLabelXY(minvalue, maxvalue) {
        rangeWidth = (maxvalue - minvalue) * width / (max - min); // If scale is reversed xPos of label will be shifted from canvas end

        return {
          x: (isScaleReversed ? width - rangeWidth - minvalue * width / (max - min) : minvalue * width / (max - min)) + rangeWidth / 2,
          y: height / 2,
          width: (maxvalue - minvalue) * width / (max - min),
          height: height
        };
      };
    } else if (gaugeType === 2) {
      // vertical gauge; top to bottom;
      getPointerLabelXY = dataSet.getPointerLabelXY = function (val, isInside, pointerOnOpposite) {
        var x, align;

        if (pointerOnOpposite) {
          if (isInside) {
            align = _lib.POSITION_RIGHT;
            x = width - labelPadding;
          } else {
            align = _lib.POSITION_LEFT;
            x = width + labelPadding;
          }
        } else {
          if (isInside) {
            align = _lib.POSITION_LEFT;
            x = labelPadding;
          } else {
            align = _lib.POSITION_RIGHT;
            x = -labelPadding;
          }
        }

        return {
          x: x,
          y: val * height / (max - min),
          align: align
        };
      };

      getColorLabelXY = function getColorLabelXY(minvalue, maxvalue) {
        return {
          y: (minvalue - min + (maxvalue - minvalue) / 2) * height / (max - min),
          x: width / 2,
          height: (maxvalue - minvalue) * height / (max - min),
          width: width
        };
      };
    } else if (gaugeType === 3) {
      // horizontal linear gauge; right to left;
      getPointerLabelXY = dataSet.getPointerLabelXY = function (val, isInside, pointerOnOpposite) {
        var y;

        if (pointerOnOpposite) {
          y = isInside ? height - labelPadding : height + labelPadding;
        } else {
          y = isInside ? labelPadding : -labelPadding;
        }

        return {
          x: width - (val - min) * width / (max - min),
          y: y,
          align: POSITION_MIDDLE
        };
      };

      getColorLabelXY = function getColorLabelXY(minvalue, maxvalue) {
        return {
          x: width - (minvalue - min + (maxvalue - minvalue) / 2) * width / (max - min),
          y: height / 2,
          width: (maxvalue - minvalue) * width / (max - min),
          height: height
        };
      };
    } else {
      // vertical linear gauge; bottom to top;
      getPointerLabelXY = dataSet.getPointerLabelXY = function (val, isInside, pointerOnOpposite) {
        var x, align;

        if (pointerOnOpposite) {
          if (isInside) {
            align = _lib.POSITION_RIGHT;
            x = width - labelPadding;
          } else {
            align = _lib.POSITION_LEFT;
            x = width + labelPadding;
          }
        } else {
          if (isInside) {
            align = _lib.POSITION_LEFT;
            x = labelPadding;
          } else {
            align = _lib.POSITION_RIGHT;
            x = -labelPadding;
          }
        }

        return {
          x: x,
          y: height - val * height / (max - min),
          align: align
        };
      };

      getColorLabelXY = function getColorLabelXY(minvalue, maxvalue) {
        return {
          y: height - (minvalue - min + (maxvalue - minvalue) / 2) * height / (max - min),
          x: width / 2,
          height: (maxvalue - minvalue) * height / (max - min),
          width: width
        };
      };
    }

    if (dataArr && dataArr.length) {
      i = dataArr.length;

      while (i--) {
        if (!data[i]) {
          continue;
        }

        config = data[i].config;

        if (showvalue !== 0 && config.displayValue !== BLANKSTRING) {
          smartText = smartLabel.getOriSize(config.displayValue);

          if (config.setWidth) {
            smartText = smartLabel.getSmartText(config.displayValue, config.setWidth, smartText.height, true);
          }

          labelXY = dataSet.getPointerLabelXY(config.itemValue, valueInsideGauge, pointerOnOpp, smartText.height / 2, smartText.width / 2);

          if (config.isLabelString) {
            isSameLevel = false;
            j = 1;

            while (!isSameLevel) {
              nextPointer = dataArr[i + j];

              if (!nextPointer) {
                break;
              }

              if (nextPointer.isLabelString) {
                isSameLevel = true;
              } else {
                j += 1;
              }
            }

            if (nextPointer) {
              nextOriText = smartLabel.getOriSize(nextPointer.displayValue);
              nextXY = getPointerLabelXY(nextPointer.y, valueInsideGauge, pointerOnOpp, nextOriText.height / 2); // calculate the overlapping area's width

              labelGap = nextXY.x - nextOriText.width / 2 - (labelXY.x + smartText.width / 2); // get the max width i.e the distance between the pointers

              maxWidth = nextXY.x - labelXY.x;

              if (labelGap < 0) {
                // calculate the truncated width using labelGap (should be -ve)
                truncatedWidth = smartText.width + labelGap; // the truncated width cannot be more than max width.

                if (truncatedWidth > maxWidth) {
                  config.setWidth = truncatedWidth = maxWidth;
                }

                if (truncatedWidth > minWidth) {
                  if (config.setWidth && config.setWidth <= truncatedWidth) {
                    nextSmartText = smartLabel.getSmartText(config.displayValue, config.setWidth, smartText.height, true);
                    config.displayValue = nextSmartText.text;
                    nextSmartText.tooltext && (config.originalText = nextSmartText.tooltext);
                  } else {
                    nextSmartText = smartLabel.getSmartText(config.displayValue, truncatedWidth, smartText.height, true);
                    config.displayValue = nextSmartText.text;
                    nextSmartText.tooltext && (config.originalText = nextSmartText.tooltext);
                  }
                } else {
                  nextSmartText = smartLabel.getSmartText(config.displayValue, minWidth, smartText.height, true);
                  config.displayValue = nextSmartText.text;
                  nextSmartText.tooltext && (config.originalText = nextSmartText.tooltext); // since the labelGap was not split equally we have to recalculate
                  // labelGap so that the next label will adjust accordingly.

                  labelGap = labelGap * 2 + minWidth - hPad;
                }

                config.setWidth = null;
                truncatedWidth = nextOriText.width + labelGap - hPad;

                if (truncatedWidth > maxWidth) {
                  nextPointer.setWidth = maxWidth;
                } else if (truncatedWidth > minWidth) {
                  nextPointer.setWidth = truncatedWidth;
                } else {
                  nextPointer.setWidth = minWidth;
                }
              }
            }

            if (config.setWidth) {
              nextSmartText = smartLabel.getSmartText(config.displayValue, config.setWidth, smartText.height, true);
              config.displayValue = nextSmartText.text;
              nextSmartText.tooltext && (config.originalText = nextSmartText.tooltext);
              config.setWidth = null;
            }
          }
        }
      }
    }

    dataSet.drawPointerValues(animation);
    smartLabel.setStyle(colorRangeStyle); // Draw the colorRange labels

    if (colorArr && showGaugeLabels) {
      for (i = 0, length = colorArr.length; i < length; i += 1) {
        colorObj = isScaleReversed ? colorArr[length - 1 - i] : colorArr[i];
        colorArrLabel = (0, _lib.pluck)(colorObj.label, colorObj.name);
        labelXY = getColorLabelXY(colorObj.minvalue - min, colorObj.maxvalue - min);

        if (labelXY.width - innerLabelPadding > minWidth && labelXY.height - innerLabelPadding > lineHeight) {
          smartText = smartLabel.getSmartText(colorArrLabel, labelXY.width - innerLabelPadding, labelXY.height - innerLabelPadding);
        } else {
          smartText = smartLabel.getSmartText(colorArrLabel, labelXY.width, labelXY.height);
        }

        attr = {
          'text-anchor': POSITION_MIDDLE,
          'vertical-align': POSITION_MIDDLE,
          x: labelXY.x,
          y: labelXY.y,
          direction: textDirection,
          fill: (0, _lib.convertColor)(colorRangeStyle.color),
          text: smartText.text
        };
        valueCont = canvas.getGraphicalElement('colorRangeLabelsCont') && canvas.getGraphicalElement('colorRangeLabelsCont')[i];
        valueCont = animationManager.setAnimation({
          el: valueCont || 'group',
          attr: {
            name: 'color-range-label'
          },
          component: dataSet,
          container: dataLabelContainer,
          label: 'final'
        });
        value = canvas.getGraphicalElement('colorRangeLabels') && canvas.getGraphicalElement('colorRangeLabels')[i];
        value = animationManager.setAnimation({
          el: value || 'text',
          attr: attr,
          css: colorRangeStyle,
          component: dataSet,
          container: valueCont,
          label: 'final'
        });
        value.outlineText(datasetConfig.showTextOutline, attr.fill);

        if (!(canvas.getGraphicalElement('colorRangeLabels') && canvas.getGraphicalElement('colorRangeLabels')[i])) {
          valueCont = canvas.addGraphicalElement('colorRangeLabelsCont', valueCont, true, i);
          value = canvas.addGraphicalElement('colorRangeLabels', value, true, i);
        } else {
          value.show();
          toolTipController.enableToolTip(value, smartText.tooltext);
        }
      }
    } else {
      // Setting i to 0 so that any previously existing trendlabels can be hidden.
      i = 0;
    } // Hiding the unused colorrangeLabels


    while (canvas.getGraphicalElement('colorRangeLabelsCont') && canvas.getGraphicalElement('colorRangeLabelsCont')[i]) {
      canvas.getGraphicalElement('colorRangeLabelsCont')[i].hide();
      i++;
    } // Drawing the display value of trend points


    if (trendArr) {
      for (i = 0, length = trendPointConfig.length; i < length; i += 1) {
        trendObj = trendPointConfig[i];
        trendObj.displayValue = (0, _lib.pluck)(trendObj.displayValue, numberFormatter.dataLabels(trendObj.startValue));
        smartLabel.setStyle(trendObj.style);
        lineHeight = smartLabel.getOriSize('Wg').height;
        smartText = smartLabel.getOriSize(trendObj.displayValue);
        labelXY = getPointerLabelXY(trendObj.startValue, 0, !trendObj.showOnTop);

        if (trendObj.setWidth) {
          smartText = smartLabel.getSmartText(trendObj.displayValue, trendObj.setWidth, smartText.height, true);
        }

        isSameLevel = false;
        j = 1;

        while (!isSameLevel) {
          nextPointer = trendArr[i + j];

          if (!nextPointer) {
            break;
          }

          if (nextPointer.showOnTop === trendObj.showOnTop) {
            isSameLevel = true;
          } else {
            j += 1;
          }
        }

        if (nextPointer) {
          nextOriText = smartLabel.getOriSize(nextPointer.displayValue);
          nextXY = getPointerLabelXY(nextPointer.startValue, 0, !nextPointer.showOnTop); // refer to the docs of pointer label drawing above.

          labelGap = nextXY.x - nextOriText.width / 2 - (labelXY.x + smartText.width / 2);

          if (labelGap < 0) {
            maxWidth = nextXY.x - labelXY.x;
            truncatedWidth = smartText.width + labelGap;

            if (truncatedWidth > maxWidth) {
              trendObj.setWidth = truncatedWidth = maxWidth;
            }

            if (truncatedWidth > minWidth) {
              if (trendObj.setWidth && trendObj.setWidth <= truncatedWidth) {
                smartText = smartLabel.getSmartText(trendObj.displayValue, trendObj.setWidth, smartText.height, true);
                trendObj.displayValue = smartText.text;
                smartText.tooltext && (trendObj.originalText = smartText.tooltext);
              } else {
                smartText = smartLabel.getSmartText(trendObj.displayValue, smartText.width + labelGap - hPad, smartText.height, true);
                trendObj.displayValue = smartText.text;
                smartText.tooltext && (trendObj.originalText = smartText.tooltext);
              }
            } else {
              smartText = smartLabel.getSmartText(trendObj.displayValue, minWidth, smartText.height, true);
              trendObj.displayValue = smartText.text;
              smartText.tooltext && (trendObj.originalText = smartText.tooltext);
              labelGap = labelGap * 2 + minWidth - hPad;
            }

            trendObj.setWidth = null;
            truncatedWidth = nextOriText.width + labelGap - hPad;

            if (truncatedWidth > maxWidth) {
              nextPointer.setWidth = maxWidth;
            } else if (truncatedWidth > minWidth) {
              nextPointer.setWidth = truncatedWidth;
            } else {
              nextPointer.setWidth = minWidth;
            }
          }
        }

        if (trendObj.setWidth) {
          smartText = smartLabel.getSmartText(trendObj.displayValue, trendObj.setWidth, smartText.height, true);
          trendObj.displayValue = smartText.text;
          smartText.tooltext && (trendObj.originalText = smartText.tooltext);
          trendObj.setWidth = null;
        }

        labelY = trendObj.showOnTop ? -(trendLabelPadding + smartText.height / 2) : height + oppTrendLabelPadding;
        labelX = trendObj.isTrendZone ? getColorLabelXY(trendObj.startValue, trendObj.endValue).x : labelXY.x;
        trendTextElem = canvas.getGraphicalElement('trendTextElems') && canvas.getGraphicalElement('trendTextElems')[i];
        trendTextElem = animationManager.setAnimation({
          el: trendTextElem || 'text',
          attr: {
            x: labelX,
            y: labelY,
            text: trendObj.displayValue,
            'text-anchor': textHAlign[labelXY.align],
            fill: (0, _lib.convertColor)(trendObj.textColor || colorRangeStyle.color),
            'font-weight': 'normal',
            direction: textDirection,
            opacity: 1,
            title: trendObj.originalText || _lib.BLANK
          },
          container: dataLabelContainer,
          component: dataSet,
          label: 'final'
        });

        if (!(canvas.getGraphicalElement('trendTextElems') && canvas.getGraphicalElement('trendTextElems')[i])) {
          trendTextElem = canvas.addGraphicalElement('trendTextElems', trendTextElem, true, i);
        }

        trendTextElem.show();
      }
    } else {
      // Setting i to 0 so that any previously existing trendlabels can be hidden.
      i = 0;
    } // Hiding the unused trendLabels


    while (canvas.getGraphicalElement('trendTextElems') && canvas.getGraphicalElement('trendTextElems')[i]) {
      canvas.getGraphicalElement('trendTextElems')[i].hide();
      i++;
    }
  }
  /**
   * Draw pointer values
   */
  ;

  _proto.drawPointerValues = function drawPointerValues() {
    var dataSet = this,
        chart = dataSet.getFromEnv('chart'),
        dataLabelsGroup = chart.getChildContainer('datalabelsGroup'),
        data = dataSet.components.data,
        datasetConfig = dataSet.config,
        showTooltip = datasetConfig.showTooltip,
        toolTipController = dataSet.getFromEnv('toolTipController'),
        tooltipVal,
        pointerOnOpp = datasetConfig.pointerOnOpp,
        valueInsideGauge = datasetConfig.valueInsideGauge,
        textDirection = datasetConfig.textDirection,
        showValue,
        animationManager = dataSet.getFromEnv('animationManager'),
        smartLabel = dataSet.getFromEnv('smartLabel'),
        chartData = dataSet.config.pointerArr && dataSet.config.pointerArr.pointer,
        style = chart.config.dataLabelStyle,
        i = chartData && chartData.length,
        config,
        pointerValue,
        pointerValueCont,
        pointerLabelStyle,
        // animObj = animationObj.animObj,
    // dummyObj = animationObj.dummyObj,
    // animationDuration = (animation || animationObj).duration,
    chartConfig = chart.config,
        width = chartConfig.canvasWidth,
        marginLeft = chartConfig.marginLeft,
        css = {
      fontFamily: style.fontFamily,
      fontSize: style.fontSize,
      lineHeight: style.lineHeight,
      fontWeight: style.fontWeight,
      fontStyle: style.fontStyle
    },
        displayValue,
        labelXY,
        halfWidth,
        height,
        graphics,
        smartText,
        pool = dataSet.pool,
        attr,
        textCreated;

    if (chart.state === 'initial') {
      animationManager.setAnimation({
        state: 'initial',
        el: dataLabelsGroup,
        attr: {
          opacity: 1
        },
        component: dataSet
      });
    }

    smartLabel.setStyle(style);

    while (i--) {
      if (!data[i]) {
        continue;
      }

      textCreated = false;
      graphics = data[i].graphics;
      config = data[i].config;
      displayValue = config.displayValue;
      showValue = config.showValue;
      pointerLabelStyle = config.dataLabelStyle;

      if (showValue !== 0 && displayValue !== BLANKSTRING) {
        smartText = smartLabel.getOriSize(displayValue);
        height = smartText.height;
        smartText = smartLabel.getSmartText(displayValue, chartConfig.width, height);
        halfWidth = smartText.width / 2;
        labelXY = dataSet.getPointerLabelXY(config.itemValue, valueInsideGauge, pointerOnOpp, height * 0.5, halfWidth); // Fix for long decimal numbers moving out of the canvas.

        halfWidth > marginLeft + labelXY.x && (labelXY.x = halfWidth - marginLeft);
        tooltipVal = smartText.tooltext || BLANKSTRING;
        attr = {
          // If scale is reversed xPos of label of pointer will be shifted from canvas end
          x: datasetConfig.isScaleReversed ? width - labelXY.x : labelXY.x,
          y: labelXY.y,
          'text-anchor': textHAlign[labelXY.align],
          title: config.originalText || _lib.BLANK,
          text: smartText.text,
          fill: pointerLabelStyle.color,
          direction: textDirection,
          'text-bound': [pointerLabelStyle.backgroundColor, pointerLabelStyle.borderColor, style.borderThickness, style.borderPadding, style.borderRadius, style.borderDash]
        };
        pointerValueCont = animationManager.setAnimation({
          el: graphics.pointerValueCont || pool && pool.pointerValueCont[0] || 'group',
          attr: {
            name: 'label-group'
          },
          container: dataLabelsGroup,
          component: dataSet,
          label: 'labelGroup'
        }).show();
        pointerValue = animationManager.setAnimation({
          el: graphics.pointerValue || pool && pool.pointerValue[0] || 'text',
          attr: attr,
          css: css,
          container: pointerValueCont,
          component: dataSet,
          label: 'pointerValues'
        }).show();
        pointerValue.outlineText(datasetConfig.showTextOutline, attr.fill);

        if (showTooltip) {
          toolTipController.enableToolTip(pointerValue, tooltipVal);
        } else {
          toolTipController.disableToolTip(pointerValue);
        }

        if (!graphics.pointerValue) {
          if (pool && pool.pointerValue[0]) {
            pool.pointerValue.splice(0, 1);
            pool.pointerValueCont.splice(0, 1);
          } else {
            textCreated = true;
          }
        }

        graphics.pointerValue = pointerValue;
        graphics.pointerValueCont = pointerValueCont; // Applying attr from second time ownwards during update.

        if (!textCreated) {
          pointerValue.show();
        }
      } else {
        graphics.pointerValue && graphics.pointerValue.hide();
        graphics.pointerValueCont && graphics.pointerValueCont.hide();
        graphics.pointerValue && toolTipController.disableToolTip(graphics.pointerValue);
      }
    }
  }
  /**
   * Sets axis limits
   * @return {Object} object consists of maximum and minimum limit
   */
  ;

  _proto.getDataLimits = function getDataLimits() {
    var dataSet = this,
        config = dataSet.config,
        jsonData = dataSet.getFromEnv('chart').getFromEnv('dataSource'),
        pointerArr = dataSet.components.data || dataSet.config.pointerArr && dataSet.config.pointerArr.pointer || jsonData.dials && jsonData.dials.dial,
        colorRange = jsonData.colorrange,
        colorArr = colorRange && colorRange.color,
        length = pointerArr && pointerArr.length,
        i,
        pointerMinVal,
        pointerMaxVal,
        upperLimit = config.upperLimit,
        lowerLimit = config.lowerLimit,
        value,
        maxColorRangeVal,
        minColorRangeVal,
        max = -Infinity,
        min = +Infinity; // finding max min amongst the pointer value

    for (i = 0; i < length; i++) {
      value = pointerArr[i].config.value;

      if (value === _lib.BLANK) {
        continue;
      }

      pointerMaxVal = max = mathMax(max, Number(value));
      pointerMinVal = min = mathMin(min, Number(value));
    }

    length = colorArr && colorArr.length; // finding max min amongst the color range value but it has a lower
    // priority than upperlimit and lowerlimit set by the user.

    for (i = 0; i < length; i++) {
      maxColorRangeVal = Number(colorArr[i].maxvalue);
      minColorRangeVal = Number(colorArr[i].minvalue);
      upperLimit && maxColorRangeVal > upperLimit && (maxColorRangeVal = upperLimit);
      lowerLimit && minColorRangeVal < lowerLimit && (minColorRangeVal = lowerLimit);
      min = (0, _safeMin.default)([min, minColorRangeVal]);
      max = (0, _safeMax.default)([max, maxColorRangeVal]);
    }

    return {
      forceMin: pointerMinVal !== min,
      forceMax: pointerMaxVal !== max,
      max: max,
      min: min
    };
  }
  /**
   * Function to update the hlinear data via drag mode or realTime update
   * @param {Object} updateObjParam data object to realTime update
   * @param {Object} updateAnimation animation required for realTime update
   * @return {boolean} return whether new data is empty or not
   */
  ;

  _proto.updateData = function updateData(updateObjParam, updateAnimation) {
    if (updateObjParam === this.config.lastUpdatedObj) {
      return false;
    }

    var dataSet = this,
        chart = dataSet.getFromEnv('chart'),
        numberFormatter = dataSet.getFromEnv('number-formatter'),
        data = dataSet.components.data,
        label,
        toolText,
        showLabel,
        dataArr = dataSet.components.data,
        i = dataArr && dataArr.length || 0,
        j,
        id,
        updateById,
        updateDataMap = {},
        updateObjLength,
        dataObj,
        config,
        formatedValue = null,
        newData = [],
        updateData,
        chartAttrs = dataSet.getFromEnv('chart-attrib'),
        plottooltext = chartAttrs.plottooltext,
        valueFontColor,
        valueBgColor,
        valueBorderColor,
        value,
        animation,
        pointObj,
        updateObj = updateObjParam;
    updateObj = updateObj.data; // use the realtime animation value or the default animation value

    animation = updateAnimation || chart.get(configStr, animationObjStr);
    updateObjLength = updateObj.length; // Store the IDs and corresponding data in hashmap.

    for (j = 0; j < updateObjLength; j++) {
      id = updateObj[j].id;
      id && (updateDataMap[id] = updateObj[j]);
    }

    updateById = Object.keys(updateDataMap).length;

    if (i) {
      while (i--) {
        dataObj = {};
        pointObj = {};
        config = data[i].config;
        id = config.id;
        updateData = UNDEF; // Check if update is done by ID of pointer or sequentially.

        updateData = updateById ? updateDataMap[id] : updateObj[i];

        if (!updateData) {
          continue;
        }

        value = updateData.value;
        toolText = updateData.tooltext;
        label = updateData.label;
        showLabel = updateData.showlabel;
        valueFontColor = updateData.valuefontcolor;
        valueBgColor = updateData.valuebgcolor;
        valueBorderColor = updateData.valuebordercolor;

        if (value !== UNDEF && value !== _lib.BLANK) {
          dataObj.value = pointObj.value = value;
          formatedValue = pointObj.displayvalue = pointObj.tooltext = numberFormatter.dataLabels(pointObj.value);
          pointObj.hasNewData = true;
        } else {
          pointObj.value = config.formatedVal;
        } // update the value cosmetics


        if (valueFontColor) {
          config.dataLabelStyle.color = (0, _lib.convertColor)(valueFontColor);
        }

        if (valueBgColor) {
          config.dataLabelStyle.backgroundColor = (0, _lib.convertColor)(valueBgColor);
        }

        if (valueBorderColor) {
          config.dataLabelStyle.borderColor = (0, _lib.convertColor)(valueBorderColor);
        }

        if (label) {
          pointObj.displayvalue = label;
          pointObj.hasNewData = true;
        }

        if (showLabel === '0') {
          pointObj.displayvalue = BLANKSTRING;
          pointObj.hasNewData = true;
        }

        if (toolText) {
          pointObj.hasNewData = true;
        }

        toolText = (0, _lib.getValidValue)((0, _lib.parseUnsafeString)((0, _lib.pluck)(toolText, plottooltext), false));

        if (pointObj.hasNewData) {
          newData[i] = pointObj;
          config.value = pointObj.value;
          config.displayValue = config.displayValue || showLabel === '1' ? pointObj.displayvalue : BLANKSTRING;
          config.toolText = toolText !== UNDEF ? (0, _lib.parseTooltext)(toolText, [1, 2], {
            formattedValue: formatedValue
          }, dataObj) : formatedValue;
        }
      }

      if (newData.length) {
        // Storing updateObj to skip update if same information is provided sequentially.
        this.config.lastUpdatedObj = updateObj;
        this.draw(animation, true);
      }

      return Boolean(newData.length);
    }
  };

  return HlineargaugeDataset;
}(_componentInterface.ComponentInterface);

HlineargaugeDataset.prototype._configureDataLabelStyle = _lib.configureDataLabelStyle;
var _default = HlineargaugeDataset;
exports["default"] = _default;

/***/ }),

/***/ 1515:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



exports.__esModule = true;
exports["default"] = void 0;

var _lib = __webpack_require__(274);

var fadeEffect = [{
  initialAttr: function initialAttr() {
    return {
      opacity: 0
    };
  },
  finalAttr: function finalAttr() {
    return {
      opacity: 1
    };
  }
}];
var _default = {
  'initial.dataset.led': function initialDatasetLed() {
    var component = this,
        conf = component.config,
        chart = component.getFromEnv('chart'),
        chartConfig = chart.config,
        canvasLeft = chartConfig.canvasLeft,
        canvasTop = chartConfig.canvasTop,
        canvasHeight = chartConfig.canvasHeight,
        canvasWidth = chartConfig.canvasWidth;
    return {
      'plotRect.appearing': function plotRectAppearing() {
        var attr,
            isAxisReverse = conf.isAxisReverse,
            isHorizontal = conf.isHorizontal;

        if (isAxisReverse && !isHorizontal) {
          attr = {
            y: canvasTop,
            height: canvasHeight
          };
        } else if (!isAxisReverse && !isHorizontal) {
          attr = {
            height: canvasHeight
          };
        } else if (!isAxisReverse && isHorizontal) {
          attr = {
            x: canvasLeft,
            width: canvasWidth
          };
        } else if (isAxisReverse && isHorizontal) {
          attr = {
            width: canvasWidth
          };
        }

        return [{
          initialAttr: {
            opacity: 0
          },
          finalAttr: {
            opacity: 1
          },
          slot: 'initial'
        }, {
          initialAttr: attr,
          finalAttr: {
            opacity: 1
          },
          slot: 'middle'
        }];
      },
      'plotRect.updating': null,
      'text.appearing': function textAppearing() {
        fadeEffect[0].slot = _lib.FINALSTR;
        return fadeEffect;
      },
      'text.updating': null,
      'plotBackground.appearing': function plotBackgroundAppearing() {
        return [Object.assign({}, fadeEffect[0], {
          slot: 'initial'
        })];
      },
      'plotBackground.updating': null
    };
  }
};
exports["default"] = _default;

/***/ }),

/***/ 1512:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _lib = __webpack_require__(274);

var _bullet = _interopRequireDefault(__webpack_require__(1513));

var _dependencyManager = __webpack_require__(282);

var _index = _interopRequireDefault(__webpack_require__(1515));

/* eslint require-jsdoc: 'error', valid-jsdoc: ["error", { "requireReturn": false }] */
var BLANKSTRING = _lib.BLANK,
    // add the tools thats are requared
colorStrings = _lib.preDefStr.colors,
    COLOR_000000 = colorStrings.c000000,
    showHoverEffectStr = _lib.preDefStr.showHoverEffectStr,
    BUTT = 'butt',
    POSITION_MIDDLE = _lib.preDefStr.POSITION_MIDDLE,
    ledColorRangeFillMixStr = '{light-10},{dark-10},{light-10},{dark-10}',
    ledColorRangeFillRatioStr = '0,10,80,10',
    win = window,
    userAgent = win.navigator.userAgent,
    isIE = /msie/i.test(userAgent) && !win.opera,
    TRACKER_FILL = 'rgba(192,192,192,' + (isIE ? 0.002 : 0.000001) + ')',
    math = Math,
    mathRound = math.round,
    mathMax = math.max,
    dropHash = _lib.regex.dropHash,
    // isArray = lib.isArray,
SETROLLOVERATTR = 'setRolloverAttr',
    SETROLLOUTATTR = 'setRolloutAttr',
    EVENTARGS = 'eventArgs',
    UNDEF,
    M = 'M',
    L = 'L',
    Z = 'Z';
(0, _dependencyManager.addDep)({
  name: 'ledAnimation',
  type: 'animationRule',
  extension: _index.default
});
/**
 * Creates the LedDataset class for led plot
 */

var LedDataset = /*#__PURE__*/function (_BulletDataset) {
  (0, _inheritsLoose2.default)(LedDataset, _BulletDataset);

  function LedDataset() {
    return _BulletDataset.apply(this, arguments) || this;
  }

  var _proto = LedDataset.prototype;

  /**
   * Sets the type of the component
   * @return {string} type
   */
  _proto.getType = function getType() {
    return 'dataset';
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */
  ;

  _proto.getName = function getName() {
    return 'led';
  }
  /**
   * Draw Led plot
   */
  ;

  _proto.draw = function draw() {
    var dataSet = this,
        chart = dataSet.getFromEnv('chart'),
        conf = dataSet.config,
        chartAttr = chart.getFromEnv('dataSource').chart,
        chartConfig = chart.config,
        canvas = chart.getChildren('canvas')[0],
        graphics = canvas.getGraphicalElement(),
        config = canvas.config,
        canvasBorderElement = graphics.canvasBorderElement,
        colorRangeElems = graphics.colorRangeElems,
        canvasElementPath = graphics.canvasElementPath,
        canvasHotElement = graphics.canvasHotElement,
        canvasLeft = chartConfig.canvasLeft,
        canvasRight = chartConfig.canvasRight,
        canvasTop = chartConfig.canvasTop,
        canvasBottom = chartConfig.canvasBottom,
        canvasWidth = chartConfig.canvasWidth,
        canvasHeight = chartConfig.canvasHeight,
        parentContainer = chart.getChildContainer().plotGroup,
        scale = dataSet.getFromEnv('scale'),
        min = scale.getLimit().min,
        max = scale.getLimit().max,
        isAxisReverse = (0, _lib.pluckNumber)(chart.getFromEnv('dataSource').chart.reverseaxis, chart.isAxisReverse),
        isHorizontal = chart.isHorizontal,
        getRectXY = function getRectXY(minValue, maxValue) {
      if (isAxisReverse && !isHorizontal) {
        return {
          x: canvasLeft,
          y: canvasTop + minValue * canvasHeight / (max - min),
          width: canvasWidth,
          height: (maxValue - minValue) * canvasHeight / (max - min)
        };
      } else if (!isAxisReverse && !isHorizontal) {
        return {
          x: canvasLeft,
          y: canvasTop + (canvasHeight - maxValue * canvasHeight / (max - min)),
          width: canvasWidth,
          height: (maxValue - minValue) * canvasHeight / (max - min)
        };
      } else if (isAxisReverse && isHorizontal) {
        return {
          x: canvasLeft + (canvasWidth - maxValue * canvasWidth / (max - min)),
          y: canvasTop,
          width: (maxValue - minValue) * canvasWidth / (max - min),
          height: canvasHeight
        };
      } else if (!isAxisReverse && isHorizontal) {
        return {
          x: canvasLeft + minValue * canvasWidth / (max - min),
          y: canvasTop,
          width: (maxValue - minValue) * canvasWidth / (max - min),
          height: canvasHeight
        };
      }
    },
        angle = 180,
        gaugeFillMix,
        gaugeFillRatio,
        colorArray,
        colorM = dataSet.getFromEnv('color-manager'),
        gaugeBorderColor,
        gaugeBorderAlpha,
        showShadow,
        showGaugeBorder,
        gaugeBorderThickness,
        colorObj,
        i,
        len,
        xyObj,
        color,
        borderColor,
        crColor,
        crAlpha,
        borderAlpha,
        shadowAlpha,
        useSameFillColor,
        useSameFillBgColor,
        ledGap,
        ledSize,
        gaugeFillColor,
        LEDlength,
        sizeGapSum,
        remaningLength,
        valueDistance,
        halfBorderWidth,
        x1,
        y1,
        x2,
        y2,
        noOfLED,
        extraSpace,
        LEDGapStartX,
        LEDGapStartY,
        pathCommand,
        colorRangeGetter,
        numberFormatter = dataSet.getFromEnv('number-formatter'),
        animationManager = chart.getFromEnv('animationManager'),
        useSameFillColorCode,
        lastColor,
        value,
        colorIndex,
        showHoverEffect = conf.showHoverEffect,
        dummyElement,
        // Fired when clicked over the hot elements.
    clickFunc = function clickFunc(data) {
      var ele = this;
      chart.plotEventHandler(ele, data);
    },
        rolloverResponseSetter = function rolloverResponseSetter(colorRangeElements) {
      var ii = 0,
          length,
          elem,
          ele;
      return function () {
        ele = this;

        if (ele.data(showHoverEffectStr) !== 0) {
          for (ii = 0, length = colorRangeElements.length; ii < length; ii += 1) {
            elem = colorRangeElements[ii];
            elem.attr(ele.data(SETROLLOVERATTR)[ii]);
          }
        }
      };
    },
        rolloutResponseSetter = function rolloutResponseSetter(colorRangeElements) {
      var ii = 0,
          length,
          elem,
          ele;
      return function () {
        ele = this;

        if (ele.data(showHoverEffectStr) !== 0) {
          for (ii = 0, length = colorRangeElements.length; ii < length; ii += 1) {
            elem = colorRangeElements[ii];
            elem.attr(ele.data(SETROLLOUTATTR)[ii]);
          }
        }
      };
    },
        setRolloverAttr = [],
        setRolloutAttr = [],
        trackerContainer = dataSet.getContainer('trackerContainer'),
        trackerLayer = chart.getChildContainer('trackerGroup'),
        setLink,
        eventArgs,
        LEDDrawn = 0,
        perLEDValueLength,
        lastX,
        lastY,
        colorLED,
        colorLedLengthPX,
        colorLEDLength,
        isNewElement = false,
        attr;

    if (!trackerContainer) {
      trackerContainer = dataSet.addContainer('trackerContainer', animationManager.setAnimation({
        el: 'group',
        attr: {
          name: 'led-hot'
        },
        container: trackerLayer,
        component: dataSet
      }));
    }

    showGaugeBorder = (0, _lib.pluckNumber)(chartAttr.showgaugeborder, 1);
    gaugeBorderColor = (0, _lib.pluck)(chartAttr.gaugebordercolor, chart.gaugeBorderColor, '333333');
    gaugeBorderThickness = showGaugeBorder ? (0, _lib.pluckNumber)(chartAttr.gaugeborderthickness, chart.gaugeBorderThickness, 2) : 0;
    gaugeBorderAlpha = (0, _lib.pluck)(chartAttr.gaugeborderalpha, _lib.HUNDREDSTRING); // Gauge fill color

    config.gaugeFillColor = gaugeFillColor = (0, _lib.pluck)(chartAttr.gaugefillcolor, chartAttr.ledbgcolor, COLOR_000000); // Whether to use same fill color?

    useSameFillColor = (0, _lib.pluckNumber)(chartAttr.usesamefillcolor, 0); // Same color for back ground

    useSameFillBgColor = (0, _lib.pluckNumber)(chartAttr.usesamefillbgcolor, useSameFillColor);
    conf.ledGap = ledGap = (0, _lib.pluckNumber)(chartAttr.ledgap, 2);
    conf.ledSize = ledSize = (0, _lib.pluckNumber)(chartAttr.ledsize, 2); // plotHoverEffect = pluckNumber(chartAttr.showhovereffect, 0);

    config.colorRangeFillMix = gaugeFillMix = (0, _lib.getFirstDefinedValue)(chartAttr.colorrangefillmix, chartAttr.gaugefillmix, chart.colorRangeFillMix, ledColorRangeFillMixStr);
    config.colorRangeFillRatio = gaugeFillRatio = (0, _lib.getFirstDefinedValue)(chartAttr.colorrangefillratio, chartAttr.gaugefillratio, chart.colorRangeFillRatio, chartAttr.gaugefillratio, ledColorRangeFillRatioStr); // paletteIndex = 0;
    // Get the colorRange from env of dataset

    config.colorRangeGetter = colorRangeGetter = dataSet.getFromEnv('colorRange');
    config.colorArray = colorArray = colorRangeGetter && colorRangeGetter.getColorRangeArr(min, max);
    gaugeBorderColor = (0, _lib.pluck)(gaugeBorderColor, COLOR_000000).replace(dropHash, _lib.HASHSTRING);
    gaugeBorderAlpha = (0, _lib.pluckNumber)(chartAttr.colorrangeborderalpha, chartAttr.gaugeborderalpha, 100);
    showShadow = (0, _lib.pluckNumber)(chartAttr.showshadow, 1);
    showGaugeBorder = (0, _lib.pluckNumber)(chartAttr.showgaugeborder, 1);
    config.colorRangeBorderThickness = gaugeBorderThickness = showGaugeBorder ? (0, _lib.pluckNumber)(chartAttr.colorrangeborderthickness, chartAttr.gaugeborderthickness, 2) : 0;
    LEDlength = !isHorizontal ? canvasHeight : canvasWidth;
    sizeGapSum = ledGap + ledSize || 1;
    remaningLength = LEDlength - ledSize;
    valueDistance = max - min;
    halfBorderWidth = gaugeBorderThickness / 2;
    x1 = canvasLeft - halfBorderWidth;
    y1 = canvasTop - halfBorderWidth;
    x2 = canvasLeft + canvasWidth + halfBorderWidth;
    y2 = canvasTop + canvasHeight + halfBorderWidth;
    noOfLED = parseInt(remaningLength / sizeGapSum, 10) + 1;
    extraSpace = remaningLength % sizeGapSum; // devide the extra space amont all the LED

    ledSize += extraSpace / noOfLED;
    conf.sizeGapSum = sizeGapSum = ledSize + ledGap;
    conf.perLEDValueLength = perLEDValueLength = valueDistance / noOfLED;
    LEDGapStartX = canvasLeft;
    LEDGapStartY = canvasTop;
    setLink = (0, _lib.pluck)(chartAttr.clickurl);
    value = numberFormatter.getCleanValue(chart.getFromEnv('dataSource').value);

    if (useSameFillColor || useSameFillBgColor) {
      for (i = 0, len = colorArray.length; i < len; i += 1) {
        if (value >= colorArray[i].minvalue && value <= colorArray[i].maxvalue) {
          useSameFillColorCode = colorArray[i].code || colorM.getPlotColor(i);
          colorIndex = i;
          break;
        }
      }
    }

    colorArray && colorArray.length > 0 && (lastColor = colorArray[0].code || colorM.getPlotColor(0));
    lastX = isAxisReverse ? canvasRight : canvasLeft;
    lastY = isAxisReverse ? canvasTop : canvasBottom;

    for (i = 0, len = colorArray && colorArray.length; i < len; i += 1) {
      colorObj = colorArray[i];
      xyObj = getRectXY(colorObj.minvalue - min, colorObj.maxvalue - min);
      colorLED = mathRound((colorObj.maxvalue - min) / perLEDValueLength);
      colorLEDLength = colorLED - LEDDrawn;
      LEDDrawn = colorLED;
      colorLedLengthPX = colorLEDLength * sizeGapSum;

      if (!isHorizontal && !isAxisReverse) {
        xyObj.height = colorLedLengthPX - ledGap;
        xyObj.y = lastY - xyObj.height;
        lastY -= colorLedLengthPX;
      } else if (!isHorizontal && isAxisReverse) {
        xyObj.height = colorLedLengthPX - ledGap;
        xyObj.y = lastY;
        lastY += colorLedLengthPX;
      } else if (isHorizontal && !isAxisReverse) {
        xyObj.width = colorLedLengthPX - ledGap;
        xyObj.x = lastX;
        lastX += colorLedLengthPX;
      } else if (isHorizontal && isAxisReverse) {
        xyObj.width = colorLedLengthPX - ledGap;
        xyObj.x = lastX - xyObj.width;
        lastX -= colorLedLengthPX;
      }

      colorObj.x = xyObj.x;
      colorObj.y = xyObj.y;
      colorObj.width = xyObj.width;
      colorObj.height = xyObj.height;

      if (useSameFillColor) {
        color = useSameFillColorCode;
      } else if (useSameFillBgColor && i > colorIndex) {
        color = lastColor;
      } else {
        color = lastColor = colorObj.code || colorM.getPlotColor(i);
      }

      borderColor = (0, _lib.convertColor)((0, _lib.getColorCodeString)((0, _lib.pluck)(colorObj.bordercolor, color), gaugeBorderColor), (0, _lib.pluckNumber)(colorObj.borderalpha, gaugeBorderAlpha)); // shadow = showShadow ? (Math.max(colorObj.alpha, gaugeBorderAlpha) / 100) : null;
      // create the shadow element

      crColor = colorM.parseColorMix(colorObj.code, gaugeFillMix);
      crAlpha = colorM.parseAlphaList(colorObj.alpha, crColor.length);
      borderAlpha = (0, _lib.pluckNumber)(colorObj.borderAlpha, gaugeBorderAlpha);
      shadowAlpha = crAlpha.split(_lib.COMMASTRING);
      shadowAlpha = mathMax.apply(Math, shadowAlpha);
      shadowAlpha = mathMax(gaugeBorderThickness && borderAlpha || 0, shadowAlpha);
      attr = {
        x: xyObj.x,
        y: xyObj.y,
        width: xyObj.width < 0 ? 0 : xyObj.width,
        height: xyObj.height < 0 ? 0 : xyObj.height,
        r: 0,
        'stroke-width': 0,
        stroke: borderColor,
        'fill': (0, _lib.toRaphaelColor)({
          FCcolor: {
            color: color,
            ratio: gaugeFillRatio,
            alpha: crAlpha,
            angle: angle
          }
        })
      };
      dummyElement = animationManager.setAnimation({
        el: colorRangeElems && colorRangeElems[i] || 'rect',
        attr: attr,
        container: parentContainer,
        component: dataSet,
        label: 'plotBackground'
      }).toBack();

      if (!(colorRangeElems && colorRangeElems[i])) {
        // In case colorRange element is not present, add it to _graphics of canvas using the graphics API
        canvas.addGraphicalElement('colorRangeElems', dummyElement, true);
        dummyElement.shadow({
          apply: showShadow,
          opacity: shadowAlpha / 100
        });
      }

      setRolloverAttr.push({
        'stroke-width': 0,
        fill: (0, _lib.toRaphaelColor)({
          FCcolor: {
            color: (0, _lib.getDarkColor)((0, _lib.pluck)(color, COLOR_000000), 80) + _lib.COMMASTRING + (0, _lib.getLightColor)((0, _lib.pluck)(color, COLOR_000000), 80),
            alpha: (0, _lib.pluckNumber)(colorObj.alpha, 100),
            angle: isHorizontal ? 90 : 0
          }
        })
      });
      setRolloutAttr.push({
        'stroke-width': 0,
        fill: (0, _lib.toRaphaelColor)({
          FCcolor: {
            color: (0, _lib.pluck)(color, COLOR_000000),
            alpha: (0, _lib.pluckNumber)(colorObj.alpha, 100)
          }
        })
      });
    } // Remove the extra colorRange elements


    colorRangeElems = canvas.getGraphicalElement('colorRangeElems') || [];
    len = colorRangeElems.length - 1;

    while (len >= i) {
      canvas.removeGraphicalElement(colorRangeElems[len]);
      len--;
    }

    eventArgs = {
      link: setLink,
      value: value
    };
    attr = {
      x: canvasLeft,
      y: canvasTop,
      width: canvasWidth,
      height: canvasHeight,
      'stroke-width': 0,
      fill: TRACKER_FILL
    };

    if (!canvasHotElement) {
      canvasHotElement = graphics.canvasHotElement = animationManager.setAnimation({
        el: 'rect',
        attr: attr,
        container: trackerContainer,
        component: dataSet
      });
      isNewElement = true;
    } else {
      animationManager.setAnimation({
        el: canvasHotElement,
        attr: attr,
        container: trackerContainer,
        component: dataSet
      });
    }

    canvasHotElement.data(EVENTARGS, eventArgs).data(showHoverEffectStr, showHoverEffect).data(SETROLLOVERATTR, setRolloverAttr).data(SETROLLOUTATTR, setRolloutAttr);

    if (isNewElement) {
      if (setLink) {
        canvasHotElement.on('fc-click', clickFunc);
      }

      canvasHotElement.hover(rolloverResponseSetter(colorRangeElems), rolloutResponseSetter(colorRangeElems));
    }

    if (isHorizontal) {
      LEDGapStartX += sizeGapSum - ledGap / 2;
    } else {
      LEDGapStartY += sizeGapSum - ledGap / 2;
    }

    pathCommand = [];
    attr = {
      path: [M, x1, y1, L, x2, y1, x2, y2, x1, y2, Z],
      stroke: (0, _lib.convertColor)(gaugeBorderColor, gaugeBorderAlpha),
      'stroke-width': gaugeBorderThickness,
      'stroke-linecap': BUTT
    };

    if (!canvasBorderElement) {
      graphics.canvasBorderElement = animationManager.setAnimation({
        el: 'path',
        attr: attr,
        container: parentContainer,
        component: dataSet,
        label: 'plotBackground'
      }).shadow({
        apply: showShadow
      }).toBack();
    } else {
      animationManager.setAnimation({
        el: canvasBorderElement,
        attr: attr,
        component: dataSet
      });
    } // Draw the path for the gap


    for (i = 1; i < noOfLED; i += 1) {
      if (isHorizontal) {
        pathCommand.push(M, LEDGapStartX, LEDGapStartY, L, LEDGapStartX, LEDGapStartY + canvasHeight);
        LEDGapStartX += sizeGapSum;
      } else {
        pathCommand.push(M, LEDGapStartX, LEDGapStartY, L, LEDGapStartX + canvasWidth, LEDGapStartY);
        LEDGapStartY += sizeGapSum;
      }
    }

    attr = {
      path: pathCommand,
      stroke: (0, _lib.convertColor)(gaugeFillColor, 100),
      'stroke-width': ledGap,
      'stroke-linecap': BUTT
    };

    if (!canvasElementPath) {
      canvasElementPath = animationManager.setAnimation({
        el: 'path',
        attr: attr,
        container: parentContainer,
        component: dataSet,
        label: 'plotBackground'
      });
      canvas.addGraphicalElement('canvasElementPath', canvasElementPath);
    } else {
      animationManager.setAnimation({
        el: canvasElementPath,
        attr: attr,
        component: dataSet
      });
    }

    dataSet.drawShade();
  }
  /**
   * Draw led shade which simulates the off leds
   */
  ;

  _proto.drawShade = function drawShade() {
    var dataSet = this,
        conf = dataSet.config,
        dataStore = dataSet.components.data,
        chart = dataSet.getFromEnv('chart'),
        caption = chart.getChildren('caption')[0],
        subCaption = chart.getChildren('subCaption')[0],
        captionHeight = caption && caption.config.text && caption.config.height || 0,
        captionPadding = caption && caption.config.text && caption.config.captionPadding || 0,
        subCaptionHeight = subCaption && subCaption.config.text && subCaption.config.height || 0,
        chartAttr = chart.getFromEnv('dataSource').chart,
        animationManager = chart.getFromEnv('animationManager'),
        toolTipController = dataSet.getFromEnv('toolTipController'),
        dataLabelObj,
        dataLabelTooltip,
        displayValue,
        smartLabel = dataSet.getFromEnv('smartLabel'),
        chartConfig = chart.config,
        canvasLeft = chartConfig.canvasLeft,
        canvasTop = chartConfig.canvasTop,
        canvasHeight = chartConfig.canvasHeight,
        canvasWidth = chartConfig.canvasWidth,
        parentContainer = chart.getChildContainer().plotGroup,
        container = dataSet.getContainer('container'),
        gaugeFillColor,
        numberFormatter = dataSet.getFromEnv('number-formatter'),
        setValue,
        yPos,
        isAxisReverse = conf.isAxisReverse = (0, _lib.pluckNumber)(chartAttr.reverseaxis, chart.isaxisreverse),
        isHorizontal = conf.isHorizontal = chart.isHorizontal,
        attr,
        dataObj = dataStore[0],
        graphic = dataObj.graphics,
        config = dataObj && dataObj.config,
        dataLabelContainer = dataSet.getContainer('dataLabelContainer'),
        dataLabelsLayer = chart.getChildContainer('datalabelsGroup'),
        canvas = chart.getChildren('canvas')[0],
        style = chart.config.dataLabelStyle,
        heightUsed = conf.heightUsed,
        lineHeight,
        labelBBox,
        labelWidth,
        setTooltext,
        lightedLed,
        lightedLedLength,
        height,
        width,
        scale = dataSet.getFromEnv('scale'),
        min = scale.getLimit().min;
    smartLabel.setStyle(style);
    gaugeFillColor = chart.getChildren('canvas')[0].config.gaugeFillColor;

    if (!container) {
      container = dataSet.addContainer('container', animationManager.setAnimation({
        el: 'group',
        attr: {
          name: 'shade'
        },
        container: parentContainer,
        component: dataSet
      }));
    } // Creating the dataLabel container group if not present and appending it to its parent.


    if (!dataLabelContainer) {
      dataLabelContainer = dataSet.addContainer('dataLabelContainer', animationManager.setAnimation({
        el: 'group',
        attr: {
          name: 'datalabel'
        },
        container: dataLabelsLayer,
        component: dataSet,
        label: 'labelGroup'
      }));
    }

    setValue = numberFormatter.getCleanValue(config.setValue);

    if (!dataObj.graphics) {
      dataObj.graphics = {};
    }

    lightedLed = (setValue - min) / conf.perLEDValueLength;
    lightedLedLength = mathRound(lightedLed) * conf.sizeGapSum - conf.ledGap;
    height = Math.ceil(canvasHeight - lightedLedLength);
    width = Math.ceil(canvasWidth - lightedLedLength);

    if (isAxisReverse && !isHorizontal) {
      attr = {
        x: canvasLeft,
        y: canvasTop + lightedLedLength,
        width: canvasWidth,
        height: height,
        r: 0,
        'stroke-width': 0,
        fill: (0, _lib.convertColor)(gaugeFillColor, 50)
      };
    } else if (!isAxisReverse && !isHorizontal) {
      attr = {
        x: canvasLeft,
        y: canvasTop,
        width: canvasWidth,
        height: height,
        r: 0,
        'stroke-width': 0,
        fill: (0, _lib.convertColor)(gaugeFillColor, 50)
      };
    } else if (!isAxisReverse && isHorizontal) {
      attr = {
        x: canvasLeft + lightedLedLength,
        y: canvasTop,
        width: width,
        height: canvasHeight,
        r: 0,
        'stroke-width': 0,
        fill: (0, _lib.convertColor)(gaugeFillColor, 50)
      };
    } else if (isAxisReverse && isHorizontal) {
      attr = {
        x: canvasLeft,
        y: canvasTop,
        width: width,
        height: canvasHeight,
        r: 0,
        'stroke-width': 0,
        fill: (0, _lib.convertColor)(gaugeFillColor, 50)
      };
    }

    dataObj.graphics.element = animationManager.setAnimation({
      el: dataObj.graphics.element || 'rect',
      attr: attr,
      container: container,
      component: dataSet,
      label: 'plotRect'
    });
    setTooltext = config.setTooltext === _lib.BLANK || config.setTooltext === UNDEF ? config.toolTipValue : config.setTooltext;

    if (conf.showTooltip) {
      toolTipController.enableToolTip(canvas._graphics.canvasHotElement, setTooltext);
    } else {
      toolTipController.disableToolTip(canvas._graphics.canvasHotElement);
    }

    lineHeight = parseInt(style.lineHeight, 10);
    yPos = lineHeight > heightUsed ? chartConfig.height - chartConfig.marginBottom - heightUsed + lineHeight / 2 : chartConfig.height - chartConfig.marginBottom - lineHeight / 2;
    yPos -= chartConfig.borderWidth;
    yPos -= (chart._manageActionBarSpace && chart._manageActionBarSpace(config.availableHeight * 0.225) || {}).bottom;

    if (caption.config.isOnTop === 0) {
      yPos -= captionHeight + subCaptionHeight + captionPadding;
    }

    graphic = dataObj.graphics;

    if (config.displayValue !== BLANKSTRING && config.displayValue !== UNDEF && conf.showValue) {
      dataLabelObj = smartLabel.getSmartText(config.displayValue, chartConfig.width, conf.heightUsed);
      displayValue = dataLabelObj.text;
      dataLabelTooltip = dataLabelObj.tooltext || BLANKSTRING;
      attr = {
        text: displayValue,
        'text-anchor': POSITION_MIDDLE,
        x: canvasWidth / 2 + canvasLeft,
        y: yPos,
        'vertical-align': POSITION_MIDDLE,
        fill: style.color,
        direction: config.textDirection,
        'text-bound': [style.backgroundColor, style.borderColor, style.borderThickness, style.borderPadding, style.borderRadius, style.borderDash]
      };
      graphic.label = animationManager.setAnimation({
        el: graphic.label || 'text',
        attr: attr,
        container: dataLabelContainer,
        component: dataSet,
        label: 'text'
      });

      if (conf.showTooltip) {
        toolTipController.enableToolTip(graphic.label, dataLabelTooltip);
      } else {
        toolTipController.disableToolTip(graphic.label);
      } // Adjusting the chart label if goes out side the chart area
      // we try to keep the label inside viewport


      labelBBox = graphic.label.getBBox();

      if (labelBBox.x + chartConfig.marginLeft < 0) {
        labelWidth = labelBBox.width - chartConfig.marginLeft;

        if (chartConfig.width < labelWidth) {
          labelWidth = chartConfig.width - chartConfig.marginLeft;
        }

        attr = {
          x: labelWidth / 2
        };
        animationManager.setAnimation({
          el: graphic.label,
          attr: attr,
          component: dataSet,
          label: 'text'
        }); // graphic.label.animateWith(dummyObj, animObj, attr, animationDuration, animType);
      }
    } else {
      graphic.label && toolTipController.disableToolTip(graphic.label);
      graphic.label = graphic.label && animationManager.setAnimation({
        el: graphic.label,
        component: dataSet
      });
    }
  };

  return LedDataset;
}(_bullet.default);

var _default = LedDataset;
exports["default"] = _default;

/***/ }),

/***/ 1568:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _lib = __webpack_require__(274);

var _funnelpyramidbase = _interopRequireDefault(__webpack_require__(1562));

var _schedular = __webpack_require__(286);

var _pyramidPoint = _interopRequireDefault(__webpack_require__(1569));

/* eslint require-jsdoc: 'error', valid-jsdoc: ["error", { "requireReturn": false }] */
var UNDEF,
    POSITION_START = _lib.preDefStr.POSITION_START,
    POSITION_MIDDLE = _lib.preDefStr.POSITION_MIDDLE;
/**
 * Creates PyramidDataset class
 */

var PyramidDataset = /*#__PURE__*/function (_FunnelPyramidBaseDat) {
  (0, _inheritsLoose2.default)(PyramidDataset, _FunnelPyramidBaseDat);

  /**
   * Constructor function of PyramidDataset class
   */
  function PyramidDataset() {
    var _this;

    _this = _FunnelPyramidBaseDat.call(this) || this;

    _this.preDrawingHook = function () {// Not required
    };

    _this.config.pointInContext = _pyramidPoint.default;
    _this.config.LABEL_PLACEMENT_ITERATOR_INDEX_START = 0;
    return _this;
  }
  /**
  * Sets the type of the component
  * @return {string} type
  */


  var _proto = PyramidDataset.prototype;

  _proto.getType = function getType() {
    return 'dataset';
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */
  ;

  _proto.getName = function getName() {
    return 'pyramid';
  }
  /**
    * Configures Dataset by parsing attribute values
    * @param  {Object} datasetJSON JSON for dataset configurations
    * @return {boolean} Indicates whether the configuration was successful or not
    */
  ;

  _proto.configure = function configure(datasetJSON) {
    if (!datasetJSON) {
      return false;
    }

    this.config.JSONData = datasetJSON;
    var datasetDefStore = this,
        chartConfig = datasetDefStore.getFromEnv('chartConfig');

    if (!datasetDefStore._checkValidData(datasetDefStore.config.JSONData.data)) {
      return;
    }
    /**
     * update the data before calling addlegend so that the legenditems of
     * removed datas do not get drawn
     */


    datasetDefStore._configure();

    chartConfig.showLegend && datasetDefStore.addLegend();
  }
  /**
   * Configure specific attributes for pyramid
   */
  ;

  _proto.configureSpecifics = function configureSpecifics() {
    var datasetStore = this,
        chart = datasetStore.getFromEnv('chart'),
        datasetConf = datasetStore.config,
        chartAttr = chart.getFromEnv('dataSource') ? chart.getFromEnv('dataSource').chart : {},
        utils = datasetStore.utils(datasetStore),
        copyProperties = utils.copyProperties;
    copyProperties(chartAttr, datasetConf, [['pyramidyscale', 'yScale', _lib.pluckNumber, UNDEF, function (datasetConfig) {
      var ys = datasetConfig.yScale;
      datasetConfig.yScale = ys >= 0 && ys <= 40 ? ys / 200 : 0.2;
    }], ['use3dlighting', 'use3DLighting', _lib.pluckNumber, 1]]);
  }
  /**
   * Calculates plot position during space management
   *
   * @memberof PyramidDataset
   */
  ;

  _proto.calculatePositionOfPlots = function calculatePositionOfPlots() {
    var datasetStore = this,
        chart = datasetStore.getFromEnv('chart'),
        chartConfig = chart.config,
        conf = datasetStore.config,
        utils = datasetStore.utils(datasetStore),
        DistributionMatrix = utils.DistributionMatrix,
        calculatePositionCoordinate = datasetStore.calculatePositionCoordinate,
        psmMargin = conf.psmMargin,
        dataStore = datasetStore.getChildren('data'),
        index,
        length,
        plotObj,
        unitHeight,
        heightAllotted,
        widthAllotted,
        drawingRadius,
        section = 2,
        dataStoreLength = dataStore.length,
        alignmentType,
        distributionKey,
        currentSliceHeight = 0,
        blockLabelLenFromOffset,
        blockLenFromOffset = 0,
        lineHeight = conf.lineHeight,
        mFloorFn = Math.floor,
        distributedResult,
        dMatrix,
        adMatrix,
        curr,
        ele,
        distributionMatrix,
        inclination;
    datasetStore.postPlotCallback = _lib.stubFN;
    chartConfig.canvasTop += chartConfig.marginTop - psmMargin.top;
    chartConfig.effCanvasHeight = heightAllotted = chartConfig.canvasHeight - (chartConfig.marginTop + chartConfig.marginBottom) + (psmMargin.top + psmMargin.bottom);
    chartConfig.effCanvasWidth = widthAllotted = chartConfig.width - (chartConfig.marginLeft + chartConfig.marginRight);
    drawingRadius = conf.drawingRadius = widthAllotted / section; // Calculating the left position for drawing the chart

    conf.x = chartConfig.canvasLeft + (chartConfig.canvasRight - chartConfig.canvasLeft) / 2;
    inclination = Math.atan(widthAllotted / 2 / heightAllotted);
    conf.unitHeight = unitHeight = heightAllotted / conf.sumValue;
    conf.lastRadius = 0; // For funnel no x shift calculation required since the shape of the funnel causes the labels to be
    // placed in non overlapping fashion

    conf.globalMinXShift = Math.floor(lineHeight / Math.cos(inclination)); // Defines how to align the labels of the chart.

    alignmentType = conf.alignmentType = {}; // Default alignment is labels placing in the right side of the pyramid, and chart is left aligned

    alignmentType['default'] = 1;
    alignmentType.alternate = 2; // Length of distribution matrix is how many labels ca be placed at one
    // side of the pyramid without overlapping

    distributionMatrix = new DistributionMatrix(mFloorFn(heightAllotted / lineHeight));

    for (index = 0, length = dataStoreLength; index < length; index++) {
      plotObj = dataStore[index];

      if (plotObj.getState('removed')) {
        continue;
      }

      currentSliceHeight = plotObj.y * unitHeight; // Effective length of the current slice from the top of pyramid drawing

      blockLenFromOffset += plotObj.y * unitHeight;
      blockLabelLenFromOffset = blockLenFromOffset - currentSliceHeight + currentSliceHeight / 2;
      distributionKey = mFloorFn(blockLabelLenFromOffset / lineHeight);
      distributionMatrix.push(plotObj, distributionKey);
    }

    distributedResult = distributionMatrix.getDistributedResult(); // Alternatively merge the data after distribution

    dataStore.length = 0;

    if (distributedResult.matrix[1] === UNDEF) {
      [].push.apply(dataStore, distributedResult.matrix[0]);
    } else {
      dMatrix = distributedResult.matrix[0];
      adMatrix = distributedResult.matrix[1];
      length = Math.max(dMatrix.length, adMatrix.length);

      for (index = 0; index < length; index++) {
        ele = dMatrix[index];
        curr = adMatrix[index];
        dataStore.push(ele || curr);
      }
    }

    switch (distributedResult.suggestion) {
      case alignmentType['default']:
        calculatePositionCoordinate.call(datasetStore, dataStore, false);
        break;

      case alignmentType.alternate:
        conf.labelAlignment = alignmentType.alternate; // 1st section for left labels, 2nd sector for chart itself, 3rd section for right label

        section = 3;
        conf.drawingRadius = drawingRadius = widthAllotted / section;
        chartConfig.canvasLeft = chartConfig.canvasWidth / 2 - drawingRadius;
        conf.x = chartConfig.canvasLeft + drawingRadius;
        calculatePositionCoordinate.call(datasetStore, dataStore, true);
        break;
    }
  }
  /**
   * Draws the pyramid plots
   */
  ;

  _proto.draw = function draw() {
    var datasetStore = this,
        chart = datasetStore.getFromEnv('chart'),
        conf = datasetStore.config,
        trackerArgs = datasetStore.config.trackerArgs = [],
        dataStore = datasetStore.getChildren('data'),
        index,
        length,
        dataStoreLength = dataStore.length,
        mMinFn = Math.min,
        slicingDistance,
        noOfGap,
        halfDistance,
        point,
        postPlotCallbackInitiated;

    if (!conf.sumValue) {
      return;
    }

    datasetStore.config.labelDrawingConfig = datasetStore.config.labelDrawingConfig || [];
    datasetStore.config.labelDrawingConfig.length = 0;

    datasetStore.animateFunction = function (group) {
      return function () {
        group.attr({
          opacity: 1
        });
      };
    };

    slicingDistance = conf.slicingDistance;
    halfDistance = slicingDistance / 2;

    for (index = 0, length = dataStore.length; index < length; index++) {
      dataStore[index] && dataStore[index].shapeArgs && (dataStore[index].shapeArgs.renderer = chart.getFromEnv('paper'));
    }

    noOfGap = conf.noOfGap;

    if (noOfGap) {
      conf.perGapDistance = mMinFn(halfDistance * 1.5, slicingDistance / noOfGap);
      conf.distanceAvailed = halfDistance;
    }

    index = dataStore.length;

    if (conf.alreadyPlotted) {
      datasetStore.postPlotCallback = function () {
        if (postPlotCallbackInitiated) {
          return;
        }

        postPlotCallbackInitiated = true;
      };
    }

    while (index--) {
      point = dataStore[index];
      point.index = index;
      point.syncDraw();
    }

    conf.oldLastData = Object.assign({}, dataStore[dataStore.length - 1].shapeArgs);
    datasetStore.hide(datasetStore.getChildren('data'), dataStoreLength);
    conf.connectorEndSwitchHistoryY = {};
    index = dataStore.length;

    while (index--) {
      trackerArgs.push(dataStore[index]);
    }

    datasetStore.addJob('labelDrawID', datasetStore.drawAllLabels.bind(datasetStore), _schedular.priorityList.label);
    datasetStore.addJob('trackerDrawID', datasetStore.drawAllTrackers.bind(datasetStore), _schedular.priorityList.tracker);
    datasetStore.removePlots();
    conf.alreadyPlotted = true;
    conf.prevIs2d = conf.is2d;
  }
  /**
   * Calculates the data plot coordinates
   * @param {Array} dataArr data points
   * @param {boolean} placeOtherSide whether to put on left side or right side
   */
  ;

  _proto.calculatePositionCoordinate = function calculatePositionCoordinate(dataArr, placeOtherSide) {
    var datasetStore = this,
        conf = datasetStore.config,
        is2d = conf.is2d,
        x = conf.x,
        // plotItemArr = datasetStore.graphics.plotItems || [],
    chart = datasetStore.getFromEnv('chart'),
        chartConfig = chart.config,
        y = chartConfig.canvasTop,
        unitHeight = conf.unitHeight,
        labelDistance = conf.labelDistance,
        showLabelsAtCenter = conf.showLabelsAtCenter,
        fontSize = chartConfig.style.fontSize,
        yShift = fontSize * 0.3,
        yScale = conf.yScale,
        blankSpace = conf.blankSpace,
        lastRadius = conf.lastRadius,
        smartLabel = datasetStore.getFromEnv('smartLabel'),
        index,
        length,
        point,
        sliceHeight,
        lastIndex = dataArr.length - 1,
        alignmentSwitchToggle = false,
        distributionOffset = 0,
        labelMeasurement,
        newRadius,
        negativeSpanningDataEnd,
        normalizedLabel,
        lineHeight = conf.lineHeight,
        totalValues = 0,
        // Base of the  maximum trimmed label.
    trimmedInfo = {
      flag: false,
      point: UNDEF,
      sLabel: UNDEF,
      setAll: function setAll(flag, pt, sLabel) {
        this.flag = flag;
        this.point = pt;
        this.sLabel = sLabel;
      }
    },
        // Base of the maximum spanned labels
    largestLabel = {
      point: UNDEF,
      sLabel: UNDEF,
      set: function set(calcFn, predicate) {
        var _calcFn = calcFn,
            _predicate = predicate;
        return function (pt, sLabel) {
          var existingLabelSpan, currentLabelSpan;

          if (pt.dontPlot) {
            return;
          }

          if (!(this.point && this.sLabel)) {
            this.point = pt;
            this.sLabel = sLabel;
            return;
          }

          existingLabelSpan = _calcFn(this.point, this.sLabel);
          currentLabelSpan = _calcFn(pt, sLabel);

          if (_predicate(existingLabelSpan, currentLabelSpan)) {
            this.point = pt;
            this.sLabel = sLabel;
          }
        };
      }
    },
        leftTrimmedInfo = {},
        rightTrimmedInfo = {},
        lLargestLabel = {},
        rLargestLabel = {},
        xPos,
        chartWidth = chart.config.width - 2,
        slicingGapPosition = conf.slicingGapPosition = {};
    (0, _lib.extend2)(leftTrimmedInfo, trimmedInfo);
    (0, _lib.extend2)(rightTrimmedInfo, trimmedInfo);

    leftTrimmedInfo.setAll = function (flag, pt, sLabel) {
      var _point = this.point,
          _sLabel = this.sLabel,
          existingLabelSpan,
          currentLabelSpan;
      this.flag = flag;

      if (!(_point && _sLabel)) {
        this.point = pt;
        this.sLabel = sLabel;
        return;
      }

      existingLabelSpan = _point.labelX - (_sLabel.oriTextWidth - _sLabel.width);
      currentLabelSpan = pt.labelX - (sLabel.oriTextWidth - sLabel.width);

      if (existingLabelSpan > currentLabelSpan) {
        this.point = pt;
        this.sLabel = sLabel;
      }
    }; // Override the base class method for labels which are kept right


    rightTrimmedInfo.setAll = function (flag, pt, sLabel) {
      var _point = this.point,
          _sLabel = this.sLabel,
          existingLabelSpan,
          currentLabelSpan;
      this.flag = flag;

      if (!(_point && _sLabel)) {
        this.point = pt;
        this.sLabel = sLabel;
        return;
      }

      existingLabelSpan = _point.labelX + _sLabel.oriTextWidth;
      currentLabelSpan = pt.labelX + sLabel.oriTextWidth;

      if (existingLabelSpan < currentLabelSpan) {
        this.point = pt;
        this.sLabel = sLabel;
      }
    };

    (0, _lib.extend2)(lLargestLabel, largestLabel);
    (0, _lib.extend2)(rLargestLabel, largestLabel);

    lLargestLabel.set = function () {
      return largestLabel.set.apply(lLargestLabel, [function (pt) {
        return pt.labelX;
      }, function (existingLabelSpan, currentLabelSpan) {
        return existingLabelSpan > currentLabelSpan;
      }]);
    }();

    rLargestLabel.set = function () {
      return largestLabel.set.apply(rLargestLabel, [function (pt, sLabel) {
        return pt.labelX + sLabel.oriTextWidth;
      }, function (existingLabelSpan, currentLabelSpan) {
        return existingLabelSpan < currentLabelSpan;
      }]);
    }();

    conf.noOfGap = 0;
    smartLabel.useEllipsesOnOverflow(chartConfig.useEllipsesWhenOverflow);

    for (index = 0, length = dataArr.length; index < length; index++) {
      point = dataArr[index];

      if (!point) {
        continue;
      }

      point.x = index;

      if (point.plot) {
        point.isSliced = !!point.isSliced || !!conf.isSliced;
      }

      point.isSliced = (0, _lib.pluckNumber)(point.isSliced, conf.isSliced);
      placeOtherSide && (alignmentSwitchToggle = !alignmentSwitchToggle);

      if (point.isSliced) {
        xPos = point.x;

        if (xPos && !slicingGapPosition[xPos]) {
          slicingGapPosition[xPos] = true;
          conf.noOfGap += 1;
        }

        if (xPos < lastIndex) {
          slicingGapPosition[xPos + 1] = true;
          conf.noOfGap += 1;
        }
      }

      smartLabel.setStyle(point.style);
      point.oriText = point.displayValue;
      labelMeasurement = labelMeasurement = smartLabel.getSmartText(point.displayValue, Number.POSITIVE_INFINITY, Number.POSITIVE_INFINITY);
      totalValues += point.y;
      newRadius = conf.drawingRadius * totalValues / conf.sumValue;
      sliceHeight = unitHeight * point.y;
      point.shapeArgs = {
        x: x,
        y: y,
        R1: lastRadius,
        R2: newRadius,
        h: sliceHeight,
        r3dFactor: yScale,
        gStr: 'point',
        is2D: is2d,
        use3DLighting: !!conf.use3DLighting,
        renderer: datasetStore.getFromEnv('paper')
      };

      if (showLabelsAtCenter) {
        point.labelAline = POSITION_MIDDLE;
        point.labelX = x;
        point.labelY = (is2d ? y : y + yScale * lastRadius) + sliceHeight / 2 + yShift;
      } else {
        point.labelAline = POSITION_START;
        point.alignmentSwitch = alignmentSwitchToggle;
        point.distributionFactor = point.distributionFactor || 0;

        if (alignmentSwitchToggle) {
          point.labelX = x - (labelDistance + (newRadius + lastRadius) / 2 + blankSpace + labelMeasurement.width);
          point.labelX -= point.distributionFactor * conf.globalMinXShift;
          lLargestLabel.set(point, labelMeasurement);
        } else {
          point.labelX = x + labelDistance + (newRadius + lastRadius) / 2 + blankSpace;
          point.labelX += point.distributionFactor * conf.globalMinXShift;
          rLargestLabel.set(point, labelMeasurement);
        }

        distributionOffset = point.distributionFactor * lineHeight;
        point.labelY = y + yShift + sliceHeight / 2 + distributionOffset;
      } // Checking text overflow for alternate alignment


      if (placeOtherSide) {
        if (alignmentSwitchToggle && point.labelX < 0) {
          // Left and behind the margin
          negativeSpanningDataEnd = point.labelX + labelMeasurement.width;
          normalizedLabel = smartLabel.getSmartText(point.displayValue, negativeSpanningDataEnd, Number.POSITIVE_INFINITY, true);
          point.labelX = 2;
          point.isLabelTruncated = true;
          point.displayValue = normalizedLabel.text;
          point.virtualWidth = normalizedLabel.maxWidth;
          leftTrimmedInfo.setAll(true, point, normalizedLabel);
        } else if (!alignmentSwitchToggle && point.labelX + labelMeasurement.width > chartWidth) {
          // Right side and spanning the margin
          normalizedLabel = smartLabel.getSmartText(point.displayValue, chartWidth - point.labelX, Number.POSITIVE_INFINITY, true);
          point.isLabelTruncated = true;
          point.displayValue = normalizedLabel.text;
          point.virtualWidth = normalizedLabel.maxWidth;
          rightTrimmedInfo.setAll(true, point, normalizedLabel);
        }

        point.pWidth = point.virtualWidth || labelMeasurement.width;
        distributionOffset = point.distributionFactor * lineHeight;
        point.labelY = y + yShift + sliceHeight / 2 + distributionOffset;
      }

      y += sliceHeight;
      point.plotX = x;
      point.plotY = y - sliceHeight / 2;
      lastRadius = newRadius;
      point.virtualWidth = point.virtualWidth || labelMeasurement.width;
    } // Recalculate the space one more time. Ideally this should be given by space manager.
    // However in the current scope space manager cannot be called from here.


    datasetStore.findBestPosition(dataArr, {
      'lTrimmedInfo': leftTrimmedInfo,
      'rTrimmedInfo': rightTrimmedInfo,
      'lLargestLabel': lLargestLabel,
      'rLargestLabel': rLargestLabel
    });
  }
  /**
   * Provides tooltip options
   * @param {Object} options congigurations of data points
   * @return {Object} returns tooltip options
   */
  ;

  _proto.getTooltipMacroStub = function getTooltipMacroStub(options) {
    var datasetStore = this,
        conf = datasetStore.config,
        numberFormatter = datasetStore.getFromEnv('number-formatter'),
        baseStub,
        percentOfPrevValue;
    percentOfPrevValue = conf.percentOfPrevious ? options.pValue : numberFormatter.percentValue(options.dataValue / options.prevValue * 100);
    baseStub = _FunnelPyramidBaseDat.prototype.getTooltipMacroStub.call(this, options);
    baseStub.percentValue = conf.percentOfPrevious ? numberFormatter.percentValue(options.dataValue / options.highestValue * 100) : options.pValue;
    baseStub.percentOfPrevValue = percentOfPrevValue;
    return baseStub;
  };

  return PyramidDataset;
}(_funnelpyramidbase.default);

var _default = PyramidDataset;
exports["default"] = _default;

/***/ }),

/***/ 1573:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _defineProperty2 = _interopRequireDefault(__webpack_require__(273));

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _componentInterface = __webpack_require__(290);

var _lib = __webpack_require__(274);

var _animationManager = _interopRequireDefault(__webpack_require__(329));

var _index = __webpack_require__(282);

var _polarUtil = __webpack_require__(1454);

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var M = 'M',
    A = 'A',
    L = 'L',
    Z = 'Z';
/**
 * Sets the svg path for drawing
 * @param {Number} _startAngle - angle where the bar starts
 * @param {Number} _endAngle - angle where the bar ends
 * @param {Number} arc - arc between the two angles
 * @param {Number} outerRadius - outer radius for the bar
 * @param {Number} innerRadius - inner radius for the bar
 * @param {Number} centerX - x coordinate of the center of the arc
 * @param {Number} centerY - y coordinate of the center of the arc
 * @param {Number} startRadius - radius for the rounded starting
 * @param {Number} endRadius - radius for rounded ending
 * @returns {Array} The path array for the path to be drawn
 */

function setPath(_startAngle, _endAngle, arc, outerRadius, innerRadius, centerX, centerY, thickness, startRadius, endRadius) {
  // in case of round edges, angles will be shifted so as to adjust round edge arc in the same place
  if (startRadius > 0 && arc !== 360) {
    // eslint-disable-next-line no-param-reassign
    _startAngle += (0, _polarUtil.radiansInAngle)(startRadius, innerRadius + startRadius);
  }

  if (endRadius > 0 && arc !== 360) {
    // eslint-disable-next-line no-param-reassign
    _endAngle -= (0, _polarUtil.radiansInAngle)(endRadius, innerRadius + endRadius);
  }

  var startAngle = (0, _polarUtil.normaliseAngle)(_startAngle),
      endAngle = (0, _polarUtil.normaliseAngle)(_endAngle),
      newArc = (0, _polarUtil.findArc)(startAngle, endAngle),
      _pointOnCircleFromCen = (0, _polarUtil.pointOnCircleFromCenter)(centerX, centerY, outerRadius, startAngle),
      x1 = _pointOnCircleFromCen.x,
      y1 = _pointOnCircleFromCen.y,
      _pointOnCircleFromCen2 = (0, _polarUtil.pointOnCircleFromCenter)(centerX, centerY, outerRadius, endAngle),
      x2 = _pointOnCircleFromCen2.x,
      y2 = _pointOnCircleFromCen2.y,
      _pointOnCircleFromCen3 = (0, _polarUtil.pointOnCircleFromCenter)(centerX, centerY, innerRadius, startAngle),
      x3 = _pointOnCircleFromCen3.x,
      y3 = _pointOnCircleFromCen3.y,
      _pointOnCircleFromCen4 = (0, _polarUtil.pointOnCircleFromCenter)(centerX, centerY, innerRadius, endAngle),
      x4 = _pointOnCircleFromCen4.x,
      y4 = _pointOnCircleFromCen4.y;

  if (newArc > 270) newArc = arc;
  x1 = (0, _lib.toPrecision)(x1, 4);
  y1 = (0, _lib.toPrecision)(y1, 4);
  x2 = (0, _lib.toPrecision)(x2, 4);
  y2 = (0, _lib.toPrecision)(y2, 4);
  x3 = (0, _lib.toPrecision)(x3, 4);
  y3 = (0, _lib.toPrecision)(y3, 4);
  x4 = (0, _lib.toPrecision)(x4, 4);
  y4 = (0, _lib.toPrecision)(y4, 4);
  return [M, x1, y1, A, outerRadius, outerRadius, 0, newArc <= 180 ? 0 : 1, 1, x2, y2, endRadius > 0 && newArc !== 360 ? A + ", " + endRadius + ", " + endRadius + ", 0, 1, 1, " + x4 + ", " + y4 : L + ", " + x4 + ", " + y4, A, innerRadius, innerRadius, 0, newArc <= 180 ? 0 : 1, 0, x3, y3, startRadius > 0 && newArc !== 360 ? A + ", " + startRadius + ", " + startRadius + ", 0, 1, 1, " + x1 + ", " + y1 : '', Z];
}

var RadialBarPlot = /*#__PURE__*/function (_SmartRenderer) {
  (0, _inheritsLoose2.default)(RadialBarPlot, _SmartRenderer);

  function RadialBarPlot() {
    return _SmartRenderer.apply(this, arguments) || this;
  }

  var _proto = RadialBarPlot.prototype;

  /**
   * Provides the name of the chart extension
   *
   * @return {string} The name of the chart extension
   */
  _proto.getName = function getName() {
    return 'RadialBarPlot';
  }
  /**
   * Provides the type of the chart extension
   *
   * @return {string} The type of the chart extension
   */
  ;

  _proto.getType = function getType() {
    return 'plot';
  }
  /**
   * Provides the name of the chart extension
   *
   * @static
   * @return {string} The name of the chart extension
   */
  ;

  RadialBarPlot.getName = function getName() {
    return 'RadialBarPlot';
  }
  /**
   * Provides the type of the chart extension
   *
   * @static
   * @return {string} The type of the chart extension
   */
  ;

  RadialBarPlot.getType = function getType() {
    return 'plot';
  }
  /**
   * This method handles mouseover event of a plot
   * @param {Event} e - reference of the original mouse event
   * @memberof RadialBarPlot
   */
  ;

  _proto._mouseOverHandler = function _mouseOverHandler(e) {
    var toolTipController = this.getFromEnv('toolTipController'),
        radialBar = this.getLinkedParent(); // Create context label text if not present

    if (radialBar.config.showcontextlabel) {
      radialBar.drawContextLabel(this.getParsedText(this.config.contexttext, true), true);
    } // Create plot tooltext if not present


    if (radialBar.config.showtooltip && !this.config.currentToolTip) {
      this.config.currentToolTip = toolTipController.draw(e.originalEvent, this.getParsedText(this.config.tooltext, true));
    }

    this.config.realBarAlpha = this.config.realBarAlpha || this.config.baralpha;
    this.config.realBarBorderAlpha = this.config.realBarBorderAlpha || this.config.barborderalpha;
    this.setData({
      'baralpha': 0.25 * this.config.realBarAlpha,
      'barborderalpha': 0.25 * this.config.realBarBorderAlpha
    }, true);

    if (e && e.sender && e.sender.config && e.sender.config.lastElemUsed) {
      var element = e.sender.config.lastElemUsed;
      radialBar.plotEventHandler(element, e, 'dataplotRollover');
    }
  }
  /**
   * This method handles mouseout event of a plot
   * @param {Event} e - reference of the original mouse event
   * @memberof RadialBarPlot
   */
  ;

  _proto._mouseOutHandler = function _mouseOutHandler(e) {
    var toolTipController = this.getFromEnv('toolTipController'),
        radialBar = this.getLinkedParent();

    if (this.config.currentToolTip) {
      toolTipController.hide(this.config.currentToolTip);
      this.config.currentToolTip = _lib.UNDEF;
    }

    this.setData({
      'baralpha': this.config.realBarAlpha,
      'barborderalpha': this.config.realBarBorderAlpha
    }, true);

    if (radialBar.config.showcontextlabel) {
      radialBar.drawContextLabel(radialBar.config.defaultcontextlabel);
    }

    if (e && e.sender && e.sender.config && e.sender.config.lastElemUsed) {
      var element = e.sender.config.lastElemUsed;
      radialBar.plotEventHandler(element, e, 'dataplotRollout');
    }
  }
  /**
   * This method handles mouse click event of a plot
   * @param {Event} e - reference of the original mouse event
   * @memberof RadialBarPlot
   */
  ;

  _proto._mouseClickHandler = function _mouseClickHandler(e) {
    var radialBar = this.getLinkedParent();

    if (e && e.sender && e.sender.config && e.sender.config.lastElemUsed) {
      var element = e.sender.config.lastElemUsed;
      radialBar.plotEventHandler(element, e, 'dataplotClick');
    }
  }
  /**
   * Sets the default values for parameters of the chart.
   * @memberof RadialBarPlot
   */
  ;

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    this.config.startangle = 90;
    this.config.endangle = 180;
    this.config.barstartradius = '100%';
    this.config.barendradius = '100%';
    this.config.barborder = 'none';
    this.config.barbordercolor = '#000000';
    this.config.barborderalpha = 1;
    this.config.barborderthickness = 1;
    this.config.color = '#0000ff';
    this.config.baralpha = 1;
    this.config.value = 0;
  }
  /**
   * Configures the chart attributes.
   * @memberof RadialBarPlot
   */
  ;

  _proto.configureAttributes = function configureAttributes(dataObj) {
    _SmartRenderer.prototype.configureAttributes.call(this, dataObj);

    if (dataObj.value <= 0) dataObj.value = 0;
    this.config = _objectSpread(_objectSpread({}, this.config), dataObj);

    if (!this.getFromEnv('chartConfig')) {
      this.addToEnv('chartConfig', this.config);
    }

    this.createBaseComponent();

    if (dataObj.thickness) {
      this.config.thickness = dataObj.thickness;
    }

    if (dataObj.startangle || dataObj.startangle === 0) {
      this.config.startingAngle = dataObj.startangle;
    }

    if (dataObj.endangle || dataObj.endangle === 0) {
      this.config.endingAngle = dataObj.endangle;
    }

    if (this.config.barborder === 'none') {
      this.config.barborderalpha = 0;
      this.config.barborderthickness = 0;
    }

    this.getLinkedParent().config.showLegend && this._addLegend();
  };

  _proto.createBaseComponent = function createBaseComponent() {
    var iapi = this,
        animationManager = iapi.getFromEnv('animationManager');

    if (!animationManager) {
      animationManager = new _animationManager.default();
      iapi.addToEnv('animationManager', animationManager);
      animationManager.addToEnv('chart', iapi);
    }

    animationManager.configure();

    animationManager._setAnimDuration();
  };

  _proto.addPaperToEnv = function addPaperToEnv() {
    var container = this.getFromEnv('chart-container'),
        Raphael = (0, _index.getDep)('redraphael', 'plugin'),
        paper = new Raphael(container, this.getFromEnv('chartWidth'), this.getFromEnv('chartHeight'));
    paper.setHTMLClassName('fusioncharts-div');
    var animationManager = this.getFromEnv('animationManager');
    animationManager.addToEnv('paper', paper);
  }
  /**
   * Called from the parent chart class. Sets values needed for
   * space management and kicks off drawing process.
   * @param {Number} box side of the square in which chart will be drawn.
   * @param {Number} thickness thickness of a track
   * @memberof RadialBarPlot
   */
  ;

  _proto.setNodePath = function setNodePath(box, thickness, config) {
    this.config.thickness = thickness;
    this.config.outerRadius = box / 2;
    this.config.innerRadius = this.config.outerRadius - this.config.thickness;
    this.config.barstartradius = config.barstartradius;
    this.config.barendradius = config.barendradius;
    this.manageSpace();
  }
  /**
   * Calculate margins and space for and mange space for components
   * @memberof RadialBarPlot
   */
  ;

  _proto.manageSpace = function manageSpace() {
    var chartConfig = this.getFromEnv('chartConfig'),
        radialBar = this.getLinkedParent(),
        canvasLeft = chartConfig.canvasLeft,
        canvasTop = chartConfig.canvasTop,
        availableWidth = chartConfig.canvasWidth,
        availableHeight = chartConfig.canvasHeight,
        centerX = canvasLeft + availableWidth / 2,
        centerY = canvasTop + availableHeight / 2,
        startAngle = (0, _polarUtil.changeAngleBase)(this.config.startingAngle),
        endingAngle = (0, _polarUtil.changeAngleBase)(this.config.endingAngle),
        trackArc = (0, _polarUtil.findArc)(startAngle, startAngle === endingAngle ? endingAngle - 0.1 : endingAngle),
        endAngle = startAngle + Math.round((this.config.value > 100 ? 100 : this.config.value) / 100 * trackArc),
        arc,
        startRadius = parseInt(this.config.barstartradius, 10) / 100 * (this.config.thickness / 2),
        endRadius = parseInt(this.config.barendradius, 10) / 100 * (this.config.thickness / 2);
    endAngle = startAngle === endingAngle ? endAngle - 0.01 : endAngle;
    arc = (0, _polarUtil.findArc)(startAngle, endAngle);
    this.getFromEnv('chart-attrib').interactivelegend = radialBar.config.interactivelegend;
    this.config.path_d = setPath(startAngle, endAngle, arc, this.config.outerRadius, this.config.innerRadius, centerX, centerY, this.config.thickness, startRadius, endRadius);
  } // eslint-disable-next-line class-methods-use-this
  ;

  _proto.allocatePosition = function allocatePosition() {
    return false;
  } // eslint-disable-next-line class-methods-use-this
  ;

  _proto.checkInvalidData = function checkInvalidData() {
    return false;
  } // eslint-disable-next-line class-methods-use-this
  ;

  _proto.checkInvalidSpecificData = function checkInvalidSpecificData() {
    return false;
  }
  /**
   * Adds the legend component
   * @memberof RadialBarPlot
   */
  ;

  _proto._addLegend = function _addLegend() {
    var legend = this.getFromEnv('legend'),
        legendItem = legend.getItem(this.config.legendItemId),
        radialBar = this.getLinkedParent(),
        config = {
      label: this.config.label,
      type: 'radialBar',
      showIcon: parseInt(radialBar.config.showiconinlegend, 10) && this.config.iconurl,
      iconUrl: this.config.iconurl
    };

    if (!legendItem) {
      this.config.legendItemId = legend.createItem(this.getLinkedParent());
      legendItem = legend.getItem(this.config.legendItemId);
    }

    legendItem.configure(config);
    legendItem.setStateCosmetics('default', {
      symbol: {
        fill: this.config.realColor || this.config.color,
        stroke: this.config.barbordercolor,
        rawFillColor: this.config.realColor || this.config.color,
        rawStrokeColor: this.config.barbordercolor,
        bgColor: this.config.realColor || this.config.color,
        bgAlpha: (this.config.realBarAlpha || this.config.baralpha) * 100,
        opacity: (this.config.realBarAlpha || this.config.baralpha) * 100
      }
    });
    legendItem.setStateCosmetics('highlight', {
      symbol: {
        fill: this.config.legenditemcolor,
        stroke: this.config.legenditembordercolor,
        rawFillColor: this.config.legenditemcolor,
        rawStrokeColor: this.config.legenditembordercolor,
        bgColor: this.config.legenditemcolor,
        bgAlpha: 25,
        opacity: 25
      },
      text: {
        fill: (0, _lib.toRaphaelColor)({
          alpha: 25
        })
      }
    });
    this.addExtEventListener('fc-click', function () {
      legendItem.itemClickFn();
    }, legendItem);
  }
  /**
   * Returns text with processed macro values
   * @param {String} text the text to be processed.
   * @param {Boolean} isIcon flag for including icons.
   * @returns {String} The parsed text with svg/span macro elements
   * @memberof RadialBarPlot
   */
  ;

  _proto.getParsedText = function getParsedText(text, isIcon, textSize) {
    var legend = this.getFromEnv('legend'),
        chartConfig = this.getFromEnv('chartConfig'),
        radialBar = this.getLinkedParent(),
        SMALLSQUARE = '&#9632;',
        MEDIUMSQUARE = '&#x25FC;',
        uniChar = _lib.isIpad ? SMALLSQUARE : MEDIUMSQUARE,
        pathArr,
        newPathArr = [],
        i,
        j,
        symbolBBox,
        legendItemSymbol,
        pathStart = [],
        finalPath = _lib.BLANKSTRING,
        legendItem = this.getLinkedParent().config.showLegend && legend.getItem(this.config.legendItemId),
        graphicalElement = legendItem && legendItem.getGraphicalElement(),
        transformText = '',
        svgSize = textSize || this.config.labelFontSize,
        plotIdentifier,
        parseConfig,
        imageSize,
        svgScale,
        strokeWidth,
        iconSpacing;

    if (legendItem && !chartConfig.showiconinlegend) {
      legendItemSymbol = graphicalElement && graphicalElement.legendItemSymbol;
      pathArr = legendItemSymbol && legendItemSymbol.attrs.path.split(/(?=[LMCA])/);
      symbolBBox = legendItemSymbol && legendItemSymbol.node.getBBox();
      svgSize = symbolBBox.height;
      strokeWidth = graphicalElement.legendItemSymbol.node.getAttribute('stroke-width');

      if (textSize && textSize < symbolBBox.height) {
        svgSize = textSize;
        svgScale = textSize / symbolBBox.height;
        strokeWidth = strokeWidth * svgScale / 2;
        transformText = "transform=scale(" + svgScale + "," + svgScale + ")";
      }

      if (pathArr && pathArr.length) {
        for (i = 0; i < pathArr.length; i++) {
          pathStart.push(pathArr[i][0]);
          pathArr[i] = pathArr[i].substring(1, pathArr[i].length);

          if (i === pathArr.length - 1) {
            pathArr[i] = pathArr[i].substring(0, pathArr[i].length - 1);
          }

          newPathArr[i] = pathArr[i].split(',');
        }
      }

      if (newPathArr && newPathArr.length) {
        for (i = 0; i < newPathArr.length; i++) {
          if (newPathArr[i].length) {
            for (j = 0; j < newPathArr[i].length; j++) {
              newPathArr[i][j] = Number(newPathArr[i][j]);

              if (pathStart[i] !== 'A') {
                if (j % 2 === 0) {
                  newPathArr[i][j] = newPathArr[i][j] - symbolBBox.x;
                } else {
                  newPathArr[i][j] = newPathArr[i][j] - symbolBBox.y;
                }
              } else if (pathStart[i] === 'A') {
                if (j === 5) {
                  newPathArr[i][j] = newPathArr[i][j] - symbolBBox.x;
                } else if (j === 6) {
                  newPathArr[i][j] = newPathArr[i][j] - symbolBBox.y;
                }
              }
            }
          }

          finalPath += pathStart[i] + newPathArr[i].toString();
        }
      }

      finalPath = finalPath + 'Z';
    }

    plotIdentifier = legendItem && finalPath ? "<svg style=\"margin:0px 1px 0px 1px;\" height= " + svgSize + " width = " + svgSize + " overflow='visible' xmlns=\"http://www.w3.org/2000/svg\">\n      <path d= " + finalPath + " fill = " + (this.config.realColor || this.config.color) + " stroke = " + graphicalElement.legendItemSymbol.node.getAttribute('stroke') + "\n      stroke-opacity = 1 fill-opacity = 1 " + transformText + "\n      stroke-width = " + strokeWidth + " stroke-linecap = " + graphicalElement.legendItemSymbol.node.getAttribute('stroke-linecap') + "></path>\n    </svg>" : "<span style='color: " + (this.config.realColor || this.config.color) + ";'>" + uniChar + "&nbsp;</span>";
    parseConfig = {
      value: this.config.value,
      barColor: this.config.realColor || this.config.color,
      plotIdentifier: plotIdentifier
    };

    if (isIcon) {
      if (this.config.iconurl) {
        imageSize = svgSize * parseInt(radialBar.config.iconscale, 10) / 100;

        if (imageSize >= Math.abs(this.config.outerRadius - this.config.innerRadius)) {
          imageSize = Math.abs(this.config.outerRadius - this.config.innerRadius);
        }

        imageSize = imageSize < 0 ? Math.abs(this.config.outerRadius - this.config.innerRadius) : imageSize;

        if (textSize) {
          iconSpacing = radialBar.config.iconposition === 'end' ? '0px 0px 0px 10px' : '0px 10px 0px 0px';
        }

        parseConfig.icon = "<svg style=\"margin:" + iconSpacing + ";\" height= " + imageSize + " width = " + imageSize + " overflow='visible' xmlns=\"http://www.w3.org/2000/svg\">\n          <image preserveAspectRatio=\"none\" href=" + this.config.iconurl + "\n          x=\"0\" y=\"0\" width= " + imageSize + " height=" + imageSize + "></image>\n        </svg>";
      } else {
        parseConfig.icon = plotIdentifier;
      }
    } // Setting the custom tooltip text for the plot


    return (0, _lib.parseTooltext)(text, [1, 2, 3, 172, 145, 173], {
      label: this.config.label,
      formattedValue: this.config.dataValue
    }, parseConfig) || this.config.label;
  }
  /**
   * Draws the plot
   * @memberof RadialBarPlot
   */
  ;

  _proto.draw = function draw() {
    var radialBar = this.getLinkedParent();
    this.addGraphicalElement({
      el: 'path',
      attr: {
        'path': this.config.path_d,
        'fill': this.config.color,
        'stroke': this.config.barbordercolor,
        'stroke-width': this.config.barborderthickness,
        'stroke-opacity': this.config.plotHidden ? 0 : this.config.barborderalpha,
        'stroke-dasharray': this.config.barborder === 'dashed' ? 5 : _lib.UNDEF,
        'fill-opacity': this.config.plotHidden ? 0 : this.config.baralpha
      },
      container: {
        id: 'node-container',
        isParent: true
      },
      label: 'bar',
      component: this
    }); // Draw label for this bar

    if (!this.config.plotHidden) {
      radialBar.drawLabel(radialBar.getChildren('dataset')[this.config.plotIndex], this);
    }
  };

  return RadialBarPlot;
}(_componentInterface.SmartRenderer);

var _default = RadialBarPlot;
exports["default"] = _default;

/***/ }),

/***/ 1572:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _defineProperty2 = _interopRequireDefault(__webpack_require__(273));

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _componentInterface = __webpack_require__(290);

var _polarUtil = __webpack_require__(1454);

var _lib = __webpack_require__(274);

var _animationManager = _interopRequireDefault(__webpack_require__(329));

var _index = __webpack_require__(282);

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var PERCENT_STR = '%',
    M = 'M',
    A = 'A',
    L = 'L',
    Z = 'Z';
/**
 * Sets the svg path for drawing
 * @param {Number} _startAngle - angle where the bar starts
 * @param {Number} _endAngle - angle where the bar ends
 * @param {Number} arc - arc between the two angles
 * @param {Number} outerRadius - outer radius for the bar
 * @param {Number} innerRadius - inner radius for the bar
 * @param {Number} centerX - x coordinate of the center of the arc
 * @param {Number} centerY - y coordinate of the center of the arc
 * @param {Number} thickness - thickness of the bar
 * @param {Number} startRadius - radius for the rounded starting
 * @param {Number} endRadius - radius for rounded ending
 * @param {Boolean} trackClockwise - flag to tell if the path is clockwise or anti-clockwise
 * @returns {Array} The path array for the path to be drawn
 */

function setPath(_startAngle, _endAngle, arc, outerRadius, innerRadius, centerX, centerY, thickness, startRadius, endRadius, trackClockwise) {
  // in case of round edges, angles will be shifted so as to adjust round edge arc in the same place
  if (startRadius > 0 && arc !== 360) {
    // eslint-disable-next-line no-param-reassign
    _startAngle += (0, _polarUtil.radiansInAngle)(startRadius, innerRadius + startRadius);
  }

  if (endRadius > 0 && arc !== 360) {
    // eslint-disable-next-line no-param-reassign
    _endAngle -= (0, _polarUtil.radiansInAngle)(endRadius, innerRadius + endRadius);
  }

  var startAngle = (0, _polarUtil.normaliseAngle)(_startAngle),
      endAngle = (0, _polarUtil.normaliseAngle)(_endAngle),
      _pointOnCircleFromCen = (0, _polarUtil.pointOnCircleFromCenter)(centerX, centerY, outerRadius, startAngle),
      x1 = _pointOnCircleFromCen.x,
      y1 = _pointOnCircleFromCen.y,
      _pointOnCircleFromCen2 = (0, _polarUtil.pointOnCircleFromCenter)(centerX, centerY, outerRadius, endAngle),
      x2 = _pointOnCircleFromCen2.x,
      y2 = _pointOnCircleFromCen2.y,
      _pointOnCircleFromCen3 = (0, _polarUtil.pointOnCircleFromCenter)(centerX, centerY, innerRadius, startAngle),
      x3 = _pointOnCircleFromCen3.x,
      y3 = _pointOnCircleFromCen3.y,
      _pointOnCircleFromCen4 = (0, _polarUtil.pointOnCircleFromCenter)(centerX, centerY, innerRadius, endAngle),
      x4 = _pointOnCircleFromCen4.x,
      y4 = _pointOnCircleFromCen4.y;

  x1 = (0, _lib.toPrecision)(x1, 4);
  y1 = (0, _lib.toPrecision)(y1, 4);
  x2 = (0, _lib.toPrecision)(x2, 4);
  y2 = (0, _lib.toPrecision)(y2, 4);
  x3 = (0, _lib.toPrecision)(x3, 4);
  y3 = (0, _lib.toPrecision)(y3, 4);
  x4 = (0, _lib.toPrecision)(x4, 4);
  y4 = (0, _lib.toPrecision)(y4, 4);
  return [M, x1, y1, A, outerRadius, outerRadius, 0, arc <= 180 ? 0 : 1, trackClockwise ? 1 : 0, x2, y2, endRadius > 0 && arc !== 360 ? A + ", " + thickness / 2 + ", " + endRadius + ", 0, 1, 1, " + x4 + ", " + y4 : L + ", " + x4 + ", " + y4, A, innerRadius, innerRadius, 0, arc <= 180 ? 0 : 1, trackClockwise ? 0 : 1, x3, y3, startRadius > 0 && arc !== 360 ? A + ", " + startRadius + ", " + thickness / 2 + ", 0, 1, 1, " + x1 + ", " + y1 : '', Z];
}

function setTextPath(_startAngle, _endAngle, arc, radius, centerX, centerY, trackClockwise) {
  var startAngle = (0, _polarUtil.normaliseAngle)(_startAngle),
      endAngle = (0, _polarUtil.normaliseAngle)(_endAngle),
      _pointOnCircleFromCen5 = (0, _polarUtil.pointOnCircleFromCenter)(centerX, centerY, radius, startAngle),
      x1 = _pointOnCircleFromCen5.x,
      y1 = _pointOnCircleFromCen5.y,
      _pointOnCircleFromCen6 = (0, _polarUtil.pointOnCircleFromCenter)(centerX, centerY, radius, endAngle),
      x2 = _pointOnCircleFromCen6.x,
      y2 = _pointOnCircleFromCen6.y;

  x1 = (0, _lib.toPrecision)(x1, 4);
  y1 = (0, _lib.toPrecision)(y1, 4);
  x2 = (0, _lib.toPrecision)(x2, 4);
  y2 = (0, _lib.toPrecision)(y2, 4);
  return "M " + x1 + " " + y1 + " A " + radius + " " + radius + " 0 " + (arc <= 180 ? 0 : 1) + " " + (trackClockwise ? 1 : 0) + " " + x2 + " " + y2 + " Z";
}

var RadialTrack = /*#__PURE__*/function (_SmartRenderer) {
  (0, _inheritsLoose2.default)(RadialTrack, _SmartRenderer);

  function RadialTrack() {
    return _SmartRenderer.apply(this, arguments) || this;
  }

  var _proto = RadialTrack.prototype;

  /**
   * Provides the name of the chart extension
   *
   * @return {string} The name of the chart extension
   */
  _proto.getName = function getName() {
    return 'RadialTrack';
  }
  /**
   * Provides the type of the chart extension
   *
   * @return {string} The type of the chart extension
   */
  ;

  _proto.getType = function getType() {
    return 'dataset';
  }
  /**
   * Provides the name of the chart extension
   *
   * @static
   * @return {string} The name of the chart extension
   */
  ;

  RadialTrack.getName = function getName() {
    return 'RadialTrack';
  }
  /**
   * Provides the type of the chart extension
   *
   * @static
   * @return {string} The type of the chart extension
   */
  ;

  RadialTrack.getType = function getType() {
    return 'dataset';
  }
  /**
   * Sets the default values for parameters of the chart.
   * @memberof RadialTrack
   */
  ;

  _proto.__setDefaultConfig = function __setDefaultConfig() {
    this.config.startangle = 90;
    this.config.endangle = 180;
    this.config.trackpadding = 0;
    this.config.trackmargin = 6;
    this.config.trackstartradius = '100%';
    this.config.trackendradius = '100%';
    this.config.trackfillcolor = '#0000ff';
    this.config.trackalpha = 0.4;
    this.config.trackborder = 'none';
    this.config.trackbordercolor = '#000000';
    this.config.trackborderalpha = 1;
    this.config.trackborderthickness = 1;
    this.config.value = 0;
  }
  /**
   * Configures the chart attributes.
   * @memberof RadialTrack
   */
  ;

  _proto.configureAttributes = function configureAttributes(dataObj) {
    _SmartRenderer.prototype.configureAttributes.call(this, dataObj);

    this.config = _objectSpread(_objectSpread({}, this.config), dataObj);

    if (!this.getFromEnv('chartConfig')) {
      this.addToEnv('chartConfig', this.config);
    }

    this.createBaseComponent();

    if (dataObj.thickness) {
      this.config.thickness = dataObj.thickness;
    }

    if (dataObj.startangle || dataObj.startangle === 0) {
      this.config.startingAngle = dataObj.startangle;
    }

    if (dataObj.endangle || dataObj.endangle === 0) {
      this.config.endingAngle = dataObj.endangle;
    }

    if (this.config.trackborder === 'none') {
      this.config.trackborderalpha = 0;
      this.config.trackborderthickness = 0;
    }
  };

  _proto.createBaseComponent = function createBaseComponent() {
    var iapi = this,
        animationManager = iapi.getFromEnv('animationManager');

    if (!animationManager) {
      animationManager = new _animationManager.default();
      iapi.addToEnv('animationManager', animationManager);
      animationManager.addToEnv('chart', iapi);
    }

    animationManager.configure();

    animationManager._setAnimDuration();
  };

  _proto.addPaperToEnv = function addPaperToEnv() {
    var container = this.getFromEnv('chart-container'),
        Raphael = (0, _index.getDep)('redraphael', 'plugin'),
        paper = new Raphael(container, this.getFromEnv('chartWidth'), this.getFromEnv('chartHeight'));
    paper.setHTMLClassName('fusioncharts-div');
    var animationManager = this.getFromEnv('animationManager');
    animationManager.addToEnv('paper', paper);
  }
  /**
   * Called from the parent chart class. Sets values needed for
   * space management and kicks off drawing process.
   * @param {Number} box side of the square in which chart will be drawn.
   * @param {Number} thickness thickness of a track
   * @memberof RadialTrack
   */
  ;

  _proto.setNodePath = function setNodePath(box, thickness, config) {
    this.config.thickness = thickness;
    this.config.outerRadius = box / 2;
    this.config.innerRadius = this.config.outerRadius - this.config.thickness;
    this.config.trackstartradius = config.trackstartradius;
    this.config.trackendradius = config.trackendradius;
    this.manageSpace();
  }
  /**
   * Calculate margins and space for and mange space for components
   * @memberof RadialTrack
   */
  ;

  _proto.manageSpace = function manageSpace() {
    var chartConfig = this.getFromEnv('chartConfig'),
        config = this.config,
        radialBar = this.getLinkedParent(),
        canvasLeft = chartConfig.canvasLeft,
        canvasTop = chartConfig.canvasTop,
        availableWidth = chartConfig.canvasWidth,
        availableHeight = chartConfig.canvasHeight,
        centerX = canvasLeft + availableWidth / 2,
        centerY = canvasTop + availableHeight / 2,
        startAngle = (0, _polarUtil.changeAngleBase)(config.startingAngle),
        endingAngle = (0, _polarUtil.changeAngleBase)(config.endingAngle),
        endAngle = startAngle === endingAngle ? endingAngle - 0.1 : endingAngle,
        arc = (0, _polarUtil.findArc)(startAngle, endAngle),
        startRadius = parseInt(config.trackstartradius, 10) / 100 * (config.thickness / 2),
        endRadius = parseInt(config.trackendradius, 10) / 100 * (config.thickness / 2),
        labelFontSize = config.thickness - radialBar.config.labelpadding.top - radialBar.config.labelpadding.bottom,
        iconSize,
        numTicksBaseNumber = parseInt(arc / (radialBar.config.tickvaluefontsize / (2 * Math.PI * radialBar.config.outerradius) * 360) / 2, 10);
    labelFontSize = iconSize = labelFontSize < 5 ? config.thickness : labelFontSize;
    iconSize = iconSize * parseInt(radialBar.config.iconscale, 10) / 100;

    if (iconSize >= Math.abs(config.outerRadius - config.innerRadius)) {
      iconSize = Math.abs(config.outerRadius - config.innerRadius);
    }

    iconSize = iconSize < 0 ? Math.abs(config.outerRadius - config.innerRadius) : iconSize; // Calculating the number of ticks as per start & end angles and font size

    config.numTicks = parseInt(config.numTicks, 10);

    if (isNaN(config.numTicks)) {
      // When numticks is auto
      config.numTicks = numTicksBaseNumber > 10 ? 10 : numTicksBaseNumber;
    } else {
      config.numTicks = config.numTicks > numTicksBaseNumber ? numTicksBaseNumber : config.numTicks;
    } // Setting the angle occupied by icon display


    iconSize = radialBar.config.iconposition === 'end' ? iconSize / 2 + 10 : iconSize + 10;
    config.iconAngle = iconSize / (2 * Math.PI * (config.outerRadius - config.thickness / 2)) * 360;
    config.iconAngle = radialBar.config.showlabelicon ? config.iconAngle : 0; // Setting the angle occupied by plot identifier display

    config.plotIdentifierAngle = radialBar.config.labeltext.toLowerCase().indexOf('$plotidentifier') > -1 ? (labelFontSize + 1) / (2 * Math.PI * (config.outerRadius - config.thickness)) * 360 : 0; // Setting the angle occupied by padding

    config.paddingAngle = radialBar.config.labelpadding.left / (2 * Math.PI * (config.outerRadius - config.thickness / 2)) * 360;
    config.labelPath = {
      start: {
        start: setTextPath(startAngle + config.paddingAngle + config.iconAngle + config.plotIdentifierAngle, endAngle, arc, config.outerRadius - config.thickness / 2, centerX, centerY, config.thickness, startRadius, endRadius, true),
        end: setTextPath(startAngle + config.paddingAngle + config.plotIdentifierAngle, endAngle, arc, config.outerRadius - config.thickness / 2, centerX, centerY, true)
      },
      end: {
        start: setTextPath(endAngle - config.paddingAngle - config.iconAngle - config.plotIdentifierAngle, startAngle, arc, config.outerRadius - config.thickness / 2, centerX, centerY, false),
        end: setTextPath(endAngle - config.paddingAngle - config.plotIdentifierAngle, startAngle, arc, config.outerRadius - config.thickness / 2, centerX, centerY, false)
      }
    };
    config.arcLength = arc / 360 * (2 * Math.PI * (config.outerRadius - config.thickness / 2));
    config.path_d = setPath(startAngle, endAngle, arc, config.outerRadius, config.innerRadius, centerX, centerY, config.thickness, startRadius, endRadius, true);
  } // eslint-disable-next-line class-methods-use-this
  ;

  _proto.allocatePosition = function allocatePosition() {
    return false;
  } // eslint-disable-next-line class-methods-use-this
  ;

  _proto.checkInvalidData = function checkInvalidData() {
    return false;
  } // eslint-disable-next-line class-methods-use-this
  ;

  _proto.checkInvalidSpecificData = function checkInvalidSpecificData() {
    return false;
  }
  /**
   * Draws the track
   * @memberof RadialTrack
   */
  ;

  _proto.draw = function draw() {
    this.addGraphicalElement({
      el: 'path',
      attr: {
        'path': this.config.path_d,
        'fill': this.config.trackfillcolor,
        'stroke': this.config.trackbordercolor,
        'stroke-width': this.config.trackborderthickness,
        'stroke-opacity': this.config.trackborderalpha,
        'stroke-dasharray': this.config.trackborder === 'dashed' ? 5 : _lib.UNDEF,
        'fill-opacity': this.config.trackalpha
      },
      container: {
        id: 'node-container',
        isParent: true
      },
      label: 'track',
      component: this
    }); // Create ticks

    if (this.config.isLast) {
      this.drawTicks();
    }
  }
  /**
   * Draws the ticks anf tick labels
   * @memberof RadialTrack
   */
  ;

  _proto.drawTicks = function drawTicks() {
    var _this = this;

    var chartConfig = this.getFromEnv('chartConfig'),
        canvasLeft = chartConfig.canvasLeft,
        canvasTop = chartConfig.canvasTop,
        availableWidth = chartConfig.canvasWidth,
        availableHeight = chartConfig.canvasHeight,
        centerX = canvasLeft + availableWidth / 2,
        centerY = canvasTop + availableHeight / 2,
        startAngle = (0, _polarUtil.changeAngleBase)(this.config.startingAngle),
        endingAngle = (0, _polarUtil.changeAngleBase)(this.config.endingAngle),
        trackArc = (0, _polarUtil.findArc)(startAngle, startAngle === endingAngle ? endingAngle - 0.1 : endingAngle),
        diff = trackArc / this.config.numTicks,
        percentDiff = 100 / this.config.numTicks,
        start,
        end,
        finalAngle,
        labelstart,
        tickValueRadius,
        labelStartArr = [];

    if (startAngle === endingAngle) {
      this.config.numTicks -= 1;
    }

    for (var i = 0; i <= this.config.numTicks; i++) {
      finalAngle = (0, _polarUtil.normaliseAngle)(startAngle) + i * diff;
      tickValueRadius = this.config.outerRadius + this.config.tickMarkLength + this.config.tickvaluegap;
      labelstart = (0, _polarUtil.pointOnCircleFromCenter)(centerX, centerY, tickValueRadius, finalAngle);

      if (this.config.showtickvalues) {
        labelStartArr.push(labelstart);
      }

      end = (0, _polarUtil.pointOnCircleFromCenter)(centerX, centerY, this.config.outerRadius + this.config.tickMarkLength, finalAngle);
      start = (0, _polarUtil.pointOnCircleFromCenter)(centerX, centerY, this.config.outerRadius, finalAngle); // Adding the tick marks

      if (this.config.showtickmarks && this.config.showticks) {
        this.addGraphicalElement({
          el: 'path',
          attr: {
            'path': M + " " + start.x + " " + start.y + " " + L + " " + end.x + " " + end.y + " " + Z,
            'stroke': this.config.tickmarkcolor,
            'stroke-width': this.config.tickmarkthickness / 2,
            'stroke-opacity': this.config.tickalpha
          },
          container: {
            id: 'ticks-container',
            isParent: true
          },
          label: 'tick',
          component: this
        });
      }
    }

    if (this.config.showtickvalues && this.config.showticks) {
      labelStartArr.forEach(function (labelPos, index) {
        finalAngle = (0, _polarUtil.changeAngleBase)((0, _polarUtil.normaliseAngle)(startAngle) + index * diff);
        finalAngle = finalAngle < 0 ? 360 + finalAngle : finalAngle;
        finalAngle = finalAngle % 360;

        _this.addGraphicalElement({
          el: 'text',
          attr: {
            'text': Math.round(index * percentDiff) + PERCENT_STR,
            'x': labelPos.x,
            'y': labelPos.y,
            'fill': _this.config.tickvaluefontcolor,
            'font-family': _this.config.tickvaluelabelfont,
            'font-size': _this.computeFontSize(_this.config.tickvaluefontsizeWithUnit),
            'opacity': _this.config.tickvaluealpha,
            'text-anchor': finalAngle > 180 ? 'end' : 'start'
          },
          container: {
            id: 'ticks-container',
            isParent: true
          },
          label: 'label',
          component: _this
        });
      });
    }
  };

  return RadialTrack;
}(_componentInterface.SmartRenderer);

var _default = RadialTrack;
exports["default"] = _default;

/***/ }),

/***/ 1543:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _area = _interopRequireDefault(__webpack_require__(617));

var _realtimecolumn = __webpack_require__(1540);

/* eslint require-jsdoc: 'error', valid-jsdoc: ["error", { "requireReturn": false }] */

/**
 * Real time area dataset class definition
 */
var RealtimeAreaDataset = /*#__PURE__*/function (_AreaDataset) {
  (0, _inheritsLoose2.default)(RealtimeAreaDataset, _AreaDataset);

  function RealtimeAreaDataset() {
    return _AreaDataset.apply(this, arguments) || this;
  }

  var _proto = RealtimeAreaDataset.prototype;

  /**
   * Setting the dataStore as per the numDisplaySets attributes.
   * @param  {boolean} force set true during clear chart
   */
  _proto._realTimeConfigure = function _realTimeConfigure(force) {
    _realtimecolumn._realTimeConfigure.call(this, force);
  }
  /**
   * Sets the type of the component
   * @return {string} type
   */
  ;

  _proto.getType = function getType() {
    return 'dataset';
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */
  ;

  _proto.getName = function getName() {
    return 'realTimeArea';
  };

  return RealtimeAreaDataset;
}(_area.default);

RealtimeAreaDataset.prototype.resetCatPos = _realtimecolumn.resetCatPos;
var _default = RealtimeAreaDataset;
exports["default"] = _default;

/***/ }),

/***/ 1541:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _index = _interopRequireDefault(__webpack_require__(599));

var _default = {
  'initial.dataset.realtimeColumn': _index.default['initial.dataset.column']
};
exports["default"] = _default;

/***/ }),

/***/ 1540:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = exports.resetCatPos = exports._realTimeConfigure = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _column = _interopRequireDefault(__webpack_require__(595));

var _dependencyManager = __webpack_require__(282);

var _index = _interopRequireDefault(__webpack_require__(1541));

/* eslint require-jsdoc: 'error', valid-jsdoc: ["error", { "requireReturn": false }] */
(0, _dependencyManager.addDep)({
  name: 'realtimeColumnAnimation',
  type: 'animationRule',
  extension: _index.default
});
/**
 * Real time column dataset class definition
 */

var RealtimeColumnDataset = /*#__PURE__*/function (_ColumnDataset) {
  (0, _inheritsLoose2.default)(RealtimeColumnDataset, _ColumnDataset);

  function RealtimeColumnDataset() {
    return _ColumnDataset.apply(this, arguments) || this;
  }

  var _proto = RealtimeColumnDataset.prototype;

  /**
   * Setting the dataStore as per the numDisplaySets attributes.
   * @param  {boolean} force set true during clear chart
   */
  _proto._realTimeConfigure = function _realTimeConfigure(force) {
    var dataSet = this,
        chart = dataSet.getFromEnv('chart'),
        datasetStore = dataSet.components.data,
        tempArr = [],
        numDisplaySets = chart.config.realTimeConfig.numDisplaySets,
        catLen;
    catLen = force ? 0 : Math.min(dataSet.getFromEnv('xAxis').getTicksLen(), datasetStore && datasetStore.length);

    if (catLen < numDisplaySets) {
      tempArr.length = numDisplaySets - catLen;
      dataSet.components.data = tempArr.concat(datasetStore);
    } else if (catLen > numDisplaySets) {
      dataSet.components.data.splice(numDisplaySets, catLen - numDisplaySets);
    }

    dataSet.resetCatPos && dataSet.resetCatPos();
  }
  /**
   * Sets the type of the component
   * @return {string} type
   */
  ;

  _proto.getType = function getType() {
    return 'dataset';
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */
  ;

  _proto.getName = function getName() {
    return 'realtimeColumn';
  }
  /**
   * Function to reset the _x position of plots when it is a changed due to RT update
   */
  ;

  _proto.resetCatPos = function resetCatPos() {
    var dataSet = this,
        dataStore = dataSet.components.data,
        len = dataStore.length,
        i;

    if (dataStore && len) {
      for (i = 0; i < len; i++) {
        if (dataStore[i] && dataStore[i].config) {
          dataStore[i].config._x = i;
        }
      }
    }
  };

  return RealtimeColumnDataset;
}(_column.default);

var _realTimeConfigure = RealtimeColumnDataset.prototype._realTimeConfigure,
    resetCatPos = RealtimeColumnDataset.prototype.resetCatPos;
exports.resetCatPos = resetCatPos;
exports._realTimeConfigure = _realTimeConfigure;
var _default = RealtimeColumnDataset;
exports["default"] = _default;

/***/ }),

/***/ 1547:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _line = _interopRequireDefault(__webpack_require__(616));

var _realtimecolumn = __webpack_require__(1540);

/* eslint require-jsdoc: 'error', valid-jsdoc: ["error", { "requireReturn": false }] */

/**
 * Real time line dataset class definition
 */
var RealtimeLineDataset = /*#__PURE__*/function (_LineDataset) {
  (0, _inheritsLoose2.default)(RealtimeLineDataset, _LineDataset);

  function RealtimeLineDataset() {
    return _LineDataset.apply(this, arguments) || this;
  }

  var _proto = RealtimeLineDataset.prototype;

  /**
   * Setting the dataStore as per the numDisplaySets attributes.
   * @param  {boolean} force set true during clear chart
   */
  _proto._realTimeConfigure = function _realTimeConfigure(force) {
    _realtimecolumn._realTimeConfigure.call(this, force);
  }
  /**
   * Sets the type of the component
   * @return {string} type
   */
  ;

  _proto.getType = function getType() {
    return 'dataset';
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */
  ;

  _proto.getName = function getName() {
    return 'realtimeLine';
  };

  return RealtimeLineDataset;
}(_line.default);

RealtimeLineDataset.prototype.resetCatPos = _realtimecolumn.resetCatPos;
var _default = RealtimeLineDataset;
exports["default"] = _default;

/***/ }),

/***/ 1535:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _index = _interopRequireDefault(__webpack_require__(599));

var _default = {
  'initial.dataset.sparkColumn': _index.default['initial.dataset.column']
};
exports["default"] = _default;

/***/ }),

/***/ 1534:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _lib = __webpack_require__(274);

var _dependencyManager = __webpack_require__(282);

var _column = _interopRequireDefault(__webpack_require__(595));

var _index = _interopRequireDefault(__webpack_require__(1535));

/* eslint require-jsdoc: 'error', valid-jsdoc: ["error", { "requireReturn": false }] */
var UNDEF,
    math = Math,
    mathMin = math.min; // mathRound = math.round,

(0, _dependencyManager.addDep)({
  name: 'sparkcolumnAnimation',
  type: 'animationRule',
  extension: _index.default
});
/**
 * Creates class SparkColumnDataset
 */

var SparkColumnDataset = /*#__PURE__*/function (_ColumnDataset) {
  (0, _inheritsLoose2.default)(SparkColumnDataset, _ColumnDataset);

  function SparkColumnDataset() {
    return _ColumnDataset.apply(this, arguments) || this;
  }

  var _proto = SparkColumnDataset.prototype;

  /**
   * Sets the type of the component
   * @return {string} type
   */
  _proto.getType = function getType() {
    return 'dataset';
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */
  ;

  _proto.getName = function getName() {
    return 'sparkColumn';
  };

  _proto.parseAttributes = function parseAttributes() {
    _ColumnDataset.prototype.parseAttributes.call(this);

    var dataSet = this,
        chart = dataSet.getFromEnv('chart'),
        conf = dataSet.config,
        JSONData = dataSet.config.JSONData,
        chartAttr = chart.getFromEnv('chart-attrib');
    conf.showValues = (0, _lib.pluckNumber)(JSONData.showvalues, chartAttr.showvalues, 0);
  }
  /**
   * Configures data level attribute settings
   * @param {Object} newDataset newly added dataset object
   */
  ;

  _proto._setConfigure = function _setConfigure(newDataset) {
    var dataSet = this,
        chart = dataSet.getFromEnv('chart'),
        chartAttr = chart.getFromEnv('dataSource').chart,
        conf = dataSet.config,
        chartConfig = chart.config,
        JSONData = dataSet.config.JSONData,
        setDataArr = newDataset || JSONData.data,
        setDataLen = setDataArr && setDataArr.length,
        xAxis = dataSet.getFromEnv('xAxis'),
        catLen = xAxis.getTicksLen(),
        len = newDataset && newDataset.data.length || mathMin(catLen, setDataLen),
        showHoverEffect = chartConfig.plothovereffect,
        colorM = dataSet.getFromEnv('color-manager'),
        isRoundEdges = chartConfig.useroundedges,
        plotFillColor,
        color,
        borderColor,
        rawHoverColor,
        hoverColor,
        hoverAlpha,
        hoverGradientColor,
        hoverBorderColor,
        hoverBorderAlpha,
        borderThickness,
        config,
        plotFillAlpha,
        plotBorderAlpha,
        plotBorderColor,
        highColor,
        lowColor,
        highBorderColor,
        lowBorderColor,
        highDisplayValue,
        lowDisplayValue,
        macroIndices,
        parserConfig,
        setData,
        dataObj,
        colorArr,
        hoverColorArr,
        i,
        cLen,
        cInd,
        dataStore,
        maxValue,
        minValue;
    conf.plotgradientcolor = _lib.BLANKSTRING;
    conf.showvalues = (0, _lib.pluckNumber)(JSONData.showvalues, chartAttr.showvalues, 0);
    conf.showShadow = (0, _lib.pluckNumber)(chartAttr.showshadow, 0); // this.__base__._setConfigure.call(this);

    _ColumnDataset.prototype._setConfigure.call(this);

    dataStore = dataSet.components.data;
    maxValue = conf.maxValue;
    minValue = conf.minValue;
    plotFillColor = (0, _lib.pluck)(chartAttr.plotfillcolor, colorM.getColor('plotFillColor'));
    plotFillAlpha = (0, _lib.pluck)(chartAttr.plotfillalpha, _lib.HUNDREDSTRING);
    plotBorderAlpha = (0, _lib.pluck)(chartAttr.plotborderalpha, _lib.HUNDREDSTRING);
    plotBorderColor = (0, _lib.pluck)(chartAttr.plotbordercolor, plotFillColor); // Fill Color for high column and low column

    highColor = (0, _lib.pluck)(chartAttr.highcolor, '000000');
    lowColor = (0, _lib.pluck)(chartAttr.lowcolor, '000000');
    highBorderColor = (0, _lib.pluck)(chartAttr.highbordercolor, chartAttr.plotbordercolor, highColor);
    lowBorderColor = (0, _lib.pluck)(chartAttr.lowbordercolor, chartAttr.plotbordercolor, lowColor); // conf.plotBorderThickness = borderThickness = pluckNumber(chartAttr.showplotborder, 0) ?
    //         pluckNumber(chartAttr.plotborderthickness, 1) : 0;
    // Loop through datastore and change the cosmetics

    for (i = 0; i < len; i++) {
      // Original data provided by user
      setData = setDataArr[i]; // Parsed data previously

      dataObj = dataStore[i];
      config = dataObj.config;
      colorArr = null;
      color = plotFillColor;
      borderColor = plotBorderColor; // Max value

      if (config.setValue === maxValue) {
        color = highColor;
        borderColor = highBorderColor;
        highDisplayValue = config.displayValue;
      } // Min value


      if (dataObj.config.setValue === minValue) {
        color = lowColor;
        borderColor = lowBorderColor;
        lowDisplayValue = config.displayValue;
      }

      config.originalPlotColor = (0, _lib.hashify)(color);
      config.plotbordercolor = borderColor; // Setting the color Array to be applied to the bar/column.

      config.colorArr = colorArr = (0, _lib.getColumnColor)(color + _lib.COMMASTRING + conf.plotgradientcolor, plotFillAlpha, '0', '90', isRoundEdges, borderColor, plotBorderAlpha, 0, 0); // Parsing the hover effects only if showhovereffect is not 0.

      if (showHoverEffect !== 0 && colorArr) {
        hoverColor = hoverAlpha = UNDEF; // Max value

        if (config.setValue === maxValue) {
          hoverColor = chartAttr.highhovercolor;
          hoverAlpha = chartAttr.highhoveralpha;
        } // Min value


        if (dataObj.config.setValue === minValue) {
          hoverColor = chartAttr.lowhovercolor;
          hoverAlpha = chartAttr.lowhoveralpha;
        }

        hoverColor = rawHoverColor = (0, _lib.pluck)(setData.hovercolor, JSONData.hovercolor, hoverColor, chartAttr.plotfillhovercolor, chartAttr.columnhovercolor, colorArr[0].FCcolor.color);
        hoverColor = hoverColor.split(/\s{0,},\s{0,}/);
        cLen = hoverColor.length;

        for (cInd = 0; cInd < cLen; cInd++) {
          hoverColor[cInd] = (0, _lib.getLightColor)(hoverColor[cInd], 70);
        }

        hoverColor = hoverColor.join(',');
        hoverAlpha = (0, _lib.pluck)(setData.hoveralpha, JSONData.hoveralpha, hoverAlpha, chartAttr.plotfillhoveralpha, chartAttr.columnhoveralpha, plotFillAlpha);
        config.hoverColor = rawHoverColor;
        config.hoverAlpha = hoverAlpha;
        hoverGradientColor = (0, _lib.pluck)(setData.hovergradientcolor, JSONData.hovergradientcolor, chartAttr.plothovergradientcolor, conf.plotgradientcolor);
        !hoverGradientColor && (hoverGradientColor = _lib.BLANKSTRING);
        hoverBorderColor = (0, _lib.pluck)(setData.borderhovercolor, JSONData.borderhovercolor, chartAttr.plotborderhovercolor, conf.plotbordercolor);
        hoverBorderAlpha = (0, _lib.pluck)(setData.borderhoveralpha, JSONData.borderhoveralpha, chartAttr.plotborderhoveralpha, chartAttr.plotfillhoveralpha, plotBorderAlpha, plotFillAlpha); // hoverBorderThickness = pluckNumber(setData.borderhoverthickness,
        //               JSONData.borderhoverthickness, chartAttr.plotborderhoverthickness, borderThickness);

        /* If no hover effects are explicitly defined and
                   * showHoverEffect is not 0 then hoverColor is set.
                   */

        if (showHoverEffect === 1 && hoverColor === colorArr[0].FCcolor.color) {
          hoverColor = (0, _lib.getLightColor)(hoverColor, 70);
        } // setting the hover color array which is always applied except when showHoverEffect is not 0.


        hoverColorArr = (0, _lib.getColumnColor)(hoverColor + _lib.COMMASTRING + hoverGradientColor, hoverAlpha, '0', '90', isRoundEdges, hoverBorderColor, hoverBorderAlpha.toString(), 0, 0);
        config.setRolloutAttr = {
          fill: (0, _lib.toRaphaelColor)(colorArr[0]),
          stroke: borderThickness && (0, _lib.toRaphaelColor)(colorArr[1]),
          'stroke-width': borderThickness
        };
        config.setRolloverAttr = {
          fill: (0, _lib.toRaphaelColor)(hoverColorArr[0]),
          stroke: borderThickness && (0, _lib.toRaphaelColor)(hoverColorArr[1]),
          'stroke-width': borderThickness
        };
      }

      config._x = i;
      config._y = config.setValue;
    }

    for (i = 0; i < len; i++) {
      var dataObject = dataStore[i],
          configuration = dataObject.config;

      if (configuration.setTooltext !== UNDEF) {
        macroIndices = [56, 57, 60, 61];
        parserConfig = {
          highValue: highDisplayValue,
          highDataValue: highDisplayValue,
          lowValue: lowDisplayValue,
          lowDataValue: lowDisplayValue
        };
        configuration.toolText = (0, _lib.parseTooltext)(configuration.setTooltext, macroIndices, parserConfig, setData, chartAttr, JSONData);
        configuration.finalTooltext = configuration.setTooltext = configuration.toolText;
      }
    }
  };

  return SparkColumnDataset;
}(_column.default);

var _default = SparkColumnDataset;
exports["default"] = _default;

/***/ }),

/***/ 1528:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _index = _interopRequireDefault(__webpack_require__(619));

var _default = {
  '*.dataset.sparkLine': _index.default['*.dataset.line']
};
exports["default"] = _default;

/***/ }),

/***/ 1527:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _lib = __webpack_require__(274);

var _line = _interopRequireDefault(__webpack_require__(616));

var _dependencyManager = __webpack_require__(282);

var _index = _interopRequireDefault(__webpack_require__(1528));

/* eslint require-jsdoc: 'error', valid-jsdoc: ["error", { "requireReturn": false }] */
var UNDEF,
    GUTTER_PADDING = 2,
    defined = function defined(obj) {
  return obj !== UNDEF && obj !== null;
},
    drawSparkValues = function drawSparkValues() {
  var dataSet = this,
      chart = dataSet.getFromEnv('chart'),
      chartConf = chart.config,
      style = chartConf.dataLabelStyle,
      valuePadding = chartConf.valuepadding + GUTTER_PADDING,
      dataLabelContainer = dataSet.getContainer('labelGroup'),
      animationManager = dataSet.getFromEnv('animationManager'),
      closeValueCheck = dataSet.getGraphicalElement('closeValue'),
      closeValue,
      openValueCheck = dataSet.getGraphicalElement('openValue'),
      openValue,
      startBracesCheck = dataSet.getGraphicalElement('startBraces'),
      startBraces,
      highValueCheck = dataSet.getGraphicalElement('highValue'),
      highValue,
      separatorCheck = dataSet.getGraphicalElement('separator'),
      separator,
      lowValueCheck = dataSet.getGraphicalElement('lowValue'),
      lowValue,
      endBracesCheck = dataSet.getGraphicalElement('endBraces'),
      endBraces,
      sparkValues = chartConf.sparkValues || (chartConf.sparkValues = {}),
      SmartLabel = dataSet.getFromEnv('smartLabel'),
      START_BRACES = "[",
      END_BRACES = "]",
      SEPARATER = "|",
      textAttr = {
    'class': 'fusioncharts-label',
    'text-anchor': _lib.POSITION_END,
    fill: style.color,
    'font-size': style.fontSize,
    'font-weight': style.fontWeight,
    'font-style': style.fontStyle,
    'font-family': style.fontFamily,
    visibility: 'visible'
  },
      attr = {
    x: 0,
    y: 0
  }; // Spark values are not visible due to the clip-rect,
  // so removing clip-rect in order to make spark labels visible

  chart.getChildContainer('datalabelsGroup').attr({
    'clip-rect': null
  });
  attr.y = chartConf.canvasHeight * 0.5 + chartConf.canvasTop; // openValue

  attr.x = chartConf.canvasLeft - valuePadding;

  if (sparkValues.openValue && sparkValues.openValue.label || openValue) {
    openValue = animationManager.setAnimation({
      el: openValueCheck || 'text',
      state: 'appearing',
      container: dataLabelContainer,
      attr: {
        text: sparkValues.openValue.label,
        x: attr.x,
        y: attr.y,
        fill: sparkValues.openValue.color || textAttr.fill,
        'text-anchor': _lib.POSITION_END,
        'line-height': style.lineHeight,
        'text-bound': [style.backgroundColor, style.borderColor, style.borderThickness, style.borderPadding, style.borderRadius, style.borderDash],
        visibility: 'visible'
      },
      label: 'label',
      component: dataSet
    });

    if (!openValueCheck) {
      dataSet.addGraphicalElement('openValue', openValue);
    }
  } // closeValue


  textAttr['text-anchor'] = _lib.POSITION_START;
  attr.x = chartConf.canvasWidth + chartConf.canvasLeft + valuePadding;

  if (sparkValues.closeValue && sparkValues.closeValue.label || closeValue) {
    closeValue = animationManager.setAnimation({
      el: closeValueCheck || 'text',
      container: dataLabelContainer,
      state: 'appearing',
      attr: {
        text: sparkValues.closeValue.label,
        x: attr.x,
        y: attr.y,
        fill: sparkValues.closeValue.color || textAttr.fill,
        'text-anchor': _lib.POSITION_START,
        'line-height': style.lineHeight,
        'text-bound': [style.backgroundColor, style.borderColor, style.borderThickness, style.borderPadding, style.borderRadius, style.borderDash],
        visibility: 'visible'
      },
      label: 'label',
      component: dataSet
    });

    if (!closeValueCheck) {
      dataSet.addGraphicalElement('closeValue', closeValue);
    }

    attr.x += sparkValues.closeValue.smartObj && sparkValues.closeValue.smartObj.width + GUTTER_PADDING + valuePadding || 0;
  } // High-low value


  if (sparkValues.highLowValue && sparkValues.highLowValue.label || highValue) {
    if (sparkValues.highLowValue && sparkValues.highLowValue.label === _lib.BLANKSTRING) {
      SEPARATER = START_BRACES = END_BRACES = _lib.BLANKSTRING;
    }

    SmartLabel.useEllipsesOnOverflow(chartConf.useEllipsesWhenOverflow);
    SmartLabel.setStyle(style);
    startBraces = animationManager.setAnimation({
      el: startBracesCheck || 'text',
      state: 'appearing',
      container: dataLabelContainer,
      attr: {
        text: START_BRACES,
        x: attr.x,
        y: attr.y,
        'text-anchor': _lib.POSITION_START,
        visibility: 'visible'
      },
      label: 'label',
      component: dataSet
    });

    if (!startBracesCheck) {
      dataSet.addGraphicalElement('startBraces', startBraces);
    }

    attr.x += SmartLabel.getSmartText(START_BRACES).width;
    highValue = animationManager.setAnimation({
      el: highValueCheck || 'text',
      state: 'appearing',
      container: dataLabelContainer,
      attr: {
        text: sparkValues.highValue.label,
        x: attr.x,
        y: attr.y,
        'text-anchor': _lib.POSITION_START,
        fill: sparkValues.highValue.color || textAttr.fill,
        visibility: 'visible'
      },
      label: 'label',
      component: dataSet
    });

    if (!highValueCheck) {
      dataSet.addGraphicalElement('highValue', highValue);
    }

    attr.x += SmartLabel.getSmartText(sparkValues.highValue.label).width;
    separator = animationManager.setAnimation({
      el: separatorCheck || 'text',
      state: 'appearing',
      container: dataLabelContainer,
      attr: {
        text: SEPARATER,
        x: attr.x,
        y: attr.y,
        'text-anchor': _lib.POSITION_START,
        visibility: 'visible'
      },
      label: 'label',
      component: dataSet
    });

    if (!separatorCheck) {
      dataSet.addGraphicalElement('separator', separator);
    }

    attr.x += SmartLabel.getSmartText(SEPARATER).width;
    lowValue = animationManager.setAnimation({
      el: lowValueCheck || 'text',
      container: dataLabelContainer,
      state: 'appearing',
      attr: {
        text: sparkValues.lowValue.label,
        x: attr.x,
        y: attr.y,
        'text-anchor': _lib.POSITION_START,
        fill: sparkValues.lowValue.color || textAttr.fill,
        visibility: 'visible'
      },
      label: 'label',
      component: dataSet
    });

    if (!lowValueCheck) {
      dataSet.addGraphicalElement('lowValue', lowValue);
    }

    attr.x += SmartLabel.getSmartText(sparkValues.lowValue.label).width;
    endBraces = animationManager.setAnimation({
      el: endBracesCheck || 'text',
      state: 'appearing',
      container: dataLabelContainer,
      attr: {
        text: END_BRACES,
        x: attr.x,
        y: attr.y,
        'text-anchor': _lib.POSITION_START,
        visibility: 'visible'
      },
      label: 'label',
      component: dataSet
    });

    if (!endBracesCheck) {
      dataSet.addGraphicalElement('endBraces', endBraces);
    }
  }

  dataSet.labelDrawn = true;
};

(0, _dependencyManager.addDep)({
  name: 'sparklineAnimation',
  type: 'animationRule',
  extension: _index.default
});
/**
 * Creates class SparkLineDataset
 */

var SparkLineDataset = /*#__PURE__*/function (_LineDataset) {
  (0, _inheritsLoose2.default)(SparkLineDataset, _LineDataset);

  function SparkLineDataset() {
    return _LineDataset.apply(this, arguments) || this;
  }

  var _proto = SparkLineDataset.prototype;

  /**
   * Sets the type of the component
   * @return {string} type
   */
  _proto.getType = function getType() {
    return 'dataset';
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */
  ;

  _proto.getName = function getName() {
    return 'sparkLine';
  }
  /**
   * Constructor function of SparkLineDataset class
   * @param {Object} datasetJSON data object
   */
  ;

  _proto.parseAttributes = function parseAttributes() {
    _LineDataset.prototype.parseAttributes.call(this);

    var dataSet = this,
        chart = dataSet.getFromEnv('chart'),
        // parseUnsafeString = lib.parseUnsafeString,
    conf = dataSet.config,
        JSONData = dataSet.config.JSONData,
        chartAttr = chart.getFromEnv('chart-attrib');
    conf.showValues = (0, _lib.pluckNumber)(JSONData.showvalues, chartAttr.showvalues, 0); // Line configuration attributes parsing

    conf.linethickness = (0, _lib.pluckNumber)(JSONData.linethickness, chartAttr.linethickness, 1);
  }
  /**
   * Configures data level attribute settings
   * @param {Object} newDataset newly added dataset object
   */
  ;

  _proto._setConfigure = function _setConfigure(newDataset) {
    _LineDataset.prototype._setConfigure.call(this);

    var dataSet = this,
        chart = dataSet.getFromEnv('chart'),
        // parseUnsafeString = lib.parseUnsafeString,
    conf = dataSet.config,
        JSONData = dataSet.config.JSONData,
        chartAttr = chart.getFromEnv('dataSource').chart,
        setDataArr = newDataset || JSONData.data,
        setData,
        dataObj,
        xAxis = dataSet.getFromEnv('xAxis'),
        len = newDataset && newDataset.data.length || xAxis.getTicksLen(),
        colorM = dataSet.getFromEnv('color-manager'),
        chartConf = chart.config,
        dataStore,
        // dataLabelStyle = chartConf.dataLabelStyle,
    config,
        i,
        // Fill Color for high, low, open and close (SparkLine Charts)
    openColor = (0, _lib.parseColor)((0, _lib.pluck)(chartAttr.opencolor, '0099FF')),
        closeColor = (0, _lib.parseColor)((0, _lib.pluck)(chartAttr.closecolor, '0099FF')),
        highColor = (0, _lib.parseColor)((0, _lib.pluck)(chartAttr.highcolor, '00CC00')),
        lowColor = (0, _lib.parseColor)((0, _lib.pluck)(chartAttr.lowcolor, 'CC0000')),
        anchorColor = (0, _lib.parseColor)((0, _lib.pluck)(chartAttr.anchorcolor, colorM.getColor('plotFillColor'))),
        // Whether to show anchors for open, close, high & low
    showOpenAnchor = (0, _lib.pluckNumber)(chartAttr.showopenanchor, chartAttr.drawanchors, chartAttr.showanchors, 1),
        showCloseAnchor = (0, _lib.pluckNumber)(chartAttr.showcloseanchor, chartAttr.drawanchors, chartAttr.showanchors, 1),
        showHighAnchor = (0, _lib.pluckNumber)(chartAttr.showhighanchor, chartAttr.drawanchors, chartAttr.showanchors, 1),
        showLowAnchor = (0, _lib.pluckNumber)(chartAttr.showlowanchor, chartAttr.drawanchors, chartAttr.showanchors, 1),
        anchorAlpha = (0, _lib.pluckNumber)(chartAttr.anchoralpha, 100),
        showAnchors = (0, _lib.pluckNumber)(chartAttr.drawanchors, chartAttr.showanchors, 0),
        defAnchorAlpha = showAnchors ? (0, _lib.pluckNumber)(chartAttr.anchoralpha, 100) : 0,
        lineColor = (0, _lib.pluck)(chartAttr.linecolor, colorM.getColor('plotFillColor')),
        sparkValues,
        hasValidValue,
        highValue,
        lowValue,
        pointAnchorAlpha,
        highDisplayValue,
        lowDisplayValue,
        openDisplayValue,
        macroIndices,
        parserConfig,
        closeDisplayValue;
    dataStore = dataSet.components.data;
    highValue = conf.maxValue;
    lowValue = conf.minValue;
    conf.shadow = {
      opacity: (0, _lib.pluckNumber)(chartAttr.showshadow, 0) ? conf.alpha / 100 : 0
    }; // openValue

    dataObj = dataStore[0];
    config = dataObj.config;
    config.anchorProps.bgColor = (0, _lib.pluck)(dataObj.anchorbgcolor, openColor);
    config.anchorProps.enabled = !!showOpenAnchor;
    config.anchorProps.bgAlpha = showOpenAnchor ? pointAnchorAlpha : 0; // Apply appropriate hover efffects on openValue

    if (config.anchorProps.enabled && config.hoverEffects) {
      config.hoverEffects.anchorColor = (0, _lib.pluck)(chartAttr.openhovercolor, chartAttr.anchorhovercolor, chartAttr.plotfillhovercolor, (0, _lib.getLightColor)(openColor, 70));
      config.hoverEffects.anchorBgAlpha = (0, _lib.pluckNumber)(chartAttr.openhoveralpha, chartAttr.anchorhoveralpha, chartAttr.plotfillhoveralpha, 100);
    }

    openDisplayValue = config.displayValue; // closeValue

    dataObj = dataStore[len - 1];
    config = dataObj.config;
    config.anchorProps.bgColor = (0, _lib.pluck)(dataObj.anchorbgcolor, closeColor);
    config.anchorProps.enabled = !!showCloseAnchor;
    config.anchorProps.bgAlpha = showCloseAnchor ? pointAnchorAlpha : 0; // Apply appropriate hover efffects on openValue

    if (config.anchorProps.enabled && config.hoverEffects) {
      config.hoverEffects.anchorColor = (0, _lib.pluck)(chartAttr.closehovercolor, chartAttr.anchorhovercolor, chartAttr.plotfillhovercolor, (0, _lib.getLightColor)(closeColor, 70));
      config.hoverEffects.anchorBgAlpha = (0, _lib.pluckNumber)(chartAttr.closehoveralpha, chartAttr.anchorhoveralpha, chartAttr.plotfillhoveralpha, 100);
    }

    closeDisplayValue = config.displayValue;

    for (i = 0; i < len; i++) {
      dataObj = dataStore[i];
      config = dataObj.config;
      setData = setDataArr[i];
      pointAnchorAlpha = (0, _lib.pluckNumber)(setData.anchorbgalpha, anchorAlpha);
      conf.maxRadius = -Infinity; // Skipp color parsing for open and close values

      if (i !== 0 && i !== len - 1) {
        config.anchorProps.bgColor = (0, _lib.pluck)(setData.anchorbgcolor, anchorColor);
        config.anchorProps.bgAlpha = (0, _lib.pluckNumber)(setData.anchorbgalpha, defAnchorAlpha);
        config.hoverEffects.anchorColor = (0, _lib.parseColor)((0, _lib.pluck)(chartAttr.anchorhovercolor, chartAttr.plotfillhovercolor, (0, _lib.getLightColor)(lineColor, 70)));
        config.hoverEffects.anchorBgAlpha = (0, _lib.pluckNumber)(chartAttr.lowhoveralpha, chartAttr.anchorhoveralpha, chartAttr.plotfillhoveralpha, 100);
      }

      config.dataLabelStyle = dataSet._configureDataLabelStyle(setData);
      config.anchorProps.radius = (0, _lib.pluckNumber)(chartAttr.anchorradius, setData.anchorradius, 2);
      config.anchorProps.borderThickness = 0;
      config.hoverEffects.anchorBorderThickness = 0;
      config.hoverEffects.anchorRadius = (0, _lib.pluckNumber)(chartAttr.anchorhoverradius, chartAttr.anchorradius, setData.anchorradius, 3);
      conf.maxRadius = Math.max(config.anchorProps.radius + config.anchorProps.borderThickness / 2, conf.maxRadius);

      if (config.setValue === lowValue) {
        config.anchorProps.bgColor = (0, _lib.pluck)(setData.anchorbgcolor, lowColor);
        config.hoverEffects.anchorColor = (0, _lib.pluck)(chartAttr.lowhovercolor, chartAttr.anchorhovercolor, chartAttr.plotfillhovercolor, (0, _lib.getLightColor)(lowColor, 70));
        config.hoverEffects.anchorBgAlpha = (0, _lib.pluckNumber)(chartAttr.lowhoveralpha, chartAttr.anchorhoveralpha, chartAttr.plotfillhoveralpha, 100);
        config.anchorProps.enabled = !!showLowAnchor;
        config.anchorProps.bgAlpha = showLowAnchor ? pointAnchorAlpha : 0;
        lowDisplayValue = config.displayValue;
      }

      if (config.setValue === highValue) {
        config.anchorProps.bgColor = (0, _lib.pluck)(setData.anchorbgcolor, highColor);
        config.hoverEffects.anchorColor = (0, _lib.pluck)(chartAttr.highhovercolor, chartAttr.anchorhovercolor, chartAttr.plotfillhovercolor, (0, _lib.getLightColor)(highColor, 70));
        config.hoverEffects.anchorBgAlpha = (0, _lib.pluckNumber)(chartAttr.highhoveralpha, chartAttr.anchorhoveralpha, chartAttr.plotfillhoveralpha, 100);
        config.anchorProps.enabled = !!showHighAnchor;
        config.anchorProps.bgAlpha = showHighAnchor ? pointAnchorAlpha : 0;
        highDisplayValue = config.displayValue;
      }

      if (defined(config.setValue)) {
        hasValidValue = 1;
      }

      config._x = i;
      config._y = config.setValue;
    }

    sparkValues = chartConf.sparkValues = {
      openValue: {
        color: openColor
      },
      closeValue: {
        color: closeColor
      },
      highValue: {
        color: highColor
      },
      lowValue: {
        color: lowColor
      },
      highLowValue: {}
    };

    if (hasValidValue) {
      sparkValues.openValue.label = (0, _lib.pluckNumber)(chartAttr.showopenvalue, 1) ? openDisplayValue : _lib.BLANKSTRING;
      sparkValues.closeValue.label = (0, _lib.pluckNumber)(chartAttr.showclosevalue, 1) ? closeDisplayValue : _lib.BLANKSTRING;

      if ((0, _lib.pluckNumber)(chartAttr.showhighlowvalue, 1)) {
        // Store complete high, low label to label for the space manager.
        sparkValues.highLowValue.label = '[' + highDisplayValue + ' | ' + lowDisplayValue + ']'; // Store high, low label separately to render the labels
        // Using different color style.

        sparkValues.highValue.label = highDisplayValue;
        sparkValues.lowValue.label = lowDisplayValue;
      }
    }

    for (i = 0; i < len; i++) {
      var dataObject = dataStore[i],
          configuration = dataObject.config;

      if (configuration.setTooltext !== UNDEF) {
        macroIndices = [54, 55, 56, 57, 58, 59, 60, 61];
        parserConfig = {
          openValue: sparkValues.openValue.label,
          openDataValue: sparkValues.openValue.label,
          closeValue: sparkValues.closeValue.label,
          closeDataValue: sparkValues.closeValue.label,
          highValue: sparkValues.highValue.label,
          highDataValue: sparkValues.highValue.label,
          lowValue: sparkValues.lowValue.label,
          lowDataValue: sparkValues.lowValue.label
        };
        configuration.toolText = (0, _lib.parseTooltext)(configuration.setTooltext, macroIndices, parserConfig, setData, chartAttr, JSONData);
        configuration.finalTooltext = configuration.setTooltext = configuration.toolText;
      }
    }
  }
  /**
   * Draws graphics of sparkline
   */
  ;

  _proto.draw = function draw() {
    var dataSet = this;

    _LineDataset.prototype.draw.call(this);

    dataSet._drawSparkValues();
  }
  /**
   * Draws spark values
   */
  ;

  _proto._drawSparkValues = function _drawSparkValues() {
    var dataSet = this;
    drawSparkValues.call(dataSet);
  };

  return SparkLineDataset;
}(_line.default);

var _default = SparkLineDataset;
exports["default"] = _default;

/***/ }),

/***/ 1531:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _index = _interopRequireDefault(__webpack_require__(599));

// import { animHelperFN } from '../lib';
var _default = {
  'initial.dataset.sparkWinLoss': _index.default['initial.dataset.column']
};
exports["default"] = _default;

/***/ }),

/***/ 1530:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _lib = __webpack_require__(274);

var _column = _interopRequireDefault(__webpack_require__(595));

var _dependencyManager = __webpack_require__(282);

var _index = _interopRequireDefault(__webpack_require__(1531));

/* eslint require-jsdoc: 'error', valid-jsdoc: ["error", { "requireReturn": false }] */
var UNDEF,
    math = Math,
    mathMin = math.min,
    mathMax = math.max,
    GUTTER_PADDING = 2,
    drawSparkValues = function drawSparkValues() {
  var dataSet = this,
      chart = dataSet.getFromEnv('chart'),
      chartConf = chart.config,
      style = chartConf.dataLabelStyle,
      valuePadding = chartConf.valuepadding + GUTTER_PADDING,
      dataLabelContainer = dataSet.getContainer('labelGroup'),
      sparkValues = chartConf.sparkValues || (chartConf.sparkValues = {}),
      closeValue = dataSet.getGraphicalElement('closeValue'),
      animationManager = dataSet.getFromEnv('animationManager'),
      textAttr = {
    'class': 'fusioncharts-label',
    'text-anchor': _lib.POSITION_END,
    fill: style.color,
    'font-size': style.fontSize,
    'font-weight': style.fontWeight,
    'font-style': style.fontStyle,
    'font-family': style.fontFamily,
    visibility: 'visible'
  },
      attr = {
    x: 0,
    y: 0
  }; // Spark values are not visible due to the clip-rect,
  // so removing clip-rect in order to make spark labels visible

  chart.getChildContainer('datalabelsGroup').attr({
    'clip-rect': null
  });
  attr.y = chartConf.canvasHeight * 0.5 + chartConf.canvasTop;
  textAttr['text-anchor'] = _lib.POSITION_START;
  attr.x = chartConf.canvasWidth + chartConf.canvasLeft + valuePadding;

  if (sparkValues.closeValue && sparkValues.closeValue.label) {
    dataSet.addGraphicalElement('closeValue', animationManager.setAnimation({
      el: closeValue || 'text',
      attr: {
        text: sparkValues.closeValue.label,
        x: attr.x,
        y: attr.y,
        fill: sparkValues.closeValue.color || textAttr.fill,
        'text-anchor': _lib.POSITION_START,
        'line-height': style.lineHeight,
        'text-bound': [style.backgroundColor, style.borderColor, style.borderThickness, style.borderPadding, style.borderRadius, style.borderDash],
        visibility: 'visible'
      },
      container: dataLabelContainer,
      component: dataSet,
      label: 'text'
    }));
    attr.x += sparkValues.closeValue.smartObj && sparkValues.closeValue.smartObj.width + GUTTER_PADDING + valuePadding || 0;
  }

  dataSet.labelDrawn = true;
};

(0, _dependencyManager.addDep)({
  name: 'sparkwinlossAnimation',
  type: 'animationRule',
  extension: _index.default
});
/**
 * Creates class for SparkWinLossDataset
 */

var SparkWinLossDataset = /*#__PURE__*/function (_ColumnDataset) {
  (0, _inheritsLoose2.default)(SparkWinLossDataset, _ColumnDataset);

  /**
   * Constructor funtion of SparkWinLossDataset class
   */
  function SparkWinLossDataset() {
    var _this;

    _this = _ColumnDataset.call(this) || this;
    _this.drawLabel = drawSparkValues;
    return _this;
  }
  /**
   * Sets the type of the component
   * @return {string} type
   */


  var _proto = SparkWinLossDataset.prototype;

  _proto.getType = function getType() {
    return 'dataset';
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */
  ;

  _proto.getName = function getName() {
    return 'sparkWinLoss';
  }
  /**
   * Configures data level attribute settings
   * @param {Object} newDataset newly added dataset object
   * @param {number} newIndex index of newly added dataset
   */
  ;

  _proto._setConfigure = function _setConfigure(newDataset, newIndex) {
    var dataSet = this,
        chart = dataSet.getFromEnv('chart'),
        chartConfig = chart.config,
        conf = dataSet.config,
        JSONData = dataSet.config.JSONData,
        setDataArr = newDataset || JSONData.data,
        setDataLen = setDataArr && setDataArr.length,
        xAxis = dataSet.getFromEnv('xAxis'),
        catLen = xAxis.getTicksLen(),
        len = newDataset && newDataset.data.length || mathMin(catLen, setDataLen),
        chartAttr = chart.getFromEnv('dataSource').chart,
        colorM = dataSet.getFromEnv('color-manager'),
        index = dataSet.index || dataSet.positionIndex,
        showplotborder = chartConfig.showplotborder,
        plotColor = conf.plotColor = colorM.getPlotColor(index),
        plotFillColor = (0, _lib.pluck)(chartAttr.plotfillcolor, colorM.getColor('plotFillColor')),
        winColor = (0, _lib.pluck)(chartAttr.wincolor, colorM.getColor('winColor')),
        lossColor = (0, _lib.pluck)(chartAttr.losscolor, colorM.getColor('lossColor')),
        drawColor = (0, _lib.pluck)(chartAttr.drawcolor, colorM.getColor('drawColor')),
        scorelessColor = (0, _lib.pluck)(chartAttr.scorelesscolor, colorM.getColor('scorelessColor')),
        winHoverColor = chartAttr.winhovercolor,
        lossHoverColor = chartAttr.losshovercolor,
        drawHoverColor = chartAttr.drawhovercolor,
        scoreLessHoverColor = chartAttr.scorelesshovercolor,
        numWon = 0,
        numLost = 0,
        numDraw = 0,
        tempPlotfillAngle,
        // toolText,
    plotDashLen,
        plotDashGap,
        plotBorderThickness = chartConfig.plotborderthickness,
        isRoundEdges = chartConfig.isroundedges,
        showHoverEffect = chartConfig.plothovereffect,
        plotfillAngle = conf.plotfillangle,
        plotFillAlpha,
        // plotRadius,
    plotFillRatio,
        // plotgradientcolor,
    plotBorderAlpha,
        plotBorderDashStyle,
        initailPlotBorderDashStyle = conf.plotBorderDashStyle,
        setData,
        setValue,
        dataObj,
        config,
        colorArr,
        hoverColor,
        hoverAlpha,
        hoverGradientColor,
        hoverRatio,
        hoverAngle,
        hoverBorderColor,
        hoverBorderAlpha,
        hoverBorderThickness,
        hoverBorderDashed,
        hoverBorderDashGap,
        hoverBorderDashLen,
        hoverDashStyle,
        hoverColorArr,
        // getDashStyle = lib.getDashStyle,
    dataStore = dataSet.components.data,
        // definedGroupPadding,
    isBar = chart.isBar,
        is3D = chart.is3D,
        // isStacked = chart.isStacked,
    // stack100Percent,
    // enableAnimation,
    setDataDashed,
        setDataPlotDashLen,
        setDataPlotDashGap,
        i,
        maxValue = conf.maxValue || -Infinity,
        minValue = conf.minValue || +Infinity,
        showPlotBorder,
        tempIndex;

    if (!dataStore) {
      dataStore = dataSet.components.data = [];
    }

    _ColumnDataset.prototype._setConfigure.call(this);

    conf.plotgradientcolor = _lib.BLANKSTRING;
    showPlotBorder = conf.showPlotBorder = (0, _lib.pluckNumber)(chartAttr.showplotborder, conf.usePattern ? 1 : 0);
    conf.plotborderalpha = plotBorderAlpha = showPlotBorder ? (0, _lib.pluck)(chartAttr.plotborderalpha, plotFillAlpha, _lib.HUNDREDSTRING) : 0;
    conf.showTooltip = 0;
    chartConfig.showtooltip = 0; // Parsing the attributes and values at set level.

    for (i = 0; i < len; i++) {
      if (newDataset) {
        setData = newDataset && newDataset.data[i];

        if (newIndex !== UNDEF) {
          tempIndex = newIndex + i;
          dataObj = dataStore[tempIndex];
        } else {
          tempIndex = dataStore.length - len + i;
          dataObj = dataStore[tempIndex];
        }
      } else {
        dataObj = dataStore[i];
        setData = setDataArr[i];
      }

      config = dataObj && dataObj.config;

      if (!dataObj) {
        dataObj = dataStore[i] = {};
      }

      if (!dataObj.config) {
        config = dataStore[i].config = {};
      }

      switch ((setData.value || '').toLowerCase()) {
        case 'w':
          plotColor = (0, _lib.pluck)(setData.color, winColor, plotFillColor);
          hoverColor = (0, _lib.pluck)(setData.hovercolor, winHoverColor, plotColor);
          config.setValue = setValue = 1;
          numWon += 1;
          break;

        case 'l':
          plotColor = (0, _lib.pluck)(setData.color, lossColor, plotFillColor);
          hoverColor = (0, _lib.pluck)(setData.hovercolor, lossHoverColor, plotColor);
          config.setValue = setValue = -1;
          numLost += 1;
          break;

        case 'd':
          plotColor = (0, _lib.pluck)(setData.color, drawColor, plotFillColor);
          hoverColor = (0, _lib.pluck)(setData.hovercolor, drawHoverColor, plotColor);
          config.setValue = setValue = 0.1;
          numDraw += 1;
          break;

        default:
          config.setValue = setValue = null;
      }

      if (Number(setData.scoreless) === 1) {
        plotColor = (0, _lib.pluck)(setData.color, scorelessColor, plotFillColor);
        hoverColor = (0, _lib.pluck)(setData.hovercolor, scoreLessHoverColor, setData.color, scorelessColor, hoverColor);
      }

      config.originalPlotColor = (0, _lib.hashify)(plotColor);
      config.toolText = false; // config.showValue = pluckNumber(setData.showvalue, conf.showValues);

      config.setLink = (0, _lib.pluck)(setData.link); // config.toolTipValue = toolTipValue = yAxis.dataLabels(setValue);

      config.setDisplayValue = (0, _lib.parseUnsafeString)(setData.displayvalue); // config.displayValue = pluck(setDisplayValue, toolTipValue);

      setDataDashed = (0, _lib.pluckNumber)(setData.dashed);
      setDataPlotDashLen = (0, _lib.pluckNumber)(setData.dashlen, plotDashLen);
      setDataPlotDashGap = plotDashGap = (0, _lib.pluckNumber)(setData.dashgap, conf.plotDashGap);

      if (setValue !== null) {
        maxValue = mathMax(maxValue, setValue);
        minValue = mathMin(minValue, setValue);
      }

      config.plotBorderDashStyle = plotBorderDashStyle = setDataDashed === 1 ? (0, _lib.getDashStyle)(setDataPlotDashLen, setDataPlotDashGap) : setDataDashed === 0 ? 'none' : initailPlotBorderDashStyle;
      plotFillAlpha = (0, _lib.pluck)(setData.alpha, conf.plotfillalpha);
      plotBorderAlpha = (0, _lib.pluck)(setData.alpha, conf.plotborderalpha, plotFillAlpha).toString(); // Setting the angle for plot fill for negative data

      if (setValue < 0 && !isRoundEdges) {
        tempPlotfillAngle = conf.plotfillAngle;
        plotfillAngle = isBar ? 180 - plotfillAngle : 360 - plotfillAngle;
      }

      config.plotbordercolor = conf.usePattern && !chartAttr.plotbordercolor ? plotColor : conf.plotbordercolor; // Setting the color Array to be applied to the bar/column.

      config.colorArr = colorArr = (0, _lib.getColumnColor)(plotColor + ',' + conf.plotgradientcolor, plotFillAlpha, plotFillRatio = conf.plotfillratio, plotfillAngle, isRoundEdges, config.plotbordercolor, plotBorderAlpha, isBar ? 1 : 0, !!is3D);
      config.label = (0, _lib.getValidValue)((0, _lib.parseUnsafeString)(xAxis.getLabel((0, _lib.pluckNumber)(tempIndex - len, i)).label)); // Parsing the hover effects only if showhovereffect is not 0.

      if (showHoverEffect !== 0) {
        hoverColor = (0, _lib.pluck)(setData.hovercolor, JSONData.hovercolor, chartAttr.plotfillhovercolor, chartAttr.columnhovercolor, plotColor);
        hoverAlpha = (0, _lib.pluck)(setData.hoveralpha, JSONData.hoveralpha, chartAttr.plotfillhoveralpha, chartAttr.columnhoveralpha, plotFillAlpha);
        hoverGradientColor = (0, _lib.pluck)(setData.hovergradientcolor, JSONData.hovergradientcolor, chartAttr.plothovergradientcolor, conf.plotgradientcolor);
        !hoverGradientColor && (hoverGradientColor = '');
        hoverRatio = (0, _lib.pluck)(setData.hoverratio, JSONData.hoverratio, chartAttr.plothoverratio, plotFillRatio);
        hoverAngle = (0, _lib.pluckNumber)(360 - setData.hoverangle, 360 - JSONData.hoverangle, 360 - chartAttr.plothoverangle, plotfillAngle);
        hoverBorderColor = (0, _lib.pluck)(setData.borderhovercolor, JSONData.borderhovercolor, chartAttr.plotborderhovercolor, conf.plotbordercolor);
        hoverBorderAlpha = (0, _lib.pluck)(setData.borderhoveralpha, JSONData.borderhoveralpha, chartAttr.plotborderhoveralpha, plotBorderAlpha, plotFillAlpha);
        hoverBorderThickness = (0, _lib.pluckNumber)(setData.borderhoverthickness, JSONData.borderhoverthickness, chartAttr.plotborderhoverthickness, plotBorderThickness);
        hoverBorderDashed = (0, _lib.pluckNumber)(setData.borderhoverdashed, JSONData.borderhoverdashed, chartAttr.plotborderhoverdashed);
        hoverBorderDashGap = (0, _lib.pluckNumber)(setData.borderhoverdashgap, JSONData.borderhoverdashgap, chartAttr.plotborderhoverdashgap, plotDashLen);
        hoverBorderDashLen = (0, _lib.pluckNumber)(setData.borderhoverdashlen, JSONData.borderhoverdashlen, chartAttr.plotborderhoverdashlen, plotDashGap);
        hoverDashStyle = hoverBorderDashed ? (0, _lib.getDashStyle)(hoverBorderDashLen, hoverBorderDashGap) : plotBorderDashStyle;
        config.hoverColor = hoverColor;
        /* If no hover effects are explicitly defined and
                   * showHoverEffect is not 0 then hoverColor is set.
                   */

        if (showHoverEffect === 1 && hoverColor === plotColor) {
          hoverColor = (0, _lib.getLightColor)(hoverColor, 70);
        } // setting the hover color array which is always applied except when showHoverEffect is not 0.


        hoverColorArr = (0, _lib.getColumnColor)(hoverColor + ',' + hoverGradientColor, hoverAlpha, hoverRatio, hoverAngle, isRoundEdges, hoverBorderColor, hoverBorderAlpha.toString(), isBar ? 1 : 0, !!is3D);
        config.setRolloutAttr = {
          fill: !is3D ? (0, _lib.toRaphaelColor)(colorArr[0]) : [(0, _lib.toRaphaelColor)(colorArr[0]), !chartConfig.use3dlighting],
          stroke: showplotborder && (0, _lib.toRaphaelColor)(colorArr[1]),
          'stroke-width': plotBorderThickness,
          'stroke-dasharray': plotBorderDashStyle
        };
        config.setRolloverAttr = {
          fill: !is3D ? (0, _lib.toRaphaelColor)(hoverColorArr[0]) : [(0, _lib.toRaphaelColor)(hoverColorArr[0]), !chartConfig.use3dlighting],
          stroke: showplotborder && (0, _lib.toRaphaelColor)(hoverColorArr[1]),
          'stroke-width': hoverBorderThickness,
          'stroke-dasharray': hoverDashStyle
        };
      } // formatedVal = config.toolTipValue;
      // config.toolText = toolText;
      // config.setTooltext = toolText;


      tempPlotfillAngle && (plotfillAngle = tempPlotfillAngle);
      tempIndex++;
      config._x = i;
      config._y = setValue;
    }

    conf.maxValue = 1;
    conf.minValue = -1;

    if ((0, _lib.pluckNumber)(chartAttr.showvalue, 1) === 1) {
      chartConfig.sparkValues = {
        closeValue: {}
      };
      chartConfig.sparkValues.closeValue.label = numWon + '-' + numLost + (numDraw > 0 ? '-' + numDraw : _lib.BLANKSTRING);
    } else {
      chartConfig.sparkValues = UNDEF;
    }
  };

  return SparkWinLossDataset;
}(_column.default);

var _default = SparkWinLossDataset;
exports["default"] = _default;

/***/ }),

/***/ 1523:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



exports.__esModule = true;
exports["default"] = void 0;

var _lib = __webpack_require__(274);

var fadeEffect = [{
  initialAttr: function initialAttr() {
    return {
      opacity: 0
    };
  },
  finalAttr: function finalAttr() {
    return {
      opacity: 1
    };
  }
}],
    textAppearing = function textAppearing() {
  fadeEffect[0].slot = _lib.FINALSTR;
  return fadeEffect;
},
    pathAppearing = function pathAppearing() {
  fadeEffect[0].slot = _lib.INITIALSTR;
  return fadeEffect;
},
    labelGroupAppearing = function labelGroupAppearing() {
  fadeEffect[0].slot = _lib.FINALSTR;
  return fadeEffect;
};

var _default = {
  'initial.dataset.thermometer': function initialDatasetThermometer() {
    var component = this,
        conf = component.config;
    return {
      'plot.appearing': function plotAppearing(input) {
        var pathArr = input.attr.path.slice(0);
        pathArr[13] = pathArr[15] = conf.thmBaseY;
        return [{
          initialAttr: {
            opacity: 0
          },
          finalAttr: {
            opacity: 1
          },
          slot: 'initial'
        }, {
          initialAttr: {
            path: pathArr
          },
          finalAttr: {
            opacity: 1
          },
          slot: 'middle'
        }];
      },
      'plot.updating': null,
      'text.appearing': textAppearing,
      'text.updating': null,
      'labelGroup.appearing': labelGroupAppearing,
      'labelGroup.updating': null,
      'path.appearing': pathAppearing,
      'path.updating': null
    };
  }
};
exports["default"] = _default;

/***/ }),

/***/ 1522:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(__webpack_require__(288));

var _lib = __webpack_require__(274);

var _dependencyManager = __webpack_require__(282);

var _index = _interopRequireDefault(__webpack_require__(1523));

var _cylinderthermometerbase = _interopRequireDefault(__webpack_require__(1494));

/* eslint require-jsdoc: 'error', valid-jsdoc: ["error", { "requireReturn": false }] */
var configStr = _lib.preDefStr.configStr,
    POSITION_TOP = _lib.preDefStr.POSITION_TOP,
    POSITION_MIDDLE = _lib.preDefStr.POSITION_MIDDLE,
    ROLLOVER = 'DataPlotRollOver',
    ROLLOUT = 'DataPlotRollOut',
    EVENTARGS = 'eventArgs',
    topLightGlowAlphaStr = '40,0',
    topLightGlowRatioStr = '0,80',
    topLightGlowRStr = '70%',
    bulbBorderLightRStr = '50%',
    bulbBorderLightAlphaStr = '0,50',
    bulbBorderLightRatioStr = '78,30',
    bulbTopLightAlphaStr = '60,0',
    bulbTopLightRatioStr = '0,30',
    bulbCenterLightAlphaStr = '80,0',
    bulbCenterLightRatioStr = '0,70',
    cylLeftLightAlphaStr = '50,0',
    cylLeftLightRatioStr = '0,80',
    cylRightLightAlphaStr = '50,0,0',
    cylRightLightRatioStr = '0,40,60',
    HUNDREDPERCENT = '100%',
    zeroCommaHundredStr = '0,100',
    M = 'M',
    A = 'A',
    L = 'L',
    Z = 'Z',
    cos50 = 0.643,
    sin50 = 0.766,
    win = window,
    userAgent = win.navigator.userAgent,
    isIE = /msie/i.test(userAgent) && !win.opera,
    TRACKER_FILL = 'rgba(192,192,192,' + (isIE ? 0.002 : 0.000001) + ')',
    getScaleFactor = function getScaleFactor(origWParam, origHParam, canvasWidth, canvasHeight) {
  var scaleFactor,
      origH = origHParam,
      origW = origWParam;
  origH = (0, _lib.pluckNumber)(origH, canvasHeight);
  origW = (0, _lib.pluckNumber)(origW, canvasWidth);

  if (!origH || !origW) {
    scaleFactor = 1;
  } else if (origW / canvasWidth === origH / canvasHeight) {
    // Now, if the ratio of original width,height & stage width,height are same
    // In this case, the transformation value would be the same, as the ratio
    // of transformation of width and height is same.
    scaleFactor = canvasWidth / origW;
  } else {
    // If the transformation factors are different, we do a constrained scaling
    // We get the aspect whose delta is on the lower side.
    scaleFactor = Math.min(canvasWidth / origW, canvasHeight / origH);
  }

  return scaleFactor;
};

(0, _dependencyManager.addDep)({
  name: 'thermometerAnimation',
  type: 'animationRule',
  extension: _index.default
});
/**
 * Creates ThermometerDataset class
 */

var ThermometerDataset = /*#__PURE__*/function (_CylinderThermometerB) {
  (0, _inheritsLoose2.default)(ThermometerDataset, _CylinderThermometerB);

  /**
   * Constructor function for ThermometerDataset class
   */
  function ThermometerDataset() {
    var _this;

    _this = _CylinderThermometerB.call(this) || this;
    _this.addData = _lib.stubFN;
    _this.removeData = _lib.stubFN;
    return _this;
  }
  /**
   * Sets the name of the component
   * @return {string} name
   */


  var _proto = ThermometerDataset.prototype;

  _proto.getName = function getName() {
    return 'thermometer';
  }
  /**
   * Returns the type of the component
   * @return {string} The type of the component, in this case a dataset.
   */
  ;

  _proto.getType = function getType() {
    return 'dataset';
  }
  /**
   * Manage space taken by plot
   * @return {Object} returns dimension taken by plot (top, right, left, bottom)
   */
  ;

  _proto._manageSpace = function _manageSpace() {
    var ds = this,
        dsConfig = ds.config,
        chart = ds.getFromEnv('chart'),
        chartConfig = chart.config,
        chartWidth = chartConfig.width,
        chartHeight = chartConfig.height,
        canvasWidth = chartConfig.canvasWidth,
        canvasHeight = chartConfig.canvasHeight,
        canvasLeft = chartConfig.canvasLeft,
        canvasRight = chartConfig.canvasRight,
        canvasTop = chartConfig.canvasTop,
        xDefined = chartConfig.xDefined,
        yDefined = chartConfig.yDefined,
        rDefined = chartConfig.rDefined,
        hDefined = chartConfig.hDefined,
        thmOriginX = chartConfig.thmOriginX,
        thmOriginY = chartConfig.thmOriginY,
        thmBulbRadius = chartConfig.thmBulbRadius,
        thmHeight = chartConfig.thmHeight,
        scaleFactor = getScaleFactor(chartConfig.origW, chartConfig.origH, chartWidth, chartHeight),
        top = 0,
        bottom = 0,
        left = 0,
        right = 0,
        thmCylenderRight,
        thmhalfWidth,
        centerPos,
        thmWidth,
        bulbHeight,
        measure,
        canvasLeftShift; // Recalculating the label font size in case of chart resize

    chartConfig.dataLabelStyle.fontSize = this.computeFontSize(chartConfig.dataLabelStyle.fontSizeWithUnit); // manage the space for the datalabels

    measure = ds._getLabelSpace(); // canvasBottom += measure;

    canvasHeight -= measure;
    bottom += measure; // manage the thermometer space

    /* First calculate the radius */
    // if Not defined the radius then calculate it.

    if (!rDefined) {
      thmBulbRadius = Math.min(canvasWidth / 2, (0, _lib.pluckNumber)(thmHeight, canvasHeight) * 0.13);
      rDefined = true;
    } else {
      thmBulbRadius = thmBulbRadius * scaleFactor;
    } // store the effective radius


    chartConfig.effectiveR = thmBulbRadius; // bulbDiameter = thmBulbRadius * 2;

    thmhalfWidth = thmBulbRadius * cos50;
    thmWidth = 2 * thmhalfWidth;
    bulbHeight = thmBulbRadius * (1 + sin50); // add the space for the top glass effect

    top += thmhalfWidth;
    canvasTop += thmhalfWidth;
    canvasHeight -= thmhalfWidth;
    /* Calculate the x */
    // if x is user defined

    if (xDefined) {
      thmOriginX = thmOriginX * scaleFactor;
      canvasLeftShift = thmOriginX - thmhalfWidth - canvasLeft;
    } else {
      // else, place the gauge at the center
      centerPos = (canvasRight - canvasLeft) / 2; // now as per the center position calculate the extra left gap

      canvasLeftShift = centerPos - thmhalfWidth; // check whether we have space to put the gauge at center

      thmCylenderRight = canvasLeftShift + thmWidth;

      if (thmCylenderRight > canvasWidth) {
        canvasLeftShift = canvasWidth - thmWidth;
      }
    }

    left += canvasLeftShift;
    canvasLeft += canvasLeftShift;
    canvasWidth -= canvasLeftShift; // to make the canvas width same as thermometer's cylinder width increase the right padding

    right += canvasWidth - thmWidth;

    if (yDefined) {
      thmOriginY = thmOriginY * scaleFactor;
    }

    if (!hDefined) {
      // if height is not defined
      if (yDefined) {
        // if y is defined then adjust thermometer height is available space
        thmHeight = thmOriginY - canvasTop;
      } else {
        thmHeight = Math.max(canvasHeight - bulbHeight, 3 * thmBulbRadius);
        thmOriginY = canvasTop + thmHeight;
      }
    } else {
      // height is defined
      thmHeight = thmHeight * scaleFactor;

      if (yDefined) {
        // if both are defined, adjust the top to accomodate this
        top += thmOriginY - thmHeight - canvasTop;
      } else {
        thmOriginY = canvasTop + thmHeight;
      }
    } // finally adjust the bottom to accomodate y and height


    bottom += canvasTop + canvasHeight - thmOriginY;
    dsConfig.thmBulbRadius = thmBulbRadius;
    dsConfig.thmHeight = thmHeight;
    return {
      top: top,
      bottom: bottom,
      left: left,
      right: right
    };
  }
  /**
   * Draws plot
   * @memberof ThermometerDataset
   */
  ;

  _proto.draw = function draw() {
    var dataSet = this,
        dsConfig = dataSet.config,
        smartLabel = dataSet.getFromEnv('smartLabel'),
        chart = dataSet.getFromEnv('chart'),
        dataLabelsLayer = chart.getChildContainer('datalabelsGroup'),
        trackerLayer = chart.getChildContainer('trackerGroup'),
        toolTipController = dataSet.getFromEnv('toolTipController'),
        scale = dataSet.getFromEnv('scale'),
        parentContainer = chart.getChildContainer().plotGroup,
        chartConfig = chart.get(configStr),
        canvasLeft = chartConfig.canvasLeft,
        canvasTop = chartConfig.canvasTop,
        canvasHeight = chartConfig.canvasHeight,
        r = chartConfig.effectiveR || 10,
        cylinderWidthHalf = r * cos50,
        use3DLighting = chartConfig.use3DLighting,
        x = canvasLeft + cylinderWidthHalf,
        y = canvasTop - cylinderWidthHalf,
        h = canvasHeight,
        canvasHorizontalDiff = Math.abs(chartConfig.width - chartConfig.canvasRight - canvasLeft),
        ypos,
        scaleTop = cylinderWidthHalf,
        bulbCenterDistance = r * sin50,
        scaleY = y + scaleTop,
        y1 = scaleY + h,
        y2 = y1 + bulbCenterDistance,
        value = (0, _lib.pluckNumber)(dsConfig.value, scale.getLimit().min),
        thmPos = scale.getPixel(value),
        topRoundR = cylinderWidthHalf * 0.33,
        y4 = y + topRoundR,
        y6 = thmPos,
        lCylWidthHalf = cylinderWidthHalf * 0.9,
        topRoundRDistance = cylinderWidthHalf - topRoundR,
        lR = r + lCylWidthHalf - cylinderWidthHalf,
        x1 = x - cylinderWidthHalf,
        x2 = x + cylinderWidthHalf,
        x3 = x - topRoundRDistance,
        x4 = x + topRoundRDistance,
        lx1 = x - lCylWidthHalf,
        lx2 = x + lCylWidthHalf,
        l1Distance = cylinderWidthHalf * 0.6,
        l1x = parseInt(x - l1Distance, 10),
        l2x = x + cylinderWidthHalf / 2,
        ly = dsConfig.thmBaseY = y2 - Math.abs(Math.sqrt(lR * lR - lCylWidthHalf * lCylWidthHalf)),
        containerDummy = dataSet.getContainer('container'),
        fluidDummy = dataSet.getGraphicalElement('fluid'),
        topLightGlowDummy = dataSet.getGraphicalElement('topLightGlow'),
        topLightDummy = dataSet.getGraphicalElement('topLight'),
        labelDummy = dataSet.getGraphicalElement('label'),
        label,
        dataLabelTooltext,
        dataLabelObj,
        container,
        fluid,
        topLightGlow,
        topLight,
        dataLabelContainerDummy = dataSet.getContainer('dataLabelContainer'),
        canvasBorderElementDummy = dataSet.getGraphicalElement('canvasBorderElement'),
        bulbBorderLightDummy = dataSet.getGraphicalElement('bulbBorderLight'),
        bulbTopLightDummy = dataSet.getGraphicalElement('bulbTopLight'),
        bulbCenterLightDummy = dataSet.getGraphicalElement('bulbCenterLight'),
        trackerContainerDummy = dataSet.getContainer('trackerContainer'),
        cylLeftLightDummy = dataSet.getGraphicalElement('cylLeftLight'),
        cylRightLightDummy = dataSet.getGraphicalElement('cylRightLight'),
        cylLeftLight1Dummy = dataSet.getGraphicalElement('cylLeftLight1'),
        cylRightLight1Dummy = dataSet.getGraphicalElement('cylRightLight1'),
        hotElementDummy = dataSet.getGraphicalElement('hotElement'),
        dataLabelContainer,
        canvasBorderElement,
        bulbBorderLight,
        bulbTopLight,
        bulbCenterLight,
        trackerContainer,
        cylLeftLight,
        cylRightLight,
        cylLeftLight1,
        cylRightLight1,
        hotElement,
        gaugeFillColor = (0, _lib.getDarkColor)(dsConfig.gaugeFillColor, use3DLighting ? 70 : 80),
        gaugeFillAlpha = dsConfig.gaugeFillAlpha,
        conColor = dsConfig.gaugeContainerColor,
        darkConColor = (0, _lib.getDarkColor)(conColor, 80),
        lightConColor = (0, _lib.getLightColor)(conColor, 80),
        gaugeBorderThickness = dsConfig.gaugeBorderThickness,
        gaugeBorderColor = dsConfig.gaugeBorderColor,
        thPath,
        bulbPathType1,
        showHoverEffect = dsConfig.showHoverEffect,
        plotFillHoverAlpha = dsConfig.plotFillHoverAlpha,
        plotFillHoverColor = dsConfig.plotFillHoverColor,
        animationManager = dataSet.getFromEnv('animationManager'),
        eventArgs,
        style = chart.config.dataLabelStyle,
        canvasBorderElementAttr,
        topLightAttr,
        hotElementAttr,
        topLightGlowAttr,
        bulbBorderLightAttr,
        bulbTopLightAttr,
        bulbCenterLightAttr,
        cylLeftLightAttr,
        cylRightLightAttr,
        cylLeftLight1Attr,
        cylRightLight1Attr,
        fluidAttr = dsConfig.fluidAttr;

    if (!fluidAttr) {
      fluidAttr = dsConfig.fluidAttr = {};
    }

    if (showHoverEffect) {
      fluidAttr.hover = {
        fill: (0, _lib.convertColor)((0, _lib.getDarkColor)(plotFillHoverColor, use3DLighting ? 70 : 80), plotFillHoverAlpha)
      };
    }

    fluidAttr.out = {
      fill: (0, _lib.convertColor)(gaugeFillColor, gaugeFillAlpha)
    };
    thPath = [M, x3, y, A, topRoundR, topRoundR, 0, 0, 0, x1, y4, L, x1, y1, A, r, r, 0, 1, 0, x2, y1, L, x2, y4, A, topRoundR, topRoundR, 0, 0, 0, x4, y, Z];
    eventArgs = {
      value: dsConfig.value,
      displayValue: dsConfig.displayValue,
      toolText: dsConfig.toolText,
      thmFillColor: dsConfig.gaugeFillColor,
      thmBulbRadius: dsConfig.thmBulbRadius,
      thmHeight: dsConfig.thmHeight,
      thmGlassColor: dsConfig.gaugeContainerColor,
      gaugeFillColor: dsConfig.gaugeFillColor,
      gaugeFillAlpha: dsConfig.gaugeFillAlpha,
      showGaugeBorder: dsConfig.showGaugeBorder,
      gaugeBorderColor: dsConfig.rawGaugeBorderColor,
      gaugeBorderThickness: dsConfig.gaugeBorderThickness,
      gaugeBorderAlpha: dsConfig.gaugeBorderAlpha
    };
    fluidAttr.out.path = [M, lx1, ly, A, lR, lR, 0, 1, 0, lx2, ly, L, lx2, y6, lx1, y6, Z];
    fluidAttr.out['stroke-width'] = 0;
    canvasBorderElementAttr = {
      'stroke-width': gaugeBorderThickness,
      stroke: gaugeBorderColor,
      path: thPath
    };
    topLightAttr = {
      path: [M, lx1, scaleY, L, lx2, scaleY],
      stroke: (0, _lib.convertColor)(gaugeFillColor, 40)
    };
    hotElementAttr = {
      path: thPath
    };
    container = animationManager.setAnimation({
      el: containerDummy || 'group',
      attr: {
        name: 'thermometer'
      },
      container: parentContainer,
      component: dataSet,
      label: 'group'
    });
    !containerDummy && dataSet.addContainer('container', container);
    canvasBorderElement = animationManager.setAnimation({
      el: canvasBorderElementDummy || 'path',
      attr: canvasBorderElementAttr,
      container: container,
      component: dataSet,
      label: 'path'
    });
    !canvasBorderElementDummy && dataSet.addGraphicalElement('canvasBorderElement', canvasBorderElement);
    fluid = animationManager.setAnimation({
      el: fluidDummy || 'path',
      attr: fluidAttr.out,
      container: container,
      component: dataSet,
      label: 'plot'
    });
    !fluidDummy && dataSet.addGraphicalElement('fluid', fluid);
    topLight = animationManager.setAnimation({
      el: topLightDummy || 'path',
      attr: topLightAttr,
      container: container,
      component: dataSet,
      label: 'path'
    });
    !topLightDummy && dataSet.addGraphicalElement('topLight', topLight);

    if (use3DLighting) {
      topLightGlowAttr = {
        path: [M, lx1, scaleY, L, lx2, scaleY, lx2, y4, lx1, y4, Z],
        'stroke-width': 0,
        fill: (0, _lib.toRaphaelColor)({
          FCcolor: {
            color: gaugeFillColor + _lib.COMMASTRING + gaugeFillColor,
            alpha: topLightGlowAlphaStr,
            ratio: topLightGlowRatioStr,
            radialGradient: true,
            cx: 0.5,
            cy: 1,
            r: topLightGlowRStr
          }
        })
      };
      topLightGlow = animationManager.setAnimation({
        el: topLightGlowDummy || 'path',
        attr: topLightGlowAttr,
        container: container,
        component: dataSet,
        label: 'path'
      });
      !topLightGlowDummy && dataSet.addGraphicalElement('topLightGlow', topLightGlow); // draw the light effect for the bulb

      bulbPathType1 = [M, x1, y1, A, r, r, 0, 0, 1, x2, y1, A, r, r, 0, 0, 0, x1, y1, A, r, r, 0, 1, 0, x2, y1, Z];
      bulbBorderLightAttr = {
        path: bulbPathType1,
        'stroke-width': 0,
        fill: (0, _lib.toRaphaelColor)({
          FCcolor: {
            cx: 0.5,
            cy: 0.5,
            r: bulbBorderLightRStr,
            color: darkConColor + _lib.COMMASTRING + lightConColor,
            alpha: bulbBorderLightAlphaStr,
            ratio: bulbBorderLightRatioStr,
            radialGradient: true
          }
        })
      };
      bulbBorderLight = animationManager.setAnimation({
        el: bulbBorderLightDummy || 'path',
        attr: bulbBorderLightAttr,
        container: container,
        component: dataSet,
        label: 'path'
      });
      !bulbBorderLightDummy && dataSet.addGraphicalElement('bulbBorderLight', bulbBorderLight);
      bulbTopLightAttr = {
        path: bulbPathType1,
        'stroke-width': 0,
        fill: (0, _lib.toRaphaelColor)({
          FCcolor: {
            cx: 0.3,
            cy: 0.1,
            r: HUNDREDPERCENT,
            color: lightConColor + _lib.COMMASTRING + darkConColor,
            alpha: bulbTopLightAlphaStr,
            ratio: bulbTopLightRatioStr,
            radialGradient: true
          }
        })
      };
      bulbTopLight = animationManager.setAnimation({
        el: bulbTopLightDummy || 'path',
        attr: bulbTopLightAttr,
        container: container,
        component: dataSet,
        label: 'path'
      });
      !bulbTopLightDummy && dataSet.addGraphicalElement('bulbTopLight', bulbTopLight);
      bulbCenterLightAttr = {
        path: bulbPathType1,
        'stroke-width': 0,
        fill: (0, _lib.toRaphaelColor)({
          FCcolor: {
            cx: 0.25,
            cy: 0.7,
            r: HUNDREDPERCENT,
            color: lightConColor + _lib.COMMASTRING + darkConColor,
            alpha: bulbCenterLightAlphaStr,
            ratio: bulbCenterLightRatioStr,
            radialGradient: true
          }
        })
      };
      bulbCenterLight = animationManager.setAnimation({
        el: bulbCenterLightDummy || 'path',
        attr: bulbCenterLightAttr,
        container: container,
        component: dataSet,
        label: 'path'
      });
      !bulbCenterLightDummy && dataSet.addGraphicalElement('bulbCenterLight', bulbCenterLight);
      cylLeftLightAttr = {
        path: [M, x, y, L, x3, y, A, topRoundR, topRoundR, 0, 0, 0, x1, y4, L, x1, y1, x, y1, Z],
        'stroke-width': 0,
        fill: (0, _lib.toRaphaelColor)({
          FCcolor: {
            color: lightConColor + _lib.COMMASTRING + darkConColor,
            alpha: cylLeftLightAlphaStr,
            ratio: cylLeftLightRatioStr,
            angle: 0
          }
        })
      };
      cylLeftLight = animationManager.setAnimation({
        el: cylLeftLightDummy || 'path',
        attr: cylLeftLightAttr,
        container: container,
        component: dataSet,
        label: 'path'
      });
      !cylLeftLightDummy && dataSet.addGraphicalElement('cylLeftLight', cylLeftLight);
      cylRightLightAttr = {
        path: [M, x1, y, L, x4, y, A, topRoundR, topRoundR, 0, 0, 1, x2, y4, L, x2, y1, x1, y1, Z],
        'stroke-width': 0,
        fill: (0, _lib.toRaphaelColor)({
          FCcolor: {
            color: lightConColor + _lib.COMMASTRING + darkConColor + _lib.COMMASTRING + darkConColor,
            alpha: cylRightLightAlphaStr,
            ratio: cylRightLightRatioStr,
            angle: 180
          }
        })
      };
      cylRightLight = animationManager.setAnimation({
        el: cylRightLightDummy || 'path',
        attr: cylRightLightAttr,
        container: container,
        component: dataSet,
        label: 'path'
      });
      !cylRightLightDummy && dataSet.addGraphicalElement('cylRightLight', cylRightLight);
      cylLeftLight1Attr = {
        path: [M, l1x, y4, L, x1, y4, x1, y1, l1x, y1, Z],
        'stroke-width': 0,
        fill: (0, _lib.toRaphaelColor)({
          FCcolor: {
            color: lightConColor + _lib.COMMASTRING + darkConColor,
            alpha: bulbTopLightAlphaStr,
            ratio: zeroCommaHundredStr,
            angle: 180
          }
        })
      };
      cylLeftLight1 = animationManager.setAnimation({
        el: cylLeftLight1Dummy || 'path',
        attr: cylLeftLight1Attr,
        container: container,
        component: dataSet,
        label: 'path'
      });
      !cylLeftLight1Dummy && dataSet.addGraphicalElement('cylLeftLight1', cylLeftLight1);
      cylRightLight1Attr = {
        path: [M, l1x - 0.01, y4, L, l2x, y4, l2x, y1, l1x - 0.01, y1, Z],
        'stroke-width': 0,
        fill: (0, _lib.toRaphaelColor)({
          FCcolor: {
            color: lightConColor + _lib.COMMASTRING + darkConColor,
            alpha: bulbTopLightAlphaStr,
            ratio: zeroCommaHundredStr,
            angle: 0
          }
        })
      };
      cylRightLight1 = animationManager.setAnimation({
        el: cylRightLight1Dummy || 'path',
        attr: cylRightLight1Attr,
        container: container,
        component: dataSet,
        label: 'path'
      });
      !cylRightLight1Dummy && dataSet.addGraphicalElement('cylRightLight1', cylRightLight1);
    } else {
      dataSet.removeGraphicalElement(topLightGlowDummy);
      dataSet.removeGraphicalElement(bulbBorderLightDummy);
      dataSet.removeGraphicalElement(bulbTopLightDummy);
      dataSet.removeGraphicalElement(bulbCenterLightDummy);
      dataSet.removeGraphicalElement(cylLeftLightDummy);
      dataSet.removeGraphicalElement(cylRightLightDummy);
      dataSet.removeGraphicalElement(cylLeftLight1Dummy);
      dataSet.removeGraphicalElement(cylRightLight1Dummy);
    }

    trackerContainer = animationManager.setAnimation({
      el: trackerContainerDummy || 'group',
      attr: {
        name: 'col-hot'
      },
      container: trackerLayer,
      component: dataSet,
      label: 'group'
    });
    !trackerContainerDummy && dataSet.addContainer('trackerContainer', trackerContainer);
    hotElementAttr.stroke = hotElementAttr.fill = TRACKER_FILL;
    hotElement = animationManager.setAnimation({
      el: hotElementDummy || 'path',
      attr: hotElementAttr,
      container: trackerContainer,
      component: dataSet,
      label: 'path'
    });

    if (!hotElementDummy) {
      dataSet.addGraphicalElement('hotElement', hotElement);
      hotElement.on('fc-click', function (setDataArr) {
        var ele = this;
        chart.plotEventHandler(ele, setDataArr);
      }).hover(function (data) {
        var ele = this;

        if (dsConfig.showHoverEffect) {
          dataSet.getGraphicalElement('fluid') && dataSet.getGraphicalElement('fluid').attr(fluidAttr.hover);
        }

        chart.plotEventHandler(ele, data, ROLLOVER);
      }, function (data) {
        var ele = this;

        if (dsConfig.showHoverEffect) {
          dataSet.getGraphicalElement('fluid') && dataSet.getGraphicalElement('fluid').attr(fluidAttr.out);
        }

        chart.plotEventHandler(ele, data, ROLLOUT);
      });
    }

    if (!dsConfig.toolText) {
      toolTipController.disableToolTip(hotElement);
    } else {
      toolTipController.enableToolTip(hotElement, dsConfig.toolText);
    }

    hotElement.data(EVENTARGS, eventArgs);
    dataLabelContainer = animationManager.setAnimation({
      el: dataLabelContainerDummy || 'group',
      attr: {
        name: 'datalabel'
      },
      container: dataLabelsLayer,
      component: dataSet,
      label: 'labelGroup'
    });
    smartLabel.setStyle(style);

    if (!dataLabelContainerDummy) {
      dataSet.addContainer('dataLabelContainer', dataLabelContainer);
    }

    if (dsConfig.showValue) {
      ypos = y2 + r + (dsConfig.valuePadding || 0);
      dataLabelObj = smartLabel.getSmartText(dsConfig.displayValue, chartConfig.width - chartConfig.marginLeft - chartConfig.marginRight - canvasHorizontalDiff / 2, chartConfig.height - ypos - chartConfig.marginBottom);
      dataLabelTooltext = dataLabelObj.tooltext || _lib.BLANKSTRING;
      label = animationManager.setAnimation({
        el: labelDummy || 'text',
        attr: {
          text: dataLabelObj.text,
          x: x,
          y: ypos,
          'text-anchor': POSITION_MIDDLE,
          'vertical-align': POSITION_TOP,
          fill: style.color,
          'text-bound': [style.backgroundColor, style.borderColor, style.borderThickness, style.borderPadding, style.borderRadius, style.borderDash]
        },
        container: dataLabelContainer,
        component: dataSet,
        label: 'text'
      });

      if (dsConfig.showTooltip) {
        toolTipController.enableToolTip(label, dataLabelTooltext);
      } else {
        toolTipController.disableToolTip(label);
      }

      if (!labelDummy) {
        dataSet.addGraphicalElement('label', label);
      }

      label.show();
    }
  };

  return ThermometerDataset;
}(_cylinderthermometerbase.default);

var _default = ThermometerDataset;
exports["default"] = _default;

/***/ }),

/***/ 1502:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = _default;

var _lib = __webpack_require__(274);

var _angulargauge = _interopRequireDefault(__webpack_require__(1503));

function _default(chart) {
  var dataObj = chart.getFromEnv('dataSource'),
      pointers = dataObj.pointers || dataObj.dials;

  if (!pointers) {
    dataObj.dials = pointers = {
      dial: [{
        value: 0
      }]
    };
  }

  (0, _lib.datasetFactory)(chart, _angulargauge.default, 'dataset', 1, [pointers]);
}

/***/ }),

/***/ 1489:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = _default;

var _gauge = _interopRequireDefault(__webpack_require__(1490));

var _lib = __webpack_require__(274);

/**
 * function to instatiate axis and get attached to canvas
 * @param {Object} chart chart API
 */
function _default(chart) {
  var canvas = chart.getChildren('canvas')[0];
  (0, _lib.componentFactory)(chart, _gauge.default, 'scale', 1, chart._feedAxesRawData());
  chart.getChildren('scale')[0].setLinkedItem('canvas', canvas);
  chart.addToEnv('scale', chart.getChildren('scale')[0]);
}

/***/ }),

/***/ 1499:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = _default;

var _polarNumeric = _interopRequireDefault(__webpack_require__(1500));

var _lib = __webpack_require__(274);

/**
 * function to instatiate axis and get attached to canvas
 * @param {Object} chart chart API
 */
function _default(chart) {
  (0, _lib.componentFactory)(chart, _polarNumeric.default, 'scale', 1, chart._feedAxesRawData());
  chart.addToEnv('scale', chart.getChildren('scale')[0]);
}

/***/ }),

/***/ 1484:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



exports.__esModule = true;
exports["default"] = _default;

var _lib = __webpack_require__(274);

function _default(chart) {
  var dataObj = chart.getFromEnv('dataSource'),
      value = dataObj.value,
      target = dataObj.target,
      DSClass,
      dataOnlyArr = [],
      datasetJSON = {};
  dataOnlyArr.push({
    value: value,
    target: target
  });
  datasetJSON.data = dataOnlyArr;
  DSClass = chart.getDSdef();
  (0, _lib.datasetFactory)(chart, DSClass, 'dataset', 1, [datasetJSON]);
}

/***/ }),

/***/ 1496:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _angulargauge = _interopRequireDefault(__webpack_require__(1497));

var _default = _angulargauge.default;
exports["default"] = _default;

/***/ }),

/***/ 1477:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _bulb = _interopRequireDefault(__webpack_require__(1478));

var _default = _bulb.default;
exports["default"] = _default;

/***/ }),

/***/ 1485:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _cylinder = _interopRequireDefault(__webpack_require__(1486));

var _default = _cylinder.default;
exports["default"] = _default;

/***/ }),

/***/ 1558:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _funnel = _interopRequireDefault(__webpack_require__(1559));

var _default = _funnel.default;
exports["default"] = _default;

/***/ }),

/***/ 1554:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _hbullet = _interopRequireDefault(__webpack_require__(1555));

var _default = _hbullet.default;
exports["default"] = _default;

/***/ }),

/***/ 1508:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _hled = _interopRequireDefault(__webpack_require__(1509));

var _default = _hled.default;
exports["default"] = _default;

/***/ }),

/***/ 1517:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _hlineargauge = _interopRequireDefault(__webpack_require__(1518));

var _default = _hlineargauge.default;
exports["default"] = _default;

/***/ }),

/***/ 1566:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _pyramid = _interopRequireDefault(__webpack_require__(1567));

var _default = _pyramid.default;
exports["default"] = _default;

/***/ }),

/***/ 1570:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _radialbar = _interopRequireDefault(__webpack_require__(1571));

var _default = _radialbar.default;
exports["default"] = _default;

/***/ }),

/***/ 1537:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _realtimearea = _interopRequireDefault(__webpack_require__(1538));

var _default = _realtimearea.default;
exports["default"] = _default;

/***/ }),

/***/ 1544:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _realtimecolumn = _interopRequireDefault(__webpack_require__(1539));

var _default = _realtimecolumn.default;
exports["default"] = _default;

/***/ }),

/***/ 1545:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _realtimeline = _interopRequireDefault(__webpack_require__(1546));

var _default = _realtimeline.default;
exports["default"] = _default;

/***/ }),

/***/ 1552:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _realtimelinedy = _interopRequireDefault(__webpack_require__(1553));

var _default = _realtimelinedy.default;
exports["default"] = _default;

/***/ }),

/***/ 1548:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _realtimestackedarea = _interopRequireDefault(__webpack_require__(1549));

var _default = _realtimestackedarea.default;
exports["default"] = _default;

/***/ }),

/***/ 1550:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _realtimestackedcolumn = _interopRequireDefault(__webpack_require__(1551));

var _default = _realtimestackedcolumn.default;
exports["default"] = _default;

/***/ }),

/***/ 1532:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _sparkcolumn = _interopRequireDefault(__webpack_require__(1533));

var _default = _sparkcolumn.default;
exports["default"] = _default;

/***/ }),

/***/ 1524:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _sparkline = _interopRequireDefault(__webpack_require__(1525));

var _default = _sparkline.default;
exports["default"] = _default;

/***/ }),

/***/ 1536:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _sparkwinloss = _interopRequireDefault(__webpack_require__(1529));

var _default = _sparkwinloss.default;
exports["default"] = _default;

/***/ }),

/***/ 1520:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _thermometer = _interopRequireDefault(__webpack_require__(1521));

var _default = _thermometer.default;
exports["default"] = _default;

/***/ }),

/***/ 1556:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _vbullet = _interopRequireDefault(__webpack_require__(1557));

var _default = _vbullet.default;
exports["default"] = _default;

/***/ }),

/***/ 1516:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _vled = _interopRequireDefault(__webpack_require__(1510));

var _default = _vled.default;
exports["default"] = _default;

/***/ }),

/***/ 1476:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _interopRequireDefault = __webpack_require__(269);

exports.__esModule = true;
exports["default"] = void 0;

var _bulb = _interopRequireDefault(__webpack_require__(1477));

exports.Bulb = _bulb.default;

var _cylinder = _interopRequireDefault(__webpack_require__(1485));

exports.Cylinder = _cylinder.default;

var _angulargauge = _interopRequireDefault(__webpack_require__(1496));

exports.AngularGauge = _angulargauge.default;

var _hled = _interopRequireDefault(__webpack_require__(1508));

exports.Hled = _hled.default;

var _vled = _interopRequireDefault(__webpack_require__(1516));

exports.Vled = _vled.default;

var _hlineargauge = _interopRequireDefault(__webpack_require__(1517));

exports.Hlineargauge = _hlineargauge.default;

var _thermometer = _interopRequireDefault(__webpack_require__(1520));

exports.Thermometer = _thermometer.default;

var _sparkline = _interopRequireDefault(__webpack_require__(1524));

exports.SparkLine = _sparkline.default;

var _sparkcolumn = _interopRequireDefault(__webpack_require__(1532));

exports.SparkColumn = _sparkcolumn.default;

var _sparkwinloss = _interopRequireDefault(__webpack_require__(1536));

exports.SparkWinLoss = _sparkwinloss.default;

var _realtimearea = _interopRequireDefault(__webpack_require__(1537));

exports.RealTimeArea = _realtimearea.default;

var _realtimecolumn = _interopRequireDefault(__webpack_require__(1544));

exports.RealTimeColumn = _realtimecolumn.default;

var _realtimeline = _interopRequireDefault(__webpack_require__(1545));

exports.RealTimeLine = _realtimeline.default;

var _realtimestackedarea = _interopRequireDefault(__webpack_require__(1548));

exports.RealTimeStackedArea = _realtimestackedarea.default;

var _realtimestackedcolumn = _interopRequireDefault(__webpack_require__(1550));

exports.RealTimeStackedColumn = _realtimestackedcolumn.default;

var _realtimelinedy = _interopRequireDefault(__webpack_require__(1552));

exports.RealTimeLineDY = _realtimelinedy.default;

var _hbullet = _interopRequireDefault(__webpack_require__(1554));

exports.HorizontalBullet = _hbullet.default;

var _vbullet = _interopRequireDefault(__webpack_require__(1556));

exports.VerticalBullet = _vbullet.default;

var _funnel = _interopRequireDefault(__webpack_require__(1558));

exports.Funnel = _funnel.default;

var _pyramid = _interopRequireDefault(__webpack_require__(1566));

exports.Pyramid = _pyramid.default;

var _radialbar = _interopRequireDefault(__webpack_require__(1570));

exports.RadialBar = _radialbar.default;

var _datastreamer = _interopRequireDefault(__webpack_require__(1481));

var _default = {
  name: 'widgets',
  type: 'package',
  requiresFusionCharts: true,
  extension: function extension(FusionCharts) {
    FusionCharts.addDep(_datastreamer.default);
    FusionCharts.addDep(_angulargauge.default);
    FusionCharts.addDep(_bulb.default);
    FusionCharts.addDep(_cylinder.default);
    FusionCharts.addDep(_hled.default);
    FusionCharts.addDep(_vled.default);
    FusionCharts.addDep(_hlineargauge.default);
    FusionCharts.addDep(_thermometer.default);
    FusionCharts.addDep(_sparkline.default);
    FusionCharts.addDep(_sparkcolumn.default);
    FusionCharts.addDep(_sparkwinloss.default);
    FusionCharts.addDep(_realtimearea.default);
    FusionCharts.addDep(_realtimecolumn.default);
    FusionCharts.addDep(_realtimeline.default);
    FusionCharts.addDep(_realtimestackedarea.default);
    FusionCharts.addDep(_realtimestackedcolumn.default);
    FusionCharts.addDep(_realtimelinedy.default);
    FusionCharts.addDep(_hbullet.default);
    FusionCharts.addDep(_vbullet.default);
    FusionCharts.addDep(_funnel.default);
    FusionCharts.addDep(_pyramid.default);
    FusionCharts.addDep(_radialbar.default);
  }
};
exports["default"] = _default;

/***/ })

}]);
}));

//# sourceMappingURL=http://localhost:3052/4.1.0-beta.9/map/eval/fusioncharts.widgets.js.map